/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { StrategyBasedIndicator } from "./StrategyBasedIndicator";
import { FullStochasticOscillatorIndicatorStrategy } from "./FullStochasticOscillatorIndicatorStrategy";
import { typeGetValue, markType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
/**
 * @hidden
 */
export class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_qm() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return FullStochasticOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.rc));
    }
    set q7(a) {
        this.h(FullStochasticOscillatorIndicator.rc, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.rd));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.rd, a);
    }
    qu() {
        return this.smoothingPeriod;
    }
    get q9() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.re));
    }
    set q9(a) {
        this.h(FullStochasticOscillatorIndicator.re, a);
    }
    qr() {
        return this.q9;
    }
    p2() {
        return this.q9;
    }
}
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FullStochasticOscillatorIndicator.rc = StrategyBasedIndicator.q4(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.rd = StrategyBasedIndicator.q5(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.re = StrategyBasedIndicator.q5(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");
//# sourceMappingURL=FullStochasticOscillatorIndicator.js.map