/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { RadialBucketCalculator } from "./RadialBucketCalculator";
import { markType, Point_$type, enumGetBox, typeCast, markDep } from "igniteui-angular-core";
import { isNaN_, intDivide, isInfinity } from "igniteui-angular-core";
import { RadialBase } from "./RadialBase";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { DependencyProperty } from "igniteui-angular-core";
import { TrendLineType_$type } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap_$type } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { RadialFrame } from "./RadialFrame";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { AxisRange } from "./AxisRange";
import { NumericAxisBase } from "./NumericAxisBase";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { RadialBaseView } from "./RadialBaseView";
import { CollisionAvoider } from "./CollisionAvoider";
import { Clipper } from "igniteui-angular-core";
import { TrendResolutionParams } from "./TrendResolutionParams";
import { RadialTrendLineManager } from "./RadialTrendLineManager";
import { CategoryMarkerManager } from "./CategoryMarkerManager";
import { PropertyMetadata } from "igniteui-angular-core";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
var AnchoredRadialBucketCalculator = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialBucketCalculator, _super);
    function AnchoredRadialBucketCalculator(a) {
        var _this = _super.call(this, a) || this;
        _this.f = null;
        _this.f = a;
        return _this;
    }
    AnchoredRadialBucketCalculator.prototype.getBucket = function (a) {
        var b = this.f.cs.n8;
        var c = Math.min(a * this.b, b.count - 1);
        var d = Math.min(c + this.b - 1, b.count - 1);
        var e = NaN;
        var f = NaN;
        for (var g = c; g <= d; ++g) {
            var h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    };
    AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
    return AnchoredRadialBucketCalculator;
}(RadialBucketCalculator));
export { AnchoredRadialBucketCalculator };
/**
 * @hidden
 */
var AnchoredRadialSeries = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeries, _super);
    function AnchoredRadialSeries() {
        var _this = _super.call(this) || this;
        _this.n3 = null;
        _this.n7 = null;
        _this.o1 = { $type: Point_$type, x: 0, y: 0 };
        _this.n5 = null;
        _this.n4 = null;
        _this.n5 = new RadialFrame(3);
        _this.n3 = new CategoryLineRasterizer();
        return _this;
    }
    AnchoredRadialSeries.prototype.bf = function () {
        return new AnchoredRadialSeriesView(this);
    };
    AnchoredRadialSeries.prototype.h1 = function () {
        _super.prototype.h1.call(this);
        this.nd = null;
        this.nf = null;
    };
    AnchoredRadialSeries.prototype.fs = function (a, b) {
        var c = this.g2(b);
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.ft(a, b, this.ok);
        }
        return _super.prototype.fs.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.i2 = function (a) {
        _super.prototype.i2.call(this, a);
        this.n2 = a;
    };
    AnchoredRadialSeries.prototype.fe = function (a, b) {
        return this.ff(a, b, this.nd, null, this.n8);
    };
    AnchoredRadialSeries.prototype.fc = function (a, b) {
        return this.fd(a, b, this.nd, null, this.n8);
    };
    AnchoredRadialSeries.prototype.d9 = function (a, b, c, d, e) {
        if (this.n8 == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.nd, d, e, this.n8.count, null);
    };
    AnchoredRadialSeries.prototype.en = function (a, b, c) {
        var d = this.getEffectiveViewport1(this.bi);
        var e = this.od(this.nd, this.bi.bs, this.bi.br, d);
        var f = new ScalerParams(0, this.bi.bs, this.bi.br, this.nd.ca, d);
        f.c = this.bs.oh;
        return this.ep(this.n8, a, this.nd, f, e, null, b, c);
    };
    AnchoredRadialSeries.prototype.lv = function (a, b, c) {
        if (this.nf == null || this.nd == null || this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        var d = this.getEffectiveViewport1(this.bi);
        var e = new ScalerParams(0, this.bi.bs, this.bi.br, this.nf.ca, d);
        e.c = this.getEffectiveViewport1(this.bi);
        var f = this.en(a, b, c);
        f = this.nf.dy(f, e);
        var g = this.ng.c(a);
        if (!b && this.nd != null) {
            var h = this.fe(a, c);
            var i = this.fc(a, c);
            var j = this.od(this.nd, this.bi.bs, this.bi.br, d);
            var k = new ScalerParams(0, this.bi.bs, this.bi.br, this.nd.ca, d);
            k.c = this.bs.oh;
            var l = this.d9(a, h, this.nd, k, j);
            var m = this.d9(a, i, this.nd, k, j);
            if (m <= l) {
                g = this.nd.dy(i, k) + j;
            }
            else {
                g = this.nd.dy(h, k) + j;
            }
        }
        var n = this.ng.d(g, f, this.bi.bs, this.bi.br);
        var o = this.ng.e(g, f, this.bi.bs, this.bi.br);
        return { $type: Point_$type, x: n, y: o };
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "n8", {
        get: function () {
            return this.n7;
        },
        set: function (a) {
            if (this.n7 != a) {
                var b = this.n7;
                this.n7 = a;
                this.raisePropertyChanged("ValueColumn", b, this.n7);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AnchoredRadialSeries.prototype, "ox", {
        get: function () {
            return this.c(AnchoredRadialSeries.oo);
        },
        set: function (a) {
            this.h(AnchoredRadialSeries.oo, a);
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.an = function (a) {
        if (a != null && a == this.nd && this.n8 != null && this.n8.count > 0) {
            return new AxisRange(0, this.n8.count - 1);
        }
        if (a != null && a == this.nf && this.n8 != null && this.n8.count > 0) {
            return new AxisRange(this.n8.minimum, this.n8.maximum);
        }
        return null;
    };
    AnchoredRadialSeries.prototype.i7 = function (a, b, c, d) {
        _super.prototype.i7.call(this, a, b, c, d);
        if (this.n2.ct.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        var e = typeCast(NumericAxisBase.$, this.nf);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.n8);
                    this.n8 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.n8 = this.bw(this.ok);
                    this.n2.co.e(this.eu);
                }
                if (e != null && !e.cn()) {
                    this.n2.co.e(this.eu);
                    this.jl(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.n8);
                    this.n8 = this.bw(this.ok);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.cn()) {
                    this.n2.co.e(this.eu);
                    this.jl(false);
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    };
    AnchoredRadialSeries.prototype.h6 = function (a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.n2.co.e(this.eu);
                break;
        }
        this.n2.ct.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 1:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (this.ok != null && this.n2.co.b > 0 && this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 3:
                if (d == this.ok) {
                    if (this.nf != null && !this.nf.cn()) {
                        this.jl(true);
                    }
                }
                break;
        }
    };
    AnchoredRadialSeries.prototype.dw = function (a, b, c) {
        var d = _super.prototype.dw.call(this, a, b, c);
        var e = c;
        if (this.bz == null || this.bz.count == 0 || this.nd == null || this.n8 == null || this.nd.j7 == 0 || this.nf == null || isInfinity(this.nf.kc) || isInfinity(this.nf.kb) || e.co.b < 1) {
            d = false;
        }
        return d;
    };
    AnchoredRadialSeries.prototype.getOffsetValue = function () {
        return this.od(this.nd, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.getCategoryWidth = function () {
        return this.nd.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    };
    AnchoredRadialSeries.prototype.get_ob = function () {
        return false;
    };
    Object.defineProperty(AnchoredRadialSeries.prototype, "ob", {
        get: function () {
            return this.get_ob();
        },
        enumerable: true,
        configurable: true
    });
    AnchoredRadialSeries.prototype.od = function (a, b, c, d) {
        var e = 0;
        var f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.nr(), b, c, d);
                break;
        }
        if (a.ca) {
            e = -e;
        }
        return e;
    };
    AnchoredRadialSeries.prototype.nw = function (a, b) {
        var _this = this;
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.nd;
        var g = this.nf;
        var h = g.kc;
        var i = g.kb;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        var j = this.md();
        var k = 0;
        var l = b;
        var m = new CollisionAvoider();
        var n = 0;
        var o = b.co.d;
        n = this.od(f, c, d, e);
        l.ct.i = this.nf.lr;
        l.ct.h = this.nf.lq;
        l.ct.j = function (p, q) { return _this.oe(p, q, c, d); };
        l.ct.k = function (p, q) { return _this.of(p, q, c, d); };
        var p = ((function () {
            var $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        var q = ((function () {
            var $ret = new TrendResolutionParams();
            $ret.c = b.co.b;
            $ret.d = b.co.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = _this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.ct.l(a.p, this.n6, this.n8, this.oh, function (r) { return _this.nd.getScaledAngle(r); }, function (r) { return _this.nf.lx(r); }, q, p);
        var r = true;
        if (this.oc(b)) {
            o--;
        }
        for (var s = b.co.c; s <= o; ++s) {
            var t = s;
            if (t * b.co.b >= this.nd.j7) {
                t -= intDivide((this.nd.j7), b.co.b);
            }
            var u = b.co.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.lx(u[1]);
                if (b.co.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.lx(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.ob && this.oa()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    var v = Math.min(t * b.co.b, this.bz.count - 1);
                    var w = this.ng.d(u[0], u[1], c, d);
                    var x = this.ng.e(u[0], u[1], c, d);
                    var y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        var z = b.cp.item(k);
                        z.ak = v;
                        z.content.item = this.bz.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.ob && this.oa()) {
                    o++;
                }
            }
        }
        b.cp.count = k;
        return;
    };
    AnchoredRadialSeries.prototype.oe = function (a, b, c, d) {
        return this.ng.d(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.of = function (a, b, c, d) {
        return this.ng.e(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.oc = function (a) {
        var b = a;
        return !this.ob && b.co.c == 0 && b.co.d == this.nd.j7;
    };
    AnchoredRadialSeries.prototype.n1 = function (a, b, c) {
        var d = null;
        var e = c.bs;
        var f = c.br;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            var g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            var h = f.bottom + 10;
            var i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            var j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    };
    AnchoredRadialSeries.prototype.on = function (a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.n9()) {
                a.add(this.o1);
                a.add(a._inner[0]);
                d.add(this.o1);
                d.add(d._inner[0]);
            }
        }
    };
    AnchoredRadialSeries.prototype.oa = function () {
        return !this.n9();
    };
    AnchoredRadialSeries.prototype.n9 = function () {
        var a = this.bi.bs;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    };
    AnchoredRadialSeries.prototype.h3 = function (a, b) {
        _super.prototype.h3.call(this, a, b);
        var c = b;
        if (a) {
            c.cp.clear();
        }
        c.ct.g$d();
    };
    AnchoredRadialSeries.prototype.nx = function (a, b) {
        var c = b.bs;
        var d = b.br;
        var e = this.getEffectiveViewport1(b);
        var f = this.l0(b);
        var g = b;
        g.ct.g$g(a.p);
        CategoryMarkerManager.b(this, a.m, g.cp, this.mf);
        g.cj();
        this.om(d, c, e, f, g);
    };
    AnchoredRadialSeries.prototype.om = function (a, b, c, d, e) {
        e.cu(a, b, c, d);
    };
    AnchoredRadialSeries.prototype.jw = function () {
        _super.prototype.jw.call(this);
        if (this.fh < 0) {
            return;
        }
        this.n2.cv();
    };
    AnchoredRadialSeries.prototype.fv = function (a, b) {
        if (a == this.n2.ct.g$j) {
            return null;
        }
        return _super.prototype.fv.call(this, a, b);
    };
    AnchoredRadialSeries.prototype.c9 = function (a) {
        var b = this.bi.bs;
        b = b.copy();
        var c = this.bi.br;
        var d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.nd == null || this.n8 == null || this.nf == null) {
            return false;
        }
        if (d < 0 || d > this.n8.count - 1) {
            return false;
        }
        var e = this.nd.getScaledAngle(d);
        var f = this.nf.lx(this.n8.item(d));
        if (isNaN_(f)) {
            f = (this.nf.lq + this.nf.lr) / 2;
        }
        var g = 0.5 + (Math.cos(e) * f);
        var h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    };
    AnchoredRadialSeries.prototype.jn = function (a, b) {
        _super.prototype.jn.call(this, a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        var c = typeCast(AnchoredRadialSeriesView.$, this.bh);
        c.co.e(this.eu);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.df) {
            this.n5 = new RadialFrame(3);
            this.nw(this.n5, c);
        }
        this.df = false;
        this.nx(this.n5, c);
        this.dl = false;
    };
    AnchoredRadialSeries.prototype.jk = function (a, b, c, d, e) {
        _super.prototype.jk.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        g.co.e(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.n4 == null) {
            this.n4 = new RadialFrame(3);
        }
        this.n4.u();
        this.nw(this.n4, g);
        this.nx(this.n4, g);
    };
    AnchoredRadialSeries.prototype.ic = function (a) {
        _super.prototype.ic.call(this, a);
        this.a2.exportTrendlineData(this, a, this.n2.ct.g$j);
    };
    AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
    AnchoredRadialSeries.oo = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, function (a, b) { return a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue); }));
    AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:ok:ow', [2, null], 'TrendLineType:n6:ou', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:og:ot', [1, 1.5], 'TrendLinePeriod:oh:os', [1, 7], 'TrendLineZIndex:oi:ov', [1, 1], 'TrendLineBrush:oy:op', [Brush.$, null], 'TrendLineDashArray:oz:oq', [DoubleCollection.$], 'TrendLineDashCap:o0:or', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
    return AnchoredRadialSeries;
}(RadialBase));
export { AnchoredRadialSeries };
/**
 * @hidden
 */
var AnchoredRadialSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(AnchoredRadialSeriesView, _super);
    function AnchoredRadialSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cs = null;
        _this.ct = null;
        _this.co = new AnchoredRadialBucketCalculator(_this);
        _this.cs = a;
        _this.ct = new RadialTrendLineManager();
        return _this;
    }
    AnchoredRadialSeriesView.prototype.cu = function (a, b, c, d) {
    };
    AnchoredRadialSeriesView.prototype.cv = function () {
        this.cs.ox = null;
        if (this.cs.oy != null) {
            this.cs.ox = this.cs.oy;
        }
        else {
            this.cs.ox = this.cs.lb;
        }
    };
    AnchoredRadialSeriesView.prototype.a2 = function (a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cs.n6 != 0 && !b) {
                var c = this.ct.g$j;
                c.ac = this.cs.og;
                c._stroke = this.cs.ox;
                c.ai = this.cs.oz;
                c.ad = this.cs.o0;
                a.u(c);
            }
        }
        _super.prototype.a2.call(this, a, b);
    };
    AnchoredRadialSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cs.nd.e9 != null) {
            a += "<span>${item." + this.cs.nd.e9 + "}</span><br/>";
        }
        a += "<span";
        var b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cs.ok + "}</span></div>";
        return a;
    };
    AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);
    return AnchoredRadialSeriesView;
}(RadialBaseView));
export { AnchoredRadialSeriesView };
//# sourceMappingURL=AnchoredRadialBucketCalculator_combined.js.map