/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { FastItemDateTimeColumn } from "igniteui-angular-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ISortingAxis_$type } from "./ISortingAxis";
import { IDateTimeAxis_$type } from "./IDateTimeAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { typeCast, Number_$type, Date_$type, fromEnum, runOn, delegateRemove, delegateCombine, markType, markDep, TypeRegistrar } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Rect } from "igniteui-angular-core";
import { NumericScaler } from "./NumericScaler";
import { SeriesViewer } from "./SeriesViewer";
import { SortedListView$1 } from "./SortedListView$1";
import { ArrayExtension } from "igniteui-angular-core";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { IFastItemsSource_$type } from "igniteui-angular-core";
import { HorizontalAxisLabelPanel } from "./HorizontalAxisLabelPanel";
import { MathUtil } from "igniteui-angular-core";
import { PropertyMetadata } from "igniteui-angular-core";
import { truncate, isNaN_ } from "igniteui-angular-core";
import { dateMinValue, dateSubtract, dateAdd, dateMaxValue, dateFromTicks } from "igniteui-angular-core";
/**
 * @hidden
 */
var TimeAxisBase = /** @class */ (function (_super) {
    tslib_1.__extends(TimeAxisBase, _super);
    function TimeAxisBase() {
        var _this = _super.call(this) || this;
        _this.k4 = null;
        _this.ld = null;
        _this.k8 = false;
        _this.lg = dateMaxValue();
        _this.lf = dateMinValue();
        FastItemDateTimeColumn.o();
        return _this;
    }
    TimeAxisBase.prototype.dy = function (a, b) {
        if (!b.c.isEmpty) {
            var c = this.ll(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ll(a, b.e, b.d, b.c);
    };
    TimeAxisBase.prototype.e6 = function (a, b) {
        var c = this.f0(b);
        if (c == this.dateTimeMemberPath) {
            return this.e7(a, b, this.dateTimeMemberPath);
        }
        return _super.prototype.e6.call(this, a, b);
    };
    TimeAxisBase.prototype.ll = function (a, b, c, d) {
        var e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.ca) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    };
    TimeAxisBase.prototype.lm = function (a, b, c) {
        var d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        var e = 0;
        if (this.ca) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    };
    TimeAxisBase.prototype.d1 = function (a, b) {
        if (!b.c.isEmpty) {
            var c = b.d.left;
            var d = b.d.width;
            if (this.categoryMode != 0) {
                var e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            var f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    };
    TimeAxisBase.prototype.getUnscaledValue3 = function (a, b, c, d) {
        var e = b.left + b.width * (a - c.left) / c.width;
        if (this.ca) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    };
    TimeAxisBase.prototype.i$h = function () {
        this.l1();
    };
    TimeAxisBase.prototype.l1 = function () {
        var a = this.bh != null ? this.bh.n2 : Rect.empty;
        var b = !a.isEmpty ? this.i9 : Rect.empty;
        var c = (new Date());
        var d = (new Date());
        var e = false;
        if (!a.isEmpty && !b.isEmpty && this.k5 != null) {
            var f = typeCast(FastItemDateTimeColumn.$, this.k5);
            if (f != null) {
                if (this.le == null) {
                    this.l2();
                }
            }
            else {
                this.le = null;
            }
            if (this.k5.count > 0) {
                e = true;
                var g = this.le == null ? 0 : this.le._inner[0];
                var h = this.le == null ? this.k5.count - 1 : this.le._inner[this.k5.count - 1];
                c = this.k5.item(g);
                d = this.k5.item(h);
                this.k9 = false;
                if (this.categoryMode == 2) {
                    var i = this.lz(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.lc()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.lb()) {
            e = true;
            d = this.maximumValue;
        }
        var j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            var k = this.actualMinimumValue;
            var l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.l6();
        }
    };
    TimeAxisBase.prototype.l6 = function () {
    };
    Object.defineProperty(TimeAxisBase.prototype, "k5", {
        get: function () {
            return this.k4;
        },
        set: function (a) {
            if (this.k4 != a) {
                var b = this.k4;
                this.k4 = a;
                this.g5("DateTimeColumn", b, this.k4);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "le", {
        get: function () {
            return this.ld;
        },
        set: function (a) {
            this.ld = a;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$b", {
        get: function () {
            if (this.le == null) {
                var a = typeCast(FastItemDateTimeColumn.$, this.k5);
                if (a != null) {
                    this.l2();
                }
                else {
                    this.le = null;
                }
            }
            return this.le;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.l2 = function () {
        if (this.la) {
            this.le = new List$1(Number_$type, 0);
            var a = this.le;
            var b = this.k5.count;
            for (var c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            var d = typeCast(FastItemDateTimeColumn.$, this.k5);
            this.le = d.h();
        }
    };
    TimeAxisBase.prototype.i$e = function (a, b, c, d) {
        return this.lo(a, b, c, d);
    };
    TimeAxisBase.prototype.lo = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.ca, c);
        var g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.ln(dateFromTicks(i));
    };
    TimeAxisBase.prototype.ln = function (a) {
        if (this.k5 == null || this.le.count != this.k5.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.k5, this.le);
        var c = this.lp(a, b);
        if (c >= 0 && c < this.le.count) {
            var d = this.k5.item(this.le._inner[c]);
            if (d > a) {
                c--;
                if (c < 0) {
                    c = 0;
                }
            }
            return c;
        }
        return this.le.count - 1;
    };
    TimeAxisBase.prototype.i$g = function (a, b, c, d) {
        return this.lr(a, b, c, d);
    };
    TimeAxisBase.prototype.lr = function (a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        var e = d;
        var f = new ScalerParams(0, a, b, this.ca, c);
        var g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        var i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.lq(dateFromTicks(i));
    };
    TimeAxisBase.prototype.lq = function (a) {
        if (this.k5 == null || this.le.count != this.k5.count) {
            return -1;
        }
        var b = new SortedListView$1(Date_$type, this.k5, this.le);
        var c = this.lp(a, b);
        if (c >= this.le.count) {
            c = this.le.count - 1;
        }
        if (c >= 0 && c < this.le.count) {
            var d = this.k5.item(this.le._inner[c]);
            if (d < a) {
                c++;
                if (c > this.le.count - 1) {
                    c = this.le.count - 1;
                }
            }
            return c;
        }
        return 0;
    };
    TimeAxisBase.prototype.i$d = function (a) {
        if (this.k5 == null) {
            return NaN;
        }
        var b = this.k4.item(a);
        var c = b.getTime();
        var d = c;
        return d;
    };
    TimeAxisBase.prototype.i$c = function (a) {
        var b = this;
        if (b.i$b == null) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.k5, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.lp(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var diff1_ = d.getTime() - c.item(e - 1).getTime();
            var diff2_ = c.item(e).getTime() - d.getTime();
            var f = e - 1;
            var g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            var h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        var i = this.i4();
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, i)) < (this.i9.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, i)) - this.i9.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.lp = function (a, b) {
        var c = this;
        if (this.k5 == null || c.i$b == null) {
            return -1;
        }
        var d = -1;
        var e = ArrayExtension.binarySearch$11(Date_$type, b, function (f) {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    };
    TimeAxisBase.prototype.i$f = function (a) {
        var b = this;
        if (b.i$b == null || this.k5 == null || b.i$b.count != this.k5.count) {
            return -1;
        }
        var c = new SortedListView$1(Date_$type, this.k5, b.i$b);
        var ticks_ = a;
        var d = (new Date(ticks_));
        var e = this.lp(d, c);
        var f = this.i4();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            var g = +d - +(c.item(e - 1));
            var h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, f)) < (this.i9.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, f)) - this.i9.left) < 2) {
            return 0;
        }
        return -1;
    };
    TimeAxisBase.prototype.i$i = function () {
        this.le = null;
        this.ha();
    };
    TimeAxisBase.prototype.get_k9 = function () {
        return this.k8;
    };
    TimeAxisBase.prototype.set_k9 = function (a) {
        this.k8 = a;
    };
    Object.defineProperty(TimeAxisBase.prototype, "k9", {
        get: function () {
            return this.get_k9();
        },
        set: function (a) {
            this.set_k9(a);
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.g1 = function (a) {
        _super.prototype.g1.call(this, a);
        this.dateTimeMemberPath = a;
    };
    TimeAxisBase.prototype.g4 = function (a) {
        _super.prototype.g4.call(this, a);
        this.minimumValue = a;
    };
    TimeAxisBase.prototype.g3 = function (a) {
        _super.prototype.g4.call(this, a);
        this.maximumValue = a;
    };
    TimeAxisBase.prototype.cp = function () {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        var a = this.actualMinimumValue.getTime();
        var b = this.actualMaximumValue.getTime();
        this.l1();
        var c = !this.lc() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        var d = !this.lb() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        var e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.g6(e);
        return true;
    };
    TimeAxisBase.prototype.lc = function () {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    };
    TimeAxisBase.prototype.lb = function () {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMinimumValue", {
        get: function () {
            return this.lg;
        },
        set: function (a) {
            var b = +(this.lg) != +a;
            if (b) {
                var c = this.lg;
                this.lg = a;
                this.g5("ActualMinimumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.fb = function () {
        return this.actualMinimumValue;
    };
    Object.defineProperty(TimeAxisBase.prototype, "actualMaximumValue", {
        get: function () {
            return this.lf;
        },
        set: function (a) {
            var b = +(this.lf) != +a;
            if (b) {
                var c = this.lf;
                this.lf = a;
                this.g5("ActualMaximumValue", c, a);
            }
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.fa = function () {
        return this.maximumValue;
    };
    TimeAxisBase.prototype.l3 = function (a) {
        var e_1, _a;
        this.hc(a);
        if (this.jn == null) {
            return;
        }
        try {
            for (var _b = tslib_1.__values(fromEnum(this.cw())), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                b.jl(a);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    TimeAxisBase.prototype.gz = function (a, b, c, d) {
        _super.prototype.gz.call(this, a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                var e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.k5);
                    this.k5 = null;
                    e.event = delegateRemove(e.event, runOn(this, this.l0));
                }
                var f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.le = null;
                    this.k5 = this.k6(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.l0));
                }
                this.l3(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.jn != null) {
                    this.jn.deregisterColumn(this.k5);
                    this.k5 = this.k6(this.dateTimeMemberPath);
                    this.le = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cn();
                this.l3(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cn();
                this.l3(false);
                break;
            case "DateTimeColumn":
                this.l1();
                break;
        }
    };
    TimeAxisBase.prototype.l0 = function (a, b) {
        this.le = null;
    };
    TimeAxisBase.prototype.k6 = function (a) {
        return TimeAxisBase.k7(a, this);
    };
    TimeAxisBase.k7 = function (a, b) {
        if (a == null) {
            return b.jn.registerColumnDateTime(null, null, false);
        }
        var c = null;
        var d = SeriesViewer.bn(a, b.coercionMethods);
        c = d.a;
        return b.jn.registerColumnDateTime(a, c, b.expectFunctions);
    };
    TimeAxisBase.prototype.au = function () {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    };
    TimeAxisBase.prototype.get_a1 = function () {
        return 0;
    };
    Object.defineProperty(TimeAxisBase.prototype, "a1", {
        get: function () {
            return this.get_a1();
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.hc = function (a) {
        _super.prototype.hc.call(this, a);
        var b = this.a4.ay();
        var c = this.a4.a1();
        var d = this.a4.az();
        var e = this.a4.a0();
        var f = this.a4.e();
        var g = this.a4.f();
        var h = this.a4.g();
        this.hk();
        this.gn(b);
        this.gn(c);
        this.gn(d);
        this.gn(e);
        this.cx.clear();
        this.cy.clear();
        this.ju.clear();
        this.av.ac = this;
        var i = this.bh != null ? this.bh.n2 : Rect.empty;
        var j = !i.isEmpty ? this.i9 : Rect.empty;
        this.av.cq = i;
        this.av.cp = j;
        if (i.isEmpty || j.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0) {
            this.av.ab.clear();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        this.l1();
    };
    TimeAxisBase.prototype.get_b7 = function () {
        return true;
    };
    TimeAxisBase.prototype.startCursor = function () {
    };
    TimeAxisBase.prototype.resetCursor = function () {
    };
    TimeAxisBase.prototype.StartTimeCursor = function () {
        this.startCursor();
    };
    TimeAxisBase.prototype.ResetTimeCursor = function () {
        this.resetCursor();
    };
    TimeAxisBase.prototype.getCategorySize = function (a, b, c) {
        if (this.j7 == 0) {
            return 0;
        }
        var d = this.i7(b, c);
        return d.width / (this.j7 * a.width);
    };
    TimeAxisBase.prototype.getGroupCenter = function (a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    };
    TimeAxisBase.prototype.jz = function (a, b, c) {
        var d = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
        var e = 1 - 0.5 * d;
        var f = this.getCategorySize(a, b, c) * e;
        return f;
    };
    TimeAxisBase.prototype.get_cf = function () {
        return true;
    };
    TimeAxisBase.prototype.lz = function (a, b) {
        return (0);
    };
    TimeAxisBase.prototype.preferredCategoryMode = function (a) {
        return this.b5 ? 0 : 1;
    };
    Object.defineProperty(TimeAxisBase.prototype, "isVertical", {
        get: function () {
            return this.ch;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.prototype.j$c = function (a, b) {
        return this.d1.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$b = function (a, b) {
        return this.dy.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$d = function (a, b, c, d, e) {
        this.gr.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$e = function (a, b, c, d) {
        this.gs.apply(this, arguments);
    };
    TimeAxisBase.prototype.j$f = function (a, b, c, d) {
        this.gt.apply(this, arguments);
    };
    Object.defineProperty(TimeAxisBase.prototype, "j$a", {
        get: function () {
            return this.ca;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(TimeAxisBase.prototype, "i$a", {
        get: function () {
            return this.b7;
        },
        enumerable: true,
        configurable: true
    });
    TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
    TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'g5', ['DateTimeMemberPath::l7', [2, null], 'IsDataPreSorted:la:l8', [0, false], 'MaximumValue::l9', [3, null], 'MinimumValue::ma', [3, null]]);
    return TimeAxisBase;
}(CategoryAxisBase));
export { TimeAxisBase };
//# sourceMappingURL=TimeAxisBase.js.map