import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { Rect } from "igniteui-angular-core";
import { Axis } from "./Axis";
import { List$1 } from "igniteui-angular-core";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { PointCollection } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private pf;
    readonly pg: IAnchoredCategorySeriesInteractionManager;
    pb: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    protected bf(): SeriesView;
    i2(a: SeriesView): void;
    pj: boolean;
    constructor();
    pq: string;
    fs(a: any, b: string): any;
    valueColumn: IFastItemColumn$1<number>;
    private ph;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    p8: Brush;
    static readonly px: DependencyProperty;
    trendLineThickness: number;
    qa: PenLineCap;
    p9: DoubleCollection;
    trendLinePeriod: number;
    pl: number;
    c9(a: any): boolean;
    protected o8(a: number, b: number, c: Axis): any[];
    protected i7(a: any, b: string, c: any, d: any): void;
    an(a: Axis): AxisRange;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected oj(): number;
    pk(a: CategorySeriesView): number;
    pv(a: PointCollection, b: number, c: CategorySeriesView): void;
    o9(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    pa(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    h3(a: boolean, b: SeriesView): void;
    oy(a: CategoryFrame, b: CategorySeriesView): void;
    o1(a: CategoryFrame, b: CategorySeriesView): void;
    pc: CategoryFrame;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ps(a: CategoryFrame, b: CategorySeriesView): void;
    protected jw(): void;
    fv(a: any, b: Point): any;
    readonly currentCategoryMode: CategoryMode;
    readonly scaler: ICategoryScaler;
    readonly yScaler: IScaler;
    readonly bucketizer: IBucketizer;
    readonly currentMode2Index: number;
    provideCollisionDetector(): IDetectsCollisions;
    readonly trendlinePreparer: IPreparesCategoryTrendline;
    protected pm: string;
    abstract pt(a: Axis): void;
    abstract pu(a: Axis): void;
    protected ic(a: any): void;
    pd: CategorySeriesMarkerCollisionAvoidance;
    fp(a: Point): any;
    pe: ConsolidatedItemHitTestBehavior;
    readonly mayContainUnknowns: boolean;
    eh(): number;
    ao(a: Rect): AxisRange;
    private pw;
    readonly useHighMarkerFidelity: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    cw: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private cx;
    cy: ITrendLineManager;
    readonly cz: boolean;
    c3(): void;
    c1(): void;
    c0(): void;
    co(): CategoryBucketCalculator;
    c2(): void;
    c4(): void;
    c5(a: number): Rect;
    protected a2(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
