import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-angular-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { TrendLineType } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { DoubleCollection } from "igniteui-angular-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-angular-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { Clipper } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-angular-core";
import { PathGeometry } from "igniteui-angular-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bf(): SeriesView;
    h1(): void;
    i2(a: SeriesView): void;
    ni: ScatterBaseView;
    protected get_c4(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    protected bd(): SeriesHitTestMode;
    l6(a: Point): Rect;
    dh(a: Point, b: boolean): boolean;
    constructor();
    nh: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    n4: string;
    nq: IFastItemColumn$1<number>;
    private np;
    n8: string;
    ns: IFastItemColumn$1<number>;
    private nr;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    o5: Brush;
    static readonly oq: DependencyProperty;
    trendLineThickness: number;
    o7: PenLineCap;
    o6: DoubleCollection;
    trendLinePeriod: number;
    ne: CollisionAvoidanceType;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    ny: number;
    nx: number;
    ik(): void;
    nj: ScatterErrorBarSettings;
    protected i7(a: any, b: string, c: any, d: any): void;
    nu(a: any): boolean;
    nt(a: any): boolean;
    private op;
    private o8;
    private o9;
    private oa;
    protected nv(a: string, b: FastItemsSourceEventAction): boolean;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    oi(a: ScatterFrame): void;
    oj(a: ScatterFrame, b: Clipper): void;
    an(a: Axis): AxisRange;
    fp(a: Point): any;
    e8(a: Point): number;
    c9(a: any): boolean;
    protected j0(a: Rect, b: Rect): void;
    protected j1(a: Rect, b: Rect): void;
    nm: ScatterFrame;
    no: ScatterFrame;
    nl: ScatterFrame;
    ob(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    of(a: ScatterFrame, b: ScatterBaseView): void;
    h3(a: boolean, b: SeriesView): void;
    oo(a: ScatterFrame, b: ScatterBaseView): void;
    od(a: ScatterFrame, b: ScatterBaseView): void;
    og(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    oe(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    oc(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    oh(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    ol(a: ScatterFrame, b: ScatterBaseView): void;
    private om;
    private on;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    jm(a: boolean): void;
    protected jw(): void;
    nn: ScatterFrame;
    jn(a: Rect, b: RenderSurface): void;
    private nk;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ok(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    nd(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    nw(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected ic(a: any): void;
    eh(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cr: MarkerManagerBase;
    protected cp: Point[];
    protected cs: ScatterBase;
    protected cx: List$1<number>;
    constructor(a: ScatterBase);
    private c7;
    private c8;
    ct: ScatterTrendLineManager;
    ap(): void;
    private c6;
    c9(a: Marker): Size;
    protected cq(): MarkerManagerBase;
    protected c4(a: IDictionary$2<any, OwnedPoint>): void;
    cw(): List$1<Marker>;
    co(): Point[];
    protected cn(): Point[];
    protected cv(): List$1<number>;
    cy(): void;
    c2(a: PathGeometry): void;
    cz(): void;
    c3(a: PathGeometry): void;
    c5(): void;
    cu: HashPool$2<any, Marker>;
    cc(a: (arg1: Marker) => void): void;
    c1(): void;
    protected a2(a: RenderingContext, b: boolean): void;
    c0(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
