import { Control } from "igniteui-angular-core";
import { INotifyPropertyChanged, Type, Base, Point, EventArgs, PropertyChangedEventArgs, IEnumerable, IEnumerable$1, IList$1 } from "igniteui-angular-core";
import { ILegendOwner } from "igniteui-angular-core";
import { IInternalLegendOwner } from "igniteui-angular-core";
import { ISeriesViewerWidget } from "./ISeriesViewerWidget";
import { SRProvider } from "igniteui-angular-core";
import { DoubleAnimator } from "igniteui-angular-core";
import { IChartLegend } from "igniteui-angular-core";
import { DependencyProperty } from "igniteui-angular-core";
import { DependencyObject } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ChartHitTestMode } from "./ChartHitTestMode";
import { InteractionState } from "igniteui-angular-core";
import { WindowResponse } from "./WindowResponse";
import { Visibility } from "igniteui-angular-core";
import { IOverviewPlusDetailPane } from "igniteui-angular-core";
import { SeriesViewerComponentsFromView } from "./SeriesViewerComponentsFromView";
import { ZoomCoercionMode } from "./ZoomCoercionMode";
import { Brush } from "igniteui-angular-core";
import { ModifierKeys } from "igniteui-angular-core";
import { DataTemplate } from "igniteui-angular-core";
import { HorizontalAlignment } from "igniteui-angular-core";
import { CanvasRenderScheduler } from "igniteui-angular-core";
import { SyncSettings } from "./SyncSettings";
import { CultureInfo } from "igniteui-angular-core";
import { SeriesViewerComponentsForView } from "./SeriesViewerComponentsForView";
import { Dictionary$2 } from "igniteui-angular-core";
import { PropertyUpdatedEventArgs } from "igniteui-angular-core";
import { NotifyCollectionChangedEventArgs } from "igniteui-angular-core";
import { ObservableCollection$1 } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { FrameworkElement } from "igniteui-angular-core";
import { MouseEventArgs } from "igniteui-angular-core";
import { MouseButtonEventArgs } from "igniteui-angular-core";
import { Tuple$2 } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesViewerManipulationEventArgs } from "./SeriesViewerManipulationEventArgs";
import { Key } from "igniteui-angular-core";
import { EventProxy } from "igniteui-angular-core";
import { RectChangedEventArgs } from "igniteui-angular-core";
import { RefreshCompletedEventArgs } from "./RefreshCompletedEventArgs";
import { Thickness } from "igniteui-angular-core";
import { AxisTitlePosition } from "./AxisTitlePosition";
import { FontInfo } from "igniteui-angular-core";
import { IFastItemsSource } from "igniteui-angular-core";
import { CoercionInfo } from "./CoercionInfo";
import { ChartContentType } from "./ChartContentType";
import { ISchedulableRender } from "igniteui-angular-core";
import { Rectangle } from "igniteui-angular-core";
import { Path } from "igniteui-angular-core";
import { Line } from "igniteui-angular-core";
import { RenderingContext } from "igniteui-angular-core";
import { TextBlock } from "igniteui-angular-core";
import { ITileZoomTile } from "./ITileZoomTile";
import { RenderSurface } from "./RenderSurface";
import { PathGeometry } from "igniteui-angular-core";
import { Geometry } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { LabelPanelsArrangeState } from "./LabelPanelsArrangeState";
import { AxisLabelsLocation } from "./AxisLabelsLocation";
import { IProvidesViewport } from "./IProvidesViewport";
import { DomRenderer, DomWrapper } from "igniteui-angular-core";
import { PointerTooltipStyle } from "./PointerTooltipStyle";
import { BrushCollection } from "igniteui-angular-core";
import { DefaultPaletteInfo } from "./DefaultPaletteInfo";
import { AxisRange } from "./AxisRange";
import { AxisAnnotationCollection } from "./AxisAnnotationCollection";
import { VerticalAlignment } from "igniteui-angular-core";
import { Canvas } from "igniteui-angular-core";
import { IFastItemsSourceProvider } from "igniteui-angular-core";
import { AxisExtentType } from "./AxisExtentType";
import { DoubleCollection } from "igniteui-angular-core";
import { LabelPosition } from "./LabelPosition";
import { BindingFormatter } from "igniteui-angular-core";
import { LabelFontHeuristics } from "./LabelFontHeuristics";
import { AxisOrientation } from "./AxisOrientation";
import { Pool$1 } from "igniteui-angular-core";
import { AxisComponentsFromView } from "./AxisComponentsFromView";
import { AxisRangeChangedEventArgs } from "./AxisRangeChangedEventArgs";
import { GeometryCollection } from "igniteui-angular-core";
import { PathRenderingInfo } from "./PathRenderingInfo";
import { RenderRequestedEventArgs } from "./RenderRequestedEventArgs";
import { CategoryMode } from "./CategoryMode";
import { GridMode } from "./GridMode";
import { Panel } from "igniteui-angular-core";
import { UIElement } from "igniteui-angular-core";
import { TickmarkValues } from "./TickmarkValues";
import { ICategoryScaler } from "./ICategoryScaler";
import { FastItemsSourceEventArgs } from "igniteui-angular-core";
import { FastItemsSourceEventAction } from "igniteui-angular-core";
import { NumericAxisRenderingParameters } from "./NumericAxisRenderingParameters";
import { AxisRenderingParametersBase } from "./AxisRenderingParametersBase";
import { HighlightingState } from "./HighlightingState";
import { Marker } from "./Marker";
import { Polyline } from "igniteui-angular-core";
import { ContentControl } from "igniteui-angular-core";
import { Polygon } from "igniteui-angular-core";
import { ILegendSeries } from "igniteui-angular-core";
import { ILegendTemplateProvider } from "igniteui-angular-core";
import { StandardLegendItems } from "igniteui-angular-core";
import { StandardLegendBadges } from "igniteui-angular-core";
import { PenLineCap } from "igniteui-angular-core";
import { Color } from "igniteui-angular-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { SeriesComponentsFromView } from "./SeriesComponentsFromView";
import { IFastItemColumn$1 } from "igniteui-angular-core";
import { ISortingAxis } from "./ISortingAxis";
import { MarkerType } from "./MarkerType";
import { Style } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class SeriesViewer extends Control implements INotifyPropertyChanged, ILegendOwner, IInternalLegendOwner {
    static $t: Type;
    private _widget;
    widget: ISeriesViewerWidget;
    b1: SeriesViewerView;
    static staticInit(): void;
    private cc;
    private readonly cd;
    private a0;
    readonly a1: ISeriesViewerInteractionManager;
    readonly df: boolean;
    constructor();
    private bt;
    iq(): void;
    private ke;
    ir(): void;
    readonly series: SeriesCollection;
    private bb;
    private k7;
    private _skipDataCleanup;
    skipDataCleanup: boolean;
    protected k1(a: any): void;
    private k8;
    iu(a: number, b: number, c: boolean, d: boolean): {
        p0?: number;
        p1?: number;
    };
    c4(): boolean;
    readonly d2: boolean;
    protected readonly dc: boolean;
    readonly az: IHighlightingManager;
    b2: DoubleAnimator;
    private ip;
    lj(a: number): void;
    io(): void;
    ng(a: number): Brush;
    nm(a: number): Brush;
    nk(a: number): Brush;
    nl(a: number): Brush;
    al: ChartContentManager;
    nu: Point;
    private nt;
    readonly de: boolean;
    legend: IChartLegend;
    static readonly mg: DependencyProperty;
    cw: boolean;
    plotAreaMouseLeftButtonDown: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseLeftButtonUp: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaClicked: (sender: any, e: PlotAreaMouseButtonEventArgs) => void;
    plotAreaMouseEnter: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseLeave: (sender: any, e: PlotAreaMouseEventArgs) => void;
    plotAreaMouseOver: (sender: any, e: PlotAreaMouseEventArgs) => void;
    jv(a: Point, b: boolean): void;
    private a2;
    private a6;
    jw(a: Point, b: boolean, c: boolean): void;
    static readonly l4: DependencyProperty;
    dm: boolean;
    static readonly mf: DependencyProperty;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected km(a: string, b: any, c: any): void;
    jm(): void;
    jn(a: IEnumerable): void;
    jy(a: Series, b: any, c: any): void;
    j2(a: Series, b: any, c: any): void;
    jz(a: Series, b: any, c: any): void;
    j0(a: Series, b: any, c: any): void;
    j1(a: Series, b: any, c: any): void;
    h4(a: Rect, b: ScalerParams): Tuple$2<boolean, number>;
    readonly dt: boolean;
    private cm;
    i6(): void;
    j3(a: Series, b: any, c: any): void;
    j4(a: Series, b: any, c: any): void;
    seriesCursorMouseMove: (sender: any, e: ChartCursorEventArgs) => void;
    kp(a: Series, b: any): void;
    seriesMouseLeftButtonDown: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    kt(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseLeftButtonUp: (sender: any, e: DataChartMouseButtonEventArgs) => void;
    ku(a: Series, b: any, c: MouseButtonEventArgs): void;
    seriesMouseMove: (sender: any, e: ChartMouseEventArgs) => void;
    kv(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseEnter: (sender: any, e: ChartMouseEventArgs) => void;
    kr(a: Series, b: any, c: MouseEventArgs): void;
    seriesMouseLeave: (sender: any, e: ChartMouseEventArgs) => void;
    ks(a: Series, b: any, c: MouseEventArgs): void;
    private ch;
    i5(): void;
    private n1;
    protected get_oh(): Rect;
    readonly oh: Rect;
    private nz;
    n6: Rect;
    ob(a: Rect, b: Rect, c: Rect): Rect;
    private cf;
    private ny;
    protected get_n5(): Rect;
    readonly n5: Rect;
    n9(a: Rect, b: Rect, c: Rect): Rect;
    protected n4(a: Rect): Rect;
    oa(): Rect;
    protected lf(a: Axis): void;
    oi: Rect;
    d8: boolean;
    cu: boolean;
    dy: boolean;
    fv: number;
    private fo;
    fr: number;
    fu: number;
    kh(a: Rect, b: Rect): void;
    private bd;
    be(): SeriesViewerComponentsForView;
    private ck;
    ia(a: Point, b: boolean): void;
    di: boolean;
    private an;
    ap: ChartHitTestMode;
    kx(): void;
    protected aq(): ChartHitTestMode;
    private am;
    ao: ChartHitTestMode;
    dj: boolean;
    seriesAnimating: (series: Series) => void;
    ko(a: Series): void;
    abstract dp(): boolean;
    abstract dq(): boolean;
    dn(): boolean;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    bs: InteractionState;
    private ci;
    private bo;
    jp(a: Point): void;
    jq(a: Point, b: boolean): void;
    dw(a: Point, b: number): boolean;
    jf(a: Point): void;
    dv(a: Key): boolean;
    private co;
    c0: boolean;
    private cg;
    cx: boolean;
    protected get_dg(): boolean;
    readonly dg: boolean;
    jh(a: Point): void;
    readonly c3: boolean;
    hu: string;
    ju(a: Point): void;
    ji(a: Point, b: boolean): void;
    jg(a: Point): void;
    dx: boolean;
    private kc;
    jt(a: Point): void;
    kd(a: Point, b: number, c: number, d: number): void;
    js(a: number): void;
    j9(a: Point, b: number, c: number, d: number): void;
    jo(a: Point): void;
    jr(a: number): void;
    jj(a: Point): void;
    j8(a: Point, b: number, c: number, d: number): void;
    jl(a: Size): void;
    im(): void;
    i9(a: Point, b: boolean): void;
    bq(a: boolean): InteractionState;
    viewerManipulationStarting: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    viewerManipulationEnding: (sender: any, e: SeriesViewerManipulationEventArgs) => void;
    private cs;
    kb(): void;
    ka(): void;
    lc(): void;
    ii(): void;
    ic(): void;
    ib(): void;
    kf(): void;
    k0(): void;
    ky(): void;
    i8(a: Point, b: boolean): void;
    d1(): boolean;
    private cp;
    d4: boolean;
    i7(a: Point, b: boolean, c: boolean): void;
    lo(a: any, b: PropertyUpdatedEventArgs): void;
    ln(a: SyncLink, b: SyncLink): void;
    id(a: Point): void;
    lq(a: Rect, b: boolean): void;
    lr(a: Rect, b: boolean, c: boolean): void;
    kg(a: Rect, b: boolean): void;
    readonly dk: boolean;
    private _eb;
    eb(): IEnumerable$1<SeriesViewer>;
    nw(a: Point): Point;
    og(a: Rect): Rect;
    windowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private kw;
    j7(a: Rect, b: Rect): void;
    sizeChanged: (sender: any, e: RectChangedEventArgs) => void;
    j5(a: Size, b: Size): void;
    c7: boolean;
    dz(a: Rect, b: Rect): boolean;
    actualWindowRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private kk;
    k6(): void;
    gridAreaRectChanged: (sender: any, e: RectChangedEventArgs) => void;
    private kl;
    protected get_dh(): boolean;
    readonly dh: boolean;
    jx(a: Rect, b: Rect): void;
    bi: WindowResponse;
    c2: boolean;
    fm: number;
    private _syncChannel;
    syncChannel: string;
    private bf;
    actualSyncLink: SyncLink;
    it(): void;
    on: Visibility;
    private cr;
    jd(): void;
    jb(): void;
    jc(): void;
    readonly bu: IOverviewPlusDetailPane;
    protected lk(a: boolean): void;
    om: Visibility;
    c6: boolean;
    d7: boolean;
    private bj;
    bk: ZoomCoercionMode;
    bl(): ZoomCoercionMode;
    bm: ZoomCoercionMode;
    no: Brush;
    ne: Brush;
    nn: Brush;
    cz(): boolean;
    cv(): boolean;
    oj: Rect;
    h9(): void;
    private fq;
    private notifyCrosshairUpdate;
    protected lp(a: number, b: number): void;
    e4(): number;
    e5(): number;
    protected ki(a: any, b: string, c: any, d: any): void;
    lm(): void;
    protected i3(): void;
    ll(): void;
    private cq;
    protected d5: boolean;
    bp: InteractionState;
    br: InteractionState;
    na: ModifierKeys;
    nb: ModifierKeys;
    private n0;
    oc: Rect;
    ec: Date;
    d9: boolean;
    protected le(): void;
    h5(): void;
    fk: number;
    fl: number;
    private of;
    refreshCompleted: (sender: any, e: RefreshCompletedEventArgs) => void;
    kn(): void;
    protected abstract b0(): SeriesViewerView;
    protected j6(a: SeriesViewerView): void;
    static oe: Rect;
    ls: DataTemplate;
    l1: DataTemplate;
    ly: DataTemplate;
    lz: DataTemplate;
    lt: DataTemplate;
    lw: DataTemplate;
    lu: DataTemplate;
    l0: DataTemplate;
    lx: DataTemplate;
    lv: DataTemplate;
    hk: string;
    m9: HorizontalAlignment;
    m8: HorizontalAlignment;
    private f1;
    hr: string;
    private f0;
    hf: string;
    private nd;
    ns: Brush;
    private nc;
    nr: Brush;
    private ev;
    fi: number;
    private et;
    fg: number;
    private eu;
    fh: number;
    private es;
    ff: number;
    private er;
    fe: number;
    private ep;
    fc: number;
    private eq;
    fd: number;
    private eo;
    fb: number;
    g8: string;
    ok(): Thickness;
    ol(): Thickness;
    aj(a: Axis): AxisTitlePosition;
    ak(a: Axis): AxisTitlePosition;
    abstract getFontInfo(): FontInfo;
    getFontHeight(): number;
    abstract getFontBrush(): Brush;
    abstract nf(): Brush;
    fy: any;
    provideContainer(a: any): void;
    ja(a: number, b: number): void;
    notifyContainerResized(): void;
    n7(): Rect;
    ij(): void;
    nv(): Point;
    b4(): FontInfo;
    b3(): FontInfo;
    nh(): Brush;
    ni(): Brush;
    h7(a: Series): void;
    k2(a: Series): void;
    ah: CanvasRenderScheduler;
    ai: CanvasRenderScheduler;
    ag: CanvasRenderScheduler;
    private cn;
    du: boolean;
    private ce;
    ct: boolean;
    private _syncSettings;
    syncSettings: SyncSettings;
    h6(a: any): void;
    k4(a: any): void;
    i0(source_: any, a: number, b: any, c: any): void;
    iv(source_: any): void;
    iy(source_: any, a: number, b: any): void;
    iz(source_: any, a: number, b: any): void;
    destroyed: boolean;
    protected fw: any;
    protected ea: Dictionary$2<string, any>;
    ds: boolean;
    destroy(): void;
    protected ih(): void;
    lb(source_: any): void;
    k5(): void;
    la(a: string, source_: any): void;
    k3(a: string, b: boolean): void;
    protected k9(a: Series, b: any): void;
    protected lh(a: any): void;
    protected li(): void;
    private ew;
    fj: number;
    private el;
    e7: number;
    private en;
    fa: number;
    private ej;
    e3: number;
    private ei;
    e2: number;
    private eh;
    e1: number;
    d0(): boolean;
    private cj;
    c9: boolean;
    private em;
    e8: number;
    private ek;
    e6: number;
    static bn(a: string, b: any): CoercionInfo;
    private fz;
    gs: string;
    private ee;
    ey: number;
    private ed;
    ex: number;
    private nx;
    n2: Rect;
    n8(): Rect;
    c5: boolean;
    private is;
    od(): Rect;
    protected n3(): Rect;
    fx(a: number, b: number): any;
    private ef;
    ez: number;
    private eg;
    e0: number;
    i2(): void;
    i1(): void;
    flush(): void;
    il(a: boolean, b: boolean): void;
    d6(): boolean;
    private l2;
    private ar;
    protected kz(a: DependencyObject, b: (arg1: boolean) => void): void;
    protected ld(a: DependencyObject): void;
    ie(): void;
    da: boolean;
    db: boolean;
    c8: boolean;
    jk(): void;
    private cl;
    readonly dl: boolean;
    h8(): void;
    dr(): boolean;
    private fp;
    ft(): number;
    b7(): FontInfo;
    b6(): FontInfo;
    lg(): void;
    protected cy: boolean;
    nq: Brush;
    np: Brush;
    e9: number;
    dd: boolean;
    seriesDataUpdated: (sender: any, e: EventArgs) => void;
    kq(): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class SeriesViewerView extends Base implements ISchedulableRender {
    static $t: Type;
    constructor(a: SeriesViewer);
    ci(): void;
    n: SeriesViewer;
    cy(): void;
    private ch;
    a: CanvasRenderScheduler;
    l: IOverviewPlusDetailPane;
    private dh;
    private dg;
    eg(): void;
    private cn;
    private cm;
    m: OverviewPlusDetailViewportHost;
    b5(a: number, b: number, c: RenderSurface): void;
    dz(): void;
    b7(): void;
    d1(): void;
    ce(): void;
    b6(): void;
    b8(): void;
    ds(a: Series): void;
    c6(): void;
    private el;
    ao(a: Series): boolean;
    protected f: SeriesCollection;
    protected b: AxisCollection;
    private ag;
    as: boolean;
    bn(a: Series): void;
    dm(a: RenderingContext): void;
    bv(): void;
    br(): void;
    b9(): void;
    b4(): void;
    dk(): void;
    protected fa: Rectangle;
    protected e9: Path;
    d2(): void;
    ea(a: Rect): void;
    bu(): void;
    c9(): void;
    ei(a: number, b: number, c: number, d: number): void;
    protected e8: Line;
    protected e7: Line;
    d7(): void;
    cf(): void;
    eb(a: number, b: number, c: number, d: number): void;
    d3(): void;
    ca(): void;
    cd(): void;
    private e0;
    private e1;
    eh(a: Rect, b: Rect): void;
    d6(): void;
    ej(a: Rect): void;
    dq(a: Axis): void;
    dr(a: Axis): void;
    bm(a: Axis): void;
    bj(a: Axis): void;
    private g;
    h(): SeriesViewerComponentsFromView;
    static au(a: Series): List$1<Series>;
    dw(): void;
    i: SeriesViewerViewManager;
    protected u: RenderingContext;
    x: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    al: boolean;
    am: boolean;
    protected bg: any;
    cu(a: any): void;
    private aj;
    protected cs(a: Point, b: boolean): void;
    protected ct(a: Point, b: boolean): void;
    protected cx(a: Point): void;
    protected cr(a: Point, b: boolean, c: boolean): void;
    dn(a: RenderingContext): void;
    protected get_an(): boolean;
    readonly an: boolean;
    j: EventProxy;
    d9(): void;
    a7: number;
    e(a: Point, b: boolean, c: DataContext, d: boolean): {
        ret: Series;
        p2: DataContext;
    };
    bb(): number;
    ba(): number;
    a6: number;
    a5: number;
    private e3;
    private ah;
    co(): void;
    cv(a: number, b: number): void;
    dx(): void;
    private az;
    private ax;
    private ay;
    private aw;
    private ai;
    private y;
    private b0;
    private ee;
    t(): FontInfo;
    s(): FontInfo;
    private ez;
    private ey;
    private bd;
    private a0;
    private bc;
    fe(): Thickness;
    fd(): Thickness;
    protected dp(a: Rect): void;
    ck(): void;
    private e4;
    protected du(): void;
    isValid(): boolean;
    preRender(): void;
    protected dl(): void;
    protected z: boolean;
    protected dv(): void;
    cw(): void;
    cq(): void;
    e5(): Rect;
    e2(): Point;
    private d0;
    d8(): void;
    di(): void;
    protected aq(a: Point): boolean;
    c2(a: Point, b: boolean, c: boolean): void;
    protected c1(a: Point): void;
    protected c0(a: Point): void;
    protected c3(a: Point): void;
    dy(): void;
    readonly et: ModifierKeys;
    ek(a: Rect): void;
    cl(a: boolean): void;
    bi(a: boolean): void;
    protected ef(): void;
    private ad;
    isDirty: boolean;
    undirty(a: boolean): void;
    readonly index: number;
    postRender(): void;
    b3(): void;
    protected ac: boolean;
    cb(): void;
    d4(): void;
    bt(a: boolean): void;
    bk(a: any): void;
    ec(a: number): void;
    ed(a: number): void;
    bl(a: any): void;
    dt(a: any): void;
    c4(a: Brush): void;
    bs(a: Point): void;
    at: boolean;
    k(a: boolean): InteractionState;
    cz(): void;
    private en;
    private em;
    a9(a: TextBlock, b: FontInfo): number;
    a8(a: string, b: FontInfo): number;
    dd(): void;
    private eo;
    dc(): void;
    c8(): void;
    c(a: Axis): AxisTitlePosition;
    d(a: Axis): AxisTitlePosition;
    de(): void;
    df(): void;
    r(): FontInfo;
    ex(): Brush;
    o(): FontInfo;
    eu(): Brush;
    q(): FontInfo;
    p(): FontInfo;
    ew(): Brush;
    ev(): Brush;
    readonly a2: number;
    readonly a3: number;
    readonly a4: number;
    readonly a1: number;
    readonly eq: TextBlock;
    readonly ep: TextBlock;
    e6(): Rect;
    fc(): Thickness;
    fb(): Thickness;
    private ab;
    private aa;
    c7(a: any, b: any): void;
    db(a: any, b: any): void;
    es(): HorizontalAlignment;
    er(): HorizontalAlignment;
    private ae;
    bo(): void;
    ak(): boolean;
    b2(): void;
    cj(): void;
    ar(a: Point): boolean;
    dj(): void;
    private av;
    b1(a: Dictionary$2<any, ITileZoomTile>, b: List$1<ITileZoomTile>, c: number): void;
    bf(a: Rect, b: ITileZoomTile, c: number): any;
    by(): void;
    bz(a: ITileZoomTile): void;
    cg(): void;
    ap: boolean;
    private be;
    bw(): void;
    bp(): void;
    bx(a: number): void;
    bq(): void;
    private af;
    cc(): void;
    d5(): void;
    da(): void;
    cp(): void;
    c5(): void;
    bh(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class OverviewPlusDetailViewportHost extends Base implements IProvidesViewport {
    static $t: Type;
    constructor(a: SeriesViewerView);
    a: SeriesViewerView;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    getEffectiveViewport(): Rect;
}
/**
 * @hidden
 */
export declare class SeriesViewerViewManager extends Base {
    static $t: Type;
    ae: DomRenderer;
    protected af: DomWrapper;
    protected aj: DomWrapper;
    protected ai: DomWrapper;
    protected ag: DomWrapper;
    ak: DomWrapper;
    t: RenderingContext;
    w: RenderingContext;
    v: RenderingContext;
    u: RenderingContext;
    x: RenderingContext;
    f: EventProxy;
    private j;
    constructor(a: SeriesViewerView);
    protected ah: DomWrapper;
    bi(): void;
    bf(a: any): void;
    static bx(a: DomRenderer, b: () => void): void;
    private bh;
    a9(): void;
    g(): IOverviewPlusDetailPane;
    bl(): void;
    bm(): void;
    b2(): Brush;
    private ab;
    private aa;
    private ac;
    ay(a: number, b: number, c: number): void;
    b7(): Point;
    y(): boolean;
    bb(a: boolean): void;
    a7(a: BrushCollection, b: BrushCollection, c: Brush, d: FontInfo, e: Brush): {
        p0: BrushCollection;
        p1: BrushCollection;
        p2: Brush;
        p3: FontInfo;
        p4: Brush;
    };
    e(): DefaultPaletteInfo;
    a6(a: number, b: number[], c: Brush, d: Brush, e: number, f: boolean): {
        p0: number;
        p1: number[];
        p2: Brush;
        p3: Brush;
        p4: number;
        p5: boolean;
    };
    ax(): void;
    bt(x_: number): void;
    private ad;
    bu(y_: number): void;
    at(a: any): void;
    a8(): void;
    bn(): void;
    au(a: any): void;
    bj(a: any): void;
    bc(): void;
    private l;
    p(): FontInfo;
    private b9;
    cd(): Thickness;
    private aq;
    as(): string;
    private ap;
    ar(): string;
    private b8;
    cc(): Thickness;
    private bz;
    b4(): Brush;
    private by;
    b3(): Brush;
    private k;
    o(): FontInfo;
    private a;
    c(): AxisTitlePosition;
    private b;
    d(): AxisTitlePosition;
    private n;
    r(): FontInfo;
    private b1;
    b6(): Brush;
    private m;
    q(): FontInfo;
    private b0;
    b5(): Brush;
    private ca;
    ce(): Thickness;
    private cb;
    cf(): Thickness;
    bo(): void;
    private bw;
    private bq;
    private bp;
    private br;
    private bs;
    a5(a: number, b: number): void;
    private h;
    i(): PointerTooltipStyle;
    ba(a: boolean): void;
    private z;
    an(a: Rect, b: ITileZoomTile, c: number): any;
    a2(a: ITileZoomTile): void;
    a1(): void;
    bk(a: List$1<ITileZoomTile>): void;
    private al;
    az(): void;
    av(): void;
    private am;
    a0(a: number): void;
    aw(): void;
    private s;
    bd(): void;
    bv(a: boolean): void;
    a3(): void;
    a4(): void;
    bg(): void;
    be(): void;
    ao(a: number, b: number): any;
}
/**
 * @hidden
 */
export declare class AutoRangeCalculator extends Base {
    static $t: Type;
    static a(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
}
/**
 * @hidden
 */
export interface IAxisAnnotationManager {
    owner: Axis;
    onAutoAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAutoAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAnnotionsChanged(a: Axis, b: AxisAnnotationCollection, c: NotifyCollectionChangedEventArgs): void;
    onAnnotionsReset(a: Axis, b: AxisAnnotationCollection, c: EventArgs): void;
    onAddAnnotations(a: Axis): void;
    arrangeAnnotations(a: Axis, b: AxisLabelPanelBaseView, c: List$1<FrameworkElement>, d: List$1<Rect>, e: boolean, f: number, g: number, h: number, i: number, j: number): void;
}
/**
 * @hidden
 */
export declare let IAxisAnnotationManager_$type: Type;
/**
 * @hidden
 */
export declare class AxisLabelSettings extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private aa;
    textStyle: string;
    private ax;
    textColor: Brush;
    location: AxisLabelsLocation;
    private b;
    visibility: Visibility;
    private a2;
    showFirstLabel: boolean;
    private h;
    c: AxisLabelsLocation;
    a: Axis;
    registerAxis(a: Axis): void;
    unregisterAxis(a: Axis): void;
    angle: number;
    private m;
    extent: number;
    private o;
    margin: number;
    leftMargin: number;
    private p;
    rightMargin: number;
    private q;
    topMargin: number;
    private r;
    bottomMargin: number;
    private n;
    private au;
    horizontalAlignment: HorizontalAlignment;
    private az;
    verticalAlignment: VerticalAlignment;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    ar(a: string, b: any, c: any): void;
    protected aq(a: any, b: string, c: any, d: any): void;
    j(): boolean;
    k(): boolean;
    static readonly extentPropertyDefault: number;
    readonly i: boolean;
    private f;
    g(a: DomRenderer): FontInfo;
}
/**
 * @hidden
 */
export declare class TitleSettings extends AxisLabelSettings {
    static $t: Type;
    constructor();
    private a4;
    position: AxisTitlePosition;
    protected aq(a: any, b: string, c: any, d: any): void;
}
/**
 * @hidden
 */
export declare abstract class Axis extends Control implements INotifyPropertyChanged {
    static $t: Type;
    a3(): AxisView;
    a4: AxisView;
    gx(a: AxisView): void;
    gk(): void;
    private bs;
    readonly bt: SRProvider;
    private a8;
    readonly a9: IAxisVisualDataManager;
    dx(): number;
    fb(): any;
    fa(): any;
    protected get_b4(): boolean;
    readonly b4: boolean;
    protected get_cc(): boolean;
    readonly cc: boolean;
    protected get_b2(): boolean;
    readonly b2: boolean;
    protected get_ce(): boolean;
    readonly ce: boolean;
    protected get_ch(): boolean;
    readonly ch: boolean;
    protected get_cf(): boolean;
    readonly cf: boolean;
    protected get_b7(): boolean;
    readonly b7: boolean;
    protected get_cd(): boolean;
    readonly cd: boolean;
    protected get_b5(): boolean;
    readonly b5: boolean;
    protected get_b6(): boolean;
    readonly b6: boolean;
    aj(): Axis;
    constructor();
    private a6;
    readonly a7: IAxisAnnotationManager;
    readonly b3: boolean;
    private gi;
    private gj;
    private gg;
    private gh;
    provideRenderer(a: DomRenderer): void;
    at: (item: any) => string;
    gu(a: Rect, b: Rect): void;
    abstract au(): AxisLabelPanelBase;
    ac(): void;
    hp: Canvas;
    bn: IFastItemsSourceProvider;
    private bm;
    bh: SeriesViewer;
    private bg;
    bf: XamDataChart;
    readonly br: (sender: any, e: RectChangedEventArgs) => void;
    private bw;
    cr: boolean;
    private c5;
    ef: number;
    private c0;
    dg: number;
    private db;
    el: number;
    private c8;
    ei: number;
    private ar;
    as: AxisExtentType;
    private c4;
    ee: number;
    df: number;
    private da;
    ek: number;
    private c7;
    eh: number;
    private bj;
    private bi;
    bl: FontInfo;
    private fc;
    f3: string;
    private c6;
    eg: number;
    dh: number;
    private dc;
    em: number;
    private c9;
    ej: number;
    private ex;
    e2: number;
    private ew;
    e1: number;
    private ev;
    e0: number;
    ey: number;
    private jf;
    ji: VerticalAlignment;
    private de;
    eo: number;
    private dd;
    en: number;
    hh(): void;
    private g8;
    private g9;
    hq: TextBlock;
    gc: string;
    iv: Brush;
    ir: Brush;
    ep: number;
    iz: DoubleCollection;
    iu: Brush;
    is: Brush;
    ip: Brush;
    d5: number;
    ix: DoubleCollection;
    it: Brush;
    iq: Brush;
    d8: number;
    iy: DoubleCollection;
    iw: Brush;
    er: number;
    i0: DoubleCollection;
    eq: number;
    di: number;
    private hj;
    b8: boolean;
    ca: boolean;
    cb: boolean;
    cq: boolean;
    static readonly il: DependencyProperty;
    ez: number;
    ay: AxisLabelSettings;
    dm(): number;
    im(): HorizontalAlignment;
    jg(): VerticalAlignment;
    io(): HorizontalAlignment;
    jh(): VerticalAlignment;
    dp(): number;
    dr(): number;
    dq(): number;
    dn(): number;
    du(): number;
    dw(): number;
    dv(): number;
    dt(): number;
    az(): AxisLabelsLocation;
    a0(): AxisLabelsLocation;
    ai: Axis;
    e4: any;
    rangeChanged: (sender: any, e: AxisRangeChangedEventArgs) => void;
    protected g6(a: AxisRangeChangedEventArgs): void;
    be: TitleSettings;
    ds(): number;
    dl(): number;
    readonly am: AxisAnnotationCollection;
    private ak;
    readonly an: AxisAnnotationCollection;
    private al;
    private i2;
    i9: Rect;
    i8: Rect;
    hk(): void;
    ct(a: Rect, b: Rect, c: AxisView): boolean;
    cg(): boolean;
    cx: List$1<any>;
    cy: List$1<LabelPosition>;
    av: AxisLabelPanelBase;
    protected hn(a: Rect, b: Rect): void;
    private bv;
    ci: boolean;
    protected i6(): Rect;
    protected ho(a: Rect, b: Rect): void;
    g7(): void;
    a5: ContentInfo;
    eu: DomRenderer;
    ah: BindingFormatter;
    protected gz(a: any, b: string, c: any, d: any): void;
    private _coercionMethods;
    coercionMethods: any;
    private bu;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    cl: boolean;
    private he;
    cs: boolean;
    protected gw(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected gv(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    protected hm(a: GeometryCollection, b: number, c: number, d: Rect): void;
    protected hl(a: GeometryCollection, b: number, c: Rect, d: PathRenderingInfo, e: boolean): void;
    private b9;
    protected hg(a: number, b: number, c: Rect, d: Rect, e: Rect, f: number, g: number): {
        p0: number;
        p1: number;
    };
    dj(a: number, b: number, c: number, d: PathRenderingInfo): number;
    gn(a: GeometryCollection): void;
    protected gm(): void;
    ha(): void;
    hb(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    bb: LabelFontHeuristics;
    static d7: number;
    ec(): number;
    ea(): number;
    eb(): number;
    protected readonly cm: boolean;
    gp(a: boolean): void;
    private c2;
    private by;
    hd(): void;
    protected hf(): void;
    private c3;
    ba(): LabelFontHeuristics;
    bk(): FontInfo;
    private gq;
    cj: boolean;
    cn(): boolean;
    co(a: boolean): boolean;
    cp(): boolean;
    protected hc(a: boolean): void;
    hi(): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected g5(a: string, b: any, c: any): void;
    cz: List$1<Series>;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    e9: any;
    fo: string;
    ag: any[];
    e6(a: any, b: string): any;
    private cv;
    protected f0(a: string): string;
    private cu;
    protected e7(a: any, b: string, c: string): any;
    e8(a: any): any;
    fl(a: number): string;
    d9(): number;
    dy(a: number, b: ScalerParams): number;
    dz(a: number, b: ScalerParams, c: CategoryMode): number;
    i5(a: Rect): Rect;
    i4(): Rect;
    i3(): Rect;
    protected i7(a: Rect, b: Rect): Rect;
    d0(a: number, b: Rect, c: Rect): number;
    gs(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    gr(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    d1(a: number, b: ScalerParams): number;
    d2(a: number, b: ScalerParams, c: CategoryMode): number;
    d3(a: number, b: Rect, c: Rect): number;
    gt(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    ed(a: number): number;
    abstract readonly a1: AxisOrientation;
    je: Size;
    gy(): void;
    ao: AxisComponentsForView;
    ap(): AxisComponentsForView;
    dk: number;
    private c1;
    d6: number;
    b1(): boolean;
    d4(): number;
    protected gl(): void;
    go(a: AxisRangeChangedEventArgs): void;
    bq: Pool$1<TextBlock>;
    bp: Pool$1<TextBlock>;
    bo: Pool$1<Rectangle>;
    readonly ja: Path;
    readonly jb: Path;
    readonly jd: Path;
    readonly jc: Path;
    bd(): SyncSettings;
    aq(): AxisComponentsFromView;
    private aw;
    readonly ax: AxisLabelSettings;
    g0(a: RenderingContext, b: RenderingContext): void;
    b0(): boolean;
    e5(): any;
    private _cw;
    cw(): IEnumerable$1<Series>;
    g1(a: string): void;
    g4(a: any): void;
    g3(a: any): void;
    et: CultureInfo;
    i1(a: number, b: Rect, c: Rect, d?: any, e?: any): Geometry;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisCollection extends ObservableCollection$1<Axis> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class AxisLabelManager extends Base {
    static $t: Type;
    e: List$1<any>;
    f: List$1<LabelPosition>;
    b: AxisLabelPanelBase;
    a: Axis;
    c: (arg1: number) => void;
    constructor();
    m(a: Rect, b: Rect): void;
    i(a: any, b: LabelPosition): void;
    s(): void;
    static j(a: FrameworkElement): void;
    private static k;
    static l(a: FrameworkElement): void;
    h(a: FrameworkElement): void;
    q(a: number): void;
    n(a: number): void;
    t(a: number): FrameworkElement;
    r(a: number): void;
    readonly d: boolean;
    p(): void;
    o(): void;
    g(): void;
}
/**
 * @hidden
 */
export declare abstract class AxisLabelPanelBase extends Panel {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b9(a: AxisLabelPanelBaseView): void;
    ae: AxisLabelPanelBaseView;
    cm: Rect;
    b0(): void;
    cf(): void;
    ce(): void;
    constructor();
    bo: number;
    ac: Axis;
    private aj;
    au: boolean;
    private ay;
    a2: List$1<any>;
    a3: List$1<LabelPosition>;
    cp: Rect;
    private cl;
    cq: Rect;
    private ck;
    co: Rect;
    private a5;
    a9: number;
    bp: () => boolean;
    a4: List$1<FrameworkElement>;
    a1: List$1<Rect>;
    af: AxisLabelSettings;
    an: boolean;
    aq: boolean;
    ar: boolean;
    as: boolean;
    br: any;
    ak: boolean;
    protected am(a: List$1<Rect>, b: List$1<boolean>): boolean;
    protected bq(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    az(): List$1<Rect>;
    by(): void;
    bu(a: Size): void;
    be(): number;
    bi(): number;
    ap(a: number, b: Rect): boolean;
    bd(a: any): number;
    bn(a: any): number;
    bf(a: any): number;
    bc(a: any): number;
    ao(): boolean;
    protected ci(a: Rect, b: Rect): void;
    protected b5(a: Rect, b: Rect): void;
    a0(): List$1<Rect>;
    bh(a: number, b: Size): number;
    bg(a: number, b: Size): number;
    bl(): number;
    bj(): number;
    bk(): number;
    bm(): number;
    cr(a: Size): Size;
    protected readonly al: boolean;
    cn(): Rect;
    protected bx(a: Size): void;
    protected bw(a: Size): void;
    protected b1(): void;
    protected ax(): IEnumerable$1<number>;
    readonly ag: AxisLabelsLocation;
    ch(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    b4(a: GeometryCollection, b: number, c: number, d: number, e: Rect, f: PathRenderingInfo): void;
    cc(a: FrameworkElement, b: number): void;
    cd(a: FrameworkElement): void;
    b3(a: FrameworkElement, b: number): void;
    cs(a: Size): Size;
    static readonly cj: DependencyProperty;
    ba: number;
    a6: number;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    at(a: AxisLabelsLocation): boolean;
    private _av;
    av(): IEnumerable$1<any>;
    bt(a: number, b: TextBlock, c: number, d: number, e: number): string;
    bz(a: any): void;
    b8(a: FrameworkElement): void;
    private _aw;
    aw(): IEnumerable$1<any>;
    protected a7: number;
    protected a8: number;
    b2(): void;
    cg(): void;
    b6(): void;
    bb(a: Rect): number;
    b7(): void;
    ca(a: RenderingContext): void;
    bv(): void;
    cb(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryAxisBase extends Axis implements ICategoryScaler {
    static $t: Type;
    a3(): AxisView;
    protected get_b6(): boolean;
    gx(a: AxisView): void;
    jj: CategoryAxisBaseView;
    constructor();
    ct(a: Rect, b: Rect, c: AxisView): boolean;
    kr(): void;
    kq(): void;
    ju: List$1<number>;
    protected get_b4(): boolean;
    k2(a: Point, b: boolean, c: number): Rect;
    k3(a: Point, b: boolean, c: number, d: boolean): Rect;
    jn: IFastItemsSource;
    private jm;
    itemsSource: IEnumerable;
    static readonly kz: DependencyProperty;
    private j5;
    j7: number;
    j8: number;
    categoryMode: CategoryMode;
    private jk;
    jw: number;
    j3: number;
    jr: boolean;
    j9: number;
    private j6;
    d1(a: number, b: ScalerParams): number;
    getUnscaledValue3(a: number, b: Rect, c: Rect, d: CategoryMode): number;
    getCategorySize(a: Rect, b: Rect, c: Rect): number;
    jz(a: Rect, b: Rect, c: Rect): number;
    getGroupCenter(a: number, b: Rect, c: Rect, d: Rect): number;
    j4(a: number): number;
    private _jt;
    private jt;
    private jp;
    jq(a: SeriesViewer): boolean;
    private _js;
    private js;
    private jo;
    kv(a: boolean): void;
    protected gz(a: any, b: string, c: any, d: any): void;
    protected kj(): void;
    kl(a: any, b: FastItemsSourceEventArgs): void;
    protected ks(a: FastItemsSourceEventArgs): void;
    private kw;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    private kt;
    ki(): void;
    ku(): void;
    kk(a: NotifyCollectionChangedEventArgs): void;
    kp(a: number, b: any, c: any): void;
    km(): void;
    kn(a: number, b: any): void;
    ko(a: number, b: any): void;
    j0(a: Rect, b: Rect, c: Rect, d: number): number;
    j1(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    getSeriesOffset(a: Rect, b: Rect, c: Rect, d: number, e: number): number;
    readonly isVertical: boolean;
    j$c(a: number, b: ScalerParams): number;
    j$b(a: number, b: ScalerParams): number;
    j$d(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    j$e(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    j$f(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    readonly j$a: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b9(a: AxisLabelPanelBaseView): void;
    ct: HorizontalAxisLabelPanelBaseView;
    c5: number;
    c2: number;
    c4: number;
    c3: number;
    by(): void;
    cv(): boolean;
    cw(): boolean;
    ao(): boolean;
    az(): List$1<Rect>;
    c7(a: List$1<Rect>, b: List$1<boolean>, c: number): void;
    private c6;
    private c8;
    protected c9(a: List$1<Rect>, b: List$1<boolean>): void;
    protected da(): void;
    cc(a: FrameworkElement, b: number): void;
    protected cx(): boolean;
    protected cu(): boolean;
    protected bq(a: number, b: List$1<Rect>, c: List$1<boolean>): {
        ret: number;
        p1?: List$1<Rect>;
    };
    cn(): Rect;
    c1(): number;
    cy(): number;
    c0(): number;
    cz(): number;
    protected b1(): void;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    static $t: Type;
    ah(): AxisLabelsLocation;
    at(a: AxisLabelsLocation): boolean;
}
/**
 * @hidden
 */
export declare abstract class NumericAxisBase extends Axis {
    static $t: Type;
    a3(): AxisView;
    gx(a: AxisView): void;
    jk: NumericAxisBaseView;
    protected get_cc(): boolean;
    constructor();
    kk: number;
    kc: number;
    private j6;
    ki: number;
    fb(): any;
    kf: number;
    private j9;
    kj: number;
    kb: number;
    private j5;
    fa(): any;
    kh: number;
    private j8;
    ke: number;
    kg: number;
    private j4;
    ka: number;
    d9(): number;
    kl: number;
    private j7;
    kd: number;
    km: number;
    j1: boolean;
    private jv;
    jx: boolean;
    readonly j2: boolean;
    ko: number;
    kp: number;
    jn: NumericAxisRenderer;
    protected j3: boolean;
    protected hc(a: boolean): void;
    g4(a: any): void;
    g3(a: any): void;
    protected gz(a: any, b: string, c: any, d: any): void;
    protected k9(): void;
    jj(): AxisRange;
    k7(a: NumericAxisBase, b: number, c: number, d: boolean, e: number, f: number, g: number): {
        p5: number;
        p6: number;
    };
    cp(): boolean;
    la(a: AxisRangeChangedEventArgs): void;
    ck(a: Series): boolean;
    bx(a: Series): boolean;
    jm(a: AxisLabelManager): NumericAxisRenderer;
    jl(): NumericAxisRenderer;
    jp(): NumericAxisRenderingParameters;
    k8(): void;
    jq(): NumericScaler;
    jo(a: Rect, b: Rect, c: Rect, d: Rect): NumericAxisRenderingParameters;
    kn(a: number): number;
    jy(): boolean;
    readonly j0: boolean;
    readonly jz: boolean;
    private lb;
    static readonly lj: DependencyProperty;
    jt: TickmarkValues;
    private jr;
    js: TickmarkValues;
    private ju;
    jw: boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class NumericScaler extends DependencyObject {
    static $t: Type;
    static readonly ac: Rect;
    abstract t(a: NumericAxisBase, b: number, c: number, d: number, e: number): {
        p3: number;
        p4: number;
    };
    l: number;
    k: number;
    protected o: number;
    protected n: number;
    y(a: number): void;
    x(a: number): void;
    protected w(a: string, b: any, c: any): void;
    private z;
    protected m: number;
    abstract q(a: number, b: ScalerParams): number;
    abstract p(a: number, b: ScalerParams): number;
    j(a: IList$1<number>, b: number, c: number, d: ScalerParams): IList$1<number>;
    v(a: IList$1<number>, b: number, c: number, d: ScalerParams): void;
    u(a: IList$1<number[]>, b: IList$1<number>, c: number, d: number, e: ScalerParams): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AxisRendererBase extends Base {
    static $t: Type;
    constructor(a: AxisLabelManager);
    u: () => void;
    o: (viewportRect: Rect, windowRect: Rect) => boolean;
    v: () => void;
    m: (p: AxisRenderingParametersBase, value: number) => number;
    l: (p: AxisRenderingParametersBase, geometry: GeometryCollection, startValue: number, endValue: number) => void;
    k: (p: AxisRenderingParametersBase, geometry: GeometryCollection, value: number) => void;
    q: (p: AxisRenderingParametersBase, value: number) => boolean;
    n: (p: AxisRenderingParametersBase, value: number) => boolean;
    j: (p: AxisRenderingParametersBase) => void;
    e: (p: AxisRenderingParametersBase) => void;
    p: (p: AxisRenderingParametersBase, position: number, isLastLabel: boolean) => boolean;
    h: (p: AxisRenderingParametersBase, value: number) => LabelPosition;
    t: (p: AxisRenderingParametersBase, value: number) => number;
    b: AxisLabelManager;
    g: (item: any) => any;
    d: (viewportRect: Rect, windowRect: Rect, effectiveViewportRect: Rect, contentViewport: Rect) => AxisRenderingParametersBase;
    r: (p: AxisRenderingParametersBase, value: number, absoluteIndex: number, interval: number) => number;
    a: (p: AxisRenderingParametersBase, value: number, absolueIndex: number, interval: number) => number;
    f: (index: number, window: Rect, viewport: Rect, effectiveViewport: Rect) => number;
    i: (index: number) => number;
    c(a: boolean, b: Rect, c: Rect, d: Rect, e: Rect): AxisRenderingParametersBase;
    private aa;
    private ab;
    protected x(a: Rect, b: Rect): void;
    private z;
    private s;
    private y;
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
}
/**
 * @hidden
 */
export declare class NumericAxisRenderer extends AxisRendererBase {
    static $t: Type;
    constructor(a: AxisLabelManager);
    w(a: AxisRenderingParametersBase, b: number, c: number, d: number): any;
    private ac;
    private ad;
    private ae;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    static $t: Type;
    ad(): AxisLabelPanelBaseView;
    b9(a: AxisLabelPanelBaseView): void;
    ct: VerticalAxisLabelPanelView;
    c2: number;
    cz: number;
    c1: number;
    c0: number;
    by(): void;
    bi(): number;
    cv(): number;
    cx(): number;
    cy(): number;
    cw(): number;
    az(): List$1<Rect>;
    private c3;
    private c4;
    cc(a: FrameworkElement, b: number): void;
    protected cu(): boolean;
    cn(): Rect;
    ai(a: TitleSettings): AxisTitlePosition;
    ah(): AxisLabelsLocation;
    at(a: AxisLabelsLocation): boolean;
    protected b1(): void;
}
/**
 * @hidden
 */
export interface IHasCategoryAxis {
    readonly categoryAxis: CategoryAxisBase;
    getOffsetValue(): number;
    getCategoryWidth(): number;
}
/**
 * @hidden
 */
export declare let IHasCategoryAxis_$type: Type;
/**
 * @hidden
 */
export interface IHasCategoryModePreference extends IHasCategoryAxis {
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
}
/**
 * @hidden
 */
export declare let IHasCategoryModePreference_$type: Type;
/**
 * @hidden
 */
export interface IHighlightingManager {
    startHighlight(a: HighlightingInfo): void;
    endHighlight(a: HighlightingInfo): void;
    clear(): void;
    getHighlightingInfo(a: Series, b: IFastItemsSource, c: Axis, d: number, e: number, f: boolean): HighlightingInfo;
    tick(a: number): boolean;
    inProgress: boolean;
    maxHighlightingProgress: number;
    sumHighlightingProgress: number;
    maxMarkerHighlightingProgress: number;
    sumMarkerHighlightingProgress: number;
    readonly dirtySeries: List$1<Series>;
}
/**
 * @hidden
 */
export declare let IHighlightingManager_$type: Type;
/**
 * @hidden
 */
export declare class HighlightingInfo extends Base {
    static $t: Type;
    constructor();
    f: number;
    e: number;
    a: HighlightingState;
    d: number;
    c: boolean;
    b: Series;
}
/**
 * @hidden
 */
export interface ISeriesInteractionManager {
    a$i(a: Series, b: Point, c: number, d: Axis, e: ScalerParams, f: number, g: number, h: (arg1: Point) => number): number;
    a$l(a: Series, b: IList$1<number>, c: Point, d: Axis, e: ScalerParams, f: number, g: (arg1: Point) => number, h: boolean, i: boolean): number;
    a$k(a: Series, b: number, c: IList$1<number>, d: number, e: number, f: number, g: number, h: number, i: boolean): number;
    a$n(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$d(a: Series, b: Point, c: boolean): boolean;
    a$a(a: Series, b: CategoryAxisBase, c: List$1<number[]>, d: number, e: number, f: Point, g: boolean): number[][];
    a$e(a: Series, b: Point, c: boolean, d: PathGeometry): boolean;
    a$f(a: Series, b: Point, c: PathGeometry): boolean;
    a$m(a: Series, b: Point, c: boolean, d: Axis, e: (arg1: Point) => number, f: IList$1<number>): number;
    a$j(a: Series, b: Point, c: Axis): number;
    a$g(a: Series, b: Point, c: boolean): boolean;
    a$aj(a: Series, b: Point, c: boolean, d: boolean, e: number, f: Axis, g: Axis, h: (arg1: Point, arg2: boolean, arg3: boolean) => number, i: (arg1: Point, arg2: boolean) => number, j: (arg1: Point, arg2: boolean) => number): Point;
    a$t(a: Series, b: any, c: Point, d: boolean, e: boolean): void;
    a$ai(a: Series, b: HighlightingInfo, c: Brush): Brush;
    a$w(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$ag(a: Series, b: Point): void;
    a$z(a: Series, b: Point, c: any, d: any, e: boolean): void;
    a$x(a: Series, b: Point, c: any, d: any): void;
    a$u(a: Series, b: Point, c: any, d: any): void;
    a$y(a: Series, b: Point, c: any, d: any): void;
    a$v(a: Series, b: Point, c: any, d: any): void;
    a$aa(a: Series, b: Point, c: any, d: any): void;
    a$ab(a: Series, b: Point, c: any, d: any): void;
    a$p(a: Series): string;
    a$q(a: Series): string;
    readonly a$b: boolean;
    readonly a$o: any;
    a$ah(a: Series, b: any): void;
    a$af(a: Series, b: Point, c: (arg1: any) => void): void;
    a$s(a: Series): void;
    a$ae(a: Series): void;
    readonly a$c: boolean;
    readonly a$h: Dictionary$2<string, SeriesView>;
    a$r(a: Series, b: Rect, c: Rect, d: string, e: number): void;
    a$ac(a: Series, b: SeriesViewer): void;
    a$ad(a: Series, b: string, c: SeriesViewer): void;
}
/**
 * @hidden
 */
export declare let ISeriesInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesViewerInteractionManager {
    f$a(a: SeriesViewer): ChartHitTestMode;
    f$ae(a: SeriesViewer): void;
    f$p(a: SeriesViewer, b: Point): void;
    f$ac(a: SeriesViewer, b: Point): void;
    f$q(a: SeriesViewer, b: Point, c: boolean): void;
    f$o(a: SeriesViewer, b: Point): void;
    f$aj(a: SeriesViewer): void;
    f$ab(a: SeriesViewer, b: Point): void;
    f$ak(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$aa(a: SeriesViewer, b: number): void;
    f$ag(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$x(a: SeriesViewer, b: Point): void;
    f$z(a: SeriesViewer, b: number): void;
    f$r(a: SeriesViewer, b: Point): void;
    f$af(a: SeriesViewer, b: Point, c: number, d: number, e: number): void;
    f$m(a: SeriesViewer, b: Point, c: boolean): void;
    f$ai(a: SeriesViewer): void;
    f$ah(a: SeriesViewer): void;
    f$am(a: SeriesViewer): void;
    f$j(a: SeriesViewer): void;
    f$g(a: SeriesViewer): void;
    f$l(a: SeriesViewer, b: Point, c: boolean): void;
    f$k(a: SeriesViewer, b: Point, c: boolean, d: boolean): void;
    f$al(a: SeriesViewer): void;
    f$ad(a: SeriesViewer): void;
    f$d(a: SeriesViewer, b: Key): boolean;
    f$e(a: SeriesViewer, b: Point, c: number): boolean;
    f$n(a: SeriesViewer, b: Point): void;
    f$i(a: SeriesViewer): void;
    f$h(a: SeriesViewer): void;
    readonly f$b: IHighlightingManager;
    f$c(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: DataContext, g: boolean): {
        ret: Series;
        p5: DataContext;
    };
    f$f(a: SeriesViewer, b: Point): boolean;
    f$v(a: SeriesViewer, b: SeriesCollection, c: RenderingContext, d: Point, e: boolean, f: boolean): void;
    f$u(a: SeriesViewer, b: Point): void;
    f$t(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$w(a: SeriesViewer, b: EventProxy, c: Point): void;
    f$s(a: SeriesViewer, b: Point, c: boolean): void;
    f$y(a: SeriesViewer, b: boolean): void;
}
/**
 * @hidden
 */
export declare let ISeriesViewerInteractionManager_$type: Type;
/**
 * @hidden
 */
export interface IDataChartVisualDataManager {
    exportVisualData(a: XamDataChart): any;
}
/**
 * @hidden
 */
export declare let IDataChartVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface IAxisVisualDataManager {
    exportVisualData(a: Axis): any;
}
/**
 * @hidden
 */
export declare let IAxisVisualDataManager_$type: Type;
/**
 * @hidden
 */
export interface ISeriesVisualDataManager {
    exportVisualData(a: Series, b: Rect): any;
    exportMarkerVisualData(a: MarkerSeries, b: any): void;
    getMarkerVisualData(a: Series, b: Marker, c: DataTemplate): any;
    copyVisualData(a: any, b: any): void;
    exportTrendlineData(a: Series, b: any, c: Polyline): void;
    exportStackedVisualData(a: Series, b: Rect): any;
    createFragmentVisualData(a: Series, b: Rect, c: string, d: string): any;
    addSubSeriesVisualData(a: any, b: any): void;
    exportRectangleData(a: any, b: Rectangle, c: string, d: string[]): void;
    exportMarkerVisualDataFromMarker(a: Series, b: any, c: ContentControl): void;
    exportPathData(a: any, b: Path, c: string, d: string[]): void;
    exportPolylineData(a: any, b: Polyline, c: string, d: string[]): void;
    exportPolygonData(a: any, b: Polygon, c: string, d: string[]): void;
    exportSeriesPixelsData(a: any, b: number[], c: number, d: number): void;
    addPointerTooltipData(a: any, b: any, c: number, d: number, e: List$1<string>): void;
    exportPointerTooltipData(a: Polygon, b: Polyline, c: Rectangle, d: Rect): any;
    exportCalloutData(a: number, b: number, c: number, d: number, e: any, f: Rectangle, g: TextBlock, h: FontInfo, i: Line, j: string, k: string[]): void;
}
/**
 * @hidden
 */
export declare let ISeriesVisualDataManager_$type: Type;
/**
 * @hidden
 */
export declare class XamDataChart extends SeriesViewer {
    static $t: Type;
    static pp: number;
    static po: number;
    private _xsr;
    private readonly XSRP;
    private ow;
    readonly ox: IDataChartVisualDataManager;
    static staticInit(): void;
    static pw(a: Series): number;
    constructor();
    protected ki(a: any, b: string, c: any, d: any): void;
    private qo;
    o8: boolean;
    e4(): number;
    e5(): number;
    protected le(): void;
    pu: number;
    pv: number;
    private pe;
    pk: number;
    private pf;
    pl: number;
    dp(): boolean;
    dq(): boolean;
    o5: boolean;
    pc: boolean;
    o6: boolean;
    o9: boolean;
    ov: GridMode;
    o2: boolean;
    pb: boolean;
    oo: BrushCollection;
    pn: number;
    pm: number;
    pa: boolean;
    o7: boolean;
    qq(a: AxisLabelPanelBase, b: Rect, c: Rect, d: Rect): void;
    op: BrushCollection;
    or: BrushCollection;
    oq: BrushCollection;
    re: Brush;
    rc: Brush;
    rd: Brush;
    readonly axes: AxisCollection;
    private os;
    private ql;
    private qm;
    axisRangeChanged: (sender: any, e: ChartAxisRangeChangedEventArgs) => void;
    private qn;
    private static qp;
    ln(a: SyncLink, b: SyncLink): void;
    private oz;
    getFontInfo(): FontInfo;
    qr(): void;
    getFontBrush(): Brush;
    protected ih(): void;
    nf(): Brush;
    d0(): boolean;
    protected li(): void;
    ng(a: number): Brush;
    private rf;
    nk(a: number): Brush;
    nl(a: number): Brush;
    nm(a: number): Brush;
    c4(): boolean;
    private o4;
    protected b0(): SeriesViewerView;
    protected j6(a: SeriesViewerView): void;
    oy: XamDataChartView;
    ky(): void;
    private ph;
    pr: number;
    private pj;
    pt: number;
    private pi;
    ps: number;
    private pg;
    pq: number;
    protected n4(a: Rect): Rect;
    oa(): Rect;
    px(): any;
    p7(): string;
    kf(): void;
    k0(): void;
    pd(a: Axis): List$1<Axis>;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class LabelPanelArranger extends Base {
    static $t: Type;
    static e(a: List$1<AxisLabelPanelBase>, b: Rect): Rect;
    private static a;
    static b(a: AxisLabelPanelBase): AxisLabelsLocation;
    private static c;
    static d(a: List$1<AxisLabelPanelBase>, b: LabelPanelsArrangeState, c: Rect, d: (arg1: AxisLabelPanelBase, arg2: Rect) => void): void;
}
/**
 * @hidden
 */
export declare class ChartContentManager extends DependencyObject {
    static $t: Type;
    private l;
    private q;
    private s;
    private t;
    constructor(a: SeriesViewer);
    k(a: ChartContentType, b: DependencyObject, c: (arg1: boolean) => void): ContentInfo;
    ac(a: ChartContentType, b: DependencyObject): void;
    private m;
    private u;
    z(a: DomRenderer): void;
    y(): void;
    ab(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: boolean): void;
    private p;
    private j;
    x(): void;
    private v;
    private _r;
    private r;
    w(a: Size): void;
    n: boolean;
    o: boolean;
    ad(a: ChartContentType, b: DependencyObject, c: ContentInfo, d: Rect): void;
    aa(a: Axis, b: ContentInfo): void;
}
/**
 * @hidden
 */
export declare class ContentInfo extends Base {
    static $t: Type;
    h: DependencyObject;
    a: (arg1: boolean) => void;
    b: boolean;
    c: boolean;
    i: Rect;
    readonly d: boolean;
    g(): void;
    f(): void;
    e: boolean;
}
/**
 * @hidden
 */
export declare abstract class Series extends Control implements INotifyPropertyChanged, IProvidesViewport, ILegendSeries, ILegendOwner, ILegendTemplateProvider {
    static $t: Type;
    bi: SeriesView;
    private static e5;
    fk: number;
    lz: Rect;
    private e3;
    e4: DomRenderer;
    provideRenderer(a: DomRenderer): void;
    g3(): string;
    constructor();
    private static readonly la;
    protected hw(a: any, b: PropertyChangedEventArgs): void;
    private b1;
    readonly b2: SRProvider;
    private a1;
    readonly a2: ISeriesVisualDataManager;
    protected readonly dz: Dictionary$2<string, SeriesView>;
    private az;
    readonly a0: ISeriesInteractionManager;
    readonly cx: boolean;
    bt: DoubleAnimator;
    i2(a: SeriesView): void;
    i0(): void;
    i1(): void;
    bg(): SeriesView;
    protected bf(): SeriesView;
    j5: Canvas;
    dt(): boolean;
    fs(a: any, b: string): any;
    private dy;
    protected g2(a: string): string;
    private dx;
    protected ft(a: any, b: string, c: string): any;
    eb(a: Point): number;
    fa(a: Point): number;
    protected get_c1(): boolean;
    readonly c1: boolean;
    ap(): CategoryAxisBase;
    e8(a: Point): number;
    fp(a: Point): any;
    protected fu(a: Series, b: Point): any;
    e7(): number;
    fb(): number;
    fg(): number;
    readonly container: ILegendOwner;
    readonly hasSubItems: boolean;
    protected ci(): boolean;
    forSubItems(a: (arg1: any) => void): void;
    protected ie(a: (arg1: any) => void): void;
    ig(a: (arg1: Series) => boolean): void;
    lj(): Brush;
    resolveLegendIndex(): number;
    a6(): Series;
    protected get_cj(): boolean;
    readonly cj: boolean;
    protected get_isVertical(): boolean;
    readonly isVertical: boolean;
    protected get_cs(): boolean;
    readonly cs: boolean;
    protected get_ck(): boolean;
    readonly ck: boolean;
    protected get_c0(): boolean;
    readonly c0: boolean;
    protected get_c4(): boolean;
    readonly c4: boolean;
    protected get_c2(): boolean;
    readonly c2: boolean;
    protected get_isStacked(): boolean;
    readonly isStacked: boolean;
    protected get_cr(): boolean;
    readonly cr: boolean;
    protected get_c3(): boolean;
    readonly c3: boolean;
    protected get_cl(): boolean;
    readonly cl: boolean;
    protected get_ct(): boolean;
    readonly ct: boolean;
    protected get_c5(): boolean;
    readonly c5: boolean;
    protected get_c6(): boolean;
    readonly c6: boolean;
    a5(): Series;
    protected get_cm(): boolean;
    readonly cm: boolean;
    protected get_cn(): boolean;
    readonly cn: boolean;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    protected ea(a: Point, b: number, c: Axis, d: ScalerParams, e: number, f: number, g: (arg1: Point) => number): number;
    protected get_dv(): boolean;
    readonly dv: boolean;
    protected ep(a: IList$1<number>, b: Point, c: Axis, d: ScalerParams, e: number, f: (arg1: Point) => number, g: boolean, h: boolean): number;
    ef(a: number, b: IList$1<number>, c: number, d: number, e: number, f: number, g: number, h: boolean): number;
    ff(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    ee(a: boolean): number;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    protected dg(a: Point, b: boolean): boolean;
    aj(a: CategoryAxisBase, b: List$1<number[]>, c: number, d: number, e: Point, f: boolean): number[][];
    protected di(a: Point, b: boolean, c: PathGeometry): boolean;
    protected dj(a: Point, b: PathGeometry): boolean;
    fd(a: Point, b: boolean, c: Axis, d: (arg1: Point) => number, e: IList$1<number>): number;
    ed(a: Point, b: Axis): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    en(a: Point, b: boolean, c: boolean): number;
    lv(a: Point, b: boolean, c: boolean): Point;
    l4(a: Point): Rect;
    ak(a: Point): Rect[];
    l5(a: Point): Rect;
    al(a: Point): Rect[];
    l6(a: Point): Rect;
    l7(a: Point): Rect;
    protected dk(a: Point, b: boolean): boolean;
    protected lx(a: Point, b: boolean, c: boolean, d: number, e: Axis, f: Axis, g: (arg1: Point, arg2: boolean, arg3: boolean) => number, h: (arg1: Point, arg2: boolean) => number, i: (arg1: Point, arg2: boolean) => number): Point;
    ej(a: Point, b: boolean, c: boolean): number;
    lr(a: Point, b: boolean, c: boolean): Point;
    el(a: Point, b: boolean, c: boolean): number;
    lt(a: Point, b: boolean, c: boolean): Point;
    lw(a: Point, b: boolean, c: boolean): Point;
    eo(a: Point, b: boolean, c: boolean): number;
    ls(a: Point, b: boolean, c: boolean): Point;
    ek(a: Point, b: boolean, c: boolean): number;
    lu(a: Point, b: boolean, c: boolean): Point;
    em(a: Point, b: boolean, c: boolean): number;
    e9(a: Point): number;
    eg(): number;
    ec(a: Point): number;
    fq(a: Point): any;
    ch(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected raisePropertyChanged(a: string, b: any, c: any): void;
    protected get_hasMarkers(): boolean;
    readonly hasMarkers: boolean;
    ij(): void;
    lg(): Brush;
    lh(): Brush;
    j7(): DataTemplate;
    ly(a: Point): Point;
    lq(a: Point): Point;
    fv(a: any, b: Point): any;
    c9(a: any): boolean;
    an(a: Axis): AxisRange;
    ao(a: Rect): AxisRange;
    jl(a: boolean): void;
    renderRequested: (sender: any, e: RenderRequestedEventArgs) => void;
    private h9;
    jm(a: boolean): void;
    protected dm: boolean;
    protected h0(): void;
    protected h4(): void;
    bh: SeriesView;
    jn(a: Rect, b: RenderSurface): void;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    getEffectiveViewport1(a: SeriesView): Rect;
    l0(a: SeriesView): Rect;
    l3(a: Rect): Rect;
    l2(a: SeriesView): Rect;
    getEffectiveViewport(): Rect;
    jf(): void;
    private jg;
    jh(a: string): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    h3(a: boolean, b: SeriesView): void;
    protected cb(): boolean;
    cc(a: SeriesView): boolean;
    i3(a: Rect, b: Rect): void;
    protected j1(a: Rect, b: Rect): void;
    protected j0(a: Rect, b: Rect): void;
    aq: ContentInfo;
    private b6;
    dl: boolean;
    protected id(a: Series): void;
    protected iu(): void;
    it(): void;
    protected get_cw(): boolean;
    readonly cw: boolean;
    protected get_isUsableInLegend(): boolean;
    readonly isUsableInLegend: boolean;
    protected iy(): void;
    iv(): void;
    protected i4(): void;
    i5(): void;
    protected de: boolean;
    protected df: boolean;
    protected c8(): boolean;
    protected i6(a: boolean): void;
    private b7;
    protected dn: boolean;
    protected readonly dp: boolean;
    protected v(): void;
    protected w(a: Visibility, b: Visibility): void;
    protected i7(a: any, b: string, c: any, d: any): void;
    ib(): void;
    protected cg(): boolean;
    protected get_cv(): boolean;
    protected readonly cv: boolean;
    cd: boolean;
    protected h8(a: Series): void;
    bn: SyncLink;
    private bm;
    bs: SeriesViewer;
    private br;
    bq: XamDataChart;
    readonly d3: (sender: any, e: NotifyCollectionChangedEventArgs) => void;
    readonly a4: (sender: any, e: PropertyUpdatedEventArgs) => void;
    readonly b0: (sender: any, e: RectChangedEventArgs) => void;
    itemsSource: IEnumerable;
    static readonly kl: DependencyProperty;
    bz: IFastItemsSource;
    e0: (sender: any, e: FastItemsSourceEventArgs) => void;
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    legend: IChartLegend;
    static readonly kp: DependencyProperty;
    j4: Control;
    private j2;
    fw(): any;
    protected j3(): Control;
    aw: IChartLegend;
    private av;
    l9: Visibility;
    legendItemBadgeTemplate: DataTemplate;
    static readonly km: DependencyProperty;
    bl: StandardLegendItems;
    bj: StandardLegendBadges;
    bk: StandardLegendItems;
    legendItemTemplate: DataTemplate;
    static readonly kn: DependencyProperty;
    j6: DataTemplate;
    static readonly kf: DependencyProperty;
    fh: number;
    static readonly ki: DependencyProperty;
    jz(): void;
    ia(): void;
    protected jw(): void;
    bu: (time: number) => number;
    bv: (time: number) => number;
    cf: boolean;
    fi: number;
    ez: number;
    ca(): boolean;
    jt(): void;
    eu: number;
    fx: any;
    ld: Brush;
    lb: Brush;
    le: Brush;
    lf: Brush;
    li: Brush;
    lc: Brush;
    es: number;
    ey: number;
    lm: PenLineCap;
    ll: DoubleCollection;
    toolTip: any;
    cu: boolean;
    cp: boolean;
    protected get_cq(): boolean;
    readonly cq: boolean;
    ev: number;
    lk: Color;
    du: boolean;
    ew: number;
    ex: number;
    b9: boolean;
    d7: number;
    d6: number;
    jv(): void;
    private b5;
    co: boolean;
    dd: boolean;
    as(a: any): DataContext;
    fj: number;
    bp: TransitionInSpeedType;
    protected bo(): TransitionInSpeedType;
    fn: any;
    jj(): void;
    jo(): void;
    ji(): void;
    h1(): void;
    ik(): void;
    private static _d1;
    static d1(a: (arg1: number) => number, b: number, c: number): IEnumerable$1<number>;
    static d0(a: (arg1: number) => number, b: number): IEnumerable$1<number>;
    lo: PenLineCap;
    ln: PenLineCap;
    private a7;
    a8(): SeriesComponentsForView;
    jp(a: Canvas): void;
    eq(): number;
    er(): number;
    private b8;
    protected get_dq(): boolean;
    protected set_dq(a: boolean): void;
    protected dq: boolean;
    readonly db: boolean;
    c7: boolean;
    at(a: any, b: Point): HighlightingInfo;
    au(a: any, b: Point): HighlightingInfo;
    iz(a: Point, b: any, c: any, d: boolean): void;
    js(a: Point): void;
    private hy;
    private h2;
    hx(a: IChartLegend, b: IChartLegend): void;
    private hz;
    je(a: IFastItemsSourceProvider): void;
    jd(a: IFastItemsSourceProvider): void;
    protected ax(): IChartLegend;
    protected dc(): boolean;
    da(a: boolean): boolean;
    protected h7(a: Axis): void;
    protected jc(a: Axis): void;
    a9(): SeriesComponentsFromView;
    jx(a: Canvas): void;
    jr(a: Point, b: (arg1: any) => void): void;
    protected get_ds(): boolean;
    readonly ds: boolean;
    i8(a: RenderingContext, b: RenderingContext): void;
    ja(a: Rect): void;
    ii(a: NotifyCollectionChangedEventArgs): void;
    ir(a: number, b: any, c: any): void;
    io(): void;
    ip(a: number, b: any): void;
    iq(a: number, b: any): void;
    ju(): void;
    fz: any;
    e2: (arg1: any) => any;
    dh(a: Point, b: boolean): boolean;
    protected _coercionMethods: any;
    protected get_coercionMethods(): any;
    protected set_coercionMethods(a: any): void;
    coercionMethods: any;
    private b4;
    protected get_expectFunctions(): boolean;
    protected set_expectFunctions(a: boolean): void;
    expectFunctions: boolean;
    ar(a: Point, b: boolean): DataContext;
    private bb;
    be: SeriesHitTestMode;
    protected bd(): SeriesHitTestMode;
    private ba;
    bc: SeriesHitTestMode;
    protected bw(a: string): IFastItemColumn$1<number>;
    protected bx(a: string): IFastItemColumn$1<number>;
    protected by(a: string): IFastItemColumn$1<any>;
    protected readonly l8: Rect;
    protected get_cz(): boolean;
    readonly cz: boolean;
    protected get_cy(): boolean;
    readonly cy: boolean;
    jq(a: Brush, b: Brush): void;
    b3: (arg1: SeriesViewer) => void;
    protected h5(a: any, b: any): void;
    fo(): any;
    protected ic(a: any): void;
    private lp;
    il(a: Point): void;
    protected ix(a: Point): void;
    im(): void;
    is(): void;
    am(a: Axis): Axis;
    ag(): Axis[];
    eh(): number;
    static ei(a: IList$1<number>, b: ISortingAxis): number;
    iw(): void;
    private d4;
    d8: number;
    private d5;
    et: number;
    protected jy(): void;
    fr(a: any): any;
    readonly f7: string;
    readonly f2: string;
    readonly f3: string;
    readonly f6: string;
    readonly gb: string;
    readonly ga: string;
    readonly f9: string;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare abstract class MarkerSeries extends Series {
    static $t: Type;
    ma: MarkerSeriesView;
    constructor();
    i2(a: SeriesView): void;
    protected get_hasMarkers(): boolean;
    lg(): Brush;
    lh(): Brush;
    j7(): DataTemplate;
    mb: MarkerType;
    mw: DataTemplate;
    mg: number;
    mu: DataTemplate;
    mv: DataTemplate;
    private static mt;
    static readonly mx: DataTemplate;
    na: Brush;
    static readonly m1: DependencyProperty;
    m8: Brush;
    nb: Brush;
    m9: Brush;
    nc: Style;
    mf: boolean;
    md(): boolean;
    protected i7(a: any, b: string, c: any, d: any): void;
    static ml(a: MarkerType): string;
    static mc(a: Series, b: MarkerType): MarkerType;
    protected jw(): void;
    protected ic(a: any): void;
    protected me(a: Point, b: boolean): boolean;
    ar(a: Point, b: boolean): DataContext;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class SyncLink extends FrameworkElement implements INotifyPropertyChanged, IFastItemsSourceProvider {
    static $t: Type;
    constructor();
    ai: string;
    protected am(a: any, b: string, c: any, d: any): void;
    releaseFastItemsSource(a: IEnumerable): IFastItemsSource;
    static ah: (arg1: IEnumerable) => IFastItemsSource;
    private static ad;
    getFastItemsSource(a: IEnumerable): IFastItemsSource;
    ae(a: IEnumerable): IFastItemsSource;
    private af;
    aq: Rect;
    private ar;
    private as;
    readonly ag: IList$1<SeriesViewer>;
    ab: ChartCollection;
    private aj;
    ak(a: SeriesViewer, b: Point): void;
    al(a: SeriesViewer, b: Rect): void;
    ao(a: SeriesViewer, b: Rect): void;
    ap(a: SeriesViewer, b: Rect, c: boolean): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    propertyUpdated: (sender: any, e: PropertyUpdatedEventArgs) => void;
    protected an(a: string, b: any, c: any): void;
}
/**
 * @hidden
 */
export declare class SyncLinkManager extends Base {
    static $t: Type;
    private static b;
    static instance(): SyncLinkManager;
    private d;
    readonly e: number;
    constructor();
    getLink(a: string): SyncLink;
    releaseLink(a: SyncLink): void;
}
/**
 * @hidden
 */
export declare class SyncManager extends Base {
    static $t: Type;
    static e(a: SeriesViewer): void;
    static c(a: SeriesViewer): void;
    static b(a: SeriesViewer, b: string, c: string): void;
    static d(a: DependencyObject, b: SyncSettings): void;
    static a(a: DependencyObject): SyncSettings;
}
/**
 * @hidden
 */
export declare class ChartCollection extends ObservableCollection$1<SeriesViewer> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class SeriesCollection extends ObservableCollection$1<Series> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    chartPosition: Point;
    private _plotAreaPosition;
    plotAreaPosition: Point;
    private _isDuringManipulation;
    isDuringManipulation: boolean;
    private _viewer;
    viewer: SeriesViewer;
}
/**
 * @hidden
 */
export declare class PlotAreaMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Point, c: Point);
    private _chartPosition;
    chartPosition: Point;
    private _plotAreaPosition;
    plotAreaPosition: Point;
    private _manipulationOccurred;
    manipulationOccurred: boolean;
    private _viewer;
    viewer: SeriesViewer;
}
/**
 * @hidden
 */
export declare class ChartCursorEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any);
    toString(): string;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _seriesViewer;
    seriesViewer: SeriesViewer;
    readonly chart: XamDataChart;
}
/**
 * @hidden
 */
export declare class DataChartMouseButtonEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseButtonEventArgs);
    toString(): string;
    protected g: MouseButtonEventArgs;
    handled: boolean;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
}
/**
 * @hidden
 */
export declare class ChartMouseEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Series, c: any, d: MouseEventArgs);
    toString(): string;
    private f;
    getPosition(a: UIElement): Point;
    readonly originalSource: any;
    private _item;
    item: any;
    private _series;
    series: Series;
    private _chart;
    chart: SeriesViewer;
}
/**
 * @hidden
 */
export declare class AxisComponentsForView extends Base {
    static $t: Type;
    a: AxisLabelPanelBase;
}
/**
 * @hidden
 */
export declare class AxisLabelPanelBaseView extends Base {
    static $t: Type;
    protected a: AxisLabelPanelBase;
    av: Path;
    constructor(a: AxisLabelPanelBase);
    aa(a: FrameworkElement, b: Rect, c: number, d: number, e: number, f: number): void;
    z(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number): void;
    ad(a: FrameworkElement): void;
    ag(a: any): void;
    ah(a: any, b: Size): void;
    ai(a: FrameworkElement, b: number): void;
    aq(a: Rectangle, b: TextBlock, c: LabelPosition, d: Rect, e: number, f: number, g: number, h: number, i: number): void;
    x(a: TextBlock, b: number, c: number, d: number): string;
    ae(): void;
    g(): IEnumerable$1<any>;
    l(a: any): number;
    n(a: any): number;
    am(): void;
    m(a: any): number;
    w(a: any): number;
    ac(): void;
    aj(): void;
    protected e: RenderingContext;
    f(): RenderingContext;
    ak(a: RenderingContext): void;
    y(): void;
    protected al(): void;
    private au;
    protected ao(a: TextBlock): void;
    an(): void;
    d(): FontInfo;
    as(): Brush;
    private c;
    af(): void;
    private h;
    private ar;
    private i;
    j(): number;
    k(): number;
    protected ap(): void;
    ab(a: Size): void;
    protected aw(): Thickness;
    v(): number;
    s(): number;
    t(): number;
    u(): number;
    at(): GeometryCollection;
    b(): PathRenderingInfo;
    r(): number;
    p(): number;
    q(): number;
    o(): number;
}
/**
 * @hidden
 */
export declare class AxisView extends Base implements ISchedulableRender {
    static $t: Type;
    protected a: Axis;
    constructor(a: Axis);
    ag(): void;
    ai(a: any): void;
    a7: Path;
    a8: Path;
    ba: Path;
    a9: Path;
    ax(): TextBlock;
    aq(a: TextBlock): void;
    as(a: TextBlock): void;
    ar(a: TextBlock): void;
    bc(): Rectangle;
    p(a: Rectangle): void;
    r(a: Rectangle): void;
    q(a: Rectangle): void;
    aj(): void;
    m(): boolean;
    readonly index: number;
    ad(): void;
    ab(): void;
    x(): void;
    av(a: Visibility): void;
    an(): void;
    w(a: AxisLabelSettings): void;
    private b;
    c(): AxisComponentsFromView;
    z(a: GeometryCollection): void;
    ay(): GeometryCollection;
    e(): PathRenderingInfo;
    a1(): GeometryCollection;
    az(): GeometryCollection;
    f(): PathRenderingInfo;
    a0(): GeometryCollection;
    g(): PathRenderingInfo;
    protected readonly d: AxisLabelPanelBase;
    at(a: Axis, b: Rect, c: Rect): void;
    y(): void;
    ap(a: number): void;
    au(a: List$1<any>, b: List$1<LabelPosition>): void;
    ao(a: number): void;
    v(): void;
    private h;
    o(a: number): string;
    n(dataItem_: any): any;
    protected k: RenderingContext;
    j: RenderingContext;
    af(a: RenderingContext, b: RenderingContext): void;
    private _isDirty;
    isDirty: boolean;
    protected ae(): void;
    undirty(a: boolean): void;
    private bb;
    protected al(a: boolean): void;
    postRender(): void;
    private a5;
    protected am(): void;
    ac(): void;
    aa(a: SeriesViewer): void;
    u(a: SeriesViewer): void;
    i(): FontInfo;
    l(): boolean;
    ak(): void;
    t(): void;
    aw(): void;
    s(a: AxisLabelSettings, b: string): void;
    preRender(): void;
    isValid(): boolean;
    a2(a: TextBlock): Point;
    a3(): Point;
    a6(): Rect;
    a4(a: TextBlock): Point;
    bd(a: TextBlock): Thickness;
    ah(): void;
}
/**
 * @hidden
 */
export declare class CategoryAxisBaseView extends AxisView {
    static $t: Type;
    protected be: CategoryAxisBase;
    constructor(a: CategoryAxisBase);
    o(a: number): string;
    bf(a: List$1<any>): number;
}
/**
 * @hidden
 */
export declare class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: HorizontalAxisLabelPanelBase;
    constructor(a: HorizontalAxisLabelPanelBase);
    az(): void;
    ay(): boolean;
    a0(a: List$1<Rect>): void;
}
/**
 * @hidden
 */
export declare class NumericAxisBaseView extends AxisView {
    static $t: Type;
    protected be: NumericAxisBase;
    constructor(a: NumericAxisBase);
    bf(): void;
    o(a: number): string;
}
/**
 * @hidden
 */
export declare class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    static $t: Type;
    protected ax: VerticalAxisLabelPanel;
    constructor(a: VerticalAxisLabelPanel);
    ay(): void;
    d(): FontInfo;
    protected aw(): Thickness;
    as(): Brush;
    az(a: List$1<Rect>, b: number): void;
}
/**
 * @hidden
 */
export declare class XamDataChartView extends SeriesViewerView {
    static $t: Type;
    constructor(a: XamDataChart);
    protected ff: XamDataChart;
    fj(a: any): void;
    protected dl(): void;
    dy(): void;
    fo: Brush;
    fk: Brush;
    fl: Brush;
    fn: Brush;
    fm: Brush;
    fh: number;
    fi: number;
    protected dv(): void;
    fg: FontInfo;
}
/**
 * @hidden
 */
export declare class SeriesView extends Base implements ISchedulableRender, IProvidesViewport {
    static $t: Type;
    protected e: Series;
    p: boolean;
    constructor(a: Series);
    getDefaultTooltipTemplate(): string;
    am(): void;
    d: DataContext;
    ap(): void;
    getEffectiveViewport(): Rect;
    aw(): void;
    ag(): void;
    readonly t: DomRenderer;
    private _isDirty;
    isDirty: boolean;
    protected get_index(): number;
    readonly index: number;
    protected an(): void;
    undirty(a: boolean): void;
    private bt;
    ar(): void;
    private bk;
    bn(): Brush;
    s: number;
    private r;
    protected a1(a: boolean): void;
    private bo;
    protected ba(a: any, b: number, c: boolean): void;
    protected bd(a: any, b: number, c: boolean): void;
    protected x(a: number, b: boolean): any;
    protected y(a: number): any;
    protected z(a: number): any;
    protected bb(a: any, b: number): void;
    protected be(a: any, b: number): void;
    protected bc(a: any, b: number): void;
    protected bf(a: any, b: number): void;
    protected a7(a: boolean): void;
    protected a8(): void;
    protected a9(): void;
    private bj;
    protected bm(a: number): Brush;
    protected bl(): Brush;
    protected a3(a: RenderingContext, b: boolean): void;
    protected a2(a: RenderingContext, b: boolean): void;
    au(): void;
    aj(): void;
    ak(): void;
    private f;
    g(): SeriesComponentsFromView;
    a6(a: Canvas): void;
    q(): boolean;
    at(): void;
    as(): void;
    a4(): void;
    ae(): void;
    a5(): void;
    af(): void;
    c(a: any): DataContext;
    protected h: RenderingContext;
    protected i: RenderingContext;
    ao(a: RenderingContext, b: RenderingContext): void;
    private bp;
    br: Rect;
    bq: Rect;
    protected get_bs(): Rect;
    readonly bs: Rect;
    private j;
    n: boolean;
    ah(a: SeriesViewer): void;
    a: CanvasRenderScheduler;
    ad(a: SeriesViewer): void;
    postRender(): void;
    protected ax(): void;
    b(a: number): DataContext;
    az(a: RenderSurface): void;
    ai(a: any): void;
    bg(): void;
    aq(): void;
    av(): void;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    l(): boolean;
    protected o: boolean;
    bh(): void;
    a0(): void;
    protected ac(): void;
    al(): void;
    preRender(): void;
    isValid(): boolean;
    k: boolean;
    m: boolean;
    ay(a: RenderSurface): void;
    aa: string;
    bi(type_: StandardLegendItems): DataTemplate;
}
/**
 * @hidden
 */
export declare abstract class MarkerSeriesView extends SeriesView {
    static $t: Type;
    protected by: MarkerSeries;
    private b2;
    private b4;
    private b3;
    constructor(a: MarkerSeries);
    ap(): void;
    cd(): void;
    ck(a: boolean): void;
    protected b1: List$1<Marker>;
    bx(): Marker;
    abstract cc(a: (arg1: Marker) => void): void;
    cg(a: Marker): void;
    ci(a: Marker): void;
    ch(a: Marker): void;
    bz(): boolean;
    cb(): void;
    b5(): void;
    cm(a: Marker): Rect;
    b8(a: string): void;
    b9(): void;
    b6(): void;
    ca(): void;
    b7(): void;
    cj(): void;
    b0: boolean;
    protected be(a: any, b: number): void;
    private bu;
    protected bf(a: any, b: number): void;
    b(a: number): DataContext;
    private cl;
    protected a2(a: RenderingContext, b: boolean): void;
    ce(a: HashPool$2<any, Marker>): void;
    cf(a: Pool$1<Marker>): void;
    bv(a: Point): Marker;
    private bw;
}
/**
 * @hidden
 */
export declare class ChartAxisRangeChangedEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: SeriesViewer, b: Axis, c: number, d: number, e: number, f: number);
    private _chart;
    chart: SeriesViewer;
    private _axis;
    axis: Axis;
    private _oldMinimumValue;
    oldMinimumValue: number;
    private _minimumValue;
    minimumValue: number;
    private _oldMaximumValue;
    oldMaximumValue: number;
    private _maximumValue;
    maximumValue: number;
}
