import { __decorate, __metadata } from 'tslib';
import { NgModule, EventEmitter, Input, Output, TemplateRef, forwardRef, Component, ChangeDetectionStrategy, ViewChild, ViewContainerRef, Renderer2, NgZone, Injector, ComponentFactoryResolver, ChangeDetectorRef, ContentChildren, QueryList, ViewChildren, ElementRef } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Type, markEnum, Base, markType, FrameworkElement, PropertyChangedEventArgs, PropertyUpdatedEventArgs, INotifyPropertyChanged_$type, markDep, DependencyProperty, PropertyMetadata, Rect, EventArgs, CanvasViewRenderer, typeCast, IEquatable$1_$type, truncate, log10, ObservableCollection$1, DependencyObject, List$1, logBase, typeGetValue, Number_$type, isNaN_, TypeRegistrar, ContentControl, Control, Dictionary$2, String_$type, DVContainer, Point_$type, dateNow, CanvasRenderScheduler, delegateCombine, runOn, DoubleAnimator, SRProvider, delegateRemove, fromEnum, fromEn, PointUtil, MouseEventArgs, MouseButtonEventArgs, enumGetBox, toEnum, RectChangedEventArgs, Size, MathUtil, DeviceUtils, NotifyCollectionChangedEventArgs, stringIsNullOrEmpty, FastItemsSource, defaultDVDateParse, FontUtil, ILegendOwner_$type, IInternalLegendOwner_$type, IChartLegend_$type, Boolean_$type, Brush, DataTemplate, Visibility_$type, InteractionState_$type, ModifierKeys_$type, HorizontalAlignment_$type, Line, Path, Rectangle, PathFigureCollection, PathFigure, LineSegment, PathGeometry, GeometryGroup, Thickness, TextBlock, ISchedulableRender_$type, ArgumentNullException, stringEmpty, Tuple$2, DomWrapper_$type, RenderingContext, BrushCollection, CssGradientUtil, isInfinity, VerticalAlignment_$type, FastReflectionHelper, Pool$1, BindingFormatter, RectangleGeometry, LineGeometry, BrushUtilCore, Delegate_$type, Array_$type, DoubleCollection, Panel, RectUtil, RotateTransform, TransformGroup, IFastItemsSource_$type, IFastItemsSourceProvider_$type, IEnumerable_$type, AngleSimplifier, TranslateTransform, Canvas, Binding, DataContext, stringIsNullOrWhiteSpace, ILegendSeries_$type, ILegendTemplateProvider_$type, PenLineCap_$type, Color, Style, FastItemsSourceReference, stringFormat, EasingFunctions, DataTemplatePassInfo, DataTemplateRenderInfo, DataTemplateMeasureInfo, callStaticConstructors, BrushUtil, HashSet$1, LinkedList$1, LinkedListNode$1, FastItemObjectColumn, LabelCollisionManager, QuadTreeBoundingBox, Date_$type, LabelCollisionInfo, HashPool$2, DOMExecutionContext, PointCollection, Polygon, Polyline, ensureBool, brushToString, stringToBrush, arrayFindByName, IgCollection, SyncableObservableCollection$2, NamePatcher, ensureEnum, SyncableObservableCollection$1, toSpinal, initializePropertiesFromCss, colorToString, stringToColor, toPoint, fromPoint, fromRect, InterpolationUtil, ArrayAccessHelper, LinearGradientBrush, ColorUtil, round10N, NotImplementedException, FastItemColumn, Random, intDivide, Clipper, NotSupportedException, TrendLineType_$type, EnumUtil, PolyLineSegment, FastFlattener, IUnknownValuePlotting_$type, UnknownValuePlotting_$type, getEnumerator, IEnumerable$1_$type, ReadOnlyCollection$1, IList$1_$type, Numeric, ArrayExtension, DataSeriesAdapter, getInstanceType, DataSeriesType_$type, BaseError, ObservableColorCollection, BrushCollectionUtil, IDataSeriesAdapterRule_$type, SimpleCategorySeriesRule, SubCollectionsRule, fromBrushCollection, toBrushCollection, toRect, addPaletteThemeEntry, addTextThemeEntry, addBrushPaletteThemeEntry, AngularRenderer, DataSeriesType, IgxDataContext, AngularWrapper, numberToString2, GeometryUtil, PolygonUtil, boxArray$1, toNullable, IgxDVInteractivityModule, IgxDVInteractivityDynamicModule, Flattener, LeastSquaresFit, TrendCalculators, RectData, PointData, StringBuilder, LegendItemHelper, DOMEventProxy, ObjectCollection, UIElement, IList_$type, SweepDirection_$type, EllipseGeometry, PathSegmentCollection, ArcSegment, PrimitiveAppearanceData, LabelAppearanceData, AppearanceHelper, PathVisualData, BezierSegment, SizeData, DomRenderer_$type, IgxPropertyUpdatedEventArgs, CollectionAdapter, NotifyCollectionChangedAction, fromSize, toSize, dateAddDays, dateFromValues, dateGetMonth, dateAddHours, dateAddMinutes, dateAddSeconds, dateMaxValue, timeSpanFromDays, dateAddYears, dateAddMonths, timeSpanFromHours, timeSpanFromMinutes, timeSpanFromSeconds, timeSpanFromMilliseconds, timeSpanFromTicks, Extensions, getBoxIfEnum, dateMinValue, FastItemDateTimeColumn, dateSubtract, dateAdd, dateFromTicks, IDictionary$2_$type, IDictionary_$type, KeyValuePair$2, IEnumerator$1_$type, IEnumerator_$type, timeSpanTicks, dateToStringFormat, timeSpanInit3, timeSpanInit1, dateGetTimeOfDay, timeSpanTotalMilliseconds, SpiralFlattener, stringEndsWith, IFastItemColumn$1_$type, EnumeratorWrapper, stringStartsWith, stringReplace, stringJoin, SimpleFinancialPriceSeriesRule, IgxTemplateContentComponent, IgxTemplateContentModule, IgxTemplateContentDynamicModule, CanvasGestureDOMEventProxy, FontInfo, IZoomSlider_$type, IgxRectChangedEventArgs, ILegendContext_$type, IgxNumberFormatSpecifierModule, IgxDateTimeFormatSpecifierModule, IgxNumberFormatSpecifierDynamicModule, IgxDateTimeFormatSpecifierDynamicModule, CompareUtil, SmartPlacer, SmartPlaceableWrapper$1, RearrangedList$1, fromColorCollection, toColorCollection, IErrorBarCalculator_$type, ErrorBarCalculatorReference_$type, IChartItemLegend_$type, IChartScaleLegend_$type, IScaleLegendSeries_$type, arrayShallowClone, Stack$1, IgxTriangulationStatusEventArgs, Triangulator, TriangulationStatusEventArgs, FastItemIntColumn, PointCollectionUtil, InvalidOperationException, PolySimplification, IgxStyle, PlatformConstants, PrimitiveVisualDataList, RectangleVisualData, ColorData, PolygonVisualData, PolyLineVisualData, LineVisualData, IOverviewPlusDetailControl_$type, Shape, IgxObjectCollection, DictionaryUtil, Queue$1 } from 'igniteui-angular-core';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IAnnotationLayerProxy_$type = new Type(null, 'IAnnotationLayerProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for performing hit testing in the chart/map.
 */
var ChartHitTestMode;
(function (ChartHitTestMode) {
    /**
     * Automatically decide the appropriate hit test mode for the content.
     */
    ChartHitTestMode[ChartHitTestMode["Auto"] = 0] = "Auto";
    /**
     * Use a computational based approach to determine which series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
     */
    ChartHitTestMode[ChartHitTestMode["Computational"] = 1] = "Computational";
    /**
     * Use a color encoded off screen buffer for hit testing. This can have extremely rare false positives where the wrong series is hit (this is due to our inability to disable anti-aliasing in our color buffer), but should always be O(1) time for determining a hit series. This increases frame render time, however. Consider using this if hit testing time is degrading performance.
     */
    ChartHitTestMode[ChartHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
    /**
     * Let each series decide which hit testing mode to use individually based on their own hit test mode.
     */
    ChartHitTestMode[ChartHitTestMode["Mixed"] = 3] = "Mixed";
    /**
     * Let each series decide which hit testing mode to use individually based on their own hit test mode, but evaluate all computational hits before evaluating any color encoding hits.
     */
    ChartHitTestMode[ChartHitTestMode["MixedFavoringComputational"] = 4] = "MixedFavoringComputational";
})(ChartHitTestMode || (ChartHitTestMode = {}));
/**
 * @hidden
 */
let ChartHitTestMode_$type = markEnum('ChartHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2|Mixed,3|MixedFavoringComputational,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of UI response to user panning and zooming operations.
 */
var WindowResponse;
(function (WindowResponse) {
    /**
     * Defer the view update until after the user action is complete.
     */
    WindowResponse[WindowResponse["Deferred"] = 0] = "Deferred";
    /**
     * Update the view immediately while the user action is happening.
     */
    WindowResponse[WindowResponse["Immediate"] = 1] = "Immediate";
})(WindowResponse || (WindowResponse = {}));
/**
 * @hidden
 */
let WindowResponse_$type = markEnum('WindowResponse', 'Deferred,0|Immediate,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewerComponentsFromView extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
    }
}
SeriesViewerComponentsFromView.$t = markType(SeriesViewerComponentsFromView, 'SeriesViewerComponentsFromView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available locations of the axis labels in the chart.
 */
var ZoomCoercionMode;
(function (ZoomCoercionMode) {
    /**
     * Zoom coercion mode is decided by the component.
     */
    ZoomCoercionMode[ZoomCoercionMode["Auto"] = 0] = "Auto";
    /**
     * The zoom window is constrained to the axis bounds.
     */
    ZoomCoercionMode[ZoomCoercionMode["AxisConstrained"] = 1] = "AxisConstrained";
    /**
     * The zoom window is unconstrained by the axis bounds.
     */
    ZoomCoercionMode[ZoomCoercionMode["Unconstrained"] = 2] = "Unconstrained";
})(ZoomCoercionMode || (ZoomCoercionMode = {}));
/**
 * @hidden
 */
let ZoomCoercionMode_$type = markEnum('ZoomCoercionMode', 'Auto,0|AxisConstrained,1|Unconstrained,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SyncSettings extends FrameworkElement {
    constructor() {
        super(...arguments);
        this.propertyChanged = null;
        this.propertyUpdated = null;
    }
    ai(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
}
SyncSettings.$t = markType(SyncSettings, 'SyncSettings', FrameworkElement.$, [INotifyPropertyChanged_$type]);
SyncSettings.$$p = markDep(DependencyProperty, PropertyMetadata, SyncSettings, 'ai', ['SyncChannel', [2, null], 'SynchronizeHorizontally', [0, true], 'SynchronizeVertically', [0, true]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewerComponentsForView extends Base {
}
SeriesViewerComponentsForView.$t = markType(SeriesViewerComponentsForView, 'SeriesViewerComponentsForView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScalerParams extends Base {
    constructor(a, ..._rest) {
        super();
        this.e = null;
        this.d = null;
        this.c = null;
        this.a = false;
        this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    this.e = c;
                    this.d = d;
                    this.c = f;
                    this.a = e;
                    this.b = NaN;
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = [c, d, e, Rect.empty];
                    {
                        let h = f[0];
                        let i = f[1];
                        let j = f[2];
                        let k = f[3];
                        this.e = h;
                        this.d = i;
                        this.c = k;
                        this.a = j;
                        this.b = NaN;
                    }
                }
                break;
        }
    }
}
ScalerParams.$t = markType(ScalerParams, 'ScalerParams');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewerManipulationEventArgs extends EventArgs {
    constructor() {
        super(...arguments);
        this._isZoomPan = false;
        this._isDragZoom = false;
    }
    get isZoomPan() {
        return this._isZoomPan;
    }
    set isZoomPan(a) {
        this._isZoomPan = a;
    }
    get isDragZoom() {
        return this._isDragZoom;
    }
    set isDragZoom(a) {
        this._isDragZoom = a;
    }
}
SeriesViewerManipulationEventArgs.$t = markType(SeriesViewerManipulationEventArgs, 'SeriesViewerManipulationEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RefreshCompletedEventArgs extends EventArgs {
}
RefreshCompletedEventArgs.$t = markType(RefreshCompletedEventArgs, 'RefreshCompletedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions for axis title in respect to axis labels
 */
var AxisTitlePosition;
(function (AxisTitlePosition) {
    /**
     * Displays the axis title in automatically selected position based on orientation and location of the axis:
     * <para/> - left title position for vertical axis located on left of the chart,
     * <para/> - right title position for vertical axis located on right of the chart,
     * <para/> - top title position for horizontal axis located on top of the chart,
     * <para/> - bottom title position for horizontal axis located on bottom of the chart,
     */
    AxisTitlePosition[AxisTitlePosition["Auto"] = 0] = "Auto";
    /**
     * Displays the axis title to the left of labels on vertical axis
     */
    AxisTitlePosition[AxisTitlePosition["Left"] = 1] = "Left";
    /**
     * Displays the axis title to the right of labels on vertical axis
     */
    AxisTitlePosition[AxisTitlePosition["Right"] = 2] = "Right";
    /**
     * Displays the axis title on top of labels on horizontal axis
     */
    AxisTitlePosition[AxisTitlePosition["Top"] = 3] = "Top";
    /**
     * Displays the axis title on bottom of labels on horizontal axis
     */
    AxisTitlePosition[AxisTitlePosition["Bottom"] = 4] = "Bottom";
})(AxisTitlePosition || (AxisTitlePosition = {}));
/**
 * @hidden
 */
let AxisTitlePosition_$type = markEnum('AxisTitlePosition', 'Auto,0|Left,1|Right,2|Top,3|Bottom,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CoercionInfo extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.a = null;
    }
}
CoercionInfo.$t = markType(CoercionInfo, 'CoercionInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ChartContentType_$type = markEnum('ChartContentType', 'Series,0|Axis,1|Background,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileZoomTile_$type = new Type(null, 'ITileZoomTile');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RenderSurface extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
    }
}
RenderSurface.$t = markType(RenderSurface, 'RenderSurface');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LabelPanelsArrangeState extends Base {
    constructor() {
        super(...arguments);
        this.a = 0;
        this.h = 0;
        this.b = 0;
        this.e = 0;
        this.f = 0;
        this.g = 0;
        this.c = 0;
        this.d = 0;
    }
}
LabelPanelsArrangeState.$t = markType(LabelPanelsArrangeState, 'LabelPanelsArrangeState');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerTemplates extends Base {
    static n(a, b, c) {
        a.beginPath();
        let d = b.actualItemBrush;
        let e = b.outline;
        if (d != null) {
            if (d.isGradient) {
                let f = c.availableWidth / 2;
                let g = c.availableHeight / 2;
                let h = c.xPosition - f;
                let i = c.yPosition - f;
                h += c.renderOffsetX;
                i += c.renderOffsetY;
                let j = CanvasViewRenderer.j(a, d, h, i, h + c.availableWidth, i + c.availableHeight, b.thickness, false);
                a.fillStyle = j;
            }
            else {
                if (a.fillStyle != d._fill) {
                    a.fillStyle = d._fill;
                }
            }
        }
        if (b.outline != null) {
            if (b.outline.isGradient) {
                let k = c.availableWidth / 2;
                let l = c.availableHeight / 2;
                let m = c.xPosition - k;
                let n = c.yPosition - k;
                m += c.renderOffsetX;
                n += c.renderOffsetY;
                let o = CanvasViewRenderer.j(a, b.outline, m, n, m + c.availableWidth, n + c.availableHeight, b.thickness, true);
                a.strokeStyle = o;
            }
            else {
                if (a.strokeStyle != b.outline._fill) {
                    a.strokeStyle = b.outline._fill;
                }
            }
            a.lineWidth = b.thickness;
        }
    }
    static a(a, b) {
        if (b.actualItemBrush != null) {
            a.fill();
        }
        if (b.outline != null) {
            a.stroke();
        }
        a.closePath();
    }
    static b(a) {
        a.isConstant = true;
        a.width = 8;
        a.height = 8;
    }
    static d(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = Math.min(a.availableWidth, a.availableHeight) / 2;
        b.arc(a.xPosition, a.yPosition, d, 0, (Math.PI * 2), false);
        MarkerTemplates.a(b, c);
    }
    static m(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f, g);
        b.lineTo(f + e, g + a.availableHeight);
        b.lineTo(f + a.availableWidth, g + 0);
        b.lineTo(f, g);
        MarkerTemplates.a(b, c);
    }
    static j(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f, g + a.availableHeight);
        b.lineTo(f + e, g + 0);
        b.lineTo(f + a.availableWidth, g + a.availableHeight);
        b.lineTo(f, g + a.availableHeight);
        MarkerTemplates.a(b, c);
    }
    static k(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.rect(f, g, a.availableWidth, a.availableHeight);
        MarkerTemplates.a(b, c);
    }
    static c(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let left_ = (a.xPosition - e);
        let top_ = (a.yPosition - d);
        b.rect((left_ | 0), (top_ | 0), a.availableWidth, a.availableHeight);
        MarkerTemplates.a(b, c);
    }
    static e(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + 0, g + d);
        b.lineTo(f + e, g + a.availableHeight);
        b.lineTo(f + a.availableWidth, g + d);
        b.lineTo(f + e, g + 0);
        b.lineTo(f + 0, g + d);
        MarkerTemplates.a(b, c);
    }
    static h(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((0.1956000030040741 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((1.6499999761581421 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((6.3499999046325684 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    }
    static f(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((0.35600000619888306 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + (a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    }
    static l(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((2.5856 / 8) * a.availableHeight));
        b.lineTo(f + ((0 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((2.5855998992919922 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
        b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((5.4144001007080078 / 8) * a.availableHeight));
        b.lineTo(f + ((8 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((5.4144001007080078 / 8) * a.availableWidth), g + ((2.5855998992919922 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    }
    static i(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((2.8243999481201172 / 8) * a.availableWidth), g + ((2.382 / 8) * a.availableHeight));
        b.lineTo(f + ((0.1956 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((2.0980000495910645 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
        b.lineTo(f + ((1.6488000154495239 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((6.3512 / 8) * a.availableWidth), g + ((7.2360000610351562 / 8) * a.availableHeight));
        b.lineTo(f + ((5.9019999504089355 / 8) * a.availableWidth), g + ((4.6180000305175781 / 8) * a.availableHeight));
        b.lineTo(f + ((7.8043999671936035 / 8) * a.availableWidth), g + ((2.7639999389648438 / 8) * a.availableHeight));
        b.lineTo(f + ((5.1756000518798828 / 8) * a.availableWidth), g + ((2.3819999694824219 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    }
    static g(a) {
        let b = a.context;
        let c = a.data;
        MarkerTemplates.n(b, c, a);
        let d = (a.availableHeight / 2);
        let e = (a.availableWidth / 2);
        let f = (a.xPosition - e);
        let g = (a.yPosition - d);
        b.moveTo(f + ((4 / 8) * a.availableWidth), g + 0);
        b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((2.268 / 8) * a.availableHeight));
        b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((2 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((0.536 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((3 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + ((8 / 8) * a.availableHeight));
        b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((5.73199987411499 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((6 / 8) * a.availableHeight));
        b.lineTo(f + ((6 / 8) * a.availableWidth), g + ((4 / 8) * a.availableHeight));
        b.lineTo(f + ((7.4640002250671387 / 8) * a.availableWidth), g + ((2 / 8) * a.availableHeight));
        b.lineTo(f + ((5 / 8) * a.availableWidth), g + ((2.2679998874664307 / 8) * a.availableHeight));
        b.lineTo(f + ((4 / 8) * a.availableWidth), g + 0);
        MarkerTemplates.a(b, c);
    }
}
MarkerTemplates.$t = markType(MarkerTemplates, 'MarkerTemplates');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available locations of the axis labels in the chart.
 */
var AxisLabelsLocation;
(function (AxisLabelsLocation) {
    /**
     * Places the axis labels at the top, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideTop"] = 0] = "OutsideTop";
    /**
     * Places the axis labels at the bottom, outside of the plotting area
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideBottom"] = 1] = "OutsideBottom";
    /**
     * Places the axis labels to the left, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideLeft"] = 2] = "OutsideLeft";
    /**
     * Places the axis labels to the right, outside of the plotting area.
     */
    AxisLabelsLocation[AxisLabelsLocation["OutsideRight"] = 3] = "OutsideRight";
    /**
     * Places the axis labels inside the plotting area above the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideTop"] = 4] = "InsideTop";
    /**
     * Places the axis labels inside the plotting area below the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideBottom"] = 5] = "InsideBottom";
    /**
     * Places the axis labels inside the plotting area and to the left of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideLeft"] = 6] = "InsideLeft";
    /**
     * Places the axis labels inside the plotting area and to the right of the axis line.
     * CrossingAxis should be set for this setting to take effect.
     */
    AxisLabelsLocation[AxisLabelsLocation["InsideRight"] = 7] = "InsideRight";
})(AxisLabelsLocation || (AxisLabelsLocation = {}));
/**
 * @hidden
 */
let AxisLabelsLocation_$type = markEnum('AxisLabelsLocation', 'OutsideTop,0|OutsideBottom,1|OutsideLeft,2|OutsideRight,3|InsideTop,4|InsideBottom,5|InsideLeft,6|InsideRight,7');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IProvidesViewport_$type = new Type(null, 'IProvidesViewport');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PointerTooltipStyle extends Base {
    constructor() {
        super();
        this.b = 0;
        this.a = 0;
        this.d = null;
        this.c = null;
        this.b = NaN;
        this.a = NaN;
    }
}
PointerTooltipStyle.$t = markType(PointerTooltipStyle, 'PointerTooltipStyle');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultPaletteInfo extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.f = null;
        this.b = null;
        this.c = null;
        this.g = null;
        this.d = null;
        this.e = null;
        this.k = null;
        this.j = null;
        this.h = null;
        this.i = null;
    }
}
DefaultPaletteInfo.$t = markType(DefaultPaletteInfo, 'DefaultPaletteInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisRange extends Base {
    constructor(a, b) {
        super();
        this.c = 0;
        this.b = 0;
        this.c = a;
        this.b = b;
    }
    equals(a) {
        return a != null && this.c == a.c && this.b == a.b;
    }
    equals1(a) {
        return this.equals(typeCast(AxisRange.$, a));
    }
    getHashCode() {
        return super.getHashCode();
    }
}
AxisRange.$t = markType(AxisRange, 'AxisRange', Base.$, [IEquatable$1_$type.specialize(-1)]).initSelfReferences();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Snapper extends Base {
    constructor() {
        super(...arguments);
        this.c = 7;
        this.a = false;
    }
    get f() {
        return this.c;
    }
    set f(a) {
        this.c = a;
    }
    get b() {
        return this.a;
    }
    set b(a) {
        this.a = a;
    }
    static d(a, b) {
        let c = 1;
        if (b > 0) {
            for (; b > 0; --b) {
                c *= a;
            }
        }
        else {
            for (; b < 0; ++b) {
                c /= a;
            }
        }
        return c;
    }
    static e(a, b) {
        let c = truncate(Math.floor(log10(a)));
        let d = a / Math.pow(10, c);
        if (b) {
            let e = d < 1.5 ? 1 : d < 3 ? 2 : d < 7 ? 5 : 10;
            return e * Math.pow(10, c);
        }
        else {
            let f = d <= 1 ? 1 : d <= 2 ? 2 : d <= 5 ? 5 : 10;
            return f * Math.pow(10, c);
        }
    }
}
Snapper.$t = markType(Snapper, 'Snapper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LinearNumericSnapper extends Snapper {
    constructor(a, ..._rest) {
        super();
        this.g = 0;
        this.j = 0;
        this.i = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    if (f > 0) {
                        this.f = f;
                        this.b = true;
                    }
                    this.k(c, d, e, 10);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    if (g > 0) {
                        this.f = g;
                        this.b = true;
                    }
                    this.k(c, d, e, f);
                }
                break;
        }
    }
    k(a, b, c, d) {
        this.g = NaN;
        this.j = 0;
        this.i = 0;
        let e = 0;
        if (c < 100) {
            e = 4;
        }
        else {
            e = Math.min(d, truncate((c / this.f)));
        }
        if (e > 0) {
            let f = this.h(a, b, e);
            if (this.b && f > e) {
                this.g = NaN;
                f = this.h(a, b, e - 1);
            }
            e = f;
            if (c / e > this.f * 10) {
                this.i = 10;
            }
            else {
                if (c / e > this.f * 5) {
                    this.i = 5;
                }
                else {
                    if (c / e > this.f * 2) {
                        this.i = 2;
                    }
                }
            }
            this.j = Math.max(-truncate(Math.floor(log10(this.g))), 0);
        }
    }
    h(a, b, c) {
        let d = Snapper.e(b - a, false);
        this.g = Snapper.e(d / (c - 1), true);
        let e = Math.floor(a / this.g) * this.g;
        let f = Math.ceil(b / this.g) * this.g;
        let g = truncate(Math.round((f - e) / this.g));
        return g;
    }
}
LinearNumericSnapper.$t = markType(LinearNumericSnapper, 'LinearNumericSnapper', Snapper.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IAxisAnnotation_$type = new Type(null, 'IAxisAnnotation');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisAnnotationCollection extends ObservableCollection$1 {
    constructor() {
        super(IAxisAnnotation_$type, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
AxisAnnotationCollection.$t = markType(AxisAnnotationCollection, 'AxisAnnotationCollection', ObservableCollection$1.$.specialize(IAxisAnnotation_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LabelPosition extends Base {
    constructor(a) {
        super();
        this.c = 0;
        this.a = false;
        this.d = null;
        this.b = false;
        this.c = a;
    }
}
LabelPosition.$t = markType(LabelPosition, 'LabelPosition');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LabelFontHeuristics extends Base {
    constructor() {
        super();
        this.a = 0;
        this.d = 0;
        this.b = 0;
        this.c = 0;
        this.a = NaN;
        this.d = NaN;
        this.b = NaN;
        this.c = NaN;
    }
}
LabelFontHeuristics.$t = markType(LabelFontHeuristics, 'LabelFontHeuristics');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisComponentsFromView extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.d = null;
        this.c = null;
    }
}
AxisComponentsFromView.$t = markType(AxisComponentsFromView, 'AxisComponentsFromView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisRangeChangedEventArgs extends EventArgs {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    super();
                    this._oldMinimumValue = 0;
                    this._minimumValue = 0;
                    this._oldMaximumValue = 0;
                    this._maximumValue = 0;
                    this.oldMinimumValue = c;
                    this.minimumValue = d;
                    this.oldMaximumValue = e;
                    this.maximumValue = f;
                }
                break;
            case 1:
                {
                    super();
                    this._oldMinimumValue = 0;
                    this._minimumValue = 0;
                    this._oldMaximumValue = 0;
                    this._maximumValue = 0;
                }
                break;
        }
    }
    get oldMinimumValue() {
        return this._oldMinimumValue;
    }
    set oldMinimumValue(a) {
        this._oldMinimumValue = a;
    }
    get minimumValue() {
        return this._minimumValue;
    }
    set minimumValue(a) {
        this._minimumValue = a;
    }
    get oldMaximumValue() {
        return this._oldMaximumValue;
    }
    set oldMaximumValue(a) {
        this._oldMaximumValue = a;
    }
    get maximumValue() {
        return this._maximumValue;
    }
    set maximumValue(a) {
        this._maximumValue = a;
    }
}
AxisRangeChangedEventArgs.$t = markType(AxisRangeChangedEventArgs, 'AxisRangeChangedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PathRenderingInfo extends Base {
    constructor() {
        super(...arguments);
        this.b = 0;
        this.e = null;
        this.d = null;
        this.f = null;
        this.a = false;
    }
    get c() {
        return this.b;
    }
    set c(a) {
        if (a < 0) {
            this.b = a * -1;
        }
        else {
            this.b = a;
        }
    }
}
PathRenderingInfo.$t = markType(PathRenderingInfo, 'PathRenderingInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RenderRequestedEventArgs extends EventArgs {
    constructor() {
        super(...arguments);
        this._animate = false;
    }
    get animate() {
        return this._animate;
    }
    set animate(a) {
        this._animate = a;
    }
}
RenderRequestedEventArgs.$t = markType(RenderRequestedEventArgs, 'RenderRequestedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let CategoryMode_$type = markEnum('CategoryMode', 'Mode0,0|Mode1,1|Mode2,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes of displaying elements in the chart grid, such as gridlines.
 */
var GridMode;
(function (GridMode) {
    /**
     * No chart grid.
     */
    GridMode[GridMode["None"] = 0] = "None";
    /**
     * Chart grid should be rendered before or in front of the data series.
     */
    GridMode[GridMode["BeforeSeries"] = 1] = "BeforeSeries";
    /**
     * Chart grid should be rendered behind or in back of the data series.
     */
    GridMode[GridMode["BehindSeries"] = 2] = "BehindSeries";
})(GridMode || (GridMode = {}));
/**
 * @hidden
 */
let GridMode_$type = markEnum('GridMode', 'None,0|BeforeSeries,1|BehindSeries,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TickmarkValues extends DependencyObject {
    constructor() {
        super(...arguments);
        this.o = 0;
        this.m = 0;
        this.n = 0;
        this.l = 0;
        this.p = 0;
        this.q = 0;
        this.r = 0;
    }
    s(a) {
        this.o = a.m;
    }
}
TickmarkValues.$t = markType(TickmarkValues, 'TickmarkValues', DependencyObject.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IScaler_$type = new Type(null, 'IScaler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICategoryScaler_$type = new Type(null, 'ICategoryScaler', null, [IScaler_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeInfo extends Base {
    constructor() {
        super();
        this.d = 0;
        this.c = 0;
        this.a = 0;
        this.b = 0;
        this.e = 0;
        this.a = -1;
        this.e = -1;
    }
}
RangeInfo.$t = markType(RangeInfo, 'RangeInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisRenderingParametersBase extends Base {
    constructor() {
        super();
        this.o = 0;
        this.z = null;
        this.aa = null;
        this.y = null;
        this.x = null;
        this.k = null;
        this.e = null;
        this.f = null;
        this.w = null;
        this.u = null;
        this.v = null;
        this.t = null;
        this.m = 0;
        this.l = 0;
        this.n = 0;
        this.r = 0;
        this.s = null;
        this.p = 0;
        this.g = false;
        this.h = false;
        this.j = false;
        this.b = null;
        this.a = null;
        this.c = null;
        this.d = null;
        this.q = 0;
        this.k = new List$1(RangeInfo.$, 0);
    }
    i() {
        return false;
    }
}
AxisRenderingParametersBase.$t = markType(AxisRenderingParametersBase, 'AxisRenderingParametersBase');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumericAxisRenderingParameters extends AxisRenderingParametersBase {
    constructor() {
        super(...arguments);
        this.ab = false;
    }
    i() {
        return true;
    }
}
NumericAxisRenderingParameters.$t = markType(NumericAxisRenderingParameters, 'NumericAxisRenderingParameters', AxisRenderingParametersBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LogarithmicNumericSnapper extends Snapper {
    constructor(a, b, c, d) {
        super();
        this.g = 0;
        this.h = 0;
        this.g = 1;
        this.h = c;
    }
}
LogarithmicNumericSnapper.$t = markType(LogarithmicNumericSnapper, 'LogarithmicNumericSnapper', Snapper.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LogarithmicTickmarkValues extends TickmarkValues {
    constructor() {
        super(...arguments);
        this.t = null;
        this.u = null;
    }
    s(a) {
        super.s(a);
        let b = new LogarithmicNumericSnapper(a.n, a.m, this.x, a.k);
        this.m = 1;
        this.r = truncate(b.h);
        this.p = truncate(Math.floor(logBase(Math.max(4.94065645841247E-324, a.n), this.x)));
        this.q = truncate(Math.ceil(logBase(Math.max(4.94065645841247E-324, a.m), this.x)));
    }
    get x() {
        return typeGetValue(this.c(LogarithmicTickmarkValues.z));
    }
    set x(a) {
        this.h(LogarithmicTickmarkValues.z, a);
    }
    v(a) {
        let b = a * this.m;
        return Math.pow(this.x, b);
    }
    j() {
        let a = this.p;
        let b = this.q;
        let c = this.o;
        let d = 0;
        for (let e = a; e <= b; ++e) {
            let f = this.v(e);
            if (f <= c) {
                d++;
            }
        }
        if (this.t == null || this.t.length != d) {
            this.t = new Array(d);
        }
        let g = this.t;
        let h = 0;
        for (let i = a; i <= b; ++i) {
            let j = this.v(i);
            if (j <= c) {
                g[h] = j;
                h++;
            }
        }
        return g;
    }
    k() {
        let a = this.p;
        let b = this.q;
        let c = this.x;
        let d = this.r;
        let e = this.o;
        let f = 0;
        for (let g = a; g <= b; ++g) {
            let h = this.v(g);
            let i = Math.pow(c, g);
            for (let j = 1; j < this.r - 1; ++j) {
                let k = h + j * i;
                if (k <= e) {
                    f++;
                }
            }
        }
        if (this.u == null || this.u.length != f) {
            this.u = new Array(f);
        }
        let l = this.u;
        let m = 0;
        for (let n = a; n <= b; ++n) {
            let o = this.v(n);
            let p = Math.pow(c, n);
            for (let q = 1; q < this.r - 1; ++q) {
                let r = o + q * p;
                if (r <= e) {
                    l[m] = r;
                    m++;
                }
            }
        }
        return l;
    }
}
LogarithmicTickmarkValues.$t = markType(LogarithmicTickmarkValues, 'LogarithmicTickmarkValues', TickmarkValues.$);
LogarithmicTickmarkValues.z = DependencyProperty.i("LogarithmBase", Number_$type, LogarithmicTickmarkValues.$, new PropertyMetadata(2, 10, (a, b) => {
}));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LinearTickmarkValues extends TickmarkValues {
    constructor() {
        super();
        this.y = 0;
        this.x = 0;
        this.t = null;
        this.u = null;
        this.y = 0;
    }
    s(a) {
        super.s(a);
        let b;
        if (this.y != 0) {
            b = new LinearNumericSnapper(1, a.n, a.m, a.k, this.y, a.h);
        }
        else {
            b = new LinearNumericSnapper(0, a.n, a.m, a.k, a.h);
        }
        this.m = b.g;
        if ((a.d) && a.l > 0 && (a.m - a.n) / a.l < 1000) {
            this.m = a.l;
        }
        if (a.i != -1) {
            this.m = a.i;
        }
        if (this.m == 0) {
            this.p = 0;
            this.q = 0;
        }
        else {
            this.p = truncate(Math.floor((a.n - a.g) / this.m));
            this.q = truncate(Math.ceil((a.m - a.g) / this.m));
        }
        this.r = b.i;
        if (a.p != -1) {
            this.r = a.p;
        }
        this.n = a.j;
        this.x = a.g;
    }
    j() {
        let a = 0;
        let b = this.p;
        if (!isNaN_(this.m)) {
            a = this.q - b + 1;
            if (a < 0) {
                a = 0;
            }
        }
        if (this.t == null || this.t.length != a) {
            this.t = new Array(a);
        }
        let c = this.t;
        for (let d = 0; d < a; ++d) {
            let e = this.x + (d + b) * this.m;
            c[d] = e;
        }
        return c;
    }
    k() {
        if (this.n > 0) {
            return this.w();
        }
        return this.v();
    }
    v() {
        let a = this.p;
        let b = this.q;
        let c = this.r;
        let d = this.m;
        let e = this.x;
        let f = this.o;
        let g = d / c;
        let h = 0;
        for (let i = a; i < b; ++i) {
            for (let j = 1; j < c; ++j) {
                let k = e + i * d + (j * g);
                if (k <= f) {
                    h++;
                }
            }
        }
        if (this.u == null || this.u.length != h) {
            this.u = new Array(h);
        }
        let l = this.u;
        let m = 0;
        for (let n = a; n < b; ++n) {
            for (let o = 1; o < c; ++o) {
                let p = e + n * d + (o * g);
                if (p <= this.o) {
                    l[m] = p;
                    m++;
                }
            }
        }
        return l;
    }
    w() {
        let a = this.p;
        let b = this.q;
        let c = this.r;
        let d = this.m;
        let e = this.x;
        let f = this.o;
        let g = d / c;
        let h = 0;
        for (let i = a; i < b; ++i) {
            let j = e + i * this.m;
            let k = this.o;
            if (i + 1 <= this.q) {
                k = this.x + ((i + 1) * this.m);
            }
            if (k > this.o) {
                k = this.o;
            }
            while (j < k) {
                j += this.n;
                if (j < k) {
                    h++;
                }
            }
        }
        if (this.u == null || this.u.length != h) {
            this.u = new Array(h);
        }
        let l = this.u;
        let m = 0;
        for (let n = a; n < b; ++n) {
            let o = e + n * this.m;
            let p = this.o;
            if (n + 1 <= this.q) {
                p = this.x + ((n + 1) * this.m);
            }
            if (p > this.o) {
                p = this.o;
            }
            while (o < p) {
                o += this.n;
                if (o < p) {
                    l[m] = o;
                    m++;
                }
            }
        }
        return l;
    }
}
LinearTickmarkValues.$t = markType(LinearTickmarkValues, 'LinearTickmarkValues', TickmarkValues.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TickmarkValuesInitializationParameters extends Base {
    constructor() {
        super(...arguments);
        this.n = 0;
        this.m = 0;
        this.g = 0;
        this.f = 0;
        this.k = 0;
        this.d = false;
        this.l = 0;
        this.i = 0;
        this.p = 0;
        this.a = 0;
        this.q = 0;
        this.r = null;
        this.s = null;
        this.e = false;
        this.o = null;
        this.b = null;
        this.c = null;
        this.j = 0;
        this.h = 0;
    }
}
TickmarkValuesInitializationParameters.$t = markType(TickmarkValuesInitializationParameters, 'TickmarkValuesInitializationParameters');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryAxisRenderingParameters extends AxisRenderingParametersBase {
    constructor() {
        super(...arguments);
        this.ae = 0;
        this.ab = 0;
        this.ad = false;
        this.af = 0;
        this.ac = false;
    }
}
CategoryAxisRenderingParameters.$t = markType(CategoryAxisRenderingParameters, 'CategoryAxisRenderingParameters', AxisRenderingParametersBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumberAbbreviatorFactory extends Base {
    static a(a) {
        if (!TypeRegistrar.isRegistered("NumberAbbreviator")) {
            return null;
        }
        let b = TypeRegistrar.create("NumberAbbreviator");
        return b;
    }
}
NumberAbbreviatorFactory.$t = markType(NumberAbbreviatorFactory, 'NumberAbbreviatorFactory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available highlighting states
 */
var HighlightingState;
(function (HighlightingState) {
    /**
     * Highlight is transitioning out.
     */
    HighlightingState[HighlightingState["outward"] = 0] = "outward";
    /**
     * Highlight is transitioning in.
     */
    HighlightingState[HighlightingState["inward"] = 1] = "inward";
    /**
     * Highlight is active and not transitioning in or out.
     */
    HighlightingState[HighlightingState["Static"] = 2] = "Static";
})(HighlightingState || (HighlightingState = {}));
/**
 * @hidden
 */
let HighlightingState_$type = markEnum('HighlightingState', 'Out:outward,0|In:inward,1|Static,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Marker extends ContentControl {
    constructor() {
        super(...arguments);
        this.am = null;
        this.an = null;
        this.ak = 0;
        this.al = 0;
        this.ai = 0;
        this.aj = 0;
    }
}
Marker.$t = markType(Marker, 'Marker', ContentControl.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of speeds used when transitioning in a series.
 */
var TransitionInSpeedType;
(function (TransitionInSpeedType) {
    /**
     * A speed type is automatically selected.
     */
    TransitionInSpeedType[TransitionInSpeedType["Auto"] = 0] = "Auto";
    /**
     * All speeds are normal, data points will arrive at the same time.
     */
    TransitionInSpeedType[TransitionInSpeedType["Normal"] = 1] = "Normal";
    /**
     * Data points will arrive later if their value is further from the start point.
     */
    TransitionInSpeedType[TransitionInSpeedType["ValueScaled"] = 2] = "ValueScaled";
    /**
     * Data points will arrive later if their index is further from the axis origin.
     */
    TransitionInSpeedType[TransitionInSpeedType["IndexScaled"] = 3] = "IndexScaled";
    /**
     * Data points will arrive at random times.
     */
    TransitionInSpeedType[TransitionInSpeedType["Random"] = 4] = "Random";
})(TransitionInSpeedType || (TransitionInSpeedType = {}));
/**
 * @hidden
 */
let TransitionInSpeedType_$type = markEnum('TransitionInSpeedType', 'Auto,0|Normal,1|ValueScaled,2|IndexScaled,3|Random,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for performing hit testing in the chart/map.
 */
var SeriesHitTestMode;
(function (SeriesHitTestMode) {
    /**
     * Automatically decide the appropriate hit test mode for the series.
     */
    SeriesHitTestMode[SeriesHitTestMode["Auto"] = 0] = "Auto";
    /**
     * Use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded.
     */
    SeriesHitTestMode[SeriesHitTestMode["Computational"] = 1] = "Computational";
    /**
     * Use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
     */
    SeriesHitTestMode[SeriesHitTestMode["ColorEncoded"] = 2] = "ColorEncoded";
})(SeriesHitTestMode || (SeriesHitTestMode = {}));
/**
 * @hidden
 */
let SeriesHitTestMode_$type = markEnum('SeriesHitTestMode', 'Auto,0|Computational,1|ColorEncoded,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesComponentsForView extends Base {
}
SeriesComponentsForView.$t = markType(SeriesComponentsForView, 'SeriesComponentsForView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesComponentsFromView extends Base {
}
SeriesComponentsFromView.$t = markType(SeriesComponentsFromView, 'SeriesComponentsFromView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var MarkerType;
(function (MarkerType) {
    /**
     * Marker hasn't been set.
     */
    MarkerType[MarkerType["Unset"] = 0] = "Unset";
    /**
     * No markerItems.
     */
    MarkerType[MarkerType["None"] = 1] = "None";
    /**
     * Automatic marker shape.
     */
    MarkerType[MarkerType["Automatic"] = 2] = "Automatic";
    /**
     * Circle marker shape.
     */
    MarkerType[MarkerType["Circle"] = 3] = "Circle";
    /**
     * Flat-top triangle marker shape.
     */
    MarkerType[MarkerType["Triangle"] = 4] = "Triangle";
    /**
     * Flat-base triangle marker shape.
     */
    MarkerType[MarkerType["Pyramid"] = 5] = "Pyramid";
    /**
     * Square marker shape.
     */
    MarkerType[MarkerType["Square"] = 6] = "Square";
    /**
     * Diamond marker shape.
     */
    MarkerType[MarkerType["Diamond"] = 7] = "Diamond";
    /**
     * Pentagon marker shape.
     */
    MarkerType[MarkerType["Pentagon"] = 8] = "Pentagon";
    /**
     * Hexagon marker shape.
     */
    MarkerType[MarkerType["Hexagon"] = 9] = "Hexagon";
    /**
     * Four-pointed star marker shape.
     */
    MarkerType[MarkerType["Tetragram"] = 10] = "Tetragram";
    /**
     * Five-pointed star marker shape.
     */
    MarkerType[MarkerType["Pentagram"] = 11] = "Pentagram";
    /**
     * Six-pointed star marker shape.
     */
    MarkerType[MarkerType["Hexagram"] = 12] = "Hexagram";
    /**
     * Renders transparent circular markers.
     */
    MarkerType[MarkerType["Hidden"] = 13] = "Hidden";
})(MarkerType || (MarkerType = {}));
/**
 * @hidden
 */
let MarkerType_$type = markEnum('MarkerType', 'Unset,0|None,1|Automatic,2|Circle,3|Triangle,4|Pyramid,5|Square,6|Diamond,7|Pentagon,8|Hexagon,9|Tetragram,10|Pentagram,11|Hexagram,12|Hidden,13');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewer extends Control {
    constructor() {
        super();
        this._widget = null;
        this.b1 = null;
        this.cc = null;
        this.a0 = null;
        this.bt = null;
        this.bb = new SeriesCollection();
        this._skipDataCleanup = false;
        this.b2 = null;
        this.al = null;
        this.nt = null;
        this.plotAreaMouseLeftButtonDown = null;
        this.plotAreaMouseLeftButtonUp = null;
        this.plotAreaClicked = null;
        this.plotAreaMouseEnter = null;
        this.plotAreaMouseLeave = null;
        this.plotAreaMouseOver = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.cm = false;
        this.seriesCursorMouseMove = null;
        this.seriesMouseLeftButtonDown = null;
        this.seriesMouseLeftButtonUp = null;
        this.seriesMouseMove = null;
        this.seriesMouseEnter = null;
        this.seriesMouseLeave = null;
        this.ch = false;
        this.n1 = Rect.empty;
        this.nz = Rect.empty;
        this.cf = true;
        this.ny = null;
        this.cu = false;
        this.fo = 30;
        this.bd = new SeriesViewerComponentsForView();
        this.ck = false;
        this.an = 0;
        this.am = 1;
        this.seriesAnimating = null;
        this.ci = false;
        this.bo = 0;
        this.co = false;
        this.c0 = false;
        this.cg = false;
        this.hu = null;
        this.viewerManipulationStarting = null;
        this.viewerManipulationEnding = null;
        this.cs = false;
        this.cp = false;
        this.windowRectChanged = null;
        this.sizeChanged = null;
        this.c7 = false;
        this.actualWindowRectChanged = null;
        this.gridAreaRectChanged = null;
        this.c2 = false;
        this._syncChannel = null;
        this.bf = null;
        this.cr = false;
        this.c6 = false;
        this.d7 = false;
        this.bj = 1;
        this.oj = null;
        this.fq = 0;
        this.cq = false;
        this.d5 = false;
        this.n0 = Rect.empty;
        this.ec = new Date();
        this.d9 = false;
        this.refreshCompleted = null;
        this.f1 = null;
        this.f0 = null;
        this.nd = null;
        this.nc = null;
        this.ev = NaN;
        this.et = NaN;
        this.eu = NaN;
        this.es = NaN;
        this.er = NaN;
        this.ep = NaN;
        this.eq = NaN;
        this.eo = NaN;
        this.fy = null;
        this.ah = null;
        this.ai = null;
        this.ag = null;
        this.cn = false;
        this.ce = false;
        this._syncSettings = null;
        this.destroyed = false;
        this.fw = null;
        this.ea = new Dictionary$2(String_$type, Base.$, 0);
        this.ds = false;
        this.ew = NaN;
        this.el = NaN;
        this.en = NaN;
        this.ej = NaN;
        this.ei = 20;
        this.eh = NaN;
        this.cj = true;
        this.em = NaN;
        this.ek = NaN;
        this.fz = null;
        this.ee = 1;
        this.ed = NaN;
        this.nx = null;
        this.c5 = false;
        this.ef = 0;
        this.eg = 0;
        this.l2 = null;
        this.ar = null;
        this.da = false;
        this.db = false;
        this.c8 = false;
        this.cl = false;
        this.fp = 0;
        this.cy = false;
        this.dd = false;
        this.seriesDataUpdated = null;
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        this.nx = Rect.empty;
        this.nt = { $type: Point_$type, x: NaN, y: NaN };
        this.ec = dateNow();
        this.da = false;
        this.db = false;
        this.ah = new CanvasRenderScheduler();
        this.ai = new CanvasRenderScheduler();
        this.ag = new CanvasRenderScheduler();
        SeriesViewer.oe = new Rect(0, 0, 0, 1, 1);
        this.syncSettings = ((() => {
            let $ret = new SyncSettings();
            $ret.synchronizeHorizontally = true;
            $ret.synchronizeVertically = true;
            return $ret;
        })());
        this.b1 = this.b0();
        this.j6(this.b1);
        this.b1.cy();
        this.lg();
        this.iq();
        this.actualSyncLink = new SyncLink();
        this.ln(null, this.actualSyncLink);
        this.al = new ChartContentManager(this);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.ki(a, b.propertyName, b.oldValue, b.newValue));
        let a = this.series;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.k7));
        let b = this.series;
        b.collectionResetting = delegateCombine(b.collectionResetting, runOn(this, this.k8));
        this.b2 = new DoubleAnimator(0, 1, this.fu);
        let c = this.b2;
        c.propertyChanged = delegateCombine(c.propertyChanged, runOn(this, this.ip));
        this.b1.bv();
        this.is();
        this.ir();
    }
    get widget() {
        return this._widget;
    }
    set widget(a) {
        this._widget = a;
    }
    static staticInit() {
        SeriesViewer.oe = new Rect(0, 0, 0, 1, 1);
    }
    get cd() {
        if (this.cc == null) {
            this.cc = new SRProvider(this.b1.i.ae);
        }
        return this.cc;
    }
    get a1() {
        if (this.a0 == null) {
            this.a0 = DVContainer.instance.createInstance(ISeriesViewerInteractionManager_$type, () => this.cd.n);
        }
        return this.a0;
    }
    get df() {
        return DVContainer.instance.checkLoaded("InteractivityFactoryManager");
    }
    iq() {
        if (this.bt != null && this.bu == null) {
            let a = this.bu;
            a.thumbnailSizeChanged = delegateRemove(a.thumbnailSizeChanged, runOn(this, this.ke));
        }
        if (this.bu != null) {
            let b = this.bu;
            b.thumbnailSizeChanged = delegateCombine(b.thumbnailSizeChanged, runOn(this, this.ke));
        }
        if (this.fz != null) {
            this.bu.backgroundImageUri = this.fz;
        }
        if (this.bu != null) {
            this.bu.initializeScalingRatio(this.ey);
        }
        if (this.bt == null && this.bu != null) {
            this.i2();
        }
        this.bt = this.bu;
    }
    ke(a, b) {
        this.bu.surfaceIsDirty = true;
        for (let c of fromEnum(this.series)) {
            c.dl = true;
        }
    }
    ir() {
        this.b1.ci();
        if (this.bu != null) {
            this.bu.initializeScalingRatio(this.ey);
        }
    }
    get series() {
        return this.bb;
    }
    k7(a, b) {
        this.cy = this.c4();
        if (b.oldItems != null) {
            for (let c of fromEn(b.oldItems)) {
                c.bn = null;
                c.bs = null;
                this.k1(c);
                this.b1.ds(c);
            }
        }
        if (b.newItems != null) {
            for (let d of fromEn(b.newItems)) {
                if (!this.b1.ao(d)) {
                    this.lh(d);
                    this.b1.bn(d);
                    d.bs = this;
                    d.bn = this.actualSyncLink;
                    d.jz();
                }
            }
        }
        this.i1();
        this.jk();
    }
    get skipDataCleanup() {
        return this._skipDataCleanup;
    }
    set skipDataCleanup(a) {
        this._skipDataCleanup = a;
    }
    k1(a) {
        if (!this.skipDataCleanup) {
            if (typeCast(Series.$, a) !== null) {
                a.itemsSource = null;
            }
            else if (typeCast(CategoryAxisBase.$, a) !== null) {
                a.itemsSource = null;
            }
        }
        this.k3(a.name, true);
    }
    k8(a, b) {
        this.cy = this.c4();
        for (let c of fromEnum(this.series)) {
            c.bn = null;
            c.bs = null;
            this.k1(c);
            this.b1.ds(c);
        }
    }
    iu(a, b, c, d) {
        let e = this.oh;
        let f = e.width;
        let g = e.height;
        let h = f / g;
        let i = a / b;
        if (isNaN_(h)) {
            return {
                p0: a,
                p1: b
            };
        }
        if (isNaN_(i) || c || d || Math.abs(h - i) > 0.0001) {
            if (c && d) {
                if (a > b) {
                    b = a / h;
                }
                else {
                    a = b * h;
                }
            }
            else if (c) {
                b = a / h;
            }
            else {
                a = b * h;
            }
        }
        if (b > 1) {
            let j = 1 / b;
            b = 1;
            a = a * j;
        }
        if (a > 1) {
            let k = 1 / a;
            a = 1;
            b = b * k;
        }
        return {
            p0: a,
            p1: b
        };
    }
    c4() {
        return false;
    }
    get d2() {
        return this.dm;
    }
    get dc() {
        return this.a0 != null;
    }
    get az() {
        return this.a1.f$b;
    }
    ip(a, b) {
        this.lj(this.b2.o);
    }
    lj(a) {
        let b = this.az.tick(a);
        if (a == 1 && b && this.b2.r > 0) {
            this.b2.v();
        }
        let c = this.az.dirtySeries;
        for (let d = 0; d < c.count; d++) {
            let e = c._inner[d];
            e.i5();
        }
        if (!b) {
            this.b2.w();
        }
    }
    io() {
        this.b1.ce();
        this.im();
        for (let a = 0; a < this.series.count; a++) {
            if (this.series._inner[a].cj) {
            }
        }
    }
    ng(a) {
        return null;
    }
    nm(a) {
        return null;
    }
    nk(a) {
        return null;
    }
    nl(a) {
        return null;
    }
    get nu() {
        return this.nt;
    }
    set nu(a) {
        if (PointUtil.notEquals(this.nt, a)) {
            let b = this.nt;
            this.nt = a;
            this.km("CrosshairPoint", b, this.nt);
        }
    }
    get de() {
        return this.bs == 1 || this.bs == 2;
    }
    get legend() {
        return this.c(SeriesViewer.mg);
    }
    set legend(a) {
        this.h(SeriesViewer.mg, a);
    }
    get cw() {
        return this.c(SeriesViewer.l4);
    }
    set cw(a) {
        this.h(SeriesViewer.l4, a);
    }
    jv(a, b) {
        this.cm = false;
        let c = false;
        c = false;
        if (this.plotAreaMouseLeftButtonDown != null) {
            let d = this.a2(a, b, c);
            this.plotAreaMouseLeftButtonDown(this, d);
        }
    }
    a2(a, b, c) {
        let d = { $type: Point_$type, x: a.x, y: a.y };
        let e = { $type: Point_$type, x: a.x, y: a.y };
        if (!this.oh.isEmpty) {
            if (c) {
                e.x -= this.oh.left;
                e.y -= this.oh.top;
            }
            else {
                d.x += this.oh.left;
                d.y += this.oh.top;
            }
        }
        let f = new PlotAreaMouseButtonEventArgs(this, d, e);
        f.manipulationOccurred = this.cm;
        return f;
    }
    a6(a, b, c) {
        let d = { $type: Point_$type, x: a.x, y: a.y };
        let e = { $type: Point_$type, x: a.x, y: a.y };
        if (!this.oh.isEmpty) {
            if (c) {
                e.x -= this.oh.left;
                e.y -= this.oh.top;
            }
            else {
                d.x += this.oh.left;
                d.y += this.oh.top;
            }
        }
        let f = new PlotAreaMouseEventArgs(this, d, e);
        return f;
    }
    jw(a, b, c) {
        let d = false;
        d = false;
        if (this.plotAreaMouseLeftButtonUp != null) {
            let e = this.a2(a, b, d);
            this.plotAreaMouseLeftButtonUp(this, e);
        }
        if (!this.cm && !c) {
            if (this.plotAreaClicked != null) {
                let f = this.a2(a, b, d);
                this.plotAreaClicked(this, f);
            }
        }
        this.cm = false;
    }
    get dm() {
        return this.c(SeriesViewer.mf);
    }
    set dm(a) {
        this.h(SeriesViewer.mf, a);
    }
    km(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    jm() {
        this.jn(this.series);
    }
    jn(a) {
        for (let b of fromEn(a)) {
            let c = b.aw;
            if (c == null) {
                continue;
            }
            let d = b.j4;
            if (d == null) {
                continue;
            }
            if (c.containsChild(d)) {
                c.removeChild(d);
            }
            if (!c.containsChild(d) && b.l9 != 1) {
                c.addChildInOrder(d, b);
            }
        }
    }
    jy(a, b, c) {
        this.kr(a, b, typeCast(MouseEventArgs.$, c));
    }
    j2(a, b, c) {
        this.kv(a, b, typeCast(MouseEventArgs.$, c));
    }
    jz(a, b, c) {
        this.ks(a, b, typeCast(MouseEventArgs.$, c));
    }
    j0(a, b, c) {
        this.kt(a, b, typeCast(MouseButtonEventArgs.$, c));
    }
    j1(a, b, c) {
        let d = typeCast(MouseButtonEventArgs.$, c);
        if (d != null) {
            this.ku(a, b, typeCast(MouseButtonEventArgs.$, c));
        }
    }
    h4(a, b) {
        return null;
    }
    get dt() {
        return this.cm;
    }
    i6() {
        if (!this.ch) {
            this.ch = true;
            this.cm = true;
            if (this.viewerManipulationStarting != null) {
                let a = new SeriesViewerManipulationEventArgs();
                a.isDragZoom = true;
                this.viewerManipulationStarting(this, a);
            }
        }
    }
    j3(a, b, c) {
    }
    j4(a, b, c) {
    }
    kp(a, b) {
        if (this.seriesCursorMouseMove != null && this.c0) {
            this.seriesCursorMouseMove(this, new ChartCursorEventArgs(this, a, b));
        }
    }
    kt(a, b, c) {
        if (this.seriesMouseLeftButtonDown != null) {
            this.seriesMouseLeftButtonDown(this, new DataChartMouseButtonEventArgs(this, a, b, c));
        }
    }
    ku(a, b, c) {
        if (this.seriesMouseLeftButtonUp != null) {
            this.seriesMouseLeftButtonUp(this, new DataChartMouseButtonEventArgs(this, a, b, c));
        }
    }
    kv(a, b, c) {
        if (this.seriesMouseMove != null) {
            this.seriesMouseMove(this, new ChartMouseEventArgs(this, a, b, c));
        }
    }
    kr(a, b, c) {
        if (this.seriesMouseEnter != null) {
            this.seriesMouseEnter(this, new ChartMouseEventArgs(this, a, b, c));
        }
    }
    ks(a, b, c) {
        if (this.seriesMouseLeave != null) {
            this.seriesMouseLeave(this, new ChartMouseEventArgs(this, a, b, c));
        }
    }
    i5() {
        if (this.ch) {
            this.ch = false;
            if (this.viewerManipulationEnding != null) {
                let a = new SeriesViewerManipulationEventArgs();
                a.isDragZoom = true;
                this.viewerManipulationEnding(this, a);
            }
        }
    }
    get_oh() {
        return this.n1;
    }
    get oh() {
        return this.get_oh();
    }
    get n6() {
        return this.nz;
    }
    set n6(a) {
        this.nz = a;
    }
    ob(a, b, c) {
        let d = c;
        let e = b;
        let f = (d.left - e.left) / e.width;
        let g = (d.top - e.top) / e.height;
        let h = (d.right - e.left) / e.width;
        let i = (d.bottom - e.top) / e.height;
        f = a.left + f * a.width;
        g = a.top + g * a.height;
        h = a.left + h * a.width;
        i = a.top + i * a.height;
        return new Rect(0, f, g, h - f, i - g);
    }
    get_n5() {
        if (this.cf) {
            this.cf = false;
            let a = this.n9(this.oh, this.n6, this.n2);
            this.ny = a;
        }
        return this.ny;
    }
    get n5() {
        return this.get_n5();
    }
    n9(a, b, c) {
        let d = b;
        let e = c;
        let f = a;
        if (f.isEmpty) {
            return Rect.empty;
        }
        if (d.isEmpty) {
            return a;
        }
        let g = (d.left - f.left) / f.width;
        let h = (d.right - f.left) / f.width;
        let i = (d.top - f.top) / f.height;
        let j = (d.bottom - f.top) / f.height;
        g = f.left + (g - e.left) / e.width * f.width;
        h = f.left + (h - e.left) / e.width * f.width;
        i = f.top + (i - e.top) / e.height * f.height;
        j = f.top + (j - e.top) / e.height * f.height;
        let k = new Rect(0, g, i, h - g, j - i);
        k.intersect(f);
        return k;
    }
    n4(a) {
        this.cf = true;
        return Rect.empty;
    }
    oa() {
        return this.oh;
    }
    lf(a) {
        a.i9 = this.oh;
    }
    get fr() {
        return this.fo;
    }
    set fr(a) {
        this.fo = a;
    }
    kh(a, b) {
        if (!b.isEmpty) {
            this.n1 = b;
            this.nz = this.n4(this.n1);
            this.b1.ek(this.n1);
        }
        if (this.c4()) {
            if (this.actualSyncLink != null) {
                this.lq(this.n2, false);
            }
        }
        this.jx(a, b);
    }
    be() {
        return this.bd;
    }
    ia(a, b) {
        let c = false;
        c = true;
        if (this.oh.containsPoint(a)) {
            if (!this.ck) {
                this.ck = true;
                if (this.plotAreaMouseEnter != null) {
                    let d = this.a6(a, false, c);
                    d.isDuringManipulation = b;
                    this.plotAreaMouseEnter(this, d);
                }
            }
            else {
                this.ck = true;
                if (this.plotAreaMouseOver != null) {
                    let e = this.a6(a, false, c);
                    e.isDuringManipulation = b;
                    this.plotAreaMouseOver(this, e);
                }
            }
        }
        else {
            if (this.ck) {
                this.ck = false;
                if (this.plotAreaMouseLeave != null) {
                    let f = this.a6(a, false, c);
                    f.isDuringManipulation = b;
                    this.plotAreaMouseLeave(this, f);
                }
            }
        }
    }
    get ap() {
        return this.an;
    }
    set ap(a) {
        let b = this.an;
        this.an = a;
        if (b != this.an) {
            this.km("ContentHitTestMode", enumGetBox(ChartHitTestMode_$type, b), enumGetBox(ChartHitTestMode_$type, this.an));
        }
    }
    kx() {
        this.ao = this.aq();
    }
    aq() {
        if (!this.df) {
            return 1;
        }
        return this.a1.f$a(this);
    }
    get ao() {
        return this.am;
    }
    set ao(a) {
        let b = this.am;
        this.am = a;
        if (b != this.am) {
            this.km("ActualContentHitTestMode", enumGetBox(ChartHitTestMode_$type, b), enumGetBox(ChartHitTestMode_$type, this.am));
        }
    }
    ko(a) {
        if (this.seriesAnimating != null) {
            this.seriesAnimating(a);
        }
    }
    dn() {
        return this.dp() || this.dq();
    }
    onDetachedFromUI() {
        this.b1.cw();
        SyncManager.e(this);
    }
    onAttachedToUI() {
        this.b1.cq();
        SyncManager.c(this);
    }
    get bs() {
        return this.bo;
    }
    set bs(a) {
        if (this.bs != a) {
            let b = this.bo;
            this.bo = a;
            if (this.df) {
                this.a1.f$ae(this);
            }
            if (b == 1 && this.bo != 1) {
                this.i5();
            }
        }
    }
    jp(a) {
        this.id(this.nw(a));
    }
    jq(a, b) {
        let c = false;
        c = false;
        this.id({ $type: Point_$type, x: NaN, y: NaN });
        if (this.ck) {
            this.ck = false;
            if (this.plotAreaMouseLeave != null) {
                let d = this.a6(a, false, c);
                d.isDuringManipulation = b;
                this.plotAreaMouseLeave(this, d);
            }
        }
    }
    dw(a, b) {
        return this.a1.f$e(this, a, b);
    }
    jf(a) {
        this.a1.f$n(this, a);
    }
    dv(a) {
        return this.a1.f$d(this, a);
    }
    get cx() {
        return this.cg;
    }
    set cx(a) {
        this.cg = a;
    }
    get_dg() {
        return this.cy || this.d6();
    }
    get dg() {
        return this.get_dg();
    }
    jh(a) {
        this.a1.f$p(this, a);
    }
    get c3() {
        return this.cg;
    }
    ju(a) {
        this.a1.f$ac(this, a);
    }
    ji(a, b) {
        this.a1.f$q(this, a, b);
    }
    jg(a) {
        this.a1.f$o(this, a);
    }
    get dx() {
        return this.co;
    }
    set dx(a) {
        this.co = a;
    }
    kc() {
        this.a1.f$aj(this);
    }
    jt(a) {
        this.a1.f$ab(this, a);
    }
    kd(a, b, c, d) {
        this.a1.f$ak(this, a, b, c, d);
    }
    js(a) {
        this.a1.f$aa(this, a);
    }
    j9(a, b, c, d) {
        this.a1.f$ag(this, a, b, c, d);
    }
    jo(a) {
        this.a1.f$x(this, a);
    }
    jr(a) {
        this.a1.f$z(this, a);
    }
    jj(a) {
        this.a1.f$r(this, a);
    }
    j8(a, b, c, d) {
        this.a1.f$af(this, a, b, c, d);
    }
    jl(a) {
        this.b1.ed(a.height);
    }
    im() {
        if (this.cg) {
            this.id({ $type: Point_$type, x: NaN, y: NaN });
            this.b1.cb();
        }
        this.cg = false;
    }
    i9(a, b) {
        this.a1.f$m(this, a, b);
    }
    bq(a) {
        let b = this.b1.j != null && this.b1.j.ai ? this.br : this.bp;
        if (b != 3) {
            return b;
        }
        return this.b1.k(a);
    }
    kb() {
        this.cr = false;
        if (!this.cs) {
            this.cs = true;
            this.cm = true;
            if (this.viewerManipulationStarting != null) {
                let a = new SeriesViewerManipulationEventArgs();
                a.isZoomPan = true;
                this.viewerManipulationStarting(this, a);
            }
        }
        this.a1.f$ai(this);
    }
    ka() {
        if (this.cs) {
            this.cs = false;
            if (this.viewerManipulationEnding != null) {
                let a = new SeriesViewerManipulationEventArgs();
                a.isZoomPan = true;
                this.viewerManipulationEnding(this, a);
            }
        }
        this.a1.f$ah(this);
    }
    lc() {
        this.a1.f$am(this);
    }
    ii() {
        if (this.cr) {
            this.jc();
        }
        this.a1.f$j(this);
    }
    ic() {
        this.ib();
    }
    ib() {
        if (this.df) {
            this.a1.f$g(this);
        }
    }
    kf() {
    }
    k0() {
    }
    ky() {
        for (let a = 0; a < this.series.count; a++) {
            this.series._inner[a].jl(false);
        }
        this.il(false, false);
    }
    i8(a, b) {
        this.a1.f$l(this, a, b);
    }
    d1() {
        return false;
    }
    get d4() {
        return this.cp;
    }
    set d4(a) {
        this.cp = a;
    }
    i7(a, b, c) {
        this.a1.f$k(this, a, b, c);
    }
    lo(a, b) {
        if (b.propertyName == SyncSettings.$$p[0]) {
            SyncManager.b(this, b.oldValue, b.newValue);
        }
    }
    ln(a, b) {
        if (a != null) {
            a.ab.remove(this);
            a.propertyUpdated = delegateRemove(a.propertyUpdated, this.propertyUpdated);
        }
        if (b != null) {
            b.ab.add(this);
            b.propertyUpdated = delegateCombine(b.propertyUpdated, this.propertyUpdated);
        }
        for (let c of fromEnum(this.series)) {
            c.bn = this.actualSyncLink;
            c.bs = this;
        }
    }
    id(a) {
        this.actualSyncLink.ak(this, a);
    }
    lq(a, b) {
        this.lr(a, b, !b);
    }
    lr(a, b, c) {
        if (!b) {
            this.actualSyncLink.ap(this, a, c);
        }
        else {
            if (!this.dp() && !this.dq()) {
                return;
            }
            let d = !a.isEmpty && !isNaN_(a.x) && !isNaN_(a.y) && !isNaN_(a.width) && !isNaN_(a.height);
            let e = a;
            if (d && !this.dp()) {
                e = new Rect(0, 0, a.y, 1, a.height);
            }
            if (d && !this.dq()) {
                e = new Rect(0, a.x, 0, a.width, 1);
            }
            this.actualSyncLink.ao(this, e);
        }
    }
    kg(a, b) {
        if (!b) {
            this.actualSyncLink.al(this, a);
        }
        else {
            if (!this.dp() && !this.dq()) {
                return;
            }
            let c = !a.isEmpty && !isNaN_(a.x) && !isNaN_(a.y) && !isNaN_(a.width) && !isNaN_(a.height);
            let d = a;
            if (c && !this.dp()) {
                d = new Rect(0, 0, a.y, 1, a.height);
            }
            if (c && !this.dq()) {
                d = new Rect(0, a.x, 0, a.width, 1);
            }
            this.actualSyncLink.al(this, d);
        }
    }
    get dk() {
        return this.actualSyncLink != null;
    }
    *_eb() {
        if (this.actualSyncLink == null) {
            return undefined;
        }
        for (let a of fromEnum(this.actualSyncLink.ag)) {
            yield a;
        }
    }
    eb() {
        return toEnum(() => this._eb());
    }
    nw(a) {
        let b = this.oh;
        let c = this.n2.left + this.n2.width * a.x / b.width;
        let d = this.n2.top + this.n2.height * a.y / b.height;
        return { $type: Point_$type, x: c, y: d };
    }
    og(a) {
        let b = this.oh;
        let c = this.n2.left + this.n2.width * a.left / b.width;
        let d = this.n2.top + this.n2.height * a.top / b.height;
        let e = this.n2.left + this.n2.width * a.right / b.width;
        let f = this.n2.top + this.n2.height * a.bottom / b.height;
        return new Rect(0, c, d, e - c, f - d);
    }
    kw(a, b) {
        if (this.windowRectChanged != null && Rect.l_op_Inequality(a, b)) {
            this.windowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    }
    j7(a, b) {
        this.kw(a, b);
    }
    j5(a, b) {
        if (this.sizeChanged != null && Size.l_op_Inequality(a, b)) {
            this.sizeChanged(this, new RectChangedEventArgs(new Rect(1, 0, 0, a), new Rect(1, 0, 0, b)));
        }
    }
    dz(a, b) {
        if (a.width != b.width || a.height != b.height || a.x != b.x || a.y != b.y) {
            return true;
        }
        return false;
    }
    kk(a, b) {
        if (this.actualWindowRectChanged != null && this.dz(a, b)) {
            this.actualWindowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    }
    k6() {
        this.b1.dw();
    }
    kl(a, b) {
        if (this.gridAreaRectChanged != null && Rect.l_op_Inequality(a, b)) {
            this.gridAreaRectChanged(this, new RectChangedEventArgs(a, b));
        }
    }
    get_dh() {
        return false;
    }
    get dh() {
        return this.get_dh();
    }
    jx(a, b) {
        this.kl(a, b);
        if (this.df) {
            this.a1.f$al(this);
        }
        if (this.dh && (Rect.l_op_Equality(a, null) || a.isEmpty || a.width == 0 || a.height == 0)) {
            this.lq(this.oi, false);
        }
        else {
            this.is();
        }
    }
    get syncChannel() {
        return this._syncChannel;
    }
    set syncChannel(a) {
        this._syncChannel = a;
    }
    get actualSyncLink() {
        return this.bf;
    }
    set actualSyncLink(a) {
        let b = this.bf;
        this.bf = a;
        this.km("ActualSyncLink", b, this.bf);
    }
    it() {
        this.b1.dx();
    }
    jd() {
        this.cr = true;
    }
    jb() {
        this.cr = false;
    }
    jc() {
        if (this.cr) {
            if (this.cs) {
                this.cs = false;
                if (this.viewerManipulationEnding != null) {
                    let a = new SeriesViewerManipulationEventArgs();
                    a.isZoomPan = true;
                    this.viewerManipulationEnding(this, a);
                }
            }
        }
    }
    get bu() {
        return this.b1.h().a;
    }
    lk(a) {
        if (this.bu != null) {
            this.bu.mobileMode = a;
        }
    }
    get bk() {
        return this.bj;
    }
    set bk(a) {
        this.bj = a;
    }
    bl() {
        if (this.bm == 0) {
            return 1;
        }
        return this.bm;
    }
    cz() {
        return this.bs == 0 && !this.co && !this.cp;
    }
    cv() {
        if (this.actualSyncLink != null && this.actualSyncLink.ag.count > 0) {
            let a = true;
            a = this.cz();
            if (!a) {
                return false;
            }
            for (let b = 0; b < this.actualSyncLink.ag.count; b++) {
                if (!this.actualSyncLink.ag.item(b).cz()) {
                    return false;
                }
            }
            return true;
        }
        else {
            return this.cz();
        }
    }
    h9() {
        if (this.bs == 2) {
            this.b1.br();
            this.bs = 0;
            this.ka();
            this.kg(Rect.empty, true);
            if (this.bi == 1) {
                this.lq(this.oj, true);
            }
        }
        if (this.bs == 1) {
            this.b1.br();
            this.bs = 0;
            this.ka();
            this.b1.b9();
            this.kg(Rect.empty, true);
        }
    }
    notifyCrosshairUpdate() {
    }
    lp(a, b) {
        let c = this.fm;
        this.oi = new Rect(0, this.ez, this.e0, MathUtil.b(a, c, 1), MathUtil.b(b, c, 1));
    }
    e4() {
        return 1;
    }
    e5() {
        return 1;
    }
    ki(a, b, c, d) {
        switch (b) {
            case SeriesViewer.$$p[28]:
                this.b1.dd();
                break;
            case SeriesViewer.$$p[25]:
                this.b1.dd();
                break;
            case SeriesViewer.$$p[36]:
                this.bk = this.bl();
                break;
            case "ActualContentHitTestMode":
                this.i3();
                break;
            case "ContentHitTestMode":
                this.kx();
                break;
            case SeriesViewer.$$p[27]:
                this.b1.db(c, d);
                this.b1.dd();
                break;
            case SeriesViewer.$$p[24]:
                this.b1.c7(c, d);
                this.b1.dd();
                break;
            case "TitleTextStyle":
            case "TitleTextColor":
            case "SubtitleTextStyle":
            case "SubtitleTextColor":
            case "TitleTopMargin":
            case "TitleLeftMargin":
            case "TitleRightMargin":
            case "TitleBottomMargin":
            case "SubtitleTopMargin":
            case "SubtitleLeftMargin":
            case "SubtitleRightMargin":
            case "SubtitleBottomMargin":
                this.b1.dd();
                break;
            case SeriesViewer.$$p[18]:
            case SeriesViewer.$$p[19]:
            case SeriesViewer.$$p[20]:
                this.b1.c5();
                break;
            case "PixelScalingRatio":
                if (isNaN_(DeviceUtils.a(this.e8))) {
                    this.ir();
                }
                else {
                    this.ey = DeviceUtils.a(this.e8);
                }
                break;
            case "InteractionPixelScalingRatio":
                this.ex = this.e6;
                break;
            case "ActualPixelScalingRatio":
                this.b1.dj();
                break;
            case SeriesViewer.$$p[9]:
                this.b1.cj();
                break;
            case "ActualSyncLink":
                this.ln(typeCast(SyncLink.$, c), typeCast(SyncLink.$, d));
                break;
            case SeriesViewer.$$p[2]:
                if (!this.c6) {
                    this.d7 = true;
                }
                if (this.om == 0) {
                    this.c0 = true;
                }
                else {
                    this.c0 = this.ct;
                }
                if (this.df) {
                    this.a1.f$al(this);
                }
                break;
            case "CrosshairPoint":
                if (this.df) {
                    this.a1.f$al(this);
                }
                this.notifyCrosshairUpdate();
                break;
            case SeriesViewer.$$p[34]:
                if (this.actualSyncLink != null) {
                    this.fq++;
                    this.lq(d, false);
                    this.fq--;
                }
                if (!this.oi.equals1(c) && this.fq == 0) {
                    this.j7(c, this.oi);
                }
                this.is();
                break;
            case SeriesViewer.$$p[31]:
                this.ez = this.fk;
                break;
            case SeriesViewer.$$p[32]:
                this.e0 = this.fl;
                break;
            case "ActualWindowPositionVertical":
            case "ActualWindowPositionHorizontal":
                if (!this.d5) {
                    this.lp(this.e4(), this.e5());
                }
                break;
            case SeriesViewer.$$p[10]:
                this.b1.cz();
                break;
            case SeriesViewer.$$p[8]:
                this.b2.r = this.fu;
                break;
            case SeriesViewer.$$p[11]:
                this.lm();
                break;
            case "ActualWindowRect":
                this.cf = true;
                if (!Base.equalsStatic(d, c)) {
                    this.h5();
                }
                if (d.width == 1 && d.height == 1 && c.isEmpty) {
                    this.d9 = true;
                }
                this.kk(c, d);
                break;
            case SeriesViewer.$$p[15]:
                this.b1.c4(d);
                break;
            case SeriesViewer.$$p[30]:
                this.cu = this.d8;
                break;
            case SeriesViewer.$$p[37]:
                this.fr = this.fv;
                this.ib();
                break;
            case SeriesViewer.$$p[17]:
                this.a1.f$ad(this);
                break;
        }
    }
    lm() {
        this.cq = this.on == 0;
        this.b1.di();
        this.ll();
        this.b1.eg();
        this.it();
    }
    i3() {
        this.b1.cp();
    }
    ll() {
        if (this.bu == null) {
            return;
        }
        this.bu.isZoomable = this.dn();
    }
    get oc() {
        return this.n0;
    }
    set oc(a) {
        let b = this.n0;
        this.n0 = a;
        if (this.n0.isEmpty) {
            this.b1.cd();
        }
        else {
            this.b1.eh(this.oh, this.of(this.oc));
            this.b1.d6();
            this.km("PreviewRect", b, this.n0);
        }
    }
    le() {
        this.ez = this.n2.x;
        this.e0 = this.n2.y;
    }
    h5() {
        this.d9 = false;
        this.ec = dateNow();
        if (this.dc) {
            this.az.clear();
        }
        if (this.b2.f()) {
            this.b2.w();
        }
        let a = this.d5;
        this.d5 = true;
        this.le();
        this.d5 = a;
        this.b1.ce();
        this.b1.ej(this.n2);
    }
    of(a) {
        if (this.oh.isEmpty) {
            return Rect.empty;
        }
        let b = this.oh;
        let c = b.left + (b.width * (a.left - this.n2.left) / this.n2.width);
        let d = b.top + (b.height * (a.top - this.n2.top) / this.n2.height);
        let e = b.left + (b.width * (a.right - this.n2.left) / this.n2.width);
        let f = b.top + (b.height * (a.bottom - this.n2.top) / this.n2.height);
        return new Rect(0, c, d, e - c, f - d);
    }
    kn() {
        if (this.refreshCompleted != null && !this.destroyed) {
            this.refreshCompleted(this, new RefreshCompletedEventArgs());
        }
    }
    j6(a) {
        this.ll();
    }
    get hr() {
        return this.f1;
    }
    set hr(a) {
        let b = this.f1;
        this.f1 = a;
        this.km("TitleTextStyle", b, a);
    }
    get hf() {
        return this.f0;
    }
    set hf(a) {
        let b = this.f0;
        this.f0 = a;
        this.km("SubtitleTextStyle", b, a);
    }
    get ns() {
        return this.nd;
    }
    set ns(a) {
        let b = this.nd;
        this.nd = a;
        this.km("TitleTextColor", b, a);
    }
    get nr() {
        return this.nc;
    }
    set nr(a) {
        let b = this.nc;
        this.nc = a;
        this.km("SubtitleTextColor", b, a);
    }
    get fi() {
        return this.ev;
    }
    set fi(a) {
        let b = this.ev;
        this.ev = a;
        this.km("TitleTopMargin", b, a);
    }
    get fg() {
        return this.et;
    }
    set fg(a) {
        let b = this.et;
        this.et = a;
        this.km("TitleLeftMargin", b, a);
    }
    get fh() {
        return this.eu;
    }
    set fh(a) {
        let b = this.eu;
        this.eu = a;
        this.km("TitleRightMargin", b, a);
    }
    get ff() {
        return this.es;
    }
    set ff(a) {
        let b = this.es;
        this.es = a;
        this.km("TitleBottomMargin", b, a);
    }
    get fe() {
        return this.er;
    }
    set fe(a) {
        let b = this.er;
        this.er = a;
        this.km("SubtitleTopMargin", b, a);
    }
    get fc() {
        return this.ep;
    }
    set fc(a) {
        let b = this.ep;
        this.ep = a;
        this.km("SubtitleLeftMargin", b, a);
    }
    get fd() {
        return this.eq;
    }
    set fd(a) {
        let b = this.eq;
        this.eq = a;
        this.km("SubtitleRightMargin", b, a);
    }
    get fb() {
        return this.eo;
    }
    set fb(a) {
        let b = this.eo;
        this.eo = a;
        this.km("SubtitleBottomMargin", b, a);
    }
    ok() {
        return this.b1.fb();
    }
    ol() {
        return this.b1.fc();
    }
    aj(a) {
        return this.b1.c(a);
    }
    ak(a) {
        return this.b1.d(a);
    }
    getFontHeight() {
        return this.b1.a7;
    }
    provideContainer(a) {
        this.b1.cu(a);
    }
    ja(a, b) {
        this.b1.cv(a, b);
    }
    notifyContainerResized() {
        this.b1.co();
    }
    n7() {
        return this.b1.e5();
    }
    ij() {
        this.b1.b2();
    }
    nv() {
        return this.b1.e2();
    }
    b4() {
        return this.b1.r();
    }
    b3() {
        return this.b1.o();
    }
    nh() {
        return this.b1.eu();
    }
    ni() {
        return this.b1.ex();
    }
    h7(a) {
        this.b1.bn(a);
    }
    k2(a) {
        this.b1.ds(a);
    }
    get du() {
        return this.cn;
    }
    set du(a) {
        let b = this.cn;
        this.cn = a;
        if (b != this.cn) {
            this.b1.cl(this.cn);
        }
    }
    get ct() {
        return this.ce;
    }
    set ct(a) {
        let b = this.ce;
        this.ce = a;
        if (b != this.ce) {
            this.b1.bi(this.ce);
        }
    }
    get syncSettings() {
        return this._syncSettings;
    }
    set syncSettings(a) {
        this._syncSettings = a;
    }
    h6(a) {
        this.b1.bl(a);
    }
    k4(a) {
        this.b1.dt(a);
    }
    i0(source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        let d = this.actualSyncLink.ae(source_);
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    iv(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        let a = this.actualSyncLink.ae(source_);
        if (a == null) {
            return;
        }
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    }
    iy(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        let c = this.actualSyncLink.ae(source_);
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    iz(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        let c = this.actualSyncLink.ae(source_);
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    destroy() {
        this.destroyed = true;
        let a = new List$1(Series.$, 0);
        for (let b = 0; b < this.series.count; b++) {
            a.add(this.series._inner[b]);
        }
        for (let c = 0; c < a.count; c++) {
            if (a._inner[c].bi != null) {
                a._inner[c].bi.ag();
            }
            this.series.remove(a._inner[c]);
            this.k3(a._inner[c].name, true);
            a._inner[c].itemsSource = null;
            a._inner[c].i8(null, null);
        }
        this.ih();
        this.k5();
        this.onDetachedFromUI();
        this.b1.cu(null);
    }
    ih() {
    }
    lb(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        this.fw = source_;
        this.li();
    }
    k5() {
        this.fw = null;
        this.li();
    }
    la(a, source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (stringIsNullOrEmpty(a) == false) {
            if (!this.ea.containsKey(a)) {
                this.ea.addItem(a, source_);
            }
            else {
                this.ea.item(a, source_);
            }
        }
        this.li();
    }
    k3(a, b) {
        if (stringIsNullOrEmpty(a) == false) {
            if (this.ea.containsKey(a)) {
                this.ea.removeItem(a);
            }
        }
        if (!b) {
            this.li();
        }
    }
    k9(a, b) {
        if (a.itemsSource != b) {
            a.itemsSource = b;
        }
    }
    lh(a) {
        if (!this.ds) {
            return;
        }
        if (typeCast(Series.$, a) !== null) {
            let b = a;
            if (this.ea.containsKey(b.name)) {
                let c = this.ea.item(b.name);
                this.k9(b, c);
            }
            else {
                this.k9(b, this.fw);
            }
        }
        if (typeCast(CategoryAxisBase.$, a) !== null) {
            let d = a;
            if (this.ea.containsKey(d.name)) {
                let e = this.ea.item(d.name);
                if (d.itemsSource != e) {
                    d.itemsSource = e;
                }
            }
            else {
                if (d.itemsSource != this.fw) {
                    d.itemsSource = this.fw;
                }
            }
        }
    }
    li() {
        if (!this.ds) {
            return;
        }
        for (let a of fromEnum(this.series)) {
            this.lh(a);
        }
    }
    get fj() {
        return this.ew;
    }
    set fj(a) {
        this.ew = a;
        this.it();
    }
    get e7() {
        return this.el;
    }
    set e7(a) {
        this.el = a;
        this.it();
    }
    get fa() {
        return this.en;
    }
    set fa(a) {
        this.en = a;
        this.it();
    }
    get e3() {
        return this.ej;
    }
    set e3(a) {
        this.ej = a;
        this.it();
    }
    get e2() {
        return this.ei;
    }
    set e2(a) {
        this.ei = a;
        this.it();
    }
    get e1() {
        return this.eh;
    }
    set e1(a) {
        this.eh = a;
        this.it();
    }
    d0() {
        return false;
    }
    get c9() {
        return this.cj;
    }
    set c9(a) {
        let b = this.cj;
        this.cj = a;
        this.km("IsAntiAliasingEnabledDuringInteraction", b, this.cj);
    }
    get e8() {
        return this.em;
    }
    set e8(a) {
        let b = this.em;
        this.em = a;
        this.km("PixelScalingRatio", b, this.em);
    }
    get e6() {
        return this.ek;
    }
    set e6(a) {
        let b = this.ek;
        this.ek = a;
        this.km("InteractionPixelScalingRatio", b, this.ek);
    }
    static bn(a, b) {
        let c = new CoercionInfo();
        c.b = a;
        c.a = null;
        let d = FastItemsSource.f(a);
        if (d.d == null) {
            return c;
        }
        if (b != null) {
            let methods_ = b;
            let key_ = d.d;
            let val_ = null;
            if (typeof methods_[key_] != 'undefined') {
                val_ = methods_[key_];
            }
            ;
            c.b = d.c;
            c.a = val_;
        }
        else if (d.d == "defaultDateParse") {
            let e = defaultDVDateParse;
            c.b = d.c;
            c.a = e;
        }
        return c;
    }
    get gs() {
        return this.fz;
    }
    set gs(a) {
        this.fz = a;
        if (this.bu == null) {
            return;
        }
        this.bu.backgroundImageUri = this.fz;
    }
    get ey() {
        return this.ee;
    }
    set ey(a) {
        let b = this.ee;
        this.ee = a;
        this.km("ActualPixelScalingRatio", b, this.ee);
    }
    get ex() {
        return this.ed;
    }
    set ex(a) {
        let b = this.ed;
        this.ed = a;
        this.km("ActualInteractionPixelScalingRatio", b, this.ed);
    }
    get n2() {
        return this.nx;
    }
    set n2(a) {
        let b = Rect.l_op_Inequality(this.nx, a);
        if (b) {
            let c = this.nx;
            this.nx = a;
            this.km("ActualWindowRect", c, a);
        }
    }
    n8() {
        return this.n2;
    }
    is() {
        if (this.c5) {
            return;
        }
        this.n2 = this.n3();
    }
    od() {
        return Rect.empty;
    }
    n3() {
        let a = this.oi.left;
        let b = this.oi.top;
        let c = this.oi.width;
        let d = this.oi.height;
        if (this.bk == 1) {
            a = Math.min(1, Math.max(0, this.oi.left));
            c = Math.min(1, Math.max(0, this.oi.width));
        }
        if (this.bk == 1) {
            b = Math.min(1, Math.max(0, this.oi.top));
            d = Math.min(1, Math.max(0, this.oi.height));
        }
        return new Rect(0, a, b, c, d);
    }
    fx(a, b) {
        return this.b1.bh(a, b);
    }
    get ez() {
        return this.ef;
    }
    set ez(a) {
        let b = this.ef;
        this.ef = a;
        this.km("ActualWindowPositionHorizontal", b, this.ef);
    }
    get e0() {
        return this.eg;
    }
    set e0(a) {
        let b = this.eg;
        this.eg = a;
        this.km("ActualWindowPositionVertical", b, this.eg);
    }
    i2() {
        if (this.cq && this.bu != null) {
            this.bu.surfaceIsDirty = true;
            this.bu.doRefresh(false);
        }
        this.ic();
    }
    i1() {
        if (this.cq && this.bu != null) {
            this.bu.surfaceIsDirty = true;
            this.bu.doRefresh(false);
        }
        this.ic();
    }
    flush() {
        this.il(true, true);
    }
    il(a, b) {
        this.al.x();
        if (a) {
            this.b1.b3();
            this.al.x();
        }
        this.ah.i();
        if (b) {
            this.b1.a.i();
        }
        this.d9 = true;
    }
    d6() {
        return false;
    }
    kz(a, b) {
        if (this.l2 != null) {
            this.ld(this.l2);
            this.l2 = null;
            this.ar = null;
        }
        this.l2 = a;
        this.ar = this.al.k(2, a, b);
    }
    ld(a) {
        this.al.ac(2, a);
        this.l2 = null;
        this.ar = null;
    }
    ie() {
        this.al.ab(2, this.l2, this.ar, false);
    }
    jk() {
        let a = false;
        let b = false;
        let c = false;
        for (let d = 0; d < this.series.count; d++) {
            let e = this.series._inner[d];
            if (e.cm) {
                a = true;
            }
            if (e.cn) {
                b = true;
            }
            if (e.cj) {
                c = true;
            }
        }
        this.da = a;
        this.db = b;
        this.c8 = c;
    }
    get dl() {
        return this.cq;
    }
    h8() {
        this.b1.bo();
        for (let a = 0; a < this.series.count; a++) {
            this.series._inner[a].iw();
        }
    }
    dr() {
        return this.b1.ak();
    }
    ft() {
        let a = this.fp;
        this.fp++;
        return a;
    }
    b7() {
        if (this.hr == null) {
            return null;
        }
        return FontUtil.toFontInfo(this.b1.i.ae, this.hr);
    }
    b6() {
        if (this.hf == null) {
            return null;
        }
        return FontUtil.toFontInfo(this.b1.i.ae, this.hf);
    }
    lg() {
        let a = false;
        a = this.ct;
        this.c6 = true;
        this.c0 = (a && !this.d7) || this.om == 0;
        this.c6 = false;
    }
    kq() {
        if (this.seriesDataUpdated != null) {
            this.seriesDataUpdated(this, EventArgs.empty);
        }
    }
}
SeriesViewer.$t = markType(SeriesViewer, 'SeriesViewer', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type, IInternalLegendOwner_$type]);
SeriesViewer.mg = DependencyProperty.i("Legend", IChartLegend_$type, SeriesViewer.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(SeriesViewer.$, a);
    c.km("Legend", b.oldValue, b.newValue);
}));
SeriesViewer.l4 = DependencyProperty.i("AnimateSeriesWhenAxisRangeChanges", Boolean_$type, SeriesViewer.$, new PropertyMetadata(2, false, (a, b) => {
    let c = typeCast(SeriesViewer.$, a);
    c.km("AnimateSeriesWhenAxisRangeChanges", b.oldValue, b.newValue);
}));
SeriesViewer.mf = DependencyProperty.i("IsWindowSyncedToVisibleRange", Boolean_$type, SeriesViewer.$, new PropertyMetadata(2, false, (a, b) => {
    let c = typeCast(SeriesViewer.$, a);
    c.km("IsWindowSyncedToVisibleRange", b.oldValue, b.newValue);
}));
SeriesViewer.oe = Rect.empty;
SeriesViewer.$$p = markDep(DependencyProperty, PropertyMetadata, SeriesViewer, 'km', ['ActualPlotAreaBorderBrush:ne:l3', [Brush.$, null], 'CircleMarkerTemplate:ls:l5', [DataTemplate.$, null], 'CrosshairVisibility:om:l6', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'DefaultInteraction:bp:l7', [InteractionState_$type, enumGetBox(InteractionState_$type, 3)], 'DiamondMarkerTemplate:lt:l8', [DataTemplate.$, null], 'DragModifier:na:l9', [ModifierKeys_$type, enumGetBox(ModifierKeys_$type, 2)], 'HexagonMarkerTemplate:lu:ma', [DataTemplate.$, null], 'HexagramMarkerTemplate:lv:mb', [DataTemplate.$, null], 'HighlightingTransitionDuration:fu:mc', [1, 300], 'IsPagePanningAllowed:di:md', [0, true], 'IsSurfaceInteractionDisabled:dj:me', [0, false], 'OverviewPlusDetailPaneVisibility:on:mh', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'PanModifier:nb:mi', [ModifierKeys_$type, enumGetBox(ModifierKeys_$type, 4)], 'PentagonMarkerTemplate:lw:mj', [DataTemplate.$, null], 'PentagramMarkerTemplate:lx:mk', [DataTemplate.$, null], 'PlotAreaBackground:nn:ml', [Brush.$, null], 'PlotAreaBorderBrush:no:mm', [Brush.$, null], 'PreferHigherResolutionTiles:dy:mn', [0, false], 'PreviewPathFill:np:mo', [Brush.$, null], 'PreviewPathOpacity:e9:mp', [1, NaN], 'PreviewPathStroke:nq:mq', [Brush.$, null], 'PyramidMarkerTemplate:ly:mr', [DataTemplate.$, null], 'RightButtonDefaultInteraction:br:ms', [InteractionState_$type, enumGetBox(InteractionState_$type, 3)], 'SquareMarkerTemplate:lz:mt', [DataTemplate.$, null], 'SubtitleHorizontalAlignment:m8:mu', [HorizontalAlignment_$type, enumGetBox(HorizontalAlignment_$type, 1)], 'Subtitle:g8:mv', [2, null], 'TetragramMarkerTemplate:l0:mw', [DataTemplate.$, null], 'TitleHorizontalAlignment:m9:mx', [HorizontalAlignment_$type, enumGetBox(HorizontalAlignment_$type, 1)], 'Title:hk:my', [2, null], 'TriangleMarkerTemplate:l1:mz', [DataTemplate.$, null], 'UseTiledZooming:d8:m0', [0, false], 'WindowPositionHorizontal:fk:m1', [1, NaN], 'WindowPositionVertical:fl:m2', [1, NaN], 'WindowRectMinWidth:fm:m3', [1, 0.0001], 'WindowRect:oi:m4', [Rect.$, new Rect(0, 0, 0, 1, 1)], 'WindowResponse:bi:m5', [WindowResponse_$type, enumGetBox(WindowResponse_$type, 1)], 'ZoomCoercionMode:bm:m6', [ZoomCoercionMode_$type, enumGetBox(ZoomCoercionMode_$type, 0)], 'ZoomTileCacheSize:fv:m7', [1, 30]]);
/**
 * @hidden
 */
class SeriesViewerView extends Base {
    constructor(a) {
        super();
        this.n = null;
        this.a = null;
        this.l = null;
        this.m = null;
        this.f = null;
        this.b = null;
        this.ag = false;
        this.fa = null;
        this.e9 = null;
        this.e8 = null;
        this.e7 = null;
        this.g = new SeriesViewerComponentsFromView();
        this.i = null;
        this.u = null;
        this.x = null;
        this.w = null;
        this.v = null;
        this.al = false;
        this.am = false;
        this.bg = null;
        this.j = null;
        this.a7 = 0;
        this.a6 = 0;
        this.a5 = 0;
        this.e3 = Rect.empty;
        this.ah = false;
        this.az = 0;
        this.ax = 0;
        this.ay = 0;
        this.aw = 0;
        this.ai = true;
        this.y = false;
        this.a0 = NaN;
        this.e4 = Rect.empty;
        this.z = false;
        this.ad = false;
        this.ac = false;
        this.at = false;
        this.en = null;
        this.em = null;
        this.ab = false;
        this.aa = false;
        this.ae = true;
        this.av = null;
        this.ap = false;
        this.be = 0;
        this.af = true;
        this.a6 = 0;
        this.a5 = 0;
        this.n = a;
        this.n.nu = { $type: Point_$type, x: NaN, y: NaN };
        this.n.bi = 1;
        this.i = new SeriesViewerViewManager(this);
        this.e7 = ((() => {
            let $ret = new Line();
            $ret.visibility = 1;
            return $ret;
        })());
        this.e8 = ((() => {
            let $ret = new Line();
            $ret.visibility = 1;
            return $ret;
        })());
    }
    ci() {
        this.i.a9();
    }
    cy() {
        this.n.c6 = true;
        this.n.om = 1;
        this.n.c6 = false;
        this.e9 = new Path();
        this.fa = new Rectangle();
        this.fa._visibility = 1;
        this.d0();
        this.f = new SeriesCollection();
        this.b = new AxisCollection();
        this.a = new CanvasRenderScheduler();
        this.a.l(this);
        this.a.e.add(this.n.ai);
        if (this.n.on == 0) {
            this.ch();
        }
        let a = this.n;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, runOn(this, this.cn));
        let b = this.n;
        b.gridAreaRectChanged = delegateCombine(b.gridAreaRectChanged, runOn(this, this.cm));
        this.m = new OverviewPlusDetailViewportHost(this);
        this.di();
    }
    ch() {
        if (this.l == null) {
            this.l = this.i.g();
        }
        this.n.bu.provideContext(this.x);
        this.n.bu.provideContainer(this.bg);
        this.n.bu.provideEventSource(this.j);
        this.l.world = new Rect(0, 0, 0, 1, 1);
        this.l.window = this.n.oi;
        this.l.surfaceViewer = TypeRegistrar.create("SeriesViewerSurfaceViewer", this.n, this);
        this.l.viewScheduler = this.a;
        this.eg();
        let a = this.l;
        a.windowChanging = delegateCombine(a.windowChanging, runOn(this, this.dh));
        let b = this.l;
        b.windowChanged = delegateCombine(b.windowChanged, runOn(this, this.dg));
    }
    dh(a, b) {
        let c = b.newValue;
        if (this.l != null) {
            c = this.l.changeRect(b.oldValue, b.newValue, this.n.dp(), this.n.dq(), this.l.world);
        }
        if (c.isEmpty) {
            this.l.window = b.oldValue;
        }
        else if (!c.equals1(b.newValue)) {
            this.l.window = c;
        }
        if (this.n.bi == 1) {
            let d = this.n.oh.width / this.n.oh.height;
            c = new Rect(0, c.left / d, c.top, c.width / d, c.height);
            this.n.oi = c;
        }
    }
    dg(a, b) {
        let c = b.newValue;
        if (this.l != null) {
            c = this.l.changeRect(b.oldValue, b.newValue, this.n.dp(), this.n.dq(), this.l.world);
        }
        if (c.isEmpty) {
            c = b.oldValue;
        }
        else if (!c.equals1(b.newValue)) {
            this.l.window = c;
        }
        let d = this.n.oh.width / this.n.oh.height;
        c = new Rect(0, c.left / d, c.top, c.width / d, c.height);
        this.n.oi = c;
    }
    eg() {
        if (this.l == null) {
            return;
        }
        if (this.n.on != 0) {
            return;
        }
        let a = 1;
        if (this.n.oh.isEmpty == false) {
            a = this.n.oh.width / this.n.oh.height;
        }
        let b = this.l.world;
        let c = new Rect(0, 0, 0, a, 1);
        this.l.world = c;
        if (b.width != c.width || b.height != c.height || b.x != c.x || b.y != c.y) {
            this.l.surfaceViewer.isDirty = true;
        }
        this.l.window = new Rect(0, this.n.oi.left * a, this.n.oi.top, this.n.oi.width * a, this.n.oi.height);
    }
    cn(a, b) {
        this.eg();
    }
    cm(a, b) {
        this.eg();
    }
    b5(a, b, c) {
        let d = true;
        for (let e of fromEnum(this.n.series)) {
            if (d && e.dl) {
                d = false;
                c.a.k(0, 0, a, b);
            }
            e.jn(new Rect(0, 0, 0, a, b), c);
        }
    }
    dz() {
        this.i.bl();
    }
    b7() {
    }
    d1() {
        this.i.bm();
    }
    ce() {
        for (let a = 0; a < this.n.series.count; a++) {
            this.n.series._inner[a].bi.am();
        }
    }
    b6() {
    }
    b8() {
    }
    ds(a) {
        let b = this.f.indexOf(a);
        if (b >= 0) {
            this.f.removeAt(b);
        }
        if (a.isStacked) {
            a.ig((c) => {
                c.bs = null;
                b = this.f.indexOf(c);
                if (b >= 0) {
                    this.f.removeAt(b);
                }
                return true;
            });
        }
        this.n.kx();
        a.i8(null, null);
        this.c6();
    }
    c6() {
        if (this.n.destroyed) {
            return;
        }
        if (this.f.count == 0) {
            if (this.w != null && Rect.l_op_Inequality(this.n.oh, null) && !this.n.oh.isEmpty) {
                this.el();
            }
        }
        this.n.ah.o(this.w, this.v);
    }
    el() {
        if (this.w != null && Rect.l_op_Inequality(this.n.oh, null) && !this.n.oh.isEmpty) {
            if (this.n.ey != 1) {
                this.w.z();
                this.w.aa(this.n.ey, this.n.ey);
            }
            this.w.k(this.n.oh.left, this.n.oh.top, this.n.oh.width, this.n.oh.height);
            if (this.n.ey != 1) {
                this.w.y();
            }
        }
    }
    ao(a) {
        a.i3(a.bi.br, this.e3);
        return this.f.contains(a);
    }
    get as() {
        return this.ag;
    }
    set as(a) {
        this.ag = a;
    }
    bn(a) {
        if (!this.f.contains(a)) {
            this.f.add(a);
            if (a.isStacked) {
                a.ig((b) => {
                    this.f.add(b);
                    return true;
                });
            }
            this.n.kx();
        }
        a.i8(this.w, this.v);
        this.n.it();
    }
    dm(a) {
        this.v = a;
        for (let b = 0; b < this.f.count; b++) {
            this.f._inner[b].i8(this.w, this.v);
        }
        for (let c = 0; c < this.b.count; c++) {
            this.b._inner[c].g0(this.w, this.v);
        }
    }
    bv() {
    }
    br() {
        this.b9();
        this.ce();
    }
    b9() {
        this.fa._visibility = 1;
        this.ck();
    }
    b4() {
    }
    dk() {
    }
    d2() {
        this.fa._visibility = 0;
        this.ck();
    }
    ea(a) {
        this.fa.o = a.top + this.n.oh.top;
        this.fa.n = a.left + this.n.oh.left;
        this.fa.width = a.width;
        this.fa.height = a.height;
        this.c5();
        this.fa._fill = null;
        this.fa.ac = 0.5;
        this.ck();
    }
    bu() {
    }
    c9() {
    }
    ei(a, b, c, d) {
        this.e8.ak = a;
        this.e8.am = b;
        this.e8.al = c;
        this.e8.an = d;
        this.ck();
    }
    d7() {
        this.e8._visibility = 0;
        this.ck();
    }
    cf() {
        if (this.e8._visibility == 0) {
            this.e8._visibility = 1;
            this.ck();
        }
    }
    eb(a, b, c, d) {
        this.e7.ak = a;
        this.e7.am = b;
        this.e7.al = c;
        this.e7.an = d;
        this.ck();
    }
    d3() {
        this.e7._visibility = 0;
        this.ck();
    }
    ca() {
        if (this.e7._visibility == 0) {
            this.e7._visibility = 1;
            this.ck();
        }
    }
    cd() {
        this.e9._visibility = 1;
        this.ck();
    }
    e0(a) {
        let b = new PathFigureCollection();
        let c = new PathFigure();
        c._isClosed = true;
        c._startPoint = { $type: Point_$type, x: a.left, y: a.top };
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.top }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.top }));
        b.add(c);
        return b;
    }
    e1(a) {
        let b = new PathFigureCollection();
        let c = new PathFigure();
        c._isClosed = true;
        c._startPoint = { $type: Point_$type, x: a.left, y: a.top };
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.top }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.right, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.bottom }));
        c._segments.add(new LineSegment(0, { $type: Point_$type, x: a.left, y: a.top }));
        b.add(c);
        return b;
    }
    eh(a, b) {
        b.intersect(a);
        let c = new PathGeometry();
        c.c = this.e1(a);
        let d = new PathGeometry();
        d.c = this.e0(b);
        let e = new GeometryGroup();
        e.d.add(c);
        e.d.add(d);
        this.e9.ak = e;
        this.c5();
        this.ck();
    }
    d6() {
        this.e9._visibility = 0;
        this.ck();
    }
    ej(a) {
    }
    dq(a) {
        let b = this.b.indexOf(a);
        this.b.removeAt(b);
        a.g0(null, null);
        this.dx();
        this.n.k3(a.name, true);
    }
    dr(a) {
    }
    bm(a) {
        if (!this.b.contains(a)) {
            this.b.add(a);
        }
        a.g0(this.w, this.v);
        this.dx();
    }
    bj(a) {
    }
    h() {
        this.g.a = this.l;
        return this.g;
    }
    static au(a) {
        let b = a.bs.series;
        let c = new List$1(Series.$, 0);
        for (let d = 0; d < b.count; d++) {
            c.add(b._inner[d]);
            if (b._inner[d].isStacked) {
                b._inner[d].ig((e) => {
                    c.add(e);
                    return true;
                });
            }
        }
        return c;
    }
    dw() {
        this.n.oi = new Rect(0, 0, 0, 1, 1);
    }
    cu(a) {
        if (a == this.bg) {
            return;
        }
        if (a == null) {
            if (this.j != null) {
                this.j.ar();
            }
            this.i.bf(null);
            this.u = null;
            this.x = null;
            this.w = null;
            this.v = null;
            this.j = null;
            if (this.n.bu != null) {
                this.n.bu.provideContext(null);
                this.n.bu.provideContainer(null);
                this.n.bu.provideEventSource(null);
            }
            return;
        }
        this.bg = a;
        if (this.as) {
            this.a.e.add(this.n.ah);
        }
        this.i.bf(a);
        this.u = this.i.t;
        this.x = this.i.w;
        this.w = this.i.v;
        this.v = this.i.u;
        this.al = false;
        try {
            this.al = (window.navigator.msPointerEnabled && MSGesture !== undefined);
        }
        catch (b) {
        }
        this.am = false;
        try {
            this.am = (window.navigator.pointerEnabled);
        }
        catch (c) {
        }
        if (this.al || this.am) {
            this.at = true;
        }
        this.j = this.i.f;
        if (this.j != null) {
            this.j.bg = this.n.oh;
            this.j.al = runOn(this, this.aq);
            let d = this.j;
            d.onContactCompleted = delegateCombine(d.onContactCompleted, (d, e) => this.cr(d, e, this.j.aj));
            let e = this.j;
            e.onContactMoved = delegateCombine(e.onContactMoved, runOn(this, this.cs));
            let f = this.j;
            f.onContactStarted = delegateCombine(f.onContactStarted, runOn(this, this.ct));
            let g = this.j;
            g.onDragCompleted = delegateCombine(g.onDragCompleted, runOn(this.n, this.n.jg));
            let h = this.j;
            h.onFlingStarted = delegateCombine(h.onFlingStarted, runOn(this, this.aj));
            let i = this.j;
            i.onDragDelta = delegateCombine(i.onDragDelta, (i) => this.n.jh(i));
            let j = this.j;
            j.onDragStarted = delegateCombine(j.onDragStarted, (j) => this.n.ji(j, true));
            let k = this.j;
            k.onKeyDown = delegateCombine(k.onKeyDown, runOn(this.n, this.n.dv));
            let l = this.j;
            l.onMouseDown = delegateCombine(l.onMouseDown, runOn(this, this.c0));
            let m = this.j;
            m.onMouseLeave = delegateCombine(m.onMouseLeave, runOn(this, this.c1));
            let n = this.j;
            n.onMouseOver = delegateCombine(n.onMouseOver, runOn(this, this.c2));
            let o = this.j;
            o.onMouseUp = delegateCombine(o.onMouseUp, runOn(this, this.c3));
            let p = this.j;
            p.onMouseWheel = delegateCombine(p.onMouseWheel, runOn(this.n, this.n.dw));
            if (this.j.ak) {
                let q = this.j;
                q.onZoomDelta = delegateCombine(q.onZoomDelta, (q, r, s, t) => this.n.j9(q, r, s, t));
                let r = this.j;
                r.onZoomStarted = delegateCombine(r.onZoomStarted, (r, s, t, u) => this.n.kd(r, s, t, u));
                let s = this.j;
                s.onZoomCompleted = delegateCombine(s.onZoomCompleted, (s, t, u, v) => this.n.j8(s, t, u, v));
            }
            else {
                let t = this.j;
                t.onPinchDelta = delegateCombine(t.onPinchDelta, (t, u) => this.n.js(u));
                let u = this.j;
                u.onPinchStarted = delegateCombine(u.onPinchStarted, (u, v) => this.n.jt(u));
                let v = this.j;
                v.onGestureCompleted = delegateCombine(v.onGestureCompleted, (v, w) => this.n.jj(v));
            }
            let w = this.j;
            w.onDoubleTap = delegateCombine(w.onDoubleTap, (w) => this.n.jf(w));
            let x = this.j;
            x.onHold = delegateCombine(x.onHold, runOn(this, this.cx));
        }
        if (this.n.bu != null) {
            this.n.bu.provideContext(this.x);
            this.n.bu.provideContainer(a);
            this.n.bu.provideEventSource(this.j);
        }
        for (let y of fromEnum(this.b)) {
            y.a4.aw();
            this.bm(y);
        }
        for (let z of fromEnum(this.f)) {
            this.bn(z);
        }
    }
    aj(a, b, c) {
        if (this.n.cx) {
            return false;
        }
        return true;
    }
    cs(a, b) {
        this.n.i8(a, b);
    }
    ct(a, b) {
        this.n.a1.f$s(this.n, a, b);
    }
    cx(a) {
        this.n.ju(a);
    }
    cr(a, b, c) {
        this.n.i7(a, b, c);
    }
    dn(a) {
    }
    get_an() {
        return false;
    }
    get an() {
        return this.get_an();
    }
    d9() {
        this.a7 = FontUtil.getCurrentFontHeight(this.i.ae, this.n.getFontInfo());
    }
    e(a, b, c, d) {
        return {
            ret: ((() => { let e = this.n.a1.f$c(this.n, this.f, this.v, a, b, c, d); c = e.p5; return e.ret; })()),
            p2: c
        };
    }
    bb() {
        return this.a6;
    }
    ba() {
        return this.a5;
    }
    co() {
        this.i.bc();
    }
    cv(a, b) {
        let c = this.a6;
        let d = this.a5;
        if (this.a6 != a) {
            this.ah = true;
        }
        this.a6 = a;
        if (this.a5 != b) {
            this.ah = true;
        }
        this.a5 = b;
        if (this.ah) {
            let e = new Size(1, c, d);
            let f = new Size(1, a, b);
            this.n.j5(e, f);
        }
        this.dd();
        this.dx();
        this.n.ah.o(this.w, this.v);
    }
    dx() {
        this.ae = true;
        this.n.al.y();
    }
    b0() {
        if (this.a6 == 0 || this.a5 == 0) {
            return;
        }
        this.ae = false;
        this.y = false;
        if (this.ai) {
            this.dc();
            this.c8();
            this.ai = false;
            this.ck();
        }
        let a = this.a6;
        let b = this.a5;
        let c = this.n.e7;
        let d = this.n.fa;
        let e = this.n.e3;
        let f = this.n.fj;
        let g = this.n.e1;
        let h = this.n.e2;
        if (isNaN_(g)) {
            g = this.a7 / 2;
        }
        if (isNaN_(h)) {
            h = 0;
        }
        let i = this.n.d0();
        let j = new List$1(AxisLabelPanelBase.$, 0);
        for (let k of fromEnum(this.b)) {
            if (k.av != null) {
                j.add(k.av);
                k.av.bp = () => this.ah;
            }
        }
        if (i) {
            let l = false;
            let m = false;
            let n = false;
            let o = false;
            for (let p of fromEnum(j)) {
                if (LabelPanelArranger.b(p) == 2 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                    l = true;
                }
                if (LabelPanelArranger.b(p) == 3 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                    m = true;
                }
                if (LabelPanelArranger.b(p) == 0 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                    n = true;
                }
                if (LabelPanelArranger.b(p) == 1 && (p.ac.ay == null || p.ac.ay.visibility == 0)) {
                    o = true;
                }
                if (p.ac != null && p.ac.ay != null) {
                    p.ac.ay.c = p.ac.ay.location;
                }
            }
            if (l || m) {
                if (!n && isNaN_(f)) {
                    f = g;
                }
                if (!o && isNaN_(e)) {
                    e = g;
                }
            }
            if (o || n) {
                if (!l && isNaN_(c)) {
                    c = h;
                }
                if (!m && isNaN_(d)) {
                    d = h;
                }
            }
        }
        if (isNaN_(f)) {
            f = 0;
        }
        if (isNaN_(c)) {
            c = 0;
        }
        if (isNaN_(d)) {
            d = 0;
        }
        if (isNaN_(e)) {
            e = 0;
        }
        let q = this.bd();
        f += q;
        let r = this.bc();
        f += r;
        let s = new Rect(0, c, f, a - (c + d), b - (f + e));
        s = LabelPanelArranger.e(j, s);
        let t = new Size(1, Math.max(0, a - (c + d)), Math.max(0, b - (f + e)));
        if (this.n.c4() && s.width != s.height) {
            if (s.width < s.height) {
                f += (s.height - s.width) / 2;
                s.top = s.top + ((s.height - s.width) / 2);
                t.height = t.height - (s.height - s.width);
                s.height = s.width;
            }
            else {
                c += (s.width - s.height) / 2;
                s.left = s.left + ((s.width - s.height) / 2);
                t.width = t.width - (s.width - s.height);
                s.width = s.height;
            }
        }
        this.az = f - (q + r);
        this.ax = c;
        this.ay = d;
        this.aw = e;
        this.e3 = s;
        let u = ((() => {
            let $ret = new LabelPanelsArrangeState();
            $ret.f = c;
            $ret.c = c;
            $ret.a = f + t.height;
            $ret.b = f + t.height;
            $ret.g = c + t.width;
            $ret.d = c + t.width;
            $ret.h = f;
            $ret.e = f;
            return $ret;
        })());
        LabelPanelArranger.d(j, u, this.e3, (v, w) => {
            if (!v.co.equals1(w)) {
                v.co = w;
                v.ac.a4.ad();
            }
        });
        let v = false;
        if (this.ah) {
            this.ah = false;
            v = true;
        }
        this.n.kh(this.n.oh, this.e3);
        for (let w of fromEnum(this.b)) {
            if (Rect.l_op_Equality(w.i9, null) || w.i9.isEmpty) {
                this.y = true;
            }
            if (w.i9.equals1(this.e3) && !this.i.y()) {
                continue;
            }
            w.gu(w.i9, this.e3);
        }
        for (let x of fromEnum(this.f)) {
            if (Rect.l_op_Equality(x.bi.br, null) || x.bi.br.isEmpty) {
                this.y = true;
            }
            if (x.bi.br.equals1(this.e3) && !this.i.y()) {
                continue;
            }
            x.i3(x.bi.br, this.e3);
        }
        this.ee();
        this.dp(this.e3);
        this.i.bb(false);
    }
    ee() {
        if (this.n.bu != null && !this.e3.isEmpty) {
            let a = this.n.bu;
            let b = (this.n.ct) ? this.e3.width : Number.POSITIVE_INFINITY;
            let c = (this.n.ct) ? this.e3.height : Number.POSITIVE_INFINITY;
            let d = a.getDesiredSize(new Size(1, b, c));
            this.n.bu.arrange(new Rect(0, this.e3.right - d.width, this.e3.bottom - d.height, d.width, d.height));
            this.eg();
        }
    }
    t() {
        let a = this.n.getFontInfo();
        let b = this.q();
        if (this.n.b7() != null) {
            a = this.n.b7();
        }
        else if (b != null) {
            a = b;
        }
        return a;
    }
    s() {
        let a = this.n.getFontInfo();
        let b = this.p();
        if (this.n.b6() != null) {
            a = this.n.b6();
        }
        else if (b != null) {
            a = b;
        }
        return a;
    }
    ez() {
        let a = this.n.getFontBrush();
        let b = this.ew();
        if (this.n.ns != null) {
            a = this.n.ns;
        }
        else if (b != null) {
            a = b;
        }
        return a;
    }
    ey() {
        let a = this.n.getFontBrush();
        let b = this.ev();
        if (this.n.nr != null) {
            a = this.n.nr;
        }
        else if (b != null) {
            a = b;
        }
        return a;
    }
    bd() {
        if (this.n.hk == null || !(typeCast(XamDataChart.$, this.n) !== null)) {
            return 0;
        }
        let a = this.t();
        let b = 0;
        b = FontUtil.getCurrentFontHeight(this.i.ae, a);
        let c = this.fe();
        b += c.e + c.b;
        return b;
    }
    bc() {
        if (this.n.g8 == null || !(typeCast(XamDataChart.$, this.n) !== null)) {
            return 0;
        }
        if (!isNaN_(this.a0)) {
            return this.a0;
        }
        let a = this.s();
        this.a0 = FontUtil.getCurrentFontHeight(this.i.ae, a);
        let b = this.fd();
        this.a0 += b.e + b.b;
        return this.a0;
    }
    fe() {
        let a = this.i.cd();
        let b = isNaN_(this.n.fi) ? a.e : this.n.fi;
        let c = isNaN_(this.n.fg) ? a.c : this.n.fg;
        let d = isNaN_(this.n.fh) ? a.d : this.n.fh;
        let e = isNaN_(this.n.ff) ? a.b : this.n.ff;
        return new Thickness(1, c, b, d, e);
    }
    fd() {
        let a = this.i.cc();
        let b = isNaN_(this.n.fe) ? a.e : this.n.fe;
        let c = isNaN_(this.n.fc) ? a.c : this.n.fc;
        let d = isNaN_(this.n.fd) ? a.d : this.n.fd;
        let e = isNaN_(this.n.fb) ? a.b : this.n.fb;
        return new Thickness(1, c, b, d, e);
    }
    dp(a) {
    }
    ck() {
        if (!this.ad) {
            if (this.x != null) {
                this.ad = true;
                this.a.o(this.x, null);
            }
        }
    }
    du() {
        if (this.x == null) {
            return;
        }
        if (this.x.d) {
            if (this.n.ey != 1) {
                this.x.z();
                this.x.aa(this.n.ey, this.n.ey);
            }
            if (!this.e4.isEmpty) {
                if (!this.as) {
                    this.x.k(this.e4.left, this.e4.top, this.e4.width, this.e4.height);
                }
            }
        }
        this.dv();
        if (this.x.d) {
            if (this.n.ey != 1) {
                this.x.y();
            }
        }
    }
    isValid() {
        return true;
    }
    preRender() {
        this.i.a5(this.a6, this.a5);
        this.dl();
    }
    dl() {
    }
    dv() {
        if (this.x.d) {
            this.e4 = new Rect(0, 0, 0, this.a6, this.a5);
            if (this.av != null && this.av.count > 0) {
                this.cc();
                this.x.z();
                this.x.ae(this.n.oh);
                if (!this.as) {
                    this.x.k(this.n.oh.left, this.n.oh.top, this.n.oh.width, this.n.oh.height);
                }
            }
            this.x.r(this.e7);
            this.x.r(this.e8);
            this.x.s(this.e9);
            this.x.v(this.fa);
            this.x.ac(this.t());
            if (this.en != null) {
                this.en.am = this.ez();
                this.x.w(this.en);
            }
            this.x.ac(this.s());
            if (this.em != null) {
                this.em.am = this.ey();
                this.x.w(this.em);
            }
            if (this.av != null && this.av.count > 0) {
                this.i.bk(this.av);
                this.x.y();
            }
            if (this.ap) {
                this.d5();
                this.ap = false;
                this.av.clear();
                this.n.a1.f$h(this.n);
                this.ck();
            }
        }
    }
    cw() {
        this.i.bg();
    }
    cq() {
        this.i.be();
    }
    e5() {
        return new Rect(0, 0, 0, this.a6, this.a5);
    }
    e2() {
        return this.i.b7();
    }
    d0() {
        this.n.ls = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.d;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.l1 = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.m;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.ly = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.j;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lz = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.k;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lt = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.e;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lw = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.h;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lu = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.f;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.l0 = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.l;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lx = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.i;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
        this.n.lv = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.g;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
    }
    d8() {
        this.i.bo();
        this.dy();
        let a = this.a7;
        this.d9();
        if (a != this.a7) {
            this.n.it();
        }
    }
    di() {
        if (this.n.on == 0) {
            this.ch();
            this.n.iq();
        }
        if (this.n.bu != null) {
            let a = this.n.on;
            this.n.bu.visibility = a;
            this.n.bu.doRefresh(false);
        }
    }
    aq(a) {
        return this.n.a1.f$f(this.n, a);
    }
    c2(a, b, c) {
        this.n.a1.f$v(this.n, this.f, this.v, a, b, c);
        this.n.ia(a, this.n.bs != 0 || this.n.dt);
    }
    c1(a) {
        this.n.a1.f$u(this.n, a);
    }
    c0(a) {
        this.n.a1.f$t(this.n, this.j, a);
    }
    c3(a) {
        this.n.a1.f$w(this.n, this.j, a);
    }
    dy() {
    }
    get et() {
        return this.j.bd;
    }
    ek(a) {
        if (this.j != null) {
            this.j.bg = this.n.oh;
        }
    }
    cl(a) {
        this.n.a1.f$y(this.n, a);
        this.n.ct = a;
    }
    bi(a) {
        this.n.lg();
        this.i.bv(a);
        if (this.n.bu != null) {
            this.n.bu.mobileMode = a;
        }
        this.ef();
    }
    ef() {
        this.n.lm();
    }
    get isDirty() {
        return this.ad;
    }
    set isDirty(a) {
        this.ad = a;
    }
    undirty(a) {
        this.ad = false;
        this.du();
    }
    get index() {
        return 10;
    }
    postRender() {
    }
    b3() {
        this.dx();
    }
    cb() {
        this.i.a8();
    }
    d4() {
        this.i.bn();
    }
    bt(a) {
        this.i.ax();
    }
    bk(a) {
        this.i.at(a);
    }
    ec(a) {
        this.i.bt(a);
    }
    ed(a) {
        this.i.bu(a);
    }
    bl(a) {
        this.i.au(a);
    }
    dt(a) {
        this.i.bj(a);
    }
    c4(a) {
        this.n.ah.o(this.w, this.x);
    }
    bs(a) {
    }
    k(a) {
        if (this.n.ct) {
            return 2;
        }
        else {
            return 1;
        }
    }
    cz() {
        if (this.j != null) {
            this.j.ac = this.n.dj;
        }
        if (this.l != null) {
            this.l.isSurfaceInteractionDisabled = this.n.dj;
        }
    }
    a9(a, b) {
        if (a == null || this.x == null) {
            return 0;
        }
        this.x.ac(b);
        return this.x.e(a);
    }
    a8(a, b) {
        if (a == null) {
            return 0;
        }
        let c = 0;
        c = FontUtil.getCurrentFontHeight(this.i.ae, b);
        return c;
    }
    dd() {
        this.ai = true;
        this.dx();
        this.ck();
    }
    eo(a, b, c, d) {
        if (a == null) {
            return null;
        }
        let e = ((() => {
            let $ret = new TextBlock();
            $ret.ak = a;
            $ret.o = b.e;
            return $ret;
        })());
        let f = this.a9(e, c);
        e.o = b.e;
        let g = this.a8(a, c);
        e.m = f;
        e.l = g;
        switch (d) {
            case 0:
                e.n = b.c;
                break;
            case 2:
                e.n = Math.max((this.a6 - b.d) - f, b.c);
                break;
            case 1:
            case 3:
            default:
                let h = (this.a6 / 2) - (f / 2);
                h += b.c;
                h -= b.d;
                e.n = h;
                break;
        }
        return e;
    }
    dc() {
        this.en = typeCast(XamDataChart.$, this.n) !== null ? this.eo(this.n.hk, this.fe(), this.t(), this.es()) : null;
    }
    c8() {
        this.a0 = NaN;
        this.em = typeCast(XamDataChart.$, this.n) !== null ? this.eo(this.n.g8, this.fd(), this.s(), this.er()) : null;
        if (this.em != null) {
            this.em.o += this.bd();
        }
    }
    c(a) {
        let b = this.i.c();
        if (b == 0) {
            let c = LabelPanelArranger.b(a.av);
            if (a.ai == null) {
                if (c == 4) {
                    return 4;
                }
                if (c == 5) {
                    return 3;
                }
            }
            else {
                if (c == 4) {
                    return 3;
                }
                if (c == 5) {
                    return 4;
                }
            }
            if (c == 0) {
                return 3;
            }
            return 4;
        }
        return b;
    }
    d(a) {
        let b = this.i.d();
        if (b == 0) {
            let c = LabelPanelArranger.b(a.av);
            if (a.ai == null) {
                if (c == 7) {
                    return 1;
                }
                if (c == 6) {
                    return 2;
                }
            }
            else {
                if (c == 7) {
                    return 2;
                }
                if (c == 6) {
                    return 1;
                }
            }
            if (c == 3) {
                return 2;
            }
            return 1;
        }
        return b;
    }
    de() {
        if (!isNaN_(this.n.ex)) {
            if (!isNaN_(DeviceUtils.a(this.n.e8))) {
                this.n.ey = DeviceUtils.a(this.n.e8);
            }
            else {
                this.ci();
            }
        }
        if (!this.n.c9) {
            this.i.a4();
        }
    }
    df() {
        if (!isNaN_(DeviceUtils.a(this.n.ex))) {
            this.n.ey = DeviceUtils.a(this.n.ex);
        }
        if (!this.n.c9) {
            this.i.a3();
        }
    }
    r() {
        return this.i.r();
    }
    ex() {
        return this.i.b6();
    }
    o() {
        return this.i.q();
    }
    eu() {
        return this.i.b5();
    }
    q() {
        return this.i.p();
    }
    p() {
        return this.i.o();
    }
    ew() {
        return this.i.b4();
    }
    ev() {
        return this.i.b3();
    }
    get a2() {
        return this.ax;
    }
    get a3() {
        return this.ay;
    }
    get a4() {
        return this.az;
    }
    get a1() {
        return this.aw;
    }
    get eq() {
        return this.en;
    }
    get ep() {
        return this.em;
    }
    e6() {
        return new Rect(0, 0, 0, this.a6, this.a5);
    }
    fc() {
        return this.i.cf();
    }
    fb() {
        return this.i.ce();
    }
    c7(a, b) {
        this.aa = true;
    }
    db(a, b) {
        this.ab = true;
    }
    es() {
        if (this.ab) {
            return this.n.m9;
        }
        else {
            let a = 1;
            switch (this.i.as()) {
                case "left":
                    a = 0;
                    break;
                case "right":
                    a = 2;
                    break;
            }
            return a;
        }
    }
    er() {
        if (this.aa) {
            return this.n.m8;
        }
        else {
            let a = 1;
            switch (this.i.ar()) {
                case "left":
                    a = 0;
                    break;
                case "right":
                    a = 2;
                    break;
            }
            return a;
        }
    }
    bo() {
        if (this.ae) {
            this.b0();
            if (this.y) {
                this.n.al.x();
            }
            if (this.ae) {
                this.b0();
            }
        }
    }
    ak() {
        if (this.n.d9) {
            return false;
        }
        if ((dateNow().getTime() - this.n.ec.getTime()) < 300) {
            return true;
        }
        return false;
    }
    b2() {
        this.i.a5(this.a6, this.a5);
    }
    cj() {
        this.i.ba(this.n.di);
    }
    ar(a) {
        let b = this.n.n2;
        let c = b.top > 0;
        let d = b.left > 0;
        let e = b.right < 1;
        let f = b.bottom < 1;
        let g = a.y < 0;
        let h = a.y > 0;
        let i = a.x < 0;
        let j = a.x > 0;
        if (c && g) {
            return true;
        }
        if (d && i) {
            return true;
        }
        if (f && h) {
            return true;
        }
        if (j && e) {
            return true;
        }
        return false;
    }
    dj() {
        this.i.bi();
        this.n.ah.o(this.w, this.v);
        this.n.ai.o(this.w, null);
        this.n.ag.o(this.w, this.v);
        this.a.o(this.x, null);
    }
    b1(a, b, c) {
        this.ap = false;
        if (this.av == null) {
            this.av = new List$1(ITileZoomTile_$type, 0);
        }
        for (let d = 0; d < this.av.count; d++) {
            while (d < this.av.count && !a.containsKey(this.av._inner[d].content)) {
                this.av.removeAt(d);
            }
        }
        for (let e = 0; e < b.count; e++) {
            this.av.add(b._inner[e]);
        }
        this.ck();
    }
    bf(a, b, c) {
        return this.i.an(a, b, c);
    }
    by() {
        this.i.a1();
    }
    bz(a) {
        this.i.a2(a);
    }
    cg() {
        if (this.av == null) {
            return;
        }
        this.ap = true;
        this.ck();
    }
    bw() {
        this.i.az();
    }
    bp() {
        this.i.av();
    }
    bx(a) {
        this.i.a0(a);
        this.n.jc();
    }
    bq() {
        this.i.aw();
        this.n.jb();
    }
    cc() {
        if (this.af) {
            this.af = false;
            this.w.k(this.n.oh.left, this.n.oh.top, this.n.oh.width, this.n.oh.height);
            this.n.ah.c = true;
        }
    }
    d5() {
        if (!this.af) {
            this.af = true;
            this.n.ah.c = false;
            this.n.ah.o(this.w, this.v);
        }
    }
    da() {
    }
    cp() {
        this.i.bd();
    }
    c5() {
        this.e9._fill = this.n.np == null ? this.i.b2() : this.n.np;
        this.e9._opacity = isNaN_(this.n.e9) ? 0.1 : this.n.e9;
        this.fa._stroke = this.n.nq == null ? this.i.b2() : this.n.nq;
    }
    bh(a, b) {
        return this.i.ao(a, b);
    }
}
SeriesViewerView.$t = markType(SeriesViewerView, 'SeriesViewerView', Base.$, [ISchedulableRender_$type]);
/**
 * @hidden
 */
class OverviewPlusDetailViewportHost extends Base {
    constructor(a) {
        super();
        this.a = null;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.a = a;
    }
    getViewInfo(a, b) {
        a = new Rect(0, 0, 0, this.a.l.worldRectViewport.width, this.a.l.worldRectViewport.height);
        b = SeriesViewer.oe;
        return {
            p0: a,
            p1: b
        };
    }
    getEffectiveViewport() {
        if (!this.a.n.dh) {
            if (this.a.n.n6.isEmpty) {
                return this.a.n.n6;
            }
            return this.a.n.ob(this.a.l.previewViewportdRect, this.a.n.oh, this.a.n.n6);
        }
        return Rect.empty;
    }
}
OverviewPlusDetailViewportHost.$t = markType(OverviewPlusDetailViewportHost, 'OverviewPlusDetailViewportHost', Base.$, [IProvidesViewport_$type]);
/**
 * @hidden
 */
class SeriesViewerViewManager extends Base {
    constructor(a) {
        super();
        this.ae = null;
        this.af = null;
        this.aj = null;
        this.ai = null;
        this.ag = null;
        this.ak = null;
        this.t = null;
        this.w = null;
        this.v = null;
        this.u = null;
        this.x = null;
        this.f = null;
        this.j = null;
        this.ah = null;
        this.ab = 0;
        this.aa = 0;
        this.ac = 1;
        this.ad = 0;
        this.l = null;
        this.b9 = new Thickness(0, 0);
        this.aq = null;
        this.ap = stringEmpty();
        this.b8 = new Thickness(0, 0);
        this.bz = null;
        this.by = null;
        this.k = null;
        this.a = 0;
        this.b = 0;
        this.n = null;
        this.b1 = null;
        this.m = null;
        this.b0 = null;
        this.ca = new Thickness(0, 0);
        this.cb = new Thickness(0, 0);
        this.h = null;
        this.z = new Dictionary$2(String_$type, Tuple$2.$.specialize(DomWrapper_$type, RenderingContext.$), 0);
        this.al = -1;
        this.am = -1;
        this.s = null;
        this.j = a;
    }
    bi() {
    }
    bf(a) {
        if (a == null) {
            if (this.f != null) {
                this.f.ar();
            }
            this.ae = null;
            if (this.af != null) {
                this.af.remove();
            }
            this.af = null;
            if (this.aj != null) {
                this.aj.remove();
            }
            this.aj = null;
            if (this.ai != null) {
                this.ai.remove();
            }
            this.ai = null;
            if (this.ag != null) {
                this.ag.remove();
            }
            this.ag = null;
            if (this.ak != null) {
                this.ak.remove();
            }
            this.ak = null;
            this.t = null;
            this.w = null;
            this.v = null;
            this.u = null;
            if (this.ah != null) {
                this.ah.remove();
            }
            this.ah = null;
            this.f = null;
            this.j.n.b2.u(null);
            this.j.n.ah.j(null);
            this.j.n.ai.j(null);
            this.j.n.ag.j(null);
            this.j.a.j(null);
            return;
        }
        this.ae = a;
        this.j.n.b2.u(this.ae);
        this.j.n.ah.j(this.ae);
        this.j.n.ai.j(this.ae);
        this.j.n.ag.j(this.ae);
        this.j.a.j(this.ae);
        this.j.n.al.z(this.ae);
        this.bh();
        this.ae.rootWrapper.setStyleProperty("position", "relative");
        this.af = this.ae.createElement("canvas");
        this.af.setStyleProperty("position", "absolute");
        this.af.setStyleProperty("top", "0px");
        this.af.setStyleProperty("left", "0px");
        this.aj = this.ae.createElement("canvas");
        this.aj.setStyleProperty("position", "absolute");
        this.aj.setStyleProperty("top", "0px");
        this.aj.setStyleProperty("left", "0px");
        this.ai = this.ae.createElement("canvas");
        this.ai.setStyleProperty("position", "absolute");
        this.ai.setStyleProperty("top", "0px");
        this.ai.setStyleProperty("left", "0px");
        this.ag = this.ae.createElement("canvas");
        this.ag.setStyleProperty("position", "absolute");
        this.ag.setStyleProperty("top", "0px");
        this.ag.setStyleProperty("left", "0px");
        this.ak = this.ae.createElement("canvas");
        this.ak.setStyleProperty("position", "absolute");
        this.ak.setStyleProperty("top", "0px");
        this.ak.setStyleProperty("left", "0px");
        this.ae.append(this.af);
        this.ae.append(this.ai);
        this.ae.append(this.aj);
        this.t = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.af));
        this.w = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.aj));
        this.v = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ai));
        if (this.j.n.ao != 1) {
            this.u = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
            this.s = this.u;
        }
        else {
            this.u = new RenderingContext(null, null);
        }
        this.x = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ak));
        this.j.dn(this.t);
        this.j.cv(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
        {
            if ((TypeRegistrar.isRegistered('CanvasGestureDOMEventProxy'))) {
                let overlayCanvas_ = this.aj;
                let container_ = this.ae;
                this.f = (TypeRegistrar.create('CanvasGestureDOMEventProxy', overlayCanvas_, container_, false));
            }
            else {
                this.f = null;
            }
            if (this.f != null) {
                this.f.am = runOn(this.j, this.j.ar);
            }
        }
        this.ah = this.ae.createElement("div");
        this.ah.hide();
        this.ah.setStyleProperty("position", "absolute");
        this.ah.setStyleProperty("z-index", "10000");
        this.ah.addClass(this.j.n.hu);
        this.ae.append(this.ah);
    }
    static bx(a, b) {
        b();
        return;
    }
    bh() {
        this.j.dy();
        this.j.d9();
        this.bo();
    }
    a9() {
        let a = this.j.n.e8;
        let b = this.j.n.ey;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.j.n.ey = window.devicePixelRatio;
        }
    }
    g() {
        if ((TypeRegistrar.isRegistered('XamOverviewPlusDetailPane'))) {
            let overlayCanvas_ = this.aj;
            let container_ = this.ae;
            return (TypeRegistrar.create('XamOverviewPlusDetailPane'));
        }
        return null;
    }
    bl() {
        this.aj.setStyleProperty("cursor", "default");
    }
    bm() {
        this.aj.setStyleProperty("cursor", "pointer");
    }
    b2() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "#000000";
            return $ret;
        })());
    }
    ay(a, b, c) {
        this.ab = a;
        this.aa = b;
        this.ac = c;
        let d = a;
        let e = b;
        if (c != 1) {
            d = Math.round(a * c);
            e = Math.round(b * c);
        }
        if (this.af != null) {
            this.af.setAttribute("width", d.toString());
            this.af.setAttribute("height", e.toString());
            this.af.setStyleProperty("width", a.toString() + "px");
            this.af.setStyleProperty("height", b.toString() + "px");
        }
        if (this.aj != null) {
            this.aj.setAttribute("width", d.toString());
            this.aj.setAttribute("height", e.toString());
            this.aj.setStyleProperty("width", a.toString() + "px");
            this.aj.setStyleProperty("height", b.toString() + "px");
            this.aj.setAttribute("tabindex", "0");
            this.aj.setStyleProperty("outline", "0");
        }
        if (this.ai != null) {
            this.ai.setAttribute("width", d.toString());
            this.ai.setAttribute("height", e.toString());
            this.ai.setStyleProperty("width", a.toString() + "px");
            this.ai.setStyleProperty("height", b.toString() + "px");
        }
        if (this.ag != null) {
            this.ag.setAttribute("width", d.toString());
            this.ag.setAttribute("height", e.toString());
            this.ag.setStyleProperty("width", a.toString() + "px");
            this.ag.setStyleProperty("height", b.toString() + "px");
        }
        if (this.ak != null) {
            this.ak.setAttribute("width", d.toString());
            this.ak.setAttribute("height", e.toString());
            this.ak.setStyleProperty("width", a.toString() + "px");
            this.ak.setStyleProperty("height", b.toString() + "px");
        }
        this.j.n.ah.n();
        this.j.n.ai.n();
        this.j.n.ag.n();
    }
    b7() {
        if (this.f == null) {
            return { $type: Point_$type, x: 0, y: 0 };
        }
        let a = this.f.bf(this.ae.rootWrapper);
        return { $type: Point_$type, x: a.left, y: a.top };
    }
    y() {
        return false;
    }
    bb(a) {
    }
    a7(a, b, c, d, e) {
        let f = this.e();
        a = f.a;
        b = f.f;
        c = f.k;
        d = f.h;
        e = f.i;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    }
    e() {
        let a = new DefaultPaletteInfo();
        a.a = new BrushCollection();
        a.f = new BrushCollection();
        a.b = new BrushCollection();
        a.c = new BrushCollection();
        let b = new List$1(String_$type, 0);
        b.add("background-image");
        this.ae.startCSSQuery();
        let c = this.ae.getCssDefaultValuesForClassCollection("ui-chart-fill-palette-", b.toArray());
        let d = c.length;
        let e = this.ae.getCssDefaultValuesForClassCollection("ui-chart-outline-palette-", b.toArray());
        let f = e.length;
        let g = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-fill-palette-", b.toArray());
        let h = g.length;
        let i = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-outline-palette-", b.toArray());
        let j = i.length;
        for (let k = 0; k < d; k++) {
            a.a.add(CssGradientUtil.brushFromGradientString(c[k][0]));
        }
        for (let l = 0; l < f; l++) {
            a.f.add(CssGradientUtil.brushFromGradientString(e[l][0]));
        }
        for (let m = 0; m < h; m++) {
            a.b.add(CssGradientUtil.brushFromGradientString(g[m][0]));
        }
        for (let n = 0; n < j; n++) {
            a.c.add(CssGradientUtil.brushFromGradientString(i[n][0]));
        }
        b.clear();
        let o = 0;
        let p = 0;
        let q = Math.min(d, f);
        let r = null;
        if (d == 0) {
            b.add("background-color");
        }
        if (f == 0) {
            b.add("border-top-color");
            p = d == 0 ? 1 : 0;
        }
        if (b.count > 0) {
            r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-palette-", b.toArray());
            q = r.length;
        }
        if (d == 0) {
            if (q > 0) {
                for (let s = 0; s < q; s++) {
                    let t = new Brush();
                    t._fill = r[s][o];
                    a.a.add(t);
                }
            }
            else {
                a.a.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#50a8be";
                    return $ret;
                })()));
                a.a.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#fc6754";
                    return $ret;
                })()));
                a.a.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#fec33c";
                    return $ret;
                })()));
                a.a.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#3c6399";
                    return $ret;
                })()));
                a.a.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#91af49";
                    return $ret;
                })()));
            }
        }
        if (f == 0) {
            if (q > 0) {
                for (let u = 0; u < q; u++) {
                    let v = new Brush();
                    v._fill = r[u][p];
                    a.f.add(v);
                }
            }
            else {
                a.f.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#B1BFC9";
                    return $ret;
                })()));
                a.f.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#798995";
                    return $ret;
                })()));
                a.f.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#4F606C";
                    return $ret;
                })()));
                a.f.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#374650";
                    return $ret;
                })()));
                a.f.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#162C3B";
                    return $ret;
                })()));
            }
        }
        b.clear();
        let w = Math.min(h, j);
        if (h == 0) {
            b.add("background-color");
        }
        if (j == 0) {
            b.add("border-top-color");
            p = h == 0 ? 1 : 0;
        }
        if (b.count > 0) {
            r = this.ae.getCssDefaultValuesForClassCollection("ui-chart-marker-palette-", b.toArray());
            w = r.length;
        }
        if (h == 0) {
            if (w > 0) {
                for (let x = 0; x < w; x++) {
                    let y = ((() => {
                        let $ret = new Brush();
                        $ret.fill = r[x][o];
                        return $ret;
                    })());
                    a.b.add(y);
                }
            }
            else {
                a.b.add(((() => {
                    let $ret = new Brush();
                    $ret.fill = "#FFFFFF";
                    return $ret;
                })()));
            }
        }
        if (j == 0) {
            if (w > 0) {
                for (let z = 0; z < w; z++) {
                    let aa = ((() => {
                        let $ret = new Brush();
                        $ret.fill = r[z][p];
                        return $ret;
                    })());
                    a.c.add(aa);
                }
            }
            else {
                for (let ab of fromEnum(a.a)) {
                    a.c.add(ab);
                }
            }
        }
        let ac = this.ae.getCssDefaultPropertyValue("ui-chart-axis", "border-top-color");
        if (ac != null) {
            a.i = new Brush();
            a.i._fill = ac;
        }
        else {
            let ad = new Brush();
            ad._fill = "#989EA3";
            a.i = ad;
        }
        a.k = new Brush();
        a.k._fill = this.ae.getCssDefaultPropertyValue("", "color");
        a.j = a.k;
        let ae = this.ae.getCssDefaultPropertyValue("ui-chart-crosshair", "border-top-color");
        if (ae != null) {
            a.j = new Brush();
            a.j._fill = ae;
        }
        this.ae.endCSSQuery();
        a.h = FontUtil.getFont(this.ae);
        let af = ((() => {
            let $ret = new Brush();
            $ret.fill = "#C62828";
            return $ret;
        })());
        a.d = new BrushCollection();
        a.d.add(af);
        a.e = new BrushCollection();
        a.e.add(af);
        return a;
    }
    a6(a, b, c, d, e, f) {
        this.ae.startCSSQuery();
        let g = this.ae.getCssDefaultPropertyValue("ui-chart-area-fill-opacity", "opacity");
        a = g != null ? parseFloat(g) : 1;
        b = new Array(4);
        let h = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-top");
        let i = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-right");
        let j = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-bottom");
        let k = this.ae.getCssDefaultPropertyValue("ui-chart-render-margins", "margin-left");
        b[0] = h != null ? parseFloat(h) : NaN;
        b[1] = i != null ? parseFloat(i) : NaN;
        b[2] = j != null ? parseFloat(j) : NaN;
        b[3] = k != null ? parseFloat(k) : NaN;
        c = d = null;
        let l = this.ae.getCssDefaultPropertyValue("ui-chart-axis-stroke", "border-top-color");
        if (l != null) {
            let m = new Brush();
            m._fill = l;
            c = m;
        }
        let n = this.ae.getCssDefaultPropertyValue("ui-chart-axis-major-line", "border-top-color");
        if (n != null) {
            let o = new Brush();
            o._fill = n;
            d = o;
        }
        let p = this.ae.getCssDefaultPropertyValue("ui-chart-aligned-gridlines", "visibility");
        f = p != null && p == "visible";
        let q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "height");
        if (q != null) {
            e = parseFloat(q);
            if (Math.abs(e) > 4000) {
                e = 0;
            }
        }
        else {
            q = this.ae.getCssDefaultPropertyValue("ui-chart-category-axis-tick", "width");
            e = q != null ? parseFloat(q) : 0;
        }
        this.ae.endCSSQuery();
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d,
            p4: e,
            p5: f
        };
    }
    ax() {
        this.ah.removeChildren();
    }
    bt(x_) {
        let box_ = this.ah;
        let offset_ = this.f.bf(this.ah);
        let a = this.b7();
        x_ = a.x + this.j.n.oh.left + x_;
        box_.setOffset(x_, this.j.n.oh.top + this.ad + a.y);
    }
    bu(y_) {
        this.ad = y_;
        let box_ = this.ah;
        let offset_ = this.ah.getOffset();
        let a = this.b7();
        y_ = this.j.n.oh.top + this.ad + a.y;
        box_.setOffset(offset_.left, y_);
    }
    at(a) {
        let b = a;
        b.show();
        this.ah.append(b);
    }
    a8() {
        this.ah.hide();
    }
    bn() {
        this.ah.show();
    }
    au(a) {
        this.ae.appendToBody(a);
    }
    bj(a) {
        a.remove();
    }
    bc() {
        if (this.ae == null) {
            return;
        }
        this.a9();
        this.j.cv(this.ae.rootWrapper.width(), this.ae.rootWrapper.height());
    }
    p() {
        return this.l;
    }
    cd() {
        return this.b9;
    }
    as() {
        return this.aq;
    }
    ar() {
        return this.ap;
    }
    cc() {
        return this.b8;
    }
    b4() {
        return this.bz;
    }
    b3() {
        return this.by;
    }
    o() {
        return this.k;
    }
    c() {
        return this.a;
    }
    d() {
        return this.b;
    }
    r() {
        return this.n;
    }
    b6() {
        return this.b1;
    }
    q() {
        return this.m;
    }
    b5() {
        return this.b0;
    }
    ce() {
        return this.ca;
    }
    cf() {
        return this.cb;
    }
    bo() {
        this.ae.startCSSQuery();
        this.bq();
        this.bp();
        this.bs();
        this.br();
        this.bw();
        this.ae.endCSSQuery();
    }
    bw() {
        let a = "ui-chart-pointer-tooltip";
        let b = this.ae.getCssDefaultPropertyValue(a, "background-color");
        let c = this.ae.getCssDefaultPropertyValue(a, "border-top-color");
        let d = this.ae.getCssDefaultPropertyValue(a, "border-top-left-radius");
        let e = this.ae.getCssDefaultPropertyValue(a, "border-top-width");
        let f = new PointerTooltipStyle();
        f.a = d != null ? parseFloat(d) : 0;
        f.c = b != null ? Brush.create(b) : ((() => {
            let $ret = new Brush();
            $ret.fill = "white";
            return $ret;
        })());
        f.d = c != null ? Brush.create(c) : ((() => {
            let $ret = new Brush();
            $ret.fill = "gray";
            return $ret;
        })());
        f.b = e != null ? parseFloat(e) : 0;
        this.h = f;
    }
    bq() {
        let a = "ui-chart-title";
        this.l = FontUtil.getFontForClass(this.ae, a);
        this.bz = ((() => {
            let $ret = new Brush();
            $ret.fill = this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        this.aq = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (this.aq == null) {
            this.aq = "center";
        }
        let b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        let c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        let d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        let e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        let f = b != null ? parseFloat(b) : 0;
        let g = c != null ? parseFloat(c) : 0;
        let h = d != null ? parseFloat(d) : 0;
        let i = e != null ? parseFloat(e) : 0;
        this.b9 = new Thickness(1, h, f, i, g);
    }
    bp() {
        let a = "ui-chart-subtitle";
        this.k = FontUtil.getFontForClass(this.ae, a);
        this.by = ((() => {
            let $ret = new Brush();
            $ret.fill = this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        this.ap = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (this.ap == null) {
            this.ap = "center";
        }
        let b = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        let c = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        let d = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        let e = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        let f = b != null ? parseFloat(b) : 0;
        let g = c != null ? parseFloat(c) : 0;
        let h = d != null ? parseFloat(d) : 0;
        let i = e != null ? parseFloat(e) : 0;
        this.b8 = new Thickness(1, h, f, i, g);
    }
    br() {
        let a = "ui-chart-horizontal-axis-title";
        this.m = FontUtil.getFontForClass(this.ae, a);
        this.b0 = ((() => {
            let $ret = new Brush();
            $ret.fill = this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        let b = this.ae.getCssDefaultPropertyValue(a, "vertical-align");
        if (b == null) {
            this.a = 0;
        }
        else if (b.toLowerCase() == "bottom") {
            this.a = 4;
        }
        else {
            this.a = 3;
        }
        let c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        let d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        let e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        let f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        let g = c != null ? parseFloat(c) : 2;
        let h = d != null ? parseFloat(d) : 2;
        let i = e != null ? parseFloat(e) : 2;
        let j = f != null ? parseFloat(f) : 2;
        this.ca = new Thickness(1, i, g, j, h);
    }
    bs() {
        let a = "ui-chart-vertical-axis-title";
        this.n = FontUtil.getFontForClass(this.ae, a);
        this.b1 = ((() => {
            let $ret = new Brush();
            $ret.fill = this.ae.getCssDefaultPropertyValue(a, "color");
            return $ret;
        })());
        let b = this.ae.getCssDefaultPropertyValue(a, "text-align");
        if (b == null) {
            this.b = 0;
        }
        else if (b.toLowerCase() == "right") {
            this.b = 2;
        }
        else {
            this.b = 1;
        }
        let c = this.ae.getCssDefaultPropertyValue(a, "margin-top");
        let d = this.ae.getCssDefaultPropertyValue(a, "margin-bottom");
        let e = this.ae.getCssDefaultPropertyValue(a, "margin-left");
        let f = this.ae.getCssDefaultPropertyValue(a, "margin-right");
        let g = c != null ? parseFloat(c) : 0;
        let h = d != null ? parseFloat(d) : 0;
        let i = e != null ? parseFloat(e) : 0;
        let j = f != null ? parseFloat(f) : 0;
        this.cb = new Thickness(1, i, g, j, h);
    }
    a5(a, b) {
        let c = this.j.n.ey;
        if (a != this.ab || b != this.aa || c != this.ac) {
            this.ay(a, b, this.j.n.ey);
            this.j.n.ah.i();
            this.j.a.i();
        }
    }
    i() {
        return this.h;
    }
    ba(a) {
        if (this.f == null) {
            return;
        }
        this.f.aa = a;
        this.f.am = runOn(this.j, this.j.ar);
    }
    an(a, b, c) {
        let d;
        if (!((() => { let e = this.z.tryGetValue(b.iD.toString(), d); d = e.p1; return e.ret; })())) {
            let e = this.ae.createElement("canvas");
            e.setAttribute("width", c.toString());
            e.setAttribute("height", c.toString());
            e.setStyleProperty("width", c.toString() + "px");
            e.setStyleProperty("height", c.toString() + "px");
            let f = this.ae.get2DCanvasContext(e);
            let g = new RenderingContext(new CanvasViewRenderer(), f);
            let h = new Tuple$2(DomWrapper_$type, RenderingContext.$, e, g);
            d = h;
            this.z.addItem(b.iD.toString(), d);
        }
        let i = new Rect(0, 0, 0, c, c);
        let j = new RenderSurface();
        j.a = d.d;
        for (let k = 0; k < this.j.n.series.count; k++) {
            let l = this.j.n.series._inner[k];
            l.jk(i, a, j, "tile", 1);
        }
        this.j.n.ag.i();
        return d.c;
    }
    a2(a) {
        this.z.removeItem(a.iD.toString());
    }
    a1() {
        this.z.clear();
    }
    bk(a) {
        for (let b = 0; b < a.count; b++) {
            let c = a._inner[b];
            let d = c.content;
            this.j.x.m(d.getNativeElement(), 1, c.xPosition + this.j.n.oh.left, c.yPosition + this.j.n.oh.top, c.width, c.height);
        }
    }
    az() {
        if (this.al != -1) {
            this.av();
        }
        if (this.ae != null) {
            this.al = this.ae.setTimeout(() => this.j.n.a1.f$i(this.j.n), 5000);
        }
        else {
            this.al = window.setTimeout(() => this.j.n.a1.f$i(this.j.n), 5000);
        }
    }
    av() {
        if (this.al != -1) {
            if (this.ae != null) {
                this.ae.clearTimeout(this.al);
            }
            else {
                window.clearTimeout(this.al);
            }
            this.al = -1;
        }
    }
    a0(a) {
        if (this.am != -1) {
            this.aw();
        }
        if (this.ae != null) {
            this.ae.setTimeout(() => this.j.n.ii(), a);
        }
        else {
            this.am = window.setTimeout(() => this.j.n.ii(), a);
        }
    }
    aw() {
        if (this.am != -1) {
            if (this.ae != null) {
                this.ae.clearTimeout(this.am);
            }
            else {
                window.clearTimeout(this.am);
            }
            this.am = -1;
        }
    }
    bd() {
        if (this.j.n.ao != 1) {
            if (this.s == null) {
                this.u = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
                this.s = this.u;
            }
            else {
                this.u = this.s;
            }
        }
        else {
            this.u = new RenderingContext(null, null);
        }
        this.j.dm(this.u);
    }
    bv(a) {
        if (this.ae != null) {
            let b = "igTouch";
            if (a) {
                this.ae.rootWrapper.addClass(b);
            }
            else {
                this.ae.rootWrapper.removeClass(b);
            }
        }
    }
    a3() {
    }
    a4() {
    }
    bg() {
        if (this.f != null) {
            this.f.bc(this.aj, "");
        }
    }
    be() {
        this.a9();
        if (this.f != null) {
            this.f.aq(this.aj, "");
        }
    }
    ao(a, b) {
        let c = this.ae.createElement("canvas");
        c.setStyleProperty("width", a + "px");
        c.setStyleProperty("height", b + "px");
        c.setProperty("width", a);
        c.setProperty("height", b);
        let d = this.ae.get2DCanvasContext(c);
        if (this.t != null) {
            d.drawImage(this.af.getNativeElement(), 0, 0, a, b);
        }
        if (this.v != null) {
            d.drawImage(this.ai.getNativeElement(), 0, 0, a, b);
        }
        if (this.w != null) {
            d.drawImage(this.aj.getNativeElement(), 0, 0, a, b);
        }
        let e = this.ae.createElement("img");
        let sCanv_ = c.getNativeElement();
        e.setProperty("src", sCanv_.toDataURL('image/png'));
        return e.getNativeElement();
    }
}
SeriesViewerViewManager.$t = markType(SeriesViewerViewManager, 'SeriesViewerViewManager');
/**
 * @hidden
 */
class AutoRangeCalculator extends Base {
    static a(a, b, c, d, e, f, g) {
        f = !isNaN_(b) && !isInfinity(b) ? b : Number.POSITIVE_INFINITY;
        g = !isNaN_(c) && !isInfinity(c) ? c : Number.NEGATIVE_INFINITY;
        let h = f;
        let i = g;
        if (isInfinity(h) || isInfinity(i)) {
            if (a != null) {
                let j = a.jj();
                if (j != null) {
                    h = Math.min(h, j.c);
                    i = Math.max(i, j.b);
                }
            }
        }
        if (!isInfinity(h) && !isInfinity(i)) {
            if (h == i && h != 0) {
                h *= h > 0 ? 0.9 : 1.1;
                i *= i > 0 ? 1.1 : 0.9;
            }
            if (h == i && h == 0) {
                i = 1;
            }
            if (b > c) {
                let k = c;
                c = b;
                b = k;
            }
            let l = isNaN_(b) || isInfinity(b) ? h : b;
            let m = isNaN_(c) || isInfinity(c) ? i : c;
            if (d) {
                if (l <= 0) {
                    if (m > 1) {
                        l = 1;
                    }
                    else {
                        l = Math.pow(e, Math.floor(logBase(m, e)));
                    }
                }
                if (isNaN_(b) || isInfinity(b)) {
                    let n = logBase(l, e);
                    h = Math.pow(e, Math.floor(n));
                }
                else {
                    h = l;
                }
                if (isNaN_(c) || isInfinity(c)) {
                    i = Math.pow(e, Math.ceil(logBase(m, e)));
                }
                else {
                    i = m;
                }
            }
            else {
                let o = Math.pow(10, Math.floor(log10(m - l)) - 1);
                let p = a.dx();
                if (a != null && p > 0 && (!a.j0 && !a.jz)) {
                    let q = new LinearNumericSnapper(0, h, i, p, a.eb());
                    o = q.g;
                }
                if ((isNaN_(b) || isInfinity(b)) && !isNaN_(h) && !isNaN_(o) && o != 0) {
                    {
                        h = o * Math.floor(h / o);
                    }
                }
                else {
                    h = l;
                }
                if ((isNaN_(c) || isInfinity(c)) && !isNaN_(i) && !isNaN_(o) && o != 0) {
                    let r = Math.ceil(i / o);
                    {
                        i = o * r;
                    }
                }
                else {
                    i = m;
                }
            }
        }
        f = h;
        g = i;
        return {
            p5: f,
            p6: g
        };
    }
}
AutoRangeCalculator.$t = markType(AutoRangeCalculator, 'AutoRangeCalculator');
/**
 * @hidden
 */
let IAxisAnnotationManager_$type = new Type(null, 'IAxisAnnotationManager');
/**
 * @hidden
 */
class AxisLabelSettings extends Base {
    constructor() {
        super();
        this.aa = null;
        this.ax = null;
        this.b = 1;
        this.a2 = 0;
        this.h = true;
        this.c = 0;
        this.a = null;
        this.m = 0;
        this.o = NaN;
        this.p = 2;
        this.q = 2;
        this.r = 2;
        this.n = 2;
        this.au = 0;
        this.az = 1;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.f = null;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.aq(a, b.propertyName, b.oldValue, b.newValue));
    }
    get textStyle() {
        return this.aa;
    }
    set textStyle(a) {
        let b = this.aa;
        this.aa = a;
        this.ar("TextStyle", b, a);
    }
    get textColor() {
        return this.ax;
    }
    set textColor(a) {
        let b = this.ax;
        this.ax = a;
        this.ar("TextColor", b, a);
    }
    get location() {
        return this.b;
    }
    set location(a) {
        let b = this.b;
        this.b = a;
        this.ar("Location", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, a));
    }
    get visibility() {
        return this.a2;
    }
    set visibility(a) {
        let b = this.a2;
        this.a2 = a;
        this.ar("Visibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, a));
    }
    get showFirstLabel() {
        return this.h;
    }
    set showFirstLabel(a) {
        let b = this.h;
        this.h = a;
        this.ar("ShowFirstLabel", b, a);
    }
    registerAxis(a) {
        this.a = a;
    }
    unregisterAxis(a) {
        this.a = null;
    }
    get angle() {
        return this.m;
    }
    set angle(a) {
        let b = this.m;
        this.m = a;
        this.ar("Angle", b, a);
    }
    get extent() {
        return this.o;
    }
    set extent(a) {
        let b = this.o;
        this.o = a;
        this.ar("Extent", b, a);
    }
    set margin(a) {
        this.leftMargin = a;
        this.bottomMargin = a;
        this.rightMargin = a;
        this.topMargin = a;
    }
    get leftMargin() {
        return this.p;
    }
    set leftMargin(a) {
        let b = this.p;
        this.p = a;
        this.ar("LeftMargin", b, a);
    }
    get rightMargin() {
        return this.q;
    }
    set rightMargin(a) {
        let b = this.q;
        this.q = a;
        this.ar("RightMargin", b, a);
    }
    get topMargin() {
        return this.r;
    }
    set topMargin(a) {
        let b = this.r;
        this.r = a;
        this.ar("TopMargin", b, a);
    }
    get bottomMargin() {
        return this.n;
    }
    set bottomMargin(a) {
        let b = this.n;
        this.n = a;
        this.ar("BottomMargin", b, a);
    }
    get horizontalAlignment() {
        return this.au;
    }
    set horizontalAlignment(a) {
        let b = this.au;
        this.au = a;
        this.ar("HorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
    }
    get verticalAlignment() {
        return this.az;
    }
    set verticalAlignment(a) {
        let b = this.az;
        this.az = a;
        this.ar("VerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
    }
    ar(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    aq(a, b, c, d) {
        switch (b) {
            case "Location":
                this.c = this.location;
                break;
        }
        if (this.a == null || this.a.bf == null) {
            return;
        }
        switch (b) {
            case "Angle":
                this.a.ci = true;
                this.a.ha();
                break;
            case "TextStyle":
                this.f = null;
                this.a.ci = true;
                if (this.a.bh != null) {
                    this.a.bh.it();
                }
                this.a.ha();
                break;
            case "Location":
            case "Extent":
            case "Visibility":
            case "HorizontalAlignment":
            case "VerticalAlignment":
            case "TopMargin":
            case "RightMargin":
            case "BottomMargin":
            case "LeftMargin":
            case "ShowFirstLabel":
                this.a.ci = true;
                if (this.a.bh != null) {
                    this.a.bh.it();
                }
                this.a.ha();
                break;
            case "TextColor":
                this.a.ha();
                break;
        }
    }
    j() {
        return this.m != 0;
    }
    k() {
        return !isNaN_(this.o);
    }
    get i() {
        return this.textStyle != null;
    }
    g(a) {
        if (this.f == null) {
            this.f = FontUtil.toFontInfo(a, this.textStyle);
        }
        return this.f;
    }
}
AxisLabelSettings.$t = markType(AxisLabelSettings, 'AxisLabelSettings', Base.$, [INotifyPropertyChanged_$type]);
AxisLabelSettings.extentPropertyDefault = NaN;
/**
 * @hidden
 */
class TitleSettings extends AxisLabelSettings {
    constructor() {
        super();
        this.a4 = 0;
        this.horizontalAlignment = 1;
        this.leftMargin = NaN;
        this.rightMargin = NaN;
        this.topMargin = NaN;
        this.bottomMargin = NaN;
    }
    get position() {
        return this.a4;
    }
    set position(a) {
        let b = this.a4;
        this.a4 = a;
        this.ar("AxisTitlePosition", enumGetBox(AxisTitlePosition_$type, b), enumGetBox(AxisTitlePosition_$type, a));
    }
    aq(a, b, c, d) {
        super.aq(a, b, c, d);
        if (this.a == null || this.a.bh == null) {
            return;
        }
        switch (b) {
            case "AxisTitlePosition":
                this.a.ci = true;
                this.a.ha();
                break;
        }
    }
}
TitleSettings.$t = markType(TitleSettings, 'TitleSettings', AxisLabelSettings.$);
/**
 * @hidden
 */
class Axis extends Control {
    constructor() {
        super();
        this.a4 = null;
        this.bs = null;
        this.a8 = null;
        this.a6 = null;
        this.hp = null;
        this.bm = null;
        this.bg = null;
        this.br = null;
        this.bw = false;
        this.c5 = NaN;
        this.c0 = 50;
        this.db = 0;
        this.c8 = 150;
        this.ar = 0;
        this.c4 = NaN;
        this.df = 0;
        this.da = 0;
        this.c7 = 180;
        this.bj = null;
        this.bi = null;
        this.fc = "Verdana";
        this.c6 = NaN;
        this.dh = 0;
        this.dc = 8;
        this.c9 = 16;
        this.ex = -1;
        this.ew = 1;
        this.ev = 3;
        this.ey = 0;
        this.jf = 0;
        this.de = 0;
        this.dd = 2;
        this.hq = null;
        this.di = 0;
        this.cb = false;
        this.rangeChanged = null;
        this.ak = new AxisAnnotationCollection();
        this.al = new AxisAnnotationCollection();
        this.i2 = Rect.empty;
        this.i8 = null;
        this.cx = null;
        this.cy = null;
        this.av = null;
        this.bv = false;
        this.a5 = null;
        this.eu = null;
        this.ah = null;
        this._coercionMethods = null;
        this.bu = false;
        this.cl = false;
        this.cs = false;
        this.renderRequested = null;
        this.bb = null;
        this.c2 = NaN;
        this.c3 = -1;
        this.cj = false;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.cz = null;
        this.cv = new Dictionary$2(String_$type, String_$type, 0);
        this.cu = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
        this.je = new Size();
        this.ao = new AxisComponentsForView();
        this.dk = 0;
        this.c1 = 0;
        this.bq = null;
        this.bp = null;
        this.bo = null;
        this.aw = new AxisLabelSettings();
        this.et = null;
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        this.dk = NaN;
        this.a4 = this.a3();
        this.gx(this.a4);
        this.a4.ag();
        this.bq = ((() => {
            let $ret = new Pool$1(TextBlock.$);
            $ret.create = runOn(this.a4, this.a4.ax);
            $ret.activate = runOn(this.a4, this.a4.aq);
            $ret.disactivate = runOn(this.a4, this.a4.as);
            $ret.destroy = runOn(this.a4, this.a4.ar);
            return $ret;
        })());
        this.bp = ((() => {
            let $ret = new Pool$1(TextBlock.$);
            $ret.create = runOn(this.a4, this.a4.ax);
            $ret.activate = runOn(this.a4, this.a4.aq);
            $ret.disactivate = runOn(this.a4, this.a4.as);
            $ret.destroy = runOn(this.a4, this.a4.ar);
            return $ret;
        })());
        this.bo = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this.a4, this.a4.bc);
            $ret.activate = runOn(this.a4, this.a4.p);
            $ret.disactivate = runOn(this.a4, this.a4.r);
            $ret.destroy = runOn(this.a4, this.a4.q);
            return $ret;
        })());
        this.i8 = Rect.empty;
        this.cx = new List$1(Base.$, 0);
        this.cy = new List$1(LabelPosition.$, 0);
        this.av = this.au();
        this.av.af = this.ay;
        this.av.ac = this;
        this.cz = new List$1(Series.$, 0);
        let a = this.ak;
        a.collectionResetting = delegateCombine(a.collectionResetting, runOn(this, this.gh));
        let b = this.ak;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.gg));
        let c = this.al;
        c.collectionResetting = delegateCombine(c.collectionResetting, runOn(this, this.gj));
        let d = this.al;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.gi));
        this.ab = Axis.$;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (e, f) => this.gz(e, f.propertyName, f.oldValue, f.newValue));
        this.br = (e, f) => {
            if (this.bh == null || !this.bh.c7) {
                this.ho(f.oldRect, f.newRect);
            }
        };
        this.a4.v();
    }
    a3() {
        return new AxisView(this);
    }
    gx(a) {
    }
    gk() {
        if (this.b3) {
            this.a7.onAddAnnotations(this);
        }
    }
    get bt() {
        if (this.bs == null) {
            this.bs = new SRProvider(this.eu);
        }
        if (this.bs.l == null) {
            this.bs.l = this.eu;
        }
        return this.bs;
    }
    get a9() {
        if (this.a8 == null) {
            this.a8 = DVContainer.instance.createInstance(IAxisVisualDataManager_$type, () => this.bt.q);
        }
        return this.a8;
    }
    dx() {
        return this.i9.width;
    }
    fb() {
        return null;
    }
    fa() {
        return null;
    }
    get_b4() {
        return false;
    }
    get b4() {
        return this.get_b4();
    }
    get_cc() {
        return false;
    }
    get cc() {
        return this.get_cc();
    }
    get_b2() {
        return false;
    }
    get b2() {
        return this.get_b2();
    }
    get_ce() {
        return false;
    }
    get ce() {
        return this.get_ce();
    }
    get_ch() {
        return false;
    }
    get ch() {
        return this.get_ch();
    }
    get_cf() {
        return false;
    }
    get cf() {
        return this.get_cf();
    }
    get_b7() {
        return false;
    }
    get b7() {
        return this.get_b7();
    }
    get_cd() {
        return false;
    }
    get cd() {
        return this.get_cd();
    }
    get_b5() {
        return false;
    }
    get b5() {
        return this.get_b5();
    }
    get_b6() {
        return true;
    }
    get b6() {
        return this.get_b6();
    }
    aj() {
        return this.ai;
    }
    get a7() {
        if (this.a6 == null) {
            this.a6 = DVContainer.instance.createInstance(IAxisAnnotationManager_$type, () => this.bt.n);
            this.a6.owner = this;
        }
        return this.a6;
    }
    get b3() {
        return DVContainer.instance.checkLoaded("AnnotationFactoryManager");
    }
    gi(a, b) {
        if (!this.b3) {
            return;
        }
        this.a7.onAutoAnnotionsChanged(this, this.al, b);
    }
    gj(a, b) {
        if (!this.b3) {
            return;
        }
        this.a7.onAutoAnnotionsReset(this, this.al, b);
    }
    gg(a, b) {
        if (!this.b3) {
            return;
        }
        this.a7.onAnnotionsChanged(this, this.ak, b);
    }
    gh(a, b) {
        if (!this.b3) {
            return;
        }
        this.a7.onAnnotionsReset(this, this.ak, b);
    }
    provideRenderer(a) {
        this.eu = a;
        this.gl();
        this.av.af = this.ay;
    }
    gu(a, b) {
        if (!a.equals1(b)) {
            this.hn(a, b);
        }
    }
    ac() {
        super.ac();
        this.a4.aj();
    }
    get bn() {
        return this.bm;
    }
    set bn(a) {
        if (this.bn != a) {
            let b = this.bn;
            this.bm = a;
            this.g5("FastItemsSourceProvider", b, this.bm);
        }
    }
    get bh() {
        return this.bg;
    }
    set bh(a) {
        if (this.bh != a) {
            let b = this.bh;
            this.bg = a;
            this.g5("SeriesViewer", b, this.bg);
        }
    }
    get bf() {
        return typeCast(XamDataChart.$, this.bh);
    }
    set bf(a) {
        this.bh = a;
    }
    get cr() {
        return this.bw;
    }
    set cr(a) {
        if (this.bw == a) {
            return;
        }
        this.bw = a;
        let b = null;
        if (this.av != null && Rect.l_op_Inequality(this.av.co, null)) {
            b = this.av.co;
        }
        this.av = this.au();
        this.av.ac = this;
        this.av.af = this.ay;
        if (Rect.l_op_Inequality(b, null)) {
            this.av.co = b;
        }
        if (this.bh != null && this.bh.b1 != null) {
            this.av.ae.ak(this.bh.b1.w);
            this.g9(true);
        }
    }
    get ef() {
        return this.c5;
    }
    set ef(a) {
        let b = this.c5;
        if (b != a) {
            this.c5 = a;
            this.dg = a;
            this.g9(true);
        }
    }
    get dg() {
        return this.c0;
    }
    set dg(a) {
        this.c0 = a;
    }
    get el() {
        return this.db;
    }
    set el(a) {
        this.db = a;
        this.g9(true);
    }
    get ei() {
        return this.c8;
    }
    set ei(a) {
        this.c8 = a;
        this.g9(true);
    }
    get as() {
        return this.ar;
    }
    set as(a) {
        let b = this.ar;
        if (b != a) {
            this.ar = a;
            this.g9(true);
        }
    }
    get ee() {
        return this.c4;
    }
    set ee(a) {
        this.c4 = a;
        this.g8();
    }
    get ek() {
        return this.da;
    }
    set ek(a) {
        this.da = a;
        this.g8();
    }
    get eh() {
        return this.c7;
    }
    set eh(a) {
        this.c7 = a;
        this.g8();
    }
    get bl() {
        if (this.bj == null) {
            if (this.bi == null) {
                this.bi = this.a4.i();
            }
            return this.bi;
        }
        return this.bj;
    }
    set bl(a) {
        this.bj = a;
        this.c6 = FontUtil.getFontSize(this.bj);
        this.g8();
    }
    get f3() {
        return this.fc;
    }
    set f3(a) {
        this.fc = a;
        let b = this.c6;
        if (isNaN_(b)) {
            b = 12;
        }
        this.bl.n = a;
        this.bl.d = b;
        this.av.b0();
        this.g8();
    }
    get eg() {
        return this.c6;
    }
    set eg(a) {
        this.c6 = a;
        this.bl = FontUtil.getFontWithNewFontSize(this.bl, this.c6);
        this.g8();
    }
    get em() {
        return this.dc;
    }
    set em(a) {
        this.dc = a;
        this.g8();
    }
    get ej() {
        return this.c9;
    }
    set ej(a) {
        this.c9 = a;
        this.g8();
    }
    get e2() {
        return this.ex;
    }
    set e2(a) {
        this.ex = a;
        this.g8();
    }
    get e1() {
        return this.ew;
    }
    set e1(a) {
        this.ew = a;
        this.g8();
    }
    get e0() {
        return this.ev;
    }
    set e0(a) {
        this.ev = a;
        this.g8();
    }
    get ji() {
        return this.jf;
    }
    set ji(a) {
        this.jf = a;
        this.g8();
    }
    get eo() {
        return this.de;
    }
    set eo(a) {
        this.de = a;
        this.g8();
    }
    get en() {
        return this.dd;
    }
    set en(a) {
        this.dd = a;
        this.g8();
    }
    hh() {
        this.av.cf();
    }
    g8() {
        this.g9(false);
    }
    g9(a) {
        if (a) {
            this.av.ce();
        }
        this.ci = true;
        this.g7();
    }
    hj() {
        if (this.eq > 0) {
            this.di = this.eq;
            return;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null && isNaN_(this.eq) && this.b4 && (this.ch || this.a1 == 0)) {
            this.di = a.oy.fi;
            return;
        }
        this.di = 0;
    }
    get cq() {
        return this.c(Axis.il);
    }
    set cq(a) {
        this.h(Axis.il, a);
    }
    dm() {
        return 0;
    }
    im() {
        if (this.ch) {
            return 2;
        }
        return 0;
    }
    jg() {
        return 1;
    }
    io() {
        return 1;
    }
    jh() {
        return 1;
    }
    dp() {
        if (this.ch) {
            return DeviceUtils.g(5);
        }
        return 0;
    }
    dr() {
        if (!this.ch && !this.b2) {
            return DeviceUtils.g(5);
        }
        return 0;
    }
    dq() {
        if (this.ch) {
            return DeviceUtils.g(5);
        }
        return 0;
    }
    dn() {
        if (!this.ch && !this.b2) {
            return DeviceUtils.g(5);
        }
        return 0;
    }
    du() {
        return NaN;
    }
    dw() {
        return NaN;
    }
    dv() {
        return NaN;
    }
    dt() {
        return NaN;
    }
    az() {
        if (this.ch) {
            return 2;
        }
        if (this.ce) {
            return 5;
        }
        return 1;
    }
    a0() {
        return 1;
    }
    g6(a) {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, a);
        }
    }
    ds() {
        if (this.ch) {
            return -90;
        }
        return 0;
    }
    dl() {
        return NaN;
    }
    get am() {
        return this.ak;
    }
    get an() {
        return this.al;
    }
    get i9() {
        if (this.i8.isEmpty) {
            return this.i2;
        }
        return this.i8;
    }
    set i9(a) {
        this.i2 = a;
    }
    hk() {
        let a = 0;
        let b = typeCast(XamDataChart.$, this.bh);
        if (b != null && b.ov == 0) {
            a = 1;
        }
        this.a4.av(a);
    }
    ct(a, b, c) {
        return this.bh != null;
    }
    cg() {
        let a = Rect.empty;
        if (this.bh != null) {
            a = this.bh.oi;
        }
        return this.ct(this.i9, a, this.a4);
    }
    hn(a, b) {
        this.i9 = b;
        this.ci = true;
        this.cn();
        this.hb(false);
        if (this.bh != null) {
            this.bh.al.ad(1, this, this.a5, b);
        }
    }
    get ci() {
        return this.bv;
    }
    set ci(a) {
        this.bv = a;
    }
    i6() {
        if (this.bh == null || this.bh.n6.isEmpty) {
            return Rect.empty;
        }
        let a = this.bh.n6;
        let b = this.i9;
        let c = (a.left - b.left) / b.width;
        let d = (a.top - b.top) / b.height;
        let e = (a.right - b.left) / b.width;
        let f = (a.bottom - b.top) / b.height;
        return new Rect(0, c, d, e - c, f - d);
    }
    ho(a, b) {
        this.ci = true;
        this.hb(true);
    }
    g7() {
        this.hb(false);
    }
    gz(a, b, c, d) {
        switch (b) {
            case Axis.$$p[9]:
            case Axis.$$p[10]:
                if (this.fo != null) {
                    this.ah = new BindingFormatter();
                    this.ah.j = this.fo;
                    this.ah.d = this.ag;
                }
                else {
                    this.ah = null;
                }
                break;
            case "SeriesViewer":
                let e = typeCast(SeriesViewer.$, c);
                if (e != null) {
                    this.eu = null;
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, this.br);
                    e.al.ac(1, this);
                    this.a4.aa(e);
                }
                let f = typeCast(SeriesViewer.$, d);
                if (f != null) {
                    this.eu = f.b1.i.ae;
                    f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, this.br);
                    this.a5 = f.al.k(1, this, runOn(this, this.gp));
                    if (this.ay == null && this.eu != null) {
                        this.provideRenderer(this.eu);
                    }
                    this.a4.u(f);
                    if (this.cj && !this.a5.e) {
                        this.cj = false;
                        this.cn();
                    }
                    this.hi();
                    this.hj();
                }
                break;
            case Axis.$$p[7]:
                this.hb(false);
                break;
            case Axis.$$p[8]:
                this.cb = this.ca;
                let g = new AxisRangeChangedEventArgs(0, 0, 0, 1, 1);
                this.go(g);
                for (let h of fromEnum(this.cz)) {
                    h.ik();
                    if (h.bs != null) {
                        h.it();
                    }
                }
                break;
            case Axis.$$p[11]:
                this.a4.ah();
                if (typeCast(DataTemplate.$, d) !== null) {
                    this.cs = true;
                }
                else {
                    this.cs = false;
                }
                this.ci = true;
                this.he();
                this.hb(false);
                break;
            case Axis.$$p[15]:
            case Axis.$$p[18]:
            case Axis.$$p[22]:
                this.hb(false);
                break;
            case Axis.$$p[12]:
                let i = typeCast(AxisLabelSettings.$, d);
                if (i != null) {
                    i.registerAxis(this);
                    this.aw = i;
                }
                else {
                    this.aw = new AxisLabelSettings();
                }
                if (this.av != null) {
                    this.av.af = this.aw;
                }
                if (this.a4.m()) {
                    this.a4.w(this.aw);
                }
                this.ci = true;
                this.hb(false);
                break;
            case Axis.$$p[27]:
                this.a4.ak();
                break;
            case Axis.$$p[28]:
                let j = typeCast(TitleSettings.$, d);
                if (j != null) {
                    j.registerAxis(this);
                }
                else {
                    j = new TitleSettings();
                }
                if (this.hq != null) {
                    this.hq.dataContext = j;
                }
                this.a4.ak();
                this.hb(false);
                break;
            case Axis.$$p[23]:
                this.ci = true;
                this.hj();
                this.a4.ad();
                this.hb(false);
                break;
            case Axis.$$p[5]:
            case "UseEnhancedIntervalManagement":
                this.ci = true;
                this.hb(false);
                break;
            case Axis.$$p[3]:
                if (this.bh != null) {
                    this.bh.it();
                }
                break;
            case Axis.$$p[17]:
                this.hi();
                if (d != null) {
                    this.cl = true;
                    this.hb(false);
                }
                else {
                    this.cl = false;
                }
                break;
            case Axis.$$p[4]:
                if (this.ai != null) {
                    this.ai.ha();
                }
                break;
            case Axis.$$p[21]:
            case Axis.$$p[14]:
                this.hi();
                this.hb(false);
                break;
            case Axis.$$p[20]:
            case Axis.$$p[13]:
            case Axis.$$p[16]:
            case Axis.$$p[6]:
            case Axis.$$p[25]:
            case Axis.$$p[26]:
            case Axis.$$p[24]:
            case Axis.$$p[2]:
            case Axis.$$p[0]:
            case Axis.$$p[1]:
            case Axis.$$p[19]:
                this.hb(false);
                break;
            case "MinExtent":
                this.a4.ad();
                break;
        }
    }
    get coercionMethods() {
        return this._coercionMethods;
    }
    set coercionMethods(a) {
        this._coercionMethods = a;
    }
    get_expectFunctions() {
        return this.bu;
    }
    set_expectFunctions(a) {
        this.bu = a;
    }
    get expectFunctions() {
        return this.get_expectFunctions();
    }
    set expectFunctions(a) {
        this.set_expectFunctions(a);
    }
    he() {
        this.bq.count = 0;
        this.bp.count = 0;
        this.bo.count = 0;
        if (this.a4.m()) {
            this.a4.an();
        }
    }
    gw(a, b, c, d) {
        let e = Math.min(b, c);
        let f = Math.max(b, c);
        if (e < d.bottom && f > d.top) {
            let g = new RectangleGeometry();
            g.e = new Rect(0, d.left, e, d.width, f - e);
            a.add(g);
        }
    }
    gv(a, b, c, d, e) {
        let f = b <= c.bottom && b >= c.top;
        if (!e && f) {
            f = !this.b9(b, d.c, c, false);
        }
        if (f) {
            if (d.a) {
                b = this.dj(b, c.top, c.bottom, d);
            }
            let g = new LineGeometry();
            g.d = { $type: Point_$type, x: c.left, y: b };
            g.c = { $type: Point_$type, x: c.right, y: b };
            a.add(g);
        }
    }
    hm(a, b, c, d) {
        let e = Math.min(b, c);
        let f = Math.max(b, c);
        if (f > d.left && e < d.right) {
            let g = new RectangleGeometry();
            g.e = new Rect(0, e, d.top, f - e, d.height);
            a.add(g);
        }
    }
    hl(a, b, c, d, e) {
        let f = b >= c.left && b <= c.right;
        if (!f) {
            let g = truncate(Math.round(b));
            let h = truncate(Math.round(c.left));
            let i = truncate(Math.round(c.right));
            if (g >= h && g <= i) {
                f = true;
            }
        }
        if (!e && f) {
            f = !this.b9(b, d.c, c, true);
        }
        if (f) {
            if (d.a) {
                b = this.dj(b, c.left, c.right, d);
            }
            let j = new LineGeometry();
            j.d = { $type: Point_$type, x: b, y: c.top };
            j.c = { $type: Point_$type, x: b, y: c.bottom };
            a.add(j);
        }
    }
    b9(a, b, c, d) {
        let e = false;
        let f = typeCast(XamDataChart.$, this.bh);
        if (f != null && f.pb && !c.isEmpty) {
            for (let g of fromEnum(f.axes)) {
                if (g._visibility != 0 || g.ep < 1 || g.ir == null || BrushUtilCore.a(g.ir) || g.i9.isEmpty) {
                    continue;
                }
                if (g.ai != null && g.b0()) {
                    let h = this.ch ? c.left : c.top;
                    let i = 0;
                    let j = g.hg(h, i, g.bh.oi, c, g.i4(), d ? c.left : c.top, d ? c.right : c.bottom);
                    h = j.p0;
                    i = j.p1;
                    let k = Rect.empty;
                    let l = Rect.empty;
                    if (d && g.ch) {
                        k = new Rect(0, h - (g.ep / 2), g.i9.top, g.ep, g.i9.height);
                        l = new Rect(0, a - (b / 2), c.top, b, c.height);
                    }
                    else if (!d && !g.ch) {
                        k = new Rect(0, g.i9.left, h - (g.ep / 2), g.i9.width, g.ep);
                        l = new Rect(0, c.left, a - (b / 2), c.width, b);
                    }
                    if (k.left <= l.right && l.left <= k.right && k.top <= l.bottom && l.top <= k.bottom) {
                        e = true;
                        break;
                    }
                }
                else {
                    let m = Rect.empty;
                    let n = Rect.empty;
                    if (d && g.ch) {
                        m = new Rect(0, g.i9.left, g.i9.top, g.ep, g.i9.height);
                        n = new Rect(0, a - (b / 2), c.top, b, c.height);
                    }
                    else if (!d && !g.ch) {
                        m = new Rect(0, g.i9.left, g.i9.bottom - (g.ep / 2), g.i9.width, g.ep);
                        n = new Rect(0, c.left, a - (b / 2), c.width, b);
                    }
                    if (m.left <= n.right && n.left <= m.right && m.top <= n.bottom && n.top <= m.bottom) {
                        e = true;
                        break;
                    }
                }
            }
        }
        return e;
    }
    hg(a, b, c, d, e, f, g) {
        let h = Math.abs(f - g);
        a = this.e4;
        a = this.ai.ed(a);
        let i = typeCast(CategoryAxisBase.$, this.ai);
        if (i != null && i.categoryMode == 2) {
            let j = 0.5 * i.getCategorySize(c, d, e);
            let k = i.a1 == 0;
            if (i.ca == k) {
                j = -j;
            }
            a = a + j;
        }
        b = a - f;
        if (a < f) {
            a = f;
        }
        else if (a > g) {
            a = g;
        }
        if (b < 0) {
            b = 0;
        }
        else if (b > h) {
            b = h;
        }
        return {
            p0: a,
            p1: b
        };
    }
    dj(a, b, c, d) {
        let e = a;
        if (d != null && d.c > 0) {
            let f = d.c % 2;
            if (f == 0 || f == 1) {
                let g = 1;
                e = Math.floor(a);
                if (e + 0.5 < a) {
                    g = -1;
                    e = Math.ceil(a);
                }
                if (f == 1) {
                    e += 0.5 * g;
                }
                if (e >= c) {
                    e -= 1;
                }
                else if (e <= b) {
                    e += 1;
                }
            }
        }
        return e;
    }
    gn(a) {
        this.a4.z(a);
    }
    gm() {
        this.bq.count = 0;
        this.bp.count = 0;
        this.bo.count = 0;
        this.a4.x();
        this.cx.clear();
        this.cy.clear();
    }
    ha() {
        this.hb(false);
    }
    hb(a) {
        if (this.bh != null) {
            this.bh.al.ab(1, this, this.a5, a);
            if (this.renderRequested != null) {
                let b = new RenderRequestedEventArgs();
                b.animate = a;
                this.renderRequested(this, b);
                a = b.animate;
            }
        }
    }
    ec() {
        if (this.bb == null) {
            return -1;
        }
        if (isNaN_(this.bb.a)) {
            return -1;
        }
        if (this.ay != null && (this.ay.angle != 0)) {
            return -1;
        }
        return Math.max(Axis.d7, this.bb.a);
    }
    ea() {
        if (this.bb == null) {
            return -1;
        }
        if (isNaN_(this.bb.c) && isNaN_(this.c2)) {
            return -1;
        }
        if (this.ay != null && (this.ay.angle != 0)) {
            return -1;
        }
        let a = this.bb.c;
        if (!isNaN_(this.c2) && this.ez == -1) {
            return this.c2;
        }
        return Math.max(Axis.d7, this.bb.c);
    }
    eb() {
        if (this.ch) {
            return this.ec();
        }
        else {
            return this.ea();
        }
    }
    get cm() {
        return this.ez == -1;
    }
    gp(a) {
        if (this.a4.l()) {
            return;
        }
        let b = 0;
        let c = 0;
        if (this.cy != null && this.cy.count > 0) {
            b = this.cy._inner[this.cy.count - 1].c;
            c = this.cy.count;
        }
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        this.hc(a);
        if (!this.ch && this.ci && this.cq && this.cm) {
            if (this.by()) {
                this.hc(a);
            }
        }
        let d = 1;
        let e = 0;
        if (this.cy != null && this.cy.count > 0) {
            d = this.cy._inner[this.cy.count - 1].c;
            e = this.cy.count;
        }
        if (this.cr) {
            this.ci = true;
        }
        let f = false;
        if (d != b || e != c || this.ci) {
            this.ci = false;
            if (this.a4.m()) {
                this.a4.ad();
                f = true;
            }
        }
        this.a4.ac();
        if (!f) {
            this.gq();
        }
    }
    by() {
        if (!isNaN_(this.c2) || this.cx == null || this.cx.count == 0) {
            return false;
        }
        let a = this.bk();
        if (a == null) {
            return false;
        }
        let b = -1.7976931348623157E+308;
        for (let c = 0; c < this.cx.count; c++) {
            let d = this.cx._inner[c];
            if (typeof d === 'string') {
                let e = FontUtil.measureStringWidth(d, a, this.a4.j);
                b = Math.max(e, b);
            }
        }
        b += 5;
        if (this.ay != null) {
            b += this.ay.leftMargin + this.ay.rightMargin;
        }
        this.c2 = b;
        return true;
    }
    hd() {
        this.c2 = NaN;
        this.hb(false);
    }
    hf() {
        this.c2 = NaN;
    }
    ba() {
        let a = this.bk();
        if (a == null) {
            return null;
        }
        let b = "W";
        let c = FontUtil.measureStringWidth(b, a, this.a4.j);
        if (this.c3 != c || this.bb == null) {
            this.c3 = c;
            let d = FontUtil.getCurrentFontHeight(this.bh.b1.i.ae, a);
            if (this.bb == null) {
                this.bb = new LabelFontHeuristics();
            }
            this.bb.a = d;
            this.bb.b = this.ez;
            this.bb.d = c;
            this.bb.c = this.bb.d * this.bb.b;
        }
        return this.bb;
    }
    bk() {
        let a = null;
        if (this.bh != null) {
            a = this.bh.getFontInfo();
        }
        if (this.ay != null && this.ay.i) {
            if (this.bh != null) {
                a = this.ay.g(this.bh.b1.i.ae);
            }
        }
        return a;
    }
    gq() {
        if (!this.a4.m()) {
            return;
        }
        if (!this.b1()) {
            this.a4.ab();
        }
    }
    cn() {
        return this.co(false);
    }
    co(a) {
        if (a || this.bh == null) {
            let b = this.cp();
            if (b) {
                this.ci = true;
            }
            this.cj = false;
            return b;
        }
        if (!this.cj) {
            this.cj = true;
            this.bh.al.aa(this, this.a5);
        }
        return false;
    }
    cp() {
        return false;
    }
    hc(a) {
        if (this.hq != null) {
            if ((this.be == null || this.be.visibility == 0) && (this.ay == null || this.ay.visibility == 0) && this.gc != null) {
                this.hq._visibility = 0;
            }
            else {
                this.hq._visibility = 1;
            }
        }
    }
    hi() {
        let a = typeCast(XamDataChart.$, this.bh);
        if (a == null) {
            return;
        }
        let b = null, c = null, d = null;
        if (this.b4 && !this.b2) {
            b = a.re;
            for (let e of fromEnum(this.cz)) {
                if (e.c4 || e.c2 || e.c0 || e.c2) {
                    c = a.rc;
                    d = a.rd;
                    break;
                }
            }
        }
        else if (this.cc && !this.b2) {
            c = a.rc;
            d = a.rd;
            b = this.ai != null ? a.re : null;
            for (let f of fromEnum(this.cz)) {
                if (f.c4 || f.c2 || f.c0 || f.c2) {
                    b = a.re;
                    break;
                }
            }
        }
        else if (this.b2 || this.a1 == 3) {
            b = a.re;
            c = a.rc;
            d = a.rd;
        }
        this.ir = this.iv != null ? this.iv : b;
        this.ip = this.is != null ? this.is : c;
        this.iq = this.it != null ? this.it : d;
    }
    g5(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    ck(a) {
        let b = this.cz.contains(a);
        if (!b) {
            this.cz.add(a);
        }
        this.hi();
        return !b;
    }
    bx(a) {
        let b = this.cz.contains(a);
        if (b) {
            this.cz.remove(a);
        }
        this.hi();
        return b;
    }
    e6(a, b) {
        let c = this.f0(b);
        if (c == Axis.$$p[11]) {
            return this.e7(a, b, this.e9);
        }
        return null;
    }
    f0(a) {
        if (!this.cv.containsKey(a)) {
            let b = a.charAt(0).toUpperCase() + a.substr(1);
            this.cv.addItem(a, b);
        }
        return this.cv.item(a);
    }
    e7(a, b, c) {
        let d = null;
        if (!this.cu.containsKey(b)) {
            d = new FastReflectionHelper(false, c);
            this.cu.addItem(b, d);
        }
        else {
            d = this.cu.item(b);
        }
        d.propertyName = c;
        return d.getPropertyValue(a);
    }
    e8(a) {
        return this.a4.n(a);
    }
    fl(a) {
        return this.a4.o(a);
    }
    d9() {
        return NaN;
    }
    dy(a, b) {
        return 0;
    }
    dz(a, b, c) {
        return 0;
    }
    i5(a) {
        if (this.bh == null) {
            return Rect.empty;
        }
        if (!a.equals1(this.i9)) {
            return Rect.empty;
        }
        return this.bh.n6;
    }
    i4() {
        if (this.bh == null) {
            return Rect.empty;
        }
        return this.bh.n6;
    }
    i3() {
        if (this.bh == null || this.bh.n5.isEmpty) {
            return this.i9;
        }
        return this.bh.n5;
    }
    i7(a, b) {
        if (b.isEmpty) {
            return a;
        }
        return b;
    }
    d0(a, b, c) {
        let d = this.i5(c);
        let e = new ScalerParams(0, b, c, this.ca, d);
        return this.dy(a, e);
    }
    gs(a, b, c, d) {
    }
    gr(a, b, c, d, e) {
    }
    d1(a, b) {
        return 0;
    }
    d2(a, b, c) {
        return 0;
    }
    d3(a, b, c) {
        let d = this.i5(c);
        let e = new ScalerParams(0, b, c, this.ca, d);
        return this.d1(a, e);
    }
    gt(a, b, c, d) {
    }
    ed(a) {
        let b = this.i4();
        let c = new ScalerParams(0, this.bh.n2, this.i9, this.ca, b);
        return this.dy(a, c);
    }
    gy() {
        this.i8 = new Rect(0, 0, 0, this.je.width, this.je.height);
    }
    ap() {
        this.ao.a = this.av;
        return this.ao;
    }
    get d6() {
        return this.c1;
    }
    set d6(a) {
        let b = this.d6;
        if (a != b) {
            this.c1 = a;
            this.g5("MinExtent", b, this.d6);
        }
    }
    b1() {
        if (!isNaN_(this.dk)) {
            return true;
        }
        if (this.ay == null) {
            return false;
        }
        else {
            return this.ay.k();
        }
    }
    d4() {
        if (!isNaN_(this.dk)) {
            return this.dk;
        }
        if (this.ay == null) {
            return 50;
        }
        return this.ay.extent;
    }
    gl() {
        this.a4.t();
    }
    go(a) {
        this.g6(a);
    }
    get ja() {
        return this.aq().a;
    }
    get jb() {
        return this.aq().b;
    }
    get jd() {
        return this.a4.c().d;
    }
    get jc() {
        return this.aq().c;
    }
    bd() {
        return SyncManager.a(this.bg);
    }
    aq() {
        return this.a4.c();
    }
    get ax() {
        return this.aw;
    }
    g0(a, b) {
        if (this.av != null) {
            this.av.ca(a);
        }
        this.a4.af(a, b);
    }
    b0() {
        return this.e4 != null;
    }
    e5() {
        return this.a9.exportVisualData(this);
    }
    *_cw() {
        for (let a = 0; a < this.cz.count; a++) {
            let b = this.cz._inner[a];
            yield b;
        }
    }
    cw() {
        return toEnum(() => this._cw());
    }
    g1(a) {
    }
    g4(a) {
    }
    g3(a) {
    }
    i1(a, b, c, d = null, e = null) {
        if (this.ch) {
            let f = new LineGeometry();
            f.d = { $type: Point_$type, x: c.left, y: a };
            f.c = { $type: Point_$type, x: c.right, y: a };
            return f;
        }
        else {
            let g = new LineGeometry();
            g.d = { $type: Point_$type, x: a, y: c.bottom };
            g.c = { $type: Point_$type, x: a, y: c.top };
            return g;
        }
    }
}
Axis.$t = markType(Axis, 'Axis', Control.$, [INotifyPropertyChanged_$type]);
Axis.il = DependencyProperty.i("UseEnhancedIntervalManagement", Boolean_$type, Axis.$, new PropertyMetadata(2, false, (a, b) => a.g5("UseEnhancedIntervalManagement", b.oldValue, b.newValue)));
Axis.d7 = 7;
Axis.$$p = markDep(DependencyProperty, PropertyMetadata, Axis, 'g5', ['ActualMajorStroke:ip:hr', [Brush.$], 'ActualMinorStroke:iq:hs', [Brush.$], 'ActualStroke:ir:ht', [Brush.$], 'CrossingAxis:ai:hu', [Axis.$], 'CrossingValue:e4:hv', [4, null], 'EnhancedIntervalMinimumCharacters:ez:hw', [1, -1], 'FormatLabel:at:hx', [Delegate_$type], 'IsDisabled:b8:hy', [0, false], 'IsInverted:ca:hz', [0, false], 'LabelFormat:fo:h0', [2, null], 'LabelFormatSpecifiers:ag:h1', [Array_$type, null], 'Label:e9:h2', [4, null], 'LabelSettings:ay:h3', [AxisLabelSettings.$, null], 'MajorStrokeDashArray:ix:h4', [DoubleCollection.$], 'MajorStroke:is:h5', [Brush.$], 'MajorStrokeThickness:d5:h6', [1, 1], 'MinorStrokeDashArray:iy:h7', [DoubleCollection.$], 'MinorStroke:it:h8', [Brush.$], 'MinorStrokeThickness:d8:h9', [1, 1], 'Strip:iu:ia', [Brush.$], 'StrokeDashArray:iz:ib', [DoubleCollection.$], 'Stroke:iv:ic', [Brush.$], 'StrokeThickness:ep:id', [1, DeviceUtils.g(2)], 'TickLength:eq:ie', [1, NaN], 'TickStrokeDashArray:i0:ig', [DoubleCollection.$], 'TickStroke:iw:ih', [Brush.$], 'TickStrokeThickness:er:ii', [1, DeviceUtils.g(2)], 'Title:gc:ij', [2], 'TitleSettings:be:ik', [TitleSettings.$, null]]);
/**
 * @hidden
 */
class AxisCollection extends ObservableCollection$1 {
    constructor() {
        super(Axis.$, 0);
        this.collectionResetting = null;
        this.propertyChanged = delegateCombine(this.propertyChanged, (a, b) => {
            if (b.propertyName == "Name") {
                for (let c = 0; c < this.count; ++c) {
                    if (this._inner[c].name == b.propertyName) {
                        this.ac(new NotifyCollectionChangedEventArgs(2, 2, this._inner[c], this._inner[c], c));
                    }
                }
            }
        });
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
AxisCollection.$t = markType(AxisCollection, 'AxisCollection', ObservableCollection$1.$.specialize(Axis.$));
/**
 * @hidden
 */
class AxisLabelManager extends Base {
    constructor() {
        super();
        this.e = null;
        this.f = null;
        this.b = null;
        this.a = null;
        this.c = null;
        this.c = (a) => {
        };
    }
    m(a, b) {
        this.e.clear();
        this.f.clear();
        this.b.ac = this.a;
        this.b.cq = a;
        this.b.cp = b;
        if (b.isEmpty || a.isEmpty) {
            this.r(0);
            this.a.bp.count = 0;
            this.a.bo.count = 0;
        }
        if (this.a.bq.count == 0 && this.a.bp.count == 0) {
            this.b.ab.clear();
        }
    }
    i(a, b) {
        this.e.add1(a);
        this.f.add(b);
    }
    s() {
        this.b.a2 = this.e;
        this.b.a3 = this.f;
    }
    static j(a) {
        AxisLabelManager.k(a, false);
    }
    static k(a, b) {
    }
    static l(a) {
        AxisLabelManager.k(a, true);
    }
    h(a) {
        this.b.ab.add(a);
    }
    q(a) {
        this.b.bo = a;
    }
    n(a) {
        this.c(a);
    }
    t(a) {
        let b = this.a.bq.item(a);
        return b;
    }
    r(a) {
        if (this.a == null) {
            return;
        }
        this.a.bq.count = a;
    }
    get d() {
        if (this.a == null || this.a.ay == null) {
            return false;
        }
        return this.a.ay.visibility != 0;
    }
    p() {
        this.a.bq.count = 0;
        this.a.bp.count = 0;
        this.a.bo.count = 0;
        this.a.av.a4.clear();
    }
    o() {
        this.a.ci = true;
    }
    g() {
        this.a.gk();
    }
}
AxisLabelManager.$t = markType(AxisLabelManager, 'AxisLabelManager');
/**
 * @hidden
 */
class AxisLabelPanelBase extends Panel {
    constructor() {
        super();
        this.cm = null;
        this.bo = 0;
        this.ac = null;
        this.aj = false;
        this.ay = null;
        this.a3 = null;
        this.cp = null;
        this.cl = Rect.empty;
        this.ck = null;
        this.a5 = 0;
        this.bp = null;
        this.a4 = null;
        this.a1 = null;
        this.af = null;
        this.an = false;
        this.aq = false;
        this.ar = false;
        this.as = false;
        this.br = null;
        this.ak = false;
        this.a6 = 50;
        this.a7 = 0;
        this.a8 = 0;
        this.a7 = NaN;
        this.cp = Rect.empty;
        this.co = Rect.empty;
        this.ae = this.ad();
        this.b9(this.ae);
        this.ae.am();
        this.a4 = new List$1(FrameworkElement.$, 0);
        this.a3 = new List$1(LabelPosition.$, 0);
        this.a1 = new List$1(Rect.$, 0);
        this.ar = false;
        this.aq = false;
        this.as = false;
        this.an = false;
        this.aj = false;
    }
    ad() {
        return new AxisLabelPanelBaseView(this);
    }
    b9(a) {
    }
    b0() {
    }
    cf() {
    }
    ce() {
    }
    get au() {
        return this.aj;
    }
    set au(a) {
        this.aj = a;
    }
    get a2() {
        return this.ay;
    }
    set a2(a) {
        let b = this.ay;
        this.ay = a;
        if (b == null && b != a) {
            this.b6();
        }
    }
    get cq() {
        return this.cl;
    }
    set cq(a) {
        let b = this.cl;
        this.cl = a;
        this.ci(b, this.cl);
    }
    get co() {
        return this.ck;
    }
    set co(a) {
        let b = this.ck;
        this.ck = a;
        this.b5(b, this.ck);
    }
    get a9() {
        return this.a5;
    }
    set a9(a) {
        this.a5 = a;
    }
    am(a, b) {
        for (let c = 0; c < a.count - 1; c++) {
            if (b._inner[c]) {
                continue;
            }
            for (let d = c; d < a.count - 1; d++) {
                if (b._inner[d + 1]) {
                    continue;
                }
                if (a._inner[c].intersectsWith(a._inner[d + 1])) {
                    return true;
                }
            }
        }
        return false;
    }
    bq(a, b, c) {
        return {
            ret: 0,
            p1: b
        };
    }
    az() {
        return null;
    }
    by() {
    }
    bu(a) {
    }
    be() {
        return this.af != null ? this.af.angle : 0;
    }
    bi() {
        return this.ac.be != null ? this.ac.be.angle : 0;
    }
    ap(a, b) {
        if (a == 0 && !this.ac.b2 && this.af != null) {
            if (this.ac.ch) {
                if (!this.af.showFirstLabel && this.ac.bh.e5() == 1) {
                    return false;
                }
            }
            else {
                if (!this.af.showFirstLabel && this.ac.bh.e4() == 1) {
                    return false;
                }
            }
        }
        return true;
    }
    bd(a) {
        return this.ae.m(a);
    }
    bn(a) {
        return this.ae.w(a);
    }
    bf(a) {
        return this.ae.n(a);
    }
    bc(a) {
        return this.ae.l(a);
    }
    ao() {
        return false;
    }
    ci(a, b) {
    }
    b5(a, b) {
    }
    a0() {
        if (this.ab.count < 1 || this.a3.count == 0) {
            return new List$1(Rect.$, 0);
        }
        this.a4 = new List$1(FrameworkElement.$, 0);
        this.a1 = new List$1(Rect.$, 0);
        this.by();
        this.ae.ae();
        let a = this.be();
        if (a % 360 == 0) {
            this.aq = false;
        }
        if (this.a4.count == 0) {
            return new List$1(Rect.$, 0);
        }
        this.a1 = this.az();
        this.aj = true;
        return this.a1;
    }
    bh(a, b) {
        let c = a * (Math.PI / 180);
        let d = Math.abs(b.width * Math.cos(c)) + Math.abs(b.height * Math.sin(c));
        return d;
    }
    bg(a, b) {
        let c = a * (Math.PI / 180);
        let d = Math.abs(b.height * Math.cos(c)) + Math.abs(b.width * Math.sin(c));
        return d;
    }
    bl() {
        let a = this.ae.k();
        return a;
    }
    bj() {
        let a = this.ae.j();
        return a;
    }
    bk() {
        if (this.ac.gc == null || (this.ac.be != null && this.ac.be.visibility == 1)) {
            return 0;
        }
        let a = this.bj();
        let b = this.bl();
        let c = new Rect(0, 0, 0, b, a);
        let d = this.bi();
        let e = RectUtil.w(c, d);
        return e.height + this.ae.v() + this.ae.s();
    }
    bm() {
        if (this.ac.gc == null || (this.ac.be != null && this.ac.be.visibility == 1)) {
            return 0;
        }
        let a = this.bj();
        let b = this.bl();
        let c = new Rect(0, 0, 0, b, a);
        let d = this.bi();
        let e = RectUtil.w(c, d);
        return e.width + this.ae.t() + this.ae.u();
    }
    cr(a) {
        if (this.ac == null || this.ab.count == 0) {
            return a;
        }
        this.bx(a);
        this.b1();
        this.bw(a);
        this.a1 = this.a0();
        if (this.a4.count != this.a1.count) {
            return a;
        }
        let b = this.ae.p();
        let c = this.ae.r();
        let d = this.ae.q();
        let e = this.ae.o();
        if (this.aq) {
            for (let f = 0; f < this.a4.count; f++) {
                if (this.ap(f, this.a1._inner[f])) {
                    this.ae.aa(this.a4._inner[f], this.a1._inner[f], b, c, d, e);
                }
                this.cc(this.a4._inner[f], this.be());
            }
        }
        for (let g = 0; g < this.a4.count; g++) {
            if (!this.aq) {
                this.ae.ad(this.a4._inner[g]);
            }
            if (this.ap(g, this.a1._inner[g])) {
                this.ae.aa(this.a4._inner[g], this.a1._inner[g], b, c, d, e);
            }
            else {
                this.ae.aa(this.a4._inner[g], new Rect(0, 0, 0, 0, 0), b, c, d, e);
            }
        }
        if (this.ac.bp.count > 0) {
            this.ac.a7.arrangeAnnotations(this.ac, this.ae, this.a4, this.a1, this.aq, this.be(), b, c, d, e);
        }
        this.bu(a);
        if (this.ao() && this.al && this.ac != null && this.ac.bf != null && this.ac.bf.pa && !this.ac.bf.o7 && this.a1 != null && this.a1.count > 0) {
            this.ac.bf.qq(this, this.co, this.a1._inner[0], this.a1._inner[this.a1.count - 1]);
        }
        return a;
    }
    get al() {
        return this.ac.ay != null && (this.ac.ay.c != 5 && this.ac.ay.c != 4);
    }
    cn() {
        return Rect.empty;
    }
    bx(a) {
        if (this.ac.hq == null) {
            return;
        }
        this.ae.ah(this.ac.hq, new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        let b = Math.abs(this.bi() - 0) > 1E-06;
        let c = this.cn();
        let d = c.left + (c.width / 2);
        let e = c.top + (c.height / 2);
        let f = this.bl() + this.ae.t() + this.ae.u();
        let g = this.bj() + this.ae.v() + this.ae.s();
        let h = f / 2;
        let i = g / 2;
        let j = new Rect(0, d - h, e - i, f, g);
        if (b) {
            this.cd(this.ac.hq);
        }
        else {
            this.ae.ad(this.ac.hq);
        }
        this.ae.aa(this.ac.hq, j, this.ae.t(), this.ae.v(), this.ae.u(), this.ae.s());
        if ((this.ac.be == null || this.ac.be.visibility == 0) && (this.ac.ay == null || this.ac.ay.visibility == 0) && this.ac.gc != null) {
            this.ac.hq._visibility = 0;
        }
        else {
            this.ac.hq._visibility = 1;
            this.ae.aa(this.ac.hq, new Rect(0, 0, 0, 0, 0), 0, 0, 0, 0);
        }
    }
    bw(a) {
        this.ae.ab(a);
    }
    b1() {
    }
    ax() {
        if (typeCast(CategoryAxisBase.$, this.ac) !== null) {
            return this.ac.ju;
        }
        if (typeCast(NumericAxisBase.$, this.ac) !== null) {
            let a = new List$1(Number_$type, 0);
            let d = this.ac.js.j();
            for (let c = 0; c < d.length; c++) {
                let b = d[c];
                let e = this.ac.i4();
                let f = new ScalerParams(0, this.ac.bh.oi, this.ac.i9, this.ac.cb, e);
                a.add(this.ac.dy(b, f));
            }
            return a;
        }
        return null;
    }
    get ag() {
        let a = this.af != null ? this.af.c : this.ah();
        if (this.ac.ai == null) {
            if (a == 4) {
                a = 5;
            }
            else if (a == 5) {
                a = 4;
            }
            else if (a == 6) {
                a = 7;
            }
            else if (a == 7) {
                a = 6;
            }
        }
        return a;
    }
    ch(a, b, c, d, e, f) {
        let g = b;
        let h = b;
        if (f != null) {
            let i = f.c / 2;
            g -= i;
            h += i;
        }
        if (h >= e.left && g <= e.right) {
            if (f.a) {
                b = this.ac.dj(b, e.left, e.right, f);
            }
            let j = new LineGeometry();
            j.d = { $type: Point_$type, x: b, y: c };
            j.c = { $type: Point_$type, x: b, y: d };
            a.add(j);
        }
    }
    b4(a, b, c, d, e, f) {
        if (b <= e.bottom && b >= e.top) {
            if (f.a) {
                b = this.ac.dj(b, e.top, e.bottom, f);
            }
            let g = new LineGeometry();
            g.d = { $type: Point_$type, x: c, y: b };
            g.c = { $type: Point_$type, x: d, y: b };
            a.add(g);
        }
    }
    cc(a, b) {
        let c = this.be();
        this.ae.ai(a, c);
    }
    cd(a) {
        let b = this.bi();
        this.b3(a, b);
    }
    b3(a, b) {
        let c = typeCast(FrameworkElement.$, a);
        let d = this.bj();
        let e = this.bl();
        let f = 0.5 * e;
        let g = 0.5 * d;
        let h = ((() => {
            let $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = f;
            $ret.l = g;
            return $ret;
        })());
        let i = new TransformGroup();
        i.j.add(h);
        c.j = i;
    }
    cs(a) {
        if ((this.ab.contains(this.ac.hq) == false) && this.ac.hq != null) {
            this.ab.add(this.ac.hq);
            AxisLabelManager.l(this.ac.hq);
        }
        for (let b of fromEnum(this.ab)) {
            if (b != this.ac.hq && b != this.ae.av) {
                this.ae.ag(b);
            }
        }
        let c = (this.ac == null || this.a6 <= 0 || isNaN_(this.a6)) ? 50 : this.a6;
        if (this.ac != null && (this.ac.cz == null || this.ac.cz.count == 0)) {
            if (this.ac.b1()) {
                c = this.ac.d4();
            }
        }
        let d = this.ao();
        c = Math.min(c, d ? a.height : a.width);
        c = isInfinity(c) ? 50 : c;
        return d ? new Size(1, 50, c) : new Size(1, c, 50);
    }
    get ba() {
        return this.c(AxisLabelPanelBase.cj);
    }
    set ba(a) {
        this.h(AxisLabelPanelBase.cj, a);
    }
    ai(a) {
        if (a == null) {
            return this.ac.bh.aj(this.ac);
        }
        if (a.position == 0) {
            if (this.ac != null && this.ac.bh != null) {
                return this.ac.bh.aj(this.ac);
            }
            return 4;
        }
        return a.position;
    }
    ah() {
        return 1;
    }
    at(a) {
        return true;
    }
    *_av() {
        for (let a of fromEnum(this.ab)) {
            if (a != this.ac.hq && a != this.ae.av) {
                yield a;
            }
        }
    }
    av() {
        return toEnum(() => this._av());
    }
    bt(a, b, c, d, e) {
        let f = this.ae.x(b, c, d, e);
        return f;
    }
    bz(a) {
        if (this.br == null || this.bd(this.br) < this.bd(a)) {
            this.br = a;
        }
    }
    b8(a) {
        this.a4.add(a);
    }
    *_aw() {
        for (let a = 0; a < this.ac.bq.count; a++) {
            yield this.ac.bq.item(a);
        }
        for (let b = 0; b < this.ac.bp.count; b++) {
            yield this.ac.bp.item(b);
        }
    }
    aw() {
        return toEnum(() => this._aw());
    }
    b2() {
        this.ae.af();
        this.cg();
    }
    cg() {
        this.a1 = this.a0();
    }
    b6() {
    }
    bb(a) {
        return this.a6;
    }
    b7() {
        this.ae.aj();
    }
    ca(a) {
        this.ae.ak(a);
    }
    bv() {
        this.ae.y();
    }
    cb() {
        this.ae.an();
    }
}
AxisLabelPanelBase.$t = markType(AxisLabelPanelBase, 'AxisLabelPanelBase', Panel.$);
AxisLabelPanelBase.cj = DependencyProperty.i("Extent", Number_$type, AxisLabelPanelBase.$, new PropertyMetadata(2, 50, (a, b) => a.a6 = b.newValue));
/**
 * @hidden
 */
class CategoryAxisBase extends Axis {
    constructor() {
        super();
        this.ju = null;
        this.jm = null;
        this.j5 = 0;
        this.j7 = 0;
        this.jk = 0;
        this.j6 = 0;
        this.jo = false;
        this.ju = new List$1(Number_$type, 0);
    }
    a3() {
        return new CategoryAxisBaseView(this);
    }
    get_b6() {
        return false;
    }
    gx(a) {
        super.gx(a);
        this.jj = a;
    }
    ct(a, b, c) {
        let d = super.ct(a, b, c);
        if (!d) {
            return false;
        }
        return this.itemsSource != null && this.j7 > 0;
    }
    kr() {
        if (this.jn != null && this.bn != null && this.itemsSource != null) {
            this.jn = this.bn.releaseFastItemsSource(this.itemsSource);
        }
    }
    kq() {
        if (this.jn == null && this.bn != null && this.itemsSource != null) {
            this.jn = this.bn.getFastItemsSource(this.itemsSource);
        }
    }
    get_b4() {
        return true;
    }
    k2(a, b, c) {
        if (this.b2) {
            return Rect.empty;
        }
        return this.k3(a, b, c, this.ch);
    }
    k3(a, b, c, d) {
        let e = 0;
        let f = a.x;
        let g = this.i9.left;
        let h = this.i9.right;
        if (d) {
            f = a.y;
            g = this.i9.top;
            h = this.i9.bottom;
        }
        let i = this.ju;
        if ((d && !this.ca) || (!d && this.ca)) {
            i = new List$1(Number_$type, 0);
            for (let j = this.ju.count - 1; j >= 0; j--) {
                i.add(this.ju._inner[j]);
            }
        }
        if (this.categoryMode == 0) {
            if (b) {
                let k;
                if (d) {
                    k = new Rect(0, this.i9.left, a.y - c / 2, this.i9.width, c);
                }
                else {
                    k = new Rect(0, a.x - c / 2, this.i9.top, c, this.i9.height);
                }
                k.intersect(this.i9);
                return k;
            }
            else {
                if (f > h) {
                    return Rect.empty;
                }
                if (f < g) {
                    return Rect.empty;
                }
                let l = 1.7976931348623157E+308;
                let m = -1;
                for (e = 0; e < i.count; e++) {
                    let n = Math.abs(i._inner[e] - f);
                    if (n < l) {
                        l = n;
                        m = e;
                    }
                }
                if (m == -1) {
                    return Rect.empty;
                }
                let o = i._inner[m];
                let p;
                if (d) {
                    p = new Rect(0, this.i9.left, o - c / 2, this.i9.width, c);
                }
                else {
                    p = new Rect(0, o - c / 2, this.i9.top, c, this.i9.height);
                }
                p.intersect(this.i9);
                return p;
            }
        }
        else {
            for (e = 0; e < i.count; e++) {
                if (i._inner[e] > f) {
                    break;
                }
            }
            if (e == 0) {
                return Rect.empty;
            }
            if (f > h) {
                return Rect.empty;
            }
            if (f < g) {
                return Rect.empty;
            }
            let q = this.i9.right;
            if (d) {
                q = this.i9.bottom;
            }
            if (e < i.count) {
                q = i._inner[e];
            }
            if (d) {
                return new Rect(0, this.i9.left, i._inner[e - 1], this.i9.width, q - i._inner[e - 1]);
            }
            else {
                return new Rect(0, i._inner[e - 1], this.i9.top, q - i._inner[e - 1], this.i9.height);
            }
        }
    }
    get itemsSource() {
        return this.c(CategoryAxisBase.kz);
    }
    set itemsSource(a) {
        this.h(CategoryAxisBase.kz, a);
    }
    get j8() {
        return this.j5;
    }
    set j8(a) {
        this.j5 = a;
        this.j7 = this.j5;
    }
    get categoryMode() {
        return this.jk;
    }
    set categoryMode(a) {
        if (this.jk != a) {
            let b = this.jk;
            this.jk = a;
            this.g5("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, a));
        }
    }
    get j9() {
        return this.j6;
    }
    set j9(a) {
        if (a != this.j6) {
            let b = this.j6;
            this.j6 = a;
            this.g5("GroupCount", b, this.j6);
        }
    }
    d1(a, b) {
        return NaN;
    }
    getUnscaledValue3(a, b, c, d) {
        return NaN;
    }
    getCategorySize(a, b, c) {
        return NaN;
    }
    jz(a, b, c) {
        return NaN;
    }
    getGroupCenter(a, b, c, d) {
        return NaN;
    }
    j4(a) {
        let b = this.bh.oi;
        let c = this.i9;
        let d = this.i4();
        let e = new ScalerParams(0, b, c, this.ca, d);
        return this.d1(a, e);
    }
    *_jt() {
        for (let a of fromEnum(this.cz)) {
            yield a;
        }
        if (this.bh != null && this.bh.dk && this.jq(this.bh)) {
            for (let b of fromEnum(this.bh.eb())) {
                if (b != this.bh) {
                    for (let c of fromEnum(b.series)) {
                        yield c;
                    }
                }
            }
        }
    }
    jt() {
        return toEnum(() => this._jt());
    }
    jp(a) {
        return this.cz.contains(a);
    }
    jq(a) {
        return false;
    }
    *_js() {
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null && a.dk && this.jq(a)) {
            for (let b of fromEnum(a.eb())) {
                if (b != this.bh) {
                    let c = typeCast(XamDataChart.$, b);
                    if (c != null) {
                        for (let d of fromEnum(c.axes)) {
                            if (typeCast(CategoryAxisBase.$, d) !== null) {
                                yield typeCast(CategoryAxisBase.$, d);
                            }
                        }
                    }
                }
            }
        }
    }
    js() {
        return toEnum(() => this._js());
    }
    kv(a) {
        if (this.jo) {
            return;
        }
        try {
            this.jo = true;
            let b = 0;
            let c = 0;
            let d = false;
            for (let e of fromEnum(this.jt())) {
                if (!e.cl && !e.c2 && !e.cr) {
                    continue;
                }
                let f = e;
                let g = f.preferredCategoryMode(this);
                if (g == 2) {
                    b = 2;
                    d = true;
                    if (this.jp(e)) {
                        c++;
                    }
                }
                if (g == 1 && !d) {
                    b = 1;
                }
            }
            let h = this.jr;
            for (let i of fromEnum(this.js())) {
                if (i.jr) {
                    h = true;
                }
                if (a) {
                    i.kv(false);
                }
            }
            if (b == 0 && h) {
                b = 2;
                if (c == 0) {
                    c = 1;
                }
            }
            this.categoryMode = b;
            this.j9 = c;
        }
        finally {
            this.jo = false;
        }
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case "FastItemsSourceProvider":
                if ((typeCast(IFastItemsSourceProvider_$type, c)) != null) {
                    this.jn = c.releaseFastItemsSource(this.itemsSource);
                }
                if ((typeCast(IFastItemsSourceProvider_$type, d)) != null) {
                    this.jn = d.getFastItemsSource(this.itemsSource);
                }
                this.j8 = 0;
                if (this.jn != null) {
                    this.j8 = this.jn.count;
                }
                this.kv(true);
                break;
            case "ItemsSource":
                if (this.bn != null) {
                    this.jn = this.bn.getFastItemsSource(this.itemsSource);
                }
                break;
            case CategoryAxisBase.$$p[0]:
                let e = typeCast(IFastItemsSource_$type, c);
                this.ki();
                this.ci = true;
                if (e != null) {
                    e.event = delegateRemove(e.event, runOn(this, this.kl));
                }
                this.j8 = 0;
                if (this.jn != null) {
                    this.j8 = this.jn.count;
                }
                if (this.jn != null) {
                    let f = this.jn;
                    f.event = delegateCombine(f.event, runOn(this, this.kl));
                    this.hb(false);
                    for (let g of fromEnum(this.cw())) {
                        g.jl(false);
                        if (g.bs != null) {
                            g.it();
                        }
                    }
                }
                else {
                    this.gm();
                    for (let h of fromEnum(this.cw())) {
                        h.h3(true, h.bi);
                        if (h.bs != null) {
                            h.it();
                        }
                    }
                }
                break;
            case "ItemsCount":
                this.g6(new AxisRangeChangedEventArgs(0, 0, 0, typeGetValue((c)) - 1, typeGetValue((d)) - 1));
                this.hb(false);
                break;
            case CategoryAxisBase.$$p[3]:
                this.ci = true;
                this.kw();
                this.hb(false);
                this.kj();
                break;
            case "CategoryMode":
                this.ci = true;
                this.hb(false);
                this.kt();
                this.kj();
                break;
            case CategoryAxisBase.$$p[2]:
            case CategoryAxisBase.$$p[1]:
                this.ci = true;
                for (let i of fromEnum(this.cw())) {
                    i.dl = true;
                    let j = typeCast(IHasCategoryModePreference_$type, i);
                    if (j != null && j.preferredCategoryMode(this) == 2) {
                        i.jl(false);
                    }
                }
                this.hb(false);
                if (this.bh != null) {
                    this.bh.i1();
                }
                break;
            case Axis.$$p[4]:
            case Axis.$$p[3]:
                this.ci = true;
                this.hb(true);
                break;
        }
    }
    kj() {
        for (let a of fromEnum(this.cw())) {
            a.jl(false);
        }
    }
    kl(a, b) {
        this.ks(b);
    }
    ks(a) {
        switch (a.action) {
            case 3:
            case 0:
            case 1:
            case 2:
            case 4:
                if (this.jn != null) {
                    this.j8 = this.jn.count;
                }
                this.hb(false);
                break;
        }
        if (this.jn != null) {
            this.j8 = this.jn.count;
        }
    }
    kw() {
        let a = false, b = false;
        for (let c of fromEnum(this.cz)) {
            let d = typeCast(IHasCategoryModePreference_$type, c);
            if (d == null) {
                continue;
            }
            let e = d.preferredCategoryMode(this);
            a = a || e == 1;
            b = b || e == 2;
        }
        let f = b ? 2 : a ? 1 : 0;
        if (f == 0 && this.jr) {
            f = 1;
            if (this.j9 == 0) {
                this.j9 = 1;
            }
        }
        this.categoryMode = f;
    }
    ck(a) {
        let b = super.ck(a);
        if (b) {
            this.kv(true);
            let c = typeCast(IHasCategoryModePreference_$type, a);
            if (c != null && c.preferredCategoryMode(this) == 2) {
                for (let d of fromEnum(this.cw())) {
                    let e = typeCast(IHasCategoryModePreference_$type, d);
                    if (e != null && e != c && e.preferredCategoryMode(this) == 2) {
                        d.jl(false);
                    }
                }
            }
            this.hb(false);
            this.cn();
        }
        return b;
    }
    bx(a) {
        let b = super.bx(a);
        if (b) {
            this.kv(true);
            let c = typeCast(IHasCategoryModePreference_$type, a);
            if (c != null && c.preferredCategoryMode(this) != 0) {
                for (let d of fromEnum(this.cw())) {
                    let e = typeCast(IHasCategoryModePreference_$type, d);
                    if (e != null) {
                        d.jl(false);
                    }
                }
            }
            this.hb(false);
        }
        return b;
    }
    kt() {
        let a = null;
        for (let b of fromEnum(this.cw())) {
            if (b.cl) {
                let c = b.am(this);
                if (c != null && c.ai == this) {
                    a = c;
                }
            }
        }
        if (a != null) {
            a.ha();
        }
    }
    ki() {
        this.jm = this.jn;
    }
    ku() {
        let a = this.ay;
        if (a == null) {
            a = new AxisLabelSettings();
        }
        if (a.visibility == 1) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        else {
            let b = 0;
            b = this.jj.bf(this.cx);
            this.bq.count = b;
        }
    }
    kk(a) {
        if (this.jn != null) {
            this.jn.handleCollectionChanged(a);
        }
    }
    kp(a, b, c) {
        this.kk(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    km() {
        this.kk(new NotifyCollectionChangedEventArgs(0, 4));
    }
    kn(a, b) {
        this.kk(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    ko(a, b) {
        this.kk(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    j0(a, b, c, d) {
        return this.j1(a, b, c, d, this.categoryMode);
    }
    j1(a, b, c, d, e) {
        let f = 0;
        let g = e;
        if (g == 0 && this.categoryMode != 0) {
            g = 1;
        }
        switch (g) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * this.getCategorySize(a, b, c);
                break;
            case 2:
                f = this.getGroupCenter(d, a, b, c);
                break;
        }
        if (this.ch != this.ca) {
            f *= -1;
        }
        return f;
    }
    getSeriesOffset(a, b, c, d, e) {
        return this.j1(a, b, c, d, e);
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryAxisBase.$t = markType(CategoryAxisBase, 'CategoryAxisBase', Axis.$, [ICategoryScaler_$type]);
CategoryAxisBase.kz = DependencyProperty.i("ItemsSource", IEnumerable_$type, CategoryAxisBase.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(CategoryAxisBase.$, a);
    if (c.bn != null) {
        c.bn.releaseFastItemsSource(b.oldValue);
    }
    a.g5("ItemsSource", b.oldValue, b.newValue);
}));
CategoryAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAxisBase, 'g5', ['FastItemsSource:jn:kx', [IFastItemsSource_$type], 'Gap:jw:ky', [1, 0.2], 'Overlap:j3:k0', [1, 0], 'UseClusteringMode:jr:k1', [0, false]]);
/**
 * @hidden
 */
class HorizontalAxisLabelPanelBase extends AxisLabelPanelBase {
    constructor() {
        super(...arguments);
        this.c5 = 0;
        this.c2 = 0;
        this.c4 = 0;
        this.c3 = 0;
    }
    ad() {
        return new HorizontalAxisLabelPanelBaseView(this);
    }
    b9(a) {
        super.b9(a);
        this.ct = a;
    }
    by() {
        this.ct.az();
    }
    cv() {
        return this.af != null && this.af.j() && this.be() % 360 != 0;
    }
    cw() {
        return this.an && !this.aq;
    }
    ao() {
        return true;
    }
    az() {
        let a = new List$1(Rect.$, 0);
        let b = new List$1(Boolean_$type, 0);
        this.ar = false;
        this.aq = false;
        this.as = false;
        let c = this.af != null ? (this.af.angle) : 0;
        let d = c * Math.PI / 180;
        if (this.cv()) {
            this.aq = true;
        }
        this.an = false;
        this.c7(a, b, d);
        this.an = this.an || this.am(a, b);
        if (this.an) {
            this.c9(a, b);
        }
        else {
            this.da();
        }
        let e = this.ac.b1();
        if (!e) {
            this.c6(c);
        }
        else {
            this.ae.ac();
        }
        if (this.aq) {
            for (let f = 0; f < a.count; f++) {
                let g = a._inner[f];
                g.x = this.a3._inner[f].c;
                a._inner[f] = g;
            }
        }
        let h = 0;
        if (this.cw()) {
            h = ((() => { let i = this.bq(this.c2, a, b); a = i.p1; return i.ret; })());
        }
        if (this.an && !this.ar) {
            if (h > 0) {
                if (this.ct.ay()) {
                    this.as = true;
                }
            }
        }
        if (this.an && this.cu()) {
            let i = this.co.width;
            let j = this.c0();
            let k = this.cz();
            let l = this.a3.count > 1 ? this.a3._inner[1].c - this.a3._inner[0].c : i;
            let m = Math.abs(l * 0.8);
            let n = 0;
            let o = Math.abs(Math.atan(this.c2 / l) * 180 / Math.PI);
            let p = this.ae.p();
            let q = this.ae.q();
            for (let r = 0; r < a.count; r++) {
                if (this.ak) {
                    if (r > 0 && r < a.count - 1) {
                        let s = this.a3.count > 1 ? this.a3._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                        let t = this.a3.count > 1 ? a._inner[r + 1].x - this.a3._inner[r].c : i;
                        m = Math.abs(Math.min(Math.abs(s * 2), Math.abs(t * 2)) * 0.8);
                    }
                    else {
                        if (r == 0) {
                            let u = this.a3.count > 1 ? a._inner[r + 1].x - this.a3._inner[r].c : i;
                            m = Math.abs((l * 2) * 0.8);
                        }
                        if (r == a.count - 1) {
                            let v = this.a3.count > 1 ? this.a3._inner[r].c - (a._inner[r - 1].x + a._inner[r - 1].width) : i;
                            m = Math.abs((v * 2) * 0.8);
                        }
                    }
                }
                let w = Math.min(a._inner[r].width, m);
                n = this.aq ? this.a3._inner[r].c : this.a3._inner[r].c - w / 2;
                let x = AngleSimplifier.a(c);
                let y = (x >= o && x <= 180 - o) || (x >= 180 + o && x <= 360 - o);
                let z = a._inner[r];
                if (this.aq && y) {
                    let aa = this.bn(this.a4._inner[r]);
                    m = Math.min(j / Math.abs(Math.sin(d)), aa);
                }
                z.x = n;
                z.width = Math.min(m, z.width);
                a._inner[r] = z;
                if (!(typeCast(TextBlock.$, this.a4._inner[r]) !== null)) {
                    this.a4._inner[r].width = Math.min(m, z.width);
                }
                let ab = typeCast(TextBlock.$, this.a4._inner[r]);
                if (ab != null) {
                    let ac = this.bt(r, ab, m, p, q);
                    if (this.as) {
                        ab.height = k;
                    }
                    else if (!Base.equalsStatic(ab.ak, ac)) {
                        ab.ak = ac;
                        this.a4._inner[r].width = Math.min(m, this.bd(this.a4._inner[r]));
                        this.c4 = Math.min(this.c4, this.a4._inner[r].width);
                    }
                }
            }
            if (!e) {
                this.c6(c);
            }
        }
        if (this.cx()) {
            this.c8(a);
        }
        return a;
    }
    c7(a, b, c) {
        let d = this.bk();
        let e = this.c1();
        this.c2 = -1.7976931348623157E+308;
        this.c5 = -1.7976931348623157E+308;
        this.c3 = -1.7976931348623157E+308;
        this.c4 = -1.7976931348623157E+308;
        let f = this.ae.p();
        let g = this.ae.q();
        let h = this.ae.r();
        let i = this.ae.o();
        let j = this.co.top;
        let k = (this.co.height - d);
        let l = false;
        for (let m = 0; m < this.a4.count; m++) {
            if (!this.a3._inner[m].a) {
                l = true;
            }
        }
        for (let n = 0; n < this.a4.count; n++) {
            if (this.a3 == null || n >= this.a3.count) {
                break;
            }
            let o, p, q, r, s, t;
            let u = this.a4._inner[n];
            s = this.bd(u);
            t = this.bc(u);
            r = s + this.ae.p() + this.ae.q();
            q = t + h + i;
            let v = this.a3._inner[n].a;
            if (this.aq) {
                o = this.a3._inner[n].c;
            }
            else {
                o = this.a3._inner[n].c - r / 2;
            }
            p = j + e;
            if (!v || !l) {
                this.c2 = Math.max(q, this.c2);
                this.c5 = Math.max(r, this.c5);
                this.c3 = Math.max(t, this.c3);
                this.c4 = Math.max(s, this.c4);
            }
            let w = new Rect(0, o, p, r, q);
            a.add(w);
            b.add(v);
            let x = r * Math.abs(Math.sin(c));
            this.an = this.an || x > k;
        }
    }
    c6(a) {
        let b = a * (Math.PI / 180);
        let c = Math.abs(this.c4 * Math.sin(b)) + Math.abs(this.c3 * Math.cos(b));
        c += this.ae.r() + this.ae.o();
        let d = this.bk();
        this.ba = (c) + (d) + this.ac.di;
    }
    c8(a) {
        this.ct.a0(a);
    }
    c9(a, b) {
    }
    da() {
    }
    cc(a, b) {
        let c = a.l;
        let d = a.m;
        let e = 0;
        let f = c / 2;
        let g = new TransformGroup();
        let h = AngleSimplifier.a(this.be());
        let i = ((() => {
            let $ret = new RotateTransform();
            $ret.j = h;
            $ret.k = e;
            $ret.l = f;
            return $ret;
        })());
        let j = 0;
        let k = 0;
        if (h != 0 && h != 360) {
            if (h > 0 && h < 180) {
                j = -Math.sin(MathUtil.k(h)) * (c / 2);
            }
            else {
                i.k = d;
                k = -d;
                j = -Math.sin(MathUtil.k(h - 180)) * (c / 2);
            }
        }
        let l = ((() => {
            let $ret = new TranslateTransform();
            $ret.k = j;
            $ret.j = k;
            return $ret;
        })());
        g.j.add(i);
        g.j.add(l);
        a.j = g;
    }
    cx() {
        return !this.ar && !this.aq;
    }
    cu() {
        return true;
    }
    bq(a, b, c) {
        let d = 0;
        let e = new List$1(Rect.$, 0);
        let f = this.c1() + this.co.top;
        let g = this.c0();
        let h = f + g;
        if (a * 3 <= this.a6) {
            d = 3;
        }
        else if (a * 2 <= this.a6) {
            d = 2;
        }
        else {
            return {
                ret: d,
                p1: b
            };
        }
        let i = 0;
        for (let j = 0; j < b.count; j++) {
            let k = RectUtil.p(b._inner[j]);
            if (!c._inner[j]) {
                if (i % d == 0) {
                    k.y = f;
                }
                else if (i % d == d - 1) {
                    k.y = h - k.height;
                }
                else {
                    k.y = (f + (g / 2)) - k.height / 2;
                }
                i++;
            }
            e.add(k);
        }
        this.an = this.am(e, c);
        if (!this.an) {
            this.ar = true;
            b = e;
        }
        return {
            ret: d,
            p1: b
        };
    }
    cn() {
        let a = this.ai(this.ac.be);
        let b = this.bk();
        let c = this.ag;
        let d = 0;
        if (a == 3) {
            d += this.co.top;
            if (c == 1 || c == 5) {
                d += this.ac.di;
            }
        }
        else {
            d = this.co.bottom - b;
            if (c == 4 || c == 0) {
                d -= this.ac.di;
            }
        }
        let e = this.bm();
        let f = 0;
        let g = this.ac.be == null ? 1 : this.ac.be.horizontalAlignment;
        if (g == 0) {
            f = this.co.left;
        }
        else if (g == 2) {
            f = this.co.right - e;
        }
        else {
            f = (this.co.left + (this.co.width / 2)) - (e / 2);
        }
        return new Rect(0, f, d, e, b);
    }
    c1() {
        let a = 0;
        let b = this.ai(this.ac.be);
        if (b == 3) {
            a += this.bk();
        }
        let c = this.ag;
        if (c == 1 || c == 5) {
            a += this.ac.di;
        }
        return a;
    }
    cy() {
        let a = 0;
        let b = this.ai(this.ac.be);
        if (b == 4) {
            a += this.bk();
        }
        let c = this.ag;
        if (c == 0 || c == 4) {
            a += this.ac.di;
        }
        return a;
    }
    c0() {
        let a = (this.a6 - this.c1()) - this.cy();
        if (a < 0) {
            a = 0;
        }
        return a;
    }
    cz() {
        let a = ((this.c0() - this.ae.r()) - this.ae.o());
        if (a < 0) {
            a = 0;
        }
        return a;
    }
    b1() {
        let a = this.ae.at();
        this.ac.gn(a);
        if (this.af != null && this.af.visibility != 0) {
            return;
        }
        let b = this.ac.di;
        if (b == 0) {
            return;
        }
        let c = this.ax();
        if (c == null) {
            return;
        }
        let d = this.co.top;
        let e;
        let f = this.ag;
        if (f == 0 || f == 4) {
            d = this.co.bottom;
            e = d - this.ac.di;
        }
        else {
            e = d + this.ac.di;
        }
        let g = this.ae.b();
        for (let h of fromEnum(c)) {
            this.ch(a, h, d, e, this.cp, g);
        }
        if (!this.ab.contains(this.ae.av)) {
            this.ab.add(this.ae.av);
        }
    }
}
HorizontalAxisLabelPanelBase.$t = markType(HorizontalAxisLabelPanelBase, 'HorizontalAxisLabelPanelBase', AxisLabelPanelBase.$);
/**
 * @hidden
 */
class HorizontalAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    ah() {
        return 1;
    }
    at(a) {
        return a == 5 || a == 4 || a == 1 || a == 0;
    }
}
HorizontalAxisLabelPanel.$t = markType(HorizontalAxisLabelPanel, 'HorizontalAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
/**
 * @hidden
 */
class NumericAxisBase extends Axis {
    constructor() {
        super();
        this.j6 = 0;
        this.ki = 0;
        this.j9 = 0;
        this.j5 = 0;
        this.kh = 0;
        this.j8 = 0;
        this.j4 = 0;
        this.j7 = 0;
        this.jv = false;
        this.kp = 0;
        this.jn = null;
        this.j3 = false;
        this.jr = null;
        this.ju = false;
        this.kp = 10;
    }
    a3() {
        return new NumericAxisBaseView(this);
    }
    gx(a) {
        super.gx(a);
        this.jk = a;
    }
    get_cc() {
        return true;
    }
    get kc() {
        return this.j6;
    }
    set kc(a) {
        if (this.kc != a) {
            let b = this.j6;
            this.j6 = a;
            this.ki = Math.log(this.kc);
            this.g5("ActualMinimumValue", b, this.kc);
        }
    }
    fb() {
        return this.kk;
    }
    get kf() {
        return this.j9;
    }
    set kf(a) {
        if (this.kf != a) {
            let b = this.j9;
            this.j9 = a;
            this.g5("ActualVisibleMinimumValue", b, this.kf);
        }
    }
    get kb() {
        return this.j5;
    }
    set kb(a) {
        if (this.kb != a) {
            let b = this.j5;
            this.j5 = a;
            this.kh = Math.log(this.kb);
            this.g5("ActualMaximumValue", b, this.kb);
        }
    }
    fa() {
        return this.kb;
    }
    get ke() {
        return this.j8;
    }
    set ke(a) {
        if (this.ke != a) {
            let b = this.j8;
            this.j8 = a;
            this.g5("ActualVisibleMaximumValue", b, this.ke);
        }
    }
    get ka() {
        return this.j4;
    }
    set ka(a) {
        if (this.ka != a) {
            let b = this.j4;
            this.j4 = a;
            this.g5("ActualInterval", b, this.ka);
        }
    }
    d9() {
        return this.ka;
    }
    get kd() {
        return this.j7;
    }
    set kd(a) {
        if (this.kd != a) {
            let b = this.j7;
            this.j7 = a;
            this.g5("ActualMinorInterval", b, this.kd);
        }
    }
    get jx() {
        return this.jv;
    }
    set jx(a) {
        if (this.jx != a) {
            let b = this.jv;
            if (b != a) {
                this.jv = a;
                this.g5("ActualIsLogarithmic", b, this.jx);
            }
        }
    }
    get j2() {
        return this.jx && this.kc > 0 && this.kp > 1;
    }
    hc(a) {
        super.hc(a);
        if (this.j2 && this.bh != null) {
            let b = this.i4();
            let c = this.i3();
            let d = this.jo(this.i9, this.bh.n2, b, c);
            if (d == null) {
                return;
            }
            for (let e = 0; e < d.k.count; e++) {
                let f = this.ko;
                let g = d.k._inner[e];
                let h = Math.min(g.d, g.c);
                let i = Math.max(g.d, g.c);
                let j = Math.floor(logBase(h, f));
                let k = Math.ceil(logBase(i, f));
                if (k - j < 2) {
                    if (typeCast(LogarithmicTickmarkValues.$, this.jr) !== null) {
                        this.jr = new LinearTickmarkValues();
                    }
                }
                else {
                    this.jr = this.jt != null ? this.jt : ((() => {
                        let $ret = new LogarithmicTickmarkValues();
                        $ret.x = f;
                        return $ret;
                    })());
                }
            }
        }
    }
    g4(a) {
        super.g4(a);
        this.kk = a;
    }
    g3(a) {
        super.g4(a);
        this.kj = a;
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[4]:
                this.cn();
                this.hb(false);
                break;
            case NumericAxisBase.$$p[3]:
                this.cn();
                this.hb(false);
                break;
            case NumericAxisBase.$$p[1]:
                this.j3 = true;
                this.jx = this.j1;
                break;
            case Axis.$$p[4]:
            case Axis.$$p[3]:
            case NumericAxisBase.$$p[0]:
            case NumericAxisBase.$$p[5]:
                this.ci = true;
                this.hb(false);
                break;
            case NumericAxisBase.$$p[2]:
                this.j3 = true;
                this.kp = this.ko;
                if (this.jx) {
                    this.cn();
                    this.k9();
                    this.hb(false);
                }
                break;
            case NumericAxisBase.$$p[6]:
                let e = new AxisRangeChangedEventArgs(0, this.kc, this.kc, this.kb, this.kb);
                this.g6(e);
                this.ci = true;
                this.hb(false);
                break;
            case Axis.$$p[12]:
                this.jn = this.jl();
                this.ci = true;
                this.hb(false);
                break;
            case "TickmarkValues":
                this.lb();
                break;
            case "ActualIsLogarithmic":
                this.cn();
                this.k9();
                this.ci = true;
                this.lb();
                this.hb(false);
                break;
            case "ActualTickmarkValues":
                this.ci = true;
                this.hb(false);
                break;
            case "AbbreviateLargeNumbers":
                this.hb(false);
                break;
        }
    }
    k9() {
        for (let a of fromEnum(this.cw())) {
            a.jl(false);
        }
    }
    jj() {
        let a = new AxisRange(Number.POSITIVE_INFINITY, Number.NEGATIVE_INFINITY);
        let b = false;
        if (this.bh != null) {
            for (let c of fromEnum(this.cw())) {
                let d = c.an(this);
                if (d != null) {
                    b = true;
                    a = new AxisRange(Math.min(a.c, d.c), Math.max(a.b, d.b));
                }
            }
        }
        if (b) {
            return a;
        }
        return null;
    }
    k7(a, b, c, d, e, f, g) {
        let h = AutoRangeCalculator.a(a, b, c, d, e, f, g);
        f = h.p5;
        g = h.p6;
        return {
            p5: f,
            p6: g
        };
    }
    cp() {
        let a = this.jx && !isNaN_(this.ko) && !isInfinity(this.ko) && this.ko > 1;
        let b;
        let c;
        let d = this.k7(this, this.kk, this.kj, a, this.ko, b, c);
        b = d.p5;
        c = d.p6;
        if (b != this.kc || c != this.kb || this.j3) {
            this.j3 = false;
            let e = new AxisRangeChangedEventArgs(0, this.kc, b, this.kb, c);
            this.kc = b;
            this.kb = c;
            this.g6(e);
            this.la(e);
            this.hb(true);
            return true;
        }
        return false;
    }
    la(a) {
    }
    ck(a) {
        let b = super.ck(a);
        if (b) {
            this.cn();
        }
        return b;
    }
    bx(a) {
        let b = super.bx(a);
        if (b) {
            this.cn();
        }
        return b;
    }
    jm(a) {
        return new NumericAxisRenderer(a);
    }
    jl() {
        let a = ((() => {
            let $ret = new AxisLabelManager();
            $ret.a = this;
            $ret.f = this.cy;
            $ret.e = this.cx;
            $ret.b = this.av;
            return $ret;
        })());
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        let b = this.jm(a);
        b.u = () => {
            let c = this.a4.ay();
            let d = this.a4.a1();
            let e = this.a4.az();
            let f = this.a4.a0();
            this.hk();
            this.gn(c);
            this.gn(d);
            this.gn(e);
            this.gn(f);
        };
        b.o = (c, d) => !d.isEmpty && !c.isEmpty;
        b.d = (c, d, e, f) => this.jo(c, d, e, f);
        b.g = (c) => this.e8(c);
        return b;
    }
    jp() {
        return new NumericAxisRenderingParameters();
    }
    k8() {
    }
    jq() {
        return null;
    }
    jo(a, b, c, d) {
        let e = this.jp();
        let f = this.a4.ay();
        let g = this.a4.a1();
        let h = this.a4.az();
        let i = this.a4.a0();
        let j = this.a4.e();
        let k = this.a4.f();
        let l = this.a4.g();
        e.t = f;
        e.w = g;
        e.u = h;
        e.v = i;
        e.a = j;
        e.c = k;
        e.d = l;
        e.l = this.kb;
        e.m = this.kc;
        e.h = this.jz;
        e.f = this.js;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.o = this.eb();
        e.g = this.jy();
        e.p = this.kg;
        e.q = this.kl;
        e.s = this.e9;
        if (this.e9 == null && (this.at != null || this.ah != null)) {
            e.s = "Format";
        }
        e.j = this.cl;
        e.ab = this.jw;
        return e;
    }
    kn(a) {
        let b = this.i4();
        let c = new ScalerParams(0, this.bh.n2, this.i9, this.ca, b);
        return this.d1(a, c);
    }
    jy() {
        return !isNaN_(this.kg);
    }
    get j0() {
        return !isNaN_(this.kk);
    }
    get jz() {
        return !isNaN_(this.kj);
    }
    lb() {
        if (this.jt != null) {
            this.js = this.jt;
        }
        else if (this.jx) {
            this.js = new LogarithmicTickmarkValues();
            this.jk.bf();
        }
        else {
            this.js = new LinearTickmarkValues();
        }
    }
    get jt() {
        return typeCast(TickmarkValues.$, this.c(NumericAxisBase.lj));
    }
    set jt(a) {
        this.h(NumericAxisBase.lj, a);
    }
    get js() {
        if (this.jr == null) {
            this.lb();
        }
        return this.jr;
    }
    set js(a) {
        let b = this.jr;
        let c = b != a;
        if (c) {
            this.jr = a;
            this.g5("ActualTickmarkValues", b, a);
        }
    }
    get jw() {
        return this.ju;
    }
    set jw(a) {
        let b = this.jw;
        if (a != b) {
            this.ju = a;
            this.g5("AbbreviateLargeNumbers", b, this.jw);
        }
    }
}
NumericAxisBase.$t = markType(NumericAxisBase, 'NumericAxisBase', Axis.$);
NumericAxisBase.lj = DependencyProperty.i("TickmarkValues", TickmarkValues.$, NumericAxisBase.$, new PropertyMetadata(1, (a, b) => a.g5("TickmarkValues", b.oldValue, b.newValue)));
NumericAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAxisBase, 'g5', ['Interval:kg:lc', [1, NaN], 'IsLogarithmic:j1:ld', [0, false], 'LogarithmBase:ko:le', [1, 10], 'MaximumValue:kj:lf', [1, NaN], 'MinimumValue:kk:lg', [1, NaN], 'MinorInterval:kl:lh', [1, NaN], 'ReferenceValue:km:li', [1, 0]]);
/**
 * @hidden
 */
class NumericScaler extends DependencyObject {
    constructor() {
        super(...arguments);
        this.o = 0;
        this.n = 0;
        this.m = 0;
    }
    y(a) {
        this.l = a;
    }
    x(a) {
        this.k = a;
    }
    w(a, b, c) {
        switch (a) {
            case NumericScaler.$$p[1]:
                this.o = this.l;
                this.z();
                break;
            case NumericScaler.$$p[0]:
                this.n = this.k;
                this.z();
                break;
        }
    }
    z() {
        if (isNaN_(this.l) || isNaN_(this.k) || isInfinity(this.l) || isInfinity(this.k) || this.l < (-7.9228162514264338E+28) || this.k > (7.9228162514264338E+28)) {
            this.m = this.k - this.l;
        }
        else {
            this.m = this.k - this.l;
        }
    }
    j(a, b, c, d) {
        let e = new List$1(Number_$type, 2, a.count);
        for (let f = b; f < c; f++) {
            e.add(this.q(a.item(f), d));
        }
        return e;
    }
    v(a, b, c, d) {
        for (let e = b; e < c; e++) {
            a.item(e, this.p(a.item(e), d));
        }
    }
    u(a, b, c, d, e) {
        for (let f = 0; f < b.count; f++) {
            let g = b.item(f);
            for (let h = c; h < d; h++) {
                a.item(h)[g] = this.p(a.item(h)[g], e);
            }
        }
    }
}
NumericScaler.$t = markType(NumericScaler, 'NumericScaler', DependencyObject.$);
NumericScaler.ac = new Rect(0, 0, 0, 1, 1);
NumericScaler.$$p = markDep(DependencyProperty, PropertyMetadata, NumericScaler, 'w', ['ActualMaximumValue:k:aa', [1, NaN], 'ActualMinimumValue:l:ab', [1, NaN]]);
/**
 * @hidden
 */
class AxisRendererBase extends Base {
    constructor(a) {
        super();
        this.u = null;
        this.o = null;
        this.v = null;
        this.m = null;
        this.l = null;
        this.k = null;
        this.q = null;
        this.n = null;
        this.j = null;
        this.e = null;
        this.p = null;
        this.h = null;
        this.t = null;
        this.b = null;
        this.g = null;
        this.d = null;
        this.r = null;
        this.a = null;
        this.f = null;
        this.i = null;
        this.u = () => {
        };
        this.o = (b, c) => false;
        this.v = () => {
        };
        this.m = (b, c) => c;
        this.l = (b, c, d, e) => {
        };
        this.k = (b, c, d) => {
        };
        this.q = (b, c) => false;
        this.n = (b, c) => this.q(b, c);
        this.j = (b) => {
        };
        this.e = (b) => {
        };
        this.p = (b, c, d) => false;
        this.h = (b, c) => new LabelPosition(c);
        this.t = (b, c) => c;
        this.g = (b) => null;
        this.r = (b, c, d, e) => c;
        this.a = (b, c, d, e) => c;
        this.b = a;
        this.d = (b, c, d, e) => null;
    }
    c(a, b, c, d, e) {
        this.x(c, b);
        if (this.o(b, c)) {
            this.v();
            let f = this.d(b, c, d, e);
            this.x(c, b);
            if (f == null) {
                this.aa();
                return null;
            }
            if (f.k.count > 1 && !f.g) {
                this.ab(f);
            }
            for (let g of fromEnum(f.k)) {
                f.e = g;
                if (isNaN_(g.c) || isInfinity(g.c) || isNaN_(g.d) || isInfinity(g.d)) {
                    continue;
                }
                if (g.d == g.c) {
                    continue;
                }
                this.e(f);
                this.b.n(f.r);
                let h = 0;
                let i = 0;
                let j = false;
                let k = (l) => l;
                if (this.f != null) {
                    k = this.i;
                }
                if (typeCast(CategoryAxisRenderingParameters.$, f) !== null) {
                    h = f.ab;
                    i = f.af;
                    j = f.ac;
                }
                f.f = this.s(f);
                f.f.s(((() => {
                    let $ret = new TickmarkValuesInitializationParameters();
                    $ret.n = f.e.d;
                    $ret.m = f.e.c;
                    $ret.g = f.m;
                    $ret.f = f.l;
                    $ret.k = f.e.b;
                    $ret.d = f.g;
                    $ret.l = f.p;
                    $ret.j = f.q;
                    $ret.h = f.o;
                    $ret.i = f.e.a;
                    $ret.p = f.e.e;
                    $ret.a = h;
                    $ret.q = i;
                    $ret.s = f.aa;
                    $ret.r = f.z;
                    $ret.e = j;
                    $ret.c = k;
                    return $ret;
                })()));
                this.y(f);
            }
            this.z();
            return f;
        }
        return null;
    }
    aa() {
        this.b.p();
    }
    ab(a) {
        let b = -1.7976931348623157E+308;
        let c = -2147483648;
        let d = 0;
        let e = 0;
        let f = false;
        let g = (h) => h;
        if (this.f != null) {
            g = this.i;
        }
        if (typeCast(CategoryAxisRenderingParameters.$, a) !== null) {
            d = a.ab;
            e = a.af;
            f = a.ac;
        }
        for (let h of fromEnum(a.k)) {
            a.e = h;
            a.f.s(((() => {
                let $ret = new TickmarkValuesInitializationParameters();
                $ret.n = h.d;
                $ret.m = h.c;
                $ret.g = a.m;
                $ret.f = a.l;
                $ret.k = h.b;
                $ret.d = a.g;
                $ret.l = a.p;
                $ret.i = h.a;
                $ret.p = h.e;
                $ret.h = a.o;
                $ret.j = a.q;
                $ret.a = d;
                $ret.q = e;
                $ret.s = a.aa;
                $ret.r = a.z;
                $ret.e = f;
                $ret.c = g;
                return $ret;
            })()));
            h.a = a.f.m;
            h.e = a.f.r;
            if (!isNaN_(a.f.m)) {
                b = Math.max(b, a.f.m);
                c = Math.max(c, a.f.r);
            }
        }
        for (let i of fromEnum(a.k)) {
            if (i.a == b) {
                i.a = -1;
                i.e = -1;
            }
            else {
                i.a = b;
                i.e = c;
            }
        }
    }
    x(a, b) {
        this.u();
        this.b.m(a, b);
        this.b.s();
    }
    z() {
        this.b.s();
        let a = false;
        if (this.b.d) {
            this.b.r(0);
        }
        else {
            let b = 0;
            for (let c of fromEnum(this.b.e)) {
                let d = typeCast(FrameworkElement.$, c);
                if (d == null) {
                    d = this.b.t(b);
                    let e = d.ak;
                    let f = c.toString();
                    let g = 0;
                    let h = 0;
                    if (e != null) {
                        g = e.length;
                    }
                    if (f != null) {
                        h = f.length;
                    }
                    if (g != h) {
                        a = true;
                    }
                    d.ak = f;
                    b++;
                }
                else {
                    this.b.h(d);
                }
            }
            if (a) {
                this.b.o();
            }
            this.b.g();
            this.b.r(b);
        }
    }
    s(a) {
        return a.f;
    }
    y(a) {
        let b = a.f.j();
        let c = a.f.k();
        this.b.q(this.m(a, a.f.m));
        this.j(a);
        for (let d = 0; d < b.length; d++) {
            let e = a.f.p + d;
            let f = b[d];
            let g = f;
            let h = 0;
            if (d < b.length - 1) {
                h = b[d + 1];
            }
            else {
                h = Number.POSITIVE_INFINITY;
            }
            g = this.r(a, g, e, a.f.m);
            h = this.r(a, h, e, a.f.m);
            let i = this.m(a, g);
            let j = this.m(a, h);
            if (this.q(a, i)) {
                if (e % 2 == 0 && this.n(a, j) && !isInfinity(j)) {
                    this.l(a, a.w, i, j);
                }
                a.b = a.c;
                this.k(a, a.u, i);
                a.b = null;
            }
            i = this.a(a, i, e, a.f.m);
            if (!isNaN_(i) && !isInfinity(i) && this.p(a, i, d == b.length - 1)) {
                let k = this.w(a, g, e, a.f.m);
                if (k != null) {
                    this.b.i(k, this.h(a, i));
                }
            }
        }
        if (a.j) {
            for (let l = 0; l < c.length; l++) {
                let m = c[l];
                let n = this.m(a, m);
                a.b = a.d;
                this.k(a, a.v, n);
                a.b = null;
            }
        }
    }
    w(a, b, c, d) {
        return null;
    }
}
AxisRendererBase.$t = markType(AxisRendererBase, 'AxisRendererBase');
/**
 * @hidden
 */
class NumericAxisRenderer extends AxisRendererBase {
    constructor(a) {
        super(a);
        this.ac = null;
        this.ad = false;
    }
    w(a, b, c, d) {
        let e;
        if (a.s != null) {
            e = this.g(b);
        }
        else {
            b = Math.round(b * 1000000) / 1000000;
            if (a.i() && a.ab) {
                return this.ae(b);
            }
            e = b.toString();
        }
        return e;
    }
    ae(a) {
        if (this.ad) {
            return a.toString();
        }
        if (this.ac == null) {
            this.ac = NumberAbbreviatorFactory.a(this.b.a.bt);
            if (this.ac == null) {
                this.ad = true;
                return a.toString();
            }
        }
        return this.ac.abbreviate(a);
    }
}
NumericAxisRenderer.$t = markType(NumericAxisRenderer, 'NumericAxisRenderer', AxisRendererBase.$);
/**
 * @hidden
 */
class VerticalAxisLabelPanel extends AxisLabelPanelBase {
    constructor() {
        super(...arguments);
        this.c2 = 0;
        this.cz = 0;
        this.c1 = 0;
        this.c0 = 0;
    }
    ad() {
        return new VerticalAxisLabelPanelView(this);
    }
    b9(a) {
        super.b9(a);
        this.ct = a;
    }
    by() {
        this.ct.ay();
    }
    bi() {
        return this.ac.be != null ? this.ac.be.angle : -90;
    }
    cv() {
        let a = 0;
        let b = this.ai(this.ac.be);
        if (b == 1) {
            a += this.bm();
        }
        let c = this.ag;
        if (c == 3 || c == 7) {
            a += this.ac.di;
        }
        return a;
    }
    cx() {
        let a = 0;
        let b = this.ai(this.ac.be);
        if (b == 2) {
            a += this.bm();
        }
        let c = this.ag;
        if (c == 2 || c == 6) {
            a += this.ac.di;
        }
        return a;
    }
    cy() {
        let a = (this.a6 - this.cv()) - this.cx();
        if (a < 0) {
            a = 0;
        }
        return a;
    }
    cw() {
        let a = ((this.cy() - this.ae.p()) - this.ae.q());
        if (a < 0) {
            a = 0;
        }
        return a;
    }
    az() {
        let a = new List$1(Rect.$, 0);
        this.ar = false;
        this.aq = false;
        if (this.af != null && this.af.j() && this.be() % 360 != 0) {
            this.aq = true;
        }
        this.c2 = -1.7976931348623157E+308;
        this.cz = -1.7976931348623157E+308;
        this.c1 = -1.7976931348623157E+308;
        this.c0 = -1.7976931348623157E+308;
        let b = this.ae.p();
        let c = this.ae.r();
        let d = this.ae.q();
        let e = this.ae.o();
        let f = this.cv();
        let g = false;
        if (!isNaN_(this.a7)) {
            this.c2 = Math.max(this.a7, this.c2);
            this.c1 = Math.max(this.a8, this.c1);
        }
        for (let h = 0; h < this.a4.count; h++) {
            let i = this.a4._inner[h];
            let j = this.a3._inner[h].a;
            let k = this.bc(i);
            let l = this.bd(i);
            let m = k + c + e;
            let n = l + b + d;
            let o = this.co.left + f;
            let p = this.a3._inner[h].c - m / 2;
            if (j) {
                let q = this.a7;
                if ((isNaN_(this.a7) || n > this.a7 || this.a3._inner[h].b) && !g) {
                    if (this.a3._inner[h].b) {
                        g = true;
                    }
                    this.a3._inner[h].b = false;
                    this.a7 = n;
                    this.a8 = l;
                }
                this.c2 = Math.max(this.a7, this.c2);
                this.cz = Math.max(m, this.cz);
                this.c1 = Math.max(this.a8, this.c1);
                this.c0 = Math.max(k, this.c0);
            }
            else {
                this.c2 = Math.max(n, this.c2);
                this.cz = Math.max(m, this.cz);
                this.c1 = Math.max(l, this.c1);
                this.c0 = Math.max(k, this.c0);
            }
            let r = new Rect(0, o, p, n, m);
            a.add(r);
        }
        let s = 0;
        if (this.aq) {
            s = this.be() % 360;
            if (s < 0) {
                s += 360;
            }
        }
        let t = this.ac.b1();
        if (!t) {
            this.c3(s, b, d);
        }
        else {
            this.ae.ac();
        }
        if (this.aq) {
            for (let u = 0; u < a.count; u++) {
                let v = a._inner[u];
                v.y = this.a3._inner[u].c - this.cz / 2;
                a._inner[u] = v;
            }
        }
        let w = false;
        if (!this.aq && this.c2 <= this.a6) {
            w = true;
        }
        if (!w) {
            let x = this.co.height;
            let y = this.cy();
            let z = y;
            let aa = this.a3.count > 1 ? Math.abs(this.a3._inner[1].c - this.a3._inner[0].c) : x;
            let ab = Math.abs(Math.asin(aa / this.c2) * (180 / Math.PI));
            let ac = (s >= ab && s <= 180 - ab) || (s - 180 >= ab && s - 180 <= 180 - ab);
            for (let ad = 0; ad < a.count; ad++) {
                if (this.aq) {
                    let ae = s * (Math.PI / 180);
                    let af = this.bn(this.a4._inner[ad]);
                    z = Math.min(y / Math.abs(Math.cos(ae)), af);
                    if (ac) {
                        let ag;
                        if (s > 0 && s < 90) {
                            ag = (Math.PI / 180) * (90 - s);
                        }
                        else if (s > 270 && s < 360) {
                            ag = (Math.PI / 180) * (s - 270);
                        }
                        else {
                            ag = 0;
                        }
                        z = aa / Math.cos(ag);
                    }
                }
                let ah = a._inner[ad];
                ah.width = Math.min(ah.width, z);
                a._inner[ad] = ah;
                if (!(typeCast(TextBlock.$, this.a4._inner[ad]) !== null)) {
                    this.a4._inner[ad].width = z;
                }
                let ai = typeCast(TextBlock.$, this.a4._inner[ad]);
                if (ai != null) {
                    let aj = this.bt(ad, ai, z, b, d);
                    if (!Base.equalsStatic(ai.ak, aj)) {
                        ai.ak = aj;
                        this.a4._inner[ad].width = z;
                    }
                }
            }
            if (!t) {
                this.c3(s, b, d);
            }
        }
        if (this.cu()) {
            this.c4(a);
        }
        return a;
    }
    c3(a, b, c) {
        let d = a * (Math.PI / 180);
        let e = Math.abs(this.c1 * Math.cos(d)) + Math.abs(this.c0 * Math.sin(d));
        let f = this.bm();
        let g = (e + b + c) + (f) + this.ac.di;
        this.ba = Math.max(this.ac.d6, g);
    }
    c4(a) {
        this.ct.az(a, this.c2);
    }
    cc(a, b) {
        let c = 0;
        let d = this.c0 / 2;
        let e = new TransformGroup();
        let f = AngleSimplifier.a(this.be());
        let g = ((() => {
            let $ret = new RotateTransform();
            $ret.j = f;
            $ret.k = c;
            $ret.l = d;
            return $ret;
        })());
        let h = 0;
        let i = 0;
        if (f != 0 && f != 360) {
            f -= 90;
            if (f > 0 && f < 180) {
                g.k = this.c1;
                h = -this.c1 + this.c0 / 2;
                h = h + Math.sin(MathUtil.k(f - 180)) * (this.c0 / 2);
            }
            else {
                if (f >= 180) {
                    h = h - Math.cos(MathUtil.k(f)) * (this.c0 / 2);
                }
                else {
                    h = h + Math.cos(MathUtil.k(f)) * (this.c0 / 2);
                }
            }
        }
        let j = ((() => {
            let $ret = new TranslateTransform();
            $ret.j = h;
            $ret.k = i;
            return $ret;
        })());
        e.j.add(g);
        e.j.add(j);
        a.j = e;
    }
    cu() {
        return !this.ar && !this.aq;
    }
    cn() {
        let a = this.ai(this.ac.be);
        let b = this.bm();
        let c = this.ag;
        let d = 0;
        if (a == 1) {
            d += this.co.left;
            if (c == 3 || c == 7) {
                d += this.ac.di;
            }
        }
        else {
            d = this.co.right - b;
            if (c == 6 || c == 2) {
                d -= this.ac.di;
            }
        }
        let e = this.bk();
        let f = 0;
        let g = this.ac.be == null ? 1 : this.ac.be.verticalAlignment;
        if (g == 0) {
            f = this.co.top;
        }
        else if (g == 2) {
            f = this.co.bottom - e;
        }
        else {
            f = (this.co.top + (this.co.height / 2)) - (e / 2);
        }
        return new Rect(0, d, f, b, e);
    }
    ai(a) {
        if (a == null) {
            return this.ac.bh.ak(this.ac);
        }
        if (a.position == 0) {
            if (this.ac != null && this.ac.bh != null) {
                return this.ac.bh.ak(this.ac);
            }
            return 1;
        }
        return a.position;
    }
    ah() {
        return 2;
    }
    at(a) {
        return a == 2 || a == 3 || a == 6 || a == 7;
    }
    b1() {
        let a = this.ae.at();
        this.ac.gn(a);
        if (this.af != null && this.af.visibility != 0) {
            return;
        }
        let b = this.ac.di;
        if (b == 0) {
            return;
        }
        let c = this.ax();
        if (c == null) {
            return;
        }
        let d = this.co.left;
        let e;
        let f = this.ag;
        if (f == 2 || f == 6) {
            d = this.co.right;
            e = d - b;
        }
        else {
            e = d + b;
        }
        let g = this.ae.b();
        for (let h of fromEnum(c)) {
            this.b4(a, h, d, e, this.cp, g);
        }
        if (!this.ab.contains(this.ae.av)) {
            this.ab.add(this.ae.av);
        }
    }
}
VerticalAxisLabelPanel.$t = markType(VerticalAxisLabelPanel, 'VerticalAxisLabelPanel', AxisLabelPanelBase.$);
/**
 * @hidden
 */
let IHasCategoryAxis_$type = new Type(null, 'IHasCategoryAxis');
/**
 * @hidden
 */
let IHasCategoryModePreference_$type = new Type(null, 'IHasCategoryModePreference', null, [IHasCategoryAxis_$type]);
/**
 * @hidden
 */
let IHighlightingManager_$type = new Type(null, 'IHighlightingManager');
/**
 * @hidden
 */
class HighlightingInfo extends Base {
    constructor() {
        super();
        this.f = 0;
        this.e = 0;
        this.a = 0;
        this.d = 0;
        this.c = false;
        this.b = null;
        this.a = HighlightingState.outward;
        this.d = 0;
        this.c = false;
    }
}
HighlightingInfo.$t = markType(HighlightingInfo, 'HighlightingInfo');
/**
 * @hidden
 */
let ISeriesInteractionManager_$type = new Type(null, 'ISeriesInteractionManager');
/**
 * @hidden
 */
let ISeriesViewerInteractionManager_$type = new Type(null, 'ISeriesViewerInteractionManager');
/**
 * @hidden
 */
let IDataChartVisualDataManager_$type = new Type(null, 'IDataChartVisualDataManager');
/**
 * @hidden
 */
let IAxisVisualDataManager_$type = new Type(null, 'IAxisVisualDataManager');
/**
 * @hidden
 */
let ISeriesVisualDataManager_$type = new Type(null, 'ISeriesVisualDataManager');
/**
 * @hidden
 */
class XamDataChart extends SeriesViewer {
    constructor() {
        super();
        this._xsr = null;
        this.ow = null;
        this.pe = 1;
        this.pf = 1;
        this.o7 = false;
        this.os = new AxisCollection();
        this.axisRangeChanged = null;
        this.oz = null;
        this.ph = 0;
        this.pj = 0;
        this.pi = 0;
        this.pg = 0;
        this.ab = XamDataChart.$;
        let a = this.axes;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.ql));
        let b = this.axes;
        b.collectionResetting = delegateCombine(b.collectionResetting, runOn(this, this.qm));
    }
    get XSRP() {
        if (this._xsr == null) {
            this._xsr = new SRProvider(this.b1.i.ae);
        }
        return this._xsr;
    }
    get ox() {
        if (this.ow == null) {
            this.ow = DVContainer.instance.createInstance(IDataChartVisualDataManager_$type, () => this.XSRP.q);
        }
        return this.ow;
    }
    static staticInit() {
        XamDataChart.pp = -1.7976931348623157E+308;
        XamDataChart.po = 1.7976931348623157E+308;
    }
    static pw(a) {
        if (a.bs == null) {
            return -1;
        }
        if (!a.cw) {
            return -1;
        }
        let b = XamDataChartView.au(a);
        if (b.count == 0) {
            return -1;
        }
        let c = -1;
        for (let d = 0; d < b.count; d++) {
            c = Math.max(c, b._inner[d].fh);
        }
        let e = c + 1;
        if (a.cs) {
            e = a.e7();
            if (e == -1) {
                return -1;
            }
            let f = a.a6();
            e = f.fh + e;
        }
        return e;
    }
    ki(a, b, c, d) {
        super.ki(a, b, c, d);
        switch (b) {
            case XamDataChart.$$p[18]:
                this.pk = this.pu;
                break;
            case XamDataChart.$$p[19]:
                this.pl = this.pv;
                break;
            case "ActualWindowScaleHorizontal":
            case "ActualWindowScaleVertical":
                if (!this.d5) {
                    this.lp(this.e4(), this.e5());
                }
                break;
            case XamDataChart.$$p[7]:
                this.b1.fj(d);
                {
                    for (let e of fromEnum(this.axes)) {
                        e.ha();
                    }
                }
                break;
            case XamDataChart.$$p[8]:
                this.o6 = this.o5;
                break;
            case XamDataChart.$$p[17]:
                this.o9 = this.pc;
                break;
            case XamDataChart.$$p[9]:
            case XamDataChart.$$p[11]:
                this.ll();
                break;
            case XamDataChart.$$p[0]:
            case XamDataChart.$$p[16]:
                if (c != d) {
                    for (let f of fromEnum(this.axes)) {
                        f.ci = true;
                        f.ha();
                    }
                }
                break;
            case XamDataChart.$$p[6]:
            case XamDataChart.$$p[4]:
            case XamDataChart.$$p[5]:
                for (let g of fromEnum(this.axes)) {
                    g.hi();
                }
                break;
        }
    }
    qo() {
        this.n6 = this.n4(this.oh);
        for (let a of fromEnum(this.axes)) {
            a.ci = true;
            a.ha();
        }
        for (let b of fromEnum(this.series)) {
            b.jl(false);
        }
    }
    e4() {
        return this.pk;
    }
    e5() {
        return this.pl;
    }
    le() {
        super.le();
        this.pk = this.n2.width;
        this.pl = this.n2.height;
    }
    get pk() {
        return this.pe;
    }
    set pk(a) {
        let b = this.pe;
        this.pe = a;
        this.km("ActualWindowScaleHorizontal", b, this.pe);
    }
    get pl() {
        return this.pf;
    }
    set pl(a) {
        let b = this.pf;
        this.pf = a;
        this.km("ActualWindowScaleVertical", b, this.pf);
    }
    dp() {
        return this.o6;
    }
    dq() {
        return this.o9;
    }
    qq(a, b, c, d) {
        if (a.ac == null) {
            return;
        }
        if (a.ac.ci || a.ac.i9.isEmpty) {
            return;
        }
        this.o7 = true;
        let e = 0;
        let f = 0;
        let g = b.left;
        let h = b.right;
        let i = c.left + g;
        let j = d.right + g;
        let k = 0;
        k = this.oh.right + this.b1.a3;
        if (i < 0) {
            e = -i;
            e += this.pm;
        }
        if (j > k) {
            f = j - k;
            f += this.pm;
        }
        e = Math.max(e, 0);
        f = Math.max(f, 0);
        e = Math.min(e, this.pn);
        f = Math.min(f, this.pn);
        this.e2 = Math.max(e, f);
    }
    get axes() {
        return this.os;
    }
    ql(a, b) {
        if (b.oldItems != null) {
            for (let c of fromEn(b.oldItems)) {
                if (c != null) {
                    c.bn = null;
                    c.bh = null;
                    this.k1(c);
                    this.b1.dq(c);
                    c.rangeChanged = delegateRemove(c.rangeChanged, runOn(this, this.qn));
                    this.b1.dr(c);
                    if (c.cz != null) {
                        for (let d of fromEnum(c.cw())) {
                            d.jl(false);
                        }
                    }
                }
            }
            if (this.axes.count == 0) {
                this.k6();
            }
        }
        if (b.newItems != null) {
            for (let e of fromEn(b.newItems)) {
                if (e != null) {
                    this.lh(e);
                    e.bn = this.actualSyncLink;
                    e.bh = this;
                    e.a4.aw();
                    this.b1.bm(e);
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.qn));
                    this.b1.bj(e);
                }
            }
        }
        this.i1();
    }
    qm(a, b) {
        let c = new List$1(Series.$, 0);
        for (let d of fromEnum(this.axes)) {
            if (d.cz != null) {
                for (let e of fromEnum(d.cw())) {
                    if (!c.contains(e)) {
                        c.add(e);
                    }
                }
            }
            d.bn = null;
            d.bh = null;
            this.k1(d);
            this.b1.dq(d);
            d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.qn));
            this.b1.dr(d);
            this.k6();
        }
        for (let f of fromEnum(this.series)) {
            if (!c.contains(f)) {
                c.add(f);
            }
        }
        for (let g of fromEnum(c)) {
            g.jl(false);
        }
    }
    qn(a, b) {
        let c = typeCast(Axis.$, a);
        if (c == null) {
            return;
        }
        this.i1();
        if (this.axisRangeChanged != null) {
            this.axisRangeChanged(this, new ChartAxisRangeChangedEventArgs(this, c, b.oldMinimumValue, b.minimumValue, b.oldMaximumValue, b.maximumValue));
        }
        if (c.ai != null) {
            c.ai.g7();
        }
        c.g7();
        let d = this.cw;
        if (typeCast(CategoryAxisBase.$, c) !== null) {
            d = true;
        }
        for (let e of fromEnum(c.cw())) {
            e.dl = true;
            this.i1();
            e.jl(d);
        }
        if (c.bh != null) {
            for (let f of fromEnum(c.bh.series)) {
                XamDataChart.qp(c, d, f);
            }
        }
        for (let g of fromEnum(this.axes)) {
            if (g != c && g.ai != null && g.ai == c) {
                g.g7();
            }
        }
    }
    static qp(a, b, c) {
    }
    ln(a, b) {
        super.ln(a, b);
        if (this.axes == null) {
            return;
        }
        for (let c of fromEnum(this.axes)) {
            c.bn = this.actualSyncLink;
            c.bh = this;
        }
    }
    getFontInfo() {
        this.oz = this.oy.fg;
        return this.oz;
    }
    qr() {
        this.b1.d8();
        for (let a of fromEnum(this.axes)) {
            a.hb(false);
        }
        for (let b of fromEnum(this.series)) {
            b.bi.bg();
            b.jl(false);
        }
    }
    getFontBrush() {
        return this.oy.fo;
    }
    ih() {
        super.ih();
        let a = new List$1(Axis.$, 0);
        for (let b = 0; b < this.axes.count; b++) {
            a.add(this.axes._inner[b]);
        }
        for (let c = 0; c < a.count; c++) {
            this.axes.remove(a._inner[c]);
            if (typeCast(CategoryAxisBase.$, a._inner[c]) !== null) {
                let d = a._inner[c];
                this.k3(d.name, true);
                d.itemsSource = null;
            }
            a._inner[c].g0(null, null);
        }
    }
    nf() {
        return this.oy.fk;
    }
    d0() {
        return true;
    }
    li() {
        super.li();
        if (!this.ds) {
            return;
        }
        for (let a of fromEnum(this.axes)) {
            this.lh(a);
        }
    }
    ng(a) {
        return this.rf(a, this.oo);
    }
    rf(a, b) {
        if (b != null && b.count > 0) {
            return b.item(a % b.count);
        }
        else {
            return null;
        }
    }
    nk(a) {
        return this.rf(a, this.op);
    }
    nl(a) {
        return this.rf(a, this.oq);
    }
    nm(a) {
        return this.rf(a, this.or);
    }
    c4() {
        if (this.o8) {
            return true;
        }
        return this.o4();
    }
    o4() {
        for (let a = 0; a < this.series.count; a++) {
            if (this.series._inner[a].c2 || this.series._inner[a].c0) {
                return true;
            }
        }
        for (let b = 0; b < this.axes.count; b++) {
            if (this.axes._inner[b].b2 || this.axes._inner[b].ce) {
                return true;
            }
        }
        return false;
    }
    b0() {
        return new XamDataChartView(this);
    }
    j6(a) {
        super.j6(a);
        this.oy = a;
    }
    ky() {
        for (let a = 0; a < this.os.count; a++) {
            this.os._inner[a].ci = true;
            this.os._inner[a].hb(false);
        }
        super.ky();
    }
    get pr() {
        return this.ph;
    }
    set pr(a) {
        this.ph = a;
        this.qo();
    }
    get pt() {
        return this.pj;
    }
    set pt(a) {
        this.pj = a;
        this.qo();
    }
    get ps() {
        return this.pi;
    }
    set ps(a) {
        this.pi = a;
        this.qo();
    }
    get pq() {
        return this.pg;
    }
    set pq(a) {
        this.pg = a;
        this.qo();
    }
    n4(a) {
        let b = super.n4(a);
        if (a.isEmpty) {
            return Rect.empty;
        }
        if (this.pr == 0 && this.pt == 0 && this.ps == 0 && this.pq == 0) {
            return Rect.empty;
        }
        if (this.pr + this.ps >= a.width || this.pt + this.pq >= a.height) {
            return Rect.empty;
        }
        let c = new Rect(0, a.left + this.pr, a.top + this.pt, a.width - this.pr - this.ps, a.height - this.pt - this.pq);
        return c;
    }
    oa() {
        let a = this.oh;
        let b = this.oi;
        let c = this.n6;
        if (c.isEmpty || a.isEmpty) {
            return a;
        }
        if (c.containsRect(a)) {
            return a;
        }
        if (a.containsRect(c)) {
            return c;
        }
        return a;
    }
    px() {
        return this.ox.exportVisualData(this);
    }
    p7() {
        let cvd_ = this.px();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    }
    kf() {
        super.kf();
        for (let a = 0; a < this.axes.count; a++) {
            let b = this.axes._inner[a];
            let c = 50;
            if (!isNaN_(b.av.ba)) {
                c = b.av.ba;
            }
            b.dk = c;
        }
    }
    k0() {
        super.k0();
        for (let a = 0; a < this.axes.count; a++) {
            let b = this.axes._inner[a];
            b.dk = NaN;
            b.ci = true;
            b.hb(false);
        }
    }
    pd(a) {
        let b = new List$1(Axis.$, 0);
        for (let c of fromEnum(this.series)) {
            let d = c.am(a);
            if (d != null) {
                b.add(d);
            }
        }
        return b;
    }
}
XamDataChart.$t = markType(XamDataChart, 'XamDataChart', SeriesViewer.$);
XamDataChart.pp = 0;
XamDataChart.po = 0;
XamDataChart.$$p = markDep(DependencyProperty, PropertyMetadata, XamDataChart, 'km', ['AlignsGridLinesToPixels:o2:qs', [0, true], 'AutoExpandMarginExtraPadding:pm:qt', [1, DeviceUtils.g(2)], 'AutoExpandMarginMaximumValue:pn:qu', [1, 60], 'Brushes:oo:qv', [BrushCollection.$, null], 'DefaultAxisMajorStroke:rc:qw', [Brush.$, null], 'DefaultAxisMinorStroke:rd:qx', [Brush.$, null], 'DefaultAxisStroke:re:qy', [Brush.$, null], 'GridMode:ov:qz', [GridMode_$type, enumGetBox(GridMode_$type, 2)], 'HorizontalZoomable:o5:q0', [0, false], 'IsHorizontalZoomEnabled:o6:q1', [0, false], 'IsSquare:o8:q2', [0, false], 'IsVerticalZoomEnabled:o9:q3', [0, false], 'MarkerBrushes:op:q4', [BrushCollection.$, null], 'MarkerOutlines:oq:q5', [BrushCollection.$, null], 'Outlines:or:q6', [BrushCollection.$, null], 'ShouldAutoExpandMarginForInitialLabels:pa:q7', [0, false], 'ShouldClipGridlines:pb:q8', [0, true], 'VerticalZoomable:pc:q9', [0, false], 'WindowScaleHorizontal:pu:ra', [1, NaN], 'WindowScaleVertical:pv:rb', [1, NaN]]);
/**
 * @hidden
 */
class LabelPanelArranger extends Base {
    static e(a, b) {
        for (let c of fromEnum(a)) {
            let d = c.ac;
            let e = d.ai;
            e = LabelPanelArranger.a(c, d, e);
            let f = LabelPanelArranger.b(c);
            let g = 0;
            let h = 0;
            let i = 0;
            if (d.b1()) {
                c.ae.ac();
                i = c.ba;
            }
            else {
                i = c.bb(b);
            }
            g = i;
            h = i;
            if (c.ac.ay != null && c.ac.ay.visibility != 0) {
                h = 0;
                g = 0;
            }
            if (c.ao()) {
                switch (f) {
                    case 0:
                        b.y = Math.max(0, b.top + h);
                        b.height = Math.max(0, b.height - h);
                        d.ay.c = 0;
                        break;
                    case 4:
                        if (e != null && (c.a9 - b.top < h && typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                            d.ay.c = 5;
                        }
                        else {
                            d.ay.c = 4;
                        }
                        break;
                    case 5:
                        if (e != null && (b.bottom - c.a9 < h && typeCast(HorizontalAxisLabelPanel.$, c) !== null)) {
                            if (d.ay != null) {
                                d.ay.c = 4;
                            }
                        }
                        else {
                            if (d.ay != null) {
                                d.ay.c = 5;
                            }
                        }
                        break;
                    case 1:
                    default:
                        if (d.ay != null) {
                            d.ay.c = 1;
                        }
                        b.height = Math.max(0, b.height - h);
                        break;
                }
            }
            if (typeCast(VerticalAxisLabelPanel.$, c) !== null) {
                switch (f) {
                    case 3:
                        b.width = Math.max(0, b.width - g);
                        d.ay.c = 3;
                        break;
                    case 6:
                        if (e != null && c.a9 - b.left < g) {
                            d.ay.c = 7;
                        }
                        else {
                            d.ay.c = 6;
                        }
                        break;
                    case 7:
                        if (e != null && b.right - c.a9 < g) {
                            d.ay.c = 6;
                        }
                        else {
                            d.ay.c = 7;
                        }
                        break;
                    case 2:
                    default:
                        if (d.ay != null) {
                            d.ay.c = 2;
                        }
                        b.x = Math.max(0, b.left + g);
                        b.width = Math.max(0, b.width - g);
                        break;
                }
            }
            if (c.ac.b2) {
                if (d.ay != null) {
                    d.ay.c = f;
                }
            }
        }
        return b;
    }
    static a(a, b, c) {
        return b.aj();
    }
    static b(a) {
        if (a == null) {
            return 1;
        }
        else {
            let b = a.ac;
            if (b != null && b.ay != null) {
                let c = b.ay.c;
                if (!a.at(c)) {
                    return a.ah();
                }
                return c;
            }
            else {
                return a.ah();
            }
        }
    }
    static c(a, b, c, d) {
        let e = a.ac;
        let f = e.ai;
        f = LabelPanelArranger.a(a, e, f);
        let g = LabelPanelArranger.b(a);
        let h;
        let i = a.bb(c);
        let j = Math.max(0, i);
        let k = Math.max(0, i);
        if (a.ac != null && a.ac.ay != null && a.ac.ay.visibility == 1) {
            return;
        }
        switch (g) {
            case 3:
                b.g = b.g - k;
                b.d = b.d - k;
                h = new Rect(0, b.g, c.top, k, c.height);
                d(a, h);
                break;
            case 2:
                h = new Rect(0, b.f, c.top, k, c.height);
                d(a, h);
                b.f = b.f + k;
                b.c = b.c + k;
                break;
            case 7:
                if (f != null) {
                    h = new Rect(0, b.f + a.a9, c.top, k, c.height);
                }
                else {
                    b.d = b.d - k;
                    h = new Rect(0, b.d, c.top, k, c.height);
                }
                d(a, h);
                break;
            case 6:
                if (f != null) {
                    h = new Rect(0, b.f + a.a9 - k, c.top, k, c.height);
                }
                else {
                    h = new Rect(0, b.c, c.top, k, c.height);
                    b.c = b.c + k;
                }
                d(a, h);
                break;
            case 1:
                b.a = b.a - j;
                b.b = b.b - j;
                h = new Rect(0, c.left, b.a, c.width, j);
                d(a, h);
                break;
            case 0:
                h = new Rect(0, c.left, b.h, c.width, j);
                d(a, h);
                b.h = b.h + j;
                b.e = b.e + j;
                break;
            case 5:
                if (f != null) {
                    h = new Rect(0, c.left, b.h + a.a9, c.width, j);
                }
                else {
                    b.b = b.b - j;
                    h = new Rect(0, c.left, b.b, c.width, j);
                }
                d(a, h);
                break;
            case 4:
                if (f != null) {
                    h = new Rect(0, c.left, b.h + a.a9 - j, c.width, j);
                }
                else {
                    h = new Rect(0, c.left, b.e, c.width, j);
                    b.e = b.e + j;
                }
                d(a, h);
                break;
        }
        if (a.ac.b2) {
            h = new Rect(0, c.left, c.top, c.width, c.height);
            d(a, h);
        }
    }
    static d(a, b, c, d) {
        let e = new List$1(AxisLabelPanelBase.$, 0);
        let f = new List$1(AxisLabelPanelBase.$, 0);
        for (let g of fromEnum(a)) {
            let h = LabelPanelArranger.b(g);
            switch (h) {
                case 1:
                case 2:
                case 0:
                case 3:
                    f.add(g);
                    break;
                case 5:
                case 6:
                case 4:
                case 7:
                    e.add(g);
                    break;
            }
        }
        for (let i of fromEnum(f)) {
            LabelPanelArranger.c(i, b, c, d);
        }
        for (let j of fromEnum(e)) {
            LabelPanelArranger.c(j, b, c, d);
        }
    }
}
LabelPanelArranger.$t = markType(LabelPanelArranger, 'LabelPanelArranger');
/**
 * @hidden
 */
class ChartContentManager extends DependencyObject {
    constructor(a) {
        super();
        this.l = null;
        this.q = new Dictionary$2(ChartContentType_$type, Dictionary$2.$.specialize(DependencyObject.$, ContentInfo.$), 0);
        this.s = new List$1(Series.$, 0);
        this.m = false;
        this.u = null;
        this.p = false;
        this.n = false;
        this.o = false;
        this.o = true;
        this.n = true;
        this.q.addItem(0, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        this.q.addItem(1, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        this.q.addItem(2, new Dictionary$2(DependencyObject.$, ContentInfo.$, 0));
        this.l = a;
    }
    get t() {
        return this.s;
    }
    set t(a) {
        this.s = a;
    }
    k(a, b, c) {
        let d = this.j(a, b);
        d.a = c;
        return d;
    }
    ac(a, b) {
        let c = this.q.item(a);
        if (c.containsKey(b)) {
            c.removeItem(b);
        }
        let d = typeCast(Series.$, b);
        if (d != null && this.t.contains(d)) {
            this.t.remove(d);
        }
    }
    z(a) {
        let b = this.u;
        this.u = a;
        if (this.m && b == null && this.u != null) {
            this.u.setTimeout(runOn(this, this.v), 0);
        }
    }
    y() {
        if (!this.m) {
            this.m = true;
            if (this.u != null) {
                this.u.setTimeout(runOn(this, this.v), 0);
            }
            else {
            }
        }
    }
    ab(a, b, c, d) {
        let e = c;
        if (!e.c) {
            e.b = d;
        }
        else {
            if (!d) {
                e.b = false;
            }
        }
        if (!e.c) {
            e.c = true;
            this.y();
        }
    }
    j(a, b) {
        let c = this.q.item(a);
        let d = null;
        if (!((() => { let e = c.tryGetValue(b, d); d = e.p1; return e.ret; })())) {
            d = new ContentInfo();
            d.h = b;
            c.addItem(b, d);
            let e = typeCast(Series.$, b);
            if (e != null && !this.t.contains(e)) {
                if (e.cs) {
                    let f = e.a6();
                    let g = this.t.indexOf(f) + 1;
                    g += e.fb();
                    if (this.t.count <= g || f.fg() == 0 || g == -1) {
                        this.t.add(e);
                    }
                    else {
                        this.t.insert(g, e);
                    }
                }
                else {
                    this.t.add(e);
                }
            }
        }
        return d;
    }
    x() {
        this.v();
    }
    v() {
        if (this.l == null || this.q == null) {
            return;
        }
        if (!this.m) {
            return;
        }
        this.m = false;
        if (this.l != null) {
            this.l.h8();
        }
        for (let a of fromEnum(this.r())) {
            a.f();
        }
        if (!this.m) {
            this.l.kn();
        }
    }
    *_r() {
        let a = null;
        a = this.q.item(1);
        for (let b of fromEnum(a.values)) {
            yield b;
        }
        a = this.q.item(0);
        let c = new List$1(ContentInfo.$, 0);
        for (let d of fromEnum(this.t)) {
            if (!d.cj) {
                c.add(a.item(d));
            }
        }
        for (let e of fromEnum(this.t)) {
            if (e.cj) {
                c.add(a.item(e));
            }
        }
        for (let f of fromEnum(c)) {
            yield f;
        }
        a = this.q.item(2);
        for (let g of fromEnum(a.values)) {
            yield g;
        }
    }
    r() {
        return toEnum(() => this._r());
    }
    w(a) {
        for (let b of fromEnum(this.q.item(1).values)) {
            b.h.gy();
        }
        for (let c of fromEnum(this.q.item(1).values)) {
            c.f();
        }
        for (let d of fromEnum(this.q.item(1).values)) {
            d.h.i8 = Rect.empty;
        }
    }
    ad(a, b, c, d) {
        c.i = d;
    }
    aa(a, b) {
        if (!b.e) {
            b.e = true;
            this.y();
        }
    }
}
ChartContentManager.$t = markType(ChartContentManager, 'ChartContentManager', DependencyObject.$);
/**
 * @hidden
 */
class ContentInfo extends Base {
    constructor() {
        super(...arguments);
        this.h = null;
        this.a = null;
        this.b = false;
        this.c = false;
        this.i = null;
        this.e = false;
    }
    get d() {
        if (this.i.isEmpty) {
            return false;
        }
        if (this.i.width == 0 && this.i.height == 0) {
            return false;
        }
        return true;
    }
    g() {
        if (this.e && typeCast(Axis.$, this.h) !== null) {
            this.e = false;
            let a = this.c;
            this.c = true;
            let b = this.h.co(true);
            if (!b) {
                this.c = a;
            }
        }
    }
    f() {
        this.g();
        if (typeCast(Axis.$, this.h) !== null) {
            let a = typeCast(Axis.$, this.h);
            if (a.ai != null) {
                let b = a.ai;
                if (b.a5 != null && b.a5.e) {
                    b.a5.g();
                }
            }
        }
        if (this.c) {
            this.c = false;
            this.a(this.b);
            this.b = false;
        }
    }
}
ContentInfo.$t = markType(ContentInfo, 'ContentInfo');
/**
 * @hidden
 */
class Series extends Control {
    constructor() {
        super();
        this.bi = null;
        this.fk = 0;
        this.lz = null;
        this.e3 = null;
        this.b1 = null;
        this.a1 = null;
        this.az = null;
        this.bt = null;
        this.j5 = null;
        this.dy = new Dictionary$2(String_$type, String_$type, 0);
        this.dx = new Dictionary$2(String_$type, FastReflectionHelper.$, 0);
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.renderRequested = null;
        this.dm = false;
        this.bh = null;
        this.aq = null;
        this.b6 = true;
        this.de = false;
        this.df = false;
        this.b7 = false;
        this.cd = false;
        this.bm = null;
        this.br = null;
        this.d3 = null;
        this.a4 = null;
        this.b0 = null;
        this.e0 = null;
        this.j2 = null;
        this.av = null;
        this.bl = 0;
        this.bj = 0;
        this.bk = 0;
        this.cf = false;
        this.le = null;
        this.lf = null;
        this.b9 = false;
        this.b5 = false;
        this.fn = null;
        this.a7 = new SeriesComponentsForView();
        this.b8 = false;
        this.fz = null;
        this.e2 = null;
        this._coercionMethods = null;
        this.b4 = false;
        this.bb = 0;
        this.ba = 0;
        this.b3 = null;
        this.lp = { $type: Point_$type, x: NaN, y: NaN };
        this.d4 = NaN;
        this.d5 = NaN;
        DVContainer.instance.registerIfLoaded("AnnotationFactoryManager");
        DVContainer.instance.registerIfLoaded("InteractivityFactoryManager");
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        this.fk = Series.e5++;
        this.dl = true;
        this.lz = Rect.empty;
        this.bi = this.bf();
        this.bi.br = Rect.empty;
        this.i2(this.bi);
        this.bi.k = true;
        this.bi.ap();
        this.bi.k = false;
        this.ab = Series.$;
        this.b0 = (a, b) => {
            if (this.bs == null || !this.bs.c7) {
                this.j1(b.oldRect, b.newRect);
            }
        };
        this.a4 = (a, b) => this.i7(a, b.propertyName, b.oldValue, b.newValue);
        this.e0 = (a, b) => {
            if (this.bs != null) {
                this.dl = true;
                this.bs.i2();
            }
            this.h6(b.action, b.position, b.count, b.propertyName);
        };
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.i7(a, b.propertyName, b.oldValue, b.newValue));
        this.j5 = new Canvas();
        this.bt = new DoubleAnimator(0, 1, this.fi);
        let a = this.bt;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.hw));
        this.g(Series.la, ((() => {
            let $ret = new Binding(1, "Visibility");
            $ret.d = this;
            return $ret;
        })()));
        this.bc = this.bd();
    }
    get e4() {
        return this.e3;
    }
    set e4(a) {
        this.e3 = a;
        this.bt.u(this.e3);
    }
    provideRenderer(a) {
        this.e4 = a;
    }
    g3() {
        return this.a0.a$q(this);
    }
    hw(a, b) {
        this.ez = this.bt.o;
    }
    get b2() {
        if (this.b1 == null) {
            this.b1 = new SRProvider(this.e4);
        }
        if (this.b1.l == null) {
            if (this.e4 != null) {
                this.b1.l = this.e4;
            }
            else if (this.bs != null && this.bs.b1 != null && this.bs.b1.i != null && this.bs.b1.i.ae != null) {
                this.b1.l = this.bs.b1.i.ae;
            }
        }
        return this.b1;
    }
    get a2() {
        if (this.a1 == null) {
            this.a1 = DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, () => this.b2.q);
        }
        return this.a1;
    }
    get dz() {
        return this.a0.a$h;
    }
    get a0() {
        if (this.az == null) {
            this.az = DVContainer.instance.createInstance(ISeriesInteractionManager_$type, () => this.b2.n);
            if (this.toolTip != null) {
                this.az.a$ah(this, this.toolTip);
            }
        }
        return this.az;
    }
    get cx() {
        return DVContainer.instance.checkLoaded("InteractivityFactoryManager");
    }
    i2(a) {
    }
    i0() {
        this.hx(this.aw, this.aw);
        if (this.bz == null && this.bn != null && this.itemsSource != null) {
            this.bz = this.bn.getFastItemsSource(this.itemsSource);
        }
        this.bi.as();
    }
    i1() {
        this.h2();
        if (this.bz != null && this.bn != null && this.itemsSource != null) {
            this.bz = this.bn.releaseFastItemsSource(this.itemsSource);
        }
        this.bi.at();
    }
    bg() {
        return this.bf();
    }
    bf() {
        return new SeriesView(this);
    }
    dt() {
        return false;
    }
    fs(a, b) {
        return null;
    }
    g2(a) {
        if (!this.dy.containsKey(a)) {
            let b = a.charAt(0).toUpperCase() + a.substr(1);
            this.dy.addItem(a, b);
        }
        return this.dy.item(a);
    }
    ft(a, b, c) {
        let d = null;
        if (!this.dx.containsKey(b)) {
            d = new FastReflectionHelper(false, c);
            this.dx.addItem(b, d);
        }
        else {
            d = this.dx.item(b);
        }
        d.propertyName = c;
        return d.getPropertyValue(a);
    }
    eb(a) {
        return this.e8(a);
    }
    fa(a) {
        return -1;
    }
    get_c1() {
        return false;
    }
    get c1() {
        return this.get_c1();
    }
    ap() {
        return null;
    }
    e8(a) {
        return -1;
    }
    fp(a) {
        return null;
    }
    fu(a, b) {
        return a.fp(b);
    }
    e7() {
        return -1;
    }
    fb() {
        return -1;
    }
    fg() {
        return -1;
    }
    get container() {
        return this.bs;
    }
    get hasSubItems() {
        return this.ci();
    }
    ci() {
        return false;
    }
    forSubItems(a) {
        this.ie(a);
    }
    ie(a) {
    }
    ig(a) {
    }
    lj() {
        return null;
    }
    resolveLegendIndex() {
        return this.fh;
    }
    a6() {
        return null;
    }
    get_cj() {
        return false;
    }
    get cj() {
        return this.get_cj();
    }
    get_isVertical() {
        return false;
    }
    get isVertical() {
        return this.get_isVertical();
    }
    get_cs() {
        return false;
    }
    get cs() {
        return this.get_cs();
    }
    get_ck() {
        return false;
    }
    get ck() {
        return this.get_ck();
    }
    get_c0() {
        return false;
    }
    get c0() {
        return this.get_c0();
    }
    get_c4() {
        return false;
    }
    get c4() {
        return this.get_c4();
    }
    get_c2() {
        return false;
    }
    get c2() {
        return this.get_c2();
    }
    get_isStacked() {
        return false;
    }
    get isStacked() {
        return this.get_isStacked();
    }
    get_cr() {
        return false;
    }
    get cr() {
        return this.get_cr();
    }
    get_c3() {
        return false;
    }
    get c3() {
        return this.get_c3();
    }
    get_cl() {
        return false;
    }
    get cl() {
        return this.get_cl();
    }
    get_ct() {
        return false;
    }
    get ct() {
        return this.get_ct();
    }
    get_c5() {
        return false;
    }
    get c5() {
        return this.get_c5();
    }
    get_c6() {
        return false;
    }
    get c6() {
        return this.get_c6();
    }
    a5() {
        return null;
    }
    get_cm() {
        return false;
    }
    get cm() {
        return this.get_cm();
    }
    get_cn() {
        return false;
    }
    get cn() {
        return this.get_cn();
    }
    d9(a, b, c, d, e) {
        return Number.POSITIVE_INFINITY;
    }
    ea(a, b, c, d, e, f, g) {
        return this.a0.a$i(this, a, b, c, d, e, f, g);
    }
    get_dv() {
        return false;
    }
    get dv() {
        return this.get_dv();
    }
    ep(a, b, c, d, e, f, g, h) {
        return this.a0.a$l(this, a, b, c, d, e, f, g, h);
    }
    ef(a, b, c, d, e, f, g, h) {
        return this.a0.a$k(this, a, b, c, d, e, f, g, h);
    }
    ff(a, b, c, d, e) {
        return this.a0.a$n(this, a, b, c, d, e);
    }
    ee(a) {
        return (a ? 10 : 3);
    }
    ah(a) {
        return null;
    }
    ai(a) {
        return null;
    }
    dg(a, b) {
        return this.a0.a$d(this, a, b);
    }
    aj(a, b, c, d, e, f) {
        return this.a0.a$a(this, a, b, c, d, e, f);
    }
    di(a, b, c) {
        return this.a0.a$e(this, a, b, c);
    }
    dj(a, b) {
        return this.a0.a$f(this, a, b);
    }
    fd(a, b, c, d, e) {
        return this.a0.a$m(this, a, b, c, d, e);
    }
    ed(a, b) {
        return this.a0.a$j(this, a, b);
    }
    fe(a, b) {
        return -1;
    }
    fc(a, b) {
        return -1;
    }
    en(a, b, c) {
        return NaN;
    }
    lv(a, b, c) {
        return { $type: Point_$type, x: NaN, y: NaN };
    }
    l4(a) {
        return Rect.empty;
    }
    ak(a) {
        let b = this.l4(a);
        if (!b.isEmpty) {
            let c = new Array(1);
            c[0] = b;
            return c;
        }
        return null;
    }
    l5(a) {
        return this.l4(this.ly(a));
    }
    al(a) {
        return this.ak(this.ly(a));
    }
    l6(a) {
        return Rect.empty;
    }
    l7(a) {
        return this.l6(this.ly(a));
    }
    dk(a, b) {
        return this.a0.a$g(this, a, b);
    }
    lx(a, b, c, d, e, f, g, h, i) {
        return this.a0.a$aj(this, a, b, c, d, e, f, g, h, i);
    }
    ej(a, b, c) {
        return this.en(a, b, c);
    }
    lr(a, b, c) {
        return this.lv(a, b, c);
    }
    el(a, b, c) {
        return this.en(a, b, c);
    }
    lt(a, b, c) {
        return this.lv(a, b, c);
    }
    lw(a, b, c) {
        let d = this.ly(a);
        return this.lv(d, b, c);
    }
    eo(a, b, c) {
        let d = this.ly(a);
        return this.en(d, b, c);
    }
    ls(a, b, c) {
        let d = this.ly(a);
        return this.lr(d, b, c);
    }
    ek(a, b, c) {
        let d = this.ly(a);
        return this.ej(d, b, c);
    }
    lu(a, b, c) {
        let d = this.ly(a);
        return this.lt(d, b, c);
    }
    em(a, b, c) {
        let d = this.ly(a);
        return this.el(d, b, c);
    }
    e9(a) {
        let b = this.ly(a);
        return this.e8(b);
    }
    eg() {
        return 0;
    }
    ec(a) {
        let b = this.ly(a);
        return this.eb(b);
    }
    fq(a) {
        let b = this.ly(a);
        return this.fp(b);
    }
    ch(a, b, c) {
        return false;
    }
    raisePropertyChanged(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    get_hasMarkers() {
        return false;
    }
    get hasMarkers() {
        return this.get_hasMarkers();
    }
    ij() {
    }
    lg() {
        return null;
    }
    lh() {
        return null;
    }
    j7() {
        return null;
    }
    ly(a) {
        let b = this.bs != null ? this.bs.n5 : this.bi.br;
        let c = this.bi.bs;
        let d = { $type: Point_$type, x: c.left + c.width * (a.x - b.left) / b.width, y: c.top + c.height * (a.y - b.top) / b.height };
        return d;
    }
    lq(a) {
        let b = this.bs != null ? this.bs.n5 : this.bi.br;
        let c = this.bi.bs;
        let d = b.left + (a.x - c.left) / c.width * b.width;
        let e = b.top + (a.y - c.top) / c.height * b.height;
        return { $type: Point_$type, x: d, y: e };
    }
    fv(a, b) {
        let c = this.bi.c(a);
        let d = c != null ? c.item : null;
        if (d == null) {
            let e = this.ly(b);
            d = this.fp(e);
        }
        return d;
    }
    c9(a) {
        return false;
    }
    an(a) {
        return new AxisRange(NaN, NaN);
    }
    ao(a) {
        return new AxisRange(NaN, NaN);
    }
    jl(a) {
        this.de = false;
        if (this.bs != null) {
            this.bs.al.ab(0, this, this.aq, a);
            if (this.renderRequested != null) {
                let b = new RenderRequestedEventArgs();
                b.animate = a;
                this.renderRequested(this, b);
                a = b.animate;
            }
        }
    }
    h9(a) {
        this.jm(a);
        this.de = false;
    }
    jm(a) {
        if (this.dp && !this.dc()) {
            this.dn = false;
        }
    }
    h0() {
        if (this.dm && !this.dp) {
            this.bt.r = truncate(Math.max(this.eq(), this.er()));
            this.h4();
        }
    }
    h4() {
    }
    jn(a, b) {
        if (this.bh == null) {
            this.bh = this.bf();
            this.bh.n = true;
            if (this.bs != null) {
                this.bs.ai.l(this.bh);
                this.bh.a = this.bs.ai;
            }
            this.bh.ap();
        }
        this.bh.br = a;
    }
    jk(a, b, c, d, e) {
        this.a0.a$r(this, a, b, d, e);
    }
    getEffectiveViewport1(a) {
        if (this.bs == null) {
            return Rect.empty;
        }
        if (a.m) {
            return this.bs.n6;
        }
        if (a.n) {
            if (this.bs.n6.isEmpty) {
                return this.bs.n6;
            }
            let b = this.bs.ob(a.br, this.bs.oh, this.bs.n6);
            return b;
        }
        return this.bs.n6;
    }
    l0(a) {
        if (this.bs == null || this.bs.n5.isEmpty) {
            return a.br;
        }
        if (a.m) {
            return a.br;
        }
        if (a.n) {
            if (this.bs.n6.isEmpty) {
                return a.br;
            }
            if (this.bs.n5.equals1(this.bs.oh)) {
                return a.br;
            }
            let b = this.bs.ob(a.br, this.bs.oh, this.bs.n6);
            let c = this.bs.n9(a.br, b, this.bs.n2);
            return c;
        }
        return this.bs.n5;
    }
    l3(a) {
        if (!this.l8.equals1(a)) {
            return Rect.empty;
        }
        return this.getEffectiveViewport();
    }
    l2(a) {
        if (this.bs == null || this.bs.n6.isEmpty) {
            return Rect.empty;
        }
        let b = this.bs.n6;
        let c = a.br;
        let d = (b.left - c.left) / c.width;
        let e = (b.top - c.top) / c.height;
        let f = (b.right - c.left) / c.width;
        let g = (b.bottom - c.top) / c.height;
        return new Rect(0, d, e, f - d, g - e);
    }
    getEffectiveViewport() {
        return this.getEffectiveViewport1(this.bi);
    }
    jf() {
        this.jg(null);
    }
    jg(a) {
        if (this.cx) {
            this.a0.a$ac(this, a);
        }
    }
    jh(a) {
        if (this.cx) {
            this.a0.a$ad(this, a, this.bs);
        }
    }
    getViewInfo(a, b) {
        a = this.bi.br;
        b = this.bi.bs;
        return {
            p0: a,
            p1: b
        };
    }
    dw(a, b, c) {
        if (a.width == 0 || a.height == 0) {
            return false;
        }
        if (this.cs) {
            return true;
        }
        return this._visibility == 0;
    }
    h3(a, b) {
        if (a) {
            this.dl = true;
        }
    }
    cb() {
        return this.cc(this.bi);
    }
    cc(a) {
        let b = a.br;
        let c = a.bs;
        if (!this.dw(b, c, a)) {
            this.h3(true, a);
            return true;
        }
        return false;
    }
    i3(a, b) {
        this.bi.br = b;
        this.j0(a, b);
        if (this.bs != null) {
            this.bs.al.ad(0, this, this.aq, b);
        }
    }
    j1(a, b) {
    }
    j0(a, b) {
    }
    get dl() {
        return this.b6;
    }
    set dl(a) {
        this.b6 = a;
    }
    id(a) {
        a.ia();
    }
    iu() {
        this.df = false;
        this.dl = true;
        if (this.bs != null) {
            this.bs.i2();
        }
    }
    it() {
        this.df = false;
        this.dl = true;
        if (this.bs != null) {
            this.bs.i1();
        }
    }
    get_cw() {
        return true;
    }
    get cw() {
        return this.get_cw();
    }
    get_isUsableInLegend() {
        return true;
    }
    get isUsableInLegend() {
        return this.get_isUsableInLegend();
    }
    iy() {
        this.bi.al();
    }
    iv() {
        this.i4();
    }
    i4() {
        this.bi.aw();
        this.i6(false);
    }
    i5() {
        this.bi.aw();
        this.i6(true);
    }
    c8() {
        return false;
    }
    i6(a) {
        if (this.aq == null || this.aq.c) {
            return;
        }
        let b = this.bi.br;
        let c = this.bi.bs;
        let d = this.dw(b, c, this.bi);
        let e = this.bs != null && this.bs.dl && this.bh != null && this.dw(this.bh.br, this.bh.bs, this.bh);
        if (d) {
            if (a) {
                this.de = !this.c8();
                this.h9(false);
            }
            else {
                this.jl(false);
                this.de = !this.c8();
            }
        }
        if (e) {
            if (!this.dl) {
                this.it();
                this.df = true;
            }
        }
    }
    get dn() {
        return this.b7;
    }
    set dn(a) {
        this.b7 = a;
    }
    get dp() {
        if (this.dn == false) {
            return false;
        }
        return this.er() > 0;
    }
    v() {
        super.v();
        this.raisePropertyChanged("Opacity", this._opacity, this._opacity);
    }
    w(a, b) {
        super.w(a, b);
        this.raisePropertyChanged("Visibility", enumGetBox(Visibility_$type, a), enumGetBox(Visibility_$type, b));
    }
    i7(a, b, c, d) {
        switch (b) {
            case "SyncLink":
                if (typeCast(SyncLink.$, c) !== null) {
                    let e = c;
                    e.propertyUpdated = delegateRemove(e.propertyUpdated, this.a4);
                    this.je(typeCast(IFastItemsSourceProvider_$type, c));
                }
                if (typeCast(SyncLink.$, d) !== null) {
                    let f = d;
                    f.propertyUpdated = delegateCombine(f.propertyUpdated, this.a4);
                    this.jd(typeCast(IFastItemsSourceProvider_$type, d));
                }
                if (this.fh == -1) {
                    this.fh = XamDataChart.pw(this);
                }
                break;
            case XamDataChart.$$p[3]:
            case XamDataChart.$$p[13]:
            case XamDataChart.$$p[12]:
            case XamDataChart.$$p[14]:
                this.ia();
                break;
            case "SeriesViewer":
                if (typeCast(SeriesViewer.$, c) !== null) {
                    this.e4 = null;
                    let g = c;
                    g.windowRectChanged = delegateRemove(g.windowRectChanged, this.b0);
                    let h = c.series;
                    h.collectionChanged = delegateRemove(h.collectionChanged, this.d3);
                    let i = c;
                    i.propertyUpdated = delegateRemove(i.propertyUpdated, this.a4);
                    c.al.ac(0, this);
                    this.jg(c);
                    this.bi.ah(c);
                }
                if (typeCast(SeriesViewer.$, d) !== null) {
                    this.e4 = d.b1.i.ae;
                    let j = d;
                    j.windowRectChanged = delegateCombine(j.windowRectChanged, this.b0);
                    let k = d.series;
                    k.collectionChanged = delegateCombine(k.collectionChanged, this.d3);
                    let l = d;
                    l.propertyUpdated = delegateCombine(l.propertyUpdated, this.a4);
                    this.aq = d.al.k(0, this, runOn(this, this.h9));
                    this.bi.ad(d);
                    this.jv();
                    this.ib();
                    this.fk = this.bs.ft();
                }
                if (this.bs == null) {
                    this.externalObject._ensureTooltipDestroyed();
                    this.bt.w();
                }
                if (this.fh != -1) {
                    this.jw();
                }
                if (this.fh == -1 || d == null) {
                    this.fh = XamDataChart.pw(this);
                }
                this.aw = this.ax();
                this.hy(typeCast(XamDataChart.$, c), typeCast(XamDataChart.$, d));
                break;
            case Series.$$p[23]:
                if (this.bi != null) {
                    this.bi.av();
                }
                break;
            case "HitTestMode":
                this.bc = this.bd();
                break;
            case "ActualHitTestMode":
                if (this.bs != null) {
                    this.bs.kx();
                }
                break;
            case "LegendItemBadgeTemplate":
            case "LegendItemTemplate":
                this.bi.bg();
                break;
            case Series.$$p[4]:
            case Series.$$p[14]:
            case Series.$$p[5]:
            case Series.$$p[6]:
                this.ia();
                this.i4();
                break;
            case "Index":
                if (typeGetValue(c) != typeGetValue(d)) {
                    this.ia();
                    this.i4();
                }
                break;
            case "RadiusX":
            case "RadiusY":
            case "RoundedCornersLocation":
                this.i4();
                break;
            case Series.$$p[3]:
                this.jv();
                this.i4();
                break;
            case Series.$$p[21]:
            case Series.$$p[7]:
            case Series.$$p[12]:
                this.i4();
                break;
            case Series.$$p[9]:
                this.iy();
                this.i4();
                break;
            case Series.$$p[31]:
            case Series.$$p[17]:
            case Series.$$p[16]:
            case Series.$$p[18]:
            case Series.$$p[19]:
                this.i4();
                break;
            case Series.$$p[1]:
            case Series.$$p[2]:
            case Series.$$p[22]:
                this.le = this.lb;
                this.lf = this.lc;
                this.i4();
                this.bi.bg();
                if (this.toolTip != null && this.az != null) {
                    this.a0.a$ah(this, this.toolTip);
                }
                break;
            case "Visibility":
                this.bi.bh();
                break;
            case "ItemsSource":
                if (this.bn != null) {
                    this.jd(this.bn);
                }
                break;
            case Series.$$p[8]:
                if (c != d && d != null) {
                    this.dn = true;
                }
                this.iu();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    let m = c;
                    m.event = delegateRemove(m.event, this.e0);
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    let n = d;
                    n.event = delegateCombine(n.event, this.e0);
                }
                break;
            case "Legend":
                if (d != null) {
                    if (a == this) {
                        d.seriesOwner = this;
                    }
                    else if (typeCast(XamDataChart.$, a) !== null) {
                        d.chartOwner = a;
                    }
                }
                this.aw = this.ax();
                break;
            case "ActualLegend":
                this.hx(typeCast(IChartLegend_$type, c), typeCast(IChartLegend_$type, d));
                break;
            case "LegendItem":
                this.hz(typeCast(Control.$, c), typeCast(Control.$, d));
                break;
            case Series.$$p[11]:
                this.bi.aq();
                break;
            case Series.$$p[24]:
                if (this.az != null) {
                    this.a0.a$ah(this, this.toolTip);
                }
                break;
            case "CrosshairPoint":
                if (this.bs != null) {
                    if (!this.cd) {
                        this.bs.kp(this, this.fp(this.bs.nu));
                    }
                }
                break;
            case Series.$$p[15]:
                this.jl(false);
                this.it();
                break;
            case Series.$$p[25]:
            case Series.$$p[26]:
                this.bt.w();
                this.bt.r = this.fi;
                this.bt.b = this.bu;
                this.jl(false);
                break;
            case "DiscreteLegendItemTemplate":
                this.jl(false);
                break;
            case "VisibilityProxy":
                if (c != d) {
                    this.jl(false);
                }
                this.it();
                this.bi.bh();
                break;
            case Series.$$p[10]:
                this.b9 = this.cg();
                this.jl(false);
                break;
            case Series.$$p[20]:
                this.ib();
                break;
            case "FinalValue":
                this.jy();
                break;
        }
    }
    ib() {
        if (this.bs != null && (this.externalObject.owner)) {
            let sv_ = this.bs;
            this.externalObject.owner._ensureDefaultTooltip(this.externalObject);
            ;
        }
    }
    cg() {
        return this.cu && this.cv;
    }
    get_cv() {
        return false;
    }
    get cv() {
        return this.get_cv();
    }
    h8(a) {
        a.cd = true;
    }
    get bn() {
        return this.bm;
    }
    set bn(a) {
        if (this.bn != a) {
            let b = this.bn;
            this.bm = a;
            this.raisePropertyChanged("SyncLink", b, this.bn);
        }
    }
    get bs() {
        return this.br;
    }
    set bs(a) {
        if (this.bs != a) {
            let b = this.bs;
            this.br = a;
            this.raisePropertyChanged("SeriesViewer", b, this.br);
        }
    }
    get bq() {
        return typeCast(XamDataChart.$, this.bs);
    }
    set bq(a) {
        this.bs = a;
    }
    get itemsSource() {
        return this.c(Series.kl);
    }
    set itemsSource(a) {
        this.h(Series.kl, a);
    }
    h6(a, b, c, d) {
        if (this.bs != null) {
            this.bs.kq();
        }
    }
    get legend() {
        return this.c(Series.kp);
    }
    set legend(a) {
        this.h(Series.kp, a);
    }
    get j4() {
        if (this.j2 == null && this.aw != null) {
            this.j2 = this.j3();
        }
        return this.j2;
    }
    set j4(a) {
        if (this.j4 != a) {
            let b = this.j4;
            this.j2 = a;
            this.raisePropertyChanged("LegendItem", b, this.j2);
        }
    }
    fw() {
        return this.j3();
    }
    j3() {
        let a = typeCast(ContentControl.$, this.j2);
        let b = this.legendItemTemplate;
        if (b == null) {
            b = this.bi.bi(this.bl);
        }
        if (b != null) {
            if (a == null) {
                a = new ContentControl();
            }
            a.content = ((() => {
                let $ret = new DataContext();
                $ret.series = this;
                $ret.item = null;
                return $ret;
            })());
            a.ah = b;
        }
        else {
            a = null;
        }
        return a;
    }
    get aw() {
        return this.av;
    }
    set aw(a) {
        if (this.aw != a) {
            let b = this.av;
            this.av = a;
            this.raisePropertyChanged("ActualLegend", b, this.av);
        }
    }
    get legendItemBadgeTemplate() {
        return this.c(Series.km);
    }
    set legendItemBadgeTemplate(a) {
        this.h(Series.km, a);
    }
    get legendItemTemplate() {
        return this.c(Series.kn);
    }
    set legendItemTemplate(a) {
        this.h(Series.kn, a);
    }
    get j6() {
        return this.c(Series.kf);
    }
    set j6(a) {
        this.h(Series.kf, a);
    }
    get fh() {
        return typeGetValue(this.c(Series.ki));
    }
    set fh(a) {
        this.h(Series.ki, a);
    }
    jz() {
        this.jw();
    }
    ia() {
        this.jw();
    }
    jw() {
        this.it();
        if (this.fh < 0) {
            return;
        }
        if (this.ld != null) {
            this.bi.a4();
            this.bi.ae();
        }
        else {
            this.lb = this.bs == null ? null : this.bs.ng(this.fh);
        }
        if (this.li != null) {
            this.bi.a5();
            this.bi.af();
        }
        else {
            this.lc = this.bs == null ? null : this.bs.nm(this.fh);
        }
    }
    ca() {
        return this.bt.f();
    }
    jt() {
        this.bt.v();
    }
    get_cq() {
        return true;
    }
    get cq() {
        return this.get_cq();
    }
    jv() {
        let a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? a.oy.fh : this.d7;
        }
    }
    get co() {
        return this.b5;
    }
    set co(a) {
        this.b5 = a;
    }
    as(a) {
        return ((() => {
            let $ret = new DataContext();
            $ret.series = this;
            $ret.item = a;
            return $ret;
        })());
    }
    bo() {
        return 1;
    }
    jj() {
        this.bi.a0();
    }
    jo() {
        this.dn = true;
        this.jl(true);
    }
    ji() {
        this.h1();
    }
    h1() {
    }
    ik() {
    }
    static *_d1(a, b, c) {
        for (let d = b; d < c; d++) {
            yield a(d);
        }
    }
    static d1(a, b, c) {
        return toEnum(() => Series._d1(a, b, c));
    }
    static d0(a, b) {
        return Series.d1(a, 0, b);
    }
    a8() {
        return this.a7;
    }
    jp(a) {
        this.jx(a);
    }
    eq() {
        return this.fi;
    }
    er() {
        return this.fj;
    }
    get_dq() {
        return this.b8;
    }
    set_dq(a) {
        this.b8 = a;
    }
    get dq() {
        return this.get_dq();
    }
    set dq(a) {
        this.set_dq(a);
    }
    get db() {
        return this.dq;
    }
    at(a, b) {
        return null;
    }
    au(a, b) {
        return null;
    }
    iz(a, b, c, d) {
        this.a0.a$w(this, a, b, c, d);
    }
    js(a) {
        this.a0.a$ag(this, a);
    }
    hy(a, b) {
        if (this.aw != null && this.j4 != null) {
            if (b == null && this.aw.containsChild(this.j4)) {
                this.aw.removeChild(this.j4);
            }
            if (b != null && !this.aw.containsChild(this.j4) && this.l9 != 1) {
                this.aw.addChildInOrder(this.j4, this);
            }
        }
    }
    h2() {
        if (this.aw == null || this.j4 == null) {
            return;
        }
        this.aw.removeChild(this.j4);
    }
    hx(a, b) {
        if (this.j4 != null) {
            if (a != null && a.containsChild(this.j4)) {
                a.removeChild(this.j4);
            }
            if (this.bs != null && b != null && !b.containsChild(this.j4) && this.l9 != 1) {
                b.addChildInOrder(this.j4, this);
            }
        }
    }
    hz(a, b) {
        if (this.aw != null) {
            if (a != null && this.aw.containsChild(a)) {
                this.aw.removeChild(a);
            }
            if (this.bs != null && b != null && this.l9 != 1) {
                this.aw.addChildInOrder(b, this);
            }
        }
    }
    je(a) {
        this.bz = a.releaseFastItemsSource(this.itemsSource);
    }
    jd(a) {
        this.bz = a.getFastItemsSource(this.itemsSource);
    }
    ax() {
        if (this.legend != null) {
            return this.legend;
        }
        if (this.bs != null && this.bs.legend != null) {
            return this.bs.legend;
        }
        return null;
    }
    dc() {
        return false;
    }
    da(a) {
        return (a && this.eq() > 0) || this.ca() || (this.dp && this.dc() && this.er() > 0);
    }
    h7(a) {
        if (a != null) {
            a.bx(this);
        }
    }
    jc(a) {
        if (a != null) {
            a.ck(this);
        }
    }
    a9() {
        return this.bi.g();
    }
    jx(a) {
        this.bi.a6(a);
    }
    jr(a, b) {
        this.a0.a$af(this, a, b);
    }
    get_ds() {
        return false;
    }
    get ds() {
        return this.get_ds();
    }
    i8(a, b) {
        this.bi.ao(a, b);
    }
    ja(a) {
        this.i3(this.l8, a);
    }
    ii(a) {
        if (this.bz != null) {
            this.bz.handleCollectionChanged(a);
        }
    }
    ir(a, b, c) {
        this.ii(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    io() {
        this.ii(new NotifyCollectionChangedEventArgs(0, 4));
    }
    ip(a, b) {
        this.ii(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    iq(a, b) {
        this.ii(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    ju() {
        this.jl(false);
    }
    dh(a, b) {
        return false;
    }
    get_coercionMethods() {
        return this._coercionMethods;
    }
    set_coercionMethods(a) {
        this._coercionMethods = a;
    }
    get coercionMethods() {
        return this.get_coercionMethods();
    }
    set coercionMethods(a) {
        this.set_coercionMethods(a);
    }
    get_expectFunctions() {
        return this.b4;
    }
    set_expectFunctions(a) {
        let b = this.b4;
        this.b4 = a;
        if (b != this.b4) {
            this.raisePropertyChanged("ExpectFunctions", b, this.b4);
        }
    }
    get expectFunctions() {
        return this.get_expectFunctions();
    }
    set expectFunctions(a) {
        this.set_expectFunctions(a);
    }
    ar(a, b) {
        return null;
    }
    get be() {
        return this.bb;
    }
    set be(a) {
        let b = this.bb;
        this.bb = a;
        if (b != this.bb) {
            this.raisePropertyChanged("HitTestMode", enumGetBox(SeriesHitTestMode_$type, b), enumGetBox(SeriesHitTestMode_$type, this.bb));
        }
    }
    bd() {
        return this.be == 0 ? 2 : this.be;
    }
    get bc() {
        return this.ba;
    }
    set bc(a) {
        let b = this.ba;
        this.ba = a;
        if (b != this.ba) {
            this.raisePropertyChanged("ActualHitTestMode", enumGetBox(SeriesHitTestMode_$type, b), enumGetBox(SeriesHitTestMode_$type, this.ba));
        }
    }
    bw(a) {
        if (a == null) {
            return this.bz.registerColumn(null, null, false);
        }
        let b = null;
        let c = SeriesViewer.bn(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumn(a, b, this.expectFunctions);
    }
    bx(a) {
        if (a == null) {
            return this.bz.registerColumnInt(null, null, false);
        }
        let b = null;
        let c = SeriesViewer.bn(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumnInt(a, b, this.expectFunctions);
    }
    by(a) {
        if (a == null) {
            return this.bz.registerColumnObject(null, null, false);
        }
        let b = null;
        let c = SeriesViewer.bn(a, this.coercionMethods);
        b = c.a;
        return this.bz.registerColumnObject(a, b, this.expectFunctions);
    }
    get l8() {
        return this.bi != null ? this.bi.br : Rect.empty;
    }
    get_cz() {
        return false;
    }
    get cz() {
        return this.get_cz();
    }
    get_cy() {
        return true;
    }
    get cy() {
        return this.get_cy();
    }
    jq(a, b) {
    }
    h5(a, b) {
        this.a2.copyVisualData(a, b);
    }
    fo() {
        let a = this.a2.exportVisualData(this, this.l8);
        this.ic(a);
        this.bi.ai(a);
        return a;
    }
    ic(a) {
    }
    il(a) {
        if (this.lp.x != a.x || this.lp.y != a.y) {
            this.lp = a;
            this.ix(a);
        }
    }
    ix(a) {
    }
    im() {
    }
    is() {
    }
    am(a) {
        return null;
    }
    ag() {
        return null;
    }
    eh() {
        return NaN;
    }
    static ei(a, b) {
        if (a == null || a.count == 0) {
            return NaN;
        }
        if (b != null && b.i$b != null) {
            if (b.i$b.count != a.count) {
                return NaN;
            }
            for (let c = 0; c < a.count; c++) {
                if (!isNaN_(a.item(b.i$b._inner[c])) && a.item(b.i$b._inner[c]) != 0) {
                    return a.item(b.i$b._inner[c]);
                }
            }
        }
        for (let d = 0; d < a.count; d++) {
            if (!isNaN_(a.item(d)) && a.item(d) != 0) {
                return a.item(d);
            }
        }
        return NaN;
    }
    iw() {
    }
    get d8() {
        return this.d4;
    }
    set d8(a) {
        let b = this.d8;
        if (a != b) {
            this.d4 = a;
            this.raisePropertyChanged("FinalValue", b, this.d8);
        }
    }
    get et() {
        return this.d5;
    }
    set et(a) {
        let b = this.et;
        if (a != b) {
            this.d5 = a;
            this.raisePropertyChanged("PercentChange", b, this.et);
        }
    }
    jy() {
        let a = this.eh();
        this.et = (this.d8 - a) / a * 100;
    }
    fr(a) {
        return null;
    }
    get f7() {
        return !stringIsNullOrWhiteSpace(this.b2.bz) ? this.b2.bz : "Open";
    }
    get f2() {
        return !stringIsNullOrWhiteSpace(this.b2.bw) ? this.b2.bw : "Close";
    }
    get f3() {
        return !stringIsNullOrWhiteSpace(this.b2.bx) ? this.b2.bx : "High";
    }
    get f6() {
        return !stringIsNullOrWhiteSpace(this.b2.by) ? this.b2.by : "Low";
    }
    get gb() {
        return !stringIsNullOrWhiteSpace(this.b2.b0) ? this.b2.b0 : "Volume";
    }
    get ga() {
        return !stringIsNullOrWhiteSpace(this.b2.b9) ? this.b2.b9 : "Value";
    }
    get f9() {
        return !stringIsNullOrWhiteSpace(this.b2.m) ? this.b2.m : "Radius";
    }
}
Series.$t = markType(Series, 'Series', Control.$, [INotifyPropertyChanged_$type, IProvidesViewport_$type, ILegendSeries_$type, ILegendOwner_$type, ILegendTemplateProvider_$type]);
Series.e5 = 0;
Series.la = DependencyProperty.i("VisibilityProxy", Visibility_$type, Series.$, new PropertyMetadata(2, enumGetBox(Visibility_$type, 0), (a, b) => a.raisePropertyChanged("VisibilityProxy", b.oldValue, b.newValue)));
Series.kl = DependencyProperty.i("ItemsSource", IEnumerable_$type, Series.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(Series.$, a);
    if (c.bn != null) {
        c.bn.releaseFastItemsSource(b.oldValue);
    }
    a.raisePropertyChanged("ItemsSource", b.oldValue, b.newValue);
}));
Series.kp = DependencyProperty.i("Legend", IChartLegend_$type, Series.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(Series.$, a);
    c.raisePropertyChanged("Legend", b.oldValue, b.newValue);
}));
Series.km = DependencyProperty.i("LegendItemBadgeTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(Series.$, a);
    c.raisePropertyChanged("LegendItemBadgeTemplate", b.oldValue, b.newValue);
    if (c.j4 != null) {
        c.j4 = c.j3();
    }
}));
Series.kn = DependencyProperty.i("LegendItemTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(Series.$, a);
    c.raisePropertyChanged("LegendItemTemplate", b.oldValue, b.newValue);
    if (c.j4 != null) {
        c.j4 = c.j3();
    }
}));
Series.kf = DependencyProperty.i("DiscreteLegendItemTemplate", DataTemplate.$, Series.$, new PropertyMetadata(2, null, (a, b) => {
    let c = typeCast(Series.$, a);
    c.raisePropertyChanged("DiscreteLegendItemTemplate", b.oldValue, b.newValue);
}));
Series.ki = DependencyProperty.i("Index", Number_$type, Series.$, new PropertyMetadata(2, -1, (a, b) => {
    let c = typeCast(Series.$, a);
    c.raisePropertyChanged("Index", b.oldValue, b.newValue);
    if (c.j4 != null) {
        c.j4 = c.j3();
    }
}));
Series.$$p = markDep(DependencyProperty, PropertyMetadata, Series, 'raisePropertyChanged', ['ActualAreaFillOpacity:d6:j8', [1, 1], 'ActualBrush:lb:j9', [Brush.$], 'ActualOutline:lc:ka', [Brush.$], 'AreaFillOpacity:d7:kb', [1, NaN], 'Brush:ld:kc', [Brush.$, null], 'DashArray:ll:kd', [DoubleCollection.$], 'DashCap:lm:ke', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'EndCap:ln:kg', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'FastItemsSource:bz:kh', [IFastItemsSource_$type], 'IsDropShadowEnabled:cp:kj', [0, false], 'IsHighlightingEnabled:cu:kk', [0, false], 'LegendItemVisibility:l9:ko', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'MiterLimit:es:kq', [1, 0], 'MouseOverEnabled:c7:kr', [0, true], 'Outline:li:ks', [Brush.$, null], 'Resolution:eu:kt', [1, 1], 'ShadowBlur:ev:ku', [1, NaN], 'ShadowColor:lk:kv', [Color.$], 'ShadowOffsetX:ew:kw', [1, NaN], 'ShadowOffsetY:ex:kx', [1, NaN], 'ShowDefaultTooltip:dd:ky', [0, false], 'StartCap:lo:kz', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'Thickness:ey:k0', [1, DeviceUtils.g(2)], 'Title:fx:k1', [4, "Series Title"], 'ToolTip::k2', [4, null], 'TransitionDuration:fi:k3', [1, 0], 'TransitionEasingFunction:bu:k4', [Delegate_$type, null], 'TransitionInDuration:fj:k5', [1, 1000], 'TransitionInEasingFunction:bv:k6', [Delegate_$type, null], 'TransitionInSpeedType:bp:k7', [TransitionInSpeedType_$type, enumGetBox(TransitionInSpeedType_$type, 0)], 'TransitionProgress:ez:k8', [1, 0], 'UseSingleShadow:du:k9', [0, true]]);
/**
 * @hidden
 */
class MarkerSeries extends Series {
    constructor() {
        super();
        this.mv = null;
    }
    i2(a) {
        super.i2(a);
        this.ma = a;
    }
    get_hasMarkers() {
        return true;
    }
    lg() {
        return this.m8;
    }
    lh() {
        return this.m9;
    }
    j7() {
        return this.mv;
    }
    static get mx() {
        if (MarkerSeries.mt == null) {
            MarkerSeries.mt = new DataTemplate();
        }
        return MarkerSeries.mt;
    }
    get na() {
        return this.c(MarkerSeries.m1);
    }
    set na(a) {
        this.h(MarkerSeries.m1, a);
    }
    md() {
        return this.mv != null && ((this.mb != 1 && this.mb != 0) || this.mw != null);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "MarkerBrush":
            case MarkerSeries.$$p[7]:
            case MarkerSeries.$$p[3]:
            case MarkerSeries.$$p[5]:
            case MarkerSeries.$$p[6]:
                this.jw();
                this.i4();
                break;
            case MarkerSeries.$$p[2]:
                this.mv = d;
                if (c == MarkerSeries.mx || d == MarkerSeries.mx || (c == null || d != null)) {
                    this.ma.cd();
                    let e = typeCast(MarkerSeriesView.$, this.bh);
                    if (e != null) {
                        e.cd();
                    }
                    this.jl(false);
                }
                this.bi.bg();
                if (this.toolTip != null && this.cx) {
                    this.a0.a$ah(this, this.toolTip);
                }
                this.it();
                break;
            case MarkerSeries.$$p[8]:
                this.ma.ck(this.mf);
                this.jl(false);
                break;
            case MarkerSeries.$$p[0]:
            case MarkerSeries.$$p[1]:
                if (this.md()) {
                    this.jl(false);
                }
                break;
        }
    }
    static ml(a) {
        switch (a) {
            case 3:
            case 13: return SeriesViewer.$$p[1];
            case 4: return SeriesViewer.$$p[29];
            case 5: return SeriesViewer.$$p[21];
            case 6: return SeriesViewer.$$p[23];
            case 7: return SeriesViewer.$$p[4];
            case 8: return SeriesViewer.$$p[13];
            case 9: return SeriesViewer.$$p[6];
            case 10: return SeriesViewer.$$p[26];
            case 11: return SeriesViewer.$$p[14];
            case 12: return SeriesViewer.$$p[7];
            case 0:
            case 1:
            default: return null;
        }
    }
    static mc(a, b) {
        let c = a.bs != null ? b : 1;
        if (c == 2) {
            let d = [3, 4, 8, 10, 7, 6, 9, 11, 5, 12];
            c = a.fh >= 0 ? d[a.fh % d.length] : 1;
        }
        return c;
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        if (this.ma.bz()) {
            this.ma.cb();
            this.ma.b5();
        }
        else {
            let a = MarkerSeries.mc(this, this.mb);
            let b = MarkerSeries.ml(a);
            if (b == null) {
                this.mu = MarkerSeries.mx;
            }
            else {
                this.ma.b8(b);
            }
        }
        if (this.na != null && this.mb != 13) {
            this.ma.b9();
            this.ma.b6();
        }
        else {
            if (this.mb == 13) {
                this.m8 = this.bi.bn();
            }
            else {
                this.m8 = this.bs == null ? null : this.bs.nk(this.fh);
            }
        }
        if (this.nb != null) {
            this.ma.ca();
            this.ma.b7();
        }
        else {
            if (this.mb == 13) {
                this.m9 = this.bi.bn();
            }
            else {
                this.m9 = this.bs == null ? null : this.bs.nl(this.fh);
            }
        }
    }
    ic(a) {
        super.ic(a);
        this.a2.exportMarkerVisualData(this, a);
    }
    me(a, b) {
        if (this.hasMarkers && this.md()) {
            let c = this.l7(a);
            if (c.isEmpty) {
                return false;
            }
            let d = RectUtil.r(c, this.ee(b));
            if (d.containsPoint(a)) {
                return true;
            }
        }
        return false;
    }
    ar(a, b) {
        let c = this.ma.bv(a);
        let d = null;
        if (c != null) {
            d = c.content;
        }
        return d;
    }
}
MarkerSeries.$t = markType(MarkerSeries, 'MarkerSeries', Series.$);
MarkerSeries.mt = null;
MarkerSeries.m1 = DependencyProperty.i("MarkerBrush", Brush.$, MarkerSeries.$, new PropertyMetadata(1, (a, b) => {
    let c = (typeCast(MarkerSeries.$, a));
    c.raisePropertyChanged("MarkerBrush", b.oldValue, b.newValue);
}));
MarkerSeries.$$p = markDep(DependencyProperty, PropertyMetadata, MarkerSeries, 'raisePropertyChanged', ['ActualMarkerBrush:m8:my', [Brush.$], 'ActualMarkerOutline:m9:mz', [Brush.$], 'ActualMarkerTemplate:mu:m0', [DataTemplate.$, null], 'MarkerOutline:nb:m2', [Brush.$], 'MarkerStyle:nc:m3', [Style.$], 'MarkerTemplate:mw:m4', [DataTemplate.$, null], 'MarkerThickness:mg:m5', [1, DeviceUtils.g(2)], 'MarkerType:mb:m6', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'UseLightweightMarkers:mf:m7', [0, false]]);
/**
 * @hidden
 */
class SyncLink extends FrameworkElement {
    constructor() {
        super();
        this.ai = null;
        this.af = new Dictionary$2(IEnumerable_$type, FastItemsSourceReference.$, 0);
        this.aq = null;
        this.ab = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.am(a, b.propertyName, b.oldValue, b.newValue));
        this.ab = new ChartCollection();
        let a = this.ab;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.aj));
        this.aq = new Rect(0, 0, 0, 1, 1);
    }
    am(a, b, c, d) {
    }
    releaseFastItemsSource(a) {
        if (a != null) {
            let b = null;
            if (((() => { let c = this.af.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
                --b.b;
                if (b.b == 0) {
                    this.af.removeItem(a);
                }
            }
        }
        return null;
    }
    static ad(a) {
        return ((() => {
            let $ret = new FastItemsSource();
            $ret.e = a;
            return $ret;
        })());
    }
    getFastItemsSource(a) {
        if (SyncLink.ah == null) {
            SyncLink.ah = SyncLink.ad;
        }
        let b = null;
        if (a != null) {
            let c = null;
            if (!((() => { let d = this.af.tryGetValue(a, c); c = d.p1; return d.ret; })())) {
                b = SyncLink.ah(a);
                c = new FastItemsSourceReference(b);
                this.af.addItem(a, c);
            }
            c.b++;
            b = c.a;
        }
        return b;
    }
    ae(a) {
        let b = null;
        if (a != null) {
            let c = null;
            if (!((() => { let d = this.af.tryGetValue(a, c); c = d.p1; return d.ret; })())) {
                return null;
            }
            b = c.a;
        }
        return b;
    }
    ar(a, b, c) {
        return this.as(a, b, c, false);
    }
    as(a, b, c, d) {
        if (!c.isEmpty) {
            c = new Rect(0, c.left, c.top, c.width, c.height);
            let e = a.fm;
            if (b == a) {
                if (!d) {
                    if (!b.dp()) {
                        c.x = b.oi.x;
                        c.width = b.oi.width;
                    }
                    if (!b.dq()) {
                        c.y = b.oi.y;
                        c.height = b.oi.height;
                    }
                }
            }
            else {
                let f = SyncManager.a(b);
                if (f == null || !f.synchronizeHorizontally) {
                    c.x = b.oi.x;
                    c.width = b.oi.width;
                }
                if (f == null || !f.synchronizeVertically) {
                    c.y = b.oi.y;
                    c.height = b.oi.height;
                }
            }
            let g = 0.5 * (c.left + c.right);
            let h = 0.5 * (c.top + c.bottom);
            let i = c.width;
            let j = c.height;
            let k = MathUtil.b(c.width, e, 1);
            let l = MathUtil.b(c.height, e, 1);
            let m = false;
            if (a.d6() && !a.oh.isEmpty) {
                let n = a.oh;
                let o = n.width / n.height;
                let p = k * n.width;
                let q = l * n.height;
                let r = p / q;
                if (r != o) {
                    if (q * o > p) {
                        p = q * o;
                        k = p / n.width;
                    }
                    else {
                        q = p / o;
                        l = q / n.height;
                    }
                }
            }
            else if (a.c4()) {
                let s = false;
                let t = false;
                if (Math.abs(k - a.n2.width) > e) {
                    s = true;
                }
                if (Math.abs(l - a.n2.height) > e) {
                    t = true;
                }
                let u = a.iu(k, l, s, t);
                k = u.p0;
                l = u.p1;
                k = MathUtil.b(k, e, 1);
                l = MathUtil.b(l, e, 1);
            }
            else if (b.d2) {
                let v = 1.7976931348623157E+308;
                let w = -1.7976931348623157E+308;
                let x = c.left;
                let y = c.right;
                let z = c.top;
                let aa = c.bottom;
                let ab = c.width;
                let ac = c.height;
                if (b.bk == 1) {
                    if (x < 0) {
                        x = 0;
                        y = x + ab;
                    }
                    if (y > 1) {
                        y = 1;
                        x = y - ab;
                    }
                    if (z < 0) {
                        z = 0;
                        aa = z + ac;
                    }
                    if (aa > 1) {
                        aa = 1;
                        z = aa - ac;
                    }
                }
                let ad = new Rect(0, x, z, y - x, aa - z);
                for (let ae = 0; ae < b.series.count; ae++) {
                    let af = b.series._inner[ae];
                    if (af.cj) {
                        continue;
                    }
                    let ag = af.ag();
                    let ah = null;
                    for (let ai = 0; ai < ag.length; ai++) {
                        if (ag[ai].ch) {
                            ah = ag[ai];
                        }
                    }
                    if (ah != null) {
                        let aj = new Rect(0, 0, 0, 1, 1);
                        let ak = new ScalerParams(0, aj, aj, ah.ca, b.n6);
                        ak.b = af.eh();
                        let al = af.ao(ad);
                        let am = al == null || al.c == 1.7976931348623157E+308 || isNaN_(al.c);
                        if (am) {
                            continue;
                        }
                        let an = ah.dy(al.c, ak);
                        let ao = ah.dy(al.b, ak);
                        w = Math.max(w, an);
                        v = Math.min(v, ao);
                    }
                }
                let ap = (v == 1.7976931348623157E+308 || w == -1.7976931348623157E+308 || isNaN_(v) || isNaN_(w));
                if (!ap) {
                    c = new Rect(0, c.left, v, c.width, w - v);
                    k = c.width;
                    l = c.height;
                    m = true;
                }
            }
            let aq = k != i;
            let ar = l != j;
            let as = aq && !m ? g - 0.5 * k : c.left;
            let at = ar && !m ? h - 0.5 * l : c.top;
            let au = aq && !m ? g + 0.5 * k : c.right;
            let av = ar && !m ? h + 0.5 * l : c.bottom;
            if (b.bk == 1) {
                if (as < 0) {
                    as = 0;
                    au = as + k;
                }
                if (au > 1) {
                    au = 1;
                    as = au - k;
                }
                if (at < 0) {
                    at = 0;
                    av = at + l;
                }
                if (av > 1) {
                    av = 1;
                    at = av - l;
                }
            }
            c = new Rect(0, as, at, au - as, av - at);
        }
        return c;
    }
    get ag() {
        return this.ab;
    }
    aj(a, b) {
        if (b.newItems != null) {
            for (let c of fromEn(b.newItems)) {
                if (c.oi.isEmpty) {
                    c.oi = this.ar(null, c, this.aq);
                }
            }
        }
    }
    ak(a, b) {
        for (let c of fromEnum(this.ag)) {
            if (c == a) {
                c.nu = { $type: Point_$type, x: b.x, y: b.y };
            }
            else {
                let d = { $type: Point_$type, x: b.x, y: b.y };
                let e = SyncManager.a(c);
                if (e == null || !e.synchronizeHorizontally) {
                    d.x = NaN;
                }
                if (e == null || !e.synchronizeVertically) {
                    d.y = NaN;
                }
                c.nu = d;
            }
        }
    }
    al(a, b) {
        for (let c of fromEnum(this.ag)) {
            c.oc = this.ar(a, c, b);
        }
    }
    ao(a, b) {
        this.ap(a, b, false);
    }
    ap(a, b, c) {
        let d = b.isEmpty || isNaN_(b.x) || isNaN_(b.y) || isNaN_(b.width) || isNaN_(b.height);
        if (!d && !a.c2) {
            for (let e of fromEnum(this.ag)) {
                e.c2 = true;
                e.oi = this.as(a, e, b, c);
                e.c2 = false;
            }
        }
    }
    an(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
}
SyncLink.$t = markType(SyncLink, 'SyncLink', FrameworkElement.$, [INotifyPropertyChanged_$type, IFastItemsSourceProvider_$type]);
SyncLink.ah = null;
/**
 * @hidden
 */
class SyncLinkManager extends Base {
    constructor() {
        super();
        this.d = null;
        this.d = new Dictionary$2(String_$type, SyncLink.$, 0);
    }
    static instance() {
        if (SyncLinkManager.b == null) {
            SyncLinkManager.b = new SyncLinkManager();
        }
        return SyncLinkManager.b;
    }
    get e() {
        return this.d.count;
    }
    getLink(a) {
        let b;
        if (((() => { let c = this.d.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
            return b;
        }
        b = new SyncLink();
        b.ai = a;
        this.d.addItem(a, b);
        return b;
    }
    releaseLink(a) {
        if (a.ag.count == 0 && a.ai != null && this.d.containsKey(a.ai)) {
            this.d.removeItem(a.ai);
        }
    }
}
SyncLinkManager.$t = markType(SyncLinkManager, 'SyncLinkManager');
SyncLinkManager.b = null;
/**
 * @hidden
 */
class SyncManager extends Base {
    static e(a) {
        let b = SyncManager.a(a);
        if (b == null) {
            return;
        }
        if (!a.dk) {
            return;
        }
        if (a.syncChannel != b.syncChannel) {
            return;
        }
        SyncManager.b(a, a.syncChannel, null);
    }
    static c(a) {
        let b = SyncManager.a(a);
        if (b == null) {
            return;
        }
        if (a.dk && a.syncChannel == b.syncChannel) {
            return;
        }
        let c = null;
        if (a.dk) {
            c = a.syncChannel;
        }
        SyncManager.b(a, c, b.syncChannel);
    }
    static b(a, b, c) {
        if (a != null) {
            if (stringIsNullOrEmpty(c)) {
                let d = a.actualSyncLink;
                a.actualSyncLink = null;
                a.actualSyncLink = new SyncLink();
                if (d != null) {
                    SyncLinkManager.instance().releaseLink(d);
                }
                a.syncChannel = null;
            }
            else {
                if (!stringIsNullOrEmpty(b)) {
                    let e = a.actualSyncLink;
                    a.actualSyncLink = null;
                    if (e != null) {
                        SyncLinkManager.instance().releaseLink(e);
                    }
                }
                a.actualSyncLink = SyncLinkManager.instance().getLink(c);
                a.syncChannel = c;
            }
        }
    }
    static d(a, b) {
        a.syncSettings = b;
    }
    static a(a) {
        return a.syncSettings;
    }
}
SyncManager.$t = markType(SyncManager, 'SyncManager');
/**
 * @hidden
 */
class ChartCollection extends ObservableCollection$1 {
    constructor() {
        super(SeriesViewer.$, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
ChartCollection.$t = markType(ChartCollection, 'ChartCollection', ObservableCollection$1.$.specialize(SeriesViewer.$));
/**
 * @hidden
 */
class SeriesCollection extends ObservableCollection$1 {
    constructor() {
        super(Series.$, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
SeriesCollection.$t = markType(SeriesCollection, 'SeriesCollection', ObservableCollection$1.$.specialize(Series.$));
/**
 * @hidden
 */
class PlotAreaMouseEventArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._chartPosition = null;
        this._plotAreaPosition = null;
        this._isDuringManipulation = false;
        this._viewer = null;
        this.viewer = a;
        this.chartPosition = b;
        this.plotAreaPosition = c;
    }
    get chartPosition() {
        return this._chartPosition;
    }
    set chartPosition(a) {
        this._chartPosition = a;
    }
    get plotAreaPosition() {
        return this._plotAreaPosition;
    }
    set plotAreaPosition(a) {
        this._plotAreaPosition = a;
    }
    get isDuringManipulation() {
        return this._isDuringManipulation;
    }
    set isDuringManipulation(a) {
        this._isDuringManipulation = a;
    }
    get viewer() {
        return this._viewer;
    }
    set viewer(a) {
        this._viewer = a;
    }
}
PlotAreaMouseEventArgs.$t = markType(PlotAreaMouseEventArgs, 'PlotAreaMouseEventArgs', EventArgs.$);
/**
 * @hidden
 */
class PlotAreaMouseButtonEventArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._chartPosition = null;
        this._plotAreaPosition = null;
        this._manipulationOccurred = false;
        this._viewer = null;
        this.viewer = a;
        this.chartPosition = b;
        this.plotAreaPosition = c;
    }
    get chartPosition() {
        return this._chartPosition;
    }
    set chartPosition(a) {
        this._chartPosition = a;
    }
    get plotAreaPosition() {
        return this._plotAreaPosition;
    }
    set plotAreaPosition(a) {
        this._plotAreaPosition = a;
    }
    get manipulationOccurred() {
        return this._manipulationOccurred;
    }
    set manipulationOccurred(a) {
        this._manipulationOccurred = a;
    }
    get viewer() {
        return this._viewer;
    }
    set viewer(a) {
        this._viewer = a;
    }
}
PlotAreaMouseButtonEventArgs.$t = markType(PlotAreaMouseButtonEventArgs, 'PlotAreaMouseButtonEventArgs', EventArgs.$);
/**
 * @hidden
 */
class ChartCursorEventArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._item = null;
        this._series = null;
        this._seriesViewer = null;
        this.seriesViewer = a;
        this.series = b;
        this.item = c;
    }
    toString() {
        return this.seriesViewer.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "");
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get seriesViewer() {
        return this._seriesViewer;
    }
    set seriesViewer(a) {
        this._seriesViewer = a;
    }
    get chart() {
        return typeCast(XamDataChart.$, this.seriesViewer);
    }
}
ChartCursorEventArgs.$t = markType(ChartCursorEventArgs, 'ChartCursorEventArgs', EventArgs.$);
/**
 * @hidden
 */
class DataChartMouseButtonEventArgs extends EventArgs {
    constructor(a, b, c, d) {
        super();
        this.g = null;
        this._item = null;
        this._series = null;
        this._chart = null;
        this.chart = a;
        this.series = b;
        this.item = c;
        this.g = d;
    }
    toString() {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    }
    get handled() {
        return this.g.handled;
    }
    set handled(a) {
        this.g.handled = a;
    }
    getPosition(a) {
        return this.g.getPosition(a);
    }
    get originalSource() {
        return this.g.originalSource;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get chart() {
        return this._chart;
    }
    set chart(a) {
        this._chart = a;
    }
}
DataChartMouseButtonEventArgs.$t = markType(DataChartMouseButtonEventArgs, 'DataChartMouseButtonEventArgs', EventArgs.$);
/**
 * @hidden
 */
class ChartMouseEventArgs extends EventArgs {
    constructor(a, b, c, d) {
        super();
        this.f = null;
        this._item = null;
        this._series = null;
        this._chart = null;
        this.chart = a;
        this.series = b;
        this.item = c;
        this.f = d;
    }
    toString() {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    }
    getPosition(a) {
        return this.f.getPosition(a);
    }
    get originalSource() {
        return this.f.originalSource;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get chart() {
        return this._chart;
    }
    set chart(a) {
        this._chart = a;
    }
}
ChartMouseEventArgs.$t = markType(ChartMouseEventArgs, 'ChartMouseEventArgs', EventArgs.$);
/**
 * @hidden
 */
class AxisComponentsForView extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
    }
}
AxisComponentsForView.$t = markType(AxisComponentsForView, 'AxisComponentsForView');
/**
 * @hidden
 */
class AxisLabelPanelBaseView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.av = null;
        this.e = null;
        this.au = Rect.empty;
        this.c = null;
        this.h = 0;
        this.i = NaN;
        this.a = a;
    }
    aa(a, b, c, d, e, f) {
        let g = typeCast(FrameworkElement.$, a);
        if (g != null) {
            g._visibility = 0;
            if (b.width == 0 && b.height == 0) {
                g._visibility = 1;
            }
            let h = b.height - (d + f);
            let i = b.width - (c + e);
            g.n = b.left + c;
            g.o = b.top + d;
            if (i < 0) {
                i = 0;
            }
            if (h < 0) {
                h = 0;
            }
            g.l = h;
            g.m = i;
            if (g.j != null) {
                let j = g.j;
                let k = j.j._inner[0];
                k.k = k.k + g.n;
                k.l = k.l + g.o;
            }
        }
    }
    z(a, b, c, d, e, f, g, h) {
        let i = Math.max(e, Math.max(f, Math.max(g, h)));
        let j = new Thickness(0, i);
        if (this.a.aq) {
            j = new Thickness(0, Math.sqrt((i * i) / 2));
        }
        let k = c.d;
        if (isNaN_(k.c) || isNaN_(k.e) || isNaN_(k.d) || isNaN_(k.b)) {
            k = j;
        }
        if (k.c > j.c || k.e > j.e || k.d > j.d || k.b > j.b) {
            k = j;
        }
        let l = new Rect(0, d.left - k.c, d.top - k.e, d.width + k.c + k.d, d.height + k.e + k.b);
        let m = a.j;
        a.j = null;
        this.aa(a, l, e, f, g, h);
        a.j = m;
        a.width = a.m;
        a.height = a.l;
    }
    ad(a) {
        let b = a;
        b.j = null;
    }
    ag(a) {
    }
    ah(a, b) {
    }
    ai(a, b) {
        let c = typeCast(FrameworkElement.$, a);
        let d = 0;
        let e = 0;
        let f = new TransformGroup();
        let g = ((() => {
            let $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = d;
            $ret.l = e;
            return $ret;
        })());
        f.j.add(g);
        c.j = f;
    }
    aq(a, b, c, d, e, f, g, h, i) {
        let j = Math.max(e, Math.max(f, Math.max(g, h)));
        let k = new Thickness(0, j);
        if (this.a.aq) {
            k = new Thickness(0, Math.sqrt((j * j) / 2));
        }
        let l = c.d;
        if (isNaN_(l.c) || isNaN_(l.e) || isNaN_(l.d) || isNaN_(l.b)) {
            l = k;
        }
        if (l.c > k.c || l.e > k.e || l.d > k.d || l.b > k.b) {
            l = k;
        }
        let m = b.j;
        let n = new TransformGroup();
        let o = a.n + l.c;
        let p = a.o + l.e;
        n.j.add(m);
        a.j = n;
    }
    x(a, b, c, d) {
        let e = a.ak.length;
        let f = a.ak;
        let g = a.ak;
        while ((this.m(a) + c + d) > b && e > 0) {
            e--;
            f = f.substr(0, e) + "\u2026";
            a.ak = f;
        }
        a.ak = g;
        return f;
    }
    ae() {
        if (this.e == null) {
            return;
        }
        let a = this.g();
        for (let b of fromEnum(a)) {
            let c = typeCast(FrameworkElement.$, b);
            if (c != null) {
                this.a.b8(c);
            }
            this.a.bz(b);
        }
    }
    g() {
        let a = this.a.aw();
        let b = this.a.av();
        if (!this.a.ac.cs) {
            return a;
        }
        else {
            return b;
        }
    }
    l(a) {
        return this.h;
    }
    n(a) {
        return this.l(a) + this.r() + this.o();
    }
    am() {
        this.av = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
    }
    m(a) {
        let b = a;
        if (b != null && b.ak != null) {
            return this.e.e(b);
        }
        return 0;
    }
    w(a) {
        let b = a;
        if (b != null && b.ak != null) {
            return this.m(a) + this.p() + this.q();
        }
        return 0;
    }
    ac() {
        this.a.ba = this.a.ac.d4();
    }
    aj() {
        this.af();
        this.a.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
    }
    f() {
        return this.e;
    }
    ak(a) {
        this.e = a;
    }
    y() {
        if (this.a.co.isEmpty) {
            return;
        }
        let a = this.a.a6;
        this.a.cr(new Size(1, this.a.co.width, this.a.co.height));
        if (this.a.a6 != a) {
            this.a.ac.bf.it();
            this.al();
        }
    }
    al() {
    }
    ao(a) {
        this.e.w(a);
    }
    an() {
        if (this.e == null) {
            return;
        }
        if (this.e.d) {
            if (this.a.ac.bh != null && this.a.ac.bh.ey != 1) {
                this.e.z();
                this.e.aa(this.a.ac.bh.ey, this.a.ac.bh.ey);
            }
            this.af();
            this.au = this.a.co;
            let a = this.a.ac.bf.getFontBrush();
            if (this.a.af != null && this.a.af.textColor != null) {
                a = this.a.af.textColor;
            }
            if (this.a.j != null) {
                this.e.z();
                this.e.j(this.a.j);
            }
            let b = false;
            for (let c of fromEnum(this.g())) {
                let d = typeCast(TextBlock.$, c);
                if (d != null) {
                    if (d.s != 0) {
                        b = true;
                        continue;
                    }
                    d.am = a;
                    if (d.j != null) {
                        this.e.z();
                        this.e.j(d.j);
                    }
                    this.ao(d);
                    if (d.j != null) {
                        this.e.y();
                    }
                }
            }
            if (b) {
                for (let e of fromEnum(this.a.ab)) {
                    let f = typeCast(Rectangle.$, e);
                    if (f != null) {
                        if (f.s == 0) {
                            continue;
                        }
                        if (f.j != null) {
                            this.e.z();
                            this.e.j(f.j);
                        }
                        this.e.v(f);
                        if (f.j != null) {
                            this.e.y();
                        }
                    }
                    let g = typeCast(TextBlock.$, e);
                    if (g != null) {
                        if (g.s == 0) {
                            continue;
                        }
                        if (g.j != null) {
                            this.e.z();
                            this.e.j(g.j);
                        }
                        if (g.am == null) {
                            g.am = a;
                        }
                        this.e.w(g);
                        if (g.j != null) {
                            this.e.y();
                        }
                    }
                }
            }
            if (this.a.j != null) {
                this.e.y();
            }
            this.ap();
            a = this.as();
            this.e.ac(this.d());
            let h = this.a.ac.hq;
            if (h != null) {
                h.am = a;
                if (h.j != null) {
                    this.e.z();
                    this.e.j(h.j);
                }
                this.e.w(h);
                if (h.j != null) {
                    this.e.y();
                }
            }
            if (this.a.ac.bh != null && this.a.ac.bh.ey != 1) {
                this.e.y();
            }
        }
    }
    d() {
        let a = this.a.ac.bh.getFontInfo();
        if (this.a.ac.be != null && this.a.ac.be.textStyle != null) {
            a = this.a.ac.be.g(this.a.ac.bh.b1.i.ae);
        }
        else {
            let b = this.a.ac.bh.b3();
            if (b != null) {
                a = b;
            }
        }
        return a;
    }
    as() {
        let a = this.a.ac.bf.getFontBrush();
        if (this.a.ac.be != null && this.a.ac.be.textColor != null) {
            a = this.a.ac.be.textColor;
        }
        else {
            let b = this.a.ac.bh.nh();
            if (b != null) {
                a = b;
            }
        }
        return a;
    }
    af() {
        if (this.e == null) {
            return;
        }
        let a = this.a.ac.bh.getFontInfo();
        if (this.a.af != null && this.a.af.textStyle != null) {
            a = this.a.af.g(this.a.ac.bh.b1.i.ae);
        }
        if (this.c != a) {
            this.c = a;
            this.ar();
        }
        this.e.ac(a);
    }
    ar() {
        if (this.a.ac != null && this.a.ac.bh != null) {
            if (this.a.af == null || this.a.af.textStyle == null) {
                this.h = this.a.ac.bh.b1.a7;
                return;
            }
            if (this.h == 0) {
                this.h = this.a.ac.bh.b1.a7;
            }
            let a = this.h;
            let b = this.a.ac.bh.getFontInfo();
            if (this.a.af != null && this.a.af.textStyle != null) {
                b = this.a.af.g(this.a.ac.bh.b1.i.ae);
            }
            let c = FontUtil.getCurrentFontHeight(this.a.ac.bh.b1.i.ae, b);
            this.h = c;
            if (a != this.h) {
                this.a.ac.bh.it();
            }
        }
    }
    j() {
        if (this.a.ac.gc == null) {
            return 0;
        }
        if (this.a.ac.be != null && this.a.ac.be.visibility == 1) {
            return 0;
        }
        if (!isNaN_(this.i)) {
            return this.i;
        }
        let a = this.d();
        if (this.a.ac.bh == null) {
            return this.h;
        }
        this.i = FontUtil.getCurrentFontHeight(this.a.ac.bh.b1.i.ae, a);
        return this.i;
    }
    k() {
        if (this.a.ac.be != null && this.a.ac.be.visibility == 1) {
            return 0;
        }
        if (this.e == null) {
            return 0;
        }
        let a = this.a.ac.hq;
        if (a != null && a.ak != null) {
            this.e.ac(this.d());
            let b = this.e.e(a);
            this.af();
            return b;
        }
        return 0;
    }
    ap() {
        if (this.a.ab.count == 0) {
            return;
        }
        if (this.a.ac.iw == null) {
            this.av._stroke = this.a.ac.bf.nf();
        }
        else {
            this.av._stroke = this.a.ac.iw;
        }
        this.av.ac = this.a.ac.er;
        this.e.s(this.av);
    }
    ab(a) {
    }
    aw() {
        return this.a.ac.bh.ok();
    }
    v() {
        if (this.a.ac.be != null && !isNaN_(this.a.ac.be.topMargin)) {
            return Math.max(0, this.a.ac.be.topMargin);
        }
        else {
            return this.aw().e;
        }
    }
    s() {
        if (this.a.ac.be != null && !isNaN_(this.a.ac.be.bottomMargin)) {
            return Math.max(0, this.a.ac.be.bottomMargin);
        }
        else {
            return this.aw().b;
        }
    }
    t() {
        if (this.a.ac.be != null && !isNaN_(this.a.ac.be.leftMargin)) {
            return Math.max(0, this.a.ac.be.leftMargin);
        }
        else {
            return this.aw().c;
        }
    }
    u() {
        if (this.a.ac.be != null && !isNaN_(this.a.ac.be.rightMargin)) {
            return Math.max(0, this.a.ac.be.rightMargin);
        }
        else {
            return this.aw().d;
        }
    }
    at() {
        return this.av.ak.d;
    }
    b() {
        let a = ((() => {
            let $ret = new PathRenderingInfo();
            $ret.e = this.a.ac.iw;
            $ret.c = this.a.ac.er;
            return $ret;
        })());
        if (this.a.ac != null && typeCast(XamDataChart.$, this.a.ac.bf) !== null) {
            let b = this.a.ac.bf;
            if (b.o2 && b.bs != 2 && b.bs != 1) {
                a.a = true;
            }
        }
        return a;
    }
    r() {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.topMargin);
    }
    p() {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.leftMargin);
    }
    q() {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.rightMargin);
    }
    o() {
        if (this.a.af == null) {
            return 0;
        }
        return Math.max(0, this.a.af.bottomMargin);
    }
}
AxisLabelPanelBaseView.$t = markType(AxisLabelPanelBaseView, 'AxisLabelPanelBaseView');
/**
 * @hidden
 */
class AxisView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.a7 = null;
        this.a8 = null;
        this.ba = null;
        this.a9 = null;
        this.b = new AxisComponentsFromView();
        this.h = null;
        this.k = null;
        this.j = null;
        this._isDirty = false;
        this.bb = null;
        this.a5 = Rect.empty;
        this.a = a;
        this.bb = new Rectangle();
    }
    ag() {
        this.a7 = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.ba = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            $ret.stroke = null;
            return $ret;
        })());
        this.a8 = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
        this.a9 = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            $ret.ab = false;
            return $ret;
        })());
        this.a.d5 = 1;
        this.a.ep = 1;
    }
    ai(a) {
    }
    ax() {
        let a = new TextBlock();
        return a;
    }
    aq(a) {
        a._visibility = 0;
        a.s = 0;
        if (a.x == null) {
            this.a.av.ab.add(a);
        }
    }
    as(a) {
        a._visibility = 1;
    }
    ar(a) {
        if (this.a.av.ab.contains(a)) {
            this.a.av.ab.remove(a);
        }
    }
    bc() {
        let a = new Rectangle();
        return a;
    }
    p(a) {
        if (a.x == null) {
            this.d.ab.add(a);
        }
        a._visibility = 0;
    }
    r(a) {
        a._visibility = 1;
    }
    q(a) {
        if (this.a.av.ab.contains(a)) {
            this.a.av.ab.remove(a);
        }
    }
    aj() {
    }
    m() {
        return true;
    }
    get index() {
        if (this.a.bh != null && this.a.bh.dh) {
            return this.a.bh.series.count + 1;
        }
        let a = typeCast(XamDataChart.$, this.a.bf);
        let b = 0;
        if (a == null) {
            return 0;
        }
        if (a != null && a.ov == 1) {
            let c = 0;
            for (let d = 0; d < this.a.bh.series.count; d++) {
                if (this.a.bh.series._inner[d].isStacked) {
                    c += this.a.bh.series._inner[d].fg();
                }
                else {
                    c++;
                }
            }
            b = c;
        }
        return b + a.axes.indexOf(this.a);
    }
    ad() {
        this.d.b7();
        this.d.bv();
    }
    ab() {
        this.d.b2();
    }
    x() {
        if (this.d != null) {
            this.d.ab.clear();
        }
        this.z(this.a7.ak.d);
        this.z(this.ba.ak.d);
        this.z(this.a8.ak.d);
        this.z(this.a9.ak.d);
        this.ae();
    }
    av(a) {
        this.a7._visibility = a;
        this.a8._visibility = a;
        this.ba._visibility = a;
        this.a9._visibility = a;
    }
    an() {
    }
    w(a) {
        this.a.ci = true;
        if (this.a.bh != null) {
            this.a.bh.it();
        }
        this.a.ha();
    }
    c() {
        this.b.a = this.a7;
        this.b.b = this.a8;
        this.b.c = this.a9;
        this.b.d = this.ba;
        return this.b;
    }
    z(a) {
        if (a != null) {
            a.clear();
        }
    }
    ay() {
        return this.a7.ak.d;
    }
    e() {
        let a = ((() => {
            let $ret = new PathRenderingInfo();
            $ret.e = this.a.iv;
            $ret.c = this.a.ep;
            $ret.f = this.a.iz;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bf) !== null) {
            let b = this.a.bf;
            if (b.o2 && b.bs != 2 && b.bs != 1) {
                a.a = true;
            }
        }
        return a;
    }
    a1() {
        return this.ba.ak.d;
    }
    az() {
        return this.a8.ak.d;
    }
    f() {
        let a = ((() => {
            let $ret = new PathRenderingInfo();
            $ret.e = this.a.is;
            $ret.c = this.a.d5;
            $ret.f = this.a.ix;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bf) !== null) {
            let b = this.a.bf;
            if (b.o2 && b.bs != 2 && b.bs != 1) {
                a.a = true;
            }
        }
        return a;
    }
    a0() {
        return this.a9.ak.d;
    }
    g() {
        let a = ((() => {
            let $ret = new PathRenderingInfo();
            $ret.e = this.a.it;
            $ret.c = this.a.d8;
            $ret.f = this.a.iy;
            return $ret;
        })());
        if (typeCast(XamDataChart.$, this.a.bf) !== null) {
            let b = this.a.bf;
            if (b.o2 && b.bs != 2 && b.bs != 1) {
                a.a = true;
            }
        }
        return a;
    }
    get d() {
        return this.a.ap().a;
    }
    at(a, b, c) {
        this.d.ac = a;
        this.d.cq = b;
        this.d.cp = c;
        this.ae();
    }
    y() {
        this.d.ab.clear();
        this.ae();
    }
    ap(a) {
        this.d.bo = a;
        this.ae();
    }
    au(a, b) {
        this.d.a2 = a;
        this.d.a3 = b;
    }
    ao(a) {
        this.d.a9 = a;
    }
    v() {
    }
    o(a) {
        return null;
    }
    n(dataItem_) {
        if (this.a.at != null) {
            return this.a.at(dataItem_);
        }
        if (this.a.ah != null) {
            return this.a.ah.i(dataItem_);
        }
        let label_ = this.a.e9;
        let a = typeof dataItem_ === 'number' && typeof label_ === 'string';
        let labelValue_ = null;
        if (this.h != null) {
            labelValue_ = this.h.getPropertyValue(dataItem_);
            if ((labelValue_ === undefined)) {
                labelValue_ = label_;
            }
        }
        else {
            labelValue_ = a ? stringFormat(label_, dataItem_) : (typeof dataItem_[label_] != 'undefined') ? dataItem_[label_] : label_;
            ;
        }
        if (this.a.expectFunctions) {
            if ((typeof (labelValue_) == 'function')) {
                labelValue_ = labelValue_();
            }
        }
        return labelValue_;
    }
    af(a, b) {
        this.j = a;
        this.k = b;
    }
    get isDirty() {
        return this._isDirty;
    }
    set isDirty(a) {
        this._isDirty = a;
    }
    ae() {
        if (this.a.bf == null || this.j == null) {
            return;
        }
        if (!this.isDirty) {
            this.isDirty = true;
            this.a.bf.ah.o(this.j, this.k);
        }
    }
    undirty(a) {
        this.isDirty = false;
        this.al(a);
    }
    al(a) {
        if (this.j == null) {
            return;
        }
        if (this.j.d) {
            if (this.a.bh != null && this.a.bh.ey != 1) {
                this.j.z();
                this.j.aa(this.a.bh.ey, this.a.bh.ey);
            }
            let b = this.a.bf.n7();
            if (a) {
                this.j.k(b.left, b.top, b.width, b.height);
            }
            if (a) {
                if (this.a.bh.nn != null && !this.a.i9.isEmpty) {
                    this.bb.o = this.a.i9.top;
                    this.bb.n = this.a.i9.left;
                    this.bb.width = this.a.i9.width;
                    this.bb.height = this.a.i9.height;
                    this.bb._fill = this.a.bh.nn;
                    this.j.v(this.bb);
                }
            }
            this.j.z();
            this.j.ae(this.a.i9);
            this.am();
            this.j.y();
            if (this.a.bh != null && this.a.bh.ey != 1) {
                this.j.y();
            }
        }
        if (this.k.d) {
            if (this.a.bh != null && this.a.bh.ey != 1) {
                this.k.z();
                this.k.aa(this.a.bh.ey, this.a.bh.ey);
            }
            let c = this.a5;
            let d = this.a.bf.n7();
            if (!c.isEmpty && a) {
                this.k.k(d.left, d.top, d.width, d.height);
            }
            if (this.a.bh != null && this.a.bh.ey != 1) {
                this.k.y();
            }
        }
    }
    postRender() {
        this.d.cb();
    }
    am() {
        if (this.j.d) {
            this.a7._stroke = this.a.ir;
            this.ba._fill = this.a.iu;
            this.a9._stroke = this.a.iq;
            this.a8._stroke = this.a.ip;
            this.a9.ac = this.a.d8;
            this.a8.ac = this.a.d5;
            this.a7.ac = this.a.ep;
            this.a9.ai = this.a.iy;
            this.a8.ai = this.a.ix;
            this.a7.ai = this.a.iz;
            this.a5 = this.a.i9;
            this.j.s(this.a7);
            this.j.s(this.ba);
            this.j.s(this.a8);
            this.j.s(this.a9);
        }
    }
    ac() {
        this.ae();
    }
    aa(a) {
        if (a != null) {
            a.ah.r(this);
            a.b1.ck();
        }
    }
    u(a) {
        if (a != null) {
            a.ah.l(this);
            this.ae();
        }
    }
    i() {
        if (this.a.bh == null || this.a.bh.b1.i.ae == null) {
            return null;
        }
        return FontUtil.getFont(this.a.bh.b1.i.ae);
    }
    l() {
        return this.j == null;
    }
    ak() {
        if (this.a.b2 || this.a.ce) {
            return;
        }
        if (this.a.gc == null) {
            this.a.hq = null;
            this.a.ci = true;
            this.a.ha();
            return;
        }
        if (this.a.hq == null) {
            let a = new TextBlock();
            a.ak = this.a.gc;
            a.dataContext = this.a.be;
            this.a.hq = a;
        }
        else {
            this.a.hq.ak = this.a.gc;
            this.a.hq.dataContext = this.a.be;
        }
        this.a.ci = true;
        this.a.ha();
    }
    t() {
        let a;
        let b = new AxisLabelSettings();
        if (this.a.b2) {
            a = "ui-angular-axis-labels";
            b.margin = 0;
        }
        else if (this.a.ch) {
            a = "ui-vertical-axis-labels";
            b.location = 2;
        }
        else if (this.a.a1 == 3) {
            a = "ui-radial-axis-labels";
            b.location = 5;
        }
        else {
            a = "ui-horizontal-axis-labels";
            b.location = 1;
        }
        this.s(b, a);
    }
    aw() {
        if (this.a.bh == null) {
            return;
        }
        let a = this.a.bh.oy;
        let b = a.fn;
        let c = a.fm;
        if (this.a.iv == null) {
            if (b == null) {
                this.a.iv = a.fk;
            }
            else if (b.color.l != 0) {
                this.a.iv = b;
            }
        }
        if (this.a.is == null) {
            if (c == null) {
                this.a.is = a.fk;
            }
            else if (c.color.l != 0) {
                this.a.is = c;
            }
        }
    }
    s(a, b) {
        this.a.eu.startCSSQuery();
        let c = this.a.eu.getCssDefaultPropertyValue(b, "margin-top");
        let d = this.a.eu.getCssDefaultPropertyValue(b, "margin-right");
        let e = this.a.eu.getCssDefaultPropertyValue(b, "margin-bottom");
        let f = this.a.eu.getCssDefaultPropertyValue(b, "margin-left");
        let g = this.a.eu.getCssDefaultPropertyValue(b, "text-align");
        let h = this.a.eu.getCssDefaultPropertyValue(b, "vertical-align");
        let i = this.a.eu.getCssDefaultPropertyValue(b, "color");
        this.a.eu.endCSSQuery();
        if (c != null) {
            a.topMargin = parseFloat(c);
        }
        if (d != null) {
            a.rightMargin = parseFloat(d);
        }
        if (e != null) {
            a.bottomMargin = parseFloat(e);
        }
        if (f != null) {
            a.leftMargin = parseFloat(f);
        }
        if (i != null) {
            if (a.textColor == null) {
                a.textColor = new Brush();
            }
            a.textColor._fill = i;
        }
        if (g != null) {
            switch (g) {
                case "right":
                    a.horizontalAlignment = 2;
                    break;
                case "left":
                    a.horizontalAlignment = 0;
                    break;
                default:
                    a.horizontalAlignment = 1;
                    break;
            }
        }
        if (h != null) {
            switch (h) {
                case "top":
                    a.verticalAlignment = 0;
                    break;
                case "bottom":
                    a.verticalAlignment = 2;
                    break;
                default:
                    a.verticalAlignment = 1;
                    break;
            }
        }
        this.a.ay = a;
    }
    preRender() {
        if (this.a.bh != null) {
            this.a.bh.ij();
        }
    }
    isValid() {
        return this.a != null && !this.a.i9.isEmpty;
    }
    a2(a) {
        return { $type: Point_$type, x: a.n, y: a.o };
    }
    a3() {
        return { $type: Point_$type, x: this.a.av.co.left, y: this.a.av.co.top };
    }
    a6() {
        let a = this.a.av.co;
        return a;
    }
    a4(a) {
        return { $type: Point_$type, x: a.n, y: a.o };
    }
    bd(a) {
        let b = this.a.av.ae.t();
        let c = this.a.av.ae.v();
        let d = this.a.av.ae.u();
        let e = this.a.av.ae.s();
        return new Thickness(1, b, c, d, e);
    }
    ah() {
        if (FastReflectionHelper.needsHelper(this.a.e9)) {
            this.h = new FastReflectionHelper(true, this.a.e9);
        }
        else {
            this.h = null;
        }
    }
}
AxisView.$t = markType(AxisView, 'AxisView', Base.$, [ISchedulableRender_$type]);
/**
 * @hidden
 */
class CategoryAxisBaseView extends AxisView {
    constructor(a) {
        super(a);
        this.be = null;
        this.be = a;
    }
    o(a) {
        let b = 0;
        if (this.be.categoryMode == 0) {
            b = truncate(Math.round(a));
        }
        else {
            b = truncate(Math.floor(a));
        }
        if (b < 0 || b > this.a.j8 - 1) {
            return null;
        }
        let c = this.a.jn.item(b);
        let d = this.n(c);
        if (d == null) {
            return null;
        }
        return d.toString();
    }
    bf(a) {
        let b = 0;
        let c = false;
        for (let d = 0; d < a.count; d++) {
            let e = typeCast(FrameworkElement.$, a._inner[d]);
            if (e == null) {
                e = this.a.bq.item(d);
                let f = a._inner[d] == null ? "" : a._inner[d].toString();
                let g = e.ak;
                let h = 0;
                let i = 0;
                if (g != null) {
                    h = g.length;
                }
                if (f != null) {
                    i = f.length;
                }
                if (h != i) {
                    c = true;
                }
                e.ak = f;
                b++;
            }
            else {
                this.d.ab.add(e);
            }
        }
        if (c) {
            this.a.ci = true;
        }
        this.a.gk();
        return b;
    }
}
CategoryAxisBaseView.$t = markType(CategoryAxisBaseView, 'CategoryAxisBaseView', AxisView.$);
/**
 * @hidden
 */
class HorizontalAxisLabelPanelBaseView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.ax = null;
        this.ax = a;
    }
    az() {
    }
    ay() {
        return false;
    }
    a0(a) {
        let b = this.a.bk();
        let c, d;
        c = this.ax.c1();
        d = this.ax.cy();
        let e = this.a.af != null ? this.a.af.verticalAlignment : 1;
        let f = this.a.a6;
        let g = a.count;
        let h = this.a.co;
        let i = this.ax.c0();
        let j = i / 2;
        for (let k = 0; k < g; k++) {
            let l = a._inner[k];
            let m = l.height / 2;
            switch (e) {
                case 0:
                    l.y = h.top + c;
                    break;
                case 1:
                case 3:
                    l.y = (h.top + c + j) - m;
                    break;
                case 2:
                    l.y = (h.bottom - d) - l.height;
                    break;
            }
        }
    }
}
HorizontalAxisLabelPanelBaseView.$t = markType(HorizontalAxisLabelPanelBaseView, 'HorizontalAxisLabelPanelBaseView', AxisLabelPanelBaseView.$);
/**
 * @hidden
 */
class NumericAxisBaseView extends AxisView {
    constructor(a) {
        super(a);
        this.be = null;
        this.be = a;
    }
    bf() {
    }
    o(a) {
        let b = this.be.jn.d(this.be.i9, this.be.bh.n2, this.be.i4(), this.be.i3());
        return this.be.jn.w(b, a, -1, NaN);
    }
}
NumericAxisBaseView.$t = markType(NumericAxisBaseView, 'NumericAxisBaseView', AxisView.$);
/**
 * @hidden
 */
class VerticalAxisLabelPanelView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.ax = null;
        this.ax = a;
    }
    ay() {
    }
    d() {
        let a = this.a.ac.bh.getFontInfo();
        if (this.a.ac.be != null && this.a.ac.be.textStyle != null) {
            a = this.a.ac.be.g(this.a.ac.bh.b1.i.ae);
        }
        else {
            let b = this.a.ac.bh.b4();
            if (b != null) {
                a = b;
            }
        }
        return a;
    }
    aw() {
        return this.a.ac.bh.ol();
    }
    as() {
        let a = this.a.ac.bf.getFontBrush();
        if (this.a.ac.be != null && this.a.ac.be.textColor != null) {
            a = this.a.ac.be.textColor;
        }
        else {
            let b = this.a.ac.bh.ni();
            if (b != null) {
                a = b;
            }
        }
        return a;
    }
    az(a, b) {
        let c, d;
        c = this.ax.cv();
        d = this.ax.cx();
        let e = this.a.af != null ? this.a.af.horizontalAlignment : 1;
        let f = this.a.a6;
        let g = this.ax.cy();
        let h = g / 2;
        let i = this.a.co;
        for (let j = 0; j < a.count; j++) {
            let k = a._inner[j];
            let l = k.width / 2;
            switch (e) {
                case 0:
                    k.x = i.left + c;
                    break;
                case 1:
                case 3:
                    k.x = (i.left + c + h) - l;
                    break;
                case 2:
                    k.x = (i.right - d) - k.width;
                    break;
            }
        }
    }
}
VerticalAxisLabelPanelView.$t = markType(VerticalAxisLabelPanelView, 'VerticalAxisLabelPanelView', AxisLabelPanelBaseView.$);
/**
 * @hidden
 */
class XamDataChartView extends SeriesViewerView {
    constructor(a) {
        super(a);
        this.ff = null;
        this.fo = null;
        this.fk = null;
        this.fl = null;
        this.fn = null;
        this.fm = null;
        this.fh = 0;
        this.fi = 0;
        this.fg = null;
        this.ff = a;
    }
    fj(a) {
        this.n.ah.p();
    }
    dl() {
        super.dl();
        if (this.b.count == 0 && this.w != null) {
            if (this.n.ey != 1) {
                this.w.z();
                this.w.aa(this.n.ey, this.n.ey);
            }
            this.w.k(0, 0, this.a6, this.a5);
            if (this.n.ey != 1) {
                this.w.y();
            }
        }
    }
    dy() {
        let a, b;
        let c = 1, d = 0;
        let e = false;
        let f = this.i.e();
        let g;
        let h = this.i.a6(c, g, a, b, d, e);
        c = h.p0;
        g = h.p1;
        a = h.p2;
        b = h.p3;
        d = h.p4;
        e = h.p5;
        if (isNaN_(this.n.fj)) {
            this.n.fj = g[0];
        }
        if (isNaN_(this.n.fa)) {
            this.n.fa = g[1];
        }
        if (isNaN_(this.n.e3)) {
            this.n.e3 = g[2];
        }
        if (isNaN_(this.n.e7)) {
            this.n.e7 = g[3];
        }
        this.ff.re = f.i;
        this.ff.rc = f.i;
        this.ff.rd = f.i;
        this.ff.o2 = e;
        this.fn = a;
        this.fm = b;
        this.ff.oo = f.a;
        this.ff.or = f.f;
        this.ff.op = f.b != null ? f.b : new BrushCollection();
        this.ff.oq = f.c != null ? f.c : new BrushCollection();
        if (this.ff.op.count == 0) {
            for (let i = 0; i < f.a.count; i++) {
                this.ff.op.add(f.a.item(i));
            }
        }
        if (f.c.count == 0) {
            for (let j = 0; j < f.f.count; j++) {
                this.ff.oq.add(f.f.item(j));
            }
        }
        this.fl = f.j;
        this.fo = f.k;
        this.fg = f.h;
        this.fk = f.i;
        this.fh = c;
        for (let k of fromEnum(this.ff.series)) {
            k.jv();
        }
        this.fi = d;
    }
    dv() {
        this.e8.ac = DeviceUtils.g(1.4);
        this.e7.ac = DeviceUtils.g(1.4);
        this.e8._stroke = this.fl;
        this.e7._stroke = this.fl;
        super.dv();
    }
}
XamDataChartView.$t = markType(XamDataChartView, 'XamDataChartView', SeriesViewerView.$);
/**
 * @hidden
 */
class SeriesView extends Base {
    constructor(a) {
        super();
        this.e = null;
        this.p = false;
        this.d = null;
        this._isDirty = false;
        this.bt = null;
        this.bk = null;
        this.s = 0;
        this.bo = Rect.empty;
        this.bj = new Brush();
        this.f = new SeriesComponentsFromView();
        this.h = null;
        this.i = null;
        this.bp = null;
        this.bq = null;
        this.j = false;
        this.a = null;
        this.o = false;
        this.k = false;
        this.m = false;
        this.aa = null;
        this.s = NaN;
        this.o = true;
        this.e = a;
        this.n = false;
        this.bt = new Rectangle();
        this.p = false;
    }
    getDefaultTooltipTemplate() {
        return this.e.a0.a$p(this.e);
    }
    am() {
        if (this.e.cx) {
            this.e.a0.a$s(this.e);
        }
    }
    ap() {
        if (!this.n) {
            this.e.bl = 0;
            this.e.bj = 0;
            this.e.bk = 1;
            this.d = new DataContext();
            this.d.series = this.e;
            this.e.bv = EasingFunctions.cubicEase;
            this.ac();
        }
    }
    getEffectiveViewport() {
        return this.e.getEffectiveViewport1(this);
    }
    aw() {
        this.an();
    }
    ag() {
    }
    get t() {
        if (this.e.bs != null) {
            return this.e.bs.b1.i.ae;
        }
        return null;
    }
    get isDirty() {
        return this._isDirty;
    }
    set isDirty(a) {
        this._isDirty = a;
    }
    get_index() {
        if (this.e == null || this.e.bs == null) {
            return 0;
        }
        if (this.e.bs.dh) {
            if (this.e.ct) {
                return this.e.bs.series.indexOf(this.e);
            }
            else {
                let a = this.e.bs.series.indexOf(this.e);
                if (a >= 0) {
                    return a;
                }
                for (let b = 0; b < this.e.bs.series.count; b++) {
                    if (this.e.bs.series._inner[b].ct) {
                        let c = this.e.bs.series._inner[b].a5();
                        if (c == this.e) {
                            return b;
                        }
                    }
                }
                return a;
            }
        }
        let d = typeCast(XamDataChart.$, this.e.bq);
        let e = 0;
        if (d != null) {
            if (d.ov == 2 || d.ov == 0) {
                e = d.axes.count;
            }
        }
        let f = 0;
        for (let g = 0; g < this.e.bs.series.count; g++) {
            if (this.e.bs.series._inner[g] == this.e) {
                break;
            }
            if (this.e.bs.series._inner[g].isStacked) {
                f += this.e.bs.series._inner[g].fg();
            }
            else {
                f++;
            }
        }
        return e + f;
    }
    get index() {
        return this.get_index();
    }
    an() {
        if (this.e.bs == null) {
            return;
        }
        if (!this.isDirty) {
            this.isDirty = true;
            this.a.o(this.h, this.i);
        }
    }
    undirty(a) {
        this.isDirty = false;
        this.a1(a);
    }
    ar() {
        this.an();
    }
    bn() {
        if (this.bk == null) {
            this.bk = ((() => {
                let $ret = new Brush();
                $ret.color = Color.u(0, 0, 0, 0);
                return $ret;
            })());
        }
        return this.bk;
    }
    r() {
        if (!isNaN_(this.s)) {
            return this.s;
        }
        if (this.e.bs != null) {
            return this.e.bs.ey;
        }
        else {
            return 1;
        }
    }
    a1(a) {
        if (this.h == null) {
            return;
        }
        if (this.bo.isEmpty) {
            this.bo = this.br;
        }
        let b = this.bo;
        let c = this.e.bs.n7();
        let d = c.left;
        let e = c.top;
        let f = c.width;
        let g = c.height;
        let h = this.r();
        if (this.m) {
            d = this.br.left;
            e = this.br.top;
            f = this.br.width;
            g = this.br.height;
        }
        if (this.h.d) {
            if (h != 1) {
                this.h.z();
                this.h.aa(h, h);
            }
            if (a) {
                this.h.k(d, e, f, g);
            }
            if (a) {
                if (this.e.bs.nn != null && !this.br.isEmpty) {
                    this.bt.o = this.br.top;
                    this.bt.n = this.br.left;
                    this.bt.width = this.br.width;
                    this.bt.height = this.br.height;
                    this.bt._fill = this.e.bs.nn;
                    this.h.v(this.bt);
                }
            }
            if (h != 1) {
                this.h.y();
            }
        }
        if (this.i != null && this.o) {
            if (this.i.d) {
                if (this.e.bs != null && h != 1) {
                    this.i.z();
                    this.i.aa(h, h);
                }
                if (!b.isEmpty && a) {
                    this.i.k(b.left, b.top, b.width, b.height);
                }
                this.a7(true);
                this.a3(this.i, true);
                this.a2(this.i, true);
                if (h != 1) {
                    this.i.y();
                }
            }
        }
        if (this.h.d && this.o) {
            if (h != 1) {
                this.h.z();
                this.h.aa(h, h);
            }
            this.h.z();
            if (!this.n && Rect.l_op_Inequality(this.e.lz, null) && !this.e.lz.isEmpty && (this.e.lz.width != 1 || this.e.lz.height != 1)) {
                this.h.ae(new Rect(0, this.br.left + this.br.width * this.e.lz.left, this.br.top + this.br.height * this.e.lz.top, this.br.width * this.e.lz.width, this.br.height * this.e.lz.height));
            }
            else {
                this.h.ae(this.br);
            }
            this.a7(false);
            this.h.ad(this.e._opacity);
            if (this.e.cp && this.e.cq && !this.n) {
                if (this.e.du) {
                    this.h.o(this.e.lk.colorString, 0, this.e.ew, this.e.ex);
                    let i = this.e.bs.b1.i.x;
                    let j = this.e.bs.b1.i.ak;
                    if (h != 1) {
                        i.z();
                        i.aa(h, h);
                    }
                    i.k(c.left, c.top, c.width, c.height);
                    this.a3(i, false);
                    this.a2(i, false);
                    this.h.m(j.getNativeElement(), 1, 0, 0, c.width, c.height);
                    if (h != 1) {
                        i.y();
                    }
                }
                else {
                    this.h.o(this.e.lk.colorString, this.e.ev, this.e.ew, this.e.ex);
                    this.a3(this.h, false);
                    this.a2(this.h, false);
                }
                this.h.l();
            }
            else {
                this.a3(this.h, false);
                this.a2(this.h, false);
            }
            this.h.ad(1);
            this.h.y();
            if (h != 1) {
                this.h.y();
            }
        }
    }
    ba(a, b, c) {
        if (c) {
            this.bc(a, b);
        }
        else {
            this.bb(a, b);
        }
    }
    bd(a, b, c) {
        if (c) {
            this.bf(a, b);
        }
        else {
            this.be(a, b);
        }
    }
    x(a, b) {
        if (b) {
            return this.y(a);
        }
        else {
            return this.z(a);
        }
    }
    y(a) {
        return null;
    }
    z(a) {
        return null;
    }
    bb(a, b) {
    }
    be(a, b) {
    }
    bc(a, b) {
    }
    bf(a, b) {
    }
    a7(a) {
        if (a) {
            this.a9();
        }
        else {
            this.a8();
        }
    }
    a8() {
    }
    a9() {
    }
    bm(a) {
        return this.bl();
    }
    bl() {
        let a = this.e.fk;
        let num_ = (a + 1) * 1000;
        let b = ((num_ & 0x3F) << 2);
        num_ = (num_ >> 6);
        let c = ((num_ & 0x3F) << 2);
        num_ = (num_ >> 6);
        let d = ((num_ & 0x3F) << 2);
        this.bj._fill = "rgb(" + b + "," + c + "," + d + ")";
        return this.bj;
    }
    a3(a, b) {
        this.bo = this.br;
    }
    a2(a, b) {
    }
    au() {
    }
    aj() {
    }
    ak() {
    }
    g() {
        return this.f;
    }
    a6(a) {
    }
    q() {
        return true;
    }
    at() {
    }
    as() {
    }
    a4() {
        this.e.lb = null;
    }
    ae() {
        this.e.lb = this.e.ld;
    }
    a5() {
        this.e.lc = null;
    }
    af() {
        this.e.lc = this.e.li;
    }
    c(a) {
        if (typeCast(DataContext.$, a) !== null) {
            return a;
        }
        return null;
    }
    ao(a, b) {
        this.h = a;
        this.i = b;
    }
    get br() {
        return this.bp;
    }
    set br(a) {
        this.bp = a;
    }
    get_bs() {
        if (this.m) {
            return this.bq;
        }
        else if (this.n) {
            return XamDataChart.oe;
        }
        else {
            return this.e.bs != null ? this.e.bs.n2 : Rect.empty;
        }
    }
    get bs() {
        return this.get_bs();
    }
    get n() {
        return this.j;
    }
    set n(a) {
        this.j = a;
    }
    ah(a) {
        if (a != null) {
            this.a.r(this);
            if (this.e.bh != null) {
                this.e.bh.a.r(this.e.bh);
            }
        }
    }
    ad(a) {
        if (a != null) {
            if (this.e.ds) {
                this.h = this.e.bs.b1.x;
                a.b1.a.l(this);
                this.a = a.b1.a;
            }
            else {
                this.h = this.e.bs.b1.w;
                a.ah.l(this);
                this.a = a.ah;
            }
            if (this.e.bh != null) {
                a.ai.l(this.e.bh);
                this.e.bh.a = a.ai;
                this.e.bh.an();
            }
            if (this.e.cx) {
                for (let b of fromEnum(this.e.a0.a$h.keys)) {
                    a.ag.l(this.e.a0.a$h.item(b));
                    this.e.a0.a$h.item(b).a = a.ag;
                    this.e.a0.a$h.item(b).an();
                }
            }
            this.an();
        }
    }
    postRender() {
        this.ax();
    }
    ax() {
    }
    b(a) {
        return null;
    }
    az(a) {
        this.e.bh.h = a.a;
    }
    ai(a) {
    }
    bg() {
        if (this.k) {
            return;
        }
        if (this.e.bs != null) {
            let a = (this.e.legend != null) ? this.e.legend : this.e.bs.legend;
            if (a != null && this.e.j4 != null && a.containsChild(this.e.j4)) {
                a.removeChild(this.e.j4);
                let b = this.e.fw();
                b.content.actualItemBrush = this.e.lb;
                b.content.outline = this.e.li;
                b.content.thickness = this.e.ey;
                a.addChildInOrder(this.e.j4, this.e);
            }
        }
    }
    aq() {
        this.e.hx(this.e.aw, this.e.aw);
    }
    av() {
        this.bg();
    }
    getViewInfo(a, b) {
        a = this.br;
        b = this.bs;
        return {
            p0: a,
            p1: b
        };
    }
    l() {
        return this.h != null;
    }
    bh() {
        this.o = this.e._visibility == 0;
        this.an();
    }
    a0() {
        this.e.a0.a$ae(this.e);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    }
    al() {
    }
    preRender() {
        if (this.e.bs != null && !this.n) {
            this.e.bs.ij();
        }
    }
    isValid() {
        return true;
    }
    ay(a) {
        this.h = a.a;
    }
    bi(type_) {
        let legendTemplates_ = TypeRegistrar.get("LegendTemplates");
        let a = (legendTemplates_.resolveLegendItemTemplate(type_));
        return a;
    }
}
SeriesView.$t = markType(SeriesView, 'SeriesView', Base.$, [ISchedulableRender_$type, IProvidesViewport_$type]);
/**
 * @hidden
 */
class MarkerSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.by = null;
        this.b2 = 1;
        this.b4 = 2;
        this.b3 = 3;
        this.b1 = null;
        this.b0 = false;
        this.bu = new Marker();
        this.cl = null;
        this.bu = new Marker();
        this.bu.content = new DataContext();
        this.by = a;
    }
    ap() {
        super.ap();
        this.b1 = new List$1(Marker.$, 0);
        this.cl = ((() => {
            let $ret = new DataTemplate();
            $ret.render = MarkerTemplates.c;
            $ret.measure = MarkerTemplates.b;
            return $ret;
        })());
    }
    cd() {
        for (let a of fromEnum(this.b1)) {
            a.ah = this.by.mv;
        }
        this.an();
    }
    ck(a) {
    }
    bx() {
        let a = new Marker();
        a.content = ((() => {
            let $ret = new DataContext();
            $ret.series = this.e;
            return $ret;
        })());
        a.ah = this.by.mv;
        this.b1.add(a);
        return a;
    }
    cg(a) {
        a._visibility = 0;
    }
    ci(a) {
        a._visibility = 1;
    }
    ch(a) {
        this.b1.remove(a);
    }
    bz() {
        return this.by.mw != null;
    }
    cb() {
        this.by.mu = null;
    }
    b5() {
        this.by.mu = this.by.mw;
    }
    cm(a) {
        let b = a.n;
        let c = a.o;
        let d = a.m;
        let e = a.l;
        return new Rect(0, b - d / 2, c - d / 2, d, e);
    }
    b8(a) {
        switch (a) {
            case SeriesViewer.$$p[1]:
                this.by.mu = this.by.bs.ls;
                break;
            case SeriesViewer.$$p[29]:
                this.by.mu = this.by.bs.l1;
                break;
            case SeriesViewer.$$p[21]:
                this.by.mu = this.by.bs.ly;
                break;
            case SeriesViewer.$$p[23]:
                this.by.mu = this.by.bs.lz;
                break;
            case SeriesViewer.$$p[4]:
                this.by.mu = this.by.bs.lt;
                break;
            case SeriesViewer.$$p[13]:
                this.by.mu = this.by.bs.lw;
                break;
            case SeriesViewer.$$p[6]:
                this.by.mu = this.by.bs.lu;
                break;
            case SeriesViewer.$$p[26]:
                this.by.mu = this.by.bs.l0;
                break;
            case SeriesViewer.$$p[14]:
                this.by.mu = this.by.bs.lx;
                break;
            case SeriesViewer.$$p[7]:
                this.by.mu = this.by.bs.lv;
                break;
        }
    }
    b9() {
        this.by.m8 = null;
    }
    b6() {
        this.by.m8 = this.by.na;
    }
    ca() {
        this.by.m9 = null;
    }
    b7() {
        this.by.m9 = this.by.nb;
    }
    cj() {
        this.an();
    }
    be(a, b) {
        super.be(a, b);
        if (!this.b0) {
            let c = a;
            let d = c.content;
            if (d != null) {
                d.actualItemBrush = this.by.m8;
                if (d.itemBrush != null) {
                    d.actualItemBrush = d.itemBrush;
                }
                d.outline = this.by.m9;
                d.thickness = this.b4;
            }
        }
    }
    bf(a, b) {
        super.bf(a, b);
        let c = a;
        this.bu._visibility = c._visibility;
        this.bu.ah = c.ah;
        this.bu.width = c.width;
        this.bu.height = c.height;
        this.bu.m = c.m;
        this.bu.l = c.l;
        this.bu.n = c.n;
        this.bu.o = c.o;
        let d = this.bm(b);
        let e = this.bu.content;
        let f = c.content;
        e.item = f.item;
        e.series = f.series;
        e.thickness = f.thickness;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = this.b2 + this.b3;
        }
    }
    b(a) {
        if (a >= 0 && a < this.b1.count) {
            return this.b1._inner[a].content;
        }
        return super.b(a);
    }
    a2(a, b) {
        super.a2(a, b);
        if (a.d) {
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.g();
            c.viewportTop = this.br.top;
            c.viewportLeft = this.br.left;
            c.viewportWidth = this.br.width;
            c.viewportHeight = this.br.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.isHitTestRender = b;
            d.passInfo = c;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.g();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.by.mv != null && this.by.mv.passStarting != null) {
                this.by.mv.passStarting(c);
            }
            for (let j = 0; j < this.b1.count; j++) {
                let k = this.b1._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bd(k, j, b);
                if (b) {
                    k = this.bu;
                }
                if (!f) {
                    e.data = k.content;
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.p(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.by.mv != null && this.by.mv.passCompleted != null) {
                this.by.mv.passCompleted(c);
            }
        }
    }
    ce(a) {
        a.create = runOn(this, this.bx);
        a.destroy = runOn(this, this.ch);
        a.activate = runOn(this, this.cg);
        a.disactivate = runOn(this, this.ci);
    }
    cf(a) {
        a.create = runOn(this, this.bx);
        a.destroy = runOn(this, this.ch);
        a.activate = runOn(this, this.cg);
        a.disactivate = runOn(this, this.ci);
    }
    bv(a) {
        let b = this.bw(a, 0);
        if (b == null) {
            b = this.bw(a, 3);
        }
        return b;
    }
    bw(a, b) {
        let c;
        let d;
        let e;
        let f;
        for (let g = this.b1.count - 1; g >= 0; g--) {
            let h = this.b1._inner[g];
            if (h._visibility == 1 || h._opacity == 0) {
                continue;
            }
            c = (h.m / 2) + b;
            d = (h.l / 2) + b;
            e = h.ai;
            f = h.aj;
            if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                return h;
            }
        }
        return null;
    }
}
MarkerSeriesView.$t = markType(MarkerSeriesView, 'MarkerSeriesView', SeriesView.$);
/**
 * @hidden
 */
class ChartAxisRangeChangedEventArgs extends EventArgs {
    constructor(a, b, c, d, e, f) {
        super();
        this._chart = null;
        this._axis = null;
        this._oldMinimumValue = 0;
        this._minimumValue = 0;
        this._oldMaximumValue = 0;
        this._maximumValue = 0;
        this.chart = a;
        this.axis = b;
        this.oldMinimumValue = c;
        this.minimumValue = d;
        this.oldMaximumValue = e;
        this.maximumValue = f;
    }
    get chart() {
        return this._chart;
    }
    set chart(a) {
        this._chart = a;
    }
    get axis() {
        return this._axis;
    }
    set axis(a) {
        this._axis = a;
    }
    get oldMinimumValue() {
        return this._oldMinimumValue;
    }
    set oldMinimumValue(a) {
        this._oldMinimumValue = a;
    }
    get minimumValue() {
        return this._minimumValue;
    }
    set minimumValue(a) {
        this._minimumValue = a;
    }
    get oldMaximumValue() {
        return this._oldMaximumValue;
    }
    set oldMaximumValue(a) {
        this._oldMaximumValue = a;
    }
    get maximumValue() {
        return this._maximumValue;
    }
    set maximumValue(a) {
        this._maximumValue = a;
    }
}
ChartAxisRangeChangedEventArgs.$t = markType(ChartAxisRangeChangedEventArgs, 'ChartAxisRangeChangedEventArgs', EventArgs.$);
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnnotationLayer extends Series {
    constructor() {
        super();
        this.nd = null;
        this.mc = null;
        this.mb = null;
        this.md = null;
        this.nb = { $type: Point_$type, x: NaN, y: NaN };
        this.me = false;
        this.nd = { $type: Point_$type, x: NaN, y: NaN };
    }
    bf() {
        return new AnnotationLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.ma = a;
    }
    mi(a) {
        if (a == null) {
            return false;
        }
        if (a.cj) {
            return false;
        }
        if (a.c6) {
            return false;
        }
        if (a == this) {
            return false;
        }
        return a.dw(a.bi.br, a.bi.bs, a.bi);
    }
    get_cm() {
        return this.mf;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    get_cw() {
        return this.mk || this.ml;
    }
    get_isUsableInLegend() {
        return this.ml;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                let e = c;
                let f = d;
                if (e != null) {
                    this.m4(e.series);
                    let g = e.series;
                    g.collectionChanged = delegateRemove(g.collectionChanged, runOn(this, this.m1));
                    if (typeCast(XamDataChart.$, e) !== null) {
                        let h = e;
                        this.m3(h.axes);
                        let i = h.axes;
                        i.collectionChanged = delegateRemove(i.collectionChanged, runOn(this, this.mr));
                    }
                }
                if (f != null) {
                    this.mz(f.series);
                    let j = f.series;
                    j.collectionChanged = delegateCombine(j.collectionChanged, runOn(this, this.m1));
                    if (typeCast(XamDataChart.$, f) !== null) {
                        let k = f;
                        this.my(k.axes);
                        let l = k.axes;
                        l.collectionChanged = delegateCombine(l.collectionChanged, runOn(this, this.mr));
                    }
                }
                break;
            case AnnotationLayer.$$p[3]:
            case AnnotationLayer.$$p[2]:
                if (this.cw) {
                    if (this.fh == -1) {
                        this.fh = XamDataChart.pw(this);
                    }
                }
                else {
                    this.fh = -1;
                    this.lb = null;
                    this.lc = null;
                }
                if (this.bs != null) {
                    this.bs.jm();
                }
                this.jl(true);
                break;
            case "TransitionProgress":
                this.md.c(this.ez, this.mc, this.mb);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.m0(this.mb, this.bi);
                }
                else {
                    this.m0(this.md, this.bi);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case AnnotationLayer.$$p[1]:
                if (this.bs != null) {
                    this.bs.jk();
                }
                break;
            case AnnotationLayer.$$p[0]:
                this.nd = this.nc;
                this.ix(this.nc);
                break;
            case "ShouldRenderAsOverlay":
                if (this.bs != null) {
                    this.bi.ah(this.bs);
                    this.bi.ad(this.bs);
                }
                break;
        }
    }
    m4(a) {
        for (let b of fromEnum(a)) {
            if (!(b == this)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.m2));
            }
        }
        this.jl(true);
    }
    m3(a) {
        for (let b of fromEnum(a)) {
            b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.ms));
        }
        this.jl(true);
    }
    mz(a) {
        for (let b of fromEnum(a)) {
            if (!(b == this)) {
                b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.m2));
            }
        }
        this.jl(true);
    }
    my(a) {
        for (let b of fromEnum(a)) {
            b.renderRequested = delegateCombine(b.renderRequested, runOn(this, this.ms));
        }
        this.jl(true);
    }
    mg(a) {
        if (a == null) {
            return false;
        }
        return true;
    }
    ms(a, b) {
        if (this.mg(a)) {
            this.mu(a, b.animate);
        }
    }
    mh(a) {
        if (a == null) {
            return false;
        }
        if (a.cj) {
            return false;
        }
        return true;
    }
    m2(a, b) {
        if (this.mh(a)) {
            this.mv(a, b.animate);
        }
    }
    mu(a, b) {
    }
    mv(a, b) {
    }
    m1(a, b) {
        this.mw(b);
    }
    mr(a, b) {
        this.mt(b);
    }
    m9() {
        if (this.lb != null) {
            return this.lb;
        }
        return this.ld;
    }
    na() {
        if (this.lc != null) {
            return this.lc;
        }
        return this.li;
    }
    mt(a) {
        if (a.oldItems != null) {
            for (let b of fromEn(a.oldItems)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.ms));
            }
        }
        if (a.newItems != null) {
            for (let c of fromEn(a.newItems)) {
                c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.ms));
            }
        }
        this.jl(true);
    }
    mw(a) {
        if (a.oldItems != null) {
            for (let b of fromEn(a.oldItems)) {
                b.renderRequested = delegateRemove(b.renderRequested, runOn(this, this.m2));
            }
        }
        if (a.newItems != null) {
            for (let c of fromEn(a.newItems)) {
                c.renderRequested = delegateCombine(c.renderRequested, runOn(this, this.m2));
            }
        }
        this.jl(true);
    }
    j1(a, b) {
        this.jl(false);
    }
    j0(a, b) {
        this.jl(true);
    }
    jm(a) {
        super.jm(a);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.da(a) && !this.de) {
            let b = this.mc;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.mc = this.md;
                this.md = b;
            }
            else {
                this.mc = this.mb;
                this.mb = b;
            }
            this.mx(this.mb, this.bi);
            this.jt();
        }
        else {
            if (!this.de) {
                this.mx(this.mb, this.bi);
            }
            this.m0(this.mb, this.bi);
        }
    }
    get_cj() {
        return true;
    }
    mx(a, b) {
    }
    m0(a, b) {
        this.ma.by();
    }
    mq(a) {
        let b = { $type: Point_$type, x: this.nb.x, y: this.nb.y };
        if (a.isVertical) {
            if (isNaN_(this.nb.y)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.nb.x)) {
                b.x = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        else {
            if (isNaN_(this.nb.x)) {
                return new Tuple$2(Boolean_$type, Point_$type, false, b);
            }
            if (isNaN_(this.nb.y)) {
                b.y = 0;
                return new Tuple$2(Boolean_$type, Point_$type, true, b);
            }
        }
        return new Tuple$2(Boolean_$type, Point_$type, true, b);
    }
    ix(a) {
        super.ix(a);
        if (isNaN_(this.nd.x) && isNaN_(this.nd.y)) {
            if (isNaN_(a.x) && isNaN_(a.y)) {
                this.ma.bx();
                return;
            }
            else {
                this.ma.bz();
                this.nb = a;
            }
        }
        else {
            this.ma.bz();
            this.nb = this.nd;
        }
        this.jl(true);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (!this.bi.q()) {
            d = false;
            return d;
        }
        return d;
    }
    get_ds() {
        return this.mj;
    }
    get mj() {
        return this.me;
    }
    set mj(a) {
        let b = this.me;
        this.me = a;
        this.raisePropertyChanged("ShouldRenderAsOverlay", b, this.me);
    }
}
AnnotationLayer.$t = markType(AnnotationLayer, 'AnnotationLayer', Series.$);
AnnotationLayer.$$p = markDep(DependencyProperty, PropertyMetadata, AnnotationLayer, 'raisePropertyChanged', ['CursorPosition:nc:m5', [Point_$type, { $type: Point_$type, x: NaN, y: NaN }], 'IsDefaultCrosshairDisabled:mf:m6', [0, true], 'UseIndex:mk:m7', [0, false], 'UseLegend:ml:m8', [0, false]]);
/**
 * @hidden
 */
class AnnotationLayerView extends SeriesView {
    constructor(a) {
        super(a);
        this.bu = null;
        this.bv = false;
        this.bw = -1;
        this.bu = a;
    }
    b0() {
        if (this.bv) {
            this.bv = false;
            this.bw = -1;
            this.bu.nb = { $type: Point_$type, x: NaN, y: NaN };
            this.bu.jl(true);
        }
    }
    bx() {
        this.bv = true;
        if (this.e.e4 != null) {
            this.e.e4.setTimeout(runOn(this, this.b0), 300);
        }
        else {
            this.bw = window.setTimeout(runOn(this, this.b0), 300);
        }
    }
    bz() {
        if (this.bv == true) {
            this.bv = false;
            if (this.bw != -1) {
                window.clearTimeout(this.bw);
                this.bw = -1;
            }
        }
    }
    by() {
        this.an();
    }
}
AnnotationLayerView.$t = markType(AnnotationLayerView, 'AnnotationLayerView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available collision modes of callout layers.
 */
var CalloutCollisionMode;
(function (CalloutCollisionMode) {
    /**
     * Automatically decide the collision strategy.
     */
    CalloutCollisionMode[CalloutCollisionMode["Auto"] = 0] = "Auto";
    /**
     * Use a simulated annealing based collision strategy. This is higher quality, but takes longer, and is performed time-sliced in the background until an acceptable quality is reached.
     */
    CalloutCollisionMode[CalloutCollisionMode["SimulatedAnnealing"] = 1] = "SimulatedAnnealing";
    /**
     * Use a greedy algorithm to avoid collisions. This is cheap and predictable, but of comparatively low quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["Greedy"] = 2] = "Greedy";
    /**
     * Use a greedy algorithm with localized center of mass hints to avoid collisions. This is relatively cheap to perform, compared to the simulated annealing approach, but is of comparatively lower quality.
     */
    CalloutCollisionMode[CalloutCollisionMode["GreedyCenterOfMass"] = 3] = "GreedyCenterOfMass";
})(CalloutCollisionMode || (CalloutCollisionMode = {}));
/**
 * @hidden
 */
let CalloutCollisionMode_$type = markEnum('CalloutCollisionMode', 'Auto,0|SimulatedAnnealing,1|Greedy,2|GreedyCenterOfMass,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Frame extends Base {
    static a(a, b, c, d) {
        let e = c.count;
        let f = d.count;
        let g = Math.max(e, f);
        let h = 1 - b;
        if (a.count < g) {
            a.s(a.count, new Array(g - a.count));
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (let i = 0; i < Math.min(e, f); ++i) {
            a._inner[i] = { $type: Point_$type, x: c._inner[i].x * h + d._inner[i].x * b, y: c._inner[i].y * h + d._inner[i].y * b };
        }
        if (e < f) {
            let j = e > 0 ? c._inner[e - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (let k = e; k < f; ++k) {
                a._inner[k] = { $type: Point_$type, x: j.x * h + d._inner[k].x * b, y: j.y * h + d._inner[k].y * b };
            }
        }
        if (e > f) {
            let l = f > 0 ? d._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (let m = f; m < e; ++m) {
                a._inner[m] = { $type: Point_$type, x: c._inner[m].x * h + l.x * b, y: c._inner[m].y * h + l.y * b };
            }
        }
    }
    static d(a, b, c, d, e) {
        let f = c.count;
        let g = d.count;
        let h = Math.max(f, g);
        let i = 1 - b;
        if (a.count < h) {
            a.s(a.count, new Array(h - a.count));
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        let j;
        let k;
        for (let l = 0; l < Math.min(f, g); ++l) {
            j = b * e._inner[l];
            j = j > 1 ? 1 : j;
            k = 1 - j;
            a._inner[l] = { $type: Point_$type, x: c._inner[l].x * k + d._inner[l].x * j, y: c._inner[l].y * k + d._inner[l].y * j };
        }
        if (f < g) {
            let m = f > 0 ? c._inner[f - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (let n = f; n < g; ++n) {
                j = b * e._inner[n];
                j = j > 1 ? 1 : j;
                k = 1 - j;
                a._inner[n] = { $type: Point_$type, x: m.x * k + d._inner[n].x * j, y: m.y * k + d._inner[n].y * j };
            }
        }
        if (f > g) {
            let o = g > 0 ? d._inner[g - 1] : { $type: Point_$type, x: 0, y: 0 };
            for (let p = g; p < f; ++p) {
                j = b * e._inner[p];
                j = j > 1 ? 1 : j;
                k = 1 - j;
                a._inner[p] = { $type: Point_$type, x: c._inner[p].x * k + o.x * j, y: c._inner[p].y * k + o.y * j };
            }
        }
    }
    static b(a, b, c, d) {
        let e = c.count;
        let f = d.count;
        let g = Math.max(e, f);
        let h = 1 - b;
        if (a.count < g) {
            let i = new Array(g - a.count);
            for (let j = 0; j < g - a.count; j++) {
                i[j] = 0;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (let k = 0; k < Math.min(e, f); ++k) {
            a._inner[k] = c._inner[k] * h + d._inner[k] * b;
        }
        if (e < f) {
            let l = e > 0 ? c._inner[e - 1] : 0;
            for (let m = e; m < f; ++m) {
                a._inner[m] = l * h + d._inner[m] * b;
            }
        }
        if (e > f) {
            let n = f > 0 ? d._inner[f - 1] : 0;
            for (let o = f; o < e; ++o) {
                a._inner[o] = c._inner[o] * h + n * b;
            }
        }
    }
    static e(a, b, c, d, e) {
        let f = c.count;
        let g = d.count;
        let h = Math.max(f, g);
        let i = 1 - b;
        if (a.count < h) {
            let j = new Array(h - a.count);
            for (let k = 0; k < h - a.count; k++) {
                j[k] = 0;
            }
            a.s(a.count, j);
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        let l;
        let m;
        for (let n = 0; n < Math.min(f, g); ++n) {
            l = b * e._inner[n];
            l = l > 1 ? 1 : l;
            m = 1 - l;
            a._inner[n] = c._inner[n] * m + d._inner[n] * l;
        }
        if (f < g) {
            let o = f > 0 ? c._inner[f - 1] : 0;
            for (let p = f; p < g; ++p) {
                l = b * e._inner[p];
                l = l > 1 ? 1 : l;
                m = 1 - l;
                a._inner[p] = o * m + d._inner[p] * l;
            }
        }
        if (f > g) {
            let q = g > 0 ? d._inner[g - 1] : 0;
            for (let r = g; r < f; ++r) {
                l = b * e._inner[r];
                l = l > 1 ? 1 : l;
                m = 1 - l;
                a._inner[r] = c._inner[r] * m + q * l;
            }
        }
    }
}
Frame.$t = markType(Frame, 'Frame');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FrameExtended extends Base {
    static b(a, b, c, d) {
        let e = BrushUtil.k(b, a, c, d);
        return e;
    }
    static a(a, b, c, d, e) {
        let f = c.count;
        let g = d.count;
        let h = Math.max(f, g);
        let i = ((() => {
            let $ret = new Brush();
            $ret.fill = "transparent";
            return $ret;
        })());
        let j = 1 - b;
        if (a.count < h) {
            let k = new Array(h - a.count);
            for (let l = 0; l < h - a.count; l++) {
                k[l] = new Brush();
            }
            a.s(a.count, k);
        }
        if (a.count > h) {
            a.v(h, a.count - h);
        }
        for (let m = 0; m < Math.min(f, g); ++m) {
            a._inner[m] = FrameExtended.b(b, c._inner[m], d._inner[m], e);
        }
        if (f < g) {
            let n = f > 0 ? c._inner[f - 1] : i;
            for (let o = f; o < g; ++o) {
                a._inner[o] = FrameExtended.b(b, n, d._inner[o], e);
            }
        }
        if (f > g) {
            let p = g > 0 ? d._inner[g - 1] : i;
            for (let q = g; q < f; ++q) {
                a._inner[q] = FrameExtended.b(b, c._inner[q], p, e);
            }
        }
    }
}
FrameExtended.$t = markType(FrameExtended, 'FrameExtended');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutLayerFrame extends Frame {
    constructor() {
        super();
        this.p = null;
        this.m = null;
        this.q = null;
        this.o = null;
        this.h = null;
        this.g = null;
        this.f = null;
        this.n = null;
        this.j = null;
        this.l = null;
        this.k = null;
        this.i = null;
        this.t = null;
        this.u = null;
        this.r = null;
        this.s = null;
        this.p = new List$1(Base.$, 0);
        this.m = new List$1(Base.$, 0);
        this.q = new List$1(Base.$, 0);
        this.o = new List$1(Brush.$, 0);
        this.h = new List$1(Brush.$, 0);
        this.g = new List$1(Brush.$, 0);
        this.f = new List$1(Brush.$, 0);
        this.n = new List$1(Number_$type, 0);
        this.j = new List$1(Number_$type, 0);
        this.l = new List$1(Number_$type, 0);
        this.k = new List$1(Number_$type, 0);
        this.i = new List$1(Number_$type, 0);
        this.t = new List$1(Number_$type, 0);
        this.u = new List$1(Number_$type, 0);
        this.r = new List$1(Number_$type, 0);
        this.s = new List$1(Number_$type, 0);
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        FrameExtended.a(this.o, a, d.o, e.o, 0);
        FrameExtended.a(this.f, a, d.f, e.f, 0);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        FrameExtended.a(this.g, a, d.g, e.g, 0);
        Frame.b(this.j, a, d.j, e.j);
        Frame.b(this.l, a, d.l, e.l);
        Frame.b(this.k, a, d.k, e.k);
        Frame.b(this.i, a, d.i, e.i);
        Frame.b(this.n, a, d.n, e.n);
        Frame.b(this.t, a, d.t, e.t);
        Frame.b(this.u, a, d.u, e.u);
        Frame.b(this.r, a, d.r, e.r);
        Frame.b(this.s, a, d.s, e.s);
        CalloutLayerFrame.v(this.p, a, d.p, e.p);
        CalloutLayerFrame.v(this.m, a, d.m, e.m);
        CalloutLayerFrame.v(this.q, a, d.q, e.q);
    }
    static v(a, b, c, d) {
        let e = c.count;
        let f = d.count;
        let g = Math.max(e, f);
        let h = 1 - b;
        if (a.count < g) {
            let i = new Array(g - a.count);
            for (let j = 0; j < g - a.count; j++) {
                i[j] = null;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (let k = 0; k < Math.min(e, f); ++k) {
            if (b == 0) {
                a._inner[k] = c._inner[k];
            }
            else {
                a._inner[k] = d._inner[k];
            }
        }
        if (e < f) {
            let l = e > 0 ? c._inner[e - 1] : null;
            for (let m = e; m < f; ++m) {
                if (b == 0) {
                    a._inner[m] = l;
                }
                else {
                    a._inner[m] = d._inner[m];
                }
            }
        }
        if (e > f) {
            let n = f > 0 ? d._inner[f - 1] : null;
            for (let o = f; o < e; ++o) {
                if (b == 0) {
                    a._inner[o] = c._inner[o];
                }
                else {
                    a._inner[o] = n;
                }
            }
        }
    }
}
CalloutLayerFrame.$t = markType(CalloutLayerFrame, 'CalloutLayerFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutAnnotation extends DependencyObject {
    constructor() {
        super(...arguments);
        this.propertyChanged = null;
        this.k = null;
        this.ab = 0;
        this.ac = 0;
        this.am = null;
        this.aw = null;
        this.aa = null;
        this.z = null;
        this.l = null;
        this._formatLabel = null;
        this.bk = null;
        this.bh = null;
        this.bj = null;
        this.bi = null;
        this.x = 0;
        this.o = false;
        this.n = true;
        this.bo = null;
        this.u = NaN;
        this.w = NaN;
        this.v = NaN;
        this.t = NaN;
    }
    a0(a, b, c) {
        this.az(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    az(a, b, c) {
        switch (a) {
            case CalloutAnnotation.$$p[13]:
                this.ab = c;
                break;
            case CalloutAnnotation.$$p[14]:
                this.ac = c;
                break;
            case CalloutAnnotation.$$p[9]:
                this.l = c;
                break;
            case CalloutAnnotation.$$p[5]:
                this.z = c;
                break;
            case CalloutAnnotation.$$p[6]:
                this.aa = c;
                break;
            case CalloutAnnotation.$$p[12]:
                this.am = c;
                break;
            case CalloutAnnotation.$$p[11]:
                this.bk = c;
                break;
            case CalloutAnnotation.$$p[7]:
                this.bi = c;
                break;
            case CalloutAnnotation.$$p[8]:
                this.bj = c;
                break;
            case CalloutAnnotation.$$p[4]:
                this.bh = c;
                break;
            case CalloutAnnotation.$$p[10]:
                this.x = c;
                break;
            case CalloutAnnotation.$$p[1]:
                this.n = true;
                this.u = c;
                break;
            case CalloutAnnotation.$$p[3]:
                this.n = true;
                this.w = c;
                break;
            case CalloutAnnotation.$$p[2]:
                this.n = true;
                this.v = c;
                break;
            case CalloutAnnotation.$$p[0]:
                this.n = true;
                this.t = c;
                break;
        }
        this.o = true;
    }
    get formatLabel() {
        return this._formatLabel;
    }
    set formatLabel(a) {
        this._formatLabel = a;
    }
    get backgroundPadding() {
        if (this.n) {
            this.n = false;
            this.bo = new Thickness(1, this.u, this.w, this.v, this.t);
        }
        return this.bo;
    }
    set backgroundPadding(a) {
        this.backgroundPaddingLeft = a.c;
        this.backgroundPaddingTop = a.e;
        this.backgroundPaddingRight = a.d;
        this.backgroundPaddingBottom = a.b;
    }
}
CalloutAnnotation.$t = markType(CalloutAnnotation, 'CalloutAnnotation', DependencyObject.$, [INotifyPropertyChanged_$type]);
CalloutAnnotation.$$p = markDep(DependencyProperty, PropertyMetadata, CalloutAnnotation, 'a0', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [Brush.$, null], 'Content', [4, null], 'Key', [4, null], 'LeaderBrush', [Brush.$, null], 'Outline', [Brush.$, null], 'Series', [Series.$, null], 'StrokeThickness', [1, 0], 'TextColor', [Brush.$, null], 'Text', [2, null], 'XValue', [4, 0], 'YValue', [4, 0]]);
/**
 * @hidden
 */
class CalloutAnnotationWrapper extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.c = null;
    }
    get b() {
        return this.a;
    }
    set b(a) {
        this.a = a;
        this.a.k = this;
    }
    equals(a) {
        let b = typeCast(CalloutAnnotationWrapper.$, a);
        if (b == null) {
            return super.equals(a);
        }
        if (b.b == null && this.b == null) {
            return super.equals(a);
        }
        if (b.b == null) {
            return false;
        }
        if (this.b.aa != null || b.b.aa != null) {
            return Base.equalsStatic(this.b.aa, b.b.aa);
        }
        return super.equals(a);
    }
    getHashCode() {
        if (this.b == null || this.b.aa == null) {
            return super.getHashCode();
        }
        return Base.getHashCodeStatic(this.b.aa);
    }
}
CalloutAnnotationWrapper.$t = markType(CalloutAnnotationWrapper, 'CalloutAnnotationWrapper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesPointOfInterest extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.c = null;
        this.a = null;
        this.d = null;
    }
}
SeriesPointOfInterest.$t = markType(SeriesPointOfInterest, 'SeriesPointOfInterest');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutLabelUpdatingEventArgs extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.d = null;
        this._item = null;
        this.b = null;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
}
CalloutLabelUpdatingEventArgs.$t = markType(CalloutLabelUpdatingEventArgs, 'CalloutLabelUpdatingEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutSeriesSelectingEventArgs extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.d = null;
        this._item = null;
        this.a = null;
        this.e = null;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
}
CalloutSeriesSelectingEventArgs.$t = markType(CalloutSeriesSelectingEventArgs, 'CalloutSeriesSelectingEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutStyleUpdatingEventArgs extends Base {
    constructor() {
        super(...arguments);
        this._xValue = null;
        this._yValue = null;
        this._item = null;
        this._series = null;
        this._background = null;
        this._textColor = null;
        this._outline = null;
        this._leaderBrush = null;
        this._strokeThickness = 0;
    }
    get xValue() {
        return this._xValue;
    }
    set xValue(a) {
        this._xValue = a;
    }
    get yValue() {
        return this._yValue;
    }
    set yValue(a) {
        this._yValue = a;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get background() {
        return this._background;
    }
    set background(a) {
        this._background = a;
    }
    get textColor() {
        return this._textColor;
    }
    set textColor(a) {
        this._textColor = a;
    }
    get outline() {
        return this._outline;
    }
    set outline(a) {
        this._outline = a;
    }
    get leaderBrush() {
        return this._leaderBrush;
    }
    set leaderBrush(a) {
        this._leaderBrush = a;
    }
    get strokeThickness() {
        return this._strokeThickness;
    }
    set strokeThickness(a) {
        this._strokeThickness = a;
    }
}
CalloutStyleUpdatingEventArgs.$t = markType(CalloutStyleUpdatingEventArgs, 'CalloutStyleUpdatingEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutContentUpdatingEventArgs extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.d = null;
        this._item = null;
        this.a = null;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
}
CalloutContentUpdatingEventArgs.$t = markType(CalloutContentUpdatingEventArgs, 'CalloutContentUpdatingEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutKey extends Base {
    constructor(a, b) {
        super();
        this._item = null;
        this.a = null;
        this.item = a;
        this.a = b;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    getHashCode() {
        return Base.getHashCodeStatic(this.item) ^ Base.getHashCodeStatic(this.a);
    }
    equals(a) {
        let b = typeCast(CalloutKey.$, a);
        if (b == null) {
            return super.equals(a);
        }
        return Base.referenceEquals(this.item, b.item) && this.a == b.a;
    }
}
CalloutKey.$t = markType(CalloutKey, 'CalloutKey');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutViewHelper extends Base {
    static a(a, b, c, d, e, f, g, h) {
        let i = Math.sqrt((c - a) * (c - a) + (d - b) * (d - b));
        let j = (c - a) / i;
        let k = (d - b) / i;
        let l = a - e;
        let m = b - f;
        let n = g - e;
        let o = h - f;
        let p = -k;
        let q = j;
        let r = n * p + o * q;
        let s = n * m - o * l;
        let t = l * p + m * q;
        let u = s / r;
        let v = t / r;
        if (u >= 0 && v >= 0 && v <= 1) {
            return u;
        }
        return Number.POSITIVE_INFINITY;
    }
    static b(a, b, c, d) {
        let e = a.x;
        let f = a.y;
        let g = 0;
        let h = 0;
        let i = 0;
        let j = 0;
        let k = 0;
        let l = 0;
        if (e < 0) {
            g = -e;
            k = g;
            e = 0;
        }
        if (f < 0) {
            h = -f;
            l = h;
            f = 0;
        }
        if (e > b) {
            i = e - b;
        }
        if (f > c) {
            j = f - c;
        }
        let m = new Thickness(1, g, h, i, j);
        let n = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k, l + c);
        let o = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l, k + b, l);
        let p = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k, l + c, k + b, l + c);
        let q = CalloutViewHelper.a(e, f, k + b / 2, l + c / 2, k + b, l, k + b, l + c);
        let r = Math.min(n, Math.min(o, Math.min(p, q)));
        let s = 0;
        let t = 0;
        if (isInfinity(r)) {
            s = e;
            t = f;
        }
        else {
            let u = k + b / 2;
            let v = l + c / 2;
            let w = e;
            let x = f;
            let y = Math.sqrt((u - w) * (u - w) + (v - x) * (v - x));
            let z = (u - w) / y;
            let aa = (v - x) / y;
            s = w + z * r;
            t = x + aa * r;
        }
        d.ak = e;
        d.am = f;
        d.al = s;
        d.an = t;
        return m;
    }
}
CalloutViewHelper.$t = markType(CalloutViewHelper, 'CalloutViewHelper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutLayer extends AnnotationLayer {
    constructor() {
        super();
        this.calloutStyleUpdating = null;
        this.np = null;
        this.nq = null;
        this.nr = null;
        this.no = null;
        this.nn = null;
        this.oe = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        this.oh = new List$1(CalloutAnnotationWrapper.$, 0);
        this.oi = new List$1(CalloutAnnotationWrapper.$, 0);
        this.nl = null;
        this.of = new LinkedList$1(CalloutAnnotationWrapper.$);
        this.oc = new Dictionary$2(CalloutAnnotationWrapper.$, LinkedListNode$1.$.specialize(CalloutAnnotationWrapper.$), 0);
        this.nx = null;
        this.q7 = new Rect(0, 0, 0, 1, 1);
        this.n4 = false;
        this.os = 0;
        this.q6 = Rect.empty;
        this.n2 = false;
        this.n3 = false;
        this.calloutContentUpdating = null;
        this.calloutLabelUpdating = null;
        this.calloutSeriesSelecting = null;
        this.og = new List$1(SeriesPointOfInterest.$, 0);
        this.n6 = false;
        this.n7 = false;
        this.ok = 0;
        this.n5 = false;
        this.n1 = true;
        FastItemObjectColumn.m();
        this.mk = true;
        let a = new CalloutLayerFrame();
        let b = new CalloutLayerFrame();
        let c = new CalloutLayerFrame();
        let d = this.fi / 1000;
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = CalloutLayer.$;
    }
    pz(a, b) {
        this.oi.clear();
        this.jl(false);
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        let e = this.od();
        switch (a) {
            case 3:
                this.qb(b, e);
                break;
            case 1:
                for (let f = b; f < b + c; f++) {
                    let g = new CalloutAnnotation();
                    let h = new CalloutAnnotationWrapper();
                    h.b = g;
                    h.b.series = this.nk;
                    this.oi.insert(f, h);
                    this.qb(f, e);
                }
                break;
            case 0:
                this.oi.v(b, c);
                break;
            case 2:
                for (let i = b; i < b + c; i++) {
                    this.qb(i, e);
                }
                break;
            case 4:
                this.oi.clear();
                for (let j = 0; j < this.bz.count; j++) {
                    let k = new CalloutAnnotation();
                    let l = new CalloutAnnotationWrapper();
                    l.b = k;
                    l.b.series = this.nk;
                    this.oi.add(l);
                    this.qb(j, e);
                }
                break;
        }
        this.jl(true);
    }
    da(a) {
        return false;
    }
    od() {
        let a = new Dictionary$2(String_$type, Series.$, 0);
        if (this.bs != null) {
            for (let b = 0; b < this.bs.series.count; b++) {
                let c = this.bs.series._inner[b];
                if (c.name != null && !a.containsKey(c.name)) {
                    a.addItem(c.name, c);
                }
            }
        }
        return a;
    }
    qb(a, b) {
        if (this.nw == null || this.nu == null) {
            return;
        }
        let c = a;
        if (this.nv != null) {
            c = this.nv.item(a);
        }
        let d = this.nw.item(a);
        let e = this.nu.item(a);
        let f = this.oi._inner[a];
        if (this.nt != null) {
            if (f.b.aa != this.nt.item(a)) {
                f.b.key = this.nt.item(a);
            }
        }
        if (this.oc.containsKey(f)) {
            f.b = this.oc.item(f).c.b;
        }
        f.b.xValue = c;
        f.b.yValue = d;
        if (this.calloutLabelUpdating != null) {
            let g = ((() => {
                let $ret = new CalloutLabelUpdatingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = this.bz.item(a);
                return $ret;
            })());
            this.calloutLabelUpdating(this, g);
            if (g.b != null && !Base.equalsStatic(g.b, f.b.am)) {
                let h = g.b;
                f.b.text = h != null ? h.toString() : "";
            }
        }
        else {
            f.b.text = e != null ? e.toString() : "";
        }
        if (this.ns != null) {
            f.b.content = this.ns.item(a);
        }
        else {
            f.b.content = this.bz.item(a);
        }
        if (this.calloutSeriesSelecting != null) {
            let i = ((() => {
                let $ret = new CalloutSeriesSelectingEventArgs();
                $ret.c = c;
                $ret.d = d;
                $ret.item = this.bz.item(a);
                return $ret;
            })());
            this.calloutSeriesSelecting(this, i);
            if (i.a != null) {
                f.b.series = i.a;
            }
            else if (i.e != null) {
                if (b.containsKey(i.e)) {
                    f.b.series = b.item(i.e);
                }
            }
        }
        this.qc(f);
    }
    qc(a) {
        let b = new Thickness(0, 3);
        if (isNaN_(this.q9.c) || isNaN_(this.q9.e) || isNaN_(this.q9.d) || isNaN_(this.q9.b)) {
            b = new Thickness(0, 3);
        }
        else {
            b = this.q9;
        }
        let c = this.q2 != null ? this.q2 : this.nh.cg(a.b.l);
        let d = this.q5 != null ? this.q5 : this.nh.cj();
        let e = this.q4 != null ? this.q4 : this.nh.ci();
        let f = this.q3 != null ? this.q3 : this.nh.ch(a.b.l);
        let g = isNaN_(this.oq) ? 0 : this.oq;
        if (this.oa && this.calloutStyleUpdating != null) {
            let h = new CalloutStyleUpdatingEventArgs();
            h.item = a.b.z;
            h.xValue = a.b.ab;
            h.yValue = a.b.ac;
            h.series = a.b.l;
            h.background = c;
            h.textColor = d;
            h.outline = e;
            h.leaderBrush = f;
            h.strokeThickness = g;
            this.calloutStyleUpdating(this, h);
            c = h.background;
            d = h.textColor;
            e = h.outline;
            f = h.leaderBrush;
            g = h.strokeThickness;
        }
        a.b.backgroundPadding = b;
        a.b.background = c;
        a.b.textColor = d;
        a.b.outline = e;
        a.b.leaderBrush = f;
        a.b.strokeThickness = g;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == CalloutLayer.$$p[19]) {
            return this.ft(a, b, this.pn);
        }
        if (c == CalloutLayer.$$p[23]) {
            return this.ft(a, b, this.pu);
        }
        if (c == CalloutLayer.$$p[24]) {
            return this.ft(a, b, this.px);
        }
        if (c == CalloutLayer.$$p[18]) {
            return this.ft(a, b, this.pk);
        }
        if (c == CalloutLayer.$$p[14]) {
            return this.ft(a, b, this.pe);
        }
        return super.fs(a, b);
    }
    get nu() {
        return this.np;
    }
    set nu(a) {
        if (this.np != a) {
            let b = this.np;
            this.np = a;
            this.raisePropertyChanged("LabelColumn", b, this.np);
        }
    }
    get nv() {
        return this.nq;
    }
    set nv(a) {
        if (this.nq != a) {
            let b = this.nq;
            this.nq = a;
            this.raisePropertyChanged("XColumn", b, this.nq);
        }
    }
    get nw() {
        return this.nr;
    }
    set nw(a) {
        if (this.nr != a) {
            let b = this.nr;
            this.nr = a;
            this.raisePropertyChanged("YColumn", b, this.nr);
        }
    }
    get nt() {
        return this.no;
    }
    set nt(a) {
        if (this.no != a) {
            let b = this.no;
            this.no = a;
            this.raisePropertyChanged("KeyColumn", b, this.no);
        }
    }
    get ns() {
        return this.nn;
    }
    set ns(a) {
        if (this.nn != a) {
            let b = this.nn;
            this.nn = a;
            this.raisePropertyChanged("ContentColumn", b, this.nn);
        }
    }
    p1(a, b) {
        if (b.propertyName == CalloutAnnotation.$$p[13] || b.propertyName == CalloutAnnotation.$$p[14]) {
            let c = a.k;
            if (!this.oe.contains(c)) {
                this.oe.add_1(c);
                this.oh.add(c);
                this.jl(false);
            }
        }
    }
    bf() {
        return new CalloutLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.nh = a;
    }
    get q9() {
        return new Thickness(1, this.om, this.oo, this.on, this.ol);
    }
    get nm() {
        if (this.nl == null) {
            this.nl = FontUtil.toFontInfo(this.e4, this.pq);
        }
        return this.nl;
    }
    mv(a, b) {
        if (this.nk == null || this.nk == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        c.p.clear();
        c.q.clear();
        c.m.clear();
        c.f.clear();
        c.h.clear();
        c.g.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.n.clear();
        c.o.clear();
        c.t.clear();
        c.u.clear();
        c.r.clear();
        c.s.clear();
        let d = this.oj();
        let e = new List$1(CalloutAnnotationWrapper.$, 0);
        if (this.n8) {
            if (this.mi(this.nk)) {
                this.p8(this.nk, c, e);
            }
            else {
                for (let f of fromEnum(this.bs.series)) {
                    if (this.mi(f)) {
                        this.p8(f, c, e);
                    }
                }
            }
        }
        this.p7(c, d, e);
    }
    j1(a, b) {
        super.j1(a, b);
        let c = b.width - this.q7.width;
        let d = b.height - this.q7.height;
        let e = 0;
        if (Math.abs(c) > Math.abs(d)) {
            e = c;
            this.ok = c * this.l8.width;
        }
        else {
            e = d;
            this.ok = d * this.l8.height;
        }
        if (e > 0 && this.ok > 5) {
            this.n7 = true;
        }
        if (e < 0 && this.ok > 5) {
            this.n6 = true;
        }
    }
    j0(a, b) {
        super.j0(a, b);
        if (!a.equals1(b)) {
            this.n5 = true;
        }
    }
    get q8() {
        return this.q6;
    }
    set q8(a) {
        this.q6 = a;
    }
    p7(a, b, c) {
        if (this.bs != null) {
            this.q7 = this.bs.n2;
        }
        if (this.l8.isEmpty) {
            return;
        }
        this.q8 = new Rect(0, this.l8.left, this.l8.top, this.l8.width, this.l8.height);
        if (this.nx != null && this.pb != null && this.pb != this.nx.ak) {
            this.p3();
        }
        if (this.nx == null) {
            let d = this.ny();
            if (d != null) {
                this.nx = d;
                let e = this.nx;
                e.labelsMoved = delegateCombine(e.labelsMoved, runOn(this, this.p0));
            }
            else {
                let f = this.l0(this.bi);
                let g = 0;
                if (this.nk != null) {
                    if (this.nk.isVertical) {
                        g = 2;
                    }
                }
                else {
                    let h = false;
                    if (this.bs != null && this.bs.series.count > 0) {
                        h = true;
                        for (let i of fromEnum(this.bs.series)) {
                            if (!i.cj) {
                                if (!i.isVertical) {
                                    h = false;
                                }
                            }
                        }
                    }
                    if (h) {
                        g = 2;
                    }
                }
                this.nx = new LabelCollisionManager(this.l8.right, this.l8.bottom, this.l8, this.nh.b4(), this.op, this.nz(), g, this.ow(), this.ov(), this.n9);
                if (this.pb != null) {
                    this.nx.ak = this.pb;
                    this.nx.ai = this;
                }
                let j = this.nx;
                j.labelsMoved = delegateCombine(j.labelsMoved, runOn(this, this.p0));
            }
        }
        if (this.n6) {
            this.n6 = false;
            if (this.nx.ag > 2) {
                this.n4 = true;
            }
        }
        if (this.n7) {
            this.n7 = false;
            if (this.ok > 5) {
                this.n4 = true;
            }
        }
        if (this.n5) {
            this.n5 = false;
            this.nx.ay(this.l8.right, this.l8.bottom, this.l8);
            this.n4 = true;
        }
        let k = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let l = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        let m = new List$1(CalloutAnnotationWrapper.$, 0);
        let n = new List$1(CalloutAnnotationWrapper.$, 0);
        let o = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (let p = 0; p < b.count; p++) {
            o.add_1(b._inner[p]);
        }
        for (let q = 0; q < c.count; q++) {
            o.add_1(c._inner[q]);
        }
        let r = this.of.c;
        while (r != null) {
            let s = r.a;
            if (!o.contains(r.c)) {
                n.add(r.c);
                l.add_1(r.c);
                let t = r.c.b;
                t.propertyChanged = delegateRemove(t.propertyChanged, runOn(this, this.p1));
                this.of.h(r);
                this.oc.removeItem(r.c);
                this.nx.ax(r.c.c);
            }
            r = s;
        }
        for (let u = 0; u < b.count; u++) {
            if (!this.oc.containsKey(b._inner[u])) {
                this.of.f(b._inner[u]);
                let v = b._inner[u].b;
                v.propertyChanged = delegateCombine(v.propertyChanged, runOn(this, this.p1));
                this.oc.addItem(b._inner[u], this.of.d);
                m.add(b._inner[u]);
                k.add_1(b._inner[u]);
                this.n4 = true;
            }
        }
        for (let w = 0; w < c.count; w++) {
            if (!this.oc.containsKey(c._inner[w])) {
                this.of.f(c._inner[w]);
                this.oc.addItem(c._inner[w], this.of.d);
                let x = c._inner[w].b;
                x.propertyChanged = delegateCombine(x.propertyChanged, runOn(this, this.p1));
                m.add(c._inner[w]);
                k.add_1(c._inner[w]);
                this.n4 = true;
            }
        }
        if (this.n2 == true) {
            this.n2 = false;
            this.n4 = true;
        }
        if (this.oh.count > 0) {
            this.n4 = true;
            this.oh.clear();
            this.oe.clear();
        }
        r = this.of.c;
        while (r != null) {
            let y = this.n0(r.c);
            if (y == null) {
                return;
            }
            if (!Base.equalsStatic(y, r.c.c.c)) {
                let z = false;
                if (r.c.c.c == null) {
                    z = true;
                }
                let aa = r.c.c;
                aa.o = y.b;
                aa.p = y.c;
                if (!isNaN_(aa.o) && !isNaN_(aa.p)) {
                    aa.n = y.e;
                    aa.m = y.d;
                    if (aa.b == null) {
                        this.nx.p(aa);
                    }
                    if (z) {
                        this.nx.al(aa);
                    }
                    else {
                        this.nx.au(aa);
                    }
                }
            }
            r = r.a;
        }
        let ab = this.nx.ah();
        let ac = this.nx.q();
        if (this.n4 && (ab != 0 || ac)) {
            this.n4 = false;
            this.os = 0x7FFFFFFF;
            if (this.pb != null) {
                let ad = true;
                for (let ae = 0; ae < this.bs.series.count; ae++) {
                    let af = this.bs.series._inner[ae];
                    if (af.cj && typeCast(CalloutLayer.$, af) !== null) {
                        let ag = af;
                        if (ag.pb == this.pb) {
                            if (!ag.q8.equals1(this.nx.a0)) {
                                ad = false;
                                break;
                            }
                        }
                    }
                }
                if (ad) {
                    this.nx.az();
                }
                else {
                    this.nx.am();
                    this.nx.an();
                }
            }
            else {
                this.nx.az();
            }
        }
        else {
            this.nx.an();
        }
        let ah = this.of.c;
        while (ah != null) {
            let ai = ah.c;
            a.m.add1(ai);
            a.f.add(ai.b.bh);
            a.h.add(ai.b.bj);
            a.g.add(ai.b.bi);
            a.j.add(ai.b.backgroundPadding.c);
            a.l.add(ai.b.backgroundPadding.e);
            a.k.add(ai.b.backgroundPadding.d);
            a.i.add(ai.b.backgroundPadding.b);
            a.n.add(ai.b.x);
            a.o.add(ai.b.bk);
            a.p.add1(ai.b.am);
            a.q.add1(ai.b.z);
            let aj = ai.c;
            a.t.add(ai.c.o - (ai.c.g - ai.c.l));
            a.u.add(ai.c.p - (ai.c.h - ai.c.k));
            a.r.add(ai.c.g - ai.c.l);
            a.s.add(ai.c.h - ai.c.k);
            ah = ah.a;
        }
    }
    p3() {
        if (this.nx != null) {
            let a = this.of.c;
            while (a != null) {
                let b = a.c.c;
                if (b != null) {
                    this.nx.ax(b);
                }
                a = a.a;
            }
            let c = this.nx;
            c.labelsMoved = delegateRemove(c.labelsMoved, runOn(this, this.p0));
            this.nx = null;
        }
        this.p2();
    }
    ny() {
        if (this.bs == null) {
            return null;
        }
        for (let a = 0; a < this.bs.series.count; a++) {
            let b = this.bs.series._inner[a];
            if (b.cj && typeCast(CalloutLayer.$, b) !== null) {
                let c = b;
                if (c != this) {
                    if (c.pb != null && c.pb == this.pb) {
                        if (c.nx != null) {
                            return c.nx;
                        }
                    }
                }
            }
        }
        return null;
    }
    ov() {
        return 20000;
    }
    ow() {
        return 300;
    }
    nz() {
        switch (this.ne) {
            case 0: return 2;
            case 2: return 1;
            case 3: return 2;
            case 1: return 0;
        }
        return 2;
    }
    p0(a) {
        let b = this.nx.ah();
        if (b < this.os) {
            this.os = b;
            this.jl(false);
        }
    }
    n0(a) {
        let b = this.nk;
        if (a.b.l != null) {
            b = a.b.l;
        }
        if (b == null) {
            for (let c = 0; c < this.bs.series.count; c++) {
                let d = this.bs.series._inner[c];
                if (!d.cj) {
                    b = d;
                    break;
                }
            }
        }
        if (b == null) {
            return null;
        }
        let e = b.ag();
        let f = b.eh();
        let g = null;
        let h = null;
        for (let i = 0; i < e.length; i++) {
            if (e[i].ch) {
                h = e[i];
            }
            else {
                g = e[i];
            }
        }
        if (g == null || h == null) {
            return null;
        }
        if (!g.cg() || !h.cg()) {
            return null;
        }
        let j = 0;
        let k = 0;
        if (g.b4 && g.categoryMode != 0) {
            if (b.cr) {
                j = b.getOffsetValue();
            }
            else if (b.cl) {
                j = b.getOffsetValue();
            }
        }
        if (h.b4 && h.categoryMode != 0) {
            if (b.cl) {
                k = b.getOffsetValue();
            }
        }
        let l = new ScalerParams(0, this.bs.n2, g.i9, g.ca, g.i4());
        l.b = f;
        let m = new ScalerParams(0, this.bs.n2, h.i9, h.ca, h.i4());
        m.b = f;
        let n = g.dy(this.or(a.b.ab), l) + j;
        let o = h.dy(this.or(a.b.ac), m) + k;
        let p = new QuadTreeBoundingBox();
        p.b = n;
        p.c = o;
        p.e = 3;
        p.d = 3;
        p.g = a.b;
        return p;
    }
    or(a) {
        if (typeCast(Date_$type, a) !== null) {
            return a.getTime();
        }
        if (a == null) {
            return 0;
        }
        return a;
    }
    oj() {
        let a = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let b = 0; b < this.oi.count; b++) {
            if (stringIsNullOrEmpty(this.oi._inner[b].b.am)) {
                continue;
            }
            if (this.oi._inner[b].c == null) {
                let c = new LabelCollisionInfo();
                this.oi._inner[b].c = c;
                let d = this.nh.cl(this.ox(this.oi._inner[b]), this.oi._inner[b].b.backgroundPadding);
                c.k = d.height / 2;
                c.l = d.width / 2;
            }
            let e = this.n0(this.oi._inner[b]);
            if (e == null || e.b < this.l8.left || e.b > this.l8.right || e.c < this.l8.top || e.c > this.l8.bottom) {
                continue;
            }
            a.add(this.oi._inner[b]);
        }
        return a;
    }
    ox(a) {
        return a.b.am;
    }
    mi(a) {
        if (!super.mi(a)) {
            return false;
        }
        return true;
    }
    iw() {
        super.iw();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.n1) {
            this.n1 = false;
            this.p5();
        }
        if (this.ca()) {
            this.qa(this.md, false);
        }
        else {
            this.qa(this.mb, false);
        }
    }
    p6() {
        if (!this.n3) {
            this.n3 = true;
            this.jl(true);
        }
    }
    p8(a, b, c) {
        let d = false;
        if (this.n3) {
            this.n3 = false;
            d = true;
        }
        if (a.ch(this.og, this.ob, this.ot)) {
            let e = this.og;
            for (let f = 0; f < this.og.count; f++) {
                let g = e._inner[f];
                let h = g.a.item != null ? g.a.item : g.a;
                let i = a;
                let j = new CalloutKey(h, i);
                let k = new CalloutAnnotationWrapper();
                let l = new CalloutAnnotation();
                k.b = l;
                l.key = j;
                let m = false;
                if (this.oc.containsKey(k)) {
                    k = this.oc.item(k).c;
                    l = k.b;
                    m = d;
                }
                else {
                    m = true;
                }
                let n = l.ab;
                let o = l.ac;
                if (this.or(n) != this.or(g.b)) {
                    l.xValue = g.b;
                }
                if (this.or(o) != this.or(g.c)) {
                    l.yValue = g.c;
                }
                l.series = a;
                let p = false;
                if (g.d != l.aw) {
                    l.aw = g.d;
                    p = true;
                }
                if (m || p) {
                    if (this.calloutLabelUpdating != null) {
                        let q = ((() => {
                            let $ret = new CalloutLabelUpdatingEventArgs();
                            $ret.c = l.ab;
                            $ret.d = l.ac;
                            $ret.item = h;
                            return $ret;
                        })());
                        this.calloutLabelUpdating(this, q);
                        if (q.b != null && !Base.equalsStatic(q.b, k.b.am)) {
                            let r = q.b;
                            k.b.text = r != null ? r.toString() : "";
                        }
                    }
                    else {
                        if (g.d != null) {
                            l.text = g.d;
                        }
                    }
                }
                if (l.am == null) {
                    continue;
                }
                if (m || p) {
                    if (this.calloutContentUpdating != null) {
                        let s = ((() => {
                            let $ret = new CalloutContentUpdatingEventArgs();
                            $ret.c = l.ab;
                            $ret.d = l.ac;
                            $ret.item = h;
                            $ret.a = h;
                            return $ret;
                        })());
                        this.calloutContentUpdating(this, s);
                        if (s.a != null && s.a != k.b.z) {
                            k.b.content = s.a;
                        }
                    }
                    else {
                        if (h != null && h != k.b.z) {
                            k.b.content = h;
                        }
                    }
                }
                if (m) {
                    this.qc(k);
                }
                if (k.c == null) {
                    let t = new LabelCollisionInfo();
                    k.c = t;
                    let u = this.nh.cl(this.ox(k), k.b.backgroundPadding);
                    t.k = u.height / 2;
                    t.l = u.width / 2;
                }
                let v = this.n0(k);
                if (v == null || v.b < this.l8.left || v.b > this.l8.right || v.c < this.l8.top || v.c > this.l8.bottom) {
                    continue;
                }
                c.add(k);
            }
        }
    }
    bd() {
        return 1;
    }
    ar(a, b) {
        let c = this.nx.d(a, b);
        if (c == null) {
            return null;
        }
        return c.u;
    }
    dh(a, b) {
        if (this.nx == null) {
            return false;
        }
        return this.nx.d(a, b) != null;
    }
    qa(a, b) {
        let c = 0;
        let d = new HashSet$1(CalloutAnnotationWrapper.$, 0);
        for (c = 0; c < a.p.count; c++) {
            let e = a.m._inner[c];
            if (isNaN_(a.t._inner[c]) || isNaN_(a.u._inner[c])) {
                continue;
            }
            let f = this.nh.b6.item(e);
            d.add_1(e);
            if (f.f != a.p._inner[c]) {
                f.f = a.p._inner[c];
                let g = f.s();
            }
            f.c = a.n._inner[c];
            f.k = a.f._inner[c];
            f.n = a.o._inner[c];
            f.m = f.c > 0 ? a.h._inner[c] : this.bi.bn();
            f.l = a.g._inner[c];
            f.v = new Thickness(1, a.j._inner[c], a.l._inner[c], a.k._inner[c], a.i._inner[c]);
            this.nh.ce(f, Math.min(a.r._inner[c], a.r._inner[c] + a.t._inner[c]), Math.min(a.s._inner[c], a.s._inner[c] + a.u._inner[c]));
            this.nh.cf(f, e, a.q._inner[c]);
            f.p = { $type: Point_$type, x: a.t._inner[c], y: a.u._inner[c] };
        }
        let h = new List$1(CalloutAnnotationWrapper.$, 0);
        for (let i of fromEnum(this.nh.b6.c)) {
            if (!d.contains(i)) {
                h.add(i);
            }
        }
        for (let j = 0; j < h.count; j++) {
            this.nh.b6.g(h._inner[j]);
        }
    }
    m0(a, b) {
        super.m0(a, b);
        if (this.ca()) {
            this.qa(this.md, true);
        }
        else {
            this.qa(this.mb, false);
        }
    }
    c8() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case CalloutLayer.$$p[21]:
                this.nl = null;
                this.nh.cd();
                this.jl(true);
                break;
            case CalloutLayer.$$p[20]:
                this.jl(true);
                break;
            case CalloutLayer.$$p[13]:
                this.jl(true);
                break;
            case "SeriesViewer":
                if (c != null) {
                    let e = c;
                    e.seriesAnimating = delegateRemove(e.seriesAnimating, runOn(this, this.p9));
                }
                if (d != null) {
                    let f = d;
                    f.seriesAnimating = delegateCombine(f.seriesAnimating, runOn(this, this.p9));
                }
                if (d == null) {
                    this.p3();
                }
                break;
            case CalloutLayer.$$p[15]:
            case CalloutLayer.$$p[16]:
            case CalloutLayer.$$p[1]:
            case CalloutLayer.$$p[5]:
            case CalloutLayer.$$p[4]:
            case CalloutLayer.$$p[7]:
            case CalloutLayer.$$p[9]:
            case CalloutLayer.$$p[8]:
            case CalloutLayer.$$p[6]:
            case CalloutLayer.$$p[11]:
            case CalloutLayer.$$p[12]:
                this.p4();
                break;
            case CalloutLayer.$$p[19]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nu);
                    this.nu = this.by(this.pn);
                }
                break;
            case "LabelColumn":
                this.p4();
                break;
            case CalloutLayer.$$p[14]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ns);
                    this.ns = this.by(this.pe);
                }
                break;
            case "ContentColumn":
                this.p4();
                break;
            case CalloutLayer.$$p[23]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nv);
                    this.nv = stringIsNullOrEmpty(this.pu) == false ? this.by(this.pu) : null;
                }
                break;
            case "XColumn":
                this.p4();
                break;
            case CalloutLayer.$$p[24]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nw);
                    this.nw = this.by(this.px);
                }
                break;
            case "YColumn":
                this.p4();
                break;
            case CalloutLayer.$$p[18]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nt);
                    this.nt = this.by(this.pk);
                }
                break;
            case "KeyColumn":
                this.p4();
                break;
            case "FastItemsSource":
                this.n2 = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nu);
                    c.deregisterColumn(this.ns);
                    c.deregisterColumn(this.nv);
                    c.deregisterColumn(this.nw);
                    c.deregisterColumn(this.nt);
                    this.nu = null;
                    this.ns = null;
                    this.nv = null;
                    this.nw = null;
                    this.nt = null;
                    this.oi.clear();
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nu = this.by(this.pn);
                    this.ns = this.by(this.pe);
                    if (stringIsNullOrEmpty(this.pu) == false) {
                        this.nv = this.by(this.pu);
                    }
                    this.nw = this.by(this.px);
                    this.nt = this.by(this.pk);
                }
                this.p4();
                break;
        }
    }
    p9(a) {
        if (a.cj) {
            return;
        }
        if ((a == this.nk || this.nk == null) && this.n8) {
            this.jl(false);
        }
    }
    p4() {
        if (this.n1 == false) {
            this.n1 = true;
            this.jl(false);
        }
    }
    p2() {
        this.nh.b6.clear();
        this.of.g();
        this.oc.clear();
    }
    p5() {
        if (this.nw == null || this.nu == null) {
            let a = this.of.c;
            while (a != null) {
                this.qc(a.c);
                a = a.a;
            }
            return;
        }
        let b = this.od();
        for (let c = 0; c < this.nw.count; c++) {
            let d;
            if (this.oi.count <= c) {
                let e = new CalloutAnnotation();
                d = new CalloutAnnotationWrapper();
                d.b = e;
                d.b.series = this.nk;
                this.oi.add(d);
            }
            else {
                d = this.oi._inner[c];
            }
            this.qb(c, b);
        }
    }
}
CalloutLayer.$t = markType(CalloutLayer, 'CalloutLayer', AnnotationLayer.$);
CalloutLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CalloutLayer, 'raisePropertyChanged', ['AutoCalloutLabelPrecision:ot:qd', [1, 5], 'CalloutBackground:q2:qe', [Brush.$, null], 'CalloutCollisionMode:ne:qf', [CalloutCollisionMode_$type, enumGetBox(CalloutCollisionMode_$type, 3)], 'CalloutInterpolatedValuePrecision:ou:qg', [1, -1], 'CalloutLeaderBrush:q3:qh', [Brush.$, null], 'CalloutOutline:q4:qi', [Brush.$, null], 'CalloutPaddingBottom:ol:qj', [1, NaN], 'CalloutPaddingLeft:om:qk', [1, NaN], 'CalloutPaddingRight:on:ql', [1, NaN], 'CalloutPaddingTop:oo:qm', [1, NaN], 'CalloutPositionPadding:op:qn', [1, 10], 'CalloutStrokeThickness:oq:qo', [1, NaN], 'CalloutTextColor:q5:qp', [Brush.$, null], 'CollisionChannel:pb:qq', [2, null], 'ContentMemberPath:pe:qr', [2, null], 'IsAutoCalloutBehaviorEnabled:n8:qs', [0, false], 'IsCalloutOffsettingEnabled:n9:qt', [0, true], 'IsCustomCalloutStyleEnabled:oa:qu', [0, false], 'KeyMemberPath:pk:qv', [2, null], 'LabelMemberPath:pn:qw', [2, null], 'TargetSeries:nk:qx', [Series.$, null], 'TextStyle:pq:qy', [2, null], 'UseValueForAutoCalloutLabels:ob:qz', [0, true], 'XMemberPath:pu:q0', [2, null], 'YMemberPath:px:q1', [2, null]]);
/**
 * @hidden
 */
class CalloutLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b7 = null;
        this.b6 = null;
        this.b8 = NaN;
        this.b2 = null;
        this.b1 = a;
        this.b7 = new List$1(CalloutView.$, 0);
    }
    ap() {
        super.ap();
        this.b6 = ((() => {
            let $ret = new HashPool$2(CalloutAnnotationWrapper.$, CalloutView.$);
            $ret.create = runOn(this, this.b3);
            $ret.activate = runOn(this, this.ca);
            $ret.disactivate = runOn(this, this.cc);
            $ret.destroy = runOn(this, this.cb);
            return $ret;
        })());
    }
    b3() {
        let a = new CalloutView(this);
        this.b7.add(a);
        return a;
    }
    ca(a) {
        a.w = 0;
    }
    cc(a) {
        a.w = 1;
    }
    cb(a) {
        this.b7.remove(a);
    }
    ck(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        a.ac(this.b5());
        if (a.d && !b) {
            for (let c = 0; c < this.b7.count; c++) {
                let d = this.b7._inner[c];
                if (d.w == 0) {
                    d.h(a);
                }
            }
        }
    }
    b5() {
        if (this.b1.nm != null) {
            return this.b1.nm;
        }
        return this.e.bs.getFontInfo();
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b7.count; b++) {
            let c = this.b7._inner[b];
            if (c.w != 0) {
                continue;
            }
            c.g(this.b1, this.b5(), a);
        }
    }
    cm(a) {
        this.h.ac(this.b5());
        this.b8 = this.b9();
        return new Size(1, this.h.f(a.ak), this.b8);
    }
    b9() {
        let a = this.b5();
        if (isNaN_(this.b8)) {
            let b = FontUtil.getCurrentFontHeight(this.e.bs.b1.i.ae, a);
            this.b8 = b;
        }
        return this.b8;
    }
    cl(a, b) {
        if (this.b2 == null) {
            this.b2 = new CalloutView(this);
        }
        this.b2.f = a;
        this.b2.v = b;
        let c = this.b2.s();
        this.b2.f = null;
        return c;
    }
    b4() {
        return new DOMExecutionContext(this.e.bs.b1.i.ae);
    }
    ce(a, b, c) {
        a.d = b;
        a.e = c;
    }
    cf(a, b, c) {
        a.i(this.e, b, c);
    }
    cg(a) {
        if (a != null) {
            return this.ck(a.le);
        }
        return this.e.le;
    }
    cj() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    ci() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 255, 255, 255);
            return $ret;
        })());
    }
    ch(a) {
        if (a != null) {
            return this.ck(a.lb);
        }
        return this.e.lb;
    }
    cd() {
        this.b8 = NaN;
    }
}
CalloutLayerView.$t = markType(CalloutLayerView, 'CalloutLayerView', AnnotationLayerView.$);
/**
 * @hidden
 */
class CalloutView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.w = 0;
        this.j = null;
        this.r = null;
        this.o = { $type: Point_$type, x: 0, y: 0 };
        this.q = null;
        this.u = new Thickness(0, 0);
        this.t = null;
        this.d = 0;
        this.e = 0;
        this.b = null;
        this.q = new Line();
        this.q.ab = false;
        this.q._stroke = ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 0, 0, 0);
            return $ret;
        })());
        this.q.ac = 2;
        this.j = new TextBlock();
        this.r = new Rectangle();
        this.r.ac = 0;
        this.a = a;
        this.w = 0;
    }
    h(a) {
        a.z();
        a.af(this.d, this.e);
        let b = new TranslateTransform();
        b.j = this.t.c;
        b.k = this.t.e;
        this.r.j = b;
        a.r(this.q);
        a.z();
        this.r.width = this.j.m + this.u.c + this.u.d;
        this.r.height = this.j.l + this.u.e + this.u.b;
        a.j(this.r.j);
        a.v(this.r);
        this.j.o = this.u.e;
        this.j.n = this.u.c;
        a.w(this.j);
        a.y();
        a.y();
    }
    get p() {
        return this.o;
    }
    set p(a) {
        if (this.o.x != a.x || this.o.y != a.y) {
            let b = this.s();
            let c = b.height;
            let d = b.width;
            this.o = a;
            let e = CalloutViewHelper.b(this.p, d, c, this.q);
            this.t = e;
        }
    }
    get n() {
        return this.j.am;
    }
    set n(a) {
        this.j.am = a;
    }
    get m() {
        return this.r._stroke;
    }
    set m(a) {
        this.r._stroke = a;
    }
    get l() {
        return this.q._stroke;
    }
    set l(a) {
        this.q._stroke = a;
    }
    get k() {
        return this.r._fill;
    }
    set k(a) {
        this.r._fill = a;
    }
    get c() {
        return this.r.ac;
    }
    set c(a) {
        this.r.ac = a;
    }
    get v() {
        return this.u;
    }
    set v(a) {
        this.u = a;
    }
    get f() {
        return this.j.ak;
    }
    set f(a) {
        if (a == null) {
            this.j.ak = "";
        }
        else {
            this.j.ak = a.toString();
        }
        let b = this.s();
        let c = b.height;
        let d = b.width;
        let e = CalloutViewHelper.b(this.p, d, c, this.q);
        this.t = e;
    }
    s() {
        let a = this.a.cm(this.j);
        this.j.m = a.width;
        this.j.l = a.height;
        return new Size(1, a.width + this.u.c + this.u.d, a.height + this.u.e + this.u.b);
    }
    i(a, b, c) {
        if (this.b == null) {
            this.b = new DataContext();
        }
        this.b.series = a;
        this.b.item = c;
        if (b.c != null) {
            b.c.u = this.b;
        }
    }
    g(a, b, c) {
        a.a2.exportCalloutData(this.d, this.e, this.t.c, this.t.e, c, this.r, this.j, b, this.q, "callout", ["Main", "Callout"]);
    }
}
CalloutView.$t = markType(CalloutView, 'CalloutView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnnotationLayerProxy extends Base {
    matchesType(a) {
        if (!a.cj) {
            return false;
        }
        return true;
    }
    setContentMemberPath(a, b) {
        a.pe = b;
    }
    setHorizontalLineVisibility(a, b) {
        a.pu = b;
    }
    setIsAxisAnnotationEnabled(a, b) {
        a.nk = b;
    }
    setLabelMemberPath(a, b) {
        a.pn = b;
    }
    setUseInterpolation(a, b) {
        a.nm = b;
    }
    setVerticalLineVisibility(a, b) {
        a.pv = b;
    }
    setXMemberPath(a, b) {
        a.pu = b;
    }
    setYMemberPath(a, b) {
        a.px = b;
    }
    setTargetSeries(a, b) {
        a.nk = b;
    }
    setCollisionChannel(a, b) {
        a.pb = b;
    }
    isCalloutLayer(a) {
        if (typeCast(CalloutLayer.$, a) !== null) {
            return true;
        }
        return false;
    }
    addCalloutStyleUpdating(a, b) {
        let c = a;
        c.calloutStyleUpdating = delegateCombine(c.calloutStyleUpdating, b);
    }
    removeCalloutStyleUpdating(a, b) {
        let c = a;
        c.calloutStyleUpdating = delegateRemove(c.calloutStyleUpdating, b);
    }
    setCalloutStyleUpdatingEventEnabled(a, b) {
        a.oa = b;
    }
}
AnnotationLayerProxy.$t = markType(AnnotationLayerProxy, 'AnnotationLayerProxy', Base.$, [IAnnotationLayerProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAnnotationLayerProxyModule = class IgxAnnotationLayerProxyModule {
    constructor() {
        TypeRegistrar.register('AnnotationLayerProxy', AnnotationLayerProxy.$type);
    }
};
IgxAnnotationLayerProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxAnnotationLayerProxyModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAnnotationLayerProxyDynamicModule = class IgxAnnotationLayerProxyDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('AnnotationLayerProxy', AnnotationLayerProxy);
        TypeRegistrar.register('AnnotationLayerProxy', AnnotationLayerProxy.$type);
    }
};
IgxAnnotationLayerProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxAnnotationLayerProxyModule
        ],
        imports: [CommonModule, IgxAnnotationLayerProxyModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxAnnotationLayerProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions on the crossing axis at which the category tooltip can be displayed.
 */
var CategoryTooltipLayerPosition;
(function (CategoryTooltipLayerPosition) {
    /**
     * A position is selected automatically
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["Auto"] = 0] = "Auto";
    /**
     * Displays at the outside start of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideStart"] = 1] = "OutsideStart";
    /**
     * Displays at the inside start of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideStart"] = 2] = "InsideStart";
    /**
     * Displays at the inside end of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["InsideEnd"] = 3] = "InsideEnd";
    /**
     * Displays at the outside end of the axis.
     */
    CategoryTooltipLayerPosition[CategoryTooltipLayerPosition["OutsideEnd"] = 4] = "OutsideEnd";
})(CategoryTooltipLayerPosition || (CategoryTooltipLayerPosition = {}));
/**
 * @hidden
 */
let CategoryTooltipLayerPosition_$type = markEnum('CategoryTooltipLayerPosition', 'Auto,0|OutsideStart,1|InsideStart,2|InsideEnd,3|OutsideEnd,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryToolTipLayerFrame extends Frame {
    constructor() {
        super();
        this.f = 0;
        this.k = 0;
        this.h = 0;
        this.g = 0;
        this.j = 0;
        this.i = 0;
        this.k = NaN;
        this.l = NaN;
        this.g = NaN;
        this.h = NaN;
        this.j = NaN;
        this.i = NaN;
    }
    get l() {
        return this.f;
    }
    set l(a) {
        this.f = a;
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        if (isNaN_(d.k)) {
            this.k = e.k;
        }
        else {
            this.k = d.k + (e.k - d.k) * a;
        }
        if (isNaN_(d.l)) {
            this.l = e.l;
        }
        else {
            this.l = d.l + (e.l - d.l) * a;
        }
        if (isNaN_(d.g)) {
            this.g = e.g;
        }
        else {
            this.g = d.g + (e.g - d.g) * a;
        }
        if (isNaN_(d.h)) {
            this.h = e.h;
        }
        else {
            this.h = d.h + (e.h - d.h) * a;
        }
        if (isNaN_(d.j)) {
            this.j = e.j;
        }
        else {
            this.j = d.j + (e.j - d.j) * a;
        }
        if (isNaN_(d.i)) {
            this.i = e.k;
        }
        else {
            this.i = d.i + (e.i - d.i) * a;
        }
    }
}
CategoryToolTipLayerFrame.$t = markType(CategoryToolTipLayerFrame, 'CategoryToolTipLayerFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTooltipSeriesInfo extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.a = null;
        this.b = null;
    }
}
CategoryTooltipSeriesInfo.$t = markType(CategoryTooltipSeriesInfo, 'CategoryTooltipSeriesInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions to anchor the pointer to the PointerTooltip.
 */
var PointerTooltipPointerLocation;
(function (PointerTooltipPointerLocation) {
    /**
     * The anchor is decided automatically.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["Auto"] = 0] = "Auto";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopLeft"] = 1] = "TopLeft";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopMiddle"] = 2] = "TopMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["TopRight"] = 3] = "TopRight";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightTop"] = 4] = "RightTop";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightMiddle"] = 5] = "RightMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["RightBottom"] = 6] = "RightBottom";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomRight"] = 7] = "BottomRight";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomMiddle"] = 8] = "BottomMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["BottomLeft"] = 9] = "BottomLeft";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftBottom"] = 10] = "LeftBottom";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftMiddle"] = 11] = "LeftMiddle";
    /**
     * The anchor is top left of the content.
     */
    PointerTooltipPointerLocation[PointerTooltipPointerLocation["LeftTop"] = 12] = "LeftTop";
})(PointerTooltipPointerLocation || (PointerTooltipPointerLocation = {}));
/**
 * @hidden
 */
let PointerTooltipPointerLocation_$type = markEnum('PointerTooltipPointerLocation', 'Auto,0|TopLeft,1|TopMiddle,2|TopRight,3|RightTop,4|RightMiddle,5|RightBottom,6|BottomRight,7|BottomMiddle,8|BottomLeft,9|LeftBottom,10|LeftMiddle,11|LeftTop,12');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PointerTooltip extends ContentControl {
    constructor() {
        super();
        this.aq = null;
        this.ai = null;
        this.am = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.bw = null;
        this.cq = null;
        this.cr = null;
        this.au = false;
        this.cf = { $type: Point_$type, x: NaN, y: NaN };
        this.ak = 0;
        this.aw = 0;
        this.av = 0;
        this.ao = null;
        this.as = false;
        this.ap = null;
        DVContainer.instance.registerIfLoaded("VisualDataFactoryManager");
        this.ab = PointerTooltip.$;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.br(a, b.propertyName, b.oldValue, b.newValue));
        this.am = new PointerTooltipView(this);
    }
    get ar() {
        if (this.aq == null) {
            this.aq = new SRProvider(this.am.j);
        }
        return this.aq;
    }
    get aj() {
        if (this.ai == null) {
            this.ai = DVContainer.instance.createInstance(ISeriesVisualDataManager_$type, () => this.ar.q);
        }
        return this.ai;
    }
    bt(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    br(a, b, c, d) {
        switch (b) {
            case PointerTooltip.$$p[15]:
                this.bq();
                break;
            case PointerTooltip.$$p[16]:
                this.bq();
                break;
        }
    }
    bn() {
        if (this.am.d(this.content)) {
            this.bq();
        }
    }
    bq() {
        this.au = true;
    }
    at(a, b) {
        if (Math.abs(a - b) < 1E-05) {
            return true;
        }
        return false;
    }
    cs(a) {
        this.au = false;
        let b = 0;
        let c = 0;
        let d = this.am.x(a);
        b = d.width;
        c = d.height;
        if (this.ak == this.al && this.at(this.cf.x, this.cn.x) && this.at(this.cf.y, this.cn.y)) {
            this.a0 = b;
            this.az = c;
            if (this.ct == 0) {
                b += this.aw;
                c += this.av;
                this.ay = this.a0 + this.aw;
                this.ax = this.az + this.av;
            }
            return new Size(1, b, c);
        }
        let e = { $type: Point_$type, x: 0, y: 0 };
        let f = { $type: Point_$type, x: b * 0.5, y: 0 };
        let g = { $type: Point_$type, x: b, y: 0 };
        let h = { $type: Point_$type, x: b, y: c };
        let i = { $type: Point_$type, x: b * 0.5, y: c };
        let j = { $type: Point_$type, x: 0, y: c };
        let k = { $type: Point_$type, x: 0, y: c * 0.5 };
        let l = { $type: Point_$type, x: b, y: c * 0.5 };
        let m = b;
        let n = c;
        let o = b;
        let p = c;
        let q = { $type: Point_$type, x: 0, y: 0 };
        let r = { $type: Point_$type, x: 0, y: 0 };
        let s = { $type: Point_$type, x: 0, y: 0 };
        let t = { $type: Point_$type, x: 0, y: 0 };
        let u = this.a1;
        let v = this.a2;
        let w = this.al;
        let x = this.cn;
        let y = 0;
        let z = 0;
        let aa = Math.pow(e.x - x.x, 2) + Math.pow(e.y - x.y, 2);
        let ab = Math.pow(f.x - x.x, 2) + Math.pow(f.y - x.y, 2);
        let ac = Math.pow(g.x - x.x, 2) + Math.pow(g.y - x.y, 2);
        let ad = Math.pow(l.x - x.x, 2) + Math.pow(l.y - x.y, 2);
        let ae = Math.pow(h.x - x.x, 2) + Math.pow(h.y - x.y, 2);
        let af = Math.pow(i.x - x.x, 2) + Math.pow(i.y - x.y, 2);
        let ag = Math.pow(j.x - x.x, 2) + Math.pow(j.y - x.y, 2);
        let ah = Math.pow(k.x - x.x, 2) + Math.pow(k.y - x.y, 2);
        let ai = 1.7976931348623157E+308;
        ai = Math.min(ai, aa);
        ai = Math.min(ai, ab);
        ai = Math.min(ai, ac);
        ai = Math.min(ai, ad);
        ai = Math.min(ai, ae);
        ai = Math.min(ai, af);
        ai = Math.min(ai, ag);
        ai = Math.min(ai, ah);
        if (w == 0) {
            if (ai == aa) {
                w = 12;
                if (x.x >= e.x) {
                    w = 1;
                }
            }
            if (ai == ah) {
                w = 11;
            }
            if (ai == ag) {
                w = 10;
                if (x.x >= j.x) {
                    w = 9;
                }
            }
            if (ai == ac) {
                w = 4;
                if (x.x <= g.x) {
                    w = 3;
                }
            }
            if (ai == ad) {
                w = 5;
            }
            if (ai == ae) {
                w = 6;
                if (x.x <= h.x) {
                    w = 7;
                }
            }
            if (ai == ab) {
                w = 2;
            }
            if (ai == af) {
                w = 8;
            }
        }
        let aj = DeviceUtils.g(3);
        switch (w) {
            case 1:
                q = { $type: Point_$type, x: e.x + u, y: e.y };
                r = { $type: Point_$type, x: e.x + u + v, y: e.y };
                s = { $type: Point_$type, x: e.x + u, y: e.y + aj };
                t = { $type: Point_$type, x: e.x + u + v, y: e.y + aj };
                break;
            case 2:
                q = { $type: Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y };
                r = { $type: Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y };
                s = { $type: Point_$type, x: ((e.x + g.x) / 2) - (v / 2), y: e.y + aj };
                t = { $type: Point_$type, x: ((e.x + g.x) / 2) + (v / 2), y: e.y + aj };
                break;
            case 3:
                q = { $type: Point_$type, x: g.x - u, y: e.y };
                r = { $type: Point_$type, x: (g.x - u) - v, y: e.y };
                s = { $type: Point_$type, x: g.x - u, y: e.y + aj };
                t = { $type: Point_$type, x: (g.x - u) - v, y: e.y + aj };
                break;
            case 4:
                q = { $type: Point_$type, x: g.x, y: g.y + u };
                r = { $type: Point_$type, x: g.x, y: g.y + u + v };
                s = { $type: Point_$type, x: g.x - aj, y: g.y + u };
                t = { $type: Point_$type, x: g.x - aj, y: g.y + u + v };
                break;
            case 5:
                q = { $type: Point_$type, x: g.x, y: ((g.y + h.y) / 2) - (v / 2) };
                r = { $type: Point_$type, x: g.x, y: ((g.y + h.y) / 2) + (v / 2) };
                s = { $type: Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) - (v / 2) };
                t = { $type: Point_$type, x: g.x - aj, y: ((g.y + h.y) / 2) + (v / 2) };
                break;
            case 6:
                q = { $type: Point_$type, x: h.x, y: h.y - u };
                r = { $type: Point_$type, x: h.x, y: h.y - u - v };
                s = { $type: Point_$type, x: h.x - aj, y: h.y - u };
                t = { $type: Point_$type, x: h.x - aj, y: h.y - u - v };
                break;
            case 7:
                q = { $type: Point_$type, x: h.x - u, y: h.y };
                r = { $type: Point_$type, x: (h.x - u) - v, y: h.y };
                s = { $type: Point_$type, x: h.x - u, y: h.y - aj };
                t = { $type: Point_$type, x: (h.x - u) - v, y: h.y - aj };
                break;
            case 8:
                q = { $type: Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y };
                r = { $type: Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y };
                s = { $type: Point_$type, x: ((j.x + h.x) / 2) - (v / 2), y: h.y - aj };
                t = { $type: Point_$type, x: ((j.x + h.x) / 2) + (v / 2), y: h.y - aj };
                break;
            case 9:
                q = { $type: Point_$type, x: j.x + u, y: j.y };
                r = { $type: Point_$type, x: j.x + u + v, y: j.y };
                s = { $type: Point_$type, x: j.x + u, y: j.y - aj };
                t = { $type: Point_$type, x: j.x + u + v, y: j.y - aj };
                break;
            case 10:
                q = { $type: Point_$type, x: e.x, y: j.y - u };
                r = { $type: Point_$type, x: e.x, y: (j.y - u) - v };
                s = { $type: Point_$type, x: e.x + aj, y: j.y - u };
                t = { $type: Point_$type, x: e.x + aj, y: (j.y - u) - v };
                break;
            case 11:
                q = { $type: Point_$type, x: e.x, y: ((e.y + j.y) / 2) - (v / 2) };
                r = { $type: Point_$type, x: e.x, y: ((e.y + j.y) / 2) + (v / 2) };
                s = { $type: Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) - (v / 2) };
                t = { $type: Point_$type, x: e.x + aj, y: ((e.y + j.y) / 2) + (v / 2) };
                break;
            case 12:
                q = { $type: Point_$type, x: e.x, y: e.y + u };
                r = { $type: Point_$type, x: e.x, y: e.y + u + v };
                s = { $type: Point_$type, x: e.x + aj, y: e.y + u };
                t = { $type: Point_$type, x: e.x + aj, y: e.y + u + v };
                break;
        }
        let ak = { $type: Point_$type, x: x.x, y: x.y };
        if (ak.y < e.y) {
            let al = e.y - ak.y;
            ak = { $type: Point_$type, x: ak.x, y: 0 };
            p += al;
            e = { $type: Point_$type, x: e.x, y: e.y + al };
            g = { $type: Point_$type, x: g.x, y: g.y + al };
            j = { $type: Point_$type, x: j.x, y: j.y + al };
            h = { $type: Point_$type, x: h.x, y: h.y + al };
            q = { $type: Point_$type, x: q.x, y: q.y + al };
            r = { $type: Point_$type, x: r.x, y: r.y + al };
            s = { $type: Point_$type, x: s.x, y: s.y + al };
            t = { $type: Point_$type, x: t.x, y: t.y + al };
        }
        else {
            p = Math.max(ak.y, n);
        }
        if (ak.x < e.x) {
            let am = e.x - ak.x;
            ak = { $type: Point_$type, x: 0, y: ak.y };
            o += am;
            e = { $type: Point_$type, x: e.x + am, y: e.y };
            g = { $type: Point_$type, x: g.x + am, y: g.y };
            j = { $type: Point_$type, x: j.x + am, y: j.y };
            h = { $type: Point_$type, x: h.x + am, y: h.y };
            q = { $type: Point_$type, x: q.x + am, y: q.y };
            r = { $type: Point_$type, x: r.x + am, y: r.y };
            s = { $type: Point_$type, x: s.x + am, y: s.y };
            t = { $type: Point_$type, x: t.x + am, y: t.y };
        }
        else {
            o = Math.max(ak.x, m);
        }
        y = o - m;
        z = p - n;
        this.aw = y;
        this.av = z;
        this.ak = this.al;
        this.cf = this.cn;
        this.cm = ak;
        this.ck = q;
        this.cl = r;
        this.a0 = m;
        this.az = n;
        this.ay = o;
        this.ax = p;
        this.ci = e;
        this.cj = g;
        this.ch = h;
        this.cg = j;
        let an = new PointCollection(0);
        an.add(t);
        an.add(this.cl);
        an.add(this.cm);
        an.add(this.ck);
        an.add(s);
        this.cp = an;
        if (this.cq != null) {
            this.cq.ak = an;
        }
        let ao = new PointCollection(0);
        ao.add(this.cl);
        ao.add(this.cm);
        ao.add(this.ck);
        this.co = ao;
        if (this.cr != null) {
            this.cr.ak = ao;
        }
        if (this.ct == 1) {
            return new Size(1, b, c);
        }
        return new Size(1, o, p);
    }
    bo() {
        this.bv();
        this.am.r();
    }
    bp() {
        this._visibility = 1;
        this.am.s();
    }
    bu(a, b) {
        if (this.au) {
            this.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        }
        this.am.v(a, b);
    }
    bs(a) {
        this.am.u(a);
    }
    bm() {
        if (!this.as) {
            if (this.ao != null && this.am.l != null) {
                this.as = true;
                this.ao.aq(this.am.l, "pointerTooltip" + Base.getHashCodeStatic(this));
            }
        }
    }
    bv() {
        if (this.as) {
            if (this.ao != null && this.am.l != null) {
                this.as = false;
                this.ao.bc(this.am.l, "pointerTooltip" + Base.getHashCodeStatic(this));
            }
            this.ao = null;
        }
    }
    a3() {
        if (this._visibility == 1) {
            return null;
        }
        return this.am.q();
    }
}
PointerTooltip.$t = markType(PointerTooltip, 'PointerTooltip', ContentControl.$, [INotifyPropertyChanged_$type]);
PointerTooltip.$$p = markDep(DependencyProperty, PropertyMetadata, PointerTooltip, 'bt', ['ActualBoxBottomLeftPosition:cg:bx', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxBottomRightPosition:ch:by', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxFullHeight:ax:bz', [1, 0], 'ActualBoxFullWidth:ay:b0', [1, 0], 'ActualBoxHeight:az:b1', [1, 0], 'ActualBoxTopLeftPosition:ci:b2', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxTopRightPosition:cj:b3', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualBoxWidth:a0:b4', [1, 0], 'ActualPointerFirstPosition:ck:b5', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualPointerSecondPosition:cl:b6', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'ActualPointerStartPosition:cm:b7', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'PointerInset:a1:b8', [1, DeviceUtils.g(7.5)], 'PointerLocation:al:b9', [PointerTooltipPointerLocation_$type, enumGetBox(PointerTooltipPointerLocation_$type, 0)], 'PointerOutlinePoints:co:ca', [PointCollection.$, null], 'PointerPoints:cp:cb', [PointCollection.$, null], 'PointerPosition:cn:cc', [Point_$type, { $type: Point_$type, x: 0, y: 0 }], 'PointerVisibility:ct:cd', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'PointerWidth:a2:ce', [1, DeviceUtils.g(5)]]);
/**
 * @hidden
 */
class PointerTooltipView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.n = null;
        this.p = null;
        this.o = null;
        this.l = null;
        this.k = null;
        this.b = null;
        this.m = null;
        this.w = null;
        this.c = false;
        this.i = 0;
        this.h = 0;
        this.g = -1;
        this.e = -1;
        this.f = 1;
        this.j = null;
        this.a = a;
        this.a.cq = new Polygon();
        this.a.cr = new Polyline();
        this.l = null;
        this.t();
    }
    t() {
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != this.f) {
            this.f = window.devicePixelRatio;
        }
    }
    x(a) {
        let b = this.a.content;
        b = b.clone();
        let c = new Size(1, 0, 0);
        if (this.n == null) {
            this.n = this.j.createElement("div");
            this.n.addClass("ui-chart-pointer-tooltip-container");
            this.n.setStyleProperty("position", "absolute");
            this.n.setStyleProperty("visibility", "hidden");
            this.n.setStyleProperty("top", "0px");
            this.n.setStyleProperty("left", "0px");
            this.p = this.j.createElement("div");
            this.p.setStyleProperty("position", "relative");
            this.o = this.j.createElement("div");
            this.o.addClass("ui-chart-pointer-tooltip-content-container");
            this.o.setStyleProperty("position", "absolute");
            this.o.setStyleProperty("top", "0px");
            this.o.setStyleProperty("left", "0px");
            this.n.append(this.p);
            this.p.append(this.o);
        }
        this.n.remove();
        this.j.appendToBody(this.n);
        this.o.append(b);
        c = new Size(1, this.o.outerWidthWithMargin(), this.o.outerHeightWithMargin());
        this.n.remove();
        b.remove();
        return c;
    }
    v(a, b) {
        if (this.l == null) {
            this.l = this.j.createElement("div");
            this.l.addClass("ui-chart-pointer-tooltip-container");
            this.l.setStyleProperty("position", "absolute");
            this.l.setStyleProperty("top", "0px");
            this.l.setStyleProperty("left", "0px");
            let c = this.j.createElement("div");
            c.setStyleProperty("position", "relative");
            this.k = this.j.createElement("canvas");
            this.k.setStyleProperty("position", "absolute");
            this.k.setStyleProperty("top", "0px");
            this.k.setStyleProperty("left", "0px");
            this.m = this.j.createElement("div");
            this.m.addClass("ui-chart-pointer-tooltip-content-container");
            this.m.setStyleProperty("position", "absolute");
            this.m.setStyleProperty("top", "0px");
            this.m.setStyleProperty("left", "0px");
            c.append(this.k);
            c.append(this.m);
            this.l.append(c);
            this.b = new RenderingContext(new CanvasViewRenderer(), this.j.get2DCanvasContext(this.k));
            this.l.hide();
            this.j.appendToBody(this.l);
        }
        this.a.bm();
        if (this.a._visibility == 1 && this.c) {
            this.l.hide();
            this.c = false;
            return;
        }
        let d = null;
        if (this.a.content != null) {
            d = this.a.content;
            d.remove();
        }
        this.m.removeChildren();
        if (d != null) {
            let cont_ = this.m;
            let xPos_ = this.a.ci.x.toString() + "px";
            let yPos_ = this.a.ci.y.toString() + "px";
            cont_.setRawStyleProperty("left", xPos_);
            cont_.setRawStyleProperty("top", yPos_);
            this.m.append(d);
        }
        let e = this.a.ap;
        let f = 1;
        this.t();
        if (e != null) {
            f = !isNaN_(e.b) ? e.b : 1;
        }
        let g = truncate(Math.ceil(this.a.ay + (f * 2)));
        let h = truncate(Math.ceil(this.a.ax + (f * 2)));
        if (g != this.i || h != this.h) {
            this.k.setStyleProperty("width", g.toString() + "px");
            this.k.setStyleProperty("height", h.toString() + "px");
            this.k.setAttribute("width", (g * this.f).toString());
            this.k.setAttribute("height", (h * this.f).toString());
            this.i = g;
            this.h = h;
        }
        if (this.b.d && this.f != 1) {
            this.b.z();
            this.b.aa(this.f, this.f);
        }
        this.b.k(0, 0, this.i, this.h);
        let i = new Rectangle();
        i.width = this.a.a0;
        i.height = this.a.az;
        i.n = this.a.ci.x;
        i.o = this.a.ci.y;
        if (e != null) {
            i._fill = e.c != null ? e.c : ((() => {
                let $ret = new Brush();
                $ret.fill = "white";
                return $ret;
            })());
            i._stroke = e.d != null ? e.d : ((() => {
                let $ret = new Brush();
                $ret.fill = "black";
                return $ret;
            })());
            i.ac = !isNaN_(e.b) ? e.b : 1;
            i.am = !isNaN_(e.a) ? e.a : 0;
            i.an = !isNaN_(e.a) ? e.a : 0;
        }
        else {
            i._fill = ((() => {
                let $ret = new Brush();
                $ret.fill = "white";
                return $ret;
            })());
            i._stroke = ((() => {
                let $ret = new Brush();
                $ret.fill = "black";
                return $ret;
            })());
            i.ac = 1;
        }
        this.w = i;
        let j = this.a.cq;
        let k = this.a.cr;
        j._fill = i._fill;
        k._stroke = i._stroke;
        this.b.v(i);
        this.b.t(j);
        this.b.u(k);
        let x_ = a + "px";
        let y_ = b + "px";
        let container_ = this.l;
        container_.setRawStyleProperty("left", x_);
        container_.setRawStyleProperty("top", y_);
        if (this.a._visibility == 0 && !this.c) {
            this.l.show();
            this.c = true;
        }
        if (this.b.d && this.f != 1) {
            this.b.y();
        }
    }
    q() {
        return this.a.aj.exportPointerTooltipData(this.a.cq, this.a.cr, this.w, new Rect(0, 0, 0, this.a.ay, this.a.ax));
    }
    d(a) {
        let b = this.g;
        let c = this.e;
        let d = this.x(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        if (d.width != b || d.height != c) {
            return true;
        }
        return false;
    }
    r() {
        this.j = null;
        this.l.hide();
        this.l.remove();
        this.l = null;
        this.n = null;
        this.p = null;
        this.o = null;
        this.l = null;
        this.k = null;
        this.m = null;
    }
    s() {
        this.l.hide();
    }
    u(a) {
        this.j = a;
    }
}
PointerTooltipView.$t = markType(PointerTooltipView, 'PointerTooltipView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryToolTipLayer extends AnnotationLayer {
    constructor() {
        super();
        let a = new CategoryToolTipLayerFrame();
        let b = new CategoryToolTipLayerFrame();
        let c = new CategoryToolTipLayerFrame();
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = CategoryToolTipLayer.$;
    }
    bf() {
        return new CategoryToolTipLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.ng = a;
    }
    get_cn() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case CategoryToolTipLayer.$$p[0]:
                this.jl(true);
                break;
            case CategoryToolTipLayer.$$p[2]:
                this.jl(true);
                break;
            case CategoryToolTipLayer.$$p[1]:
                this.jl(true);
                break;
            case "SeriesViewer":
                this.ng.cc();
                break;
        }
    }
    mu(a, b) {
        if (this.ne == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mv(a, b) {
        if (!this.aq.c) {
            this.jl(b);
        }
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        let d = this.ni;
        c.l = NaN;
        c.k = NaN;
        c.g = NaN;
        c.h = NaN;
        c.k = NaN;
        c.l = NaN;
        if (isNaN_(this.nb.x) && isNaN_(this.nb.y)) {
            this.ng.ca(this.ng.b7());
            return;
        }
        if (this.ne != null) {
            let e = this.ne;
            if (e == null || !e.b4 || e.b2) {
                return;
            }
            if (!e.cg()) {
                return;
            }
            let f = e;
            let g = this.nh(f.cz, d);
            this.nn(g, c, d);
        }
        else {
            if (typeCast(XamDataChart.$, this.bs) !== null) {
                let h = this.bs;
                let i = true;
                let j = false;
                let k = new List$1(Series.$, 0);
                for (let l of fromEnum(h.axes)) {
                    if (l.b4 && !l.b2) {
                        if (!l.cg()) {
                            continue;
                        }
                        if (i) {
                            i = false;
                            j = l.ch;
                        }
                        else {
                            if (l.ch != j) {
                                continue;
                            }
                        }
                        for (let m of fromEnum(l.cz)) {
                            k.add(m);
                        }
                    }
                }
                let n = this.nh(k, d);
                this.nn(n, c, d);
            }
        }
    }
    nh(a, b) {
        let c = 1.7976931348623157E+308;
        let d = -1.7976931348623157E+308;
        let e = new List$1(DataContext.$, 0);
        let f = new List$1(Base.$, 0);
        let g = false;
        let h = true;
        for (let i = 0; i < a.count; i++) {
            let j = a.item(i);
            if (!j.cr && !j.cl) {
                continue;
            }
            if (j.isStacked) {
                continue;
            }
            let k = j;
            if (!k.categoryAxis.cg()) {
                continue;
            }
            if (h) {
                g = j.isVertical;
            }
            else {
                if (g != j.isVertical) {
                    continue;
                }
            }
            let l = this.mq(j);
            if (!l.c) {
                continue;
            }
            let m = j.lv(l.d, b, false);
            if (g) {
                if (!isNaN_(m.y)) {
                    c = Math.min(c, m.y);
                    d = Math.max(d, m.y);
                }
            }
            else {
                if (!isNaN_(m.x)) {
                    c = Math.min(c, m.x);
                    d = Math.max(d, m.x);
                }
            }
            let n = this.nj(j);
            if (n == null) {
                continue;
            }
            let o = null;
            let p = j.fp(this.nb);
            if (j.co && p != null) {
                o = j.as(p);
            }
            else {
                o = new DataContext();
                o.item = p;
                o.series = j;
            }
            e.add(o);
            f.add1(n);
        }
        let q = 0;
        let r = 0;
        if (g) {
            r = (c + d) / 2;
            q = this.l8.right;
            if (this.nf == 2 || this.nf == 1) {
                q = this.l8.left;
            }
            if (r < 0 || r > this.l8.bottom) {
                r = NaN;
            }
        }
        else {
            q = (c + d) / 2;
            r = this.l8.top;
            if (this.nf == 2 || this.nf == 1) {
                r = this.l8.bottom;
            }
            if (q < 0 || q > this.l8.right) {
                q = NaN;
            }
        }
        let s = new CategoryTooltipSeriesInfo();
        s.c = { $type: Point_$type, x: q, y: r };
        s.a = e;
        s.b = f;
        return s;
    }
    ij() {
        this.nb = { $type: Point_$type, x: NaN, y: NaN };
        this.bi.am();
    }
    nn(a, b, c) {
        let d = a.c;
        let e = a.a;
        let f = a.b;
        d = this.ng.cd(d);
        let g = 0;
        let h = this.bi.br;
        let i = this.ng.b7();
        this.ng.b9();
        let j = false;
        if (e.count == 0) {
            this.bi.am();
            return;
        }
        let k = false;
        for (let l = 0; l < e.count; l++) {
            let m = e._inner[l].series;
            j = m.isVertical;
            let n = e._inner[l];
            let o = f._inner[l];
            if (this.ng.b4(m, o, n)) {
                k = true;
            }
            g++;
        }
        if (!k) {
            this.ng.ca(i);
            return;
        }
        let p = this.ng.ce(i);
        let q = 0;
        let r = 0;
        let s = 0;
        let t = 0;
        let u = false;
        let v = false;
        let w = this.nf;
        if (w == 2 || w == 3) {
            v = true;
        }
        if (w == 2 || w == 1) {
            u = true;
        }
        let x = this.ng.cf();
        if (j) {
            if (!u && !v && d.x + (p.width + DeviceUtils.g(10)) > x.width) {
                v = true;
            }
            if (u && !v && d.x - (p.width + DeviceUtils.g(10)) < 0) {
                v = true;
            }
        }
        else {
            if (!u && !v && d.y - (p.height + 10) < 0) {
                v = true;
            }
            if (u && !v && d.y + (p.height + 10) > x.height) {
                v = true;
            }
        }
        let y = DeviceUtils.g(10);
        let z = DeviceUtils.g(5);
        if (!u) {
            if (!j) {
                z = p.height + y;
            }
            if (v) {
                if (j) {
                    z = z + p.width + y;
                }
                else {
                    z = 0;
                }
            }
        }
        else {
            if (j) {
                z = p.width + y;
                if (v) {
                    z = 0;
                }
            }
            else {
                z = DeviceUtils.g(5);
                if (v) {
                    z = z + p.height + y;
                }
            }
        }
        if (j) {
            r = 0 - (y + DeviceUtils.g(5));
            if (u) {
                r = (r * -1) + p.width;
            }
            q = p.height / 2;
            t = d.y - p.height / 2;
            s = d.x - z;
        }
        else {
            q = p.height + DeviceUtils.g(10) + DeviceUtils.g(5);
            if (u) {
                q = 0 - (y + DeviceUtils.g(5));
            }
            r = p.width / 2;
            s = d.x - p.width / 2;
            t = d.y - z;
        }
        if (j) {
            if (t < 0) {
                q -= 0 - t;
                t = 0;
            }
            if (t + p.height > x.height) {
                q += (t + p.height) - x.height;
                t = x.height - p.height;
            }
        }
        else {
            if (s < 0) {
                r -= 0 - s;
                s = 0;
            }
            if (s + p.width > x.width) {
                r += (s + p.width) - x.width;
                s = x.width - p.width;
            }
        }
        b.k = s;
        b.l = t;
        b.g = r;
        b.h = q;
        b.j = p.width;
        b.i = p.height;
    }
    nj(a) {
        return a.toolTip;
    }
    m0(a, b) {
        super.m0(a, b);
        let c = a;
        let d = b.br.left;
        let e = b.br.right;
        let f = b.br.top;
        let g = b.br.bottom;
        let h = this.ng.b7();
        if (isNaN_(c.k) || isNaN_(c.l) || isNaN_(c.g) || isNaN_(c.h)) {
            this.ng.ca(h);
            return;
        }
        let i = c.k;
        let j = c.l;
        let k = c.g;
        let l = c.h;
        this.ng.cb(h, i, j, k, l);
    }
    c8() {
        return true;
    }
}
CategoryToolTipLayer.$t = markType(CategoryToolTipLayer, 'CategoryToolTipLayer', AnnotationLayer.$);
CategoryToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryToolTipLayer, 'raisePropertyChanged', ['TargetAxis:ne:no', [Axis.$, null], 'ToolTipPosition:nf:np', [CategoryTooltipLayerPosition_$type, enumGetBox(CategoryTooltipLayerPosition_$type, 0)], 'UseInterpolation:ni:nq', [0, false]]);
/**
 * @hidden
 */
class CategoryToolTipLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this._tooltips = null;
        this.b5 = null;
        this.b3 = false;
        this._htmlTest = null;
        this.b1 = a;
        this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
    }
    b7() {
        if (this.b2 == null) {
            this.b2 = new PointerTooltip();
            this.b2.bs(this.e.e4);
            this.b2.ao = this.e.bs.b1.j;
            this._tooltips = this.e.e4.createElement("div");
            this.b5 = this.e.e4.createElement("div");
            this.b2._visibility = 0;
        }
        return this.b2;
    }
    ap() {
        super.ap();
        if (this.b2 != null) {
            this.b2._visibility = 1;
        }
    }
    ag() {
        super.ag();
        if (this.b2 != null) {
            this.b2.bo();
            this.b2 = null;
        }
    }
    get htmlTest() {
        return this._htmlTest;
    }
    set htmlTest(a) {
        this._htmlTest = a;
    }
    b4(a, b, c) {
        if (a.fz == "default") {
            a.fz = a.bi.getDefaultTooltipTemplate();
        }
        let template_ = a.fz;
        let context_ = c;
        if (a.toolTip == null) {
            return false;
        }
        let tooltip_ = a.toolTip;
        if ((tooltip_.updateToolTip)) {
            tooltip_._inPointer = true;
            tooltip_.updateToolTip(context_, true);
            tooltip_.setStyleProperty('position', 'relative');
            tooltip_.setStyleProperty('left', '');
            tooltip_.setStyleProperty('top', '');
            tooltip_.remove();
        }
        this._tooltips.append(a.toolTip);
        return true;
    }
    ce(a) {
        let b = a;
        b.content = this._tooltips;
        let c = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        b.ct = 1;
        let d = b.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        b.ct = 0;
        return d;
    }
    cd(a) {
        let b = 0;
        let c = 0;
        if (this.e.bs != null) {
            let d = this.e.bs.nv();
            b += d.x;
            c += d.y;
        }
        return { $type: Point_$type, x: b + a.x, y: c + a.y };
    }
    cb(a, b, c, d, e) {
        let f = a;
        let g = f.content;
        f.cn = { $type: Point_$type, x: d, y: e };
        f._visibility = 0;
        f.n = b;
        f.o = c;
    }
    cf() {
        let a = (window.innerWidth);
        let b = (window.innerHeight);
        return new Size(1, a, b);
    }
    ca(a) {
        this._tooltips.removeChildren();
        this.b5.removeChildren();
        this.b2._visibility = 1;
    }
    b9() {
        if (this._tooltips != null) {
            this._tooltips.removeChildren();
        }
    }
    cc() {
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            return;
        }
        let c = null;
        if (this.e.bs != null) {
            c = this.e.bs.b1.i.i();
        }
        let d = 0;
        let e = 0;
        let f = this.e.bs;
        if (f != null) {
            let g = f.b1.i.b7();
            d += g.x;
            e += g.y;
        }
        if (this.b2 != null) {
            this.b2.ap = c;
            this.b2.bu(this.b2.n, this.b2.o);
        }
    }
    ai(a) {
        super.ai(a);
        let b = this.b2;
        let c = 0;
        let d = 0;
        if (this.e.bs != null) {
            let e = this.e.bs.nv();
            c += e.x;
            d += e.y;
        }
        let f = b.a3();
        let g = b.n - c;
        let h = b.o - d;
        let i = new List$1(String_$type, 0);
        let j = this._tooltips.getChildCount();
        for (let k = 0; k < j; k++) {
            let indexliteral_ = k.toString();
            let l = this._tooltips.getChildAt(k).getText();
            let m = l.toString();
            i.add(m);
        }
        this.e.a2.addPointerTooltipData(a, f, g, h, i);
    }
}
CategoryToolTipLayerView.$t = markType(CategoryToolTipLayerView, 'CategoryToolTipLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * EventArgs class for RenderRequested events.
*
* Use the `RenderRequested` class for RenderRequested events.
*/
class IgxRenderRequestedEventArgs {
    createImplementation() {
        return new RenderRequestedEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * True if animation is requested.
    *
    * Use the `animate` property true if the animation is requested.
    *
    * ```ts
    * e.animation = true;
    * ```
    */
    get animate() {
        return this.i.animate;
    }
    set animate(v) {
        this.i.animate = ensureBool(v);
    }
}

/**
 * Provides data for Axis RangeChanged events.
*
* The `IgxAxisRangeChangedEventArgs` event fire when the axis range changes.
*/
class IgxAxisRangeChangedEventArgs {
    createImplementation() {
        return new AxisRangeChangedEventArgs(0);
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the minimum value before the range changed. The reported minimum is the effective,
     * not the set value.
    *
    * The `oldMinimumValue` property is used to gets the minimum value before the range changed.
    */
    get oldMinimumValue() {
        return this.i.oldMinimumValue;
    }
    set oldMinimumValue(v) {
        this.i.oldMinimumValue = +v;
    }
    /**
     * Gets the minimum value after the range changed. The reported minimum is the effective,
     * not the set value.
    *
    * The `minimumValue` property is used to getsthe minimum value after the range changed.
    *
    * ```ts
    *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
    * 	let maxVal= e.maximumValue
    * 	let minVal= e.minimumValue
    *
    *     }
    * ```
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = +v;
    }
    /**
     * Gets the maximum value before the range changed. The reported maximum is the effective,
     * not the set value.
    *
    * The `oldMaximumValue` property is used to gets the maximum value before the range changed.
    */
    get oldMaximumValue() {
        return this.i.oldMaximumValue;
    }
    set oldMaximumValue(v) {
        this.i.oldMaximumValue = +v;
    }
    /**
     * Gets the maximum value after the range changed. The reported maximum is the effective,
     * not the set value.
    *
    * The `maximumValue` property is used to gets the maximum value after the range changed.
    *
    * ```ts
    *   public yAxisRangeChanged(sender : any, e: AxisRangeChangedEventArgs) :void {
    * 	let maxVal= e.maximumValue
    * 	let minVal= e.minimumValue
    *
    *     }
    * ```
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisAnnotation extends DependencyObject {
    constructor() {
        super(...arguments);
        this.propertyChanged = null;
        this.l = false;
        this._formatLabel = null;
        this.k = false;
        this.j = null;
    }
    resetCachedExtent() {
        this.l = true;
    }
    checkForExtentReset(a) {
        if (this.l) {
            this.l = false;
            a();
        }
    }
    ad(a, b, c) {
        this.ac(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    ac(a, b, c) {
        this.k = true;
        switch (a) {
            case AxisAnnotation.$$p[5]:
            case AxisAnnotation.$$p[6]:
                if (this.labelFormat != null) {
                    this.j = new BindingFormatter();
                    this.j.j = this.labelFormat;
                    this.j.d = this.labelFormatSpecifiers;
                }
                else {
                    this.j = null;
                }
                break;
        }
    }
    resolveLabelValue() {
        if (this.text != null) {
            return this.text;
        }
        if (this.formatLabel != null) {
            return this.formatLabel(this.value);
        }
        if (this.j != null) {
            return this.j.i(this.value);
        }
        if (this.value == null) {
            return null;
        }
        return this.value.toString();
    }
    get formatLabel() {
        return this._formatLabel;
    }
    set formatLabel(a) {
        this._formatLabel = a;
    }
    get backgroundPadding() {
        return new Thickness(1, this.backgroundPaddingLeft, this.backgroundPaddingTop, this.backgroundPaddingRight, this.backgroundPaddingBottom);
    }
    set backgroundPadding(a) {
        this.backgroundPaddingLeft = a.c;
        this.backgroundPaddingTop = a.e;
        this.backgroundPaddingRight = a.d;
        this.backgroundPaddingBottom = a.b;
    }
}
AxisAnnotation.$t = markType(AxisAnnotation, 'AxisAnnotation', DependencyObject.$, [INotifyPropertyChanged_$type, IAxisAnnotation_$type]);
AxisAnnotation.$$p = markDep(DependencyProperty, PropertyMetadata, AxisAnnotation, 'ad', ['BackgroundPaddingBottom', [1, NaN], 'BackgroundPaddingLeft', [1, NaN], 'BackgroundPaddingRight', [1, NaN], 'BackgroundPaddingTop', [1, NaN], 'Background', [Brush.$, null], 'LabelFormat', [2, null], 'LabelFormatSpecifiers', [Array_$type, null], 'Outline', [Brush.$, null], 'StrokeThickness', [1, 0], 'TextColor', [Brush.$, null], 'Text', [2, null], 'Value', [4, null]]);

/**
 * Represents an axis annotation
*/
class IgxAxisAnnotation {
    constructor() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new AxisAnnotation();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the value at which this annotation is displayed on the axis.
    */
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
    /**
     * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
    */
    get text() {
        return this.i.text;
    }
    set text(v) {
        this.i.text = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get labelFormat() {
        return this.i.labelFormat;
    }
    set labelFormat(v) {
        this.i.labelFormat = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LabelFormat string.
    */
    get labelFormatSpecifiers() {
        return this.i.labelFormatSpecifiers;
    }
    set labelFormatSpecifiers(v) {
        this.i.labelFormatSpecifiers = v;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
    */
    get formatLabel() {
        return this.i.formatLabel;
    }
    set formatLabel(v) {
        this.i.formatLabel = v;
    }
    /**
     * Gets or sets the color to use for the text in the annotation.
    */
    get textColor() {
        return brushToString(this.i.textColor);
    }
    set textColor(v) {
        this.i.textColor = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for tha axis annotation box.
    */
    get background() {
        return brushToString(this.i.background);
    }
    set background(v) {
        this.i.background = stringToBrush(v);
    }
    /**
     * Gets or sets the Outline to use for tha axis annotation box.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets or sets the border stroke thickness to use for tha axis annotation box.
    */
    get strokeThickness() {
        return this.i.strokeThickness;
    }
    set strokeThickness(v) {
        this.i.strokeThickness = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingLeft() {
        return this.i.backgroundPaddingLeft;
    }
    set backgroundPaddingLeft(v) {
        this.i.backgroundPaddingLeft = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingTop() {
        return this.i.backgroundPaddingTop;
    }
    set backgroundPaddingTop(v) {
        this.i.backgroundPaddingTop = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingRight() {
        return this.i.backgroundPaddingRight;
    }
    set backgroundPaddingRight(v) {
        this.i.backgroundPaddingRight = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingBottom() {
        return this.i.backgroundPaddingBottom;
    }
    set backgroundPaddingBottom(v) {
        this.i.backgroundPaddingBottom = +v;
    }
    findByName(name) {
        if (this.labelFormatSpecifiers != null && arrayFindByName(this.labelFormatSpecifiers, name)) {
            return arrayFindByName(this.labelFormatSpecifiers, name);
        }
        return null;
    }
    resetCachedExtent() {
        this.i.resetCachedExtent();
    }
    resolveLabelValue() {
        let iv = this.i.resolveLabelValue();
        return (iv);
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}

class IgxAxisAnnotationCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxAxisAnnotation.$type) {
            IgxAxisAnnotation.$type = markType(IgxAxisAnnotation, "AxisAnnotation");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxAxisAnnotation.$type) {
            IgxAxisAnnotation.$type = markType(IgxAxisAnnotation, "AxisAnnotation");
        }
        let coll = new SyncableObservableCollection$2(IgxAxisAnnotation.$type, IAxisAnnotation_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxAxisAnnotation();
                ext._implementation = int;
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
const IgxAxisComponent_PROVIDERS = [];
/**
 * Represents the base class from which all axis types are derived.
*
* The `IgxAxisComponent` is an array of axis objects.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* </igx-data-chart>
* ```
*/
class IgxAxisComponent {
    constructor() {
        this._renderer = null;
        this._annotations = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._rangeChanged = null;
        this._renderRequested = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    get axisInternal() {
        return this.i;
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    set name(value) {
        //console.log("setting axis name: " + value);
        this.i.name = value;
        //console.log("checking axis anme: " + this.i.name)
    }
    get name() {
        //console.log("getting axis anme: " + this.i.name)
        return this.i.name;
    }
    provideData(data) {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * Gets or sets if the current axis is of category axis type
*/
    get isCategory() {
        return this.i.b4;
    }
    /**
     * Gets or sets if the current axis is of numeric axis type
    *
    *     Gets or sets if the current axis is of numeric axis type
    */
    get isNumeric() {
        return this.i.cc;
    }
    /**
     * Gets if the current axis is of angular axis type
    */
    get isAngular() {
        return this.i.b2;
    }
    /**
     * Gets or sets if the current axis is of radial axis type
    */
    get isRadial() {
        return this.i.ce;
    }
    /**
     * Gets if the current axis is a vertical axis.
    */
    get isVertical() {
        return this.i.ch;
    }
    /**
     * Gets or sets if the current axis is sorting data items
    */
    get isSorting() {
        return this.i.cf;
    }
    /**
     * Gets or sets if the current axis is of date time axis type
    */
    get isDateTime() {
        return this.i.b7;
    }
    /**
     * Gets or sets if the axis is a piecewise scaling function.
    */
    get isPiecewise() {
        return this.i.cd;
    }
    /**
     * Gets if the current axis is of category date time axis type
    */
    get isCategoryDateTime() {
        return this.i.b5;
    }
    /**
     * Gets if the current axis is a continuous rather than a discrete scale
    */
    get isContinuous() {
        return this.i.b6;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
    *
    * The `formatLabel` function takes an object that produces a formatted label for displaying in the chart.
    *
    * ```html
    * <igx-data-chart [dataSource]="data" >
    *     <igx-category-x-axis
    * 		name="xAxis"
    * 		FormatLabel="xAxis_FormatLabel" />
    * </igx-data-chart>
    * ```
    */
    get formatLabel() {
        return this.i.at;
    }
    set formatLabel(v) {
        this.i.at = v;
    }
    /**
     * Gets or sets the Title property.
    *
    * Use `title` property to display the title of the component.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get title() {
        return this.i.gc;
    }
    set title(v) {
        this.i.gc = v;
    }
    /**
     * Gets or sets the Stroke property.
     * Null is treated as auto. The axis stroke will be displayed or not based on the axis type and series used with it.
    *
    * Use `stroke` property to set the stroke of the chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		stroke="blue"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get stroke() {
        return brushToString(this.i.iv);
    }
    set stroke(v) {
        this.i.iv = stringToBrush(v);
    }
    /**
     * Gets or sets the effective stroke used for the axis.
    */
    get actualStroke() {
        return brushToString(this.i.ir);
    }
    set actualStroke(v) {
        this.i.ir = stringToBrush(v);
    }
    /**
     * Gets or sets the StrokeThickness property.
    *
    * Use `strokeThickness` property for the thickness of the stroke.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		strokeThickness= 5
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get strokeThickness() {
        return this.i.ep;
    }
    set strokeThickness(v) {
        this.i.ep = +v;
    }
    /**
     * Gets or sets the Strip property.
    *
    * Use `strip` property to set the strip of the chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		 strip= "grey"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get strip() {
        return brushToString(this.i.iu);
    }
    set strip(v) {
        this.i.iu = stringToBrush(v);
    }
    /**
     * Gets or sets the MajorStroke property.
     * Null is treated as auto. Major lines will be displayed or not based on the axis type and series used with it.
    *
    * Gets or sets the `majorStroke` using this property.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 	   majorStroke="black"
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get majorStroke() {
        return brushToString(this.i.is);
    }
    set majorStroke(v) {
        this.i.is = stringToBrush(v);
    }
    /**
     * Gets or sets the ActualMajorStroke property.
    *
    * The `actualMajorStroke` property is used for ActualMajorStroke of the axis.
    */
    get actualMajorStroke() {
        return brushToString(this.i.ip);
    }
    set actualMajorStroke(v) {
        this.i.ip = stringToBrush(v);
    }
    /**
     * Gets or sets the MajorStrokeThickness property.
    *
    * Gets or sets the `majorStrokeThickness` using this property.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 	  majorStrokeThickness="1"
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get majorStrokeThickness() {
        return this.i.d5;
    }
    set majorStrokeThickness(v) {
        this.i.d5 = +v;
    }
    /**
     * Gets or sets the MinorStroke property.
    *
    * Gets or sets the minorStroke thickness using `minorStrokeThickness` property.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 	 minorStrokeThickness="1"
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get minorStroke() {
        return brushToString(this.i.it);
    }
    set minorStroke(v) {
        this.i.it = stringToBrush(v);
    }
    /**
     * Gets or sets the ActualMinorStroke property.
    *
    * The `actualMinorStroke` property is used for ActualMinorStroke of the axis.
    */
    get actualMinorStroke() {
        return brushToString(this.i.iq);
    }
    set actualMinorStroke(v) {
        this.i.iq = stringToBrush(v);
    }
    /**
     * Gets or sets the MinorStrokeThickness property.
    */
    get minorStrokeThickness() {
        return this.i.d8;
    }
    set minorStrokeThickness(v) {
        this.i.d8 = +v;
    }
    /**
     * Gets or sets the TickStroke property.
    *
    * Use `tickStroke` property for the color of the tickmarks.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		tickStroke="black"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get tickStroke() {
        return brushToString(this.i.iw);
    }
    set tickStroke(v) {
        this.i.iw = stringToBrush(v);
    }
    /**
     * Gets or sets the TickStrokeThickness property.
    *
    * Use `tickStrokeThickness` property for thickness of the stroke tickmarks.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		tickStrokeThicknes="2"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get tickStrokeThickness() {
        return this.i.er;
    }
    set tickStrokeThickness(v) {
        this.i.er = +v;
    }
    /**
     * Gets or sets the TickLength property.
    *
    * Use `tickLength` property for The length of the tickmarks to display for this axis.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		tickLength="5"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get tickLength() {
        return this.i.eq;
    }
    set tickLength(v) {
        this.i.eq = +v;
    }
    /**
     * Gets or sets the IsDisabled property. If true, the axis will not be rendered.
    *
    * The `isDisabled` property is used to decide if the axis will not be rendered.
    */
    get isDisabled() {
        return this.i.b8;
    }
    set isDisabled(v) {
        this.i.b8 = ensureBool(v);
    }
    /**
     * Gets or sets the IsInverted property.
    *
    * Gets or sets the `isInverted` property.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		isInverted= true
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get isInverted() {
        return this.i.ca;
    }
    set isInverted(v) {
        this.i.ca = ensureBool(v);
    }
    /**
     * Gets or sets whether to use more advanced heuristics when determining the initial number of labels to render, before resolving collisions, etc.
    *
    * Use `useEnhancedIntervalManagement` property to gets/sets whether to use more advanced heuristics when determining the initial number of labels to render,
    * before resolving collisions, etc.
    */
    get useEnhancedIntervalManagement() {
        return this.i.cq;
    }
    set useEnhancedIntervalManagement(v) {
        this.i.cq = ensureBool(v);
    }
    /**
     * Gets or sets the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics. -1 will attempt to adjust the interval to precisely fit the horizontal labels.
    *
    * The `enhancedIntervalMinimumCharacters` property is used to set the mininum desired characters to be displayed for horizontal axes when using advanced label heuristics.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		enhancedIntervalMinimumCharacters=5
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *
    * </igx-data-chart>
    * ```
    */
    get enhancedIntervalMinimumCharacters() {
        return this.i.ez;
    }
    set enhancedIntervalMinimumCharacters(v) {
        this.i.ez = +v;
    }
    /**
     * Gets or sets the text style to use for axis labels.
    *
    * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
    */
    get labelTextStyle() {
        return this.i.ay ? this.i.ay.textStyle : null;
    }
    set labelTextStyle(v) {
        this.ensureLabelSettings();
        this.i.ay.textStyle = v;
    }
    /**
     * The color of the {0}.
    *
    * The `labelTextColor` property Overrides the color of the text used for the axis labels.
    */
    get labelTextColor() {
        return brushToString(this.i.ay ? this.i.ay.textColor : null);
    }
    set labelTextColor(v) {
        this.ensureLabelSettings();
        this.i.ay.textColor = stringToBrush(v);
    }
    /**
     * Gets or sets the location of the {0}.
    *
    * The `Location` property is used for the location.
    */
    get labelLocation() {
        return this.i.ay ? this.i.ay.location : 0;
    }
    set labelLocation(v) {
        this.ensureLabelSettings();
        this.i.ay.location = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
     * Gets or sets the visibility of the {0}.
    *
    * The `Visibility` property is used for the visibility of the axis.
    */
    get labelVisibility() {
        return this.i.ay ? this.i.ay.visibility : 0;
    }
    set labelVisibility(v) {
        this.ensureLabelSettings();
        this.i.ay.visibility = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets whether the first label is displayed when the zoom level is set to 1.
    *
    * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
    */
    get labelShowFirstLabel() {
        return this.i.ay ? this.i.ay.showFirstLabel : false;
    }
    set labelShowFirstLabel(v) {
        this.ensureLabelSettings();
        this.i.ay.showFirstLabel = ensureBool(v);
    }
    /**
     * Gets or sets the angle of the {0}.
    *
    * The `Angle` property is used to set the angle of the axis.
    */
    get labelAngle() {
        return this.i.ay ? this.i.ay.angle : NaN;
    }
    set labelAngle(v) {
        this.ensureLabelSettings();
        this.i.ay.angle = +v;
    }
    /**
     * Distance between the axis and the edge of the control.
    *
    * The `Extent` property is used for the extent.
    */
    get labelExtent() {
        return this.i.ay ? this.i.ay.extent : NaN;
    }
    set labelExtent(v) {
        this.ensureLabelSettings();
        this.i.ay.extent = +v;
    }
    /**
     * Margin applied to the left of the {0}.
    *
    * The `labelLeftMargin` property is used for the left margin of the labels.
    */
    get labelLeftMargin() {
        return this.i.ay ? this.i.ay.leftMargin : NaN;
    }
    set labelLeftMargin(v) {
        this.ensureLabelSettings();
        this.i.ay.leftMargin = +v;
    }
    /**
     * Margin applied to the right of the {0}.
    *
    * The `labelRightMargin` property is used for the right margin of the labels.
    */
    get labelRightMargin() {
        return this.i.ay ? this.i.ay.rightMargin : NaN;
    }
    set labelRightMargin(v) {
        this.ensureLabelSettings();
        this.i.ay.rightMargin = +v;
    }
    /**
     * Margin applied above the {0}.
    *
    * The `labelTopMargin` property is used for the top margin of the labels.
    */
    get labelTopMargin() {
        return this.i.ay ? this.i.ay.topMargin : NaN;
    }
    set labelTopMargin(v) {
        this.ensureLabelSettings();
        this.i.ay.topMargin = +v;
    }
    /**
     * Margin applied below the {0}.
    *
    * The `labelBottomMargin` is used to set the bottom margin of the labels.
    */
    get labelBottomMargin() {
        return this.i.ay ? this.i.ay.bottomMargin : NaN;
    }
    set labelBottomMargin(v) {
        this.ensureLabelSettings();
        this.i.ay.bottomMargin = +v;
    }
    /**
     * Gets or sets the horizontal alignment of the {0}.
    *
    * The `HorizontalAlignment` property is used for the horizontal alignment.
    */
    get labelHorizontalAlignment() {
        return this.i.ay ? this.i.ay.horizontalAlignment : 0;
    }
    set labelHorizontalAlignment(v) {
        this.ensureLabelSettings();
        this.i.ay.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the vertical alignment of the {0}.
    *
    * The `VerticalAlignment` property is used for the vertical alignment of the axis.
    */
    get labelVerticalAlignment() {
        return this.i.ay ? this.i.ay.verticalAlignment : 0;
    }
    set labelVerticalAlignment(v) {
        this.ensureLabelSettings();
        this.i.ay.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
    }
    ensureLabelSettings() {
        if (this.i.ay) {
            return;
        }
        this.i.ay = new AxisLabelSettings();
        this.i.ay.location = this.i.az();
        this.i.ay.angle = this.i.dm();
        this.i.ay.leftMargin = this.i.dp();
        this.i.ay.rightMargin = this.i.dq();
        this.i.ay.topMargin = this.i.dr();
        this.i.ay.bottomMargin = this.i.dn();
        this.i.ay.horizontalAlignment = this.i.im();
        this.i.ay.verticalAlignment = this.i.jg();
    }
    /**
     * Gets or sets the CrossingAxis property.
    *
    * The `crossingAxis` property is used for CrossingAxis .
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		crossingAxis= "xAxis"
    * 		crossingValue= 700
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get crossingAxis() {
        if (this.i.ai == null) {
            return null;
        }
        if (!this.i.ai.externalObject) {
            let e = IgxAxisComponent._createFromInternal(this.i.ai);
            if (e) {
                e._implementation = this.i.ai;
            }
            this.i.ai.externalObject = e;
        }
        return this.i.ai.externalObject;
    }
    set crossingAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ai = null : this.i.ai = v.i;
    }
    /**
     * Gets or sets the CrossingValue property.
    *
    * The `crossingValue` property is used for CrossingValue of the axis.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		crossingAxis= "xAxis"
    * 		crossingValue= 700
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * </igx-data-chart>
    * ```
    */
    get crossingValue() {
        return this.i.e4;
    }
    set crossingValue(v) {
        this.i.e4 = v;
    }
    /**
     * Gets or sets the title position relative to the axis labels.
    */
    get titlePosition() {
        return this.i.be ? this.i.be.position : 0;
    }
    set titlePosition(v) {
        this.ensureTitleSettings();
        this.i.be.position = ensureEnum(AxisTitlePosition_$type, v);
    }
    /**
     * Gets or sets the text style to use for axis labels.
    *
    * The `labelTextStyle` property Overrides the style of the text used for the axis labels.
    */
    get titleTextStyle() {
        return this.i.be ? this.i.be.textStyle : null;
    }
    set titleTextStyle(v) {
        this.ensureTitleSettings();
        this.i.be.textStyle = v;
    }
    /**
     * The color of the {0}.
    *
    * The `labelTextColor` property Overrides the color of the text used for the axis labels.
    */
    get titleTextColor() {
        return brushToString(this.i.be ? this.i.be.textColor : null);
    }
    set titleTextColor(v) {
        this.ensureTitleSettings();
        this.i.be.textColor = stringToBrush(v);
    }
    /**
     * Gets or sets the location of the {0}.
    *
    * The `Location` property is used for the location.
    */
    get titleLocation() {
        return this.i.be ? this.i.be.location : 0;
    }
    set titleLocation(v) {
        this.ensureTitleSettings();
        this.i.be.location = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
     * Gets or sets the visibility of the {0}.
    *
    * The `Visibility` property is used for the visibility of the axis.
    */
    get titleVisibility() {
        return this.i.be ? this.i.be.visibility : 0;
    }
    set titleVisibility(v) {
        this.ensureTitleSettings();
        this.i.be.visibility = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets whether the first label is displayed when the zoom level is set to 1.
    *
    * The `ShowFirstLabel` is used to check whether the first label is displayed when the zoom level is set to 1.
    */
    get titleShowFirstLabel() {
        return this.i.be ? this.i.be.showFirstLabel : false;
    }
    set titleShowFirstLabel(v) {
        this.ensureTitleSettings();
        this.i.be.showFirstLabel = ensureBool(v);
    }
    /**
     * Gets or sets the angle of the {0}.
    *
    * The `Angle` property is used to set the angle of the axis.
    */
    get titleAngle() {
        return this.i.be ? this.i.be.angle : NaN;
    }
    set titleAngle(v) {
        this.ensureTitleSettings();
        this.i.be.angle = +v;
    }
    /**
     * Distance between the axis and the edge of the control.
    *
    * The `Extent` property is used for the extent.
    */
    get titleExtent() {
        return this.i.be ? this.i.be.extent : NaN;
    }
    set titleExtent(v) {
        this.ensureTitleSettings();
        this.i.be.extent = +v;
    }
    /**
     * Margin applied to the left of the {0}.
    *
    * The `labelLeftMargin` property is used for the left margin of the labels.
    */
    get titleLeftMargin() {
        return this.i.be ? this.i.be.leftMargin : NaN;
    }
    set titleLeftMargin(v) {
        this.ensureTitleSettings();
        this.i.be.leftMargin = +v;
    }
    /**
     * Margin applied to the right of the {0}.
    *
    * The `labelRightMargin` property is used for the right margin of the labels.
    */
    get titleRightMargin() {
        return this.i.be ? this.i.be.rightMargin : NaN;
    }
    set titleRightMargin(v) {
        this.ensureTitleSettings();
        this.i.be.rightMargin = +v;
    }
    /**
     * Margin applied above the {0}.
    *
    * The `labelTopMargin` property is used for the top margin of the labels.
    */
    get titleTopMargin() {
        return this.i.be ? this.i.be.topMargin : NaN;
    }
    set titleTopMargin(v) {
        this.ensureTitleSettings();
        this.i.be.topMargin = +v;
    }
    /**
     * Margin applied below the {0}.
    *
    * The `labelBottomMargin` is used to set the bottom margin of the labels.
    */
    get titleBottomMargin() {
        return this.i.be ? this.i.be.bottomMargin : NaN;
    }
    set titleBottomMargin(v) {
        this.ensureTitleSettings();
        this.i.be.bottomMargin = +v;
    }
    /**
     * Gets or sets the horizontal alignment of the {0}.
    *
    * The `HorizontalAlignment` property is used for the horizontal alignment.
    */
    get titleHorizontalAlignment() {
        return this.i.be ? this.i.be.horizontalAlignment : 0;
    }
    set titleHorizontalAlignment(v) {
        this.ensureTitleSettings();
        this.i.be.horizontalAlignment = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the vertical alignment of the {0}.
    *
    * The `VerticalAlignment` property is used for the vertical alignment of the axis.
    */
    get titleVerticalAlignment() {
        return this.i.be ? this.i.be.verticalAlignment : 0;
    }
    set titleVerticalAlignment(v) {
        this.ensureTitleSettings();
        this.i.be.verticalAlignment = ensureEnum(VerticalAlignment_$type, v);
    }
    ensureTitleSettings() {
        if (this.i.be) {
            return;
        }
        this.i.be = new TitleSettings();
        this.i.be.location = this.i.a0();
        this.i.be.angle = this.i.ds();
        this.i.be.leftMargin = this.i.du();
        this.i.be.rightMargin = this.i.dv();
        this.i.be.topMargin = this.i.dw();
        this.i.be.bottomMargin = this.i.dt();
        this.i.be.horizontalAlignment = this.i.io();
        this.i.be.verticalAlignment = this.i.jh();
    }
    /**
     * Gets the current annotations for the axis.
    */
    get annotations() {
        if (this._annotations === null) {
            let coll = new IgxAxisAnnotationCollection();
            let innerColl = this.i.am;
            if (!innerColl) {
                innerColl = new AxisAnnotationCollection();
            }
            this._annotations = coll._fromInner(innerColl);
        }
        return this._annotations;
    }
    set annotations(v) {
        if (this._annotations !== null) {
            this._annotations._setSyncTarget(null);
            this._annotations = null;
        }
        let coll = new IgxAxisAnnotationCollection();
        this._annotations = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(IAxisAnnotation_$type);
        let innerColl = this.i.am;
        if (!innerColl) {
            innerColl = new AxisAnnotationCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._annotations._setSyncTarget(syncColl);
    }
    /**
     * Gets or sets the coercion methods to use when loading data from data sources.
     * Should be specified before setting any member paths, if being used. Setting it later
     * will not cause data to be re-imported into the chart.
    *
    * The	`coercionMethods` methods is to use when loading data from data sources. Should be specified before setting any member paths, if being used.
    * Setting it later will not cause data to be reimported into the chart.
    */
    get coercionMethods() {
        return this.i.coercionMethods;
    }
    set coercionMethods(v) {
        this.i.coercionMethods = v;
    }
    /**
     * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
     * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
     * This value must be set before assigning an item's source to take effect.
    */
    get expectFunctions() {
        return this.i.expectFunctions;
    }
    set expectFunctions(v) {
        this.i.expectFunctions = ensureBool(v);
    }
    /**
     * Gets or sets the axis label format string.
    *
    * The `label` property is used for label mapping of the axis labels.
    */
    get label() {
        return this.i.e9;
    }
    set label(v) {
        this.i.e9 = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get labelFormat() {
        return this.i.fo;
    }
    set labelFormat(v) {
        this.i.fo = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LabelFormat string.
    */
    get labelFormatSpecifiers() {
        return this.i.ag;
    }
    set labelFormatSpecifiers(v) {
        this.i.ag = v;
    }
    findByName(name) {
        if (this.crossingAxis && this.crossingAxis.name && this.crossingAxis.name == name) {
            return this.crossingAxis;
        }
        if (this.annotations != null && this.annotations.findByName && this.annotations.findByName(name)) {
            return this.annotations.findByName(name);
        }
        if (this.labelFormatSpecifiers != null && arrayFindByName(this.labelFormatSpecifiers, name)) {
            return arrayFindByName(this.labelFormatSpecifiers, name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("AxisComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this.crossingAxis && this.crossingAxis._styling) {
            this.crossingAxis._styling(container, component, this);
        }
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Renders the axis with no animation.

*/
    renderAxis() {
        this.i.ha();
    }
    /**
     * If using enhanced interval management and precise interval fitting, this will reset the cached maximum label width, and recalculate using the current labels.
    
    */
    resetCachedEnhancedInterval() {
        this.i.hd();
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.e6(item, memberPathName);
        return (iv);
    }
    /**
     * Gets the label for a data item.
    
    * @param value  * The unscaled value to get a label for.
    */
    getValueLabel(value) {
        let iv = this.i.fl(value);
        return (iv);
    }
    /**
     * Scales a value from axis space into screen space.
    
    * @param unscaledValue  * The unscaled axis value to scale.
    */
    scaleValue(unscaledValue) {
        let iv = this.i.ed(unscaledValue);
        return (iv);
    }
    /**
     * Occurs when the axis range changes.
    */
    get rangeChanged() {
        if (this._rangeChanged == null) {
            this._rangeChanged = new EventEmitter();
            this.i.rangeChanged = delegateCombine(this.i.rangeChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxAxisRangeChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeRangeChanged) {
                        this.beforeRangeChanged(this, outerArgs);
                    }
                    this._rangeChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._rangeChanged;
    }
    /**
     * This event is raised every time a render has been requested from a series.
    */
    get renderRequested() {
        if (this._renderRequested == null) {
            this._renderRequested = new EventEmitter();
            this.i.renderRequested = delegateCombine(this.i.renderRequested, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxRenderRequestedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeRenderRequested) {
                        this.beforeRenderRequested(this, outerArgs);
                    }
                    this._renderRequested.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._renderRequested;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "name", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxAxisComponent.prototype, "formatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "title", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "stroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "actualStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "strokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "strip", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "majorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "actualMajorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "majorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "minorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "actualMinorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "minorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "tickStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "tickStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "tickLength", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "isDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "isInverted", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "useEnhancedIntervalManagement", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "enhancedIntervalMinimumCharacters", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "labelTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "labelTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelLocation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "labelShowFirstLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "labelVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", IgxAxisComponent),
    __metadata("design:paramtypes", [IgxAxisComponent])
], IgxAxisComponent.prototype, "crossingAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxAxisComponent.prototype, "crossingValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titlePosition", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "titleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "titleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleLocation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "titleShowFirstLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAxisComponent.prototype, "titleVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", IgxAxisAnnotationCollection),
    __metadata("design:paramtypes", [IgxAxisAnnotationCollection])
], IgxAxisComponent.prototype, "annotations", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxAxisComponent.prototype, "coercionMethods", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAxisComponent.prototype, "expectFunctions", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxAxisComponent.prototype, "label", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAxisComponent.prototype, "labelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxAxisComponent.prototype, "labelFormatSpecifiers", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxAxisComponent.prototype, "rangeChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxAxisComponent.prototype, "renderRequested", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
const IgxSeriesComponent_PROVIDERS = [];
/**
 * Represents the base class for all IgxDataChartComponent series.
*/
class IgxSeriesComponent {
    constructor() {
        //@Input()
        //set opacity(value: number) {
        //    this.i.opacity = +value;
        //}
        //get opacity(): number {
        //    return this.i.opacity;
        //}
        //@Input()
        //set visibility(v: Visibility) {
        //    this.i.visibility = ensureEnum<Visibility>(Visibility_$type, v);
        //}
        //get visibility(): Visibility {
        //    return this.i.visibility;
        //}
        this._chartLevelData = null;
        this._dataSource = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._tooltipContainerTemplate = null;
        this._renderer = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._renderRequested = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return null;
    }
    get seriesInternal() {
        return this.i;
    }
    ngOnInit() {
    }
    set name(value) {
        this.i.name = value;
    }
    get name() {
        return this.i.name;
    }
    /**
     * Gets or sets the legend used for the current series.
    */
    get legend() {
        if (this.i.legend != null)
            return this.i.legend.externalObject;
    }
    set legend(v) {
        if (v != undefined && v != null)
            this.i.legend = v.i;
    }
    provideData(data) {
        this._chartLevelData = data;
        this.updateDataSource();
    }
    onUpdateDataSource(dataSource) {
        return dataSource;
    }
    updateDataSource() {
        if (this._dataSource == null) {
            this.i.itemsSource = this.onUpdateDataSource(this._chartLevelData);
        }
        else {
            this.i.itemsSource = this.onUpdateDataSource(this._dataSource);
        }
    }
    set dataSource(value) {
        this._dataSource = value;
        this.updateDataSource();
        //console.log("setting axis data source: " + value)
    }
    get dataSource() {
        if (this._dataSource != null) {
            return this._dataSource;
        }
        return this.i.itemsSource;
    }
    bindAxes(axes) {
    }
    set tooltipTemplate(value) {
        this._tooltipTemplate = value;
        if (value == null) {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        }
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.template = this._tooltipTemplate;
        }
        else {
            if (this.owner != null) {
                this.owner._ensureTooltipCreated(this);
            }
        }
    }
    get tooltipTemplate() {
        return this._tooltipTemplate;
    }
    set tooltipContainerTemplate(value) {
        this._tooltipContainerTemplate = value;
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
        }
    }
    get tooltipContainerTemplate() {
        return this._tooltipContainerTemplate;
    }
    _ensureTooltipCreated(createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            let tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip.location.nativeElement);
        }
    }
    _ensureTooltipDestroyed() {
        if (this._tooltipContent !== null) {
            this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => {
            if (renderer !== null) {
                renderer._ngZone.run(act);
            }
            else {
                act();
            }
        };
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * Gets whether the series is an annotation layer.
*
* ```ts
* let isAnnotationLayer: boolean = this.series.isAnnotationLayer;
* ```
*/
    get isAnnotationLayer() {
        return this.i.cj;
    }
    /**
     * Gets whether the current series is oriented vertically.
    *
    * ```ts
    * let isVertical: boolean = this.series.isVertical;
    * ```
    */
    get isVertical() {
        return this.i.isVertical;
    }
    /**
     * Gets whether the current series is a stack fragment.
    *
    * ```ts
    * let isFragment: boolean = this.series.isFragment;
    * ```
    */
    get isFragment() {
        return this.i.cs;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    *
    * ```ts
    * let isAreaorLine: boolean = this.series.isAreaorLine;
    * ```
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
    /**
     * Gets whether the current series is a polar type series.
    *
    * ```ts
    * let isPolar: boolean = this.series.isPolar;
    * ```
    */
    get isPolar() {
        return this.i.c0;
    }
    /**
     * Gets whether the current series is a scatter type series.
    *
    * ```ts
    * let isScatter: boolean = this.series.isScatter;
    * ```
    */
    get isScatter() {
        return this.i.c4;
    }
    /**
     * Gets whether the current series is a radial type series.
    *
    * ```ts
    * let isRadial: boolean = this.series.isRadial;
    * ```
    */
    get isRadial() {
        return this.i.c2;
    }
    /**
     * Gets whether the current series is a stacked type series.
    *
    * ```ts
    * let isStacked: boolean = this.series.isStacked;
    * ```
    */
    get isStacked() {
        return this.i.isStacked;
    }
    /**
     * Gets whether the current series is a financial type series.
    *
    * ```ts
    * let isFinancial: boolean = this.series.isFinancial;
    * ```
    */
    get isFinancial() {
        return this.i.cr;
    }
    /**
     * Gets whether the current series is a range type series.
    *
    * ```ts
    * let isRange: boolean = this.series.isRange;
    * ```
    */
    get isRange() {
        return this.i.c3;
    }
    /**
     * Gets whether the current series is a category type series.
    *
    * ```ts
    * let isCategory: boolean = this.series.isCategory;
    * ```
    */
    get isCategory() {
        return this.i.cl;
    }
    /**
     * Gets whether the current seires is a geogrpahic series.
    *
    * ```ts
    * let isGeographic: boolean = this.series.isGeographic;
    * ```
    */
    get isGeographic() {
        return this.i.ct;
    }
    /**
     * Gets whether the current series is a shape type series.
    */
    get isShape() {
        return this.i.c5;
    }
    /**
     * Gets whether the series is a value overlay.
    */
    get isValueOverlay() {
        return this.i.c6;
    }
    /**
     * Gets whether the default crosshair behavior should be disabled if this series is present.
    *
    * `isDefaultCrosshairBehaviorDisabled` defaults to true for annotation layers. When not using annotaion layers, you can show crosshairs by setting the chart's `CrosshairVisibility` to true.
    *
    * ```ts
    * let isDefaultCrosshairBehaviorDisabled: boolean = this.series.isDefaultCrosshairBehaviorDisabled;
    * ```
    */
    get isDefaultCrosshairBehaviorDisabled() {
        return this.i.cm;
    }
    /**
     * Gets whether the default tooltip behavior should be disabled if this series is present.
    *
    * ```ts
    *  let isDefaultTooltipBehaviorDisabled: boolean = this.series.isDefaultTooltipBehaviorDisabled;
    * ```
    */
    get isDefaultTooltipBehaviorDisabled() {
        return this.i.cn;
    }
    /**
     * Returns whether the current series supports visual markers.
    *
    * ```ts
    * let hasMarkers: boolean = this.series.hasMarkers;
    * ```
    */
    get hasMarkers() {
        return this.i.hasMarkers;
    }
    /**
     * Gets if the series uses an index, which can be used to auto-assign it a color.
    *
    * ```ts
    * let isIndexed: boolean = this.series.isIndexed;
    * ```
    */
    get isIndexed() {
        return this.i.cw;
    }
    /**
     * Gets if the series should appear in any legends.
    *
    * ```ts
    * let isUsableInLegend: boolean = this.series.isUsableInLegend;
    * ```
    */
    get isUsableInLegend() {
        return this.i.isUsableInLegend;
    }
    /**
     * Gets or sets the legend item visibility for the current series object.
    *
    * The `LegendItemVisibilty` can be used to exclude only certain `IgxSeriesComponent` from the `IgxLegendComponent`.
    */
    get legendItemVisibility() {
        return this.i.l9;
    }
    set legendItemVisibility(v) {
        this.i.l9 = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the LegendItemBadgeTemplate property.
     * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
     * the series object itself.
    */
    get legendItemBadgeTemplate() {
        return this.i.legendItemBadgeTemplate;
    }
    set legendItemBadgeTemplate(v) {
        this.i.legendItemBadgeTemplate = v;
    }
    /**
     * Gets or sets the LegendItemTemplate property.
     * The legend item control content is created according to the LegendItemTemplate on-demand by
     * the series object itself.
    */
    get legendItemTemplate() {
        return this.i.legendItemTemplate;
    }
    set legendItemTemplate(v) {
        this.i.legendItemTemplate = v;
    }
    /**
     * Gets or sets the DiscreteLegendItemTemplate property.
     * The legend item control content is created according to the DiscreteLegendItemTemplate on-demand by
     * the series object itself.
    */
    get discreteLegendItemTemplate() {
        return this.i.j6;
    }
    set discreteLegendItemTemplate(v) {
        this.i.j6 = v;
    }
    /**
     * Gets or sets the easing function used to morph the current series.
    *
    * The `TransitioninDuration` and `transitionEasingFunction` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
    *
    * ```ts
    * this.series.transitionEasingFunction =  EasingFunctions.cubicEase;
    * ```
    */
    get transitionEasingFunction() {
        return this.i.bu;
    }
    set transitionEasingFunction(v) {
        this.i.bu = v;
    }
    /**
     * Gets or sets the EasingFunction used to morph the current series during the initial transition.
    *
    * The `transitionInEasingFunction` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
    *
    * ```ts
    * this.series.transitionInEasingFunction =  EasingFunctions.cubicEase;
    * ```
    */
    get transitionInEasingFunction() {
        return this.i.bv;
    }
    set transitionInEasingFunction(v) {
        this.i.bv = v;
    }
    /**
     * Gets or sets the duration of the current series's morph.
    *
    * The `transitionDuration` can be used to play animation when data is added or removed from a `IgxSeriesComponent`. To play an initial animation see `transitionInDuration`.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     animateSeriesWhenAxisRangeChanges=true>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         transitionInMode="accordionFromBottom"
    *         isTransitionInEnabled=true
    *         transitionInSpeedType="indexScaled"
    *         transitionDuration=500
    *         transitionInDuration=500>
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.transitionDuration = 500;
    * ```
    */
    get transitionDuration() {
        return this.i.fi;
    }
    set transitionDuration(v) {
        this.i.fi = +v;
    }
    /**
     * Gets or sets the current series object's rendering resolution.
    *
    * Setting the `resolution` on a Series to a higher value can help with performance, but it will lower the graphical fidelity of the line. As such, it can be increased up until the fidelity is unacceptable.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         resolution=1.5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.resolution = 1.5;
    * ```
    */
    get resolution() {
        return this.i.eu;
    }
    set resolution(v) {
        this.i.eu = +v;
    }
    /**
     * Gets or sets the Title property.
     * The legend item control is created according to the Title on-demand by
     * the series object itself.
    *
    * The `IgxSeriesComponent` `title` may be used in tooltips and legends.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         showDefaultTooltip="true"
    *         title="InStock Items">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.title = "InStock Items";
    * ```
    */
    get title() {
        return this.i.fx;
    }
    set title(v) {
        this.i.fx = v;
    }
    /**
     * Gets or sets the brush to use for the series.
    *
    * The `brush` along with the `outline` and `Negative Brush` can be used to affect the visuals of the `IgxSeriesComponent`.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         brush="red">
    *     </igx-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.brush = "red";
    * ```
    */
    get brush() {
        return brushToString(this.i.ld);
    }
    set brush(v) {
        this.i.ld = stringToBrush(v);
    }
    /**
     * Gets the effective brush for the current series object.
    *
    * ```ts
    * let actualBrush: string = series.actualBrush;
    * ```
    */
    get actualBrush() {
        return brushToString(this.i.lb);
    }
    set actualBrush(v) {
        this.i.lb = stringToBrush(v);
    }
    /**
     * Gets or sets the brush to use for the outline of the series.
     * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
    *
    * The `outline` along with the `brush` and `NegativeBrush` can be used to affect the visuals of the `IgxSeriesComponent`.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         outline="red">
    *     </igx-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.brush = "red";
    * ```
    */
    get outline() {
        return brushToString(this.i.li);
    }
    set outline(v) {
        this.i.li = stringToBrush(v);
    }
    /**
     * Gets the effective outline for the current series object.
    *
    * ```ts
    * let actualOutline: string = series.ActualOutline;
    * ```
    */
    get actualOutline() {
        return brushToString(this.i.lc);
    }
    set actualOutline(v) {
        this.i.lc = stringToBrush(v);
    }
    /**
     * Gets or sets the width of the current series object's line thickness.
    *
    * Depending on the `IgxSeriesComponent` type, this can be the main brush used, or just the outline. For example, when using a `IgxLineSeriesComponent` it will affect the thickness of the lines drawn, whereas when using a `IgxColumnSeriesComponent` it will affect the outer border thickness of the columns.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.thickness=5;
    * ```
    */
    get thickness() {
        return this.i.ey;
    }
    set thickness(v) {
        this.i.ey = +v;
    }
    /**
     * Gets or sets whether highlighting should be enabled for this series, if this type of series supports highlighting.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightEnabled="true">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.isHighlightingEnabled = true;
    * ```
    */
    get isHighlightingEnabled() {
        return this.i.cu;
    }
    set isHighlightingEnabled(v) {
        this.i.cu = ensureBool(v);
    }
    /**
     * Gets or sets whether drop shadow should be enabled for this series.
    *
    * `isDropShadowEnabled` is used to decide whether drop shadow should be enabled for this series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled=true>
    *     </igx-line-series>
    *     </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.isDropShadowEnabled = true;
    * ```
    */
    get isDropShadowEnabled() {
        return this.i.cp;
    }
    set isDropShadowEnabled(v) {
        this.i.cp = ensureBool(v);
    }
    /**
     * Gets or sets the shadow blur.
     * This property is ignored when Series.UseSingleShadow is set to true.
    *
    * `shadowBlur` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled="true"
    *         shadowBlur="7"
    *         shadowColor="blue">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shadowBlur = 7;
    * ```
    */
    get shadowBlur() {
        return this.i.ev;
    }
    set shadowBlur(v) {
        this.i.ev = +v;
    }
    /**
     * Gets or sets the drop shadow color.
    *
    * `shadowColor` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled="true"
    *         shadowBlur="7"
    *         shadowColor="blue">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shadowColor = "blue";
    * ```
    */
    get shadowColor() {
        return colorToString(this.i.lk);
    }
    set shadowColor(v) {
        this.i.lk = stringToColor(v);
    }
    /**
     * Gets or sets whether drop shadow is applied to the whole series visual or to each of the individual shapes forming the series.
     * When this property is set to true, no Series.ShadowBlur is applied.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled=true
    *         markerType="circle"
    *         useSingleShadow=true>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.useSingleShadow = true;
    * ```
    */
    get useSingleShadow() {
        return this.i.du;
    }
    set useSingleShadow(v) {
        this.i.du = ensureBool(v);
    }
    /**
     * Gets or sets the drop shadow x-offset.
    *
    * `shadowOffsetX` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled="true"
    *         shadowOffsetX="10"
    *         shadowOffsetY="10">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shadowOffsetX = 10;
    * ```
    */
    get shadowOffsetX() {
        return this.i.ew;
    }
    set shadowOffsetX(v) {
        this.i.ew = +v;
    }
    /**
     * Gets or sets the drop shadow y-offset.
    *
    * `shadowOffsetY` can be set in conjection with `isDropShadowEnabled` to further define the drop shadow effect.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isDropShadowEnabled="true"
    *         shadowOffsetX="10"
    *         shadowOffsetY="10">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shadowOffsetY = 10;
    * ```
    */
    get shadowOffsetY() {
        return this.i.ex;
    }
    set shadowOffsetY(v) {
        this.i.ex = +v;
    }
    /**
     * Gets or sets the opacity applied to the area fill visual.
     * This property only applies to series that have area visual.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         areaFillOpacity=.5>
    *     </igx-area-series>
    * </igx-data-chart>
    * ```
    */
    get areaFillOpacity() {
        return this.i.d7;
    }
    set areaFillOpacity(v) {
        this.i.d7 = +v;
    }
    /**
     * Gets the actual opacity applied to the area fill visual.
    *
    * ```ts
    * let actualFillOpacity: number = series.actualAreaFillOpacity;
    * ```
    */
    get actualAreaFillOpacity() {
        return this.i.d6;
    }
    set actualAreaFillOpacity(v) {
        this.i.d6 = +v;
    }
    /**
     * Gets if the default tooltip has been selected for display.
    *
    * To use the default tooltip set `showDefaultTooltip` to true.
    *
    * ```ts
    * let isDefaultToolTipSelected: boolean = this.series.isDefaultToolTipSelected;
    * ```
    */
    get isDefaultToolTipSelected() {
        return this.i.co;
    }
    set isDefaultToolTipSelected(v) {
        this.i.co = ensureBool(v);
    }
    /**
     * Gets or sets whether default tooltip will be shown.
    *
    * The default tooltips display all the information relevant to the particular series item (series title, data values, axis values etc.) and are styled to match the series' style. When using default tooltips, you should also set the series `title`.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         showDefaultTooltip="true"
    *         title="InStock Items">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.showDefaultTooltip ="true";
    * ```
    */
    get showDefaultTooltip() {
        return this.i.dd;
    }
    set showDefaultTooltip(v) {
        this.i.dd = ensureBool(v);
    }
    /**
     * Gets or sets the duration of the current series's transition in morph.
    *
    * The `transitionInDuration` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         transitionInMode="accordionFromBottom"
    *         isTransitionInEnabled=true
    *         transitionInSpeedType="indexScaled"
    *         transitionDuration=500
    *         transitionInDuration=500>
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.transitionDuration = 500;
    * ```
    */
    get transitionInDuration() {
        return this.i.fj;
    }
    set transitionInDuration(v) {
        this.i.fj = +v;
    }
    /**
     * Gets or sets the duration of the current series's transition in morph.
    *
    * The `transitionInSpeedType` can be used with `IsTransitionInEnabled` to cofigure the animation when a new datasource is loaded.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         transitionInMode="accordionFromBottom"
    *         isTransitionInEnabled=true
    *         transitionInSpeedType="indexScaled"
    *         transitionInDuration=500>
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.transitionInSpeedType = TransitionInSpeedType.IndexScaled;
    * ```
    */
    get transitionInSpeedType() {
        return this.i.bp;
    }
    set transitionInSpeedType(v) {
        this.i.bp = ensureEnum(TransitionInSpeedType_$type, v);
    }
    /**
     * Gets or sets the whether the chart reacts to mouse move events.
    */
    get mouseOverEnabled() {
        return this.i.c7;
    }
    set mouseOverEnabled(v) {
        this.i.c7 = ensureBool(v);
    }
    /**
     * Gets or sets the coercion methods to use when loading data from data sources.
     * Should be specified before setting any member paths, if being used. Setting it later
     * will not cause data to be reimported into the chart.
    *
    * ```html
    *  <igx-data-chart
    *       [dataSource]="data"
    *      >
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         #yAxis>
    *       </igx-numeric-y-axis>
    *       <igx-line-series
    *       [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       valueMemberPath="value">
    *      </igx-line-series>
    *        <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         [coercionMethods]= cMethods
    *         valueMemberPath="value!ValueCoercion">
    *        </igx-line-series>
    *     </igx-data-chart>
    * ```
    *
    * &lt;-- position: content member-->
    *
    * ```ts
    * cMethods: any = {
    *     ValueCoercion: function(value:number): number {return value+2;}
    *  }
    * ```
    */
    get coercionMethods() {
        return this.i.coercionMethods;
    }
    set coercionMethods(v) {
        this.i.coercionMethods = v;
    }
    /**
     * Gets or sets whether the series should expect that properties in its items source may be functions that need to be
     * evaluated to yield their value. This defaults to false, as there will be a subtle performance impact to using this feature.
     * This value must be set before assigning an item's source to take effect.
    *
    * `expectFunctions` is used to decide whether the series should expect that its data source members need to be called as functions to get their values.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     expectFunctions=true
    *     valueMemberPath="MyFunction">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.expectFunctions=true;
    * ```
    */
    get expectFunctions() {
        return this.i.expectFunctions;
    }
    set expectFunctions(v) {
        this.i.expectFunctions = ensureBool(v);
    }
    /**
     * Method of hit testing to use when pointing to items in this series.
    *
    * The `hitTestMode` can be set to either:
    *
    * -   `Auto`: automatically decide the appropriate hit test mode for the series.
    * -   `ColorEncoded`: use a color encoded off screen buffer for hit testing. Should always be O(1) time for determining a hit series. This increases frame render time and memory usage, however. Consider using this if hit testing time is degrading performance.
    * -   `Computational`: use a computational based approach to determine whether the series has been hit. This uses loose bounding boxes, in some cases, and can range in time complexity between O(1) and O(log n) to find a hit. This decreases frame render time compared to color encoded
    *
    * ```ts
    * this.series.hitTestMode = SeriesHitTestMode.Computational;
    * ```
    */
    get hitTestMode() {
        return this.i.be;
    }
    set hitTestMode(v) {
        this.i.be = ensureEnum(SeriesHitTestMode_$type, v);
    }
    /**
     * Resolved method of hit testing to use when pointing to items in the chart.
    *
    * ```ts
    * let hitTestMode: SeriesHitTestMode = this.series.actualHitTestMode;
    * ```
    */
    get actualHitTestMode() {
        return this.i.bc;
    }
    set actualHitTestMode(v) {
        this.i.bc = ensureEnum(SeriesHitTestMode_$type, v);
    }
    /**
     * Overridden by derived series classes to indicate when negative colors are supported or not.
    */
    get isNegativeColorSupported() {
        return this.i.cz;
    }
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
    /**
     * The final value of this series.
    */
    get finalValue() {
        return this.i.d8;
    }
    set finalValue(v) {
        this.i.d8 = +v;
    }
    /**
     * The percent change from the beginning to the end of this series.
    */
    get percentChange() {
        return this.i.et;
    }
    set percentChange(v) {
        this.i.et = +v;
    }
    /**
     * Gets the text that is displayed for the Open label in the tooltip.
    */
    get actualOpenLabel() {
        return this.i.f7;
    }
    /**
     * Gets the text that is displayed for the Close label in the tooltip.
    */
    get actualCloseLabel() {
        return this.i.f2;
    }
    /**
     * Gets the text that is displayed for the High label in the tooltip.
    */
    get actualHighLabel() {
        return this.i.f3;
    }
    /**
     * Gets the text that is displayed for the Low label in the tooltip.
    */
    get actualLowLabel() {
        return this.i.f6;
    }
    /**
     * Gets the text that is displayed for the Volume label in the tooltip.
    */
    get actualVolumeLabel() {
        return this.i.gb;
    }
    /**
     * Gets the text that is displayed for the Value label in the tooltip.
    */
    get actualValueLabel() {
        return this.i.ga;
    }
    /**
     * Gets the text that is displayed for the Value label in the tooltip.
    */
    get actualRadiusLabel() {
        return this.i.f9;
    }
    get opacity() {
        return this.i.opacity;
    }
    set opacity(v) {
        this.i.opacity = +v;
    }
    get visibility() {
        return this.i.visibility;
    }
    set visibility(v) {
        this.i.visibility = ensureEnum(Visibility_$type, v);
    }
    findByName(name) {
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SeriesComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Gets the brush for tooltip labels.

*/
    resolveTooltipBrush() {
        let iv = this.i.g3();
        return (iv);
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    *
    * ```ts
    * let index: number = this.series.getExactItemIndex({x:.5,y:.5});
    * ```
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item item index associated with the specified world position
    
    *
    * ```ts
    * let index: number = this.series.getItemIndex({x:.5,y:.5});
    * ```
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * ```ts
    * let item: number = this.series.getItem({x:.5,y:.5});
    * ```
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * ```ts
    * let box: IgxRect = this.series.getSeriesValueBoundingBox({x:.8,y:.8});
    * ```
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    *
    * ```ts
    * let box: IgxRect = this.series.getSeriesValueMarkerBoundingBox({x:.8,y:.8});
    * ```
    */
    getSeriesValueMarkerBoundingBox(world) {
        let iv = this.i.l6(toPoint(world));
        return fromRect(iv);
    }
    getSeriesHighValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lr(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesLowValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesLowValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lt(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValuePositionFromSeriesPixel(mouse, useInterpolation, skipUnknowns) {
        let iv = this.i.lw(toPoint(mouse), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValueFromSeriesPixel(mouse, useInterpolation, skipUnknowns) {
        let iv = this.i.eo(toPoint(mouse), useInterpolation, skipUnknowns);
        return (iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * ```ts
    * let span: number = this.series.getItemSpan();
    * ```
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
    /**
     * Hides any internal tooltips presented by the series, if any.
    
    */
    hideToolTips() {
        this.i.ij();
    }
    /**
     * Converts a point from coordinates within the series plot area to a world position within axis space.
    
    * @param seriesPoint  * The pixel location within the plot area of the series.
    *
    * ```ts
    * this.series.toWorldPosition({x:500,y:500});
    * ```
    */
    toWorldPosition(seriesPoint) {
        let iv = this.i.ly(toPoint(seriesPoint));
        return fromPoint(iv);
    }
    /**
     * Converts a point from world coordinates to coordinates within the viewport of the series.
    
    * @param world  * The world position from which to convert.
    *
    * ```ts
    * let pt: IgxPoint = this.series.fromWorldPosition({x:.5,y:.5});
    * ```
    */
    fromWorldPosition(world) {
        let iv = this.i.lq(toPoint(world));
        return fromPoint(iv);
    }
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    *
    * ```ts
    * this.series.scrollIntoView(dataItem);
    * ```
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Renders the series.
    
    * @param animate  * True if the change should be animated.
    *
    * ```ts
    * this.series.renderSeries(true);
    * ```
    */
    renderSeries(animate) {
        this.i.jl(animate);
    }
    /**
     * Gets the effective viewport, adjusted to account for margins and other factors.
    
    */
    getEffectiveViewport() {
        let iv = this.i.getEffectiveViewport();
        return fromRect(iv);
    }
    /**
     * Removes all alternate views of this series.
    
    */
    removeAllAlternateViews() {
        this.i.jf();
    }
    /**
     * Removes an alternate view of this series.
    
    * @param viewIdentifier  * The string identifier for the view to remove.
    */
    removeAlternateView(viewIdentifier) {
        this.i.jh(viewIdentifier);
    }
    /**
     * Replays the assigned transition in animation, if any.
    
    *
    * ```ts
    * this.series.replayTransitionIn();
    * ```
    */
    replayTransitionIn() {
        this.i.jo();
    }
    /**
     * Call to null out the axes of the series;
    
    */
    removeAxes() {
        this.i.ji();
    }
    /**
     * Simulates a pointer hover over the series surface.
    
    * @param point  * The pointer position relative to the series viewport over which to hover.
    *
    * When tooltips are enabled, `simulateHover` can be used to automatically display the tooltip over a particular series item.
    *
    * ```ts
    * this.series.simulateHover({x:250,y:250});
    * ```
    */
    simulateHover(point) {
        this.i.js(toPoint(point));
    }
    /**
     * Called when this series' Style is updated.
    
    */
    styleUpdated() {
        this.i.ju();
    }
    setNegativeColors(negativeBrush, negativeOutline) {
        this.i.jq(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    }
    /**
     * Moves the cursor point to the provided world position. Some series may react to the current cursor position.
    
    * @param point  * The cursor point, in world coordinates.
    *
    * `moveCursorPoint` can be used on annotation layers to programitically show the annotation at the given point.
    *
    * ```ts
    * this.crosshair.moveCursorPoint({x:.5,y:.5});
    * ```
    */
    moveCursorPoint(point) {
        this.i.il(toPoint(point));
    }
    /**
     * This event is raised every time a render has been requested from a series.
    */
    get renderRequested() {
        if (this._renderRequested == null) {
            this._renderRequested = new EventEmitter();
            this.i.renderRequested = delegateCombine(this.i.renderRequested, (o, e) => {
                let outerArgs = new IgxRenderRequestedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeRenderRequested) {
                    this.beforeRenderRequested(this, outerArgs);
                }
                this._renderRequested.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._renderRequested;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "name", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "legend", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxSeriesComponent.prototype, "tooltipTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxSeriesComponent.prototype, "tooltipContainerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "legendItemVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "legendItemBadgeTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "legendItemTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "discreteLegendItemTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxSeriesComponent.prototype, "transitionEasingFunction", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxSeriesComponent.prototype, "transitionInEasingFunction", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "transitionDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "resolution", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "title", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "brush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "actualBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "outline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "actualOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "thickness", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "isHighlightingEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "isDropShadowEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "shadowBlur", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesComponent.prototype, "shadowColor", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "useSingleShadow", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "shadowOffsetX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "shadowOffsetY", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "areaFillOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "actualAreaFillOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "isDefaultToolTipSelected", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "showDefaultTooltip", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "transitionInDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "transitionInSpeedType", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "mouseOverEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesComponent.prototype, "coercionMethods", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesComponent.prototype, "expectFunctions", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "hitTestMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "actualHitTestMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "finalValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "percentChange", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "opacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesComponent.prototype, "visibility", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesComponent.prototype, "renderRequested", null);

/**
 * Represents the base class for annotation layer types. Annotations will usually disable some of the default hover/touch behaviors of the chart when they are introduced to the series collection.
 * In return they provide some valuable information as the cursor is moved by hovering over the chart, or performing a press-hold-drag interaction in touch mode.
*/
const IgxAnnotationLayerComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAnnotationLayerComponent) }];
class IgxAnnotationLayerComponent extends IgxSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets whether this series should take up an index for auto brush coloring.
    */
    get useIndex() {
        return this.i.mk;
    }
    set useIndex(v) {
        this.i.mk = ensureBool(v);
    }
    /**
     * Gets or sets whether this series interacts with the chart legend.
    */
    get useLegend() {
        return this.i.ml;
    }
    set useLegend(v) {
        this.i.ml = ensureBool(v);
    }
    /**
     * Gets or sets the world position to use instead of the pointer position for this annotation layer. If you set this value, rather than responding to the pointer, this layer will be fixed on the provided world position.
     * A world position has x and y values that range from 0 to 1 that represent the global position of the cursor relative to the entire ranges of the axes. The default of (NaN, NaN) means that the layer should react to pointer movement.
    */
    get cursorPosition() {
        return fromPoint(this.i.nc);
    }
    set cursorPosition(v) {
        this.i.nc = toPoint(v);
    }
    /**
     * Gets or sets whether the series viewer's default crosshair should be disabled by the presence of this layer.
    */
    get isDefaultCrosshairDisabled() {
        return this.i.mf;
    }
    set isDefaultCrosshairDisabled(v) {
        this.i.mf = ensureBool(v);
    }
    /**
     * Gets whether or not the default crosshair behavior is disabled.
    */
    get isDefaultCrosshairBehaviorDisabled() {
        return this.i.cm;
    }
    /**
     * Gets if the series uses an index, which can be used to auto-assign it a color.
    */
    get isIndexed() {
        return this.i.cw;
    }
    /**
     * Gets if the series should appear in any legends.
    */
    get isUsableInLegend() {
        return this.i.isUsableInLegend;
    }
    /**
     * Gets whether this series is an annotation layer.
    */
    get isAnnotationLayer() {
        return this.i.cj;
    }
    /**
     * Gets or sets whether this layer renders as an overlay or not.
    */
    get shouldRenderAsOverlay() {
        return this.i.mj;
    }
    set shouldRenderAsOverlay(v) {
        this.i.mj = ensureBool(v);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAnnotationLayerComponent.prototype, "useIndex", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAnnotationLayerComponent.prototype, "useLegend", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxAnnotationLayerComponent.prototype, "cursorPosition", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAnnotationLayerComponent.prototype, "isDefaultCrosshairDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxAnnotationLayerComponent.prototype, "shouldRenderAsOverlay", null);

var IgxCategoryToolTipLayerComponent_1;
/**
 * Represents an annotation layer that displays grouped tooltips for series that use a category axis.
*/
const IgxCategoryToolTipLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryToolTipLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryToolTipLayerComponent) }];
let IgxCategoryToolTipLayerComponent = IgxCategoryToolTipLayerComponent_1 = class IgxCategoryToolTipLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CategoryToolTipLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    get isDefaultTooltipBehaviorDisabled() {
        return this.i.cn;
    }
    /**
     * Gets or sets the Axis to target this annotation to. If null, this annotation layer will not render content.
    */
    get targetAxis() {
        if (this.i.ne == null) {
            return null;
        }
        if (!this.i.ne.externalObject) {
            let e = IgxAxisComponent._createFromInternal(this.i.ne);
            if (e) {
                e._implementation = this.i.ne;
            }
            this.i.ne.externalObject = e;
        }
        return this.i.ne.externalObject;
    }
    set targetAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ne = null : this.i.ne = v.i;
    }
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    get useInterpolation() {
        return this.i.ni;
    }
    set useInterpolation(v) {
        this.i.ni = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetAxis && this.targetAxis.name && this.targetAxis.name == name) {
            return this.targetAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetAxis && this.targetAxis._styling) {
            this.targetAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips() {
        this.i.ij();
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxAxisComponent),
    __metadata("design:paramtypes", [IgxAxisComponent])
], IgxCategoryToolTipLayerComponent.prototype, "targetAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryToolTipLayerComponent.prototype, "useInterpolation", null);
IgxCategoryToolTipLayerComponent = IgxCategoryToolTipLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-category-tool-tip-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryToolTipLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryToolTipLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryToolTipLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryToolTipLayerModule = class IgxCategoryToolTipLayerModule {
};
IgxCategoryToolTipLayerModule = __decorate([
    NgModule({
        declarations: [IgxCategoryToolTipLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxCategoryToolTipLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxCategoryToolTipLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryToolTipLayerDynamicModule = class IgxCategoryToolTipLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryToolTipLayerComponent", IgxCategoryToolTipLayerComponent);
        TypeRegistrar.register("CategoryToolTipLayer", CategoryToolTipLayer.$type);
    }
};
IgxCategoryToolTipLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryToolTipLayerModule],
        exports: [IgxCategoryToolTipLayerModule],
        entryComponents: [IgxCategoryToolTipLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryToolTipLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryToolTipCollisionInfo extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.c = 0;
        this.b = 0;
        this.a = 0;
    }
}
CategoryToolTipCollisionInfo.$t = markType(CategoryToolTipCollisionInfo, 'CategoryToolTipCollisionInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemTooltipLayerFrame extends Frame {
    constructor() {
        super();
        this.o = null;
        this.n = null;
        this.g = null;
        this.f = null;
        this.l = null;
        this.j = null;
        this.i = null;
        this.m = null;
        this.k = null;
        this.h = null;
        this.o = new List$1(Number_$type, 0);
        this.n = new List$1(Number_$type, 0);
        this.g = new List$1(Number_$type, 0);
        this.f = new List$1(Number_$type, 0);
        this.l = new List$1(Base.$, 0);
        this.j = new List$1(Base.$, 0);
        this.i = new List$1(Base.$, 0);
        this.m = new List$1(Number_$type, 0);
        this.k = new List$1(Number_$type, 0);
        this.h = new List$1(Brush.$, 0);
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        Frame.b(this.o, a, d.o, e.o);
        Frame.b(this.n, a, d.n, e.n);
        Frame.b(this.g, a, d.g, e.g);
        Frame.b(this.f, a, d.f, e.f);
        Frame.b(this.m, a, d.m, e.m);
        Frame.b(this.k, a, d.k, e.k);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        InterpolationUtil.c(Base.$, this.l, a, d.l, e.l, () => null, (f, g, h, i) => i);
        InterpolationUtil.c(Base.$, this.j, a, d.j, e.j, () => null, (f, g, h, i) => i);
        InterpolationUtil.c(Base.$, this.i, a, d.i, e.i, () => null, (f, g, h, i) => i);
    }
}
ItemTooltipLayerFrame.$t = markType(ItemTooltipLayerFrame, 'ItemTooltipLayerFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemTooltipCollisionInfo extends Base {
    constructor() {
        super(...arguments);
        this.e = null;
        this.d = 0;
        this.c = 0;
        this.a = 0;
        this.b = 0;
    }
}
ItemTooltipCollisionInfo.$t = markType(ItemTooltipCollisionInfo, 'ItemTooltipCollisionInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemToolTipLayer extends AnnotationLayer {
    constructor() {
        super();
        let a = new ItemTooltipLayerFrame();
        let b = new ItemTooltipLayerFrame();
        let c = new ItemTooltipLayerFrame();
        let d = this.fi / 1000;
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = ItemToolTipLayer.$;
    }
    bf() {
        return new ItemToolTipLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.ne = a;
    }
    get_cn() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ItemToolTipLayer.$$p[1]:
                this.jl(true);
                break;
            case ItemToolTipLayer.$$p[2]:
                this.jl(true);
                break;
            case ItemToolTipLayer.$$p[0]:
                this.jl(true);
                break;
        }
    }
    mv(a, b) {
        if (this.nf == null || this.nf == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mi(a) {
        if (!super.mi(a)) {
            return false;
        }
        let b = this.mq(a);
        if (!b.c) {
            return false;
        }
        return true;
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        let d = this.ne.b2;
        let e = this.ni;
        let f = this.nh;
        c.o.clear();
        c.i.clear();
        c.n.clear();
        c.g.clear();
        c.f.clear();
        c.l.clear();
        c.j.clear();
        c.m.clear();
        c.k.clear();
        c.h.clear();
        if (isNaN_(this.nb.x) && isNaN_(this.nb.y)) {
            d.count = 0;
            return;
        }
        let g = 0;
        if (this.mi(this.nf)) {
            this.no(this.nf, c, e, f, 0);
            g++;
        }
        else {
            for (let h of fromEnum(this.bs.series)) {
                if (this.mi(h)) {
                    this.no(h, c, e, f, g);
                    g++;
                }
            }
            this.nn(c);
        }
        d.count = g;
    }
    nn(a) {
        let b = new List$1(ItemTooltipCollisionInfo.$, 0);
        for (let c = 0; c < a.f.count; c++) {
            let d = new ItemTooltipCollisionInfo();
            d.d = c;
            d.e = { $type: Point_$type, x: a.f._inner[c], y: a.g._inner[c] };
            d.c = a.m._inner[c];
            d.a = a.k._inner[c];
            d.b = a.o._inner[c];
            if (isNaN_(d.e.x) || isNaN_(d.e.y)) {
                continue;
            }
            b.add(d);
        }
        b.aa((e, f) => {
            if (e.e.y < f.e.y) {
                return -1;
            }
            if (e.e.y > f.e.y) {
                return 1;
            }
            if (e.b < f.b) {
                return -1;
            }
            if (e.b > f.b) {
                return 1;
            }
            return 0;
        });
        let e = this.ng(b);
        if (!e) {
            return;
        }
        for (let f = 0; f < b.count - 1; f++) {
            let g = b._inner[f];
            let h = b._inner[f + 1];
            let i = new Rect(0, g.e.x, g.e.y, g.c, g.a);
            let j = new Rect(0, h.e.x, h.e.y, h.c, h.a);
            if (i.intersectsWith(j) || i.top > j.bottom) {
                h.e = { $type: Point_$type, x: h.e.x, y: i.bottom + 1 };
            }
        }
        if (b._inner[b.count - 1].e.y + b._inner[b.count - 1].a > this.bi.br.height) {
            b._inner[b.count - 1].e = { $type: Point_$type, x: b._inner[b.count - 1].e.x, y: b._inner[b.count - 1].e.y - ((b._inner[b.count - 1].e.y + b._inner[b.count - 1].a) - this.bi.br.height) };
        }
        for (let k = b.count - 1; k >= 1; k--) {
            let l = b._inner[k];
            let m = b._inner[k - 1];
            let n = new Rect(0, l.e.x, l.e.y, l.c, l.a);
            let o = new Rect(0, m.e.x, m.e.y, m.c, m.a);
            if (n.intersectsWith(o) || n.top < o.bottom) {
                m.e = { $type: Point_$type, x: m.e.x, y: n.top - (o.height + 1) };
            }
        }
        for (let p = 0; p < b.count; p++) {
            let q = b._inner[p].d;
            let r = b._inner[p];
            a.f._inner[q] = r.e.x;
            a.g._inner[q] = r.e.y;
        }
    }
    ng(a) {
        if (a.count <= 1) {
            return false;
        }
        let b = this.bi.br;
        for (let c = 0; c < a.count - 1; c++) {
            let d = a._inner[c];
            let e = a._inner[c + 1];
            let f = new Rect(0, d.e.x, d.e.y, d.c, d.a);
            let g = new Rect(0, e.e.x, e.e.y, e.c, e.a);
            if (f.intersectsWith(g)) {
                return true;
            }
        }
        return false;
    }
    no(a, b, c, d, e) {
        let f = this.mq(a);
        if (!f.c) {
            return;
        }
        let g = a.lv(f.d, c, d);
        let h = this.ne.b2;
        let i = this.nj(a);
        let j = this.nb;
        if (!c) {
            j = this.ly(g);
        }
        let k = a.fp(j);
        let l = h.item(e);
        let m = this.bi.br;
        let n = null;
        if (a.co && k != null) {
            n = a.as(k);
        }
        else {
            n = new DataContext();
            n.item = k;
            n.series = a;
        }
        if (!this.ne.b3(a, l, i, n)) {
            return;
        }
        let o = this.ne.cd(l, i, n);
        b.i.add1(l);
        b.j.add1(n);
        b.l.add1(i);
        let p = g.x;
        let q = g.x;
        q = Math.max(q, m.left);
        q = Math.min(q, m.right);
        b.n.add(q);
        let r = g.y;
        r = Math.max(r, m.top);
        r = Math.min(r, m.bottom);
        b.o.add(r);
        let s = DeviceUtils.g(10);
        let t = g.x + s;
        if (t + o.width > m.right) {
            t = (p - o.width) - s;
        }
        if (t < m.left) {
            t = m.left;
        }
        b.f.add(t);
        let u = (g.y - o.height) - s;
        if (u + o.height > m.bottom) {
            u = (m.bottom - o.height) - s;
        }
        if (u < m.top) {
            u = m.top;
        }
        b.g.add(u);
        b.m.add(o.width);
        b.k.add(o.height);
        let v = this.lb;
        if (v == null) {
            v = this.ld;
        }
        if (v == null) {
            v = a.lb;
        }
        b.h.add(v);
    }
    nj(a) {
        return a.toolTip;
    }
    ij() {
        this.nb = { $type: Point_$type, x: NaN, y: NaN };
        this.ne.cb();
    }
    m0(a, b) {
        super.m0(a, b);
        let c = a;
        let d = c.o.count;
        let e = b.br.left;
        let f = b.br.right;
        let g = b.br.top;
        let h = b.br.bottom;
        for (let i = 0; i < d; i++) {
            if (isNaN_(c.n._inner[i]) || isNaN_(c.o._inner[i]) || isNaN_(c.f._inner[i]) || isNaN_(c.g._inner[i]) || c.l._inner[i] == null || c.j._inner[i] == null) {
                this.ne.ca(c.i._inner[i]);
                continue;
            }
            let j = c.f._inner[i];
            let k = c.g._inner[i];
            let l = c.m._inner[i];
            let m = c.k._inner[i];
            let n = false;
            if (j < e && Math.abs(j - e) > 1) {
                n = true;
            }
            if (k < g && Math.abs(k - g) > 1) {
                n = true;
            }
            if ((j + l) > f && Math.abs((j + l) - f) > 1) {
                n = true;
            }
            if ((k + m) > h && Math.abs((k + m) - h) > 1) {
                n = true;
            }
            if (n) {
                this.ne.ca(c.i._inner[i]);
                continue;
            }
            let o = c.i._inner[i];
            let p = Math.min(c.f._inner[i], c.n._inner[i]);
            let q = Math.min(c.g._inner[i], c.o._inner[i]);
            let r = c.n._inner[i] - c.f._inner[i];
            let s = c.o._inner[i] - c.g._inner[i];
            this.ne.cc(o, p, q, r, s);
        }
    }
    c8() {
        return true;
    }
}
ItemToolTipLayer.$t = markType(ItemToolTipLayer, 'ItemToolTipLayer', AnnotationLayer.$);
ItemToolTipLayer.$$p = markDep(DependencyProperty, PropertyMetadata, ItemToolTipLayer, 'raisePropertyChanged', ['SkipUnknownValues:nh:np', [0, true], 'TargetSeries:nf:nq', [Series.$, null], 'UseInterpolation:ni:nr', [0, false]]);
/**
 * @hidden
 */
class ItemToolTipLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this.b4 = null;
        this._htmlTest = null;
        this.b1 = a;
        this.b4 = new List$1(PointerTooltip.$, 0);
    }
    ap() {
        super.ap();
        this.b2 = ((() => {
            let $ret = new Pool$1(Base.$);
            $ret.create = runOn(this, this.b5);
            $ret.activate = runOn(this, this.b7);
            $ret.disactivate = runOn(this, this.b9);
            $ret.destroy = runOn(this, this.b8);
            return $ret;
        })());
        this.htmlTest = /^[^<]*(<[\w\W]+>)[^>]*$/;
    }
    ag() {
        super.ag();
        for (let a = 0; a < this.b2.a.count; a++) {
            this.b2.a._inner[a].bo();
        }
        for (let b = 0; b < this.b2.b.count; b++) {
            this.b2.b._inner[b].bo();
        }
        this.b2.clear();
    }
    b5() {
        let a = new PointerTooltip();
        a.bs(this.e.e4);
        a._visibility = 1;
        a.ao = this.e.bs.b1.j;
        this.b4.add(a);
        return a;
    }
    b7(a) {
        let b = a;
    }
    b9(a) {
        let b = a;
        b._visibility = 1;
    }
    b8(a) {
        let b = a;
        b.bv();
        b.content = null;
        this.b4.remove1(a);
    }
    get htmlTest() {
        return this._htmlTest;
    }
    set htmlTest(a) {
        this._htmlTest = a;
    }
    b3(a, b, c, d) {
        let e = b;
        if (a.fz == "default") {
            a.fz = a.bi.getDefaultTooltipTemplate();
        }
        let template_ = a.fz;
        let context_ = d;
        if (a.toolTip == null) {
            return false;
        }
        let tooltip_ = a.toolTip;
        if ((tooltip_.updateToolTip)) {
            tooltip_._inPointer = true;
            tooltip_.updateToolTip(context_, true);
            tooltip_.setStyleProperty('position', 'relative');
            tooltip_.setStyleProperty('left', '');
            tooltip_.setStyleProperty('top', '');
        }
        e.content = a.toolTip;
        return true;
    }
    cd(a, b, c) {
        let d = a;
        let e = d.content;
        let f = new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY);
        d.ct = 1;
        let g = d.cs(new Size(1, Number.POSITIVE_INFINITY, Number.POSITIVE_INFINITY));
        d.ct = 0;
        return g;
    }
    cc(a, b, c, d, e) {
        let f = null;
        if (this.e.bs != null) {
            f = this.e.bs.b1.i.i();
        }
        let g = a;
        g.ap = f;
        let h = g.content;
        g.cn = { $type: Point_$type, x: d, y: e };
        g._visibility = 0;
        g.n = b;
        g.o = c;
    }
    ca(a) {
        if (a != null) {
            let b = a;
            b._visibility = 1;
        }
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            return;
        }
        let c = 0;
        let d = 0;
        let e = this.e.bs;
        if (e != null) {
            let f = e.b1.i.b7();
            c += f.x;
            d += f.y;
        }
        for (let g = 0; g < this.b4.count; g++) {
            this.b4._inner[g].bu(this.b4._inner[g].n + c, this.b4._inner[g].o + d);
        }
    }
    ai(a) {
        super.ai(a);
        for (let tooltip_ of fromEnum(this.b2.a)) {
            if (tooltip_._visibility != 0) {
                continue;
            }
            let b = tooltip_;
            let c = b.a3();
            let d = b.n;
            let e = b.o;
            let f = new List$1(String_$type, 0);
            let g = typeCast(DomWrapper_$type, b.content);
            if (g != null) {
                let h = g.getText();
                f.add(h);
            }
            this.e.a2.addPointerTooltipData(a, c, d, e, f);
        }
    }
    cb() {
        for (let a = 0; a < this.b4.count; a++) {
            this.ca(this.b4._inner[a]);
        }
    }
}
ItemToolTipLayerView.$t = markType(ItemToolTipLayerView, 'ItemToolTipLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxItemToolTipLayerComponent_1;
/**
 * Represents an annotation layer that displays tooltips for all target series individually.
*/
const IgxItemToolTipLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxItemToolTipLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxItemToolTipLayerComponent) }];
let IgxItemToolTipLayerComponent = IgxItemToolTipLayerComponent_1 = class IgxItemToolTipLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ItemToolTipLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the default tooltip behaviors for the chart are disabled if this layer is present.
    */
    get isDefaultTooltipBehaviorDisabled() {
        return this.i.cn;
    }
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries() {
        if (this.i.nf == null) {
            return null;
        }
        if (!this.i.nf.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.nf);
            if (e) {
                e._implementation = this.i.nf;
            }
            this.i.nf.externalObject = e;
        }
        return this.i.nf.externalObject;
    }
    set targetSeries(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nf = null : this.i.nf = v.i;
    }
    /**
     * Gets or sets whether to use value interpolation when drawing the tooltips.
    */
    get useInterpolation() {
        return this.i.ni;
    }
    set useInterpolation(v) {
        this.i.ni = ensureBool(v);
    }
    /**
     * Gets or sets whether to skip past unknown values when searching for series values.
    */
    get skipUnknownValues() {
        return this.i.nh;
    }
    set skipUnknownValues(v) {
        this.i.nh = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
            return this.targetSeries;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Hides any tooltips presented by the layer, if any.
    
    */
    hideToolTips() {
        this.i.ij();
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxSeriesComponent),
    __metadata("design:paramtypes", [IgxSeriesComponent])
], IgxItemToolTipLayerComponent.prototype, "targetSeries", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxItemToolTipLayerComponent.prototype, "useInterpolation", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxItemToolTipLayerComponent.prototype, "skipUnknownValues", null);
IgxItemToolTipLayerComponent = IgxItemToolTipLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-item-tool-tip-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxItemToolTipLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxItemToolTipLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxItemToolTipLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxItemToolTipLayerModule = class IgxItemToolTipLayerModule {
};
IgxItemToolTipLayerModule = __decorate([
    NgModule({
        declarations: [IgxItemToolTipLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxItemToolTipLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxItemToolTipLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxItemToolTipLayerDynamicModule = class IgxItemToolTipLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxItemToolTipLayerComponent", IgxItemToolTipLayerComponent);
        TypeRegistrar.register("ItemToolTipLayer", ItemToolTipLayer.$type);
    }
};
IgxItemToolTipLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxItemToolTipLayerModule],
        exports: [IgxItemToolTipLayerModule],
        entryComponents: [IgxItemToolTipLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxItemToolTipLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisAnnotationFrame extends Frame {
    constructor() {
        super();
        this.n = null;
        this.h = null;
        this.g = null;
        this.m = null;
        this.j = null;
        this.l = null;
        this.k = null;
        this.i = null;
        this.y = null;
        this.s = null;
        this.r = null;
        this.x = null;
        this.u = null;
        this.w = null;
        this.v = null;
        this.t = null;
        this.p = null;
        this.aa = null;
        this.o = null;
        this.z = null;
        this.f = null;
        this.q = null;
        this.n = new List$1(Brush.$, 0);
        this.g = new List$1(Brush.$, 0);
        this.h = new List$1(Brush.$, 0);
        this.j = new List$1(Number_$type, 0);
        this.k = new List$1(Number_$type, 0);
        this.l = new List$1(Number_$type, 0);
        this.i = new List$1(Number_$type, 0);
        this.m = new List$1(Number_$type, 0);
        this.y = new List$1(Brush.$, 0);
        this.r = new List$1(Brush.$, 0);
        this.s = new List$1(Brush.$, 0);
        this.u = new List$1(Number_$type, 0);
        this.v = new List$1(Number_$type, 0);
        this.w = new List$1(Number_$type, 0);
        this.t = new List$1(Number_$type, 0);
        this.x = new List$1(Number_$type, 0);
        this.f = new List$1(Axis.$, 0);
        this.q = new List$1(Axis.$, 0);
        this.p = new List$1(Number_$type, 0);
        this.o = new List$1(Number_$type, 0);
        this.aa = new List$1(Number_$type, 0);
        this.z = new List$1(Number_$type, 0);
    }
    static ab(a, b, c, d) {
        let e = c.count;
        let f = d.count;
        let g = Math.max(e, f);
        let h = 1 - b;
        if (a.count < g) {
            let i = new Array(g - a.count);
            for (let j = 0; j < g - a.count; j++) {
                i[j] = null;
            }
            a.s(a.count, i);
        }
        if (a.count > g) {
            a.v(g, a.count - g);
        }
        for (let k = 0; k < Math.min(e, f); ++k) {
            if (b == 0) {
                a._inner[k] = c._inner[k];
            }
            else {
                a._inner[k] = d._inner[k];
            }
        }
        if (e < f) {
            let l = e > 0 ? c._inner[e - 1] : null;
            for (let m = e; m < f; ++m) {
                if (b == 0) {
                    a._inner[m] = l;
                }
                else {
                    a._inner[m] = d._inner[m];
                }
            }
        }
        if (e > f) {
            let n = f > 0 ? d._inner[f - 1] : null;
            for (let o = f; o < e; ++o) {
                if (b == 0) {
                    a._inner[o] = c._inner[o];
                }
                else {
                    a._inner[o] = n;
                }
            }
        }
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        FrameExtended.a(this.n, a, d.n, e.n, 0);
        FrameExtended.a(this.g, a, d.g, e.g, 0);
        FrameExtended.a(this.h, a, d.h, e.h, 0);
        Frame.b(this.j, a, d.j, e.j);
        Frame.b(this.k, a, d.k, e.k);
        Frame.b(this.l, a, d.l, e.l);
        Frame.b(this.i, a, d.i, e.i);
        Frame.b(this.m, a, d.m, e.m);
        FrameExtended.a(this.y, a, d.y, e.y, 0);
        FrameExtended.a(this.r, a, d.r, e.r, 0);
        FrameExtended.a(this.s, a, d.s, e.s, 0);
        Frame.b(this.u, a, d.u, e.u);
        Frame.b(this.v, a, d.v, e.v);
        Frame.b(this.w, a, d.w, e.w);
        Frame.b(this.t, a, d.t, e.t);
        Frame.b(this.x, a, d.x, e.x);
        AxisAnnotationFrame.ab(this.f, a, d.f, e.f);
        AxisAnnotationFrame.ab(this.q, a, d.q, e.q);
    }
}
AxisAnnotationFrame.$t = markType(AxisAnnotationFrame, 'AxisAnnotationFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LinearCategorySnapper extends Snapper {
    constructor(a, ..._rest) {
        super();
        this.g = 0;
        this.h = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = [c, d, e, NaN, 0, f];
                    {
                        let i = g[0];
                        let j = g[1];
                        let k = g[2];
                        let l = g[3];
                        let m = g[4];
                        let n = g[5];
                        if (n > 0) {
                            this.f = n;
                            this.b = true;
                        }
                        this.g = l;
                        this.h = 0;
                        let o = Math.min(10, truncate((k / this.f)));
                        if (o > 0) {
                            let p = this.i(i, j, o);
                            if (this.b && p > o) {
                                this.g = l;
                                p = this.i(i, j, o - 1);
                            }
                            o = p;
                            if (k / o > this.f * 10) {
                                this.h = 10;
                            }
                            else {
                                if (k / o > this.f * 5) {
                                    this.h = 5;
                                }
                                else {
                                    if (k / o > this.f * 2) {
                                        this.h = 2;
                                    }
                                }
                            }
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    let h = _rest[5];
                    if (h > 0) {
                        this.f = h;
                        this.b = true;
                    }
                    this.g = f;
                    this.h = 0;
                    let i = Math.min(10, truncate((e / this.f)));
                    if (i > 0) {
                        let j = this.i(c, d, i);
                        if (this.b && j > i) {
                            this.g = f;
                            j = this.i(c, d, i - 1);
                        }
                        i = j;
                        if (e / i > this.f * 10) {
                            this.h = 10;
                        }
                        else {
                            if (e / i > this.f * 5) {
                                this.h = 5;
                            }
                            else {
                                if (e / i > this.f * 2) {
                                    this.h = 2;
                                }
                            }
                        }
                    }
                }
                break;
        }
    }
    i(a, b, c) {
        let d = Snapper.e(b - a, false);
        if (isNaN_(this.g)) {
            this.g = Snapper.e(d / (c - 1), true);
        }
        if (this.g < 1) {
            this.g = 1;
        }
        let e = Math.floor(a / this.g) * this.g;
        let f = Math.ceil(b / this.g) * this.g;
        let g = truncate(Math.round((f - e) / this.g));
        return g;
    }
}
LinearCategorySnapper.$t = markType(LinearCategorySnapper, 'LinearCategorySnapper', Snapper.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available scaling behaviors of a numeric axis.
 */
var NumericScaleMode;
(function (NumericScaleMode) {
    /**
     * Scale values on a linear number line.
     */
    NumericScaleMode[NumericScaleMode["Linear"] = 0] = "Linear";
    /**
     * Scale values on a logarithmic number line.
     */
    NumericScaleMode[NumericScaleMode["Logarithmic"] = 1] = "Logarithmic";
})(NumericScaleMode || (NumericScaleMode = {}));
/**
 * @hidden
 */
let NumericScaleMode_$type = markEnum('NumericScaleMode', 'Linear,0|Logarithmic,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LogarithmicScaler extends NumericScaler {
    constructor() {
        super(...arguments);
        this.ae = 0;
        this.ad = 0;
    }
    w(a, b, c) {
        super.w(a, b, c);
        switch (a) {
            case NumericScaler.$$p[1]:
                this.ae = Math.log(this.l);
                break;
            case NumericScaler.$$p[0]:
                this.ad = Math.log(this.k);
                break;
        }
    }
    t(a, b, c, d, e) {
        let f;
        let g;
        let h = AutoRangeCalculator.a(a, b, c, true, a.ko, f, g);
        f = h.p5;
        g = h.p6;
        d = f;
        e = g;
        return {
            p3: d,
            p4: e
        };
    }
}
LogarithmicScaler.$t = markType(LogarithmicScaler, 'LogarithmicScaler', NumericScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StraightNumericAxisBase extends NumericAxisBase {
    constructor() {
        super();
        this.lm = null;
        this.lq = false;
        this.l0();
    }
    a3() {
        return new StraightNumericAxisBaseView(this);
    }
    gx(a) {
        super.gx(a);
        this.lp = a;
    }
    get lo() {
        return this.c(StraightNumericAxisBase.l2);
    }
    set lo(a) {
        this.h(StraightNumericAxisBase.l2, a);
    }
    static ly(a, b) {
        let c = typeCast(StraightNumericAxisBase.$, a);
        c.l0();
        c.g5("Scaler", b.oldValue, b.newValue);
    }
    ln() {
        return null;
    }
    get_ll() {
        if (this.lm == null) {
            this.l0();
        }
        return this.lm;
    }
    set_ll(a) {
        let b = this.lm != a;
        if (b) {
            let c = this.lm;
            this.lm = a;
            this.g5("ActualScaler", c, a);
        }
    }
    get ll() {
        return this.get_ll();
    }
    set ll(a) {
        this.set_ll(a);
    }
    k7(a, b, c, d, e, f, g) {
        let h = this.ll.t(a, b, c, f, g);
        f = h.p3;
        g = h.p4;
        return {
            p5: f,
            p6: g
        };
    }
    lz(a) {
        let b = this.lq;
        this.lq = true;
        a();
        this.lq = b;
    }
    l0() {
        let a = this.lo;
        if (a == null) {
            a = this.jq();
        }
        this.ll = a;
        if (this.ll == null) {
            throw new ArgumentNullException(0, "ActualScaler");
        }
        this.lv();
    }
    lv() {
        this.lp.bh();
    }
    gz(a, b, c, d) {
        if (this.lq) {
            return;
        }
        super.gz(a, b, c, d);
        switch (b) {
            case NumericAxisBase.$$p[2]:
                this.l0();
                break;
            case NumericAxisBase.$$p[1]:
                this.l0();
                break;
            case StraightNumericAxisBase.$$p[0]:
                this.l0();
                break;
            case "Scaler":
                this.l0();
                break;
            case "ActualScaler":
                this.jx = typeCast(LogarithmicScaler.$, this.ll) !== null;
                this.lv();
                this.cn();
                this.hb(false);
                break;
            case "ActualMaximumValue":
                this.lw();
                break;
            case "ActualMinimumValue":
                this.lx();
                this.l0();
                break;
        }
    }
    lx() {
        this.ll.y(this.kc);
    }
    lw() {
        this.ll.x(this.kb);
    }
    lr(a, b) {
        if (a < this.kc) {
            a = this.kc;
        }
        else if (a > this.kb) {
            a = this.kb;
        }
        if (!b.ch) {
            return (a - this.kc) / (this.kb - this.kc);
        }
        else {
            return (a - this.kb) / (this.kc - this.kb);
        }
    }
}
StraightNumericAxisBase.$t = markType(StraightNumericAxisBase, 'StraightNumericAxisBase', NumericAxisBase.$);
StraightNumericAxisBase.l2 = DependencyProperty.i("Scaler", NumericScaler.$, StraightNumericAxisBase.$, new PropertyMetadata(2, null, StraightNumericAxisBase.ly));
StraightNumericAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, StraightNumericAxisBase, 'g5', ['ScaleMode:lk:l1', [NumericScaleMode_$type, enumGetBox(NumericScaleMode_$type, 0)]]);
/**
 * @hidden
 */
class StraightNumericAxisBaseView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
    bh() {
        this.bg.ll.x(this.bg.kb);
        this.bg.ll.y(this.bg.kc);
    }
}
StraightNumericAxisBaseView.$t = markType(StraightNumericAxisBaseView, 'StraightNumericAxisBaseView', NumericAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VerticalLogarithmicScaler extends LogarithmicScaler {
    q(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.ag(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ag(a, b.e, b.d, b.a);
    }
    p(a, b) {
        if (!b.c.isEmpty) {
            let c = this.af(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.af(a, b.e, b.d, b.a);
    }
    af(a, b, c, d) {
        if (isNaN_(a)) {
            return NaN;
        }
        let e;
        if (a <= 0) {
            e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
        }
        else {
            e = (Math.log(a) - this.ae) / (this.ad - this.ae);
        }
        if (!d) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    }
    ag(a, b, c, d) {
        let e = b.top + b.height * (a - c.top) / c.height;
        if (!d) {
            e = 1 - e;
        }
        return Math.exp(e * (this.ad - this.ae) + this.ae);
    }
}
VerticalLogarithmicScaler.$t = markType(VerticalLogarithmicScaler, 'VerticalLogarithmicScaler', LogarithmicScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LinearScaler extends NumericScaler {
    t(a, b, c, d, e) {
        let f;
        let g;
        let h = AutoRangeCalculator.a(a, b, c, false, -1, f, g);
        f = h.p5;
        g = h.p6;
        d = f;
        e = g;
        return {
            p3: d,
            p4: e
        };
    }
}
LinearScaler.$t = markType(LinearScaler, 'LinearScaler', NumericScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VerticalLinearScaler extends LinearScaler {
    q(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.ae(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ae(a, b.e, b.d, b.a);
    }
    p(a, b) {
        if (!b.c.isEmpty) {
            let c = this.ad(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.ad(a, b.e, b.d, b.a);
    }
    v(a, b, c, d) {
        let e;
        let f = d.e;
        let g = d.d;
        let h = d.c;
        let i = d.a;
        let j = !h.isEmpty;
        let k = this.m;
        let l = this.o;
        let m = h.top;
        let n = h.height;
        let o = f.top;
        let p = f.height;
        let q = g.top;
        let r = g.height;
        let s = 0;
        let t = 1;
        let u = ArrayAccessHelper.b(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        for (let w = b; w < c; w++) {
            if (v) {
                e = u[w];
            }
            else {
                e = a.item(w);
            }
            if (j) {
                let x = (e - l) / (k);
                if (!i) {
                    x = 1 - x;
                }
                x = m + n * (x - s) / t;
                let y = (x - (o * r)) / p;
                if (v) {
                    u[w] = y;
                }
                else {
                    a.item(w, y);
                }
            }
            else {
                let z = (e - l) / (k);
                if (!i) {
                    z = 1 - z;
                }
                z = q + r * (z - o) / p;
                if (v) {
                    u[w] = z;
                }
                else {
                    a.item(w, z);
                }
            }
        }
    }
    ad(a, b, c, d) {
        let e = (a - this.o) / (this.m);
        if (!d) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    }
    ae(a, b, c, d) {
        let e = b.top + b.height * (a - c.top) / c.height;
        if (!d) {
            e = 1 - e;
        }
        return this.o + e * (this.m);
    }
}
VerticalLinearScaler.$t = markType(VerticalLinearScaler, 'VerticalLinearScaler', LinearScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FastVerticalLinearScaler extends VerticalLinearScaler {
    u(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.m;
        let m = this.o;
        let n = i.top;
        let o = i.height;
        let p = g.top;
        let q = g.height;
        let r = h.top;
        let s = h.height;
        let t = 0;
        let u = 1;
        let v = ArrayAccessHelper.a(a);
        let w = false;
        if (v != null) {
            w = true;
        }
        let x;
        for (let y = 0; y < b.count; y++) {
            x = b.item(y);
            for (let z = c; z < d; z++) {
                if (w) {
                    f = v[z];
                }
                else {
                    f = a.item(z);
                }
                if (k) {
                    let aa = (f[x] - m) / (l);
                    if (!j) {
                        aa = 1 - aa;
                    }
                    aa = n + o * (aa - t) / u;
                    let ab = (aa - (p * s)) / q;
                    f[x] = ab;
                }
                else {
                    let ac = (f[x] - m) / (l);
                    if (!j) {
                        ac = 1 - ac;
                    }
                    ac = r + s * (ac - p) / q;
                    f[x] = ac;
                }
            }
        }
    }
}
FastVerticalLinearScaler.$t = markType(FastVerticalLinearScaler, 'FastVerticalLinearScaler', VerticalLinearScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumericYAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericYAxis.$;
        this.jn = this.jl();
    }
    a3() {
        return new NumericYAxisView(this);
    }
    au() {
        return new VerticalAxisLabelPanel();
    }
    get_ch() {
        return true;
    }
    dx() {
        return this.i9.height;
    }
    dy(a, b) {
        if (this.lm != null) {
            return this.lm.p(a, b);
        }
        return this.ll.p(a, b);
    }
    gs(a, b, c, d) {
        if (this.lm != null) {
            this.lm.v(a, b, c, d);
            return;
        }
        this.ll.v(a, b, c, d);
    }
    gr(a, b, c, d, e) {
        if (this.lm != null) {
            this.lm.u(a, b, c, d, e);
            return;
        }
        this.ll.u(a, b, c, d, e);
    }
    d1(a, b) {
        if (this.lm != null) {
            return this.lm.q(a, b);
        }
        return this.ll.q(a, b);
    }
    gt(a, b, c, d) {
        if (this.lm != null) {
            this.lm.j(a, b, c, d);
            return;
        }
        this.ll.j(a, b, c, d);
    }
    l3(a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.lr(a, this);
        let d = this.lr(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.oi = new Rect(0, this.bh.oi.x, d, this.bh.oi.width, c - d);
    }
    jl() {
        let a = super.jl();
        a.b.c = (b) => {
            if (this.ay == null || this.ay.visibility == 0) {
                this.av.a9 = b;
                if (this.ay != null && (this.ay.location == 7 || this.ay.location == 6)) {
                    this.bh.it();
                }
            }
        };
        a.k = (b, c, d) => this.gv(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.gw(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.cb, d);
            return this.dy(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.hl(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = this.ay != null && (this.ay.location == 7 || this.ay.location == 3) ? b.z.right : b.z.left;
            let c = b.y;
            let d = new ScalerParams(0, b.aa, b.z, this.cb, c);
            if (this.ai != null && this.ai.bh != null) {
                let e = b.n;
                let f = b.r;
                let g = this.hg(e, f, b.aa, b.z, b.y, b.z.left, b.z.right);
                e = g.p0;
                f = g.p1;
                b.n = e;
                b.r = f;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.top) && e <= Math.ceil(b.z.bottom);
        };
        return a;
    }
    jo(a, b, c, d) {
        let e = d;
        let f = super.jo(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.ca, c);
        let h = NaN;
        let i = NaN;
        if (!this.ca && b.top == 0) {
            i = this.kb;
        }
        else if (this.ca && b.bottom == 1) {
            h = this.kb;
        }
        if (isNaN_(h)) {
            h = this.d1(e.bottom, g);
        }
        if (isNaN_(i)) {
            i = this.d1(e.top, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.kf = j;
        this.ke = k;
        let l = ((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.height;
            return $ret;
        })());
        f.k.add(l);
        return f;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = this.i9;
        let d = this.i4();
        let e = this.i3();
        let f = this.jn.c(a, c, b, d, e);
        if (f != null) {
            this.ka = f.f.m;
            this.kd = f.f.l;
        }
    }
    hn(a, b) {
        super.hn(a, b);
        if (b.height != a.height) {
            this.cn();
        }
    }
    get_a1() {
        return 1;
    }
    get a1() {
        return this.get_a1();
    }
    jq() {
        if (this.j1) {
            return new VerticalLogarithmicScaler();
        }
        switch (this.lk) {
            case 0: return new FastVerticalLinearScaler();
            case 1: return new VerticalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
NumericYAxis.$t = markType(NumericYAxis, 'NumericYAxis', StraightNumericAxisBase.$, [IScaler_$type]);
/**
 * @hidden
 */
class NumericYAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bi = null;
        this.bi = a;
    }
}
NumericYAxisView.$t = markType(NumericYAxisView, 'NumericYAxisView', StraightNumericAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryXAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.lh = 1;
        this.lg = 1;
        this.lk = null;
        this.k7 = 0;
        this.k8 = 0;
        this.ju = new List$1(Number_$type, 0);
        this.ab = CategoryXAxis.$;
    }
    a3() {
        return new CategoryXAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.k5 = a;
    }
    get lj() {
        return this.lh;
    }
    set lj(a) {
        this.lh = a;
    }
    get li() {
        return this.lg;
    }
    set li(a) {
        this.lg = a;
    }
    au() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    getCategorySize(a, b, c) {
        let d = this.i7(b, c);
        return d.width / (this.j7 * a.width);
    }
    jz(a, b, c) {
        let d = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.j3)) {
            e = Math.min(this.j3, 1);
        }
        else {
            e = 0;
        }
        ;
        let f = 1 - 0.5 * d;
        let g = this.j9 == 0 ? 1 : this.j9;
        let h = this.getCategorySize(a, b, c) * f / (g - (g - 1) * e);
        return h;
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.j9 > 1) {
            let f = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.j3)) {
                g = Math.min(this.j3, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.j9 - (this.j9 - 1) * g);
            let j = (h - i) / (this.j9 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    dl() {
        return this.le;
    }
    lp(a) {
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        b = b.copy();
        let c = this.i9;
        let d = this.i6();
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, e, e, this.ca, d);
        let g = !b.isEmpty && !c.isEmpty && this.jn != null ? this.jn.indexOf(a) : -1;
        let h = g > -1 ? this.dy(g, f) : NaN;
        if (!isNaN_(h) && this.bh.dk) {
            if (!isNaN_(h)) {
                if (h < b.left + 0.1 * b.width) {
                    h = h + 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
                if (h > b.right - 0.1 * b.width) {
                    h = h - 0.4 * b.width;
                    b.x = h - 0.5 * b.width;
                }
            }
            this.bh.lr(b, false, true);
        }
    }
    dy(a, b) {
        if (!b.c.isEmpty) {
            let c = this.ld(a, NumericScaler.ac, b.c, this.categoryMode);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ld(a, b.e, b.d, this.categoryMode);
    }
    k4(a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    }
    gr(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.categoryMode == 0 ? this.j7 - 1 : this.j7;
        if (l < 0) {
            l = 0;
        }
        let m = i.left;
        let n = i.width;
        let o = g.left;
        let p = g.width;
        let q = h.left;
        let r = h.width;
        let s = 0;
        let t = 1;
        let u = this.k4(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        let w;
        for (let x = 0; x < b.count; x++) {
            w = b.item(x);
            for (let y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    let aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    }
    dz(a, b, c) {
        if (!b.c.isEmpty) {
            let d = this.ld(a, NumericScaler.ac, b.c, c);
            d = (d - b.d.left) / b.d.width;
            d = b.d.left + b.d.width * (d - b.e.left) / b.e.width;
            return d;
        }
        return this.ld(a, b.e, b.d, c);
    }
    ld(a, b, c, d) {
        let e = d == 0 ? this.j7 - 1 : this.j7;
        if (e < 0) {
            e = 0;
        }
        let f = e >= 1 ? (a) / (e) : e == 0 ? 0.5 : NaN;
        if (this.cb) {
            f = 1 - f;
        }
        return c.left + c.width * (f - b.left) / b.width;
    }
    d1(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    d2(a, b, c) {
        if (!b.c.isEmpty) {
            let d = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            d = (d * b.d.width) + b.d.left;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + (a - c.left) * b.width / c.width;
        if (this.cb) {
            e = 1 - e;
        }
        let f = d == 0 ? this.j7 - 1 : this.j7;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    }
    lq(a, b) {
        if (a == NaN || b == NaN || this.jn == null || this.jn.count == 0) {
            return;
        }
        let c = a / this.jn.count;
        let d = (b + 1) / this.jn.count;
        this.bh.oi = new Rect(0, c, this.bh.oi.y, d - c, this.bh.oi.height);
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = this.i9;
        let d = this.i4();
        let e = this.i3();
        let f = new ScalerParams(0, b, c, this.ca, d);
        let g = this.a4.ay();
        let h = this.a4.a1();
        let i = this.a4.az();
        let j = this.a4.a0();
        let k = this.a4.e();
        let l = this.a4.f();
        let m = this.a4.g();
        let n = this.jn;
        let o = this.k6();
        this.hk();
        this.gn(g);
        this.gn(h);
        this.gn(i);
        this.gn(j);
        this.cx.clear();
        this.cy.clear();
        this.ju.clear();
        this.a4.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0 && this.bp.count == 0) {
            this.a4.y();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        if (this.itemsSource == null || o == null || n.count == 0) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let p = this.d1(e.left, f);
            let q = this.d1(e.right, f);
            if (this.ca) {
                p = Math.ceil(p);
                q = Math.floor(q);
            }
            else {
                p = Math.floor(p);
                q = Math.ceil(q);
            }
            let r = c.bottom;
            let s = r - c.top;
            if (this.ai != null) {
                let t = typeCast(NumericYAxis.$, this.ai);
                if (t != null) {
                    let u = this.hg(r, s, b, c, d, c.top, c.bottom);
                    r = u.p0;
                    s = u.p1;
                }
            }
            this.gv(g, r, c, k, true);
            this.a4.ao(s);
            let v = Math.min(p, q);
            let w = Math.max(p, q);
            let x = new LinearCategorySnapper(1, v, w, e.width, this.le, this.categoryMode, this.eb());
            let y = Math.floor((v - 0) / x.g);
            let z = Math.ceil((w - 0) / x.g);
            this.k9 = x.g;
            if (!isNaN_(y) && !isNaN_(z)) {
                let aa = truncate(y);
                let ab = truncate(z);
                let ac = this.lc(0 + aa * x.g, f);
                let ad = this.dy(x.g, f);
                let ae = Math.abs(ad - this.dy(0, f));
                this.a4.ap(ad);
                let af = truncate(Math.ceil(e.right));
                let ag = truncate(Math.floor(e.left));
                let ah = this.lf;
                let ai = ah > 0 && ah < x.g;
                let aj = c.right;
                let ak = this.ju;
                let al = x.g;
                let am = truncate(al);
                let an = this.j9;
                let ao = this.ca;
                let ap = this.categoryMode;
                this.lk = null;
                for (let aq = aa; aq <= ab; ++aq) {
                    let ar = this.lc(0 + (aq + 1) * x.g, f);
                    if (ac <= aj) {
                        if (aq % 2 == 0) {
                            this.hm(h, ac, ar, c);
                        }
                        this.hl(i, ac, c, l, false);
                        ak.add(ac);
                    }
                    if (this.categoryMode != 0 && this.j9 != 0 && this.cl) {
                        if (ai) {
                            let as = ae * this.lf;
                            if (this.ca) {
                                let at = ac;
                                while (at - as > ar) {
                                    at -= as;
                                    if (Math.abs(at - ar) < 0.0001) {
                                        break;
                                    }
                                    this.hl(j, at, c, m, false);
                                }
                            }
                            else {
                                let au = ac;
                                while (au + as < ar) {
                                    au += as;
                                    if (Math.abs(au - ar) < 0.0001) {
                                        break;
                                    }
                                    this.hl(j, au, c, m, false);
                                }
                            }
                            this.la = this.lf;
                        }
                        else {
                            for (let av = 0; av < truncate(x.g); av++) {
                                for (let aw = 0; aw < this.j9; aw++) {
                                    let ax = this.getGroupCenter(aw, b, c, d);
                                    if (this.ca) {
                                        ax = -ax;
                                    }
                                    let ay = this.dy(av + aq * x.g, f) + ax;
                                    this.hl(j, ay, c, m, false);
                                }
                            }
                            this.la = 0.5;
                        }
                    }
                    let az = this.lb(aq * al, ac, ap == 0, f);
                    let a0 = truncate(Math.round(az));
                    if (a0 >= ag && a0 <= af) {
                        let a1 = 0;
                        if (al >= 1) {
                            a1 = aq * truncate(Math.floor(al));
                        }
                        else {
                            if ((aq * al) * 2 % 2 == 0) {
                                a1 = truncate(Math.floor(aq * al));
                            }
                            else {
                                a1 = -1;
                            }
                        }
                        if (o != null && a1 < n.count && a1 >= 0) {
                            let a2 = o.getItem(a1);
                            let a3 = this.e8(a2);
                            this.lk = a2;
                            if (!isNaN_(az) && !isInfinity(az) && a3 != null) {
                                if ((typeof a3 === 'string') && Base.equalsStatic(a3, "")) {
                                }
                                else {
                                    this.cx.add1(a3);
                                    this.cy.add(new LabelPosition(az));
                                }
                            }
                        }
                    }
                    ac = ar;
                }
            }
            this.lk = null;
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.it();
                }
            }
            this.a4.au(this.cx, this.cy);
            this.ku();
        }
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jn == null) {
            return false;
        }
        let a = this.jn.count;
        if (a != this.li) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.li, a);
            this.li = a;
            this.g6(b);
            return true;
        }
        return false;
    }
    get le() {
        return this.c(CategoryXAxis.lr);
    }
    set le(a) {
        this.h(CategoryXAxis.lr, a);
    }
    get k9() {
        return this.k7;
    }
    set k9(a) {
        if (this.k9 != a) {
            let b = this.k7;
            this.k7 = a;
            this.g5("ActualInterval", b, this.k9);
        }
    }
    d9() {
        return this.k9;
    }
    get lf() {
        return this.c(CategoryXAxis.ls);
    }
    set lf(a) {
        this.h(CategoryXAxis.ls, a);
    }
    get la() {
        return this.k8;
    }
    set la(a) {
        if (this.la != a) {
            let b = this.k8;
            this.k8 = a;
            this.g5("ActualMinorInterval", b, this.la);
        }
    }
    jq(a) {
        if (a == null) {
            return false;
        }
        let b = this.bd();
        if (b == null) {
            return false;
        }
        return b.synchronizeHorizontally;
    }
    get_a1() {
        return 0;
    }
    get a1() {
        return this.get_a1();
    }
    k6() {
        return this.jn;
    }
    lc(a, b) {
        return this.dy(a, b);
    }
    lb(a, b, c, d) {
        if (!c) {
            let e = this.lc(a + 1, d);
            return (b + e) / 2;
        }
        return b;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryXAxis.$t = markType(CategoryXAxis, 'CategoryXAxis', CategoryAxisBase.$);
CategoryXAxis.lr = DependencyProperty.i("Interval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.g5("Interval", b.oldValue, b.newValue);
    a.hb(false);
}));
CategoryXAxis.ls = DependencyProperty.i("MinorInterval", Number_$type, CategoryXAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryXAxis.$, a)).g5("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryXAxis.$, a)).hb(false);
}));
/**
 * @hidden
 */
class CategoryXAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
CategoryXAxisView.$t = markType(CategoryXAxisView, 'CategoryXAxisView', CategoryAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisAnnotationFrameManager extends Base {
    static e(a, b, c) {
        let d = new Color();
        if (typeCast(LinearGradientBrush.$, a) !== null) {
            if (a.gradientStops == null || a.gradientStops.length < 1) {
                let e = new Brush();
                e.color = b;
                return e;
            }
            d = a.gradientStops[0].color;
        }
        else {
            d = a.color;
        }
        let f = ColorUtil.a(d);
        let g = ColorUtil.a(c);
        let h = ColorUtil.a(b);
        let i = (f[3] + 0.05) / (h[3] + 0.05);
        let j = (g[3] + 0.05) / (f[3] + 0.05);
        if (i > j) {
            let k = new Brush();
            k.color = b;
        }
        let l = new Brush();
        l.color = c;
        return l;
    }
    static c(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r) {
        let s = c.ag();
        let t = null;
        let u = null;
        for (let v = 0; v < s.length; v++) {
            if (s[v].ch) {
                u = s[v];
            }
            else {
                t = s[v];
            }
        }
        let w = Color.u(255, 102, 102, 102);
        let x = Color.u(255, 255, 255, 255);
        if (t != null) {
            let y = new ScalerParams(1, d.n2, t.i9, t.ca);
            y.c = e;
            let z = t.d1(b.x, y);
            a.p.add(z);
            a.o.add(z);
            if (g != null) {
                a.g.add(g);
            }
            else {
                a.g.add(f);
            }
            if (h != null) {
                a.n.add(h);
            }
            else {
                a.n.add(AxisAnnotationFrameManager.e(a.g._inner[a.g.count - 1], w, x));
            }
            a.j.add(j.c);
            a.l.add(j.e);
            a.k.add(j.d);
            a.i.add(j.b);
            if (!isNaN_(k)) {
                a.m.add(k);
            }
            else {
                a.m.add(NaN);
            }
            if (i != null) {
                a.h.add(i);
            }
            else {
                a.h.add(null);
            }
            if (q) {
                a.f.add(t);
            }
            else {
                a.f.add(null);
            }
        }
        if (u != null) {
            let aa = new ScalerParams(1, d.n2, u.i9, u.ca);
            aa.c = e;
            let ab = u.d1(b.y, aa);
            a.aa.add(ab);
            a.z.add(ab);
            if (l != null) {
                a.r.add(l);
            }
            else {
                a.r.add(f);
            }
            if (m != null) {
                a.y.add(m);
            }
            else {
                a.y.add(AxisAnnotationFrameManager.e(a.r._inner[a.r.count - 1], w, x));
            }
            a.u.add(o.c);
            a.w.add(o.e);
            a.v.add(o.d);
            a.t.add(o.b);
            if (!isNaN_(p)) {
                a.x.add(p);
            }
            else {
                a.x.add(NaN);
            }
            if (n != null) {
                a.s.add(n);
            }
            else {
                a.s.add(null);
            }
            if (r) {
                a.q.add(u);
            }
            else {
                a.q.add(null);
            }
        }
    }
    static b(a) {
        a.f.clear();
        a.q.clear();
        a.p.clear();
        a.aa.clear();
        a.o.clear();
        a.z.clear();
        a.g.clear();
        a.h.clear();
        a.j.clear();
        a.l.clear();
        a.k.clear();
        a.i.clear();
        a.m.clear();
        a.n.clear();
        a.r.clear();
        a.s.clear();
        a.u.clear();
        a.w.clear();
        a.v.clear();
        a.t.clear();
        a.x.clear();
        a.y.clear();
    }
    static a(a, b, c) {
        if (!b.cc) {
            return a;
        }
        let d = 0;
        if (c >= 0) {
            d = c;
        }
        else {
            let e = b.d9();
            d = e == 0 ? 0 : truncate(Math.max(-Math.floor(log10(e)), 0));
            d += 1;
        }
        return round10N(a, d);
    }
    static d(a, b, c, d, e, f, g, h, i, j) {
        let k = new List$1(Axis.$, 0);
        let l = new HashSet$1(Axis.$, 0);
        let m = new Dictionary$2(Axis.$, Number_$type, 0);
        for (let n = 0; n < b.p.count; n++) {
            let o = b.f._inner[n];
            if (o != null) {
                if (!l.contains(o)) {
                    k.add(o);
                    m.item(o, 0);
                    l.add_1(o);
                }
                let p;
                if (!d.containsKey(o)) {
                    p = new Pool$1(AxisAnnotation.$);
                    p.create = () => new AxisAnnotation();
                    p.destroy = (q) => {
                    };
                    p.activate = (q) => o.an.add(q);
                    p.disactivate = (q) => o.an.remove(q);
                    d.item(o, p);
                    e.add(o);
                }
                else {
                    p = d.item(o);
                }
                let q = p.item(m.item(o));
                m.item(o, m.item(o) + 1);
                q.k = false;
                q.value = b.o._inner[n];
                let r = b.p._inner[n];
                if (i != null) {
                    let s = i(r);
                    q.text = s;
                }
                else {
                    r = AxisAnnotationFrameManager.a(r, o, g);
                    q.text = o.fl(r);
                }
                q.textColor = b.n._inner[n];
                q.background = b.g._inner[n];
                q.backgroundPadding = new Thickness(1, b.j._inner[n], b.l._inner[n], b.k._inner[n], b.i._inner[n]);
                q.outline = b.h._inner[n];
                q.strokeThickness = b.m._inner[n];
                if (q.k) {
                    q.k = false;
                    c = true;
                }
            }
        }
        for (let t = 0; t < b.aa.count; t++) {
            let u = b.q._inner[t];
            if (u != null) {
                if (!l.contains(u)) {
                    k.add(u);
                    m.item(u, 0);
                    l.add_1(u);
                }
                let v;
                if (!d.containsKey(u)) {
                    v = new Pool$1(AxisAnnotation.$);
                    v.create = () => new AxisAnnotation();
                    v.destroy = (w) => {
                    };
                    v.activate = (w) => u.an.add(w);
                    v.disactivate = (w) => u.an.remove(w);
                    d.item(u, v);
                    e.add(u);
                }
                else {
                    v = d.item(u);
                }
                let w = v.item(m.item(u));
                m.item(u, m.item(u) + 1);
                w.k = false;
                let x = b.aa._inner[t];
                w.value = b.z._inner[t];
                if (j != null) {
                    let y = j(x);
                    w.text = y;
                }
                else {
                    x = AxisAnnotationFrameManager.a(x, u, h);
                    w.text = u.fl(x);
                }
                w.textColor = b.y._inner[t];
                w.background = b.r._inner[t];
                w.backgroundPadding = new Thickness(1, b.u._inner[t], b.w._inner[t], b.v._inner[t], b.t._inner[t]);
                w.outline = b.s._inner[t];
                w.strokeThickness = b.x._inner[t];
                if (w.k) {
                    w.k = false;
                    c = true;
                }
            }
        }
        for (let z = 0; z < k.count; z++) {
            if (d.containsKey(k._inner[z])) {
                let aa = d.item(k._inner[z]);
                aa.count = m.item(k._inner[z]);
            }
        }
        for (let ab = e.count - 1; ab >= 0; ab--) {
            if (!l.contains(e._inner[ab])) {
                c = true;
                let ac = d.item(e._inner[ab]);
                ac.count = 0;
                ac.activate = null;
                ac.create = null;
                ac.destroy = null;
                ac.disactivate = null;
                d.removeItem(e._inner[ab]);
                e.removeAt(ab);
            }
        }
        if (c && f) {
            for (let ad = 0; ad < k.count; ad++) {
                let ae = k._inner[ad];
                if (ae.a5.c) {
                    ae.gp(true);
                    ae.a5.c = false;
                }
            }
        }
    }
}
AxisAnnotationFrameManager.$t = markType(AxisAnnotationFrameManager, 'AxisAnnotationFrameManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ValueOverlay extends Series {
    constructor() {
        super();
        this.mq = 0;
        this.mr = 0;
        this.mn = 0;
        this.mb = null;
        this.mh = null;
        this.mg = null;
        this.ab = ValueOverlay.$;
    }
    en(a, b, c) {
        return this.ms;
    }
    mo(a, b) {
        let c = Math.sqrt(Math.pow(a.x - b.x, 2) + Math.pow(a.y - b.y, 2));
        let d = Math.acos((a.x - b.x) / c);
        if ((a.y - b.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    }
    lv(a, b, c) {
        if (this.ma == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        let d = this.mp();
        let e = NaN;
        let f = NaN;
        let g = NaN;
        let h = { $type: Point_$type, x: 0.5, y: 0.5 };
        let i = NaN;
        switch (this.ma.a1) {
            case 2:
                i = Math.sqrt(Math.pow(a.x - h.x, 2) + Math.pow(a.y - h.y, 2));
                g = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
            case 0:
                e = d;
                f = a.y;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                break;
            case 1:
                f = d;
                e = a.x;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
            case 3:
                g = this.mo(a, h);
                i = d;
                e = h.x + Math.cos(g) * i;
                f = h.y + Math.sin(g) * i;
                f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
                e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
                break;
        }
        return { $type: Point_$type, x: e, y: f };
    }
    e8(a) {
        throw new NotImplementedException(0);
    }
    fp(a) {
        return this;
    }
    c9(a) {
        return false;
    }
    an(a) {
        let b = typeCast(NumericAxisBase.$, a);
        let c = this.ms;
        if (isNaN_(c) || isInfinity(c)) {
            return null;
        }
        return new AxisRange(c, c);
    }
    jm(a) {
        this.h3(true, this.bi);
        if (!this.mf()) {
            if (this.mb != null) {
                this.na(NaN, this.ca());
            }
            return;
        }
        if (this.da(a)) {
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                let b = this.mq;
                this.mq = this.mr;
                this.mr = b;
            }
            else {
                this.mq = this.mn;
            }
            this.mn = this.mp();
            this.jt();
        }
        else {
            this.mn = this.mp();
            this.m9(this.mn, this.md);
        }
    }
    mp() {
        let a, b;
        let c = this.getViewInfo(b, a);
        b = c.p0;
        a = c.p1;
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, a, b, this.ma.ca, d);
        return this.ma.dy(this.ms, e);
    }
    m9(a, b) {
        if (this.ma == null) {
            return;
        }
        let c = typeCast(CategoryAxisBase.$, this.ma);
        if (c != null && !c.b7) {
            if (this.ms > c.j8 - 1) {
                return;
            }
            if (c.categoryMode == 2) {
                let d = this.getEffectiveViewport1(b);
                let e = 0.5 * c.getCategorySize(b.bs, b.br, d);
                let f = false;
                if (c.ch && !c.ca) {
                    f = true;
                }
                if (typeCast(CategoryXAxis.$, c) !== null && c.ca) {
                    f = true;
                }
                if (f) {
                    e = -e;
                }
                a += e;
            }
        }
        let g = typeCast(NumericAxisBase.$, this.ma);
        if (g != null) {
            if (this.ms < g.kc || this.ms > g.kb) {
                return;
            }
            if (g.j2 && this.ms < 0) {
                return;
            }
        }
        let h;
        switch (this.ma.a1) {
            case 2:
            case 3:
                h = this.ma.i1(a, b.bs, b.br, this.getEffectiveViewport1(b), this.l0(b));
                break;
            default:
                h = this.ma.i1(a, b.bs, b.br);
                break;
        }
        if (h != null) {
            b.bv(h);
        }
        this.na(a, this.ca());
    }
    dw(a, b, c) {
        let d = true;
        d = super.dw(a, b, c);
        if (!c.l() || b.isEmpty || a.isEmpty || this.ma == null || this.ma.bh == null) {
            d = false;
        }
        return d;
    }
    j1(a, b) {
        this.jl(false);
    }
    j0(a, b) {
        this.jl(false);
    }
    h6(a, b, c, d) {
        throw new NotImplementedException(0);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ValueOverlay.$$p[10]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.jl(false);
                this.it();
                break;
            case "TransitionProgress":
                this.mr = this.mq + this.ez * (this.mn - this.mq);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.m9(this.mn, this.md);
                }
                else {
                    this.m9(this.mr, this.md);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case ValueOverlay.$$p[12]:
                let e = typeCast(NumericAxisBase.$, this.ma);
                if (e != null) {
                    e.cn();
                }
                this.jl(true);
                this.iu();
                break;
            case ValueOverlay.$$p[11]:
            case ValueOverlay.$$p[9]:
            case ValueOverlay.$$p[0]:
            case ValueOverlay.$$p[2]:
            case ValueOverlay.$$p[3]:
            case ValueOverlay.$$p[8]:
            case ValueOverlay.$$p[4]:
            case ValueOverlay.$$p[5]:
            case ValueOverlay.$$p[6]:
            case ValueOverlay.$$p[7]:
                this.jl(true);
                break;
        }
    }
    ik() {
        super.ik();
        if (this.ma != null) {
            this.ma.hb(false);
        }
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.bu();
    }
    mf() {
        if (this.ma == null || this.ma.bh == null || isNaN_(this.ms) || this._visibility == 1) {
            return false;
        }
        let a = typeCast(CategoryAxisBase.$, this.ma);
        if (a != null && a.j8 == 0) {
            return false;
        }
        return true;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get categoryAxis() {
        return typeCast(CategoryAxisBase.$, this.ma);
    }
    bf() {
        return new ValueOverlayView(this);
    }
    i2(a) {
        super.i2(a);
        this.md = typeCast(ValueOverlayView.$, a);
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh) || !this.mf()) {
            return;
        }
        let c = this.getEffectiveViewport1(this.bi);
        let d = this.ma.dy(this.ms, new ScalerParams(0, this.bh.bs, a, this.ma.ca, c));
        this.m9(d, typeCast(ValueOverlayView.$, this.bh));
        this.dl = false;
    }
    getOffsetValue() {
        return 0;
    }
    getCategoryWidth() {
        return 0;
    }
    get nr() {
        return new Thickness(1, this.mj, this.ml, this.mk, this.mi);
    }
    ag() {
        return [this.ma];
    }
    na(a, b) {
        if (isNaN_(a)) {
            if (this.mb != null) {
                AxisAnnotationFrameManager.b(this.mb);
                AxisAnnotationFrameManager.d(this, this.mb, true, this.mg, this.mh, b, this.mt, this.mt, this.mc, this.mc);
            }
            return;
        }
        let c = false;
        if (this.mg == null) {
            c = true;
            this.mh = new List$1(Axis.$, 0);
            this.mg = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        this.mb = new AxisAnnotationFrame();
        let d = this.lb;
        if (d == null) {
            d = this.ld;
        }
        let e = this.ma.ch;
        AxisAnnotationFrameManager.c(this.mb, { $type: Point_$type, x: a, y: a }, this, this.bs, this.getEffectiveViewport(), d, this.no, this.nq, this.np, this.nr, this.mm, this.no, this.nq, this.np, this.nr, this.mm, !e && this.me, e && this.me);
        AxisAnnotationFrameManager.d(this, this.mb, c, this.mg, this.mh, b, this.mt, this.mt, this.mc, this.mc);
    }
    get_c6() {
        return true;
    }
    m5(a) {
        if (this.ma != null) {
            return this.ma.fl(a);
        }
        return null;
    }
    get m7() {
        let a = this.m5(this.ms);
        return a != null ? a : stringFormat("{0:0.##}", this.ms);
    }
}
ValueOverlay.$t = markType(ValueOverlay, 'ValueOverlay', Series.$, [IHasCategoryModePreference_$type]);
ValueOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, ValueOverlay, 'raisePropertyChanged', ['AxisAnnotationBackground:no:nb', [Brush.$, null], 'AxisAnnotationFormatLabel:mc:nc', [Delegate_$type], 'AxisAnnotationInterpolatedValuePrecision:mt:nd', [1, -1], 'AxisAnnotationOutline:np:ne', [Brush.$, null], 'AxisAnnotationPaddingBottom:mi:nf', [1, NaN], 'AxisAnnotationPaddingLeft:mj:ng', [1, NaN], 'AxisAnnotationPaddingRight:mk:nh', [1, NaN], 'AxisAnnotationPaddingTop:ml:ni', [1, NaN], 'AxisAnnotationStrokeThickness:mm:nj', [1, NaN], 'AxisAnnotationTextColor:nq:nk', [Brush.$, null], 'Axis:ma:nl', [Axis.$, null], 'IsAxisAnnotationEnabled:me:nm', [0, false], 'Value:ms:nn', [1, 0]]);
/**
 * @hidden
 */
class ValueOverlayView extends SeriesView {
    constructor(a) {
        super(a);
        this.bw = null;
        this.bw = new Path();
    }
    a8() {
        super.a8();
        this.bw._stroke = this.e.lb;
        this.bw.ac = this.e.ey;
        this.bw.ai = this.e.ll;
        this.bw.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.bw._stroke = a;
        this.bw.ac = this.e.ey + 3;
        this.bw._stroke = a;
        this.bw.ac = this.e.ey + 3;
    }
    bv(a) {
        this.bw.ak = a;
        this.an();
    }
    bu() {
        this.bw.ak = null;
        this.an();
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.bw);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.bw, "ValueOverlayPath", []);
    }
}
ValueOverlayView.$t = markType(ValueOverlayView, 'ValueOverlayView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxValueOverlayComponent_1;
/**
 * Represents the class of the value overlay. The value overlay is a line or circle representing a value on an axis.
*/
const IgxValueOverlayComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxValueOverlayComponent) }];
let IgxValueOverlayComponent = IgxValueOverlayComponent_1 = class IgxValueOverlayComponent extends IgxSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ValueOverlay();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the axis used by the value overlay.
    */
    get axis() {
        if (this.i.ma == null) {
            return null;
        }
        if (!this.i.ma.externalObject) {
            let e = IgxAxisComponent._createFromInternal(this.i.ma);
            if (e) {
                e._implementation = this.i.ma;
            }
            this.i.ma.externalObject = e;
        }
        return this.i.ma.externalObject;
    }
    set axis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ma = null : this.i.ma = v.i;
    }
    /**
     * Gets or sets the value of the overlay.
    */
    get value() {
        return this.i.ms;
    }
    set value(v) {
        this.i.ms = +v;
    }
    /**
     * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
    */
    get isAxisAnnotationEnabled() {
        return this.i.me;
    }
    set isAxisAnnotationEnabled(v) {
        this.i.me = ensureBool(v);
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for the axis annotation.
    */
    get axisAnnotationFormatLabel() {
        return this.i.mc;
    }
    set axisAnnotationFormatLabel(v) {
        this.i.mc = v;
    }
    /**
     * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
    */
    get axisAnnotationTextColor() {
        return brushToString(this.i.nq);
    }
    set axisAnnotationTextColor(v) {
        this.i.nq = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
    */
    get axisAnnotationBackground() {
        return brushToString(this.i.no);
    }
    set axisAnnotationBackground(v) {
        this.i.no = stringToBrush(v);
    }
    /**
     * Gets or sets the precision to use displaying values for interpolated positions.
    */
    get axisAnnotationInterpolatedValuePrecision() {
        return this.i.mt;
    }
    set axisAnnotationInterpolatedValuePrecision(v) {
        this.i.mt = +v;
    }
    /**
     * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
    */
    get axisAnnotationOutline() {
        return brushToString(this.i.np);
    }
    set axisAnnotationOutline(v) {
        this.i.np = stringToBrush(v);
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingLeft() {
        return this.i.mj;
    }
    set axisAnnotationPaddingLeft(v) {
        this.i.mj = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingTop() {
        return this.i.ml;
    }
    set axisAnnotationPaddingTop(v) {
        this.i.ml = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingRight() {
        return this.i.mk;
    }
    set axisAnnotationPaddingRight(v) {
        this.i.mk = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingBottom() {
        return this.i.mi;
    }
    set axisAnnotationPaddingBottom(v) {
        this.i.mi = +v;
    }
    /**
     * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
    */
    get axisAnnotationStrokeThickness() {
        return this.i.mm;
    }
    set axisAnnotationStrokeThickness(v) {
        this.i.mm = +v;
    }
    /**
     * Gets whether the series is a value overlay.
    */
    get isValueOverlay() {
        return this.i.c6;
    }
    get labelResolved() {
        return this.i.m7;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.axis && this.axis.name && this.axis.name == name) {
            return this.axis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.axis && this.axis._styling) {
            this.axis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Gets the item item index associated with the specified world position
    
    * @param world
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Requests that the provided item should be brought into view if possible.
    
    * @param item  * The item to attempt to bring into view.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Gets the label for a data item.
    
    * @param value  * The unscaled value to get a label for.
    */
    getLabel(value) {
        let iv = this.i.m5(value);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxAxisComponent),
    __metadata("design:paramtypes", [IgxAxisComponent])
], IgxValueOverlayComponent.prototype, "axis", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "value", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxValueOverlayComponent.prototype, "isAxisAnnotationEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxValueOverlayComponent.prototype, "axisAnnotationFormatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxValueOverlayComponent.prototype, "axisAnnotationTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxValueOverlayComponent.prototype, "axisAnnotationBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationInterpolatedValuePrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxValueOverlayComponent.prototype, "axisAnnotationOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationPaddingLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationPaddingTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationPaddingRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationPaddingBottom", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueOverlayComponent.prototype, "axisAnnotationStrokeThickness", null);
IgxValueOverlayComponent = IgxValueOverlayComponent_1 = __decorate([
    Component({
        selector: 'igx-value-overlay',
        template: ``,
        providers: [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxValueOverlayComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxValueOverlayComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxValueOverlayModule = class IgxValueOverlayModule {
};
IgxValueOverlayModule = __decorate([
    NgModule({
        declarations: [IgxValueOverlayComponent],
        imports: [CommonModule],
        exports: [IgxValueOverlayComponent],
        entryComponents: []
    })
], IgxValueOverlayModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxValueOverlayDynamicModule = class IgxValueOverlayDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxValueOverlayComponent", IgxValueOverlayComponent);
        TypeRegistrar.register("ValueOverlay", ValueOverlay.$type);
    }
};
IgxValueOverlayDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxValueOverlayModule],
        exports: [IgxValueOverlayModule],
        entryComponents: [IgxValueOverlayComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxValueOverlayDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IAnnotationInfoProvider_$type = new Type(null, 'IAnnotationInfoProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnnotationInfoProvider extends Base {
}
AnnotationInfoProvider.$t = markType(AnnotationInfoProvider, 'AnnotationInfoProvider');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisAnnotationManager extends Base {
    constructor() {
        super(...arguments);
        this._owner = null;
    }
    get owner() {
        return this._owner;
    }
    set owner(a) {
        this._owner = a;
    }
    onAddAnnotations(a) {
        let b = 0;
        for (let c = 0; c < a.an.count; c++) {
            b = this.a(a, a.an._inner[c], b);
        }
        for (let d = 0; d < a.am.count; d++) {
            b = this.a(a, a.am._inner[d], b);
        }
        a.bo.count = b;
        a.bp.count = b;
    }
    a(a, b, c) {
        let d = NaN;
        d = b.value;
        let e = new LabelPosition(a.ed(d));
        if (a.b5) {
            let f = a;
            if (f.categoryMode == 2) {
                let g = a.bh.n2;
                let h = a.i9;
                let i = a.i4();
                e.c += (a.ca ? -f.getCategorySize(g, h, i) * 0.5 : f.getCategorySize(g, h, i) * 0.5);
            }
        }
        let j = e.c;
        if (a.ch) {
            if (e.c > a.i9.bottom || e.c < a.i9.top) {
                return c;
            }
        }
        else {
            if (e.c > a.i9.right || e.c < a.i9.left) {
                return c;
            }
        }
        let k = a.bo.item(c);
        let l = a.bp.item(c);
        let m = 100 + c * 2;
        c++;
        l.ak = b.resolveLabelValue();
        if (b.textColor != null) {
            l.am = b.textColor;
        }
        k._fill = b.background;
        k._stroke = b.outline;
        k.ac = b.strokeThickness;
        k.s = m;
        l.s = m + 1;
        b.checkForExtentReset(() => e.b = true);
        e.a = true;
        e.d = b.backgroundPadding;
        a.cy.add(e);
        a.cx.add1(l.ak);
        return c;
    }
    arrangeAnnotations(a, b, c, d, e, f, g, h, i, j) {
        for (let k = 0; k < a.bp.count; k++) {
            let l = a.bo.item(k);
            let m = -1;
            for (let n = c.count - 1; n >= 0; n--) {
                if (c._inner[n] == a.bp.item(k)) {
                    m = n;
                    break;
                }
            }
            if (m == -1) {
                continue;
            }
            if (e) {
                b.z(l, a.bp.item(k), a.cy._inner[m], d._inner[m], g, h, i, j);
                b.aq(l, a.bp.item(k), a.cy._inner[m], d._inner[m], g, h, i, j, f);
            }
            else {
                b.z(l, a.bp.item(k), a.cy._inner[m], d._inner[m], g, h, i, j);
            }
        }
    }
    b(a, b) {
        this.owner.ci = true;
        this.owner.ha();
    }
    c(a) {
        if (a.oldItems != null) {
            for (let b = 0; b < a.oldItems.count; b++) {
                let c = a.oldItems.item(b);
                if (c == null) {
                    continue;
                }
                let d = c;
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
            }
        }
        if (a.newItems != null) {
            for (let e = 0; e < a.newItems.count; e++) {
                let f = a.newItems.item(e);
                if (f == null) {
                    continue;
                }
                let g = f;
                g.propertyChanged = delegateCombine(g.propertyChanged, runOn(this, this.b));
            }
        }
        this.owner.ci = true;
        this.owner.ha();
    }
    onAnnotionsChanged(a, b, c) {
        this.c(c);
    }
    onAnnotionsReset(a, b, c) {
        for (let d of fromEnum(b)) {
            d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
        }
    }
    onAutoAnnotionsChanged(a, b, c) {
        this.c(c);
    }
    onAutoAnnotionsReset(a, b, c) {
        for (let d of fromEnum(b)) {
            d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.b));
        }
    }
}
AxisAnnotationManager.$t = markType(AxisAnnotationManager, 'AxisAnnotationManager', Base.$, [IAxisAnnotationManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnnotationFactoryManager extends Base {
    static register() {
        if (!AnnotationFactoryManager.a) {
            DVContainer.instance.registerFactory(IAnnotationInfoProvider_$type, () => new AnnotationInfoProvider());
            DVContainer.instance.registerFactory(IAxisAnnotationManager_$type, () => new AxisAnnotationManager());
            AnnotationFactoryManager.a = true;
        }
    }
}
AnnotationFactoryManager.$t = markType(AnnotationFactoryManager, 'AnnotationFactoryManager');
AnnotationFactoryManager.a = false;

/**
 * Represents a callout annotation
*/
class IgxCalloutAnnotation {
    constructor() {
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new CalloutAnnotation();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the XValue at which this annotation is displayed on the axis.
    */
    get xValue() {
        return this.i.xValue;
    }
    set xValue(v) {
        this.i.xValue = v;
    }
    /**
     * Gets or sets the YValue at which this annotation is displayed on the axis.
    */
    get yValue() {
        return this.i.yValue;
    }
    set yValue(v) {
        this.i.yValue = v;
    }
    /**
     * Gets or sets the text that should be displayed for the annotation. Leave null to display the value automatically.
    */
    get text() {
        return this.i.text;
    }
    set text(v) {
        this.i.text = v;
    }
    /**
     * Gets or sets the Key that should be annotated.
    */
    get key() {
        return this.i.key;
    }
    set key(v) {
        this.i.key = v;
    }
    /**
     * Gets or sets the Content that should be annotated.
    */
    get content() {
        return this.i.content;
    }
    set content(v) {
        this.i.content = v;
    }
    /**
     * Gets or sets the series to which the callout pertains to. Leave unset for an automatic value.
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for the value of this annotation.
    */
    get formatLabel() {
        return this.i.formatLabel;
    }
    set formatLabel(v) {
        this.i.formatLabel = v;
    }
    /**
     * Gets or sets the color to use for the text in the annotation.
    */
    get textColor() {
        return brushToString(this.i.textColor);
    }
    set textColor(v) {
        this.i.textColor = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for tha axis annotation box.
    */
    get background() {
        return brushToString(this.i.background);
    }
    set background(v) {
        this.i.background = stringToBrush(v);
    }
    /**
     * Gets or sets the Outline to use for tha axis annotation box.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets or sets the LeaderBrush to use for tha axis annotation box.
    */
    get leaderBrush() {
        return brushToString(this.i.leaderBrush);
    }
    set leaderBrush(v) {
        this.i.leaderBrush = stringToBrush(v);
    }
    /**
     * Gets or sets the border stroke thickness to use for tha axis annotation box.
    */
    get strokeThickness() {
        return this.i.strokeThickness;
    }
    set strokeThickness(v) {
        this.i.strokeThickness = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingLeft() {
        return this.i.backgroundPaddingLeft;
    }
    set backgroundPaddingLeft(v) {
        this.i.backgroundPaddingLeft = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingTop() {
        return this.i.backgroundPaddingTop;
    }
    set backgroundPaddingTop(v) {
        this.i.backgroundPaddingTop = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingRight() {
        return this.i.backgroundPaddingRight;
    }
    set backgroundPaddingRight(v) {
        this.i.backgroundPaddingRight = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get backgroundPaddingBottom() {
        return this.i.backgroundPaddingBottom;
    }
    set backgroundPaddingBottom(v) {
        this.i.backgroundPaddingBottom = +v;
    }
    findByName(name) {
        if (this.series && this.series.name && this.series.name == name) {
            return this.series;
        }
        return null;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}

class IgxCalloutAnnotationCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxCalloutAnnotation.$type) {
            IgxCalloutAnnotation.$type = markType(IgxCalloutAnnotation, "IgxCalloutAnnotation");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxCalloutAnnotation.$type) {
            IgxCalloutAnnotation.$type = markType(IgxCalloutAnnotation, "IgxCalloutAnnotation");
        }
        let coll = new SyncableObservableCollection$2(IgxCalloutAnnotation.$type, CalloutAnnotation.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxCalloutAnnotation();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutAnnotationCollection extends ObservableCollection$1 {
    constructor() {
        super(CalloutAnnotation.$, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
CalloutAnnotationCollection.$t = markType(CalloutAnnotationCollection, 'CalloutAnnotationCollection', ObservableCollection$1.$.specialize(CalloutAnnotation.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryHighlightFrameRect extends Base {
    constructor() {
        super();
        this.f = 0;
        this.e = 0;
        this.b = 0;
        this.c = 0;
        this.a = 0;
        this.g = null;
        this.h = null;
        this.d = 0;
        this.f = 0;
        this.e = NaN;
        this.b = NaN;
        this.c = NaN;
        this.b = NaN;
        this.a = NaN;
        this.d = NaN;
    }
}
CategoryHighlightFrameRect.$t = markType(CategoryHighlightFrameRect, 'CategoryHighlightFrameRect');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DictInterpolator$3 extends Base {
    constructor($tKey, $tValue, $tFrame, a, b, c, d) {
        super();
        this.$tKey = null;
        this.$tValue = null;
        this.$tFrame = null;
        this.b = null;
        this.d = null;
        this.e = null;
        this.c = null;
        this.a = null;
        this.$tKey = $tKey;
        this.$tValue = $tValue;
        this.$tFrame = $tFrame;
        this.$type = this.$type.specialize(this.$tKey, this.$tValue, this.$tFrame);
        this.b = a;
        this.d = b;
        this.e = c;
        this.c = d;
        this.a = Type.getDefaultValue(this.$tValue);
    }
    f(a, b, c, d, e, f) {
        let g = new List$1(this.$tKey, 0);
        for (let h of fromEnum(a.keys)) {
            let i = this.a;
            let j = this.a;
            let k = a.item(h);
            let l = ((() => { let m = c.tryGetValue(h, i); i = m.p1; return m.ret; })());
            let m = ((() => { let n = d.tryGetValue(h, j); j = n.p1; return n.ret; })());
            if (!l && !m) {
                g.add(h);
            }
            else {
                this.b(k, b, i, j, e, f);
                if (!this.e(k)) {
                    g.add(h);
                }
            }
        }
        for (let n of fromEnum(g)) {
            a.removeItem(n);
        }
        for (let o of fromEnum(c.keys)) {
            let p = c.item(o);
            let q = this.a;
            let r = this.a;
            let s = d.tryGetValue(o, q);
            q = s.p1;
            let t = ((() => { let u = a.tryGetValue(o, r); r = u.p1; return u.ret; })());
            if (!t) {
                r = this.c();
                this.b(r, b, p, q, e, f);
                if (!this.e(r)) {
                    continue;
                }
                a.addItem(this.d(r), r);
            }
        }
        for (let u of fromEnum(d.keys)) {
            let v = d.item(u);
            let w = this.a;
            let x = this.a;
            let y = ((() => { let z = c.tryGetValue(u, w); w = z.p1; return z.ret; })());
            let z = ((() => { let aa = a.tryGetValue(u, x); x = aa.p1; return aa.ret; })());
            if (!z && !y) {
                x = this.c();
                this.b(x, b, w, v, e, f);
                if (!this.e(x)) {
                    continue;
                }
                a.addItem(this.d(x), x);
            }
        }
    }
}
DictInterpolator$3.$t = markType(DictInterpolator$3, 'DictInterpolator$3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryHighlightLayerFrame extends Frame {
    constructor() {
        super();
        this.g = null;
        this.f = null;
        this.g = new Dictionary$2(Number_$type, CategoryHighlightFrameRect.$, 0);
        this.f = new DictInterpolator$3(Number_$type, CategoryHighlightFrameRect.$, CategoryHighlightLayerFrame.$, runOn(this, this.h), (a) => a.f, (a) => true, () => new CategoryHighlightFrameRect());
    }
    h(a, b, c, d, e, f) {
        if (d != null) {
            a.f = d.f;
        }
        else if (c != null) {
            a.f = c.f;
        }
        else {
            a.f = 0;
        }
        if (c == null || isNaN_(c.e)) {
            a.e = d != null ? d.e : NaN;
        }
        else if (d == null || isNaN_(d.e)) {
            a.e = NaN;
        }
        else {
            a.e = c.e + b * (d.e - c.e);
        }
        if (c == null || isNaN_(c.b)) {
            a.b = d != null ? d.b : NaN;
        }
        else if (d == null || isNaN_(d.b)) {
            a.b = NaN;
        }
        else {
            a.b = c.b + b * (d.b - c.b);
        }
        if (c == null || isNaN_(c.c)) {
            a.c = d != null ? d.c : NaN;
        }
        else if (d == null || isNaN_(d.c)) {
            a.c = NaN;
        }
        else {
            a.c = c.c + b * (d.c - c.c);
        }
        if (c == null || isNaN_(c.a)) {
            a.a = d != null ? d.a : NaN;
        }
        else if (d == null || isNaN_(d.a)) {
            a.a = NaN;
        }
        else {
            a.a = c.a + b * (d.a - c.a);
        }
        if (c == null || isNaN_(c.d)) {
            a.d = d != null ? d.d : NaN;
        }
        else if (d == null || isNaN_(d.d)) {
            a.d = NaN;
        }
        else {
            a.d = c.d + b * (d.d - c.d);
        }
        if (c == null || c.g == null) {
            a.g = d != null ? d.g : null;
        }
        else if (d == null || d.g == null) {
            a.g = null;
        }
        else {
            a.g = BrushUtil.k(c.g, b, d.g, 0);
        }
        if (c == null || c.h == null) {
            a.h = d != null ? d.h : null;
        }
        else if (d == null || d.h == null) {
            a.h = null;
        }
        else {
            a.h = BrushUtil.k(c.h, b, d.h, 0);
        }
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        this.f.f(this.g, a, d.g, e.g, d, e);
    }
}
CategoryHighlightLayerFrame.$t = markType(CategoryHighlightLayerFrame, 'CategoryHighlightLayerFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryHighlightLayer extends AnnotationLayer {
    constructor() {
        super();
        let a = new CategoryHighlightLayerFrame();
        let b = new CategoryHighlightLayerFrame();
        let c = new CategoryHighlightLayerFrame();
        let d = this.fi / 1000;
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = CategoryHighlightLayer.$;
    }
    bf() {
        return new CategoryHighlightLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.nf = a;
    }
    get ni() {
        return this.c(CategoryHighlightLayer.np);
    }
    set ni(a) {
        this.h(CategoryHighlightLayer.np, a);
    }
    mu(a, b) {
        if (this.ne == null || this.ne == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    ng(a) {
        return a != null && a.cg();
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        c.g.clear();
        let d = this.nh;
        if (isNaN_(this.nb.x) && isNaN_(this.nb.y)) {
            return;
        }
        if (this.ne != null) {
            if (this.ng(this.ne)) {
                this.nn(this.ne, c, d);
            }
        }
        else {
            if (typeCast(XamDataChart.$, this.bs) !== null) {
                let e = this.bs;
                for (let f of fromEnum(e.axes)) {
                    if (typeCast(CategoryAxisBase.$, f) !== null && this.ng(f)) {
                        this.nn(f, c, d);
                    }
                }
            }
        }
    }
    nn(a, b, c) {
        if (this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return;
        }
        let d = this.nb.x;
        if (a.ch && isNaN_(d)) {
            d = 0;
        }
        d = this.bi.br.left + this.bi.br.width * (d - this.bi.bs.left) / this.bi.bs.width;
        let e = this.nb.y;
        if (!a.ch && isNaN_(e)) {
            e = 0;
        }
        e = this.bi.br.top + this.bi.br.height * (e - this.bi.bs.top) / this.bi.bs.height;
        let f = a.k2({ $type: Point_$type, x: d, y: e }, c, this.ni);
        this.nm(f, b, a);
    }
    nm(a, b, c) {
        let d = new CategoryHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.g = this.m9();
        d.h = this.na();
        if (d.g == null) {
            d.g = this.nf.b9(c.ir);
        }
        if (d.h == null) {
            d.h = this.nf.b9(c.ir);
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    }
    m0(a, b) {
        super.m0(a, b);
        let c = this.nf.b2;
        let d = a;
        let e = 0;
        for (let f of fromEnum(d.g.values)) {
            let g = c.item(e);
            this.no(f, g);
            e++;
        }
        c.count = e;
    }
    c8() {
        return true;
    }
    no(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.nf.b4(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.g;
        b._stroke = a.h;
        b.ac = a.d;
        if (this.ll != null) {
            b.ai = this.ll;
        }
        else {
            b.ai = null;
        }
        b.ad = this.lm;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case CategoryHighlightLayer.$$p[0]:
                this.jl(true);
                break;
            case CategoryHighlightLayer.$$p[1]:
                this.jl(true);
                break;
        }
    }
}
CategoryHighlightLayer.$t = markType(CategoryHighlightLayer, 'CategoryHighlightLayer', AnnotationLayer.$);
CategoryHighlightLayer.np = DependencyProperty.i("BAndHighlightWidth", Number_$type, CategoryHighlightLayer.$, new PropertyMetadata(2, 10, (a, b) => a.raisePropertyChanged("BAndHighlightWidth", b.oldValue, b.newValue)));
CategoryHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryHighlightLayer, 'raisePropertyChanged', ['TargetAxis:ne:nq', [CategoryAxisBase.$, null], 'UseInterpolation:nh:nr', [0, false]]);
/**
 * @hidden
 */
class CategoryHighlightLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this.b3 = null;
        this.b1 = a;
        this.b3 = new List$1(Rectangle.$, 0);
    }
    ap() {
        super.ap();
        this.b2 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.ca);
            $ret.activate = runOn(this, this.b5);
            $ret.disactivate = runOn(this, this.b7);
            $ret.destroy = runOn(this, this.b6);
            return $ret;
        })());
    }
    ca() {
        let a = new Rectangle();
        a.ab = false;
        this.b3.add(a);
        return a;
    }
    b5(a) {
        a._visibility = 0;
    }
    b7(a) {
        a._visibility = 1;
    }
    b6(a) {
        this.b3.remove(a);
    }
    b8(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    }
    b9(a) {
        if (a != null) {
            let b = BrushUtil.l(a, 0.3);
            if (b.isGradient) {
                let c = b;
                if (c.gradientStops != null) {
                    for (let d = 0; d < c.gradientStops.length; d++) {
                        let e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.2)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l) * 0.2)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    }
    b4(a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b3.count; c++) {
                let d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b3.count; b++) {
            this.e.a2.exportRectangleData(a, this.b3._inner[b], "cihRect", ["Main", "CategoryItem"]);
        }
    }
}
CategoryHighlightLayerView.$t = markType(CategoryHighlightLayerView, 'CategoryHighlightLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
const IgxCategoryAxisBaseComponent_PROVIDERS = [{ provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryAxisBaseComponent) }];
/**
 * Represents the base class for all IgxDataChartComponent category-based axes.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*
*     <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-column-series>
*     <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*       </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath="value";
* this.chart.series.add(series);
* ```
*/
class IgxCategoryAxisBaseComponent extends IgxAxisComponent {
    constructor() {
        super();
        this._chartLevelData = null;
        this._dataSource = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
    }
    provideData(data) {
        this._chartLevelData = data;
        this.updateDataSource();
    }
    updateDataSource() {
        if (this._dataSource == null) {
            this.i.itemsSource = this._chartLevelData;
        }
        else {
            this.i.itemsSource = this._dataSource;
        }
    }
    set dataSource(value) {
        this._dataSource = value;
        this.updateDataSource();
        //console.log("setting axis data source: " + value)
    }
    get dataSource() {
        if (this._dataSource != null) {
            return this._dataSource;
        }
        return this.i.itemsSource;
    }
    /**
                             * @hidden
                             */
    get i() {
        return this._implementation;
    }
    /**
 * Gets if the current axis is a continuous rather than a discrete scale
*/
    get isContinuous() {
        return this.i.b6;
    }
    /**
     * Checks if the axis is of category axis type
    */
    get isCategory() {
        return this.i.b4;
    }
    /**
     * Gets the number of items in the current category axis items source.
    */
    get itemsCount() {
        return this.i.j8;
    }
    set itemsCount(v) {
        this.i.j8 = +v;
    }
    /**
     * Gets or sets the amount of space between adjacent categories for the current axis object.
     * The gap is silently clamped to the range [0, 1] when used.
    *
    * Use the `gap` property to configure the spacing between items on a category axis with item spacing.
    *
    * A `gap` of 0 allocates no space between items.  A `gap` of 1 allocates a space between items equal to the width of one item.
    *
    * To set the item spacing to 75% the width of one item, set the `gap` to 0.75, as in this code:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         gap="0.75"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get gap() {
        return this.i.jw;
    }
    set gap(v) {
        this.i.jw = +v;
    }
    /**
     * Gets or sets the amount of overlap between adjacent categories for the current axis object.
     * The overlap is silently clamped to the range [-1, 1] when used.
    *
    * Use the `overlap` property to configure the spacing between items on a category axis with item spacing and more than one series.
    *
    * An `overlap` of 0 places grouped items adjacent to each other.  An `overlap` of 1 places grouped items in the same axis space, completely overlapping.  An `overlap` of -1 places a space between grouped items equal to the width of one item.
    *
    * To place grouped items with 75% overlap, set the `overlap` to 0.75, as in this code:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *
    *     <igx-category-x-axis
    *         label="label"
    *         overlap="0.75"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get overlap() {
        return this.i.j3;
    }
    set overlap(v) {
        this.i.j3 = +v;
    }
    /**
     * Gets or sets whether the category axis should use clustering display mode even if no series are present that would force clustering mode.
    *
    * `useClusteringMode` applies grouping and spacing to a category axis equivalent to the grouping that occurs when grouping series, such as ColumnSeries, are used.
    *
    * Try setting it on an axis displaying financial series to adjust the spacing on the left and right sides of the axis:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="financialData">
    *     <igx-category-x-axis
    *     label="time"
    *     useClusteringMode="true"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *     </igx-column-series>
    *     <igx-financial-price-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume">
    *     </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get useClusteringMode() {
        return this.i.jr;
    }
    set useClusteringMode(v) {
        this.i.jr = ensureBool(v);
    }
    getCategoryBoundingBox(point, useInterpolation, singularWidth) {
        let iv = this.i.k2(toPoint(point), useInterpolation, singularWidth);
        return fromRect(iv);
    }
    getCategoryBoundingBoxHelper(point, useInterpolation, singularWidth, isVertical) {
        let iv = this.i.k3(toPoint(point), useInterpolation, singularWidth, isVertical);
        return fromRect(iv);
    }
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    */
    unscaleValue(unscaledValue) {
        let iv = this.i.j4(unscaledValue);
        return (iv);
    }
    notifySetItem(index, oldItem, newItem) {
        this.i.kp(index, oldItem, newItem);
    }
    /**
     * Used to manually notify the axis that the data source has reset or cleared its items.
    
    */
    notifyClearItems() {
        this.i.km();
    }
    notifyInsertItem(index, newItem) {
        this.i.kn(index, newItem);
    }
    notifyRemoveItem(index, oldItem) {
        this.i.ko(index, oldItem);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxCategoryAxisBaseComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAxisBaseComponent.prototype, "itemsCount", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAxisBaseComponent.prototype, "gap", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAxisBaseComponent.prototype, "overlap", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryAxisBaseComponent.prototype, "useClusteringMode", null);

var IgxCategoryHighlightLayerComponent_1;
/**
 * Represents an annotation layer that targets a category axis, or all category axes in the chart.
 * If the axis contains any series that are aligned between major gridlines of the axis (column, waterfall, etc) this will render a shape that fills the current category.
 * Otherwise it will render a band with an adjustable thickness at the closest gridline to the pointer position.
 * Setting UseIterpolation to true will cause the x position in the latter case to become affixed to the x position of the pointer.
*/
const IgxCategoryHighlightLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryHighlightLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryHighlightLayerComponent) }];
let IgxCategoryHighlightLayerComponent = IgxCategoryHighlightLayerComponent_1 = class IgxCategoryHighlightLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CategoryHighlightLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the axis to target this annotation to. If null, this annotation targets all category axes simultaneously.
    */
    get targetAxis() {
        if (this.i.ne == null) {
            return null;
        }
        if (!this.i.ne.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.ne);
            if (e) {
                e._implementation = this.i.ne;
            }
            this.i.ne.externalObject = e;
        }
        return this.i.ne.externalObject;
    }
    set targetAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ne = null : this.i.ne = v.i;
    }
    /**
     * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
    */
    get useInterpolation() {
        return this.i.nh;
    }
    set useInterpolation(v) {
        this.i.nh = ensureBool(v);
    }
    /**
     * Gets or sets the width to use for the highlight region if drawing a band rather than filling a category.
    */
    get bandHighlightWidth() {
        return this.i.ni;
    }
    set bandHighlightWidth(v) {
        this.i.ni = +v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetAxis && this.targetAxis.name && this.targetAxis.name == name) {
            return this.targetAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetAxis && this.targetAxis._styling) {
            this.targetAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAxisBaseComponent),
    __metadata("design:paramtypes", [IgxCategoryAxisBaseComponent])
], IgxCategoryHighlightLayerComponent.prototype, "targetAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryHighlightLayerComponent.prototype, "useInterpolation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryHighlightLayerComponent.prototype, "bandHighlightWidth", null);
IgxCategoryHighlightLayerComponent = IgxCategoryHighlightLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-category-highlight-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryHighlightLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryHighlightLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryHighlightLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryHighlightLayerModule = class IgxCategoryHighlightLayerModule {
};
IgxCategoryHighlightLayerModule = __decorate([
    NgModule({
        declarations: [IgxCategoryHighlightLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxCategoryHighlightLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxCategoryHighlightLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryHighlightLayerDynamicModule = class IgxCategoryHighlightLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryHighlightLayerComponent", IgxCategoryHighlightLayerComponent);
        TypeRegistrar.register("CategoryHighlightLayer", CategoryHighlightLayer.$type);
    }
};
IgxCategoryHighlightLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryHighlightLayerModule],
        exports: [IgxCategoryHighlightLayerModule],
        entryComponents: [IgxCategoryHighlightLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryHighlightLayerDynamicModule);

class IgxCalloutStyleUpdatingEventArgs {
    createImplementation() {
        return new CalloutStyleUpdatingEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get xValue() {
        return this.i.xValue;
    }
    set xValue(v) {
        this.i.xValue = v;
    }
    get yValue() {
        return this.i.yValue;
    }
    set yValue(v) {
        this.i.yValue = v;
    }
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    get background() {
        return brushToString(this.i.background);
    }
    set background(v) {
        this.i.background = stringToBrush(v);
    }
    get textColor() {
        return brushToString(this.i.textColor);
    }
    set textColor(v) {
        this.i.textColor = stringToBrush(v);
    }
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    get leaderBrush() {
        return brushToString(this.i.leaderBrush);
    }
    set leaderBrush(v) {
        this.i.leaderBrush = stringToBrush(v);
    }
    get strokeThickness() {
        return this.i.strokeThickness;
    }
    set strokeThickness(v) {
        this.i.strokeThickness = +v;
    }
}

/**
 * Represents event arguments for updating content of callout layer
*/
class IgxCalloutContentUpdatingEventArgs {
    createImplementation() {
        return new CalloutContentUpdatingEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets data X-value assositated with callout layer
    */
    get xValue() {
        return this.i.c;
    }
    set xValue(v) {
        this.i.c = v;
    }
    /**
     * Gets data Y-value assositated with callout layer
    */
    get yValue() {
        return this.i.d;
    }
    set yValue(v) {
        this.i.d = v;
    }
    /**
     * Gets data item assositated with callout layer
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets or sets content displayed by callout layer
    */
    get content() {
        return this.i.a;
    }
    set content(v) {
        this.i.a = v;
    }
}

/**
 * Represents event arguments for updating label of callout layer
*/
class IgxCalloutLabelUpdatingEventArgs {
    createImplementation() {
        return new CalloutLabelUpdatingEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets data X-value assositated with callout layer
    */
    get xValue() {
        return this.i.c;
    }
    set xValue(v) {
        this.i.c = v;
    }
    /**
     * Gets data Y-value assositated with callout layer
    */
    get yValue() {
        return this.i.d;
    }
    set yValue(v) {
        this.i.d = v;
    }
    /**
     * Gets data item assositated with callout layer
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets or sets label displayed by callout layer
    */
    get label() {
        return this.i.b;
    }
    set label(v) {
        this.i.b = v;
    }
}

/**
 * Represents event arguments for selecting callout layer
*/
class IgxCalloutSeriesSelectingEventArgs {
    createImplementation() {
        return new CalloutSeriesSelectingEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets data X-value assositated with callout layer
    */
    get xValue() {
        return this.i.c;
    }
    set xValue(v) {
        this.i.c = v;
    }
    /**
     * Gets data Y-value assositated with callout layer
    */
    get yValue() {
        return this.i.d;
    }
    set yValue(v) {
        this.i.d = v;
    }
    /**
     * Gets data item assositated with callout layer
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets or sets series object assositated with callout layer
    */
    get series() {
        if (this.i.a == null) {
            return null;
        }
        if (!this.i.a.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.a);
            if (e) {
                e._implementation = this.i.a;
            }
            this.i.a.externalObject = e;
        }
        return this.i.a.externalObject;
    }
    set series(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    /**
     * Gets or sets series name assositated with callout layer
    */
    get seriesName() {
        return this.i.e;
    }
    set seriesName(v) {
        this.i.e = v;
    }
}

var IgxCalloutLayerComponent_1;
/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
const IgxCalloutLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCalloutLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCalloutLayerComponent) }];
let IgxCalloutLayerComponent = IgxCalloutLayerComponent_1 = class IgxCalloutLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
        this._calloutStyleUpdating = null;
        this._calloutContentUpdating = null;
        this._calloutLabelUpdating = null;
        this._calloutSeriesSelecting = null;
    }
    createImplementation() {
        return new CalloutLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the label mapping property for the callouts.
    */
    get labelMemberPath() {
        return this.i.pn;
    }
    set labelMemberPath(v) {
        this.i.pn = v;
    }
    /**
     * Gets or sets the label mapping property for the callouts.
    */
    get xMemberPath() {
        return this.i.pu;
    }
    set xMemberPath(v) {
        this.i.pu = v;
    }
    /**
     * Gets or sets the label mapping property for the callouts.
    */
    get yMemberPath() {
        return this.i.px;
    }
    set yMemberPath(v) {
        this.i.px = v;
    }
    /**
     * Gets or sets the key mapping property for the callouts.
    */
    get keyMemberPath() {
        return this.i.pk;
    }
    set keyMemberPath(v) {
        this.i.pk = v;
    }
    /**
     * Gets or sets whether to allow the callouts to be variable distances from the target points, for suppporting collision modes.
    */
    get isCalloutOffsettingEnabled() {
        return this.i.n9;
    }
    set isCalloutOffsettingEnabled(v) {
        this.i.n9 = ensureBool(v);
    }
    /**
     * Gets or sets the content mapping property for the callouts.
    */
    get contentMemberPath() {
        return this.i.pe;
    }
    set contentMemberPath(v) {
        this.i.pe = v;
    }
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries() {
        if (this.i.nk == null) {
            return null;
        }
        if (!this.i.nk.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.nk);
            if (e) {
                e._implementation = this.i.nk;
            }
            this.i.nk.externalObject = e;
        }
        return this.i.nk.externalObject;
    }
    set targetSeries(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nk = null : this.i.nk = v.i;
    }
    /**
     * Gets or sets a channel name to identify other callout layers within the chart to share collision information with.
    */
    get collisionChannel() {
        return this.i.pb;
    }
    set collisionChannel(v) {
        this.i.pb = v;
    }
    /**
     * Gets or sets how to select the final value to annotate.
    */
    get isAutoCalloutBehaviorEnabled() {
        return this.i.n8;
    }
    set isAutoCalloutBehaviorEnabled(v) {
        this.i.n8 = ensureBool(v);
    }
    /**
     * Gets or sets whether to use values, rather than labels for auto callout labels.
    */
    get useValueForAutoCalloutLabels() {
        return this.i.ob;
    }
    set useValueForAutoCalloutLabels(v) {
        this.i.ob = ensureBool(v);
    }
    /**
     * Gets or sets whether to allow for custom callout styles.
    */
    get isCustomCalloutStyleEnabled() {
        return this.i.oa;
    }
    set isCustomCalloutStyleEnabled(v) {
        this.i.oa = ensureBool(v);
    }
    /**
     * Gets or sets the precision to use when values are used for the auto callout labels.
    */
    get autoCalloutLabelPrecision() {
        return this.i.ot;
    }
    set autoCalloutLabelPrecision(v) {
        this.i.ot = +v;
    }
    /**
     * Gets or sets the color to use for the callout text. Leave unset for an automatic value.
    */
    get calloutTextColor() {
        return brushToString(this.i.q5);
    }
    set calloutTextColor(v) {
        this.i.q5 = stringToBrush(v);
    }
    /**
     * Gets or sets the brush that specifies how the backgrounds for the callouts of the layer are painted. Leave unset for an automatic value.
    */
    get calloutBackground() {
        return brushToString(this.i.q2);
    }
    set calloutBackground(v) {
        this.i.q2 = stringToBrush(v);
    }
    /**
     * Gets or sets the precision to use displaying values for interpolated crosshair positions.
    */
    get calloutInterpolatedValuePrecision() {
        return this.i.ou;
    }
    set calloutInterpolatedValuePrecision(v) {
        this.i.ou = +v;
    }
    /**
     * Gets or sets the brush that specifies how the outlines for the callouts of the layer are painted.
    */
    get calloutOutline() {
        return brushToString(this.i.q4);
    }
    set calloutOutline(v) {
        this.i.q4 = stringToBrush(v);
    }
    /**
     * Gets or sets the brush that specifies how the leader lines for the callouts of the layer are painted.
    */
    get calloutLeaderBrush() {
        return brushToString(this.i.q3);
    }
    set calloutLeaderBrush(v) {
        this.i.q3 = stringToBrush(v);
    }
    /**
     * Gets or sets the left padding to use withing the callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get calloutPaddingLeft() {
        return this.i.om;
    }
    set calloutPaddingLeft(v) {
        this.i.om = +v;
    }
    /**
     * Gets or sets the top padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get calloutPaddingTop() {
        return this.i.oo;
    }
    set calloutPaddingTop(v) {
        this.i.oo = +v;
    }
    /**
     * Gets or sets the right padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get calloutPaddingRight() {
        return this.i.on;
    }
    set calloutPaddingRight(v) {
        this.i.on = +v;
    }
    /**
     * Gets or sets the bottom padding to use within the callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get calloutPaddingBottom() {
        return this.i.ol;
    }
    set calloutPaddingBottom(v) {
        this.i.ol = +v;
    }
    /**
     * Gets or sets the strategy to use for avoiding collisions between the callouts in this layer. Leave unset for an automatic value.
    */
    get calloutCollisionMode() {
        return this.i.ne;
    }
    set calloutCollisionMode(v) {
        this.i.ne = ensureEnum(CalloutCollisionMode_$type, v);
    }
    /**
     * Gets or sets the padding to add to the callout positioning. Leave unset for an automatic value.
    */
    get calloutPositionPadding() {
        return this.i.op;
    }
    set calloutPositionPadding(v) {
        this.i.op = +v;
    }
    /**
     * Gets or sets the stroke thickness for the callout backing. Leave unset for an automatic value.
    */
    get calloutStrokeThickness() {
        return this.i.oq;
    }
    set calloutStrokeThickness(v) {
        this.i.oq = +v;
    }
    /**
     * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
    */
    get textStyle() {
        return this.i.pq;
    }
    set textStyle(v) {
        this.i.pq = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
            return this.targetSeries;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Invalidates content of callout layer
    
    */
    invalidateCalloutContent() {
        this.i.p6();
    }
    /**
     * Event raised when updating style of callout layer
    */
    get calloutStyleUpdating() {
        if (this._calloutStyleUpdating == null) {
            this._calloutStyleUpdating = new EventEmitter();
            this.i.calloutStyleUpdating = delegateCombine(this.i.calloutStyleUpdating, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxCalloutStyleUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeCalloutStyleUpdating) {
                        this.beforeCalloutStyleUpdating(this, outerArgs);
                    }
                    this._calloutStyleUpdating.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._calloutStyleUpdating;
    }
    /**
     * Raised to allow you to decide on the content for an automatically created callout.
    */
    get calloutContentUpdating() {
        if (this._calloutContentUpdating == null) {
            this._calloutContentUpdating = new EventEmitter();
            this.i.calloutContentUpdating = delegateCombine(this.i.calloutContentUpdating, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxCalloutContentUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeCalloutContentUpdating) {
                        this.beforeCalloutContentUpdating(this, outerArgs);
                    }
                    this._calloutContentUpdating.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._calloutContentUpdating;
    }
    /**
     * Raised to allow you to decide on the label for an automatically created callout.
    */
    get calloutLabelUpdating() {
        if (this._calloutLabelUpdating == null) {
            this._calloutLabelUpdating = new EventEmitter();
            this.i.calloutLabelUpdating = delegateCombine(this.i.calloutLabelUpdating, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxCalloutLabelUpdatingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeCalloutLabelUpdating) {
                        this.beforeCalloutLabelUpdating(this, outerArgs);
                    }
                    this._calloutLabelUpdating.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._calloutLabelUpdating;
    }
    /**
     * Raised to allow you to select a target series for a data bound callout.
    */
    get calloutSeriesSelecting() {
        if (this._calloutSeriesSelecting == null) {
            this._calloutSeriesSelecting = new EventEmitter();
            this.i.calloutSeriesSelecting = delegateCombine(this.i.calloutSeriesSelecting, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxCalloutSeriesSelectingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeCalloutSeriesSelecting) {
                        this.beforeCalloutSeriesSelecting(this, outerArgs);
                    }
                    this._calloutSeriesSelecting.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._calloutSeriesSelecting;
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "xMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "yMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "keyMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCalloutLayerComponent.prototype, "isCalloutOffsettingEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "contentMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxSeriesComponent),
    __metadata("design:paramtypes", [IgxSeriesComponent])
], IgxCalloutLayerComponent.prototype, "targetSeries", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "collisionChannel", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCalloutLayerComponent.prototype, "isAutoCalloutBehaviorEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCalloutLayerComponent.prototype, "useValueForAutoCalloutLabels", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCalloutLayerComponent.prototype, "isCustomCalloutStyleEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "autoCalloutLabelPrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "calloutTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "calloutBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutInterpolatedValuePrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "calloutOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "calloutLeaderBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutPaddingLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutPaddingTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutPaddingRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutPaddingBottom", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutCollisionMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutPositionPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCalloutLayerComponent.prototype, "calloutStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCalloutLayerComponent.prototype, "textStyle", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerComponent.prototype, "calloutStyleUpdating", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerComponent.prototype, "calloutContentUpdating", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerComponent.prototype, "calloutLabelUpdating", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerComponent.prototype, "calloutSeriesSelecting", null);
IgxCalloutLayerComponent = IgxCalloutLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-callout-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCalloutLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCalloutLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCalloutLayerModule = class IgxCalloutLayerModule {
};
IgxCalloutLayerModule = __decorate([
    NgModule({
        declarations: [IgxCalloutLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxCalloutLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxCalloutLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCalloutLayerDynamicModule = class IgxCalloutLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCalloutLayerComponent", IgxCalloutLayerComponent);
        TypeRegistrar.register("CalloutLayer", CalloutLayer.$type);
    }
};
IgxCalloutLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCalloutLayerModule],
        exports: [IgxCalloutLayerModule],
        entryComponents: [IgxCalloutLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCalloutLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinalValueLayerFrame extends AxisAnnotationFrame {
}
FinalValueLayerFrame.$t = markType(FinalValueLayerFrame, 'FinalValueLayerFrame', AxisAnnotationFrame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Gets or sets how to select the final value to annotate.
 */
var FinalValueSelectionMode;
(function (FinalValueSelectionMode) {
    /**
     * A mode is selected automatically
     */
    FinalValueSelectionMode[FinalValueSelectionMode["Auto"] = 0] = "Auto";
    /**
     * Displays the last value visible.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["FinalVisible"] = 1] = "FinalVisible";
    /**
     * Displays an interploated last value for when the series leaves view.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["FinalVisibleInterpolated"] = 2] = "FinalVisibleInterpolated";
    /**
     * Displays the last value in the series, whether visible or not.
     */
    FinalValueSelectionMode[FinalValueSelectionMode["Final"] = 3] = "Final";
})(FinalValueSelectionMode || (FinalValueSelectionMode = {}));
/**
 * @hidden
 */
let FinalValueSelectionMode_$type = markEnum('FinalValueSelectionMode', 'Auto,0|FinalVisible,1|FinalVisibleInterpolated,2|Final,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinalValueLayer extends AnnotationLayer {
    constructor() {
        super();
        this.axisAnnotationFormatLabel = null;
        this.nk = null;
        this.nj = null;
        let a = new FinalValueLayerFrame();
        let b = new FinalValueLayerFrame();
        let c = new FinalValueLayerFrame();
        let d = this.fi / 1000;
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = FinalValueLayer.$;
    }
    bf() {
        return new FinalValueLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.nf = a;
    }
    get oj() {
        return new Thickness(1, this.nm, this.no, this.nn, this.nl);
    }
    ni() {
        return this.axisAnnotationFormatLabel != null;
    }
    mv(a, b) {
        if (this.nh == null || this.nh == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        c.f.clear();
        c.q.clear();
        c.p.clear();
        c.aa.clear();
        c.o.clear();
        c.z.clear();
        c.g.clear();
        c.h.clear();
        c.j.clear();
        c.l.clear();
        c.k.clear();
        c.i.clear();
        c.m.clear();
        c.n.clear();
        c.r.clear();
        c.s.clear();
        c.u.clear();
        c.w.clear();
        c.v.clear();
        c.t.clear();
        c.x.clear();
        c.y.clear();
        if (this.mi(this.nh)) {
            this.n2(this.nh, c);
        }
        else {
            for (let d of fromEnum(this.bs.series)) {
                if (this.mi(d)) {
                    this.n2(d, c);
                }
            }
        }
    }
    mi(a) {
        if (!super.mi(a)) {
            return false;
        }
        return true;
    }
    iw() {
        super.iw();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.n3(this.md, false);
        }
        else {
            this.n3(this.mb, false);
        }
    }
    oi(a) {
        let b = NaN;
        let c = NaN;
        let d = this.ng;
        if (d == 0) {
            d = 1;
        }
        let e = false;
        if (d == 2) {
            e = true;
        }
        if (a.isVertical) {
            let f = a.ap();
            if (f != null) {
                if (d == 1 || d == 2) {
                    if (f.ca) {
                        c = a.ly({ $type: Point_$type, x: this.l8.right, y: this.l8.bottom }).y;
                    }
                    else {
                        c = a.ly({ $type: Point_$type, x: this.l8.right, y: this.l8.top }).y;
                    }
                }
                else {
                    if (f.ca) {
                        c = 1;
                    }
                    else {
                        c = 0;
                    }
                }
            }
            return a.lv({ $type: Point_$type, x: 0, y: c }, e, true);
        }
        else {
            let g = a.ap();
            if (g != null) {
                if (d == 1 || d == 2) {
                    if (g.ca) {
                        b = a.ly({ $type: Point_$type, x: this.l8.left, y: this.l8.top }).x;
                    }
                    else {
                        b = a.ly({ $type: Point_$type, x: this.l8.right, y: this.l8.top }).x;
                    }
                }
                else {
                    if (g.ca) {
                        b = 0;
                    }
                    else {
                        b = 1;
                    }
                }
            }
            if (a.cr) {
                return a.lv({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
            else {
                return a.lv({ $type: Point_$type, x: b, y: 0 }, e, true);
            }
        }
    }
    n2(a, b) {
        let c = this.oi(a);
        let d = this.ly(c);
        let e = this.lb;
        if (e == null) {
            e = this.ld;
        }
        if (e == null) {
            e = a.lb;
            if (e != null) {
                e = this.nf.b2(e);
            }
        }
        AxisAnnotationFrameManager.c(b, c, a, this.bs, this.getEffectiveViewport(), e, this.of, this.oh, this.og, this.oj, this.np, this.of, this.oh, this.og, this.oj, this.np, a.isVertical, !a.isVertical);
    }
    n3(a, b) {
        let c = false;
        if (this.nj == null) {
            c = true;
            this.nk = new List$1(Axis.$, 0);
            this.nj = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.nj, this.nk, b, this.nq, this.nq, this.axisAnnotationFormatLabel, this.axisAnnotationFormatLabel);
    }
    m0(a, b) {
        super.m0(a, b);
        if (this.ca()) {
            this.n3(this.md, true);
        }
        else {
            this.n3(this.mb, false);
        }
    }
    c8() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case FinalValueLayer.$$p[10]:
                this.jl(true);
                break;
            case FinalValueLayer.$$p[0]:
            case FinalValueLayer.$$p[2]:
            case FinalValueLayer.$$p[4]:
            case FinalValueLayer.$$p[6]:
            case FinalValueLayer.$$p[5]:
            case FinalValueLayer.$$p[3]:
            case FinalValueLayer.$$p[7]:
            case FinalValueLayer.$$p[8]:
            case FinalValueLayer.$$p[9]:
                this.jl(true);
                break;
            case "SeriesViewer":
                let e = this.nk;
                let f = this.nj;
                if (f != null) {
                    for (let g of fromEnum(f)) {
                        let h = g.value;
                        h.c((i) => g.key.am.remove(i));
                        h.clear();
                    }
                    e.clear();
                    f.clear();
                }
                break;
        }
    }
}
FinalValueLayer.$t = markType(FinalValueLayer, 'FinalValueLayer', AnnotationLayer.$);
FinalValueLayer.$$p = markDep(DependencyProperty, PropertyMetadata, FinalValueLayer, 'raisePropertyChanged', ['AxisAnnotationBackground:of:n4', [Brush.$, null], 'AxisAnnotationInterpolatedValuePrecision:nq:n5', [1, -1], 'AxisAnnotationOutline:og:n6', [Brush.$, null], 'AxisAnnotationPaddingBottom:nl:n7', [1, NaN], 'AxisAnnotationPaddingLeft:nm:n8', [1, NaN], 'AxisAnnotationPaddingRight:nn:n9', [1, NaN], 'AxisAnnotationPaddingTop:no:oa', [1, NaN], 'AxisAnnotationStrokeThickness:np:ob', [1, NaN], 'AxisAnnotationTextColor:oh:oc', [Brush.$, null], 'FinalValueSelectionMode:ng:od', [FinalValueSelectionMode_$type, enumGetBox(FinalValueSelectionMode_$type, 0)], 'TargetSeries:nh:oe', [Series.$, null]]);
/**
 * @hidden
 */
class FinalValueLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b1 = a;
    }
    ap() {
        super.ap();
    }
    b2(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    }
    ai(a) {
        super.ai(a);
    }
}
FinalValueLayerView.$t = markType(FinalValueLayerView, 'FinalValueLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxFinalValueLayerComponent_1;
/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
const IgxFinalValueLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxFinalValueLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinalValueLayerComponent) }];
let IgxFinalValueLayerComponent = IgxFinalValueLayerComponent_1 = class IgxFinalValueLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new FinalValueLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries() {
        if (this.i.nh == null) {
            return null;
        }
        if (!this.i.nh.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.nh);
            if (e) {
                e._implementation = this.i.nh;
            }
            this.i.nh.externalObject = e;
        }
        return this.i.nh.externalObject;
    }
    set targetSeries(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nh = null : this.i.nh = v.i;
    }
    /**
     * Gets or sets how to select the final value to annotate.
    */
    get finalValueSelectionMode() {
        return this.i.ng;
    }
    set finalValueSelectionMode(v) {
        this.i.ng = ensureEnum(FinalValueSelectionMode_$type, v);
    }
    /**
     * Gets or sets the color to use for the axis annotation text. Leave unset for an automatic value.
    */
    get axisAnnotationTextColor() {
        return brushToString(this.i.oh);
    }
    set axisAnnotationTextColor(v) {
        this.i.oh = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the axis annotation backing. Leave unset for an automatic value.
    */
    get axisAnnotationBackground() {
        return brushToString(this.i.of);
    }
    set axisAnnotationBackground(v) {
        this.i.of = stringToBrush(v);
    }
    /**
     * Gets or sets the precision to use displaying values for interpolated crosshair positions.
    */
    get axisAnnotationInterpolatedValuePrecision() {
        return this.i.nq;
    }
    set axisAnnotationInterpolatedValuePrecision(v) {
        this.i.nq = +v;
    }
    /**
     * Gets or sets the color to use for the axis annotation outline. Leave unset for an automatic value.
    */
    get axisAnnotationOutline() {
        return brushToString(this.i.og);
    }
    set axisAnnotationOutline(v) {
        this.i.og = stringToBrush(v);
    }
    /**
     * Gets or sets the left padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingLeft() {
        return this.i.nm;
    }
    set axisAnnotationPaddingLeft(v) {
        this.i.nm = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingTop() {
        return this.i.no;
    }
    set axisAnnotationPaddingTop(v) {
        this.i.no = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingRight() {
        return this.i.nn;
    }
    set axisAnnotationPaddingRight(v) {
        this.i.nn = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get axisAnnotationPaddingBottom() {
        return this.i.nl;
    }
    set axisAnnotationPaddingBottom(v) {
        this.i.nl = +v;
    }
    /**
     * Gets or sets the stroke thickness for the axis annotation backing. Leave unset for an automatic value.
    */
    get axisAnnotationStrokeThickness() {
        return this.i.np;
    }
    set axisAnnotationStrokeThickness(v) {
        this.i.np = +v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
            return this.targetSeries;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxSeriesComponent),
    __metadata("design:paramtypes", [IgxSeriesComponent])
], IgxFinalValueLayerComponent.prototype, "targetSeries", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "finalValueSelectionMode", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationInterpolatedValuePrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationPaddingBottom", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinalValueLayerComponent.prototype, "axisAnnotationStrokeThickness", null);
IgxFinalValueLayerComponent = IgxFinalValueLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-final-value-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxFinalValueLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinalValueLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxFinalValueLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinalValueLayerModule = class IgxFinalValueLayerModule {
};
IgxFinalValueLayerModule = __decorate([
    NgModule({
        declarations: [IgxFinalValueLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxFinalValueLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxFinalValueLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinalValueLayerDynamicModule = class IgxFinalValueLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxFinalValueLayerComponent", IgxFinalValueLayerComponent);
        TypeRegistrar.register("FinalValueLayer", FinalValueLayer.$type);
    }
};
IgxFinalValueLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxFinalValueLayerModule],
        exports: [IgxFinalValueLayerModule],
        entryComponents: [IgxFinalValueLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFinalValueLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CrosshairLayerFrame extends AxisAnnotationFrame {
    constructor() {
        super();
        this.ad = null;
        this.ae = null;
        this.ac = null;
        this.af = null;
        this.ad = new List$1(Number_$type, 0);
        this.ae = new List$1(Number_$type, 0);
        this.ac = new List$1(Brush.$, 0);
        this.af = new List$1(Brush.$, 0);
    }
    c(a, b, c) {
        super.c(a, b, c);
        let d = b;
        let e = c;
        Frame.b(this.ad, a, d.ad, e.ad);
        Frame.b(this.ae, a, d.ae, e.ae);
        FrameExtended.a(this.ac, a, d.ac, e.ac, 0);
        FrameExtended.a(this.af, a, d.af, e.af, 0);
    }
}
CrosshairLayerFrame.$t = markType(CrosshairLayerFrame, 'CrosshairLayerFrame', AxisAnnotationFrame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemHighlightFrameRect extends Base {
    constructor() {
        super();
        this.f = 0;
        this.e = 0;
        this.b = 0;
        this.c = 0;
        this.a = 0;
        this.i = null;
        this.j = null;
        this.h = null;
        this.g = null;
        this.d = 0;
        this.f = 0;
        this.e = NaN;
        this.b = NaN;
        this.c = NaN;
        this.b = NaN;
        this.a = NaN;
        this.d = NaN;
    }
}
ItemHighlightFrameRect.$t = markType(ItemHighlightFrameRect, 'ItemHighlightFrameRect');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available shapes for a category item highlight.
 */
var CategoryItemHighlightType;
(function (CategoryItemHighlightType) {
    /**
     * The default depends on the series being highlighted.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Auto"] = 0] = "Auto";
    /**
     * The highlight should use a marker shape.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Marker"] = 1] = "Marker";
    /**
     * The highlight should use a filled band shape.
     */
    CategoryItemHighlightType[CategoryItemHighlightType["Shape"] = 2] = "Shape";
})(CategoryItemHighlightType || (CategoryItemHighlightType = {}));
/**
 * @hidden
 */
let CategoryItemHighlightType_$type = markEnum('CategoryItemHighlightType', 'Auto,0|Marker,1|Shape,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryItemHighlightLayerFrame extends Frame {
    constructor() {
        super();
        this.g = null;
        this.f = null;
        this.g = new Dictionary$2(Number_$type, ItemHighlightFrameRect.$, 0);
        this.f = new DictInterpolator$3(Number_$type, ItemHighlightFrameRect.$, CategoryItemHighlightLayerFrame.$, runOn(this, this.h), (a) => a.f, (a) => true, () => new ItemHighlightFrameRect());
    }
    h(a, b, c, d, e, f) {
        if (d != null) {
            a.f = d.f;
        }
        else if (c != null) {
            a.f = c.f;
        }
        else {
            a.f = 0;
        }
        if (c == null || isNaN_(c.e)) {
            a.e = d != null ? d.e : NaN;
        }
        else if (d == null || isNaN_(d.e)) {
            a.e = NaN;
        }
        else {
            a.e = c.e + b * (d.e - c.e);
        }
        if (c == null || isNaN_(c.b)) {
            a.b = d != null ? d.b : NaN;
        }
        else if (d == null || isNaN_(d.b)) {
            a.b = NaN;
        }
        else {
            a.b = c.b + b * (d.b - c.b);
        }
        if (c == null || isNaN_(c.c)) {
            a.c = d != null ? d.c : NaN;
        }
        else if (d == null || isNaN_(d.c)) {
            a.c = NaN;
        }
        else {
            a.c = c.c + b * (d.c - c.c);
        }
        if (c == null || isNaN_(c.a)) {
            a.a = d != null ? d.a : NaN;
        }
        else if (d == null || isNaN_(d.a)) {
            a.a = NaN;
        }
        else {
            a.a = c.a + b * (d.a - c.a);
        }
        if (c == null || isNaN_(c.d)) {
            a.d = d != null ? d.d : NaN;
        }
        else if (d == null || isNaN_(d.d)) {
            a.d = NaN;
        }
        else {
            a.d = c.d + b * (d.d - c.d);
        }
        if (c == null || c.i == null) {
            a.i = d != null ? d.i : null;
        }
        else if (d == null || d.i == null) {
            a.i = null;
        }
        else {
            a.i = BrushUtil.k(c.i, b, d.i, 0);
        }
        if (c == null || c.j == null) {
            a.j = d != null ? d.j : null;
        }
        else if (d == null || d.j == null) {
            a.j = null;
        }
        else {
            a.j = BrushUtil.k(c.j, b, d.j, 0);
        }
        if (c == null || c.h == null) {
            a.h = d != null ? d.h : null;
        }
        else if (d == null || d.j == null) {
            a.h = null;
        }
        else {
            a.h = d.h;
        }
        if (c == null || c.g == null) {
            a.g = d != null ? d.g : null;
        }
        else if (d == null || d.j == null) {
            a.g = null;
        }
        else {
            a.g = d.g;
        }
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        this.f.f(this.g, a, d.g, e.g, d, e);
    }
}
CategoryItemHighlightLayerFrame.$t = markType(CategoryItemHighlightLayerFrame, 'CategoryItemHighlightLayerFrame', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryItemHighlightLayer extends AnnotationLayer {
    constructor() {
        super();
        this.nk = false;
        this.nj = true;
        this.nn = 10;
        let a = new CategoryItemHighlightLayerFrame();
        let b = new CategoryItemHighlightLayerFrame();
        let c = new CategoryItemHighlightLayerFrame();
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = CategoryItemHighlightLayer.$;
    }
    bf() {
        return new CategoryItemHighlightLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.ne = a;
    }
    mv(a, b) {
        if (this.ni == null || this.ni == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mi(a) {
        if (!super.mi(a)) {
            return false;
        }
        let b = this.mq(a);
        if (!b.c) {
            return false;
        }
        return true;
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        let d = this.nm;
        c.g.clear();
        if (isNaN_(this.nb.x) && isNaN_(this.nb.y)) {
            return;
        }
        if (this.mi(this.ni)) {
            this.n0(this.ni, c, d);
        }
        else {
            for (let e of fromEnum(this.bs.series)) {
                if (this.mi(e)) {
                    this.n0(e, c, d);
                }
            }
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case CategoryItemHighlightLayer.$$p[4]:
            case CategoryItemHighlightLayer.$$p[5]:
            case CategoryItemHighlightLayer.$$p[2]:
            case CategoryItemHighlightLayer.$$p[3]:
                this.jl(true);
                break;
            case CategoryItemHighlightLayer.$$p[7]:
                this.jl(true);
                break;
            case CategoryItemHighlightLayer.$$p[8]:
                this.nk = d;
                this.jl(true);
                break;
            case CategoryItemHighlightLayer.$$p[1]:
                this.jl(true);
                break;
            case CategoryItemHighlightLayer.$$p[0]:
                this.nn = this.no;
                this.jl(true);
                break;
            case CategoryItemHighlightLayer.$$p[6]:
                this.nj = d;
                this.jl(true);
                break;
        }
    }
    n0(a, b, c) {
        if (this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return;
        }
        if (!a.cl && !a.cr) {
            return;
        }
        let d = a;
        if (d.categoryAxis == null) {
            return;
        }
        let e = this.nb.x;
        e = this.bi.br.left + this.bi.br.width * (e - this.bi.bs.left) / this.bi.bs.width;
        let f = this.nb.y;
        f = this.bi.br.top + this.bi.br.height * (f - this.bi.bs.top) / this.bi.bs.height;
        let g = this.nl;
        let h = true;
        let i = typeCast(IHasCategoryModePreference_$type, a);
        let j = 0;
        if (i != null) {
            j = i.preferredCategoryMode(d.categoryAxis);
            if (j == 2) {
                h = false;
            }
        }
        let k = true;
        if (!h || this.nf == 2) {
            k = false;
        }
        if (this.nf == 1) {
            k = true;
        }
        let l = this.mq(a);
        if (!l.c) {
            return;
        }
        if (k) {
            let m = a.lv(l.d, this.nm, g);
            if (j != 0 && !d.categoryAxis.cf) {
                let n = m.x;
                if (a.cr) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
                else if (a.cl) {
                    n -= a.getOffsetValue();
                    n += a.getCategoryWidth() * 0.5;
                    m = { $type: Point_$type, x: n, y: m.y };
                }
            }
            if (!isNaN_(m.x) && !isNaN_(m.y)) {
                m = this.ly(m);
            }
            this.ny(m, b, a);
        }
        else {
            let o = a.lv(l.d, this.nm, g);
            let p;
            let q = this.getEffectiveViewport1(this.bi);
            if (a.isVertical) {
                let r = o.y;
                let s = d.categoryAxis;
                let t = this.nn;
                if (j != 0) {
                    t = s.jz(this.bi.bs, this.bi.br, q);
                }
                if (isNaN_(t) || isInfinity(t)) {
                    return;
                }
                p = new Rect(0, this.l8.left, r - t / 2, this.l8.width, t);
            }
            else {
                let u = o.x;
                let v = d.categoryAxis;
                let w = this.nn;
                if (j != 0) {
                    w = v.jz(this.bi.bs, this.bi.br, q);
                }
                if (isNaN_(w) || isInfinity(w)) {
                    return;
                }
                p = new Rect(0, u - w / 2, this.l8.top, w, this.l8.height);
            }
            p.intersect(this.bi.br);
            this.nz(p, b, a);
        }
    }
    ny(a, b, c) {
        let d = new ItemHighlightFrameRect();
        d.b = a.x;
        d.e = a.y;
        d.i = this.m9();
        if (this.od != null) {
            d.i = this.od;
        }
        d.j = this.na();
        if (this.oe != null) {
            d.j = this.oe;
        }
        if (d.i == null) {
            if (c.hasMarkers) {
                d.i = this.ne.cf(c.lg());
            }
            else {
                d.i = this.ne.cf(c.lb);
            }
        }
        if (d.j == null) {
            if (c.hasMarkers) {
                d.j = this.ne.cf(c.lh());
            }
            else {
                d.j = this.ne.cf(c.lc);
            }
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        d.g = this.ng(c, a);
        let e = (typeCast(MarkerSeries.$, c) !== null) ? c.mu : null;
        if (e == null || e == MarkerSeries.mx || (this.nh != 2 && this.nh != 0)) {
            let f = MarkerSeries.mc(c, 2);
            if (this.nh != 2 && this.nh != 0) {
                f = this.nh;
            }
            switch (f) {
                case 3:
                case 13:
                    e = this.bs.ls;
                    break;
                case 4:
                    e = this.bs.l1;
                    break;
                case 5:
                    e = this.bs.ly;
                    break;
                case 6:
                    e = this.bs.lz;
                    break;
                case 7:
                    e = this.bs.lt;
                    break;
                case 8:
                    e = this.bs.lw;
                    break;
                case 9:
                    e = this.bs.lu;
                    break;
                case 10:
                    e = this.bs.l0;
                    break;
                case 11:
                    e = this.bs.lx;
                    break;
                case 12:
                    e = this.bs.lv;
                    break;
            }
        }
        d.h = this.n3 != null ? this.n3 : e;
        if (!isNaN_(d.b) && !isNaN_(d.e)) {
            b.g.addItem(d.f, d);
        }
    }
    ng(a, b) {
        let c = a.fp(b);
        let d = a.eb(b);
        if (this.nm && d != Math.floor(d)) {
            c = null;
        }
        return ((() => {
            let $ret = new DataContext();
            $ret.series = a;
            $ret.item = c;
            return $ret;
        })());
    }
    nz(a, b, c) {
        let d = new ItemHighlightFrameRect();
        d.b = a.left;
        d.e = a.top;
        d.c = a.right;
        d.a = a.bottom;
        d.i = this.m9();
        d.j = this.na();
        if (d.i == null) {
            if (c != null) {
                d.i = this.ne.cg(c.lb);
            }
        }
        if (d.j == null) {
            if (c != null) {
                d.j = this.ne.cg(c.lc);
            }
        }
        d.d = this.ey;
        d.f = Base.getHashCodeStatic(c);
        if (!a.isEmpty) {
            b.g.addItem(d.f, d);
        }
    }
    m0(a, b) {
        super.m0(a, b);
        let c = this.ne.b3;
        let d = this.ne.b2;
        let e = 0;
        let f = 0;
        let g = a;
        for (let h of fromEnum(g.g.values)) {
            if (h.h != null) {
                let i = d.item(f);
                this.n1(h, i);
                f++;
            }
            else {
                let j = c.item(e);
                this.n2(h, j);
                e++;
            }
        }
        c.count = e;
        d.count = f;
    }
    n1(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.d) || a.g == null) {
            b._visibility = 1;
            return;
        }
        let c = { $type: Point_$type, x: a.b, y: a.e };
        let d = a.g;
        d.itemBrush = a.i;
        let e = d.series.lv(c, this.ca() || this.nk, this.nj);
        if (isNaN_(e.x) || isNaN_(e.y)) {
            b._visibility = 1;
            return;
        }
        this.ne.b9(b, e.x, e.y);
        b.ah = a.h;
        b.content = a.g;
    }
    n2(a, b) {
        if (isNaN_(a.b) || isNaN_(a.e) || isNaN_(a.a) || isNaN_(a.c) || isNaN_(a.d)) {
            b._visibility = 1;
            return;
        }
        this.ne.ca(b, a.b, a.e, a.c - a.b, a.a - a.e);
        b._fill = a.i;
        b._stroke = a.j;
        b.ac = a.d;
        if (this.ll != null) {
            b.ai = this.ll;
        }
        else {
            b.ai = null;
        }
        b.ad = this.lm;
    }
    c8() {
        return true;
    }
}
CategoryItemHighlightLayer.$t = markType(CategoryItemHighlightLayer, 'CategoryItemHighlightLayer', AnnotationLayer.$);
CategoryItemHighlightLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryItemHighlightLayer, 'raisePropertyChanged', ['BandHighlightWidth:no:n4', [1, 10], 'HighlightType:nf:n5', [CategoryItemHighlightType_$type, enumGetBox(CategoryItemHighlightType_$type, 0)], 'MarkerBrush:od:n6', [Brush.$, null], 'MarkerOutline:oe:n7', [Brush.$, null], 'MarkerTemplate:n3:n8', [DataTemplate.$, null], 'MarkerType:nh:n9', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'SkipUnknownValues:nl:oa', [0, true], 'TargetSeries:ni:ob', [Series.$, null], 'UseInterpolation:nm:oc', [0, false]]);
/**
 * @hidden
 */
class CategoryItemHighlightLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b3 = null;
        this.b2 = null;
        this.b4 = null;
        this.b5 = null;
        this.b1 = a;
        this.b4 = new List$1(ContentControl.$, 0);
        this.b5 = new List$1(Rectangle.$, 0);
    }
    ap() {
        super.ap();
        this.b3 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.ch);
            $ret.activate = runOn(this, this.cb);
            $ret.disactivate = runOn(this, this.cd);
            $ret.destroy = runOn(this, this.cc);
            return $ret;
        })());
        this.b2 = ((() => {
            let $ret = new Pool$1(ContentControl.$);
            $ret.create = runOn(this, this.ce);
            $ret.activate = runOn(this, this.b6);
            $ret.disactivate = runOn(this, this.b8);
            $ret.destroy = runOn(this, this.b7);
            return $ret;
        })());
    }
    ch() {
        let a = new Rectangle();
        a.ab = false;
        this.b5.add(a);
        return a;
    }
    cb(a) {
        a._visibility = 0;
    }
    cd(a) {
        a._visibility = 1;
    }
    cc(a) {
        this.b5.remove(a);
    }
    ce() {
        let a = new Marker();
        this.b4.add(a);
        return a;
    }
    b6(a) {
        a._visibility = 0;
    }
    b8(a) {
        a._visibility = 1;
    }
    b7(a) {
        this.b4.remove(a);
    }
    cf(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.3);
    }
    cg(a) {
        if (a != null) {
            let b = BrushUtil.l(a, 0.3);
            if (b.isGradient) {
                let c = b;
                if (c.gradientStops != null) {
                    for (let d = 0; d < c.gradientStops.length; d++) {
                        let e = c.gradientStops[d];
                        e.color = Color.u(truncate(Math.round((e.color.l) * 0.3)), e.color.o, e.color.n, e.color.m);
                        e.color = e.color;
                    }
                }
            }
            else {
                b.color = Color.u(truncate(Math.round((b.color.l & 255) * 0.3)), b.color.o, b.color.n, b.color.m);
                b.color = b.color;
            }
            return b;
        }
        else {
            return null;
        }
    }
    ca(a, b, c, d, e) {
        a._visibility = 0;
        a.n = b;
        a.o = c;
        a.width = d;
        a.height = e;
    }
    b9(a, b, c) {
        a.n = b;
        a.o = c;
    }
    be(a, b) {
        super.be(a, b);
        let c = a;
        let d = c.content;
        if (d != null) {
            if (d.itemBrush != null) {
                d.actualItemBrush = d.itemBrush;
            }
            let e = d.series;
            if (e.hasMarkers) {
                d.outline = e.lh();
            }
            d.thickness = 0.5;
        }
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b5.count; c++) {
                let d = this.b5._inner[c];
                if (d._visibility == 0) {
                    a.v(d);
                }
            }
            if (this.b4.count > 0) {
                let e = new DataTemplatePassInfo();
                e.isHitTestRender = b;
                e.context = a.g();
                e.viewportTop = this.br.top;
                e.viewportLeft = this.br.left;
                e.viewportWidth = this.br.width;
                e.viewportHeight = this.br.height;
                e.passID = "ItemMarkers";
                let f = new DataTemplateRenderInfo();
                f.isHitTestRender = b;
                f.passInfo = e;
                let g = new DataTemplateMeasureInfo();
                g.passInfo = e;
                let h = false;
                let i = a.g();
                g.context = i;
                f.context = i;
                g.renderContext = a;
                f.renderContext = a;
                let j = 0;
                let k = 0;
                let l = new Dictionary$2(DataTemplate.$, DataTemplate.$, 0);
                for (let m = 0; m < this.b4.count; m++) {
                    let n = this.b4._inner[m];
                    let o = n.ah;
                    if (!l.containsKey(o)) {
                        l.addItem(o, o);
                        if (o != null && o.passStarting != null) {
                            o.passStarting(e);
                        }
                    }
                    if (n._visibility == 1) {
                        continue;
                    }
                    this.bd(n, m, b);
                    if (!h) {
                        g.data = n.content;
                        g.width = n.width;
                        g.height = n.height;
                        if (o.measure != null) {
                            g.data = n.content;
                            o.measure(g);
                            h = g.isConstant;
                            if (h) {
                                j = g.width;
                                k = g.height;
                            }
                        }
                        f.availableWidth = g.width;
                        f.availableHeight = g.height;
                    }
                    else {
                        f.availableWidth = j;
                        f.availableHeight = k;
                    }
                    if (!isNaN_(n.width) && !isInfinity(n.width)) {
                        f.availableWidth = n.width;
                    }
                    if (!isNaN_(n.height) && !isInfinity(n.height)) {
                        f.availableHeight = n.height;
                    }
                    a.p(f, n);
                    n.m = f.availableWidth;
                    n.l = f.availableHeight;
                }
                for (let p of fromEnum(l.keys)) {
                    if (p != null && p.passCompleted != null) {
                        p.passCompleted(e);
                    }
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b5.count; b++) {
            this.e.a2.exportRectangleData(a, this.b5._inner[b], "catItemRect", ["Main", "CategoryItem"]);
        }
        for (let c = 0; c < this.b4.count; c++) {
            this.e.a2.exportMarkerVisualDataFromMarker(this.e, a, this.b4._inner[c]);
        }
    }
}
CategoryItemHighlightLayerView.$t = markType(CategoryItemHighlightLayerView, 'CategoryItemHighlightLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxCategoryItemHighlightLayerComponent_1;
/**
 * Represents an annotation layer that highlights items in a series that use a category axis
 * either by drawing a banded shape at their position, or by rendering a marker at their position.
 * Depending on the type of series, the default highlight will be affected. To override
 * the type of highlight used, you can set the HighlightType property.
*/
const IgxCategoryItemHighlightLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryItemHighlightLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryItemHighlightLayerComponent) }];
let IgxCategoryItemHighlightLayerComponent = IgxCategoryItemHighlightLayerComponent_1 = class IgxCategoryItemHighlightLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CategoryItemHighlightLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries() {
        if (this.i.ni == null) {
            return null;
        }
        if (!this.i.ni.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.ni);
            if (e) {
                e._implementation = this.i.ni;
            }
            this.i.ni.externalObject = e;
        }
        return this.i.ni.externalObject;
    }
    set targetSeries(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ni = null : this.i.ni = v.i;
    }
    /**
     * Gets or sets whether to use value interpolation when drawing a line through the best value for the pointer position.
    */
    get useInterpolation() {
        return this.i.nm;
    }
    set useInterpolation(v) {
        this.i.nm = ensureBool(v);
    }
    /**
     * Gets or sets which type of highlight shape to use when highlighting items.
    */
    get highlightType() {
        return this.i.nf;
    }
    set highlightType(v) {
        this.i.nf = ensureEnum(CategoryItemHighlightType_$type, v);
    }
    /**
     * Gets or sets which type of marker to use when highlighting items, if appropriate.
    */
    get markerType() {
        return this.i.nh;
    }
    set markerType(v) {
        this.i.nh = ensureEnum(MarkerType_$type, v);
    }
    /**
     * Gets or sets which color to use for the marker when highlighting items, if appropriate.
    */
    get markerBrush() {
        return brushToString(this.i.od);
    }
    set markerBrush(v) {
        this.i.od = stringToBrush(v);
    }
    /**
     * Gets or sets which outline color to use for the marker when highlighting items, if appropriate.
    */
    get markerOutline() {
        return brushToString(this.i.oe);
    }
    set markerOutline(v) {
        this.i.oe = stringToBrush(v);
    }
    /**
     * Gets or sets the template to use for marker visuals for the current series object.
    */
    get markerTemplate() {
        return this.i.n3;
    }
    set markerTemplate(v) {
        this.i.n3 = v;
    }
    /**
     * Gets or sets the width to use for the highlight region if highlighting items in a grid aligned series (line, spline, etc), with a banded shape.
    */
    get bandHighlightWidth() {
        return this.i.no;
    }
    set bandHighlightWidth(v) {
        this.i.no = +v;
    }
    /**
     * Gets or sets whether to skip unknown values when searching for series values.
    */
    get skipUnknownValues() {
        return this.i.nl;
    }
    set skipUnknownValues(v) {
        this.i.nl = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
            return this.targetSeries;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxSeriesComponent),
    __metadata("design:paramtypes", [IgxSeriesComponent])
], IgxCategoryItemHighlightLayerComponent.prototype, "targetSeries", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryItemHighlightLayerComponent.prototype, "useInterpolation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryItemHighlightLayerComponent.prototype, "highlightType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryItemHighlightLayerComponent.prototype, "markerType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCategoryItemHighlightLayerComponent.prototype, "markerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCategoryItemHighlightLayerComponent.prototype, "markerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxCategoryItemHighlightLayerComponent.prototype, "markerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryItemHighlightLayerComponent.prototype, "bandHighlightWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryItemHighlightLayerComponent.prototype, "skipUnknownValues", null);
IgxCategoryItemHighlightLayerComponent = IgxCategoryItemHighlightLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-category-item-highlight-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCategoryItemHighlightLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategoryItemHighlightLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryItemHighlightLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryItemHighlightLayerModule = class IgxCategoryItemHighlightLayerModule {
};
IgxCategoryItemHighlightLayerModule = __decorate([
    NgModule({
        declarations: [IgxCategoryItemHighlightLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxCategoryItemHighlightLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxCategoryItemHighlightLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryItemHighlightLayerDynamicModule = class IgxCategoryItemHighlightLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryItemHighlightLayerComponent", IgxCategoryItemHighlightLayerComponent);
        TypeRegistrar.register("CategoryItemHighlightLayer", CategoryItemHighlightLayer.$type);
    }
};
IgxCategoryItemHighlightLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryItemHighlightLayerModule],
        exports: [IgxCategoryItemHighlightLayerModule],
        entryComponents: [IgxCategoryItemHighlightLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryItemHighlightLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CrosshairLayer extends AnnotationLayer {
    constructor() {
        super();
        this.xAxisAnnotationFormatLabel = null;
        this.yAxisAnnotationFormatLabel = null;
        this.no = null;
        this.nn = null;
        let a = new CrosshairLayerFrame();
        let b = new CrosshairLayerFrame();
        let c = new CrosshairLayerFrame();
        let d = this.fi / 1000;
        this.mc = a;
        this.mb = b;
        this.md = c;
        this.ab = CrosshairLayer.$;
    }
    bf() {
        return new CrosshairLayerView(this);
    }
    i2(a) {
        super.i2(a);
        this.ng = a;
    }
    ni() {
        return this.xAxisAnnotationFormatLabel != null;
    }
    nj() {
        return this.yAxisAnnotationFormatLabel != null;
    }
    get ps() {
        return new Thickness(1, this.nq, this.ns, this.nr, this.np);
    }
    get pt() {
        return new Thickness(1, this.nv, this.nx, this.nw, this.nu);
    }
    mv(a, b) {
        if (this.nh == null || this.nh == a) {
            if (!this.aq.c) {
                this.jl(b);
            }
        }
    }
    mx(a, b) {
        super.mx(a, b);
        let c = a;
        let d = this.nm;
        let e = this.nl;
        c.ad.clear();
        c.ae.clear();
        c.ac.clear();
        c.af.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.mi(this.nh)) {
            this.os(this.nh, c, d, e);
        }
        else {
            for (let f of fromEnum(this.bs.series)) {
                if (this.mi(f)) {
                    this.os(f, c, d, e);
                }
            }
        }
    }
    mi(a) {
        if (!super.mi(a)) {
            return false;
        }
        let b = this.mq(a);
        if (!b.c) {
            return false;
        }
        return true;
    }
    iw() {
        super.iw();
        if (!this.aq.c && !this.ca()) {
            return;
        }
        if (this.ca()) {
            this.ot(this.md, false);
        }
        else {
            this.ot(this.mb, false);
        }
    }
    os(a, b, c, d) {
        let e = this.mq(a);
        if (!e.c) {
            return;
        }
        let f = e.d;
        f = a.lv(f, c, d);
        let g = this.lb;
        if (g == null) {
            g = this.ld;
        }
        if (g == null) {
            g = a.lb;
            if (g != null) {
                g = this.ng.b8(g);
            }
        }
        let h = g;
        let i = g;
        if (this.pk != null) {
            h = this.pk;
        }
        if (this.pl != null) {
            i = this.pl;
        }
        b.ac.add(h);
        b.af.add(i);
        b.ad.add(f.y);
        b.ae.add(f.x);
        if (this.nk) {
            AxisAnnotationFrameManager.c(b, f, a, this.bs, this.getEffectiveViewport(), g, this.pm, this.po, this.pn, this.ps, this.nt, this.pp, this.pr, this.pq, this.pt, this.ny, this.pv == 0, this.pu == 0);
        }
    }
    ot(a, b) {
        let c = false;
        if (this.nn == null) {
            c = true;
            this.no = new List$1(Axis.$, 0);
            this.nn = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.nn, this.no, b, this.nz, this.n0, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    }
    or(a, b, c, d, e) {
        let f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.af._inner[c];
            f._fill = d.af._inner[c];
        }
        else {
            f._stroke = d.ac._inner[c];
            f._fill = d.ac._inner[c];
        }
        f.ac = this.ey;
        f.ai = this.ll;
        f.ad = this.lm;
        return new Tuple$2(Path.$, Number_$type, f, b);
    }
    m0(a, b) {
        super.m0(a, b);
        let c = this.ng.b2;
        let d = a;
        let e = d.ad.count;
        let f = 0;
        let g = b.br.left;
        let h = b.br.right;
        let i = b.br.top;
        let j = b.br.bottom;
        let k = this.pv == 0;
        let l = this.pu == 0;
        for (let m = 0; m < e; m++) {
            let n = Math.floor(d.ad._inner[m]);
            let o = Math.floor(d.ae._inner[m]);
            let p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                let q = this.or(c, f, m, d, true);
                p = q.c;
                f = q.d;
                let r = new PathGeometry();
                let s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                let t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.ak = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                let u = this.or(c, f, m, d, false);
                p = u.c;
                f = u.d;
                let v = new PathGeometry();
                let w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                let x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.ak = v;
            }
        }
        c.count = f;
        if (this.ca()) {
            this.ot(this.md, true);
        }
        else {
            this.ot(this.mb, false);
        }
    }
    c8() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case CrosshairLayer.$$p[1]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[7]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[4]:
                this.jl(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[8]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[11]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[19]:
            case CrosshairLayer.$$p[21]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[6]:
            case CrosshairLayer.$$p[5]:
                this.jl(true);
                break;
        }
    }
}
CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:pk:ou', [Brush.$, null], 'HorizontalLineVisibility:pu:ov', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:nk:ow', [0, false], 'SkipUnknownValues:nl:ox', [0, true], 'TargetSeries:nh:oy', [Series.$, null], 'UseInterpolation:nm:oz', [0, true], 'VerticalLineStroke:pl:o0', [Brush.$, null], 'VerticalLineVisibility:pv:o1', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackground:pm:o2', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:nz:o3', [1, -1], 'XAxisAnnotationOutline:pn:o4', [Brush.$, null], 'XAxisAnnotationPaddingBottom:np:o5', [1, NaN], 'XAxisAnnotationPaddingLeft:nq:o6', [1, NaN], 'XAxisAnnotationPaddingRight:nr:o7', [1, NaN], 'XAxisAnnotationPaddingTop:ns:o8', [1, NaN], 'XAxisAnnotationStrokeThickness:nt:o9', [1, NaN], 'XAxisAnnotationTextColor:po:pa', [Brush.$, null], 'YAxisAnnotationBackground:pp:pb', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:n0:pc', [1, -1], 'YAxisAnnotationOutline:pq:pd', [Brush.$, null], 'YAxisAnnotationPaddingBottom:nu:pe', [1, NaN], 'YAxisAnnotationPaddingLeft:nv:pf', [1, NaN], 'YAxisAnnotationPaddingRight:nw:pg', [1, NaN], 'YAxisAnnotationPaddingTop:nx:ph', [1, NaN], 'YAxisAnnotationStrokeThickness:ny:pi', [1, NaN], 'YAxisAnnotationTextColor:pr:pj', [Brush.$, null]]);
/**
 * @hidden
 */
class CrosshairLayerView extends AnnotationLayerView {
    constructor(a) {
        super(a);
        this.b1 = null;
        this.b2 = null;
        this.b3 = null;
        this.b1 = a;
        this.b3 = new List$1(Path.$, 0);
    }
    ap() {
        super.ap();
        this.b2 = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.b9);
            $ret.activate = runOn(this, this.b4);
            $ret.disactivate = runOn(this, this.b6);
            $ret.destroy = runOn(this, this.b5);
            return $ret;
        })());
    }
    b9() {
        let a = new Path();
        a.j = new TranslateTransform();
        this.b3.add(a);
        return a;
    }
    b4(a) {
        a._visibility = 0;
    }
    b6(a) {
        a._visibility = 1;
    }
    b5(a) {
        this.b3.remove(a);
    }
    b7(a, b, c, d) {
        if (a.ak == null || a.ak.c.x != d || a.ak.d.x != c) {
            let e = ((() => {
                let $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.ak = e;
        }
    }
    b8(a) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, 0.1);
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d && !b) {
            for (let c = 0; c < this.b3.count; c++) {
                let d = this.b3._inner[c];
                if (d._visibility == 0) {
                    a.s(d);
                }
            }
        }
    }
    ai(a) {
        super.ai(a);
        for (let b = 0; b < this.b3.count; b++) {
            this.e.a2.exportPathData(a, this.b3._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    }
}
CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxCrosshairLayerComponent_1;
/**
 * Represents an annotation layer that displays crosshair lines that cross through the closest value of the target series under the cursor.
*/
const IgxCrosshairLayerComponent_PROVIDERS = [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCrosshairLayerComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCrosshairLayerComponent) }];
let IgxCrosshairLayerComponent = IgxCrosshairLayerComponent_1 = class IgxCrosshairLayerComponent extends IgxAnnotationLayerComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CrosshairLayer();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the color to use for the horizontal line. Leave null for an automatic value.
    */
    get horizontalLineStroke() {
        return brushToString(this.i.pk);
    }
    set horizontalLineStroke(v) {
        this.i.pk = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for vertical line. Leave null for an automatic value.
    */
    get verticalLineStroke() {
        return brushToString(this.i.pl);
    }
    set verticalLineStroke(v) {
        this.i.pl = stringToBrush(v);
    }
    /**
     * Gets or sets the series to target this annotation to. If null, this annotation targets all series simultaneously.
    */
    get targetSeries() {
        if (this.i.nh == null) {
            return null;
        }
        if (!this.i.nh.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.nh);
            if (e) {
                e._implementation = this.i.nh;
            }
            this.i.nh.externalObject = e;
        }
        return this.i.nh.externalObject;
    }
    set targetSeries(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nh = null : this.i.nh = v.i;
    }
    /**
     * Gets or sets whether to use value interpolation when drawing a line through the best value for the cursor position.
    */
    get useInterpolation() {
        return this.i.nm;
    }
    set useInterpolation(v) {
        this.i.nm = ensureBool(v);
    }
    /**
     * Gets or sets whether to draw annotations over the axes where the crosshair meets with them.
    */
    get isAxisAnnotationEnabled() {
        return this.i.nk;
    }
    set isAxisAnnotationEnabled(v) {
        this.i.nk = ensureBool(v);
    }
    /**
     * Gets or sets the color to use for the x axis annotation text. Leave unset for an automatic value.
    */
    get xAxisAnnotationTextColor() {
        return brushToString(this.i.po);
    }
    set xAxisAnnotationTextColor(v) {
        this.i.po = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the x axis annotation backing. Leave unset for an automatic value.
    */
    get xAxisAnnotationBackground() {
        return brushToString(this.i.pm);
    }
    set xAxisAnnotationBackground(v) {
        this.i.pm = stringToBrush(v);
    }
    /**
     * Gets or sets the precision to use displaying values for interpolated crosshair positions.
    */
    get xAxisAnnotationInterpolatedValuePrecision() {
        return this.i.nz;
    }
    set xAxisAnnotationInterpolatedValuePrecision(v) {
        this.i.nz = +v;
    }
    /**
     * Gets or sets the color to use for the x axis annotation outline. Leave unset for an automatic value.
    */
    get xAxisAnnotationOutline() {
        return brushToString(this.i.pn);
    }
    set xAxisAnnotationOutline(v) {
        this.i.pn = stringToBrush(v);
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get xAxisAnnotationPaddingLeft() {
        return this.i.nq;
    }
    set xAxisAnnotationPaddingLeft(v) {
        this.i.nq = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get xAxisAnnotationPaddingTop() {
        return this.i.ns;
    }
    set xAxisAnnotationPaddingTop(v) {
        this.i.ns = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get xAxisAnnotationPaddingRight() {
        return this.i.nr;
    }
    set xAxisAnnotationPaddingRight(v) {
        this.i.nr = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get xAxisAnnotationPaddingBottom() {
        return this.i.np;
    }
    set xAxisAnnotationPaddingBottom(v) {
        this.i.np = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get yAxisAnnotationPaddingLeft() {
        return this.i.nv;
    }
    set yAxisAnnotationPaddingLeft(v) {
        this.i.nv = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get yAxisAnnotationPaddingTop() {
        return this.i.nx;
    }
    set yAxisAnnotationPaddingTop(v) {
        this.i.nx = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get yAxisAnnotationPaddingRight() {
        return this.i.nw;
    }
    set yAxisAnnotationPaddingRight(v) {
        this.i.nw = +v;
    }
    /**
     * Gets or sets the padding to use withing the axis annotation callout. Leaving this NaN will use an automatic value related to the axis label margins.
    */
    get yAxisAnnotationPaddingBottom() {
        return this.i.nu;
    }
    set yAxisAnnotationPaddingBottom(v) {
        this.i.nu = +v;
    }
    /**
     * Gets or sets the stroke thickness for the x axis annotation backing. Leave unset for an automatic value.
    */
    get xAxisAnnotationStrokeThickness() {
        return this.i.nt;
    }
    set xAxisAnnotationStrokeThickness(v) {
        this.i.nt = +v;
    }
    /**
     * Gets or sets the color to use for the y axis annotation text. Leave unset for an automatic value.
    */
    get yAxisAnnotationTextColor() {
        return brushToString(this.i.pr);
    }
    set yAxisAnnotationTextColor(v) {
        this.i.pr = stringToBrush(v);
    }
    /**
     * Gets or sets the color to use for the y axis annotation backing. Leave unset for an automatic value.
    */
    get yAxisAnnotationBackground() {
        return brushToString(this.i.pp);
    }
    set yAxisAnnotationBackground(v) {
        this.i.pp = stringToBrush(v);
    }
    /**
     * Gets or sets the precision to use displaying values for interpolated crosshair positions.
    */
    get yAxisAnnotationInterpolatedValuePrecision() {
        return this.i.n0;
    }
    set yAxisAnnotationInterpolatedValuePrecision(v) {
        this.i.n0 = +v;
    }
    /**
     * Gets or sets the color to use for the y axis annotation outline. Leave unset for an automatic value.
    */
    get yAxisAnnotationOutline() {
        return brushToString(this.i.pq);
    }
    set yAxisAnnotationOutline(v) {
        this.i.pq = stringToBrush(v);
    }
    /**
     * Gets or sets the stroke thickness for the y axis annotation backing. Leave unset for an automatic value.
    */
    get yAxisAnnotationStrokeThickness() {
        return this.i.ny;
    }
    set yAxisAnnotationStrokeThickness(v) {
        this.i.ny = +v;
    }
    /**
     * Gets or sets whether to display the vertical line.
    */
    get verticalLineVisibility() {
        return this.i.pv;
    }
    set verticalLineVisibility(v) {
        this.i.pv = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets whether to display the horizontal line.
    */
    get horizontalLineVisibility() {
        return this.i.pu;
    }
    set horizontalLineVisibility(v) {
        this.i.pu = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets whether to skip unknown values when searching for series values.
    */
    get skipUnknownValues() {
        return this.i.nl;
    }
    set skipUnknownValues(v) {
        this.i.nl = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.targetSeries && this.targetSeries.name && this.targetSeries.name == name) {
            return this.targetSeries;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.targetSeries && this.targetSeries._styling) {
            this.targetSeries._styling(container, component, this);
        }
        this._inStyling = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "horizontalLineStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "verticalLineStroke", null);
__decorate([
    Input(),
    __metadata("design:type", IgxSeriesComponent),
    __metadata("design:paramtypes", [IgxSeriesComponent])
], IgxCrosshairLayerComponent.prototype, "targetSeries", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCrosshairLayerComponent.prototype, "useInterpolation", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCrosshairLayerComponent.prototype, "isAxisAnnotationEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationInterpolatedValuePrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationPaddingBottom", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationPaddingBottom", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "xAxisAnnotationStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationInterpolatedValuePrecision", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "yAxisAnnotationStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "verticalLineVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCrosshairLayerComponent.prototype, "horizontalLineVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCrosshairLayerComponent.prototype, "skipUnknownValues", null);
IgxCrosshairLayerComponent = IgxCrosshairLayerComponent_1 = __decorate([
    Component({
        selector: 'igx-crosshair-layer',
        template: ``,
        providers: [{ provide: IgxAnnotationLayerComponent, useExisting: forwardRef(() => IgxCrosshairLayerComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCrosshairLayerComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCrosshairLayerComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCrosshairLayerModule = class IgxCrosshairLayerModule {
};
IgxCrosshairLayerModule = __decorate([
    NgModule({
        declarations: [IgxCrosshairLayerComponent],
        imports: [CommonModule, IgxAnnotationLayerProxyModule],
        exports: [IgxCrosshairLayerComponent, IgxAnnotationLayerProxyModule],
        entryComponents: []
    })
], IgxCrosshairLayerModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCrosshairLayerDynamicModule = class IgxCrosshairLayerDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCrosshairLayerComponent", IgxCrosshairLayerComponent);
        TypeRegistrar.register("CrosshairLayer", CrosshairLayer.$type);
    }
};
IgxCrosshairLayerDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCrosshairLayerModule],
        exports: [IgxCrosshairLayerModule],
        entryComponents: [IgxCrosshairLayerComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCrosshairLayerDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHorizontalAnchoredCategorySeriesProxy_$type = new Type(null, 'IHorizontalAnchoredCategorySeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IBucketizer_$type = new Type(null, 'IBucketizer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISortingAxis_$type = new Type(null, 'ISortingAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsErrorBars_$type = new Type(null, 'ISupportsErrorBars');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsMarkers_$type = new Type(null, 'ISupportsMarkers');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultSupportsMarkers extends Base {
    get shouldDisplayMarkers() {
        return false;
    }
    updateMarkerCount(a) {
    }
    updateMarkerTemplate(a, b, c) {
    }
}
DefaultSupportsMarkers.$t = markType(DefaultSupportsMarkers, 'DefaultSupportsMarkers', Base.$, [ISupportsMarkers_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultProvidesViewport extends Base {
    getViewInfo(a, b) {
        a = Rect.empty;
        b = Rect.empty;
        return {
            p0: a,
            p1: b
        };
    }
    getEffectiveViewport() {
        return Rect.empty;
    }
}
DefaultProvidesViewport.$t = markType(DefaultProvidesViewport, 'DefaultProvidesViewport', Base.$, [IProvidesViewport_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultSupportsErrorBars extends Base {
    get GetErrorBarsXAxis() {
        return null;
    }
    get GetErrorBarsYAxis() {
        return null;
    }
}
DefaultSupportsErrorBars.$t = markType(DefaultSupportsErrorBars, 'DefaultSupportsErrorBars', Base.$, [ISupportsErrorBars_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FramePreparer extends Base {
    constructor(a, ..._rest) {
        super();
        this.b = null;
        this.c = null;
        this.a = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        this.c = new DefaultSupportsMarkers();
                        this.a = new DefaultProvidesViewport();
                        this.b = new DefaultSupportsErrorBars();
                        if (f != null) {
                            this.c = f;
                        }
                        if (g != null) {
                            this.a = g;
                        }
                        if (h != null) {
                            this.b = h;
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    this.c = new DefaultSupportsMarkers();
                    this.a = new DefaultProvidesViewport();
                    this.b = new DefaultSupportsErrorBars();
                    if (c != null) {
                        this.c = c;
                    }
                    if (d != null) {
                        this.a = d;
                    }
                    if (e != null) {
                        this.b = e;
                    }
                }
                break;
        }
    }
}
FramePreparer.$t = markType(FramePreparer, 'FramePreparer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIsCategoryBased_$type = new Type(null, 'IIsCategoryBased');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryFrame extends Frame {
    constructor(a) {
        super();
        this.z = null;
        this.f = new List$1(Array_$type, 0);
        this.k = new List$1(Number_$type, 0);
        this.l = new List$1(Number_$type, 0);
        this.m = new List$1(Point_$type, 0);
        this.n = new List$1(Number_$type, 0);
        this.p = new List$1(Point_$type, 0);
        this.q = new List$1(Number_$type, 0);
        this.i = new List$1(Point_$type, 0);
        this.j = new List$1(Number_$type, 0);
        this.h = new List$1(Number_$type, 0);
        this.g = new List$1(Number_$type, 0);
        this.o = new List$1(Number_$type, 0);
        this.t = 0;
        this.s = 0;
        this.aa = null;
        this.z = new Rect(0, 0, 0, 1, 1);
        this.s = a;
        this.w();
    }
    c(a, b, c) {
        this.w();
        let d = typeCast(CategoryFrame.$, b);
        let e = typeCast(CategoryFrame.$, c);
        let f = d.f.count;
        let g = e.f.count;
        let h = Math.max(f, g);
        let i = Math.max(d.m.count, e.m.count);
        let j = Math.max(d.p.count, e.p.count);
        let k = Math.max(d.k.count, e.k.count);
        let l = Math.max(d.i.count, e.i.count);
        let m = d.o.count > 0;
        if (m) {
            this.x(this.o, a, d.o, e.o, h);
        }
        let n = d.n.count > 0;
        if (n) {
            this.x(this.n, a, d.n, e.n, i);
        }
        let o = d.q.count > 0;
        if (o) {
            this.x(this.q, a, d.q, e.q, j);
        }
        let p = d.l.count > 0;
        if (p) {
            this.x(this.l, a, d.l, e.l, k);
        }
        let q = d.j.count > 0;
        if (q) {
            this.x(this.j, a, d.j, e.j, l);
        }
        if (this.f.count < h) {
            while (this.f.count < h) {
                this.f.add(new Array(this.s));
            }
        }
        if (this.f.count > h) {
            this.f.v(h, this.f.count - h);
        }
        if (m) {
            let r = 0;
            for (let s = 0; s < Math.min(f, g); ++s) {
                let t = this.f._inner[s];
                r = a * this.o._inner[s];
                r = r > 1 ? 1 : r;
                for (let u = 0; u < this.s; ++u) {
                    t[u] = d.f._inner[s][u] + r * (e.f._inner[s][u] - d.f._inner[s][u]);
                }
            }
        }
        else {
            for (let v = 0; v < Math.min(f, g); ++v) {
                let w = this.f._inner[v];
                for (let x = 0; x < this.s; ++x) {
                    w[x] = d.f._inner[v][x] + a * (e.f._inner[v][x] - d.f._inner[v][x]);
                }
            }
        }
        if (f < g) {
            let y = new Array(this.s);
            for (let z = this.s - 1; z >= 0; --z) {
                y[z] = d.f.count > 0 ? d.f._inner[d.f.count - 1][z] : 0;
            }
            if (m) {
                let aa = 0;
                for (let ab = f; ab < g; ++ab) {
                    let ac = this.f._inner[ab];
                    aa = a * this.o._inner[ab];
                    aa = aa > 1 ? 1 : aa;
                    for (let ad = this.s - 1; ad >= 0; --ad) {
                        ac[ad] = y[ad] + aa * (e.f._inner[ab][ad] - y[ad]);
                    }
                }
            }
            else {
                for (let ae = f; ae < g; ++ae) {
                    let af = this.f._inner[ae];
                    for (let ag = this.s - 1; ag >= 0; --ag) {
                        af[ag] = y[ag] + a * (e.f._inner[ae][ag] - y[ag]);
                    }
                }
            }
        }
        if (f > g) {
            let ah = new Array(this.s);
            for (let ai = this.s - 1; ai >= 0; --ai) {
                ah[ai] = e.f.count > 0 ? e.f._inner[e.f.count - 1][ai] : 0;
            }
            if (m) {
                let aj = 0;
                for (let ak = g; ak < f; ++ak) {
                    let al = this.f._inner[ak];
                    aj = a * this.o._inner[ak];
                    aj = aj > 1 ? 1 : aj;
                    for (let am = this.s - 1; am >= 0; --am) {
                        al[am] = d.f._inner[ak][am] + aj * (ah[am] - d.f._inner[ak][am]);
                    }
                }
            }
            else {
                for (let an = g; an < f; ++an) {
                    let ao = this.f._inner[an];
                    for (let ap = this.s - 1; ap >= 0; --ap) {
                        ao[ap] = d.f._inner[an][ap] + a * (ah[ap] - d.f._inner[an][ap]);
                    }
                }
            }
        }
        if (n) {
            Frame.d(this.m, a, d.m, e.m, this.n);
        }
        else {
            Frame.a(this.m, a, d.m, e.m);
        }
        if (o) {
            Frame.d(this.p, a, d.p, e.p, this.q);
        }
        else {
            Frame.a(this.p, a, d.p, e.p);
        }
        if (p) {
            Frame.d(this.i, a, d.i, e.i, this.l);
        }
        else {
            Frame.a(this.i, a, d.i, e.i);
        }
        if (q) {
            Frame.e(this.h, a, d.h, e.h, this.j);
            Frame.e(this.g, a, d.g, e.g, this.j);
        }
        else {
            Frame.b(this.h, a, d.h, e.h);
            Frame.b(this.g, a, d.g, e.g);
        }
        let aq = d.aa;
        let ar = e.aa;
        if (Rect.l_op_Equality(aq, null)) {
            aq = this.z;
        }
        if (Rect.l_op_Equality(ar, null)) {
            ar = this.z;
        }
        let as = aq.left + (ar.left - aq.left) * a;
        let at = aq.top + (ar.top - aq.top) * a;
        let au = Math.max(0, aq.width + (ar.width - aq.width) * a);
        let av = Math.max(0, aq.height + (ar.height - aq.height) * a);
        this.aa = new Rect(0, as, at, au, av);
    }
    x(a, b, c, d, e) {
        if (d.count == 0) {
            for (let f = 0; f < c.count; f++) {
                d.add(c._inner[f]);
            }
        }
        else {
            Frame.b(a, b, c, d);
        }
        if (a.count < e) {
            let g = a.count;
            for (let h = 0; h < e - g; h++) {
                a.add(1);
            }
        }
    }
    v() {
        this.o.clear();
        this.q.clear();
        this.n.clear();
        this.l.clear();
        this.j.clear();
    }
    u() {
        this.w();
        this.v();
        this.aa = this.z;
    }
    y() {
        this.u();
        this.f.clear();
        this.i.clear();
        this.k.clear();
        this.m.clear();
        this.p.clear();
    }
    w() {
        CategoryFrame.r++;
        if (CategoryFrame.r >= (0x7FFFFFFF - 1)) {
            CategoryFrame.r = 0;
        }
        this.t = CategoryFrame.r;
    }
}
CategoryFrame.$t = markType(CategoryFrame, 'CategoryFrame', Frame.$);
CategoryFrame.r = 0;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PreparationParams extends Base {
    constructor() {
        super(...arguments);
        this.i = 0;
        this.j = 0;
        this.h = 0;
        this.g = 0;
        this.m = null;
        this.l = null;
        this.k = null;
        this.b = null;
        this.d = null;
        this.c = null;
        this.a = null;
        this.e = false;
        this.f = false;
    }
}
PreparationParams.$t = markType(PreparationParams, 'PreparationParams');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDateTimeAxis_$type = new Type(null, 'IDateTimeAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHasTrendline_$type = new Type(null, 'IHasTrendline');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHasCategoryTrendline_$type = new Type(null, 'IHasCategoryTrendline', null, [IHasTrendline_$type]);
/**
 * @hidden
 */
let IPreparesCategoryTrendline_$type = new Type(null, 'IPreparesCategoryTrendline');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHasSingleValueCategory_$type = new Type(null, 'IHasSingleValueCategory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultCategoryTrendlinePreparer extends Base {
    prepareLine(a, b, c, d) {
    }
    prepareLineCore(a, b, c, d, e, f, g) {
    }
}
DefaultCategoryTrendlinePreparer.$t = markType(DefaultCategoryTrendlinePreparer, 'DefaultCategoryTrendlinePreparer', Base.$, [IPreparesCategoryTrendline_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultCategoryTrendlineHost extends Base {
    constructor() {
        super();
        this.a = null;
        this.a = new DefaultCategoryTrendlinePreparer();
    }
    get trendlinePreparer() {
        return this.a;
    }
    get trendLineType() {
        return 0;
    }
    get trendLinePeriod() {
        return 1;
    }
    get isVertical() {
        return false;
    }
}
DefaultCategoryTrendlineHost.$t = markType(DefaultCategoryTrendlineHost, 'DefaultCategoryTrendlineHost', Base.$, [IHasCategoryTrendline_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultSingleValueProvider extends Base {
    get valueColumn() {
        return new FastItemColumn(null, null, null, false);
    }
}
DefaultSingleValueProvider.$t = markType(DefaultSingleValueProvider, 'DefaultSingleValueProvider', Base.$, [IHasSingleValueCategory_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ValuesHolder extends Base {
    constructor() {
        super(...arguments);
        this.a = 0;
        this.b = 0;
        this.c = 0;
        this.d = 0;
    }
}
ValuesHolder.$t = markType(ValuesHolder, 'ValuesHolder');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SingleValuesHolder extends ValuesHolder {
    constructor() {
        super(...arguments);
        this.f = null;
    }
    get_e() {
        if (this.f != null) {
            return this.f.count;
        }
        return 0;
    }
    get e() {
        return this.get_e();
    }
}
SingleValuesHolder.$t = markType(SingleValuesHolder, 'SingleValuesHolder', ValuesHolder.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ICategorySeriesInteractionManager_$type = new Type(null, 'ICategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available transition effects that can applied to initial rendering of a series
 */
var CategoryTransitionInMode;
(function (CategoryTransitionInMode) {
    /**
     * Series transitions in an automatically chosen based on type of series and its orientation
     */
    CategoryTransitionInMode[CategoryTransitionInMode["Auto"] = 0] = "Auto";
    /**
     * Series transitions in from the reference value of the value axis.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["FromZero"] = 1] = "FromZero";
    /**
     * Series sweeps in from the left
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromLeft"] = 2] = "SweepFromLeft";
    /**
     * Series sweeps in from the right
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromRight"] = 3] = "SweepFromRight";
    /**
     * Series sweeps in from the top.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromTop"] = 4] = "SweepFromTop";
    /**
     * Series sweeps in from the bottom.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromBottom"] = 5] = "SweepFromBottom";
    /**
     * Series sweeps in from the center.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCenter"] = 6] = "SweepFromCenter";
    /**
     * Series accordions in from the left.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromLeft"] = 7] = "AccordionFromLeft";
    /**
     * Series accordions in from the right.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromRight"] = 8] = "AccordionFromRight";
    /**
     * Series accordions in from the top.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromTop"] = 9] = "AccordionFromTop";
    /**
     * Series accordions in from the bottom.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromBottom"] = 10] = "AccordionFromBottom";
    /**
     * Series expands from the value midpoints.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["Expand"] = 11] = "Expand";
    /**
     * Series sweeps in from the category axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMinimum"] = 12] = "SweepFromCategoryAxisMinimum";
    /**
     * Series sweeps in from the category axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromCategoryAxisMaximum"] = 13] = "SweepFromCategoryAxisMaximum";
    /**
     * Series sweeps in from the value axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMinimum"] = 14] = "SweepFromValueAxisMinimum";
    /**
     * Series sweeps in from the value axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["SweepFromValueAxisMaximum"] = 15] = "SweepFromValueAxisMaximum";
    /**
     * Series accordions in from the category axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMinimum"] = 16] = "AccordionFromCategoryAxisMinimum";
    /**
     * Series accordions in from the category axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromCategoryAxisMaximum"] = 17] = "AccordionFromCategoryAxisMaximum";
    /**
     * Series accordions in from the value axis minimum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMinimum"] = 18] = "AccordionFromValueAxisMinimum";
    /**
     * Series accordions in from the value axis maximum.
     */
    CategoryTransitionInMode[CategoryTransitionInMode["AccordionFromValueAxisMaximum"] = 19] = "AccordionFromValueAxisMaximum";
})(CategoryTransitionInMode || (CategoryTransitionInMode = {}));
/**
 * @hidden
 */
let CategoryTransitionInMode_$type = markEnum('CategoryTransitionInMode', 'Auto,0|FromZero,1|SweepFromLeft,2|SweepFromRight,3|SweepFromTop,4|SweepFromBottom,5|SweepFromCenter,6|AccordionFromLeft,7|AccordionFromRight,8|AccordionFromTop,9|AccordionFromBottom,10|Expand,11|SweepFromCategoryAxisMinimum,12|SweepFromCategoryAxisMaximum,13|SweepFromValueAxisMinimum,14|SweepFromValueAxisMaximum,15|AccordionFromCategoryAxisMinimum,16|AccordionFromCategoryAxisMaximum,17|AccordionFromValueAxisMinimum,18|AccordionFromValueAxisMaximum,19');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTransitionSourceFramePreparer extends Base {
    constructor() {
        super(...arguments);
        this.a = new Random(0);
    }
    p(a, b, c, d, e, f, g, h, i, j, k) {
        a.aa = new Rect(0, 0, 0, 1, 1);
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        let l = false;
        let m = false;
        if (e != null) {
            l = e.ca;
        }
        if (d != null) {
            m = d.ca;
        }
        let n = f;
        if (n == 0) {
            n = g;
        }
        switch (n) {
            case 1:
                let o = j();
                this.t(a, b, o, c);
                break;
            case 7:
                this.r(a, b, false, c, k);
                break;
            case 9:
                this.s(a, b, true, c, k);
                break;
            case 10:
                this.s(a, b, false, c, k);
                break;
            case 8:
                this.r(a, b, true, c, k);
                break;
            case 2:
                this.u(a, b, false);
                break;
            case 3:
                this.u(a, b, true);
                break;
            case 4:
                this.v(a, b, true);
                break;
            case 5:
                this.v(a, b, false);
                break;
            case 6:
                this.j(a, b);
                a.aa = new Rect(0, 0.5, 0.5, 0, 0);
                break;
            case 16:
                if (c) {
                    this.s(a, b, l, c, k);
                }
                else {
                    this.r(a, b, m, c, k);
                }
                break;
            case 17:
                if (c) {
                    this.s(a, b, !l, c, k);
                }
                else {
                    this.r(a, b, !m, c, k);
                }
                break;
            case 18:
                if (c) {
                    this.r(a, b, m, c, k);
                }
                else {
                    this.s(a, b, l, c, k);
                }
                break;
            case 19:
                if (c) {
                    this.r(a, b, !m, c, k);
                }
                else {
                    this.s(a, b, !l, c, k);
                }
                break;
            case 12:
                if (c) {
                    this.v(a, b, l);
                }
                else {
                    this.u(a, b, m);
                }
                break;
            case 13:
                if (c) {
                    this.v(a, b, !l);
                }
                else {
                    this.u(a, b, !m);
                }
                break;
            case 14:
                if (c) {
                    this.u(a, b, m);
                }
                else {
                    this.v(a, b, l);
                }
                break;
            case 15:
                if (c) {
                    this.u(a, b, !m);
                }
                else {
                    this.v(a, b, !l);
                }
                break;
            case 11:
                this.q(a, b);
                break;
        }
        if (h == 0) {
            h = i;
        }
        a.v();
        b.v();
        switch (h) {
            case 3:
                this.b(a.f.count, n, a.o, b.o, d, e, c, k);
                this.b(a.m.count, n, a.n, b.n, d, e, c, k);
                this.b(a.p.count, n, a.q, b.q, d, e, c, k);
                this.b(a.i.count, n, a.l, b.l, d, e, c, k);
                this.b(a.h.count, n, a.j, b.j, d, e, c, k);
                break;
            case 2:
                let p = j();
                this.d(a.f.count, p, n, a.f, b.f, a.o, b.o, d, e, c, k);
                this.f(a.m.count, p, n, a.m, b.m, a.n, b.n, d, e, c, k);
                this.f(a.p.count, p, n, a.p, b.p, a.q, b.q, d, e, c, k);
                this.f(a.i.count, p, n, a.i, b.i, a.l, b.l, d, e, c, k);
                this.e(a.h.count, p, n, a.h, b.h, a.j, b.j, d, e, c, k);
                break;
            case 4:
                this.c(a.f.count, n, a.o, b.o);
                this.c(a.m.count, n, a.n, b.n);
                this.c(a.p.count, n, a.q, b.q);
                this.c(a.i.count, n, a.l, b.l);
                this.c(a.h.count, n, a.j, b.j);
                break;
        }
    }
    c(a, b, c, d) {
        if (a == 0) {
            return;
        }
        for (let e = 0; e < a; e++) {
            c.add(1 + this.a.nextDouble());
            d.add(1 + this.a.nextDouble());
        }
    }
    d(a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        let l = false;
        let m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.ca;
        }
        let n = k.bottom;
        let o = k.bottom;
        let p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        let q;
        for (let r = 0; r < a; r++) {
            q = e._inner[r];
            for (let s = 1; s < q.length; s++) {
                if (isNaN_(q[s]) || isInfinity(q[s])) {
                    continue;
                }
                n = Math.max(n, Math.abs(b - q[s]));
            }
        }
        let t;
        let u;
        let v;
        for (let w = 0; w < a; w++) {
            q = e._inner[w];
            t = Math.abs(q[1] - b);
            u = Math.abs(q[1] - b);
            for (let x = 1; x < q.length; x++) {
                if (isNaN_(q[x]) || isInfinity(q[x])) {
                    continue;
                }
                t = Math.max(Math.abs(q[x] - b), t);
                u = Math.min(Math.abs(q[x] - b), u);
            }
            let y = (t + u) / 2;
            if (isNaN_(y) || n == 0) {
                v = 1;
            }
            else {
                v = y / n;
            }
            f.add(2 - v);
            g.add(2 - v);
        }
    }
    f(a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        let l = false;
        let m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.ca;
        }
        let n = k.bottom;
        let o = k.bottom;
        let p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        let q;
        for (let r = 0; r < a; r++) {
            q = e._inner[r];
            if (j) {
                if (isNaN_(q.x) || isInfinity(q.x)) {
                    continue;
                }
                n = Math.max(n, Math.abs(q.x - b));
            }
            else {
                if (isNaN_(q.y) || isInfinity(q.y)) {
                    continue;
                }
                n = Math.max(n, Math.abs(q.y - b));
            }
        }
        let s;
        for (let t = 0; t < a; t++) {
            q = e._inner[t];
            let u;
            if (j) {
                u = q.x;
            }
            else {
                u = q.y;
            }
            if (isNaN_(u) || isInfinity(u) || n == 0) {
                s = 1;
            }
            else {
                s = Math.abs(u - b) / n;
            }
            f.add(2 - s);
            g.add(2 - s);
        }
    }
    e(a, b, c, d, e, f, g, h, i, j, k) {
        if (a == 0) {
            return;
        }
        let l = false;
        let m = i;
        if (j) {
            m = h;
        }
        if (m != null) {
            l = m.ca;
        }
        let n = k.bottom;
        let o = k.bottom;
        let p = k.top;
        if (j) {
            o = k.right;
            p = k.left;
        }
        if (l) {
            o = k.top;
            p = k.bottom;
            if (j) {
                o = k.left;
                p = k.right;
            }
        }
        b = Math.max(b, Math.min(p, o));
        b = Math.min(b, Math.max(p, o));
        n = 0;
        let q;
        for (let r = 0; r < a; r++) {
            q = e._inner[r];
            if (isNaN_(q) || isInfinity(q)) {
                continue;
            }
            n = Math.max(n, Math.abs(q - b));
        }
        let s;
        for (let t = 0; t < a; t++) {
            q = e._inner[t];
            let u;
            u = q;
            if (n == 0 || isNaN_(u) || isInfinity(u)) {
                s = 1;
            }
            else {
                s = Math.abs(u - b) / n;
            }
            f.add(2 - s);
            g.add(2 - s);
        }
    }
    b(a, b, c, d, e, f, g, h) {
        if (a == 0) {
            return;
        }
        let i = e;
        if (g) {
            i = f;
        }
        let j = false;
        if (i != null) {
            j = i.ca;
        }
        let k;
        for (let l = 0; l < a; l++) {
            if (a == 1) {
                k = 1;
            }
            else {
                k = l / (a - 1);
            }
            k = 1 - k;
            c.add(1 + k);
            d.add(1 + k);
        }
    }
    q(a, b) {
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        this.g(a.f, b.f);
        this.h(a.k, b.k);
        this.k(a.m, b.m);
        this.k(a.p, b.p);
        this.k(a.i, b.i);
        this.h(a.h, b.h);
        this.h(a.g, b.g);
        let c = a.f.count;
        let d = a.f;
        let e;
        let f;
        let g;
        let h;
        for (let i = 0; i < c; i++) {
            e = d._inner[i];
            f = e[1];
            g = e[1];
            for (let j = 2; j < e.length; j++) {
                f = Math.min(f, e[j]);
                g = Math.max(g, e[j]);
            }
            h = (f + g) / 2;
            for (let k = 1; k < e.length; k++) {
                e[k] = h;
            }
        }
        let l = a.h.count;
        let m = a.h;
        let n = a.g;
        for (let o = 0; o < l; o++) {
            m._inner[o] = 0;
            n._inner[o] = 0;
        }
    }
    u(a, b, c) {
        if (c) {
            this.j(a, b);
            a.aa = new Rect(0, 1, 0, 0, 1);
        }
        else {
            this.j(a, b);
            a.aa = new Rect(0, 0, 0, 0, 1);
        }
    }
    v(a, b, c) {
        if (c) {
            this.j(a, b);
            a.aa = new Rect(0, 0, 0, 1, 0);
        }
        else {
            this.j(a, b);
            a.aa = new Rect(0, 0, 1, 1, 0);
        }
    }
    j(a, b) {
        a.f.clear();
        a.k.clear();
        a.m.clear();
        a.p.clear();
        a.i.clear();
        a.h.clear();
        a.g.clear();
        this.g(a.f, b.f);
        this.h(a.k, b.k);
        this.k(a.m, b.m);
        this.k(a.p, b.p);
        this.k(a.i, b.i);
        this.h(a.h, b.h);
        this.h(a.g, b.g);
    }
    o(a, b, c, d, e) {
        let f = b.count;
        let g;
        let h;
        for (let i = 0; i < f; i++) {
            g = b._inner[i];
            if (e) {
                if (c) {
                    h = { $type: Point_$type, x: d, y: g.y };
                }
                else {
                    h = { $type: Point_$type, x: g.x, y: d };
                }
            }
            else {
                if (c) {
                    h = { $type: Point_$type, x: g.x, y: d };
                }
                else {
                    h = { $type: Point_$type, x: d, y: g.y };
                }
            }
            a.add(h);
        }
    }
    k(a, b) {
        let c = b.count;
        let d;
        let e;
        for (let f = 0; f < c; f++) {
            d = b._inner[f];
            e = { $type: Point_$type, x: d.x, y: d.y };
            a.add(e);
        }
    }
    g(a, b) {
        let c = b.count;
        let d = b;
        let e;
        let f;
        let g = a;
        for (let h = 0; h < c; h++) {
            f = d._inner[h];
            e = new Array(f.length);
            for (let i = 0; i < e.length; i++) {
                e[i] = f[i];
            }
            g.add(e);
        }
    }
    l(a, b, c, d, e) {
        let f = b.count;
        let g = b;
        let h;
        let i;
        let j = a;
        for (let k = 0; k < f; k++) {
            i = g._inner[k];
            h = new Array(i.length);
            if (e) {
                h[0] = i[0];
                for (let l = 1; l < h.length; l++) {
                    h[l] = d;
                }
            }
            else {
                h[0] = d;
                for (let m = 1; m < h.length; m++) {
                    h[m] = i[m];
                }
            }
            j.add(h);
        }
    }
    n(a, b) {
        let c = b.count;
        let d;
        for (let e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    }
    i(a, b) {
        let c = b.count;
        let d;
        for (let e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    }
    h(a, b) {
        let c = b.count;
        let d;
        for (let e = 0; e < c; e++) {
            d = b._inner[e];
            a.add(d);
        }
    }
    m(a, b, c, d, e) {
        let f = b.count;
        let g;
        for (let h = 0; h < f; h++) {
            g = b._inner[h];
            a.add(g);
        }
    }
    r(a, b, c, d, e) {
        let f = e.right;
        if (!c) {
            f = e.left;
        }
        let g = false;
        if (d) {
            g = true;
        }
        this.l(a.f, b.f, d, f, g);
        this.m(a.k, b.k, d, f, g);
        this.o(a.m, b.m, d, f, g);
        this.o(a.p, b.p, d, f, g);
        this.o(a.i, b.i, d, f, g);
        this.m(a.h, b.h, d, f, g);
        this.m(a.g, b.g, d, f, g);
    }
    s(a, b, c, d, e) {
        let f = e.bottom;
        if (c) {
            f = e.top;
        }
        let g = true;
        if (d) {
            g = false;
        }
        this.l(a.f, b.f, d, f, g);
        this.m(a.k, b.k, d, f, g);
        this.o(a.m, b.m, d, f, g);
        this.o(a.p, b.p, d, f, g);
        this.o(a.i, b.i, d, f, g);
        this.m(a.h, b.h, d, f, g);
        this.m(a.g, b.g, d, f, g);
    }
    t(a, b, c, d) {
        this.l(a.f, b.f, d, c, true);
        this.m(a.k, b.k, d, c, true);
        this.o(a.m, b.m, d, c, true);
        this.o(a.p, b.p, d, c, true);
        this.o(a.i, b.i, d, c, true);
        this.m(a.h, b.h, d, c, true);
        this.m(a.g, b.g, d, c, true);
    }
}
CategoryTransitionSourceFramePreparer.$t = markType(CategoryTransitionSourceFramePreparer, 'CategoryTransitionSourceFramePreparer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AssigningCategoryStyleEventArgsBase extends Base {
    constructor() {
        super(...arguments);
        this.m = 0;
        this.l = 0;
        this.h = new Date();
        this.g = new Date();
        this.a = null;
        this.n = null;
        this.o = null;
        this.j = 0;
        this.b = null;
        this.i = 0;
        this.k = 0;
        this.d = false;
        this.c = false;
        this.e = false;
        this.f = false;
    }
}
AssigningCategoryStyleEventArgsBase.$t = markType(AssigningCategoryStyleEventArgsBase, 'AssigningCategoryStyleEventArgsBase');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AssigningCategoryStyleEventArgs extends AssigningCategoryStyleEventArgsBase {
    constructor() {
        super(...arguments);
        this.r = 0;
        this.s = null;
        this.t = 0;
        this.p = 0;
        this.q = 0;
    }
}
AssigningCategoryStyleEventArgs.$t = markType(AssigningCategoryStyleEventArgs, 'AssigningCategoryStyleEventArgs', AssigningCategoryStyleEventArgsBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AssigningCategoryMarkerStyleEventArgs extends AssigningCategoryStyleEventArgsBase {
}
AssigningCategoryMarkerStyleEventArgs.$t = markType(AssigningCategoryMarkerStyleEventArgs, 'AssigningCategoryMarkerStyleEventArgs', AssigningCategoryStyleEventArgsBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategorySeriesRenderManager extends Base {
    constructor() {
        super(...arguments);
        this.ah = null;
        this.ai = null;
        this.l = 0;
        this.an = null;
        this.ap = 0;
        this.j = 0;
        this.k = 0;
        this.i = 0;
        this.h = 0;
        this.ar = 0;
        this.aq = 0;
        this.al = null;
        this.am = null;
        this.r = 0;
        this.ao = null;
        this.as = 0;
        this.p = 0;
        this.q = 0;
        this.o = 0;
        this.n = 0;
        this.au = 0;
        this.at = 0;
        this.aj = null;
        this.ak = null;
        this.m = 0;
        this.f = false;
        this.e = false;
        this.af = null;
        this.ag = null;
        this.g = 0;
        this.c = null;
        this.b = null;
        this.d = null;
        this.s = 0;
        this.t = 0;
    }
    w(a, b, c, d, e) {
        this.s = d;
        this.t = e;
        this.e = false;
        this.aj = a.m8;
        this.ak = a.m9;
        this.m = 1;
        this.af = this.aj;
        this.ag = this.ak;
        this.g = this.m;
        let f = b;
        this.b = null;
        if (f) {
            this.b = new AssigningCategoryMarkerStyleEventArgs();
            this.b.i = 0;
            this.b.k = 0;
            if (a.bs != null && a.b9) {
                this.b.i = a.bs.az.maxMarkerHighlightingProgress;
                this.b.k = a.bs.az.sumMarkerHighlightingProgress;
            }
            this.b.a = c;
        }
    }
    x(a, b, c, d, e, f) {
        this.s = e;
        this.t = f;
        this.f = false;
        this.al = a.lb;
        this.am = a.lc;
        this.r = a.ey;
        this.ao = a.ll;
        this.as = a.lm;
        this.p = 0;
        this.q = 0;
        this.o = 1;
        this.n = a.es;
        this.au = a.lo;
        this.at = a.ln;
        this.ah = this.al;
        this.ai = this.am;
        this.l = this.r;
        this.an = this.ao;
        this.ap = this.as;
        this.j = this.p;
        this.k = this.q;
        this.i = this.o;
        this.h = this.n;
        this.ar = this.au;
        this.aq = this.at;
        this.d = c;
        let g = b;
        this.c = null;
        if (g) {
            this.c = new AssigningCategoryStyleEventArgs();
            this.c.i = 0;
            this.c.k = 0;
            if (a.bs != null && a.b9) {
                this.c.i = a.bs.az.maxHighlightingProgress;
                this.c.k = a.bs.az.sumHighlightingProgress;
            }
            this.c.a = d;
        }
    }
    ae(a, b, c, d, e) {
        let f = this.ah;
        if (e) {
            f = this.ai;
        }
        if (c) {
            a._fill = f;
        }
        else {
            if (b) {
                a._stroke = f;
            }
            else {
                a._fill = f;
                a._stroke = this.ai;
            }
            a.ac = this.l;
            a.ai = this.an;
            a.ad = this.ap;
            if (d) {
            }
        }
        a._opacity = this.i;
    }
    ad(a, b) {
        a._opacity = this.g;
        b.itemBrush = this.af;
        b.actualItemBrush = b.itemBrush;
        b.outline = this.ag;
        b.thickness = DeviceUtils.g(2);
    }
    a(a, b) {
        let c = this.s;
        let d = Math.min(b * c, a - 1);
        let e = Math.min(d + c - 1, a - 1);
        let f = new Array(2);
        f[0] = Math.min(d + this.t * c, a - 1);
        f[1] = Math.min(e + this.t * c, a - 1);
        return f;
    }
    u(a) {
        if (a == null) {
            return;
        }
        if (a.b == null) {
            return;
        }
        this.ah = a.b.a0.a$ai(a.b, a, this.ah);
        this.ai = a.b.a0.a$ai(a.b, a, this.ai);
    }
    v(a) {
        if (a == null) {
            return;
        }
        if (a.b == null) {
            return;
        }
        this.af = a.b.a0.a$ai(a.b, a, this.af);
        this.ag = a.b.a0.a$ai(a.b, a, this.ag);
    }
    y(a, b, c, d, e, f, g, h, i) {
        if (d == -1) {
            if (b) {
                a.c = true;
                a.h = f.fb();
                a.g = f.fa();
            }
            else {
                a.c = false;
                a.m = 0;
                a.l = e - 1;
            }
        }
        else {
            if (b) {
                let longStart_ = truncate(f.d1(c._inner[d][0], g));
                let longEnd_ = longStart_;
                if (d + 1 < c.count) {
                    longEnd_ = truncate(f.d1(c._inner[d + 1][0], g));
                }
                a.c = true;
                a.h = (new Date(longStart_));
                a.g = (new Date(longEnd_));
                if (f.ca) {
                    let j = a.g;
                    a.g = a.h;
                    a.h = j;
                }
                if (i) {
                    a.m = d;
                    a.l = d;
                }
                else {
                    let k = this.a(e, d);
                    a.m = k[0];
                    a.l = k[1];
                }
            }
            else {
                if (i) {
                    a.m = d;
                    a.l = d;
                }
                else {
                    let l = this.a(e, d);
                    a.c = false;
                    a.m = l[0];
                    a.l = l[1];
                }
            }
        }
    }
    ac(a, b, c, d, e, f, g) {
        this.ah = this.al;
        this.ai = this.am;
        this.l = this.r;
        this.an = this.ao;
        this.ap = this.as;
        this.j = this.p;
        this.k = this.q;
        this.i = this.o;
        let h = this.c;
        let i = d.cf;
        this.y(h, i, a, b, c, d, e, f, false);
        h.n = this.ah;
        h.o = this.ai;
        h.r = this.l;
        h.s = this.an;
        h.t = this.ap;
        h.p = this.j;
        h.q = this.k;
        h.j = this.i;
        h.e = this.f;
        h.d = false;
    }
    aa(a, b, c) {
        let d = this.c;
        this.ah = d.n;
        this.ai = d.o;
        this.l = d.r;
        this.an = d.s;
        this.ap = d.t;
        this.j = d.p;
        this.k = d.q;
        this.i = d.j;
        if (c && !d.d && !b) {
            this.u(a);
        }
    }
    ab(a, b, c, d, e, f, g) {
        this.af = this.aj;
        this.ag = this.ak;
        this.g = this.m;
        let h = this.b;
        let i = d.cf;
        this.y(h, i, a, b, c, d, e, f, true);
        h.n = this.af;
        h.o = this.ag;
        h.j = this.g;
        h.e = this.e;
        h.d = false;
    }
    z(a, b, c) {
        let d = this.b;
        this.af = d.n;
        this.ag = d.o;
        this.g = d.j;
        if (c && !d.d && !b) {
            this.v(a);
        }
    }
}
CategorySeriesRenderManager.$t = markType(CategorySeriesRenderManager, 'CategorySeriesRenderManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryBucketCalculator extends Base {
    constructor(a) {
        super();
        this.c = null;
        this.e = 0;
        this.f = 0;
        this.d = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.c = a;
        this.e = -1;
        this.d = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    g(a) {
        let b = this.c.bs;
        let c = this.c.br;
        let d = this.c.cp;
        let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
        let f = d.bz;
        if (b.isEmpty || c.isEmpty || e == null || f == null || f.count == 0) {
            this.d = 0;
            return;
        }
        let g = d.getEffectiveViewport1(this.c);
        let h = d.l0(this.c);
        let i = typeCast(ISortingAxis_$type, e);
        if (i == null || i.i$b == null) {
            let j = new ScalerParams(0, b, c, e.ca, g);
            let k = Math.floor(e.d2(h.left, j, 0));
            let l = Math.ceil(e.d2(h.right, j, 0));
            if (e.ca) {
                l = Math.ceil(e.d2(h.left, j, 0));
                k = Math.floor(e.d2(h.right, j, 0));
            }
            let m = Math.floor((l - k + 1) * a / h.width);
            this.d = truncate(Math.max(1, m));
            this.e = truncate(Math.max(0, Math.floor(k / this.d) - 1));
            this.f = truncate(Math.ceil(l / this.d));
        }
        else {
            this.e = i.i$e(b, c, g, h);
            this.f = i.i$g(b, c, g, h);
            this.d = 1;
        }
    }
    getBucketInfo(a, b, c, d) {
        a = this.e;
        b = this.f;
        c = this.d;
        d = this.c.cp.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
CategoryBucketCalculator.$t = markType(CategoryBucketCalculator, 'CategoryBucketCalculator', Base.$, [IBucketizer_$type]);
/**
 * @hidden
 */
class CategoryFramePreparerBase extends FramePreparer {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, g, h, i);
                        this.g = null;
                        this.h = null;
                        this.m = false;
                        this.o = new List$1(Array_$type, 0);
                        this.p = new List$1(Number_$type, 0);
                        this.n = new List$1(Number_$type, 0);
                        this.h = f;
                        this.g = j;
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, d, e, f);
                    this.g = null;
                    this.h = null;
                    this.m = false;
                    this.o = new List$1(Array_$type, 0);
                    this.p = new List$1(Number_$type, 0);
                    this.n = new List$1(Number_$type, 0);
                    this.h = c;
                    this.g = g;
                }
                break;
        }
    }
    i(a) {
        let b = new PreparationParams();
        b.f = this.h.useHighMarkerFidelity;
        b.b = this.h.scaler;
        b.c = this.h.yScaler;
        b.d = typeCast(ISortingAxis_$type, b.b);
        b.a = typeCast(CategoryFrame.$, a);
        if (b.a == null || b.b == null || b.c == null) {
            return null;
        }
        let c;
        let d;
        let e;
        let f;
        let g = this.g.getBucketInfo(c, d, e, f);
        c = g.p0;
        d = g.p1;
        e = g.p2;
        f = g.p3;
        b.i = c;
        b.j = d;
        b.h = e;
        b.g = f;
        if (b.j < b.i) {
            return null;
        }
        let h;
        let i;
        let j;
        let k = this.a.getViewInfo(i, h);
        i = k.p0;
        h = k.p1;
        j = this.a.getEffectiveViewport();
        b.m = h;
        b.l = i;
        b.k = j;
        if (Rect.l_op_Equality(b.m, Rect.empty) || Rect.l_op_Equality(b.l, Rect.empty)) {
            return null;
        }
        if (this.h != null && (typeCast(Series.$, this.h) !== null && this.h.cs) && this.g != null) {
            b.e = true;
        }
        return b;
    }
    r(a, b, c, d) {
        return a.getSeriesOffset(b, c, d, this.h.currentMode2Index, this.h.currentCategoryMode);
    }
    s(a) {
        return this.r(a.b, a.m, a.l, a.k);
    }
    d(a, b) {
        let c = this.i(a);
        if (c == null || this.g == null) {
            return;
        }
        c.a.f.clear();
        c.a.k.clear();
        c.a.m.clear();
        c.a.p.clear();
        c.a.i.clear();
        c.a.h.clear();
        c.a.g.clear();
        let d = this.c.shouldDisplayMarkers;
        let e = false;
        let f = this.s(c);
        let g = this.j(c);
        if (c.d != null && c.d.i$b != null && c.d.i$b.count != g.e) {
            return;
        }
        if (c.d != null && c.d.i$a) {
            c.d.i$h();
        }
        this.g.cacheValues();
        if (this.m && c.d != null && c.d.i$b.count > 0) {
            let h = c.d.i$b._inner[c.i];
            this.z(g, h, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.i > 0) {
                c.i = c.i - 1;
                h = c.d.i$b._inner[c.i];
                this.z(g, h, true, c.e);
            }
            let i = c.d.i$b._inner[c.j];
            this.z(g, i, true, c.e);
            while ((isNaN_(g.c) || isNaN_(g.d)) && c.j < g.e - 1) {
                c.j = c.j + 1;
                i = c.d.i$b._inner[c.j];
                this.z(g, i, true, c.e);
            }
        }
        if (this.m && c.d == null) {
            let j = c.i;
            let k = this.g.getBucket(j);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.i > 0) {
                c.i = c.i - 1;
                j = c.i;
                k = this.g.getBucket(j);
            }
            let l = c.j;
            k = this.g.getBucket(l);
            while ((isNaN_(k[1]) || isNaN_(k[2])) && c.j < (intDivide(g.e, c.h))) {
                c.j = c.j + 1;
                l = c.j;
                k = this.g.getBucket(l);
            }
        }
        this.w(c, g, f);
        let m = this.t(c, g, f, d, e);
        this.c.updateMarkerCount(m);
        this.v(typeCast(CategoryFrame.$, a), b);
        this.g.unCacheValues();
        return;
    }
    v(a, b) {
    }
    get q() {
        return this.o;
    }
    t(a, b, c, d, e) {
        let f = 0;
        let g = false;
        let h = null;
        let i = false;
        let j = a.d != null;
        let k = a.m;
        let l = a.l;
        let m = typeCast(NumericAxisBase.$, a.c) !== null && a.c.j2;
        let n = a.f;
        let o = this.h.mayContainUnknowns;
        let p = this.o;
        let q = this.n;
        let r = this.p;
        p.clear();
        q.clear();
        r.clear();
        let s = this.g;
        let t = this.h.provideCollisionDetector();
        let u = 0;
        let v = a.k;
        let w = new ScalerParams(0, k, l, a.b.j$a, v);
        let x = ((() => {
            let $ret = new ScalerParams(0, k, l, a.c.j$a, v);
            $ret.b = typeCast(Series.$, this.h) !== null ? this.h.eh() : NaN;
            return $ret;
        })());
        if (j) {
            u = a.b.j$c(2, w) - a.b.j$c(1, w);
            i = this.k();
        }
        let y = a.i;
        let z = a.j;
        let aa = a.a.f;
        let ab = typeCast(IDateTimeAxis_$type, a.b);
        if (ab != null) {
            ab.StartTimeCursor();
        }
        for (let ac = y; ac <= z; ++ac) {
            let ad;
            if (!j) {
                if (!o) {
                    ad = s.getBucketWithoutUnknowns(ac);
                }
                else {
                    ad = s.getBucket(ac);
                }
            }
            else {
                ad = ((() => { let ae = this.f(a, ac, b, u, g, h, c); ac = ae.p1; g = ae.p4; h = ae.p5; return ae.ret; })());
            }
            let ae = !m || (m && ad[1] > 0);
            let af = ad[0];
            if (!j || !isNaN_(ad[0])) {
                aa.add(ad);
                if (g && i) {
                    if (h != null) {
                        aa.add(h);
                    }
                }
                if (d && ae) {
                    let ag = ac * a.h;
                    let ah = ag;
                    if (j && a.d.i$b != null && ag >= 0 && ag < a.d.i$b.count) {
                        ag = a.d.i$b._inner[ag];
                    }
                    let ai = new Array(ad.length);
                    ai[0] = ad[0];
                    ai[1] = ad[1];
                    ai[2] = ad[2];
                    if (n && ag < b.e) {
                        ai = new Array(ad.length);
                        ai[0] = af;
                        this.z(b, ag, true, a.e);
                        ai[1] = b.c;
                        ai[2] = b.d;
                    }
                    p.add(ai);
                    q.add(a.a.f.count - 1);
                    r.add(ag);
                }
            }
        }
        if (ab != null) {
            ab.ResetTimeCursor();
        }
        this.y(a, c, j, w, x, e, d);
        if (d) {
            let aj = p.count;
            let ak;
            for (let al = 0; al < aj; al++) {
                ak = p._inner[al];
                if (this.l(a.a, ak, t, Math.min(r._inner[al], b.e - 1), f, q._inner[al])) {
                    ++f;
                }
            }
        }
        return f;
    }
    k() {
        if (typeCast(Series.$, this.h) !== null) {
            return this.h.ck;
        }
        return false;
    }
    f(a, b, c, d, e, f, g) {
        let h;
        f = null;
        e = false;
        let i = typeCast(CategorySeries.$, this.h);
        let j = a.l;
        let k = a.m;
        let l = a.k;
        let m = new ScalerParams(0, k, j, a.b.j$a, l);
        let n = new ScalerParams(0, k, j, a.c.j$a, l);
        let o = a.e;
        if (a.d == null || a.d.i$b == null || a.d.i$b.count == 0) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        if (i != null && i.bz != null && i.bz.count < a.d.i$b.count) {
            return {
                ret: [NaN, NaN, NaN],
                p1: b,
                p4: e,
                p5: f
            };
        }
        let p = a.d.i$b._inner[b];
        let q = a.d.i$d(p);
        let r = q;
        this.z(c, p, false, o);
        while (b < a.j) {
            p = a.d.i$b._inner[b + 1];
            r = a.d.i$d(p);
            this.z(c, p, true, o);
            if (r - q >= d || isNaN_(c.c) || isNaN_(c.d)) {
                if (e) {
                    let s = a.d.i$b._inner[b];
                    this.z(c, s, true, o);
                    f = [a.b.j$b(q, m), c.c, c.d];
                }
                break;
            }
            if (!e && this.k()) {
                let t = a.d.i$b._inner[b];
                this.z(c, t, true, o);
                let u = [a.b.j$b(q, m), c.c, c.d];
                if (!isNaN_(u[0])) {
                    if (!isNaN_(u[1]) && !isNaN_(u[2])) {
                        if (a.d != null) {
                            u[0] = u[0] + g;
                        }
                        a.a.f.add(u);
                        e = true;
                    }
                    else {
                        break;
                    }
                }
            }
            b++;
            this.u(c, p, o);
        }
        let v = NaN;
        if (!isNaN_(q)) {
            v = a.b.j$b(q, m);
        }
        h = this.e(v, c);
        return {
            ret: h,
            p1: b,
            p4: e,
            p5: f
        };
    }
    y(a, b, c, d, e, f, g) {
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.o;
        let l = k.count;
        if (f) {
            let m = a.c.j$b(a.c.km, e);
            a.c.j$e(a.a.k, 0, a.a.k.count, e);
            let n = a.a.k;
            let o = n.count;
            for (let p = 0; p < n.count; p++) {
                n._inner[p] = Math.abs(n._inner[p] - m);
            }
        }
    }
    w(a, b, c) {
    }
}
CategoryFramePreparerBase.$t = markType(CategoryFramePreparerBase, 'CategoryFramePreparerBase', FramePreparer.$);
/**
 * @hidden
 */
class CategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, f, g, h, i, j);
                        this.aa = null;
                        this.ab = null;
                        this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                    this.aa = null;
                    this.ab = null;
                    this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
    }
    l(a, b, c, d, e, f) {
        let g = b[0];
        let h = b[1];
        let i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
    j(a) {
        let b = new SingleValuesHolder();
        let c = this.ab.valueColumn;
        b.f = c;
        return b;
    }
    x(a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        if (a.h > 1 || d) {
            b[2] = a.c.j$b(b[2], f);
        }
        else {
            b[2] = b[1];
        }
    }
    y(a, b, c, d, e, f, g) {
        super.y(a, b, c, d, e, f, g);
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.q;
        let l = k.count;
        let m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        let n = new List$1(Number_$type, 0);
        n.add(1);
        if (c || h > 1) {
            n.add(2);
        }
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (let o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (h == 1 && !c) {
            for (let p = 0; p < i; p++) {
                j._inner[p][2] = j._inner[p][1];
            }
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (let q = 0; q < l; q++) {
                k._inner[q][0] = k._inner[q][0] + b;
            }
            if (h == 1 && !c) {
                for (let r = 0; r < l; r++) {
                    k._inner[r][2] = k._inner[r][1];
                }
            }
        }
    }
    w(a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        this.aa.trendlinePreparer.prepareLine(this.aa, a, b, c);
    }
    z(a, b, c, d) {
        let e = a;
        let f = e.f;
        let g = f.item(b);
        let h = g;
        if (d) {
            let i = this.g.getBucket(b);
            g = i[1];
            h = i[1];
        }
        if (c) {
            e.c = g;
            e.d = h;
        }
        else {
            e.a = g;
            e.b = h;
        }
    }
    u(a, b, c) {
        let d = a;
        let e = d.f;
        if (b < e.count) {
            let f;
            if (c) {
                let g = this.g.getBucket(b);
                f = g[1];
            }
            else {
                f = e.item(b);
            }
            d.a = Math.min(d.a, f);
            d.b = Math.max(d.b, f);
        }
    }
    e(a, b) {
        let c = b;
        return [a, c.a, c.b];
    }
}
CategoryFramePreparer.$t = markType(CategoryFramePreparer, 'CategoryFramePreparer', CategoryFramePreparerBase.$);
/**
 * @hidden
 */
class CategorySeries extends MarkerSeries {
    constructor() {
        super();
        this.no = null;
        this.n1 = null;
        this.n5 = false;
        this.n4 = false;
        this.assigningCategoryStyle = null;
        this.assigningCategoryMarkerStyle = null;
        this.nz = null;
        this.n0 = null;
        this.nl = new CategoryFrame(3);
        this.nn = new CategoryFrame(3);
        this.nk = new CategoryFrame(3);
        this.nm = new CategoryFrame(3);
        this.nr = null;
        this.nv = null;
        this.nr = new CategorySeriesRenderManager();
        this.nv = new CategoryTransitionSourceFramePreparer();
        this.n5 = false;
        this.n4 = false;
        this.ab = CategorySeries.$;
    }
    bf() {
        let a = new CategorySeriesView(this);
        return a;
    }
    get n2() {
        if (this.n1 == null) {
            this.n1 = DVContainer.instance.createInstance(ICategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.n1;
    }
    ch(a, b, c) {
        if (!this.hasMarkers) {
            return false;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.fetchXAxis();
        let f = new ScalerParams(1, this.bs.n2, this.l8, e.ca);
        f.c = d;
        let g = this.fetchYAxis();
        let h = new ScalerParams(1, this.bs.n2, this.l8, g.ca);
        h.c = d;
        let i = this.bs.n2;
        let j = this.l8;
        let k = this.currentMode2Index;
        let l = 0;
        if (e.b7 && e.b5) {
            l = e.getSeriesOffset(i, j, d, k, e.categoryMode);
        }
        a.clear();
        this.ma.cc((m) => {
            if (m._visibility == 0) {
                let n = new SeriesPointOfInterest();
                let o = m.n;
                let p = m.o;
                if (o < this.l8.left || o > this.l8.right || p < this.l8.top || p > this.l8.bottom) {
                    return;
                }
                if (e.b4 && !e.b7 && e.categoryMode != 0) {
                    n.b = m.ak;
                }
                else {
                    n.b = e.d1(o, f);
                }
                if (g.b4 && !g.b7 && g.categoryMode != 0) {
                    n.c = m.ak;
                }
                else {
                    n.c = g.d1(p, h);
                }
                n.a = m.content;
                if (b) {
                    n.d = this.on(n.c, c);
                }
                else {
                    n.d = e.fl(m.ak);
                }
                a.add(n);
            }
        });
        return true;
    }
    on(a, b) {
        if (b >= 0) {
            return round10N(a, b).toString();
        }
        else {
            return a.toString();
        }
    }
    i2(a) {
        super.i2(a);
        this.ns = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get categoryAxis() {
        return this.nj();
    }
    nj() {
        return this.fetchXAxis();
    }
    n3() {
        return this.fetchYAxis();
    }
    get_cl() {
        return true;
    }
    ac() {
        super.ac();
        this.ns.cn.g(this.eu);
    }
    oc() {
        return (this.assigningCategoryStyle != null && this.n5) || this.cu;
    }
    od() {
        return (this.assigningCategoryMarkerStyle != null && this.n4) || this.cu;
    }
    o0(a) {
        if (this.assigningCategoryStyle != null && this.n5) {
            this.assigningCategoryStyle(this, a);
        }
    }
    oz(a) {
        if (this.assigningCategoryMarkerStyle != null && this.n4) {
            this.assigningCategoryMarkerStyle(this, a);
        }
    }
    nd(a, b) {
        return null;
    }
    h3(a, b) {
        super.h3(a, b);
        if (a) {
            this.ou(b);
        }
    }
    a8() {
        let a = super.a8();
        return a;
    }
    ik() {
        super.ik();
        let a = this.fetchXAxis();
        if (a != null) {
            a.hb(false);
        }
        let b = this.fetchYAxis();
        if (b != null) {
            b.hb(false);
        }
    }
    j1(a, b) {
        super.j1(a, b);
        this.ns.cn.g(this.eu);
        this.jl(false);
    }
    j0(a, b) {
        if (this.dm && this.ez < 0.05 && (this.bs == null || !this.bs.dr())) {
            this.dn = true;
        }
        super.j0(a, b);
        this.ns.cn.g(this.eu);
        this.jl(false);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                let e = this.fetchYAxis();
                let f = this.fetchXAxis();
                if (c != null && d == null) {
                    this.h7(f);
                    this.h7(e);
                }
                if (c == null && d != null) {
                    this.jc(f);
                    this.jc(e);
                }
                this.ns.cn.g(this.eu);
                this.jl(false);
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.ns.cn.g(this.eu);
                }
                this.jl(false);
                break;
            case "TransitionProgress":
                this.nn.c(this.ez, this.nl, this.nk);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.nk.v();
                    this.o1(this.nk, this.ns);
                    if (this.dm) {
                        this.dm = false;
                        this.h4();
                        this.bt.r = truncate(this.eq());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.o1(this.nn, this.ns);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case "ErrorBarSettings":
                this.it();
                break;
            case CategorySeries.$$p[4]:
                this.jl(false);
                break;
            case CategorySeries.$$p[1]:
                this.n5 = this.n7();
                this.jl(false);
                break;
            case CategorySeries.$$p[0]:
                this.n4 = this.n6();
                this.jl(false);
                break;
        }
    }
    n7() {
        return this.oa;
    }
    n6() {
        return this.n9;
    }
    oi(a) {
        return this.ed(a, this.fetchXAxis());
    }
    get_c1() {
        return typeCast(ISortingAxis_$type, this.nj()) !== null;
    }
    ap() {
        return this.nj();
    }
    fa(a) {
        return this.n2.b$d(this, a);
    }
    fp(a) {
        return this.n2.b$f(this, a);
    }
    e8(a) {
        let b = truncate(Math.round(this.eb(a)));
        return b;
    }
    eb(a) {
        return this.n2.b$c(this, a);
    }
    get_n8() {
        return false;
    }
    get n8() {
        return this.get_n8();
    }
    au(a, b) {
        let c = this.ny(a, b, this.n0);
        this.n0 = c;
        return c;
    }
    get_cv() {
        return true;
    }
    at(a, b) {
        if (this.n8) {
            let c = this.nx(a, b, this.nz);
            this.nz = c;
            return c;
        }
        else {
            let d = this.nw(a, b, this.nz);
            this.nz = d;
            return d;
        }
    }
    oh() {
        return this.ns.cq.a;
    }
    ny(a, b, c) {
        if (!this.md()) {
            return null;
        }
        let d = this.nk;
        if (this.ca()) {
            d = this.nn;
        }
        let e = this.oh();
        return this.n2.b$b(this, e, d.f, a, b, c);
    }
    nx(a, b, c) {
        let d = this.ns.cn.e;
        let e = this.ns.cn.f;
        let f = this.ns.cn.d;
        let g = this.nk;
        if (this.ca()) {
            g = this.nn;
        }
        return this.n2.b$a(this, g.f, d, e, f, a, b, c);
    }
    nw(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    }
    ow(a, b, c, d, e, f) {
        let g = this.b9;
        this.nr.ab(a, b, c, d, e, f, g);
        let h = this.nr.b;
        let i = null;
        let j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, true);
            h.b = i;
        }
        h.f = f;
        this.oz(h);
        this.nr.z(i, f, g);
    }
    ox(a, b, c, d, e, f) {
        let g = this.b9;
        this.nr.ac(a, b, c, d, e, f, g);
        let h = this.nr.c;
        let i = null;
        let j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.o0(h);
        this.nr.aa(i, f, g);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        d = d && this.og(this.fetchXAxis());
        d = d && this.og(this.fetchYAxis());
        let e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.bz == null) {
            d = false;
        }
        if (!d) {
            e.cn.d = 0;
        }
        return d;
    }
    og(a) {
        if (a == null || a.bh == null) {
            return false;
        }
        let b = typeCast(CategoryAxisBase.$, a);
        if (b != null) {
            if (b.itemsSource == null) {
                return false;
            }
            if (b.j7 < 1) {
                return false;
            }
        }
        else {
            let c = typeCast(NumericAxisBase.$, a);
            if (c != null) {
                return c.kc != c.kb;
            }
        }
        return true;
    }
    dc() {
        return this.ob;
    }
    nt() {
        return 12;
    }
    h4() {
        super.h4();
        this.nl.v();
        this.nk.v();
        this.nn.v();
    }
    jm(a) {
        super.jm(a);
        this.ns.cn.g(this.eu);
        if (this.cc(this.bi)) {
            this.nk.y();
            this.nn.y();
            this.nl.y();
            return;
        }
        if (this.de) {
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.o1(this.nn, this.ns);
            }
            else {
                this.o1(this.nk, this.ns);
            }
            return;
        }
        if (this.da(a)) {
            let b = this.nl;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.nl = this.nn;
                this.nn = b;
            }
            else {
                this.nl = this.nk;
                this.nk = b;
            }
            this.oy(this.nk, this.ns);
            if (this.dp) {
                this.bt.w();
                this.bt.r = truncate(this.er());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.nv.p(this.nl, this.nk, this.isVertical, this.fetchXAxis(), this.fetchYAxis(), this.nu, this.nt(), this.bp, this.bo(), runOn(this, this.oj), this.ns.br);
            }
            this.h0();
            this.jt();
            if (this.dp) {
                this.dn = false;
                this.dm = true;
            }
        }
        else {
            this.oy(this.nk, this.ns);
            this.o1(this.nk, this.ns);
        }
    }
    bo() {
        return 3;
    }
    oj() {
        if (this.isVertical) {
            return this.l8.left;
        }
        return this.l8.bottom;
    }
    om() {
        let a = 0;
        let b = this.fetchXAxis();
        for (let c of fromEnum(this.bs.series)) {
            if (c == this) {
                return a;
            }
            let d = typeCast(CategorySeries.$, c);
            if (d != null) {
                let e = typeCast(CategoryAxisBase.$, d.fetchXAxis());
                if (e == b && d.preferredCategoryMode(e) == 2) {
                    a++;
                }
            }
        }
        return -1;
    }
    get GetErrorBarsXAxis() {
        return this.fetchXAxis();
    }
    get GetErrorBarsYAxis() {
        return this.fetchYAxis();
    }
    ov(a, b) {
        this.nr.w(this, this.od(), runOn(this, this.nd), this.ok(a), this.ol(a));
        let c = this.nr.b;
        let d = c != null;
        let e = this.nj();
        if (e == null) {
            return;
        }
        let f = this.getEffectiveViewport1(a);
        let g = new ScalerParams(0, a.bs, a.br, e.ca, f);
        let h = this.bz == null ? 0 : this.bz.count;
        let i = a;
        let j = b.f;
        let k = i.cn.e;
        let l = i.cn.f;
        let m = i.cn.d;
        let n = k * m;
        for (let o = 0; o < a.cq.count; o++) {
            let p = a.cq.item(o);
            let q = p.content;
            if (d) {
                let r = p.al;
                this.ow(j, r, h, e, g, a.n);
            }
            this.nr.ad(p, q);
        }
    }
    o1(a, b) {
        this.lz = a.aa;
        b.ar();
    }
    oy(a, b) {
        a.u();
    }
    ok(a) {
        return a.cn.d;
    }
    ol(a) {
        return a.cn.e;
    }
    ou(a) {
        let b = a;
        b.cq.count = 0;
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        let c = typeCast(CategorySeriesView.$, this.bh);
        c.cn.g(this.eu);
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        this.o2();
        this.dl = false;
    }
    o2() {
        let a = typeCast(CategorySeriesView.$, this.bh);
        if (!this.df) {
            this.oy(this.nm, a);
        }
        this.df = false;
        this.o1(this.nm, a);
    }
    np(a) {
        let b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), b, this, b.cn);
            }
            else {
                return new CategoryFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, b), this.bs.b1.m, this, b.cn);
            }
        }
        else {
            return this.no;
        }
    }
    am(a) {
        if (this.fetchXAxis() == a) {
            return this.fetchYAxis();
        }
        if (this.fetchYAxis() == a) {
            return this.fetchXAxis();
        }
        return null;
    }
    ag() {
        return [this.fetchXAxis(), this.fetchYAxis()];
    }
    static ne(a, b, c, d, e) {
        let f = null;
        if (b > -1 && !d.isEmpty && !c.isEmpty) {
            let g = a._inner[0][0] < c.left - 2000 ? c.left - 10 : NaN;
            let h = c.bottom + 10;
            let i = a._inner[b][0] > c.right + 2000 ? c.right + 10 : NaN;
            let j = c.top - 10;
            f = new Clipper(1, g, h, i, j, e);
        }
        return f;
    }
}
CategorySeries.$t = markType(CategorySeries, 'CategorySeries', MarkerSeries.$, [IHasCategoryModePreference_$type, ISupportsErrorBars_$type]);
CategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, CategorySeries, 'raisePropertyChanged', ['IsCustomCategoryMarkerStyleAllowed:n9:o3', [0, false], 'IsCustomCategoryStyleAllowed:oa:o4', [0, false], 'IsTransitionInEnabled:ob:o5', [0, false], 'TransitionInMode:nu:o6', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'UseHighMarkerFidelity:of:o7', [0, false]]);
/**
 * @hidden
 */
class CategorySeriesView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.cp = null;
        this.cs = 0;
        this.cn = null;
        this.cq = null;
        this.cs = -1;
        this.cp = a;
        this.cn = this.co();
        this.cq = ((() => {
            let $ret = new Pool$1(Marker.$);
            $ret.create = runOn(this, this.bx);
            $ret.activate = runOn(this, this.cg);
            $ret.disactivate = runOn(this, this.ci);
            $ret.destroy = runOn(this, this.ch);
            return $ret;
        })());
    }
    cr(a) {
        if (this.cs != a.t) {
            return true;
        }
        return false;
    }
    cu(a) {
        this.cs = a.t;
    }
    updateMarkerTemplate(a, b, c) {
        if (!this.by.mf) {
            let d = this.cq.item(a);
            let e = d.content;
            e.item = this.e.bz.item(b);
            d.ak = b;
            d.al = c;
        }
    }
    co() {
        return new CategoryBucketCalculator(this);
    }
    get shouldDisplayMarkers() {
        return this.cp.md();
    }
    updateMarkerCount(a) {
        this.cq.count = a;
    }
    cc(a) {
        this.cq.c(a);
    }
    ct() {
    }
}
CategorySeriesView.$t = markType(CategorySeriesView, 'CategorySeriesView', MarkerSeriesView.$, [ISupportsMarkers_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrendLineSeries_$type = new Type(null, 'ITrendLineSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IAnchoredCategorySeriesInteractionManager_$type = new Type(null, 'IAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of collision avoidance of category series' markers.
 */
var CategorySeriesMarkerCollisionAvoidance;
(function (CategorySeriesMarkerCollisionAvoidance) {
    /**
     * Collision avoidance is disabled.
     */
    CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["None"] = 0] = "None";
    /**
     * Items colliding with other items will be hidden from view.
     */
    CategorySeriesMarkerCollisionAvoidance[CategorySeriesMarkerCollisionAvoidance["Omit"] = 1] = "Omit";
})(CategorySeriesMarkerCollisionAvoidance || (CategorySeriesMarkerCollisionAvoidance = {}));
/**
 * @hidden
 */
let CategorySeriesMarkerCollisionAvoidance_$type = markEnum('CategorySeriesMarkerCollisionAvoidance', 'None,0|Omit,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Determines the item returned in hit-testing when mousing over an object which represents several consolidated items.
 */
var ConsolidatedItemHitTestBehavior;
(function (ConsolidatedItemHitTestBehavior) {
    /**
     * Returns the item based on the X-location only.  Will return one of the consolidated items.
     */
    ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["Basic"] = 0] = "Basic";
    /**
     * Returns the item with the nearest Y-location out of all the items with a matching X-location.
     */
    ConsolidatedItemHitTestBehavior[ConsolidatedItemHitTestBehavior["NearestY"] = 1] = "NearestY";
})(ConsolidatedItemHitTestBehavior || (ConsolidatedItemHitTestBehavior = {}));
/**
 * @hidden
 */
let ConsolidatedItemHitTestBehavior_$type = markEnum('ConsolidatedItemHitTestBehavior', 'Basic,0|NearestY,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryMarkerManager extends Base {
    static b(a, b, c, d) {
        let e = a.md();
        if (c == null) {
            return;
        }
        if (e) {
            for (let f = 0; f < b.count; ++f) {
                CategoryMarkerManager.a(c, f, b, d);
            }
            c.count = b.count;
        }
    }
    static a(a, b, c, d) {
        a.item(b).n = c._inner[b].x;
        a.item(b).o = c._inner[b].y;
    }
}
CategoryMarkerManager.$t = markType(CategoryMarkerManager, 'CategoryMarkerManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDetectsCollisions_$type = new Type(null, 'IDetectsCollisions');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CollisionAvoider extends Base {
    constructor() {
        super();
        this.a = new List$1(Rect.$, 0);
    }
    tryAdd(a) {
        for (let b = this.a.count - 1; b >= 0; --b) {
            if (a.left > this.a._inner[b].right) {
                break;
            }
            if (this.a._inner[b].intersectsWith(a)) {
                return false;
            }
        }
        if (this.a.count == 0 || a.right >= this.a._inner[this.a.count - 1].right) {
            this.a.add(a);
        }
        else {
            this.a.add(a);
            this.a.aa((c, d) => Math.sign(c.right - d.right));
        }
        return true;
    }
    clear() {
        this.a.clear();
    }
}
CollisionAvoider.$t = markType(CollisionAvoider, 'CollisionAvoider', Base.$, [IDetectsCollisions_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NonCollisionAvoider extends Base {
    constructor() {
        super();
    }
    static get b() {
        if (NonCollisionAvoider.a == null) {
            NonCollisionAvoider.a = new NonCollisionAvoider();
        }
        return NonCollisionAvoider.a;
    }
    clear() {
    }
    tryAdd(a) {
        return true;
    }
}
NonCollisionAvoider.$t = markType(NonCollisionAvoider, 'NonCollisionAvoider', Base.$, [IDetectsCollisions_$type]);
NonCollisionAvoider.a = null;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTrendLineManagerFactory extends Base {
    static a(a, b, c, d, e) {
        if (b != null && typeCast(ISortingAxis_$type, b) !== null) {
            if (a != null) {
                a.g$f();
            }
            if (!TypeRegistrar.isRegistered("SortingTrendLineManager")) {
                throw new NotSupportedException(1, e.p);
            }
            let f = TypeRegistrar.create("SortingTrendLineManager", ((g) => {
                let h = g;
                let i = typeCast(ISortingAxis_$type, b);
                if (i != null) {
                    g = Math.min(g, i.i$b.count - 1);
                    h = i.i$b._inner[g];
                }
                return i.i$d(h);
            }), ((g, h, i) => {
                let j = d.getEffectiveViewport1(d.bi);
                let k = new ScalerParams(0, i, h, b.ca, j);
                return b.d1(g, k);
            }));
            f.g$c(c, d);
            return f;
        }
        else if (a == null || a.g$a != 0) {
            if (a != null) {
                a.g$f();
            }
            if (!TypeRegistrar.isRegistered("CategoryTrendLineManager")) {
                throw new NotSupportedException(1, e.p);
            }
            let g = TypeRegistrar.create("CategoryTrendLineManager");
            g.g$c(c, d);
            return g;
        }
        return a;
    }
}
CategoryTrendLineManagerFactory.$t = markType(CategoryTrendLineManagerFactory, 'CategoryTrendLineManagerFactory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnchoredCategorySeries extends CategorySeries {
    constructor() {
        super();
        this.pf = null;
        this.pj = false;
        this.ph = null;
        this.pc = null;
        this.pm = null;
        this.no = new CategoryFramePreparer(1, this, this.ns, this, this, this.ns.cn);
    }
    get pg() {
        if (this.pf == null) {
            this.pf = DVContainer.instance.createInstance(IAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.pf;
    }
    getHostReferenceValue() {
        return this.eh();
    }
    bf() {
        let a = new AnchoredCategorySeriesView(this);
        return a;
    }
    i2(a) {
        super.i2(a);
        this.pb = a;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == AnchoredCategorySeries.$$p[2]) {
            return this.ft(a, b, this.pq);
        }
        return super.fs(a, b);
    }
    get valueColumn() {
        return this.ph;
    }
    set valueColumn(a) {
        if (this.ph != a) {
            let b = this.ph;
            this.ph = a;
            if (!this.pj) {
                this.raisePropertyChanged("ValueColumn", b, this.ph);
            }
        }
    }
    get p8() {
        return this.c(AnchoredCategorySeries.px);
    }
    set p8(a) {
        this.h(AnchoredCategorySeries.px, a);
    }
    c9(a) {
        let b = new Rect(0, 0, 0, 1, 1);
        let c = this.fetchXAxis();
        let d = this.fetchYAxis();
        let e = this.l2(this.bi);
        let f = c != null ? this.no.r(typeCast(ICategoryScaler_$type, c), b, b, e) : 0;
        return this.pg.c$a(this, this.valueColumn, c, d, f, a);
    }
    o8(a, b, c) {
        if (b < a || a < 0 || a > this.valueColumn.count || b < 0 || b > this.valueColumn.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.cf;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.pb.cz && this.pb.cy.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.valueColumn);
                    this.valueColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.valueColumn = this.bw(this.pq);
                }
                let e = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (e != null && !e.cn()) {
                    this.pb.cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case AnchoredCategorySeries.$$p[2]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.valueColumn);
                    this.valueColumn = this.bw(this.pq);
                }
                this.pm = this.pq;
                break;
            case "ValueColumn":
                if (this.pb.cz) {
                    this.pb.cy.g$i();
                }
                let f = typeCast(NumericAxisBase.$, this.fetchYAxis());
                if (f != null && !f.cn()) {
                    this.pb.cn.g(this.eu);
                    this.jl(false);
                }
                this.pw();
                this.jy();
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case "ErrorBarSettings":
                this.jl(false);
                break;
            case "TrendLineType":
                this.it();
                break;
            case AnchoredCategorySeries.$$p[1]:
                this.jl(false);
                break;
        }
    }
    an(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    }
    h6(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.pb.cn.g(this.eu);
                break;
        }
        if (this.pb.cz) {
            this.pb.cy.g$e(a, b, c, d);
        }
        this.pw();
        this.jy();
    }
    oj() {
        return this.pk(this.ns);
    }
    pk(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        let f = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!c.isEmpty && !d.isEmpty && f != null) {
            let g = new ScalerParams(0, c, d, f.ca, e);
            if (f.ch) {
                g.b = this.eh();
            }
            b = f.dy(f.km, g);
        }
        return b;
    }
    pv(a, b, c) {
        let d = this.pk(c);
        if (a.count > 0) {
            let e = d;
            a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
            a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
        }
    }
    o9(a, b, c, d) {
        return this.pa(a, b, c, d, false);
    }
    pa(a, b, c, d, e) {
        return CategorySeries.ne(a, b, c, d, e);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        let e = c;
        if (this.valueColumn == null || this.valueColumn.count == 0 || e.cn.d < 1) {
            d = false;
        }
        return d;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.ct();
        if (c.cz) {
            c.cy.g$d();
        }
    }
    oy(a, b) {
        super.oy(a, b);
        this.np(b).d(a, b);
    }
    o1(a, b) {
        super.o1(a, b);
        let c = typeCast(AnchoredCategorySeriesView.$, b);
        c.b0 = true;
        if (c.cz) {
            c.cy.g$g(a.p);
        }
        if (this.md()) {
            CategoryMarkerManager.b(this, a.m, b.cq, this.mf);
            this.ov(b, a);
            b.cj();
        }
        this.ps(a, b);
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.cn.g(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.pc == null) {
            this.pc = new CategoryFrame(3);
        }
        this.pc.u();
        this.oy(this.pc, g);
        this.o1(this.pc, g);
    }
    ps(a, b) {
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        this.pb.c3();
        if (this.trendLineBrush != null) {
            this.pb.c1();
        }
        else {
            this.pb.c0();
        }
    }
    fv(a, b) {
        if (this.pb.cz && a == this.pb.cy.g$j) {
            return null;
        }
        return super.fv(a, b);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.nj()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.nj());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.n3());
    }
    get bucketizer() {
        return this.pb.cn;
    }
    get currentMode2Index() {
        return this.om();
    }
    provideCollisionDetector() {
        if (this.pd == 1) {
            return new CollisionAvoider();
        }
        return NonCollisionAvoider.b;
    }
    get trendlinePreparer() {
        return this.pb.cz ? this.pb.cy : null;
    }
    ic(a) {
        super.ic(a);
        if (this.pb.cz) {
            this.a2.exportTrendlineData(this, a, this.pb.cy.g$j);
        }
    }
    fp(a) {
        let b = this.fetchXAxis();
        let c = this.fetchYAxis();
        return this.pg.c$b(this, a, this.ok(this.bi), this.valueColumn, b, c, this.pe == 1, (d) => super.fp(d));
    }
    get mayContainUnknowns() {
        return this.valueColumn == null || this.valueColumn.mayContainUnknowns;
    }
    eh() {
        return Series.ei(this.valueColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    }
    ao(a) {
        if (a.isEmpty && this.bs != null) {
            a = this.bs.n2;
        }
        if (this.valueColumn == null) {
            return null;
        }
        let b = this.l0(this.bi);
        let c = this.nj();
        let d = new ScalerParams(0, a, this.bs.oh, c.ca, this.getEffectiveViewport());
        let e = (c.d1(b.left, d));
        let f = (c.d1(b.right, d));
        let g = null;
        if (c.cf) {
            g = c;
            e = g.i$f(e);
            f = g.i$f(f);
        }
        else {
            e = Math.floor(e);
            f = Math.ceil(f);
        }
        if (isNaN_(e) || isNaN_(f)) {
            return null;
        }
        e = Math.max(0, Math.min(this.valueColumn.count - 1, e));
        f = Math.max(0, Math.min(this.valueColumn.count - 1, f));
        let h = 1.7976931348623157E+308;
        let i = -1.7976931348623157E+308;
        for (let j = truncate(e); j <= truncate(f); j++) {
            let k = j;
            if (g != null) {
                k = g.i$b._inner[j];
            }
            h = Math.min(h, this.valueColumn.item(k));
            i = Math.max(i, this.valueColumn.item(k));
        }
        return new AxisRange(h, i);
    }
    pw() {
        this.d8 = this.valueColumn == null || this.valueColumn.count == 0 ? NaN : this.valueColumn.item(this.valueColumn.count - 1);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
AnchoredCategorySeries.$t = markType(AnchoredCategorySeries, 'AnchoredCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasSingleValueCategory_$type, IHasCategoryTrendline_$type, ITrendLineSeries_$type]);
AnchoredCategorySeries.px = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredCategorySeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
AnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredCategorySeries, 'raisePropertyChanged', ['ConsolidatedItemHitTestBehavior:pe:py', [ConsolidatedItemHitTestBehavior_$type, enumGetBox(ConsolidatedItemHitTestBehavior_$type, 0)], 'MarkerCollisionAvoidance:pd:pz', [CategorySeriesMarkerCollisionAvoidance_$type, enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, 1)], 'ValueMemberPath:pq:p7', [2, null], 'TrendLineType::p5', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::p4', [1, 1.5], 'TrendLinePeriod::p3', [1, 7], 'TrendLineBrush::p0', [Brush.$, null], 'TrendLineZIndex:pl:p6', [1, 1001], 'TrendLineDashArray:p9:p1', [DoubleCollection.$], 'TrendLineDashCap:qa:p2', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.i = null;
        this.h = null;
        this.j = 0;
        this.i = a;
    }
    getBucketWithoutUnknowns(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    getBucket(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 0;
        let h = 0;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            if (!i) {
                if (!isNaN_(k)) {
                    g = g < k ? g : k;
                    h = h > k ? h : k;
                }
            }
            else {
                if (!isNaN_(k)) {
                    g = k;
                    h = k;
                    i = false;
                }
            }
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    cacheValues() {
        this.j = this.i.cw.valueColumn.count;
        this.h = this.i.cw.valueColumn.asArray();
    }
    unCacheValues() {
        this.h = null;
    }
}
AnchoredCategoryBucketCalculator.$t = markType(AnchoredCategoryBucketCalculator, 'AnchoredCategoryBucketCalculator', CategoryBucketCalculator.$);
/**
 * @hidden
 */
class AnchoredCategorySeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cx = null;
        this.cw = a;
    }
    get cy() {
        if (this.cx == null) {
            this.cx = CategoryTrendLineManagerFactory.a(this.cx, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
        return this.cx;
    }
    set cy(a) {
        this.cx = a;
    }
    get cz() {
        return this.cx != null;
    }
    c3() {
        this.cw.p8 = null;
    }
    c1() {
        this.cw.p8 = this.cw.trendLineBrush;
    }
    c0() {
        this.cw.p8 = this.cw.lb;
    }
    co() {
        return new AnchoredCategoryBucketCalculator(this);
    }
    c2() {
        this.cn.cacheValues();
    }
    c4() {
        this.cn.unCacheValues();
    }
    c5(a) {
        let b = this.cq.item(a);
        return this.cm(b);
    }
    a2(a, b) {
        if (a.d) {
            if (this.cw.trendLineType != 0 && !b) {
                let c = this.cy.g$j;
                c.ac = this.cw.trendLineThickness;
                c._stroke = this.cw.p8;
                c.ai = this.cw.p9;
                c.ad = this.cw.qa;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    getDefaultTooltipTemplate() {
        return this.cw.pg.c$c(this.e, this.cw.pq);
    }
}
AnchoredCategorySeriesView.$t = markType(AnchoredCategorySeriesView, 'AnchoredCategorySeriesView', CategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHorizontalAnchoredCategorySeriesInteractionManager_$type = new Type(null, 'IHorizontalAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalAnchoredCategorySeries extends AnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.qf = null;
        this.qb = null;
        this.qh = null;
        this.qd = 0;
    }
    get qg() {
        if (this.qf == null) {
            this.qf = DVContainer.instance.createInstance(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.qf;
    }
    h1() {
        super.h1();
        this.xAxis = null;
        this.yAxis = null;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    nj() {
        return this.qb;
    }
    n3() {
        return this.qh;
    }
    l6(a) {
        if (this.nk == null || this.nk.m.count == 0 || !this.hasMarkers || !this.md()) {
            return Rect.empty;
        }
        return this.qg.d$d(this, this.nk.m, a, runOn(this, this.qt));
    }
    qt(a) {
        return this.pb.c5(a);
    }
    ql(a, b, c) {
        return this.qg.d$c(this, this.n3(), a, b, c);
    }
    ah(a) {
        return this.qg.d$a(this, this.nk.f, this.ok(this.bi), this.ol(this.bi), a);
    }
    ai(a) {
        return this.qg.d$b(this, this.nk.f, this.ok(this.bi), this.ol(this.bi), a);
    }
    dh(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    getOffsetValue() {
        return this.no.r(this.nj(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        let a = this.getEffectiveViewport1(this.bi);
        return this.nj().getCategorySize(this.bi.bs, this.bi.br, a);
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.nj();
        let f = new ScalerParams(0, this.bs.n2, this.bi.br, e.ca, d);
        let g = this.no.r(e, this.bs.n2, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.oi), b, c);
    }
    fe(a, b) {
        return this.ff(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    }
    fc(a, b) {
        return this.fd(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    }
    d9(a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.nj(), d, e, this.valueColumn.count, runOn(this, this.oi));
    }
    lv(a, b, c) {
        if (this.nj() == null || this.n3() == null) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        return this.lx(a, b, c, this.no.r(this.nj(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.n3(), this.nj(), null, null, null);
    }
    fetchXAxis() {
        return this.qb;
    }
    fetchYAxis() {
        return this.qh;
    }
    pt(a) {
        this.xAxis = typeCast(CategoryAxisBase.$, a);
    }
    pu(a) {
        this.yAxis = typeCast(NumericYAxis.$, a);
    }
    oe() {
        return this.qh != null && this.qh.cn();
    }
    qp(a) {
        this.qb = a;
    }
    qq(a) {
        this.qh = a;
    }
    nd(a, b) {
        return this.o8(a, b, this.qb);
    }
    i7(a, b, c, d) {
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                this.qp(this.xAxis);
                if (this.pb.cz) {
                    this.pb.cy = CategoryTrendLineManagerFactory.a(this.pb.cy, this.qb, this.j5, this, this.b2);
                }
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pb.cy = CategoryTrendLineManagerFactory.a(this.pb.cy, this.qb, this.j5, this, this.b2);
                }
                break;
        }
        super.i7(a, b, c, d);
        switch (b) {
            case HorizontalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.qp(this.xAxis);
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                    this.it();
                }
                break;
            case HorizontalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.qq(this.yAxis);
                    this.ns.cn.g(this.eu);
                    this.oe();
                    this.jl(false);
                    this.it();
                }
                break;
            case "CategoryMode":
                if (this.xAxis != null) {
                    this.xAxis.kv(true);
                }
                break;
        }
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.qb != null && typeCast(ISortingAxis_$type, this.qb) !== null) {
            this.qb.i$i();
        }
        switch (a) {
            case 4:
                if (this.qb != null) {
                    this.qb.cn();
                }
                if (this.qh != null && !this.qh.cn()) {
                    this.jl(true);
                }
                break;
            case 1:
                if (this.qb != null) {
                    this.qb.cn();
                }
                if (this.qh != null && !this.qh.cn()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (this.qb != null) {
                    this.qb.cn();
                }
                if (this.qh != null && !this.qh.cn()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (this.pm != null && this.pb.cn.d > 0 && this.qh != null && !this.qh.cn()) {
                    this.jl(true);
                }
                break;
            case 3:
                if (d == this.pm) {
                    if (this.qb != null) {
                        this.qb.cn();
                    }
                    if (this.qh != null && !this.qh.cn()) {
                        this.jl(true);
                    }
                }
                break;
        }
    }
    qj(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    }
    qk(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get qe() {
        return this.qd;
    }
    set qe(a) {
        let b = this.qe;
        if (a != b) {
            this.qd = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.qe));
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
HorizontalAnchoredCategorySeries.$t = markType(HorizontalAnchoredCategorySeries, 'HorizontalAnchoredCategorySeries', AnchoredCategorySeries.$);
HorizontalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::qr', [CategoryAxisBase.$, null], 'YAxis::qs', [NumericYAxis.$, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalAnchoredCategorySeriesProxy extends Base {
    matchesType(a) {
        return typeCast(HorizontalAnchoredCategorySeries.$, a) !== null;
    }
    setCategoryMode(a, b) {
        a.qe = b;
    }
    setValueMemberPath(a, b) {
        a.pq = b;
    }
    setXAxis(a, b) {
        a.xAxis = b;
    }
    setYAxis(a, b) {
        a.yAxis = b;
    }
}
HorizontalAnchoredCategorySeriesProxy.$t = markType(HorizontalAnchoredCategorySeriesProxy, 'HorizontalAnchoredCategorySeriesProxy', Base.$, [IHorizontalAnchoredCategorySeriesProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHorizontalAnchoredCategorySeriesProxyModule = class IgxHorizontalAnchoredCategorySeriesProxyModule {
    constructor() {
        TypeRegistrar.register('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy.$type);
    }
};
IgxHorizontalAnchoredCategorySeriesProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxHorizontalAnchoredCategorySeriesProxyModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHorizontalAnchoredCategorySeriesProxyDynamicModule = class IgxHorizontalAnchoredCategorySeriesProxyDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy);
        TypeRegistrar.register('HorizontalAnchoredCategorySeriesProxy', HorizontalAnchoredCategorySeriesProxy.$type);
    }
};
IgxHorizontalAnchoredCategorySeriesProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxHorizontalAnchoredCategorySeriesProxyModule
        ],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxHorizontalAnchoredCategorySeriesProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum used to determine positioning logic for data items which have been consolidated into a single visual element.
 */
var ConsolidatedItemsPosition;
(function (ConsolidatedItemsPosition) {
    /**
     * Consolidated Items should be positioned using their minimum value.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Minimum"] = 0] = "Minimum";
    /**
     * Consolidated Items should be positioned using their maximum value.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Maximum"] = 1] = "Maximum";
    /**
     * Consolidated Items should be positioned at the midpoint of the range.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["Median"] = 2] = "Median";
    /**
     * Consolidated Items should be positioned using the value nearest to the reference value of the corresponding axis.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMinimum"] = 3] = "RelativeMinimum";
    /**
     * Consolidated Items should be positioned using the value farthest from the reference value of the corresponding axis.
     */
    ConsolidatedItemsPosition[ConsolidatedItemsPosition["RelativeMaximum"] = 4] = "RelativeMaximum";
})(ConsolidatedItemsPosition || (ConsolidatedItemsPosition = {}));
/**
 * @hidden
 */
let ConsolidatedItemsPosition_$type = markEnum('ConsolidatedItemsPosition', 'Minimum,0|Maximum,1|Median,2|RelativeMinimum,3|RelativeMaximum,4');

/**
 * Represents the base class for all IgxDataChartComponent numeric axes.
*/
const IgxNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericAxisBaseComponent) }];
class IgxNumericAxisBaseComponent extends IgxAxisComponent {
    constructor() {
        super();
        this._actualMinimumValueChange = null;
        this._actualMaximumValueChange = null;
        this._actualIntervalChange = null;
        this._actualMinorIntervalChange = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets if the current axis is of numeric axis type
    */
    get isNumeric() {
        return this.i.cc;
    }
    /**
     * Gets or sets the MinimumValue property.
    *
    * Used to set the minimum value of a numeric axis. To get the minimum value in effect on a numeric axis use `actualMinimumValue`.
    *
    * ```ts
    * this.yAxis.minimumValue = 0;
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         minimumValue=0
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get minimumValue() {
        return this.i.kk;
    }
    set minimumValue(v) {
        this.i.kk = +v;
    }
    /**
     * Gets the effective minimum value for the current numeric axis object.
    *
    * ```ts
    * let effectiveMinValue: number = yAxis.actualMinimumValue;
    * ```
    */
    get actualMinimumValue() {
        return this.i.kc;
    }
    set actualMinimumValue(v) {
        this.i.kc = +v;
    }
    /**
     * Gets the effective minimum value for the current numeric axis object.
    *
    * The `actualVisibleMinimumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMinimumValue` may differ from the `actualMinimumValue`, for example when the chart is zoomed.
    *
    * ```ts
    * let effectiveVisibleMinValue: number = yAxis.actualVisibleMinimumValue;
    * ```
    */
    get actualVisibleMinimumValue() {
        return this.i.kf;
    }
    set actualVisibleMinimumValue(v) {
        this.i.kf = +v;
    }
    /**
     * Gets or sets the MaximumValue property.
    *
    * Used to set the maximum value of a numeric axis. To get the maximum value in effect on a numeric axis use `actualMaximumValue`.
    *
    * ```ts
    * this.yAxis.maximumValue = 80;
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         maximumValue=80
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    */
    get maximumValue() {
        return this.i.kj;
    }
    set maximumValue(v) {
        this.i.kj = +v;
    }
    /**
     * Gets the effective maximum value for the current numeric axis object.
    *
    * ```ts
    * let effectiveMaxValue: number = yAxis.actualMaximumValue;
    * ```
    */
    get actualMaximumValue() {
        return this.i.kb;
    }
    set actualMaximumValue(v) {
        this.i.kb = +v;
    }
    /**
     * Gets the effective visible maximum value for the current numeric axis object.
    *
    * The `actualVisibleMaximumValue` is used to get the current visible maximum value for the a numeric axis. Note, at times the `actualVisibleMaximumValue` may differ from the `actualMaximumValue`, for example when the chart is zoomed.
    *
    * ```ts
    * let effectiveVisibleMaxValue: number = yAxis.actualVisibleMaximumValue;
    * ```
    */
    get actualVisibleMaximumValue() {
        return this.i.ke;
    }
    set actualVisibleMaximumValue(v) {
        this.i.ke = +v;
    }
    /**
     * Gets or sets the Interval property.
    *
    * The `interval` is used to get or set the numeric axis major interval which specifies how frequent major gridlines and axis labels are rendered on an axis.
    *
    * ```ts
    * this.yAxis.interval = 20;
    * ```
    *
    * ```html
    * <igx-data-chart
    *       [dataSource]="data">
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis
    *         >
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         interval="20"
    *         #yAxis>
    *       </igx-numeric-y-axis>
    *
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get interval() {
        return this.i.kg;
    }
    set interval(v) {
        this.i.kg = +v;
    }
    /**
     * Gets the effective value for the current Interval.
    *
    * ```ts
    * let effectiveInterval: number = yAxis.actualInterval;
    * ```
    */
    get actualInterval() {
        return this.i.ka;
    }
    set actualInterval(v) {
        this.i.ka = +v;
    }
    /**
     * Gets or sets the MinorInterval property.
    *
    * The `minorInterval` is used to get or set the numeric axis minor interval which specifies how frequent minor gridlines are rendered on an axis. Please note, in order for minor gridlines to be displayed the following may also need to be set: `MinorStroke`, `MinorStrokeThickness`.
    *
    * ```ts
    * this.yAxis.minorInterval = 2.5;
    * this.yAxis.minorStroke = 'blue';
    * this.yAxis.minorStrokeThickness = 1;
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         minorInterval= 2.5
    *         minorStroke="blue"
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get minorInterval() {
        return this.i.kl;
    }
    set minorInterval(v) {
        this.i.kl = +v;
    }
    /**
     * Gets the effective value for the current MinorInterval.
    *
    * ```ts
    * let effectiveMinorInterval: number = yAxis.actualMinorInterval;
    * ```
    */
    get actualMinorInterval() {
        return this.i.kd;
    }
    set actualMinorInterval(v) {
        this.i.kd = +v;
    }
    /**
     * Gets or sets the ReferenceValue property.
    *
    * Used to get or set a reference value on a numeric axis which when used with an area, bar, or column series will result in the series shapes being drawn above or below the specified value.
    *
    * ```ts
    * this.yAxis.referenceValue = 30;
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         referenceValue=30
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get referenceValue() {
        return this.i.km;
    }
    set referenceValue(v) {
        this.i.km = +v;
    }
    /**
     * Gets or sets the IsLogarithmic property.
    *
    * `isLogarithmic` is used to get or set whether the numeric axis scaler is in linear or logarithmic mode. For logarithmic scaling, this can be used in conjunction with `logarithmBase` to further define the logarithmic scale.
    *
    * ```ts
    * this.yAxis.isLogarithmic= true;
    * this.yAxis.logarithmBase = 2;
    * ```
    *
    * ```html
    * <igx-data-chart
    *       [dataSource]="data">
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         isLogarithmic=true
    *         logarithmBase=2
    *         #yAxis>
    *       </igx-numeric-y-axis>
    *       <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-line-series>
    * </igx-data-chart>
    * ```
    */
    get isLogarithmic() {
        return this.i.j1;
    }
    set isLogarithmic(v) {
        this.i.j1 = ensureBool(v);
    }
    /**
     * Determines if the axis has a valid logarithmic scale.
    *
    * ```ts
    * let effectiveLogarithmic: boolean = this.yAxis.actualIsLogarithmic
    * ```
    */
    get actualIsLogarithmic() {
        return this.i.jx;
    }
    set actualIsLogarithmic(v) {
        this.i.jx = ensureBool(v);
    }
    /**
     * Gets or sets the LogarithmBase property.
    *
    * `logarithmBase` is used to get or set logarithm base when a numeric axis is in Logarithmic scale mode. For logarithmic scaling, this is used in conjunction with `isLogarithmic` or `ScaleMode` to set logarithmic scaling.
    *
    * ```ts
    * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
    * this.yAxis.logarithmBase = 2;
    * ```
    *
    * ```html
    * <igx-data-chart
    *       [dataSource]="data">
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis
    *         scaleMode="Logarithmic"
    *         logarithmBase=2
    *         #yAxis>
    *       </igx-numeric-y-axis>
    *       <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *       </igx-line-series>
    * </igx-data-chart>
    * ```
    */
    get logarithmBase() {
        return this.i.ko;
    }
    set logarithmBase(v) {
        this.i.ko = +v;
    }
    /**
     * Determines if the axis has a user-defined minimum.
    *
    *  `hasUserMaximum` is used to determine if a numeric axis has a user definied maximum value.
    *
    * ```ts
    * let hasSetMaximum: boolean = this.yAxis.hasUserMaximum;
    * ```
    */
    get hasUserMinimum() {
        return this.i.j0;
    }
    /**
     * Determines if the axis has a user-defined maximum.
    *
    *  `hasUserMinimum` is used to determine if a numeric axis has a user definied minium value.
    *
    * ```ts
    * let hasSetMinimum: boolean = this.yAxis.hasUserMinimum;
    * ```
    */
    get hasUserMaximum() {
        return this.i.jz;
    }
    /**
     * A boolean indicating whether or not to abbreviate large numbers.
    */
    get abbreviateLargeNumbers() {
        return this.i.jw;
    }
    set abbreviateLargeNumbers(v) {
        this.i.jw = ensureBool(v);
    }
    /**
     * Unscales a value from screen space into axis space.
    
    * @param unscaledValue  * The scaled value in screen coordinates to unscale into axis space.
    *
    * Unscales a value from screen space into axis space.
    *
    * ```ts
    * let dataValue: number = this.yAxis.unscaleValue(pixel);
    * ```
    */
    unscaleValue(unscaledValue) {
        let iv = this.i.kn(unscaledValue);
        return (iv);
    }
    get actualMinimumValueChange() {
        if (this._actualMinimumValueChange == null) {
            this._actualMinimumValueChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinimumValue;
                if (this.beforeActualMinimumValueChange) {
                    this.beforeActualMinimumValueChange(this, ext);
                }
                this._actualMinimumValueChange.emit(ext);
            });
        }
        return this._actualMinimumValueChange;
    }
    get actualMaximumValueChange() {
        if (this._actualMaximumValueChange == null) {
            this._actualMaximumValueChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMaximumValue;
                if (this.beforeActualMaximumValueChange) {
                    this.beforeActualMaximumValueChange(this, ext);
                }
                this._actualMaximumValueChange.emit(ext);
            });
        }
        return this._actualMaximumValueChange;
    }
    get actualIntervalChange() {
        if (this._actualIntervalChange == null) {
            this._actualIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualInterval;
                if (this.beforeActualIntervalChange) {
                    this.beforeActualIntervalChange(this, ext);
                }
                this._actualIntervalChange.emit(ext);
            });
        }
        return this._actualIntervalChange;
    }
    get actualMinorIntervalChange() {
        if (this._actualMinorIntervalChange == null) {
            this._actualMinorIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinorInterval;
                if (this.beforeActualMinorIntervalChange) {
                    this.beforeActualMinorIntervalChange(this, ext);
                }
                this._actualMinorIntervalChange.emit(ext);
            });
        }
        return this._actualMinorIntervalChange;
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualVisibleMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "maximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualVisibleMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "minorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "actualMinorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "referenceValue", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxNumericAxisBaseComponent.prototype, "isLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxNumericAxisBaseComponent.prototype, "actualIsLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAxisBaseComponent.prototype, "logarithmBase", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxNumericAxisBaseComponent.prototype, "abbreviateLargeNumbers", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxNumericAxisBaseComponent.prototype, "actualMinimumValueChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxNumericAxisBaseComponent.prototype, "actualMaximumValueChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxNumericAxisBaseComponent.prototype, "actualIntervalChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxNumericAxisBaseComponent.prototype, "actualMinorIntervalChange", null);

/**
 * Defines a set of basic methods and properties used to create a StraightNumeric axis.
*/
const IgxStraightNumericAxisBaseComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxStraightNumericAxisBaseComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxStraightNumericAxisBaseComponent) }];
class IgxStraightNumericAxisBaseComponent extends IgxNumericAxisBaseComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the axis scale mode.
    *
    * `scaleMode` can be used on numeric axes to allow scaling data values using built-in scalers. The available scalers are linear or logarithmic.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis
    *         scaleMode="logarithmic">
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.yAxis.scaleMode = NumericScaleMode.Logarithmic;
    * ```
    */
    get scaleMode() {
        return this.i.lk;
    }
    set scaleMode(v) {
        this.i.lk = ensureEnum(NumericScaleMode_$type, v);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStraightNumericAxisBaseComponent.prototype, "scaleMode", null);

var IgxNumericYAxisComponent_1;
/**
 * Represents a IgxDataChartComponent numeric Y axis.
*
* The `IgxNumericYAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the Y-axis. Location of labels varies according to the value in a data column that is mapped using the `YMemberPath` property for Scatter Series or `ValueMemberPath` property for Category Series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-column-series>
* </igx-data-chart>
* ```
*/
const IgxNumericYAxisComponent_PROVIDERS = [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent) }];
let IgxNumericYAxisComponent = IgxNumericYAxisComponent_1 = class IgxNumericYAxisComponent extends IgxStraightNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericYAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets if the current axis is of vertical axis
    */
    get isVertical() {
        return this.i.ch;
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.l3(minimum, maximum);
    }
};
IgxNumericYAxisComponent = IgxNumericYAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-numeric-y-axis',
        template: ``,
        providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent_1) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericYAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxNumericYAxisComponent);

/**
 * Contains contextual information about a highlighting.
*/
class IgxHighlightingInfo {
    createImplementation() {
        return new HighlightingInfo();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The index of the first highlighted item.
    *
    * You can use `startIndex` to get or set the first highlighted item for the series.
    *
    * ```html
    * <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true" (assigningCategoryStyle)="assigningSeries($event)"   >
    * </igx-column-series>
    * ```
    */
    get startIndex() {
        return this.i.f;
    }
    set startIndex(v) {
        this.i.f = +v;
    }
    /**
     * The index of the last highlighted item.
    *
    * You can use the `endIndex` to get or set the last highlighted item for the series.
    *
    * ```html
    * <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
    *       </igx-column-series>
    * ```
    */
    get endIndex() {
        return this.i.e;
    }
    set endIndex(v) {
        this.i.e = +v;
    }
    /**
     * The state of the highlighting.
    *
    * You can use the `state` to get or set the transitioning state of the highlighting, between In, Out, or Static.
    */
    get state() {
        return this.i.a;
    }
    set state(v) {
        this.i.a = ensureEnum(HighlightingState_$type, v);
    }
    /**
     * A number between 0 and 1 representing the progress of the highlighting.
    *
    * You can use the `progress` property to set a number between 0 and 1 representing the progress of the highlighting.
    *
    * ```html
    * <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
    *       </igx-column-series>
    * ```
    */
    get progress() {
        return this.i.d;
    }
    set progress(v) {
        this.i.d = +v;
    }
    /**
     * True if this HighlightingInfo represents a marker highlighting.
    *
    * You can set the `isMarker` to True if the HighlightingInfo represents a marker highlighting. Otherwise set to false.
    *
    * ```html
    * <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
    *       </igx-column-series>
    * ```
    */
    get isMarker() {
        return this.i.c;
    }
    set isMarker(v) {
        this.i.c = ensureBool(v);
    }
    /**
     * The series in context.
    *
    * You can use the `series` property to get the series in context.
    *
    * ```html
    * <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isHighlightingEnabled="true" isCustomCategoryStyleAllowed="true"  (assigningCategoryStyle)="assigningSeries($event)"   >
    *       </igx-column-series>
    * ```
    */
    get series() {
        if (this.i.b == null) {
            return null;
        }
        if (!this.i.b.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.b);
            if (e) {
                e._implementation = this.i.b;
            }
            this.i.b.externalObject = e;
        }
        return this.i.b.externalObject;
    }
    set series(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    findByName(name) {
        if (this.series && this.series.name && this.series.name == name) {
            return this.series;
        }
        return null;
    }
}

/**
 * Represents event arguments base class for the AssigningCategoryStyleEventArgsBase
*/
class IgxAssigningCategoryStyleEventArgsBase {
    createImplementation() {
        return null;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the start index
    */
    get startIndex() {
        return this.i.m;
    }
    set startIndex(v) {
        this.i.m = +v;
    }
    /**
     * Gets the end index
    */
    get endIndex() {
        return this.i.l;
    }
    set endIndex(v) {
        this.i.l = +v;
    }
    /**
     * Gets the start date
    */
    get startDate() {
        return this.i.h;
    }
    set startDate(v) {
        this.i.h = v;
    }
    /**
     * Gets the end date
    */
    get endDate() {
        return this.i.g;
    }
    set endDate(v) {
        this.i.g = v;
    }
    /**
     * Gets a function that will return the items associated with this event.
    */
    get getItems() {
        return this.i.a;
    }
    set getItems(v) {
        this.i.a = v;
    }
    /**
     * Gets or sets fill brush to use for the current item.
    */
    get fill() {
        return brushToString(this.i.n);
    }
    set fill(v) {
        this.i.n = stringToBrush(v);
    }
    /**
     * Gets or sets stroke to use for the current item.
    */
    get stroke() {
        return brushToString(this.i.o);
    }
    set stroke(v) {
        this.i.o = stringToBrush(v);
    }
    /**
     * Gets or sets opacity to use for the current item.
    */
    get opacity() {
        return this.i.j;
    }
    set opacity(v) {
        this.i.j = +v;
    }
    /**
     * Gets or sets highlighting info
    */
    get highlightingInfo() {
        if (this.i.b == null) {
            return null;
        }
        if (!this.i.b.externalObject) {
            let e = new IgxHighlightingInfo();
            e._implementation = this.i.b;
            this.i.b.externalObject = e;
        }
        return this.i.b.externalObject;
    }
    set highlightingInfo(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    /**
     * Gets the max highlighting progress from all series.
    */
    get maxAllSeriesHighlightingProgress() {
        return this.i.i;
    }
    set maxAllSeriesHighlightingProgress(v) {
        this.i.i = +v;
    }
    /**
     * Gets the sum of highlighting progress from all series.
    */
    get sumAllSeriesHighlightingProgress() {
        return this.i.k;
    }
    set sumAllSeriesHighlightingProgress(v) {
        this.i.k = +v;
    }
    /**
     * Gets or sets if highlighting was handled by this event handler, and whether internal highlighting logic should be skipped.
    */
    get highlightingHandled() {
        return this.i.d;
    }
    set highlightingHandled(v) {
        this.i.d = ensureBool(v);
    }
    /**
     * Gets if this event has a valid date range
    */
    get hasDateRange() {
        return this.i.c;
    }
    set hasDateRange(v) {
        this.i.c = ensureBool(v);
    }
    /**
     * Gets if the current shape is identified as a negative shape if this series supports discrete negative shapes.
    */
    get isNegativeShape() {
        return this.i.e;
    }
    set isNegativeShape(v) {
        this.i.e = ensureBool(v);
    }
    /**
     * Gets if the current event is being raised for the thumbnail image.
    */
    get isThumbnail() {
        return this.i.f;
    }
    set isThumbnail(v) {
        this.i.f = ensureBool(v);
    }
    findByName(name) {
        if (this.highlightingInfo && this.highlightingInfo.name && this.highlightingInfo.name == name) {
            return this.highlightingInfo;
        }
        return null;
    }
}

/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `AssigningCategoryStyle` event fired to allow you to override the style of items in a category or financial series
*/
class IgxAssigningCategoryStyleEventArgs extends IgxAssigningCategoryStyleEventArgsBase {
    createImplementation() {
        return new AssigningCategoryStyleEventArgs();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets stroke thickness to use for the current item.
    *
    * Used the `strokeThickness` proprty  for the current item thickness.
    */
    get strokeThickness() {
        return this.i.r;
    }
    set strokeThickness(v) {
        this.i.r = +v;
    }
    /**
     * Gets or sets corner radius X to use for the current item, if applicable.
    *
    * Use the `radiusX` property to round the corners of the column.
    */
    get radiusX() {
        return this.i.p;
    }
    set radiusX(v) {
        this.i.p = +v;
    }
    /**
     * Gets or sets corner radius Y to use for the current item, if applicable.
    *
    * Use the `radiusY` property for the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.q;
    }
    set radiusY(v) {
        this.i.q = +v;
    }
}

/**
 * Represents event arguments class for the AssigningCategoryStyleEvent
*
* The `assigningCategoryMarkerStyle` event fired to allow you to override the style of markers for the items in a category or financial series.
*/
class IgxAssigningCategoryMarkerStyleEventArgs extends IgxAssigningCategoryStyleEventArgsBase {
    createImplementation() {
        return new AssigningCategoryMarkerStyleEventArgs();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}

/**
 * Represents the base class for series containing markers.
*
* MarkerSeries represents the base class for series containing markers.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
*         label="label"
*         #xAxis
*         >
*       </igx-category-x-axis>
*       <igx-numeric-y-axis
*         minimumValue="0"
*         #yAxis>
*       </igx-numeric-y-axis>
* 	 <igx-column-series
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*      valueMemberPath="value">
*      </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxMarkerSeriesComponent = new IgxMarkerSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "value";
* this.chart.series.add(series);
* ```
*/
const IgxMarkerSeriesComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMarkerSeriesComponent) }];
class IgxMarkerSeriesComponent extends IgxSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Returns whether the current series supports visual markers.
    *
    * `hasMarkers` property is overriden, it returns whether the current series supports visual markers. You can use it like this:
    *
    * ```ts
    *  let gotMarkers: boolean = this.series.hasMarkers;
    * ```
    */
    get hasMarkers() {
        return this.i.hasMarkers;
    }
    /**
     * Gets or sets the marker type for the current series object.
     * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
    *
    * `markerType` property gets or sets the marker type for the current series object. For example, you can set it like this:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	 <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *      valueMemberPath="value"
    * 	 markerType = "circle">
    *      </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.markerType = "circle";
    * ```
    */
    get markerType() {
        return this.i.mb;
    }
    set markerType(v) {
        this.i.mb = ensureEnum(MarkerType_$type, v);
    }
    /**
     * Gets or sets the MarkerTemplate for the current series object.
    *
    * `markerTemplate` property gets or sets the MarkerTemplate for the current series object. For example, you can use it like this:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *      valueMemberPath="value"
    * 	 markerTemplate="circleMarkerTemplate">
    *      </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get markerTemplate() {
        return this.i.mw;
    }
    set markerTemplate(v) {
        this.i.mw = v;
    }
    /**
     * Gets or sets thickness of the marker outline
    */
    get markerThickness() {
        return this.i.mg;
    }
    set markerThickness(v) {
        this.i.mg = +v;
    }
    /**
     * Gets the effective marker template for the current series object.
    *
    * `actualMarkerTemplate` property gets the effective marker template for the current series object. You can use it like this:
    *
    * ```ts
    *  let effectiveMarkerTemplate: IgxDataTemplate = this.series.actualMarkerTemplate;
    * ```
    */
    get actualMarkerTemplate() {
        return this.i.mu;
    }
    set actualMarkerTemplate(v) {
        this.i.mu = v;
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
    *
    * `markerBrush` property gets or sets the brush that specifies how the current series object's marker interiors are painted. You can use it like this:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *      valueMemberPath="value"
    * 	 markerBrush = "blue">
    *      </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.markerBrush = "red";
    * ```
    */
    get markerBrush() {
        return brushToString(this.i.na);
    }
    set markerBrush(v) {
        this.i.na = stringToBrush(v);
    }
    /**
     * Gets the effective marker brush for the current series object.
    *
    * `actualMarkerBrush` property gets the effective marker brush for the current series object. For example, you can use it like this:
    *
    * ```ts
    *  let effectiveMarkerBrush: string = this.series.actualMarkerBrush;
    *
    * ```
    */
    get actualMarkerBrush() {
        return brushToString(this.i.m8);
    }
    set actualMarkerBrush(v) {
        this.i.m8 = stringToBrush(v);
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
    *
    * `markerOutline` property gets or sets the brush that specifies how the current series object's marker outlines are painted. You can use it like this:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *      valueMemberPath="value"
    * 	 markerOutline = "blue">
    *      </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.markerOutline = "red";
    * ```
    */
    get markerOutline() {
        return brushToString(this.i.nb);
    }
    set markerOutline(v) {
        this.i.nb = stringToBrush(v);
    }
    /**
     * Gets the effective marker outline for the current series object.
    *
    *     `ActualMarkerOutline` property gets the effective marker outline for the current series object. You can use it like this:
    *
    * ```ts
    *  let effectiveMarkerOutline: string = this.series.actualMarkerOutline;
    *
    * ```
    */
    get actualMarkerOutline() {
        return brushToString(this.i.m9);
    }
    set actualMarkerOutline(v) {
        this.i.m9 = stringToBrush(v);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMarkerSeriesComponent.prototype, "markerType", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxMarkerSeriesComponent.prototype, "markerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMarkerSeriesComponent.prototype, "markerThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxMarkerSeriesComponent.prototype, "actualMarkerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxMarkerSeriesComponent.prototype, "markerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxMarkerSeriesComponent.prototype, "actualMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxMarkerSeriesComponent.prototype, "markerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxMarkerSeriesComponent.prototype, "actualMarkerOutline", null);

/**
 * Represents the base class for IgxDataChartComponent category series.
*
* `IgxCategorySeriesComponent` class represents the base class for IgxDataChartComponent category series.
*
* ```html
*     <igx-data-chart [dataSource]="data" >
*       <igx-category-x-axis
*         label="label"
*         #xAxis>
*       </igx-category-x-axis>
*       <igx-numeric-y-axis #yAxis>
*       </igx-numeric-y-axis>
*       <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value"
*         isTransitionInEnabled="true">
*       </igx-column-series>
*     </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath="value";
* this.chart.series.add(series);
* ```
*/
const IgxCategorySeriesComponent_PROVIDERS = [{ provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCategorySeriesComponent) }];
class IgxCategorySeriesComponent extends IgxMarkerSeriesComponent {
    constructor() {
        super();
        this._assigningCategoryStyle = null;
        this._assigningCategoryMarkerStyle = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether or not this series is Category series
    */
    get isCategory() {
        return this.i.cl;
    }
    /**
     * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
    */
    get isCustomCategoryStyleAllowed() {
        return this.i.oa;
    }
    set isCustomCategoryStyleAllowed(v) {
        this.i.oa = ensureBool(v);
    }
    /**
     * Gets or sets whether this category series should allow custom style overrides of its individual marker visuals.
    */
    get isCustomCategoryMarkerStyleAllowed() {
        return this.i.n9;
    }
    set isCustomCategoryMarkerStyleAllowed(v) {
        this.i.n9 = ensureBool(v);
    }
    /**
     * Sets or Gets whether to increase marker fidelity for extreme data shapes that have lots of Y variation over short X intervals.
    *
    * Set `useHighMarkerFidelity` when your data has high variation along the y-axis within a short span of this x-axis.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    *         useHighMarkerFidelity="true">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath= "value";
    * series.useHighMarkerFidelity= "true";
    * this.chart.series.add(series);
    * ```
    *
    * ```ts
    *       this.columnSeries2.useHighMarkerFidelity= "true";
    * ```
    */
    get useHighMarkerFidelity() {
        return this.i.of;
    }
    set useHighMarkerFidelity(v) {
        this.i.of = ensureBool(v);
    }
    /**
     * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
     * Note: Transitions are not currently supported for stacked series.
    *
    * `transitionInMode` controls the direction of the transition-in animation.
    *
    * ```html
    *     <igx-data-chart
    *       [dataSource]="data" >
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    *
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isTransitionInEnabled="true"
    *         transitionInMode="accordionfromRight">
    *       </igx-column-series>
    *     </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * series.transitionInMode="accordionfromRight";
    * this.chart.series.add(series);
    * ```
    *
    * ```ts
    *
    * 	this.columnSeries2.transitionInMode= "accordionfromRight";
    * ```
    */
    get transitionInMode() {
        return this.i.nu;
    }
    set transitionInMode(v) {
        this.i.nu = ensureEnum(CategoryTransitionInMode_$type, v);
    }
    /**
     * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
     * Note: Transitions are not currently supported for stacked series.
    *
    * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
    *
    * ```html
    *     <igx-data-chart [dataSource]="data" >
    *       <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *       </igx-category-x-axis>
    *       <igx-numeric-y-axis #yAxis>
    *       </igx-numeric-y-axis>
    *
    *       <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         isTransitionInEnabled="true">
    *       </igx-column-series>
    *     </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * series.isTransitionInEnabled="true";
    * this.chart.series.add(series);
    * ```
    */
    get isTransitionInEnabled() {
        return this.i.ob;
    }
    set isTransitionInEnabled(v) {
        this.i.ob = ensureBool(v);
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item based on world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * Event raised when Assigning Category Style
    */
    get assigningCategoryStyle() {
        if (this._assigningCategoryStyle == null) {
            this._assigningCategoryStyle = new EventEmitter();
            this.i.assigningCategoryStyle = delegateCombine(this.i.assigningCategoryStyle, (o, e) => {
                let outerArgs = new IgxAssigningCategoryStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeAssigningCategoryStyle) {
                    this.beforeAssigningCategoryStyle(this, outerArgs);
                }
                this._assigningCategoryStyle.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._assigningCategoryStyle;
    }
    /**
     * Event raised when Assigning Category Marker Style
    */
    get assigningCategoryMarkerStyle() {
        if (this._assigningCategoryMarkerStyle == null) {
            this._assigningCategoryMarkerStyle = new EventEmitter();
            this.i.assigningCategoryMarkerStyle = delegateCombine(this.i.assigningCategoryMarkerStyle, (o, e) => {
                let outerArgs = new IgxAssigningCategoryMarkerStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeAssigningCategoryMarkerStyle) {
                    this.beforeAssigningCategoryMarkerStyle(this, outerArgs);
                }
                this._assigningCategoryMarkerStyle.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._assigningCategoryMarkerStyle;
    }
}
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategorySeriesComponent.prototype, "isCustomCategoryStyleAllowed", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategorySeriesComponent.prototype, "isCustomCategoryMarkerStyleAllowed", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategorySeriesComponent.prototype, "useHighMarkerFidelity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategorySeriesComponent.prototype, "transitionInMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategorySeriesComponent.prototype, "isTransitionInEnabled", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategorySeriesComponent.prototype, "assigningCategoryStyle", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategorySeriesComponent.prototype, "assigningCategoryMarkerStyle", null);

/**
 * Represents the base class for all IgxDataChartComponent anchored category/value series.
*
* The `IgxAnchoredCategorySeriesComponent` represents the base class for all IgxDataChartComponent anchored category/value series.
*
* ```html
* <igx-data-chart [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value"
*         markerType="circle" >
*     </igx-column-series>
* </igx-data-chart>
* ```
*/
const IgxAnchoredCategorySeriesComponent_PROVIDERS = [{ provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAnchoredCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAnchoredCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAnchoredCategorySeriesComponent) }];
class IgxAnchoredCategorySeriesComponent extends IgxCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    *
    * The `valueMemberPath` property is used for the value mapping property of the current series object.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value" >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get valueMemberPath() {
        return this.i.pq;
    }
    set valueMemberPath(v) {
        this.i.pq = v;
    }
    /**
     * Gets or sets the trend type for the current series object.
    *
    * The `trendLineType` property is used for the current series object's trend type.'
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    *         trendLineType="simpleAverage" >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLineType= "CubicFit";
    * ```
    */
    get trendLineType() {
        return this.i.trendLineType;
    }
    set trendLineType(v) {
        this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush to use to draw the trend line.
    *
    * The `trendLineBrush` property is used to brush the trend line.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    *         trendLineBrush= "grey"	>
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLineBrush="red";
    * ```
    */
    get trendLineBrush() {
        return brushToString(this.i.trendLineBrush);
    }
    set trendLineBrush(v) {
        this.i.trendLineBrush = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this series.
    *
    * The `actualTrendLineBrush` property is used to gets the effective `trendLineBrush` for this series.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.p8);
    }
    set actualTrendLineBrush(v) {
        this.i.p8 = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current series object's trend line.
    *
    * The `trendLineThickness` property is used for thickness of the current series object's trend line.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    * 		trendLineThickness= 2  >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLineThickness= 2;
    * ```
    */
    get trendLineThickness() {
        return this.i.trendLineThickness;
    }
    set trendLineThickness(v) {
        this.i.trendLineThickness = +v;
    }
    /**
     * Gets or sets the trend line period for the current series.
     * The typical, and initial, value for trend line period is 7.
    *
    * The `trendLinePeriod` property is used for trend line period of the current series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    *         trendLinePeriod: "7">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLinePeriod= 7;
    * ```
    */
    get trendLinePeriod() {
        return this.i.trendLinePeriod;
    }
    set trendLinePeriod(v) {
        this.i.trendLinePeriod = +v;
    }
    /**
     * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
    *
    * The `markerCollisionAvoidance` property controls the technique the chart uses to avoid overlapping markers.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         markerType="circle"
    * 		markerCollisionAvoidance= "fade"
    *         >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get markerCollisionAvoidance() {
        return this.i.pd;
    }
    set markerCollisionAvoidance(v) {
        this.i.pd = ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
    }
    /**
     * Determines the item returned in hit-testing when the pointer is over an object which represents several consolidated items.
    *
    * The `consolidatedItemHitTestBehavior` property is used to determines returned item in hit-testing when the pointer is over an object which represents several consolidated items.
    */
    get consolidatedItemHitTestBehavior() {
        return this.i.pe;
    }
    set consolidatedItemHitTestBehavior(v) {
        this.i.pe = ensureEnum(ConsolidatedItemHitTestBehavior_$type, v);
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` method is used to notifies the target axis or series that it should scroll the requested data item into view.
    *
    * ```ts
    * this.series.scrollIntoView(dataItem);
    * ```
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * The `getItem` method is used to gets the item that is the best match for the specified world coordinates.
    *
    * ```ts
    * let item: number = this.series.getItem({x:.5,y:.5});
    * ```
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredCategorySeriesComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredCategorySeriesComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredCategorySeriesComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredCategorySeriesComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredCategorySeriesComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredCategorySeriesComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredCategorySeriesComponent.prototype, "markerCollisionAvoidance", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredCategorySeriesComponent.prototype, "consolidatedItemHitTestBehavior", null);

/**
 * Base class for anchored category series with a category x-axis and a numeric y-axis.
*
* Instantiate HorizontalAnchoredCategorySeries
*
* ```html
*  <igx-data-chart
*       [dataSource]="data"  >
* 	 <igx-column-series
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value"
*           >
*       </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath="value";
* this.chart.series.add(series);
* ```
*/
const IgxHorizontalAnchoredCategorySeriesComponent_PROVIDERS = [{ provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxHorizontalAnchoredCategorySeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxHorizontalAnchoredCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxHorizontalAnchoredCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxHorizontalAnchoredCategorySeriesComponent) }];
class IgxHorizontalAnchoredCategorySeriesComponent extends IgxAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the effective x-axis for this series.
    *
    * Instantiate xAxis
    *
    * <!-- Angular -->
    *
    * ```js
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	  <igx-category-x-axis
    *         label="label"
    *         #xAxis
    *         >
    *       </igx-category-x-axis>
    * 	 <igx-column-series
    *     ...
    *         [xAxis]="xAxis"
    *     ...
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for this series.
    *
    * Instantiate yAxis
    *
    * <!-- Angular -->
    *
    * ```js
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *     ...
    *         [yAxis]="yAxis"
    *     ...
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *     var x = financialSeries.GetSeriesValueMarkerBoundingBox(new IgxPoint());
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    getSeriesValueMarkerBoundingBox(world) {
        let iv = this.i.l6(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
    *
    * <!-- Angular JS -->
    *
    *       var g = series.getOffsetValue();
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    */
    canUseAsXAxis(axis) {
        let iv = this.i.qj(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    canUseAsYAxis(axis) {
        let iv = this.i.qk(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAxisBaseComponent),
    __metadata("design:paramtypes", [IgxCategoryAxisBaseComponent])
], IgxHorizontalAnchoredCategorySeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxHorizontalAnchoredCategorySeriesComponent.prototype, "yAxis", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PointSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = PointSeries.$;
    }
    bf() {
        return new PointSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qu = a;
    }
    dh(a, b) {
        let c = this.lv(this.ly(a), true, false);
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
    }
    get_cy() {
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
PointSeries.$t = markType(PointSeries, 'PointSeries', HorizontalAnchoredCategorySeries.$);
/**
 * @hidden
 */
class PointSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c6 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.by.mb = 2;
            this.e.bj = 4;
        }
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    }
}
PointSeriesView.$t = markType(PointSeriesView, 'PointSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPointSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent point series.
*
* You can use the `IgxPointSeriesComponent` plot a value along a category or date.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis
* 		#yAxis>
*     <igx-numeric-y-axis>
*     </igx-numeric-y-axis>
*     <igx-point-series
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		valueMemberPath="coal">
*     </igx-point-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxPointSeriesComponent = new IgxPointSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "coal";
* this.chart.series.add(series);
* ```
*/
const IgxPointSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent) }];
let IgxPointSeriesComponent = IgxPointSeriesComponent_1 = class IgxPointSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PointSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
};
IgxPointSeriesComponent = IgxPointSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-point-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPointSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPointSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPointSeriesModule = class IgxPointSeriesModule {
};
IgxPointSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPointSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxPointSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxPointSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPointSeriesDynamicModule = class IgxPointSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPointSeriesComponent", IgxPointSeriesComponent);
        TypeRegistrar.register("PointSeries", PointSeries.$type);
    }
};
IgxPointSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPointSeriesModule],
        exports: [IgxPointSeriesModule],
        entryComponents: [IgxPointSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPointSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryLineRasterizer extends Base {
    constructor() {
        super(...arguments);
        this.a = false;
        this.n = new PointCollection(0);
    }
    get o() {
        return this.n;
    }
    set o(a) {
        this.n = a;
    }
    m(a, b, c, d, e, f, g, h, i, j) {
        let k = new PathGeometry();
        let l = new PathGeometry();
        let m = new PathGeometry();
        a.ak = k;
        b.ak = l;
        c.ak = m;
        k.c = new PathFigureCollection();
        l.c = new PathFigureCollection();
        m.c = new PathFigureCollection();
        let n = new List$1(PolyLineSegment.$, 0);
        let o = new List$1(PolyLineSegment.$, 0);
        let p = new List$1(PolyLineSegment.$, 0);
        let q = new List$1(PolyLineSegment.$, 0);
        if (g == 0 || g == 1) {
            let r = g == 1 ? h : null;
            let s = 0;
            for (let t = 0; t < d; t++) {
                if (isNaN_(e._inner[t][1])) {
                    let u = t - s;
                    let v = (g == 0 && u > 0) || (g == 1 && u > 1);
                    if (v) {
                        if (g == 1 || n.count == 0) {
                            let w = new PolyLineSegment();
                            let x = new PolyLineSegment();
                            let y = new PolyLineSegment();
                            let z = new PolyLineSegment();
                            n.add(w);
                            o.add(x);
                            p.add(y);
                            q.add(z);
                        }
                        this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, t - 1, e, f, r, i, j);
                    }
                    s = t + 1;
                }
            }
            if (g == 1 || n.count == 0) {
                let aa = new PolyLineSegment();
                let ab = new PolyLineSegment();
                let ac = new PolyLineSegment();
                let ad = new PolyLineSegment();
                n.add(aa);
                o.add(ad);
                p.add(ab);
                q.add(ac);
            }
            this.l(n._inner[n.count - 1]._points, o._inner[o.count - 1]._points, p._inner[p.count - 1]._points, q._inner[q.count - 1]._points, s, d - 1, e, f, r, i, j);
            if (r == null && n.count == 1 && h != null) {
                this.d(n._inner[0], h);
                if (o.count == 1) {
                    this.d(o._inner[0], h);
                }
            }
        }
        else {
            n.add(new PolyLineSegment());
            o.add(new PolyLineSegment());
            p.add(new PolyLineSegment());
            q.add(new PolyLineSegment());
            this.k(n._inner[0]._points, o._inner[0]._points, p._inner[0]._points, q._inner[0]._points, d, e, f, h, i, j);
        }
        for (let ae = 0; ae < n.count; ae++) {
            let af = n._inner[ae];
            let ag = o._inner[ae];
            let ah = p._inner[ae];
            let ai = q._inner[ae];
            if (af._points.count > 0) {
                let aj = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = af._points._inner[0];
                    return $ret;
                })());
                aj._segments.add(af);
                k.c.add(aj);
            }
            if (ag._points.count > 0) {
                let ak = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = ag._points._inner[0];
                    return $ret;
                })());
                ak._segments.add(ag);
                m.c.add(ak);
            }
            if (ah._points.count > 0 && ai._points.count > 0) {
                let al = new PolyLineSegment();
                if (h != null) {
                    let am = h.f;
                    h.f = true;
                    h.i = al._points;
                    h.k(ah._points, false);
                    h.k(ai._points, true);
                    h.i = null;
                    h.f = am;
                }
                else {
                    for (let an of fromEnum(ah._points)) {
                        al._points.add(an);
                    }
                    for (let ao = ai._points.count - 1; ao >= 0; ao--) {
                        al._points.add(ai._points._inner[ao]);
                    }
                }
                if (al._points.count > 0) {
                    let ap = ((() => {
                        let $ret = new PathFigure();
                        $ret.startPoint = al._points._inner[0];
                        return $ret;
                    })());
                    ap._segments.add(al);
                    l.c.add(ap);
                }
            }
        }
    }
    d(a, b) {
        let c = a._points;
        a._points = new PointCollection(0);
        b.i = a._points;
        b.k(c, false);
        b.i = null;
    }
    k(a, b, c, d, e, f, g, h, i, j) {
        this.l(a, b, c, d, 0, e - 1, f, g, h, i, j);
    }
    e(a, b, c, d, e, f, g) {
        let h = FastFlattener.a(new List$1(Number_$type, 0), d, e, f, b, c, g);
        let i = ArrayAccessHelper.c(h);
        let j = ArrayAccessHelper.a(d);
        let k = i != null;
        let l = j != null;
        let m = 0;
        let n = h.count;
        let o;
        let p;
        let q;
        if (e) {
            for (let r = 0; r < n; r++) {
                m = k ? i[r] : h.item(r);
                o = l ? j[m] : d._inner[m];
                p = o[0];
                q = o[1];
                let s = { $type: Point_$type, x: p, y: q };
                a.add(s);
            }
        }
        else if (f) {
            for (let t = 0; t < n; t++) {
                m = k ? i[t] : h.item(t);
                o = l ? j[m] : d._inner[m];
                p = o[0];
                q = o[2];
                let u = { $type: Point_$type, x: p, y: q };
                a.add(u);
            }
        }
        else {
            for (let v = 0; v < n; v++) {
                m = k ? i[v] : h.item(v);
                o = l ? j[m] : d._inner[m];
                p = o[2];
                q = o[3];
                let w = { $type: Point_$type, x: p, y: q };
                a.add(w);
            }
        }
    }
    b(a, b, c, d) {
        c.i = a;
        c.k(b, false);
        c.i = null;
    }
    c(a, b, c, d, e) {
        let f = c.f;
        c.f = e;
        this.b(a, b, c, d);
        c.f = f;
    }
    l(a, b, c, d, e, f, g, h, i, j, k) {
        if (f > -1) {
            if (j == 1 && !this.a) {
                let l = new PointCollection(0);
                this.e(l, e, f, g, true, h, k);
                if (i != null) {
                    this.b(a, l, i, k);
                }
                else {
                    this.f(a, l);
                }
            }
            else {
                let m = new PointCollection(0);
                let n = new PointCollection(0);
                this.e(m, e, f, g, true, h, k);
                this.e(n, e, f, g, false, h, k);
                this.f(c, m);
                this.f(d, n);
                if (i != null) {
                    this.b(a, m, i, k);
                    this.b(b, n, i, k);
                }
                else {
                    this.f(a, m);
                    this.f(b, n);
                }
            }
        }
    }
    i(a, b, c, d, e, f, g, h, i, j, k) {
        this.j(a, b, c, d, e, f, g, h, i, j, k, null);
    }
    j(a, b, c, d, e, f, g, h, i, j, k, l) {
        let m = new PathGeometry();
        let n = new PathGeometry();
        let o = new PathGeometry();
        let p = new PathGeometry();
        a.ak = m;
        b.ak = n;
        c.ak = o;
        d.ak = p;
        m.c = new PathFigureCollection();
        n.c = new PathFigureCollection();
        o.c = new PathFigureCollection();
        p.c = new PathFigureCollection();
        let q = new List$1(PolyLineSegment.$, 0);
        let r = new List$1(PolyLineSegment.$, 0);
        let s = new List$1(PolyLineSegment.$, 0);
        let t = new List$1(PolyLineSegment.$, 0);
        if (k == 0 || k == 1) {
            let u = k == 1 ? l : null;
            let v = 0;
            for (let w = 0; w < e; w++) {
                if (isNaN_(f._inner[w][1])) {
                    let x = w - v;
                    let y = (k == 0 && x > 0) || (k == 1 && x > 1);
                    if (y) {
                        if (k == 1 || r.count == 0) {
                            let z = new PolyLineSegment();
                            let aa = new PolyLineSegment();
                            let ab = new PolyLineSegment();
                            let ac = new PolyLineSegment();
                            q.add(z);
                            r.add(aa);
                            s.add(ab);
                            t.add(ac);
                        }
                        let ad;
                        let ae;
                        let af;
                        let ag;
                        if (l != null && k == 1) {
                            ad = new PointCollection(0);
                            ae = new PointCollection(0);
                            af = new PointCollection(0);
                            ag = new PointCollection(0);
                        }
                        else {
                            ad = q._inner[q.count - 1]._points;
                            ae = r._inner[r.count - 1]._points;
                            af = s._inner[s.count - 1]._points;
                            ag = t._inner[t.count - 1]._points;
                        }
                        this.g(ad, ae, af, ag, v, w - 1, f, g, null, h, i);
                        if (k == 1) {
                            j(ad, ae, af, ag, false);
                            if (l != null) {
                                this.c(q._inner[q.count - 1]._points, ad, l, i, true);
                                this.c(r._inner[r.count - 1]._points, ae, l, i, false);
                                this.c(s._inner[s.count - 1]._points, af, l, i, true);
                                this.c(t._inner[t.count - 1]._points, ag, l, i, false);
                            }
                        }
                    }
                    v = w + 1;
                }
            }
            if (k == 1 || r.count == 0) {
                let ah = new PolyLineSegment();
                let ai = new PolyLineSegment();
                let aj = new PolyLineSegment();
                let ak = new PolyLineSegment();
                q.add(ah);
                r.add(ai);
                s.add(aj);
                t.add(ak);
            }
            let al;
            let am;
            let an;
            let ao;
            if (l != null) {
                al = new PointCollection(0);
                this.f(al, q._inner[q.count - 1]._points);
                am = new PointCollection(0);
                this.f(am, r._inner[r.count - 1]._points);
                an = new PointCollection(0);
                this.f(an, s._inner[s.count - 1]._points);
                ao = new PointCollection(0);
                this.f(ao, t._inner[t.count - 1]._points);
                q._inner[q.count - 1]._points.clear();
                r._inner[r.count - 1]._points.clear();
                s._inner[s.count - 1]._points.clear();
                t._inner[t.count - 1]._points.clear();
            }
            else {
                al = q._inner[q.count - 1]._points;
                am = r._inner[r.count - 1]._points;
                an = s._inner[s.count - 1]._points;
                ao = t._inner[t.count - 1]._points;
            }
            this.g(al, am, an, ao, v, e - 1, f, g, null, h, i);
            j(al, am, an, ao, true);
            if (l != null) {
                this.c(q._inner[q.count - 1]._points, al, l, i, true);
                this.c(r._inner[r.count - 1]._points, am, l, i, false);
                this.c(s._inner[s.count - 1]._points, an, l, i, true);
                this.c(t._inner[t.count - 1]._points, ao, l, i, false);
            }
        }
        else {
            q.add(new PolyLineSegment());
            r.add(new PolyLineSegment());
            s.add(new PolyLineSegment());
            t.add(new PolyLineSegment());
            this.h(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, 0, e - 1, f, g, h, i);
            j(q._inner[0]._points, r._inner[0]._points, s._inner[0]._points, t._inner[0]._points, true);
        }
        for (let ap = 0; ap < r.count; ap++) {
            let aq = q._inner[ap];
            let ar = r._inner[ap];
            let as = s._inner[ap];
            let at = t._inner[ap];
            if (aq._points.count > 0) {
                let au = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = aq._points._inner[0];
                    return $ret;
                })());
                au._segments.add(aq);
                m.c.add(au);
            }
            if (ar._points.count > 0) {
                let av = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = ar._points._inner[0];
                    return $ret;
                })());
                av._segments.add(ar);
                n.c.add(av);
            }
            if (as._points.count > 0) {
                let aw = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = as._points._inner[0];
                    return $ret;
                })());
                aw._segments.add(as);
                o.c.add(aw);
            }
            if (at._points.count > 0) {
                let ax = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = at._points._inner[0];
                    return $ret;
                })());
                ax._segments.add(at);
                p.c.add(ax);
            }
        }
    }
    h(a, b, c, d, e, f, g, h, i, j) {
        this.g(a, b, c, d, e, f, g, h, null, i, j);
    }
    g(a, b, c, d, e, f, g, h, i, j, k) {
        this.o.clear();
        if (j == 1 && !this.a) {
            let l = FastFlattener.a(new List$1(Number_$type, 0), g, true, h, e, f, k);
            let m = l.count;
            let n = 0;
            let o;
            let p;
            let q;
            let r = new PointCollection(0);
            for (let s = 0; s < m; s++) {
                n = l.item(s);
                o = g._inner[n];
                p = o[0];
                q = o[1];
                r.add({ $type: Point_$type, x: p, y: q });
            }
            if (i != null) {
                this.c(a, r, i, k, true);
                this.c(d, r, i, k, false);
                this.c(this.o, r, i, k, false);
            }
            else {
                this.f(a, r);
                this.f(d, r);
                this.f(this.o, r);
            }
        }
        else {
            let t = FastFlattener.a(new List$1(Number_$type, 0), g, true, h, e, f, k);
            let u = FastFlattener.a(new List$1(Number_$type, 0), g, false, h, e, f, k);
            let v = t.count;
            let w = u.count;
            let x = 0;
            let y;
            let z;
            let aa;
            let ab = new PointCollection(0);
            let ac = new PointCollection(0);
            for (let ad = 0; ad < v; ad++) {
                x = t.item(ad);
                y = g._inner[x];
                z = y[0];
                aa = y[1];
                ab.add({ $type: Point_$type, x: z, y: aa });
                ac.add({ $type: Point_$type, x: z, y: aa });
            }
            let ae = new PointCollection(0);
            let af;
            let ag;
            for (let ah = w - 1; ah >= 0; ah--) {
                x = u.item(ah);
                y = g._inner[x];
                if (h) {
                    af = y[0];
                    ag = y[2];
                }
                else {
                    af = y[2];
                    ag = y[3];
                }
                ae.add({ $type: Point_$type, x: af, y: ag });
                ac.add({ $type: Point_$type, x: af, y: ag });
            }
            if (i != null) {
                this.c(a, ab, i, k, true);
                this.c(b, ab, i, k, false);
                this.c(d, ae, i, k, false);
                this.c(c, ac, i, k, true);
            }
            else {
                this.f(a, ab);
                this.f(b, ab);
                this.f(d, ae);
                this.f(c, ac);
            }
        }
    }
    f(a, b) {
        let c = b.count;
        for (let d = 0; d < c; d++) {
            a.add(b._inner[d]);
        }
    }
}
CategoryLineRasterizer.$t = markType(CategoryLineRasterizer, 'CategoryLineRasterizer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AreaSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qv = null;
        this.qv = new CategoryLineRasterizer();
        this.ab = AreaSeries.$;
        this.qe = 0;
    }
    bf() {
        return new AreaSeriesView(this);
    }
    nt() {
        return 1;
    }
    i2(a) {
        super.i2(a);
        this.qu = a;
    }
    get_ck() {
        return true;
    }
    preferredCategoryMode(a) {
        return this.qe;
    }
    dh(a, b) {
        let c = this.lv(this.ly(a), true, false);
        if (this.ql(a, c, b)) {
            return true;
        }
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    o1(a, b) {
        super.o1(a, b);
        let c = b.cn.d;
        let d = typeCast(AreaSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(d);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let g = false;
        let h = this.nr.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bs, b.br, this.qb.ca, f);
            this.ox(e, -1, this.valueColumn.count, this.qb, i, b.n);
        }
        let j = d.di;
        let k = d.dj;
        let l = d.dk;
        let m = d.dl;
        this.nr.ae(j, true, false, true, true);
        this.nr.ae(k, true, false, true, true);
        this.nr.ae(l, false, true, false, false);
        this.nr.ae(m, false, true, false, false);
        if (b.cr(a)) {
            d.c9(e.count, e, true, c, this.eu, (n, o, p, q, r) => this.pv(n, a.f.count, b), this.unknownValuePlotting, e.count == 1 ? null : this.pa(e, e.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        let n = this.fetchYAxis();
        l._opacity = this.nr.i * this.d6;
        m._opacity = 0.5 * this.nr.i * this.d6;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case AreaSeries.$$p[0]:
                this.no.m = this.unknownValuePlotting == 0;
                this.jl(false);
                this.it();
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
AreaSeries.$t = markType(AreaSeries, 'AreaSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
AreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting::qx', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class AreaSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.de = new Path();
        this.dg = new Path();
        this.df = new Path();
        this.dh = new Path();
        this.da = new Path();
        this.dc = new Path();
        this.db = new Path();
        this.dd = new Path();
        this.c6 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get di() {
        return this.dg;
    }
    get dj() {
        return this.dh;
    }
    get dk() {
        return this.de;
    }
    get dl() {
        return this.df;
    }
    c7() {
        this.de.ak = null;
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    }
    c8(a, b, c, d, e, f, g) {
        this.c9(a, b, c, d, e, f, g, null);
    }
    c9(a, b, c, d, e, f, g, h) {
        this.c6.qv.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qv.j(this.de, this.dg, this.df, this.dh, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.da.ak = this.de.ak;
        this.dc.ak = this.dg.ak;
        this.db.ak = this.df.ak;
        this.dd.ak = this.dh.ak;
        let a = this.bl();
        this.da._fill = a;
        this.da._opacity = 1;
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
        }
        else {
            a.s(this.de);
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.de, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 1;
        this.e.ex = -3;
    }
}
AreaSeriesView.$t = markType(AreaSeriesView, 'AreaSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent area series.
 * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
*
* The `IgxAreaSeriesComponent` class represents a IgxDataChartComponent area series.Displays trend over time or ordered categories.
*
* Useful when there are many data points and the order is important.
*
* ```html
* <igx-data-chart #chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value"  >
*     </igx-area-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxAreaSeriesComponent = new IgxAreaSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "Value";
* this.chart.series.add(series);
* ```
*/
const IgxAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent) }];
let IgxAreaSeriesComponent = IgxAreaSeriesComponent_1 = class IgxAreaSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    *
    * The `isAreaOrLine` is used to check if the current series shows an area or line shape.
    *
    * ```ts
    * let series: IgxAreaSeriesComponent = new IgxAreaSeriesComponent();
    * let x= series.isAreaOrLine;
    * ```
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    *
    * The `unknownValuePlotting` property is used to determines how unknown values will be plotted on the chart.
    *
    * Null and Double.NaN are two examples of unknown values.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    * 		unknownValuePlotting="DontPlot"  >
    *     </igx-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
    * ```
    */
    get unknownValuePlotting() {
        return this.i.unknownValuePlotting;
    }
    set unknownValuePlotting(v) {
        this.i.unknownValuePlotting = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAreaSeriesComponent.prototype, "unknownValuePlotting", null);
IgxAreaSeriesComponent = IgxAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-area-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAreaSeriesModule = class IgxAreaSeriesModule {
};
IgxAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxAreaSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAreaSeriesDynamicModule = class IgxAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAreaSeriesComponent", IgxAreaSeriesComponent);
        TypeRegistrar.register("AreaSeries", AreaSeries.$type);
    }
};
IgxAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAreaSeriesModule],
        exports: [IgxAreaSeriesModule],
        entryComponents: [IgxAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ColumnSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.q0 = null;
        this.qv = 0;
        this.ab = ColumnSeries.$;
        this.qe = 2;
    }
    bf() {
        return new ColumnSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qu = a;
    }
    nt() {
        return 1;
    }
    get_n8() {
        return true;
    }
    preferredCategoryMode(a) {
        return this.qe;
    }
    l4(a) {
        if (this.q0 == null) {
            this.q0 = runOn(this, this.qx);
        }
        let b = this.qh != null ? this.qh : this.yAxis;
        let c = this.qb;
        return this.pg.c$d(this, a, c, b, this.nk, this.ok(this.bi), this.ol(this.bi), this.q0);
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a && c.c7 != null) {
            c.c7.count = 0;
        }
    }
    eg() {
        return this.qb.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    o1(a, b) {
        super.o1(a, b);
        let c = a.f;
        if (!b.q()) {
            return;
        }
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.qh.ca, f);
        g.b = this.eh();
        let h = new ScalerParams(0, d, e, this.qb.ca, f);
        let i = this.qh;
        let j = i.dy(i.km, g);
        let k = this.qb.jz(d, e, f);
        let l = this.qb;
        let m = b;
        if (isNaN_(k) || isInfinity(k)) {
            m.c7.count = 0;
            return;
        }
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        this.nr.p = this.qy;
        this.nr.q = this.qz;
        this.nr.j = this.qy;
        this.nr.k = this.qz;
        let n = false;
        let o = this.nr.c;
        if (o != null) {
            n = true;
        }
        let p = this.qb.cf;
        let q = p ? this.qb : null;
        let r = this.valueColumn.count;
        let s = this.ok(b);
        let t = 0;
        for (let u = 0; u < c.count; ++u) {
            let v = c._inner[u][0] - 0.5 * k;
            let w = this.qx(c._inner[u]);
            let x = j;
            w = Math.max(w, -100);
            x = Math.min(x, e.bottom + 100);
            let y = Math.abs(x - w);
            if (isInfinity(y)) {
                continue;
            }
            let z = m.c7.item(t);
            t++;
            z.width = k;
            z.height = y;
            if (n) {
                this.ox(c, u, r, l, h, b.n);
            }
            if (z.dataContext != null) {
                let aa = z.dataContext;
                if (s == 1) {
                    let ab = this.nr.a(r, u)[0];
                    if (ab >= 0 && ab < this.bz.count) {
                        if (q != null && q.i$b != null && q.i$b.count > ab) {
                            ab = q.i$b._inner[ab];
                        }
                        aa.item = this.bz.item(ab);
                    }
                }
                else {
                    aa.item = null;
                }
            }
            this.nr.ae(z, false, false, false, false);
            z.am = this.nr.j;
            z.an = this.nr.k;
            m.dc(z, v, Math.min(x, w));
        }
        m.c7.count = t;
        b.cu(a);
    }
    get qw() {
        return this.qv;
    }
    set qw(a) {
        if (this.qw != a) {
            let b = this.qw;
            this.qv = a;
            this.raisePropertyChanged("ConsolidatedColumnVerticalPosition", enumGetBox(ConsolidatedItemsPosition_$type, b), enumGetBox(ConsolidatedItemsPosition_$type, this.qw));
        }
    }
    qx(a) {
        if (a == null || a.length < 3) {
            return NaN;
        }
        switch (this.qw) {
            case 0: return a[1];
            case 1: return a[2];
            case 2: return (a[1] + a[2]) / 2;
            case 3:
                let b = (a[1] + a[2]) / 2;
                if (this.yAxis == null) {
                    return b;
                }
                let c = this.yAxis.d1(b, new ScalerParams(1, this.bs.oi, this.bs.oh, this.yAxis.ca));
                if (c < this.yAxis.km) {
                    return a[2];
                }
                else {
                    return a[1];
                }
            case 4:
                let d = (a[1] + a[2]) / 2;
                let e = this.yAxis.d1(d, new ScalerParams(1, this.bs.oi, this.bs.oh, this.yAxis.ca));
                if (this.yAxis == null) {
                    return d;
                }
                if (e < this.yAxis.km) {
                    return a[1];
                }
                else {
                    return a[2];
                }
            default: return (a[1] + a[2]) / 2;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
ColumnSeries.$t = markType(ColumnSeries, 'ColumnSeries', HorizontalAnchoredCategorySeries.$);
ColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ColumnSeries, 'raisePropertyChanged', ['RadiusX:qy:q4', [1, 2], 'RadiusY:qz:q5', [1, 2]]);
/**
 * @hidden
 */
class ColumnSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c8 = null;
        this.dd = new Rectangle();
        this.c7 = null;
        this.c6 = a;
        this.c7 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.de);
            $ret.activate = runOn(this, this.c9);
            $ret.disactivate = runOn(this, this.db);
            $ret.destroy = runOn(this, this.da);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    de() {
        let a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    }
    c9(a) {
        a._visibility = 0;
    }
    db(a) {
        a._visibility = 1;
    }
    da(a) {
        this.c8.remove(a);
    }
    dc(a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    }
    z(a) {
        return this.c8._inner[a];
    }
    y(a) {
        let b = this.c8._inner[a];
        this.dd._visibility = b._visibility;
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        let c = this.bm(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.ey + 3;
        return this.dd;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c8.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c7.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
}
ColumnSeriesView.$t = markType(ColumnSeriesView, 'ColumnSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxColumnSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent column series.
 * Compare values across categories by using vertical rectangles.Use it when the order of categories is not important or for displaying
 * item counts such as a histogram.
*
* ```html
*     <igx-data-chart [dataSource]="data" >
*       <igx-category-x-axis
*         label="label"
*         #xAxis>
*       </igx-category-x-axis>
*       <igx-numeric-y-axis #yAxis>
*       </igx-numeric-y-axis>
*       <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value" >
*       </igx-column-series>
*     </igx-data-chart>
* ```
*/
const IgxColumnSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent) }];
let IgxColumnSeriesComponent = IgxColumnSeriesComponent_1 = class IgxColumnSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ColumnSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX() {
        return this.i.qy;
    }
    set radiusX(v) {
        this.i.qy = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.qz;
    }
    set radiusY(v) {
        this.i.qz = +v;
    }
    /**
     * The positioning logic to use for columns which have been consolidated into a single visual element.
    */
    get consolidatedColumnVerticalPosition() {
        return this.i.qw;
    }
    set consolidatedColumnVerticalPosition(v) {
        this.i.qw = ensureEnum(ConsolidatedItemsPosition_$type, v);
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxColumnSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxColumnSeriesComponent.prototype, "radiusY", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxColumnSeriesComponent.prototype, "consolidatedColumnVerticalPosition", null);
IgxColumnSeriesComponent = IgxColumnSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-column-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxColumnSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxColumnSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxColumnSeriesModule = class IgxColumnSeriesModule {
};
IgxColumnSeriesModule = __decorate([
    NgModule({
        declarations: [IgxColumnSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxColumnSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxColumnSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxColumnSeriesDynamicModule = class IgxColumnSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxColumnSeriesComponent", IgxColumnSeriesComponent);
        TypeRegistrar.register("ColumnSeries", ColumnSeries.$type);
    }
};
IgxColumnSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxColumnSeriesModule],
        exports: [IgxColumnSeriesModule],
        entryComponents: [IgxColumnSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxColumnSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LineSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qu = null;
        this.qu = new CategoryLineRasterizer();
        this.ab = LineSeries.$;
        this.qe = 0;
    }
    bf() {
        return new LineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qv = a;
    }
    get_ck() {
        return true;
    }
    preferredCategoryMode(a) {
        return this.qe;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    o1(a, b) {
        super.o1(a, b);
        let c = b.cn.d;
        let d = typeCast(LineSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(b);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let g = false;
        let h = this.nr.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bs, b.br, this.qb.ca, f);
            this.ox(e, -1, this.valueColumn.count, this.qb, i, b.n);
        }
        let j = d.dd;
        let k = d.de;
        let l = d.dc;
        this.nr.ae(j, true, false, true, false);
        this.nr.ae(k, true, false, true, false);
        this.nr.ae(l, false, true, false, false);
        l._opacity = 0.75 * this.nr.i;
        if (b.cr(a)) {
            d.c8(e.count, e, true, this.unknownValuePlotting, this.o9(e, e.count - 1, b.br, b.bs), c, this.eu);
            b.cu(a);
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.no.m = this.unknownValuePlotting == 0;
                this.jl(false);
                this.it();
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
LineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::qx', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class LineSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.dg = new Path();
        this.df = new Path();
        this.dh = new Path();
        this.db = new Path();
        this.da = new Path();
        this.c9 = new Path();
        this.c6 = a;
    }
    get dd() {
        return this.dg;
    }
    get de() {
        return this.dh;
    }
    get dc() {
        return this.df;
    }
    c7() {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    }
    c8(a, b, c, d, e, f, g) {
        this.c6.qu.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qu.m(this.dg, this.df, this.dh, a, b, c, d, e, f, g);
        this.an();
    }
    a8() {
        super.a8();
    }
    a9() {
        super.a9();
        this.da.ak = this.dg.ak;
        this.db.ak = this.dh.ak;
        this.c9.ak = this.df.ak;
        let a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.s(this.c9);
                a.s(this.da);
                a.s(this.db);
            }
            else {
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxLineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent line series.
 * Displays trend over time or ordered categories.Useful when there are many data points and the order is important.
*
* `IgxLineSeriesComponent` belongs to a group of `IgxCategorySeriesComponent` and it is rendered using a collection of points connected by straight line segments.
*
* ```html
*  <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-line-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-line-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxLineSeriesComponent = new IgxLineSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "value";
* this.chart.series.add(series);
* ```
*/
const IgxLineSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent) }];
let IgxLineSeriesComponent = IgxLineSeriesComponent_1 = class IgxLineSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new LineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    *
    * Gets whether the `IgxSeriesComponent` shows an area or a line shape.
    *
    * ```ts
    * let isAreaOrLine: boolean = series.isAreaOrLine;
    * ```
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    *
    * Determines how unknown values will be plotted for the `IgxSeriesComponent`. This can be set to `LinearInterpolate` to create a continous shape or `DontPlot` to create breaks in the series.
    *
    * Null and Double.NaN are two examples of unknown values.
    *
    * ```html
    * <igx-data-chart #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         unknownValuePlotting="LinearInterpolate">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.unknownValuePlotting = UnknownValuePlotting.LinearInterpolate;
    * ```
    */
    get unknownValuePlotting() {
        return this.i.unknownValuePlotting;
    }
    set unknownValuePlotting(v) {
        this.i.unknownValuePlotting = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxLineSeriesComponent.prototype, "unknownValuePlotting", null);
IgxLineSeriesComponent = IgxLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-line-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLineSeriesModule = class IgxLineSeriesModule {
};
IgxLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxLineSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLineSeriesDynamicModule = class IgxLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxLineSeriesComponent", IgxLineSeriesComponent);
        TypeRegistrar.register("LineSeries", LineSeries.$type);
    }
};
IgxLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxLineSeriesModule],
        exports: [IgxLineSeriesModule],
        entryComponents: [IgxLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of Spline calculations.
 */
var SplineType;
(function (SplineType) {
    /**
     * Calculates the spline using a natural spline calculation formula.
     */
    SplineType[SplineType["Natural"] = 0] = "Natural";
    /**
     * Calculated the spline using a clamped spline calculation formula.
     */
    SplineType[SplineType["Clamped"] = 1] = "Clamped";
})(SplineType || (SplineType = {}));
/**
 * @hidden
 */
let SplineType_$type = markEnum('SplineType', 'Natural,0|Clamped,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SafeEnumerable extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.a = a;
    }
    c(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    }
    *_b() {
        if (this.a == null) {
            return undefined;
        }
        for (let a of fromEnum(this.a)) {
            yield this.c(a);
        }
    }
    b() {
        return toEnum(() => this._b());
    }
    getEnumerator() {
        return getEnumerator(this.b());
    }
    getEnumeratorObject() {
        return this.getEnumerator();
    }
}
SafeEnumerable.$t = markType(SafeEnumerable, 'SafeEnumerable', Base.$, [IEnumerable$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SafeReadOnlyDoubleCollection extends Base {
    constructor(a, ..._rest) {
        super();
        this.a = null;
        this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    this.a = new ReadOnlyCollection$1(Number_$type, 1, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    this.a = new ReadOnlyCollection$1(Number_$type, 1, c);
                    this.b = d;
                }
                break;
        }
    }
    c(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return this.b;
        }
        return a;
    }
    indexOf(a) {
        return this.a.indexOf(a);
    }
    insert(a, b) {
        this.a.insert(a, b);
    }
    removeAt(a) {
        this.a.removeAt(a);
    }
    item(a, b) {
        if (arguments.length === 2) {
            this.a.item(a, b);
            return b;
        }
        else {
            return this.c(this.a.item(a));
        }
    }
    add(a) {
        this.a.add(a);
    }
    clear() {
        this.a.clear();
    }
    contains(a) {
        return this.a.contains(a);
    }
    copyTo(a, b) {
        for (let c = b; c < a.length; c++) {
            a[c] = this.item(c);
        }
    }
    get count() {
        return this.a.count;
    }
    get isReadOnly() {
        return this.a.isReadOnly;
    }
    remove(a) {
        return this.a.remove(a);
    }
    getEnumerator() {
        return new SafeEnumerable(this.a).getEnumerator();
    }
    getEnumeratorObject() {
        return this.getEnumerator();
    }
}
SafeReadOnlyDoubleCollection.$t = markType(SafeReadOnlyDoubleCollection, 'SafeReadOnlyDoubleCollection', Base.$, [IList$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SafeSortedReadOnlyDoubleCollection extends Base {
    constructor(a, ..._rest) {
        super();
        this.a = null;
        this.b = null;
        this.c = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    this.a = new SafeReadOnlyDoubleCollection(0, c);
                    this.b = d;
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    this.a = new SafeReadOnlyDoubleCollection(1, c, e);
                    this.b = d;
                    this.c = e;
                }
                break;
        }
    }
    d(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return this.c;
        }
        return a;
    }
    indexOf(a) {
        let b = this.a.indexOf(a);
        return this.b.indexOf(b);
    }
    insert(a, b) {
        this.a.insert(a, b);
    }
    removeAt(a) {
        this.a.removeAt(a);
    }
    item(a, b) {
        if (arguments.length === 2) {
            this.a.item(a, b);
            return b;
        }
        else {
            let b = this.b.item(a);
            return this.d(this.a.item(b));
        }
    }
    add(a) {
        this.a.add(a);
    }
    clear() {
        this.a.clear();
    }
    contains(a) {
        return this.a.contains(a);
    }
    copyTo(a, b) {
        for (let c = b; c < a.length; c++) {
            a[c] = this.item(c);
        }
    }
    get count() {
        return this.a.count;
    }
    get isReadOnly() {
        return this.a.isReadOnly;
    }
    remove(a) {
        return this.a.remove(a);
    }
    *_getEnumerator() {
        for (let a = 0; a < this.a.count; a++) {
            yield this.item(a);
        }
    }
    getEnumerator() {
        return toEnum(() => this._getEnumerator()).getEnumerator();
    }
    getEnumeratorObject() {
        return this.getEnumerator();
    }
}
SafeSortedReadOnlyDoubleCollection.$t = markType(SafeSortedReadOnlyDoubleCollection, 'SafeSortedReadOnlyDoubleCollection', Base.$, [IList$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SplineSeriesBase extends HorizontalAnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.qu = null;
    }
    bf() {
        return new SplineSeriesBaseView(this);
    }
    i2(a) {
        super.i2(a);
        this.qv = a;
    }
    get_ck() {
        return true;
    }
    q1(a, b, c, d, e, f) {
        let g = typeCast(ISortingAxis_$type, d);
        let h = this.getEffectiveViewport1(f);
        if (g == null) {
            return;
        }
        let i = new ScalerParams(0, b, c, d.ca, h);
        let j = new ScalerParams(0, b, c, e.ca, h);
        j.b = this.eh();
        let k = this.md();
        let l = 0;
        let m = this.qz(d, b, c, h);
        let n = (o) => o;
        let o = (p) => this.valueColumn.item(g.i$b._inner[p]);
        let p = this.ns.cn.f;
        let q = this.ns.cn.e;
        let r = truncate(Math.ceil(c.width / (p - q)));
        let s = new CollisionAvoider();
        let t = this.ns.cn.d;
        if (t <= 0 || (q <= 0 && p <= 0)) {
            this.ns.cq.count = l;
            return;
        }
        let u = 0;
        let v = 0;
        for (let w = q; w < p + 1; ++w) {
            let x = null;
            let y = w * t;
            if (g != null && g.i$b != null && y >= 0 && y < g.i$b.count) {
                y = g.i$b._inner[y];
            }
            if (w >= (this.valueColumn.count - 1)) {
                if (k && this.qx(a, a.f._inner[a.f.count - 1], s, Math.min(y, this.bz.count - 1), l, f, u - 1)) {
                    ++l;
                }
                break;
            }
            let z = n(w);
            let aa = o(w);
            let ab = n(w + 1);
            let ac = o(w + 1);
            let ad = ab - z;
            let ae = this.qu[w];
            let af = this.qu[w + 1];
            let ag = g.i$d(g.i$b._inner[w]);
            let ah = d.dy(ag, i) + m;
            let ai = e.dy(aa, j);
            a.f.add([ah, ai, ai]);
            u++;
            v = u;
            for (let aj = 1; aj < r; ++aj) {
                let ak = aj / r;
                let al = z + ad * ak;
                let am = (ab - al) / ad;
                let an = (al - z) / ad;
                let ao = am * aa + an * ac + ((am * am * am - am) * ae + (an * an * an - an) * af) * (ad * ad) / 6;
                let ap = g.i$d(g.i$b._inner[w]);
                let aq = g.i$d(g.i$b._inner[w + 1]);
                let ar = ap + (aq - ap) * ak;
                al = d.dy(ar, i) + m;
                ao = e.dy(ao, j);
                a.f.add([al, ao, ao]);
                u++;
            }
            if (k) {
                x = [ah, ai, ai];
            }
            if (k && this.qx(a, x, s, Math.min(y, this.bz.count - 1), l, f, v - 1)) {
                ++l;
            }
        }
        f.cq.count = l;
    }
    qx(a, b, c, d, e, f, g) {
        let h = b[0];
        let i = b[1];
        let j = new Rect(0, h - 5, i - 5, 11, 11);
        if (!isNaN_(h) && !isNaN_(i) && c.tryAdd(j)) {
            a.m.add({ $type: Point_$type, x: h, y: i });
            let k = f.cq.item(e);
            k.content.item = this.bz.item(d);
            k.al = g;
            return true;
        }
        return false;
    }
    aj(a, b, c, d, e, f) {
        if (a == null || a.cf || this.ok(this.bi) > 1 || this.ok(this.bi) == 0) {
            return super.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), e, f);
        }
        if (this.nk.f.count == 0) {
            return null;
        }
        let g = this.qv.cn.f;
        let h = this.bi.br;
        let i = truncate(Math.ceil(h.width / (g - d)));
        let j = -1;
        let k = -1;
        let l = this.eb(e);
        let m = this.fe(e, f);
        let n = this.fc(e, f);
        let o = truncate(Math.floor(m / this.ok(this.bi)));
        let p = truncate(Math.floor(n / this.ok(this.bi)));
        j = o - this.ol(this.bi);
        k = p - this.ol(this.bi);
        let q = j * i;
        let r = k * i;
        let s = 0;
        if (m != n) {
            s = (l - m) / (n - m);
        }
        let t = truncate(Math.floor(q + s * (r - q)));
        j = t;
        k = t + 1;
        if (j < 0) {
            j = 0;
        }
        if (j > this.nk.f.count - 1) {
            j = this.nk.f.count - 1;
        }
        if (k < 0) {
            k = 0;
        }
        if (k > this.nk.f.count - 1) {
            k = this.nk.f.count - 1;
        }
        let u = this.nk.f._inner[j];
        let v = this.nk.f._inner[k];
        let w = new Array(2);
        w[0] = u;
        w[1] = v;
        return w;
    }
    oy(a, b) {
        super.oy(a, b);
        if (a.f.count <= 1) {
            return;
        }
        if (b.cn.d == 0) {
            return;
        }
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.qb;
        let g = this.qh;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, g.ca, e);
            $ret.b = this.eh();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        let j = this.md();
        let k = 0;
        let l = typeCast(ISortingAxis_$type, this.qb);
        if (l != null && l.i$b.count != this.bz.count) {
            return;
        }
        let m = this.qz(f, c, d, e);
        let n = (o) => o;
        let o = (p) => this.valueColumn.item(p);
        let p = b.cn.d;
        if ((this.qu == null || this.qu.length != this.valueColumn.count) && p == 1) {
            let q = this.qw == 0 ? NaN : 0;
            if (this.qb != null && typeCast(ISortingAxis_$type, this.qb) !== null && this.qb.i$b != null) {
                let r = new SafeSortedReadOnlyDoubleCollection(1, this.valueColumn, this.qb.i$b, NaN);
                o = (s) => r.item(s);
            }
            this.qu = Numeric.c(this.valueColumn.count, n, o, q, q);
        }
        let s = b.cn.f;
        let t = b.cn.e;
        let u = truncate(Math.ceil(d.width / (s - t)));
        let v = new CollisionAvoider();
        if (l != null) {
            this.q1(a, c, d, f, g, b);
            return;
        }
        let w = b;
        w.c2();
        let x = 0;
        let y = 0;
        for (let z = t; z <= s; ++z) {
            let aa = null;
            if (p == 1) {
                if (z >= (this.valueColumn.count - 1)) {
                    if (j && this.qx(a, a.f._inner[a.f.count - 1], v, Math.min(z * p, this.bz.count - 1), k, b, x - 1)) {
                        ++k;
                    }
                    break;
                }
                let ab = n(z);
                let ac = o(z);
                let ad = n(z + 1);
                let ae = o(z + 1);
                let af = ad - ab;
                let ag = this.qu[z];
                let ah = this.qu[z + 1];
                let ai = f.dy(ab, h) + m;
                let aj = g.dy(ac, i);
                a.f.add([ai, aj, aj]);
                x++;
                y = x;
                for (let ak = 1; ak < u; ++ak) {
                    let al = ab + af * ak / u;
                    let am = (ad - al) / af;
                    let an = (al - ab) / af;
                    let ao = am * ac + an * ae + ((am * am * am - am) * ag + (an * an * an - an) * ah) * (af * af) / 6;
                    al = f.dy(al, h) + m;
                    ao = g.dy(ao, i);
                    a.f.add([al, ao, ao]);
                    x++;
                }
                if (j) {
                    aa = b.cn.getBucket(z);
                    aa[0] = (f.dy(aa[0], h) + m);
                    aa[1] = g.dy(aa[1], i);
                    aa[2] = g.dy(aa[2], i);
                }
            }
            else {
                aa = b.cn.getBucket(z);
                if (!isNaN_(aa[0])) {
                    aa[0] = (f.dy(aa[0], h) + m);
                    aa[1] = g.dy(aa[1], i);
                    aa[2] = g.dy(aa[2], i);
                    a.f.add(aa);
                    x++;
                }
            }
            if (j && this.qx(a, aa, v, Math.min(z * p, this.bz.count - 1), k, b, y - 1)) {
                ++k;
            }
        }
        w.c4();
        b.cq.count = k;
    }
    qy(a, b, c, d, e, f, g) {
        let h = d - b;
        let i = b + h * a;
        let j = (d - i) / h;
        let k = (i - b) / h;
        let l = j * c + k * e + ((j * j * j - j) * f + (k * k * k - k) * g) * (h * h) / 6;
        return l;
    }
    ef(a, b, c, d, e, f, g, h) {
        let i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        let j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        let k = e;
        let l = f;
        let m = i;
        let n = j;
        let o = NaN;
        let p = NaN;
        if (this.qu != null && e >= 0 && e < this.qu.length) {
            o = this.qu[e];
        }
        if (this.qu != null && f >= 0 && f < this.qu.length) {
            p = this.qu[f];
        }
        return this.qy(a, k, m, l, n, o, p);
    }
    qz(a, b, c, d) {
        let e = this.preferredCategoryMode(a);
        if (e == 0 && a.categoryMode != 0) {
            e = 1;
        }
        let f = 0;
        switch (e) {
            case 0:
                f = 0;
                break;
            case 1:
                f = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                f = a.getGroupCenter(this.fh, b, c, d);
                break;
        }
        if (a.ca) {
            f = -f;
        }
        return f;
    }
    q2() {
        this.qu = null;
    }
    i7(a, b, c, d) {
        switch (b) {
            case "ValueColumn":
            case "FastItemsSource":
                this.q2();
                break;
        }
        super.i7(a, b, c, d);
        switch (b) {
            case SplineSeriesBase.$$p[0]:
                this.q2();
                this.jl(false);
                this.it();
                break;
        }
    }
    h6(a, b, c, d) {
        this.q2();
        super.h6(a, b, c, d);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineSeriesBase.$t = markType(SplineSeriesBase, 'SplineSeriesBase', HorizontalAnchoredCategorySeries.$);
SplineSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, SplineSeriesBase, 'raisePropertyChanged', ['SplineType:qw:q3', [SplineType_$type, enumGetBox(SplineType_$type, 0)]]);
/**
 * @hidden
 */
class SplineSeriesBaseView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c6 = a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
SplineSeriesBaseView.$t = markType(SplineSeriesBaseView, 'SplineSeriesBaseView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SplineAreaSeries extends SplineSeriesBase {
    constructor() {
        super();
        this.q4 = null;
        this.q4 = new CategoryLineRasterizer();
        this.ab = SplineAreaSeries.$;
    }
    bf() {
        return new SplineAreaSeriesView(this);
    }
    nt() {
        return 1;
    }
    i2(a) {
        super.i2(a);
        this.q5 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c8();
    }
    dh(a, b) {
        let c = this.lv(this.ly(a), true, false);
        if (this.ql(a, c, b)) {
            return true;
        }
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    o1(a, b) {
        super.o1(a, b);
        let c = this.ns.cn.d;
        let d = typeCast(SplineAreaSeriesView.$, b);
        let e = a.f;
        let f = this.getEffectiveViewport1(b);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let g = false;
        let h = this.nr.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            let i = new ScalerParams(0, b.bs, b.br, this.qb.ca, f);
            this.ox(e, -1, this.valueColumn.count, this.qb, i, b.n);
        }
        let j = d.dj;
        let k = d.dk;
        let l = d.dl;
        let m = d.dm;
        this.nr.ae(j, true, false, true, true);
        this.nr.ae(k, true, false, true, true);
        this.nr.ae(l, false, true, false, false);
        this.nr.ae(m, false, true, false, false);
        l._opacity = this.nr.i * this.d6;
        m._opacity = 0.5 * this.nr.i * this.d6;
        if (b.cr(a)) {
            d.da(a.f.count, e, true, c, this.eu, (n, o, p, q, r) => this.pv(n, a.f.count, b), 1, a.f.count == 1 ? null : this.pa(e, e.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        let n = this.fetchYAxis();
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineAreaSeries.$t = markType(SplineAreaSeries, 'SplineAreaSeries', SplineSeriesBase.$);
/**
 * @hidden
 */
class SplineAreaSeriesView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c7 = null;
        this.df = new Path();
        this.dh = new Path();
        this.dg = new Path();
        this.di = new Path();
        this.db = new Path();
        this.dd = new Path();
        this.dc = new Path();
        this.de = new Path();
        this.c7 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get dj() {
        return this.dh;
    }
    get dk() {
        return this.di;
    }
    get dl() {
        return this.df;
    }
    get dm() {
        return this.dg;
    }
    c8() {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.di.ak = null;
        this.an();
    }
    c9(a, b, c, d, e, f, g) {
        this.da(a, b, c, d, e, f, g, null);
    }
    da(a, b, c, d, e, f, g, h) {
        this.c7.q4.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c7.q4.j(this.df, this.dh, this.dg, this.di, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.db.ak = this.df.ak;
        this.dd.ak = this.dh.ak;
        this.dc.ak = this.dg.ak;
        this.de.ak = this.di.ak;
        let a = this.bl();
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._fill = a;
        this.dc._opacity = 1;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
        this.de._stroke = a;
        this.de.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
            a.s(this.de);
        }
        else {
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
            a.s(this.di);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dh, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.di, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.df, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 1;
        this.e.ex = -3;
    }
}
SplineAreaSeriesView.$t = markType(SplineAreaSeriesView, 'SplineAreaSeriesView', SplineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the base class for all IgxDataChartComponent spline series.
*/
const IgxSplineSeriesBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesBaseComponent) }];
class IgxSplineSeriesBaseComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
    /**
     * Gets or sets the type of spline to be rendered.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-spline-area-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         splineType="clamped"
    *         valueMemberPath="value">
    *     </igx-spline-area-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.splineType = SplineType.Clamped;
    * ```
    */
    get splineType() {
        return this.i.qw;
    }
    set splineType(v) {
        this.i.qw = ensureEnum(SplineType_$type, v);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSplineSeriesBaseComponent.prototype, "splineType", null);

var IgxSplineAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent spline area series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-spline-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-spline-area-series>
* </igx-data-chart>
* ```
*/
const IgxSplineAreaSeriesComponent_PROVIDERS = [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent) }];
let IgxSplineAreaSeriesComponent = IgxSplineAreaSeriesComponent_1 = class IgxSplineAreaSeriesComponent extends IgxSplineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxSplineAreaSeriesComponent = IgxSplineAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-spline-area-series',
        template: ``,
        providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSplineAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineAreaSeriesModule = class IgxSplineAreaSeriesModule {
};
IgxSplineAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxSplineAreaSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxSplineAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxSplineAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineAreaSeriesDynamicModule = class IgxSplineAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSplineAreaSeriesComponent", IgxSplineAreaSeriesComponent);
        TypeRegistrar.register("SplineAreaSeries", SplineAreaSeries.$type);
    }
};
IgxSplineAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSplineAreaSeriesModule],
        exports: [IgxSplineAreaSeriesModule],
        entryComponents: [IgxSplineAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSplineAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SplineSeries extends SplineSeriesBase {
    constructor() {
        super();
        this.q4 = null;
        this.q4 = new CategoryLineRasterizer();
        this.ab = SplineSeries.$;
    }
    bf() {
        return new SplineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.q5 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c8();
    }
    o1(a, b) {
        super.o1(a, b);
        let c = b;
        let d = c.cn.d;
        let e = typeCast(SplineSeriesView.$, b);
        let f = a.f;
        let g = this.getEffectiveViewport1(b);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let h = false;
        let i = this.nr.c;
        if (i != null) {
            h = true;
        }
        if (h) {
            let j = new ScalerParams(0, b.bs, b.br, this.qb.ca, g);
            this.ox(f, -1, this.valueColumn.count, this.qb, j, b.n);
        }
        let k = e.de;
        let l = e.df;
        let m = e.dd;
        this.nr.ae(k, true, false, true, false);
        this.nr.ae(l, true, false, true, false);
        this.nr.ae(m, false, true, false, false);
        m._opacity = 0.75 * this.nr.i;
        if (b.cr(a)) {
            e.c9(f.count, f, true, 1, this.o9(f, f.count - 1, b.br, b.bs), d, this.eu);
            b.cu(a);
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineSeries.$t = markType(SplineSeries, 'SplineSeries', SplineSeriesBase.$);
/**
 * @hidden
 */
class SplineSeriesView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c7 = null;
        this.dh = new Path();
        this.dg = new Path();
        this.di = new Path();
        this.dc = new Path();
        this.db = new Path();
        this.da = new Path();
        this.c7 = a;
    }
    get de() {
        return this.dh;
    }
    get df() {
        return this.di;
    }
    get dd() {
        return this.dg;
    }
    c8() {
        this.dg.ak = null;
        this.dh.ak = null;
        this.di.ak = null;
        this.an();
    }
    c9(a, b, c, d, e, f, g) {
        this.c7.q4.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c7.q4.m(this.dh, this.dg, this.di, a, b, c, d, e, f, g);
        this.an();
    }
    a9() {
        super.a9();
        this.db.ak = this.dh.ak;
        this.dc.ak = this.di.ak;
        this.da.ak = this.dg.ak;
        let a = this.bl();
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.da._fill = a;
        this.da._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.s(this.da);
                a.s(this.db);
                a.s(this.dc);
            }
            else {
                a.s(this.dg);
                a.s(this.dh);
                a.s(this.di);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dh, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.di, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.dg, "translucentShape", ["Translucent"]);
    }
}
SplineSeriesView.$t = markType(SplineSeriesView, 'SplineSeriesView', SplineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxSplineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent spline series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-spline-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-spline-series>
* </igx-data-chart>
* ```
*/
const IgxSplineSeriesComponent_PROVIDERS = [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent) }];
let IgxSplineSeriesComponent = IgxSplineSeriesComponent_1 = class IgxSplineSeriesComponent extends IgxSplineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxSplineSeriesComponent = IgxSplineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-spline-series',
        template: ``,
        providers: [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSplineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineSeriesModule = class IgxSplineSeriesModule {
};
IgxSplineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxSplineSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxSplineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxSplineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineSeriesDynamicModule = class IgxSplineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSplineSeriesComponent", IgxSplineSeriesComponent);
        TypeRegistrar.register("SplineSeries", SplineSeries.$type);
    }
};
IgxSplineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSplineSeriesModule],
        exports: [IgxSplineSeriesModule],
        entryComponents: [IgxSplineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSplineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StepAreaSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qu = null;
        this.qu = new CategoryLineRasterizer();
        this.ab = StepAreaSeries.$;
    }
    bf() {
        return new StepAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qv = a;
    }
    get_ck() {
        return true;
    }
    preferredCategoryMode(a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    qw(a, b, c, d, e) {
        if (b) {
            if (e) {
                if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 1 ? -d : d);
        }
        if (e) {
            if ((a & 1) == 0 || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        return c.f._inner[(intDivide(a, 2))][0] + ((a & 1) == 0 ? -d : d);
    }
    nt() {
        return 1;
    }
    ef(a, b, c, d, e, f, g, h) {
        let i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        let j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    }
    bd() {
        if (this.be == 0) {
            return 2;
        }
        else {
            return super.bd();
        }
    }
    o1(a, b) {
        super.o1(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = typeCast(ISortingAxis_$type, this.qb) != null;
        let g = this.qb != null ? 0.5 * this.qb.getCategorySize(c, d, e) : 0;
        if (this.qb != null && this.qb.ca) {
            g = -g;
        }
        let h = a.f.count * 2;
        let i = new List$1(Array_$type, 2, h);
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let j = false;
        let k = this.nr.c;
        if (k != null) {
            j = true;
        }
        for (let l = 0; l < h; l++) {
            let m = new Array(4);
            m[0] = this.qw(l, false, a, g, f);
            m[1] = a.f._inner[(intDivide(l, 2))][1];
            m[2] = this.qw(l, true, a, g, f);
            m[3] = a.f._inner[(intDivide(l, 2))][2];
            i.add(m);
        }
        let n = this.ns.cn.d;
        if (j) {
            let o = new ScalerParams(0, b.bs, b.br, this.qb.ca, e);
            this.ox(i, -1, this.valueColumn.count, this.qb, o, b.n);
        }
        let p = typeCast(StepAreaSeriesView.$, b);
        let q = p.dk;
        let r = p.dl;
        let s = p.di;
        let t = p.dj;
        this.nr.ae(q, true, false, true, true);
        this.nr.ae(r, true, false, true, true);
        this.nr.ae(s, false, true, false, false);
        this.nr.ae(t, false, true, false, false);
        if (b.cr(a)) {
            p.c9(h, i, false, n, this.eu, (u, v, w, x, y) => this.pv(u, 2 * a.f.count, b), 1, this.pa(i, i.count - 1, b.br, b.bs, true));
            b.cu(a);
        }
        let u = this.fetchYAxis();
        p.di._opacity = this.d6;
        p.dj._opacity = 0.5 * this.d6;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StepAreaSeries.$t = markType(StepAreaSeries, 'StepAreaSeries', HorizontalAnchoredCategorySeries.$);
/**
 * @hidden
 */
class StepAreaSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.de = new Path();
        this.dg = new Path();
        this.df = new Path();
        this.dh = new Path();
        this.da = new Path();
        this.dc = new Path();
        this.db = new Path();
        this.dd = new Path();
        this.c6 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get di() {
        return this.de;
    }
    get dk() {
        return this.dg;
    }
    get dj() {
        return this.df;
    }
    get dl() {
        return this.dh;
    }
    c7() {
        this.de.ak = null;
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    }
    c8(a, b, c, d, e, f, g) {
        this.c8(a, b, c, d, e, f, g);
    }
    c9(a, b, c, d, e, f, g, h) {
        this.c6.qu.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qu.j(this.de, this.dg, this.df, this.dh, a, b, c, d, e, f, g, h);
        this.an();
    }
    a9() {
        super.a9();
        this.da.ak = this.de.ak;
        this.dc.ak = this.dg.ak;
        this.db.ak = this.df.ak;
        this.dd.ak = this.dh.ak;
        let a = this.bl();
        this.da._fill = a;
        this.da._opacity = 1;
        this.db._fill = a;
        this.db._opacity = 1;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
        this.dd._stroke = a;
        this.dd.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
            a.s(this.dd);
        }
        else {
            a.s(this.de);
            a.s(this.df);
            a.s(this.dg);
            a.s(this.dh);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.de, "fillShape", ["Fill"]);
    }
}
StepAreaSeriesView.$t = markType(StepAreaSeriesView, 'StepAreaSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStepAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent step area series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-step-area-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-step-area-series>
* </igx-data-chart>
* ```
*
* ```ts
*    let series = new IgxStepAreaSeriesComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.valueMemberPath="value";
*    this.chart.series.add(series);
* ```
*/
const IgxStepAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent) }];
let IgxStepAreaSeriesComponent = IgxStepAreaSeriesComponent_1 = class IgxStepAreaSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StepAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxStepAreaSeriesComponent = IgxStepAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-step-area-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStepAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStepAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStepAreaSeriesModule = class IgxStepAreaSeriesModule {
};
IgxStepAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStepAreaSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxStepAreaSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxStepAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStepAreaSeriesDynamicModule = class IgxStepAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStepAreaSeriesComponent", IgxStepAreaSeriesComponent);
        TypeRegistrar.register("StepAreaSeries", StepAreaSeries.$type);
    }
};
IgxStepAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStepAreaSeriesModule],
        exports: [IgxStepAreaSeriesModule],
        entryComponents: [IgxStepAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStepAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StepLineSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qu = null;
        this.qu = new CategoryLineRasterizer();
        this.ab = StepLineSeries.$;
    }
    bf() {
        return new StepLineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qv = a;
    }
    ac() {
        super.ac();
    }
    preferredCategoryMode(a) {
        return typeCast(ISortingAxis_$type, a) !== null ? 0 : 1;
    }
    get_ck() {
        return true;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    bd() {
        if (this.be == 0) {
            return 2;
        }
        else {
            return super.bd();
        }
    }
    ef(a, b, c, d, e, f, g, h) {
        let i = NaN;
        if (c >= 0 && c < b.count) {
            i = b.item(c);
        }
        let j = NaN;
        if (d >= 0 && d < b.count) {
            j = b.item(d);
        }
        if (f == 0) {
            return j;
        }
        if (e == b.count - 1) {
            return i;
        }
        if (isNaN_(j) && g != 0 && a <= 0.5 && !h) {
            return i;
        }
        if (isNaN_(i) && g != 0 && a >= 0.5 && !h) {
            return j;
        }
        if (a > 0.5) {
            return j;
        }
        return i;
    }
    qw(a, b, c, d, e, f) {
        let g;
        if (b) {
            if (f) {
                g = (a & 1) == 0;
                if (g || (intDivide(a, 2)) + 1 < 0) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                if (c.f.count == (intDivide(a, 2)) + 1) {
                    return c.f._inner[(intDivide(a, 2))][0];
                }
                return c.f._inner[(intDivide(a, 2)) + 1][0];
            }
            g = (a & 1) == 0;
            return c.f._inner[(intDivide(a, 2))][0] + (g ? d : -d);
        }
        if (f) {
            g = (a & 1) == 0;
            if (g || ((intDivide(a, 2)) + 1) >= c.f.count) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            if (c.f.count == (intDivide(a, 2)) + 1) {
                return c.f._inner[(intDivide(a, 2))][0];
            }
            return c.f._inner[(intDivide(a, 2)) + 1][0];
        }
        g = (a & 1) == 0;
        return c.f._inner[(intDivide(a, 2))][0] + (g ? -d : d);
    }
    o1(a, b) {
        super.o1(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = typeCast(ISortingAxis_$type, this.qb) != null;
        let g = this.qb.ca;
        let h = 0;
        if (this.qb != null) {
            h = 0.5 * this.qb.getCategorySize(c, d, e);
        }
        let i = a.f;
        let j = 2 * i.count;
        let k = new List$1(Array_$type, 2, j);
        if (!this.qb.ca) {
            for (let l = 0; l < j; l++) {
                let m = new Array(4);
                m[0] = this.qw(l, false, a, h, g, f);
                m[1] = a.f._inner[(intDivide(l, 2))][1];
                m[2] = this.qw(l, true, a, h, g, f);
                m[3] = a.f._inner[(intDivide(l, 2))][2];
                k.add(m);
            }
        }
        else {
            for (let n = 0; n < j; n++) {
                let o = new Array(4);
                o[0] = this.qw(n, true, a, h, g, f);
                o[1] = a.f._inner[(intDivide(n, 2))][1];
                o[2] = this.qw(n, true, a, h, g, f);
                o[3] = a.f._inner[(intDivide(n, 2))][2];
                k.add(o);
            }
        }
        let p = typeCast(StepLineSeriesView.$, b);
        let q = p.cn.d;
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        let r = false;
        let s = this.nr.c;
        if (s != null) {
            r = true;
        }
        if (r) {
            let t = new ScalerParams(0, b.bs, b.br, this.qb.ca, e);
            this.ox(i, -1, this.valueColumn.count, this.qb, t, b.n);
        }
        let u = p.dd;
        let v = p.de;
        let w = p.dc;
        this.nr.ae(u, true, false, true, false);
        this.nr.ae(v, true, false, true, false);
        this.nr.ae(w, false, true, false, false);
        w._opacity = 0.75 * this.nr.i;
        if (b.cr(a)) {
            p.c8(j, k, false, 1, this.o9(k, j - 1, b.br, b.bs), q, this.eu);
            b.cu(a);
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StepLineSeries.$t = markType(StepLineSeries, 'StepLineSeries', HorizontalAnchoredCategorySeries.$);
/**
 * @hidden
 */
class StepLineSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.dg = new Path();
        this.df = new Path();
        this.dh = new Path();
        this.db = new Path();
        this.da = new Path();
        this.c9 = new Path();
        this.c6 = a;
    }
    get dd() {
        return this.dg;
    }
    get de() {
        return this.dh;
    }
    get dc() {
        return this.df;
    }
    c7() {
        this.df.ak = null;
        this.dg.ak = null;
        this.dh.ak = null;
        this.an();
    }
    c8(a, b, c, d, e, f, g) {
        this.c6.qu.a = typeCast(ISortingAxis_$type, this.cp.fetchXAxis()) !== null ? true : false;
        this.c6.qu.m(this.dg, this.df, this.dh, a, b, c, d, e, f, g);
        this.an();
    }
    a9() {
        super.a9();
        this.da.ak = this.dg.ak;
        this.db.ak = this.dh.ak;
        this.c9.ak = this.df.ak;
        let a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.s(this.c9);
                a.s(this.da);
                a.s(this.db);
            }
            else {
                a.s(this.df);
                a.s(this.dg);
                a.s(this.dh);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.dg, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.dh, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.df, "translucentShape", ["Translucent"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
StepLineSeriesView.$t = markType(StepLineSeriesView, 'StepLineSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStepLineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent step line series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-step-line-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-step-line-series>
* </igx-data-chart>
* ```
*
* ```ts
*    let series = new IgxStepLineSeriesComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.valueMemberPath="value";
*    this.chart.series.add(series);
* ```
*/
const IgxStepLineSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent) }];
let IgxStepLineSeriesComponent = IgxStepLineSeriesComponent_1 = class IgxStepLineSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StepLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxStepLineSeriesComponent = IgxStepLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-step-line-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStepLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStepLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStepLineSeriesModule = class IgxStepLineSeriesModule {
};
IgxStepLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStepLineSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxStepLineSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxStepLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStepLineSeriesDynamicModule = class IgxStepLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStepLineSeriesComponent", IgxStepLineSeriesComponent);
        TypeRegistrar.register("StepLineSeries", StepLineSeries.$type);
    }
};
IgxStepLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStepLineSeriesModule],
        exports: [IgxStepLineSeriesModule],
        entryComponents: [IgxStepLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStepLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WaterfallSeries extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = WaterfallSeries.$;
    }
    bf() {
        return new WaterfallSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qu = a;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    get_cz() {
        return true;
    }
    jq(a, b) {
        super.jq(a, b);
        this.q5 = a;
        this.q6 = b;
    }
    lj() {
        return this.q5;
    }
    get_n8() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case WaterfallSeries.$$p[3]:
            case WaterfallSeries.$$p[2]:
            case WaterfallSeries.$$p[0]:
            case WaterfallSeries.$$p[1]:
                this.jl(false);
                break;
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    l4(a) {
        if (this.qu == null || this.qu.c7 == null || this.qu.c7.count == 0 || this.xAxis == null) {
            return Rect.empty;
        }
        let b = this.qu.c7;
        let c = this.lq(a);
        let d = -1;
        let e = this.xAxis.ca;
        let f = this.l8.right * 2;
        if (e) {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, (g) => {
                let h = this.qu.de(g);
                return (f - c.x) < (f - (h.left + h.width / 2)) ? -1 : ((f - c.x) > (f - (h.left + h.width / 2)) ? 1 : 0);
            });
        }
        else {
            d = ArrayExtension.binarySearch$1(Rectangle.$, b, (g) => {
                let h = this.qu.de(g);
                return c.x < (h.left + h.width / 2) ? -1 : (c.x > (h.left + h.width / 2) ? 1 : 0);
            });
        }
        if (d < 0) {
            d = ~d;
            d--;
        }
        if (d < 0) {
            d = 0;
        }
        if (d > b.count - 1) {
            d = b.count - 1;
        }
        let g = d;
        let h = d;
        if (g < 0) {
            g--;
        }
        if (h < b.count - 1) {
            h++;
        }
        let i = this.q7(g);
        let j = this.q7(d);
        let k = this.q7(h);
        let l = i.left + i.width / 2;
        let m = j.left + j.width / 2;
        let n = k.left + k.width / 2;
        let o = Math.abs(l - c.x);
        let p = Math.abs(m - c.x);
        let q = Math.abs(n - c.x);
        let r = i.containsPoint(c);
        let s = j.containsPoint(c);
        let t = k.containsPoint(c);
        if (p <= o && p <= q) {
            if (!e && t) {
                return k;
            }
            if (e && r) {
                return i;
            }
            return j;
        }
        if (o <= p && o <= q) {
            if (!e && s) {
                return j;
            }
            return i;
        }
        if (q <= p && q <= o) {
            if (e && s) {
                return j;
            }
            return k;
        }
        return Rect.empty;
    }
    q7(a) {
        return this.qu.dd(a);
    }
    nt() {
        return 1;
    }
    h3(a, b) {
        super.h3(a, b);
        this.qu.c7.count = 0;
    }
    eg() {
        return this.qb.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    o1(a, b) {
        let c = b;
        super.o1(a, b);
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = this.qb.jz(d, e, f);
        let h = this.qv;
        let i = this.qw;
        let j;
        let k = this.pk(b);
        let l = NaN;
        let m = c.c7;
        let n;
        let o = 0;
        this.nr.x(this, this.oc(), this.qb, runOn(this, this.nd), this.ok(b), this.ol(b));
        this.nr.p = this.qv;
        this.nr.q = this.qw;
        this.nr.j = this.qv;
        this.nr.k = this.qw;
        let p = false;
        let q = this.nr.c;
        if (q != null) {
            p = true;
        }
        let r = this.qb.cf;
        let s = this.valueColumn.count;
        let t = a.f;
        let u = this.qb;
        let v = new ScalerParams(0, d, e, this.qb.ca, f);
        let w = this.lb;
        let x = this.q5;
        let y = this.lc;
        let z = this.q6 || y;
        if (a.f.count > 0) {
            j = a.f._inner[0][0] - 0.5 * g;
            let aa = a.f._inner[0][1];
            if (!isNaN_(aa)) {
                if (aa > k) {
                    n = m.item(o);
                    o++;
                    c.dc(n, j, k);
                    n.width = g;
                    n.height = Math.abs(k - aa);
                    this.nr.al = x;
                    this.nr.ah = x;
                    this.nr.am = z;
                    this.nr.ai = z;
                    this.nr.f = true;
                    if (p) {
                        this.ox(t, 0, s, u, v, b.n);
                    }
                    this.nr.ae(n, false, false, false, false);
                    n.am = this.nr.j;
                    n.an = this.nr.k;
                }
                else {
                    n = m.item(o);
                    o++;
                    c.dc(n, j, aa);
                    n.width = g;
                    n.height = Math.abs(aa - k);
                    this.nr.al = w;
                    this.nr.ah = w;
                    this.nr.am = y;
                    this.nr.ai = y;
                    this.nr.f = false;
                    if (p) {
                        this.ox(t, 0, s, u, v, b.n);
                    }
                    this.nr.ae(n, false, false, false, false);
                    n.am = this.nr.j;
                    n.an = this.nr.k;
                }
                l = aa;
            }
            else {
                l = k;
            }
        }
        for (let ab = 1; ab < a.f.count; ++ab) {
            let ac = a.f._inner[ab];
            j = a.f._inner[ab][0] - 0.5 * g;
            let ad = ac[1];
            if (!isNaN_(ad)) {
                n = m.item(o);
                o++;
                c.dc(n, j, Math.min(l, ad));
                n.width = g;
                n.height = Math.abs(l - ad);
                this.nr.al = w;
                this.nr.ah = w;
                this.nr.am = y;
                this.nr.ai = y;
                this.nr.f = false;
                if (l > ad) {
                    if (p) {
                        this.ox(t, ab, s, u, v, b.n);
                    }
                }
                else {
                    this.nr.al = x;
                    this.nr.ah = x;
                    this.nr.am = z;
                    this.nr.ai = z;
                    this.nr.f = true;
                    if (p) {
                        this.ox(t, ab, s, u, v, b.n);
                    }
                }
                this.nr.ae(n, false, false, false, false);
                n.am = this.nr.j;
                n.an = this.nr.k;
                l = ad;
            }
        }
        m.count = o;
        b.cu(a);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
WaterfallSeries.$t = markType(WaterfallSeries, 'WaterfallSeries', HorizontalAnchoredCategorySeries.$);
WaterfallSeries.$$p = markDep(DependencyProperty, PropertyMetadata, WaterfallSeries, 'raisePropertyChanged', ['NegativeBrush:q5:q1', [Brush.$, null], 'NegativeOutline:q6:q2', [Brush.$, null], 'RadiusX:qv:q3', [1, 2], 'RadiusY:qw:q4', [1, 2]]);
/**
 * @hidden
 */
class WaterfallSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c8 = null;
        this.df = new Rectangle();
        this.c7 = null;
        this.c6 = a;
        this.c7 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.dg);
            $ret.activate = runOn(this, this.c9);
            $ret.disactivate = runOn(this, this.db);
            $ret.destroy = runOn(this, this.da);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.c6.q5 = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.c6.q6 = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.e.bj = 5;
        }
    }
    dg() {
        let a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    }
    c9(a) {
        a._visibility = 0;
    }
    db(a) {
        a._visibility = 1;
    }
    da(a) {
        this.c8.remove(a);
    }
    dc(a, b, c) {
        let d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    }
    z(a) {
        return this.c8._inner[a];
    }
    y(a) {
        let b = this.c8._inner[a];
        this.df._visibility = b._visibility;
        this.df.n = b.n;
        this.df.o = b.o;
        this.df.width = b.width;
        this.df.height = b.height;
        let c = this.bm(a);
        this.df._fill = c;
        this.df._stroke = c;
        this.df.ac = this.e.ey + 3;
        return this.df;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c8.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c7.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            let f = "Negative";
            if (e._fill == this.e.lb) {
                f = "Positive";
            }
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", f]);
        }
        b++;
    }
    dd(a) {
        let b = this.c7.item(a);
        return new Rect(0, b.n, b.o, b.width, b.height);
    }
    de(a) {
        return new Rect(0, a.n, a.o, a.width, a.height);
    }
}
WaterfallSeriesView.$t = markType(WaterfallSeriesView, 'WaterfallSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxWaterfallSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent waterfall column series.
*
* `IgxWaterfallSeriesComponent` belongs to a group of `IgxCategorySeriesComponent` and it is rendered using a collection of vertical columns that show the difference between consecutive data points.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis #xAxis
*         label="label">
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-waterfall-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-waterfall-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxWaterfallSeriesComponent = new IgxWaterfallSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath = "value";
* this.chart.series.add(series);
* ```
*/
const IgxWaterfallSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent) }];
let IgxWaterfallSeriesComponent = IgxWaterfallSeriesComponent_1 = class IgxWaterfallSeriesComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new WaterfallSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Overridden by derived series classes to indicate when negative colors are supported or not.
    */
    get isNegativeColorSupported() {
        return this.i.cz;
    }
    /**
     * Gets or sets the brush to use for negative portions of the series.
    *
    * Gets or sets the color used to draw negative declines in values for this `IgxWaterfallSeriesComponent`.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-waterfall-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         negativeBrush="#ff0000"
    *         valueMemberPath="value">
    *     </igx-waterfall-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * series.negativeBrush = "#ff0000";
    * this.chart.series.add(series);
    * ```
    */
    get negativeBrush() {
        return brushToString(this.i.q5);
    }
    set negativeBrush(v) {
        this.i.q5 = stringToBrush(v);
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    *
    * Gets or sets the amount to round corners in the direction of the X axis in this series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-waterfall-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         radiusX="15"
    *         radiusY="15"
    *         valueMemberPath="value">
    *     </igx-waterfall-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * series.radiusX = 15;
    * series.radiusY = 15;
    * this.chart.series.add(series);
    * ```
    */
    get radiusX() {
        return this.i.qv;
    }
    set radiusX(v) {
        this.i.qv = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    *
    * Gets or sets the amount to round corners in the direction of the Y axis in this series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-waterfall-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         radiusX="15"
    *         radiusY="15"
    *         valueMemberPath="value">
    *     </igx-waterfall-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * series.radiusX = 15;
    * series.radiusY = 15;
    * this.chart.series.add(series);
    * ```
    */
    get radiusY() {
        return this.i.qw;
    }
    set radiusY(v) {
        this.i.qw = +v;
    }
    /**
     * Brush to use for outlining negative elements in the waterfall series.
    *
    * Gets or sets the color used to draw borders of negative declines in values for this `IgxWaterfallSeriesComponent`.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-waterfall-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         negativeOutline="#ff0000"
    *         valueMemberPath="value">
    *     </igx-waterfall-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath = "value";
    * series.negativeOutline = "#ff0000";
    * this.chart.series.add(series);
    * ```
    */
    get negativeOutline() {
        return brushToString(this.i.q6);
    }
    set negativeOutline(v) {
        this.i.q6 = stringToBrush(v);
    }
    setNegativeColors(negativeBrush, negativeOutline) {
        this.i.jq(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * Returns a bounding box `Rect` for a data value given a `Point`.
    *
    * ```ts
    * let box : IgxRect = series.getSeriesValueBoundingBox({x: 4, y: 7});
    * ```
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * Returns the width of items in the `IgxWaterfallSeriesComponent`.
    *
    * ```ts
    * let itemSpan: number = series.GetItemSpan();
    * ```
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxWaterfallSeriesComponent.prototype, "negativeBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxWaterfallSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxWaterfallSeriesComponent.prototype, "radiusY", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxWaterfallSeriesComponent.prototype, "negativeOutline", null);
IgxWaterfallSeriesComponent = IgxWaterfallSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-waterfall-series',
        template: ``,
        providers: [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWaterfallSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxWaterfallSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWaterfallSeriesModule = class IgxWaterfallSeriesModule {
};
IgxWaterfallSeriesModule = __decorate([
    NgModule({
        declarations: [IgxWaterfallSeriesComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxWaterfallSeriesComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxWaterfallSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWaterfallSeriesDynamicModule = class IgxWaterfallSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxWaterfallSeriesComponent", IgxWaterfallSeriesComponent);
        TypeRegistrar.register("WaterfallSeries", WaterfallSeries.$type);
    }
};
IgxWaterfallSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxWaterfallSeriesModule],
        exports: [IgxWaterfallSeriesModule],
        entryComponents: [IgxWaterfallSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxWaterfallSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available tooltip types to display in the chart.
 */
var ToolTipType;
(function (ToolTipType) {
    /**
     * Display default tooltip for each series in the chart.
     */
    ToolTipType[ToolTipType["Default"] = 0] = "Default";
    /**
     * Display individual tooltips for all series in the chart.
     */
    ToolTipType[ToolTipType["Item"] = 1] = "Item";
    /**
     * Display combined tooltip for all series in the chart.
     */
    ToolTipType[ToolTipType["Category"] = 2] = "Category";
    /**
     * Display no tooltips in the chart.
     */
    ToolTipType[ToolTipType["None"] = 3] = "None";
})(ToolTipType || (ToolTipType = {}));
/**
 * @hidden
 */
let ToolTipType_$type = markEnum('ToolTipType', 'Default,0|Item,1|Category,2|None,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available display modes of crosshairs lines in the chart.
 */
var CrosshairsDisplayMode;
(function (CrosshairsDisplayMode) {
    /**
     * Display default number of crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Default"] = 0] = "Default";
    /**
     * Display no crosshair lines in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["None"] = 1] = "None";
    /**
     * Display horizontal line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Horizontal"] = 2] = "Horizontal";
    /**
     * Display vertical line of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Vertical"] = 3] = "Vertical";
    /**
     * Display both horizontal and vertical lines of crosshairs in the chart.
     */
    CrosshairsDisplayMode[CrosshairsDisplayMode["Both"] = 4] = "Both";
})(CrosshairsDisplayMode || (CrosshairsDisplayMode = {}));
/**
 * @hidden
 */
let CrosshairsDisplayMode_$type = markEnum('CrosshairsDisplayMode', 'Default,0|None,1|Horizontal,2|Vertical,3|Both,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChartSeriesEventArgs extends Base {
    constructor(a) {
        super();
        this._series = null;
        this.series = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
}
ChartSeriesEventArgs.$t = markType(ChartSeriesEventArgs, 'ChartSeriesEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DomainChartSeriesPointerEventArgs extends Base {
    constructor(a, b) {
        super();
        this._series = null;
        this._item = null;
        this.series = a;
        this.item = b;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
}
DomainChartSeriesPointerEventArgs.$t = markType(DomainChartSeriesPointerEventArgs, 'DomainChartSeriesPointerEventArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DomainChart extends Base {
    constructor() {
        super();
        this.di = null;
        this.dh = null;
        this.bz = null;
        this.cd = NaN;
        this.dg = null;
        this.cm = 0;
        this.cn = 0;
        this.co = 0;
        this.cl = 0;
        this.ch = 0;
        this.cj = 0;
        this.ci = 0;
        this.cg = 0;
        this.hx = null;
        this.hy = null;
        this.cc = NaN;
        this.cp = NaN;
        this.cf = NaN;
        this.cb = NaN;
        this.db = 0;
        this.a0 = null;
        this.c7 = null;
        this.bx = false;
        this.af = null;
        this.dw = null;
        this.dy = null;
        this.ay = null;
        this.b3 = null;
        this.propertyChanged = null;
        this.da = 0;
        this.br = false;
        this.ab = null;
        this.by = null;
        this.seriesAdded = null;
        this.seriesRemoved = null;
        this.seriesPointerEnter = null;
        this.seriesPointerLeave = null;
        this.seriesPointerMove = null;
        this.seriesPointerDown = null;
        this.seriesPointerUp = null;
        this.calloutStyleUpdating = null;
        this.b2 = null;
        this.a3 = null;
        this.a6 = false;
        this.b8 = null;
        this.b = null;
        this.a = null;
        this.e = null;
        this.h = null;
        this.ad = null;
        this.bc = true;
        this.be = true;
        this.bd = false;
        this.h6 = new Rect(0, 0, 0, 1, 1);
        this.dx = null;
        this.dv = null;
        this.hu = 1;
        this.ht = 1;
        this.aw = 0;
        this.ce = 1;
        this.ck = 1;
        this.aj = null;
        this.f = null;
        this.g = null;
        this.c9 = 400;
        this.a5 = false;
        this.i = null;
        this.au = 0;
        this.cq = 1.5;
        this.a4 = true;
        this.dc = 7;
        this.as = 0;
        this.s = 0;
        this.ba = true;
        this.a9 = false;
        this.bb = false;
        this.a8 = false;
        this.a7 = false;
        this.b7 = null;
        this.dt = null;
        this.du = null;
        this.ds = "CalloutLabel";
        this.dr = "CalloutContent";
        this.b2 = new List$1(Delegate_$type, 0);
        this.gh();
        this.f3();
    }
    provideContainer(a) {
        if (a == null) {
            this.gx((b) => b.provideContainer(null));
            return;
        }
        let b = this.di;
        this.di = a;
        if (this.a3 != null && this.di != null && b == null) {
            this.di.setTimeout(this.a3, 0);
            this.a3 = null;
        }
        let c = ((() => {
            let $ret = new XamDataChart();
            $ret.dd = true;
            return $ret;
        })());
        c.provideContainer(a);
        this.dataChart = c;
        this.gi();
    }
    destroy() {
        this.provideContainer(null);
    }
    gi() {
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.b1.i.e();
        this.j = a.a;
        this.n = a.f;
        this.l = a.b;
        this.m = a.c;
        this.o = a.g;
        this.c0 = DeviceUtils.g(1);
        this.gj();
    }
    gj() {
    }
    gf(a) {
        if (a == null) {
            return;
        }
        a.fi = this.c4;
        a.fg = this.c2;
        a.fh = this.c3;
        a.ff = this.c1;
        a.ns = this.h4;
        a.fc = this.cx;
        a.fe = this.cz;
        a.fd = this.cy;
        a.fb = this.cw;
        a.nr = this.h3;
        if (!isNaN_(this.ct)) {
            a.e8 = this.ct;
        }
    }
    gc() {
    }
    gl(a, b) {
        a.fi = this.de;
        a.bu = this.a1;
    }
    g4(a, b, c) {
        switch (a) {
            case "TitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.fi = this.c4;
                }
                break;
            case "TitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.fg = this.c2;
                }
                break;
            case "PixelScalingRatio":
                if (this.dataChart != null) {
                    this.gx((d) => d.e8 = this.ct);
                }
                break;
            case "TitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.fh = this.c3;
                }
                break;
            case "TitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.ff = this.c1;
                }
                break;
            case "TitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.ns = this.h4;
                }
                break;
            case "SubtitleLeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.fc = this.cx;
                }
                break;
            case "SubtitleTopMargin":
                if (this.dataChart != null) {
                    this.dataChart.fe = this.cz;
                }
                break;
            case "SubtitleRightMargin":
                if (this.dataChart != null) {
                    this.dataChart.fd = this.cy;
                }
                break;
            case "SubtitleBottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.fb = this.cw;
                }
                break;
            case "SubtitleTextColor":
                if (this.dataChart != null) {
                    this.dataChart.nr = this.h3;
                }
                break;
            case "LeftMargin":
                if (this.dataChart != null) {
                    this.dataChart.e7 = this.cs;
                }
                break;
            case "TopMargin":
                if (this.dataChart != null) {
                    this.dataChart.fj = this.c5;
                }
                break;
            case "RightMargin":
                if (this.dataChart != null) {
                    this.dataChart.fa = this.cv;
                }
                break;
            case "BottomMargin":
                if (this.dataChart != null) {
                    this.dataChart.e3 = this.cr;
                }
                break;
            case "TransitionDuration":
                this.f8((d) => d.fi = this.de);
                break;
            case "TransitionEasingFunction":
                this.f8((d) => d.bu = this.a1);
                break;
        }
    }
    get tooltipTemplate() {
        return ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, 0);
    }
    set tooltipTemplate(a) {
        this.tooltipTemplates = a == null ? null : new List$1(Base.$, 1, [a]);
    }
    get tooltipTemplates() {
        return this.bz;
    }
    set tooltipTemplates(a) {
        let b = this.tooltipTemplates;
        if (a != b) {
            this.bz = a;
            this.g3("TooltipTemplates", b, this.tooltipTemplates);
        }
    }
    get ct() {
        return this.cd;
    }
    set ct(a) {
        let b = this.cd;
        if (a != b) {
            this.cd = a;
            this.g3("PixelScalingRatio", b, this.ct);
        }
    }
    get toolTip() {
        return this.dg;
    }
    set toolTip(a) {
        let b = this.toolTip;
        if (b != a) {
            this.dg = a;
            this.g3("ToolTip", b, this.toolTip);
        }
    }
    get c2() {
        return this.cm;
    }
    set c2(a) {
        let b = this.c2;
        if (a != b) {
            this.cm = a;
            this.g3("TitleLeftMargin", b, this.c2);
        }
    }
    get c3() {
        return this.cn;
    }
    set c3(a) {
        let b = this.c3;
        if (a != b) {
            this.cn = a;
            this.g3("TitleRightMargin", b, this.c3);
        }
    }
    get c4() {
        return this.co;
    }
    set c4(a) {
        let b = this.c4;
        if (a != b) {
            this.co = a;
            this.g3("TitleTopMargin", b, this.c4);
        }
    }
    get c1() {
        return this.cl;
    }
    set c1(a) {
        let b = this.c1;
        if (a != b) {
            this.cl = a;
            this.g3("TitleBottomMargin", b, this.c1);
        }
    }
    get cx() {
        return this.ch;
    }
    set cx(a) {
        let b = this.cx;
        if (a != b) {
            this.ch = a;
            this.g3("SubtitleLeftMargin", b, this.cx);
        }
    }
    get cz() {
        return this.cj;
    }
    set cz(a) {
        let b = this.cz;
        if (a != b) {
            this.cj = a;
            this.g3("SubtitleTopMargin", b, this.cz);
        }
    }
    get cy() {
        return this.ci;
    }
    set cy(a) {
        let b = this.cy;
        if (a != b) {
            this.ci = a;
            this.g3("SubtitleRightMargin", b, this.cy);
        }
    }
    get cw() {
        return this.cg;
    }
    set cw(a) {
        let b = this.cw;
        if (a != b) {
            this.cg = a;
            this.g3("SubtitleBottomMargin", b, this.cw);
        }
    }
    get h3() {
        return this.hx;
    }
    set h3(a) {
        let b = this.h3;
        if (a != b) {
            this.hx = a;
            this.g3("SubtitleTextColor", b, this.h3);
        }
    }
    get h4() {
        return this.hy;
    }
    set h4(a) {
        let b = this.h4;
        if (a != b) {
            this.hy = a;
            this.g3("TitleTextColor", b, this.h4);
        }
    }
    get_cs() {
        return this.cc;
    }
    set_cs(a) {
        let b = this.cs;
        if (a != b) {
            this.cc = a;
            this.g3("LeftMargin", b, this.cs);
        }
    }
    get cs() {
        return this.get_cs();
    }
    set cs(a) {
        this.set_cs(a);
    }
    get c5() {
        return this.cp;
    }
    set c5(a) {
        let b = this.c5;
        if (a != b) {
            this.cp = a;
            this.g3("TopMargin", b, this.c5);
        }
    }
    get cv() {
        return this.cf;
    }
    set cv(a) {
        let b = this.cv;
        if (a != b) {
            this.cf = a;
            this.g3("RightMargin", b, this.cv);
        }
    }
    get cr() {
        return this.cb;
    }
    set cr(a) {
        let b = this.cr;
        if (a != b) {
            this.cb = a;
            this.g3("BottomMargin", b, this.cr);
        }
    }
    get de() {
        return this.db;
    }
    set de(a) {
        let b = this.de;
        if (a != b) {
            this.db = a;
            this.g3("TransitionDuration", b, this.de);
        }
    }
    get a1() {
        return this.a0;
    }
    set a1(a) {
        let b = this.a1;
        if (a != b) {
            this.a0 = a;
            this.g3("TransitionEasingFunction", b, this.a1);
        }
    }
    gg(a) {
        if (this.dataChart == null) {
            return;
        }
        a.hr = this.fk;
        a.hf = this.e9;
    }
    gm(a, b) {
        this.gn(a, b);
    }
    gd() {
    }
    gn(a, b) {
        if (a == null) {
            return;
        }
        let toolTipTemplate_ = ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, b);
        if (toolTipTemplate_ == null) {
            a.dd = true;
        }
        else {
            let series_ = a;
            a.dd = false;
            series_.externalObject.tooltipTemplate = toolTipTemplate_;
        }
    }
    hr(a, b, c) {
    }
    dk(a) {
        return a;
        return null;
    }
    c8(a) {
        return null;
    }
    g5(a, b, c) {
        switch (a) {
            case "SubtitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.hf = this.e9;
                }
                break;
            case "TitleTextStyle":
                if (this.dataChart != null) {
                    this.dataChart.hr = this.fk;
                }
                break;
            case "TooltipTemplate":
                if (this.bx) {
                    return;
                }
                this.bx = true;
                this.tooltipTemplate = this.dk(this.tooltipTemplate);
                this.bx = false;
                if (this.dataChart != null) {
                    this.dataChart.fy = this.tooltipTemplate;
                }
                this.toolTip = this.tooltipTemplate;
                break;
            case "ToolTip":
                this.f9((d, e) => this.gn(d, e));
                break;
            case "TooltipTemplates":
                if (this.tooltipTemplates == null) {
                    break;
                }
                this.bx = true;
                this.f9((d, e) => {
                    let f = this.dk(ArrayExtension.getModulus$1(Base.$, this.tooltipTemplates, e));
                    let series_ = d;
                    let templ_ = f;
                    series_.externalObject.tooltipTemplate = templ_;
                });
                this.bx = false;
                break;
        }
    }
    get ag() {
        return this.af;
    }
    set ag(a) {
        let b = this.ag;
        if (a != b) {
            this.af = a;
            this.g3("Widget", b, this.ag);
        }
    }
    get e9() {
        return this.dw;
    }
    set e9(a) {
        let b = this.e9;
        if (a != b) {
            this.dw = a;
            this.g3("SubtitleTextStyle", b, this.e9);
        }
    }
    get fk() {
        return this.dy;
    }
    set fk(a) {
        let b = this.fk;
        if (a != b) {
            this.dy = a;
            this.g3("TitleTextStyle", b, this.fk);
        }
    }
    get dataChart() {
        return this.ay;
    }
    set dataChart(a) {
        let b = this.dataChart;
        if (b != a) {
            this.ay = a;
            this.g3("DataChart", b, this.dataChart);
        }
    }
    onDetachedFromUI() {
        this.gx((a) => a.onDetachedFromUI());
    }
    onAttachedToUI() {
        this.gx((a) => a.onAttachedToUI());
    }
    gh() {
        this.b3 = new List$1(MarkerType_$type, 0);
        this.v = new DataSeriesAdapter().e;
        if (this.d != null) {
            this.v.includedProperties = this.d;
        }
        if (this.c != null) {
            this.v.excludedProperties = this.c;
        }
        this.v.supportedSeriesTypes = this.b5.toArray();
        this.v.rules.clear();
        for (let a of fromEnum(this.b4)) {
            this.v.rules.add(a);
        }
        let b = new List$1(String_$type, 0);
        for (let c of fromEnum(this.v.rules)) {
            b.add(getInstanceType(c).typeName);
        }
        let d = this.v.dataSeries;
        d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.g0));
    }
    bt(a) {
        return a != 24 && this.b5.contains(a);
    }
    notifyResized() {
        this.gx((a) => a.notifyContainerResized());
    }
    gv() {
        this.gx((a) => {
            for (let b = 0; b < a.series.count; b++) {
                a.series._inner[b].iv();
            }
        });
    }
    f7() {
        if (this.dataChart == null) {
            return;
        }
        if (this.br) {
            this.hl();
        }
        this.dataChart.flush();
    }
    ga() {
        if (this.dataChart == null) {
            return;
        }
        this.dataChart.io();
    }
    ha(a) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    f8(a) {
        this.f9((b, c) => a(b));
    }
    f9(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            a(this.dataChart.series._inner[b], b);
        }
    }
    gx(a) {
        this.gy(a, true);
    }
    gy(a, b) {
        this.gz(a, b, null);
    }
    gz(a, b, c) {
        if (this.dataChart == null) {
            return;
        }
        a(this.dataChart);
    }
    bu(a) {
        if (!this.bt(a.suggestedSeries)) {
            return false;
        }
        let b = a.data;
        if (b == null) {
            return false;
        }
        return true;
    }
    bp() {
        if (this.dataChart == null) {
            return false;
        }
        return true;
    }
    el(a) {
        let b = "series_" + (this.dataChart.series.count + 1) + "_" + EnumUtil.getName(DataSeriesType_$type, a.suggestedSeries);
        return b;
    }
    em(a, b) {
        if (stringIsNullOrEmpty(a.title)) {
            let c = EnumUtil.getName(DataSeriesType_$type, b);
            return c + (this.dataChart.series.count + 1);
        }
        else {
            return a.title;
        }
    }
    ek() {
        return stringEmpty();
    }
    hl() {
        if (this.dataChart == null) {
            return;
        }
        this.br = false;
        this.hn();
        if (this.itemsSource == null) {
            return;
        }
        let a = new List$1(MarkerType_$type, 0);
        for (let b of fromEnum(this.v.dataSeries)) {
            a.add(this.ah(b.suggestedMarker));
        }
        this.b3 = a;
        let c = 0;
        for (let d of fromEnum(this.v.dataSeries)) {
            if (!this.bu(d)) {
                continue;
            }
            if (d.index < 0) {
                d.index = c;
            }
            this.hj(d);
            this.hk(d);
            c++;
        }
        this.hs();
        this.f9(runOn(this, this.gk));
    }
    ar(seriesType_) {
        return (this.externalObject.createSeries(seriesType_).i);
    }
    al() {
        return this.ar(28);
    }
    an() {
        return this.ar(27);
    }
    ao() {
        return this.ar(29);
    }
    ap() {
        return this.ar(25);
    }
    am() {
        return this.ar(26);
    }
    get ac() {
        if (TypeRegistrar.isRegistered("AnnotationLayerProxy")) {
            return TypeRegistrar.create("AnnotationLayerProxy");
        }
        else {
            throw new BaseError(1, "annoation layer module is not loaded, but is required.");
        }
    }
    get bn() {
        return (TypeRegistrar.isRegistered("AnnotationLayerProxy"));
    }
    bo(a) {
        if (!this.bn) {
            return false;
        }
        return this.ac.matchesType(a);
    }
    hs() {
        let a = this.b1("", true);
        if (a != null) {
            for (let b = 0; b < a.count; b++) {
                this.dataChart.series.add(a._inner[b]);
            }
        }
    }
    b1(a, b) {
        if (!this.bn) {
            return null;
        }
        let c = new List$1(Series.$, 0);
        if (b) {
            if (this.a8) {
                let d = 1;
                if (this.b7 == null) {
                    for (let e of fromEnum(this.dataChart.series)) {
                        let f = this.al();
                        this.ac.setTargetSeries(f, e);
                        this.ac.setCollisionChannel(f, "MainChartCollisionChannel");
                        this.hq(f, e, this.v.dataSeries._inner[d - 1]);
                        f.name = a + getInstanceType(f).typeName + d.toString();
                        c.add(f);
                        d++;
                    }
                    ;
                }
                else {
                    let g = this.al();
                    this.hq(g, null, this.v.dataSeries._inner[d - 1]);
                    g.name = a + getInstanceType(g).typeName + d.toString();
                    c.add(g);
                }
            }
        }
        switch (this.s) {
            case 4:
            case 3:
            case 2:
                {
                    let h = this.an();
                    this.ac.setUseInterpolation(h, !this.ba);
                    this.ac.setHorizontalLineVisibility(h, (this.s == 2 || this.s == 4) ? 0 : 1);
                    this.ac.setVerticalLineVisibility(h, (this.s == 3 || this.s == 4) ? 0 : 1);
                    this.ac.setIsAxisAnnotationEnabled(h, this.a9);
                    c.add(h);
                    break;
                }
            case 1:
            case 0:
                {
                    break;
                }
        }
        if (this.bb) {
            let i = this.ao();
            c.add(i);
        }
        if (b) {
            switch (this.as) {
                case 1:
                    {
                        let j = this.ap();
                        c.add(j);
                        break;
                    }
                case 2:
                    {
                        let k = this.am();
                        c.add(k);
                        break;
                    }
                case 3:
                    {
                        this.f8((l) => l.dd = false);
                        break;
                    }
                case 0:
                    {
                        this.f8((l) => l.dd = true);
                        break;
                    }
            }
        }
        for (let l of fromEnum(c)) {
            if (stringIsNullOrEmpty(l.name) == false) {
                continue;
            }
            l.name = a + getInstanceType(l).typeName;
        }
        return c;
    }
    hq(a, b, c) {
        a.itemsSource = this.b7 != null ? this.b7 : b.itemsSource;
        this.ac.setXMemberPath(a, this.dt);
        this.ac.setYMemberPath(a, this.du);
        this.ac.setLabelMemberPath(a, this.ds);
        this.ac.setContentMemberPath(a, this.dr);
    }
    hn() {
        this.ho(this.dataChart);
    }
    ho(a) {
        if (a != null && a == this.dataChart) {
            this.hm();
        }
        if (a == null || a.series.count == 0) {
            return;
        }
        this.f8((b) => {
            if (this.bo(b) && this.ac.isCalloutLayer(b)) {
                this.ac.removeCalloutStyleUpdating(b, runOn(this, this.g9));
            }
            this.hh(b);
        });
        for (let b of fromEnum(a.series)) {
            this.hp(b);
        }
        a.series.clear();
    }
    hp(a) {
        a.itemsSource = null;
        a.legend = null;
        a.h1();
    }
    g0(a, b) {
        if (this.dataChart == null) {
            return;
        }
        let c = b.oldItems == null ? "null" : b.oldItems.count.toString();
        let d = b.newItems == null ? "null" : b.newItems.count.toString();
        if (this.br) {
            return;
        }
        let e = this.g8(runOn(this, this.f5), this.br);
        this.br = e.p1;
    }
    f5() {
        this.hl();
    }
    hz(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.j, a);
    }
    h2(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.n, a);
    }
    h0(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.l, a);
    }
    h1(a) {
        return ArrayExtension.getModulus$1(Brush.$, this.m, a);
    }
    h5(a) {
        let b = new Color();
        if (this.j == null || this.j.count == 0) {
            b = ArrayExtension.getModulus$1(Color.$, this.b0, a);
        }
        else {
            let c = ArrayExtension.getModulus$1(Brush.$, this.j, a);
            if (c == null) {
                b = ArrayExtension.getModulus$1(Color.$, this.b0, a);
            }
            else {
                b = ColorUtil.j(c);
            }
        }
        return b;
    }
    a2(a) {
        let b = new ObservableColorCollection();
        b.add(ColorUtil.o(a, 0.5));
        b.add(a);
        return b;
    }
    k(a) {
        let b = this.a2(a);
        let c = BrushCollectionUtil.a(b);
        return c;
    }
    get b0() {
        if (this.by != null) {
            return this.by;
        }
        this.by = new List$1(Color.$, 0);
        this.by.add(ColorUtil.k("#FF7446B9"));
        this.by.add(ColorUtil.k("#FF9FB328"));
        this.by.add(ColorUtil.k("#FFF96232"));
        this.by.add(ColorUtil.k("#FF2E9CA6"));
        this.by.add(ColorUtil.k("#FFDC3F76"));
        this.by.add(ColorUtil.k("#FFFF9800"));
        this.by.add(ColorUtil.k("#FF3F51B5"));
        this.by.add(ColorUtil.k("#FF439C47"));
        this.by.add(ColorUtil.k("#FF795548"));
        this.by.add(ColorUtil.k("#FF494747"));
        return this.by;
    }
    dj() {
        if (this.dataChart == null) {
            return null;
        }
        return this.dataChart.px();
    }
    go(a, b) {
    }
    gp(a, b, c) {
    }
    ah(a) {
        if (a == 2) {
            return 3;
        }
        else if (a == 12) {
            return 13;
        }
        else if (a == 6) {
            return 7;
        }
        else if (a == 8) {
            return 9;
        }
        else if (a == 11) {
            return 12;
        }
        else if (a == 1) {
            return 1;
        }
        else if (a == 7) {
            return 8;
        }
        else if (a == 10) {
            return 11;
        }
        else if (a == 4) {
            return 5;
        }
        else if (a == 5) {
            return 6;
        }
        else if (a == 9) {
            return 10;
        }
        else if (a == 3) {
            return 4;
        }
        return 2;
    }
    gu(source_, a, b, c) {
        if (this.v != null) {
            this.v.notifySetItem(source_, a, b, c);
        }
        if (this.dataChart != null) {
            this.dataChart.i0(source_, a, b, c);
        }
    }
    gq(source_) {
        if (this.v != null) {
            this.v.notifyClearItems(source_);
        }
        if (this.dataChart != null) {
            this.dataChart.iv(source_);
        }
    }
    gr(source_, a, b) {
        if (this.v != null) {
            this.v.notifyInsertItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.iy(source_, a, b);
        }
    }
    gs(source_, a, b) {
        if (this.v != null) {
            this.v.notifyRemoveItem(source_, a, b);
        }
        if (this.dataChart != null) {
            this.dataChart.iz(source_, a, b);
        }
    }
    hb(a) {
        if (this.seriesAdded != null && a != null) {
            this.seriesAdded(this, new ChartSeriesEventArgs(a));
        }
    }
    hh(a) {
        if (this.seriesRemoved != null && a != null) {
            this.seriesRemoved(this, new ChartSeriesEventArgs(a));
        }
    }
    hd(a, b) {
        if (this.seriesPointerEnter != null && a != null) {
            this.seriesPointerEnter(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    he(a, b) {
        if (this.seriesPointerLeave != null && a != null) {
            this.seriesPointerLeave(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    hf(a, b) {
        if (this.seriesPointerMove != null && a != null) {
            this.seriesPointerMove(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    hc(a, b) {
        if (this.seriesPointerDown != null && a != null) {
            this.seriesPointerDown(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    hg(a, b) {
        if (this.seriesPointerUp != null && a != null) {
            this.seriesPointerUp(this, new DomainChartSeriesPointerEventArgs(a, b));
        }
    }
    g9(a, b) {
        if (this.calloutStyleUpdating != null && a != null) {
            this.calloutStyleUpdating(this, b);
        }
    }
    g7(a) {
        if (!this.b2.contains(a)) {
            this.b2.add(a);
            let b = false;
            let c = this.g8(() => {
                a();
                this.b2.remove(a);
            }, b);
            b = c.p1;
        }
    }
    g8(a, b) {
        if (!b) {
            b = true;
            if (this.di != null) {
                this.di.setTimeout(a, 0);
            }
            else {
                this.a3 = a;
            }
        }
        return {
            p1: b
        };
    }
    get_bv() {
        return true;
    }
    get bv() {
        return this.get_bv();
    }
    ge(a) {
        let b = a == this.dataChart;
        if (b) {
            a.oo = this.j;
        }
        if (b) {
            a.or = this.n;
        }
        a.op = this.l;
        a.oq = this.m;
        a.legend = this.legend;
        a.o6 = this.bq;
        a.o9 = this.bw && this.bv;
        a.seriesMouseEnter = delegateCombine(a.seriesMouseEnter, (c, d) => this.hd(d.series, d.item));
        a.seriesMouseLeave = delegateCombine(a.seriesMouseLeave, (c, d) => this.he(d.series, d.item));
        a.seriesMouseMove = delegateCombine(a.seriesMouseMove, (c, d) => this.hf(d.series, d.item));
        a.seriesMouseLeftButtonDown = delegateCombine(a.seriesMouseLeftButtonDown, (c, d) => this.hc(d.series, d.item));
        a.seriesMouseLeftButtonUp = delegateCombine(a.seriesMouseLeftButtonUp, (c, d) => this.hg(d.series, d.item));
        if (b) {
            a.oi = this.h8;
        }
        if (b) {
            a.hk = this.fd;
        }
        a.m9 = this.hw;
        if (b) {
            a.g8 = this.e2;
        }
        a.m8 = this.hv;
        a.o2 = this.bf;
        a.cw = this.bg;
        a.e7 = this.cs;
        a.fa = this.cv;
        a.fj = this.c5;
        a.e3 = this.cr;
        if (a == this.dataChart) {
            this.hl();
        }
        this.gf(a);
        this.gg(a);
    }
    gk(a, b) {
        if (!isNaN_(this.cu)) {
            a.eu = this.cu;
        }
        a.ey = this.c0;
        if (a.isUsableInLegend) {
            a.legend = this.legend;
        }
        if (typeCast(IUnknownValuePlotting_$type, a) !== null) {
            a.unknownValuePlotting = this.ax;
        }
        a.cu = this.bs;
        if (this.bo(a) && this.ac.isCalloutLayer(a)) {
            this.ac.setCalloutStyleUpdatingEventEnabled(a, this.bi);
            this.ac.addCalloutStyleUpdating(a, runOn(this, this.g9));
        }
        this.f1(a, b);
        this.f2(a, b);
        this.gl(a, b);
        this.gm(a, b);
        this.hb(a);
    }
    get bh() {
        return this.a6;
    }
    f6() {
        if (!this.a6) {
            this.a6 = true;
            this.gb();
        }
    }
    gb() {
        this.gc();
        this.gd();
    }
    hi(a) {
        this.ho(a);
    }
    f2(a, b) {
        let c = typeCast(ITrendLineSeries_$type, a);
        if (c != null) {
            c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
            c.trendLineThickness = this.c6;
            c.trendLineType = this.av;
            c.trendLinePeriod = this.df;
        }
    }
    ai(a, b) {
        if (this.ak == null || this.ak.count == 0) {
            if (this.b3 == null || this.b3.count == 0) {
                return a != null && a.cy ? 1 : 2;
            }
            let c = ArrayExtension.getModulus$1(MarkerType_$type, this.b3, b);
            return c == 2 && a != null && a.cy ? 1 : c;
        }
        return ArrayExtension.getModulus$1(MarkerType_$type, this.ak, b);
    }
    g3(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case "DataChart":
                this.hi(typeCast(XamDataChart.$, b));
                this.ge(typeCast(XamDataChart.$, c));
                break;
            case "ItemsSource":
                this.v.itemsSource = this.itemsSource;
                break;
            case "IncludedProperties":
                this.v.includedProperties = this.d;
                break;
            case "ExcludedProperties":
                this.v.excludedProperties = this.c;
                break;
            case "Brushes":
                this.gz((d) => d.oo = this.j, true, a);
                break;
            case "Outlines":
                this.gz((d) => d.or = this.n, true, a);
                break;
            case "Legend":
                this.gx((d) => d.legend = this.legend);
                break;
            case "IsHorizontalZoomEnabled":
                this.gx((d) => d.o6 = this.bq);
                break;
            case "IsVerticalZoomEnabled":
                this.gx((d) => d.o9 = this.bw);
                break;
            case "WindowRect":
                this.gy((d) => d.oi = this.h8, false);
                break;
            case "Title":
                this.gy((d) => d.hk = this.fd, false);
                break;
            case "Subtitle":
                this.gy((d) => d.g8 = this.e2, false);
                break;
            case "TitleAlignment":
                this.gx((d) => d.m9 = this.hw);
                break;
            case "SubtitleAlignment":
                this.gx((d) => d.m8 = this.hv);
                break;
            case "UnknownValuePlotting":
                this.f8((d) => {
                    if (typeCast(IUnknownValuePlotting_$type, d) !== null) {
                        d.unknownValuePlotting = this.ax;
                    }
                });
                break;
            case "IsSeriesHighlightingEnabled":
                this.f8((d) => d.cu = this.bs);
                break;
            case "Thickness":
                this.f8((d) => d.ey = this.c0);
                break;
            case "Resolution":
                if (!isNaN_(this.cu)) {
                    this.f8((d) => d.eu = this.cu);
                }
                break;
            case "TrendLineBrushes":
            case "TrendLineType":
            case "TrendLineThickness":
            case "TrendLinePeriod":
                this.f9((d, e) => this.f2(d, e));
                break;
            case "MarkerMaxCount":
                this.f9((d, e) => this.f1(d, e));
                break;
            case "MarkerTypes":
                let d = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), b);
                if (d != null) {
                    d.collectionChanged = delegateRemove(d.collectionChanged, runOn(this, this.g2));
                }
                let e = typeCast(ObservableCollection$1.$.specialize(MarkerType_$type), c);
                if (e != null) {
                    e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.g2));
                }
                this.f9((f, g) => this.f1(f, g));
                break;
            case "MarkerBrushes":
                this.gx((f) => f.op = this.l);
                break;
            case "MarkerOutlines":
                this.gx((f) => f.oq = this.m);
                break;
            case "AlignsGridLinesToPixels":
                this.gx((f) => f.o2 = this.bf);
                break;
            case "AnimateSeriesWhenAxisRangeChanges":
                this.gx((f) => f.cw = this.bg);
                break;
            case "ToolTipType":
            case "CrosshairsDisplayMode":
            case "CrosshairsSnapToData":
            case "CrosshairsAnnotationEnabled":
            case "FinalValueAnnotationsVisible":
            case "CalloutsVisible":
            case "CalloutsItemsSource":
            case "CalloutsXMemberPath":
            case "CalloutsYMemberPath":
            case "CalloutsLabelMemberPath":
            case "CalloutsContentMemberPath":
                let f = this.g8(runOn(this, this.f5), this.br);
                this.br = f.p1;
                break;
        }
        this.g4(a, b, c);
        this.g5(a, b, c);
    }
    g2(a, b) {
        this.f9((c, d) => this.f1(c, d));
    }
    get itemsSource() {
        return this.b8;
    }
    set itemsSource(a) {
        let b = this.itemsSource;
        if (b != a) {
            this.b8 = a;
            this.g3("ItemsSource", b, this.itemsSource);
        }
    }
    get d() {
        return this.b;
    }
    set d(a) {
        let b = this.b;
        this.b = a;
        if (b != this.b) {
            this.g3("IncludedProperties", b, this.b);
        }
    }
    get c() {
        return this.a;
    }
    set c(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.g3("ExcludedProperties", b, this.a);
        }
    }
    get j() {
        return this.e;
    }
    set j(a) {
        let b = this.j;
        if (a != b) {
            this.e = a;
            this.g3("Brushes", b, this.j);
        }
    }
    get n() {
        return this.h;
    }
    set n(a) {
        let b = this.n;
        if (a != b) {
            this.h = a;
            this.g3("Outlines", b, this.n);
        }
    }
    get legend() {
        return this.ad;
    }
    set legend(a) {
        let b = this.legend;
        if (a != b) {
            this.ad = a;
            this.g3("Legend", b, this.legend);
        }
    }
    get_bq() {
        return this.bc;
    }
    set_bq(a) {
        let b = this.bq;
        if (a != b) {
            this.bc = a;
            this.g3("IsHorizontalZoomEnabled", b, this.bq);
        }
    }
    get bq() {
        return this.get_bq();
    }
    set bq(a) {
        this.set_bq(a);
    }
    get_bw() {
        return this.be;
    }
    set_bw(a) {
        let b = this.bw;
        if (a != b) {
            this.be = a;
            this.g3("IsVerticalZoomEnabled", b, this.bw);
        }
    }
    get bw() {
        return this.get_bw();
    }
    set bw(a) {
        this.set_bw(a);
    }
    get_bs() {
        return this.bd;
    }
    set_bs(a) {
        let b = this.bs;
        if (a != b) {
            this.bd = a;
            this.g3("IsSeriesHighlightingEnabled", b, this.bs);
        }
    }
    get bs() {
        return this.get_bs();
    }
    set bs(a) {
        this.set_bs(a);
    }
    get h8() {
        return this.h6;
    }
    set h8(a) {
        let b = this.h8;
        if (Rect.l_op_Inequality(a, b)) {
            this.h6 = a;
            this.g3("WindowRect", b, this.h8);
        }
    }
    get h7() {
        return this.dataChart != null ? this.dataChart.oh : Rect.empty;
    }
    get fd() {
        return this.dx;
    }
    set fd(a) {
        let b = this.fd;
        if (a != b) {
            this.dx = a;
            this.g3("Title", b, this.fd);
        }
    }
    get e2() {
        return this.dv;
    }
    set e2(a) {
        let b = this.e2;
        if (a != b) {
            this.dv = a;
            this.g3("Subtitle", b, this.e2);
        }
    }
    get hw() {
        return this.hu;
    }
    set hw(a) {
        let b = this.hw;
        if (b != a) {
            this.hu = a;
            this.g3("TitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hw));
        }
    }
    get hv() {
        return this.ht;
    }
    set hv(a) {
        let b = this.hv;
        if (b != a) {
            this.ht = a;
            this.g3("SubtitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.hv));
        }
    }
    get ax() {
        return this.aw;
    }
    set ax(a) {
        let b = this.ax;
        if (a != b) {
            this.aw = a;
            this.g3("UnknownValuePlotting", enumGetBox(UnknownValuePlotting_$type, b), enumGetBox(UnknownValuePlotting_$type, this.ax));
        }
    }
    get_cu() {
        return this.ce;
    }
    set_cu(a) {
        let b = this.cu;
        if (a != b) {
            this.ce = a;
            this.g3("Resolution", b, this.cu);
        }
    }
    get cu() {
        return this.get_cu();
    }
    set cu(a) {
        this.set_cu(a);
    }
    get c0() {
        return this.ck;
    }
    set c0(a) {
        let b = this.c0;
        if (a != b) {
            this.ck = a;
            this.g3("Thickness", b, this.c0);
        }
    }
    get ak() {
        return this.aj;
    }
    set ak(a) {
        let b = this.ak;
        if (a != b) {
            this.aj = a;
            this.g3("MarkerTypes", b, this.ak);
        }
    }
    get l() {
        return this.f;
    }
    set l(a) {
        let b = this.l;
        if (a != b) {
            this.f = a;
            this.g3("MarkerBrushes", b, this.l);
        }
    }
    get m() {
        return this.g;
    }
    set m(a) {
        let b = this.m;
        if (!Base.equalsStatic(a, b)) {
            this.g = a;
            this.g3("MarkerOutlines", b, this.m);
        }
    }
    get dd() {
        return this.c9;
    }
    set dd(a) {
        let b = this.c9;
        if (a != b) {
            this.c9 = a;
            this.g3("MarkerMaxCount", b, this.c9);
        }
    }
    get bg() {
        return this.a5;
    }
    set bg(a) {
        let b = this.a5;
        if (a != b) {
            this.a5 = a;
            this.g3("AnimateSeriesWhenAxisRangeChanges", b, this.a5);
        }
    }
    get o() {
        return this.i;
    }
    set o(a) {
        let b = this.o;
        if (a != b) {
            this.i = a;
            this.g3("TrendLineBrushes", b, this.o);
        }
    }
    get av() {
        return this.au;
    }
    set av(a) {
        let b = this.av;
        if (a != b) {
            this.au = a;
            this.g3("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.av));
        }
    }
    get c6() {
        return this.cq;
    }
    set c6(a) {
        let b = this.c6;
        if (a != b) {
            this.cq = a;
            this.g3("TrendLineThickness", b, this.c6);
        }
    }
    get bf() {
        return this.a4;
    }
    set bf(a) {
        let b = this.bf;
        if (a != b) {
            this.a4 = a;
            this.g3("AlignsGridLinesToPixels", b, this.bf);
        }
    }
    get df() {
        return this.dc;
    }
    set df(a) {
        let b = this.df;
        if (a != b) {
            this.dc = a;
            this.g3("TrendLinePeriod", b, this.df);
        }
    }
    get at() {
        return this.as;
    }
    set at(a) {
        let b = this.at;
        if (a != b) {
            this.as = a;
            this.g3("ToolTipType", enumGetBox(ToolTipType_$type, b), enumGetBox(ToolTipType_$type, this.at));
        }
    }
    get t() {
        return this.s;
    }
    set t(a) {
        let b = this.t;
        if (a != b) {
            this.s = a;
            this.g3("CrosshairsDisplayMode", enumGetBox(CrosshairsDisplayMode_$type, b), enumGetBox(CrosshairsDisplayMode_$type, this.t));
        }
    }
    get bl() {
        return this.ba;
    }
    set bl(a) {
        let b = this.bl;
        if (a != b) {
            this.ba = a;
            this.g3("CrosshairsSnapToData", b, this.bl);
        }
    }
    get bk() {
        return this.a9;
    }
    set bk(a) {
        let b = this.bk;
        if (a != b) {
            this.a9 = a;
            this.g3("CrosshairsAnnotationEnabled", b, this.bk);
        }
    }
    get bm() {
        return this.bb;
    }
    set bm(a) {
        let b = this.bm;
        if (a != b) {
            this.bb = a;
            this.g3("FinalValueAnnotationsVisible", b, this.bm);
        }
    }
    get bj() {
        return this.a8;
    }
    set bj(a) {
        let b = this.bj;
        if (a != b) {
            this.a8 = a;
            this.g3("CalloutsVisible", b, this.bj);
        }
    }
    get bi() {
        return this.a7;
    }
    set bi(a) {
        let b = this.bi;
        if (a != b) {
            this.a7 = a;
            this.g3("CalloutStyleUpdatingEventEnabled", b, this.bi);
        }
    }
    get calloutsItemsSource() {
        return this.b7;
    }
    set calloutsItemsSource(a) {
        let b = this.calloutsItemsSource;
        if (a != b) {
            this.b7 = a;
            this.g3("CalloutsItemsSource", b, this.calloutsItemsSource);
        }
    }
    get ea() {
        return this.dt;
    }
    set ea(a) {
        let b = this.ea;
        if (a != b) {
            this.dt = a;
            this.g3("CalloutsXMemberPath", b, this.ea);
        }
    }
    get ec() {
        return this.du;
    }
    set ec(a) {
        let b = this.ec;
        if (a != b) {
            this.du = a;
            this.g3("CalloutsYMemberPath", b, this.ec);
        }
    }
    get d6() {
        return this.ds;
    }
    set d6(a) {
        let b = this.d6;
        if (a != b) {
            this.ds = a;
            this.g3("CalloutsLabelMemberPath", b, this.d6);
        }
    }
    get d3() {
        return this.dr;
    }
    set d3(a) {
        let b = this.d3;
        if (a != b) {
            this.dr = a;
            this.g3("CalloutsContentMemberPath", b, this.d3);
        }
    }
}
DomainChart.$t = markType(DomainChart, 'DomainChart', Base.$, [INotifyPropertyChanged_$type]);
DomainChart.dq = new Random(0);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class XYChart extends DomainChart {
    constructor() {
        super(...arguments);
        this.ig = null;
        this.ih = null;
        this.iu = 0;
        this.iw = 5;
        this.iv = 0;
        this.it = 5;
        this.jb = 5;
        this.jd = 0;
        this.jc = 5;
        this.ja = 0;
        this.nx = null;
        this.n4 = null;
        this.i5 = 0;
        this.jm = 0;
        this.i4 = NaN;
        this.jl = NaN;
        this.i7 = NaN;
        this.jo = NaN;
        this.i6 = NaN;
        this.jn = NaN;
        this.i3 = NaN;
        this.jk = NaN;
        this.n3 = null;
        this.oa = null;
        this.kw = null;
        this.k0 = null;
        this.ky = null;
        this.k2 = null;
        this.kr = null;
        this.ks = null;
        this.ny = null;
        this.n5 = null;
        this.ix = 1;
        this.je = 1;
        this.iy = 1;
        this.jf = 0;
        this.n0 = null;
        this.n7 = null;
        this.n1 = null;
        this.n8 = null;
        this.iz = 1;
        this.jg = 1;
        this.i0 = 5;
        this.jh = 0;
        this.n2 = null;
        this.n9 = null;
        this.i1 = 2;
        this.ji = 2;
        this.kx = null;
        this.k1 = null;
        this.nz = null;
        this.n6 = null;
        this.is = 0;
        this.i9 = 0;
        this.ir = NaN;
        this.i8 = NaN;
        this.i2 = 0;
        this.jj = -90;
        this.im = false;
        this.io = false;
        this.ns = 1;
        this.or = 1;
        this.nr = 1;
        this.nt = 2;
        this.op = 0;
        this.oq = 1;
        this.ov = 0;
        this.ow = 0;
        this.ik = 2;
        this.kv = null;
        this.h9 = null;
        this.kz = null;
        this.ia = null;
    }
    provideContainer(a) {
        if (a != null) {
            let b = this.id();
            let c = this.ie();
            if (b != null) {
                b.provideRenderer(a);
            }
            if (c != null) {
                c.provideRenderer(a);
            }
        }
        super.provideContainer(a);
    }
    gj() {
        super.gj();
        let a = this.id();
        let b = this.ie();
        if (a != null && a.ay != null) {
            this.ob = a.ay.textColor;
        }
        if (b != null && b.ay != null) {
            this.oi = b.ay.textColor;
        }
    }
    g4(a, b, c) {
        super.g4(a, b, c);
        switch (a) {
            case "XAxisLabelLeftMargin":
                this.nl((d) => d.leftMargin = this.jw);
                break;
            case "XAxisLabelTopMargin":
                this.nl((d) => d.topMargin = this.jy);
                break;
            case "XAxisLabelRightMargin":
                this.nl((d) => d.rightMargin = this.jx);
                break;
            case "XAxisLabelBottomMargin":
                this.nl((d) => d.bottomMargin = this.jv);
                break;
            case "YAxisLabelLeftMargin":
                this.np((d) => d.leftMargin = this.kd);
                break;
            case "YAxisLabelTopMargin":
                this.np((d) => d.topMargin = this.kf);
                break;
            case "YAxisLabelRightMargin":
                this.np((d) => d.rightMargin = this.ke);
                break;
            case "YAxisLabelBottomMargin":
                this.np((d) => d.bottomMargin = this.kc);
                break;
            case "XAxisLabelTextColor":
                this.nl((d) => d.textColor = this.ob);
                break;
            case "YAxisLabelTextColor":
                this.np((d) => d.textColor = this.oi);
                break;
            case "XAxisTitleMargin":
                this.nm((d) => d.margin = this.j7);
                break;
            case "YAxisTitleMargin":
                this.nq((d) => d.margin = this.ko);
                break;
            case "XAxisTitleLeftMargin":
                this.nm((d) => d.leftMargin = this.j6);
                break;
            case "YAxisTitleLeftMargin":
                this.nq((d) => d.leftMargin = this.kn);
                break;
            case "XAxisTitleTopMargin":
                this.nm((d) => d.topMargin = this.j9);
                break;
            case "YAxisTitleTopMargin":
                this.nq((d) => d.topMargin = this.kq);
                break;
            case "XAxisTitleRightMargin":
                this.nm((d) => d.rightMargin = this.j8);
                break;
            case "YAxisTitleRightMargin":
                this.nq((d) => d.rightMargin = this.kp);
                break;
            case "XAxisTitleBottomMargin":
                this.nm((d) => d.bottomMargin = this.j5);
                break;
            case "YAxisTitleBottomMargin":
                this.nq((d) => d.bottomMargin = this.km);
                break;
            case "XAxisTitleTextColor":
                this.nm((d) => d.textColor = this.oh);
                break;
            case "YAxisTitleTextColor":
                this.nq((d) => d.textColor = this.oo);
                break;
            case "XAxisFormatLabel":
                this.nj((d) => d.at = this.ii);
                break;
            case "YAxisFormatLabel":
                this.nn((d) => d.at = this.ij);
                break;
        }
    }
    get ii() {
        return this.ig;
    }
    set ii(a) {
        let b = this.ii;
        if (a != b) {
            this.ig = a;
            this.g3("XAxisFormatLabel", b, this.ii);
        }
    }
    get ij() {
        return this.ih;
    }
    set ij(a) {
        let b = this.ij;
        if (a != b) {
            this.ih = a;
            this.g3("YAxisFormatLabel", b, this.ij);
        }
    }
    get jw() {
        return this.iu;
    }
    set jw(a) {
        let b = this.jw;
        if (a != b) {
            this.iu = a;
            this.g3("XAxisLabelLeftMargin", b, this.jw);
        }
    }
    get jy() {
        return this.iw;
    }
    set jy(a) {
        let b = this.jy;
        if (a != b) {
            this.iw = a;
            this.g3("XAxisLabelTopMargin", b, this.jy);
        }
    }
    get jx() {
        return this.iv;
    }
    set jx(a) {
        let b = this.jx;
        if (a != b) {
            this.iv = a;
            this.g3("XAxisLabelRightMargin", b, this.jx);
        }
    }
    get jv() {
        return this.it;
    }
    set jv(a) {
        let b = this.jv;
        if (a != b) {
            this.it = a;
            this.g3("XAxisLabelBottomMargin", b, this.jv);
        }
    }
    get kd() {
        return this.jb;
    }
    set kd(a) {
        let b = this.kd;
        if (a != b) {
            this.jb = a;
            this.g3("YAxisLabelLeftMargin", b, this.kd);
        }
    }
    get kf() {
        return this.jd;
    }
    set kf(a) {
        let b = this.kf;
        if (a != b) {
            this.jd = a;
            this.g3("YAxisLabelTopMargin", b, this.kf);
        }
    }
    get ke() {
        return this.jc;
    }
    set ke(a) {
        let b = this.ke;
        if (a != b) {
            this.jc = a;
            this.g3("YAxisLabelRightMargin", b, this.ke);
        }
    }
    get kc() {
        return this.ja;
    }
    set kc(a) {
        let b = this.kc;
        if (a != b) {
            this.ja = a;
            this.g3("YAxisLabelBottomMargin", b, this.kc);
        }
    }
    get ob() {
        return this.nx;
    }
    set ob(a) {
        let b = this.ob;
        if (a != b) {
            this.nx = a;
            this.g3("XAxisLabelTextColor", b, this.ob);
        }
    }
    get oi() {
        return this.n4;
    }
    set oi(a) {
        let b = this.oi;
        if (a != b) {
            this.n4 = a;
            this.g3("YAxisLabelTextColor", b, this.oi);
        }
    }
    get j7() {
        return this.i5;
    }
    set j7(a) {
        let b = this.j7;
        if (a != b) {
            this.i5 = a;
            this.g3("XAxisTitleMargin", b, this.j7);
        }
    }
    get ko() {
        return this.jm;
    }
    set ko(a) {
        let b = this.ko;
        if (a != b) {
            this.jm = a;
            this.g3("YAxisTitleMargin", b, this.ko);
        }
    }
    get j6() {
        return this.i4;
    }
    set j6(a) {
        let b = this.j6;
        if (a != b) {
            this.i4 = a;
            this.g3("XAxisTitleLeftMargin", b, this.j6);
        }
    }
    get kn() {
        return this.jl;
    }
    set kn(a) {
        let b = this.kn;
        if (a != b) {
            this.jl = a;
            this.g3("YAxisTitleLeftMargin", b, this.kn);
        }
    }
    get j9() {
        return this.i7;
    }
    set j9(a) {
        let b = this.j9;
        if (a != b) {
            this.i7 = a;
            this.g3("XAxisTitleTopMargin", b, this.j9);
        }
    }
    get kq() {
        return this.jo;
    }
    set kq(a) {
        let b = this.kq;
        if (a != b) {
            this.jo = a;
            this.g3("YAxisTitleTopMargin", b, this.kq);
        }
    }
    get j8() {
        return this.i6;
    }
    set j8(a) {
        let b = this.j8;
        if (a != b) {
            this.i6 = a;
            this.g3("XAxisTitleRightMargin", b, this.j8);
        }
    }
    get kp() {
        return this.jn;
    }
    set kp(a) {
        let b = this.kp;
        if (a != b) {
            this.jn = a;
            this.g3("YAxisTitleRightMargin", b, this.kp);
        }
    }
    get j5() {
        return this.i3;
    }
    set j5(a) {
        let b = this.j5;
        if (a != b) {
            this.i3 = a;
            this.g3("XAxisTitleBottomMargin", b, this.j5);
        }
    }
    get km() {
        return this.jk;
    }
    set km(a) {
        let b = this.km;
        if (a != b) {
            this.jk = a;
            this.g3("YAxisTitleBottomMargin", b, this.km);
        }
    }
    get oh() {
        return this.n3;
    }
    set oh(a) {
        let b = this.oh;
        if (a != b) {
            this.n3 = a;
            this.g3("XAxisTitleTextColor", b, this.oh);
        }
    }
    get oo() {
        return this.oa;
    }
    set oo(a) {
        let b = this.oo;
        if (a != b) {
            this.oa = a;
            this.g3("YAxisTitleTextColor", b, this.oo);
        }
    }
    g5(a, b, c) {
        super.g5(a, b, c);
        switch (a) {
            case "XAxisLabelTextStyle":
                this.nl((d) => d.textStyle = this.lh);
                break;
            case "YAxisLabelTextStyle":
                this.np((d) => d.textStyle = this.mm);
                break;
            case "XAxisTitleTextStyle":
                this.nm((d) => d.textStyle = this.l5);
                break;
            case "YAxisTitleTextStyle":
                this.nq((d) => d.textStyle = this.na);
                break;
        }
    }
    get lh() {
        return this.kw;
    }
    set lh(a) {
        let b = this.lh;
        if (a != b) {
            this.kw = a;
            this.g3("XAxisLabelTextStyle", b, this.lh);
        }
    }
    get mm() {
        return this.k0;
    }
    set mm(a) {
        let b = this.mm;
        if (a != b) {
            this.k0 = a;
            this.g3("YAxisLabelTextStyle", b, this.mm);
        }
    }
    get l5() {
        return this.ky;
    }
    set l5(a) {
        let b = this.l5;
        if (a != b) {
            this.ky = a;
            this.g3("XAxisTitleTextStyle", b, this.l5);
        }
    }
    get na() {
        return this.k2;
    }
    set na(a) {
        let b = this.na;
        if (a != b) {
            this.k2 = a;
            this.g3("YAxisTitleTextStyle", b, this.na);
        }
    }
    ng(a) {
        this.nd(a, (b) => b.leftMargin = this.jw);
        this.nd(a, (b) => b.topMargin = this.jy);
        this.nd(a, (b) => b.rightMargin = this.jx);
        this.nd(a, (b) => b.bottomMargin = this.jv);
        this.nd(a, (b) => b.textColor = this.ob);
        this.ne(a, (b) => b.textColor = this.oh);
        this.ne(a, (b) => b.leftMargin = this.j6);
        this.ne(a, (b) => b.topMargin = this.j9);
        this.ne(a, (b) => b.rightMargin = this.j8);
        this.ne(a, (b) => b.bottomMargin = this.j5);
        this.nd(a, (b) => b.textStyle = this.lh);
        this.ne(a, (b) => b.textStyle = this.l5);
    }
    ni(a) {
        this.nd(a, (b) => b.leftMargin = this.kd);
        this.nd(a, (b) => b.topMargin = this.kf);
        this.nd(a, (b) => b.rightMargin = this.ke);
        this.nd(a, (b) => b.bottomMargin = this.kc);
        this.nd(a, (b) => b.textColor = this.oi);
        this.ne(a, (b) => b.textColor = this.oo);
        this.ne(a, (b) => b.leftMargin = this.kn);
        this.ne(a, (b) => b.topMargin = this.kq);
        this.ne(a, (b) => b.rightMargin = this.kp);
        this.ne(a, (b) => b.bottomMargin = this.km);
        this.nd(a, (b) => b.textStyle = this.mm);
        this.ne(a, (b) => b.textStyle = this.na);
    }
    hk(a) {
        let b = this.u(a);
        let c = this.aq(a, b);
        if (c == null) {
            return;
        }
        c.itemsSource = a.data;
        c.name = this.el(a);
        c.fx = this.em(a, b);
        this.dataChart.series.add(c);
    }
    nj(a) {
        this.nk(a, null);
    }
    nk(a, b) {
        a(this.id());
    }
    no(a, b) {
        a(this.ie());
    }
    nn(a) {
        this.no(a, true);
    }
    nm(a) {
        this.ne(this.id(), a);
    }
    nq(a) {
        this.ne(this.ie(), a);
    }
    np(a) {
        this.nd(this.ie(), a);
    }
    nl(a) {
        this.nd(this.id(), a);
    }
    jp(a) {
        let b = this.id();
        return b.dy(a, new ScalerParams(1, this.h8, this.h7, b.ca));
    }
    jr(a) {
        let b = this.id();
        return b.d1(a, new ScalerParams(1, this.h8, this.h7, b.ca));
    }
    jq(a) {
        let b = this.ie();
        return b.dy(a, new ScalerParams(1, this.h8, this.h7, b.ca));
    }
    js(a) {
        let b = this.ie();
        return b.d1(a, new ScalerParams(1, this.h8, this.h7, b.ca));
    }
    hi(a) {
        super.hi(a);
        if (a == null) {
            return;
        }
        if (a.axes != null) {
            let b = this.id();
            let c = this.ie();
            if (a.axes.contains(b)) {
                a.axes.remove(b);
            }
            if (a.axes.contains(c)) {
                a.axes.remove(c);
            }
        }
    }
    static k3(a, b) {
        for (let c of fromEnum(b)) {
            let d = c.findMatchingHint(16);
            if (d != null) {
                let e = d.path;
                return e;
            }
        }
        return null;
    }
    ge(a) {
        super.ge(a);
        if (a == this.dataChart) {
            this.dataChart.axes.add(this.id());
            this.dataChart.axes.add(this.ie());
        }
    }
    nf(a) {
        if (a != null && this.di != null && a.eu == null) {
            a.provideRenderer(this.di);
        }
        a.is = this.oc;
        a.d5 = this.jz;
        a.it = this.od;
        a.d8 = this.j0;
        a.iv = this.of;
        a.ep = this.j1;
        a.iu = this.oe;
        a.eq = this.j2;
        a.iw = this.og;
        a.er = this.j3;
        a.cq = true;
        let b = a == this.id();
        if (b) {
            a.gc = this.lw;
        }
        a.e9 = this.kt;
        a.fo = this.k9;
        a.ag = this.ib;
        this.nd(a, (c) => c.angle = this.ju);
        this.nd(a, (c) => {
            if (c.extent != this.jt) {
                c.extent = this.jt;
            }
        });
        this.nd(a, (c) => c.horizontalAlignment = this.nu);
        this.nd(a, (c) => c.verticalAlignment = this.os);
        this.nd(a, (c) => c.visibility = this.ox);
        this.ne(a, (c) => c.horizontalAlignment = this.nv);
        this.ne(a, (c) => c.angle = this.j4);
        this.ng(a);
    }
    nh(a) {
        if (a == null) {
            return;
        }
        if (this.di != null && a.eu == null) {
            a.provideRenderer(this.di);
        }
        this.nd(a, (b) => b.angle = this.kb);
        this.nd(a, (b) => {
            if (b.extent != this.ka) {
                b.extent = this.ka;
            }
        });
        this.nd(a, (b) => b.horizontalAlignment = this.nw);
        this.nd(a, (b) => b.verticalAlignment = this.ot);
        this.nd(a, (b) => b.visibility = this.oy);
        this.nd(a, (b) => b.location = this.il);
        this.ne(a, (b) => b.verticalAlignment = this.ou);
        this.ne(a, (b) => b.angle = this.kl);
        a.is = this.oj;
        a.d5 = this.kg;
        a.it = this.ok;
        a.d8 = this.kh;
        a.iv = this.om;
        a.ep = this.ki;
        a.iu = this.ol;
        a.eq = this.kj;
        a.iw = this.on;
        a.er = this.kk;
        let b = a == this.ie();
        if (b) {
            a.gc = this.m1;
        }
        a.fo = this.md;
        a.ag = this.ic;
        this.ni(a);
    }
    gb() {
        super.gb();
        this.nf(this.id());
        this.nh(this.ie());
    }
    nd(a, b) {
        if (a == null) {
            return;
        }
        if (a.ay == null) {
            a.ay = new AxisLabelSettings();
            a.ay.angle = a.dm();
            a.ay.bottomMargin = a.dn();
            a.ay.leftMargin = a.dp();
            a.ay.rightMargin = a.dq();
            a.ay.topMargin = a.dr();
            a.ay.horizontalAlignment = a.im();
            a.ay.location = a.az();
            a.ay.verticalAlignment = a.jg();
        }
        b(a.ay);
    }
    ne(a, b) {
        if (a == null) {
            return;
        }
        if (a.be == null) {
            a.be = new TitleSettings();
            a.be.bottomMargin = a.dt();
            a.be.leftMargin = a.du();
            a.be.rightMargin = a.dv();
            a.be.topMargin = a.dw();
            a.be.location = a.a0();
            a.be.angle = a.ds();
            a.be.horizontalAlignment = a.io();
            a.be.verticalAlignment = a.jh();
        }
        b(a.be);
    }
    g3(a, b, c) {
        super.g3(a, b, c);
        switch (a) {
            case "XAxisLabelAngle":
                this.nl((d) => d.angle = this.ju);
                break;
            case "YAxisLabelAngle":
                this.np((d) => d.angle = this.kb);
                break;
            case "XAxisLabelHorizontalAlignment":
                this.nl((d) => d.horizontalAlignment = this.nu);
                break;
            case "YAxisLabelHorizontalAlignment":
                this.np((d) => d.horizontalAlignment = this.nw);
                break;
            case "XAxisLabelVerticalAlignment":
                this.nl((d) => d.verticalAlignment = this.os);
                break;
            case "YAxisLabelVerticalAlignment":
                this.np((d) => d.verticalAlignment = this.ot);
                break;
            case "XAxisLabelVisibility":
                this.nl((d) => d.visibility = this.ox);
                break;
            case "YAxisLabelVisibility":
                this.np((d) => d.visibility = this.oy);
                break;
            case "XAxisLabel":
                this.nj((d) => d.e9 = this.kt);
                break;
            case "YAxisLabel":
                this.nn((d) => d.e9 = this.ku);
                break;
            case "XAxisLabelFormat":
                this.nj((d) => d.fo = this.k9);
                break;
            case "XAxisLabelFormatSpecifiers":
                this.nj((d) => d.ag = this.ib);
                break;
            case "YAxisLabelFormat":
                this.nn((d) => d.fo = this.md);
                break;
            case "YAxisLabelFormatSpecifiers":
                this.nn((d) => d.ag = this.ic);
                break;
            case "XAxisTitleAngle":
                this.nm((d) => d.angle = this.j4);
                break;
            case "YAxisTitleAngle":
                this.nq((d) => d.angle = this.kl);
                break;
            case "XAxisTitleAlignment":
                this.nm((d) => d.horizontalAlignment = this.nv);
                break;
            case "YAxisTitleAlignment":
                this.nq((d) => d.verticalAlignment = this.ou);
                break;
            case "XAxisTitle":
                this.nj((d) => d.gc = this.lw);
                break;
            case "YAxisTitle":
                this.no((d) => d.gc = this.m1, false);
                break;
            case "XAxisMajorStroke":
                this.nk((d) => d.is = this.oc, a);
                break;
            case "YAxisMajorStroke":
                this.nn((d) => d.is = this.oj);
                break;
            case "XAxisMajorStrokeThickness":
                this.nk((d) => d.d5 = this.jz, a);
                break;
            case "YAxisMajorStrokeThickness":
                this.nn((d) => d.d5 = this.kg);
                break;
            case "XAxisMinorStroke":
                this.nj((d) => d.it = this.od);
                break;
            case "YAxisMinorStroke":
                this.nn((d) => d.it = this.ok);
                break;
            case "XAxisMinorStrokeThickness":
                this.nj((d) => d.d8 = this.j0);
                break;
            case "YAxisMinorStrokeThickness":
                this.nn((d) => d.d8 = this.kh);
                break;
            case "XAxisTickLength":
                this.nj((d) => d.eq = this.j2);
                break;
            case "YAxisTickLength":
                this.nn((d) => d.eq = this.kj);
                break;
            case "XAxisTickStroke":
                this.nj((d) => d.iw = this.og);
                break;
            case "YAxisTickStroke":
                this.nn((d) => d.iw = this.on);
                break;
            case "XAxisTickStrokeThickness":
                this.nj((d) => d.er = this.j3);
                break;
            case "YAxisTickStrokeThickness":
                this.nn((d) => d.er = this.kk);
                break;
            case "XAxisStroke":
                this.nj((d) => d.iv = this.of);
                break;
            case "YAxisStroke":
                this.nn((d) => d.iv = this.om);
                break;
            case "XAxisStrokeThickness":
                this.nj((d) => d.ep = this.j1);
                break;
            case "YAxisStrokeThickness":
                this.nn((d) => d.ep = this.ki);
                break;
            case "XAxisExtent":
                this.nl((d) => d.extent = this.jt);
                break;
            case "YAxisExtent":
                this.np((d) => d.extent = this.ka);
                break;
            case "XAxisStrip":
                this.nj((d) => d.iu = this.oe);
                break;
            case "YAxisStrip":
                this.nn((d) => d.iu = this.ol);
                break;
            case "XAxisInverted":
                this.nj((d) => d.ca = this.ip);
                break;
            case "YAxisInverted":
                this.nn((d) => d.ca = this.iq);
                break;
            case "YAxisLabelLocation":
                this.np((d) => d.location = this.il);
                break;
        }
    }
    get kt() {
        return this.kr;
    }
    set kt(a) {
        let b = this.kt;
        if (a != b) {
            this.kr = a;
            this.g3("XAxisLabel", b, this.kt);
        }
    }
    get ku() {
        return this.ks;
    }
    set ku(a) {
        let b = this.ku;
        if (a != b) {
            this.ks = a;
            this.g3("YAxisLabel", b, this.ku);
        }
    }
    get oc() {
        return this.ny;
    }
    set oc(a) {
        let b = this.oc;
        if (a != b) {
            this.ny = a;
            this.g3("XAxisMajorStroke", b, this.oc);
        }
    }
    get oj() {
        return this.n5;
    }
    set oj(a) {
        let b = this.oj;
        if (a != b) {
            this.n5 = a;
            this.g3("YAxisMajorStroke", b, this.oj);
        }
    }
    get jz() {
        return this.ix;
    }
    set jz(a) {
        let b = this.jz;
        if (a != b) {
            this.ix = a;
            this.g3("XAxisMajorStrokeThickness", b, this.jz);
        }
    }
    get kg() {
        return this.je;
    }
    set kg(a) {
        let b = this.kg;
        if (a != b) {
            this.je = a;
            this.g3("YAxisMajorStrokeThickness", b, this.kg);
        }
    }
    get j0() {
        return this.iy;
    }
    set j0(a) {
        let b = this.j0;
        if (a != b) {
            this.iy = a;
            this.g3("XAxisMinorStrokeThickness", b, this.j0);
        }
    }
    get kh() {
        return this.jf;
    }
    set kh(a) {
        let b = this.kh;
        if (a != b) {
            this.jf = a;
            this.g3("YAxisMinorStrokeThickness", b, this.kh);
        }
    }
    get oe() {
        return this.n0;
    }
    set oe(a) {
        let b = this.oe;
        if (a != b) {
            this.n0 = a;
            this.g3("XAxisStrip", b, this.oe);
        }
    }
    get ol() {
        return this.n7;
    }
    set ol(a) {
        let b = this.ol;
        if (a != b) {
            this.n7 = a;
            this.g3("YAxisStrip", b, this.ol);
        }
    }
    get of() {
        return this.n1;
    }
    set of(a) {
        let b = this.of;
        if (a != b) {
            this.n1 = a;
            this.g3("XAxisStroke", b, this.of);
        }
    }
    get om() {
        return this.n8;
    }
    set om(a) {
        let b = this.om;
        if (a != b) {
            this.n8 = a;
            this.g3("YAxisStroke", b, this.om);
        }
    }
    get j1() {
        return this.iz;
    }
    set j1(a) {
        let b = this.j1;
        if (a != b) {
            this.iz = a;
            this.g3("XAxisStrokeThickness", b, this.j1);
        }
    }
    get ki() {
        return this.jg;
    }
    set ki(a) {
        let b = this.ki;
        if (a != b) {
            this.jg = a;
            this.g3("YAxisStrokeThickness", b, this.ki);
        }
    }
    get j2() {
        return this.i0;
    }
    set j2(a) {
        let b = this.j2;
        if (a != b) {
            this.i0 = a;
            this.g3("XAxisTickLength", b, this.j2);
        }
    }
    get kj() {
        return this.jh;
    }
    set kj(a) {
        let b = this.kj;
        if (a != b) {
            this.jh = a;
            this.g3("YAxisTickLength", b, this.kj);
        }
    }
    get og() {
        return this.n2;
    }
    set og(a) {
        let b = this.og;
        if (a != b) {
            this.n2 = a;
            this.g3("XAxisTickStroke", b, this.og);
        }
    }
    get on() {
        return this.n9;
    }
    set on(a) {
        let b = this.on;
        if (a != b) {
            this.n9 = a;
            this.g3("YAxisTickStroke", b, this.on);
        }
    }
    get j3() {
        return this.i1;
    }
    set j3(a) {
        let b = this.j3;
        if (a != b) {
            this.i1 = a;
            this.g3("XAxisTickStrokeThickness", b, this.j3);
        }
    }
    get kk() {
        return this.ji;
    }
    set kk(a) {
        let b = this.kk;
        if (a != b) {
            this.ji = a;
            this.g3("YAxisTickStrokeThickness", b, this.kk);
        }
    }
    get lw() {
        return this.kx;
    }
    set lw(a) {
        let b = this.lw;
        if (a != b) {
            this.kx = a;
            this.g3("XAxisTitle", b, this.lw);
        }
    }
    get m1() {
        return this.k1;
    }
    set m1(a) {
        let b = this.m1;
        if (a != b) {
            this.k1 = a;
            this.g3("YAxisTitle", b, this.m1);
        }
    }
    get od() {
        return this.nz;
    }
    set od(a) {
        let b = this.od;
        if (a != b) {
            this.nz = a;
            this.g3("XAxisMinorStroke", b, this.od);
        }
    }
    get ok() {
        return this.n6;
    }
    set ok(a) {
        let b = this.ok;
        if (a != b) {
            this.n6 = a;
            this.g3("YAxisMinorStroke", b, this.ok);
        }
    }
    get ju() {
        return this.is;
    }
    set ju(a) {
        let b = this.ju;
        if (a != b) {
            this.is = a;
            this.g3("XAxisLabelAngle", b, this.ju);
        }
    }
    get kb() {
        return this.i9;
    }
    set kb(a) {
        let b = this.kb;
        if (a != b) {
            this.i9 = a;
            this.g3("YAxisLabelAngle", b, this.kb);
        }
    }
    get jt() {
        return this.ir;
    }
    set jt(a) {
        let b = this.jt;
        if (a != b) {
            this.ir = a;
            this.g3("XAxisExtent", b, this.jt);
        }
    }
    get ka() {
        return this.i8;
    }
    set ka(a) {
        let b = this.ka;
        if (a != b) {
            this.i8 = a;
            this.g3("YAxisExtent", b, this.ka);
        }
    }
    get j4() {
        return this.i2;
    }
    set j4(a) {
        let b = this.j4;
        if (a != b) {
            this.i2 = a;
            this.g3("XAxisTitleAngle", b, this.j4);
        }
    }
    get kl() {
        return this.jj;
    }
    set kl(a) {
        let b = this.kl;
        if (a != b) {
            this.jj = a;
            this.g3("YAxisTitleAngle", b, this.kl);
        }
    }
    get ip() {
        return this.im;
    }
    set ip(a) {
        let b = this.ip;
        if (a != b) {
            this.im = a;
            this.g3("XAxisInverted", b, this.ip);
        }
    }
    get iq() {
        return this.io;
    }
    set iq(a) {
        let b = this.iq;
        if (a != b) {
            this.io = a;
            this.g3("YAxisInverted", b, this.iq);
        }
    }
    get nv() {
        return this.ns;
    }
    set nv(a) {
        let b = this.nv;
        if (a != b) {
            this.ns = a;
            this.g3("XAxisTitleAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nv));
        }
    }
    get ou() {
        return this.or;
    }
    set ou(a) {
        let b = this.ou;
        if (a != b) {
            this.or = a;
            this.g3("YAxisTitleAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ou));
        }
    }
    get nu() {
        return this.nr;
    }
    set nu(a) {
        let b = this.nu;
        if (a != b) {
            this.nr = a;
            this.g3("XAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nu));
        }
    }
    get_nw() {
        return this.nt;
    }
    set_nw(a) {
        let b = this.nw;
        if (a != b) {
            this.nt = a;
            this.g3("YAxisLabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, this.nw));
        }
    }
    get nw() {
        return this.get_nw();
    }
    set nw(a) {
        this.set_nw(a);
    }
    get os() {
        return this.op;
    }
    set os(a) {
        let b = this.os;
        if (a != b) {
            this.op = a;
            this.g3("XAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.os));
        }
    }
    get ot() {
        return this.oq;
    }
    set ot(a) {
        let b = this.ot;
        if (a != b) {
            this.oq = a;
            this.g3("YAxisLabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, this.ot));
        }
    }
    get ox() {
        return this.ov;
    }
    set ox(a) {
        let b = this.ox;
        if (a != b) {
            this.ov = a;
            this.g3("XAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.ox));
        }
    }
    get oy() {
        return this.ow;
    }
    set oy(a) {
        let b = this.oy;
        if (a != b) {
            this.ow = a;
            this.g3("YAxisLabelVisibility", enumGetBox(Visibility_$type, b), enumGetBox(Visibility_$type, this.oy));
        }
    }
    get_il() {
        return this.ik;
    }
    set_il(a) {
        let b = this.il;
        if (a != b) {
            this.ik = a;
            this.g3("YAxisLabelLocation", enumGetBox(AxisLabelsLocation_$type, b), enumGetBox(AxisLabelsLocation_$type, this.il));
        }
    }
    get il() {
        return this.get_il();
    }
    set il(a) {
        this.set_il(a);
    }
    get k9() {
        return this.kv;
    }
    set k9(a) {
        let b = this.kv;
        if (a != b) {
            this.kv = a;
            this.g3("XAxisLabelFormat", b, this.kv);
        }
    }
    get ib() {
        return this.h9;
    }
    set ib(a) {
        let b = this.h9;
        if (a != b) {
            this.h9 = a;
            this.g3("XAxisLabelFormatSpecifiers", b, this.h9);
        }
    }
    get md() {
        return this.kz;
    }
    set md(a) {
        let b = this.kz;
        if (a != b) {
            this.kz = a;
            this.g3("YAxisLabelFormat", b, this.kz);
        }
    }
    get ic() {
        return this.ia;
    }
    set ic(a) {
        let b = this.ia;
        if (a != b) {
            this.ia = a;
            this.g3("YAxisLabelFormatSpecifiers", b, this.ia);
        }
    }
}
XYChart.$t = markType(XYChart, 'XYChart', DomainChart.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of data visualizations in the Category Chart
 */
var CategoryChartType;
(function (CategoryChartType) {
    /**
     * Specifies category line series with markers at each data point
     */
    CategoryChartType[CategoryChartType["Line"] = 0] = "Line";
    /**
     * Specifies category area series
     */
    CategoryChartType[CategoryChartType["Area"] = 1] = "Area";
    /**
     * Specifies category column chart with vertical rectangles at each data point
     */
    CategoryChartType[CategoryChartType["Column"] = 2] = "Column";
    /**
     * Specifies category point chart with markers at each data point
     */
    CategoryChartType[CategoryChartType["Point"] = 3] = "Point";
    /**
     * Specifies category step line chart
     */
    CategoryChartType[CategoryChartType["StepLine"] = 4] = "StepLine";
    /**
     * Specifies category step area chart
     */
    CategoryChartType[CategoryChartType["StepArea"] = 5] = "StepArea";
    /**
     * Specifies category spline line series with markers at each data point
     */
    CategoryChartType[CategoryChartType["Spline"] = 6] = "Spline";
    /**
     * Specifies category spline area series
     */
    CategoryChartType[CategoryChartType["SplineArea"] = 7] = "SplineArea";
    /**
     * Specifies category waterfall chart
     */
    CategoryChartType[CategoryChartType["Waterfall"] = 8] = "Waterfall";
    /**
     * Specifies automatic selection of chart type based on suggestions from Data Adapter
     */
    CategoryChartType[CategoryChartType["Auto"] = 9] = "Auto";
})(CategoryChartType || (CategoryChartType = {}));
/**
 * @hidden
 */
let CategoryChartType_$type = markEnum('CategoryChartType', 'Line,0|Area,1|Column,2|Point,3|StepLine,4|StepArea,5|Spline,6|SplineArea,7|Waterfall,8|Auto,9');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryChart extends XYChart {
    constructor() {
        super();
        this.qj = 1000;
        this.pj = null;
        this.o3 = 9;
        this.o5 = 1;
        this.pn = false;
        this.o7 = 0;
        this.ph = 0;
        this.pw = 0;
        this.px = 0;
        this.pv = 0;
        this.py = 0;
        this.pz = NaN;
        this.pp = false;
        this.qk = 10;
        this.p1 = NaN;
        this.p0 = NaN;
        this.p2 = 0;
        this.oz = null;
        this.o0 = null;
        this.po = true;
        this.pl = false;
        this.pm = false;
        this.f6();
    }
    gj() {
        super.gj();
        if (this.dataChart == null) {
            return;
        }
        let a = this.dataChart.b1.i.e();
        this.o1 = a.d;
        this.o2 = a.e;
        if (this.ob == null) {
            this.ob = a.k;
        }
        if (this.oi == null) {
            this.oi = a.k;
        }
    }
    gl(a, b) {
        super.gl(a, b);
        a.fj = this.ql;
        a.bv = this.pk;
    }
    g4(a, b, c) {
        super.g4(a, b, c);
        switch (a) {
            case "TransitionInDuration":
                this.ra((d) => d.fj = this.ql);
                break;
            case "TransitionInEasingFunction":
                this.ra((d) => d.bv = this.pk);
                break;
        }
    }
    get ql() {
        return this.qj;
    }
    set ql(a) {
        let b = this.ql;
        if (a != b) {
            this.qj = a;
            this.g3("TransitionInDuration", b, this.ql);
        }
    }
    get pk() {
        return this.pj;
    }
    set pk(a) {
        let b = this.pk;
        if (a != b) {
            this.pj = a;
            this.g3("TransitionInEasingFunction", b, this.pk);
        }
    }
    qo() {
        let cvd_ = this.dj();
        cvd_.scaleByViewport();
        return (cvd_.serialize());
    }
    ge(a) {
        super.ge(a);
        a.cw = this.bg;
    }
    gk(a, b) {
        super.gk(a, b);
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c == null) {
            return;
        }
        c.pd = this.o6;
        c.ob = this.ps;
        c.nu = this.o8;
        c.bp = this.pi;
        c.trendLineBrush = ArrayExtension.getModulus$1(Brush.$, this.o, b);
        c.trendLineType = this.av;
        c.trendLineThickness = this.c6;
        c.mb = this.ai(a, b);
        if (a.cz) {
            a.jq(ArrayExtension.getModulus$1(Brush.$, this.o1, b), ArrayExtension.getModulus$1(Brush.$, this.o2, b));
        }
    }
    o9() {
        return new CategoryXAxis();
    }
    pd() {
        return new NumericYAxis();
    }
    f3() {
        this.xAxis = this.o9();
        this.xAxis.name = "xAxis";
        let a = this.xAxis;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.rc));
        this.yAxis = this.pd();
        this.yAxis.name = "yAxis";
        let b = this.yAxis;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.rd));
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
    }
    nh(a) {
        super.nh(a);
        a.jw = this.pt;
    }
    get o4() {
        return this.o3;
    }
    set o4(a) {
        if (a != this.o3) {
            let b = this.o4;
            this.o3 = a;
            this.g3("ChartType", enumGetBox(CategoryChartType_$type, b), enumGetBox(CategoryChartType_$type, this.o4));
        }
    }
    get o6() {
        return this.o5;
    }
    set o6(a) {
        let b = this.o6;
        if (a != b) {
            this.o5 = a;
            this.g3("MarkerCollisionAvoidance", enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, b), enumGetBox(CategorySeriesMarkerCollisionAvoidance_$type, this.o6));
        }
    }
    get ps() {
        return this.pn;
    }
    set ps(a) {
        let b = this.ps;
        if (a != b) {
            this.pn = a;
            this.g3("IsTransitionInEnabled", b, this.ps);
        }
    }
    get o8() {
        return this.o7;
    }
    set o8(a) {
        let b = this.o8;
        if (a != b) {
            this.o7 = a;
            this.g3("TransitionInMode", enumGetBox(CategoryTransitionInMode_$type, b), enumGetBox(CategoryTransitionInMode_$type, this.o8));
        }
    }
    get pi() {
        return this.ph;
    }
    set pi(a) {
        let b = this.pi;
        if (a != b) {
            this.ph = a;
            this.g3("TransitionInSpeedType", enumGetBox(TransitionInSpeedType_$type, b), enumGetBox(TransitionInSpeedType_$type, this.pi));
        }
    }
    get qa() {
        return this.pw;
    }
    set qa(a) {
        let b = this.qa;
        if (a != b) {
            this.pw = a;
            this.g3("XAxisInterval", b, this.qa);
        }
    }
    get qb() {
        return this.px;
    }
    set qb(a) {
        let b = this.qb;
        if (a != b) {
            this.px = a;
            this.g3("XAxisMinorInterval", b, this.qb);
        }
    }
    get p9() {
        return this.pv;
    }
    set p9(a) {
        let b = this.p9;
        if (a != b) {
            this.pv = a;
            this.g3("XAxisGap", b, this.p9);
        }
    }
    get qc() {
        return this.py;
    }
    set qc(a) {
        let b = this.qc;
        if (a != b) {
            this.py = a;
            this.g3("XAxisOverlap", b, this.qc);
        }
    }
    get qf() {
        return this.pz;
    }
    set qf(a) {
        let b = this.qf;
        if (a != b) {
            this.pz = a;
            this.g3("YAxisInterval", b, this.qf);
        }
    }
    get pu() {
        return this.pp;
    }
    set pu(a) {
        let b = this.pu;
        if (a != b) {
            this.pp = a;
            this.g3("YAxisIsLogarithmic", b, this.pu);
        }
    }
    get qm() {
        return this.qk;
    }
    set qm(a) {
        let b = this.qm;
        if (a != b) {
            this.qk = a;
            this.g3("YAxisLogarithmBase", b, this.qm);
        }
    }
    get qh() {
        return this.p1;
    }
    set qh(a) {
        let b = this.qh;
        if (a != b) {
            this.p1 = a;
            this.g3("YAxisMinimumValue", b, this.qh);
        }
    }
    get qg() {
        return this.p0;
    }
    set qg(a) {
        let b = this.qg;
        if (a != b) {
            this.p0 = a;
            this.g3("YAxisMaximumValue", b, this.qg);
        }
    }
    get qi() {
        return this.p2;
    }
    set qi(a) {
        let b = this.qi;
        if (a != b) {
            this.p2 = a;
            this.g3("YAxisMinorInterval", b, this.qi);
        }
    }
    get p8() {
        return this.xAxis.lj;
    }
    get p7() {
        return this.xAxis.li;
    }
    p4() {
        return this.p8;
    }
    p6() {
        return this.qe;
    }
    p3() {
        return this.p7;
    }
    p5() {
        return this.qd;
    }
    get qe() {
        return this.yAxis.kc;
    }
    get qd() {
        return this.yAxis.kb;
    }
    get o1() {
        return this.oz;
    }
    set o1(a) {
        let b = this.o1;
        if (a != b) {
            this.oz = a;
            this.g3("NegativeBrushes", b, this.o1);
        }
    }
    get o2() {
        return this.o0;
    }
    set o2(a) {
        let b = this.o2;
        if (a != b) {
            this.o0 = a;
            this.g3("NegativeOutlines", b, this.o2);
        }
    }
    get pt() {
        return this.po;
    }
    set pt(a) {
        let b = this.pt;
        if (a != b) {
            this.po = a;
            this.g3("YAxisAbbreviateLargeNumbers", b, this.pt);
        }
    }
    get pq() {
        return this.pl;
    }
    set pq(a) {
        let b = this.pq;
        if (a != b) {
            this.pl = a;
            this.g3("IsCategoryHighlightingEnabled", b, this.pq);
        }
    }
    get pr() {
        return this.pm;
    }
    set pr(a) {
        let b = this.pr;
        if (a != b) {
            this.pm = a;
            this.g3("IsItemHighlightingEnabled", b, this.pr);
        }
    }
    get_b5() {
        let a = new List$1(DataSeriesType_$type, 0);
        if (TypeRegistrar.isRegistered("AreaSeries")) {
            a.add(2);
        }
        if (TypeRegistrar.isRegistered("ColumnSeries")) {
            a.add(1);
        }
        if (TypeRegistrar.isRegistered("LineSeries")) {
            a.add(0);
        }
        if (TypeRegistrar.isRegistered("PointSeries")) {
            a.add(10);
        }
        if (TypeRegistrar.isRegistered("SplineSeries")) {
            a.add(6);
        }
        if (TypeRegistrar.isRegistered("SplineAreaSeries")) {
            a.add(7);
        }
        if (TypeRegistrar.isRegistered("StepAreaSeries")) {
            a.add(5);
        }
        if (TypeRegistrar.isRegistered("StepLineSeries")) {
            a.add(4);
        }
        if (TypeRegistrar.isRegistered("WaterfallSeries")) {
            a.add(8);
        }
        return a;
    }
    get b5() {
        return this.get_b5();
    }
    rc(a, b) {
        switch (b.propertyName) {
            case "ActualMinimum":
                this.ha("XAxisActualMinimum");
                break;
            case "ActualMaximum":
                this.ha("XAxisActualMaximum");
                break;
        }
    }
    rd(a, b) {
        switch (b.propertyName) {
            case "ActualMinimumValue":
                this.ha("YAxisActualMinimum");
                break;
            case "ActualMaximumValue":
                this.ha("YAxisActualMaximum");
                break;
        }
    }
    hl() {
        super.hl();
        this.xAxis.e9 = this.kt == null ? XYChart.k3(this.xAxis, this.v.dataSeries) : this.kt;
        this.xAxis.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
    }
    get xAxis() {
        return this._xAxis;
    }
    set xAxis(a) {
        this._xAxis = a;
    }
    get yAxis() {
        return this._yAxis;
    }
    set yAxis(a) {
        this._yAxis = a;
    }
    pc(a, b) {
        switch (a) {
            case 2: return this.ar(1);
            case 3: return this.ar(10);
            case 0: return this.ar(0);
            case 1: return this.ar(2);
            case 6: return this.ar(6);
            case 7: return this.ar(7);
            case 4: return this.ar(4);
            case 5: return this.ar(5);
            case 8: return this.ar(8);
            case 9: return this.pb(b);
            default: return this.ar(1);
        }
    }
    pb(a) {
        return this.ar(a);
    }
    u(a) {
        switch (this.o4) {
            case 1: return 2;
            case 0: return 0;
            case 3: return 10;
            case 6: return 6;
            case 7: return 7;
            case 5: return 5;
            case 4: return 4;
            case 8: return 8;
            case 9: return a.suggestedSeries;
            default:
            case 2: return 1;
        }
    }
    aq(a, b) {
        let c = this.pc(this.o4, a.suggestedSeries);
        c.pq = a.findMatchingHint(0).path;
        c.xAxis = this.xAxis;
        c.yAxis = this.yAxis;
        return c;
    }
    hj(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.j1 = true;
            this.yAxis.ko = 10;
        }
    }
    hm() {
        this.yAxis.j1 = this.pu;
        this.yAxis.ko = this.qm;
    }
    get_b4() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleCategorySeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get b4() {
        return this.get_b4();
    }
    f1(a, b) {
        let c = typeCast(HorizontalAnchoredCategorySeries.$, a);
        if (c != null) {
            c.pd = this.o6;
            c.mb = this.ai(a, b);
        }
    }
    ra(a) {
        this.rb((b, c) => a(b));
    }
    rb(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = typeCast(HorizontalAnchoredCategorySeries.$, this.dataChart.series._inner[b]);
            if (c == null) {
                continue;
            }
            a(c, b);
        }
    }
    id() {
        return this.xAxis;
    }
    ie() {
        return this.yAxis;
    }
    pf() {
        return this.ar(30);
    }
    pg() {
        return this.ar(31);
    }
    b1(a, b) {
        let c = super.b1(a, b);
        if (c != null) {
            let d = new List$1(Series.$, 0);
            if (this.pl) {
                d.add(this.pf());
            }
            if (this.pm) {
                d.add(this.pg());
            }
            for (let e = 0; e < d.count; e++) {
                let f = d._inner[e];
                f.name = a + getInstanceType(f).typeName;
                c.add(f);
            }
        }
        return c;
    }
    hq(a, b, c) {
        super.hq(a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (stringIsNullOrEmpty(this.ea)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(16));
            }
            if (stringIsNullOrEmpty(this.ec)) {
                this.ac.setYMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d6)) {
                this.ac.setLabelMemberPath(a, c.getMemberPathFor(0));
            }
            if (stringIsNullOrEmpty(this.d3)) {
                this.ac.setContentMemberPath(a, c.getMemberPathFor(0));
            }
        }
    }
    g3(a, b, c) {
        super.g3(a, b, c);
        switch (a) {
            case "ChartType":
                this.hl();
                break;
            case "MarkerCollisionAvoidance":
                this.ra((d) => d.pd = this.o6);
                break;
            case "IsTransitionInEnabled":
                this.ra((d) => d.ob = this.ps);
                break;
            case "TransitionInMode":
                this.ra((d) => d.nu = this.o8);
                break;
            case "TransitionInSpeedType":
                this.ra((d) => d.bp = this.pi);
                break;
            case "XAxisInterval":
                this.xAxis.le = this.qa;
                break;
            case "XAxisMinorInterval":
                this.xAxis.lf = this.qb;
                break;
            case "XAxisGap":
                this.xAxis.jw = this.p9;
                break;
            case "XAxisOverlap":
                this.xAxis.j3 = this.qc;
                break;
            case "YAxisInterval":
                this.yAxis.kg = this.qf;
                break;
            case "YAxisIsLogarithmic":
                this.yAxis.j1 = this.pu;
                break;
            case "YAxisLogarithmBase":
                this.yAxis.ko = this.qm;
                break;
            case "YAxisMinimumValue":
                this.yAxis.kk = this.qh;
                break;
            case "YAxisMaximumValue":
                this.yAxis.kj = this.qg;
                break;
            case "YAxisMinorInterval":
                this.yAxis.kl = this.qi;
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.rb((d, e) => {
                    if (d.cz) {
                        d.jq(ArrayExtension.getModulus$1(Brush.$, this.o1, e), ArrayExtension.getModulus$1(Brush.$, this.o2, e));
                    }
                });
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.nn((d) => d.jw = this.pt);
                break;
            case "IsCategoryHighlightingEnabled":
            case "IsItemHighlightingEnabled":
                this.hl();
                break;
        }
    }
}
CategoryChart.$t = markType(CategoryChart, 'CategoryChart', XYChart.$);

/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*/
class IgxChartSeriesEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the series.
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
}

/**
 * Represents event arguments for chart's SeriesAdded and SeriesRemoved events
*
* The `IgxDomainChartSeriesPointerEventArgs` class provide events for chart's SeriesAdded and SeriesRemoved.
*
* `SeriesPointerDown` get fired when the pointer is press down over a Series.
*
* ```html
*  <igx-financial-chart
*       #chart
*       [dataSource]="data"
*       (seriesPointerDown)=chart_seriesPointerDown()
*       >
*     </igx-financial-chart>
* ```
*
* ```ts
* this.chart.seriesPointerDown = this.chart_seriesPointerDown();
* ```
*/
class IgxDomainChartSeriesPointerEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the series hit by the pointer.
    *
    * Use the `series` property to get the series.
    *
    * ```ts
    *  var series= args.series;
    * ```
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * Gets the item hit by the pointer.
    *
    * Use the `item` property to get the items.
    *
    * <https://www.infragistics.com/help/wpf/infragisticswpf.controls.charts.xamdatachart~infragistics.controls.charts.domainchartseriespointereventargs~item>
    *
    * ```ts
    * var Chartitem = args.item;
    * ```
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerTypeCollection extends ObservableCollection$1 {
    constructor() {
        super(MarkerType_$type, 0);
    }
}
MarkerTypeCollection.$t = markType(MarkerTypeCollection, 'MarkerTypeCollection', ObservableCollection$1.$.specialize(MarkerType_$type));

class IgxMarkerTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(MarkerType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(MarkerType_$type, MarkerType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

const IgxDomainChartComponent_PROVIDERS = [];
class IgxDomainChartComponent {
    constructor() {
        this._calloutsDataSource = null;
        this._markerTypes = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._seriesAdded = null;
        this._seriesRemoved = null;
        this._seriesPointerEnter = null;
        this._seriesPointerLeave = null;
        this._seriesPointerMove = null;
        this._seriesPointerDown = null;
        this._seriesPointerUp = null;
        this._calloutStyleUpdating = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    /**
    * Sets or gets the template reference to use for tooltips for all the series.
    *
    *
    */
    get tooltipTemplate() {
        return this.i.tooltipTemplate;
    }
    set tooltipTemplate(v) {
        this.i.tooltipTemplate = v;
    }
    /**
    * Sets or gets the template references to use for tooltips for all the series, in order.
    *
    *
    */
    get tooltipTemplates() {
        let ret = [];
        if (this.i.tooltipTemplates) {
            for (let ii = 0; ii < this.i.tooltipTemplates.count; ii++) {
                ret.push(this.i.tooltipTemplates.item(ii));
            }
        }
        return ret;
    }
    set tooltipTemplates(v) {
        this.i.tooltipTemplates.clear();
        if (v) {
            for (let ii = 0; ii < v.length; ii++) {
                this.i.tooltipTemplates.add(v[ii]);
            }
        }
    }
    get legend() {
        if (this.i.legend != null)
            return this.i.legend.externalObject;
    }
    set legend(v) {
        if (v != undefined && v != null)
            this.i.legend = v.i;
    }
    set calloutsDataSource(value) {
        this._calloutsDataSource = value;
        this.bindCalloutsData();
    }
    get calloutsDataSource() {
        return this._calloutsDataSource;
    }
    bindCalloutsData() {
        if (this.i != null && this.i !== undefined) {
            this.i.calloutsItemsSource = this._calloutsDataSource;
        }
    }
    /**
 * Gets or sets the scaling value used to affect the pixel density of the control.
 * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
 * to appear blurry.
*/
    get pixelScalingRatio() {
        return this.i.ct;
    }
    set pixelScalingRatio(v) {
        this.i.ct = +v;
    }
    /**
     * Gets or sets the left margin of chart title
    *
    *  Use `titleLeftMargin` property for the left margin of chart title.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    * 	titleLeftMargin= 10>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.titleLeftMargin = 10;
    * ```
    */
    get titleLeftMargin() {
        return this.i.c2;
    }
    set titleLeftMargin(v) {
        this.i.c2 = +v;
    }
    /**
     * Gets or sets the right margin of chart title
    *
    *  Use `titleLeftMargin` property for the right margin of chart title.
    *
    * ```html
    * <igx-category-chart
    * 		yAxisMinimumValue="0"
    * 		[dataSource]="data"
    * 		titleRightMargin= 10>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.titleRightMargin = 10;
    * ```
    */
    get titleRightMargin() {
        return this.i.c3;
    }
    set titleRightMargin(v) {
        this.i.c3 = +v;
    }
    /**
     * Gets or sets the top margin of chart title
    *
    *  Use `titleTopMargin` property for the top margin of chart title.
    *
    * ```html
    * <igx-category-chart
    *      yAxisMinimumValue="0"
    *      [dataSource]="data"
    *      title="Countries"
    *      titleTopMargin=10 >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.titleTopMargin = 10;
    * ```
    */
    get titleTopMargin() {
        return this.i.c4;
    }
    set titleTopMargin(v) {
        this.i.c4 = +v;
    }
    /**
     * Gets or sets the bottom margin of chart title
    *
    *  Use `titleBottomMargin` property for the bottom margin of chart title.
    *
    * ```html
    * <igx-category-chart
    *    yAxisMinimumValue="0"
    *    [dataSource]="data"
    *    titleBottomMargin= 10 >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.titleBottomMargin = 5;
    * ```
    */
    get titleBottomMargin() {
        return this.i.c1;
    }
    set titleBottomMargin(v) {
        this.i.c1 = +v;
    }
    /**
     * Gets or sets the left margin of chart subtitle
    *
    * Use `subtitleLeftMargin` property for the left margin of chart subtitle.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     subtitleLeftMargin= 20>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleLeftMargin = 20 ;
    * ```
    */
    get subtitleLeftMargin() {
        return this.i.cx;
    }
    set subtitleLeftMargin(v) {
        this.i.cx = +v;
    }
    /**
     * Gets or sets the top margin of chart subtitle
    *
    * Use `subtitleTopMargin` property for the top margin of chart subtitle.
    *
    * ```html
    *    <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       subtitle= "This is a subtitle"
    *       subtitleTopMargin=10>
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleTopMargin = 10;
    * ```
    */
    get subtitleTopMargin() {
        return this.i.cz;
    }
    set subtitleTopMargin(v) {
        this.i.cz = +v;
    }
    /**
     * Gets or sets the right margin of chart subtitle
    *
    * Use `subtitleRightMargin` property for the right margin of chart subtitle.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     subtitleRightMargin= 10>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.subtitleRightMargin = 20 ;
    * ```
    */
    get subtitleRightMargin() {
        return this.i.cy;
    }
    set subtitleRightMargin(v) {
        this.i.cy = +v;
    }
    /**
     * Gets or sets the bottom margin of chart subtitle
    *
    * Use `subtitleBottomMargin` property for the bottom margin of chart subtitle.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    * 	subtitleBottomMargin=10>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleBottomMargin = 10 ;
    * ```
    */
    get subtitleBottomMargin() {
        return this.i.cw;
    }
    set subtitleBottomMargin(v) {
        this.i.cw = +v;
    }
    /**
     * Gets or sets color of chart subtitle
    *
    * Use `subtitleTextColor` property to color the subtitle.
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       subtitle= "This is a subtitle"
    *       subtitleTextColor= 'blue'>
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleTextColor = "#ff0000" ;
    * ```
    */
    get subtitleTextColor() {
        return brushToString(this.i.h3);
    }
    set subtitleTextColor(v) {
        this.i.h3 = stringToBrush(v);
    }
    /**
     * Gets or sets color of chart title
    *
    *  Use `titleTextColor` property to color the chart title
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       titleTextColor= "red">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.titleTextColor="red" ;
    * ```
    */
    get titleTextColor() {
        return brushToString(this.i.h4);
    }
    set titleTextColor(v) {
        this.i.h4 = stringToBrush(v);
    }
    /**
     * Gets or sets the left margin of the chart content.
    *
    * Use the 'leftMargin' property for the left margin of the chart content.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       leftMargin=20>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.leftMargin = 20;
    * ```
    */
    get leftMargin() {
        return this.i.cs;
    }
    set leftMargin(v) {
        this.i.cs = +v;
    }
    /**
     * Gets or sets the top margin of the chart content.
    *
    * Use `topMargin` property for the margin of the chart content.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     topMargin= 20>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.topMargin=20;
    * ```
    */
    get topMargin() {
        return this.i.c5;
    }
    set topMargin(v) {
        this.i.c5 = +v;
    }
    /**
     * Gets or sets the right margin of the chart content.
    *
    * Use `rightMargin` property for the right margin of the chart content.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     rightMargin=20>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *   this.chart.rightMargin = 20 ;
    * ```
    */
    get rightMargin() {
        return this.i.cv;
    }
    set rightMargin(v) {
        this.i.cv = +v;
    }
    /**
     * Gets or sets the bottom margin around the chart content.
    *
    * Use the `bottomMargin` property for the bottom margin around the chart content.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       bottomMargin= 20>
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.bottomMargin=20;
    * ```
    */
    get bottomMargin() {
        return this.i.cr;
    }
    set bottomMargin(v) {
        this.i.cr = +v;
    }
    /**
     * Gets or sets the duration used for animating series plots when the data is changing
    *
    * Use the `transitionDuration` property to animating between data values.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     transitionDuration="500">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.transitionDuratio= 500;
    * ```
    */
    get transitionDuration() {
        return this.i.de;
    }
    set transitionDuration(v) {
        this.i.de = +v;
    }
    /**
     * Gets or sets the easing function used for animating series plots when the data is changing.
     * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
    *
    * The 'transitionInEasingFunction' property used for easing function for animating series plots when the chart is loading into view.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     transitionInEasingFunction= "cubic">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.transitionInEasingFunction=  this.cubicFunc;
    *
    * cubicFunc(time: number) : number
    *   {
    *     return time;
    *   }
    * ```
    */
    get transitionEasingFunction() {
        return this.i.a1;
    }
    set transitionEasingFunction(v) {
        this.i.a1 = v;
    }
    /**
     * Gets or sets CSS font property for the chart subtitle
    *
    * Use `subtitleTextStyle` property for the CSS font of the chart subtitle.
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       subtitle= "This is a subtitle"
    *       subtitleTextStyle ="16pt Verdona">
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleTextStyle= "16pt Verdona";
    * ```
    */
    get subtitleTextStyle() {
        return this.i.e9;
    }
    set subtitleTextStyle(v) {
        this.i.e9 = v;
    }
    /**
     * Gets or sets CSS font property for the chart title
    *
    * Use `titleTextStyle` property for the CSS font property of the chart title
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       titleTextStyle= "24pt Verdona">
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleTextStyle = "24pt Verdona";
    * ```
    */
    get titleTextStyle() {
        return this.i.fk;
    }
    set titleTextStyle(v) {
        this.i.fk = v;
    }
    /**
     * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
    *
    * The `includedProperties` property used to include the properties for the consideration of the category chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     includedProperties="ProductName,Cost" >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.includedProperties = ["ProductName", "Cost"];
    * ```
    */
    get includedProperties() {
        return this.i.d;
    }
    set includedProperties(v) {
        this.i.d = v;
    }
    /**
     * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
    *
    * The `excludedProperties` property used for the property paths that should be excluded from consideration by the category chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     excludedProperties="ID">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.excludedProperties = ["ID", "Discount"];
    * ```
    */
    get excludedProperties() {
        return this.i.c;
    }
    set excludedProperties(v) {
        this.i.c = v;
    }
    /**
     * Gets or sets the palette of brushes to use for coloring the chart series.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    *
    * Use the `brushes` property to  set the brushes.
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       Brushes="#ff0000, #cc0000, #aa0000">
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.brushes = ["#ff0000","#00ff00"];
    * ```
    */
    get brushes() {
        return fromBrushCollection(this.i.j);
    }
    set brushes(v) {
        this.i.j = toBrushCollection(v);
    }
    /**
     * Gets or sets the palette of brushes to use for outlines on the chart series.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    *
    *  Use the `outlines` property to sets the palette of brushes to use for outlines on the chart series
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     outlines="#ff0000, #cc0000, #aa0000">
    * </igx-category-chart>
    * ```
    */
    get outlines() {
        return fromBrushCollection(this.i.n);
    }
    set outlines(v) {
        this.i.n = toBrushCollection(v);
    }
    /**
     * Gets or sets whether the chart can be horizontally zoomed through user interactions.
    *
    * Use the `isHorizontalZoomEnabled` property to allow chart horizontally zoomed .
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       isHorizontalZoomEnabled=true>
    *   </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.isHorizontalZoomEnabled = true;
    * ```
    */
    get isHorizontalZoomEnabled() {
        return this.i.bq;
    }
    set isHorizontalZoomEnabled(v) {
        this.i.bq = ensureBool(v);
    }
    /**
     * Gets or sets whether the chart can be vertically zoomed through user interactions.
    *
    * Use the `isVerticalZoomEnabled` property to allow chart zoom vertically.
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       isVerticalZoomEnabled=true>
    *     </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.isVerticalZoomEnabled = true;
    * ```
    */
    get isVerticalZoomEnabled() {
        return this.i.bw;
    }
    set isVerticalZoomEnabled(v) {
        this.i.bw = ensureBool(v);
    }
    /**
     * Gets or sets whether the chart can highlight series through user interactions.
     * This property applies to Category Chart and Financial Chart controls.
    */
    get isSeriesHighlightingEnabled() {
        return this.i.bs;
    }
    set isSeriesHighlightingEnabled(v) {
        this.i.bs = ensureBool(v);
    }
    /**
     * Gets or sets the rectangle representing the current scroll and zoom state of the chart.
     * WindowRect is expressed as a Rectangle with coordinates and sizes between 0 and 1.
    *
    * Use `windowRect` property representing the current scroll and zoom state of the chart.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       WindowRect=[0,0,1,1]>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.windowRect =[0,0,1,1];
    * ```
    */
    get windowRect() {
        return fromRect(this.i.h8);
    }
    set windowRect(v) {
        this.i.h8 = toRect(v);
    }
    /**
     * Gets a rectangle representing the bounds of the plot area.
    *
    * `viewport` property representing the bounds of the plot area.
    *
    * ```ts
    * let viewport:Rect =  this.chart.viewport;
    * ```
    */
    get viewport() {
        return fromRect(this.i.h7);
    }
    /**
     * Gets or sets text to display above the plot area.
    *
    * Use the `chartTitle` property to display the text above the plot area.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     title="This is a Title">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.title= "This is a Title";
    * ```
    */
    get chartTitle() {
        return this.i.fd;
    }
    set chartTitle(v) {
        this.i.fd = v;
    }
    /**
     * Gets or sets text to display below the Title, above the plot area.
    *
    * Use the `subtitle` property to display the text below  and above the plot area.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     subtitle= "This is a subtitle">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.subtitle ="CategoryChart Subtitle" ;
    * ```
    */
    get subtitle() {
        return this.i.e2;
    }
    set subtitle(v) {
        this.i.e2 = v;
    }
    /**
     * Gets or sets horizontal alignment which determines the title position, relative to the left and right edges of the control.
    *
    * Use the `titleAlignment` property for the horizontal alignment of the title.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     titleAlignment= "center">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.titleAlignment = HorizontalAlignment.Center;
    * ```
    */
    get titleAlignment() {
        return this.i.hw;
    }
    set titleAlignment(v) {
        this.i.hw = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets horizontal alignment which determines the subtitle position, relative to the left and right edges of the control.
    *
    * Use the `subtitleAlignment` property to Gets or sets horizontal alignment.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     subtitleAlignment= "center">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleAlignment = HorizontalAlignment.Right;
    * ```
    */
    get subtitleAlignment() {
        return this.i.hv;
    }
    set subtitleAlignment(v) {
        this.i.hv = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the behavior that determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    *
    * Use the `unknownValuePlotting` property to determines the behavior that how unknown values will be plotted on the chart.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       unknownValuePlotting= "dontPlot">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.unknownValuePlotting =UnknownValuePlotting.DontPlot;
    * ```
    */
    get unknownValuePlotting() {
        return this.i.ax;
    }
    set unknownValuePlotting(v) {
        this.i.ax = ensureEnum(UnknownValuePlotting_$type, v);
    }
    /**
     * Gets or sets the rendering resolution for all series in this chart.
     * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
    *
    * Use the `resolution` property if the callouts should be display.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     resolution= 2>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *   this.chart.resolution = 2 ;
    * ```
    */
    get resolution() {
        return this.i.cu;
    }
    set resolution(v) {
        this.i.cu = +v;
    }
    /**
     * Gets or sets the thickness for all series in this chart. Depending on the ChartType, this can be the main brush used, or just the outline.
    *
    * Use the `thickness` property for the thickness of all the series in this chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     thickness=5>
    * </igx-category-chart>
    * ```
    */
    get thickness() {
        return this.i.c0;
    }
    set thickness(v) {
        this.i.c0 = +v;
    }
    /**
     * Gets or sets the marker shapes used for indicating location of data points in this chart.
     * This property applies only to these chart types: point, line, spline, bubble, and polygon
    */
    get markerTypes() {
        if (this._markerTypes === null) {
            let coll = new IgxMarkerTypeCollection();
            let innerColl = this.i.ak;
            if (!innerColl) {
                innerColl = new MarkerTypeCollection();
            }
            this._markerTypes = coll._fromInner(innerColl);
            this.i.ak = innerColl;
        }
        return this._markerTypes;
    }
    set markerTypes(v) {
        if (this._markerTypes !== null) {
            this._markerTypes._setSyncTarget(null);
            this._markerTypes = null;
        }
        let coll = new IgxMarkerTypeCollection();
        this._markerTypes = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(MarkerType_$type);
        let innerColl = this.i.ak;
        if (!innerColl) {
            innerColl = new MarkerTypeCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._markerTypes._setSyncTarget(syncColl);
        this.i.ak = innerColl;
    }
    /**
     * Gets or sets the palette of brushes used for rendering fill area of data point markers.
     * This property applies only to these chart types: point, line, spline, bubble, and polygon
    *
    * `markerBrushes` property used for rendering fill area of data point markers.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     markerBrushes="#ff0000, #cc0000, #aa0000">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.markerBrushes=[ "#ff0000", "#ffff00", "#00ffff" ];
    * ```
    */
    get markerBrushes() {
        return fromBrushCollection(this.i.l);
    }
    set markerBrushes(v) {
        this.i.l = toBrushCollection(v);
    }
    /**
     * Gets or sets the palette of brushes used for rendering outlines of data point markers.
     * This property applies only to these chart types: point, line, spline, bubble, and polygon
    *
    * `markerOutlines` property used for rendering outlines of data point markers.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     markerOutlines="#ff0000, #cc0000, #aa0000">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.markerOutlines= ["#ff0000", "#ffff00", "#00ffff"] ;
    * ```
    */
    get markerOutlines() {
        return fromBrushCollection(this.i.m);
    }
    set markerOutlines(v) {
        this.i.m = toBrushCollection(v);
    }
    /**
     * Gets or sets the maximum number of markers displyed in the plot area of the chart.
    *
    * `markerMaxCount` property used to display maximum number of markers in the plot area of the chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     markerMaxCount=100 >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.markerMaxCount = 100 ;
    * ```
    */
    get markerMaxCount() {
        return this.i.dd;
    }
    set markerMaxCount(v) {
        this.i.dd = +v;
    }
    /**
     * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
    */
    get animateSeriesWhenAxisRangeChanges() {
        return this.i.bg;
    }
    set animateSeriesWhenAxisRangeChanges(v) {
        this.i.bg = ensureBool(v);
    }
    /**
     * Gets or sets the palette of brushes to used for coloring trend lines in this chart.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    *
    * Use the `trendLineBrushes` property for coloring trend lines in the chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     trendLineBrushes="#ff0000,#aa0000">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.trendLineBrushes=["#ff0000", "#ffff00", "#00ffff"]	;
    * ```
    */
    get trendLineBrushes() {
        return fromBrushCollection(this.i.o);
    }
    set trendLineBrushes(v) {
        this.i.o = toBrushCollection(v);
    }
    /**
     * Gets or sets the formula used for calculating trend lines in this chart.
     * This property applies only to these chart types: point, line, spline, and bubble
    *
    * Use the `trendLineType` property for calculating trend lines.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       trendLineType= "cubicFit">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.trendLineType = TrendLineType.CubicFit;
    * ```
    */
    get trendLineType() {
        return this.i.av;
    }
    set trendLineType(v) {
        this.i.av = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the thickness of the trend lines in this chart.
     * This property applies only to these chart types: point, line, spline, and bubble
    *
    * Use the `trendLineThickness` property for the thickness of the trend lines in the chart.
    *
    * ```html
    * <igx-category-chart
    *     yAxisMinimumValue="0"
    *     [dataSource]="data"
    *     trendLineThickness= 2>
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.trendLineThickness=2;
    * ```
    */
    get trendLineThickness() {
        return this.i.c6;
    }
    set trendLineThickness(v) {
        this.i.c6 = +v;
    }
    /**
     * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
    *
    * Use `alignsGridLinesToPixels` propert to indicat whether grid and tick lines are aligned to device pixels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     AlignsGridLinesToPixels="true">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  this.chart.alignsGridLinesToPixels= true;
    * ```
    */
    get alignsGridLinesToPixels() {
        return this.i.bf;
    }
    set alignsGridLinesToPixels(v) {
        this.i.bf = ensureBool(v);
    }
    get trendLinePeriod() {
        return this.i.df;
    }
    set trendLinePeriod(v) {
        this.i.df = +v;
    }
    /**
     * Gets or sets the style of tooltip to be displayed.
    */
    get toolTipType() {
        return this.i.at;
    }
    set toolTipType(v) {
        this.i.at = ensureEnum(ToolTipType_$type, v);
    }
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get crosshairsDisplayMode() {
        return this.i.t;
    }
    set crosshairsDisplayMode(v) {
        this.i.t = ensureEnum(CrosshairsDisplayMode_$type, v);
    }
    /**
     * Gets or sets whether crosshairs will snap to the nearest data point.
    */
    get crosshairsSnapToData() {
        return this.i.bl;
    }
    set crosshairsSnapToData(v) {
        this.i.bl = ensureBool(v);
    }
    /**
     * Gets or sets whether annotations are shown along the axis for crosshair values
    */
    get crosshairsAnnotationEnabled() {
        return this.i.bk;
    }
    set crosshairsAnnotationEnabled(v) {
        this.i.bk = ensureBool(v);
    }
    /**
     * Gets or sets whether annotations for the final value of each series is displayed on the axis.
    */
    get finalValueAnnotationsVisible() {
        return this.i.bm;
    }
    set finalValueAnnotationsVisible(v) {
        this.i.bm = ensureBool(v);
    }
    /**
     * Gets or sets if callouts should be displayed.
    */
    get calloutsVisible() {
        return this.i.bj;
    }
    set calloutsVisible(v) {
        this.i.bj = ensureBool(v);
    }
    /**
     * Gets or sets if event annotations should be displayed.
    */
    get calloutStyleUpdatingEventEnabled() {
        return this.i.bi;
    }
    set calloutStyleUpdatingEventEnabled(v) {
        this.i.bi = ensureBool(v);
    }
    /**
     * Gets or sets the member path of the X data for the callouts.
    */
    get calloutsXMemberPath() {
        return this.i.ea;
    }
    set calloutsXMemberPath(v) {
        this.i.ea = v;
    }
    /**
     * Gets or sets the member path of the Y data for the callouts.
    */
    get calloutsYMemberPath() {
        return this.i.ec;
    }
    set calloutsYMemberPath(v) {
        this.i.ec = v;
    }
    /**
     * Gets or sets the member path of the label data for the callouts.
    */
    get calloutsLabelMemberPath() {
        return this.i.d6;
    }
    set calloutsLabelMemberPath(v) {
        this.i.d6 = v;
    }
    /**
     * Gets or sets the member path of the content data for the callouts.
    */
    get calloutsContentMemberPath() {
        return this.i.d3;
    }
    set calloutsContentMemberPath(v) {
        this.i.d3 = v;
    }
    findByName(name) {
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        if (this.markerTypes != null && this.markerTypes.findByName && this.markerTypes.findByName(name)) {
            return this.markerTypes.findByName(name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DomainChartComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Provides a container for this control

*
* `provideContainer` method provide container for the control.
*
* ```ts
*     this.chart.provideContainer("Container");
* ```
*/
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    /**
     * Destroy this control
    
    *
    * Use the `destroy` property to destroy the chart.
    *
    * ```ts
    * this.chart.destroy();
    * ```
    */
    destroy() {
        this.i.destroy();
    }
    /**
     * Called when the control has been resized.
    
    *
    * `notifyResized` method Called when the control has been resized.
    *
    * ```ts
    * this.chart.notifyResized();
    * ```
    */
    notifyResized() {
        this.i.notifyResized();
    }
    notifyVisualPropertiesChanged() {
        this.i.gv();
    }
    /**
     * Forces any pending refresh to the chart to be finished.
    
    *
    * Method `flush` used to Forces any pending deferred work to render on the chart before continuing.
    *
    * ```ts
    * this.chart.flush();
    * ```
    */
    flush() {
        this.i.f7();
    }
    /**
     * Hides the active main tooltip, if displayed.
    
    *
    * Use the `hideToolTip` method to hide the active tooltip.
    *
    * ```ts
    * this.chart.hideToolTip();
    * ```
    */
    hideToolTip() {
        this.i.ga();
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.gu(source_, index, oldItem, newItem);
    }
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    *
    * Use `notifyClearItems` method to notifies the chart that the items have been cleared from an associated data source.
    *
    * ```ts
    * this.chart.notifyClearItems(this.data);
    * ```
    */
    notifyClearItems(source_) {
        this.i.gq(source_);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.gr(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.gs(source_, index, oldItem);
    }
    /**
     * Event raised when a series is initialized and added to this chart.
    *
    * `SeriesAdded` event raised when a series is initialized and added to this chart.
    *
    * ```html
    *  <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesAdded)="CategoryChart_SeriesAdded()"
    *      >
    * </igx-category-chart>
    * ```
    */
    get seriesAdded() {
        if (this._seriesAdded == null) {
            this._seriesAdded = new EventEmitter();
            this.i.seriesAdded = delegateCombine(this.i.seriesAdded, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxChartSeriesEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesAdded) {
                        this.beforeSeriesAdded(this, outerArgs);
                    }
                    this._seriesAdded.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesAdded;
    }
    /**
     * Event raised when a series is removed from this chart.
    *
    * `SeriesRemoved` event raised when a series is removed from this chart.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesRemoved)="CategoryChart_seriesRemoved()">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  CategoryChart_seriesRemoved(sender: any , aregs: ChartSeriesEventArgs)
    *   {
    *
    *   }
    * ```
    */
    get seriesRemoved() {
        if (this._seriesRemoved == null) {
            this._seriesRemoved = new EventEmitter();
            this.i.seriesRemoved = delegateCombine(this.i.seriesRemoved, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxChartSeriesEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesRemoved) {
                        this.beforeSeriesRemoved(this, outerArgs);
                    }
                    this._seriesRemoved.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesRemoved;
    }
    /**
     * Occurs when the pointer enters a Series.
    *
    * `SeriesPointerEnter` event raised when the pointer enters a Series.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesPointerEnter)="CategoryChart_seriesPointerEnter()" >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * CategoryChart_seriesPointerEnter(sender: any , aregs: ChartSeriesEventArgs)
    *   {
    *
    *   }
    * ```
    */
    get seriesPointerEnter() {
        if (this._seriesPointerEnter == null) {
            this._seriesPointerEnter = new EventEmitter();
            this.i.seriesPointerEnter = delegateCombine(this.i.seriesPointerEnter, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesPointerEnter) {
                        this.beforeSeriesPointerEnter(this, outerArgs);
                    }
                    this._seriesPointerEnter.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesPointerEnter;
    }
    /**
     * Occurs when the pointer leaves a Series.
    *
    * `SeriesPointerLeave` event raised when the pointer leaves a Series.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesPointerLeave)= "CategoryChart_seriesPointerLeave()" >
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * CategoryChart_seriesPointerLeave(sender: any , aregs: ChartSeriesEventArgs)
    *   {
    *
    *   }
    * ```
    */
    get seriesPointerLeave() {
        if (this._seriesPointerLeave == null) {
            this._seriesPointerLeave = new EventEmitter();
            this.i.seriesPointerLeave = delegateCombine(this.i.seriesPointerLeave, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesPointerLeave) {
                        this.beforeSeriesPointerLeave(this, outerArgs);
                    }
                    this._seriesPointerLeave.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesPointerLeave;
    }
    /**
     * Occurs when the pointer moves over a Series.
    *
    * `SeriesPointerMove` event raised when the pointer moves over a Series.
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *        (seriesPointerMove)="CategoryChart_seriesPointerMove()">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    *  CategoryChart_seriesPointerMove(sender: any , aregs: ChartSeriesEventArgs)
    *   {
    *
    *   }
    * ```
    */
    get seriesPointerMove() {
        if (this._seriesPointerMove == null) {
            this._seriesPointerMove = new EventEmitter();
            this.i.seriesPointerMove = delegateCombine(this.i.seriesPointerMove, (o, e) => {
                let outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSeriesPointerMove) {
                    this.beforeSeriesPointerMove(this, outerArgs);
                }
                this._seriesPointerMove.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._seriesPointerMove;
    }
    /**
     * Occurs when the pointer is pressed down over a Series.
    *
    * `SeriesPointerDown` event raised when the pointer is pressed down over a Series
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesPointerDown)="CategoryChart_seriesPointerDown()" >
    * </igx-category-chart>
    * ```
    */
    get seriesPointerDown() {
        if (this._seriesPointerDown == null) {
            this._seriesPointerDown = new EventEmitter();
            this.i.seriesPointerDown = delegateCombine(this.i.seriesPointerDown, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesPointerDown) {
                        this.beforeSeriesPointerDown(this, outerArgs);
                    }
                    this._seriesPointerDown.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesPointerDown;
    }
    /**
     * Occurs when the pointer is released over a Series.
    *
    * `SeriesPointerUp` event raised when the pointer is released over a Series.
    *
    * ```ts
    *  CategoryChart_seriesPointerUp(sender: any , aregs: ChartSeriesEventArgs)
    *   {
    *
    *   }
    * ```
    *
    * ```html
    * <igx-category-chart
    *       yAxisMinimumValue="0"
    *       [dataSource]="data"
    *       (seriesPointerUp)="CategoryChart_seriesPointerUp()" >
    * </igx-category-chart>
    * ```
    */
    get seriesPointerUp() {
        if (this._seriesPointerUp == null) {
            this._seriesPointerUp = new EventEmitter();
            this.i.seriesPointerUp = delegateCombine(this.i.seriesPointerUp, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDomainChartSeriesPointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesPointerUp) {
                        this.beforeSeriesPointerUp(this, outerArgs);
                    }
                    this._seriesPointerUp.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesPointerUp;
    }
    /**
     * Occurs when the style of a callout is updated.
    */
    get calloutStyleUpdating() {
        if (this._calloutStyleUpdating == null) {
            this._calloutStyleUpdating = new EventEmitter();
            this.i.calloutStyleUpdating = delegateCombine(this.i.calloutStyleUpdating, (o, e) => {
                let outerArgs = new IgxCalloutStyleUpdatingEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeCalloutStyleUpdating) {
                    this.beforeCalloutStyleUpdating(this, outerArgs);
                }
                this._calloutStyleUpdating.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._calloutStyleUpdating;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxDomainChartComponent.prototype, "tooltipTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "tooltipTemplates", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxDomainChartComponent.prototype, "legend", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "calloutsDataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "titleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "titleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "titleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "titleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "subtitleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "subtitleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "subtitleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "subtitleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "subtitleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "titleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "leftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "topMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "rightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "bottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "transitionDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxDomainChartComponent.prototype, "transitionEasingFunction", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "subtitleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "titleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "includedProperties", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "excludedProperties", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "brushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "outlines", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "isHorizontalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "isVerticalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "isSeriesHighlightingEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxDomainChartComponent.prototype, "windowRect", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "chartTitle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "subtitle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "titleAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "subtitleAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "unknownValuePlotting", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "resolution", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "thickness", null);
__decorate([
    Input(),
    __metadata("design:type", IgxMarkerTypeCollection),
    __metadata("design:paramtypes", [IgxMarkerTypeCollection])
], IgxDomainChartComponent.prototype, "markerTypes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "markerBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "markerOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "markerMaxCount", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "animateSeriesWhenAxisRangeChanges", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDomainChartComponent.prototype, "trendLineBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "alignsGridLinesToPixels", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "toolTipType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDomainChartComponent.prototype, "crosshairsDisplayMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "crosshairsSnapToData", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "crosshairsAnnotationEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "finalValueAnnotationsVisible", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "calloutsVisible", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDomainChartComponent.prototype, "calloutStyleUpdatingEventEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "calloutsXMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "calloutsYMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "calloutsLabelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDomainChartComponent.prototype, "calloutsContentMemberPath", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesAdded", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesRemoved", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesPointerEnter", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesPointerLeave", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesPointerMove", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesPointerDown", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "seriesPointerUp", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDomainChartComponent.prototype, "calloutStyleUpdating", null);

/**
 * Represents a base class for domain charts with X/Y axes
*/
const IgxXYChartComponent_PROVIDERS = [{ provide: IgxDomainChartComponent, useExisting: forwardRef(() => IgxXYChartComponent) }];
class IgxXYChartComponent extends IgxDomainChartComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets function which takes an context object and returns a formatted label for the X-axis.
    *
    * To customize the text of the x-axis label, set `xAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be your data item.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     [xAxisFormatLabel]="formatX"
    *     xAxisExtent="250">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * formatX(item: any): string {
    *     return "[ " + item.label + "! ]";
    * }
    * ```
    */
    get xAxisFormatLabel() {
        return this.i.ii;
    }
    set xAxisFormatLabel(v) {
        this.i.ii = v;
    }
    /**
     * Gets or sets function which takes a context object and returns a formatted label for the Y-axis.
    *
    * To customize the text of the y-axis label, set `yAxisFormatLabel` to a single-parameter function.  The argument passed to that function will be the numeric value corresponding to a position on the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     [yAxisFormatLabel]="formatY">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * formatY(value: any): string {
    *     return "[ " + value+ "! ]";
    * }
    * ```
    */
    get yAxisFormatLabel() {
        return this.i.ij;
    }
    set yAxisFormatLabel(v) {
        this.i.ij = v;
    }
    /**
     * Gets or sets the left margin of labels on the X-axis
    *
    * Use the `xAxisLabelLeftMargin` property to apply a margin left of the x-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelLeftMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelLeftMargin ="100";
    * ```
    */
    get xAxisLabelLeftMargin() {
        return this.i.jw;
    }
    set xAxisLabelLeftMargin(v) {
        this.i.jw = +v;
    }
    /**
     * Gets or sets the top margin of labels on the X-axis
    *
    * Use the `xAxisLabelTopMargin` property to apply a margin above the x-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleTopMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleTopMargin="250";
    * ```
    */
    get xAxisLabelTopMargin() {
        return this.i.jy;
    }
    set xAxisLabelTopMargin(v) {
        this.i.jy = +v;
    }
    /**
     * Gets or sets the right margin of labels on the X-axis
    *
    * Use the `xAxisLabelRightMargin` property to apply a margin right of the x-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelRightMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelRightMargin="100";
    * ```
    */
    get xAxisLabelRightMargin() {
        return this.i.jx;
    }
    set xAxisLabelRightMargin(v) {
        this.i.jx = +v;
    }
    /**
     * Gets or sets the bottom margin of labels on the X-axis
    *
    * Use the `xAxisLabelBottomMargin` property to apply a margin below the x-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelBottomMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelBottomMargin ="100";
    * ```
    */
    get xAxisLabelBottomMargin() {
        return this.i.jv;
    }
    set xAxisLabelBottomMargin(v) {
        this.i.jv = +v;
    }
    /**
     * Gets or sets the left margin of labels on the Y-axis
    *
    * Use the `yAxisLabelLeftMargin` property to apply a margin left of the y-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelLeftMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart. yAxisLabelLeftMargin="250";
    * ```
    */
    get yAxisLabelLeftMargin() {
        return this.i.kd;
    }
    set yAxisLabelLeftMargin(v) {
        this.i.kd = +v;
    }
    /**
     * Gets or sets the top margin of labels on the Y-axis
    *
    * Use the `yAxisLabelTopMargin` property to apply a margin above the y-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelTopMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelTopMargin="250";
    * ```
    */
    get yAxisLabelTopMargin() {
        return this.i.kf;
    }
    set yAxisLabelTopMargin(v) {
        this.i.kf = +v;
    }
    /**
     * Gets or sets the right margin of labels on the Y-axis
    *
    * Use the `yAxisLabelRightMargin` property to apply a margin right of the y-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelRightMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelRightMargin="250";
    * ```
    */
    get yAxisLabelRightMargin() {
        return this.i.ke;
    }
    set yAxisLabelRightMargin(v) {
        this.i.ke = +v;
    }
    /**
     * Gets or sets the bottom margin of labels on the Y-axis
    *
    * Use the `yAxisLabelBottomMargin` property to apply a margin below the y-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelBottomMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelBottomMargin="250";
    * ```
    */
    get yAxisLabelBottomMargin() {
        return this.i.kc;
    }
    set yAxisLabelBottomMargin(v) {
        this.i.kc = +v;
    }
    /**
     * Gets or sets color of labels on the X-axis
    *
    * To change the color of x-axis labels, set the `xAxisLabelTextColor` property to a color string.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelTextColor="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelTextColor="green";
    * ```
    */
    get xAxisLabelTextColor() {
        return brushToString(this.i.ob);
    }
    set xAxisLabelTextColor(v) {
        this.i.ob = stringToBrush(v);
    }
    /**
     * Gets or sets color of labels on the Y-axis
    *
    * To change the color of y-axis labels, set the `yAxisLabelTextColor` property to a color string.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelTextColor="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelTextColor="green";
    * ```
    */
    get yAxisLabelTextColor() {
        return brushToString(this.i.oi);
    }
    set yAxisLabelTextColor(v) {
        this.i.oi = stringToBrush(v);
    }
    /**
     * Gets or sets the margin around a title on the X-axis
    *
    * Use the `xAxisTitleMargin` property to set a margin around the y-axis title.
    */
    get xAxisTitleMargin() {
        return this.i.j7;
    }
    set xAxisTitleMargin(v) {
        this.i.j7 = +v;
    }
    /**
     * Gets or sets the margin around a title on the Y-axis
    *
    * Use the `yAxisTitleMargin` property to set a margin around the y-axis title.
    */
    get yAxisTitleMargin() {
        return this.i.ko;
    }
    set yAxisTitleMargin(v) {
        this.i.ko = +v;
    }
    /**
     * Gets or sets the left margin of a title on the X-axis
    *
    * Use the `xAxisTitleLeftMargin` property to apply a margin left of the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleAlignment="left"
    *     xAxisTitleLeftMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleLeftMargin="150";
    * ```
    */
    get xAxisTitleLeftMargin() {
        return this.i.j6;
    }
    set xAxisTitleLeftMargin(v) {
        this.i.j6 = +v;
    }
    /**
     * Gets or sets the left margin of a title on the Y-axis
    *
    * Use the `yAxisTitleLeftMargin` property to apply a margin left of the y-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleLeftMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleLeftMargin="150";
    * ```
    */
    get yAxisTitleLeftMargin() {
        return this.i.kn;
    }
    set yAxisTitleLeftMargin(v) {
        this.i.kn = +v;
    }
    /**
     * Gets or sets the top margin of a title on the X-axis
    *
    * Use the `xAxisTitleTopMargin` property to apply a margin above the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleTopMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleTopMargin="150";
    * ```
    */
    get xAxisTitleTopMargin() {
        return this.i.j9;
    }
    set xAxisTitleTopMargin(v) {
        this.i.j9 = +v;
    }
    /**
     * Gets or sets the top margin of a title on the Y-axis
    *
    * Use the `yAxisTitleTopMargin` property to apply a margin above the y-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleAlignment="top"
    *     yAxisTitleTopMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleTopMargin="150";
    * ```
    */
    get yAxisTitleTopMargin() {
        return this.i.kq;
    }
    set yAxisTitleTopMargin(v) {
        this.i.kq = +v;
    }
    /**
     * Gets or sets the right margin of a title on the X-axis
    *
    * Use the `xAxisTitleRightMargin` property to apply a margin right of the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleAlignment="right"
    *     xAxisTitleRightMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleRightMargin="100";
    * ```
    */
    get xAxisTitleRightMargin() {
        return this.i.j8;
    }
    set xAxisTitleRightMargin(v) {
        this.i.j8 = +v;
    }
    /**
     * Gets or sets the right margin of a title on the Y-axis
    *
    * Use the `yAxisTitleRightMargin` property to apply a margin right of the y-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleRightMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleRightMargin="150";
    * ```
    */
    get yAxisTitleRightMargin() {
        return this.i.kp;
    }
    set yAxisTitleRightMargin(v) {
        this.i.kp = +v;
    }
    /**
     * Gets or sets the bottom margin of a title on the X-axis
    *
    * Use the `xAxisTitleBottomMargin` property to apply a margin below the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleBottomMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleBottomMargin="150";
    * ```
    */
    get xAxisTitleBottomMargin() {
        return this.i.j5;
    }
    set xAxisTitleBottomMargin(v) {
        this.i.j5 = +v;
    }
    /**
     * Gets or sets the bottom margin of a title on the Y-axis
    *
    * Use the `yAxisTitleBottomMargin` property to apply a margin below the y-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleAlignment="bottom"
    *     yAxisTitleBottomMargin="100">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleBottomMargin="150";
    * ```
    */
    get yAxisTitleBottomMargin() {
        return this.i.km;
    }
    set yAxisTitleBottomMargin(v) {
        this.i.km = +v;
    }
    /**
     * Gets or sets color of title on the X-axis
    *
    * To change the color of the x-axis title, set the `xAxisTitleTextColor` property to a color string.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleTextColor="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleTextColor="green";
    * ```
    */
    get xAxisTitleTextColor() {
        return brushToString(this.i.oh);
    }
    set xAxisTitleTextColor(v) {
        this.i.oh = stringToBrush(v);
    }
    /**
     * Gets or sets color of title on the Y-axis
    *
    * To change the color of the y-axis title, set the `yAxisTitleTextColor` property to a color string.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleTextColor="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleTextColor="green";
    * ```
    */
    get yAxisTitleTextColor() {
        return brushToString(this.i.oo);
    }
    set yAxisTitleTextColor(v) {
        this.i.oo = stringToBrush(v);
    }
    /**
     * Gets or sets CSS font property for labels on X-axis
    *
    * To change the font of x-axis labels, set the `xAxisLabelTextStyle` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelTextStyle="italic 15px arial, sans-serif">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelTextStyle="italic 15px arial, sans-serif";
    * ```
    */
    get xAxisLabelTextStyle() {
        return this.i.lh;
    }
    set xAxisLabelTextStyle(v) {
        this.i.lh = v;
    }
    /**
     * Gets or sets CSS font property for labels on Y-axis
    *
    * To change the font of x-axis labels, set the `yAxisLabelTextStyle` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelTextStyle="italic 15px arial, sans-serif">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart. yAxisLabelTextStyle="italic 15px arial, sans-serif";
    * ```
    */
    get yAxisLabelTextStyle() {
        return this.i.mm;
    }
    set yAxisLabelTextStyle(v) {
        this.i.mm = v;
    }
    /**
     * Gets or sets CSS font property for title on X-axis
    *
    * To change the font of the x-axis title, set the `xAxisTitleTextStyle` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleTextStyle="italic 15px arial, sans-serif">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleTextStyle="italic 15px arial, sans-serif";
    * ```
    */
    get xAxisTitleTextStyle() {
        return this.i.l5;
    }
    set xAxisTitleTextStyle(v) {
        this.i.l5 = v;
    }
    /**
     * Gets or sets CSS font property for title on Y-axis
    *
    * To change the font of the x-axis title, set the `yAxisTitleTextStyle` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="y axis"
    *     yAxisTitleTextStyle="italic 15px arial, sans-serif">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleTextStyle="italic 15px arial, sans-serif";
    * ```
    */
    get yAxisTitleTextStyle() {
        return this.i.na;
    }
    set yAxisTitleTextStyle(v) {
        this.i.na = v;
    }
    /**
     * Gets or sets the format for labels along the X-axis.
    */
    get xAxisLabel() {
        return this.i.kt;
    }
    set xAxisLabel(v) {
        this.i.kt = v;
    }
    /**
     * Gets or sets the property or string from which the labels are derived.
    */
    get yAxisLabel() {
        return this.i.ku;
    }
    set yAxisLabel(v) {
        this.i.ku = v;
    }
    /**
     * Gets or sets the color to apply to major gridlines along the X-axis.
    *
    * Set `xAxisMajorStroke` to control the color of major gridlines extending vertically from the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisMajorStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisMajorStroke="green";
    * ```
    */
    get xAxisMajorStroke() {
        return brushToString(this.i.oc);
    }
    set xAxisMajorStroke(v) {
        this.i.oc = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to major gridlines along the Y-axis.
    *
    * Set `yAxisMajorStroke` to control the color of major gridlines extending horizontally from the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMajorStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisMajorStroke="green";
    * ```
    */
    get yAxisMajorStroke() {
        return brushToString(this.i.oj);
    }
    set yAxisMajorStroke(v) {
        this.i.oj = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness to apply to major gridlines along the X-axis.
    *
    * Set `xAxisMajorStrokeThickness` to control the thickness of major gridlines extending vertically from the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisMajorStroke="green"
    *     xAxisMajorStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisMajorStrokeThickness="3" ;
    * ```
    */
    get xAxisMajorStrokeThickness() {
        return this.i.jz;
    }
    set xAxisMajorStrokeThickness(v) {
        this.i.jz = +v;
    }
    /**
     * Gets or sets the thickness to apply to major gridlines along the Y-axis.
    *
    * Set `yAxisMajorStrokeThickness` to control the thickness of major gridlines extending horizontally from the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMajorStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisMajorStrokeThickness="2";
    * ```
    */
    get yAxisMajorStrokeThickness() {
        return this.i.kg;
    }
    set yAxisMajorStrokeThickness(v) {
        this.i.kg = +v;
    }
    /**
     * Gets or sets the thickness to apply to minor gridlines along the X-axis.
    *
    * Set `xAxisMinorStrokeThickness` to control the thickness of minor gridlines extending vertically from the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisMinorStroke="green"
    *     xAxisMinorStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisMinorStrokeThickness="3";
    * ```
    */
    get xAxisMinorStrokeThickness() {
        return this.i.j0;
    }
    set xAxisMinorStrokeThickness(v) {
        this.i.j0 = +v;
    }
    /**
     * Gets or sets the thickness to apply to minor gridlines along the Y-axis.
    *
    * Set `yAxisMinorStrokeThickness` to control the thickness of minor gridlines extending horizontally from the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMinorStroke="green"
    *     yAxisMinorStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisMinorStrokeThickness="3";
    * ```
    */
    get yAxisMinorStrokeThickness() {
        return this.i.kh;
    }
    set yAxisMinorStrokeThickness(v) {
        this.i.kh = +v;
    }
    /**
     * Gets or sets the color to apply to stripes along the X-axis.
    *
    * Set `xAxisStrip` to control the alternating color of stripes extending vertically from the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisStrip="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisStrip="green";
    * ```
    */
    get xAxisStrip() {
        return brushToString(this.i.oe);
    }
    set xAxisStrip(v) {
        this.i.oe = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to stripes along the Y-axis.
    *
    * Set `yAxisStrip` to control the alternating color of stripes extending horizontally from the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisStrip="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisStrip="green";
    * ```
    */
    get yAxisStrip() {
        return brushToString(this.i.ol);
    }
    set yAxisStrip(v) {
        this.i.ol = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to the X-axis line.
    *
    * Set `xAxisStroke` to control the color of the x-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisStroke="green"";
    * ```
    */
    get xAxisStroke() {
        return brushToString(this.i.of);
    }
    set xAxisStroke(v) {
        this.i.of = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to the Y-axis line.
    *
    * Set `yAxisStroke` to control the color of the y-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisStroke="green";
    * ```
    */
    get yAxisStroke() {
        return brushToString(this.i.om);
    }
    set yAxisStroke(v) {
        this.i.om = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness to apply to the X-axis line.
    *
    * Set `xAxisStrokeThickness` to control the thickness of the x-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisStrokeThickness="2";
    * ```
    */
    get xAxisStrokeThickness() {
        return this.i.j1;
    }
    set xAxisStrokeThickness(v) {
        this.i.j1 = +v;
    }
    /**
     * Gets or sets the thickness to apply to the Y-axis line.
    *
    * Set `yAxisStrokeThickness` to control the thickness of the y-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisStroke="green"
    *     yAxisStrokeThickness="3">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart. yAxisStrokeThickness="2";
    * ```
    */
    get yAxisStrokeThickness() {
        return this.i.ki;
    }
    set yAxisStrokeThickness(v) {
        this.i.ki = +v;
    }
    /**
     * Gets or sets the length of tickmarks along the X-axis.
    *
    * Set `xAxisTickLength` to control the length of tickmarks extending vertically from the x-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTickLength="23">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTickLength="25";
    * ```
    */
    get xAxisTickLength() {
        return this.i.j2;
    }
    set xAxisTickLength(v) {
        this.i.j2 = +v;
    }
    /**
     * Gets or sets the length of tickmarks along the Y-axis.
    *
    * Set `yAxisTickLength` to control the length of tickmarks extending horizontally from the y-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTickLength="23">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTickLength="25";
    * ```
    */
    get yAxisTickLength() {
        return this.i.kj;
    }
    set yAxisTickLength(v) {
        this.i.kj = +v;
    }
    /**
     * Gets or sets the color to apply to tickmarks along the X-axis.
    *
    * Set `xAxisTickStroke` to control the color of tickmarks extending vertically from the x-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTickStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart. xAxisTickStroke="green";
    * ```
    */
    get xAxisTickStroke() {
        return brushToString(this.i.og);
    }
    set xAxisTickStroke(v) {
        this.i.og = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to tickmarks along the Y-axis.
    *
    * Set `yAxisTickStroke` to control the color of tickmarks extending horizontally from the y-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTickLength="5"
    *     yAxisTickStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTickStroke="green";
    * ```
    */
    get yAxisTickStroke() {
        return brushToString(this.i.on);
    }
    set yAxisTickStroke(v) {
        this.i.on = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness to apply to tickmarks along the X-axis.
    *
    * Set `xAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the x-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTickStrokeThickness="10">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTickStrokeThickness="20";
    * ```
    */
    get xAxisTickStrokeThickness() {
        return this.i.j3;
    }
    set xAxisTickStrokeThickness(v) {
        this.i.j3 = +v;
    }
    /**
     * Gets or sets the thickness to apply to tickmarks along the Y-axis.
    *
    * Set `yAxisTickStrokeThickness` to control the thickness of tickmarks extending vertically from the y-axis line.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTickLength="5"
    *     yAxisTickStrokeThickness="10">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTickStrokeThickness="25";
    * ```
    */
    get yAxisTickStrokeThickness() {
        return this.i.kk;
    }
    set yAxisTickStrokeThickness(v) {
        this.i.kk = +v;
    }
    /**
     * Gets or sets the Text to display below the X-axis.
    *
    * Set `xAxisTitle` to display a label adjacent to the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart. xAxisTitle="x axis";
    * ```
    */
    get xAxisTitle() {
        return this.i.lw;
    }
    set xAxisTitle(v) {
        this.i.lw = v;
    }
    /**
     * Gets or sets the Text to display to the left of the Y-axis.
    *
    * Set `yAxisTitle` to display a label adjacent to the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitle="y axis";
    * ```
    */
    get yAxisTitle() {
        return this.i.m1;
    }
    set yAxisTitle(v) {
        this.i.m1 = v;
    }
    /**
     * Gets or sets the color to apply to minor gridlines along the X-axis.
    *
    * Set `xAxisMinorStroke` to control the color of minor gridlines extending vertically from the x-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisMinorStroke="green">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisExtent="250";
    * ```
    */
    get xAxisMinorStroke() {
        return brushToString(this.i.od);
    }
    set xAxisMinorStroke(v) {
        this.i.od = stringToBrush(v);
    }
    /**
     * Gets or sets the color to apply to minor gridlines along the Y-axis.
    *
    * Set `yAxisMinorStroke` to control the color of minor gridlines extending horizontally from the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMinorStroke="green"
    *     yAxisMinorStrokeThickness="1">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisMinorStroke="green";
    * ```
    */
    get yAxisMinorStroke() {
        return brushToString(this.i.ok);
    }
    set yAxisMinorStroke(v) {
        this.i.ok = stringToBrush(v);
    }
    /**
     * Gets or sets the angle of rotation for labels along the X-axis.
    *
    * To control the rotation of labels on the x-axis, set the `xAxisLabelAngle` property to a number of rotational degrees.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelAngle="45">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelAngle="45";
    * ```
    */
    get xAxisLabelAngle() {
        return this.i.ju;
    }
    set xAxisLabelAngle(v) {
        this.i.ju = +v;
    }
    /**
     * Gets or sets the angle of rotation for labels along the Y-axis.
    *
    * To control the rotation of labels on the y-axis, set the `yAxisLabelAngle` property to a number of rotational degrees.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelAngle="45">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelAngle="25";
    * ```
    */
    get yAxisLabelAngle() {
        return this.i.kb;
    }
    set yAxisLabelAngle(v) {
        this.i.kb = +v;
    }
    /**
     * Gets or sets the distance between the X-axis and the bottom of the chart.
    *
    * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisExtent="250">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisExtent="250";
    * ```
    */
    get xAxisExtent() {
        return this.i.jt;
    }
    set xAxisExtent(v) {
        this.i.jt = +v;
    }
    /**
     * Gets or sets the distance between the Y-axis and the left edge of the chart.
    *
    * To allocate space between the x-axis and the edge of the chart, set the `xAxisExtent` property.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisExtent="250">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisExtent="250";
    * ```
    */
    get yAxisExtent() {
        return this.i.ka;
    }
    set yAxisExtent(v) {
        this.i.ka = +v;
    }
    /**
     * Gets or sets the angle of rotation for the X-axis title.
    *
    * Set `xAxisTitleAngle` to control the rotation of the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleAngle="45">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleAngle="50";
    * ```
    */
    get xAxisTitleAngle() {
        return this.i.j4;
    }
    set xAxisTitleAngle(v) {
        this.i.j4 = +v;
    }
    /**
     * Gets or sets the angle of rotation for the Y-axis title.
    *
    * Set `yAxisTitleAngle` to control the rotation of the y-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleAngle="45">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleAngle="25";
    * ```
    */
    get yAxisTitleAngle() {
        return this.i.kl;
    }
    set yAxisTitleAngle(v) {
        this.i.kl = +v;
    }
    /**
     * Gets or sets whether to invert the direction of the X-axis by placing the first data items on the right side of the chart.
    *
    * To reverse the direction of items along the x-axis, set the `xAxisInverted` property to true.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisInverted="true">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.XAxisInverted="True";
    * ```
    */
    get xAxisInverted() {
        return this.i.ip;
    }
    set xAxisInverted(v) {
        this.i.ip = ensureBool(v);
    }
    /**
     * Gets or sets whether to invert the direction of the Y-axis by placing the minimum numeric value at the top of the chart.
    *
    * You can use `yAxisInverted` to invert the scale of the y axis like this:
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisInverted="true"
    * >
    *
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisInverted="true";
    * ```
    *
    * The default value of `yAxisInverted` is false.
    */
    get yAxisInverted() {
        return this.i.iq;
    }
    set yAxisInverted(v) {
        this.i.iq = ensureBool(v);
    }
    /**
     * Gets or sets Horizontal alignment of the X-axis title.
    *
    * Set `xAxisTitleAlignment` to control the horizontal alignment of the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisTitle="x axis"
    *     xAxisTitleAlignment="right">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisTitleAlignment="right";
    * ```
    */
    get xAxisTitleAlignment() {
        return this.i.nv;
    }
    set xAxisTitleAlignment(v) {
        this.i.nv = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets Vertical alignment of the Y-axis title.
    *
    * Set `yAxisTitleAlignment` to control the vertical alignment of the x-axis title.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisTitle="y axis"
    *     yAxisTitleAlignment="bottom">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisTitleAlignment="bottom";
    * ```
    */
    get yAxisTitleAlignment() {
        return this.i.ou;
    }
    set yAxisTitleAlignment(v) {
        this.i.ou = ensureEnum(VerticalAlignment_$type, v);
    }
    /**
     * Gets or sets Horizontal alignment of X-axis labels.
    */
    get xAxisLabelHorizontalAlignment() {
        return this.i.nu;
    }
    set xAxisLabelHorizontalAlignment(v) {
        this.i.nu = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets Horizontal alignment of Y-axis labels.
    *
    * Set the `yAxisLabelHorizontalAlignment` property to change the horizontal alignment of y-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisExtent="250"
    *     yAxisLabelHorizontalAlignment="left">
    * </igx-category-chart>
    * ```
    */
    get yAxisLabelHorizontalAlignment() {
        return this.i.nw;
    }
    set yAxisLabelHorizontalAlignment(v) {
        this.i.nw = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets Vertical alignment of X-axis labels.
    *
    * Use the `xAxisLabelVerticalAlignment` property to change the vertical position of x-axis labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisExtent="250"
    *     xAxisLabelVerticalAlignment="bottom">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelVerticalAlignment="bottom";
    * ```
    */
    get xAxisLabelVerticalAlignment() {
        return this.i.os;
    }
    set xAxisLabelVerticalAlignment(v) {
        this.i.os = ensureEnum(VerticalAlignment_$type, v);
    }
    /**
     * Gets or sets Vertical alignment of Y-axis labels.
    */
    get yAxisLabelVerticalAlignment() {
        return this.i.ot;
    }
    set yAxisLabelVerticalAlignment(v) {
        this.i.ot = ensureEnum(VerticalAlignment_$type, v);
    }
    /**
     * Gets or sets Visibility of X-axis labels.
    *
    * To hide the x-axis labels, set `xAxisLabelVisibility` to collapsed.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisLabelVisibility="collapsed">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.xAxisLabelVisibility="collapsed";
    * ```
    */
    get xAxisLabelVisibility() {
        return this.i.ox;
    }
    set xAxisLabelVisibility(v) {
        this.i.ox = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets Visibility of Y-axis labels.
    *
    * To hide the y-axis labels, set `yAxisLabelVisibility` to collapsed.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelVisibility="collapsed">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelVisibility="collapsed"";
    * ```
    */
    get yAxisLabelVisibility() {
        return this.i.oy;
    }
    set yAxisLabelVisibility(v) {
        this.i.oy = ensureEnum(Visibility_$type, v);
    }
    /**
     * The location of Y-axis labels, relative to the plot area.
    *
    * Set the `yAxisLabelLocation` property to change the location of the y-axis and its labels.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisLabelLocation="outsideRight">
    * </igx-category-chart>
    * ```
    *
    * ```ts
    * this.chart.yAxisLabelLocation="outsideRight";
    * ```
    */
    get yAxisLabelLocation() {
        return this.i.il;
    }
    set yAxisLabelLocation(v) {
        this.i.il = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
     * Gets or sets the format string for the X axis label.
    */
    get xAxisLabelFormat() {
        return this.i.k9;
    }
    set xAxisLabelFormat(v) {
        this.i.k9 = v;
    }
    /**
     * Gets or sets the format specifiers to use with the XAxisLabelFormat string.
    */
    get xAxisLabelFormatSpecifiers() {
        return this.i.ib;
    }
    set xAxisLabelFormatSpecifiers(v) {
        this.i.ib = v;
    }
    /**
     * Gets or sets the format string for the Y axis label.
    */
    get yAxisLabelFormat() {
        return this.i.md;
    }
    set yAxisLabelFormat(v) {
        this.i.md = v;
    }
    /**
     * Gets or sets the format specifiers to use with the YAxisLabelFormat string.
    */
    get yAxisLabelFormatSpecifiers() {
        return this.i.ic;
    }
    set yAxisLabelFormatSpecifiers(v) {
        this.i.ic = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxisLabelFormatSpecifiers != null && arrayFindByName(this.xAxisLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.xAxisLabelFormatSpecifiers, name);
        }
        if (this.yAxisLabelFormatSpecifiers != null && arrayFindByName(this.yAxisLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.yAxisLabelFormatSpecifiers, name);
        }
        return null;
    }
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    /**
     * Converts the given visual location to a data value.
    
    * @param unscaledValue  * The x-coordinate of the location to scale.
    */
    getScaledValueX(unscaledValue) {
        let iv = this.i.jp(unscaledValue);
        return (iv);
    }
    /**
     * Converts the given data value to a visual location.
    
    * @param scaledValue  * The data value to un-scale.
    */
    getUnscaledValueX(scaledValue) {
        let iv = this.i.jr(scaledValue);
        return (iv);
    }
    /**
     * Converts the given visual location to a data value.
    
    * @param unscaledValue  * The y-coordinate of the location to scale.
    */
    getScaledValueY(unscaledValue) {
        let iv = this.i.jq(unscaledValue);
        return (iv);
    }
    /**
     * Converts the given data value to a visual location.
    
    * @param scaledValue  * The data value to un-scale.
    */
    getUnscaledValueY(scaledValue) {
        let iv = this.i.js(scaledValue);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxXYChartComponent.prototype, "xAxisFormatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxXYChartComponent.prototype, "yAxisFormatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisLabelTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisLabelTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisTitleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisTitleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisLabelTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisLabelTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisTitleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisTitleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxXYChartComponent.prototype, "xAxisLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxXYChartComponent.prototype, "yAxisLabel", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisMajorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisMajorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisMajorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisMajorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisMinorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisMinorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisStrip", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisStrip", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTickLength", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTickLength", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisTickStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisTickStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTickStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTickStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisTitle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisTitle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisMinorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisMinorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxXYChartComponent.prototype, "xAxisInverted", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxXYChartComponent.prototype, "yAxisInverted", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisTitleAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisTitleAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "xAxisLabelVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxXYChartComponent.prototype, "yAxisLabelLocation", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "xAxisLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxXYChartComponent.prototype, "xAxisLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxXYChartComponent.prototype, "yAxisLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxXYChartComponent.prototype, "yAxisLabelFormatSpecifiers", null);

let defaultFont = "\"Verdana\", Arial, sans-serif";
const ɵ0 = function () {
    let DataChartStylingDefaults = {
        "ui-chart-category-axis-tick": {
            "height": "5px",
            "color": "rgba(102, 102, 102, 0.2470)"
        },
        "ui-chart-area-fill-opacity": {
            "opacity": "0.7"
        },
        "ui-chart-aligned-gridlines": {
            "visibility": "visible"
        },
        "ui-chart-axis-stroke": {
            /* transparent is treated as auto */
            "border-top-color": "transparent"
        },
        "ui-chart-axis-major-line": {
            /* transparent is treated as auto */
            "border-top-color": "transparent"
        },
        "font-family": defaultFont,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "11px",
        "color": "#666666",
        "font-variant": "",
        "line-height": "",
        "default-font-height": 13
    };
    addPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-axis", null, "rgba(102, 102, 102, 0.2470)");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-title", defaultFont, "16px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-subtitle", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-horizontal-axis-title", defaultFont, "11px", "#666", "0px", "0px", "0px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-chart-vertical-axis-title", defaultFont, "11px", "#666", "0px", "0px", "5px", "0px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-horizontal-axis-labels", defaultFont, "12px", "#666", "0px", "5px", "0px", "5px", null, "top");
    addTextThemeEntry(DataChartStylingDefaults, "ui-vertical-axis-labels", defaultFont, "12px", "#666", "5px", "0px", "5px", "0px", "right");
    addTextThemeEntry(DataChartStylingDefaults, "ui-angular-axis-labels", null, null, "#666", "5px", "5px", "5px", "5px");
    addTextThemeEntry(DataChartStylingDefaults, "ui-radial-axis-labels", null, null, "#666", "0px", "5px", "0px", "5px", null, "top");
    addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-palette", ["#7446B9", "#9FB328", "#F96232", "#2E9CA6", "#DC3F76", "#FF9800", "#3F51B5", "#439C47", "#795548", "#9A9A9A", "#C62828", "#9f725f"], null);
    addBrushPaletteThemeEntry(DataChartStylingDefaults, "ui-chart-marker-palette", ["#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff", "#fff"], ["#7446B9", "#9FB328", "#F96232", "#2E9CA6", "#DC3F76", "#FF9800", "#3F51B5", "#439C47", "#795548", "#9A9A9A", "#C62828", "#9f725f"]);
    return DataChartStylingDefaults;
};
let DataChartStylingDefaults = (ɵ0)();

var IgxCategoryXAxisComponent_1;
/**
 * Represents a IgxDataChartComponent category X axis.
*
* `IgxCategoryXAxisComponent` class represents a IgxDataChartComponent category X axis.
*
* ```html
* <igx-data-chart [dataSource]="data">
*   <igx-category-x-axis #xAxis
*     label="label" >
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis>
*   </igx-numeric-y-axis>
*   <igx-column-series
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     valueMemberPath="value">
*   </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath="value";
* this.chart.series.add(series);
* ```
*/
const IgxCategoryXAxisComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryXAxisComponent) }];
let IgxCategoryXAxisComponent = IgxCategoryXAxisComponent_1 = class IgxCategoryXAxisComponent extends IgxCategoryAxisBaseComponent {
    constructor() {
        super();
        this._actualIntervalChange = null;
        this._actualMinorIntervalChange = null;
    }
    createImplementation() {
        return new CategoryXAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the frequency of displayed labels.
     * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
    *
    * `interval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="label"
    *     interval="3">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * xAxis.interval="3";
    * series.yAxis = this.yAxis;
    *
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    get interval() {
        return this.i.le;
    }
    set interval(v) {
        this.i.le = +v;
    }
    /**
     * Gets the effective value for the current Interval.
    *
    * ```ts
    * let effectiveInterval: number = xAxis.actualInterval;
    * ```
    */
    get actualInterval() {
        return this.i.k9;
    }
    set actualInterval(v) {
        this.i.k9 = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines.
     * The set value is a factor that determines how the minor lines will be displayed.
    *
    * `minorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
    *
    * `minorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `minorInterval` to 0.1.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="label"
    *     minorInterval="0.1"
    *     minorStroke="green"
    *     minorStrokeThickness="1">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * xAxis.minorInterval="0.1";
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    get minorInterval() {
        return this.i.lf;
    }
    set minorInterval(v) {
        this.i.lf = +v;
    }
    /**
     * Gets the effective value for the current MinorInterval.
    *
    * ```ts
    * let effectiveMinorInterval: number = xAxis.actualMinorInterval;
    * ```
    */
    get actualMinorInterval() {
        return this.i.la;
    }
    set actualMinorInterval(v) {
        this.i.la = +v;
    }
    /**
     * Scrolls the specified item into view.
    
    * @param item  * Data item to scroll into view
    */
    scrollIntoView(item) {
        this.i.lp(item);
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.lq(minimum, maximum);
    }
    get actualIntervalChange() {
        if (this._actualIntervalChange == null) {
            this._actualIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualInterval;
                if (this.beforeActualIntervalChange) {
                    this.beforeActualIntervalChange(this, ext);
                }
                this._actualIntervalChange.emit(ext);
            });
        }
        return this._actualIntervalChange;
    }
    get actualMinorIntervalChange() {
        if (this._actualMinorIntervalChange == null) {
            this._actualMinorIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinorInterval;
                if (this.beforeActualMinorIntervalChange) {
                    this.beforeActualMinorIntervalChange(this, ext);
                }
                this._actualMinorIntervalChange.emit(ext);
            });
        }
        return this._actualMinorIntervalChange;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryXAxisComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryXAxisComponent.prototype, "actualInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryXAxisComponent.prototype, "minorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryXAxisComponent.prototype, "actualMinorInterval", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryXAxisComponent.prototype, "actualIntervalChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryXAxisComponent.prototype, "actualMinorIntervalChange", null);
IgxCategoryXAxisComponent = IgxCategoryXAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-category-x-axis',
        template: ``,
        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryXAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryXAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryXAxisComponent);

const IgxCategoryChartComponent_PROVIDERS = [];
/**
 * Represents a chart with an ordinal X-axis and a numeric Y-axis.
*
* **Ignite UI for Angular Category Chart** - [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/CategoryChart.html)
*
* The Ignite UI Category Chart is a lightweight, highly performant chart. It can be easily configured to display category data using an extremely simple and intuitive API. All you need to do is provide your data to the chart and it will take care of everything else.
*
* Example:
*
* ```html
* <igx-category-chart
*     [dataSource]="data"    >
* </igx-category-chart>
* ```
*/
let IgxCategoryChartComponent = class IgxCategoryChartComponent extends IgxXYChartComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        super();
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this._dataSource = null;
        this._defaultTooltips = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._zoneRunner = (act) => ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(_elRef.element.nativeElement, this.container);
        renderer.setStyle(this.container, "display", "block");
        renderer.setStyle(this.container, "width", "100%");
        renderer.setStyle(this.container, "height", "100%");
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        var chart = this.i;
        this._chart = chart;
        if (chart.xAxis) {
            let x = new IgxCategoryXAxisComponent();
            x._provideRenderer(ren);
            x._implementation = chart.xAxis;
            chart.xAxis.externalObject = x;
        }
        if (chart.yAxis) {
            let y = new IgxNumericYAxisComponent();
            y._provideRenderer(ren);
            y._implementation = chart.yAxis;
            chart.yAxis.externalObject = y;
        }
        chart.provideContainer(ren);
        this.bindData();
        chart.notifyResized();
        ren.addSizeWatcher(() => {
            this._chart.notifyResized();
        });
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._chart.notifyResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._chart.notifyResized();
    }
    get width() {
        return this._width;
    }
    ngOnDestroy() {
        this._chart.destroy();
        this._wrapper.destroy();
    }
    createImplementation() {
        return new CategoryChart();
    }
    get i() {
        return this._implementation;
    }
    createSeriesComponent(type) {
        if (TypeRegistrar.isRegistered(type)) {
            let s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this.renderer);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    }
    createSeries(type) {
        switch (type) {
            case DataSeriesType.Area:
                return this.createSeriesComponent('IgxAreaSeriesComponent');
            case DataSeriesType.Column:
                return this.createSeriesComponent('IgxColumnSeriesComponent');
            case DataSeriesType.Line:
                return this.createSeriesComponent('IgxLineSeriesComponent');
            case DataSeriesType.Point:
                return this.createSeriesComponent('IgxPointSeriesComponent');
            case DataSeriesType.Spline:
                return this.createSeriesComponent('IgxSplineSeriesComponent');
            case DataSeriesType.SplineArea:
                return this.createSeriesComponent('IgxSplineAreaSeriesComponent');
            case DataSeriesType.StepArea:
                return this.createSeriesComponent('IgxStepAreaSeriesComponent');
            case DataSeriesType.StepLine:
                return this.createSeriesComponent('IgxStepLineSeriesComponent');
            case DataSeriesType.Waterfall:
                return this.createSeriesComponent('IgxWaterfallSeriesComponent');
            case DataSeriesType.ItemToolTipLayer:
                return this.createSeriesComponent('IgxItemToolTipLayerComponent');
            case DataSeriesType.CategoryToolTipLayer:
                return this.createSeriesComponent('IgxCategoryToolTipLayerComponent');
            case DataSeriesType.CrosshairLayer:
                return this.createSeriesComponent('IgxCrosshairLayerComponent');
            case DataSeriesType.FinalValueLayer:
                return this.createSeriesComponent('IgxFinalValueLayerComponent');
            case DataSeriesType.CalloutLayer:
                return this.createSeriesComponent('IgxCalloutLayerComponent');
            case DataSeriesType.CategoryHighlightLayer:
                return this.createSeriesComponent('IgxCategoryHighlightLayerComponent');
            case DataSeriesType.CategoryItemHighlightLayer:
                return this.createSeriesComponent('IgxCategoryItemHighlightLayerComponent');
            default:
                return this.createSeriesComponent('IgxColumnSeriesComponent');
        }
    }
    set dataSource(value) {
        this._dataSource = value;
        this.bindData();
    }
    get dataSource() {
        return this._dataSource;
    }
    bindData() {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    }
    ngAfterContentInit() {
        if (TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
            let c = TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
            let cf = this.componentFactoryResolver.resolveComponentFactory(c);
            //let cr = cf.create(this.injector);
            let cr = this._dynamicContent.createComponent(cf);
            this._defaultTooltips = cr;
            cr.instance.onContentReady.subscribe(() => {
                this._onDefaultTooltipsReady(cr);
            });
            this.container.appendChild(cr.location.nativeElement);
        }
        this._styling(this.container, this);
    }
    createTooltip() {
        if (!TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
            return null;
        }
        let t = TypeRegistrar.get("IgxTooltipContainerComponent");
        let cf = this.componentFactoryResolver.resolveComponentFactory(t);
        //let cr = cf.create(this.injector);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        let self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                let ext = new IgxDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self.container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self.container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            cr.instance.context = c;
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    }
    _ensureTooltipCreated(series) {
        series._ensureTooltipCreated(() => this.createTooltip(), (ele) => {
            let wrapper = new AngularWrapper(ele, this.renderer, this.ngZone);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        });
    }
    _createXAxis() {
        let x = new IgxCategoryXAxisComponent();
        x._provideRenderer(this.renderer);
        return x.i;
    }
    _createYAxis() {
        let y = new IgxNumericYAxisComponent();
        y.provideRenderer(this.renderer);
        return y.i;
    }
    _ensureDefaultTooltip(series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](series);
    }
    _onDefaultTooltipsReady(cr) {
        if (this.i.dataChart) {
            var currSeries = this.i.dataChart.series;
            for (var i = 0; i < currSeries.count; i++) {
                if (currSeries.item(i).externalObject.showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                }
            }
        }
    }
    /**
 * Gets or sets the duration used for animating series plots when the chart is loading into view
*
* `transitionInDuration` controls the length of time taken by the transition-in animation.  Try setting it to 2 seconds:
*
* ```html
* <igx-category-chart
*     [dataSource]="data"
*     isTransitionInEnabled="true"
*     transitionInDuration="2000">
* </igx-category-chart>
* ```
*/
    get transitionInDuration() {
        return this.i.ql;
    }
    set transitionInDuration(v) {
        this.i.ql = +v;
    }
    /**
     * Gets or sets the easing function used for animating series plots when the chart is loading into view
     * This can be set to one of the known values "linear" or "cubic," or it can be set to an easing function which takes a single numeric parameter and returns a number.
    */
    get transitionInEasingFunction() {
        return this.i.pk;
    }
    set transitionInEasingFunction(v) {
        this.i.pk = v;
    }
    /**
     * Gets or sets the type of chart series to generate from the data.
    *
    * The `chartType` property determines the type of data series to display.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     chartType="stepArea">
    * </igx-category-chart>
    * ```
    */
    get chartType() {
        return this.i.o4;
    }
    set chartType(v) {
        this.i.o4 = ensureEnum(CategoryChartType_$type, v);
    }
    /**
     * Gets or sets the behavior for markers in each series which are placed too close together for the current view, resulting in a collision.
    *
    * `markerCollisionAvoidance` controls the technique the chart uses to avoid overlapping markers.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     markerCollisionAvoidance="none">
    * </igx-category-chart>
    * ```
    */
    get markerCollisionAvoidance() {
        return this.i.o6;
    }
    set markerCollisionAvoidance(v) {
        this.i.o6 = ensureEnum(CategorySeriesMarkerCollisionAvoidance_$type, v);
    }
    /**
     * Gets or sets whether animation of series plots is enabled when the chart is loading into view
    *
    * Set `isTransitionInEnabled` to true if you want your chart series to animate into position when the chart is loading into view.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     isTransitionInEnabled="true">
    * </igx-category-chart>
    * ```
    */
    get isTransitionInEnabled() {
        return this.i.ps;
    }
    set isTransitionInEnabled(v) {
        this.i.ps = ensureBool(v);
    }
    /**
     * Gets or sets the method that determines how to animate series plots when the chart is loading into view
    *
    * `transitionInMode` controls the direction of the transition-in animation.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     isTransitionInEnabled="true"
    *     transitionInMode="accordionfromRight">
    * </igx-category-chart>
    * ```
    */
    get transitionInMode() {
        return this.i.o8;
    }
    set transitionInMode(v) {
        this.i.o8 = ensureEnum(CategoryTransitionInMode_$type, v);
    }
    /**
     * Gets or sets the arrival speed used for animating series plots when the chart is loading into view
    *
    * `transitionInSpeedType` controls the speed of the transition-in animation.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     isTransitionInEnabled="true"
    *     transitionInSpeedType="indexScaled">
    * </igx-category-chart>
    * ```
    */
    get transitionInSpeedType() {
        return this.i.pi;
    }
    set transitionInSpeedType(v) {
        this.i.pi = ensureEnum(TransitionInSpeedType_$type, v);
    }
    /**
     * Gets or sets the frequency of displayed labels along the X-axis.
     * Gets or sets the set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
    *
    * `xAxisInterval` determines how often to show a label, tickmark, and/or gridline along the x-axis.  Set this property to _n_ to display a label every _nth_ item.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisInterval="3">
    * </igx-category-chart>
    * ```
    */
    get xAxisInterval() {
        return this.i.qa;
    }
    set xAxisInterval(v) {
        this.i.qa = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines along the X-axis.
     * Gets or sets the set value is a factor that determines how the minor lines will be displayed.
    *
    * `xAxisMinorInterval` determines how often to show a minor gridline along the x-axis.  This property is relevant only when the displayed series is a type with grouping, like column series.
    *
    * `xAxisMinorInterval` is expressed as a number between 0 and 1, representing the frequency of the interval.  To display minor gridlines representing 10ths of an item width, set `xAxisMinorInterval` to 0.1.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisMinorInterval="0.1"
    *     xAxisMinorStroke="green"
    *     xAxisMinorStrokeThickness="1">
    * </igx-category-chart>
    * ```
    */
    get xAxisMinorInterval() {
        return this.i.qb;
    }
    set xAxisMinorInterval(v) {
        this.i.qb = +v;
    }
    /**
     * Gets or sets the amount of space between adjacent categories for the X-axis.
     * The gap is silently clamped to the range [0, 1] when used.
    *
    * Use the `xAxisGap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
    *
    * An `xAxisGap` of 0 allocates no space between items.  An `xAxisGap` of 1 allocates a space between items equal to the width of one item.
    *
    * To set the item spacing to 75% the width of one item, set the `xAxisGap` to 0.75, as in this code:
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisGap="0.75">
    * </igx-category-chart>
    * ```
    */
    get xAxisGap() {
        return this.i.p9;
    }
    set xAxisGap(v) {
        this.i.p9 = +v;
    }
    /**
     * Gets or sets the amount of overlap between adjacent categories for the X-axis.
     * Gets or sets the overlap is silently clamped to the range [-1, 1] when used.
    *
    * Use the `xAxisOverlap` property to configure the spacing between items on the x-axis.  This property is relevant only when the displayed series is a type with item spacing, like column series.
    *
    * An `xAxisOverlap` of 0 places grouped items adjacent to each other.  An `xAxisOverlap` of 1 places grouped items in the same axis space, completely overlapping.  An `xAxisOverlap` of -1 places a space between grouped items equal to the width of one item.
    *
    * To place grouped items with 75% overlap, set the `xAxisOverlap` to 0.75, as in this code:
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     xAxisOverlap="0.75">
    * </igx-category-chart>
    * ```
    */
    get xAxisOverlap() {
        return this.i.qc;
    }
    set xAxisOverlap(v) {
        this.i.qc = +v;
    }
    /**
     * Gets or sets the distance between each label and grid line along the Y-axis.
    *
    * `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisInterval="10">
    * </igx-category-chart>
    * ```
    */
    get yAxisInterval() {
        return this.i.qf;
    }
    set yAxisInterval(v) {
        this.i.qf = +v;
    }
    /**
     * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
     * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
    *
    * Set `yAxisIsLogarithmic` to true if you want the y-axis to be a logarithmic scale.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisIsLogarithmic="true">
    * </igx-category-chart>
    * ```
    */
    get yAxisIsLogarithmic() {
        return this.i.pu;
    }
    set yAxisIsLogarithmic(v) {
        this.i.pu = ensureBool(v);
    }
    /**
     * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
     * This property is effective only when YAxisIsLogarithmic is true.
    *
    * When `yAxisIsLogarithmic` is true, `yAxisLogarithmBase` sets the logarithm base of the y-axis scale.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisIsLogarithmic="true"
    *     yAxisLogarithmBase="2">
    * </igx-category-chart>
    * ```
    */
    get yAxisLogarithmBase() {
        return this.i.qm;
    }
    set yAxisLogarithmBase(v) {
        this.i.qm = +v;
    }
    /**
     * Gets or sets the data value corresponding to the minimum value of the Y-axis.
    *
    * `yAxisMaximumValue` determines the minimum of the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMinimumValue="42">
    * </igx-category-chart>
    * ```
    */
    get yAxisMinimumValue() {
        return this.i.qh;
    }
    set yAxisMinimumValue(v) {
        this.i.qh = +v;
    }
    /**
     * Gets or sets the data value corresponding to the maximum value of the Y-axis.
    *
    * `yAxisMaximumValue` determines the maximum of the y-axis.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMaximumValue="42">
    * </igx-category-chart>
    * ```
    */
    get yAxisMaximumValue() {
        return this.i.qg;
    }
    set yAxisMaximumValue(v) {
        this.i.qg = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines along the Y-axis.
    *
    * `yAxisMinorInterval` determines how often to show a minor gridline along the y-axis.  Set this property to a number less than the y-axis interval.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisMinorInterval="2"
    *     yAxisMinorStroke="green"
    *     yAxisMinorStrokeThickness="1">
    * </igx-category-chart>
    * ```
    */
    get yAxisMinorInterval() {
        return this.i.qi;
    }
    set yAxisMinorInterval(v) {
        this.i.qi = +v;
    }
    /**
     * Gets the current minimum value for the X-axis.
    */
    get xAxisActualMinimum() {
        return this.i.p8;
    }
    /**
     * Gets the current maximum value for the X-axis.
    */
    get xAxisActualMaximum() {
        return this.i.p7;
    }
    /**
     * Gets the current minimum value for the Y-axis.
    */
    get yAxisActualMinimum() {
        return this.i.qe;
    }
    /**
     * Gets the current maximum value for the Y-axis.
    */
    get yAxisActualMaximum() {
        return this.i.qd;
    }
    /**
     * Gets or sets the palette used for coloring negative items of Waterfall chart type.
    *
    * `negativeBrushes` controls the brushes used by the chart for negative data, when the `chartType` is one that supports negative brushes.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     chartType="waterfall"
    *     negativeBrushes="#ff0000, #cc0000, #aa0000">
    * </igx-category-chart>
    * ```
    */
    get negativeBrushes() {
        return fromBrushCollection(this.i.o1);
    }
    set negativeBrushes(v) {
        this.i.o1 = toBrushCollection(v);
    }
    /**
     * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
    *
    * `negativeOutlines` controls the outlines used by the chart for negative data, when the `chartType` is one that supports negative brushes.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     chartType="waterfall"
    *     negativeOutlines="#0000ff, #0000cc, #0000aa">
    * </igx-category-chart>
    * ```
    */
    get negativeOutlines() {
        return fromBrushCollection(this.i.o2);
    }
    set negativeOutlines(v) {
        this.i.o2 = toBrushCollection(v);
    }
    /**
     * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
    *
    * To abbreviate on the y-axis using formats like "1K" or "1M," set `yAxisAbbreviateLargeNumbers` to true.
    *
    * ```html
    * <igx-category-chart
    *     [dataSource]="data"
    *     yAxisAbbreviateLargeNumbers="true">
    * </igx-category-chart>
    * ```
    */
    get yAxisAbbreviateLargeNumbers() {
        return this.i.pt;
    }
    set yAxisAbbreviateLargeNumbers(v) {
        this.i.pt = ensureBool(v);
    }
    /**
     * Gets or sets whether the category should be highlighted when hovered
    */
    get isCategoryHighlightingEnabled() {
        return this.i.pq;
    }
    set isCategoryHighlightingEnabled(v) {
        this.i.pq = ensureBool(v);
    }
    /**
     * Gets or sets whether the item should be highlighted when hovered
    */
    get isItemHighlightingEnabled() {
        return this.i.pr;
    }
    set isItemHighlightingEnabled(v) {
        this.i.pr = ensureBool(v);
    }
    /**
 * Export serialized visual data.

*/
    exportSerializedVisualData() {
        let iv = this.i.qo();
        return (iv);
    }
    getCurrentXAxisActualMinimum() {
        let iv = this.i.p4();
        return (iv);
    }
    getCurrentYAxisActualMinimum() {
        let iv = this.i.p6();
        return (iv);
    }
    getCurrentXAxisActualMaximum() {
        let iv = this.i.p3();
        return (iv);
    }
    getCurrentYAxisActualMaximum() {
        let iv = this.i.p5();
        return (iv);
    }
};
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxCategoryChartComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCategoryChartComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxCategoryChartComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxCategoryChartComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "transitionInDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxCategoryChartComponent.prototype, "transitionInEasingFunction", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "chartType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "markerCollisionAvoidance", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryChartComponent.prototype, "isTransitionInEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "transitionInMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "transitionInSpeedType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "xAxisInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "xAxisMinorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "xAxisGap", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "xAxisOverlap", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "yAxisInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryChartComponent.prototype, "yAxisIsLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "yAxisLogarithmBase", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "yAxisMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "yAxisMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryChartComponent.prototype, "yAxisMinorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxCategoryChartComponent.prototype, "negativeBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxCategoryChartComponent.prototype, "negativeOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryChartComponent.prototype, "yAxisAbbreviateLargeNumbers", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryChartComponent.prototype, "isCategoryHighlightingEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxCategoryChartComponent.prototype, "isItemHighlightingEnabled", null);
IgxCategoryChartComponent = __decorate([
    Component({
        selector: 'igx-category-chart',
        template: `<ng-container #dynamicContent></ng-container>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxCategoryChartComponent_PROVIDERS,
        host: { 'class': 'ig-category-chart igx-category-chart' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxCategoryChartComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryXAxisModule = class IgxCategoryXAxisModule {
};
IgxCategoryXAxisModule = __decorate([
    NgModule({
        declarations: [IgxCategoryXAxisComponent],
        imports: [CommonModule],
        exports: [IgxCategoryXAxisComponent],
        entryComponents: []
    })
], IgxCategoryXAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryXAxisDynamicModule = class IgxCategoryXAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryXAxisComponent", IgxCategoryXAxisComponent);
        TypeRegistrar.register("CategoryXAxis", CategoryXAxis.$type);
    }
};
IgxCategoryXAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryXAxisModule],
        exports: [IgxCategoryXAxisModule],
        entryComponents: [IgxCategoryXAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryXAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericYAxisModule = class IgxNumericYAxisModule {
};
IgxNumericYAxisModule = __decorate([
    NgModule({
        declarations: [IgxNumericYAxisComponent],
        imports: [CommonModule],
        exports: [IgxNumericYAxisComponent],
        entryComponents: []
    })
], IgxNumericYAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericYAxisDynamicModule = class IgxNumericYAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxNumericYAxisComponent", IgxNumericYAxisComponent);
        TypeRegistrar.register("NumericYAxis", NumericYAxis.$type);
    }
};
IgxNumericYAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxNumericYAxisModule],
        exports: [IgxNumericYAxisModule],
        entryComponents: [IgxNumericYAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxNumericYAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryChartCoreModule = class IgxCategoryChartCoreModule {
    constructor() {
    }
};
IgxCategoryChartCoreModule = __decorate([
    NgModule({
        declarations: [IgxCategoryChartComponent],
        exports: [IgxCategoryChartComponent,
            IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule
        ],
        imports: [CommonModule, IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryChartCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryChartCoreDynamicModule = class IgxCategoryChartCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxCategoryChartComponent', IgxCategoryChartComponent);
    }
};
IgxCategoryChartCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxCategoryChartCoreModule
        ],
        imports: [CommonModule, IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxCategoryChartCoreModule
        ],
        entryComponents: [IgxCategoryChartComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryChartCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let INumberAbbreviator_$type = new Type(null, 'INumberAbbreviator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumberAbbreviator extends Base {
    abbreviate(a) {
        let b = "0.#";
        let c = Math.abs(a);
        let d = ['Q', 'T', 'B', 'M', 'K'];
        let e = [1E+15, 1000000000000, 1000000000, 1000000, 1000];
        for (let f = 0; f < d.length; f++) {
            if (c >= e[f]) {
                return numberToString2((a / e[f]), b) + d[f];
            }
        }
        return a.toString();
    }
}
NumberAbbreviator.$t = markType(NumberAbbreviator, 'NumberAbbreviator', Base.$, [INumberAbbreviator_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumberAbbreviatorModule = class IgxNumberAbbreviatorModule {
    constructor() {
        TypeRegistrar.register('NumberAbbreviator', NumberAbbreviator.$type);
    }
};
IgxNumberAbbreviatorModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxNumberAbbreviatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumberAbbreviatorDynamicModule = class IgxNumberAbbreviatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('NumberAbbreviator', NumberAbbreviator);
        TypeRegistrar.register('NumberAbbreviator', NumberAbbreviator.$type);
    }
};
IgxNumberAbbreviatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumberAbbreviatorModule
        ],
        imports: [CommonModule, IgxNumberAbbreviatorModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxNumberAbbreviatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesInteractionManager extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.a$o = null;
        this.a$c = false;
        this.i = false;
        this.c = false;
        this.d = false;
        this.e = true;
        this.f = false;
        this._toolTipObject = null;
        this.p = null;
        this.s = null;
        this.o = null;
        this.j = false;
        this.k = new Dictionary$2(String_$type, SeriesView.$, 0);
    }
    a$i(a, b, c, d, e, f, g, h) {
        if (d == null) {
            return Number.POSITIVE_INFINITY;
        }
        if (c < 0 || c > g - 1) {
            return Number.POSITIVE_INFINITY;
        }
        let i;
        let j = NaN;
        let k = NaN;
        let l = NaN;
        let m = NaN;
        if (d.cf) {
            let n = d;
            i = h(b);
            let o = truncate(Math.floor(i));
            let p = truncate(Math.ceil(i));
            m = i - o;
            if (o >= 0 && o < g) {
                let q = n.i$d(n.i$b._inner[o]);
                j = d.dy(q, e) + f;
            }
            else {
                j = NaN;
            }
            if (p >= 0 && p < g) {
                let r = n.i$d(n.i$b._inner[p]);
                k = d.dy(r, e) + f;
            }
            else {
                k = NaN;
            }
            if (isNaN_(j) && !isNaN_(k)) {
                j = k;
            }
            if (isNaN_(k) && !isNaN_(j)) {
                k = j;
            }
            if (c >= 0 && c < g) {
                let s = n.i$d(n.i$b._inner[c]);
                l = d.dy(s, e) + f;
            }
        }
        else {
            i = a.eb(b);
            let t = truncate(Math.floor(i));
            let u = truncate(Math.ceil(i));
            m = i - t;
            if (t >= 0 && t < g) {
                j = d.dy(t, e) + f;
            }
            else {
                j = NaN;
            }
            if (u >= 0 && u < g) {
                k = d.dy(u, e) + f;
            }
            else {
                k = NaN;
            }
            if (isNaN_(j) && !isNaN_(k)) {
                j = k;
            }
            if (isNaN_(k) && !isNaN_(j)) {
                k = j;
            }
            if (c >= 0 && c < g) {
                l = d.dy(c, e) + f;
            }
        }
        let v = j + m * (k - j);
        return Math.abs(l - v);
    }
    a$k(a, b, c, d, e, f, g, h, i) {
        let j = NaN;
        if (d >= 0 && d < c.count) {
            j = c.item(d);
        }
        let k = NaN;
        if (e >= 0 && e < c.count) {
            k = c.item(e);
        }
        if (g == 0) {
            return k;
        }
        if (f == c.count - 1) {
            return j;
        }
        if (isNaN_(k) && h != 0 && b <= 0.5 && !i) {
            return j;
        }
        if (isNaN_(j) && h != 0 && b >= 0.5 && !i) {
            return k;
        }
        return j * (1 - b) + k * b;
    }
    a$a(a, b, c, d, e, f, g) {
        if (b == null) {
            return null;
        }
        let h = -1;
        let i = -1;
        if (b.cf) {
            let j = a.lq(f);
            let k = -1;
            let l = b.ca;
            let m = a.bi.br.right * 2;
            k = SeriesInteractionManager.n(c, j, l, m);
            if (k < 0) {
                k = ~k;
                k--;
            }
            if (k < 0) {
                k = 0;
            }
            if (k > c.count - 1) {
                k = c.count - 1;
            }
            let n = k;
            let o = k + 1;
            if (o > c.count - 1) {
                o = c.count - 1;
            }
            h = n;
            i = o;
        }
        else {
            let p = a.fe(f, g);
            let q = a.fc(f, g);
            let r = truncate(Math.floor(p / d));
            let s = truncate(Math.floor(q / d));
            h = r - e;
            i = s - e;
            if (i == h) {
                i++;
            }
        }
        if (h < 0) {
            h = 0;
        }
        if (h > c.count - 1) {
            h = c.count - 1;
        }
        if (i < 0) {
            i = 0;
        }
        if (i > c.count - 1) {
            i = c.count - 1;
        }
        if (h < 0 || i < 0) {
            return null;
        }
        let t = c._inner[h];
        let u = c._inner[i];
        let v = new Array(2);
        v[0] = t;
        v[1] = u;
        return v;
    }
    static n(a, b, c, d) {
        let e = 0;
        let f = a.count - 1;
        while (e <= f) {
            let g = (e + ((f - e) >> 1));
            let h;
            let i = a.item(g);
            if (c) {
                h = (d - b.x) < (d - i[0]) ? -1 : ((d - b.x) > (d - i[0]) ? 1 : 0);
            }
            else {
                h = b.x < i[0] ? -1 : (b.x > i[0] ? 1 : 0);
            }
            if (h < 0) {
                f = g - 1;
            }
            else if (h > 0) {
                e = g + 1;
            }
            else {
                return g;
            }
        }
        return ~e;
    }
    a$n(a, b, c, d, e, f) {
        if (d == null) {
            return -1;
        }
        let g = d.cf;
        let h = a.dv;
        let i = null;
        if (g) {
            i = d;
        }
        let j = -1;
        let k = -1;
        let l = -1;
        if (g) {
            j = e(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        else {
            j = a.eb(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        if (f == null) {
            return -1;
        }
        if (k < 0 || k > f.count - 1) {
            return -1;
        }
        if (!c) {
            return k;
        }
        let m = NaN;
        if (g && !h) {
            if (k < i.i$b.count && i.i$b._inner[k] < f.count) {
                m = f.item(i.i$b._inner[k]);
            }
        }
        else {
            m = f.item(k);
        }
        while (isNaN_(m)) {
            k--;
            if (k < 0 || k > f.count - 1) {
                return -1;
            }
            if (g && !h) {
                m = f.item(i.i$b._inner[k]);
            }
            else {
                m = f.item(k);
            }
        }
        return k;
    }
    a$l(a, b, c, d, e, f, g, h, i) {
        if (b == null) {
            return NaN;
        }
        let j = a.dv;
        let k = a.ff(c, i, d, g, b);
        let l = a.fd(c, i, d, g, b);
        let m = a.d9(c, k, d, e, f);
        let n = a.d9(c, l, d, e, f);
        let o = k;
        let p = l;
        let q = d.cf;
        if (q && !j) {
            let r = d;
            if (k >= 0 && k < r.i$b.count) {
                k = r.i$b._inner[k];
            }
            if (l >= 0 && k < r.i$b.count) {
                l = r.i$b._inner[l];
            }
        }
        let s = m / (n + m);
        if (m == 0) {
            s = 0;
        }
        if (n == 0) {
            s = 1;
        }
        if (!h) {
            if (n <= m) {
                if (l >= 0 && l < b.count) {
                    return b.item(l);
                }
            }
            else {
                if (k >= 0 && k < b.count) {
                    return b.item(k);
                }
            }
            return NaN;
        }
        return a.ef(s, b, k, l, o, p, f, q);
    }
    a$d(a, b, c) {
        let d = a.ai(b);
        let e = a.ah(b);
        if (d == null) {
            return false;
        }
        for (let f = 0; f < d.length; f++) {
            let g = d[f];
            if (g == null || g.length != 2) {
                continue;
            }
            if (GeometryUtil.a(b, g[0], g[1], a.ey / 2 + a.ee(c))) {
                return true;
            }
            if (e != null && f < e.length) {
                let h = e[f];
                if (h == null || h.length != 2) {
                    continue;
                }
                if (GeometryUtil.a(b, h[0], h[1], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                if (GeometryUtil.a(b, g[0], h[0], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                if (GeometryUtil.a(b, g[1], h[1], a.ey / 2 + a.ee(c))) {
                    return true;
                }
                let i = new Array(5);
                i[0] = h[0];
                i[1] = h[1];
                i[2] = g[1];
                i[3] = g[0];
                i[4] = h[0];
                if (PolygonUtil.a(boxArray$1(i), b)) {
                    return true;
                }
            }
        }
        return false;
    }
    a$e(a, b, c, d) {
        if (d == null) {
            return false;
        }
        for (let e = 0; e < d.c.count; e++) {
            let f = d.c._inner[e];
            for (let g = 0; g < f._segments.count; g++) {
                let h = f._segments._inner[g];
                if (GeometryUtil.b(b, f._startPoint, h._points, a.ee(c))) {
                    return true;
                }
            }
        }
        return false;
    }
    a$f(a, b, c) {
        if (c == null) {
            return false;
        }
        if (c.c.count > 0) {
            let d = c.c._inner[0];
            if (d._segments.count > 0) {
                let e = d._segments._inner[0];
                if (PolygonUtil.a(e._points, b)) {
                    return true;
                }
            }
        }
        return false;
    }
    a$m(a, b, c, d, e, f) {
        let g = a.dv;
        let h = d.cf;
        let i = null;
        if (h) {
            i = d;
        }
        let j = -1;
        let k = -1;
        let l = -1;
        if (h) {
            j = e(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        else {
            j = a.eb(b);
            if (isNaN_(j)) {
                return -1;
            }
            k = truncate(Math.floor(j));
            l = truncate(Math.ceil(j));
        }
        if (f == null) {
            return -1;
        }
        if (l < 0 || l > f.count - 1) {
            return -1;
        }
        if (!c) {
            return l;
        }
        let m = NaN;
        if (h && !g) {
            if (l < i.i$b.count && i.i$b._inner[l] < f.count) {
                m = f.item(i.i$b._inner[l]);
            }
        }
        else {
            m = f.item(l);
        }
        while (isNaN_(m)) {
            l++;
            if (l < 0 || l > f.count - 1) {
                return -1;
            }
            if (h && !g) {
                m = f.item(i.i$b._inner[l]);
            }
            else {
                m = f.item(l);
            }
        }
        return l;
    }
    a$j(a, b, c) {
        let d = a.bi.bs;
        let e = a.bi.br;
        if (d.isEmpty || e.isEmpty || c == null) {
            return -1;
        }
        let f = a.getEffectiveViewport1(a.bi);
        let g = null;
        if (c.cf) {
            g = c;
        }
        let h = new ScalerParams(0, d, e, c.ca, f);
        if (a.bs == null) {
            return -1;
        }
        h.c = a.getEffectiveViewport1(a.bi);
        let i = a.l0(a.bi);
        let j = 0;
        if (c.ch) {
            let k = c.d1(i.top, h);
            let l = c.d1(i.bottom, h);
            let m = (b.y - d.top) / d.height;
            j = k + ((l - k) * m);
        }
        else {
            if (c.b5) {
                let n = c.d1(i.left, h);
                let o = c.d1(i.right, h);
                let p = (b.x - d.left) / d.width;
                j = n + ((o - n) * p);
            }
            else {
                let q = new Rect(0, 0, 0, 1, 1);
                j = c.d1(b.x, new ScalerParams(1, q, q, c.ca));
            }
        }
        if (c.b7) {
        }
        let r = g.i$c(j);
        return r;
    }
    a$g(a, b, c) {
        let d = a.l5(b);
        if (d.isEmpty) {
            return false;
        }
        let e = RectUtil.r(d, a.ee(c));
        return e.containsPoint(b);
    }
    a$aj(a, b, c, d, e, f, g, h, i, j) {
        if (f == null || g == null || a.bi == null || a.bi.bs.isEmpty || a.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        let k = a.getEffectiveViewport1(a.bi);
        let l = new ScalerParams(0, a.bi.bs, a.bi.br, f.ca, k);
        if (f.ch) {
            l.b = a.eh();
        }
        l.c = a.getEffectiveViewport1(a.bi);
        let m = a.bi;
        let n;
        if (g.ch) {
            n = b.y;
            n = m.br.top + m.br.height * (n - m.bs.top) / m.bs.height;
        }
        else {
            n = b.x;
            n = m.br.left + m.br.width * (n - m.bs.left) / m.bs.width;
        }
        if (!c && g != null) {
            let o;
            let p;
            if (i != null) {
                o = i(b, d);
            }
            else {
                o = a.fe(b, d);
            }
            if (j != null) {
                p = j(b, d);
            }
            else {
                p = a.fc(b, d);
            }
            if (o == -1 && p == -1) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            let q = new ScalerParams(0, m.bs, m.br, g.ca, k);
            q.c = a.bs.oh;
            let r = a.d9(b, o, g, q, e);
            let s = a.d9(b, p, g, q, e);
            let t = p;
            let u = o;
            if (g.cf) {
                let v = g;
                if (t >= 0 && t < v.i$b.count) {
                    t = v.i$d(v.i$b._inner[truncate(t)]);
                }
                if (u >= 0 && u < v.i$b.count) {
                    u = v.i$d(v.i$b._inner[truncate(u)]);
                }
            }
            if ((s + r) != 0) {
                let w = s / (r + s);
                if (Math.abs(w - 0.5) < 1E-07) {
                    s = r;
                }
            }
            if (s <= r) {
                n = g.dy(t, q) + e;
            }
            else {
                n = g.dy(u, q) + e;
            }
        }
        else {
            if (g.b4 && !g.b7 && g.categoryMode != 0) {
                let x = 0.5 * g.getCategorySize(m.bs, m.br, a.getEffectiveViewport1(m));
                if (a.isVertical) {
                    x = x * -1;
                }
                if (g.ca) {
                    x = x * -1;
                }
                n -= x;
                n += e;
            }
        }
        let y;
        if (h != null) {
            y = h(b, c, d);
        }
        else {
            y = a.en(b, c, d);
        }
        let z = f.dy(y, l);
        if (g.ch) {
            return { $type: Point_$type, x: z, y: n };
        }
        else {
            return { $type: Point_$type, x: n, y: z };
        }
    }
    a$t(a, b, c, d, e) {
        if (a.bs.dr() && !e) {
            return;
        }
        if (!a.b9) {
            return;
        }
        if (a.bs == null) {
            return;
        }
        let f = null;
        let g = null;
        let h = a.bs.az;
        let i = a.bs.b2;
        if (e && this.a != null) {
            f = this.a;
        }
        else {
            f = a.at(b, c);
            if (this.a != null && this.a != f) {
                if (a.bs != null) {
                    h.endHighlight(this.a);
                }
            }
            this.a = f;
        }
        if (a.hasMarkers) {
            if (e && this.b != null) {
                g = this.b;
            }
            else {
                g = a.au(b, c);
                if (this.b != null && this.b != g) {
                    h.endHighlight(this.b);
                }
                this.b = g;
            }
        }
        let j = true;
        if (e) {
            h.endHighlight(f);
            if (g != null) {
                h.endHighlight(g);
            }
        }
        else {
            if (d || !j) {
                h.startHighlight(f);
                if (g != null) {
                    h.startHighlight(g);
                }
            }
        }
        if (!i.f() && i.r > 0) {
            i.v();
        }
        if (i.r == 0) {
            a.bs.lj(1);
        }
    }
    a$ai(a, b, c) {
        let d = b.d;
        d = d * 0.5;
        return this.r(c, d);
    }
    r(a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.l(a, b);
    }
    a$w(a, b, c, d, e) {
        let f = a.bi;
        f.aj();
        this.a$c = true;
        let g = a.fv(c, b);
        this.a$o = g;
        if (!e && a.bs != null && !a.aq.c) {
            this.q(a, b, g, d);
        }
        this.c = false;
        if (a.db && g == null) {
            this.c = true;
        }
        if (a.bs != null && !this.c) {
            if (a.db) {
                this.d = true;
            }
            this.a$t(a, g, a.ly(b), true, false);
            a.bs.jy(a, g, d);
        }
    }
    a$ag(a, b) {
        let c = null;
        let d = null;
        let e;
        let f = ((() => { let g = a.bs.b1.e(b, false, e, false); e = g.p2; return g.ret; })());
        if (f != a) {
            if (this.a$c) {
                this.a$x(a, b, null, null);
            }
            return;
        }
        c = e;
        if (!this.a$c) {
            this.a$w(a, b, c, d, false);
        }
        this.a$z(a, b, c, d, false);
    }
    a$z(a, b, c, d, e) {
        this.a$c = true;
        let f = a.fv(c, b);
        if (!e) {
            this.q(a, b, f, d);
        }
        if (f != null) {
            this.a$o = f;
        }
        if (a.bs != null && f != null && this.c) {
            this.c = false;
            this.d = true;
            this.a$t(a, f, a.ly(b), true, false);
            a.bs.jy(a, f, d);
        }
        if (a.bs != null && (!a.db || f != null) && !this.c) {
            this.a$t(a, f, a.ly(b), true, false);
            a.bs.j2(a, f, d);
        }
        if (f == null && !this.c && a.db) {
            this.a$t(a, f, a.ly(b), false, true);
            a.bs.jz(a, this.a$o, d);
            this.d = false;
            this.c = true;
        }
    }
    a$x(a, b, c, d) {
        a.bi.ak();
        this.a$c = false;
        let e = this.a$o;
        a.bi.am();
        if (a.bs != null && (this.d || !a.db)) {
            this.d = false;
            this.c = false;
            this.a$t(a, e, a.ly(b), false, true);
            a.bs.jz(a, e, d);
        }
    }
    a$u(a, b, c, d) {
        this.i = true;
        if (a.bs != null) {
            a.bs.j0(a, a.fv(c, b), d);
        }
    }
    a$y(a, b, c, d) {
        this.i = false;
        if (a.bs != null) {
            a.bs.j1(a, a.fv(c, b), d);
        }
    }
    a$v(a, b, c, d) {
        if (a.bi.p) {
            return;
        }
        if (this.i) {
            this.a$y(a, b, c, d);
        }
        if (this.a$c) {
            this.a$x(a, b, c, d);
        }
    }
    a$aa(a, b, c, d) {
        if (a.bs != null) {
            a.bs.j3(a, a.fv(c, b), d);
        }
    }
    a$ab(a, b, c, d) {
        if (a.bs != null) {
            a.bs.j4(a, a.fv(c, b), d);
        }
    }
    get g() {
        return this.c;
    }
    set g(a) {
        this.c = a;
    }
    get a$b() {
        return this.d;
    }
    set a$b(a) {
        this.d = a;
    }
    q(a, b, c, d) {
        let e = false;
        if (a.bs != null) {
            e = a.bs.db;
        }
        if (e) {
            return;
        }
        if (a.bs == null || a.bs.c3) {
            return;
        }
        this.j = true;
        this.s = b;
        this.o = c;
        a.bi.d.item = c;
        a.bi.d.itemLabel = a.fr(c);
        let f = a.bs.nv();
        let pos_ = { $type: Point_$type, x: b.x + 15 + f.x, y: b.y + 15 + f.y };
        let context_ = a.bi.d;
        let g = false;
        if (this._toolTipObject != null) {
            g = (this._toolTipObject._inPointer);
            this._toolTipObject._inPointer = false;
        }
        if (this._toolTipObject != null) {
            if (this.f || g) {
                this.f = false;
                this._toolTipObject.remove();
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.addClass(a.bs.hu);
                a.bs.h6(this._toolTipObject);
                this._toolTipObject.hide();
            }
            if (this.e) {
                a.bs.h6(this._toolTipObject);
                this.e = false;
            }
            context_.hideOthers = true;
            if ((this._toolTipObject.updateToolTip && !this._toolTipObject.updateToolTip(context_))) {
                this.a$s(a);
            }
            let h = window.pageXOffset;
            let i = window.pageYOffset;
            let j = document.documentElement.clientWidth;
            let k = document.documentElement.clientHeight;
            let l = this._toolTipObject.outerWidthWithMargin();
            let m = this._toolTipObject.outerHeightWithMargin();
            let n = pos_.x;
            let o = pos_.y;
            let p = 5;
            let q = 30;
            if (l + n - h + p > j) {
                pos_.x -= q;
                pos_.x -= l;
            }
            if (m + o - i + p > k) {
                pos_.y -= q;
                pos_.y -= m;
            }
            this._toolTipObject.setOffset(pos_.x, pos_.y);
        }
    }
    a$af(a, b, c) {
        this.j = true;
        let d = { $type: Point_$type, x: b.x + a.bi.br.left, y: b.y + a.bi.br.top };
        let e = a.fv(null, d);
        if (a.bi.d != null) {
            a.bi.d.series = a;
            a.bi.d.item = e;
        }
        let tooltip_ = this._toolTipObject;
        let context_ = a.bi.d;
        let f = false;
        if (this._toolTipObject != null) {
            f = (this._toolTipObject._inPointer);
            this._toolTipObject._inPointer = false;
        }
        if (context_ != null) {
            context_.hideOthers = false;
        }
        if ((!this.f || f) && tooltip_ != null) {
            this.f = true;
            tooltip_.remove();
            tooltip_.setStyleProperty("position", "relative");
            tooltip_.setStyleProperty("top", "");
            tooltip_.setStyleProperty("left", "");
            tooltip_.removeClass(a.bs.hu);
        }
        if (this._toolTipObject != null) {
            if (tooltip_.updateToolTip) {
                tooltip_.updateToolTip(context_);
            }
            ;
        }
        if (tooltip_ != null) {
            c(tooltip_);
        }
    }
    a$p(a) {
        let b = "<div class='ui-chart-default-tooltip-content'><span";
        let c = this.a$q(a);
        if (!stringIsNullOrEmpty(c)) {
            b += " style='color:" + c + "'";
        }
        b += ">" + a.fx + "</span></div>";
        return b;
    }
    h(a, b) {
        let c = a != null && Color.e(toNullable(Color.$, a.color), toNullable(Color.$, null));
        c = c && a.color.l > 0;
        c = c && Color.d(a.color, b);
        return !c;
    }
    a$q(a) {
        let b = new Color();
        let c = a != null && a.bs != null && a.bs.b1 != null && a.bs.b1.i != null ? a.bs.b1.i.ae : null;
        c.startCSSQuery();
        b.colorString = c.getCssDefaultPropertyValue("ui-chart-pointer-tooltip", "background-color");
        c.endCSSQuery();
        if (!this.h(a.lc, b)) {
            return a.lc._fill;
        }
        if (!this.h(a.lb, b)) {
            return a.lb._fill;
        }
        return null;
    }
    a$s(a) {
        if (this._toolTipObject != null && this.j) {
            this.j = false;
            let context_ = a.bi.d;
            if (this._toolTipObject.hideToolTip) {
                this._toolTipObject.hideToolTip(context_);
            }
            ;
        }
    }
    a$ah(a, b) {
        let c = this._toolTipObject;
        this.p = null;
        this._toolTipObject = null;
        if (typeof b === 'string') {
            this.p = b;
        }
        else {
            this._toolTipObject = b;
            if (this._toolTipObject != null) {
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.setStyleProperty("top", "0px");
                this._toolTipObject.setStyleProperty("left", "0px");
                this._toolTipObject.setStyleProperty("z-index", "10000");
                this._toolTipObject.setStyleProperty("pointer-events", "none");
                let d = a.lc != null && Color.e(toNullable(Color.$, a.lc.color), toNullable(Color.$, null)) && a.lc.color.l > 0;
                if (d) {
                    this._toolTipObject.setStyleProperty("border-color", a.lc._fill);
                }
            }
            else {
                if (!this.e && c != null) {
                    a.bs.k4(c);
                    this.e = true;
                }
            }
        }
    }
    a$ae(a) {
    }
    get a$h() {
        return this.k;
    }
    a$r(a, b, c, d, e) {
        let f;
        if (!((() => { let g = this.k.tryGetValue(d, f); f = g.p1; return g.ret; })())) {
            f = a.bg();
            f.n = true;
            f.m = true;
            if (a.bs != null) {
                f.a = a.bs.ag;
                a.bs.ag.l(f);
            }
            f.ap();
            f.aa = d;
            this.k.item(d, f);
        }
        f.s = e;
        f.br = b;
        f.bq = c;
    }
    a$ad(a, b, c) {
        let d;
        let e = c;
        if (e == null) {
            e = a.bs;
        }
        if (((() => { let f = this.k.tryGetValue(b, d); d = f.p1; return f.ret; })())) {
            if (e != null) {
                d.a = null;
                e.ag.r(d);
            }
            this.k.removeItem(b);
        }
    }
    a$ac(a, b) {
        let c = new List$1(String_$type, 0);
        for (let d of fromEnum(this.k.keys)) {
            c.add(d);
        }
        for (let e = 0; e < c.count; e++) {
            this.a$ad(a, c._inner[e], b);
        }
    }
}
SeriesInteractionManager.$t = markType(SeriesInteractionManager, 'SeriesInteractionManager', Base.$, [ISeriesInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IVerticalAnchoredCategorySeriesInteractionManager_$type = new Type(null, 'IVerticalAnchoredCategorySeriesInteractionManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategorySeriesInteractionManager extends Base {
    b$c(a, b) {
        let c = a.bi.bs;
        let d = a.bi.br;
        let e = a.ap();
        let f = a.getEffectiveViewport1(a.bi);
        let g = a.l0(a.bi);
        let h = -1;
        if (e != null && !c.isEmpty && !d.isEmpty) {
            let i = new ScalerParams(0, c, d, e.ca, f);
            let j = e.d1(g.left, i);
            let k = e.d1(g.right, i);
            let l = (b.x - c.left) / c.width;
            let m = j + (l * (k - j));
            if (e.categoryMode != 0) {
                m -= 0.5;
            }
            h = m;
        }
        return h;
    }
    b$f(a, b) {
        let c = 0;
        if (a.c1) {
            c = a.fa(b);
            if (c == -1) {
                return null;
            }
        }
        else if (b.x == 1 && a.bz != null) {
            c = a.bz.count - 1;
        }
        else {
            c = a.e8(b);
        }
        return c >= 0 && a.bz != null && c < a.bz.count ? a.bz.item(c) : null;
    }
    b$d(a, b) {
        let c = a.bi.bs;
        let d = a.bi.br;
        let e = a.getEffectiveViewport1(a.bi);
        if (c.isEmpty || d.isEmpty) {
            return -1;
        }
        if (isNaN_(b.x)) {
            return -1;
        }
        let f = a.ap();
        if (f == null) {
            return -1;
        }
        let g = typeCast(ISortingAxis_$type, f);
        let h = a.l0(a.bi);
        let i = new ScalerParams(0, c, d, f.ca, e);
        let j = 0;
        if (f.cd) {
            let k = (b.x - c.left) / c.width;
            let l = k * h.width + h.left;
            j = f.d1(l, i);
        }
        else {
            let m = f.d1(h.left, i);
            let n = f.d1(h.right, i);
            let o = (b.x - c.left) / c.width;
            j = m + ((n - m) * o);
        }
        let p = g.i$f(j);
        return p;
    }
    b$e(a, b, c) {
        let d = a.bi.br;
        let e = a.bi.bs;
        let f = a.ap();
        let g = 0;
        if (f.ch) {
            let h = (c.y - e.top) / e.height;
            g = h * d.height + d.top;
        }
        else {
            let i = (c.x - e.left) / e.width;
            g = i * d.width + d.left;
        }
        if (f.ca) {
            let j = b.count;
            let k = 0;
            for (k = j - 1; k >= 0; k--) {
                let l = b._inner[k];
                let m = null;
                if (k > 0) {
                    m = b._inner[k - 1];
                }
                if (l[0] <= g && m == null || m[0] >= g) {
                    if (m != null) {
                        if (Math.abs(l[0] - g) < Math.abs(m[0] - g)) {
                            return k;
                        }
                        else {
                            return k - 1;
                        }
                    }
                    else {
                        return k;
                    }
                }
            }
            return k;
        }
        else {
            let n = b.count;
            let o = 0;
            for (o = 0; o < n; o++) {
                let p = b._inner[o];
                let q = null;
                if (o < n - 1) {
                    q = b._inner[o + 1];
                }
                if (p[0] <= g && q == null || q[0] >= g) {
                    if (q != null) {
                        if (Math.abs(p[0] - g) < Math.abs(q[0] - g)) {
                            return o;
                        }
                        else {
                            return o + 1;
                        }
                    }
                    else {
                        return o;
                    }
                }
            }
            return o;
        }
    }
    b$a(a, b, c, d, e, f, g, h) {
        let i = a.bz.count;
        let j = a.ap();
        let k = -1;
        let l = -1;
        if (j.cf) {
            let m = this.b$e(a, b, g);
            k = m;
            l = m;
        }
        else {
            let n = a.e8(g);
            k = truncate(Math.floor((intDivide(n, e)))) * e;
            l = k + (e - 1);
        }
        if (h != null && h.f == k && h.e == l) {
            return h;
        }
        let o = new HighlightingInfo();
        o.b = a;
        o.f = k;
        o.e = l;
        return o;
    }
    b$b(a, b, c, d, e, f) {
        let g = a.lq(e);
        let h = b;
        if (h == null) {
            return null;
        }
        let i = h.count;
        if (i == 0) {
            return null;
        }
        let j = h._inner[0].al;
        if (a.isVertical) {
            let k = c._inner[h._inner[0].al][0];
            let l = (g.y - k) * (g.y - k);
            let m;
            for (let n = 0; n < i; n++) {
                k = c._inner[h._inner[n].al][0];
                m = (g.y - k) * (g.y - k);
                if (m <= l) {
                    l = m;
                    j = h._inner[n].al;
                }
            }
        }
        else {
            let o = c._inner[h._inner[0].al][0];
            let p = (g.x - o) * (g.x - o);
            let q;
            for (let r = 0; r < i; r++) {
                o = c._inner[h._inner[r].al][0];
                q = (g.x - o) * (g.x - o);
                if (q <= p) {
                    p = q;
                    j = h._inner[r].al;
                }
            }
        }
        let s = new HighlightingInfo();
        s.b = a;
        s.c = true;
        s.f = j;
        s.e = s.f;
        if (f != null && f.f == s.f && f.e == s.e) {
            return f;
        }
        return s;
    }
}
CategorySeriesInteractionManager.$t = markType(CategorySeriesInteractionManager, 'CategorySeriesInteractionManager', Base.$, [ICategorySeriesInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnchoredCategorySeriesInteractionManager extends Base {
    c$b(a, b, c, d, e, f, g, h) {
        if (!g) {
            return h(b);
        }
        if (e == null || e.cf || f == null || d == null || isNaN_(b.x) || isNaN_(b.y)) {
            return h(b);
        }
        if (c <= 1) {
            return h(b);
        }
        let i = truncate(Math.round(a.eb(b)));
        if (i < 0 || i >= a.bz.count) {
            return h(b);
        }
        let j = intDivide(i, c);
        let k = c * j;
        let l = Math.min(k + c, d.count - 1);
        let m = a.l0(a.bi);
        let n = new ScalerParams(0, a.bs.oi, a.bs.oh, f.ca, a.bs.n6);
        let o = m.top;
        let p = m.bottom;
        let q = o + (p - o) * b.y;
        let r = f.d1(q, n);
        let s = 1.7976931348623157E+308;
        let t = k;
        for (let u = k; u <= l; u++) {
            let v = Math.abs(d.item(u) - r);
            if (v < s) {
                s = v;
                t = u;
            }
        }
        return a.bz.item(t);
    }
    c$a(a, b, c, d, e, f) {
        let g = a.bi.bs;
        g = g.copy();
        let h = a.bi.br;
        let i = new Rect(0, 0, 0, 1, 1);
        let j = !g.isEmpty && !h.isEmpty && a.bz != null ? a.bz.indexOf(f) : -1;
        let k = a.l2(a.bi);
        let l = new ScalerParams(0, i, i, c.ca, k);
        let m = new ScalerParams(0, i, i, d.ca, k);
        m.b = a.eh();
        let n = c != null ? c.dy(j, l) : NaN;
        n += e;
        let o = d != null && b != null && j < b.count ? d.dy(b.item(j), m) : NaN;
        if (!isNaN_(n)) {
            if (n < g.left + 0.1 * g.width) {
                n = n + 0.4 * g.width;
                g.x = n - 0.5 * g.width;
            }
            if (n > g.right - 0.1 * g.width) {
                n = n - 0.4 * g.width;
                g.x = n - 0.5 * g.width;
            }
        }
        if (!isNaN_(o)) {
            if (o < g.top + 0.1 * g.height) {
                o = o + 0.4 * g.height;
                g.y = o - 0.5 * g.height;
            }
            if (o > g.bottom - 0.1 * g.height) {
                o = o - 0.4 * g.height;
                g.y = o - 0.5 * g.height;
            }
        }
        if (a.bn != null) {
            a.bn.ap(a.bs, g, true);
        }
        return j >= 0;
    }
    c$c(a, b) {
        let c = "<div class='ui-chart-default-tooltip-content'>";
        let d = null;
        d = a.ap();
        if (d.b7) {
            let e = d;
            c += "<span>${item." + e.dateTimeMemberPath + "}</span><br/>";
        }
        else if (d != null && d.e9 != null) {
            c += "<span>${item." + d.e9.toString() + "}</span><br/>";
        }
        c += "<span";
        let f = a.a0.a$q(a);
        if (!stringIsNullOrEmpty(f)) {
            c += " style='color:" + f + "'";
        }
        c += ">${series.title}: </span><span class='ui-priority-primary'>" + "${item." + b + "}</span></div>";
        return c;
    }
    c$d(a, b, c, d, e, f, g, h) {
        if (c == null || d == null) {
            return Rect.empty;
        }
        let i = a.lq(b);
        let j = a.bi.bs;
        let k = a.bi.br;
        let l = a.getEffectiveViewport1(a.bi);
        let m = new ScalerParams(0, j, k, d.ca, l);
        m.b = a.eh();
        let n = a.aj(a.ap(), e.f, f, g, b, true);
        if (n == null) {
            return Rect.empty;
        }
        let o = n[0];
        let p = n[1];
        let q = Math.abs(i.x - o[0]);
        let r = Math.abs(i.x - p[0]);
        let s = d.dy(d.km, m);
        let t = c.jz(j, k, l);
        if (q < r) {
            let u = o[0] - 0.5 * t;
            let v = h(o);
            let w = s;
            return new Rect(0, u, Math.min(v, w), t, Math.max(v, w) - Math.min(v, w));
        }
        else {
            let x = p[0] - 0.5 * t;
            let y = h(p);
            let z = s;
            return new Rect(0, x, Math.min(y, z), t, Math.max(y, z) - Math.min(y, z));
        }
    }
}
AnchoredCategorySeriesInteractionManager.$t = markType(AnchoredCategorySeriesInteractionManager, 'AnchoredCategorySeriesInteractionManager', Base.$, [IAnchoredCategorySeriesInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalAnchoredCategorySeriesInteractionManager extends Base {
    d$a(a, b, c, d, e) {
        let f = a.aj(a.ap(), b, c, d, a.ly(e), true);
        if (f == null) {
            return null;
        }
        let g = f[0];
        let h = f[1];
        let i = new Array(1);
        let j = new Array(2);
        j[0] = { $type: Point_$type, x: g[0], y: g[2] };
        j[1] = { $type: Point_$type, x: h[0], y: h[2] };
        i[0] = j;
        return i;
    }
    d$b(a, b, c, d, e) {
        let f = a.aj(a.ap(), b, c, d, a.ly(e), true);
        if (f == null) {
            return null;
        }
        let g = f[0];
        let h = f[1];
        let i = new Array(1);
        let j = new Array(2);
        j[0] = { $type: Point_$type, x: g[0], y: g[1] };
        j[1] = { $type: Point_$type, x: h[0], y: h[1] };
        i[0] = j;
        return i;
    }
    d$d(a, b, c, d) {
        let e = a.lq(c);
        let f = -1;
        let g = a.ap();
        let h = g.ca;
        let i = a.bi.br.right * 2;
        if (h) {
            f = ArrayExtension.binarySearch$11(Point_$type, b, (j) => (i - e.x) < (i - j.x) ? -1 : ((i - e.x) > (i - j.x) ? 1 : 0));
        }
        else {
            f = ArrayExtension.binarySearch$11(Point_$type, b, (j) => e.x < j.x ? -1 : (e.x > j.x ? 1 : 0));
        }
        if (f < 0) {
            f = ~f;
        }
        if (f < 0) {
            f = 0;
        }
        if (f > b.count - 1) {
            f = b.count - 1;
        }
        let j = f;
        let k = f;
        if (j > 0) {
            j--;
        }
        if (k < b.count - 1) {
            k++;
        }
        let l = b._inner[j].x;
        let m = b._inner[f].x;
        let n = b._inner[k].x;
        let o = Math.abs(l - e.x);
        let p = Math.abs(m - e.x);
        let q = Math.abs(n - e.x);
        let r = d(j);
        let s = d(f);
        let t = d(k);
        let u = r.containsPoint(e);
        let v = s.containsPoint(e);
        let w = t.containsPoint(e);
        if (p <= o && p <= q) {
            if (!h && w) {
                return t;
            }
            if (h && u) {
                return r;
            }
            return s;
        }
        if (o <= p && o <= q) {
            if (!h && v) {
                return s;
            }
            return d(j);
        }
        if (q <= p && q <= o) {
            if (h && v) {
                return s;
            }
            return d(k);
        }
        return Rect.empty;
    }
    d$c(a, b, c, d, e) {
        if (isNaN_(d.x) || isNaN_(d.y)) {
            return false;
        }
        let f = 0;
        if (b != null) {
            f = b.ed(b.km);
        }
        if ((c.y >= f && c.y <= d.y) || (c.y <= f && c.y >= d.y)) {
            return true;
        }
        return false;
    }
}
HorizontalAnchoredCategorySeriesInteractionManager.$t = markType(HorizontalAnchoredCategorySeriesInteractionManager, 'HorizontalAnchoredCategorySeriesInteractionManager', Base.$, [IHorizontalAnchoredCategorySeriesInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VerticalAnchoredCategorySeriesInteractionManager extends Base {
    e$a(a, b) {
        let c = a.bs != null ? a.bs.n2 : Rect.empty;
        let d = a.bi.br;
        let e = a.l0(a.bi);
        let f = a.getEffectiveViewport1(a.bi);
        let g = a.ap();
        let h = -1;
        if (g != null && !c.isEmpty && !d.isEmpty) {
            let i = new ScalerParams(0, c, d, g.ca, f);
            let j = g.d1(e.top, i);
            let k = g.d1(e.bottom, i);
            let l = (b.y - c.top) / c.height;
            let m = j + (l * (k - j));
            if (g.categoryMode != 0) {
                m -= 0.5;
            }
            h = m;
        }
        return h;
    }
    e$b(a, b, c, d) {
        let e = a.lq(c);
        let f = -1;
        let g = a.ap().ca;
        let h = a.bi.br.bottom * 2;
        if (g) {
            f = ArrayExtension.binarySearch$11(Point_$type, b, (i) => (h - e.y) < (h - i.y) ? -1 : ((h - e.y) > (h - i.y) ? 1 : 0));
        }
        else {
            f = ArrayExtension.binarySearch$11(Point_$type, b, (i) => e.y < i.y ? -1 : (e.y > i.y ? 1 : 0));
        }
        if (f < 0) {
            f = ~f;
        }
        if (f < 0) {
            f = 0;
        }
        if (f > b.count - 1) {
            f = b.count - 1;
        }
        let i = f;
        let j = f;
        if (i > 0) {
            i--;
        }
        if (j < b.count - 1) {
            j++;
        }
        let k = b._inner[i].y;
        let l = b._inner[f].y;
        let m = b._inner[j].y;
        let n = Math.abs(k - e.y);
        let o = Math.abs(l - e.y);
        let p = Math.abs(m - e.y);
        let q = d(i);
        let r = d(f);
        let s = d(j);
        let t = q.containsPoint(e);
        let u = r.containsPoint(e);
        let v = s.containsPoint(e);
        if (o <= n && o <= p) {
            if (!g && v) {
                return s;
            }
            if (g && t) {
                return q;
            }
            return r;
        }
        if (n <= o && n <= p) {
            if (!g && u) {
                return r;
            }
            return d(i);
        }
        if (p <= o && p <= n) {
            if (g && u) {
                return r;
            }
            return d(j);
        }
        return Rect.empty;
    }
}
VerticalAnchoredCategorySeriesInteractionManager.$t = markType(VerticalAnchoredCategorySeriesInteractionManager, 'VerticalAnchoredCategorySeriesInteractionManager', Base.$, [IVerticalAnchoredCategorySeriesInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HighlightingManager extends Base {
    constructor() {
        super();
        this.a = new Dictionary$2(HighlightingInfo.$, HighlightingInfo.$, 0);
        this.c = new List$1(HighlightingInfo.$, 0);
        this.d = 0;
        this.e = 0;
        this.f = 0;
        this._dirtySeries = null;
        this.b = new Dictionary$2(Series.$, Boolean_$type, 0);
        this._inProgress = false;
        this._maxHighlightingProgress = 0;
        this._sumHighlightingProgress = 0;
        this._maxMarkerHighlightingProgress = 0;
        this._sumMarkerHighlightingProgress = 0;
        this.dirtySeries = new List$1(Series.$, 0);
    }
    startHighlight(a) {
        if (a == null) {
            return;
        }
        this.inProgress = true;
        if (!this.a.containsKey(a)) {
            a.a = HighlightingState.inward;
            this.a.item(a, a);
            this.c.add(a);
        }
        if (a.a == HighlightingState.outward) {
            a.a = HighlightingState.inward;
        }
    }
    endHighlight(a) {
        if (a == null) {
            return;
        }
        if (!this.a.containsKey(a)) {
            return;
        }
        if (a.a == HighlightingState.inward) {
            if (a.d < 0.05) {
                if (a.c) {
                    this.e = this.e + a.d;
                }
                else {
                    this.d = this.d + a.d;
                }
                this.a.removeItem(a);
                this.c.remove(a);
                return;
            }
            a.a = HighlightingState.outward;
        }
        if (a.a == 2) {
            a.a = HighlightingState.outward;
            a.d = 1;
        }
    }
    clear() {
        this.c.clear();
        this.a.clear();
    }
    getHighlightingInfo(a, b, c, d, e, f) {
        for (let g = 0; g < this.c.count; g++) {
            let h = this.c._inner[g];
            let i = h.f;
            let j = h.e;
            if (d >= i && e <= j && h.c == f && a == h.b && (h.a == HighlightingState.inward || h.a == 2)) {
                return h;
            }
        }
        for (let k = 0; k < this.c.count; k++) {
            let l = this.c._inner[k];
            let m = l.f;
            let n = l.e;
            if (d >= m && e <= n && l.c == f && a == l.b && (l.a == HighlightingState.outward)) {
                return l;
            }
        }
        return null;
    }
    get dirtySeries() {
        return this._dirtySeries;
    }
    set dirtySeries(a) {
        this._dirtySeries = a;
    }
    tick(a) {
        this.b.clear();
        this.dirtySeries.clear();
        let b = 0;
        if (this.f > a) {
            b = (1 - this.f) + a;
        }
        else {
            b = a - this.f;
        }
        this.f = a;
        let c = false;
        let d = new List$1(HighlightingInfo.$, 0);
        this.maxHighlightingProgress = 0;
        this.sumHighlightingProgress = 0;
        this.maxMarkerHighlightingProgress = 0;
        this.sumMarkerHighlightingProgress = 0;
        let e = false;
        let f = false;
        let g = 0;
        let h = 0;
        let i = 0;
        let j = 0;
        let k = 0;
        let l = 0;
        for (let m = 0; m < this.c.count; m++) {
            let n = this.c._inner[m];
            if (n.a == HighlightingState.inward) {
                if (n.c) {
                    e = true;
                    i = i + Math.min(1 - n.d, b);
                }
                else {
                    f = true;
                    g = g + Math.min(1 - n.d, b);
                }
            }
            if (n.a == HighlightingState.outward) {
                if (n.c) {
                    j = j + Math.min(n.d, b);
                    l++;
                }
                else {
                    h = h + Math.min(n.d, b);
                    k++;
                }
            }
        }
        h = h + this.d;
        this.d = 0;
        j = j + this.e;
        this.e = 0;
        let o = 1;
        let p = 1;
        if (f && h > g) {
            let q = h - g;
            o = g / h;
        }
        if (e && j > i) {
            let r = j - i;
            p = i / j;
        }
        let s;
        for (let t = 0; t < this.c.count; t++) {
            let u = this.c._inner[t];
            s = b;
            if (u.a == HighlightingState.outward) {
                s = Math.min(s, u.d);
                if (u.c) {
                    s = s * p;
                }
                else {
                    s = s * o;
                }
                u.d = u.d - s;
            }
            else {
                u.d = u.d + s;
            }
            if (u.a == 2) {
                u.d = 1;
            }
            if (u.d > 1) {
                u.d = 1;
            }
            if (u.d < 0) {
                u.d = 0;
            }
            if (u.c) {
                this.maxMarkerHighlightingProgress = Math.max(u.d, this.maxMarkerHighlightingProgress);
                this.sumMarkerHighlightingProgress = this.sumMarkerHighlightingProgress + u.d;
            }
            else {
                this.maxHighlightingProgress = Math.max(u.d, this.maxHighlightingProgress);
                this.sumHighlightingProgress = this.sumHighlightingProgress + u.d;
            }
            if (u.a != HighlightingState.outward && u.d != 1) {
                c = true;
            }
            if (u.a == HighlightingState.outward && u.d != 0) {
                c = true;
            }
            if (u.d == 1 && u.a == HighlightingState.inward) {
                u.a = 2;
            }
            if (u.d == 0 && u.a == HighlightingState.outward) {
                d.add(u);
            }
            if (!this.b.containsKey(u.b)) {
                this.b.addItem(u.b, true);
                this.dirtySeries.add(u.b);
            }
        }
        for (let v of fromEnum(d)) {
            this.a.removeItem(v);
            this.c.remove(v);
        }
        if (this.a.count == 0) {
            this.inProgress = false;
            this.maxHighlightingProgress = 0;
            this.sumHighlightingProgress = 0;
            this.maxMarkerHighlightingProgress = 0;
            this.sumMarkerHighlightingProgress = 0;
        }
        if (!c) {
            this.f = 0;
        }
        return c;
    }
    get inProgress() {
        return this._inProgress;
    }
    set inProgress(a) {
        this._inProgress = a;
    }
    get maxHighlightingProgress() {
        return this._maxHighlightingProgress;
    }
    set maxHighlightingProgress(a) {
        this._maxHighlightingProgress = a;
    }
    get sumHighlightingProgress() {
        return this._sumHighlightingProgress;
    }
    set sumHighlightingProgress(a) {
        this._sumHighlightingProgress = a;
    }
    get maxMarkerHighlightingProgress() {
        return this._maxMarkerHighlightingProgress;
    }
    set maxMarkerHighlightingProgress(a) {
        this._maxMarkerHighlightingProgress = a;
    }
    get sumMarkerHighlightingProgress() {
        return this._sumMarkerHighlightingProgress;
    }
    set sumMarkerHighlightingProgress(a) {
        this._sumMarkerHighlightingProgress = a;
    }
}
HighlightingManager.$t = markType(HighlightingManager, 'HighlightingManager', Base.$, [IHighlightingManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITileZoomTileInfo_$type = new Type(null, 'ITileZoomTileInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TileZoomTileInfo extends Base {
    constructor() {
        super(...arguments);
        this._zoomLevel = 0;
        this._xPosition = 0;
        this._yPosition = 0;
    }
    get zoomLevel() {
        return this._zoomLevel;
    }
    set zoomLevel(a) {
        this._zoomLevel = a;
    }
    get xPosition() {
        return this._xPosition;
    }
    set xPosition(a) {
        this._xPosition = a;
    }
    get yPosition() {
        return this._yPosition;
    }
    set yPosition(a) {
        this._yPosition = a;
    }
    toString() {
        return this.zoomLevel + "_" + this.xPosition + "_" + this.yPosition;
    }
}
TileZoomTileInfo.$t = markType(TileZoomTileInfo, 'TileZoomTileInfo', Base.$, [ITileZoomTileInfo_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TileZoomInfo extends Base {
    constructor() {
        super(...arguments);
        this.f = null;
        this.g = null;
        this.e = 0;
        this.d = 0;
        this.c = 0;
        this.b = 0;
        this.a = 0;
    }
}
TileZoomInfo.$t = markType(TileZoomInfo, 'TileZoomInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TileZoomManager extends Base {
    constructor(a, b, c) {
        super();
        this.e = null;
        this.av = null;
        this.aw = null;
        this.au = null;
        this.i = false;
        this.v = 0;
        this.k = null;
        this.l = null;
        this.n = null;
        this.q = -1;
        this.ao = null;
        this.p = 1;
        this.r = 1;
        this.y = 0;
        this.o = null;
        this.m = null;
        this.d = null;
        this.f = false;
        this.h = false;
        this.e = a;
        let d = this.e;
        d.actualWindowRectChanged = delegateCombine(d.actualWindowRectChanged, runOn(this, this.am));
        let e = this.e;
        e.gridAreaRectChanged = delegateCombine(e.gridAreaRectChanged, runOn(this, this.an));
        this.d = new TileZoomTileCache(c, this);
        this.o = new List$1(TileZoomTileInfo.$, 0);
        this.m = new List$1(TileZoomTile.$, 0);
        this.k = new Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
        this.l = new Dictionary$2(TileZoomTile.$, ITileZoomTile_$type, 0);
        this.n = new List$1(ITileZoomTile_$type, 0);
        this.h = b;
        this.ai();
    }
    ai() {
        this.av = this.e.oh;
        this.ao = this.ap(this.av);
        let a = this.s();
        this.ac();
        this.ab();
        this.q = a;
        this.v = this.t(a);
        this.au = new Rect(0, 0, 0, a, a);
    }
    ap(a) {
        return new Rect(0, a.left, a.top, a.width * this.p, a.height * this.r);
    }
    t(a) {
        let b = a / 512;
        let c = logBase(b, 2);
        return c;
    }
    s() {
        let a = Math.max(this.ao.width, this.ao.height);
        let b = 1;
        let c = 512;
        while (c < a) {
            b++;
            c = 512 * b;
        }
        return c;
    }
    an(a, b) {
        this.ai();
        this.aj();
    }
    am(a, b) {
        this.aj();
    }
    aj() {
        this.f = true;
        this.aw = this.e.n2;
        if (this.i) {
            if (this.j(this.aw)) {
                this.ai();
            }
            this.af();
            this.ak();
            this.ag();
        }
    }
    j(a) {
        let b = 1;
        let c = 1;
        if (this.g(a)) {
            if (a.width > a.height) {
                let d = 1;
                if (a.height != 0) {
                    d = a.width / a.height;
                }
                let e = 0;
                let f = 1;
                while (f < d) {
                    e++;
                    f = truncate(Math.pow(3, e));
                }
                f = truncate(Math.pow(3, e - 1));
                c = f;
                if (c == 0 || isInfinity(c) || isNaN_(c)) {
                    c = 1;
                }
            }
            else {
                let g = 1;
                if (a.width != 0) {
                    g = a.height / a.width;
                }
                let h = 0;
                let i = 1;
                while (i < g) {
                    h++;
                    i = truncate(Math.pow(3, h));
                }
                i = truncate(Math.pow(3, h - 1));
                b = i;
                if (isInfinity(b) || isNaN_(b)) {
                    b = 1;
                }
            }
        }
        else {
            b = 1;
            c = 1;
        }
        let j = c != this.r || b != this.p;
        this.p = b;
        this.r = c;
        return j;
    }
    g(a) {
        return (a.width / a.height) > 3 || (a.height / a.width) > 3;
    }
    ag() {
        let a = this.a();
        for (let b = 0; b < this.m.count; b++) {
            this.aa(a, this.m._inner[b]);
        }
        let c = new Dictionary$2(Base.$, ITileZoomTile_$type, 0);
        for (let d of fromEnum(this.l.keys)) {
            c.addItem(this.l.item(d).content, this.l.item(d));
        }
        this.e.b1.b1(c, this.n, 512);
    }
    aa(a, b) {
        let c = this.as(b, a);
        let d = c.left * a.b;
        let e = c.top * a.a;
        let f = c.right * a.b;
        let g = c.bottom * a.a;
        let h = d - a.f.left;
        let i = e - a.f.top;
        let j = f - d;
        let k = g - e;
        b.xPosition = h / this.p;
        b.yPosition = i / this.r;
        b.width = j / this.p;
        b.height = k / this.r;
    }
    ak() {
        let a = this.a();
        this.k.clear();
        for (let b = 0; b < this.m.count; b++) {
            let c = this.m._inner[b];
            this.k.addItem(c, c);
        }
        this.m.clear();
        this.l.clear();
        this.n.clear();
        for (let d = 0; d < this.o.count; d++) {
            let e = this.o._inner[d];
            let f = this.d.b(e);
            if (f == null) {
                f = this.b(e, a);
                this.d.f(f);
            }
            if (this.k.containsKey(f)) {
                this.k.removeItem(f);
                this.l.addItem(f, f);
            }
            else {
                this.z(f);
                this.n.add(f);
            }
            this.m.add(f);
        }
        for (let g of fromEnum(this.k.keys)) {
            this.ad(g);
        }
    }
    ad(a) {
    }
    z(a) {
    }
    b(a, b) {
        let c = this.c(a);
        let d = this.as(c, b);
        let e = this.ar();
        let f = 1 / e.width;
        let g = e.height;
        if (e.width > e.height) {
            f = e.width;
            g = 1 / e.height;
        }
        let h = (d.left - e.left) * f;
        let i = (d.top - e.top) * g;
        let j = (d.right - e.left) * f;
        let k = (d.bottom - e.top) * g;
        d = new Rect(0, h, i, j - h, k - i);
        let l = this.e.b1.bf(d, c, truncate(512));
        c.content = l;
        return c;
    }
    ar() {
        let a = this.e.oh;
        let b = this.e.n6;
        if (b.isEmpty) {
            return new Rect(0, 0, 0, 1, 1);
        }
        let c = (b.left - a.left) / a.width;
        let d = (b.top - a.top) / a.height;
        let e = (b.right - a.left) / a.width;
        let f = (b.bottom - a.top) / a.height;
        return new Rect(0, c, d, e - c, f - d);
    }
    as(a, b) {
        let c = a.info.xPosition * 512;
        let d = a.info.yPosition * 512;
        let e = c + 512;
        let f = d + 512;
        let g = c / b.d;
        let h = d / b.c;
        let i = 512 / b.d;
        let j = 512 / b.c;
        return new Rect(0, g, h, i, j);
    }
    c(a) {
        let b = 0;
        b = this.y;
        this.y++;
        let c = new TileZoomTile();
        c.info = a;
        c.iD = b;
        return c;
    }
    a() {
        let a = this.aq(this.aw);
        let b = this.x(a);
        let c = Math.pow(2, b) * 512;
        let d = c;
        let e = (this.ao.width / this.au.width) * c;
        let f = (this.ao.height / this.au.height) * d;
        let g = (this.ao.width / a.width);
        let h = (this.ao.height / a.height);
        let i = a.left * g;
        let j = a.top * h;
        let k = a.right * g;
        let l = a.bottom * h;
        let m = new TileZoomInfo();
        m.f = new Rect(0, i, j, k - i, l - j);
        let n = this.at(this.aw, m.f, b, g, h, e, f);
        let o = n.left * e;
        let p = n.top * f;
        let q = n.right * e;
        let r = n.bottom * f;
        m.g = new Rect(0, o, p, q - o, r - p);
        m.e = b;
        m.d = e;
        m.c = f;
        m.b = g;
        m.a = h;
        return m;
    }
    aq(a) {
        return a;
    }
    at(a, b, c, d, e, f, g) {
        let h = (a.left + a.right) / 2;
        let i = (a.top + a.bottom) / 2;
        let j = a.width;
        let k = a.height;
        j = j * d / f;
        k = k * e / g;
        let l = j / 2;
        let m = k / 2;
        return new Rect(0, h - l, i - m, j, k);
    }
    af() {
        let a = this.a();
        let b = 512 * a.b / a.d;
        let c = 512 * a.a / a.c;
        let d = truncate(Math.floor(a.f.left / b));
        let e = truncate(Math.floor(a.f.top / c));
        let f = truncate(Math.floor(a.f.right / b));
        let g = truncate(Math.floor(a.f.bottom / c));
        this.o.clear();
        for (let h = e; h <= g; h++) {
            for (let i = d; i <= f; i++) {
                this.o.add(((() => {
                    let $ret = new TileZoomTileInfo();
                    $ret.xPosition = i;
                    $ret.yPosition = h;
                    $ret.zoomLevel = a.e;
                    return $ret;
                })()));
            }
        }
    }
    x(a) {
        let b = 1 / a.width;
        let c = 1 / a.height;
        let d;
        let e;
        if (this.h) {
            d = Math.floor(logBase(b, 2));
            e = Math.floor(logBase(c, 2));
        }
        else {
            d = Math.ceil(logBase(b, 2));
            e = Math.ceil(logBase(c, 2));
        }
        let f = Math.min(d, e) + (this.v);
        return truncate(f);
    }
    ab() {
        if (!this.f) {
            return;
        }
        this.f = false;
        this.e.b1.by();
        this.d.g();
    }
    al() {
        this.i = true;
    }
    ah() {
        this.i = false;
        this.e.b1.cg();
    }
    ae(a) {
        this.e.b1.bz(a);
    }
    ac() {
        this.m.clear();
        this.o.clear();
        this.k.clear();
    }
}
TileZoomManager.$t = markType(TileZoomManager, 'TileZoomManager');
/**
 * @hidden
 */
class TileZoomTileCache extends Base {
    constructor(a, b) {
        super();
        this.c = new Dictionary$2(String_$type, TileZoomTile.$, 0);
        this.d = new LinkedList$1(TileZoomTile.$);
        this.e = 0;
        this.a = null;
        this.e = a;
        this.a = b;
    }
    g() {
        this.c.clear();
        this.d = new LinkedList$1(TileZoomTile.$);
    }
    i(a) {
        this.d.h(a.b);
        this.d.f(a);
        a.b = this.d.d;
    }
    f(a) {
        this.d.f(a);
        this.c.addItem(a.info.toString(), a);
        a.a = this;
        a.b = this.d.d;
        while (this.c.count > this.e) {
            this.h(this.d.c.c);
        }
    }
    h(a) {
        this.d.h(a.b);
        this.c.removeItem(a.info.toString());
        this.a.ae(a);
    }
    b(a) {
        if (this.c.containsKey(a.toString())) {
            let b = this.c.item(a.toString());
            b.touch();
            return b;
        }
        return null;
    }
}
TileZoomTileCache.$t = markType(TileZoomTileCache, 'TileZoomTileCache');
/**
 * @hidden
 */
class TileZoomTile extends Base {
    constructor() {
        super(...arguments);
        this._info = null;
        this.a = null;
        this.b = null;
        this._content = null;
        this._xPosition = 0;
        this._width = 0;
        this._yPosition = 0;
        this._height = 0;
        this._iD = 0;
    }
    get info() {
        return this._info;
    }
    set info(a) {
        this._info = a;
    }
    touch() {
        if (this.a == null) {
            return;
        }
        this.a.i(this);
    }
    get content() {
        return this._content;
    }
    set content(a) {
        this._content = a;
    }
    get xPosition() {
        return this._xPosition;
    }
    set xPosition(a) {
        this._xPosition = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get yPosition() {
        return this._yPosition;
    }
    set yPosition(a) {
        this._yPosition = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    get iD() {
        return this._iD;
    }
    set iD(a) {
        this._iD = a;
    }
}
TileZoomTile.$t = markType(TileZoomTile, 'TileZoomTile', Base.$, [ITileZoomTile_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewerInteractionManager extends Base {
    constructor() {
        super();
        this.r = 0;
        this.s = 0;
        this.af = null;
        this.o = 0;
        this.p = 0;
        this.n = 0;
        this.q = 0;
        this.h = false;
        this.ag = null;
        this.ai = null;
        this.j = false;
        this.e = null;
        this.b = null;
        this.ah = null;
        this.aj = null;
        this.d = null;
        this.a = null;
        this.g = false;
        this.ah = Rect.empty;
        this.ag = Rect.empty;
    }
    get f$b() {
        if (this.b == null) {
            this.b = new HighlightingManager();
        }
        return this.b;
    }
    f$a(a) {
        if (a.ap != 0) {
            return a.ap;
        }
        let b = 1;
        let c = false;
        let d = false;
        for (let e = 0; e < a.series.count; e++) {
            let f = a.series._inner[e];
            if (f.isStacked) {
                f.ig((g) => {
                    if (g.bc == 2) {
                        c = true;
                    }
                    if (g.bc == 1) {
                        d = true;
                    }
                    return true;
                });
            }
            else {
                if (f.bc == 2) {
                    c = true;
                }
                if (f.bc == 1) {
                    d = true;
                }
            }
        }
        if (d) {
            b = 1;
        }
        if (c) {
            b = 2;
        }
        if (c && d) {
            b = 3;
        }
        return b;
    }
    f$al(a) {
        let b = a.nu;
        let c = b;
        let d = a.b1;
        let e = a.cv();
        let f = a.cx;
        let g = a.dx;
        let h = a.d4;
        if (!e) {
            c = { $type: Point_$type, x: NaN, y: NaN };
        }
        for (let i = 0; i < a.series.count; i++) {
            let j = a.series._inner[i];
            j.il(c);
        }
        let k = a.bs == 0 && !a.da && (a.c0 || f) && !g && !h;
        let l = a.oh;
        if (k && !isNaN_(b.x) && !l.isEmpty) {
            let m = l.width * (b.x - a.n2.left) / a.n2.width;
            d.ei(l.left + m, l.top, l.left + m, l.bottom);
            d.d7();
            d.ec(m);
        }
        else {
            d.cf();
        }
        if (k && !isNaN_(b.y) && !l.isEmpty) {
            let n = l.height * (b.y - a.n2.top) / a.n2.height;
            d.eb(l.left, l.top + n, l.right, l.top + n);
            d.d3();
        }
        else {
            d.ca();
        }
    }
    f$ae(a) {
        switch (a.bs) {
            case 0:
                a.b1.dz();
                this.f$al(a);
                a.b1.b7();
                break;
            case 1:
                a.b1.d1();
                a.b1.ce();
                this.f$al(a);
                a.b1.b6();
                break;
            case 2:
                a.b1.d1();
                a.b1.ce();
                this.f$al(a);
                a.b1.b8();
                break;
        }
    }
    f$p(a, b) {
        if (b.x >= 0 && b.y >= 0 && b.x <= a.oh.width && b.y <= a.oh.height) {
            this.ab(a, b);
        }
        else {
            a.im();
        }
    }
    ab(a, b) {
        let c = a.b1;
        let d = a.oh;
        if (a.db || a.da) {
            return;
        }
        if (a.cx && a.c0) {
            let e = d.height > d.width;
            c.bt(e);
            for (let f of fromEnum(a.series)) {
                if (f.isStacked) {
                    f.ig((g) => {
                        if (g._visibility == 0) {
                            g.jr(b, runOn(c, c.bk));
                        }
                        return true;
                    });
                }
                else {
                    if (f._visibility == 0) {
                        f.jr(b, runOn(c, c.bk));
                    }
                }
            }
            c.d4();
        }
    }
    aa(a, b) {
        if (a.c0 || a.c8) {
            a.cx = true;
            a.ka();
            this.ag = new Rect(0, b.x, b.y, 0, 0);
            this.ai = new Rect(0, b.x, b.y, 0, 0);
            a.bs = 0;
            a.id(a.nw(b));
        }
    }
    f$ac(a, b) {
        this.aa(a, b);
        this.ab(a, b);
        this.f$al(a);
    }
    f$q(a, b, c) {
        if (!a.cx) {
            this.ad(a, b, c);
        }
    }
    f$o(a, b) {
        this.ah = Rect.empty;
        a.im();
    }
    f$aj(a) {
        let b = a.b1;
        this.q = 1;
        a.cx = false;
        b.cd();
        b.b9();
        b.cb();
        a.id({ $type: Point_$type, x: NaN, y: NaN });
        b.ca();
        b.cf();
        b.ce();
        a.bs = 0;
        this.h = true;
        a.dx = true;
        a.kb();
    }
    f$ab(a, b) {
        this.f$aj(a);
    }
    f$ak(a, b, c, d, e) {
        this.r = b.x;
        this.s = b.y;
        this.o = c;
        this.p = d;
        this.n = e;
        this.af = a.n2;
        this.f$aj(a);
    }
    f$aa(a, b) {
        let c = a.b1;
        c.ca();
        c.cf();
        if (c.at) {
            this.w(a, b);
        }
        else {
            this.y(a, b);
            this.q = b;
        }
    }
    f$ag(a, b, c, d, e) {
        let f = a.b1;
        f.ca();
        f.cf();
        this.o = this.o * c;
        this.p = this.p * d;
        this.n = this.n * e;
        if (a.dg) {
            this.o = this.n;
            this.p = this.n;
        }
        let g = a.n2;
        let h = a.oh;
        let i = b.x - this.r;
        let j = b.y - this.s;
        this.r = b.x;
        this.s = b.y;
        let k = g.width;
        let l = g.height;
        let m = this.af.width / this.o;
        let n = this.af.height / this.p;
        if (m > 1) {
            m = 1;
        }
        if (n > 1) {
            n = 1;
        }
        let o = { $type: Point_$type, x: b.x, y: b.y };
        let p = { $type: Point_$type, x: (o.x - h.left) / h.width * g.width + g.left, y: (o.y - h.top) / h.height * g.height + g.top };
        let q = new Rect(0, g.left, g.top, m, n);
        let r = { $type: Point_$type, x: (p.x - q.left) / q.width * h.width + h.left, y: (p.y - q.top) / q.height * h.height + h.top };
        let s = (r.x - o.x) - i;
        let t = (r.y - o.y) - j;
        let u = s / h.width * q.width;
        let v = t / h.height * q.height;
        q = new Rect(0, q.left + u, q.top + v, q.width, q.height);
        g = q;
        a.lq(g, true);
    }
    f$x(a, b) {
        this.ag = new Rect(0, b.x, b.y, 0, 0);
        this.ai = new Rect(0, b.x, b.y, 0, 0);
    }
    x(a, b, c) {
        let d = a.n2.width;
        let e = a.n2.height;
        let f = a.n2.left + d / 2;
        let g = a.n2.top + e / 2;
        d = d / b;
        e = e / b;
        let h = f - d / 2;
        let i = g - e / 2;
        a.lq(new Rect(0, h, i, d, e), true);
    }
    f$z(a, b) {
        let c = a.b1;
        if (c.at) {
            this.w(a, b);
        }
        else {
            this.y(a, b);
        }
        this.ag = Rect.empty;
        a.dx = false;
    }
    f$r(a, b) {
        a.dx = false;
        this.ag = Rect.empty;
        a.im();
    }
    f$af(a, b, c, d, e) {
        a.dx = false;
        this.ag = Rect.empty;
        a.im();
    }
    w(a, b) {
        let c = a.oi;
        let d = 1 / b;
        let e = { $type: Point_$type, x: c.x + c.width / 2, y: c.y + c.height / 2 };
        let f = { $type: Point_$type, x: c.x - e.x, y: c.y - e.y };
        let g = new Rect(0, f.x * d + e.x, f.y * d + e.y, c.width * d, c.height * d);
        a.lq(g, true);
    }
    y(a, b) {
        let c = a.oh;
        let d = a.oi;
        let e = b - this.q;
        if (e != 0) {
            let f = 0.03;
            let g = e < 0 ? 1 + f : 1 - f;
            let h = { $type: Point_$type, x: d.x + d.width / 2, y: d.y + d.height / 2 };
            let i = { $type: Point_$type, x: d.x - h.x, y: d.y - h.y };
            let j = new Rect(0, i.x * g + h.x, i.y * g + h.y, d.width * g, d.height * g);
            a.lq(j, true);
        }
    }
    f$m(a, b, c) {
        if (!a.dx) {
            this.h = false;
        }
        this.ad(a, b, c);
        a.jv(b, c);
    }
    ad(a, b, c) {
        let d;
        let e = a.b1;
        let f = a.bq(c);
        if (e.et == 0) {
            switch (f) {
                case 1:
                    d = a.dn() ? f : 0;
                    break;
                default:
                    d = f;
                    break;
            }
        }
        else {
            if (e.et == a.na) {
                d = 1;
            }
            else if (e.et == a.nb) {
                d = 2;
            }
            else {
                d = 0;
            }
        }
        switch (d) {
            case 1:
            case 2:
                a.b1.b4();
                a.b1.dk();
                break;
        }
        a.bs = d;
        switch (a.bs) {
            case 1:
                a.id({ $type: Point_$type, x: NaN, y: NaN });
                this.ag = new Rect(0, b.x, b.y, 0, 0);
                this.ai = new Rect(0, b.x, b.y, 0, 0);
                this.ah = new Rect(0, b.x, b.y, 0, 0);
                e.d2();
                e.ea(this.ag);
                a.kg(Rect.empty, true);
                break;
            case 2:
                this.ag = new Rect(0, b.x, b.y, 0, 0);
                this.ah = new Rect(0, b.x, b.y, 0, 0);
                break;
        }
        this.aj = a.n2;
        a.oj = a.n2;
    }
    f$ai(a) {
        a.lc();
        a.b1.df();
    }
    f$ah(a) {
        a.ii();
        a.b1.de();
    }
    f$am(a) {
        if (a.cu && !this.j) {
            this.j = true;
            this.ac(a);
        }
    }
    f$j(a) {
        if (this.j) {
            this.z(a);
            this.j = false;
        }
    }
    f$g(a) {
        if (this.e == null) {
            return;
        }
        this.f.ab();
    }
    get f() {
        return this.e;
    }
    ac(a) {
        if (this.e == null) {
            this.e = new TileZoomManager(a, true, a.fr);
            this.e.h = !a.dy;
        }
        a.c7 = true;
        a.kf();
        this.e.al();
        a.b1.bp();
        a.b1.bq();
    }
    z(a) {
        if (this.e == null) {
            return;
        }
        a.c7 = false;
        a.b1.da();
        this.e.ah();
        a.ky();
        a.b1.bw();
    }
    f$i(a) {
        a.ib();
        a.k0();
    }
    l(a) {
        return a.bs == 2;
    }
    m(a, b) {
        return a.bi == 1 || b || a.cu;
    }
    k(a) {
        return a.bs == 1;
    }
    f$l(a, b, c) {
        let d = a.b1;
        if (this.ag.isEmpty && c) {
            this.ad(a, b, c);
        }
        let e = 2;
        if (c) {
            e = 10;
        }
        let f = false;
        let g = new Rect(2, { $type: Point_$type, x: this.ag.x, y: this.ag.y }, b);
        let h = new Rect(0, 0, 0, 0, 0);
        if (!this.ah.isEmpty) {
            h = new Rect(2, { $type: Point_$type, x: this.ah.x, y: this.ah.y }, b);
        }
        if (h.width > e && h.height > e) {
            f = true;
        }
        if (!a.dx) {
            if (f) {
                this.h = false;
            }
        }
        if (!a.dx && (a.cx || !c)) {
            a.id(a.nw(b));
        }
        if (this.k(a)) {
            if (f) {
                let i = a.og(g);
                a.kg(i, true);
            }
            else {
                a.kg(Rect.empty, true);
            }
            a.i6();
            d.ea(g);
        }
        let j = a.oh;
        let k = a.n2;
        if (this.l(a)) {
            let l = j;
            let m = k.left + k.width * (this.ag.x - b.x) / l.width;
            let n = k.top + k.height * (this.ag.y - b.y) / l.height;
            let o = new Rect(0, m, n, k.width, k.height);
            if (this.m(a, c)) {
                if (h.width != 0 || h.height != 0) {
                    a.kb();
                }
                a.kg(Rect.empty, true);
                a.lq(o, true);
                this.ag = new Rect(3, b, new Size(1, 0, 0));
                this.ai = new Rect(3, b, new Size(1, 0, 0));
            }
            else {
                a.kg(o, true);
            }
        }
        this.ai = new Rect(3, b, new Size(1, 0, 0));
        d.bs(b);
    }
    f$k(a, b, c, d) {
        let e = a.b1;
        let f = 2;
        if (c) {
            f = 10;
        }
        let g = a.oh;
        let h = a.n2;
        if (!this.h) {
            let i = false;
            let j = new Rect(2, { $type: Point_$type, x: this.ag.x, y: this.ag.y }, b);
            if (j.width > f && j.height > f) {
                i = true;
            }
            if (a.bs == 1) {
                a.i5();
                e.b9();
                if (i) {
                    a.lq(a.og(j), true);
                }
            }
            if (a.bs == 2) {
                let k = g;
                let l = h.left + h.width * (this.ag.x - b.x) / k.width;
                let m = h.top + h.height * (this.ag.y - b.y) / k.height;
                a.lq(new Rect(0, l, m, h.width, h.height), true);
            }
        }
        let n = false;
        let o = new Rect(2, { $type: Point_$type, x: this.ah.x, y: this.ah.y }, b);
        if (o.width > f || o.height > f) {
            n = true;
        }
        if (n) {
            a.d4 = true;
        }
        a.bs = 0;
        a.kg(Rect.empty, true);
        e.bu();
        a.d4 = false;
        e.ca();
        e.cf();
        if (c) {
            e.ce();
            e.ca();
            e.cf();
            e.cb();
        }
        a.im();
        a.ka();
        a.jw(b, c, d);
    }
    f$ad(a) {
        if (this.f != null) {
            this.f.h = !a.dy;
        }
    }
    f$d(a, b) {
        let c = a.b1;
        let d = a.n2;
        if (a.bs == 2 && b == 8) {
            c.br();
            a.bs = 0;
            a.ka();
            a.kg(Rect.empty, true);
            if (a.bi == 1) {
                a.lq(this.aj, true);
            }
            return true;
        }
        if (a.bs == 1 && b == 8) {
            c.br();
            a.bs = 0;
            a.ka();
            c.b9();
            a.kg(Rect.empty, true);
            return true;
        }
        let e = Rect.empty;
        let f = false;
        switch (b) {
            case 13:
                f = true;
                e = new Rect(0, 0, 0, 1, 1);
                break;
            case 11:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top - 0.1 * d.height, 1.2 * d.width, 1.2 * d.height);
                break;
            case 10:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top + 0.1 * d.height, 0.8 * d.width, 0.8 * d.height);
                break;
            case 14:
                f = true;
                e = new Rect(0, d.left - 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.min(e.left, 0);
                break;
            case 16:
                f = true;
                e = new Rect(0, d.left + 0.1 * d.width, d.top, d.width, d.height);
                e.x = e.x - Math.max(e.right - 1, 0);
                break;
            case 15:
                f = true;
                e = new Rect(0, d.left, d.top - 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.min(e.top, 0);
                break;
            case 17:
                f = true;
                e = new Rect(0, d.left, d.top + 0.1 * d.height, d.width, d.height);
                e.y = e.y - Math.max(e.bottom - 1, 0);
                break;
        }
        if (!e.isEmpty && Rect.l_op_Inequality(e, d)) {
            a.lq(e, true);
        }
        return f;
    }
    f$e(a, b, c) {
        let d = a.b1;
        let e = a.n2;
        let f = e.left + e.width * b.x / a.oh.width;
        let g = e.top + e.height * b.y / a.oh.height;
        let h = 1 - MathUtil.b(c, -0.5, 0.5);
        let i = Math.max(0, f - h * (f - e.left));
        let j = Math.min(1, g + h * (e.bottom - g));
        let k = Math.min(1, f + h * (e.right - f));
        let l = Math.max(0, g - h * (g - e.top));
        a.kb();
        this.v(a, 1000);
        a.lq(new Rect(0, i, l, k - i, j - l), true);
        return a.dn();
    }
    v(a, b) {
        a.b1.bx(b);
    }
    f$n(a, b) {
        let c = a.n2;
        let d = c.left + c.width * b.x / a.oh.width;
        let e = c.top + c.height * b.y / a.oh.height;
        let f = 0.7;
        let g = Math.max(0, d - f * (d - c.left));
        let h = Math.min(1, e + f * (c.bottom - e));
        let i = Math.min(1, d + f * (c.right - d));
        let j = Math.max(0, e - f * (e - c.top));
        a.lq(new Rect(0, g, j, i - g, h - j), true);
    }
    f$h(a) {
        this.f.ac();
    }
    f$c(a, b, c, d, e, f, g) {
        let h = true;
        let i = false;
        let j = false;
        let k = a;
        if (k.ao == 1) {
            h = false;
            i = true;
        }
        if (k.ao == 3 || k.ao == 4) {
            i = true;
        }
        if (k.ao == 4) {
            j = true;
        }
        let l = truncate(Math.round(d.x));
        let m = truncate(Math.round(d.y));
        f = null;
        let n = -1;
        if (h && c != null) {
            let o = l;
            let p = m;
            if (a.ey != 1) {
                o = truncate(Math.round(d.x * a.ey));
                p = truncate(Math.round(d.y * a.ey));
            }
            let q = c.a(o, p);
            if (q == null || q.length == 0) {
                f = null;
                return {
                    ret: null,
                    p5: f
                };
            }
            if ((q[0] > 0 || q[1] > 0 || q[2] > 0) && q[3] == 255) {
                let num2_ = q[2];
                if (num2_ % 4 != 0) {
                    num2_ = num2_ + (4 - (num2_ % 4));
                }
                let num1_ = q[1];
                if (num1_ % 4 != 0) {
                    num1_ = num1_ + (4 - (num1_ % 4));
                }
                let num0_ = q[0];
                if (num0_ % 4 != 0) {
                    num0_ = num0_ + (4 - (num0_ % 4));
                }
                let num_ = 0;
                num_ = (num2_ >> 2);
                num_ = (num_ << 6);
                num_ = (num_ | (num1_ >> 2));
                num_ = (num_ << 6);
                num_ = (num_ | (num0_ >> 2));
                n = truncate(Math.floor((intDivide(num_, 1000))));
                n--;
            }
        }
        let r = null;
        let s = -1;
        if (n >= 0) {
            let t = false;
            let u = 0;
            for (let v of fromEnum(b)) {
                if (!v.c7) {
                    continue;
                }
                if (t) {
                    break;
                }
                if (v.isStacked) {
                    v.ig((w) => {
                        if (w.fk == n) {
                            r = w;
                            s = u;
                            t = true;
                            return false;
                        }
                        return true;
                    });
                }
                else if (v.fk == n) {
                    r = v;
                    s = u;
                    break;
                }
                u++;
            }
        }
        let w = null;
        if (i) {
            let x = false;
            for (let y = b.count - 1; y >= 0; y--) {
                let z = b._inner[y];
                if (!z.c7) {
                    continue;
                }
                let aa = z.bi;
                if (!z.dw(aa.br, aa.bs, aa)) {
                    continue;
                }
                if (!x && y < s && h && !j) {
                    if (r != null) {
                        w = r;
                        x = true;
                        break;
                    }
                }
                if (z != null && z.bc == 1) {
                    if (z.dh(d, g)) {
                        w = z;
                        break;
                    }
                }
            }
            if (h && !x) {
                if (r != null) {
                    w = r;
                    x = true;
                }
            }
        }
        else {
            w = r;
        }
        if (w != null) {
            let ab = w.ar({ $type: Point_$type, x: l, y: m }, g);
            if (ab != null) {
                f = ab;
            }
            return {
                ret: w,
                p5: f
            };
        }
        return {
            ret: null,
            p5: f
        };
    }
    f$f(a, b) {
        if (PointUtil.equals(b, null)) {
            return false;
        }
        let c = b.x;
        let d = b.y;
        if (c >= a.oh.left && d >= a.oh.top && c <= a.oh.left + a.oh.width && d <= a.oh.top + a.oh.height) {
            let e = a.bu;
            if (e != null && e.viewShouldInteract(b)) {
                return false;
            }
            return true;
        }
        return false;
    }
    c(a) {
        if (a != null) {
            return a.a6();
        }
        else {
            return null;
        }
    }
    f$v(a, b, c, d, e, f) {
        if (!f && a.ct) {
            this.ae(a, false);
        }
        let g = new MouseEventArgs();
        g.position = d;
        if (a.bs == 2 || a.bs == 1 || a.dx || (a.bu != null && a.bu.isPinching)) {
            if (this.d != null) {
                this.d.a0.a$x(this.d, g.position, this.a, g);
                this.d = null;
            }
            return;
        }
        let h = null;
        let i = ((() => { let j = this.f$c(a, b, c, d, !e, h, f); h = j.p5; return j.ret; })());
        this.a = h;
        let j = this.c(i);
        if (i != null) {
            let k = false;
            let l = false;
            if (this.d != i) {
                l = true;
            }
            if (this.d == null || l) {
                k = true;
            }
            if (k) {
                if (l) {
                    if (this.d != null) {
                        j = this.c(this.d);
                        this.d.a0.a$x(this.d, g.position, h, g);
                        if (j != null) {
                            j.a0.a$x(j, g.position, h, g);
                        }
                    }
                }
                this.d = i;
                i.iz(g.position, h, g, f);
                if (j != null) {
                    j.iz(g.position, h, g, f);
                }
            }
            else {
                this.d = i;
                i.a0.a$z(i, g.position, h, g, f);
                if (j != null) {
                    j.a0.a$z(j, g.position, h, g, f);
                }
            }
        }
        else {
            if (this.d != null) {
                j = this.c(this.d);
                this.d.a0.a$x(this.d, g.position, h, g);
                if (j != null) {
                    j.a0.a$x(j, g.position, h, g);
                }
                this.d = null;
            }
            for (let m = 0; m < a.series.count; m++) {
                let n = a.series._inner[m];
                if (n.a0.a$b) {
                    j = this.c(n);
                    n.a0.a$x(n, g.position, n.a0.a$o, g);
                    if (j != null) {
                        j.a0.a$x(j, g.position, n.a0.a$o, g);
                    }
                }
            }
        }
    }
    f$u(a, b) {
        if (this.d != null) {
            let c = this.c(this.d);
            let d = new MouseEventArgs();
            d.position = b;
            this.d.a0.a$x(this.d, d.position, null, d);
            if (c != null) {
                c.a0.a$x(c, d.position, null, d);
            }
            this.d = null;
        }
        a.jq(b, a.bs != 0 || a.dt);
    }
    f$t(a, b, c) {
        if (this.d != null) {
            let d = new MouseButtonEventArgs();
            d.position = c;
            if (b.ai) {
                this.d.a0.a$aa(this.d, d.position, this.a, d);
            }
            else {
                this.d.a0.a$u(this.d, d.position, this.a, d);
            }
        }
    }
    f$w(a, b, c) {
        let d;
        let e = (this.d != null) ? this.d : ((() => { let f = a.b1.e(c, false, d, false); d = f.p2; return f.ret; })());
        if (e != null) {
            let f = new MouseButtonEventArgs();
            f.position = c;
            if (b.ai) {
                e.a0.a$ab(e, f.position, this.a, f);
            }
            else {
                e.a0.a$y(e, f.position, this.a, f);
            }
        }
    }
    f$s(a, b, c) {
        if (!c && a.du) {
            this.ae(a, false);
        }
        if (c && !a.du) {
            this.ae(a, true);
        }
        a.i9(b, c);
    }
    ae(a, b) {
        if (a != null) {
            if (!this.i) {
                a.ct = b;
            }
        }
    }
    f$y(a, b) {
        this.g = true;
    }
    get i() {
        return this.g;
    }
}
SeriesViewerInteractionManager.$t = markType(SeriesViewerInteractionManager, 'SeriesViewerInteractionManager', Base.$, [ISeriesViewerInteractionManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class InteractivityFactoryManager extends Base {
    static register() {
        if (!InteractivityFactoryManager.a) {
            TypeRegistrar.register("InteractivityFactoryManager", InteractivityFactoryManager.$);
            DVContainer.instance.registerFactory(ISeriesInteractionManager_$type, () => new SeriesInteractionManager());
            DVContainer.instance.registerFactory(ICategorySeriesInteractionManager_$type, () => new CategorySeriesInteractionManager());
            DVContainer.instance.registerFactory(IAnchoredCategorySeriesInteractionManager_$type, () => new AnchoredCategorySeriesInteractionManager());
            DVContainer.instance.registerFactory(IHorizontalAnchoredCategorySeriesInteractionManager_$type, () => new HorizontalAnchoredCategorySeriesInteractionManager());
            DVContainer.instance.registerFactory(IVerticalAnchoredCategorySeriesInteractionManager_$type, () => new VerticalAnchoredCategorySeriesInteractionManager());
            DVContainer.instance.registerFactory(ISeriesViewerInteractionManager_$type, () => new SeriesViewerInteractionManager());
            InteractivityFactoryManager.a = true;
        }
    }
}
InteractivityFactoryManager.$t = markType(InteractivityFactoryManager, 'InteractivityFactoryManager');
InteractivityFactoryManager.a = false;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgxDataChartDefaultTooltipsComponent_1;
let IgxDataChartDefaultTooltipsComponent = IgxDataChartDefaultTooltipsComponent_1 = class IgxDataChartDefaultTooltipsComponent {
    constructor(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    ensureDefaultTooltip(series) {
        if (series.isPolar) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.polarTooltip;
            }
            else {
                if (series.tooltipTemplate === this.polarTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isRadial) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.radialTooltip;
            }
            else {
                if (series.tooltipTemplate === this.radialTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isShape) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.shapeTooltip;
            }
            else {
                if (series.tooltipTemplate === this.shapeTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isScatter) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.scatterTooltip;
            }
            else {
                if (series.tooltipTemplate === this.scatterTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isCategory &&
            !series.isFinancial) {
            let tooltip = series.isVertical ? this.anchoredVerticalCategoryTooltip : series.isRange ? this.rangeTooltip : this.anchoredCategoryTooltip;
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = tooltip;
            }
            else {
                if (series.tooltipTemplate === tooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
        else if (series.isFinancial) {
            if (series.showDefaultTooltip) {
                series.tooltipTemplate = this.financialTooltip;
            }
            else {
                if (series.tooltipTemplate === this.financialTooltip) {
                    series.tooltipTemplate = null;
                }
            }
        }
    }
    format(value) {
        if (value == undefined || value == null) {
            return "";
        }
        if (value.getTime) {
            return this.shortDate(value);
        }
        return value.toString();
    }
    shortDate(item) {
        if (item == undefined || item == null) {
            return "";
        }
        return item.toLocaleDateString() + " " + item.toLocaleTimeString();
    }
    hasOpen(series) {
        return series.openMemberPath;
    }
    getOpenValue(series, item) {
        return this.getItemValue(series, item, "openMemberPath", series.openMemberPath);
    }
    hasHigh(series) {
        return series.highMemberPath;
    }
    getHighValue(series, item) {
        return this.getItemValue(series, item, "highMemberPath", series.highMemberPath);
    }
    hasLow(series) {
        return series.lowMemberPath;
    }
    getLowValue(series, item) {
        return this.getItemValue(series, item, "lowMemberPath", series.lowMemberPath);
    }
    hasClose(series) {
        return series.closeMemberPath;
    }
    getCloseValue(series, item) {
        return this.getItemValue(series, item, "closeMemberPath", series.closeMemberPath);
    }
    hasVolume(series) {
        return series.volumeMemberPath;
    }
    getVolumeValue(series, item) {
        return this.getItemValue(series, item, "volumeMemberPath", series.volumeMemberPath);
    }
    getAnchoredValue(series, item) {
        return this.getItemValue(series, item, "valueMemberPath", series.valueMemberPath);
    }
    getXValue(series, item) {
        return this.getItemValue(series, item, "xMemberPath", series.xMemberPath);
    }
    getYValue(series, item) {
        return this.getItemValue(series, item, "yMemberPath", series.yMemberPath);
    }
    hasRadius(series) {
        return series.radiusMemberPath !== undefined;
    }
    getRadiusValue(series, item) {
        return this.getItemValue(series, item, "radiusMemberPath", series.radiusMemberPath);
    }
    getAngleValue(series, item) {
        return this.getItemValue(series, item, "angleMemberPath", series.angleMemberPath);
    }
    hasValue(series) {
        return series.valueMemberPath;
    }
    getItemValue(series, item, memberPath, memberPathValue) {
        return series.getItemValue(item, memberPath);
    }
    getValue(series, item) {
        return this.getItemValue(series, item, "valueMemberPath", series.valueMemberPath);
    }
    getBrush(series) {
        return series.actualBrush;
    }
    hasXY(series, item) {
        return series.xMemberPath && series.yMemberPath && item[series.xMemberPath] && item[series.yMemberPath];
    }
    hasColor(series) {
        return series.colorMemberPath;
    }
    getColorValue(series, item) {
        return this.getItemValue(series, item, "colorMemberPath", series.colorMemberPath);
    }
    asAny(item) {
        return item;
    }
    static register() {
        TypeRegistrar.registerCons("IgxDataChartDefaultTooltipsComponent", IgxDataChartDefaultTooltipsComponent_1);
    }
    ngAfterContentInit() {
        this.onContentReady.emit({});
    }
};
__decorate([
    ViewChild("anchoredCategoryTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "anchoredCategoryTooltip", void 0);
__decorate([
    ViewChild("anchoredVerticalCategoryTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "anchoredVerticalCategoryTooltip", void 0);
__decorate([
    ViewChild("financialTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "financialTooltip", void 0);
__decorate([
    ViewChild("polarTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "polarTooltip", void 0);
__decorate([
    ViewChild("radialTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "radialTooltip", void 0);
__decorate([
    ViewChild("rangeTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "rangeTooltip", void 0);
__decorate([
    ViewChild("scatterTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "scatterTooltip", void 0);
__decorate([
    ViewChild("shapeTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDataChartDefaultTooltipsComponent.prototype, "shapeTooltip", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], IgxDataChartDefaultTooltipsComponent.prototype, "onContentReady", void 0);
IgxDataChartDefaultTooltipsComponent = IgxDataChartDefaultTooltipsComponent_1 = __decorate([
    Component({
        selector: 'igx-data-chart-default-tooltips',
        changeDetection: ChangeDetectionStrategy.OnPush,
        template: `
    <ng-template #anchoredCategoryTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">            
            <span *ngIf="series.xAxis.isDateTime">{{shortDate(series.xAxis.getItemValue(asAny(item),'dateTimeMemberPath'))}}</span>
            <br *ngIf="series.xAxis.isDateTime" />
            <span *ngIf="!series.xAxis.isDateTime && series.xAxis.label">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>
            <br *ngIf="!series.xAxis.isDateTime && series.xAxis.label" />
            <span [style.color]="getBrush(series)">{{series.title}}: </span>
            <span class="ui-tooltip-priority">{{getAnchoredValue(series, item)}}</span>
        </div>
    </ng-template>
    <ng-template #anchoredVerticalCategoryTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">            
            <span *ngIf="series.yAxis.isDateTime">{{shortDate(series.yAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>
            <br *ngIf="series.yAxis.isDateTime" />
            <span *ngIf="!series.yAxis.isDateTime && series.yAxis.label">{{format(series.yAxis.getItemValue(asAny(item), 'label'))}}</span>
            <br *ngIf="!series.yAxis.isDateTime && series.yAxis.label" />
            <span [style.color]="getBrush(series)">{{series.title}}: </span>
            <span class="ui-tooltip-priority">{{getAnchoredValue(series, item)}}</span>
        </div>
    </ng-template>
    <ng-template #financialTooltip let-series="series" let-item="item" let-itemLabel="itemLabel">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">            
            <span *ngIf="series.xAxis.isDateTime">{{itemLabel}}</span>
            <br *ngIf="series.xAxis.isDateTime" />
            <span *ngIf="!series.xAxis.isDateTime && series.xAxis.label">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>
            <br *ngIf="!series.xAxis.isDateTime && series.xAxis.label" />
            <span [style.color]="getBrush(series)">{{series.title}}: </span>
            <table>
                <tr *ngIf="hasOpen(series)"><td>{{series.actualOpenLabel}}:</td><td>{{getOpenValue(series, item)}}</td></tr>
                <tr *ngIf="hasHigh(series)"><td>{{series.actualHighLabel}}:</td><td>{{getHighValue(series, item)}}</td></tr>
                <tr *ngIf="hasLow(series)"><td>{{series.actualLowLabel}}:</td><td>{{getLowValue(series, item)}}</td></tr>
                <tr *ngIf="hasClose(series)"><td>{{series.actualCloseLabel}}:</td><td>{{getCloseValue(series, item)}}</td></tr>
                <tr *ngIf="hasVolume(series)"><td>{{series.actualVolumeLabel}}:</td><td>{{getVolumeValue(series, item)}}</td></tr>
            </table>
        </div>
    </ng-template>    
    <ng-template #scatterTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">   
            <span [style.color]="getBrush(series)">{{series.title}}</span>
            <br/>
            <span *ngIf="hasRadius(series)">({{getXValue(series, item)}}, {{getYValue(series, item)}}), {{series.actualRadiusLabel}}: {{getRadiusValue(series, item)}}</span>
            <span *ngIf="!hasRadius(series)">x: {{getXValue(series, item)}}</span>
            <br *ngIf="!hasRadius(series)"/>
            <span *ngIf="!hasRadius(series)">y: {{getYValue(series, item)}}</span>
        </div>
    </ng-template>
    <ng-template #polarTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">
            <span>{{getAngleValue(series, item)}}</span>
            <br/>
            <span [style.color]="getBrush(series)">{{series.title}}: {{getRadiusValue(series, item)}}</span> 
        </div>
    </ng-template>
    <ng-template #radialTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">
            <span>{{series.angleAxis.label}}</span>
            <br/>
            <span [style.color]="getBrush(series)">{{series.title}}: {{getAnchoredValue(series, item)}}</span> 
        </div>
    </ng-template>    
    <ng-template #rangeTooltip let-series="series" let-item="item">
    <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">            
        <span *ngIf="series.xAxis.isDateTime">{{shortDate(series.xAxis.getItemValue(asAny(item), 'dateTimeMemberPath'))}}</span>
        <br *ngIf="series.xAxis.isDateTime" />
        <span *ngIf="!series.xAxis.isDateTime && series.xAxis.label">{{format(series.xAxis.getItemValue(asAny(item), 'label'))}}</span>
        <br *ngIf="!series.xAxis.isDateTime && series.xAxis.label" />
        <span [style.color]="getBrush(series)">{{series.title}}: </span>
        <span class="ui-tooltip-priority">{{getLowValue(series, item)}} - {{getHighValue(series, item)}}</span>
    </div>
    </ng-template>    
    <ng-template #shapeTooltip let-series="series" let-item="item">
        <div class='ui-chart-default-tooltip-content' *ngIf="item" style="white-space:nowrap">   
            <span [style.color]="getBrush(series)">{{series.title}}</span>
            <br *ngIf="hasXY(series, item)"/>
            <span *ngIf="hasXY(series, item)">({{getXValue(series, item)}}, {{getYValue(series, item)}})</span>
            <br *ngIf="hasColor(series)"/>
            <span *ngIf="hasColor(series)">{{series.actualValueLabel}}: {{getColorValue(series, item)}}</span>
            <br *ngIf="hasValue(series)"/>
            <span *ngIf="hasValue(series)">{{series.actualValueLabel}}: {{item}}</span>
        </div>
    </ng-template>
  `,
        styles: []
    }),
    __metadata("design:paramtypes", [ChangeDetectorRef])
], IgxDataChartDefaultTooltipsComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartInteractivityModule = class IgxDataChartInteractivityModule {
    constructor() {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        TypeRegistrar.registerCons('IgxDataChartDefaultTooltipsComponent', IgxDataChartDefaultTooltipsComponent);
    }
};
IgxDataChartInteractivityModule = __decorate([
    NgModule({
        declarations: [IgxDataChartDefaultTooltipsComponent],
        exports: [IgxDataChartDefaultTooltipsComponent,
            IgxDVInteractivityModule
        ],
        imports: [CommonModule, IgxDVInteractivityModule
        ],
        entryComponents: [IgxDataChartDefaultTooltipsComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartInteractivityModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartInteractivityDynamicModule = class IgxDataChartInteractivityDynamicModule {
    constructor() {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        TypeRegistrar.registerCons('IgxDataChartDefaultTooltipsComponent', IgxDataChartDefaultTooltipsComponent);
    }
};
IgxDataChartInteractivityDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDVInteractivityDynamicModule,
            IgxDataChartInteractivityModule
        ],
        imports: [CommonModule, IgxDVInteractivityDynamicModule,
            IgxDataChartInteractivityModule
        ],
        entryComponents: [IgxDataChartDefaultTooltipsComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartInteractivityDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrendLineManager_$type = new Type(null, 'ITrendLineManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendLineManagerBase$1 extends Base {
    constructor($tTrendColumn) {
        super();
        this.$tTrendColumn = null;
        this.d = null;
        this.a = null;
        this.g = ((() => {
            let $ret = new Polyline();
            $ret.ab = false;
            return $ret;
        })());
        this.$tTrendColumn = $tTrendColumn;
        this.$type = this.$type.specialize(this.$tTrendColumn);
        this.d = new List$1(this.$tTrendColumn, 0);
    }
    get g$j() {
        return this.g;
    }
    g$g(a) {
        this.g$h(a, null);
    }
    c(a) {
        return a == 1 || a == 2 || a == 3 || a == 4 || a == 5 || a == 6 || a == 7 || a == 8;
    }
    b(a) {
        return a == 9 || a == 10 || a == 11 || a == 12 || a == 13;
    }
    g$h(a, b) {
        this.g$j.ak.clear();
        if (b != null) {
            b.i = this.g$j.ak;
        }
        if (a != null) {
            for (let c of fromEnum(a)) {
                if (!isNaN_(c.x) && !isNaN_(c.y)) {
                    if (b != null) {
                        b.j(c);
                    }
                    else {
                        this.g$j.ak.add(c);
                    }
                }
            }
        }
        this.g$j.ab = this.g$j.ak.count > 0;
    }
    e(a, b, c) {
        this.f(a, b, c, null);
    }
    f(a, b, c, d) {
        if (d != null) {
            d.i = c;
        }
        for (let e of fromEnum(Flattener.d(a.count, (f) => a.item(f).x, (f) => a.item(f).y, b.b))) {
            if (d != null) {
                d.j(a.item(e));
            }
            else {
                c.add(a.item(e));
            }
        }
    }
    g$c(a, b) {
        if (a == null || b == null) {
            return;
        }
        if (this.g$j.x != null) {
            this.g$f();
        }
        a.ab.add(this.g$j);
    }
    g$f() {
        if (this.g$j == null) {
            return;
        }
        let a = typeCast(Panel.$, this.g$j.x);
        if (a != null) {
            a.ab.remove(this.g$j);
        }
    }
    g$d() {
        this.g$j.ak.clear();
    }
    g$i() {
        this.a = null;
        this.d.clear();
    }
    g$e(a, b, c, d) {
        switch (a) {
            case 3:
            case 2:
            case 1:
            case 0:
            case 4:
                this.g$i();
                break;
        }
    }
    g$b(a, b, c, d) {
        let e = false;
        switch (b) {
            case "TrendLineType":
            case "TrendLinePeriod":
                this.g$i();
                e = true;
                break;
            case "TrendLineThickness":
                e = true;
                break;
            case Series.$$p[8]:
                e = true;
                this.g$i();
                break;
        }
        return e;
    }
}
TrendLineManagerBase$1.$t = markType(TrendLineManagerBase$1, 'TrendLineManagerBase$1', Base.$, [ITrendLineManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendResolutionParams extends Base {
    constructor() {
        super(...arguments);
        this.d = 0;
        this.e = 0;
        this.c = 0;
        this.f = null;
        this.g = null;
        this.b = 0;
        this.a = 0;
    }
}
TrendResolutionParams.$t = markType(TrendResolutionParams, 'TrendResolutionParams');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTrendLineManagerBase extends TrendLineManagerBase$1 {
    constructor() {
        super(Number_$type);
    }
    get_g$a() {
        return 0;
    }
    get g$a() {
        return this.get_g$a();
    }
    prepareLine(a, b, c, d) {
        let e = b.k;
        let f = new ScalerParams(0, b.m, b.l, b.b.j$a, e);
        let g = new ScalerParams(0, b.m, b.l, b.c.j$a, e);
        if (typeCast(Series.$, a) !== null) {
            g.b = a.eh();
        }
        let h = c.f;
        if (b.d != null && b.d.i$b != null) {
            h = new SafeSortedReadOnlyDoubleCollection(0, h, b.d.i$b);
        }
        let i = ((() => {
            let $ret = new TrendResolutionParams();
            $ret.c = b.h;
            $ret.d = b.i;
            $ret.e = b.j;
            $ret.a = d;
            $ret.b = b.g;
            $ret.f = b.l;
            return $ret;
        })());
        if (a.trendLineType != 0) {
            if (a.isVertical) {
                this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, (j) => b.c.j$b(j, g), (j) => b.b.j$b(j, f), i);
            }
            else {
                this.prepareLineCore(b.a.p, a.trendLineType, h, a.trendLinePeriod, (j) => b.b.j$b(j, f), (j) => b.c.j$b(j, g), i);
            }
        }
    }
}
CategoryTrendLineManagerBase.$t = markType(CategoryTrendLineManagerBase, 'CategoryTrendLineManagerBase', TrendLineManagerBase$1.$.specialize(Number_$type), [IPreparesCategoryTrendline_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendFitCalculator extends Base {
    static a(a, b, c, d, e, f, g, h, i, j, k) {
        if (d == null) {
            switch (b) {
                case 1:
                    d = LeastSquaresFit.k(e, f, g);
                    break;
                case 2:
                    d = LeastSquaresFit.o(e, f, g);
                    break;
                case 3:
                    d = LeastSquaresFit.i(e, f, g);
                    break;
                case 4:
                    d = LeastSquaresFit.p(e, f, g);
                    break;
                case 5:
                    d = LeastSquaresFit.q(e, f, g);
                    break;
                case 7:
                    d = LeastSquaresFit.j(e, f, g);
                    break;
                case 6:
                    d = LeastSquaresFit.l(e, f, g);
                    break;
                case 8:
                    d = LeastSquaresFit.n(e, f, g);
                    break;
                default: throw new NotImplementedException(0);
            }
        }
        if (d == null) {
            return null;
        }
        for (let l = 0; l < c.f.width; l += 2) {
            let m = l / (c.f.width - 1);
            let n = j + m * (k - j);
            let o = NaN;
            switch (b) {
                case 1:
                    o = LeastSquaresFit.ad(d, n);
                    break;
                case 2:
                    o = LeastSquaresFit.ah(d, n);
                    break;
                case 3:
                    o = LeastSquaresFit.ab(d, n);
                    break;
                case 4:
                    o = LeastSquaresFit.ai(d, n);
                    break;
                case 5:
                    o = LeastSquaresFit.aj(d, n);
                    break;
                case 7:
                    o = LeastSquaresFit.ac(d, n);
                    break;
                case 6:
                    o = LeastSquaresFit.ae(d, n);
                    break;
                case 8:
                    o = LeastSquaresFit.ag(d, n);
                    break;
                default: throw new NotImplementedException(0);
            }
            n = h(n);
            o = i(o);
            if (!isNaN_(o) && !isInfinity(o)) {
                a.add({ $type: Point_$type, x: n + c.a, y: o });
            }
        }
        return d;
    }
}
TrendFitCalculator.$t = markType(TrendFitCalculator, 'TrendFitCalculator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendAverageCalculator extends Base {
    static a(a, b, c) {
        let d;
        switch (a) {
            case 9:
            case 10:
            case 11:
            case 13:
                if (c < 1) {
                    c = 1;
                }
                break;
        }
        switch (a) {
            case 9:
                d = TrendCalculators.e(b, c);
                break;
            case 10:
                d = TrendCalculators.b(b, c);
                break;
            case 11:
                d = TrendCalculators.c(b, c);
                break;
            case 12:
                d = TrendCalculators.a(b);
                break;
            case 13:
                d = TrendCalculators.g(b, c);
                break;
            default: throw new NotImplementedException(0);
        }
        return d;
    }
    static b(a, b, c, d) {
        if (b.count == 0) {
            let e = TrendAverageCalculator.a(a, c, d);
            for (let f of fromEnum(e)) {
                b.add(f);
            }
        }
    }
    static c(a, b, c, d, e) {
        if (b.count == 0) {
            let f = getEnumerator(TrendAverageCalculator.a(a, c, e));
            let g = getEnumerator(TrendAverageCalculator.a(a, d, e));
            while (f.moveNext() && g.moveNext()) {
                b.add({ $type: Point_$type, x: f.current, y: g.current });
            }
        }
    }
}
TrendAverageCalculator.$t = markType(TrendAverageCalculator, 'TrendAverageCalculator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTrendLineManager extends CategoryTrendLineManagerBase {
    prepareLineCore(a, b, c, d, e, f, g) {
        let h = g.d * g.c;
        let i = g.e * g.c;
        let j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, (k) => (k + 1), (k) => c.item(k), (k) => e(k - 1), f, h + 1, i + 1);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (let k = g.d; k <= g.e; k += 1) {
                let l = k * g.c;
                if (l >= 0 && l < this.d.count) {
                    let m = e(l);
                    let n = f(this.d._inner[l]);
                    j.add({ $type: Point_$type, x: m + g.a, y: n });
                }
            }
        }
        this.e(j, g, a);
    }
}
CategoryTrendLineManager.$t = markType(CategoryTrendLineManager, 'CategoryTrendLineManager', CategoryTrendLineManagerBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SortingTrendLineManager extends CategoryTrendLineManagerBase {
    constructor(a, b) {
        super();
        this.h = null;
        this.i = null;
        this.h = a;
        this.i = b;
    }
    get_g$a() {
        return 1;
    }
    prepareLineCore(a, b, c, d, e, f, g) {
        let h = g.d * g.c;
        let i = g.e * g.c;
        let j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = TrendFitCalculator.a(j, b, g, this.a, c.count, (k) => (k + 1), (k) => c.item(k), (k) => {
                let l = truncate(Math.floor(k));
                let m = truncate(Math.ceil(k));
                let n = k - l;
                let o;
                if (m <= i) {
                    o = this.h(l) + n * (this.h(m) - this.h(l));
                }
                else {
                    o = this.h(l) + n * (this.h(truncate(i)) - this.h(l));
                }
                return e(o);
            }, f, h, i);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (let k = g.d; k <= g.e; k += 1) {
                let l = k * g.c;
                let m = this.h(l);
                if (l >= 0 && l < this.d.count) {
                    let n = e(m);
                    let o = f(this.d._inner[l]);
                    j.add({ $type: Point_$type, x: n + g.a, y: o });
                }
            }
        }
        this.e(j, g, a);
    }
}
SortingTrendLineManager.$t = markType(SortingTrendLineManager, 'SortingTrendLineManager', CategoryTrendLineManagerBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryTrendLineModule = class IgxDataChartCategoryTrendLineModule {
    constructor() {
        TypeRegistrar.register('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory.$type);
        TypeRegistrar.register('CategoryTrendLineManager', CategoryTrendLineManager.$type);
        TypeRegistrar.register('SortingTrendLineManager', SortingTrendLineManager.$type);
    }
};
IgxDataChartCategoryTrendLineModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartCategoryTrendLineModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryTrendLineDynamicModule = class IgxDataChartCategoryTrendLineDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory);
        TypeRegistrar.registerCons('CategoryTrendLineManager', CategoryTrendLineManager);
        TypeRegistrar.registerCons('SortingTrendLineManager', SortingTrendLineManager);
        TypeRegistrar.register('CategoryTrendLineManagerFactory', CategoryTrendLineManagerFactory.$type);
        TypeRegistrar.register('CategoryTrendLineManager', CategoryTrendLineManager.$type);
        TypeRegistrar.register('SortingTrendLineManager', SortingTrendLineManager.$type);
    }
};
IgxDataChartCategoryTrendLineDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDataChartCategoryTrendLineModule
        ],
        imports: [CommonModule, IgxDataChartCategoryTrendLineModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartCategoryTrendLineDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartAnnotationModule = class IgxDataChartAnnotationModule {
    constructor() {
        TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
    }
};
IgxDataChartAnnotationModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCrosshairLayerModule,
            IgxCategoryToolTipLayerModule,
            IgxItemToolTipLayerModule,
            IgxCategoryItemHighlightLayerModule,
            IgxCategoryHighlightLayerModule,
            IgxFinalValueLayerModule,
            IgxCalloutLayerModule
        ],
        imports: [CommonModule, IgxCrosshairLayerModule,
            IgxCategoryToolTipLayerModule,
            IgxItemToolTipLayerModule,
            IgxCategoryItemHighlightLayerModule,
            IgxCategoryHighlightLayerModule,
            IgxFinalValueLayerModule,
            IgxCalloutLayerModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartAnnotationModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartAnnotationDynamicModule = class IgxDataChartAnnotationDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('AnnotationFactoryManager', AnnotationFactoryManager);
        TypeRegistrar.register('AnnotationFactoryManager', AnnotationFactoryManager.$type);
    }
};
IgxDataChartAnnotationDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCrosshairLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxDataChartAnnotationModule
        ],
        imports: [CommonModule, IgxCrosshairLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxDataChartAnnotationModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartAnnotationDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryChartModule = class IgxCategoryChartModule {
};
IgxCategoryChartModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryChartCoreModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorModule,
            IgxDataChartInteractivityModule,
            IgxDataChartCategoryTrendLineModule,
            IgxDataChartAnnotationModule
        ],
        imports: [CommonModule, IgxCategoryChartCoreModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorModule,
            IgxDataChartInteractivityModule,
            IgxDataChartCategoryTrendLineModule,
            IgxDataChartAnnotationModule
        ],
        entryComponents: []
    })
], IgxCategoryChartModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryChartDynamicModule = class IgxCategoryChartDynamicModule {
};
IgxCategoryChartDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryChartCoreDynamicModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxDataChartCategoryTrendLineDynamicModule,
            IgxDataChartAnnotationDynamicModule,
            IgxCategoryChartModule
        ],
        imports: [CommonModule, IgxCategoryChartCoreDynamicModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxDataChartCategoryTrendLineDynamicModule,
            IgxDataChartAnnotationDynamicModule,
            IgxCategoryChartModule
        ],
        entryComponents: []
    })
], IgxCategoryChartDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeValueList extends Base {
    constructor(a, b) {
        super();
        this.a = null;
        this.b = null;
        this.a = a;
        this.b = b;
    }
    indexOf(a) {
        throw new NotImplementedException(0);
    }
    insert(a, b) {
        throw new NotImplementedException(0);
    }
    removeAt(a) {
        throw new NotImplementedException(0);
    }
    item(a, b) {
        if (arguments.length === 2) {
            return b;
        }
        else {
            let b = NaN;
            let c = NaN;
            if (this.a != null && a >= 0 && a < this.a.count) {
                b = this.a.item(a);
            }
            if (this.b != null && a >= 0 && a < this.b.count) {
                c = this.b.item(a);
            }
            let d = isNaN_(b);
            let e = isNaN_(c);
            if (!d && !e) {
                return (b + c) / 2;
            }
            if (!d) {
                return b;
            }
            if (!e) {
                return c;
            }
            return NaN;
        }
    }
    add(a) {
        throw new NotImplementedException(0);
    }
    clear() {
        throw new NotImplementedException(0);
    }
    contains(a) {
        throw new NotImplementedException(0);
    }
    copyTo(a, b) {
        throw new NotImplementedException(0);
    }
    get count() {
        let a = 0;
        let b = 0;
        if (this.a != null) {
            a = this.a.count;
        }
        if (this.b != null) {
            b = this.b.count;
        }
        let c = 0;
        c = Math.max(c, a);
        c = Math.max(c, b);
        return c;
    }
    get isReadOnly() {
        return true;
    }
    remove(a) {
        throw new NotImplementedException(0);
    }
    getEnumerator() {
        throw new NotImplementedException(0);
    }
    getEnumeratorObject() {
        throw new NotImplementedException(0);
    }
}
RangeValueList.$t = markType(RangeValueList, 'RangeValueList', Base.$, [IList$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Tooltip extends HTMLElement {
    constructor() {
        super(...arguments);
        this._updateToolTip = null;
        this._hideToolTip = null;
    }
    get updateToolTip() {
        return this._updateToolTip;
    }
    set updateToolTip(a) {
        this._updateToolTip = a;
    }
    get hideToolTip() {
        return this._hideToolTip;
    }
    set hideToolTip(a) {
        this._hideToolTip = a;
    }
}
Tooltip.$t = markType(Tooltip, 'Tooltip', HTMLElement.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IDomainChartWidget_$type = new Type(null, 'IDomainChartWidget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieChartStyleInfo extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.f = null;
        this.g = null;
        this.c = null;
        this.h = null;
        this.i = null;
        this.e = 0;
        this.d = 0;
    }
}
PieChartStyleInfo.$t = markType(PieChartStyleInfo, 'PieChartStyleInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieSliceVisualData extends Base {
    constructor() {
        super();
        this._startAngle = 0;
        this._endAngle = 0;
        this._origin = null;
        this._explodedOrigin = null;
        this._radius = 0;
        this._explodedRadius = 0;
        this._innerExtentStart = 0;
        this._innerExtentEnd = 0;
        this._isSelected = false;
        this._isExploded = false;
        this._isOthersSlice = false;
        this._index = 0;
        this._label = null;
        this._labelAngle = 0;
        this._labelBounds = null;
        this._appearance = null;
        this._labelAppearance = null;
        this._leaderLineAppearance = null;
        this._slicePath = null;
        this._leaderLinePath = null;
        this.labelBounds = RectData.empty;
    }
    get startAngle() {
        return this._startAngle;
    }
    set startAngle(a) {
        this._startAngle = a;
    }
    get endAngle() {
        return this._endAngle;
    }
    set endAngle(a) {
        this._endAngle = a;
    }
    get origin() {
        return this._origin;
    }
    set origin(a) {
        this._origin = a;
    }
    get explodedOrigin() {
        return this._explodedOrigin;
    }
    set explodedOrigin(a) {
        this._explodedOrigin = a;
    }
    get radius() {
        return this._radius;
    }
    set radius(a) {
        this._radius = a;
    }
    get explodedRadius() {
        return this._explodedRadius;
    }
    set explodedRadius(a) {
        this._explodedRadius = a;
    }
    get innerExtentStart() {
        return this._innerExtentStart;
    }
    set innerExtentStart(a) {
        this._innerExtentStart = a;
    }
    get innerExtentEnd() {
        return this._innerExtentEnd;
    }
    set innerExtentEnd(a) {
        this._innerExtentEnd = a;
    }
    get isSelected() {
        return this._isSelected;
    }
    set isSelected(a) {
        this._isSelected = a;
    }
    get isExploded() {
        return this._isExploded;
    }
    set isExploded(a) {
        this._isExploded = a;
    }
    get isOthersSlice() {
        return this._isOthersSlice;
    }
    set isOthersSlice(a) {
        this._isOthersSlice = a;
    }
    get index() {
        return this._index;
    }
    set index(a) {
        this._index = a;
    }
    get label() {
        return this._label;
    }
    set label(a) {
        this._label = a;
    }
    get labelAngle() {
        return this._labelAngle;
    }
    set labelAngle(a) {
        this._labelAngle = a;
    }
    get labelBounds() {
        return this._labelBounds;
    }
    set labelBounds(a) {
        this._labelBounds = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    get labelAppearance() {
        return this._labelAppearance;
    }
    set labelAppearance(a) {
        this._labelAppearance = a;
    }
    get leaderLineAppearance() {
        return this._leaderLineAppearance;
    }
    set leaderLineAppearance(a) {
        this._leaderLineAppearance = a;
    }
    get slicePath() {
        return this._slicePath;
    }
    set slicePath(a) {
        this._slicePath = a;
    }
    get leaderLinePath() {
        return this._leaderLinePath;
    }
    set leaderLinePath(a) {
        this._leaderLinePath = a;
    }
    scaleByViewport(a) {
        if (this.slicePath != null) {
            this.slicePath.scaleByViewport(a);
        }
        if (this.leaderLinePath != null) {
            this.leaderLinePath.scaleByViewport(a);
        }
        if (!this.labelBounds.isEmpty) {
            let b = (this.labelBounds.left - a.left) / a.width;
            let c = (this.labelBounds.top - a.top) / a.height;
            let d = ((this.labelBounds.left + this.labelBounds.width) - a.left) / a.width;
            let e = ((this.labelBounds.top + this.labelBounds.height) - a.top) / a.height;
            this.labelBounds = new RectData(b, c, d - b, e - c);
        }
        if (this.origin != null) {
            this.origin = new PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
        }
        if (this.explodedOrigin != null) {
            this.explodedOrigin = new PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        if (this.leaderLineAppearance != null) {
            a.u("leaderLineAppearance: " + this.leaderLineAppearance.serialize() + ", ");
        }
        if (this.slicePath != null) {
            a.u("slicePath: " + this.slicePath.serialize() + ", ");
        }
        if (this.leaderLinePath != null) {
            let b = this.leaderLinePath.serialize();
            if (b != null) {
                a.u("leaderLinePath: " + b + ", ");
            }
        }
        a.u("labelAngle: " + this.labelAngle + ", ");
        a.u("labelBounds: { left: " + this.labelBounds.left + ", top: " + this.labelBounds.top + ", width: " + this.labelBounds.width + ", height: " + this.labelBounds.height + "}");
        a.u("}");
        return a.toString();
    }
}
PieSliceVisualData.$t = markType(PieSliceVisualData, 'PieSliceVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieSliceVisualDataList extends List$1 {
    constructor() {
        super(PieSliceVisualData.$, 0);
    }
}
PieSliceVisualDataList.$t = markType(PieSliceVisualDataList, 'PieSliceVisualDataList', List$1.$.specialize(PieSliceVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieChartVisualData extends Base {
    constructor() {
        super();
        this._slices = null;
        this._othersSlice = null;
        this._name = null;
        this._viewport = null;
        this._width = 0;
        this._height = 0;
        this._others = null;
        this._radiusFactor = 0;
        this._leaderLineMargin = 0;
        this._isViewportScaled = false;
        this._dipScalingRatio = 0;
        this.slices = new PieSliceVisualDataList();
        this.others = new List$1(Base.$, 0);
        this.dipScalingRatio = 1;
    }
    get slices() {
        return this._slices;
    }
    set slices(a) {
        this._slices = a;
    }
    get othersSlice() {
        return this._othersSlice;
    }
    set othersSlice(a) {
        this._othersSlice = a;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    get others() {
        return this._others;
    }
    set others(a) {
        this._others = a;
    }
    get radiusFactor() {
        return this._radiusFactor;
    }
    set radiusFactor(a) {
        this._radiusFactor = a;
    }
    get leaderLineMargin() {
        return this._leaderLineMargin;
    }
    set leaderLineMargin(a) {
        this._leaderLineMargin = a;
    }
    get isViewportScaled() {
        return this._isViewportScaled;
    }
    set isViewportScaled(a) {
        this._isViewportScaled = a;
    }
    get dipScalingRatio() {
        return this._dipScalingRatio;
    }
    set dipScalingRatio(a) {
        this._dipScalingRatio = a;
    }
    scaleByViewport() {
        if (this.isViewportScaled) {
            return;
        }
        this.isViewportScaled = true;
        for (let a = 0; a < this.slices.count; a++) {
            this.slices._inner[a].scaleByViewport(this.viewport);
        }
        if (this.othersSlice != null) {
            this.othersSlice.scaleByViewport(this.viewport);
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: " + this.name + ",");
        a.u("leaderLineMargin: " + this.leaderLineMargin + ",");
        a.u("radiusFactor: " + this.radiusFactor + ",");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
        a.u("slices: [");
        for (let b = 0; b < this.slices.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.slices._inner[b].serialize());
        }
        a.u("],");
        a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}");
        a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    }
}
PieChartVisualData.$t = markType(PieChartVisualData, 'PieChartVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available positions of labels.
 */
var LabelsPosition;
(function (LabelsPosition) {
    /**
     * No labels will be displayed.
     */
    LabelsPosition[LabelsPosition["None"] = 0] = "None";
    /**
     * Labels will be displayed in the center.
     */
    LabelsPosition[LabelsPosition["Center"] = 1] = "Center";
    /**
     * Labels will be displayed inside and by the edge of the container.
     */
    LabelsPosition[LabelsPosition["InsideEnd"] = 2] = "InsideEnd";
    /**
     * Labels will be displayed outside the container.
     */
    LabelsPosition[LabelsPosition["OutsideEnd"] = 3] = "OutsideEnd";
    /**
     * Labels will automatically decide their location.
     */
    LabelsPosition[LabelsPosition["BestFit"] = 4] = "BestFit";
})(LabelsPosition || (LabelsPosition = {}));
/**
 * @hidden
 */
let LabelsPosition_$type = markEnum('LabelsPosition', 'None,0|Center,1|InsideEnd,2|OutsideEnd,3|BestFit,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of a callout line for the labels.
 */
var LeaderLineType;
(function (LeaderLineType) {
    /**
     * A straight line is drawn between the slice and its label.
     */
    LeaderLineType[LeaderLineType["Straight"] = 0] = "Straight";
    /**
     * A curved line is drawn between the slice and its label. The line follows makes a natural turn from the slice to the label.
     */
    LeaderLineType[LeaderLineType["Arc"] = 1] = "Arc";
    /**
     * A curved line is drawn between the slice and its label. The line starts radially from the slice and then turns to the label.
     */
    LeaderLineType[LeaderLineType["Spline"] = 2] = "Spline";
})(LeaderLineType || (LeaderLineType = {}));
/**
 * @hidden
 */
let LeaderLineType_$type = markEnum('LeaderLineType', 'Straight,0|Arc,1|Spline,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for calculating and grouping slices into the Others slice.
 */
var OthersCategoryType;
(function (OthersCategoryType) {
    /**
     * Data value is compared directly to the value of OthersCategoryThreshold.
     */
    OthersCategoryType[OthersCategoryType["Number"] = 0] = "Number";
    /**
     * Data value is compared to OthersCategoryThreshold as a percentage of the total.
     */
    OthersCategoryType[OthersCategoryType["Percent"] = 1] = "Percent";
})(OthersCategoryType || (OthersCategoryType = {}));
/**
 * @hidden
 */
let OthersCategoryType_$type = markEnum('OthersCategoryType', 'Number,0|Percent,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndexCollection extends ObservableCollection$1 {
    constructor() {
        super(Number_$type, 0);
    }
    r(a, b) {
        if (!this.contains(b)) {
            super.r(a, b);
        }
    }
    x(a, b) {
        if (this.contains(b)) {
            this.remove(b);
            this.r(a, b);
        }
        else {
            super.x(a, b);
        }
    }
}
IndexCollection.$t = markType(IndexCollection, 'IndexCollection', ObservableCollection$1.$.specialize(Number_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes for selecting slices.
 */
var SliceSelectionMode;
(function (SliceSelectionMode) {
    /**
     * Slices can be programmatically selected but cannot be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Manual"] = 0] = "Manual";
    /**
     * Single slice can be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Single"] = 1] = "Single";
    /**
     * Multiple slices can be selected through the UI.
     */
    SliceSelectionMode[SliceSelectionMode["Multiple"] = 2] = "Multiple";
})(SliceSelectionMode || (SliceSelectionMode = {}));
/**
 * @hidden
 */
let SliceSelectionMode_$type = markEnum('SliceSelectionMode', 'Manual,0|Single,1|Multiple,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SelectedItemChangedEventArgs extends EventArgs {
    constructor(a, b) {
        super();
        this._oldItem = null;
        this._newItem = null;
        this.oldItem = a;
        this.newItem = b;
    }
    get oldItem() {
        return this._oldItem;
    }
    set oldItem(a) {
        this._oldItem = a;
    }
    get newItem() {
        return this._newItem;
    }
    set newItem(a) {
        this._newItem = a;
    }
}
SelectedItemChangedEventArgs.$t = markType(SelectedItemChangedEventArgs, 'SelectedItemChangedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SelectedItemChangingEventArgs extends SelectedItemChangedEventArgs {
    constructor(a, b) {
        super(a, b);
        this._cancel = false;
    }
    get cancel() {
        return this._cancel;
    }
    set cancel(a) {
        this._cancel = a;
    }
}
SelectedItemChangingEventArgs.$t = markType(SelectedItemChangingEventArgs, 'SelectedItemChangingEventArgs', SelectedItemChangedEventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SelectedItemsChangedEventArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._oldItems = null;
        this._newItems = null;
        this._currentItems = null;
        this.oldItems = a;
        this.newItems = b;
        this.currentItems = c;
    }
    get oldItems() {
        return this._oldItems;
    }
    set oldItems(a) {
        this._oldItems = a;
    }
    get newItems() {
        return this._newItems;
    }
    set newItems(a) {
        this._newItems = a;
    }
    get currentItems() {
        return this._currentItems;
    }
    set currentItems(a) {
        this._currentItems = a;
    }
}
SelectedItemsChangedEventArgs.$t = markType(SelectedItemsChangedEventArgs, 'SelectedItemsChangedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SelectedItemsChangingEventArgs extends SelectedItemsChangedEventArgs {
    constructor(a, b, c) {
        super(a, b, c);
        this._cancel = false;
    }
    get cancel() {
        return this._cancel;
    }
    set cancel(a) {
        this._cancel = a;
    }
}
SelectedItemsChangingEventArgs.$t = markType(SelectedItemsChangingEventArgs, 'SelectedItemsChangingEventArgs', SelectedItemsChangedEventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieLegendTemplates extends Base {
    static f(a) {
        let b = a.data;
        let c = b.series;
        let d = c.legendItemBadgeTemplate;
        let e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
        if (e == null) {
            e = "Pie Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    }
    static c(a) {
        let b = a.data;
        let c = b.series;
        let d = c.legendItemBadgeTemplate;
        let e = b.legendLabel != null ? b.legendLabel : b.itemLabel;
        if (e == null) {
            e = "Doughnut Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    }
    static a(a) {
    }
    static d(a) {
    }
    static e(a) {
        let b = a.data;
        let c = a.context;
        let d = new RenderingContext(new CanvasViewRenderer(), c);
        let e = b.series;
        let f = b.itemBrush;
        let g = b.outline;
        let h = b.thickness;
        let i = new Rectangle();
        i.width = a.availableWidth - (h * 2) - 2;
        i.height = a.availableHeight - (h * 2);
        i.n = h + 1;
        i.o = h;
        i.ac = h;
        i._fill = f;
        i._stroke = g;
        d.v(i);
    }
    static b(a) {
        let b = a.data;
        let c = a.context;
        let d = new RenderingContext(new CanvasViewRenderer(), c);
        let e = b.itemBrush;
        let f = b.outline;
        let g = b.thickness;
        let h = new Rectangle();
        h.width = a.availableWidth - (g * 2) - 2;
        h.height = a.availableHeight - (g * 2);
        h.n = g + 1;
        h.o = g;
        h.ac = g;
        h._fill = e;
        h._stroke = f;
        d.v(h);
    }
}
PieLegendTemplates.$t = markType(PieLegendTemplates, 'PieLegendTemplates');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PieChartViewManager extends Base {
    constructor(a) {
        super();
        this.n = null;
        this.p = null;
        this.s = null;
        this.r = null;
        this.q = null;
        this.k = 0;
        this.j = 0;
        this.l = 1;
        this.ap = null;
        this.e = null;
        this.g = null;
        this.f = null;
        this.h = null;
        this.a = null;
        this.c = null;
        this._toolTipObject = null;
        this.u = null;
        this.i = true;
        this.a = a;
    }
    aa() {
        let a = this.n.rootWrapper.width();
        let b = this.n.rootWrapper.height();
        this.ad(a, b);
    }
    ad(a, b) {
        this.z();
        this.c.bg = new Rect(0, 0, 0, a, b);
        let c = this.a.a.cn;
        if (c == this.l && a == this.k && b == this.j) {
            return;
        }
        this.k = a;
        this.j = b;
        this.l = c;
        this.a.ba();
    }
    ae() {
        if (this.c != null) {
            this.c.bc(this.p, "");
        }
    }
    ab() {
        this.z();
        if (this.c != null) {
            this.c.aq(this.p, "");
        }
    }
    z() {
        let a = this.a.a.c0;
        let b = this.a.a.cn;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.a.a.cn = window.devicePixelRatio;
        }
    }
    w(a, b) {
        let c = this.a.a.cn;
        if (a != this.k || b != this.j || c != this.l) {
            this.k = a;
            this.j = b;
            this.l = this.a.a.cn;
            this.ao();
        }
    }
    ao() {
        this.ap = new Rect(0, 0, 0, this.k, this.j);
        let a = this.k;
        let b = this.j;
        let c = this.l;
        if (c != 1) {
            a = Math.round(this.k * c);
            b = Math.round(this.j * c);
        }
        this.p.setAttribute("width", a.toString());
        this.p.setAttribute("height", b.toString());
        this.p.setStyleProperty("width", this.k.toString() + "px");
        this.p.setStyleProperty("height", this.j.toString() + "px");
        this.r.setAttribute("width", a.toString());
        this.r.setAttribute("height", b.toString());
        this.r.setStyleProperty("width", this.k.toString() + "px");
        this.r.setStyleProperty("height", this.j.toString() + "px");
        this.q.setAttribute("width", a.toString());
        this.q.setAttribute("height", b.toString());
        this.q.setStyleProperty("width", this.k.toString() + "px");
        this.q.setStyleProperty("height", this.j.toString() + "px");
        this.s.setAttribute("width", a.toString());
        this.s.setAttribute("height", b.toString());
        this.s.setStyleProperty("width", this.k.toString() + "px");
        this.s.setStyleProperty("height", this.j.toString() + "px");
        return this.ap;
    }
    d() {
        return this.a.b.c;
    }
    an() {
        let a = DOMEventProxy.cz(this.n.rootWrapper);
        return { $type: Point_$type, x: a.left, y: a.top };
    }
    ah(a) {
        if (this.n != null) {
            this.n.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    }
    b() {
        let a = new PieChartStyleInfo();
        let b;
        let c;
        let d = BrushUtil.e("chart", this.n, b, c);
        b = d.p2;
        c = d.p3;
        a.a = b;
        a.b = c;
        this.n.startCSSQuery();
        a.f = ((() => {
            let $ret = new Brush();
            $ret.fill = this.n.getCssDefaultPropertyValue("ui-chart-innerlabels", "color");
            return $ret;
        })());
        a.g = ((() => {
            let $ret = new Brush();
            $ret.fill = this.n.getCssDefaultPropertyValue("ui-chart-outerlabels", "color");
            return $ret;
        })());
        this.n.endCSSQuery();
        a.c = FontUtil.getFont(this.n);
        a.e = DeviceUtils.g(6);
        a.i = ((() => {
            let $ret = new Brush();
            $ret.fill = "#00000033";
            return $ret;
        })());
        a.d = 1;
        return a;
    }
    ai(a) {
        a._stroke = ((() => {
            let $ret = new Brush();
            $ret.fill = "#000000";
            return $ret;
        })());
        a._fill = ((() => {
            let $ret = new Brush();
            $ret.fill = "#222222";
            return $ret;
        })());
    }
    ac(a) {
        if (a == null) {
            if (this.c != null) {
                this.c.ar();
            }
            this.n = null;
            this.p = null;
            this.r = null;
            this.q = null;
            this.s = null;
            this.e = null;
            this.g = null;
            this.f = null;
            this.h = null;
            this.c = null;
            return;
        }
        let b = a;
        this.n = b;
        this.a.bb();
        this.a.bk();
        this.n.rootWrapper.setStyleProperty("position", "relative");
        this.n.rootWrapper.addClass("ui-corner-all");
        this.n.rootWrapper.addClass("ui-widget-content");
        this.p = this.n.createElement("canvas");
        this.p.setStyleProperty("position", "absolute");
        this.p.setStyleProperty("top", "0px");
        this.p.setStyleProperty("left", "0px");
        this.r = this.n.createElement("canvas");
        this.r.setStyleProperty("position", "absolute");
        this.r.setStyleProperty("top", "0px");
        this.r.setStyleProperty("left", "0px");
        this.q = this.n.createElement("canvas");
        this.q.setStyleProperty("position", "absolute");
        this.q.setStyleProperty("top", "0px");
        this.q.setStyleProperty("left", "0px");
        this.s = this.n.createElement("canvas");
        this.s.setStyleProperty("position", "absolute");
        this.s.setStyleProperty("top", "0px");
        this.s.setStyleProperty("left", "0px");
        this.n.append(this.p);
        this.n.append(this.r);
        this.n.append(this.q);
        this.n.append(this.s);
        this.e = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.p));
        this.g = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.r));
        this.f = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.q));
        this.h = new RenderingContext(new CanvasViewRenderer(), this.n.get2DCanvasContext(this.s));
        this.c = new DOMEventProxy(this.s, this.n, false);
        let c = this.c;
        c.onMouseOver = delegateCombine(c.onMouseOver, runOn(this.a, this.a.aj));
        let d = this.c;
        d.onMouseLeave = delegateCombine(d.onMouseLeave, runOn(this.a, this.a.ai));
        let e = this.c;
        e.onMouseDown = delegateCombine(e.onMouseDown, runOn(this.a, this.a.ah));
        let f = this.c;
        f.onMouseUp = delegateCombine(f.onMouseUp, runOn(this.a, this.a.ak));
        this.c.ac = this.a.a.b5;
        this.ad(this.n.rootWrapper.width(), this.n.rootWrapper.height());
    }
    v(a) {
        this.n.append(a);
    }
    af(a) {
        if (this.c == null) {
            return;
        }
        this.c.ac = a;
    }
    t() {
        return this.n;
    }
    x(a) {
        a.width = this.k;
        a.height = this.j;
    }
    ak(a) {
        this.u = null;
        this._toolTipObject = null;
        if (typeof a === 'string') {
            this.u = a;
        }
        else {
            this._toolTipObject = a;
            if (this._toolTipObject != null) {
                this._toolTipObject.setStyleProperty("position", "absolute");
                this._toolTipObject.setStyleProperty("white-space", "nowrap");
                this._toolTipObject.setStyleProperty("top", "0");
                this._toolTipObject.setStyleProperty("left", "0");
                this._toolTipObject.setStyleProperty("z-index", "10000");
            }
        }
    }
    aj(pos_, context_) {
        if (this._toolTipObject != null) {
            if (this.i) {
                this.v(this._toolTipObject);
                this.i = false;
            }
            context_.hideOthers = true;
            if (this._toolTipObject.updateToolTip) {
                this._toolTipObject.updateToolTip(context_);
            }
            ;
            this._toolTipObject.setOffset(pos_.x, pos_.y);
        }
    }
    y(a) {
        if (this._toolTipObject != null) {
            let context_ = a;
            if (this._toolTipObject.hideToolTip) {
                this._toolTipObject.hideToolTip(context_);
            }
            ;
        }
    }
    al(style_) {
        let a = null;
        let fillColor_ = null;
        if (style_ != null) {
            if (style_.fill) {
                fillColor_ = style_.fill;
            }
            ;
            if (fillColor_ != null) {
                a = Brush.create(fillColor_);
            }
        }
        return a;
    }
    am(style_) {
        let a = null;
        let outlineColor_ = null;
        if (style_ != null) {
            if (style_.stroke) {
                outlineColor_ = style_.stroke;
            }
            ;
            if (outlineColor_ != null) {
                a = Brush.create(outlineColor_);
            }
        }
        return a;
    }
    m(style_) {
        let actualOutlineThickness_ = NaN;
        if (style_ != null) {
            if (style_.strokeThickness) {
                actualOutlineThickness_ = style_.strokeThickness;
            }
            ;
        }
        return actualOutlineThickness_;
    }
    ag() {
    }
}
PieChartViewManager.$t = markType(PieChartViewManager, 'PieChartViewManager');
/**
 * @hidden
 */
class LabelClickEventArgs extends EventArgs {
    constructor(a, b) {
        super();
        this._slice = null;
        this.c = true;
        this.slice = a;
    }
    get slice() {
        return this._slice;
    }
    set slice(a) {
        this._slice = a;
    }
    get item() {
        if (this.slice != null) {
            return this.slice.dataContext;
        }
        else {
            return null;
        }
    }
    get allowSliceClick() {
        return this.c;
    }
    set allowSliceClick(a) {
        this.c = a;
    }
}
LabelClickEventArgs.$t = markType(LabelClickEventArgs, 'LabelClickEventArgs', EventArgs.$);
/**
 * @hidden
 */
class SliceClickEventArgs extends EventArgs {
    constructor(a, b) {
        super();
        this._slice = null;
        this.d = false;
        this.c = false;
        this._originalEvent = null;
        this.slice = a;
        this.originalEvent = b;
        if (a == null) {
            return;
        }
        this.d = a.isSelected;
        this.c = a.isExploded;
    }
    get slice() {
        return this._slice;
    }
    set slice(a) {
        this._slice = a;
    }
    get isSelected() {
        return this.d;
    }
    set isSelected(a) {
        this.d = a;
        this.slice.ai.f8(this.slice, a);
    }
    get isExploded() {
        return this.c;
    }
    set isExploded(a) {
        this.c = a;
        this.slice.isExploded = a;
    }
    get isOthersSlice() {
        return this.slice.isOthersSlice;
    }
    get index() {
        return this.slice.a5;
    }
    get dataContext() {
        if (this.slice != null) {
            return this.slice.dataContext;
        }
        return null;
    }
    get originalEvent() {
        return this._originalEvent;
    }
    set originalEvent(a) {
        this._originalEvent = a;
    }
}
SliceClickEventArgs.$t = markType(SliceClickEventArgs, 'SliceClickEventArgs', EventArgs.$);
/**
 * @hidden
 */
class PieLabel extends Control {
    constructor() {
        super();
        this.ah = null;
        this.ao = null;
        this.ai = 0;
        this.aj = null;
        this.ap = null;
        this.aq = null;
        this.ag = 0;
    }
    ak(a) {
        if (a.a.aw == 3) {
            this.ao = a.b1(this);
            let b = typeCast(TextBlock.$, this.aj);
            let c = b.ak;
            a.a.f5();
            let d = this.ah.isExploded ? this.ah.b5 : this.ah.b7;
            let e = GeometryUtil.k(d, this.ai, this.ah.a2 + a.a.cw);
            let f = a.b2.width;
            if (a.y(b) + e.x > f && e.x < f) {
                while (c.length > 0 && a.y(b) + e.x > f) {
                    c = c.substr(0, c.length - 1);
                    b.ak = c;
                }
                if (c.length > 3) {
                    c = c.substr(0, c.length - 3);
                    c = c + "...";
                }
                else {
                    if (a.y("...") < this.ao.width) {
                        c = "...";
                    }
                    else {
                        c = stringEmpty();
                    }
                }
            }
            let g = new TextBlock();
            g.ak = c;
            this.aj = g;
        }
    }
    al() {
    }
    am() {
        this.ap._visibility = this.ah.ai.h6 != 0 ? this.ah.ai.h6 : this.ah.aj._visibility;
        let a;
        let b = this.ah.ai.cx;
        let c = GeometryUtil.k(this.ah.b6(), this.ai, this.ah.a2);
        this.ap.ak = c.x;
        this.ap.am = c.y;
        if (this.ai < 90 || this.ai >= 270) {
            a = { $type: Point_$type, x: this.ao.left, y: (this.ao.top + this.ao.bottom) / 2 };
        }
        else {
            a = { $type: Point_$type, x: this.ao.right, y: (this.ao.top + this.ao.bottom) / 2 };
        }
        if (b > 0) {
            let d = GeometryUtil.f(c, a);
            if (b < d) {
                a = GeometryUtil.m(a, c, b);
            }
            else {
                a = c;
            }
        }
        this.ap.al = a.x;
        this.ap.an = a.y;
    }
    an() {
        this.aq._visibility = this.ah.ai.h6 != 0 ? this.ah.ai.h6 : this.ah.aj._visibility;
        let a = this.ah.b6();
        let b = this.aq.ak.c._inner[0];
        let c = b._segments._inner[0];
        let d = this.ah.ai.cx;
        let e = (this.ao.top + this.ao.bottom) / 2;
        let f = GeometryUtil.k(a, this.ai, this.ah.a2);
        let g = GeometryUtil.k(a, this.ai, this.ah.a2 + this.ah.ai.cw / 2);
        let h;
        let i;
        let j;
        let k = e;
        if (this.ai < 90 && this.ai >= 0) {
            h = { $type: Point_$type, x: this.ao.left - 30, y: k };
            j = { $type: Point_$type, x: this.ao.left, y: e };
        }
        else if (this.ai < 180 && this.ai >= 90) {
            h = { $type: Point_$type, x: this.ao.right + 30, y: k };
            j = { $type: Point_$type, x: this.ao.right, y: e };
        }
        else if (this.ai < 270 && this.ai >= 180) {
            h = { $type: Point_$type, x: this.ao.right + 30, y: k };
            j = { $type: Point_$type, x: this.ao.right, y: e };
        }
        else {
            h = { $type: Point_$type, x: this.ao.left - 30, y: k };
            j = { $type: Point_$type, x: this.ao.left, y: e };
        }
        if (d > 0) {
            let l = GeometryUtil.f(f, j);
            if (d < l) {
                i = GeometryUtil.m(j, f, d);
                let m = g.x - f.x;
                let n = g.y - f.y;
                g = GeometryUtil.m(g, f, d);
                let o = g.x - f.x;
                let p = g.y - f.y;
                if ((m > 0 && o < 0) || (m < 0 && o > 0) || (n > 0 && p < 0) || (n < 0 && p > 0)) {
                    g = f;
                }
                h = GeometryUtil.m(h, f, d);
                let q = GeometryUtil.f(f, i) / GeometryUtil.f(f, j);
                h.x = f.x + (h.x - f.x) * q;
                h.y = f.y + (h.y - f.y) * q;
            }
            else {
                this.aq._visibility = 1;
                return;
            }
        }
        else {
            i = j;
        }
        if (this.ai < 180 && this.ai >= 0) {
            if (g.y > h.y) {
                g.y = f.y;
            }
        }
        else {
            if (g.y < h.y) {
                g.y = f.y;
            }
        }
        b._startPoint = f;
        if (this.ah.ai.ax == 1) {
            c.e = f;
        }
        else {
            c.e = g;
        }
        c.f = h;
        c.g = i;
    }
}
PieLabel.$t = markType(PieLabel, 'PieLabel', Control.$);
/**
 * @hidden
 */
class PieChartBase extends Control {
    constructor() {
        super();
        this.a0 = null;
        this.br = false;
        this.bu = false;
        this.bt = false;
        this.bv = false;
        this.bs = false;
        this.by = false;
        this.bx = false;
        this.bw = false;
        this.a4 = null;
        this.cf = null;
        this.ch = null;
        this.cg = null;
        this.ci = null;
        this.c5 = null;
        this.bh = null;
        this.c7 = 0;
        this.cz = 0;
        this.c4 = 0;
        this.cc = null;
        this.cb = null;
        this.ca = null;
        this.cp = 0;
        this.b9 = null;
        this.a3 = null;
        this._xsr = null;
        this.bf = null;
        this.bg = null;
        this.ar = new IndexCollection();
        this.as = new IndexCollection();
        this.ck = NaN;
        this.cj = 1;
        this._selectedItems = null;
        this.labelClick = null;
        this.selectedItemChanging = null;
        this.selectedItemsChanging = null;
        this.selectedItemChanged = null;
        this.selectedItemsChanged = null;
        this.sliceClick = null;
        this.bo = null;
        this.bn = null;
        this.h1 = null;
        this.am = null;
        this.ap = null;
        this.an = null;
        this.ao = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.db = null;
        this.h1 = Rect.empty;
        let a = this.az();
        this.fu(a);
        a.a1();
        this.ab = PieChartBase.$;
        this.cc = new List$1(Number_$type, 0);
        this.cb = new List$1(Number_$type, 0);
        this.ca = new List$1(Base.$, 0);
        this.a4 = (b, c) => this.fy(b, c.propertyName, c.oldValue, c.newValue);
        this.cf = (b, c) => {
            this.f5();
            this.f4();
        };
        this.cg = (b, c) => {
            if (this.bz) {
                this.fx();
                this.fw();
                this.f5();
                this.f3();
            }
        };
        this.ch = (b, c) => this.f7(c);
        this.ci = (b, c) => this.fq(c);
        this.c5 = (b, c) => this.e6(c.action, c.position, c.count, c.propertyName);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, this.a4);
        let b = this.selectedSlices;
        b.collectionChanged = delegateCombine(b.collectionChanged, this.ch);
        this.bv = true;
        let c = this.explodedSlices;
        c.collectionChanged = delegateCombine(c.collectionChanged, this.cg);
        this.bs = true;
        this.selectedItems = new ObjectCollection(0);
        let d = this.selectedItems;
        d.collectionChanged = delegateCombine(d.collectionChanged, this.ci);
        this.bo = ((() => {
            let $ret = new Pool$1(Slice.$);
            $ret.create = runOn(this.a0, this.a0.g);
            $ret.activate = runOn(this.a0, this.a0.be);
            $ret.disactivate = runOn(this.a0, this.a0.bg);
            $ret.destroy = runOn(this.a0, this.a0.bf);
            return $ret;
        })());
        this.bn = ((() => {
            let $ret = new Pool$1(PieLabel.$);
            $ret.create = runOn(this.a0, this.a0.d);
            $ret.activate = runOn(this.a0, this.a0.ar);
            $ret.disactivate = runOn(this.a0, this.a0.at);
            $ret.destroy = runOn(this.a0, this.a0.as);
            return $ret;
        })());
        this.a3 = new PieChartSliceSelector(this);
        FastItemObjectColumn.m();
    }
    az() {
        return new PieChartBaseView(this);
    }
    fu(a) {
        this.a0 = a;
    }
    onDetachedFromUI() {
        this.a0.a0();
    }
    onAttachedToUI() {
        this.a0.ax();
    }
    get bm() {
        return this.bh;
    }
    set bm(a) {
        if (this.bh != a) {
            let b = this.bh;
            this.bh = a;
            this.f0("ValueColumn", b, this.bh);
        }
    }
    get cm() {
        return Math.abs(this.cv) > 1 ? this.cv : this.cv * 100;
    }
    get XSRP() {
        if (this._xsr == null) {
            this._xsr = new SRProvider(this.a0.c.n);
        }
        return this._xsr;
    }
    get dn() {
        let a = this.XSRP.b1("InvalidLabelBinding");
        if (stringIsNullOrWhiteSpace(a)) {
            a = "There is no such value for the labels to bind.";
        }
        return a;
    }
    get cv() {
        return this.c(PieChartBase.gq);
    }
    set cv(a) {
        let b = a;
        if (isNaN_(a) || isInfinity(a)) {
            b = 0;
        }
        if (a < 0) {
            b = 0;
        }
        if (a > 100) {
            b = 100;
        }
        this.h(PieChartBase.gq, b);
    }
    get bi() {
        return this.bf;
    }
    set bi(a) {
        if (this.bf != a) {
            let b = this.bi;
            this.bf = a;
            this.f0("LabelColumn", b, this.bi);
        }
    }
    get bj() {
        return this.bg;
    }
    set bj(a) {
        if (this.bg != a) {
            let b = this.bj;
            this.bg = a;
            this.f0("LegendLabelColumn", b, this.bj);
        }
    }
    get cl() {
        let a = this.cq;
        if (isNaN_(a) || isInfinity(a) || a < 0) {
            return 0;
        }
        if (a > 1) {
            return 1;
        }
        return a;
    }
    get co() {
        let a = this.c1;
        if (isNaN_(a) || isInfinity(a) || a < 0) {
            return 0;
        }
        if (a > 1) {
            return 1;
        }
        return a;
    }
    get explodedSlices() {
        return this.ar;
    }
    set explodedSlices(a) {
        let b = this.ar;
        if (b != null) {
            let c = this.ar;
            c.collectionChanged = delegateRemove(c.collectionChanged, this.cg);
        }
        this.bs = false;
        this.ar = a;
        if (this.ar != null) {
            let d = this.ar;
            d.collectionChanged = delegateCombine(d.collectionChanged, this.cg);
            this.bs = true;
        }
        if (this.bz) {
            this.fx();
            this.fw();
            this.f5();
            this.f3();
        }
    }
    get selectedSlices() {
        return this.as;
    }
    set selectedSlices(a) {
        let b = this.as;
        b.collectionChanged = delegateRemove(b.collectionChanged, this.ch);
        this.bv = false;
        this.as = a;
        if (this.as != null) {
            let c = this.as;
            c.collectionChanged = delegateCombine(c.collectionChanged, this.ch);
            this.bv = true;
        }
        if (this.b0) {
            this.fx();
            this.fw();
            this.f5();
            this.f3();
            this.f4();
        }
    }
    get gi() {
        return typeCast(DataTemplate.$, this.c(PieChartBase.g0));
    }
    set gi(a) {
        this.h(PieChartBase.g0, a);
    }
    b2() {
        return this.a1 != null;
    }
    b3() {
        return this.a2 != null;
    }
    get c0() {
        return this.ck;
    }
    set c0(a) {
        let b = this.ck;
        this.ck = a;
        this.f0("PixelScalingRatio", b, this.ck);
    }
    get cn() {
        return this.cj;
    }
    set cn(a) {
        let b = this.cj;
        this.cj = a;
        this.f0("ActualPixelScalingRatio", b, this.cj);
    }
    get selectedItem() {
        return this.c(PieChartBase.hl);
    }
    set selectedItem(a) {
        this.h(PieChartBase.hl, a);
    }
    get selectedItems() {
        return this._selectedItems;
    }
    set selectedItems(a) {
        this._selectedItems = a;
    }
    fm(a, b) {
        if (this.labelClick != null) {
            this.labelClick(a, b);
        }
    }
    fo(a, b) {
        if (this.selectedItemChanging != null) {
            this.selectedItemChanging(a, b);
        }
    }
    fr(a, b) {
        if (this.selectedItemsChanging != null) {
            this.selectedItemsChanging(a, b);
        }
    }
    fn(a, b) {
        if (this.selectedItemChanged != null) {
            this.selectedItemChanged(a, b);
        }
    }
    fp(a, b) {
        if (this.selectedItemsChanged != null) {
            this.selectedItemsChanged(a, b);
        }
    }
    ft(a, b) {
        if (this.sliceClick != null) {
            this.sliceClick(a, b);
        }
    }
    e8(a, b) {
        if (!this.bs) {
            return;
        }
        if (!this.explodedSlices.contains(a.a5) && b) {
            this.explodedSlices.add(a.a5);
        }
        if (this.explodedSlices.contains(a.a5) && !b) {
            this.explodedSlices.remove(a.a5);
        }
    }
    f8(a, b) {
        this.bx = true;
        if (!this.selectedSlices.contains(a.a5) && b) {
            this.selectedSlices.add(a.a5);
        }
        if (this.selectedSlices.contains(a.a5) && !b) {
            this.selectedSlices.remove(a.a5);
        }
        this.bx = false;
    }
    f9(a) {
        this.a0.bc(a);
    }
    c8(a) {
        return this.a0.ad(a);
    }
    h0(a, b) {
        let c = new Rect(0, 0, 0, 0, 0);
        return c;
    }
    b1(a, b) {
        let c = a.ah;
        if (c == null) {
            return false;
        }
        let d = c.b6();
        let e = this.hv == 1 ? c.a3 : c.ax;
        let f = this.hv == 1 ? c.ax : c.a3;
        let g = false;
        let h = false;
        let i = GeometryUtil.k(d, e, c.a2);
        let j = GeometryUtil.k(d, f, c.a2);
        e = PieChartBase.cr(i.x, d.x, i.y, d.y);
        f = PieChartBase.cr(j.x, d.x, j.y, d.y);
        if (this.b4(c)) {
            h = true;
        }
        let k;
        k = MathUtil.e(a.ao.right - d.x, a.ao.top - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.right - d.x, a.ao.bottom - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.left - d.x, a.ao.top - d.y);
        if (k > c.a2) {
            return false;
        }
        k = MathUtil.e(a.ao.left - d.x, a.ao.bottom - d.y);
        if (k > c.a2) {
            return false;
        }
        if (h) {
            return true;
        }
        if (e > f) {
            e = e - 360;
            g = true;
        }
        let l;
        l = PieChartBase.cr(a.ao.right, d.x, a.ao.top, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.cr(a.ao.right, d.x, a.ao.bottom, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.cr(a.ao.left, d.x, a.ao.top, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        l = PieChartBase.cr(a.ao.left, d.x, a.ao.bottom, d.y);
        if (g && l > 180 && l < 360) {
            l = l - 360;
        }
        if (l < e || l > f) {
            return false;
        }
        return true;
    }
    static c2(a) {
        let b = Math.round(a * Math.pow(10, 5)) / Math.pow(10, 5);
        return b;
    }
    b4(a) {
        return PieChartBase.c2(Math.abs(a.ax - a.a3)) == 360;
    }
    static cr(a, b, c, d) {
        let e = MathUtil.e(a - b, c - d);
        let f = Math.asin((c - d) / e) * 180 / Math.PI;
        if (a < b) {
            f = 180 - f;
        }
        if (a > b) {
            f = 360 + f;
        }
        if (f == 360) {
            f = 0;
        }
        return GeometryUtil.g(f);
    }
    static ge(a) {
        let b = new Array(a.count);
        for (let c = 0; c < a.count; c++) {
            let d = a._inner[c];
            let e = d.ah;
            let f = GeometryUtil.k(e.b7, d.ai, e.a2);
            b[c] = f.y;
        }
        for (let g = 0; g < a.count; g++) {
            for (let h = g + 1; h < a.count; h++) {
                if (b[g] >= b[h]) {
                    let i = a._inner[g];
                    a._inner[g] = a._inner[h];
                    a._inner[h] = i;
                    let j = b[g];
                    b[g] = b[h];
                    b[h] = j;
                }
            }
        }
    }
    f6(a) {
        if (a.count == 0) {
            return;
        }
        let b = this.a0.b2.width;
        let c = this.a0.b2.height;
        let d = a.count;
        let e = a._inner[0].ah.a2;
        let f = a._inner[0].ah.b6();
        let g = true;
        let h = 0;
        let i = Number.POSITIVE_INFINITY;
        let j = Number.NEGATIVE_INFINITY;
        for (let k = 0; k < d - 1; k++) {
            let l = a._inner[k];
            let m = a._inner[k + 1];
            if (l.ao.intersectsWith(m.ao)) {
                h++;
            }
        }
        let n = 0;
        for (let o of fromEnum(a)) {
            i = Math.min(i, o.ao.height);
            j = Math.max(j, o.ao.height);
            n += o.ao.height;
        }
        if (n > c) {
            g = false;
        }
        if (g && h > 0) {
            for (let p = 0; p < d - 1; p++) {
                for (let q = p + 1; q < d; q++) {
                    let r = a._inner[p];
                    let s = a._inner[q];
                    if (r.ao.intersectsWith(s.ao)) {
                        let t = s.ao;
                        t.y = Math.min(r.ao.bottom + 0.01, c - i);
                        let u = this.cw + e;
                        let v = Math.abs(f.y - (t.y + i / 2));
                        let w = Math.sqrt(Math.abs(u * u - v * v));
                        let x = GeometryUtil.g(s.ai);
                        if (x > 90 && x < 270) {
                            w = (t.width + w) * -1;
                        }
                        t.x = f.x + w;
                        s.ao = t;
                    }
                }
            }
            for (let y = d - 1; y > 0; y--) {
                for (let z = y - 1; z >= 0; z--) {
                    let aa = a._inner[y];
                    let ab = a._inner[z];
                    if (aa.ao.intersectsWith(ab.ao)) {
                        let ac = ab.ao;
                        ac.y = Math.max(aa.ao.top - i - 0.01, 0);
                        let ad = this.cw + e;
                        let ae = Math.abs(f.y - (ac.y + i / 2));
                        let af = Math.sqrt(Math.abs(ad * ad - ae * ae));
                        let ag = GeometryUtil.g(ab.ai);
                        if (ag > 90 && ag < 270) {
                            af = (ac.width + af) * -1;
                        }
                        ac.x = f.x + af;
                        ab.ao = ac;
                    }
                }
            }
        }
        for (let ah of fromEnum(a)) {
            let ai = ah.ao;
            if (ai.left > b || ai.right < 0) {
                ah._visibility = 1;
                if (this.ax == 0) {
                    ah.ap._visibility = 1;
                }
                else {
                    ah.aq._visibility = 1;
                }
            }
            else if (ai.left < 0) {
                let aj = Math.abs(ai.x);
                ai.x = 0;
                if (aj > ai.width) {
                    ai.width = 0;
                }
                else {
                }
                ah.ao = ai;
            }
            else if (ai.right > b) {
                let ak = ai.right - b;
                if (ak > ai.width) {
                    ai.width = 0;
                }
                else {
                    ai.width = ai.width - ak;
                }
                ah.ao = ai;
            }
        }
    }
    e6(a, b, c, d) {
        this.f2();
    }
    f2() {
        this.fv();
        this.fx();
        this.fw();
        this.f5();
        this.f3();
        this.f4();
        this.a0.br();
    }
    fv() {
        this.c4 = 0;
        this.cz = 0;
        this.cc.clear();
        this.cb.clear();
        this.ca.clear();
        if (this.itemsSource == null || this.bd == null) {
            return;
        }
        if (this.bm == null || this.bm.count == 0) {
            return;
        }
        for (let a of fromEnum(this.bm)) {
            if (isNaN_(a) || isInfinity(a) || a <= 0) {
                continue;
            }
            this.c4 = this.c4 + a;
        }
        for (let b = 0; b < this.bm.count; b++) {
            let c = this.bm.item(b);
            let d = c <= 0;
            if (isNaN_(c) || isInfinity(c) || d) {
                continue;
            }
            let e = this.ay == 1 ? c / this.c4 : c;
            let f = this.ay == 1 ? this.cy / 100 : this.cy;
            let g = true;
            if (e <= f && g) {
                this.cz = this.cz + c;
                this.cb.add(b);
                this.ca.add1(this.bd.item(b));
            }
            else {
                this.cc.add(b);
            }
        }
    }
    fx() {
        if (this.itemsSource == null || this.bd == null) {
            this.bo.count = 0;
            return;
        }
        let a = this.cc.count;
        let b = this.cb.count > 0;
        let c = PieChartBase.c2(this.cp);
        let d = PieChartBase.c2(this.cp);
        if (b) {
            a++;
        }
        this.c7 = a;
        for (let e = 0; e < a; e++) {
            let f = false;
            let g;
            if (e == a - 1 && b) {
                g = this.cz;
                f = true;
            }
            else {
                g = this.bm.item(this.cc._inner[e]);
            }
            if (this.hv == 1) {
                d += PieChartBase.c2(Math.abs(g) * 360 / this.c4);
            }
            else {
                d -= PieChartBase.c2(Math.abs(g) * 360 / this.c4);
            }
            let h = this.bo.item(e);
            h.aw = true;
            h.a3 = c;
            h.ax = d;
            h.a1 = h.a0 = this.cm;
            h.isOthersSlice = f;
            h.ay = this.cl;
            h.a5 = e;
            h.dataContext = f ? this.ca : this.bd.item(this.cc._inner[e]);
            this.a3.j(h);
            h.isExploded = this.bs ? this.explodedSlices.contains(e) : false;
            c = d;
            h.aw = false;
        }
        this.bo.count = a;
    }
    et() {
        let a = this.XSRP.b7;
        if (stringIsNullOrWhiteSpace(a)) {
            a = "Others";
        }
        return this.ej != null ? this.ej : a;
    }
    fw() {
        if (this.itemsSource == null || this.bd == null) {
            this.bn.count = 0;
            return;
        }
        if (this.bi == null || this.bi.count == 0 || this.aw == 0) {
            this.bn.count = 0;
        }
        let a = this.cc.count;
        if (this.cb.count > 0) {
            a++;
        }
        this.a0.au();
        let b = 0;
        for (let c = 0; c < a; c++) {
            let d = stringEmpty();
            let e = false;
            let f;
            let g = null;
            if (c == a - 1 && this.cb.count > 0) {
                f = this.et();
                e = true;
                if (this.b2() || this.am != null || this.ap != null) {
                    let h = ((() => {
                        let $ret = new PieSliceDataContext();
                        $ret.series = this;
                        $ret.item = e ? this.ca : this.bd.item(this.cc._inner[c]);
                        $ret.percentValue = this.cu(this.bo.item(c));
                        $ret.isOthersSlice = e;
                        return $ret;
                    })());
                    if (f != null) {
                        h.itemLabel = f.toString();
                        h.legendLabel = f.toString();
                    }
                    let i = h;
                    i = i.flatten();
                    if (this.am != null && !e) {
                        f = this.am.i(i);
                    }
                    else if (this.ap != null && e) {
                        f = this.ap.i(i);
                    }
                    else if (this.b2()) {
                        f = this.a1(i);
                    }
                }
                if (null != f) {
                    d = f.toString();
                }
                else {
                    d = this.et();
                }
            }
            else {
                if (this.bi != null && this.bi.count >= this.cc.count) {
                    f = this.bi.item(this.cc._inner[c]);
                }
                else {
                    f = null;
                }
                g = (this.bj != null && this.bj.count > 0) ? this.bj.item(this.cc._inner[c]) : null;
                if (this.b2() || this.am != null || this.ap != null) {
                    let j = ((() => {
                        let $ret = new PieSliceDataContext();
                        $ret.series = this;
                        $ret.item = e ? this.ca : this.bd.item(this.cc._inner[c]);
                        $ret.itemLabel = f != null ? f.toString() : null;
                        $ret.legendLabel = g != null ? g.toString() : f != null ? f.toString() : null;
                        $ret.percentValue = this.cu(this.bo.item(c));
                        $ret.isOthersSlice = e;
                        return $ret;
                    })());
                    let k = j;
                    k = k.flatten();
                    let formattedLabel_ = null;
                    if ((this.am != null && !e) || (this.ap != null && e)) {
                        if (e) {
                            formattedLabel_ = this.ap.i(k);
                        }
                        else {
                            formattedLabel_ = this.am.i(k);
                        }
                    }
                    else {
                        formattedLabel_ = this.a1(k);
                    }
                    if (null == formattedLabel_ && this.bi != null && this.bi.count > 0) {
                        f = this.bi.item(this.cc._inner[c]);
                    }
                    else {
                        f = formattedLabel_;
                    }
                }
                let label_ = f;
                let errorMsg_ = this.dn;
                if (label_ === undefined) {
                    throw new Error(errorMsg_);
                }
                ;
                if (null != f) {
                    d = f.toString();
                }
                else {
                    d = null;
                }
            }
            if (this.bi != null && this.bi.count > 0) {
                let l = this.bn.item(c);
                let m = this.bo.item(c);
                m.aj = l;
                l.ai = GeometryUtil.g((m.a3 + m.ax) / 2);
                l.ah = m;
                l.aj = ((() => {
                    let $ret = new TextBlock();
                    $ret.ak = d;
                    return $ret;
                })());
                if (this.gi == null) {
                    l.dataContext = e ? this.ca : this.bd.item(this.cc._inner[c]);
                    l.ak(this.a0);
                }
                else {
                }
                l._visibility = 0;
                l.ao = this.a0.b1(l);
                b++;
            }
            if (this.bj != null && this.bj.count > 0) {
                let n = this.bo.item(c);
                n.bf = g != null ? g.toString() : null;
            }
        }
        this.bn.count = b;
    }
    f5() {
        if (this.itemsSource == null || this.bd == null) {
            return;
        }
        let a = this.a0.b3();
        this.h1 = new Rect(0, 0, 0, a.width, a.height);
        let b = this.a0.aa();
        let c = this.a0.z(this.h4);
        b = isNaN_(b) ? 0 : b / 2;
        c = isNaN_(c) ? 0 : c / 2;
        b = Math.max(c, b);
        let d = Math.min(a.width / 2, a.height / 2);
        let e = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        let f = d * this.co;
        let g = f + b;
        if (g > d) {
            let h = g - d;
            f = f - h;
        }
        for (let i of fromEnum(this.bo.a)) {
            let j = GeometryUtil.j(a.width, a.height, true, (i.a3 + i.ax) / 2, f * this.cl);
            i.aw = true;
            i.a1 = i.a0 = this.cm;
            i.a2 = f;
            i.ay = this.cl;
            i.b7 = e;
            i.b5 = j;
            this.f9(i);
            i.aw = false;
        }
        this.a0.br();
    }
    f3() {
        let a = this.a0.b2.width;
        let b = this.a0.b2.height;
        if (b == 0 || a == 0) {
            return;
        }
        if (this.bn.a.count == 0 || this.aw == 0) {
            this.bn.count = 0;
            return;
        }
        let c = new List$1(PieLabel.$, 0);
        let d = new List$1(PieLabel.$, 0);
        let e = new List$1(PieLabel.$, 0);
        let f = new List$1(PieLabel.$, 0);
        for (let g of fromEnum(this.bn.a)) {
            let h = g.ah;
            if (h == null) {
                continue;
            }
            let i = h.b6();
            let j = g.ao.width;
            let k = g.ao.height;
            if (this.aw == 1 || this.aw == 4) {
                let l = h.a2 * h.a1 / 100;
                let m = GeometryUtil.k(i, g.ai, h.a2 - (h.a2 - l) / 2);
                g.ao = new Rect(0, m.x - j / 2, m.y - k / 2, j, k);
                let n = this.b1(g, m);
                if (n || this.aw == 1) {
                    if (this.ht == null) {
                        h.f(Slice.bp);
                    }
                    else {
                        h.b2 = this.ht;
                    }
                    h.au = true;
                    e.add(g);
                    g.ag = 1;
                    if (g.ah.ai.ax == 0) {
                        g.ap._visibility = 1;
                    }
                    else {
                        g.aq._visibility = 1;
                    }
                    if (!n && this.aw == 1) {
                        g._visibility = 1;
                    }
                    else {
                        g._visibility = 0;
                    }
                    continue;
                }
            }
            if (this.aw == 2 || this.aw == 4) {
                let o = PieChartBase.cs(i, h.a2, g);
                let p = GeometryUtil.k(i, g.ai, o);
                g.ao = new Rect(0, p.x - j / 2, p.y - k / 2, j, k);
                let q = this.b1(g, p);
                if (q || this.aw == 2) {
                    if (this.ht == null) {
                        h.f(Slice.bp);
                    }
                    else {
                        h.b2 = this.ht;
                    }
                    h.au = true;
                    f.add(g);
                    g.ag = 2;
                    if (g.ah.ai.ax == 0) {
                        g.ap._visibility = 1;
                    }
                    else {
                        g.aq._visibility = 1;
                    }
                    if (!q && this.aw == 2) {
                        g._visibility = 1;
                    }
                    else {
                        g._visibility = 0;
                    }
                    continue;
                }
            }
            if (this.hu == null) {
                h.f(Slice.bp);
            }
            else {
                h.b2 = this.hu;
            }
            h.au = false;
            let r = GeometryUtil.k(i, g.ai, h.a2 + this.cw);
            g.ag = 3;
            g._visibility = 0;
            g.al();
            if (g.ai < 90 && g.ai >= 0) {
                g.ao = new Rect(0, r.x, r.y, j, k);
                c.add(g);
            }
            else if (g.ai < 180 && g.ai >= 90) {
                g.ao = new Rect(0, r.x - j, r.y, j, k);
                d.add(g);
            }
            else if (g.ai < 270 && g.ai >= 180) {
                g.ao = new Rect(0, r.x - j, r.y - k, j, k);
                d.add(g);
            }
            else {
                g.ao = new Rect(0, r.x, r.y - k, j, k);
                c.add(g);
            }
            if (g.ao.y < 0) {
                g.ao = new Rect(0, g.ao.x, 0, g.ao.width, g.ao.height);
            }
            if (g.ao.bottom > b) {
                g.ao = new Rect(0, g.ao.x, b - g.ao.height, g.ao.width, g.ao.height);
            }
        }
        PieChartBase.ge(c);
        this.f6(c);
        PieChartBase.ge(d);
        this.f6(d);
        for (let s of fromEnum(e)) {
            this.a0.bm(s, s.ao.x, s.ao.y);
        }
        for (let t of fromEnum(f)) {
            this.a0.bm(t, t.ao.x, t.ao.y);
        }
        for (let u of fromEnum(c)) {
            this.a0.bm(u, u.ao.x, u.ao.y);
            if (u.ah.ai.ax == 0) {
                u.am();
            }
            else {
                u.an();
            }
        }
        for (let v of fromEnum(d)) {
            this.a0.bm(v, v.ao.x, v.ao.y);
            if (v.ah.ai.ax == 0) {
                v.am();
            }
            else {
                v.an();
            }
        }
        this.a0.br();
    }
    static cs(a, b, c) {
        let d = c.ai * Math.PI / 180;
        let e = 1;
        let f = GeometryUtil.k({ $type: Point_$type, x: 0, y: 0 }, c.ai, e);
        let g = PieChartBase.hx(c);
        let h = Math.sqrt(g.x * g.x + g.y * g.y);
        let i = { $type: Point_$type, x: g.x / h, y: g.y / h };
        let j = PieChartBase.ct(f, i);
        let k = h / b;
        let l = j * k;
        let m = l;
        let n = GeometryUtil.e({ $type: Point_$type, x: 0, y: 0 }, f);
        let o = GeometryUtil.e({ $type: Point_$type, x: 0, y: 0 }, i);
        if (o < n) {
            m = -m;
        }
        let p = GeometryUtil.k(a, (d + m) * 180 / Math.PI, b);
        let q = PieChartBase.hw(c, p);
        let r = Math.sqrt((q.x - a.x) * (q.x - a.x) + (q.y - a.y) * (q.y - a.y));
        let s = r - 5;
        return s;
    }
    static hw(a, b) {
        let c = GeometryUtil.g(a.ai);
        let d = a.ao.width / 2;
        let e = a.ao.height / 2;
        if (c >= 0 && c <= 90) {
            return { $type: Point_$type, x: b.x - d, y: b.y - e };
        }
        if (c >= 90 && c <= 180) {
            return { $type: Point_$type, x: b.x + d, y: b.y - e };
        }
        if (c >= 180 && c <= 270) {
            return { $type: Point_$type, x: b.x + d, y: b.y + e };
        }
        return { $type: Point_$type, x: b.x - d, y: b.y + e };
    }
    static ct(a, b) {
        let c = a.x * b.x + a.y * b.y;
        let d = Math.sqrt(a.x * a.x + a.y * a.y);
        let e = Math.sqrt(b.x * b.x + b.y * b.y);
        let f = Math.acos(c / (d * e));
        return f;
    }
    static hx(a) {
        let b = GeometryUtil.g(a.ai);
        let c = a.ao.width / 2;
        let d = a.ao.height / 2;
        if (b >= 0 && b <= 90) {
            return { $type: Point_$type, x: c, y: d };
        }
        if (b >= 90 && b <= 180) {
            return { $type: Point_$type, x: -c, y: d };
        }
        if (b >= 180 && b <= 270) {
            return { $type: Point_$type, x: -c, y: -d };
        }
        return { $type: Point_$type, x: c, y: -d };
    }
    f4() {
        if (this.legend == null || !this.legend.isItemwise) {
            return;
        }
        if ((this.bi == null || this.bi.count == 0) && (this.bj == null || this.bj.count == 0)) {
            this.legend.clearLegendItemsForSeries(this);
            return;
        }
        this.b9 = new List$1(UIElement.$, 0);
        for (let a of fromEnum(this.bo.a)) {
            let b = new ContentControl();
            let c = this.c8(a);
            let d = this.a0.bt(a);
            let e = this.a0.bu(a);
            b.content = ((() => {
                let $ret = new PieSliceDataContext();
                $ret.series = this;
                $ret.slice = a;
                $ret.item = a.dataContext;
                $ret.itemBrush = d;
                $ret.outline = e;
                $ret.thickness = a.a4;
                $ret.itemLabel = c != null ? c.toString() : null;
                $ret.legendLabel = a.isOthersSlice ? this.et() : a.bf != null ? a.bf : (c != null ? c.toString() : null);
                $ret.percentValue = this.cu(a);
                $ret.isOthersSlice = a.isOthersSlice;
                return $ret;
            })());
            let f = b.content;
            if (this.b3() || this.an != null || this.ao != null) {
                let g = null;
                if (this.b3()) {
                    g = this.a2(b.content);
                }
                if (this.an != null && !f.isOthersSlice) {
                    g = this.an.i(b.content);
                }
                if (this.ao != null && f.isOthersSlice) {
                    g = this.ao.i(b.content);
                }
                if (g != null) {
                    f.legendLabel = g.toString();
                }
            }
            if (this.legendItemTemplate != null) {
                b.ah = this.legendItemTemplate;
            }
            this.b9.add(b);
        }
        if (this.legend.isItemwise) {
            let h = this.legend;
            h.createItemwiseLegendItems(this.b9, this);
        }
    }
    bc() {
        let a = new PieChartVisualData();
        a.viewport = RectData.b(this.h1);
        this.a0.an(a);
        for (let b = 0; b < this.bo.count; b++) {
            let c = this.bo.item(b).am();
            a.slices.add(c);
            if (this.bo.item(b).isOthersSlice) {
                a.othersSlice = this.bo.item(b).am();
            }
        }
        a.others = this.ca;
        a.name = this.name;
        a.radiusFactor = this.co;
        a.leaderLineMargin = this.cx;
        return a;
    }
    di() {
        let a = this.bc();
        a.scaleByViewport();
        return a.serialize();
    }
    bk(a) {
        let b = null;
        return this.bd.registerColumn(a, b, false);
    }
    bl(a) {
        let b = null;
        return this.bd.registerColumnObject(a, b, false);
    }
    fy(a, b, c, d) {
        switch (b) {
            case PieChartBase.$$p[8]:
                this.bd = ((() => {
                    let $ret = new FastItemsSource();
                    $ret.e = d;
                    return $ret;
                })());
                break;
            case PieChartBase.$$p[10]:
            case PieChartBase.$$p[11]:
                if (this.dt != null) {
                    this.am = new BindingFormatter();
                    this.am.j = this.dt;
                    this.am.d = this.ag;
                }
                else {
                    this.am = null;
                }
                break;
            case PieChartBase.$$p[32]:
            case PieChartBase.$$p[33]:
                if (this.en != null) {
                    this.ap = new BindingFormatter();
                    this.ap.j = this.en;
                    this.ap.d = this.aj;
                }
                else {
                    this.ap = null;
                }
                break;
            case PieChartBase.$$p[22]:
            case PieChartBase.$$p[23]:
                if (this.d9 != null) {
                    this.an = new BindingFormatter();
                    this.an.j = this.d9;
                    this.an.d = this.ah;
                }
                else {
                    this.an = null;
                }
                break;
            case PieChartBase.$$p[25]:
            case PieChartBase.$$p[26]:
                if (this.ee != null) {
                    this.ao = new BindingFormatter();
                    this.ao.j = this.ee;
                    this.ao.d = this.ai;
                }
                else {
                    this.ao = null;
                }
                break;
            case PieChartBase.$$p[4]:
                if (typeCast(FastItemsSource.$, c) != null) {
                    let e = c;
                    e.event = delegateRemove(e.event, this.c5);
                    this.bt = false;
                    c.deregisterColumn(this.bm);
                    c.deregisterColumn(this.bi);
                    this.bm = null;
                    this.bi = null;
                    this.selectedItem = null;
                    this.selectedItems.clear();
                    if (this.selectedSlices != null) {
                        this.selectedSlices.clear();
                    }
                    (typeCast(FastItemsSource.$, c)).deregisterColumn(this.bj);
                    this.bj = null;
                }
                if (typeCast(FastItemsSource.$, d) != null) {
                    let f = d;
                    f.event = delegateCombine(f.event, this.c5);
                    this.bt = true;
                    this.bm = this.bk(this.e4);
                    this.bi = this.bl(this.dx);
                    this.bj = this.bl(this.ec);
                    this.fx();
                    if (this.selectedItem != null || this.selectedItems.count > 0) {
                        this.gg();
                    }
                    else if (this.selectedSlices != null && this.selectedSlices.count > 0) {
                        this.gh();
                    }
                }
                this.f2();
                break;
            case PieChartBase.$$p[42]:
                if (this.bd != null) {
                    this.bd.deregisterColumn(this.bm);
                    this.bm = this.bk(this.e4);
                }
                break;
            case PieChartBase.$$p[24]:
                if (this.bd != null) {
                    this.bd.deregisterColumn(this.bj);
                    this.bj = this.bl(this.ec);
                    this.fw();
                    this.f3();
                    this.f4();
                }
                break;
            case PieChartBase.$$p[6]:
                this.f4();
                break;
            case PieChartBase.$$p[5]:
            case PieChartBase.$$p[13]:
                if (this.bd != null) {
                    this.bd.deregisterColumn(this.bi);
                    this.bi = this.bl(this.dx);
                    this.fw();
                    this.f3();
                    this.f4();
                }
                break;
            case PieChartBase.$$p[38]:
                this.cp = d;
                this.fx();
                this.fw();
                this.f5();
                this.f3();
                break;
            case PieChartBase.$$p[40]:
                this.a0.bp(this.da);
                break;
            case PieChartBase.$$p[27]:
                let g = typeCast(IChartLegend_$type, c);
                if (g != null) {
                    g.clearLegendItemsForSeries(this);
                }
                this.f4();
                break;
            case PieChartBase.$$p[20]:
            case PieChartBase.$$p[21]:
                this.f4();
                break;
            case PieChartBase.$$p[35]:
            case PieChartBase.$$p[3]:
            case PieChartBase.$$p[39]:
                this.fx();
                this.fw();
                this.f5();
                this.f3();
                break;
            case PieChartBase.$$p[28]:
            case PieChartBase.$$p[36]:
                this.f5();
                this.f4();
                break;
            case PieChartBase.$$p[2]:
                if (c != null) {
                    let h = c;
                    h.collectionChanged = delegateRemove(h.collectionChanged, this.cf);
                    this.br = false;
                }
                if (d != null) {
                    let i = d;
                    i.collectionChanged = delegateCombine(i.collectionChanged, this.cf);
                    this.br = true;
                }
                this.f5();
                this.f4();
                break;
            case PieChartBase.$$p[34]:
                if (c != null) {
                    let j = c;
                    j.collectionChanged = delegateRemove(j.collectionChanged, this.cf);
                    this.bu = false;
                }
                if (d != null) {
                    let k = d;
                    k.collectionChanged = delegateCombine(k.collectionChanged, this.cf);
                    this.bu = true;
                }
                this.f5();
                this.f4();
                break;
            case "ValueColumn":
            case PieChartBase.$$p[30]:
            case PieChartBase.$$p[31]:
                this.f2();
                this.gg();
                this.gh();
                break;
            case PieChartBase.$$p[0]:
            case PieChartBase.$$p[1]:
                this.f2();
                break;
            case PieChartBase.$$p[15]:
                this.fw();
                this.f3();
                this.a0.br();
                break;
            case PieChartBase.$$p[12]:
            case PieChartBase.$$p[14]:
            case PieChartBase.$$p[9]:
                this.fw();
                this.f3();
                break;
            case PieChartBase.$$p[29]:
                this.fw();
                this.f3();
                this.f4();
                break;
            case PieChartBase.$$p[19]:
                this.f3();
                break;
            case PieChartBase.$$p[17]:
                this.f3();
                break;
            case "TextStyle":
                this.a0.bh();
                break;
            case "PixelScalingRatio":
                if (isNaN_(DeviceUtils.a(this.c0))) {
                    this.cn = 1;
                }
                else {
                    this.cn = DeviceUtils.a(this.c0);
                }
                break;
            case "ActualPixelScalingRatio":
                this.a0.a3();
                break;
            case "LabelTemplate":
                this.fw();
                this.f3();
                break;
            case PieChartBase.$$p[18]:
            case PieChartBase.$$p[16]:
                this.bn.c(runOn(this.a0, this.a0.bl));
                this.f3();
                break;
            case PieChartBase.$$p[7]:
                this.a0.a2();
                break;
            case "InnerExtent":
                this.f2();
                break;
            case "SelectedItem":
                if (!this.bx) {
                    this.fx();
                    this.f5();
                    this.f4();
                }
                break;
            case PieChartBase.$$p[37]:
                if (EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 1 && this.selectedItems != null && this.selectedItems.count > 1) {
                    this.selectedItems.clear();
                }
                else if (EnumUtil.getEnumValue(SliceSelectionMode_$type, d) == 2 && this.selectedItem != null && this.selectedItems != null) {
                    if (!this.selectedItems.contains1(this.selectedItem)) {
                        if (typeCast(PieSliceOthersContext.$, this.selectedItem) !== null) {
                            let l = typeCast(PieSliceOthersContext.$, this.selectedItem);
                            for (let m of fromEn(l.data)) {
                                this.selectedItems.add1(m);
                            }
                        }
                        else {
                            this.selectedItems.add1(this.selectedItem);
                        }
                        this.gh();
                    }
                }
                this.gg();
                this.fx();
                this.f5();
                break;
        }
    }
    f7(a) {
        if (this.by) {
            return;
        }
        this.gh();
        if (this.b0) {
            this.fx();
            this.f5();
            this.f4();
        }
    }
    fq(a) {
        if (a.action == 4 && a.newItems == null && a.oldItems == null) {
            return;
        }
        if (this.bx) {
            return;
        }
        this.gg();
        if (this.b0) {
            this.fx();
            this.f5();
            this.f4();
        }
        let b = new ObjectCollection(0);
        if (a.oldItems != null) {
            for (let c = 0; c < a.oldItems.count; c++) {
                b.add1(a.oldItems.item(c));
            }
        }
        let d = new ObjectCollection(0);
        if (a.newItems != null) {
            for (let e = 0; e < a.newItems.count; e++) {
                d.add1(a.newItems.item(e));
            }
        }
        let f = this.selectedItems;
        this.fp(this, new SelectedItemsChangedEventArgs(b, d, f));
    }
    f0(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    gh() {
        if (this.itemsSource == null || this.bo.a.count == 0) {
            return;
        }
        this.bx = true;
        let a = this.selectedSlices.count;
        if (a == 0) {
            if (this.selectedItems.count > 0) {
                this.selectedItems.clear();
            }
            if (this.selectedItem != null) {
                this.selectedItem = null;
            }
        }
        if (this.bb == 1) {
            if (a != 0) {
                let b = this.bo.a._inner[this.selectedSlices._inner[a - 1]];
                if (b.isOthersSlice) {
                    this.selectedItem = ((() => {
                        let $ret = new PieSliceOthersContext();
                        $ret.data = typeCast(IList_$type, b.dataContext);
                        $ret.slice = b;
                        return $ret;
                    })());
                }
                else {
                    this.selectedItem = b.dataContext;
                }
            }
        }
        else if (this.bb == 2) {
            if (a != 0) {
                this.selectedItems.clear();
                for (let c of fromEnum(this.selectedSlices)) {
                    let d = this.bo.a._inner[c];
                    if (d.isOthersSlice) {
                        let e = typeCast(IEnumerable_$type, d.dataContext);
                        for (let f of fromEn(e)) {
                            this.a3.e(f);
                        }
                    }
                    else {
                        this.a3.e(d.dataContext);
                    }
                }
                this.selectedItem = this.bo.a._inner[this.selectedSlices._inner[a - 1]].dataContext;
            }
        }
        this.bx = false;
    }
    gg() {
        if (this.itemsSource == null || this.bo.a.count == 0) {
            return;
        }
        this.by = true;
        this.selectedSlices.clear();
        for (let a of fromEnum(this.bo.a)) {
            if (this.a3.d(a)) {
                this.selectedSlices.add(a.a5);
            }
        }
        this.by = false;
    }
    gc(a, b) {
        this.gd(a, b, false);
    }
    gd(a, b, c) {
        if (this.b0) {
            if (this.bb == 1) {
                this.a3.k(a);
            }
            else if (this.bb == 2) {
                this.a3.i(a);
            }
        }
        let d = new SliceClickEventArgs(a, this.a0.ae(b));
        this.ft(this, d);
        if (!c) {
            this.a0.bn(a, b);
        }
    }
    gb(a) {
        this.a0.ak(a);
    }
    b6(a, b) {
        let c = new LabelClickEventArgs(a, this.a0.ae(b));
        this.fm(this, c);
        return c.allowSliceClick;
    }
    fa(a, b) {
        this.a0.bn(a, b);
    }
    fd(a, b, c) {
        this.a0.bn(a, b);
    }
    fc(a, b) {
        this.fd(a, b, false);
    }
    fb(a, b) {
        this.a0.al();
    }
    fs() {
        this.f2();
    }
    provideContainer(a) {
        this.a0.ay(a);
    }
    fk(a, b) {
        this.a0.az(a, b);
    }
    notifyContainerResized() {
        this.a0.aw();
    }
    hz() {
        return this.a0.b0();
    }
    hy() {
        return this.a0.bx();
    }
    destroy() {
        this.f1();
        this.a0.ay(null);
    }
    e9() {
        this.a0.ao();
    }
    get ez() {
        return this.db;
    }
    set ez(a) {
        let b = this.db;
        this.db = a;
        this.f0("TextStyle", b, a);
    }
    get container() {
        return this;
    }
    get isStacked() {
        return false;
    }
    get isVertical() {
        return false;
    }
    get hasMarkers() {
        return false;
    }
    get isUsableInLegend() {
        return true;
    }
    get hasSubItems() {
        return false;
    }
    cu(a) {
        if (a == null || this.bm == null || this.cc == null) {
            return NaN;
        }
        if (a.isOthersSlice) {
            return this.cz / this.c4 * 100;
        }
        else {
            return this.bm.item(this.cc._inner[a.a5]) / this.c4 * 100;
        }
    }
    fi(source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.b7(source_)) {
            return;
        }
        let d = this.bd;
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    fe(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.b7(source_)) {
            return;
        }
        let a = this.bd;
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    }
    b7(a) {
        return PieChartBase.b8(a, this.itemsSource);
    }
    static b8(a, b) {
        return a == b;
    }
    fg(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.b7(source_)) {
            return;
        }
        let c = this.bd;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    fh(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.b7(source_)) {
            return;
        }
        let c = this.bd;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    ga(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        this.itemsSource = source_;
    }
    f1() {
        this.itemsSource = null;
    }
    gf() {
        this.a0.bh();
    }
    be() {
        return FontUtil.toFontInfo(this.a0.c.n, this.ez);
    }
    resolveLegendIndex() {
        return -1;
    }
    forSubItems(a) {
    }
}
PieChartBase.$t = markType(PieChartBase, 'PieChartBase', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type, ILegendSeries_$type, ILegendTemplateProvider_$type]);
PieChartBase.gq = DependencyProperty.i("InnerExtent", Number_$type, PieChartBase.$, new PropertyMetadata(2, 0, (a, b) => a.f0("InnerExtent", b.oldValue, b.newValue)));
PieChartBase.g0 = DependencyProperty.i("LabelTemplate", DataTemplate.$, PieChartBase.$, new PropertyMetadata(2, null, (a, b) => a.f0("LabelTemplate", b.oldValue, b.newValue)));
PieChartBase.hl = DependencyProperty.i("SelectedItem", Base.$, PieChartBase.$, new PropertyMetadata(1, (a, b) => {
    let c = typeCast(PieChartBase.$, a);
    if (c.bw) {
        return;
    }
    let d = new SelectedItemChangingEventArgs(b.oldValue, b.newValue);
    c.fo(c, d);
    if (!d.cancel) {
        if (!c.bx) {
            c.gg();
        }
        c.f0("SelectedItem", b.oldValue, b.newValue);
        c.fn(a, new SelectedItemChangedEventArgs(b.oldValue, b.newValue));
    }
    else {
        c.bw = true;
        c.selectedItem = b.oldValue;
        c.bw = false;
    }
}));
PieChartBase.$$p = markDep(DependencyProperty, PropertyMetadata, PieChartBase, 'f0', ['AllowSliceExplosion:bz:gj', [0, true], 'AllowSliceSelection:b0:gk', [0, true], 'Brushes:ak:gl', [BrushCollection.$, null], 'ExplodedRadius:cq:gm', [1, 0.2], 'FastItemsSource:bd:gn', [FastItemsSource.$], 'FormatLabel:a1:go', [Delegate_$type], 'FormatLegendLabel:a2:gp', [Delegate_$type], 'IsSurfaceInteractionDisabled:b5:gr', [0, false], 'ItemsSource::gs', [IEnumerable_$type, null], 'LabelExtent:cw:gt', [1, 10], 'LabelFormat:dt:gu', [2, null], 'LabelFormatSpecifiers:ag:gv', [Array_$type, null], 'LabelInnerColor:ht:gw', [Brush.$, null], 'LabelMemberPath:dx:gx', [2], 'LabelOuterColor:hu:gy', [Brush.$, null], 'LabelsPosition:aw:gz', [LabelsPosition_$type, enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:cx:g1', [1, 6], 'LeaderLineStyle:h2:g2', [Style.$, null], 'LeaderLineType:ax:g3', [LeaderLineType_$type, enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:h6:g4', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'LegendItemBadgeTemplate::g5', [DataTemplate.$, null], 'LegendItemTemplate::g6', [DataTemplate.$, null], 'LegendLabelFormat:d9:g7', [2, null], 'LegendLabelFormatSpecifiers:ah:g8', [Array_$type, null], 'LegendLabelMemberPath:ec:g9', [2], 'LegendOthersLabelFormat:ee:ha', [2, null], 'LegendOthersLabelFormatSpecifiers:ai:hb', [Array_$type, null], 'Legend::hc', [IChartLegend_$type, null], 'OthersCategoryStyle:h3:hd', [Style.$, null], 'OthersCategoryText:ej:he', [2, null], 'OthersCategoryThreshold:cy:hf', [1, 3], 'OthersCategoryType:ay:hg', [OthersCategoryType_$type, enumGetBox(OthersCategoryType_$type, 1)], 'OthersLabelFormat:en:hh', [2, null], 'OthersLabelFormatSpecifiers:aj:hi', [Array_$type, null], 'Outlines:al:hj', [BrushCollection.$, null], 'RadiusFactor:c1:hk', [1, 0.9], 'SelectedStyle:h4:hm', [Style.$, null], 'SelectionMode:bb:hn', [SliceSelectionMode_$type, enumGetBox(SliceSelectionMode_$type, 1)], 'StartAngle:c3:ho', [1, 0], 'SweepDirection:hv:hp', [SweepDirection_$type, enumGetBox(SweepDirection_$type, 1)], 'ToolTip:da:hq', [4, null], 'ToolTipStyle:h5:hr', [Style.$, null], 'ValueMemberPath:e4:hs', [2, null]]);
/**
 * @hidden
 */
class PieChartSliceSelector extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.a = a;
    }
    d(a) {
        let b = a.dataContext;
        if (this.a.bb == 1) {
            if (a.isOthersSlice) {
                let c = typeCast(IList_$type, b);
                if (c != null && c.contains(this.a.selectedItem)) {
                    return true;
                }
                if (typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                    return true;
                }
            }
            if (b == this.a.selectedItem) {
                return true;
            }
        }
        else if (this.a.bb == 2) {
            if (this.c(a)) {
                return true;
            }
        }
        else if (this.a.bb == 0) {
            if (this.a.selectedSlices.contains(a.a5)) {
                return true;
            }
        }
        return false;
    }
    c(a) {
        let b = a.dataContext;
        if (a.isOthersSlice) {
            for (let c of fromEn(b)) {
                if (this.a.selectedItems.contains1(c)) {
                    return true;
                }
            }
        }
        else {
            if (this.a.selectedItems.contains1(b)) {
                return true;
            }
        }
        return false;
    }
    h(a) {
        let b = a.dataContext;
        if (!a.isOthersSlice) {
            if (this.a.selectedItem != b) {
                return b;
            }
            else {
                return null;
            }
        }
        else {
            if (typeCast(PieSliceOthersContext.$, this.a.selectedItem) !== null) {
                return null;
            }
            else {
                return ((() => {
                    let $ret = new PieSliceOthersContext();
                    $ret.data = typeCast(IList_$type, a.dataContext);
                    $ret.slice = a;
                    return $ret;
                })());
            }
        }
    }
    f(a, b) {
        let c = false;
        if (b) {
            if (this.a.selectedItems.contains1(a)) {
                c = this.g(a);
            }
        }
        else {
            if (!this.a.selectedItems.contains1(a)) {
                c = this.b(a);
            }
            else {
                c = this.g(a);
            }
        }
        return c;
    }
    e(a) {
        return this.f(a, false);
    }
    g(a) {
        let b = new SelectedItemsChangingEventArgs(this.a.selectedItems, new ObjectCollection(0), this.a.selectedItems);
        this.a.fr(this, b);
        if (!b.cancel) {
            this.a.selectedItems.remove1(a);
        }
        return b.cancel;
    }
    b(a) {
        let b = new SelectedItemsChangingEventArgs(this.a.selectedItems, ((() => {
            let $ret = new ObjectCollection(0);
            $ret.add1(a);
            return $ret;
        })()), this.a.selectedItems);
        this.a.fr(this, b);
        if (!b.cancel) {
            this.a.selectedItems.add1(a);
        }
        return b.cancel;
    }
    k(a) {
        this.a.selectedItem = this.h(a);
    }
    i(a) {
        let b = new List$1(Base.$, 1, this.a.selectedItems);
        if (a.isOthersSlice) {
            let c = typeCast(IList_$type, a.dataContext);
            let d = 0;
            for (let e of fromEn(c)) {
                if (this.a.selectedItems.contains1(e)) {
                    d++;
                }
            }
            let f = d > 0 && d < c.count;
            for (let g of fromEn(c)) {
                this.f(g, f);
            }
            if (this.c(a)) {
                this.a.selectedItem = ((() => {
                    let $ret = new PieSliceOthersContext();
                    $ret.data = typeCast(IList_$type, a.dataContext);
                    $ret.slice = a;
                    return $ret;
                })());
            }
            else {
                this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
            }
        }
        else {
            this.e(a.dataContext);
            this.a.selectedItem = this.a.selectedItems.count > 0 ? this.a.selectedItems._inner[this.a.selectedItems.count - 1] : null;
        }
    }
    j(a) {
        if (a != null) {
            a.av = true;
            a.isSelected = this.d(a);
            a.av = false;
        }
    }
}
PieChartSliceSelector.$t = markType(PieChartSliceSelector, 'PieChartSliceSelector');
/**
 * @hidden
 */
class PieSliceOthersContext extends Base {
    constructor() {
        super(...arguments);
        this._data = null;
        this._slice = null;
    }
    get data() {
        return this._data;
    }
    set data(a) {
        this._data = a;
    }
    get slice() {
        return this._slice;
    }
    set slice(a) {
        this._slice = a;
    }
}
PieSliceOthersContext.$t = markType(PieSliceOthersContext, 'PieSliceOthersContext');
/**
 * @hidden
 */
class Slice extends ContentControl {
    constructor() {
        super();
        this.al = null;
        this.b8 = null;
        this.ai = null;
        this.aj = null;
        this.bf = null;
        this.b9 = null;
        this.b3 = null;
        this.aq = false;
        this.au = false;
        this.av = false;
        this.an = false;
        this.b0 = null;
        this.b1 = null;
        let a = this.ak();
        this.bl(a);
        a.b();
        this.av = false;
    }
    ak() {
        return new SliceView(this);
    }
    bl(a) {
        this.al = a;
    }
    get isSelected() {
        return this.c(Slice.bv);
    }
    set isSelected(a) {
        this.h(Slice.bv, a);
    }
    get isExploded() {
        return this.c(Slice.bt);
    }
    set isExploded(a) {
        this.h(Slice.bt, a);
    }
    get isOthersSlice() {
        return this.c(Slice.bu);
    }
    set isOthersSlice(a) {
        this.h(Slice.bu, a);
    }
    get b2() {
        return this.c(Slice.bp);
    }
    set b2(a) {
        this.h(Slice.bp, a);
    }
    ac() {
        super.ac();
        this.al.c();
    }
    az() {
        let a = Math.abs(PieChartBase.c2(this.ax - this.a3)) == 360;
        if (a) {
            return this.a2;
        }
        return this.a2;
    }
    cb() {
        let a = (this.ai != null && this.ai.bz) ? true : false;
        let b = this.az();
        if (this.isExploded && a && this.ai.c7 > 1) {
            let c = new Rect(0, this.b5.x - b, this.b5.y - b, b * 2, b * 2);
            return c;
        }
        return new Rect(0, this.b7.x - b, this.b7.y - b, b * 2, b * 2);
    }
    b6() {
        if (this.isExploded && this.ai != null && this.ai.bz && this.ai.c7 > 1) {
            if (this.aq) {
                return this.b3;
            }
            return this.b5;
        }
        return this.b7;
    }
    get aw() {
        return this.an;
    }
    set aw(a) {
        let b = this.an;
        this.an = a;
        if (b && !this.an) {
            this.bk();
        }
    }
    bk() {
        if (this.aw) {
            return;
        }
        let a = this.al.f();
        let b = this.ai.h1;
        if (isNaN_(this.a3) || isNaN_(this.ax) || isNaN_(this.a2) || isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0) || this.a3 == this.ax) {
            return;
        }
        this.b8 = this.cb();
        let c = GeometryUtil.d(this.b8);
        let d = this.b8.height / 2;
        let e = this.az();
        let f = RectUtil.l(this.b8);
        let g = Slice.b4(MathUtil.k(this.a3), c, f, d, 100);
        let h = Slice.b4(MathUtil.k(this.ax), c, f, d, 100);
        let i = Slice.b4(MathUtil.k(this.ax), c, f, this.a2, this.a0);
        let j = Slice.b4(MathUtil.k(this.a3), c, f, this.a2, this.a1);
        let k = Math.abs(PieChartBase.c2(this.ax - this.a3)) == 360;
        if (k) {
            if (this.a0 == 0) {
                let l = ((() => {
                    let $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = this.a2;
                    $ret.d = this.a2;
                    return $ret;
                })());
                a.ak = l;
                return;
            }
            else if (this.a0 > 0) {
                let m = new Size(1, this.a2, this.a2);
                let n = new Size(1, this.a2 * this.a0 / 100, this.a2 * this.a0 / 100);
                let o = ((() => {
                    let $ret = PointUtil.create();
                    $ret.x = f.x - this.a2;
                    $ret.y = f.y;
                    return $ret;
                })());
                let p = ((() => {
                    let $ret = PointUtil.create();
                    $ret.x = f.x + this.a2;
                    $ret.y = f.y;
                    return $ret;
                })());
                let q = ((() => {
                    let $ret = PointUtil.create();
                    $ret.x = f.x - this.a2 * this.a0 / 100;
                    $ret.y = f.y;
                    return $ret;
                })());
                let r = ((() => {
                    let $ret = PointUtil.create();
                    $ret.x = f.x + this.a2 * this.a0 / 100;
                    $ret.y = f.y;
                    return $ret;
                })());
                let s = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = o;
                    return $ret;
                })());
                let t = new PathSegmentCollection();
                let u = ((() => {
                    let $ret = new ArcSegment();
                    $ret.f = m;
                    $ret.d = 1;
                    $ret.e = p;
                    return $ret;
                })());
                t.add(u);
                s._segments = t;
                let v = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = r;
                    return $ret;
                })());
                let w = new PathSegmentCollection();
                let x = ((() => {
                    let $ret = new ArcSegment();
                    $ret.f = n;
                    $ret.d = 0;
                    $ret.e = q;
                    return $ret;
                })());
                w.add(x);
                v._segments = w;
                let y = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = o;
                    return $ret;
                })());
                let z = new PathSegmentCollection();
                let aa = ((() => {
                    let $ret = new ArcSegment();
                    $ret.f = m;
                    $ret.d = 0;
                    $ret.e = p;
                    return $ret;
                })());
                z.add(aa);
                y._segments = z;
                let ab = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = r;
                    return $ret;
                })());
                let ac = new PathSegmentCollection();
                let ad = ((() => {
                    let $ret = new ArcSegment();
                    $ret.f = n;
                    $ret.d = 1;
                    $ret.e = q;
                    return $ret;
                })());
                ac.add(ad);
                ab._segments = ac;
                let ae = ((() => {
                    let $ret = new PathFigureCollection();
                    $ret.add(s);
                    $ret.add(v);
                    $ret.add(y);
                    $ret.add(ab);
                    return $ret;
                })());
                let af = ((() => {
                    let $ret = new PathGeometry();
                    $ret.c = ae;
                    return $ret;
                })());
                let ag = new GeometryGroup();
                ag.d.add(af);
                a.ak = ag;
                return;
            }
            else {
                let ah = ((() => {
                    let $ret = new GeometryGroup();
                    $ret.c = 0;
                    return $ret;
                })());
                ah.d.add(((() => {
                    let $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = this.a2;
                    $ret.d = this.a2;
                    return $ret;
                })()));
                ah.d.add(((() => {
                    let $ret = new EllipseGeometry();
                    $ret.e = f;
                    $ret.c = this.a2 * this.a0 / 100;
                    $ret.d = this.a2 * this.a0 / 100;
                    return $ret;
                })()));
                a.ak = ah;
                return;
            }
        }
        let ai = new PathGeometry();
        a.ak = ai;
        let aj = ((() => {
            let $ret = new PathFigure();
            $ret.isClosed = true;
            return $ret;
        })());
        ai.c = new PathFigureCollection();
        ai.c.add(aj);
        aj._startPoint = g;
        let ak = Math.abs(this.ax - this.a3) > 180;
        let al = new ArcSegment();
        al.e = h;
        al.f = new Size(1, this.b8.width / 2, this.b8.height / 2);
        al.b = ak;
        if (this.ax > this.a3) {
            al.d = 1;
        }
        else {
            al.d = 0;
        }
        aj._segments = new PathSegmentCollection();
        aj._segments.add(al);
        let am = new LineSegment(1);
        am.c = i;
        aj._segments.add(am);
        let an = Math.sqrt(Math.pow(i.x - h.x, 2) + Math.pow(i.y - h.y, 2));
        let ao = e - an;
        let ap = new ArcSegment();
        ap.e = j;
        if (ao < 0) {
            ao = 0.1;
        }
        ap.f = new Size(1, ao, ao);
        ap.b = al.b;
        ap.d = 0;
        aj._segments.add(ap);
        let aq = this.ca(a, g, h, this.a3, this.ax, f, e);
        let ar = true;
        if (ar && this.b8.height > 0 && this.b8.width > 0 && !b.containsRect(aq)) {
            let as = aq;
            let at = new Rect(0, 0, 0, b.width, b.height);
            at.intersect(as);
            let au = GeometryUtil.g((this.a3 + this.ax) / 2);
            let av = au / 180 * Math.PI;
            let aw = Math.abs((as.height - at.height) / Math.sin(av));
            let ax = Math.abs((as.width - at.width) / Math.cos(av));
            if (isNaN_(aw) || isInfinity(aw)) {
                aw = 0;
            }
            if (isNaN_(ax) || isInfinity(ax)) {
                ax = 0;
            }
            let ay = Math.max(aw, ax);
            let az = GeometryUtil.j(this.ai.h1.width, this.ai.h1.height, true, au, this.a2 * this.ai.cl - ay);
            this.al.d(az.x - this.b5.x, az.y - this.b5.y);
            this.aq = true;
            this.b3 = az;
            this.b9 = new Rect(0, as.x - (az.x - this.b5.x), as.y - (az.y - this.b5.y), as.width, as.height);
        }
        else {
            this.aq = false;
            this.al.e();
        }
    }
    ap(a) {
        let b = this.ai.h1;
        if (this._visibility == 1) {
            return false;
        }
        if (isNaN_(this.a3) || isNaN_(this.ax) || isNaN_(this.a2) || isNaN_(this.ay) || this.a5 < 0 || this.ai == null || b.width == 0 || b.height == 0 || (this.b7.x == 0 && this.b7.y == 0) || (this.b5.x == 0 && this.b5.y == 0)) {
            return false;
        }
        let c = this.az();
        let d = ((this.a0 / 100) * c);
        let e = c;
        let f = this.b7;
        if (this.isExploded && this.ai.bz && this.ai.c7 > 1) {
            f = this.b5;
            if (this.aq) {
                f = this.b3;
            }
        }
        let g = d * d;
        let h = e * e;
        let i = Math.pow(a.x - f.x, 2) + Math.pow(a.y - f.y, 2);
        if (i < g || i > h) {
            return false;
        }
        let j = Math.atan2(a.y - f.y, a.x - f.x);
        j = j * 180 / Math.PI;
        return this.ao(j);
    }
    ao(a) {
        a = GeometryUtil.g(a);
        let b = Math.min(this.a3, this.ax);
        let c = Math.max(this.a3, this.ax);
        return (a > b && a < c) || (a - 360 > b && a - 360 < c) || (a + 360 > b && a + 360 < c);
    }
    ca(a, b, c, d, e, f, g) {
        let h = new List$1(Point_$type, 0);
        h.add(b);
        h.add(c);
        h.add(f);
        d = GeometryUtil.g(d);
        e = GeometryUtil.g(e);
        if ((0 > d && 0 < e) || (360 > d && 360 < e) || (e < d)) {
            h.add(GeometryUtil.k(f, 0, g));
        }
        if (90 > d && 90 < e) {
            h.add(GeometryUtil.k(f, 90, g));
        }
        if (180 > d && 180 < e) {
            h.add(GeometryUtil.k(f, 180, g));
        }
        if (270 > d && 270 < e) {
            h.add(GeometryUtil.k(f, 270, g));
        }
        let i = 1.7976931348623157E+308;
        let j = 1.7976931348623157E+308;
        let k = -1.7976931348623157E+308;
        let l = -1.7976931348623157E+308;
        for (let m of fromEnum(h)) {
            i = Math.min(i, m.x);
            j = Math.min(j, m.y);
            k = Math.max(k, m.x);
            l = Math.max(l, m.y);
        }
        return new Rect(0, i, j, k - i, l - j);
    }
    am() {
        let a = new PieSliceVisualData();
        a.appearance = new PrimitiveAppearanceData();
        a.labelAppearance = new LabelAppearanceData();
        a.leaderLineAppearance = new PrimitiveAppearanceData();
        a.startAngle = this.a3;
        a.endAngle = this.ax;
        a.explodedOrigin = PointData.b(this.b5);
        a.explodedRadius = this.ay;
        a.origin = PointData.b(this.b7);
        a.radius = this.az();
        a.index = this.a5;
        a.innerExtentEnd = this.a0;
        a.innerExtentStart = this.a1;
        a.isExploded = this.isExploded;
        a.isOthersSlice = this.isOthersSlice;
        a.isSelected = this.isSelected;
        if (this.aj != null) {
            a.labelAppearance.angle = this.aj.ai;
            a.labelBounds = RectData.b(this.aj.ao);
            a.labelAngle = this.aj.ai;
            if (typeCast(TextBlock.$, this.aj.aj) !== null) {
                let b = typeCast(TextBlock.$, this.aj.aj);
                a.label = b.ak;
                let c = null;
                a.labelAppearance.labelBrush = AppearanceHelper.b(b.am);
                a.labelAppearance.text = b.ak;
                if (this.ai != null) {
                    c = this.ai.be();
                    if (c == null) {
                        c = this.ai.a0.b.c;
                    }
                }
                a.labelAppearance = AppearanceHelper.c(b, c);
                a.labelAppearance.visibility = this.aj._visibility == 0;
            }
            else {
                a.label = this.aj.aj.toString();
            }
            if (this.aj.ap != null) {
                a.leaderLineAppearance.fill = AppearanceHelper.b(this.aj.ap._fill);
                a.leaderLineAppearance.opacity = this.aj.ap._opacity;
                a.leaderLineAppearance.stroke = AppearanceHelper.b(this.aj.ap._stroke);
                a.leaderLineAppearance.strokeThickness = this.aj.ap.ac;
                a.leaderLineAppearance.isVisible = this.aj.ap._visibility == 0;
                a.leaderLinePath = new PathVisualData(2, "leaderLine", this.aj.ap);
            }
            else if (this.aj.aq != null) {
                a.leaderLineAppearance.fill = AppearanceHelper.b(this.aj.aq._fill);
                a.leaderLineAppearance.opacity = this.aj.aq._opacity;
                a.leaderLineAppearance.stroke = AppearanceHelper.b(this.aj.aq._stroke);
                a.leaderLineAppearance.strokeThickness = this.aj.aq.ac;
                a.leaderLineAppearance.isVisible = this.aj.aq._visibility == 0;
                a.leaderLinePath = new PathVisualData(1, "leaderLine", this.aj.aq);
            }
        }
        if (this.al != null) {
            let d = this.al.f();
            a.slicePath = new PathVisualData(1, "slicePath", d);
            a.appearance.fill = AppearanceHelper.b(d._fill);
            a.appearance.opacity = d._opacity;
            a.appearance.stroke = AppearanceHelper.b(d._stroke);
            a.appearance.strokeThickness = d.ac;
            a.appearance.isVisible = d._visibility == 0;
        }
        return a;
    }
    static b4(a, b, c, d, e) {
        if (d == 0) {
            return c;
        }
        let f = Math.cos(a);
        let g = Math.sin(a);
        let h = Math.sqrt(d * d / (1 - (b * Math.pow(f, 2))));
        h *= (e / 100);
        return { $type: Point_$type, x: h * f + c.x, y: h * g + c.y };
    }
}
Slice.$t = markType(Slice, 'Slice', ContentControl.$);
Slice.bv = DependencyProperty.i("IsSelected", Boolean_$type, Slice.$, new PropertyMetadata(2, false, (a, b) => {
    let c = typeCast(Slice.$, a);
    if (!c.av) {
        let d = b.newValue;
        if (c.ai != null) {
            c.ai.f8(c, d);
        }
    }
}));
Slice.bt = DependencyProperty.i("IsExploded", Boolean_$type, Slice.$, new PropertyMetadata(2, false, (a, b) => {
    let c = typeCast(Slice.$, a);
    let d = b.newValue;
    if (c.ai != null) {
        c.ai.e8(c, d);
    }
}));
Slice.bu = DependencyProperty.i("IsOtherSlice", Boolean_$type, Slice.$, new PropertyMetadata(2, false, (a, b) => a.bk()));
Slice.bp = DependencyProperty.i("Foreground", Brush.$, Slice.$, new PropertyMetadata(1, null));
Slice.$$p = markDep(DependencyProperty, PropertyMetadata, Slice, 'bk', ['EndAngle:ax:bm', [1, 0], 'ExplodedOrigin:b5:bn', [Point_$type, PointUtil.create()], 'ExplodedRadius:ay:bo', [1, 0], 'Index:a5:bq', [1, -1], 'InnerExtentEnd:a0:br', [1, 0], 'InnerExtentStart:a1:bs', [1, 0], 'Origin:b7:bw', [Point_$type, PointUtil.create()], 'Radius:a2:bx', [1, 0], 'StartAngle:a3:by', [1, 0], 'StrokeThickness:a4:bz', [1, 1]]);
/**
 * @hidden
 */
class PieChartBaseView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.bs = null;
        this.b = null;
        this.h = null;
        this.j = null;
        this.i = null;
        this.k = null;
        this.c = null;
        this.b2 = null;
        this.l = false;
        this.bz = Rect.empty;
        this.f = null;
        this.u = null;
        this.t = null;
        this.v = 0;
        this.by = null;
        this.ag = null;
        this.s = false;
        this.e = null;
        this.a = a;
        this.c = new PieChartViewManager(this);
    }
    a1() {
        this.e = new PieSliceDataContext();
        this.e.series = this.a;
        this.b2 = Rect.empty;
        this.u = new List$1(Slice.$, 0);
        this.t = new List$1(PieLabel.$, 0);
        this.a.legendItemTemplate = ((() => {
            let $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.f;
            $ret.measure = PieLegendTemplates.a;
            return $ret;
        })());
        this.a.legendItemBadgeTemplate = ((() => {
            let $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.e;
            $ret.measure = PieLegendTemplates.d;
            return $ret;
        })());
        this.c.z();
    }
    bb() {
        let a = this.c.b();
        if (this.a.ak == null) {
            this.a.ak = a.a;
        }
        if (this.a.al == null) {
            this.a.al = a.b;
        }
        if (this.a.h4 == null) {
            this.a.h4 = ((() => {
                let $ret = new Style();
                $ret.fill = a.h != null ? a.h.color.colorString : null;
                $ret.stroke = a.i != null ? a.i.color.colorString : null;
                $ret.strokeThickness = a.e;
                $ret.opacity = a.d;
                return $ret;
            })());
        }
        this.b = a;
        if (this.a.ez != null) {
            this.b.c = this.a.be();
        }
    }
    ax() {
        this.c.ab();
    }
    a0() {
        this.c.ae();
    }
    ay(a) {
        if (a == null) {
            this.l = false;
            this.c.ac(null);
            this.h = null;
            this.j = null;
            this.i = null;
            this.k = null;
            return;
        }
        this.c.ac(a);
        this.h = this.c.e;
        this.j = this.c.g;
        this.i = this.c.f;
        this.k = this.c.h;
    }
    b0() {
        return this.b2;
    }
    bx() {
        return this.c.an();
    }
    ba() {
        this.b2 = this.c.ao();
        this.a.fs();
    }
    av() {
        if (!this.l) {
            this.l = true;
            this.c.ah(runOn(this, this.bi));
        }
    }
    bi() {
        if (this.l) {
            this.l = false;
            this.a5();
        }
    }
    a5() {
        this.am();
        this.c.w(this.b2.width, this.b2.height);
        let a = this.k == this.j;
        if (this.k != null && this.k.d && !a) {
            if (this.a.cn != 1) {
                this.k.z();
                this.k.aa(this.a.cn, this.a.cn);
            }
            if (!this.bz.isEmpty) {
                this.k.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.i != null && this.i.d && !a) {
            if (this.a.cn != 1) {
                this.i.z();
                this.i.aa(this.a.cn, this.a.cn);
            }
            if (!this.bz.isEmpty) {
                this.i.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.j != null && this.j.d) {
            if (this.a.cn != 1) {
                this.j.z();
                this.j.aa(this.a.cn, this.a.cn);
            }
            if (!this.bz.isEmpty) {
                this.j.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        if (this.h != null && this.h.d && !a) {
            if (this.a.cn != 1) {
                this.h.z();
                this.h.aa(this.a.cn, this.a.cn);
            }
            if (!this.bz.isEmpty) {
                this.h.k(this.bz.left, this.bz.top, this.bz.width, this.bz.height);
            }
        }
        this.a6();
        if (!this.bz.isEmpty && this.a.cn != 1) {
            if (this.k != null && this.k.d && !a) {
                this.k.y();
            }
            if (this.i != null && this.i.d && !a) {
                this.i.y();
            }
            if (this.j != null && this.j.d) {
                this.j.y();
            }
            if (this.h != null && this.h.d && !a) {
                this.h.y();
            }
        }
    }
    a6() {
        this.bz = this.b2;
        if (this.j != null && this.j.d) {
            this.a9();
            this.a7();
        }
        if (this.i != null && this.i.d) {
            let a = this.b.c;
            if (this.a.ez != null) {
                a = this.a.be();
            }
            this.i.ac(a);
            for (let b of fromEnum(this.t)) {
                if (b._visibility == 0) {
                    let c = b.aj;
                    if (c != null) {
                        {
                            if (b.ah.b2 == null) {
                                if (b.ah.au) {
                                    c.am = this.b.f;
                                }
                                else {
                                    c.am = this.b.g;
                                }
                            }
                            else {
                                c.am = b.ah.b2;
                            }
                            this.i.w(c);
                        }
                    }
                    let d = b.ah.b0;
                    if (b.ah.y != null) {
                        let e = new Path();
                        this.j.i(e, b.ah.y);
                        if (e._fill != null) {
                            d = e._fill;
                        }
                    }
                    if (this.a.ax != 0 && b.aq != null) {
                        b.aq._stroke = d;
                        b.aq.ac = 1;
                        if (this.a.h2 != null) {
                            this.i.i(b.aq, this.a.h2);
                        }
                        this.i.s(b.aq);
                    }
                    if (this.a.ax == 0 && b.ap != null) {
                        b.ap._stroke = d;
                        b.ap.ac = 1;
                        if (this.a.h2 != null) {
                            this.i.i(b.ap, this.a.h2);
                        }
                        this.i.r(b.ap);
                    }
                }
            }
        }
    }
    a8(a) {
        if (a._visibility != 0) {
            return;
        }
        let b = a.al.f();
        this.c.ai(b);
        b.ac = 1;
        b._opacity = a._opacity;
        if (a.b0 != null) {
            b._fill = a.b0;
        }
        if (a.b1 != null) {
            b._stroke = a.b1;
        }
        if (a.y != null) {
            this.j.i(b, a.y);
        }
        if (b.j != null) {
            this.j.z();
            this.j.j(b.j);
        }
        let c = b._fill;
        let d = b._stroke;
        let e = this.m(a, b, this.j);
        this.j.s(b);
        if (e) {
            b._fill = c;
            b._stroke = d;
        }
        if (b.j != null) {
            this.j.y();
        }
    }
    a9() {
        for (let a of fromEnum(this.u)) {
            if (!a.isSelected) {
                this.a8(a);
            }
        }
    }
    a7() {
        for (let a of fromEnum(this.u)) {
            if (a.isSelected) {
                this.a8(a);
            }
        }
    }
    m(a, b, c) {
        return false;
    }
    aj(a, b, c) {
        let d = this.f;
        this.bj(a);
        if (this.f == null && d != null) {
            let e = ((() => {
                let $ret = new MouseEventArgs();
                $ret.position = a;
                return $ret;
            })());
            this.a.fb(this.f, e);
        }
        else if (this.f != null) {
            let f = ((() => {
                let $ret = new MouseEventArgs();
                $ret.position = a;
                return $ret;
            })());
            this.a.fc(this.f, f);
        }
    }
    ai(a) {
        let b = this.f;
        this.bj(a);
        let c = ((() => {
            let $ret = new MouseEventArgs();
            $ret.position = a;
            return $ret;
        })());
        this.a.fb(b, c);
    }
    ah(a) {
        this.bj(a);
    }
    ak(a) {
        this.ap(a);
    }
    ap(a) {
        let b = ((() => {
            let $ret = new MouseButtonEventArgs();
            $ret.position = a;
            return $ret;
        })());
        let c = true;
        let d = null;
        for (let e of fromEnum(this.t)) {
            let f = e.ao.containsPoint(a);
            if (f) {
                d = e;
                c = this.a.b6(e.ah, b);
                break;
            }
        }
        this.bj(a);
        if (this.f == null && c && d != null) {
            this.a.gc(d.ah, b);
        }
        else if (this.f != null && c) {
            this.a.gc(this.f, b);
        }
    }
    bj(a) {
        this.f = null;
        for (let b = 0; b < this.u.count; b++) {
            if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                this.f = this.u._inner[b];
                break;
            }
        }
    }
    n(a) {
        for (let b of fromEnum(this.t)) {
            let c = b.ao.containsPoint(a);
            if (c) {
                return true;
            }
        }
        return false;
    }
    p(a) {
        for (let b = 0; b < this.u.count; b++) {
            if (this.u._inner[b]._visibility == 0 && this.u._inner[b].ap(a)) {
                return true;
            }
        }
        return false;
    }
    o(a) {
        return this.n(a) || this.p(a);
    }
    bd() {
        this.a.fs();
    }
    al() {
        this.aq();
    }
    bn(a, b) {
        let c = b;
        this.bo(c.position, a, b);
    }
    g() {
        let a = new Slice();
        a.ai = this.a;
        this.u.add(a);
        return a;
    }
    be(a) {
        a._visibility = 0;
    }
    bg(a) {
        a._visibility = 1;
    }
    bf(a) {
        a.ai = null;
        this.u.remove(a);
    }
    d() {
        let a = new PieLabel();
        if (this.a.ax == 0) {
            a.ap = new Line();
        }
        else {
            a.aq = new Path();
            let b = new PathGeometry();
            b.c.add(new PathFigure());
            b.c._inner[0]._segments.add(new BezierSegment(0));
            a.aq.ak = b;
        }
        this.t.add(a);
        return a;
    }
    ar(a) {
        a._visibility = 0;
    }
    at(a) {
        a._visibility = 1;
    }
    as(a) {
        this.t.remove(a);
    }
    bl(a) {
        if ((this.a.ax != 0 && a.aq != null) || (this.a.ax == 0 && a.ap != null)) {
            return;
        }
        if (this.a.ax == 0) {
            a.aq = null;
            a.ap = new Line();
        }
        else {
            a.ap = null;
            a.aq = new Path();
            let b = new PathGeometry();
            let c = new PathFigure();
            c._startPoint = { $type: Point_$type, x: NaN, y: NaN };
            b.c.add(c);
            b.c._inner[0]._segments.add(new BezierSegment(0));
            a.aq.ak = b;
        }
    }
    bc(a) {
        if (this.a.h3 != null && a.isOthersSlice) {
            a.b0 = this.bv(a.a5);
            a.b1 = this.bw(a.a5);
            a.y = this.a.h3;
        }
        else if (a.isSelected && this.a.b0 && this.a.h4 != null) {
            a.y = this.a.h4;
        }
        else {
            a.y = null;
            a.b0 = this.bv(a.a5);
            a.b1 = this.bw(a.a5);
        }
    }
    bv(a) {
        if (this.a.ak != null && a >= 0 && this.a.ak.count > 0) {
            return this.a.ak.item(a % this.a.ak.count);
        }
        return null;
    }
    bw(a) {
        if (this.a.al != null && a >= 0 && this.a.al.count > 0) {
            return this.a.al.item(a % this.a.al.count);
        }
        return null;
    }
    ad(a) {
        if (a == null || a.aj == null) {
            return this.a.dx;
        }
        let b = a.aj;
        let c = b.aj;
        if (typeCast(TextBlock.$, c) !== null) {
            return c.ak;
        }
        return c;
    }
    y(a) {
        let b = typeCast(TextBlock.$, a);
        if (b != null && b.ak != null && this.i != null) {
            return this.i.e(b) + 0;
        }
        return 0;
    }
    bk() {
        this.v = FontUtil.getCurrentFontHeight(this.c.n, this.c.d());
    }
    x(a) {
        return this.v + 0;
    }
    b1(a) {
        let b = a.aj;
        if (typeCast(TextBlock.$, b) !== null) {
            let c = this.y(b);
            let d = this.x(b);
            return new Rect(0, 0, 0, c, d);
        }
        return Rect.empty;
    }
    b3() {
        return new Size(1, this.b2.width, this.b2.height);
    }
    bm(a, b, c) {
        let d = typeCast(TextBlock.$, a.aj);
        if (d != null) {
            d.n = b;
            d.o = c;
        }
        this.av();
    }
    bp(a) {
        this.bq(a);
    }
    br() {
        this.av();
    }
    au() {
        this.am();
    }
    am() {
        let a = this.b.c;
        if (this.a.ez != null) {
            a = this.a.be();
        }
        if (this.i != null) {
            this.i.ac(a);
        }
    }
    az(a, b) {
        this.c.ad(a, b);
    }
    aw() {
        this.c.aa();
    }
    get af() {
        return this.c != null && this.c.n != null ? this.c.n.getResourceString("invalidLabelBinding") : "There is no such value for the labels to bind.";
    }
    aq() {
        if (this.s == true) {
            this.s = false;
            this.c.y(this.e);
        }
    }
    bq(a) {
        this.c.ak(a);
    }
    bo(a, b, c) {
        this.s = true;
        this.by = a;
        if (b == null) {
            this.ag = null;
            this.e.item = null;
        }
        else {
            this.ag = b.dataContext;
            this.e.item = b.dataContext;
            this.e.slice = b;
        }
        let d = this.a.hy();
        let pos_ = { $type: Point_$type, x: a.x + 15 + d.x, y: a.y + 15 + d.y };
        let context_ = this.e;
        this.c.aj(pos_, context_);
    }
    bh() {
        this.bb();
        this.bk();
        this.a.f2();
    }
    a2() {
        this.c.af(this.a.b5);
    }
    ac() {
        return this.c.t();
    }
    ao() {
        if (this.l) {
            this.bi();
        }
    }
    r() {
        return this.ac() != null;
    }
    an(a) {
        this.c.x(a);
    }
    q() {
        return true;
    }
    a4() {
    }
    bt(a) {
        let b = this.c.al(a.y);
        if (b != null) {
            return b;
        }
        return a.b0;
    }
    bu(a) {
        let b = this.c.am(a.y);
        if (b != null) {
            return b;
        }
        return a.b1;
    }
    w(a) {
        return this.c.m(a.y);
    }
    z(a) {
        return this.c.m(a);
    }
    aa() {
        for (let a of fromEnum(this.u)) {
            if (!a.isSelected) {
                return a.a4;
            }
        }
        return NaN;
    }
    a3() {
        this.c.ag();
        this.av();
    }
    ae(a) {
        return this.c.c.ap;
    }
}
PieChartBaseView.$t = markType(PieChartBaseView, 'PieChartBaseView');
/**
 * @hidden
 */
class PieSliceDataContext extends DataContext {
    constructor() {
        super(...arguments);
        this._slice = null;
        this._percentValue = 0;
        this._isOthersSlice = false;
    }
    get slice() {
        return this._slice;
    }
    set slice(a) {
        this._slice = a;
    }
    get percentValue() {
        return this._percentValue;
    }
    set percentValue(a) {
        this._percentValue = a;
    }
    get isOthersSlice() {
        return this._isOthersSlice;
    }
    set isOthersSlice(a) {
        this._isOthersSlice = a;
    }
    flatten() {
        let ret_ = super.flatten();
        let percentValue_ = this.percentValue;
        let isOthersSlice_ = this.isOthersSlice;
        ret_.percentValue = percentValue_;
        ret_.isOthersSlice = isOthersSlice_;
        if (isOthersSlice_ && this.item != null) {
            let items_ = [];
            for (let currItem_ of fromEn(this.item)) {
                items_.push(currItem_);
            }
            ret_.item = items_;
        }
        return ret_;
    }
}
PieSliceDataContext.$t = markType(PieSliceDataContext, 'PieSliceDataContext', DataContext.$);
/**
 * @hidden
 */
class SliceView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.g = null;
        this.a = a;
    }
    b() {
        this.g = new Path();
        this.a.content = this.g;
    }
    c() {
        this.a.bk();
    }
    f() {
        return this.g;
    }
    d(a, b) {
        this.g.j = ((() => {
            let $ret = new TranslateTransform();
            $ret.j = a;
            $ret.k = b;
            return $ret;
        })());
    }
    e() {
        this.g.j = null;
    }
}
SliceView.$t = markType(SliceView, 'SliceView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HoleDimensionsChangedEventArgs extends EventArgs {
    constructor(a, b) {
        super();
        this.d = null;
        this.b = 0;
        this.d = a;
        this.b = b;
    }
    get center() {
        return this.d;
    }
    get radius() {
        return this.b;
    }
}
HoleDimensionsChangedEventArgs.$t = markType(HoleDimensionsChangedEventArgs, 'HoleDimensionsChangedEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DoughnutChartVisualData extends Base {
    constructor() {
        super();
        this._series = null;
        this._height = 0;
        this._width = 0;
        this._holeRadius = 0;
        this._dipScalingRatio = 0;
        this._viewport = null;
        this.dipScalingRatio = 1;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get holeRadius() {
        return this._holeRadius;
    }
    set holeRadius(a) {
        this._holeRadius = a;
    }
    get dipScalingRatio() {
        return this._dipScalingRatio;
    }
    set dipScalingRatio(a) {
        this._dipScalingRatio = a;
    }
    scaleByViewport() {
        if (this.series != null) {
            for (let a of fromEnum(this.series)) {
                for (let b of fromEnum(a.rings)) {
                    for (let c of fromEnum(b.arcs)) {
                        for (let d of fromEnum(c.a)) {
                            d.scaleByViewport(this.viewport);
                        }
                    }
                }
            }
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (!isNaN_(this.width)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("width: ");
            a.u(this.width.toString());
        }
        if (!isNaN_(this.height)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("height: ");
            a.u(this.height.toString());
        }
        if (!isNaN_(this.holeRadius)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("holeRadius: ");
            a.u(this.holeRadius.toString());
        }
        if (this.viewport != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("viewport: {");
            a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
            a.u("}");
        }
        if (this.series != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("series: [");
            for (let c = 0; c < this.series.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.series._inner[c].serialize());
            }
            a.u("]");
        }
        if (!b) {
            a.l(", ");
        }
        a.l("dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
}
DoughnutChartVisualData.$t = markType(DoughnutChartVisualData, 'DoughnutChartVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RingSeriesVisualData extends Base {
    constructor() {
        super(...arguments);
        this._name = null;
        this._labelExtent = 0;
        this._labelsPosition = null;
        this._leaderLineType = null;
        this._leaderLineVisibility = false;
        this._leaderLineMargin = 0;
        this._rings = null;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get labelExtent() {
        return this._labelExtent;
    }
    set labelExtent(a) {
        this._labelExtent = a;
    }
    get labelsPosition() {
        return this._labelsPosition;
    }
    set labelsPosition(a) {
        this._labelsPosition = a;
    }
    get leaderLineType() {
        return this._leaderLineType;
    }
    set leaderLineType(a) {
        this._leaderLineType = a;
    }
    get leaderLineVisibility() {
        return this._leaderLineVisibility;
    }
    set leaderLineVisibility(a) {
        this._leaderLineVisibility = a;
    }
    get leaderLineMargin() {
        return this._leaderLineMargin;
    }
    set leaderLineMargin(a) {
        this._leaderLineMargin = a;
    }
    get rings() {
        return this._rings;
    }
    set rings(a) {
        this._rings = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.name != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("name: ");
            a.u("'" + this.name + "'");
        }
        if (!isNaN_(this.labelExtent)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelExtent: ");
            a.u(this.labelExtent.toString());
        }
        if (this.labelsPosition != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelsPosition: ");
            a.u("'" + this.labelsPosition + "'");
        }
        if (this.leaderLineType != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLineType: ");
            a.u("'" + this.leaderLineType + "'");
        }
        a.l(", leaderLineVisibility: ");
        a.u(this.leaderLineVisibility ? "true" : "false");
        if (!isNaN_(this.leaderLineMargin)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLineMargin: ");
            a.u(this.leaderLineMargin.toString());
        }
        a.u(", rings: [");
        for (let c = 0; c < this.rings.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.rings._inner[c].serialize());
        }
        a.u("]}");
        return a.toString();
    }
}
RingSeriesVisualData.$t = markType(RingSeriesVisualData, 'RingSeriesVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RingSeriesVisualDataList extends List$1 {
    constructor() {
        super(RingSeriesVisualData.$, 0);
    }
}
RingSeriesVisualDataList.$t = markType(RingSeriesVisualDataList, 'RingSeriesVisualDataList', List$1.$.specialize(RingSeriesVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SliceVisualData extends Base {
    constructor() {
        super(...arguments);
        this._pieSlice = null;
        this._outline = null;
        this._labelVisualData = null;
        this._backgroundPath = null;
        this._origin = null;
        this._explodedOrigin = null;
        this._isExploded = false;
        this._isSelected = false;
        this._index = 0;
        this._radius = 0;
        this._startAngle = 0;
        this._endAngle = 0;
        this._visibility = false;
    }
    get pieSlice() {
        return this._pieSlice;
    }
    set pieSlice(a) {
        this._pieSlice = a;
    }
    get outline() {
        return this._outline;
    }
    set outline(a) {
        this._outline = a;
    }
    get labelVisualData() {
        return this._labelVisualData;
    }
    set labelVisualData(a) {
        this._labelVisualData = a;
    }
    get backgroundPath() {
        return this._backgroundPath;
    }
    set backgroundPath(a) {
        this._backgroundPath = a;
    }
    get origin() {
        return this._origin;
    }
    set origin(a) {
        this._origin = a;
    }
    get explodedOrigin() {
        return this._explodedOrigin;
    }
    set explodedOrigin(a) {
        this._explodedOrigin = a;
    }
    get isExploded() {
        return this._isExploded;
    }
    set isExploded(a) {
        this._isExploded = a;
    }
    get isSelected() {
        return this._isSelected;
    }
    set isSelected(a) {
        this._isSelected = a;
    }
    get index() {
        return this._index;
    }
    set index(a) {
        this._index = a;
    }
    get radius() {
        return this._radius;
    }
    set radius(a) {
        this._radius = a;
    }
    get startAngle() {
        return this._startAngle;
    }
    set startAngle(a) {
        this._startAngle = a;
    }
    get endAngle() {
        return this._endAngle;
    }
    set endAngle(a) {
        this._endAngle = a;
    }
    get visibility() {
        return this._visibility;
    }
    set visibility(a) {
        this._visibility = a;
    }
    scaleByViewport(a) {
        this.origin = new PointData((this.origin.x - a.left) / a.width, (this.origin.y - a.top) / a.height);
        this.explodedOrigin = new PointData((this.explodedOrigin.x - a.left) / a.width, (this.explodedOrigin.y - a.top) / a.height);
    }
    serialize() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.pieSlice != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("pieSlice: ");
            a.u(this.pieSlice.serialize());
        }
        if (this.labelVisualData != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("labelVisualData: ");
            a.u(this.labelVisualData.serialize());
        }
        if (this.backgroundPath != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("backgroundPath: ");
            a.u(this.backgroundPath.serialize());
        }
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("isExploded: ");
        a.u(this.isExploded.toString().toLowerCase());
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("isSelected: ");
        a.u(this.isSelected.toString().toLowerCase());
        if (!isNaN_(this.explodedOrigin.x) && !isNaN_(this.explodedOrigin.y)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("explodedOrigin: ");
            a.u("{ x: " + this.explodedOrigin.x.toString() + ", y: " + this.explodedOrigin.y.toString() + "}");
        }
        if (!isNaN_(this.origin.x) && !isNaN_(this.origin.y)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("origin: ");
            a.u("{ x: " + this.origin.x.toString() + ", y: " + this.origin.y.toString() + "}");
        }
        if (!isNaN_(this.index)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("index: ");
            a.u(this.index.toString());
        }
        if (!isNaN_(this.radius)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("radius: ");
            a.u(this.radius.toString());
        }
        a.l(", visibility: ");
        a.u(this.visibility ? "true" : "false");
        if (!isNaN_(this.startAngle)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("startAngle: ");
            a.u(this.startAngle.toString());
        }
        if (!isNaN_(this.endAngle)) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("endAngle: ");
            a.u(this.endAngle.toString());
        }
        a.u("}");
        return a.toString();
    }
}
SliceVisualData.$t = markType(SliceVisualData, 'SliceVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DoughnutChartLabelVisualData extends Base {
    constructor() {
        super(...arguments);
        this._labelValue = null;
        this._labelSize = null;
        this._labelPosition = null;
    }
    get labelValue() {
        return this._labelValue;
    }
    set labelValue(a) {
        this._labelValue = a;
    }
    get labelSize() {
        return this._labelSize;
    }
    set labelSize(a) {
        this._labelSize = a;
    }
    get labelPosition() {
        return this._labelPosition;
    }
    set labelPosition(a) {
        this._labelPosition = a;
    }
    scaleByViewport(a) {
        this.labelPosition = new PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
        this.labelSize = new SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
    }
    serialize() {
        let a = "{ labelValue: '";
        a += this.labelValue == null ? stringEmpty() : this.labelValue;
        a += "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}}";
        return a;
    }
}
DoughnutChartLabelVisualData.$t = markType(DoughnutChartLabelVisualData, 'DoughnutChartLabelVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RingVisualData extends Base {
    constructor() {
        super(...arguments);
        this._arcs = null;
    }
    get arcs() {
        return this._arcs;
    }
    set arcs(a) {
        this._arcs = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.arcs != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("arcs: [");
            for (let c = 0; c < this.arcs.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.arcs._inner[c].c());
            }
            a.u("]");
        }
        a.u("}");
        return a.toString();
    }
}
RingVisualData.$t = markType(RingVisualData, 'RingVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RingVisualDataList extends List$1 {
    constructor() {
        super(RingVisualData.$, 0);
    }
}
RingVisualDataList.$t = markType(RingVisualDataList, 'RingVisualDataList', List$1.$.specialize(RingVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ArcVisualData extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
    }
    d(a) {
        for (let b of fromEnum(this.a)) {
            b.scaleByViewport(a);
        }
    }
    c() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.b != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("leaderLine: ");
            a.u(this.b.serialize());
        }
        if (this.a != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.u("slices: [");
            for (let c = 0; c < this.a.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.a._inner[c].serialize());
            }
        }
        a.u("]}");
        return a.toString();
    }
}
ArcVisualData.$t = markType(ArcVisualData, 'ArcVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ArcVisualDataList extends List$1 {
    constructor() {
        super(ArcVisualData.$, 0);
    }
}
ArcVisualDataList.$t = markType(ArcVisualDataList, 'ArcVisualDataList', List$1.$.specialize(ArcVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SliceVisualDataList extends List$1 {
    constructor() {
        super(SliceVisualData.$, 0);
    }
}
SliceVisualDataList.$t = markType(SliceVisualDataList, 'SliceVisualDataList', List$1.$.specialize(SliceVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Arc extends PieChartBase {
    constructor() {
        super();
        this.h9 = null;
        this.h7 = null;
        this.ic = 0;
        this.ab = Arc.$;
    }
    az() {
        return new ArcView(this);
    }
    fu(a) {
        super.fu(a);
        this.h8 = a;
    }
    get ia() {
        return this.h9;
    }
    set ia(a) {
        let b = this.h9;
        this.h9 = a;
        this.h8.b6(b, this.h9);
    }
    get id() {
        if (this.ia != null) {
            return this.ia.i;
        }
        return 0;
    }
    ft(a, b) {
        super.ft(a, b);
        if (this.ia != null) {
            this.ia.c.ax.bu(a, b);
        }
    }
    e8(a, b) {
        if (this.ia != null && this.ia.d != null) {
            super.e8(a, b);
            let c = this.ib(a);
            if (c != null) {
                this.ia.d.bj(c, b);
            }
        }
    }
    f8(a, b) {
        if (this.ia != null && this.ia.d != null) {
            super.f8(a, b);
            let c = this.ib(a);
            if (c != null) {
                this.ia.d.b5(c, b);
            }
        }
    }
    ib(a) {
        for (let b of fromEnum(this.h7.g)) {
            if (b.b == a) {
                return b;
            }
        }
        return null;
    }
    f7(a) {
        if (this.b0) {
            this.fx();
            this.f5();
            this.f4();
        }
    }
    fx() {
        if (this.itemsSource == null || this.bd == null) {
            this.bo.count = 0;
            return;
        }
        let a = this.cc.count;
        let b = this.cb.count > 0;
        let c = PieChartBase.c2(this.cp);
        let d = PieChartBase.c2(this.cp);
        this.c7 = a;
        if (b) {
            a++;
        }
        for (let e = 0; e < a; e++) {
            let f = false;
            let g;
            if (e == a - 1 && b) {
                g = this.cz;
                f = true;
            }
            else {
                g = this.bm.item(this.cc._inner[e]);
            }
            if (this.hv == 1) {
                d += PieChartBase.c2(Math.abs(g) * this.ie / this.c4);
            }
            else {
                d -= PieChartBase.c2(Math.abs(g) * this.ie / this.c4);
            }
            let h = this.bo.item(e);
            if (this.cm >= 100) {
                h._visibility = 1;
            }
            else {
                h._visibility = 0;
            }
            h.aw = true;
            h.a3 = c;
            h.ax = d;
            h.a1 = h.a0 = this.cm;
            h.isOthersSlice = f;
            h.ay = this.cl;
            h.a5 = e;
            h.dataContext = f ? this.ca : this.bd.item(this.cc._inner[e]);
            h.isExploded = this.explodedSlices.contains(e);
            h.isSelected = this.selectedSlices.contains(e);
            c = d;
            h.aw = false;
        }
        this.bo.count = a;
        if (this.h7 != null) {
            this.h7.q(this);
        }
    }
    f4() {
        let a = typeCast(IChartLegend_$type, this.legend);
        if (a == null) {
            return;
        }
        if (this.bi == null || this.bi.count == 0 || ((this.ia != null && this.ia.c != null) && (this.ia.d != null && !this.ia.d.series.contains(this.ia.c)))) {
            a.clearLegendItemsForSeries(this.ia.c);
            return;
        }
        this.b9 = new List$1(UIElement.$, 0);
        for (let b of fromEnum(this.bo.a)) {
            let c = new ContentControl();
            let d = this.c8(b);
            let e = b.b0;
            let f = b.isOthersSlice ? this.ej : (this.bj != null && this.bj.count > 0) ? this.bj.item(this.cc._inner[b.a5]) : null;
            f = (f == null && this.bi.count > 0) ? this.bi.item(this.cc._inner[b.a5]) : f;
            c.content = ((() => {
                let $ret = new PieSliceDataContext();
                $ret.series = this.ia.c;
                $ret.slice = b;
                $ret.item = b.dataContext;
                $ret.itemBrush = e;
                $ret.legendLabel = f != null ? f.toString() : null;
                $ret.itemLabel = d != null ? d.toString() : null;
                $ret.percentValue = this.cu(b);
                $ret.isOthersSlice = b.isOthersSlice;
                return $ret;
            })());
            let g = c.content;
            if (this.a2 != null) {
                let h = this.a2(g);
                if (h != null) {
                    g.legendLabel = h.toString();
                }
            }
            if (this.an != null && !g.isOthersSlice) {
                let i = this.an.i(g);
                g.legendLabel = i;
            }
            if (this.ao != null && g.isOthersSlice) {
                let j = this.ao.i(g);
                g.legendLabel = j;
            }
            if (this.legendItemTemplate != null) {
                c.ah = this.legendItemTemplate;
            }
            this.b9.add(c);
        }
        if (a.isItemwise) {
            let k = a;
            k.createLegendItemsInsert(this.b9, this.ia.c);
        }
    }
    fy(a, b, c, d) {
        super.fy(a, b, c, d);
        switch (b) {
            case Arc.$$p[0]:
                this.ic = d;
                this.fx();
                this.fw();
                this.f5();
                this.f3();
                break;
            case "RadiusFactor":
                if (this.ia != null && this.ia.d != null) {
                    this.ia.d.bw();
                }
                break;
            case "Legend":
                let e = typeCast(IChartLegend_$type, c);
                if (e != null && this.ia != null && this.ia.c != null) {
                    e.clearLegendItemsForSeries(this.ia.c);
                }
                break;
        }
    }
    ig() {
        return this.a0.ac();
    }
}
Arc.$t = markType(Arc, 'Arc', PieChartBase.$);
Arc.$$p = markDep(DependencyProperty, PropertyMetadata, Arc, 'f0', ['EndAngle:ie:ii', [1, 360]]);
/**
 * @hidden
 */
class ArcItem extends Base {
    constructor() {
        super();
        this.d = null;
        this.b = null;
        this.n = null;
        this.l = 0;
        this.m = 0;
        this.k = 0;
        this.i = 0;
        this.j = 0;
        this.c = 0;
        this.a = null;
        this.g = null;
        this.e = null;
        this.h = null;
        this.k = 0;
        this.i = 360;
        this.g = new List$1(SliceItem.$, 0);
    }
    o(a, b) {
        let c = 0;
        let d = 0;
        let e = new List$1(Number_$type, 0);
        let f = new List$1(Number_$type, 0);
        let g = new List$1(Base.$, 0);
        this.g.clear();
        if (this.h == null) {
            return;
        }
        let h = new FastItemsSource();
        h.e = this.h;
        let i = this.f(h, this.n);
        if (i == null || i.count == 0) {
            h.deregisterColumn(i);
            h.m();
            return;
        }
        for (let j of fromEnum(i)) {
            if (isNaN_(j) || isInfinity(j) || j <= 0) {
                continue;
            }
            c = c + j;
        }
        for (let k = 0; k < i.count; k++) {
            let l = i.item(k);
            if (isNaN_(l) || isInfinity(l) || l <= 0) {
                continue;
            }
            let m = this.c == 1 ? l / c : l;
            let n = this.c == 1 ? this.j / 100 : this.j;
            if (m <= n) {
                d = d + l;
                f.add(k);
                g.add1(h.item(k));
            }
            else {
                e.add(k);
            }
        }
        let o = e.count;
        let p = f.count > 0;
        let q = PieChartBase.c2(a);
        let r = PieChartBase.c2(a);
        if (p) {
            o++;
        }
        for (let s = 0; s < o; s++) {
            let t = false;
            let u;
            if (s == o - 1 && p) {
                u = d;
                t = true;
            }
            else {
                u = i.item(e._inner[s]);
            }
            let v = 1;
            if (v == 1) {
                r += PieChartBase.c2(Math.abs(u) * b / c);
            }
            else {
                r -= PieChartBase.c2(Math.abs(u) * b / c);
            }
            this.g.add(((() => {
                let $ret = new SliceItem();
                $ret.e = q;
                $ret.d = r - q;
                $ret.g = t ? g : h.item(e._inner[s]);
                return $ret;
            })()));
            q = r;
        }
        h.deregisterColumn(i);
        h.m();
    }
    f(a, b) {
        let c = null;
        return a.registerColumn(b, c, false);
    }
    p(a) {
        let b = this.e == null ? a : this.e.e;
        let c = this.e == null ? 360 : this.e.d;
        this.o(b, c);
    }
    q(a) {
        this.g.clear();
        for (let b = 0; b < a.bo.count; b++) {
            let c = a.bo.item(b);
            this.g.add(((() => {
                let $ret = new SliceItem();
                $ret.e = c.a3;
                $ret.d = c.ax - c.a3;
                $ret.f = b;
                $ret.a = this;
                $ret.g = c.dataContext;
                $ret.c = c.isOthersSlice;
                $ret.b = c;
                return $ret;
            })()));
        }
    }
}
ArcItem.$t = markType(ArcItem, 'ArcItem');
/**
 * @hidden
 */
class RingSeriesBase extends Control {
    constructor() {
        super();
        this.as = null;
        this.ax = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.bd = null;
        this.a2 = false;
        this.a1 = false;
        this.bb = null;
        this.eh = null;
        this.aw = null;
        this.c9 = null;
        this.az = null;
        this.eh = { $type: Point_$type, x: 0, y: 0 };
        this.as = (a, b) => this.c4(a, b.propertyName, b.oldValue, b.newValue);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, this.as);
        this.aw = this.av();
        this.c1(this.aw);
        this.aw.k();
        this.bb = (a, b) => this.cv(b.action, b.position, b.count, b.propertyName);
    }
    c6(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    get el() {
        if (this.ek != null) {
            return this.ek;
        }
        if (this.ax != null && this.ax.cg != null) {
            return this.ax.cg;
        }
        return null;
    }
    set el(a) {
        let b = this.el;
        if (this.ek != null && a != this.ek) {
            a = this.ek;
        }
        this.c6("SelectedStyleResolved", b, a);
    }
    get co() {
        return this.bd;
    }
    set co(a) {
        let b = this.bd;
        this.bd = a;
        this.c6("TextStyle", b, a);
    }
    get da() {
        return typeCast(DataTemplate.$, this.c(RingSeriesBase.dp));
    }
    set da(a) {
        this.h(RingSeriesBase.dp, a);
    }
    get a3() {
        return this.c(RingSeriesBase.df);
    }
    set a3(a) {
        this.a2 = true;
        this.h(RingSeriesBase.df, a);
    }
    get a4() {
        if (!this.a2) {
            return this.ax.ax;
        }
        else {
            return this.a3;
        }
    }
    c4(a, b, c, d) {
        if (b == RingSeriesBase.$$p[4]) {
            this.ay = ((() => {
                let $ret = new FastItemsSource();
                $ret.e = d;
                return $ret;
            })());
        }
        if (b == RingSeriesBase.$$p[1]) {
            if (typeCast(FastItemsSource.$, c) != null) {
                let e = (typeCast(FastItemsSource.$, c));
                e.event = delegateRemove(e.event, this.bb);
                this.a1 = false;
            }
            if (typeCast(FastItemsSource.$, d) != null) {
                let f = (typeCast(FastItemsSource.$, d));
                f.event = delegateCombine(f.event, this.bb);
                this.a1 = true;
            }
            this.c3();
        }
        switch (b) {
            case RingSeriesBase.$$p[32]:
                this.el = d;
                break;
            case RingSeriesBase.$$p[36]:
                this.c3();
                break;
        }
    }
    get container() {
        return this.ax;
    }
    get isStacked() {
        return false;
    }
    get isVertical() {
        return false;
    }
    get isUsableInLegend() {
        return true;
    }
    get hasMarkers() {
        return false;
    }
    get hasSubItems() {
        return false;
    }
    cv(a, b, c, d) {
        this.c3();
    }
    av() {
        return new RingSeriesBaseView(this);
    }
    c1(a) {
    }
    c5(a) {
        this.aw.n(a);
    }
    cu() {
        if (this.aw != null) {
            this.aw.i();
        }
    }
    cy(a, b) {
        this.cw(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    c0(a, b, c) {
        this.cw(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    cx() {
        this.cw(new NotifyCollectionChangedEventArgs(0, 4));
    }
    cz(a, b) {
        this.cw(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    cw(a) {
        if (this.ay != null) {
            this.ay.handleCollectionChanged(a);
        }
    }
    resolveLegendIndex() {
        return -1;
    }
    forSubItems(a) {
    }
    get a0() {
        if (this.az == null) {
            this.az = new SRProvider(this.aw.g);
        }
        return this.az;
    }
    cj() {
        let a = this.a0.b7;
        if (stringIsNullOrWhiteSpace(a)) {
            a = "Others";
        }
        return this.ca != null ? this.ca : a;
    }
}
RingSeriesBase.$t = markType(RingSeriesBase, 'RingSeriesBase', Control.$, [INotifyPropertyChanged_$type, ILegendSeries_$type, ILegendTemplateProvider_$type]);
RingSeriesBase.dp = DependencyProperty.i("LabelTemplate", DataTemplate.$, RingSeriesBase.$, new PropertyMetadata(2, null, (a, b) => (typeCast(RingSeriesBase.$, a)).c6("LabelTemplate", b.oldValue, b.newValue)));
RingSeriesBase.df = DependencyProperty.i("IsSurfaceInteractionDisabled", Boolean_$type, RingSeriesBase.$, new PropertyMetadata(2, false, (a, b) => a.c6("IsSurfaceInteractionDisabled", b.oldValue, b.newValue)));
RingSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, RingSeriesBase, 'c6', ['Brushes:ak:db', [BrushCollection.$, null], 'FastItemsSource:ay:dc', [FastItemsSource.$], 'FormatLabel:aq:dd', [Delegate_$type], 'FormatLegendLabel:ar:de', [Delegate_$type], 'ItemsSource::dg', [IEnumerable_$type, null], 'LabelExtent:a6:dh', [1, 10], 'LabelFormat:bl:di', [2, null], 'LabelFormatSpecifiers:ag:dj', [Array_$type, null], 'LabelInnerColor:ef:dk', [Brush.$, null], 'LabelMemberPath:bp:dl', [2], 'LabelOuterColor:eg:dm', [Brush.$, null], 'LabelsPosition:an:dn', [LabelsPosition_$type, enumGetBox(LabelsPosition_$type, 1)], 'LeaderLineMargin:a7:dq', [1, 6], 'LeaderLineStyle:ei:dr', [Style.$, null], 'LeaderLineType:ao:ds', [LeaderLineType_$type, enumGetBox(LeaderLineType_$type, 0)], 'LeaderLineVisibility:en:dt', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'LegendItemBadgeTemplate::du', [DataTemplate.$, null], 'LegendItemTemplate::dv', [DataTemplate.$, null], 'LegendLabelFormat:b0:dw', [2, null], 'LegendLabelFormatSpecifiers:ah:dx', [Array_$type, null], 'LegendLabelMemberPath:b3:dy', [2], 'LegendOthersLabelFormat:b5:dz', [2, null], 'LegendOthersLabelFormatSpecifiers:ai:d0', [Array_$type, null], 'Legend::d1', [IChartLegend_$type, null], 'OthersCategoryStyle:ej:d2', [Style.$, null], 'OthersCategoryText:ca:d3', [2, null], 'OthersCategoryThreshold:a8:d4', [1, 3], 'OthersCategoryType:ap:d5', [OthersCategoryType_$type, enumGetBox(OthersCategoryType_$type, 1)], 'OthersLabelFormat:ce:d6', [2, null], 'OthersLabelFormatSpecifiers:aj:d7', [Array_$type, null], 'Outlines:al:d8', [BrushCollection.$, null], 'RadiusFactor:a9:d9', [1, 0.9], 'SelectedStyle:ek:ea', [Style.$, null], 'StartAngle:ba:eb', [1, 0], 'ToolTip::ec', [4, null], 'ToolTipStyle:em:ed', [Style.$, null], 'ValueMemberPath:cs:ee', [2, null]]);
/**
 * @hidden
 */
class Ring extends Base {
    constructor() {
        super();
        this.j = 0;
        this.h = 0;
        this.q = new Size();
        this.p = null;
        this._ringControl = null;
        this.b = null;
        this.i = 0;
        this.g = null;
        this.d = null;
        this.e = false;
        this.p = { $type: Point_$type, x: 0, y: 0 };
        this.q = new Size(1, 0, 0);
        this.ringControl = ((() => {
            let $ret = new RingControl();
            $ret.ai = this;
            return $ret;
        })());
        this.g = new List$1(ArcItem.$, 0);
        this.e = true;
    }
    get ringControl() {
        return this._ringControl;
    }
    set ringControl(a) {
        this._ringControl = a;
    }
    get c() {
        return this.b;
    }
    set c(a) {
        this.b = a;
        this.b.aw.h(this.ringControl);
        if (this.ringControl != null) {
            this.ringControl.ak.s(a);
        }
    }
    f() {
        if (this.ringControl != null && this.ringControl.ak.d()) {
            let a, b;
            a = this.p.x - this.c.eh.x;
            b = this.p.y - this.c.eh.y;
            this.ringControl.ak.v(a, b);
            return this.ringControl.an();
        }
        return false;
    }
    o() {
        if (this.ringControl != null) {
            this.ringControl.width = this.q.width;
            this.ringControl.height = this.q.height;
            this.c.aw.h(this.ringControl);
            this.ringControl.ao = this.g;
        }
    }
    l(source_, a, b) {
        this.ringControl.as(source_, a, b);
    }
    k(source_) {
        this.ringControl.ar(source_);
    }
    m(source_, a, b) {
        this.ringControl.at(source_, a, b);
    }
    n(source_, a, b, c) {
        this.ringControl.au(source_, a, b, c);
    }
}
Ring.$t = markType(Ring, 'Ring');
/**
 * @hidden
 */
class RingCollection extends ObservableCollection$1 {
    constructor() {
        super(Ring.$, 0);
    }
    p() {
        for (let a of fromEnum(this)) {
            if (a.e) {
                let b = 0;
                let c = a.ringControl.arcs.count;
                while (b < c) {
                    a.ringControl.arcs.destroy(a.ringControl.arcs.item(b));
                    b++;
                }
                a.ringControl.arcs.count = 0;
                a.ringControl = null;
            }
        }
        super.p();
    }
    u(a) {
        let b = this._inner[a];
        if (b.e) {
            b.ringControl.arcs.destroy(b.ringControl.arcs.item(a));
            b.ringControl.arcs.count = 0;
            b.ringControl = null;
        }
        super.u(a);
    }
}
RingCollection.$t = markType(RingCollection, 'RingCollection', ObservableCollection$1.$.specialize(Ring.$));
/**
 * @hidden
 */
class RingControl extends Control {
    constructor() {
        super();
        this.ak = null;
        this.ah = null;
        this.arcs = null;
        this.ao = null;
        this.a0 = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.ab = RingControl.$;
        this.ak = this.aj();
        this.ax(this.ak);
        this.ak.r();
        this.arcs = ((() => {
            let $ret = new Pool$1(Arc.$);
            $ret.create = runOn(this.ak, this.ak.a);
            $ret.activate = runOn(this.ak, this.ak.l);
            $ret.disactivate = runOn(this.ak, this.ak.n);
            $ret.destroy = runOn(this.ak, this.ak.m);
            return $ret;
        })());
    }
    get al() {
        return this.ai.c;
    }
    get ai() {
        return this.ah;
    }
    set ai(a) {
        this.ah = a;
        if (this.ah == null) {
            this.ak.s(null);
        }
        else {
            this.ak.s(this.ah.c);
        }
    }
    aj() {
        return new RingControlView(this);
    }
    ax(a) {
    }
    az(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    aw() {
        this.an();
    }
    an() {
        if (this.ao == null) {
            return false;
        }
        if (!this.ak.d()) {
            return false;
        }
        let a = 0;
        let b = false;
        for (let c of fromEnum(this.ao)) {
            let d = this.arcs.item(a);
            d.h7 = c;
            if (d.cv != this.ai.h) {
                d.cv = this.ai.h;
            }
            if ((d.width != this.ai.q.width || d.height != this.ai.q.height) && d.a0.r()) {
                d.width = this.ai.q.width;
                d.height = this.ai.q.height;
                this.ak.ab(d);
                b = true;
            }
            if (d.c3 != c.k) {
                d.c3 = c.k;
            }
            if (d.ie != c.i) {
                d.ie = c.i;
            }
            if (d.itemsSource != c.h) {
                d.itemsSource = c.h;
            }
            if (d.ak != c.a) {
                d.ak = c.a;
            }
            this.ak.t(d, 0, 0);
            a++;
        }
        this.arcs.count = a;
        return b;
    }
    ay(a) {
        this.ak.w(a);
    }
    av() {
        this.ak.q();
    }
    ap() {
        return this.ak.j();
    }
    as(source_, a, b) {
        for (let c = 0; c < this.arcs.count; c++) {
            this.arcs.item(c).fg(source_, a, b);
        }
    }
    ar(source_) {
        for (let a = 0; a < this.arcs.count; a++) {
            this.arcs.item(a).fe(source_);
        }
    }
    at(source_, a, b) {
        for (let c = 0; c < this.arcs.count; c++) {
            this.arcs.item(c).fh(source_, a, b);
        }
    }
    au(source_, a, b, c) {
        for (let d = 0; d < this.arcs.count; d++) {
            this.arcs.item(d).fi(source_, a, b, c);
        }
    }
}
RingControl.$t = markType(RingControl, 'RingControl', Control.$, [INotifyPropertyChanged_$type]);
/**
 * @hidden
 */
class RingSeriesCollection extends ObservableCollection$1 {
    constructor() {
        super(RingSeriesBase.$, 0);
    }
}
RingSeriesCollection.$t = markType(RingSeriesCollection, 'RingSeriesCollection', ObservableCollection$1.$.specialize(RingSeriesBase.$));
/**
 * @hidden
 */
class SliceItem extends Base {
    constructor() {
        super();
        this.e = 0;
        this.d = 0;
        this.a = null;
        this.f = 0;
        this.b = null;
        this.g = null;
        this.c = false;
    }
}
SliceItem.$t = markType(SliceItem, 'SliceItem');
/**
 * @hidden
 */
class SliceCollection extends ObservableCollection$1 {
    constructor() {
        super(SliceItem.$, 0);
        this.ae = false;
        this.ag = false;
    }
    r(a, b) {
        if (this.contains(b)) {
            return;
        }
        let c = this.ah(b.b);
        if (c != -1) {
            super.x(c, b);
        }
        else {
            super.r(a, b);
            if (this.ae) {
                if (this.ag) {
                    b.b.isSelected = true;
                }
                else {
                    b.b.isExploded = true;
                }
            }
        }
    }
    x(a, b) {
        if (this.ae) {
            if (this.ag) {
                this._inner[a].b.isSelected = false;
            }
            else {
                this._inner[a].b.isExploded = false;
            }
        }
        super.x(a, b);
    }
    u(a) {
        let b = this._inner[a];
        super.u(a);
        if (this.ae) {
            if (this.ag) {
                b.b.isSelected = false;
            }
            else {
                b.b.isExploded = false;
            }
        }
    }
    remove(a) {
        let b = this.ah(a.b);
        if (b != -1) {
            this.u(b);
            return true;
        }
        else {
            return false;
        }
    }
    p() {
        while (this.count > 0) {
            this.u(0);
        }
    }
    ah(a) {
        for (let b = 0; b < this.count; b++) {
            if (this._inner[b].b == a) {
                return b;
            }
        }
        return -1;
    }
}
SliceCollection.$t = markType(SliceCollection, 'SliceCollection', ObservableCollection$1.$.specialize(SliceItem.$));
/**
 * @hidden
 */
class XamDoughnutChart extends Control {
    constructor() {
        super();
        this.al = new RingSeriesCollection();
        this.aj = new RingCollection();
        this.ap = ((() => {
            let $ret = new SliceCollection();
            $ret.ae = true;
            $ret.ag = true;
            return $ret;
        })());
        this.ao = ((() => {
            let $ret = new SliceCollection();
            $ret.ae = true;
            $ret.ag = false;
            return $ret;
        })());
        this.ah = null;
        this.a0 = NaN;
        this.az = 1;
        this.au = null;
        this.sliceClick = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.holeDimensionsChanged = null;
        let a = this.at();
        this.bv(a);
        a.s();
        this.ab = XamDoughnutChart.$;
        this.ah = (b, c) => this.bz(b, c.propertyName, c.oldValue, c.newValue);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, this.ah);
        let b = this.series;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.b6));
    }
    get ak() {
        return this.aj;
    }
    get series() {
        return this.al;
    }
    b6(a, b) {
        let c = new List$1(RingSeriesBase.$, 0);
        if (b.oldItems != null) {
            for (let d of fromEn(b.oldItems)) {
                if (b.newItems == null || !b.newItems.contains(d)) {
                    d.cu();
                    this.au.w(d);
                }
            }
        }
        this.bx();
        this.b2();
    }
    get a3() {
        return this.c(XamDoughnutChart.cc);
    }
    set a3(a) {
        this.h(XamDoughnutChart.cc, a);
    }
    get ar() {
        return this.ap;
    }
    set ar(a) {
        this.ap.clear();
        this.ap.ae = false;
        this.ap = a;
        this.ap.ae = true;
        this.ap.ag = true;
        for (let b = 0; b < this.ap.count; b++) {
            this.ap._inner[b].b.isSelected = true;
        }
    }
    get aq() {
        return this.ao;
    }
    set aq(a) {
        this.ao.clear();
        this.ao.ae = false;
        this.ao = a;
        this.ao.ae = true;
        this.ao.ag = false;
        for (let b = 0; b < this.ao.count; b++) {
            this.ao._inner[b].b.isExploded = true;
        }
    }
    get a4() {
        return this.a0;
    }
    set a4(a) {
        let b = this.a0;
        this.a0 = a;
        this.b1("PixelScalingRatio", b, this.a0);
    }
    get a1() {
        return this.az;
    }
    set a1(a) {
        let b = this.az;
        this.az = a;
        this.b1("ActualPixelScalingRatio", b, this.az);
    }
    destroy() {
        this.au.v(null);
        for (let a of fromEnum(this.series)) {
            a.cu();
        }
    }
    b5(a, b) {
        if (b) {
            this.ar.add(a);
        }
        else {
            this.ar.remove(a);
        }
    }
    bj(a, b) {
        if (b) {
            this.aq.add(a);
        }
        else {
            this.aq.remove(a);
        }
    }
    bz(a, b, c, d) {
        switch (b) {
            case XamDoughnutChart.$$p[5]:
                for (let e of fromEnum(this.series)) {
                    e.el = d;
                }
                break;
            case XamDoughnutChart.$$p[0]:
                for (let f = 0; f < this.aj.count; f++) {
                    for (let g of fromEnum(this.aj._inner[f].ringControl.arcs.a)) {
                        g.bz = this.av;
                    }
                }
                break;
            case XamDoughnutChart.$$p[1]:
                for (let h = 0; h < this.aj.count; h++) {
                    for (let i of fromEnum(this.aj._inner[h].ringControl.arcs.a)) {
                        i.b0 = this.aw;
                    }
                }
                break;
            case "PixelScalingRatio":
                let j = DeviceUtils.a(this.a4);
                if (isNaN_(j)) {
                    this.a1 = 1;
                }
                else {
                    this.a1 = j;
                }
                break;
            case "ActualPixelScalingRatio":
                for (let k of fromEnum(this.aj)) {
                    for (let l of fromEnum(k.ringControl.arcs.a)) {
                        l.cn = this.a1;
                    }
                }
                break;
        }
    }
    at() {
        return new XamDoughnutChartView(this);
    }
    bv(a) {
        this.au = a;
    }
    b2() {
        this.by();
        this.b4();
        this.b3();
        this.bw();
        this.au.z();
    }
    b4() {
        for (let a of fromEnum(this.series)) {
            a.c8();
        }
    }
    bw() {
        let a = this.au.ab;
        if (a.isEmpty || a.width == 0 || a.height == 0) {
            return;
        }
        let b = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        let c = Math.min(a.width / 2, a.height / 2);
        let d = 0.9;
        if (this.series.count > 0) {
            d = this.series._inner[0].a9;
            if (isNaN_(d) || isInfinity(d) || d < 0) {
                d = 0;
            }
            else if (d > 1) {
                d = 1;
            }
        }
        let e = this.a3 * c / 100 * d;
        this.au.x(e * 2, e * 2);
        this.au.u(b.x - e, b.y - e);
    }
    b3() {
        let a = false;
        for (let b of fromEnum(this.aj)) {
            if (b.f()) {
                a = true;
            }
        }
        if (a) {
            for (let c of fromEnum(this.aj)) {
                c.c.aw.l();
            }
        }
    }
    by() {
        let a = this.au.ab;
        if (a.isEmpty || a.width == 0 || a.height == 0) {
            return;
        }
        let b = { $type: Point_$type, x: a.width / 2, y: a.height / 2 };
        let c = Math.min(a.width / 2, a.height / 2);
        let d = Math.max(a.width / 2, a.height / 2);
        if (a.width > a.height) {
            c = c + d;
            d = c - d;
            c = c - d;
        }
        let e = ((100 - this.a3) / 100 * c) / this.aj.count;
        let f = ((100 - this.a3) / 100 * d) / this.aj.count;
        let g = this.a3 * c / 100;
        let h = this.a3 * d / 100;
        let i = 1;
        for (let j of fromEnum(this.aj)) {
            let k = (g + (e * i));
            let l = (h + (f * i));
            j.i = e;
            j.q = new Size(1, k * 2, l * 2);
            j.p = { $type: Point_$type, x: b.x - k, y: b.y - l };
            j.h = 100 - (e / k * 100);
            j.o();
            i++;
        }
    }
    bx() {
        this.aq.clear();
        this.ar.clear();
        this.aj.clear();
        this.au.j();
        this.au.i();
        let a = 0;
        for (let b = 0; b < this.series.count; b++) {
            let c = this.series._inner[b];
            c.ax = this;
            this.au.h(c);
            let series_ = c;
            series_.externalObject.sychronizeCollections();
            let d = c.au();
            for (let e of fromEnum(d)) {
                e.d = this;
                e.j = a;
                this.aj.add(e);
                a++;
            }
        }
    }
    bt() {
        if (this.au != null) {
            this.height = this.au.ab.height;
            this.width = this.au.ab.width;
        }
        this.b2();
    }
    bu(a, b) {
        let c = a;
        let d = c.ia.c;
        if (d.a4) {
            return;
        }
        if (this.sliceClick != null) {
            this.sliceClick(a, b);
        }
    }
    b1(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    onDetachedFromUI() {
        this.au.r();
        for (let a = 0; a < this.aj.count; a++) {
            for (let b of fromEnum(this.aj._inner[a].ringControl.arcs.a)) {
                b.onDetachedFromUI();
            }
            for (let c of fromEnum(this.aj._inner[a].ringControl.arcs.b)) {
                c.onDetachedFromUI();
            }
        }
    }
    onAttachedToUI() {
        this.au.q();
        for (let a = 0; a < this.aj.count; a++) {
            for (let b of fromEnum(this.aj._inner[a].ringControl.arcs.a)) {
                b.onAttachedToUI();
            }
            for (let c of fromEnum(this.aj._inner[a].ringControl.arcs.b)) {
                c.onAttachedToUI();
            }
        }
    }
    provideContainer(a) {
        this.au.v(a);
    }
    notifyResized() {
        this.au.y();
    }
    bd() {
        return this.au.g();
    }
    cf() {
        return this.au.aa;
    }
    a2() {
        return this.au.d;
    }
    bk() {
        let a;
        let b;
        for (let c = 0; c < this.series.count; c++) {
            b = this.series._inner[c].au();
            for (let d = 0; d < b.count; d++) {
                a = b._inner[d].ringControl.ak.h();
                for (let e = 0; e < a.count; e++) {
                    a._inner[e].e9();
                }
            }
        }
    }
    bs() {
        if (this.holeDimensionsChanged != null) {
            this.holeDimensionsChanged(this, new HoleDimensionsChangedEventArgs(this.cf(), this.a2()));
        }
    }
    as() {
        let a = new DoughnutChartVisualData();
        a.series = new RingSeriesVisualDataList();
        a.viewport = RectData.b(this.au.ab);
        this.au.o(a);
        return a;
    }
    bc() {
        let a = this.as();
        a.scaleByViewport();
        return a.serialize();
    }
    *_ay(a) {
        for (let b of fromEnum(this.series)) {
            if (PieChartBase.b8(a, b.itemsSource)) {
                yield b;
            }
        }
    }
    ay(a) {
        return toEnum(() => this._ay(a));
    }
    bm(source_, a, b) {
        for (let c of fromEnum(this.ay(source_))) {
            c.cy(a, b);
        }
    }
    bp(source_, a, b, c) {
        for (let d of fromEnum(this.ay(source_))) {
            d.c0(a, b, c);
        }
    }
    bl(source_) {
        for (let a of fromEnum(this.ay(source_))) {
            a.cx();
        }
    }
    bn(source_, a, b) {
        for (let c of fromEnum(this.ay(source_))) {
            c.cz(a, b);
        }
    }
}
XamDoughnutChart.$t = markType(XamDoughnutChart, 'XamDoughnutChart', Control.$, [INotifyPropertyChanged_$type, ILegendOwner_$type]);
XamDoughnutChart.cc = DependencyProperty.i("InnerExtent", Number_$type, XamDoughnutChart.$, new PropertyMetadata(2, 40, (a, b) => {
    let c = b.newValue;
    if (c < 0 || c > 100) {
        if (b.oldValue != null) {
            a.a3 = b.oldValue;
        }
        return;
    }
    a.b2();
    a.b1("InnerExtent", b.oldValue, b.newValue);
}));
XamDoughnutChart.$$p = markDep(DependencyProperty, PropertyMetadata, XamDoughnutChart, 'b1', ['AllowSliceExplosion:av:b8', [0, true], 'AllowSliceSelection:aw:b9', [0, true], 'CenterData:a5:ca', [4, null], 'CenterDataTemplate:b7:cb', [DataTemplate.$, null], 'IsSurfaceInteractionDisabled:ax:cd', [0, false], 'SelectedStyle:cg:ce', [Style.$, null]]);
/**
 * @hidden
 */
class ArcView extends PieChartBaseView {
    constructor(a) {
        super(a);
        this.b4 = null;
        this.b4 = a;
    }
    b6(a, b) {
        this.e.series = this.b4.ia.c;
    }
    b5() {
        return this.f;
    }
    b7() {
        this.bb();
        this.bs = new Brush();
        let a = this.c.t();
        this.bs._fill = a.rootWrapper.getStyleProperty("color");
    }
}
ArcView.$t = markType(ArcView, 'ArcView', PieChartBaseView.$);
/**
 * @hidden
 */
class RingControlView extends Base {
    constructor(a) {
        super();
        this.b = null;
        this.f = new List$1(Arc.$, 0);
        this.g = new List$1(Arc.$, 0);
        this.i = null;
        this.e = new Dictionary$2(Arc.$, DomRenderer_$type, 0);
        this.c = null;
        this.b = a;
    }
    a() {
        let a = new Arc();
        a.o = 0;
        a.n = 0;
        a.ia = this.b.ai;
        this.f.add(a);
        this.z(a);
        if (a.ez != this.b.al.co) {
            a.ez = this.b.al.co;
        }
        a.cw = this.b.al.a6;
        a.a1 = this.b.al.aq;
        a.dx = this.b.al.bp;
        a.aw = this.b.al.an;
        a.gi = this.b.al.da;
        a.e4 = this.b.al.cs;
        if (this.b.al.toolTip != null) {
            a.da = this.b.al.toolTip;
        }
        a.h6 = this.b.al.en;
        a.h2 = this.b.al.ei;
        a.ax = this.b.al.ao;
        a.cx = this.b.al.a7;
        a.cy = this.b.al.a8;
        a.ay = this.b.al.ap;
        a.ej = this.b.al.cj();
        a.h3 = this.b.al.ej;
        a.legend = this.b.al.legend;
        a.legendItemTemplate = this.b.al.legendItemTemplate;
        a.legendItemBadgeTemplate = this.b.al.legendItemBadgeTemplate;
        a.al = this.b.al.al;
        a.ht = this.b.al.ef;
        a.hu = this.b.al.eg;
        a.c3 = this.b.al.ba;
        a.ak = this.b.al.ak;
        a.h4 = this.b.al.el;
        a.b5 = true;
        a.c1 = this.b.al.a9;
        a.bz = this.b.al.ax.av;
        a.b0 = this.b.al.ax.aw;
        a.a2 = this.b.al.ar;
        a.ec = this.b.al.b3;
        a.cn = this.b.al.ax.a1;
        return a;
    }
    l(a) {
        let b = this.e.item(a).rootWrapper;
        if (b != null) {
            b.show();
        }
        this.g.add(a);
    }
    n(a) {
        let b = this.e.item(a).rootWrapper;
        if (b != null) {
            b.hide();
        }
        this.g.remove(a);
    }
    m(a) {
        this.o(a);
        this.f.remove(a);
    }
    h() {
        return this.f;
    }
    r() {
    }
    aa() {
        this.b.aw();
    }
    t(a, b, c) {
        b = b + this.b.n;
        c = c + this.b.o;
        if (this.c != null) {
            b = b + this.c.n;
            c = c + this.c.o;
        }
        if (a.n != b || a.o != c) {
            a.n = b;
            a.o = c;
            this.u(a, this.e.item(a).rootWrapper);
        }
    }
    w(a) {
        if (a == null) {
            this.b.arcs.count = 0;
            for (let b of fromEnum(this.f)) {
                b.destroy();
            }
            this.f.clear();
            this.e.clear();
            this.g.clear();
            return;
        }
        this.i = a;
        this.i.rootWrapper.setStyleProperty("position", "relative");
        for (let c of fromEnum(this.f)) {
            let d = this.e.item(c);
            this.i.append(d.rootWrapper);
            c.h8.b7();
        }
        this.aa();
    }
    z(a) {
        let b = this.i.createElement("div");
        b.setStyleProperty("position", "absolute");
        this.e.addItem(a, this.i.getSubRenderer(b));
        this.k(a, b);
        this.u(a, b);
        if (this.i != null) {
            this.i.append(b);
        }
        a.provideContainer(this.e.item(a));
        b.setStyleProperty("position", "absolute");
    }
    k(a, b) {
        b.setStyleProperty("width", a.width.toString() + "px");
        b.setStyleProperty("height", a.height.toString() + "px");
    }
    u(a, b) {
        b.setStyleProperty("top", a.o.toString() + "px");
        b.setStyleProperty("left", a.n.toString() + "px");
    }
    o(a) {
        let b = this.e.item(a);
        b.rootWrapper.remove();
        this.e.removeItem(a);
        a.provideContainer(null);
    }
    ab(a) {
        this.k(a, a.ig().rootWrapper);
        a.fk(a.width, a.height);
    }
    d() {
        return this.i != null;
    }
    q() {
    }
    s(a) {
        this.c = a;
        if (a != null) {
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.y));
        }
    }
    y(a, b) {
        switch (b.propertyName) {
            case "LabelExtent":
                for (let c = 0; c < this.f.count; c++) {
                    this.f._inner[c].cw = b.newValue;
                }
                break;
            case "LabelMemberPath":
                for (let d = 0; d < this.f.count; d++) {
                    this.f._inner[d].dx = b.newValue;
                }
                break;
            case "LabelsPosition":
                for (let e = 0; e < this.f.count; e++) {
                    this.f._inner[e].aw = EnumUtil.getEnumValue(LabelsPosition_$type, b.newValue);
                }
                break;
            case "LabelTemplate":
                for (let f = 0; f < this.f.count; f++) {
                    this.f._inner[f].gi = b.newValue;
                }
                break;
            case "ValueMemberPath":
                for (let g = 0; g < this.f.count; g++) {
                    this.f._inner[g].e4 = b.newValue;
                }
                break;
            case "ToolTip":
                for (let h = 0; h < this.f.count; h++) {
                    this.f._inner[h].da = b.newValue;
                }
                break;
            case "LeaderLineVisibility":
                for (let i = 0; i < this.f.count; i++) {
                    this.f._inner[i].h6 = EnumUtil.getEnumValue(Visibility_$type, b.newValue);
                }
                break;
            case "LeaderLineStyle":
                for (let j = 0; j < this.f.count; j++) {
                    this.f._inner[j].h2 = b.newValue;
                }
                break;
            case "LeaderLineType":
                for (let k = 0; k < this.f.count; k++) {
                    this.f._inner[k].ax = EnumUtil.getEnumValue(LeaderLineType_$type, b.newValue);
                }
                break;
            case "LeaderLineMargin":
                for (let l = 0; l < this.f.count; l++) {
                    this.f._inner[l].cx = b.newValue;
                }
                break;
            case "OthersCategoryThreshold":
                for (let m = 0; m < this.f.count; m++) {
                    this.f._inner[m].cy = b.newValue;
                }
                break;
            case "OthersCategoryType":
                for (let n = 0; n < this.f.count; n++) {
                    this.f._inner[n].ay = EnumUtil.getEnumValue(OthersCategoryType_$type, b.newValue);
                }
                break;
            case "OthersCategoryText":
                for (let o = 0; o < this.f.count; o++) {
                    this.f._inner[o].ej = b.newValue;
                }
                break;
            case "OthersCategoryStyle":
                for (let p = 0; p < this.f.count; p++) {
                    this.f._inner[p].h3 = b.newValue;
                }
                break;
            case "Legend":
                for (let q = 0; q < this.f.count; q++) {
                    this.f._inner[q].legend = b.newValue;
                }
                break;
            case "LegendItemTemplate":
                for (let r = 0; r < this.f.count; r++) {
                    this.f._inner[r].legendItemTemplate = b.newValue;
                }
                break;
            case "LegendItemBadgeTemplate":
                for (let s = 0; s < this.f.count; s++) {
                    this.f._inner[s].legendItemBadgeTemplate = b.newValue;
                }
                break;
            case "Outlines":
                for (let t = 0; t < this.f.count; t++) {
                    this.f._inner[t].al = b.newValue;
                }
                break;
            case "Brushes":
                for (let u = 0; u < this.f.count; u++) {
                    this.f._inner[u].ak = b.newValue;
                }
                break;
            case "SelectedStyle":
                for (let v = 0; v < this.f.count; v++) {
                    this.f._inner[v].h4 = b.newValue;
                }
                break;
            case "SelectedStyleResolved":
                for (let w = 0; w < this.f.count; w++) {
                    this.f._inner[w].h4 = b.newValue;
                }
                break;
            case "RadiusFactor":
                for (let x = 0; x < this.f.count; x++) {
                    this.f._inner[x].c1 = b.newValue;
                }
                break;
        }
    }
    p() {
        for (let a of fromEnum(this.f)) {
            a.e9();
        }
    }
    j() {
        return this.i;
    }
    v(a, b) {
        this.b.n = a;
        this.b.o = b;
        this.x();
    }
    x() {
        for (let a = 0; a < this.f.count; a++) {
            let b = this.f._inner[a];
            this.t(b, 0, 0);
        }
    }
}
RingControlView.$t = markType(RingControlView, 'RingControlView');
/**
 * @hidden
 */
class RingSeriesBaseView extends Base {
    constructor(a) {
        super();
        this.c = null;
        this.f = null;
        this.g = null;
        this.a = null;
        this.b = null;
        this.o = null;
        this.d = null;
        this.f = new List$1(RingControl.$, 0);
        this.c = a;
    }
    k() {
        this.c.legendItemTemplate = ((() => {
            let $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.c;
            $ret.measure = PieLegendTemplates.a;
            return $ret;
        })());
        this.c.legendItemBadgeTemplate = ((() => {
            let $ret = new DataTemplate();
            $ret.render = PieLegendTemplates.b;
            $ret.measure = PieLegendTemplates.d;
            return $ret;
        })());
    }
    h(a) {
        if (!this.f.contains(a)) {
            this.f.add(a);
        }
        if (this.g != null && (a.ap() != this.g)) {
            a.ay(this.g);
        }
    }
    j(a, b, c, d, e) {
        let f = BrushUtil.e("chart", a, b, c);
        b = f.p2;
        c = f.p3;
        let g = new Array(b.count * 2);
        for (let h = 0; h < g.length; h += 2) {
            g[h] = "#fff";
            g[h + 1] = b.item(intDivide(h, 2))._fill;
        }
        let i = BrushUtil.e("doughnut", a, b, c, g);
        b = i.p2;
        c = i.p3;
        d = new Brush();
        d._fill = this.g.rootWrapper.getStyleProperty("color");
        e = FontUtil.getFont(a);
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    }
    n(a) {
        if (a == null) {
            for (let b of fromEnum(this.f)) {
                b.ay(null);
            }
            return;
        }
        this.g = a;
        let c;
        let d;
        let e;
        let f;
        let g = this.j(this.g, c, d, e, f);
        c = g.p1;
        d = g.p2;
        e = g.p3;
        f = g.p4;
        this.a = c;
        this.b = d;
        this.o = e;
        this.d = f;
        if (this.c.ak == null) {
            this.c.ak = this.a;
        }
        if (this.c.al == null) {
            this.c.al = this.b;
        }
        for (let h of fromEnum(this.f)) {
            h.ay(this.g);
        }
    }
    e() {
        return true;
    }
    i() {
        this.n(null);
    }
    l() {
        for (let a = 0; a < this.f.count; a++) {
            let b = this.f._inner[a];
            for (let c = 0; c < b.arcs.a.count; c++) {
                let d = b.arcs.a._inner[c];
                d.e9();
            }
        }
    }
    m(a, b) {
        this.c.n = a;
        this.c.o = b;
        this.c.eh = { $type: Point_$type, x: a, y: b };
    }
}
RingSeriesBaseView.$t = markType(RingSeriesBaseView, 'RingSeriesBaseView');
/**
 * @hidden
 */
class XamDoughnutChartView extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.aa = null;
        this.d = 0;
        this.c = null;
        this.ab = null;
        this.f = null;
        this.e = null;
        this.b = null;
        this.ab = Rect.empty;
        this.aa = { $type: Point_$type, x: 0, y: 0 };
        this.d = 0;
        this.c = new List$1(RingSeriesBase.$, 0);
        this.a = a;
    }
    s() {
        this.p();
    }
    z() {
    }
    h(a) {
        if (!this.c.contains(a)) {
            a.c5(this.e);
            this.c.add(a);
        }
    }
    w(a) {
        if (this.c.contains(a)) {
            a.c5(null);
            this.c.remove(a);
        }
    }
    i() {
    }
    y() {
        if (this.e == null) {
            return;
        }
        this.p();
        let a = this.e.rootWrapper.width();
        let b = this.e.rootWrapper.height();
        this.ab = new Rect(0, 0, 0, a, b);
        if (this.b != null) {
            this.b.bg = this.ab;
        }
        this.a.bt();
    }
    v(a) {
        if (a == null) {
            if (this.b != null) {
                this.b.ar();
            }
            return;
        }
        let b = a;
        this.e = b;
        let c = this.e.rootWrapper.width();
        let d = this.e.rootWrapper.height();
        this.ab = new Rect(0, 0, 0, c, d);
        this.b = new DOMEventProxy(this.e.rootWrapper, this.e, false);
        this.b.bg = this.ab;
        let e = this.b;
        e.onMouseOver = delegateCombine(e.onMouseOver, runOn(this, this.m));
        let f = this.b;
        f.onMouseLeave = delegateCombine(f.onMouseLeave, runOn(this, this.l));
        let g = this.b;
        g.onMouseDown = delegateCombine(g.onMouseDown, runOn(this, this.k));
        let h = this.b;
        h.onMouseUp = delegateCombine(h.onMouseUp, runOn(this, this.n));
        this.y();
    }
    t(a, b, c) {
        for (let d = this.c.count - 1; d >= 0; d--) {
            let e = this.c._inner[d];
            if (e.a4) {
                continue;
            }
            let f = e.aw.f;
            for (let g = 0; g < f.count; g++) {
                let h = f._inner[g];
                let i = h.arcs.a;
                for (let j = 0; j < i.count; j++) {
                    let k = i._inner[j];
                    let l = { $type: Point_$type, x: a.x - k.n, y: a.y - k.o };
                    b(k.a0, l);
                    if (c == "mouseUp") {
                        let m = k.h8.b5();
                        if (m != null) {
                            return;
                        }
                    }
                }
            }
        }
    }
    n(a) {
        this.t(a, (b, c) => b.ak(c), "mouseUp");
    }
    k(a) {
        this.t(a, (b, c) => b.ah(c), "mouseDown");
    }
    l(a) {
        this.t(a, (b, c) => b.ai(c), "mouseLeave");
    }
    m(a, b, c) {
        this.t(a, (d, e) => d.aj(e, b, c), "mouseOver");
    }
    g() {
        return this.e.rootWrapper.getAttribute("id");
    }
    u(a, b) {
        if (!this.ab.isEmpty && this.ab.width != 0 && this.ab.height != 0) {
            let c = this.aa.x;
            let d = this.aa.y;
            this.aa.x = this.ab.width / 2;
            this.aa.y = this.ab.height / 2;
            if (this.aa.x != c || this.aa.y != d) {
                this.a.bs();
            }
        }
    }
    x(a, b) {
        let c = this.d;
        this.d = a / 2;
        if (c != this.d) {
            this.a.bs();
        }
    }
    j() {
    }
    o(a) {
        a.width = this.a.width;
        a.height = this.a.height;
        a.holeRadius = this.a.a2();
        for (let b = 0; b < this.a.series.count; b++) {
            a.series.add(new RingSeriesVisualData());
            a.series._inner[b].rings = new RingVisualDataList();
            a.series._inner[b].name = this.a.series._inner[b].name;
            a.series._inner[b].labelExtent = this.a.series._inner[b].a6;
            a.series._inner[b].leaderLineMargin = this.a.series._inner[b].a7;
            a.series._inner[b].leaderLineType = EnumUtil.getName(LeaderLineType_$type, this.a.series._inner[b].ao);
            a.series._inner[b].labelsPosition = EnumUtil.getName(LabelsPosition_$type, this.a.series._inner[b].an);
            a.series._inner[b].leaderLineVisibility = this.a.series._inner[b].en == 0;
            for (let c = 0; c < this.a.series._inner[b].au().count; c++) {
                a.series._inner[b].rings.add(new RingVisualData());
                a.series._inner[b].rings._inner[c].arcs = new ArcVisualDataList();
                for (let d = 0; d < this.a.series._inner[b].au()._inner[c].g.count; d++) {
                    a.series._inner[b].rings._inner[c].arcs.add(new ArcVisualData());
                    a.series._inner[b].rings._inner[c].arcs._inner[d].a = new SliceVisualDataList();
                    for (let e = 0; e < this.a.series._inner[b].au()._inner[c].g._inner[d].g.count; e++) {
                        if (null == this.a.series._inner[b].au()._inner[c].g._inner[d].g._inner[e].b) {
                            continue;
                        }
                        a.series._inner[b].rings._inner[c].arcs._inner[d].a.add(new SliceVisualData());
                        let f = new SliceVisualData();
                        let g = this.a.series._inner[b].au()._inner[c].g._inner[d].g._inner[e].b;
                        f.visibility = g._visibility == 0;
                        f.endAngle = g.ax;
                        f.startAngle = g.a3;
                        f.radius = g.a2;
                        f.origin = PointData.b(g.b7);
                        f.explodedOrigin = PointData.b(g.b5);
                        f.index = g.a5;
                        f.isExploded = g.isExploded;
                        f.isSelected = g.isSelected;
                        f.outline = AppearanceHelper.a(g.b1);
                        f.backgroundPath = new PathVisualData(1, "slicePath", g.al.f());
                        a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e] = f;
                        let h = g.aj;
                        if (null != h) {
                            a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData = ((() => {
                                let $ret = new DoughnutChartLabelVisualData();
                                $ret.labelSize = SizeData.b(RectUtil.z(h.ao));
                                $ret.labelValue = h.aj.ak;
                                return $ret;
                            })());
                            if (!isNaN_(h.n) && !isNaN_(h.o)) {
                                a.series._inner[b].rings._inner[c].arcs._inner[d].a._inner[e].labelVisualData.labelPosition = new PointData(h.n, h.o);
                            }
                        }
                    }
                }
            }
        }
    }
    p() {
        let a = this.a.a4;
        let b = this.a.a1;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.a.a1 = window.devicePixelRatio;
        }
    }
    r() {
        if (this.b != null) {
            this.b.bc(this.e.rootWrapper, "");
        }
    }
    q() {
        this.p();
        if (this.b != null) {
            this.b.aq(this.e.rootWrapper, "");
        }
    }
}
XamDoughnutChartView.$t = markType(XamDoughnutChartView, 'XamDoughnutChartView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Contains PieChart click event data.
*/
class IgxSliceClickEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets whether the slice is selected.
    */
    get isSelected() {
        return this.i.isSelected;
    }
    set isSelected(v) {
        this.i.isSelected = ensureBool(v);
    }
    /**
     * Gets or sets whether the slice is exploded.
    */
    get isExploded() {
        return this.i.isExploded;
    }
    set isExploded(v) {
        this.i.isExploded = ensureBool(v);
    }
    /**
     * Gets whether the current slice is part of the others slice.
    */
    get isOthersSlice() {
        return this.i.isOthersSlice;
    }
    /**
     * Gets the index of the slice that was clicked.
    */
    get index() {
        return this.i.index;
    }
    /**
     * Gets the slice data context.
    */
    get dataContext() {
        return this.i.dataContext;
    }
    /**
     * Holds a reference to the original event that triggered slice click.
    */
    get originalEvent() {
        return this.i.originalEvent;
    }
    set originalEvent(v) {
        this.i.originalEvent = v;
    }
}

/**
 * EventArgs class holding information about the dimensions of a hole in a doughnut chart.
*/
class IgxHoleDimensionsChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The center point of the hole.
    */
    get center() {
        return fromPoint(this.i.center);
    }
    /**
     * The radius of the hole.
    */
    get radius() {
        return this.i.radius;
    }
}

/**
 * Represents a IgxRingSeriesBaseComponent base series.
*/
const IgxRingSeriesBaseComponent_PROVIDERS = [];
class IgxRingSeriesBaseComponent {
    constructor() {
        //
        this._dataSource = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._tooltipContainerTemplate = null;
        this._showDefaultTooltip = false;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._propertyUpdated = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    set dataSource(value) {
        this._dataSource = value;
        this.bindData();
    }
    get dataSource() {
        return this._dataSource;
    }
    bindData() {
        if (this.i != null && this.i !== undefined) {
            this.i.itemsSource = this._dataSource;
        }
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    get legend() {
        if (this.i.legend != null)
            return this.i.legend.externalObject;
    }
    set legend(v) {
        if (v != undefined && v != null)
            this.i.legend = v.i;
    }
    set tooltipTemplate(value) {
        this._tooltipTemplate = value;
        if (value == null) {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        }
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.template = this._tooltipTemplate;
        }
        else {
            if (this.owner != null) {
                this.owner._ensureTooltipCreated(this);
            }
        }
    }
    get tooltipTemplate() {
        return this._tooltipTemplate;
    }
    set tooltipContainerTemplate(value) {
        this._tooltipContainerTemplate = value;
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.containerTemplate = this._tooltipContainerTemplate;
        }
    }
    get tooltipContainerTemplate() {
        return this._tooltipContainerTemplate;
    }
    _ensureTooltipCreated(createTooltip, createWrapper) {
        if (this._tooltipTemplate == null) {
            this.i.toolTip = null;
        }
        if (this._tooltipContent == null && this._tooltipTemplate != null) {
            let tooltip = createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = createWrapper(tooltip.location.nativeElement);
        }
    }
    _ensureTooltipDestroyed() {
        if (this._tooltipContent !== null) {
            this._tooltipContent.destroy();
            this._tooltipContent = null;
        }
    }
    /**
     * Gets or sets whether default tooltip will be shown.
    */
    get showDefaultTooltip() {
        return this._showDefaultTooltip;
    }
    set showDefaultTooltip(v) {
        this._showDefaultTooltip = ensureBool(v);
    }
    sychronizeCollections() { }
    /**
 * Gets or Sets the property name that contains the values.
*/
    get valueMemberPath() {
        return this.i.cs;
    }
    set valueMemberPath(v) {
        this.i.cs = v;
    }
    /**
     * Gets or sets the property name that contains the labels.
    */
    get labelMemberPath() {
        return this.i.bp;
    }
    set labelMemberPath(v) {
        this.i.bp = v;
    }
    /**
     * Gets or sets the property name that contains the legend labels.
    */
    get legendLabelMemberPath() {
        return this.i.b3;
    }
    set legendLabelMemberPath(v) {
        this.i.b3 = v;
    }
    /**
     * Gets or sets the position of chart labels.
    */
    get labelsPosition() {
        return this.i.an;
    }
    set labelsPosition(v) {
        this.i.an = ensureEnum(LabelsPosition_$type, v);
    }
    /**
     * Gets or sets whether the leader lines are visible.
    */
    get leaderLineVisibility() {
        return this.i.en;
    }
    set leaderLineVisibility(v) {
        this.i.en = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the fill brush.
    */
    get leaderLineFill() {
        return this.i.ei ? this.i.ei.fill : null;
    }
    set leaderLineFill(v) {
        this.ensureLeaderLineStyle();
        this.i.ei.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get leaderLineStroke() {
        return this.i.ei ? this.i.ei.stroke : null;
    }
    set leaderLineStroke(v) {
        this.ensureLeaderLineStyle();
        this.i.ei.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get leaderLineStrokeThickness() {
        return this.i.ei ? this.i.ei.strokeThickness : NaN;
    }
    set leaderLineStrokeThickness(v) {
        this.ensureLeaderLineStyle();
        this.i.ei.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get leaderLineOpacity() {
        return this.i.ei ? this.i.ei.opacity : NaN;
    }
    set leaderLineOpacity(v) {
        this.ensureLeaderLineStyle();
        this.i.ei.opacity = +v;
    }
    ensureLeaderLineStyle() {
        if (this.i.ei) {
            return;
        }
        this.i.ei = new Style();
    }
    /**
     * Gets or sets what type of leader lines will be used for the outside end labels.
    */
    get leaderLineType() {
        return this.i.ao;
    }
    set leaderLineType(v) {
        this.i.ao = ensureEnum(LeaderLineType_$type, v);
    }
    /**
     * Gets or sets the margin between a label and its leader line. The default is 6 pixels.
    */
    get leaderLineMargin() {
        return this.i.a7;
    }
    set leaderLineMargin(v) {
        this.i.a7 = +v;
    }
    /**
     * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
    */
    get othersCategoryThreshold() {
        return this.i.a8;
    }
    set othersCategoryThreshold(v) {
        this.i.a8 = +v;
    }
    /**
     * Gets or sets whether to use numeric or percent-based threshold value.
    */
    get othersCategoryType() {
        return this.i.ap;
    }
    set othersCategoryType(v) {
        this.i.ap = ensureEnum(OthersCategoryType_$type, v);
    }
    /**
     * Gets or sets the label of the Others slice.
    */
    get othersCategoryText() {
        return this.i.ca;
    }
    set othersCategoryText(v) {
        this.i.ca = v;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
    */
    get formatLabel() {
        return this.i.aq;
    }
    set formatLabel(v) {
        this.i.aq = v;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
    */
    get formatLegendLabel() {
        return this.i.ar;
    }
    set formatLegendLabel(v) {
        this.i.ar = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get labelFormat() {
        return this.i.bl;
    }
    set labelFormat(v) {
        this.i.bl = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LabelFormat string.
    */
    get labelFormatSpecifiers() {
        return this.i.ag;
    }
    set labelFormatSpecifiers(v) {
        this.i.ag = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get othersLabelFormat() {
        return this.i.ce;
    }
    set othersLabelFormat(v) {
        this.i.ce = v;
    }
    /**
     * Gets or sets the format specifiers to use with the OthersLabelFormat string.
    */
    get othersLabelFormatSpecifiers() {
        return this.i.aj;
    }
    set othersLabelFormatSpecifiers(v) {
        this.i.aj = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get legendLabelFormat() {
        return this.i.b0;
    }
    set legendLabelFormat(v) {
        this.i.b0 = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LegendLabelFormat string.
    */
    get legendLabelFormatSpecifiers() {
        return this.i.ah;
    }
    set legendLabelFormatSpecifiers(v) {
        this.i.ah = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get legendOthersLabelFormat() {
        return this.i.b5;
    }
    set legendOthersLabelFormat(v) {
        this.i.b5 = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LegendOthersLabelFormat string.
    */
    get legendOthersLabelFormatSpecifiers() {
        return this.i.ai;
    }
    set legendOthersLabelFormatSpecifiers(v) {
        this.i.ai = v;
    }
    /**
     * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
    */
    get labelExtent() {
        return this.i.a6;
    }
    set labelExtent(v) {
        this.i.a6 = +v;
    }
    /**
     * Gets or sets the starting angle of the chart.
     * The default zero value is equivalent to 3 o'clock.
    */
    get startAngle() {
        return this.i.ba;
    }
    set startAngle(v) {
        this.i.ba = +v;
    }
    /**
     * Gets or sets the fill brush.
    */
    get othersCategoryFill() {
        return this.i.ej ? this.i.ej.fill : null;
    }
    set othersCategoryFill(v) {
        this.ensureOthersCategoryStyle();
        this.i.ej.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get othersCategoryStroke() {
        return this.i.ej ? this.i.ej.stroke : null;
    }
    set othersCategoryStroke(v) {
        this.ensureOthersCategoryStyle();
        this.i.ej.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get othersCategoryStrokeThickness() {
        return this.i.ej ? this.i.ej.strokeThickness : NaN;
    }
    set othersCategoryStrokeThickness(v) {
        this.ensureOthersCategoryStyle();
        this.i.ej.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get othersCategoryOpacity() {
        return this.i.ej ? this.i.ej.opacity : NaN;
    }
    set othersCategoryOpacity(v) {
        this.ensureOthersCategoryStyle();
        this.i.ej.opacity = +v;
    }
    ensureOthersCategoryStyle() {
        if (this.i.ej) {
            return;
        }
        this.i.ej = new Style();
    }
    /**
     * Gets or sets the fill brush.
    */
    get selectedSliceFill() {
        return this.i.ek ? this.i.ek.fill : null;
    }
    set selectedSliceFill(v) {
        this.ensureSelectedStyle();
        this.i.ek.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get selectedSliceStroke() {
        return this.i.ek ? this.i.ek.stroke : null;
    }
    set selectedSliceStroke(v) {
        this.ensureSelectedStyle();
        this.i.ek.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get selectedSliceStrokeThickness() {
        return this.i.ek ? this.i.ek.strokeThickness : NaN;
    }
    set selectedSliceStrokeThickness(v) {
        this.ensureSelectedStyle();
        this.i.ek.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get selectedSliceOpacity() {
        return this.i.ek ? this.i.ek.opacity : NaN;
    }
    set selectedSliceOpacity(v) {
        this.ensureSelectedStyle();
        this.i.ek.opacity = +v;
    }
    ensureSelectedStyle() {
        if (this.i.ek) {
            return;
        }
        this.i.ek = new Style();
    }
    /**
     * Gets or sets the palette of brushes to use for coloring the slices.
    */
    get brushes() {
        return fromBrushCollection(this.i.ak);
    }
    set brushes(v) {
        this.i.ak = toBrushCollection(v);
    }
    /**
     * Gets or sets the palette of brushes to use for outlines on the slices.
    */
    get outlines() {
        return fromBrushCollection(this.i.al);
    }
    set outlines(v) {
        this.i.al = toBrushCollection(v);
    }
    /**
     * Gets or sets the color for labels rendered outside of the pie chart.
    */
    get labelOuterColor() {
        return brushToString(this.i.eg);
    }
    set labelOuterColor(v) {
        this.i.eg = stringToBrush(v);
    }
    /**
     * Gets or sets the color for labels rendered inside of the pie chart.
    */
    get labelInnerColor() {
        return brushToString(this.i.ef);
    }
    set labelInnerColor(v) {
        this.i.ef = stringToBrush(v);
    }
    /**
     * Gets or sets whether all surface interactions with the plot area should be disabled.
    */
    get isSurfaceInteractionDisabled() {
        return this.i.a3;
    }
    set isSurfaceInteractionDisabled(v) {
        this.i.a3 = ensureBool(v);
    }
    /**
     * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
    */
    get radiusFactor() {
        return this.i.a9;
    }
    set radiusFactor(v) {
        this.i.a9 = +v;
    }
    findByName(name) {
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        if (this.labelFormatSpecifiers != null && arrayFindByName(this.labelFormatSpecifiers, name)) {
            return arrayFindByName(this.labelFormatSpecifiers, name);
        }
        if (this.othersLabelFormatSpecifiers != null && arrayFindByName(this.othersLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.othersLabelFormatSpecifiers, name);
        }
        if (this.legendLabelFormatSpecifiers != null && arrayFindByName(this.legendLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.legendLabelFormatSpecifiers, name);
        }
        if (this.legendOthersLabelFormatSpecifiers != null && arrayFindByName(this.legendOthersLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.legendOthersLabelFormatSpecifiers, name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("RingSeriesBaseComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    provideContainer(container) {
        this.i.c5(container);
    }
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    get propertyUpdated() {
        if (this._propertyUpdated == null) {
            this._propertyUpdated = new EventEmitter();
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPropertyUpdatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePropertyUpdated) {
                        this.beforePropertyUpdated(this, outerArgs);
                    }
                    this._propertyUpdated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._propertyUpdated;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxRingSeriesBaseComponent.prototype, "legend", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxRingSeriesBaseComponent.prototype, "tooltipTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxRingSeriesBaseComponent.prototype, "tooltipContainerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxRingSeriesBaseComponent.prototype, "showDefaultTooltip", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "legendLabelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "labelsPosition", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "leaderLineVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "leaderLineFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "leaderLineStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "leaderLineStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "leaderLineOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "leaderLineType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "leaderLineMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryThreshold", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryText", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxRingSeriesBaseComponent.prototype, "formatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxRingSeriesBaseComponent.prototype, "formatLegendLabel", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "labelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "labelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "othersLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "othersLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "legendLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "legendLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "legendOthersLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "legendOthersLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "labelExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "startAngle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "othersCategoryOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "selectedSliceFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "selectedSliceStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "selectedSliceStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "selectedSliceOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "brushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxRingSeriesBaseComponent.prototype, "outlines", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "labelOuterColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRingSeriesBaseComponent.prototype, "labelInnerColor", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxRingSeriesBaseComponent.prototype, "isSurfaceInteractionDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRingSeriesBaseComponent.prototype, "radiusFactor", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxRingSeriesBaseComponent.prototype, "propertyUpdated", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgxRingSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxRingSeriesBaseComponent.$type) {
            IgxRingSeriesBaseComponent.$type = markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxRingSeriesBaseComponent.$type) {
            IgxRingSeriesBaseComponent.$type = markType(IgxRingSeriesBaseComponent, "IgxRingSeriesBaseComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxRingSeriesBaseComponent.$type, RingSeriesBase.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxRingSeriesBaseComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/**
 * DataContext for a pie slice.
*/
class IgxPieSliceDataContext extends IgxDataContext {
    createImplementation() {
        return new PieSliceDataContext();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets or sets the value of this slice as a percentage of the total pie.
    */
    get percentValue() {
        return this.i.percentValue;
    }
    set percentValue(v) {
        this.i.percentValue = +v;
    }
    /**
     * Gets or sets whether this slice is an Others slice or not.
    */
    get isOthersSlice() {
        return this.i.isOthersSlice;
    }
    set isOthersSlice(v) {
        this.i.isOthersSlice = ensureBool(v);
    }
}

const IgxDoughnutChartComponent_PROVIDERS = [];
/**
 * Represents concentric circles divided on arcs  depending on data.
*/
let IgxDoughnutChartComponent = class IgxDoughnutChartComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        this.actualSeries = [];
        this._seriesAdapter = null;
        this._series = null;
        this._defaultTooltips = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._sliceClick = null;
        this._holeDimensionsChanged = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        this._zoneRunner = (act) => ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(_elRef.element.nativeElement, this.container);
        renderer.setStyle(this.container, "display", "block");
        renderer.setStyle(this.container, "width", "100%");
        renderer.setStyle(this.container, "height", "100%");
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        var chart = this.i;
        this._chart = chart;
        this._seriesAdapter = new CollectionAdapter([], this.i.series, this.actualSeries, (c) => c.i, (i) => {
            i.owner = this;
            // (<any>i)._provideRenderer(this._dataSource);
            if (this.container && this.container.parentElement) {
                i._styling(this.container, this, this);
            }
            this._ensureDefaultTooltip(i);
            this._ensureTooltipCreated(i);
        }, (i) => {
            //(<any>i)._provideRenderer(null);
        });
        chart.provideContainer(ren);
        ren.addSizeWatcher(() => {
            this._chart.notifyResized();
        });
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._chart.notifyResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._chart.notifyResized();
    }
    get width() {
        return this._width;
    }
    ngOnDestroy() {
        this._chart.destroy();
        this._wrapper.destroy();
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new XamDoughnutChart();
    }
    get i() {
        return this._implementation;
    }
    createSeriesComponent(type) {
        if (TypeRegistrar.isRegistered(type)) {
            let s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this._wrapper);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    }
    ngAfterContentInit() {
        if (TypeRegistrar.isRegistered("IgxDoughnutChartDefaultTooltipsComponent")) {
            let c = TypeRegistrar.get("IgxDoughnutChartDefaultTooltipsComponent");
            let cf = this.componentFactoryResolver.resolveComponentFactory(c);
            let cr = this._dynamicContent.createComponent(cf);
            this._defaultTooltips = cr;
            cr.instance.onContentReady.subscribe(() => {
                this._onDefaultTooltipsReady(cr);
            });
        }
        this._seriesAdapter.updateQuery(this.contentSeries);
        this._styling(this.container, this);
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i]._styling(this.container, this, this);
            }
        }
        this.i.notifyResized();
    }
    /**
     * A collection or manually added series for the chart.
    */
    get series() {
        if (this._series === null) {
            let coll = new IgxRingSeriesCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._seriesAdapter.addManualItem(e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._seriesAdapter.clearManualItems();
                        break;
                }
            });
            this._series = coll;
        }
        return this._series;
    }
    _ensureTooltipCreated(series) {
        series._ensureTooltipCreated(() => this.createTooltip(), (ele) => {
            let wrapper = new AngularWrapper(ele, this.renderer, this.ngZone);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        });
    }
    _ensureDefaultTooltip(series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](series);
    }
    _onDefaultTooltipsReady(cr) {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                if (currSeries[i].showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries[i]);
                }
            }
        }
    }
    createTooltip() {
        if (!TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
            return null;
        }
        let t = TypeRegistrar.get("IgxTooltipContainerComponent");
        let cf = this.componentFactoryResolver.resolveComponentFactory(t);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        let self = this;
        ele.updateToolTip = function (c) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                let ext = new IgxPieSliceDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (ele.parentElement != self.container) {
                if (ele.parentElement != null) {
                    ele.parentElement.removeChild(ele);
                }
                self.container.appendChild(ele);
            }
            cr.instance.context = c;
            if (c.series.showDefaultTooltip) {
                var tooltipContainers = ele.getElementsByClassName("ui-tooltip-container");
                if (tooltipContainers.length > 0)
                    tooltipContainers[0].style.borderColor = c.i.slice.background.fill;
            }
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    }
    /**
 * Gets or sets whether the slices can be selected.
*/
    get allowSliceSelection() {
        return this.i.aw;
    }
    set allowSliceSelection(v) {
        this.i.aw = ensureBool(v);
    }
    /**
     * Gets or sets whether all surface interactions with the plot area should be disabled.
    */
    get isSurfaceInteractionDisabled() {
        return this.i.ax;
    }
    set isSurfaceInteractionDisabled(v) {
        this.i.ax = ensureBool(v);
    }
    /**
     * Gets or sets whether the slices can be exploded.
    */
    get allowSliceExplosion() {
        return this.i.av;
    }
    set allowSliceExplosion(v) {
        this.i.av = ensureBool(v);
    }
    /**
     * Gets or sets the inner extent of the doughnut chart. It is percent from the outer ring's radius.
    */
    get innerExtent() {
        return this.i.a3;
    }
    set innerExtent(v) {
        this.i.a3 = +v;
    }
    /**
     * Gets or sets the fill brush.
    */
    get selectedSliceFill() {
        return this.i.cg ? this.i.cg.fill : null;
    }
    set selectedSliceFill(v) {
        this.ensureSelectedStyle();
        this.i.cg.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get selectedSliceStroke() {
        return this.i.cg ? this.i.cg.stroke : null;
    }
    set selectedSliceStroke(v) {
        this.ensureSelectedStyle();
        this.i.cg.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get selectedSliceStrokeThickness() {
        return this.i.cg ? this.i.cg.strokeThickness : NaN;
    }
    set selectedSliceStrokeThickness(v) {
        this.ensureSelectedStyle();
        this.i.cg.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get selectedSliceOpacity() {
        return this.i.cg ? this.i.cg.opacity : NaN;
    }
    set selectedSliceOpacity(v) {
        this.ensureSelectedStyle();
        this.i.cg.opacity = +v;
    }
    ensureSelectedStyle() {
        if (this.i.cg) {
            return;
        }
        this.i.cg = new Style();
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.a4;
    }
    set pixelScalingRatio(v) {
        this.i.a4 = +v;
    }
    /**
     * Resolved pixel scaling ratio. Unless explicitly overridden by the IgxDoughnutChart.PixelScalingRatioComponent property,
     * this one returns the default ratio enforced by device. High resolution devices will initialize this property
     * to a higher value.
    */
    get actualPixelScalingRatio() {
        return this.i.a1;
    }
    set actualPixelScalingRatio(v) {
        this.i.a1 = +v;
    }
    findByName(name) {
        if (this.series != null && this.series.findByName && this.series.findByName(name)) {
            return this.series.findByName(name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DoughnutChartComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    /**
     * Called when the control has been resized.
    
    */
    notifyResized() {
        this.i.notifyResized();
    }
    /**
     * Gets the ID of the UI container.
    
    */
    getContainerID() {
        let iv = this.i.bd();
        return (iv);
    }
    /**
     * Gets the center coordinates of the doughnut chart's center presenter.
    
    */
    getCenterCoordinates() {
        let iv = this.i.cf();
        return fromPoint(iv);
    }
    /**
     * Gets the hole radius of the doughnut chart's center presenter.
    
    */
    getHoleRadius() {
        let iv = this.i.a2();
        return (iv);
    }
    /**
     * Use to force the doughnut chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the doughnut chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the doughnut chart.
    
    */
    flush() {
        this.i.bk();
    }
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    exportSerializedVisualData() {
        let iv = this.i.bc();
        return (iv);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.bm(source_, index, newItem);
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.bp(source_, index, oldItem, newItem);
    }
    /**
     * Used to manually notify the chart that the data source has reset or cleared its items.
    
    */
    notifyClearItems(source_) {
        this.i.bl(source_);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.bn(source_, index, oldItem);
    }
    /**
     * Raised when the slice is clicked.
    */
    get sliceClick() {
        if (this._sliceClick == null) {
            this._sliceClick = new EventEmitter();
            this.i.sliceClick = delegateCombine(this.i.sliceClick, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSliceClickEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSliceClick) {
                        this.beforeSliceClick(this, outerArgs);
                    }
                    this._sliceClick.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._sliceClick;
    }
    /**
     * Raised when the dimensions (center point or radius) of the doughnut hole change.
    */
    get holeDimensionsChanged() {
        if (this._holeDimensionsChanged == null) {
            this._holeDimensionsChanged = new EventEmitter();
            this.i.holeDimensionsChanged = delegateCombine(this.i.holeDimensionsChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxHoleDimensionsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeHoleDimensionsChanged) {
                        this.beforeHoleDimensionsChanged(this, outerArgs);
                    }
                    this._holeDimensionsChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._holeDimensionsChanged;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    ContentChildren(IgxRingSeriesBaseComponent),
    __metadata("design:type", QueryList)
], IgxDoughnutChartComponent.prototype, "contentSeries", void 0);
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxDoughnutChartComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDoughnutChartComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDoughnutChartComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDoughnutChartComponent.prototype, "allowSliceSelection", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDoughnutChartComponent.prototype, "isSurfaceInteractionDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDoughnutChartComponent.prototype, "allowSliceExplosion", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDoughnutChartComponent.prototype, "innerExtent", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDoughnutChartComponent.prototype, "selectedSliceFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDoughnutChartComponent.prototype, "selectedSliceStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDoughnutChartComponent.prototype, "selectedSliceStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDoughnutChartComponent.prototype, "selectedSliceOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDoughnutChartComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDoughnutChartComponent.prototype, "actualPixelScalingRatio", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartComponent.prototype, "sliceClick", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartComponent.prototype, "holeDimensionsChanged", null);
IgxDoughnutChartComponent = __decorate([
    Component({
        selector: 'igx-doughnut-chart',
        template: `<ng-container #dynamicContent></ng-container>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxDoughnutChartComponent_PROVIDERS,
        host: { 'class': 'ig-doughnut-chart igx-doughnut-chart' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxDoughnutChartComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgxDoughnutChartDefaultTooltipsComponent_1;
let IgxDoughnutChartDefaultTooltipsComponent = IgxDoughnutChartDefaultTooltipsComponent_1 = class IgxDoughnutChartDefaultTooltipsComponent {
    constructor(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    ensureDefaultTooltip(series) {
        if (series.showDefaultTooltip) {
            series.tooltipTemplate = this.doughnutSliceTooltip;
        }
        else {
            if (series.tooltipTemplate === this.doughnutSliceTooltip) {
                series.tooltipTemplate = null;
            }
        }
    }
    getSliceLabel(series, item) {
        return item[series.labelMemberPath];
    }
    getValue(series, item) {
        return item[this.getValueMemberPath(series)];
    }
    getValueMemberPath(series) {
        return series.valueMemberPath;
    }
    getBrush(i) {
        if (i.slice.background)
            return i.slice.background.fill;
        return "black";
    }
    static register() {
        TypeRegistrar.registerCons("IgxDoughnutChartDefaultTooltipsComponent", IgxDoughnutChartDefaultTooltipsComponent_1);
    }
    ngAfterContentInit() {
        this.onContentReady.emit({});
    }
};
__decorate([
    ViewChild("doughnutSliceTooltip", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxDoughnutChartDefaultTooltipsComponent.prototype, "doughnutSliceTooltip", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], IgxDoughnutChartDefaultTooltipsComponent.prototype, "onContentReady", void 0);
IgxDoughnutChartDefaultTooltipsComponent = IgxDoughnutChartDefaultTooltipsComponent_1 = __decorate([
    Component({
        selector: 'igx-dougnut-chart-default-tooltips',
        changeDetection: ChangeDetectionStrategy.OnPush,
        template: `
    <ng-template #doughnutSliceTooltip let-series="series" let-item="item" let-implementation="i">
        <div class='ui-chart-default-tooltip-content'>            
            <span [style.color]="getBrush(implementation)">{{getSliceLabel(series, item)}}</span>
            <br/>
            <span class="ui-tooltip-priority">{{getValueMemberPath(series)}} : {{getValue(series, item)}}</span>
        </div>
    </ng-template>
  `,
        styles: []
    }),
    __metadata("design:paramtypes", [ChangeDetectorRef])
], IgxDoughnutChartDefaultTooltipsComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartInteractivityModule = class IgxDoughnutChartInteractivityModule {
    constructor() {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        IgxDoughnutChartDefaultTooltipsComponent.register();
    }
};
IgxDoughnutChartInteractivityModule = __decorate([
    NgModule({
        declarations: [IgxDoughnutChartDefaultTooltipsComponent],
        exports: [IgxDoughnutChartDefaultTooltipsComponent,
            IgxDVInteractivityModule
        ],
        imports: [CommonModule, IgxDVInteractivityModule
        ],
        entryComponents: [IgxDoughnutChartDefaultTooltipsComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartInteractivityModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartInteractivityDynamicModule = class IgxDoughnutChartInteractivityDynamicModule {
    constructor() {
        TypeRegistrar.register('InteractivityFactoryManager', InteractivityFactoryManager.$type);
        InteractivityFactoryManager.register();
        IgxDoughnutChartDefaultTooltipsComponent.register();
    }
};
IgxDoughnutChartInteractivityDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDVInteractivityDynamicModule,
            IgxDoughnutChartInteractivityModule
        ],
        imports: [CommonModule, IgxDVInteractivityDynamicModule,
            IgxDoughnutChartInteractivityModule
        ],
        entryComponents: [IgxDoughnutChartDefaultTooltipsComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartInteractivityDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents data for Ring.RingControl element.
*/
class IgxRing {
    createImplementation() {
        return new Ring();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the index of ring in the chart.
    */
    get index() {
        return this.i.j;
    }
    set index(v) {
        this.i.j = +v;
    }
    /**
     * Gets the inner extend of the ring in percentage.
    */
    get innerExtend() {
        return this.i.h;
    }
    set innerExtend(v) {
        this.i.h = +v;
    }
    /**
     * Gets the size of the ring.
    */
    get controlSize() {
        return fromSize(this.i.q);
    }
    set controlSize(v) {
        this.i.q = toSize(v);
    }
    /**
     * Gets the center point of the ring.
    */
    get center() {
        return fromPoint(this.i.p);
    }
    set center(v) {
        this.i.p = toPoint(v);
    }
    /**
     * Gets reference to ring series.
    */
    get ringSeries() {
        if (this.i.c == null) {
            return null;
        }
        if (!this.i.c.externalObject) {
            let e = IgxRingSeriesBaseComponent._createFromInternal(this.i.c);
            if (e) {
                e._implementation = this.i.c;
            }
            this.i.c.externalObject = e;
        }
        return this.i.c.externalObject;
    }
    set ringSeries(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    /**
     * Gets the ring breadth.
    */
    get ringBreadth() {
        return this.i.i;
    }
    set ringBreadth(v) {
        this.i.i = +v;
    }
    findByName(name) {
        if (this.ringSeries && this.ringSeries.name && this.ringSeries.name == name) {
            return this.ringSeries;
        }
        return null;
    }
    /**
     * Renders the arcs.
    
    */
    renderArcs() {
        let iv = this.i.f();
        return (iv);
    }
    /**
     * Prepares data needed to create Arcs.
    
    */
    prepareArcs() {
        this.i.o();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RingSeries extends RingSeriesBase {
    constructor() {
        super();
        this.eo = null;
        this.eo = ((() => {
            let $ret = new Ring();
            $ret.c = this;
            $ret.e = false;
            return $ret;
        })());
        let a = ((() => {
            let $ret = new ArcItem();
            $ret.k = this.ba;
            $ret.d = this.eo;
            $ret.n = this.cs;
            $ret.c = this.ap;
            $ret.j = this.a8;
            return $ret;
        })());
        this.eo.g.add(a);
        this.ab = RingSeries.$;
    }
    c4(a, b, c, d) {
        super.c4(a, b, c, d);
        if (b == RingSeriesBase.$$p[6]) {
            for (let e = 0; e < this.eo.ringControl.arcs.count; e++) {
                this.eo.ringControl.arcs.item(e).dt = d;
            }
        }
        if (b == RingSeriesBase.$$p[7]) {
            for (let f = 0; f < this.eo.ringControl.arcs.count; f++) {
                this.eo.ringControl.arcs.item(f).ag = d;
            }
        }
        if (b == RingSeriesBase.$$p[28]) {
            for (let g = 0; g < this.eo.ringControl.arcs.count; g++) {
                this.eo.ringControl.arcs.item(g).en = d;
            }
        }
        if (b == RingSeriesBase.$$p[29]) {
            for (let h = 0; h < this.eo.ringControl.arcs.count; h++) {
                this.eo.ringControl.arcs.item(h).aj = d;
            }
        }
        if (b == RingSeriesBase.$$p[18]) {
            for (let i = 0; i < this.eo.ringControl.arcs.count; i++) {
                this.eo.ringControl.arcs.item(i).d9 = d;
            }
        }
        if (b == RingSeriesBase.$$p[19]) {
            for (let j = 0; j < this.eo.ringControl.arcs.count; j++) {
                this.eo.ringControl.arcs.item(j).ah = d;
            }
        }
        if (b == RingSeriesBase.$$p[21]) {
            for (let k = 0; k < this.eo.ringControl.arcs.count; k++) {
                this.eo.ringControl.arcs.item(k).ee = d;
            }
        }
        if (b == RingSeriesBase.$$p[22]) {
            for (let l = 0; l < this.eo.ringControl.arcs.count; l++) {
                this.eo.ringControl.arcs.item(l).ai = d;
            }
        }
        if (b == RingSeriesBase.$$p[2]) {
            for (let m = 0; m < this.eo.ringControl.arcs.count; m++) {
                this.eo.ringControl.arcs.item(m).a1 = d;
            }
        }
        if (b == RingSeriesBase.$$p[3]) {
            for (let n = 0; n < this.eo.ringControl.arcs.count; n++) {
                this.eo.ringControl.arcs.item(n).a2 = d;
            }
        }
        if (b == RingSeriesBase.$$p[20]) {
            for (let o = 0; o < this.eo.ringControl.arcs.count; o++) {
                this.eo.ringControl.arcs.item(o).ec = this.b3;
            }
        }
        if (b == RingSeriesBase.$$p[0]) {
            this.c2();
        }
        if (b == RingSeriesBase.$$p[33]) {
            if (this.eo.g != null && this.eo.g.count > 0) {
                this.eo.g._inner[0].k = this.ba;
            }
        }
        if (b == RingSeriesBase.$$p[36]) {
            if (this.eo.g != null && this.eo.g.count > 0) {
                this.eo.g._inner[0].n = this.cs;
                this.c3();
            }
        }
        if (this.eo != null && this.aw.e()) {
            this.eo.o();
            if (this.eo.f()) {
                this.eo.c.aw.l();
            }
        }
    }
    au() {
        let a = new RingCollection();
        if (this.eo.g._inner[0].g.count > 0) {
            a.add(this.eo);
        }
        return a;
    }
    c3() {
        if (this.eo != null) {
            this.eo.g._inner[0].h = this.itemsSource;
            this.eo.g._inner[0].p(this.ba);
            if (this.ax != null) {
                this.ax.bx();
                this.ax.b2();
            }
        }
    }
    c2() {
        if (this.eo != null) {
            this.eo.g._inner[0].a = this.ak;
        }
    }
    c8() {
        if (this.eo != null) {
            this.width = this.eo.q.width;
            this.height = this.eo.q.height;
            this.aw.m(this.eo.p.x, this.eo.p.y);
        }
    }
    c7() {
        if (this.eo != null) {
            for (let a of fromEnum(this.eo.ringControl.arcs.a)) {
                a.f4();
            }
        }
    }
    cy(a, b) {
        super.cy(a, b);
        if (this.eo != null) {
            this.eo.l(this.itemsSource, a, b);
        }
    }
    cx() {
        super.cx();
        if (this.eo != null) {
            this.eo.k(this.itemsSource);
        }
    }
    cz(a, b) {
        super.cz(a, b);
        if (this.eo != null) {
            this.eo.m(this.itemsSource, a, b);
        }
    }
    c0(a, b, c) {
        super.c0(a, b, c);
        if (this.eo != null) {
            this.eo.n(this.itemsSource, a, b, c);
        }
    }
}
RingSeries.$t = markType(RingSeries, 'RingSeries', RingSeriesBase.$);

class IgxIndexCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return +item;
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(Number_$type, Number_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

var IgxRingSeriesComponent_1;
const IgxRingSeriesComponent_PROVIDERS = [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxRingSeriesComponent) }];
/**
 * Represents one ring in IgxDoughnutChartComponent series.
*/
let IgxRingSeriesComponent = IgxRingSeriesComponent_1 = class IgxRingSeriesComponent extends IgxRingSeriesBaseComponent {
    constructor() {
        super();
        this._explodedSlices = null;
        this._selectedSlices = null;
    }
    createImplementation() {
        return new RingSeries();
    }
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the collection of exploded slice indices.
    */
    get explodedSlices() {
        if (this._explodedSlices === null) {
            let coll = new IgxIndexCollection();
            let innerColl;
            if (this.ring.i.ringControl.arcs.count == 0) {
                innerColl = new IndexCollection();
            }
            else {
                innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
            }
            this._explodedSlices = coll._fromInner(innerColl);
        }
        return this._explodedSlices;
    }
    set explodedSlices(v) {
        if (this._explodedSlices !== null) {
            this._explodedSlices._setSyncTarget(null);
            this._explodedSlices = null;
        }
        let coll = new IgxIndexCollection();
        this._explodedSlices = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Number_$type);
        let innerColl;
        if (this.ring.i.ringControl.arcs.count == 0) {
            innerColl = new IndexCollection();
        }
        else {
            innerColl = this.ring.i.ringControl.arcs.item(0).explodedSlices;
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._explodedSlices._setSyncTarget(syncColl);
    }
    /**
     * Gets or sets the collection of selected slice indices.
    */
    get selectedSlices() {
        if (this._selectedSlices === null) {
            let coll = new IgxIndexCollection();
            let innerColl;
            if (this.ring.i.ringControl.arcs.count == 0) {
                innerColl = new IndexCollection();
            }
            else {
                innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
            }
            this._selectedSlices = coll._fromInner(innerColl);
        }
        return this._selectedSlices;
    }
    set selectedSlices(v) {
        if (this._selectedSlices !== null) {
            this._selectedSlices._setSyncTarget(null);
            this._selectedSlices = null;
        }
        let coll = new IgxIndexCollection();
        this._selectedSlices = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Number_$type);
        let innerColl;
        if (this.ring.i.ringControl.arcs.count == 0) {
            innerColl = new IndexCollection();
        }
        else {
            innerColl = this.ring.i.ringControl.arcs.item(0).selectedSlices;
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedSlices._setSyncTarget(syncColl);
    }
    sychronizeCollections() {
        if (this._explodedSlices) {
            let inner = this._explodedSlices._inner;
            if (inner && inner !== this.ring.i.ringControl.arcs.item(0).explodedSlices) {
                this._explodedSlices._inner = this.ring.i.ringControl.arcs.item(0).explodedSlices;
                for (var i = 0; i < inner.count; i++) {
                    this._explodedSlices.add(inner.item(i));
                }
            }
        }
        if (this._selectedSlices) {
            let inner = this._selectedSlices._inner;
            if (inner && inner !== this.ring.i.ringControl.arcs.item(0).selectedSlices) {
                this._selectedSlices._inner = this.ring.i.ringControl.arcs.item(0).selectedSlices;
                for (var i = 0; i < inner.count; i++) {
                    this._selectedSlices.add(inner.item(i));
                }
            }
        }
    }
    /**
 * Gets reference to the ring data.
*/
    get ring() {
        if (this.i.eo == null) {
            return null;
        }
        if (!this.i.eo.externalObject) {
            let e = new IgxRing();
            e._implementation = this.i.eo;
            this.i.eo.externalObject = e;
        }
        return this.i.eo.externalObject;
    }
    set ring(v) {
        v == null ? this.i.eo = null : this.i.eo = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.ring && this.ring.name && this.ring.name == name) {
            return this.ring;
        }
        return null;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxIndexCollection),
    __metadata("design:paramtypes", [IgxIndexCollection])
], IgxRingSeriesComponent.prototype, "explodedSlices", null);
__decorate([
    Input(),
    __metadata("design:type", IgxIndexCollection),
    __metadata("design:paramtypes", [IgxIndexCollection])
], IgxRingSeriesComponent.prototype, "selectedSlices", null);
__decorate([
    Input(),
    __metadata("design:type", IgxRing),
    __metadata("design:paramtypes", [IgxRing])
], IgxRingSeriesComponent.prototype, "ring", null);
IgxRingSeriesComponent = IgxRingSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-ring-series',
        template: ``,
        providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxRingSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRingSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRingSeriesModule = class IgxRingSeriesModule {
};
IgxRingSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRingSeriesComponent],
        imports: [CommonModule],
        exports: [IgxRingSeriesComponent],
        entryComponents: []
    })
], IgxRingSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRingSeriesDynamicModule = class IgxRingSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRingSeriesComponent", IgxRingSeriesComponent);
        TypeRegistrar.register("RingSeries", RingSeries.$type);
    }
};
IgxRingSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRingSeriesModule],
        exports: [IgxRingSeriesModule],
        entryComponents: [IgxRingSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRingSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartCoreModule = class IgxDoughnutChartCoreModule {
    constructor() {
    }
};
IgxDoughnutChartCoreModule = __decorate([
    NgModule({
        declarations: [IgxDoughnutChartComponent],
        exports: [IgxRingSeriesModule,
            IgxDoughnutChartComponent
        ],
        imports: [CommonModule, IgxRingSeriesModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartCoreDynamicModule = class IgxDoughnutChartCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxDoughnutChartComponent', IgxDoughnutChartComponent);
    }
};
IgxDoughnutChartCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxRingSeriesDynamicModule,
            IgxDoughnutChartCoreModule
        ],
        imports: [CommonModule, IgxRingSeriesDynamicModule,
            IgxDoughnutChartCoreModule
        ],
        entryComponents: [IgxDoughnutChartComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDoughnutChartCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartModule = class IgxDoughnutChartModule {
};
IgxDoughnutChartModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDoughnutChartInteractivityModule,
            IgxDoughnutChartCoreModule
        ],
        imports: [CommonModule, IgxDoughnutChartInteractivityModule,
            IgxDoughnutChartCoreModule
        ],
        entryComponents: []
    })
], IgxDoughnutChartModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDoughnutChartDynamicModule = class IgxDoughnutChartDynamicModule {
};
IgxDoughnutChartDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDoughnutChartInteractivityDynamicModule,
            IgxDoughnutChartCoreDynamicModule,
            IgxDoughnutChartModule
        ],
        imports: [CommonModule, IgxDoughnutChartInteractivityDynamicModule,
            IgxDoughnutChartCoreDynamicModule,
            IgxDoughnutChartModule
        ],
        entryComponents: []
    })
], IgxDoughnutChartDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Node$1 extends Base {
    constructor(a, b) {
        super();
        this.a = null;
        this.b = null;
        this.a = b;
        this.b = a;
    }
}
Node$1.$t = markType(Node$1, 'Node');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IgQueue$1 extends Base {
    constructor($t) {
        super();
        this.$t = null;
        this.e = 0;
        this.b = null;
        this.a = null;
        this.c = null;
        this.$t = $t;
        this.$type = this.$type.specialize(this.$t);
    }
    get d() {
        return (this.e == 0);
    }
    get f() {
        return this.e;
    }
    h(a) {
        if (this.e == 0) {
            this.b = this.a = new Node$1(a, this.b);
        }
        else {
            this.a.a = new Node$1(a, this.a.a);
            this.a = this.a.a;
        }
        this.e++;
    }
    g(a) {
        this.c = this.b;
        if (this.e == 0) {
            throw new BaseError(1, "tried to serve from an empty Queue");
        }
        this.b = this.b.a;
        this.e--;
        a = typeCast(this.$t, this.c.b);
        return {
            p0: a
        };
    }
}
IgQueue$1.$t = markType(IgQueue$1, 'IgQueue$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HierarchicalRingSeries extends RingSeriesBase {
    constructor() {
        super();
        this.ep = null;
        this.ab = HierarchicalRingSeries.$;
    }
    au() {
        if (this.itemsSource == null) {
            return new RingCollection();
        }
        this.ep = this.eq(this.itemsSource);
        return this.ep;
    }
    c4(a, b, c, d) {
        super.c4(a, b, c, d);
        switch (b) {
            case RingSeriesBase.$$p[33]:
                let e = c;
                let f = d;
                let g = f - e;
                if (this.ep != null && this.ep.count > 0) {
                    for (let h = 0; h < this.ep.count; h++) {
                        let i = this.ep._inner[h];
                        for (let j of fromEnum(i.g)) {
                            j.k = j.k + g;
                        }
                    }
                }
                break;
            case RingSeriesBase.$$p[0]:
                this.c2();
                break;
            case HierarchicalRingSeries.$$p[0]:
                this.c3();
                break;
        }
        if (this.ep != null && this.aw.e()) {
            let k = false;
            for (let l of fromEnum(this.ep)) {
                l.o();
                if (l.f()) {
                    k = true;
                }
            }
            if (k) {
                for (let m of fromEnum(this.ep)) {
                    m.c.aw.l();
                }
            }
        }
    }
    c3() {
        if (this.ax != null) {
            this.ax.bx();
            this.ax.b2();
        }
    }
    c2() {
        if (this.ep != null) {
            for (let a of fromEnum(this.ep)) {
                for (let b of fromEnum(a.g)) {
                    this.ev(b);
                }
            }
        }
    }
    c8() {
        if (this.ep != null && this.ep.count > 0) {
            let a = this.ep._inner[this.ep.count - 1];
            this.width = a.q.width;
            this.height = a.q.height;
            this.aw.m(a.p.x, a.p.y);
        }
    }
    c7() {
        for (let a = 0; a < this.ep.count; a++) {
            for (let b of fromEnum(this.ep._inner[a].ringControl.arcs.a)) {
                b.f4();
            }
        }
    }
    es(obj_) {
        let memberPath_ = this.et;
        if ((obj_[memberPath_] !== undefined)) {
            return (obj_[memberPath_]);
        }
        return null;
    }
    eq(a) {
        let b = new IgQueue$1(ArcItem.$);
        let c = new IgQueue$1(ArcItem.$);
        let d = ((() => {
            let $ret = new ArcItem();
            $ret.m = 0;
            $ret.h = a;
            $ret.n = this.cs;
            $ret.c = this.ap;
            $ret.j = this.a8;
            return $ret;
        })());
        d.p(this.ba);
        let e = ((() => {
            let $ret = new ArcItem();
            $ret.m = -1;
            $ret.h = null;
            return $ret;
        })());
        c.h(d);
        b.h(e);
        let f = new RingCollection();
        let g = null;
        let h = -1;
        while (c.f > 0) {
            let i;
            let j = c.g(i);
            i = j.p0;
            let k;
            let l = b.g(k);
            k = l.p0;
            if (i == null) {
                continue;
            }
            let m = 0;
            for (let n of fromEnum(i.g)) {
                let o = this.es(n.g);
                if ((o != null && this.er(o) == false) || n.c) {
                    let p = ((() => {
                        let $ret = new ArcItem();
                        $ret.m = i.m + 1;
                        $ret.h = n.c ? ((() => {
                            let $ret = new List$1(Number_$type, 0);
                            $ret.add(0);
                            return $ret;
                        })()) : o;
                        $ret.l = m;
                        $ret.b = i;
                        $ret.n = this.cs;
                        $ret.e = n;
                        return $ret;
                    })());
                    p.p(this.ba);
                    c.h(p);
                    b.h(i);
                }
                m++;
            }
            let q = this.eo(i, k, h, g);
            if (q != g) {
                f.add(q);
                g = q;
            }
            h = i.m;
        }
        return f;
    }
    eo(a, b, c, d) {
        a.k = a.e == null ? this.ba : a.e.e;
        a.i = a.e == null ? 360 : a.e.d;
        this.ev(a);
        if (a.m != c) {
            let e = ((() => {
                let $ret = new Ring();
                $ret.c = this;
                return $ret;
            })());
            e.g.add(a);
            a.d = e;
            return e;
        }
        a.d = d;
        d.g.add(a);
        return d;
    }
    er(a) {
        for (let b of fromEn(a)) {
            return false;
        }
        return true;
    }
    ev(a) {
        if (a.b == null) {
            a.a = this.ak;
        }
        else if (a.b.m == 0) {
            a.a = new BrushCollection();
            if (a.b.a != null) {
                a.a.add(a.b.a.item(a.l % a.b.a.count));
            }
        }
        else {
            a.a = a.b.a;
        }
    }
}
HierarchicalRingSeries.$t = markType(HierarchicalRingSeries, 'HierarchicalRingSeries', RingSeriesBase.$);
HierarchicalRingSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HierarchicalRingSeries, 'c6', ['ChildrenMemberPath:et:ew', [2]]);

var IgxHierarchicalRingSeriesComponent_1;
/**
 * Represents a IgxDoughnutChartComponent hierarchical series.
*/
const IgxHierarchicalRingSeriesComponent_PROVIDERS = [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent) }];
let IgxHierarchicalRingSeriesComponent = IgxHierarchicalRingSeriesComponent_1 = class IgxHierarchicalRingSeriesComponent extends IgxRingSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new HierarchicalRingSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the property name that contains the children items collection.
    */
    get childrenMemberPath() {
        return this.i.et;
    }
    set childrenMemberPath(v) {
        this.i.et = v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxHierarchicalRingSeriesComponent.prototype, "childrenMemberPath", null);
IgxHierarchicalRingSeriesComponent = IgxHierarchicalRingSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-hierarchical-ring-series',
        template: ``,
        providers: [{ provide: IgxRingSeriesBaseComponent, useExisting: forwardRef(() => IgxHierarchicalRingSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxHierarchicalRingSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHierarchicalRingSeriesModule = class IgxHierarchicalRingSeriesModule {
};
IgxHierarchicalRingSeriesModule = __decorate([
    NgModule({
        declarations: [IgxHierarchicalRingSeriesComponent],
        imports: [CommonModule],
        exports: [IgxHierarchicalRingSeriesComponent],
        entryComponents: []
    })
], IgxHierarchicalRingSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHierarchicalRingSeriesDynamicModule = class IgxHierarchicalRingSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxHierarchicalRingSeriesComponent", IgxHierarchicalRingSeriesComponent);
        TypeRegistrar.register("HierarchicalRingSeries", HierarchicalRingSeries.$type);
    }
};
IgxHierarchicalRingSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxHierarchicalRingSeriesModule],
        exports: [IgxHierarchicalRingSeriesModule],
        entryComponents: [IgxHierarchicalRingSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxHierarchicalRingSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisBreak extends Base {
    constructor() {
        super(...arguments);
        this.b = new Date();
        this.a = new Date();
        this.h = (0);
        this.propertyChanged = null;
    }
    get d() {
        return this.b;
    }
    set d(a) {
        let b = this.d;
        if (+a != +b) {
            this.b = a;
            this.j("Start", b, this.d);
        }
    }
    get c() {
        return this.a;
    }
    set c(a) {
        let b = this.c;
        if (+a != +b) {
            this.a = a;
            this.j("End", b, this.c);
        }
    }
    get i() {
        return this.h;
    }
    set i(a) {
        let b = this.i;
        if (a != b) {
            this.h = a;
            this.j("Interval", b, this.i);
        }
    }
    j(a, b, c) {
        this.k(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    k(a, b, c) {
    }
}
TimeAxisBreak.$t = markType(TimeAxisBreak, 'TimeAxisBreak', Base.$, [INotifyPropertyChanged_$type]);

const IgxTimeAxisBreakComponent_PROVIDERS = [];
let IgxTimeAxisBreakComponent = class IgxTimeAxisBreakComponent {
    constructor() {
        this._renderer = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisBreak();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * The start time of the axis break.
*
* Use `start` property for the start time of the axis break.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-time-x-axis
* 		dateTimeMemberPath="date"
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*/
    get start() {
        return this.i.d;
    }
    set start(v) {
        this.i.d = v;
    }
    /**
     * The end time of the axis break.
    *
    * Use `end` property for the end time of the axis break.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    get end() {
        return this.i.c;
    }
    set end(v) {
        this.i.c = v;
    }
    /**
     * The interval at which to repeat this break, expressed as a TimeSpan.
    *
    * Use `interval` property to se the interval at which to repeat this break, expressed as a TimeSpan.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    get interval() {
        return this.i.i;
    }
    set interval(v) {
        this.i.i = +v;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisBreakComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBreakComponent.prototype, "start", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBreakComponent.prototype, "end", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeAxisBreakComponent.prototype, "interval", null);
IgxTimeAxisBreakComponent = __decorate([
    Component({
        selector: 'igx-time-axis-break',
        template: ``,
        providers: IgxTimeAxisBreakComponent_PROVIDERS
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisBreakComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum representing a unit of time.
 */
var TimeAxisIntervalType;
(function (TimeAxisIntervalType) {
    /**
     * Ticks are ten millionths of seconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Ticks"] = 0] = "Ticks";
    /**
     * Milliseconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Milliseconds"] = 1] = "Milliseconds";
    /**
     * Seconds.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Seconds"] = 2] = "Seconds";
    /**
     * Minutes.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Minutes"] = 3] = "Minutes";
    /**
     * Hours.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Hours"] = 4] = "Hours";
    /**
     * Days.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Days"] = 5] = "Days";
    /**
     * Weeks.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Weeks"] = 6] = "Weeks";
    /**
     * Months.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Months"] = 7] = "Months";
    /**
     * Years.
     */
    TimeAxisIntervalType[TimeAxisIntervalType["Years"] = 8] = "Years";
})(TimeAxisIntervalType || (TimeAxisIntervalType = {}));
/**
 * @hidden
 */
let TimeAxisIntervalType_$type = markEnum('TimeAxisIntervalType', 'Ticks,0|Milliseconds,1|Seconds,2|Minutes,3|Hours,4|Days,5|Weeks,6|Months,7|Years,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisInterval extends Base {
    constructor() {
        super(...arguments);
        this.j = (0);
        this.e = 0;
        this.a = 0;
        this.propertyChanged = null;
    }
    get k() {
        return this.j;
    }
    set k(a) {
        let b = this.k;
        if (a != b) {
            this.j = a;
            this.l("Range", b, this.k);
        }
    }
    get f() {
        return this.e;
    }
    set f(a) {
        let b = this.f;
        if (a != b) {
            this.e = a;
            this.l("Interval", b, this.f);
        }
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.b;
        if (a != b) {
            this.a = a;
            this.l("Interval", enumGetBox(TimeAxisIntervalType_$type, b), enumGetBox(TimeAxisIntervalType_$type, this.b));
        }
    }
    d(a) {
        let b;
        switch (this.b) {
            case 0:
                let c = 10000;
                return dateAddSeconds(a, 1 / c);
            case 1:
                b = dateAddSeconds(a, 1 / 1000);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), b.getMilliseconds());
            case 2:
                b = dateAddSeconds(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), b.getSeconds(), 0);
            case 3:
                b = dateAddMinutes(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), b.getMinutes(), 0, 0);
            case 4:
            case 5:
                b = dateAddHours(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), b.getHours(), 0, 0, 0);
            case 6:
            case 7:
            case 8:
                b = dateAddDays(a, 1);
                return dateFromValues(b.getFullYear(), dateGetMonth(b), b.getDate(), 0, 0, 0, 0);
            default: return a;
        }
    }
    c(a) {
        let b = +(dateMaxValue()) - +a;
        switch (this.b) {
            case 0:
                let c = 10000;
                if (b > timeSpanFromTicks(truncate(this.f))) {
                    return dateAddSeconds(a, this.f / c);
                }
                return dateMaxValue();
            case 1:
                if (b > timeSpanFromMilliseconds(this.f)) {
                    return dateAddSeconds(a, this.f / 1000);
                }
                return dateMaxValue();
            case 2:
                if (b > timeSpanFromSeconds(this.f)) {
                    return dateAddSeconds(a, this.f);
                }
                return dateMaxValue();
            case 3:
                if (b > timeSpanFromMinutes(this.f)) {
                    return dateAddMinutes(a, this.f);
                }
                return dateMaxValue();
            case 4:
                if (b > timeSpanFromHours(this.f)) {
                    return dateAddHours(a, this.f);
                }
                return dateMaxValue();
            case 5:
                if (b > timeSpanFromDays(this.f)) {
                    return dateAddDays(a, this.f);
                }
                return dateMaxValue();
            case 6:
                if (b > timeSpanFromDays(7 * this.f)) {
                    return dateAddDays(a, this.f * 7);
                }
                return dateMaxValue();
            case 7:
                if (b > timeSpanFromDays(31 * truncate(this.f))) {
                    return dateAddMonths(a, truncate(this.f));
                }
                return dateMaxValue();
            case 8:
                if (b > timeSpanFromDays(365 * truncate(this.f))) {
                    return dateAddYears(a, truncate(this.f));
                }
                return dateMaxValue();
            default: return a;
        }
    }
    l(a, b, c) {
        this.m(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    m(a, b, c) {
    }
}
TimeAxisInterval.$t = markType(TimeAxisInterval, 'TimeAxisInterval', Base.$, [INotifyPropertyChanged_$type]);

const IgxTimeAxisIntervalComponent_PROVIDERS = [];
let IgxTimeAxisIntervalComponent = class IgxTimeAxisIntervalComponent {
    constructor() {
        this._renderer = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisInterval();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * The visible axis range at which to apply this interval.
*
* Use `range` property for the visible axis range at which to apply this interval.
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-time-x-axis
* 		[labelFormats]="labelFormats"
* 		dateTimeMemberPath="time"
*
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*/
    get range() {
        return this.i.k;
    }
    set range(v) {
        this.i.k = +v;
    }
    /**
     * The interval, expressed as a multiple of IntervalType.
    *
    * Use the `interval` property expressed as a multiple of IntervalType.
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-time-x-axis
    * 		[labelFormats]="labelFormats"
    * 		dateTimeMemberPath="time"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get interval() {
        return this.i.f;
    }
    set interval(v) {
        this.i.f = +v;
    }
    /**
     * The unit of time for this interval.
    *
    * The `intervalType` is the unit of time for this interval.
    */
    get intervalType() {
        return this.i.b;
    }
    set intervalType(v) {
        this.i.b = ensureEnum(TimeAxisIntervalType_$type, v);
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisIntervalComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeAxisIntervalComponent.prototype, "range", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeAxisIntervalComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeAxisIntervalComponent.prototype, "intervalType", null);
IgxTimeAxisIntervalComponent = __decorate([
    Component({
        selector: 'igx-time-axis-interval',
        template: ``,
        providers: IgxTimeAxisIntervalComponent_PROVIDERS
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisIntervalComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisLabelFormat extends Base {
    constructor() {
        super(...arguments);
        this.n = (0);
        this.a = null;
        this.d = null;
        this.c = null;
        this.b = null;
        this.propertyChanged = null;
    }
    get o() {
        return this.n;
    }
    set o(a) {
        let b = this.o;
        if (a != b) {
            this.n = a;
            this.p("Range", b, this.o);
        }
    }
    get e() {
        return this.a;
    }
    set e(a) {
        let b = this.e;
        if (a != b) {
            this.a = a;
            this.p("Format", b, this.e);
        }
    }
    get l() {
        return this.d;
    }
    set l(a) {
        let b = this.l;
        if (a != b) {
            this.d = a;
            this.p("RepeatedYearFormat", b, this.l);
        }
    }
    get j() {
        return this.c;
    }
    set j(a) {
        let b = this.j;
        if (a != b) {
            this.c = a;
            this.p("RepeatedMonthFormat", b, this.j);
        }
    }
    get h() {
        return this.b;
    }
    set h(a) {
        let b = this.h;
        if (a != b) {
            this.b = a;
            this.p("RepeatedDayFormat", b, this.h);
        }
    }
    p(a, b, c) {
        this.q(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    q(a, b, c) {
    }
}
TimeAxisLabelFormat.$t = markType(TimeAxisLabelFormat, 'TimeAxisLabelFormat', Base.$, [INotifyPropertyChanged_$type]);

const IgxTimeAxisLabelFormatComponent_PROVIDERS = [];
let IgxTimeAxisLabelFormatComponent = class IgxTimeAxisLabelFormatComponent {
    constructor() {
        this._renderer = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._zoneRunner = null;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    createImplementation() {
        return new TimeAxisLabelFormat();
    }
    ngOnInit() {
    }
    _provideRenderer(renderer) {
        this._renderer = renderer;
        this._zoneRunner = (act) => renderer._ngZone.run(act);
    }
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * The visible axis range at which to apply this label format.
*
* The `range` property provide the visible axis range at which to apply this label format.
*
* ```ts
* let labelFormat = new TimeAxisLabelFormat();
* labelFormat.format = "hh:mm:ss";
* labelFormat.range = 1000;
* this.xAxis.labelFormats.add(labelFormat);
* labelFormat = new TimeAxisLabelFormat();
* labelFormat.format = "hh:mm";
* labelFormat.range = 60 * 1000;
* this.xAxis.labelFormats.add(labelFormat);
* labelFormat = new TimeAxisLabelFormat();
* labelFormat.format = "MMM-dd-yy";
* labelFormat.range = 24 * 60 * 60 * 1000;
* this.xAxis.labelFormats.add(labelFormat);
* ```
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-time-x-axis
* 		[labelFormats]="labelFormats"
* 		dateTimeMemberPath="time"
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*/
    get range() {
        return this.i.o;
    }
    set range(v) {
        this.i.o = +v;
    }
    /**
     * The DateTime format string to apply.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    *
    * The `format` property provide the DateTime format string to apply.
    *
    * ```ts
    * let labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm:ss";
    * labelFormat.range = 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm";
    * labelFormat.range = 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "MMM-dd-yy";
    * labelFormat.range = 24 * 60 * 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-time-x-axis
    * 		[labelFormats]="labelFormats"
    * 		dateTimeMemberPath="time"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get format() {
        return this.i.e;
    }
    set format(v) {
        this.i.e = v;
    }
    /**
     * The DateTime format string to apply, if the year is repeated from the prior date.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    */
    get repeatedYearFormat() {
        return this.i.l;
    }
    set repeatedYearFormat(v) {
        this.i.l = v;
    }
    /**
     * The DateTime format string to apply, if the month is repeated from the prior date.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    */
    get repeatedMonthFormat() {
        return this.i.j;
    }
    set repeatedMonthFormat(v) {
        this.i.j = v;
    }
    /**
     * The DateTime format string to apply, if the day is repeated from the prior date.
     * Some common DateTime format strings are: yyyy, MM/dd/yy, and hh:mm:ss.
    */
    get repeatedDayFormat() {
        return this.i.h;
    }
    set repeatedDayFormat(v) {
        this.i.h = v;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TimeAxisLabelFormatComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeAxisLabelFormatComponent.prototype, "range", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTimeAxisLabelFormatComponent.prototype, "format", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTimeAxisLabelFormatComponent.prototype, "repeatedYearFormat", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTimeAxisLabelFormatComponent.prototype, "repeatedMonthFormat", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTimeAxisLabelFormatComponent.prototype, "repeatedDayFormat", null);
IgxTimeAxisLabelFormatComponent = __decorate([
    Component({
        selector: 'igx-time-axis-label-format',
        template: ``,
        providers: IgxTimeAxisLabelFormatComponent_PROVIDERS
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisLabelFormatComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IAngleScaler_$type = new Type(null, 'IAngleScaler');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryAxisRenderer extends AxisRendererBase {
    constructor(a) {
        super(a);
    }
    ac(a, b, c, d, e) {
        let f = typeCast(CategoryAxisRenderingParameters.$, a);
        let g = 0;
        if (f != null) {
            g = f.ab;
        }
        let h = new LinearCategorySnapper(1, a.e.d, a.e.c, a.e.b, a.p, g, a.o);
        b = h.g;
        if (a.e.a != -1) {
            b = a.e.a;
        }
        let i = Math.floor((a.e.d - a.m) / b);
        let j = Math.ceil((a.e.c - a.m) / b);
        d = truncate(i);
        e = truncate(j);
        c = truncate(h.h);
        if (a.e.e != -1) {
            c = a.e.e;
        }
        return {
            p1: b,
            p2: c,
            p3: d,
            p4: e
        };
    }
    w(a, b, c, d) {
        let e = typeCast(CategoryAxisRenderingParameters.$, a);
        if (e == null) {
            return null;
        }
        let f = 0;
        if (d >= 1) {
            f = c * truncate(Math.floor(d));
        }
        else {
            if ((c * d) * 2 % 2 == 0) {
                f = truncate(Math.floor(c * d));
            }
            else {
                f = -1;
            }
        }
        let g = null;
        if ((e.ae > 0 && f < e.ae && f >= 0) || e.ad) {
            while (f >= e.ae && e.ad) {
                f -= e.ae;
            }
            g = this.g(f);
        }
        return g;
    }
    ad(a, b, c, d, e, f) {
        let g = typeCast(CategoryAxisRenderingParameters.$, a);
        if (g.ab != 0 && g.af != 0) {
            for (let h = 0; h < truncate(b); h++) {
                for (let i = 0; i < g.af; i++) {
                    let j = this.f(i, a.aa, a.z, a.y);
                    if (g.ac) {
                        j = -j;
                    }
                    let k = this.m(a, h + e * b) + j;
                    a.b = a.d;
                    this.k(a, a.v, k);
                    a.b = null;
                }
            }
        }
    }
}
CategoryAxisRenderer.$t = markType(CategoryAxisRenderer, 'CategoryAxisRenderer', AxisRendererBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ViewportUtils extends Base {
    static c(a, b, c) {
        return c.left + c.width * (a - b.left) / b.width;
    }
    static a(a, b, c) {
        return ((a - c.left) * b.width / c.width) + b.left;
    }
    static f(a, b, c) {
        return c.top + c.height * (a - b.top) / b.height;
    }
    static e(a, b, c) {
        return ((a - c.top) * b.height / c.height) + b.top;
    }
    static d(a, b, c) {
        return c.width * a / b.width;
    }
    static b(a, b, c) {
        return b.width * a / c.width;
    }
    static g(a, b, c) {
        return c.height * a / b.height;
    }
}
ViewportUtils.$t = markType(ViewportUtils, 'ViewportUtils');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IPolarRadialRenderingParameters_$type = new Type(null, 'IPolarRadialRenderingParameters');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarAxisRenderingParameters extends NumericAxisRenderingParameters {
    constructor() {
        super(...arguments);
        this._minLength = 0;
        this._maxLength = 0;
        this._center = null;
        this._minAngle = 0;
        this._maxAngle = 0;
        this._crossingAngleRadians = 0;
        this._effectiveMaximum = 0;
    }
    get minLength() {
        return this._minLength;
    }
    set minLength(a) {
        this._minLength = a;
    }
    get maxLength() {
        return this._maxLength;
    }
    set maxLength(a) {
        this._maxLength = a;
    }
    get center() {
        return this._center;
    }
    set center(a) {
        this._center = a;
    }
    get minAngle() {
        return this._minAngle;
    }
    set minAngle(a) {
        this._minAngle = a;
    }
    get maxAngle() {
        return this._maxAngle;
    }
    set maxAngle(a) {
        this._maxAngle = a;
    }
    get crossingAngleRadians() {
        return this._crossingAngleRadians;
    }
    set crossingAngleRadians(a) {
        this._crossingAngleRadians = a;
    }
    get effectiveMaximum() {
        return this._effectiveMaximum;
    }
    set effectiveMaximum(a) {
        this._effectiveMaximum = a;
    }
}
PolarAxisRenderingParameters.$t = markType(PolarAxisRenderingParameters, 'PolarAxisRenderingParameters', NumericAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialAxisRenderingParameters extends CategoryAxisRenderingParameters {
    constructor() {
        super(...arguments);
        this._minLength = 0;
        this._maxLength = 0;
        this._center = null;
        this._crossingAngleRadians = 0;
        this._minAngle = 0;
        this._maxAngle = 0;
        this._effectiveMaximum = 0;
    }
    get minLength() {
        return this._minLength;
    }
    set minLength(a) {
        this._minLength = a;
    }
    get maxLength() {
        return this._maxLength;
    }
    set maxLength(a) {
        this._maxLength = a;
    }
    get center() {
        return this._center;
    }
    set center(a) {
        this._center = a;
    }
    get crossingAngleRadians() {
        return this._crossingAngleRadians;
    }
    set crossingAngleRadians(a) {
        this._crossingAngleRadians = a;
    }
    get minAngle() {
        return this._minAngle;
    }
    set minAngle(a) {
        this._minAngle = a;
    }
    get maxAngle() {
        return this._maxAngle;
    }
    set maxAngle(a) {
        this._maxAngle = a;
    }
    get effectiveMaximum() {
        return this._effectiveMaximum;
    }
    set effectiveMaximum(a) {
        this._effectiveMaximum = a;
    }
}
RadialAxisRenderingParameters.$t = markType(RadialAxisRenderingParameters, 'RadialAxisRenderingParameters', CategoryAxisRenderingParameters.$, [IPolarRadialRenderingParameters_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarAxisRenderingManager extends Base {
    p(a, b, c, d, e, f) {
        let g = ViewportUtils.d(a, e, f);
        let h = ViewportUtils.g(a, e, f);
        let i = ViewportUtils.c(b.x, e, f);
        let j = ViewportUtils.f(b.y, e, f);
        if (d - c < Math.PI && d - c > 0) {
            let k = { $type: Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(c), e, f), y: ViewportUtils.f(b.y + a * Math.sin(c), e, f) };
            let l = { $type: Point_$type, x: ViewportUtils.c(b.x + a * Math.cos(d), e, f), y: ViewportUtils.f(b.y + a * Math.sin(d), e, f) };
            let m = new PathFigure();
            m._startPoint = k;
            m._isClosed = false;
            m._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = l;
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            return m;
        }
        else {
            let n = new PathFigure();
            n._startPoint = { $type: Point_$type, x: i, y: j - h };
            n._isClosed = true;
            n._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: i, y: j + h };
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            n._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: i, y: j - h };
                $ret.f = new Size(1, g, h);
                $ret.d = 1;
                return $ret;
            })()));
            return n;
        }
    }
    j(a, b, c, d, e, f, g, h) {
        let i = Math.min(b, c);
        let j = Math.max(b, c);
        let k = new PathGeometry();
        let l = null;
        let m = null;
        let n = null;
        let o = null;
        if (i > 0) {
            l = this.p(i, f, g, h, e, d);
            if (h - g < Math.PI && h - g > 0) {
                let p = typeCast(ArcSegment.$, l._segments._inner[0]);
                if (p != null) {
                    let q = { $type: Point_$type, x: ViewportUtils.c(f.x + j * Math.cos(h), e, d), y: ViewportUtils.f(f.y + j * Math.sin(h), e, d) };
                    m = ((() => {
                        let $ret = new LineSegment(1);
                        $ret.c = q;
                        return $ret;
                    })());
                }
            }
        }
        if (j > 0) {
            n = this.p(j, f, g, h, e, d);
        }
        if (i > 0) {
            if (h - g < Math.PI && h - g > 0) {
                let r = n._startPoint;
                let s = typeCast(ArcSegment.$, n._segments._inner[0]);
                if (s != null) {
                    n._startPoint = s.e;
                    s.e = r;
                    s.d = 0;
                    let t = { $type: Point_$type, x: ViewportUtils.c(f.x + i * Math.cos(g), e, d), y: ViewportUtils.f(f.y + i * Math.sin(g), e, d) };
                    o = ((() => {
                        let $ret = new LineSegment(1);
                        $ret.c = t;
                        return $ret;
                    })());
                }
            }
        }
        if (m != null && o != null) {
            l._segments.add(m);
            let u = n._segments._inner[0];
            n._segments.remove(u);
            l._segments.add(u);
            l._segments.add(o);
            l._isClosed = true;
            k.c.add(l);
        }
        else {
            if (l != null) {
                k.c.add(l);
                this.o(n);
            }
            if (n != null) {
                k.c.add(n);
            }
        }
        a.add(k);
    }
    o(a) {
        if (a._segments.count > 1) {
            let b = typeCast(ArcSegment.$, a._segments._inner[0]);
            let c = typeCast(ArcSegment.$, a._segments._inner[1]);
            a._segments._inner[0] = c;
            a._segments._inner[1] = b;
            let d = c.e;
            let e = a._startPoint;
            let f = b.e;
            a._startPoint = d;
            c.e = f;
            b.e = e;
            b.d = 0;
            c.d = 0;
        }
        else {
            let g = a._startPoint;
            let h = typeCast(ArcSegment.$, a._segments._inner[0]);
            if (h != null) {
                a._startPoint = h.e;
                h.e = g;
                h.d = 0;
            }
        }
    }
    i(a, b, c, d, e, f, g) {
        if (b > 0) {
            let h = new PathGeometry();
            h.c.add(this.p(b, e, f, g, d, c));
            a.add(h);
        }
    }
    n(a, b, c, d, e, f, g, h) {
        let i = Math.min(b, c);
        let j = Math.max(b, c);
        let k = false;
        if (j - i > Math.PI) {
            k = true;
        }
        let l = Math.cos(i);
        let m = Math.sin(i);
        let n = h.x + l * f;
        let o = h.y + m * f;
        let p = h.x + l * g;
        let q = h.y + m * g;
        let r = Math.cos(j);
        let s = Math.sin(j);
        let t = h.x + r * f;
        let u = h.y + s * f;
        let v = h.x + r * g;
        let w = h.y + s * g;
        n = ViewportUtils.c(n, e, d);
        o = ViewportUtils.f(o, e, d);
        p = ViewportUtils.c(p, e, d);
        q = ViewportUtils.f(q, e, d);
        t = ViewportUtils.c(t, e, d);
        u = ViewportUtils.f(u, e, d);
        v = ViewportUtils.c(v, e, d);
        w = ViewportUtils.f(w, e, d);
        let x = new PathFigure();
        x._startPoint = { $type: Point_$type, x: n, y: o };
        x._isClosed = true;
        x._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = { $type: Point_$type, x: p, y: q };
            return $ret;
        })()));
        x._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = { $type: Point_$type, x: v, y: w };
            $ret.f = new Size(1, ViewportUtils.d(g, e, d), ViewportUtils.g(g, e, d));
            $ret.d = 1;
            $ret.b = k;
            return $ret;
        })()));
        x._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = { $type: Point_$type, x: t, y: u };
            return $ret;
        })()));
        x._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = { $type: Point_$type, x: n, y: o };
            $ret.f = new Size(1, ViewportUtils.d(f, e, d), ViewportUtils.g(f, e, d));
            $ret.d = 0;
            $ret.b = k;
            return $ret;
        })()));
        let y = new PathGeometry();
        y.c.add(x);
        a.add(y);
    }
    m(a, b, c, d, e, f, g) {
        let h = new LineGeometry();
        let i = Math.cos(b);
        let j = Math.sin(b);
        let k = g.x + i * e;
        let l = g.y + j * e;
        let m = g.x + i * f;
        let n = g.y + j * f;
        k = ViewportUtils.c(k, d, c);
        l = ViewportUtils.f(l, d, c);
        m = ViewportUtils.c(m, d, c);
        n = ViewportUtils.f(n, d, c);
        h.d = { $type: Point_$type, x: k, y: l };
        h.c = { $type: Point_$type, x: m, y: n };
        a.add(h);
    }
    a(a, b) {
        return a.x >= b.left && a.x <= b.right;
    }
    b(a, b) {
        return a.y >= b.top && a.y <= b.bottom;
    }
    c(a, b) {
        let c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
        let d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
        let e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
        let f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
        return Math.min(c, Math.min(d, Math.min(e, f)));
    }
    d(a, b) {
        let c = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.top, 2));
        let d = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.top, 2));
        let e = Math.sqrt(Math.pow(a.x - b.right, 2) + Math.pow(a.y - b.bottom, 2));
        let f = Math.sqrt(Math.pow(a.x - b.left, 2) + Math.pow(a.y - b.bottom, 2));
        return Math.max(c, Math.max(d, Math.max(e, f)));
    }
    f(a) {
        let b = { $type: Point_$type, x: 0.5, y: 0.5 };
        if (this.a(b, a) && this.b(b, a)) {
            return 0;
        }
        if (this.a(b, a)) {
            if (b.y < a.top) {
                return a.top - b.y;
            }
            else {
                return b.y - a.bottom;
            }
        }
        if (this.b(b, a)) {
            if (b.x < a.left) {
                return a.left - b.x;
            }
            else {
                return b.x - a.right;
            }
        }
        return this.c(b, a);
    }
    g(a) {
        let b = { $type: Point_$type, x: 0.5, y: 0.5 };
        return this.d(b, a);
    }
    e(a, b) {
        let c = Math.sqrt(Math.pow(b.x - a.x, 2) + Math.pow(b.y - a.y, 2));
        let d = Math.acos((b.x - a.x) / c);
        if ((b.y - a.y) < 0) {
            d = (2 * Math.PI) - d;
        }
        return d;
    }
    h(a, b) {
        return ((a.y - 0.5) * b.x) + ((0.5 - a.x) * b.y) + ((a.x * 0.5) - (0.5 * a.y));
    }
    l(a, b, c) {
        let d = { $type: Point_$type, x: 0.5, y: 0.5 };
        if (this.a(d, a) && this.b(d, a)) {
            b = 0;
            c = Math.PI * 2;
            return {
                p1: b,
                p2: c
            };
        }
        let e = this.e(d, { $type: Point_$type, x: a.left, y: a.top });
        let f = this.e(d, { $type: Point_$type, x: a.right, y: a.top });
        let g = this.e(d, { $type: Point_$type, x: a.right, y: a.bottom });
        let h = this.e(d, { $type: Point_$type, x: a.left, y: a.bottom });
        if (this.b(d, a) && a.left > d.x) {
            b = e;
            c = 2 * Math.PI + h;
            return {
                p1: b,
                p2: c
            };
        }
        b = Math.min(e, Math.min(f, Math.min(g, h)));
        c = Math.max(e, Math.max(f, Math.max(g, h)));
        return {
            p1: b,
            p2: c
        };
    }
    k(a, b, c, d, e, f, g) {
        let h;
        let i;
        let j = this.l(a, h, i);
        h = j.p1;
        i = j.p2;
        let k = Math.min(h, i);
        let l = Math.max(h, i);
        if (typeCast(PolarAxisRenderingParameters.$, b) !== null) {
            b.minAngle = k;
            b.maxAngle = l;
        }
        else if (typeCast(RadialAxisRenderingParameters.$, b) !== null) {
            b.minAngle = k;
            b.maxAngle = l;
        }
        if (h == 0 && i == Math.PI * 2) {
            let m = c;
            let n = d;
            let o = Math.min(m, n);
            let p = Math.max(m, n);
            b.k.add(((() => {
                let $ret = new RangeInfo();
                $ret.d = o;
                $ret.c = p;
                $ret.b = g;
                return $ret;
            })()));
            return;
        }
        else {
            if (i > Math.PI * 2) {
                i = i - Math.PI * 2;
            }
            let q = f(h);
            let r = f(i);
            if (q < c || q > d) {
                q = f(h + Math.PI * 2);
            }
            if (r < c || r > d) {
                r = f(i + Math.PI * 2);
            }
            let s = Math.min(q, r);
            let t = Math.max(q, r);
            if ((!e && q > r) || (e && q < r)) {
                let u = (d - t);
                let v = (s - c);
                b.k.add(((() => {
                    let $ret = new RangeInfo();
                    $ret.d = t;
                    $ret.c = d;
                    $ret.b = (u / (u + v)) * g;
                    return $ret;
                })()));
                b.k.add(((() => {
                    let $ret = new RangeInfo();
                    $ret.d = c;
                    $ret.c = s;
                    $ret.b = (v / (u + v)) * g;
                    return $ret;
                })()));
            }
            else {
                b.k.add(((() => {
                    let $ret = new RangeInfo();
                    $ret.d = s;
                    $ret.c = t;
                    $ret.b = g;
                    return $ret;
                })()));
            }
        }
    }
}
PolarAxisRenderingManager.$t = markType(PolarAxisRenderingManager, 'PolarAxisRenderingManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryTickmarkValues extends TickmarkValues {
    constructor() {
        super(...arguments);
        this.v = 0;
        this.z = 0;
        this.aa = null;
        this.ab = null;
        this.x = false;
        this.w = null;
        this.y = 0;
        this.t = null;
        this.u = null;
    }
    s(a) {
        super.s(a);
        let b = a.a;
        this.v = b;
        this.z = a.q;
        this.aa = a.r;
        this.ab = a.s;
        this.x = a.e;
        this.w = a.c;
        let c = new LinearCategorySnapper(1, a.n, a.m, a.k, a.l, b, a.h);
        let d = c.g;
        if (a.i != -1) {
            d = a.i;
        }
        let e = Math.floor((a.n - a.g) / d);
        let f = Math.ceil((a.m - a.g) / d);
        let g = truncate(e);
        let h = truncate(f);
        let i = truncate(c.h);
        if (a.p != -1) {
            i = a.p;
        }
        this.m = d;
        this.n = a.j;
        this.p = g;
        this.q = h;
        this.r = i;
        this.y = a.g;
    }
    j() {
        let a = this.p;
        let b = this.q - a + 1;
        if (b < 0) {
            b = 0;
        }
        if (this.t == null || this.t.length != b) {
            this.t = new Array(b);
        }
        let c = this.t;
        for (let d = 0; d < b; ++d) {
            let e = this.y + (d + a) * this.m;
            c[d] = e;
        }
        return c;
    }
    k() {
        let a = this.m;
        let b = this.q;
        let c = this.p;
        let d = this.z;
        let e = this.v;
        a = Math.min(a, 20);
        let f = 0;
        for (let g = c; g < b; ++g) {
            if (e != 0 && d != 0) {
                for (let h = 0; h < truncate(a); h++) {
                    for (let i = 0; i < d; i++) {
                        f++;
                    }
                }
            }
        }
        if (this.u == null || this.u.length != f) {
            this.u = new Array(f);
        }
        let j = this.u;
        let k = 0;
        for (let l = c; l < b; ++l) {
            if (e != 0 && d != 0) {
                for (let m = 0; m < truncate(a); m++) {
                    for (let n = 0; n < d; n++) {
                        let o = this.w(n);
                        let p = m + (l * a) + o;
                        j[k] = p;
                        k++;
                    }
                }
            }
        }
        return this.u;
    }
}
CategoryTickmarkValues.$t = markType(CategoryTickmarkValues, 'CategoryTickmarkValues', TickmarkValues.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialAxisLabelPanel extends HorizontalAxisLabelPanelBase {
    constructor() {
        super(...arguments);
        this.dh = null;
        this.de = 0;
        this.dd = new List$1(Number_$type, 0);
    }
    ad() {
        return new RadialAxisLabelPanelView(this);
    }
    b9(a) {
        super.b9(a);
        this.db = a;
    }
    get dc() {
        return !this.al;
    }
    cw() {
        return this.an && (!this.aq || this.be() == -180);
    }
    cx() {
        return !this.ar;
    }
    bu(a) {
        super.bu(a);
        if (this.de % 360 == 0 || this.al) {
            this.db.a3();
        }
        else {
            this.db.a2(a);
        }
    }
    be() {
        let a = super.be();
        if (this.dc) {
            a -= (this.de * 180) / Math.PI;
        }
        return a;
    }
    cv() {
        return this.be() % 360 != 0;
    }
    cu() {
        if (this.al) {
            return true;
        }
        let a = this.de * 180 / Math.PI;
        if (a < 30 || a > 330 || (a > 150 && a < 210)) {
            return true;
        }
        return false;
    }
    cc(a, b) {
        let c = b * Math.PI / 180;
        let d = Math.abs(Math.sin(c));
        if (this.ac.ay != null && this.ac.ay.c == 4) {
            d = d * -1;
        }
        this.db.a4(a, b, d);
    }
    dg() {
        let a = 1.7976931348623157E+308;
        for (let b of fromEnum(this.a3)) {
            a = Math.min(b.c, a);
        }
        return a;
    }
    df() {
        let a = -1.7976931348623157E+308;
        for (let b of fromEnum(this.a3)) {
            a = Math.max(b.c, a);
        }
        return a;
    }
    c9(a, b) {
        let c;
        if (this.ac.ca) {
            c = this.dg();
        }
        else {
            c = this.df();
        }
        let d = new List$1(Number_$type, 0);
        let e = new List$1(Boolean_$type, 0);
        for (let f = 0; f < this.a3.count; f++) {
            let g = this.a3._inner[f];
            if (g.c == c && !g.a) {
                d.add(this.a3.indexOf(g));
            }
        }
        this.dd = d;
        let h = new List$1(Rect.$, 0);
        for (let i = 0; i < a.count; i++) {
            let j = a._inner[i];
            let k = this.a3._inner[i].a;
            if (!this.dd.contains(i)) {
                h.add(j);
                e.add(k);
            }
        }
        this.an = this.am(h, e);
    }
    ap(a, b) {
        if (this.dd.contains(a)) {
            return false;
        }
        else {
            return super.ap(a, b);
        }
    }
    da() {
        this.dd = new List$1(Number_$type, 0);
        super.da();
    }
    ah() {
        return 5;
    }
    at(a) {
        return a == 5 || a == 4 || a == 1 || a == 0;
    }
    b1() {
    }
}
RadialAxisLabelPanel.$t = markType(RadialAxisLabelPanel, 'RadialAxisLabelPanel', HorizontalAxisLabelPanelBase.$);
/**
 * @hidden
 */
class RadialAxisLabelPanelView extends HorizontalAxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.a1 = null;
        this.a1 = a;
    }
    a4(a, b, c) {
        let d = this.m(a);
        let e = this.l(a);
        let f = new TransformGroup();
        f.j.add(((() => {
            let $ret = new RotateTransform();
            $ret.j = b;
            $ret.k = d / 2;
            $ret.l = e / 2;
            return $ret;
        })()));
        f.j.add(((() => {
            let $ret = new TranslateTransform();
            $ret.j = d / -2;
            $ret.k = d / 2 * c;
            return $ret;
        })()));
        a.j = f;
    }
    a3() {
        this.a.j = null;
    }
    a2(a) {
        let b = ViewportUtils.f(0.5, this.a.cq, this.a.cp);
        this.a.j = ((() => {
            let $ret = new RotateTransform();
            $ret.j = (this.a1.de * 180) / Math.PI;
            $ret.k = this.a1.dh.x;
            $ret.l = (this.a1.dh.y * a.height) + b;
            return $ret;
        })());
    }
    al() {
        super.al();
        this.a.cr(new Size(1, this.a.co.width, this.a.co.height));
    }
}
RadialAxisLabelPanelView.$t = markType(RadialAxisLabelPanelView, 'RadialAxisLabelPanelView', HorizontalAxisLabelPanelBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AngleAxisLabelPanel extends AxisLabelPanelBase {
    constructor() {
        super();
        this.cu = false;
        this.c0 = null;
        this.cy = 0;
        this.cv = 0;
        this.cx = 0;
        this.cw = 0;
    }
    ad() {
        return new AngleAxisLabelPanelView(this);
    }
    b9(a) {
        super.b9(a);
        this.ct = a;
    }
    ap(a, b) {
        if (!Extensions.b(b)) {
            return false;
        }
        if (this.ac == null || this.ac.i9.isEmpty) {
            return super.ap(a, b);
        }
        return true;
    }
    az() {
        let a = new List$1(Rect.$, 0);
        let b = new List$1(Boolean_$type, 0);
        if (this.a4.count != this.a3.count) {
            return a;
        }
        this.ct.ay(a, b);
        let c = false;
        this.an = this.am(a, b);
        if (!this.ac.b1()) {
            c = true;
            this.ba = this.cy / 2;
            this.ba = this.ba + this.cz();
        }
        else {
            c = true;
            this.ct.ac();
        }
        if (c) {
            for (let d = 0; d < a.count; d++) {
                let e = this.a4._inner[d];
                let f = this.a3._inner[d];
                let g = a._inner[d];
                let h = this.c0(f.c);
                let i = h.x - this.bd(e) / 2;
                let j = h.y - this.bc(e) / 2;
                g.x = i;
                g.y = j;
                a._inner[d] = g;
            }
        }
        return a;
    }
    cz() {
        let a;
        let b;
        b = this.ac;
        a = null;
        if (b != null) {
            a = typeCast(XamDataChart.$, b.bh);
        }
        if (a == null || b == null) {
            return 0;
        }
        let c = new List$1(Axis.$, 0);
        for (let d = 0; d < a.axes.count; d++) {
            let e = a.axes._inner[d];
            if ((typeCast(NumericAngleAxis.$, e) !== null || typeCast(CategoryAngleAxis.$, e) !== null) && typeCast(AngleAxisLabelPanel.$, e.av) !== null && e.av.a4.count > 0 && (!e.b1()) && !e.b0() && (e.ai == null || this.ac.ai == null || e.ai.lr == b.ai.lr)) {
                c.add(e);
            }
        }
        let f = c.indexOf(b);
        if (f == -1) {
            return 0;
        }
        let g = 0;
        let h = 5;
        if (f == 0) {
            g += h;
        }
        else {
            g += c._inner[f - 1].av.ba;
            g += c._inner[f].av.ba * 2 + h;
        }
        return g;
    }
    ah() {
        return 4;
    }
    at(a) {
        return a == 4 || a == 5;
    }
}
AngleAxisLabelPanel.$t = markType(AngleAxisLabelPanel, 'AngleAxisLabelPanel', AxisLabelPanelBase.$);
/**
 * @hidden
 */
class CategoryAngleAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.la = null;
        this.k7 = null;
        this.lb = false;
        this.lf = NaN;
        this.k8 = null;
        this.lg = 0;
        this.ld = 0;
        this.le = 0;
        this.lr = 1;
        this.ab = CategoryAngleAxis.$;
        this.k7 = this.k6();
        this.la = new PolarAxisRenderingManager();
    }
    a3() {
        return new CategoryAngleAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.k5 = a;
    }
    get_b2() {
        return true;
    }
    au() {
        let a = new AngleAxisLabelPanel();
        a.c0 = (b) => {
            let c = this.bh != null ? this.bh.n2 : Rect.empty;
            let d = !c.isEmpty ? this.i9 : Rect.empty;
            return this.l4(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.ba);
        };
        return a;
    }
    lp(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    k6() {
        let a = ((() => {
            let $ret = new AxisLabelManager();
            $ret.a = this;
            $ret.f = this.cy;
            $ret.e = this.cx;
            $ret.b = this.av;
            return $ret;
        })());
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        let b = new CategoryAxisRenderer(a);
        b.u = () => {
            let c = this.a4.ay();
            let d = this.a4.a1();
            let e = this.a4.az();
            let f = this.a4.a0();
            this.hk();
            this.gn(c);
            this.gn(d);
            this.gn(e);
            this.gn(f);
        };
        b.o = (c, d) => !d.isEmpty && !c.isEmpty && this.k9 != null;
        b.d = (c, d, e, f) => this.k4(c, d, e, f);
        b.v = () => {
            if (!this.lb) {
                this.lb = true;
                this.k9.cn();
                this.lb = false;
            }
        };
        b.g = (c) => {
            let d = typeGetValue(c);
            if (d > this.jn.count - 1) {
                d -= this.jn.count;
            }
            let e = this.jn.item(d);
            return this.e8(e);
        };
        b.b.c = (c) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.k9 != null && this.lf != c) {
                let d = typeCast(XamDataChart.$, this.bh);
                if (d == null) {
                    return;
                }
                this.lf = c;
                this.av.a9 = c;
                d.it();
                for (let e of fromEnum(d.axes)) {
                    if (e != this && typeCast(AngleAxisLabelPanel.$, e.av) !== null) {
                        e.a4.ad();
                    }
                }
            }
        };
        b.k = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            this.la.m(d, e, c.z, c.aa, f.minLength, f.maxLength, f.center);
        };
        b.l = (c, d, e, f) => {
            let g = typeCast(RadialAxisRenderingParameters.$, c);
            this.la.n(d, e, f, g.z, c.aa, g.minLength, g.maxLength, g.center);
        };
        b.m = (c, d) => this.getScaledAngle(d);
        b.q = (c, d) => {
            if (this.lp(d - this.lg) < 0) {
                return false;
            }
            if (this.lp(d - this.lg - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        b.j = (c) => {
            let d = typeCast(RadialAxisRenderingParameters.$, c);
            if (d.e == d.k._inner[0]) {
                this.la.i(c.t, c.n, c.z, c.aa, d.center, d.minAngle, d.maxAngle);
            }
        };
        b.e = (c) => {
            c.n = this.lj();
            c.r = c.n;
        };
        b.p = (c, d, e) => {
            let f = typeCast(RadialAxisRenderingParameters.$, c);
            if (e) {
                return false;
            }
            let g = this.l4(d, f.center, c.aa, c.z, 0);
            if (g.x < c.z.right && g.x >= c.z.left && g.y < c.z.bottom && g.y >= c.z.top) {
                return true;
            }
            return false;
        };
        b.a = (c, d, e, f) => {
            let g = c.y;
            let h = new ScalerParams(0, c.aa, c.z, this.ca, g);
            let i = d;
            if (this.categoryMode != 0) {
                let j = (e * f) + 1;
                j = Math.min(j, this.j7);
                let k = this.dy(j, h);
                i = (d + k) / 2;
            }
            return i;
        };
        b.f = runOn(this, this.getGroupCenter);
        b.i = runOn(this, this.lm);
        return b;
    }
    l4(a, b, c, d, e) {
        let f = this.lj();
        let g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    lj() {
        if (this.k9 == null) {
            return 0;
        }
        if (!this.b0()) {
            return this.k9.lw();
        }
        else {
            return this.k9.lx((this.e4));
        }
    }
    k4(a, b, c, d) {
        if (this.jn == null) {
            return null;
        }
        let e = new RadialAxisRenderingParameters();
        let f = this.jn.count - 1;
        let g = this.a4.ay();
        let h = this.a4.a1();
        let i = this.a4.az();
        let j = this.a4.a0();
        e.t = g;
        e.w = h;
        e.u = i;
        e.v = j;
        e.l = f;
        e.m = 0;
        e.h = false;
        e.z = a;
        e.y = c;
        e.x = d;
        e.aa = b;
        e.g = this.lc();
        e.p = this.ln;
        e.o = this.eb();
        e.q = this.lo;
        e.s = this.e9;
        let k = this.la.f(b);
        let l = this.la.g(b);
        let m = 0.5 * this.k9.lr;
        let n = 0.5 * this.k9.lq;
        let o = k;
        let p = l;
        let q = this.k9.lw();
        if (isNaN_(q) || isInfinity(q)) {
            return null;
        }
        if (p >= m) {
            p = q;
        }
        if (o < n) {
            o = n;
        }
        let r = a.width;
        this.la.k(b, e, 0, this.jn.count, this.ca, runOn(this, this.getUnscaledAngle), r);
        let s = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = s;
        e.maxLength = p;
        e.minLength = o;
        e.effectiveMaximum = q;
        e.ae = this.jn.count;
        e.ab = this.categoryMode;
        e.ad = true;
        e.ac = this.ca;
        e.af = this.j9;
        e.f = new CategoryTickmarkValues();
        e.j = this.cl;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.la.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    ac() {
        super.ac();
        this.hb(false);
    }
    get k9() {
        if (this.k8 != null) {
            return this.k8;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericRadiusAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.k8;
    }
    set k9(a) {
        this.k8 = a;
    }
    aj() {
        return this.k9;
    }
    getCategorySize(a, b, c) {
        return 2 * Math.PI / this.j7;
    }
    jz(a, b, c) {
        let d = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
        let e = 0;
        if (!isNaN_(this.j3)) {
            e = Math.min(this.j3, 1);
        }
        let f = 1 - 0.5 * d;
        return this.getCategorySize(a, b, c) * f / (this.j9 - (this.j9 - 1) * e);
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.j9 > 1) {
            let f = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
            let g = 0;
            if (!isNaN_(this.j3)) {
                g = Math.min(this.j3, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.j9 - (this.j9 - 1) * g);
            let j = (h - i) / (this.j9 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    lm(a) {
        let b = 0.5;
        if (this.j9 > 1) {
            let c = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
            let d = 0;
            if (!isNaN_(this.j3)) {
                d = Math.min(this.j3, 1);
            }
            let e = 1 - 0.5 * c;
            let f = e / (this.j9 - (this.j9 - 1) * d);
            let g = (e - f) / (this.j9 - 1);
            b = 0.25 * c + 0.5 * f + a * g;
        }
        return b;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = this.k7.c(a, c, b, d, e);
        if (f != null) {
            this.lh = f.f.m;
            this.li = f.f.l;
        }
    }
    ll(a, b) {
        let c;
        let d;
        let e = this.la.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (c == 0) {
            if (this.ca) {
                return this.j7;
            }
            else {
                return 0;
            }
        }
        let f = this.getUnscaledAngle(c);
        if (f < 0 || f > this.j7) {
            f = this.getUnscaledAngle(c + Math.PI * 2);
        }
        return f;
    }
    lk(a, b) {
        let c;
        let d;
        let e = this.la.l(b, c, d);
        c = e.p1;
        d = e.p2;
        if (d > Math.PI * 2) {
            d = d - Math.PI * 2;
        }
        if (d == Math.PI * 2) {
            if (this.ca) {
                return 0;
            }
            else {
                return this.j7;
            }
        }
        let f = this.getUnscaledAngle(d);
        if (f < 0 || f > this.j7) {
            f = this.getUnscaledAngle(d + Math.PI * 2);
        }
        return f;
    }
    getScaledAngle(a) {
        let b = this.j7;
        let c = b >= 2 ? (a) / (b) : b == 1 ? 0.5 : NaN;
        if (this.cb) {
            c = 1 - c;
        }
        return (c * 2 * Math.PI) + this.lg;
    }
    getUnscaledAngle(a) {
        if (a < this.lg) {
            a += 2 * Math.PI;
        }
        let b = (a - this.lg) / (2 * Math.PI);
        if (this.ca) {
            b = 1 - b;
        }
        return b * (this.j7);
    }
    dy(a, b) {
        return this.getScaledAngle(a);
    }
    d1(a, b) {
        return this.getUnscaledAngle(a);
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.l0(f);
                if (f != null) {
                    f.l6(this);
                }
                this.ci = true;
                this.hb(false);
                break;
            case CategoryAngleAxis.$$p[0]:
                this.lg = this.lq;
                while (this.lg < 0) {
                    this.lg += 360;
                }
                while (this.lg >= 360) {
                    this.lg -= 360;
                }
                this.lg = (this.lg * Math.PI) / 180;
                this.ci = true;
                this.hb(false);
                for (let g of fromEnum(this.cz)) {
                    g.jl(false);
                    g.it();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.ci = true;
                        h.ha();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.ci = true;
                            i.ha();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.k7 = this.k6();
                this.ly();
                this.ci = true;
                this.hb(false);
                break;
        }
    }
    ly() {
        this.lf = NaN;
    }
    l0(a) {
        this.k9 = a;
    }
    get ln() {
        return this.c(CategoryAngleAxis.l1);
    }
    set ln(a) {
        this.h(CategoryAngleAxis.l1, a);
    }
    get lh() {
        return this.ld;
    }
    set lh(a) {
        if (this.lh != a) {
            let b = this.ld;
            this.ld = a;
            this.g5("ActualInterval", b, this.lh);
        }
    }
    d9() {
        return this.lh;
    }
    get lo() {
        return this.c(CategoryAngleAxis.l2);
    }
    set lo(a) {
        this.h(CategoryAngleAxis.l2, a);
    }
    get li() {
        return this.le;
    }
    set li(a) {
        if (this.li != a) {
            let b = this.le;
            this.le = a;
            this.g5("ActualMinorInterval", b, this.li);
        }
    }
    lc() {
        return false;
    }
    get_a1() {
        return 2;
    }
    get a1() {
        return this.get_a1();
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jn == null) {
            return false;
        }
        let a = this.jn.count;
        if (a != this.ls) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.ls, a);
            this.ls = a;
            this.g6(b);
            return true;
        }
        return false;
    }
    get ls() {
        return this.lr;
    }
    set ls(a) {
        this.lr = a;
    }
    i1(a, b, c, d = null, e = null) {
        let f = typeCast(RadialAxisRenderingParameters.$, this.k7.d(c, b, d, e));
        if (f == null) {
            return null;
        }
        let g = Math.cos(a);
        let h = Math.sin(a);
        let i = f.center.x + g * f.minLength;
        let j = f.center.y + h * f.minLength;
        let k = f.center.x + g * f.maxLength;
        let l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        let m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryAngleAxis.$t = markType(CategoryAngleAxis, 'CategoryAngleAxis', CategoryAxisBase.$, [IAngleScaler_$type]);
CategoryAngleAxis.l1 = DependencyProperty.i("Interval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.g5("Interval", b.oldValue, b.newValue);
    a.hb(false);
}));
CategoryAngleAxis.l2 = DependencyProperty.i("MinorInterval", Number_$type, CategoryAngleAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryAngleAxis.$, a)).g5("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryAngleAxis.$, a)).hb(false);
}));
CategoryAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryAngleAxis, 'g5', ['StartAngleOffset:lq:l3', [1, 0]]);
/**
 * @hidden
 */
class NumericAngleAxis extends NumericAxisBase {
    constructor() {
        super();
        this.ln = null;
        this.lo = false;
        this.lp = NaN;
        this.lq = 0;
        this.ll = null;
        this.ab = NumericAngleAxis.$;
        this.ln = new PolarAxisRenderingManager();
        this.jn = this.jl();
    }
    a3() {
        return new NumericAngleAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.lk = a;
    }
    get_b2() {
        return true;
    }
    au() {
        let a = new AngleAxisLabelPanel();
        a.c0 = (b) => {
            let c = this.bh != null ? this.bh.n2 : Rect.empty;
            let d = !c.isEmpty ? this.i9 : Rect.empty;
            return this.l0(b, { $type: Point_$type, x: 0.5, y: 0.5 }, c, d, this.av.ba);
        };
        return a;
    }
    lr() {
        if (this.lm == null) {
            return 0;
        }
        if (!this.b0()) {
            return this.lm.lw();
        }
        else {
            return this.lm.lx((this.e4));
        }
    }
    lt(a) {
        return Math.round(a * Math.pow(10, 10)) / Math.pow(10, 10);
    }
    jl() {
        let a = super.jl();
        a.b.c = (b) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.lm != null && this.lp != b) {
                let c = typeCast(XamDataChart.$, this.bh);
                if (c == null) {
                    return;
                }
                this.lp = b;
                this.av.a9 = b;
                c.it();
                for (let d of fromEnum(c.axes)) {
                    if (d != this && typeCast(AngleAxisLabelPanel.$, d.av) !== null) {
                        d.a4.ad();
                    }
                }
            }
        };
        a.e = (b) => {
            b.n = this.lr();
            b.r = b.n;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            if (c.e == c.k._inner[0]) {
                this.ln.i(b.t, b.n, b.z, b.aa, c.center, c.minAngle, c.maxAngle);
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.ln.m(c, d, b.z, b.aa, e.minLength, e.maxLength, e.center);
        };
        a.l = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.ln.n(c, d, e, f.z, b.aa, f.minLength, f.maxLength, f.center);
        };
        a.d = (b, c, d, e) => {
            let f = typeCast(PolarAxisRenderingParameters.$, this.jo(b, c, d, e));
            return f;
        };
        a.v = () => {
            if (!this.lo) {
                this.lo = true;
                this.lm.cn();
                this.lo = false;
            }
        };
        a.m = (b, c) => this.getScaledAngle(c);
        a.o = (b, c) => !c.isEmpty && !b.isEmpty && this.lm != null;
        a.q = (b, c) => {
            if (this.lt(c - this.lq) < 0) {
                return false;
            }
            if (this.lt(c - this.lq - (2 * Math.PI)) > 0) {
                return false;
            }
            return true;
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            let f = this.l0(this.getScaledAngle(e.l), e.center, b.aa, b.z, 0);
            let g = this.l0(c, e.center, b.aa, b.z, 0);
            if (d && MathUtil.e(f.x - g.x, f.y - g.y) < 2) {
                return false;
            }
            if (g.x < b.z.right && g.x >= b.z.left && g.y < b.z.bottom && g.y >= b.z.top) {
                return true;
            }
            return false;
        };
        a.r = (b, c, d, e) => {
            if (c < b.m && typeCast(LogarithmicTickmarkValues.$, b.f) !== null) {
                return b.m;
            }
            else if (c > b.l && (typeCast(LogarithmicTickmarkValues.$, b.f) !== null || b.h)) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    l0(a, b, c, d, e) {
        let f = this.lr();
        let g = ViewportUtils.b(e, c, d);
        if (this.ay != null && (this.ay.c == 5 || this.ay.c == 1)) {
            g *= -1;
        }
        let h = b.x + (f + g) * Math.cos(a);
        let i = b.y + (f + g) * Math.sin(a);
        h = ViewportUtils.c(h, c, d);
        i = ViewportUtils.f(i, c, d);
        return { $type: Point_$type, x: h, y: i };
    }
    dy(a, b) {
        return this.getScaledAngle(a);
    }
    getScaledAngle1(a, b, c) {
        let d = 0;
        if (b) {
            d = (Math.log(a) - this.ki) / (this.kh - this.ki);
        }
        else {
            d = (a - this.kc) / (this.kb - this.kc);
        }
        if (c) {
            d = 1 - d;
        }
        return (d * 2 * Math.PI) + this.lq;
    }
    getScaledAngle(a) {
        return this.getScaledAngle1(a, this.j2, this.cb);
    }
    d1(a, b) {
        return this.getUnscaledAngle(a);
    }
    getUnscaledAngle(a) {
        let b = (a - this.lq) / (2 * Math.PI);
        if (this.ca) {
            b = 1 - b;
        }
        if (this.j2) {
            return Math.exp(b * (this.kh - this.ki) + this.ki);
        }
        else {
            return this.kc + b * (this.kb - this.kc);
        }
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        let e = typeCast(XamDataChart.$, this.bh);
        switch (b) {
            case "CrossingAxis":
                let f = typeCast(NumericRadiusAxis.$, d);
                this.ly(f);
                if (f != null) {
                    f.l6(this);
                }
                this.hb(false);
                break;
            case NumericAngleAxis.$$p[0]:
                this.lq = this.lu;
                while (this.lq < 0) {
                    this.lq += 360;
                }
                while (this.lq >= 360) {
                    this.lq -= 360;
                }
                this.lq = (this.lu * Math.PI) / 180;
                this.hb(false);
                for (let g of fromEnum(this.cw())) {
                    g.jl(false);
                    g.it();
                }
                break;
            case "Label":
                if (e != null) {
                    for (let h of fromEnum(e.axes)) {
                        h.ha();
                    }
                }
                break;
            case "CrossingValue":
                if (e != null) {
                    for (let i of fromEnum(e.axes)) {
                        if (typeCast(NumericAngleAxis.$, i) !== null || typeCast(CategoryAngleAxis.$, i) !== null) {
                            i.ha();
                        }
                    }
                }
                break;
            case "LabelSettings":
                this.jn = this.jl();
                this.lw();
                this.ci = true;
                this.hb(false);
                break;
        }
    }
    lw() {
        this.lp = NaN;
    }
    jp() {
        return new PolarAxisRenderingParameters();
    }
    jo(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.jo(a, b, c, d));
        let f = this.ln.f(b);
        let g = this.ln.g(b);
        let h = 0.5 * this.lm.lr;
        let i = 0.5 * this.lm.lq;
        let j = f;
        let k = g;
        let l = this.lm.lw();
        if (isNaN_(l) || isInfinity(l)) {
            return null;
        }
        if (k >= h) {
            k = l;
        }
        if (j < i) {
            j = i;
        }
        let m = a.width;
        this.ln.k(b, e, this.kc, this.kb, this.ca, runOn(this, this.getUnscaledAngle), m);
        let n = { $type: Point_$type, x: 0.5, y: 0.5 };
        e.center = n;
        e.maxLength = k;
        e.minLength = j;
        e.effectiveMaximum = l;
        return e;
    }
    getMinMaxAngle(a, b, c) {
        let d = this.ln.l(a, b, c);
        b = d.p1;
        c = d.p2;
        return {
            p1: b,
            p2: c
        };
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = this.jn.c(a, c, b, d, e);
        if (f != null) {
            this.ka = f.f.m;
            this.kd = f.f.l;
        }
    }
    get lm() {
        if (this.ll != null) {
            return this.ll;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (a.axes._inner[b].ce) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.ll;
    }
    set lm(a) {
        this.ll = a;
    }
    aj() {
        return this.lm;
    }
    ly(a) {
        this.lm = a;
    }
    hn(a, b) {
        super.hn(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cn();
        }
    }
    get_a1() {
        return 2;
    }
    get a1() {
        return this.get_a1();
    }
    i1(a, b, c, d = null, e = null) {
        if (this.lm == null) {
            return null;
        }
        let f = typeCast(PolarAxisRenderingParameters.$, this.jo(c, b, d, e));
        if (f == null) {
            return null;
        }
        let g = Math.cos(a);
        let h = Math.sin(a);
        let i = f.center.x + g * f.minLength;
        let j = f.center.y + h * f.minLength;
        let k = f.center.x + g * f.maxLength;
        let l = f.center.y + h * f.maxLength;
        i = ViewportUtils.c(i, b, c);
        j = ViewportUtils.f(j, b, c);
        k = ViewportUtils.c(k, b, c);
        l = ViewportUtils.f(l, b, c);
        let m = new LineGeometry();
        m.d = { $type: Point_$type, x: i, y: j };
        m.c = { $type: Point_$type, x: k, y: l };
        return m;
    }
}
NumericAngleAxis.$t = markType(NumericAngleAxis, 'NumericAngleAxis', NumericAxisBase.$, [IAngleScaler_$type]);
NumericAngleAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericAngleAxis, 'g5', ['StartAngleOffset:lu:lz', [1, 0]]);
/**
 * @hidden
 */
class NumericRadiusAxis extends NumericAxisBase {
    constructor() {
        super();
        this.ln = null;
        this.lo = false;
        this.lp = NaN;
        this.lr = 0;
        this.lq = 0;
        this.lt = 0;
        this.lk = null;
        this.ab = NumericRadiusAxis.$;
        this.lr = this.l1;
        this.lq = this.l0;
        this.ln = new PolarAxisRenderingManager();
        this.jn = this.jl();
    }
    a3() {
        return new NumericRadiusAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.lm = a;
    }
    get_ce() {
        return true;
    }
    dx() {
        let a = this.lr;
        let b = this.lq;
        let c = Math.min(this.lv(), this.lu()) * (a - b) / 2;
        c = Math.max(c, 14);
        return c;
    }
    lv() {
        return this.i9.width;
    }
    lu() {
        return this.i9.height;
    }
    au() {
        return new RadialAxisLabelPanel();
    }
    ls(a) {
        if (a == null) {
            return 0;
        }
        return a;
    }
    jl() {
        let a = super.jl();
        a.b.c = (b) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.ll != null) {
                if ((this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) && this.lp != b) {
                    this.lp = b;
                    this.av.a9 = b;
                    this.bh.it();
                }
            }
        };
        a.k = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            this.ln.i(c, d, e.z, e.aa, e.center, e.minAngle, e.maxAngle);
        };
        a.l = (b, c, d, e) => {
            if (d == e) {
                return;
            }
            let f = typeCast(PolarAxisRenderingParameters.$, b);
            this.ln.j(c, d, e, f.z, f.aa, f.center, f.minAngle, f.maxAngle);
        };
        a.m = (b, c) => this.lx(c);
        a.q = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.n = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return c <= d.effectiveMaximum;
        };
        a.j = (b) => {
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            this.ln.m(b.t, c.crossingAngleRadians, b.z, b.aa, c.minLength, c.maxLength, c.center);
        };
        a.e = (b) => {
            b.n = this.ay == null || (this.ay.c == 4 || this.ay.c == 0) ? b.z.top : b.z.bottom;
            b.r = b.n;
            let c = typeCast(PolarAxisRenderingParameters.$, b);
            c.crossingAngleRadians = (this.ls(this.e4) * Math.PI) / 180;
            if (this.ay == null || (this.ay.c == 4 || this.ay.c == 5)) {
                c.n = ViewportUtils.f(0.5, c.aa, c.z) - b.z.top;
                c.r = c.n;
                let d = typeCast(RadialAxisLabelPanel.$, this.av);
                if (d != null) {
                    let e = 0;
                    if (this.ay != null && this.ay.c == 4) {
                        e = 1;
                    }
                    d.dh = { $type: Point_$type, x: ViewportUtils.c(0.5, c.aa, c.z), y: e };
                    d.de = c.crossingAngleRadians;
                }
            }
        };
        a.p = (b, c, d) => {
            let e = typeCast(PolarAxisRenderingParameters.$, b);
            if (this.ll == null) {
                return false;
            }
            if (c > e.effectiveMaximum) {
                return false;
            }
            let f = false;
            f = this.ay == null || (this.ay.c == 4 || this.ay.c == 5);
            let g = 0;
            if (f) {
                g = this.lt;
            }
            let h = e.center.x + c * Math.cos(g);
            let i = e.center.y + c * Math.sin(g);
            h = ViewportUtils.c(h, e.aa, e.z);
            i = ViewportUtils.f(i, e.aa, e.z);
            if (h <= b.z.right && h >= b.z.left && ((i <= b.z.bottom && i >= b.z.top) || !f)) {
                return true;
            }
            return false;
        };
        a.h = (b, c) => {
            let d = typeCast(PolarAxisRenderingParameters.$, b);
            return new LabelPosition(ViewportUtils.c(d.center.x + c, d.aa, d.z));
        };
        a.r = (b, c, d, e) => {
            if (c < b.m) {
                return b.m;
            }
            else if (c > b.l) {
                return b.l;
            }
            return c;
        };
        return a;
    }
    dy(a, b) {
        return this.lx(a);
    }
    ly(a, b, c, d, e) {
        let f = 0;
        if (b) {
            if (a <= 0) {
                f = (Math.log(this.kc) - this.ki) / (this.kh - this.ki);
            }
            else {
                f = (Math.log(a) - this.ki) / (this.kh - this.ki);
            }
        }
        else {
            f = (a - this.kc) / (this.kb - this.kc);
        }
        if (c) {
            f = 1 - f;
        }
        f = e + (f * (d - e));
        f /= 2;
        return f;
    }
    lx(a) {
        return this.ly(a, this.j2, this.cb, this.lr, this.lq);
    }
    lz(a) {
        let b = a * 2;
        b = (b - this.lq) / (this.lr - this.lq);
        if (this.ca) {
            b = 1 - b;
        }
        if (this.j2) {
            return Math.exp(b * (this.kh - this.ki) + this.ki);
        }
        else {
            return this.kc + b * (this.kb - this.kc);
        }
    }
    d1(a, b) {
        return this.lz(a);
    }
    gz(a, b, c, d) {
        switch (b) {
            case "CrossingValue":
                this.lt = this.ls(this.e4) * Math.PI / 180;
                break;
        }
        super.gz(a, b, c, d);
        switch (b) {
            case NumericRadiusAxis.$$p[1]:
                this.lr = this.l1;
                if (this.lr < 0) {
                    this.lr = 0.1;
                }
                if (this.lr > 1) {
                    this.lr = 1;
                }
                if (this.lq >= this.lr) {
                    this.lq = this.lr - 0.01;
                    if (this.lq < 0) {
                        this.lq = 0;
                        this.lr = 0.01;
                    }
                }
                this.ci = true;
                this.hb(false);
                if (this.ll != null) {
                    this.ll.ha();
                }
                for (let e of fromEnum(this.cw())) {
                    e.jl(false);
                }
                break;
            case NumericRadiusAxis.$$p[0]:
                this.lq = this.l0;
                if (this.lq < 0) {
                    this.lq = 0.1;
                }
                if (this.lq > 1) {
                    this.lq = 1;
                }
                if (this.lq >= this.lr) {
                    this.lq = this.lr - 0.01;
                    if (this.lq < 0) {
                        this.lq = 0;
                        this.lr = 0.01;
                    }
                }
                this.ci = true;
                this.hb(false);
                if (this.ll != null) {
                    this.ll.ha();
                }
                for (let f of fromEnum(this.cw())) {
                    f.dl = true;
                    f.jl(false);
                }
                if (this.bh != null) {
                    this.bh.i1();
                }
                break;
            case "CrossingAxis":
                let g = typeCast(NumericAngleAxis.$, d);
                let h = typeCast(CategoryAngleAxis.$, d);
                if (g == null && h == null) {
                    this.l6(null);
                }
                if (g != null) {
                    this.l6(g);
                    g.ly(this);
                }
                if (h != null) {
                    this.l6(h);
                    h.l0(this);
                }
                this.ci = true;
                this.hb(false);
                break;
            case "IsInverted":
                if (this.ll != null) {
                    this.ll.ci = true;
                    this.ll.hb(false);
                }
                break;
        }
    }
    l6(a) {
        this.ll = a;
    }
    get ll() {
        if (this.lk != null) {
            return this.lk;
        }
        let a = typeCast(XamDataChart.$, this.bh);
        if (a != null) {
            for (let b = 0; b < a.axes.count; b++) {
                if (typeCast(NumericAngleAxis.$, a.axes._inner[b]) !== null || typeCast(CategoryAngleAxis.$, a.axes._inner[b]) !== null) {
                    return a.axes._inner[b];
                }
            }
        }
        return this.lk;
    }
    set ll(a) {
        this.lk = a;
    }
    aj() {
        return this.ll;
    }
    jp() {
        return new PolarAxisRenderingParameters();
    }
    jo(a, b, c, d) {
        let e = typeCast(PolarAxisRenderingParameters.$, super.jo(a, b, c, d));
        let f = this.ln.f(b);
        let g = this.ln.g(b);
        let h = 0.5 * this.lr;
        let i = 0.5 * this.lq;
        let j, k;
        if (Rect.l_op_Equality(b, SeriesViewer.oe)) {
            k = this.kb;
            j = this.kc;
        }
        else {
            k = Math.min(g, h);
            j = this.lz(f);
            k = this.lz(k);
            let l = this.l7(a, b, j, k);
            j = l.p2;
            k = l.p3;
        }
        let m = { $type: Point_$type, x: 0.5, y: 0.5 };
        let n = f;
        let o = g;
        let p = Math.min(a.width, a.height) * (this.lr - this.lq) / 2;
        e.center = m;
        let q = Math.max(o, n);
        let r = Math.min(n, o);
        e.maxLength = q;
        e.minLength = r;
        let s = Math.min(j, k);
        let t = Math.max(j, k);
        if (s < this.kc) {
            s = this.kc;
        }
        if (t > this.kb) {
            t = this.kb;
        }
        this.kf = s;
        this.ke = t;
        e.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = s;
            $ret.c = t;
            $ret.b = p;
            return $ret;
        })()));
        let u = typeCast(IAngleScaler_$type, this.ll);
        if (u != null) {
            let v;
            let w;
            let x = u.getMinMaxAngle(b, v, w);
            v = x.p1;
            w = x.p2;
            e.minAngle = Math.min(v, w);
            e.maxAngle = Math.max(v, w);
        }
        let y = this.lw();
        if (o >= h) {
            o = y;
        }
        if (n < i) {
            n = i;
        }
        e.minLength = n;
        e.maxLength = o;
        e.effectiveMaximum = y;
        e.f = this.js;
        let z = typeCast(LinearTickmarkValues.$, e.f);
        if (z != null) {
            z.y = this.l2(m, e.minLength, e.maxLength, b, a);
        }
        return e;
    }
    l7(a, b, c, d) {
        let e = { $type: Point_$type, x: 0.5, y: 0.5 };
        let f = 0;
        if (this.ca) {
            f = this.lx(this.kc);
        }
        else {
            f = this.lx(this.kb);
        }
        let g = 0;
        if (this.e4 != null) {
            g = this.lt;
        }
        let h = e.x + f * Math.cos(g);
        let i = e.y + f * Math.sin(g);
        e.x = ViewportUtils.c(e.x, b, a);
        e.y = ViewportUtils.f(e.y, b, a);
        h = ViewportUtils.c(h, b, a);
        i = ViewportUtils.f(i, b, a);
        if (h >= a.left && h <= a.right && i >= a.top && i <= a.bottom) {
            if (this.ca) {
                d = this.kc;
            }
            else {
                d = this.kb;
            }
        }
        if (e.x >= a.left && e.x <= a.right && e.y >= a.top && e.y <= a.bottom) {
            if (this.ca) {
                c = this.kb;
            }
            else {
                c = this.kc;
            }
        }
        return {
            p2: c,
            p3: d
        };
    }
    l2(a, b, c, d, e) {
        let f = ViewportUtils.d(c - b, d, e);
        let g = f / Math.min(e.width, e.height);
        if (g > 0.7) {
            return 10;
        }
        return 5;
    }
    lw() {
        let a = 0;
        if (!this.ca) {
            a = this.lx(this.kb);
        }
        else {
            a = this.lx(this.kc);
        }
        return a;
    }
    la(a) {
        if (this.ll != null) {
            this.ll.ha();
        }
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = this.jn.c(a, c, b, d, e);
        if (f != null) {
            this.ka = f.f.m;
            this.kd = f.f.l;
        }
    }
    hn(a, b) {
        super.hn(a, b);
        if (b.height != a.height || b.width != a.width) {
            this.cn();
        }
    }
    l5(a, b, c, d, e) {
        let f = typeCast(IPolarRadialRenderingParameters_$type, this.jo(b, c, d, e));
        if (f == null) {
            return;
        }
        this.ln.j(a.d, f.minLength, f.maxLength, b, c, f.center, f.minAngle, f.maxAngle);
    }
    get_a1() {
        return 3;
    }
    get a1() {
        return this.get_a1();
    }
    i1(a, b, c, d = null, e = null) {
        let f = typeCast(PolarAxisRenderingParameters.$, this.jo(c, b, d, e));
        let g = a;
        let h = new PathGeometry();
        let i = ViewportUtils.d(g, b, c);
        let j = ViewportUtils.g(g, b, c);
        if (i <= 0 || j <= 0) {
            return null;
        }
        let k = ViewportUtils.c(f.center.x, b, c);
        let l = ViewportUtils.f(f.center.y, b, c);
        if (f.maxAngle - f.minAngle < Math.PI && f.maxAngle - f.minAngle > 0) {
            let m = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.minAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.minAngle), b, c) };
            let n = { $type: Point_$type, x: ViewportUtils.c(f.center.x + g * Math.cos(f.maxAngle), b, c), y: ViewportUtils.f(f.center.y + g * Math.sin(f.maxAngle), b, c) };
            let o = new PathFigure();
            o._startPoint = m;
            o._isClosed = false;
            o._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = n;
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(o);
        }
        else {
            let p = new PathFigure();
            p._startPoint = { $type: Point_$type, x: k, y: l - j };
            p._isClosed = true;
            p._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l + j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            p._segments.add(((() => {
                let $ret = new ArcSegment();
                $ret.b = false;
                $ret.e = { $type: Point_$type, x: k, y: l - j };
                $ret.f = new Size(1, i, j);
                $ret.d = 1;
                return $ret;
            })()));
            h.c.add(p);
        }
        return h;
    }
}
NumericRadiusAxis.$t = markType(NumericRadiusAxis, 'NumericRadiusAxis', NumericAxisBase.$);
NumericRadiusAxis.$$p = markDep(DependencyProperty, PropertyMetadata, NumericRadiusAxis, 'g5', ['InnerRadiusExtentScale:l0:l8', [1, 0], 'RadiusExtentScale:l1:l9', [1, 0.75]]);
/**
 * @hidden
 */
class AngleAxisLabelPanelView extends AxisLabelPanelBaseView {
    constructor(a) {
        super(a);
        this.ax = null;
        this.ax = a;
    }
    am() {
        super.am();
        this.ax.cu = true;
    }
    ay(a, b) {
        this.ax.cy = -1.7976931348623157E+308;
        this.ax.cv = -1.7976931348623157E+308;
        this.ax.cx = -1.7976931348623157E+308;
        this.ax.cw = -1.7976931348623157E+308;
        for (let c = 0; c < this.a.a4.count; c++) {
            let d = this.a.a4._inner[c];
            let e = this.a.a3._inner[c];
            let f = e.a;
            let g = this.ax.c0(e.c);
            let h = this.m(d);
            let i = this.l(d);
            let j = h + this.p() + this.q();
            let k = i + this.r() + this.o();
            let l = g.x - j / 2;
            let m = g.y - k / 2;
            this.ax.cx = Math.max(h, this.ax.cx);
            this.ax.cw = Math.max(i, this.ax.cw);
            this.ax.cy = Math.max(j, this.ax.cy);
            this.ax.cv = Math.max(k, this.ax.cv);
            let n = new Rect(0, l, m, j, k);
            a.add(n);
            b.add(f);
        }
    }
    o() {
        return 0;
    }
    p() {
        return 0;
    }
    q() {
        return 0;
    }
    r() {
        return 0;
    }
}
AngleAxisLabelPanelView.$t = markType(AngleAxisLabelPanelView, 'AngleAxisLabelPanelView', AxisLabelPanelBaseView.$);
/**
 * @hidden
 */
class CategoryAngleAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
CategoryAngleAxisView.$t = markType(CategoryAngleAxisView, 'CategoryAngleAxisView', CategoryAxisBaseView.$);
/**
 * @hidden
 */
class NumericAngleAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
NumericAngleAxisView.$t = markType(NumericAngleAxisView, 'NumericAngleAxisView', NumericAxisBaseView.$);
/**
 * @hidden
 */
class NumericRadiusAxisView extends NumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
NumericRadiusAxisView.$t = markType(NumericRadiusAxisView, 'NumericRadiusAxisView', NumericAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxCategoryAngleAxisComponent_1;
/**
 * Represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories.
*
* `IgxCategoryAngleAxisComponent` represents a IgxDataChartComponent category angle axis. Useful for displaying radial categories
*
* ```html
* <igx-data-chart
*     [dataSource]="dataSource"   >
*     <igx-category-angle-axis name="angleAxis" label="Department" />
*     <igx-numeric-radius-axis name="radiusAxis" />
*  </igx-data-chart>
* ```
*/
const IgxCategoryAngleAxisComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryAngleAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryAngleAxisComponent) }];
let IgxCategoryAngleAxisComponent = IgxCategoryAngleAxisComponent_1 = class IgxCategoryAngleAxisComponent extends IgxCategoryAxisBaseComponent {
    constructor() {
        super();
        this._actualIntervalChange = null;
    }
    createImplementation() {
        return new CategoryAngleAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if the axis is of angular type
    */
    get isAngular() {
        return this.i.b2;
    }
    /**
     * Indicates the angle in degress that the chart's 0th angle should be offset.
    *
    * Indicates the angle in degress that the chart's 0th angle should be offset.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="dataSource"   >
    *     <igx-category-angle-axis name="angleAxis" startAngleOffset=30/>
    *     <igx-numeric-radius-axis name="radiusAxis" />
    *  </igx-data-chart>
    * ```
    */
    get startAngleOffset() {
        return this.i.lq;
    }
    set startAngleOffset(v) {
        this.i.lq = +v;
    }
    /**
     * Gets or sets the frequency of displayed labels.
     * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
    *
    * Gets or sets the frequency of displayed labels.The set value is a factor that determines which labels will be hidden.
    * For example, an interval of 2 will display every other label.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="dataSource"   >
    *     <igx-category-angle-axis name="angleAxis" interval =2 />
    *     <igx-numeric-radius-axis name="radiusAxis" />
    *  </igx-data-chart>
    * ```
    */
    get interval() {
        return this.i.ln;
    }
    set interval(v) {
        this.i.ln = +v;
    }
    /**
     * Gets the effective value for the current Interval.
    *
    * Gets the effective value for the current Interval.
    */
    get actualInterval() {
        return this.i.lh;
    }
    set actualInterval(v) {
        this.i.lh = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines.
     * The set value is a factor that determines how the minor lines will be displayed.
    *
    * Gets or sets the frequency of displayed minor lines. The set value is a factor that determines how the minor lines will be displayed.
    */
    get minorInterval() {
        return this.i.lo;
    }
    set minorInterval(v) {
        this.i.lo = +v;
    }
    /**
     * Gets the effective value for the current MinorInterval.
    *
    * Get the effective value for the current minorInterval.
    */
    get actualMinorInterval() {
        return this.i.li;
    }
    set actualMinorInterval(v) {
        this.i.li = +v;
    }
    /**
     * Gets the scaled angle in radians from the raw axis value.
    
    * @param unscaledAngle  * The raw axis value.
    */
    getScaledAngle(unscaledAngle) {
        let iv = this.i.getScaledAngle(unscaledAngle);
        return (iv);
    }
    /**
     * Gets the raw axis value from the scaled angle in radians.
    
    */
    getUnscaledAngle(scaledAngle) {
        let iv = this.i.getUnscaledAngle(scaledAngle);
        return (iv);
    }
    get actualIntervalChange() {
        if (this._actualIntervalChange == null) {
            this._actualIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualInterval;
                if (this.beforeActualIntervalChange) {
                    this.beforeActualIntervalChange(this, ext);
                }
                this._actualIntervalChange.emit(ext);
            });
        }
        return this._actualIntervalChange;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAngleAxisComponent.prototype, "startAngleOffset", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAngleAxisComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAngleAxisComponent.prototype, "actualInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAngleAxisComponent.prototype, "minorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryAngleAxisComponent.prototype, "actualMinorInterval", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryAngleAxisComponent.prototype, "actualIntervalChange", null);
IgxCategoryAngleAxisComponent = IgxCategoryAngleAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-category-angle-axis',
        template: ``,
        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryAngleAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryAngleAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryAngleAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryAngleAxisModule = class IgxCategoryAngleAxisModule {
};
IgxCategoryAngleAxisModule = __decorate([
    NgModule({
        declarations: [IgxCategoryAngleAxisComponent],
        imports: [CommonModule],
        exports: [IgxCategoryAngleAxisComponent],
        entryComponents: []
    })
], IgxCategoryAngleAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryAngleAxisDynamicModule = class IgxCategoryAngleAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryAngleAxisComponent", IgxCategoryAngleAxisComponent);
        TypeRegistrar.register("CategoryAngleAxis", CategoryAngleAxis.$type);
    }
};
IgxCategoryAngleAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryAngleAxisModule],
        exports: [IgxCategoryAngleAxisModule],
        entryComponents: [IgxCategoryAngleAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryAngleAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SortedListView$1 extends Base {
    constructor($t, a, b) {
        super();
        this.$t = null;
        this.c = null;
        this.d = null;
        this.$t = $t;
        this.$type = this.$type.specialize(this.$t);
        this.c = b;
        this.d = a;
    }
    add(a) {
        throw new NotImplementedException(0);
    }
    clear() {
        throw new NotImplementedException(0);
    }
    contains(a) {
        return this.d.contains(a);
    }
    indexOf(a) {
        return this.c.indexOf(this.d.indexOf(a));
    }
    insert(a, b) {
        throw new NotImplementedException(0);
    }
    get a() {
        return true;
    }
    get isReadOnly() {
        return true;
    }
    remove(a) {
        throw new NotImplementedException(0);
    }
    removeAt(a) {
        throw new NotImplementedException(0);
    }
    item(a, b) {
        if (arguments.length === 2) {
            throw new NotImplementedException(0);
            return b;
        }
        else {
            return this.d.item(this.c.item(a));
        }
    }
    get count() {
        return this.d.count;
    }
    get b() {
        throw new NotImplementedException(0);
    }
    get e() {
        throw new NotImplementedException(0);
    }
    *_getEnumeratorObject() {
        for (let a = 0; a < this.count; a++) {
            yield getBoxIfEnum(this.$t, this.item(a));
        }
    }
    getEnumeratorObject() {
        return toEnum(() => this._getEnumeratorObject()).getEnumeratorObject();
    }
    *_getEnumerator() {
        for (let a = 0; a < this.count; a++) {
            yield this.item(a);
        }
    }
    getEnumerator() {
        return toEnum(() => this._getEnumerator()).getEnumerator();
    }
    copyTo(a, b) {
        throw new NotImplementedException(0);
    }
}
SortedListView$1.$t = markType(SortedListView$1, 'SortedListView$1', Base.$, [IList$1_$type.specialize(0)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisBase extends CategoryAxisBase {
    constructor() {
        super();
        this.k4 = null;
        this.ld = null;
        this.k8 = false;
        this.lg = dateMaxValue();
        this.lf = dateMinValue();
        FastItemDateTimeColumn.o();
    }
    dy(a, b) {
        if (!b.c.isEmpty) {
            let c = this.ll(a, NumericScaler.ac, b.c, Rect.empty);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ll(a, b.e, b.d, b.c);
    }
    e6(a, b) {
        let c = this.f0(b);
        if (c == this.dateTimeMemberPath) {
            return this.e7(a, b, this.dateTimeMemberPath);
        }
        return super.e6(a, b);
    }
    ll(a, b, c, d) {
        let e;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            e = -1;
        }
        else {
            e = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let f = 0;
        if (this.categoryMode == 2) {
            f = this.getGroupCenter(0, b, c, d);
        }
        if (this.ca) {
            e = 1 - e;
            f = -f;
        }
        return c.left + c.width * (e - b.left) / b.width - f;
    }
    lm(a, b, c) {
        let d;
        if (+(this.actualMaximumValue) == +(this.actualMinimumValue)) {
            d = -1;
        }
        else {
            d = (a - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        }
        let e = 0;
        if (this.ca) {
            d = 1 - d;
            e = -e;
        }
        return c.left + c.width * (d - b.left) / b.width - e;
    }
    d1(a, b) {
        if (!b.c.isEmpty) {
            let c = b.d.left;
            let d = b.d.width;
            if (this.categoryMode != 0) {
                let e = this.getCategorySize(b.e, b.d, b.c);
                c += e / 2;
                d -= e;
            }
            let f = b.e.left + b.e.width * (a - c) / b.d.width;
            f = (f * b.d.width) + b.d.left;
            f = this.getUnscaledValue3(f, NumericScaler.ac, b.c, this.categoryMode);
            return f;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.left + b.width * (a - c.left) / c.width;
        if (this.ca) {
            e = 1 - e;
        }
        return truncate(Math.floor(this.actualMinimumValue.getTime() + e * (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime())));
    }
    i$h() {
        this.l1();
    }
    l1() {
        let a = this.bh != null ? this.bh.n2 : Rect.empty;
        let b = !a.isEmpty ? this.i9 : Rect.empty;
        let c = (new Date());
        let d = (new Date());
        let e = false;
        if (!a.isEmpty && !b.isEmpty && this.k5 != null) {
            let f = typeCast(FastItemDateTimeColumn.$, this.k5);
            if (f != null) {
                if (this.le == null) {
                    this.l2();
                }
            }
            else {
                this.le = null;
            }
            if (this.k5.count > 0) {
                e = true;
                let g = this.le == null ? 0 : this.le._inner[0];
                let h = this.le == null ? this.k5.count - 1 : this.le._inner[this.k5.count - 1];
                c = this.k5.item(g);
                d = this.k5.item(h);
                this.k9 = false;
                if (this.categoryMode == 2) {
                    let i = this.lz(c, d);
                    if (+c != +(dateMinValue())) {
                        c = dateSubtract(+c, +i);
                    }
                    d = dateAdd(+d, +i);
                }
            }
        }
        if (this.lc()) {
            e = true;
            c = this.minimumValue;
        }
        if (this.lb()) {
            e = true;
            d = this.maximumValue;
        }
        let j = +(this.actualMinimumValue) != +c || +(this.actualMaximumValue) != +d;
        if (e && j) {
            let k = this.actualMinimumValue;
            let l = this.actualMaximumValue;
            this.actualMinimumValue = c;
            this.actualMaximumValue = d;
            this.l6();
        }
    }
    l6() {
    }
    get k5() {
        return this.k4;
    }
    set k5(a) {
        if (this.k4 != a) {
            let b = this.k4;
            this.k4 = a;
            this.g5("DateTimeColumn", b, this.k4);
        }
    }
    get le() {
        return this.ld;
    }
    set le(a) {
        this.ld = a;
    }
    get i$b() {
        if (this.le == null) {
            let a = typeCast(FastItemDateTimeColumn.$, this.k5);
            if (a != null) {
                this.l2();
            }
            else {
                this.le = null;
            }
        }
        return this.le;
    }
    l2() {
        if (this.la) {
            this.le = new List$1(Number_$type, 0);
            let a = this.le;
            let b = this.k5.count;
            for (let c = 0; c < b; c++) {
                a.add(c);
            }
        }
        else {
            let d = typeCast(FastItemDateTimeColumn.$, this.k5);
            this.le = d.h();
        }
    }
    i$e(a, b, c, d) {
        return this.lo(a, b, c, d);
    }
    lo(a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        let e = d;
        let f = new ScalerParams(0, a, b, this.ca, c);
        let g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(g)));
        return this.ln(dateFromTicks(i));
    }
    ln(a) {
        if (this.k5 == null || this.le.count != this.k5.count) {
            return -1;
        }
        let b = new SortedListView$1(Date_$type, this.k5, this.le);
        let c = this.lp(a, b);
        if (c >= 0 && c < this.le.count) {
            let d = this.k5.item(this.le._inner[c]);
            if (d > a) {
                c--;
                if (c < 0) {
                    c = 0;
                }
            }
            return c;
        }
        return this.le.count - 1;
    }
    i$g(a, b, c, d) {
        return this.lr(a, b, c, d);
    }
    lr(a, b, c, d) {
        if (b.isEmpty) {
            return -1;
        }
        let e = d;
        let f = new ScalerParams(0, a, b, this.ca, c);
        let g, h;
        if (this.ca) {
            h = this.d1(e.left, f);
            g = this.d1(e.right, f);
        }
        else {
            g = this.d1(e.left, f);
            h = this.d1(e.right, f);
        }
        let i = Math.max(dateMinValue().getTime(), Math.min(dateMaxValue().getTime(), truncate(h)));
        return this.lq(dateFromTicks(i));
    }
    lq(a) {
        if (this.k5 == null || this.le.count != this.k5.count) {
            return -1;
        }
        let b = new SortedListView$1(Date_$type, this.k5, this.le);
        let c = this.lp(a, b);
        if (c >= this.le.count) {
            c = this.le.count - 1;
        }
        if (c >= 0 && c < this.le.count) {
            let d = this.k5.item(this.le._inner[c]);
            if (d < a) {
                c++;
                if (c > this.le.count - 1) {
                    c = this.le.count - 1;
                }
            }
            return c;
        }
        return 0;
    }
    i$d(a) {
        if (this.k5 == null) {
            return NaN;
        }
        let b = this.k4.item(a);
        let c = b.getTime();
        let d = c;
        return d;
    }
    i$c(a) {
        let b = this;
        if (b.i$b == null) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.k5, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.lp(d, c);
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let diff1_ = d.getTime() - c.item(e - 1).getTime();
            let diff2_ = c.item(e).getTime() - d.getTime();
            let f = e - 1;
            let g = e;
            if (f < 0 && g >= 0) {
                return g;
            }
            if (g > b.i$b.count - 1 && f < b.i$b.count) {
                return f;
            }
            if (f < 0 && g < 0) {
                return -1;
            }
            if (f > b.i$b.count - 1 && g > b.i$b.count - 1) {
                return -1;
            }
            let h = diff1_ / (diff1_ + diff2_);
            if (isNaN_(h)) {
                h = 0;
            }
            return f + h;
        }
        if (e >= 0 && e < b.i$b.count) {
            return e;
        }
        let i = this.i4();
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, i)) < (this.i9.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, i)) - this.i9.left) < 2) {
            return 0;
        }
        return -1;
    }
    lp(a, b) {
        let c = this;
        if (this.k5 == null || c.i$b == null) {
            return -1;
        }
        let d = -1;
        let e = ArrayExtension.binarySearch$11(Date_$type, b, (f) => {
            if (a < f) {
                return -1;
            }
            if (a > f) {
                return 1;
            }
            return 0;
        });
        if (e >= 0) {
            d = e;
        }
        else {
            d = ~e;
        }
        while (d >= 0 && d < b.count && d - 1 >= 0 && +(b.item(d)) == +(b.item(d - 1))) {
            d--;
        }
        return d;
    }
    i$f(a) {
        let b = this;
        if (b.i$b == null || this.k5 == null || b.i$b.count != this.k5.count) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.k5, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.lp(d, c);
        let f = this.i4();
        if (e >= 0 && e < b.i$b.count && e - 1 >= 0 && e - 1 < b.i$b.count) {
            let g = +d - +(c.item(e - 1));
            let h = +(c.item(e)) - +d;
            if (g < h) {
                e = e - 1;
            }
        }
        if (e >= 0 && e < b.i$b.count) {
            return b.i$b._inner[e];
        }
        if (e == b.i$b.count && this.bh != null && this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, f)) < (this.i9.right + 2)) {
            return e - 1;
        }
        if (e == -1 && this.bh != null && Math.abs(this.dy(a, new ScalerParams(0, this.bh.n2, this.i9, this.ca, f)) - this.i9.left) < 2) {
            return 0;
        }
        return -1;
    }
    i$i() {
        this.le = null;
        this.ha();
    }
    get_k9() {
        return this.k8;
    }
    set_k9(a) {
        this.k8 = a;
    }
    get k9() {
        return this.get_k9();
    }
    set k9(a) {
        this.set_k9(a);
    }
    g1(a) {
        super.g1(a);
        this.dateTimeMemberPath = a;
    }
    g4(a) {
        super.g4(a);
        this.minimumValue = a;
    }
    g3(a) {
        super.g4(a);
        this.maximumValue = a;
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        let a = this.actualMinimumValue.getTime();
        let b = this.actualMaximumValue.getTime();
        this.l1();
        let c = !this.lc() ? this.actualMinimumValue.getTime() : this.minimumValue.getTime();
        let d = !this.lb() ? this.actualMaximumValue.getTime() : this.maximumValue.getTime();
        let e = new AxisRangeChangedEventArgs(0, a, c, b, d);
        this.g6(e);
        return true;
    }
    lc() {
        if (+(this.minimumValue) == +(dateMinValue())) {
            return false;
        }
        return (this.minimumValue != null);
    }
    lb() {
        if (+(this.maximumValue) == +(dateMaxValue())) {
            return false;
        }
        return (this.maximumValue != null);
    }
    get actualMinimumValue() {
        return this.lg;
    }
    set actualMinimumValue(a) {
        let b = +(this.lg) != +a;
        if (b) {
            let c = this.lg;
            this.lg = a;
            this.g5("ActualMinimumValue", c, a);
        }
    }
    fb() {
        return this.actualMinimumValue;
    }
    get actualMaximumValue() {
        return this.lf;
    }
    set actualMaximumValue(a) {
        let b = +(this.lf) != +a;
        if (b) {
            let c = this.lf;
            this.lf = a;
            this.g5("ActualMaximumValue", c, a);
        }
    }
    fa() {
        return this.maximumValue;
    }
    l3(a) {
        this.hc(a);
        if (this.jn == null) {
            return;
        }
        for (let b of fromEnum(this.cw())) {
            b.jl(a);
        }
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.k5);
                    this.k5 = null;
                    e.event = delegateRemove(e.event, runOn(this, this.l0));
                }
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.le = null;
                    this.k5 = this.k6(this.dateTimeMemberPath);
                    f.event = delegateCombine(f.event, runOn(this, this.l0));
                }
                this.l3(false);
                break;
            case TimeAxisBase.$$p[0]:
                if (this.jn != null) {
                    this.jn.deregisterColumn(this.k5);
                    this.k5 = this.k6(this.dateTimeMemberPath);
                    this.le = null;
                }
                break;
            case TimeAxisBase.$$p[3]:
                this.cn();
                this.l3(false);
                break;
            case TimeAxisBase.$$p[2]:
                this.cn();
                this.l3(false);
                break;
            case "DateTimeColumn":
                this.l1();
                break;
        }
    }
    l0(a, b) {
        this.le = null;
    }
    k6(a) {
        return TimeAxisBase.k7(a, this);
    }
    static k7(a, b) {
        if (a == null) {
            return b.jn.registerColumnDateTime(null, null, false);
        }
        let c = null;
        let d = SeriesViewer.bn(a, b.coercionMethods);
        c = d.a;
        return b.jn.registerColumnDateTime(a, c, b.expectFunctions);
    }
    au() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    get_a1() {
        return 0;
    }
    get a1() {
        return this.get_a1();
    }
    hc(a) {
        super.hc(a);
        let b = this.a4.ay();
        let c = this.a4.a1();
        let d = this.a4.az();
        let e = this.a4.a0();
        let f = this.a4.e();
        let g = this.a4.f();
        let h = this.a4.g();
        this.hk();
        this.gn(b);
        this.gn(c);
        this.gn(d);
        this.gn(e);
        this.cx.clear();
        this.cy.clear();
        this.ju.clear();
        this.av.ac = this;
        let i = this.bh != null ? this.bh.n2 : Rect.empty;
        let j = !i.isEmpty ? this.i9 : Rect.empty;
        this.av.cq = i;
        this.av.cp = j;
        if (i.isEmpty || j.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0) {
            this.av.ab.clear();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        this.l1();
    }
    get_b7() {
        return true;
    }
    startCursor() {
    }
    resetCursor() {
    }
    StartTimeCursor() {
        this.startCursor();
    }
    ResetTimeCursor() {
        this.resetCursor();
    }
    getCategorySize(a, b, c) {
        if (this.j7 == 0) {
            return 0;
        }
        let d = this.i7(b, c);
        return d.width / (this.j7 * a.width);
    }
    getGroupCenter(a, b, c, d) {
        return this.getCategorySize(b, c, d) * 0.5;
    }
    jz(a, b, c) {
        let d = !isNaN_(this.jw) ? MathUtil.b(this.jw, 0, 1) : 0;
        let e = 1 - 0.5 * d;
        let f = this.getCategorySize(a, b, c) * e;
        return f;
    }
    get_cf() {
        return true;
    }
    lz(a, b) {
        return (0);
    }
    preferredCategoryMode(a) {
        return this.b5 ? 0 : 1;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
    get i$a() {
        return this.b7;
    }
}
TimeAxisBase.$t = markType(TimeAxisBase, 'TimeAxisBase', CategoryAxisBase.$, [ISortingAxis_$type, IDateTimeAxis_$type]);
TimeAxisBase.$$p = markDep(DependencyProperty, PropertyMetadata, TimeAxisBase, 'g5', ['DateTimeMemberPath::l7', [2, null], 'IsDataPreSorted:la:l8', [0, false], 'MaximumValue::l9', [3, null], 'MinimumValue::ma', [3, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for displaying of gridlines, tickmarks, and labels on a time axis.
 */
var TimeAxisDisplayType;
(function (TimeAxisDisplayType) {
    /**
     * Points occur at even intervals, even where data is not present at a given point.
     */
    TimeAxisDisplayType[TimeAxisDisplayType["Continuous"] = 0] = "Continuous";
    /**
     * Points occur when data is present, possibly at uneven intervals.
     */
    TimeAxisDisplayType[TimeAxisDisplayType["Discrete"] = 1] = "Discrete";
})(TimeAxisDisplayType || (TimeAxisDisplayType = {}));
/**
 * @hidden
 */
let TimeAxisDisplayType_$type = markEnum('TimeAxisDisplayType', 'Continuous,0|Discrete,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryDateTimeXAxis extends TimeAxisBase {
    constructor() {
        super();
        this.mh = 0;
        this.mi = 0;
        this.ab = CategoryDateTimeXAxis.$;
        this.actualMinimumValue = (new Date());
        this.actualMaximumValue = (new Date());
    }
    get_b6() {
        return this.mc == 0;
    }
    a3() {
        return new CategoryDateTimeXAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.mb = a;
    }
    get mj() {
        return this.mh;
    }
    set mj(a) {
        if (this.mj != a) {
            let b = this.mh;
            this.mh = a;
            this.g5("ActualInterval", b, this.mj);
        }
    }
    d9() {
        return this.mj;
    }
    get mn() {
        return typeGetValue(this.c(CategoryDateTimeXAxis.my));
    }
    set mn(a) {
        this.h(CategoryDateTimeXAxis.my, a);
    }
    get mk() {
        return this.mi;
    }
    set mk(a) {
        if (this.mk != a) {
            let b = this.mi;
            this.mi = a;
            this.g5("ActualMinorInterval", b, this.mk);
        }
    }
    ct(a, b, c) {
        let d = super.ct(a, b, c);
        if (!d) {
            return false;
        }
        return +(this.actualMinimumValue) != +(this.actualMaximumValue);
    }
    dl() {
        return this.mj;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = new ScalerParams(0, b, c, this.ca, d);
        if (this.k5 == null && !this.lb() && !this.lc()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty && (this.mc != 1 || this.k5 != null)) {
            let g = c.bottom;
            let h = g - c.top;
            if (this.ai != null) {
                let i = typeCast(NumericYAxis.$, this.ai);
                if (i != null) {
                    let j = this.hg(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.gv(this.a4.ay(), g, c, this.a4.e(), true);
            this.av.a9 = h;
            let k = this.a4.a1();
            let l = this.a4.f();
            let m = this.a4.az();
            let n = this.a4.a0();
            let o = this.a4.g();
            if (this.mc == 1) {
                let p = this.i$e(b, c, d, e);
                let q = this.i$g(b, c, d, e);
                if (p < 0 || q < 0) {
                    return;
                }
                let r = NaN;
                for (let s = p; s <= q; s++) {
                    let t = this.le == null ? s : this.le._inner[s];
                    let u = this.dy(this.k5.item(t).getTime(), f);
                    if (u == r) {
                        continue;
                    }
                    r = u;
                    if (this.categoryMode == 2) {
                        u += this.ca ? -this.getGroupCenter(s, b, c, d) : this.getGroupCenter(s, b, c, d);
                    }
                    if (u < e.left || u > e.right) {
                        continue;
                    }
                    this.hl(m, u, c, l, false);
                    this.ju.add(u);
                    if (this.jn != null && s < this.jn.count) {
                        let v = this.jn.item(t);
                        let w = super.e8(v);
                        if (!isNaN_(u) && !isInfinity(u) && w != null) {
                            if ((typeof w === 'string') && Base.equalsStatic(w, "")) {
                            }
                            else {
                                this.cx.add1(w);
                                this.cy.add(new LabelPosition(u));
                            }
                        }
                    }
                }
            }
            else {
                let x = this.d1(e.left, f);
                let y = this.d1(e.right, f);
                let z = Math.min(x, y);
                let aa = Math.max(x, y);
                let ab = new LinearNumericSnapper(0, z, aa, e.width, this.eb());
                let ac = this.k9 ? this.mg() : ab.g;
                this.mu(truncate(ac));
                let ad = truncate(Math.floor((z - this.actualMinimumValue.getTime()) / ac));
                let ae = truncate(Math.ceil((aa - this.actualMinimumValue.getTime()) / ac));
                let af = 0;
                if (this.categoryMode == 2) {
                    af = this.getGroupCenter(0, b, c, d);
                    af = this.ca ? -af : af;
                }
                let ag = truncate(Math.ceil(e.right));
                let ah = truncate(Math.floor(e.left));
                let ai = this.dy(this.actualMinimumValue.getTime() + ad * ac, f) + af;
                for (let aj = ad; aj <= ae; aj++) {
                    let ak = this.dy(this.actualMinimumValue.getTime() + (aj + 1) * ac, f) + af;
                    if (!isNaN_(ai) && !isInfinity(ai)) {
                        let al = truncate(Math.round(ai));
                        if (al <= ag) {
                            if (aj % 2 == 0) {
                                this.hm(k, ai, ak, c);
                            }
                            this.hl(m, ai, c, l, false);
                            this.ju.add(ai);
                            if (this.cl) {
                                let am = this.ml();
                                if (am > 0 && am < ac) {
                                    if (ac / am < 20) {
                                        let an = ai;
                                        let ao = Math.abs(this.dy(this.actualMinimumValue.getTime() + am, f) - this.dy(this.actualMinimumValue.getTime(), f));
                                        while (an + ao < ak) {
                                            if (Math.abs(an + ao - ak) < 0.0001) {
                                                break;
                                            }
                                            an += ao;
                                            if (an > 0) {
                                                this.hl(n, an, c, o, false);
                                            }
                                        }
                                        this.mv(am);
                                    }
                                }
                                else {
                                    for (let ap = 1; ap < ab.i; ++ap) {
                                        let aq = this.dy(this.actualMinimumValue.getTime() + aj * ac + (ap * ac) / ab.i, f) + af;
                                        this.hl(n, aq, c, o, false);
                                    }
                                    if (ab.i > 0) {
                                        this.mv(truncate((ac / ab.i)));
                                    }
                                }
                            }
                        }
                        if (al >= ah && al <= ag) {
                            let ar = this.actualMinimumValue.getTime() + aj * ac;
                            let ticks_ = truncate(Math.floor(ar));
                            let as = (new Date(ticks_));
                            let at = this.e8(as);
                            if (at != null) {
                                this.cx.add1(at);
                                this.cy.add(new LabelPosition(ai));
                            }
                        }
                    }
                    ai = ak;
                }
            }
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.it();
                }
            }
            this.av.a2 = this.cx;
            this.av.a3 = this.cy;
            this.ku();
        }
    }
    mg() {
        return this.mj;
    }
    ml() {
        return this.mn;
    }
    mu(a) {
        this.mj = a;
    }
    mv(a) {
        this.mk = a;
    }
    me() {
        return this.mm != 0;
    }
    md() {
        return this.mj == 0;
    }
    mf(a) {
        return this.k5 == null ? dateMinValue() : this.k5.item(a);
    }
    mt(a, b) {
        if (a > b || this.jn == null || this.jn.count == 0) {
            return;
        }
        let c = (a.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        let d = (b.getTime() - this.actualMinimumValue.getTime()) / (this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
        this.bh.oi = new Rect(0, c, this.bh.oi.y, d - c, this.bh.oi.height);
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case CategoryDateTimeXAxis.$$p[0]:
                this.ci = true;
                this.av.ak = this.mc == 1;
                this.hb(false);
                break;
            case CategoryDateTimeXAxis.$$p[1]:
                this.ci = true;
                this.hb(false);
                break;
        }
    }
    l1() {
        super.l1();
        if (this.me()) {
            this.mj = this.mm;
            let a = this.bh != null ? this.bh.n2 : Rect.empty;
            let b = !a.isEmpty ? this.i9 : Rect.empty;
            let c = Math.abs(this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime());
            this.k9 = this.md() || (this.mc == 1) || (1 * c / this.mg() > (b.width / a.width)) ? false : true;
        }
        else {
            this.k9 = false;
        }
    }
    lz(a, b) {
        let c = b.getTime() - a.getTime();
        let timeOffset_ = truncate(Math.round(intDivide(c, this.j7) / 2));
        return timeOffset_ == 0 ? timeSpanFromMilliseconds(1) : timeSpanFromMilliseconds(timeOffset_);
    }
    get_b5() {
        return true;
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
    get i$a() {
        return this.b7;
    }
}
CategoryDateTimeXAxis.$t = markType(CategoryDateTimeXAxis, 'CategoryDateTimeXAxis', TimeAxisBase.$);
CategoryDateTimeXAxis.my = DependencyProperty.i("MinorInterval", Number_$type, CategoryDateTimeXAxis.$, new PropertyMetadata(2, 0, (a, b) => {
    (typeCast(CategoryDateTimeXAxis.$, a)).g5("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryDateTimeXAxis.$, a)).hb(false);
}));
CategoryDateTimeXAxis.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryDateTimeXAxis, 'g5', ['DisplayType:mc:mw', [TimeAxisDisplayType_$type, enumGetBox(TimeAxisDisplayType_$type, 0)], 'Interval:mm:mx', [1, 0]]);
/**
 * @hidden
 */
class CategoryDateTimeXAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
    o(a) {
        let b = this.n(dateFromTicks(truncate(a)));
        return b;
    }
}
CategoryDateTimeXAxisView.$t = markType(CategoryDateTimeXAxisView, 'CategoryDateTimeXAxisView', CategoryAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents an category-based horizontal X axis that uses a DateTime scale.
*
* Represents horizontal axis that uses a DateTime scale.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-time-x-axis
* 		dateTimeMemberPath="date"
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*/
const IgxTimeAxisBaseComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxTimeAxisBaseComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxTimeAxisBaseComponent) }];
class IgxTimeAxisBaseComponent extends IgxCategoryAxisBaseComponent {
    constructor() {
        super();
        this._actualMinimumValueChange = null;
        this._actualMaximumValueChange = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the DateTime mapping property for the axis.
    *
    * Use `dateTimeMemberPath` property for DateTime mapping with the axis.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    get dateTimeMemberPath() {
        return this.i.dateTimeMemberPath;
    }
    set dateTimeMemberPath(v) {
        this.i.dateTimeMemberPath = v;
    }
    /**
     * Gets or sets whether the data assigned to the date time axis should be considered pre-sorted by date/time.
    *
    * Use `isDataPreSorted` property to decide if the data assigned to the date time axis should be considered pre-sorted by date/time.
    */
    get isDataPreSorted() {
        return this.i.la;
    }
    set isDataPreSorted(v) {
        this.i.la = ensureBool(v);
    }
    /**
     * Gets the coerced minimum value.
    *
    * Use `actualMinimumValue` to get the coerced maximum value.
    */
    get actualMinimumValue() {
        return this.i.actualMinimumValue;
    }
    set actualMinimumValue(v) {
        this.i.actualMinimumValue = v;
    }
    /**
     * Gets the coerced maximum value.
    *
    * Use `actualMaximumValue` to get the  coerced maximum value
    */
    get actualMaximumValue() {
        return this.i.actualMaximumValue;
    }
    set actualMaximumValue(v) {
        this.i.actualMaximumValue = v;
    }
    /**
     * Gets or sets the axis MinimumValue.
    *
    * Use `minimumValue` property for axis minimum value.
    *
    * ```ts
    * this.timeXAxis.maximumValue="2019-12-26";
    * ```
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = v;
    }
    /**
     * Gets or sets the axis MaximumValue.
    *
    * Use `maximumValue` property for axis maximum value.
    *
    * ```ts
    * this.timeXAxis.maximumValue="2019-12-26";
    * ```
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = v;
    }
    /**
     * Checks if the axis is of date time axis type
    *
    * Use `isDateTime` property to Checks if the axis is of date time axis type.
    *
    * ```ts
    * const isDT = this.timeXAxis.isDateTime;
    * ```
    */
    get isDateTime() {
        return this.i.b7;
    }
    /**
     * Checks if axis requires sorting of items
    *
    * Use `isSorting` property to Checks if axis requires sorting of items.
    *
    * ```ts
    * const isDT = this.timeXAxis.isDateTime;
    * ```
    */
    get isSorting() {
        return this.i.cf;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.e6(item, memberPathName);
        return (iv);
    }
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    getIndexClosestToUnscaledValue(unscaledValue) {
        let iv = this.i.i$f(unscaledValue);
        return (iv);
    }
    /**
     * Updates the axis when the data has been changed.
    
    */
    notifyDataChanged() {
        this.i.i$i();
    }
    get actualMinimumValueChange() {
        if (this._actualMinimumValueChange == null) {
            this._actualMinimumValueChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinimumValue;
                if (this.beforeActualMinimumValueChange) {
                    this.beforeActualMinimumValueChange(this, ext);
                }
                this._actualMinimumValueChange.emit(ext);
            });
        }
        return this._actualMinimumValueChange;
    }
    get actualMaximumValueChange() {
        if (this._actualMaximumValueChange == null) {
            this._actualMaximumValueChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMaximumValue;
                if (this.beforeActualMaximumValueChange) {
                    this.beforeActualMaximumValueChange(this, ext);
                }
                this._actualMaximumValueChange.emit(ext);
            });
        }
        return this._actualMaximumValueChange;
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTimeAxisBaseComponent.prototype, "dateTimeMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxTimeAxisBaseComponent.prototype, "isDataPreSorted", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBaseComponent.prototype, "actualMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBaseComponent.prototype, "actualMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBaseComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxTimeAxisBaseComponent.prototype, "maximumValue", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTimeAxisBaseComponent.prototype, "actualMinimumValueChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTimeAxisBaseComponent.prototype, "actualMaximumValueChange", null);

var IgxCategoryDateTimeXAxisComponent_1;
/**
 * Represents a category-based horizontal X axis that uses a DateTime scale.
*
* `IgxCategoryDateTimeXAxisComponent` class represents a category-based horizontal X axis that uses a DateTime scale.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-time-x-axis
* 		dateTimeMemberPath="date"
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*/
const IgxCategoryDateTimeXAxisComponent_PROVIDERS = [{ provide: IgxTimeAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent) }];
let IgxCategoryDateTimeXAxisComponent = IgxCategoryDateTimeXAxisComponent_1 = class IgxCategoryDateTimeXAxisComponent extends IgxTimeAxisBaseComponent {
    constructor() {
        super();
        this._actualIntervalChange = null;
        this._actualMinorIntervalChange = null;
    }
    createImplementation() {
        return new CategoryDateTimeXAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets if the current axis is a continuous rather than a discrete scale
    */
    get isContinuous() {
        return this.i.b6;
    }
    /**
     * Gets or sets the axis display type.
     * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points.
     * Discrete display type will not use a constant interval, but will align each label with its data point.
    *
    * `displayType` property is used for axis display type.
    *
    * Continuous display type divides the axis into even intervals, where labels will not necessarily be aligned with data points. Discrete display type will not use a constant interval, but will align each label with its data point.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		displayType ="continuous"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get displayType() {
        return this.i.mc;
    }
    set displayType(v) {
        this.i.mc = ensureEnum(TimeAxisDisplayType_$type, v);
    }
    /**
     * Gets or sets the X axis time interval.
    *
    * `interval` property is used to get/sets the frequency of displayed labels.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		interval=2
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get interval() {
        return this.i.mm;
    }
    set interval(v) {
        this.i.mm = +v;
    }
    /**
     * Gets the effective value for the current Interval.
    */
    get actualInterval() {
        return this.i.mj;
    }
    set actualInterval(v) {
        this.i.mj = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines.
     * The set value is a factor that determines how the minor lines will be displayed.
    */
    get minorInterval() {
        return this.i.mn;
    }
    set minorInterval(v) {
        this.i.mn = +v;
    }
    /**
     * Gets the effective value for the current MinorInterval.
    */
    get actualMinorInterval() {
        return this.i.mk;
    }
    set actualMinorInterval(v) {
        this.i.mk = +v;
    }
    /**
     * Gets if the current axis is of category date time axis type
    */
    get isCategoryDateTime() {
        return this.i.b5;
    }
    scrollIntoView(minimum, maximum) {
        this.i.mt(minimum, maximum);
    }
    get actualIntervalChange() {
        if (this._actualIntervalChange == null) {
            this._actualIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualInterval;
                if (this.beforeActualIntervalChange) {
                    this.beforeActualIntervalChange(this, ext);
                }
                this._actualIntervalChange.emit(ext);
            });
        }
        return this._actualIntervalChange;
    }
    get actualMinorIntervalChange() {
        if (this._actualMinorIntervalChange == null) {
            this._actualMinorIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinorInterval;
                if (this.beforeActualMinorIntervalChange) {
                    this.beforeActualMinorIntervalChange(this, ext);
                }
                this._actualMinorIntervalChange.emit(ext);
            });
        }
        return this._actualMinorIntervalChange;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryDateTimeXAxisComponent.prototype, "displayType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryDateTimeXAxisComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryDateTimeXAxisComponent.prototype, "actualInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryDateTimeXAxisComponent.prototype, "minorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryDateTimeXAxisComponent.prototype, "actualMinorInterval", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryDateTimeXAxisComponent.prototype, "actualIntervalChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryDateTimeXAxisComponent.prototype, "actualMinorIntervalChange", null);
IgxCategoryDateTimeXAxisComponent = IgxCategoryDateTimeXAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-category-date-time-x-axis',
        template: ``,
        providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent_1) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryDateTimeXAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryDateTimeXAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryDateTimeXAxisModule = class IgxCategoryDateTimeXAxisModule {
};
IgxCategoryDateTimeXAxisModule = __decorate([
    NgModule({
        declarations: [IgxCategoryDateTimeXAxisComponent],
        imports: [CommonModule],
        exports: [IgxCategoryDateTimeXAxisComponent],
        entryComponents: []
    })
], IgxCategoryDateTimeXAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryDateTimeXAxisDynamicModule = class IgxCategoryDateTimeXAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryDateTimeXAxisComponent", IgxCategoryDateTimeXAxisComponent);
        TypeRegistrar.register("CategoryDateTimeXAxis", CategoryDateTimeXAxis.$type);
    }
};
IgxCategoryDateTimeXAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryDateTimeXAxisModule],
        exports: [IgxCategoryDateTimeXAxisModule],
        entryComponents: [IgxCategoryDateTimeXAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryDateTimeXAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxNumericAngleAxisComponent_1;
/**
 * Represents a IgxDataChartComponent angle based axis for polar series.
*/
const IgxNumericAngleAxisComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericAngleAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericAngleAxisComponent) }];
let IgxNumericAngleAxisComponent = IgxNumericAngleAxisComponent_1 = class IgxNumericAngleAxisComponent extends IgxNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericAngleAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets if the current axis is of angular axis type
    */
    get isAngular() {
        return this.i.b2;
    }
    /**
     * Indicates the angle in degress that the chart's 0th angle should be offset.
    */
    get startAngleOffset() {
        return this.i.lu;
    }
    set startAngleOffset(v) {
        this.i.lu = +v;
    }
    /**
     * Gets the scaled angle value in radians based on the raw input.
    
    * @param unscaledValue  * The raw input value.
    */
    getScaledAngle(unscaledAngle) {
        let iv = this.i.getScaledAngle(unscaledAngle);
        return (iv);
    }
    /**
     * Gets the raw axis value back from the angle that would be used on the chart.
    
    * @param scaledValue  * The chart angle value.
    */
    getUnscaledAngle(scaledAngle) {
        let iv = this.i.getUnscaledAngle(scaledAngle);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericAngleAxisComponent.prototype, "startAngleOffset", null);
IgxNumericAngleAxisComponent = IgxNumericAngleAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-numeric-angle-axis',
        template: ``,
        providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericAngleAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericAngleAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxNumericAngleAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericAngleAxisModule = class IgxNumericAngleAxisModule {
};
IgxNumericAngleAxisModule = __decorate([
    NgModule({
        declarations: [IgxNumericAngleAxisComponent],
        imports: [CommonModule],
        exports: [IgxNumericAngleAxisComponent],
        entryComponents: []
    })
], IgxNumericAngleAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericAngleAxisDynamicModule = class IgxNumericAngleAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxNumericAngleAxisComponent", IgxNumericAngleAxisComponent);
        TypeRegistrar.register("NumericAngleAxis", NumericAngleAxis.$type);
    }
};
IgxNumericAngleAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxNumericAngleAxisModule],
        exports: [IgxNumericAngleAxisModule],
        entryComponents: [IgxNumericAngleAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxNumericAngleAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxNumericRadiusAxisComponent_1;
/**
 * Represents a IgxDataChartComponent radius axis for polar and radial series.
*
* ```html
* <igx-data-chart
*     [dataSource]="dataSource"   >
*     <igx-category-angle-axis name="angleAxis" label="Department" />
*     <igx-numeric-radius-axis name="radiusAxis" />
*  </igx-data-chart>
* ```
*
* ```ts
* this.series1.angleAxisName = "AngleAxis";
* this.series1.valueAxisName = "numericYAxis";
* ```
*/
const IgxNumericRadiusAxisComponent_PROVIDERS = [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericRadiusAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericRadiusAxisComponent) }];
let IgxNumericRadiusAxisComponent = IgxNumericRadiusAxisComponent_1 = class IgxNumericRadiusAxisComponent extends IgxNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericRadiusAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if the axis is of radial axis type
    *
    * ```ts
    * let isRadial: boolean = this.series.isRadial;
    * ```
    */
    get isRadial() {
        return this.i.ce;
    }
    /**
     * Defines the percentage of the maximum radius extent to use as the maximum radius. Should be
     * a value between 0.0 and 1.0.
    */
    get radiusExtentScale() {
        return this.i.l1;
    }
    set radiusExtentScale(v) {
        this.i.l1 = +v;
    }
    /**
     * Defines the percentage of the maximum radius extent to leave blank at the center of the chart. Should be
     * a value between 0.0 and 1.0.
    */
    get innerRadiusExtentScale() {
        return this.i.l0;
    }
    set innerRadiusExtentScale(v) {
        this.i.l0 = +v;
    }
    /**
     * Returns a world coordinates radius length (0 - 0.5) from a raw axis value.
    
    * @param unscaledValue  * The raw axis value.
    */
    getScaledValue(unscaledValue) {
        let iv = this.i.lx(unscaledValue);
        return (iv);
    }
    /**
     * Returns a raw axis value from the world coordinates radius length provided.
    
    * @param scaledValue  * The scaled world coordinates radius length.
    *
    * Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
    */
    getUnscaledValue(scaledValue) {
        let iv = this.i.lz(scaledValue);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericRadiusAxisComponent.prototype, "radiusExtentScale", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxNumericRadiusAxisComponent.prototype, "innerRadiusExtentScale", null);
IgxNumericRadiusAxisComponent = IgxNumericRadiusAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-numeric-radius-axis',
        template: ``,
        providers: [{ provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericRadiusAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericRadiusAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxNumericRadiusAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericRadiusAxisModule = class IgxNumericRadiusAxisModule {
};
IgxNumericRadiusAxisModule = __decorate([
    NgModule({
        declarations: [IgxNumericRadiusAxisComponent],
        imports: [CommonModule],
        exports: [IgxNumericRadiusAxisComponent],
        entryComponents: []
    })
], IgxNumericRadiusAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericRadiusAxisDynamicModule = class IgxNumericRadiusAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxNumericRadiusAxisComponent", IgxNumericRadiusAxisComponent);
        TypeRegistrar.register("NumericRadiusAxis", NumericRadiusAxis.$type);
    }
};
IgxNumericRadiusAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxNumericRadiusAxisModule],
        exports: [IgxNumericRadiusAxisModule],
        entryComponents: [IgxNumericRadiusAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxNumericRadiusAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITimeRangeSelectorAxis_$type = new Type(null, 'ITimeRangeSelectorAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enum representing a unit of time.
 */
var TimeAxisLabellingMode;
(function (TimeAxisLabellingMode) {
    /**
     * LabellingMode is decided automatically.
     */
    TimeAxisLabellingMode[TimeAxisLabellingMode["Auto"] = 0] = "Auto";
    /**
     * Labels are presented in a uniform format based on visible interval.
     */
    TimeAxisLabellingMode[TimeAxisLabellingMode["Normal"] = 1] = "Normal";
    /**
     * Labels are shortened by eliminating repeated elements compared to prior values.
     */
    TimeAxisLabellingMode[TimeAxisLabellingMode["Compressed"] = 2] = "Compressed";
})(TimeAxisLabellingMode || (TimeAxisLabellingMode = {}));
/**
 * @hidden
 */
let TimeAxisLabellingMode_$type = markEnum('TimeAxisLabellingMode', 'Auto,0|Normal,1|Compressed,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisLabelFormatCollection extends ObservableCollection$1 {
    constructor() {
        super(TimeAxisLabelFormat.$, 0);
    }
}
TimeAxisLabelFormatCollection.$t = markType(TimeAxisLabelFormatCollection, 'TimeAxisLabelFormatCollection', ObservableCollection$1.$.specialize(TimeAxisLabelFormat.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisBreakCollection extends ObservableCollection$1 {
    constructor() {
        super(TimeAxisBreak.$, 0);
    }
}
TimeAxisBreakCollection.$t = markType(TimeAxisBreakCollection, 'TimeAxisBreakCollection', ObservableCollection$1.$.specialize(TimeAxisBreak.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OrderedDictionary extends Base {
}
OrderedDictionary.$t = markType(OrderedDictionary, 'OrderedDictionary');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OrderedDictionary$2 extends OrderedDictionary {
    constructor($tKey, $tValue) {
        super();
        this.$tKey = null;
        this.$tValue = null;
        this.e = null;
        this.f = null;
        this.$tKey = $tKey;
        this.$tValue = $tValue;
        this.$type = this.$type.specialize(this.$tKey, this.$tValue);
        this.e = new Dictionary$2(this.$tKey, this.$tValue, 0);
        this.f = new List$1(this.$tKey, 0);
    }
    item1(a) {
        return this.f._inner[a];
    }
    item(a, b) {
        if (arguments.length === 2) {
            let c = this.f.indexOf(a);
            this.f._inner[c] = a;
            this.e.item(a, b);
            return b;
        }
        else {
            return this.e.item(a);
        }
    }
    get_a() {
        return this.count;
    }
    get a() {
        return this.get_a();
    }
    get count() {
        return this.e.count;
    }
    get isReadOnly() {
        return false;
    }
    get keys() {
        return this.f;
    }
    get values() {
        return this.e.values;
    }
    add(a) {
        this.addItem(a.key, a.value);
    }
    addItem(a, b) {
        this.e.addItem(a, b);
        this.f.add(a);
    }
    clear() {
        this.e.clear();
        this.f.clear();
    }
    contains(a) {
        return this.e.contains(a);
    }
    containsKey(a) {
        return this.e.containsKey(a);
    }
    copyTo(a, b) {
        this.e.copyTo(a, b);
    }
    getEnumerator() {
        return new OrderedDictionaryEnumerator$2(this.$tKey, this.$tValue, this);
    }
    remove(a) {
        return this.removeItem(a.key);
    }
    removeItem(a) {
        return this.e.removeItem(a) && this.f.remove(a);
    }
    tryGetValue(a, b) {
        if (this.e.containsKey(a)) {
            b = this.e.item(a);
            return {
                ret: true,
                p1: b
            };
        }
        b = Type.getDefaultValue(this.$tValue);
        return {
            ret: false,
            p1: b
        };
    }
    getEnumeratorObject() {
        return new OrderedDictionaryEnumerator$2(this.$tKey, this.$tValue, this);
    }
    b(a) {
        return getBoxIfEnum(this.$tKey, this.item1(a));
    }
    c(a) {
        return this.item(a);
    }
}
OrderedDictionary$2.$t = markType(OrderedDictionary$2, 'OrderedDictionary$2', OrderedDictionary.$, [IDictionary$2_$type.specialize(0, 1), IDictionary_$type]);
/**
 * @hidden
 */
class OrderedDictionaryEnumerator$2 extends Base {
    constructor($tKey, $tValue, a) {
        super();
        this.$tKey = null;
        this.$tValue = null;
        this.b = 0;
        this.a = null;
        this.$tKey = $tKey;
        this.$tValue = $tValue;
        this.$type = this.$type.specialize(this.$tKey, this.$tValue);
        this.b = -1;
        this.a = a;
    }
    get currentObject() {
        return getBoxIfEnum(this.$tValue, this.a.item(this.a.item1(this.b)));
    }
    get current() {
        let a = this.a.item1(this.b);
        return new KeyValuePair$2(this.$tKey, this.$tValue, 1, a, this.a.item(a));
    }
    moveNext() {
        this.b += 1;
        return this.b < this.a.count;
    }
    reset() {
        this.b = -1;
    }
    dispose() {
    }
}
OrderedDictionaryEnumerator$2.$t = markType(OrderedDictionaryEnumerator$2, 'OrderedDictionaryEnumerator$2', Base.$, [IEnumerator$1_$type.specialize(KeyValuePair$2.$.specialize(0, 1)), IEnumerator_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeAxisIntervalCollection extends ObservableCollection$1 {
    constructor() {
        super(TimeAxisInterval.$, 0);
    }
}
TimeAxisIntervalCollection.$t = markType(TimeAxisIntervalCollection, 'TimeAxisIntervalCollection', ObservableCollection$1.$.specialize(TimeAxisInterval.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TimeXAxis extends TimeAxisBase {
    constructor() {
        super();
        this.my = 0;
        this.me = null;
        this.mn = 0;
        this.ml = null;
        this._omission = 0;
        this.mc = null;
        this.mj = null;
        this.m0 = null;
        this.nc = 0;
        this.mu = dateMaxValue();
        this.mt = dateMinValue();
        this.mg = null;
        this.na = 0;
        this.visibleRangeChanged = null;
        this.ab = TimeXAxis.$;
        this.omission = (0);
        this.my = -2147483648;
        this.me = new TimeAxisBreakCollection();
        let a = this.breaks;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.nf));
        this.mj = new TimeAxisIntervalCollection();
        let b = this.intervals;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.ng));
        this.ml = new TimeAxisLabelFormatCollection();
        let c = this.labelFormats;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.nh));
        this.nc = (0);
    }
    get_cd() {
        return this.breaks != null && this.breaks.count > 0;
    }
    dy(a, b) {
        let c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        let d = this.my != -2147483648 ? this.my : 0;
        let e = this.mc != null ? this.mc.count : 0;
        while (d < e) {
            let f = this.mc.item1(d);
            if (f.d.getTime() <= a && f.c.getTime() >= a) {
                return NaN;
            }
            if (f.c.getTime() <= a) {
                c = new KeyValuePair$2(TimeAxisBreak.$, Number_$type, 1, f, this.mc.item(f));
                d++;
            }
            else {
                break;
            }
        }
        if (d > 0) {
            d -= 1;
        }
        if (this.my != -2147483648) {
            this.my = d;
        }
        let g;
        let h;
        if (c.key != null) {
            g = c.value;
            h = c.key.c;
        }
        else {
            g = 0;
            h = this.actualMinimumValue;
        }
        let fromPrecedingBreak_ = +(dateFromTicks(truncate(a))) - +h;
        let i = (fromPrecedingBreak_ / ((this.actualMaximumValue.getTime() - this.actualMinimumValue.getTime()) - this.omission));
        let j = g + i;
        j -= b.e.left;
        j /= b.e.width;
        let k = b.d.left;
        let l = b.d.right;
        let m = b.d.width;
        if (this.categoryMode != 0) {
            let n = this.getCategorySize(b.e, b.d, b.c);
            k += n / 2;
            l -= n / 2;
            m -= n;
        }
        if (this.ca) {
            return l - m * j;
        }
        return k + m * j;
    }
    gs(a, b, c, d) {
        this.my = 0;
        for (let e = b; e < c; e++) {
            a.item(e, this.dy(a.item(e), d));
        }
        this.my = -2147483648;
    }
    startCursor() {
        this.my = 0;
    }
    resetCursor() {
        this.my = -2147483648;
    }
    d1(a, b) {
        let c = b.d.left;
        let d = b.d.width;
        if (this.categoryMode != 0) {
            let e = this.getCategorySize(b.e, b.d, b.c);
            c += e / 2;
            d -= e;
        }
        let f = b.e.left + b.e.width * (a - c) / d;
        if (this.ca) {
            f = 1 - f;
        }
        let g = new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        if (this.mc != null) {
            for (let h of fromEnum(this.mc)) {
                if (h.value >= f && h.value <= f) {
                    return h.key.d.getTime();
                }
                if (h.value < f && h.value > g.value) {
                    g = h;
                }
            }
        }
        let precedingBreakEnd_;
        let i;
        if (g.key != null) {
            i = g.value;
            precedingBreakEnd_ = g.key.c;
        }
        else {
            i = 0;
            precedingBreakEnd_ = this.actualMinimumValue;
        }
        let portionFromPrecedingBreak_ = f - i;
        let actualRange_ = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        return (precedingBreakEnd_.getTime() + portionFromPrecedingBreak_ * actualRange_);
    }
    get breaks() {
        return this.me;
    }
    get mo() {
        return this.mn;
    }
    set mo(a) {
        let b = this.mo;
        if (a != b) {
            this.mn = a;
            this.g5("LabellingMode", enumGetBox(TimeAxisLabellingMode_$type, b), enumGetBox(TimeAxisLabellingMode_$type, this.mo));
        }
    }
    get labelFormats() {
        return this.ml;
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case "ActualMaximumValue":
                this.ne();
                break;
            case "DateTimeColumn":
                this.na = this.m8();
                break;
            case "LabellingMode":
                this.hb(false);
                break;
        }
    }
    ho(a, b) {
        super.ho(a, b);
        this.nd();
        this.l6();
    }
    hn(a, b) {
        super.hn(a, b);
        this.nd();
        this.l6();
    }
    cp() {
        let a = super.cp();
        this.nd();
        return a;
    }
    get omission() {
        return this._omission;
    }
    set omission(a) {
        this._omission = a;
    }
    ne() {
        let a = this.mr(this.breaks);
        let b = (0);
        for (let c of fromEnum(a)) {
            b += (+(c.c) - +(c.d));
        }
        this.omission = b;
    }
    mr(a) {
        let b = new List$1(TimeAxisBreak.$, 0);
        if (a == null || +(this.actualMaximumValue) == +(dateMaxValue())) {
            return b;
        }
        for (let c of fromEn(a)) {
            if (c.c >= this.actualMinimumValue && c.d <= this.actualMaximumValue) {
                b.add(c);
            }
            if (c.i != (0)) {
                let d = +(c.c) - +(c.d);
                let e = dateAdd(+(c.d), +(c.i));
                while (e <= this.actualMaximumValue) {
                    let f = this.mv(e, d);
                    let g = ((() => {
                        let $ret = new TimeAxisBreak();
                        $ret.d = e;
                        $ret.c = f;
                        return $ret;
                    })());
                    if (g.c >= this.actualMinimumValue && g.d <= this.actualMaximumValue) {
                        b.add(g);
                    }
                    if (dateSubtract(+(dateMaxValue()), +(c.i)) < g.d) {
                        break;
                    }
                    e = this.mv(g.d, c.i);
                }
            }
        }
        return b;
    }
    mv(a, b) {
        let c = dateFromTicks(a.getTime());
        c.setMilliseconds(c.getMilliseconds() + b);
        return c;
    }
    nd() {
        this.mc = new OrderedDictionary$2(TimeAxisBreak.$, Number_$type);
        if (+(this.actualMaximumValue) == +(dateMaxValue()) || this.breaks == null || this.breaks.count == 0 || this.bh == null) {
            return;
        }
        let a = new List$1(TimeAxisBreak.$, 1, this.mr(this.breaks));
        a.aa((b, c) => b.d < c.d ? -1 : b.d > c.d ? 1 : 0);
        let b = this.bh.n2;
        let c = new ScalerParams(0, this.bh.n2, this.bh.oh, this.ca, this.bh.n6);
        let d = +(this.actualMaximumValue) - +(this.actualMinimumValue) - this.omission;
        let e = 0;
        for (let f of fromEnum(a)) {
            let g = timeSpanTicks((+(f.d) - +(this.actualMinimumValue))) / timeSpanTicks(d);
            let h = timeSpanTicks((+(f.c) - +(this.actualMinimumValue))) / timeSpanTicks(d);
            if (h < 0 || g - e > 1) {
                continue;
            }
            this.mc.addItem(f, g - e);
            e += (h - g);
        }
    }
    fl(a) {
        if (isNaN_(a)) {
            return null;
        }
        let ticks_ = truncate(a);
        let b = (new Date(ticks_));
        let c = this.e8(b);
        if (c == null) {
            return null;
        }
        return c.toString();
    }
    e8(a) {
        if (!(typeCast(Date_$type, a) !== null)) {
            return super.e8(a);
        }
        let b = dateMinValue();
        let c = false;
        if (this.m0 != null) {
            if (typeCast(Date_$type, this.m0) !== null) {
                b = this.m0;
                c = true;
            }
        }
        let d = TimeXAxis.mz(a, c, b, this.mo, this.nc, this.labelFormats, this.et);
        return d == null ? super.e8(a) : d;
    }
    static mz(a, b, c, d, e, f, g) {
        let h = null;
        if (e == (0)) {
            return null;
        }
        let i = 0;
        if (b) {
            i = TimeXAxis.mp(a, c);
        }
        let j;
        if (f == null || f.count == 0) {
            j = TimeXAxis.m3(e, i, d);
        }
        else {
            for (let k of fromEnum(f)) {
                if (k.o > e) {
                    continue;
                }
                if (h == null || k.o > h.o) {
                    h = k;
                }
            }
            if (h == null) {
                return null;
            }
            switch (i) {
                case 3:
                    if (h.h != null) {
                        j = h.h;
                    }
                    else if (h.j != null) {
                        j = h.j;
                    }
                    else if (h.l != null) {
                        j = h.l;
                    }
                    else {
                        j = h.e;
                    }
                    break;
                case 2:
                    if (h.j != null) {
                        j = h.j;
                    }
                    else if (h.l != null) {
                        j = h.l;
                    }
                    else {
                        j = h.e;
                    }
                    break;
                case 1:
                    if (h.l != null) {
                        j = h.l;
                    }
                    else {
                        j = h.e;
                    }
                    break;
                default:
                    j = h.e;
                    break;
            }
        }
        return dateToStringFormat(a, j, g);
    }
    static mp(a, b) {
        if (a.getFullYear() == b.getFullYear() && dateGetMonth(a) == dateGetMonth(b) && a.getDate() == b.getDate()) {
            return 3;
        }
        else if (a.getFullYear() == b.getFullYear() && dateGetMonth(a) == dateGetMonth(b)) {
            return 2;
        }
        else if (a.getFullYear() == b.getFullYear()) {
            return 1;
        }
        return 0;
    }
    get_k9() {
        return super.get_k9() || (this.intervals != null && this.intervals.count > 0);
    }
    set_k9(a) {
        super.set_k9(a);
    }
    get intervals() {
        return this.mj;
    }
    m2(a, b) {
        return TimeXAxis.m3(this.nc, a, b);
    }
    static m3(a, b, c) {
        if (c != 2) {
            b = 0;
        }
        a = Math.abs(a);
        if (a > timeSpanInit3(1825, 0, 0, 0)) {
            return "yyyy";
        }
        if (a > timeSpanInit3(365, 0, 0, 0)) {
            switch (b) {
                case 1: return "MMM";
            }
            return "MMM yyyy";
        }
        ;
        if (a > timeSpanInit3(4, 0, 0, 0)) {
            switch (b) {
                case 2: return "dd";
            }
            return "MMM dd";
        }
        ;
        if (a > timeSpanInit3(1, 0, 0, 0)) {
            switch (b) {
                case 3: return "hh:mmtt";
                case 2: return "dd hh:mmtt";
            }
            return "MMM dd hh:mmtt";
        }
        ;
        if (a > timeSpanInit1(0, 10, 0)) {
            return "hh:mm";
        }
        return "hh:mm:ss";
    }
    static md() {
        if (TimeXAxis.mb == null) {
            TimeXAxis.mb = ((() => {
                let $ret = new OrderedDictionary$2(Number_$type, TimeAxisInterval.$);
                $ret.addItem((0), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 0;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMilliseconds(1), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 1;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromSeconds(1), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 2;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromSeconds(30), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 2;
                    $ret.f = 30;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMinutes(2), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 2;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromMinutes(5), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 3;
                    $ret.f = 5;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromHours(1), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 4;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(1), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(2), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 2;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(5), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 5;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(10), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 5;
                    $ret.f = 10;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(30), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(60), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 7;
                    $ret.f = 3;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(365), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 1;
                    return $ret;
                })()));
                $ret.addItem(timeSpanFromDays(365 * 10), ((() => {
                    let $ret = new TimeAxisInterval();
                    $ret.b = 8;
                    $ret.f = 10;
                    return $ret;
                })()));
                return $ret;
            })());
        }
        return TimeXAxis.mb;
    }
    mh() {
        if (this.cq && (this.ay == null || this.ay.angle == 0)) {
            let a = this.ea();
            let b = this.i9.width;
            let c = truncate(Math.floor(b / a));
            let d = Number.MAX_VALUE;
            let e = c == 0 ? d : timeSpanFromTicks((intDivide(timeSpanTicks(this.nc), c)));
            let f = null;
            for (let g of fromEnum(TimeXAxis.md())) {
                f = g.value;
                if (g.key > e) {
                    break;
                }
            }
            let h = this.mg;
            if (h != f) {
                this.hf();
            }
            this.mg = f;
            return f;
        }
        let i = this.nc;
        if (i == (0)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(365 * 100)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 10;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(365 * 5)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(365 * 2)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 7;
                $ret.f = 3;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(150)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 7;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(60)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 10;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(30)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 5;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(20)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 2;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(4)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 5;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (i >= timeSpanFromDays(1)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 4;
                $ret.f = 12;
                return $ret;
            })());
        }
        if (i >= timeSpanFromHours(6)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 4;
                $ret.f = 1;
                return $ret;
            })());
        }
        if (i >= timeSpanFromMinutes(30)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 3;
                $ret.f = 5;
                return $ret;
            })());
        }
        if (i >= timeSpanFromMinutes(10)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 3;
                $ret.f = 2;
                return $ret;
            })());
        }
        return ((() => {
            let $ret = new TimeAxisInterval();
            $ret.b = 2;
            $ret.f = 30;
            return $ret;
        })());
    }
    mi() {
        if (this.intervals == null || this.intervals.count == 0) {
            return this.mh();
        }
        if (this.nc == (0)) {
            return ((() => {
                let $ret = new TimeAxisInterval();
                $ret.b = 8;
                $ret.f = 1;
                return $ret;
            })());
        }
        let a = null;
        for (let b of fromEnum(this.intervals)) {
            if (b.k > this.nc) {
                continue;
            }
            if (a == null || b.k > a.k) {
                a = b;
            }
        }
        return a == null ? this.mh() : a;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = new ScalerParams(0, b, c, this.ca, d);
        if (this.k5 == null && !this.lb() && !this.lc()) {
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let g = c.bottom;
            let h = g - c.top;
            if (this.ai != null) {
                let i = typeCast(NumericYAxis.$, this.ai);
                if (i != null) {
                    let j = this.hg(g, h, b, c, d, c.top, c.bottom);
                    g = j.p0;
                    h = j.p1;
                }
            }
            if (isNaN_(g)) {
                g = 0;
            }
            this.gv(this.a4.ay(), g, c, this.a4.e(), true);
            this.av.a9 = h;
            let k = truncate(Math.ceil(e.right));
            let l = truncate(Math.floor(e.left));
            let m = this.a4.a1();
            let n = this.a4.f();
            let o = this.a4.az();
            this.l6();
            let p = new List$1(Date_$type, 1, this.mq());
            let q = new List$1(Number_$type, 0);
            for (let r = 0; r < p.count; r++) {
                q.add(p._inner[r].getTime());
            }
            this.gs(q, 0, q.count, f);
            this.m0 = null;
            for (let s = 0; s < p.count; s++) {
                let t = p._inner[s];
                let u = q._inner[s];
                let v = truncate(Math.round(u));
                if (v <= k) {
                    if (s % 2 == 0) {
                        let w = s < q.count - 1 ? q._inner[s + 1] : e.right;
                        this.hm(m, u, w, c);
                    }
                    this.hl(o, u, c, n, false);
                    this.ju.add(u);
                }
                if (v >= l && v <= k) {
                    let x = this.e8(t);
                    this.m0 = t;
                    if (x != null) {
                        this.cx.add1(x);
                        this.cy.add(new LabelPosition(u));
                    }
                }
            }
            this.m0 = null;
        }
        if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
            if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                this.bh.it();
            }
        }
        this.av.a2 = this.cx;
        this.av.a3 = this.cy;
        this.ku();
    }
    mq() {
        let a = this.bh != null ? this.bh.n2 : Rect.empty;
        let b = !a.isEmpty ? this.i9 : Rect.empty;
        let c = this.i4();
        let d = this.i3();
        let e = new ScalerParams(0, a, b, this.ca, c);
        let f = this.mi();
        let g = this.visibleMinimum;
        if (!this.lc() && f != null) {
            if (f.b == 7 && g.getDate() != 1) {
                g = dateAddMonths(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), 1, 0, 0, 0, 0);
            }
            else if (f.b == 5 && dateGetTimeOfDay(g) != (0)) {
                g = dateAddDays(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), 0, 0, 0, 0);
            }
            else if (f.b == 4 && g.getMinutes() != 0) {
                g = dateAddHours(g, 1);
                g = dateFromValues(g.getFullYear(), dateGetMonth(g), g.getDate(), g.getHours(), 0, 0, 0);
            }
        }
        let h = new List$1(Date_$type, 0);
        let i = 0;
        let j = 10000;
        if (f.f == 0) {
            return h;
        }
        while (g <= this.visibleMaximum && i++ < j) {
            let k = this.ms(g);
            let l = g;
            if (k.key != null) {
                l = f.d(k.key.c);
            }
            h.add(l);
            while (g <= l) {
                g = f.c(g);
            }
        }
        return h;
    }
    ms(a) {
        if (this.mc == null) {
            return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
        }
        for (let b of fromEnum(this.mc)) {
            if (b.key.d <= a && b.key.c >= a) {
                return b;
            }
        }
        return new KeyValuePair$2(TimeAxisBreak.$, Number_$type);
    }
    get visibleMinimum() {
        return this.mu;
    }
    set visibleMinimum(a) {
        this.mu = a;
    }
    get visibleMaximum() {
        return this.mt;
    }
    set visibleMaximum(a) {
        this.mt = a;
    }
    l6() {
        super.l6();
        if (this.bh == null || !Extensions.b(this.bh.oh)) {
            return;
        }
        let a = new ScalerParams(0, this.bh.n2, this.bh.oh, this.ca, this.bh.n6);
        let b = this.bh.oh.left;
        let c = this.bh.oh.right;
        if (this.categoryMode != 0) {
            let d = this.getCategorySize(a.e, a.d, a.c);
            b += d / 2;
            c -= d / 2;
        }
        let e = truncate(this.d1(b, a));
        let f = truncate(this.d1(c, a));
        if (e < 0 || f < 0) {
            this.nc = (0);
            return;
        }
        e = Math.min(dateMaxValue().getTime(), e);
        f = Math.min(dateMaxValue().getTime(), f);
        let g = dateFromTicks(Math.min(e, f));
        let h = dateFromTicks(Math.max(e, f));
        let i = +(this.visibleMinimum) != +g || +(this.visibleMaximum) != +h;
        this.visibleMinimum = g;
        this.visibleMaximum = h;
        if (i && this.visibleRangeChanged != null) {
            this.visibleRangeChanged(this, EventArgs.empty);
        }
        this.nc = +(this.visibleMaximum) - +(this.visibleMinimum);
    }
    j1(a, b, c, d, e) {
        return 0;
    }
    i$f(a) {
        let b = this;
        if (b.i$b == null || b.i$b.count == 0) {
            return -1;
        }
        let c = new SortedListView$1(Date_$type, this.k5, b.i$b);
        let ticks_ = a;
        let d = (new Date(ticks_));
        let e = this.lp(d, c);
        e = Math.max(0, Math.min(b.i$b.count - 1, e));
        let f = c.item(e);
        let g;
        let h;
        if (f < d) {
            g = e;
            h = g + 1;
        }
        else {
            h = e;
            g = e - 1;
        }
        if (g < 0) {
            return h;
        }
        if (h >= b.i$b.count) {
            return g;
        }
        let i = c.item(g);
        let j = c.item(h);
        let k = new ScalerParams(0, this.bh.oi, this.i9, this.ca, this.bh.n6);
        this.startCursor();
        let l = this.dy(i.getTime(), k);
        let m = this.dy(a, k);
        let n = this.dy(j.getTime(), k);
        this.resetCursor();
        if (i < this.visibleMinimum && j <= this.visibleMaximum) {
            return this.le._inner[h];
        }
        if (j > this.visibleMaximum && i >= this.visibleMinimum) {
            return this.le._inner[g];
        }
        if (Math.abs(l - m) < Math.abs(n - m)) {
            return this.le._inner[g];
        }
        else {
            return this.le._inner[h];
        }
    }
    nf(a, b) {
        this.ne();
        this.nd();
        if (this.av != null) {
            this.av.ak = this.breaks.count > 0;
        }
        this.hb(false);
        for (let c of fromEnum(this.cw())) {
            c.jl(false);
        }
    }
    nh(a, b) {
        this.hb(false);
    }
    ng(a, b) {
        this.hb(false);
    }
    get_b5() {
        return false;
    }
    getWindowRectForSelection(a, b) {
        let c = +(this.actualMaximumValue) - +(this.actualMinimumValue);
        let d = timeSpanTotalMilliseconds((+a - +(this.actualMinimumValue))) / timeSpanTotalMilliseconds(c);
        let e = 1 - (timeSpanTotalMilliseconds((+(this.actualMaximumValue) - +b)) / timeSpanTotalMilliseconds(c));
        e = Math.min(1, e);
        return new Rect(0, d, NaN, Math.max(0, e - d), NaN);
    }
    getCategorySize(a, b, c) {
        if (this.nc != (0)) {
            let d = timeSpanFromTicks(truncate((timeSpanTicks(this.nc) * (a.width / (this.bh != null ? this.bh.n2.width : 1)))));
            let e = timeSpanTicks(d) / timeSpanTicks(this.na);
            let f = b.width / 4;
            return Math.min(f, b.width / (e + 1));
        }
        return super.getCategorySize(a, b, c);
    }
    static m9(a, b) {
        let c = Math.min(5, b);
        let d = a(0);
        let e = new Dictionary$2(Number_$type, Number_$type, 0);
        let f = 0;
        let g = (0);
        for (let h = 0; h < c; h++) {
            let i = a(h);
            let j = +i - +d;
            if (!e.containsKey(j)) {
                e.addItem(j, 0);
            }
            e.item(j, e.item(j) + 1);
            if (e.item(j) > f) {
                f = e.item(j);
                g = j;
            }
            d = i;
        }
        return g;
    }
    m8() {
        if (this.k5 == null || this.k5.count < 2 || this.le == null) {
            return (0);
        }
        return TimeXAxis.m9((a) => this.k5.item(this.le._inner[a]), this.k5.count);
    }
    l2() {
        super.l2();
        this.na = this.m8();
    }
    static m5(a) {
        if (a >= timeSpanFromDays(1)) {
            return "D";
        }
        return "g";
    }
    itemLabelFormat() {
        return TimeXAxis.m5(this.na);
    }
    lo(a, b, c, d) {
        return this.ln(this.visibleMinimum);
    }
    lr(a, b, c, d) {
        return this.lq(this.visibleMaximum);
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
    get i$a() {
        return this.b7;
    }
}
TimeXAxis.$t = markType(TimeXAxis, 'TimeXAxis', TimeAxisBase.$, [ITimeRangeSelectorAxis_$type]);
TimeXAxis.mb = null;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OrdinalTimeXAxis extends CategoryXAxis {
    constructor() {
        super();
        this.l0 = dateMaxValue();
        this.lz = dateMinValue();
        this.l4 = dateMaxValue();
        this.l3 = dateMinValue();
        this.l9 = null;
        this.lv = 0;
        this.lx = null;
        this.lt = null;
        this.mh = 0;
        this.l2 = dateMinValue();
        this.l1 = dateMaxValue();
        this.visibleRangeChanged = null;
        FastItemDateTimeColumn.o();
        this.lt = new TimeAxisLabelFormatCollection();
        let a = this.lu;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.mj));
        this.lj = 0;
    }
    d0(a, b, c) {
        return this.dy(a, new ScalerParams(0, b, c, this.ca, this.i4()));
    }
    dz(a, b, c) {
        return this.dy(a, b);
    }
    dy(a, b) {
        let c = this.li;
        let d = this.lj;
        let e = this.li - this.lj;
        let f = e >= 1 ? (a - d) / (c - d) : e == 0 ? 0.5 : NaN;
        if (this.cb) {
            f = 1 - f;
        }
        let g = b.d;
        let h = b.e;
        return g.left + g.width * (f - h.left) / h.width;
    }
    gr(a, b, c, d, e) {
        let f = this.k4(a);
        let g = f != null;
        for (let h = 0; h < b.count; h++) {
            for (let i = c; i < d; i++) {
                let j = g ? f[i] : a.item(i);
                j[h] = this.dy(j[h], e);
            }
        }
    }
    gs(a, b, c, d) {
        for (let e = b; e < c; e++) {
            a.item(e, this.dy(a.item(e), d));
        }
    }
    d3(a, b, c) {
        return this.d1(a, new ScalerParams(0, b, this.i9, this.ca, this.i4()));
    }
    getUnscaledValue3(a, b, c, d) {
        return this.d1(a, new ScalerParams(0, b, this.i9, this.ca, this.i4()));
    }
    d1(a, b) {
        let c = b.e;
        let d = b.d;
        let e = c.left + (a - d.left) * c.width / d.width;
        if (this.cb) {
            e = 1 - e;
        }
        return this.lj + e * (this.li - this.lj);
    }
    d2(a, b, c) {
        return this.d1(a, b);
    }
    gt(a, b, c, d) {
        for (let e = b; e < c; e++) {
            a.item(e, this.d1(a.item(e), d));
        }
    }
    gz(a, b, c, d) {
        super.gz(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.ly);
                    this.ly = null;
                }
                if (this.jn != null) {
                    this.ly = TimeAxisBase.k7(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeMemberPath":
                if (this.jn != null) {
                    this.jn.deregisterColumn(this.ly);
                    this.ly = TimeAxisBase.k7(this.dateTimeMemberPath, this);
                }
                break;
            case "DateTimeColumn":
                this.cn();
                this.mh = this.mg();
                break;
            case "MinimumValue":
            case "MaximumValue":
                this.cn();
                this.ha();
                break;
            case "LabellingMode":
                this.ha();
                break;
        }
    }
    get actualMinimumValue() {
        return this.l0;
    }
    set actualMinimumValue(a) {
        this.l0 = a;
    }
    get actualMaximumValue() {
        return this.lz;
    }
    set actualMaximumValue(a) {
        this.lz = a;
    }
    get visibleMinimum() {
        return this.l4;
    }
    set visibleMinimum(a) {
        this.l4 = a;
    }
    get visibleMaximum() {
        return this.l3;
    }
    set visibleMaximum(a) {
        this.l3 = a;
    }
    mk() {
        if (this.ly == null || this.ly.count == 0 || this.ly.count < this.lj - 1) {
            this.actualMinimumValue = dateMinValue();
            this.actualMaximumValue = dateMaxValue();
            return;
        }
        let a = Math.max(0, Math.min(this.lj, this.ly.count - 1));
        let b = Math.max(0, Math.min(this.li, this.ly.count - 1));
        let c = +(this.actualMinimumValue) != +(this.ly.item(a)) || +(this.actualMaximumValue) != +(this.ly.item(b));
        if (c) {
            let d = this.actualMinimumValue;
            let e = this.actualMaximumValue;
            this.actualMinimumValue = this.ly.item(a);
            this.actualMaximumValue = this.ly.item(b);
            this.ml();
        }
    }
    ml() {
        if (this.ly == null || this.ly.count == 0 || this.bh == null) {
            let a = +(this.visibleMinimum) != +(this.actualMinimumValue) || +(this.visibleMaximum) != +(this.actualMaximumValue);
            this.visibleMinimum = this.actualMinimumValue;
            this.visibleMaximum = this.actualMaximumValue;
            if (a && this.visibleRangeChanged != null) {
                this.visibleRangeChanged(this, EventArgs.empty);
            }
            return;
        }
        let b = this.i3();
        let c = new ScalerParams(1, this.bh.oi, this.bh.oh, this.ca);
        let d = truncate(Math.ceil(this.d1(b.left, c)));
        let e = truncate(Math.ceil(this.d1(b.right, c)));
        let f = d >= 0 && d < this.ly.count ? this.ly.item(d) : this.actualMinimumValue;
        let g = e >= 0 && e < this.ly.count ? this.ly.item(e) : this.actualMaximumValue;
        let h = +(this.visibleMinimum) != +f || +(this.visibleMaximum) != +g;
        this.visibleMinimum = f;
        this.visibleMaximum = g;
        if (h && this.visibleRangeChanged != null) {
            this.visibleRangeChanged(this, EventArgs.empty);
        }
    }
    get dateTimeMemberPath() {
        return this.l9;
    }
    set dateTimeMemberPath(a) {
        let b = this.dateTimeMemberPath;
        if (a != b) {
            this.l9 = a;
            this.g5("DateTimeMemberPath", b, this.dateTimeMemberPath);
        }
    }
    get lw() {
        return this.lv;
    }
    set lw(a) {
        let b = this.lw;
        if (a != b) {
            this.lv = a;
            this.g5("LabellingMode", enumGetBox(TimeAxisLabellingMode_$type, b), enumGetBox(TimeAxisLabellingMode_$type, this.lw));
        }
    }
    get ly() {
        return this.lx;
    }
    set ly(a) {
        if (this.lx != a) {
            let b = this.lx;
            this.lx = a;
            this.g5("DateTimeColumn", b, this.lx);
        }
    }
    ho(a, b) {
        super.ho(a, b);
        this.ml();
    }
    getWindowRectForSelection(a, b) {
        if (this.ly == null) {
            return Rect.empty;
        }
        let c = a > b;
        let d = c ? b : a;
        let e = c ? a : b;
        let f = -1;
        while (++f < this.ly.count && this.ly.item(f) < d) {
        }
        let g = this.ly.count;
        while (--g >= 0 && this.ly.item(g) > e) {
        }
        let h = new ScalerParams(0, new Rect(0, 0, 0, 1, 1), new Rect(0, 0, 0, 1, 1), this.ca, this.bh.n6);
        let i = this.dy(f, h);
        let j = this.dy(g + 1, h);
        return new Rect(0, i, NaN, Math.max(0, j - i), NaN);
    }
    get lu() {
        return this.lt;
    }
    mj(a, b) {
        this.hb(false);
    }
    g1(a) {
        super.g1(a);
        this.dateTimeMemberPath = a;
    }
    e8(a) {
        if (this.at != null) {
            return this.at(a);
        }
        if (this.ah != null) {
            return this.ah.i(a);
        }
        if (!(typeCast(Date_$type, a) !== null)) {
            return super.e8(a);
        }
        let b = dateMinValue();
        let c = false;
        if (this.lk != null) {
            if (typeCast(Date_$type, this.lk) !== null) {
                b = this.lk;
                c = true;
            }
        }
        let d = TimeXAxis.mz(a, c, b, this.lw, this.mi, this.lu, this.et);
        return d == null ? super.e8(a) : d;
    }
    fl(a) {
        let b = 0;
        if (this.categoryMode == 0) {
            b = truncate(Math.round(a));
        }
        else {
            b = truncate(Math.floor(a));
        }
        if (b < 0 || b > this.j8 - 1) {
            return super.fl(a);
        }
        let c = this.ly.item(b);
        let d = this.e8(c);
        if (d == null) {
            return null;
        }
        return d.toString();
    }
    get mi() {
        return +(this.visibleMaximum) - +(this.visibleMinimum);
    }
    k6() {
        return this.ly;
    }
    hn(a, b) {
        super.hn(a, b);
        this.ml();
    }
    lc(a, b) {
        let c = this.categoryMode == 0 ? 0 : 0.5;
        return super.lc(a + c, b);
    }
    lb(a, b, c, d) {
        return b;
    }
    mg() {
        if (this.ly == null || this.ly.count < 2) {
            return (0);
        }
        return TimeXAxis.m9((a) => this.ly.item(a), this.ly.count);
    }
    itemLabelFormat() {
        return TimeXAxis.m5(this.mh);
    }
    get minimumValue() {
        return this.l2;
    }
    set minimumValue(a) {
        let b = this.minimumValue;
        if (+a != +b) {
            this.l2 = a;
            this.gz(this, "MinimumValue", b, this.minimumValue);
        }
    }
    get maximumValue() {
        return this.l1;
    }
    set maximumValue(a) {
        let b = this.maximumValue;
        if (+a != +b) {
            this.l1 = a;
            this.gz(this, "MaximumValue", b, this.maximumValue);
        }
    }
    cp() {
        if (+(this.minimumValue) == +(dateMaxValue()) || +(this.maximumValue) == +(dateMinValue())) {
            return super.cp();
        }
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jn == null || this.ly == null) {
            return false;
        }
        let a = this.lj;
        if (+(this.minimumValue) != +(dateMinValue())) {
            let b = -1;
            while (b++ <= this.ly.count) {
                if (this.ly.item(b) >= this.minimumValue) {
                    break;
                }
            }
            a = b;
        }
        let c = this.categoryMode == 0 ? this.jn.count - 1 : this.jn.count;
        if (+(this.maximumValue) != +(dateMaxValue())) {
            let d = this.jn.count;
            while (d-- > 0) {
                if (this.ly.item(d) <= this.maximumValue) {
                    break;
                }
            }
            c = d;
        }
        if (a != this.lj || c != this.li) {
            let e = new AxisRangeChangedEventArgs(0, this.lj, a, this.li, c);
            this.lj = a;
            this.li = c;
            this.g6(e);
            this.mk();
            this.kj();
            return true;
        }
        return false;
    }
    ks(a) {
        super.ks(a);
        this.co(true);
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
OrdinalTimeXAxis.$t = markType(OrdinalTimeXAxis, 'OrdinalTimeXAxis', CategoryXAxis.$, [ITimeRangeSelectorAxis_$type]);

class IgxTimeAxisLabelFormatCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxTimeAxisLabelFormatComponent.$type) {
            IgxTimeAxisLabelFormatComponent.$type = markType(IgxTimeAxisLabelFormatComponent, "IgxTimeAxisLabelFormatComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxTimeAxisLabelFormatComponent.$type) {
            IgxTimeAxisLabelFormatComponent.$type = markType(IgxTimeAxisLabelFormatComponent, "IgxTimeAxisLabelFormatComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxTimeAxisLabelFormatComponent.$type, TimeAxisLabelFormat.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxTimeAxisLabelFormatComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

var IgxOrdinalTimeXAxisComponent_1;
/**
 * A horizontal axis that uses an ordinal DateTime scale.
 * On an ordinal time axis, datapoints are aligned according to their order in the ItemsSource, like a category axis.
*
* You can use the `IgxOrdinalTimeXAxisComponent` to display dates at equidistant.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-ordinal-time-x-axis
* 		dateTimeMemberPath="date"
* 		#xAxis>
*     </igx-ordinal-time-x-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let xAxis = new IgxOrdinalTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*
* ```ts
* this.series.xAxis = this.ordinalTimeXAxis;
* this.series.yAxis = this.numericYAxis;
* this.series.xAxisName = "xAxis";
* this.series.yAxisName = "YAxis";
* ```
*/
const IgxOrdinalTimeXAxisComponent_PROVIDERS = [{ provide: IgxCategoryXAxisComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent) }];
let IgxOrdinalTimeXAxisComponent = IgxOrdinalTimeXAxisComponent_1 = class IgxOrdinalTimeXAxisComponent extends IgxCategoryXAxisComponent {
    constructor() {
        super();
        this._labelFormats = null;
    }
    createImplementation() {
        return new OrdinalTimeXAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the DateTime mapping property for the axis.
    */
    get dateTimeMemberPath() {
        return this.i.dateTimeMemberPath;
    }
    set dateTimeMemberPath(v) {
        this.i.dateTimeMemberPath = v;
    }
    /**
     * Gets or sets the labelling mode to use when the automatic label formats are applied.
    */
    get labellingMode() {
        return this.i.lw;
    }
    set labellingMode(v) {
        this.i.lw = ensureEnum(TimeAxisLabellingMode_$type, v);
    }
    /**
     * A list of axis label formats to apply, which are selected according to the visible axis range.
     * The label format selected will be the one with the largest range smaller than the visible range of the axis.
    *
    * You can use the `labelFormats` for adjusting the labels depending on the range of the time shown by the chart.
    *
    * ```ts
    * let labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm:ss";
    * labelFormat.range = 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "hh:mm";
    * labelFormat.range = 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "MMM-dd-yy";
    * labelFormat.range = 24 * 60 * 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "MMM yy";
    * labelFormat.range = 365.24 * 24 * 60 * 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * labelFormat = new TimeAxisLabelFormat();
    * labelFormat.format = "yyyy";
    * labelFormat.range = 5 * 365 * 24 * 60 * 60 * 1000;
    * this.xAxis.labelFormats.add(labelFormat);
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-ordinal-time-x-axis
    * 		[labelFormats]="labelFormats"
    * 		dateTimeMemberPath="time"
    * 		#xAxis>
    *     </igx-ordinal-time-x-axis>
    * </igx-data-chart>
    * ```
    */
    get labelFormats() {
        if (this._labelFormats === null) {
            let coll = new IgxTimeAxisLabelFormatCollection();
            let innerColl = this.i.lu;
            if (!innerColl) {
                innerColl = new TimeAxisLabelFormatCollection();
            }
            this._labelFormats = coll._fromInner(innerColl);
        }
        return this._labelFormats;
    }
    set labelFormats(v) {
        if (this._labelFormats !== null) {
            this._labelFormats._setSyncTarget(null);
            this._labelFormats = null;
        }
        let coll = new IgxTimeAxisLabelFormatCollection();
        this._labelFormats = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
        let innerColl = this.i.lu;
        if (!innerColl) {
            innerColl = new TimeAxisLabelFormatCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._labelFormats._setSyncTarget(syncColl);
    }
    /**
     * Sets the minimum DateTime value to be displayed on this axis.
     * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = v;
    }
    /**
     * Sets the maximum DateTime value to be displayed on this axis.
     * This property can be used to constrain the items displayed on the axis, within the range of DateTimes in the ItemsSource.  It will ignore any setting outside the actual range of data.
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.labelFormats != null && this.labelFormats.findByName && this.labelFormats.findByName(name)) {
            return this.labelFormats.findByName(name);
        }
        return null;
    }
    getValueLabel(value) {
        let iv = this.i.fl(value);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxOrdinalTimeXAxisComponent.prototype, "dateTimeMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxOrdinalTimeXAxisComponent.prototype, "labellingMode", null);
__decorate([
    Input(),
    __metadata("design:type", IgxTimeAxisLabelFormatCollection),
    __metadata("design:paramtypes", [IgxTimeAxisLabelFormatCollection])
], IgxOrdinalTimeXAxisComponent.prototype, "labelFormats", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxOrdinalTimeXAxisComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxOrdinalTimeXAxisComponent.prototype, "maximumValue", null);
IgxOrdinalTimeXAxisComponent = IgxOrdinalTimeXAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-ordinal-time-x-axis',
        template: ``,
        providers: [{ provide: IgxCategoryXAxisComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent_1) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxOrdinalTimeXAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxOrdinalTimeXAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOrdinalTimeXAxisModule = class IgxOrdinalTimeXAxisModule {
};
IgxOrdinalTimeXAxisModule = __decorate([
    NgModule({
        declarations: [IgxOrdinalTimeXAxisComponent],
        imports: [CommonModule],
        exports: [IgxOrdinalTimeXAxisComponent],
        entryComponents: []
    })
], IgxOrdinalTimeXAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOrdinalTimeXAxisDynamicModule = class IgxOrdinalTimeXAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxOrdinalTimeXAxisComponent", IgxOrdinalTimeXAxisComponent);
        TypeRegistrar.register("OrdinalTimeXAxis", OrdinalTimeXAxis.$type);
    }
};
IgxOrdinalTimeXAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxOrdinalTimeXAxisModule],
        exports: [IgxOrdinalTimeXAxisModule],
        entryComponents: [IgxOrdinalTimeXAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxOrdinalTimeXAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentChangeAxisRenderer extends NumericAxisRenderer {
    constructor(a) {
        super(a);
    }
    w(a, b, c, d) {
        let e = super.w(a, b, c, d);
        if (a.s == null) {
            e = e.toString() + "%";
        }
        return e;
    }
}
PercentChangeAxisRenderer.$t = markType(PercentChangeAxisRenderer, 'PercentChangeAxisRenderer', NumericAxisRenderer.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentChangeYAxis extends NumericYAxis {
    jq() {
        return new VerticalPercentChangeScaler(this);
    }
    jj() {
        let a = 1.7976931348623157E+308;
        let b = -1.7976931348623157E+308;
        for (let c of fromEnum(this.cw())) {
            let d = c.an(this);
            if (d == null) {
                continue;
            }
            let e = c.eh();
            if (isNaN_(e) || e == 0) {
                continue;
            }
            let f = d.b - e;
            let g = e - d.c;
            let h = Math.abs(f / e * 100);
            let i = Math.abs(g / e * 100);
            a = Math.min(a, -i);
            b = Math.max(b, h);
        }
        return new AxisRange(a, b);
    }
    jm(a) {
        return new PercentChangeAxisRenderer(a);
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
PercentChangeYAxis.$t = markType(PercentChangeYAxis, 'PercentChangeYAxis', NumericYAxis.$);
/**
 * @hidden
 */
class VerticalPercentChangeScaler extends NumericScaler {
    constructor(a) {
        super();
        this.ad = null;
        this.ad = a;
    }
    t(a, b, c, d, e) {
        let f = AutoRangeCalculator.a(this.ad, b, c, false, -1, d, e);
        d = f.p5;
        e = f.p6;
        return {
            p3: d,
            p4: e
        };
    }
    p(a, b) {
        let c;
        if (isNaN_(b.b)) {
            c = a;
        }
        else {
            let d = (a - b.b) / Math.abs(b.b) * 100;
            c = d;
        }
        let e = (c - this.o) / this.m;
        if (!b.a) {
            e = 1 - e;
        }
        return b.d.top + b.d.height * (e - b.e.top) / b.e.height;
    }
    q(a, b) {
        let c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
        if (!b.a) {
            c = 1 - c;
        }
        return this.o + c * (this.m);
    }
}
VerticalPercentChangeScaler.$t = markType(VerticalPercentChangeScaler, 'VerticalPercentChangeScaler', NumericScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPercentChangeYAxisComponent_1;
/**
 * A horizontal axis that uses a DateTime scale.
*
* You can use the `IgxPercentChangeYAxisComponent` show percentage values.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-percent-change-y-axis
* 		#yAxis>
*     </igx-percent-change-y-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let yAxis = new IgxPercentChangeYAxisComponent();
* this.chart.axes.add(yAxis);
* ```
*/
const IgxPercentChangeYAxisComponent_PROVIDERS = [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent) }];
let IgxPercentChangeYAxisComponent = IgxPercentChangeYAxisComponent_1 = class IgxPercentChangeYAxisComponent extends IgxNumericYAxisComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PercentChangeYAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxPercentChangeYAxisComponent = IgxPercentChangeYAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-percent-change-y-axis',
        template: ``,
        providers: [{ provide: IgxNumericYAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent_1) }, { provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent_1) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxPercentChangeYAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPercentChangeYAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentChangeYAxisModule = class IgxPercentChangeYAxisModule {
};
IgxPercentChangeYAxisModule = __decorate([
    NgModule({
        declarations: [IgxPercentChangeYAxisComponent],
        imports: [CommonModule],
        exports: [IgxPercentChangeYAxisComponent],
        entryComponents: []
    })
], IgxPercentChangeYAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentChangeYAxisDynamicModule = class IgxPercentChangeYAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPercentChangeYAxisComponent", IgxPercentChangeYAxisComponent);
        TypeRegistrar.register("PercentChangeYAxis", PercentChangeYAxis.$type);
    }
};
IgxPercentChangeYAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPercentChangeYAxisModule],
        exports: [IgxPercentChangeYAxisModule],
        entryComponents: [IgxPercentChangeYAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPercentChangeYAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarAxes extends Base {
    constructor(a, b) {
        super();
        this.b = null;
        this.a = null;
        this.g = { $type: Point_$type, x: 0.5, y: 0.5 };
        this.b = a;
        this.a = b;
    }
    c(a, b, c, d, e) {
        let f = this.g.x + (b * e(a));
        return ViewportUtils.c(f, c, d);
    }
    h(a, b, c, d, e, f, g, h, i, j) {
        let k = this.a.getScaledAngle1(a, e, f);
        let l = this.b.ly(b, g, h, i, j);
        let m = this.g.x;
        let n = this.g.y;
        let o = m + (l * Math.cos(k));
        let p = n + (l * Math.sin(k));
        o = d.left + d.width * (o - c.left) / c.width;
        p = d.top + d.height * (p - c.top) / c.height;
        return { $type: Point_$type, x: o, y: p };
    }
    e(a, b, c, d, e, f, g, h) {
        let i = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
        a.clear();
        let j;
        let k;
        let l = this.g.x;
        let m = this.g.y;
        let n;
        let o;
        let p = Math.min(this.a.kc, this.a.kb);
        let q = Math.max(this.a.kc, this.a.kb);
        let r = Math.min(this.b.kb, this.b.kc);
        let s = Math.max(this.b.kb, this.b.kc);
        let t = this.a.j2;
        let u = this.a.ca;
        let v = this.b.j2;
        let w = this.b.ca;
        let x = this.b.lr;
        let y = this.b.lq;
        for (let z = 0; z < i; z++) {
            if ((b.item(z) <= q && b.item(z) >= p && c.item(z) <= s && c.item(z) >= r) || (isNaN_(b.item(z)) || isNaN_(c.item(z)))) {
                j = this.a.getScaledAngle1(b.item(z), t, u);
                k = this.b.ly(c.item(z), v, w, x, y);
                n = l + (k * f(z, j));
                o = m + (k * g(z, j));
                n = e.left + e.width * (n - d.left) / d.width;
                o = e.top + e.height * (o - d.top) / d.height;
                a.add({ $type: Point_$type, x: n, y: o });
            }
            else {
                a.add({ $type: Point_$type, x: NaN, y: NaN });
            }
        }
    }
    f(a, b, c, d, e, f) {
        let g = ViewportUtils.a(a, c, d);
        let h = ViewportUtils.e(b, c, d);
        let i = Math.sqrt(Math.pow(g - this.g.x, 2) + Math.pow(h - this.g.y, 2));
        let j = Math.acos((g - this.g.x) / i);
        if ((h - this.g.y) < 0) {
            j = (2 * Math.PI) - j;
        }
        e = this.a.getUnscaledAngle(j);
        f = this.b.lz(i);
        return {
            p4: e,
            p5: f
        };
    }
    d(a, b, c, d, e) {
        let f = this.g.y + (b * e(a));
        return ViewportUtils.f(f, c, d);
    }
}
PolarAxes.$t = markType(PolarAxes, 'PolarAxes');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialAxes extends Base {
    constructor(a, b) {
        super();
        this.b = null;
        this.a = null;
        this.h = { $type: Point_$type, x: 0.5, y: 0.5 };
        this.b = a;
        this.a = b;
    }
    d(a, b, c, d) {
        let e = this.h.x + (b * Math.cos(a));
        return ViewportUtils.c(e, c, d);
    }
    f(a, b, c, d, e, f, g) {
        let h = Math.min(b != null ? b.count : 0, c != null ? c.count : 0);
        let i = false;
        if (a.count == h) {
            i = true;
        }
        let j;
        let k;
        let l = this.h.x;
        let m = this.h.y;
        let n;
        let o;
        for (let p = 0; p < h; p++) {
            j = this.a.getScaledAngle(b.item(p));
            k = this.b.lx(c.item(p));
            n = l + (k * f(p, j));
            o = m + (k * g(p, j));
            n = e.left + e.width * (n - d.left) / d.width;
            o = e.top + e.height * (o - d.top) / d.height;
            if (!i) {
                a.add({ $type: Point_$type, x: n, y: o });
            }
            else {
                a.item(p, { $type: Point_$type, x: n, y: o });
            }
        }
    }
    g(a, b, c, d, e, f) {
        let g = ViewportUtils.a(a, c, d);
        let h = ViewportUtils.e(b, c, d);
        let i = Math.sqrt(Math.pow(g - this.h.x, 2) + Math.pow(h - this.h.y, 2));
        let j = Math.acos((g - this.h.x) / i);
        if ((h - this.h.y) < 0) {
            j = (2 * Math.PI) - j;
        }
        e = this.a.getUnscaledAngle(j);
        f = this.b.lz(i);
        return {
            p4: e,
            p5: f
        };
    }
    e(a, b, c, d) {
        let e = this.h.y + (b * Math.sin(a));
        return ViewportUtils.f(e, c, d);
    }
    c(a) {
        let b = Math.sqrt(Math.pow(a.x - this.h.x, 2) + Math.pow(a.y - this.h.y, 2));
        let c = Math.acos((a.x - this.h.x) / b);
        if ((a.y - this.h.y) < 0) {
            c = (2 * Math.PI) - c;
        }
        return c;
    }
}
RadialAxes.$t = markType(RadialAxes, 'RadialAxes');

class IgxTimeAxisIntervalCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxTimeAxisIntervalComponent.$type) {
            IgxTimeAxisIntervalComponent.$type = markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxTimeAxisIntervalComponent.$type) {
            IgxTimeAxisIntervalComponent.$type = markType(IgxTimeAxisIntervalComponent, "IgxTimeAxisIntervalComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxTimeAxisIntervalComponent.$type, TimeAxisInterval.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxTimeAxisIntervalComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

class IgxTimeAxisBreakCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxTimeAxisBreakComponent.$type) {
            IgxTimeAxisBreakComponent.$type = markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxTimeAxisBreakComponent.$type) {
            IgxTimeAxisBreakComponent.$type = markType(IgxTimeAxisBreakComponent, "IgxTimeAxisBreakComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxTimeAxisBreakComponent.$type, TimeAxisBreak.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxTimeAxisBreakComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisBreakModule = class IgxTimeAxisBreakModule {
};
IgxTimeAxisBreakModule = __decorate([
    NgModule({
        declarations: [IgxTimeAxisBreakComponent],
        imports: [CommonModule],
        exports: [IgxTimeAxisBreakComponent],
        entryComponents: []
    })
], IgxTimeAxisBreakModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisBreakDynamicModule = class IgxTimeAxisBreakDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisBreakComponent", IgxTimeAxisBreakComponent);
        TypeRegistrar.register("TimeAxisBreak", TimeAxisBreak.$type);
        TypeRegistrar.registerCons("IgxTimeAxisBreakCollection", IgxTimeAxisBreakCollection);
        TypeRegistrar.register("TimeAxisBreakCollection", TimeAxisBreakCollection.$type);
    }
};
IgxTimeAxisBreakDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTimeAxisBreakModule],
        exports: [IgxTimeAxisBreakModule],
        entryComponents: [IgxTimeAxisBreakComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisBreakDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisIntervalModule = class IgxTimeAxisIntervalModule {
};
IgxTimeAxisIntervalModule = __decorate([
    NgModule({
        declarations: [IgxTimeAxisIntervalComponent],
        imports: [CommonModule],
        exports: [IgxTimeAxisIntervalComponent],
        entryComponents: []
    })
], IgxTimeAxisIntervalModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisIntervalDynamicModule = class IgxTimeAxisIntervalDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisIntervalComponent", IgxTimeAxisIntervalComponent);
        TypeRegistrar.register("TimeAxisInterval", TimeAxisInterval.$type);
        TypeRegistrar.registerCons("IgxTimeAxisIntervalCollection", IgxTimeAxisIntervalCollection);
        TypeRegistrar.register("TimeAxisIntervalCollection", TimeAxisIntervalCollection.$type);
    }
};
IgxTimeAxisIntervalDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTimeAxisIntervalModule],
        exports: [IgxTimeAxisIntervalModule],
        entryComponents: [IgxTimeAxisIntervalComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisIntervalDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisLabelFormatModule = class IgxTimeAxisLabelFormatModule {
};
IgxTimeAxisLabelFormatModule = __decorate([
    NgModule({
        declarations: [IgxTimeAxisLabelFormatComponent],
        imports: [CommonModule],
        exports: [IgxTimeAxisLabelFormatComponent],
        entryComponents: []
    })
], IgxTimeAxisLabelFormatModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeAxisLabelFormatDynamicModule = class IgxTimeAxisLabelFormatDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatComponent", IgxTimeAxisLabelFormatComponent);
        TypeRegistrar.register("TimeAxisLabelFormat", TimeAxisLabelFormat.$type);
        TypeRegistrar.registerCons("IgxTimeAxisLabelFormatCollection", IgxTimeAxisLabelFormatCollection);
        TypeRegistrar.register("TimeAxisLabelFormatCollection", TimeAxisLabelFormatCollection.$type);
    }
};
IgxTimeAxisLabelFormatDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTimeAxisLabelFormatModule],
        exports: [IgxTimeAxisLabelFormatModule],
        entryComponents: [IgxTimeAxisLabelFormatComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTimeAxisLabelFormatDynamicModule);

var IgxTimeXAxisComponent_1;
/**
 * A horizontal axis that uses a DateTime scale.
*
* The `IgxTimeXAxisComponent` is a horizontal axis that uses a DateTime scale.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-time-x-axis
* 		dateTimeMemberPath="date"
* 		#xAxis>
*     </igx-time-x-axis>
* </igx-data-chart>
* ```
*
* ```ts
* let xAxis = new IgxTimeXAxisComponent();
* xAxis.dataTimeMemberPath="date";
* this.chart.axes.add(xAxis);
* ```
*/
const IgxTimeXAxisComponent_PROVIDERS = [{ provide: IgxTimeAxisBaseComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent) }];
let IgxTimeXAxisComponent = IgxTimeXAxisComponent_1 = class IgxTimeXAxisComponent extends IgxTimeAxisBaseComponent {
    constructor() {
        super();
        this._breaks = null;
        this._labelFormats = null;
        this._intervals = null;
    }
    createImplementation() {
        return new TimeXAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    get isPiecewise() {
        return this.i.cd;
    }
    /**
     * TimeAxisBreaks to apply to this axis, representing spans of time to omit, such as weekends.
    *
    * The `breaks` to apply to this axis, representing spans of time to omit, such as weekends.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    *     <igx-time-x-axis
    * 		dateTimeMemberPath="date"
    * 		#xAxis>
    *     </igx-time-x-axis>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let xAxis = new IgxTimeXAxisComponent();
    * xAxis.dataTimeMemberPath="date";
    * this.chart.axes.add(xAxis);
    * ```
    */
    get breaks() {
        if (this._breaks === null) {
            let coll = new IgxTimeAxisBreakCollection();
            let innerColl = this.i.breaks;
            if (!innerColl) {
                innerColl = new TimeAxisBreakCollection();
            }
            this._breaks = coll._fromInner(innerColl);
        }
        return this._breaks;
    }
    set breaks(v) {
        if (this._breaks !== null) {
            this._breaks._setSyncTarget(null);
            this._breaks = null;
        }
        let coll = new IgxTimeAxisBreakCollection();
        this._breaks = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(TimeAxisBreak.$type);
        let innerColl = this.i.breaks;
        if (!innerColl) {
            innerColl = new TimeAxisBreakCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._breaks._setSyncTarget(syncColl);
    }
    /**
     * Gets or sets the labelling mode to use when the automatic label formats are applied.
    */
    get labellingMode() {
        return this.i.mo;
    }
    set labellingMode(v) {
        this.i.mo = ensureEnum(TimeAxisLabellingMode_$type, v);
    }
    /**
     * A list of axis label formats to apply, which are selected according to the visible axis range.
     * The label format selected will be the one with the largest range smaller than the visible range of the axis.
    */
    get labelFormats() {
        if (this._labelFormats === null) {
            let coll = new IgxTimeAxisLabelFormatCollection();
            let innerColl = this.i.labelFormats;
            if (!innerColl) {
                innerColl = new TimeAxisLabelFormatCollection();
            }
            this._labelFormats = coll._fromInner(innerColl);
        }
        return this._labelFormats;
    }
    set labelFormats(v) {
        if (this._labelFormats !== null) {
            this._labelFormats._setSyncTarget(null);
            this._labelFormats = null;
        }
        let coll = new IgxTimeAxisLabelFormatCollection();
        this._labelFormats = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(TimeAxisLabelFormat.$type);
        let innerColl = this.i.labelFormats;
        if (!innerColl) {
            innerColl = new TimeAxisLabelFormatCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._labelFormats._setSyncTarget(syncColl);
    }
    /**
     * A list of axis label intervals to apply, which are selected according to the visible axis range.
     * The interval selected will be the one with the largest range smaller than the visible range of the axis.
    */
    get intervals() {
        if (this._intervals === null) {
            let coll = new IgxTimeAxisIntervalCollection();
            let innerColl = this.i.intervals;
            if (!innerColl) {
                innerColl = new TimeAxisIntervalCollection();
            }
            this._intervals = coll._fromInner(innerColl);
        }
        return this._intervals;
    }
    set intervals(v) {
        if (this._intervals !== null) {
            this._intervals._setSyncTarget(null);
            this._intervals = null;
        }
        let coll = new IgxTimeAxisIntervalCollection();
        this._intervals = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(TimeAxisInterval.$type);
        let innerColl = this.i.intervals;
        if (!innerColl) {
            innerColl = new TimeAxisIntervalCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._intervals._setSyncTarget(syncColl);
    }
    /**
     * Gets if the current axis is of category date time axis type
    */
    get isCategoryDateTime() {
        return this.i.b5;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.breaks != null && this.breaks.findByName && this.breaks.findByName(name)) {
            return this.breaks.findByName(name);
        }
        if (this.labelFormats != null && this.labelFormats.findByName && this.labelFormats.findByName(name)) {
            return this.labelFormats.findByName(name);
        }
        if (this.intervals != null && this.intervals.findByName && this.intervals.findByName(name)) {
            return this.intervals.findByName(name);
        }
        return null;
    }
    getValueLabel(value) {
        let iv = this.i.fl(value);
        return (iv);
    }
    /**
     * Gets the index of the data item with the value nearest the given value.
    
    * @param unscaledValue  * The value to find a value close to.
    */
    getIndexClosestToUnscaledValue(unscaledValue) {
        let iv = this.i.i$f(unscaledValue);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxTimeAxisBreakCollection),
    __metadata("design:paramtypes", [IgxTimeAxisBreakCollection])
], IgxTimeXAxisComponent.prototype, "breaks", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTimeXAxisComponent.prototype, "labellingMode", null);
__decorate([
    Input(),
    __metadata("design:type", IgxTimeAxisLabelFormatCollection),
    __metadata("design:paramtypes", [IgxTimeAxisLabelFormatCollection])
], IgxTimeXAxisComponent.prototype, "labelFormats", null);
__decorate([
    Input(),
    __metadata("design:type", IgxTimeAxisIntervalCollection),
    __metadata("design:paramtypes", [IgxTimeAxisIntervalCollection])
], IgxTimeXAxisComponent.prototype, "intervals", null);
IgxTimeXAxisComponent = IgxTimeXAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-time-x-axis',
        template: ``,
        providers: [{ provide: IgxTimeAxisBaseComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent_1) }, { provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxTimeXAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxTimeXAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeXAxisModule = class IgxTimeXAxisModule {
};
IgxTimeXAxisModule = __decorate([
    NgModule({
        declarations: [IgxTimeXAxisComponent],
        imports: [CommonModule, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule],
        exports: [IgxTimeXAxisComponent, IgxTimeAxisBreakModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatModule],
        entryComponents: []
    })
], IgxTimeXAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTimeXAxisDynamicModule = class IgxTimeXAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTimeXAxisComponent", IgxTimeXAxisComponent);
        TypeRegistrar.register("TimeXAxis", TimeXAxis.$type);
    }
};
IgxTimeXAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTimeXAxisModule],
        exports: [IgxTimeXAxisModule],
        entryComponents: [IgxTimeXAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTimeXAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TimeRepetitionLevel_$type = markEnum('TimeRepetitionLevel', 'None,0|Year,1|Month,2|Day,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AngleRadiusPair extends Base {
    constructor() {
        super(...arguments);
        this.c = 0;
        this.a = 0;
        this.b = 0;
    }
}
AngleRadiusPair.$t = markType(AngleRadiusPair, 'AngleRadiusPair');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarLinePlanner extends Base {
    constructor() {
        super(...arguments);
        this.f = false;
        this.b = 0;
        this.m = null;
        this.n = null;
        this.o = null;
        this.p = null;
        this.l = 0;
        this.q = 0;
        this.z = null;
        this.aa = null;
        this.a = null;
        this.c = false;
        this.d = false;
        this.i = null;
    }
    get ab() {
        return this.z;
    }
    set ab(a) {
        this.z = a;
    }
    get ac() {
        return this.aa;
    }
    set ac(a) {
        this.aa = a;
    }
    g() {
        if (this.m == null || this.n == null || this.o == null || this.p == null || Rect.l_op_Equality(this.ab, Rect.empty) || Rect.l_op_Equality(this.ac, Rect.empty)) {
            return false;
        }
        return true;
    }
    k(a, b, c, d) {
        let e = a(d) - a(c);
        let f = b(d) - b(c);
        return e * e + f * f;
    }
    h(a) {
        let b = new List$1(AngleRadiusPair.$, 0);
        let c = this.l * this.l;
        let d;
        if (a != null) {
            d = a;
        }
        else {
            let e = new List$1(Number_$type, 0);
            for (let f = 0; f < this.q; f++) {
                e.add(f);
            }
            d = e;
        }
        let g = getEnumerator(d);
        let h = true;
        h = g.moveNext();
        let i = 0;
        if (h) {
            i = g.current;
        }
        while (h) {
            let j = i;
            h = g.moveNext();
            i = g.current;
            while (h && this.k(this.o, this.p, j, i) < c) {
                h = g.moveNext();
                i = g.current;
            }
            let k = new AngleRadiusPair();
            k.c = j;
            if (!this.f) {
                k.a = this.m(j);
                k.b = this.n(j);
            }
            b.add(k);
        }
        return b;
    }
    v(a) {
        for (let b of fromEnum(this.h(a))) {
            if (isNaN_(b.a) || isInfinity(b.a) || isNaN_(b.b) || isInfinity(b.b)) {
                this.s({ $type: Point_$type, x: NaN, y: NaN });
                continue;
            }
            this.s({ $type: Point_$type, x: this.o(b.c), y: this.p(b.c) });
        }
    }
    j() {
        return Math.pow(this.l / (Math.max(this.ab.width / this.ac.width, this.ab.height / this.ac.height)), 2);
    }
    r(a, b) {
        let c = 0.5 + b * Math.cos(a);
        let d = 0.5 + b * Math.sin(a);
        c = this.z.left + this.z.width * (c - this.aa.left) / this.aa.width;
        d = this.z.top + this.z.height * (d - this.aa.top) / this.aa.height;
        this.s({ $type: Point_$type, x: c, y: d });
    }
    y(a) {
        let b = this.j();
        let c = this.h(a);
        let d = c.item(0).a;
        let e = c.item(0).b;
        let f = c.item(0).c;
        for (let g = 1; g < c.count; g++) {
            let h = c.item(g).a;
            let i = c.item(g).b;
            let j = c.item(g).c;
            if (isNaN_(h) || isInfinity(h) || isNaN_(i) || isInfinity(i)) {
                this.s({ $type: Point_$type, x: NaN, y: NaN });
                if (this.b != 0) {
                    g++;
                    if (g < c.count) {
                        d = c.item(g).a;
                        e = c.item(g).b;
                    }
                }
                continue;
            }
            this.t(h, i, d, e, g, b, f > j);
            d = h;
            e = i;
            f = j;
        }
    }
    t(a, b, c, d, e, f, g) {
        let h = false;
        if ((a < c && !g) || (a > c && g)) {
            h = true;
            let i = a;
            a = c;
            c = i;
            i = b;
            b = d;
            d = i;
        }
        let j = SpiralFlattener.a(c, d, a, b, f);
        if (h) {
            let k = new List$1(Number_$type, 2, j.count);
            for (let l = j.count - 1; l >= 0; l--) {
                k.add(j._inner[l]);
            }
            j = k;
        }
        for (let m = 0; m < j.count; m++) {
            let n = j._inner[m];
            let o = c + n * (a - c);
            let p = d + n * (b - d);
            this.r(o, p);
        }
    }
    u(a) {
        let b = this.ab.top - 10;
        let c = this.ab.bottom + 10;
        let d = this.ab.left - 10;
        let e = this.ab.right + 10;
        if (this.a == null) {
            this.a = ((() => {
                let $ret = new Clipper(1, d, c, e, b, this.d);
                $ret.i = a;
                return $ret;
            })());
        }
    }
    e(a) {
        return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
    }
    s(a) {
        if (this.b == 0 && !this.e(a)) {
            return;
        }
        if (this.c) {
            this.i.add(a);
        }
        else {
            this.a.j(a);
        }
    }
    w(a) {
        this.x(null, null);
    }
    x(a, b) {
        this.i = a;
        if (!this.g()) {
            return;
        }
        if (this.q > 1) {
            this.u(a);
            if (this.f) {
                this.v(b);
            }
            else {
                this.y(b);
            }
            this.a.i = null;
        }
    }
}
PolarLinePlanner.$t = markType(PolarLinePlanner, 'PolarLinePlanner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IOverlayProxy_$type = new Type(null, 'IOverlayProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OverlayProxy extends Base {
    matchesType(a) {
        if (stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return true;
        }
        return false;
    }
    setCloseMemberPath(a, b) {
        a.om = b;
    }
    setHighMemberPath(a, b) {
        a.op = b;
    }
    setLowMemberPath(a, b) {
        a.ou = b;
    }
    setMultiplier(a, b) {
        if (getInstanceType(a).typeName == "BollingerBandsOverlay") {
            let s_ = a;
            let p_ = b;
            s_['multiplier'] = p_;
        }
    }
    setOpenMemberPath(a, b) {
        a.oy = b;
    }
    setVolumeMemberPath(a, b) {
        a.o2 = b;
    }
    setXAxis(a, b) {
        a.mi = b;
    }
    setYAxis(a, b) {
        a.m3 = b;
    }
}
OverlayProxy.$t = markType(OverlayProxy, 'OverlayProxy', Base.$, [IOverlayProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOverlayProxyModule = class IgxOverlayProxyModule {
    constructor() {
        TypeRegistrar.register('OverlayProxy', OverlayProxy.$type);
    }
};
IgxOverlayProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxOverlayProxyModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOverlayProxyDynamicModule = class IgxOverlayProxyDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('OverlayProxy', OverlayProxy);
        TypeRegistrar.register('OverlayProxy', OverlayProxy.$type);
    }
};
IgxOverlayProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxOverlayProxyModule
        ],
        imports: [CommonModule, IgxOverlayProxyModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxOverlayProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IIndicatorProxy_$type = new Type(null, 'IIndicatorProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IShortPeriodLongPeriod_$type = new Type(null, 'IShortPeriodLongPeriod');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialValueList extends Base {
    constructor(a, b, c, d, e) {
        super();
        this.d = null;
        this.b = null;
        this.a = null;
        this.c = null;
        this.e = null;
        this.d = a;
        this.b = b;
        this.a = d;
        this.c = c;
        this.e = e;
    }
    indexOf(a) {
        throw new NotImplementedException(0);
    }
    insert(a, b) {
        throw new NotImplementedException(0);
    }
    removeAt(a) {
        throw new NotImplementedException(0);
    }
    item(a, b) {
        if (arguments.length === 2) {
            return b;
        }
        else {
            let b = NaN;
            let c = NaN;
            let d = NaN;
            let e = NaN;
            let f = NaN;
            if (this.d != null && a >= 0 && a < this.d.count) {
                b = this.d.item(a);
            }
            if (this.b != null && a >= 0 && a < this.b.count) {
                c = this.b.item(a);
            }
            if (this.c != null && a >= 0 && a < this.c.count) {
                d = this.c.item(a);
            }
            if (this.a != null && a >= 0 && a < this.a.count) {
                e = this.a.item(a);
            }
            if (this.e != null && a >= 0 && a < this.e.count) {
                f = this.e.item(a);
            }
            let g = isNaN_(b);
            let h = isNaN_(c);
            let i = isNaN_(d);
            let j = isNaN_(e);
            let k = isNaN_(f);
            if (!h && !i && !j) {
                return (c + d + e) / 3;
            }
            if (!h && !i) {
                return (c + d) / 2;
            }
            if (!g && !j) {
                return (b + e) / 2;
            }
            if (!g) {
                return b;
            }
            if (!h) {
                return c;
            }
            if (!i) {
                return d;
            }
            if (!j) {
                return e;
            }
            return NaN;
        }
    }
    add(a) {
        throw new NotImplementedException(0);
    }
    clear() {
        throw new NotImplementedException(0);
    }
    contains(a) {
        throw new NotImplementedException(0);
    }
    copyTo(a, b) {
        throw new NotImplementedException(0);
    }
    get count() {
        let a = 0;
        let b = 0;
        let c = 0;
        let d = 0;
        let e = 0;
        if (this.d != null) {
            a = this.d.count;
        }
        if (this.b != null) {
            b = this.b.count;
        }
        if (this.c != null) {
            c = this.c.count;
        }
        if (this.a != null) {
            d = this.a.count;
        }
        if (this.e != null) {
            e = this.e.count;
        }
        let f = 0;
        f = Math.max(f, a);
        f = Math.max(f, b);
        f = Math.max(f, c);
        f = Math.max(f, d);
        f = Math.max(f, e);
        return f;
    }
    get isReadOnly() {
        return true;
    }
    remove(a) {
        throw new NotImplementedException(0);
    }
    getEnumerator() {
        throw new NotImplementedException(0);
    }
    getEnumeratorObject() {
        throw new NotImplementedException(0);
    }
}
FinancialValueList.$t = markType(FinancialValueList, 'FinancialValueList', Base.$, [IList$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalculatedColumn extends Base {
    constructor(a, ..._rest) {
        super();
        this._valuesProvider = null;
        this.c = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [];
                    for (let b = 1; b < _rest.length; b++) {
                        d[b - 1] = _rest[b];
                    }
                    this._valuesProvider = c;
                    this.c = new List$1(String_$type, 1, d);
                }
                break;
            case 1:
                {
                    let d = _rest[0];
                    let e = _rest[1];
                    this._valuesProvider = d;
                    this.c = new List$1(String_$type, 1, e);
                }
                break;
        }
    }
    get basedOn() {
        return this.c;
    }
    getEnumerator() {
        return getEnumerator(this._valuesProvider);
    }
    getEnumeratorObject() {
        return getEnumerator(this._valuesProvider);
    }
}
CalculatedColumn.$t = markType(CalculatedColumn, 'CalculatedColumn', Base.$, [IEnumerable$1_$type.specialize(Number_$type)]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SupportingCalculation$1 extends Base {
    constructor($tCalculationStrategy, a, ..._rest) {
        super();
        this.$tCalculationStrategy = null;
        this.a = null;
        this.d = null;
        this.$tCalculationStrategy = $tCalculationStrategy;
        this.$type = this.$type.specialize(this.$tCalculationStrategy);
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    this.a = c;
                    this.d = new List$1(String_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    this.a = c;
                    this.d = new List$1(String_$type, 1, d);
                }
                break;
        }
    }
    get b() {
        return this.a;
    }
    get c() {
        return this.d;
    }
}
SupportingCalculation$1.$t = markType(SupportingCalculation$1, 'SupportingCalculation$1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ColumnSupportingCalculation extends SupportingCalculation$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    super(Delegate_$type, 0, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    super(Delegate_$type, 1, c, d);
                }
                break;
        }
    }
}
ColumnSupportingCalculation.$t = markType(ColumnSupportingCalculation, 'ColumnSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialEventArgs extends EventArgs {
    constructor(a, b, c, d, e) {
        super();
        this._position = 0;
        this._count = 0;
        this._dataSource = null;
        this._supportingCalculations = null;
        this._basedOn = null;
        this.position = a;
        this.count = b;
        this.dataSource = c;
        this.supportingCalculations = d;
        if (c != null) {
            c.series = e;
        }
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get dataSource() {
        return this._dataSource;
    }
    set dataSource(a) {
        this._dataSource = a;
    }
    get supportingCalculations() {
        return this._supportingCalculations;
    }
    set supportingCalculations(a) {
        this._supportingCalculations = a;
    }
    get basedOn() {
        return this._basedOn;
    }
    set basedOn(a) {
        this._basedOn = a;
    }
}
FinancialEventArgs.$t = markType(FinancialEventArgs, 'FinancialEventArgs', EventArgs.$);
/**
 * @hidden
 */
class FinancialBucketCalculator extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.b = 0;
        if (a == null) {
            throw new ArgumentNullException(0, "view");
        }
        this.a = a;
        this.c = -1;
        this.d = this.d;
        this.b = 0;
    }
    getBucket(a) {
        return null;
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    getBucketInfo(a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.bw.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    e(a) {
        let b = this.a.bs;
        let c = this.a.br;
        let d = this.a.br;
        if (this.a.bw != null) {
            d = this.a.bw.getEffectiveViewport1(this.a);
        }
        if (b.isEmpty || c.isEmpty || this.a.bw.mi == null) {
            this.b = 0;
            return;
        }
        let e = (this.a.bw.mi != null) ? this.a.bw.mi.ca : false;
        let f = new ScalerParams(0, b, c, e, d);
        let g = this.a.bw.l0(this.a);
        let h = typeCast(ISortingAxis_$type, this.a.bw.mi);
        if (h == null || h.i$b == null) {
            let i = Math.floor(this.a.bw.mi.d1(g.left, f));
            let j = Math.ceil(this.a.bw.mi.d1(g.right, f));
            if (this.a.bw.mi.ca) {
                j = Math.ceil(this.a.bw.mi.d1(g.left, f));
                i = Math.floor(this.a.bw.mi.d1(g.right, f));
            }
            let k = Math.floor((j - i + 1) * a / g.width);
            this.b = truncate(Math.max(1, k));
            this.c = truncate(Math.floor(i / this.b));
            this.d = truncate(Math.ceil(j / this.b));
        }
        else {
            this.c = h.i$e(b, c, d, g);
            this.d = h.i$g(b, c, d, g);
            this.b = 1;
        }
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
FinancialBucketCalculator.$t = markType(FinancialBucketCalculator, 'FinancialBucketCalculator', Base.$, [IBucketizer_$type]);
/**
 * @hidden
 */
class FinancialSeries extends Series {
    constructor() {
        super();
        this.m8 = null;
        this.m6 = null;
        this.m7 = null;
        this.m5 = null;
        this.m9 = null;
        this.ni = false;
        this.assigningCategoryStyle = null;
        this.mq = null;
        this.nt = new Dictionary$2(IFastItemColumn$1_$type.specialize(Number_$type), String_$type, 0);
        this.nu = new Dictionary$2(String_$type, String_$type, 0);
        this.nh = false;
        this.m1 = null;
        this.ml = null;
        this.mn = null;
        this.mk = null;
        this.mt = null;
        this.typical = null;
        this.typicalBasedOn = null;
        this.ng = false;
        this.n6 = null;
        this.n4 = null;
        this.n5 = null;
        this.n3 = null;
        this.n7 = null;
        this.mm = null;
        this.mj = null;
        this.mo = 0;
        this.m2 = null;
        this.m4 = null;
        this.mq = new CategorySeriesRenderManager();
        this.ni = false;
        this.mt = new CategoryTransitionSourceFramePreparer();
        this.mm = new CategoryFrame(3);
        this.ab = FinancialSeries.$;
        this.mp = 0;
    }
    i2(a) {
        super.i2(a);
        this.my = a;
    }
    get_cr() {
        return true;
    }
    ag() {
        return [this.mi, this.m3];
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == FinancialSeries.$$p[6]) {
            return this.ft(a, b, this.oy);
        }
        if (c == FinancialSeries.$$p[1]) {
            return this.ft(a, b, this.op);
        }
        if (c == FinancialSeries.$$p[4]) {
            return this.ft(a, b, this.ou);
        }
        if (c == FinancialSeries.$$p[0]) {
            return this.ft(a, b, this.om);
        }
        if (c == FinancialSeries.$$p[8]) {
            return this.ft(a, b, this.o2);
        }
        return super.fs(a, b);
    }
    oi() {
        return 2;
    }
    og() {
        return 4;
    }
    ah(a) {
        let b = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        let g = this.oi();
        f[0] = { $type: Point_$type, x: c[0], y: c[g] };
        f[1] = { $type: Point_$type, x: d[0], y: d[g] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    lj() {
        return this.po;
    }
    h1() {
        super.h1();
        this.mi = null;
        this.m3 = null;
    }
    get nd() {
        return this.m8;
    }
    set nd(a) {
        if (this.m8 != a) {
            let b = this.m8;
            this.m8 = a;
            this.raisePropertyChanged("OpenColumn", b, this.m8);
        }
    }
    get nb() {
        return this.m6;
    }
    set nb(a) {
        if (this.m6 != a) {
            let b = this.m6;
            this.m6 = a;
            this.raisePropertyChanged("HighColumn", b, this.m6);
        }
    }
    get nc() {
        return this.m7;
    }
    set nc(a) {
        if (this.m7 != a) {
            let b = this.m7;
            this.m7 = a;
            this.raisePropertyChanged("LowColumn", b, this.m7);
        }
    }
    get na() {
        return this.m5;
    }
    set na(a) {
        if (this.m5 != a) {
            let b = this.m5;
            this.m5 = a;
            this.raisePropertyChanged("CloseColumn", b, this.m5);
        }
    }
    get nf() {
        return this.m9;
    }
    set nf(a) {
        if (this.m9 != a) {
            let b = this.m9;
            this.m9 = a;
            this.raisePropertyChanged("VolumeColumn", b, this.m9);
        }
    }
    nq() {
        return (this.assigningCategoryStyle != null && this.ni) || this.cu;
    }
    pa(a) {
        if (this.assigningCategoryStyle != null && this.ni) {
            this.assigningCategoryStyle(this, a);
        }
    }
    o8(a, b, c, d, e, f) {
        let g = this.b9;
        this.mq.ac(a, b, c, d, e, f, g);
        let h = this.mq.c;
        let i = null;
        let j = this.bz;
        if (g && this.bs != null) {
            i = this.bs.az.getHighlightingInfo(this, j, d, h.m, h.l, false);
            h.b = i;
        }
        h.f = f;
        this.pa(h);
        this.mq.aa(i, f, g);
    }
    n8(a) {
        return this.ed(a, this.mi);
    }
    fe(a, b) {
        return this.ff(a, b, this.mi, runOn(this, this.n8), new FinancialValueList(this.nd, this.nb, this.nc, this.na, this.nf));
    }
    fc(a, b) {
        return this.fd(a, b, this.mi, runOn(this, this.n8), new FinancialValueList(this.nd, this.nb, this.nc, this.na, this.nf));
    }
    d9(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.mi.j7;
        return this.ea(a, b, this.mi, d, e, f, runOn(this, this.n8));
    }
    getOffsetValue() {
        return this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.mi.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    lv(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, null, null, null);
    }
    en(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(new FinancialValueList(this.nd, this.nb, this.nc, this.na, this.nf), a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    ej(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(this.nb, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    el(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(this.nc, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    oa(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(this.na, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    ob(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(this.nd, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    oc(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        return this.ep(this.nf, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    lr(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, runOn(this, this.ej), (d, e) => this.ff(d, e, this.mi, runOn(this, this.n8), this.nb), (d, e) => this.fd(d, e, this.mi, runOn(this, this.n8), this.nb));
    }
    lt(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, runOn(this, this.el), (d, e) => this.ff(d, e, this.mi, runOn(this, this.n8), this.nc), (d, e) => this.fd(d, e, this.mi, runOn(this, this.n8), this.nc));
    }
    pq(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, runOn(this, this.ob), (d, e) => this.ff(d, e, this.mi, runOn(this, this.n8), this.nd), (d, e) => this.fd(d, e, this.mi, runOn(this, this.n8), this.nd));
    }
    pp(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, runOn(this, this.oa), (d, e) => this.ff(d, e, this.mi, runOn(this, this.n8), this.na), (d, e) => this.fd(d, e, this.mi, runOn(this, this.n8), this.na));
    }
    pr(a, b, c) {
        return this.lx(a, b, c, this.n9(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.m3, this.mi, runOn(this, this.oc), (d, e) => this.ff(d, e, this.mi, runOn(this, this.n8), this.nf), (d, e) => this.fd(d, e, this.mi, runOn(this, this.n8), this.nf));
    }
    ik() {
        super.ik();
        if (this.mi != null) {
            this.mi.hb(false);
        }
        if (this.m3 != null) {
            this.m3.hb(false);
        }
    }
    j1(a, b) {
        this.my.bu.e(this.eu);
        this.jl(false);
    }
    j0(a, b) {
        if (this.dm && this.ez < 0.05) {
            this.dn = true;
        }
        this.my.bu.e(this.eu);
        this.jl(false);
    }
    ne(a, b, c) {
        let d = this.bw(b);
        this.nt.addItem(d, b);
        this.nu.addItem(b, c);
        return d;
    }
    o7(a, b) {
        if (b == null) {
            return;
        }
        a.deregisterColumn(b);
        let c = this.nt.item(b);
        this.nu.removeItem(c);
        this.nt.removeItem(b);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.mi != null) {
                        this.mi.bx(this);
                    }
                    if (this.m3 != null) {
                        this.m3.bx(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.mi != null) {
                        this.mi.ck(this);
                    }
                    if (this.m3 != null) {
                        this.m3.ck(this);
                    }
                }
                this.my.bu.e(this.eu);
                this.jl(false);
                break;
            case "FastItemsSource":
                this.nh = true;
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    this.o7(typeCast(IFastItemsSource_$type, c), this.nd);
                    this.o7(typeCast(IFastItemsSource_$type, c), this.nb);
                    this.o7(typeCast(IFastItemsSource_$type, c), this.nc);
                    this.o7(typeCast(IFastItemsSource_$type, c), this.na);
                    this.o7(typeCast(IFastItemsSource_$type, c), this.nf);
                    this.nd = null;
                    this.nb = null;
                    this.nc = null;
                    this.na = null;
                    this.nf = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    if (stringIsNullOrEmpty(this.oy) == false) {
                        this.nd = this.ne(typeCast(IFastItemsSource_$type, d), this.oy, "OpenColumn");
                    }
                    if (stringIsNullOrEmpty(this.op) == false) {
                        this.nb = this.ne(typeCast(IFastItemsSource_$type, d), this.op, "HighColumn");
                    }
                    if (stringIsNullOrEmpty(this.ou) == false) {
                        this.nc = this.ne(typeCast(IFastItemsSource_$type, d), this.ou, "LowColumn");
                    }
                    if (stringIsNullOrEmpty(this.om) == false) {
                        this.na = this.ne(typeCast(IFastItemsSource_$type, d), this.om, "CloseColumn");
                    }
                    if (stringIsNullOrEmpty(this.o2) == false) {
                        this.nf = this.ne(typeCast(IFastItemsSource_$type, d), this.o2, "VolumeColumn");
                    }
                }
                this.nh = false;
                if (this.m3 != null && !this.m3.cn()) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case FinancialSeries.$$p[6]:
                if (this.bz != null) {
                    this.o7(this.bz, this.nd);
                    this.nd = this.ne(this.bz, this.oy, "OpenColumn");
                }
                break;
            case "OpenColumn":
                if (this.m3 != null && !this.m3.cn() && !this.nh) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case FinancialSeries.$$p[1]:
                if (this.bz != null) {
                    this.o7(this.bz, this.nb);
                    this.nb = this.ne(this.bz, this.op, "HighColumn");
                }
                break;
            case "HighColumn":
                if (this.m3 != null && !this.m3.cn() && !this.nh) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case FinancialSeries.$$p[4]:
                if (this.bz != null) {
                    this.o7(this.bz, this.nc);
                    this.nc = this.ne(this.bz, this.ou, "LowColumn");
                }
                break;
            case "LowColumn":
                if (this.m3 != null && !this.m3.cn() && !this.nh) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case FinancialSeries.$$p[0]:
                if (this.bz != null) {
                    this.o7(this.bz, this.na);
                    this.na = this.ne(this.bz, this.om, "CloseColumn");
                }
                break;
            case "CloseColumn":
                if (this.m3 != null && !this.m3.cn() && !this.nh) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                this.pc();
                break;
            case FinancialSeries.$$p[8]:
                if (this.bz != null) {
                    this.o7(this.bz, this.nf);
                    this.nf = this.ne(this.bz, this.o2, "VolumeColumn");
                }
                break;
            case "VolumeColumn":
                if (this.m3 != null && !this.m3.cn() && !this.nh) {
                    this.my.bu.e(this.eu);
                    this.jl(false);
                }
                break;
            case FinancialSeries.$$p[9]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.my.bu.e(this.eu);
                this.jl(false);
                this.it();
                this.m2 = typeCast(ITimeRangeSelectorAxis_$type, this.mi);
                break;
            case FinancialSeries.$$p[10]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.my.bu.e(this.eu);
                if (this.m3 != null) {
                    this.m3.cn();
                }
                {
                    this.jl(false);
                }
                this.it();
                break;
            case "TransitionProgress":
                this.mn.c(this.ez, this.ml, this.mk);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.mk.v();
                    this.pb(this.mk, this.my);
                    if (this.dm) {
                        this.dm = false;
                        this.h4();
                        this.bt.r = truncate(this.eq());
                        this.bt.b = this.bu;
                    }
                }
                else {
                    this.pb(this.mn, this.my);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case FinancialSeries.$$p[5]:
                this.jl(false);
                break;
            case "IsCustomCategoryStyleAllowed":
                this.ni = this.nl();
                this.jl(false);
                break;
            case "CategoryMode":
                if (this.mi != null) {
                    this.mi.kv(true);
                }
                break;
        }
    }
    nk(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    nj(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    }
    mb(a, b, c) {
        if (b < a || a < 0 || a > this.bz.count || b < 0 || b > this.bz.count || c == null) {
            return null;
        }
        let d = new Array((b - a) + 1);
        let e = c.cf;
        let f = null;
        if (e) {
            f = c.i$b;
        }
        for (let g = a; g <= b; g++) {
            let h = g;
            if (e) {
                h = f._inner[h];
            }
            d[g - a] = this.bz.item(g);
        }
        return d;
    }
    of(a) {
        return a.bu.b;
    }
    oh(a) {
        return a.bu.c;
    }
    ma(a, b) {
        return this.mb(a, b, this.m3);
    }
    get_nm() {
        return false;
    }
    get nm() {
        return this.get_nm();
    }
    get_cv() {
        return true;
    }
    at(a, b) {
        if (this.nm) {
            let c = this.m0(a, b, this.m1);
            this.m1 = c;
            return c;
        }
        else {
            let d = this.mz(a, b, this.m1);
            this.m1 = d;
            return d;
        }
    }
    oj(a) {
        let b = this.mk;
        if (this.ca()) {
            b = this.mn;
        }
        let c = this.bi.br;
        let d = this.bi.bs;
        let e = this.mi;
        let f = 0;
        if (e.ch) {
            let g = (a.y - d.top) / d.height;
            f = g * c.height + c.top;
        }
        else {
            let h = (a.x - d.left) / d.width;
            f = h * c.width + c.left;
        }
        let i = b.f.count;
        let j = 0;
        for (j = 0; j < i; j++) {
            let k = b.f._inner[j];
            let l = null;
            if (j < i - 1) {
                l = b.f._inner[j + 1];
            }
            if (k[0] <= f && l == null || l[0] >= f) {
                if (l != null) {
                    if (Math.abs(k[0] - f) < Math.abs(l[0] - f)) {
                        return j;
                    }
                    else {
                        return j + 1;
                    }
                }
                else {
                    return j;
                }
            }
        }
        return j;
    }
    m0(a, b, c) {
        let d = this.bz.count;
        let e = this.my.bu.c;
        let f = this.my.bu.d;
        let g = this.my.bu.b;
        let h = this.mi;
        let i = -1;
        let j = -1;
        if (h.cf) {
            let k = this.mk;
            if (this.ca()) {
                k = this.mn;
            }
            let l = this.oj(b);
            i = l;
            j = l;
        }
        else {
            let m = this.e8(b);
            i = truncate(Math.floor((intDivide(m, g)))) * g;
            j = i + (g - 1);
        }
        if (c != null && c.f == i && c.e == j) {
            return c;
        }
        let n = new HighlightingInfo();
        n.b = this;
        n.f = i;
        n.e = j;
        return n;
    }
    mz(a, b, c) {
        let d = new HighlightingInfo();
        d.b = this;
        d.f = 0;
        d.e = this.bz.count - 1;
        if (c != null && c.f == d.f && c.e == d.e) {
            return c;
        }
        return d;
    }
    nl() {
        return this.no;
    }
    eb(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = -1;
        if (!b.isEmpty && !c.isEmpty && this.mi != null) {
            let e = this.getEffectiveViewport1(this.bi);
            let f = new ScalerParams(0, b, c, this.mi.ca, e);
            let g = this.l0(this.bi);
            let h = this.mi.d1(g.left, f);
            let i = this.mi.d1(g.right, f);
            let j = (a.x - b.left) / b.width;
            let k = h + (j * (i - h));
            if (this.mi.categoryMode != 0) {
                k -= 0.5;
            }
            d = k;
        }
        return d;
    }
    e8(a) {
        return truncate(Math.round(this.eb(a)));
    }
    get_c1() {
        return typeCast(ISortingAxis_$type, this.mi) !== null;
    }
    ap() {
        return this.mi;
    }
    fa(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        let e = new Rect(0, 0, 0, 1, 1);
        let f = new ScalerParams(0, b, c, this.mi.ca, d);
        let g = typeCast(ISortingAxis_$type, this.mi);
        let h = this.l0(this.bi);
        let i = h.left;
        let j = h.right;
        let k = this.lq(a).x;
        let l = this.mi.d1(k, f);
        let m = this.mi.d1(i, f);
        let n = this.mi.d1(j, f);
        l = Math.max(m, Math.min(n, l));
        let o = g.i$f(l);
        return o;
    }
    fp(a) {
        let b = 0;
        if (typeCast(ISortingAxis_$type, this.mi) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    n9(a, b, c) {
        if (this.mi == null) {
            return 0;
        }
        return this.mi.j0(a, b, c, this.fh);
    }
    dc() {
        return this.np;
    }
    mr() {
        return 11;
    }
    bo() {
        return 3;
    }
    pb(a, b) {
        this.lz = a.aa;
        b.ar();
    }
    o9(a, b) {
        a.u();
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        let e = c;
        if (this.bz == null || this.bz.count == 0 || !c.l() || b.isEmpty || a.isEmpty || this.mi == null || this.m3 == null || e.bu.b < 1 || this.mi.bh == null || this.m3.bh == null || this.m3.kc == this.m3.kb || this.mi.itemsSource == null || this.mi.j7 < 1) {
            e.bu.b = 0;
            d = false;
        }
        return d;
    }
    getViewInfo(a, b) {
        b = this.bi.bs;
        a = this.bi.br;
        return {
            p0: a,
            p1: b
        };
    }
    od(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(this.bi);
        if (!c.isEmpty && !d.isEmpty && this.m3 != null) {
            let f = new ScalerParams(0, c, d, this.m3.ca, e);
            f.b = this.eh();
            b = this.m3.dy(this.m3.km, f);
        }
        return b;
    }
    h4() {
        super.h4();
        this.ml.v();
        this.mk.v();
        this.mn.v();
    }
    jm(a) {
        super.jm(a);
        this.my.bu.e(this.eu);
        if (this.cc(this.bi)) {
            return;
        }
        if (this.de) {
            if (this.ca()) {
                this.pb(this.mn, this.my);
            }
            else {
                this.pb(this.mk, this.my);
            }
            return;
        }
        if (this.da(a)) {
            let b = this.ml;
            if (this.ca()) {
                if (this.bt.g) {
                    this.bt.t();
                }
                this.ml = this.mn;
                this.mn = b;
            }
            else {
                this.ml = this.mk;
                this.mk = b;
            }
            this.o9(this.mk, this.my);
            if (this.dp) {
                this.bt.w();
                this.bt.r = truncate(this.er());
                this.bt.b = this.bv != null ? this.bv : this.bu;
                this.mt.p(this.ml, this.mk, this.isVertical, this.mi, this.m3, this.ms, this.mr(), this.bp, this.bo(), () => this.od(this.my), this.my.br);
            }
            this.h0();
            this.jt();
            if (this.dp) {
                this.dn = false;
                this.dm = true;
            }
        }
        else {
            this.o9(this.mk, this.my);
            this.pb(this.mk, this.my);
        }
    }
    nr(a) {
        for (let b of fromEnum(a)) {
            switch (b) {
                case "HighColumn":
                    if (this.nb == null) {
                        return false;
                    }
                    break;
                case "LowColumn":
                    if (this.nc == null) {
                        return false;
                    }
                    break;
                case "OpenColumn":
                    if (this.nd == null) {
                        return false;
                    }
                    break;
                case "CloseColumn":
                    if (this.na == null) {
                        return false;
                    }
                    break;
                case "VolumeColumn":
                    if (this.nf == null) {
                        return false;
                    }
                    break;
            }
        }
        return true;
    }
    get ns() {
        return this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null;
    }
    nn() {
        return this.typical != null;
    }
    o6(a) {
        this.typical(this, a);
    }
    get n0() {
        return this.nx();
    }
    *_nx() {
        let a = false;
        if (this.nn()) {
            let b = this.mu(0, this.bz.count);
            this.o6(new FinancialEventArgs(0, this.bz.count, b, this.mv(b), this));
            if (b.typicalColumn != null) {
                a = true;
                for (let c of fromEnum(b.typicalColumn)) {
                    yield c;
                }
            }
        }
        if (!a) {
            if (this.ns && this.mi.i$b != null) {
                let d = this.bz.count;
                let e = this.mi.i$b;
                for (let f = 0; f < d; ++f) {
                    yield (this.nb.item(e.item(f)) + this.nc.item(e.item(f)) + this.na.item(e.item(f))) / 3;
                }
            }
            else {
                let g = this.bz.count;
                for (let h = 0; h < g; ++h) {
                    yield (this.nb.item(h) + this.nc.item(h) + this.na.item(h)) / 3;
                }
            }
        }
    }
    nx() {
        return toEnum(() => this._nx());
    }
    get nz() {
        return this.nw();
    }
    *_nw() {
        if (this.ns && this.mi.i$b != null) {
            let a = this.nb.count;
            let b = this.mi.i$b;
            if (a > 0) {
                yield this.oe(this.nb.item(b.item(0)) - this.nc.item(b.item(0)));
            }
            for (let c = 1; c < a; ++c) {
                yield Math.max(this.oe(this.nb.item(b.item(c)) - this.nc.item(b.item(c))), Math.max(this.oe(Math.abs(this.nb.item(b.item(c)) - this.na.item(b.item(c - 1)))), this.oe(Math.abs(this.nc.item(b.item(c)) - this.na.item(b.item(c - 1))))));
            }
        }
        else {
            let d = this.nb.count;
            if (d > 0) {
                yield this.oe(this.nb.item(0) - this.nc.item(0));
            }
            for (let e = 1; e < d; ++e) {
                yield Math.max(this.oe(this.nb.item(e) - this.nc.item(e)), Math.max(this.oe(Math.abs(this.nb.item(e) - this.na.item(e - 1))), this.oe(Math.abs(this.nc.item(e) - this.na.item(e - 1)))));
            }
        }
    }
    nw() {
        return toEnum(() => this._nw());
    }
    get ny() {
        return this.nv();
    }
    *_nv() {
        if (this.ns && this.mi.i$b != null) {
            let a = this.nc.count;
            let b = this.mi.i$b;
            if (a > 0) {
                yield this.oe(this.nc.item(b.item(0)));
            }
            for (let c = 1; c < a; c++) {
                yield Math.min(this.oe(this.nc.item(b.item(c))), this.oe(this.na.item(b.item(c - 1))));
            }
        }
        else {
            let d = this.nc.count;
            if (d > 0) {
                yield this.oe(this.nc.item(0));
            }
            for (let e = 1; e < d; e++) {
                yield Math.min(this.oe(this.nc.item(e)), this.oe(this.na.item(e - 1)));
            }
        }
    }
    nv() {
        return toEnum(() => this._nv());
    }
    n2(a) {
        if (a == null) {
            return null;
        }
        if (this.ns && this.mi.i$b != null) {
            return new SafeSortedReadOnlyDoubleCollection(0, a, this.mi.i$b);
        }
        return new SafeReadOnlyDoubleCollection(0, a);
    }
    n1() {
        let a = new List$1(String_$type, 0);
        a.add("HighColumn");
        a.add("LowColumn");
        a.add("CloseColumn");
        if (this.typicalBasedOn != null && this.bz != null && !this.ng) {
            this.ng = true;
            let b = this.mu(0, this.bz.count);
            this.ng = false;
            let c = new FinancialEventArgs(0, this.bz.count, b, this.mv(b), this);
            this.typicalBasedOn(this, c);
            if (c.basedOn != null && c.basedOn.count > 0) {
                return c.basedOn;
            }
        }
        return a;
    }
    getOpenColumnAsArray() {
        if (this.nd == null) {
            return null;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            if (this.n6 != null) {
                return this.n6.asArray();
            }
            let a = new List$1(Number_$type, 2, this.nd.count);
            let b = this.mi.i$b;
            let c = this.nd.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.n6 = a;
            return this.n6.asArray();
        }
        else {
            return this.nd.asArray();
        }
    }
    getHighColumnAsArray() {
        if (this.nb == null) {
            return null;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            if (this.n4 != null) {
                return this.n4.asArray();
            }
            let a = new List$1(Number_$type, 2, this.nb.count);
            let b = this.mi.i$b;
            let c = this.nb.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.n4 = a;
            return this.n4.asArray();
        }
        else {
            return this.nb.asArray();
        }
    }
    getLowColumnAsArray() {
        if (this.nc == null) {
            return null;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            if (this.n5 != null) {
                return this.n5.asArray();
            }
            let a = new List$1(Number_$type, 2, this.nc.count);
            let b = this.mi.i$b;
            let c = this.nc.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.n5 = a;
            return this.n5.asArray();
        }
        else {
            return this.nc.asArray();
        }
    }
    getCloseColumnAsArray() {
        if (this.na == null) {
            return null;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            if (this.n3 != null) {
                return this.n3.asArray();
            }
            let a = new List$1(Number_$type, 2, this.na.count);
            let b = this.mi.i$b;
            let c = this.na.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.n3 = a;
            return this.n3.asArray();
        }
        else {
            return this.na.asArray();
        }
    }
    getVolumeColumnAsArray() {
        if (this.nf == null) {
            return null;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            if (this.n7 != null) {
                return this.n7.asArray();
            }
            let a = new List$1(Number_$type, 2, this.nf.count);
            let b = this.mi.i$b;
            let c = this.nf.asArray();
            for (let d = 0; d < b.count; d++) {
                a.add(c[b._inner[d]]);
            }
            this.n7 = a;
            return this.n7.asArray();
        }
        else {
            return this.nf.asArray();
        }
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.mi == null || !(typeCast(ISortingAxis_$type, this.mi) !== null)) {
            return;
        }
        let e = this.mi.i$b;
        switch (a) {
            case 1:
                for (let f = b; f < c; f++) {
                    let g = e._inner[f];
                    if (this.n6 != null) {
                        this.n6.insert(f, this.nd.item(g));
                    }
                    if (this.n4 != null) {
                        this.n4.insert(f, this.nb.item(g));
                    }
                    if (this.n5 != null) {
                        this.n5.insert(f, this.nc.item(g));
                    }
                    if (this.n3 != null) {
                        this.n3.insert(f, this.na.item(g));
                    }
                    if (this.n7 != null) {
                        this.n7.insert(f, this.nf.item(g));
                    }
                }
                break;
            case 0:
                if (this.n6 != null) {
                    this.n6.v(b, c);
                }
                if (this.n4 != null) {
                    this.n4.v(b, c);
                }
                if (this.n5 != null) {
                    this.n5.v(b, c);
                }
                if (this.n3 != null) {
                    this.n3.v(b, c);
                }
                if (this.n7 != null) {
                    this.n7.v(b, c);
                }
                break;
            case 4:
                if (this.n6 != null) {
                    this.n6 = new List$1(Number_$type, 0);
                }
                if (this.n4 != null) {
                    this.n4 = new List$1(Number_$type, 0);
                }
                if (this.n5 != null) {
                    this.n5 = new List$1(Number_$type, 0);
                }
                if (this.n3 != null) {
                    this.n3 = new List$1(Number_$type, 0);
                }
                if (this.n7 != null) {
                    this.n7 = new List$1(Number_$type, 0);
                }
                break;
            case 3:
            case 2:
                for (let h = b; h < c; h++) {
                    let i = e._inner[h];
                    if (this.n6 != null) {
                        this.n6._inner[h] = this.nd.item(i);
                    }
                    if (this.n4 != null) {
                        this.n4._inner[h] = this.nb.item(i);
                    }
                    if (this.n5 != null) {
                        this.n5._inner[h] = this.nc.item(i);
                    }
                    if (this.n3 != null) {
                        this.n3._inner[h] = this.na.item(i);
                    }
                    if (this.n7 != null) {
                        this.n7._inner[h] = this.nf.item(i);
                    }
                }
                break;
        }
        this.pc();
        this.jy();
    }
    mu(a, b) {
        let c = this.n2(this.nd);
        let d = this.n2(this.na);
        let e = this.n2(this.nb);
        let f = this.n2(this.nc);
        let g = this.n2(this.nf);
        let h = ((() => {
            let $ret = new FinancialCalculationDataSource();
            $ret.typicalColumn = new CalculatedColumn(1, new SafeEnumerable(this.n0), this.n1());
            $ret.trueRange = new CalculatedColumn(1, new SafeEnumerable(this.nz), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("HighColumn");
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.trueLow = new CalculatedColumn(1, new SafeEnumerable(this.ny), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("LowColumn");
                $ret.add("CloseColumn");
                return $ret;
            })()));
            $ret.openColumn = c;
            $ret.closeColumn = d;
            $ret.highColumn = e;
            $ret.lowColumn = f;
            $ret.volumeColumn = g;
            $ret.calculateFrom = a;
            $ret.calculateCount = b;
            $ret.minimumValue = NaN;
            $ret.maximumValue = NaN;
            $ret.count = this.bz != null ? this.bz.count : 0;
            return $ret;
        })());
        return h;
    }
    oe(a) {
        if (isInfinity(a) || isNaN_(a)) {
            return 0;
        }
        return a;
    }
    mv(a) {
        return ((() => {
            let $ret = new FinancialCalculationSupportingCalculations();
            $ret.a = new ColumnSupportingCalculation(1, TrendCalculators.b, new List$1(String_$type, 0));
            $ret.c = new ColumnSupportingCalculation(1, TrendCalculators.e, new List$1(String_$type, 0));
            $ret.d = new ColumnSupportingCalculation(1, TrendCalculators.f, new List$1(String_$type, 0));
            $ret.b = new ColumnSupportingCalculation(1, TrendCalculators.d, new List$1(String_$type, 0));
            $ret.h = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.shortPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.f = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.volumeColumn, b.longPeriod), ((() => {
                let $ret = new List$1(String_$type, 0);
                $ret.add("VolumeColumn");
                return $ret;
            })()));
            $ret.g = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.shortPeriod), a.typicalColumn.basedOn);
            $ret.e = new DataSourceSupportingCalculation(1, (b) => TrendCalculators.b(b.typicalColumn, b.longPeriod), a.typicalColumn.basedOn);
            $ret.k = Series.d1;
            $ret.j = Series.d0;
            $ret.i = runOn(this, this.oe);
            return $ret;
        })());
    }
    get categoryAxis() {
        return this.mi;
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        let c = typeCast(FinancialSeriesView.$, this.bh);
        this.bi.az(b);
        c.bu.e(this.eu);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.df) {
            this.o9(this.mm, c);
        }
        this.df = false;
        this.pb(this.mm, c);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.bu.e(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.mj == null) {
            this.mj = new CategoryFrame(3);
        }
        this.mj.u();
        this.o9(this.mj, g);
        this.pb(this.mj, g);
    }
    am(a) {
        if (this.mi == a) {
            return this.m3;
        }
        if (this.m3 == a) {
            return this.mi;
        }
        return null;
    }
    preferredCategoryMode(a) {
        let b = typeCast(IDateTimeAxis_$type, this.mi);
        return b != null ? b.preferredCategoryMode(this) : this.mp;
    }
    get mp() {
        return this.mo;
    }
    set mp(a) {
        let b = this.mp;
        if (a != b) {
            this.mo = a;
            this.raisePropertyChanged("CategoryMode", enumGetBox(CategoryMode_$type, b), enumGetBox(CategoryMode_$type, this.mp));
        }
    }
    get_cz() {
        return true;
    }
    jq(a, b) {
        super.jq(a, b);
        this.po = a;
    }
    pc() {
        this.d8 = this.na == null || this.na.count == 0 ? NaN : this.na.item(this.na.count - 1);
    }
    fr(a) {
        if (this.m2 != null && a != null) {
            if (this.m4 == null || this.m4.propertyName != this.m2.dateTimeMemberPath) {
                this.m4 = new FastReflectionHelper(false, this.m2.dateTimeMemberPath);
            }
            let b = this.m4.getPropertyValue(a);
            if (typeCast(Date_$type, b) !== null) {
                return dateToStringFormat(b, this.m2.itemLabelFormat());
            }
        }
        return super.fr(a);
    }
}
FinancialSeries.$t = markType(FinancialSeries, 'FinancialSeries', Series.$, [IHasCategoryAxis_$type, IHasCategoryModePreference_$type]);
FinancialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialSeries, 'raisePropertyChanged', ['CloseMemberPath:om:pd', [2, null], 'HighMemberPath:op:pe', [2, null], 'IsCustomCategoryStyleAllowed:no:pf', [0, false], 'IsTransitionInEnabled:np:pg', [0, false], 'LowMemberPath:ou:ph', [2, null], 'NegativeBrush:po:pi', [Brush.$, null], 'OpenMemberPath:oy:pj', [2, null], 'TransitionInMode:ms:pk', [CategoryTransitionInMode_$type, enumGetBox(CategoryTransitionInMode_$type, 0)], 'VolumeMemberPath:o2:pl', [2, null], 'XAxis:mi:pm', [CategoryAxisBase.$, null], 'YAxis:m3:pn', [NumericYAxis.$, null]]);
/**
 * @hidden
 */
class FinancialCalculationSupportingCalculations extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.c = null;
        this.d = null;
        this.b = null;
        this.h = null;
        this.f = null;
        this.g = null;
        this.e = null;
        this.k = null;
        this.j = null;
        this.i = null;
    }
}
FinancialCalculationSupportingCalculations.$t = markType(FinancialCalculationSupportingCalculations, 'FinancialCalculationSupportingCalculations');
/**
 * @hidden
 */
class DataSourceSupportingCalculation extends SupportingCalculation$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    super(Delegate_$type, 0, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    super(Delegate_$type, 1, c, d);
                }
                break;
        }
    }
}
DataSourceSupportingCalculation.$t = markType(DataSourceSupportingCalculation, 'DataSourceSupportingCalculation', SupportingCalculation$1.$.specialize(Delegate_$type));
/**
 * @hidden
 */
class FinancialCalculationDataSource extends Base {
    constructor() {
        super(...arguments);
        this._openColumn = null;
        this._closeColumn = null;
        this._highColumn = null;
        this._lowColumn = null;
        this._volumeColumn = null;
        this._indicatorColumn = null;
        this._typicalColumn = null;
        this._trueRange = null;
        this._trueLow = null;
        this._period = 0;
        this._shortPeriod = 0;
        this._longPeriod = 0;
        this._count = 0;
        this._calculateFrom = 0;
        this._calculateCount = 0;
        this._multiplier = 0;
        this._minimumValue = 0;
        this._maximumValue = 0;
        this._specifiesRange = false;
        this._series = null;
    }
    get openColumn() {
        return this._openColumn;
    }
    set openColumn(a) {
        this._openColumn = a;
    }
    get closeColumn() {
        return this._closeColumn;
    }
    set closeColumn(a) {
        this._closeColumn = a;
    }
    get highColumn() {
        return this._highColumn;
    }
    set highColumn(a) {
        this._highColumn = a;
    }
    get lowColumn() {
        return this._lowColumn;
    }
    set lowColumn(a) {
        this._lowColumn = a;
    }
    get volumeColumn() {
        return this._volumeColumn;
    }
    set volumeColumn(a) {
        this._volumeColumn = a;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    get typicalColumn() {
        return this._typicalColumn;
    }
    set typicalColumn(a) {
        this._typicalColumn = a;
    }
    get trueRange() {
        return this._trueRange;
    }
    set trueRange(a) {
        this._trueRange = a;
    }
    get trueLow() {
        return this._trueLow;
    }
    set trueLow(a) {
        this._trueLow = a;
    }
    get period() {
        return this._period;
    }
    set period(a) {
        this._period = a;
    }
    get shortPeriod() {
        return this._shortPeriod;
    }
    set shortPeriod(a) {
        this._shortPeriod = a;
    }
    get longPeriod() {
        return this._longPeriod;
    }
    set longPeriod(a) {
        this._longPeriod = a;
    }
    get count() {
        return this._count;
    }
    set count(a) {
        this._count = a;
    }
    get calculateFrom() {
        return this._calculateFrom;
    }
    set calculateFrom(a) {
        this._calculateFrom = a;
    }
    get calculateCount() {
        return this._calculateCount;
    }
    set calculateCount(a) {
        this._calculateCount = a;
    }
    get multiplier() {
        return this._multiplier;
    }
    set multiplier(a) {
        this._multiplier = a;
    }
    get minimumValue() {
        return this._minimumValue;
    }
    set minimumValue(a) {
        this._minimumValue = a;
    }
    get maximumValue() {
        return this._maximumValue;
    }
    set maximumValue(a) {
        this._maximumValue = a;
    }
    get specifiesRange() {
        return this._specifiesRange;
    }
    set specifiesRange(a) {
        this._specifiesRange = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
}
FinancialCalculationDataSource.$t = markType(FinancialCalculationDataSource, 'FinancialCalculationDataSource');
/**
 * @hidden
 */
class FinancialSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bw = null;
        this.bu = null;
        this.by = 0;
        this.by = -1;
        this.bw = a;
        this.bu = this.bv();
    }
    bx(a) {
        if (this.by != a.t) {
            return true;
        }
        return false;
    }
    bz(a) {
        this.by = a.t;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 6;
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.bw.mi.b7) {
            a += "<span>${itemLabel}</span><br/>";
        }
        else if (this.bw.mi.e9 != null) {
            a += "<span>${item." + this.bw.mi.e9 + "}</span><br/>";
        }
        a += "<span class='ui-priority-primary'";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        let c = new SRProvider(this.t);
        let d = c.b1("financialSeries_Open");
        let e = c.b1("financialSeries_High");
        let f = c.b1("financialSeries_Low");
        let g = c.b1("financialSeries_Close");
        d = stringIsNullOrEmpty(d) ? "Open" : d;
        e = stringIsNullOrEmpty(e) ? "High" : e;
        f = stringIsNullOrEmpty(f) ? "Low" : f;
        g = stringIsNullOrEmpty(g) ? "Close" : g;
        a += ">" + this.bw.fx + "</span><table><tr><td>" + d + ":</td><td>" + "${item." + this.bw.oy + "}</td></tr><tr><td>" + e + ":</td><td>" + "${item." + this.bw.op + "}</td></tr><tr><td>" + f + ":</td><td>" + "${item." + this.bw.ou + "}</td></tr><tr><td>" + g + ":</td><td>" + "${item." + this.bw.om + "}</td></tr>";
        if (!stringIsNullOrEmpty(this.bw.o2)) {
            let h = c.b1("financialSeries_Volume");
            h = stringIsNullOrEmpty(h) ? "Volume" : h;
            a += "<tr><td>" + h + ":</td><td>" + "${item." + this.bw.o2 + "}</td></tr>";
        }
        a += "</table></div>";
        return a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 2;
        this.e.ex = 2;
    }
}
FinancialSeriesView.$t = markType(FinancialSeriesView, 'FinancialSeriesView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available display types for financial indicators.
 */
var IndicatorDisplayType;
(function (IndicatorDisplayType) {
    /**
     * Display indicator as a line chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Line"] = 0] = "Line";
    /**
     * Display indicator as an area chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Area"] = 1] = "Area";
    /**
     * Display indicator as a column chart.
     */
    IndicatorDisplayType[IndicatorDisplayType["Column"] = 2] = "Column";
})(IndicatorDisplayType || (IndicatorDisplayType = {}));
/**
 * @hidden
 */
let IndicatorDisplayType_$type = markEnum('IndicatorDisplayType', 'Line,0|Area,1|Column,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DelegateClipper extends Base {
    constructor(a, b, c, d) {
        super();
        this.b = null;
        this.c = null;
        this.d = null;
        let e = new List$1(Point_$type, 0);
        for (let f of fromEnum(DelegateClipper.a(0, c))) {
            e.add({ $type: Point_$type, x: a(f), y: b(f) });
        }
        this.b = new List$1(Point_$type, 0);
        this.c = (g) => this.b.count > g ? this.b._inner[g].x : NaN;
        this.d = (g) => this.b.count > g ? this.b._inner[g].y : NaN;
        d.i = this.b;
        for (let g of fromEnum(e)) {
            d.j(g);
        }
        d.i = null;
    }
    get e() {
        return this.b.count;
    }
    static *_a(a, b) {
        for (let c = a; c < a + b; c++) {
            yield c;
        }
    }
    static a(a, b) {
        return toEnum(() => DelegateClipper._a(a, b));
    }
}
DelegateClipper.$t = markType(DelegateClipper, 'DelegateClipper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndicatorRenderer extends Base {
    static h(a, b, c, d) {
        let e = new PathFigure();
        let f = IndicatorRenderer.b(a, b, c, d);
        for (let g of fromEnum(f)) {
            e._segments.add(((() => {
                let $ret = new LineSegment(1);
                $ret.c = g;
                return $ret;
            })()));
        }
        e._startPoint = e._segments._inner[0].c;
        return e;
    }
    static g(a, b, c, d, e, f, g, h, i, j, k) {
        let l = g.ak.c;
        let m = h.ak.c;
        if (a > 1) {
            let n = new DelegateClipper(b, c, a, k);
            b = n.c;
            c = n.d;
            a = n.e;
        }
        if (i == 1) {
            let o = new List$1(Number_$type, 0);
            let p = l;
            let q = 0;
            o.add(0);
            for (let r = 0, s = 1; s < a; r = s++) {
                let t = q;
                let u = c(s) - c(r);
                if (d && !isNaN_(u)) {
                    t = Math.sign(u);
                }
                if (t != 0 && t != q) {
                    p.add(IndicatorRenderer.h(o, b, c, j));
                    q = t;
                    p = q == 1 ? m : l;
                    o.clear();
                    o.add(r);
                }
                o.add(s);
            }
            p.add(IndicatorRenderer.h(o, b, c, j));
        }
        else {
            let v = new List$1(Number_$type, 0);
            let w = l;
            let x = 0;
            v.add(0);
            for (let y = 0, z = 1; z < a; y = z++) {
                let aa = x;
                let ab = c(z) - c(y);
                if (d && !isNaN_(ab)) {
                    aa = Math.sign(ab);
                }
                if (aa != 0 && aa != x) {
                    if (v.count > 0) {
                        w.add(IndicatorRenderer.h(v, b, c, j));
                    }
                    x = aa;
                    w = x == 1 ? m : l;
                    v.clear();
                    v.add(y);
                }
                v.add(z);
            }
            if (v.count > 0) {
                w.add(IndicatorRenderer.h(v, b, c, j));
            }
        }
    }
    static e(a, b, c, d, e, f, g, h, i, j, k, l, m, n) {
        let o = new List$1(List$1.$.specialize(Point_$type), 0);
        let p = new List$1(List$1.$.specialize(Point_$type), 0);
        let q = new List$1(List$1.$.specialize(Point_$type), 0);
        let r = new List$1(List$1.$.specialize(Point_$type), 0);
        if (a <= 1) {
            n = null;
        }
        k = Math.max(f.top, Math.min(f.bottom, k));
        if (l == 1) {
            let s = new List$1(Number_$type, 0);
            let t = o;
            let u = p;
            let v = 0;
            s.add(0);
            for (let w = 0, x = 1; x < a; w = x++) {
                let y = v;
                let z = c(x) - c(w);
                if (d && !isNaN_(z)) {
                    y = Math.sign(z);
                }
                if (y != 0 && y != v) {
                    if (s.count > 0) {
                        let aa = new List$1(Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
                        let ab = new List$1(Point_$type, 1, aa);
                        ab.add({ $type: Point_$type, x: aa._inner[aa.count - 1].x, y: k });
                        ab.add({ $type: Point_$type, x: aa._inner[0].x, y: k });
                        t.add(aa);
                        u.add(ab);
                    }
                    v = y;
                    t = v == 1 ? q : o;
                    u = v == 1 ? r : p;
                    s.clear();
                    s.add(w);
                }
                s.add(x);
            }
            let ac = new List$1(Point_$type, 1, IndicatorRenderer.b(s, b, c, m));
            let ad = new List$1(Point_$type, 1, ac);
            ad.add({ $type: Point_$type, x: ac._inner[ac.count - 1].x, y: k });
            ad.add({ $type: Point_$type, x: ac._inner[0].x, y: k });
            t.add(ac);
            u.add(ad);
        }
        else {
            let ae = new List$1(Number_$type, 0);
            let af = o;
            let ag = p;
            let ah = 0;
            ae.add(0);
            for (let ai = 0, aj = 1; aj < a; ai = aj++) {
                let ak = ah;
                let al = c(aj) - c(ai);
                if (d && !isNaN_(al)) {
                    ak = Math.sign(al);
                }
                if (ak != 0 && ak != ah) {
                    if (ae.count > 0) {
                        let am = new List$1(Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
                        let an = new List$1(Point_$type, 1, am);
                        an.add({ $type: Point_$type, x: am._inner[am.count - 1].x, y: k });
                        an.add({ $type: Point_$type, x: am._inner[0].x, y: k });
                        af.add(am);
                        ag.add(an);
                    }
                    ah = ak;
                    af = ah == 1 ? q : o;
                    ag = ah == 1 ? r : p;
                    ae.clear();
                    ae.add(ai);
                }
                ae.add(aj);
            }
            let ao = new List$1(Point_$type, 1, IndicatorRenderer.b(ae, b, c, m));
            let ap = new List$1(Point_$type, 1, ao);
            ap.add({ $type: Point_$type, x: ao._inner[ao.count - 1].x, y: k });
            ap.add({ $type: Point_$type, x: ao._inner[0].x, y: k });
            af.add(ao);
            ag.add(ap);
        }
        if (n != null) {
            o = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), o, (aq) => IndicatorRenderer.c(n, aq, false)));
            p = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), p, (aq) => IndicatorRenderer.c(n, aq, true)));
            q = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), q, (aq) => IndicatorRenderer.c(n, aq, false)));
            r = new List$1(List$1.$.specialize(Point_$type), 1, IndicatorRenderer.a(List$1.$.specialize(Point_$type), List$1.$.specialize(Point_$type), r, (aq) => IndicatorRenderer.c(n, aq, true)));
        }
        let aq = g.ak.c;
        let ar = h.ak.c;
        let as = i.ak.c;
        let at = j.ak.c;
        IndicatorRenderer.d(aq, o);
        IndicatorRenderer.d(ar, p);
        IndicatorRenderer.d(as, q);
        IndicatorRenderer.d(at, r);
    }
    static f(a, b, c, d, e, f, g, h, i) {
        let j = typeCast(GeometryGroup.$, h.ak);
        let k = typeCast(GeometryGroup.$, i.ak);
        let l = c;
        let m = b;
        let n = (o) => Math.max(e.left, Math.min(e.right, o));
        let o = (p) => Math.max(e.top, Math.min(e.bottom, p));
        b = (p) => n(m(p));
        c = (p) => o(l(p));
        f = o(f);
        for (let p = 0; p < a; ++p) {
            let q = g.item(p);
            q.d = { $type: Point_$type, x: b(p), y: f };
            q.c = { $type: Point_$type, x: b(p), y: c(p) };
            let r = false;
            if (p > 0) {
                if (c(p) <= c(p - 1)) {
                    r = true;
                }
            }
            else {
                if (a > 1) {
                    if (c(p + 1) <= c(p)) {
                        r = true;
                    }
                }
            }
            if (r) {
                j.d.add(q);
            }
            else {
                k.d.add(q);
            }
        }
        g.count = a;
    }
    static *_b(a, b, c, d) {
        let e = Flattener.a(new List$1(Number_$type, 0), a, b, c, 0, a.count - 1, d);
        for (let f = 0; f < e.count; f++) {
            let g = e.item(f);
            yield { $type: Point_$type, x: b(g), y: c(g) };
        }
    }
    static b(a, b, c, d) {
        return toEnum(() => IndicatorRenderer._b(a, b, c, d));
    }
    static d(a, b) {
        for (let c of fromEnum(b)) {
            if (c.count == 0) {
                continue;
            }
            let d = ((() => {
                let $ret = new PathFigure();
                $ret.startPoint = c._inner[0];
                return $ret;
            })());
            for (let e of fromEnum(c)) {
                d._segments.add(((() => {
                    let $ret = new LineSegment(1);
                    $ret.c = e;
                    return $ret;
                })()));
            }
            a.add(d);
        }
    }
    static c(a, b, c) {
        let d = a.f;
        a.f = c;
        let e = new List$1(Point_$type, 0);
        a.i = e;
        a.k(b, false);
        a.i = null;
        a.f = d;
        return e;
    }
    static *_a($tSource, $tResult, a, b) {
        for (let c of fromEnum(a)) {
            yield b(c);
        }
    }
    static a($tSource, $tResult, a, b) {
        return toEnum(() => IndicatorRenderer._a($tSource, $tResult, a, b));
    }
}
IndicatorRenderer.$t = markType(IndicatorRenderer, 'IndicatorRenderer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialIndicator extends FinancialSeries {
    constructor() {
        super();
        this._indicatorColumn = null;
        this.ps = null;
        this.ml = new CategoryFrame(3);
        this.mn = new CategoryFrame(3);
        this.mk = new CategoryFrame(3);
        this.indicatorColumn = new List$1(Number_$type, 0);
        this.ps = new AxisRange(-100, 100);
    }
    bf() {
        return new FinancialIndicatorView(this);
    }
    i2(a) {
        super.i2(a);
        this.pt = a;
    }
    p5(a) {
        if (this.m3 != null && !this.m3.cn()) {
            this.jl(true);
        }
    }
    px(a, b, c) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        let d = this.m3;
        let e = 0;
        if (d != null) {
            e = d.ed(d.km);
        }
        if ((a.y >= e && a.y <= b.y) || (a.y <= e && a.y >= b.y)) {
            return true;
        }
        return false;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    l4(a) {
        if (this.mi == null || this.m3 == null) {
            return Rect.empty;
        }
        let b = this.lq(a);
        let c = this.bi.bs;
        let d = this.bi.br;
        let e = this.getEffectiveViewport1(this.bi);
        let f = new ScalerParams(0, c, d, this.m3.ca, e);
        f.b = this.eh();
        let g = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        let h = g[0];
        let i = g[1];
        let j = Math.abs(b.x - h[0]);
        let k = Math.abs(b.x - i[0]);
        let l = this.m3.dy(this.m3.km, f);
        let m = 1;
        if (j < k) {
            let n = h[0] - 0.5 * m;
            let o = h[1];
            let p = l;
            return new Rect(0, n, Math.min(o, p), m, Math.max(o, p) - Math.min(o, p));
        }
        else {
            let q = i[0] - 0.5 * m;
            let r = i[1];
            let s = l;
            return new Rect(0, q, Math.min(r, s), m, Math.max(r, s) - Math.min(r, s));
        }
    }
    dh(a, b) {
        let c = this.lv(this.ly(a), true, false);
        if (this.pu == 1) {
            if (this.px(a, c, b)) {
                return true;
            }
        }
        if (this.pu == 1 || this.pu == 0) {
            if (this.dg(a, b)) {
                return true;
            }
        }
        if (this.pu == 2) {
            if (this.dk(a, b)) {
                return true;
            }
        }
        return false;
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            this.mi.i$i();
        }
        if (this.pt.b4) {
            this.pt.b2.g$e(a, b, c, d);
        }
        if (d != null && this.nu.containsKey(d)) {
            let e = this.nu.tryGetValue(d, d);
            d = e.p1;
        }
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            a = 4;
            b = 0;
            c = this.bz.count;
        }
        switch (a) {
            case 3:
                if (this.pw(b, c, d)) {
                    this.p7(b, c, d);
                    this.p5(true);
                }
                break;
            case 2:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 1:
                if (this.pw(b, this.bz.count - b, d)) {
                    let f = new Array(c);
                    for (let g = 0; g < c; g++) {
                        f[g] = 0;
                    }
                    this.indicatorColumn.s(b, f);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 0:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.indicatorColumn.v(b, c);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
            case 4:
                if (this.pw(b, this.bz.count - b, d)) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    let h = new Array(c);
                    for (let i = 0; i < c; i++) {
                        h[i] = 0;
                    }
                    this.indicatorColumn.s(0, h);
                    this.p7(b, this.bz.count - b, d);
                    this.p5(true);
                }
                break;
        }
    }
    get qi() {
        return this.c(FinancialIndicator.p8);
    }
    set qi(a) {
        this.h(FinancialIndicator.p8, a);
    }
    p2() {
        return -1;
    }
    get indicatorColumn() {
        return this._indicatorColumn;
    }
    set indicatorColumn(a) {
        this._indicatorColumn = a;
    }
    i7(a, b, c, d) {
        switch (b) {
            case "XAxis":
                this.pt.ca();
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pt.b2 = CategoryTrendLineManagerFactory.a(this.pt.b2, this.mi, this.j5, this, this.b2);
                }
                break;
        }
        super.i7(a, b, c, d);
        if (this.pt.b4 && this.pt.b2.g$b(a, b, c, d)) {
            this.jl(false);
            let f = typeCast(FinancialIndicatorView.$, this.bh);
            if (f != null && f.b4) {
                f.b2.g$b(a, b, c, d);
            }
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (this.bz != null) {
                    this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                    let g = new Array(this.bz.count);
                    for (let h = 0; h < this.bz.count; h++) {
                        g[h] = 0;
                    }
                    this.indicatorColumn.s(0, g);
                    this.p7(0, this.bz.count, null);
                    if (this.m3 != null && !this.m3.cn()) {
                        this.my.bu.e(this.eu);
                        this.jl(false);
                    }
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case FinancialIndicator.$$p[0]:
                this.h3(true, this.bi);
                this.jl(false);
                this.it();
                break;
            case "OpenColumn":
            case "HighColumn":
            case "LowColumn":
            case "CloseColumn":
            case "VolumeColumn":
                if (this.bz != null) {
                    if (this.indicatorColumn.count != this.bz.count) {
                        this.indicatorColumn = new List$1(Number_$type, 2, this.bz.count);
                        let i = new Array(this.bz.count);
                        for (let j = 0; j < this.bz.count; j++) {
                            i[j] = 0;
                        }
                        this.indicatorColumn.s(0, i);
                    }
                    if (this.pw(0, this.bz.count - 1, b)) {
                        this.p6();
                    }
                }
                break;
            case "XAxis":
                if (this.mi != null && (typeCast(ISortingAxis_$type, this.mi) !== null || typeCast(ISortingAxis_$type, c) !== null)) {
                    this.p6();
                }
                break;
            case "YAxis":
            case FinancialIndicator.$$p[1]:
                this.p6();
                this.it();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    }
    en(a, b, c) {
        if (this.indicatorColumn == null) {
            return super.en(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        f.c = this.bs.oh;
        return this.ep(this.indicatorColumn, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    fe(a, b) {
        if (this.indicatorColumn == null) {
            return super.fe(a, b);
        }
        return this.ff(a, b, this.mi, runOn(this, this.n8), this.indicatorColumn);
    }
    fc(a, b) {
        if (this.indicatorColumn == null) {
            return super.fc(a, b);
        }
        return this.fd(a, b, this.mi, runOn(this, this.n8), this.indicatorColumn);
    }
    get_dv() {
        return true;
    }
    pw(a, b, c) {
        if (c == null) {
            return true;
        }
        if (this.py(a, b).contains(c)) {
            return true;
        }
        return false;
    }
    p7(a, b, c) {
        this.pv(a, b);
    }
    an(a) {
        if (this.bz == null) {
            return null;
        }
        if (a != null && a == this.m3) {
            return this.ps;
        }
        return null;
    }
    c9(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bi.bs;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.l2(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.mi != null) {
                let g = new ScalerParams(0, e, e, this.mi.ca, f);
                let h = this.mi.dy(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.m3 != null && this.indicatorColumn != null && b < this.indicatorColumn.count) {
                let i = new ScalerParams(0, e, e, this.m3.ca, f);
                i.b = this.eh();
                let j = this.m3.dy(this.indicatorColumn._inner[b], i);
                if (j < c.top + 0.1 * c.height) {
                    j = j + 0.4 * c.height;
                }
                if (j > c.bottom - 0.1 * c.height) {
                    j = j - 0.4 * c.height;
                }
                c.y = j - 0.5 * c.height;
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.indicatorColumn == null || this.indicatorColumn.count == 0) {
            d = false;
        }
        return d;
    }
    o9(a, b) {
        super.o9(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.mi;
        let g = this.m3;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = new ScalerParams(0, c, d, g.ca, e);
        i.b = this.eh();
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.mi);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.n9(c, d, e);
        let l = this.p2();
        if (l == -1) {
            l = this.trendLinePeriod;
        }
        let m = typeCast(FinancialIndicatorView.$, b);
        if (m.b4) {
            m.b2.prepareLineCore(a.p, this.trendLineType, this.indicatorColumn, l, (n) => this.mi.dy(n, h), (n) => this.m3.dy(n, i), ((() => {
                let $ret = new TrendResolutionParams();
                $ret.c = b.bu.b;
                $ret.d = b.bu.c;
                $ret.e = b.bu.d;
                $ret.a = j;
                $ret.b = this.eu;
                $ret.f = d;
                $ret.g = c;
                return $ret;
            })()));
        }
        let n = this.mi.d1(2, h) - this.mi.d1(1, h);
        for (let o = b.bu.c; o <= b.bu.d; ++o) {
            let p;
            if (k == null) {
                p = b.bu.getBucket(o);
            }
            else {
                let q = k.i$b._inner[o];
                let r = k.i$d(q);
                let s = this.indicatorColumn._inner[o];
                let t = s;
                let u = r;
                while (o < b.bu.d) {
                    q = k.i$b._inner[o + 1];
                    u = k.i$d(q);
                    if (u - r > n) {
                        break;
                    }
                    o++;
                    let v = this.indicatorColumn._inner[o];
                    s = Math.min(s, v);
                    t = Math.max(t, v);
                }
                let w = NaN;
                if (!isNaN_(r)) {
                    w = this.mi.dy(r, h);
                }
                p = [w, s, t];
            }
            if (!isNaN_(p[0])) {
                if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
                    p[0] = p[0] + j;
                }
                else {
                    p[0] = f.dy(p[0], h) + j;
                }
                p[1] = g.dy(p[1], i);
                if (b.bu.b > 1 || k != null) {
                    p[2] = g.dy(p[2], i);
                }
                else {
                    p[2] = p[1];
                }
                a.f.add(p);
            }
        }
        return;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.b5(a);
        if (c.b4) {
            c.b2.g$d();
        }
    }
    mr() {
        switch (this.pu) {
            case 1: return 1;
            case 2: return 1;
            case 0: return 12;
        }
        return 1;
    }
    pb(a, b) {
        super.pb(a, b);
        let c = typeCast(FinancialIndicatorView.$, b);
        let d = (e) => a.f._inner[e][0];
        let e = (f) => a.f._inner[f][1];
        if (c.b4) {
            c.b2.g$d();
            c.b2.g$g(a.p);
        }
        let f = b.br;
        let g = this.getEffectiveViewport1(b);
        let h = 0;
        let i = this.lb;
        let j = this.po;
        if (b.bx(a)) {
            c.b5(false);
            if (a.f.count > 0) {
                switch (this.pu) {
                    case 0:
                        let k = CategorySeries.ne(a.f, a.f.count - 1, f, b.bs, false);
                        c.b9(a.f.count, d, e, true, k);
                        break;
                    case 1:
                        if (this.m3 != null) {
                            h = this.od(b);
                        }
                        else {
                            h = 0.5 * (f.top + f.bottom);
                        }
                        let l = CategorySeries.ne(a.f, a.f.count - 1, f, b.bs, false);
                        c.b7(a.f.count, d, e, true, h, l);
                        break;
                    case 2:
                        h = this.od(b);
                        c.b8(a.f.count, d, e, true, h);
                        break;
                    default: throw new NotImplementedException(0);
                }
            }
            b.bz(a);
        }
        let m = a.f;
        let n = this.bz.count;
        this.mq.x(this, this.nq(), this.mi, runOn(this, this.ma), this.of(b), this.oh(b));
        let o = false;
        let p = this.mq.c;
        if (p != null) {
            o = true;
        }
        this.mq.al = i;
        this.mq.ah = i;
        if (o) {
            let q = new ScalerParams(0, b.bs, b.br, this.mi.ca, g);
            this.mq.f = false;
            this.o8(m, -1, n, this.mi, q, b.n);
        }
        this.mq.ae(c.cr, true, false, true, false);
        this.mq.ae(c.ct, true, false, true, false);
        this.mq.ae(c.cs, false, true, false, false);
        c.cs._opacity = 0.8 * this.mq.i * this.d6;
        this.mq.ae(c.cq, true, false, false, false);
        this.mq.al = j;
        this.mq.ah = j;
        if (o) {
            let r = new ScalerParams(0, b.bs, b.br, this.mi.ca, g);
            this.mq.f = true;
            this.o8(m, -1, n, this.mi, r, b.n);
        }
        this.mq.ae(c.cn, true, false, true, false);
        this.mq.ae(c.cp, true, false, true, false);
        this.mq.ae(c.co, false, true, false, false);
        c.co._opacity = 0.8 * this.mq.i * this.d6;
        this.mq.ae(c.cm, true, false, false, false);
        c.cb();
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        if (this.pt.b4) {
            this.pt.cc();
        }
    }
    p6() {
        if (this.pt.b4) {
            this.pt.b2.g$i();
        }
        this.pv(0, this.indicatorColumn.count);
        if (this.m3 != null && !this.m3.cn()) {
            this.jl(false);
        }
    }
    ic(a) {
        super.ic(a);
        this.a2.exportTrendlineData(this, a, this.pt.b2.g$j);
    }
}
FinancialIndicator.$t = markType(FinancialIndicator, 'FinancialIndicator', FinancialSeries.$, [ITrendLineSeries_$type]);
FinancialIndicator.p8 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialIndicator.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
FinancialIndicator.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialIndicator, 'raisePropertyChanged', ['DisplayType:pu:p9', [IndicatorDisplayType_$type, enumGetBox(IndicatorDisplayType_$type, 0)], 'IgnoreFirst:p0:qa', [1, 0], 'TrendLineType::qg', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::qf', [1, 1.5], 'TrendLinePeriod::qe', [1, 7], 'TrendLineBrush::qb', [Brush.$, null], 'TrendLineZIndex:p1:qh', [1, 1001], 'TrendLineDashArray:qj:qc', [DoubleCollection.$], 'TrendLineDashCap:qk:qd', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class FinancialIndicatorBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.f.b0.indicatorColumn.count - 1);
        let d = NaN;
        let e = NaN;
        for (let f = b; f <= c; ++f) {
            let g = this.f.b0.indicatorColumn._inner[f];
            if (!isNaN_(d)) {
                if (!isNaN_(g)) {
                    d = Math.min(d, g);
                    e = Math.max(e, g);
                }
            }
            else {
                d = g;
                e = g;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [NaN, NaN, NaN];
    }
}
FinancialIndicatorBucketCalculator.$t = markType(FinancialIndicatorBucketCalculator, 'FinancialIndicatorBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
class FinancialIndicatorView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b0 = null;
        this.b3 = null;
        this.cr = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cn = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cs = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.co = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.ct = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cp = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cq = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.cm = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.b1 = null;
        this.cj = new Path();
        this.cl = new Path();
        this.ck = new Path();
        this.ci = new Path();
        this.cf = new Path();
        this.ch = new Path();
        this.cg = new Path();
        this.ce = new Path();
        this.b0 = a;
        this.b3 = ((() => {
            let $ret = new Pool$1(LineGeometry.$);
            $ret.create = runOn(this, this.cd);
            $ret.destroy = runOn(this, this.b6);
            return $ret;
        })());
    }
    bv() {
        return new FinancialIndicatorBucketCalculator(this);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.bw.po = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.bw.ey = 2;
        }
    }
    cd() {
        return new LineGeometry();
    }
    b6(a) {
    }
    get b2() {
        if (this.b1 == null) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
        return this.b1;
    }
    set b2(a) {
        this.b1 = a;
    }
    get b4() {
        return this.b1 != null;
    }
    b5(a) {
        Extensions.e(this.cr.ak);
        Extensions.e(this.cs.ak);
        Extensions.e(this.ct.ak);
        Extensions.e(this.cn.ak);
        Extensions.e(this.co.ak);
        Extensions.e(this.cp.ak);
        Extensions.d(this.cq.ak);
        Extensions.d(this.cm.ak);
        if (a) {
            this.b3.count = 0;
        }
        this.an();
    }
    cb() {
    }
    b9(a, b, c, d, e) {
        IndicatorRenderer.g(a, b, c, d, this.bs, this.br, this.cr, this.cn, this.bu.b, this.e.eu, e);
        this.an();
    }
    b7(a, b, c, d, e, f) {
        IndicatorRenderer.e(a, b, c, d, this.bs, this.br, this.cr, this.cs, this.cn, this.co, e, this.bu.b, this.e.eu, f);
        this.an();
    }
    b8(a, b, c, d, e) {
        IndicatorRenderer.f(a, b, c, d, this.br, e, this.b3, this.cq, this.cm);
        this.an();
    }
    cc() {
        this.b0.qi = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.qi = this.b0.trendLineBrush;
        }
        else {
            this.b0.qi = this.b0.lb;
        }
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.cj.ak = this.cr.ak;
        this.cl.ak = this.ct.ak;
        this.ck.ak = this.cs.ak;
        this.ci.ak = this.cq.ak;
        this.cf.ak = this.cn.ak;
        this.ch.ak = this.cp.ak;
        this.cg.ak = this.co.ak;
        this.ce.ak = this.cm.ak;
        this.cj._stroke = a;
        this.cl._stroke = a;
        this.cj.ac = this.e.ey + 3;
        this.cl.ac = this.e.ey + 3;
        this.ck._fill = a;
        this.ck._opacity = 1;
        this.ci._stroke = a;
        this.ci.ac = this.e.ey + 3;
        this.cf._stroke = a;
        this.ch._stroke = a;
        this.cf.ac = this.e.ey + 3;
        this.ch.ac = this.e.ey + 3;
        this.cg._fill = a;
        this.cg._opacity = 1;
        this.ce._stroke = a;
        this.ce.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                if (this.b0.pu == 2) {
                    a.s(this.ci);
                    a.s(this.ce);
                }
                else {
                    a.s(this.ck);
                    a.s(this.cj);
                    a.s(this.cl);
                    a.s(this.cg);
                    a.s(this.cf);
                    a.s(this.ch);
                }
            }
            else {
                if (this.b0.pu == 2) {
                    a.s(this.cq);
                    a.s(this.cm);
                }
                else {
                    a.s(this.cs);
                    a.s(this.cr);
                    a.s(this.ct);
                    a.s(this.co);
                    a.s(this.cn);
                    a.s(this.cp);
                }
            }
        }
    }
    a2(a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                let c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.qi;
                c.ad = this.b0.qk;
                c.ai = this.b0.qj;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.cq, "positiveColumnsShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cm, "negativeColumnsShape", ["Negative"]);
        this.e.a2.exportPathData(a, this.cr, "positive0", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.ct, "positive1", ["Positive"]);
        this.e.a2.exportPathData(a, this.cs, "positive01", ["PositiveFill"]);
        this.e.a2.exportPathData(a, this.cn, "negative0", ["Negative", "Main"]);
        this.e.a2.exportPathData(a, this.cp, "negative1", ["Negative"]);
        this.e.a2.exportPathData(a, this.co, "negative01", ["NegativeFill"]);
    }
    ca() {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
    }
}
FinancialIndicatorView.$t = markType(FinancialIndicatorView, 'FinancialIndicatorView', FinancialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StrategyBasedIndicator extends FinancialIndicator {
    constructor() {
        super();
        this.q0();
    }
    q0() {
        this.ql = this.qm;
        this.ab = this.qz;
    }
    qs() {
        return -2147483648;
    }
    q1(a) {
    }
    qu() {
        return -2147483648;
    }
    qr() {
        return -2147483648;
    }
    static q5(a, b, c) {
        let d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, (e, f) => (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue)));
        StrategyBasedIndicator.qp.add(c);
        return d;
    }
    static q4(a, b) {
        return StrategyBasedIndicator.q5(a, b, "Period");
    }
    static q2(a, b) {
        return StrategyBasedIndicator.q5(a, b, "LongPeriod");
    }
    static q6(a, b) {
        return StrategyBasedIndicator.q5(a, b, "ShortPeriod");
    }
    py(a, b) {
        let c = this.mu(a, b);
        let d = this.mv(c);
        return this.ql.b(c, d);
    }
    pv(a, b) {
        let c = this.mu(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.nr(this.py(a, b))) {
            return false;
        }
        let d = this.mv(c);
        if (this.ps != null) {
            c.minimumValue = this.ps.c;
            c.maximumValue = this.ps.b;
        }
        let e = this.ql.a(c, d);
        for (let f = 0; f < this.p0 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.m3 != null && this.qo(c)) {
            this.m3.cn();
        }
        return e;
    }
    qo(a) {
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            let b = this.ps;
            this.ps = new AxisRange(a.minimumValue, a.maximumValue);
            return this.qn(b, this.ps);
        }
        let c = 1.7976931348623157E+308;
        let d = -1.7976931348623157E+308;
        for (let e of fromEnum(a.indicatorColumn)) {
            if (!isNaN_(e)) {
                c = Math.min(c, e);
                d = Math.max(d, e);
            }
        }
        let f = this.ps;
        this.ps = new AxisRange(c, d);
        return this.qn(f, this.ps);
    }
    qn(a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    }
    qt(a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    }
    mu(a, b) {
        let c = super.mu(a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.qt(this.qs());
        c.shortPeriod = this.qt(this.qu());
        c.longPeriod = this.qt(this.qr());
        c.multiplier = this.qq();
        return c;
    }
    qq() {
        return 1;
    }
    static q3(a, b) {
        let c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, (d, e) => (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue)));
        StrategyBasedIndicator.qp.add("Multiplier");
        return c;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (StrategyBasedIndicator.qp.contains(b)) {
            if (this.m3 != null && !this.m3.cn()) {
                this.my.bu.e(this.eu);
                this.pv(0, this.indicatorColumn.count);
                if (this.pt.b4) {
                    this.pt.b2.g$i();
                }
                this.jl(false);
            }
        }
    }
}
StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
StrategyBasedIndicator.qp = new List$1(String_$type, 0);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndicatorProxy extends Base {
    matchesType(a) {
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator")) {
            return true;
        }
        return false;
    }
    setCloseMemberPath(a, b) {
        a.om = b;
    }
    setDisplayType(a, b) {
        a.pu = b;
    }
    setHighMemberPath(a, b) {
        a.op = b;
    }
    setLongPeriod(a, b) {
        if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
            a.longPeriod = b;
        }
    }
    setLowMemberPath(a, b) {
        a.ou = b;
    }
    setNegativeBrush(a, b) {
        a.po = b;
    }
    setOpenMemberPath(a, b) {
        a.oy = b;
    }
    setPeriodOverride(a, b) {
        if (typeCast(StrategyBasedIndicator.$, a) !== null) {
            a.q1(b);
        }
    }
    setShortPeriod(a, b) {
        if (typeCast(IShortPeriodLongPeriod_$type, a) !== null) {
            a.shortPeriod = b;
        }
    }
    setSignalPeriod(a, b) {
        if (getInstanceType(a).typeName == "MovingAverageConvergenceDivergenceIndicator") {
            let s_ = a;
            let p_ = b;
            s_['signalPeriod'] = p_;
        }
    }
    setSmoothingPeriod(a, b) {
        if (getInstanceType(a).typeName == "FullStochasticOscillatorIndicator") {
            let s_ = a;
            let p_ = b;
            s_['smoothingPeriod'] = p_;
        }
    }
    setVolumeMemberPath(a, b) {
        a.o2 = b;
    }
    setXAxis(a, b) {
        a.mi = b;
    }
    setYAxis(a, b) {
        a.m3 = b;
    }
    handleCustomIndicatorEvent(a, b) {
        if (getInstanceType(a).typeName == "CustomIndicator") {
            let s_ = a;
            let p_ = b;
            s_['indicator'] = p_;
        }
    }
}
IndicatorProxy.$t = markType(IndicatorProxy, 'IndicatorProxy', Base.$, [IIndicatorProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxIndicatorProxyModule = class IgxIndicatorProxyModule {
    constructor() {
        TypeRegistrar.register('IndicatorProxy', IndicatorProxy.$type);
    }
};
IgxIndicatorProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxIndicatorProxyModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxIndicatorProxyDynamicModule = class IgxIndicatorProxyDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IndicatorProxy', IndicatorProxy);
        TypeRegistrar.register('IndicatorProxy', IndicatorProxy.$type);
    }
};
IgxIndicatorProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxIndicatorProxyModule
        ],
        imports: [CommonModule, IgxIndicatorProxyModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxIndicatorProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the data contract between a financial series and the
 * decoupled calculation responsibilities which implement its mathmatical logic.
 * The FinancialCalculationDataSource contract represents the subset
 * of data which needs to be provided in order to test or run a calculation,
 * and its intentionally a subset of the information available to the series,
 * in order to make calculation strategies more easily testable and usable in isolation to
 * the financial series container.
*/
class IgxFinancialCalculationDataSource {
    createImplementation() {
        return new FinancialCalculationDataSource();
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get openColumn() {
        return this.i.series.getOpenColumnAsArray();
    }
    get highColumn() {
        return this.i.series.getHighColumnAsArray();
    }
    get lowColumn() {
        return this.i.series.getLowColumnAsArray();
    }
    get closeColumn() {
        return this.i.series.getCloseColumnAsArray();
    }
    get volumeColumn() {
        return this.i.series.getVolumeColumnAsArray();
    }
    get indicatorColumn() {
        return this.i.series.indicatorColumn.asArray();
    }
    /**
 * An enumerable list of typical prices provided by the series to use
 * in calculations.
*/
    get typicalColumn() {
        if (this.i.typicalColumn == null) {
            return null;
        }
        return this.i.typicalColumn.externalObject;
    }
    set typicalColumn(v) {
        v == null ? this.i.typicalColumn = null : this.i.typicalColumn = v.i;
    }
    /**
     * And enumerable list of true range values provided by the series to use
     * in calculations.
    */
    get trueRange() {
        if (this.i.trueRange == null) {
            return null;
        }
        return this.i.trueRange.externalObject;
    }
    set trueRange(v) {
        v == null ? this.i.trueRange = null : this.i.trueRange = v.i;
    }
    /**
     * An enumerable list of true low values provided by the series to use
     * in calculations.
    */
    get trueLow() {
        if (this.i.trueLow == null) {
            return null;
        }
        return this.i.trueLow.externalObject;
    }
    set trueLow(v) {
        v == null ? this.i.trueLow = null : this.i.trueLow = v.i;
    }
    /**
     * The period to use when calculating, if applicable.
    */
    get period() {
        return this.i.period;
    }
    set period(v) {
        this.i.period = +v;
    }
    /**
     * The short period to use when calculating, if applicable.
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * The long period to use when calculating, if applicable.
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
    /**
     * The count of the values in the series.
    */
    get count() {
        return this.i.count;
    }
    set count(v) {
        this.i.count = +v;
    }
    /**
     * The starting index from which to calculate
    */
    get calculateFrom() {
        return this.i.calculateFrom;
    }
    set calculateFrom(v) {
        this.i.calculateFrom = +v;
    }
    /**
     * The number of items from the starting index from which to calculate
    */
    get calculateCount() {
        return this.i.calculateCount;
    }
    set calculateCount(v) {
        this.i.calculateCount = +v;
    }
    /**
     * If the calculation supports some sort of scaling factor,
     * this value will be used.
    */
    get multiplier() {
        return this.i.multiplier;
    }
    set multiplier(v) {
        this.i.multiplier = +v;
    }
    /**
     * If the calculation determines the range of indicator values,
     * it will set the minimum and maximux properties.
     * This will contain the previous minimum value when the indicator
     * calculation is called again, in case this makes the update of the
     * value speedier.
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = +v;
    }
    /**
     * If the calculation determines the range of indicator values,
     * it will set the minimum and maximux properties.
     * This will contain the previous minimum value when the indicator
     * calculation is called again, in case this makes the update of the
     * value speedier.
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = +v;
    }
    /**
     * The calculation strategy should set this to true if it
     * specifes the minimum and maximum value properties.
    */
    get specifiesRange() {
        return this.i.specifiesRange;
    }
    set specifiesRange(v) {
        this.i.specifiesRange = ensureBool(v);
    }
    findByName(name) {
        if (this.typicalColumn && this.typicalColumn.name && this.typicalColumn.name == name) {
            return this.typicalColumn;
        }
        if (this.trueRange && this.trueRange.name && this.trueRange.name == name) {
            return this.trueRange;
        }
        if (this.trueLow && this.trueLow.name && this.trueLow.name == name) {
            return this.trueLow;
        }
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a contract between the financial series and the calculation strategies
 * detailing the supporting calculation strategies that the financial series will
 * provide in order for the indicator calculations to be performed.
*/
class IgxFinancialCalculationSupportingCalculations {
    createImplementation() {
        return new FinancialCalculationSupportingCalculations();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The strategy provided to calculate an exponential moving average for a collection.
    */
    get eMA() {
        if (this.i.a == null) {
            return null;
        }
        return this.i.a.externalObject;
    }
    set eMA(v) {
        v == null ? this.i.a = null : this.i.a = v.i;
    }
    /**
     * The strategy provided to calculate a simple moving average for a collection.
    */
    get sMA() {
        if (this.i.c == null) {
            return null;
        }
        return this.i.c.externalObject;
    }
    set sMA(v) {
        v == null ? this.i.c = null : this.i.c = v.i;
    }
    /**
     * The strategy provided to calculate a standard deviation for a collection.
    */
    get sTDEV() {
        if (this.i.d == null) {
            return null;
        }
        return this.i.d.externalObject;
    }
    set sTDEV(v) {
        v == null ? this.i.d = null : this.i.d = v.i;
    }
    /**
     * The strategy provided to calculate a moving sum for a collection.
    */
    get movingSum() {
        if (this.i.b == null) {
            return null;
        }
        return this.i.b.externalObject;
    }
    set movingSum(v) {
        v == null ? this.i.b = null : this.i.b = v.i;
    }
    /**
     * The strategy provided to calculate the short period moving average for volume oscillator indicators.
    */
    get shortVolumeOscillatorAverage() {
        if (this.i.h == null) {
            return null;
        }
        return this.i.h.externalObject;
    }
    set shortVolumeOscillatorAverage(v) {
        v == null ? this.i.h = null : this.i.h = v.i;
    }
    /**
     * The strategy provided to calculate the long period moving average for volume oscillator indicators.
    */
    get longVolumeOscillatorAverage() {
        if (this.i.f == null) {
            return null;
        }
        return this.i.f.externalObject;
    }
    set longVolumeOscillatorAverage(v) {
        v == null ? this.i.f = null : this.i.f = v.i;
    }
    /**
     * The strategy provided to calculate the short period moving average for price oscillator indicators.
    */
    get shortPriceOscillatorAverage() {
        if (this.i.g == null) {
            return null;
        }
        return this.i.g.externalObject;
    }
    set shortPriceOscillatorAverage(v) {
        v == null ? this.i.g = null : this.i.g = v.i;
    }
    /**
     * The strategy provided to calculate the long period moving average for price oscillator indicators.
    */
    get longPriceOscillatorAverage() {
        if (this.i.e == null) {
            return null;
        }
        return this.i.e.externalObject;
    }
    set longPriceOscillatorAverage(v) {
        v == null ? this.i.e = null : this.i.e = v.i;
    }
    /**
     * The strategy provided to make doubles safe for plotting, by default will just make zero if the value
     * is invalid.
    */
    get makeSafe() {
        return this.i.i;
    }
    set makeSafe(v) {
        this.i.i = v;
    }
    findByName(name) {
        if (this.eMA && this.eMA.name && this.eMA.name == name) {
            return this.eMA;
        }
        if (this.sMA && this.sMA.name && this.sMA.name == name) {
            return this.sMA;
        }
        if (this.sTDEV && this.sTDEV.name && this.sTDEV.name == name) {
            return this.sTDEV;
        }
        if (this.movingSum && this.movingSum.name && this.movingSum.name == name) {
            return this.movingSum;
        }
        if (this.shortVolumeOscillatorAverage && this.shortVolumeOscillatorAverage.name && this.shortVolumeOscillatorAverage.name == name) {
            return this.shortVolumeOscillatorAverage;
        }
        if (this.longVolumeOscillatorAverage && this.longVolumeOscillatorAverage.name && this.longVolumeOscillatorAverage.name == name) {
            return this.longVolumeOscillatorAverage;
        }
        if (this.shortPriceOscillatorAverage && this.shortPriceOscillatorAverage.name && this.shortPriceOscillatorAverage.name == name) {
            return this.shortPriceOscillatorAverage;
        }
        if (this.longPriceOscillatorAverage && this.longPriceOscillatorAverage.name && this.longPriceOscillatorAverage.name == name) {
            return this.longPriceOscillatorAverage;
        }
        return null;
    }
}

/**
 * Parameterizes a financial calculation event.
*/
class IgxFinancialEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get basedOn() {
        let ret = null;
        if (this.i.basedOn) {
            ret = [];
            for (let i = 0; i < this.i.basedOn.count; i++) {
                ret.push(this.i.basedOn[i]);
            }
        }
        return ret;
    }
    set basedOn(v) {
        if (!v) {
            this.i.basedOn = null;
            return;
        }
        let list = new List$1(String_$type, 0);
        for (let i = 0; i < v.length; i++) {
            list.add(v[i]);
        }
        this.i.basedOn = list;
    }
    /**
 * The beginning position that should be calculated from.
*/
    get position() {
        return this.i.position;
    }
    set position(v) {
        this.i.position = +v;
    }
    /**
     * The number of positions that should be calculated from the start.
    */
    get count() {
        return this.i.count;
    }
    set count(v) {
        this.i.count = +v;
    }
    /**
     * The data to use for the calculation.
    */
    get dataSource() {
        if (this.i.dataSource == null) {
            return null;
        }
        if (!this.i.dataSource.externalObject) {
            let e = new IgxFinancialCalculationDataSource();
            e._implementation = this.i.dataSource;
            this.i.dataSource.externalObject = e;
        }
        return this.i.dataSource.externalObject;
    }
    set dataSource(v) {
        v == null ? this.i.dataSource = null : this.i.dataSource = v.i;
    }
    /**
     * The supporting calculations to use in the calculation.
    */
    get supportingCalculations() {
        if (this.i.supportingCalculations == null) {
            return null;
        }
        if (!this.i.supportingCalculations.externalObject) {
            let e = new IgxFinancialCalculationSupportingCalculations();
            e._implementation = this.i.supportingCalculations;
            this.i.supportingCalculations.externalObject = e;
        }
        return this.i.supportingCalculations.externalObject;
    }
    set supportingCalculations(v) {
        v == null ? this.i.supportingCalculations = null : this.i.supportingCalculations = v.i;
    }
}

/**
 * Represents the base class for all financial indicator and overlay series.
*
* The `IgxFinancialSeriesComponent` represents the base class for all financial indicator and overlay series.
*
* ```html
*  <igx-data-chart
*     #chart
*         [dataSource]="data" >
*   <igx-category-x-axis
*         label="label"
*         #xAxis>
*         </igx-category-x-axis>
*  <igx-numeric-y-axis
*         minimumValue="0"
*         #yAxis>
* </igx-numeric-y-axis>
* <igx-financial-price-series
*     [xAxis]="xAxis"
*       [yAxis]="yAxis"
*       openMemberPath="open"
*       highMemberPath="high"
*       lowMemberPath="low"
*       closeMemberPath="close"
*       volumeMemberPath="volume">
* </igx-financial-price-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxFinancialPriceSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* series.volumeMemberPath="volume";
* this.chart.series.add(series);
* ```
*/
const IgxFinancialSeriesComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinancialSeriesComponent) }];
class IgxFinancialSeriesComponent extends IgxSeriesComponent {
    constructor() {
        super();
        this._assigningCategoryStyle = null;
        this._typical = null;
        this._typicalBasedOn = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series is a financial type series.
    */
    get isFinancial() {
        return this.i.cr;
    }
    /**
     * Gets or sets the brush to use for negative portions of the series.
    *
    * The `negativeBrush` property is used to brush the negative portions of the series.
    *
    * ```ts
    * series.negativeBrush="red";
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    * 	  negativeBrush="red">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get negativeBrush() {
        return brushToString(this.i.po);
    }
    set negativeBrush(v) {
        this.i.po = stringToBrush(v);
    }
    /**
     * Gets or sets the effective x-axis for the current FinancialSeries object.
    *
    * Use `xAxis` property to set effective x-axis for the current FinancialSeries object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get xAxis() {
        if (this.i.mi == null) {
            return null;
        }
        if (!this.i.mi.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.mi);
            if (e) {
                e._implementation = this.i.mi;
            }
            this.i.mi.externalObject = e;
        }
        return this.i.mi.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mi = null : this.i.mi = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current FinancialSeries object.
    *
    * Use `yAxis` property to set the effective y-axis for the current FinancialSeries object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get yAxis() {
        if (this.i.m3 == null) {
            return null;
        }
        if (!this.i.m3.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.m3);
            if (e) {
                e._implementation = this.i.m3;
            }
            this.i.m3.externalObject = e;
        }
        return this.i.m3.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.m3 = null : this.i.m3 = v.i;
    }
    /**
     * Gets or sets the open mapping property for the current series object.
    *
    * The `openMemberPath` property is used for open mapping of the current series object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get openMemberPath() {
        return this.i.oy;
    }
    set openMemberPath(v) {
        this.i.oy = v;
    }
    /**
     * Gets or sets the high mapping property for the current series object.
    *
    * Use `highMemberPath` propert for high mapping of the current series object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get highMemberPath() {
        return this.i.op;
    }
    set highMemberPath(v) {
        this.i.op = v;
    }
    /**
     * Gets or sets the low mapping property for the current series object.
    *
    * The `lowMemberPath` is used for low mapping property of the current series object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get lowMemberPath() {
        return this.i.ou;
    }
    set lowMemberPath(v) {
        this.i.ou = v;
    }
    /**
     * Gets or sets the close mapping property for the current series object.
    *
    * Use `closeMemberPath` property for the close mapping of the current series object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get closeMemberPath() {
        return this.i.om;
    }
    set closeMemberPath(v) {
        this.i.om = v;
    }
    /**
     * Gets or sets the volume mapping property for the current series object.
    *
    * The `volumeMemberPath` property is used for the volume mapping property of the current series object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxFinancialPriceSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.openMemberPath = "open";
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * series.closeMemberPath = "close";
    * series.volumeMemberPath="volume";
    * this.chart.series.add(series);
    * ```
    */
    get volumeMemberPath() {
        return this.i.o2;
    }
    set volumeMemberPath(v) {
        this.i.o2 = v;
    }
    /**
     * Gets or sets whether this category series should allow custom style overrides of its individual visuals.
    *
    * The `isCustomCategoryStyleAllowed` property is used to check if the category series should allow custom style.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    * 	  isCustomCategoryStyleAllowed="True" />
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.isCustomCategoryStyleAllowed= true;
    * ```
    */
    get isCustomCategoryStyleAllowed() {
        return this.i.no;
    }
    set isCustomCategoryStyleAllowed(v) {
        this.i.no = ensureBool(v);
    }
    /**
     * Gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
     * Note: Transitions are not currently supported for stacked series.
    *
    * The `transitionInMode` property is used to gets or sets the method by which to animate the data into the chart when the chart data source is swapped.
    *
    * ```ts
    * series.transitionInMode =CategoryTransitionInMode.Auto;
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    * 	  transitionInMode= "Auto">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get transitionInMode() {
        return this.i.ms;
    }
    set transitionInMode(v) {
        this.i.ms = ensureEnum(CategoryTransitionInMode_$type, v);
    }
    /**
     * Gets or sets whether the series should transition into the plot area when a new data source is assigned.
     * Note: Transitions are not currently supported for stacked series.
    *
    * The `isTransitionInEnabled` property is used to check if the series should transition into the plot area when a new data source is assigned.
    *
    * ```ts
    * series.isTransitionInEnabled= true;
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *   <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *         </igx-category-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    * 	  isTransitionInEnabled= "true">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get isTransitionInEnabled() {
        return this.i.np;
    }
    set isTransitionInEnabled(v) {
        this.i.np = ensureBool(v);
    }
    /**
     * Overridden by derived series classes to indicate when negative colors are supported or not.
    */
    get isNegativeColorSupported() {
        return this.i.cz;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * The `getOffsetValue` method returns the offset value for this series if grouped on a category axis.
    *
    * ```ts
    * number offset= series.getOffsetValue();
    * ```
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * The `getCategoryWidth` method returns the width of the category grouping this series is in.
    *
    * ```ts
    * number width = series.getCategoryWidth();
    * ```
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesLowValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesCloseValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.oa(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesOpenValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ob(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesVolumeValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.oc(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lr(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesLowValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lt(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesOpenValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.pq(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesCloseValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.pp(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesVolumeValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.pr(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * Use `canUseAsYAxis` method to determine if the object can be used as YAxis.
    *
    * ```ts
    *   boolean canY =series.canUseAsYAxis(yAxis);
    * ```
    */
    canUseAsYAxis(axis) {
        let iv = this.i.nk(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * Use `canUseAsXAxis` method to determine if the object can be used as XAxis.
    *
    * ```ts
    *   boolean canX =series.canUseAsXAxis(xAxis);
    * ```
    */
    canUseAsXAxis(axis) {
        let iv = this.i.nj(axis);
        return (iv);
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    *
    * The `getExactItemIndex` method gets the precise item index, if possible, based on the closeness to the previous or next whole integer.
    *
    * If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    *
    * ```ts
    * number index = series.getExactItemIndex(world);
    * ```
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    *
    * The `getItemIndex` method gets the index of the item that resides at the provided world coordinates.
    *
    * ```ts
    * number itemindex= series.getItemIndex(world);
    * ```
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    *
    * The `getItem` method gets the item that is the best match for the specified world coordinates.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    setNegativeColors(negativeBrush, negativeOutline) {
        this.i.jq(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    }
    /**
     * Event raised when Assigning Category Style
    *
    * The `AssigningCategoryStyle` event raised when assigning Category Style.
    *
    * ```ts
    * series.assigningCategoryStyle= this.chart_AssigningCategoryStyle;
    * chart_AssigningCategoryStyle(sender :any,args: AssigningCategoryStyleEventArgs )
    *   {
    *
    *
    *   }
    * ```
    */
    get assigningCategoryStyle() {
        if (this._assigningCategoryStyle == null) {
            this._assigningCategoryStyle = new EventEmitter();
            this.i.assigningCategoryStyle = delegateCombine(this.i.assigningCategoryStyle, (o, e) => {
                let outerArgs = new IgxAssigningCategoryStyleEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeAssigningCategoryStyle) {
                    this.beforeAssigningCategoryStyle(this, outerArgs);
                }
                this._assigningCategoryStyle.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._assigningCategoryStyle;
    }
    /**
     * Handle this event in order to perform a custom typical price calculation.
    *
    * Use `Typical` event to perform a custom typical price calculation.
    *
    * ```ts
    * series.typical= this.chart_typical;
    *
    *   chart_typical(sender :any,args: FinancialEventArgs )
    *   {
    *
    *
    *   }
    * ```
    */
    get typical() {
        if (this._typical == null) {
            this._typical = new EventEmitter();
            this.i.typical = delegateCombine(this.i.typical, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxFinancialEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeTypical) {
                        this.beforeTypical(this, outerArgs);
                    }
                    this._typical.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._typical;
    }
    /**
     * Handle this event in order to specify which columns the Typical price calculation is based on.
    *
    * Use `TypicalBasedOn` event to specify which columns the Typical price calculation is based on.
    *
    * ```ts
    *    series.typicalBasedOn= this.chart_typicalBasedOn;
    *     chart_typicalBasedOn(sender :any,args: FinancialEventArgs )
    *   {
    *
    *   }
    * ```
    */
    get typicalBasedOn() {
        if (this._typicalBasedOn == null) {
            this._typicalBasedOn = new EventEmitter();
            this.i.typicalBasedOn = delegateCombine(this.i.typicalBasedOn, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxFinancialEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeTypicalBasedOn) {
                        this.beforeTypicalBasedOn(this, outerArgs);
                    }
                    this._typicalBasedOn.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._typicalBasedOn;
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "negativeBrush", null);
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAxisBaseComponent),
    __metadata("design:paramtypes", [IgxCategoryAxisBaseComponent])
], IgxFinancialSeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxFinancialSeriesComponent.prototype, "yAxis", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "openMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "highMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "lowMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "closeMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialSeriesComponent.prototype, "volumeMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialSeriesComponent.prototype, "isCustomCategoryStyleAllowed", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialSeriesComponent.prototype, "transitionInMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialSeriesComponent.prototype, "isTransitionInEnabled", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxFinancialSeriesComponent.prototype, "assigningCategoryStyle", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxFinancialSeriesComponent.prototype, "typical", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxFinancialSeriesComponent.prototype, "typicalBasedOn", null);

/**
 * Represents the base functionality for a IgxDataChartComponent financial indicator series.
*
* The `IgxFinancialIndicatorComponent` class represents the base functionality for a IgxDataChartComponent financial indicator series.
*
* ```html
* <igx-data-chart  #chart
*     [dataSource]="data" >
* <igx-ordinal-time-x-axis
*     label="label"
*     #xAxis>
*     </igx-ordinal-time-x-axis>
*  <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
*     </igx-numeric-y-axis>
* <igx-mass-index-indicator
* [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume"   >
*     </igx-mass-index-indicator >
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMassIndexIndicatorComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.openMemberPath = "open";
*    series.highMemberPath = "high";
*    series.lowMemberPath = "low";
*    series.closeMemberPath = "close";
*    this.chart.series.add(series);
*
* ```
*/
const IgxFinancialIndicatorComponent_PROVIDERS = [{ provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFinancialIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinancialIndicatorComponent) }];
class IgxFinancialIndicatorComponent extends IgxFinancialSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the display for the current FinancialIndicator object.
    *
    * The `displayType` property is used to display the current FinancialIndicator object.
    *
    * ```ts
    * series.displayType= IndicatorDisplayType.Column;
    * ```
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    * 	displayType="Column"   >
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    */
    get displayType() {
        return this.i.pu;
    }
    set displayType(v) {
        this.i.pu = ensureEnum(IndicatorDisplayType_$type, v);
    }
    /**
     * Gets or sets the number of values to hide at the beginning of the indicator.
    *
    * Use the `ignoreFirst` propert to hide the number of values at the beginning of the indicator.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    * 	ignoreFirst="2" >
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.ignoreFirst  = 2;
    * ```
    */
    get ignoreFirst() {
        return this.i.p0;
    }
    set ignoreFirst(v) {
        this.i.p0 = +v;
    }
    /**
     * Gets or sets the trend type for the current indicator series.
    *
    * Use `trendLineType` property to get the trend type for the current indicator series.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *    <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-mass-index-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close"
    * 		trendLineType="CubicFit">
    *     </igx-mass-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLineType= TrendLineType.CubicFit;
    * ```
    */
    get trendLineType() {
        return this.i.trendLineType;
    }
    set trendLineType(v) {
        this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush to use to draw the trend line.
    *
    * Use the `trendLineBrush` propert to draw the trend line.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    * 	trendLineBrush="Red">
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    */
    get trendLineBrush() {
        return brushToString(this.i.trendLineBrush);
    }
    set trendLineBrush(v) {
        this.i.trendLineBrush = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this indicator.
    *
    * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.qi);
    }
    set actualTrendLineBrush(v) {
        this.i.qi = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current indicator object's trend line.
    *
    * Use `trendLineThickness` property for the thickness of the current indicator object's trend line.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    * 	trendLineThickness="2" >
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    *
    * ```ts
    *  series.trendLineThickness=2 ;
    * ```
    */
    get trendLineThickness() {
        return this.i.trendLineThickness;
    }
    set trendLineThickness(v) {
        this.i.trendLineThickness = +v;
    }
    /**
     * Gets or sets the trend line period for the current series.
     * The typical, and initial, value for trend line period is 7.
    *
    * Use `trendLinePeriod` property for the trend line period of the current series.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data" >
    * <igx-ordinal-time-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    * <igx-mass-index-indicator
    * [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    * 	trendLinePeriod="30" >
    *     </igx-mass-index-indicator >
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.trendLinePeriod  =30;
    * ```
    */
    get trendLinePeriod() {
        return this.i.trendLinePeriod;
    }
    set trendLinePeriod(v) {
        this.i.trendLinePeriod = +v;
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method returns the best available value bounding box within the series that has the best value match for the world position provided.
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` method scrolls the series to display the item for the specified data item.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialIndicatorComponent.prototype, "displayType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialIndicatorComponent.prototype, "ignoreFirst", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialIndicatorComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialIndicatorComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialIndicatorComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialIndicatorComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialIndicatorComponent.prototype, "trendLinePeriod", null);

/**
 * A base class for indicator series with simple calculations that separates the calculation
 * responsibility from the other responsibilities of the financial series, this enables
 * easier unit testing and decoupling of individual calculation strategies.
 * A contract is defined between the financial series and these simple indicator calculations
 * detailing the data which the series agrees to provide the simple indicator calculations,
 * this contract is defined by FinancialCalculationDataSource. If more
 * complex interactions are needed between the indicator calculation and the series, the
 * indicators should instead derive from FinancialIndicator directly, or some
 * derivative other than StrategyBasedIndicator
*/
const IgxStrategyBasedIndicatorComponent_PROVIDERS = [{ provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxStrategyBasedIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxStrategyBasedIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStrategyBasedIndicatorComponent) }];
class IgxStrategyBasedIndicatorComponent extends IgxFinancialIndicatorComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndicatorCalculationStrategy extends Base {
}
IndicatorCalculationStrategy.$t = markType(IndicatorCalculationStrategy, 'IndicatorCalculationStrategy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AbsoluteVolumeOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(b.h.c);
        c.o(b.f.c);
        return c;
    }
    a(a, b) {
        let c = getEnumerator(b.h.b(a));
        let d = getEnumerator(b.f.b(a));
        let e = a.indicatorColumn;
        let f = 0;
        while (c.moveNext() && d.moveNext()) {
            let g = c.current - d.current;
            e.item(f, b.i(g));
            ++f;
        }
        return true;
    }
}
AbsoluteVolumeOscillatorIndicatorStrategy.$t = markType(AbsoluteVolumeOscillatorIndicatorStrategy, 'AbsoluteVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AbsoluteVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new AbsoluteVolumeOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return AbsoluteVolumeOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.q8));
    }
    set shortPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.q8, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(AbsoluteVolumeOscillatorIndicator.q7));
    }
    set longPeriod(a) {
        this.h(AbsoluteVolumeOscillatorIndicator.q7, a);
    }
    qr() {
        return this.longPeriod;
    }
}
AbsoluteVolumeOscillatorIndicator.$t = markType(AbsoluteVolumeOscillatorIndicator, 'AbsoluteVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
AbsoluteVolumeOscillatorIndicator.q8 = StrategyBasedIndicator.q6(10, AbsoluteVolumeOscillatorIndicator.$);
AbsoluteVolumeOscillatorIndicator.q7 = StrategyBasedIndicator.q2(30, AbsoluteVolumeOscillatorIndicator.$);

var IgxAbsoluteVolumeOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Absolute Volume Oscillator indicator series.
 * Default required members: Volume
*
* You can use the `IgxAbsoluteVolumeOscillatorIndicatorComponent` to identify whether volume trands are increasing or decreasing.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-absolute-volume-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-absolute-volume-oscillator-indicator>
* </igx-data-chart>
* ```
*/
const IgxAbsoluteVolumeOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent) }];
let IgxAbsoluteVolumeOscillatorIndicatorComponent = IgxAbsoluteVolumeOscillatorIndicatorComponent_1 = class IgxAbsoluteVolumeOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AbsoluteVolumeOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
     * The typical, and initial, value for short AVO periods is 10.
    *
    * You can use the `shortPeriod` to set the short moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-absolute-volume-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		shortPeriod="10">
    *     </igx-absolute-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shortPeriod = 10;
    * ```
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * Gets or sets the short moving average period for the current AbsoluteVolumeOscillatorIndicator object.
     * The typical, and initial, value for long AVO periods is 30.
    *
    * You can use the `longPeriod` to set the long moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-absolute-volume-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		longPeriod="30">
    *     </igx-absolute-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod = 30;
    * ```
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype, "shortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAbsoluteVolumeOscillatorIndicatorComponent.prototype, "longPeriod", null);
IgxAbsoluteVolumeOscillatorIndicatorComponent = IgxAbsoluteVolumeOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-absolute-volume-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAbsoluteVolumeOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAbsoluteVolumeOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAbsoluteVolumeOscillatorIndicatorModule = class IgxAbsoluteVolumeOscillatorIndicatorModule {
};
IgxAbsoluteVolumeOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxAbsoluteVolumeOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxAbsoluteVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxAbsoluteVolumeOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAbsoluteVolumeOscillatorIndicatorDynamicModule = class IgxAbsoluteVolumeOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAbsoluteVolumeOscillatorIndicatorComponent", IgxAbsoluteVolumeOscillatorIndicatorComponent);
        TypeRegistrar.register("AbsoluteVolumeOscillatorIndicator", AbsoluteVolumeOscillatorIndicator.$type);
    }
};
IgxAbsoluteVolumeOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule],
        exports: [IgxAbsoluteVolumeOscillatorIndicatorModule],
        entryComponents: [IgxAbsoluteVolumeOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAbsoluteVolumeOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StreamingIndicatorCalculationStrategy extends IndicatorCalculationStrategy {
}
StreamingIndicatorCalculationStrategy.$t = markType(StreamingIndicatorCalculationStrategy, 'StreamingIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AccumulationDistributionIndicatorStrategy extends StreamingIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("LowColumn");
        c.add("HighColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = 0;
        for (let d of fromEnum(this.c(a, b))) {
            a.indicatorColumn.item(c, d);
            c++;
        }
        return true;
    }
    *_c(a, b) {
        let c = 0;
        let d = Number.POSITIVE_INFINITY;
        let e = Number.NEGATIVE_INFINITY;
        let f = a.indicatorColumn != null ? a.indicatorColumn.count : 0;
        let g = a.closeColumn != null ? a.closeColumn.count : 0;
        let h = a.highColumn != null ? a.highColumn.count : 0;
        let i = a.volumeColumn != null ? a.volumeColumn.count : 0;
        let j = Math.min(f, Math.min(g, Math.min(h, i)));
        for (let k = 0; k < j; ++k) {
            let l = a.closeColumn.item(k);
            let m = a.lowColumn.item(k);
            let n = a.highColumn.item(k);
            let o = a.volumeColumn.item(k);
            let p = ((l - m) - (n - l)) / (n - m);
            c += b.i(p * o);
            d = Math.min(d, c);
            e = Math.max(e, c);
            yield c;
        }
    }
    c(a, b) {
        return toEnum(() => this._c(a, b));
    }
}
AccumulationDistributionIndicatorStrategy.$t = markType(AccumulationDistributionIndicatorStrategy, 'AccumulationDistributionIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AccumulationDistributionIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new AccumulationDistributionIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return AccumulationDistributionIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
AccumulationDistributionIndicator.$t = markType(AccumulationDistributionIndicator, 'AccumulationDistributionIndicator', StrategyBasedIndicator.$);

var IgxAccumulationDistributionIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Accumulation/Distribution indicator series.
 * Default required members: Close, Low, High, Volume
*
* You can use the `IgxAccumulationDistributionIndicatorComponent` to evaluate the suppy and demand of a stock, security, or index.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-accumulation-distribution-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-accumulation-distribution-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxAccumulationDistributionIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxAccumulationDistributionIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent) }];
let IgxAccumulationDistributionIndicatorComponent = IgxAccumulationDistributionIndicatorComponent_1 = class IgxAccumulationDistributionIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AccumulationDistributionIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxAccumulationDistributionIndicatorComponent = IgxAccumulationDistributionIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-accumulation-distribution-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAccumulationDistributionIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAccumulationDistributionIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAccumulationDistributionIndicatorModule = class IgxAccumulationDistributionIndicatorModule {
};
IgxAccumulationDistributionIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxAccumulationDistributionIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxAccumulationDistributionIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxAccumulationDistributionIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAccumulationDistributionIndicatorDynamicModule = class IgxAccumulationDistributionIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAccumulationDistributionIndicatorComponent", IgxAccumulationDistributionIndicatorComponent);
        TypeRegistrar.register("AccumulationDistributionIndicator", AccumulationDistributionIndicator.$type);
    }
};
IgxAccumulationDistributionIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAccumulationDistributionIndicatorModule],
        exports: [IgxAccumulationDistributionIndicatorModule],
        entryComponents: [IgxAccumulationDistributionIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAccumulationDistributionIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AverageDirectionalIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("LowColumn");
        c.add("HighColumn");
        c.o(a.trueRange.basedOn);
        c.o(b.a.c);
        return c;
    }
    j(a, b, c) {
        return b.item(a) - b.item(a - 1);
    }
    i(a, b, c) {
        return c.item(a - 1) - c.item(a);
    }
    *_h(a, b) {
        yield 0;
        let c = 0;
        let d = 0;
        for (let e = 1; e < a.count; e++) {
            c = this.j(e, a, b);
            d = this.i(e, a, b);
            if (c > d && c > 0) {
                yield c;
            }
            else {
                yield 0;
            }
        }
    }
    h(a, b) {
        return toEnum(() => this._h(a, b));
    }
    *_f(a, b) {
        yield 0;
        let c = 0;
        let d = 0;
        for (let e = 1; e < a.count; e++) {
            c = this.j(e, a, b);
            d = this.i(e, a, b);
            if (d > c && d > 0) {
                yield d;
            }
            else {
                yield 0;
            }
        }
    }
    f(a, b) {
        return toEnum(() => this._f(a, b));
    }
    *_g(a, b) {
        let c = getEnumerator(b.a.b(this.h(a.highColumn, a.lowColumn), a.period));
        let d = getEnumerator(b.a.b(a.trueRange, a.period));
        while (c.moveNext() && d.moveNext()) {
            yield b.i(c.current / d.current);
        }
    }
    g(a, b) {
        return toEnum(() => this._g(a, b));
    }
    *_e(a, b) {
        let c = getEnumerator(b.a.b(this.f(a.highColumn, a.lowColumn), a.period));
        let d = getEnumerator(b.a.b(a.trueRange, a.period));
        while (c.moveNext() && d.moveNext()) {
            yield b.i(c.current / d.current);
        }
    }
    e(a, b) {
        return toEnum(() => this._e(a, b));
    }
    *_d(a, b) {
        let c = getEnumerator(this.g(a, b));
        let d = getEnumerator(this.e(a, b));
        c.moveNext();
        d.moveNext();
        while (c.moveNext() && d.moveNext()) {
            yield Math.abs(b.i((c.current - d.current) / (c.current + d.current)));
        }
    }
    d(a, b) {
        return toEnum(() => this._d(a, b));
    }
    *_c(a, b) {
        let c = getEnumerator(b.a.b(this.d(a, b), a.period));
        yield 0;
        while (c.moveNext()) {
            yield c.current * 100;
        }
    }
    c(a, b) {
        return toEnum(() => this._c(a, b));
    }
    a(a, b) {
        let c = getEnumerator(this.c(a, b));
        let d = a.indicatorColumn;
        for (let e = 0; e < d.count; e++) {
            if (c.moveNext()) {
                d.item(e, c.current);
            }
        }
        return true;
    }
}
AverageDirectionalIndexIndicatorStrategy.$t = markType(AverageDirectionalIndexIndicatorStrategy, 'AverageDirectionalIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AverageDirectionalIndexIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new AverageDirectionalIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return AverageDirectionalIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(AverageDirectionalIndexIndicator.q8));
    }
    set q7(a) {
        this.h(AverageDirectionalIndexIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
AverageDirectionalIndexIndicator.$t = markType(AverageDirectionalIndexIndicator, 'AverageDirectionalIndexIndicator', StrategyBasedIndicator.$);
AverageDirectionalIndexIndicator.q8 = StrategyBasedIndicator.q4(14, AverageDirectionalIndexIndicator.$);

var IgxAverageDirectionalIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Average Directional indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgxAverageDirectionalIndexIndicatorComponent` to measures trend strength without regard to trend direction.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-average-directional-index-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-average-directional-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxAverageDirectionalIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxAverageDirectionalIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent) }];
let IgxAverageDirectionalIndexIndicatorComponent = IgxAverageDirectionalIndexIndicatorComponent_1 = class IgxAverageDirectionalIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AverageDirectionalIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current AverageDirectionalIndexIndicator object.
     * The typical, and initial, value for AverageDirectionalIndexIndicator periods is 14.
    *
    * You can use the `period` to set the moving average.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-average-directional-index-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		period="14">
    *     </igx-average-directional-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 14;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAverageDirectionalIndexIndicatorComponent.prototype, "period", null);
IgxAverageDirectionalIndexIndicatorComponent = IgxAverageDirectionalIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-average-directional-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAverageDirectionalIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAverageDirectionalIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAverageDirectionalIndexIndicatorModule = class IgxAverageDirectionalIndexIndicatorModule {
};
IgxAverageDirectionalIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxAverageDirectionalIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxAverageDirectionalIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxAverageDirectionalIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAverageDirectionalIndexIndicatorDynamicModule = class IgxAverageDirectionalIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAverageDirectionalIndexIndicatorComponent", IgxAverageDirectionalIndexIndicatorComponent);
        TypeRegistrar.register("AverageDirectionalIndexIndicator", AverageDirectionalIndexIndicator.$type);
    }
};
IgxAverageDirectionalIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAverageDirectionalIndexIndicatorModule],
        exports: [IgxAverageDirectionalIndexIndicatorModule],
        entryComponents: [IgxAverageDirectionalIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAverageDirectionalIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AverageTrueRangeIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.trueRange.basedOn);
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = 0;
        for (let d of fromEnum(b.a.b(a.trueRange, a.period))) {
            a.indicatorColumn.item(c, d);
            ++c;
        }
        return true;
    }
}
AverageTrueRangeIndicatorStrategy.$t = markType(AverageTrueRangeIndicatorStrategy, 'AverageTrueRangeIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AverageTrueRangeIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new AverageTrueRangeIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return AverageTrueRangeIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(AverageTrueRangeIndicator.q8));
    }
    set q7(a) {
        this.h(AverageTrueRangeIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
AverageTrueRangeIndicator.$t = markType(AverageTrueRangeIndicator, 'AverageTrueRangeIndicator', StrategyBasedIndicator.$);
AverageTrueRangeIndicator.q8 = StrategyBasedIndicator.q4(14, AverageTrueRangeIndicator.$);

var IgxAverageTrueRangeIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Average True Range indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgxAverageTrueRangeIndicatorComponent` to measures a security's degree of price movement or volatility within a given period of time.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-average-true-range-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-average-true-range-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxAverageTrueRangeIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxAverageTrueRangeIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent) }];
let IgxAverageTrueRangeIndicatorComponent = IgxAverageTrueRangeIndicatorComponent_1 = class IgxAverageTrueRangeIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AverageTrueRangeIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
     * The typical, and initial, value for AverageTrueRange periods is 14.
    *
    * You can use the `period` to set the moving average.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-average-true-range-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		period="14">
    *     </igx-average-true-range-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 14;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAverageTrueRangeIndicatorComponent.prototype, "period", null);
IgxAverageTrueRangeIndicatorComponent = IgxAverageTrueRangeIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-average-true-range-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAverageTrueRangeIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAverageTrueRangeIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAverageTrueRangeIndicatorModule = class IgxAverageTrueRangeIndicatorModule {
};
IgxAverageTrueRangeIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxAverageTrueRangeIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxAverageTrueRangeIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxAverageTrueRangeIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAverageTrueRangeIndicatorDynamicModule = class IgxAverageTrueRangeIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAverageTrueRangeIndicatorComponent", IgxAverageTrueRangeIndicatorComponent);
        TypeRegistrar.register("AverageTrueRangeIndicator", AverageTrueRangeIndicator.$type);
    }
};
IgxAverageTrueRangeIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAverageTrueRangeIndicatorModule],
        exports: [IgxAverageTrueRangeIndicatorModule],
        entryComponents: [IgxAverageTrueRangeIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAverageTrueRangeIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BollingerBandWidthIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.c.c);
        c.o(b.d.c);
        return c;
    }
    a(a, b) {
        let c = getEnumerator(b.c.b(a.typicalColumn, a.period));
        let d = getEnumerator(b.d.b(a.typicalColumn, a.period));
        let e = a.multiplier;
        let f = a.indicatorColumn;
        let g = 0;
        while (c.moveNext() && d.moveNext()) {
            let h = d.current * e;
            let i = c.current + h;
            let j = c.current - h;
            let k = c.current;
            let l = b.i((i - j) / k);
            f.item(g, l);
            g++;
        }
        return true;
    }
}
BollingerBandWidthIndicatorStrategy.$t = markType(BollingerBandWidthIndicatorStrategy, 'BollingerBandWidthIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BollingerBandWidthIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new BollingerBandWidthIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return BollingerBandWidthIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q8() {
        return typeGetValue(this.c(BollingerBandWidthIndicator.rb));
    }
    set q8(a) {
        this.h(BollingerBandWidthIndicator.rb, a);
    }
    qs() {
        return this.q8;
    }
    get q7() {
        return this.c(BollingerBandWidthIndicator.ra);
    }
    set q7(a) {
        this.h(BollingerBandWidthIndicator.ra, a);
    }
    qq() {
        return this.q7;
    }
}
BollingerBandWidthIndicator.$t = markType(BollingerBandWidthIndicator, 'BollingerBandWidthIndicator', StrategyBasedIndicator.$);
BollingerBandWidthIndicator.rb = StrategyBasedIndicator.q4(20, BollingerBandWidthIndicator.$);
BollingerBandWidthIndicator.ra = StrategyBasedIndicator.q3(2, BollingerBandWidthIndicator.$);

var IgxBollingerBandWidthIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
 * Represents the normalized width of the Bollinger bands for each provided value.
 * For more info see: BollingerBandsOverlay
 * Default required members: High, Low, Close
*
* You can use the `IgxBollingerBandWidthIndicatorComponent` to represents a IgxDataChartComponent Bollinger Bandwidth indicator series.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-bollinger-band-width-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-bollinger-band-width-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxBollingerBandWidthIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxBollingerBandWidthIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent) }];
let IgxBollingerBandWidthIndicatorComponent = IgxBollingerBandWidthIndicatorComponent_1 = class IgxBollingerBandWidthIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new BollingerBandWidthIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the Bollinger Band Width Indicator.
     * The typical, and initial, value for CCI periods is 20.
    *
    * You can use the `period` to set the moving average.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-bollinger-band-width-indicator
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		period="14">
    *     </igx-bollinger-band-width-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 14;
    * ```
    */
    get period() {
        return this.i.q8;
    }
    set period(v) {
        this.i.q8 = +v;
    }
    /**
     * Gets or sets the multiplier for the Bollinger Band width.
     * The typical, and initial, value for Bollinger Band width multiplier is 2.
    *
    * Use the `multiplier` property for the Bollinger Band width. The typical, and initial, value for Bollinger Band width multiplier is 2.
    *
    * ```ts
    * this.series.multiplier = 14;
    * ```
    */
    get multiplier() {
        return this.i.q7;
    }
    set multiplier(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBollingerBandWidthIndicatorComponent.prototype, "period", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBollingerBandWidthIndicatorComponent.prototype, "multiplier", null);
IgxBollingerBandWidthIndicatorComponent = IgxBollingerBandWidthIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-bollinger-band-width-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandWidthIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBollingerBandWidthIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBollingerBandWidthIndicatorModule = class IgxBollingerBandWidthIndicatorModule {
};
IgxBollingerBandWidthIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxBollingerBandWidthIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxBollingerBandWidthIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxBollingerBandWidthIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBollingerBandWidthIndicatorDynamicModule = class IgxBollingerBandWidthIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBollingerBandWidthIndicatorComponent", IgxBollingerBandWidthIndicatorComponent);
        TypeRegistrar.register("BollingerBandWidthIndicator", BollingerBandWidthIndicator.$type);
    }
};
IgxBollingerBandWidthIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBollingerBandWidthIndicatorModule],
        exports: [IgxBollingerBandWidthIndicatorModule],
        entryComponents: [IgxBollingerBandWidthIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBollingerBandWidthIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChaikinOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super();
        this.c = null;
        this.c = new AccumulationDistributionIndicatorStrategy();
    }
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = a.indicatorColumn;
        let d = this.c.c(a, b);
        let e = getEnumerator(b.a.b(d, a.shortPeriod));
        let f = getEnumerator(b.a.b(d, a.longPeriod));
        let g = 0;
        while (e.moveNext() && f.moveNext()) {
            let h = e.current - f.current;
            c.item(g, h);
            g++;
        }
        return true;
    }
}
ChaikinOscillatorIndicatorStrategy.$t = markType(ChaikinOscillatorIndicatorStrategy, 'ChaikinOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChaikinOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new ChaikinOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return ChaikinOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.q8));
    }
    set shortPeriod(a) {
        this.h(ChaikinOscillatorIndicator.q8, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(ChaikinOscillatorIndicator.q7));
    }
    set longPeriod(a) {
        this.h(ChaikinOscillatorIndicator.q7, a);
    }
    qr() {
        return this.longPeriod;
    }
}
ChaikinOscillatorIndicator.$t = markType(ChaikinOscillatorIndicator, 'ChaikinOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
ChaikinOscillatorIndicator.q8 = StrategyBasedIndicator.q6(3, ChaikinOscillatorIndicator.$);
ChaikinOscillatorIndicator.q7 = StrategyBasedIndicator.q2(10, ChaikinOscillatorIndicator.$);

var IgxChaikinOscillatorIndicatorComponent_1;
/**
 * Represents the IgxDataChartComponent Chaikin Oscillator indicator series.
 * Default required members: Close, Low, High, Volume
*
* `IgxChaikinOscillatorIndicatorComponent` class specify the series as Chaikin Oscillator Indicator series.
*
* ```html
* <igx-data-chart [dataSource]="data">
*   <igx-category-x-axis #xAxis
*     label="time">
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis>
*   </igx-numeric-y-axis>
*   <igx-chaikin-oscillator-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume"
*     longPeriod="30">
*   </igx-chaikin-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxChaikinOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxChaikinOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent) }];
let IgxChaikinOscillatorIndicatorComponent = IgxChaikinOscillatorIndicatorComponent_1 = class IgxChaikinOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ChaikinOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the short moving average period for the current ChaikinOscillatorIndicator object.
     * The typical, and initial, value for short CHO periods is 3.
    *
    * Set the `shortPeriod` property if you wish to change the short moving average period for the indicator.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-chaikin-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     shortPeriod="5">
    *   </igx-chaikin-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shortPeriod = 30;
    * ```
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * Gets or sets the long moving average period for the current ChaikinOscillatorIndicator object.
     * The typical, and initial, value for long CHO periods is 10.
    *
    * Set the `longPeriod` property if you wish to change the long moving average period for the indicator.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-chaikin-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     longPeriod="30" >
    *   </igx-chaikin-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod = 30;
    * ```
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxChaikinOscillatorIndicatorComponent.prototype, "shortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxChaikinOscillatorIndicatorComponent.prototype, "longPeriod", null);
IgxChaikinOscillatorIndicatorComponent = IgxChaikinOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-chaikin-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxChaikinOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxChaikinOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxChaikinOscillatorIndicatorModule = class IgxChaikinOscillatorIndicatorModule {
};
IgxChaikinOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxChaikinOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxChaikinOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxChaikinOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxChaikinOscillatorIndicatorDynamicModule = class IgxChaikinOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxChaikinOscillatorIndicatorComponent", IgxChaikinOscillatorIndicatorComponent);
        TypeRegistrar.register("ChaikinOscillatorIndicator", ChaikinOscillatorIndicator.$type);
    }
};
IgxChaikinOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxChaikinOscillatorIndicatorModule],
        exports: [IgxChaikinOscillatorIndicatorModule],
        entryComponents: [IgxChaikinOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxChaikinOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChaikinVolatilityIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = b.j((d) => a.highColumn.item(d) - a.lowColumn.item(d), a.count);
        let d = getEnumerator(b.a.b(c, a.period));
        let e = a.indicatorColumn;
        let f = new Array(a.period);
        for (let g = 0; g < a.period; g++) {
            f[g] = 0;
        }
        let h = 0;
        while (d.moveNext()) {
            let i = h % a.period;
            let j = b.i((d.current - f[i]) / (f[i] * 100));
            if (h < a.period) {
                e.item(h, 0);
            }
            else {
                e.item(h, j);
            }
            f[i] = d.current;
            h++;
        }
        return true;
    }
}
ChaikinVolatilityIndicatorStrategy.$t = markType(ChaikinVolatilityIndicatorStrategy, 'ChaikinVolatilityIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChaikinVolatilityIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new ChaikinVolatilityIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return ChaikinVolatilityIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(ChaikinVolatilityIndicator.q8));
    }
    set q7(a) {
        this.h(ChaikinVolatilityIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
ChaikinVolatilityIndicator.$t = markType(ChaikinVolatilityIndicator, 'ChaikinVolatilityIndicator', StrategyBasedIndicator.$);
ChaikinVolatilityIndicator.q8 = StrategyBasedIndicator.q4(10, ChaikinVolatilityIndicator.$);

var IgxChaikinVolatilityIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Chaikin Volatility indicator series.
 * The ChaikinVolatility indicator attempts to show volatility by displaying the spread between
 * the high and low values.
 * Default required members: High, Low
*
* `IgxChaikinVolatilityIndicatorComponent` class specify the series as Chaikin Volitility Indicator series.
*
* ```html
* <igx-data-chart [dataSource]="data">
*   <igx-category-x-axis #xAxis
*     label="time">
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis>
*   </igx-numeric-y-axis>
*
*   <igx-chaikin-volatility-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume"   >
*   </igx-chaikin-volatility-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxChaikinVolatilityIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxChaikinVolatilityIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent) }];
let IgxChaikinVolatilityIndicatorComponent = IgxChaikinVolatilityIndicatorComponent_1 = class IgxChaikinVolatilityIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ChaikinVolatilityIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current ChaikinVolatilityIndicator object.
     * The typical, and initial, value for ChaikinVolatilityIndicator periods is 10.
    *
    * Set the `period` property if you wish to change the moving average period for the indicator.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-chaikin-volatility-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     period="30">
    *   </igx-chaikin-volatility-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxChaikinVolatilityIndicatorComponent.prototype, "period", null);
IgxChaikinVolatilityIndicatorComponent = IgxChaikinVolatilityIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-chaikin-volatility-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxChaikinVolatilityIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxChaikinVolatilityIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxChaikinVolatilityIndicatorModule = class IgxChaikinVolatilityIndicatorModule {
};
IgxChaikinVolatilityIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxChaikinVolatilityIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxChaikinVolatilityIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxChaikinVolatilityIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxChaikinVolatilityIndicatorDynamicModule = class IgxChaikinVolatilityIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxChaikinVolatilityIndicatorComponent", IgxChaikinVolatilityIndicatorComponent);
        TypeRegistrar.register("ChaikinVolatilityIndicator", ChaikinVolatilityIndicator.$type);
    }
};
IgxChaikinVolatilityIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxChaikinVolatilityIndicatorModule],
        exports: [IgxChaikinVolatilityIndicatorModule],
        entryComponents: [IgxChaikinVolatilityIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxChaikinVolatilityIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CommodityChannelIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.c.c);
        return c;
    }
    a(a, b) {
        let c = a.period;
        let d = a.typicalColumn;
        let e = a.indicatorColumn;
        let f = getEnumerator(b.c.b(d, c));
        let g = getEnumerator(d);
        let h = new Array(c);
        for (let i = 0; i < c; i++) {
            h[i] = 0;
        }
        let j = 0;
        while (g.moveNext() && f.moveNext()) {
            h[j % c] = g.current;
            let k = 0;
            for (let l = 0; l < c; ++l) {
                k += Math.abs(f.current - h[l]);
            }
            k /= c;
            e.item(j, b.i((g.current - f.current) / (0.015 * k)));
            ++j;
        }
        return true;
    }
}
CommodityChannelIndexIndicatorStrategy.$t = markType(CommodityChannelIndexIndicatorStrategy, 'CommodityChannelIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CommodityChannelIndexIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new CommodityChannelIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return CommodityChannelIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(CommodityChannelIndexIndicator.q8));
    }
    set q7(a) {
        this.h(CommodityChannelIndexIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
CommodityChannelIndexIndicator.$t = markType(CommodityChannelIndexIndicator, 'CommodityChannelIndexIndicator', StrategyBasedIndicator.$);
CommodityChannelIndexIndicator.q8 = StrategyBasedIndicator.q4(20, CommodityChannelIndexIndicator.$);

var IgxCommodityChannelIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Commodity Channel Index indicator series.
 * Default required members: High, Low, Close
*
* `IgxCommodityChannelIndexIndicatorComponent` class specify the series as Commodity Channel Index Indicator series.
*
* ```html
* <igx-data-chart [dataSource]="data">
*   <igx-category-x-axis #xAxis
*     label="time">
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis>
*   </igx-numeric-y-axis>
*
*   <igx-commodity-channel-index-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume"
*     longPeriod="30" >
*   </igx-commodity-channel-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxCommodityChannelIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxCommodityChannelIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent) }];
let IgxCommodityChannelIndexIndicatorComponent = IgxCommodityChannelIndexIndicatorComponent_1 = class IgxCommodityChannelIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CommodityChannelIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current CCISeries object.
     * The typical, and initial, value for CCI periods is 20.
    *
    * ```html
    * <igx-data-chart [dataSource]="data">
    *   <igx-category-x-axis #xAxis
    *     label="time">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *   <igx-commodity-channel-index-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    *     volumeMemberPath="volume"
    *     period="30" >
    *   </igx-commodity-channel-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCommodityChannelIndexIndicatorComponent.prototype, "period", null);
IgxCommodityChannelIndexIndicatorComponent = IgxCommodityChannelIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-commodity-channel-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCommodityChannelIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCommodityChannelIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCommodityChannelIndexIndicatorModule = class IgxCommodityChannelIndexIndicatorModule {
};
IgxCommodityChannelIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxCommodityChannelIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxCommodityChannelIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxCommodityChannelIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCommodityChannelIndexIndicatorDynamicModule = class IgxCommodityChannelIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCommodityChannelIndexIndicatorComponent", IgxCommodityChannelIndexIndicatorComponent);
        TypeRegistrar.register("CommodityChannelIndexIndicator", CommodityChannelIndexIndicator.$type);
    }
};
IgxCommodityChannelIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCommodityChannelIndexIndicatorModule],
        exports: [IgxCommodityChannelIndexIndicatorModule],
        entryComponents: [IgxCommodityChannelIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCommodityChannelIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DetrendedPriceOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.o(b.c.c);
        return c;
    }
    a(a, b) {
        let c = a.period;
        let d = a.closeColumn;
        let e = a.indicatorColumn;
        let f = getEnumerator(b.c.b(d, c));
        let g = (intDivide(c, 2)) + 1;
        let h = new Array(g);
        for (let i = 0; i < g; i++) {
            h[i] = 0;
        }
        for (let j = 1; j < Math.min(g + 1, e.count); ++j) {
            let k = j % g;
            e.item(j, 0);
            f.moveNext();
            h[k] = f.current;
        }
        for (let l = g + 1; l < e.count; l++) {
            let m = l % g;
            e.item(l, d.item(l) - h[m]);
            f.moveNext();
            h[m] = f.current;
        }
        return true;
    }
}
DetrendedPriceOscillatorIndicatorStrategy.$t = markType(DetrendedPriceOscillatorIndicatorStrategy, 'DetrendedPriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DetrendedPriceOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new DetrendedPriceOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return DetrendedPriceOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(DetrendedPriceOscillatorIndicator.q8));
    }
    set q7(a) {
        this.h(DetrendedPriceOscillatorIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
DetrendedPriceOscillatorIndicator.$t = markType(DetrendedPriceOscillatorIndicator, 'DetrendedPriceOscillatorIndicator', StrategyBasedIndicator.$);
DetrendedPriceOscillatorIndicator.q8 = StrategyBasedIndicator.q4(20, DetrendedPriceOscillatorIndicator.$);

var IgxDetrendedPriceOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
 * Default required members: Close
*
* The `IgxDetrendedPriceOscillatorIndicatorComponent` class represents a IgxDataChartComponent Detrended Price Oscillator indicator series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis #xAxis
*         label="label">
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-detrended-price-oscillator-indicator
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         openMemberPath="open"
*         highMemberPath="high"
*         lowMemberPath="low"
*         closeMemberPath="close">
*     </igx-detrended-price-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxDetrendedPriceOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxDetrendedPriceOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent) }];
let IgxDetrendedPriceOscillatorIndicatorComponent = IgxDetrendedPriceOscillatorIndicatorComponent_1 = class IgxDetrendedPriceOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new DetrendedPriceOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current DetrendedPriceOscillatorIndicator object.
     * The typical, and initial, value for DPO periods is 20.
    *
    * You can use the `period` to set the current moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-detrended-price-oscillator-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close"
    * 		period=30>
    *     </igx-detrended-price-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDetrendedPriceOscillatorIndicatorComponent.prototype, "period", null);
IgxDetrendedPriceOscillatorIndicatorComponent = IgxDetrendedPriceOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-detrended-price-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxDetrendedPriceOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxDetrendedPriceOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDetrendedPriceOscillatorIndicatorModule = class IgxDetrendedPriceOscillatorIndicatorModule {
};
IgxDetrendedPriceOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxDetrendedPriceOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxDetrendedPriceOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxDetrendedPriceOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDetrendedPriceOscillatorIndicatorDynamicModule = class IgxDetrendedPriceOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxDetrendedPriceOscillatorIndicatorComponent", IgxDetrendedPriceOscillatorIndicatorComponent);
        TypeRegistrar.register("DetrendedPriceOscillatorIndicator", DetrendedPriceOscillatorIndicator.$type);
    }
};
IgxDetrendedPriceOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxDetrendedPriceOscillatorIndicatorModule],
        exports: [IgxDetrendedPriceOscillatorIndicatorModule],
        entryComponents: [IgxDetrendedPriceOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDetrendedPriceOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class EaseOfMovementIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = a.indicatorColumn;
        let d = a.highColumn;
        let e = a.lowColumn;
        let f = a.volumeColumn;
        let g = a.count;
        if (g > 0) {
            c.item(0, 0);
        }
        for (let h = 1; h < g; h++) {
            let i = (d.item(h) + e.item(h)) / 2;
            let j = (d.item(h - 1) + e.item(h - 1)) / 2;
            let k = i - j;
            let l = 10000;
            let m = b.i((f.item(h) / l) / (d.item(h) - e.item(h)));
            c.item(h, b.i(k / m));
        }
        return true;
    }
}
EaseOfMovementIndicatorStrategy.$t = markType(EaseOfMovementIndicatorStrategy, 'EaseOfMovementIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class EaseOfMovementIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new EaseOfMovementIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return EaseOfMovementIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
EaseOfMovementIndicator.$t = markType(EaseOfMovementIndicator, 'EaseOfMovementIndicator', StrategyBasedIndicator.$);

var IgxEaseOfMovementIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Ease of Movement indicator series.
 * The ease of movement indicator by Richard W. Arms, Jr relates the price change of an asset to
 * its volume. Normally smoothed with a moving average.
 * Default required members: Low, High, Volume
*
* The ease of movment indicator is used to analyze relationships between a price changes and volume. One would usually plot this in a separate chart below the main price chart. It can be added to a chart like this:
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-ordinal-time-x-axis
*     dateTimeMemberPath="TimeStamp"
*     #xAxis
*     >
*     </igx-ordinal-time-x-axis>
*     <igx-numeric-y-axis
*     #yAxis>
*     </igx-numeric-y-axis>
*
*     <igx-ease-of-movement-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     highMemberPath="High"
*     lowMemberPath="Low"
*     volumeMemberPath="Volume">
*     </igx-ease-of-movement-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxEaseOfMovementIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "High";
* series.lowMemberPath = "Low";
* series.volumeMemberPath = "Volume";
* series.dataSource = this.data;
* this.chart.series.add(series);
* ```
*/
const IgxEaseOfMovementIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent) }];
let IgxEaseOfMovementIndicatorComponent = IgxEaseOfMovementIndicatorComponent_1 = class IgxEaseOfMovementIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new EaseOfMovementIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxEaseOfMovementIndicatorComponent = IgxEaseOfMovementIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-ease-of-movement-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxEaseOfMovementIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxEaseOfMovementIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxEaseOfMovementIndicatorModule = class IgxEaseOfMovementIndicatorModule {
};
IgxEaseOfMovementIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxEaseOfMovementIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxEaseOfMovementIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxEaseOfMovementIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxEaseOfMovementIndicatorDynamicModule = class IgxEaseOfMovementIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxEaseOfMovementIndicatorComponent", IgxEaseOfMovementIndicatorComponent);
        TypeRegistrar.register("EaseOfMovementIndicator", EaseOfMovementIndicator.$type);
    }
};
IgxEaseOfMovementIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxEaseOfMovementIndicatorModule],
        exports: [IgxEaseOfMovementIndicatorModule],
        entryComponents: [IgxEaseOfMovementIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxEaseOfMovementIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentKCalculationStrategy extends StreamingIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    }
    *_c(a, b) {
        let c = a.period;
        let d = a.highColumn;
        let e = a.lowColumn;
        for (let f = 0; f < a.count; f++) {
            let g = Math.min(c, f);
            let h = -1.7976931348623157E+308;
            let i = 1.7976931348623157E+308;
            for (let j = 0; j < g; j++) {
                if (!isNaN_(d.item(f - j))) {
                    h = Math.max(h, d.item(f - j));
                }
                if (!isNaN_(e.item(f - j))) {
                    i = Math.min(i, e.item(f - j));
                }
            }
            yield b.i((a.closeColumn.item(f) - i) / (h - i) * 100);
        }
    }
    c(a, b) {
        return toEnum(() => this._c(a, b));
    }
    a(a, b) {
        let c = 0;
        for (let d of fromEnum(this.c(a, b))) {
            a.indicatorColumn.item(c, d);
            c++;
        }
        return true;
    }
}
PercentKCalculationStrategy.$t = markType(PercentKCalculationStrategy, 'PercentKCalculationStrategy', StreamingIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FastStochasticOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super();
        this.c = null;
        this.c = new PercentKCalculationStrategy();
    }
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        return c;
    }
    a(a, b) {
        let c = this.c.c(a, b);
        let d = 0;
        for (let e of fromEnum(c)) {
            a.indicatorColumn.item(d, e);
            d++;
        }
        return true;
    }
}
FastStochasticOscillatorIndicatorStrategy.$t = markType(FastStochasticOscillatorIndicatorStrategy, 'FastStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FastStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_qm() {
        return new FastStochasticOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return FastStochasticOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(FastStochasticOscillatorIndicator.q8));
    }
    set q7(a) {
        this.h(FastStochasticOscillatorIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
FastStochasticOscillatorIndicator.$t = markType(FastStochasticOscillatorIndicator, 'FastStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FastStochasticOscillatorIndicator.q8 = StrategyBasedIndicator.q4(14, FastStochasticOscillatorIndicator.$);

var IgxFastStochasticOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Fast Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*/
const IgxFastStochasticOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent) }];
let IgxFastStochasticOscillatorIndicatorComponent = IgxFastStochasticOscillatorIndicatorComponent_1 = class IgxFastStochasticOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new FastStochasticOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current FastStochasticOscillatorIndicator object.
     * The typical, and initial, value for FastStochasticOscillatorIndicator periods is 14.
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFastStochasticOscillatorIndicatorComponent.prototype, "period", null);
IgxFastStochasticOscillatorIndicatorComponent = IgxFastStochasticOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-fast-stochastic-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFastStochasticOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxFastStochasticOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFastStochasticOscillatorIndicatorModule = class IgxFastStochasticOscillatorIndicatorModule {
};
IgxFastStochasticOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxFastStochasticOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxFastStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxFastStochasticOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFastStochasticOscillatorIndicatorDynamicModule = class IgxFastStochasticOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxFastStochasticOscillatorIndicatorComponent", IgxFastStochasticOscillatorIndicatorComponent);
        TypeRegistrar.register("FastStochasticOscillatorIndicator", FastStochasticOscillatorIndicator.$type);
    }
};
IgxFastStochasticOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxFastStochasticOscillatorIndicatorModule],
        exports: [IgxFastStochasticOscillatorIndicatorModule],
        entryComponents: [IgxFastStochasticOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFastStochasticOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ForceIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        c.o(b.a.c);
        return c;
    }
    *_c(a) {
        let b = 0;
        let c = a.closeColumn;
        let d = a.volumeColumn;
        let e = a.indicatorColumn;
        if (c != null && d != null) {
            b = Math.min(c.count, d.count);
        }
        if (b > 0) {
            yield 0;
        }
        for (let f = 1; f < b; ++f) {
            yield d.item(f) * (c.item(f) - c.item(f - 1));
        }
    }
    c(a) {
        return toEnum(() => this._c(a));
    }
    a(a, b) {
        let c = this.c(a);
        let d = a.period;
        let e = a.indicatorColumn;
        if (d != 0 && !isNaN_(d) && !isInfinity(d)) {
            c = b.a.b(c, a.period);
        }
        let f = 0;
        for (let g of fromEnum(c)) {
            e.item(f, g);
            ++f;
        }
        return true;
    }
}
ForceIndexIndicatorStrategy.$t = markType(ForceIndexIndicatorStrategy, 'ForceIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ForceIndexIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 1;
    }
    get_qm() {
        return new ForceIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return ForceIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(ForceIndexIndicator.q8));
    }
    set q7(a) {
        this.h(ForceIndexIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
ForceIndexIndicator.$t = markType(ForceIndexIndicator, 'ForceIndexIndicator', StrategyBasedIndicator.$);
ForceIndexIndicator.q8 = StrategyBasedIndicator.q4(0, ForceIndexIndicator.$);

var IgxForceIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Force Index indicator series.
 * Default required members: Close, Volume
*
* The `IgxForceIndexIndicatorComponent` represents a IgxDataChartComponent Force Index indicator series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis #xAxis
*         label="label">
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-force-index-indicator
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         openMemberPath="open"
*         highMemberPath="high"
*         lowMemberPath="low"
*         closeMemberPath="close">
*     </igx-force-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxForceIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);;
* ```
*/
const IgxForceIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent) }];
let IgxForceIndexIndicatorComponent = IgxForceIndexIndicatorComponent_1 = class IgxForceIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ForceIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
     * The typical, and initial, value for ForceIndiex periods is 0.
    *
    * You can use the `period` property to get the moving average period of the current FullStochasticOscillatorIndicator object
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-force-index-indicator
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close"
    * 		period=30>
    *     </igx-force-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxForceIndexIndicatorComponent.prototype, "period", null);
IgxForceIndexIndicatorComponent = IgxForceIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-force-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxForceIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxForceIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxForceIndexIndicatorModule = class IgxForceIndexIndicatorModule {
};
IgxForceIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxForceIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxForceIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxForceIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxForceIndexIndicatorDynamicModule = class IgxForceIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxForceIndexIndicatorComponent", IgxForceIndexIndicatorComponent);
        TypeRegistrar.register("ForceIndexIndicator", ForceIndexIndicator.$type);
    }
};
IgxForceIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxForceIndexIndicatorModule],
        exports: [IgxForceIndexIndicatorModule],
        entryComponents: [IgxForceIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxForceIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FullStochasticOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super();
        this.c = null;
        this.c = new PercentKCalculationStrategy();
    }
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = this.c.c(a, b);
        let d = b.a.b(c, a.shortPeriod);
        let e = 0;
        for (let f of fromEnum(d)) {
            a.indicatorColumn.item(e, f);
            e++;
        }
        return true;
    }
}
FullStochasticOscillatorIndicatorStrategy.$t = markType(FullStochasticOscillatorIndicatorStrategy, 'FullStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FullStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_qm() {
        return new FullStochasticOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return FullStochasticOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.rc));
    }
    set q7(a) {
        this.h(FullStochasticOscillatorIndicator.rc, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
    get smoothingPeriod() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.rd));
    }
    set smoothingPeriod(a) {
        this.h(FullStochasticOscillatorIndicator.rd, a);
    }
    qu() {
        return this.smoothingPeriod;
    }
    get q9() {
        return typeGetValue(this.c(FullStochasticOscillatorIndicator.re));
    }
    set q9(a) {
        this.h(FullStochasticOscillatorIndicator.re, a);
    }
    qr() {
        return this.q9;
    }
    p2() {
        return this.q9;
    }
}
FullStochasticOscillatorIndicator.$t = markType(FullStochasticOscillatorIndicator, 'FullStochasticOscillatorIndicator', StrategyBasedIndicator.$);
FullStochasticOscillatorIndicator.rc = StrategyBasedIndicator.q4(14, FullStochasticOscillatorIndicator.$);
FullStochasticOscillatorIndicator.rd = StrategyBasedIndicator.q5(3, FullStochasticOscillatorIndicator.$, "SmoothingPeriod");
FullStochasticOscillatorIndicator.re = StrategyBasedIndicator.q5(3, FullStochasticOscillatorIndicator.$, "TriggerPeriod");

var IgxFullStochasticOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*
* The `IgxFullStochasticOscillatorIndicatorComponent` class represents a IgxDataChartComponent Full Stochastic Oscillator indicator series.
*
* ```html
* <igx-data-chart  #chart
*     [dataSource]="data">
*     <igx-category-x-axis
*     label="label"
*     #xAxis
*     >
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
*     </igx-numeric-y-axis>
*     <igx-full-stochastic-oscillator-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close">
* </gx-full-stochastic-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxFullStochasticOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxFullStochasticOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent) }];
let IgxFullStochasticOscillatorIndicatorComponent = IgxFullStochasticOscillatorIndicatorComponent_1 = class IgxFullStochasticOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new FullStochasticOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current FullStochasticOscillatorIndicator object.
     * The typical, and initial, value for FullStochasticOscillatorIndicator periods is 14.
    *
    * You can use the `period` property for the moving average period of the current FullStochasticOscillatorIndicator object.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-full-stochastic-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    * 	period=30>
    * </gx-full-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
    /**
     * Gets or sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
     * The typical, and initial, value for FullStochasticOscillatorIndicator SmoothingPeriod is 3.
    *
    * The `smoothingPeriod` property to fets/sets the moving average SmoothingPeriod for the current FullStochasticOscillatorIndicator object.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-full-stochastic-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    * 	[smoothingPeriod]=30>
    * </gx-full-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.smoothingPeriod=30;
    * ```
    */
    get smoothingPeriod() {
        return this.i.smoothingPeriod;
    }
    set smoothingPeriod(v) {
        this.i.smoothingPeriod = +v;
    }
    /**
     * Gets or sets the moving average TriggerPeriod for the current FullStochasticOscillatorIndicator object.
     * The typical, and initial, value for FullStochasticOscillatorIndicator TriggerPeriod is 3.
    *
    * You can use the `period` to set the current moving average period.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-full-stochastic-oscillator-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    * 	[triggerPeriod]=30>
    * </gx-full-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.triggerPeriod = 30;
    * ```
    */
    get triggerPeriod() {
        return this.i.q9;
    }
    set triggerPeriod(v) {
        this.i.q9 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFullStochasticOscillatorIndicatorComponent.prototype, "period", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFullStochasticOscillatorIndicatorComponent.prototype, "smoothingPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFullStochasticOscillatorIndicatorComponent.prototype, "triggerPeriod", null);
IgxFullStochasticOscillatorIndicatorComponent = IgxFullStochasticOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-full-stochastic-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFullStochasticOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxFullStochasticOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFullStochasticOscillatorIndicatorModule = class IgxFullStochasticOscillatorIndicatorModule {
};
IgxFullStochasticOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxFullStochasticOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxFullStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxFullStochasticOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFullStochasticOscillatorIndicatorDynamicModule = class IgxFullStochasticOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxFullStochasticOscillatorIndicatorComponent", IgxFullStochasticOscillatorIndicatorComponent);
        TypeRegistrar.register("FullStochasticOscillatorIndicator", FullStochasticOscillatorIndicator.$type);
    }
};
IgxFullStochasticOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxFullStochasticOscillatorIndicatorModule],
        exports: [IgxFullStochasticOscillatorIndicatorModule],
        entryComponents: [IgxFullStochasticOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFullStochasticOscillatorIndicatorDynamicModule);

/**
 * Financial indicator base class for doing calculating an itemwize indicator.
 * An itemwise indicator's individual values don't depend on any other values in the
 * collection so can always be independently recalculated. Also, because of this, the
 * base class handles all the looping logic and inheritors only need to provide the
 * actual calculation.
*/
const IgxItemwiseStrategyBasedIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxItemwiseStrategyBasedIndicatorComponent) }];
class IgxItemwiseStrategyBasedIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemwiseStrategyCalculationStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super(...arguments);
        this.c = null;
    }
    b(a, b) {
        return this.c.b(a, b);
    }
    a(a, b) {
        let c = true;
        for (let d = a.calculateFrom; d < a.calculateFrom + a.calculateCount; d++) {
            c = this.c.a(a, b, d);
            if (!c) {
                return false;
            }
        }
        return c;
    }
}
ItemwiseStrategyCalculationStrategy.$t = markType(ItemwiseStrategyCalculationStrategy, 'ItemwiseStrategyCalculationStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemwiseStrategyBasedIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
    }
    get_qm() {
        return new ItemwiseStrategyCalculationStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    q0() {
        super.q0();
        this.q7 = this.q8;
        this.ql.c = this.q7;
    }
}
ItemwiseStrategyBasedIndicator.$t = markType(ItemwiseStrategyBasedIndicator, 'ItemwiseStrategyBasedIndicator', StrategyBasedIndicator.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemwiseIndicatorCalculationStrategy extends Base {
}
ItemwiseIndicatorCalculationStrategy.$t = markType(ItemwiseIndicatorCalculationStrategy, 'ItemwiseIndicatorCalculationStrategy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarketFacilitationIndexIndicatorStrategy extends ItemwiseIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b, c) {
        a.indicatorColumn.item(c, b.i((a.highColumn.item(c) - a.lowColumn.item(c)) / a.volumeColumn.item(c)));
        return true;
    }
}
MarketFacilitationIndexIndicatorStrategy.$t = markType(MarketFacilitationIndexIndicatorStrategy, 'MarketFacilitationIndexIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarketFacilitationIndexIndicator extends ItemwiseStrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 1;
    }
    get_q8() {
        return new MarketFacilitationIndexIndicatorStrategy();
    }
    get q8() {
        return this.get_q8();
    }
    get_qz() {
        return MarketFacilitationIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
MarketFacilitationIndexIndicator.$t = markType(MarketFacilitationIndexIndicator, 'MarketFacilitationIndexIndicator', ItemwiseStrategyBasedIndicator.$);

var IgxMarketFacilitationIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Market Facilitation Index indicator series.
 * The Market Facilitation Index (MFI) indicator is represented by
 * the difference of the high and the low for a bar divided by the volume.
 * Default required members: High, Low, Volume
*
* The Market Facilitation Index (MFI) indicator is represented by the difference of the high and the low for a bar divided by the volume.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-market-facilitation-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-market-facilitation-index-indicator>
* </igx-data-chart>
* ```
*/
const IgxMarketFacilitationIndexIndicatorComponent_PROVIDERS = [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent) }];
let IgxMarketFacilitationIndexIndicatorComponent = IgxMarketFacilitationIndexIndicatorComponent_1 = class IgxMarketFacilitationIndexIndicatorComponent extends IgxItemwiseStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new MarketFacilitationIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxMarketFacilitationIndexIndicatorComponent = IgxMarketFacilitationIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-market-facilitation-index-indicator',
        template: ``,
        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent_1) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMarketFacilitationIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxMarketFacilitationIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMarketFacilitationIndexIndicatorModule = class IgxMarketFacilitationIndexIndicatorModule {
};
IgxMarketFacilitationIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxMarketFacilitationIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxMarketFacilitationIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxMarketFacilitationIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMarketFacilitationIndexIndicatorDynamicModule = class IgxMarketFacilitationIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxMarketFacilitationIndexIndicatorComponent", IgxMarketFacilitationIndexIndicatorComponent);
        TypeRegistrar.register("MarketFacilitationIndexIndicator", MarketFacilitationIndexIndicator.$type);
    }
};
IgxMarketFacilitationIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxMarketFacilitationIndexIndicatorModule],
        exports: [IgxMarketFacilitationIndexIndicatorModule],
        entryComponents: [IgxMarketFacilitationIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxMarketFacilitationIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MassIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.o(b.a.c);
        return c;
    }
    c(a, b) {
        let c = new List$1(Number_$type, 0);
        for (let d = 0; d < (Math.min(a.count, b.count)); d++) {
            c.add(a.item(d) - b.item(d));
        }
        return c;
    }
    a(a, b) {
        let c = 9;
        let d = a.highColumn;
        let e = a.lowColumn;
        let f = a.indicatorColumn;
        let g = getEnumerator(b.a.b(this.c(d, e), c));
        let h = getEnumerator(b.a.b(b.a.b(this.c(d, e), c), c));
        let i = new Array(c);
        for (let j = 0; j < c; j++) {
            i[j] = 0;
        }
        let k = 0;
        for (let l = 0; l < f.count; l++) {
            let m = l % c;
            k -= i[m];
            g.moveNext();
            h.moveNext();
            let n = b.i(g.current / h.current);
            k += n;
            f.item(l, k);
            i[m] = n;
        }
        return true;
    }
}
MassIndexIndicatorStrategy.$t = markType(MassIndexIndicatorStrategy, 'MassIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MassIndexIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new MassIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return MassIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
MassIndexIndicator.$t = markType(MassIndexIndicator, 'MassIndexIndicator', StrategyBasedIndicator.$);

var IgxMassIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Mass Index indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Mass Index indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-mass-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-mass-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMassIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
const IgxMassIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent) }];
let IgxMassIndexIndicatorComponent = IgxMassIndexIndicatorComponent_1 = class IgxMassIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new MassIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxMassIndexIndicatorComponent = IgxMassIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-mass-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMassIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxMassIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMassIndexIndicatorModule = class IgxMassIndexIndicatorModule {
};
IgxMassIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxMassIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxMassIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxMassIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMassIndexIndicatorDynamicModule = class IgxMassIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxMassIndexIndicatorComponent", IgxMassIndexIndicatorComponent);
        TypeRegistrar.register("MassIndexIndicator", MassIndexIndicator.$type);
    }
};
IgxMassIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxMassIndexIndicatorModule],
        exports: [IgxMassIndexIndicatorModule],
        entryComponents: [IgxMassIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxMassIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MedianPriceIndicatorStrategy extends ItemwiseIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        return c;
    }
    a(a, b, c) {
        a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c)) / 2);
        return true;
    }
}
MedianPriceIndicatorStrategy.$t = markType(MedianPriceIndicatorStrategy, 'MedianPriceIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MedianPriceIndicator extends ItemwiseStrategyBasedIndicator {
    get_q8() {
        return new MedianPriceIndicatorStrategy();
    }
    get q8() {
        return this.get_q8();
    }
    get_qz() {
        return MedianPriceIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
MedianPriceIndicator.$t = markType(MedianPriceIndicator, 'MedianPriceIndicator', ItemwiseStrategyBasedIndicator.$);

var IgxMedianPriceIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Median Price indicator series.
 * Default required members: High, Low
*
* Represents a Ignite UIDataChart Median Price indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-median-price-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-median-price-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMedianPriceIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
const IgxMedianPriceIndicatorComponent_PROVIDERS = [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent) }];
let IgxMedianPriceIndicatorComponent = IgxMedianPriceIndicatorComponent_1 = class IgxMedianPriceIndicatorComponent extends IgxItemwiseStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new MedianPriceIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxMedianPriceIndicatorComponent = IgxMedianPriceIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-median-price-indicator',
        template: ``,
        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent_1) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMedianPriceIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxMedianPriceIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMedianPriceIndicatorModule = class IgxMedianPriceIndicatorModule {
};
IgxMedianPriceIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxMedianPriceIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxMedianPriceIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxMedianPriceIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMedianPriceIndicatorDynamicModule = class IgxMedianPriceIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxMedianPriceIndicatorComponent", IgxMedianPriceIndicatorComponent);
        TypeRegistrar.register("MedianPriceIndicator", MedianPriceIndicator.$type);
    }
};
IgxMedianPriceIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxMedianPriceIndicatorModule],
        exports: [IgxMedianPriceIndicatorModule],
        entryComponents: [IgxMedianPriceIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxMedianPriceIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MoneyFlowIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = a.typicalColumn.getEnumerator();
        let d = getEnumerator(a.volumeColumn);
        let e = a.period;
        let f = 0;
        let g = new Array(e);
        for (f = 0; f < e; f++) {
            g[f] = 0;
        }
        let h = 0;
        let i = new Array(e);
        for (f = 0; f < e; f++) {
            i[f] = 0;
        }
        let j = 0;
        let k = 0;
        f = 0;
        while (c.moveNext() && d.moveNext()) {
            let l = f % e;
            let m = c.current * d.current;
            h -= g[l];
            j -= i[l];
            switch (Math.sign(m - k)) {
                case -1:
                    g[l] = 0;
                    i[l] = m;
                    break;
                case 0:
                    g[l] = 0;
                    i[l] = 0;
                    break;
                case 1:
                    g[l] = m;
                    i[l] = 0;
                    break;
            }
            h += g[l];
            j += i[l];
            let n = b.i(100 * h / (h + j));
            a.indicatorColumn.item(f, n);
            k = m;
            ++f;
        }
        return true;
    }
}
MoneyFlowIndexIndicatorStrategy.$t = markType(MoneyFlowIndexIndicatorStrategy, 'MoneyFlowIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MoneyFlowIndexIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 1;
    }
    get_qm() {
        return new MoneyFlowIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return MoneyFlowIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(MoneyFlowIndexIndicator.q8));
    }
    set q7(a) {
        this.h(MoneyFlowIndexIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
MoneyFlowIndexIndicator.$t = markType(MoneyFlowIndexIndicator, 'MoneyFlowIndexIndicator', StrategyBasedIndicator.$);
MoneyFlowIndexIndicator.q8 = StrategyBasedIndicator.q4(14, MoneyFlowIndexIndicator.$);

var IgxMoneyFlowIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Money Flow Index indicator series.
 * Default required members: Close, Low, High, Volume
*
* Represents a Ignite UIDataChart Money Flow Index indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-money-flow-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
* 		openMemberPath="open"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close"
* 		volumeMemberPath="volume">
*     </igx-money-flow-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMoneyFlowIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath="open"
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath="close"
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
const IgxMoneyFlowIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent) }];
let IgxMoneyFlowIndexIndicatorComponent = IgxMoneyFlowIndexIndicatorComponent_1 = class IgxMoneyFlowIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new MoneyFlowIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
     * The typical, and initial, value for MoneyFlowIndexIndicator periods is 14.
    *
    * Gets or sets the moving average period for the current MoneyFlowIndexIndicator object.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-money-flow-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume"
    * 		period="14">
    *     </igx-money-flow-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 14;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMoneyFlowIndexIndicatorComponent.prototype, "period", null);
IgxMoneyFlowIndexIndicatorComponent = IgxMoneyFlowIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-money-flow-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMoneyFlowIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxMoneyFlowIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMoneyFlowIndexIndicatorModule = class IgxMoneyFlowIndexIndicatorModule {
};
IgxMoneyFlowIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxMoneyFlowIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxMoneyFlowIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxMoneyFlowIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMoneyFlowIndexIndicatorDynamicModule = class IgxMoneyFlowIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxMoneyFlowIndexIndicatorComponent", IgxMoneyFlowIndexIndicatorComponent);
        TypeRegistrar.register("MoneyFlowIndexIndicator", MoneyFlowIndexIndicator.$type);
    }
};
IgxMoneyFlowIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxMoneyFlowIndexIndicatorModule],
        exports: [IgxMoneyFlowIndexIndicatorModule],
        entryComponents: [IgxMoneyFlowIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxMoneyFlowIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MovingAverageConvergenceDivergenceIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = a.typicalColumn;
        let d = a.indicatorColumn;
        let e = a.shortPeriod;
        let f = a.longPeriod;
        let g = getEnumerator(b.a.b(c, e));
        let h = getEnumerator(b.a.b(c, f));
        let i = 0;
        while (g.moveNext() && h.moveNext()) {
            let j = b.i(g.current - h.current);
            d.item(i, j);
            i++;
        }
        return true;
    }
}
MovingAverageConvergenceDivergenceIndicatorStrategy.$t = markType(MovingAverageConvergenceDivergenceIndicatorStrategy, 'MovingAverageConvergenceDivergenceIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MovingAverageConvergenceDivergenceIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 9;
        this.pu = 1;
    }
    get_qm() {
        return new MovingAverageConvergenceDivergenceIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return MovingAverageConvergenceDivergenceIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.ra));
    }
    set shortPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.ra, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.q9));
    }
    set longPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.q9, a);
    }
    qr() {
        return this.longPeriod;
    }
    get signalPeriod() {
        return typeGetValue(this.c(MovingAverageConvergenceDivergenceIndicator.rb));
    }
    set signalPeriod(a) {
        this.h(MovingAverageConvergenceDivergenceIndicator.rb, a);
    }
    p2() {
        return this.signalPeriod;
    }
}
MovingAverageConvergenceDivergenceIndicator.$t = markType(MovingAverageConvergenceDivergenceIndicator, 'MovingAverageConvergenceDivergenceIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
MovingAverageConvergenceDivergenceIndicator.ra = StrategyBasedIndicator.q6(10, MovingAverageConvergenceDivergenceIndicator.$);
MovingAverageConvergenceDivergenceIndicator.q9 = StrategyBasedIndicator.q2(30, MovingAverageConvergenceDivergenceIndicator.$);
MovingAverageConvergenceDivergenceIndicator.rb = StrategyBasedIndicator.q5(9, MovingAverageConvergenceDivergenceIndicator.$, "SignalPeriod");

var IgxMovingAverageConvergenceDivergenceIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Moving Average Convergence/Divergence (MACD) indicator series.
 * Default required members: High, Low, Close
*
* Represents a Ignite UIDataChart Moving Average Convergence/Divergence (MACD) indicator series.
*
* Example:
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-moving-average-convergence-divergence-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
* 		openMemberPath="open"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close"
* 		volumeMemberPath="volume">
*     </gx-moving-average-convergence-divergence-indicatorr>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxMovingAverageConvergenceDivergenceIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath="open"
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath="close"
* series.volumeMemberPath= "volume";
* this.chart.series.add(series);
* ```
*/
const IgxMovingAverageConvergenceDivergenceIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent) }];
let IgxMovingAverageConvergenceDivergenceIndicatorComponent = IgxMovingAverageConvergenceDivergenceIndicatorComponent_1 = class IgxMovingAverageConvergenceDivergenceIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new MovingAverageConvergenceDivergenceIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
     * The typical, and initial, value for short MACD periods is 10.
    *
    * Gets or sets the short moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-moving-average-convergence-divergence-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume"
    * 		shortPeriod="10">
    *     </gx-moving-average-convergence-divergence-indicatorr>
    * </igx-data-chart>
    * ```
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
     * The typical, and initial, value for long MACD periods is 30.
    *
    * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-moving-average-convergence-divergence-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume"
    * 		longPeriod="30">
    *     </gx-moving-average-convergence-divergence-indicatorr>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod="30" ;
    * ```
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
    /**
     * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
     * The typical, and initial, value for long PVO periods is 30.
    *
    * Gets or sets the long moving average period for the current MovingAverageConvergenceDivergenceIndicator object.
    *
    * Example:
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-moving-average-convergence-divergence-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    * 		openMemberPath="open"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		volumeMemberPath="volume"
    * 		signalPeriod="30">
    *     </gx-moving-average-convergence-divergence-indicatorr>
    * </igx-data-chart>
    * ```
    */
    get signalPeriod() {
        return this.i.signalPeriod;
    }
    set signalPeriod(v) {
        this.i.signalPeriod = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "shortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "longPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxMovingAverageConvergenceDivergenceIndicatorComponent.prototype, "signalPeriod", null);
IgxMovingAverageConvergenceDivergenceIndicatorComponent = IgxMovingAverageConvergenceDivergenceIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-moving-average-convergence-divergence-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxMovingAverageConvergenceDivergenceIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxMovingAverageConvergenceDivergenceIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMovingAverageConvergenceDivergenceIndicatorModule = class IgxMovingAverageConvergenceDivergenceIndicatorModule {
};
IgxMovingAverageConvergenceDivergenceIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxMovingAverageConvergenceDivergenceIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxMovingAverageConvergenceDivergenceIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxMovingAverageConvergenceDivergenceIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule = class IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxMovingAverageConvergenceDivergenceIndicatorComponent", IgxMovingAverageConvergenceDivergenceIndicatorComponent);
        TypeRegistrar.register("MovingAverageConvergenceDivergenceIndicator", MovingAverageConvergenceDivergenceIndicator.$type);
    }
};
IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxMovingAverageConvergenceDivergenceIndicatorModule],
        exports: [IgxMovingAverageConvergenceDivergenceIndicatorModule],
        entryComponents: [IgxMovingAverageConvergenceDivergenceIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NegativeVolumeIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = a.closeColumn;
        let d = a.volumeColumn;
        let e = a.indicatorColumn;
        let f = 0;
        let g = 0;
        let h = 0;
        if (e.count > 0) {
            e.item(0, f);
        }
        for (let i = 1; i < e.count; i++) {
            if (d.item(i) < d.item(i - 1)) {
                g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                if (h != 0) {
                    f += g * h;
                }
                else {
                    f += g;
                }
            }
            e.item(i, f);
            h = f;
        }
        return true;
    }
}
NegativeVolumeIndexIndicatorStrategy.$t = markType(NegativeVolumeIndexIndicatorStrategy, 'NegativeVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NegativeVolumeIndexIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new NegativeVolumeIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return NegativeVolumeIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
NegativeVolumeIndexIndicator.$t = markType(NegativeVolumeIndexIndicator, 'NegativeVolumeIndexIndicator', StrategyBasedIndicator.$);

var IgxNegativeVolumeIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Negative Volume Index indicator (NVI) series.
 * Default required members: Close, Volume
*
* The `IgxNegativeVolumeIndexIndicatorComponent` (NVI) is a finacial indicator frequently used in combination with the PositiveVolumeIndexIndicator. This calculation can be used to identify bull markets. These two indicators are based on the premise that smart money trades on low volume days and less informed or overly optimistic investors trade on high volume days.
*
* Using this indicator requires setting both the `CloseMemberPath` and `VolumeMemberPath`.
*
* ```html
* <igx-data-chart
*     width=500px
*     height=500px
*     [dataSource]="data" >
*     <igx-ordinal-time-x-axis
*         dateTimeMemberPath="TimeStamp"
*         #xAxis>
*       </igx-ordinal-time-x-axis>
*     <igx-numeric-y-axis
*        #yAxis></igx-numeric-y-axis>
*     <igx-negative-volume-index-indicator
*        [xAxis]="xAxis"
*        [yAxis]="yAxis"
*        volumeMemberPath="volume"
*        closeMemberPath="close">
*     </igx-negative-volume-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxNegativeVolumeIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.closeMemberPath = "Close";
* series.volumeMemberPath = "Volume";
* series.dataSource = this.data;
* this.chart.series.add(series);
* ```
*/
const IgxNegativeVolumeIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent) }];
let IgxNegativeVolumeIndexIndicatorComponent = IgxNegativeVolumeIndexIndicatorComponent_1 = class IgxNegativeVolumeIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NegativeVolumeIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxNegativeVolumeIndexIndicatorComponent = IgxNegativeVolumeIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-negative-volume-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxNegativeVolumeIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxNegativeVolumeIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNegativeVolumeIndexIndicatorModule = class IgxNegativeVolumeIndexIndicatorModule {
};
IgxNegativeVolumeIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxNegativeVolumeIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxNegativeVolumeIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxNegativeVolumeIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNegativeVolumeIndexIndicatorDynamicModule = class IgxNegativeVolumeIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxNegativeVolumeIndexIndicatorComponent", IgxNegativeVolumeIndexIndicatorComponent);
        TypeRegistrar.register("NegativeVolumeIndexIndicator", NegativeVolumeIndexIndicator.$type);
    }
};
IgxNegativeVolumeIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxNegativeVolumeIndexIndicatorModule],
        exports: [IgxNegativeVolumeIndexIndicatorModule],
        entryComponents: [IgxNegativeVolumeIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxNegativeVolumeIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OnBalanceVolumeIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = a.closeColumn;
        let d = a.volumeColumn;
        let e = a.indicatorColumn;
        let f = 0;
        if (c != null && d != null) {
            f = Math.min(c.count, d.count);
        }
        let g = 0;
        if (f > 0) {
            g = d.item(0);
            e.item(0, g);
        }
        for (let h = 1; h < f; ++h) {
            switch (Math.sign(c.item(h) - c.item(h - 1))) {
                case -1:
                    g -= d.item(h);
                    break;
                case 1:
                    g += d.item(h);
                    break;
            }
            e.item(h, g);
        }
        return true;
    }
}
OnBalanceVolumeIndicatorStrategy.$t = markType(OnBalanceVolumeIndicatorStrategy, 'OnBalanceVolumeIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OnBalanceVolumeIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new OnBalanceVolumeIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return OnBalanceVolumeIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
OnBalanceVolumeIndicator.$t = markType(OnBalanceVolumeIndicator, 'OnBalanceVolumeIndicator', StrategyBasedIndicator.$);

var IgxOnBalanceVolumeIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent On Balance Bolume indicator series.
 * Default required members: Close, Volume
*
* You can use the `IgxOnBalanceVolumeIndicatorComponent` to calculate a running total of sales volume for a stock.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-on-balance-volume-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-on-balance-volume-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxOnBalanceVolumeIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxOnBalanceVolumeIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent) }];
let IgxOnBalanceVolumeIndicatorComponent = IgxOnBalanceVolumeIndicatorComponent_1 = class IgxOnBalanceVolumeIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new OnBalanceVolumeIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxOnBalanceVolumeIndicatorComponent = IgxOnBalanceVolumeIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-on-balance-volume-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxOnBalanceVolumeIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxOnBalanceVolumeIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOnBalanceVolumeIndicatorModule = class IgxOnBalanceVolumeIndicatorModule {
};
IgxOnBalanceVolumeIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxOnBalanceVolumeIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxOnBalanceVolumeIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxOnBalanceVolumeIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOnBalanceVolumeIndicatorDynamicModule = class IgxOnBalanceVolumeIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxOnBalanceVolumeIndicatorComponent", IgxOnBalanceVolumeIndicatorComponent);
        TypeRegistrar.register("OnBalanceVolumeIndicator", OnBalanceVolumeIndicator.$type);
    }
};
IgxOnBalanceVolumeIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxOnBalanceVolumeIndicatorModule],
        exports: [IgxOnBalanceVolumeIndicatorModule],
        entryComponents: [IgxOnBalanceVolumeIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxOnBalanceVolumeIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentagePriceOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(b.g.c);
        c.o(b.e.c);
        return c;
    }
    a(a, b) {
        let c = a.indicatorColumn;
        let d = getEnumerator(b.g.b(a));
        let e = getEnumerator(b.e.b(a));
        let f = 0;
        while (d.moveNext() && e.moveNext()) {
            let g = b.i(100 * (d.current - e.current) / e.current);
            c.item(f, g);
            ++f;
        }
        return true;
    }
}
PercentagePriceOscillatorIndicatorStrategy.$t = markType(PercentagePriceOscillatorIndicatorStrategy, 'PercentagePriceOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentagePriceOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new PercentagePriceOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return PercentagePriceOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.q8));
    }
    set shortPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.q8, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentagePriceOscillatorIndicator.q7));
    }
    set longPeriod(a) {
        this.h(PercentagePriceOscillatorIndicator.q7, a);
    }
    qr() {
        return this.longPeriod;
    }
}
PercentagePriceOscillatorIndicator.$t = markType(PercentagePriceOscillatorIndicator, 'PercentagePriceOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
PercentagePriceOscillatorIndicator.q8 = StrategyBasedIndicator.q6(10, PercentagePriceOscillatorIndicator.$);
PercentagePriceOscillatorIndicator.q7 = StrategyBasedIndicator.q2(30, PercentagePriceOscillatorIndicator.$);

var IgxPercentagePriceOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent percentage price oscillator series.
 * Default required members: High, Low, Volume
*
* You can use the `IgxPercentagePriceOscillatorIndicatorComponent` to show the difference between two moving averages.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-percentage-price-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-percentage-price-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxPercentagePriceOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxPercentagePriceOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent) }];
let IgxPercentagePriceOscillatorIndicatorComponent = IgxPercentagePriceOscillatorIndicatorComponent_1 = class IgxPercentagePriceOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PercentagePriceOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the short moving average period for the current PercentagePriceOscillatorIndicator object.
     * The typical, and initial, value for short PPO periods is 10.
    *
    * You can use the `shortPeriod` to set the short moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-price-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		shortPeriod="10">
    *     </igx-percentage-price-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shortPeriod = 10;
    * ```
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * Gets or sets the long moving average period for the current PercentagePriceOscillatorIndicator object.
     * The typical, and initial, value for long PVO periods is 30.
    *
    * You can use the `longPeriod` to set the long moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-price-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		longPeriod="30">
    *     </igx-percentage-price-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod = 30;
    * ```
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPercentagePriceOscillatorIndicatorComponent.prototype, "shortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPercentagePriceOscillatorIndicatorComponent.prototype, "longPeriod", null);
IgxPercentagePriceOscillatorIndicatorComponent = IgxPercentagePriceOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-percentage-price-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPercentagePriceOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPercentagePriceOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentagePriceOscillatorIndicatorModule = class IgxPercentagePriceOscillatorIndicatorModule {
};
IgxPercentagePriceOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxPercentagePriceOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxPercentagePriceOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxPercentagePriceOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentagePriceOscillatorIndicatorDynamicModule = class IgxPercentagePriceOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPercentagePriceOscillatorIndicatorComponent", IgxPercentagePriceOscillatorIndicatorComponent);
        TypeRegistrar.register("PercentagePriceOscillatorIndicator", PercentagePriceOscillatorIndicator.$type);
    }
};
IgxPercentagePriceOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPercentagePriceOscillatorIndicatorModule],
        exports: [IgxPercentagePriceOscillatorIndicatorModule],
        entryComponents: [IgxPercentagePriceOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPercentagePriceOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentageVolumeOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(b.h.c);
        c.o(b.f.c);
        return c;
    }
    a(a, b) {
        let c = getEnumerator(b.h.b(a));
        let d = getEnumerator(b.f.b(a));
        let e = a.indicatorColumn;
        let f = 0;
        while (c.moveNext() && d.moveNext()) {
            let g = b.i(100 * (c.current - d.current) / d.current);
            e.item(f, g);
            ++f;
        }
        return true;
    }
}
PercentageVolumeOscillatorIndicatorStrategy.$t = markType(PercentageVolumeOscillatorIndicatorStrategy, 'PercentageVolumeOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PercentageVolumeOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new PercentageVolumeOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return PercentageVolumeOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get shortPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.q8));
    }
    set shortPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.q8, a);
    }
    qu() {
        return this.shortPeriod;
    }
    get longPeriod() {
        return typeGetValue(this.c(PercentageVolumeOscillatorIndicator.q7));
    }
    set longPeriod(a) {
        this.h(PercentageVolumeOscillatorIndicator.q7, a);
    }
    qr() {
        return this.longPeriod;
    }
}
PercentageVolumeOscillatorIndicator.$t = markType(PercentageVolumeOscillatorIndicator, 'PercentageVolumeOscillatorIndicator', StrategyBasedIndicator.$, [IShortPeriodLongPeriod_$type]);
PercentageVolumeOscillatorIndicator.q8 = StrategyBasedIndicator.q6(10, PercentageVolumeOscillatorIndicator.$);
PercentageVolumeOscillatorIndicator.q7 = StrategyBasedIndicator.q2(30, PercentageVolumeOscillatorIndicator.$);

var IgxPercentageVolumeOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Percentage Volume Oscillator (PVO) series.
 * Default required members: Volume
*
* You can use the `IgxPercentageVolumeOscillatorIndicatorComponent` to show the percentage difference volume.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-percentage-volume-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-percentage-volume-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxPercentageVolumeOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxPercentageVolumeOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent) }];
let IgxPercentageVolumeOscillatorIndicatorComponent = IgxPercentageVolumeOscillatorIndicatorComponent_1 = class IgxPercentageVolumeOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PercentageVolumeOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
     * The typical, and initial, value for short PVO periods is 10.
    *
    * You can use the `shortPeriod` to set the short moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-volume-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		shortPeriod="10">
    *     </igx-percentage-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.shortPeriod = 30;
    * ```
    */
    get shortPeriod() {
        return this.i.shortPeriod;
    }
    set shortPeriod(v) {
        this.i.shortPeriod = +v;
    }
    /**
     * Gets or sets the short moving average period for the current PercentageVolumeOscillatorIndicator object.
     * The typical, and initial, value for long PVO periods is 30.
    *
    * You can use the `longPeriod` to set the long moving average period.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-percentage-volume-oscillator-indicator
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		longPeriod="30">
    *     </igx-percentage-volume-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.longPeriod = 30;
    * ```
    */
    get longPeriod() {
        return this.i.longPeriod;
    }
    set longPeriod(v) {
        this.i.longPeriod = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPercentageVolumeOscillatorIndicatorComponent.prototype, "shortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPercentageVolumeOscillatorIndicatorComponent.prototype, "longPeriod", null);
IgxPercentageVolumeOscillatorIndicatorComponent = IgxPercentageVolumeOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-percentage-volume-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPercentageVolumeOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPercentageVolumeOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentageVolumeOscillatorIndicatorModule = class IgxPercentageVolumeOscillatorIndicatorModule {
};
IgxPercentageVolumeOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxPercentageVolumeOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxPercentageVolumeOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxPercentageVolumeOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPercentageVolumeOscillatorIndicatorDynamicModule = class IgxPercentageVolumeOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPercentageVolumeOscillatorIndicatorComponent", IgxPercentageVolumeOscillatorIndicatorComponent);
        TypeRegistrar.register("PercentageVolumeOscillatorIndicator", PercentageVolumeOscillatorIndicator.$type);
    }
};
IgxPercentageVolumeOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPercentageVolumeOscillatorIndicatorModule],
        exports: [IgxPercentageVolumeOscillatorIndicatorModule],
        entryComponents: [IgxPercentageVolumeOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPercentageVolumeOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PositiveVolumeIndexIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.add("VolumeColumn");
        return c;
    }
    a(a, b) {
        let c = a.closeColumn;
        let d = a.volumeColumn;
        let e = a.indicatorColumn;
        let f = 0;
        let g = 0;
        let h = 0;
        if (e.count > 0) {
            e.item(0, f);
        }
        for (let i = 1; i < e.count; i++) {
            if (d.item(i) > d.item(i - 1)) {
                g = b.i((c.item(i) - c.item(i - 1)) / c.item(i - 1));
                if (h != 0) {
                    f += g * h;
                }
                else {
                    f += g;
                }
            }
            e.item(i, f);
            h = f;
        }
        return true;
    }
}
PositiveVolumeIndexIndicatorStrategy.$t = markType(PositiveVolumeIndexIndicatorStrategy, 'PositiveVolumeIndexIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PositiveVolumeIndexIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new PositiveVolumeIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return PositiveVolumeIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
PositiveVolumeIndexIndicator.$t = markType(PositiveVolumeIndexIndicator, 'PositiveVolumeIndexIndicator', StrategyBasedIndicator.$);

var IgxPositiveVolumeIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Positive Volume Index (PVI) indicator series.
 * Default required members: Close, Volume
*
* You can use the `IgxPositiveVolumeIndexIndicatorComponent` with the 'NegativeVolumeIndexIndicator' to identify bull markets.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-positive-volume-index-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-positive-volume-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxPositiveVolumeIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxPositiveVolumeIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent) }];
let IgxPositiveVolumeIndexIndicatorComponent = IgxPositiveVolumeIndexIndicatorComponent_1 = class IgxPositiveVolumeIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PositiveVolumeIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxPositiveVolumeIndexIndicatorComponent = IgxPositiveVolumeIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-positive-volume-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPositiveVolumeIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPositiveVolumeIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPositiveVolumeIndexIndicatorModule = class IgxPositiveVolumeIndexIndicatorModule {
};
IgxPositiveVolumeIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxPositiveVolumeIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxPositiveVolumeIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxPositiveVolumeIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPositiveVolumeIndexIndicatorDynamicModule = class IgxPositiveVolumeIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPositiveVolumeIndexIndicatorComponent", IgxPositiveVolumeIndexIndicatorComponent);
        TypeRegistrar.register("PositiveVolumeIndexIndicator", PositiveVolumeIndexIndicator.$type);
    }
};
IgxPositiveVolumeIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPositiveVolumeIndexIndicatorModule],
        exports: [IgxPositiveVolumeIndexIndicatorModule],
        entryComponents: [IgxPositiveVolumeIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPositiveVolumeIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PriceVolumeTrendIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("VolumeColumn");
        c.add("CloseColumn");
        return c;
    }
    a(a, b) {
        let c = 0;
        let d = a.indicatorColumn;
        let e = a.volumeColumn;
        let f = a.closeColumn;
        let g = a.count;
        if (g > 0) {
            d.item(0, c);
        }
        for (let h = 1; h < g; ++h) {
            c = c + b.i(e.item(h) * (f.item(h) - f.item(h - 1)) / f.item(h - 1));
            d.item(h, c);
        }
        return true;
    }
}
PriceVolumeTrendIndicatorStrategy.$t = markType(PriceVolumeTrendIndicatorStrategy, 'PriceVolumeTrendIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PriceVolumeTrendIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new PriceVolumeTrendIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return PriceVolumeTrendIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
PriceVolumeTrendIndicator.$t = markType(PriceVolumeTrendIndicator, 'PriceVolumeTrendIndicator', StrategyBasedIndicator.$);

var IgxPriceVolumeTrendIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Price Volume Trend Indicator series.
 * Default required members: Volume, Close
*
* You can use the `IgxPriceVolumeTrendIndicatorComponent` to measure money flow by adding or subtracting a portion of the daily volume.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-price-volume-trend-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-price-volume-trend-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxPriceVolumeTrendIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxPriceVolumeTrendIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent) }];
let IgxPriceVolumeTrendIndicatorComponent = IgxPriceVolumeTrendIndicatorComponent_1 = class IgxPriceVolumeTrendIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PriceVolumeTrendIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxPriceVolumeTrendIndicatorComponent = IgxPriceVolumeTrendIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-price-volume-trend-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPriceVolumeTrendIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPriceVolumeTrendIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPriceVolumeTrendIndicatorModule = class IgxPriceVolumeTrendIndicatorModule {
};
IgxPriceVolumeTrendIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxPriceVolumeTrendIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxPriceVolumeTrendIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxPriceVolumeTrendIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPriceVolumeTrendIndicatorDynamicModule = class IgxPriceVolumeTrendIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPriceVolumeTrendIndicatorComponent", IgxPriceVolumeTrendIndicatorComponent);
        TypeRegistrar.register("PriceVolumeTrendIndicator", PriceVolumeTrendIndicator.$type);
    }
};
IgxPriceVolumeTrendIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPriceVolumeTrendIndicatorModule],
        exports: [IgxPriceVolumeTrendIndicatorModule],
        entryComponents: [IgxPriceVolumeTrendIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPriceVolumeTrendIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RateOfChangeAndMomentumIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        return c;
    }
    a(a, b) {
        let c = a.closeColumn;
        let d = a.indicatorColumn;
        let e = a.period;
        let f = 0;
        let g = new Array(e);
        for (f = 0; f < e; f++) {
            g[f] = 0;
        }
        f = 0;
        for (let h of fromEnum(c)) {
            let i = f % e;
            let j = b.i(100 * (h - g[i]) / g[i]);
            d.item(f, j);
            g[i] = h;
            ++f;
        }
        return true;
    }
}
RateOfChangeAndMomentumIndicatorStrategy.$t = markType(RateOfChangeAndMomentumIndicatorStrategy, 'RateOfChangeAndMomentumIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RateOfChangeAndMomentumIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new RateOfChangeAndMomentumIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return RateOfChangeAndMomentumIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(RateOfChangeAndMomentumIndicator.q8));
    }
    set q7(a) {
        this.h(RateOfChangeAndMomentumIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
RateOfChangeAndMomentumIndicator.$t = markType(RateOfChangeAndMomentumIndicator, 'RateOfChangeAndMomentumIndicator', StrategyBasedIndicator.$);
RateOfChangeAndMomentumIndicator.q8 = StrategyBasedIndicator.q4(14, RateOfChangeAndMomentumIndicator.$);

var IgxRateOfChangeAndMomentumIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Rate of Change and Momentum indicator series.
 * Default required members: Close
*
* `IgxRateOfChangeAndMomentumIndicatorComponent` class represents a Rate of Change and Momentum indicator series for the IgxDataChartComponent.
*
* ```html
* <igx-data-chart  #chart
*     [dataSource]="data">
*     <igx-category-x-axis
*     label="label"
*     #xAxis
*     >
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
*     </igx-numeric-y-axis>
*     <igx-rate-of-change-and-momentum-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     >
* </igx-rate-of-change-and-momentum-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxRateOfChangeAndMomentumIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxRateOfChangeAndMomentumIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent) }];
let IgxRateOfChangeAndMomentumIndicatorComponent = IgxRateOfChangeAndMomentumIndicatorComponent_1 = class IgxRateOfChangeAndMomentumIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RateOfChangeAndMomentumIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current AverageTrueRangeSeries object.
     * The typical, and initial, value for AverageTrueRange periods is 14.
    *
    * You can use the `period` property for the current AverageTrueRangeSeries object.
    *
    * The typical, and initial, value for AverageTrueRange periods is 14.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-rate-of-change-and-momentum-indicator
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     openMemberPath="open"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     closeMemberPath="close"
    * 	period="30">
    * </igx-rate-of-change-and-momentum-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRateOfChangeAndMomentumIndicatorComponent.prototype, "period", null);
IgxRateOfChangeAndMomentumIndicatorComponent = IgxRateOfChangeAndMomentumIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-rate-of-change-and-momentum-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRateOfChangeAndMomentumIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRateOfChangeAndMomentumIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRateOfChangeAndMomentumIndicatorModule = class IgxRateOfChangeAndMomentumIndicatorModule {
};
IgxRateOfChangeAndMomentumIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxRateOfChangeAndMomentumIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxRateOfChangeAndMomentumIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxRateOfChangeAndMomentumIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRateOfChangeAndMomentumIndicatorDynamicModule = class IgxRateOfChangeAndMomentumIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRateOfChangeAndMomentumIndicatorComponent", IgxRateOfChangeAndMomentumIndicatorComponent);
        TypeRegistrar.register("RateOfChangeAndMomentumIndicator", RateOfChangeAndMomentumIndicator.$type);
    }
};
IgxRateOfChangeAndMomentumIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRateOfChangeAndMomentumIndicatorModule],
        exports: [IgxRateOfChangeAndMomentumIndicatorModule],
        entryComponents: [IgxRateOfChangeAndMomentumIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRateOfChangeAndMomentumIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RelativeStrengthIndexIndicatorStrategy extends StreamingIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        return c;
    }
    a(a, b) {
        let c = 0;
        for (let d of fromEnum(this.c(a, b))) {
            a.indicatorColumn.item(c, d);
            c++;
        }
        return true;
    }
    *_c(a, b) {
        let c = a.period;
        let d = 2 / (c + 1);
        let e = 0;
        let f = 0;
        let g = a.indicatorColumn;
        let h = a.closeColumn;
        if (g.count > 0) {
            yield 0;
        }
        for (let i = 1; i < Math.min(a.period, g.count); ++i) {
            let j = h.item(i) - h.item(i - 1);
            let k = j > 0 ? j : 0;
            let l = j > 0 ? 0 : -j;
            e += k / (c - 1);
            f += l / (c - 1);
            yield 0;
        }
        for (let m = a.period; m < g.count; ++m) {
            let n = h.item(m) - h.item(m - 1);
            let o = n > 0 ? n : 0;
            let p = n > 0 ? 0 : -n;
            e = (e * (c - 1) + o) / c;
            f = (f * (c - 1) + p) / c;
            yield b.i(e != 0 ? 100 * e / (e + f) : 0);
        }
    }
    c(a, b) {
        return toEnum(() => this._c(a, b));
    }
}
RelativeStrengthIndexIndicatorStrategy.$t = markType(RelativeStrengthIndexIndicatorStrategy, 'RelativeStrengthIndexIndicatorStrategy', StreamingIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RelativeStrengthIndexIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 1;
    }
    get_qm() {
        return new RelativeStrengthIndexIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return RelativeStrengthIndexIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(RelativeStrengthIndexIndicator.q8));
    }
    set q7(a) {
        this.h(RelativeStrengthIndexIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
RelativeStrengthIndexIndicator.$t = markType(RelativeStrengthIndexIndicator, 'RelativeStrengthIndexIndicator', StrategyBasedIndicator.$);
RelativeStrengthIndexIndicator.q8 = StrategyBasedIndicator.q4(14, RelativeStrengthIndexIndicator.$);

var IgxRelativeStrengthIndexIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Relative Strength Index indicator series.
 * Default required members: Close
*
* The `IgxRelativeStrengthIndexIndicatorComponent` class represents Relative Strength Index indicator series for the IgxDataChartComponent .
*
* ```html
*  <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-relative-strength-index-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-relative-strength-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxRelativeStrengthIndexIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxRelativeStrengthIndexIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent) }];
let IgxRelativeStrengthIndexIndicatorComponent = IgxRelativeStrengthIndexIndicatorComponent_1 = class IgxRelativeStrengthIndexIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RelativeStrengthIndexIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current RelativeStrengthIndexIndicator object.
     * The typical, and initial, value for RSI periods is 14.
    *
    * You can use the `period` property for the current RelativeStrengthIndexIndicator object.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-relative-strength-index-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume"
    * 		period=30>
    *     </igx-relative-strength-index-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRelativeStrengthIndexIndicatorComponent.prototype, "period", null);
IgxRelativeStrengthIndexIndicatorComponent = IgxRelativeStrengthIndexIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-relative-strength-index-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRelativeStrengthIndexIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRelativeStrengthIndexIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRelativeStrengthIndexIndicatorModule = class IgxRelativeStrengthIndexIndicatorModule {
};
IgxRelativeStrengthIndexIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxRelativeStrengthIndexIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxRelativeStrengthIndexIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxRelativeStrengthIndexIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRelativeStrengthIndexIndicatorDynamicModule = class IgxRelativeStrengthIndexIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRelativeStrengthIndexIndicatorComponent", IgxRelativeStrengthIndexIndicatorComponent);
        TypeRegistrar.register("RelativeStrengthIndexIndicator", RelativeStrengthIndexIndicator.$type);
    }
};
IgxRelativeStrengthIndexIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRelativeStrengthIndexIndicatorModule],
        exports: [IgxRelativeStrengthIndexIndicatorModule],
        entryComponents: [IgxRelativeStrengthIndexIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRelativeStrengthIndexIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SlowStochasticOscillatorIndicatorStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super();
        this.c = null;
        this.c = new PercentKCalculationStrategy();
    }
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = this.c.c(a, b);
        let d = b.a.b(c, 3);
        let e = 0;
        for (let f of fromEnum(d)) {
            a.indicatorColumn.item(e, f);
            e++;
        }
        return true;
    }
}
SlowStochasticOscillatorIndicatorStrategy.$t = markType(SlowStochasticOscillatorIndicatorStrategy, 'SlowStochasticOscillatorIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SlowStochasticOscillatorIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 10;
        this.trendLinePeriod = 3;
    }
    get_qm() {
        return new SlowStochasticOscillatorIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return SlowStochasticOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(SlowStochasticOscillatorIndicator.q8));
    }
    set q7(a) {
        this.h(SlowStochasticOscillatorIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
SlowStochasticOscillatorIndicator.$t = markType(SlowStochasticOscillatorIndicator, 'SlowStochasticOscillatorIndicator', StrategyBasedIndicator.$);
SlowStochasticOscillatorIndicator.q8 = StrategyBasedIndicator.q4(14, SlowStochasticOscillatorIndicator.$);

var IgxSlowStochasticOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Slow Stochastic Oscillator indicator series.
 * Default required members: High, Low, Close
*
* `IgxSlowStochasticOscillatorIndicatorComponent` (SSO) displays the closing price relative to the high-low range over a given period of time. There are three types of Stochastic Oscillators: Fast, Slow, and Full. The Stochastic Oscillator is a momentum indicator that shows the relation of the current close price relative to the high/low range over a given time period using a scale of 0 to 100. It is based on the premise that prices will close near 100 in a rising market and closer to 0 in a declining market.
*
* The Fast Stochastic Oscillator Indicator is used to identify buying or selling divergences. The Slow Stochastic Oscillator uses a 3-day SMA and the Full Stochastic Oscillator is the Slow Stochastic Oscillator with time period.
*
* Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `VolumeMemberPath`.
*
* ```html
* <igx-data-chart
*     width=500px
*     height=500px
*     [dataSource]="data" >
*     <igx-ordinal-time-x-axis
*         dateTimeMemberPath="TimeStamp"
*         #xAxis>
*       </igx-ordinal-time-x-axis>
*     <igx-numeric-y-axis
*        #yAxis></igx-numeric-y-axis>
*     <igx-slow-stochastic-oscillator-indicator
*        [xAxis]="xAxis"
*        [yAxis]="yAxis"
*        volumeMemberPath="Volume"
*        highMemberPath="High"
*        lowMemberPath="Low">
*      </igx-slow-stochastic-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxSlowStochasticOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.volumeMemberPath = "Volume";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* this.chart.series.add(series);
* ```
*/
const IgxSlowStochasticOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent) }];
let IgxSlowStochasticOscillatorIndicatorComponent = IgxSlowStochasticOscillatorIndicatorComponent_1 = class IgxSlowStochasticOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SlowStochasticOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current SlowStochasticOscillatorIndicator object.
     * The typical, and initial, value for SlowStochasticOscillatorIndicator periods is 14.
    *
    * ```html
    * <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-slow-stochastic-oscillator-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        closeMemberPath="Close"
    *        highMemberPath="High"
    *        lowMemberPath="Low"
    *        period=10>
    *      </igx-slow-stochastic-oscillator-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxSlowStochasticOscillatorIndicatorComponent();
    * series.period=10;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSlowStochasticOscillatorIndicatorComponent.prototype, "period", null);
IgxSlowStochasticOscillatorIndicatorComponent = IgxSlowStochasticOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-slow-stochastic-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSlowStochasticOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSlowStochasticOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSlowStochasticOscillatorIndicatorModule = class IgxSlowStochasticOscillatorIndicatorModule {
};
IgxSlowStochasticOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxSlowStochasticOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxSlowStochasticOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxSlowStochasticOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSlowStochasticOscillatorIndicatorDynamicModule = class IgxSlowStochasticOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSlowStochasticOscillatorIndicatorComponent", IgxSlowStochasticOscillatorIndicatorComponent);
        TypeRegistrar.register("SlowStochasticOscillatorIndicator", SlowStochasticOscillatorIndicator.$type);
    }
};
IgxSlowStochasticOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSlowStochasticOscillatorIndicatorModule],
        exports: [IgxSlowStochasticOscillatorIndicatorModule],
        entryComponents: [IgxSlowStochasticOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSlowStochasticOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StandardDeviationIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        c.o(b.d.c);
        return c;
    }
    a(a, b) {
        let c = getEnumerator(b.d.b(a.typicalColumn, a.period));
        let d = a.indicatorColumn;
        let e = 0;
        while (c.moveNext()) {
            d.item(e, c.current);
            e++;
        }
        return true;
    }
}
StandardDeviationIndicatorStrategy.$t = markType(StandardDeviationIndicatorStrategy, 'StandardDeviationIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StandardDeviationIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new StandardDeviationIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return StandardDeviationIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(StandardDeviationIndicator.q8));
    }
    set q7(a) {
        this.h(StandardDeviationIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
StandardDeviationIndicator.$t = markType(StandardDeviationIndicator, 'StandardDeviationIndicator', StrategyBasedIndicator.$);
StandardDeviationIndicator.q8 = StrategyBasedIndicator.q4(20, StandardDeviationIndicator.$);

var IgxStandardDeviationIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Standard Deviation indicator series.
 * Default required members: High, Low, Close
*
* `IgxStandardDeviationIndicatorComponent` (SDI) measures statistical variation in stock prices or volatility. The difference between an individual security’s closing price and the average security closing price is called the dispersion. The larger the dispersion is the higher the standard deviation will be and therefore the volatility. The smaller the dispersion is (the difference between an individual closing price and the average price), the smaller the standard deviation and the lower the price volatility.
*
* Using this indicator requires setting both the `HighMemberPath`, `LowMemberPath` and `CloseMemberPath`.
*
* ```html
*  <igx-data-chart
*     width=500px
*     height=500px
*     [dataSource]="data" >
*     <igx-ordinal-time-x-axis
*         dateTimeMemberPath="TimeStamp"
*         #xAxis>
*       </igx-ordinal-time-x-axis>
*     <igx-numeric-y-axis
*        #yAxis></igx-numeric-y-axis>
*     <igx-standard-deviation-indicator
*        [xAxis]="xAxis"
*        [yAxis]="yAxis"
*        closeMemberPath="Close"
*        highMemberPath="High"
*        lowMemberPath="Low">
*      </igx-standard-deviation-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxStandardDeviatioIndicatorComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.highMemberPath = "high";
*    series.lowMemberPath = "low";
*    series.closeMemberPath = "close";
*    this.chart.series.add(series);
*
* ```
*/
const IgxStandardDeviationIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent) }];
let IgxStandardDeviationIndicatorComponent = IgxStandardDeviationIndicatorComponent_1 = class IgxStandardDeviationIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StandardDeviationIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current StandardDeviationIndicator object.
     * The typical, and initial, value for STDEV periods is 20.
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStandardDeviationIndicatorComponent.prototype, "period", null);
IgxStandardDeviationIndicatorComponent = IgxStandardDeviationIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-standard-deviation-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStandardDeviationIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStandardDeviationIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStandardDeviationIndicatorModule = class IgxStandardDeviationIndicatorModule {
};
IgxStandardDeviationIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxStandardDeviationIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxStandardDeviationIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxStandardDeviationIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStandardDeviationIndicatorDynamicModule = class IgxStandardDeviationIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStandardDeviationIndicatorComponent", IgxStandardDeviationIndicatorComponent);
        TypeRegistrar.register("StandardDeviationIndicator", StandardDeviationIndicator.$type);
    }
};
IgxStandardDeviationIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStandardDeviationIndicatorModule],
        exports: [IgxStandardDeviationIndicatorModule],
        entryComponents: [IgxStandardDeviationIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStandardDeviationIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StochRSIIndicatorStrategy extends IndicatorCalculationStrategy {
    constructor() {
        super();
        this.c = null;
        this.c = new RelativeStrengthIndexIndicatorStrategy();
    }
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(this.c.b(a, b));
        return c;
    }
    a(a, b) {
        let c = getEnumerator(this.c.c(a, b));
        let d = a.period;
        let e = 0;
        let f = new Array(d);
        for (e = 0; e < d; e++) {
            f[e] = 0;
        }
        e = 0;
        while (c.moveNext()) {
            let g = Math.min(d, e);
            let h = -1.7976931348623157E+308;
            let i = 1.7976931348623157E+308;
            let j = e % d;
            for (let k = 0; k < g; k++) {
                if (!isNaN_(f[g - k - 1])) {
                    h = Math.max(h, f[g - k - 1]);
                }
                if (!isNaN_(f[g - k - 1])) {
                    i = Math.min(i, f[g - k - 1]);
                }
            }
            f[j] = c.current;
            let l = b.i((c.current - i) / (h - i));
            a.indicatorColumn.item(e, l);
            e++;
        }
        return true;
    }
}
StochRSIIndicatorStrategy.$t = markType(StochRSIIndicatorStrategy, 'StochRSIIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StochRSIIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new StochRSIIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return StochRSIIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(StochRSIIndicator.q8));
    }
    set q7(a) {
        this.h(StochRSIIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
StochRSIIndicator.$t = markType(StochRSIIndicator, 'StochRSIIndicator', StrategyBasedIndicator.$);
StochRSIIndicator.q8 = StrategyBasedIndicator.q4(14, StochRSIIndicator.$);

var IgxStochRSIIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent StochRSI indicator series.
 * Default required members: Close
*
* `IgxStochRSIIndicatorComponent` or Stochastic Relative Strength IndexI Indicator (SRSI) measures when a security is overbought or oversold within a specified period of time. The values range from 0 to 1. The StochRSI Indicator is calculated by applying the Stochastic Oscillator formula to RelativeStrengthIndexIndicator (RSI) data.
*
* Using this indicator requires setting the `CloseMemberPath`.
*
* ```html
* <igx-data-chart
*     width=500px
*     height=500px
*     [dataSource]="data" >
*     <igx-ordinal-time-x-axis
*         dateTimeMemberPath="TimeStamp"
*         #xAxis>
*       </igx-ordinal-time-x-axis>
*     <igx-numeric-y-axis
*        #yAxis></igx-numeric-y-axis>
*     <igx-stoch-rsi-indicator
*        [xAxis]="xAxis"
*        [yAxis]="yAxis"
*        closeMemberPath="Close">
*      </igx-stoch-rsi-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxStochRSIIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxStochRSIIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent) }];
let IgxStochRSIIndicatorComponent = IgxStochRSIIndicatorComponent_1 = class IgxStochRSIIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StochRSIIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current StochRSIIndicator object.
     * The typical, and initial, value for StochRSI periods is 14.
    *
    * ```html
    * <igx-data-chart
    *     width=500px
    *     height=500px
    *     [dataSource]="data" >
    *     <igx-ordinal-time-x-axis
    *         dateTimeMemberPath="TimeStamp"
    *         #xAxis>
    *       </igx-ordinal-time-x-axis>
    *     <igx-numeric-y-axis
    *        #yAxis></igx-numeric-y-axis>
    *     <igx-stoch-rsi-indicator
    *        [xAxis]="xAxis"
    *        [yAxis]="yAxis"
    *        closeMemberPath="Close"
    *        period=10>
    *      </igx-stoch-rsi-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 10;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStochRSIIndicatorComponent.prototype, "period", null);
IgxStochRSIIndicatorComponent = IgxStochRSIIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-stoch-rsi-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStochRSIIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStochRSIIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStochRSIIndicatorModule = class IgxStochRSIIndicatorModule {
};
IgxStochRSIIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxStochRSIIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxStochRSIIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxStochRSIIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStochRSIIndicatorDynamicModule = class IgxStochRSIIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStochRSIIndicatorComponent", IgxStochRSIIndicatorComponent);
        TypeRegistrar.register("StochRSIIndicator", StochRSIIndicator.$type);
    }
};
IgxStochRSIIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStochRSIIndicatorModule],
        exports: [IgxStochRSIIndicatorModule],
        entryComponents: [IgxStochRSIIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStochRSIIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TRIXIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("CloseColumn");
        c.o(b.a.c);
        return c;
    }
    a(a, b) {
        let c = b.a.b(a.closeColumn, a.period);
        let d = b.a.b(c, a.period);
        let e = getEnumerator(b.a.b(d, a.period));
        let f = a.indicatorColumn;
        if (f.count > 0) {
            f.item(0, 0);
        }
        let g = 1;
        e.moveNext();
        let h = e.current;
        while (e.moveNext()) {
            f.item(g, b.i((e.current - h) / h));
            h = e.current;
            g++;
        }
        return true;
    }
}
TRIXIndicatorStrategy.$t = markType(TRIXIndicatorStrategy, 'TRIXIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TRIXIndicator extends StrategyBasedIndicator {
    constructor() {
        super();
        this.pu = 0;
        this.trendLineBrush = ((() => {
            let $ret = new Brush();
            $ret.fill = "#565656";
            return $ret;
        })());
        this.trendLineType = 9;
        this.trendLinePeriod = 9;
    }
    get_qm() {
        return new TRIXIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return TRIXIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(TRIXIndicator.q8));
    }
    set q7(a) {
        this.h(TRIXIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
TRIXIndicator.$t = markType(TRIXIndicator, 'TRIXIndicator', StrategyBasedIndicator.$);
TRIXIndicator.q8 = StrategyBasedIndicator.q4(15, TRIXIndicator.$);

var IgxTRIXIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent TRIX indicator series.
 * Default required members: Close
*
* The `IgxTRIXIndicatorComponent` class specify the series as Trix Indicator series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-trix-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-trix-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxTrixIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxTRIXIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent) }];
let IgxTRIXIndicatorComponent = IgxTRIXIndicatorComponent_1 = class IgxTRIXIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TRIXIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current TRIXIndicator object.
     * The typical, and initial, value for TRIX periods is 15.
    *
    * The `period` property is used for moving average period of the current TRIXIndicator object.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data">
    * 	<igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    * 	<igx-trix-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         highMemberPath="high"
    * 		lowMemberPath="low"
    * 		volumeMemberPath="volume"
    * 		period="7">
    *     </igx-trix-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTRIXIndicatorComponent.prototype, "period", null);
IgxTRIXIndicatorComponent = IgxTRIXIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-trix-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxTRIXIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxTRIXIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTRIXIndicatorModule = class IgxTRIXIndicatorModule {
};
IgxTRIXIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxTRIXIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxTRIXIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxTRIXIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTRIXIndicatorDynamicModule = class IgxTRIXIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTRIXIndicatorComponent", IgxTRIXIndicatorComponent);
        TypeRegistrar.register("TRIXIndicator", TRIXIndicator.$type);
    }
};
IgxTRIXIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTRIXIndicatorModule],
        exports: [IgxTRIXIndicatorModule],
        entryComponents: [IgxTRIXIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTRIXIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TypicalPriceIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.typicalColumn.basedOn);
        return c;
    }
    a(a, b) {
        let c = 0;
        for (let d of fromEnum(a.typicalColumn)) {
            a.indicatorColumn.item(c, d);
            c++;
        }
        return true;
    }
}
TypicalPriceIndicatorStrategy.$t = markType(TypicalPriceIndicatorStrategy, 'TypicalPriceIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TypicalPriceIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new TypicalPriceIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return TypicalPriceIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
TypicalPriceIndicator.$t = markType(TypicalPriceIndicator, 'TypicalPriceIndicator', StrategyBasedIndicator.$);

var IgxTypicalPriceIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Typical Price indicator series.
 * The typical price indicator is represented as a arithmetic average
 * of the High, Low, and Close for a day.
 * Default required members: High, Low, Close
*
* The `IgxTypicalPriceIndicatorComponent` class represents a IgxDataChartComponent Typical Price indicator series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
* 	<igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
* 	<igx-typical-price-indicator
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         highMemberPath="high"
* 		lowMemberPath="low"
* 		volumeMemberPath="volume">
*     </igx-typical-price-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxTypicalPriceIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxTypicalPriceIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent) }];
let IgxTypicalPriceIndicatorComponent = IgxTypicalPriceIndicatorComponent_1 = class IgxTypicalPriceIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TypicalPriceIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxTypicalPriceIndicatorComponent = IgxTypicalPriceIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-typical-price-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxTypicalPriceIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxTypicalPriceIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTypicalPriceIndicatorModule = class IgxTypicalPriceIndicatorModule {
};
IgxTypicalPriceIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxTypicalPriceIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxTypicalPriceIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxTypicalPriceIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTypicalPriceIndicatorDynamicModule = class IgxTypicalPriceIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTypicalPriceIndicatorComponent", IgxTypicalPriceIndicatorComponent);
        TypeRegistrar.register("TypicalPriceIndicator", TypicalPriceIndicator.$type);
    }
};
IgxTypicalPriceIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTypicalPriceIndicatorModule],
        exports: [IgxTypicalPriceIndicatorModule],
        entryComponents: [IgxTypicalPriceIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTypicalPriceIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class UltimateOscillatorIndicatorCalculationStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.o(a.trueLow.basedOn);
        c.add("CloseColumn");
        c.o(a.trueRange.basedOn);
        c.o(b.b.c);
        return c;
    }
    c(a) {
        let b = 0;
        let c = new List$1(Number_$type, 0);
        let d = a.trueLow.getEnumerator();
        while (d.moveNext()) {
            c.add(a.closeColumn.item(b) - d.current);
            b++;
        }
        return c;
    }
    a(a, b) {
        let c = this.c(a);
        let d = a.trueRange;
        let e = getEnumerator(b.b.b(c, 7));
        let f = getEnumerator(b.b.b(d, 7));
        let g = getEnumerator(b.b.b(c, 14));
        let h = getEnumerator(b.b.b(d, 14));
        let i = getEnumerator(b.b.b(c, 28));
        let j = getEnumerator(b.b.b(d, 28));
        let k = 0;
        while (e.moveNext() && f.moveNext() && g.moveNext() && h.moveNext() && i.moveNext() && j.moveNext()) {
            let l = b.i(4 * (e.current / f.current) + 2 * (g.current / h.current) + (i.current / j.current));
            let m = (l / (4 + 2 + 1)) * 100;
            a.indicatorColumn.item(k, m);
            k++;
        }
        return true;
    }
}
UltimateOscillatorIndicatorCalculationStrategy.$t = markType(UltimateOscillatorIndicatorCalculationStrategy, 'UltimateOscillatorIndicatorCalculationStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class UltimateOscillatorIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new UltimateOscillatorIndicatorCalculationStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return UltimateOscillatorIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
UltimateOscillatorIndicator.$t = markType(UltimateOscillatorIndicator, 'UltimateOscillatorIndicator', StrategyBasedIndicator.$);

var IgxUltimateOscillatorIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Ultimate Oscillator indicator series.
 * Default required members: High, Low, Close
*
* You can use the `IgxUltimateOscillatorIndicatorComponent` which represents a IgxDataChartComponent Ultimate Oscillator indicator series.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-ultimate-oscillator-indicator
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-ultimate-oscillator-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxUltimateOscillatorIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxUltimateOscillatorIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent) }];
let IgxUltimateOscillatorIndicatorComponent = IgxUltimateOscillatorIndicatorComponent_1 = class IgxUltimateOscillatorIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new UltimateOscillatorIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxUltimateOscillatorIndicatorComponent = IgxUltimateOscillatorIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-ultimate-oscillator-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxUltimateOscillatorIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxUltimateOscillatorIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxUltimateOscillatorIndicatorModule = class IgxUltimateOscillatorIndicatorModule {
};
IgxUltimateOscillatorIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxUltimateOscillatorIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxUltimateOscillatorIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxUltimateOscillatorIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxUltimateOscillatorIndicatorDynamicModule = class IgxUltimateOscillatorIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxUltimateOscillatorIndicatorComponent", IgxUltimateOscillatorIndicatorComponent);
        TypeRegistrar.register("UltimateOscillatorIndicator", UltimateOscillatorIndicator.$type);
    }
};
IgxUltimateOscillatorIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxUltimateOscillatorIndicatorModule],
        exports: [IgxUltimateOscillatorIndicatorModule],
        entryComponents: [IgxUltimateOscillatorIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxUltimateOscillatorIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WeightedCloseIndicatorStrategy extends ItemwiseIndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    }
    a(a, b, c) {
        a.indicatorColumn.item(c, (a.highColumn.item(c) + a.lowColumn.item(c) + (a.closeColumn.item(c) * 2)) / 4);
        return true;
    }
}
WeightedCloseIndicatorStrategy.$t = markType(WeightedCloseIndicatorStrategy, 'WeightedCloseIndicatorStrategy', ItemwiseIndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WeightedCloseIndicator extends ItemwiseStrategyBasedIndicator {
    get_q8() {
        return new WeightedCloseIndicatorStrategy();
    }
    get q8() {
        return this.get_q8();
    }
    get_qz() {
        return WeightedCloseIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
}
WeightedCloseIndicator.$t = markType(WeightedCloseIndicator, 'WeightedCloseIndicator', ItemwiseStrategyBasedIndicator.$);

var IgxWeightedCloseIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Weigted Close indicator series.
 * The weighted close indicator shows an average of the high low and close
 * for a day but with the closing price counted twice in the average.
 * Default required members: High, Low, Close
*
* The `IgxWeightedCloseIndicatorComponent` is similar to the `IgxTypicalPriceIndicatorComponent` in that it represents an average of the high price, low price, and closing price for a day.
* However, with the `IgxWeightedCloseIndicatorComponent`, more emphasis is placed on the closing price and it is included twice when calculating the arithmetic average.
*
* ```html
* <igx-data-chart
*     [dataSource]="data">
*     <igx-category-x-axis #xAxis
*         label="label">
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-weighted-close-indicator
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         openMemberPath="open"
*         highMemberPath="high"
*         lowMemberPath="low"
*         closeMemberPath="close">
*     </igx-weighted-close-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxWeightedCloseIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxWeightedCloseIndicatorComponent_PROVIDERS = [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent) }];
let IgxWeightedCloseIndicatorComponent = IgxWeightedCloseIndicatorComponent_1 = class IgxWeightedCloseIndicatorComponent extends IgxItemwiseStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new WeightedCloseIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxWeightedCloseIndicatorComponent = IgxWeightedCloseIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-weighted-close-indicator',
        template: ``,
        providers: [{ provide: IgxItemwiseStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent_1) }, { provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWeightedCloseIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxWeightedCloseIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWeightedCloseIndicatorModule = class IgxWeightedCloseIndicatorModule {
};
IgxWeightedCloseIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxWeightedCloseIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxWeightedCloseIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxWeightedCloseIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWeightedCloseIndicatorDynamicModule = class IgxWeightedCloseIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxWeightedCloseIndicatorComponent", IgxWeightedCloseIndicatorComponent);
        TypeRegistrar.register("WeightedCloseIndicator", WeightedCloseIndicator.$type);
    }
};
IgxWeightedCloseIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxWeightedCloseIndicatorModule],
        exports: [IgxWeightedCloseIndicatorModule],
        entryComponents: [IgxWeightedCloseIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxWeightedCloseIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WilliamsPercentRIndicatorStrategy extends IndicatorCalculationStrategy {
    b(a, b) {
        let c = new List$1(String_$type, 0);
        c.add("HighColumn");
        c.add("LowColumn");
        c.add("CloseColumn");
        return c;
    }
    a(a, b) {
        let c = a.period;
        let d = a.highColumn;
        let e = a.lowColumn;
        for (let f = 0; f < a.count; f++) {
            let g = Math.min(c, f);
            let h = -1.7976931348623157E+308;
            let i = 1.7976931348623157E+308;
            for (let j = 0; j < g; j++) {
                if (!isNaN_(d.item(f - j))) {
                    h = Math.max(h, d.item(f - j));
                }
                if (!isNaN_(e.item(f - j))) {
                    i = Math.min(i, e.item(f - j));
                }
            }
            a.indicatorColumn.item(f, b.i((a.closeColumn.item(f) - h) / (h - i) * 100));
        }
        return true;
    }
}
WilliamsPercentRIndicatorStrategy.$t = markType(WilliamsPercentRIndicatorStrategy, 'WilliamsPercentRIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WilliamsPercentRIndicator extends StrategyBasedIndicator {
    get_qm() {
        return new WilliamsPercentRIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return WilliamsPercentRIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    get q7() {
        return typeGetValue(this.c(WilliamsPercentRIndicator.q8));
    }
    set q7(a) {
        this.h(WilliamsPercentRIndicator.q8, a);
    }
    qs() {
        return this.q7;
    }
    q1(a) {
        this.q7 = a;
    }
}
WilliamsPercentRIndicator.$t = markType(WilliamsPercentRIndicator, 'WilliamsPercentRIndicator', StrategyBasedIndicator.$);
WilliamsPercentRIndicator.q8 = StrategyBasedIndicator.q4(14, WilliamsPercentRIndicator.$);

var IgxWilliamsPercentRIndicatorComponent_1;
/**
 * Represents a IgxDataChartComponent Williams %R indicator series.
 * Default required members: High, Low, Close
*
* The `IgxWilliamsPercentRIndicatorComponent` scale ranges from 0 to -100. It is useful for identifying overbought and oversold securities.
* The `IgxWilliamsPercentRIndicatorComponent` is calculated by dividing the difference between the highest high for the period and the current close by the highest high minus the lowest low for the period.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis #xAxis
*         label="label">
*     </igx-category-x-axis>
*     <igx-numeric-y-axis #yAxis>
*     </igx-numeric-y-axis>
*     <igx-williams-percent-r-indicator
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         openMemberPath="open"
*         highMemberPath="high"
*         lowMemberPath="low"
*         closeMemberPath="close">
*     </igx-williams-percent-r-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxWilliamsPercentRIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxWilliamsPercentRIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent) }];
let IgxWilliamsPercentRIndicatorComponent = IgxWilliamsPercentRIndicatorComponent_1 = class IgxWilliamsPercentRIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new WilliamsPercentRIndicator();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current StandardDeviationIndicator object.
     * The typical, and initial, value for Williams %R periods is 14.
    *
    * Gets or sets the `period` for the moving average period.
    *
    * The typical, and initial, value for Williams %R periods is 14.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis #xAxis
    *         label="label">
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-williams-percent-r-indicator
    *         #series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         openMemberPath="open"
    *         highMemberPath="high"
    *         lowMemberPath="low"
    *         closeMemberPath="close"
    *         period="30">
    *     </igx-williams-percent-r-indicator>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 30;
    * ```
    */
    get period() {
        return this.i.q7;
    }
    set period(v) {
        this.i.q7 = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxWilliamsPercentRIndicatorComponent.prototype, "period", null);
IgxWilliamsPercentRIndicatorComponent = IgxWilliamsPercentRIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-williams-percent-r-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxWilliamsPercentRIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxWilliamsPercentRIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWilliamsPercentRIndicatorModule = class IgxWilliamsPercentRIndicatorModule {
};
IgxWilliamsPercentRIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxWilliamsPercentRIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxWilliamsPercentRIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxWilliamsPercentRIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxWilliamsPercentRIndicatorDynamicModule = class IgxWilliamsPercentRIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxWilliamsPercentRIndicatorComponent", IgxWilliamsPercentRIndicatorComponent);
        TypeRegistrar.register("WilliamsPercentRIndicator", WilliamsPercentRIndicator.$type);
    }
};
IgxWilliamsPercentRIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxWilliamsPercentRIndicatorModule],
        exports: [IgxWilliamsPercentRIndicatorModule],
        entryComponents: [IgxWilliamsPercentRIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxWilliamsPercentRIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomIndicatorStrategy extends IndicatorCalculationStrategy {
    a(a, b) {
        return true;
    }
    b(a, b) {
        return new List$1(String_$type, 0);
    }
}
CustomIndicatorStrategy.$t = markType(CustomIndicatorStrategy, 'CustomIndicatorStrategy', IndicatorCalculationStrategy.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomIndicator extends StrategyBasedIndicator {
    constructor() {
        super(...arguments);
        this.q8 = null;
        this.q7 = null;
    }
    get_qm() {
        return new CustomIndicatorStrategy();
    }
    get qm() {
        return this.get_qm();
    }
    get_qz() {
        return CustomIndicator.$;
    }
    get qz() {
        return this.get_qz();
    }
    py(a, b) {
        let c = this.mu(a, b);
        let d = this.mv(c);
        let e = new List$1(String_$type, 0);
        if (this.basedOnColumns != null) {
            let f = new FinancialEventArgs(c.calculateFrom, c.calculateCount, c, d, this);
            this.basedOnColumns(this, f);
            if (f.basedOn != null) {
                for (let g of fromEnum(f.basedOn)) {
                    e.add(g);
                }
            }
        }
        return e;
    }
    get indicator() {
        return this.q8;
    }
    set indicator(a) {
        this.q8 = a;
        this.p6();
    }
    get basedOnColumns() {
        return this.q7;
    }
    set basedOnColumns(a) {
        this.q7 = a;
    }
    pv(a, b) {
        super.pv(a, b);
        if (this.indicator != null) {
            let c = this.mu(a, b);
            if (b == 0) {
                return false;
            }
            if (!this.nr(this.py(a, b))) {
                return false;
            }
            this.indicator(this, new FinancialEventArgs(a, b, c, this.mv(c), this));
            if (this.qo(c) && this.m3 != null) {
                this.m3.cn();
            }
            return true;
        }
        return false;
    }
}
CustomIndicator.$t = markType(CustomIndicator, 'CustomIndicator', StrategyBasedIndicator.$);

var IgxCustomIndicatorComponent_1;
const IgxCustomIndicatorComponent_PROVIDERS = [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent) }];
/**
 * Represents a IgxDataChartComponent Custom Indicator series.
 * The indicator value is calculated in the user specified Indicator event handler.
*
* `IgxCustomIndicatorComponent` class specify the series as Custom Indicator series.
*
* ```html
* <igx-data-chart [dataSource]="data">
*   <igx-category-x-axis #xAxis
*     label="time">
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis>
*   </igx-numeric-y-axis>
*   <igx-commodity-channel-index-indicator
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume" >
*   </igx-commodity-channel-index-indicator>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxCustomIndicatorComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
let IgxCustomIndicatorComponent = IgxCustomIndicatorComponent_1 = class IgxCustomIndicatorComponent extends IgxStrategyBasedIndicatorComponent {
    constructor() {
        super();
        this._indicator = null;
        this._basedOnColumns = null;
    }
    createImplementation() {
        return new CustomIndicator();
    }
    get i() {
        return this._implementation;
    }
    /**
     * This event is raised when the indicator values need to be computed.
    */
    get indicator() {
        if (this._indicator == null) {
            this._indicator = new EventEmitter();
            this.i.indicator = delegateCombine(this.i.indicator, (o, e) => {
                let outerArgs = new IgxFinancialEventArgs();
                outerArgs._provideImplementation(e);
                this._indicator.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._indicator;
    }
    /**
     * This event is raised when the based on columns to be specified.
    */
    get basedOnColumns() {
        if (this._basedOnColumns == null) {
            this._basedOnColumns = new EventEmitter();
            this.i.basedOnColumns = delegateCombine(this.i.indicator, (o, e) => {
                let outerArgs = new IgxFinancialEventArgs();
                outerArgs._provideImplementation(e);
                this._basedOnColumns.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._indicator;
    }
};
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCustomIndicatorComponent.prototype, "indicator", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCustomIndicatorComponent.prototype, "basedOnColumns", null);
IgxCustomIndicatorComponent = IgxCustomIndicatorComponent_1 = __decorate([
    Component({
        selector: 'igx-custom-indicator',
        template: ``,
        providers: [{ provide: IgxStrategyBasedIndicatorComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent_1) }, { provide: IgxFinancialIndicatorComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxCustomIndicatorComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCustomIndicatorComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomIndicatorModule = class IgxCustomIndicatorModule {
};
IgxCustomIndicatorModule = __decorate([
    NgModule({
        declarations: [IgxCustomIndicatorComponent],
        imports: [CommonModule, IgxIndicatorProxyModule],
        exports: [IgxCustomIndicatorComponent, IgxIndicatorProxyModule],
        entryComponents: []
    })
], IgxCustomIndicatorModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomIndicatorDynamicModule = class IgxCustomIndicatorDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCustomIndicatorComponent", IgxCustomIndicatorComponent);
        TypeRegistrar.register("CustomIndicator", CustomIndicator.$type);
    }
};
IgxCustomIndicatorDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCustomIndicatorModule],
        exports: [IgxCustomIndicatorModule],
        entryComponents: [IgxCustomIndicatorComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCustomIndicatorDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxIndicatorsModule = class IgxIndicatorsModule {
};
IgxIndicatorsModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxAbsoluteVolumeOscillatorIndicatorModule,
            IgxAccumulationDistributionIndicatorModule,
            IgxAverageDirectionalIndexIndicatorModule,
            IgxAverageTrueRangeIndicatorModule,
            IgxBollingerBandWidthIndicatorModule,
            IgxChaikinOscillatorIndicatorModule,
            IgxChaikinVolatilityIndicatorModule,
            IgxCommodityChannelIndexIndicatorModule,
            IgxDetrendedPriceOscillatorIndicatorModule,
            IgxEaseOfMovementIndicatorModule,
            IgxFastStochasticOscillatorIndicatorModule,
            IgxForceIndexIndicatorModule,
            IgxFullStochasticOscillatorIndicatorModule,
            IgxMarketFacilitationIndexIndicatorModule,
            IgxMassIndexIndicatorModule,
            IgxMedianPriceIndicatorModule,
            IgxMoneyFlowIndexIndicatorModule,
            IgxMovingAverageConvergenceDivergenceIndicatorModule,
            IgxNegativeVolumeIndexIndicatorModule,
            IgxOnBalanceVolumeIndicatorModule,
            IgxPercentagePriceOscillatorIndicatorModule,
            IgxPercentageVolumeOscillatorIndicatorModule,
            IgxPositiveVolumeIndexIndicatorModule,
            IgxPriceVolumeTrendIndicatorModule,
            IgxRateOfChangeAndMomentumIndicatorModule,
            IgxRelativeStrengthIndexIndicatorModule,
            IgxSlowStochasticOscillatorIndicatorModule,
            IgxStandardDeviationIndicatorModule,
            IgxStochRSIIndicatorModule,
            IgxTRIXIndicatorModule,
            IgxTypicalPriceIndicatorModule,
            IgxUltimateOscillatorIndicatorModule,
            IgxWeightedCloseIndicatorModule,
            IgxWilliamsPercentRIndicatorModule,
            IgxCustomIndicatorModule
        ],
        imports: [CommonModule, IgxAbsoluteVolumeOscillatorIndicatorModule,
            IgxAccumulationDistributionIndicatorModule,
            IgxAverageDirectionalIndexIndicatorModule,
            IgxAverageTrueRangeIndicatorModule,
            IgxBollingerBandWidthIndicatorModule,
            IgxChaikinOscillatorIndicatorModule,
            IgxChaikinVolatilityIndicatorModule,
            IgxCommodityChannelIndexIndicatorModule,
            IgxDetrendedPriceOscillatorIndicatorModule,
            IgxEaseOfMovementIndicatorModule,
            IgxFastStochasticOscillatorIndicatorModule,
            IgxForceIndexIndicatorModule,
            IgxFullStochasticOscillatorIndicatorModule,
            IgxMarketFacilitationIndexIndicatorModule,
            IgxMassIndexIndicatorModule,
            IgxMedianPriceIndicatorModule,
            IgxMoneyFlowIndexIndicatorModule,
            IgxMovingAverageConvergenceDivergenceIndicatorModule,
            IgxNegativeVolumeIndexIndicatorModule,
            IgxOnBalanceVolumeIndicatorModule,
            IgxPercentagePriceOscillatorIndicatorModule,
            IgxPercentageVolumeOscillatorIndicatorModule,
            IgxPositiveVolumeIndexIndicatorModule,
            IgxPriceVolumeTrendIndicatorModule,
            IgxRateOfChangeAndMomentumIndicatorModule,
            IgxRelativeStrengthIndexIndicatorModule,
            IgxSlowStochasticOscillatorIndicatorModule,
            IgxStandardDeviationIndicatorModule,
            IgxStochRSIIndicatorModule,
            IgxTRIXIndicatorModule,
            IgxTypicalPriceIndicatorModule,
            IgxUltimateOscillatorIndicatorModule,
            IgxWeightedCloseIndicatorModule,
            IgxWilliamsPercentRIndicatorModule,
            IgxCustomIndicatorModule
        ],
        entryComponents: []
    })
], IgxIndicatorsModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxIndicatorsDynamicModule = class IgxIndicatorsDynamicModule {
};
IgxIndicatorsDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
            IgxAccumulationDistributionIndicatorDynamicModule,
            IgxAverageDirectionalIndexIndicatorDynamicModule,
            IgxAverageTrueRangeIndicatorDynamicModule,
            IgxBollingerBandWidthIndicatorDynamicModule,
            IgxChaikinOscillatorIndicatorDynamicModule,
            IgxChaikinVolatilityIndicatorDynamicModule,
            IgxCommodityChannelIndexIndicatorDynamicModule,
            IgxDetrendedPriceOscillatorIndicatorDynamicModule,
            IgxEaseOfMovementIndicatorDynamicModule,
            IgxFastStochasticOscillatorIndicatorDynamicModule,
            IgxForceIndexIndicatorDynamicModule,
            IgxFullStochasticOscillatorIndicatorDynamicModule,
            IgxMarketFacilitationIndexIndicatorDynamicModule,
            IgxMassIndexIndicatorDynamicModule,
            IgxMedianPriceIndicatorDynamicModule,
            IgxMoneyFlowIndexIndicatorDynamicModule,
            IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
            IgxNegativeVolumeIndexIndicatorDynamicModule,
            IgxOnBalanceVolumeIndicatorDynamicModule,
            IgxPercentagePriceOscillatorIndicatorDynamicModule,
            IgxPercentageVolumeOscillatorIndicatorDynamicModule,
            IgxPositiveVolumeIndexIndicatorDynamicModule,
            IgxPriceVolumeTrendIndicatorDynamicModule,
            IgxRateOfChangeAndMomentumIndicatorDynamicModule,
            IgxRelativeStrengthIndexIndicatorDynamicModule,
            IgxSlowStochasticOscillatorIndicatorDynamicModule,
            IgxStandardDeviationIndicatorDynamicModule,
            IgxStochRSIIndicatorDynamicModule,
            IgxTRIXIndicatorDynamicModule,
            IgxTypicalPriceIndicatorDynamicModule,
            IgxUltimateOscillatorIndicatorDynamicModule,
            IgxWeightedCloseIndicatorDynamicModule,
            IgxWilliamsPercentRIndicatorDynamicModule,
            IgxCustomIndicatorDynamicModule,
            IgxIndicatorsModule
        ],
        imports: [CommonModule, IgxAbsoluteVolumeOscillatorIndicatorDynamicModule,
            IgxAccumulationDistributionIndicatorDynamicModule,
            IgxAverageDirectionalIndexIndicatorDynamicModule,
            IgxAverageTrueRangeIndicatorDynamicModule,
            IgxBollingerBandWidthIndicatorDynamicModule,
            IgxChaikinOscillatorIndicatorDynamicModule,
            IgxChaikinVolatilityIndicatorDynamicModule,
            IgxCommodityChannelIndexIndicatorDynamicModule,
            IgxDetrendedPriceOscillatorIndicatorDynamicModule,
            IgxEaseOfMovementIndicatorDynamicModule,
            IgxFastStochasticOscillatorIndicatorDynamicModule,
            IgxForceIndexIndicatorDynamicModule,
            IgxFullStochasticOscillatorIndicatorDynamicModule,
            IgxMarketFacilitationIndexIndicatorDynamicModule,
            IgxMassIndexIndicatorDynamicModule,
            IgxMedianPriceIndicatorDynamicModule,
            IgxMoneyFlowIndexIndicatorDynamicModule,
            IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule,
            IgxNegativeVolumeIndexIndicatorDynamicModule,
            IgxOnBalanceVolumeIndicatorDynamicModule,
            IgxPercentagePriceOscillatorIndicatorDynamicModule,
            IgxPercentageVolumeOscillatorIndicatorDynamicModule,
            IgxPositiveVolumeIndexIndicatorDynamicModule,
            IgxPriceVolumeTrendIndicatorDynamicModule,
            IgxRateOfChangeAndMomentumIndicatorDynamicModule,
            IgxRelativeStrengthIndexIndicatorDynamicModule,
            IgxSlowStochasticOscillatorIndicatorDynamicModule,
            IgxStandardDeviationIndicatorDynamicModule,
            IgxStochRSIIndicatorDynamicModule,
            IgxTRIXIndicatorDynamicModule,
            IgxTypicalPriceIndicatorDynamicModule,
            IgxUltimateOscillatorIndicatorDynamicModule,
            IgxWeightedCloseIndicatorDynamicModule,
            IgxWilliamsPercentRIndicatorDynamicModule,
            IgxCustomIndicatorDynamicModule,
            IgxIndicatorsModule
        ],
        entryComponents: []
    })
], IgxIndicatorsDynamicModule);

/**
 * Represents the base functionality for a IgxDataChartComponent financial overlay series.
 * The difference between a FinancialIndicator and a FinancialOverlay is small.
 * Overlays are usually drawn against the same axes as the price, but they don't
 * have to be. Overlays mostly display multiple values, but not all of them, and so
 * so some indicators.
*
* The `IgxFinancialOverlayComponent` class represents the base functionality for a IgxDataChartComponent financial overlay series.
*
* ```html
* <igx-data-chart
* #chart
* [dataSource]="data" >
* <igx-ordinal-time-x-axis
* dateTimeMemberPath="TimeStamp"
* #xAxis
* >
* </igx-ordinal-time-x-axis>
* <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
* </igx-numeric-y-axis>
* <igx-bollinger-bands-overlay
* [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     openMemberPath="open"
*     highMemberPath="high"
*     lowMemberPath="low"
*     closeMemberPath="close"
*     volumeMemberPath="volume">
* </igx-bollinger-bands-overlay>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxBollingerBandsOverlayComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* series.volumeMemberPath="volume";
* this.chart.series.add(series);
* ```
*/
const IgxFinancialOverlayComponent_PROVIDERS = [{ provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFinancialOverlayComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinancialOverlayComponent) }];
class IgxFinancialOverlayComponent extends IgxFinancialSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the number of values to hide at the beginning of the indicator.
    *
    * Use the `ignoreFirst` property to sets the number of values to hide at the beginning of the indicator.
    *
    * ```ts
    *  series.ignoreFirst=2;
    * ```
    *
    * ```html
    *    <igx-data-chart
    *    #chart
    *        [dataSource]="data" >
    *  <igx-category-x-axis
    *        label="label"
    *        #xAxis>
    *        </igx-category-x-axis>
    * <igx-numeric-y-axis
    *        minimumValue="0"
    *        #yAxis>
    * </igx-numeric-y-axis>
    * <igx-bollinger-bands-overlay
    *    [xAxis]="xAxis"
    *      [yAxis]="yAxis"
    *      openMemberPath="open"
    *      highMemberPath="high"
    *      lowMemberPath="low"
    *      closeMemberPath="close"
    *      volumeMemberPath="volume"
    * 	  ignoreFirst="2">
    * </igx-bollinger-bands-overlay>
    *  </igx-data-chart>
    * ```
    */
    get ignoreFirst() {
        return this.i.pu;
    }
    set ignoreFirst(v) {
        this.i.pu = +v;
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * Use the `scrollIntoView` method to scrolls the series to display the item for the specified data item.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialOverlayComponent.prototype, "ignoreFirst", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialOverlay extends FinancialSeries {
    constructor() {
        super();
        this.ps = false;
        this.ps = false;
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            this.mi.i$i();
        }
        this.my.bu.e(this.eu);
        this.pt();
        if (this.m3 != null) {
            this.m3.cn();
        }
        this.jl(true);
    }
    get_dv() {
        return true;
    }
    i7(a, b, c, d) {
        switch (b) {
            case "FastItemsSource":
                this.ps = false;
                break;
            case FinancialOverlay.$$p[0]:
                this.ps = false;
                this.jl(false);
                this.it();
                break;
            case "XAxis":
                this.ps = false;
                break;
        }
        super.i7(a, b, c, d);
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    dh(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        return false;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    c9(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bi.bs;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.l2(this.bi);
        let g = new ScalerParams(0, e, e, this.mi.ca, f);
        let h = new ScalerParams(0, e, e, this.m3.ca, f);
        h.b = this.eh();
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.mi != null) {
                let i = this.mi.dy(b, g);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (this.m3 != null && this.nc != null && this.nb != null && b < this.nc.count && b < this.nb.count) {
                let j = this.m3.dy(this.nc.item(b), h);
                let k = this.m3.dy(this.nb.item(b), h);
                if (!isNaN_(j) && !isNaN_(k)) {
                    let l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    an(a) {
        if (a != null && a == this.m3 && this.nc != null && this.nb != null) {
            return new AxisRange(this.nc.minimum, this.nb.maximum);
        }
        return null;
    }
}
FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:pu:pw', [1, 0]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PriceChannelOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.pz = new List$1(Number_$type, 0);
        this.py = new List$1(Number_$type, 0);
        this.ab = PriceChannelOverlay.$;
        this.ml = new CategoryFrame(3);
        this.mn = new CategoryFrame(3);
        this.mk = new CategoryFrame(3);
    }
    i7(a, b, c, d) {
        switch (b) {
            case "HighColumn":
            case "LowColumn":
                this.ps = false;
                break;
        }
        super.i7(a, b, c, d);
        switch (b) {
            case PriceChannelOverlay.$$p[0]:
                this.ps = false;
                this.jl(false);
                break;
        }
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.nb == null || this.nc == null) {
            d = false;
        }
        return d;
    }
    pt() {
        this.pz.clear();
        this.py.clear();
        let a = truncate(MathUtil.b(this.p0, 0, this.bz.count));
        let b = Math.min(this.nb.count, this.nc.count);
        let c = this.n2(this.nb);
        let d = this.n2(this.nc);
        for (let e = 0; e < b; e++) {
            let f = Math.min(a, e);
            let g = -1.7976931348623157E+308;
            let h = 1.7976931348623157E+308;
            for (let i = 0; i < f; i++) {
                if (!isNaN_(c.item(e - i))) {
                    g = Math.max(g, c.item(e - i));
                }
                if (!isNaN_(d.item(e - i))) {
                    h = Math.min(h, d.item(e - i));
                }
            }
            if (e == 0) {
                h = d.item(0);
                g = c.item(0);
            }
            this.pz.add(g);
            this.py.add(h);
        }
        return true;
    }
    o9(a, b) {
        super.o9(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = new ScalerParams(0, c, d, this.mi.ca, e);
        let g = new ScalerParams(0, c, d, this.m3.ca, e);
        g.b = this.eh();
        let h = this.mi;
        let i = this.m3;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.mi);
        if (k != null && k.i$b.count != this.bz.count) {
            return;
        }
        j = this.n9(c, d, e);
        if (!this.ps) {
            this.ps = this.pt();
        }
        g.b = this.eh();
        let l = this.mi.d1(2, f) - this.mi.d1(1, f);
        for (let m = b.bu.c; m <= b.bu.d; ++m) {
            let n;
            if (k == null) {
                n = b.bu.getBucket(m);
            }
            else {
                let o = k.i$b._inner[m];
                let p = k.i$d(o);
                let q = this.pz._inner[m];
                let r = this.py._inner[m];
                let s = q;
                let t = r;
                let u = p;
                while (m < b.bu.d) {
                    o = k.i$b._inner[m + 1];
                    u = k.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s = Math.max(q, this.pz._inner[m]);
                    t = Math.min(r, this.py._inner[m]);
                }
                if (!isInfinity(t) && !isInfinity(s)) {
                    let v = NaN;
                    if (!isNaN_(p)) {
                        v = this.mi.dy(p, f);
                    }
                    n = [v, t, s];
                }
                else {
                    n = [NaN, NaN, NaN];
                }
            }
            let w = Math.max(1, l);
            if (!isNaN_(n[0]) && m * w >= this.pu) {
                if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
                    n[0] = n[0] + j;
                }
                else {
                    n[0] = h.dy(n[0], f) + j;
                }
                n[1] = i.dy(n[1], g);
                n[2] = i.dy(n[2], g);
                a.f.add(n);
            }
        }
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (c != null) {
            c.b1();
        }
    }
    pb(a, b) {
        super.pb(a, b);
        let c = typeCast(PriceChannelOverlayView.$, b);
        if (c == null) {
            return;
        }
        let d = this.getEffectiveViewport1(b);
        if (b.bx(a)) {
            c.b1();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[e - 1 - j][2];
            c.b2(e, f, g, h, i);
            b.bz(a);
        }
        this.mq.x(this, this.nq(), this.mi, runOn(this, this.ma), this.of(b), this.oh(b));
        let j = false;
        let k = this.mq.c;
        let l = a.f;
        let m = this.bz.count;
        if (k != null) {
            j = true;
        }
        if (j) {
            let n = new ScalerParams(0, b.bs, b.br, this.mi.ca, d);
            this.o8(l, -1, m, this.mi, n, b.n);
        }
        let o = c.b8;
        let p = c.b9;
        let q = c.b4;
        this.mq.ae(o, true, false, true, true);
        this.mq.ae(p, true, false, true, true);
        this.mq.ae(q, false, true, false, false);
        q._opacity = this.mq.i * this.d6;
    }
    bf() {
        return new PriceChannelOverlayView(this);
    }
    i2(a) {
        super.i2(a);
        this.px = typeCast(PriceChannelOverlayView.$, a);
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.mi.ca, d);
        let f = this.n9(this.bs.n2, this.bi.br, d);
        return this.ep(new RangeValueList(this.pz, this.py), a, this.mi, e, f, runOn(this, this.n8), b, c);
    }
    fc(a, b) {
        if (this.pz == null || this.py == null) {
            return super.fc(a, b);
        }
        return this.fd(a, b, this.mi, runOn(this, this.n8), new RangeValueList(this.pz, this.py));
    }
    fe(a, b) {
        if (this.pz == null || this.py == null) {
            return super.fe(a, b);
        }
        return this.ff(a, b, this.mi, runOn(this, this.n8), new RangeValueList(this.pz, this.py));
    }
    eh() {
        return Series.ei(this.py, null);
    }
}
PriceChannelOverlay.$t = markType(PriceChannelOverlay, 'PriceChannelOverlay', FinancialOverlay.$);
PriceChannelOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, PriceChannelOverlay, 'raisePropertyChanged', ['Period:p0:p2', [1, 14]]);
/**
 * @hidden
 */
class PriceChannelBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c) {
            let d = -1.7976931348623157E+308;
            let e = 1.7976931348623157E+308;
            let f = 0;
            for (let g = b; g <= c; ++g) {
                if (!isNaN_(this.f.b0.pz._inner[g]) && !isNaN_(this.f.b0.py._inner[g])) {
                    d = Math.max(d, this.f.b0.pz._inner[g]);
                    e = Math.min(e, this.f.b0.py._inner[g]);
                    ++f;
                }
            }
            if (f > 0 && e != 1.7976931348623157E+308 && d != -1.7976931348623157E+308) {
                return [0.5 * (b + c), e, d];
            }
        }
        return [NaN, NaN, NaN];
    }
}
PriceChannelBucketCalculator.$t = markType(PriceChannelBucketCalculator, 'PriceChannelBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
class PriceChannelOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b5 = new Polygon();
        this.ca = new Polyline();
        this.cb = new Polyline();
        this.b0 = null;
        this.b3 = new Polygon();
        this.b6 = new Polyline();
        this.b7 = new Polyline();
        this.b0 = a;
    }
    get b4() {
        return this.b5;
    }
    get b8() {
        return this.ca;
    }
    get b9() {
        return this.cb;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    bv() {
        return new PriceChannelBucketCalculator(this);
    }
    b1() {
        this.b5.ak.clear();
        this.ca.ak.clear();
        this.cb.ak.clear();
        this.an();
    }
    b2(a, b, c, d, e) {
        for (let f of fromEnum(Flattener.d(a, b, d, this.e.eu))) {
            this.b5.ak.add({ $type: Point_$type, x: b(f), y: d(f) });
            this.ca.ak.add({ $type: Point_$type, x: b(f), y: d(f) });
        }
        for (let g of fromEnum(Flattener.d(a, c, e, this.e.eu))) {
            this.b5.ak.add({ $type: Point_$type, x: c(g), y: e(g) });
            this.cb.ak.add({ $type: Point_$type, x: c(g), y: e(g) });
        }
        this.an();
    }
    a9() {
        super.a9();
        this.b3.ak = this.b5.ak;
        this.b6.ak = this.ca.ak;
        this.b7.ak = this.cb.ak;
        let a = this.bl();
        this.b3._fill = a;
        this.b3._opacity = 1;
        this.b6._stroke = a;
        this.b6.ac = this.e.ey + 3;
        this.b7._stroke = a;
        this.b7.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b3);
                a.u(this.b6);
                a.u(this.b7);
            }
            else {
                a.t(this.b5);
                a.u(this.ca);
                a.u(this.cb);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPolygonData(a, this.b5, "fill", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.ca, "bottom", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.cb, "top", ["Upper"]);
    }
}
PriceChannelOverlayView.$t = markType(PriceChannelOverlayView, 'PriceChannelOverlayView', FinancialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPriceChannelOverlayComponent_1;
/**
 * Represents a IgxDataChartComponent Financial Price Channel Overlay series.
 * Default required members: High, Low
*
* You can use the `IgxPriceChannelOverlayComponent` to display price volatility.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-price-channel-overlay
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-price-channel-overlay>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxPriceChannelOverlayComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxPriceChannelOverlayComponent_PROVIDERS = [{ provide: IgxFinancialOverlayComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent) }];
let IgxPriceChannelOverlayComponent = IgxPriceChannelOverlayComponent_1 = class IgxPriceChannelOverlayComponent extends IgxFinancialOverlayComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PriceChannelOverlay();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current PriceChannelOverlay object.
     * The typical, and initial, value for Bollinger band periods is 14.
    *
    * You can use the `period` to set the moving average.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-price-channel-overlay
    * 		#series
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		period="14">
    *     </igx-price-channel-overlay>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 14;
    * ```
    */
    get period() {
        return this.i.p0;
    }
    set period(v) {
        this.i.p0 = +v;
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPriceChannelOverlayComponent.prototype, "period", null);
IgxPriceChannelOverlayComponent = IgxPriceChannelOverlayComponent_1 = __decorate([
    Component({
        selector: 'igx-price-channel-overlay',
        template: ``,
        providers: [{ provide: IgxFinancialOverlayComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPriceChannelOverlayComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPriceChannelOverlayComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPriceChannelOverlayModule = class IgxPriceChannelOverlayModule {
};
IgxPriceChannelOverlayModule = __decorate([
    NgModule({
        declarations: [IgxPriceChannelOverlayComponent],
        imports: [CommonModule, IgxOverlayProxyModule],
        exports: [IgxPriceChannelOverlayComponent, IgxOverlayProxyModule],
        entryComponents: []
    })
], IgxPriceChannelOverlayModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPriceChannelOverlayDynamicModule = class IgxPriceChannelOverlayDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPriceChannelOverlayComponent", IgxPriceChannelOverlayComponent);
        TypeRegistrar.register("PriceChannelOverlay", PriceChannelOverlay.$type);
    }
};
IgxPriceChannelOverlayDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPriceChannelOverlayModule],
        exports: [IgxPriceChannelOverlayModule],
        entryComponents: [IgxPriceChannelOverlayComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPriceChannelOverlayDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BollingerBandsOverlay extends FinancialOverlay {
    constructor() {
        super();
        this.p0 = 0;
        this.p1 = 0;
        this.py = new List$1(Number_$type, 0);
        this.pz = new List$1(Number_$type, 0);
        this.ab = BollingerBandsOverlay.$;
        this.ml = new CategoryFrame(4);
        this.mn = new CategoryFrame(4);
        this.mk = new CategoryFrame(4);
    }
    i7(a, b, c, d) {
        if (this.n1().contains(b)) {
            this.ps = false;
        }
        super.i7(a, b, c, d);
        switch (b) {
            case BollingerBandsOverlay.$$p[1]:
                this.ps = false;
                this.jl(false);
                break;
            case BollingerBandsOverlay.$$p[0]:
                this.jl(false);
                break;
        }
    }
    pt() {
        this.py.clear();
        this.pz.clear();
        let a = getEnumerator(TrendCalculators.e(new SafeEnumerable(this.n0), this.p3));
        let b = getEnumerator(TrendCalculators.f(new SafeEnumerable(this.n0), this.p3));
        this.p1 = 1.7976931348623157E+308;
        this.p0 = -1.7976931348623157E+308;
        let c = true;
        let d = true;
        let e = this.p2;
        while (c || d) {
            if (a.moveNext()) {
                this.py.add(a.current);
            }
            else {
                c = false;
            }
            if (b.moveNext()) {
                this.pz.add(b.current);
            }
            else {
                d = false;
            }
            if (c && d) {
                this.p1 = Math.min(this.p1, a.current - b.current * e);
                this.p0 = Math.max(this.p0, a.current + b.current * e);
            }
        }
        return true;
    }
    an(a) {
        if (this.py == null || this.pz == null || a == null || this.bz == null || a != this.m3) {
            return null;
        }
        let b = new AxisRange(this.p1, this.p0);
        return b;
    }
    o9(a, b) {
        super.o9(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.mi;
        let g = this.m3;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = new ScalerParams(0, c, d, g.ca, e);
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = typeCast(ISortingAxis_$type, this.mi);
        if (j != null && j.i$b.count != this.bz.count) {
            return;
        }
        let k = 0;
        k = this.n9(c, d, e);
        if (!this.ps) {
            this.ps = this.pt();
            if (this.m3 != null) {
                this.m3.co(true);
            }
        }
        i.b = this.eh();
        let l = this.mi.d1(2, h) - this.mi.d1(1, h);
        for (let m = b.bu.c; m <= b.bu.d; ++m) {
            let n;
            if (j == null) {
                n = b.bu.getBucket(m);
            }
            else {
                let o = j.i$b._inner[m];
                let p = j.i$d(o);
                let q = this.py._inner[m];
                let r = this.pz._inner[m];
                let s = q;
                let t = r;
                let u = p;
                let v = 1;
                while (m < b.bu.d) {
                    o = j.i$b._inner[m + 1];
                    u = j.i$d(o);
                    if (u - p > l) {
                        break;
                    }
                    m++;
                    s += this.py._inner[m];
                    t += this.pz._inner[m];
                    v++;
                }
                s /= v;
                t /= v;
                let w = s - t * this.p2;
                let x = s;
                let y = s + t * this.p2;
                let z = NaN;
                if (!isNaN_(p)) {
                    z = this.mi.dy(p, h);
                }
                n = [z, w, x, y];
            }
            let aa = Math.max(1, l);
            if (!isNaN_(n[0]) && m * aa >= this.pu) {
                if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
                    n[0] = n[0] + k;
                }
                else {
                    n[0] = f.dy(n[0], h) + k;
                }
                n[1] = g.dy(n[1], i);
                n[2] = g.dy(n[2], i);
                n[3] = g.dy(n[3], i);
                a.f.add(n);
            }
        }
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (c != null) {
            c.b1();
        }
    }
    en(a, b, c) {
        if (this.py == null) {
            return super.en(a, b, c);
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.n9(this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.mi.ca, d);
        f.c = this.bs.oh;
        return this.ep(this.py, a, this.mi, f, e, runOn(this, this.n8), b, c);
    }
    fe(a, b) {
        if (this.py == null) {
            return super.fe(a, b);
        }
        return this.ff(a, b, this.mi, runOn(this, this.n8), this.py);
    }
    fc(a, b) {
        if (this.py == null) {
            return super.fc(a, b);
        }
        return this.fd(a, b, this.mi, runOn(this, this.n8), this.py);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (!this.nr(this.n1())) {
            d = false;
        }
        return d;
    }
    pb(a, b) {
        super.pb(a, b);
        let c = typeCast(BollingerBandsOverlayView.$, b);
        let d = this.getEffectiveViewport1(b);
        if (b.bx(a)) {
            c.b1();
            let e = a.f.count;
            let f = (g) => a.f._inner[g][0];
            let g = (h) => a.f._inner[e - 1 - h][0];
            let h = (i) => a.f._inner[i][1];
            let i = (j) => a.f._inner[j][2];
            let j = (k) => a.f._inner[e - 1 - k][3];
            c.b2(e, f, g, h, i, j);
            b.bz(a);
        }
        this.mq.x(this, this.nq(), this.mi, runOn(this, this.ma), this.of(b), this.oh(b));
        let k = false;
        let l = this.mq.c;
        let m = a.f;
        let n = this.bz.count;
        if (l != null) {
            k = true;
        }
        if (k) {
            let o = new ScalerParams(0, b.bs, b.br, this.mi.ca, d);
            this.o8(m, -1, n, this.mi, o, b.n);
        }
        let p = c.b9;
        let q = c.ca;
        let r = c.cb;
        let s = c.b4;
        this.mq.ae(q, true, false, true, true);
        this.mq.ao = null;
        this.mq.an = null;
        this.mq.ae(p, true, false, false, true);
        this.mq.ae(r, true, false, false, true);
        this.mq.ae(s, false, true, false, false);
        s._opacity = this.mq.i * this.d6;
    }
    bf() {
        return new BollingerBandsOverlayView(this);
    }
    i2(a) {
        super.i2(a);
        this.px = typeCast(BollingerBandsOverlayView.$, a);
    }
    oi() {
        return 3;
    }
    eh() {
        return Series.ei(this.py, null);
    }
}
BollingerBandsOverlay.$t = markType(BollingerBandsOverlay, 'BollingerBandsOverlay', FinancialOverlay.$);
BollingerBandsOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, BollingerBandsOverlay, 'raisePropertyChanged', ['Multiplier:p2:p6', [1, 2], 'Period:p3:p7', [1, 14]]);
/**
 * @hidden
 */
class BollingerBandsBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c) {
            let d = this.f.b0.p2;
            let e = 0;
            let f = 0;
            let g = 0;
            for (let h = b; h <= c; ++h) {
                if (!isNaN_(this.f.b0.py._inner[h]) && !isNaN_(this.f.b0.pz._inner[h])) {
                    e += this.f.b0.py._inner[h];
                    f += this.f.b0.pz._inner[h];
                    ++g;
                }
            }
            if (g > 0) {
                e = e / g;
                f = f / g;
                return [0.5 * (b + c), e - f * d, e, e + f * d];
            }
        }
        return [NaN, NaN, NaN, NaN];
    }
}
BollingerBandsBucketCalculator.$t = markType(BollingerBandsBucketCalculator, 'BollingerBandsBucketCalculator', FinancialBucketCalculator.$);
/**
 * @hidden
 */
class BollingerBandsOverlayView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b0 = null;
        this.b5 = new Polygon();
        this.cc = new Polyline();
        this.cd = new Polyline();
        this.ce = new Polyline();
        this.b3 = new Polygon();
        this.b6 = new Polyline();
        this.b7 = new Polyline();
        this.b8 = new Polyline();
        this.b0 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    bv() {
        return new BollingerBandsBucketCalculator(this);
    }
    b2(a, b, c, d, e, f) {
        for (let g of fromEnum(Flattener.d(a, b, d, this.e.eu))) {
            this.b5.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
            this.cc.ak.add({ $type: Point_$type, x: b(g), y: d(g) });
        }
        for (let h of fromEnum(Flattener.d(a, b, e, this.e.eu))) {
            this.cd.ak.add({ $type: Point_$type, x: b(h), y: e(h) });
        }
        for (let i of fromEnum(Flattener.d(a, c, f, this.e.eu))) {
            this.b5.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
            this.ce.ak.add({ $type: Point_$type, x: c(i), y: f(i) });
        }
        this.an();
    }
    b1() {
        this.b5.ak.clear();
        this.cc.ak.clear();
        this.cd.ak.clear();
        this.ce.ak.clear();
        this.an();
    }
    get b4() {
        return this.b5;
    }
    get b9() {
        return this.cc;
    }
    get ca() {
        return this.cd;
    }
    get cb() {
        return this.ce;
    }
    a9() {
        super.a9();
        this.b3.ak = this.b5.ak;
        this.b6.ak = this.cc.ak;
        this.b7.ak = this.cd.ak;
        this.b8.ak = this.ce.ak;
        let a = this.bl();
        this.b3._fill = a;
        this.b3._opacity = 1;
        this.b6._stroke = a;
        this.b6.ac = this.e.ey + 3;
        this.b7._stroke = a;
        this.b7.ac = this.e.ey + 3;
        this.b8._stroke = a;
        this.b8.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.b3);
                a.u(this.b6);
                a.u(this.b7);
                a.u(this.b8);
            }
            else {
                a.t(this.b5);
                a.u(this.cc);
                a.u(this.cd);
                a.u(this.ce);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPolygonData(a, this.b5, "FillShape", ["Fill"]);
        this.e.a2.exportPolylineData(a, this.cc, "BottomLine", ["Lower", "Main"]);
        this.e.a2.exportPolylineData(a, this.cd, "CentralLine", ["Central"]);
        this.e.a2.exportPolylineData(a, this.ce, "TopLine", ["Upper"]);
    }
}
BollingerBandsOverlayView.$t = markType(BollingerBandsOverlayView, 'BollingerBandsOverlayView', FinancialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxBollingerBandsOverlayComponent_1;
/**
 * Represents a IgxDataChartComponent Bollinger Bands financial overlay series.
 * Default required members: High, Low, Close
*
* You can use the `IgxBollingerBandsOverlayComponent` class represents a IgxDataChartComponent Bollinger Bands financial overlay series.
*
* ```html
* <igx-data-chart
* 	#chart
*     [dataSource]="data" >
*     <igx-category-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		#yAxis>
*     </igx-numeric-y-axis>
*     <igx-bollinger-band-overlay
* 		[xAxis]="xAxis"
* 		[yAxis]="yAxis"
* 		openMemberPath="open"
* 		highMemberPath="high"
* 		lowMemberPath="low"
* 		closeMemberPath="close">
*     </igx-bollinger-band-overlay>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxBollingerBandOverlayComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.openMemberPath = "open";
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* series.closeMemberPath = "close";
* this.chart.series.add(series);
* ```
*/
const IgxBollingerBandsOverlayComponent_PROVIDERS = [{ provide: IgxFinancialOverlayComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent) }];
let IgxBollingerBandsOverlayComponent = IgxBollingerBandsOverlayComponent_1 = class IgxBollingerBandsOverlayComponent extends IgxFinancialOverlayComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new BollingerBandsOverlay();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the moving average period for the current BollingerBandOverlay object.
     * The typical, and initial, value for Bollinger band periods is 14.
    *
    * You can use the `period` property for moving average of the current BollingerBandOverlay object.
    *
    * ```html
    * <igx-data-chart
    * 	#chart
    *     [dataSource]="data" >
    *     <igx-category-x-axis
    * 		label="label"
    * 		#xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    * 		#yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-bollinger-band-overlay
    * 		[xAxis]="xAxis"
    * 		[yAxis]="yAxis"
    * 		openMemberPath="open"
    * 		highMemberPath="high"
    * 		lowMemberPath="low"
    * 		closeMemberPath="close"
    * 		period="7">
    *     </igx-bollinger-band-overlay>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.series.period = 7;
    * ```
    */
    get period() {
        return this.i.p3;
    }
    set period(v) {
        this.i.p3 = +v;
    }
    /**
     * Gets or sets the moving average period for the current BollingerBandOverlay object.
     * The typical, and initial, value for Bollinger band multipliers is 2.
    *
    * You can use the `IgxBollingerBandsOverlayComponent`
    */
    get multiplier() {
        return this.i.p2;
    }
    set multiplier(v) {
        this.i.p2 = +v;
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBollingerBandsOverlayComponent.prototype, "period", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBollingerBandsOverlayComponent.prototype, "multiplier", null);
IgxBollingerBandsOverlayComponent = IgxBollingerBandsOverlayComponent_1 = __decorate([
    Component({
        selector: 'igx-bollinger-bands-overlay',
        template: ``,
        providers: [{ provide: IgxFinancialOverlayComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent_1) }, { provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBollingerBandsOverlayComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBollingerBandsOverlayComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBollingerBandsOverlayModule = class IgxBollingerBandsOverlayModule {
};
IgxBollingerBandsOverlayModule = __decorate([
    NgModule({
        declarations: [IgxBollingerBandsOverlayComponent],
        imports: [CommonModule, IgxOverlayProxyModule],
        exports: [IgxBollingerBandsOverlayComponent, IgxOverlayProxyModule],
        entryComponents: []
    })
], IgxBollingerBandsOverlayModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBollingerBandsOverlayDynamicModule = class IgxBollingerBandsOverlayDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBollingerBandsOverlayComponent", IgxBollingerBandsOverlayComponent);
        TypeRegistrar.register("BollingerBandsOverlay", BollingerBandsOverlay.$type);
    }
};
IgxBollingerBandsOverlayDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBollingerBandsOverlayModule],
        exports: [IgxBollingerBandsOverlayModule],
        entryComponents: [IgxBollingerBandsOverlayComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBollingerBandsOverlayDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOverlaysModule = class IgxOverlaysModule {
};
IgxOverlaysModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPriceChannelOverlayModule,
            IgxBollingerBandsOverlayModule
        ],
        imports: [CommonModule, IgxPriceChannelOverlayModule,
            IgxBollingerBandsOverlayModule
        ],
        entryComponents: []
    })
], IgxOverlaysModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxOverlaysDynamicModule = class IgxOverlaysDynamicModule {
};
IgxOverlaysDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPriceChannelOverlayDynamicModule,
            IgxBollingerBandsOverlayDynamicModule,
            IgxOverlaysModule
        ],
        imports: [CommonModule, IgxPriceChannelOverlayDynamicModule,
            IgxBollingerBandsOverlayDynamicModule,
            IgxOverlaysModule
        ],
        entryComponents: []
    })
], IgxOverlaysDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a column that is calculated based on the values of other columns.
*/
class IgxCalculatedColumn {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    [Symbol.iterator]() {
        return new EnumeratorWrapper(this.i.getEnumerator());
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFinancialPriceSeriesProxy_$type = new Type(null, 'IFinancialPriceSeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialPriceSeriesProxy extends Base {
    getCloseMemberPath(a) {
        return a.om;
    }
    getHighMemberPath(a) {
        return a.op;
    }
    getLowMemberPath(a) {
        return a.ou;
    }
    getOpenMemberPath(a) {
        return a.oy;
    }
    getVolumeMemberPath(a) {
        return a.o2;
    }
    matchesType(a) {
        if (!a.cr) {
            return false;
        }
        if (stringEndsWith(getInstanceType(a).typeName, "Indicator") || stringEndsWith(getInstanceType(a).typeName, "Overlay")) {
            return false;
        }
        return true;
    }
    setCategoryMode(a, b) {
        a.mp = b;
    }
    setCloseMemberPath(a, b) {
        a.om = b;
    }
    setDisplayType(a, b) {
        a.pu = b;
    }
    setHighMemberPath(a, b) {
        a.op = b;
    }
    setLowMemberPath(a, b) {
        a.ou = b;
    }
    setOpenMemberPath(a, b) {
        a.oy = b;
    }
    setVolumeMemberPath(a, b) {
        a.o2 = b;
    }
    setXAxis(a, b) {
        a.mi = b;
    }
    setYAxis(a, b) {
        a.m3 = b;
    }
}
FinancialPriceSeriesProxy.$t = markType(FinancialPriceSeriesProxy, 'FinancialPriceSeriesProxy', Base.$, [IFinancialPriceSeriesProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialPriceSeriesProxyModule = class IgxFinancialPriceSeriesProxyModule {
    constructor() {
        TypeRegistrar.register('FinancialPriceSeriesProxy', FinancialPriceSeriesProxy.$type);
        TypeRegistrar.register('FinancialEventArgs', FinancialEventArgs.$type);
        TypeRegistrar.registerCons('igx-financial-event-args', IgxFinancialEventArgs);
    }
};
IgxFinancialPriceSeriesProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialPriceSeriesProxyModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialPriceSeriesProxyDynamicModule = class IgxFinancialPriceSeriesProxyDynamicModule {
    constructor() {
        TypeRegistrar.register('FinancialPriceSeriesProxy', FinancialPriceSeriesProxy.$type);
        TypeRegistrar.register('FinancialEventArgs', FinancialEventArgs.$type);
        TypeRegistrar.registerCons('igx-financial-event-args', IgxFinancialEventArgs);
    }
};
IgxFinancialPriceSeriesProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialPriceSeriesProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialPriceBucketCalculator extends FinancialBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        let b = a * this.b;
        let c = Math.min(b + this.b - 1, this.a.bw.bz.count - 1);
        if (b <= c && b >= 0 && c >= 0) {
            let d = this.a.bw.nd.item(b);
            let e = Number.NEGATIVE_INFINITY;
            let f = Number.POSITIVE_INFINITY;
            let g = this.a.bw.na.item(c);
            for (let h = b; h <= c; ++h) {
                e = Math.max(e, this.a.bw.nb.item(h));
                f = Math.min(f, this.a.bw.nc.item(h));
            }
            f = Math.min(d, f);
            e = Math.max(g, e);
            return [0.5 * (b + c), d, e, f, g];
        }
        return [NaN, NaN, NaN, NaN, NaN];
    }
}
FinancialPriceBucketCalculator.$t = markType(FinancialPriceBucketCalculator, 'FinancialPriceBucketCalculator', FinancialBucketCalculator.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available display types of financial price series.
 */
var PriceDisplayType;
(function (PriceDisplayType) {
    /**
     * Displays prices as a Japanese Candlestick.
     */
    PriceDisplayType[PriceDisplayType["Candlestick"] = 0] = "Candlestick";
    /**
     * Displays prices as an OHLC bar.
     */
    PriceDisplayType[PriceDisplayType["OHLC"] = 1] = "OHLC";
})(PriceDisplayType || (PriceDisplayType = {}));
/**
 * @hidden
 */
let PriceDisplayType_$type = markEnum('PriceDisplayType', 'Candlestick,0|OHLC,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialPriceSeries extends FinancialSeries {
    constructor() {
        super();
        this.ab = FinancialPriceSeries.$;
        this.ml = new CategoryFrame(5);
        this.mn = new CategoryFrame(5);
        this.mk = new CategoryFrame(5);
    }
    bf() {
        return new FinancialPriceSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pt = a;
    }
    get qd() {
        return this.c(FinancialPriceSeries.p3);
    }
    set qd(a) {
        this.h(FinancialPriceSeries.p3, a);
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.mi != null && typeCast(ISortingAxis_$type, this.mi) !== null) {
            this.mi.i$i();
        }
        this.pt.bu.e(this.eu);
        if (this.pt.b4) {
            this.pt.b2.g$e(a, b, c, d);
        }
        if (this.m3 != null) {
            this.m3.cn();
        }
        this.jl(true);
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    l4(a) {
        if (this.mk == null || this.mk.f.count == 0) {
            return Rect.empty;
        }
        let b = this.lq(a);
        let c = this.bi.bs;
        let d = this.bi.br;
        let e = this.getEffectiveViewport1(this.bi);
        let f = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), a, true);
        let g = f[0];
        let h = f[1];
        let i = Math.abs(b.x - g[0]);
        let j = Math.abs(b.x - h[0]);
        let k = this.pv(this.my, e);
        k = Math.max(k, 3);
        let l = (k - 1) / 2;
        if (i < j) {
            let m = g[0] - l;
            let n = g[0];
            let o = g[0] + l;
            let p = g[1];
            let q = g[2];
            let r = g[3];
            let s = g[4];
            let t = Math.min(Math.min(Math.min(p, q), r), s);
            let u = Math.max(Math.max(Math.max(p, q), r), s);
            return new Rect(0, m, t, Math.abs(o - m), u - t);
        }
        else {
            let v = h[0] - l;
            let w = h[0];
            let x = h[0] + l;
            let y = h[1];
            let z = h[2];
            let aa = h[3];
            let ab = h[4];
            let ac = Math.min(Math.min(Math.min(y, z), aa), ab);
            let ad = Math.max(Math.max(Math.max(y, z), aa), ab);
            return new Rect(0, v, ac, Math.abs(x - v), ad - ac);
        }
    }
    ps(a, b) {
        let c = a[0] - b;
        let d = a[0];
        let e = a[0] + b;
        let f = a[1];
        let g = a[2];
        let h = a[3];
        let i = a[4];
        let j = Math.min(Math.min(Math.min(f, g), h), i);
        let k = Math.max(Math.max(Math.max(f, g), h), i);
        let l = Math.min(g, h);
        let m = Math.max(g, h);
        let n = Math.min(f, i);
        let o = Math.max(f, i);
        if (this.pu == 1) {
            let p = new Array(3);
            let q = new Rect(0, c, f, b, 0);
            let r = new Rect(0, d, i, b, 0);
            let s = new Rect(0, d, l, 0, m - l);
            p[0] = q;
            p[1] = r;
            p[2] = s;
            return p;
        }
        else {
            let t = new Array(2);
            let u = new Rect(0, d, l, 0, m - l);
            let v = new Rect(0, c, n, b * 2, o - n);
            t[0] = u;
            t[1] = v;
            return t;
        }
    }
    ak(a) {
        let b = new List$1(Rect.$, 0);
        let c = this.lq(a);
        let d = this.bi.bs;
        let e = this.bi.br;
        let f = this.getEffectiveViewport1(this.bi);
        let g = this.aj(this.mi, this.mk.f, this.of(this.bi), this.oh(this.bi), a, true);
        let h = g[0];
        let i = g[1];
        let j = Math.abs(c.x - h[0]);
        let k = Math.abs(c.x - i[0]);
        let l = this.pv(this.my, f);
        l = Math.max(l, 3);
        let m = (l - 1) / 2;
        if (j < k) {
            return this.ps(h, m);
        }
        else {
            return this.ps(i, m);
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        return false;
    }
    dk(a, b) {
        let c = this.l5(a);
        if (c.isEmpty) {
            return false;
        }
        let d = RectUtil.r(c, (this.ey / 2) + this.ee(b));
        if (d.containsPoint(a)) {
            let e = this.al(a);
            if (e != null) {
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    let h = RectUtil.r(g, (this.ey / 2) + this.ee(b));
                    if (h.containsPoint(a)) {
                        return true;
                    }
                }
            }
        }
        return false;
    }
    i7(a, b, c, d) {
        switch (b) {
            case FinancialSeries.$$p[9]:
                this.pt.ca();
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pt.b2 = CategoryTrendLineManagerFactory.a(this.pt.b2, this.mi, this.j5, this, this.b2);
                }
                break;
        }
        super.i7(a, b, c, d);
        if (this.pt.b4 && this.pt.b2 != null && this.pt.b2.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        switch (b) {
            case FinancialPriceSeries.$$p[0]:
                if (this.j5 != null) {
                    this.p2();
                    this.mk.w();
                    this.pb(this.mk, this.pt);
                }
                this.it();
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case "TrendLineType":
                this.it();
                break;
            case FinancialSeries.$$p[5]:
            case FinancialPriceSeries.$$p[1]:
                this.i4();
                break;
        }
    }
    p2() {
        this.pt.ce();
        if (this.bh != null) {
            this.bh.ce();
        }
    }
    an(a) {
        if (a != null && a == this.m3 && this.nc != null && !isNaN_(this.nc.minimum) && this.nb != null && !isNaN_(this.nb.maximum)) {
            return new AxisRange(this.nc.minimum, this.nb.maximum);
        }
        return null;
    }
    ao(a) {
        if (a.isEmpty && this.bs != null) {
            a = this.bs.n2;
        }
        if (this.nc == null || this.nb == null) {
            return null;
        }
        let b = this.l0(this.bi);
        let c = new ScalerParams(0, a, this.bs.oh, this.mi.ca, this.getEffectiveViewport());
        let d = (this.mi.d1(b.left, c));
        let e = (this.mi.d1(b.right, c));
        let f = null;
        if (this.mi.cf) {
            f = this.mi;
            d = f.i$f(d);
            e = f.i$f(e);
        }
        else {
            d = Math.floor(d);
            e = Math.ceil(e);
        }
        d = Math.max(0, Math.min(this.nc.count - 1, d));
        e = Math.max(0, Math.min(this.nc.count - 1, e));
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        for (let i = truncate(d); i <= truncate(e); i++) {
            let j = i;
            if (f != null) {
                j = f.i$b._inner[i];
            }
            g = Math.min(g, this.nc.item(j));
            h = Math.max(h, this.nb.item(j));
        }
        return new AxisRange(g, h);
    }
    eh() {
        return Series.ei(this.nd, typeCast(ISortingAxis_$type, this.mi));
    }
    c9(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bi.bs;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.l2(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.mi != null) {
                let g = new ScalerParams(0, e, e, this.mi.ca, f);
                let h = this.mi.dy(b, g);
                if (h < c.left + 0.1 * c.width) {
                    h = h + 0.4 * c.width;
                }
                if (h > c.right - 0.1 * c.width) {
                    h = h - 0.4 * c.width;
                }
                c.x = h - 0.5 * c.width;
            }
            if (this.m3 != null && this.nc != null && this.nb != null && b < this.nc.count && b < this.nb.count) {
                let i = new ScalerParams(0, e, e, this.m3.ca, f);
                i.b = this.eh();
                let j = this.m3.dy(this.nc.item(b), i);
                let k = this.m3.dy(this.nb.item(b), i);
                if (!isNaN_(j) && !isNaN_(k)) {
                    let l = Math.abs(j - k);
                    if (c.height < l) {
                        c.height = l;
                        c.y = Math.min(j, k);
                    }
                    else {
                        if (j < c.top + 0.1 * c.height) {
                            j = j + 0.4 * c.height;
                        }
                        if (j > c.bottom - 0.1 * c.height) {
                            j = j - 0.4 * c.height;
                        }
                        c.y = j - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.nd == null || this.na == null || this.nb == null || this.nc == null) {
            d = false;
        }
        return d;
    }
    o9(a, b) {
        super.o9(a, b);
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.mi;
        let g = this.m3;
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, g.ca, e);
            $ret.b = this.eh();
            return $ret;
        })());
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = 0;
        let k = typeCast(ISortingAxis_$type, this.mi);
        if (k != null && (k.i$b == null || k.i$b.count != this.bz.count)) {
            return;
        }
        j = this.n9(c, d, e);
        let l = typeCast(FinancialPriceSeriesView.$, b);
        let m = this.eu;
        if (this.trendLineType != 0) {
            let n = new Array(this.bz.count);
            let o = 0;
            for (let p of fromEnum(this.n0)) {
                n[o] = p;
                o++;
            }
            if (this.pt.b4) {
                this.pt.b2.prepareLineCore(a.p, this.trendLineType, boxArray$1(n), this.trendLinePeriod, (q) => this.mi.dy(q, h), (q) => this.m3.dy(q, i), ((() => {
                    let $ret = new TrendResolutionParams();
                    $ret.c = b.bu.b;
                    $ret.d = b.bu.c;
                    $ret.e = b.bu.d;
                    $ret.a = j;
                    $ret.b = m;
                    $ret.f = d;
                    return $ret;
                })()));
            }
        }
        let q = this.mi.d1(2, h) - this.mi.d1(1, h);
        for (let r = b.bu.c; r <= b.bu.d; ++r) {
            let s;
            if (k == null) {
                s = b.bu.getBucket(r);
            }
            else {
                let t = k.i$b._inner[r];
                let u = k.i$d(t);
                let v = this.nd.item(t);
                let w = this.nb.item(t);
                let x = this.nc.item(t);
                let y = this.na.item(t);
                let z = v;
                let aa = w;
                let ab = x;
                let ac = y;
                let ad = u;
                while (r < b.bu.d) {
                    t = k.i$b._inner[r + 1];
                    ad = k.i$d(t);
                    if (ad - u > q * m) {
                        break;
                    }
                    r++;
                    aa = Math.max(aa, this.nb.item(t));
                    ab = Math.min(ab, this.nc.item(t));
                    ac = this.na.item(t);
                }
                let ae = NaN;
                if (!isNaN_(u)) {
                    ae = this.mi.dy(u, h);
                }
                s = [ae, z, aa, ab, ac];
            }
            if (!isNaN_(s[0])) {
                if (k != null) {
                    s[0] = s[0] + j;
                }
                else {
                    s[0] = f.dy(s[0], h) + j;
                }
                s[1] = g.dy(s[1], i);
                s[2] = g.dy(s[2], i);
                s[3] = g.dy(s[3], i);
                s[4] = g.dy(s[4], i);
                a.f.add(s);
            }
        }
        return;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = typeCast(FinancialPriceSeriesView.$, b);
        c.b8();
        if (a) {
            c.b3.count = 0;
        }
        if (c.b4 && c.b2 != null) {
            c.b2.g$d();
        }
    }
    get_nm() {
        return true;
    }
    pb(a, b) {
        super.pb(a, b);
        if (this.mi == null || this.m3 == null) {
            return;
        }
        let c = false;
        if (b.bx(a)) {
            c = true;
            b.bz(a);
        }
        this.mq.x(this, this.nq(), this.mi, runOn(this, this.ma), this.of(b), this.oh(b));
        let d = false;
        let e = this.mq.c;
        if (e != null) {
            d = true;
        }
        let f = typeCast(FinancialPriceSeriesView.$, b);
        f.b7();
        f.b5 = false;
        if (f.b4) {
            f.b2.g$d();
        }
        if (this.trendLineType != 0) {
            f.b2.g$g(a.p);
        }
        if (d) {
            this.p1(a, b, c);
        }
        else {
            f.b3.count = 0;
            this.p0(a, b);
        }
    }
    eg() {
        let a = this.getEffectiveViewport1(this.bi);
        return this.pv(this.my, a);
    }
    p1(a, b, c) {
        let d = this.pu;
        let e = this.getEffectiveViewport1(b);
        let f = this.pv(b, e);
        let g = (f - 1) / 2;
        let h = typeCast(FinancialPriceSeriesView.$, b);
        h.b5 = true;
        let i = a.f;
        let j = 0;
        let k = this.bz.count;
        let l = this.mi;
        let m = new ScalerParams(0, b.bs, b.br, l.ca, e);
        let n = this.lb;
        let o = this.po;
        if (o == null) {
            o = n;
        }
        let p = this.lc;
        let q = this.qe;
        if (q == null) {
            q = p;
        }
        for (let r = 0; r < i.count; ++r) {
            let s = i._inner[r][0] - g;
            let t = i._inner[r][0];
            let u = i._inner[r][0] + g;
            let v = i._inner[r][1];
            let w = i._inner[r][2];
            let x = i._inner[r][3];
            let y = i._inner[r][4];
            if (isNaN_(v) || isNaN_(w) || isNaN_(x) || isNaN_(y)) {
                continue;
            }
            let z = h.b3.item(j);
            j++;
            let aa = v < y;
            let ab = new PathGeometry();
            if (c) {
                switch (d) {
                    case 0:
                        if (aa) {
                            let ac = v;
                            v = y;
                            y = ac;
                        }
                        let ad = new PathFigure();
                        ad._startPoint = { $type: Point_$type, x: t, y: x };
                        ad._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        let ae = new PathFigure();
                        ae._startPoint = { $type: Point_$type, x: s, y: y };
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: v };
                            return $ret;
                        })()));
                        ae._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: s, y: y };
                            return $ret;
                        })()));
                        let af = new PathFigure();
                        af._startPoint = { $type: Point_$type, x: t, y: y };
                        af._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        ab.c.add(ad);
                        ab.c.add(ae);
                        ab.c.add(af);
                        break;
                    case 1:
                        let ag = new PathFigure();
                        ag._startPoint = { $type: Point_$type, x: s, y: v };
                        ag._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: v };
                            return $ret;
                        })()));
                        let ah = new PathFigure();
                        ah._startPoint = { $type: Point_$type, x: t, y: x };
                        ah._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: t, y: w };
                            return $ret;
                        })()));
                        let ai = new PathFigure();
                        ai._startPoint = { $type: Point_$type, x: t, y: y };
                        ai._segments.add(((() => {
                            let $ret = new LineSegment(1);
                            $ret.c = { $type: Point_$type, x: u, y: y };
                            return $ret;
                        })()));
                        ab.c.add(ag);
                        ab.c.add(ah);
                        ab.c.add(ai);
                        break;
                }
            }
            if (aa) {
                this.mq.al = o;
                this.mq.ah = o;
                this.mq.ai = q;
                this.mq.am = q;
                this.mq.f = true;
            }
            else {
                this.mq.al = n;
                this.mq.ah = n;
                this.mq.ai = p;
                this.mq.am = p;
                this.mq.f = false;
            }
            this.o8(i, r, k, l, m, b.n);
            if (d == 1) {
                this.mq.ae(z, true, false, false, false);
            }
            else {
                this.mq.ae(z, false, false, false, false);
            }
            if (c) {
                z.ak = ab;
            }
        }
        h.b3.count = j;
        h.b9();
    }
    pv(a, b) {
        let c = this.mi.jz(a.bs, a.br, b);
        c = Math.max(c, this.eu * 0.9);
        c = Math.max(c, 3);
        return c;
    }
    p0(a, b) {
        let c = this.pu;
        let d = this.getEffectiveViewport1(b);
        let e = this.pv(b, d);
        let f = (e - 1) / 2;
        let g = typeCast(FinancialPriceSeriesView.$, b);
        let h = g.ch();
        let i = g.cg();
        let j = a.f;
        for (let k = 0; k < j.count; ++k) {
            let l = j._inner[k][0] - f;
            let m = j._inner[k][0];
            let n = j._inner[k][0] + f;
            let o = j._inner[k][1];
            let p = j._inner[k][2];
            let q = j._inner[k][3];
            let r = j._inner[k][4];
            if (isNaN_(o) || isNaN_(p) || isNaN_(q) || isNaN_(r)) {
                continue;
            }
            let s = o < r;
            let t = s ? i : h;
            switch (c) {
                case 0:
                    if (s) {
                        let u = o;
                        o = r;
                        r = u;
                    }
                    t.d.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((() => {
                        let $ret = new RectangleGeometry();
                        $ret.e = new Rect(0, l, r, n - l, o - r);
                        return $ret;
                    })()));
                    t.d.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    break;
                case 1:
                    t.d.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: l, y: o };
                        $ret.c = { $type: Point_$type, x: m, y: o };
                        return $ret;
                    })()));
                    t.d.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: q };
                        $ret.c = { $type: Point_$type, x: m, y: p };
                        return $ret;
                    })()));
                    t.d.add(((() => {
                        let $ret = new LineGeometry();
                        $ret.d = { $type: Point_$type, x: m, y: r };
                        $ret.c = { $type: Point_$type, x: n, y: r };
                        return $ret;
                    })()));
                    break;
            }
        }
    }
    fv(a, b) {
        if (this.pt.b4 && a == this.pt.b2.g$j) {
            return null;
        }
        return super.fv(a, b);
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        this.pt.cf();
    }
    ic(a) {
        super.ic(a);
        if (this.pt.b4) {
            this.a2.exportTrendlineData(this, a, this.pt.b2.g$j);
        }
    }
    jq(a, b) {
        super.jq(a, b);
        this.qe = b;
    }
}
FinancialPriceSeries.$t = markType(FinancialPriceSeries, 'FinancialPriceSeries', FinancialSeries.$, [ITrendLineSeries_$type]);
FinancialPriceSeries.p3 = DependencyProperty.i("ActualTrendLineBrush", Brush.$, FinancialPriceSeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
FinancialPriceSeries.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialPriceSeries, 'raisePropertyChanged', ['DisplayType:pu:p4', [PriceDisplayType_$type, enumGetBox(PriceDisplayType_$type, 0)], 'NegativeOutline:qe:p5', [Brush.$, null], 'TrendLineType::qb', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::qa', [1, 1.5], 'TrendLinePeriod::p9', [1, 7], 'TrendLineBrush::p6', [Brush.$, null], 'TrendLineZIndex:px:qc', [1, 1001], 'TrendLineDashArray:qf:p7', [DoubleCollection.$], 'TrendLineDashCap:qg:p8', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class FinancialPriceSeriesView extends FinancialSeriesView {
    constructor(a) {
        super(a);
        this.b0 = null;
        this.b3 = null;
        this.b6 = null;
        this.ck = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.cj = ((() => {
            let $ret = new Path();
            $ret.ak = new GeometryGroup();
            return $ret;
        })());
        this.b1 = null;
        this.ci = new Path();
        this.b5 = false;
        this.b0 = a;
        this.b6 = new List$1(Path.$, 0);
        this.b3 = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.cl);
            $ret.activate = runOn(this, this.cb);
            $ret.disactivate = runOn(this, this.cd);
            $ret.destroy = runOn(this, this.cc);
            return $ret;
        })());
    }
    cl() {
        let a = new Path();
        this.b6.add(a);
        a._visibility = 1;
        return a;
    }
    cb(a) {
        a._visibility = 0;
    }
    cd(a) {
        a._visibility = 1;
    }
    cc(a) {
        this.b6.remove(a);
    }
    bv() {
        return new FinancialPriceBucketCalculator(this);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.bw.po = ((() => {
                let $ret = new Brush();
                $ret.fill = "#C62828";
                return $ret;
            })());
            this.b0.qe = this.bw.po;
            this.bw.eu = 5;
            this.bw.ey = 1;
        }
    }
    get b2() {
        if (this.b1 == null) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
        return this.b1;
    }
    set b2(a) {
        this.b1 = a;
    }
    get b4() {
        return this.b1 != null;
    }
    ce() {
        if (this.b0.pu == 1) {
            this.ck._stroke = this.e.lb;
        }
        else {
            this.ck._stroke = this.e.lc;
        }
        if (this.b0.pu == 1) {
            this.cj._stroke = this.bw.po;
        }
        else {
            this.cj._stroke = this.b0.qe;
        }
    }
    b8() {
        this.an();
        this.b3.count = 0;
        this.b7();
    }
    b7() {
        let a = typeCast(GeometryGroup.$, this.ck.ak);
        let b = typeCast(GeometryGroup.$, this.cj.ak);
        Extensions.d(a);
        Extensions.d(b);
    }
    ch() {
        this.an();
        return typeCast(GeometryGroup.$, this.ck.ak);
    }
    cg() {
        this.an();
        return typeCast(GeometryGroup.$, this.cj.ak);
    }
    cf() {
        this.b0.qd = null;
        if (this.b0.trendLineBrush != null) {
            this.b0.qd = this.b0.trendLineBrush;
        }
        else {
            this.b0.qd = this.b0.lb;
        }
    }
    a8() {
        super.a8();
        this.ck.ac = this.e.ey;
        this.ck.ai = this.e.ll;
        this.ck.ad = this.e.lm;
        if (this.b0.pu == 1) {
            this.ck._stroke = this.e.lb;
        }
        else {
            this.ck._stroke = this.e.lc;
            this.ck._fill = this.e.lb;
        }
        this.cj.ac = this.e.ey;
        this.cj.ai = this.e.ll;
        this.cj.ad = this.e.lm;
        if (this.b0.pu == 1) {
            this.cj._stroke = this.bw.po;
        }
        else {
            this.cj._stroke = this.b0.qe;
            this.cj._fill = this.bw.po;
        }
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.ck.ac = this.e.ey + 3;
        if (this.b0.pu == 1) {
            this.ck._stroke = a;
        }
        else {
            this.ck._stroke = a;
            this.ck._fill = a;
        }
        this.cj.ac = this.e.ey + 3;
        if (this.b0.pu == 1) {
            this.cj._stroke = a;
        }
        else {
            this.cj._stroke = a;
            this.cj._fill = a;
        }
    }
    z(a) {
        return this.b6._inner[a];
    }
    y(a) {
        let b = this.b6._inner[a];
        this.ci._visibility = b._visibility;
        this.ci.ak = b.ak;
        let c = this.bm(a);
        this.ci._fill = c;
        this.ci._stroke = c;
        this.ci.ac = this.e.ey + 3;
        return this.ci;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (this.b5) {
                for (let c = 0; c < this.b6.count; c++) {
                    let d = this.x(c, b);
                    if (d._visibility == 0) {
                        a.s(d);
                    }
                }
            }
            else {
                a.s(this.ck);
                a.s(this.cj);
            }
        }
    }
    a2(a, b) {
        if (a.d) {
            if (this.b0.trendLineType != 0 && !b) {
                let c = this.b2.g$j;
                c.ac = this.b0.trendLineThickness;
                c._stroke = this.b0.qd;
                c.ai = this.b0.qf;
                c.ad = this.b0.qg;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.ck, "positivePathShape", ["Positive", "Main"]);
        this.e.a2.exportPathData(a, this.cj, "negativePathShape", ["Negative"]);
    }
    b9() {
        this.an();
    }
    ca() {
        if (this.b4) {
            this.b1 = CategoryTrendLineManagerFactory.a(this.b1, this.e.ap(), this.e.j5, this.e, this.e.b2);
        }
    }
}
FinancialPriceSeriesView.$t = markType(FinancialPriceSeriesView, 'FinancialPriceSeriesView', FinancialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxFinancialPriceSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
 * Default required members: Open, Low, High, Close
*
* The `IgxFinancialPriceSeriesComponent` class represents a IgxDataChartComponent financial price series that renders as Candlestick or OHLC representations.
*
* ```html
*  <igx-data-chart
*     #chart
*         [dataSource]="data" >
*  <igx-ordinal-time-x-axis
*     dateTimeMemberPath="TimeStamp"
*     #xAxis >
*     </igx-ordinal-time-x-axis>
*  <igx-numeric-y-axis
*         minimumValue="0"
*         #yAxis>
* </igx-numeric-y-axis>
* <igx-financial-price-series
*     [xAxis]="xAxis"
*       [yAxis]="yAxis"
*       openMemberPath="open"
*       highMemberPath="high"
*       lowMemberPath="low"
*       closeMemberPath="close"
*       volumeMemberPath="volume"
*       >
* </igx-financial-price-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxFinancialPriceSeriesComponent();
*    series.xAxis = this.xAxis;
*    series.yAxis = this.yAxis;
*    series.openMemberPath = "open";
*    series.highMemberPath = "high";
*    series.lowMemberPath = "low";
*    series.closeMemberPath = "close";
*    series.volumeMemberPath="volume";
*    this.chart.series.add(series);
* ```
*/
const IgxFinancialPriceSeriesComponent_PROVIDERS = [{ provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFinancialPriceSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinancialPriceSeriesComponent) }];
let IgxFinancialPriceSeriesComponent = IgxFinancialPriceSeriesComponent_1 = class IgxFinancialPriceSeriesComponent extends IgxFinancialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new FinancialPriceSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the trend type for the current financial series.
    *
    * Use the `trendLineType` property for the trend type of the current financial series.
    *
    * ```ts
    * series.trendLineType= "CubicFit";
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       trendLineType="CubicFit">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get trendLineType() {
        return this.i.trendLineType;
    }
    set trendLineType(v) {
        this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush to use to draw the trend line.
    *
    * Use the `trendLineBrush` property to brush the the trend line.
    *
    * ```ts
    * series.trendLineBrush="red";
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *      trendLineBrush="red" >
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get trendLineBrush() {
        return brushToString(this.i.trendLineBrush);
    }
    set trendLineBrush(v) {
        this.i.trendLineBrush = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this FinancialPriceSeries.
    *
    * Use the `actualTrendLineBrush` property to Gets the effective TrendLineBrush for the FinancialIndicator.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.qd);
    }
    set actualTrendLineBrush(v) {
        this.i.qd = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current FinancialPriceSeries object's trend line.
    *
    * Use the `trendLineThickness` property for the thickness of the current FinancialPriceSeries object's trend line.
    *
    * ```ts
    * series.trendLineThickness=5;
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       trendLineThickness="3">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get trendLineThickness() {
        return this.i.trendLineThickness;
    }
    set trendLineThickness(v) {
        this.i.trendLineThickness = +v;
    }
    /**
     * Gets or sets the trend line period for the current series.
     * The typical, and initial, value for trend line period is 7.
    *
    * Use the `trendLinePeriod` property for the periodo the the current series.
    *
    * ```ts
    * series.trendLinePeriod= 7;
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       trendLinePeriod="7">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get trendLinePeriod() {
        return this.i.trendLinePeriod;
    }
    set trendLinePeriod(v) {
        this.i.trendLinePeriod = +v;
    }
    /**
     * Gets or sets the display type for the current FinancialPriceSeries object.
    *
    * Use the `displayType` property for the display type of the current FinancialPriceSeries object.
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       displayType="Candlestick">
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.displayType=PriceDisplayType.Candlestick;
    * ```
    */
    get displayType() {
        return this.i.pu;
    }
    set displayType(v) {
        this.i.pu = ensureEnum(PriceDisplayType_$type, v);
    }
    /**
     * Brush to use for outlining negative elements in the series.
    *
    * Use the `negativeOutline` property to brush the outline negative elements in the series.
    *
    * ```ts
    * series.negativeOutline="red";
    * ```
    *
    * ```html
    *  <igx-data-chart
    *     #chart
    *         [dataSource]="data" >
    *  <igx-ordinal-time-x-axis
    *     dateTimeMemberPath="TimeStamp"
    *     #xAxis >
    *     </igx-ordinal-time-x-axis>
    *  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    * </igx-numeric-y-axis>
    * <igx-financial-price-series
    *     [xAxis]="xAxis"
    *       [yAxis]="yAxis"
    *       openMemberPath="open"
    *       highMemberPath="high"
    *       lowMemberPath="low"
    *       closeMemberPath="close"
    *       volumeMemberPath="volume"
    *       negativeOutline="Red" >
    * </igx-financial-price-series>
    * </igx-data-chart>
    * ```
    */
    get negativeOutline() {
        return brushToString(this.i.qe);
    }
    set negativeOutline(v) {
        this.i.qe = stringToBrush(v);
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method return the best available value bounding box within the series that has the best value match for the world position provided.
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The categorySeries is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * The `scrollIntoView` methos scrolls the series to display the item for the specified data item.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * The `getItemSpan` method is used For a category plotted series, returns the current width of the items within the categories.
    *
    * This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
    setNegativeColors(negativeBrush, negativeOutline) {
        this.i.jq(stringToBrush(negativeBrush), stringToBrush(negativeOutline));
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialPriceSeriesComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialPriceSeriesComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialPriceSeriesComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialPriceSeriesComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialPriceSeriesComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialPriceSeriesComponent.prototype, "displayType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialPriceSeriesComponent.prototype, "negativeOutline", null);
IgxFinancialPriceSeriesComponent = IgxFinancialPriceSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-financial-price-series',
        template: ``,
        providers: [{ provide: IgxFinancialSeriesComponent, useExisting: forwardRef(() => IgxFinancialPriceSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFinancialPriceSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialPriceSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialPriceSeriesModule = class IgxFinancialPriceSeriesModule {
};
IgxFinancialPriceSeriesModule = __decorate([
    NgModule({
        declarations: [IgxFinancialPriceSeriesComponent],
        imports: [CommonModule, IgxFinancialPriceSeriesProxyModule],
        exports: [IgxFinancialPriceSeriesComponent, IgxFinancialPriceSeriesProxyModule],
        entryComponents: []
    })
], IgxFinancialPriceSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialPriceSeriesDynamicModule = class IgxFinancialPriceSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxFinancialPriceSeriesComponent", IgxFinancialPriceSeriesComponent);
        TypeRegistrar.register("FinancialPriceSeries", FinancialPriceSeries.$type);
    }
};
IgxFinancialPriceSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxFinancialPriceSeriesModule],
        exports: [IgxFinancialPriceSeriesModule],
        entryComponents: [IgxFinancialPriceSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialPriceSeriesDynamicModule);

/**
 * Represents a calculation strategy that takes in a column of values
 * and returns a resulting column of values.
*/
class IgxColumnSupportingCalculation {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a calculation strategy that uses the calculation data source
 * to product a column of values.
*
* `IgxDataSourceSupportingCalculation` class Represents a calculation strategy that uses the calculation data source to product a column of values.
*
*     DataSourceSupportingCalculation SC = new DataSourceSupportingCalculation();
*/
class IgxDataSourceSupportingCalculation {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndicatorPane extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.d = null;
        this.a = null;
    }
    h(a) {
        this.c = a;
        if (this.c == null) {
            return;
        }
        this.d = this.c.createElement("div");
        this.d.setStyleProperty("height", "100%");
        this.d.setStyleProperty("width", "100%");
        this.d.setStyleProperty("display", "grid");
        this.d.setStyleProperty("display", "-ms-grid");
        this.d.setStyleProperty("-ms-grid-columns", "100%");
        this.c.append(this.d);
        this.i();
    }
    i() {
        if (this.d == null) {
            return;
        }
        this.d.removeChildren();
        if (this.b == null) {
            return;
        }
        let a = "";
        for (let b = 0; b < this.b.count; b++) {
            let c = this.b._inner[b];
            let d = this.c.createElement("div");
            d.setStyleProperty("grid-row", (b + 1).toString());
            d.setStyleProperty("grid-column", (1).toString());
            d.setStyleProperty("-ms-grid-row", (b + 1).toString());
            d.setStyleProperty("-ms-grid-column", (1).toString());
            this.d.append(d);
            let e = this.c.getSubRenderer(d);
            c.provideContainer(e);
            a += " 1fr";
        }
        a = a.trim();
        this.d.setStyleProperty("-ms-grid-rows", a);
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.b;
        if (a != b) {
            this.a = a;
            this.g("IndicatorCharts", b, this.b);
        }
    }
    g(a, b, c) {
        switch (a) {
            case "IndicatorCharts":
                this.i();
                break;
        }
    }
    f() {
        if (this.b == null || this.c == null) {
            return;
        }
        for (let a of fromEnum(this.b)) {
            a.notifyContainerResized();
        }
    }
}
IndicatorPane.$t = markType(IndicatorPane, 'IndicatorPane');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available series types to display in the volume pane.
 */
var FinancialChartVolumeType;
(function (FinancialChartVolumeType) {
    /**
     * Do not display the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["None"] = 0] = "None";
    /**
     * Display column series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Column"] = 1] = "Column";
    /**
     * Display line series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Line"] = 2] = "Line";
    /**
     * Display area series in the volume pane.
     */
    FinancialChartVolumeType[FinancialChartVolumeType["Area"] = 3] = "Area";
})(FinancialChartVolumeType || (FinancialChartVolumeType = {}));
/**
 * @hidden
 */
let FinancialChartVolumeType_$type = markEnum('FinancialChartVolumeType', 'None,0|Column,1|Line,2|Area,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available X axis types in the Financial Chart.
 */
var FinancialChartXAxisMode;
(function (FinancialChartXAxisMode) {
    /**
     * An ordinal scale with time labels.
     * Items on an ordinal scale are consecutive and equidistant.
     */
    FinancialChartXAxisMode[FinancialChartXAxisMode["Ordinal"] = 0] = "Ordinal";
    /**
     * A time scale.
     * Items on a time scale are positioned according to their time values.
     */
    FinancialChartXAxisMode[FinancialChartXAxisMode["Time"] = 1] = "Time";
})(FinancialChartXAxisMode || (FinancialChartXAxisMode = {}));
/**
 * @hidden
 */
let FinancialChartXAxisMode_$type = markEnum('FinancialChartXAxisMode', 'Ordinal,0|Time,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available Y axis types in the Financial Chart.
 */
var FinancialChartYAxisMode;
(function (FinancialChartYAxisMode) {
    /**
     * A linear or logarithmic numeric scale.
     */
    FinancialChartYAxisMode[FinancialChartYAxisMode["Numeric"] = 0] = "Numeric";
    /**
     * A numeric scale where all values are scaled proportionally to a reference value.
     */
    FinancialChartYAxisMode[FinancialChartYAxisMode["PercentChange"] = 1] = "PercentChange";
})(FinancialChartYAxisMode || (FinancialChartYAxisMode = {}));
/**
 * @hidden
 */
let FinancialChartYAxisMode_$type = markEnum('FinancialChartYAxisMode', 'Numeric,0|PercentChange,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available price series types to display in the main chart.
 */
var FinancialChartType;
(function (FinancialChartType) {
    /**
     * Automatically determine the price series type to display in the main chart.
     */
    FinancialChartType[FinancialChartType["Auto"] = 0] = "Auto";
    /**
     * Display financial bar series in the main chart.
     */
    FinancialChartType[FinancialChartType["Bar"] = 1] = "Bar";
    /**
     * Display candlestick series in the main chart.
     */
    FinancialChartType[FinancialChartType["Candle"] = 2] = "Candle";
    /**
     * Display column series in the main chart.
     */
    FinancialChartType[FinancialChartType["Column"] = 3] = "Column";
    /**
     * Display line series in the main chart.
     */
    FinancialChartType[FinancialChartType["Line"] = 4] = "Line";
})(FinancialChartType || (FinancialChartType = {}));
/**
 * @hidden
 */
let FinancialChartType_$type = markEnum('FinancialChartType', 'Auto,0|Bar,1|Candle,2|Column,3|Line,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the available series types to display in the zoom slider pane.
 */
var FinancialChartZoomSliderType;
(function (FinancialChartZoomSliderType) {
    /**
     * Do not display the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["None"] = 0] = "None";
    /**
     * In the zoom slider pane, match the series type in the price pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Auto"] = 1] = "Auto";
    /**
     * Display financial bar series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Bar"] = 2] = "Bar";
    /**
     * Display candle series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Candle"] = 3] = "Candle";
    /**
     * Display column series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Column"] = 4] = "Column";
    /**
     * Display line series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Line"] = 5] = "Line";
    /**
     * Display an area series in the zoom slider pane.
     */
    FinancialChartZoomSliderType[FinancialChartZoomSliderType["Area"] = 6] = "Area";
})(FinancialChartZoomSliderType || (FinancialChartZoomSliderType = {}));
/**
 * @hidden
 */
let FinancialChartZoomSliderType_$type = markEnum('FinancialChartZoomSliderType', 'None,0|Auto,1|Bar,2|Candle,3|Column,4|Line,5|Area,6');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * An enum representing the time range presets on a financial chart range selector.
 */
var FinancialChartRangeSelectorOption;
(function (FinancialChartRangeSelectorOption) {
    /**
     * Include a preset button for one month in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneMonth"] = 0] = "OneMonth";
    /**
     * Include a preset button for three months in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["ThreeMonths"] = 1] = "ThreeMonths";
    /**
     * Include a preset button for six months in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["SixMonths"] = 2] = "SixMonths";
    /**
     * Include a preset button for year-to-date in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["YearToDate"] = 3] = "YearToDate";
    /**
     * Include a preset button for one year in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["OneYear"] = 4] = "OneYear";
    /**
     * Include a preset button for all data in the range selector.
     */
    FinancialChartRangeSelectorOption[FinancialChartRangeSelectorOption["All"] = 5] = "All";
})(FinancialChartRangeSelectorOption || (FinancialChartRangeSelectorOption = {}));
/**
 * @hidden
 */
let FinancialChartRangeSelectorOption_$type = markEnum('FinancialChartRangeSelectorOption', 'OneMonth,0|ThreeMonths,1|SixMonths,2|YearToDate,3|OneYear,4|All,5');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartRangeSelectorOptionCollection extends ObservableCollection$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    super(FinancialChartRangeSelectorOption_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialChartRangeSelectorOption_$type, 1, c);
                }
                break;
        }
    }
}
FinancialChartRangeSelectorOptionCollection.$t = markType(FinancialChartRangeSelectorOptionCollection, 'FinancialChartRangeSelectorOptionCollection', ObservableCollection$1.$.specialize(FinancialChartRangeSelectorOption_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TemplatedHtmlControl extends Base {
    constructor(a, b, c) {
        super();
        this.j = null;
        this.i = null;
        this.e = null;
        this.d = null;
        this.i = TemplatedHtmlControl.h(b, a, c);
        this.j = a;
    }
    static f(a, b) {
        for (let c = 0; c < a.getChildCount(); c++) {
            let d = a.getChildAt(c);
            if (d.getNativeElement() != null) {
                let ele_ = d.getNativeElement();
                if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                    return d;
                }
                let e = TemplatedHtmlControl.f(d, b);
                if (e != null) {
                    return e;
                }
            }
        }
        return null;
    }
    static a(a, b) {
        let c = new List$1(DomWrapper_$type, 0);
        for (let d = 0; d < a.getChildCount(); d++) {
            let e = a.getChildAt(d);
            if (e.getNativeElement() != null) {
                let ele_ = e.getNativeElement();
                if (b.toUpperCase() == (ele_.nodeName).toUpperCase()) {
                    c.add(e);
                }
                let f = TemplatedHtmlControl.a(e, b);
                if (f != null) {
                    c.o(f);
                }
            }
        }
        return c;
    }
    static h(a, b, c) {
        return a;
    }
    get g() {
        if (this.e == null && this.d != null) {
            return this.d.rootWrapper;
        }
        return this.e;
    }
    set g(a) {
        this.e = a;
    }
    l(a) {
        if (a == null) {
            if (this.g != null) {
                this.g.remove();
            }
            return;
        }
        this.d = a;
    }
    static c(a) {
        return null;
    }
    static n(a, b, c, d) {
        TemplatedHtmlControl.m(a, d.b1(b), c);
    }
    static m(a, b, c) {
        if (c == null) {
            return;
        }
        let d = c.querySelector(a);
        if (d == null) {
            return;
        }
        d.setText(b);
    }
    b() {
        if (this.d == null || this.d.rootWrapper == null) {
            return NaN;
        }
        let a = this.d.rootWrapper.getOffset();
        return this.d.rootWrapper.width() + (a == null ? 0 : a.left);
    }
    k() {
        if (this.d == null || this.d.rootWrapper == null) {
            return;
        }
        this.d.rootWrapper.hide();
    }
}
TemplatedHtmlControl.$t = markType(TemplatedHtmlControl, 'TemplatedHtmlControl');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartContext extends Base {
    constructor() {
        super(...arguments);
        this._vm = null;
        this._template = null;
        this._container = null;
        this._toolbarContainer = null;
        this._legendContainer = null;
        this._indicatorsContainer = null;
        this._volumeContainer = null;
        this._zoomContainer = null;
    }
    get vm() {
        return this._vm;
    }
    set vm(a) {
        this._vm = a;
    }
    get template() {
        return this._template;
    }
    set template(a) {
        this._template = a;
    }
    get container() {
        return this._container;
    }
    set container(a) {
        this._container = a;
    }
    get toolbarContainer() {
        return this._toolbarContainer;
    }
    set toolbarContainer(a) {
        this._toolbarContainer = a;
    }
    get legendContainer() {
        return this._legendContainer;
    }
    set legendContainer(a) {
        this._legendContainer = a;
    }
    get indicatorsContainer() {
        return this._indicatorsContainer;
    }
    set indicatorsContainer(a) {
        this._indicatorsContainer = a;
    }
    get volumeContainer() {
        return this._volumeContainer;
    }
    set volumeContainer(a) {
        this._volumeContainer = a;
    }
    get zoomContainer() {
        return this._zoomContainer;
    }
    set zoomContainer(a) {
        this._zoomContainer = a;
    }
}
FinancialChartContext.$t = markType(FinancialChartContext, 'FinancialChartContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartToolbarContext extends Base {
    constructor() {
        super(...arguments);
        this._vm = null;
        this._template = null;
        this._container = null;
    }
    get vm() {
        return this._vm;
    }
    set vm(a) {
        this._vm = a;
    }
    get template() {
        return this._template;
    }
    set template(a) {
        this._template = a;
    }
    get container() {
        return this._container;
    }
    set container(a) {
        this._container = a;
    }
}
FinancialChartToolbarContext.$t = markType(FinancialChartToolbarContext, 'FinancialChartToolbarContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartViewModel extends Base {
    constructor() {
        super(...arguments);
        this._toolbar = null;
    }
    get toolbar() {
        return this._toolbar;
    }
    set toolbar(a) {
        this._toolbar = a;
    }
}
FinancialChartViewModel.$t = markType(FinancialChartViewModel, 'FinancialChartViewModel');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartToolbarViewModel extends Base {
    constructor() {
        super(...arguments);
        this._financialChartRangeSelector = null;
        this._financialChartTypePicker = null;
        this._financialChartIndicatorMenu = null;
        this._isIndicatorMenuVisible = false;
    }
    get financialChartRangeSelector() {
        return this._financialChartRangeSelector;
    }
    set financialChartRangeSelector(a) {
        this._financialChartRangeSelector = a;
    }
    get financialChartTypePicker() {
        return this._financialChartTypePicker;
    }
    set financialChartTypePicker(a) {
        this._financialChartTypePicker = a;
    }
    get financialChartIndicatorMenu() {
        return this._financialChartIndicatorMenu;
    }
    set financialChartIndicatorMenu(a) {
        this._financialChartIndicatorMenu = a;
    }
    get isIndicatorMenuVisible() {
        return this._isIndicatorMenuVisible;
    }
    set isIndicatorMenuVisible(a) {
        this._isIndicatorMenuVisible = a;
    }
}
FinancialChartToolbarViewModel.$t = markType(FinancialChartToolbarViewModel, 'FinancialChartToolbarViewModel');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var FinancialOverlayType;
(function (FinancialOverlayType) {
    /**
     * Bollinger bands overlay.
     */
    FinancialOverlayType[FinancialOverlayType["BollingerBands"] = 0] = "BollingerBands";
    /**
     * Price channel overlay.
     */
    FinancialOverlayType[FinancialOverlayType["PriceChannel"] = 1] = "PriceChannel";
})(FinancialOverlayType || (FinancialOverlayType = {}));
/**
 * @hidden
 */
let FinancialOverlayType_$type = markEnum('FinancialOverlayType', 'BollingerBands,0|PriceChannel,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types of marker than can be displayed by default by series with markers.
 */
var FinancialIndicatorType;
(function (FinancialIndicatorType) {
    /**
     * Absolute volume oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AbsoluteVolumeOscillator"] = 0] = "AbsoluteVolumeOscillator";
    /**
     * Accumulation distribution indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AccumulationDistribution"] = 1] = "AccumulationDistribution";
    /**
     * Average directional index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AverageDirectionalIndex"] = 2] = "AverageDirectionalIndex";
    /**
     * Average true range indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["AverageTrueRange"] = 3] = "AverageTrueRange";
    /**
     * Bollinger band width indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["BollingerBandWidth"] = 4] = "BollingerBandWidth";
    /**
     * Chaikin oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ChaikinOscillator"] = 5] = "ChaikinOscillator";
    /**
     * Chaikin volatility indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ChaikinVolatility"] = 6] = "ChaikinVolatility";
    /**
     * Commodity channel index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["CommodityChannelIndex"] = 7] = "CommodityChannelIndex";
    /**
     * Detrended price oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["DetrendedPriceOscillator"] = 8] = "DetrendedPriceOscillator";
    /**
     * Ease of movement indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["EaseOfMovement"] = 9] = "EaseOfMovement";
    /**
     * Fast stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["FastStochasticOscillator"] = 10] = "FastStochasticOscillator";
    /**
     * Force index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["ForceIndex"] = 11] = "ForceIndex";
    /**
     * Full stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["FullStochasticOscillator"] = 12] = "FullStochasticOscillator";
    /**
     * Market facilitation index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MarketFacilitationIndex"] = 13] = "MarketFacilitationIndex";
    /**
     * Mass index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MassIndex"] = 14] = "MassIndex";
    /**
     * Median price indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MedianPrice"] = 15] = "MedianPrice";
    /**
     * Money flow index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MoneyFlowIndex"] = 16] = "MoneyFlowIndex";
    /**
     * Moving average convergence divergence (MACD) indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["MovingAverageConvergenceDivergence"] = 17] = "MovingAverageConvergenceDivergence";
    /**
     * Negative volume index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["NegativeVolumeIndex"] = 18] = "NegativeVolumeIndex";
    /**
     * On balance volume indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["OnBalanceVolume"] = 19] = "OnBalanceVolume";
    /**
     * Percentage price oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PercentagePriceOscillator"] = 20] = "PercentagePriceOscillator";
    /**
     * Percentage volume oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PercentageVolumeOscillator"] = 21] = "PercentageVolumeOscillator";
    /**
     * Positive volume index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PositiveVolumeIndex"] = 22] = "PositiveVolumeIndex";
    /**
     * Price volume trend indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["PriceVolumeTrend"] = 23] = "PriceVolumeTrend";
    /**
     * Rate of change and momentum indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["RateOfChangeAndMomentum"] = 24] = "RateOfChangeAndMomentum";
    /**
     * Relative strength index indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["RelativeStrengthIndex"] = 25] = "RelativeStrengthIndex";
    /**
     * Slow stochastic oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["SlowStochasticOscillator"] = 26] = "SlowStochasticOscillator";
    /**
     * Standard deviation indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["StandardDeviation"] = 27] = "StandardDeviation";
    /**
     * StochRSI indicator.
     * Stochastic Relative Strength Index.
     */
    FinancialIndicatorType[FinancialIndicatorType["StochRSI"] = 28] = "StochRSI";
    /**
     * TRIX indicator.
     * TRIple eXponential.
     */
    FinancialIndicatorType[FinancialIndicatorType["TRIX"] = 29] = "TRIX";
    /**
     * Typical price indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["TypicalPrice"] = 30] = "TypicalPrice";
    /**
     * Ultimate oscillator indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["UltimateOscillator"] = 31] = "UltimateOscillator";
    /**
     * Weighted close indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["WeightedClose"] = 32] = "WeightedClose";
    /**
     * Williams %R indicator.
     */
    FinancialIndicatorType[FinancialIndicatorType["WilliamsPercentR"] = 33] = "WilliamsPercentR";
})(FinancialIndicatorType || (FinancialIndicatorType = {}));
/**
 * @hidden
 */
let FinancialIndicatorType_$type = markEnum('FinancialIndicatorType', 'AbsoluteVolumeOscillator,0|AccumulationDistribution,1|AverageDirectionalIndex,2|AverageTrueRange,3|BollingerBandWidth,4|ChaikinOscillator,5|ChaikinVolatility,6|CommodityChannelIndex,7|DetrendedPriceOscillator,8|EaseOfMovement,9|FastStochasticOscillator,10|ForceIndex,11|FullStochasticOscillator,12|MarketFacilitationIndex,13|MassIndex,14|MedianPrice,15|MoneyFlowIndex,16|MovingAverageConvergenceDivergence,17|NegativeVolumeIndex,18|OnBalanceVolume,19|PercentagePriceOscillator,20|PercentageVolumeOscillator,21|PositiveVolumeIndex,22|PriceVolumeTrend,23|RateOfChangeAndMomentum,24|RelativeStrengthIndex,25|SlowStochasticOscillator,26|StandardDeviation,27|StochRSI,28|TRIX,29|TypicalPrice,30|UltimateOscillator,31|WeightedClose,32|WilliamsPercentR,33');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartRangeSelectorVisualData extends Base {
    constructor() {
        super(...arguments);
        this._visibility = null;
        this._buttonVisibilities = null;
        this._buttonLabels = null;
        this._buttonsChecked = null;
        this._buttonLefts = null;
        this._buttonTops = null;
        this._buttonWidths = null;
        this._buttonHeights = null;
        this._left = 0;
        this._top = 0;
        this._width = 0;
        this._height = 0;
    }
    get visibility() {
        return this._visibility;
    }
    set visibility(a) {
        this._visibility = a;
    }
    get buttonVisibilities() {
        return this._buttonVisibilities;
    }
    set buttonVisibilities(a) {
        this._buttonVisibilities = a;
    }
    get buttonLabels() {
        return this._buttonLabels;
    }
    set buttonLabels(a) {
        this._buttonLabels = a;
    }
    get buttonsChecked() {
        return this._buttonsChecked;
    }
    set buttonsChecked(a) {
        this._buttonsChecked = a;
    }
    get buttonLefts() {
        return this._buttonLefts;
    }
    set buttonLefts(a) {
        this._buttonLefts = a;
    }
    get buttonTops() {
        return this._buttonTops;
    }
    set buttonTops(a) {
        this._buttonTops = a;
    }
    get buttonWidths() {
        return this._buttonWidths;
    }
    set buttonWidths(a) {
        this._buttonWidths = a;
    }
    get buttonHeights() {
        return this._buttonHeights;
    }
    set buttonHeights(a) {
        this._buttonHeights = a;
    }
    get left() {
        return this._left;
    }
    set left(a) {
        this._left = a;
    }
    get top() {
        return this._top;
    }
    set top(a) {
        this._top = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    serialize() {
        return FinancialChartVisualData.y(["buttonLabels", "buttonsChecked", "buttonLefts", "buttonTops", "buttonWidths", "buttonHeights", "left", "top", "width", "height"], [this.buttonLabels, this.buttonsChecked, this.buttonLefts, this.buttonTops, this.buttonWidths, this.buttonHeights, this.left, this.top, this.width, this.height]);
    }
}
FinancialChartRangeSelectorVisualData.$t = markType(FinancialChartRangeSelectorVisualData, 'FinancialChartRangeSelectorVisualData');
/**
 * @hidden
 */
class FinancialChartEnumPickerVisualData extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.g = null;
        this.d = 0;
        this.e = 0;
        this.f = 0;
        this.c = 0;
        this.b = false;
    }
    h() {
        return FinancialChartVisualData.y(["items", "selectedItem", "left", "top", "width", "height", "isVisible"], [this.a, this.g, this.d, this.e, this.f, this.c, this.b]);
    }
}
FinancialChartEnumPickerVisualData.$t = markType(FinancialChartEnumPickerVisualData, 'FinancialChartEnumPickerVisualData');
/**
 * @hidden
 */
class FinancialChartToolbarVisualData extends Base {
    constructor() {
        super(...arguments);
        this._chartTypePicker = null;
        this._rangeSelector = null;
    }
    get chartTypePicker() {
        return this._chartTypePicker;
    }
    set chartTypePicker(a) {
        this._chartTypePicker = a;
    }
    get rangeSelector() {
        return this._rangeSelector;
    }
    set rangeSelector(a) {
        this._rangeSelector = a;
    }
    serialize() {
        return FinancialChartVisualData.y(["chartTypePicker", "rangeSelector"], [this.chartTypePicker == null ? null : this.chartTypePicker.h(), this.rangeSelector == null ? null : this.rangeSelector.serialize()]);
    }
}
FinancialChartToolbarVisualData.$t = markType(FinancialChartToolbarVisualData, 'FinancialChartToolbarVisualData');
/**
 * @hidden
 */
class FinancialChartVisualData extends Base {
    constructor() {
        super();
        this._mainChart = null;
        this._volumeChart = null;
        this._indicatorCharts = null;
        this._toolbar = null;
        this._zoomChart = null;
        this._mainChartLeft = 0;
        this._mainChartTop = 0;
        this._volumeChartLeft = 0;
        this._volumeChartTop = 0;
        this._indicatorChartLefts = null;
        this._indicatorChartTops = null;
        this._zoomChartLeft = 0;
        this._zoomChartTop = 0;
        this._toolbarLeft = 0;
        this._toolbarTop = 0;
        this._toolbarWidth = 0;
        this._toolbarHeight = 0;
        this._legendLeft = 0;
        this._legendTop = 0;
        this._legendWidth = 0;
        this._legendHeight = 0;
        this._legend = null;
        this.mainChartLeft = NaN;
        this.mainChartTop = NaN;
        this.volumeChartLeft = NaN;
        this.volumeChartTop = NaN;
        this.zoomChartLeft = NaN;
        this.zoomChartTop = NaN;
        this.indicatorChartLefts = new List$1(Number_$type, 0);
        this.indicatorChartTops = new List$1(Number_$type, 0);
    }
    get mainChart() {
        return this._mainChart;
    }
    set mainChart(a) {
        this._mainChart = a;
    }
    get volumeChart() {
        return this._volumeChart;
    }
    set volumeChart(a) {
        this._volumeChart = a;
    }
    get indicatorCharts() {
        return this._indicatorCharts;
    }
    set indicatorCharts(a) {
        this._indicatorCharts = a;
    }
    get toolbar() {
        return this._toolbar;
    }
    set toolbar(a) {
        this._toolbar = a;
    }
    get zoomChart() {
        return this._zoomChart;
    }
    set zoomChart(a) {
        this._zoomChart = a;
    }
    get mainChartLeft() {
        return this._mainChartLeft;
    }
    set mainChartLeft(a) {
        this._mainChartLeft = a;
    }
    get mainChartTop() {
        return this._mainChartTop;
    }
    set mainChartTop(a) {
        this._mainChartTop = a;
    }
    get volumeChartLeft() {
        return this._volumeChartLeft;
    }
    set volumeChartLeft(a) {
        this._volumeChartLeft = a;
    }
    get volumeChartTop() {
        return this._volumeChartTop;
    }
    set volumeChartTop(a) {
        this._volumeChartTop = a;
    }
    get indicatorChartLefts() {
        return this._indicatorChartLefts;
    }
    set indicatorChartLefts(a) {
        this._indicatorChartLefts = a;
    }
    get indicatorChartTops() {
        return this._indicatorChartTops;
    }
    set indicatorChartTops(a) {
        this._indicatorChartTops = a;
    }
    get zoomChartLeft() {
        return this._zoomChartLeft;
    }
    set zoomChartLeft(a) {
        this._zoomChartLeft = a;
    }
    get zoomChartTop() {
        return this._zoomChartTop;
    }
    set zoomChartTop(a) {
        this._zoomChartTop = a;
    }
    get toolbarLeft() {
        return this._toolbarLeft;
    }
    set toolbarLeft(a) {
        this._toolbarLeft = a;
    }
    get toolbarTop() {
        return this._toolbarTop;
    }
    set toolbarTop(a) {
        this._toolbarTop = a;
    }
    get toolbarWidth() {
        return this._toolbarWidth;
    }
    set toolbarWidth(a) {
        this._toolbarWidth = a;
    }
    get toolbarHeight() {
        return this._toolbarHeight;
    }
    set toolbarHeight(a) {
        this._toolbarHeight = a;
    }
    get legendLeft() {
        return this._legendLeft;
    }
    set legendLeft(a) {
        this._legendLeft = a;
    }
    get legendTop() {
        return this._legendTop;
    }
    set legendTop(a) {
        this._legendTop = a;
    }
    get legendWidth() {
        return this._legendWidth;
    }
    set legendWidth(a) {
        this._legendWidth = a;
    }
    get legendHeight() {
        return this._legendHeight;
    }
    set legendHeight(a) {
        this._legendHeight = a;
    }
    get legend() {
        return this._legend;
    }
    set legend(a) {
        this._legend = a;
    }
    ab(a) {
        if (a != null) {
            let chart_ = a;
            chart_.scaleByViewport();
        }
    }
    scaleByViewport() {
        this.ab(this.mainChart);
        this.ab(this.volumeChart);
        if (this.indicatorCharts != null) {
            for (let a = 0; a < this.indicatorCharts.count; a++) {
                this.ab(this.indicatorCharts._inner[a]);
            }
        }
        this.ab(this.zoomChart);
    }
    w(a) {
        if (a != null) {
            let chart_ = a;
            return (chart_.serialize());
        }
        return null;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        if (this.volumeChart != null) {
            a.u("volumeChart: " + this.w(this.volumeChart) + ",");
        }
        if (this.zoomChart != null) {
            a.u("zoomChart: " + this.w(this.zoomChart) + ",");
        }
        if (this.indicatorCharts != null) {
            a.u("indicatorCharts: [");
            for (let b = 0; b < this.indicatorCharts.count; b++) {
                if (b > 0) {
                    a.u(",");
                }
                a.l(this.w(this.indicatorCharts._inner[b]));
            }
            a.t();
            a.u("],");
        }
        if (this.toolbar != null) {
            a.u("toolbar: " + this.toolbar.serialize() + ",");
        }
        if (this.mainChart != null) {
            a.u("mainChart: " + this.w(this.mainChart) + ",");
        }
        a.u("mainChartLeft: " + this.mainChartLeft.toString() + ",");
        a.u("mainChartTop: " + this.mainChartTop.toString() + ",");
        a.u("volumeChartLeft: " + this.volumeChartLeft.toString() + ",");
        a.u("volumeChartTop: " + this.volumeChartTop.toString() + ",");
        a.u("zoomChartLeft: " + this.zoomChartLeft.toString() + ",");
        a.u("zoomChartTop: " + this.zoomChartTop.toString() + ",");
        a.u("toolbarLeft: " + this.toolbarLeft.toString() + ",");
        a.u("toolbarTop: " + this.toolbarTop.toString() + ",");
        a.u("toolbarWidth: " + this.toolbarWidth.toString() + ",");
        a.u("toolbarHeight: " + this.toolbarHeight.toString() + ",");
        a.u("indicatorChartLefts: [");
        for (let c = 0; c < this.indicatorChartLefts.count; c++) {
            if (c > 0) {
                a.u(",");
            }
            a.k(this.indicatorChartLefts._inner[c]);
        }
        a.t();
        a.u("],");
        a.u("indicatorChartTops: [");
        for (let d = 0; d < this.indicatorChartTops.count; d++) {
            if (d > 0) {
                a.u(",");
            }
            a.k(this.indicatorChartTops._inner[d]);
        }
        a.t();
        a.u("],");
        a.u(stringFormat("legendLeft: {0},", this.legendLeft));
        a.u(stringFormat("legendTop: {0},", this.legendTop));
        a.u(stringFormat("legendWidth: {0},", this.legendWidth));
        a.u(stringFormat("legendHeight: {0},", this.legendHeight));
        let e;
        if (this.legend != null) {
            e = (this.legend.serialize());
        }
        else {
            e = "null";
        }
        a.u(stringFormat("legend: {0}", e));
        a.u("}");
        return a.toString();
    }
    static y(a, b) {
        let c = new StringBuilder(0);
        c.u("{");
        for (let d = 0; d < a.length; d++) {
            c.l(a[d] + ": " + FinancialChartVisualData.aa(b[d]));
            if (d < a.length - 1) {
                c.l(", ");
            }
            c.t();
        }
        c.l("}");
        return c.toString();
    }
    static aa(a) {
        if (a == null) {
            return "null";
        }
        if (typeof a === 'string' && !stringStartsWith(a, "{")) {
            return "\"" + a + "\"";
        }
        if (typeCast(IList_$type, a) !== null) {
            return FinancialChartVisualData.z(a);
        }
        if (typeCast(Array_$type, a) !== null) {
            return FinancialChartVisualData.z(boxArray$1(a));
        }
        return a.toString();
    }
    static z(a) {
        if (a == null) {
            return "null";
        }
        let b = new StringBuilder(0);
        b.l("[");
        let c = 0;
        for (let d of fromEn(a)) {
            b.l(FinancialChartVisualData.aa(d));
            if (++c < a.count) {
                b.l(", ");
            }
        }
        b.l("]");
        return b.toString();
    }
}
FinancialChartVisualData.$t = markType(FinancialChartVisualData, 'FinancialChartVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartCustomIndicatorArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._indicatorInfo = null;
        this._series = null;
        this._index = 0;
        this.index = c;
        this.indicatorInfo = a;
        this.series = b;
    }
    get indicatorInfo() {
        return this._indicatorInfo;
    }
    set indicatorInfo(a) {
        this._indicatorInfo = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get index() {
        return this._index;
    }
    set index(a) {
        this._index = a;
    }
}
FinancialChartCustomIndicatorArgs.$t = markType(FinancialChartCustomIndicatorArgs, 'FinancialChartCustomIndicatorArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartDropDownControl extends TemplatedHtmlControl {
    constructor(a, b, c) {
        super(a, b, c);
        this.selectionChanged = null;
        this.o = null;
        this.p = null;
    }
    v() {
        if (this.selectionChanged != null) {
            this.selectionChanged(this, EventArgs.empty);
        }
    }
    l(a) {
        super.l(a);
        this.o.f(this.d, this.p, this.s, this.t);
    }
    get_q() {
        return false;
    }
    get q() {
        return this.get_q();
    }
    u(a) {
        if (this.p.isOpen) {
            let b = a.target;
            let c = b.matches(this.s + " *");
            let d = c || (this.q && b.matches(this.t + " *"));
            if (!d) {
                this.p.isOpen = false;
                this.p.updateUI();
            }
        }
    }
}
FinancialChartDropDownControl.$t = markType(FinancialChartDropDownControl, 'FinancialChartDropDownControl', TemplatedHtmlControl.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartDropDownControlViewModel extends Base {
    constructor() {
        super(...arguments);
        this._onSelectionChanged = null;
        this._isOpen = false;
        this._notifyChanged = null;
        this.a = null;
        this.b = null;
    }
    get onSelectionChanged() {
        return this._onSelectionChanged;
    }
    set onSelectionChanged(a) {
        this._onSelectionChanged = a;
    }
    get isOpen() {
        return this._isOpen;
    }
    set isOpen(a) {
        this._isOpen = a;
    }
    get notifyChanged() {
        return this._notifyChanged;
    }
    set notifyChanged(a) {
        this._notifyChanged = a;
    }
    updateUI() {
        if (this.notifyChanged != null) {
            this.notifyChanged();
        }
    }
    onButtonPressed() {
        this.isOpen = !this.isOpen;
        this.updateUI();
    }
    handleDropDownClick(a) {
        if (this.b != null) {
            this.b(a);
        }
    }
}
FinancialChartDropDownControlViewModel.$t = markType(FinancialChartDropDownControlViewModel, 'FinancialChartDropDownControlViewModel');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartTypePickerViewModel extends FinancialChartDropDownControlViewModel {
    constructor() {
        super(...arguments);
        this._chartType = 0;
    }
    get chartType() {
        return this._chartType;
    }
    set chartType(a) {
        this._chartType = a;
    }
    get chartTypeString() {
        return EnumUtil.getName(FinancialChartType_$type, this.chartType);
    }
}
FinancialChartTypePickerViewModel.$t = markType(FinancialChartTypePickerViewModel, 'FinancialChartTypePickerViewModel', FinancialChartDropDownControlViewModel.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartDropDownControlView extends Base {
    constructor() {
        super(...arguments);
        this.b = false;
        this.c = false;
        this.d = null;
        this.e = null;
        this.a = null;
    }
    i(a) {
        if (!this.b && !this.c) {
            this.g();
        }
        this.b = false;
        this.c = false;
    }
    h(a) {
        this.b = true;
    }
    k(a) {
    }
    j(a) {
        this.c = true;
        this.k(a.target);
    }
    f(a, b, c, d) {
        this.a = b;
        this.a.a = new SRProvider(a);
    }
    g() {
        this.a.isOpen = false;
        this.a.updateUI();
    }
}
FinancialChartDropDownControlView.$t = markType(FinancialChartDropDownControlView, 'FinancialChartDropDownControlView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartTypePickerView extends FinancialChartDropDownControlView {
    get l() {
        return this.a;
    }
    k(a) {
        super.k(a);
        let b = a;
        let c = b.parentNode;
        for (let d = 0; d < c.children.length; d++) {
            let e = c.children.item(d);
            if (e != b) {
                e.classList.remove("checked");
            }
        }
        let f = b.getAttribute("data-value");
        if (stringIsNullOrEmpty(f)) {
            return;
        }
        let g = EnumUtil.parse(FinancialChartType_$type, f, true);
        this.l.chartType = EnumUtil.getEnumValue(FinancialChartType_$type, g);
        this.g();
        this.a.onSelectionChanged();
    }
}
FinancialChartTypePickerView.$t = markType(FinancialChartTypePickerView, 'FinancialChartTypePickerView', FinancialChartDropDownControlView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartTypePicker extends FinancialChartDropDownControl {
    constructor(a) {
        super("financialChartTypePicker", a, FinancialChartTypePicker.z);
        this.o = new FinancialChartTypePickerView();
        this.p = new FinancialChartTypePickerViewModel();
        this.p.onSelectionChanged = runOn(this, this.v);
        this.p.b = runOn(this.o, this.o.j);
        this.o.a = this.p;
    }
    get w() {
        return this.y.chartType;
    }
    set w(a) {
        this.y.chartType = a;
    }
    get x() {
        return this.o;
    }
    get y() {
        return this.p;
    }
    get_s() {
        return ".financialChartTypePickerDropDownButton";
    }
    get s() {
        return this.get_s();
    }
    get_t() {
        return ".financialChartTypePickerDropDownMenu";
    }
    get t() {
        return this.get_t();
    }
}
FinancialChartTypePicker.$t = markType(FinancialChartTypePicker, 'FinancialChartTypePicker', FinancialChartDropDownControl.$);
FinancialChartTypePicker.z = "<button class='financialChartTypePickerDropDownButton' data-value='Auto'>\r\n\t\t<span class='ui-icon ui-icon-changeable'></span>\r\n\t\t<span class='ui-icon-toolbar-dd'></span>\r\n\t</button>\r\n\r\n\t<div class='financialChartTypePickerDropDownMenu'>\r\n\t\t<ul>\r\n\t\t\t<li class='financialChartListItem' data-value='Auto'>\r\n\t\t\t<span class='ui-icon ui-icon-chartAuto'></span>\r\n\t\t\t<span>Auto</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Bar'>\r\n\t\t\t\t<span class='ui-icon ui-icon-BarIcon'></span>\r\n\t\t\t\t<span>Bar</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Line'>\r\n\t\t\t\t<span class='ui-icon ui-icon-LineIcon'></span>\r\n\t\t\t\t<span>Line</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Candle'>\r\n\t\t\t\t<span class='ui-icon ui-icon-CandleIcon'></span>\r\n\t\t\t\t<span>Candle</span>\r\n\t\t\t</li>\r\n\t\t\t<li class='financialChartListItem' data-value='Column'>\r\n\t\t\t\t<span class='ui-icon ui-icon-ColumnIcon'></span>\r\n\t\t\t\t<span>Column</span>\r\n\t\t\t</li>\r\n\t\t</ul>\r\n\t</div>";

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenuViewModel extends FinancialChartDropDownControlViewModel {
    constructor() {
        super(...arguments);
        this.j = null;
        this.k = null;
        this.l = 0;
        this.i = 0;
        this.m = "Indicator";
        this.n = "Standalone Indicators";
        this.o = "Overlays";
        this.p = "Trendlines";
        this.q = "Volumes";
        this.r = "Absolute Volume Oscillator";
        this.s = "Accumulation Distribution";
        this.t = "Average Directional Index";
        this.u = "Average True Range";
        this.v = "Bollinger Band Width";
        this.w = "Chaikin Oscillator";
        this.x = "Chaikin Volatility";
        this.y = "Commodity Channel Index";
        this.z = "Detrended Price Oscillator";
        this.aa = "Ease Of Movement";
        this.ab = "Fast Stochastic Oscillator";
        this.ac = "Force Index";
        this.ad = "Full Stochastic Oscillator";
        this.ae = "Market Facilitation Index";
        this.af = "Mass Index";
        this.ag = "Median Price";
        this.ah = "Money Flow Index";
        this.ai = "MACD";
        this.aj = "Negative Volume Index";
        this.ak = "On Balance Volume";
        this.al = "Percentage Price Oscillator";
        this.am = "Percentage Volume Oscillator";
        this.an = "Positive Volume Index";
        this.ao = "Price Volume Trend";
        this.ap = "ROC";
        this.aq = "RSI";
        this.ar = "Slow Stochastic Oscillator";
        this.as = "Standard Deviation";
        this.at = "Stoch RSI";
        this.au = "TRIX";
        this.av = "Typical Price";
        this.aw = "Ultimate Oscillator";
        this.ax = "Weighted Closez";
        this.ay = "Williams %R";
        this.az = "Bollinger Bands";
        this.a0 = "Price Channel";
        this.a1 = "Cubic Fit";
        this.a2 = "Cumulative Average";
        this.a3 = "Exponential Average";
        this.a4 = "Exponential Fit";
        this.a5 = "Linear Fit";
        this.a6 = "Logarithmic Fit";
        this.a7 = "Modified Average";
        this.a8 = "PowerLaw Fit";
        this.a9 = "Quadratic Fit";
        this.ba = "Quartic Fit";
        this.bb = "Quintic Fit";
        this.bc = "Simple Average";
        this.bd = "Weighted Average";
        this.be = "Area";
        this.bf = "Column";
        this.bg = "Line";
    }
    get financialChart_IndicatorMenu_Header() {
        return !stringIsNullOrWhiteSpace(this.a.t) ? this.a.t : this.m;
    }
    get financialChart_IndicatorsMenu_Overlay_BollingerBands() {
        return !stringIsNullOrWhiteSpace(this.a.a6) ? this.a.a6 : this.az;
    }
    get financialChart_IndicatorsMenu_Overlay_PriceChannel() {
        return !stringIsNullOrWhiteSpace(this.a.a7) ? this.a.a7 : this.a0;
    }
    get financialChart_IndicatorMenu_IndicatorsCategoryHeader() {
        return !stringIsNullOrWhiteSpace(this.a.u) ? this.a.u : this.n;
    }
    get financialChart_IndicatorMenu_OverlaysCategoryHeader() {
        return !stringIsNullOrWhiteSpace(this.a.v) ? this.a.v : this.o;
    }
    get financialChart_IndicatorMenu_TrendlinesCategoryHeader() {
        return !stringIsNullOrWhiteSpace(this.a.w) ? this.a.w : this.p;
    }
    get financialChart_IndicatorMenu_VolumeCategoryHeader() {
        return !stringIsNullOrWhiteSpace(this.a.x) ? this.a.x : this.q;
    }
    get financialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.y) ? this.a.y : this.r;
    }
    get financialChart_IndicatorsMenu_Indicator_AccumulationDistribution() {
        return !stringIsNullOrWhiteSpace(this.a.z) ? this.a.z : this.s;
    }
    get financialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex() {
        return !stringIsNullOrWhiteSpace(this.a.aa) ? this.a.aa : this.t;
    }
    get financialChart_IndicatorsMenu_Indicator_AverageTrueRange() {
        return !stringIsNullOrWhiteSpace(this.a.ab) ? this.a.ab : this.u;
    }
    get financialChart_IndicatorsMenu_Indicator_BollingerBandWidth() {
        return !stringIsNullOrWhiteSpace(this.a.ac) ? this.a.ac : this.v;
    }
    get financialChart_IndicatorsMenu_Indicator_ChaikinOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.ad) ? this.a.ad : this.w;
    }
    get financialChart_IndicatorsMenu_Indicator_ChaikinVolatility() {
        return !stringIsNullOrWhiteSpace(this.a.ae) ? this.a.ae : this.x;
    }
    get financialChart_IndicatorsMenu_Indicator_CommodityChannelIndex() {
        return !stringIsNullOrWhiteSpace(this.a.af) ? this.a.af : this.y;
    }
    get financialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.ag) ? this.a.ag : this.z;
    }
    get financialChart_IndicatorsMenu_Indicator_EaseOfMovement() {
        return !stringIsNullOrWhiteSpace(this.a.ah) ? this.a.ah : this.aa;
    }
    get financialChart_IndicatorsMenu_Indicator_FastStochasticOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.ai) ? this.a.ai : this.ab;
    }
    get financialChart_IndicatorsMenu_Indicator_ForceIndex() {
        return !stringIsNullOrWhiteSpace(this.a.aj) ? this.a.aj : this.ac;
    }
    get financialChart_IndicatorsMenu_Indicator_FullStochasticOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.ak) ? this.a.ak : this.ad;
    }
    get financialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex() {
        return !stringIsNullOrWhiteSpace(this.a.al) ? this.a.al : this.ae;
    }
    get financialChart_IndicatorsMenu_Indicator_MassIndex() {
        return !stringIsNullOrWhiteSpace(this.a.am) ? this.a.am : this.af;
    }
    get financialChart_IndicatorsMenu_Indicator_MedianPrice() {
        return !stringIsNullOrWhiteSpace(this.a.an) ? this.a.an : this.ag;
    }
    get financialChart_IndicatorsMenu_Indicator_MoneyFlowIndex() {
        return !stringIsNullOrWhiteSpace(this.a.ao) ? this.a.ao : this.ah;
    }
    get financialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence() {
        return !stringIsNullOrWhiteSpace(this.a.ap) ? this.a.ap : this.ai;
    }
    get financialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex() {
        return !stringIsNullOrWhiteSpace(this.a.aq) ? this.a.aq : this.aj;
    }
    get financialChart_IndicatorsMenu_Indicator_OnBalanceVolume() {
        return !stringIsNullOrWhiteSpace(this.a.ar) ? this.a.ar : this.ak;
    }
    get financialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.as) ? this.a.as : this.al;
    }
    get financialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.at) ? this.a.at : this.am;
    }
    get financialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex() {
        return !stringIsNullOrWhiteSpace(this.a.au) ? this.a.au : this.an;
    }
    get financialChart_IndicatorsMenu_Indicator_PriceVolumeTrend() {
        return !stringIsNullOrWhiteSpace(this.a.av) ? this.a.av : this.ao;
    }
    get financialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum() {
        return !stringIsNullOrWhiteSpace(this.a.aw) ? this.a.aw : this.ap;
    }
    get financialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex() {
        return !stringIsNullOrWhiteSpace(this.a.ax) ? this.a.ax : this.aq;
    }
    get financialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.ay) ? this.a.ay : this.ar;
    }
    get financialChart_IndicatorsMenu_Indicator_StandardDeviation() {
        return !stringIsNullOrWhiteSpace(this.a.az) ? this.a.az : this.as;
    }
    get financialChart_IndicatorsMenu_Indicator_StochRSI() {
        return !stringIsNullOrWhiteSpace(this.a.a0) ? this.a.a0 : this.at;
    }
    get financialChart_IndicatorsMenu_Indicator_TRIX() {
        return !stringIsNullOrWhiteSpace(this.a.a1) ? this.a.a1 : this.au;
    }
    get financialChart_IndicatorsMenu_Indicator_TypicalPrice() {
        return !stringIsNullOrWhiteSpace(this.a.a2) ? this.a.a2 : this.av;
    }
    get financialChart_IndicatorsMenu_Indicator_UltimateOscillator() {
        return !stringIsNullOrWhiteSpace(this.a.a3) ? this.a.a3 : this.aw;
    }
    get financialChart_IndicatorsMenu_Indicator_WeightedClose() {
        return !stringIsNullOrWhiteSpace(this.a.a4) ? this.a.a4 : this.ax;
    }
    get financialChart_IndicatorsMenu_Indicator_WilliamsPercentR() {
        return !stringIsNullOrWhiteSpace(this.a.a5) ? this.a.a5 : this.ay;
    }
    get financialChart_IndicatorsMenu_TrendLine_CubicFit() {
        return !stringIsNullOrWhiteSpace(this.a.a8) ? this.a.a8 : this.a1;
    }
    get financialChart_IndicatorsMenu_TrendLine_CumulativeAverage() {
        return !stringIsNullOrWhiteSpace(this.a.a9) ? this.a.a9 : this.a2;
    }
    get financialChart_IndicatorsMenu_TrendLine_ExponentialAverage() {
        return !stringIsNullOrWhiteSpace(this.a.ba) ? this.a.ba : this.a3;
    }
    get financialChart_IndicatorsMenu_TrendLine_ExponentialFit() {
        return !stringIsNullOrWhiteSpace(this.a.bb) ? this.a.bb : this.a4;
    }
    get financialChart_IndicatorsMenu_TrendLine_LinearFit() {
        return !stringIsNullOrWhiteSpace(this.a.bc) ? this.a.bc : this.a5;
    }
    get financialChart_IndicatorsMenu_TrendLine_LogarithmicFit() {
        return !stringIsNullOrWhiteSpace(this.a.bd) ? this.a.bd : this.a6;
    }
    get financialChart_IndicatorsMenu_TrendLine_ModifiedAverage() {
        return !stringIsNullOrWhiteSpace(this.a.be) ? this.a.be : this.a7;
    }
    get financialChart_IndicatorsMenu_TrendLine_PowerLawFit() {
        return !stringIsNullOrWhiteSpace(this.a.bf) ? this.a.bf : this.a8;
    }
    get financialChart_IndicatorsMenu_TrendLine_QuadraticFit() {
        return !stringIsNullOrWhiteSpace(this.a.bg) ? this.a.bg : this.a9;
    }
    get financialChart_IndicatorsMenu_TrendLine_QuarticFit() {
        return !stringIsNullOrWhiteSpace(this.a.bh) ? this.a.bh : this.ba;
    }
    get financialChart_IndicatorsMenu_TrendLine_QuinticFit() {
        return !stringIsNullOrWhiteSpace(this.a.bi) ? this.a.bi : this.bb;
    }
    get financialChart_IndicatorsMenu_TrendLine_SimpleAverage() {
        return !stringIsNullOrWhiteSpace(this.a.bj) ? this.a.bj : this.bc;
    }
    get financialChart_IndicatorsMenu_TrendLine_WeightedAverage() {
        return !stringIsNullOrWhiteSpace(this.a.bk) ? this.a.bk : this.bd;
    }
    get financialChart_IndicatorsMenu_Volume_Area() {
        return !stringIsNullOrWhiteSpace(this.a.bl) ? this.a.bl : this.be;
    }
    get financialChart_IndicatorsMenu_Volume_Column() {
        return !stringIsNullOrWhiteSpace(this.a.bm) ? this.a.bm : this.bf;
    }
    get financialChart_IndicatorsMenu_Volume_Line() {
        return !stringIsNullOrWhiteSpace(this.a.bn) ? this.a.bn : this.bg;
    }
}
FinancialChartIndicatorMenuViewModel.$t = markType(FinancialChartIndicatorMenuViewModel, 'FinancialChartIndicatorMenuViewModel', FinancialChartDropDownControlViewModel.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialIndicatorTypeCollection extends ObservableCollection$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    super(FinancialIndicatorType_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialIndicatorType_$type, 1, c);
                }
                break;
        }
    }
}
FinancialIndicatorTypeCollection.$t = markType(FinancialIndicatorTypeCollection, 'FinancialIndicatorTypeCollection', ObservableCollection$1.$.specialize(FinancialIndicatorType_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialOverlayTypeCollection extends ObservableCollection$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    super(FinancialOverlayType_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(FinancialOverlayType_$type, 1, c);
                }
                break;
        }
    }
}
FinancialOverlayTypeCollection.$t = markType(FinancialOverlayTypeCollection, 'FinancialOverlayTypeCollection', ObservableCollection$1.$.specialize(FinancialOverlayType_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenuView extends FinancialChartDropDownControlView {
    f(a, b, c, d) {
        super.f(a, b, c, d);
    }
    k(a) {
        super.k(a);
        let b = a;
        if (b.tagName != "LI") {
            return;
        }
        let c = b.parentNode.parentNode;
        let d;
        let e = false;
        switch (c.getAttribute("data-value")) {
            case "FinancialOverlayType":
                d = FinancialOverlayType_$type;
                e = false;
                break;
            case "TrendLineType":
                d = TrendLineType_$type;
                e = true;
                break;
            case "FinancialChartVolumeType":
                d = FinancialChartVolumeType_$type;
                e = true;
                break;
            default:
            case "FinancialIndicatorType":
                d = FinancialIndicatorType_$type;
                e = false;
                break;
        }
        let f = b.classList.toggle("checked");
        let g = b.parentNode;
        if (e) {
            for (let h = 0; h < g.children.length; h++) {
                let i = g.children.item(h);
                if (i != b) {
                    i.classList.remove("checked");
                }
            }
            let j = f ? b.getAttribute("data-value") : "None";
            if (stringIsNullOrEmpty(j)) {
                return;
            }
            let k = EnumUtil.parse(d, j, true);
            if (d == FinancialChartVolumeType_$type) {
                this.l.i = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, k);
            }
            else {
                this.l.l = EnumUtil.getEnumValue(TrendLineType_$type, k);
            }
        }
        else {
            if (d == FinancialIndicatorType_$type) {
                this.l.j = new FinancialIndicatorTypeCollection(0);
                ;
            }
            else {
                this.l.k = new FinancialOverlayTypeCollection(0);
            }
            for (let l = 0; l < g.children.length; l++) {
                let m = g.children.item(l);
                if (m.classList.contains("checked")) {
                    let n = m.getAttribute("data-value");
                    if (stringIsNullOrEmpty(n)) {
                        continue;
                    }
                    let o = EnumUtil.parse(d, n, true);
                    if (d == FinancialIndicatorType_$type) {
                        let p = EnumUtil.getEnumValue(FinancialIndicatorType_$type, o);
                        this.l.j.add(p);
                    }
                    else {
                        let q = EnumUtil.getEnumValue(FinancialOverlayType_$type, o);
                        this.l.k.add(q);
                    }
                }
            }
        }
        this.a.onSelectionChanged();
    }
    get l() {
        return this.a;
    }
}
FinancialChartIndicatorMenuView.$t = markType(FinancialChartIndicatorMenuView, 'FinancialChartIndicatorMenuView', FinancialChartDropDownControlView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenu extends FinancialChartDropDownControl {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = [null];
                    {
                        let e = c[0];
                        super("financialChartIndicatorMenu", e, "");
                        this.o = new FinancialChartIndicatorMenuView();
                        this.p = new FinancialChartIndicatorMenuViewModel();
                        this.p.onSelectionChanged = runOn(this, this.v);
                        this.p.b = runOn(this.o, this.o.j);
                        this.o.a = this.p;
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super("financialChartIndicatorMenu", c, "");
                    this.o = new FinancialChartIndicatorMenuView();
                    this.p = new FinancialChartIndicatorMenuViewModel();
                    this.p.onSelectionChanged = runOn(this, this.v);
                    this.p.b = runOn(this.o, this.o.j);
                    this.o.a = this.p;
                }
                break;
        }
    }
    get_s() {
        return ".financialChartIndicatorMenuDropDownButton";
    }
    get s() {
        return this.get_s();
    }
    get_t() {
        return ".financialChartIndicatorMenuDropDownMenu";
    }
    get t() {
        return this.get_t();
    }
    get y() {
        return this.w.j;
    }
    get z() {
        return this.w.k;
    }
    get aa() {
        return this.w.l;
    }
    get x() {
        return this.w.i;
    }
    get w() {
        return this.p;
    }
    get_q() {
        return true;
    }
}
FinancialChartIndicatorMenu.$t = markType(FinancialChartIndicatorMenu, 'FinancialChartIndicatorMenu', FinancialChartDropDownControl.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenuContext extends Base {
    constructor() {
        super(...arguments);
        this._vm = null;
        this._template = null;
    }
    get vm() {
        return this._vm;
    }
    set vm(a) {
        this._vm = a;
    }
    get template() {
        return this._template;
    }
    set template(a) {
        this._template = a;
    }
}
FinancialChartIndicatorMenuContext.$t = markType(FinancialChartIndicatorMenuContext, 'FinancialChartIndicatorMenuContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartTypePickerContext extends Base {
    constructor() {
        super(...arguments);
        this._vm = null;
        this._template = null;
    }
    get vm() {
        return this._vm;
    }
    set vm(a) {
        this._vm = a;
    }
    get template() {
        return this._template;
    }
    set template(a) {
        this._template = a;
    }
}
FinancialChartTypePickerContext.$t = markType(FinancialChartTypePickerContext, 'FinancialChartTypePickerContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartRangeSelectorContext extends Base {
    constructor() {
        super(...arguments);
        this._vm = null;
        this._template = null;
    }
    get vm() {
        return this._vm;
    }
    set vm(a) {
        this._vm = a;
    }
    get template() {
        return this._template;
    }
    set template(a) {
        this._template = a;
    }
}
FinancialChartRangeSelectorContext.$t = markType(FinancialChartRangeSelectorContext, 'FinancialChartRangeSelectorContext');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartRangeSelectorViewModel extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this._notifyChanged = null;
        this._options = null;
        this.u = dateMaxValue();
        this.t = dateMinValue();
        this._oneMonthChecked = false;
        this._threeMonthsChecked = false;
        this._sixMonthsChecked = false;
        this._yearToDateChecked = false;
        this._oneYearChecked = false;
        this._allChecked = false;
        this._oneMonthVisible = false;
        this._threeMonthsVisible = false;
        this._sixMonthsVisible = false;
        this._yearToDateVisible = false;
        this._oneYearVisible = false;
        this._allVisible = false;
        this.s = dateMinValue();
        this.r = dateMaxValue();
        this._onRangeChanged = null;
    }
    get notifyChanged() {
        return this._notifyChanged;
    }
    set notifyChanged(a) {
        this._notifyChanged = a;
    }
    get options() {
        return this._options;
    }
    set options(a) {
        this._options = a;
    }
    get selectionStart() {
        return this.u;
    }
    set selectionStart(a) {
        this.u = a;
    }
    get selectionEnd() {
        return this.t;
    }
    set selectionEnd(a) {
        this.t = a;
    }
    get oneMonthChecked() {
        return this._oneMonthChecked;
    }
    set oneMonthChecked(a) {
        this._oneMonthChecked = a;
    }
    get threeMonthsChecked() {
        return this._threeMonthsChecked;
    }
    set threeMonthsChecked(a) {
        this._threeMonthsChecked = a;
    }
    get sixMonthsChecked() {
        return this._sixMonthsChecked;
    }
    set sixMonthsChecked(a) {
        this._sixMonthsChecked = a;
    }
    get yearToDateChecked() {
        return this._yearToDateChecked;
    }
    set yearToDateChecked(a) {
        this._yearToDateChecked = a;
    }
    get oneYearChecked() {
        return this._oneYearChecked;
    }
    set oneYearChecked(a) {
        this._oneYearChecked = a;
    }
    get allChecked() {
        return this._allChecked;
    }
    set allChecked(a) {
        this._allChecked = a;
    }
    get oneMonthVisible() {
        return this._oneMonthVisible;
    }
    set oneMonthVisible(a) {
        this._oneMonthVisible = a;
    }
    get threeMonthsVisible() {
        return this._threeMonthsVisible;
    }
    set threeMonthsVisible(a) {
        this._threeMonthsVisible = a;
    }
    get sixMonthsVisible() {
        return this._sixMonthsVisible;
    }
    set sixMonthsVisible(a) {
        this._sixMonthsVisible = a;
    }
    get yearToDateVisible() {
        return this._yearToDateVisible;
    }
    set yearToDateVisible(a) {
        this._yearToDateVisible = a;
    }
    get oneYearVisible() {
        return this._oneYearVisible;
    }
    set oneYearVisible(a) {
        this._oneYearVisible = a;
    }
    get allVisible() {
        return this._allVisible;
    }
    set allVisible(a) {
        this._allVisible = a;
    }
    ao() {
        if (this.options == null) {
            return;
        }
        this.oneMonthVisible = this.options.contains(0);
        this.threeMonthsVisible = this.options.contains(1);
        this.sixMonthsVisible = this.options.contains(2);
        this.yearToDateVisible = this.options.contains(3);
        this.oneYearVisible = this.options.contains(4);
        this.allVisible = this.options.contains(5);
    }
    get financialChart_RangeSelector_OneMonth() {
        return !stringIsNullOrWhiteSpace(this.b.bq) ? this.b.bq : "1M";
    }
    get financialChart_RangeSelector_ThreeMonths() {
        return !stringIsNullOrWhiteSpace(this.b.bt) ? this.b.bt : "3M";
    }
    get financialChart_RangeSelector_SixMonths() {
        return !stringIsNullOrWhiteSpace(this.b.bs) ? this.b.bs : "6M";
    }
    get financialChart_RangeSelector_YearToDate() {
        return !stringIsNullOrWhiteSpace(this.b.bv) ? this.b.bv : "YTD";
    }
    get financialChart_RangeSelector_OneYear() {
        return !stringIsNullOrWhiteSpace(this.b.br) ? this.b.br : "1Y";
    }
    get financialChart_RangeSelector_All() {
        return !stringIsNullOrWhiteSpace(this.b.bo) ? this.b.bo : "ALL";
    }
    get financialChart_RangeSelector_From() {
        return !stringIsNullOrWhiteSpace(this.b.bp) ? this.b.bp : "From";
    }
    get financialChart_RangeSelector_To() {
        return !stringIsNullOrWhiteSpace(this.b.bu) ? this.b.bu : "To";
    }
    get rangeStart() {
        return this.s;
    }
    set rangeStart(a) {
        this.s = a;
    }
    get rangeEnd() {
        return this.r;
    }
    set rangeEnd(a) {
        this.r = a;
    }
    onPropertiesChanged() {
        let a = false;
        let b = +(this.selectionEnd) == +(this.rangeEnd);
        if (this.allChecked != ((+(this.selectionStart) == +(this.rangeStart)) && b)) {
            this.allChecked = (+(this.selectionStart) == +(this.rangeStart)) && b;
            a = true;
        }
        if (this.oneYearChecked != ((+(this.selectionStart) == +(this.oneYearFromEnd)) && b)) {
            this.oneYearChecked = (+(this.selectionStart) == +(this.oneYearFromEnd)) && b;
            a = true;
        }
        if (this.yearToDateChecked != ((+(this.selectionStart) == +(this.firstDayOfEndYear)) && b)) {
            this.yearToDateChecked = (+(this.selectionStart) == +(this.firstDayOfEndYear)) && b;
            a = true;
        }
        if (this.sixMonthsChecked != ((+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b)) {
            this.sixMonthsChecked = (+(this.selectionStart) == +(this.sixMonthsFromEnd)) && b;
            a = true;
        }
        if (this.threeMonthsChecked != ((+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b)) {
            this.threeMonthsChecked = (+(this.selectionStart) == +(this.threeMonthsFromEnd)) && b;
            a = true;
        }
        if (this.oneMonthChecked != ((+(this.selectionStart) == +(this.oneMonthFromEnd)) && b)) {
            this.oneMonthChecked = (+(this.selectionStart) == +(this.oneMonthFromEnd)) && b;
            a = true;
        }
        if (a) {
            if (this.notifyChanged != null) {
                this.notifyChanged();
            }
        }
        return a;
    }
    get oneYearFromEnd() {
        return dateAddYears(this.rangeEnd, -1);
    }
    get firstDayOfEndYear() {
        return dateFromValues(this.rangeEnd.getFullYear(), 1, 1, 0, 0, 0, 0);
    }
    get sixMonthsFromEnd() {
        return dateAddMonths(this.rangeEnd, -6);
    }
    get threeMonthsFromEnd() {
        return dateAddMonths(this.rangeEnd, -3);
    }
    get oneMonthFromEnd() {
        return dateAddMonths(this.rangeEnd, -1);
    }
    changeSelection(a) {
        this.allChecked = false;
        this.oneMonthChecked = false;
        this.threeMonthsChecked = false;
        this.sixMonthsChecked = false;
        this.yearToDateChecked = false;
        this.oneYearChecked = false;
        if (a == "1m") {
            this.oneMonthChecked = true;
        }
        else if (a == "3m") {
            this.threeMonthsChecked = true;
        }
        else if (a == "6m") {
            this.sixMonthsChecked = true;
        }
        else if (a == "YTD") {
            this.yearToDateChecked = true;
        }
        else if (a == "1y") {
            this.oneYearChecked = true;
        }
        else if (a == "all") {
            this.allChecked = true;
        }
        this.onRadioButtonChanged();
    }
    onRadioButtonChanged() {
        let a = dateFromTicks(this.selectionStart.getTime());
        let b = dateFromTicks(this.selectionEnd.getTime());
        this.selectionEnd = this.rangeEnd;
        if (this.oneMonthChecked) {
            this.selectionStart = this.oneMonthFromEnd;
        }
        if (this.threeMonthsChecked) {
            this.selectionStart = this.threeMonthsFromEnd;
        }
        if (this.sixMonthsChecked) {
            this.selectionStart = this.sixMonthsFromEnd;
        }
        if (this.yearToDateChecked) {
            this.selectionStart = this.firstDayOfEndYear;
        }
        if (this.oneYearChecked) {
            this.selectionStart = this.oneYearFromEnd;
        }
        if (this.allChecked) {
            this.selectionStart = this.rangeStart;
        }
        if (+(this.selectionStart) != +a || +(this.selectionEnd) != +b) {
            this.onRangeChanged();
            if (this.notifyChanged != null) {
                this.notifyChanged();
            }
        }
    }
    get onRangeChanged() {
        return this._onRangeChanged;
    }
    set onRangeChanged(a) {
        this._onRangeChanged = a;
    }
}
FinancialChartRangeSelectorViewModel.$t = markType(FinancialChartRangeSelectorViewModel, 'FinancialChartRangeSelectorViewModel');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartRangeSelectorView extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.e = null;
    }
    f(a, b) {
        let c = new SRProvider(a);
        this.e = c;
        this.c.b = this.e;
    }
    h(a, b, c) {
        TemplatedHtmlControl.n(".rangeSelector" + b + " span", "FinancialChart_RangeSelector_" + b, a, c);
    }
    g(a) {
    }
    d(a) {
        let b = new List$1(String_$type, 0);
        let c = new List$1(Boolean_$type, 0);
        let d = new List$1(Number_$type, 0);
        let e = new List$1(Number_$type, 0);
        let f = new List$1(Boolean_$type, 0);
        let g = new List$1(Number_$type, 0);
        let h = new List$1(Number_$type, 0);
        let k = this.a(a);
        for (let j = 0; j < k.length; j++) {
            let i = k[j];
            let l = i.parent() != null ? i.parent().getText() : "not found";
            l = l != null ? l.trim() : null;
            b.add(l);
            c.add1(i.getProperty("checked"));
            d.add(i.getOffset().left);
            e.add(i.getOffset().top);
            let m = i.parent().getNativeElement();
            let n = m.offsetParent != null;
            g.add(m.offsetWidth);
            h.add(m.offsetHeight);
            f.add(n);
        }
        ;
        return ((() => {
            let $ret = new FinancialChartRangeSelectorVisualData();
            $ret.buttonLabels = b.toArray();
            $ret.buttonsChecked = c.toArray();
            $ret.buttonLefts = d.toArray();
            $ret.buttonTops = e.toArray();
            $ret.buttonVisibilities = f.toArray();
            $ret.buttonWidths = g.toArray();
            $ret.buttonHeights = h.toArray();
            $ret.visibility = a.getStyleProperty("visibility");
            $ret.left = parseFloat(a.getStyleProperty("offsetLeft"));
            $ret.top = parseFloat(a.getStyleProperty("offsetTop"));
            $ret.width = parseFloat(a.getStyleProperty("offsetWidth"));
            $ret.height = parseFloat(a.getStyleProperty("offsetHeight"));
            return $ret;
        })());
    }
    b(a) {
        return 5;
    }
    i(a) {
    }
    a(a) {
        return TemplatedHtmlControl.a(a, "input").toArray();
    }
}
FinancialChartRangeSelectorView.$t = markType(FinancialChartRangeSelectorView, 'FinancialChartRangeSelectorView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChart extends XYChart {
    constructor() {
        super();
        this.qr = null;
        this.s9 = null;
        this.s7 = null;
        this.s4 = null;
        this.s6 = null;
        this.s8 = null;
        this.s5 = null;
        this.px = null;
        this.tr = null;
        this.ts = null;
        this.to = null;
        this.tt = null;
        this.tu = null;
        this.tp = null;
        this.tq = null;
        this.rf = null;
        this.sk = 40;
        this.ql = null;
        this.qj = null;
        this.qn = null;
        this.qs = null;
        this.t2 = null;
        this.rb = null;
        this.rz = false;
        this.ry = false;
        this.r4 = false;
        this.rl = false;
        this.tf = 10;
        this.sm = NaN;
        this.so = NaN;
        this.sn = NaN;
        this.sp = 0;
        this.p3 = 0;
        this.p6 = 0;
        this.p8 = 0;
        this.ri = true;
        this.pz = 0;
        this.rj = false;
        this.qd = null;
        this.qf = null;
        this.r6 = null;
        this.rk = true;
        this.rc = null;
        this.qa = 1;
        this.o1 = null;
        this.o2 = null;
        this.o3 = null;
        this.o4 = null;
        this.o6 = null;
        this.o5 = null;
        this.o0 = null;
        this.oz = null;
        this.sl = 1;
        this.sj = 1;
        this.si = 1;
        this.qp = null;
        this.tb = -2147483648;
        this.sh = 2;
        this.te = 3;
        this.tc = 10;
        this.ta = 30;
        this.td = 9;
        this.pu = null;
        this.pv = null;
        this.pq = null;
        this.applyCustomIndicators = null;
        this.xm = null;
        this.sq = 1;
        this.rh = false;
        this.qh = null;
        this.se = dateMinValue();
        this.sd = dateMaxValue();
        this.sb = null;
        this.f6();
        this.sb = new ObservableCollection$1(Base.$, 0);
        if (this.xAxisBreaks != null) {
            let a = this.xAxisBreaks;
            a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => this.xb());
        }
        this.ww();
    }
    g5(a, b, c) {
        super.g5(a, b, c);
        switch (a) {
            case "ToolbarTemplate":
            case "RangeSelectorTemplate":
                this.py = new FinancialChartToolbar(this, this.tz);
                break;
            case "Toolbar":
                let d = b;
                if (d != null) {
                    d.chartTypeChanged = delegateRemove(d.chartTypeChanged, runOn(this, this.wk));
                    d.trendLineTypeChanged = delegateRemove(d.trendLineTypeChanged, runOn(this, this.wn));
                    d.volumeTypeChanged = delegateRemove(d.volumeTypeChanged, runOn(this, this.wo));
                    d.l(null);
                }
                if (this.py != null) {
                    this.py.ac = this.p5;
                    this.py.ai = this.av;
                    this.py.y = this.p0;
                    this.py.al = this.rw;
                    if (this.s6 != null) {
                        this.py.l(this.s6);
                    }
                    let e = this.py;
                    e.chartTypeChanged = delegateCombine(e.chartTypeChanged, runOn(this, this.wk));
                    ;
                    let f = this.py;
                    f.trendLineTypeChanged = delegateCombine(f.trendLineTypeChanged, runOn(this, this.wn));
                    let g = this.py;
                    g.volumeTypeChanged = delegateCombine(g.volumeTypeChanged, runOn(this, this.wo));
                }
                break;
            case "ChartType":
                if (this.py != null) {
                    this.py.y = this.p0;
                }
                break;
            case "VolumeType":
                if (this.py != null) {
                    this.py.ac = this.p5;
                }
                break;
            case "TrendLineType":
                if (this.py != null) {
                    this.py.ai = this.av;
                }
                break;
            case "IsToolbarVisible":
                if (this.py == null) {
                    break;
                }
                this.py.al = this.rw;
                this.setGridRows();
                break;
        }
    }
    wo(a, b) {
        this.p5 = this.py.ac;
    }
    wn(a, b) {
        this.av = this.py.ai;
    }
    wk(a, b) {
        this.p0 = this.py.y;
    }
    ww() {
        this.qr = new IndicatorPane();
        this.qi = TypeRegistrar.create("FinancialLegend");
    }
    provideGrid(a) {
        this.s9 = a;
        this.xh();
        this.setGridRows();
        if (this.py != null) {
            this.py.bg(a);
        }
    }
    onDocumentClick(a) {
        if (this.py != null) {
            this.py.bl(a);
        }
    }
    getContext() {
        let a = this.py.v();
        let b = new FinancialChartContext();
        b.vm = new FinancialChartViewModel();
        b.vm.toolbar = a;
        b.container = this.di;
        b.toolbarContainer = this.s6;
        b.legendContainer = this.s5;
        b.indicatorsContainer = this.s4;
        b.volumeContainer = this.s7;
        b.zoomContainer = this.s8;
        return b;
    }
    provideContainer(a) {
        let b = a;
        if (b != null) {
            let c = "financialChartMainGrid";
            let d = b.createElement("div");
            d.setStyleProperty("width", "100%");
            d.setStyleProperty("height", "100%");
            if (this.py == null) {
                this.py = new FinancialChartToolbar(this, this.tz);
            }
            this.py.w.isIndicatorMenuVisible = this.rn && this.ro;
            this.s6 = b.getSubRenderer(d);
            this.py.l(this.s6);
            let e = b.createElement("div");
            e.setStyleProperty("width", "100%");
            e.setStyleProperty("height", "100%");
            let f = b.createElement("div");
            f.setStyleProperty("width", "100%");
            f.setStyleProperty("height", "100%");
            this.s5 = b.getSubRenderer(f);
            let g = b.createElement("div");
            g.setStyleProperty("width", "100%");
            g.setStyleProperty("height", "100%");
            this.s4 = b.getSubRenderer(g);
            let h = b.createElement("div");
            h.setStyleProperty("width", "100%");
            h.setStyleProperty("height", "100%");
            this.s7 = b.getSubRenderer(h);
            let i = b.createElement("div");
            i.setStyleProperty("width", "100%");
            i.setStyleProperty("height", "100%");
            this.s8 = b.getSubRenderer(i);
            a = b.getSubRenderer(e);
        }
        else {
            this.s6 = null;
            if (this.py != null) {
                this.py.l(null);
            }
            if (this.rg != null) {
                this.rg.provideContainer(null);
                this.rg = null;
            }
            if (this.qi != null) {
                this.qi.provideContainer(null);
            }
        }
        super.provideContainer(a);
        if (b != null) {
            if (this.volumeChart != null) {
                this.volumeChart.provideContainer(this.s7);
            }
            if (this.qr != null) {
                this.qr.h(this.s4);
            }
            if (this.zoomSliderChart != null) {
                this.zoomSliderChart.provideContainer(this.s8);
                if (a != null) {
                    this.v4();
                }
                else {
                    this.rg = null;
                }
            }
            if (this.qi != null) {
                this.qi.provideContainer(this.s5);
            }
            this.setGridRows();
        }
    }
    w7(a, b, c) {
        if (a != null) {
            a.provideContainer(null);
        }
        if (b != null) {
            b.provideContainer(c);
        }
        this.setGridRows();
    }
    xl(a, b) {
        this.w7(a, b, this.s8);
        if (b == null) {
            return;
        }
        this.v4();
    }
    v4() {
        if (this.s8 == null) {
            return;
        }
        if (this.rg != null) {
            this.rg.provideContainer(null);
        }
        this.rg = TypeRegistrar.create("ZoomSlider");
        this.rg.provideContainer(this.s8);
        let a = this.rg;
        a.windowRectChanged = delegateCombine(a.windowRectChanged, (a, b) => {
            if (this.dataChart != null) {
                this.dataChart.oi = new Rect(0, this.rg.windowRect.left, this.dataChart.n2.top, this.rg.windowRect.width, this.dataChart.n2.height);
            }
        });
        this.v5();
    }
    xj(a, b) {
        this.w7(a, b, this.s7);
    }
    setGridRows() {
        if (this.s9 == null) {
            return;
        }
        let a = new Array(6);
        a[0] = (this.rw ? this.sv : 0) + "px";
        a[1] = this.rs ? "min-content" : "0px";
        a[2] = "auto";
        a[3] = this.indicatorCharts == null || this.indicatorCharts.count == 0 ? "0px" : this.indicatorCharts.count * 150 + "px";
        a[4] = this.volumeChart == null ? "0px" : "100px";
        a[5] = this.zoomSliderChart == null ? "0px" : "100px";
        if (this.rg != null) {
            if (a[5] == "0px") {
                this.rg.hide();
            }
            else {
                this.rg.show();
            }
        }
        this.s9.setStyleProperty("-ms-grid-rows", stringReplace(stringJoin(" ", ...a), "auto", "1fr"));
        this.s9.setStyleProperty("grid-template-rows", stringJoin(" ", ...a));
        if (this.di == null) {
            return;
        }
        if (this.dataChart != null) {
            this.dataChart.notifyContainerResized();
        }
        if (this.qr != null) {
            this.qr.f();
        }
        if (this.volumeChart != null) {
            this.volumeChart.notifyContainerResized();
        }
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.notifyContainerResized();
        }
        if (this.rg != null) {
            this.rg.notifySizeChanged();
        }
    }
    gj() {
        super.gj();
        this.il = 3;
        this.nw = 0;
        this.cu = NaN;
        this.cs = 30;
        this.bq = true;
        this.bw = false;
        if (this.dataChart != null) {
            let a = this.dataChart.b1.i.e();
            this.o9 = a.d;
            this.pa = a.e;
            this.o8 = a.d;
            this.xn = this.dataChart.rc;
        }
        let b = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(116, 70, 185, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(159, 179, 40, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(46, 156, 166, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(63, 81, 181, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(154, 154, 154, .3)";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(67, 156, 71, .3)";
            return $ret;
        })()));
        this.pb = b;
        let c = new BrushCollection();
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#7446B9";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9FB328";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#2E9CA6";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#3F51B5";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#9A9A9A";
            return $ret;
        })()));
        b.add(((() => {
            let $ret = new Brush();
            $ret.fill = "#439C47";
            return $ret;
        })()));
        this.pc = c;
    }
    w3() {
        if (this.qr != null) {
            this.qr.b = null;
            this.qr.b = this.indicatorCharts;
        }
        this.setGridRows();
    }
    w4() {
        this.setGridRows();
    }
    xd() {
        this.w3();
    }
    v3() {
        if (this.rg == null || this.zoomSliderChart == null || this.dataChart == null || this.dataChart.series.count == 0) {
            return;
        }
        let a = this.di.rootWrapper.width();
        let b = this.dataChart.oh.left + this.dataChart.oh.width;
        let c = this.dataChart.oh.left;
        let d = a - b;
        this.rg.startInset = c - this.rg.trackStartInset;
        this.rg.endInset = d - this.rg.trackEndInset;
        if (this.rg.endInset < 0) {
            let e = this.rg.endInset;
            this.rg.endInset = 0;
            this.dataChart.fa += (e * -1);
        }
        if (this.rg.startInset < 0) {
            let f = this.rg.startInset;
            this.rg.startInset = 0;
            this.dataChart.e7 += (f * -1);
        }
        this.zoomSliderChart.e7 = c;
        this.zoomSliderChart.fa = d;
        this.zoomSliderChart.e3 = this.rg.barExtent;
    }
    wu() {
        this.v3();
    }
    gg(a) {
        super.gg(a);
        if (a != null) {
            a.e2 = 0;
        }
    }
    xo(a) {
        return a.nv();
    }
    xr() {
        return this.s5 == null ? null : this.xq(this.s5.rootWrapper);
    }
    xp(a) {
        if (a == null || a.d == null) {
            return null;
        }
        return this.xq(a.d.rootWrapper);
    }
    xq(a) {
        if (a == null) {
            return null;
        }
        let b = a.getOffset();
        return new Rect(0, b.left, b.top, a.width(), a.height());
    }
    sr() {
        if (this.s9 == null) {
            return NaN;
        }
        let a = this.s9.getOffset();
        return this.s9.width() + (a == null ? 0 : a.left);
    }
    gr(source_, a, b) {
        super.gr(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.iy(source_, a, b);
        }
    }
    gs(source_, a, b) {
        super.gs(source_, a, b);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.iz(source_, a, b);
        }
    }
    gq(source_) {
        super.gq(source_);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.iv(source_);
        }
    }
    gu(source_, a, b, c) {
        super.gu(source_, a, b, c);
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.i0(source_, a, b, c);
        }
    }
    gm(a, b) {
        super.gm(a, b);
        if (this.rt(a)) {
            a.toolTip = null;
        }
    }
    get py() {
        return this.px;
    }
    set py(a) {
        let b = this.py;
        if (a != b) {
            this.px = a;
            this.g3("Toolbar", b, this.py);
        }
    }
    get ty() {
        return this.tr;
    }
    set ty(a) {
        let b = this.ty;
        if (a != b) {
            this.tr = a;
            this.g3("RangeSelectorTemplate", b, this.ty);
        }
    }
    get tz() {
        return this.ts;
    }
    set tz(a) {
        let b = this.tz;
        if (a != b) {
            this.ts = a;
            this.g3("ToolbarTemplate", b, this.tz);
        }
    }
    get tv() {
        return this.to;
    }
    set tv(a) {
        let b = this.tv;
        if (a != b) {
            this.to = a;
            this.g3("ChartTypePickerTemplate", b, this.tv);
        }
    }
    get t0() {
        return this.tt;
    }
    set t0(a) {
        let b = this.t0;
        if (a != b) {
            this.tt = a;
            this.g3("TrendLineTypePickerTemplate", b, this.t0);
        }
    }
    get t1() {
        return this.tu;
    }
    set t1(a) {
        let b = this.t1;
        if (a != b) {
            this.tu = a;
            this.g3("VolumeTypePickerTemplate", b, this.t1);
        }
    }
    get tw() {
        return this.tp;
    }
    set tw(a) {
        let b = this.tw;
        if (a != b) {
            this.tp = a;
            this.g3("IndicatorMenuTemplate", b, this.tw);
        }
    }
    get tx() {
        return this.tq;
    }
    set tx(a) {
        let b = this.tx;
        if (a != b) {
            this.tq = a;
            this.g3("OverlayPickerTemplate", b, this.tx);
        }
    }
    get rg() {
        return this.rf;
    }
    set rg(a) {
        let b = this.rg;
        if (a != b) {
            this.rf = a;
            this.g3("ZoomSlider", b, this.rg);
        }
    }
    get_cs() {
        return super.get_cs();
    }
    set_cs(a) {
        super.set_cs(a);
    }
    get_bq() {
        return super.get_bq();
    }
    set_bq(a) {
        super.set_bq(a);
    }
    get sv() {
        return this.sk;
    }
    set sv(a) {
        let b = this.sv;
        if (a != b) {
            this.sk = a;
            this.g3("ToolbarHeight", b, this.sv);
        }
    }
    id() {
        return this.xAxis;
    }
    ie() {
        return this.yAxis;
    }
    onAttachedToUI() {
        super.onAttachedToUI();
        if (this.rg != null) {
            this.rg.onAttachedToUI();
        }
    }
    onDetachedFromUI() {
        super.onDetachedFromUI();
        if (this.rg != null) {
            this.rg.onDetachedFromUI();
        }
    }
    u(a) {
        return 20;
    }
    get_b5() {
        return ((() => {
            let $ret = new List$1(DataSeriesType_$type, 0);
            $ret.add(20);
            return $ret;
        })());
    }
    get b5() {
        return this.get_b5();
    }
    get_b4() {
        return ((() => {
            let $ret = new List$1(IDataSeriesAdapterRule_$type, 0);
            $ret.add(new SimpleFinancialPriceSeriesRule());
            $ret.add(new SubCollectionsRule());
            return $ret;
        })());
    }
    get b4() {
        return this.get_b4();
    }
    pk(a) {
        return this.pl(a);
    }
    qy(a) {
        return this.qz(a);
    }
    pj(a) {
        let b = this.pk(0);
        b.name = a;
        return b;
    }
    f3() {
        this.xAxis = this.pj("xAxis");
        this.yAxis = this.qy(0);
        this.yAxis.name = "yAxis";
        this.volumeAxis = this.qy(0);
        this.volumeAxis.name = "volumeAxis";
        this.volumeXAxis = this.pj("volumeXAxis");
        this.r8 = new List$1(NumericYAxis.$, 0);
        this.sa = new List$1(CategoryAxisBase.$, 0);
        this.indicatorAxis = this.qy(0);
        this.indicatorAxis.name = "indicatorAxis";
        this.indicatorXAxis = this.pj("indicatorXAxis_0");
        this.r8.add(this.indicatorAxis);
        this.sa.add(this.indicatorXAxis);
        if (this.xAxis.ay == null) {
            this.xAxis.ay = new AxisLabelSettings();
        }
        if (this.yAxis.ay == null) {
            this.yAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.volumeXAxis.ay == null) {
            this.volumeAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorAxis.ay == null) {
            this.indicatorAxis.ay = new AxisLabelSettings();
        }
        if (this.indicatorXAxis.ay == null) {
            this.indicatorXAxis.ay = new AxisLabelSettings();
        }
        this.zoomSliderAxis = this.qy(0);
        this.zoomSliderAxis.name = "zoomSliderAxis";
        this.zoomSliderXAxis = this.pj("zoomSliderXAxis");
        if (this.zoomSliderAxis.ay == null) {
            this.zoomSliderAxis.ay = new AxisLabelSettings();
        }
        if (this.zoomSliderXAxis.ay == null) {
            this.zoomSliderXAxis.ay = new AxisLabelSettings();
        }
    }
    f1(a, b) {
        let c = typeCast(MarkerSeries.$, a);
        if (c != null) {
            c.mb = this.ai(a, b);
        }
    }
    hj(a) {
        if (a.suggestedSecondaryAxis == 2) {
            this.yAxis.j1 = true;
            this.yAxis.ko = 10;
        }
    }
    hm() {
        this.yAxis.j1 = this.r1;
        this.yAxis.ko = this.tn;
    }
    p2(a) {
        let b;
        if (this.p0 == 0) {
            if (a == null || a.index > 0 || stringIsNullOrEmpty(a.getMemberPathFor(12))) {
                b = 4;
            }
            else {
                b = 2;
            }
        }
        else {
            b = this.p0;
        }
        b = this.p1(b);
        return b;
    }
    p1(a) {
        if ((a == 1 || a == 2)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    qb(a) {
        if ((a == 2 || a == 3)) {
            if (TypeRegistrar.isRegistered("FinancialPriceSeries")) {
                return a;
            }
            a = 5;
        }
        if (a == 5) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 6;
        }
        if (a == 6) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 4;
        }
        if (a == 4) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    p4(a) {
        if (a == 2) {
            if (TypeRegistrar.isRegistered("LineSeries")) {
                return a;
            }
            a = 3;
        }
        if (a == 3) {
            if (TypeRegistrar.isRegistered("AreaSeries")) {
                return a;
            }
            a = 1;
        }
        if (a == 1) {
            if (TypeRegistrar.isRegistered("ColumnSeries")) {
                return a;
            }
        }
        return a;
    }
    t9(a) {
        let b = a.getMemberPathFor(14);
        if (stringIsNullOrEmpty(b)) {
            b = a.getMemberPathFor(11);
        }
        return b;
    }
    pl(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createXAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("TimeXAxis")) {
                        a = TypeRegistrar.create("TimeXAxis");
                    }
                    else if (TypeRegistrar.isRegistered("OrdinalTimeXAxis")) {
                        a = TypeRegistrar.create("OrdinalTimeXAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    qz(axisType_) {
        if ((this.externalObject)) {
            return (this.externalObject.createYAxis(axisType_).i);
        }
        else {
            let a;
            switch (axisType_) {
                case 0:
                    if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
                case 1:
                    if (TypeRegistrar.isRegistered("PercentChangeYAxis")) {
                        a = TypeRegistrar.create("PercentChangeYAxis");
                    }
                    else if (TypeRegistrar.isRegistered("NumericYAxis")) {
                        a = TypeRegistrar.create("NumericYAxis");
                    }
                    else {
                        throw new BaseError(1, "no valid axes loaded");
                    }
                    return a;
            }
            return null;
        }
    }
    q5() {
        return this.ar(1);
    }
    q6() {
        return this.ar(0);
    }
    q4() {
        return this.ar(2);
    }
    q7() {
        return this.ar(20);
    }
    get rm() {
        return (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy"));
    }
    get qm() {
        if (TypeRegistrar.isRegistered("HorizontalAnchoredCategorySeriesProxy")) {
            return TypeRegistrar.create("HorizontalAnchoredCategorySeriesProxy");
        }
        else {
            throw new BaseError(1, "horizontal series module is not loaded, but is required.");
        }
    }
    get rp() {
        return (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy"));
    }
    get qk() {
        if (TypeRegistrar.isRegistered("FinancialPriceSeriesProxy")) {
            return TypeRegistrar.create("FinancialPriceSeriesProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get rn() {
        return (TypeRegistrar.isRegistered("IndicatorProxy"));
    }
    get qo() {
        if (TypeRegistrar.isRegistered("IndicatorProxy")) {
            return TypeRegistrar.create("IndicatorProxy");
        }
        else {
            throw new BaseError(1, "financial series module is not loaded, but is required.");
        }
    }
    get ro() {
        return (TypeRegistrar.isRegistered("OverlayProxy"));
    }
    get qt() {
        if (TypeRegistrar.isRegistered("OverlayProxy")) {
            return TypeRegistrar.create("OverlayProxy");
        }
        else {
            throw new BaseError(1, "overlay series module is not loaded, but is required.");
        }
    }
    aq(a, b) {
        let c = this.t9(a);
        switch (this.p2(a)) {
            case 3:
                let d = this.q5();
                this.qm.setValueMemberPath(d, c);
                this.qm.setXAxis(d, this.xAxis);
                this.qm.setYAxis(d, this.yAxis);
                this.qm.setCategoryMode(d, 1);
                return d;
            case 4:
                let e = this.q6();
                this.qm.setValueMemberPath(e, c);
                this.qm.setXAxis(e, this.xAxis);
                this.qm.setYAxis(e, this.yAxis);
                this.qm.setCategoryMode(e, 1);
                return e;
            default:
            case 1:
            case 2:
                let f = this.q7();
                this.qk.setOpenMemberPath(f, a.getMemberPathFor(11));
                this.qk.setHighMemberPath(f, a.getMemberPathFor(12));
                this.qk.setLowMemberPath(f, a.getMemberPathFor(13));
                this.qk.setCloseMemberPath(f, a.getMemberPathFor(14));
                this.qk.setVolumeMemberPath(f, a.getMemberPathFor(15));
                this.qk.setXAxis(f, this.xAxis);
                this.qk.setYAxis(f, this.yAxis);
                this.qk.setDisplayType(f, this.p0 == 1 ? 1 : 0);
                this.qk.setCategoryMode(f, 1);
                return f;
        }
    }
    hl() {
        super.hl();
        this.ws(this.xAxis);
        this.xf(false);
        if (this.p5 != 0 && this.volumeChart != null) {
            this.wy();
        }
        this.ws(this.volumeXAxis);
        this.ws(this.indicatorXAxis);
        this.xc();
        this.xe();
        if (this.qc != 0) {
            this.wz();
            this.ws(this.zoomSliderXAxis);
        }
    }
    nk(a, b) {
        super.nk(a, b);
        a(this.volumeXAxis);
        if (this.sa != null) {
            for (let c of fromEnum(this.sa)) {
                a(c);
            }
        }
        let d = true;
        switch (b) {
            case "XAxisMajorStroke":
            case "XAxisMajorStrokeThickness":
                d = false;
                break;
        }
        if (d) {
            a(this.zoomSliderXAxis);
        }
    }
    no(a, b) {
        super.no(a, b);
        if (b) {
            a(this.volumeAxis);
            if (this.r8 != null) {
                for (let c of fromEnum(this.r8)) {
                    a(c);
                }
            }
            a(this.zoomSliderAxis);
        }
    }
    nm(a) {
        super.nm(a);
        this.ne(this.volumeXAxis, a);
        this.ne(this.indicatorXAxis, a);
        this.ne(this.zoomSliderXAxis, a);
    }
    nq(a) {
        super.nq(a);
        this.ne(this.volumeAxis, a);
        this.ne(this.indicatorAxis, a);
        this.ne(this.zoomSliderAxis, a);
    }
    np(a) {
        super.np(a);
        this.nd(this.volumeAxis, a);
        this.nd(this.indicatorAxis, a);
        this.nd(this.zoomSliderAxis, a);
    }
    nl(a) {
        super.nl(a);
        this.nd(this.volumeXAxis, a);
        this.nd(this.indicatorXAxis, a);
        this.nd(this.zoomSliderXAxis, a);
    }
    gf(a) {
        super.gf(a);
        if (a == null) {
            return;
        }
        if (a == this.zoomSliderChart) {
            a.o6 = a.o9 = false;
            a.legend = null;
            if (this.dataChart != null) {
                a.oo = this.dataChart.oo;
                a.or = this.dataChart.or;
            }
        }
        else {
            SyncManager.d(a, ((() => {
                let $ret = new SyncSettings();
                $ret.syncChannel = this.u3();
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })()));
            SyncManager.c(a);
        }
        a.bp = 2;
    }
    u3() {
        if (this.t2 == null) {
            FinancialChart.tm++;
            this.t2 = FinancialChart.tm.toString();
        }
        return this.t2;
    }
    we(a, b) {
        this.v0();
        this.wu();
    }
    v0() {
        if (this.yAxis.b1()) {
            return;
        }
        let a = this.yAxis.av.a6;
        if (this.p5 != 0) {
            a = Math.max(a, this.volumeAxis.av.a6);
        }
        for (let b of fromEnum(this.r8)) {
            a = Math.max(a, b.av.a6);
        }
        this.v1(a);
    }
    v1(a) {
        if (this.yAxis.b1()) {
            return;
        }
        this.yAxis.d6 = this.volumeAxis.d6 = a;
        for (let b of fromEnum(this.r8)) {
            b.d6 = a;
        }
        this.zoomSliderAxis.d6 = this.yAxis.d6;
    }
    v6(a) {
        if (this.indicatorCharts == null) {
            return;
        }
        for (let b = 0; b < this.indicatorCharts.count; b++) {
            let c = this.indicatorCharts._inner[b];
            for (let d = 0; d < c.series.count; d++) {
                a(c.series._inner[d], b);
            }
        }
    }
    v9(a) {
        if (this.volumeChart == null) {
            return;
        }
        for (let b = 0; b < this.volumeChart.series.count; b++) {
            a(this.volumeChart.series._inner[b], b);
        }
    }
    v7(a) {
        if (this.dataChart == null) {
            return;
        }
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            if (!this.rt(c)) {
                continue;
            }
            a(c, b);
        }
    }
    v8(a, b) {
        if (this.dataChart == null) {
            return;
        }
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.rt(d)) {
                continue;
            }
            let e = this.tg(d, c);
            a(d, e);
        }
        if (b) {
            this.wa(a);
        }
    }
    wa(a) {
        if (this.zoomSliderChart == null) {
            return;
        }
        for (let b = 0; b < this.zoomSliderChart.series.count; b++) {
            a(this.zoomSliderChart.series._inner[b], b);
        }
    }
    tg(a, b) {
        if (a.bq != this.dataChart) {
            return b;
        }
        let c = this.v == null || this.v.dataSeries == null ? 0 : this.v.dataSeries.count;
        let d = this.qg == null ? 0 : this.qg.count;
        return b - (c * d);
    }
    f9(a) {
        super.f9(a);
        this.v9(a);
        this.v6(a);
        this.wa(a);
    }
    get volumeChart() {
        return this.rb;
    }
    set volumeChart(a) {
        let b = this.volumeChart;
        if (a != b) {
            this.rb = a;
            this.g3("VolumeChart", b, this.volumeChart);
        }
    }
    wy() {
        if (this.dataChart == null) {
            return;
        }
        this.volumeChart.series.clear();
        let a = new List$1(Series.$, 0);
        let b = -1;
        for (let c = 0; c < this.dataChart.series.count; c++) {
            let d = this.dataChart.series._inner[c];
            if (this.rt(d) || d.cj) {
                continue;
            }
            b++;
            let e;
            let f = this.p5;
            f = this.p4(f);
            switch (f) {
                case 2:
                    e = this.q6();
                    break;
                case 3:
                    e = this.q4();
                    break;
                default:
                case 1:
                    e = this.q5();
                    break;
            }
            this.qm.setCategoryMode(e, 1);
            e.name = "volumeSeries_" + b;
            e.itemsSource = d.itemsSource;
            this.qm.setXAxis(e, this.volumeXAxis);
            this.qm.setYAxis(e, this.volumeAxis);
            this.qm.setValueMemberPath(e, this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > b ? this.v.dataSeries._inner[b].getMemberPathFor(15) : null);
            e.fx = d.fx + " Volume";
            e.ld = ArrayExtension.getModulus$1(Brush.$, this.pd, b);
            e.li = ArrayExtension.getModulus$1(Brush.$, this.pe, b);
            e.ey = this.sw;
            a.add(e);
        }
        let g = this.b1("volume", false);
        if (g != null) {
            a.o(g);
        }
        for (let h = 0; h < a.count; h++) {
            let i = a._inner[h];
            this.volumeChart.series.add(i);
            this.gk(i, h);
        }
    }
    rq(a) {
        if (!this.rm) {
            return false;
        }
        return this.qm.matchesType(a);
    }
    ru(a) {
        if (!this.rp) {
            return false;
        }
        return this.qk.matchesType(a);
    }
    rr(a) {
        if (!this.rn) {
            return false;
        }
        return this.qo.matchesType(a);
    }
    rt(a) {
        if (!this.ro) {
            return false;
        }
        return this.qt.matchesType(a);
    }
    wx() {
        if (this.dataChart == null) {
            return;
        }
        let a = 0;
        let b = this.qe == null ? 0 : this.qe.count;
        let c = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let d = b + c;
        for (let e = 0; e < d; e++) {
            let f = new List$1(Series.$, 0);
            let g = this.indicatorCharts._inner[e];
            let h = e >= b;
            let i = h ? this.customIndicatorNames._inner[e - b] : EnumUtil.getName(FinancialIndicatorType_$type, this.qe._inner[e]);
            let j = -1;
            for (let k = 0; k < this.dataChart.series.count; k++) {
                let l = this.dataChart.series._inner[k];
                if (this.rt(l) || l.cj) {
                    continue;
                }
                j++;
                let m;
                if (h) {
                    let n = this.q8("Custom");
                    this.qo.handleCustomIndicatorEvent(n, runOn(this, this.wc));
                    m = n;
                }
                else {
                    m = this.ra(this.qe._inner[e]);
                }
                if (m == null) {
                    continue;
                }
                m.name = "indicator_" + a++;
                this.qo.setXAxis(m, this.sa._inner[e]);
                this.qo.setYAxis(m, this.r8._inner[e]);
                m.itemsSource = l.itemsSource;
                this.qo.setOpenMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(11));
                this.qo.setHighMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(12));
                this.qo.setLowMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(13));
                this.qo.setCloseMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(14));
                this.qo.setVolumeMemberPath(m, this.v.dataSeries._inner[j].getMemberPathFor(15));
                m.fx = l.fx + " " + i;
                m.ld = ArrayExtension.getModulus$1(Brush.$, this.o7, e);
                m.ey = this.st;
                if (this.rr(m)) {
                    this.qo.setNegativeBrush(m, ArrayExtension.getModulus$1(Brush.$, this.o8, e));
                    this.qo.setDisplayType(m, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.qq, e));
                }
                if (this.ti != -2147483648 && this.rr(m)) {
                    this.qo.setPeriodOverride(m, this.ti);
                }
                if (this.rr(m)) {
                    this.qo.setSmoothingPeriod(m, this.tl);
                }
                if (this.rr(m)) {
                    this.qo.setSignalPeriod(m, this.tk);
                }
                if (this.rr(m)) {
                    this.qo.setShortPeriod(m, this.tj);
                    this.qo.setLongPeriod(m, this.th);
                }
                this.gk(m, e);
                f.add(m);
            }
            let o = this.b1(i, false);
            for (let p = 0; p < f.count; p++) {
                let q = f._inner[p];
                g.series.add(q);
            }
            if (o != null) {
                for (let r = 0; r < o.count; r++) {
                    let s = o._inner[r];
                    g.series.add(s);
                    this.gk(s, r);
                }
            }
        }
    }
    q8(indicatorName_) {
        return (this.externalObject.createIndicator(indicatorName_ + 'Indicator').i);
    }
    ra(a) {
        return this.q8(EnumUtil.getName(FinancialIndicatorType_$type, a));
    }
    xf(a) {
        if (this.py == null) {
            return;
        }
        let b = this.xAxis;
        if (b.actualMinimumValue > b.actualMaximumValue) {
            return;
        }
        this.py.as = b.actualMinimumValue;
        this.py.ar = b.actualMaximumValue;
        if (a) {
            this.py.au = b.visibleMinimum;
            this.py.at = b.visibleMaximum;
        }
        this.py.bn();
    }
    dj() {
        let a = ((() => {
            let $ret = new FinancialChartVisualData();
            $ret.mainChart = super.dj();
            $ret.volumeChart = this.volumeChart == null ? null : this.volumeChart.px();
            $ret.toolbar = this.py == null ? null : this.py.aj();
            $ret.zoomChart = this.zoomSliderChart == null ? null : this.zoomSliderChart.px();
            return $ret;
        })());
        if (this.indicatorCharts != null) {
            a.indicatorCharts = new List$1(Base.$, 0);
            for (let b of fromEnum(this.indicatorCharts)) {
                a.indicatorCharts.add1(b.px());
            }
        }
        if (this.dataChart != null) {
            a.mainChartLeft = this.xo(this.dataChart).x;
            a.mainChartTop = this.xo(this.dataChart).y;
        }
        if (this.volumeChart != null) {
            a.volumeChartLeft = this.xo(this.volumeChart).x;
            a.volumeChartTop = this.xo(this.volumeChart).y;
        }
        if (this.zoomSliderChart != null) {
            a.zoomChartLeft = this.xo(this.zoomSliderChart).x;
            a.zoomChartTop = this.xo(this.zoomSliderChart).y;
        }
        if (this.py != null) {
            let c = this.xp(this.py);
            a.toolbarLeft = c.left;
            a.toolbarTop = c.top;
            a.toolbarWidth = c.width;
            a.toolbarHeight = c.height;
        }
        if (this.indicatorCharts != null) {
            a.indicatorChartLefts = new List$1(Number_$type, 0);
            a.indicatorChartTops = new List$1(Number_$type, 0);
            for (let d of fromEnum(this.indicatorCharts)) {
                a.indicatorChartLefts.add(this.xo(d).x);
                a.indicatorChartTops.add(this.xo(d).y);
            }
        }
        let e = this.xr();
        a.legendLeft = e.left;
        a.legendTop = e.top;
        a.legendWidth = e.width;
        a.legendHeight = e.height;
        a.legend = this.qi == null ? null : this.qi.exportVisualData();
        return a;
    }
    t7() {
        let a = this.dj();
        a.scaleByViewport();
        return a.serialize();
    }
    q9(overlayName_) {
        return (this.externalObject.createOverlay(overlayName_ + 'Overlay').i);
    }
    xe() {
        if (this.dataChart == null) {
            return;
        }
        let a = new List$1(Series.$, 0);
        for (let b of fromEnum(this.dataChart.series)) {
            if (this.rt(b)) {
                a.add(b);
            }
        }
        for (let c of fromEnum(a)) {
            this.dataChart.series.remove(c);
        }
        if (this.qg == null) {
            return;
        }
        let d = new List$1(Series.$, 0);
        let e = -1;
        for (let f = 0; f < this.dataChart.series.count; f++) {
            let g = this.dataChart.series._inner[f];
            if (this.rt(g) || g.cj) {
                continue;
            }
            e++;
            for (let h = 0; h < this.qg.count; h++) {
                let i = this.qg._inner[h];
                let j;
                switch (i) {
                    case 1:
                        j = this.q9(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                    default:
                    case 0:
                        j = this.q9(EnumUtil.getName(FinancialOverlayType_$type, i));
                        break;
                }
                j.name = g.name + "_" + EnumUtil.getName(FinancialOverlayType_$type, i);
                this.qt.setXAxis(j, this.xAxis);
                this.qt.setYAxis(j, this.yAxis);
                j.itemsSource = g.itemsSource;
                let k = e * this.qg.count + h;
                j.ld = ArrayExtension.getModulus$1(Brush.$, this.pb, k);
                j.li = ArrayExtension.getModulus$1(Brush.$, this.pc, k);
                j.ey = this.su;
                j.fx = g.fx + " " + EnumUtil.getName(FinancialOverlayType_$type, i);
                let l = g;
                if (l == null) {
                    continue;
                }
                let m = this.v.dataSeries._inner[e];
                this.qt.setOpenMemberPath(j, m.getMemberPathFor(11));
                this.qt.setHighMemberPath(j, m.getMemberPathFor(12));
                this.qt.setLowMemberPath(j, m.getMemberPathFor(13));
                this.qt.setCloseMemberPath(j, m.getMemberPathFor(14));
                this.qt.setVolumeMemberPath(j, m.getMemberPathFor(15));
                d.add(j);
            }
        }
        let n = new Array(this.dataChart.series.count);
        this.dataChart.series.copyTo(n, 0);
        this.dataChart.skipDataCleanup = true;
        this.dataChart.series.clear();
        this.dataChart.skipDataCleanup = false;
        for (let o = 0; o < n.length; o++) {
            n[o].fh = -1;
        }
        d.o(n);
        for (let p = 0; p < d.count; p++) {
            let q = d._inner[p];
            this.dataChart.series.add(q);
            this.gk(q, p);
        }
    }
    xc() {
        if (this.rz) {
            return;
        }
        this.rz = true;
        if (this.indicatorCharts != null) {
            let a = this.indicatorCharts;
            this.indicatorCharts = null;
            for (let b of fromEnum(a)) {
                this.wt(b);
            }
        }
        if ((this.qe == null || this.qe.count == 0) && (this.customIndicatorNames == null || this.customIndicatorNames.count == 0)) {
            this.indicatorCharts = null;
            if (this.r8 != null) {
                this.r8.clear();
            }
            if (this.sa != null) {
                this.sa.clear();
            }
            this.w3();
            this.xd();
            this.rz = false;
            return;
        }
        if (this.indicatorCharts == null) {
            this.indicatorCharts = new List$1(XamDataChart.$, 0);
        }
        this.indicatorCharts.clear();
        this.r8.clear();
        this.sa.clear();
        let c = this.qe == null ? 0 : this.qe.count;
        let d = this.customIndicatorNames == null ? 0 : this.customIndicatorNames.count;
        let e = c + d;
        for (let f = 0; f < e; f++) {
            let g = new XamDataChart();
            this.indicatorCharts.add(g);
            this.wr(g);
            let h = f >= c;
            g.hk = h ? this.customIndicatorNames._inner[f - c] : EnumUtil.getName(FinancialIndicatorType_$type, this.qe._inner[f]);
            if (this.indicatorAxis != null) {
                let i;
                let j;
                if (f == 0) {
                    i = this.indicatorAxis;
                    j = this.indicatorXAxis;
                }
                else {
                    i = new NumericYAxis();
                    if (!this.indicatorXAxis.b7) {
                        j = this.pk(0);
                    }
                    else {
                        j = this.pk(1);
                    }
                }
                j.name = "indicatorXAxis_" + f;
                i.name = "indicatorAxis_" + f;
                g.axes.add(i);
                g.axes.add(j);
                this.r8.add(i);
                this.sa.add(j);
                if (this.bh) {
                    this.nh(i);
                }
                if (this.bh) {
                    this.nf(j);
                }
            }
        }
        this.wx();
        this.w3();
        if (this.py != null) {
            this.py.ae = this.qe;
        }
        this.v2();
        this.xd();
        this.rz = false;
    }
    gc() {
        super.gc();
        this.nf(this.xAxis);
        this.nf(this.volumeXAxis);
        if (this.sa != null) {
            for (let a of fromEnum(this.sa)) {
                this.nf(a);
            }
        }
        this.nh(this.yAxis);
        this.nh(this.volumeAxis);
        if (this.r8 != null) {
            for (let b of fromEnum(this.r8)) {
                this.nh(b);
            }
        }
        this.nf(this.zoomSliderXAxis);
        this.nh(this.zoomSliderAxis);
    }
    get_bv() {
        return !this.rx;
    }
    get r3() {
        return (this.externalObject._dynamicContent);
    }
    xk(a, b) {
        this.w6(a, b);
        this.v2();
        if (this.zoomSliderChart != null) {
            this.zoomSliderChart.axes.add(this.zoomSliderAxis);
            this.zoomSliderChart.axes.add(this.zoomSliderXAxis);
        }
        this.wz();
        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
        this.w4();
        this.xl(a, b);
    }
    wz() {
        if (this.dataChart == null || this.zoomSliderChart == null) {
            return;
        }
        this.zoomSliderChart.series.clear();
        let a = new List$1(Series.$, 0);
        for (let b = 0; b < this.dataChart.series.count; b++) {
            let c = this.dataChart.series._inner[b];
            if (this.rt(c) || c.cj) {
                continue;
            }
            let d;
            let e = this.qc;
            e = this.qb(e);
            let f = this.tg(c, b);
            if (e == 1) {
                switch (this.p2(this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null)) {
                    case 1:
                        e = 2;
                        break;
                    case 2:
                        e = 3;
                        break;
                    case 3:
                        e = 4;
                        break;
                    case 4:
                        e = 5;
                        break;
                }
            }
            switch (e) {
                case 2:
                    d = this.q7();
                    this.qk.setDisplayType(d, 1);
                    break;
                case 3:
                    d = this.q7();
                    this.qk.setDisplayType(d, 0);
                    break;
                case 5:
                    d = this.q6();
                    break;
                case 6:
                    d = this.q4();
                    break;
                default:
                case 4:
                    d = this.q5();
                    break;
            }
            let g = this.v != null && this.v.dataSeries != null && this.v.dataSeries.count > f ? this.v.dataSeries._inner[f] : null;
            if (d.cl && !d.cr) {
                this.qm.setCategoryMode(d, 1);
                this.qm.setXAxis(d, this.zoomSliderXAxis);
                this.qm.setYAxis(d, this.zoomSliderAxis);
                this.qm.setValueMemberPath(d, g == null ? null : this.t9(g));
            }
            else if (d.cr) {
                this.qk.setCategoryMode(d, 1);
                this.qk.setXAxis(d, this.zoomSliderXAxis);
                this.qk.setYAxis(d, this.zoomSliderAxis);
                if (g != null) {
                    this.qk.setOpenMemberPath(d, g.getMemberPathFor(11));
                    this.qk.setHighMemberPath(d, g.getMemberPathFor(12));
                    this.qk.setLowMemberPath(d, g.getMemberPathFor(13));
                    this.qk.setCloseMemberPath(d, g.getMemberPathFor(14));
                    this.qk.setVolumeMemberPath(d, g.getMemberPathFor(15));
                }
            }
            d.name = "zoomSliderSeries_" + f;
            d.itemsSource = c.itemsSource;
            d.fx = c.fx;
            a.add(d);
        }
        for (let h = 0; h < a.count; h++) {
            let i = a._inner[h];
            this.zoomSliderChart.series.add(i);
            this.gk(i, h);
        }
    }
    gz(a, b, c) {
        super.gz(a, b, c);
        if (a == null || !b) {
            return;
        }
        let d = true;
        let e = true;
        switch (c) {
            case "Brushes":
            case "Outlines":
                d = e = false;
                break;
        }
        if (this.indicatorCharts != null && d) {
            for (let f of fromEnum(this.indicatorCharts)) {
                a(f);
            }
        }
        if (this.volumeChart != null && e) {
            a(this.volumeChart);
        }
        if (this.zoomSliderChart != null) {
            a(this.zoomSliderChart);
        }
    }
    wc(a, b) {
        let c = b;
        let d = a;
        let e = -1;
        if (this.indicatorCharts != null) {
            e = this.indicatorCharts.indexOf(d.bq);
        }
        e -= this.qe == null ? 0 : this.qe.count;
        if (this.applyCustomIndicators != null) {
            this.applyCustomIndicators(this, new FinancialChartCustomIndicatorArgs(c, d, e));
        }
    }
    w8(a, b, c) {
        if (a != null) {
            if (b != null) {
                a.axes.remove(b);
            }
            a.axes.add(c);
        }
        if (this.bh) {
            this.nf(c);
        }
    }
    get r2() {
        return TypeRegistrar.isRegistered("IgxZoomSliderComponent");
    }
    wd(a, b) {
        this.xc();
    }
    rv(a, b) {
        if (b <= (0)) {
            return false;
        }
        switch (a) {
            case 5: return true;
            case 4:
            case 3: return b >= timeSpanFromDays(365);
            case 2: return b >= timeSpanFromDays(180);
            case 1: return b >= timeSpanFromDays(90);
            case 0: return b >= timeSpanFromDays(30);
        }
        return false;
    }
    w2() {
        let a = this.pw != null ? this.pw : new FinancialChartRangeSelectorOptionCollection(1, [5, 4, 3, 2, 1, 0]);
        let b = new FinancialChartRangeSelectorOptionCollection(0);
        let c = this.xAxis;
        let d = +(c.actualMaximumValue) - +(c.actualMinimumValue);
        for (let e of fromEnum(a)) {
            if (this.rv(e, d)) {
                b.add(e);
            }
        }
        this.pv = b;
        if (this.py != null) {
            this.py.u = this.pv;
        }
    }
    wh(a, b) {
        this.w2();
    }
    wm(a, b) {
        this.qg = this.py.ag;
    }
    wl(a, b) {
        this.qe = this.py.ae;
    }
    wf(a, b) {
        this.xc();
    }
    wg(a, b) {
        this.xe();
    }
    wq(a, b) {
        let c = a;
        if (c.bf == null) {
            return;
        }
        if (this.rx) {
            this.w1(c.bf);
        }
    }
    wt(a) {
        SyncManager.e(a);
        a.axes.clear();
        a.series.clear();
        a.gridAreaRectChanged = delegateRemove(a.gridAreaRectChanged, runOn(this, this.we));
        a.provideContainer(null);
        if (this.volumeChart == null && this.indicatorCharts == null) {
            this.yAxis.d6 = this.volumeAxis.d6 = this.indicatorAxis.d6 = 0;
            this.xAxis.ay.visibility = this.ox;
        }
    }
    wr(a) {
        let b = a != this.zoomSliderChart;
        if (b) {
            if (this.dataChart != null) {
                a.oi = new Rect(0, this.dataChart.n2.x, a.oi.y, this.dataChart.n2.width, a.oi.height);
            }
            let c = ((() => {
                let $ret = new SyncSettings();
                $ret.syncChannel = "one";
                $ret.synchronizeHorizontally = true;
                $ret.synchronizeVertically = false;
                return $ret;
            })());
            SyncManager.d(a, c);
            SyncManager.c(a);
        }
        a.gridAreaRectChanged = delegateCombine(a.gridAreaRectChanged, runOn(this, this.we));
        this.ge(a);
    }
    v2() {
        if (this.indicatorCharts != null || this.volumeChart != null) {
            this.nd(this.xAxis, (a) => a.visibility = 1);
        }
        for (let a = 0; a < this.sa.count; a++) {
            let b = this.sa._inner[a];
            let c = a < this.sa.count - 1 || this.volumeChart != null;
            this.nd(b, (d) => d.visibility = c ? 1 : 0);
        }
    }
    w6(a, b) {
        if (a != null) {
            this.wt(a);
        }
        if (b != null) {
            this.wr(b);
        }
    }
    xi(a, b) {
        this.w6(a, b);
        this.v2();
        if (this.volumeChart != null) {
            if (this.volumeAxis != null) {
                this.volumeChart.axes.add(this.volumeAxis);
                this.volumeChart.axes.add(this.volumeXAxis);
            }
            this.wy();
            this.volumeXAxis.itemsSource = this.xAxis.itemsSource;
        }
        this.xj(a, b);
    }
    wi(a, b) {
        this.xg();
    }
    xg() {
        if (this.py == null || +(this.py.au) == +(dateMaxValue()) || +(this.py.at) == +(dateMinValue()) || this.dataChart == null) {
            return;
        }
        let a = this.xAxis;
        let b = a.getWindowRectForSelection(this.py.au, this.py.at);
        if (b.width == 0 || isNaN_(b.width) || isInfinity(b.width)) {
            return;
        }
        this.ry = true;
        this.dataChart.oi = new Rect(0, b.left, this.dataChart.oi.top, b.width, this.dataChart.oi.height);
        if (this.rg != null) {
            this.rg.windowRect = this.dataChart.n2;
        }
        if (this.rx) {
            this.w1(this.dataChart);
        }
        this.ry = false;
    }
    wp(a, b) {
        this.w2();
        this.xf(!this.ry);
    }
    wb(a, b) {
        if (!this.ry) {
            if (this.rx) {
                this.w1(a);
            }
            let c = false;
            let d = this.g8(() => this.xf(true), c);
            c = d.p1;
            if (this.rg != null) {
                this.rg.windowRect = this.dataChart.n2;
            }
        }
    }
    xa(a, b, c, d) {
        if (a == null || b == null) {
            return;
        }
        if (c != -1) {
            this.ry = true;
            a.oi = new Rect(0, d, a.n2.top, c, a.n2.height);
            this.ry = false;
        }
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        let g = new Rect(0, 0, 0, 1, 1);
        let h = new ScalerParams(0, g, g, this.yAxis.ca, a.n6);
        for (let i of fromEnum(a.series)) {
            h.b = i.eh();
            let j = i.ao(a.n2);
            let k = j == null || j.c == 1.7976931348623157E+308 || isNaN_(j.c);
            if (k) {
                continue;
            }
            let l = b.dy(j.c, h);
            let m = b.dy(j.b, h);
            f = Math.max(f, l);
            e = Math.min(e, m);
        }
        let n = a.n2.width;
        if (c != -1) {
            n = c;
        }
        let o = a.n2.left;
        if (d != -1) {
            o = d;
        }
        if (e == 1.7976931348623157E+308 || f == -1.7976931348623157E+308 || isNaN_(e) || isNaN_(f)) {
            return;
        }
        this.ry = true;
        let p = new Rect(0, o, e, n, f - e);
        a.oi = p;
        this.ry = false;
    }
    w9(a) {
        if (a == null) {
            return;
        }
        if (a == this.dataChart) {
            this.xa(this.dataChart, this.yAxis, -1, -1);
            if (this.volumeChart != null) {
                this.xa(this.volumeChart, this.volumeAxis, this.dataChart.n2.width, this.dataChart.n2.left);
            }
        }
        else if (a == this.volumeChart) {
            this.xa(this.volumeChart, this.volumeAxis, -1, -1);
            this.xa(this.dataChart, this.yAxis, this.volumeChart.n2.width, this.volumeChart.n2.left);
        }
    }
    w1(a) {
        this.g7(() => this.w9(a));
    }
    wj(a, b) {
        if (this.rx) {
            this.w1(a);
        }
    }
    xh() {
        if (!this.r3) {
            return;
        }
        this.v5();
        if (this.qc == 0) {
            this.zoomSliderChart = null;
        }
        else if (this.zoomSliderChart == null) {
            this.zoomSliderChart = ((() => {
                let $ret = new XamDataChart();
                $ret.name = "ZoomSliderChart";
                return $ret;
            })());
        }
        else {
            this.wz();
        }
    }
    v5() {
        let container_ = this.s8.rootWrapper.getNativeElement();
        let containerParent_ = container_.parentElement;
        if (this.rg != null && containerParent_ != null && !this.r4) {
            this.r4 = true;
            if (TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
                let z_ = this.rg;
                let f_ = this.externalObject;
                let sliderComponent_ = TypeRegistrar.get("IgxZoomSliderComponent");
                let sliderInstance_ = TypeRegistrar.create("IgxZoomSliderComponent");
                sliderInstance_._implementation = z_;
                sliderComponent_._staticStyling(container_, sliderInstance_, f_);
            }
        }
    }
    xb() {
        if (this.p7 != 1) {
            return;
        }
        this.nj((a) => {
            let b;
            b = a.breaks;
            b.clear();
            if (this.xAxisBreaks == null) {
                return;
            }
            for (let c of fromEnum(this.xAxisBreaks)) {
                b.add(c);
            }
        });
    }
    hq(a, b, c) {
        super.hq(a, b, c);
        if (this.v.dataSeries.count > 0) {
            if (this.p7 == 1 && stringIsNullOrEmpty(this.ea)) {
                this.ac.setXMemberPath(a, c.getMemberPathFor(17));
            }
            if (stringIsNullOrEmpty(this.ec)) {
                this.ac.setYMemberPath(a, this.t9(c));
            }
            if (stringIsNullOrEmpty(this.d6)) {
                this.ac.setLabelMemberPath(a, this.t9(c));
            }
            if (stringIsNullOrEmpty(this.d3)) {
                this.ac.setContentMemberPath(a, this.t9(c));
            }
        }
    }
    nf(a) {
        super.nf(a);
        let b = a;
        this.ws(b);
        if (a.bf != null) {
            for (let c of fromEnum(a.bf.series)) {
                if (this.rq(c)) {
                    this.qm.setXAxis(c, b);
                }
                else if (this.ru(c)) {
                    this.qk.setXAxis(c, b);
                }
                else if (this.rr(c)) {
                    this.qo.setXAxis(c, b);
                }
                else if (this.rt(c)) {
                    this.qt.setXAxis(c, b);
                }
            }
        }
        let d = a == this.zoomSliderXAxis;
        if (d) {
            a.is = this.xn;
            a.d5 = this.s3;
            this.nd(a, (e) => e.visibility = 1);
        }
        let e = a;
        e.minimumValue = this.sg;
        e.maximumValue = this.sf;
    }
    nh(a) {
        super.nh(a);
        if (a.bf != null && a == this.yAxis) {
            for (let b of fromEnum(a.bf.series)) {
                if (this.rq(b)) {
                    this.qm.setYAxis(b, this.yAxis);
                }
                else if (this.ru(b)) {
                    this.qk.setYAxis(b, this.yAxis);
                }
                else if (this.rr(b)) {
                    this.qo.setYAxis(b, this.yAxis);
                }
                else if (this.rt(b)) {
                    this.qt.setYAxis(b, this.yAxis);
                }
            }
        }
        a.jw = this.r0;
        a.kk = this.s1;
        a.kj = this.s0;
        if (a == this.yAxis) {
            a.kg = this.sz;
        }
        let c = a == this.zoomSliderAxis;
        if (c) {
            this.nd(a, (d) => d.visibility = 1);
        }
    }
    ws(a) {
        a.itemsSource = this.dataChart != null && this.dataChart.series.count > 0 ? this.dataChart.series._inner[0].itemsSource : null;
        a.e9 = XYChart.k3(a, this.v.dataSeries);
        if (this.v.dataSeries.count > 0) {
            let b = this.v.dataSeries._inner[0].getMemberPathFor(17);
            a.g1(b);
        }
    }
    gk(a, b) {
        super.gk(a, b);
        if (a == null) {
            return;
        }
        let c = this.dataChart != null && this.dataChart.series.contains(a);
        if (c && a.cz) {
            a.jq(this.o9 != null ? ArrayExtension.getModulus$1(Brush.$, this.o9, b) : null, this.pa != null ? ArrayExtension.getModulus$1(Brush.$, this.pa, b) : null);
        }
        let d = this.zoomSliderChart == a.bq;
        let e = this.rr(a);
        if (this.rt(a)) {
            a.ld = this.pb != null ? ArrayExtension.getModulus$1(Brush.$, this.pb, b) : null;
            a.li = this.pc != null ? ArrayExtension.getModulus$1(Brush.$, this.pc, b) : null;
            a.ey = this.su;
        }
        else if (e) {
            a.ld = this.o7 != null ? ArrayExtension.getModulus$1(Brush.$, this.o7, b) : null;
            a.ey = this.st;
        }
        else if (!a.cj && (c || d)) {
            a.ld = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, b) : null;
            a.li = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, b) : null;
        }
        let f = this.volumeChart != null && this.volumeChart == a.bq;
        if (f) {
            a.ey = this.sw;
        }
        a.legend = d || f || e || !a.isUsableInLegend ? null : this.legend != null ? this.legend : this.rs ? this.qi : null;
    }
    g3(a, b, c) {
        super.g3(a, b, c);
        switch (a) {
            case "YAxisIsLogarithmic":
                this.yAxis.j1 = this.r1;
                if (this.volumeAxis != null) {
                    this.volumeAxis.j1 = this.r1;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.j1 = this.r1;
                }
                break;
            case "YAxisLogarithmBase":
                this.yAxis.ko = this.tn;
                if (this.volumeAxis != null) {
                    this.volumeAxis.ko = this.tn;
                }
                if (this.zoomSliderAxis != null) {
                    this.zoomSliderAxis.ko = this.tn;
                }
                break;
            case "VolumeType":
                let d = EnumUtil.getEnumValue(FinancialChartVolumeType_$type, b);
                if (this.p5 == 0) {
                    this.volumeChart = null;
                }
                else if (this.volumeChart == null) {
                    this.volumeChart = ((() => {
                        let $ret = new XamDataChart();
                        $ret.name = "VolumeChart";
                        return $ret;
                    })());
                }
                else {
                    this.wy();
                }
                break;
            case "VolumeChart":
                this.xi(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "DataChart":
                if (typeCast(XamDataChart.$, b) !== null) {
                    let e = b;
                    e.gridAreaRectChanged = delegateRemove(e.gridAreaRectChanged, runOn(this, this.we));
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.wb));
                    e.seriesDataUpdated = delegateRemove(e.seriesDataUpdated, runOn(this, this.wj));
                }
                if (this.dataChart != null) {
                    let f = this.dataChart;
                    f.gridAreaRectChanged = delegateCombine(f.gridAreaRectChanged, runOn(this, this.we));
                    let g = this.dataChart;
                    g.actualWindowRectChanged = delegateCombine(g.actualWindowRectChanged, runOn(this, this.wb));
                    let h = this.dataChart;
                    h.seriesDataUpdated = delegateCombine(h.seriesDataUpdated, runOn(this, this.wj));
                }
                this.xh();
                break;
            case "XAxisMode":
                this.xAxis = this.pk(this.p7);
                this.xAxis.name = "xAxis";
                this.volumeXAxis = this.pk(this.p7);
                this.volumeXAxis.name = "volumeXAxis";
                this.indicatorXAxis = this.pk(this.p7);
                this.indicatorXAxis.name = "indicatorXAxis_0";
                this.zoomSliderXAxis = this.pk(this.p7);
                this.zoomSliderXAxis.name = "zoomSliderXAxis";
                this.nd(this.zoomSliderXAxis, (i) => i.visibility = 1);
                this.v2();
                if (this.p7 == 1) {
                    this.xb();
                }
                break;
            case "YAxisMode":
                this.yAxis = this.qy(this.p9);
                this.yAxis.name = "yAxis";
                this.zoomSliderAxis = this.qy(this.p9);
                this.zoomSliderAxis.name = "zoomSliderAxis";
                this.volumeAxis = this.qy(this.p9);
                this.volumeAxis.name = "volumeAxis";
                break;
            case "Toolbar":
                let i = typeCast(FinancialChartToolbar.$, b);
                if (i != null) {
                    i.rangeChanged = delegateRemove(i.rangeChanged, runOn(this, this.wi));
                    i.indicatorTypesChanged = delegateRemove(i.indicatorTypesChanged, runOn(this, this.wl));
                    i.overlayTypesChanged = delegateRemove(i.overlayTypesChanged, runOn(this, this.wm));
                }
                if (this.py != null) {
                    this.py.ae = this.qe;
                    this.py.ag = this.qg;
                    this.py.u = this.pv;
                    this.xf(true);
                    let j = this.py;
                    j.rangeChanged = delegateCombine(j.rangeChanged, runOn(this, this.wi));
                    let k = this.py;
                    k.indicatorTypesChanged = delegateCombine(k.indicatorTypesChanged, runOn(this, this.wl));
                    let l = this.py;
                    l.overlayTypesChanged = delegateCombine(l.overlayTypesChanged, runOn(this, this.wm));
                }
                break;
            case "XAxis":
                let m = typeCast(CategoryAxisBase.$, b);
                if (m != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(m);
                    }
                }
                let n = typeCast(ITimeRangeSelectorAxis_$type, b);
                if (n != null) {
                    n.visibleRangeChanged = delegateRemove(n.visibleRangeChanged, runOn(this, this.wp));
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.xAxis);
                }
                if (this.bh) {
                    this.nf(this.xAxis);
                    this.f7();
                }
                this.xf(false);
                this.xg();
                this.w2();
                let o = this.xAxis;
                o.visibleRangeChanged = delegateCombine(o.visibleRangeChanged, runOn(this, this.wp));
                break;
            case "ChartType":
                this.hl();
                break;
            case "VolumeXAxis":
                this.w8(this.volumeChart, typeCast(Axis.$, b), this.volumeXAxis);
                break;
            case "ZoomSliderXAxis":
                this.w8(this.zoomSliderChart, typeCast(Axis.$, b), this.zoomSliderXAxis);
                break;
            case "IndicatorXAxis":
                this.xc();
                break;
            case "YAxis":
                let p = typeCast(NumericYAxis.$, b);
                if (p != null) {
                    if (this.dataChart != null) {
                        this.dataChart.axes.remove(p);
                    }
                }
                if (this.dataChart != null) {
                    this.dataChart.axes.add(this.yAxis);
                }
                if (this.bh) {
                    this.nh(this.yAxis);
                    this.nh(this.yAxis);
                }
                let q = this.yAxis;
                q.rangeChanged = delegateCombine(q.rangeChanged, runOn(this, this.wq));
                break;
            case "VolumeAxis":
                let r = typeCast(Axis.$, b);
                if (this.volumeChart != null && r != null) {
                    this.volumeChart.axes.remove(r);
                }
                if (this.volumeChart != null && this.volumeAxis != null) {
                    this.volumeChart.axes.add(this.volumeAxis);
                    this.wy();
                }
                if (this.bh) {
                    this.nh(this.volumeAxis);
                }
                let s = this.volumeAxis;
                s.rangeChanged = delegateCombine(s.rangeChanged, runOn(this, this.wq));
                break;
            case "IndicatorAxis":
                if (this.indicatorCharts != null) {
                    for (let t = 0; t < this.indicatorCharts.count; t++) {
                        let u = this.indicatorCharts._inner[t];
                        let v = new List$1(Axis.$, 0);
                        for (let w of fromEnum(u.axes)) {
                            if (typeCast(NumericYAxis.$, w) !== null) {
                                v.add(w);
                            }
                        }
                        for (let x of fromEnum(v)) {
                            u.axes.remove(x);
                        }
                        let y = null;
                        if (t == 0) {
                            y = this.indicatorAxis;
                        }
                        else if (this.p9 == 1) {
                            y = this.qy(this.p9);
                        }
                        else if (typeCast(NumericYAxis.$, this.indicatorAxis) !== null) {
                            y = new NumericYAxis();
                        }
                        if (y != null) {
                            u.axes.add(y);
                        }
                        if (this.bh) {
                            this.nh(y);
                        }
                    }
                }
                break;
            case "IsWindowSyncedToVisibleRange":
                if (this.dataChart != null) {
                    this.dataChart.o9 = this.bw && this.bv;
                }
                if (this.volumeChart != null) {
                    this.volumeChart.o9 = this.bw && this.bv;
                }
                if (this.rx) {
                    this.w9(this.dataChart);
                }
                else {
                    this.volumeChart.pv = 1;
                }
                break;
            case "IndicatorTypes":
                let z = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), b);
                if (z != null) {
                    z.collectionChanged = delegateRemove(z.collectionChanged, runOn(this, this.wf));
                }
                let aa = typeCast(ObservableCollection$1.$.specialize(FinancialIndicatorType_$type), c);
                if (aa != null) {
                    aa.collectionChanged = delegateCombine(aa.collectionChanged, runOn(this, this.wf));
                }
                this.xc();
                break;
            case "OverlayTypes":
                let ab = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), b);
                if (ab != null) {
                    ab.collectionChanged = delegateRemove(ab.collectionChanged, runOn(this, this.wg));
                }
                let ac = typeCast(ObservableCollection$1.$.specialize(FinancialOverlayType_$type), c);
                if (ac != null) {
                    ac.collectionChanged = delegateCombine(ac.collectionChanged, runOn(this, this.wg));
                }
                this.xe();
                break;
            case "YAxisAbbreviateLargeNumbers":
                this.nn((ad) => ad.jw = this.r0);
                break;
            case "YAxisMinimumValue":
                this.no((ad) => ad.kk = this.s1, false);
                break;
            case "YAxisMaximumValue":
                this.no((ad) => ad.kj = this.s0, false);
                break;
            case "YAxisInterval":
                this.no((ad) => ad.kg = this.sz, false);
                break;
            case "ZoomSliderType":
                this.xh();
                break;
            case "ZoomSliderChart":
                if (!this.r2) {
                    return;
                }
                this.xk(typeCast(XamDataChart.$, b), typeCast(XamDataChart.$, c));
                break;
            case "NegativeBrushes":
            case "NegativeOutlines":
                this.v8((ad, ae) => {
                    if (ad.cz) {
                        ad.jq(this.o9 != null ? ArrayExtension.getModulus$1(Brush.$, this.o9, ae) : null, this.pa != null ? ArrayExtension.getModulus$1(Brush.$, this.pa, ae) : null);
                    }
                }, true);
                break;
            case "OverlayBrushes":
                this.f9((ad, ae) => {
                    if (!(this.rt(ad))) {
                        return;
                    }
                    ad.ld = this.pb != null ? ArrayExtension.getModulus$1(Brush.$, this.pb, ae) : null;
                });
                break;
            case "OverlayOutlines":
                this.f9((ad, ae) => {
                    if (!(this.rt(ad))) {
                        return;
                    }
                    ad.li = this.pc != null ? ArrayExtension.getModulus$1(Brush.$, this.pc, ae) : null;
                });
                break;
            case "OverlayThickness":
                this.f9((ad, ae) => {
                    if (!(this.rt(ad))) {
                        return;
                    }
                    ad.ey = this.su;
                });
                break;
            case "VolumeBrushes":
                this.v9((ad, ae) => ad.ld = ArrayExtension.getModulus$1(Brush.$, this.pd, ae));
                break;
            case "VolumeOutlines":
                this.v9((ad, ae) => ad.li = ArrayExtension.getModulus$1(Brush.$, this.pe, ae));
                break;
            case "VolumeThickness":
                this.v9((ad, ae) => ad.ey = this.sw);
                break;
            case "IndicatorNegativeBrushes":
                this.v6((ad, ae) => this.qo.setNegativeBrush(ad, ArrayExtension.getModulus$1(Brush.$, this.o8, ae)));
                break;
            case "IndicatorBrushes":
                this.v6((ad, ae) => ad.ld = ArrayExtension.getModulus$1(Brush.$, this.o7, ae));
                break;
            case "IndicatorThickness":
                this.v6((ad, ae) => ad.ey = this.st);
                break;
            case "IndicatorDisplayTypes":
                this.v6((ad, ae) => this.qo.setDisplayType(ad, ArrayExtension.getModulus$1(IndicatorDisplayType_$type, this.qq, ae)));
                break;
            case "IndicatorPeriod":
                this.v6((ad, ae) => {
                    if (this.ti == -2147483648 || !(this.rr(ad))) {
                        return;
                    }
                    this.qo.setPeriodOverride(ad, this.ti);
                });
                break;
            case "IndicatorMultiplier":
                this.v6((ad, ae) => {
                    if (!(this.rt(ad))) {
                        return;
                    }
                    this.qt.setMultiplier(ad, this.ss);
                });
                break;
            case "IndicatorSmoothingPeriod":
                this.v6((ad, ae) => {
                    if (!(this.rr(ad))) {
                        return;
                    }
                    this.qo.setSmoothingPeriod(ad, this.tl);
                });
                break;
            case "IndicatorShortPeriod":
                this.v6((ad, ae) => {
                    if (!(this.rr(ad))) {
                        return;
                    }
                    this.qo.setShortPeriod(ad, this.tj);
                });
                break;
            case "IndicatorLongPeriod":
                this.v6((ad, ae) => {
                    if (!(this.rr(ad))) {
                        return;
                    }
                    this.qo.setLongPeriod(ad, this.th);
                });
                break;
            case "IndicatorSignalPeriod":
                this.v6((ad, ae) => {
                    if (!(this.rr(ad))) {
                        return;
                    }
                    this.qo.setSignalPeriod(ad, this.tk);
                });
                break;
            case "RangeSelectorOptions":
                let ad = typeCast(FinancialChartRangeSelectorOptionCollection.$, b);
                if (ad != null) {
                    ad.collectionChanged = delegateRemove(ad.collectionChanged, runOn(this, this.wh));
                }
                if (this.pw != null) {
                    let ae = this.pw;
                    ae.collectionChanged = delegateCombine(ae.collectionChanged, runOn(this, this.wh));
                }
                this.w2();
                break;
            case "CustomIndicatorNames":
                let af = typeCast(ObservableCollection$1.$.specialize(String_$type), b);
                if (af != null) {
                    af.collectionChanged = delegateRemove(af.collectionChanged, runOn(this, this.wd));
                }
                if (this.customIndicatorNames != null) {
                    let ag = this.customIndicatorNames;
                    ag.collectionChanged = delegateCombine(ag.collectionChanged, runOn(this, this.wd));
                }
                this.xc();
                break;
            case "Legend":
                if (this.zoomSliderChart != null) {
                    this.zoomSliderChart.legend = null;
                }
                break;
            case "Brushes":
                this.v8((ah, ai) => ah.ld = this.j != null ? ArrayExtension.getModulus$1(Brush.$, this.j, ai) : null, true);
                break;
            case "Outlines":
                this.v8((ah, ai) => ah.li = this.n != null ? ArrayExtension.getModulus$1(Brush.$, this.n, ai) : null, true);
                break;
            case "XAxisLabelVisibility":
                if (this.ox == 0 && this.zoomSliderXAxis != null) {
                    this.nd(this.zoomSliderXAxis, (ah) => ah.visibility = 1);
                }
                this.v2();
                break;
            case "YAxisLabelVisibility":
                if (this.oy != 0 || this.zoomSliderAxis == null) {
                    break;
                }
                this.nd(this.zoomSliderAxis, (ah) => ah.visibility = 1);
                break;
            case "ZoomSliderXAxisMajorStroke":
                this.zoomSliderXAxis.is = this.xn;
                break;
            case "ZoomSliderXAxisMajorStrokeThickness":
                this.zoomSliderXAxis.d5 = this.s3;
                break;
            case "FinancialChartLegend":
            case "IsLegendVisible":
                let ah = this.rs && this.legend == null;
                {
                    let ai = (aj, ak) => {
                        if (aj.isUsableInLegend) {
                            aj.legend = ah ? this.qi : null;
                        }
                    };
                    this.v8(ai, false);
                    this.v7(ai);
                }
                break;
            case "ZoomSliderAxis":
                let aj = typeCast(Axis.$, b);
                if (aj != null && this.zoomSliderChart != null) {
                    this.zoomSliderChart.axes.remove(aj);
                }
                if (this.zoomSliderAxis != null) {
                    if (this.zoomSliderChart != null) {
                        this.zoomSliderChart.axes.add(this.zoomSliderAxis);
                        this.wz();
                        this.zoomSliderXAxis.itemsSource = this.xAxis.itemsSource;
                    }
                    if (this.bh) {
                        this.nh(this.zoomSliderAxis);
                    }
                    this.nd(this.zoomSliderAxis, (ak) => ak.visibility = 1);
                }
                break;
            case "XAxisMinimumValue":
                this.nj((ak) => {
                    let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.minimumValue = this.sg;
                    }
                });
                break;
            case "XAxisMaximumValue":
                this.nj((ak) => {
                    let al = typeCast(ITimeRangeSelectorAxis_$type, ak);
                    if (al != null) {
                        al.maximumValue = this.sf;
                    }
                });
                break;
        }
    }
    get r1() {
        return this.rl;
    }
    set r1(a) {
        let b = this.r1;
        if (a != b) {
            this.rl = a;
            this.g3("YAxisIsLogarithmic", b, this.r1);
        }
    }
    get tn() {
        return this.tf;
    }
    set tn(a) {
        let b = this.tn;
        if (a != b) {
            this.tf = a;
            this.g3("YAxisLogarithmBase", b, this.tn);
        }
    }
    get sz() {
        return this.sm;
    }
    set sz(a) {
        let b = this.sz;
        if (a != b) {
            this.sm = a;
            this.g3("YAxisInterval", b, this.sz);
        }
    }
    get s1() {
        return this.so;
    }
    set s1(a) {
        let b = this.s1;
        if (a != b) {
            this.so = a;
            this.g3("YAxisMinimumValue", b, this.s1);
        }
    }
    get s0() {
        return this.sn;
    }
    set s0(a) {
        let b = this.s0;
        if (a != b) {
            this.sn = a;
            this.g3("YAxisMaximumValue", b, this.s0);
        }
    }
    get s2() {
        return this.sp;
    }
    set s2(a) {
        let b = this.s2;
        if (a != b) {
            this.sp = a;
            this.g3("YAxisMinorInterval", b, this.s2);
        }
    }
    get sy() {
        return this.yAxis.kc;
    }
    get sx() {
        return this.yAxis.kb;
    }
    get p5() {
        return this.p3;
    }
    set p5(a) {
        let b = this.p5;
        if (a != b) {
            this.p3 = a;
            this.g3("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.p5));
        }
    }
    get p7() {
        return this.p6;
    }
    set p7(a) {
        let b = this.p7;
        if (a != b) {
            this.p6 = a;
            this.g3("XAxisMode", enumGetBox(FinancialChartXAxisMode_$type, b), enumGetBox(FinancialChartXAxisMode_$type, this.p7));
        }
    }
    get p9() {
        return this.p8;
    }
    set p9(a) {
        let b = this.p9;
        if (a != b) {
            this.p8 = a;
            this.g3("YAxisMode", enumGetBox(FinancialChartYAxisMode_$type, b), enumGetBox(FinancialChartYAxisMode_$type, this.p9));
        }
    }
    get rw() {
        return this.ri;
    }
    set rw(a) {
        let b = this.rw;
        if (a != b) {
            this.ri = a;
            this.g3("IsToolbarVisible", b, this.rw);
        }
    }
    get p0() {
        return this.pz;
    }
    set p0(a) {
        let b = this.p0;
        if (a != b) {
            this.pz = a;
            this.g3("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.p0));
        }
    }
    get_nw() {
        return super.get_nw();
    }
    set_nw(a) {
        super.set_nw(a);
    }
    get rx() {
        return this.rj;
    }
    set rx(a) {
        let b = this.rx;
        if (a != b) {
            this.rj = a;
            this.g3("IsWindowSyncedToVisibleRange", b, this.rx);
        }
    }
    get qe() {
        return this.qd;
    }
    set qe(a) {
        let b = this.qe;
        if (a != b) {
            this.qd = a;
            this.g3("IndicatorTypes", b, this.qe);
        }
    }
    get qg() {
        return this.qf;
    }
    set qg(a) {
        let b = this.qg;
        if (a != b) {
            this.qf = a;
            this.g3("OverlayTypes", b, this.qg);
        }
    }
    get indicatorCharts() {
        return this.r6;
    }
    set indicatorCharts(a) {
        let b = this.indicatorCharts;
        if (a != b) {
            this.r6 = a;
            this.g3("IndicatorCharts", b, this.indicatorCharts);
        }
    }
    get r0() {
        return this.rk;
    }
    set r0(a) {
        let b = this.r0;
        if (a != b) {
            this.rk = a;
            this.g3("YAxisAbbreviateLargeNumbers", b, this.r0);
        }
    }
    get_cu() {
        return super.get_cu();
    }
    set_cu(a) {
        super.set_cu(a);
    }
    get_il() {
        return super.get_il();
    }
    set_il(a) {
        super.set_il(a);
    }
    get zoomSliderChart() {
        return this.rc;
    }
    set zoomSliderChart(a) {
        let b = this.zoomSliderChart;
        if (a != b) {
            this.rc = a;
            this.g3("ZoomSliderChart", b, this.zoomSliderChart);
        }
    }
    get zoomSliderAxis() {
        return this.qx;
    }
    set zoomSliderAxis(a) {
        let b = this.zoomSliderAxis;
        if (a != b) {
            this.qx = a;
            this.g3("ZoomSliderAxis", b, this.zoomSliderAxis);
        }
    }
    get zoomSliderXAxis() {
        return this.pi;
    }
    set zoomSliderXAxis(a) {
        let b = this.zoomSliderXAxis;
        if (a != b) {
            this.pi = a;
            this.g3("ZoomSliderXAxis", b, this.zoomSliderXAxis);
        }
    }
    get qc() {
        return this.qa;
    }
    set qc(a) {
        let b = this.qc;
        if (a != b) {
            this.qa = a;
            this.g3("ZoomSliderType", enumGetBox(FinancialChartZoomSliderType_$type, b), enumGetBox(FinancialChartZoomSliderType_$type, this.qc));
        }
    }
    get o9() {
        return this.o1;
    }
    set o9(a) {
        let b = this.o9;
        if (a != b) {
            this.o1 = a;
            this.g3("NegativeBrushes", b, this.o9);
        }
    }
    get pa() {
        return this.o2;
    }
    set pa(a) {
        let b = this.pa;
        if (a != b) {
            this.o2 = a;
            this.g3("NegativeOutlines", b, this.pa);
        }
    }
    get pb() {
        return this.o3;
    }
    set pb(a) {
        let b = this.pb;
        if (a != b) {
            this.o3 = a;
            this.g3("OverlayBrushes", b, this.pb);
        }
    }
    get pc() {
        return this.o4;
    }
    set pc(a) {
        let b = this.pc;
        if (a != b) {
            this.o4 = a;
            this.g3("OverlayOutlines", b, this.pc);
        }
    }
    get pe() {
        return this.o6;
    }
    set pe(a) {
        let b = this.pe;
        if (a != b) {
            this.o6 = a;
            this.g3("VolumeOutlines", b, this.pe);
        }
    }
    get pd() {
        return this.o5;
    }
    set pd(a) {
        let b = this.pd;
        if (a != b) {
            this.o5 = a;
            this.g3("VolumeBrushes", b, this.pd);
        }
    }
    get o8() {
        return this.o0;
    }
    set o8(a) {
        let b = this.o8;
        if (a != b) {
            this.o0 = a;
            this.g3("IndicatorNegativeBrushes", b, this.o8);
        }
    }
    get o7() {
        return this.oz;
    }
    set o7(a) {
        let b = this.o7;
        if (a != b) {
            this.oz = a;
            this.g3("IndicatorBrushes", b, this.o7);
        }
    }
    get sw() {
        return this.sl;
    }
    set sw(a) {
        let b = this.sw;
        if (a != b) {
            this.sl = a;
            this.g3("VolumeThickness", b, this.sw);
        }
    }
    get su() {
        return this.sj;
    }
    set su(a) {
        let b = this.su;
        if (a != b) {
            this.sj = a;
            this.g3("OverlayThickness", b, this.su);
        }
    }
    get st() {
        return this.si;
    }
    set st(a) {
        let b = this.st;
        if (a != b) {
            this.si = a;
            this.g3("IndicatorThickness", b, this.st);
        }
    }
    get qq() {
        return this.qp;
    }
    set qq(a) {
        let b = this.qq;
        if (a != b) {
            this.qp = a;
            this.g3("IndicatorDisplayTypes", b, this.qq);
        }
    }
    get ti() {
        return this.tb;
    }
    set ti(a) {
        let b = this.ti;
        if (a != b) {
            this.tb = a;
            this.g3("IndicatorPeriod", b, this.ti);
        }
    }
    get ss() {
        return this.sh;
    }
    set ss(a) {
        let b = this.ss;
        if (a != b) {
            this.sh = a;
            this.g3("IndicatorMultiplier", b, this.ss);
        }
    }
    get tl() {
        return this.te;
    }
    set tl(a) {
        let b = this.tl;
        if (a != b) {
            this.te = a;
            this.g3("IndicatorSmoothingPeriod", b, this.tl);
        }
    }
    get tj() {
        return this.tc;
    }
    set tj(a) {
        let b = this.tj;
        if (a != b) {
            this.tc = a;
            this.g3("IndicatorShortPeriod", b, this.tj);
        }
    }
    get th() {
        return this.ta;
    }
    set th(a) {
        let b = this.th;
        if (a != b) {
            this.ta = a;
            this.g3("IndicatorLongPeriod", b, this.th);
        }
    }
    get tk() {
        return this.td;
    }
    set tk(a) {
        let b = this.tk;
        if (a != b) {
            this.td = a;
            this.g3("IndicatorSignalPeriod", b, this.tk);
        }
    }
    get pw() {
        return this.pu;
    }
    set pw(a) {
        let b = this.pw;
        if (a != b) {
            this.pu = a;
            this.g3("RangeSelectorOptions", b, this.pw);
        }
    }
    get customIndicatorNames() {
        return this.pq;
    }
    set customIndicatorNames(a) {
        let b = this.pq;
        if (a != b) {
            this.pq = a;
            this.g3("CustomIndicatorNames", b, this.customIndicatorNames);
        }
    }
    get_bw() {
        return super.get_bw();
    }
    set_bw(a) {
        super.set_bw(a);
    }
    get xn() {
        return this.xm;
    }
    set xn(a) {
        let b = this.xn;
        if (a != b) {
            this.xm = a;
            this.g3("ZoomSliderXAxisMajorStroke", b, this.xn);
        }
    }
    get s3() {
        return this.sq;
    }
    set s3(a) {
        let b = this.s3;
        if (a != b) {
            this.sq = a;
            this.g3("ZoomSliderXAxisMajorStrokeThickness", b, this.s3);
        }
    }
    get rs() {
        return this.rh;
    }
    set rs(a) {
        let b = this.rs;
        if (a != b) {
            this.rh = a;
            this.g3("IsLegendVisible", b, this.rs);
        }
    }
    get qi() {
        return this.qh;
    }
    set qi(a) {
        let b = this.qi;
        if (a != b) {
            this.qh = a;
            this.g3("FinancialChartLegend", b, this.qi);
        }
    }
    get xAxis() {
        return this.ph;
    }
    set xAxis(a) {
        let b = this.xAxis;
        if (a != b) {
            this.ph = a;
            this.g3("XAxis", b, this.xAxis);
        }
    }
    get yAxis() {
        return this.qw;
    }
    set yAxis(a) {
        let b = this.yAxis;
        if (a != b) {
            this.qw = a;
            this.g3("YAxis", b, this.yAxis);
        }
    }
    get volumeAxis() {
        return this.qv;
    }
    set volumeAxis(a) {
        let b = this.volumeAxis;
        if (a != b) {
            this.qv = a;
            this.g3("VolumeAxis", b, this.volumeAxis);
        }
    }
    get volumeXAxis() {
        return this.pg;
    }
    set volumeXAxis(a) {
        let b = this.volumeXAxis;
        if (a != b) {
            this.pg = a;
            this.g3("VolumeXAxis", b, this.volumeXAxis);
        }
    }
    get indicatorAxis() {
        return this.qu;
    }
    set indicatorAxis(a) {
        let b = this.indicatorAxis;
        if (a != b) {
            this.qu = a;
            this.g3("IndicatorAxis", b, this.indicatorAxis);
        }
    }
    get indicatorXAxis() {
        return this.pf;
    }
    set indicatorXAxis(a) {
        let b = this.indicatorXAxis;
        if (a != b) {
            this.pf = a;
            this.g3("IndicatorXAxis", b, this.indicatorXAxis);
        }
    }
    get r8() {
        return this.r5;
    }
    set r8(a) {
        let b = this.r8;
        if (a != b) {
            this.r5 = a;
            this.g3("IndicatorAxes", b, this.r8);
        }
    }
    get sa() {
        return this.r7;
    }
    set sa(a) {
        let b = this.sa;
        if (a != b) {
            this.r7 = a;
            this.g3("IndicatorXAxes", b, this.sa);
        }
    }
    get sg() {
        return this.se;
    }
    set sg(a) {
        let b = this.sg;
        if (+a != +b) {
            this.se = a;
            this.g3("XAxisMinimumValue", b, this.sg);
        }
    }
    get sf() {
        return this.sd;
    }
    set sf(a) {
        let b = this.sf;
        if (+a != +b) {
            this.sd = a;
            this.g3("XAxisMaximumValue", b, this.sf);
        }
    }
    get xAxisBreaks() {
        return this.sb;
    }
}
FinancialChart.$t = markType(FinancialChart, 'FinancialChart', XYChart.$);
FinancialChart.tm = 0;
/**
 * @hidden
 */
class FinancialChartToolbar extends TemplatedHtmlControl {
    constructor(a, b) {
        super("financialChartToolbar", b, "");
        this.o = null;
        this.r = null;
        this.z = null;
        this.p = null;
        this.w = null;
        this.aq = dateMaxValue();
        this.ap = dateMinValue();
        this.ao = dateMaxValue();
        this.an = dateMinValue();
        this.rangeChanged = null;
        this.chartTypeChanged = null;
        this.trendLineTypeChanged = null;
        this.volumeTypeChanged = null;
        this.indicatorTypesChanged = null;
        this.overlayTypesChanged = null;
        this.x = 0;
        this.ah = 0;
        this.ab = 0;
        this.ad = null;
        this.af = null;
        this.t = null;
        this.ak = false;
        this.o = a;
        this.w = new FinancialChartToolbarViewModel();
        this.s = new FinancialChartRangeSelector(a != null ? a.ty : null);
        this.aa = new FinancialChartTypePicker(a != null ? a.tv : null);
        this.q = new FinancialChartIndicatorMenu(1, a != null ? a.tw : null);
    }
    bg(a) {
        let b = a.querySelectorAll(".financialChartToolbarArea");
        if (b != null && b.length > 0) {
            this.g = b[0];
            if (!this.al) {
                this.g.hide();
            }
        }
        let c = a.querySelectorAll(".financialChartIndicatorMenu");
        if (c != null && c.length > 0) {
            this.q.g = c[0];
        }
        let d = a.querySelectorAll(".financialChartRangeSelector");
        if (d != null && d.length > 0) {
            this.s.g = d[0];
        }
        let e = a.querySelectorAll(".financialChartTypePicker");
        if (e != null && e.length > 0) {
            this.aa.g = e[0];
        }
    }
    bl(a) {
        this.q.u(a);
        this.aa.u(a);
    }
    get s() {
        return this.r;
    }
    set s(a) {
        let b = this.s;
        if (a != b) {
            this.r = a;
            this.bm("RangeSelector", b, this.s);
        }
    }
    get aa() {
        return this.z;
    }
    set aa(a) {
        let b = this.aa;
        if (a != b) {
            this.z = a;
            this.bm("ChartTypePicker", b, this.aa);
        }
    }
    get q() {
        return this.p;
    }
    set q(a) {
        let b = this.q;
        if (a != b) {
            this.p = a;
            this.bm("IndicatorMenu", b, this.q);
        }
    }
    bm(a, b, c) {
        switch (a) {
            case "RangeStart":
                if (this.s != null) {
                    this.s.t = this.as;
                }
                break;
            case "RangeEnd":
                if (this.s != null) {
                    this.s.s = this.ar;
                }
                break;
            case "SelectionStart":
                if (this.s != null) {
                    this.s.v = this.au;
                }
                break;
            case "SelectionEnd":
                if (this.s != null) {
                    this.s.u = this.at;
                }
                break;
            case "RangeSelector":
                let d = b;
                if (d != null) {
                    d.rangeChanged = delegateRemove(d.rangeChanged, runOn(this, this.bj));
                }
                if (this.s != null) {
                    this.s.t = this.as;
                    this.s.s = this.ar;
                    this.s.o = this.u;
                    this.s.v = this.au;
                    this.s.u = this.at;
                    let e = this.s;
                    e.rangeChanged = delegateCombine(e.rangeChanged, runOn(this, this.bj));
                }
                break;
            case "ChartTypePicker":
                let f = b;
                if (f != null) {
                    f.selectionChanged = delegateRemove(f.selectionChanged, runOn(this, this.bi));
                }
                if (this.aa != null) {
                    this.aa.w = this.y;
                    let g = this.aa;
                    g.selectionChanged = delegateCombine(g.selectionChanged, runOn(this, this.bi));
                }
                break;
            case "ChartType":
                if (this.aa != null) {
                    this.aa.w = this.y;
                }
                break;
            case "RangeSelectorOptions":
                if (this.s != null) {
                    this.s.o = this.u;
                }
                break;
            case "IsToolbarVisible":
                if (this.g == null) {
                    break;
                }
                if (this.al) {
                    this.g.show();
                }
                else {
                    this.g.hide();
                }
                break;
            case "IndicatorMenu":
                let h = typeCast(FinancialChartIndicatorMenu.$, b);
                if (h != null) {
                    h.selectionChanged = delegateRemove(h.selectionChanged, runOn(this, this.bh));
                }
                if (this.q != null) {
                    let i = this.q;
                    i.selectionChanged = delegateCombine(i.selectionChanged, runOn(this, this.bh));
                }
                break;
            case "IndicatorTypes":
                if (this.indicatorTypesChanged != null) {
                    this.indicatorTypesChanged(this, EventArgs.empty);
                }
                break;
            case "OverlayTypes":
                if (this.overlayTypesChanged != null) {
                    this.overlayTypesChanged(this, EventArgs.empty);
                }
                break;
            case "TrendLineType":
                if (this.trendLineTypeChanged != null) {
                    this.trendLineTypeChanged(this, EventArgs.empty);
                }
                break;
            case "VolumeType":
                if (this.volumeTypeChanged != null) {
                    this.volumeTypeChanged(this, EventArgs.empty);
                }
                break;
        }
    }
    bh(a, b) {
        this.ag = this.q.z;
        this.ae = this.q.y;
        this.ai = this.q.aa;
        this.ac = this.q.x;
    }
    bi(a, b) {
        this.y = this.aa.w;
        if (this.chartTypeChanged != null) {
            this.chartTypeChanged(this, b);
        }
    }
    bj(a, b) {
        this.au = this.s.v;
        this.at = this.s.u;
        if (this.rangeChanged != null) {
            this.rangeChanged(this, b);
        }
    }
    v() {
        let a = new FinancialChartToolbarContext();
        a.container = this.d;
        a.vm = this.w;
        a.vm.financialChartIndicatorMenu = ((() => {
            let $ret = new FinancialChartIndicatorMenuContext();
            $ret.vm = this.q.p;
            return $ret;
        })());
        a.vm.financialChartTypePicker = ((() => {
            let $ret = new FinancialChartTypePickerContext();
            $ret.vm = this.aa.p;
            return $ret;
        })());
        a.vm.financialChartRangeSelector = ((() => {
            let $ret = new FinancialChartRangeSelectorContext();
            $ret.vm = this.s.q;
            return $ret;
        })());
        return a;
    }
    l(a) {
        super.l(a);
        if (a == null) {
            return;
        }
        this.s.l(a);
        this.aa.l(a);
        this.q.l(a);
        this.bk();
    }
    bk() {
    }
    get au() {
        return this.aq;
    }
    set au(a) {
        let b = this.au;
        if (+a != +b) {
            this.aq = a;
            this.bm("SelectionStart", b, this.au);
        }
    }
    get at() {
        return this.ap;
    }
    set at(a) {
        let b = this.at;
        if (+a != +b) {
            this.ap = a;
            this.bm("SelectionEnd", b, this.at);
        }
    }
    get as() {
        return this.ao;
    }
    set as(a) {
        let b = this.as;
        if (+a != +b) {
            this.ao = a;
            this.bm("RangeStart", b, this.as);
        }
    }
    get ar() {
        return this.an;
    }
    set ar(a) {
        let b = this.ar;
        if (+a != +b) {
            this.an = a;
            this.bm("RangeEnd", b, this.ar);
        }
    }
    bn() {
        if (this.s != null) {
            this.s.ab();
        }
    }
    get y() {
        return this.x;
    }
    set y(a) {
        let b = this.y;
        if (a != b) {
            this.x = a;
            this.bm("ChartType", enumGetBox(FinancialChartType_$type, b), enumGetBox(FinancialChartType_$type, this.y));
        }
    }
    get ai() {
        return this.ah;
    }
    set ai(a) {
        let b = this.ai;
        if (a != b) {
            this.ah = a;
            this.bm("TrendLineType", enumGetBox(TrendLineType_$type, b), enumGetBox(TrendLineType_$type, this.ai));
        }
    }
    get ac() {
        return this.ab;
    }
    set ac(a) {
        let b = this.ac;
        if (a != b) {
            this.ab = a;
            this.bm("VolumeType", enumGetBox(FinancialChartVolumeType_$type, b), enumGetBox(FinancialChartVolumeType_$type, this.ac));
        }
    }
    get ae() {
        return this.ad;
    }
    set ae(a) {
        let b = this.ae;
        if (!FinancialChartToolbar.am(b, a)) {
            this.ad = a;
            this.bm("IndicatorTypes", b, this.ae);
        }
    }
    get ag() {
        return this.af;
    }
    set ag(a) {
        let b = this.ag;
        if (!FinancialChartToolbar.am(b, a)) {
            this.af = a;
            this.bm("OverlayTypes", b, this.ag);
        }
    }
    static am(a, b) {
        if (a == b) {
            return true;
        }
        if ((a == null && b != null) || (a != null && b == null)) {
            return false;
        }
        if (a.count != b.count) {
            return false;
        }
        for (let c of fromEn(a)) {
            if (!b.contains(c)) {
                return false;
            }
        }
        return true;
    }
    aj() {
        return ((() => {
            let $ret = new FinancialChartToolbarVisualData();
            $ret.rangeSelector = this.s == null ? null : this.s.r();
            return $ret;
        })());
    }
    get u() {
        return this.t;
    }
    set u(a) {
        let b = this.u;
        if (a != b) {
            this.t = a;
            this.bm("RangeSelectorOptions", b, this.u);
        }
    }
    get al() {
        return this.ak;
    }
    set al(a) {
        let b = this.al;
        if (a != b) {
            this.ak = a;
            this.bm("IsToolbarVisible", b, this.al);
        }
    }
}
FinancialChartToolbar.$t = markType(FinancialChartToolbar, 'FinancialChartToolbar', TemplatedHtmlControl.$);
/**
 * @hidden
 */
class FinancialChartRangeSelector extends TemplatedHtmlControl {
    constructor(a) {
        super("financialChartRangeSelector", a, "");
        this.q = null;
        this.rangeChanged = null;
        this.p = null;
        this.p = new FinancialChartRangeSelectorView();
        this.q = new FinancialChartRangeSelectorViewModel();
        this.q.onRangeChanged = runOn(this, this.z);
        this.p.c = this.q;
    }
    get v() {
        return this.q.selectionStart;
    }
    set v(a) {
        this.q.selectionStart = a;
    }
    get u() {
        return this.q.selectionEnd;
    }
    set u(a) {
        this.q.selectionEnd = a;
    }
    get t() {
        return this.q.rangeStart;
    }
    set t(a) {
        this.q.rangeStart = a;
    }
    get s() {
        return this.q.rangeEnd;
    }
    set s(a) {
        this.q.rangeEnd = a;
    }
    ab() {
        if (this.q.onPropertiesChanged()) {
            this.p.g(this.q);
        }
    }
    l(a) {
        super.l(a);
        this.p.f(this.d, this.q);
    }
    z() {
        if (this.rangeChanged != null) {
            this.rangeChanged(this, EventArgs.empty);
        }
    }
    r() {
        return this.p.d(this.g);
    }
    get o() {
        return this.q.options;
    }
    set o(a) {
        let b = !FinancialChartToolbar.am(this.q.options, a);
        if (b) {
            this.q.options = a;
            this.aa();
        }
    }
    aa() {
        if (this.q != null) {
            this.q.ao();
        }
        if (this.p != null) {
            this.p.i(this.o);
        }
    }
}
FinancialChartRangeSelector.$t = markType(FinancialChartRangeSelector, 'FinancialChartRangeSelector', TemplatedHtmlControl.$);
FinancialChartRangeSelector.x = 0;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgxFinancialChartDefaultTemplatesComponent_1;
let IgxFinancialChartDefaultTemplatesComponent = IgxFinancialChartDefaultTemplatesComponent_1 = class IgxFinancialChartDefaultTemplatesComponent {
    constructor(_changeDetectorRef) {
        this._changeDetectorRef = _changeDetectorRef;
        this.onContentReady = new EventEmitter();
    }
    getSelection(ele) {
        let ret = [];
        for (let i = 0; i < ele.options.length; i++) {
            if (ele.options[i].selected) {
                ret.push(ele.options[i].value);
            }
        }
        return ret;
    }
    static register() {
        TypeRegistrar.registerCons("IgxFinancialChartDefaultTemplatesComponent", IgxFinancialChartDefaultTemplatesComponent_1);
    }
    ngAfterContentInit() {
        this.onContentReady.emit({});
    }
};
__decorate([
    ViewChild("financialChartRangeSelectorTemplate", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartDefaultTemplatesComponent.prototype, "financialChartRangeSelectorTemplate", void 0);
__decorate([
    ViewChild("financialChartTypePickerTemplate", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartDefaultTemplatesComponent.prototype, "financialChartTypePickerTemplate", void 0);
__decorate([
    ViewChild("financialChartIndicatorMenuTemplate", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartDefaultTemplatesComponent.prototype, "financialChartIndicatorMenuTemplate", void 0);
__decorate([
    ViewChild("financialChartToolbarTemplate", { static: true }),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartDefaultTemplatesComponent.prototype, "financialChartToolbarTemplate", void 0);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter)
], IgxFinancialChartDefaultTemplatesComponent.prototype, "onContentReady", void 0);
IgxFinancialChartDefaultTemplatesComponent = IgxFinancialChartDefaultTemplatesComponent_1 = __decorate([
    Component({
        selector: 'igx-financial-chart-default-templates',
        changeDetection: ChangeDetectionStrategy.OnPush,
        template: `
    <ng-template #financialChartRangeSelectorTemplate let-vm="vm">
        <div class='financialChartRangeSelector'>
		    <label class='financialChartRangeSelectorLabel rangeSelectorOneMonth' *ngIf="vm.oneMonthVisible">
		    	<input type='radio' value='1m' [checked]="vm.oneMonthChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneMonth}}</span>
		    </label>
		    <label class='financialChartRangeSelectorLabel rangeSelectorThreeMonths' *ngIf="vm.threeMonthsVisible">
		    	<input type='radio' value='3m' [checked]="vm.threeMonthsChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_ThreeMonths}}</span>
		    </label>
		    <label class='financialChartRangeSelectorLabel rangeSelectorSixMonths' *ngIf="vm.sixMonthsVisible">
		    	<input type='radio' value='6m' [checked]="vm.sixMonthsChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_SixMonths}}</span>
		    </label>
		    <label class='financialChartRangeSelectorLabel rangeSelectorYTD' *ngIf="vm.yearToDateVisible">
		    	<input type='radio' value='YTD' [checked]="vm.yearToDateChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_YearToDate}}</span>
		    </label>
		    <label class='financialChartRangeSelectorLabel rangeSelectorOneYear' *ngIf="vm.oneYearVisible">
		    	<input type='radio' value='1y' [checked]="vm.oneYearChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_OneYear}}</span>
		    </label>
		    <label class='financialChartRangeSelectorLabel rangeSelectorAll' *ngIf="vm.allVisible">
		    	<input type='radio' value='all' [checked]="vm.allChecked" (change)="vm.changeSelection($event.target.value)">
		    	<span class='financialChartRangeSelectorLabelSpan'>{{vm.financialChart_RangeSelector_All}}</span>
		    </label>
	    </div>
    </ng-template>

    <ng-template #financialChartTypePickerTemplate let-vm="vm">
        <button class='financialChartTypePickerDropDownButton' (click)="vm.onButtonPressed()" [attr.data-value]="vm.chartTypeString">
	    	<span class='ui-icon ui-icon-changeable'></span>
	    	<span class='ui-icon-toolbar-dd'></span>
	    </button>

	    <div class='financialChartTypePickerDropDownMenu' [style.display]="vm.isOpen ? 'block' : 'none'"
            (click)="vm.handleDropDownClick($event)">
	    	<ul>
	    		<li class='financialChartListItem' data-value='Auto'>
	    		    <span class='ui-icon ui-icon-chartAuto'></span>
	    		    <span>Auto</span>
	    		</li>
	    		<li class='financialChartListItem' data-value='Bar'>
	    			<span class='ui-icon ui-icon-BarIcon'></span>
	    			<span>Bar</span>
	    		</li>
	    		<li class='financialChartListItem' data-value='Line'>
	    			<span class='ui-icon ui-icon-LineIcon'></span>
	    			<span>Line</span>
	    		</li>
	    		<li class='financialChartListItem' data-value='Candle'>
	    			<span class='ui-icon ui-icon-CandleIcon'></span>
	    			<span>Candle</span>
	    		</li>
	    		<li class='financialChartListItem' data-value='Column'>
	    			<span class='ui-icon ui-icon-ColumnIcon'></span>
	    			<span>Column</span>
	    		</li>
	    	</ul>
	    </div>
    </ng-template>

    <ng-template #financialChartIndicatorMenuTemplate let-vm="vm">
        <button class='financialChartIndicatorMenuDropDownButton' (click)="vm.onButtonPressed()">
	    	<div class='ui-ChartButtonWrapper'>
	    		<span class='ui-icon ui-icon-IndicatorsIcon'></span>
	    		<span class='financialChartIndicatorMenuLabel'>{{vm.financialChart_IndicatorMenu_Header}}</span>
	    		<span class='ui-icon-toolbar-dd'></span>
	    	</div>
        </button>

	    <div class='financialChartIndicatorMenuDropDownMenu' [style.display]="vm.isOpen ? 'block' : 'none'" (click)="vm.handleDropDownClick($event)">
	    	<ul class='financialChartIndicatorMenuDropDownMenuList'>
			<li data-value='FinancialOverlayType'>
				<span>{{vm.financialChart_IndicatorMenu_OverlaysCategoryHeader}}</span>
				<ul>
					<li class='financialChartListItem' data-value='BollingerBands'>{{vm.financialChart_IndicatorsMenu_Overlay_BollingerBands}}</li>
					<li class='financialChartListItem' data-value='PriceChannel'>{{vm.financialChart_IndicatorsMenu_Overlay_PriceChannel}}</li>
				</ul>
			</li>
			<li data-value='TrendLineType'>
				<span>{{vm.financialChart_IndicatorMenu_TrendlinesCategoryHeader}}</span>
				<ul>
					<li class='financialChartListItem' data-value='LinearFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LinearFit}}</li>
					<li class='financialChartListItem' data-value='QuadraticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuadraticFit}}</li>
					<li class='financialChartListItem' data-value='CubicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_CubicFit}}</li>
					<li class='financialChartListItem' data-value='QuarticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuarticFit}}</li>
					<li class='financialChartListItem' data-value='QuinticFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_QuinticFit}}</li>
					<li class='financialChartListItem' data-value='LogarithmicFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_LogarithmicFit}}</li>
					<li class='financialChartListItem' data-value='ExponentialFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialFit}}</li>
					<li class='financialChartListItem' data-value='PowerLawFit'>{{vm.financialChart_IndicatorsMenu_TrendLine_PowerLawFit}}</li>
					<li class='financialChartListItem' data-value='SimpleAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_SimpleAverage}}</li>
					<li class='financialChartListItem' data-value='ExponentialAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ExponentialAverage}}</li>
					<li class='financialChartListItem' data-value='ModifiedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_ModifiedAverage}}</li>
					<li class='financialChartListItem' data-value='CumulativeAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_CumulativeAverage}}</li>
					<li class='financialChartListItem' data-value='WeightedAverage'>{{vm.financialChart_IndicatorsMenu_TrendLine_WeightedAverage}}</li>
				</ul>
			</li>
			<li data-value='FinancialChartVolumeType'><span>{{vm.financialChart_IndicatorMenu_VolumeCategoryHeader}}</span>
				<ul>
					<li class='financialChartListItem' data-value='Column'>{{vm.financialChart_IndicatorsMenu_Volume_Column}}</li>
					<li class='financialChartListItem' data-value='Line'>{{vm.financialChart_IndicatorsMenu_Volume_Line}}</li>
					<li class='financialChartListItem' data-value='Area'>{{vm.financialChart_IndicatorsMenu_Volume_Area}}</li>
				</ul>
			</li>
			<li data-value='FinancialIndicatorType'><span>{{vm.financialChart_IndicatorMenu_IndicatorsCategoryHeader}}</span>
				<ul>
					<li class='financialChartListItem' data-value='AbsoluteVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator}}</li>
					<li class='financialChartListItem' data-value='AccumulationDistribution'>{{vm.financialChart_IndicatorsMenu_Indicator_AccumulationDistribution}}</li>
					<li class='financialChartListItem' data-value='AverageDirectionalIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex}}</li>
					<li class='financialChartListItem' data-value='AverageTrueRange'>{{vm.financialChart_IndicatorsMenu_Indicator_AverageTrueRange}}</li>
					<li class='financialChartListItem' data-value='BollingerBandWidth'>{{vm.financialChart_IndicatorsMenu_Indicator_BollingerBandWidth}}</li>
					<li class='financialChartListItem' data-value='ChaikinOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinOscillator}}</li>
					<li class='financialChartListItem' data-value='ChaikinVolatility'>{{vm.financialChart_IndicatorsMenu_Indicator_ChaikinVolatility}}</li>
					<li class='financialChartListItem' data-value='CommodityChannelIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_CommodityChannelIndex}}</li>
					<li class='financialChartListItem' data-value='DetrendedPriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator}}</li>
					<li class='financialChartListItem' data-value='EaseOfMovement'>{{vm.financialChart_IndicatorsMenu_Indicator_EaseOfMovement}}</li>
					<li class='financialChartListItem' data-value='FastStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FastStochasticOscillator}}</li>
					<li class='financialChartListItem' data-value='ForceIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_ForceIndex}}</li>
					<li class='financialChartListItem' data-value='FullStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_FullStochasticOscillator}}</li>
					<li class='financialChartListItem' data-value='MarketFacilitationIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex}}</li>
					<li class='financialChartListItem' data-value='MassIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MassIndex}}</li>
					<li class='financialChartListItem' data-value='MedianPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_MedianPrice}}</li>
					<li class='financialChartListItem' data-value='MoneyFlowIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_MoneyFlowIndex}}</li>
					<li class='financialChartListItem' data-value='MovingAverageConvergenceDivergence'>{{vm.financialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence}}</li>
					<li class='financialChartListItem' data-value='NegativeVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex}}</li>
					<li class='financialChartListItem' data-value='OnBalanceVolume'>{{vm.financialChart_IndicatorsMenu_Indicator_OnBalanceVolume}}</li>
					<li class='financialChartListItem' data-value='PercentagePriceOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator}}</li>
					<li class='financialChartListItem' data-value='PercentageVolumeOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator}}</li>
					<li class='financialChartListItem' data-value='PositiveVolumeIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex}}</li>
					<li class='financialChartListItem' data-value='PriceVolumeTrend'>{{vm.financialChart_IndicatorsMenu_Indicator_PriceVolumeTrend}}</li>
					<li class='financialChartListItem' data-value='RateOfChangeAndMomentum'>{{vm.financialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum}}</li>
					<li class='financialChartListItem' data-value='RelativeStrengthIndex'>{{vm.financialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex}}</li>
					<li class='financialChartListItem' data-value='SlowStochasticOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator}}</li>
					<li class='financialChartListItem' data-value='StandardDeviation'>{{vm.financialChart_IndicatorsMenu_Indicator_StandardDeviation}}</li>
					<li class='financialChartListItem' data-value='StochRSI'>{{vm.financialChart_IndicatorsMenu_Indicator_StochRSI}}</li>
					<li class='financialChartListItem' data-value='TRIX'>{{vm.financialChart_IndicatorsMenu_Indicator_TRIX}}</li>
					<li class='financialChartListItem' data-value='TypicalPrice'>{{vm.financialChart_IndicatorsMenu_Indicator_TypicalPrice}}</li>
					<li class='financialChartListItem' data-value='UltimateOscillator'>{{vm.financialChart_IndicatorsMenu_Indicator_UltimateOscillator}}</li>
					<li class='financialChartListItem' data-value='WeightedClose'>{{vm.financialChart_IndicatorsMenu_Indicator_WeightedClose}}</li>
					<li class='financialChartListItem' data-value='WilliamsPercentR'>{{vm.financialChart_IndicatorsMenu_Indicator_WilliamsPercentR}}</li>
				</ul>
			</li>
		</ul>
	    </div>
    </ng-template>

    <ng-template #financialChartToolbarTemplate let-vm="vm">
        <ng-template #defaultTemplate>
            <div></div>
        </ng-template>

        <div class='financialChartToolbar'>
            <div class='financialChartToolbar'>
                <div class='financialChartIndicatorMenu' *ngIf='vm.isIndicatorMenuVisible'>
                    <ng-container *ngTemplateOutlet="vm.financialChartIndicatorMenu.template ? vm.financialChartIndicatorMenu.template : defaultTemplate; context: vm.financialChartIndicatorMenu">
                    </ng-container>
                </div>
                <div class='financialChartRangeSelector'>
                    <ng-container *ngTemplateOutlet="vm.financialChartRangeSelector.template ? vm.financialChartRangeSelector.template : defaultTemplate; context: vm.financialChartRangeSelector">
                    </ng-container>
                </div>
                <div class='financialChartTypePicker'>
                    <ng-container *ngTemplateOutlet="vm.financialChartTypePicker.template ? vm.financialChartTypePicker.template : defaultTemplate; context: vm.financialChartTypePicker">
                    </ng-container>
                </div>
            </div>
        </div>
    </ng-template>
  `,
        styles: [`
.ui-financialchart-container {
    font-family: "Segoe UI",Arial,sans-serif;
    font-family: var(--financial-toolbar-font-family, "Segoe UI",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--financial-toolbar-font-size, 12px);
    border-width: 0;
    -webkit-tap-highlight-color: rgba(0,0,0,0);
    -webkit-tap-highlight-color: var(--financial-highlight-color, rgba(0,0,0,0));
}

.ui-financialchart-mainChart {
    margin-left: 15px;
    margin-left: var(--financial-pane-margin-left, 15px);
}

.ui-financialchart-volumeChart {
    margin-left: 15px;
    margin-left: var(--financial-pane-margin-left, 15px);
}

.financialChartMainGrid {
    height: 100%;
    width: 100%;
    display: grid;
    display: -ms-grid;
    -ms-grid-columns: 100%;
}

.financialChartPrice {
    grid-row: 3;
    -ms-grid-row: 3;
    margin-top: 10px;
    margin-top: var(--financial-pane-margin-top, 10px);
}
.financialChartPrice, .financialChartPrice > div {
    min-height: 100px;
}
.financialChartIndicators {
    grid-row: 4;
    -ms-grid-row: 4;
}
.financialChartVolume {
    grid-row: 5;
    -ms-grid-row: 5;
}
.financialChartZoomSlider {
    grid-row: 6;
    -ms-grid-row: 6;
}

/*
/////////////////////
*/
/* Toolbar styles */
/*
/////////////////////
*/

.financialChartToolbar {
    display: grid;
    display: -ms-grid;
    grid-row: 1;
    -ms-grid-rows: 100%;
    -ms-grid-row: 1;
    -ms-grid-columns: 100%;
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--financial-toolbar-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--financial-toolbar-font-size, 12px);
}

/* scrollbar styles */
.financialChartToolbar ::-webkit-scrollbar
{
    width: 14px;
    width: var(--financial-toolbar-scrollbar-width, 14px);
    background-color: #eee;
    background-color: var(--financial-toolbar-scrollbar-background, #eee);
}
.financialChartToolbar ::-webkit-scrollbar-track
{
    border-radius: 1px;
    border-radius: var(--financial-toolbar-scrollbar-track-radius, 1px);
    background-color: #eee;
    background-color: var(--financial-toolbar-scrollbar-track-background, #eee);
    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);
    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-track-shadow-radius, 6px) var(--financial-toolbar-scrollbar-track-shadow-color, rgba(0,0,0,0.3));
}
.financialChartToolbar ::-webkit-scrollbar-thumb
{
    border-radius: 1px;
    border-radius: var(--financial-toolbar-scrollbar-thumb-radius, 1px);
    background-color: #838383;
    background-color: var(--financial-toolbar-scrollbar-thumb-background, #838383);
    -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,.3);
    -webkit-box-shadow: inset 0 0 var(--financial-toolbar-scrollbar-thumb-shadow-radius, 6px) var(--financial-toolbar-scrollbar-thumb-shadow-color, rgba(0,0,0,0.3));
}

.financialChartToolbar .financialChartToolbar {
    display: flex;
    display: -ms-flexbox;
    align-items: center;
    border: 1px solid #dadada;
    border: var(--financial-toolbar-border-thickness, 1px) solid var(--financial-toolbar-border-color, #dadada);
    color: black;
    color: var(--financial-toolbar-text-color, black);
    max-height: 45px;
    max-height: var(--financial-toolbar-max-height, 45px);
    background: #eeeeee;
    background: var(--financial-toolbar-background, #eeeeee);
}

.financialChartToolbar,
.financialChartToolbar button {
    font: 400 13px "Segoe UI", Arial, sans-serif!important;
    font: var(--financial-toolbar-range-button-font, 400 13px "Segoe UI", Arial, sans-serif!important);
}

.financialChartRangeSelector {
    display: flex;
    align-items: center;
    justify-content: center;
    text-transform: uppercase;
    height: 100%;
}

.financialChartRangeSelector input {
    display: none;
}

.financialChartRangeSelectorLabel {
    cursor: pointer;
    height: 100%;
}
.financialChartRangeSelectorLabel:hover .financialChartRangeSelectorLabelSpan {
    color: #4897AA;
    color: var(--financial-toolbar-range-button-hover-color, #4897AA);
    background: transparent;
    background: var(--financial-toolbar-range-button-hover-background, transparent);
}

.financialChartRangeSelectorLabel input:checked + span {
    color: #444444;
    color: var(--financial-toolbar-range-button-check-color, #444444);
    background-color: #dadada;
    background-color: var(--financial-toolbar-range-button-check-background, #dadada);
}

.financialChartRangeSelectorLabelSpan {
    height: 100%;
    display: flex;
    justify-content: center;
    align-items: center;
    padding: 10px;
    padding: var(--financial-toolbar-range-button-padding, 10px);
    box-sizing: border-box;
}

.financialChartRangeSelectorLastOption {
    border: none;
    padding-right: 0;
    padding-right: var(--financial-toolbar-range-button-padding-right, 0px);
}

.financialChartIndicatorMenu,
.financialChartTypePicker {
    position: relative;
    display: flex;
    align-items: center;
    justify-content: center;
}

.financialChartTypePicker {
    margin-left: auto;
    height: 100%;
    border-left: 1px solid #dadada;
    border-left: var(--financial-toolbar-border-thickness, 1px) solid
                 var(--financial-toolbar-border-color, #dadada);
}

.financialChartIndicatorMenu {
    height: 100%;
    padding:0 10px;
    border-right: 1px solid #dadada;
    border-right: var(--financial-toolbar-border-thickness, 1px) solid
                  var(--financial-toolbar-border-color, #dadada);
}

.financialChartIndicatorMenuDropDownMenu,
.financialChartTypePickerDropDownMenu {
    background: #fff;
    background: var(--financial-toolbar-dropdown-background-color, #fff);
    color: black;
    color: var(--financial-toolbar-dropdown-text-color, black);
    display: flex;
    flex-direction: column;
    z-index: 1;
    position: absolute;
    top: calc(100% + 1px);
    top: calc(100% + var(--financial-toolbar-dropdown-top-offset, 1px));
    box-shadow: 0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22);
    box-shadow: var(--financial-toolbar-dropdown-shadow,  0 19px 38px rgba(0,0,0,0.30), 0 15px 12px rgba(0,0,0,0.22));
    white-space: nowrap;
    font-family: "Verdana",Arial,sans-serif;
    font-family: var(--financial-toolbar-dropdown-font-family, "Verdana",Arial,sans-serif);
    font-size: 12px;
    font-size: var(--financial-toolbar-dropdown-font-size, 12px);
}

.financialChartIndicatorMenuDropDownMenu {
    left: 0;
    min-width: 100px;
    min-width: var(--financial-toolbar-dropdown-min-width, 100px);
    height: 300px;
    height: var(--financial-toolbar-dropdown-height, 300px);
    overflow: auto;
}

.financialChartTypePickerDropDownMenu {
    right: 0;
}

.financialChartListItem {
    cursor: pointer;
    cursor: var(--financial-toolbar-dropdown-item-cursor, pointer);
}

.financialChartListItem:hover,
.financialChartListItem:focus {
    color: #4897AA;
    color: var(--financial-toolbar-dropdown-item-hover-color, #4897AA);
    background: transparent;
    background: var(--financial-toolbar-dropdown-item-hover-background, transparent);
}

.financialChartListItem span {
    position: relative;
    /* TODO: figure out why we need z-index here */
    z-index: -1;
}

.financialChartTypePickerDropDownMenu .financialChartListItem {
    display: flex;
    align-items: center;
    justify-content: flex-start;
}
.financialChartTypePickerDropDownMenu .ui-icon {
    margin-right: 5px;
    margin-right: var(--financial-toolbar-icon-margin-right, 5px);
}

.financialChartIndicatorMenuDropDownButton,
.financialChartTypePickerDropDownButton {
    background-color: transparent;
    background-color: var(--financial-toolbar-indicators-background-color, transparent);
    border: none;
    outline: none;
    cursor: pointer;
    display: flex;
    justify-content: center;
    align-items: center;
}

.financialChartIndicatorMenuDropDownMenuList {
    font-weight: bold;
}

.financialChartIndicatorMenuDropDownMenu li.checked,
.financialChartTypePickerDropDownMenu li.checked {
    color: #4897AA;
    color: var(--financial-toolbar-dropdown-item-check-color, #4897AA);
    background: transparent;
    background: var(--financial-toolbar-dropdown-item-check-background, transparent);
}

.financialChartIndicatorMenuDropDownMenu ul,
.financialChartTypePickerDropDownMenu ul {
    list-style-type: none;
    margin: 0;
    padding: 8px;
}

.financialChartIndicatorMenuDropDownMenu ul ul,
.financialChartTypePickerDropDownMenu ul ul {
    padding-left: 15px;
    padding-left: var(--financial-toolbar-dropdown-list-padding-left, 15px);
    font-weight: normal;
}

.financialChartIndicatorMenuDropDownMenu ul li,
.financialChartTypePickerDropDownMenu ul li {
    padding-top: 4px;
    padding-top: var(--financial-toolbar-dropdown-list-padding-top, 4px);
    position: relative;
}

.financialChartIndicatorMenuDropDownMenu li.checked:before{
    margin-left: -15px;
    margin-left:  var(--financial-toolbar-dropdown-list-margin-left, -15px);
    margin-right: 5px;
    margin-right: var(--financial-toolbar-dropdown-list-margin-right, 5px);
    content: "\\2713";
    position: absolute;
}

.financialChartLegend {
    grid-row: 2;
    -ms-grid-row: 2;
}

.ui-ChartButtonWrapper {
    display: flex;
    align-items: center;
    justify-content: center;
}

.financialChartTypePickerDropDownButton .ui-icon-triangle-1-s,
.ui-ChartButtonWrapper .ui-icon-triangle-1-s {
    font-size: 10px;
    font-size: var(--financial-toolbar-icon-font-size, 10px);
}

.financialChartTypePickerDropDownButton {
    background-color: transparent;
    background-color: var(--financial-toolbar-chart-picker-background, transparent);
    height: 100%;
    padding: 0 10px;
    padding: var(--financial-toolbar-chart-picker-padding, 0 10px);
}

.financialChartIndicatorMenuLabel {
    margin: 0 5px;
    margin: var(--financial-toolbar-indicators-label-margin, 0 5px);
    color: inherit;
    color: var(--financial-toolbar-indicators-label-normal-color, inherit);
}

/* Icon styles if no theme is included */
.financialChartToolbar .ui-icon {
    color: #888888;
    color: var(--financial-toolbar-icon-color, #888888);
    width: 16px;
    width: var(--financial-toolbar-icon-width, 16px);
    height: 16px;
    height: var(--financial-toolbar-icon-height, 16px);
    display: flex;
    justify-content: center;
    align-items: center;
    text-indent: -99999px;
    overflow: hidden;
    position: relative;
}
.financialChartToolbar .ui-icon:before {
    display: block;
    height: 1em;
    left: 50%;
    line-height: 1;
    margin-left: -0.5em;
    margin-top: -0.5em;
    position: absolute;
    text-indent: 0;
    top: 50%;
    width: 1em;
}

.ui-icon-IndicatorsIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-indicators-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%23777777%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartIndicatorMenuDropDownButton:hover .ui-icon-IndicatorsIcon:before,
.financialChartIndicatorMenuDropDownButton:focus .ui-icon-IndicatorsIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-indicators-hover-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2055%2055%27%20fill%3D%27%234897AA%27%3E%3Crect%20x%3D%2746.32%27%20y%3D%2716.34%27%20width%3D%275.97%27%20height%3D%2738.47%27%2F%3E%3Cpolygon%20points%3D%2736.73%2054.8%2042.7%2054.8%2042.7%2020.71%2040.34%2020.71%2036.73%2023.92%2036.73%2054.8%27%2F%3E%3Cpolygon%20points%3D%2727.14%2030.07%2027.14%2054.8%2033.11%2054.8%2033.11%2027.15%2028.46%2031.28%2027.14%2030.07%27%2F%3E%3Cpolygon%20points%3D%2730.74%2020.71%2029.62%2020.71%2030.12%2021.22%2030.74%2020.71%27%2F%3E%3Cpolygon%20points%3D%2717.55%2026.49%2017.55%2054.8%2023.52%2054.8%2023.52%2026.76%2020.26%2023.78%2017.55%2026.49%27%2F%3E%3Cpolygon%20points%3D%277.96%2024.97%207.96%2026.49%209.48%2024.97%207.96%2024.97%27%2F%3E%3Cpolygon%20points%3D%277.96%2054.8%2013.93%2054.8%2013.93%2030.11%207.96%2036.08%207.96%2054.8%27%2F%3E%3Cpolygon%20points%3D%2737.29%200.2%2043.23%206.14%2030.12%2016.96%2021.68%208.51%202.5%2027.69%207.29%2032.48%2020.26%2019.52%2028.46%2027.02%2047.33%2010.23%2052.5%2015.4%2052.5%2014.57%2052.5%200.2%2037.29%200.2%27%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartIndicatorMenuDropDownButton:hover .financialChartIndicatorMenuLabel,
.financialChartIndicatorMenuDropDownButton:focus .financialChartIndicatorMenuLabel {
    color: #4897AA;
    color: var(--financial-toolbar-indicators-label-hover-color, #4897AA);
}

.ui-icon-toolbar-dd {
    position: relative;
    width: 16px;
    width: var(--financial-toolbar-dropdown-icon-width, 16px);
    height: 16px;
    height: var(--financial-toolbar-dropdown-icon-height, 16px);
    display: flex;
    justify-content: center;
    align-items: center;
}

.ui-icon-toolbar-dd:before {
    content: '';
    position: absolute;
    width: 0;
    height: 0;
    border-style: solid;
    border-width: 5px 4px 0 4px;
    border-color: #666 transparent transparent transparent;
    border-color: var(--financial-toolbar-dropdown-icon-normal-color, #666) transparent transparent transparent;
}

.financialChartIndicatorMenuDropDownButton:hover .ui-icon-toolbar-dd:before,
.financialChartIndicatorMenuDropDownButton:focus .ui-icon-toolbar-dd:before,
.financialChartTypePickerDropDownButton:hover .ui-icon-toolbar-dd:before,
.financialChartTypePickerDropDownButton:focus .ui-icon-toolbar-dd:before {
    content: '';
    border-color: #4897AA transparent transparent transparent;
    border-color: var(--financial-toolbar-dropdown-icon-hover-color, #4897AA) transparent transparent transparent;
}

.financialChartListItem[data-value='Auto'] {
    padding-bottom: 5px;
    padding-bottom: var(--financial-toolbar-dropdown-border-bottom-padding, 5px)
    border-bottom: 1px solid #ddd;
    border-bottom: 1px solid var(--financial-toolbar-dropdown-border-bottom-color, #ddd)
    margin-bottom: 3px;
    margin-bottom: var(--financial-toolbar-dropdown-border-bottom-margin, 3px)
}

.financialChartTypePickerDropDownButton[data-value="Auto"] .ui-icon-chartAuto:before,
.financialChartListItem[data-value='Auto'] .ui-icon-changeable:before,
.financialChartListItem[data-value='Auto'] .ui-icon-chartAuto:before,
.financialChartTypePickerDropDownButton[data-value="Auto"] .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-auto-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartListItem[data-value='Auto']:hover .ui-icon-chartAuto:before,
.financialChartListItem[data-value='Auto']:focus .ui-icon-chartAuto:before,
.financialChartTypePickerDropDownButton[data-value='Auto']:hover .ui-icon-changeable:before,
.financialChartTypePickerDropDownButton[data-value='Auto']:focus .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-auto-hover-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartListItem[data-value='Bar'] .ui-icon-BarIcon:before,
.financialChartTypePickerDropDownButton[data-value="Bar"] .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-bar-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartTypePickerDropDownButton[data-value='Bar']:hover .ui-icon-changeable:before,
.financialChartTypePickerDropDownButton[data-value='Bar']:focus .ui-icon-changeable:before,
.financialChartListItem[data-value="Bar"]:hover .ui-icon-BarIcon:before,
.financialChartListItem[data-value="Bar"]:focus .ui-icon-BarIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-bar-hover-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%203%202%20L%203%204%20L%203%206%20L%203%207%20L%200%207%20L%200%209%20L%203%209%20L%203%2012%20L%205%2012%20L%205%209%20L%205%207%20L%205%206%20L%208%206%20L%208%204%20L%205%204%20L%205%202%20L%203%202%20ZM%2010%200%20L%2010%203%20L%2010%205%20L%2010%2010%20L%207%2010%20L%207%2012%20L%2010%2012%20L%2010%2015%20L%2012%2015%20L%2012%2012%20L%2012%2010%20L%2012%205%20L%2015%205%20L%2015%203%20L%2012%203%20L%2012%200%20L%2010%200%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartListItem[data-value='Line'] .ui-icon-LineIcon:before,
.financialChartTypePickerDropDownButton[data-value="Line"] .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-line-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartTypePickerDropDownButton[data-value='Line']:hover .ui-icon-changeable:before,
.financialChartTypePickerDropDownButton[data-value='Line']:focus .ui-icon-changeable:before,
.financialChartListItem[data-value="Line"]:hover .ui-icon-LineIcon:before,
.financialChartListItem[data-value="Line"]:focus .ui-icon-LineIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-line-hover-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2011.3333%20L%201.6842%2013%20L%206.5%208.8125%20L%209.5313%2011.3438%20L%2016%205.5%20L%2014%203.5%20L%209.5313%208.1875%20L%206.5%205.625%20L%200%2011.3333%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartListItem[data-value='Candle'] .ui-icon-CandleIcon:before,
.financialChartTypePickerDropDownButton[data-value="Candle"] .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-candle-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartTypePickerDropDownButton[data-value='Candle']:hover .ui-icon-changeable:before,
.financialChartTypePickerDropDownButton[data-value='Candle']:focus .ui-icon-changeable:before,
.financialChartListItem[data-value="Candle"]:hover .ui-icon-CandleIcon:before,
.financialChartListItem[data-value="Candle"]:focus .ui-icon-CandleIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-candle-hover-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%20%3E%3Cpath%20d%3D%27M%208%203%20L%208%2013%20L%2010%2013%20L%2010%2016%20L%2012%2016%20L%2012%2013%20L%2014%2013%20L%2014%203%20L%2012%203%20L%2012%200%20L%2010%200%20L%2010%203%20L%208%203%20ZM%200%205%20L%200%2012%20L%202%2012%20L%202%2015%20L%204%2015%20L%204%2012%20L%206%2012%20L%206%205%20L%204%205%20L%204%202%20L%202%202%20L%202%205%20L%200%205%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E")
    );
}

.financialChartListItem[data-value='Column'] .ui-icon-ColumnIcon:before,
.financialChartTypePickerDropDownButton[data-value="Column"] .ui-icon-changeable:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-column-normal-icon,
             url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%23777777%27%20%2F%3E%3C%2Fsvg%3E");
    );
}

.financialChartTypePickerDropDownButton[data-value='Column']:hover .ui-icon-changeable:before,
.financialChartTypePickerDropDownButton[data-value='Column']:focus .ui-icon-changeable:before,
.financialChartListItem[data-value="Column"]:hover .ui-icon-ColumnIcon:before,
.financialChartListItem[data-value="Column"]:focus .ui-icon-ColumnIcon:before {
    content: url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E");
    content: var(--financial-toolbar-chart-column-hover-icon,
        url("data:image/svg+xml,%3Csvg%20xmlns%3D%27http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%27%20viewBox%3D%270%200%2016%2016%27%3E%3Cpath%20d%3D%27M%200%2016%20L%203%2016%20L%203%2011%20L%200%2011%20L%200%2016%20ZM%2011%2016%20L%2011%202%20L%208%202%20L%208%2016%20L%2011%2016%20ZM%2015%2016%20L%2015%204%20L%2012%204%20L%2012%2016%20L%2015%2016%20ZM%207%2016%20L%207%206%20L%204%206%20L%204%2016%20L%207%2016%20Z%27%20fill%3D%27%234897AA%27%20%2F%3E%3C%2Fsvg%3E")
    );
}
`]
    }),
    __metadata("design:paramtypes", [ChangeDetectorRef])
], IgxFinancialChartDefaultTemplatesComponent);

class IgxFinancialIndicatorTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(FinancialIndicatorType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(FinancialIndicatorType_$type, FinancialIndicatorType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

class IgxFinancialOverlayTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(FinancialOverlayType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(FinancialOverlayType_$type, FinancialOverlayType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

class IgxIndicatorDisplayTypeCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(IndicatorDisplayType_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(IndicatorDisplayType_$type, IndicatorDisplayType_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class IndicatorDisplayTypeCollection extends ObservableCollection$1 {
    constructor() {
        super(IndicatorDisplayType_$type, 0);
    }
}
IndicatorDisplayTypeCollection.$t = markType(IndicatorDisplayTypeCollection, 'IndicatorDisplayTypeCollection', ObservableCollection$1.$.specialize(IndicatorDisplayType_$type));

class IgxFinancialChartRangeSelectorOptionCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _ensureOuter(item) {
        return ensureEnum(FinancialChartRangeSelectorOption_$type, item);
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorOption_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

/**
 * Event arguments for the Financial Chart's custom indicator event.
*/
class IgxFinancialChartCustomIndicatorArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get indicatorInfo() {
        if (!this.i.indicatorInfo) {
            return null;
        }
        if (!this.i.indicatorInfo.externalObject && TypeRegistrar.isRegistered("igx-financial-event-args")) {
            let e = TypeRegistrar.create("igx-financial-event-args");
            e._implementation = this.i.indicatorInfo;
            this.i.indicatorInfo.externalObject = e;
        }
        if (this.i.indicatorInfo.externalObject) {
            return this.i.indicatorInfo.externalObject;
        }
        return null;
    }
    /**
 * The Series in context.
*/
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * An integer representing the position of the associated custom indicator in its host.
    */
    get index() {
        return this.i.index;
    }
    set index(v) {
        this.i.index = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomIndicatorNameCollection extends ObservableCollection$1 {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    super(String_$type, 0);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    super(String_$type, 1, c);
                }
                break;
        }
    }
}
CustomIndicatorNameCollection.$t = markType(CustomIndicatorNameCollection, 'CustomIndicatorNameCollection', ObservableCollection$1.$.specialize(String_$type));

class IgxCustomIndicatorNameCollection extends IgCollection {
    constructor(list) {
        super();
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        let coll = new SyncableObservableCollection$2(String_$type, String_$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext;
        };
        coll.createFrom = (int) => {
            return int;
        };
        return coll;
    }
}

const IgxFinancialChartComponent_PROVIDERS = [];
/**
 * Represents a chart with an ordinal X-axis and a numeric Y-axis.
*
* **Ignite UI for Angular Financial Chart** - [Documentation](https://www.infragistics.com/products/ignite-ui-angular/angular/components/FinancialChart.html)
*
* The Ignite UI Financial Chart is a lightweight, highly performant chart. It can be easily configured to display category data using an extremely simple and intuitive API. It offers multiple ways for the user to visualize data, including several display modes for price and volume, and many financial indicators.
*
* ```html
* <igx-financial-chart [dataSource]="data"
* 					 width="850px" height="600px">
* </igx-financial-chart>
* ```
*/
let IgxFinancialChartComponent = class IgxFinancialChartComponent extends IgxXYChartComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        super();
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this._wrapper = null;
        this._dataSource = null;
        this._defaultTooltips = null;
        this._xAxisBreaks = null;
        this._indicatorTypes = null;
        this._overlayTypes = null;
        this._indicatorDisplayTypes = null;
        this._rangeSelectorOptions = null;
        this._customIndicatorNames = null;
        this._applyCustomIndicators = null;
        this._zoneRunner = (act) => ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(_elRef.element.nativeElement, this.container);
        renderer.setStyle(this.container, "display", "block");
        renderer.setStyle(this.container, "width", "100%");
        renderer.setStyle(this.container, "height", "100%");
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        var chart = this.i;
        this._chart = chart;
        if (chart.xAxis) {
            this.rewrapAxis(chart.xAxis);
        }
        if (chart.yAxis) {
            this.rewrapAxis(chart.yAxis);
        }
        if (chart.volumeAxis) {
            this.rewrapAxis(chart.volumeAxis);
        }
        if (chart.volumeXAxis) {
            this.rewrapAxis(chart.volumeXAxis);
        }
        if (chart.indicatorAxis) {
            this.rewrapAxis(chart.indicatorAxis);
        }
        if (chart.indicatorXAxis) {
            this.rewrapAxis(chart.indicatorXAxis);
        }
        if (chart.zoomSliderAxis) {
            this.rewrapAxis(chart.zoomSliderAxis);
        }
        if (chart.zoomSliderXAxis) {
            this.rewrapAxis(chart.zoomSliderXAxis);
        }
        chart.provideContainer(ren);
        this.bindData();
        chart.notifyResized();
        ren.addSizeWatcher(() => {
            this._checkToolbarSize();
            this._chart.notifyResized();
        });
        // supports angular themes or custom properties set in CSS 
        this._styling(_elRef.element.nativeElement, this);
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._chart.notifyResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._chart.notifyResized();
    }
    get width() {
        return this._width;
    }
    _checkToolbarSize() {
        if (this._toolbarElement) {
            let start = this._toolbarElement.nativeElement;
            if (start.children.length == 1) {
                start = start.children[0];
            }
            let toolbarRoot = start.querySelector(".financialChartToolbar");
            let rootRect = toolbarRoot.getBoundingClientRect();
            let hideRemaining = false;
            for (let i = 0; i < toolbarRoot.children.length; i++) {
                let child = toolbarRoot.children[i];
                if (child.nodeType == Node.ELEMENT_NODE) {
                    if (!hideRemaining) {
                        child.style.display = "";
                    }
                    let childRect = child.getBoundingClientRect();
                    if (hideRemaining ||
                        childRect.left + childRect.width >
                            rootRect.left + rootRect.width) {
                        child.style.display = "none";
                        hideRemaining = true;
                    }
                    else {
                        child.style.display = "";
                    }
                }
            }
        }
    }
    ngOnDestroy() {
        this._chart.destroy();
        this._wrapper.destroy();
    }
    onDocumentClick(ev) {
        this._chart.onDocumentClick(ev);
    }
    rewrapAxis(axis) {
        let axisName = axis.$type.name;
        let componentName = "Igx" + axisName + "Component";
        if (TypeRegistrar.isRegistered(componentName)) {
            let x = TypeRegistrar.create(componentName);
            x._implementation = axis;
            axis.externalObject = x;
        }
        else {
            throw new Error("Axis type not loaded: " + componentName);
        }
    }
    createImplementation() {
        return new FinancialChart();
    }
    get i() {
        return this._implementation;
    }
    createSeriesComponent(type) {
        if (TypeRegistrar.isRegistered(type)) {
            let s = TypeRegistrar.create(type);
            s.owner = this;
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    }
    createIndicator(typeName) {
        return this.createSeriesComponent("Igx" + typeName + "Component");
    }
    createOverlay(typeName) {
        return this.createSeriesComponent("Igx" + typeName + "Component");
    }
    createSeries(type) {
        switch (type) {
            case DataSeriesType.Area:
                return this.createSeriesComponent('IgxAreaSeriesComponent');
            case DataSeriesType.Column:
                return this.createSeriesComponent('IgxColumnSeriesComponent');
            case DataSeriesType.Line:
                return this.createSeriesComponent('IgxLineSeriesComponent');
            case DataSeriesType.FinancialPrice:
                return this.createSeriesComponent('IgxFinancialPriceSeriesComponent');
            case DataSeriesType.ItemToolTipLayer:
                return this.createSeriesComponent('IgxItemToolTipLayerComponent');
            case DataSeriesType.CategoryToolTipLayer:
                return this.createSeriesComponent('IgxCategoryToolTipLayerComponent');
            case DataSeriesType.CrosshairLayer:
                return this.createSeriesComponent('IgxCrosshairLayerComponent');
            case DataSeriesType.FinalValueLayer:
                return this.createSeriesComponent('IgxFinalValueLayerComponent');
            case DataSeriesType.CalloutLayer:
                return this.createSeriesComponent('IgxCalloutLayerComponent');
            default:
                return this.createSeriesComponent('IgxColumnSeriesComponent');
        }
    }
    createXAxis(type) {
        switch (type) {
            case FinancialChartXAxisMode.Ordinal:
                if (TypeRegistrar.isRegistered("IgxOrdinalTimeXAxisComponent")) {
                    return TypeRegistrar.create("IgxOrdinalTimeXAxisComponent");
                }
                else if (TypeRegistrar.isRegistered("IgxTimeXAxisComponent")) {
                    return TypeRegistrar.create("IgxTimeXAxisComponent");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
            case FinancialChartXAxisMode.Time:
                if (TypeRegistrar.isRegistered("IgxTimeXAxisComponent")) {
                    return TypeRegistrar.create("IgxTimeXAxisComponent");
                }
                else if (TypeRegistrar.isRegistered("IgxOrdinalTimeXAxisComponent")) {
                    return TypeRegistrar.create("IgxOrdinalTimeXAxisComponent");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
        }
    }
    createYAxis(type) {
        switch (type) {
            case FinancialChartYAxisMode.Numeric:
                if (TypeRegistrar.isRegistered("IgxNumericYAxisComponent")) {
                    return TypeRegistrar.create("IgxNumericYAxisComponent");
                }
                else if (TypeRegistrar.isRegistered("IgxPercentChangeYAxisComponent")) {
                    return TypeRegistrar.create("IgxPercentChangeYAxisComponent");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
            case FinancialChartYAxisMode.PercentChange:
                if (TypeRegistrar.isRegistered("IgxPercentChangeYAxisComponent")) {
                    return TypeRegistrar.create("IgxPercentChangeYAxisComponent");
                }
                else if (TypeRegistrar.isRegistered("IgxNumericYAxisComponent")) {
                    return TypeRegistrar.create("IgxNumericYAxisComponent");
                }
                else {
                    throw new Error("not valid axes components loaded");
                }
        }
    }
    createTimeAxisBreakCollection() {
        return TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection") ? TypeRegistrar.create("IgxTimeAxisBreakCollection") : null;
    }
    set dataSource(value) {
        this._dataSource = value;
        this.bindData();
    }
    get dataSource() {
        return this._dataSource;
    }
    bindData() {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    }
    ngAfterViewInit() {
        if (TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
            let c = TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
            let cf = this.componentFactoryResolver.resolveComponentFactory(c);
            //let cr = cf.create(this.injector);
            let cr = this._dynamicContent.createComponent(cf);
            this._defaultTooltips = cr;
            cr.instance.onContentReady.subscribe(() => {
                this._onDefaultTooltipsReady(cr);
            });
            this.container.appendChild(cr.location.nativeElement);
        }
        let context = this._chart.getContext();
        let toolbarContext = context.vm.toolbar;
        toolbarContext.vm.financialChartIndicatorMenu.template = this.indicatorMenuTemplate ? this.indicatorMenuTemplate : this._defaultTemplates.financialChartIndicatorMenuTemplate;
        toolbarContext.vm.financialChartIndicatorMenu.vm.notifyChanged = () => { toolbarArea.context = toolbarContext; };
        toolbarContext.vm.financialChartTypePicker.template = this.chartTypePickerTemplate ? this.chartTypePickerTemplate : this._defaultTemplates.financialChartTypePickerTemplate;
        toolbarContext.vm.financialChartTypePicker.vm.notifyChanged = () => { toolbarArea.context = toolbarContext; };
        toolbarContext.vm.financialChartRangeSelector.template = this.rangeSelectorTemplate ? this.rangeSelectorTemplate : this._defaultTemplates.financialChartRangeSelectorTemplate;
        toolbarContext.vm.financialChartRangeSelector.vm.notifyChanged = () => { toolbarArea.context = toolbarContext; };
        toolbarContext.template = this.toolbarTemplate ? this.toolbarTemplate : this._defaultTemplates.financialChartToolbarTemplate;
        let toolContainer = toolbarContext.container.rootWrapper.getNativeElement();
        let toolbarArea = this._templates.toArray()[0];
        let mainArea = this._templates.toArray()[1];
        toolbarArea.context = toolbarContext;
        toolbarArea.template = toolbarContext.template;
        let ele = this._toolbarElement.nativeElement;
        ele.style.width = "100%";
        ele.style.height = "100%";
        if (ele.parentElement != null) {
            ele.parentElement.removeChild(ele);
        }
        toolContainer.appendChild(ele);
        this.renderer.setStyle(ele, "display", "");
        let legendContainer = context.legendContainer.rootWrapper.getNativeElement();
        let mainContainer = context.container.rootWrapper.getNativeElement();
        let indicatorContainer = context.indicatorsContainer.rootWrapper.getNativeElement();
        let volumeContainer = context.volumeContainer.rootWrapper.getNativeElement();
        let zoomSliderContainer = context.zoomContainer.rootWrapper.getNativeElement();
        var main = mainArea.viewContainer.element.nativeElement;
        let templateMain = main.querySelector(".financialChartPrice");
        let templateToolbar = main.querySelector(".financialChartToolbar");
        let templateLegend = main.querySelector(".financialChartLegend");
        let templateIndicator = main.querySelector(".financialChartIndicators");
        let templateVolume = main.querySelector(".financialChartVolume");
        let templateZoomSlider = main.querySelector(".financialChartZoomSlider");
        let grid = main.querySelector(".financialChartMainGrid");
        let gridWrapper = new AngularWrapper(grid, this.renderer, this.ngZone);
        templateMain.appendChild(mainContainer);
        templateToolbar.appendChild(toolContainer);
        templateLegend.appendChild(legendContainer);
        templateIndicator.appendChild(indicatorContainer);
        templateVolume.appendChild(volumeContainer);
        templateZoomSlider.appendChild(zoomSliderContainer);
        this._mainElement.nativeElement.parentElement.removeChild(this._mainElement.nativeElement);
        this.container.appendChild(this._mainElement.nativeElement);
        this._chart.provideGrid(gridWrapper);
        this._checkToolbarSize();
    }
    _createZoomSlider(hostEle, onReady) {
        if (!TypeRegistrar.isRegistered("IgxZoomSliderComponent")) {
            //shouldn't happen.
            throw new Error("zoom slider component isn't loaded");
        }
        let t = TypeRegistrar.get("IgxZoomSliderComponent");
        let cf = this.componentFactoryResolver.resolveComponentFactory(t);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        ele.style.width = "100%";
        ele.style.height = "100%";
        cr.instance.width = "100%";
        cr.instance.height = "100%";
        if (ele.parentElement !== null) {
            ele.parentElement.removeChild(ele);
        }
        hostEle.appendChild(ele);
        onReady(cr.instance);
    }
    createTooltip() {
        if (!TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
            return null;
        }
        let t = TypeRegistrar.get("IgxTooltipContainerComponent");
        let cf = this.componentFactoryResolver.resolveComponentFactory(t);
        //let cr = cf.create(this.injector);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        let self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                let ext = new IgxDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self.container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self.container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            cr.instance.context = c;
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    }
    _ensureTooltipCreated(series) {
        series._ensureTooltipCreated(() => this.createTooltip(), (ele) => {
            let wrapper = new AngularWrapper(ele, this.renderer, this.ngZone);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        });
    }
    // private _createXAxis(): any {
    //     let x = new IgxCategoryXAxisComponent();
    //     return x.i;
    // }
    // private _createYAxis(): any {
    //     let y = new IgxNumericYAxisComponent();
    //     return y.i;
    // }
    _ensureDefaultTooltip(series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](series);
    }
    _onDefaultTooltipsReady(cr) {
        if (this.i.dataChart) {
            var currSeries = this.i.dataChart.series;
            for (var i = 0; i < currSeries.count; i++) {
                if (currSeries.item(i).externalObject.showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries.item(i).externalObject);
                }
            }
        }
    }
    onImplementationCreated() {
        super.onImplementationCreated();
    }
    /**
     * TimeAxisBreaks to apply to this chart when in time axis mode, representing spans of time to omit, such as weekends.
    */
    get xAxisBreaks() {
        if (this._xAxisBreaks === null) {
            if (!TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection")) {
                return null;
            }
            let coll = TypeRegistrar.create("IgxTimeAxisBreakCollection");
            let innerColl = this.i.xAxisBreaks;
            if (!innerColl) {
                innerColl = TypeRegistrar.create("TimeAxisBreakCollection");
            }
            this._xAxisBreaks = coll._fromInner(innerColl);
        }
        return this._xAxisBreaks;
    }
    set xAxisBreaks(v) {
        if (this._xAxisBreaks !== null) {
            this._xAxisBreaks._setSyncTarget(null);
            this._xAxisBreaks = null;
        }
        if (!TypeRegistrar.isRegistered("IgxTimeAxisBreakCollection")) {
            return;
        }
        let coll = TypeRegistrar.create("IgxTimeAxisBreakCollection");
        let t = TypeRegistrar.get("TimeAxisBreak");
        this._xAxisBreaks = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(t.$type);
        let innerColl = this.i.xAxisBreaks;
        if (!innerColl) {
            innerColl = TypeRegistrar.create("TimeAxisBreakCollection");
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._xAxisBreaks._setSyncTarget(syncColl);
    }
    get leftMargin() {
        return this.i.cs;
    }
    set leftMargin(v) {
        this.i.cs = +v;
    }
    get isHorizontalZoomEnabled() {
        return this.i.bq;
    }
    set isHorizontalZoomEnabled(v) {
        this.i.bq = ensureBool(v);
    }
    get toolbarHeight() {
        return this.i.sv;
    }
    set toolbarHeight(v) {
        this.i.sv = +v;
    }
    /**
     * Gets or sets whether the Y-axis should use a logarithmic scale instead of a linear one.
     * Since log(-1) is imaginary and log(0) is undefined, it is recommended to enable this property only when the Y-axis minimum is greater than zero.
    */
    get yAxisIsLogarithmic() {
        return this.i.r1;
    }
    set yAxisIsLogarithmic(v) {
        this.i.r1 = ensureBool(v);
    }
    /**
     * Gets or sets the base value to use in the log function when mapping the position of data items along the Y-axis.
     * This property is effective only when YAxisIsLogarithmic is true.
    */
    get yAxisLogarithmBase() {
        return this.i.tn;
    }
    set yAxisLogarithmBase(v) {
        this.i.tn = +v;
    }
    /**
     * Gets or sets the distance between each label and grid line along the Y-axis.
    *
    * The `yAxisInterval` determines how often to show a label, tickmark, and/or gridline along the y-axis.  Set this property to a number less than the numeric range of the y-axis.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     yAxisInterval="10">
    * </igx-financial-chart>
    * ```
    */
    get yAxisInterval() {
        return this.i.sz;
    }
    set yAxisInterval(v) {
        this.i.sz = +v;
    }
    /**
     * Gets or sets the data value corresponding to the minimum value of the Y-axis.
    *
    * The `yAxisMinimumValue` determines starting value of labels, tickmarks, and gridlines on the y-axis.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     yAxisMinimumValue="10">
    * </igx-financial-chart>
    * ```
    */
    get yAxisMinimumValue() {
        return this.i.s1;
    }
    set yAxisMinimumValue(v) {
        this.i.s1 = +v;
    }
    /**
     * Gets or sets the data value corresponding to the maximum value of the Y-axis.
    *
    * The `yAxisMaximumValue` determines ending value of labels, tickmarks, and gridlines on the y-axis.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     yAxisMaximumValue="100">
    * </igx-financial-chart>
    * ```
    */
    get yAxisMaximumValue() {
        return this.i.s0;
    }
    set yAxisMaximumValue(v) {
        this.i.s0 = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines along the Y-axis.
    *
    * The `yAxisMinorInterval` determines how often to show minor gridline along the y-axis.  Set this property to a number less than the `yAxisInterval` and the numeric range of the y-axis.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     yAxisMinorInterval="5">
    * </igx-financial-chart>
    * ```
    */
    get yAxisMinorInterval() {
        return this.i.s2;
    }
    set yAxisMinorInterval(v) {
        this.i.s2 = +v;
    }
    /**
     * Gets the current minimum value for the Y-axis.
    */
    get yAxisActualMinimum() {
        return this.i.sy;
    }
    /**
     * Gets the current maximum value for the Y-axis.
    */
    get yAxisActualMaximum() {
        return this.i.sx;
    }
    /**
     * The type of series to display in the volume pane.
    *
    * Use the `volumeType` property to set a type of all series that will be rendered in the volume pane, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     volumeType="Column">
    * </igx-financial-chart>
    * ```
    */
    get volumeType() {
        return this.i.p5;
    }
    set volumeType(v) {
        this.i.p5 = ensureEnum(FinancialChartVolumeType_$type, v);
    }
    /**
     * The scaling mode of the X-axis.
    *
    * Use the `xAxisMode` property to plot data items without any breaks in data range (Ordinal mode) or with breaks in data range (Time mode) such as weekends/holidays. Note that the Ordinal axis mode is less expensive to use in the financial chart than the Time axis mode.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     xAxisMode="Time">
    * </igx-financial-chart>
    * ```
    */
    get xAxisMode() {
        return this.i.p7;
    }
    set xAxisMode(v) {
        this.i.p7 = ensureEnum(FinancialChartXAxisMode_$type, v);
    }
    /**
     * The scaling mode of the Y-axis.
    *
    * Use the `yAxisMode` property to plot data items using their actual values (Numeric) or using percent changes from the first data point (PercentChange), e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     yAxisMode="PercentChange">
    * </igx-financial-chart>
    * ```
    */
    get yAxisMode() {
        return this.i.p9;
    }
    set yAxisMode(v) {
        this.i.p9 = ensureEnum(FinancialChartYAxisMode_$type, v);
    }
    /**
     * A boolean property controlling the visibility of the toolbar.
    */
    get isToolbarVisible() {
        return this.i.rw;
    }
    set isToolbarVisible(v) {
        this.i.rw = ensureBool(v);
    }
    /**
     * The type of price series to display in the main chart.
    *
    * Use the `chartType` property to set a type of series that will be used to render prices in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     chartType="Candle">
    * </igx-financial-chart>
    * ```
    */
    get chartType() {
        return this.i.p0;
    }
    set chartType(v) {
        this.i.p0 = ensureEnum(FinancialChartType_$type, v);
    }
    /**
     * Gets or sets Horizontal alignment of Y-axis labels.
    */
    get yAxisLabelHorizontalAlignment() {
        return this.i.nw;
    }
    set yAxisLabelHorizontalAlignment(v) {
        this.i.nw = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * A boolean indicating whether the chart should automatically zoom in vertically on the currently visible range of data.
     * When this property is set to true, panning and zooming along the X-axis will result in a corresponding zoom on the Y-axis, so that the visible range of data fills the zoom window as fully as possible.
    */
    get isWindowSyncedToVisibleRange() {
        return this.i.rx;
    }
    set isWindowSyncedToVisibleRange(v) {
        this.i.rx = ensureBool(v);
    }
    /**
     * A collection indicating what financial indicator types to display on the Financial Chart.
    *
    * Use the `indicatorTypes` property to set types of indicators that will be rendered below the price pane in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MoneyFlowIndex, AverageTrueRange">
    * </igx-financial-chart>
    * ```
    */
    get indicatorTypes() {
        if (this._indicatorTypes === null) {
            let coll = new IgxFinancialIndicatorTypeCollection();
            let innerColl = this.i.qe;
            if (!innerColl) {
                innerColl = new FinancialIndicatorTypeCollection(0);
            }
            this._indicatorTypes = coll._fromInner(innerColl);
            this.i.qe = innerColl;
        }
        return this._indicatorTypes;
    }
    set indicatorTypes(v) {
        if (this._indicatorTypes !== null) {
            this._indicatorTypes._setSyncTarget(null);
            this._indicatorTypes = null;
        }
        let coll = new IgxFinancialIndicatorTypeCollection();
        this._indicatorTypes = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(FinancialIndicatorType_$type);
        let innerColl = this.i.qe;
        if (!innerColl) {
            innerColl = new FinancialIndicatorTypeCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._indicatorTypes._setSyncTarget(syncColl);
        this.i.qe = innerColl;
    }
    /**
     * A collection indicating what financial overlay types to display on the Financial Chart.
    *
    * Use the `overlayTypes` property to set types of overlays that will be rendered behind price series in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     overlayTypes="BollingerBands">
    * </igx-financial-chart>
    * ```
    */
    get overlayTypes() {
        if (this._overlayTypes === null) {
            let coll = new IgxFinancialOverlayTypeCollection();
            let innerColl = this.i.qg;
            if (!innerColl) {
                innerColl = new FinancialOverlayTypeCollection(0);
            }
            this._overlayTypes = coll._fromInner(innerColl);
            this.i.qg = innerColl;
        }
        return this._overlayTypes;
    }
    set overlayTypes(v) {
        if (this._overlayTypes !== null) {
            this._overlayTypes._setSyncTarget(null);
            this._overlayTypes = null;
        }
        let coll = new IgxFinancialOverlayTypeCollection();
        this._overlayTypes = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(FinancialOverlayType_$type);
        let innerColl = this.i.qg;
        if (!innerColl) {
            innerColl = new FinancialOverlayTypeCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._overlayTypes._setSyncTarget(syncColl);
        this.i.qg = innerColl;
    }
    /**
     * Gets or sets whether the large numbers on the Y-axis labels are abbreviated.
    */
    get yAxisAbbreviateLargeNumbers() {
        return this.i.r0;
    }
    set yAxisAbbreviateLargeNumbers(v) {
        this.i.r0 = ensureBool(v);
    }
    /**
     * Gets or sets the rendering resolution for all series in this chart.
     * Where n = Resolution, for every n horizontal pixels, combine all items into a single datapoint.  When Resolution = 0, all datapoints will be rendered as graphical objects.  Charts with a higher resolution will have faster performance.
    */
    get resolution() {
        return this.i.cu;
    }
    set resolution(v) {
        this.i.cu = +v;
    }
    /**
     * Gets or sets the location of Y-axis labels, relative to the plot area.
    */
    get yAxisLabelLocation() {
        return this.i.il;
    }
    set yAxisLabelLocation(v) {
        this.i.il = ensureEnum(AxisLabelsLocation_$type, v);
    }
    /**
     * Gets or sets type of series to display in the zoom slider pane.
    *
    * Use the `zoomSliderType` property to set a type of all series that will be rendered in the zoom pane, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     zoomSliderType="Candle">
    * </igx-financial-chart>
    * ```
    */
    get zoomSliderType() {
        return this.i.qc;
    }
    set zoomSliderType(v) {
        this.i.qc = ensureEnum(FinancialChartZoomSliderType_$type, v);
    }
    /**
     * Gets or sets the palette used for coloring negative items of Waterfall chart type.
    *
    * Use the `negativeBrushes` property to set a collection of brushes that will be used to render fill area of negative elements in the price pane, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     negativeBrushes="Red, Orange">
    * </igx-financial-chart>
    * ```
    */
    get negativeBrushes() {
        return fromBrushCollection(this.i.o9);
    }
    set negativeBrushes(v) {
        this.i.o9 = toBrushCollection(v);
    }
    /**
     * Brushes to use for drawing negative elements, when using a chart type with contextual coloring, such as Waterfall.
    *
    * Use the `negativeOutlines` property to set a collection of brushes that will be used to render outline of negative elements in the price pane, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     negativeOutlines="Red, Orange">
    * </igx-financial-chart>
    * ```
    */
    get negativeOutlines() {
        return fromBrushCollection(this.i.pa);
    }
    set negativeOutlines(v) {
        this.i.pa = toBrushCollection(v);
    }
    /**
     * Brushes to use for filling financial overlays.
    *
    * Use the `overlayBrushes` property to set a collection of brushes that will be used to render fill area of overlays in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     overlayTypes="BollingerBands"
    *     overlayBrushes="Green">
    * </igx-financial-chart>
    * ```
    */
    get overlayBrushes() {
        return fromBrushCollection(this.i.pb);
    }
    set overlayBrushes(v) {
        this.i.pb = toBrushCollection(v);
    }
    /**
     * Brushes to use for outlining financial overlays.
    *
    * Use the `overlayOutlines` property to set a collection of brushes that will be used to render outlines of overlays in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     overlayTypes="BollingerBands"
    *     overlayOutlines="Green">
    * </igx-financial-chart>
    * ```
    */
    get overlayOutlines() {
        return fromBrushCollection(this.i.pc);
    }
    set overlayOutlines(v) {
        this.i.pc = toBrushCollection(v);
    }
    /**
     * Brushes to use for outlining volume series in the volume pane.
    *
    * Use the `volumeOutlines` property to set a collection of brushes that will be used to render outline of multiple series in the volume pane of the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     volumeOutlines="Green, Blue">
    * </igx-financial-chart>
    * ```
    */
    get volumeOutlines() {
        return fromBrushCollection(this.i.pe);
    }
    set volumeOutlines(v) {
        this.i.pe = toBrushCollection(v);
    }
    /**
     * Brushes to use for filling volume series in the volume pane.
    *
    * Use the `volumeBrushes` property to set a collection of brushes that will be used to render fill area of multiple series in the volume pane of the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     volumeBrushes="Green, Blue">
    * </igx-financial-chart>
    * ```
    */
    get volumeBrushes() {
        return fromBrushCollection(this.i.pd);
    }
    set volumeBrushes(v) {
        this.i.pd = toBrushCollection(v);
    }
    /**
     * Brushes to use for negative elements in financial indicators.
    *
    * Use the `indicatorNegativeBrushes` property to set a collection of brushes that will be used to render negative elements of indicators in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
    *     indicatorNegativeBrushes="Red, Orange">
    * </igx-financial-chart>
    * ```
    */
    get indicatorNegativeBrushes() {
        return fromBrushCollection(this.i.o8);
    }
    set indicatorNegativeBrushes(v) {
        this.i.o8 = toBrushCollection(v);
    }
    /**
     * Brushes to use for financial indicators.
    *
    * Use the `indicatorBrushes` property to set a collection of brushes that will be used to render positive elements of indicators in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
    *     indicatorBrushes="Green, Blue">
    * </igx-financial-chart>
    * ```
    */
    get indicatorBrushes() {
        return fromBrushCollection(this.i.o7);
    }
    set indicatorBrushes(v) {
        this.i.o7 = toBrushCollection(v);
    }
    /**
     * The outline thickness of volume series in the volume pane.
    *
    * Use the `volumeThickness` property to set a number that will be used to render outline thickness of all series in the volume pane, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     volumeThickness="2.5">
    * </igx-financial-chart>
    * ```
    */
    get volumeThickness() {
        return this.i.sw;
    }
    set volumeThickness(v) {
        this.i.sw = +v;
    }
    /**
     * The outline thickness of financial overlays.
    *
    * Use the `overlayThickness` property to set a number that will be used to render outline thickness of all overlays in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     overlayTypes="BollingerBands"
    *     overlayThickness="2.5">
    * </igx-financial-chart>
    * ```
    */
    get overlayThickness() {
        return this.i.su;
    }
    set overlayThickness(v) {
        this.i.su = +v;
    }
    /**
     * The outline or stroke thickness of financial indicators.
    *
    * Use the `indicatorThickness` property to set a number that will be used to render outline thickness of all indicators in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
    *     indicatorThickness="2.5">
    * </igx-financial-chart>
    * ```
    */
    get indicatorThickness() {
        return this.i.st;
    }
    set indicatorThickness(v) {
        this.i.st = +v;
    }
    /**
     * The display types of financial indicators.
    *
    * Use the `indicatorDisplayTypes` property to set display types that will determine whether render all indicators as area, lines, or columns in the Financial Chart control, e.g.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MoneyFlowIndex, AverageTrueRange"
    *     indicatorDisplayTypes="Line, Line">
    * </igx-financial-chart>
    * ```
    */
    get indicatorDisplayTypes() {
        if (this._indicatorDisplayTypes === null) {
            let coll = new IgxIndicatorDisplayTypeCollection();
            let innerColl = this.i.qq;
            if (!innerColl) {
                innerColl = new IndicatorDisplayTypeCollection();
            }
            this._indicatorDisplayTypes = coll._fromInner(innerColl);
            this.i.qq = innerColl;
        }
        return this._indicatorDisplayTypes;
    }
    set indicatorDisplayTypes(v) {
        if (this._indicatorDisplayTypes !== null) {
            this._indicatorDisplayTypes._setSyncTarget(null);
            this._indicatorDisplayTypes = null;
        }
        let coll = new IgxIndicatorDisplayTypeCollection();
        this._indicatorDisplayTypes = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(IndicatorDisplayType_$type);
        let innerColl = this.i.qq;
        if (!innerColl) {
            innerColl = new IndicatorDisplayTypeCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._indicatorDisplayTypes._setSyncTarget(syncColl);
        this.i.qq = innerColl;
    }
    /**
     * The period of financial indicators, where applicable.
    *
    * The `indicatorPeriod` property applies to only the `BollingerBands` overlay as well as to these indicators types: `AverageDirectionalIndex`, `AverageTrueRange`, `BollingerBandWidth`, `ChaikinVolatility`, `CommodityChannelIndex`, `DetrendedPriceOscillator`, `FastStochasticOscillator`, `ForceIndex`, `FullStochasticOscillator`, `MoneyFlowIndex`, `IgxPriceChannelOverlayComponent`, `RateOfChangeAndMomentum`, `RelativeStrengthIndex`, `SlowStochasticOscillator`, `StandardDeviation`, `StochRSI`, `TRIX`, `WilliamsPercentR`
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="AverageTrueRange"
    *     indicatorPeriod="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorPeriod() {
        return this.i.ti;
    }
    set indicatorPeriod(v) {
        this.i.ti = +v;
    }
    /**
     * The multiplier of financial indicators, where applicable.
    *
    * The `indicatorMultiplier` property applies to only to BollingerBandWidth indicator type.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="BollingerBandWidth"
    *     indicatorMultiplier="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorMultiplier() {
        return this.i.ss;
    }
    set indicatorMultiplier(v) {
        this.i.ss = +v;
    }
    /**
     * The smoothing period of financial indicators, where applicable.
    *
    * The `indicatorSmoothingPeriod` property applies to only to `FullStochasticOscillator` indicator type.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="FullStochasticOscillator"
    *     indicatorSmoothingPeriod="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorSmoothingPeriod() {
        return this.i.tl;
    }
    set indicatorSmoothingPeriod(v) {
        this.i.tl = +v;
    }
    /**
     * The short period of financial indicators, where applicable.
    *
    * The `indicatorShortPeriod` property applies only to these indicator types:
    *
    * -   AbsoluteVolumeOscillator,
    * -   ChaikinOscillator,
    * -   MovingAverageConvergenceDivergence,
    * -   PercentagePriceOscillator,
    * -   PercentageVolumeOscillator,
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="ChaikinOscillator"
    *     indicatorShortPeriod="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorShortPeriod() {
        return this.i.tj;
    }
    set indicatorShortPeriod(v) {
        this.i.tj = +v;
    }
    /**
     * The long period of financial indicators, where applicable.
    *
    * The `indicatorLongPeriod` property applies only to these indicator types:
    *
    * -   AbsoluteVolumeOscillator,
    * -   ChaikinOscillator,
    * -   MovingAverageConvergenceDivergence,
    * -   PercentagePriceOscillator,
    * -   PercentageVolumeOscillator,
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="ChaikinOscillator"
    *     indicatorLongPeriod="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorLongPeriod() {
        return this.i.th;
    }
    set indicatorLongPeriod(v) {
        this.i.th = +v;
    }
    /**
     * The signal period of financial indicators, where applicable.
    *
    * The `indicatorSignalPeriod` property applies to only to MovingAverageConvergenceDivergence indicator type.
    *
    * ```html
    * <igx-financial-chart
    *     [dataSource]="data"
    *     indicatorTypes="MovingAverageConvergenceDivergence"
    *     indicatorSignalPeriod="8">
    * </igx-financial-chart>
    * ```
    */
    get indicatorSignalPeriod() {
        return this.i.tk;
    }
    set indicatorSignalPeriod(v) {
        this.i.tk = +v;
    }
    /**
     * A FinancialChartRangeSelectorOptionCollection containing the available range selector options on the toolbar.
    */
    get rangeSelectorOptions() {
        if (this._rangeSelectorOptions === null) {
            let coll = new IgxFinancialChartRangeSelectorOptionCollection();
            let innerColl = this.i.pw;
            if (!innerColl) {
                innerColl = new FinancialChartRangeSelectorOptionCollection(0);
            }
            this._rangeSelectorOptions = coll._fromInner(innerColl);
            this.i.pw = innerColl;
        }
        return this._rangeSelectorOptions;
    }
    set rangeSelectorOptions(v) {
        if (this._rangeSelectorOptions !== null) {
            this._rangeSelectorOptions._setSyncTarget(null);
            this._rangeSelectorOptions = null;
        }
        let coll = new IgxFinancialChartRangeSelectorOptionCollection();
        this._rangeSelectorOptions = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(FinancialChartRangeSelectorOption_$type);
        let innerColl = this.i.pw;
        if (!innerColl) {
            innerColl = new FinancialChartRangeSelectorOptionCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._rangeSelectorOptions._setSyncTarget(syncColl);
        this.i.pw = innerColl;
    }
    /**
     * The names of custom indicators to add to the chart.
     * When CustomIndicatorNames is set, the ApplyCustomIndicators event will be raised for each custom indicator name.
    */
    get customIndicatorNames() {
        if (this._customIndicatorNames === null) {
            let coll = new IgxCustomIndicatorNameCollection();
            let innerColl = this.i.customIndicatorNames;
            if (!innerColl) {
                innerColl = new CustomIndicatorNameCollection(0);
            }
            this._customIndicatorNames = coll._fromInner(innerColl);
            this.i.customIndicatorNames = innerColl;
        }
        return this._customIndicatorNames;
    }
    set customIndicatorNames(v) {
        if (this._customIndicatorNames !== null) {
            this._customIndicatorNames._setSyncTarget(null);
            this._customIndicatorNames = null;
        }
        let coll = new IgxCustomIndicatorNameCollection();
        this._customIndicatorNames = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(String_$type);
        let innerColl = this.i.customIndicatorNames;
        if (!innerColl) {
            innerColl = new CustomIndicatorNameCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._customIndicatorNames._setSyncTarget(syncColl);
        this.i.customIndicatorNames = innerColl;
    }
    get isVerticalZoomEnabled() {
        return this.i.bw;
    }
    set isVerticalZoomEnabled(v) {
        this.i.bw = ensureBool(v);
    }
    /**
     * Gets or sets stroke brush of major gridlines on x-axis of the zoom slider pane
    */
    get zoomSliderXAxisMajorStroke() {
        return brushToString(this.i.xn);
    }
    set zoomSliderXAxisMajorStroke(v) {
        this.i.xn = stringToBrush(v);
    }
    /**
     * Gets or sets thickness of major gridlines on x-axis of the zoom slider pane
    */
    get zoomSliderXAxisMajorStrokeThickness() {
        return this.i.s3;
    }
    set zoomSliderXAxisMajorStrokeThickness(v) {
        this.i.s3 = +v;
    }
    /**
     * Gets or sets weather or not a legend is visible between toolbar and chart's plot area
    */
    get isLegendVisible() {
        return this.i.rs;
    }
    set isLegendVisible(v) {
        this.i.rs = ensureBool(v);
    }
    /**
     * Gets or sets minimum value on x-axis
    */
    get xAxisMinimumValue() {
        return this.i.sg;
    }
    set xAxisMinimumValue(v) {
        this.i.sg = v;
    }
    /**
     * Gets or sets maximum value on x-axis
    */
    get xAxisMaximumValue() {
        return this.i.sf;
    }
    set xAxisMaximumValue(v) {
        this.i.sf = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.indicatorTypes != null && this.indicatorTypes.findByName && this.indicatorTypes.findByName(name)) {
            return this.indicatorTypes.findByName(name);
        }
        if (this.overlayTypes != null && this.overlayTypes.findByName && this.overlayTypes.findByName(name)) {
            return this.overlayTypes.findByName(name);
        }
        if (this.indicatorDisplayTypes != null && this.indicatorDisplayTypes.findByName && this.indicatorDisplayTypes.findByName(name)) {
            return this.indicatorDisplayTypes.findByName(name);
        }
        if (this.rangeSelectorOptions != null && this.rangeSelectorOptions.findByName && this.rangeSelectorOptions.findByName(name)) {
            return this.rangeSelectorOptions.findByName(name);
        }
        if (this.xAxisBreaks != null && this.xAxisBreaks.findByName && this.xAxisBreaks.findByName(name)) {
            return this.xAxisBreaks.findByName(name);
        }
        return null;
    }
    /**
 * Called by the UI framework to provide a UI container for rendering this control.

* @param container  * The UI container element.
*/
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.gr(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.gs(source_, index, oldItem);
    }
    notifyClearItems(source_) {
        this.i.gq(source_);
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.gu(source_, index, oldItem, newItem);
    }
    /**
     * Returns visuals as a serialized string.
    
    */
    exportSerializedVisualData() {
        let iv = this.i.t7();
        return (iv);
    }
    /**
     * Event raised by the chart when custom indicator data is needed from the application.
     * During series rendering, event will be raised once for each value in the CustomIndicatorNames collection.
    */
    get applyCustomIndicators() {
        if (this._applyCustomIndicators == null) {
            this._applyCustomIndicators = new EventEmitter();
            this.i.applyCustomIndicators = delegateCombine(this.i.applyCustomIndicators, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxFinancialChartCustomIndicatorArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeApplyCustomIndicators) {
                        this.beforeApplyCustomIndicators(this, outerArgs);
                    }
                    this._applyCustomIndicators.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._applyCustomIndicators;
    }
};
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxFinancialChartComponent.prototype, "_dynamicContent", void 0);
__decorate([
    ViewChild(IgxFinancialChartDefaultTemplatesComponent, { static: true }),
    __metadata("design:type", IgxFinancialChartDefaultTemplatesComponent)
], IgxFinancialChartComponent.prototype, "_defaultTemplates", void 0);
__decorate([
    ViewChildren(IgxTemplateContentComponent),
    __metadata("design:type", QueryList)
], IgxFinancialChartComponent.prototype, "_templates", void 0);
__decorate([
    ViewChild('toolbarContent', { read: ElementRef, static: true }),
    __metadata("design:type", ElementRef)
], IgxFinancialChartComponent.prototype, "_toolbarElement", void 0);
__decorate([
    ViewChild('mainContent', { read: ElementRef, static: true }),
    __metadata("design:type", ElementRef)
], IgxFinancialChartComponent.prototype, "_mainElement", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialChartComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialChartComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartComponent.prototype, "rangeSelectorTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartComponent.prototype, "chartTypePickerTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartComponent.prototype, "indicatorMenuTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartComponent.prototype, "toolbarTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef)
], IgxFinancialChartComponent.prototype, "chartTemplate", void 0);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", IgCollection),
    __metadata("design:paramtypes", [IgCollection])
], IgxFinancialChartComponent.prototype, "xAxisBreaks", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "leftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "isHorizontalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "toolbarHeight", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "yAxisIsLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisLogarithmBase", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisMinorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "volumeType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "xAxisMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "isToolbarVisible", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "chartType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisLabelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "isWindowSyncedToVisibleRange", null);
__decorate([
    Input(),
    __metadata("design:type", IgxFinancialIndicatorTypeCollection),
    __metadata("design:paramtypes", [IgxFinancialIndicatorTypeCollection])
], IgxFinancialChartComponent.prototype, "indicatorTypes", null);
__decorate([
    Input(),
    __metadata("design:type", IgxFinancialOverlayTypeCollection),
    __metadata("design:paramtypes", [IgxFinancialOverlayTypeCollection])
], IgxFinancialChartComponent.prototype, "overlayTypes", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "yAxisAbbreviateLargeNumbers", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "resolution", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "yAxisLabelLocation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "zoomSliderType", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "negativeBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "negativeOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "overlayBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "overlayOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "volumeOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "volumeBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "indicatorNegativeBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxFinancialChartComponent.prototype, "indicatorBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "volumeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "overlayThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorThickness", null);
__decorate([
    Input(),
    __metadata("design:type", IgxIndicatorDisplayTypeCollection),
    __metadata("design:paramtypes", [IgxIndicatorDisplayTypeCollection])
], IgxFinancialChartComponent.prototype, "indicatorDisplayTypes", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorMultiplier", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorSmoothingPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorShortPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorLongPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "indicatorSignalPeriod", null);
__decorate([
    Input(),
    __metadata("design:type", IgxFinancialChartRangeSelectorOptionCollection),
    __metadata("design:paramtypes", [IgxFinancialChartRangeSelectorOptionCollection])
], IgxFinancialChartComponent.prototype, "rangeSelectorOptions", null);
__decorate([
    Input(),
    __metadata("design:type", IgxCustomIndicatorNameCollection),
    __metadata("design:paramtypes", [IgxCustomIndicatorNameCollection])
], IgxFinancialChartComponent.prototype, "customIndicatorNames", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "isVerticalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxFinancialChartComponent.prototype, "zoomSliderXAxisMajorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxFinancialChartComponent.prototype, "zoomSliderXAxisMajorStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxFinancialChartComponent.prototype, "isLegendVisible", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxFinancialChartComponent.prototype, "xAxisMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Date),
    __metadata("design:paramtypes", [Date])
], IgxFinancialChartComponent.prototype, "xAxisMaximumValue", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxFinancialChartComponent.prototype, "applyCustomIndicators", null);
IgxFinancialChartComponent = __decorate([
    Component({
        selector: 'igx-financial-chart',
        template: `
    <ng-template #financialChartTemplate>
        <div class='financialChartMainGrid'>
		    <div class='financialChartToolbar'></div>
            <div class='financialChartLegend'></div>
		    <div class='financialChartPrice'></div>
		    <div class='financialChartIndicators'></div>
		    <div class='financialChartVolume'></div>
		    <div class='financialChartZoomSlider'></div>
	    </div>
    </ng-template>

    <ng-container #dynamicContent></ng-container>
    <igx-financial-chart-default-templates #defaultTemplates></igx-financial-chart-default-templates>
    <igx-template-content #toolbarContent style="display: none"></igx-template-content>
	<igx-template-content
		style="width: 100%; height: 100%"
		#mainContent [template]="chartTemplate ? chartTemplate : financialChartTemplate"></igx-template-content>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxFinancialChartComponent_PROVIDERS,
        styles: [`
		:host {
			display: block;
		}
        .financialChartToolbar {
            grid-row: 1;
            -ms-grid-row: 1;
        }
        .financialChartPrice {
            grid-row: 3;
            -ms-grid-row: 3;
        }
        .financialChartPrice, .financialChartPrice > div {
            min-height: 100px;
        }
        .financialChartIndicators {
            grid-row: 4;
            -ms-grid-row: 4;
        }
        .financialChartVolume {
            grid-row: 5;
            -ms-grid-row: 5;
        }
        .financialChartZoomSlider {
            grid-row: 6;
            -ms-grid-row: 6;
        }
		.financialChartMainGrid {
			height: 100%;
			width: 100%;
			display: grid;
			display: -ms-grid;
			-ms-grid-columns: 100%;
		}
        .financialChartLegend {
	        grid-row: 2;
	        -ms-grid-row: 2;
        }
	`],
        host: {
            '(document:click)': 'onDocumentClick($event)',
            class: "ig-financial-chart igx-financial-chart"
        }
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxFinancialChartComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialChartCoreModule = class IgxFinancialChartCoreModule {
    constructor() {
    }
};
IgxFinancialChartCoreModule = __decorate([
    NgModule({
        declarations: [IgxFinancialChartComponent,
            IgxFinancialChartDefaultTemplatesComponent],
        exports: [IgxFinancialChartComponent,
            IgxFinancialChartDefaultTemplatesComponent,
            IgxTemplateContentModule
        ],
        imports: [CommonModule, IgxTemplateContentModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialChartCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialChartCoreDynamicModule = class IgxFinancialChartCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxFinancialChartComponent', IgxFinancialChartComponent);
        TypeRegistrar.registerCons('IgxFinancialChartDefaultTemplatesComponent', IgxFinancialChartDefaultTemplatesComponent);
    }
};
IgxFinancialChartCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxTemplateContentDynamicModule,
            IgxFinancialChartCoreModule
        ],
        imports: [CommonModule, IgxTemplateContentDynamicModule,
            IgxFinancialChartCoreModule
        ],
        entryComponents: [IgxFinancialChartComponent,
            IgxFinancialChartDefaultTemplatesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialChartCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ZoomSliderOrientation;
(function (ZoomSliderOrientation) {
    ZoomSliderOrientation[ZoomSliderOrientation["Horizontal"] = 0] = "Horizontal";
    ZoomSliderOrientation[ZoomSliderOrientation["Vertical"] = 1] = "Vertical";
})(ZoomSliderOrientation || (ZoomSliderOrientation = {}));
/**
 * @hidden
 */
let ZoomSliderOrientation_$type = markEnum('ZoomSliderOrientation', 'Horizontal,0|Vertical,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ZoomSliderResolvingAxisValueEventArgs extends Base {
    constructor() {
        super(...arguments);
        this._position = 0;
        this._value = null;
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get value() {
        return this._value;
    }
    set value(a) {
        this._value = a;
    }
}
ZoomSliderResolvingAxisValueEventArgs.$t = markType(ZoomSliderResolvingAxisValueEventArgs, 'ZoomSliderResolvingAxisValueEventArgs');

class IgxZoomSliderResolvingAxisValueEventArgs {
    createImplementation() {
        return new ZoomSliderResolvingAxisValueEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get position() {
        return this.i.position;
    }
    set position(v) {
        this.i.position = +v;
    }
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackThumbVisual_$type = new Type(null, 'ITrackThumbVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultTrackThumbVisual extends Base {
    constructor() {
        super();
        this._translateX = 0;
        this._translateY = 0;
        this.c = -1;
        this.a = 0;
        this.b = -1;
        this._thumbBox = null;
        this._thumbRidges = null;
        this._allPaths = null;
        this.thumbBox = new Path();
        this.thumbRidges = new Path();
        this.allPaths = new List$1(Path.$, 0);
        this.allPaths.add(this.thumbBox);
        this.allPaths.add(this.thumbRidges);
        this.width = this.getTrackThumbDefaultWidth();
        this.height = this.getTrackThumbDefaultHeight();
        this.thumbBox._stroke = this.getThumbBoxDefaultStroke();
        this.thumbBox.ac = this.getThumbBoxDefaultStrokeThickness();
        this.thumbBox._fill = this.getThumbBoxDefaultBrush();
        this.thumbRidges._stroke = this.getThumbRidgesDefaultStroke();
        this.thumbRidges.ac = 1;
    }
    get translateX() {
        return this._translateX;
    }
    set translateX(a) {
        this._translateX = a;
    }
    get translateY() {
        return this._translateY;
    }
    set translateY(a) {
        this._translateY = a;
    }
    getTrackThumbDefaultWidth() {
        return 10;
    }
    getTrackThumbDefaultHeight() {
        return 22;
    }
    getThumbBoxDefaultStroke() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    }
    getThumbBoxDefaultStrokeThickness() {
        return 1;
    }
    getThumbBoxDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 249, 249, 249);
            return $ret;
        })());
    }
    getThumbRidgesDefaultStroke() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 119, 119, 119);
            return $ret;
        })());
    }
    e() {
        if (this.orientation == 0) {
            let a = new PathGeometry();
            let b = new PathFigure();
            let c = new LineSegment(1);
            b._isClosed = false;
            b._isFilled = false;
            b._startPoint = { $type: Point_$type, x: -1.5, y: -4 };
            c.c = { $type: Point_$type, x: -1.5, y: 4 };
            b._segments.add(c);
            a.c.add(b);
            let d = new PathFigure();
            let e = new LineSegment(1);
            d._isClosed = false;
            d._isFilled = false;
            d._startPoint = { $type: Point_$type, x: 1.5, y: -4 };
            e.c = { $type: Point_$type, x: 1.5, y: 4 };
            d._segments.add(e);
            a.c.add(d);
            this.thumbRidges.ak = a;
        }
        else {
            let f = new PathGeometry();
            let g = new PathFigure();
            let h = new LineSegment(1);
            g._isClosed = false;
            g._isFilled = false;
            g._startPoint = { $type: Point_$type, x: -4, y: -1.5 };
            h.c = { $type: Point_$type, x: 4, y: -1.5 };
            g._segments.add(h);
            f.c.add(g);
            let i = new PathFigure();
            let j = new LineSegment(1);
            i._isClosed = false;
            i._isFilled = false;
            i._startPoint = { $type: Point_$type, x: -4, y: 1.5 };
            j.c = { $type: Point_$type, x: 4, y: 1.5 };
            i._segments.add(j);
            f.c.add(i);
            this.thumbRidges.ak = f;
        }
    }
    d() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.thumbBox.ak = a;
    }
    get width() {
        return this.c;
    }
    set width(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.f();
        }
    }
    f() {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    }
    get orientation() {
        return this.a;
    }
    set orientation(a) {
        let b = this.a;
        this.a = a;
        if (this.a != b) {
            this.f();
        }
    }
    get height() {
        return this.b;
    }
    set height(a) {
        let b = this.b;
        this.b = a;
        if (this.b != b) {
            this.f();
        }
    }
    get thumbBox() {
        return this._thumbBox;
    }
    set thumbBox(a) {
        this._thumbBox = a;
    }
    get thumbRidges() {
        return this._thumbRidges;
    }
    set thumbRidges(a) {
        this._thumbRidges = a;
    }
    get allPaths() {
        return this._allPaths;
    }
    set allPaths(a) {
        this._allPaths = a;
    }
}
DefaultTrackThumbVisual.$t = markType(DefaultTrackThumbVisual, 'DefaultTrackThumbVisual', Base.$, [ITrackThumbVisual_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackRangeVisual_$type = new Type(null, 'ITrackRangeVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultTrackRangeVisual extends Base {
    constructor() {
        super();
        this._translateX = 0;
        this._translateY = 0;
        this.a = 0;
        this.c = -1;
        this.b = -1;
        this._thumbBox = null;
        this._thumbRidges = null;
        this._allPaths = null;
        this.thumbBox = new Path();
        this.thumbRidges = new Path();
        this.allPaths = new List$1(Path.$, 0);
        this.allPaths.add(this.thumbBox);
        this.allPaths.add(this.thumbRidges);
        this.thumbBox._stroke = this.getThumbBoxDefaultStroke();
        this.thumbBox.ac = 1;
        this.thumbBox._fill = this.getThumbBoxDefaultBrush();
        this.thumbRidges._stroke = this.getThumbRidgesDefaultStroke();
        this.thumbRidges.ac = 1;
    }
    getThumbBoxDefaultStroke() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    }
    getThumbBoxDefaultStrokeThickness() {
        return 1;
    }
    getThumbBoxDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 249, 249, 249);
            return $ret;
        })());
    }
    getThumbRidgesDefaultStroke() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 119, 119, 119);
            return $ret;
        })());
    }
    get translateX() {
        return this._translateX;
    }
    set translateX(a) {
        this._translateX = a;
    }
    get translateY() {
        return this._translateY;
    }
    set translateY(a) {
        this._translateY = a;
    }
    e() {
        if (this.orientation == 0) {
            let a = new PathGeometry();
            let b = new PathFigure();
            let c = new LineSegment(1);
            b._isClosed = false;
            b._isFilled = false;
            b._startPoint = { $type: Point_$type, x: -3, y: (this.height / -2) * 0.5 };
            c.c = { $type: Point_$type, x: -3, y: (this.height / 2) * 0.5 };
            b._segments.add(c);
            a.c.add(b);
            let d = new PathFigure();
            let e = new LineSegment(1);
            d._isClosed = false;
            d._isFilled = false;
            d._startPoint = { $type: Point_$type, x: 0, y: (this.height / -2) * 0.5 };
            e.c = { $type: Point_$type, x: 0, y: (this.height / 2) * 0.5 };
            d._segments.add(e);
            a.c.add(d);
            let f = new PathFigure();
            let g = new LineSegment(1);
            f._isClosed = false;
            f._isFilled = false;
            f._startPoint = { $type: Point_$type, x: 3, y: (this.height / -2) * 0.5 };
            g.c = { $type: Point_$type, x: 3, y: (this.height / 2) * 0.5 };
            f._segments.add(g);
            a.c.add(f);
            this.thumbRidges.ak = a;
        }
        else {
            let h = new PathGeometry();
            let i = new PathFigure();
            let j = new LineSegment(1);
            i._isClosed = false;
            i._isFilled = false;
            i._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: -3 };
            j.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: -3 };
            i._segments.add(j);
            h.c.add(i);
            let k = new PathFigure();
            let l = new LineSegment(1);
            k._isClosed = false;
            k._isFilled = false;
            k._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: 0 };
            l.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: 0 };
            k._segments.add(l);
            h.c.add(k);
            let m = new PathFigure();
            let n = new LineSegment(1);
            m._isClosed = false;
            m._isFilled = false;
            i._startPoint = { $type: Point_$type, x: (this.width / -2) * 0.5, y: 3 };
            j.c = { $type: Point_$type, x: (this.width / 2) * 0.5, y: 3 };
            m._segments.add(n);
            h.c.add(m);
            this.thumbRidges.ak = h;
        }
    }
    d() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.thumbBox.ak = a;
    }
    get orientation() {
        return this.a;
    }
    set orientation(a) {
        let b = this.a;
        this.a = a;
        if (this.a != b) {
            this.f();
        }
    }
    get width() {
        return this.c;
    }
    set width(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.f();
        }
    }
    f() {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    }
    get height() {
        return this.b;
    }
    set height(a) {
        let b = this.b;
        this.b = a;
        if (this.b != b) {
            this.f();
        }
    }
    get thumbBox() {
        return this._thumbBox;
    }
    set thumbBox(a) {
        this._thumbBox = a;
    }
    get thumbRidges() {
        return this._thumbRidges;
    }
    set thumbRidges(a) {
        this._thumbRidges = a;
    }
    get allPaths() {
        return this._allPaths;
    }
    set allPaths(a) {
        this._allPaths = a;
    }
}
DefaultTrackRangeVisual.$t = markType(DefaultTrackRangeVisual, 'DefaultTrackRangeVisual', Base.$, [ITrackRangeVisual_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackBarVisual_$type = new Type(null, 'ITrackBarVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultTrackBarVisual extends Base {
    constructor() {
        super();
        this._translateX = 0;
        this._translateY = 0;
        this.b = -1;
        this.a = -1;
        this._barBox = null;
        this._allPaths = null;
        this.barBox = new Path();
        this.allPaths = new List$1(Path.$, 0);
        this.allPaths.add(this.barBox);
        this.barBox._fill = this.getBarBoxDefaultBrush();
    }
    get translateX() {
        return this._translateX;
    }
    set translateX(a) {
        this._translateX = a;
    }
    get translateY() {
        return this._translateY;
    }
    set translateY(a) {
        this._translateY = a;
    }
    getBarBoxDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 218, 218, 218);
            return $ret;
        })());
    }
    getBarBoxDefaultOutline() {
        return null;
    }
    getBarBoxDefaultStrokeThickness() {
        return 0;
    }
    c() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.barBox.ak = a;
    }
    get width() {
        return this.b;
    }
    set width(a) {
        let b = this.b;
        this.b = a;
        if (b != this.b) {
            this.d();
        }
    }
    d() {
        if (this.width > 0 && this.height > 0) {
            this.c();
        }
    }
    get height() {
        return this.a;
    }
    set height(a) {
        let b = this.a;
        this.a = a;
        if (this.a != b) {
            this.d();
        }
    }
    get barBox() {
        return this._barBox;
    }
    set barBox(a) {
        this._barBox = a;
    }
    get allPaths() {
        return this._allPaths;
    }
    set allPaths(a) {
        this._allPaths = a;
    }
}
DefaultTrackBarVisual.$t = markType(DefaultTrackBarVisual, 'DefaultTrackBarVisual', Base.$, [ITrackBarVisual_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackShadeVisual_$type = new Type(null, 'ITrackShadeVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultTrackShadeVisual extends Base {
    constructor() {
        super();
        this._translateX = 0;
        this._translateY = 0;
        this.a = 0;
        this.c = -1;
        this.b = -1;
        this._shadeBox = null;
        this._shadeOutline = null;
        this._allPaths = null;
        this.shadeBox = new Path();
        this.shadeOutline = new Path();
        this.allPaths = new List$1(Path.$, 0);
        this.allPaths.add(this.shadeBox);
        this.allPaths.add(this.shadeOutline);
        this.shadeBox._fill = this.getShadeBoxDefaultBrush();
        this.shadeOutline._stroke = this.getShadeOutlineDefaultBrush();
        this.shadeOutline.ac = this.getShadeOutlineDefaultStrokeThickness();
    }
    get translateX() {
        return this._translateX;
    }
    set translateX(a) {
        this._translateX = a;
    }
    get translateY() {
        return this._translateY;
    }
    set translateY(a) {
        this._translateY = a;
    }
    getShadeBoxDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(128, 255, 255, 255);
            return $ret;
        })());
    }
    getShadeOutlineDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    }
    getShadeOutlineDefaultStrokeThickness() {
        return 1;
    }
    d() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
        c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
        c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
        b._segments.add(c);
        a.c.add(b);
        this.shadeBox.ak = a;
    }
    e() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = false;
        b._isFilled = false;
        switch (this.orientation) {
            case 0:
                b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / -2 };
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / 2 });
                break;
            case 1:
                b._startPoint = { $type: Point_$type, x: this.width / -2, y: this.height / 2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / 2, y: this.height / -2 });
                break;
            case 2:
                b._startPoint = { $type: Point_$type, x: this.width / 2, y: this.height / 2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                break;
            case 3:
                b._startPoint = { $type: Point_$type, x: this.width / 2, y: this.height / -2 };
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / -2 });
                c._points.add({ $type: Point_$type, x: this.width / -2, y: this.height / 2 });
                break;
        }
        b._segments.add(c);
        a.c.add(b);
        this.shadeOutline.ak = a;
    }
    get orientation() {
        return this.a;
    }
    set orientation(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.f();
        }
    }
    get width() {
        return this.c;
    }
    set width(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.f();
        }
    }
    f() {
        if (this.width > 0 && this.height > 0) {
            this.d();
            this.e();
        }
    }
    get height() {
        return this.b;
    }
    set height(a) {
        let b = this.b;
        this.b = a;
        if (this.b != b) {
            this.f();
        }
    }
    get shadeBox() {
        return this._shadeBox;
    }
    set shadeBox(a) {
        this._shadeBox = a;
    }
    get shadeOutline() {
        return this._shadeOutline;
    }
    set shadeOutline(a) {
        this._shadeOutline = a;
    }
    get allPaths() {
        return this._allPaths;
    }
    set allPaths(a) {
        this._allPaths = a;
    }
}
DefaultTrackShadeVisual.$t = markType(DefaultTrackShadeVisual, 'DefaultTrackShadeVisual', Base.$, [ITrackShadeVisual_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackThumbCalloutVisual_$type = new Type(null, 'ITrackThumbCalloutVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultTrackThumbCalloutVisual extends Base {
    constructor() {
        super();
        this._translateX = 0;
        this._translateY = 0;
        this._textTranslateX = 0;
        this._textTranslateY = 0;
        this.c = -1;
        this.b = -1;
        this.a = false;
        this._calloutBox = null;
        this._calloutText = null;
        this._allPaths = null;
        this.calloutBox = new Path();
        this.calloutBox._visibility = 1;
        this.calloutText = new TextBlock();
        this.calloutText._visibility = 1;
        this.allPaths = new List$1(Path.$, 0);
        this.allPaths.add(this.calloutBox);
        this.height = 22;
        this.width = 10;
        this.calloutBox._stroke = this.getCalloutBoxDefaultStroke();
        this.calloutBox.ac = this.getCalloutBoxDefaultStrokeThickness();
        this.calloutBox._fill = this.getCalloutBoxDefaultBrush();
        this.calloutText.am = this.getCalloutTextDefaultBrush();
        this.calloutText.ak = "";
    }
    get translateX() {
        return this._translateX;
    }
    set translateX(a) {
        this._translateX = a;
    }
    get translateY() {
        return this._translateY;
    }
    set translateY(a) {
        this._translateY = a;
    }
    get textTranslateX() {
        return this._textTranslateX;
    }
    set textTranslateX(a) {
        this._textTranslateX = a;
    }
    get textTranslateY() {
        return this._textTranslateY;
    }
    set textTranslateY(a) {
        this._textTranslateY = a;
    }
    getCalloutBoxDefaultStroke() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    }
    getCalloutBoxDefaultStrokeThickness() {
        return 1;
    }
    getCalloutBoxDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(200, 255, 255, 255);
            return $ret;
        })());
    }
    getCalloutTextDefaultBrush() {
        return ((() => {
            let $ret = new Brush();
            $ret.color = Color.u(255, 185, 185, 185);
            return $ret;
        })());
    }
    e() {
    }
    d() {
        let a = new PathGeometry();
        let b = new PathFigure();
        let c = new PolyLineSegment();
        b._isClosed = true;
        b._isFilled = true;
        b._startPoint = { $type: Point_$type, x: 0, y: 0 };
        c._points.add({ $type: Point_$type, x: this.width, y: 0 });
        c._points.add({ $type: Point_$type, x: this.width, y: this.height });
        c._points.add({ $type: Point_$type, x: 0, y: this.height });
        b._segments.add(c);
        a.c.add(b);
        this.calloutBox.ak = a;
    }
    get width() {
        return this.c;
    }
    set width(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.f();
        }
    }
    f() {
        if (this.width > 0 && this.height > 0) {
            this.e();
            this.d();
        }
    }
    get height() {
        return this.b;
    }
    set height(a) {
        let b = this.b;
        this.b = a;
        if (this.b != b) {
            this.f();
        }
    }
    get isVisible() {
        return this.a;
    }
    set isVisible(a) {
        let b = this.a;
        this.a = a;
        if (this.a != b) {
            this.calloutBox._visibility = this.a ? 0 : 1;
            this.calloutText._visibility = this.a ? 0 : 1;
        }
    }
    get calloutBox() {
        return this._calloutBox;
    }
    set calloutBox(a) {
        this._calloutBox = a;
    }
    get calloutText() {
        return this._calloutText;
    }
    set calloutText(a) {
        this._calloutText = a;
    }
    get allPaths() {
        return this._allPaths;
    }
    set allPaths(a) {
        this._allPaths = a;
    }
}
DefaultTrackThumbCalloutVisual.$t = markType(DefaultTrackThumbCalloutVisual, 'DefaultTrackThumbCalloutVisual', Base.$, [ITrackThumbCalloutVisual_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITrackOwner_$type = new Type(null, 'ITrackOwner');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var ThumbRangePosition;
(function (ThumbRangePosition) {
    ThumbRangePosition[ThumbRangePosition["PinnedLower"] = 0] = "PinnedLower";
    ThumbRangePosition[ThumbRangePosition["PinnedHigher"] = 1] = "PinnedHigher";
})(ThumbRangePosition || (ThumbRangePosition = {}));
/**
 * @hidden
 */
let ThumbRangePosition_$type = markEnum('ThumbRangePosition', 'PinnedLower,0|PinnedHigher,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrackThumbRange extends Base {
    constructor() {
        super(...arguments);
        this.i = 0;
        this.j = 0;
        this.h = 0;
        this.g = 1;
        this.d = null;
        this.c = null;
        this.a = null;
        this.propertyChanged = null;
    }
    t(a, b, c) {
        this.u(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    u(a, b, c) {
        this.s();
    }
    s() {
        if (this.b == null) {
            return;
        }
        this.b.trackDirty();
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.t("Owner", b, this.a);
        }
    }
    get n() {
        return this.i;
    }
    set n(a) {
        let b = this.i;
        this.i = a;
        if (b != this.i) {
            this.t("Position", b, this.i);
        }
    }
    o(a) {
        if (a > 0 && this.n + (this.r / 2) + a > 1) {
            a = 1 - (this.n + (this.r / 2));
        }
        if (a < 0 && (this.n - (this.r / 2)) + a < 0) {
            a = (this.n - (this.r / 2)) * -1;
        }
        this.f.i += a;
        this.e.i += a;
        this.n += a;
        return a;
    }
    p(a) {
        a = this.k(a);
        let b = this.n - this.r / 2;
        this.r += a;
        this.n = b + this.r / 2;
        return a;
    }
    k(a) {
        if (a < 0) {
            let b = this.r + a;
            if (b < this.m) {
                b = this.m;
                a = (b - this.r);
            }
        }
        if (a > 0) {
            let c = this.r + a;
            if (c > this.l) {
                c = this.l;
                a = (c - this.r);
            }
        }
        return a;
    }
    q(a) {
        a = -1 * this.k(a * -1);
        let b = this.n + this.r / 2;
        this.r -= a;
        this.n = b - this.r / 2;
        return a;
    }
    get r() {
        return this.j;
    }
    set r(a) {
        let b = this.j;
        this.j = a;
        if (b != this.j) {
            this.t("Width", b, this.j);
        }
    }
    get m() {
        return this.h;
    }
    set m(a) {
        let b = this.h;
        this.h = a;
        if (b != this.h) {
            this.t("MinWidth", b, this.h);
        }
    }
    get l() {
        return this.g;
    }
    set l(a) {
        let b = this.g;
        this.g = a;
        if (b != this.g) {
            this.t("MaxWidth", b, this.g);
        }
    }
    get f() {
        return this.d;
    }
    set f(a) {
        let b = this.d;
        this.d = a;
        if (b != this.d) {
            this.t("LowerThumb", b, this.d);
        }
    }
    get e() {
        return this.c;
    }
    set e(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.t("HigherThumb", b, this.c);
        }
    }
}
TrackThumbRange.$t = markType(TrackThumbRange, 'TrackThumbRange', Base.$, [INotifyPropertyChanged_$type]);
/**
 * @hidden
 */
class TrackThumb extends Base {
    constructor() {
        super(...arguments);
        this.g = 0;
        this.h = 0;
        this.c = 1;
        this.e = null;
        this.a = null;
        this.propertyChanged = null;
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.m("Owner", b, this.a);
        }
    }
    m(a, b, c) {
        this.n(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    n(a, b, c) {
        this.l();
    }
    j(a) {
        if (this.i + a > 1) {
            a = 1 - this.i;
        }
        if (this.i + a < 0) {
            a = -this.i;
        }
        if (this.f != null) {
            if (this.d == 0) {
                a = this.f.q(a);
            }
            else {
                a = this.f.p(a);
            }
        }
        this.i += a;
        return a;
    }
    l() {
        if (this.b == null) {
            return;
        }
        this.b.trackDirty();
    }
    get i() {
        return this.g;
    }
    set i(a) {
        let b = this.g;
        this.g = a;
        if (b != this.g) {
            this.m("Position", b, this.g);
        }
    }
    get k() {
        return this.h;
    }
    set k(a) {
        let b = this.h;
        this.h = a;
        if (b != this.h) {
            this.m("Width", b, this.h);
        }
    }
    get d() {
        return this.c;
    }
    set d(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.m("RangePosition", enumGetBox(ThumbRangePosition_$type, b), enumGetBox(ThumbRangePosition_$type, this.c));
        }
    }
    get f() {
        return this.e;
    }
    set f(a) {
        let b = this.e;
        this.e = a;
        if (b != this.e) {
            this.m("Range", b, this.e);
        }
    }
}
TrackThumb.$t = markType(TrackThumb, 'TrackThumb', Base.$, [INotifyPropertyChanged_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ZoomSliderView extends Base {
    constructor(a) {
        super();
        this.q = false;
        this.i = null;
        this.h = null;
        this.c = null;
        this.b = null;
        this.e = null;
        this.d = null;
        this.g = null;
        this.f = null;
        this.j = null;
        this.u = null;
        this.v = null;
        this.o = null;
        this.t = 0;
        this.r = false;
        this.x = 0;
        this.w = 0;
        this.m = null;
        this.a = null;
        this.l = null;
        this.y = -1;
        this.s = 10;
        this.k = 0;
        this.z = -1;
        this.p = true;
        this.j = a;
        this.i = new DefaultTrackThumbVisual();
        this.h = new DefaultTrackThumbVisual();
        this.c = new DefaultTrackRangeVisual();
        this.b = new DefaultTrackBarVisual();
        this.e = new DefaultTrackShadeVisual();
        this.d = new DefaultTrackShadeVisual();
        this.g = new DefaultTrackThumbCalloutVisual();
        this.f = new DefaultTrackThumbCalloutVisual();
        this.m = this.n();
        this.an();
    }
    ar() {
        this.p = true;
        this.an();
        if (this.a != null) {
            this.a.aq(this.u.rootWrapper, "");
        }
        if (this.z == -1) {
            this.z = this.u.setTimeout(runOn(this, this.al), 200);
        }
    }
    as() {
        this.p = false;
        if (this.a != null) {
            this.a.bc(this.u.rootWrapper, "");
        }
        if (this.z != -1) {
            window.clearTimeout(this.z);
            this.z = -1;
        }
    }
    ao() {
        if (!this.q) {
            if (this.u != null) {
                this.q = true;
                this.u.setTimeout(runOn(this, this.a2), 0);
            }
        }
    }
    aj() {
        this.a2();
    }
    a2() {
        if (!this.q) {
            return;
        }
        this.q = false;
        this.j.d6();
        this.aw();
    }
    aw() {
        if (this.o == null) {
            return;
        }
        let a = this.j.fj.width;
        let b = this.j.fj.height;
        let c = Math.round(a * this.t);
        let d = Math.round(b * this.t);
        if (this.x != c || this.w != d) {
            this.v.setAttribute("width", c.toString());
            this.v.setAttribute("height", d.toString());
            this.v.setStyleProperty("width", a.toString() + "px");
            this.v.setStyleProperty("height", b.toString() + "px");
            this.x = truncate(Math.round(c));
            this.w = truncate(Math.round(d));
        }
        if (this.o.d && this.t != 1) {
            this.o.z();
            this.o.aa(this.t, this.t);
        }
        this.o.k(this.j.fj.left, this.j.fj.top, this.j.fj.width, this.j.fj.height);
        this.a0(this.i.allPaths, this.i.translateX, this.i.translateY);
        this.a0(this.h.allPaths, this.h.translateX, this.h.translateY);
        this.a0(this.c.allPaths, this.c.translateX, this.c.translateY);
        this.a0(this.b.allPaths, this.b.translateX, this.b.translateY);
        this.a0(this.e.allPaths, this.e.translateX, this.e.translateY);
        this.a0(this.d.allPaths, this.d.translateX, this.d.translateY);
        this.a0(this.g.allPaths, this.g.translateX, this.g.translateY);
        this.a0(this.f.allPaths, this.f.translateX, this.f.translateY);
        this.a1(this.g.calloutText, this.g.textTranslateX, this.g.textTranslateY);
        this.a1(this.f.calloutText, this.f.textTranslateX, this.f.textTranslateY);
        this.ax(this.b.allPaths);
        this.ax(this.c.allPaths);
        this.ax(this.e.allPaths);
        this.ax(this.d.allPaths);
        this.ax(this.i.allPaths);
        this.ax(this.h.allPaths);
        this.ax(this.g.allPaths);
        this.ax(this.f.allPaths);
        this.ay(this.g.calloutText);
        this.ay(this.f.calloutText);
        if (this.o.d && this.t != 1) {
            this.o.y();
        }
    }
    ay(a) {
        if (a.j != null) {
            this.o.z();
        }
        this.o.j(a.j);
        this.o.w(a);
        if (a.j != null) {
            this.o.y();
        }
    }
    ax(a) {
        for (let b = 0; b < a.count; b++) {
            let c = a.item(b);
            if (c.j != null) {
                this.o.z();
            }
            this.o.j(c.j);
            this.o.s(c);
            if (c.j != null) {
                this.o.y();
            }
        }
    }
    a1(a, b, c) {
        if (a.j == null) {
            a.j = new TranslateTransform();
        }
        let d = a.j;
        d.j = b;
        d.k = c;
    }
    a0(a, b, c) {
        for (let d = 0; d < a.count; d++) {
            let e = a.item(d);
            if (e.j == null) {
                e.j = new TranslateTransform();
            }
            let f = e.j;
            f.j = b;
            f.k = c;
        }
    }
    an() {
        let a = this.j.bi;
        let b = this.j.a4;
        if (!isNaN_(a) && a != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != b) {
            this.j.a4 = window.devicePixelRatio;
        }
    }
    au(a) {
        if (a == null) {
            let b = this.u;
            this.v = null;
            this.u = null;
            this.o = null;
            this.ab();
            if (this.z != -1) {
                if (b != null) {
                    b.clearTimeout(this.z);
                }
                else {
                    window.clearTimeout(this.z);
                }
                this.z = -1;
            }
            return;
        }
        this.t = (isNaN_(this.j.bi) ? this.j.a4 : this.j.bi);
        let c = a;
        this.u = c;
        this.j.l.u(this.u);
        this.u.rootWrapper.addClass("ui-zoomslider-container");
        let d = this.t;
        let e = Math.round(c.rootWrapper.width());
        let f = Math.round(c.rootWrapper.height());
        let g = e * d;
        let h = f * d;
        this.u.rootWrapper.setStyleProperty("position", "relative");
        let i = this.u.createElement("canvas");
        i.setStyleProperty("position", "absolute");
        this.u.append(i);
        this.x = truncate(Math.round(g));
        this.w = truncate(Math.round(h));
        i.setAttribute("width", g.toString());
        i.setAttribute("height", h.toString());
        i.setStyleProperty("width", e.toString() + "px");
        i.setStyleProperty("height", f.toString() + "px");
        this.v = i;
        let j = this.u.get2DCanvasContext(this.v);
        this.o = new RenderingContext(new CanvasViewRenderer(), j);
        this.o.ac(this.m);
        this.ab();
        this.a = new CanvasGestureDOMEventProxy(this.u.rootWrapper, this.u, false);
        this.a.bg = this.j.fj;
        let k = this.a;
        k.onContactStarted = delegateCombine(k.onContactStarted, runOn(this, this.ai));
        let l = this.a;
        l.onContactMoved = delegateCombine(l.onContactMoved, runOn(this, this.ah));
        let m = this.a;
        m.onContactCompleted = delegateCombine(m.onContactCompleted, runOn(this, this.ag));
        this.a.al = (n) => this.j.fh.containsPoint(n);
        this.j.de(0, 0, e, f);
        this.s = FontUtil.getCurrentFontHeight(this.u, this.m);
        this.j.trackDirty();
        this.z = this.u.setTimeout(runOn(this, this.al), 200);
    }
    ag(a, b) {
        this.j.c8(a, b);
    }
    ah(a, b) {
        this.j.c9(a);
    }
    ai(a, b) {
        this.j.ae(a, b);
    }
    ab() {
        if (this.a != null) {
            let a = this.a;
            a.onContactStarted = delegateRemove(a.onContactStarted, runOn(this, this.ai));
            let b = this.a;
            b.onContactMoved = delegateRemove(b.onContactMoved, runOn(this, this.ah));
            let c = this.a;
            c.onContactCompleted = delegateRemove(c.onContactCompleted, runOn(this, this.ag));
            this.a.al = null;
            this.a.ar();
        }
    }
    av() {
    }
    ap() {
        this.aq(true);
    }
    aq(a) {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.an();
        let b = Math.round(this.u.rootWrapper.width());
        let c = Math.round(this.u.rootWrapper.height());
        let d = b != this.j.fj.width || c != this.j.fj.height;
        if (a || d) {
            this.j.de(0, 0, b, c);
            if (this.a != null) {
                this.a.bg = this.j.fj;
            }
        }
    }
    ak() {
    }
    n() {
        return ((() => {
            let $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = 10;
            return $ret;
        })());
    }
    a3(a, b, c) {
        if (a.ak != b) {
            a.ak = b;
        }
        if (this.l != c) {
            this.l = c;
            this.m = this.l;
            this.s = FontUtil.getCurrentFontHeight(this.u, this.m);
            this.o.ac(this.l);
            this.j.trackDirty();
        }
    }
    ad() {
        if (this.k != 3) {
            this.k = 3;
            this.u.rootWrapper.setStyleProperty("cursor", "move");
        }
    }
    af() {
        if (this.k != 2) {
            this.k = 2;
            this.u.rootWrapper.setStyleProperty("cursor", "ns-resize");
        }
    }
    ac() {
        if (this.k != 0) {
            this.k = 0;
            this.u.rootWrapper.setStyleProperty("cursor", "inherit");
        }
    }
    ae() {
        if (this.k != 1) {
            this.k = 1;
            this.u.rootWrapper.setStyleProperty("cursor", "ew-resize");
        }
    }
    a4(a) {
        let b = this.s;
        let c = this.o.f(a.ak);
        return new Size(1, c, b);
    }
    at() {
        this.t = this.j.a4;
        this.ao();
    }
    az() {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.u.rootWrapper.show();
    }
    am() {
        if (this.u == null || this.u.rootWrapper == null) {
            return;
        }
        this.u.rootWrapper.hide();
    }
    al() {
        this.z = -1;
        if (this.u == null) {
            return;
        }
        if (!this.p) {
            return;
        }
        this.aq(false);
        this.z = this.u.setTimeout(runOn(this, this.al), 200);
    }
}
ZoomSliderView.$t = markType(ZoomSliderView, 'ZoomSliderView');
/**
 * @hidden
 */
class ZoomSlider extends Base {
    constructor() {
        super();
        this.b = null;
        this.a = null;
        this.c = null;
        this.g = null;
        this.propertyChanged = null;
        this.bk = 500;
        this.ax = 1;
        this.az = NaN;
        this.ag = 1;
        this.resolvingAxisValue = null;
        this.fg = new Rect(0, 0, 0, 1, 1);
        this.w = false;
        this.af = false;
        this.windowRectChanged = null;
        this.i = 0;
        this.h = 0;
        this.ff = null;
        this.fe = null;
        this.fk = new Thickness(1, 5, 5, 5, 5);
        this.fj = null;
        this.fh = null;
        this.fi = null;
        this.ay = 1E-05;
        this.a1 = 0;
        this.al = 0;
        this.a3 = 5;
        this.a2 = 5;
        this.ah = 16;
        this.d = 0;
        this.en = null;
        this.av = 1;
        this.ap = 1;
        this.ef = null;
        this.eo = null;
        this.eg = null;
        this.ep = null;
        this.eh = null;
        this.aw = 10;
        this.aq = 10;
        this.au = 22;
        this.ao = 22;
        this.el = null;
        this.em = null;
        this.at = 1;
        this.ed = null;
        this.ee = null;
        this.an = 1;
        this.d8 = null;
        this.d9 = null;
        this.ai = 0;
        this.eq = null;
        this.er = null;
        this.a0 = 1;
        this.es = null;
        this.ei = null;
        this.ek = null;
        this.ej = null;
        this.as = 1;
        this.ea = null;
        this.ec = null;
        this.eb = null;
        this.am = 1;
        this.q = false;
        this.m = null;
        this.o = null;
        this.k = null;
        this.ak = 0;
        this.aj = 0;
        this.ar = 0;
        this.p = false;
        this.h = 6;
        this.fj = Rect.empty;
        this.fh = Rect.empty;
        this.fi = Rect.empty;
        this.g = new ZoomSliderView(this);
        this.m = this.g.n();
        this.b = new TrackThumb();
        this.b.d = 0;
        this.a = new TrackThumb();
        this.a.d = 1;
        this.c = new TrackThumbRange();
        this.c.f = this.b;
        this.c.e = this.a;
        this.b.i = 0;
        this.a.i = 1;
        this.c.r = 1;
        this.c.n = 0.5;
        this.c.m = 0;
        this.c.l = 1;
        this.b.f = this.c;
        this.a.f = this.c;
        this.c.f = this.b;
        this.c.e = this.a;
        this.b.b = this;
        this.a.b = this;
        this.c.b = this;
        this.k = new DoubleAnimator(0, 1, this.bl);
        let a = this.k;
        a.propertyChanged = delegateCombine(a.propertyChanged, runOn(this, this.cx));
        this.k.b = EasingFunctions.exponentialEase;
    }
    onDetachedFromUI() {
        this.g.as();
    }
    onAttachedToUI() {
        this.g.ar();
    }
    get bl() {
        return this.bk;
    }
    set bl(a) {
        let b = this.bk;
        this.bk = a;
        if (b != this.bk) {
            this.dc("PanTransitionDuration", b, this.bk);
        }
    }
    get bg() {
        return this.ax;
    }
    set bg(a) {
        let b = this.ax;
        this.ax = a;
        if (b != this.ax) {
            this.dc("MaxZoomWidth", b, this.ax);
        }
    }
    get bi() {
        return this.az;
    }
    set bi(a) {
        let b = this.az;
        this.az = a;
        if (b != this.az) {
            this.dc("PixelScalingRatio", b, this.az);
        }
    }
    get a4() {
        return this.ag;
    }
    set a4(a) {
        let b = this.ag;
        this.ag = a;
        if (b != this.ag) {
            this.dc("ActualPixelScalingRatio", b, this.ag);
        }
    }
    de(a, b, c, d) {
        this.fj = new Rect(0, a, b, c, d);
        if (this.e == 0) {
            let e = Math.max(0, this.fj.width - (this.startInset + this.endInset));
            this.fh = new Rect(0, this.fj.left + this.startInset, this.fj.top, e, this.fj.height);
            let f = Math.max(0, this.fh.width - (this.trackStartInset + this.trackEndInset));
            this.fi = new Rect(0, this.fh.left + this.trackStartInset, this.fh.top, f, Math.max(0, this.fh.height - this.barExtent));
        }
        else {
            this.fh = new Rect(0, this.fj.left, this.fj.top + this.startInset, this.fj.width, this.fj.height - (this.startInset + this.endInset));
            this.fi = new Rect(0, this.fh.left, this.fh.top + this.trackStartInset, this.fh.width - this.barExtent, this.fh.height - (this.trackStartInset + this.trackEndInset));
        }
        this.trackDirty();
    }
    d6() {
        if (!this.p) {
            return;
        }
        this.p = false;
        let a = this.g.i;
        let b = this.g.h;
        let c = this.g.c;
        let d = this.g.b;
        let e = this.g.e;
        let f = this.g.d;
        if (this.ab) {
            let g = this.bn();
            let h = this.bm();
            this.ds(g, this.b);
            this.dr(h, this.b.i);
            this.ds(h, this.a);
            this.dr(h, this.a.i);
        }
        else {
            this.d5(a, this.b);
            this.d5(b, this.a);
        }
        if (this.z) {
        }
        else {
            this.d3(c, this.c);
        }
        if (this.y) {
        }
        else {
            this.dp(d);
        }
        if (this.aa) {
        }
        else {
            this.dz(e);
            this.du(f);
        }
        this.d7();
    }
    get windowRect() {
        return this.fg;
    }
    set windowRect(a) {
        let b = this.fg;
        this.fg = a;
        if (Rect.l_op_Inequality(b, this.fg)) {
            this.dc("WindowRect", b, this.fg);
        }
    }
    d7() {
        let a = this.windowRect.width;
        let b = this.windowRect.height;
        let c = this.windowRect.left;
        let d = this.windowRect.top;
        let e = c;
        let f = d;
        let g = a;
        let h = b;
        if (this.e == 0) {
            e = this.b.i;
            g = this.c.r;
        }
        else {
            f = this.b.i;
            h = this.c.r;
        }
        if (e != c || f != d || g != a || h != b) {
            this.w = true;
            let i = this.windowRect;
            this.windowRect = new Rect(0, e, f, g, h);
            this.dg(i, this.windowRect);
            this.w = false;
        }
    }
    dg(a, b) {
        if (this.af) {
            return;
        }
        if (this.windowRectChanged != null) {
            this.windowRectChanged(this, new RectChangedEventArgs(a, b));
        }
    }
    c8(a, b) {
        if (this.h != 6) {
            this.g.av();
        }
        this.i = this.j(a, b);
        this.h = 6;
        this.c0();
        this.c1();
    }
    c1() {
        this.g.g.isVisible = false;
        this.g.ao();
    }
    c0() {
        this.g.f.isVisible = false;
        this.g.ao();
    }
    da(a, b) {
        this.i = this.j(a, false);
    }
    ae(a, b) {
        this.i = this.j(a, b);
        if (this.i == 6) {
            return false;
        }
        this.cy();
        if (this.ac(this.i)) {
            this.dm(a, this.i);
            this.g.ak();
            return true;
        }
        if (this.x(this.i)) {
            return this.ad(a, this.i);
        }
        return false;
    }
    ad(a, b) {
        switch (b) {
            case 5:
            case 2:
            case 3:
                this.di(a);
                return true;
        }
        return false;
    }
    di(a) {
        let b;
        if (this.e == 0) {
            b = (a.x - this.fi.left) / this.fi.width;
        }
        else {
            b = (a.y - this.fi.top) / this.fi.height;
        }
        if (b < 0 || b > 1) {
            return;
        }
        if (b + (this.c.r / 2) > 1) {
            b = 1 - (this.c.r / 2);
        }
        if (b - (this.c.r / 2) < 0) {
            b = (this.c.r / 2);
        }
        if (this.bl > 0) {
            this.dn(b);
        }
        else {
            this.c.n = b;
        }
    }
    dm(a, b) {
        this.h = b;
        this.ff = a;
        this.fe = a;
    }
    ac(a) {
        switch (a) {
            case 0:
            case 1:
            case 4: return true;
        }
        return false;
    }
    x(a) {
        switch (a) {
            case 5:
            case 2:
            case 3: return true;
        }
        return false;
    }
    c9(a) {
        this.i = this.j(a, false);
        if (this.h != 6) {
            if (this.e == 0) {
                this.c4(a);
            }
            else {
                this.dd(a);
            }
        }
        else {
            this.c2();
        }
    }
    c2() {
        if (this.i == 4) {
            this.g.ad();
        }
        else if (this.i == 0 || this.i == 1) {
            if (this.e == 1) {
                this.g.af();
            }
            else {
                this.g.ae();
            }
        }
        else {
            this.g.ac();
        }
    }
    dd(a) {
        let b = a.y - this.fe.y;
        b = b / this.fi.height;
        this.fe = a;
        switch (this.h) {
            case 0:
                this.b.j(b);
                this.d1(this.b);
                this.c3();
                break;
            case 1:
                this.a.j(b);
                this.dw(this.a);
                this.c3();
                break;
            case 4:
                this.c.o(b);
                this.d1(this.b);
                this.dw(this.a);
                this.c3();
                break;
        }
    }
    dw(a) {
        let b;
        let c;
        if (this.e == 0) {
            b = a.i;
            c = a.i * this.fi.width + this.fi.left;
            if (this.q) {
                let d = b;
                if (this.resolvingAxisValue != null) {
                    let e = ((() => {
                        let $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = d;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, e);
                    d = e.value;
                }
                this.dk(c, this.fi.top, d);
            }
        }
        else {
            b = a.i;
            c = a.i * this.fi.height + this.fi.top;
            if (this.q) {
                let f = b;
                if (this.resolvingAxisValue != null) {
                    let g = ((() => {
                        let $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = f;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, g);
                    f = g.value;
                }
                this.dk(c, this.fi.top, f);
            }
        }
    }
    dk(a, b, c) {
        let d = this.g.f;
        d.isVisible = true;
        let e = "";
        if (c != null) {
            e = c.toString();
        }
        this.g.a3(d.calloutText, e, this.n());
        let f = this.g.a4(d.calloutText);
        let g = this.fl();
        f = new Size(1, f.width + g.c + g.d, f.height + g.e + g.b);
        let h = this.a.i * this.fi.width + this.fi.left;
        let i = this.b.i * this.fi.width + this.fi.left;
        let j = 0;
        let k = 0;
        if ((this.fj.right - h) <= f.width) {
            j = h - f.width;
        }
        else {
            j = h;
        }
        if (j < i) {
            k = this.fi.top;
        }
        else {
            k = this.fi.bottom - f.height;
        }
        d.width = f.width;
        d.height = f.height;
        d.translateX = j;
        d.translateY = k;
        d.textTranslateX = j + g.c;
        d.textTranslateY = k + g.e;
    }
    d1(a) {
        let b;
        let c;
        if (this.e == 0) {
            b = a.i;
            c = a.i * this.fi.width + this.fi.left;
            if (this.q) {
                let d = b;
                if (this.resolvingAxisValue != null) {
                    let e = ((() => {
                        let $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = d;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, e);
                    d = e.value;
                }
                this.dl(c, this.fi.top, d);
            }
        }
        else {
            b = a.i;
            c = a.i * this.fi.height + this.fi.top;
            if (this.q) {
                let f = b;
                if (this.resolvingAxisValue != null) {
                    let g = ((() => {
                        let $ret = new ZoomSliderResolvingAxisValueEventArgs();
                        $ret.position = b;
                        $ret.value = f;
                        return $ret;
                    })());
                    this.resolvingAxisValue(this, g);
                    f = g.value;
                }
                this.dl(c, this.fi.top, f);
            }
        }
    }
    fl() {
        return this.fk;
    }
    dl(a, b, c) {
        let d = this.g.g;
        d.isVisible = true;
        let e = "";
        if (c != null) {
            e = c.toString();
        }
        this.g.a3(d.calloutText, e, this.n());
        let f = this.g.a4(d.calloutText);
        let g = this.fl();
        f = new Size(1, f.width + g.c + g.d, f.height + g.e + g.b);
        let h = this.b.i * this.fi.width + this.fi.left;
        let i = this.a.i * this.fi.width + this.fi.left;
        let j = 0;
        let k = 0;
        if (h >= f.width) {
            j = h - f.width;
        }
        else {
            j = h;
        }
        if (j > i) {
            k = this.fi.top;
        }
        else {
            k = this.fi.bottom - f.height;
        }
        d.width = f.width;
        d.height = f.height;
        d.translateX = j;
        d.translateY = k;
        d.textTranslateX = j + g.c;
        d.textTranslateY = k + g.e;
    }
    n() {
        if (this.o != null) {
            return this.o;
        }
        return this.m;
    }
    c4(a) {
        let b = a.x - this.fe.x;
        this.fe = a;
        b = b / this.fi.width;
        switch (this.h) {
            case 0:
                this.b.j(b);
                this.d1(this.b);
                this.c3();
                break;
            case 1:
                this.a.j(b);
                this.dw(this.a);
                this.c3();
                break;
            case 4:
                this.c.o(b);
                this.d1(this.b);
                this.dw(this.a);
                this.c3();
                break;
        }
    }
    c6(a) {
        this.i = this.j(a, false);
    }
    c7(a) {
        this.i = this.j(a, false);
    }
    j(a, b) {
        if (this.v(a, this.b, this.g.i, b)) {
            return 0;
        }
        if (this.v(a, this.a, this.g.h, b)) {
            return 1;
        }
        if (this.u(a, this.c, this.g.c)) {
            return 4;
        }
        if (this.t(a, this.b)) {
            return 2;
        }
        if (this.s(a, this.a)) {
            return 3;
        }
        if (this.r(a)) {
            return 5;
        }
        return 6;
    }
    r(a) {
        if (this.e == 0) {
            if (a.y > this.fi.bottom && a.x >= this.fi.left && a.x <= this.fi.right && a.y <= this.fh.bottom) {
                return true;
            }
        }
        else {
            if (a.x > this.fi.right && a.y >= this.fi.top && a.y <= this.fi.bottom && a.x <= this.fh.right) {
                return true;
            }
        }
        return false;
    }
    u(a, b, c) {
        if (this.e == 0) {
            let d = (b.n) * this.fi.width + this.fi.left;
            let e = d - c.width / 2;
            let f = d + c.width / 2;
            if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= e && a.x <= f) {
                return true;
            }
        }
        else {
            let g = (b.n) * this.fi.height + this.fi.top;
            let h = g - c.height / 2;
            let i = g + c.height / 2;
            if (a.x >= this.fh.left && a.x <= this.fh.right && a.y >= h && a.y <= i) {
                return true;
            }
        }
        return false;
    }
    t(a, b) {
        if (this.e == 0) {
            let c = b.i * this.fi.width + this.fi.left;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x <= c && a.y <= this.fi.bottom) {
                return true;
            }
        }
        else {
            let d = b.i * this.fi.height + this.fi.top;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.y <= d && a.x <= this.fi.right) {
                return true;
            }
        }
        return false;
    }
    s(a, b) {
        if (this.e == 0) {
            let c = b.i * this.fi.width + this.fi.left;
            if (a.y >= this.fh.top && a.x >= this.fh.left && a.x <= this.fh.right && a.x >= c && a.y <= this.fi.bottom) {
                return true;
            }
        }
        else {
            let d = b.i * this.fi.height + this.fi.top;
            if (a.y >= this.fh.top && a.y <= this.fh.bottom && a.x >= this.fh.left && a.x <= this.fh.right && a.y >= d && a.x <= this.fi.right) {
                return true;
            }
        }
        return false;
    }
    v(a, b, c, d) {
        let e = 40;
        if (this.e == 0) {
            let f = b.i * this.fi.width + this.fi.left;
            let g = this.fi.top + this.fi.height / 2;
            let h = new Rect(0, f - c.width / 2, g - c.height / 2, c.width, c.height);
            if (d) {
                if (h.width < e) {
                    h.inflate((e - h.width) / 2, 0);
                }
                if (h.height < e) {
                    h.inflate(0, (e - h.height) / 2);
                }
            }
            if (h.containsPoint(a)) {
                return true;
            }
        }
        else {
            let i = b.i * this.fi.height + this.fi.top;
            let j = this.fi.left + this.fi.width / 2;
            let k = new Rect(0, j - c.width / 2, i - c.height / 2, c.width, c.height);
            if (d) {
                if (k.width < e) {
                    k.inflate((e - k.width) / 2, 0);
                }
                if (k.height < e) {
                    k.inflate(0, (e - k.height) / 2);
                }
            }
            if (k.containsPoint(a)) {
                return true;
            }
        }
        return false;
    }
    d3(a, b) {
        if (this.e == 0) {
            a.orientation = this.e;
            a.width = Math.max(15, this.fi.width * b.r);
            a.height = this.barExtent;
            a.translateX = (this.fi.left + this.fi.width * b.n);
            a.translateY = this.fi.bottom + this.barExtent / 2;
        }
        else {
            a.orientation = this.e;
            a.height = Math.max(15, this.fi.height * b.r);
            a.width = this.barExtent;
            a.translateY = (this.fi.top + this.fi.height * b.n);
            a.translateX = this.fi.right + this.barExtent / 2;
        }
    }
    du(a) {
        let b = this.a.i;
        if (this.e == 0) {
            let c = this.fi.left + b * this.fi.width;
            a.height = this.fi.height;
            a.translateX = c + (this.fh.right - c) / 2;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.width = (this.fh.right - c);
            a.orientation = 1;
        }
        else {
            let d = this.fi.top + b * this.fi.height;
            a.width = this.fi.width;
            a.translateY = d + (this.fh.bottom - d) / 2;
            a.translateX = this.fh.left + this.fi.width / 2;
            a.height = (this.fh.bottom - d);
            a.orientation = 3;
        }
    }
    dz(a) {
        let b = this.b.i;
        if (this.e == 0) {
            let c = this.fi.left + b * this.fi.width;
            a.height = this.fi.height;
            a.translateX = c - (c - this.fh.left) / 2;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.width = c - this.fh.left;
            a.orientation = 0;
        }
        else {
            let d = this.fi.top + b * this.fi.height;
            a.width = this.fi.width;
            a.translateY = d - (d - this.fh.top) / 2;
            a.translateX = this.fh.left + this.fi.width / 2;
            a.height = d - this.fh.top;
            a.orientation = 2;
        }
    }
    dp(a) {
        if (this.e == 0) {
            a.height = this.barExtent;
            a.width = this.fi.width;
            a.translateX = this.fi.left + this.fi.width / 2;
            a.translateY = this.fh.bottom - this.barExtent / 2;
        }
        else {
            a.width = this.barExtent;
            a.height = this.fi.height;
            a.translateY = this.fi.top + this.fi.height / 2;
            a.translateX = this.fh.right - this.barExtent / 2;
        }
    }
    d5(a, b) {
        if (this.e == 0) {
            a.orientation = this.e;
            a.translateX = this.fi.left + this.fi.width * b.i;
            a.translateY = this.fi.top + this.fi.height / 2;
        }
        else {
            a.orientation = this.e;
            a.translateY = this.fi.top + this.fi.height * b.i;
            a.translateX = this.fi.left + this.fi.width / 2;
        }
    }
    ds(a, b) {
    }
    dr(a, b) {
    }
    bm() {
        throw new NotImplementedException(0);
    }
    bn() {
        throw new NotImplementedException(0);
    }
    get bh() {
        return this.ay;
    }
    set bh(a) {
        let b = this.ay;
        this.ay = a;
        if (b != this.ay) {
            this.dc("MinZoomWidth", b, this.ay);
        }
    }
    get startInset() {
        return this.a1;
    }
    set startInset(a) {
        let b = this.a1;
        this.a1 = a;
        if (b != this.a1) {
            this.dc("StartInset", b, this.a1);
        }
    }
    get endInset() {
        return this.al;
    }
    set endInset(a) {
        let b = this.al;
        this.al = a;
        if (b != this.al) {
            this.dc("EndInset", b, this.al);
        }
    }
    get trackStartInset() {
        return this.a3;
    }
    set trackStartInset(a) {
        let b = this.a3;
        this.a3 = a;
        if (b != this.a3) {
            this.dc("TrackStartInset", b, this.a3);
        }
    }
    get trackEndInset() {
        return this.a2;
    }
    set trackEndInset(a) {
        let b = this.a2;
        this.a2 = a;
        if (b != this.a2) {
            this.dc("TrackEndInset", b, this.a2);
        }
    }
    get barExtent() {
        return this.ah;
    }
    set barExtent(a) {
        let b = this.ah;
        this.ah = a;
        if (b != this.ah) {
            this.dc("BarExtent", b, this.ah);
        }
    }
    get e() {
        return this.d;
    }
    set e(a) {
        let b = this.d;
        this.d = a;
        if (b != this.d) {
            this.dc("Orientation", enumGetBox(ZoomSliderOrientation_$type, b), enumGetBox(ZoomSliderOrientation_$type, this.d));
        }
    }
    get e8() {
        return this.en;
    }
    set e8(a) {
        let b = this.en;
        this.en = a;
        if (b != this.en) {
            this.dc("LowerThumbBrush", b, this.en);
        }
    }
    get be() {
        return this.av;
    }
    set be(a) {
        let b = this.av;
        this.av = a;
        if (b != this.av) {
            this.dc("LowerThumbStrokeThickness", b, this.av);
        }
    }
    get a9() {
        return this.ap;
    }
    set a9(a) {
        let b = this.ap;
        this.ap = a;
        if (b != this.ap) {
            this.dc("HigherThumbStrokeThickness", b, this.ap);
        }
    }
    get e0() {
        return this.ef;
    }
    set e0(a) {
        let b = this.ef;
        this.ef = a;
        if (b != this.ef) {
            this.dc("HigherThumbBrush", b, this.ef);
        }
    }
    get e9() {
        return this.eo;
    }
    set e9(a) {
        let b = this.eo;
        this.eo = a;
        if (b != this.eo) {
            this.dc("LowerThumbOutline", b, this.eo);
        }
    }
    get e1() {
        return this.eg;
    }
    set e1(a) {
        let b = this.eg;
        this.eg = a;
        if (b != this.eg) {
            this.dc("HigherThumbOutline", b, this.eg);
        }
    }
    get fa() {
        return this.ep;
    }
    set fa(a) {
        let b = this.ep;
        this.ep = a;
        if (b != this.ep) {
            this.dc("LowerThumbRidgesBrush", b, this.ep);
        }
    }
    get e2() {
        return this.eh;
    }
    set e2(a) {
        let b = this.eh;
        this.eh = a;
        if (b != this.eh) {
            this.dc("HigherThumbRidgesBrush", b, this.eh);
        }
    }
    get bf() {
        return this.aw;
    }
    set bf(a) {
        let b = this.aw;
        this.aw = a;
        if (b != this.aw) {
            this.dc("LowerThumbWidth", b, this.aw);
        }
    }
    get ba() {
        return this.aq;
    }
    set ba(a) {
        let b = this.aq;
        this.aq = a;
        if (b != this.aq) {
            this.dc("HigherThumbWidth", b, this.aq);
        }
    }
    get bd() {
        return this.au;
    }
    set bd(a) {
        let b = this.au;
        this.au = a;
        if (b != this.au) {
            this.dc("LowerThumbHeight", b, this.au);
        }
    }
    get a8() {
        return this.ao;
    }
    set a8(a) {
        let b = this.ao;
        this.ao = a;
        if (b != this.ao) {
            this.dc("HigherThumbHeight", b, this.ao);
        }
    }
    get e6() {
        return this.el;
    }
    set e6(a) {
        let b = this.el;
        this.el = a;
        if (b != this.el) {
            this.dc("LowerShadeBrush", b, this.el);
        }
    }
    get e7() {
        return this.em;
    }
    set e7(a) {
        let b = this.em;
        this.em = a;
        if (b != this.em) {
            this.dc("LowerShadeOutline", b, this.em);
        }
    }
    destroy() {
        this.provideContainer(null);
    }
    get bc() {
        return this.at;
    }
    set bc(a) {
        let b = this.at;
        this.at = a;
        if (b != this.at) {
            this.dc("LowerShadeStrokeThickness", b, this.at);
        }
    }
    get ey() {
        return this.ed;
    }
    set ey(a) {
        let b = this.ed;
        this.ed = a;
        if (b != this.ed) {
            this.dc("HigherShadeBrush", b, this.ed);
        }
    }
    get ez() {
        return this.ee;
    }
    set ez(a) {
        let b = this.ee;
        this.ee = a;
        if (b != this.ee) {
            this.dc("HigherShadeOutline", b, this.ee);
        }
    }
    get a7() {
        return this.an;
    }
    set a7(a) {
        let b = this.an;
        this.an = a;
        if (b != this.an) {
            this.dc("HigherShadeStrokeThickness", b, this.an);
        }
    }
    get et() {
        return this.d8;
    }
    set et(a) {
        let b = this.d8;
        this.d8 = a;
        if (b != this.d8) {
            this.dc("BarBrush", b, this.d8);
        }
    }
    get eu() {
        return this.d9;
    }
    set eu(a) {
        let b = this.d9;
        this.d9 = a;
        if (b != this.d9) {
            this.dc("BarOutline", b, this.d9);
        }
    }
    get a5() {
        return this.ai;
    }
    set a5(a) {
        let b = this.ai;
        this.ai = a;
        if (b != this.ai) {
            this.dc("BarStrokeThickness", b, this.ai);
        }
    }
    get fb() {
        return this.eq;
    }
    set fb(a) {
        let b = this.eq;
        this.eq = a;
        if (b != this.eq) {
            this.dc("RangeThumbBrush", b, this.eq);
        }
    }
    get fc() {
        return this.er;
    }
    set fc(a) {
        let b = this.er;
        this.er = a;
        if (b != this.er) {
            this.dc("RangeThumbOutline", b, this.er);
        }
    }
    get bj() {
        return this.a0;
    }
    set bj(a) {
        let b = this.a0;
        this.a0 = a;
        if (b != this.a0) {
            this.dc("RangeThumbStrokeThickness", b, this.a0);
        }
    }
    get fd() {
        return this.es;
    }
    set fd(a) {
        let b = this.es;
        this.es = a;
        if (b != this.es) {
            this.dc("RangeThumbRidgesBrush", b, this.es);
        }
    }
    get e3() {
        return this.ei;
    }
    set e3(a) {
        let b = this.ei;
        this.ei = a;
        if (b != this.ei) {
            this.dc("LowerCalloutBrush", b, this.ei);
        }
    }
    get e5() {
        return this.ek;
    }
    set e5(a) {
        let b = this.ek;
        this.ek = a;
        if (b != this.ek) {
            this.dc("LowerCalloutTextColor", b, this.ek);
        }
    }
    get e4() {
        return this.ej;
    }
    set e4(a) {
        let b = this.ej;
        this.ej = a;
        if (b != this.ej) {
            this.dc("LowerCalloutOutline", b, this.ej);
        }
    }
    get bb() {
        return this.as;
    }
    set bb(a) {
        let b = this.as;
        this.as = a;
        if (b != this.as) {
            this.dc("LowerCalloutStrokeThickness", b, this.as);
        }
    }
    get ev() {
        return this.ea;
    }
    set ev(a) {
        let b = this.ea;
        this.ea = a;
        if (b != this.ea) {
            this.dc("HigherCalloutBrush", b, this.ea);
        }
    }
    get ex() {
        return this.ec;
    }
    set ex(a) {
        let b = this.ec;
        this.ec = a;
        if (b != this.ec) {
            this.dc("HigherCalloutTextColor", b, this.ec);
        }
    }
    get ew() {
        return this.eb;
    }
    set ew(a) {
        let b = this.eb;
        this.eb = a;
        if (b != this.eb) {
            this.dc("HigherCalloutOutline", b, this.eb);
        }
    }
    get a6() {
        return this.am;
    }
    set a6(a) {
        let b = this.am;
        this.am = a;
        if (b != this.am) {
            this.dc("HigherCalloutStrokeThickness", b, this.am);
        }
    }
    get ab() {
        return false;
    }
    get z() {
        return false;
    }
    get y() {
        return false;
    }
    get aa() {
        return false;
    }
    dc(a, b, c) {
        this.dj(a, b, c);
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
    }
    dj(a, b, c) {
        switch (a) {
            case "PixelScalingRatio":
                this.a4 = this.bi;
                break;
            case "ActualPixelScalingRatio":
                if (this.g != null) {
                    this.g.at();
                }
                break;
            case "Orientation":
                this.db();
                this.trackDirty();
                break;
            case "TrackStartInset":
            case "TrackEndInset":
            case "StartInset":
            case "EndInset":
                this.c5();
                this.trackDirty();
                break;
            case "MaxZoomWidth":
            case "MinZoomWidth":
                this.dh();
                this.trackDirty();
                break;
            case "WindowRect":
                if (!this.w) {
                    this.af = true;
                    this.df();
                    this.trackDirty();
                    this.c3();
                    this.af = false;
                }
                break;
            case "LowerThumbBrush":
            case "LowerThumbOutline":
            case "LowerThumbRidgesBrush":
            case "LowerThumbStrokeThickness":
                this.d2();
                this.g.ao();
                break;
            case "LowerThumbWidth":
            case "LowerThumbHeight":
                this.g.i.width = this.bf;
                this.g.i.height = this.bd;
                this.trackDirty();
                break;
            case "HigherThumbBrush":
            case "HigherThumbOutline":
            case "HigherThumbRidgesBrush":
            case "HigherThumbStrokeThickness":
                this.dx();
                this.g.ao();
                break;
            case "HigherThumbWidth":
            case "HigherThumbHeight":
                this.g.i.width = this.bf;
                this.g.i.height = this.bd;
                this.trackDirty();
                break;
            case "LowerShadeBrush":
            case "LowerShadeOutline":
            case "LowerShadeStrokeThickness":
                this.d0();
                this.g.ao();
                break;
            case "HigherShadeBrush":
            case "HigherShadeOutline":
            case "HigherShadeStrokeThickness":
                this.dv();
                this.g.ao();
                break;
            case "RangeThumbBrush":
            case "RangeThumbOutline":
            case "RangeThumbRidgesBrush":
            case "RangeThumbStrokeThickness":
                this.d4();
                this.g.ao();
                break;
            case "BarBrush":
            case "BarOutline":
            case "BarStrokeThickness":
                this.dq();
                this.g.ao();
                break;
            case "LowerCalloutBrush":
            case "LowerCalloutOutline":
            case "LowerCalloutTextColor":
            case "LowerCalloutStrokeThickness":
                this.dy();
                this.g.ao();
                break;
            case "HigherCalloutBrush":
            case "HigherCalloutOutline":
            case "HigherCalloutTextColor":
            case "HigherCalloutStrokeThickness":
                this.dt();
                this.g.ao();
                break;
        }
    }
    dq() {
        let a = this.g.b;
        if (this.et == null) {
            a.barBox._fill = a.getBarBoxDefaultBrush();
        }
        else {
            a.barBox._fill = this.et;
        }
        if (this.eu == null) {
            a.barBox._stroke = a.getBarBoxDefaultOutline();
        }
        else {
            a.barBox._stroke = this.eu;
        }
        if (this.a5 == NaN) {
            a.barBox.ac = a.getBarBoxDefaultStrokeThickness();
        }
        else {
            a.barBox.ac = this.a5;
        }
    }
    dy() {
        let a = this.g.g;
        if (this.e3 == null) {
            a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
        }
        else {
            a.calloutBox._fill = this.e3;
        }
        if (this.e4 == null) {
            a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
        }
        else {
            a.calloutBox._stroke = this.e4;
        }
        if (this.e5 == null) {
            a.calloutText.am = a.getCalloutTextDefaultBrush();
        }
        else {
            a.calloutText.am = this.e5;
        }
        if (this.bb == NaN) {
            a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
        }
        else {
            a.calloutBox.ac = this.bb;
        }
    }
    dt() {
        let a = this.g.f;
        if (this.ev == null) {
            a.calloutBox._fill = a.getCalloutBoxDefaultBrush();
        }
        else {
            a.calloutBox._fill = this.ev;
        }
        if (this.ew == null) {
            a.calloutBox._stroke = a.getCalloutBoxDefaultStroke();
        }
        else {
            a.calloutBox._stroke = this.ew;
        }
        if (this.ex == null) {
            a.calloutText.am = a.getCalloutTextDefaultBrush();
        }
        else {
            a.calloutText.am = this.ex;
        }
        if (this.a6 == NaN) {
            a.calloutBox.ac = a.getCalloutBoxDefaultStrokeThickness();
        }
        else {
            a.calloutBox.ac = this.a6;
        }
    }
    d2() {
        let a = this.g.i;
        if (this.e8 == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.e8;
        }
        if (this.e9 == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.e9;
        }
        if (this.fa == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.fa;
        }
        if (this.be == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.be;
        }
    }
    d4() {
        let a = this.g.c;
        if (this.fb == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.fb;
        }
        if (this.fc == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.fc;
        }
        if (this.fd == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.fd;
        }
        if (this.bj == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.bj;
        }
    }
    d0() {
        let a = this.g.e;
        if (this.e6 == null) {
            a.shadeBox._fill = a.getShadeBoxDefaultBrush();
        }
        else {
            a.shadeBox._fill = this.e6;
        }
        if (this.e7 == null) {
            a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
        }
        else {
            a.shadeOutline._stroke = this.e7;
        }
        if (this.bc == NaN) {
            a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
        }
        else {
            a.shadeOutline.ac = this.bc;
        }
    }
    dv() {
        let a = this.g.d;
        if (this.ey == null) {
            a.shadeBox._fill = a.getShadeBoxDefaultBrush();
        }
        else {
            a.shadeBox._fill = this.ey;
        }
        if (this.ez == null) {
            a.shadeOutline._stroke = a.getShadeOutlineDefaultBrush();
        }
        else {
            a.shadeOutline._stroke = this.ez;
        }
        if (this.a7 == NaN) {
            a.shadeOutline.ac = a.getShadeOutlineDefaultStrokeThickness();
        }
        else {
            a.shadeOutline.ac = this.a7;
        }
    }
    dx() {
        let a = this.g.h;
        if (this.e0 == null) {
            a.thumbBox._fill = a.getThumbBoxDefaultBrush();
        }
        else {
            a.thumbBox._fill = this.e0;
        }
        if (this.e1 == null) {
            a.thumbBox._stroke = a.getThumbBoxDefaultStroke();
        }
        else {
            a.thumbBox._stroke = this.e1;
        }
        if (this.e2 == null) {
            a.thumbRidges._stroke = a.getThumbRidgesDefaultStroke();
        }
        else {
            a.thumbRidges._stroke = this.e2;
        }
        if (this.a9 == NaN) {
            a.thumbBox.ac = a.getThumbBoxDefaultStrokeThickness();
        }
        else {
            a.thumbBox.ac = this.a9;
        }
    }
    df() {
        if (this.w) {
            return;
        }
        if (this.e == 0) {
            this.b.i = this.windowRect.left;
            this.a.i = this.windowRect.right;
            this.c.r = this.windowRect.width;
            this.c.n = this.windowRect.left + this.windowRect.width / 2;
        }
        else {
            this.b.i = this.windowRect.top;
            this.a.i = this.windowRect.bottom;
            this.c.r = this.windowRect.height;
            this.c.n = this.windowRect.top + this.windowRect.height / 2;
        }
    }
    dh() {
        this.c.m = this.bh;
        this.c.l = this.bg;
    }
    c5() {
        if (this.fj.isEmpty) {
            return;
        }
        this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
    }
    db() {
        if (this.e == 0) {
            this.g.i.width = this.bf;
            this.g.i.height = this.bd;
            this.g.h.width = this.ba;
            this.g.h.height = this.a8;
        }
        else {
            this.g.i.height = this.bf;
            this.g.i.width = this.bd;
            this.g.h.height = this.ba;
            this.g.h.width = this.a8;
        }
        if (this.fj.isEmpty) {
            return;
        }
        this.de(this.fj.left, this.fj.top, this.fj.width, this.fj.height);
    }
    provideContainer(a) {
        this.g.au(a);
    }
    notifySizeChanged() {
        this.g.ap();
    }
    get l() {
        return this.k;
    }
    dn(a) {
        this.ak = a;
        this.aj = this.c.n;
        this.ar = this.aj;
        this.k.v();
    }
    cy() {
        if (this.k.f()) {
            this.k.w();
        }
    }
    cx(a, b) {
        let c = this.k.o;
        let d = this.aj + c * (this.ak - this.aj);
        let e = d - this.ar;
        this.ar = d;
        this.c.o(e);
        if (this.k.f()) {
            this.d1(this.b);
            this.dw(this.a);
            this.c3();
        }
        else {
            this.c1();
            this.c0();
        }
    }
    c3() {
        this.g.aj();
    }
    trackDirty() {
        this.p = true;
        if (this.g == null) {
            return;
        }
        this.g.ao();
    }
    show() {
        if (this.g != null) {
            this.g.az();
        }
    }
    hide() {
        if (this.g != null) {
            this.g.am();
        }
    }
}
ZoomSlider.$t = markType(ZoomSlider, 'ZoomSlider', Base.$, [ITrackOwner_$type, INotifyPropertyChanged_$type, IZoomSlider_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

const IgxZoomSliderComponent_PROVIDERS = [];
const ZoomSliderStylingDefaults = {};
let IgxZoomSliderComponent = class IgxZoomSliderComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this._wrapper = null;
        this._root = null;
        this._implementation = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._resolvingAxisValue = null;
        this._windowRectChanged = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        if (renderer) {
            this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, this.container);
            renderer.setStyle(this.container, "display", "block");
            renderer.setStyle(this.container, "width", "100%");
            renderer.setStyle(this.container, "height", "100%");
        }
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        if (root && root.nativeElement) {
            root = root.nativeElement;
        }
        this._root = root;
        var zoomSlider = this.i;
        this._zoomSlider = zoomSlider;
        if (renderer) {
            var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, ZoomSliderStylingDefaults);
            this._wrapper = ren;
            zoomSlider.provideContainer(ren);
            zoomSlider.notifySizeChanged();
            ren.addSizeWatcher(() => {
                this._zoomSlider.notifySizeChanged();
            });
        }
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._zoomSlider.notifySizeChanged();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._zoomSlider.notifySizeChanged();
    }
    get width() {
        return this._width;
    }
    // supports angular themes or custom properties set in CSS
    updateStyle() {
        this._styling(this._root, this);
    }
    ngOnDestroy() {
        this._zoomSlider.destroy();
        this._wrapper.destroy();
    }
    ngAfterContentInit() {
        this.updateStyle();
    }
    createImplementation() {
        return new ZoomSlider();
    }
    get i() {
        return this._implementation;
    }
    static _staticStyling(container, component, parent) {
        let genericPrefix = "";
        let typeName = (component.i ? component.i : component).$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ZoomSlider");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = (component.i ? component.i : component).$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, component, genericPrefix + "-", new Set(), false, additionalPrefixes);
    }
    get panTransitionDuration() {
        return this.i.bl;
    }
    set panTransitionDuration(v) {
        this.i.bl = +v;
    }
    get maxZoomWidth() {
        return this.i.bg;
    }
    set maxZoomWidth(v) {
        this.i.bg = +v;
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.bi;
    }
    set pixelScalingRatio(v) {
        this.i.bi = +v;
    }
    get actualPixelScalingRatio() {
        return this.i.a4;
    }
    set actualPixelScalingRatio(v) {
        this.i.a4 = +v;
    }
    get windowRect() {
        return fromRect(this.i.windowRect);
    }
    set windowRect(v) {
        this.i.windowRect = toRect(v);
    }
    get minZoomWidth() {
        return this.i.bh;
    }
    set minZoomWidth(v) {
        this.i.bh = +v;
    }
    get startInset() {
        return this.i.startInset;
    }
    set startInset(v) {
        this.i.startInset = +v;
    }
    get endInset() {
        return this.i.endInset;
    }
    set endInset(v) {
        this.i.endInset = +v;
    }
    get trackStartInset() {
        return this.i.trackStartInset;
    }
    set trackStartInset(v) {
        this.i.trackStartInset = +v;
    }
    get trackEndInset() {
        return this.i.trackEndInset;
    }
    set trackEndInset(v) {
        this.i.trackEndInset = +v;
    }
    get barExtent() {
        return this.i.barExtent;
    }
    set barExtent(v) {
        this.i.barExtent = +v;
    }
    get orientation() {
        return this.i.e;
    }
    set orientation(v) {
        this.i.e = ensureEnum(ZoomSliderOrientation_$type, v);
    }
    get lowerThumbBrush() {
        return brushToString(this.i.e8);
    }
    set lowerThumbBrush(v) {
        this.i.e8 = stringToBrush(v);
    }
    get lowerThumbStrokeThickness() {
        return this.i.be;
    }
    set lowerThumbStrokeThickness(v) {
        this.i.be = +v;
    }
    get higherThumbStrokeThickness() {
        return this.i.a9;
    }
    set higherThumbStrokeThickness(v) {
        this.i.a9 = +v;
    }
    get higherThumbBrush() {
        return brushToString(this.i.e0);
    }
    set higherThumbBrush(v) {
        this.i.e0 = stringToBrush(v);
    }
    get lowerThumbOutline() {
        return brushToString(this.i.e9);
    }
    set lowerThumbOutline(v) {
        this.i.e9 = stringToBrush(v);
    }
    get higherThumbOutline() {
        return brushToString(this.i.e1);
    }
    set higherThumbOutline(v) {
        this.i.e1 = stringToBrush(v);
    }
    get lowerThumbRidgesBrush() {
        return brushToString(this.i.fa);
    }
    set lowerThumbRidgesBrush(v) {
        this.i.fa = stringToBrush(v);
    }
    get higherThumbRidgesBrush() {
        return brushToString(this.i.e2);
    }
    set higherThumbRidgesBrush(v) {
        this.i.e2 = stringToBrush(v);
    }
    get lowerThumbWidth() {
        return this.i.bf;
    }
    set lowerThumbWidth(v) {
        this.i.bf = +v;
    }
    get higherThumbWidth() {
        return this.i.ba;
    }
    set higherThumbWidth(v) {
        this.i.ba = +v;
    }
    get lowerThumbHeight() {
        return this.i.bd;
    }
    set lowerThumbHeight(v) {
        this.i.bd = +v;
    }
    get higherThumbHeight() {
        return this.i.a8;
    }
    set higherThumbHeight(v) {
        this.i.a8 = +v;
    }
    get lowerShadeBrush() {
        return brushToString(this.i.e6);
    }
    set lowerShadeBrush(v) {
        this.i.e6 = stringToBrush(v);
    }
    get lowerShadeOutline() {
        return brushToString(this.i.e7);
    }
    set lowerShadeOutline(v) {
        this.i.e7 = stringToBrush(v);
    }
    get lowerShadeStrokeThickness() {
        return this.i.bc;
    }
    set lowerShadeStrokeThickness(v) {
        this.i.bc = +v;
    }
    get higherShadeBrush() {
        return brushToString(this.i.ey);
    }
    set higherShadeBrush(v) {
        this.i.ey = stringToBrush(v);
    }
    get higherShadeOutline() {
        return brushToString(this.i.ez);
    }
    set higherShadeOutline(v) {
        this.i.ez = stringToBrush(v);
    }
    get higherShadeStrokeThickness() {
        return this.i.a7;
    }
    set higherShadeStrokeThickness(v) {
        this.i.a7 = +v;
    }
    get barBrush() {
        return brushToString(this.i.et);
    }
    set barBrush(v) {
        this.i.et = stringToBrush(v);
    }
    get barOutline() {
        return brushToString(this.i.eu);
    }
    set barOutline(v) {
        this.i.eu = stringToBrush(v);
    }
    get barStrokeThickness() {
        return this.i.a5;
    }
    set barStrokeThickness(v) {
        this.i.a5 = +v;
    }
    get rangeThumbBrush() {
        return brushToString(this.i.fb);
    }
    set rangeThumbBrush(v) {
        this.i.fb = stringToBrush(v);
    }
    get rangeThumbOutline() {
        return brushToString(this.i.fc);
    }
    set rangeThumbOutline(v) {
        this.i.fc = stringToBrush(v);
    }
    get rangeThumbStrokeThickness() {
        return this.i.bj;
    }
    set rangeThumbStrokeThickness(v) {
        this.i.bj = +v;
    }
    get rangeThumbRidgesBrush() {
        return brushToString(this.i.fd);
    }
    set rangeThumbRidgesBrush(v) {
        this.i.fd = stringToBrush(v);
    }
    get lowerCalloutBrush() {
        return brushToString(this.i.e3);
    }
    set lowerCalloutBrush(v) {
        this.i.e3 = stringToBrush(v);
    }
    get lowerCalloutTextColor() {
        return brushToString(this.i.e5);
    }
    set lowerCalloutTextColor(v) {
        this.i.e5 = stringToBrush(v);
    }
    get lowerCalloutOutline() {
        return brushToString(this.i.e4);
    }
    set lowerCalloutOutline(v) {
        this.i.e4 = stringToBrush(v);
    }
    get lowerCalloutStrokeThickness() {
        return this.i.bb;
    }
    set lowerCalloutStrokeThickness(v) {
        this.i.bb = +v;
    }
    get higherCalloutBrush() {
        return brushToString(this.i.ev);
    }
    set higherCalloutBrush(v) {
        this.i.ev = stringToBrush(v);
    }
    get higherCalloutTextColor() {
        return brushToString(this.i.ex);
    }
    set higherCalloutTextColor(v) {
        this.i.ex = stringToBrush(v);
    }
    get higherCalloutOutline() {
        return brushToString(this.i.ew);
    }
    set higherCalloutOutline(v) {
        this.i.ew = stringToBrush(v);
    }
    get higherCalloutStrokeThickness() {
        return this.i.a6;
    }
    set higherCalloutStrokeThickness(v) {
        this.i.a6 = +v;
    }
    get isCustomThumbProvided() {
        return this.i.ab;
    }
    get isCustomRangeThumbProvided() {
        return this.i.z;
    }
    get isCustomBarProvided() {
        return this.i.y;
    }
    get isCustomShadeProvided() {
        return this.i.aa;
    }
    get areThumbCalloutsEnabled() {
        return this.i.q;
    }
    set areThumbCalloutsEnabled(v) {
        this.i.q = ensureBool(v);
    }
    get thumbCalloutTextStyle() {
        if (this.i.o == null) {
            return null;
        }
        return this.i.o.fontString;
    }
    set thumbCalloutTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.o = fi;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ZoomSliderComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    onDetachedFromUI() {
        this.i.onDetachedFromUI();
    }
    onAttachedToUI() {
        this.i.onAttachedToUI();
    }
    /**
     * Release any resources held by the ZoomSlider.
    
    */
    destroy() {
        this.i.destroy();
    }
    /**
     * Called by the UI framework to provide a UI container for rendering this control.
    
    * @param container  * The UI container element.
    */
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    flush() {
        this.i.c3();
    }
    trackDirty() {
        this.i.trackDirty();
    }
    /**
     * Shows the ZoomSlider.
    
    */
    show() {
        this.i.show();
    }
    /**
     * Hides the ZoomSlider.
    
    */
    hide() {
        this.i.hide();
    }
    get resolvingAxisValue() {
        if (this._resolvingAxisValue == null) {
            this._resolvingAxisValue = new EventEmitter();
            this.i.resolvingAxisValue = delegateCombine(this.i.resolvingAxisValue, (o, e) => {
                let outerArgs = new IgxZoomSliderResolvingAxisValueEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeResolvingAxisValue) {
                    this.beforeResolvingAxisValue(this, outerArgs);
                }
                this._resolvingAxisValue.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._resolvingAxisValue;
    }
    /**
     * Occurs just after the current ZoomSlider's window rectangle is changed.
    */
    get windowRectChanged() {
        if (this._windowRectChanged == null) {
            this._windowRectChanged = new EventEmitter();
            this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, (o, e) => {
                let outerArgs = new IgxRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeWindowRectChanged) {
                    this.beforeWindowRectChanged(this, outerArgs);
                }
                this._windowRectChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._windowRectChanged;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "width", null);
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxZoomSliderComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "panTransitionDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "maxZoomWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "actualPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxZoomSliderComponent.prototype, "windowRect", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "minZoomWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "startInset", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "endInset", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "trackStartInset", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "trackEndInset", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "barExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "orientation", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerThumbBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "lowerThumbStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "higherThumbStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherThumbBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerThumbOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherThumbOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerThumbRidgesBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherThumbRidgesBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "lowerThumbWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "higherThumbWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "lowerThumbHeight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "higherThumbHeight", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerShadeBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerShadeOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "lowerShadeStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherShadeBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherShadeOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "higherShadeStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "barBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "barOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "barStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "rangeThumbBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "rangeThumbOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "rangeThumbStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "rangeThumbRidgesBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerCalloutBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerCalloutTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "lowerCalloutOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "lowerCalloutStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherCalloutBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherCalloutTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "higherCalloutOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxZoomSliderComponent.prototype, "higherCalloutStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxZoomSliderComponent.prototype, "areThumbCalloutsEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxZoomSliderComponent.prototype, "thumbCalloutTextStyle", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxZoomSliderComponent.prototype, "resolvingAxisValue", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxZoomSliderComponent.prototype, "windowRectChanged", null);
IgxZoomSliderComponent = __decorate([
    Component({
        selector: 'igx-zoom-slider',
        template: ``,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxZoomSliderComponent_PROVIDERS,
        host: { 'class': 'ig-zoom-slider igx-zoom-slider' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxZoomSliderComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxZoomSliderModule = class IgxZoomSliderModule {
    constructor() {
        TypeRegistrar.registerCons('IgxZoomSliderComponent', IgxZoomSliderComponent);
        TypeRegistrar.register('ZoomSlider', ZoomSlider.$type);
    }
};
IgxZoomSliderModule = __decorate([
    NgModule({
        declarations: [IgxZoomSliderComponent],
        exports: [IgxZoomSliderComponent
        ],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxZoomSliderModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxZoomSliderDynamicModule = class IgxZoomSliderDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('ZoomSlider', ZoomSlider);
        TypeRegistrar.registerCons('IgxZoomSliderComponent', IgxZoomSliderComponent);
        TypeRegistrar.register('ZoomSlider', ZoomSlider.$type);
    }
};
IgxZoomSliderDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxZoomSliderModule
        ],
        imports: [CommonModule, IgxZoomSliderModule
        ],
        entryComponents: [IgxZoomSliderComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxZoomSliderDynamicModule);

//some of the build tools don't like styles not being an array literal for Angular
//export const LegendBaseStyles: string[] = [`
//`];
/**
 * Represents the base class for a legend in IgxDataChartComponent.
*/
class IgxLegendBaseComponent {
    constructor() {
        this._zoneRunner = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
    }
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    /**
 * Gets if the legend is item-wise.
*/
    get isItemwise() {
        return this.i.isItemwise;
    }
    /**
     * Gets if the legend is a financial legend.
    */
    get isFinancial() {
        return this.i.isFinancial;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("LegendBaseComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendMouseButtonEventArgs extends EventArgs {
    constructor(a, b, c, d, e) {
        super();
        this._originalEvent = null;
        this._item = null;
        this._series = null;
        this._chart = null;
        this._legendItem = null;
        this.chart = a;
        this.series = b;
        this.item = c;
        this.originalEvent = d;
        this.legendItem = e;
    }
    toString() {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    }
    get originalEvent() {
        return this._originalEvent;
    }
    set originalEvent(a) {
        this._originalEvent = a;
    }
    get handled() {
        return this.originalEvent.handled;
    }
    set handled(a) {
        this.originalEvent.handled = a;
    }
    getPosition(a) {
        return this.originalEvent.getPosition(a);
    }
    get originalSource() {
        return this.originalEvent.originalSource;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get chart() {
        return this._chart;
    }
    set chart(a) {
        this._chart = a;
    }
    get legendItem() {
        return this._legendItem;
    }
    set legendItem(a) {
        this._legendItem = a;
    }
}
LegendMouseButtonEventArgs.$t = markType(LegendMouseButtonEventArgs, 'LegendMouseButtonEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendMouseEventArgs extends EventArgs {
    constructor(a, b, c, d, e) {
        super();
        this._originalEvent = null;
        this._item = null;
        this._series = null;
        this._chart = null;
        this._legendItem = null;
        this.chart = a;
        this.series = b;
        this.item = c;
        this.originalEvent = d;
        this.legendItem = e;
    }
    toString() {
        return this.chart.name + ", " + this.series.name + ", " + (this.item != null ? this.item.toString() : "") + ", " + this.getPosition(null).toString();
    }
    get originalEvent() {
        return this._originalEvent;
    }
    set originalEvent(a) {
        this._originalEvent = a;
    }
    getPosition(a) {
        return this.originalEvent.getPosition(a);
    }
    get originalSource() {
        return this.originalEvent.originalSource;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get chart() {
        return this._chart;
    }
    set chart(a) {
        this._chart = a;
    }
    get legendItem() {
        return this._legendItem;
    }
    set legendItem(a) {
        this._legendItem = a;
    }
}
LegendMouseEventArgs.$t = markType(LegendMouseEventArgs, 'LegendMouseEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendItemVisualData extends Base {
    constructor() {
        super();
        this._label = null;
        this._labelBounds = null;
        this._appearance = null;
        this._labelAppearance = null;
        this._bounds = null;
        this._badgeBounds = null;
        this.labelBounds = RectData.empty;
        this.appearance = new PrimitiveAppearanceData();
    }
    get label() {
        return this._label;
    }
    set label(a) {
        this._label = a;
    }
    get labelBounds() {
        return this._labelBounds;
    }
    set labelBounds(a) {
        this._labelBounds = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    get labelAppearance() {
        return this._labelAppearance;
    }
    set labelAppearance(a) {
        this._labelAppearance = a;
    }
    get bounds() {
        return this._bounds;
    }
    set bounds(a) {
        this._bounds = a;
    }
    get badgeBounds() {
        return this._badgeBounds;
    }
    set badgeBounds(a) {
        this._badgeBounds = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        if (this.label != null) {
            a.u("label: \"" + this.label + "\", ");
        }
        if (this.appearance != null) {
            a.u("appearance: " + this.appearance.serialize() + ", ");
        }
        if (this.labelAppearance != null) {
            a.u("labelAppearance: " + this.labelAppearance.serialize() + ", ");
        }
        let b = (c) => "{ left: " + c.left + ", top: " + c.top + ", width: " + c.width + ", height: " + c.height + "}";
        a.q("bounds: {0},\r\n", b(this.bounds));
        a.q("badgeBounds: {0},\r\n", b(this.badgeBounds));
        a.q("labelBounds: {0}\r\n", b(this.labelBounds));
        a.u("}");
        return a.toString();
    }
}
LegendItemVisualData.$t = markType(LegendItemVisualData, 'LegendItemVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendVisualDataList extends List$1 {
    constructor() {
        super(LegendItemVisualData.$, 0);
    }
}
LegendVisualDataList.$t = markType(LegendVisualDataList, 'LegendVisualDataList', List$1.$.specialize(LegendItemVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendVisualData extends Base {
    constructor() {
        super();
        this._items = null;
        this._viewport = null;
        this._width = 0;
        this._height = 0;
        this.items = new LegendVisualDataList();
    }
    get items() {
        return this._items;
    }
    set items(a) {
        this._items = a;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("items: [");
        for (let b = 0; b < this.items.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.items._inner[b].serialize());
        }
        a.u("],");
        a.u("}");
        return a.toString();
    }
}
LegendVisualData.$t = markType(LegendVisualData, 'LegendVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendBaseViewManager extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.l = null;
        this.g = null;
        this.d = false;
        this.f = null;
        this.m = null;
        this.c = null;
        this.a = a;
        this.f = new Dictionary$2(Base.$, DomWrapper_$type, 0);
        this.p();
    }
    p() {
        let a = LegendItemHelper.b;
        if (window.devicePixelRatio != undefined && (isNaN_(a) || window.devicePixelRatio != a)) {
            LegendItemHelper.b = window.devicePixelRatio;
            this.a.al();
        }
    }
    u() {
    }
    s() {
        this.p();
    }
    t(a) {
        if (a == null) {
            this.l = null;
            this.g = null;
            return;
        }
        this.g = a;
        this.l = this.i();
        this.l.addClass(this.a.s);
        this.g.append(this.l);
    }
    i() {
        return this.g.createElement("table");
    }
    h() {
        let a = this.g.createElement("tr");
        a.addClass(this.a.t);
        let b = this.a.k;
        if (b) {
            a.setStyleProperty("display", "block");
            a.setStyleProperty("float", "left");
            a.setStyleProperty("margin", "0px");
            a.setStyleProperty("margin-right", "8px");
        }
        return a;
    }
    j(a) {
        return this.k(a, this.l);
    }
    k(a, b) {
        let c = typeCast(ContentControl.$, a);
        let d = this.h();
        if (c != null) {
            let e = typeCast(ILegendContext_$type, c.content);
            if (e != null && c.ah != null) {
                let f = new DataTemplatePassInfo();
                f.context = d;
                f.passID = "LegendItem";
                let g = new DataTemplateMeasureInfo();
                g.passInfo = f;
                g.width = NaN;
                g.height = NaN;
                g.data = e;
                g.context = d;
                let h = new DataTemplateRenderInfo();
                h.passInfo = f;
                if (c.ah.measure != null) {
                    c.ah.measure(g);
                }
                h.context = this.g.getSubRenderer(d);
                h.availableWidth = g.width;
                h.availableHeight = g.height;
                h.data = e;
                h.xPosition = 0;
                h.yPosition = 0;
                c.ah.render(h);
                let i = d.findByClass(".ui-legend-item-badge");
                for (let j = 0; j < i.length; j++) {
                    i[j].removeClass("ui-legend-item-badge").addClass(this.a.r);
                }
                i = d.findByClass(".ui-legend-item-text");
                for (let k = 0; k < i.length; k++) {
                    if (this.a.k) {
                        i[k].setStyleProperty("white-space", "nowrap");
                    }
                    i[k].removeClass("ui-legend-item-text").addClass(this.a.u);
                }
            }
        }
        return d;
    }
    o(a, b) {
        let c = this.k(a, this.l);
        c.listen("mouseup", runOn(this.a, this.a.ae));
        c.listen("mousedown", runOn(this.a, this.a.ab));
        c.listen("mouseleave", runOn(this.a, this.a.ac));
        c.listen("mousemove", runOn(this.a, this.a.ad));
        this.f.addItem(a, c);
        if ((this.l.getChildCount() == 0) || (b >= this.l.getChildCount())) {
            this.l.append(c);
        }
        else {
            let d = this.l.getChildAt(b);
            d.before(c);
        }
    }
    w(a) {
    }
    x(a) {
        let b;
        if (((() => { let c = this.f.tryGetValue(a, b); b = c.p1; return c.ret; })())) {
            b.unlistenAll();
            b.remove();
            this.f.removeItem(a);
        }
    }
    n(visual_) {
        for (let pair_ of fromEnum(this.f)) {
            if (pair_.value.getNativeElement() === visual_) {
                return pair_.key;
            }
            ;
        }
        return null;
    }
    e(a) {
        for (let b of fromEnum(this.f.keys)) {
            let c = typeCast(ContentControl.$, b);
            if (c != null && c.content != null) {
                let d = typeCast(ILegendContext_$type, c.content);
                if (d != null && d.itemLabel == a.itemLabel && d.legendLabel == a.legendLabel && d.series == a.series && d.itemBrush == a.itemBrush) {
                    return true;
                }
            }
        }
        return false;
    }
    b(a) {
        let b = this.g.rootWrapper.width();
        let c = this.g.rootWrapper.height();
        this.l.remove();
        let d = this.g.createElement("div");
        d.setStyleProperty("position", "relative");
        this.m = this.g.createElement("<canvas style=\"position : absolute; top : 0; left : 0\" />");
        this.m.setStyleProperty("position", "absolute");
        this.m.setStyleProperty("top", "0px");
        this.m.setStyleProperty("left", "0px");
        this.g.append(d);
        d.append(this.m);
        this.c = new RenderingContext(new CanvasViewRenderer(), this.g.get2DCanvasContext(this.m));
        this.m.setAttribute("width", b.toString());
        this.m.setAttribute("height", c.toString());
        return this.c;
    }
    ab() {
        return new Size(1, this.g.rootWrapper.width(), Math.max(10, this.g.rootWrapper.height() - 15));
    }
    y(a, b, c, d) {
        let e = a.g();
        e.beginPath();
        e.moveTo(b.ak._inner[0].x, b.ak._inner[0].y);
        for (let f = 1; f < b.ak.count; f++) {
            e.lineTo(b.ak._inner[f].x, b.ak._inner[f].y);
        }
        e.lineTo(b.ak._inner[0].x, b.ak._inner[0].y);
        let g = e.createLinearGradient(d.left, d.top, d.left, d.top + d.height);
        for (let h of fromEnum(c.a)) {
            g.addColorStop(h.a, h.b._fill);
        }
        e.fillStyle = g;
        e.fill();
    }
    q() {
    }
    r() {
    }
    v(a) {
        let b = this.l == null ? 0 : this.l.getChildCount();
        for (let c = 0; c < b; c++) {
            let d = this.l.getChildAt(c);
            d.setStyleProperty("display", a ? "block" : "");
            d.setStyleProperty("float", a ? "left" : "");
            d.setStyleProperty("margin", a ? "0px" : "");
            d.setStyleProperty("margin-right", a ? "8px" : "");
            d.getChildAt(1).setStyleProperty("white-space", a ? "nowrap" : "");
        }
    }
    z(a) {
        this.l.setStyleProperty("color", a);
    }
    aa(a) {
        let b = FontUtil.getFontInfoFromString(this.g, a);
        this.l.setStyleProperty("font-family", b.n);
        this.l.setStyleProperty("font-size", b.d + "px");
        this.l.setStyleProperty("font-style", b.q);
    }
}
LegendBaseViewManager.$t = markType(LegendBaseViewManager, 'LegendBaseViewManager');
/**
 * @hidden
 */
class LegendBase extends ContentControl {
    constructor() {
        super();
        this.ak = null;
        this.at = null;
        this._seriesOwner = null;
        this._chartOwner = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.legendItemMouseLeftButtonDown = null;
        this.legendItemMouseLeftButtonUp = null;
        this.legendItemMouseEnter = null;
        this.legendItemMouseLeave = null;
        this.legendItemMouseMove = null;
        let a = this.aj();
        this.a8(a);
        a.ak();
        this.at = new ObservableCollection$1(UIElement.$, 0);
        this.aw = "ig-chart-legend-items-list";
        this.ax = "ig-chart-legend-item";
        this.av = "ig-chart-legend-item-badge";
        this.ay = "ig-chart-legend-item-text";
    }
    onDetachedFromUI() {
        this.ak.aj();
    }
    onAttachedToUI() {
        this.ak.ah();
    }
    aj() {
        return new LegendBaseView(this);
    }
    a8(a) {
        this.ak = a;
    }
    addChildInOrder(a, b) {
    }
    a0(a, b) {
    }
    get seriesOwner() {
        return this._seriesOwner;
    }
    set seriesOwner(a) {
        this._seriesOwner = a;
    }
    get chartOwner() {
        return this._chartOwner;
    }
    set chartOwner(a) {
        this._chartOwner = a;
    }
    get_isItemwise() {
        return false;
    }
    get isItemwise() {
        return this.get_isItemwise();
    }
    get_isScale() {
        return false;
    }
    get isScale() {
        return this.get_isScale();
    }
    clearLegendItemsForSeries(a) {
        if (a == null || this.at == null || this.at.count == 0) {
            return;
        }
        let b = new ObservableCollection$1(UIElement.$, 0);
        for (let c of fromEnum(this.at)) {
            let d = typeCast(ContentControl.$, c);
            if (d != null && d.content != null) {
                let e = typeCast(ILegendContext_$type, d.content);
                if (e != null && e.series == a) {
                    b.add(c);
                }
            }
        }
        for (let f of fromEnum(b)) {
            this.at.remove(f);
        }
    }
    containsChild(a) {
        return this.at.contains(a);
    }
    removeChild(a) {
        this.at.remove(a);
    }
    get ai() {
        if (this.seriesOwner != null) {
            return this.seriesOwner;
        }
        else {
            return this.chartOwner;
        }
    }
    a9(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    a5(a) {
        if (this.legendItemMouseLeftButtonDown != null) {
            this.legendItemMouseLeftButtonDown(this, a);
        }
    }
    a6(a) {
        if (this.legendItemMouseLeftButtonUp != null) {
            this.legendItemMouseLeftButtonUp(this, a);
        }
    }
    a3(a) {
        if (this.legendItemMouseEnter != null) {
            this.legendItemMouseEnter(this, a);
        }
    }
    a4(a) {
        if (this.legendItemMouseLeave != null) {
            this.legendItemMouseLeave(this, a);
        }
    }
    a7(a) {
        if (this.legendItemMouseMove != null) {
            this.legendItemMouseMove(this, a);
        }
    }
    provideContainer(a) {
        this.ak.ai(a);
    }
    get aw() {
        return this.ak.s;
    }
    set aw(a) {
        this.ak.s = a;
    }
    get ax() {
        return this.ak.t;
    }
    set ax(a) {
        this.ak.t = a;
    }
    get av() {
        return this.ak.r;
    }
    set av(a) {
        this.ak.r = a;
    }
    get ay() {
        return this.ak.u;
    }
    set ay(a) {
        this.ak.u = a;
    }
    exportVisualData() {
        return this.ak.f();
    }
    exportSerializedVisualData() {
        return this.exportVisualData().serialize();
    }
    get_isFinancial() {
        return false;
    }
    get isFinancial() {
        return this.get_isFinancial();
    }
}
LegendBase.$t = markType(LegendBase, 'LegendBase', ContentControl.$, [INotifyPropertyChanged_$type, IChartLegend_$type]);
/**
 * @hidden
 */
class LegendBaseView extends Base {
    constructor(a) {
        super();
        this.c = null;
        this.b = null;
        this.s = null;
        this.t = null;
        this.r = null;
        this.u = null;
        this.l = false;
        this.i = false;
        this.p = null;
        this.q = null;
        this.b = a;
        this.c = new LegendBaseViewManager(this);
    }
    aj() {
        this.c.u();
    }
    ah() {
        this.c.s();
    }
    ak() {
    }
    get_j() {
        return false;
    }
    get j() {
        return this.get_j();
    }
    d(a) {
        let b;
        let c;
        let d;
        let e = this.aa(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        let f = new MouseButtonEventArgs();
        let g = new LegendMouseButtonEventArgs(b, c, d, f, a);
        return g;
    }
    e(a) {
        let b;
        let c;
        let d;
        let e = this.aa(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        let f = new MouseEventArgs();
        let g = new LegendMouseEventArgs(b, c, d, f, a);
        return g;
    }
    aa(a, b, c, d) {
        b = this.b.ai;
        c = null;
        d = null;
        if (a != null) {
            let e = typeCast(ContentControl.$, a);
            if (e != null && e.content != null && typeCast(ILegendContext_$type, e.content) !== null) {
                let f = typeCast(ILegendContext_$type, e.content);
                c = typeCast(ILegendSeries_$type, f.series);
                if (c != null) {
                    b = c.container;
                }
                d = f.item;
            }
        }
        return {
            p1: b,
            p2: c,
            p3: d
        };
    }
    z() {
    }
    m() {
        return true;
    }
    y(a) {
    }
    am(a) {
    }
    ai(a) {
        this.c.t(a);
    }
    an(a) {
        this.c.x(a);
    }
    x(a) {
        let b = this.b.at.indexOf(a);
        this.c.o(a, b);
    }
    af() {
        this.c.q();
    }
    ag() {
        this.c.r();
    }
    get k() {
        return this.i;
    }
    set k(a) {
        this.i = a;
        this.c.v(this.i);
    }
    get v() {
        return this.p;
    }
    set v(a) {
        this.p = a;
        this.c.z(this.p);
    }
    get w() {
        return this.q;
    }
    set w(a) {
        this.q = a;
        this.c.aa(this.q);
    }
    al() {
        this.c.p();
    }
    n(e_) {
        let ev_ = e_.originalEvent;
        return ev_.currentTarget;
    }
    o(e_) {
        return this.c.n(this.n(e_));
    }
    ad(a) {
        if (!this.l) {
            this.b.a3(this.e(this.o(a)));
        }
        this.l = true;
    }
    ac(a) {
        if (this.l) {
            this.b.a4(this.e(this.o(a)));
        }
        this.l = false;
    }
    ab(a) {
        this.b.a5(this.d(this.o(a)));
    }
    ae(a) {
        this.b.a6(this.d(this.o(a)));
    }
    h(a) {
        let b = a.querySelectorAll("span *");
        let c = Rect.empty;
        for (let e = 0; e < b.length; e++) {
            let d = b[e];
            if (stringIsNullOrEmpty(d.getText())) {
                continue;
            }
            let f = new Rect(0, d.getOffset().left, d.getOffset().top, d.width(), d.height());
            f.union(c);
            c = f;
        }
        return RectData.b(c);
    }
    g(a) {
        let b = a.querySelectorAll("canvas");
        let c = b.length > 0 ? b[0] : null;
        return c != null ? new RectData(c.getOffset().left, c.getOffset().top, c.width(), c.height()) : null;
    }
    a(a) {
        if (this.b == null || this.b.at == null || this.b.at.count <= a) {
            return null;
        }
        let b = this.b.at._inner[a];
        if (b == null) {
            return null;
        }
        let c = b.content;
        if (c == null) {
            return null;
        }
        let d = c.actualItemBrush != null ? c.actualItemBrush : c.itemBrush;
        return AppearanceHelper.b(d);
    }
    f() {
        let a = new LegendVisualData();
        let b = this.c.l;
        let c = b.getChildCount();
        for (let d = 0; d < c; d++) {
            let e = new LegendItemVisualData();
            let f = b.getChildAt(d);
            e.label = f.getText();
            e.label = e.label != null ? e.label.trim() : null;
            e.bounds = new RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
            e.labelBounds = this.h(f);
            e.badgeBounds = this.g(f);
            a.items.add(e);
        }
        for (let g = 0; g < this.b.at.count; g++) {
            a.items._inner[g].appearance.fill = this.a(g);
        }
        return a;
    }
}
LegendBaseView.$t = markType(LegendBaseView, 'LegendBaseView');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendItemInfo extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.c = null;
        this.a = null;
        this.b = null;
    }
}
LegendItemInfo.$t = markType(LegendItemInfo, 'LegendItemInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Legend extends LegendBase {
    constructor() {
        super();
        this.ab = Legend.$;
        let a = this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    this.bc.an(c);
                }
            }
            if (b.newItems != null) {
                for (let d of fromEn(b.newItems)) {
                    this.bc.x(d);
                }
            }
        });
    }
    aj() {
        return new LegendView(this);
    }
    a8(a) {
        super.a8(a);
        this.bc = a;
    }
    bd(a) {
        return a.resolveLegendIndex();
    }
    bf(a) {
        return this.be(a);
    }
    addChildInOrder(a, b) {
        if (b.isStacked) {
            return;
        }
        if (!b.isUsableInLegend) {
            return;
        }
        let c = 0;
        for (let d of fromEnum(this.at)) {
            let e;
            let f;
            let g;
            let h = this.ak.aa(d, e, f, g);
            e = h.p1;
            f = h.p2;
            g = h.p3;
            if (b.container != null && e != null && (this.bf(b.container) < this.bf(e) || (this.bf(b.container) == -1 && this.bf(e) == -1 && Base.getHashCodeStatic(b.container) < Base.getHashCodeStatic(e)))) {
                break;
            }
            if (b.container != null && e != null && b.container == e && f != null) {
                let i = this.bd(b);
                let j = this.bd(f);
                let k = this.bf(b);
                let l = this.bf(f);
                if (f.isVertical && !f.isStacked) {
                    if (l == -1 && k == -1) {
                        c = 0;
                        break;
                    }
                    if (k < l || l == -1) {
                        break;
                    }
                }
                if (i <= j) {
                    break;
                }
            }
            c++;
        }
        this.at.insert(c, a);
        let m = new LegendItemInfo();
        m.c = a;
        m.a = b;
        let n = typeCast(ContentControl.$, a);
        if (n != null && n.content != null) {
            let o = typeCast(ILegendContext_$type, n.content);
            if (o != null) {
                m.b = o;
                m.d = o.itemLabel;
            }
        }
    }
    get bb() {
        return this.ak.k ? 0 : 0;
    }
    set bb(a) {
        this.ak.k = a == 0;
    }
    be(a) {
        return -1;
    }
    get bh() {
        return this.ak.v;
    }
    set bh(a) {
        this.ak.v = a;
    }
    get bi() {
        return this.ak.w;
    }
    set bi(a) {
        this.ak.w = a;
    }
}
Legend.$t = markType(Legend, 'Legend', LegendBase.$);
/**
 * @hidden
 */
class LegendView extends LegendBaseView {
    constructor(a) {
        super(a);
        this.ao = null;
        this.ao = a;
    }
    ak() {
        super.ak();
    }
}
LegendView.$t = markType(LegendView, 'LegendView', LegendBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxFinancialLegendComponent_1;
const IgxFinancialLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxFinancialLegendComponent) }];
/**
 * Represents a legend that displays information about each series, most often used in financial charting.
*/
let IgxFinancialLegendComponent = IgxFinancialLegendComponent_1 = class IgxFinancialLegendComponent extends IgxLegendBaseComponent {
    constructor(renderer, elRef, ngZone) {
        super();
        this.renderer = renderer;
        this.elRef = elRef;
        this.ngZone = ngZone;
        this._zoneRunner = (act) => this.ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(elRef.nativeElement, this.container);
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        this.i.provideContainer(ren);
    }
    ngOnDestroy() {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    }
    createImplementation() {
        return new Legend();
    }
    get i() {
        return this._implementation;
    }
    /**
 * Gets if the legend is a financial legend.
*/
    get isFinancial() {
        return this.i.isFinancial;
    }
};
IgxFinancialLegendComponent = IgxFinancialLegendComponent_1 = __decorate([
    Component({
        selector: 'igx-financial-legend',
        template: ``,
        providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxFinancialLegendComponent_1) }],
        host: { 'class': 'ig-financial-legend igx-financial-legend' },
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [`:host {
    display: block;
}
.ig-legend {
    border: none;
    border: var(--legend-border, none);
    overflow: auto;
    overflow: var(--legend-item-overflow, auto);
}
.ig-chart-legend-item-text {
    font: 12px Verdana, Arial, sans-serif;
    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);
    vertical-align: middle;
    vertical-align: var(--legend-item-vertical-align, middle);
}
.ig-chart-legend-items-list
{
    padding: 5px;
    padding: var(--legend-item-padding, 5px);
    margin: 0px;
    margin: var(--legend-item-margin, 0px);
    background-color: transparent;
    background-color: var(--legend-list-background-color, transparent);
}
.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas
{
    vertical-align: middle;
    vertical-align: var(--legend-item-badge-vertical-align, middle);
}
.ig-chart-legend-item
{
    background-color: transparent;
    background-color: var(--legend-item-background-color, transparent);
}`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ElementRef,
        NgZone])
], IgxFinancialLegendComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LegendTemplates extends Base {
    static d(a) {
        let b = a.data;
        let c = b.series;
        let d = c.legendItemBadgeTemplate;
        if (d == null) {
            d = LegendTemplates.ab(c.bj);
        }
        let e = c.fx;
        if (e == null) {
            e = "Series Title";
        }
        LegendItemHelper.d(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo, c.aw != null && c.aw.isFinancial, c.d8, c.et);
    }
    static resolveLegendItemTemplate(a) {
        switch (a) {
            case 0: return LegendTemplates.q;
            case 1: return LegendTemplates.r;
        }
        return LegendTemplates.q;
    }
    static b(a) {
        let b = a.data;
        let c = b.series;
        let d = c.legendItemBadgeTemplate;
        if (d == null) {
            d = LegendTemplates.ab(c.bj);
        }
        let e = b.itemLabel;
        if (e == null) {
            e = "Series Item";
        }
        LegendItemHelper.c(a.context, a.xPosition, a.yPosition, a.availableWidth, a.availableHeight, a.data, e.toString(), d, a.passInfo);
    }
    static h(a) {
        let b = a.data;
        let c = a.context;
        let d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.lb;
        }
        let e = new RenderingContext(new CanvasViewRenderer(), c);
        let f = new Line();
        f.ak = 0;
        f.am = a.availableHeight / 2;
        f.al = a.availableWidth;
        f.an = a.availableHeight / 2;
        f.ac = d.ey;
        f._stroke = b.actualItemBrush;
        f.ai = d.ll;
        e.r(f);
        let g = typeCast(MarkerSeries.$, b.series);
        if (g != null && g.mu != null && g.mu.render != null) {
            b.outline = g.m9;
            b.thickness = 2;
            LegendTemplates.n(g.mu, a);
        }
    }
    static n(a, b) {
        let c = new DataTemplateMeasureInfo();
        c.passInfo = b.passInfo;
        c.width = 11;
        c.height = 11;
        c.data = b.data;
        c.context = b.context;
        c.renderContext = b.renderContext;
        let d = b.data;
        let e = d.actualItemBrush;
        let f = d.itemBrush;
        if (typeCast(Series.$, d.series) !== null) {
            if (d.itemBrush == null) {
                let g = d.series;
                d.actualItemBrush = g.lg();
            }
        }
        if (a.measure != null) {
            a.measure(c);
            if (isNaN_(c.width) || isInfinity(c.width) || c.width > 11) {
                c.width = 11;
            }
            if (isNaN_(c.height) || isInfinity(c.height) || c.height > 11) {
                c.height = 11;
            }
        }
        let h = new DataTemplateRenderInfo();
        h.passInfo = b.passInfo;
        h.availableWidth = c.width;
        h.availableHeight = c.height;
        h.xPosition = b.availableWidth / 2;
        h.yPosition = b.availableHeight / 2;
        h.data = b.data;
        h.context = b.context;
        h.renderContext = b.renderContext;
        a.render(h);
        d.itemBrush = f;
        d.actualItemBrush = e;
    }
    static p(a) {
        let b = null;
        if (typeCast(Series.$, a.series) !== null) {
            b = a.series;
        }
        if (a.itemBrush != null) {
            a.actualItemBrush = a.itemBrush;
        }
        else {
            if (b != null) {
                a.actualItemBrush = b.lb;
            }
            else {
                a.actualItemBrush = a.itemBrush;
            }
        }
    }
    static c(a) {
    }
    static a(a) {
    }
    static g(a) {
    }
    static m(a) {
        let b = a.data;
        let c = a.context;
        LegendTemplates.p(b);
        let d = new RenderingContext(new CanvasViewRenderer(), c);
        let e = new Path();
        let f = new PathGeometry();
        let g = new PathFigure();
        g._isFilled = true;
        let h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.lc;
            e.ai = b.series.ll;
        }
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        g._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        d.s(e);
        let i = typeCast(MarkerSeries.$, b.series);
        if (i != null && i.mu != null && i.mu.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.lc;
            }
            LegendTemplates.n(i.mu, a);
        }
    }
    static j(a) {
        let b = a.data;
        let c = a.context;
        LegendTemplates.p(b);
        let d = new Path();
        let e = new PathGeometry();
        let f = new PathFigure();
        let g = 0;
        if (typeCast(Series.$, b.series) !== null) {
            g = b.series.ey / 2;
            d.ac = b.series.ey;
            d._stroke = b.series.lc;
            d.ai = b.series.ll;
        }
        f._isFilled = true;
        f._startPoint = { $type: Point_$type, x: g, y: 5 };
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: g, y: 14 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        f._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: g }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: g }));
        f._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: g, y: 5 };
            return $ret;
        })()));
        e.c.add(f);
        d.ak = e;
        d._fill = b.actualItemBrush;
        let h = new RenderingContext(new CanvasViewRenderer(), c);
        h.s(d);
    }
    static i(a) {
        let b = a.data;
        let c = a.context;
        let d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.lb;
        }
        let e = new Line();
        e.ak = 0;
        e.am = a.availableHeight / 2;
        e.al = a.availableWidth;
        e.an = a.availableHeight / 2;
        e.ac = d.ey;
        e.ai = d.ll;
        e._stroke = b.actualItemBrush;
        let f = new RenderingContext(new CanvasViewRenderer(), c);
        f.r(e);
    }
    static k(a) {
        let b = a.data;
        LegendTemplates.p(b);
        let c = typeCast(MarkerSeries.$, b.series);
        if (c != null && c.mu != null && c.mu.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.lh();
            }
            LegendTemplates.n(c.mu, a);
        }
    }
    static l(a) {
        let b = a.data;
        let c = a.context;
        let d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.lb;
        }
        let e = new Path();
        let f = new PathGeometry();
        let g = new PathFigure();
        let h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.lc;
            e.ai = b.series.ll;
        }
        g._isFilled = true;
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        let i = new Path();
        let j = new PathGeometry();
        let k = new PathFigure();
        let l = 0;
        let m = null;
        if (typeCast(Series.$, b.series) !== null) {
            l = b.series.ey / 2;
            i.ac = b.series.ey;
            i._stroke = b.series.lc;
            m = b.series.lj();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        let n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
        let o = typeCast(MarkerSeries.$, b.series);
        if (o != null && o.mu != null && o.mu.render != null) {
            if (typeCast(Series.$, b.series) !== null) {
                b.outline = b.series.lc;
            }
            LegendTemplates.n(o.mu, a);
        }
    }
    static e(a) {
        let b = a.data;
        let c = a.context;
        let d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.lb;
        }
        let e = new Path();
        let f = new PathGeometry();
        let g = 0;
        if (typeCast(Series.$, b.series) !== null) {
            g = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.lc;
            e.ai = b.series.ll;
        }
        let h = new PathFigure();
        h._isFilled = true;
        h._startPoint = { $type: Point_$type, x: g, y: 5 };
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: g, y: 14 }));
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: g }));
        h._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: g }));
        h._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: g, y: 5 };
            return $ret;
        })()));
        f.c.add(h);
        e.ak = f;
        e._fill = b.actualItemBrush;
        let i = new Path();
        let j = new PathGeometry();
        let k = new PathFigure();
        let l = 0;
        let m = null;
        if (typeCast(Series.$, b.series) !== null) {
            i.ac = b.series.ey;
            i._stroke = b.series.lc;
            i.ai = b.series.ll;
            m = b.series.lj();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        let n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
    }
    static f(a) {
        let b = a.data;
        let c = a.context;
        let d = b.series;
        if (b.itemBrush != null) {
            b.actualItemBrush = b.itemBrush;
        }
        else {
            b.actualItemBrush = d.lb;
        }
        let e = new Path();
        let f = new PathGeometry();
        let g = new PathFigure();
        let h = 0;
        if (typeCast(Series.$, b.series) !== null) {
            h = b.series.ey / 2;
            e.ac = b.series.ey;
            e._stroke = b.series.lc;
            e.ai = b.series.ll;
        }
        g._isFilled = true;
        g._startPoint = { $type: Point_$type, x: h, y: 5 };
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: h, y: 14 }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: h }));
        g._segments.add(new LineSegment(0, { $type: Point_$type, x: 5, y: h }));
        g._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: h, y: 5 };
            return $ret;
        })()));
        f.c.add(g);
        e.ak = f;
        e._fill = b.actualItemBrush;
        let i = new Path();
        let j = new PathGeometry();
        let k = new PathFigure();
        let l = 0;
        let m = null;
        if (typeCast(Series.$, b.series) !== null) {
            l = b.series.ey / 2;
            i.ac = b.series.ey;
            i._stroke = b.series.lc;
            i.ai = b.series.ll;
            m = b.series.lj();
        }
        k._isFilled = true;
        k._startPoint = { $type: Point_$type, x: l, y: 14 };
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 11, y: 14 }));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.f = new Size(1, 5, 5);
            $ret.b = false;
            $ret.e = { $type: Point_$type, x: 16, y: 9 };
            return $ret;
        })()));
        k._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: l }));
        j.c.add(k);
        i.ak = j;
        if (m != null) {
            i._fill = m;
        }
        let n = new RenderingContext(new CanvasViewRenderer(), c);
        n.s(e);
        n.s(i);
    }
    static o(a) {
        let b = a.data;
        let c = a.context;
        LegendTemplates.p(b);
        let d = typeCast(Series.$, b.series) !== null ? b.series : null;
        if (d != null) {
            b.outline = d.lc;
        }
        let e = new PathGeometry();
        let f = ((() => {
            let $ret = new PathFigure();
            $ret.isClosed = true;
            $ret.isFilled = true;
            return $ret;
        })());
        f._startPoint = { $type: Point_$type, x: 0, y: 0 };
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: 0 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 16, y: 16 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 0, y: 16 }));
        f._segments.add(new LineSegment(0, { $type: Point_$type, x: 0, y: 0 }));
        e.c.add(f);
        let g = ((() => {
            let $ret = new Path();
            $ret.ak = e;
            $ret.fill = b.actualItemBrush;
            return $ret;
        })());
        let h = new RenderingContext(new CanvasViewRenderer(), c);
        h.s(g);
        h.r(((() => {
            let $ret = new Line();
            $ret.ak = 8;
            $ret.al = 8;
            $ret.am = 0;
            $ret.an = 16;
            $ret.stroke = b.outline;
            $ret.ac = 2;
            return $ret;
        })()));
    }
    static ab(a) {
        switch (a) {
            case 0: return LegendTemplates.u;
            case 1: return LegendTemplates.z;
            case 4: return LegendTemplates.x;
            case 6: return LegendTemplates.s;
            case 7: return LegendTemplates.t;
            case 2: return LegendTemplates.v;
            case 3: return LegendTemplates.w;
            case 5: return LegendTemplates.y;
            case 8: return LegendTemplates.aa;
        }
        return LegendTemplates.z;
    }
}
LegendTemplates.$t = markType(LegendTemplates, 'LegendTemplates');
LegendTemplates.q = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.d;
    return $ret;
})());
LegendTemplates.r = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.a;
    $ret.render = LegendTemplates.b;
    return $ret;
})());
LegendTemplates.u = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.h;
    return $ret;
})());
LegendTemplates.z = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.m;
    return $ret;
})());
LegendTemplates.x = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.k;
    return $ret;
})());
LegendTemplates.s = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.e;
    return $ret;
})());
LegendTemplates.t = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.f;
    return $ret;
})());
LegendTemplates.v = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.j;
    return $ret;
})());
LegendTemplates.w = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.i;
    return $ret;
})());
LegendTemplates.y = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.l;
    return $ret;
})());
LegendTemplates.aa = ((() => {
    let $ret = new DataTemplate();
    $ret.measure = LegendTemplates.c;
    $ret.render = LegendTemplates.o;
    return $ret;
})());

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialLegendViewManager extends LegendBaseViewManager {
    constructor(a) {
        super(a);
    }
    i() {
        if (this.g == null) {
            return null;
        }
        let a = this.g.createElement("div");
        return a;
    }
    h() {
        if (this.g == null) {
            return null;
        }
        let a = this.g.createElement("span");
        a.setStyleProperty("display", "inline-block");
        a.setStyleProperty("padding", "5px 2px 5px 2px");
        a.setStyleProperty("margin", "2px");
        return a;
    }
}
FinancialLegendViewManager.$t = markType(FinancialLegendViewManager, 'FinancialLegendViewManager', LegendBaseViewManager.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialLegend extends LegendBase {
    constructor() {
        super();
        this.ab = FinancialLegend.$;
        let a = this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    this.bb.an(c);
                }
            }
            if (b.newItems != null) {
                for (let d of fromEn(b.newItems)) {
                    this.bb.x(d);
                }
            }
        });
    }
    aj() {
        return new FinancialLegendView(this);
    }
    get bb() {
        return this.ak;
    }
    addChildInOrder(a, b) {
        this.at.add(a);
    }
    get_isFinancial() {
        return true;
    }
}
FinancialLegend.$t = markType(FinancialLegend, 'FinancialLegend', LegendBase.$);
/**
 * @hidden
 */
class FinancialLegendView extends LegendBaseView {
    constructor(a) {
        super(a);
        this.c = new FinancialLegendViewManager(this);
    }
}
FinancialLegendView.$t = markType(FinancialLegendView, 'FinancialLegendView', LegendBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialLegendModule = class IgxFinancialLegendModule {
    constructor() {
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        TypeRegistrar.register('FinancialLegend', FinancialLegend.$type);
    }
};
IgxFinancialLegendModule = __decorate([
    NgModule({
        declarations: [IgxFinancialLegendComponent],
        exports: [IgxFinancialLegendComponent
        ],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialLegendModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialLegendDynamicModule = class IgxFinancialLegendDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxFinancialLegendComponent', IgxFinancialLegendComponent);
        TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
        TypeRegistrar.registerCons('FinancialLegend', FinancialLegend);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
        TypeRegistrar.register('FinancialLegend', FinancialLegend.$type);
    }
};
IgxFinancialLegendDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxFinancialLegendModule
        ],
        imports: [CommonModule, IgxFinancialLegendModule
        ],
        entryComponents: [IgxFinancialLegendComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxFinancialLegendDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialChartModule = class IgxFinancialChartModule {
};
IgxFinancialChartModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxFinancialChartCoreModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxCategoryXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxPercentChangeYAxisDynamicModule,
            IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartCategoryTrendLineModule,
            IgxIndicatorsDynamicModule,
            IgxOverlaysDynamicModule,
            IgxZoomSliderDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorModule,
            IgxDataChartInteractivityModule,
            IgxDataChartAnnotationModule,
            IgxFinancialLegendModule
        ],
        imports: [CommonModule, IgxFinancialChartCoreModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxCategoryXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxPercentChangeYAxisDynamicModule,
            IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartCategoryTrendLineModule,
            IgxIndicatorsDynamicModule,
            IgxOverlaysDynamicModule,
            IgxZoomSliderDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorModule,
            IgxDataChartInteractivityModule,
            IgxDataChartAnnotationModule,
            IgxFinancialLegendModule
        ],
        entryComponents: []
    })
], IgxFinancialChartModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxFinancialChartDynamicModule = class IgxFinancialChartDynamicModule {
};
IgxFinancialChartDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxFinancialChartCoreDynamicModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxCategoryXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxPercentChangeYAxisDynamicModule,
            IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartCategoryTrendLineDynamicModule,
            IgxIndicatorsDynamicModule,
            IgxOverlaysDynamicModule,
            IgxZoomSliderDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxDataChartAnnotationDynamicModule,
            IgxFinancialLegendDynamicModule,
            IgxFinancialChartModule
        ],
        imports: [CommonModule, IgxFinancialChartCoreDynamicModule,
            IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxCategoryXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxPercentChangeYAxisDynamicModule,
            IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartCategoryTrendLineDynamicModule,
            IgxIndicatorsDynamicModule,
            IgxOverlaysDynamicModule,
            IgxZoomSliderDynamicModule,
            IgxCrosshairLayerDynamicModule,
            IgxCalloutLayerDynamicModule,
            IgxItemToolTipLayerDynamicModule,
            IgxCategoryToolTipLayerDynamicModule,
            IgxCategoryHighlightLayerDynamicModule,
            IgxCategoryItemHighlightLayerDynamicModule,
            IgxFinalValueLayerDynamicModule,
            IgxNumberAbbreviatorDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxDataChartAnnotationDynamicModule,
            IgxFinancialLegendDynamicModule,
            IgxFinancialChartModule
        ],
        entryComponents: []
    })
], IgxFinancialChartDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ITimeXAxis_$type = new Type(null, 'ITimeXAxis');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TemplatePicker extends Base {
    static a(a, b) {
        if (a != null) {
            return a;
        }
        return a;
    }
}
TemplatePicker.$t = markType(TemplatePicker, 'TemplatePicker');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenuItem extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.c = 0;
        this.f = null;
        this.g = null;
        this.a = false;
        this.propertyChanged = null;
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.b;
        if (a != b) {
            this.a = a;
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs("IsChecked"));
            }
        }
    }
}
FinancialChartIndicatorMenuItem.$t = markType(FinancialChartIndicatorMenuItem, 'FinancialChartIndicatorMenuItem', Base.$, [INotifyPropertyChanged_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartIndicatorMenuItems extends List$1 {
    constructor(a) {
        super(FinancialChartIndicatorMenuItem.$, 0);
        this.ak = null;
        this.ac = null;
        this.ad = null;
        this.ae = null;
        this.af = null;
        this.ak = a;
        this.am(FinancialOverlayType_$type, this.al("FinancialChart_IndicatorMenu_OverlaysCategoryHeader", "Overlays"));
        this.am(TrendLineType_$type, this.al("FinancialChart_IndicatorMenu_TrendlinesCategoryHeader", "Trendlines"));
        this.am(FinancialChartVolumeType_$type, this.al("FinancialChart_IndicatorMenu_VolumeCategoryHeader", "Volume"));
        this.am(FinancialIndicatorType_$type, this.al("FinancialChart_IndicatorMenu_IndicatorsCategoryHeader", "Standalone Indicators"));
    }
    al(a, b) {
        let c = this.ak.b1(a);
        return stringIsNullOrEmpty(c) ? b : c;
    }
    am($t, a) {
        this.add(((() => {
            let $ret = new FinancialChartIndicatorMenuItem();
            $ret.d = a;
            $ret.f = a;
            return $ret;
        })()));
        this.an($t);
    }
    an($t) {
        let a = new List$1(Base.$, 0);
        let b = new Dictionary$2(Base.$, String_$type, 0);
        let c = new Dictionary$2(Base.$, Type.$, 0);
        let d = (e) => {
            for (let f = 0; f < e.a; f++) {
                let g = typeGetValue(e.b(f));
                a.add1(g);
                let h = e.c(g);
                b.addItem(g, h);
                c.addItem(g, $t);
            }
        };
        if ($t == FinancialOverlayType_$type) {
            d(this.ah);
        }
        else if ($t == TrendLineType_$type) {
            d(this.ai);
        }
        else if ($t == FinancialIndicatorType_$type) {
            d(this.ag);
        }
        else if ($t == FinancialChartVolumeType_$type) {
            d(this.aj);
        }
        else {
            let e = EnumUtil.getNames($t);
            let f = EnumUtil.getValues($t);
            for (let g = 0; g < f.length; g++) {
                let h;
                let i;
                h = f[g];
                i = e[g];
                i = i.charAt(0).toUpperCase() + i.substr(1);
                if (i == "None") {
                    continue;
                }
                a.add1(h);
                b.addItem(h, i);
                c.addItem(h, $t);
            }
        }
        for (let j of fromEnum(a)) {
            this.add(((() => {
                let $ret = new FinancialChartIndicatorMenuItem();
                $ret.d = j;
                $ret.f = b.containsKey(j) ? b.item(j) : j.toString();
                $ret.c = 1;
                $ret.g = c.containsKey(j) ? c.item(j) : null;
                return $ret;
            })()));
        }
    }
    get ag() {
        if (this.ac == null) {
            this.ao();
        }
        return this.ac;
    }
    ao() {
        this.ac = ((() => {
            let $ret = new OrderedDictionary$2(FinancialIndicatorType_$type, String_$type);
            $ret.addItem(0, this.al("FinancialChart_IndicatorsMenu_Indicator_AbsoluteVolumeOscillator", "Absolute Volume Oscillator"));
            $ret.addItem(1, this.al("FinancialChart_IndicatorsMenu_Indicator_AccumulationDistribution", "Accumulation Distribution"));
            $ret.addItem(2, this.al("FinancialChart_IndicatorsMenu_Indicator_AverageDirectionalIndex", "Average Directional Index"));
            $ret.addItem(3, this.al("FinancialChart_IndicatorsMenu_Indicator_AverageTrueRange", "Average True Range"));
            $ret.addItem(4, this.al("FinancialChart_IndicatorsMenu_Indicator_BollingerBandWidth", "Bollinger Band Width"));
            $ret.addItem(5, this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinOscillator", "Chaikin Oscillator"));
            $ret.addItem(6, this.al("FinancialChart_IndicatorsMenu_Indicator_ChaikinVolatility", "Chaikin Volatility"));
            $ret.addItem(7, this.al("FinancialChart_IndicatorsMenu_Indicator_CommodityChannelIndex", "Commodity Channel Index"));
            $ret.addItem(8, this.al("FinancialChart_IndicatorsMenu_Indicator_DetrendedPriceOscillator", "Detrended Price Oscillator"));
            $ret.addItem(9, this.al("FinancialChart_IndicatorsMenu_Indicator_EaseOfMovement", "Ease Of Movement"));
            $ret.addItem(10, this.al("FinancialChart_IndicatorsMenu_Indicator_FastStochasticOscillator", "Fast Stochastic Oscillator"));
            $ret.addItem(11, this.al("FinancialChart_IndicatorsMenu_Indicator_ForceIndex", "Force Index"));
            $ret.addItem(12, this.al("FinancialChart_IndicatorsMenu_Indicator_FullStochasticOscillator", "Full Stochastic Oscillator"));
            $ret.addItem(13, this.al("FinancialChart_IndicatorsMenu_Indicator_MarketFacilitationIndex", "Market Facilitation Index"));
            $ret.addItem(14, this.al("FinancialChart_IndicatorsMenu_Indicator_MassIndex", "Mass Index"));
            $ret.addItem(15, this.al("FinancialChart_IndicatorsMenu_Indicator_MedianPrice", "Median Price"));
            $ret.addItem(16, this.al("FinancialChart_IndicatorsMenu_Indicator_MoneyFlowIndex", "Money Flow Index"));
            $ret.addItem(17, this.al("FinancialChart_IndicatorsMenu_Indicator_MovingAverageConvergenceDivergence", "MACD"));
            $ret.addItem(18, this.al("FinancialChart_IndicatorsMenu_Indicator_NegativeVolumeIndex", "Negative Volume Index"));
            $ret.addItem(19, this.al("FinancialChart_IndicatorsMenu_Indicator_OnBalanceVolume", "On Balance Volume"));
            $ret.addItem(20, this.al("FinancialChart_IndicatorsMenu_Indicator_PercentagePriceOscillator", "Percentage Price Oscillator"));
            $ret.addItem(21, this.al("FinancialChart_IndicatorsMenu_Indicator_PercentageVolumeOscillator", "Percentage Volume Oscillator"));
            $ret.addItem(22, this.al("FinancialChart_IndicatorsMenu_Indicator_PositiveVolumeIndex", "Positive Volume Index"));
            $ret.addItem(23, this.al("FinancialChart_IndicatorsMenu_Indicator_PriceVolumeTrend", "Price Volume Trend"));
            $ret.addItem(24, this.al("FinancialChart_IndicatorsMenu_Indicator_RateOfChangeAndMomentum", "ROC"));
            $ret.addItem(25, this.al("FinancialChart_IndicatorsMenu_Indicator_RelativeStrengthIndex", "RSI"));
            $ret.addItem(26, this.al("FinancialChart_IndicatorsMenu_Indicator_SlowStochasticOscillator", "Slow Stochastic Oscillator"));
            $ret.addItem(27, this.al("FinancialChart_IndicatorsMenu_Indicator_StandardDeviation", "Standard Deviation"));
            $ret.addItem(28, this.al("FinancialChart_IndicatorsMenu_Indicator_StochRSI", "Stoch RSI"));
            $ret.addItem(29, this.al("FinancialChart_IndicatorsMenu_Indicator_TRIX", "TRIX"));
            $ret.addItem(30, this.al("FinancialChart_IndicatorsMenu_Indicator_TypicalPrice", "Typical Price"));
            $ret.addItem(31, this.al("FinancialChart_IndicatorsMenu_Indicator_UltimateOscillator", "Ultimate Oscillator"));
            $ret.addItem(32, this.al("FinancialChart_IndicatorsMenu_Indicator_WeightedClose", "Weighted Close"));
            $ret.addItem(33, this.al("FinancialChart_IndicatorsMenu_Indicator_WilliamsPercentR", "Williams %R"));
            return $ret;
        })());
    }
    get ah() {
        if (this.ad == null) {
            this.ap();
        }
        return this.ad;
    }
    ap() {
        this.ad = ((() => {
            let $ret = new OrderedDictionary$2(FinancialOverlayType_$type, String_$type);
            $ret.addItem(0, this.al("FinancialChart_IndicatorsMenu_Overlay_BollingerBands", "Bollinger Bands"));
            $ret.addItem(1, this.al("FinancialChart_IndicatorsMenu_Overlay_PriceChannel", "Price Channel"));
            return $ret;
        })());
    }
    get ai() {
        if (this.ae == null) {
            this.aq();
        }
        return this.ae;
    }
    aq() {
        this.ae = ((() => {
            let $ret = new OrderedDictionary$2(TrendLineType_$type, String_$type);
            $ret.addItem(1, this.al("FinancialChart_IndicatorsMenu_TrendLine_LinearFit", "Linear Fit"));
            $ret.addItem(2, this.al("FinancialChart_IndicatorsMenu_TrendLine_QuadraticFit", "Quadratic Fit"));
            $ret.addItem(3, this.al("FinancialChart_IndicatorsMenu_TrendLine_CubicFit", "Cubic Fit"));
            $ret.addItem(4, this.al("FinancialChart_IndicatorsMenu_TrendLine_QuarticFit", "Quartic Fit"));
            $ret.addItem(5, this.al("FinancialChart_IndicatorsMenu_TrendLine_QuinticFit", "Quintic Fit"));
            $ret.addItem(6, this.al("FinancialChart_IndicatorsMenu_TrendLine_LogarithmicFit", "Logarithmic Fit"));
            $ret.addItem(7, this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialFit", "Exponential Fit"));
            $ret.addItem(8, this.al("FinancialChart_IndicatorsMenu_TrendLine_PowerLawFit", "Power LawFit"));
            $ret.addItem(9, this.al("FinancialChart_IndicatorsMenu_TrendLine_SimpleAverage", "Simple Average"));
            $ret.addItem(10, this.al("FinancialChart_IndicatorsMenu_TrendLine_ExponentialAverage", "Exponential Average"));
            $ret.addItem(11, this.al("FinancialChart_IndicatorsMenu_TrendLine_ModifiedAverage", "Modified Average"));
            $ret.addItem(12, this.al("FinancialChart_IndicatorsMenu_TrendLine_CumulativeAverage", "Cumulative Average"));
            $ret.addItem(13, this.al("FinancialChart_IndicatorsMenu_TrendLine_WeightedAverage", "Weighted Average"));
            return $ret;
        })());
    }
    get aj() {
        if (this.af == null) {
            this.ar();
        }
        return this.af;
    }
    ar() {
        this.af = ((() => {
            let $ret = new OrderedDictionary$2(FinancialChartVolumeType_$type, String_$type);
            $ret.addItem(3, this.al("FinancialChart_IndicatorsMenu_Volume_Area", "Area"));
            $ret.addItem(1, this.al("FinancialChart_IndicatorsMenu_Volume_Column", "Column"));
            $ret.addItem(2, this.al("FinancialChart_IndicatorsMenu_Volume_Line", "Line"));
            return $ret;
        })());
    }
}
FinancialChartIndicatorMenuItems.$t = markType(FinancialChartIndicatorMenuItems, 'FinancialChartIndicatorMenuItems', List$1.$.specialize(FinancialChartIndicatorMenuItem.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FinancialChartEnumCollectionPickerVisualData extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.k = 0;
        this.l = 0;
        this.m = 0;
        this.j = 0;
        this.f = 0;
        this.g = 0;
        this.h = 0;
        this.e = 0;
        this.n = 0;
        this.i = 0;
        this.d = false;
        this.c = false;
    }
    o() {
        return FinancialChartVisualData.y(["items", "selectedItems", "pickerLeft", "pickerTop", "pickerWidth", "pickerHeight", "buttonLeft", "buttonTop", "buttonWidth", "buttonHeight", "width", "height", "isVisible", "isPickerVisible"], [this.a, this.b, this.k, this.l, this.m, this.j, this.f, this.g, this.h, this.e, this.n, this.i, this.d, this.c]);
    }
}
FinancialChartEnumCollectionPickerVisualData.$t = markType(FinancialChartEnumCollectionPickerVisualData, 'FinancialChartEnumCollectionPickerVisualData');

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
class IgxPlotAreaMouseButtonEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get chartPosition() {
        return fromPoint(this.i.chartPosition);
    }
    set chartPosition(v) {
        this.i.chartPosition = toPoint(v);
    }
    get plotAreaPosition() {
        return fromPoint(this.i.plotAreaPosition);
    }
    set plotAreaPosition(v) {
        this.i.plotAreaPosition = toPoint(v);
    }
    get manipulationOccurred() {
        return this.i.manipulationOccurred;
    }
    set manipulationOccurred(v) {
        this.i.manipulationOccurred = ensureBool(v);
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get viewer() {
        if (this.i.viewer == null) {
            return null;
        }
        return this.i.viewer.externalObject;
    }
    set viewer(v) {
        v == null ? this.i.viewer = null : this.i.viewer = v.i;
    }
}

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
class IgxPlotAreaMouseEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get chartPosition() {
        return fromPoint(this.i.chartPosition);
    }
    set chartPosition(v) {
        this.i.chartPosition = toPoint(v);
    }
    get plotAreaPosition() {
        return fromPoint(this.i.plotAreaPosition);
    }
    set plotAreaPosition(v) {
        this.i.plotAreaPosition = toPoint(v);
    }
    get isDuringManipulation() {
        return this.i.isDuringManipulation;
    }
    set isDuringManipulation(v) {
        this.i.isDuringManipulation = ensureBool(v);
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get viewer() {
        if (this.i.viewer == null) {
            return null;
        }
        return this.i.viewer.externalObject;
    }
    set viewer(v) {
        v == null ? this.i.viewer = null : this.i.viewer = v.i;
    }
}

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
class IgxChartCursorEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the series associated with the current event.
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get seriesViewer() {
        if (this.i.seriesViewer == null) {
            return null;
        }
        return this.i.seriesViewer.externalObject;
    }
    set seriesViewer(v) {
        v == null ? this.i.seriesViewer = null : this.i.seriesViewer = v.i;
    }
    /**
     * Provides a human readable expresion of the event arguments.
    
    */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*
* `DataChartMouseButtonEventHandler` class represents the method that will handle IgxDataChartComponent mouse button related events.
*
* ```html
*  <igx-data-chart  #chart
*       [dataSource]="data"
* 	  (seriesMouseLeftButtonDown)="chart_seriesMouseLeftButtonDown()">
*       <igx-category-x-axis
*         label="label"
*         #xAxis
*         >
*       </igx-category-x-axis>
*       <igx-numeric-y-axis
*         minimumValue="0"
*         #yAxis>
*       </igx-numeric-y-axis>
*
*       <igx-column-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*       </igx-column-series>
*     </igx-data-chart>
* ```
*
* ```ts
* this.chart.seriesMouseLeftButtonDown.subscribe(this.chart_seriesMouseLeftButtonDown);
* chart_seriesMouseLeftButtonDown(sender :any,args: DataChartMouseButtonEventArgs )
*   {
*   }
* ```
*/
class IgxDataChartMouseButtonEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets a value that indicates the present state of the event handling for a routed
     * event as it travels the route.
     * ChartMouseButton events are not routed events; setting this property effects the underlying
     * MouseButtonEvent.
    *
    * Use the `handled` property to indicates the present state of the event handling for a routed event.
    */
    get handled() {
        return this.i.handled;
    }
    set handled(v) {
        this.i.handled = ensureBool(v);
    }
    /**
     * Gets a reference to the object that raised the event.
    *
    * Use the `originalSource` property for the raised object event.
    *
    * ```ts
    * args.originalSource;
    * ```
    */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
     * Gets the ItemsSource item associated with the current event.
    *
    * Use the `item` property to get the ItemsSource item associated with the current event.
    *
    * ```ts
    * var item1= args.item;
    * ```
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the series associated with the current event.
    *
    * Use the `series` property for the associated current event.
    *
    * ```ts
    *  var DataSeries= args.series;
    * ```
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * Gets the Chart associated with the current event.
    *
    * Use the `chart` property to get the chart associated with the current event.
    *
    * ```ts
    * var dataChart=  args.chart;
    * ```
    */
    get chart() {
        if (this.i.chart == null) {
            return null;
        }
        return this.i.chart.externalObject;
    }
    set chart(v) {
        v == null ? this.i.chart = null : this.i.chart = v.i;
    }
    /**
     * Provides a human readable description of the mouse button event.
    
    *
    * Use the `toString` property to provides a human readable discription.
    *
    * ```ts
    *   var item= args.item.label.toString();
    * ```
    */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    *
    * To get mouse X and Y position.
    *
    * ```ts
    *    var args.getPosition;
    * ```
    */
    getPosition(relativeTo) {
        let iv = this.i.getPosition(relativeTo);
        return fromPoint(iv);
    }
}

/**
 * Provides data for IgxDataChartComponent mouse button related events.
*/
class IgxChartMouseEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the series associated with the current event.
    */
    get series() {
        if (this.i.series == null) {
            return null;
        }
        if (!this.i.series.externalObject) {
            let e = IgxSeriesComponent._createFromInternal(this.i.series);
            if (e) {
                e._implementation = this.i.series;
            }
            this.i.series.externalObject = e;
        }
        return this.i.series.externalObject;
    }
    set series(v) {
        v == null ? this.i.series = null : this.i.series = v.i;
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get chart() {
        if (this.i.chart == null) {
            return null;
        }
        return this.i.chart.externalObject;
    }
    set chart(v) {
        v == null ? this.i.chart = null : this.i.chart = v.i;
    }
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
    /**
     * Returns the x- and y- coordinates of the mouse pointer position, optionally evaluated
     * against the origin of a supplied UIElement.
    
    * @param relativeTo  * Any UIElement derived object that is contained by the the engine plug-in
     * and connected to the object tree. To specify the object relative to the overall the engine
     * coordinate system, use a relativeTo value of null.
    */
    getPosition(relativeTo) {
        let iv = this.i.getPosition(relativeTo);
        return fromPoint(iv);
    }
}

class IgxSeriesViewerManipulationEventArgs {
    createImplementation() {
        return new SeriesViewerManipulationEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get isZoomPan() {
        return this.i.isZoomPan;
    }
    set isZoomPan(v) {
        this.i.isZoomPan = ensureBool(v);
    }
    get isDragZoom() {
        return this.i.isDragZoom;
    }
    set isDragZoom(v) {
        this.i.isDragZoom = ensureBool(v);
    }
}

class IgxRefreshCompletedEventArgs {
    createImplementation() {
        return new RefreshCompletedEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
}

/**
 * Represents a control for viewing series objects.
*/
const IgxSeriesViewerComponent_PROVIDERS = [];
class IgxSeriesViewerComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._plotAreaMouseLeftButtonDown = null;
        this._plotAreaMouseLeftButtonUp = null;
        this._plotAreaClicked = null;
        this._plotAreaMouseEnter = null;
        this._plotAreaMouseLeave = null;
        this._plotAreaMouseOver = null;
        this._seriesCursorMouseMove = null;
        this._seriesMouseLeftButtonDown = null;
        this._seriesMouseLeftButtonUp = null;
        this._seriesMouseMove = null;
        this._seriesMouseEnter = null;
        this._seriesMouseLeave = null;
        this._viewerManipulationStarting = null;
        this._viewerManipulationEnding = null;
        this._windowRectChanged = null;
        this._sizeChanged = null;
        this._actualWindowRectChanged = null;
        this._gridAreaRectChanged = null;
        this._refreshCompleted = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets or sets the cross hair point (in world coordinates)
     * Either or both of the crosshair point's X and Y may be set to double.NaN, in which
     * case the relevant crosshair line is hidden.
    *
    * The `crosshairPoint` property is used to gets/sets the cross hair point (in world coordinates).
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     crosshairVisibility="visible"
    *     crosshairPoint={x:.8,y:.2}>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.crosshairPoint = {x:.8,y:.2};
    * ```
    */
    get crosshairPoint() {
        return fromPoint(this.i.nu);
    }
    set crosshairPoint(v) {
        this.i.nu = toPoint(v);
    }
    /**
     * Gets or sets whether the series animations should be allowed when a range change has been detected on an axis.
    *
    * `animateSeriesWhenAxisRangeChanges` is a Boolean property to override the default behavior in which series do not animate if an axis range changes.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     animateSeriesWhenAxisRangeChanges=true>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         transitionInMode="accordionFromBottom"
    *         isTransitionInEnabled=true
    *         transitionInSpeedType="indexScaled"
    *         transitionDuration=1000>
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.animateSeriesWhenAxisRangeChanges = true;
    * ```
    */
    get animateSeriesWhenAxisRangeChanges() {
        return this.i.cw;
    }
    set animateSeriesWhenAxisRangeChanges(v) {
        this.i.cw = ensureBool(v);
    }
    /**
     * Gets or sets whether to sync the vertical aspect of the window with the contained series content. This is only supported for a subset of the available series.
    */
    get isWindowSyncedToVisibleRange() {
        return this.i.dm;
    }
    set isWindowSyncedToVisibleRange(v) {
        this.i.dm = ensureBool(v);
    }
    /**
     * Gets the viewport rectangle associated with the SeriesViewer, the physical dimensions of the plot area.
    *
    * ```ts
    * let viewPortRect: IgxRect = this.chart.viewportRect;
    * ```
    */
    get viewportRect() {
        return fromRect(this.i.oh);
    }
    /**
     * Gets the EffectiveViewport rectangle, representing the effective viewport area after margins have been subtracted.
    *
    *  ``ts
    * let viewport: IgxRect = this.chart.effectiveViewport;
    *
    * ```
    *
    * ```
    */
    get effectiveViewport() {
        return fromRect(this.i.n6);
    }
    set effectiveViewport(v) {
        this.i.n6 = toRect(v);
    }
    /**
     * Represents the subset area within the viewport into which content should be mapped.
     * This is the projection of the current EffectiveViewport into the viewport at current zoom level.
    *
    * ```ts
    * let contentViewport: IgxRect = this.chart.contentViewport;
    * ```
    */
    get contentViewport() {
        return fromRect(this.i.n5);
    }
    /**
     * A rectangle representing the portion of the SeriesViewer currently in view.
     * A rectangle at X=0, Y=0 with a Height and Width of 1 implies the entire plotting area is in view.  A Height and Width of .5 would imply that the view is halfway zoomed in.
    *
    * You can set the `windowRect` to zoom in on an area of interest in the chart.
    *
    * ```ts
    * this.chart.windowRect = {left:0, top:1, width: .5, height: .5};
    * ```
    */
    get windowRect() {
        return fromRect(this.i.oi);
    }
    set windowRect(v) {
        this.i.oi = toRect(v);
    }
    /**
     * Gets or sets whether the series viewer should use cached tiles during zooms rather than the default live content.
    */
    get useTiledZooming() {
        return this.i.d8;
    }
    set useTiledZooming(v) {
        this.i.d8 = ensureBool(v);
    }
    /**
     * Gets or sets whether the series viewer should prefer selecting higher resolution tiles over lower resolution tiles when performing tile zooming. Setting this to true will lower performance but increase quality.
    */
    get preferHigherResolutionTiles() {
        return this.i.dy;
    }
    set preferHigherResolutionTiles(v) {
        this.i.dy = ensureBool(v);
    }
    /**
     * Gets or sets the maximum number of zoom tiles that the series viewer should cache while in tiled zooming mode.
    */
    get zoomTileCacheSize() {
        return this.i.fv;
    }
    set zoomTileCacheSize(v) {
        this.i.fv = +v;
    }
    /**
     * Gets or sets the duration the highlighting/de-highlighting effects.
    *
    * The `highlightingTransitionDuration` property is used to set the time for highlighting transition in milliseconds .
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    * 	HighlightingTransitionDuration=500 >
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value" >
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * chart.HighlightingTransitionDuration=500;
    * ```
    */
    get highlightingTransitionDuration() {
        return this.i.fu;
    }
    set highlightingTransitionDuration(v) {
        this.i.fu = +v;
    }
    /**
     * Gets or sets the whether the series viewer can allow the page to pan if a control pan is not possible in the requested direction.
    */
    get isPagePanningAllowed() {
        return this.i.di;
    }
    set isPagePanningAllowed(v) {
        this.i.di = ensureBool(v);
    }
    /**
     * Determines the method of hit testing used when mousing over elements in the chart.
    *
    * ```ts
    * this.chart.contentHitTestMode = ChartHitTestMode.Computational;
    * ```
    */
    get contentHitTestMode() {
        return this.i.ap;
    }
    set contentHitTestMode(v) {
        this.i.ap = ensureEnum(ChartHitTestMode_$type, v);
    }
    /**
     * Resolved method of hit testing used when the pointer is over elements in the chart.
    *
    * ```ts
    * let actualContentHitTestMode: ChartHitTestMode  =this.chart.actualContentHitTestMode;
    * ```
    */
    get actualContentHitTestMode() {
        return this.i.ao;
    }
    set actualContentHitTestMode(v) {
        this.i.ao = ensureEnum(ChartHitTestMode_$type, v);
    }
    /**
     * Gets or sets whether all surface interactions with the plot area should be disabled.
    *
    * The `isSurfaceInteractionDisabled` property is used to enable/disable interactions with the plot surface.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isSurfaceInteractionDisabled=true>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * chart.isSurfaceInteractionDisabled=true;
    * ```
    */
    get isSurfaceInteractionDisabled() {
        return this.i.dj;
    }
    set isSurfaceInteractionDisabled(v) {
        this.i.dj = ensureBool(v);
    }
    /**
     * Indicates if this SeriesViewer is a map.
    */
    get isMap() {
        return this.i.dh;
    }
    /**
     * The response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.  The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
    *
    * The `windowResponse` property is used to set the response to user panning and zooming: whether to update the view immediately while the user action is happening, or to defer the update to after the user action is complete.
    * The user action will be an action such as a mouse drag which causes panning and/or zooming to occur.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     windowResponse="deferred">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.windowResponse="deferred";
    * ```
    */
    get windowResponse() {
        return this.i.bi;
    }
    set windowResponse(v) {
        this.i.bi = ensureEnum(WindowResponse_$type, v);
    }
    /**
     * Sets or gets the minimum width that the window rect is allowed to reach before being clamped.
     * Decrease this value if you want to allow for further zooming into the viewer.
     * If this value is lowered too much it can cause graphical corruption due to floating point arithmetic inaccuracy.
    *
    * The `windowRectMinWidth` property is used to set or get the minimum width that the window rect is allowed to reach before being clamped.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     windowRectMinWidth=.2>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.WindowRectMinWidth=".2";
    * ```
    */
    get windowRectMinWidth() {
        return this.i.fm;
    }
    set windowRectMinWidth(v) {
        this.i.fm = +v;
    }
    /**
     * Gets or sets the current SeriesViewer's crosshair visibility override.
    *
    * The `crosshairVisibility` property is used to gets or sets the current Chart's crosshair visibility override. Note: setting this property does not affect the mobile browser version of the chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     crosshairVisibility="visible">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.crosshairVisibility = Visibility.Visible;
    * ```
    */
    get crosshairVisibility() {
        return this.i.om;
    }
    set crosshairVisibility(v) {
        this.i.om = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets zoom is contrained to within the axes. Setting this to false is a preview feature at the present time.
    */
    get zoomCoercionMode() {
        return this.i.bm;
    }
    set zoomCoercionMode(v) {
        this.i.bm = ensureEnum(ZoomCoercionMode_$type, v);
    }
    /**
     * Gets or sets the brush used as the background for the current SeriesViewer object's plot area.
    *
    * `plotAreaBackground` property set the background brush to the current Chart object's plot area.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     plotAreaBackground="#F0F8FF">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.plotAreaBackground="#F0F8FF";
    * ```
    */
    get plotAreaBackground() {
        return brushToString(this.i.nn);
    }
    set plotAreaBackground(v) {
        this.i.nn = stringToBrush(v);
    }
    /**
     * Gets or sets the DefaultInteraction property.
     * The default interaction state defines the SeriesViewer's response to mouse events.
    *
    * The default interaction state defines the chart's response to mouse events.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     defaultInteraction="dragPan">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.defaultInteraction = InteractionState.DragPan;
    * ```
    */
    get defaultInteraction() {
        return this.i.bp;
    }
    set defaultInteraction(v) {
        this.i.bp = ensureEnum(InteractionState_$type, v);
    }
    /**
     * Gets or sets the RightButtonDefaultInteraction property.
     * The default interaction state defines the SeriesViewer's response to right button mouse events.
    */
    get rightButtonDefaultInteraction() {
        return this.i.br;
    }
    set rightButtonDefaultInteraction(v) {
        this.i.br = ensureEnum(InteractionState_$type, v);
    }
    /**
     * Gets or sets the current SeriesViewer's DragModifier property.
    *
    * `dragModifier` is useful to enable zooming when zooming is not the default interaction.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     defaultInteraction="dragPan"
    *     dragModifier="alt">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.dragModifier = ModifierKeys.Alt;
    * ```
    */
    get dragModifier() {
        return this.i.na;
    }
    set dragModifier(v) {
        this.i.na = ensureEnum(ModifierKeys_$type, v);
    }
    /**
     * Gets or sets the current SeriesViewer's PanModifier property.
    *
    * `panModifier` is useful to enable panning when panning is not the default interaction.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     defaultInteraction="dragZoom"
    *     panModifier="alt">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.panModifier = ModifierKeys.Alt;
    * ```
    */
    get panModifier() {
        return this.i.nb;
    }
    set panModifier(v) {
        this.i.nb = ensureEnum(ModifierKeys_$type, v);
    }
    /**
     * Gets or sets the preview rectangle.
     * The preview rectangle may be set to Rect.Empty, in which case the visible preview
     * strokePath is hidden.
    *
    * `previewRect` can be used to highlight an area of importance.
    *
    * ```ts
    * this.chart.previewRect = {left:0,top:0,height:.5,width:.5};
    * ```
    */
    get previewRect() {
        return fromRect(this.i.oc);
    }
    set previewRect(v) {
        this.i.oc = toRect(v);
    }
    /**
     * A number between 0 and 1 determining the position of the horizontal scroll.
     * This property is effectively a shortcut to the X position of the WindowRect property.
    *
    * ```ts
    * this.chart.windowPositionHorizontal = .2;
    * ```
    */
    get windowPositionHorizontal() {
        return this.i.fk;
    }
    set windowPositionHorizontal(v) {
        this.i.fk = +v;
    }
    /**
     * A number between 0 and 1 determining the position of the vertical scroll.
     * This property is effectively a shortcut to the Y position of the WindowRect property.
    *
    * ```ts
    * this.chart.windowPositionVertical = .2;
    * ```
    */
    get windowPositionVertical() {
        return this.i.fl;
    }
    set windowPositionVertical(v) {
        this.i.fl = +v;
    }
    /**
     * Text to display above the plot area.
    *
    * The `chartTitle` property is used to set the title to display for the component.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.title="Items Sold";
    * ```
    */
    get chartTitle() {
        return this.i.hk;
    }
    set chartTitle(v) {
        this.i.hk = v;
    }
    /**
     * Gets or sets the TitleHorizontalAlignment property.
    *
    * The `subtitleHorizontalAlignment` property is used to set horizontal alignment for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     titleHorizontalAlignment="left"
    *     subtitleHorizontalAlignment="left">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleHorizontalAlignment="left";
    * ```
    */
    get titleHorizontalAlignment() {
        return this.i.m9;
    }
    set titleHorizontalAlignment(v) {
        this.i.m9 = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the SubtitleHorizontalAlignment property.
    *
    * The `subtitleBottomMargin` property is used to set the horizontal alignment for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="Date of Sale: 1/1/2018"
    *     titleHorizontalAlignment="left"
    *     subtitleHorizontalAlignment="left">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleHorizontalAlignment="left";
    * ```
    */
    get subtitleHorizontalAlignment() {
        return this.i.m8;
    }
    set subtitleHorizontalAlignment(v) {
        this.i.m8 = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Font settings for the title.
    */
    get titleTextStyle() {
        return this.i.hr;
    }
    set titleTextStyle(v) {
        this.i.hr = v;
    }
    /**
     * Font settings for the subtitle.
    */
    get subtitleTextStyle() {
        return this.i.hf;
    }
    set subtitleTextStyle(v) {
        this.i.hf = v;
    }
    /**
     * Gets or sets the Color used for the Title Text.
    *
    * The `titleTextColor` property is used to set the title brush.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     titleTextColor="blue">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleTextColor="blue" ;
    * ```
    */
    get titleTextColor() {
        return brushToString(this.i.ns);
    }
    set titleTextColor(v) {
        this.i.ns = stringToBrush(v);
    }
    /**
     * Gets or sets the Color used for the Subtitle Text.
    *
    * The `subtitleTextColor` property is used to set the color for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="Date of Sale: 1/1/2018"
    *     subtitleTextColor="blue">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleTextColor="blue";
    * ```
    */
    get subtitleTextColor() {
        return brushToString(this.i.nr);
    }
    set subtitleTextColor(v) {
        this.i.nr = stringToBrush(v);
    }
    /**
     * Margin applied above the title.
    *
    * The `titleTopMargin` property is used to set the top margin for the title.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     titleLeftMarging=10
    *     titleTopMargin=10
    *     titleRightMargin=10
    *     titleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleTopMargin=10;
    * ```
    */
    get titleTopMargin() {
        return this.i.fi;
    }
    set titleTopMargin(v) {
        this.i.fi = +v;
    }
    /**
     * Margin applied to the left of the title.
    *
    * The `titleLeftMarging` property is used to set the left margin for the title.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     titleLeftMarging=10
    *     titleTopMargin=10
    *     titleRightMargin=10
    *     titleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleLeftMarging=10;
    * ```
    */
    get titleLeftMargin() {
        return this.i.fg;
    }
    set titleLeftMargin(v) {
        this.i.fg = +v;
    }
    /**
     * Margin applied to the right of the title.
    *
    * The `titleRightMargin` property is used to set the right margin for the title.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     titleLeftMarging=10
    *     titleTopMargin=10
    *     titleRightMargin=10
    *     titleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleRightMargin=10;
    * ```
    */
    get titleRightMargin() {
        return this.i.fh;
    }
    set titleRightMargin(v) {
        this.i.fh = +v;
    }
    /**
     * Margin applied below the title.
    *
    * The `titleBottomMargin` property is used to set the bottom margin for the title.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     titleLeftMarging=10
    *     titleTopMargin=10
    *     titleRightMargin=10
    *     titleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.titleBottomMargin=20;
    * ```
    */
    get titleBottomMargin() {
        return this.i.ff;
    }
    set titleBottomMargin(v) {
        this.i.ff = +v;
    }
    /**
     * Margin applied above the subtitle.
    *
    * The `subtitleTopMargin` property is used to set the top margin for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     subtitleLeftMarging=10
    *     subtitleTopMargin=10
    *     subtitleRightMargin=10
    *     subtitleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleTopMargin =10;
    * ```
    */
    get subtitleTopMargin() {
        return this.i.fe;
    }
    set subtitleTopMargin(v) {
        this.i.fe = +v;
    }
    /**
     * Margin applied to the left of the subtitle.
    *
    * The `subtitleLeftMarging` property is used to set the left margin for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     subtitleLeftMarging=10
    *     subtitleTopMargin=10
    *     subtitleRightMargin=10
    *     subtitleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleLeftMarging=10;
    * ```
    */
    get subtitleLeftMargin() {
        return this.i.fc;
    }
    set subtitleLeftMargin(v) {
        this.i.fc = +v;
    }
    /**
     * Margin applied to the right of the subtitle.
    *
    * The `subTitleRightMargin` property is used to set the right margin for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     subtitleLeftMarging=10
    *     subtitleTopMargin=10
    *     subTitleRightMargin=10
    *     subtitleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleLeftMarging=10;
    * ```
    */
    get subtitleRightMargin() {
        return this.i.fd;
    }
    set subtitleRightMargin(v) {
        this.i.fd = +v;
    }
    /**
     * Margin applied below the subtitle.
    *
    * The `subtitleBottomMargin` property is used to set the bottom margin for the subtitle.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="date of sale: 1/1/2018"
    *     subtitleLeftMarging=10
    *     subtitleTopMargin=10
    *     subtitleRightMargin=10
    *     subtitleBottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitleBottomMargin = 20;
    * ```
    */
    get subtitleBottomMargin() {
        return this.i.fb;
    }
    set subtitleBottomMargin(v) {
        this.i.fb = +v;
    }
    /**
     * Gets or sets the Subtitle property.
     * The Title property defines the Subtitle of the chart
    *
    * The `subtitle` property is used to display subtitle for the component.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     title="Items Sold"
    *     subtitle="Date of Sale: 1/1/2018">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.subtitle="Date of Sale: 1/1/2018";
    * ```
    */
    get subtitle() {
        return this.i.g8;
    }
    set subtitle(v) {
        this.i.g8 = v;
    }
    /**
     * Sets or gets the top margin to use around the chart content.
    *
    * The `topMargin` property is used to set the top margin.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data"
    *     leftMargin=20
    *     rightMargin=20
    *     topMargin=30
    *     bottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.topMargin=30;
    * ```
    */
    get topMargin() {
        return this.i.fj;
    }
    set topMargin(v) {
        this.i.fj = +v;
    }
    /**
     * Sets or gets the left margin to use around the chart content.
    *
    * The `leftMargin` property is used to set the left margin.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data"
    *     leftMargin=20
    *     rightMargin=20
    *     topMargin=30
    *     bottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    *  this.chart.leftMargin = 20;
    * ```
    */
    get leftMargin() {
        return this.i.e7;
    }
    set leftMargin(v) {
        this.i.e7 = +v;
    }
    /**
     * Sets or gets the right margin to use around the chart content.
    *
    * The `rightMargin` property is used to set the left margin around the chart content in the canvas.
    *
    * ```html
    *  <igx-data-chart
    *     [dataSource]="data"
    *     leftMargin=20
    *     rightMargin=20
    *     topMargin=30
    *     bottomMargin=20>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.rightMargin=20;
    * ```
    */
    get rightMargin() {
        return this.i.fa;
    }
    set rightMargin(v) {
        this.i.fa = +v;
    }
    /**
     * Sets or gets the bottom margin to use around the chart content.
    *
    * The `bottomMargin` property is used to gets/set the bottom margin around the chart content in the canvas.
    *
    * ```ts
    * this.chart.bottomMargin = 50;
    * ```
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     bottomMargin=50>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get bottomMargin() {
        return this.i.e3;
    }
    set bottomMargin(v) {
        this.i.e3 = +v;
    }
    /**
     * Sets or gets the automatic width to add when automatically adding margins to the chart.
    *
    * The `autoMarginWidth` propertry is used find the automatic width to add when automatically adding margins to the chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     autoMarginWidth=50>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.autoMarginWidth = 50;
    * ```
    */
    get autoMarginWidth() {
        return this.i.e2;
    }
    set autoMarginWidth(v) {
        this.i.e2 = +v;
    }
    /**
     * Sets or gets the automatic height to add when automatically adding margins to the chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     autoMarginHeight=50>
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-column-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    *  this.chart.autoMarginHeight = 50;
    * ```
    */
    get autoMarginHeight() {
        return this.i.e1;
    }
    set autoMarginHeight(v) {
        this.i.e1 = +v;
    }
    /**
     * Gets or sets the IsAntiAliasingEnabledDuringInteraction property.
    */
    get isAntiAliasingEnabledDuringInteraction() {
        return this.i.c9;
    }
    set isAntiAliasingEnabledDuringInteraction(v) {
        this.i.c9 = ensureBool(v);
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.e8;
    }
    set pixelScalingRatio(v) {
        this.i.e8 = +v;
    }
    /**
     * Method of pixel scaling to use during end user interaction with the chart.
    */
    get interactionPixelScalingRatio() {
        return this.i.e6;
    }
    set interactionPixelScalingRatio(v) {
        this.i.e6 = +v;
    }
    /**
     * Gets the resolved pixel scaling ratio.
    *
    * A higher scaling ratio will produce crisper visuals at the expense of memory. Lower values will cause the control to appear blurry
    *
    * ```ts
    * let actualPixelScalingRatio: number = this.chart.actualPixelScalingRatio;
    * ```
    */
    get actualPixelScalingRatio() {
        return this.i.ey;
    }
    set actualPixelScalingRatio(v) {
        this.i.ey = +v;
    }
    /**
     * Resolved method of pixel scaling to use during end user interaction with the chart.
    *
    * ```ts
    * let actualInteractionPixelScalingRatio: number = this.chart.actualInteractionPixelScalingRatio;
    * ```
    */
    get actualInteractionPixelScalingRatio() {
        return this.i.ex;
    }
    set actualInteractionPixelScalingRatio(v) {
        this.i.ex = +v;
    }
    /**
     * Gets the actual value of the window rectangle, which represents the current zoom level.
    *
    * ```ts
    * let actualWindowRect: IgxRect = this.chart.actualWindowRect;
    * ``
    * ```
    */
    get actualWindowRect() {
        return fromRect(this.i.n2);
    }
    set actualWindowRect(v) {
        this.i.n2 = toRect(v);
    }
    /**
     * A number between 0 and 1 determining the position of the horizontal scroll.
     * This property is effectively a shortcut to the Left of the ActualWindowRect property.
    *
    * ```ts
    * let actualWindowPositionHorizontal: number = this.chart.actualWindowPositionHorizontal;
    * ```
    */
    get actualWindowPositionHorizontal() {
        return this.i.ez;
    }
    set actualWindowPositionHorizontal(v) {
        this.i.ez = +v;
    }
    /**
     * A number between 0 and 1 determining the position of the vertical scroll.
     * This property is effectively a shortcut to the Top of the ActualWindowRect property.
    *
    * ```ts
    * let actualWindowPositionVertical: number = this.chart.actualWindowPositionVertical;
    * ``
    * ```
    */
    get actualWindowPositionVertical() {
        return this.i.e0;
    }
    set actualWindowPositionVertical(v) {
        this.i.e0 = +v;
    }
    findByName(name) {
        if (this.series != null && this.series.findByName && this.series.findByName(name)) {
            return this.series.findByName(name);
        }
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SeriesViewerComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
     * Hides the active main tooltip, if displayed.
    
    *
    * ```ts
    * this.chart.hideToolTip();
    * ```
    */
    hideToolTip() {
        this.i.io();
    }
    /**
     * Manually starts a tiled zoom if one isn't already running.
    
    */
    startTiledZoomingIfNecessary() {
        this.i.lc();
    }
    /**
     * Manually ends a tiled zoom if one is running.
    
    */
    endTiledZoomingIfRunning() {
        this.i.ii();
    }
    /**
     * Clears the tile zoom tile cache so that new tiles will be generated. Only applies if the viewer is using a tile based zoom.
    
    */
    clearTileZoomCache() {
        this.i.ib();
    }
    /**
     * Resets the zoom level to default.
    
    */
    resetZoom() {
        this.i.k6();
    }
    cancelManipulation() {
        this.i.h9();
    }
    /**
     * Gets actual window scale for horizontal dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleHorizontal: number = chart.getActualWindowScaleHorizontal();
    * ```
    */
    getActualWindowScaleHorizontal() {
        let iv = this.i.e4();
        return (iv);
    }
    /**
     * Gets actual window scale for vertical dimension of the control
    
    *
    * ```ts
    * let actualWindowScaleVertical: number = chart.getActualWindowScaleVertical();
    * ```
    */
    getActualWindowScaleVertical() {
        let iv = this.i.e5();
        return (iv);
    }
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    notifyContainerResized() {
        this.i.notifyContainerResized();
    }
    /**
     * Attaches the given series to the chart.
    
    * @param s  * The series to attach to the chart.
    */
    attachSeries(s) {
        this.i.h7((s == null ? null : s.i));
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.i0(source_, index, oldItem, newItem);
    }
    /**
     * Used to manually notify the SeriesViewer that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    *
    * ```ts
    * this.chart.notifyClearItems(this.data);
    * ```
    */
    notifyClearItems(source_) {
        this.i.iv(source_);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.iy(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.iz(source_, index, oldItem);
    }
    /**
     * Release any resources held by the control.
    
    */
    destroy() {
        this.i.destroy();
    }
    getCurrentActualWindowRect() {
        let iv = this.i.n8();
        return fromRect(iv);
    }
    renderToImage(width, height) {
        let iv = this.i.fx(width, height);
        return (iv);
    }
    /**
     * Use to force the SeriesViewer to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the SeriesViewer needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the SeriesViewer.
    
    *
    * ```ts
    * this.chart.flush();
    * ```
    */
    flush() {
        this.i.flush();
    }
    /**
     * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
    */
    get plotAreaMouseLeftButtonDown() {
        if (this._plotAreaMouseLeftButtonDown == null) {
            this._plotAreaMouseLeftButtonDown = new EventEmitter();
            this.i.plotAreaMouseLeftButtonDown = delegateCombine(this.i.plotAreaMouseLeftButtonDown, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePlotAreaMouseLeftButtonDown) {
                        this.beforePlotAreaMouseLeftButtonDown(this, outerArgs);
                    }
                    this._plotAreaMouseLeftButtonDown.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._plotAreaMouseLeftButtonDown;
    }
    /**
     * Occurs when the left mouse button is pressed while the mouse pointer is over the plot area.
    */
    get plotAreaMouseLeftButtonUp() {
        if (this._plotAreaMouseLeftButtonUp == null) {
            this._plotAreaMouseLeftButtonUp = new EventEmitter();
            this.i.plotAreaMouseLeftButtonUp = delegateCombine(this.i.plotAreaMouseLeftButtonUp, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePlotAreaMouseLeftButtonUp) {
                        this.beforePlotAreaMouseLeftButtonUp(this, outerArgs);
                    }
                    this._plotAreaMouseLeftButtonUp.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._plotAreaMouseLeftButtonUp;
    }
    /**
     * Occurs when the left mouse button is clicked while the mouse pointer is over the plot area.
    */
    get plotAreaClicked() {
        if (this._plotAreaClicked == null) {
            this._plotAreaClicked = new EventEmitter();
            this.i.plotAreaClicked = delegateCombine(this.i.plotAreaClicked, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPlotAreaMouseButtonEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePlotAreaClicked) {
                        this.beforePlotAreaClicked(this, outerArgs);
                    }
                    this._plotAreaClicked.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._plotAreaClicked;
    }
    /**
     * Occurs when the pointer enters the plot area.
    */
    get plotAreaMouseEnter() {
        if (this._plotAreaMouseEnter == null) {
            this._plotAreaMouseEnter = new EventEmitter();
            this.i.plotAreaMouseEnter = delegateCombine(this.i.plotAreaMouseEnter, (o, e) => {
                let outerArgs = new IgxPlotAreaMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforePlotAreaMouseEnter) {
                    this.beforePlotAreaMouseEnter(this, outerArgs);
                }
                this._plotAreaMouseEnter.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._plotAreaMouseEnter;
    }
    /**
     * Occurs when the pointer exits the plot area.
    */
    get plotAreaMouseLeave() {
        if (this._plotAreaMouseLeave == null) {
            this._plotAreaMouseLeave = new EventEmitter();
            this.i.plotAreaMouseLeave = delegateCombine(this.i.plotAreaMouseLeave, (o, e) => {
                let outerArgs = new IgxPlotAreaMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforePlotAreaMouseLeave) {
                    this.beforePlotAreaMouseLeave(this, outerArgs);
                }
                this._plotAreaMouseLeave.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._plotAreaMouseLeave;
    }
    /**
     * Occurs when the pointer if over the plot area.
    */
    get plotAreaMouseOver() {
        if (this._plotAreaMouseOver == null) {
            this._plotAreaMouseOver = new EventEmitter();
            this.i.plotAreaMouseOver = delegateCombine(this.i.plotAreaMouseOver, (o, e) => {
                let outerArgs = new IgxPlotAreaMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforePlotAreaMouseOver) {
                    this.beforePlotAreaMouseOver(this, outerArgs);
                }
                this._plotAreaMouseOver.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._plotAreaMouseOver;
    }
    /**
     * Occurs when the cursors are moved over a series in this SeriesViewer.
    */
    get seriesCursorMouseMove() {
        if (this._seriesCursorMouseMove == null) {
            this._seriesCursorMouseMove = new EventEmitter();
            this.i.seriesCursorMouseMove = delegateCombine(this.i.seriesCursorMouseMove, (o, e) => {
                let outerArgs = new IgxChartCursorEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSeriesCursorMouseMove) {
                    this.beforeSeriesCursorMouseMove(this, outerArgs);
                }
                this._seriesCursorMouseMove.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._seriesCursorMouseMove;
    }
    /**
     * Occurs when the left mouse button is pressed while the mouse pointer is over a Series.
    *
    * The `SeriesMouseLeftButtonDown` event occurs when the left mouse button is pressed while the mouse pointer is over an element of this chart.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (seriesMouseLeftButtonDown)="onSeriesMouseLeftButtonDown($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * public onSeriesMouseLeftButtonDown(event: {sender: any, args: DataChartMouseButtonEventArgs})
    * {
    *     var item = event.args.item;
    * }
    * ```
    */
    get seriesMouseLeftButtonDown() {
        if (this._seriesMouseLeftButtonDown == null) {
            this._seriesMouseLeftButtonDown = new EventEmitter();
            this.i.seriesMouseLeftButtonDown = delegateCombine(this.i.seriesMouseLeftButtonDown, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDataChartMouseButtonEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesMouseLeftButtonDown) {
                        this.beforeSeriesMouseLeftButtonDown(this, outerArgs);
                    }
                    this._seriesMouseLeftButtonDown.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesMouseLeftButtonDown;
    }
    /**
     * Occurs when the left mouse button is released while the mouse pointer is over a Series.
    *
    * The `SeriesMouseLeftButtonUp` event occurs when the left mouse button is released while the mouse pointer is over an element of this chart.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (seriesMouseLeftButtonUp)="onSeriesMouseLeftButtonUp($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * &lt;-- position: content member-->
    *
    * ```ts
    * public onSeriesMouseLeftButtonUp(event: {sender: any, args: DataChartMouseButtonEventArgs})
    * {
    *     var item = event.args.item;
    * }
    * ```
    *
    * ```ts
    * public onSeriesMouseLeftButtonUp =(event: any, args: DataChartMouseButtonEventArgs )
    * {
    *
    * }
    * ```
    */
    get seriesMouseLeftButtonUp() {
        if (this._seriesMouseLeftButtonUp == null) {
            this._seriesMouseLeftButtonUp = new EventEmitter();
            this.i.seriesMouseLeftButtonUp = delegateCombine(this.i.seriesMouseLeftButtonUp, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxDataChartMouseButtonEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesMouseLeftButtonUp) {
                        this.beforeSeriesMouseLeftButtonUp(this, outerArgs);
                    }
                    this._seriesMouseLeftButtonUp.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesMouseLeftButtonUp;
    }
    /**
     * Occurs when the mouse pointer moves while over a Series.
    *
    * The `SeriesMouseMove` event occurs when the left mouse pointer moves while over an element of this chart.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (seriesMouseMove)="onSeriesMouseMove($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * &lt;-- position: content member-->
    *
    * ```ts
    * public onSeriesMouseMove(event: {sender: any, args: ChartMouseEventArgs})
    * {
    *     var item = event.args.item;
    * }
    * ```
    *
    * ```ts
    * public onSeriesMouseMove =( event: any, args: ChartMouseEventArgs) => {
    *                  }
    * ```
    */
    get seriesMouseMove() {
        if (this._seriesMouseMove == null) {
            this._seriesMouseMove = new EventEmitter();
            this.i.seriesMouseMove = delegateCombine(this.i.seriesMouseMove, (o, e) => {
                let outerArgs = new IgxChartMouseEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSeriesMouseMove) {
                    this.beforeSeriesMouseMove(this, outerArgs);
                }
                this._seriesMouseMove.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._seriesMouseMove;
    }
    /**
     * Occurs when the mouse pointer enters a Series.
    *
    * The `SeriesMouseEnter` event occurs when the left mouse pointer enters an element of this chart.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (seriesMouseEnter)="onSeriesMouseEnter($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * public onSeriesMouseEnter(event: {sender: any, args: ChartMouseEventArgs})
    * {
    *     var item = event.args.item;
    * }
    * ```
    */
    get seriesMouseEnter() {
        if (this._seriesMouseEnter == null) {
            this._seriesMouseEnter = new EventEmitter();
            this.i.seriesMouseEnter = delegateCombine(this.i.seriesMouseEnter, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxChartMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesMouseEnter) {
                        this.beforeSeriesMouseEnter(this, outerArgs);
                    }
                    this._seriesMouseEnter.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesMouseEnter;
    }
    /**
     * Occurs when the mouse pointer leaves a Series.
    *
    * The `SeriesMouseLeave` event occurs when the left mouse pointer leaves an element of this chart.
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (seriesMouseLeave)="onSeriesMouseLeave($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value"
    *         thickness=5>
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * public onSeriesMouseLeave(event: {sender: any, args: ChartMouseEventArgs})
    * {
    *     var item = event.args.item;
    * }
    * ```
    */
    get seriesMouseLeave() {
        if (this._seriesMouseLeave == null) {
            this._seriesMouseLeave = new EventEmitter();
            this.i.seriesMouseLeave = delegateCombine(this.i.seriesMouseLeave, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxChartMouseEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesMouseLeave) {
                        this.beforeSeriesMouseLeave(this, outerArgs);
                    }
                    this._seriesMouseLeave.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesMouseLeave;
    }
    /**
     * Raised when an ongoing manipulation of the series viewer is started.
    */
    get viewerManipulationStarting() {
        if (this._viewerManipulationStarting == null) {
            this._viewerManipulationStarting = new EventEmitter();
            this.i.viewerManipulationStarting = delegateCombine(this.i.viewerManipulationStarting, (o, e) => {
                let outerArgs = new IgxSeriesViewerManipulationEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeViewerManipulationStarting) {
                    this.beforeViewerManipulationStarting(this, outerArgs);
                }
                this._viewerManipulationStarting.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._viewerManipulationStarting;
    }
    /**
     * Raised when an ongoing manipulation of the series viewer is ended.
    */
    get viewerManipulationEnding() {
        if (this._viewerManipulationEnding == null) {
            this._viewerManipulationEnding = new EventEmitter();
            this.i.viewerManipulationEnding = delegateCombine(this.i.viewerManipulationEnding, (o, e) => {
                let outerArgs = new IgxSeriesViewerManipulationEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeViewerManipulationEnding) {
                    this.beforeViewerManipulationEnding(this, outerArgs);
                }
                this._viewerManipulationEnding.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._viewerManipulationEnding;
    }
    /**
     * Occurs just after the current SeriesViewer's window rectangle is changed.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     isHorizontalZoomEnabled=true
    *     (windowRectChanged)="onWindowRectChanged($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * &lt;-- position: content member-->
    *
    * ```ts
    * public onWindowRectChanged(event: {sender: any, args: RectChangedEventArgs})
    * {
    *     let newRect: IgxRect = event.args.newRect;
    * }
    * ```
    *
    * ```ts
    * public onWindowRectChanged =( s:any, e: RectChangedEventArgs) => {
    *
    *        }
    * ```
    */
    get windowRectChanged() {
        if (this._windowRectChanged == null) {
            this._windowRectChanged = new EventEmitter();
            this.i.windowRectChanged = delegateCombine(this.i.windowRectChanged, (o, e) => {
                let outerArgs = new IgxRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeWindowRectChanged) {
                    this.beforeWindowRectChanged(this, outerArgs);
                }
                this._windowRectChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._windowRectChanged;
    }
    /**
     * Occurs after the size of the series viewer changes.
    *
    * &lt;-- position: content member-->
    *
    * ```html
    * <igx-data-chart
    *     [dataSource]="data"
    *     (sizeChanged)="onSizeChanged($event)">
    *     <igx-category-x-axis
    *         label="label"
    *         #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *         #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-line-series
    *         [xAxis]="xAxis"
    *         [yAxis]="yAxis"
    *         valueMemberPath="value">
    *     </igx-line-series>
    * </igx-data-chart>
    * ```
    *
    * &lt;-- position: content member-->
    *
    * ```ts
    * public onSizeChanged(event: {sender: any, args: RectChangedEventArgs})
    * {
    *     let newRect: IgxRect = event.args.newRect;
    * }
    * ```
    *
    * ```ts
    * public onSizeChanged =(event: any, args: RectChangedEventArgs}){
    *
    * }
    * ```
    */
    get sizeChanged() {
        if (this._sizeChanged == null) {
            this._sizeChanged = new EventEmitter();
            this.i.sizeChanged = delegateCombine(this.i.sizeChanged, (o, e) => {
                let outerArgs = new IgxRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeSizeChanged) {
                    this.beforeSizeChanged(this, outerArgs);
                }
                this._sizeChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._sizeChanged;
    }
    /**
     * Raised when the actual window rectangle of the SeriesViewer changes.
    */
    get actualWindowRectChanged() {
        if (this._actualWindowRectChanged == null) {
            this._actualWindowRectChanged = new EventEmitter();
            this.i.actualWindowRectChanged = delegateCombine(this.i.actualWindowRectChanged, (o, e) => {
                let outerArgs = new IgxRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeActualWindowRectChanged) {
                    this.beforeActualWindowRectChanged(this, outerArgs);
                }
                this._actualWindowRectChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._actualWindowRectChanged;
    }
    /**
     * Occurs just after the current SeriesViewer's grid area rectangle is changed.
     * The grid area may change as the result of the SeriesViewer being resized, or
     * of an axis being added or changing size, possibly in another SeriesViewer.
    */
    get gridAreaRectChanged() {
        if (this._gridAreaRectChanged == null) {
            this._gridAreaRectChanged = new EventEmitter();
            this.i.gridAreaRectChanged = delegateCombine(this.i.gridAreaRectChanged, (o, e) => {
                let outerArgs = new IgxRectChangedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeGridAreaRectChanged) {
                    this.beforeGridAreaRectChanged(this, outerArgs);
                }
                this._gridAreaRectChanged.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._gridAreaRectChanged;
    }
    /**
     * Raised when the SeriesViewer's processing for an update has completed.
    */
    get refreshCompleted() {
        if (this._refreshCompleted == null) {
            this._refreshCompleted = new EventEmitter();
            this.i.refreshCompleted = delegateCombine(this.i.refreshCompleted, (o, e) => {
                let outerArgs = new IgxRefreshCompletedEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeRefreshCompleted) {
                    this.beforeRefreshCompleted(this, outerArgs);
                }
                this._refreshCompleted.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._refreshCompleted;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesViewerComponent.prototype, "crosshairPoint", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "animateSeriesWhenAxisRangeChanges", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "isWindowSyncedToVisibleRange", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesViewerComponent.prototype, "effectiveViewport", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesViewerComponent.prototype, "windowRect", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "useTiledZooming", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "preferHigherResolutionTiles", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "zoomTileCacheSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "highlightingTransitionDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "isPagePanningAllowed", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "contentHitTestMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "actualContentHitTestMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "isSurfaceInteractionDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "windowResponse", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "windowRectMinWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "crosshairVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "zoomCoercionMode", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "plotAreaBackground", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "defaultInteraction", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "rightButtonDefaultInteraction", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "dragModifier", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "panModifier", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesViewerComponent.prototype, "previewRect", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "windowPositionHorizontal", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "windowPositionVertical", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "chartTitle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "titleHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "subtitleHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "titleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "subtitleTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "titleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "subtitleTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "titleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "titleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "titleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "titleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "subtitleTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "subtitleLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "subtitleRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "subtitleBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSeriesViewerComponent.prototype, "subtitle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "topMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "leftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "rightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "bottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "autoMarginWidth", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "autoMarginHeight", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSeriesViewerComponent.prototype, "isAntiAliasingEnabledDuringInteraction", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "interactionPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "actualPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "actualInteractionPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSeriesViewerComponent.prototype, "actualWindowRect", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "actualWindowPositionHorizontal", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSeriesViewerComponent.prototype, "actualWindowPositionVertical", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonDown", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaMouseLeftButtonUp", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaClicked", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaMouseEnter", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaMouseLeave", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "plotAreaMouseOver", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesCursorMouseMove", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonDown", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesMouseLeftButtonUp", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesMouseMove", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesMouseEnter", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "seriesMouseLeave", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "viewerManipulationStarting", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "viewerManipulationEnding", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "windowRectChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "sizeChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "actualWindowRectChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "gridAreaRectChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSeriesViewerComponent.prototype, "refreshCompleted", null);

class IgxSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxSeriesComponent.$type) {
            IgxSeriesComponent.$type = markType(IgxSeriesComponent, "IgxSeriesComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxSeriesComponent.$type, Series.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxSeriesComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

class IgxAxisCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxAxisComponent.$type) {
            IgxAxisComponent.$type = markType(IgxAxisComponent, "IgxAxisComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxAxisComponent.$type, Axis.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = IgxAxisComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var IgxDataChartComponent_1;
const IgxDataChartComponent_PROVIDERS = [{ provide: IgxSeriesViewerComponent, useExisting: forwardRef(() => IgxDataChartComponent) }];
/**
 * Represents a chart area containing axes, series, an optional legend and other hosted content.
*/
let IgxDataChartComponent = IgxDataChartComponent_1 = class IgxDataChartComponent extends IgxSeriesViewerComponent {
    constructor(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
        super();
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._ngZone = _ngZone;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._injector = _injector;
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        this.actualSeries = [];
        /**
         * The axes actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing axes from the manual axes collection on the axes property.
         */
        this.actualAxes = [];
        this._series = null;
        this._axes = null;
        this._root = null;
        this._dataSource = null;
        this._axesAdapter = null;
        this._seriesAdapter = null;
        this._defaultTooltips = null;
        this._zoneRunner = (act) => this._ngZone.run(act);
        this._container = _renderer.createElement("div");
        _renderer.appendChild(_elRef.element.nativeElement, this._container);
        _renderer.setStyle(this._container, "display", "block");
        _renderer.setStyle(this._container, "width", "100%");
        _renderer.setStyle(this._container, "height", "100%");
        var root;
        root = this._container;
        if (this._container.nativeElement != null) {
            root = this._container.nativeElement;
        }
        this._root = root;
        var ren = new AngularRenderer(root, this._renderer, window.document, this._ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        var chart = this.i;
        this._chart = chart;
        this._axesAdapter = new CollectionAdapter([], this.i.axes, this.actualAxes, (c) => c.i, (i) => {
            i._provideRenderer(this._wrapper);
            i.provideData(this._dataSource);
            if (this._container && this._container.parentElement) {
                i._styling(this._root, this, this);
            }
        }, (i) => { i._provideRenderer(null); i.provideData(null); });
        this._seriesAdapter = new CollectionAdapter([], this.i.series, this.actualSeries, (c) => c.i, (i) => {
            i.owner = this;
            i._provideRenderer(this._dataSource);
            i.provideData(this._dataSource);
            if (this._container && this._container.parentElement) {
                i._styling(this._root, this, this);
            }
            i.bindAxes(this.actualAxes);
            this._ensureDefaultTooltip(i);
            this._ensureTooltipCreated(i);
        }, (i) => { i._provideRenderer(null); i.provideData(null); });
        chart.provideContainer(ren);
        ren.addSizeWatcher(() => {
            this._chart.notifyContainerResized();
        });
    }
    set height(value) {
        this._height = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._chart.notifyContainerResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._chart.notifyContainerResized();
    }
    get width() {
        return this._width;
    }
    /**
     * Gets or sets the legend used for the current chart.
    */
    get legend() {
        if (this.i.legend != null)
            return this.i.legend.externalObject;
    }
    set legend(v) {
        if (v != undefined && v != null)
            this.i.legend = v.i;
    }
    /**
     * A collection or manually added series for the chart.
    */
    get series() {
        if (this._series === null) {
            let coll = new IgxSeriesCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._seriesAdapter.clearManualItems();
                        break;
                }
            });
            this._series = coll;
        }
        return this._series;
    }
    /**
     * A collection or manually added axes for the chart.
    */
    get axes() {
        if (this._axes === null) {
            let coll = new IgxAxisCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._axesAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._axesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._axesAdapter.clearManualItems();
                        break;
                }
            });
            this._axes = coll;
        }
        return this._axes;
    }
    ngOnDestroy() {
        this._chart.destroy();
        this._wrapper.destroy();
    }
    createImplementation() {
        return new XamDataChart();
    }
    set dataSource(value) {
        this._dataSource = value;
        this.bindData();
    }
    get dataSource() {
        return this._dataSource;
    }
    bindData() {
        //console.log("binding data: " + this._dataSource);
        if (this.actualAxes && this.actualAxes.length > 0) {
            var currAxes = this.actualAxes;
            for (var i = 0; i < currAxes.length; i++) {
                currAxes[i].provideData(this._dataSource);
            }
        }
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i].provideData(this._dataSource);
            }
        }
    }
    ngAfterContentInit() {
        if (TypeRegistrar.isRegistered("IgxDataChartDefaultTooltipsComponent")) {
            let c = TypeRegistrar.get("IgxDataChartDefaultTooltipsComponent");
            let cf = this._componentFactoryResolver.resolveComponentFactory(c);
            let cr = this._dynamicContent.createComponent(cf);
            //let cr = cf.create(this._injector);
            this._defaultTooltips = cr;
            cr.instance.onContentReady.subscribe(() => {
                this._onDefaultTooltipsReady(cr);
            });
            //this._container.appendChild(cr.location.nativeElement);
        }
        this._axesAdapter.updateQuery(this.contentAxes);
        this._seriesAdapter.updateQuery(this.contentSeries);
        if (this.actualAxes && this.actualAxes.length > 0) {
            var currAxes = this.actualAxes;
            for (var i = 0; i < currAxes.length; i++) {
                currAxes[i].provideData(this._dataSource);
            }
        }
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                currSeries[i].provideData(this._dataSource);
            }
        }
        this._styling(this._root, this);
        this.i.notifyContainerResized();
    }
    _ensureTooltipCreated(series) {
        series._ensureTooltipCreated(() => this.createTooltip(), (ele) => {
            let wrapper = new AngularWrapper(ele, this._renderer, this._ngZone);
            wrapper.updateToolTip = ele.updateToolTip;
            wrapper.hideToolTip = ele.hideToolTip;
            return wrapper;
        });
    }
    _ensureDefaultTooltip(series) {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](series);
    }
    _onDefaultTooltipsReady(cr) {
        if (this.actualSeries && this.actualSeries.length > 0) {
            var currSeries = this.actualSeries;
            for (var i = 0; i < currSeries.length; i++) {
                if (currSeries[i].showDefaultTooltip) {
                    this._ensureDefaultTooltip(currSeries[i]);
                }
            }
        }
    }
    createTooltip() {
        if (!TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
            return null;
        }
        let t = TypeRegistrar.get("IgxTooltipContainerComponent");
        let cf = this._componentFactoryResolver.resolveComponentFactory(t);
        //let cr = cf.create(this._injector);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        let self = this;
        ele.updateToolTip = function (c, isSubContent) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                let ext = new IgxDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (!isSubContent) {
                if (ele.parentElement != self._container) {
                    if (ele.parentElement != null) {
                        ele.parentElement.removeChild(ele);
                    }
                    self._container.appendChild(ele);
                }
            }
            else {
                c.isSubContent = true;
            }
            cr.instance.context = c;
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    }
    /**
     * Gets or sets the channel with which to synchronize.
    *
    * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
    */
    get syncChannel() {
        return this.i.syncChannel;
    }
    set syncChannel(v) {
        let newLink = null;
        if (v && v.length > 0) {
            newLink = SyncLinkManager.instance().getLink(v);
        }
        let oldLink = this.i.actualSyncLink;
        if (oldLink) {
            SyncLinkManager.instance().releaseLink(oldLink);
        }
        if (newLink) {
            this.i.actualSyncLink = newLink;
        }
        else {
            this.i.actualSyncLink = new SyncLink();
        }
        this.i.syncChannel = v;
    }
    /**
     * Gets or sets the bool used to display the window preview shadow.
    *
    * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
    */
    get synchronizeVertically() {
        return this.i.syncSettings ? this.i.syncSettings.synchronizeVertically : false;
    }
    set synchronizeVertically(v) {
        this.i.syncSettings.synchronizeVertically = ensureBool(v);
    }
    /**
     * Gets or sets the bool used to display the window preview shadow.
    *
    * Synchronization is the coordination of zooming, panning and crosshairs events between multiple charts. Multiple chart controls can be synchronized horizontally (along X-Axis), vertically (along Y-Axis), or both. If you want to synchronize a set of charts, assign them the same name to the `syncChannel` and then specify whether or not synchronize chart horizontally and/or vertically.
    */
    get synchronizeHorizontally() {
        return this.i.syncSettings ? this.i.syncSettings.synchronizeHorizontally : false;
    }
    set synchronizeHorizontally(v) {
        this.i.syncSettings.synchronizeHorizontally = ensureBool(v);
    }
    /**
                             * @hidden
                             */
    get i() {
        return this._implementation;
    }
    /**
 * Gets or sets whether to use a square aspect ratio for the chart. This is locked to true for polar and radial charts.
*
* Set `isSquare` to true to constrain the chart to a square, using the minimum of its height and width.
*
* ```html
* <igx-data-chart [dataSource]="data"
*     isSquare="true"
*     width="800px"
*     height="400px">
*   <igx-category-x-axis #xAxis
*     label="label">
*   </igx-category-x-axis>
*   <igx-numeric-y-axis #yAxis
*     majorStroke="green">
*   </igx-numeric-y-axis>
*
*   <igx-column-series
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     valueMemberPath="value">
*   </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
*  this.chart.isSquare="True";
* ```
*/
    get isSquare() {
        return this.i.o8;
    }
    set isSquare(v) {
        this.i.o8 = ensureBool(v);
    }
    /**
     * A number between 0 and 1 determining the scale of the horizontal zoom.
     * This property is effectively a shortcut to the Width of the WindowRect property.
    *
    * To programmatically change the horizontal zoom level, set `windowScaleHorizontal` to a value between 0 and 1.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     windowScaleHorizontal="0.75">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.windowScaleHorizontal="0.75";
    * ```
    */
    get windowScaleHorizontal() {
        return this.i.pu;
    }
    set windowScaleHorizontal(v) {
        this.i.pu = +v;
    }
    /**
     * A number between 0 and 1 determining the scale of the vertical zoom.
     * This property is effectively a shortcut to the Height of the WindowRect property.
    *
    * To programmatically change the vertical zoom level, set `windowScaleVertical` to a value between 0 and 1.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     windowScaleVertical="0.75">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.windowScaleVertical="0.75";
    * ```
    */
    get windowScaleVertical() {
        return this.i.pv;
    }
    set windowScaleVertical(v) {
        this.i.pv = +v;
    }
    /**
     * A number between 0 and 1 determining the scale of the horizontal zoom.
     * This property is effectively a shortcut to the Width of the ActualWindowRect property.
    */
    get actualWindowScaleHorizontal() {
        return this.i.pk;
    }
    set actualWindowScaleHorizontal(v) {
        this.i.pk = +v;
    }
    /**
     * A number between 0 and 1 determining the scale of the vertical zoom.
     * This property is effectively a shortcut to the Height of the ActualWindowRect property.
    */
    get actualWindowScaleVertical() {
        return this.i.pl;
    }
    set actualWindowScaleVertical(v) {
        this.i.pl = +v;
    }
    /**
     * Gets or sets horizontal zoomability of the current control
    *
    * Set `isHorizontalZoomEnabled` to enable or disable horizontal zooming.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     isHorizontalZoomEnabled="true">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.IsHorizontalZoomEnabled= true;
    * ```
    */
    get isHorizontalZoomEnabled() {
        return this.i.o6;
    }
    set isHorizontalZoomEnabled(v) {
        this.i.o6 = ensureBool(v);
    }
    /**
     * Gets or sets vertical zoomability of the current control
    *
    * Set `isVerticalZoomEnabled` to enable or disable vertical zooming.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     isVerticalZoomEnabled="true">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.isVerticalZoomEnabled="True";
    * ```
    */
    get isVerticalZoomEnabled() {
        return this.i.o9;
    }
    set isVerticalZoomEnabled(v) {
        this.i.o9 = ensureBool(v);
    }
    /**
     * Gets or sets how grid lines are rendered in relation to series.
    *
    *  Try setting the `gridMode` property to bring your grid lines in front of the data series.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     gridMode="beforeSeries">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis
    *     majorStroke="green">
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get gridMode() {
        return this.i.ov;
    }
    set gridMode(v) {
        this.i.ov = ensureEnum(GridMode_$type, v);
    }
    /**
     * Gets or sets a value indicating whether grid and tick lines are aligned to device pixels.
    */
    get alignsGridLinesToPixels() {
        return this.i.o2;
    }
    set alignsGridLinesToPixels(v) {
        this.i.o2 = ensureBool(v);
    }
    /**
     * Gets or sets the palette of brushes to use for coloring the chart series.
    *
    * `brushes` can be set declaratively to a list of color strings.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     brushes="red,green,blue">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.brushes="red" ;
    * ```
    */
    get brushes() {
        return fromBrushCollection(this.i.oo);
    }
    set brushes(v) {
        this.i.oo = toBrushCollection(v);
    }
    /**
     * Gets or sets the maximum amount the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
    */
    get autoExpandMarginMaximumValue() {
        return this.i.pn;
    }
    set autoExpandMarginMaximumValue(v) {
        this.i.pn = +v;
    }
    /**
     * Gets or sets the extra amount the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
    */
    get autoExpandMarginExtraPadding() {
        return this.i.pm;
    }
    set autoExpandMarginExtraPadding(v) {
        this.i.pm = +v;
    }
    /**
     * Gets or sets a whether the series viewer should auto expand margins to accomodate the initial horizontal axis labels.
    */
    get shouldAutoExpandMarginForInitialLabels() {
        return this.i.pa;
    }
    set shouldAutoExpandMarginForInitialLabels(v) {
        this.i.pa = ensureBool(v);
    }
    /**
     * Gets or sets the MarkerBrushes property.
     * The brushes property defines the palette from which automatically assigned series brushes are selected.
    *
    * `markerBrushes` can be set declaratively to a list of color strings.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     markerBrushes="red,green,blue">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.markerBrushes="red,green,blue";
    * ```
    */
    get markerBrushes() {
        return fromBrushCollection(this.i.op);
    }
    set markerBrushes(v) {
        this.i.op = toBrushCollection(v);
    }
    /**
     * Gets or sets the palette of brushes to use for outlines on the chart series.
    *
    * `outlines` can be set declaratively to a list of color strings.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     outlines="red,green,blue">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.outlines="red,green,blue";
    * ```
    */
    get outlines() {
        return fromBrushCollection(this.i.or);
    }
    set outlines(v) {
        this.i.or = toBrushCollection(v);
    }
    /**
     * Gets or sets the MarkerOutlines property.
     * The brushes property defines the palette from which automatically assigned series brushes are selected.
    *
    * `markerOutlines` can be set declaratively to a list of color strings.
    *
    * ```html
    * <igx-data-chart [dataSource]="data"
    *     markerOutlines="red,green,blue">
    *   <igx-category-x-axis #xAxis
    *     label="label">
    *   </igx-category-x-axis>
    *   <igx-numeric-y-axis #yAxis>
    *   </igx-numeric-y-axis>
    *
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    *   <igx-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     valueMemberPath="value"
    *     markerType="circle">
    *   </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * this.chart.markerOutlines="red,green,blue";
    * ```
    */
    get markerOutlines() {
        return fromBrushCollection(this.i.oq);
    }
    set markerOutlines(v) {
        this.i.oq = toBrushCollection(v);
    }
    /**
     * Gets or sets the DefaultAxisStroke property.
     * The DefaultAxisStroke property defines the brush which is used by the axes when no Axis.Stroke is set.
    */
    get defaultAxisStroke() {
        return brushToString(this.i.re);
    }
    set defaultAxisStroke(v) {
        this.i.re = stringToBrush(v);
    }
    /**
     * Gets or sets the DefaultAxisMajorStroke property.
     * The DefaultAxisMajorStroke property defines the brush which is used by the axes when no Axis.MajorStroke is set.
    */
    get defaultAxisMajorStroke() {
        return brushToString(this.i.rc);
    }
    set defaultAxisMajorStroke(v) {
        this.i.rc = stringToBrush(v);
    }
    /**
     * Gets or sets the DefaultAxisMinorStroke property.
     * The DefaultAxisMinorStroke property defines the brush which is used by the axes when no Axis.MinorStroke is set.
    */
    get defaultAxisMinorStroke() {
        return brushToString(this.i.rd);
    }
    set defaultAxisMinorStroke(v) {
        this.i.rd = stringToBrush(v);
    }
    /**
     * Margin applied to the left of the plot area.
    */
    get plotAreaMarginLeft() {
        return this.i.pr;
    }
    set plotAreaMarginLeft(v) {
        this.i.pr = +v;
    }
    /**
     * Margin applied above the plot area.
    */
    get plotAreaMarginTop() {
        return this.i.pt;
    }
    set plotAreaMarginTop(v) {
        this.i.pt = +v;
    }
    /**
     * Margin applied to the right of the plot area.
    */
    get plotAreaMarginRight() {
        return this.i.ps;
    }
    set plotAreaMarginRight(v) {
        this.i.ps = +v;
    }
    /**
     * Margin applied below the plot area.
    */
    get plotAreaMarginBottom() {
        return this.i.pq;
    }
    set plotAreaMarginBottom(v) {
        this.i.pq = +v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.axes != null && this.axes.findByName && this.axes.findByName(name)) {
            return this.axes.findByName(name);
        }
        return null;
    }
    /**
 * Notifies the chart that the CSS styles in effect have been updated.

*/
    styleUpdated() {
        this.i.qr();
    }
    /**
     * Export serialized visual data.
    
    */
    exportSerializedVisualData() {
        let iv = this.i.p7();
        return (iv);
    }
};
__decorate([
    ContentChildren(IgxAxisComponent),
    __metadata("design:type", QueryList)
], IgxDataChartComponent.prototype, "contentAxes", void 0);
__decorate([
    ContentChildren(IgxSeriesComponent),
    __metadata("design:type", QueryList)
], IgxDataChartComponent.prototype, "contentSeries", void 0);
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxDataChartComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxDataChartComponent.prototype, "legend", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxDataChartComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "syncChannel", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "synchronizeVertically", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "synchronizeHorizontally", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "isSquare", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "windowScaleHorizontal", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "windowScaleVertical", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "actualWindowScaleHorizontal", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "actualWindowScaleVertical", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "isHorizontalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "isVerticalZoomEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "gridMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "alignsGridLinesToPixels", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDataChartComponent.prototype, "brushes", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "autoExpandMarginMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "autoExpandMarginExtraPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxDataChartComponent.prototype, "shouldAutoExpandMarginForInitialLabels", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDataChartComponent.prototype, "markerBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDataChartComponent.prototype, "outlines", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxDataChartComponent.prototype, "markerOutlines", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "defaultAxisStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "defaultAxisMajorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxDataChartComponent.prototype, "defaultAxisMinorStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "plotAreaMarginLeft", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "plotAreaMarginTop", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "plotAreaMarginRight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxDataChartComponent.prototype, "plotAreaMarginBottom", null);
IgxDataChartComponent = IgxDataChartComponent_1 = __decorate([
    Component({
        selector: 'igx-data-chart',
        template: `<ng-container #dynamicContent></ng-container>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: [{ provide: IgxSeriesViewerComponent, useExisting: forwardRef(() => IgxDataChartComponent_1) }],
        host: { 'class': 'igx-data-chart ig-data-chart' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        ComponentFactoryResolver,
        Injector])
], IgxDataChartComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHorizontalRangeCategorySeriesProxy_$type = new Type(null, 'IHorizontalRangeCategorySeriesProxy');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IHasHighLowValueCategory_$type = new Type(null, 'IHasHighLowValueCategory');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultHighLowValueProvider extends Base {
    get highColumn() {
        return new FastItemColumn(null, null, null, false);
    }
    get lowColumn() {
        return new FastItemColumn(null, null, null, false);
    }
}
DefaultHighLowValueProvider.$t = markType(DefaultHighLowValueProvider, 'DefaultHighLowValueProvider', Base.$, [IHasHighLowValueCategory_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HighLowValuesHolder extends ValuesHolder {
    constructor() {
        super(...arguments);
        this.f = null;
        this.g = null;
    }
    get_e() {
        if (this.f == null || this.g == null) {
            return 0;
        }
        return Math.min(this.f.count, this.g.count);
    }
    get e() {
        return this.get_e();
    }
}
HighLowValuesHolder.$t = markType(HighLowValuesHolder, 'HighLowValuesHolder', ValuesHolder.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeCategoryFramePreparer extends CategoryFramePreparerBase {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, f, g, h, i, j);
                        this.aa = null;
                        this.ab = null;
                        this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        this.ab = new DefaultHighLowValueProvider();
                        if (typeCast(IHasHighLowValueCategory_$type, f) !== null) {
                            this.ab = typeCast(IHasHighLowValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                    this.aa = null;
                    this.ab = null;
                    this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    this.ab = new DefaultHighLowValueProvider();
                    if (typeCast(IHasHighLowValueCategory_$type, c) !== null) {
                        this.ab = typeCast(IHasHighLowValueCategory_$type, c);
                    }
                }
                break;
        }
    }
    l(a, b, c, d, e, f) {
        let g = b[0];
        let h = b[1];
        let i = b[2];
        if (!isNaN_(g) && !isNaN_(h) && !isNaN_(i)) {
            a.m.add({ $type: Point_$type, x: g, y: (h + i) / 2 });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
    z(a, b, c, d) {
        let e = a;
        let f = e.f;
        let g = e.g;
        let h = f.item(b);
        let i = g.item(b);
        let j = Math.max(h, i);
        let k = Math.min(h, i);
        if (c) {
            e.c = k;
            e.d = j;
        }
        else {
            e.b = j;
            e.a = k;
        }
    }
    u(a, b, c) {
        let d = a;
        let e = d.f;
        let f = d.g;
        let g = e.item(b);
        let h = f.item(b);
        if (!isNaN_(g)) {
            d.b = Math.max(d.b, g);
            d.a = Math.min(d.a, g);
        }
        if (!isNaN_(h)) {
            d.b = Math.max(d.b, h);
            d.a = Math.min(d.a, h);
        }
    }
    e(a, b) {
        let c = b;
        return [a, c.a, c.b];
    }
    x(a, b, c, d, e, f) {
        if (d) {
            b[0] = b[0] + c;
        }
        else {
            b[0] = a.b.j$b(b[0], e) + c;
        }
        b[1] = a.c.j$b(b[1], f);
        b[2] = a.c.j$b(b[2], f);
    }
    y(a, b, c, d, e, f, g) {
        super.y(a, b, c, d, e, f, g);
        let h = a.h;
        let i = a.a.f.count;
        let j = a.a.f;
        let k = this.q;
        let l = k.count;
        let m = new List$1(Number_$type, 0);
        if (!c) {
            m.add(0);
        }
        let n = new List$1(Number_$type, 0);
        n.add(1);
        n.add(2);
        a.b.j$d(j, m, 0, i, d);
        a.c.j$d(j, n, 0, i, e);
        for (let o = 0; o < i; o++) {
            j._inner[o][0] = j._inner[o][0] + b;
        }
        if (g) {
            a.b.j$d(k, m, 0, l, d);
            a.c.j$d(k, n, 0, l, e);
            for (let p = 0; p < l; p++) {
                k._inner[p][0] = k._inner[p][0] + b;
            }
        }
    }
    j(a) {
        let b = new HighLowValuesHolder();
        b.f = this.ab.highColumn;
        b.g = this.ab.lowColumn;
        return b;
    }
}
RangeCategoryFramePreparer.$t = markType(RangeCategoryFramePreparer, 'RangeCategoryFramePreparer', CategoryFramePreparerBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeCategoryBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.j = null;
        this.l = 0;
        this.k = 0;
        this.i = null;
        this.h = null;
        this.j = a;
    }
    getBucketWithoutUnknowns(a) {
        let b = false;
        let c = this.i;
        let d = this.h;
        let e = this.l;
        let f = this.k;
        let g = Math.min(e, f);
        let h = a * this.d;
        let i = Math.min(h + this.d - 1, g - 1);
        let j = 1.7976931348623157E+308;
        let k = -1.7976931348623157E+308;
        let l = true;
        let m = 0;
        let n = 0;
        let o;
        let p;
        for (let q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                j = j < o ? j : o;
                k = k > o ? k : o;
                j = j < p ? j : p;
                k = k > p ? k : p;
            }
            else {
                j = Math.min(j, o);
                k = Math.max(k, o);
                k = Math.max(k, p);
                j = Math.min(j, p);
                l = false;
            }
        }
        if (b && n < m) {
            let r = j;
            j = k;
            k = r;
        }
        if (!l) {
            let s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        let t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    }
    getBucket(a) {
        let b = false;
        let c = this.i;
        let d = this.h;
        let e = this.l;
        let f = this.k;
        let g = Math.min(e, f);
        let h = a * this.d;
        let i = Math.min(h + this.d - 1, g - 1);
        let j = NaN;
        let k = NaN;
        let l = true;
        let m = 0;
        let n = 0;
        let o;
        let p;
        for (let q = h; q <= i; ++q) {
            m = c[q];
            n = d[q];
            if (m < n) {
                o = m;
                p = n;
            }
            else {
                p = m;
                o = n;
            }
            if (!l) {
                if (!isNaN_(o)) {
                    j = j < o ? j : o;
                    k = k > o ? k : o;
                }
                if (!isNaN_(p)) {
                    j = j < p ? j : p;
                    k = k > p ? k : p;
                }
            }
            else {
                if (!isNaN_(o)) {
                    if (isNaN_(j)) {
                        j = o;
                    }
                    else {
                        j = Math.min(j, o);
                    }
                    if (!isNaN_(k)) {
                        k = Math.max(k, o);
                    }
                }
                if (!isNaN_(p)) {
                    if (isNaN_(k)) {
                        k = p;
                    }
                    else {
                        k = Math.max(k, p);
                    }
                    if (!isNaN_(j)) {
                        j = Math.min(j, p);
                    }
                }
                if (!isNaN_(j) && !isNaN_(k)) {
                    l = false;
                }
            }
        }
        if (n < m && b) {
            let r = j;
            j = k;
            k = r;
        }
        if (!l) {
            let s = new Array(3);
            s[0] = 0.5 * (h + i);
            s[1] = j;
            s[2] = k;
            return s;
        }
        let t = new Array(3);
        t[0] = NaN;
        t[1] = NaN;
        t[2] = NaN;
        return t;
    }
    cacheValues() {
        this.l = this.j.cw.lowColumn.count;
        this.k = this.j.cw.highColumn.count;
        this.i = this.j.cw.lowColumn.asArray();
        this.h = this.j.cw.highColumn.asArray();
    }
    unCacheValues() {
        this.i = null;
        this.h = null;
    }
}
RangeCategoryBucketCalculator.$t = markType(RangeCategoryBucketCalculator, 'RangeCategoryBucketCalculator', CategoryBucketCalculator.$);
/**
 * @hidden
 */
class RangeCategorySeries extends CategorySeries {
    constructor() {
        super();
        this._RangeFramePreparer = null;
        this.pc = null;
        this.pb = null;
        this.o8 = null;
        this.RangeFramePreparer = new RangeCategoryFramePreparer(1, this, this.pa, this, this, this.pa.cn);
    }
    bf() {
        return new RangeCategorySeriesView(this);
    }
    getHostReferenceValue() {
        return this.eh();
    }
    i2(a) {
        super.i2(a);
        this.pa = a;
    }
    get RangeFramePreparer() {
        return this._RangeFramePreparer;
    }
    set RangeFramePreparer(a) {
        this._RangeFramePreparer = a;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == RangeCategorySeries.$$p[0]) {
            return this.ft(a, b, this.pg);
        }
        if (c == RangeCategorySeries.$$p[0]) {
            return this.ft(a, b, this.pg);
        }
        return super.fs(a, b);
    }
    get lowColumn() {
        return this.pc;
    }
    set lowColumn(a) {
        if (this.pc != a) {
            let b = this.pc;
            this.pc = a;
            this.raisePropertyChanged("LowColumn", b, this.pc);
        }
    }
    get highColumn() {
        return this.pb;
    }
    set highColumn(a) {
        if (this.pb != a) {
            let b = this.pb;
            this.pb = a;
            this.raisePropertyChanged("HighColumn", b, this.pb);
        }
    }
    nt() {
        return 11;
    }
    o1(a, b) {
        super.o1(a, b);
        b.b0 = true;
        CategoryMarkerManager.b(this, a.m, b.cq, this.mf);
        this.ov(b, a);
    }
    pl(a, b, c, d, e, f) {
        this.pa.cx(a, b, c, d, e, f);
    }
    c9(a) {
        let b = new Rect(0, 0, 0, 1, 1);
        let c = this.bi != null ? this.bi.bs : Rect.empty;
        c = c.copy();
        let d = this.bi != null ? this.bi.br : Rect.empty;
        let e = !c.isEmpty && !d.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        let f = this.fetchXAxis();
        let g = this.fetchYAxis();
        let h = this.l2(this.bi);
        let i;
        if (f != null) {
            let j = new ScalerParams(0, b, b, f.ca, h);
            i = f.dy(e, j);
        }
        else {
            i = NaN;
        }
        let k = f != null ? this.RangeFramePreparer.r(typeCast(ICategoryScaler_$type, f), b, b, h) : 0;
        i += k;
        if (e >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (!isNaN_(i)) {
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            if (g != null && this.highColumn != null && e < this.highColumn.count) {
                let l = new ScalerParams(0, b, b, g.ca, h);
                l.b = this.eh();
                let m = g.dy(this.highColumn.item(e), l);
                let n = g.dy(this.lowColumn.item(e), l);
                if (!isNaN_(m) && !isNaN_(n)) {
                    let o = Math.abs(n - m);
                    if (c.height < o) {
                        c.height = o;
                        c.y = Math.min(n, m);
                    }
                    else {
                        if (n < c.top + 0.1 * c.height) {
                            n = n + 0.4 * c.height;
                        }
                        if (n > c.bottom - 0.1 * c.height) {
                            n = n - 0.4 * c.height;
                        }
                        c.y = n - 0.5 * c.height;
                    }
                }
            }
            if (this.bn != null) {
                this.bn.ap(this.bs, c, true);
            }
        }
        return e >= 0;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.lowColumn);
                    c.deregisterColumn(this.highColumn);
                    this.lowColumn = null;
                    this.highColumn = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.lowColumn = this.bw(this.pj);
                    this.highColumn = this.bw(this.pg);
                }
                if (!this.oe()) {
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case RangeCategorySeries.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.lowColumn);
                    this.lowColumn = this.bw(this.pj);
                }
                break;
            case "LowColumn":
                if (!this.oe()) {
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case RangeCategorySeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.highColumn);
                    this.highColumn = this.bw(this.pg);
                }
                break;
            case "HighColumn":
                if (!this.oe()) {
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                }
                break;
        }
    }
    an(a) {
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            let b = Math.min(this.lowColumn.count, this.highColumn.count);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            let c = Math.min(this.lowColumn.minimum, this.highColumn.minimum);
            let d = Math.max(this.lowColumn.maximum, this.highColumn.maximum);
            return new AxisRange(Math.min(c, d), Math.max(c, d));
        }
        return null;
    }
    h6(a, b, c, d) {
        if (this.fetchXAxis() != null && typeCast(ISortingAxis_$type, this.fetchXAxis()) !== null) {
            this.fetchXAxis().i$i();
        }
        let e = this.fetchXAxis();
        switch (a) {
            case 3:
                if (d == this.pj || d == this.pg) {
                    if (e != null) {
                        e.cn();
                    }
                    if (!this.oe()) {
                        this.jl(true);
                    }
                }
                break;
            case 1:
                if (e != null) {
                    e.cn();
                }
                this.ns.cn.g(this.eu);
                if (!this.oe()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (e != null) {
                    e.cn();
                }
                this.ns.cn.g(this.eu);
                if (!this.oe()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (e != null) {
                    e.cn();
                }
                if (this.pj != null && this.pg != null && this.ns.cn.d > 0 && !this.oe()) {
                    this.jl(true);
                }
                break;
            case 4:
                if (e != null) {
                    e.cn();
                }
                this.ns.cn.g(this.eu);
                if (!this.oe()) {
                    this.jl(true);
                }
                break;
        }
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.lowColumn == null || this.lowColumn.count == 0 || this.highColumn == null || this.highColumn.count == 0) {
            d = false;
        }
        return d;
    }
    oy(a, b) {
        super.oy(a, b);
        this.RangeFramePreparer.d(a, b);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.fetchXAxis());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.fetchYAxis());
    }
    get bucketizer() {
        return this.ns.cn;
    }
    get currentMode2Index() {
        return this.om();
    }
    provideCollisionDetector() {
        return new CollisionAvoider();
    }
    get mayContainUnknowns() {
        return this.lowColumn == null || this.lowColumn.mayContainUnknowns || this.highColumn == null || this.highColumn.mayContainUnknowns;
    }
    jn(a, b) {
        let c = this.dl;
        super.jn(a, b);
        if (!c) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        let d = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, this.bh), this.bs.b1.m, this, this.bh.cn);
        if (!this.df) {
            this.nm = new CategoryFrame(3);
            this.nm.u();
            d.d(this.nm, this.bh);
        }
        this.df = false;
        this.o1(this.nm, this.bh);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.cn.g(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        let h = new RangeCategoryFramePreparer(1, this, typeCast(ISupportsMarkers_$type, f), f, this, f.cn);
        if (this.o8 == null) {
            this.o8 = new CategoryFrame(3);
        }
        this.o8.u();
        h.d(this.o8, g);
        this.o1(this.o8, g);
    }
    eh() {
        return Series.ei(this.lowColumn, typeCast(ISortingAxis_$type, this.fetchXAxis()));
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
RangeCategorySeries.$t = markType(RangeCategorySeries, 'RangeCategorySeries', CategorySeries.$, [IIsCategoryBased_$type, IHasHighLowValueCategory_$type]);
RangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeCategorySeries, 'raisePropertyChanged', ['HighMemberPath:pg:pm', [2, null], 'LowMemberPath:pj:pn', [2, null]]);
/**
 * @hidden
 */
class RangeCategorySeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cw = a;
    }
    cx(a, b, c, d, e, f) {
        a.ak.clear();
        b.ak.clear();
        c.ak.clear();
        let g = FastFlattener.b(d, e, true, f, this.e.eu);
        let h = FastFlattener.b(d, e, false, f, this.e.eu);
        let i = g.count;
        let j = h.count;
        let k;
        let l;
        let m;
        let n;
        for (let o = 0; o < i; o++) {
            k = g.item(o);
            l = e._inner[k];
            m = l[0];
            n = l[1];
            a.ak.add({ $type: Point_$type, x: m, y: n });
            b.ak.add({ $type: Point_$type, x: m, y: n });
        }
        let p;
        let q;
        for (let r = 0; r < j; r++) {
            k = h.item(r);
            l = e._inner[k];
            if (f) {
                p = l[0];
                q = l[2];
            }
            else {
                p = l[2];
                q = l[3];
            }
            c.ak.add({ $type: Point_$type, x: p, y: q });
            b.ak.add({ $type: Point_$type, x: p, y: q });
        }
        a.ab = a.ak.count > 0;
        b.ab = b.ak.count > 0;
        c.ab = c.ak.count > 0;
    }
    co() {
        return new RangeCategoryBucketCalculator(this);
    }
}
RangeCategorySeriesView.$t = markType(RangeCategorySeriesView, 'RangeCategorySeriesView', CategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalRangeCategorySeries extends RangeCategorySeries {
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    h1() {
        super.h1();
        this.xAxis = null;
        this.yAxis = null;
    }
    ah(a) {
        let b = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[2] };
        f[1] = { $type: Point_$type, x: d[0], y: d[2] };
        e[0] = f;
        return e;
    }
    ai(a) {
        let b = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), this.ly(a), true);
        if (b == null) {
            return null;
        }
        let c = b[0];
        let d = b[1];
        let e = new Array(1);
        let f = new Array(2);
        f[0] = { $type: Point_$type, x: c[0], y: c[1] };
        f[1] = { $type: Point_$type, x: d[0], y: d[1] };
        e[0] = f;
        return e;
    }
    get_c3() {
        return true;
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    getOffsetValue() {
        return this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    fc(a, b) {
        return this.fd(a, b, this.xAxis, runOn(this, this.oi), new RangeValueList(this.highColumn, this.lowColumn));
    }
    fe(a, b) {
        return this.ff(a, b, this.xAxis, runOn(this, this.oi), new RangeValueList(this.highColumn, this.lowColumn));
    }
    d9(a, b, c, d, e) {
        if (c == null) {
            return Number.POSITIVE_INFINITY;
        }
        let f = this.xAxis.j7;
        return this.ea(a, b, this.xAxis, d, e, f, runOn(this, this.oi));
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(new RangeValueList(this.highColumn, this.lowColumn), a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    el(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(this.lowColumn, a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    ej(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bs.n2, this.bi.br, this.xAxis.ca, d);
        let f = this.RangeFramePreparer.r(this.xAxis, this.bs.n2, this.bi.br, d);
        return this.ep(this.highColumn, a, this.xAxis, e, f, runOn(this, this.oi), b, c);
    }
    lr(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.ej), (d, e) => this.ff(d, e, this.xAxis, runOn(this, this.oi), this.highColumn), (d, e) => this.fd(d, e, this.xAxis, runOn(this, this.oi), this.highColumn));
    }
    lt(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, runOn(this, this.el), (d, e) => this.ff(d, e, this.xAxis, runOn(this, this.oi), this.lowColumn), (d, e) => this.fd(d, e, this.xAxis, runOn(this, this.oi), this.lowColumn));
    }
    lv(a, b, c) {
        return this.lx(a, b, c, this.RangeFramePreparer.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.yAxis, this.xAxis, null, null, null);
    }
    oe() {
        return this.yAxis != null && this.yAxis.cn();
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case HorizontalRangeCategorySeries.$$p[0]:
                this.h7(typeCast(Axis.$, c));
                this.jc(typeCast(Axis.$, d));
                this.ns.cn.g(this.eu);
                this.jl(false);
                this.it();
                break;
            case HorizontalRangeCategorySeries.$$p[1]:
                this.h7(typeCast(Axis.$, c));
                this.jc(typeCast(Axis.$, d));
                this.ns.cn.g(this.eu);
                this.oe();
                this.jl(false);
                this.it();
                break;
        }
    }
    pr(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    pq(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
HorizontalRangeCategorySeries.$t = markType(HorizontalRangeCategorySeries, 'HorizontalRangeCategorySeries', RangeCategorySeries.$);
HorizontalRangeCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalRangeCategorySeries, 'raisePropertyChanged', ['XAxis::pu', [CategoryAxisBase.$, null], 'YAxis::pv', [NumericYAxis.$, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalRangeCategorySeriesProxy extends Base {
    matchesType(a) {
        return typeCast(HorizontalRangeCategorySeries.$, a) !== null;
    }
    setHighMemberPath(a, b) {
        a.pg = b;
    }
    setLowMemberPath(a, b) {
        a.pj = b;
    }
    setXAxis(a, b) {
        a.xAxis = b;
    }
    setYAxis(a, b) {
        a.yAxis = b;
    }
}
HorizontalRangeCategorySeriesProxy.$t = markType(HorizontalRangeCategorySeriesProxy, 'HorizontalRangeCategorySeriesProxy', Base.$, [IHorizontalRangeCategorySeriesProxy_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHorizontalRangeCategorySeriesProxyModule = class IgxHorizontalRangeCategorySeriesProxyModule {
    constructor() {
        TypeRegistrar.register('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy.$type);
    }
};
IgxHorizontalRangeCategorySeriesProxyModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxHorizontalRangeCategorySeriesProxyModule);

/**
 * Represents the base class for all IgxDataChartComponent ranged category/value series.
*
* The `IgxRangeCategorySeriesComponent` represents the base class for all IgxDataChartComponent ranged category/value series.
*
* ```html
* <igx-data-chart  #chart
*     [dataSource]="data">
*     <igx-category-x-axis
*     label="label"
*     #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
*     </igx-numeric-y-axis>
*     <igx-range-column-series
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     highMemberPath="high"
*     lowMemberPath="low">
* </igx-range-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxRangeColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* this.chart.series.add(series);
* ```
*/
const IgxRangeCategorySeriesComponent_PROVIDERS = [{ provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeCategorySeriesComponent) }];
class IgxRangeCategorySeriesComponent extends IgxCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    *
    * The `lowMemberPath` is used for low mapping property of the current series object.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxRangeColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.highMemberPath = "high";
    * series.lowMemberPath = "low";
    * this.chart.series.add(series);
    * ```
    */
    get lowMemberPath() {
        return this.i.pj;
    }
    set lowMemberPath(v) {
        this.i.pj = v;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    *
    * Use `highMemberPath` propert for high mapping of the current series object.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data">
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis>
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.highMemberPath = "high";
    * ```
    */
    get highMemberPath() {
        return this.i.pg;
    }
    set highMemberPath(v) {
        this.i.pg = v;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    *
    * `scrollIntoView` method Scrolls the series to display the item for the specified data item.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRangeCategorySeriesComponent.prototype, "lowMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxRangeCategorySeriesComponent.prototype, "highMemberPath", null);

/**
 * Base class for ranged category series with a category X-axis and a numeric Y-axis.
*
* Instantiate HorizontalAnchoredCategorySeries
*
* ```html
*  <igx-data-chart
*       [dataSource]="data"  >
* 	 <igx-column-series
*         #series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value"
*           >
*       </igx-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.valueMemberPath="value";
* this.chart.series.add(series);
* ```
*/
const IgxHorizontalRangeCategorySeriesComponent_PROVIDERS = [{ provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxHorizontalRangeCategorySeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxHorizontalRangeCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxHorizontalRangeCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxHorizontalRangeCategorySeriesComponent) }];
class IgxHorizontalRangeCategorySeriesComponent extends IgxRangeCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the effective x-axis for the current CategorySeries object.
    *
    * Instantiate xAxis
    *
    * <!-- Angular -->
    *
    * ```html
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	  <igx-category-x-axis
    *         label="label"
    *         #xAxis
    *         >
    *       </igx-category-x-axis>
    * 	 <igx-column-series
    *     ...
    *         [xAxis]="xAxis"
    *     ...
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current CategorySeries object.
    *
    * Instantiate yAxis
    *
    * <!-- Angular -->
    *
    * ```js
    *  <igx-data-chart
    *       [dataSource]="data"  >
    * 	  <igx-numeric-y-axis
    *         minimumValue="0"
    *         #yAxis>
    *       </igx-numeric-y-axis>
    * 	 <igx-column-series
    *     ...
    *         [yAxis]="yAxis"
    *     ...
    *           >
    *       </igx-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * let series = new IgxColumnSeriesComponent();
    * series.xAxis = this.xAxis;
    * series.yAxis = this.yAxis;
    * series.valueMemberPath="value";
    * this.chart.series.add(series);
    * ```
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    /**
     * Checks if this series is a range series
    *
    * You can use the `isRange` to get the current series is a range type series.
    *
    * <!-- Angular JS -->
    *
    * ```ts
    *   var r = this.series.isRange;
    * ```
    */
    get isRange() {
        return this.i.c3;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    *
    * You can use the `getOffsetValue` to get the offset value for this series if grouped on a category axis.
    *
    * <!-- Angular JS -->
    *
    *       var g = series.getOffsetValue();
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    *
    * You can use the `getCategoryWidth` to get the width of the category grouping a series is in.
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    *
    * <!-- Ignite JS -->
    *
    *      N/A
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesLowValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.el(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.ej(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesHighValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lr(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesLowValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lt(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsYAxis` method to determine if object can be used as YAxis
    */
    canUseAsYAxis(axis) {
        let iv = this.i.pr(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    *
    * You can use the `canUseAsXAxis` method to determine if object can be used as XAxis
    *
    * <!-- Angular JS -->
    *
    *      var x = this.financialSeries.CanUseAsXAxis(this.xAxis);
    */
    canUseAsXAxis(axis) {
        let iv = this.i.pq(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAxisBaseComponent),
    __metadata("design:paramtypes", [IgxCategoryAxisBaseComponent])
], IgxHorizontalRangeCategorySeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxHorizontalRangeCategorySeriesComponent.prototype, "yAxis", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeAreaSeries extends HorizontalRangeCategorySeries {
    constructor() {
        super();
        this.ab = RangeAreaSeries.$;
    }
    bf() {
        return new RangeAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pw = a;
    }
    get_ck() {
        return true;
    }
    px(a, b, c, d) {
        if (isNaN_(b.x) || isNaN_(b.y)) {
            return false;
        }
        if (isNaN_(c.x) || isNaN_(c.y)) {
            return false;
        }
        if ((a.y <= b.y && a.y >= c.y)) {
            return true;
        }
        return false;
    }
    dh(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.cz();
    }
    o1(a, b) {
        super.o1(a, b);
        let c = a.f.count;
        let d = new List$1(Array_$type, 2, c);
        for (let e = 0; e < c; e++) {
            let f = a.f._inner[e];
            let g = new Array(4);
            g[0] = f[0];
            g[1] = f[1];
            let h = a.f._inner[a.f.count - 1 - e];
            g[2] = h[0];
            g[3] = h[2];
            d.add(g);
        }
        let i = typeCast(RangeAreaSeriesView.$, b);
        let j = this.getEffectiveViewport1(i);
        this.nr.x(this, this.oc(), this.xAxis, runOn(this, this.nd), this.ok(b), this.ol(b));
        let k = false;
        let l = this.nr.c;
        if (l != null) {
            k = true;
        }
        if (k) {
            let m = new ScalerParams(0, b.bs, b.br, this.xAxis.ca, j);
            this.ox(d, -1, this.lowColumn.count, this.xAxis, m, b.n);
        }
        let n = i.c8;
        let o = i.c9;
        let p = i.c3;
        this.nr.ae(n, true, false, true, true);
        this.nr.ae(o, true, false, true, true);
        this.nr.ae(p, false, true, false, false);
        if (b.cr(a)) {
            i.c0(a.f.count, d, false);
            b.cu(a);
        }
        i.c3._opacity = this.nr.i * this.d6;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
RangeAreaSeries.$t = markType(RangeAreaSeries, 'RangeAreaSeries', HorizontalRangeCategorySeries.$);
/**
 * @hidden
 */
class RangeAreaSeriesView extends RangeCategorySeriesView {
    constructor(a) {
        super(a);
        this.cy = null;
        this.c6 = new Polyline();
        this.c2 = new Polygon();
        this.c7 = new Polyline();
        this.c5 = new Polyline();
        this.c4 = new Polyline();
        this.c1 = new Polygon();
        this.cy = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get c8() {
        return this.c6;
    }
    get c3() {
        return this.c2;
    }
    get c9() {
        return this.c7;
    }
    cz() {
        this.c2.ak.clear();
        this.c6.ak.clear();
        this.c7.ak.clear();
    }
    c0(a, b, c) {
        this.cx(this.c6, this.c2, this.c7, a, b, c);
        this.an();
    }
    a9() {
        super.a9();
        this.c4.ak = this.c6.ak;
        this.c5.ak = this.c7.ak;
        this.c1.ak = this.c2.ak;
        let a = this.bl();
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
        this.c5._stroke = a;
        this.c5.ac = this.e.ey + 3;
        this.c1._fill = a;
        this.c1._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            if (b) {
                a.t(this.c1);
                a.u(this.c4);
                a.u(this.c5);
            }
            else {
                a.t(this.c2);
                a.u(this.c6);
                a.u(this.c7);
            }
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPolylineData(a, this.c6, "lowerShape", ["Lower"]);
        this.e.a2.exportPolylineData(a, this.c7, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPolygonData(a, this.c2, "fillShape", ["Fill"]);
    }
}
RangeAreaSeriesView.$t = markType(RangeAreaSeriesView, 'RangeAreaSeriesView', RangeCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRangeAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent range area series.
*
* The `IgxRangeAreaSeriesComponent` class represents the range area series of the IgxDataChartComponent.
*
* ```html
* <igx-data-chart
* [dataSource]="data">
* <igx-category-x-axis
* 	label="label"
* 	#xAxis>
* </igx-category-x-axis>
* <igx-numeric-y-axis
* 	#yAxis>
* </igx-numeric-y-axis>
*     <igx-range-area-series
*       [xAxis]="xAxis"
*       [yAxis]="yAxis"
*       highMemberPath="high"
*       lowMemberPath="low">
*   </igx-range-area-series>
*     </igx-data-chart>
* </igx-data-chart>
* ```
*
* ```ts
* let series: IgxRangeAreaSeriesComponent = new IgxRangeAreaSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "High";
* series.lowMemberPath = "Low";
* this.chart.series.add(series);
* ```
*/
const IgxRangeAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent) }];
let IgxRangeAreaSeriesComponent = IgxRangeAreaSeriesComponent_1 = class IgxRangeAreaSeriesComponent extends IgxHorizontalRangeCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RangeAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    *
    * Use the `isAreaOrLine` property to check if the current series shows an area or line shape.
    *
    * ```ts
    * var x= series.isAreaOrLine;
    * ```
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxRangeAreaSeriesComponent = IgxRangeAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-range-area-series',
        template: ``,
        providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent_1) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRangeAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRangeAreaSeriesModule = class IgxRangeAreaSeriesModule {
};
IgxRangeAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRangeAreaSeriesComponent],
        imports: [CommonModule, IgxHorizontalRangeCategorySeriesProxyModule],
        exports: [IgxRangeAreaSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxRangeAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRangeAreaSeriesDynamicModule = class IgxRangeAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRangeAreaSeriesComponent", IgxRangeAreaSeriesComponent);
        TypeRegistrar.register("RangeAreaSeries", RangeAreaSeries.$type);
    }
};
IgxRangeAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRangeAreaSeriesModule],
        exports: [IgxRangeAreaSeriesModule],
        entryComponents: [IgxRangeAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRangeAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RangeColumnSeries extends HorizontalRangeCategorySeries {
    constructor() {
        super();
        this.ab = RangeColumnSeries.$;
    }
    bf() {
        return new RangeColumnSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pw = a;
    }
    get_n8() {
        return true;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    l4(a) {
        if (this.xAxis == null || this.yAxis == null) {
            return Rect.empty;
        }
        let b = this.lq(a);
        let c = this.bi.bs;
        let d = this.bi.br;
        let e = this.getEffectiveViewport1(this.bi);
        let f = new ScalerParams(0, c, d, this.yAxis.ca, e);
        f.b = this.eh();
        let g = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        let h = g[0];
        let i = g[1];
        let j = Math.abs(b.x - h[0]);
        let k = Math.abs(b.x - i[0]);
        let l = this.xAxis.jz(c, d, e);
        if (j < k) {
            let m = h[0] - 0.5 * l;
            let n = h[1];
            let o = h[2];
            return new Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
        }
        else {
            let p = i[0] - 0.5 * l;
            let q = i[1];
            let r = i[2];
            return new Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a && c.cz != null) {
            c.cz.count = 0;
        }
    }
    eg() {
        return this.xAxis.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    o1(a, b) {
        super.o1(a, b);
        let c = typeCast(RangeColumnSeriesView.$, b);
        let d = a.f;
        let e = b.bs;
        let f = b.br;
        let g = this.getEffectiveViewport1(b);
        let h = this.xAxis.jz(e, f, g);
        if (isNaN_(h) || isInfinity(h)) {
            c.cz.count = 0;
            return;
        }
        this.nr.x(this, this.oc(), this.xAxis, runOn(this, this.nd), this.ok(b), this.ol(b));
        this.nr.p = this.px;
        this.nr.q = this.py;
        this.nr.j = this.px;
        this.nr.k = this.py;
        let i = false;
        let j = this.nr.c;
        if (j != null) {
            i = true;
        }
        let k = this.xAxis.cf;
        let l = this.lowColumn.count;
        let m = this.xAxis;
        let n = new ScalerParams(0, e, f, this.xAxis.ca, g);
        let o = 0;
        for (let p = 0; p < d.count; ++p) {
            let q = d._inner[p][0] - 0.5 * h;
            let r = Math.min(d._inner[p][1], d._inner[p][2]);
            let s = Math.max(d._inner[p][1], d._inner[p][2]);
            let t = Math.abs(s - r);
            if (isInfinity(t)) {
                continue;
            }
            let u = c.cz.item(o);
            o++;
            u.width = h;
            u.height = t;
            if (i) {
                this.ox(d, p, l, m, n, b.n);
            }
            this.nr.ae(u, false, false, false, false);
            u.am = this.nr.j;
            u.an = this.nr.k;
            c.c4(u, q, r);
        }
        c.cz.count = o;
        b.cu(a);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
RangeColumnSeries.$t = markType(RangeColumnSeries, 'RangeColumnSeries', HorizontalRangeCategorySeries.$);
RangeColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RangeColumnSeries, 'raisePropertyChanged', ['RadiusX:px:p1', [1, 2], 'RadiusY:py:p2', [1, 2]]);
/**
 * @hidden
 */
class RangeColumnSeriesView extends RangeCategorySeriesView {
    constructor(a) {
        super(a);
        this.cy = null;
        this.cz = null;
        this.c0 = null;
        this.c5 = new Rectangle();
        this.cy = a;
        this.cz = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.c6);
            $ret.activate = runOn(this, this.c1);
            $ret.disactivate = runOn(this, this.c3);
            $ret.destroy = runOn(this, this.c2);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.c0 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    c6() {
        let a = new Rectangle();
        this.c0.add(a);
        a._visibility = 1;
        return a;
    }
    c1(a) {
        a._visibility = 0;
    }
    c3(a) {
        a._visibility = 1;
    }
    c2(a) {
        this.c0.remove(a);
    }
    c4(a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    }
    z(a) {
        return this.c0._inner[a];
    }
    y(a) {
        let b = this.c0._inner[a];
        this.c5._visibility = b._visibility;
        this.c5.n = b.n;
        this.c5.o = b.o;
        this.c5.width = b.width;
        this.c5.height = b.height;
        let c = this.bm(a);
        this.c5._fill = c;
        this.c5._stroke = c;
        this.c5.ac = this.e.ey + 3;
        return this.c5;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c0.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.cz.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
}
RangeColumnSeriesView.$t = markType(RangeColumnSeriesView, 'RangeColumnSeriesView', RangeCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRangeColumnSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent range column series.
*
* The `IgxRangeColumnSeriesComponent` class represents range column series of the IgxDataChartComponent.
*
* ```html
* <igx-data-chart  #chart
*     [dataSource]="data">
*     <igx-category-x-axis
*     label="label"
*     #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*     minimumValue="0"
*     #yAxis>
*     </igx-numeric-y-axis>
*     <igx-range-column-series
*     [xAxis]="xAxis"
*     [yAxis]="yAxis"
*     highMemberPath="high"
*     lowMemberPath="low">
* </igx-range-column-series>
* </igx-data-chart>
* ```
*
* ```ts
* let series = new IgxRangeColumnSeriesComponent();
* series.xAxis = this.xAxis;
* series.yAxis = this.yAxis;
* series.highMemberPath = "high";
* series.lowMemberPath = "low";
* this.chart.series.add(series);
* ```
*/
const IgxRangeColumnSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent) }];
let IgxRangeColumnSeriesComponent = IgxRangeColumnSeriesComponent_1 = class IgxRangeColumnSeriesComponent extends IgxHorizontalRangeCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RangeColumnSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    *
    * Use the `radiusX` property to round the corners of the column.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data"
    *     >
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     radiusX="10">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.radiusX=10;
    * ```
    */
    get radiusX() {
        return this.i.px;
    }
    set radiusX(v) {
        this.i.px = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    *
    * Use the `radiusY` property for the y-radius of the ellipse that is used to round the corners of the column.
    *
    * ```html
    * <igx-data-chart  #chart
    *     [dataSource]="data"
    *     >
    *     <igx-category-x-axis
    *     label="label"
    *     #xAxis
    *     >
    *     </igx-category-x-axis>
    *     <igx-numeric-y-axis
    *     minimumValue="0"
    *     #yAxis>
    *     </igx-numeric-y-axis>
    *     <igx-range-column-series
    *
    *     [xAxis]="xAxis"
    *     [yAxis]="yAxis"
    *     highMemberPath="high"
    *     lowMemberPath="low"
    *     radiusY= "10">
    * </igx-range-column-series>
    * </igx-data-chart>
    * ```
    *
    * ```ts
    * series.radiusY=10;
    * ```
    */
    get radiusY() {
        return this.i.py;
    }
    set radiusY(v) {
        this.i.py = +v;
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    *
    * The `getSeriesValueBoundingBox` method return the best available value of the bounding box within the series.
    *
    * ```ts
    * series.getSeriesValueBoundingBox(world :IgxPoint) : IgxRect
    * ```
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    *
    * The `getItemSpan` method returns the current width of the items within the categories.
    *
    * ```ts
    * var x =series.getItemSpan();
    * ```
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRangeColumnSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRangeColumnSeriesComponent.prototype, "radiusY", null);
IgxRangeColumnSeriesComponent = IgxRangeColumnSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-range-column-series',
        template: ``,
        providers: [{ provide: IgxHorizontalRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent_1) }, { provide: IgxRangeCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRangeColumnSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRangeColumnSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRangeColumnSeriesModule = class IgxRangeColumnSeriesModule {
};
IgxRangeColumnSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRangeColumnSeriesComponent],
        imports: [CommonModule, IgxHorizontalRangeCategorySeriesProxyModule],
        exports: [IgxRangeColumnSeriesComponent, IgxHorizontalRangeCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxRangeColumnSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRangeColumnSeriesDynamicModule = class IgxRangeColumnSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRangeColumnSeriesComponent", IgxRangeColumnSeriesComponent);
        TypeRegistrar.register("RangeColumnSeries", RangeColumnSeries.$type);
    }
};
IgxRangeColumnSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRangeColumnSeriesModule],
        exports: [IgxRangeColumnSeriesModule],
        entryComponents: [IgxRangeColumnSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRangeColumnSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCoreModule = class IgxDataChartCoreModule {
    constructor() {
        TypeRegistrar.register('XamDataChart', XamDataChart.$type);
    }
};
IgxDataChartCoreModule = __decorate([
    NgModule({
        declarations: [IgxDataChartComponent],
        exports: [IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule,
            IgxDataChartComponent
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCoreDynamicModule = class IgxDataChartCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxDataChartComponent', IgxDataChartComponent);
        TypeRegistrar.registerCons('XamDataChart', XamDataChart);
        TypeRegistrar.register('XamDataChart', XamDataChart.$type);
    }
};
IgxDataChartCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxDataChartCoreModule
        ],
        entryComponents: [IgxDataChartComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryCoreModule = class IgxDataChartCategoryCoreModule {
};
IgxDataChartCategoryCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxCategoryXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartCategoryCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryCoreDynamicModule = class IgxDataChartCategoryCoreDynamicModule {
};
IgxDataChartCategoryCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartCategoryCoreModule
        ],
        imports: [CommonModule, IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartCategoryCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartCategoryCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryModule = class IgxDataChartCategoryModule {
};
IgxDataChartCategoryModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxLineSeriesModule,
            IgxAreaSeriesModule,
            IgxColumnSeriesModule,
            IgxSplineSeriesModule,
            IgxSplineAreaSeriesModule,
            IgxStepLineSeriesModule,
            IgxStepAreaSeriesModule,
            IgxPointSeriesModule,
            IgxWaterfallSeriesModule,
            IgxRangeAreaSeriesModule,
            IgxRangeColumnSeriesModule,
            IgxDataChartCategoryCoreModule
        ],
        imports: [CommonModule, IgxLineSeriesModule,
            IgxAreaSeriesModule,
            IgxColumnSeriesModule,
            IgxSplineSeriesModule,
            IgxSplineAreaSeriesModule,
            IgxStepLineSeriesModule,
            IgxStepAreaSeriesModule,
            IgxPointSeriesModule,
            IgxWaterfallSeriesModule,
            IgxRangeAreaSeriesModule,
            IgxRangeColumnSeriesModule,
            IgxDataChartCategoryCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartCategoryModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartCategoryDynamicModule = class IgxDataChartCategoryDynamicModule {
};
IgxDataChartCategoryDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxRangeAreaSeriesDynamicModule,
            IgxRangeColumnSeriesDynamicModule,
            IgxDataChartCategoryCoreDynamicModule,
            IgxDataChartCategoryModule
        ],
        imports: [CommonModule, IgxLineSeriesDynamicModule,
            IgxAreaSeriesDynamicModule,
            IgxColumnSeriesDynamicModule,
            IgxSplineSeriesDynamicModule,
            IgxSplineAreaSeriesDynamicModule,
            IgxStepLineSeriesDynamicModule,
            IgxStepAreaSeriesDynamicModule,
            IgxPointSeriesDynamicModule,
            IgxWaterfallSeriesDynamicModule,
            IgxRangeAreaSeriesDynamicModule,
            IgxRangeColumnSeriesDynamicModule,
            IgxDataChartCategoryCoreDynamicModule,
            IgxDataChartCategoryModule
        ],
        entryComponents: []
    })
], IgxDataChartCategoryDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartPolarCoreModule = class IgxDataChartPolarCoreModule {
};
IgxDataChartPolarCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericAngleAxisModule,
            IgxNumericRadiusAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxNumericAngleAxisModule,
            IgxNumericRadiusAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartPolarCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartPolarCoreDynamicModule = class IgxDataChartPolarCoreDynamicModule {
};
IgxDataChartPolarCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericAngleAxisDynamicModule,
            IgxNumericRadiusAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartPolarCoreModule
        ],
        imports: [CommonModule, IgxNumericAngleAxisDynamicModule,
            IgxNumericRadiusAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartPolarCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartPolarCoreDynamicModule);

/**
 * Represents the base class from which all IgxDataChartComponent polar series are derived.
*/
const IgxPolarBaseComponent_PROVIDERS = [{ provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarBaseComponent) }];
class IgxPolarBaseComponent extends IgxMarkerSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if this series is a polar series
    */
    get isPolar() {
        return this.i.c0;
    }
    /**
     * Gets or sets the path to use to find the angle values for the series.
    */
    get angleMemberPath() {
        return this.i.n9;
    }
    set angleMemberPath(v) {
        this.i.n9 = v;
    }
    /**
     * Gets or sets the path to use to get the radius values for the series.
    */
    get radiusMemberPath() {
        return this.i.of;
    }
    set radiusMemberPath(v) {
        this.i.of = v;
    }
    /**
     * Gets the effective angle axis for the current series object.
    */
    get angleAxis() {
        if (this.i.ng == null) {
            return null;
        }
        if (!this.i.ng.externalObject) {
            let e = IgxNumericAngleAxisComponent._createFromInternal(this.i.ng);
            if (e) {
                e._implementation = this.i.ng;
            }
            this.i.ng.externalObject = e;
        }
        return this.i.ng.externalObject;
    }
    set angleAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ng = null : this.i.ng = v.i;
    }
    /**
     * Gets the effective radius axis for the current series object.
    */
    get radiusAxis() {
        if (this.i.nh == null) {
            return null;
        }
        if (!this.i.nh.externalObject) {
            let e = IgxNumericRadiusAxisComponent._createFromInternal(this.i.nh);
            if (e) {
                e._implementation = this.i.nh;
            }
            this.i.nh.externalObject = e;
        }
        return this.i.nh.externalObject;
    }
    set radiusAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nh = null : this.i.nh = v.i;
    }
    /**
     * Gets or sets whether Cartesian Interpolation should be used rather than Archimedian
     * spiral based interpolation.
    */
    get useCartesianInterpolation() {
        return this.i.n1;
    }
    set useCartesianInterpolation(v) {
        this.i.n1 = ensureBool(v);
    }
    /**
     * Gets or sets the maximum number of markers displayed by the current series.
     * If more than the specified number of markers are visible, the polar series will automatically
     * choose a representative set.
    */
    get maximumMarkers() {
        return this.i.n4;
    }
    set maximumMarkers(v) {
        this.i.n4 = +v;
    }
    /**
     * Gets or sets the trend type for the current series object.
    */
    get trendLineType() {
        return this.i.ns;
    }
    set trendLineType(v) {
        this.i.ns = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush that specifies how the current series
     * object's trend line is drawn.
    */
    get trendLineBrush() {
        return brushToString(this.i.o5);
    }
    set trendLineBrush(v) {
        this.i.o5 = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this series.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.o4);
    }
    set actualTrendLineBrush(v) {
        this.i.o4 = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current series object's trend line.
    */
    get trendLineThickness() {
        return this.i.n3;
    }
    set trendLineThickness(v) {
        this.i.n3 = +v;
    }
    /**
     * Gets or sets the moving average period for the current series object.
    */
    get trendLinePeriod() {
        return this.i.n5;
    }
    set trendLinePeriod(v) {
        this.i.n5 = +v;
    }
    /**
     * Sets or Gets the Trendline Z index.
    */
    get trendLineZIndex() {
        return this.i.n6;
    }
    set trendLineZIndex(v) {
        this.i.n6 = +v;
    }
    /**
     * Gets or sets whether to clip the series to the bounds.
     * Setting this to true can effect performance.
    */
    get clipSeriesToBounds() {
        return this.i.nz;
    }
    set clipSeriesToBounds(v) {
        this.i.nz = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.angleAxis && this.angleAxis.name && this.angleAxis.name == name) {
            return this.angleAxis;
        }
        if (this.radiusAxis && this.radiusAxis.name && this.radiusAxis.name == name) {
            return this.radiusAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.angleAxis && this.angleAxis._styling) {
            this.angleAxis._styling(container, component, this);
        }
        if (this.radiusAxis && this.radiusAxis._styling) {
            this.radiusAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Scrolls the requested item into view, if possible.
    
    * @param item  * The item to scroll into view.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Determine if object can be used as RadiusAxis
    
    * @param axis  * The object to check
    */
    canUseAsRadiusAxis(axis) {
        let iv = this.i.ny(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as AngleAxis
    
    * @param axis  * The object to check
    */
    canUseAsAngleAxis(axis) {
        let iv = this.i.nx(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPolarBaseComponent.prototype, "angleMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPolarBaseComponent.prototype, "radiusMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericAngleAxisComponent),
    __metadata("design:paramtypes", [IgxNumericAngleAxisComponent])
], IgxPolarBaseComponent.prototype, "angleAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericRadiusAxisComponent),
    __metadata("design:paramtypes", [IgxNumericRadiusAxisComponent])
], IgxPolarBaseComponent.prototype, "radiusAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxPolarBaseComponent.prototype, "useCartesianInterpolation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarBaseComponent.prototype, "maximumMarkers", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarBaseComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPolarBaseComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPolarBaseComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarBaseComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarBaseComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarBaseComponent.prototype, "trendLineZIndex", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxPolarBaseComponent.prototype, "clipSeriesToBounds", null);

/**
 * Represents the base class from which all IgxDataChartComponent polar line series are derived.
*/
const IgxPolarLineSeriesBaseComponent_PROVIDERS = [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarLineSeriesBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesBaseComponent) }];
class IgxPolarLineSeriesBaseComponent extends IgxPolarBaseComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarAxisInfoCache extends Base {
    constructor(a, b, c) {
        super();
        this.a = null;
        this.b = null;
        this.e = false;
        this.g = false;
        this.d = false;
        this.f = false;
        this.c = null;
        this.i = 0;
        this.h = 0;
        this.a = a;
        this.b = b;
        this.e = this.a.j2;
        this.d = this.a.ca;
        this.g = this.b.j2;
        this.f = this.b.ca;
        this.i = this.b.lr;
        this.h = this.b.lq;
        this.c = c;
    }
}
PolarAxisInfoCache.$t = markType(PolarAxisInfoCache, 'PolarAxisInfoCache');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesRenderer$2 extends Base {
    constructor($tFrame, $tView, a, ..._rest) {
        super();
        this.$tFrame = null;
        this.$tView = null;
        this.c = null;
        this.d = null;
        this.a = null;
        this.e = null;
        this.f = null;
        this.b = null;
        this.$tFrame = $tFrame;
        this.$tView = $tView;
        this.$type = this.$type.specialize(this.$tFrame, this.$tView);
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    this.c = c;
                    this.d = d;
                    this.a = (h) => {
                    };
                    this.f = e;
                    this.e = f;
                    this.b = g;
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    let h = _rest[5];
                    this.c = c;
                    this.d = d;
                    this.a = h;
                    this.f = e;
                    this.e = f;
                    this.b = g;
                }
                break;
        }
    }
    g(a, b, c, d, e) {
        let f = 0;
        f = a.c;
        if (a.a && f > 0 && !a.b) {
            let g = b;
            if (this.f()) {
                this.b();
                b = d;
                d = g;
            }
            else {
                b = c;
                c = g;
            }
            this.a(c);
            this.c(c, e);
            this.e();
        }
        else {
            if (!a.b) {
                this.a(c);
                this.c(c, e);
            }
            this.d(c, e);
        }
        return {
            p1: b,
            p2: c,
            p3: d
        };
    }
}
SeriesRenderer$2.$t = markType(SeriesRenderer$2, 'SeriesRenderer$2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class OwnedPoint extends Base {
    constructor() {
        super();
        this.c = null;
        this.a = null;
        this.b = null;
        this.b = { $type: Point_$type, x: 0, y: 0 };
    }
}
OwnedPoint.$t = markType(OwnedPoint, 'OwnedPoint');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterFrameBase$1 extends Frame {
    constructor($t) {
        super();
        this.$t = null;
        this.f = null;
        this.o = null;
        this.j = null;
        this.g = null;
        this.m = null;
        this.n = null;
        this.h = null;
        this.l = null;
        this.i = null;
        this.k = null;
        this.$t = $t;
        this.$type = this.$type.specialize(this.$t);
        this.m = new List$1(Point_$type, 0);
        this.g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        this.j = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        this.n = new List$1(Point_$type, 0);
        this.h = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        this.l = new Dictionary$2(Base.$, OwnedPoint.$, 0);
        this.i = new Dictionary$2(Base.$, Array_$type, 0);
        this.k = new Dictionary$2(Base.$, Array_$type, 0);
        this.o = (a, b, c) => a;
        this.f = new DictInterpolator$3(Base.$, OwnedPoint.$, ScatterFrameBase$1.$.specialize(this.$t), runOn(this, this.s), (a) => a.a, (a) => !isNaN_(a.c.x) && !isNaN_(a.c.y), () => new OwnedPoint());
    }
    c(a, b, c) {
        let d = b;
        let e = c;
        if (d == null || e == null) {
            return;
        }
        this.f.f(this.g, a, d.g, e.g, d, e);
        Frame.a(this.m, a, d.m, e.m);
        this.f.f(this.j, a, d.j, e.j, d, e);
        this.f.f(this.h, a, d.h, e.h, d, e);
        this.f.f(this.l, a, d.l, e.l, d, e);
        this.p(this.j, a, d, e);
        Frame.a(this.n, a, d.n, e.n);
        this.i = e.i;
        this.k = e.k;
        this.r(a, d, e);
    }
    r(a, b, c) {
    }
    p(a, b, c, d) {
        for (let e of fromEnum(c.g.values)) {
            if (a.containsKey(e.a)) {
                continue;
            }
            let f;
            if (!((() => { let g = d.g.tryGetValue(e.a, f); f = g.p1; return g.ret; })()) || (f.b.x == e.b.x && f.b.y == e.b.y)) {
                continue;
            }
            let g = new OwnedPoint();
            this.s(g, b, e, f, c, d);
            if (isNaN_(g.c.x) || isNaN_(g.c.y)) {
                continue;
            }
            a.addItem(g.a, g);
        }
    }
    q(a, b, c, d) {
        if (c != null) {
            a.b = { $type: Point_$type, x: c.b.x, y: c.b.y };
        }
        else if (d != null) {
            a.b = { $type: Point_$type, x: d.b.x, y: d.b.y };
        }
    }
    s(a, b, c, d, e, f) {
        let g;
        let h;
        if (c == null) {
            if (d != null) {
                let i;
                if (((() => { let j = e.g.tryGetValue(d.a, i); i = j.p1; return j.ret; })())) {
                    g = i;
                }
                else {
                    g = this.o(d, e, f);
                }
            }
            else {
                a.c = { $type: Point_$type, x: NaN, y: NaN };
                return;
            }
        }
        else {
            g = c;
            if (a.a == null) {
                a.a = c.a;
            }
        }
        if (d == null) {
            if (c != null) {
                let j;
                if (((() => { let k = f.g.tryGetValue(c.a, j); j = k.p1; return k.ret; })())) {
                    h = j;
                }
                else {
                    a.c = { $type: Point_$type, x: NaN, y: NaN };
                    return;
                }
            }
            else {
                a.c = { $type: Point_$type, x: NaN, y: NaN };
                return;
            }
        }
        else {
            h = d;
            if (a.a == null) {
                a.a = d.a;
            }
        }
        this.q(a, b, g, h);
        if (isNaN_(g.c.x) || isNaN_(g.c.y)) {
            g = h;
        }
        this.t(a, b, g, h);
    }
    t(a, b, c, d) {
        let e = 1 - b;
        a.c = { $type: Point_$type, x: c.c.x * e + d.c.x * b, y: c.c.y * e + d.c.y * b };
    }
}
ScatterFrameBase$1.$t = markType(ScatterFrameBase$1, 'ScatterFrameBase$1', Frame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarFrame extends ScatterFrameBase$1 {
    constructor() {
        super(PolarFrame.$);
        this.w = null;
        this.v = false;
        this.x = null;
        this.w = new List$1(Point_$type, 0);
        this.v = true;
    }
    r(a, b, c) {
        let d = typeCast(PolarFrame.$, b);
        let e = typeCast(PolarFrame.$, c);
        if (d == null || e == null) {
            return;
        }
        Frame.a(this.w, a, d.w, e.w);
    }
    q(a, b, c, d) {
        if (this.v) {
            super.q(a, b, c, d);
        }
        else {
            super.q(a, b, c, d);
            if (c != null && d != null && (c.b.x != d.b.x || c.b.y != d.b.y)) {
                let e = 1 - b;
                a.b = { $type: Point_$type, x: c.b.x * e + d.b.x * b, y: c.b.y * e + d.b.y * b };
            }
        }
    }
    u(a) {
        return !isNaN_(a.x) && !isNaN_(a.y) && !isInfinity(a.x) && !isInfinity(a.y);
    }
    t(a, b, c, d) {
        if (this.v) {
            super.t(a, b, c, d);
        }
        else {
            if (c != null && d != null && (c.c.x != d.c.x || c.c.y != d.c.y) && this.u(a.b)) {
                a.c = this.x(a.b);
            }
            else {
                super.t(a, b, c, d);
            }
        }
    }
}
PolarFrame.$t = markType(PolarFrame, 'PolarFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesRenderingArguments extends Base {
    constructor(a, b, c, d, e) {
        super();
        this.e = null;
        this.f = null;
        this.c = 0;
        this.a = false;
        this.d = null;
        this.b = false;
        this.c = a.fi;
        this.d = a;
        this.e = b;
        this.f = c;
        this.a = d;
        this.b = e;
    }
}
SeriesRenderingArguments.$t = markType(SeriesRenderingArguments, 'SeriesRenderingArguments');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarTrendLineManager extends TrendLineManagerBase$1 {
    constructor() {
        super(Point_$type);
        this.i = false;
        this.h = 0;
        this.k = 0;
        this.j = 0;
        this.l = null;
        this.m = null;
    }
    get_g$a() {
        return 2;
    }
    get g$a() {
        return this.get_g$a();
    }
    n(a, b, c, d, e, f, g, h, i, j, k) {
        let l = j;
        let m = k;
        let n = new List$1(Point_$type, 0);
        if (!h.g.isEmpty && !h.f.isEmpty) {
            let o = c;
            let p = d;
            let q = 0;
            if (o != null) {
                q = o.count;
            }
            if (p != null) {
                q = Math.min(q, p.count);
            }
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(n, b, h, this.a, q, (r) => o.item(r), (r) => p.item(r), f, g, l, m);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.c(b, this.d, c, d, e);
                for (let r of fromEnum(this.d)) {
                    let s = f(r.x);
                    let t = g(r.y);
                    if (!isNaN_(s) && !isNaN_(t)) {
                        n.add({ $type: Point_$type, x: s, y: t });
                    }
                }
            }
            if (n.count > 0) {
                this.f(n, h, a, i);
            }
        }
    }
    f(a, b, c, d) {
        if (d != null) {
            d.i = c;
        }
        let e = ((() => {
            let $ret = new PolarLinePlanner();
            $ret.m = (f) => a.item(f).x;
            $ret.n = (f) => a.item(f).y;
            $ret.a = d;
            $ret.q = a.count;
            $ret.l = b.b;
            $ret.o = (f) => this.l(a.item(f).x, a.item(f).y);
            $ret.p = (f) => this.m(a.item(f).x, a.item(f).y);
            $ret.f = this.i;
            $ret.b = this.h;
            $ret.ab = b.f;
            $ret.ac = b.g;
            return $ret;
        })());
        e.x(null, null);
    }
}
PolarTrendLineManager.$t = markType(PolarTrendLineManager, 'PolarTrendLineManager', TrendLineManagerBase$1.$.specialize(Point_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerManagerBucket extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.c = null;
    }
    get d() {
        if (this.b == null) {
            this.b = new List$1(Number_$type, 0);
        }
        return this.b;
    }
    get e() {
        if (this.c == null) {
            this.c = new List$1(Number_$type, 0);
        }
        return this.c;
    }
    f(a) {
        if (this.e.count > 0) {
            let b = this.e._inner[this.e.count - 1];
            this.e.removeAt(this.e.count - 1);
            a = true;
            return {
                ret: b,
                p0: a
            };
        }
        let c = this.d._inner[this.d.count - 1];
        this.d.removeAt(this.d.count - 1);
        a = false;
        return {
            ret: c,
            p0: a
        };
    }
    get a() {
        return this.d.count == 0 && this.e.count == 0;
    }
}
MarkerManagerBucket.$t = markType(MarkerManagerBucket, 'MarkerManagerBucket');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerManagerBase extends Base {
    constructor(a, b, c, d, e) {
        super();
        this.f = null;
        this.h = null;
        this.a = null;
        this.g = null;
        this.e = null;
        this.h = a;
        this.g = b;
        this.a = c;
        this.f = d;
        this.e = e;
    }
    d(a, b) {
        let c = new List$1(Number_$type, 0);
        let d = new List$1(Number_$type, 0);
        for (let e of fromEnum(b)) {
            if (a.item(e).e.count > 0) {
                c.add(e);
            }
            else {
                d.add(e);
            }
        }
        let f = new List$1(Number_$type, 0);
        f.o(c);
        f.o(d);
        return f;
    }
    k(a, b, c, d) {
        while (a > 0) {
            if (a < c.count) {
                if (!MarkerManagerBase.b) {
                    let e = c;
                    ArrayExtension.shuffle$1(Number_$type, e);
                }
                c = this.d(b, c);
                let f = a;
                for (let g = 0; g < f; g++) {
                    let h = g;
                    let i = b.item(c._inner[h]);
                    let j;
                    let k = ((() => { let l = i.f(j); j = l.p0; return l.ret; })());
                    d.add(k);
                    a--;
                    if (i.a) {
                        b.removeItem(c._inner[h]);
                    }
                }
            }
            else {
                for (let l of fromEnum(c)) {
                    let m = b.item(l);
                    let n;
                    let o = ((() => { let p = m.f(n); n = p.p0; return p.ret; })());
                    d.add(o);
                    a--;
                    if (m.a) {
                        b.removeItem(l);
                    }
                }
                c = new List$1(Number_$type, 1, b.keys);
            }
        }
    }
    i(a, b, c, d) {
        let e = b.left;
        let f = b.right;
        let g = b.top;
        let h = b.bottom;
        if (!a.isEmpty && !b.isEmpty) {
            for (let i = 0; i < c.count; ++i) {
                let j = c.item(i).x;
                if (isNaN_(j)) {
                    continue;
                }
                let k = c.item(i).y;
                if (isNaN_(k)) {
                    continue;
                }
                if (j < e || j > f) {
                    continue;
                }
                if (k < g || k > h) {
                    continue;
                }
                d.add(i);
            }
        }
    }
    c(a, b, c, d) {
        let e = new Array(d.count);
        for (let f of fromEnum(this.e())) {
            if (f != -1) {
                e[f] = true;
            }
        }
        let g = truncate(Math.floor(a.width / c));
        let h = new Dictionary$2(Number_$type, MarkerManagerBucket.$, 0);
        for (let i of fromEnum(b)) {
            let j = d.item(i).x;
            let k = d.item(i).y;
            let l = truncate(Math.floor(k / c));
            let m = truncate(Math.floor(j / c));
            let n = (l * g) + m;
            let o;
            if (!((() => { let p = h.tryGetValue(n, o); o = p.p1; return p.ret; })())) {
                o = new MarkerManagerBucket();
                h.addItem(n, o);
            }
            if (e[i]) {
                o.e.add(i);
            }
            else {
                o.d.add(i);
            }
        }
        return h;
    }
}
MarkerManagerBase.$t = markType(MarkerManagerBase, 'MarkerManagerBase');
MarkerManagerBase.b = false;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumericMarkerManager extends MarkerManagerBase {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    let h = [c, d, e, f, g, () => 0];
                    {
                        let j = h[0];
                        let k = h[1];
                        let l = h[2];
                        let m = h[3];
                        let n = h[4];
                        let o = h[5];
                        super(j, k, l, m, n);
                        this.n = false;
                        this.p = null;
                        this.o = null;
                        this.q = null;
                        this.m = null;
                        this.n = false;
                        this.p = (p) => ({ $type: Point_$type, x: 0, y: 0 });
                        this.o = o;
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    let h = _rest[5];
                    super(c, d, e, f, g);
                    this.n = false;
                    this.p = null;
                    this.o = null;
                    this.q = null;
                    this.m = null;
                    this.n = false;
                    this.p = (i) => ({ $type: Point_$type, x: 0, y: 0 });
                    this.o = h;
                }
                break;
        }
    }
    l(a, b, c, d, e) {
        let f = this.f();
        a.clear();
        let g = new List$1(Number_$type, 0);
        b = Math.max(0, b);
        let h = null;
        this.i(c, d, boxArray$1(f), g);
        if (b >= g.count) {
            h = g;
        }
        else {
            h = new List$1(Number_$type, 0);
            let i = Math.max(8, e);
            let j = this.c(d, g, i, boxArray$1(f));
            let k = new List$1(Number_$type, 1, j.keys);
            if (MarkerManagerBase.b) {
                k.y();
            }
            this.k(b, j, k, h);
        }
        this.r(a, f, h);
    }
    r(a, b, c) {
        for (let d = 0; d < c.count; ++d) {
            let e = c._inner[d];
            let f = b[e];
            let g = this.g(e);
            let h = this.h(g);
            if (h.content != null) {
                h.content.item = g;
            }
            let i = new OwnedPoint();
            if (this.n) {
                i.b = this.p(e);
            }
            i.a = g;
            i.c = { $type: Point_$type, x: f.x, y: f.y };
            if (!a.containsKey(g)) {
                a.addItem(g, i);
            }
        }
    }
    j(a, b) {
        let c = a.keys;
        if (MarkerManagerBase.b) {
            let d = new List$1(Base.$, 1, a.keys);
            d.aa((e, f) => {
                let g = a.item(e);
                let h = a.item(f);
                let i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                let j = Math.pow(h.c.x, 2) + Math.pow(h.c.y, 2);
                return CompareUtil.compareToObject(i, j);
            });
            c = d;
        }
        let e = null;
        let f = null;
        switch (this.o()) {
            case 0: break;
            case 1:
                e = ((() => {
                    let $ret = new SmartPlacer();
                    $ret.c = 0.3;
                    $ret.b = 0;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                f.f = true;
                break;
            case 2:
                e = ((() => {
                    let $ret = new SmartPlacer();
                    $ret.c = 0.6;
                    $ret.b = 2;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                f.f = true;
                break;
            case 3:
                e = ((() => {
                    let $ret = new SmartPlacer();
                    $ret.c = 0.3;
                    $ret.b = 0;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                break;
            case 4:
                e = ((() => {
                    let $ret = new SmartPlacer();
                    $ret.c = 0.6;
                    $ret.b = 2;
                    return $ret;
                })());
                f = new SmartPlaceableWrapper$1(Marker.$);
                break;
        }
        for (let g of fromEnum(c)) {
            let h = a.item(g);
            let i = this.h(h.a);
            if (e != null && f != null) {
                f.d = i;
                f.j = this.q(i);
                f.i = h.c;
                e.d(f);
                if (f.opacity == 0) {
                    f.smartPosition = f.smartPosition;
                }
                h.c = f.g;
            }
            else {
                i._opacity = 1;
                i._visibility = 0;
            }
            this.s(i, h, b);
        }
        this.a(a);
    }
    s(a, b, c) {
        a.n = b.c.x;
        a.o = b.c.y;
    }
}
NumericMarkerManager.$t = markType(NumericMarkerManager, 'NumericMarkerManager', MarkerManagerBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarBase extends MarkerSeries {
    constructor() {
        super();
        this.nl = null;
        this.ne = null;
        this.nj = null;
        this.pb = null;
        this.pa = null;
        this.nr = null;
        this.nt = null;
        this.nu = null;
        this.no = new PolarFrame();
        this.nq = new PolarFrame();
        this.nn = new PolarFrame();
        this.ni = null;
        this.np = null;
        this.nm = null;
        this.np = new PolarFrame();
        this.nq.x = runOn(this, this.o9);
        this.no.x = runOn(this, this.o9);
        this.nn.x = runOn(this, this.o9);
        this.nr = new SeriesRenderer$2(PolarFrame.$, PolarBaseView.$, 0, runOn(this, this.om), runOn(this, this.oo), runOn(this, this.ca), runOn(this, this.jt), runOn(this, this.ok));
    }
    bf() {
        return new PolarBaseView(this);
    }
    i2(a) {
        super.i2(a);
        this.nk = a;
    }
    h1() {
        super.h1();
        this.ng = null;
        this.nh = null;
    }
    get_c0() {
        return true;
    }
    n0(a) {
        if (!this.hasMarkers) {
            return false;
        }
        let b = this.ng;
        let c = new ScalerParams(1, this.bs.n2, this.l8, b.ca);
        c.c = this.getEffectiveViewport1(this.bi);
        let d = this.nh;
        let e = new ScalerParams(1, this.bs.n2, this.l8, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ma.cc((f) => {
            if (f._visibility == 0) {
                let g = new SeriesPointOfInterest();
                let h = f.n;
                let i = f.o;
                if (h < this.l8.left || h > this.l8.right || i < this.l8.top || i > this.l8.bottom) {
                    return;
                }
                g.b = b.d1(h, c);
                g.c = d.d1(i, e);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    }
    ok() {
        if (this.bt.g) {
            this.bt.t();
        }
    }
    ol() {
        this.ni.e(this.nl.w, this.nv, this.nw, this.pb, this.pa, (a, b) => Math.cos(b), (a, b) => Math.sin(b), true);
    }
    get nv() {
        return this.nt;
    }
    set nv(a) {
        if (this.nt != a) {
            let b = this.nv;
            this.nt = a;
            this.raisePropertyChanged("AngleColumn", b, this.nv);
        }
    }
    get nw() {
        return this.nu;
    }
    set nw(a) {
        if (this.nu != a) {
            let b = this.nw;
            this.nu = a;
            this.raisePropertyChanged("RadiusColumn", b, this.nw);
        }
    }
    get o4() {
        return this.c(PolarBase.op);
    }
    set o4(a) {
        this.h(PolarBase.op, a);
    }
    ik() {
        super.ik();
        if (this.nh != null) {
            this.nh.hb(false);
        }
        if (this.ng != null) {
            this.ng.hb(false);
        }
    }
    h6(a, b, c, d) {
        let e = false;
        this.nk.cr.g$e(a, b, c, d);
        if (this.ng != null && !this.ng.cn()) {
            e = true;
        }
        if (this.nh != null && !this.nh.cn()) {
            e = true;
        }
        if (e) {
            this.jl(true);
        }
    }
    j0(a, b) {
        this.jl(false);
    }
    j1(a, b) {
        this.jl(false);
    }
    dw(a, b, c) {
        let d = true;
        if (!super.dw(a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.ng == null || this.nh == null || this.nv == null || this.nw == null || this.nv.count == 0 || this.nw.count == 0 || this.bz == null || this.bz.count != this.nv.count || this.bz.count != this.nw.count || this.ni == null || this.ng.bh == null || this.nh.bh == null || this.ng.kc == this.ng.kb || this.nh.kc == this.nh.kb) {
            d = false;
        }
        return d;
    }
    jm(a) {
        let b;
        let c;
        let d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.h3(true, this.bi);
            return;
        }
        this.pb = b;
        this.pa = c;
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        let e = new SeriesRenderingArguments(this, c, b, a, this.de);
        let f = this.nr.g(e, this.no, this.nn, this.nq, this.nk);
        this.no = f.p1;
        this.nn = f.p2;
        this.nq = f.p3;
    }
    o9(a) {
        let b = this.ni.h(a.x, a.y, this.pb, this.pa, this.nj.e, this.nj.d, this.nj.g, this.nj.f, this.nj.i, this.nj.h);
        return b;
    }
    an(a) {
        if (a != null && a == this.ng && this.nv != null) {
            return new AxisRange(this.nv.minimum, this.nv.maximum);
        }
        if (a != null && a == this.nh && this.nw != null) {
            return new AxisRange(this.nw.minimum, this.nw.maximum);
        }
        return null;
    }
    c9(a) {
        let b = this.bi.bs;
        b = b.copy();
        let c = this.bi.br;
        let d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.ng == null || this.nv == null || this.nh == null || this.nw == null) {
            return false;
        }
        if (d < 0 || d > this.nv.count - 1 || d > this.nw.count - 1) {
            return false;
        }
        let e = this.ng.getScaledAngle(this.nv.item(d));
        let f = this.nh.lx(this.nw.item(d));
        let g = 0.5 + (Math.cos(e) * f);
        let h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    }
    fp(a) {
        return null;
    }
    e8(a) {
        return -1;
    }
    ag() {
        return [this.ng, this.nh];
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == PolarBase.$$p[1]) {
            return this.ft(a, b, this.n9);
        }
        if (c == PolarBase.$$p[5]) {
            return this.ft(a, b, this.of);
        }
        return super.fs(a, b);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.nk.cr.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nv);
                    c.deregisterColumn(this.nw);
                    this.nv = null;
                    this.nw = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nv = this.bw(this.n9);
                    this.nw = this.bw(this.of);
                }
                if ((this.nh != null && !this.nh.cn()) || (this.ng != null && !this.ng.cn())) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[0]:
                if (this.ng != null && this.nh != null) {
                    this.ni = new PolarAxes(this.nh, this.ng);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.ng != null && !this.ng.cn()) {
                    this.jl(false);
                }
                else if (c != null && d == null) {
                    this.h3(true, this.bi);
                }
                break;
            case PolarBase.$$p[4]:
                if (this.ng != null && this.nh != null) {
                    this.ni = new PolarAxes(this.nh, this.ng);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.nh != null && !this.nh.cn()) {
                    this.jl(false);
                }
                else if (c != null && d == null) {
                    this.h3(true, this.bi);
                }
                if (this.ng != null && !this.ng.cn()) {
                    this.ng.g7();
                }
                break;
            case PolarBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nv);
                    this.nv = this.bw(this.n9);
                }
                break;
            case "AngleColumn":
                this.nk.cr.g$i();
                if (this.ng != null && !this.ng.cn()) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[5]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nw);
                    this.nw = this.bw(this.of);
                }
                break;
            case "RadiusColumn":
                this.nk.cr.g$i();
                if (this.nh != null && !this.nh.cn()) {
                    this.jl(false);
                }
                break;
            case PolarBase.$$p[6]:
                this.jl(false);
                this.it();
                break;
            case PolarBase.$$p[3]:
                this.jl(false);
                this.it();
                break;
            case "TransitionProgress":
                this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
                this.pb = this.bi.bs;
                this.pa = this.bi.br;
                this.nq.v = this.n1;
                this.nq.c(this.ez, this.no, this.nn);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.oo(this.nn, this.nk);
                }
                else {
                    this.oo(this.nq, this.nk);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case PolarBase.$$p[2]:
                this.jl(false);
                this.it();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    }
    ny(a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    nx(a) {
        if (typeCast(NumericAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a) {
            c.cs.clear();
        }
        c.cr.g$d();
    }
    nf(a, b) {
        let c = a.top - 10;
        let d = a.bottom + 10;
        let e = a.left - 10;
        let f = a.right + 10;
        let g = ((() => {
            let $ret = new Clipper(1, e, d, f, c, false);
            $ret.i = b;
            return $ret;
        })());
        return g;
    }
    oj(a, b, c, d) {
        a.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, b);
        let e = this.bz;
        for (let f = 0; f < b; f++) {
            let g = a.w._inner[f];
            if (!isInfinity(g.x) && !isInfinity(g.y)) {
                let h = { $type: Point_$type, x: this.nv.item(f), y: this.nw.item(f) };
                let i = { $type: Point_$type, x: g.x, y: g.y };
                a.g.addItem(e.item(f), ((() => {
                    let $ret = new OwnedPoint();
                    $ret.a = e.item(f);
                    $ret.b = h;
                    $ret.c = i;
                    return $ret;
                })()));
            }
        }
    }
    om(a, b) {
        let c = b.bs;
        let d = b.br;
        a.j.clear();
        a.n.clear();
        let e = Math.min(this.nv != null ? this.nv.count : 0, this.nw != null ? this.nw.count : 0);
        if (e < 1) {
            return;
        }
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        this.nl = a;
        this.pa = d;
        this.pb = c;
        b.cp.l(a.j, this.n4, c, d, this.eu);
        if (e <= this.n4) {
            this.oj(a, e, c, d);
        }
        let f = this.nf(d, a.n);
        let g = Math.min(this.ng.kc, this.ng.kb);
        let h = Math.max(this.ng.kb, this.ng.kc);
        b.cr.i = this.n1;
        b.cr.h = 0;
        b.cr.k = this.nh.lr;
        b.cr.j = this.nh.lq;
        b.cr.l = (i, j) => this.ni.c(i, j, c, d, Math.cos);
        b.cr.m = (i, j) => this.ni.d(i, j, c, d, Math.sin);
        let i = new List$1(Number_$type, 0);
        for (let j = 0; j < this.nv.count; j++) {
            if (this.nv.item(j) >= g && this.nv.item(j) <= h) {
                i.add(this.nv.item(j));
            }
        }
        let k = this.nw;
        if (i.count != this.nv.count) {
            k = new List$1(Number_$type, 0);
            for (let l = 0; l < this.nv.count; l++) {
                if (this.nv.item(l) >= g && this.nv.item(l) <= h) {
                    k.add(this.nw.item(l));
                }
            }
        }
        b.cr.n(a.n, this.ns, i, k, this.n5, runOn(this.ng, this.ng.getScaledAngle), runOn(this.nh, this.nh.lx), ((() => {
            let $ret = new TrendResolutionParams();
            $ret.b = this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })()), f, g, h);
    }
    oo(a, b) {
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.l0(b);
        this.nj = new PolarAxisInfoCache(this.ng, this.nh, this.bz);
        b.cp.j(a.j, this.mf);
        b.cj();
        let g = this.nf(d, b.cr.g$j.ak);
        b.cr.g$h(a.n, g);
        this.oi(d, c, e, f, b);
    }
    oi(a, b, c, d, e) {
        e.cu(a, b, c, d);
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        this.nk.cw();
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        let c = this.bh;
        if (!this.df) {
            this.np = new PolarFrame();
            this.om(this.np, c);
        }
        this.df = false;
        this.oo(this.np, c);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.nm == null) {
            this.nm = new PolarFrame();
        }
        this.om(this.nm, g);
        this.oo(this.nm, g);
    }
    on(a, b) {
        let c = new List$1(Base.$, 0);
        for (let d of fromEnum(b.c)) {
            if (!a.containsKey(d)) {
                c.add1(d);
            }
        }
        for (let e of fromEnum(c)) {
            b.g(e);
        }
    }
    nd(a, b, c) {
        this.ol();
        return this.nl.w.toArray();
    }
    n2(a) {
        let b = new List$1(Number_$type, 0);
        let c = this.bz;
        for (let d of fromEnum(this.nk.cs.c)) {
            b.add(c.indexOf(d));
        }
        return b;
    }
    o8(a) {
        return { $type: Point_$type, x: this.nv.item(a), y: this.nw.item(a) };
    }
    ic(a) {
        super.ic(a);
        this.a2.exportTrendlineData(this, a, this.nk.cr.g$j);
    }
}
PolarBase.$t = markType(PolarBase, 'PolarBase', MarkerSeries.$);
PolarBase.op = DependencyProperty.i("ActualTrendLineBrush", Brush.$, PolarBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
PolarBase.$$p = markDep(DependencyProperty, PropertyMetadata, PolarBase, 'raisePropertyChanged', ['AngleAxis:ng:oq', [NumericAngleAxis.$, null], 'AngleMemberPath:n9:or', [2], 'ClipSeriesToBounds:nz:os', [0, false], 'MaximumMarkers:n4:ot', [1, 400], 'RadiusAxis:nh:ou', [NumericRadiusAxis.$, null], 'RadiusMemberPath:of:ov', [2], 'UseCartesianInterpolation:n1:o3', [0, true], 'TrendLineType:ns:o1', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:n3:o0', [1, 1.5], 'TrendLinePeriod:n5:oz', [1, 7], 'TrendLineZIndex:n6:o2', [1, 1], 'TrendLineBrush:o5:ow', [Brush.$, null], 'TrendLineDashArray:o6:ox', [DoubleCollection.$], 'TrendLineDashCap:o7:oy', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class PolarBaseView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.cq = null;
        this.cp = null;
        this.cr = null;
        this.cs = null;
        this.cq = a;
        this.cs = new HashPool$2(Base.$, Marker.$);
        this.ce(this.cs);
        this.cr = new PolarTrendLineManager();
    }
    ap() {
        super.ap();
        this.cp = this.co();
        if (!this.n) {
            this.cq.n4 = 1000;
            this.by.mb = 2;
        }
    }
    co() {
        let a = new NumericMarkerManager(0, (b) => this.cs.item(b), (b) => this.cq.nj.c.item(b), runOn(this, this.cv), runOn(this, this.cn), runOn(this, this.ct));
        a.n = true;
        a.p = runOn(this.cq, this.cq.o8);
        return a;
    }
    cv(a) {
        this.cq.on(a, this.cs);
    }
    cn() {
        return this.cq.nd(this.cs, this.bs, this.br);
    }
    ct() {
        return this.cq.n2(this.cs);
    }
    cu(a, b, c, d) {
        if (this.cq.nz) {
            let e = new GeometryGroup();
            this.cq.nh.l5(e, a, b, c, d);
        }
        else {
        }
    }
    cw() {
        if (this.cq.o5 != null) {
            this.cq.o4 = this.cq.o5;
        }
        else {
            this.cq.o4 = this.cq.lb;
        }
    }
    cc(a) {
        this.cs.f(a);
    }
    a2(a, b) {
        if (a.d) {
            if (this.cq.ns != 0 && !b) {
                let c = this.cr.g$j;
                c.ac = this.cq.n3;
                c._stroke = this.cq.o4;
                c.ad = this.cq.o7;
                c.ai = this.cq.o6;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    cx() {
        return Rect.empty;
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span>" + "${item." + this.cq.n9 + "}" + "</span><br/><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cq.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cq.of + "}</span></div>";
        return a;
    }
}
PolarBaseView.$t = markType(PolarBaseView, 'PolarBaseView', MarkerSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NaNSegmenter extends Base {
    static c(a, b) {
        let c = new List$1(IList$1_$type.specialize(Point_$type), 0);
        let d = getEnumerator(a);
        let e = new List$1(Point_$type, 0);
        let f = true;
        while (d.moveNext()) {
            if (NaNSegmenter.a(d.current)) {
                if (!f && b == 1) {
                    f = true;
                    let g = e;
                    e = new List$1(Point_$type, 0);
                    c.add(new ReadOnlyCollection$1(Point_$type, 1, g));
                }
            }
            else {
                f = false;
                e.add(d.current);
            }
        }
        c.add(new ReadOnlyCollection$1(Point_$type, 1, e));
        return c;
    }
    static a(a) {
        return (isNaN_(a.x) || isNaN_(a.y) || isInfinity(a.x) || isInfinity(a.y));
    }
    static b(a) {
        return !NaNSegmenter.a(a);
    }
}
NaNSegmenter.$t = markType(NaNSegmenter, 'NaNSegmenter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PathRenderer extends Base {
    constructor(a, ..._rest) {
        super();
        this.a = null;
        this.b = 0;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    this.b = 1;
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    this.a = c;
                }
                break;
        }
    }
    d(a, b, c) {
        let d = NaNSegmenter.c(b, this.b);
        let e = this.c(d, c);
        let f = new PathGeometry();
        for (let g of fromEnum(e)) {
            f.c.add(g);
        }
        a.ak = f;
    }
    *_c(a, b) {
        for (let c = 0; c < a.count; c++) {
            let d = a.item(c);
            if (d.count >= 2) {
                let e = new PathFigure();
                let f = d.item(0);
                e._startPoint = f;
                let g = this.e(d, b);
                e._segments.add(g);
                yield e;
            }
        }
    }
    c(a, b) {
        return toEnum(() => this._c(a, b));
    }
    e(a, b) {
        let c = new PolyLineSegment();
        if (this.a == null) {
            for (let d = 1; d < a.count; d++) {
                let e = a.item(d);
                c._points.add(e);
            }
        }
        else {
            let f = this.a.flatten(a, b);
            for (let g = 1; g < f.count; g++) {
                let h = f.item(g);
                c._points.add(h);
            }
        }
        return c;
    }
}
PathRenderer.$t = markType(PathRenderer, 'PathRenderer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IFlattener_$type = new Type(null, 'IFlattener');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DefaultFlattener extends Base {
    a(a, b, c, d, e, f) {
        let g = new List$1(Number_$type, 0);
        let h = d;
        let i = e;
        let j = i - h + 1;
        while (j > 0) {
            if (j <= 512) {
                Flattener.c(g, b, c, h, i, f);
                h = i + 1;
            }
            else {
                let k = h + 512 - 1;
                Flattener.c(g, b, c, h, k, f);
                h = k + 1;
            }
            j = i - h + 1;
        }
        return g;
    }
    d(a, b, c, d, e) {
        let f = new List$1(Number_$type, 0);
        let g = c;
        let h = d;
        let i = h - g + 1;
        while (i > 0) {
            if (i <= 512) {
                FastFlattener.e(f, a, b, g, h, e);
                g = h + 1;
            }
            else {
                let j = g + 512 - 1;
                FastFlattener.e(f, a, b, g, j, e);
                g = j + 1;
            }
            i = h - g + 1;
        }
        return f;
    }
    flatten(a, b) {
        let c = (d) => this.f(a, d);
        let d = (e) => this.g(a, e);
        return this.b(a, b, c, d);
    }
    c(a, b, c, d) {
        return this.e(a, b, c, d);
    }
    b(a, b, c, d) {
        let e = this.a(new List$1(Number_$type, 0), c, d, 0, a.count - 1, b);
        let f = new RearrangedList$1(Point_$type, a, e);
        return f;
    }
    e(a, b, c, d) {
        let e = this.d(a, b, 0, c - 1, d);
        let f = new List$1(Point_$type, 0);
        for (let g = 0; g < e.count; g++) {
            f.add({ $type: Point_$type, x: a[e._inner[g]], y: b[e._inner[g]] });
        }
        return f;
    }
    f(a, b) {
        return a.item(b).x;
    }
    g(a, b) {
        return a.item(b).y;
    }
}
DefaultFlattener.$t = markType(DefaultFlattener, 'DefaultFlattener', Base.$, [IFlattener_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarLineSeriesBase extends PolarBase {
    constructor() {
        super();
        this.pc = null;
        this.pe = null;
        this.pd = null;
        this.pc = new PathRenderer(1, new DefaultFlattener());
        this.pe = new PathRenderer(0);
    }
    bf() {
        return new PolarLineSeriesBaseView(this);
    }
    i2(a) {
        super.i2(a);
        this.pf = a;
    }
    pg() {
        return 1;
    }
    get_pj() {
        return false;
    }
    get pj() {
        return this.get_pj();
    }
    get_pl() {
        return false;
    }
    get pl() {
        return this.get_pl();
    }
    om(a, b) {
        super.om(a, b);
        a.m.clear();
        let c = b.bs;
        let d = b.br;
        let e = this.nv != null ? this.nv.count : 0;
        let f = this.nw != null ? this.nw.count : 0;
        let g = Math.min(e, f);
        let h = ((() => {
            let $ret = new PolarLinePlanner();
            $ret.m = (i) => this.nj.a.getScaledAngle1(this.nv.item(i), this.nj.e, this.nj.d);
            $ret.q = g;
            $ret.n = (i) => this.nh.ly(this.nw.item(i), this.nj.g, this.nj.f, this.nj.i, this.nj.h);
            $ret.l = this.eu;
            $ret.f = this.n1;
            $ret.b = this.pg();
            $ret.o = (i) => this.pm(a, i);
            $ret.p = (i) => this.pn(a, i);
            $ret.ab = d;
            $ret.ac = c;
            $ret.d = this.pl;
            $ret.c = this.pj;
            return $ret;
        })());
        let i = new List$1(Number_$type, 0);
        for (let j = 0; j < g; j++) {
            if (this.pk(j)) {
                i.add(j);
            }
        }
        if (this.pl && i.count > 0) {
            i.add(i._inner[0]);
        }
        h.x(a.m, i);
    }
    pm(a, b) {
        return a.w._inner[b].x;
    }
    pn(a, b) {
        return a.w._inner[b].y;
    }
    pi() {
        return !this.ph();
    }
    ph() {
        let a = this.bs.n2;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    }
    pk(a) {
        return (this.nv.item(a) >= this.nj.a.kc && this.nv.item(a) <= this.nj.a.kb && this.nw.item(a) >= this.nj.b.kc && this.nw.item(a) <= this.nj.b.kb) || (isNaN_(this.nv.item(a)) || isNaN_(this.nw.item(a)));
    }
    h3(a, b) {
        super.h3(a, b);
        this.po(b);
    }
    oo(a, b) {
        super.oo(a, b);
        if (this.n1) {
            this.pd = this.pc;
        }
        else {
            this.pd = this.pe;
        }
        this.pd.b = this.pg();
        this.po(b);
        this.pp(a, b);
    }
}
PolarLineSeriesBase.$t = markType(PolarLineSeriesBase, 'PolarLineSeriesBase', PolarBase.$);
/**
 * @hidden
 */
class PolarLineSeriesBaseView extends PolarBaseView {
    constructor(a) {
        super(a);
        this.cy = null;
        this.cy = a;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
PolarLineSeriesBaseView.$t = markType(PolarLineSeriesBaseView, 'PolarLineSeriesBaseView', PolarBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarAreaSeries extends PolarLineSeriesBase {
    constructor() {
        super();
        this.ab = PolarAreaSeries.$;
    }
    bf() {
        return new PolarAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pq = a;
    }
    po(a) {
        let b = a;
        b.c0();
    }
    pp(a, b) {
        if (a.m.count > 0) {
            let c = a.m._inner[0];
            let d = a.m._inner[a.m.count - 1];
            let e = c.x == d.x && c.y == d.y;
            if (!e) {
                a.m.add(a.m._inner[0]);
            }
        }
        let f = b;
        f.c3._opacity = this.d6;
        f.c1(a.m, this.eu);
    }
    get_pl() {
        return true;
    }
    pg() {
        return this.pr;
    }
}
PolarAreaSeries.$t = markType(PolarAreaSeries, 'PolarAreaSeries', PolarLineSeriesBase.$);
PolarAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:pr:pt', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class PolarAreaSeriesView extends PolarLineSeriesBaseView {
    constructor(a) {
        super(a);
        this.cz = null;
        this.c4 = new Path();
        this.c2 = new Path();
        this.cz = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get c3() {
        return this.c2;
    }
    c0() {
        this.c2.ak = null;
        this.c4.ak = null;
        this.an();
    }
    c1(a, b) {
        let c = new List$1(Point_$type, 1, a);
        this.cz.pd.d(this.c4, c, b);
        this.cz.pd.d(this.c2, c, b);
        this.an();
    }
    a8() {
        super.a8();
        this.c4._stroke = this.e.lc;
        this.c4.ac = this.e.ey;
        this.c4.ai = this.e.ll;
        this.c4.ad = this.e.lm;
        this.c2._fill = this.e.lb;
        this.c2._opacity = this.e.d6;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
        this.c2._fill = a;
        this.c2._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.c2);
            a.s(this.c4);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c4, "polarShape", ["Main"]);
        this.e.a2.exportPathData(a, this.c2, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    }
}
PolarAreaSeriesView.$t = markType(PolarAreaSeriesView, 'PolarAreaSeriesView', PolarLineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPolarAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent polar area series.
*/
const IgxPolarAreaSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent) }];
let IgxPolarAreaSeriesComponent = IgxPolarAreaSeriesComponent_1 = class IgxPolarAreaSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.pr;
    }
    set unknownValuePlotting(v) {
        this.i.pr = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarAreaSeriesComponent.prototype, "unknownValuePlotting", null);
IgxPolarAreaSeriesComponent = IgxPolarAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-polar-area-series',
        template: ``,
        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent_1) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPolarAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarAreaSeriesModule = class IgxPolarAreaSeriesModule {
};
IgxPolarAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPolarAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxPolarAreaSeriesComponent],
        entryComponents: []
    })
], IgxPolarAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarAreaSeriesDynamicModule = class IgxPolarAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPolarAreaSeriesComponent", IgxPolarAreaSeriesComponent);
        TypeRegistrar.register("PolarAreaSeries", PolarAreaSeries.$type);
    }
};
IgxPolarAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPolarAreaSeriesModule],
        exports: [IgxPolarAreaSeriesModule],
        entryComponents: [IgxPolarAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPolarAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarLineSeries extends PolarLineSeriesBase {
    constructor() {
        super();
        this.ab = PolarLineSeries.$;
    }
    bf() {
        return new PolarLineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pq = a;
    }
    po(a) {
        let b = a;
        b.c0();
    }
    pp(a, b) {
        let c = b;
        c.c1(a.m, this.eu);
    }
    pg() {
        return this.pr;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case PolarLineSeries.$$p[0]:
                this.jl(false);
                this.it();
                break;
        }
    }
}
PolarLineSeries.$t = markType(PolarLineSeries, 'PolarLineSeries', PolarLineSeriesBase.$);
PolarLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:pr:pt', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class PolarLineSeriesView extends PolarLineSeriesBaseView {
    constructor(a) {
        super(a);
        this.cz = null;
        this.c2 = new Path();
        this.cz = a;
    }
    ap() {
        super.ap();
    }
    c0() {
        this.c2.ak = null;
        this.an();
    }
    c1(a, b) {
        this.cz.pd.d(this.c2, a, b);
        this.an();
    }
    a8() {
        super.a8();
        this.c2._stroke = this.e.lb;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.ll;
        this.c2.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        a.s(this.c2);
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c2, "polarShape", ["Main"]);
    }
}
PolarLineSeriesView.$t = markType(PolarLineSeriesView, 'PolarLineSeriesView', PolarLineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPolarLineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent polar line series.
*/
const IgxPolarLineSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent) }];
let IgxPolarLineSeriesComponent = IgxPolarLineSeriesComponent_1 = class IgxPolarLineSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.pr;
    }
    set unknownValuePlotting(v) {
        this.i.pr = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarLineSeriesComponent.prototype, "unknownValuePlotting", null);
IgxPolarLineSeriesComponent = IgxPolarLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-polar-line-series',
        template: ``,
        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent_1) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPolarLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarLineSeriesModule = class IgxPolarLineSeriesModule {
};
IgxPolarLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPolarLineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxPolarLineSeriesComponent],
        entryComponents: []
    })
], IgxPolarLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarLineSeriesDynamicModule = class IgxPolarLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPolarLineSeriesComponent", IgxPolarLineSeriesComponent);
        TypeRegistrar.register("PolarLineSeries", PolarLineSeries.$type);
    }
};
IgxPolarLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPolarLineSeriesModule],
        exports: [IgxPolarLineSeriesModule],
        entryComponents: [IgxPolarLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPolarLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarScatterSeries extends PolarBase {
    constructor() {
        super();
        this.ab = PolarScatterSeries.$;
    }
    bf() {
        return new PolarScatterSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pc = a;
    }
}
PolarScatterSeries.$t = markType(PolarScatterSeries, 'PolarScatterSeries', PolarBase.$);
/**
 * @hidden
 */
class PolarScatterSeriesView extends PolarBaseView {
    constructor(a) {
        super(a);
        this.cy = null;
        this.cy = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    }
}
PolarScatterSeriesView.$t = markType(PolarScatterSeriesView, 'PolarScatterSeriesView', PolarBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPolarScatterSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent polar scatter series.
*/
const IgxPolarScatterSeriesComponent_PROVIDERS = [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent) }];
let IgxPolarScatterSeriesComponent = IgxPolarScatterSeriesComponent_1 = class IgxPolarScatterSeriesComponent extends IgxPolarBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarScatterSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxPolarScatterSeriesComponent = IgxPolarScatterSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-polar-scatter-series',
        template: ``,
        providers: [{ provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarScatterSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPolarScatterSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarScatterSeriesModule = class IgxPolarScatterSeriesModule {
};
IgxPolarScatterSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPolarScatterSeriesComponent],
        imports: [CommonModule],
        exports: [IgxPolarScatterSeriesComponent],
        entryComponents: []
    })
], IgxPolarScatterSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarScatterSeriesDynamicModule = class IgxPolarScatterSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPolarScatterSeriesComponent", IgxPolarScatterSeriesComponent);
        TypeRegistrar.register("PolarScatterSeries", PolarScatterSeries.$type);
    }
};
IgxPolarScatterSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPolarScatterSeriesModule],
        exports: [IgxPolarScatterSeriesModule],
        entryComponents: [IgxPolarScatterSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPolarScatterSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarSplineSeries extends PolarLineSeriesBase {
    constructor() {
        super();
        this.ab = PolarSplineSeries.$;
    }
    bf() {
        return new PolarSplineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pq = a;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case PolarSplineSeries.$$p[0]:
                this.jl(false);
                break;
        }
    }
    po(a) {
        let b = a;
        b.c0();
    }
    pp(a, b) {
        this.po(b);
        let c = b;
        c.c1(a.m, this.pr);
    }
}
PolarSplineSeries.$t = markType(PolarSplineSeries, 'PolarSplineSeries', PolarLineSeriesBase.$);
PolarSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineSeries, 'raisePropertyChanged', ['Stiffness:pr:pt', [1, 0.5]]);
/**
 * @hidden
 */
class PolarSplineSeriesView extends PolarLineSeriesBaseView {
    constructor(a) {
        super(a);
        this.cz = null;
        this.c2 = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cz = a;
    }
    ap() {
        super.ap();
        let a = new PathGeometry();
        a.c.add(((() => {
            let $ret = new PathFigure();
            return $ret;
        })()));
        this.c2.ak = a;
    }
    c0() {
        Extensions.e(this.c2.ak);
        this.an();
    }
    c1(a, b) {
        this.c2.ak.c = Numeric.h(a.count, (c) => a._inner[c].x, (c) => a._inner[c].y, b);
        this.an();
    }
    a8() {
        super.a8();
        this.c2._stroke = this.e.lb;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.ll;
        this.c2.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        a.s(this.c2);
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c2, "polarShape", ["Main"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
PolarSplineSeriesView.$t = markType(PolarSplineSeriesView, 'PolarSplineSeriesView', PolarLineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPolarSplineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent polar spline series.
*/
const IgxPolarSplineSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent) }];
let IgxPolarSplineSeriesComponent = IgxPolarSplineSeriesComponent_1 = class IgxPolarSplineSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarSplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness() {
        return this.i.pr;
    }
    set stiffness(v) {
        this.i.pr = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarSplineSeriesComponent.prototype, "stiffness", null);
IgxPolarSplineSeriesComponent = IgxPolarSplineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-polar-spline-series',
        template: ``,
        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent_1) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPolarSplineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarSplineSeriesModule = class IgxPolarSplineSeriesModule {
};
IgxPolarSplineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPolarSplineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxPolarSplineSeriesComponent],
        entryComponents: []
    })
], IgxPolarSplineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarSplineSeriesDynamicModule = class IgxPolarSplineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPolarSplineSeriesComponent", IgxPolarSplineSeriesComponent);
        TypeRegistrar.register("PolarSplineSeries", PolarSplineSeries.$type);
    }
};
IgxPolarSplineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPolarSplineSeriesModule],
        exports: [IgxPolarSplineSeriesModule],
        entryComponents: [IgxPolarSplineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPolarSplineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolarSplineAreaSeries extends PolarLineSeriesBase {
    constructor() {
        super();
        this.ab = PolarSplineAreaSeries.$;
    }
    bf() {
        return new PolarSplineAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pq = a;
    }
    po(a) {
        let b = a;
        b.c0();
    }
    pp(a, b) {
        this.po(b);
        if (a.m.count < 1) {
            return;
        }
        let c = b;
        c.c3._opacity = this.d6;
        c.c1(a.m, this.pr);
    }
    get_pl() {
        return true;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case PolarSplineAreaSeries.$$p[0]:
                this.jl(false);
                break;
        }
    }
}
PolarSplineAreaSeries.$t = markType(PolarSplineAreaSeries, 'PolarSplineAreaSeries', PolarLineSeriesBase.$);
PolarSplineAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, PolarSplineAreaSeries, 'raisePropertyChanged', ['Stiffness:pr:pt', [1, 0.5]]);
/**
 * @hidden
 */
class PolarSplineAreaSeriesView extends PolarLineSeriesBaseView {
    constructor(a) {
        super(a);
        this.cz = null;
        this.c4 = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.c2 = ((() => {
            let $ret = new Path();
            $ret.ak = new PathGeometry();
            return $ret;
        })());
        this.cz = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    get c3() {
        return this.c2;
    }
    c0() {
        Extensions.e(this.c2.ak);
        Extensions.e(this.c4.ak);
        this.an();
    }
    c1(a, b) {
        this.c4.ak.c = Numeric.h(a.count + 1, (c) => c < a.count ? a._inner[c].x : a._inner[c - a.count].x, (c) => c < a.count ? a._inner[c].y : a._inner[c - a.count].y, b);
        this.c2.ak.c = Numeric.h(a.count + 1, (c) => c < a.count ? a._inner[c].x : a._inner[c - a.count].x, (c) => c < a.count ? a._inner[c].y : a._inner[c - a.count].y, b);
        this.an();
    }
    a8() {
        super.a8();
        this.c2._fill = this.e.lb;
        this.c2._opacity = this.e.d6;
        this.c4._stroke = this.e.lc;
        this.c4.ac = this.e.ey;
        this.c4.ai = this.e.ll;
        this.c4.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c2._fill = a;
        this.c2._opacity = 1;
        this.c4._stroke = a;
        this.c4.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.c2);
            a.s(this.c4);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c4, "polarShape", ["Main"]);
        this.e.a2.exportPathData(a, this.c2, "fillShape", ["Fill"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = 5;
    }
}
PolarSplineAreaSeriesView.$t = markType(PolarSplineAreaSeriesView, 'PolarSplineAreaSeriesView', PolarLineSeriesBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxPolarSplineAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent polar spline area series.
*/
const IgxPolarSplineAreaSeriesComponent_PROVIDERS = [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent) }];
let IgxPolarSplineAreaSeriesComponent = IgxPolarSplineAreaSeriesComponent_1 = class IgxPolarSplineAreaSeriesComponent extends IgxPolarLineSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new PolarSplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness() {
        return this.i.pr;
    }
    set stiffness(v) {
        this.i.pr = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPolarSplineAreaSeriesComponent.prototype, "stiffness", null);
IgxPolarSplineAreaSeriesComponent = IgxPolarSplineAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-polar-spline-area-series',
        template: ``,
        providers: [{ provide: IgxPolarLineSeriesBaseComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent_1) }, { provide: IgxPolarBaseComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxPolarSplineAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxPolarSplineAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarSplineAreaSeriesModule = class IgxPolarSplineAreaSeriesModule {
};
IgxPolarSplineAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxPolarSplineAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxPolarSplineAreaSeriesComponent],
        entryComponents: []
    })
], IgxPolarSplineAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPolarSplineAreaSeriesDynamicModule = class IgxPolarSplineAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxPolarSplineAreaSeriesComponent", IgxPolarSplineAreaSeriesComponent);
        TypeRegistrar.register("PolarSplineAreaSeries", PolarSplineAreaSeries.$type);
    }
};
IgxPolarSplineAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxPolarSplineAreaSeriesModule],
        exports: [IgxPolarSplineAreaSeriesModule],
        entryComponents: [IgxPolarSplineAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPolarSplineAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartPolarModule = class IgxDataChartPolarModule {
};
IgxDataChartPolarModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPolarAreaSeriesModule,
            IgxPolarLineSeriesModule,
            IgxPolarScatterSeriesModule,
            IgxPolarSplineSeriesModule,
            IgxPolarSplineAreaSeriesModule,
            IgxDataChartPolarCoreModule
        ],
        imports: [CommonModule, IgxPolarAreaSeriesModule,
            IgxPolarLineSeriesModule,
            IgxPolarScatterSeriesModule,
            IgxPolarSplineSeriesModule,
            IgxPolarSplineAreaSeriesModule,
            IgxDataChartPolarCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartPolarModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartPolarDynamicModule = class IgxDataChartPolarDynamicModule {
};
IgxDataChartPolarDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPolarAreaSeriesDynamicModule,
            IgxPolarLineSeriesDynamicModule,
            IgxPolarScatterSeriesDynamicModule,
            IgxPolarSplineSeriesDynamicModule,
            IgxPolarSplineAreaSeriesDynamicModule,
            IgxDataChartPolarCoreDynamicModule,
            IgxDataChartPolarModule
        ],
        imports: [CommonModule, IgxPolarAreaSeriesDynamicModule,
            IgxPolarLineSeriesDynamicModule,
            IgxPolarScatterSeriesDynamicModule,
            IgxPolarSplineSeriesDynamicModule,
            IgxPolarSplineAreaSeriesDynamicModule,
            IgxDataChartPolarCoreDynamicModule,
            IgxDataChartPolarModule
        ],
        entryComponents: []
    })
], IgxDataChartPolarDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartRadialCoreModule = class IgxDataChartRadialCoreModule {
};
IgxDataChartRadialCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryAngleAxisModule,
            IgxNumericRadiusAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxCategoryAngleAxisModule,
            IgxNumericRadiusAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartRadialCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartRadialCoreDynamicModule = class IgxDataChartRadialCoreDynamicModule {
};
IgxDataChartRadialCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryAngleAxisDynamicModule,
            IgxNumericRadiusAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartRadialCoreModule
        ],
        imports: [CommonModule, IgxCategoryAngleAxisDynamicModule,
            IgxNumericRadiusAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartRadialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartRadialCoreDynamicModule);

/**
 * Represents the base class for all IgxDataChartComponent radial series
*/
const IgxRadialBaseComponent_PROVIDERS = [{ provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialBaseComponent) }];
class IgxRadialBaseComponent extends IgxMarkerSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if this series is a radial series
    */
    get isRadial() {
        return this.i.c2;
    }
    /**
     * Gets the effective angle axis for the current series object.
    */
    get angleAxis() {
        if (this.i.nd == null) {
            return null;
        }
        if (!this.i.nd.externalObject) {
            let e = IgxCategoryAngleAxisComponent._createFromInternal(this.i.nd);
            if (e) {
                e._implementation = this.i.nd;
            }
            this.i.nd.externalObject = e;
        }
        return this.i.nd.externalObject;
    }
    set angleAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nd = null : this.i.nd = v.i;
    }
    /**
     * Gets the effective value axis for the current series object.
    */
    get valueAxis() {
        if (this.i.nf == null) {
            return null;
        }
        if (!this.i.nf.externalObject) {
            let e = IgxNumericRadiusAxisComponent._createFromInternal(this.i.nf);
            if (e) {
                e._implementation = this.i.nf;
            }
            this.i.nf.externalObject = e;
        }
        return this.i.nf.externalObject;
    }
    set valueAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nf = null : this.i.nf = v.i;
    }
    /**
     * Gets or sets whether to clip the series to the bounds.
     * Setting this property to true will decrease chart performance.
    */
    get clipSeriesToBounds() {
        return this.i.no;
    }
    set clipSeriesToBounds(v) {
        this.i.no = ensureBool(v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.angleAxis && this.angleAxis.name && this.angleAxis.name == name) {
            return this.angleAxis;
        }
        if (this.valueAxis && this.valueAxis.name && this.valueAxis.name == name) {
            return this.valueAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.angleAxis && this.angleAxis._styling) {
            this.angleAxis._styling(container, component, this);
        }
        if (this.valueAxis && this.valueAxis._styling) {
            this.valueAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Determine if object can be used as ValueAxis
    
    * @param axis  * The object to check
    */
    canUseAsValueAxis(axis) {
        let iv = this.i.nn(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as AngleAxis
    
    * @param axis  * The object to check
    */
    canUseAsAngleAxis(axis) {
        let iv = this.i.nm(axis);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Gets the angle to the provided world position from the center of the radial series.
    
    * @param world  * The world position to get the angle for
    */
    getAngleFromWorld(world) {
        let iv = this.i.nq(toPoint(world));
        return (iv);
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * Get the index of the item near the provided world coordinates.
    
    * @param world  * The world coordinates for which to getch the item index.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Scrolls the specified item into the view.
    
    * @param item  * The item to scroll into view.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAngleAxisComponent),
    __metadata("design:paramtypes", [IgxCategoryAngleAxisComponent])
], IgxRadialBaseComponent.prototype, "angleAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericRadiusAxisComponent),
    __metadata("design:paramtypes", [IgxNumericRadiusAxisComponent])
], IgxRadialBaseComponent.prototype, "valueAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxRadialBaseComponent.prototype, "clipSeriesToBounds", null);

/**
 * Represents the base class for all IgxDataChartComponent anchored radial category series.
*/
const IgxAnchoredRadialSeriesComponent_PROVIDERS = [{ provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxAnchoredRadialSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAnchoredRadialSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAnchoredRadialSeriesComponent) }];
class IgxAnchoredRadialSeriesComponent extends IgxRadialBaseComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the item path that provides the values for the current series.
    */
    get valueMemberPath() {
        return this.i.ok;
    }
    set valueMemberPath(v) {
        this.i.ok = v;
    }
    /**
     * Gets or sets the trend type for the current series object.
    */
    get trendLineType() {
        return this.i.n6;
    }
    set trendLineType(v) {
        this.i.n6 = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush that specifies how to the current series
     * object's Trend line is drawn.
    */
    get trendLineBrush() {
        return brushToString(this.i.oy);
    }
    set trendLineBrush(v) {
        this.i.oy = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this series.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.ox);
    }
    set actualTrendLineBrush(v) {
        this.i.ox = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current series object's trend line.
    */
    get trendLineThickness() {
        return this.i.og;
    }
    set trendLineThickness(v) {
        this.i.og = +v;
    }
    /**
     * Gets or sets the trend line period for the current series.
     * The typical, and initial, value for bollinger band periods is 20.
    */
    get trendLinePeriod() {
        return this.i.oh;
    }
    set trendLinePeriod(v) {
        this.i.oh = +v;
    }
    /**
     * Sets or Gets the Z index of the trendline.
    */
    get trendLineZIndex() {
        return this.i.oi;
    }
    set trendLineZIndex(v) {
        this.i.oi = +v;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    /**
     * Scrolls the specified item into the view.
    
    * @param item  * The item to scroll into view.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredRadialSeriesComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredRadialSeriesComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredRadialSeriesComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxAnchoredRadialSeriesComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredRadialSeriesComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredRadialSeriesComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxAnchoredRadialSeriesComponent.prototype, "trendLineZIndex", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialFrame extends CategoryFrame {
    constructor(a) {
        super(a);
    }
}
RadialFrame.$t = markType(RadialFrame, 'RadialFrame', CategoryFrame.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialBucketCalculator extends Base {
    constructor(a) {
        super();
        this.a = null;
        this.c = 0;
        this.d = 0;
        this.b = 0;
        this.a = a;
    }
    getBucket(a) {
        throw new NotImplementedException(0);
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getErrorBucket(a, b) {
        return NaN;
    }
    getBucketInfo(a, b, c, d) {
        a = this.c;
        b = this.d;
        c = this.b;
        d = this.a.cn.eu;
        return {
            p0: a,
            p1: b,
            p2: c,
            p3: d
        };
    }
    e(a) {
        let b = this.a.bs;
        let c = this.a.br;
        let d = this.a.cn.nd;
        if (b.isEmpty || c.isEmpty || d == null || this.a.cn.bz == null || this.a.cn.bz.count == 0) {
            this.b = 0;
            return;
        }
        let e = Math.floor(d.ll(c, b));
        let f = Math.ceil(d.lk(c, b));
        if (d.ca) {
            f = Math.ceil(d.ll(c, b));
            e = Math.floor(d.lk(c, b));
        }
        if (f < e) {
            f = d.j7 + f;
        }
        let g = this.a.cn.nf;
        let h = g != null ? g.lr : 0.75;
        let i = Math.min(c.width, c.height) * 0.5 * (h) * 2 * Math.PI;
        let j = Math.floor((f - e + 1) * a / i);
        this.b = truncate(Math.max(1, j));
        this.c = truncate(Math.max(0, Math.floor(e / this.b) - 1));
        this.d = truncate(Math.ceil(f / this.b));
    }
    cacheValues() {
    }
    unCacheValues() {
    }
}
RadialBucketCalculator.$t = markType(RadialBucketCalculator, 'RadialBucketCalculator', Base.$, [IBucketizer_$type]);
/**
 * @hidden
 */
class RadialBase extends MarkerSeries {
    constructor() {
        super();
        this.nl = null;
        this.nj = new RadialFrame(3);
        this.nk = new RadialFrame(3);
        this.ni = new RadialFrame(3);
        this.ng = null;
        this.nl = new SeriesRenderer$2(RadialFrame.$, RadialBaseView.$, 1, runOn(this, this.nw), runOn(this, this.nx), runOn(this, this.ca), runOn(this, this.jt), runOn(this, this.nv), (a) => this.nh.co.e(this.eu));
    }
    i2(a) {
        super.i2(a);
        this.nh = a;
    }
    nv() {
        if (this.bt.g) {
            this.bt.t();
        }
    }
    get categoryAxis() {
        return this.nd;
    }
    ap() {
        return this.nd;
    }
    np(a) {
        if (!this.hasMarkers) {
            return false;
        }
        let b = this.nd;
        let c = new ScalerParams(1, this.bs.n2, this.l8, b.ca);
        c.c = this.getEffectiveViewport1(this.bi);
        let d = this.nf;
        let e = new ScalerParams(1, this.bs.n2, this.l8, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ma.cc((f) => {
            if (f._visibility == 0) {
                let g = new SeriesPointOfInterest();
                let h = f.n;
                let i = f.o;
                if (h < this.l8.left || h > this.l8.right || i < this.l8.top || i > this.l8.bottom) {
                    return;
                }
                g.b = b.d1(h, c);
                g.c = d.d1(i, e);
                g.d = b.fl(f.ak);
                g.a = f.content;
                a.add(g);
            }
        });
        return true;
    }
    get_c2() {
        return true;
    }
    ag() {
        return [this.nd, this.nf];
    }
    j1(a, b) {
        this.nh.co.e(this.eu);
        this.jl(false);
    }
    j0(a, b) {
        this.nh.co.e(this.eu);
        this.jl(false);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    if (this.nd != null) {
                        this.nd.bx(this);
                    }
                    if (this.nf != null) {
                        this.nf.bx(this);
                    }
                }
                if (c == null && d != null) {
                    if (this.nd != null) {
                        this.nd.ck(this);
                    }
                    if (this.nf != null) {
                        this.nf.ck(this);
                    }
                }
                this.nh.co.e(this.eu);
                this.jl(false);
                break;
            case RadialBase.$$p[0]:
                if (this.nd != null && this.nf != null) {
                    this.ng = new RadialAxes(this.nf, this.nd);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.nh.co.e(this.eu);
                this.jl(false);
                break;
            case RadialBase.$$p[2]:
                if (this.nd != null && this.nf != null) {
                    this.ng = new RadialAxes(this.nf, this.nd);
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.nh.co.e(this.eu);
                if (this.nf == null || !this.nf.cn()) {
                    this.jl(false);
                }
                break;
            case "SyncLink":
                if (this.bn != null && this.bs != null) {
                    this.nh.co.e(this.eu);
                    this.jl(false);
                }
                break;
            case "TransitionProgress":
                this.nk.c(this.ez, this.nj, this.ni);
                if (this.cc(this.bi)) {
                    return;
                }
                if (this.ez == 1) {
                    this.nx(this.ni, this.nh);
                }
                else {
                    this.nx(this.nk, this.nh);
                }
                if (this.bs != null) {
                    this.bs.ko(this);
                }
                break;
            case RadialBase.$$p[1]:
                this.jl(false);
                this.it();
                break;
            case "VisibilityProxy":
                if (EnumUtil.getEnumValue(Visibility_$type, c) != 0 && EnumUtil.getEnumValue(Visibility_$type, d) == 0) {
                    this.nh.co.e(this.eu);
                }
                break;
        }
    }
    nn(a) {
        if (typeCast(NumericRadiusAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    nm(a) {
        if (typeCast(CategoryAngleAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    fp(a) {
        let b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    nq(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        if (this.nd != null && !b.isEmpty && !c.isEmpty && this.ng != null) {
            let d = this.ng.c(a);
            if (d < 0) {
                d += Math.PI * 2;
            }
            if (d > Math.PI * 2) {
                d -= Math.PI * 2;
            }
            return d;
        }
        return NaN;
    }
    eb(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = -1;
        if (this.nd != null && !b.isEmpty && !c.isEmpty && this.ng != null) {
            let e = this.ng.c(a);
            if (e < 0) {
                e += Math.PI * 2;
            }
            if (e > Math.PI * 2) {
                e -= Math.PI * 2;
            }
            let f = this.nd.getUnscaledAngle(e);
            if (this.nd.categoryMode != 0) {
                f -= 0.5;
            }
            d = f;
        }
        return d;
    }
    e8(a) {
        let b = truncate(Math.round(this.eb(a)));
        if (this.bz != null && b == this.bz.count) {
            b = 0;
        }
        return b;
    }
    c9(a) {
        return false;
    }
    ik() {
        super.ik();
        if (this.nd != null) {
            this.nd.hb(false);
        }
        if (this.nf != null) {
            this.nf.hb(false);
        }
    }
    dw(a, b, c) {
        let d = true;
        let e = c;
        if (!super.dw(a, b, c) || !c.l() || b.isEmpty || a.isEmpty || this.nd == null || this.nd.itemsSource == null || this.nf == null || this.ng == null || this.bz == null || this.nd.bh == null || this.nf.bh == null || this.nf.kc == this.nf.kb) {
            e.co.b = 0;
            d = false;
        }
        return d;
    }
    jm(a) {
        let b;
        let c;
        let d = this.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        if (!this.dw(c, b, this.bi)) {
            this.h3(true, this.bi);
            return;
        }
        let e = new SeriesRenderingArguments(this, c, b, a, this.de);
        let f = this.nl.g(e, this.nj, this.ni, this.nk, this.nh);
        this.nj = f.p1;
        this.ni = f.p2;
        this.nk = f.p3;
    }
    nr() {
        let a = 0;
        for (let b of fromEnum(this.bs.series)) {
            if (b == this) {
                return a;
            }
            let c = typeCast(RadialBase.$, b);
            if (c != null && c.nd == this.nd && c.preferredCategoryMode(c.nd) == 2) {
                a++;
            }
        }
        return -1;
    }
}
RadialBase.$t = markType(RadialBase, 'RadialBase', MarkerSeries.$, [IHasCategoryModePreference_$type]);
RadialBase.$$p = markDep(DependencyProperty, PropertyMetadata, RadialBase, 'raisePropertyChanged', ['AngleAxis:nd:ny', [CategoryAngleAxis.$, null], 'ClipSeriesToBounds:no:nz', [0, false], 'ValueAxis:nf:n0', [NumericRadiusAxis.$, null]]);
/**
 * @hidden
 */
class RadialBaseView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.co = null;
        this.cn = null;
        this.cp = null;
        this.cq = 0;
        this.cr = null;
        this.cn = a;
        this.cp = new Pool$1(Marker.$);
        this.cf(this.cp);
    }
    cc(a) {
        this.cp.c(a);
    }
}
RadialBaseView.$t = markType(RadialBaseView, 'RadialBaseView', MarkerSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialTrendLineManager extends TrendLineManagerBase$1 {
    constructor() {
        super(Number_$type);
        this.i = 0;
        this.h = 0;
        this.j = null;
        this.k = null;
    }
    get_g$a() {
        return 3;
    }
    get g$a() {
        return this.get_g$a();
    }
    l(a, b, c, d, e, f, g, h) {
        let i = g.d * g.c;
        let j = g.e * g.c;
        let k = new List$1(Point_$type, 0);
        if (!g.g.isEmpty && !g.f.isEmpty) {
            if (b == 0) {
                this.a = null;
                this.d.clear();
                return;
            }
            if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(k, b, g, this.a, c.count, (l) => (l + 1), (l) => c.item(l), (l) => e(l - 1), f, i + 1, j + 1);
            }
            if (this.b(b)) {
                this.a = null;
                TrendAverageCalculator.b(b, this.d, c, d);
                for (let l = g.d; l <= g.e; l += 1) {
                    let m = (l % c.count) * g.c;
                    if (m >= 0 && m < this.d.count) {
                        let n = e(m);
                        let o = f(this.d._inner[m]);
                        if (!isNaN_(n) && !isNaN_(o)) {
                            k.add({ $type: Point_$type, x: n + g.a, y: o });
                        }
                    }
                }
            }
            if (k.count > 0) {
                this.f(k, g, a, h);
            }
        }
    }
    e(a, b, c) {
        this.f(a, b, c, null);
    }
    f(a, b, c, d) {
        if (d != null) {
            d.i = c;
        }
        let e = ((() => {
            let $ret = new PolarLinePlanner();
            $ret.m = (f) => a.item(f).x;
            $ret.n = (f) => a.item(f).y;
            $ret.a = d;
            $ret.q = a.count;
            $ret.l = b.b;
            $ret.o = (f) => this.j(a.item(f).x, a.item(f).y);
            $ret.p = (f) => this.k(a.item(f).x, a.item(f).y);
            $ret.f = true;
            $ret.ab = b.f;
            $ret.ac = b.g;
            return $ret;
        })());
        e.x(null, null);
    }
}
RadialTrendLineManager.$t = markType(RadialTrendLineManager, 'RadialTrendLineManager', TrendLineManagerBase$1.$.specialize(Number_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AnchoredRadialBucketCalculator extends RadialBucketCalculator {
    constructor(a) {
        super(a);
        this.f = null;
        this.f = a;
    }
    getBucket(a) {
        let b = this.f.cs.n8;
        let c = Math.min(a * this.b, b.count - 1);
        let d = Math.min(c + this.b - 1, b.count - 1);
        let e = NaN;
        let f = NaN;
        for (let g = c; g <= d; ++g) {
            let h = b.item(g);
            if (!isNaN_(e)) {
                if (!isNaN_(h)) {
                    e = Math.min(e, h);
                    f = Math.max(f, h);
                }
            }
            else {
                e = h;
                f = h;
            }
        }
        if (!isNaN_(e)) {
            return [0.5 * (c + d), e, f];
        }
        return [0.5 * (c + d), NaN, NaN];
    }
}
AnchoredRadialBucketCalculator.$t = markType(AnchoredRadialBucketCalculator, 'AnchoredRadialBucketCalculator', RadialBucketCalculator.$);
/**
 * @hidden
 */
class AnchoredRadialSeries extends RadialBase {
    constructor() {
        super();
        this.n3 = null;
        this.n7 = null;
        this.o1 = { $type: Point_$type, x: 0, y: 0 };
        this.n5 = null;
        this.n4 = null;
        this.n5 = new RadialFrame(3);
        this.n3 = new CategoryLineRasterizer();
    }
    bf() {
        return new AnchoredRadialSeriesView(this);
    }
    h1() {
        super.h1();
        this.nd = null;
        this.nf = null;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == AnchoredRadialSeries.$$p[0]) {
            return this.ft(a, b, this.ok);
        }
        return super.fs(a, b);
    }
    i2(a) {
        super.i2(a);
        this.n2 = a;
    }
    fe(a, b) {
        return this.ff(a, b, this.nd, null, this.n8);
    }
    fc(a, b) {
        return this.fd(a, b, this.nd, null, this.n8);
    }
    d9(a, b, c, d, e) {
        if (this.n8 == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.nd, d, e, this.n8.count, null);
    }
    en(a, b, c) {
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.od(this.nd, this.bi.bs, this.bi.br, d);
        let f = new ScalerParams(0, this.bi.bs, this.bi.br, this.nd.ca, d);
        f.c = this.bs.oh;
        return this.ep(this.n8, a, this.nd, f, e, null, b, c);
    }
    lv(a, b, c) {
        if (this.nf == null || this.nd == null || this.bi == null || this.bi.bs.isEmpty || this.bi.br.isEmpty) {
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, this.bi.bs, this.bi.br, this.nf.ca, d);
        e.c = this.getEffectiveViewport1(this.bi);
        let f = this.en(a, b, c);
        f = this.nf.dy(f, e);
        let g = this.ng.c(a);
        if (!b && this.nd != null) {
            let h = this.fe(a, c);
            let i = this.fc(a, c);
            let j = this.od(this.nd, this.bi.bs, this.bi.br, d);
            let k = new ScalerParams(0, this.bi.bs, this.bi.br, this.nd.ca, d);
            k.c = this.bs.oh;
            let l = this.d9(a, h, this.nd, k, j);
            let m = this.d9(a, i, this.nd, k, j);
            if (m <= l) {
                g = this.nd.dy(i, k) + j;
            }
            else {
                g = this.nd.dy(h, k) + j;
            }
        }
        let n = this.ng.d(g, f, this.bi.bs, this.bi.br);
        let o = this.ng.e(g, f, this.bi.bs, this.bi.br);
        return { $type: Point_$type, x: n, y: o };
    }
    get n8() {
        return this.n7;
    }
    set n8(a) {
        if (this.n7 != a) {
            let b = this.n7;
            this.n7 = a;
            this.raisePropertyChanged("ValueColumn", b, this.n7);
        }
    }
    get ox() {
        return this.c(AnchoredRadialSeries.oo);
    }
    set ox(a) {
        this.h(AnchoredRadialSeries.oo, a);
    }
    an(a) {
        if (a != null && a == this.nd && this.n8 != null && this.n8.count > 0) {
            return new AxisRange(0, this.n8.count - 1);
        }
        if (a != null && a == this.nf && this.n8 != null && this.n8.count > 0) {
            return new AxisRange(this.n8.minimum, this.n8.maximum);
        }
        return null;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.n2.ct.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        let e = typeCast(NumericAxisBase.$, this.nf);
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) !== null) {
                    c.deregisterColumn(this.n8);
                    this.n8 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) !== null) {
                    this.n8 = this.bw(this.ok);
                    this.n2.co.e(this.eu);
                }
                if (e != null && !e.cn()) {
                    this.n2.co.e(this.eu);
                    this.jl(false);
                }
                break;
            case AnchoredRadialSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.n8);
                    this.n8 = this.bw(this.ok);
                }
                break;
            case "ValueColumn":
                if (e != null && !e.cn()) {
                    this.n2.co.e(this.eu);
                    this.jl(false);
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    }
    h6(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.n2.co.e(this.eu);
                break;
        }
        this.n2.ct.g$e(a, b, c, d);
        switch (a) {
            case 4:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 1:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (this.ok != null && this.n2.co.b > 0 && this.nf != null && !this.nf.cn()) {
                    this.jl(true);
                }
                break;
            case 3:
                if (d == this.ok) {
                    if (this.nf != null && !this.nf.cn()) {
                        this.jl(true);
                    }
                }
                break;
        }
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        let e = c;
        if (this.bz == null || this.bz.count == 0 || this.nd == null || this.n8 == null || this.nd.j7 == 0 || this.nf == null || isInfinity(this.nf.kc) || isInfinity(this.nf.kb) || e.co.b < 1) {
            d = false;
        }
        return d;
    }
    getOffsetValue() {
        return this.od(this.nd, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.nd.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    get_ob() {
        return false;
    }
    get ob() {
        return this.get_ob();
    }
    od(a, b, c, d) {
        let e = 0;
        let f = this.preferredCategoryMode(a);
        if (f == 0 && a.categoryMode != 0) {
            f = 1;
        }
        switch (f) {
            case 0:
                e = 0;
                break;
            case 1:
                e = 0.5 * a.getCategorySize(b, c, d);
                break;
            case 2:
                e = a.getGroupCenter(this.nr(), b, c, d);
                break;
        }
        if (a.ca) {
            e = -e;
        }
        return e;
    }
    nw(a, b) {
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.nd;
        let g = this.nf;
        let h = g.kc;
        let i = g.kb;
        a.f.clear();
        a.m.clear();
        a.p.clear();
        let j = this.md();
        let k = 0;
        let l = b;
        let m = new CollisionAvoider();
        let n = 0;
        let o = b.co.d;
        n = this.od(f, c, d, e);
        l.ct.i = this.nf.lr;
        l.ct.h = this.nf.lq;
        l.ct.j = (p, q) => this.oe(p, q, c, d);
        l.ct.k = (p, q) => this.of(p, q, c, d);
        let p = ((() => {
            let $ret = new Clipper(0, d, false);
            $ret.i = a.p;
            return $ret;
        })());
        let q = ((() => {
            let $ret = new TrendResolutionParams();
            $ret.c = b.co.b;
            $ret.d = b.co.c;
            $ret.e = o;
            $ret.a = n;
            $ret.b = this.eu;
            $ret.f = d;
            $ret.g = c;
            return $ret;
        })());
        l.ct.l(a.p, this.n6, this.n8, this.oh, (r) => this.nd.getScaledAngle(r), (r) => this.nf.lx(r), q, p);
        let r = true;
        if (this.oc(b)) {
            o--;
        }
        for (let s = b.co.c; s <= o; ++s) {
            let t = s;
            if (t * b.co.b >= this.nd.j7) {
                t -= intDivide((this.nd.j7), b.co.b);
            }
            let u = b.co.getBucket(t);
            if (!isNaN_(u[0])) {
                u[0] = f.getScaledAngle(u[0]) + n;
                if (u[1] < h || u[1] > i) {
                    continue;
                }
                u[1] = g.lx(u[1]);
                if (b.co.b > 1) {
                    if (u[2] < h || u[2] > i) {
                        continue;
                    }
                    u[2] = g.lx(u[2]);
                }
                else {
                    u[2] = u[1];
                }
                if ((isNaN_(u[1]) || isNaN_(u[2])) && r && this.ob && this.oa()) {
                    o++;
                }
                else {
                    r = false;
                }
                a.f.add(u);
                if (j) {
                    let v = Math.min(t * b.co.b, this.bz.count - 1);
                    let w = this.ng.d(u[0], u[1], c, d);
                    let x = this.ng.e(u[0], u[1], c, d);
                    let y = new Rect(0, w - 5, x - 5, 11, 11);
                    if (!isNaN_(w) && !isNaN_(x) && !isInfinity(w) && !isInfinity(x) && m.tryAdd(y)) {
                        a.m.add({ $type: Point_$type, x: w, y: x });
                        let z = b.cp.item(k);
                        z.ak = v;
                        z.content.item = this.bz.item(v);
                        ++k;
                    }
                }
            }
            else {
                if (r && this.ob && this.oa()) {
                    o++;
                }
            }
        }
        b.cp.count = k;
        return;
    }
    oe(a, b, c, d) {
        return this.ng.d(a, b, c, d);
    }
    of(a, b, c, d) {
        return this.ng.e(a, b, c, d);
    }
    oc(a) {
        let b = a;
        return !this.ob && b.co.c == 0 && b.co.d == this.nd.j7;
    }
    n1(a, b, c) {
        let d = null;
        let e = c.bs;
        let f = c.br;
        if (b > -1 && !e.isEmpty && !f.isEmpty) {
            let g = a._inner[0][0] < f.left - 2000 ? f.left - 10 : NaN;
            let h = f.bottom + 10;
            let i = a._inner[b][0] > f.right + 2000 ? f.right + 10 : NaN;
            let j = f.top - 10;
            d = new Clipper(1, g, h, i, j, false);
        }
        return d;
    }
    on(a, b, c, d, e) {
        if (a.count > 0 && d.count > 0) {
            if (!e || this.n9()) {
                a.add(this.o1);
                a.add(a._inner[0]);
                d.add(this.o1);
                d.add(d._inner[0]);
            }
        }
    }
    oa() {
        return !this.n9();
    }
    n9() {
        let a = this.bi.bs;
        return !a.containsPoint({ $type: Point_$type, x: 0.5, y: 0.5 });
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a) {
            c.cp.clear();
        }
        c.ct.g$d();
    }
    nx(a, b) {
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.l0(b);
        let g = b;
        g.ct.g$g(a.p);
        CategoryMarkerManager.b(this, a.m, g.cp, this.mf);
        g.cj();
        this.om(d, c, e, f, g);
    }
    om(a, b, c, d, e) {
        e.cu(a, b, c, d);
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        this.n2.cv();
    }
    fv(a, b) {
        if (a == this.n2.ct.g$j) {
            return null;
        }
        return super.fv(a, b);
    }
    c9(a) {
        let b = this.bi.bs;
        b = b.copy();
        let c = this.bi.br;
        let d = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        if (this.nd == null || this.n8 == null || this.nf == null) {
            return false;
        }
        if (d < 0 || d > this.n8.count - 1) {
            return false;
        }
        let e = this.nd.getScaledAngle(d);
        let f = this.nf.lx(this.n8.item(d));
        if (isNaN_(f)) {
            f = (this.nf.lq + this.nf.lr) / 2;
        }
        let g = 0.5 + (Math.cos(e) * f);
        let h = 0.5 + (Math.sin(e) * f);
        if (!isNaN_(g)) {
            if (g < b.left + 0.1 * b.width) {
                g = g + 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
            if (g > b.right - 0.1 * b.width) {
                g = g - 0.4 * b.width;
                b.x = g - 0.5 * b.width;
            }
        }
        if (!isNaN_(h)) {
            if (h < b.top + 0.1 * b.height) {
                h = h + 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
            if (h > b.bottom - 0.1 * b.height) {
                h = h - 0.4 * b.height;
                b.y = h - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return d >= 0;
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        let c = typeCast(AnchoredRadialSeriesView.$, this.bh);
        c.co.e(this.eu);
        if (this.cc(this.bh)) {
            return;
        }
        if (!this.df) {
            this.n5 = new RadialFrame(3);
            this.nw(this.n5, c);
        }
        this.df = false;
        this.nx(this.n5, c);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        g.co.e(this.eu);
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.n4 == null) {
            this.n4 = new RadialFrame(3);
        }
        this.n4.u();
        this.nw(this.n4, g);
        this.nx(this.n4, g);
    }
    ic(a) {
        super.ic(a);
        this.a2.exportTrendlineData(this, a, this.n2.ct.g$j);
    }
}
AnchoredRadialSeries.$t = markType(AnchoredRadialSeries, 'AnchoredRadialSeries', RadialBase.$);
AnchoredRadialSeries.oo = DependencyProperty.i("ActualTrendLineBrush", Brush.$, AnchoredRadialSeries.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
AnchoredRadialSeries.$$p = markDep(DependencyProperty, PropertyMetadata, AnchoredRadialSeries, 'raisePropertyChanged', ['ValueMemberPath:ok:ow', [2, null], 'TrendLineType:n6:ou', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness:og:ot', [1, 1.5], 'TrendLinePeriod:oh:os', [1, 7], 'TrendLineZIndex:oi:ov', [1, 1], 'TrendLineBrush:oy:op', [Brush.$, null], 'TrendLineDashArray:oz:oq', [DoubleCollection.$], 'TrendLineDashCap:o0:or', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class AnchoredRadialSeriesView extends RadialBaseView {
    constructor(a) {
        super(a);
        this.cs = null;
        this.ct = null;
        this.co = new AnchoredRadialBucketCalculator(this);
        this.cs = a;
        this.ct = new RadialTrendLineManager();
    }
    cu(a, b, c, d) {
    }
    cv() {
        this.cs.ox = null;
        if (this.cs.oy != null) {
            this.cs.ox = this.cs.oy;
        }
        else {
            this.cs.ox = this.cs.lb;
        }
    }
    a2(a, b) {
        if (a.d) {
            if (!b) {
            }
            if (this.cs.n6 != 0 && !b) {
                let c = this.ct.g$j;
                c.ac = this.cs.og;
                c._stroke = this.cs.ox;
                c.ai = this.cs.oz;
                c.ad = this.cs.o0;
                a.u(c);
            }
        }
        super.a2(a, b);
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        if (this.cs.nd.e9 != null) {
            a += "<span>${item." + this.cs.nd.e9 + "}</span><br/>";
        }
        a += "<span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.cs.ok + "}</span></div>";
        return a;
    }
}
AnchoredRadialSeriesView.$t = markType(AnchoredRadialSeriesView, 'AnchoredRadialSeriesView', RadialBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialAreaSeries extends AnchoredRadialSeries {
    constructor() {
        super();
        this.ab = RadialAreaSeries.$;
    }
    bf() {
        return new RadialAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.o2 = a;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        this.o2.cx();
    }
    nx(a, b) {
        super.nx(a, b);
        let c = b.bs;
        let d = b.br;
        let e = b;
        if (b.l() && !c.isEmpty && !d.isEmpty && this.nd != null && this.nf != null) {
            let f = a.f;
            let g = f.count;
            let h = new List$1(Array_$type, 2, g);
            let i = 0;
            for (let j = 0; j < g; j++) {
                let k = new Array(4);
                h.add(k);
                k[0] = this.ng.d(a.f._inner[j][0], a.f._inner[j][1], c, d);
                k[1] = this.ng.e(a.f._inner[j][0], a.f._inner[j][1], c, d);
                k[2] = this.ng.d(a.f._inner[j][0], a.f._inner[j][2], c, d);
                let l = a.f._inner[j][2];
                k[3] = this.ng.e(a.f._inner[j][0], l, c, d);
                if (l > i) {
                    i = l;
                }
            }
            let m = ViewportUtils.c(0.5, c, d);
            let n = ViewportUtils.f(0.5, c, d);
            this.o1 = { $type: Point_$type, x: m, y: n };
            e.cy(a.f.count, h, false, this.o2.co.b, this.eu, runOn(this, this.on), this.o3);
            e.cz._opacity = this.d6;
            e.c0._opacity = this.d6 * 0.5;
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case RadialAreaSeries.$$p[0]:
                this.jl(false);
                this.it();
                break;
        }
    }
    get_ob() {
        return true;
    }
}
RadialAreaSeries.$t = markType(RadialAreaSeries, 'RadialAreaSeries', AnchoredRadialSeries.$);
RadialAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialAreaSeries, 'raisePropertyChanged', ['UnknownValuePlotting:o3:o5', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class RadialAreaSeriesView extends AnchoredRadialSeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cz = new Path();
        this.c1 = new Path();
        this.c0 = new Path();
        this.c2 = new Path();
        this.cw = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    cx() {
        this.cz.ak = null;
        this.c1.ak = null;
        this.c0.ak = null;
        this.c2.ak = null;
        this.an();
    }
    cy(a, b, c, d, e, f, g) {
        this.cs.n3.i(this.cz, this.c1, this.c0, this.c2, a, b, c, d, e, f, g);
        this.an();
    }
    a8() {
        super.a8();
        this.cz._fill = this.e.lb;
        this.cz._opacity = this.e.d6;
        this.c0._fill = this.e.lb;
        this.c0._opacity = this.e.d6 * 0.5;
        this.c1._stroke = this.e.lc;
        this.c1.ac = this.e.ey;
        this.c1.ai = this.e.ll;
        this.c1.ad = this.e.lm;
        this.c2._stroke = this.e.lc;
        this.c2.ac = this.e.ey;
        this.c2.ai = this.e.ll;
        this.c2.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c1._stroke = a;
        this.c1.ac = this.e.ey + 3;
        this.c2._stroke = a;
        this.c2.ac = this.e.ey + 3;
        this.cz._fill = a;
        this.cz._opacity = 1;
        this.c0._fill = a;
        this.c0._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.cz);
            a.s(this.c0);
            a.s(this.c1);
            a.s(this.c2);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c1, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.c2, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.c0, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.cz, "fillShape", ["Fill"]);
    }
}
RadialAreaSeriesView.$t = markType(RadialAreaSeriesView, 'RadialAreaSeriesView', AnchoredRadialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRadialAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent radial area series.
*/
const IgxRadialAreaSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent) }];
let IgxRadialAreaSeriesComponent = IgxRadialAreaSeriesComponent_1 = class IgxRadialAreaSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RadialAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.o3;
    }
    set unknownValuePlotting(v) {
        this.i.o3 = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialAreaSeriesComponent.prototype, "unknownValuePlotting", null);
IgxRadialAreaSeriesComponent = IgxRadialAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-radial-area-series',
        template: ``,
        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent_1) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRadialAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialAreaSeriesModule = class IgxRadialAreaSeriesModule {
};
IgxRadialAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRadialAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxRadialAreaSeriesComponent],
        entryComponents: []
    })
], IgxRadialAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialAreaSeriesDynamicModule = class IgxRadialAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRadialAreaSeriesComponent", IgxRadialAreaSeriesComponent);
        TypeRegistrar.register("RadialAreaSeries", RadialAreaSeries.$type);
    }
};
IgxRadialAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRadialAreaSeriesModule],
        exports: [IgxRadialAreaSeriesModule],
        entryComponents: [IgxRadialAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRadialAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialColumnSeries extends AnchoredRadialSeries {
    constructor() {
        super();
        this.ab = RadialColumnSeries.$;
    }
    bf() {
        return new RadialColumnSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.o2 = a;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    preferredCategoryMode(a) {
        return a != null && a == this.nd ? 2 : 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a) {
            c.cx.count = 0;
        }
    }
    eg() {
        return this.nd.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    nx(a, b) {
        super.nx(a, b);
        let c = a.f;
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = this.l0(b);
        let h = this.nf.jo(e, d, f, g);
        let i = b;
        let j = this.nf;
        let k = Math.max(0, 0.5 * j.lq);
        k = Math.max(k, h.minLength * 0.9);
        let l = ViewportUtils.d(k, d, e);
        let m = this.nd.jz(d, e, f);
        let n = Math.max(0.1 * this.nf.lr, k);
        let o = this.ng.d(0, n, d, e);
        let p = this.ng.e(0, n, d, e);
        let q = this.ng.d(m, n, d, e);
        let r = this.ng.e(m, n, d, e);
        let s = Math.sqrt((o - q) * (o - q) + (p - r) * (p - r));
        let t = { $type: Point_$type, x: ViewportUtils.c(0.5, d, e), y: ViewportUtils.f(0.5, d, e) };
        for (let u = 0; u < c.count; ++u) {
            let v = Math.min(a.f._inner[u][2], h.maxLength * 1.1);
            let w = this.ng.d(a.f._inner[u][0], v, d, e);
            let x = this.ng.e(a.f._inner[u][0], v, d, e);
            let y = Math.sqrt((w - t.x) * (w - t.x) + (x - t.y) * (x - t.y));
            let z = y;
            let aa = l;
            let ab = a.f._inner[u][0] - (Math.PI / 2);
            let ac = i.cx.item(u);
            let ad = 0 - (s / 2);
            let ae = (s / 2);
            let af = Math.max(aa, z);
            let ag = Math.min(aa, z);
            let ah = Math.cos(ab);
            let ai = Math.sin(ab);
            let aj = { $type: Point_$type, x: t.x + (ad * ah - af * ai), y: t.y + (ad * ai + af * ah) };
            let ak = { $type: Point_$type, x: t.x + (ae * ah - af * ai), y: t.y + (ae * ai + af * ah) };
            let al = { $type: Point_$type, x: t.x + (ae * ah - ag * ai), y: t.y + (ae * ai + ag * ah) };
            let am = { $type: Point_$type, x: t.x + (ad * ah - ag * ai), y: t.y + (ad * ai + ag * ah) };
            let an = new PathGeometry();
            let ao = new PathFigure();
            ao._startPoint = aj;
            ao._isClosed = true;
            let ap = new PolyLineSegment();
            ap._points.add(ak);
            ap._points.add(al);
            ap._points.add(am);
            ao._segments.add(ap);
            an.c.add(ao);
            ac.ak = an;
        }
        i.cx.count = c.count;
        this.o2.c2();
    }
}
RadialColumnSeries.$t = markType(RadialColumnSeries, 'RadialColumnSeries', AnchoredRadialSeries.$);
RadialColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialColumnSeries, 'raisePropertyChanged', ['RadiusX:o3:o7', [1, 2], 'RadiusY:o4:o8', [1, 2]]);
/**
 * @hidden
 */
class RadialColumnSeriesView extends AnchoredRadialSeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cx = null;
        this.cy = null;
        this.cw = a;
        this.cx = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.c4);
            $ret.activate = runOn(this, this.cz);
            $ret.disactivate = runOn(this, this.c1);
            $ret.destroy = runOn(this, this.c0);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.cy = new List$1(Path.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    c4() {
        let a = new Path();
        this.cy.add(a);
        a._visibility = 1;
        return a;
    }
    cz(a) {
        a._visibility = 0;
    }
    c1(a) {
        a._visibility = 1;
    }
    c0(a) {
        this.cy.remove(a);
    }
    c3(a, b, c, d, e, f) {
        this.an();
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._fill = this.e.lb;
        c._stroke = this.e.lc;
        c.ac = this.e.ey;
        c.ai = this.e.ll;
        c.ad = this.e.lm;
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.cy.count; c++) {
                let d = this.cy._inner[c];
                this.ba(d, c, b);
                a.s(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        for (let c of fromEnum(this.cx.a)) {
            this.e.a2.exportPathData(a, c, "column" + b, ["Main", "Fill"]);
            b++;
        }
    }
    c2() {
        this.an();
    }
}
RadialColumnSeriesView.$t = markType(RadialColumnSeriesView, 'RadialColumnSeriesView', AnchoredRadialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRadialColumnSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent radial column series.
 * Compare values across categories by using radial rectangles.
*/
const IgxRadialColumnSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent) }];
let IgxRadialColumnSeriesComponent = IgxRadialColumnSeriesComponent_1 = class IgxRadialColumnSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RadialColumnSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX() {
        return this.i.o3;
    }
    set radiusX(v) {
        this.i.o3 = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.o4;
    }
    set radiusY(v) {
        this.i.o4 = +v;
    }
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate() {
        this.i.ac();
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialColumnSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialColumnSeriesComponent.prototype, "radiusY", null);
IgxRadialColumnSeriesComponent = IgxRadialColumnSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-radial-column-series',
        template: ``,
        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent_1) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialColumnSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRadialColumnSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialColumnSeriesModule = class IgxRadialColumnSeriesModule {
};
IgxRadialColumnSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRadialColumnSeriesComponent],
        imports: [CommonModule],
        exports: [IgxRadialColumnSeriesComponent],
        entryComponents: []
    })
], IgxRadialColumnSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialColumnSeriesDynamicModule = class IgxRadialColumnSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRadialColumnSeriesComponent", IgxRadialColumnSeriesComponent);
        TypeRegistrar.register("RadialColumnSeries", RadialColumnSeries.$type);
    }
};
IgxRadialColumnSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRadialColumnSeriesModule],
        exports: [IgxRadialColumnSeriesModule],
        entryComponents: [IgxRadialColumnSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRadialColumnSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialLineSeries extends AnchoredRadialSeries {
    constructor() {
        super();
        this.ab = RadialLineSeries.$;
    }
    bf() {
        return new RadialLineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.o2 = a;
    }
    ac() {
        super.ac();
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.cx();
    }
    nx(a, b) {
        super.nx(a, b);
        let c = b.bs;
        let d = b.br;
        let e = a.f;
        let f = e.count;
        let g = new List$1(Array_$type, 2, f);
        let h = 0;
        for (let i = 0; i < f; i++) {
            let j = new Array(4);
            g.add(j);
            j[0] = this.ng.d(a.f._inner[i][0], a.f._inner[i][1], c, d);
            j[1] = this.ng.e(a.f._inner[i][0], a.f._inner[i][1], c, d);
            j[2] = this.ng.d(a.f._inner[i][0], a.f._inner[i][2], c, d);
            let k = a.f._inner[i][2];
            j[3] = this.ng.e(a.f._inner[i][0], k, c, d);
            if (k > h) {
                h = k;
            }
        }
        let l = b;
        l.cy(f, g, false, this.o3, this.n1(g, f - 1, b), l.co.b, this.eu);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case RadialLineSeries.$$p[0]:
                this.jl(false);
                this.it();
                break;
        }
    }
    get_ob() {
        return true;
    }
}
RadialLineSeries.$t = markType(RadialLineSeries, 'RadialLineSeries', AnchoredRadialSeries.$);
RadialLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:o3:o5', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
/**
 * @hidden
 */
class RadialLineSeriesView extends AnchoredRadialSeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.c0 = new Path();
        this.cz = new Path();
        this.c1 = new Path();
        this.cw = a;
    }
    cx() {
        this.c0.ak = null;
        this.cz.ak = null;
        this.c1.ak = null;
        this.an();
    }
    cy(a, b, c, d, e, f, g) {
        this.cs.n3.m(this.c0, this.cz, this.c1, a, b, c, d, e, f, g);
        this.an();
    }
    a8() {
        super.a8();
        this.c0._stroke = this.e.lb;
        this.c0.ac = this.e.ey;
        this.c0.ai = this.e.ll;
        this.c0.ad = this.e.lm;
        this.c1._stroke = this.e.lb;
        this.c1.ac = this.e.ey;
        this.c1.ai = this.e.ll;
        this.c1.ad = this.e.lm;
        this.cz._fill = this.e.lb;
        this.cz._opacity = 0.75;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c0._stroke = a;
        this.c0.ac = this.e.ey + 3;
        this.c1._stroke = a;
        this.c1.ac = this.e.ey + 3;
        this.cz._fill = a;
        this.cz._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.cz);
            a.s(this.c0);
            a.s(this.c1);
        }
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c0, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.c1, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.cz, "translucentShape", ["Translucent"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
RadialLineSeriesView.$t = markType(RadialLineSeriesView, 'RadialLineSeriesView', AnchoredRadialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRadialLineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent radial line series.
*/
const IgxRadialLineSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent) }];
let IgxRadialLineSeriesComponent = IgxRadialLineSeriesComponent_1 = class IgxRadialLineSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RadialLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.o3;
    }
    set unknownValuePlotting(v) {
        this.i.o3 = ensureEnum(UnknownValuePlotting_$type, v);
    }
    /**
     * When overridden in a derived class, is invoked whenever application code or internal processes
     * call ApplyTemplate.
    
    */
    onApplyTemplate() {
        this.i.ac();
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialLineSeriesComponent.prototype, "unknownValuePlotting", null);
IgxRadialLineSeriesComponent = IgxRadialLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-radial-line-series',
        template: ``,
        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent_1) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRadialLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialLineSeriesModule = class IgxRadialLineSeriesModule {
};
IgxRadialLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRadialLineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxRadialLineSeriesComponent],
        entryComponents: []
    })
], IgxRadialLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialLineSeriesDynamicModule = class IgxRadialLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRadialLineSeriesComponent", IgxRadialLineSeriesComponent);
        TypeRegistrar.register("RadialLineSeries", RadialLineSeries.$type);
    }
};
IgxRadialLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRadialLineSeriesModule],
        exports: [IgxRadialLineSeriesModule],
        entryComponents: [IgxRadialLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRadialLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SliceCoords extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.f = null;
        this.h = null;
        this.j = null;
        this.e = null;
        this.g = null;
        this.i = null;
        this.k = null;
        this.c = false;
        this.n = new Size();
        this.m = new Size();
        this.l = new Size();
    }
    static b(a, b, c, d, e, f, g) {
        let h = Math.min(c, d);
        let i = Math.max(c, d);
        let j = Math.cos(h);
        let k = Math.sin(h);
        let l = Math.max(0, e);
        let m = f;
        let n = g.x + j * l;
        let o = g.y + k * l;
        let p = g.x + j * m;
        let q = g.y + k * m;
        let r = Math.cos(i);
        let s = Math.sin(i);
        let t = g.x + r * l;
        let u = g.y + s * l;
        let v = g.x + r * m;
        let w = g.y + s * m;
        n = ViewportUtils.c(n, a, b);
        o = ViewportUtils.f(o, a, b);
        p = ViewportUtils.c(p, a, b);
        q = ViewportUtils.f(q, a, b);
        t = ViewportUtils.c(t, a, b);
        u = ViewportUtils.f(u, a, b);
        v = ViewportUtils.c(v, a, b);
        w = ViewportUtils.f(w, a, b);
        let x = { $type: Point_$type, x: n, y: o };
        let y = { $type: Point_$type, x: p, y: q };
        let z = { $type: Point_$type, x: v, y: w };
        let aa = { $type: Point_$type, x: t, y: u };
        let ab = ViewportUtils.d(m, a, b);
        let ac = ViewportUtils.g(m, a, b);
        let ad = ViewportUtils.d(l, a, b);
        let ae = ViewportUtils.g(l, a, b);
        return ((() => {
            let $ret = new SliceCoords();
            $ret.d = x;
            $ret.f = y;
            $ret.h = z;
            $ret.j = aa;
            $ret.c = ((i - h) > Math.PI);
            $ret.n = new Size(1, ab, ac);
            $ret.m = new Size(1, ad, ae);
            return $ret;
        })());
    }
    static a(a, b, c, d, e, f, g, h, i) {
        let j = ViewportUtils.b(i, a, b);
        let k = f - e;
        if (k < 0) {
            return null;
        }
        if (ViewportUtils.d(k, a, b) < 2) {
            return null;
        }
        if (j * 2 > k) {
            j = k / 2;
            i = ViewportUtils.d(j, a, b);
        }
        let l = ViewportUtils.b(h, a, b);
        let m = l / (f - j);
        let n = Math.atan(m);
        if (n * 2 > Math.abs(d - c)) {
            n = Math.abs(d - c) / 2;
            h = ViewportUtils.d(Math.tan(n) * (f - j), a, b);
        }
        let o = SliceCoords.b(a, b, c + n, d - n, e, f, g);
        let p = SliceCoords.b(a, b, c, d, e + (j * (e / f)), f - j, g);
        o.g = o.f;
        o.k = o.j;
        o.e = p.d;
        o.f = p.f;
        o.i = p.h;
        o.j = p.j;
        o.l = new Size(1, h, i);
        return o;
    }
}
SliceCoords.$t = markType(SliceCoords, 'SliceCoords');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RadialPieSeries extends AnchoredRadialSeries {
    constructor() {
        super();
        this.ab = RadialPieSeries.$;
    }
    bf() {
        return new RadialPieSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.o2 = a;
    }
    preferredCategoryMode(a) {
        return a != null && a == this.nd ? 2 : 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a && c.cx != null) {
            c.cx.count = 0;
        }
    }
    eg() {
        return this.nd.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    nx(a, b) {
        super.nx(a, b);
        let c = b;
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = this.l0(b);
        let h = this.nf.jo(e, d, f, g);
        let i = a.f;
        let j = this.nf;
        let k = Math.max(0, 0.5 * j.lq);
        let l = k;
        l = Math.max(l, h.minLength);
        let m = this.nd.jz(d, e, f);
        let n = { $type: Point_$type, x: 0.5, y: 0.5 };
        let o = this.o3;
        let p = this.o4;
        let q = (o > 0 && p > 0);
        let r = 0;
        for (let s = 0; s < i.count; ++s) {
            let t = c.cx.item(s);
            let u = i._inner[s][0];
            let v = Math.min(i._inner[s][2], h.maxLength);
            let w = null;
            if (q) {
                w = this.o9(d, e, u - (m * 0.5), u + (m * 0.5), l, v, n, o, p);
            }
            else {
                w = this.pa(d, e, u - (m * 0.5), u + (m * 0.5), l, v, n);
            }
            t.ak = w;
            let x = i._inner[s][2];
            if (x > r) {
                r = x;
            }
        }
        c.cq = ViewportUtils.d(r, d, e);
        c.cr = { $type: Point_$type, x: ViewportUtils.c(n.x, d, e), y: ViewportUtils.f(n.y, d, e) };
        c.cx.count = i.count;
        c.c2();
    }
    pa(a, b, c, d, e, f, g) {
        let h = SliceCoords.b(a, b, c, d, e, f, g);
        let i = new PathFigure();
        i._startPoint = h.d;
        i._isClosed = true;
        i._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = h.f;
            return $ret;
        })()));
        i._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = h.h;
            $ret.f = h.n;
            $ret.d = 1;
            $ret.b = h.c;
            return $ret;
        })()));
        i._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = h.j;
            return $ret;
        })()));
        i._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = h.d;
            $ret.f = h.m;
            $ret.d = 0;
            $ret.b = h.c;
            return $ret;
        })()));
        let j = new PathGeometry();
        j.c.add(i);
        return j;
    }
    o9(a, b, c, d, e, f, g, h, i) {
        let j = SliceCoords.a(a, b, c, d, e, f, g, h, i);
        if (j == null) {
            return this.pa(a, b, c, d, e, f, g);
        }
        let k = new PathFigure();
        k._startPoint = j.d;
        k._isClosed = true;
        let l = ((c + ((d - c) * 0.5)) * 180 / Math.PI) + 90;
        let m = new Size(1, j.l.width * (e / f), j.l.height * (e / f));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.e;
            $ret.f = m;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = j.f;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.g;
            $ret.f = j.l;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.h;
            $ret.f = j.n;
            $ret.d = 1;
            $ret.b = j.c;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.i;
            $ret.f = j.l;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new LineSegment(1);
            $ret.c = j.j;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.k;
            $ret.f = m;
            $ret.c = l;
            $ret.d = 1;
            $ret.b = false;
            return $ret;
        })()));
        k._segments.add(((() => {
            let $ret = new ArcSegment();
            $ret.e = j.d;
            $ret.f = j.m;
            $ret.d = 0;
            $ret.b = j.c;
            return $ret;
        })()));
        let n = new PathGeometry();
        n.c.add(k);
        return n;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case RadialPieSeries.$$p[0]:
            case RadialPieSeries.$$p[1]:
                this.jl(false);
                break;
        }
    }
}
RadialPieSeries.$t = markType(RadialPieSeries, 'RadialPieSeries', AnchoredRadialSeries.$);
RadialPieSeries.$$p = markDep(DependencyProperty, PropertyMetadata, RadialPieSeries, 'raisePropertyChanged', ['RadiusX:o3:o7', [1, 2], 'RadiusY:o4:o8', [1, 2]]);
/**
 * @hidden
 */
class RadialPieSeriesView extends AnchoredRadialSeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cx = null;
        this.cy = null;
        this.cw = a;
        this.cx = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.c3);
            $ret.activate = runOn(this, this.cz);
            $ret.disactivate = runOn(this, this.c1);
            $ret.destroy = runOn(this, this.c0);
            return $ret;
        })());
    }
    ap() {
        super.ap();
        this.cy = new List$1(Path.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    c3() {
        let a = ((() => {
            let $ret = new Path();
            $ret.dataContext = ((() => {
                let $ret = new DataContext();
                $ret.series = this.e;
                return $ret;
            })());
            return $ret;
        })());
        this.cy.add(a);
        a._visibility = 1;
        return a;
    }
    cz(a) {
        a._visibility = 0;
    }
    c1(a) {
        a._visibility = 1;
    }
    c0(a) {
        this.cy.remove(a);
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._stroke = this.e.lc;
        c.ac = this.e.ey;
        c._fill = this.e.lb;
        c.ai = this.e.ll;
        c.ad = this.e.lm;
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._stroke = d;
        c.ac = this.e.ey;
        c._fill = d;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.cy.count; c++) {
                let d = this.cy._inner[c];
                this.ba(d, c, b);
                a.s(d);
            }
        }
    }
    c2() {
        this.an();
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        for (let c of fromEnum(this.cx.a)) {
            this.e.a2.exportPathData(a, c, "slice" + b, ["Main", "Fill"]);
            b++;
        }
    }
}
RadialPieSeriesView.$t = markType(RadialPieSeriesView, 'RadialPieSeriesView', AnchoredRadialSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxRadialPieSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent radial pie series.
 * Compare values across categories by using radial pie slices.
*/
const IgxRadialPieSeriesComponent_PROVIDERS = [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent) }];
let IgxRadialPieSeriesComponent = IgxRadialPieSeriesComponent_1 = class IgxRadialPieSeriesComponent extends IgxAnchoredRadialSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new RadialPieSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX() {
        return this.i.o3;
    }
    set radiusX(v) {
        this.i.o3 = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.o4;
    }
    set radiusY(v) {
        this.i.o4 = +v;
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialPieSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxRadialPieSeriesComponent.prototype, "radiusY", null);
IgxRadialPieSeriesComponent = IgxRadialPieSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-radial-pie-series',
        template: ``,
        providers: [{ provide: IgxAnchoredRadialSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent_1) }, { provide: IgxRadialBaseComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxRadialPieSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxRadialPieSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialPieSeriesModule = class IgxRadialPieSeriesModule {
};
IgxRadialPieSeriesModule = __decorate([
    NgModule({
        declarations: [IgxRadialPieSeriesComponent],
        imports: [CommonModule],
        exports: [IgxRadialPieSeriesComponent],
        entryComponents: []
    })
], IgxRadialPieSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxRadialPieSeriesDynamicModule = class IgxRadialPieSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxRadialPieSeriesComponent", IgxRadialPieSeriesComponent);
        TypeRegistrar.register("RadialPieSeries", RadialPieSeries.$type);
    }
};
IgxRadialPieSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxRadialPieSeriesModule],
        exports: [IgxRadialPieSeriesModule],
        entryComponents: [IgxRadialPieSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxRadialPieSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartRadialModule = class IgxDataChartRadialModule {
};
IgxDataChartRadialModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxRadialAreaSeriesModule,
            IgxRadialColumnSeriesModule,
            IgxRadialLineSeriesModule,
            IgxRadialPieSeriesModule,
            IgxDataChartRadialCoreModule
        ],
        imports: [CommonModule, IgxRadialAreaSeriesModule,
            IgxRadialColumnSeriesModule,
            IgxRadialLineSeriesModule,
            IgxRadialPieSeriesModule,
            IgxDataChartRadialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartRadialModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartRadialDynamicModule = class IgxDataChartRadialDynamicModule {
};
IgxDataChartRadialDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxRadialAreaSeriesDynamicModule,
            IgxRadialColumnSeriesDynamicModule,
            IgxRadialLineSeriesDynamicModule,
            IgxRadialPieSeriesDynamicModule,
            IgxDataChartRadialCoreDynamicModule,
            IgxDataChartRadialModule
        ],
        imports: [CommonModule, IgxRadialAreaSeriesDynamicModule,
            IgxRadialColumnSeriesDynamicModule,
            IgxRadialLineSeriesDynamicModule,
            IgxRadialPieSeriesDynamicModule,
            IgxDataChartRadialCoreDynamicModule,
            IgxDataChartRadialModule
        ],
        entryComponents: []
    })
], IgxDataChartRadialDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalLogarithmicScaler extends LogarithmicScaler {
    q(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.ag(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ag(a, b.e, b.d, b.a);
    }
    p(a, b) {
        if (!b.c.isEmpty) {
            let c = this.af(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.af(a, b.e, b.d, b.a);
    }
    ag(a, b, c, d) {
        let e = b.left + b.width * (a - c.left) / c.width;
        if (d) {
            e = 1 - e;
        }
        return Math.exp(e * (this.ad - this.ae) + this.ae);
    }
    af(a, b, c, d) {
        if (isNaN_(a)) {
            return NaN;
        }
        let e = 0;
        if (a <= 0) {
            e = (Math.log(this.o) - this.ae) / (this.ad - this.ae);
        }
        else {
            e = (Math.log(a) - this.ae) / (this.ad - this.ae);
        }
        if (d) {
            e = 1 - e;
        }
        return c.left + c.width * (e - b.left) / b.width;
    }
}
HorizontalLogarithmicScaler.$t = markType(HorizontalLogarithmicScaler, 'HorizontalLogarithmicScaler', LogarithmicScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalLinearScaler extends LinearScaler {
    q(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.left + b.e.width * (a - b.d.left) / b.d.width;
            c = (c * b.d.width) + b.d.left;
            c = this.ae(c, NumericScaler.ac, b.c, b.a);
            return c;
        }
        return this.ae(a, b.e, b.d, b.a);
    }
    p(a, b) {
        if (!b.c.isEmpty) {
            let c = this.ad(a, NumericScaler.ac, b.c, b.a);
            c = (c - b.d.left) / b.d.width;
            c = b.d.left + b.d.width * (c - b.e.left) / b.e.width;
            return c;
        }
        return this.ad(a, b.e, b.d, b.a);
    }
    v(a, b, c, d) {
        let e;
        let f = d.e;
        let g = d.d;
        let h = d.c;
        let i = d.a;
        let j = !h.isEmpty;
        let k = this.m;
        let l = this.o;
        let m = h.left;
        let n = h.width;
        let o = f.left;
        let p = f.width;
        let q = g.left;
        let r = g.width;
        let s = 0;
        let t = 1;
        let u = ArrayAccessHelper.b(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        for (let w = b; w < c; w++) {
            if (v) {
                e = u[w];
            }
            else {
                e = a.item(w);
            }
            if (j) {
                let x = (e - l) / (k);
                if (i) {
                    x = 1 - x;
                }
                x = m + n * (x - s) / t;
                let y = (x - (o * r)) / p;
                if (v) {
                    u[w] = y;
                }
                else {
                    a.item(w, y);
                }
            }
            else {
                let z = (e - l) / (k);
                if (i) {
                    z = 1 - z;
                }
                z = q + r * (z - o) / p;
                if (v) {
                    u[w] = z;
                }
                else {
                    a.item(w, z);
                }
            }
        }
    }
    ae(a, b, c, d) {
        let e = b.left + b.width * (a - c.left) / c.width;
        if (d) {
            e = 1 - e;
        }
        return this.o + e * (this.m);
    }
    ad(a, b, c, d) {
        let e = (a - this.o) / (this.m);
        if (d) {
            e = 1 - e;
        }
        return c.left + c.width * (e - b.left) / b.width;
    }
}
HorizontalLinearScaler.$t = markType(HorizontalLinearScaler, 'HorizontalLinearScaler', LinearScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FastHorizontalLinearScaler extends HorizontalLinearScaler {
    u(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.m;
        let m = this.o;
        let n = i.left;
        let o = i.width;
        let p = g.left;
        let q = g.width;
        let r = h.left;
        let s = h.width;
        let t = 0;
        let u = 1;
        let v = ArrayAccessHelper.a(a);
        let w = false;
        if (v != null) {
            w = true;
        }
        let x;
        for (let y = 0; y < b.count; y++) {
            x = b.item(y);
            for (let z = c; z < d; z++) {
                if (w) {
                    f = v[z];
                }
                else {
                    f = a.item(z);
                }
                if (k) {
                    let aa = (f[x] - m) / (l);
                    if (j) {
                        aa = 1 - aa;
                    }
                    aa = n + o * (aa - t) / u;
                    let ab = (aa - (p * s)) / q;
                    f[x] = ab;
                }
                else {
                    let ac = (f[x] - m) / (l);
                    if (j) {
                        ac = 1 - ac;
                    }
                    ac = r + s * (ac - p) / q;
                    f[x] = ac;
                }
            }
        }
    }
}
FastHorizontalLinearScaler.$t = markType(FastHorizontalLinearScaler, 'FastHorizontalLinearScaler', HorizontalLinearScaler.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumericXAxis extends StraightNumericAxisBase {
    constructor() {
        super();
        this.ab = NumericXAxis.$;
        this.jn = this.jl();
    }
    a3() {
        return new NumericXAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.l3 = a;
    }
    au() {
        if (this.cr) {
            return (TypeRegistrar.create('HorizontalSmartAxisLabelPanel'));
        }
        else {
            return new HorizontalAxisLabelPanel();
        }
    }
    jl() {
        let a = super.jl();
        a.b.c = (b) => {
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                this.av.a9 = b;
                if (this.ay != null && (this.ay.location == 4 || this.ay.location == 5)) {
                    this.bh.it();
                }
            }
        };
        a.k = (b, c, d) => this.hl(c, d, b.z, b.b, false);
        a.l = (b, c, d, e) => this.hm(c, d, e, b.z);
        a.m = (b, c) => {
            let d = b.y;
            let e = new ScalerParams(0, b.aa, b.z, this.cb, d);
            return this.dy(c, e);
        };
        a.q = (b, c) => true;
        a.j = (b) => this.gv(b.t, b.n, b.z, b.a, true);
        a.e = (b) => {
            b.n = b.z.bottom;
            if (this.ai != null && this.ai.bh != null) {
                let c = b.n;
                let d = b.r;
                let e = this.hg(c, d, b.aa, b.z, b.y, b.z.top, b.z.bottom);
                c = e.p0;
                d = e.p1;
                b.n = c;
                b.r = d;
            }
        };
        a.p = (b, c, d) => {
            let e = Math.round(c);
            return e >= Math.floor(b.z.left) && e <= Math.ceil(b.z.right);
        };
        return a;
    }
    dy(a, b) {
        if (this.lm != null) {
            return this.lm.p(a, b);
        }
        return this.ll.p(a, b);
    }
    d1(a, b) {
        if (this.lm != null) {
            return this.lm.q(a, b);
        }
        return this.ll.q(a, b);
    }
    gs(a, b, c, d) {
        if (this.lm != null) {
            this.lm.v(a, b, c, d);
            return;
        }
        this.ll.v(a, b, c, d);
    }
    gr(a, b, c, d, e) {
        if (this.lm != null) {
            this.lm.u(a, b, c, d, e);
            return;
        }
        this.ll.u(a, b, c, d, e);
    }
    gt(a, b, c, d) {
        if (this.lm != null) {
            this.lm.j(a, b, c, d);
            return;
        }
        this.ll.j(a, b, c, d);
    }
    l4(a, b) {
        if (this.bh == null || a == NaN || b == NaN) {
            return;
        }
        let c = this.lr(a, this);
        let d = this.lr(b, this);
        if (c == NaN || d == NaN) {
            return;
        }
        this.bh.oi = new Rect(0, c, this.bh.oi.y, d - c, this.bh.oi.height);
    }
    jo(a, b, c, d) {
        let e = d;
        let f = super.jo(a, b, c, d);
        let g = new ScalerParams(0, b, a, this.ca, c);
        let h = NaN;
        let i = NaN;
        if (!this.ca && b.right == 1) {
            i = this.kb;
        }
        else if (this.ca && b.left == 0) {
            h = this.kb;
        }
        if (isNaN_(h)) {
            h = this.d1(e.left, g);
        }
        if (isNaN_(i)) {
            i = this.d1(e.right, g);
        }
        let j = Math.min(h, i);
        let k = Math.max(h, i);
        this.kf = j;
        this.ke = k;
        f.k.add(((() => {
            let $ret = new RangeInfo();
            $ret.d = j;
            $ret.c = k;
            $ret.b = e.width;
            return $ret;
        })()));
        return f;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = !b.isEmpty ? this.i9 : Rect.empty;
        let d = this.i4();
        let e = this.i3();
        let f = this.jn.c(a, c, b, d, e);
        if (f != null) {
            this.ka = f.f.m;
            this.kd = f.f.l;
        }
    }
    hn(a, b) {
        super.hn(a, b);
        if (b.height != a.height) {
            this.cn();
        }
    }
    get_a1() {
        return 0;
    }
    get a1() {
        return this.get_a1();
    }
    jq() {
        if (this.j1) {
            return new HorizontalLogarithmicScaler();
        }
        switch (this.lk) {
            case 0: return new FastHorizontalLinearScaler();
            case 1: return new HorizontalLogarithmicScaler();
        }
        return null;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
NumericXAxis.$t = markType(NumericXAxis, 'NumericXAxis', StraightNumericAxisBase.$, [IScaler_$type]);
/**
 * @hidden
 */
class NumericXAxisView extends StraightNumericAxisBaseView {
    constructor(a) {
        super(a);
        this.bi = null;
        this.bi = a;
    }
}
NumericXAxisView.$t = markType(NumericXAxisView, 'NumericXAxisView', StraightNumericAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxNumericXAxisComponent_1;
/**
 * Represents a IgxDataChartComponent numeric X axis.
*
* The `IgxNumericXAxisComponent` treats the data as continuously varying numerical data items. Labels on this axis are placed along the X-axis. The location of labels varies according to the value in a data column that is mapped using the `XMemberPath` property of Scatter Series or `ValueMemberPath` property of Bar Series.
*
* ```html
* <igx-data-chart
*     [dataSource]="data" >
*     <igx-numeric-x-axis
* 		label="label"
* 		#xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
* 		crossingAxis= "xAxis"
* 		crossingValue= 700
* 		#yAxis>
*     </igx-numeric-y-axis>
* </igx-data-chart>
* ```
*/
const IgxNumericXAxisComponent_PROVIDERS = [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent) }];
let IgxNumericXAxisComponent = IgxNumericXAxisComponent_1 = class IgxNumericXAxisComponent extends IgxStraightNumericAxisBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new NumericXAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.l4(minimum, maximum);
    }
};
IgxNumericXAxisComponent = IgxNumericXAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-numeric-x-axis',
        template: ``,
        providers: [{ provide: IgxStraightNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent_1) }, { provide: IgxNumericAxisBaseComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxNumericXAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxNumericXAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericXAxisModule = class IgxNumericXAxisModule {
};
IgxNumericXAxisModule = __decorate([
    NgModule({
        declarations: [IgxNumericXAxisComponent],
        imports: [CommonModule],
        exports: [IgxNumericXAxisComponent],
        entryComponents: []
    })
], IgxNumericXAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxNumericXAxisDynamicModule = class IgxNumericXAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxNumericXAxisComponent", IgxNumericXAxisComponent);
        TypeRegistrar.register("NumericXAxis", NumericXAxis.$type);
    }
};
IgxNumericXAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxNumericXAxisModule],
        exports: [IgxNumericXAxisModule],
        entryComponents: [IgxNumericXAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxNumericXAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartScatterCoreModule = class IgxDataChartScatterCoreModule {
};
IgxDataChartScatterCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartScatterCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartScatterCoreDynamicModule = class IgxDataChartScatterCoreDynamicModule {
};
IgxDataChartScatterCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartScatterCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartScatterCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartScatterCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsSizeScale_$type = new Type(null, 'ISupportsSizeScale');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SizeScale extends DependencyObject {
    constructor() {
        super();
        this._globalMinimum = 0;
        this._globalMaximum = 0;
        this.l = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.globalMinimum = NaN;
        this.globalMaximum = NaN;
        this.l = new List$1(Series.$, 0);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.y(a, b.propertyName, b.oldValue, b.newValue));
    }
    get globalMinimum() {
        return this._globalMinimum;
    }
    set globalMinimum(a) {
        this._globalMinimum = a;
    }
    get globalMaximum() {
        return this._globalMaximum;
    }
    set globalMaximum(a) {
        this._globalMaximum = a;
    }
    getCurrentGlobalMinimum() {
        return this.globalMinimum;
    }
    getCurrentGlobalMaximum() {
        return this.globalMaximum;
    }
    x() {
        if (isNaN_(this.globalMinimum) || isNaN_(this.globalMaximum)) {
            for (let a of fromEnum(this.l)) {
                if (typeCast(ISupportsSizeScale_$type, a) !== null) {
                    a.updateSizeScaleGlobals();
                }
            }
        }
    }
    ab(a, b) {
        if (!isNaN_(a) && !isInfinity(a)) {
            if (isNaN_(this.globalMinimum)) {
                this.globalMinimum = a;
            }
            else {
                this.globalMinimum = MathUtil.h(a, this.globalMinimum);
            }
        }
        if (!isNaN_(b) && !isInfinity(b)) {
            if (isNaN_(this.globalMaximum)) {
                this.globalMaximum = b;
            }
            else {
                this.globalMaximum = MathUtil.f(b, this.globalMaximum);
            }
        }
    }
    aa() {
        this.globalMinimum = NaN;
        this.globalMaximum = NaN;
    }
    z(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    y(a, b, c, d) {
        for (let e of fromEnum(this.l)) {
            e.jl(false);
            if (e.bs != null) {
                e.it();
                e.is();
            }
        }
    }
}
SizeScale.$t = markType(SizeScale, 'SizeScale', DependencyObject.$, [INotifyPropertyChanged_$type]);
SizeScale.$$p = markDep(DependencyProperty, PropertyMetadata, SizeScale, 'z', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);

/**
 * Represents a scale that is used determine an object's size.
*/
const IgxSizeScaleComponent_PROVIDERS = [];
let IgxSizeScaleComponent = class IgxSizeScaleComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._propertyUpdated = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new SizeScale();
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets or sets global minimum value that will be mapped to MinumumValue of this scale
    */
    get globalMinimum() {
        return this.i.globalMinimum;
    }
    set globalMinimum(v) {
        this.i.globalMinimum = +v;
    }
    /**
     * Gets or sets global maximum value that will be mapped to MaxumumValue of this scale
    */
    get globalMaximum() {
        return this.i.globalMaximum;
    }
    set globalMaximum(v) {
        this.i.globalMaximum = +v;
    }
    /**
     * Gets or sets the minimum size (in pixels) for this scale.
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = +v;
    }
    /**
     * Gets or sets the maximum size (in pixels) for this scale.
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = +v;
    }
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    get isLogarithmic() {
        return this.i.isLogarithmic;
    }
    set isLogarithmic(v) {
        this.i.isLogarithmic = ensureBool(v);
    }
    /**
     * Gets or sets the logarithm base for this scale.
    */
    get logarithmBase() {
        return this.i.logarithmBase;
    }
    set logarithmBase(v) {
        this.i.logarithmBase = +v;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SizeScaleComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    getCurrentGlobalMinimum() {
        let iv = this.i.getCurrentGlobalMinimum();
        return (iv);
    }
    getCurrentGlobalMaximum() {
        let iv = this.i.getCurrentGlobalMaximum();
        return (iv);
    }
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    get propertyUpdated() {
        if (this._propertyUpdated == null) {
            this._propertyUpdated = new EventEmitter();
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPropertyUpdatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePropertyUpdated) {
                        this.beforePropertyUpdated(this, outerArgs);
                    }
                    this._propertyUpdated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._propertyUpdated;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSizeScaleComponent.prototype, "globalMinimum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSizeScaleComponent.prototype, "globalMaximum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSizeScaleComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSizeScaleComponent.prototype, "maximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSizeScaleComponent.prototype, "isLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSizeScaleComponent.prototype, "logarithmBase", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxSizeScaleComponent.prototype, "propertyUpdated", null);
IgxSizeScaleComponent = __decorate([
    Component({
        selector: 'igx-size-scale',
        template: ``,
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSizeScaleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSizeScaleModule = class IgxSizeScaleModule {
};
IgxSizeScaleModule = __decorate([
    NgModule({
        declarations: [IgxSizeScaleComponent],
        imports: [CommonModule],
        exports: [IgxSizeScaleComponent],
        entryComponents: []
    })
], IgxSizeScaleModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSizeScaleDynamicModule = class IgxSizeScaleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSizeScaleComponent", IgxSizeScaleComponent);
        TypeRegistrar.register("SizeScale", SizeScale.$type);
    }
};
IgxSizeScaleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSizeScaleModule],
        exports: [IgxSizeScaleModule],
        entryComponents: [IgxSizeScaleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSizeScaleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISupportsFillScale_$type = new Type(null, 'ISupportsFillScale');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BrushScale extends DependencyObject {
    constructor() {
        super();
        this.j = null;
        this.o = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.q = 0;
        this.p = 0;
        this.o = new List$1(Series.$, 0);
        this.brushes = new BrushCollection();
        let a = this.brushes;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.r));
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (b, c) => this.t(b, c.propertyName, c.oldValue, c.newValue));
    }
    r(a, b) {
        for (let c of fromEnum(this.o)) {
            c.jl(false);
            c.im();
            c.it();
        }
    }
    s() {
        if (isNaN_(this.q) || isNaN_(this.p)) {
            for (let a of fromEnum(this.o)) {
                if (typeCast(ISupportsFillScale_$type, a) !== null) {
                    a.updateFillScaleGlobals();
                }
            }
        }
    }
    get brushes() {
        return this.j;
    }
    set brushes(a) {
        let b = this.j;
        if (this.j != null) {
            let c = this.j;
            c.collectionChanged = delegateRemove(c.collectionChanged, runOn(this, this.r));
        }
        this.j = a;
        if (this.j != null) {
            let d = this.j;
            d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.r));
        }
        for (let e of fromEnum(this.o)) {
            e.jl(false);
            e.im();
            e.it();
        }
    }
    registerSeries(a) {
        let b = this.o.contains(a);
        if (!b) {
            this.o.add(a);
        }
    }
    unregisterSeries(a) {
        let b = this.o.contains(a);
        if (b) {
            this.o.remove(a);
        }
    }
    getBrush(a) {
        if (this.brushes == null || a < 0 || a >= this.brushes.count) {
            return null;
        }
        return this.brushes.item(a);
    }
    get_isReady() {
        return true;
    }
    get isReady() {
        return this.get_isReady();
    }
    aa(a) {
        if (this.brushes == null || this.brushes.count == 0 || a < 0) {
            return null;
        }
        return BrushCollectionUtil.b(this.brushes, a);
    }
    u(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    t(a, b, c, d) {
        for (let e of fromEnum(this.o)) {
            e.jl(false);
            e.im();
            e.it();
        }
    }
    y(a, b) {
        if (!isNaN_(a) && !isInfinity(a)) {
            if (isNaN_(this.q)) {
                this.q = a;
            }
            else {
                this.q = MathUtil.h(a, this.q);
            }
        }
        if (!isNaN_(b) && !isInfinity(b)) {
            if (isNaN_(this.p)) {
                this.p = b;
            }
            else {
                this.p = MathUtil.f(b, this.p);
            }
        }
    }
    w() {
        this.q = NaN;
        this.p = NaN;
    }
    get_isBrushScale() {
        return true;
    }
    get isBrushScale() {
        return this.get_isBrushScale();
    }
}
BrushScale.$t = markType(BrushScale, 'BrushScale', DependencyObject.$, [INotifyPropertyChanged_$type]);

/**
 * Represents a base class for brush scales.
*/
const IgxBrushScaleComponent_PROVIDERS = [];
let IgxBrushScaleComponent = class IgxBrushScaleComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._propertyUpdated = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new BrushScale();
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets the brushes collection used by this scale.
    */
    get brushes() {
        return fromBrushCollection(this.i.brushes);
    }
    set brushes(v) {
        this.i.brushes = toBrushCollection(v);
    }
    /**
     * Gets the status of the scale
    */
    get isReady() {
        return this.i.isReady;
    }
    /**
     * Checks if this item is a BrushScale
    */
    get isBrushScale() {
        return this.i.isBrushScale;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("BrushScaleComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
     * Registers a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to register with the scale.
    */
    registerSeries(series) {
        this.i.registerSeries((series == null ? null : series.i));
    }
    /**
     * Unregisters a series with the scale. Under normal circumstances you should not need to call this manually.
    
    * @param series  * The series to unregister from the scale.
    */
    unregisterSeries(series) {
        this.i.unregisterSeries((series == null ? null : series.i));
    }
    /**
     * Gets a brush from the brushes collection by index.
    
    */
    getBrush(index) {
        let iv = this.i.getBrush(index);
        return brushToString(iv);
    }
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    get propertyUpdated() {
        if (this._propertyUpdated == null) {
            this._propertyUpdated = new EventEmitter();
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPropertyUpdatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePropertyUpdated) {
                        this.beforePropertyUpdated(this, outerArgs);
                    }
                    this._propertyUpdated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._propertyUpdated;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxBrushScaleComponent.prototype, "brushes", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxBrushScaleComponent.prototype, "propertyUpdated", null);
IgxBrushScaleComponent = __decorate([
    Component({
        selector: 'igx-brush-scale',
        template: ``,
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBrushScaleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ValueBrushScale extends BrushScale {
    constructor() {
        super();
        this.ab = false;
        this.af = 10;
    }
    getBrushByIndex(a, b) {
        if (b == null || this.brushes == null || this.brushes.count == 0 || a < 0 || a >= b.count) {
            return null;
        }
        if (b.count == 0) {
            return this.brushes.item(0);
        }
        let c = isNaN_(this.minimumValue) || isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
        let d = isNaN_(this.maximumValue) || isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
        let e = b.item(a);
        if (c == d) {
            return e == c ? this.brushes.item(0) : null;
        }
        return this.at(c, d, e);
    }
    getBrushByValue(a, b) {
        if (b == null || this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (b.count <= 1) {
            return this.brushes.item(0);
        }
        let c = isNaN_(this.minimumValue) || isInfinity(this.minimumValue) ? b.minimum : this.minimumValue;
        let d = isNaN_(this.maximumValue) || isInfinity(this.maximumValue) ? b.maximum : this.maximumValue;
        if (a < c) {
            return null;
        }
        if (a > d) {
            return null;
        }
        return this.at(c, d, a);
    }
    getBrushByRange(a, b, c) {
        if (this.brushes == null || this.brushes.count == 0 || isNaN_(a)) {
            return null;
        }
        if (this.brushes.count == 1) {
            return this.brushes.item(0);
        }
        let d = isNaN_(this.minimumValue) || isInfinity(this.minimumValue) ? b : this.minimumValue;
        let e = isNaN_(this.maximumValue) || isInfinity(this.maximumValue) ? c : this.maximumValue;
        if (isNaN_(d) || a < d) {
            return null;
        }
        if (isNaN_(e) || a > e) {
            return null;
        }
        return this.at(d, e, a);
    }
    at(a, b, c) {
        if (this.ab && this.af > 0) {
            let d = logBase(a, this.af);
            let e = logBase(b, this.af);
            let f = logBase(c, this.af);
            return this.as(d, e, f);
        }
        return this.as(a, b, c);
    }
    as(a, b, c) {
        if (c < a || c > b) {
            return null;
        }
        let d = (c - a) / (b - a);
        let e = d * (this.brushes.count - 1);
        return this.aa(e);
    }
    get_isReady() {
        return this.brushes != null && this.brushes.count > 0;
    }
    t(a, b, c, d) {
        switch (b) {
            case ValueBrushScale.$$p[1]:
                this.af = typeGetValue(d);
                break;
            case ValueBrushScale.$$p[0]:
                this.ab = d;
                break;
        }
        super.t(a, b, c, d);
    }
}
ValueBrushScale.$t = markType(ValueBrushScale, 'ValueBrushScale', BrushScale.$);
ValueBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, ValueBrushScale, 'u', ['IsLogarithmic', [0, false], 'LogarithmBase', [1, 10], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);

var IgxValueBrushScaleComponent_1;
/**
 * Represents a brush scale that uses value-based brush selection.
*/
const IgxValueBrushScaleComponent_PROVIDERS = [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(() => IgxValueBrushScaleComponent) }];
let IgxValueBrushScaleComponent = IgxValueBrushScaleComponent_1 = class IgxValueBrushScaleComponent extends IgxBrushScaleComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ValueBrushScale();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the minimum value for this scale.
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = +v;
    }
    /**
     * Gets or sets the maximum value for this scale.
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = +v;
    }
    /**
     * Gets or sets whether the scale is logarithmic.
    */
    get isLogarithmic() {
        return this.i.isLogarithmic;
    }
    set isLogarithmic(v) {
        this.i.isLogarithmic = ensureBool(v);
    }
    /**
     * Gets or sets the logarithm base for this scale.
    */
    get logarithmBase() {
        return this.i.logarithmBase;
    }
    set logarithmBase(v) {
        this.i.logarithmBase = +v;
    }
    /**
     * Checks if the value brush scale is ready for usage in the chart
    */
    get isReady() {
        return this.i.isReady;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueBrushScaleComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueBrushScaleComponent.prototype, "maximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxValueBrushScaleComponent.prototype, "isLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxValueBrushScaleComponent.prototype, "logarithmBase", null);
IgxValueBrushScaleComponent = IgxValueBrushScaleComponent_1 = __decorate([
    Component({
        selector: 'igx-value-brush-scale',
        template: ``,
        providers: [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(() => IgxValueBrushScaleComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxValueBrushScaleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxValueBrushScaleModule = class IgxValueBrushScaleModule {
};
IgxValueBrushScaleModule = __decorate([
    NgModule({
        declarations: [IgxValueBrushScaleComponent],
        imports: [CommonModule],
        exports: [IgxValueBrushScaleComponent],
        entryComponents: []
    })
], IgxValueBrushScaleModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxValueBrushScaleDynamicModule = class IgxValueBrushScaleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxValueBrushScaleComponent", IgxValueBrushScaleComponent);
        TypeRegistrar.register("ValueBrushScale", ValueBrushScale.$type);
    }
};
IgxValueBrushScaleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxValueBrushScaleModule],
        exports: [IgxValueBrushScaleModule],
        entryComponents: [IgxValueBrushScaleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxValueBrushScaleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available modes of interpolation on a color scale.
 */
var ColorScaleInterpolationMode;
(function (ColorScaleInterpolationMode) {
    /**
     * Select one of the colors in the palette.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["Select"] = 0] = "Select";
    /**
     * Interpolate between colors in the palette using RGB interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateRGB"] = 1] = "InterpolateRGB";
    /**
     * Interpolate between colors in the palette using HSV interpolation.
     */
    ColorScaleInterpolationMode[ColorScaleInterpolationMode["InterpolateHSV"] = 2] = "InterpolateHSV";
})(ColorScaleInterpolationMode || (ColorScaleInterpolationMode = {}));
/**
 * @hidden
 */
let ColorScaleInterpolationMode_$type = markEnum('ColorScaleInterpolationMode', 'Select,0|InterpolateRGB,1|InterpolateHSV,2');

/**
 * Base class for classes which provide colors corresponding to numeric values within a known list of numeric values.
*/
const IgxColorScaleComponent_PROVIDERS = [];
class IgxColorScaleComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._propertyUpdated = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ColorScaleComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    get propertyUpdated() {
        if (this._propertyUpdated == null) {
            this._propertyUpdated = new EventEmitter();
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPropertyUpdatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePropertyUpdated) {
                        this.beforePropertyUpdated(this, outerArgs);
                    }
                    this._propertyUpdated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._propertyUpdated;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxColorScaleComponent.prototype, "propertyUpdated", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ColorScale extends DependencyObject {
    constructor() {
        super(...arguments);
        this.propertyChanged = null;
        this.propertyUpdated = null;
    }
    l(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    k(a, b, c, d) {
    }
}
ColorScale.$t = markType(ColorScale, 'ColorScale', DependencyObject.$, [INotifyPropertyChanged_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomPaletteColorScale extends ColorScale {
    constructor() {
        super();
        this.p = null;
        this.ag = new Color();
        this.u = NaN;
        this.t = NaN;
        this.s = true;
        this.r = true;
        this.n = 0;
        this.ag = Color.u(0, 0, 0, 0);
        this.p = new ObservableColorCollection();
        let a = this.p;
        a.collectionChanged = delegateCombine(a.collectionChanged, runOn(this, this.ab));
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (b, c) => this.k(b, c.propertyName, c.oldValue, c.newValue));
    }
    get palette() {
        return this.p;
    }
    set palette(a) {
        let b = this.p;
        if (this.p != null) {
            let c = this.p;
            c.collectionChanged = delegateRemove(c.collectionChanged, runOn(this, this.ab));
        }
        this.p = a;
        if (this.p != null) {
            let d = this.p;
            d.collectionChanged = delegateCombine(d.collectionChanged, runOn(this, this.ab));
        }
        this.l("Palette", b, this.palette);
    }
    ab(a, b) {
        this.l("Palette", this.palette, this.palette);
    }
    k(a, b, c, d) {
        super.k(a, b, c, d);
        switch (b) {
            case CustomPaletteColorScale.$$p[2]:
                this.u = this.minimumValue;
                this.s = isNaN_(this.u);
                break;
            case CustomPaletteColorScale.$$p[1]:
                this.t = this.maximumValue;
                this.r = isNaN_(this.t);
                break;
            case CustomPaletteColorScale.$$p[0]:
                this.n = this.interpolationMode;
                break;
        }
    }
    getColor(a, b, c, d) {
        if (((this.p == null) || (this.p.count == 0)) || d == null) {
            return this.ag;
        }
        let e = this.s ? b : this.u;
        let f = this.r ? c : this.t;
        let g = (a - e) / (f - e);
        if (isNaN_(g) || g < 0 || g > 1) {
            return this.ag;
        }
        let h = g * (this.p.count - 1);
        if (this.n == 2 || this.n == 1) {
            let i = Math.floor(h);
            let j = Math.ceil(h);
            let k = this.p._inner[truncate(i)];
            let l = this.p._inner[truncate(j)];
            let m = h - i;
            let n = this.n == 2 ? 1 : 0;
            return ColorUtil.n(k, m, l, n);
        }
        else {
            let o = truncate(Math.round(h));
            return this.p._inner[o];
        }
    }
    providePalette(a) {
        let b = new ObservableColorCollection();
        for (let d = 0; d < a.length; d++) {
            let c = a[d];
            let e = ((() => {
                let $ret = new Color();
                $ret.colorString = c;
                return $ret;
            })());
            b.add(e);
        }
        this.palette = b;
    }
}
CustomPaletteColorScale.$t = markType(CustomPaletteColorScale, 'CustomPaletteColorScale', ColorScale.$);
CustomPaletteColorScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteColorScale, 'l', ['InterpolationMode', [ColorScaleInterpolationMode_$type, enumGetBox(ColorScaleInterpolationMode_$type, 0)], 'MaximumValue', [1, NaN], 'MinimumValue', [1, NaN]]);

var IgxCustomPaletteColorScaleComponent_1;
/**
 * ColorScale class for selecting a color from a given palette, or interpolating between adjacent colors in that palette.
*/
const IgxCustomPaletteColorScaleComponent_PROVIDERS = [{ provide: IgxColorScaleComponent, useExisting: forwardRef(() => IgxCustomPaletteColorScaleComponent) }];
let IgxCustomPaletteColorScaleComponent = IgxCustomPaletteColorScaleComponent_1 = class IgxCustomPaletteColorScaleComponent extends IgxColorScaleComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CustomPaletteColorScale();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The lowest value to assign a color.  Any given value less than this value will be made Transparent.
    */
    get minimumValue() {
        return this.i.minimumValue;
    }
    set minimumValue(v) {
        this.i.minimumValue = +v;
    }
    /**
     * The highest value to assign a color.  Any given value greater than this value will be made Transparent.
    */
    get maximumValue() {
        return this.i.maximumValue;
    }
    set maximumValue(v) {
        this.i.maximumValue = +v;
    }
    /**
     * A list of colors to select from or interpolate between.
    */
    get palette() {
        return fromColorCollection(this.i.palette);
    }
    set palette(v) {
        this.i.palette = toColorCollection(v);
    }
    /**
     * The approach to use when getting a color from the palette.
    */
    get interpolationMode() {
        return this.i.interpolationMode;
    }
    set interpolationMode(v) {
        this.i.interpolationMode = ensureEnum(ColorScaleInterpolationMode_$type, v);
    }
    providePalette(colors) {
        this.i.providePalette(colors);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCustomPaletteColorScaleComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCustomPaletteColorScaleComponent.prototype, "maximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxCustomPaletteColorScaleComponent.prototype, "palette", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCustomPaletteColorScaleComponent.prototype, "interpolationMode", null);
IgxCustomPaletteColorScaleComponent = IgxCustomPaletteColorScaleComponent_1 = __decorate([
    Component({
        selector: 'igx-custom-palette-color-scale',
        template: ``,
        providers: [{ provide: IgxColorScaleComponent, useExisting: forwardRef(() => IgxCustomPaletteColorScaleComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCustomPaletteColorScaleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomPaletteColorScaleModule = class IgxCustomPaletteColorScaleModule {
};
IgxCustomPaletteColorScaleModule = __decorate([
    NgModule({
        declarations: [IgxCustomPaletteColorScaleComponent],
        imports: [CommonModule],
        exports: [IgxCustomPaletteColorScaleComponent],
        entryComponents: []
    })
], IgxCustomPaletteColorScaleModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomPaletteColorScaleDynamicModule = class IgxCustomPaletteColorScaleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCustomPaletteColorScaleComponent", IgxCustomPaletteColorScaleComponent);
        TypeRegistrar.register("CustomPaletteColorScale", CustomPaletteColorScale.$type);
    }
};
IgxCustomPaletteColorScaleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCustomPaletteColorScaleModule],
        exports: [IgxCustomPaletteColorScaleModule],
        entryComponents: [IgxCustomPaletteColorScaleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCustomPaletteColorScaleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBrushScaleModule = class IgxBrushScaleModule {
};
IgxBrushScaleModule = __decorate([
    NgModule({
        declarations: [IgxBrushScaleComponent],
        imports: [CommonModule],
        exports: [IgxBrushScaleComponent],
        entryComponents: []
    })
], IgxBrushScaleModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors of selecting a brush from a brush collection.
 */
var BrushSelectionMode;
(function (BrushSelectionMode) {
    /**
     * alternates between brushes sequentially.
     */
    BrushSelectionMode[BrushSelectionMode["Select"] = 0] = "Select";
    /**
     * Uses index-based interpolation.
     */
    BrushSelectionMode[BrushSelectionMode["Interpolate"] = 1] = "Interpolate";
})(BrushSelectionMode || (BrushSelectionMode = {}));
/**
 * @hidden
 */
let BrushSelectionMode_$type = markEnum('BrushSelectionMode', 'Select,0|Interpolate,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterAxisInfoCache extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.d = false;
        this.e = false;
        this.c = null;
    }
}
ScatterAxisInfoCache.$t = markType(ScatterAxisInfoCache, 'ScatterAxisInfoCache');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available methods of collision avoidance of series' markers.
 */
var CollisionAvoidanceType;
(function (CollisionAvoidanceType) {
    /**
     * Collision avoidance is disabled.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["None"] = 0] = "None";
    /**
     * Items colliding with other items will be hidden from view.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["Omit"] = 1] = "Omit";
    /**
     * Items colliding with other items will be partially hidden from view by reducing their opacity.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["Fade"] = 2] = "Fade";
    /**
     * Items colliding with other items will be either hidden from view or moved to new positions.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["OmitAndShift"] = 3] = "OmitAndShift";
    /**
     * Items colliding with other items will be either partially hidden from view by reducing their opacity, or moved to new positions, or a combination of both.
     */
    CollisionAvoidanceType[CollisionAvoidanceType["FadeAndShift"] = 4] = "FadeAndShift";
})(CollisionAvoidanceType || (CollisionAvoidanceType = {}));
/**
 * @hidden
 */
let CollisionAvoidanceType_$type = markEnum('CollisionAvoidanceType', 'None,0|Omit,1|Fade,2|OmitAndShift,3|FadeAndShift,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ErrorBarSettingsBase extends DependencyObject {
    constructor() {
        super();
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.n = new Style();
    }
    l(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
}
ErrorBarSettingsBase.$t = markType(ErrorBarSettingsBase, 'ErrorBarSettingsBase', DependencyObject.$, [INotifyPropertyChanged_$type]);
ErrorBarSettingsBase.$$p = markDep(DependencyProperty, PropertyMetadata, ErrorBarSettingsBase, 'l', ['DefaultErrorBarStyle:n:m', [Style.$, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available types for enabling error bars
 */
var EnableErrorBars;
(function (EnableErrorBars) {
    /**
     * No error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["None"] = 0] = "None";
    /**
     * Both error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Both"] = 1] = "Both";
    /**
     * Positive error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Positive"] = 2] = "Positive";
    /**
     * Negative error bars are enabled
     */
    EnableErrorBars[EnableErrorBars["Negative"] = 3] = "Negative";
})(EnableErrorBars || (EnableErrorBars = {}));
/**
 * @hidden
 */
let EnableErrorBars_$type = markEnum('EnableErrorBars', 'None,0|Both,1|Positive,2|Negative,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterErrorBarSettings extends ErrorBarSettingsBase {
    constructor() {
        super();
        this.q = null;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, runOn(this, this.ap));
    }
    get r() {
        return this.q;
    }
    set r(a) {
        this.q = a;
    }
    ap(a, b) {
        switch (b.propertyName) {
            case ScatterErrorBarSettings.$$p[2]:
            case ScatterErrorBarSettings.$$p[8]:
                let c = typeCast(IErrorBarCalculator_$type, b.oldValue);
                if (c != null) {
                    c.changed = delegateRemove(c.changed, runOn(this, this.ao));
                }
                if (this.r != null) {
                    this.r.jl(false);
                    if (this.r.bs != null) {
                        this.r.it();
                    }
                }
                let d = typeCast(IErrorBarCalculator_$type, b.newValue);
                if (d != null) {
                    d.changed = delegateCombine(d.changed, runOn(this, this.ao));
                }
                break;
            case ScatterErrorBarSettings.$$p[0]:
            case ScatterErrorBarSettings.$$p[1]:
            case ScatterErrorBarSettings.$$p[3]:
            case ScatterErrorBarSettings.$$p[4]:
            case ScatterErrorBarSettings.$$p[5]:
            case ScatterErrorBarSettings.$$p[6]:
            case ScatterErrorBarSettings.$$p[7]:
            case ScatterErrorBarSettings.$$p[9]:
            case ScatterErrorBarSettings.$$p[10]:
            case ScatterErrorBarSettings.$$p[11]:
            case ScatterErrorBarSettings.$$p[12]:
            case ScatterErrorBarSettings.$$p[13]:
                if (this.r != null) {
                    this.r.jl(false);
                    if (this.r.bs != null) {
                        this.r.it();
                    }
                }
                break;
        }
    }
    ao(a, b) {
        let c = typeCast(IErrorBarCalculator_$type, a);
        if (c != null) {
            c.changed = delegateRemove(c.changed, runOn(this, this.ao));
            if (this.r != null) {
                this.r.jl(false);
            }
            c.changed = delegateCombine(c.changed, runOn(this, this.ao));
        }
    }
}
ScatterErrorBarSettings.$t = markType(ScatterErrorBarSettings, 'ScatterErrorBarSettings', ErrorBarSettingsBase.$);
ScatterErrorBarSettings.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterErrorBarSettings, 'l', ['EnableErrorBarsHorizontal:o:aq', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'EnableErrorBarsVertical:p:ar', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'HorizontalCalculator:u:as', [IErrorBarCalculator_$type, null], 'HorizontalCalculatorReference:s:at', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 0)], 'HorizontalErrorBarCapLength:y:au', [1, 6], 'HorizontalErrorBarStyle:a6:av', [Style.$, null], 'HorizontalStroke:a4:aw', [Brush.$, null], 'HorizontalStrokeThickness:w:ax', [1, 1], 'VerticalCalculator:v:ay', [IErrorBarCalculator_$type, null], 'VerticalCalculatorReference:t:az', [ErrorBarCalculatorReference_$type, enumGetBox(ErrorBarCalculatorReference_$type, 1)], 'VerticalErrorBarCapLength:z:a0', [1, 6], 'VerticalErrorBarStyle:a7:a1', [Style.$, null], 'VerticalStroke:a5:a2', [Brush.$, null], 'VerticalStrokeThickness:x:a3', [1, 1]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterFrame extends ScatterFrameBase$1 {
    constructor() {
        super(ScatterFrame.$);
        this.u = null;
        this.u = new Dictionary$2(Base.$, OwnedPoint.$, 0);
    }
    r(a, b, c) {
        super.r(a, b, c);
        let d = typeCast(ScatterFrame.$, b);
        let e = typeCast(ScatterFrame.$, c);
        if (d == null || e == null) {
            return;
        }
        this.f.f(this.u, a, d.u, e.u, d, e);
    }
}
ScatterFrame.$t = markType(ScatterFrame, 'ScatterFrame', ScatterFrameBase$1.$.specialize(-1)).initSelfReferences();

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterTrendLineManager extends TrendLineManagerBase$1 {
    constructor() {
        super(Point_$type);
    }
    get_g$a() {
        return 4;
    }
    get g$a() {
        return this.get_g$a();
    }
    h(a, b, c, d, e, f, g, h, i, j, k) {
        let l = j;
        let m = k;
        let n = new List$1(Point_$type, 0);
        let o = 0;
        if (c != null) {
            o = c.count;
        }
        if (d != null) {
            o = Math.min(o, d.count);
        }
        if (!h.g.isEmpty && !h.f.isEmpty) {
            if (b == 0) {
                this.a = null;
                this.d.clear();
            }
            else if (this.c(b)) {
                this.d.clear();
                this.a = TrendFitCalculator.a(n, b, h, this.a, o, (p) => c.item(p), (p) => d.item(p), f, g, l, m);
            }
            else if (this.b(b)) {
                this.a = null;
                this.d.clear();
                TrendAverageCalculator.c(b, this.d, c, d, e);
                for (let p of fromEnum(this.d)) {
                    let q = f(p.x);
                    let r = g(p.y);
                    if (!isNaN_(q) && !isNaN_(r)) {
                        n.add({ $type: Point_$type, x: q, y: r });
                    }
                }
            }
            this.f(n, h, a, i);
        }
    }
}
ScatterTrendLineManager.$t = markType(ScatterTrendLineManager, 'ScatterTrendLineManager', TrendLineManagerBase$1.$.specialize(Point_$type));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ErrorBarsHelper extends Base {
    constructor(a, b) {
        super();
        this.b = null;
        this.a = null;
        this.b = a;
        this.a = b;
    }
    c(a) {
        let b = a.getCalculatorType();
        if (b == 1 || b == 2) {
            return false;
        }
        else {
            return true;
        }
    }
    i(a, b) {
        if (a.hasConstantPosition()) {
            b = a.getPosition();
        }
        return {
            p1: b
        };
    }
    k(a, b, c, d, e) {
        let f;
        let g;
        let h;
        let i = this.a.getViewInfo(g, f);
        g = i.p0;
        f = i.p1;
        h = this.a.getEffectiveViewport();
        let j = new ScalerParams(0, f, g, c.ca, h);
        let k = c.dy(a, j);
        let l = b.getIndependentValue();
        d = Math.abs(Math.round(c.dy(a + l, j) - k));
        e = Math.abs(Math.round(c.dy(a - l, j) - k));
        return {
            p3: d,
            p4: e
        };
    }
    j(a, b, c, d, e) {
        let f;
        let g;
        let h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        let i = new ScalerParams(1, f, g, c.ca);
        let j = c.d1(a, i);
        let k = b.getIndependentValue();
        d = Math.abs(Math.round(c.dy(j + k, i) - a));
        e = Math.abs(Math.round(c.dy(j - k, i) - a));
        return {
            p3: d,
            p4: e
        };
    }
    g(a, b, c, d, e) {
        let f;
        let g;
        let h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        let i = new ScalerParams(1, f, g, c.ca);
        let j = c.d1(a, i);
        let k = b.getDependentValue(j);
        d = Math.abs(Math.round(c.dy(j + k, i) - a));
        e = Math.abs(Math.round(c.dy(j - k, i) - a));
        return {
            p3: d,
            p4: e
        };
    }
    f(a, b, c, d, e, f) {
        let g;
        let h;
        let i = this.a.getViewInfo(h, g);
        h = i.p0;
        g = i.p1;
        let j = new ScalerParams(1, g, h, c.ca);
        let k = new ScalerParams(1, g, h, d.ca);
        let l = c.d1(a, j);
        let m = b.getDependentValue(l);
        e = Math.abs(Math.round(c.dy(l + m, k) - a));
        f = Math.abs(Math.round(c.dy(l - m, k) - a));
        return {
            p4: e,
            p5: f
        };
    }
    h(a, b, c, d, e) {
        let f;
        let g;
        let h = this.a.getViewInfo(g, f);
        g = h.p0;
        f = h.p1;
        let i = new ScalerParams(1, f, g, c.ca);
        let j = c.d1(a, i);
        d = Math.abs(Math.round(c.dy(j + b, i) - a));
        e = Math.abs(Math.round(c.dy(j - b, i) - a));
        return {
            p3: d,
            p4: e
        };
    }
    e(a, b, c, d) {
    }
    d(a, b, c, d) {
    }
    l(a, b, c, d) {
        let e = PointUtil.create();
        if (a.getCalculatorType() == 3) {
            let f;
            let g;
            let h;
            let i = this.a.getViewInfo(g, f);
            g = i.p0;
            f = i.p1;
            h = this.a.getEffectiveViewport();
            let j = new ScalerParams(0, f, g, b.ca, h);
            e.x = Math.round(b.dy(d, j));
            e.y = Math.round(c.y);
        }
        else {
            e.x = Math.round(c.x);
            e.y = Math.round(c.y);
        }
        return e;
    }
    m(a, b, c, d) {
        let e = PointUtil.create();
        if (a.getCalculatorType() == 3) {
            let f;
            let g;
            let h;
            let i = this.a.getViewInfo(g, f);
            g = i.p0;
            f = i.p1;
            h = this.a.getEffectiveViewport();
            let j = new ScalerParams(0, f, g, b.ca, h);
            e.x = Math.round(c.x);
            e.y = Math.round(b.dy(d, j));
        }
        else {
            e.x = Math.round(c.x);
            e.y = Math.round(c.y);
        }
        return e;
    }
}
ErrorBarsHelper.$t = markType(ErrorBarsHelper, 'ErrorBarsHelper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterBase extends MarkerSeries {
    constructor() {
        super();
        this.nh = null;
        this.np = null;
        this.nr = null;
        this.o8 = null;
        this.o9 = null;
        this.nm = null;
        this.no = null;
        this.nl = null;
        this.nn = null;
        this.nk = null;
        this.nn = new ScatterFrame();
        this.o9 = Rect.empty;
        this.o8 = Rect.empty;
    }
    bf() {
        return new ScatterBaseView(this);
    }
    h1() {
        super.h1();
        this.xAxis = null;
        this.yAxis = null;
    }
    i2(a) {
        super.i2(a);
        this.ni = a;
    }
    get_c4() {
        return true;
    }
    ag() {
        return [this.xAxis, this.yAxis];
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == ScatterBase.$$p[4]) {
            return this.ft(a, b, this.n4);
        }
        if (c == ScatterBase.$$p[6]) {
            return this.ft(a, b, this.n8);
        }
        return null;
    }
    ch(a, b, c) {
        if (!this.hasMarkers) {
            return false;
        }
        let d = this.xAxis;
        let e = new ScalerParams(1, this.bs.n2, this.l8, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        let f = this.yAxis;
        let g = new ScalerParams(1, this.bs.n2, this.l8, f.ca);
        g.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ma.cc((h) => {
            if (h._visibility == 0) {
                let i = new SeriesPointOfInterest();
                let j = h.n;
                let k = h.o;
                if (j < this.l8.left || j > this.l8.right || k < this.l8.top || k > this.l8.bottom) {
                    return;
                }
                i.b = d.d1(j, e);
                i.c = f.d1(k, g);
                i.a = h.content;
                a.add(i);
            }
        });
        return true;
    }
    bd() {
        if (this.be == 0) {
            if (this.nx <= 2000) {
                return 1;
            }
            else {
                return super.bd();
            }
        }
        else {
            return super.bd();
        }
    }
    l6(a) {
        if (!this.hasMarkers || !this.md()) {
            return Rect.empty;
        }
        let b = this.ma.bv(this.lq(a));
        if (b != null) {
            return this.ma.cm(b);
        }
        return Rect.empty;
    }
    dh(a, b) {
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    get nq() {
        return this.np;
    }
    set nq(a) {
        if (this.np != a) {
            let b = this.nq;
            this.np = a;
            this.raisePropertyChanged("XColumn", b, this.nq);
        }
    }
    get ns() {
        return this.nr;
    }
    set ns(a) {
        if (this.nr != a) {
            let b = this.ns;
            this.nr = a;
            this.raisePropertyChanged("YColumn", b, this.ns);
        }
    }
    get o5() {
        return this.c(ScatterBase.oq);
    }
    set o5(a) {
        this.h(ScatterBase.oq, a);
    }
    get GetErrorBarsXAxis() {
        return this.xAxis;
    }
    get GetErrorBarsYAxis() {
        return this.yAxis;
    }
    ik() {
        super.ik();
        if (this.xAxis != null) {
            this.xAxis.hb(false);
        }
        if (this.yAxis != null) {
            this.yAxis.hb(false);
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.ni.ct.g$b(a, b, c, d)) {
            this.jl(false);
            this.it();
        }
        switch (b) {
            case "FastItemsSource":
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.nq);
                    c.deregisterColumn(this.ns);
                    this.nq = null;
                    this.ns = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.nq = this.bw(this.n4);
                    this.ns = this.bw(this.n8);
                }
                if ((this.yAxis != null && !this.yAxis.cn()) || (this.xAxis != null && !this.xAxis.cn())) {
                    this.jl(false);
                }
                break;
            case ScatterBase.$$p[3]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if ((this.xAxis != null && !this.xAxis.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                this.it();
                break;
            case ScatterBase.$$p[5]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if ((this.yAxis != null && !this.yAxis.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                this.it();
                break;
            case ScatterBase.$$p[4]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nq);
                    this.nq = this.bw(this.n4);
                }
                break;
            case "XColumn":
                this.ni.ct.g$i();
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(false);
                }
                break;
            case ScatterBase.$$p[6]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ns);
                    this.ns = this.bw(this.n8);
                }
                break;
            case "YColumn":
                this.ni.ct.g$i();
                if (this.yAxis != null && !this.yAxis.cn()) {
                    this.jl(false);
                }
                break;
            case ScatterBase.$$p[1]:
                this.jl(false);
                this.it();
                break;
            case ScatterBase.$$p[2]:
                this.jl(false);
                this.it();
                break;
            case "TransitionProgress":
                this.no.c(this.ez, this.nm, this.nl);
                this.oa();
                try {
                    if (this.cc(this.bi)) {
                        return;
                    }
                    if ((Math.round(this.ez * 100000) / 100000) == 1) {
                        this.oo(this.nl, this.ni);
                    }
                    else {
                        this.oo(this.no, this.ni);
                    }
                    if (this.bs != null) {
                        this.bs.ko(this);
                    }
                }
                finally {
                    this.op();
                }
                break;
            case "TrendLineBrush":
                this.jw();
                break;
            case ScatterBase.$$p[0]:
                if (this.nj != null) {
                    this.nj.r = this;
                }
                this.jl(false);
                this.it();
                break;
            case "TrendLineType":
                this.it();
                break;
        }
    }
    nu(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    nt(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    op() {
        this.o8 = Rect.empty;
        this.o9 = Rect.empty;
    }
    oa() {
        let a = this.getViewInfo(this.o8, this.o9);
        this.o8 = a.p0;
        this.o9 = a.p1;
    }
    nv(a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.n4 == a || this.n8 == a) {
            return true;
        }
        return false;
    }
    h6(a, b, c, d) {
        let e = false;
        if (!this.nv(d, a)) {
            return;
        }
        this.ni.ct.g$e(a, b, c, d);
        if (this.xAxis != null && !this.xAxis.cn()) {
            e = true;
        }
        if (this.yAxis != null && !this.yAxis.cn()) {
            e = true;
        }
        if (e) {
            this.jl(true);
        }
    }
    oi(a) {
        this.oj(a, null);
    }
    oj(a, b) {
        let c = this.nq != null ? this.nq.count : 0;
        let d = this.ns != null ? this.ns.count : 0;
        let e = Math.min(c, d);
        if (e <= this.nx) {
            a.m.clear();
            let f = new List$1(OwnedPoint.$, 0);
            for (let g of fromEnum(a.u.values)) {
                f.add(g);
            }
            let h = this.bz;
            f.aa((i, j) => {
                let k = h.indexOf(i.a);
                let l = h.indexOf(j.a);
                if (k < l) {
                    return -1;
                }
                if (k > l) {
                    return 1;
                }
                return 0;
            });
            if (b != null) {
                b.i = a.m;
            }
            for (let i of fromEnum(f)) {
                if (h.indexOf(i.a) >= 0) {
                    if (b != null) {
                        b.j(i.c);
                    }
                    else {
                        a.m.add({ $type: Point_$type, x: i.c.x, y: i.c.y });
                    }
                }
            }
        }
    }
    an(a) {
        if (a != null && a == this.xAxis && this.nq != null) {
            return new AxisRange(this.nq.minimum, this.nq.maximum);
        }
        if (a != null && a == this.yAxis && this.ns != null) {
            return new AxisRange(this.ns.minimum, this.ns.maximum);
        }
        return null;
    }
    fp(a) {
        return null;
    }
    e8(a) {
        return -1;
    }
    c9(a) {
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        b = b.copy();
        let c = this.bs != null ? this.bs.oh : Rect.empty;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = this.l2(this.bi);
        let f = new ScalerParams(0, d, d, this.xAxis.ca, e);
        let g = ((() => {
            let $ret = new ScalerParams(0, d, d, this.yAxis.ca, e);
            $ret.b = this.eh();
            return $ret;
        })());
        let h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        let i = this.xAxis != null && this.nq != null && h < this.nq.count ? this.xAxis.dy(this.nq.item(h), f) : NaN;
        let j = this.yAxis != null && this.ns != null && h < this.ns.count ? this.yAxis.dy(this.ns.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    }
    j0(a, b) {
        this.jl(false);
    }
    j1(a, b) {
        this.jl(false);
    }
    ob(a, b, c, d, e) {
        b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        let f = this.getEffectiveViewport1(a);
        let g = this.bz;
        let h;
        let i;
        let j = ((() => {
            let $ret = new ScalerParams(0, d, e, this.nh.d, f);
            $ret.c = this.getEffectiveViewport1(a);
            return $ret;
        })());
        let k = ((() => {
            let $ret = new ScalerParams(0, d, e, this.nh.e, f);
            $ret.c = this.getEffectiveViewport1(a);
            $ret.b = this.eh();
            return $ret;
        })());
        let l = false;
        let m = 0;
        if (this.bs != null) {
            if (this.bs.d1()) {
                let n = this.bs.h4(d, j);
                l = n.c;
                m = n.d;
            }
        }
        for (let o = 0; o < c; o++) {
            h = this.nq.item(o);
            i = this.ns.item(o);
            let p = { $type: Point_$type, x: this.nh.a.dy(h, j), y: this.nh.b.dy(i, k) };
            if (l) {
                if (p.x < e.left || p.x > e.right) {
                    if (p.x + m >= e.left && p.x + m <= e.right) {
                        p = { $type: Point_$type, x: p.x + m, y: i };
                    }
                }
            }
            if (!isInfinity(p.x) && !isInfinity(p.y)) {
                let q = g.item(o);
                if (!b.g.containsKey(q)) {
                    let r = { $type: Point_$type, x: h, y: i };
                    let s = { $type: Point_$type, x: p.x, y: p.y };
                    b.g.addItem(q, ((() => {
                        let $ret = new OwnedPoint();
                        $ret.a = q;
                        $ret.b = r;
                        $ret.c = s;
                        return $ret;
                    })()));
                }
            }
        }
    }
    of(a, b) {
        a.j.clear();
        a.n.clear();
        a.h.clear();
        a.l.clear();
        a.i.clear();
        a.k.clear();
        let c = Math.min(this.nq != null ? this.nq.count : 0, this.ns != null ? this.ns.count : 0);
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.xAxis.ca, f);
        g.c = this.getEffectiveViewport1(b);
        let h = ((() => {
            let $ret = new ScalerParams(0, d, e, this.yAxis.ca, f);
            $ret.b = this.eh();
            return $ret;
        })());
        ;
        h.c = this.getEffectiveViewport1(b);
        if (c < 1) {
            return;
        }
        this.nh = ((() => {
            let $ret = new ScatterAxisInfoCache();
            $ret.a = this.xAxis;
            $ret.b = this.yAxis;
            $ret.d = this.xAxis.ca;
            $ret.e = this.yAxis.ca;
            $ret.c = this.bz;
            return $ret;
        })());
        let i = b;
        if (c <= this.nx) {
            this.ob(i, a, c, d, e);
        }
        if (this.md()) {
            b.cr.l(a.j, this.nx, d, e, this.eu);
        }
        let j = ((() => {
            let $ret = new Clipper(0, e, false);
            $ret.i = a.n;
            return $ret;
        })());
        let k = this.l0(b);
        let l = this.xAxis.d1(k.left, g);
        let m = this.xAxis.d1(k.right, g);
        b.ct.h(a.n, this.trendLineType, this.nq, this.ns, this.trendLinePeriod, (n) => this.xAxis.dy(n, g), (n) => this.yAxis.dy(n, h), ((() => {
            let $ret = new TrendResolutionParams();
            $ret.b = this.eu;
            $ret.f = e;
            $ret.g = d;
            return $ret;
        })()), j, l, m);
        this.od(a, b);
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c0(a);
    }
    oo(a, b) {
        let c = b.br;
        this.nh = ((() => {
            let $ret = new ScatterAxisInfoCache();
            $ret.a = this.xAxis;
            $ret.b = this.yAxis;
            $ret.d = this.xAxis.ca;
            $ret.e = this.yAxis.ca;
            return $ret;
        })());
        if (this.md()) {
            b.cr.j(a.j, this.mf);
        }
        b.cj();
        let d = ((() => {
            let $ret = new Clipper(1, NaN, c.bottom, NaN, c.top, false);
            $ret.i = b.ct.g$j.ak;
            return $ret;
        })());
        b.ct.g$h(a.n, d);
        this.ol(a, b);
    }
    od(a, b) {
        let c = new ErrorBarsHelper(this, b);
        if (this.nj == null) {
            return;
        }
        let d = this.nj.u;
        let e = this.nj.v;
        let f = 0;
        let g = 0;
        let h = 0;
        let i = 0;
        for (let j of fromEnum(a.j.keys)) {
            let k = a.j.item(j);
            if (d != null) {
                switch (d.getCalculatorType()) {
                    case 1:
                        let l = this.og(k, c, d, h, i, true);
                        h = l.p3;
                        i = l.p4;
                        break;
                    case 0:
                        let m = this.oe(k, c, d, h, i, true);
                        h = m.p3;
                        i = m.p4;
                        break;
                    case 2:
                        let n = this.oc(k, c, d, j, h, i, true);
                        h = n.p4;
                        i = n.p5;
                        break;
                    case 3:
                        let o = this.oh(c, d, f, h, i, true);
                        f = o.p2;
                        h = o.p3;
                        i = o.p4;
                        break;
                    case 4:
                        let p = this.oe(k, c, d, h, i, true);
                        h = p.p3;
                        i = p.p4;
                        break;
                }
                ;
                let q = new OwnedPoint();
                q.c = c.l(d, this.nh.a, k.c, f);
                ;
                q.a = k.a;
                a.h.addItem(j, q);
                a.i.addItem(j, [h, i]);
            }
            if (e != null) {
                switch (e.getCalculatorType()) {
                    case 1:
                        let r = this.og(k, c, e, h, i, false);
                        h = r.p3;
                        i = r.p4;
                        break;
                    case 0:
                        let s = this.oe(k, c, e, h, i, false);
                        h = s.p3;
                        i = s.p4;
                        break;
                    case 2:
                        let t = this.oc(k, c, e, j, h, i, false);
                        h = t.p4;
                        i = t.p5;
                        break;
                    case 3:
                        let u = this.oh(c, e, g, h, i, false);
                        g = u.p2;
                        h = u.p3;
                        i = u.p4;
                        break;
                    case 4:
                        let v = this.oe(k, c, e, h, i, false);
                        h = v.p3;
                        i = v.p4;
                        break;
                }
                ;
                let w = new OwnedPoint();
                w.c = c.m(e, this.nh.b, k.c, g);
                ;
                w.a = k.a;
                a.l.addItem(j, w);
                a.k.addItem(j, [h, i]);
            }
        }
    }
    og(a, b, c, d, e, f) {
        if (f) {
            let g;
            let h, i;
            i = this.nh.a;
            if (this.nj.s == 0) {
                g = a.c.x;
                h = this.nh.a;
            }
            else {
                g = a.c.y;
                h = this.nh.b;
            }
            let j = b.f(g, c, h, i, d, e);
            d = j.p4;
            e = j.p5;
        }
        else {
            let k;
            let l, m;
            m = this.nh.b;
            if (this.nj.t == 0) {
                k = a.c.x;
                l = this.nh.a;
            }
            else {
                k = a.c.y;
                l = this.nh.b;
            }
            let n = b.f(k, c, l, m, d, e);
            d = n.p4;
            e = n.p5;
        }
        return {
            p3: d,
            p4: e
        };
    }
    oe(a, b, c, d, e, f) {
        if (f) {
            let g = b.j(a.c.x, c, this.nh.a, d, e);
            d = g.p3;
            e = g.p4;
        }
        else {
            let h = b.j(a.c.y, c, this.nh.b, d, e);
            d = h.p3;
            e = h.p4;
        }
        return {
            p3: d,
            p4: e
        };
    }
    oc(a, b, c, d, e, f, g) {
        let h = c.getItemColumn();
        let i = this.bz.indexOf(d);
        if (h != null && i < h.count) {
            let j = h.item(i);
            if (g) {
                let k = b.h(a.c.x, j, this.nh.a, e, f);
                e = k.p3;
                f = k.p4;
            }
            else {
                let l = b.h(a.c.y, j, this.nh.b, e, f);
                e = l.p3;
                f = l.p4;
            }
        }
        else {
            e = f = NaN;
        }
        return {
            p4: e,
            p5: f
        };
    }
    oh(a, b, c, d, e, f) {
        let g = a.i(b, c);
        c = g.p1;
        if (f) {
            let h = a.k(c, b, this.nh.a, d, e);
            d = h.p3;
            e = h.p4;
        }
        else {
            let i = a.k(c, b, this.nh.b, d, e);
            d = i.p3;
            e = i.p4;
        }
        return {
            p2: c,
            p3: d,
            p4: e
        };
    }
    ol(a, b) {
        if (!b.l() || this.nj == null) {
            b.c1();
            return;
        }
        this.om(a, b);
        this.on(a, b);
    }
    om(a, b) {
        b.cy();
        let c = new ErrorBarsHelper(this, b);
        let d = new PathGeometry();
        let e = this.nj.u;
        for (let f of fromEnum(a.j.keys)) {
            if (e != null && a.i.containsKey(f)) {
                let g = a.i.item(f)[0];
                let h = a.i.item(f)[1];
                if (!isNaN_(g) && !isNaN_(h)) {
                    let i = a.h.item(f).c;
                    if (this.nj.o == 1 || this.nj.o == 2) {
                        c.d(d, i, g, true);
                    }
                    if (this.nj.o == 1 || this.nj.o == 3) {
                        c.d(d, i, h, false);
                    }
                }
            }
        }
        b.c2(d);
    }
    on(a, b) {
        b.cz();
        let c = new ErrorBarsHelper(this, b);
        let d = new PathGeometry();
        let e = this.nj.v;
        for (let f of fromEnum(a.j.keys)) {
            if (e != null && a.k.containsKey(f)) {
                let g = a.k.item(f)[0];
                let h = a.k.item(f)[1];
                if (!isNaN_(g) && !isNaN_(h)) {
                    let i = a.l.item(f).c;
                    if (this.nj.p == 1 || this.nj.p == 2) {
                        c.e(d, i, g, true);
                    }
                    if (this.nj.p == 1 || this.nj.p == 3) {
                        c.e(d, i, h, false);
                    }
                }
            }
        }
    }
    dw(a, b, c) {
        let d = true;
        if (!super.dw(a, b, c) || b.isEmpty || a.isEmpty || this.xAxis == null || this.yAxis == null || this.xAxis.bh == null || this.yAxis.bh == null || this.nq == null || this.ns == null || this.nq.count == 0 || this.ns.count == 0 || this.bz == null || this.bz.count != this.nq.count || this.bz.count != this.ns.count || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.kc == this.xAxis.kb || this.yAxis.kc == this.yAxis.kb) {
            d = false;
        }
        return d;
    }
    getViewInfo(a, b) {
        if (!this.o8.isEmpty && !this.o9.isEmpty) {
            a = this.o8;
            b = this.o9;
            return {
                p0: a,
                p1: b
            };
        }
        a = this.bi.br;
        b = this.bi.bs;
        return {
            p0: a,
            p1: b
        };
    }
    jm(a) {
        this.oa();
        try {
            if (this.cc(this.bi)) {
                return;
            }
            if (this.bz != null && this.bz.count > this.nx) {
                a = false;
            }
            if (this.da(a) && !this.de) {
                let b = this.nm;
                if (this.ca()) {
                    if (this.bt.g) {
                        this.bt.t();
                    }
                    this.nm = this.no;
                    this.no = b;
                }
                else {
                    this.nm = this.nl;
                    this.nl = b;
                }
                this.of(this.nl, this.ni);
                this.jt();
            }
            else {
                if (!this.de) {
                    this.of(this.nl, this.ni);
                }
                this.oo(this.nl, this.ni);
            }
        }
        finally {
            this.op();
        }
    }
    jw() {
        super.jw();
        if (this.fh < 0) {
            return;
        }
        this.ni.c5();
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        let c = typeCast(ScatterBaseView.$, this.bh);
        if (!this.df) {
            this.nn = new ScatterFrame();
            this.of(this.nn, c);
        }
        this.df = false;
        this.oo(this.nn, c);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.nk == null) {
            this.nk = new ScatterFrame();
        }
        this.of(this.nk, g);
        this.oo(this.nk, g);
    }
    ok(a, b) {
        let c = new List$1(Base.$, 0);
        for (let d of fromEnum(b.c)) {
            if (!a.containsKey(d)) {
                c.add1(d);
            }
        }
        for (let e of fromEnum(c)) {
            b.g(e);
        }
    }
    nd(a, b, c, d, e) {
        if (c == null || c.length != this.nh.c.count) {
            c = new Array(this.nh.c.count);
            for (let f = 0; f < this.nh.c.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        let g = this.getEffectiveViewport1(a);
        let h = ((() => {
            let $ret = new ScalerParams(0, d, e, this.xAxis.ca, g);
            $ret.c = this.getEffectiveViewport1(a);
            return $ret;
        })());
        let i = ((() => {
            let $ret = new ScalerParams(0, d, e, this.yAxis.ca, g);
            $ret.c = this.getEffectiveViewport1(a);
            $ret.b = this.eh();
            return $ret;
        })());
        let j = this.l0(a);
        let k = this.nh.a.d1(j.left, h);
        let l = this.nh.a.d1(j.right, h);
        let m = this.nh.b.d1(j.bottom, i);
        let n = this.nh.b.d1(j.top, i);
        if (this.nh.d) {
            let o = k;
            k = l;
            l = o;
        }
        if (this.nh.e) {
            let p = m;
            m = n;
            n = p;
        }
        let q = this.nh;
        let r = q.a;
        let s = q.b;
        let t;
        let u;
        let v = this.nq;
        let w = this.ns;
        let x = false;
        let y = 0;
        let z = 0;
        if (this.bs != null) {
            if (this.bs.d1()) {
                let aa = this.bs.h4(d, h);
                x = aa.c;
                y = aa.d;
                z = r.d1(0 + y, h);
                let ab = r.d1(0, h);
                z -= ab;
            }
        }
        for (let ac = 0; ac < this.nh.c.count; ac++) {
            t = v.item(ac);
            u = w.item(ac);
            if (x) {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.dy(t, h);
                    c[ac].y = s.dy(u, i);
                }
                else {
                    if ((t + z) >= k && (t + z) <= l && u >= m && u <= n) {
                        c[ac].x = r.dy(t, h) + y;
                        c[ac].y = s.dy(u, i);
                    }
                    else {
                        c[ac].x = NaN;
                        c[ac].y = NaN;
                    }
                }
            }
            else {
                if (t >= k && t <= l && u >= m && u <= n) {
                    c[ac].x = r.dy(t, h);
                    c[ac].y = s.dy(u, i);
                }
                else {
                    c[ac].x = NaN;
                    c[ac].y = NaN;
                }
            }
        }
        return c;
    }
    nw(a, b) {
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        let c = 0;
        let d = this.bz;
        for (let e of fromEnum(a.c)) {
            b.add(d.indexOf(e));
        }
        return b;
    }
    ic(a) {
        super.ic(a);
        this.a2.exportTrendlineData(this, a, this.ni.ct.g$j);
    }
    eh() {
        return Series.ei(this.ns, null);
    }
}
ScatterBase.$t = markType(ScatterBase, 'ScatterBase', MarkerSeries.$, [ISupportsErrorBars_$type, ITrendLineSeries_$type]);
ScatterBase.oq = DependencyProperty.i("ActualTrendLineBrush", Brush.$, ScatterBase.$, new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("ActualTrendLineBrush", b.oldValue, b.newValue)));
ScatterBase.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterBase, 'raisePropertyChanged', ['ErrorBarSettings:nj:or', [ScatterErrorBarSettings.$, null], 'MarkerCollisionAvoidance:ne:os', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MaximumMarkers:nx:ot', [1, 400], 'XAxis::o1', [NumericXAxis.$, null], 'XMemberPath:n4:o2', [2, null], 'YAxis::o3', [NumericYAxis.$, null], 'YMemberPath:n8:o4', [2, null], 'TrendLineType::oz', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'TrendLineThickness::oy', [1, 1.5], 'TrendLinePeriod::ox', [1, 7], 'TrendLineBrush::ou', [Brush.$, null], 'TrendLineZIndex:ny:o0', [1, 1001], 'TrendLineDashArray:o6:ov', [DoubleCollection.$], 'TrendLineDashCap:o7:ow', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)]]);
/**
 * @hidden
 */
class ScatterBaseView extends MarkerSeriesView {
    constructor(a) {
        super(a);
        this.cr = null;
        this.cp = null;
        this.cs = null;
        this.cx = null;
        this.c7 = null;
        this.c8 = null;
        this.ct = null;
        this.c6 = null;
        this.cu = null;
        this.cs = a;
        this.cu = new HashPool$2(Base.$, Marker.$);
        this.ce(this.cu);
        this.ct = new ScatterTrendLineManager();
    }
    ap() {
        super.ap();
        this.cr = this.cq();
        this.c7 = new Path();
        this.c8 = new Path();
        if (!this.n) {
            this.cs.nx = 2000;
        }
    }
    c9(a) {
        if (this.c6 == null) {
            this.c6 = new DataTemplateMeasureInfo();
            this.c6.context = this.h.g();
        }
        this.c6.width = a.width;
        this.c6.height = a.height;
        this.c6.data = a.content;
        let b = a.ah;
        if (b.measure != null) {
            b.measure(this.c6);
        }
        return new Size(1, this.c6.width, this.c6.height);
    }
    cq() {
        let a = new NumericMarkerManager(1, (b) => this.cu.item(b), (b) => this.cs.nh.c.item(b), runOn(this, this.c4), runOn(this, this.cn), runOn(this, this.cv), () => this.cs.ne);
        a.q = runOn(this, this.c9);
        return a;
    }
    c4(a) {
        this.cs.ok(a, this.cu);
    }
    cw() {
        return this.b1;
    }
    co() {
        return this.cp;
    }
    cn() {
        this.cp = this.cs.nd(this, this.cu, this.cp, this.bs, this.br);
        return this.cp;
    }
    cv() {
        this.cx = this.cs.nw(this.cu, this.cx);
        return this.cx;
    }
    cy() {
    }
    c2(a) {
    }
    cz() {
    }
    c3(a) {
    }
    c5() {
        if (this.cs.trendLineBrush != null) {
            this.cs.o5 = this.cs.trendLineBrush;
        }
        else {
            this.cs.o5 = this.cs.lb;
        }
    }
    cc(a) {
        this.cu.f(a);
    }
    c1() {
    }
    a2(a, b) {
        super.a2(a, b);
        if (a.d) {
            if (this.cs.trendLineType != 0 && !b) {
                let c = this.ct.g$j;
                c.ac = this.cs.trendLineThickness;
                c._stroke = this.cs.o5;
                c.ai = this.cs.o6;
                c.ad = this.cs.o7;
                a.u(c);
            }
        }
    }
    c0(a) {
        if (a) {
            this.c1();
            this.cu.clear();
        }
        this.ct.g$d();
        this.an();
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.cs.fx + "</span><br/><span>" + "x: </span><span class='ui-priority-primary'>${item." + this.cs.n4 + "}</span><br/><span>" + "y: </span><span class='ui-priority-primary'>${item." + this.cs.n8 + "}</span></div>";
        return a;
    }
}
ScatterBaseView.$t = markType(ScatterBaseView, 'ScatterBaseView', MarkerSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ActualRange extends Base {
    constructor() {
        super(...arguments);
        this.b = 0;
        this.a = 0;
    }
}
ActualRange.$t = markType(ActualRange, 'ActualRange');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BubbleMarkerManager extends MarkerManagerBase {
    constructor(a, b, c, d, e) {
        super(a, b, c, d, e);
        this.m = null;
        this.o = null;
        this.n = null;
        this.o = new List$1(Number_$type, 0);
        this.n = new List$1(Marker.$, 0);
    }
    l(a, b, c, d, e) {
        let f = this.f();
        a.clear();
        this.o.clear();
        this.n.clear();
        let g = new List$1(Number_$type, 0);
        b = Math.max(0, b);
        let h = null;
        this.i(c, d, boxArray$1(f), g);
        if (b >= g.count) {
            h = g;
        }
        else {
            h = new List$1(Number_$type, 0);
            let i = Math.max(8, e);
            let j = this.c(d, g, i, boxArray$1(f));
            let k = new List$1(Number_$type, 1, j.keys);
            if (MarkerManagerBase.b) {
                k.y();
            }
            this.k(b, j, k, h);
        }
        for (let l = 0; l < h.count; ++l) {
            let m = f[h._inner[l]].x;
            let n = f[h._inner[l]].y;
            let o = this.m.item(h._inner[l]);
            this.o.add(o);
            let p = this.h(this.g(h._inner[l]));
            p.content.item = this.g(h._inner[l]);
            let q = new OwnedPoint();
            q.a = p.content.item;
            q.c = { $type: Point_$type, x: m, y: n };
            if (!a.containsKey(q.a)) {
                a.addItem(q.a, q);
                this.n.add(p);
            }
        }
    }
    j(a, b) {
        let c = new List$1(Base.$, 1, a.keys);
        if (MarkerManagerBase.b) {
            c.aa((d, e) => {
                let f = a.item(d);
                let g = a.item(e);
                let h = Math.pow(f.c.x, 2) + Math.pow(f.c.y, 2);
                let i = Math.pow(g.c.x, 2) + Math.pow(g.c.y, 2);
                return CompareUtil.compareToObject(h, i);
            });
        }
        for (let d of fromEnum(c)) {
            let e = a.item(d);
            let f = this.h(e.a);
            f.s = c.indexOf1(d);
            f.n = e.c.x;
            f.o = e.c.y;
        }
        this.a(a);
    }
}
BubbleMarkerManager.$t = markType(BubbleMarkerManager, 'BubbleMarkerManager', MarkerManagerBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BubbleSeries extends ScatterBase {
    constructor() {
        super();
        this.qq = null;
        this.qp = null;
        this.pp = null;
        this.ph = null;
        this.pg = null;
        this.pf = null;
        this.ab = BubbleSeries.$;
        this.nm = new ScatterFrame();
        this.no = new ScatterFrame();
        this.nl = new ScatterFrame();
    }
    bf() {
        return new BubbleSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pd = a;
    }
    isAttachedTo(a) {
        return this.aw == a;
    }
    ci() {
        return true;
    }
    ie(a) {
        super.ie(a);
        if (this.pk != null && this.pp != null && this.pp.count > 0) {
            for (let b = 0; b < this.pp.count; b++) {
                a(this.pp._inner[b]);
            }
        }
    }
    get pj() {
        return this.pl;
    }
    qo(a) {
        let b = typeCast(CustomPaletteBrushScale.$, this.pc);
        let c = typeCast(ValueBrushScale.$, this.pc);
        let d = this.pc;
        if (b != null && this.bz != null) {
            return b.getBrush1(a, this.bz.count);
        }
        else if (c != null) {
            return c.getBrushByIndex(a, this.pi);
        }
        else if (d != null) {
            return d.getBrush(a);
        }
        return null;
    }
    get legendReady() {
        return this.pl != null && this.pl.count != 0;
    }
    get minScaleText() {
        let a = this.pb(this.pe).b;
        return (Math.round(a * 1000) / 1000).toString();
    }
    get maxScaleText() {
        let a = this.pb(this.pe).a;
        return (Math.round(a * 1000) / 1000).toString();
    }
    forScaleColors(a) {
        for (let b = 0; b < this.pl.count; b++) {
            if (this.pc == null || !this.pc.isReady) {
                return false;
            }
            let c = NaN;
            if (this.pi != null) {
                c = (this.pi.item(b) - this.pi.minimum) / (this.pi.maximum - this.pi.minimum);
            }
            let d = (this.pl.item(b) - this.pl.minimum) / (this.pl.maximum - this.pl.minimum);
            if (isNaN_(c)) {
                c = 0;
            }
            if (isNaN_(d)) {
                d = c;
            }
            let e = this.m8;
            let f = this.qo(b);
            let g = f != null ? f : e;
            a(g, d);
        }
        return true;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == BubbleSeries.$$p[3]) {
            return this.ft(a, b, this.p0);
        }
        if (c == BubbleSeries.$$p[7]) {
            return this.ft(a, b, this.p6);
        }
        if (c == ScatterBase.$$p[4]) {
            return this.ft(a, b, this.n4);
        }
        if (c == ScatterBase.$$p[6]) {
            return this.ft(a, b, this.n8);
        }
        if (c == BubbleSeries.$$p[0]) {
            return this.ft(a, b, this.pv);
        }
        return super.fs(a, b);
    }
    get pl() {
        return this.ph;
    }
    set pl(a) {
        if (this.ph != a) {
            let b = this.pl;
            this.ph = a;
            this.raisePropertyChanged("RadiusColumn", b, this.pl);
        }
    }
    get pk() {
        return this.pg;
    }
    set pk(a) {
        if (this.pg != a) {
            let b = this.pk;
            this.pg = a;
            this.raisePropertyChanged("LabelColumn", b, this.pk);
        }
    }
    get pi() {
        return this.pf;
    }
    set pi(a) {
        if (this.pf != a) {
            let b = this.pi;
            this.pf = a;
            this.raisePropertyChanged("FillColumn", b, this.pi);
        }
    }
    ob(a, b, c, d, e) {
        if (c <= this.nx) {
            b.g = new Dictionary$2(Base.$, OwnedPoint.$, 1, c);
        }
        let f = this.nx;
        let g = this.bz;
        let h;
        let i;
        let j = this.getEffectiveViewport1(a);
        let k = new ScalerParams(0, d, e, this.nh.d, j);
        let l = new ScalerParams(0, d, e, this.nh.e, j);
        let m = false;
        let n = 0;
        if (this.bs != null) {
            if (this.bs.d1()) {
                let o = this.bs.h4(d, k);
                m = o.c;
                n = o.d;
            }
        }
        for (let p = 0; p < c; p++) {
            h = this.nq.item(p);
            i = this.ns.item(p);
            let q = { $type: Point_$type, x: this.nh.a.dy(h, k), y: this.nh.b.dy(i, l) };
            if (m) {
                if (q.x < e.left || q.x > e.right) {
                    if (q.x + n >= e.left && q.x + n <= e.right) {
                        q = { $type: Point_$type, x: q.x + n, y: i };
                    }
                }
            }
            if (!isInfinity(q.x) && !isInfinity(q.y)) {
                let r = g.item(p);
                if (c <= f) {
                    if (!b.g.containsKey(r)) {
                        let s = { $type: Point_$type, x: h, y: i };
                        b.g.addItem(r, ((() => {
                            let $ret = new OwnedPoint();
                            $ret.a = r;
                            $ret.b = s;
                            $ret.c = q;
                            return $ret;
                        })()));
                    }
                }
            }
        }
    }
    of(a, b) {
        let c = typeCast(BubbleSeriesView.$, b);
        let d = c.cr;
        d.m = this.pl;
        super.of(a, b);
        let e = Math.min(this.nq != null ? this.nq.count : 0, this.ns != null ? this.ns.count : 0);
        if (e < 1) {
            return;
        }
        c.dc();
        c.dd();
    }
    qb() {
        if (this.bs == null) {
            return;
        }
        if (this.aw == null) {
            return;
        }
        if (this.aw.isItemwise) {
            let a = this.aw;
            this.aw.clearLegendItemsForSeries(this);
            this.qa();
            a.renderItemwiseContent(this);
        }
        if (this.aw.isScale) {
            let b = this.aw;
            b.restoreOriginalState();
            b.initializeLegend(this);
        }
    }
    static pq(a, b, c, d, e) {
        if (e <= a || isNaN_(e) || isInfinity(e)) {
            return c;
        }
        if (e >= b) {
            return d;
        }
        let f = c + ((d - c) / (b - a)) * (e - a);
        return f;
    }
    static pr(a, b, c, d, logBase_, e) {
        let f = logBase(e, logBase_);
        let g = logBase(a, logBase_);
        let h = logBase(b, logBase_);
        return BubbleSeries.pq(g, h, c, d, f);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.pl == null || this.bz == null || this.pl.count == 0 || this.bz.count != this.pl.count) {
            d = false;
        }
        return d;
    }
    nv(a, b) {
        if (b != 3) {
            return true;
        }
        if (a == null) {
            return true;
        }
        if (this.n4 == a || this.n8 == a || this.p6 == a) {
            return true;
        }
        return false;
    }
    qa() {
        let a = typeCast(IChartLegend_$type, this.aw);
        if (a == null || this.bz == null) {
            return;
        }
        this.pp = new List$1(UIElement.$, 0);
        let b = typeCast(CustomPaletteBrushScale.$, this.pc);
        let c = typeCast(ValueBrushScale.$, this.pc);
        let d = this.pc;
        let e = this.pa();
        let f = e.b;
        let g = e.a;
        let h = this.bz;
        for (let i = 0; i < h.count; i++) {
            let j = null;
            if (c != null && this.pi != null) {
                let k = this.pi.item(i);
                j = c.getBrushByRange(k, f, g);
            }
            else if (b != null) {
                j = b.getBrush1(i, h.count);
            }
            else if (d != null) {
                j = d.getBrush(i);
            }
            let l = new ContentControl();
            let m = this.pk != null && this.pk.item(i) != null ? this.pk.item(i).toString() : "";
            l.content = ((() => {
                let $ret = new DataContext();
                $ret.series = this;
                $ret.item = h.item(i);
                $ret.itemBrush = j;
                $ret.itemLabel = m;
                return $ret;
            })());
            let n = this.j6;
            if (n == null) {
                n = this.bi.bi(this.bk);
            }
            l.ah = n;
            this.pp.add(l);
        }
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        if (this.pe != null) {
            this.pe.aa();
        }
        if (this.pc != null) {
            this.pc.w();
        }
        this.qb();
    }
    im() {
        super.im();
        this.qb();
    }
    is() {
        super.is();
        this.qb();
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                if (this.pe != null) {
                    this.pe.aa();
                }
                if (this.pc != null) {
                    this.pc.w();
                }
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.pl);
                    c.deregisterColumn(this.pi);
                    c.deregisterColumn(this.pk);
                    this.pl = null;
                    this.pi = null;
                    this.pk = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.pl = this.bw(this.p6);
                    if (!stringIsNullOrEmpty(this.pv)) {
                        this.pi = this.bw(this.pv);
                    }
                    this.pk = this.by(this.p0);
                }
                this.jl(false);
                this.qb();
                break;
            case BubbleSeries.$$p[7]:
                if (this.pe != null) {
                    this.pe.aa();
                }
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.pl);
                    this.pl = this.bw(this.p6);
                    this.qb();
                }
                break;
            case "RadiusColumn":
                if (this.pe != null) {
                    this.pe.aa();
                }
                this.ni.ct.g$i();
                this.jl(false);
                this.iu();
                break;
            case BubbleSeries.$$p[8]:
                if (c != null) {
                    c.l.remove(this);
                    c.aa();
                }
                if (d != null) {
                    d.l.add(this);
                    d.aa();
                }
                this.jl(false);
                this.it();
                break;
            case BubbleSeries.$$p[9]:
                this.jl(false);
                this.it();
                break;
            case "DiscreteLegendItemTemplate":
                this.qb();
                break;
            case BubbleSeries.$$p[1]:
                if (c != null) {
                    c.o.remove(this);
                    c.w();
                }
                if (d != null) {
                    d.o.add(this);
                    d.w();
                }
                this.jl(false);
                this.qb();
                this.it();
                break;
            case BubbleSeries.$$p[2]:
            case BubbleSeries.$$p[6]:
            case BubbleSeries.$$p[5]:
            case BubbleSeries.$$p[4]:
                this.jl(false);
                this.qb();
                this.it();
                break;
            case "FillColumn":
                this.jl(false);
                this.it();
                break;
            case BubbleSeries.$$p[0]:
                if (this.pc != null) {
                    this.pc.w();
                }
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.pi);
                    this.pi = this.bw(this.pv);
                    this.qb();
                }
                break;
            case BubbleSeries.$$p[3]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.pk);
                    this.pk = this.by(this.p0);
                    this.qb();
                }
                break;
            case "ActualLegend":
                let e = typeCast(IChartLegend_$type, c);
                if (e != null && e.isItemwise) {
                    let f = typeCast(IChartItemLegend_$type, e);
                    f.clearLegendItemsForSeries(this);
                }
                if (e != null && e.isScale) {
                    let g = typeCast(IChartScaleLegend_$type, e);
                    let h = true;
                    let i = null;
                    if (this.bs != null) {
                        for (let j of fromEnum(this.bs.series)) {
                            if (j.legend == g) {
                                i = j;
                                h = false;
                            }
                        }
                    }
                    if (h) {
                        g.restoreOriginalState();
                    }
                    else {
                        g.initializeLegend(typeCast(IScaleLegendSeries_$type, i));
                    }
                }
                this.qb();
                break;
            case "SeriesViewer":
                this.qb();
                break;
        }
    }
    updateSizeScaleGlobals() {
        let a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.pl != null) {
            a.b = this.pl.minimum;
            a.a = this.pl.maximum;
        }
        if (this.pe != null) {
            this.pe.ab(a.b, a.a);
        }
    }
    updateFillScaleGlobals() {
        let a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.pi != null) {
            a.b = this.pi.minimum;
            a.a = this.pi.maximum;
        }
        if (this.pc != null) {
            this.pc.y(a.b, a.a);
        }
    }
    pb(a) {
        let b = new ActualRange();
        b.b = NaN;
        b.a = NaN;
        if (this.pl != null) {
            b.b = this.pl.minimum;
            b.a = this.pl.maximum;
        }
        if (a != null) {
            a.x();
            if (this.po) {
                b.b = a.globalMinimum;
                b.a = a.globalMaximum;
            }
        }
        return b;
    }
    pa() {
        let a = new ActualRange();
        a.b = NaN;
        a.a = NaN;
        if (this.pi != null) {
            a.b = this.pi.minimum;
            a.a = this.pi.maximum;
        }
        let b = typeCast(ValueBrushScale.$, this.pc);
        if (b != null) {
            b.s();
            if (this.pm && this.pc.o.count > 1) {
                a.b = b.q;
                a.a = b.p;
            }
        }
        return a;
    }
    qd(a, b, c, d) {
        let e = c.width;
        if (!this.bi.br.isEmpty) {
            e = this.bi.br.width;
        }
        else if (this.bs != null && !this.bs.oh.isEmpty) {
            e = this.bs.oh.width;
        }
        let f = DeviceUtils.c(e);
        let g = this.pe || ((() => {
            let $ret = new SizeScale();
            $ret.minimumValue = f / 10;
            $ret.maximumValue = f / 5;
            return $ret;
        })());
        if (g != null) {
            let h = g.minimumValue;
            let i = g.maximumValue;
            let j = g.logarithmBase;
            let k = this.pb(g);
            let l = k.b;
            let m = k.a;
            if (g.isLogarithmic) {
                for (let n = 0; n < b.count; n++) {
                    b._inner[n] = BubbleSeries.pr(l, m, h, i, j, b._inner[n]);
                }
            }
            else {
                for (let o = 0; o < b.count; o++) {
                    b._inner[o] = BubbleSeries.pq(l, m, h, i, b._inner[o]);
                }
            }
        }
        let p = 1;
        p = DeviceUtils.d();
        let q = this.pe == null;
        if (d) {
            let r = c.width / e;
            for (let s = 0; s < b.count; s++) {
                if (q) {
                    b._inner[s] = b._inner[s] / p;
                }
                b._inner[s] = b._inner[s] * r;
            }
        }
        for (let t = 0; t < a.count; t++) {
            let u = a._inner[t];
            if (q && !d) {
                u.width = Math.max(0, b._inner[t] / p);
                u.height = Math.max(0, b._inner[t] / p);
            }
            else {
                u.width = Math.max(0, b._inner[t]);
                u.height = Math.max(0, b._inner[t]);
            }
        }
    }
    qc(a) {
        let b = typeCast(BubbleSeriesView.$, this.bh);
        this.pd.b0 = false;
        if (b != null) {
            b.b0 = false;
        }
        let c = typeCast(CustomPaletteBrushScale.$, this.pc);
        let d = typeCast(ValueBrushScale.$, this.pc);
        let e = this.pc;
        let f = this.pa();
        let g = f.b;
        let h = f.a;
        let i = this.pc == null || !this.pc.isReady || (d != null && this.pv == null);
        if (i) {
            this.pd.db();
            if (b != null) {
                b.db();
            }
            return;
        }
        this.pd.b0 = true;
        if (b != null) {
            b.b0 = true;
        }
        let j = a.count;
        let k = this.bz;
        for (let l = 0; l < j; l++) {
            let m = a._inner[l];
            let n = typeCast(DataContext.$, m.content);
            if (n != null) {
                let o = null;
                let p = k.indexOf(n.item);
                if (c != null) {
                    o = c.getBrush1(p, k.count);
                }
                else if (d != null && this.pi != null) {
                    let q = this.pi.item(p);
                    o = d.getBrushByRange(q, g, h);
                }
                else if (e != null) {
                    o = e.getBrush(p);
                }
                else {
                    if (this.na == null) {
                        o = this.m8;
                    }
                    else {
                        o = this.na;
                    }
                }
                let r = null;
                if (this.nb == null) {
                    r = this.m9;
                }
                else {
                    r = this.nb;
                }
                if (this.pn && o != null) {
                    r = o;
                }
                if (r != null && !isNaN_(this.pt)) {
                    r = BrushUtil.l(r, this.pt);
                }
                if (o != null && !isNaN_(this.ps)) {
                    o = BrushUtil.l(o, this.ps);
                }
                n.itemBrush = o;
                n.actualItemBrush = o;
                n.outline = r;
            }
        }
    }
    get_cy() {
        return false;
    }
    get actualMarkerBrush() {
        return this.m8;
    }
}
BubbleSeries.$t = markType(BubbleSeries, 'BubbleSeries', ScatterBase.$, [IScaleLegendSeries_$type, ISupportsSizeScale_$type, ISupportsFillScale_$type]);
BubbleSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BubbleSeries, 'raisePropertyChanged', ['FillMemberPath:pv:qe', [2], 'FillScale:pc:qf', [BrushScale.$], 'FillScaleUseGlobalValues:pm:qg', [0, false], 'LabelMemberPath:p0:qh', [2], 'MarkerBrushBrightness:ps:qi', [1, NaN], 'MarkerOutlineBrightness:pt:qj', [1, NaN], 'MarkerOutlineUsesFillScale:pn:qk', [0, false], 'RadiusMemberPath:p6:ql', [2, null], 'RadiusScale:pe:qm', [SizeScale.$], 'RadiusScaleUseGlobalValues:po:qn', [0, false]]);
/**
 * @hidden
 */
class CustomPaletteBrushScale extends BrushScale {
    constructor() {
        super();
    }
    getBrush1(a, b) {
        if (this.brushes == null || this.brushes.count == 0) {
            return null;
        }
        if (this.brushSelectionMode == 0) {
            return super.getBrush(a % this.brushes.count);
        }
        let c = BubbleSeries.pq(0, b - 1, 0, this.brushes.count - 1, a);
        return this.aa(c);
    }
    get_isReady() {
        return this.brushes != null && this.brushes.count > 0;
    }
}
CustomPaletteBrushScale.$t = markType(CustomPaletteBrushScale, 'CustomPaletteBrushScale', BrushScale.$);
CustomPaletteBrushScale.$$p = markDep(DependencyProperty, PropertyMetadata, CustomPaletteBrushScale, 'u', ['BrushSelectionMode', [BrushSelectionMode_$type, enumGetBox(BrushSelectionMode_$type, 0)]]);
/**
 * @hidden
 */
class BubbleSeriesView extends ScatterBaseView {
    constructor(a) {
        super(a);
        this.da = null;
        this.da = a;
        this.ct = new ScatterTrendLineManager();
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.by.mb = 2;
            this.e.bj = 4;
        }
    }
    cq() {
        return new BubbleMarkerManager((a) => this.cu.item(a), (a) => this.cs.nh.c.item(a), runOn(this, this.c4), runOn(this, this.cn), runOn(this, this.cv));
    }
    dc() {
        let a = this.cr;
        this.da.qd(a.n, a.o, this.br, this == this.e.bh);
        this.an();
    }
    dd() {
        let a = this.cr;
        this.da.qc(a.n);
    }
    db() {
        let a = this.cr;
        for (let b of fromEnum(a.n)) {
            let c = typeCast(DataContext.$, b.content);
            if (c != null) {
                c.itemBrush = null;
                c.outline = null;
            }
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.da.fx + "</span><br/><span>" + "(${item." + this.da.n4 + "}, ${item." + this.da.n8 + "})</span>";
        if (!stringIsNullOrEmpty(this.da.p6)) {
            a += "<span>, Radius: ${item." + this.da.p6 + "}</span>";
        }
        a += "</div>";
        return a;
    }
}
BubbleSeriesView.$t = markType(BubbleSeriesView, 'BubbleSeriesView', ScatterBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxCustomPaletteBrushScaleComponent_1;
/**
 * Represents a brush scale that uses index-based brush selection mode.
*/
const IgxCustomPaletteBrushScaleComponent_PROVIDERS = [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(() => IgxCustomPaletteBrushScaleComponent) }];
let IgxCustomPaletteBrushScaleComponent = IgxCustomPaletteBrushScaleComponent_1 = class IgxCustomPaletteBrushScaleComponent extends IgxBrushScaleComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new CustomPaletteBrushScale();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the brush selection mode.
    */
    get brushSelectionMode() {
        return this.i.brushSelectionMode;
    }
    set brushSelectionMode(v) {
        this.i.brushSelectionMode = ensureEnum(BrushSelectionMode_$type, v);
    }
    /**
     * Checks if this scale is ready for useage with a series
    */
    get isReady() {
        return this.i.isReady;
    }
    getBrush1(index, total) {
        let iv = this.i.getBrush1(index, total);
        return brushToString(iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCustomPaletteBrushScaleComponent.prototype, "brushSelectionMode", null);
IgxCustomPaletteBrushScaleComponent = IgxCustomPaletteBrushScaleComponent_1 = __decorate([
    Component({
        selector: 'igx-custom-palette-brush-scale',
        template: ``,
        providers: [{ provide: IgxBrushScaleComponent, useExisting: forwardRef(() => IgxCustomPaletteBrushScaleComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCustomPaletteBrushScaleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomPaletteBrushScaleModule = class IgxCustomPaletteBrushScaleModule {
};
IgxCustomPaletteBrushScaleModule = __decorate([
    NgModule({
        declarations: [IgxCustomPaletteBrushScaleComponent],
        imports: [CommonModule],
        exports: [IgxCustomPaletteBrushScaleComponent],
        entryComponents: []
    })
], IgxCustomPaletteBrushScaleModule);

/**
 * Represents the base class for all IgxDataChartComponent scatter series
*/
const IgxScatterBaseComponent_PROVIDERS = [{ provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterBaseComponent) }];
class IgxScatterBaseComponent extends IgxMarkerSeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if this series is a scatter series
    */
    get isScatter() {
        return this.i.c4;
    }
    /**
     * Gets or sets the effective x-axis for the current object.
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current object.
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    */
    get xMemberPath() {
        return this.i.n4;
    }
    set xMemberPath(v) {
        this.i.n4 = v;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    */
    get yMemberPath() {
        return this.i.n8;
    }
    set yMemberPath(v) {
        this.i.n8 = v;
    }
    /**
     * Gets or sets the trend type for the current scatter series.
    */
    get trendLineType() {
        return this.i.trendLineType;
    }
    set trendLineType(v) {
        this.i.trendLineType = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the brush to use to draw the trend line.
    */
    get trendLineBrush() {
        return brushToString(this.i.trendLineBrush);
    }
    set trendLineBrush(v) {
        this.i.trendLineBrush = stringToBrush(v);
    }
    /**
     * Gets the effective TrendLineBrush for this series.
    */
    get actualTrendLineBrush() {
        return brushToString(this.i.o5);
    }
    set actualTrendLineBrush(v) {
        this.i.o5 = stringToBrush(v);
    }
    /**
     * Gets or sets the thickness of the current scatter series object's trend line.
    */
    get trendLineThickness() {
        return this.i.trendLineThickness;
    }
    set trendLineThickness(v) {
        this.i.trendLineThickness = +v;
    }
    /**
     * Gets or sets the moving average period for the current scatter series object.
     * The typical, and initial, value for trend line period is 7.
    */
    get trendLinePeriod() {
        return this.i.trendLinePeriod;
    }
    set trendLinePeriod(v) {
        this.i.trendLinePeriod = +v;
    }
    /**
     * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
    */
    get markerCollisionAvoidance() {
        return this.i.ne;
    }
    set markerCollisionAvoidance(v) {
        this.i.ne = ensureEnum(CollisionAvoidanceType_$type, v);
    }
    /**
     * Gets or sets the Z-Index of the trend line.  Values greater than 1000 will result in the trend line being rendered in front of the series data.
    */
    get trendLineZIndex() {
        return this.i.ny;
    }
    set trendLineZIndex(v) {
        this.i.ny = +v;
    }
    /**
     * Gets or sets the maximum number of markerItems displayed by the current series.
     * If more than the specified number of markerItems are visible, the series will automatically
     * choose a representative set.
    */
    get maximumMarkers() {
        return this.i.nx;
    }
    set maximumMarkers(v) {
        this.i.nx = +v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    getSeriesValueMarkerBoundingBox(world) {
        let iv = this.i.l6(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.nu(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.nt(axis);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxScatterBaseComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxScatterBaseComponent.prototype, "yAxis", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterBaseComponent.prototype, "xMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterBaseComponent.prototype, "yMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterBaseComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterBaseComponent.prototype, "actualTrendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "markerCollisionAvoidance", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "trendLineZIndex", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterBaseComponent.prototype, "maximumMarkers", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxBubbleSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent bubble series.
*/
const IgxBubbleSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent) }];
let IgxBubbleSeriesComponent = IgxBubbleSeriesComponent_1 = class IgxBubbleSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new BubbleSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the radius mapping property for the current series object.
    */
    get radiusMemberPath() {
        return this.i.p6;
    }
    set radiusMemberPath(v) {
        this.i.p6 = v;
    }
    /**
     * Gets or sets the radius size scale for the bubbles.
    */
    get radiusScale() {
        if (this.i.pe == null) {
            return null;
        }
        if (!this.i.pe.externalObject) {
            let e = IgxSizeScaleComponent._createFromInternal(this.i.pe);
            if (e) {
                e._implementation = this.i.pe;
            }
            this.i.pe.externalObject = e;
        }
        return this.i.pe.externalObject;
    }
    set radiusScale(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.pe = null : this.i.pe = v.i;
    }
    /**
     * Gets or sets the Label mapping property for the current series object.
    */
    get labelMemberPath() {
        return this.i.p0;
    }
    set labelMemberPath(v) {
        this.i.p0 = v;
    }
    /**
     * Gets or sets the fill mapping property for the current series object.
    */
    get fillMemberPath() {
        return this.i.pv;
    }
    set fillMemberPath(v) {
        this.i.pv = v;
    }
    /**
     * Gets or sets the brush scale for the fill brush of markers.
    */
    get fillScale() {
        if (this.i.pc == null) {
            return null;
        }
        if (!this.i.pc.externalObject) {
            let e = IgxBrushScaleComponent._createFromInternal(this.i.pc);
            if (e) {
                e._implementation = this.i.pc;
            }
            this.i.pc.externalObject = e;
        }
        return this.i.pc.externalObject;
    }
    set fillScale(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.pc = null : this.i.pc = v.i;
    }
    /**
     * Gets or sets whether or not the FillScale uses global min/max values of FillMemberPath from multiple series.
     * This setting applies only if multiple series are using the same FillScale.
    */
    get fillScaleUseGlobalValues() {
        return this.i.pm;
    }
    set fillScaleUseGlobalValues(v) {
        this.i.pm = ensureBool(v);
    }
    /**
     * Gets or sets whether or not the marker outline should use FillScale like the marker fill does.
     * This setting applies only if the current series has a FillScale set and it overrides MarkerOutline setting.
    */
    get markerOutlineUsesFillScale() {
        return this.i.pn;
    }
    set markerOutlineUsesFillScale(v) {
        this.i.pn = ensureBool(v);
    }
    /**
     * Gets or sets brightness of the marker outline. Using negative value will change marker outline to darker color and positive value will change marker outline to brighter color
     * Note you can use any values between minimum value of -1 (darkest outline) and maximum value of 1 (brightest outline)
    */
    get markerOutlineBrightness() {
        return this.i.pt;
    }
    set markerOutlineBrightness(v) {
        this.i.pt = +v;
    }
    /**
     * Gets or sets brightness of the marker fill. Using negative value will change marker fill to darker color and positive value will change marker fill to brighter color
     * Note you can use any values between minimum value of -1 (darkest fill) and maximum value of 1 (brightest fill)
    */
    get markerBrushBrightness() {
        return this.i.ps;
    }
    set markerBrushBrightness(v) {
        this.i.ps = +v;
    }
    /**
     * Gets or sets the whether or not the RadiusScale uses global values of RadiusMemberPath from multiple series.
     * This setting applies only if multiple series are using the same RadiusScale.
    */
    get radiusScaleUseGlobalValues() {
        return this.i.po;
    }
    set radiusScaleUseGlobalValues(v) {
        this.i.po = ensureBool(v);
    }
    /**
     * Overridden by derived series classes to indicate when marker-less display is preferred or not.
    */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.radiusScale && this.radiusScale.name && this.radiusScale.name == name) {
            return this.radiusScale;
        }
        if (this.fillScale && this.fillScale.name && this.fillScale.name == name) {
            return this.fillScale;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.radiusScale && this.radiusScale._styling) {
            this.radiusScale._styling(container, component, this);
        }
        if (this.fillScale && this.fillScale._styling) {
            this.fillScale._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxBubbleSeriesComponent.prototype, "radiusMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxSizeScaleComponent),
    __metadata("design:paramtypes", [IgxSizeScaleComponent])
], IgxBubbleSeriesComponent.prototype, "radiusScale", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxBubbleSeriesComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxBubbleSeriesComponent.prototype, "fillMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxBrushScaleComponent),
    __metadata("design:paramtypes", [IgxBrushScaleComponent])
], IgxBubbleSeriesComponent.prototype, "fillScale", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxBubbleSeriesComponent.prototype, "fillScaleUseGlobalValues", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxBubbleSeriesComponent.prototype, "markerOutlineUsesFillScale", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBubbleSeriesComponent.prototype, "markerOutlineBrightness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBubbleSeriesComponent.prototype, "markerBrushBrightness", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxBubbleSeriesComponent.prototype, "radiusScaleUseGlobalValues", null);
IgxBubbleSeriesComponent = IgxBubbleSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-bubble-series',
        template: ``,
        providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBubbleSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBubbleSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBubbleSeriesModule = class IgxBubbleSeriesModule {
};
IgxBubbleSeriesModule = __decorate([
    NgModule({
        declarations: [IgxBubbleSeriesComponent],
        imports: [CommonModule, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule],
        exports: [IgxBubbleSeriesComponent, IgxSizeScaleModule, IgxBrushScaleModule, IgxValueBrushScaleModule, IgxCustomPaletteBrushScaleModule],
        entryComponents: []
    })
], IgxBubbleSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBubbleSeriesDynamicModule = class IgxBubbleSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBubbleSeriesComponent", IgxBubbleSeriesComponent);
        TypeRegistrar.register("BubbleSeries", BubbleSeries.$type);
    }
};
IgxBubbleSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBubbleSeriesModule],
        exports: [IgxBubbleSeriesModule],
        entryComponents: [IgxBubbleSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBubbleSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterSeries extends ScatterBase {
    constructor() {
        super();
        this.ab = ScatterSeries.$;
        this.nm = new ScatterFrame();
        this.no = new ScatterFrame();
        this.nl = new ScatterFrame();
    }
    bf() {
        return new ScatterSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.pa = a;
    }
    get_cy() {
        return false;
    }
}
ScatterSeries.$t = markType(ScatterSeries, 'ScatterSeries', ScatterBase.$);
/**
 * @hidden
 */
class ScatterSeriesView extends ScatterBaseView {
    constructor(a) {
        super(a);
        this.da = null;
        this.da = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.by.mb = 2;
            this.e.bj = 4;
        }
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 2;
        this.e.ex = 2;
        this.e.du = false;
    }
}
ScatterSeriesView.$t = markType(ScatterSeriesView, 'ScatterSeriesView', ScatterBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScatterSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent scatter series
*/
const IgxScatterSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent) }];
let IgxScatterSeriesComponent = IgxScatterSeriesComponent_1 = class IgxScatterSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Overridden by derived series classes to indicate when markerless display is preferred or not.
    */
    get isMarkerlessDisplayPreferred() {
        return this.i.cy;
    }
};
IgxScatterSeriesComponent = IgxScatterSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-series',
        template: ``,
        providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterSeriesModule = class IgxScatterSeriesModule {
};
IgxScatterSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterSeriesComponent],
        entryComponents: []
    })
], IgxScatterSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterSeriesDynamicModule = class IgxScatterSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterSeriesComponent", IgxScatterSeriesComponent);
        TypeRegistrar.register("ScatterSeries", ScatterSeries.$type);
    }
};
IgxScatterSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterSeriesModule],
        exports: [IgxScatterSeriesModule],
        entryComponents: [IgxScatterSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterLineSeriesView extends ScatterBaseView {
    constructor(a) {
        super(a);
        this.da = new Path();
    }
    a8() {
        super.a8();
        this.da._stroke = this.e.lb;
        this.da.ac = this.e.ey;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.da);
        }
    }
    c0(a) {
        super.c0(a);
        this.da.ak = null;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.da, "shape", ["Main"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
ScatterLineSeriesView.$t = markType(ScatterLineSeriesView, 'ScatterLineSeriesView', ScatterBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterLineSeries extends ScatterBase {
    constructor() {
        super();
        this.ab = ScatterLineSeries.$;
        this.nm = new ScatterFrame();
        this.no = new ScatterFrame();
        this.nl = new ScatterFrame();
        let a = (b, c, d) => {
            let e = this.bz.indexOf(b.a);
            if (e == -1 || e == 0) {
                return b;
            }
            let f = this.bz.item(e - 1);
            let g;
            if (!((() => { let h = c.g.tryGetValue(f, g); g = h.p1; return h.ret; })())) {
                return b;
            }
            return g;
        };
        this.nm.o = a;
        this.no.o = a;
        this.nl.o = a;
    }
    bf() {
        return new ScatterLineSeriesView(this);
    }
    dh(a, b) {
        if (this.me(a, b)) {
            return true;
        }
        if (this.pb(a, b)) {
            return true;
        }
        return false;
    }
    pb(a, b) {
        let c = this.bi;
        let d = c.da;
        return this.di(a, b, d.ak);
    }
    of(a, b) {
        super.of(a, b);
        a.m.clear();
        a.u.clear();
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.eu * this.eu;
        let g = 0;
        if (this.nq != null) {
            g = this.nq.count;
        }
        if (this.ns != null) {
            g = Math.min(this.ns.count, g);
        }
        let h = new ScalerParams(0, c, d, this.nh.d, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, this.nh.e, e);
            $ret.b = this.eh();
            return $ret;
        })());
        let j = arrayShallowClone(this.nq.asArray());
        let k = arrayShallowClone(this.ns.asArray());
        this.xAxis.gs(boxArray$1(j), 0, j.length, h);
        this.yAxis.gs(boxArray$1(k), 0, k.length, i);
        let l = d.top - 10;
        let m = d.bottom + 10;
        let n = d.left - 10;
        let o = d.right + 10;
        let p = ((() => {
            let $ret = new Clipper(1, n, m, o, l, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (let q = 0; q < g;) {
            let r = q;
            ++q;
            if (g > this.nx) {
                while (q < g) {
                    let s = j[q] - j[r];
                    let t = k[q] - k[r];
                    let u = s * s + t * t;
                    if (u >= f) {
                        break;
                    }
                    ++q;
                }
                p.j(this.pi(j, k, r, q - 1));
            }
            else {
                let v = new OwnedPoint();
                v.c = { $type: Point_$type, x: j[r], y: k[r] };
                v.a = this.bz.item(r);
                if (!a.u.containsKey(v.a)) {
                    a.u.addItem(v.a, v);
                }
            }
        }
        if (g > this.nx) {
            p.i = null;
        }
    }
    pi(a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a[c], y: b[c] };
        }
        let e = 0;
        let f = 0;
        let g = (d - c + 1);
        for (let h = c; h <= d; ++h) {
            e += a[h];
            f += b[h];
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    }
    oo(a, b) {
        b.c0(false);
        super.oo(a, b);
        let c = new Rect(0, b.br.left, b.br.top, b.br.width, b.br.height);
        c = RectUtil.t(c, this.ey, this.ey);
        this.oj(a, new Clipper(0, c, false));
        let d = typeCast(ScatterLineSeriesView.$, b);
        this.pg(d.da, a.m.count, (e) => a.m._inner[e].x, (e) => a.m._inner[e].y, this.pa, this.eu);
    }
    pg(a, b, c, d, e, f) {
        let g = new PathGeometry();
        a.ak = g;
        g.c = new PathFigureCollection();
        let h = new List$1(PolyLineSegment.$, 0);
        let i = 0;
        for (let j = 0; j < b; j++) {
            if (isNaN_(c(j)) || isNaN_(d(j))) {
                let k = j - i;
                if (k > 0) {
                    if (e == 1 || h.count == 0) {
                        let l = new PolyLineSegment();
                        h.add(l);
                    }
                    this.pf(h._inner[h.count - 1]._points, i, j - 1, c, d, f);
                }
                i = j + 1;
            }
        }
        if (e == 1 || h.count == 0) {
            let m = new PolyLineSegment();
            h.add(m);
        }
        this.pf(h._inner[h.count - 1]._points, i, b - 1, c, d, f);
        for (let n = 0; n < h.count; n++) {
            let o = h._inner[n];
            if (o._points.count > 0) {
                let p = ((() => {
                    let $ret = new PathFigure();
                    $ret.startPoint = o._points._inner[0];
                    return $ret;
                })());
                p._segments.add(o);
                g.c.add(p);
            }
        }
    }
    pc(a, b, c, d, e, f) {
        let g = new List$1(Number_$type, 0);
        let h = d;
        let i = e;
        let j = i - h + 1;
        while (j > 0) {
            if (j <= 512) {
                Flattener.c(g, b, c, h, i, f);
                h = i + 1;
            }
            else {
                let k = h + 512 - 1;
                Flattener.c(g, b, c, h, k, f);
                h = k + 1;
            }
            j = i - h + 1;
        }
        return g;
    }
    pf(a, b, c, d, e, f) {
        if (c > -1) {
            let g = this.eu;
            let h = this.pc(new List$1(Number_$type, 0), d, e, b, c, g);
            let i;
            for (let j = 0; j < h.count; j++) {
                i = h.item(j);
                a.add({ $type: Point_$type, x: d(i), y: e(i) });
            }
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ScatterLineSeries.$$p[0]:
                this.jl(false);
                this.it();
                break;
        }
    }
}
ScatterLineSeries.$t = markType(ScatterLineSeries, 'ScatterLineSeries', ScatterBase.$);
ScatterLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterLineSeries, 'raisePropertyChanged', ['UnknownValuePlotting:pa:ph', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);

var IgxScatterLineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent scatter line series
*/
const IgxScatterLineSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent) }];
let IgxScatterLineSeriesComponent = IgxScatterLineSeriesComponent_1 = class IgxScatterLineSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Determines how unknown values will be plotted on the chart.
     * Null and Double.NaN are two examples of unknown values.
    */
    get unknownValuePlotting() {
        return this.i.pa;
    }
    set unknownValuePlotting(v) {
        this.i.pa = ensureEnum(UnknownValuePlotting_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterLineSeriesComponent.prototype, "unknownValuePlotting", null);
IgxScatterLineSeriesComponent = IgxScatterLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-line-series',
        template: ``,
        providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterLineSeriesModule = class IgxScatterLineSeriesModule {
};
IgxScatterLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterLineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterLineSeriesComponent],
        entryComponents: []
    })
], IgxScatterLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterLineSeriesDynamicModule = class IgxScatterLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterLineSeriesComponent", IgxScatterLineSeriesComponent);
        TypeRegistrar.register("ScatterLineSeries", ScatterLineSeries.$type);
    }
};
IgxScatterLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterLineSeriesModule],
        exports: [IgxScatterLineSeriesModule],
        entryComponents: [IgxScatterLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterSplineSeriesView extends ScatterBaseView {
    constructor(a) {
        super(a);
        this.da = new Path();
    }
    a8() {
        super.a8();
        this.da._stroke = this.e.lb;
        this.da.ac = this.e.ey;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.da);
        }
    }
    c0(a) {
        super.c0(a);
        this.da.ak = null;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.da, "shape", ["Main"]);
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 3;
        this.e.ew = 1;
        this.e.ex = 4;
        this.e.du = false;
    }
}
ScatterSplineSeriesView.$t = markType(ScatterSplineSeriesView, 'ScatterSplineSeriesView', ScatterBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterSplineSeries extends ScatterBase {
    constructor() {
        super();
        this.ab = ScatterSplineSeries.$;
        this.nm = new ScatterFrame();
        this.no = new ScatterFrame();
        this.nl = new ScatterFrame();
    }
    bf() {
        return new ScatterSplineSeriesView(this);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ScatterSplineSeries.$$p[0]:
                this.jl(false);
                this.it();
                break;
        }
    }
    bd() {
        if (this.be == 0) {
            return 2;
        }
        else {
            return super.bd();
        }
    }
    of(a, b) {
        super.of(a, b);
        a.m.clear();
        a.u.clear();
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = this.eu * this.eu;
        let g = Math.min(this.nq != null ? this.nq.count : 0, this.ns != null ? this.ns.count : 0);
        let h = new ScalerParams(0, c, d, this.nh.d, e);
        let i = ((() => {
            let $ret = new ScalerParams(0, c, d, this.nh.e, e);
            $ret.b = this.eh();
            return $ret;
        })());
        let j = (k) => this.nh.a.dy(this.nq.item(k), h);
        let k = (l) => this.nh.b.dy(this.ns.item(l), i);
        let l = ((() => {
            let $ret = new Clipper(0, d, false);
            $ret.i = a.m;
            return $ret;
        })());
        for (let m = 0; m < g;) {
            let n = m;
            ++m;
            while (m < g && this.pa(j, k, n, m) < f) {
                ++m;
            }
            if (g > this.nx) {
                l.j(this.pe(j, k, n, m - 1));
            }
            else {
                let o = new OwnedPoint();
                o.c = { $type: Point_$type, x: j(n), y: k(n) };
                o.a = this.bz.item(n);
                if (!a.u.containsKey(o.a)) {
                    a.u.addItem(o.a, o);
                }
            }
        }
        if (g > this.nx) {
            l.i = null;
        }
    }
    pe(a, b, c, d) {
        if (c == d) {
            return { $type: Point_$type, x: a(c), y: b(c) };
        }
        let e = 0;
        let f = 0;
        let g = (d - c + 1);
        for (let h = c; h <= d; ++h) {
            e += a(h);
            f += b(h);
        }
        return { $type: Point_$type, x: e / g, y: f / g };
    }
    pa(a, b, c, d) {
        let e = a(d) - a(c);
        let f = b(d) - b(c);
        return e * e + f * f;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = typeCast(ScatterSplineSeriesView.$, b);
        c.c0(false);
    }
    oo(a, b) {
        this.h3(false, b);
        super.oo(a, b);
        this.oi(a);
        let c = typeCast(ScatterSplineSeriesView.$, b);
        c.da.ak = new PathGeometry();
        c.da.ak.c = Numeric.h(a.m.count, (d) => a.m._inner[d].x, (d) => a.m._inner[d].y, this.pb);
    }
}
ScatterSplineSeries.$t = markType(ScatterSplineSeries, 'ScatterSplineSeries', ScatterBase.$);
ScatterSplineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterSplineSeries, 'raisePropertyChanged', ['Stiffness:pb:pd', [1, 0.5]]);

var IgxScatterSplineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent scatter spline series
*/
const IgxScatterSplineSeriesComponent_PROVIDERS = [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent) }];
let IgxScatterSplineSeriesComponent = IgxScatterSplineSeriesComponent_1 = class IgxScatterSplineSeriesComponent extends IgxScatterBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterSplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the Stiffness property.
    */
    get stiffness() {
        return this.i.pb;
    }
    set stiffness(v) {
        this.i.pb = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterSplineSeriesComponent.prototype, "stiffness", null);
IgxScatterSplineSeriesComponent = IgxScatterSplineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-spline-series',
        template: ``,
        providers: [{ provide: IgxScatterBaseComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterSplineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterSplineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterSplineSeriesModule = class IgxScatterSplineSeriesModule {
};
IgxScatterSplineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterSplineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterSplineSeriesComponent],
        entryComponents: []
    })
], IgxScatterSplineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterSplineSeriesDynamicModule = class IgxScatterSplineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterSplineSeriesComponent", IgxScatterSplineSeriesComponent);
        TypeRegistrar.register("ScatterSplineSeries", ScatterSplineSeries.$type);
    }
};
IgxScatterSplineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterSplineSeriesModule],
        exports: [IgxScatterSplineSeriesModule],
        entryComponents: [IgxScatterSplineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterSplineSeriesDynamicModule);

/**
 * Provides information about the progressive load progress of the HighDensityScatterSeries.
*/
class IgxProgressiveLoadStatusEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The current status from 0 to 100 of the progressive load.
    */
    get currentStatus() {
        return this.i.currentStatus;
    }
    set currentStatus(v) {
        this.i.currentStatus = +v;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KDTreeNode2D extends Base {
    constructor() {
        super(...arguments);
        this.g = false;
        this.f = false;
        this.h = 0;
        this.b = null;
        this.c = null;
        this.d = null;
        this.a = null;
        this.e = null;
    }
}
KDTreeNode2D.$t = markType(KDTreeNode2D, 'KDTreeNode2D');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KDTreeThunk extends Base {
    constructor() {
        super(...arguments);
        this.e = 0;
        this.b = 0;
        this.c = 0;
        this.d = 0;
        this.a = null;
    }
}
KDTreeThunk.$t = markType(KDTreeThunk, 'KDTreeThunk');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KNearestResult extends Base {
    constructor() {
        super(...arguments);
        this.e = 0;
        this.b = false;
        this.c = 0;
        this.d = 0;
        this.a = null;
    }
}
KNearestResult.$t = markType(KNearestResult, 'KNearestResult');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SearchData extends Base {
    constructor() {
        super(...arguments);
        this.a = false;
        this.d = 0;
        this.b = 0;
        this.e = 0;
        this.c = 0;
    }
}
SearchData.$t = markType(SearchData, 'SearchData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KDTree2D extends Base {
    constructor(a, ..._rest) {
        super();
        this.a = null;
        this.h = null;
        this.g = null;
        this.k = 0;
        this.o = {};
        this.progressiveThunkCompleted = null;
        this.e = false;
        this.q = new Random(0);
        this.d = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    this.d = this.c(c, 0, c.length - 1, 0, d);
                }
                break;
            case 1: break;
        }
    }
    get p() {
        return this.o;
    }
    static b(a, b) {
        let c = new KDTree2D(1);
        c.d = new KDTreeNode2D();
        c.d.g = true;
        c.a = a;
        c.h = new Stack$1(KDTreeThunk.$);
        c.g = new List$1(KDTreeThunk.$, 0);
        let d = new KDTreeThunk();
        d.e = 0;
        d.b = a.length - 1;
        d.c = 0;
        d.d = b;
        d.a = c.d;
        c.h.h(d);
        return c;
    }
    f(a) {
        if (this.h.f == 0 && this.g.count == 0) {
            this.a = null;
            return false;
        }
        if (this.h.f == 0 && this.g.count > 0) {
            return true;
        }
        this.k = this.h.d().c;
        while (this.h.f > 0 && this.h.d().c == this.k) {
            this.g.add(this.h.e());
        }
        if (a != null) {
            a.setTimeout(runOn(this, this.y), 0);
        }
        else {
            window.setTimeout(runOn(this, this.y), 0);
        }
        return true;
    }
    s() {
        this.e = true;
    }
    y() {
        let a;
        for (let b = 0; b < this.g.count; b++) {
            if (this.e || this.a == null) {
                return;
            }
            if (this.a.length == 0) {
                continue;
            }
            a = this.g._inner[b];
            this.v(a.a, this.a, a.e, a.b, a.c, a.d);
        }
        this.g.clear();
        if (this.progressiveThunkCompleted != null) {
            this.progressiveThunkCompleted(this, new EventArgs());
        }
    }
    v(a, b, c, d, e, f) {
        a.g = false;
        a.f = (e % 2) == 0;
        a.h = (d - c);
        if (c == d) {
            a.b = b[c];
            return;
        }
        if (c > d) {
            a.g = true;
            return;
        }
        if ((d - c) + 1 <= f) {
            a.b = b[c];
            a.a = new Array((d - c) + 1);
            let g = 0;
            for (let h = c; h <= d; h++) {
                a.a[g++] = b[h];
            }
            return;
        }
        let i = Math.max(intDivide((d - c), 2), 1);
        let j = this.m(b, c, d, a.f, i);
        a.b = b[j];
        if (c <= j - 1) {
            a.c = ((() => {
                let $ret = new KDTreeNode2D();
                $ret.g = true;
                return $ret;
            })());
            a.c.h = ((j - 1) - c) + 1;
            this.h.h(((() => {
                let $ret = new KDTreeThunk();
                $ret.e = c;
                $ret.b = j - 1;
                $ret.c = e + 1;
                $ret.d = f;
                $ret.a = a.c;
                return $ret;
            })()));
        }
        else {
            a.c = null;
        }
        if (j + 1 <= d) {
            a.d = ((() => {
                let $ret = new KDTreeNode2D();
                $ret.g = true;
                return $ret;
            })());
            a.d.h = (d - (j + 1)) + 1;
            this.h.h(((() => {
                let $ret = new KDTreeThunk();
                $ret.e = j + 1;
                $ret.b = d;
                $ret.c = e + 1;
                $ret.d = f;
                $ret.a = a.d;
                return $ret;
            })()));
        }
        else {
            a.d = null;
        }
    }
    c(a, b, c, d, e) {
        let f = new KDTreeNode2D();
        f.f = (d % 2) == 0;
        f.h = (c - b);
        if (b == c) {
            f.b = a[b];
            return f;
        }
        if (b > c) {
            return null;
        }
        if ((c - b) + 1 <= e) {
            f.b = a[b];
            f.a = new Array(c - b + 1);
            let g = 0;
            for (let h = b; h <= c; h++) {
                f.a[g++] = a[h];
            }
            return f;
        }
        let i = Math.max(intDivide((c - b), 2), 1);
        let j = this.m(a, b, c, f.f, i);
        f.b = a[j];
        f.c = this.c(a, b, j - 1, d + 1, e);
        f.d = this.c(a, j + 1, c, d + 1, e);
        return f;
    }
    l(a, b, c, d, e) {
        let f = b ? a[e].a : a[e].b;
        let g = a[e];
        a[e] = a[d];
        a[d] = g;
        let h = c;
        for (let i = c; i < d; i++) {
            let j;
            if (b) {
                j = a[i].a;
            }
            else {
                j = a[i].b;
            }
            if (j <= f) {
                g = a[h];
                a[h] = a[i];
                a[i] = g;
                h++;
            }
        }
        g = a[d];
        a[d] = a[h];
        a[h] = g;
        return h;
    }
    m(a, b, c, d, e) {
        if (b == c) {
            return b;
        }
        let f = this.q.next2(b, c);
        let g = this.l(a, d, b, c, f);
        let h = g - b + 1;
        if (h == e) {
            return g;
        }
        else if (e < h) {
            return this.m(a, b, g - 1, d, e);
        }
        else {
            return this.m(a, g + 1, c, d, e - h);
        }
    }
    w(a, b, c, d) {
        this.x(a, b, c, d, this.d);
    }
    x(a, b, c, d, e) {
        if (e == null || e.g) {
            return;
        }
        if (e.c == null && e.d == null) {
            this.r(a, b, c, e, e.b, true, 0, d);
            if (a.a) {
                return;
            }
            if (e.a != null && e.a.length > 0) {
                for (let f = 0; f < e.a.length; f++) {
                    this.r(a, b, c, e, e.a[f], false, f, d);
                    if (a.a) {
                        return;
                    }
                }
            }
            return;
        }
        this.r(a, b, c, e, e.b, true, 0, d);
        if (a.a) {
            return;
        }
        if (e.f) {
            if (b <= e.b.a) {
                this.x(a, b, c, d, e.c);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, e.b.a, c) < a.c) {
                    this.x(a, b, c, d, e.d);
                }
                if (a.a) {
                    return;
                }
            }
            else {
                this.x(a, b, c, d, e.d);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, e.b.a, c) < a.c) {
                    this.x(a, b, c, d, e.c);
                }
                if (a.a) {
                    return;
                }
            }
        }
        else {
            if (c <= e.b.b) {
                this.x(a, b, c, d, e.c);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, b, e.b.b) < a.c) {
                    this.x(a, b, c, d, e.d);
                }
                if (a.a) {
                    return;
                }
            }
            else {
                this.x(a, b, c, d, e.d);
                if (a.a) {
                    return;
                }
                if (this.i(b, c, b, e.b.b) < a.c) {
                    this.x(a, b, c, d, e.c);
                }
                if (a.a) {
                    return;
                }
            }
        }
    }
    r(a, b, c, d, e, f, g, h) {
        if (a.a) {
            return;
        }
        if (a.e > a.f) {
            a.a = true;
            return;
        }
        if (a.b.count < h) {
            if (isNaN_(a.d)) {
                a.d = this.i(b, c, e.a, e.b);
                a.c = a.d;
                a.g = 0;
            }
            a.b.add(((() => {
                let $ret = new KNearestResult();
                $ret.b = f;
                $ret.e = g;
                $ret.a = d;
                $ret.c = e.a;
                $ret.d = e.b;
                return $ret;
            })()));
            a.e++;
            let i = this.i(b, c, e.a, e.b);
            if (i < a.d) {
                a.d = i;
            }
            if (i > a.c) {
                a.c = i;
                a.g = a.b.count - 1;
            }
            return;
        }
        let j = 0;
        if (j < a.c) {
            if (j < a.d) {
                a.d = j;
            }
            a.b._inner[a.g] = ((() => {
                let $ret = new KNearestResult();
                $ret.b = f;
                $ret.e = g;
                $ret.a = d;
                $ret.c = e.a;
                $ret.d = e.b;
                return $ret;
            })());
            let k = 0;
            let l = 0;
            for (let m = 0; m < a.b.count; m++) {
                let n = this.i(b, c, a.b._inner[m].c, a.b._inner[m].d);
                if (n > k) {
                    k = n;
                    l = m;
                }
            }
            a.e++;
        }
    }
    i(a, b, c, d) {
        return (a - c) * (a - c) + (b - d) * (b - d);
    }
    t(a, b, c, d, e, f) {
        this.u(a, this.d, b, c, d, e, f, false, 0);
    }
    u(a, b, c, d, e, f, g, h, i) {
        if (b == null) {
            return;
        }
        let j = b.e;
        if (i > c.g || ((g - f) < c.f && (e - d) < c.e)) {
            if (b.e == null) {
                b.e = new SearchData();
            }
            j = b.e;
            j.a = true;
            j.d = d;
            j.b = e;
            j.e = f;
            j.c = g;
            a.add(b);
            return;
        }
        if (j != null) {
            j.a = false;
        }
        if (b.c == null && b.d == null) {
            a.add(b);
            return;
        }
        let k;
        let l;
        let m;
        let n;
        let o;
        let p;
        let q;
        let r;
        if (b.f) {
            k = d;
            l = b.b.a;
            m = f;
            n = g;
            o = b.b.a;
            p = e;
            q = f;
            r = g;
        }
        else {
            k = d;
            l = e;
            m = f;
            n = b.b.b;
            o = d;
            p = e;
            q = b.b.b;
            r = g;
        }
        if (h) {
            a.add(b);
            this.u(a, b.c, c, k, l, m, n, true, i + 1);
            this.u(a, b.d, c, o, p, q, r, true, i + 1);
        }
        else {
            let s = false;
            if (k >= c.c && l <= c.a && m >= c.d && n <= c.b) {
                s = true;
                a.add(b);
                this.u(a, b.c, c, k, l, m, n, true, i + 1);
            }
            else if (!(c.c > l || c.a < k || c.d > n || c.b < m)) {
                s = true;
                a.add(b);
                this.u(a, b.c, c, k, l, m, n, false, i + 1);
            }
            if (o >= c.c && p <= c.a && q >= c.d && r <= c.b) {
                if (!s) {
                    a.add(b);
                }
                this.u(a, b.d, c, o, p, q, r, true, i + 1);
            }
            else if (!(c.c > p || c.a < o || c.d > r || c.b < q)) {
                if (!s) {
                    a.add(b);
                }
                this.u(a, b.d, c, o, p, q, r, false, i + 1);
            }
        }
    }
    z() {
        this.n(this.d);
    }
    n(a) {
        if (a == null) {
            return 0;
        }
        if (this.n(a.c) + this.n(a.d) != a.h) {
            let b = 0;
        }
        return a.h + 1;
    }
}
KDTree2D.$t = markType(KDTree2D, 'KDTree2D');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KDPointData extends Base {
    constructor() {
        super(...arguments);
        this.a = 0;
        this.b = 0;
        this.c = 0;
    }
}
KDPointData.$t = markType(KDPointData, 'KDPointData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ProgressiveLoadStatusEventArgs extends EventArgs {
    constructor(a) {
        super();
        this._currentStatus = 0;
        this.currentStatus = a;
    }
    get currentStatus() {
        return this._currentStatus;
    }
    set currentStatus(a) {
        this._currentStatus = a;
    }
}
ProgressiveLoadStatusEventArgs.$t = markType(ProgressiveLoadStatusEventArgs, 'ProgressiveLoadStatusEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SearchArgs extends Base {
    constructor() {
        super(...arguments);
        this.c = 0;
        this.d = 0;
        this.a = 0;
        this.b = 0;
        this.e = 0;
        this.f = 0;
        this.g = 0;
    }
}
SearchArgs.$t = markType(SearchArgs, 'SearchArgs');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HighDensityScatterSeries extends Series {
    constructor() {
        super();
        this.mn = null;
        this.mp = null;
        this.nv = 0;
        this.mr = false;
        this.nb = 0;
        this.na = 0;
        this.m9 = 0;
        this.m8 = 255;
        this.m7 = 0;
        this.m6 = 0;
        this.ne = 255;
        this.nd = 0;
        this.nc = 0;
        this.mf = null;
        this.mk = null;
        this.ml = null;
        this.mg = null;
        this.mi = null;
        this.mt = false;
        this.nw = 0;
        this.ny = 0;
        this.ns = 0;
        this.nr = 0;
        this.progressiveLoadStatusChanged = null;
        this.my = null;
        this.m4 = 0;
        this.m3 = 0;
        this.m5 = 0;
        this.nh = 0;
        this.nf = 0;
        this.ng = 0;
        this.ni = 0;
        this.nk = 0;
        this.nm = 0;
        this.nl = 0;
        this.nj = 0;
        this.m0 = 0;
        this.m1 = 0;
        this.m2 = 0;
        this.mz = 0;
        this.nu = 0;
        this.nt = 0;
        this.mc = null;
        this.nx = 0;
        this.ms = false;
        this._itemIndexes = null;
        this.md = null;
        this.ma = null;
        this.mm = null;
        this.ab = HighDensityScatterSeries.$;
        this.c7 = false;
    }
    get_c4() {
        return true;
    }
    get mo() {
        return this.mn;
    }
    set mo(a) {
        if (this.mn != a) {
            let b = this.mo;
            this.mn = a;
            this.raisePropertyChanged("XColumn", b, this.mo);
        }
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == HighDensityScatterSeries.$$p[8]) {
            return this.ft(a, b, this.od);
        }
        if (c == HighDensityScatterSeries.$$p[10]) {
            return this.ft(a, b, this.oh);
        }
        return super.fs(a, b);
    }
    get mq() {
        return this.mp;
    }
    set mq(a) {
        if (this.mp != a) {
            let b = this.mq;
            this.mp = a;
            this.raisePropertyChanged("YColumn", b, this.mq);
        }
    }
    ov() {
        if (this.mf == null) {
            return;
        }
        this.mf.s();
        let a = this.mf;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.oj));
        this.mf = null;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (this.bs != null) {
                    let e = this.getEffectiveViewport1(this.bi);
                    this.ms = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.ov();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.mo);
                    c.deregisterColumn(this.mq);
                    this.mo = null;
                    this.mq = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.mo = this.bw(this.od);
                    this.mq = this.bw(this.oh);
                }
                if ((this.mj != null && !this.mj.cn()) || (this.mh != null && !this.mh.cn())) {
                    this.jl(false);
                }
                this.iu();
                break;
            case HighDensityScatterSeries.$$p[7]:
                let f = this.mg;
                this.mg = this.mh;
                this.ov();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.om));
                }
                if (this.mg != null) {
                    let g = this.mg;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.om));
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if ((this.mh != null && !this.mh.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                break;
            case HighDensityScatterSeries.$$p[9]:
                let h = this.mi;
                this.mi = this.mj;
                this.ov();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.om));
                }
                if (this.mi != null) {
                    let i = this.mi;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.om));
                }
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if ((this.mj != null && !this.mj.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                break;
            case "MouseOverEnabled":
                this.mt = this.c7;
                this.jl(false);
                break;
            case HighDensityScatterSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mo);
                    this.mo = this.bw(this.od);
                }
                break;
            case "XColumn":
                this.ov();
                if (this.mh != null && !this.mh.cn()) {
                    this.jl(false);
                }
                this.iu();
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mq);
                    this.mq = this.bw(this.oh);
                }
                break;
            case "YColumn":
                this.ov();
                if (this.mj != null && !this.mj.cn()) {
                    this.jl(false);
                }
                this.iu();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.ov();
                this.jl(false);
                this.it();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.jl(false);
                this.it();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.jl(false);
                this.it();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.me.by(this.pa, this.o9)) {
                    return;
                }
                this.nb = this.pa.o;
                this.na = this.pa.n;
                this.m9 = this.pa.m;
                this.m8 = this.o9.o;
                this.m7 = this.o9.n;
                this.m6 = this.o9.m;
                this.ne = this.m8 - this.nb;
                this.nd = this.m7 - this.na;
                this.nc = this.m6 - this.m9;
                this.jl(false);
                this.it();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.nv = Math.max(typeGetValue(d) - 1, 0);
                this.mr = this.nv > 0;
                this.jl(false);
                this.it();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.jl(false);
                this.it();
                break;
        }
    }
    mv(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    mu(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    om(a, b) {
        this.ov();
        this.jl(false);
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        if (this.mj == null || this.mh == null || this.mh.bh == null || this.mj.bh == null || this.mq == null || this.mo == null || this.mq.count < 1 || this.mo.count < 1 || this.mq.count != this.mo.count || this.mh.kc == this.mh.kb || this.mj.kc == this.mj.kb || this.l8.isEmpty) {
            d = false;
        }
        return d;
    }
    get n2() {
        return this.nw;
    }
    set n2(a) {
        let b = this.nw;
        this.nw = a;
        this.raisePropertyChanged("ProgressiveStatus", b, this.nw);
    }
    jm(a) {
        super.jm(a);
        this.oo(a, this.bi);
    }
    oo(a, b) {
        if (this.cc(b)) {
            return;
        }
        if (this.mf == null && !this.mx) {
            let c = new List$1(KDPointData.$, 2, this.mo.count);
            let d = this.mh;
            let e = this.mj;
            let f = new Rect(0, 0, 0, 1, 1);
            let g = new Rect(0, 0, 0, 1, 1);
            let h = new ScalerParams(1, f, g, d.ca);
            let i = new ScalerParams(1, f, g, e.ca);
            let j;
            let k;
            for (let l = 0; l < this.mo.count; l++) {
                j = d.dy(this.mo.item(l), h);
                k = e.dy(this.mq.item(l), i);
                if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k)) {
                    c.add(((() => {
                        let $ret = new KDPointData();
                        $ret.a = j;
                        $ret.b = k;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            }
            if (this.mw) {
                this.nr = 1;
                this.ns = truncate(logBase(c.count, 2)) + 3;
                this.n2 = truncate(((this.nr / this.ns) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.n2));
                }
                this.mf = KDTree2D.b(c.toArray(), 1);
                let m = this.mf;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.oj));
                if (!this.mf.f(this.e4)) {
                    let n = this.mf;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.oj));
                }
                this.it();
            }
            else {
                let o = dateNow();
                this.mf = new KDTree2D(0, c.toArray(), 1);
                let p = dateNow();
            }
        }
        if (this.mw && !this.mx) {
            this.op(b);
        }
        else {
            this.oq(b);
        }
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        this.ov();
        let e = false;
        if (this.mh != null && !this.mh.cn()) {
            e = true;
        }
        if (this.mj != null && !this.mj.cn()) {
            e = true;
        }
        if (e) {
            this.jl(false);
        }
        this.iu();
    }
    ol(a) {
        let b = a;
        let c = this.nu * this.nt;
        if (this.mt) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (let d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (let e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    }
    oq(a) {
        let b;
        let c;
        let d = null;
        if (a.n) {
            d = this._itemIndexes;
        }
        let e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        let f = a;
        let g = this.getEffectiveViewport1(a);
        this.mk = new ScalerParams(0, b, c, this.mg.ca, g);
        this.ml = new ScalerParams(0, b, c, this.mi.ca, g);
        this.ok(a);
        this.ol(a);
        let h = this.nu * this.nt;
        if (this.md == null || this.md.length != h) {
            this.md = new Array(h);
            this.ma = new Array(h);
        }
        let i = this.md.length;
        let j = this.md;
        let k = this.ma;
        for (let l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.ny = truncate(Math.round(this.eu));
        this.mc = f.bv();
        let m = this.mc.length;
        let n = this.mc;
        for (let o = 0; o < m; o++) {
            n[o] = 0;
        }
        let p = this.np;
        let q = this.no;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.m4 = Math.min(p, q);
        this.m3 = Math.max(p, q);
        if (this.m4 < 0) {
            this.m4 = 0;
        }
        if (this.m3 < 0) {
            this.m3 = 0;
        }
        this.m5 = this.m3 - this.m4;
        if (this.mx) {
            this.on(a);
        }
        else {
            this.ox(a);
        }
        f.b6();
        if (a.n) {
            this._itemIndexes = d;
            this.me.b7();
        }
    }
    op(a) {
        if (this.mf == null) {
            return;
        }
        this.oq(a);
    }
    oj(a, b) {
        this.me.b5(() => {
            if (this.nr < this.ns - 1) {
                this.nr++;
            }
            this.n2 = truncate(((this.nr / this.ns) * 100));
            if (this.progressiveLoadStatusChanged != null) {
                this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.n2));
            }
            this.op(this.bi);
            this.it();
            if (this.mf != null) {
                if (!this.mf.f(this.e4)) {
                    let c = this.mf;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(this, this.oj));
                    this.n2 = 100;
                    if (this.progressiveLoadStatusChanged != null) {
                        this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.n2));
                    }
                }
            }
        });
    }
    on(a) {
        let b = arrayShallowClone(this.mo.asArray());
        this.mh.gs(boxArray$1(b), 0, b.length, this.mk);
        let c = arrayShallowClone(this.mq.asArray());
        this.nx = 0;
        let d = this.nv;
        let e = this.mr;
        let f = this.md.length;
        this.mj.gs(boxArray$1(c), 0, c.length, this.ml);
        let g = 255 << 24 | truncate(this.nb) << 16 | truncate(this.na) << 8 | truncate(this.m9);
        for (let h = 0; h < b.length; h++) {
            let i = truncate(b[h]);
            let j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.nu || j < 0 || j >= this.nt) {
                continue;
            }
            if (e) {
                let k = i - d;
                let l = i + d;
                l = l > (this.nu - 1) ? (this.nu - 1) : l;
                k = k < 0 ? 0 : k;
                let m = j + d;
                let n = j - d;
                for (let o = k; o <= l; o++) {
                    for (let p = n; p <= m; p++) {
                        let q = (p * this.nu) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.md[q] = this.md[q] + 1;
                        this.ma[q] = 1;
                        this.nx++;
                        if (this.mt) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                let r = (j * this.nu) + i;
                this.md[r] = this.md[r] + 1;
                this.ma[r] = 1;
                this.nx++;
                if (this.mt) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.or();
    }
    ox(a) {
        let b;
        let c;
        let d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.mf == null) {
            return;
        }
        if (this.my == null) {
            this.my = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.my.clear();
        }
        let e = c.left;
        let f = c.right;
        let g = c.top;
        let h = c.bottom;
        this.nl = c.top;
        this.nj = c.height;
        this.nk = c.left;
        this.nm = c.width;
        this.nh = b.top;
        this.nf = b.height;
        this.ng = b.left;
        this.ni = b.width;
        let i = this.getEffectiveViewport1(a);
        this.m0 = (i.left - this.ng) / this.ni;
        this.m1 = (i.top - this.nh) / this.nf;
        let j = (i.right - this.ng) / this.ni;
        this.m2 = j - this.m0;
        let k = (i.bottom - this.nh) / this.nf;
        this.mz = k - this.m1;
        if (this.ms) {
            e = (e - this.m0) / this.m2;
            f = (f - this.m0) / this.m2;
            g = (g - this.m1) / this.mz;
            h = (h - this.m1) / this.mz;
        }
        let l = this.eu / b.width * c.width;
        let m = this.eu / b.height * c.height;
        let n = Math.min(l, m);
        let o = ((() => {
            let $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.mf.t(this.my, o, 0, 1, 0, 1);
        let p;
        this.nx = 0;
        for (let q = 0; q < this.my.count; q++) {
            p = this.my._inner[q];
            this.os(p);
        }
        this.or();
    }
    os(a) {
        if (a.g) {
            return;
        }
        let b = a.e != null && a.e.a;
        let c = a.a == null ? 0 : a.a.length;
        let d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.ou(a.b, d, b, a.e);
        if (c > 0 && !b) {
            let e;
            for (let f = 0; f < c; f++) {
                e = a.a[f];
                this.ou(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    }
    c9(a) {
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        let c = this.bs != null ? this.bs.oh : Rect.empty;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = this.l2(this.bi);
        let f = new ScalerParams(0, d, d, this.mh.ca, e);
        let g = new ScalerParams(0, d, d, this.mj.ca, e);
        let h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        let i = this.mh != null && this.mo != null && h < this.mo.count ? this.mh.dy(this.mo.item(h), f) : NaN;
        let j = this.mj != null && this.mq != null && h < this.mq.count ? this.mj.dy(this.mq.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    }
    ou(a, b, c, d) {
        let e = this.n0(b);
        let f = a.c;
        let g = this.nv;
        if (c) {
            let h = d.d;
            let i = d.b;
            let j = d.e;
            let k = d.c;
            if (this.ms) {
                h = this.m0 + this.m2 * h;
                i = this.m0 + this.m2 * i;
                j = this.m1 + this.mz * j;
                k = this.m1 + this.mz * k;
            }
            let l = truncate((this.ng + this.ni * (h - this.nk) / this.nm));
            let m = truncate((this.ng + this.ni * (i - this.nk) / this.nm));
            let n = truncate((this.nh + this.nf * (j - this.nl) / this.nj));
            let o = truncate((this.nh + this.nf * (k - this.nl) / this.nj));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.mr) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            let p = ((m - l) + 1) * ((o - n) + 1);
            let q = b / p;
            let r = q;
            for (let s = l; s <= m; s++) {
                for (let t = n; t <= o; t++) {
                    this.ot(f, s, t, q, r);
                }
            }
        }
        else {
            let u = a.a;
            let v = a.b;
            if (this.ms) {
                u = this.m0 + this.m2 * u;
                v = this.m1 + this.mz * v;
            }
            let w = truncate((this.ng + this.ni * (u - this.nk) / this.nm));
            let x = truncate((this.nh + this.nf * (v - this.nl) / this.nj));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.mr) {
                let y = w - g;
                let z = w + g;
                let aa = x + g;
                let ab = x - g;
                let ac = ((z - y) + 1) * ((aa - ab) + 1);
                let ad = b / ac;
                let ae = ad;
                for (let af = y; af <= z; af++) {
                    for (let ag = ab; ag <= aa; ag++) {
                        this.ot(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.ot(f, w, x, b, 1);
            }
        }
    }
    nz(a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.nb + a * this.ne))) << 16 | truncate(Math.floor(b * (this.na + a * this.nd))) << 8 | truncate(Math.floor(b * (this.m9 + a * this.nc)));
    }
    n0(a) {
        return 255 << 24 | truncate(Math.floor((this.nb + a * this.ne))) << 16 | truncate(Math.floor((this.na + a * this.nd))) << 8 | truncate(Math.floor((this.m9 + a * this.nc)));
    }
    nn(a) {
        return (a >> 24 & 255) / 255;
    }
    ot(a, b, c, d, e) {
        if (b < 0 || b >= this.nu || c < 0 || c >= this.nt) {
            return;
        }
        let f = (c * this.nu) + b;
        this.md[f] = this.md[f] + d;
        this.ma[f] = this.ma[f] + e;
        if (this.mt) {
            this._itemIndexes[f] = a + 1;
        }
        this.nx += truncate(d);
    }
    or() {
        let a = 0;
        let b = 0;
        let c = this.m5;
        let d = this.m4;
        let e = this.m3;
        let f = this.md.length;
        let g = this.md;
        let h = this.ma;
        let i = this.mc;
        let j = NaN;
        let k = NaN;
        let l = 0;
        let m = 0;
        for (let n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.nz(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    }
    ok(a) {
        let b = a;
        b.b3();
    }
    bf() {
        return new HighDensityScatterSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.me = a;
    }
    an(a) {
        if (a != null && a == this.mh && this.mo != null) {
            return new AxisRange(this.mo.minimum, this.mo.maximum);
        }
        if (a != null && a == this.mj && this.mq != null) {
            return new AxisRange(this.mq.minimum, this.mq.maximum);
        }
        return null;
    }
    j0(a, b) {
        if (this.bs != null) {
            let c = this.getEffectiveViewport1(this.bi);
            this.ms = !c.isEmpty;
        }
        this.jl(false);
    }
    j1(a, b) {
        this.jl(false);
    }
    fp(a) {
        if (!this.mt || this._itemIndexes == null || this.bs == null || this.bz == null || this._itemIndexes.length != (this.nu * this.nt)) {
            return null;
        }
        let b = this.bs.n2;
        let c = (a.x - b.left) / b.width;
        let d = (a.y - b.top) / b.height;
        let e = truncate(Math.round(this.l8.left + (this.l8.width * c)));
        let f = truncate(Math.round(this.l8.top + (this.l8.height * d)));
        let g = this.n3(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        let h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.bz.count) {
            return null;
        }
        return this.bz.item(h);
    }
    n3(a, b) {
        let c = (this.nu * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        let d = 1;
        c = (this.nu * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nu * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    }
    ow(a, b, c) {
        this.mc = a;
        this.nu = b;
        this.nt = c;
    }
    get_dq() {
        return true;
    }
    set_dq(a) {
        super.set_dq(a);
    }
    h3(a, b) {
        super.h3(a, b);
        this.me.b4();
        if (this.bh != null) {
            this.bh.b4();
        }
        this.it();
    }
    jn(a, b) {
        super.jn(a, b);
        if (!this.dl) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        let c = typeCast(HighDensityScatterSeriesView.$, this.bh);
        let d = new ScatterFrame();
        this.oo(false, c);
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.mm == null) {
            this.mm = new ScatterFrame();
        }
        this.oo(false, f);
    }
    h1() {
        super.h1();
        this.mh = null;
        this.mj = null;
    }
}
HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
HighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:o9:oy', [Color.$, null], 'HeatMaximum:no:oz', [1, 50], 'HeatMinimumColor:pa:o0', [Color.$, null], 'HeatMinimum:np:o1', [1, 0], 'PointExtent:n1:o2', [1, 1], 'ProgressiveLoad:mw:o3', [0, true], 'UseBruteForce:mx:o4', [0, false], 'XAxis:mh:o5', [NumericXAxis.$, null], 'XMemberPath:od:o6', [2, null], 'YAxis:mj:o7', [NumericYAxis.$, null], 'YMemberPath:oh:o8', [2, null]]);
/**
 * @hidden
 */
class HighDensityScatterSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bw = null;
        this.bu = null;
        this.b2 = 0;
        this.b1 = 0;
        this.bz = null;
        this.b0 = null;
        this.bx = null;
        this.bw = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.eu = 4;
            this.bw.pa = Color.u(255, 0, 0, 0);
            this.bw.o9 = Color.u(255, 255, 0, 0);
        }
    }
    b7() {
        this.bw.ow(this.bu, this.b2, this.b1);
    }
    b3() {
        if (this.bz == null) {
            this.bz = this.e.e4.createElement("canvas");
            let a = this.e.e4.get2DCanvasContext(this.bz);
            this.bx = new RenderingContext(new CanvasViewRenderer(), a);
        }
        let b;
        if (this.m) {
            b = this.br;
        }
        else {
            b = this.e.bs.n7();
        }
        let c = truncate(Math.round(b.left));
        let d = truncate(Math.round(b.top));
        let e = truncate(Math.round(b.width));
        let f = truncate(Math.round(b.height));
        let g = this.b2;
        let h = this.b1;
        this.b2 = e;
        this.b1 = f;
        if (g != this.b2 || h != this.b1 || this.bu == null) {
            this.bz.setAttribute("width", e.toString());
            this.bz.setAttribute("height", f.toString());
            this.b0 = this.bx.g().getImageData(0, 0, e, f);
            let imageDataArray_ = this.b0.data;
            this.bu = imageDataArray_;
        }
        this.bw.ow(this.bu, this.b2, this.b1);
    }
    bv() {
        return this.bu;
    }
    b6() {
        let a = truncate(Math.round(this.br.left));
        let b = truncate(Math.round(this.br.left));
        let c = truncate(Math.round(this.br.width));
        let d = truncate(Math.round(this.br.height));
        this.bx.g().putImageData(this.b0, 0, 0);
        this.an();
    }
    b5(a) {
        if (this.e.e4 != null) {
            this.e.e4.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    }
    a3(a, b) {
        super.a3(a, b);
        if (b) {
            if (!this.bw.c7) {
                return;
            }
            let c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
            return;
        }
        if (this.bz == null) {
            return;
        }
        let d = truncate(Math.round(this.br.left));
        let e = truncate(Math.round(this.br.top));
        let f = truncate(Math.round(this.br.width));
        let g = truncate(Math.round(this.br.height));
        this.h.n(this.bz.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    }
    by(a, b) {
        return Color.e(toNullable(Color.$, a), toNullable(Color.$, null)) && Color.e(toNullable(Color.$, b), toNullable(Color.$, null));
    }
    b4() {
        if (this.bu != null) {
            for (let a = 0; a < this.bu.length; a++) {
                this.bu[a] = 0;
            }
            this.b6();
        }
    }
    ai(a) {
        super.ai(a);
        if (this.bu == null) {
            this.e.a2.exportSeriesPixelsData(a, null, this.b2, this.b1);
            return;
        }
        let b = new Array(intDivide(this.bu.length, 4));
        let c;
        for (let d = 0; d < intDivide(this.bu.length, 4); d++) {
            c = d * 4;
            b[d] = this.bu[c + 3] << 24 | this.bu[c] << 16 | this.bu[c + 1] << 8 | this.bu[c + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, b, this.b2, this.b1);
    }
}
HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxHighDensityScatterSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent series where a high volume of scatter points can be displayed.
*/
const IgxHighDensityScatterSeriesComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxHighDensityScatterSeriesComponent) }];
let IgxHighDensityScatterSeriesComponent = IgxHighDensityScatterSeriesComponent_1 = class IgxHighDensityScatterSeriesComponent extends IgxSeriesComponent {
    constructor() {
        super();
        this._progressiveLoadStatusChanged = null;
    }
    createImplementation() {
        return new HighDensityScatterSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Checks if this series is a scatter series
    */
    get isScatter() {
        return this.i.c4;
    }
    /**
     * Gets or sets the effective x-axis for the current object.
    */
    get xAxis() {
        if (this.i.mh == null) {
            return null;
        }
        if (!this.i.mh.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.mh);
            if (e) {
                e._implementation = this.i.mh;
            }
            this.i.mh.externalObject = e;
        }
        return this.i.mh.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mh = null : this.i.mh = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current object.
    */
    get yAxis() {
        if (this.i.mj == null) {
            return null;
        }
        if (!this.i.mj.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.mj);
            if (e) {
                e._implementation = this.i.mj;
            }
            this.i.mj.externalObject = e;
        }
        return this.i.mj.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mj = null : this.i.mj = v.i;
    }
    /**
     * Gets or sets the x value mapping property for the current series object.
    */
    get xMemberPath() {
        return this.i.od;
    }
    set xMemberPath(v) {
        this.i.od = v;
    }
    /**
     * Gets or sets the y value mapping property for the current series object.
    */
    get yMemberPath() {
        return this.i.oh;
    }
    set yMemberPath(v) {
        this.i.oh = v;
    }
    /**
     * Gets or sets the whether to use use brute force mode.
    */
    get useBruteForce() {
        return this.i.mx;
    }
    set useBruteForce(v) {
        this.i.mx = ensureBool(v);
    }
    /**
     * Gets or sets the whether to progressively load the data into the chart.
    */
    get progressiveLoad() {
        return this.i.mw;
    }
    set progressiveLoad(v) {
        this.i.mw = ensureBool(v);
    }
    /**
     * Gets or sets the density value that maps to the minimum heat color.
    */
    get heatMinimum() {
        return this.i.np;
    }
    set heatMinimum(v) {
        this.i.np = +v;
    }
    /**
     * Gets or sets the value that maps to the maximum heat color.
    */
    get heatMaximum() {
        return this.i.no;
    }
    set heatMaximum(v) {
        this.i.no = +v;
    }
    /**
     * Gets or sets the color to use for the minimum end of the scale.
    */
    get heatMinimumColor() {
        return colorToString(this.i.pa);
    }
    set heatMinimumColor(v) {
        this.i.pa = stringToColor(v);
    }
    /**
     * Gets or sets the color to use for the maximum end of the scale.
    */
    get heatMaximumColor() {
        return colorToString(this.i.o9);
    }
    set heatMaximumColor(v) {
        this.i.o9 = stringToColor(v);
    }
    /**
     * Gets or sets the the pixel extent of the square data points that are rendered.
    */
    get pointExtent() {
        return this.i.n1;
    }
    set pointExtent(v) {
        this.i.n1 = +v;
    }
    /**
     * Represents the current status of the progressive load of the series. It will range from 0 to 100, where 100 is fully loaded.
    */
    get progressiveStatus() {
        return this.i.n2;
    }
    set progressiveStatus(v) {
        this.i.n2 = +v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.mv(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.mu(axis);
        return (iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Raised when the progressive loading state of the series has changed.
    */
    get progressiveLoadStatusChanged() {
        if (this._progressiveLoadStatusChanged == null) {
            this._progressiveLoadStatusChanged = new EventEmitter();
            this.i.progressiveLoadStatusChanged = delegateCombine(this.i.progressiveLoadStatusChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxProgressiveLoadStatusEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeProgressiveLoadStatusChanged) {
                        this.beforeProgressiveLoadStatusChanged(this, outerArgs);
                    }
                    this._progressiveLoadStatusChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._progressiveLoadStatusChanged;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxHighDensityScatterSeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxHighDensityScatterSeriesComponent.prototype, "yAxis", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxHighDensityScatterSeriesComponent.prototype, "xMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxHighDensityScatterSeriesComponent.prototype, "yMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxHighDensityScatterSeriesComponent.prototype, "useBruteForce", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxHighDensityScatterSeriesComponent.prototype, "progressiveLoad", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxHighDensityScatterSeriesComponent.prototype, "heatMinimum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxHighDensityScatterSeriesComponent.prototype, "heatMaximum", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxHighDensityScatterSeriesComponent.prototype, "heatMinimumColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxHighDensityScatterSeriesComponent.prototype, "heatMaximumColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxHighDensityScatterSeriesComponent.prototype, "pointExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxHighDensityScatterSeriesComponent.prototype, "progressiveStatus", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxHighDensityScatterSeriesComponent.prototype, "progressiveLoadStatusChanged", null);
IgxHighDensityScatterSeriesComponent = IgxHighDensityScatterSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-high-density-scatter-series',
        template: ``,
        providers: [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxHighDensityScatterSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxHighDensityScatterSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHighDensityScatterSeriesModule = class IgxHighDensityScatterSeriesModule {
};
IgxHighDensityScatterSeriesModule = __decorate([
    NgModule({
        declarations: [IgxHighDensityScatterSeriesComponent],
        imports: [CommonModule],
        exports: [IgxHighDensityScatterSeriesComponent],
        entryComponents: []
    })
], IgxHighDensityScatterSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHighDensityScatterSeriesDynamicModule = class IgxHighDensityScatterSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxHighDensityScatterSeriesComponent", IgxHighDensityScatterSeriesComponent);
        TypeRegistrar.register("HighDensityScatterSeries", HighDensityScatterSeries.$type);
    }
};
IgxHighDensityScatterSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxHighDensityScatterSeriesModule],
        exports: [IgxHighDensityScatterSeriesModule],
        entryComponents: [IgxHighDensityScatterSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxHighDensityScatterSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartScatterModule = class IgxDataChartScatterModule {
};
IgxDataChartScatterModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxSizeScaleModule,
            IgxValueBrushScaleModule,
            IgxCustomPaletteColorScaleModule,
            IgxBubbleSeriesModule,
            IgxScatterSeriesModule,
            IgxScatterLineSeriesModule,
            IgxScatterSplineSeriesModule,
            IgxHighDensityScatterSeriesModule,
            IgxDataChartScatterCoreModule
        ],
        imports: [CommonModule, IgxSizeScaleModule,
            IgxValueBrushScaleModule,
            IgxCustomPaletteColorScaleModule,
            IgxBubbleSeriesModule,
            IgxScatterSeriesModule,
            IgxScatterLineSeriesModule,
            IgxScatterSplineSeriesModule,
            IgxHighDensityScatterSeriesModule,
            IgxDataChartScatterCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartScatterModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartScatterDynamicModule = class IgxDataChartScatterDynamicModule {
};
IgxDataChartScatterDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxSizeScaleDynamicModule,
            IgxValueBrushScaleDynamicModule,
            IgxCustomPaletteColorScaleDynamicModule,
            IgxBubbleSeriesDynamicModule,
            IgxScatterSeriesDynamicModule,
            IgxScatterLineSeriesDynamicModule,
            IgxScatterSplineSeriesDynamicModule,
            IgxHighDensityScatterSeriesDynamicModule,
            IgxDataChartScatterCoreDynamicModule,
            IgxDataChartScatterModule
        ],
        imports: [CommonModule, IgxSizeScaleDynamicModule,
            IgxValueBrushScaleDynamicModule,
            IgxCustomPaletteColorScaleDynamicModule,
            IgxBubbleSeriesDynamicModule,
            IgxScatterSeriesDynamicModule,
            IgxScatterLineSeriesDynamicModule,
            IgxScatterSplineSeriesDynamicModule,
            IgxHighDensityScatterSeriesDynamicModule,
            IgxDataChartScatterCoreDynamicModule,
            IgxDataChartScatterModule
        ],
        entryComponents: []
    })
], IgxDataChartScatterDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartShapeCoreModule = class IgxDataChartShapeCoreModule {
};
IgxDataChartShapeCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartShapeCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartShapeCoreDynamicModule = class IgxDataChartShapeCoreDynamicModule {
};
IgxDataChartShapeCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartShapeCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartShapeCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartShapeCoreDynamicModule);

/**
 * Base class for series which triangulate XY data prior to rendering.
*/
const IgxScatterTriangulationSeriesComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterTriangulationSeriesComponent) }];
class IgxScatterTriangulationSeriesComponent extends IgxSeriesComponent {
    constructor() {
        super();
        this._triangulationStatusChanged = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The name of the property from which to extract the X-coordinate for each item in the ItemsSource.
    */
    get xMemberPath() {
        return this.i.m8;
    }
    set xMemberPath(v) {
        this.i.m8 = v;
    }
    /**
     * The name of the property from which to extract the Y-coordinate for each item in the ItemsSource.
    */
    get yMemberPath() {
        return this.i.nc;
    }
    set yMemberPath(v) {
        this.i.nc = v;
    }
    /**
     * The X-Axis for this series.
    */
    get xAxis() {
        if (this.i.ma == null) {
            return null;
        }
        if (!this.i.ma.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.ma);
            if (e) {
                e._implementation = this.i.ma;
            }
            this.i.ma.externalObject = e;
        }
        return this.i.ma.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ma = null : this.i.ma = v.i;
    }
    /**
     * The Y-Axis for this series.
    */
    get yAxis() {
        if (this.i.mb == null) {
            return null;
        }
        if (!this.i.mb.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.mb);
            if (e) {
                e._implementation = this.i.mb;
            }
            this.i.mb.externalObject = e;
        }
        return this.i.mb.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mb = null : this.i.mb = v.i;
    }
    /**
     * The source of triangulation data.
     * This property is optional.  If it is left as null, the triangulation will be created based on the items in the ItemsSource.  Triangulation is a demanding operation, so the runtime performance will be better when specifying a TriangulationSource, especially when a large number of data items are present.
    */
    get trianglesSource() {
        return this.i.trianglesSource;
    }
    set trianglesSource(v) {
        this.i.trianglesSource = v;
    }
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the first vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath1() {
        return this.i.m0;
    }
    set triangleVertexMemberPath1(v) {
        this.i.m0 = v;
    }
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the second vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath2() {
        return this.i.m2;
    }
    set triangleVertexMemberPath2(v) {
        this.i.m2 = v;
    }
    /**
     * The name of the property of the TrianglesSource items which, for each triangle, contains the index of the third vertex point in the ItemsSource.
    */
    get triangleVertexMemberPath3() {
        return this.i.m4;
    }
    set triangleVertexMemberPath3(v) {
        this.i.m4 = v;
    }
    /**
     * Gets whether or not this series is a shape series
    */
    get isShape() {
        return this.i.c5;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.ms(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.mr(axis);
        return (iv);
    }
    /**
     * Raised when the status of an ongoing Triangulation has changed.
    */
    get triangulationStatusChanged() {
        if (this._triangulationStatusChanged == null) {
            this._triangulationStatusChanged = new EventEmitter();
            this.i.triangulationStatusChanged = delegateCombine(this.i.triangulationStatusChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxTriangulationStatusEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeTriangulationStatusChanged) {
                        this.beforeTriangulationStatusChanged(this, outerArgs);
                    }
                    this._triangulationStatusChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._triangulationStatusChanged;
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterTriangulationSeriesComponent.prototype, "xMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterTriangulationSeriesComponent.prototype, "yMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxScatterTriangulationSeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxScatterTriangulationSeriesComponent.prototype, "yAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxScatterTriangulationSeriesComponent.prototype, "trianglesSource", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath1", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath2", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterTriangulationSeriesComponent.prototype, "triangleVertexMemberPath3", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxScatterTriangulationSeriesComponent.prototype, "triangulationStatusChanged", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterTriangulationSeries extends Series {
    constructor() {
        super(...arguments);
        this.mh = null;
        this.mi = null;
        this.mq = false;
        this.md = null;
        this.triangulationStatusChanged = null;
        this.mt = null;
        this.me = null;
        this.mf = null;
        this.mg = null;
    }
    h1() {
        super.h1();
        this.ma = null;
        this.mb = null;
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == ScatterTriangulationSeries.$$p[6]) {
            return this.ft(a, b, this.m8);
        }
        if (c == ScatterTriangulationSeries.$$p[8]) {
            return this.ft(a, b, this.nc);
        }
        return super.fs(a, b);
    }
    get mn() {
        return this.mh;
    }
    set mn(a) {
        let b = this.mn != a;
        if (b) {
            let c = this.mn;
            this.mh = a;
            this.raisePropertyChanged("XColumn", c, this.mn);
        }
    }
    get mo() {
        return this.mi;
    }
    set mo(a) {
        let b = this.mo != a;
        if (b) {
            let c = this.mo;
            this.mi = a;
            this.raisePropertyChanged("YColumn", c, this.mo);
        }
    }
    jm(a) {
        let b = this.bz != null && this.mp == null && this.mt == null && this.mn != null && this.mo != null && this.mn.count >= 3 && this.mo.count >= 3 && !this.mq;
        if (b) {
            this.ng();
            this.mq = true;
        }
    }
    ng() {
        this.md = new Triangulator(this.bz.count, this.mn, this.mo);
        let a = this.md;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.nh));
        this.md.y();
    }
    ne() {
        if (this.md == null) {
            return;
        }
        this.md.r();
        let a = this.md;
        a.triangulationStatusChanged = delegateRemove(a.triangulationStatusChanged, runOn(this, this.nh));
        this.md = null;
    }
    nh(a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, new TriangulationStatusEventArgs(b.currentStatus));
        }
        if (b.currentStatus >= 100) {
            if (this.md == null) {
                return;
            }
            let c = this.md;
            c.triangulationStatusChanged = delegateRemove(c.triangulationStatusChanged, runOn(this, this.nh));
            this.mt = this.md.n();
            this.md = null;
            let d = ((() => {
                let $ret = new FastItemsSource();
                $ret.e = this.mt;
                return $ret;
            })());
            this.mk = this.mj(d, "v1");
            this.ml = this.mj(d, "v2");
            this.mm = this.mj(d, "v3");
            this.jl(false);
        }
    }
    mj(a, b) {
        if (b == null) {
            return a.registerColumnInt(null, null, false);
        }
        let c = null;
        let d = SeriesViewer.bn(b, this.coercionMethods);
        c = d.a;
        return a.registerColumnInt(b, c, this.expectFunctions);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.mn);
                    e.deregisterColumn(this.mo);
                    this.mn = null;
                    this.mo = null;
                }
                this.nf();
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.mn = this.bw(this.m8);
                    this.mo = this.bw(this.nc);
                }
                this.jl(false);
                break;
            case ScatterTriangulationSeries.$$p[6]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mn);
                    this.mn = this.bw(this.m8);
                }
                this.nf();
                this.jl(false);
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.mo);
                    this.mo = this.bw(this.nc);
                }
                this.nf();
                this.jl(false);
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[5]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bx(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).ck(this);
                }
                if ((this.ma != null && !this.ma.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[7]:
                if (c != null) {
                    (typeCast(Axis.$, c)).bx(this);
                }
                if (d != null) {
                    (typeCast(Axis.$, d)).ck(this);
                }
                if ((this.mb != null && !this.mb.cn()) || (d == null && c != null)) {
                    this.jl(false);
                }
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[1]:
                if (this.trianglesSource != null) {
                    this.ne();
                    this.mp = ((() => {
                        let $ret = new FastItemsSource();
                        $ret.e = this.trianglesSource;
                        return $ret;
                    })());
                }
                else {
                    this.mp = null;
                }
                break;
            case ScatterTriangulationSeries.$$p[0]:
                let g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.mk);
                    g.deregisterColumn(this.ml);
                    g.deregisterColumn(this.mm);
                    this.mk = null;
                    this.ml = null;
                    this.mm = null;
                }
                let h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.mk = this.mj(h, this.m0);
                    this.ml = this.mj(h, this.m2);
                    this.mm = this.mj(h, this.m4);
                }
                this.jl(false);
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[2]:
                if (this.mp != null) {
                    this.mp.deregisterColumn(this.mk);
                    this.mk = this.mj(this.mp, this.m0);
                }
                this.jl(false);
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[3]:
                if (this.mp != null) {
                    this.mp.deregisterColumn(this.ml);
                    this.ml = this.mj(this.mp, this.m2);
                }
                this.jl(false);
                this.it();
                break;
            case ScatterTriangulationSeries.$$p[4]:
                if (this.mp != null) {
                    this.mp.deregisterColumn(this.mm);
                    this.mm = this.mj(this.mp, this.m4);
                }
                this.jl(false);
                this.it();
                break;
            case "XColumn":
                if (this.ma != null) {
                    this.ma.cn();
                }
                break;
            case "YColumn":
                if (this.mb != null) {
                    this.mb.cn();
                }
                break;
        }
    }
    ms(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    mr(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    dw(a, b, c) {
        return super.dw(a, b, c) && this.bz != null && this.ma != null && this.mb != null && this.ma.bh != null && this.mb.bh != null && a.width > 0 && a.height > 0 && this.mk != null && this.mk.count > 0 && this.ml != null && this.ml.count > 0 && this.mm != null && this.mm.count > 0 && this.mn != null && this.mn.count > 0 && this.mo != null && this.mo.count > 0;
    }
    nf() {
        if (this.trianglesSource == null) {
            this.mt = null;
            this.mk = null;
            this.ml = null;
            this.mm = null;
            this.mq = false;
        }
    }
    ik() {
        super.ik();
        if (this.ma != null) {
            this.ma.ha();
        }
        if (this.mb != null) {
            this.mb.ha();
        }
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        this.nf();
        this.jl(false);
    }
    an(a) {
        if (a != null && a == this.ma && this.mn != null) {
            return new AxisRange(this.mn.minimum, this.mn.maximum);
        }
        if (a != null && a == this.mb && this.mo != null) {
            return new AxisRange(this.mo.minimum, this.mo.maximum);
        }
        return null;
    }
    j1(a, b) {
        this.jl(false);
    }
    j0(a, b) {
        this.jl(false);
    }
    get mk() {
        return this.me;
    }
    set mk(a) {
        let b = this.mk != a;
        if (b) {
            let c = this.mk;
            this.me = a;
            this.raisePropertyChanged("TriangleVertexColumn1", c, this.mk);
        }
    }
    get ml() {
        return this.mf;
    }
    set ml(a) {
        let b = this.ml != a;
        if (b) {
            let c = this.ml;
            this.mf = a;
            this.raisePropertyChanged("TriangleVertexColumn2", c, this.ml);
        }
    }
    get mm() {
        return this.mg;
    }
    set mm(a) {
        let b = this.mm != a;
        if (b) {
            let c = this.mm;
            this.mg = a;
            this.raisePropertyChanged("TriangleVertexColumn3", c, this.mm);
        }
    }
    get_c5() {
        return true;
    }
}
ScatterTriangulationSeries.$t = markType(ScatterTriangulationSeries, 'ScatterTriangulationSeries', Series.$);
ScatterTriangulationSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterTriangulationSeries, 'raisePropertyChanged', ['FastTrianglesSource:mp:ni', [IFastItemsSource_$type, null], 'TrianglesSource::nj', [IEnumerable_$type, null], 'TriangleVertexMemberPath1:m0:nk', [2, null], 'TriangleVertexMemberPath2:m2:nl', [2, null], 'TriangleVertexMemberPath3:m4:nm', [2, null], 'XAxis:ma:nn', [NumericXAxis.$, null], 'XMemberPath:m8:no', [2, null], 'YAxis:mb:np', [NumericYAxis.$, null], 'YMemberPath:nc:nq', [2, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TriangleRasterizer extends Base {
    constructor(a, b, c, d, e, f, g) {
        super();
        this.a = null;
        this.k = 0;
        this.j = 0;
        this.g = 0;
        this.f = 0;
        this.b = null;
        this.d = null;
        if (a == null || b == null || e == null) {
            throw new BaseError(0);
        }
        this.a = a;
        this.c = b;
        this.e = e;
        this.m = f;
        this.l = g;
        this.g = c;
        this.f = d;
    }
    get m() {
        return this.k;
    }
    set m(a) {
        this.k = a;
    }
    get l() {
        return this.j;
    }
    set l(a) {
        this.j = a;
    }
    get i() {
        return this.g;
    }
    set i(a) {
        this.g = a;
    }
    get h() {
        return this.f;
    }
    set h(a) {
        this.f = a;
    }
    get c() {
        return this.b;
    }
    set c(a) {
        this.b = a;
    }
    get e() {
        return this.d;
    }
    set e(a) {
        this.d = a;
    }
    p(a, b, c, d, e, f, g, h) {
        let i = this.k;
        let j = this.j;
        let k;
        let l;
        if (d.y > e.y) {
            k = d;
            d = e;
            e = k;
            l = g;
            g = h;
            h = l;
        }
        if (c.y > e.y) {
            k = c;
            c = e;
            e = k;
            l = f;
            f = h;
            h = l;
        }
        if (c.y > d.y) {
            k = c;
            c = d;
            d = k;
            l = f;
            f = g;
            g = l;
        }
        let m = truncate(Math.round(c.y));
        let n = truncate(Math.round(d.y));
        let o = truncate(Math.round(e.y));
        if (o == m) {
            return;
        }
        if (isNaN_(f) || isNaN_(g) || isNaN_(h)) {
            return;
        }
        let p = (d.x - c.x) * (e.y - c.y) - (e.x - c.x) * (d.y - c.y) >= 0;
        let q = Math.max(0, m);
        let r = Math.min(j - 1, n);
        for (let s = q; s < r; ++s) {
            let t = (s - m) / (n - m);
            let u = c.x + t * (d.x - c.x);
            let v = f + t * (g - f);
            let w = (s - m) / (o - m);
            let x = c.x + w * (e.x - c.x);
            let y = f + w * (h - f);
            if (p) {
                this.o(a, b, s, truncate(Math.floor(x)), truncate(Math.ceil(u)), y, v);
            }
            else {
                this.o(a, b, s, truncate(Math.floor(u)), truncate(Math.ceil(x)), v, y);
            }
        }
        {
            let z = Math.min(j - 1, Math.max(0, n));
            let aa = Math.min(j - 1, o);
            let ab = 0;
            let ac = d.x + ab * (e.x - d.x);
            let ad = g + ab * (h - g);
            let ae = z;
            let af = (o - m);
            let ag = (ae - m) / af;
            let ah = c.x + ag * (e.x - c.x);
            let ai = f + ag * (h - f);
            do {
                if (p) {
                    this.o(a, b, ae, truncate(Math.floor(ah)), truncate(Math.ceil(ac)), ai, ad);
                }
                else {
                    this.o(a, b, ae, truncate(Math.floor(ac)), truncate(Math.ceil(ah)), ad, ai);
                }
                ++ae;
                ab = (ae - n) / (o - n);
                ac = d.x + ab * (e.x - d.x);
                ad = g + ab * (h - g);
                ag = (ae - m) / af;
                ah = c.x + ag * (e.x - c.x);
                ai = f + ag * (h - f);
            } while (ae < aa);
        }
    }
    o(a, b, c, d, e, f, g) {
        let h = this.k;
        let i = d > 0 ? d : 0;
        let j = e < h - 1 ? e : h - 1;
        let k = c * h * 4 + (i * 4);
        let l = g - f;
        let m = 1 / (e - d);
        let n = this.d;
        let o = this.g;
        let p = this.f;
        let q = c * h;
        for (let r = i; r <= j; r++) {
            let s = f + l * (r - d) * m;
            let color_ = this.b.getColor(s, o, p, n);
            this.a[k] = (color_._r);
            this.a[k + 1] = (color_._g);
            this.a[k + 2] = (color_._b);
            this.a[k + 3] = (color_._a);
            b[q + r] = a + 1;
            k += 4;
        }
    }
    n() {
    }
}
TriangleRasterizer.$t = markType(TriangleRasterizer, 'TriangleRasterizer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterAreaSeries extends ScatterTriangulationSeries {
    constructor() {
        super();
        this.nu = null;
        this.nz = null;
        this.ns = null;
        this.nt = null;
        this.nr = [Color.u(255, 0, 0, 255), Color.u(255, 0, 255, 0), Color.u(255, 255, 0, 0)];
        FastItemIntColumn.m();
        this.ab = ScatterAreaSeries.$;
    }
    get nv() {
        return this.nu;
    }
    set nv(a) {
        let b = this.nu != a;
        if (b) {
            let c = this.nu;
            if (this.nu != null) {
                let d = this.nu;
                d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.n8));
            }
            this.nu = a;
            if (this.nu != null) {
                let e = this.nu;
                e.propertyChanged = delegateCombine(e.propertyChanged, runOn(this, this.n8));
            }
            this.raisePropertyChanged("ColorScale", c, this.nu);
        }
    }
    n8(a, b) {
        this.jl(false);
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == ScatterAreaSeries.$$p[0]) {
            return this.ft(a, b, this.n3);
        }
        return super.fs(a, b);
    }
    get n0() {
        return this.nz;
    }
    set n0(a) {
        let b = this.n0 != a;
        if (b) {
            let c = this.n0;
            this.nz = a;
            this.raisePropertyChanged("ColorColumn", c, this.n0);
        }
    }
    get_dq() {
        return true;
    }
    set_dq(a) {
        super.set_dq(a);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.n0);
                    this.n0 = null;
                }
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.n0 = this.bw(this.n3);
                }
                this.jl(false);
                break;
            case ScatterAreaSeries.$$p[0]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.n0);
                    this.n0 = this.bw(this.n3);
                }
                this.jl(false);
                this.it();
                break;
            case "ColorScale":
                this.jl(false);
                this.it();
                break;
        }
    }
    jm(a) {
        super.jm(a);
        this.n9(this.bi);
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.n9(f);
    }
    n9(a) {
        if (this.cc(a)) {
            return;
        }
        let b;
        let c;
        let d = a.getViewInfo(c, b);
        c = d.p0;
        b = d.p1;
        let e = a;
        let f = null;
        let g = null;
        let h = this.ma;
        let i = this.mb;
        let j = this.getEffectiveViewport1(a);
        let k = new ScalerParams(1, b, c, h.ca);
        k.c = j;
        let l = new ScalerParams(1, b, c, i.ca);
        l.c = j;
        g = this.ny(a, k, l);
        if (g != null) {
            e.b5(g);
        }
        else {
            e.b8(f);
        }
    }
    n6(a) {
        let b;
        let c;
        let d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        let e = truncate(Math.round(b.width)) * truncate(Math.round(b.height));
        let f = a.bx;
        if (f == null || f.length != e) {
            f = new Array(e);
            for (let g = 0; g < e; g++) {
                f[g] = 0;
            }
        }
        else {
            for (let h = 0; h < e; h++) {
                f[h] = 0;
            }
        }
        a.bx = f;
    }
    fp(a) {
        let b = truncate(Math.round(this.l8.width));
        let c = truncate(Math.round(this.l8.height));
        let d = this.bi.bx;
        if (d == null || d.length != (b * c) || this.mk == null || this.mk.count < 1 || this.ml == null || this.ml.count < 1 || this.mm == null || this.mm.count < 1) {
            return null;
        }
        let e = this.bs.oi;
        let f = (a.x - e.left) / e.width;
        let g = (a.y - e.top) / e.height;
        let h = truncate(Math.round(b * f));
        let i = truncate(Math.round(c * g));
        let j = (b * i) + h;
        if (j < 0 || j > d.length - 1) {
            return null;
        }
        let k = d[j] - 1;
        if (k < 0 || k > this.mk.count) {
            return null;
        }
        let l = this.ns.length;
        let m = this.mk.item(k);
        let n = this.ml.item(k);
        let o = this.mm.item(k);
        if ((m >= l) || (n >= l) || (o >= l)) {
            return null;
        }
        let p = (this.ns[m] - this.l8.left) / this.l8.width;
        let q = (this.nt[m] - this.l8.top) / this.l8.height;
        let r = (this.ns[n] - this.l8.left) / this.l8.width;
        let s = (this.nt[n] - this.l8.top) / this.l8.height;
        let t = (this.ns[o] - this.l8.left) / this.l8.width;
        let u = (this.nt[o] - this.l8.top) / this.l8.height;
        let v = Math.pow(p - f, 2) + Math.pow(q - g, 2);
        let w = Math.pow(r - f, 2) + Math.pow(s - g, 2);
        let x = Math.pow(t - f, 2) + Math.pow(u - g, 2);
        if (v < w && v < x) {
            return this.bz.item(m);
        }
        if (w < v && w < x) {
            return this.bz.item(n);
        }
        if (x < v && x < w) {
            return this.bz.item(o);
        }
        return this.bz.item(m);
    }
    ny(a, b, c) {
        let d;
        let e;
        let f = a.getViewInfo(e, d);
        e = f.p0;
        d = f.p1;
        e = new Rect(0, 0, 0, e.width, e.height);
        b = new ScalerParams(0, b.e, e, b.a, b.c);
        c = new ScalerParams(0, c.e, e, c.a, c.c);
        c.b = this.eh();
        let g = a;
        let h = this.ma;
        let i = this.mb;
        let j = this.mk.count;
        let k;
        let xArr_ = this.mn.asArray();
        k = (xArr_.slice(0));
        let l;
        let yArr_ = this.mo.asArray();
        l = (yArr_.slice(0));
        let m = this.n0.asArray();
        let n = this.mk.asArray();
        let o = this.ml.asArray();
        let p = this.mm.asArray();
        this.ns = k;
        this.nt = l;
        h.gs(boxArray$1(k), 0, k.length, b);
        i.gs(boxArray$1(l), 0, l.length, c);
        let q = this.nw();
        let r = g.bz(b.d, q, this.n0);
        let s = e.top;
        let t = e.left;
        let u = e.right;
        let v = e.bottom;
        let w;
        let x;
        let y;
        let z;
        this.n6(g);
        let aa = g.bx;
        let ab = k.length;
        for (let ac = 0; ac < j; ac++) {
            let ad = n[ac];
            let ae = o[ac];
            let af = p[ac];
            if ((ad >= ab) || (ae >= ab) || (af >= ab) || (ad < 0) || (ae < 0) || (af < 0)) {
                continue;
            }
            let ag = k[ad];
            let ah = l[ad];
            let ai = { $type: Point_$type, x: ag, y: ah };
            let aj = k[ae];
            let ak = l[ae];
            let al = { $type: Point_$type, x: aj, y: ak };
            let am = k[af];
            let an = l[af];
            let ao = { $type: Point_$type, x: am, y: an };
            w = al.y < ao.y ? al.y : ao.y;
            w = ai.y < w ? ai.y : w;
            x = al.y > ao.y ? al.y : ao.y;
            x = ai.y > x ? ai.y : x;
            y = al.x < ao.x ? al.x : ao.x;
            y = ai.x < y ? ai.x : y;
            z = al.x > ao.x ? al.x : ao.x;
            z = ai.x > z ? ai.x : z;
            if (w < v && x > s && y < u && z > t) {
                let ap = m[ad];
                let aq = m[ae];
                let ar = m[af];
                r.p(ac, aa, ai, al, ao, ap, aq, ar);
            }
        }
        return r;
    }
    n1() {
        let a = new Color();
        let b = this.lb;
        if (b == null) {
            a = this.nr[this.fh % this.nr.length];
        }
        else {
            a = ColorUtil.j(b);
        }
        let c = new ObservableColorCollection();
        c.add(ColorUtil.o(a, -0.5));
        c.add(a);
        return c;
    }
    nw() {
        let a = this.nv;
        if (a == null) {
            a = ((() => {
                let $ret = new CustomPaletteColorScale();
                $ret.palette = this.n1();
                $ret.interpolationMode = 2;
                return $ret;
            })());
        }
        else if (typeCast(CustomPaletteColorScale.$, a) !== null) {
            let b = a;
            if (b.palette == null || b.palette.count == 0) {
                b.palette = this.n1();
            }
            a = b;
        }
        return a;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.b4();
    }
    bf() {
        return new ScatterAreaSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.nx = typeCast(ScatterAreaSeriesView.$, a);
    }
    n7(a) {
        if (this.nx != null) {
            this.nx.b3(a);
        }
    }
}
ScatterAreaSeries.$t = markType(ScatterAreaSeries, 'ScatterAreaSeries', ScatterTriangulationSeries.$);
ScatterAreaSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterAreaSeries, 'raisePropertyChanged', ['ColorMemberPath:n3:oa', [2, null]]);
/**
 * @hidden
 */
class ScatterAreaSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.by = null;
        this.bu = null;
        this.b2 = null;
        this.b1 = null;
        this.b0 = null;
        this.by = a;
    }
    get bx() {
        return this.bu;
    }
    set bx(a) {
        this.bu = a;
    }
    b7(a, b) {
    }
    b3(a) {
    }
    bv() {
        return this.bw(true);
    }
    bw(a) {
        this.b6();
        let b = truncate(Math.round(this.br.left));
        let c = truncate(Math.round(this.br.left));
        let d = truncate(Math.round(this.br.width));
        let e = truncate(Math.round(this.br.height));
        let f = d.toString();
        let g = e.toString();
        if (this.b1.getAttribute("width") != f) {
            this.b1.setAttribute("width", d.toString());
        }
        if (this.b1.getAttribute("height") != g) {
            this.b1.setAttribute("height", e.toString());
        }
        let h = this.b0.g();
        if (a) {
            h.clearRect(0, 0, d, e);
        }
        this.b2 = h.getImageData(0, 0, d, e);
        let imageDataArray_ = this.b2.data;
        return imageDataArray_;
    }
    b6() {
        if (this.b1 == null) {
            this.b1 = this.e.e4.createElement("canvas");
            let a = this.e.e4.get2DCanvasContext(this.b1);
            this.b0 = new RenderingContext(new CanvasViewRenderer(), a);
        }
    }
    bz(a, b, c) {
        let d = truncate(Math.round(this.br.left));
        let e = truncate(Math.round(this.br.left));
        let f = truncate(Math.round(this.br.width));
        let g = truncate(Math.round(this.br.height));
        return new TriangleRasterizer(this.bv(), b, c.minimum, c.maximum, c, f, g);
    }
    b5(a) {
        this.b8(null);
    }
    b4() {
        if (this.b0 != null) {
            this.b0.k(this.br.left, this.br.top, this.br.width, this.br.height);
        }
        this.an();
    }
    a3(a, b) {
        super.a3(a, b);
        if (this.b1 == null) {
            return;
        }
        if (b) {
            let c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
        }
        else {
            let d = truncate(Math.round(this.br.left));
            let e = truncate(Math.round(this.br.top));
            let f = truncate(Math.round(this.br.width));
            let g = truncate(Math.round(this.br.height));
            a.m(this.b1.getNativeElement(), 1, d, e, f, g);
        }
    }
    b8(a) {
        let b = truncate(Math.round(this.br.left));
        let c = truncate(Math.round(this.br.left));
        let d = truncate(Math.round(this.br.width));
        let e = truncate(Math.round(this.br.height));
        this.b6();
        this.b0.g().putImageData(this.b2, 0, 0);
        this.an();
    }
    ai(a) {
        super.ai(a);
        let b = truncate(Math.round(this.br.width));
        let c = truncate(Math.round(this.br.height));
        let d = this.bw(false);
        if (d == null || d.length == 0) {
            this.e.a2.exportSeriesPixelsData(a, null, b, c);
            return;
        }
        let e = new Array(intDivide(d.length, 4));
        let f;
        for (let g = 0; g < intDivide(d.length, 4); g++) {
            f = g * 4;
            e[g] = d[f + 3] << 24 | d[f] << 16 | d[f + 1] << 8 | d[f + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, e, b, c);
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.by.fx + "</span><br/><span>" + "(${item." + this.by.m8 + "}, ${item." + this.by.nc + "})</span>";
        if (!stringIsNullOrEmpty(this.by.n3)) {
            a += "<span>, Value: ${item." + this.by.n3 + "}</span>";
        }
        a += "</div>";
        return a;
    }
}
ScatterAreaSeriesView.$t = markType(ScatterAreaSeriesView, 'ScatterAreaSeriesView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScatterAreaSeriesComponent_1;
/**
 * Series class which draws a colored 2D surface based on a triangulation of XY data with numeric values assigned to each point.
*/
const IgxScatterAreaSeriesComponent_PROVIDERS = [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: forwardRef(() => IgxScatterAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterAreaSeriesComponent) }];
let IgxScatterAreaSeriesComponent = IgxScatterAreaSeriesComponent_1 = class IgxScatterAreaSeriesComponent extends IgxScatterTriangulationSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets ColorScale used to resolve the color values of points in the series.
    */
    get colorScale() {
        if (this.i.nv == null) {
            return null;
        }
        if (!this.i.nv.externalObject) {
            let e = IgxColorScaleComponent._createFromInternal(this.i.nv);
            if (e) {
                e._implementation = this.i.nv;
            }
            this.i.nv.externalObject = e;
        }
        return this.i.nv.externalObject;
    }
    set colorScale(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nv = null : this.i.nv = v.i;
    }
    /**
     * Gets or sets the name of the property on each data item containing a numeric value which can be converted to a color by the ColorScale.
    */
    get colorMemberPath() {
        return this.i.n3;
    }
    set colorMemberPath(v) {
        this.i.n3 = v;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.colorScale && this.colorScale.name && this.colorScale.name == name) {
            return this.colorScale;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.colorScale && this.colorScale._styling) {
            this.colorScale._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Attaches an image to the view of this series
    
    */
    attachImage(image) {
        this.i.n7(image);
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxColorScaleComponent),
    __metadata("design:paramtypes", [IgxColorScaleComponent])
], IgxScatterAreaSeriesComponent.prototype, "colorScale", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterAreaSeriesComponent.prototype, "colorMemberPath", null);
IgxScatterAreaSeriesComponent = IgxScatterAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-area-series',
        template: ``,
        providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: forwardRef(() => IgxScatterAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterAreaSeriesModule = class IgxScatterAreaSeriesModule {
};
IgxScatterAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterAreaSeriesComponent],
        imports: [CommonModule, IgxCustomPaletteColorScaleModule],
        exports: [IgxScatterAreaSeriesComponent, IgxCustomPaletteColorScaleModule],
        entryComponents: []
    })
], IgxScatterAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterAreaSeriesDynamicModule = class IgxScatterAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterAreaSeriesComponent", IgxScatterAreaSeriesComponent);
        TypeRegistrar.register("ScatterAreaSeries", ScatterAreaSeries.$type);
    }
};
IgxScatterAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterAreaSeriesModule],
        exports: [IgxScatterAreaSeriesModule],
        entryComponents: [IgxScatterAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterAreaSeriesDynamicModule);

/**
 * Class used to determine the numeric values of contour lines, given a larger list of numeric values.
*/
const IgxContourValueResolverComponent_PROVIDERS = [];
class IgxContourValueResolverComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("ContourValueResolverComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ContourValueResolver extends DependencyObject {
    constructor() {
        super(...arguments);
        this.updated = null;
    }
    l(a, b, c) {
        if (this.updated != null) {
            this.updated(this, EventArgs.empty);
        }
    }
}
ContourValueResolver.$t = markType(ContourValueResolver, 'ContourValueResolver', DependencyObject.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class LinearContourValueResolver extends ContourValueResolver {
    constructor() {
        super();
    }
    *_j(a) {
        for (let b = 0; b < this.valueCount; b++) {
            yield a.minimum + (a.maximum - a.minimum) * (b + 1) / (this.valueCount + 1);
        }
    }
    j(a) {
        return toEnum(() => this._j(a));
    }
}
LinearContourValueResolver.$t = markType(LinearContourValueResolver, 'LinearContourValueResolver', ContourValueResolver.$);
LinearContourValueResolver.$$p = markDep(DependencyProperty, PropertyMetadata, LinearContourValueResolver, 'l', ['ValueCount::o', [1, 10]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolylineBuilder extends Base {
    constructor() {
        super(...arguments);
        this.a = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
        this.b = new Dictionary$2(Number_$type, List$1.$.specialize(Number_$type), 0);
    }
    e() {
        this.a.clear();
        this.b.clear();
    }
    c() {
        let a = new List$1(List$1.$.specialize(Number_$type), 0);
        for (let b of fromEnum(this.a.values)) {
            a.add(b);
        }
        return a;
    }
    d(a, b) {
        let c = null;
        let d = null;
        let e = this.b.tryGetValue(a, c);
        c = e.p1;
        let f = this.a.tryGetValue(b, d);
        d = f.p1;
        if (c == null && d == null) {
            let g = new List$1(Number_$type, 0);
            g.add(a);
            g.add(b);
            this.a.addItem(a, g);
            this.b.addItem(b, g);
        }
        if (c == null && d != null) {
            this.a.removeItem(b);
            d.insert(0, a);
            this.a.addItem(a, d);
        }
        if (c != null && d == null) {
            this.b.removeItem(a);
            c.add(b);
            this.b.addItem(b, c);
        }
        if (c != null && d != null) {
            if (c == d) {
                c.add(b);
                this.b.removeItem(a);
            }
            else {
                this.a.removeItem(d._inner[0]);
                this.b.removeItem(d._inner[d.count - 1]);
                this.b.removeItem(c._inner[c.count - 1]);
                c.o(d);
                this.b.addItem(c._inner[c.count - 1], c);
            }
        }
    }
}
PolylineBuilder.$t = markType(PolylineBuilder, 'PolylineBuilder');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ContourBuilder extends PolylineBuilder {
    constructor() {
        super(...arguments);
        this.f = new Dictionary$2(Number_$type, Number_$type, 0);
        this.i = new List$1(Number_$type, 0);
        this.j = new List$1(Number_$type, 0);
    }
    e() {
        super.e();
        this.f.clear();
        this.i.clear();
        this.j.clear();
    }
    get g() {
        return this.i;
    }
    get h() {
        return this.j;
    }
    k(a, b, c, d, e, f, g, h, i) {
        let j = Math.min(a, e) + 0x100000000 * Math.max(a, e);
        let k = -1;
        if (!((() => { let l = this.f.tryGetValue(j, k); k = l.p1; return l.ret; })())) {
            k = this.i.count;
            let l = (i - d) / (h - d);
            this.f.addItem(j, k);
            this.i.add((b + l * (f - b)));
            this.j.add((c + l * (g - c)));
        }
        return k;
    }
}
ContourBuilder.$t = markType(ContourBuilder, 'ContourBuilder', PolylineBuilder.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterContourSeries extends ScatterTriangulationSeries {
    constructor() {
        super();
        this.nv = null;
        this.nr = null;
        FastItemIntColumn.m();
        this.ab = ScatterContourSeries.$;
        this.ns = new LinearContourValueResolver();
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == ScatterContourSeries.$$p[1]) {
            return this.ft(a, b, this.nz);
        }
        return super.fs(a, b);
    }
    bf() {
        this.nt = new ScatterContourSeriesView(this);
        return this.nt;
    }
    get nw() {
        return this.nv;
    }
    set nw(a) {
        let b = this.nw != a;
        if (b) {
            let c = this.nw;
            this.nv = a;
            this.raisePropertyChanged("ValueColumn", c, this.nw);
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "FastItemsSource":
                let e = typeCast(IFastItemsSource_$type, c);
                if (e != null) {
                    e.deregisterColumn(this.nw);
                    this.nw = null;
                }
                let f = typeCast(IFastItemsSource_$type, d);
                if (f != null) {
                    this.nw = this.bw(this.nz);
                }
                this.jl(false);
                break;
            case ScatterContourSeries.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.nw);
                    this.nw = this.bw(this.nz);
                }
                this.jl(false);
                this.it();
                break;
            case "ValueResolver":
                this.jl(false);
                this.it();
                break;
            case ScatterContourSeries.$$p[0]:
                let g = c;
                let h = d;
                if (g != null) {
                    g.unregisterSeries(this);
                }
                if (h != null) {
                    h.registerSeries(this);
                }
                this.jl(false);
                this.it();
                break;
            case "ActualBrush":
                this.jl(false);
                this.it();
                break;
        }
    }
    h3(a, b) {
        super.h3(a, b);
        if (a) {
            b.b0(a);
        }
    }
    jm(a) {
        super.jm(a);
        this.n2(this.bi);
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.n2(f);
    }
    n2(a) {
        if (this.cc(a)) {
            return;
        }
        let b;
        let c;
        let d = a;
        let e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        let f = new ScalerParams(1, b, c, this.ma.ca);
        f.c = this.getEffectiveViewport1(a);
        let g = new ScalerParams(1, b, c, this.mb.ca);
        g.c = this.getEffectiveViewport1(a);
        let h = this.ma;
        let i = this.mb;
        let j = this.mk.count;
        let k;
        let xArr_ = this.mn.asArray();
        k = (xArr_.slice(0));
        let l;
        let yArr_ = this.mo.asArray();
        l = (yArr_.slice(0));
        let m = this.nw.asArray();
        let n = this.mk.asArray();
        let o = this.ml.asArray();
        let p = this.mm.asArray();
        let q = this.ns.j(this.nw);
        let r = new List$1(Number_$type, 1, q).toArray();
        h.gs(boxArray$1(k), 0, k.length, f);
        i.gs(boxArray$1(l), 0, l.length, g);
        let s = r.length;
        let t = new Array(s);
        for (let u = 0; u < s; ++u) {
            t[u] = new ContourBuilder();
        }
        let v = c.top;
        let w = c.left;
        let x = c.right;
        let y = c.bottom;
        let z;
        let aa;
        let ab;
        let ac;
        let ad = k.length;
        for (let ae = 0; ae < j; ae++) {
            let af = n[ae];
            let ag = o[ae];
            let ah = p[ae];
            if ((af >= ad) || (ag >= ad) || (ah >= ad) || (af < 0) || (ag < 0) || (ah < 0)) {
                continue;
            }
            let ai = k[af];
            let aj = l[af];
            let ak = { $type: Point_$type, x: ai, y: aj };
            let al = k[ag];
            let am = l[ag];
            let an = { $type: Point_$type, x: al, y: am };
            let ao = k[ah];
            let ap = l[ah];
            let aq = { $type: Point_$type, x: ao, y: ap };
            z = an.y < aq.y ? an.y : aq.y;
            z = ak.y < z ? ak.y : z;
            aa = an.y > aq.y ? an.y : aq.y;
            aa = ak.y > aa ? ak.y : aa;
            ab = an.x < aq.x ? an.x : aq.x;
            ab = ak.x < ab ? ak.x : ab;
            ac = an.x > aq.x ? an.x : aq.x;
            ac = ak.x > ac ? ak.x : ac;
            if (z < y && aa > v && ab < x && ac > w) {
                let ar = m[af];
                let as = m[ag];
                let at = m[ah];
                if (isNaN_(ar) || isNaN_(as) || isNaN_(at)) {
                    continue;
                }
                for (let au = 0; au < s; au++) {
                    let av = r[au];
                    let aw = t[au];
                    switch ((ar < av ? 1 : 0) | (as < av ? 2 : 0) | (at < av ? 4 : 0)) {
                        case 0: break;
                        case 1:
                            aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                            break;
                        case 2:
                            aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                            break;
                        case 3:
                            aw.d(aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av), aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av));
                            break;
                        case 4:
                            aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                            break;
                        case 5:
                            aw.d(aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av), aw.k(ag, an.x, an.y, as, ah, aq.x, aq.y, at, av));
                            break;
                        case 6:
                            aw.d(aw.k(ah, aq.x, aq.y, at, af, ak.x, ak.y, ar, av), aw.k(af, ak.x, ak.y, ar, ag, an.x, an.y, as, av));
                            break;
                        case 7: break;
                    }
                }
            }
        }
        let ax = new Clipper(0, RectUtil.r(c, 2), false);
        let ay = new List$1(List$1.$.specialize(List$1.$.specialize(Point_$type)), 0);
        for (let az = 0; az < s; ++az) {
            let a0 = t[az];
            let a1 = new List$1(List$1.$.specialize(Point_$type), 0);
            let a2 = a0.c();
            for (let a3 = 0; a3 < a2.count; a3++) {
                let a4 = a2._inner[a3];
                let a5 = new List$1(Point_$type, 0);
                ax.i = a5;
                for (let a6 of fromEnum(a4)) {
                    ax.j({ $type: Point_$type, x: a0.g.item(a6), y: a0.h.item(a6) });
                }
                ax.i = null;
                a1.add(a5);
            }
            ay.add(a1);
        }
        d.bz(ay, r);
    }
    get ns() {
        return this.nr;
    }
    set ns(a) {
        let b = a != this.ns;
        if (b) {
            if (this.nr != null) {
                let c = this.nr;
                c.updated = delegateRemove(c.updated, runOn(this, this.n3));
            }
            let d = this.nr;
            this.nr = a;
            if (this.nr != null) {
                let e = this.nr;
                e.updated = delegateCombine(e.updated, runOn(this, this.n3));
            }
            this.raisePropertyChanged("ValueResolver", d, a);
            this.jl(false);
        }
    }
    n3(a, b) {
        this.jl(false);
    }
    dw(a, b, c) {
        return super.dw(a, b, c) && this.ns != null && this.mn != null && this.mo != null && this.mk != null && this.ml != null && this.mm != null && this.mn.count > 0 && this.mo.count > 0 && this.mk.count > 0 && this.ml.count > 0 && this.mm.count > 0;
    }
    ar(a, b) {
        let c = this.nt.b4(a, b);
        if (c != null) {
            return c.dataContext;
        }
        return null;
    }
}
ScatterContourSeries.$t = markType(ScatterContourSeries, 'ScatterContourSeries', ScatterTriangulationSeries.$);
ScatterContourSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterContourSeries, 'raisePropertyChanged', ['FillScale:nu:n4', [ValueBrushScale.$, null], 'ValueMemberPath:nz:n5', [2, null]]);
/**
 * @hidden
 */
class ScatterContourSeriesView extends SeriesView {
    constructor(a) {
        super(a);
        this.bw = null;
        this.bv = null;
        this.by = null;
        this.bx = new List$1(Brush.$, 0);
        this.bu = null;
        this.by = new List$1(Path.$, 0);
        this.bv = a;
        this.bw = ((() => {
            let $ret = new Pool$1(Path.$);
            $ret.create = runOn(this, this.b5);
            $ret.destroy = runOn(this, this.b3);
            $ret.activate = runOn(this, this.b1);
            $ret.disactivate = runOn(this, this.b2);
            return $ret;
        })());
    }
    b5() {
        let a = new Path();
        a.dataContext = ((() => {
            let $ret = new DataContext();
            $ret.series = this.e;
            return $ret;
        })());
        this.by.add(a);
        return a;
    }
    b1(a) {
        a._visibility = 0;
    }
    b2(a) {
        a._visibility = 1;
    }
    b3(a) {
        this.by.remove(a);
    }
    bz(a, b) {
        let c = 0;
        this.bu = b;
        this.bx.clear();
        let d = this.bv.nu;
        if (d == null) {
            d = new ValueBrushScale();
            d.brushes.add(BrushUtil.l(this.e.lb, -0.5));
            d.brushes.add(this.e.lb);
        }
        else if (d.brushes == null) {
            d.brushes = new BrushCollection();
            d.brushes.add(BrushUtil.l(this.e.lb, -0.5));
            d.brushes.add(this.e.lb);
        }
        else if (d.brushes.count == 0) {
            d.brushes.add(BrushUtil.l(this.e.lb, -0.5));
            d.brushes.add(this.e.lb);
        }
        for (let e = 0; e < b.length; e++) {
            let f = b[e];
            let g = a._inner[c];
            let h = new PathGeometry();
            for (let i = 0; i < g.count; i++) {
                let j = g._inner[i];
                if (j.count == 0) {
                    continue;
                }
                let k = PointCollectionUtil.f(j);
                let l = ((() => {
                    let $ret = new PathFigure();
                    $ret.isClosed = false;
                    $ret.isFilled = false;
                    $ret.startPoint = k._inner[0];
                    return $ret;
                })());
                l._segments.add(((() => {
                    let $ret = new PolyLineSegment();
                    $ret.points = k;
                    return $ret;
                })()));
                h.c.add(l);
            }
            this.bw.item(c).ak = h;
            if (this.bw.item(c).dataContext != null) {
                this.bw.item(c).dataContext.item = f;
            }
            if (d != null) {
                let m = d.getBrushByValue(f, this.bv.nw);
                if (m == null) {
                    m = this.e.lb;
                }
                this.bx.add(m);
            }
            else {
                this.bx.add(this.e.lb);
            }
            c++;
        }
        this.bw.count = c;
        this.an();
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._stroke = this.bx._inner[b];
        c.ac = this.e.ey;
        if (c.y != null) {
            this.h.i(c, c.y);
        }
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._stroke = d;
        c.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        for (let c = 0; c < this.by.count; c++) {
            let d = this.by._inner[c];
            if (d._visibility != 1) {
                this.ba(d, c, b);
                a.s(d);
            }
        }
    }
    b0(a) {
        this.bw.count = 0;
        this.an();
    }
    ai(a) {
        super.ai(a);
        let b = new List$1(Tuple$2.$.specialize(Number_$type, Path.$), 0);
        if (this.bu != null) {
            for (let c = 0; c < this.bw.count; c++) {
                b.add(new Tuple$2(Number_$type, Path.$, this.bu[c], this.bw.item(c)));
            }
        }
        b.aa((d, e) => {
            if (d.c < e.c) {
                return -1;
            }
            else if (d.c > e.c) {
                return 1;
            }
            return 0;
        });
        for (let d = 0; d < b.count; d++) {
            let e = typeCast(Path.$, b._inner[d].d);
            if (e._visibility != 1) {
                this.e.a2.exportPathData(a, e, "contour" + d, ["Main "]);
            }
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.bv.fx + "</span><br/>";
        if (!stringIsNullOrEmpty(this.bv.nz)) {
            a += "<span>Value: ${item}</span>";
        }
        a += "</div>";
        return a;
    }
    b4(a, b) {
        for (let c = 0; c < this.by.count; c++) {
            let d = this.by._inner[c];
            let e = typeCast(PathGeometry.$, d.ak);
            if (e != null) {
                for (let f = 0; f < e.c.count; f++) {
                    let g = e.c._inner[f];
                    let h = e.c._inner[f]._startPoint;
                    for (let i = 0; i < g._segments.count; i++) {
                        let j = typeCast(PolyLineSegment.$, g._segments._inner[i]);
                        if (j != null) {
                            let k = this.bv.ey / 2 + this.bv.ee(b);
                            if (j._points.count > 0 && GeometryUtil.b(a, h, j._points, k)) {
                                return d;
                            }
                        }
                    }
                }
            }
        }
        return null;
    }
}
ScatterContourSeriesView.$t = markType(ScatterContourSeriesView, 'ScatterContourSeriesView', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScatterContourSeriesComponent_1;
/**
 * Series class for rendering isarithmic contours based on a triangulation of X+Y+Value points in the ItemsSource.
*/
const IgxScatterContourSeriesComponent_PROVIDERS = [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: forwardRef(() => IgxScatterContourSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterContourSeriesComponent) }];
let IgxScatterContourSeriesComponent = IgxScatterContourSeriesComponent_1 = class IgxScatterContourSeriesComponent extends IgxScatterTriangulationSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterContourSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or set the name of the property from which to retrieve the numeric values from the ItemsSource items.
    */
    get valueMemberPath() {
        return this.i.nz;
    }
    set valueMemberPath(v) {
        this.i.nz = v;
    }
    /**
     * Gets or sets the ValueBrushScale to use when determining Brushes for each contour line, based on the values found in ValueMemberPath.
    */
    get fillScale() {
        if (this.i.nu == null) {
            return null;
        }
        if (!this.i.nu.externalObject) {
            let e = IgxValueBrushScaleComponent._createFromInternal(this.i.nu);
            if (e) {
                e._implementation = this.i.nu;
            }
            this.i.nu.externalObject = e;
        }
        return this.i.nu.externalObject;
    }
    set fillScale(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.nu = null : this.i.nu = v.i;
    }
    /**
     * Gets or set the ContourValueResolver used to determine the numeric values of contours.
    */
    get valueResolver() {
        if (this.i.ns == null) {
            return null;
        }
        if (!this.i.ns.externalObject) {
            let e = IgxContourValueResolverComponent._createFromInternal(this.i.ns);
            if (e) {
                e._implementation = this.i.ns;
            }
            this.i.ns.externalObject = e;
        }
        return this.i.ns.externalObject;
    }
    set valueResolver(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.ns = null : this.i.ns = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.fillScale && this.fillScale.name && this.fillScale.name == name) {
            return this.fillScale;
        }
        if (this.valueResolver && this.valueResolver.name && this.valueResolver.name == name) {
            return this.valueResolver;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.fillScale && this.fillScale._styling) {
            this.fillScale._styling(container, component, this);
        }
        if (this.valueResolver && this.valueResolver._styling) {
            this.valueResolver._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterContourSeriesComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxValueBrushScaleComponent),
    __metadata("design:paramtypes", [IgxValueBrushScaleComponent])
], IgxScatterContourSeriesComponent.prototype, "fillScale", null);
__decorate([
    Input(),
    __metadata("design:type", IgxContourValueResolverComponent),
    __metadata("design:paramtypes", [IgxContourValueResolverComponent])
], IgxScatterContourSeriesComponent.prototype, "valueResolver", null);
IgxScatterContourSeriesComponent = IgxScatterContourSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-contour-series',
        template: ``,
        providers: [{ provide: IgxScatterTriangulationSeriesComponent, useExisting: forwardRef(() => IgxScatterContourSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterContourSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterContourSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterContourSeriesModule = class IgxScatterContourSeriesModule {
};
IgxScatterContourSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterContourSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterContourSeriesComponent],
        entryComponents: []
    })
], IgxScatterContourSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterContourSeriesDynamicModule = class IgxScatterContourSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterContourSeriesComponent", IgxScatterContourSeriesComponent);
        TypeRegistrar.register("ScatterContourSeries", ScatterContourSeries.$type);
    }
};
IgxScatterContourSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterContourSeriesModule],
        exports: [IgxScatterContourSeriesModule],
        entryComponents: [IgxScatterContourSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterContourSeriesDynamicModule);

class IgxStyleShapeEventArgs {
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets or sets the fill brush.
    */
    get shapeFill() {
        return this.i.shapeStyle ? this.i.shapeStyle.fill : null;
    }
    set shapeFill(v) {
        this.ensureShapeStyle();
        this.i.shapeStyle.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get shapeStroke() {
        return this.i.shapeStyle ? this.i.shapeStyle.stroke : null;
    }
    set shapeStroke(v) {
        this.ensureShapeStyle();
        this.i.shapeStyle.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get shapeStrokeThickness() {
        return this.i.shapeStyle ? this.i.shapeStyle.strokeThickness : NaN;
    }
    set shapeStrokeThickness(v) {
        this.ensureShapeStyle();
        this.i.shapeStyle.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get shapeOpacity() {
        return this.i.shapeStyle ? this.i.shapeStyle.opacity : NaN;
    }
    set shapeOpacity(v) {
        this.ensureShapeStyle();
        this.i.shapeStyle.opacity = +v;
    }
    ensureShapeStyle() {
        if (this.i.shapeStyle) {
            return;
        }
        this.i.shapeStyle = new Style();
    }
}

/**
 * Series class for rendering polygons.
*/
const IgxShapeSeriesBaseComponent_PROVIDERS = [{ provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxShapeSeriesBaseComponent) }];
class IgxShapeSeriesBaseComponent extends IgxSeriesComponent {
    constructor() {
        super();
        this._styleShape = null;
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The name of the property on ItemsSource items which, for each shape, contains a list of points to be converted to a polygon.
     * To be consistent with the Shapefile technical description, it is expected that each list of points is defined as an IEnumerable of IEnumerable of Point, or in other words, a list of lists of points.
    */
    get shapeMemberPath() {
        return this.i.m4;
    }
    set shapeMemberPath(v) {
        this.i.m4 = v;
    }
    /**
     * Gets or sets the effective x-axis for the current ScatterBase object.
    */
    get xAxis() {
        if (this.i.mg == null) {
            return null;
        }
        if (!this.i.mg.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.mg);
            if (e) {
                e._implementation = this.i.mg;
            }
            this.i.mg.externalObject = e;
        }
        return this.i.mg.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mg = null : this.i.mg = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current ScatterBase object.
    */
    get yAxis() {
        if (this.i.mi == null) {
            return null;
        }
        if (!this.i.mi.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.mi);
            if (e) {
                e._implementation = this.i.mi;
            }
            this.i.mi.externalObject = e;
        }
        return this.i.mi.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.mi = null : this.i.mi = v.i;
    }
    /**
     * The resolution at which to filter out shapes in the series.  For example, if the ShapeFilterResolution is set to 3, then elements with a bounding rectangle smaller than 3 X 3 pixels will be filtered out.
     * In the case of ScatterPolylineSeries, the resolution is compared to either dimension, rather than both.  In other words, a polyline will not be filtered if its height or its width exceeds the value of this property.  Whereas with a ShapeSeries, both the height and the width must exceed the value of this property.
    */
    get shapeFilterResolution() {
        return this.i.my;
    }
    set shapeFilterResolution(v) {
        this.i.my = +v;
    }
    /**
     * Gets whether or not this series is a shape series
    */
    get isShape() {
        return this.i.c5;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    getItemValue(item, memberPathName) {
        let iv = this.i.fs(item, memberPathName);
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.mn(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.mm(axis);
        return (iv);
    }
    /**
     * Raised when tile's image URI should be provided
    */
    get styleShape() {
        if (this._styleShape == null) {
            this._styleShape = new EventEmitter();
            this.i.styleShape = delegateCombine(this.i.styleShape, (o, e) => {
                let outerArgs = new IgxStyleShapeEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeStyleShape) {
                    this.beforeStyleShape(this, outerArgs);
                }
                this._styleShape.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._styleShape;
    }
}
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxShapeSeriesBaseComponent.prototype, "shapeMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxShapeSeriesBaseComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxShapeSeriesBaseComponent.prototype, "yAxis", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxShapeSeriesBaseComponent.prototype, "shapeFilterResolution", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxShapeSeriesBaseComponent.prototype, "styleShape", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class FlattenedShape extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.c = null;
    }
}
FlattenedShape.$t = markType(FlattenedShape, 'FlattenedShape');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StyleShapeEventArgs extends EventArgs {
    constructor(a, b, c) {
        super();
        this._item = null;
        this._container = null;
        this._shapeStyle = null;
        this.item = a;
        this.container = b;
        this.shapeStyle = c;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get container() {
        return this._container;
    }
    set container(a) {
        this._container = a;
    }
    get shapeStyle() {
        return this._shapeStyle;
    }
    set shapeStyle(a) {
        this._shapeStyle = a;
    }
    d() {
        return this.shapeStyle;
    }
}
StyleShapeEventArgs.$t = markType(StyleShapeEventArgs, 'StyleShapeEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ShapeHitRegion extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.a = null;
        this.b = 0;
        this.c = null;
    }
}
ShapeHitRegion.$t = markType(ShapeHitRegion, 'ShapeHitRegion');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ShapeSeriesBase extends Series {
    constructor() {
        super();
        this.mk = null;
        this.mf = null;
        this.mh = null;
        this.mx = 0;
        this.mt = null;
        this.mb = null;
        this.md = null;
        this.mc = null;
        this.ma = null;
        this.nj = null;
        this.mz = 0;
        this.styleShape = null;
        FastItemObjectColumn.m();
        this.mz = this.my;
        this.nj = Rect.empty;
    }
    h1() {
        super.h1();
        this.mg = null;
        this.mi = null;
    }
    ag() {
        return [this.mg, this.mi];
    }
    fs(a, b) {
        let c = this.g2(b);
        if (c == ShapeSeriesBase.$$p[1]) {
            return this.ft(a, b, this.m4);
        }
        return null;
    }
    get ml() {
        return this.mk;
    }
    set ml(a) {
        let b = this.ml != a;
        if (b) {
            let c = this.ml;
            this.mk = a;
            this.raisePropertyChanged("ShapeColumn", c, this.ml);
        }
    }
    mo(array_) {
        let a = (Array.isArray(array_));
        return a;
    }
    static mq(a) {
        if (a == null) {
            return true;
        }
        let val_ = a;
        return (val_ == undefined);
    }
    convertToListList(a) {
        if (a == null) {
            return null;
        }
        let b = new List$1(List$1.$.specialize(Point_$type), 0);
        let c;
        let curr_;
        let d;
        let e;
        let f = false;
        let g = false;
        for (let h = 0; h < a.length; h++) {
            c = a[h];
            if (c == null) {
                continue;
            }
            let i = new List$1(Point_$type, 0);
            for (let j = 0; j < c.length; j++) {
                curr_ = c[j];
                if (f) {
                    d = (curr_.X);
                    e = (curr_.Y);
                }
                else {
                    d = (curr_.x);
                    e = (curr_.y);
                }
                if (!g) {
                    if ((isNaN_(d) || ShapeSeriesBase.mq(d)) && (isNaN_(e) || ShapeSeriesBase.mq(e))) {
                        d = (curr_.X);
                        e = (curr_.Y);
                        if (!isNaN_(d) && !ShapeSeriesBase.mq(d) && !isNaN_(e) && !ShapeSeriesBase.mq(e)) {
                            g = true;
                            f = true;
                        }
                    }
                    else {
                        g = true;
                    }
                }
                i.add({ $type: Point_$type, x: d, y: e });
            }
            b.add(i);
        }
        return b;
    }
    by(a) {
        if (this.bz != null && this.mo(this.itemsSource) && a != null && a.split('!').length != 2) {
            if (this.coercionMethods == null) {
                this.coercionMethods = {};
            }
            let methods_ = this.coercionMethods;
            methods_.convertToListList = this.convertToListList;
            a += "!convertToListList";
        }
        return super.by(a);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        let e = false;
        let f = false;
        switch (b) {
            case "FastItemsSource":
                let g = typeCast(IFastItemsSource_$type, c);
                if (g != null) {
                    g.deregisterColumn(this.ml);
                    this.ml = null;
                }
                let h = typeCast(IFastItemsSource_$type, d);
                if (h != null) {
                    this.ml = this.by(this.m4);
                }
                e = this.mg != null && !this.mg.cn();
                f = this.mi != null && !this.mi.cn();
                if (e || f) {
                    this.jl(false);
                }
                break;
            case ShapeSeriesBase.$$p[1]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.ml);
                    this.ml = this.by(this.m4);
                }
                break;
            case "ShapeColumn":
                this.nc();
                e = this.mg != null && !this.mg.cn();
                f = this.mi != null && !this.mi.cn();
                if (e || f) {
                    this.jl(false);
                }
                this.it();
                break;
            case ShapeSeriesBase.$$p[2]:
            case ShapeSeriesBase.$$p[3]:
                this.mf = this.mg;
                this.mh = this.mi;
                let i = c;
                let j = d;
                this.nd(i);
                this.m9(j);
                if ((j != null && !j.cn()) || (j == null && i != null)) {
                    this.jl(false);
                }
                this.it();
                break;
            case "Resolution":
                this.mx = this.eu;
                this.it();
                break;
            case "ActualBrush":
                this.jl(false);
                break;
            case ShapeSeriesBase.$$p[0]:
                this.mz = this.my;
                this.jl(false);
                this.it();
                break;
            case "Thickness":
                this.jl(false);
                this.it();
                break;
        }
    }
    mn(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    mm(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    nc() {
        this.mt = null;
        if (this.ml == null) {
            return;
        }
        this.mt = new List$1(Rect.$, 2, this.ml.count);
        for (let a = 0; a < this.ml.count; a++) {
            this.mt.add(PointCollectionUtil.j(this.ml.item(a)));
        }
    }
    nk(a) {
        if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
            return PointCollectionUtil.h(a);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
            return PointCollectionUtil.g(a);
        }
        return Rect.empty;
    }
    mv(a, b, c, d, e, f, g) {
        return this.mw(a, b, c, d, e, f, g);
        if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
            return this.mw(a, b, c, d, e, f, g);
        }
        else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
            let h = c;
            let i = new List$1(FlattenedShape.$, 0);
            let j = null;
            for (let k of fromEnum(h)) {
                j = this.me(a, b, PointCollectionUtil.b(k), d, e, f, g);
                if (j == null) {
                    continue;
                }
                i.add(j);
            }
            return i;
        }
        else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
            let l = c;
            let m = this.me(a, b, PointCollectionUtil.b(l), d, e, f, g);
            let n = new List$1(FlattenedShape.$, 0);
            if (m != null) {
                n.add(m);
            }
            return n;
        }
        else {
            throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
        }
    }
    get_mp() {
        return true;
    }
    get mp() {
        return this.get_mp();
    }
    ms() {
        return false;
    }
    jm(a) {
        this.nb(this.bi);
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        this.nb(f);
    }
    nb(a) {
        if (this.cc(a)) {
            return;
        }
        let b;
        let c;
        let d = a;
        let e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        if (c.width < 1 || c.height < 1 || this.ml == null) {
            return;
        }
        let f = this.mg;
        let g = this.mi;
        let h = this.getEffectiveViewport1(a);
        let i = new ScalerParams(1, b, c, f.ca);
        i.c = h;
        let j = new ScalerParams(1, b, c, g.ca);
        j.c = h;
        d.cj();
        let k = new Rect(0, 0, 0, 0, 0);
        let l;
        let m;
        let n;
        let o;
        let p = this.ml.count;
        if (this.md == null || this.md.length != p) {
            this.md = new Array(p);
            this.mb = new Array(p);
            this.mc = new Array(p);
            this.ma = new Array(p);
        }
        let q = this.md;
        let r = this.mb;
        let s = this.mc;
        let t = this.ma;
        let u;
        for (let v = 0; v < p; v++) {
            u = this.mt._inner[v];
            q[v] = u.top;
            r[v] = u.left;
            s[v] = u.right;
            t[v] = u.bottom;
        }
        this.mf.gs(boxArray$1(r), 0, r.length, i);
        this.mf.gs(boxArray$1(s), 0, s.length, i);
        this.mh.gs(boxArray$1(q), 0, q.length, j);
        this.mh.gs(boxArray$1(t), 0, t.length, j);
        d.ck(r, q, s, t);
        let w = this.ml;
        let x = this.bz;
        this.ne(d);
        let y = c.left;
        let z = c.right;
        let aa = c.top;
        let ab = c.bottom;
        let ac = null;
        if (this.nj.isEmpty) {
            ac = null;
        }
        else {
            ac = new Clipper(1, this.nj.left, this.nj.bottom, this.nj.right, this.nj.top, this.mp);
        }
        let ad = this.ms();
        if (ad) {
            d.b3.clear();
        }
        let ae = false;
        let af = true;
        let ag = 0;
        if (this.bs != null) {
            if (this.bs.d1()) {
                let ah = this.bs.h4(b, i);
                ae = ah.c;
                ag = ah.d;
            }
        }
        let ai;
        for (let aj = 0; aj < p; aj++) {
            n = r[aj];
            l = q[aj];
            m = t[aj];
            o = s[aj];
            k.x = Math.min(n, o);
            k.y = Math.min(l, m);
            k.width = Math.max(n, o) - k.x;
            k.height = Math.max(l, m) - k.y;
            if (k.intersectsWith(c)) {
                if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                    ai = ac;
                }
                else {
                    ai = null;
                }
                let ak = this.mv(a, ai, w.item(aj), i, j, 0, ag);
                if (ad) {
                    ShapeSeriesBase.na(d, aj, ak);
                }
                d.b8(aj, x.item(aj), k, ak);
            }
            else if (ae) {
                k.x = k.x + ag;
                if (k.intersectsWith(c)) {
                    if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                        ai = ac;
                    }
                    else {
                        ai = null;
                    }
                    let al = this.mv(a, ai, w.item(aj), i, j, ag, ag);
                    if (ad) {
                        ShapeSeriesBase.na(d, aj, al);
                    }
                    d.b8(aj, x.item(aj), k, al);
                }
            }
        }
        d.ci();
    }
    static na(a, b, c) {
        let d = 0;
        let e = null;
        for (let f = 0; f < c.count; f++) {
            let g = c._inner[f];
            let h = g.b.width * g.b.height;
            if (h > d) {
                d = h;
                e = g;
            }
        }
        a.b3.addItem(b, e);
    }
    ik() {
        super.ik();
        if (this.mg != null) {
            this.mg.ha();
        }
        if (this.mi != null) {
            this.mi.ha();
        }
    }
    j1(a, b) {
        this.jl(false);
    }
    j0(a, b) {
        this.jl(false);
    }
    h6(a, b, c, d) {
        super.h6(a, b, c, d);
        switch (a) {
            case 3:
                if (d == this.m4) {
                    this.mt._inner[b] = this.nk(this.ml.item(b));
                }
                break;
            case 1:
                for (let e = b; e < b + c; e++) {
                    this.mt.insert(e, this.nk(this.ml.item(e)));
                }
                break;
            case 0:
                this.mt.v(b, c);
                break;
            case 2:
                for (let f = b; f < b + c; f++) {
                    this.mt._inner[f] = this.nk(this.ml.item(f));
                }
                break;
            case 4:
                this.nc();
                break;
        }
        this.jl(false);
    }
    dw(a, b, c) {
        let d = true;
        if (!super.dw(a, b, c) || (this.mr && this.ml == null) || b.isEmpty || a.isEmpty || this.mg == null || this.mi == null || this.mg.bh == null || this.mi.bh == null || this.mg.kc == this.mg.kb || this.mi.kc == this.mi.kb || this.ml == null || this.ml.count == 0 || this.mt == null || this.mt.count == 0 || this.mt.count != this.ml.count) {
            d = false;
        }
        return d;
    }
    get_mr() {
        return true;
    }
    get mr() {
        return this.get_mr();
    }
    i2(a) {
        super.i2(a);
        this.mj = typeCast(ShapeSeriesViewBase.$, a);
    }
    mw(a, b, c, d, e, f, g) {
        let h = new List$1(FlattenedShape.$, 0);
        let i;
        let j = c.count;
        for (let k = 0; k < j; k++) {
            i = c._inner[k];
            let l = this.me(a, b, i, d, e, f, g);
            if (l == null) {
                continue;
            }
            h.add(l);
        }
        return h;
    }
    me(a, b, c, d, e, f, g) {
        let h = this.m8(c, d, e);
        let i = h.c;
        let j = h.d;
        let k = i.length;
        let l = 1.7976931348623157E+308;
        let m = 1.7976931348623157E+308;
        let n = -1.7976931348623157E+308;
        let o = -1.7976931348623157E+308;
        let p;
        let q;
        if (f != 0) {
            for (let r = 0; r < k; r++) {
                i[r] = i[r] + f;
            }
        }
        for (let s = 0; s < k; s++) {
            p = i[s];
            q = j[s];
            l = p < l ? p : l;
            m = q < m ? q : m;
            n = p > n ? p : n;
            o = q > o ? q : o;
        }
        let t = !(l > this.nj.right || n < this.nj.left || m > this.nj.bottom || o < this.nj.top);
        if (!t && f == 0 && g != 0) {
            if (g != 0) {
                for (let u = 0; u < k; u++) {
                    i[u] = i[u] + g;
                }
            }
            for (let v = 0; v < k; v++) {
                p = i[v];
                q = j[v];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            t = !(l > this.nj.right || n < this.nj.left || m > this.nj.bottom || o < this.nj.top);
        }
        if (!t) {
            return null;
        }
        let w = b != null && (l < this.nj.left || m < this.nj.top || n > this.nj.right || o > this.nj.bottom);
        let x = new Rect(0, l, m, n - l, o - m);
        if (!a.b2(x)) {
            return null;
        }
        l = l < this.nj.left ? this.nj.left : l;
        n = n > this.nj.right ? this.nj.right : n;
        m = m < this.nj.top ? this.nj.top : m;
        o = o > this.nj.bottom ? this.nj.bottom : o;
        let y = PolySimplification.b(h, this.eu);
        let z = new DefaultFlattener().c(h.c, h.d, y, this.mx);
        let aa = z.count;
        if (w) {
            let ab = new List$1(Point_$type, 0);
            b.i = ab;
            for (let ac = 0; ac < aa; ac++) {
                b.j(z._inner[ac]);
            }
            b.i = null;
            z = ab;
        }
        if (z == null || z.count == 0) {
            return null;
        }
        let ad = new FlattenedShape();
        ad.a = z;
        ad.b = new Rect(0, l, m, n - l, o - m);
        ad.c = x;
        return ad;
    }
    m8(a, b, c) {
        let d = this.mf;
        let e = this.mh;
        let f = a.count;
        let g = new Array(f);
        let h = new Array(f);
        for (let i = 0; i < f; i++) {
            g[i] = a._inner[i].x;
            h[i] = a._inner[i].y;
        }
        d.gs(boxArray$1(g), 0, g.length, b);
        e.gs(boxArray$1(h), 0, h.length, c);
        return new Tuple$2(Array_$type, Array_$type, g, h);
    }
    ne(a) {
        a.cp();
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.cd();
    }
    m9(a) {
        if (a != null) {
            a.ck(this);
        }
    }
    nd(a) {
        if (a != null) {
            a.bx(this);
        }
    }
    ar(a, b) {
        let c = this.mj.cr(a, b);
        let d = null;
        if (c != null) {
            d = c.dataContext;
        }
        if (d != null) {
            return d;
        }
        return super.ar(a, b);
    }
    m1(a) {
        return this.bz.item(a);
    }
    get_dq() {
        return true;
    }
    set_dq(a) {
        super.set_dq(a);
    }
    an(a) {
        if (typeCast(NumericXAxis.$, a) !== null && this.mt != null) {
            let b = 1.7976931348623157E+308;
            let c = -1.7976931348623157E+308;
            for (let d of fromEnum(this.mt)) {
                b = Math.min(b, d.left);
                c = Math.max(c, d.right);
            }
            return new AxisRange(b, c);
        }
        if (typeCast(NumericYAxis.$, a) !== null && this.mt != null) {
            let e = 1.7976931348623157E+308;
            let f = -1.7976931348623157E+308;
            for (let g of fromEnum(this.mt)) {
                e = Math.min(e, g.top);
                f = Math.max(f, g.bottom);
            }
            return new AxisRange(e, f);
        }
        return null;
    }
    get_c5() {
        return true;
    }
    nl(a, b, c) {
        if (this.styleShape != null) {
            if (this.mj.cx != null && c == this.mj.cx) {
                c = new Style();
                let d = this.mj.cx;
                c.fill = d.fill;
                c.opacity = d.opacity;
                c.stroke = d.stroke;
                c.strokeThickness = d.strokeThickness;
            }
            else {
                if (c != null) {
                    let e = new Style();
                    e.fill = c.fill;
                    e.opacity = c.opacity;
                    e.stroke = c.stroke;
                    e.strokeThickness = c.strokeThickness;
                    c = e;
                }
                else {
                    c = new Style();
                }
            }
            let f = new StyleShapeEventArgs(a, b, c);
            this.styleShape(this, f);
            return f.d();
        }
        return null;
    }
}
ShapeSeriesBase.$t = markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$);
ShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['ShapeFilterResolution:my:nf', [1, 2], 'ShapeMemberPath:m4:ng', [2, null], 'XAxis:mg:nh', [NumericXAxis.$, null], 'YAxis:mi:ni', [NumericYAxis.$, null]]);
/**
 * @hidden
 */
class ShapeSeriesViewBase extends SeriesView {
    constructor(a) {
        super(a);
        this.b3 = null;
        this.by = null;
        this.b4 = new List$1(ShapeHitRegion.$, 0);
        this.b7 = 0;
        this.b6 = null;
        this.b1 = null;
        this.bz = null;
        this.cw = null;
        this.bv = null;
        this.bx = null;
        this.bw = null;
        this.bu = null;
        this.by = a;
        this.b1 = this.b0();
        this.b6 = new List$1(Path.$, 0);
        this.b3 = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
    }
    b0() {
        return ((() => {
            let $ret = new Pool$1(FrameworkElement.$);
            $ret.create = runOn(this, this.cq);
            $ret.activate = runOn(this, this.cf);
            $ret.disactivate = runOn(this, this.cg);
            $ret.destroy = runOn(this, this.ch);
            return $ret;
        })());
    }
    b2(a) {
        return a.width >= this.by.mz && a.height >= this.by.mz;
    }
    static b5(a) {
        let b = new List$1(PointCollection.$, 0);
        let c;
        let d = a.count;
        for (let e = 0; e < d; e++) {
            c = a._inner[e];
            let f = new PointCollection(1, c.a);
            b.add(f);
        }
        return b;
    }
    b8(a, b, c, d) {
        if (d != null && d.count > 0) {
            let e = ShapeSeriesViewBase.b5(d);
            c.intersect(this.br);
            if (!this.b2(c)) {
            }
            else {
                let f = this.cu(a, e);
                if (f != null) {
                    let g = this.ct(this.b7, b);
                    for (let h = 0; h < d.count; h++) {
                        let i = new ShapeHitRegion();
                        i.d = d._inner[h].b;
                        i.a = d._inner[h].a;
                        i.b = a;
                        i.c = g;
                        this.b4.add(i);
                    }
                    this.ce(g);
                    this.ca(g, f);
                    this.cc(g, b);
                    this.b7 = this.b7 + 1;
                }
            }
        }
    }
    ct(a, b) {
        let c = this.b1.item(this.b7);
        if (c.dataContext != null) {
            c.dataContext.item = b;
        }
        return c;
    }
    static cb(a, b, c) {
        if (b._fill == null) {
            b._fill = a.e.lb;
        }
        if (b._stroke == null) {
            b._stroke = a.e.lc;
        }
        if (b.y == null) {
            b.ac = a.e.ey;
        }
    }
    cc(a, b) {
        if (a == null) {
            return;
        }
        let c = false;
        if (this.bz != null) {
            let d = this.bz.selectStyle(b, a);
            if (d != null) {
                c = true;
            }
            a.y = d;
        }
        if (!c) {
            a.y = this.cw;
        }
        a.y = this.by.nl(b, a, a.y);
    }
    ce(a) {
    }
    b9(a, b) {
        let c = truncate(Math.floor(a.left));
        let d = truncate(Math.ceil(a.right));
        let e = truncate(Math.floor(a.top));
        let f = truncate(Math.ceil(a.bottom));
        for (let g = c; g < d; g++) {
            for (let h = e; h < f; h++) {
                this.cm(g, h, b);
            }
        }
    }
    cm(a, b, c) {
    }
    cj() {
        this.b7 = 0;
    }
    ci() {
        this.b1.count = this.b7;
        this.an();
    }
    cl(a, b) {
    }
    cd() {
        this.b1.count = 0;
        this.an();
    }
    cq() {
        let a = this.by;
        let b = ((() => {
            let $ret = new Path();
            $ret.dataContext = ((() => {
                let $ret = new DataContext();
                $ret.series = a;
                return $ret;
            })());
            return $ret;
        })());
        this.b6.add(b);
        return b;
    }
    cf(a) {
        a._visibility = 0;
    }
    cg(a) {
        a.dataContext.item = null;
        a._visibility = 1;
    }
    ch(a) {
        this.b6.remove(a);
    }
    cv(a, b, c) {
        if (b == null) {
            return null;
        }
        let d = new PathGeometry();
        let e;
        let f = b.count;
        for (let g = 0; g < f; g++) {
            e = b._inner[g];
            if (e.count < 1) {
                continue;
            }
            let h = new PolyLineSegment();
            h._points = e;
            let i = new PathFigure();
            i._isFilled = c;
            i._isClosed = c;
            i._startPoint = e._inner[0];
            i._segments.add(h);
            d.c.add(i);
        }
        return d;
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._fill = this.e.lb;
        c._stroke = this.e.lc;
        c.ac = this.e.ey;
        if (c.y != null) {
            this.h.i(c, c.y);
        }
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        for (let c = 0; c < this.b6.count; c++) {
            let d = this.b6._inner[c];
            if (d._visibility != 1) {
                this.ba(d, c, b);
                a.s(d);
            }
        }
    }
    get cx() {
        return this.cw;
    }
    co(a) {
        this.bz = a;
    }
    cn(a) {
        this.cw = a;
    }
    cr(a, b) {
        return this.cs(a, b, false);
    }
    cs(a, b, c) {
        if (this.b4.count == 0) {
            return null;
        }
        let d = a.x;
        let e = a.y;
        let f = this.b4.count;
        let g = this.b4;
        let h = null;
        for (let i = 0; i < f; i++) {
            h = g._inner[i];
            if (h.a == null || h.a.count == 0) {
                continue;
            }
            if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                if (c) {
                    let j = this.by.ey / 2 + this.by.ee(b);
                    if (GeometryUtil.b(a, h.a._inner[0], h.a, j)) {
                        return h.c;
                    }
                }
                else {
                    if (PolygonUtil.a(h.a, a)) {
                        return h.c;
                    }
                }
            }
        }
        return null;
    }
    ck(a, b, c, d) {
        this.bv = a;
        this.bx = b;
        this.bw = c;
        this.bu = d;
        this.b4.clear();
    }
    cp() {
        let a = this.br;
        let b = ((() => {
            let $ret = new Path();
            $ret.y = this.cw;
            return $ret;
        })());
        b.ac = 1;
        if (this.h != null) {
            this.h.i(b, b.y);
        }
        this.by.nj = RectUtil.r(a, b.ac);
    }
    ai(a) {
        super.ai(a);
        if (this.b1.a == null) {
            return;
        }
        for (let b = 0; b < this.b1.a.count; b++) {
            let c = typeCast(Path.$, this.b1.a._inner[b]);
            if (c._visibility != 1) {
                this.e.a2.exportPathData(a, c, "shape" + b, ["Main "]);
            }
        }
    }
}
ShapeSeriesViewBase.$t = markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ShapeAxisInfoCache extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.b = null;
        this.e = false;
        this.f = false;
        this.d = null;
        this.c = null;
    }
}
ShapeAxisInfoCache.$t = markType(ShapeAxisInfoCache, 'ShapeAxisInfoCache');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StyleSelector extends Base {
    selectStyle(a, b) {
        return null;
    }
}
StyleSelector.$t = markType(StyleSelector, 'StyleSelector');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerVisualData extends Base {
    constructor() {
        super(...arguments);
        this._x = 0;
        this._y = 0;
        this._index = 0;
        this._markerAppearance = null;
        this._markerType = null;
        this._contentTemplate = null;
        this._isVisible = false;
        this._bounds = null;
    }
    get x() {
        return this._x;
    }
    set x(a) {
        this._x = a;
    }
    get y() {
        return this._y;
    }
    set y(a) {
        this._y = a;
    }
    get index() {
        return this._index;
    }
    set index(a) {
        this._index = a;
    }
    get markerAppearance() {
        return this._markerAppearance;
    }
    set markerAppearance(a) {
        this._markerAppearance = a;
    }
    get markerType() {
        return this._markerType;
    }
    set markerType(a) {
        this._markerType = a;
    }
    get contentTemplate() {
        return this._contentTemplate;
    }
    set contentTemplate(a) {
        this._contentTemplate = a;
    }
    get isVisible() {
        return this._isVisible;
    }
    set isVisible(a) {
        this._isVisible = a;
    }
    serialize() {
        return "{ x: " + this.x + ", y: " + this.y + ", index: " + this.index + ", markerAppearance: " + (this.markerAppearance != null ? this.markerAppearance.serialize() : "null") + ", markerType: \"" + this.markerType + "\", isVisible: " + (this.isVisible ? "true" : "false") + ", " + "bounds: { left: " + this.bounds.left + ", top:" + this.bounds.top + ", width:" + this.bounds.width + ", height: " + this.bounds.height + "} }";
    }
    i(a) {
        this.x = (this.x - a.left) / a.width;
        this.y = (this.y - a.top) / a.height;
        if (this.bounds != null) {
            let b = (this.bounds.left - a.left) / a.width;
            let c = (this.bounds.top - a.top) / a.height;
            let d = ((this.bounds.left + this.bounds.width) - a.left) / a.width;
            let e = ((this.bounds.top + this.bounds.height) - a.top) / a.height;
            this.bounds = new RectData(b, c, d - b, e - c);
        }
    }
    get bounds() {
        return this._bounds;
    }
    set bounds(a) {
        this._bounds = a;
    }
}
MarkerVisualData.$t = markType(MarkerVisualData, 'MarkerVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterPolygonSeries extends ShapeSeriesBase {
    constructor() {
        super();
        this.nt = null;
        this.nq = new ScalerParams(1, ScatterPolygonSeries.os, ScatterPolygonSeries.os, false);
        this.nr = new ScalerParams(1, ScatterPolygonSeries.os, ScatterPolygonSeries.os, false);
        this.ab = ScatterPolygonSeries.$;
    }
    ms() {
        return this.nv();
    }
    nb(a) {
        let b = a;
        b.cn(this.ou);
        b.co(this.nu);
        super.nb(a);
        if (this.cc(a)) {
            return;
        }
        let c, d;
        let e = a.getViewInfo(c, d);
        c = e.p0;
        d = e.p1;
        let f = this.getEffectiveViewport1(a);
        this.nq = new ScalerParams(1, d, c, this.mg.ca);
        this.nq.c = f;
        this.nr = new ScalerParams(1, d, c, this.mi.ca);
        this.nr.c = f;
        if (c.width < 1 || c.height < 1) {
            return;
        }
        this.nt = ((() => {
            let $ret = new ShapeAxisInfoCache();
            $ret.a = this.mg;
            $ret.b = this.mi;
            $ret.e = this.mg.ca;
            $ret.f = this.mi.ca;
            $ret.d = this.bz;
            $ret.c = this.ml;
            return $ret;
        })());
        if (this.nv()) {
            let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
            b.c5.l(g, 400, d, c, this.eu);
            b.c5.j(g, false);
        }
    }
    nv() {
        return this.oa != null && ((this.np != 1 && this.np != 0) || this.ob != null);
    }
    bf() {
        return new ScatterPolygonSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.ns = a;
    }
    get_hasMarkers() {
        return true;
    }
    lg() {
        return this.oo;
    }
    lh() {
        return this.op;
    }
    j7() {
        return this.oa;
    }
    jw() {
        super.jw();
        if (this.ob != null) {
            this.ns.dd();
        }
        else {
            let a = MarkerSeries.mc(this, this.np);
            let b = MarkerSeries.ml(a);
            if (b == null) {
                this.oa = MarkerSeries.mx;
            }
            else {
                this.ns.da(b);
            }
        }
        if (this.oq != null) {
            this.ns.db();
        }
        else {
            this.oo = this.bs == null ? null : this.bs.nk(this.fh);
        }
        if (this.or != null) {
            this.ns.dc();
        }
        else {
            this.op = this.bs == null ? null : this.bs.nl(this.fh);
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ScatterPolygonSeries.$$p[3]:
            case ScatterPolygonSeries.$$p[9]:
            case ScatterPolygonSeries.$$p[5]:
            case ScatterPolygonSeries.$$p[7]:
            case ScatterPolygonSeries.$$p[8]:
                this.jw();
                this.jl(false);
                break;
            case ScatterPolygonSeries.$$p[2]:
                if (c == MarkerSeries.mx || d == MarkerSeries.mx || (c == null || d != null)) {
                    this.ns.df();
                    this.jl(false);
                }
                this.jl(false);
                this.it();
                break;
            case ScatterPolygonSeries.$$p[10]:
                this.ns.cn(this.ou);
                this.jl(false);
                this.it();
                break;
            case ScatterPolygonSeries.$$p[11]:
                this.ns.co(this.nu);
                this.jl(false);
                this.it();
                break;
            case ScatterPolygonSeries.$$p[4]:
                this.jl(false);
                this.it();
                break;
        }
    }
    ar(a, b) {
        let c = this.ns.c2(a);
        let d = null;
        if (c != null) {
            d = c.content;
        }
        if (d != null) {
            return d;
        }
        return super.ar(a, b);
    }
    n9(a, b) {
        let c = new List$1(Base.$, 0);
        for (let d of fromEnum(b.c)) {
            if (!a.containsKey(d)) {
                c.add1(d);
            }
        }
        for (let e of fromEnum(c)) {
            b.g(e);
        }
    }
    ch(a, b, c) {
        if (!this.hasMarkers) {
            return false;
        }
        let d = this.mg;
        let e = new ScalerParams(1, this.bs.n2, this.l8, d.ca);
        e.c = this.getEffectiveViewport1(this.bi);
        let f = this.mi;
        let g = new ScalerParams(1, this.bs.n2, this.l8, f.ca);
        g.c = this.getEffectiveViewport1(this.bi);
        a.clear();
        this.ns.de((h) => {
            if (h._visibility == 0) {
                let i = new SeriesPointOfInterest();
                let j = h.n;
                let k = h.o;
                if (j < this.l8.left || j > this.l8.right || k < this.l8.top || k > this.l8.bottom) {
                    return;
                }
                i.b = d.d1(j, e);
                i.c = f.d1(k, g);
                i.a = h.content;
                a.add(i);
            }
        });
        return true;
    }
    nn(a, b, c, d, e) {
        if (c == null || c.length != this.nt.d.count) {
            c = new Array(this.nt.d.count);
            for (let f = 0; f < this.nt.d.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        let g = ((() => {
            let $ret = new ScalerParams(1, d, e, this.mg.ca);
            $ret.c = this.getEffectiveViewport1(a);
            return $ret;
        })());
        let h = ((() => {
            let $ret = new ScalerParams(1, d, e, this.mi.ca);
            $ret.c = this.getEffectiveViewport1(a);
            return $ret;
        })());
        let i = this.l0(a);
        let j = this.nt.a.d1(i.left, g);
        let k = this.nt.a.d1(i.right, g);
        let l = this.nt.b.d1(i.bottom, h);
        let m = this.nt.b.d1(i.top, h);
        if (this.nt.e) {
            let n = j;
            j = k;
            k = n;
        }
        if (this.nt.f) {
            let o = l;
            l = m;
            m = o;
        }
        let p = this.nt;
        let q = p.a;
        let r = p.b;
        let s;
        let t;
        let u = g.d.left;
        let v = g.d.right;
        let w = h.d.top;
        let x = h.d.bottom;
        for (let y = 0; y < this.nt.d.count; y++) {
            s = 0;
            t = 0;
            let z = null;
            let aa = a.b3.tryGetValue(y, z);
            z = aa.p1;
            if (z == null) {
                c[y].x = NaN;
                c[y].y = NaN;
            }
            else {
                let ab = z.c;
                let ac = RectUtil.l(ab);
                s = ac.x;
                t = ac.y;
                if (s >= u && s <= v && t >= w && t <= x) {
                    c[y].x = s;
                    c[y].y = t;
                }
                else {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
            }
        }
        return c;
    }
    nm(a, b) {
        if (b == null || b.length != a.e) {
            b = new Array(a.e);
        }
        let c = 0;
        let d = this.bz;
        for (let e of fromEnum(a.c)) {
            b[c] = d.indexOf(e);
            c++;
        }
        return b;
    }
}
ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
ScatterPolygonSeries.os = new Rect(0, 0, 0, 1, 1);
ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:oo:oc', [Brush.$], 'ActualMarkerOutline:op:od', [Brush.$], 'ActualMarkerTemplate:oa:oe', [DataTemplate.$, null], 'MarkerBrush:oq:of', [Brush.$], 'MarkerCollisionAvoidance:no:og', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerOutline:or:oh', [Brush.$], 'MarkerStyle:ot:oi', [Style.$], 'MarkerTemplate:ob:oj', [DataTemplate.$, null], 'MarkerThickness:nw:ok', [1, DeviceUtils.g(2)], 'MarkerType:np:ol', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:ou:om', [Style.$, null], 'ShapeStyleSelector:nu:on', [StyleSelector.$, null]]);
/**
 * @hidden
 */
class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
    constructor(a) {
        super(a);
        this.c1 = null;
        this.c0 = null;
        this.c6 = null;
        this.c4 = null;
        this.c8 = false;
        this.c7 = null;
        this.c9 = null;
        this.dm = null;
        this.c6 = a;
        this.c7 = new HashPool$2(Base.$, Marker.$);
        this.c9 = new List$1(Marker.$, 0);
        this.dg(this.c7);
        this.c4 = new NumericMarkerManager(1, (b) => this.c7.item(b), (b) => this.c6.nt.d.item(b), runOn(this, this.dk), runOn(this, this.cz), runOn(this, this.cy), () => this.c6.no);
        this.c4.q = runOn(this, this.dn);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 8;
        }
    }
    get c5() {
        return this.c4;
    }
    dk(a) {
        this.c6.n9(a, this.c7);
    }
    cz() {
        this.c1 = this.c6.nn(this, this.c7, this.c1, this.bs, this.br);
        return this.c1;
    }
    cy() {
        this.c0 = this.c6.nm(this.c7, this.c0);
        return this.c0;
    }
    cu(a, b) {
        return this.cv(a, b, true);
    }
    cc(a, b) {
        super.cc(a, b);
        ShapeSeriesViewBase.cb(this, a, b);
    }
    ca(a, b) {
        let c = a;
        if (c == null) {
            return;
        }
        c.ak = b;
    }
    de(a) {
        this.c7.f(a);
    }
    dg(a) {
        a.create = runOn(this, this.c3);
        a.destroy = runOn(this, this.di);
        a.activate = runOn(this, this.dh);
        a.disactivate = runOn(this, this.dj);
    }
    c3() {
        let a = new Marker();
        if (!this.c8) {
            a.content = ((() => {
                let $ret = new DataContext();
                $ret.series = this.e;
                return $ret;
            })());
        }
        a.ah = this.e.oa;
        this.c9.add(a);
        return a;
    }
    di(a) {
        a.content = null;
        this.c9.remove(a);
    }
    dh(a) {
        a._visibility = 0;
    }
    dj(a) {
        if (a.content != null) {
            (typeCast(DataContext.$, a.content)).item = null;
        }
        a._visibility = 1;
    }
    dl(a) {
        this.c8 = a;
    }
    be(a, b) {
        super.be(a, b);
        let c = a;
        let d = c.content;
        if (d != null) {
            if (this.c6.oo != null) {
                d.actualItemBrush = this.c6.oo;
            }
            else {
                d.actualItemBrush = this.by.lb;
            }
            if (this.c6.oo != null) {
                d.outline = this.c6.op;
            }
            else {
                d.outline = this.by.lc;
            }
            d.thickness = 0.5;
        }
    }
    bf(a, b) {
        super.bf(a, b);
        let c = a;
        let d = this.bm(b);
        let e = c.content;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = 1 + 3;
        }
    }
    a2(a, b) {
        super.a2(a, b);
        let c = new DataTemplatePassInfo();
        c.isHitTestRender = b;
        c.context = a.g();
        c.viewportTop = this.br.top;
        c.viewportLeft = this.br.left;
        c.viewportWidth = this.br.width;
        c.viewportHeight = this.br.height;
        c.passID = "Markers";
        let d = new DataTemplateRenderInfo();
        d.passInfo = c;
        d.isHitTestRender = b;
        let e = new DataTemplateMeasureInfo();
        e.passInfo = c;
        let f = false;
        let g = a.g();
        e.context = g;
        d.context = g;
        let h = 0;
        let i = 0;
        if (this.c6.oa != null && this.c6.oa.passStarting != null) {
            this.c6.oa.passStarting(c);
        }
        for (let j = 0; j < this.c9.count; j++) {
            let k = this.c9._inner[j];
            if (k._visibility == 1) {
                continue;
            }
            this.bd(k, j, b);
            if (!f) {
                e.width = k.width;
                e.height = k.height;
                e.renderOffsetX = 0;
                e.renderOffsetY = 0;
                e.renderContext = a;
                let l = k.ah;
                if (l.measure != null) {
                    e.data = k.content;
                    l.measure(e);
                    f = e.isConstant;
                    if (f) {
                        h = e.width;
                        i = e.height;
                    }
                }
                d.availableWidth = e.width;
                d.availableHeight = e.height;
                d.renderOffsetX = e.renderOffsetX;
                d.renderOffsetY = e.renderOffsetY;
                d.renderContext = a;
            }
            else {
                d.availableWidth = h;
                d.availableHeight = i;
            }
            if (!isNaN_(k.width) && !isInfinity(k.width)) {
                d.availableWidth = k.width;
            }
            if (!isNaN_(k.height) && !isInfinity(k.height)) {
                d.availableHeight = k.height;
            }
            a.p(d, k);
            k.m = d.availableWidth;
            k.l = d.availableHeight;
            k.ai = d.renderOffsetX;
            k.aj = d.renderOffsetY;
        }
        if (this.c6.oa != null && this.c6.oa.passCompleted != null) {
            this.c6.oa.passCompleted(c);
        }
    }
    dd() {
        this.c6.oa = null;
        this.c6.oa = this.c6.ob;
    }
    db() {
        this.c6.oo = null;
        this.c6.oo = this.c6.oq;
    }
    dc() {
        this.c6.op = null;
        this.c6.op = this.c6.or;
    }
    da(a) {
        switch (a) {
            case "CircleMarkerTemplate":
                this.c6.oa = this.c6.bs.ls;
                break;
            case "TriangleMarkerTemplate":
                this.c6.oa = this.c6.bs.l1;
                break;
            case "PyramidMarkerTemplate":
                this.c6.oa = this.c6.bs.ly;
                break;
            case "SquareMarkerTemplate":
                this.c6.oa = this.c6.bs.lz;
                break;
            case "DiamondMarkerTemplate":
                this.c6.oa = this.c6.bs.lt;
                break;
            case "PentagonMarkerTemplate":
                this.c6.oa = this.c6.bs.lw;
                break;
            case "HexagonMarkerTemplate":
                this.c6.oa = this.c6.bs.lu;
                break;
            case "TetragramMarkerTemplate":
                this.c6.oa = this.c6.bs.lw;
                break;
            case "PentagramMarkerTemplate":
                this.c6.oa = this.c6.bs.lx;
                break;
            case "HexagramMarkerTemplate":
                this.c6.oa = this.c6.bs.lv;
                break;
        }
    }
    df() {
        for (let a of fromEnum(this.c9)) {
            a.ah = this.c6.oa;
        }
        this.an();
    }
    dn(a) {
        if (this.dm == null) {
            this.dm = new DataTemplateMeasureInfo();
            this.dm.context = this.h.g();
        }
        this.dm.width = a.width;
        this.dm.height = a.height;
        this.dm.data = a.content;
        let b = a.ah;
        if (b.measure != null) {
            b.measure(this.dm);
        }
        return new Size(1, this.dm.width, this.dm.height);
    }
    c2(a) {
        let b;
        let c;
        let d;
        let e;
        for (let f = this.c9.count - 1; f >= 0; f--) {
            let g = this.c9._inner[f];
            if (g._visibility == 1 || g._opacity == 0) {
                continue;
            }
            b = (g.m / 2) + 3;
            c = (g.l / 2) + 3;
            d = g.ai;
            e = g.aj;
            if ((g.n + d) - b <= a.x && (g.n + d) + b >= a.x && (g.o + e) - c <= a.y && (g.o + e) + c >= a.y) {
                return g;
            }
        }
        return null;
    }
    ai(a) {
        let b = a;
        super.ai(b);
        for (let c of fromEnum(this.c7.c)) {
            let d = this.c7.item(c);
            if (d._visibility != 1) {
                let e = typeCast(ScatterPolygonSeries.$, this.e);
                let f = this.e.a2.getMarkerVisualData(e, d, e.oa);
                b.markerShapes.add(typeCast(MarkerVisualData.$, f));
            }
        }
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.c6.fx + "</span><br/>";
        a += "</div>";
        return a;
    }
}
ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScatterPolygonSeriesComponent_1;
/**
 * Series class which renders polygons as Paths based on lists of points in the ItemsSource.
*/
const IgxScatterPolygonSeriesComponent_PROVIDERS = [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolygonSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolygonSeriesComponent) }];
let IgxScatterPolygonSeriesComponent = IgxScatterPolygonSeriesComponent_1 = class IgxScatterPolygonSeriesComponent extends IgxShapeSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterPolygonSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Returns whether the current series supports visual markers.
    */
    get hasMarkers() {
        return this.i.hasMarkers;
    }
    /**
     * The default style to apply to all Shapes in the series.
    */
    get shapeStyle() {
        if (this.i.ou == null) {
            return null;
        }
        if (!this.i.ou.externalObject) {
            let e = new IgxStyle();
            e._implementation = this.i.ou;
            this.i.ou.externalObject = e;
        }
        return this.i.ou.externalObject;
    }
    set shapeStyle(v) {
        v == null ? this.i.ou = null : this.i.ou = v.i;
    }
    /**
     * Gets or sets the marker type for the current series object.
     * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
    */
    get markerType() {
        return this.i.np;
    }
    set markerType(v) {
        this.i.np = ensureEnum(MarkerType_$type, v);
    }
    /**
     * Gets or sets the MarkerTemplate for the current series object.
    */
    get markerTemplate() {
        return this.i.ob;
    }
    set markerTemplate(v) {
        this.i.ob = v;
    }
    /**
     * Gets or sets thickness of the marker outline
    */
    get markerThickness() {
        return this.i.nw;
    }
    set markerThickness(v) {
        this.i.nw = +v;
    }
    /**
     * Gets the effective marker template for the current series object.
    */
    get actualMarkerTemplate() {
        return this.i.oa;
    }
    set actualMarkerTemplate(v) {
        this.i.oa = v;
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
    */
    get markerBrush() {
        return brushToString(this.i.oq);
    }
    set markerBrush(v) {
        this.i.oq = stringToBrush(v);
    }
    /**
     * Gets the effective marker brush for the current series object.
    */
    get actualMarkerBrush() {
        return brushToString(this.i.oo);
    }
    set actualMarkerBrush(v) {
        this.i.oo = stringToBrush(v);
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
    */
    get markerOutline() {
        return brushToString(this.i.or);
    }
    set markerOutline(v) {
        this.i.or = stringToBrush(v);
    }
    /**
     * Gets the effective marker outline for the current series object.
    */
    get actualMarkerOutline() {
        return brushToString(this.i.op);
    }
    set actualMarkerOutline(v) {
        this.i.op = stringToBrush(v);
    }
    /**
     * The desired behavior for markers in this series which are placed too close together for the current view, resulting in a collision.
    */
    get markerCollisionAvoidance() {
        return this.i.no;
    }
    set markerCollisionAvoidance(v) {
        this.i.no = ensureEnum(CollisionAvoidanceType_$type, v);
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.shapeStyle && this.shapeStyle.name && this.shapeStyle.name == name) {
            return this.shapeStyle;
        }
        return null;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxStyle),
    __metadata("design:paramtypes", [IgxStyle])
], IgxScatterPolygonSeriesComponent.prototype, "shapeStyle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterPolygonSeriesComponent.prototype, "markerType", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxScatterPolygonSeriesComponent.prototype, "markerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterPolygonSeriesComponent.prototype, "markerThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxScatterPolygonSeriesComponent.prototype, "actualMarkerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterPolygonSeriesComponent.prototype, "markerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterPolygonSeriesComponent.prototype, "actualMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterPolygonSeriesComponent.prototype, "markerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxScatterPolygonSeriesComponent.prototype, "actualMarkerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxScatterPolygonSeriesComponent.prototype, "markerCollisionAvoidance", null);
IgxScatterPolygonSeriesComponent = IgxScatterPolygonSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-polygon-series',
        template: ``,
        providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolygonSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolygonSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterPolygonSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterPolygonSeriesModule = class IgxScatterPolygonSeriesModule {
};
IgxScatterPolygonSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterPolygonSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterPolygonSeriesComponent],
        entryComponents: []
    })
], IgxScatterPolygonSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterPolygonSeriesDynamicModule = class IgxScatterPolygonSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterPolygonSeriesComponent", IgxScatterPolygonSeriesComponent);
        TypeRegistrar.register("ScatterPolygonSeries", ScatterPolygonSeries.$type);
    }
};
IgxScatterPolygonSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterPolygonSeriesModule],
        exports: [IgxScatterPolygonSeriesModule],
        entryComponents: [IgxScatterPolygonSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterPolygonSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScatterPolylineSeries extends ShapeSeriesBase {
    constructor() {
        super();
        this.ab = ScatterPolylineSeries.$;
    }
    bf() {
        return new ScatterPolylineSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.nm = a;
    }
    get_mp() {
        return false;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case ScatterPolylineSeries.$$p[0]:
                this.nm.cn(this.ns);
                this.jl(false);
                this.it();
                break;
            case ScatterPolylineSeries.$$p[1]:
                this.nm.co(this.nn);
                this.jl(false);
                this.it();
                break;
        }
    }
    nb(a) {
        let b = a;
        b.cn(this.ns);
        b.co(this.nn);
        super.nb(a);
    }
    ar(a, b) {
        let c = this.nm.cs(a, b, true);
        if (c != null) {
            return c.dataContext;
        }
        return super.ar(a, b);
    }
}
ScatterPolylineSeries.$t = markType(ScatterPolylineSeries, 'ScatterPolylineSeries', ShapeSeriesBase.$);
ScatterPolylineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolylineSeries, 'raisePropertyChanged', ['ShapeStyle:ns:nq', [Style.$, null], 'ShapeStyleSelector:nn:nr', [StyleSelector.$, null]]);
/**
 * @hidden
 */
class ScatterPolylineSeriesView extends ShapeSeriesViewBase {
    constructor(a) {
        super(a);
    }
    cu(a, b) {
        return this.cv(a, b, false);
    }
    cc(a, b) {
        super.cc(a, b);
        ShapeSeriesViewBase.cb(this, a, b);
    }
    ca(a, b) {
        let c = typeCast(Path.$, a);
        if (c == null) {
            return;
        }
        c.ak = b;
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._fill = null;
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        c._fill = null;
    }
    b2(a) {
        return a.width >= this.by.mz || a.height >= this.by.mz;
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'><span";
        let b = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.by.fx + "</span><br/>";
        a += "</div>";
        return a;
    }
}
ScatterPolylineSeriesView.$t = markType(ScatterPolylineSeriesView, 'ScatterPolylineSeriesView', ShapeSeriesViewBase.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScatterPolylineSeriesComponent_1;
/**
 * Series class used for displaying multiple polylines for datasources which contain multiple lists of points.
*/
const IgxScatterPolylineSeriesComponent_PROVIDERS = [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent) }];
let IgxScatterPolylineSeriesComponent = IgxScatterPolylineSeriesComponent_1 = class IgxScatterPolylineSeriesComponent extends IgxShapeSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScatterPolylineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The default style to apply to all Shapes in the series.
    */
    get shapeStyle() {
        if (this.i.ns == null) {
            return null;
        }
        if (!this.i.ns.externalObject) {
            let e = new IgxStyle();
            e._implementation = this.i.ns;
            this.i.ns.externalObject = e;
        }
        return this.i.ns.externalObject;
    }
    set shapeStyle(v) {
        v == null ? this.i.ns = null : this.i.ns = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.shapeStyle && this.shapeStyle.name && this.shapeStyle.name == name) {
            return this.shapeStyle;
        }
        return null;
    }
};
__decorate([
    Input(),
    __metadata("design:type", IgxStyle),
    __metadata("design:paramtypes", [IgxStyle])
], IgxScatterPolylineSeriesComponent.prototype, "shapeStyle", null);
IgxScatterPolylineSeriesComponent = IgxScatterPolylineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-scatter-polyline-series',
        template: ``,
        providers: [{ provide: IgxShapeSeriesBaseComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxScatterPolylineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScatterPolylineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterPolylineSeriesModule = class IgxScatterPolylineSeriesModule {
};
IgxScatterPolylineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxScatterPolylineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxScatterPolylineSeriesComponent],
        entryComponents: []
    })
], IgxScatterPolylineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScatterPolylineSeriesDynamicModule = class IgxScatterPolylineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxScatterPolylineSeriesComponent", IgxScatterPolylineSeriesComponent);
        TypeRegistrar.register("ScatterPolylineSeries", ScatterPolylineSeries.$type);
    }
};
IgxScatterPolylineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxScatterPolylineSeriesModule],
        exports: [IgxScatterPolylineSeriesModule],
        entryComponents: [IgxScatterPolylineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScatterPolylineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartShapeModule = class IgxDataChartShapeModule {
};
IgxDataChartShapeModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxScatterAreaSeriesModule,
            IgxScatterContourSeriesModule,
            IgxScatterPolygonSeriesModule,
            IgxScatterPolylineSeriesModule,
            IgxDataChartShapeCoreModule
        ],
        imports: [CommonModule, IgxScatterAreaSeriesModule,
            IgxScatterContourSeriesModule,
            IgxScatterPolygonSeriesModule,
            IgxScatterPolylineSeriesModule,
            IgxDataChartShapeCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartShapeModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartShapeDynamicModule = class IgxDataChartShapeDynamicModule {
};
IgxDataChartShapeDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxScatterAreaSeriesDynamicModule,
            IgxScatterContourSeriesDynamicModule,
            IgxScatterPolygonSeriesDynamicModule,
            IgxScatterPolylineSeriesDynamicModule,
            IgxDataChartShapeCoreDynamicModule,
            IgxDataChartShapeModule
        ],
        imports: [CommonModule, IgxScatterAreaSeriesDynamicModule,
            IgxScatterContourSeriesDynamicModule,
            IgxScatterPolygonSeriesDynamicModule,
            IgxScatterPolylineSeriesDynamicModule,
            IgxDataChartShapeCoreDynamicModule,
            IgxDataChartShapeModule
        ],
        entryComponents: []
    })
], IgxDataChartShapeDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryYAxis extends CategoryAxisBase {
    constructor() {
        super();
        this.k6 = 0;
        this.k7 = 0;
        this.le = 1;
        this.ld = 1;
        this.ju = new List$1(Number_$type, 0);
        this.ab = CategoryYAxis.$;
    }
    a3() {
        return new CategoryYAxisView(this);
    }
    gx(a) {
        super.gx(a);
        this.k5 = a;
    }
    get_ch() {
        return true;
    }
    dx() {
        return this.i9.height;
    }
    k2(a, b, c) {
        return this.k3(a, b, c, true);
    }
    k4(a) {
        if (typeCast(List$1.$.specialize(Array_$type), a) !== null) {
            return a.asArray();
        }
        return null;
    }
    gr(a, b, c, d, e) {
        let f;
        let g = e.e;
        let h = e.d;
        let i = e.c;
        let j = e.a;
        let k = !i.isEmpty;
        let l = this.categoryMode == 0 ? this.j7 - 1 : this.j7;
        if (l < 0) {
            l = 0;
        }
        let m = i.top;
        let n = i.height;
        let o = g.top;
        let p = g.height;
        let q = h.top;
        let r = h.height;
        let s = 0;
        let t = 1;
        let u = this.k4(a);
        let v = false;
        if (u != null) {
            v = true;
        }
        let w;
        for (let x = 0; x < b.count; x++) {
            w = b.item(x);
            for (let y = c; y < d; y++) {
                if (v) {
                    f = u[y];
                }
                else {
                    f = a.item(y);
                }
                if (k) {
                    let z = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        z = 1 - z;
                    }
                    z = m + n * (z - s) / t;
                    let aa = (z - (o * r)) / p;
                    f[w] = aa;
                }
                else {
                    let ab = l >= 1 ? (f[w]) / (l) : l == 0 ? 0.5 : NaN;
                    if (!j) {
                        ab = 1 - ab;
                    }
                    ab = q + r * (ab - o) / p;
                    f[w] = ab;
                }
            }
        }
    }
    get lb() {
        return this.c(CategoryYAxis.ln);
    }
    set lb(a) {
        this.h(CategoryYAxis.ln, a);
    }
    get k8() {
        return this.k6;
    }
    set k8(a) {
        if (this.k8 != a) {
            let b = this.k6;
            this.k6 = a;
            this.g5("ActualInterval", b, this.k8);
        }
    }
    d9() {
        return this.k8;
    }
    get lc() {
        return this.c(CategoryYAxis.lo);
    }
    set lc(a) {
        this.h(CategoryYAxis.lo, a);
    }
    get k9() {
        return this.k7;
    }
    set k9(a) {
        if (this.k9 != a) {
            let b = this.k7;
            this.k7 = a;
            this.g5("ActualMinorInterval", b, this.k9);
        }
    }
    get lg() {
        return this.le;
    }
    set lg(a) {
        this.le = a;
    }
    get lf() {
        return this.ld;
    }
    set lf(a) {
        this.ld = a;
    }
    dy(a, b) {
        if (!b.c.isEmpty) {
            let c = this.la(a, NumericScaler.ac, b.c);
            c = (c - b.d.top) / b.d.height;
            c = b.d.top + b.d.height * (c - b.e.top) / b.e.height;
            return c;
        }
        return this.la(a, b.e, b.d);
    }
    la(a, b, c) {
        let d = this.categoryMode == 0 ? this.j7 - 1 : this.j7;
        if (d < 0) {
            d = 0;
        }
        let e = d >= 1 ? (a) / (d) : d == 0 ? 0.5 : NaN;
        if (!this.cb) {
            e = 1 - e;
        }
        return c.top + c.height * (e - b.top) / b.height;
    }
    d1(a, b) {
        if (!b.c.isEmpty) {
            let c = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            c = (c * b.d.height) + b.d.top;
            c = this.getUnscaledValue3(c, NumericScaler.ac, b.c, this.categoryMode);
            return c;
        }
        return this.getUnscaledValue3(a, b.e, b.d, this.categoryMode);
    }
    d2(a, b, c) {
        if (!b.c.isEmpty) {
            let d = b.e.top + b.e.height * (a - b.d.top) / b.d.height;
            d = (d * b.d.height) + b.d.top;
            d = this.getUnscaledValue3(d, NumericScaler.ac, b.c, c);
            return d;
        }
        return this.getUnscaledValue3(a, b.e, b.d, c);
    }
    getUnscaledValue3(a, b, c, d) {
        let e = b.top + (a - c.top) * b.height / c.height;
        if (!this.cb) {
            e = 1 - e;
        }
        let f = d == 0 ? this.j7 - 1 : this.j7;
        if (f < 0) {
            f = 0;
        }
        return e * f;
    }
    lm(a, b) {
        if (a == NaN || b == NaN || this.jn == null || this.jn.count == 0) {
            return;
        }
        let c = a / this.jn.count;
        let d = b / this.jn.count;
        this.bh.oi = new Rect(0, this.bh.oi.x, 1 - d, this.bh.oi.width, d - c);
    }
    au() {
        return new VerticalAxisLabelPanel();
    }
    dl() {
        return this.lb;
    }
    getCategorySize(a, b, c) {
        let d = this.i7(b, c);
        return d.height / (this.j7 * a.height);
    }
    jz(a, b, c) {
        let d = 0;
        if (!isNaN_(this.jw)) {
            d = MathUtil.b(this.jw, 0, 1);
        }
        let e = 0;
        if (!isNaN_(this.j3)) {
            e = Math.min(this.j3, 1);
        }
        let f = 1 - 0.5 * d;
        let g = this.getCategorySize(a, b, c) * f / (this.j9 - (this.j9 - 1) * e);
        return g;
    }
    getGroupCenter(a, b, c, d) {
        let e = 0.5;
        if (this.j9 > 1) {
            let f = 0;
            if (!isNaN_(this.jw)) {
                f = MathUtil.b(this.jw, 0, 1);
            }
            let g = 0;
            if (!isNaN_(this.j3)) {
                g = Math.min(this.j3, 1);
            }
            let h = 1 - 0.5 * f;
            let i = h / (this.j9 - (this.j9 - 1) * g);
            let j = (h - i) / (this.j9 - 1);
            e = 0.25 * f + 0.5 * i + a * j;
        }
        return this.getCategorySize(b, c, d) * e;
    }
    ll(a) {
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        b = b.copy();
        let c = this.i9;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = this.i6();
        let f = new ScalerParams(0, d, d, this.ca, e);
        let g = !b.isEmpty && !c.isEmpty && this.jn != null ? this.jn.indexOf(a) : -1;
        let h = g > -1 ? this.dy(g, f) : NaN;
        if (!isNaN_(h) && this.bh.dk) {
            if (!isNaN_(h)) {
                if (h < b.top + 0.1 * b.height) {
                    h = h + 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
                if (h > b.bottom - 0.1 * b.height) {
                    h = h - 0.4 * b.height;
                    b.y = h - 0.5 * b.height;
                }
            }
            this.bh.lr(b, false, true);
        }
    }
    cp() {
        if (this.ci && this.cq) {
            this.bb = this.ba();
        }
        if (this.jn == null) {
            return false;
        }
        let a = this.jn.count;
        if (a != this.lf) {
            let b = new AxisRangeChangedEventArgs(0, 1, 1, this.lf, a);
            this.lf = a;
            this.g6(b);
            return true;
        }
        return false;
    }
    jq(a) {
        if (a == null) {
            return false;
        }
        let b = this.bd();
        if (b == null) {
            return false;
        }
        return b.synchronizeVertically;
    }
    hc(a) {
        super.hc(a);
        let b = this.bh != null ? this.bh.n2 : Rect.empty;
        let c = this.i9;
        let d = this.i4();
        let e = this.i3();
        let f = new ScalerParams(0, b, c, this.ca, d);
        let g = this.a4.ay();
        let h = this.a4.a1();
        let i = this.a4.az();
        let j = this.a4.a0();
        let k = this.a4.e();
        let l = this.a4.f();
        let m = this.a4.g();
        this.hk();
        this.gn(g);
        this.gn(h);
        this.gn(i);
        this.gn(j);
        this.cx.clear();
        this.cy.clear();
        this.ju.clear();
        this.a4.at(this, b, c);
        if (b.isEmpty || c.isEmpty) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
        }
        if (this.bq.count == 0 && this.bp.count == 0) {
            this.a4.y();
        }
        if (this.ay != null) {
            this.ay.registerAxis(this);
        }
        if (this.itemsSource == null || this.jn == null || this.jn.count == 0) {
            this.bq.count = 0;
            this.bp.count = 0;
            this.bo.count = 0;
            this.a4.y();
            return;
        }
        if (!b.isEmpty && !c.isEmpty) {
            let n = this.d1(e.top, f);
            let o = this.d1(e.bottom, f);
            if (!this.ca) {
                n = Math.ceil(n);
                o = Math.floor(o);
            }
            else {
                n = Math.floor(n);
                o = Math.ceil(o);
            }
            let p = c.left;
            let q = 0;
            if (this.ai != null) {
                let r = typeCast(NumericXAxis.$, this.ai);
                if (r != null) {
                    let s = this.hg(p, q, b, c, d, c.left, c.right);
                    p = s.p0;
                    q = s.p1;
                }
            }
            this.hl(g, p, c, k, true);
            this.a4.ao(q);
            let t = Math.min(n, o);
            let u = Math.max(n, o);
            let v = new LinearCategorySnapper(1, t, u, e.height, this.lb, this.categoryMode, this.eb());
            let w = Math.floor((t - 0) / v.g);
            let x = Math.ceil((u - 0) / v.g);
            if (!isNaN_(w) && !isNaN_(x)) {
                let y = truncate(w);
                let z = truncate(x);
                let aa = this.dy(0 + y * v.g, f);
                let ab = Math.abs(this.dy(v.g, f) - this.dy(0, f));
                this.av.bo = this.dy(v.g, f);
                for (let ac = y; ac <= z; ++ac) {
                    let ad = this.dy(0 + (ac + 1) * v.g, f);
                    if (aa <= e.bottom) {
                        if (ac % 2 == 0) {
                            this.gw(h, aa, ad, c);
                        }
                        this.gv(i, aa, c, l, false);
                        this.ju.add(aa);
                    }
                    if (this.categoryMode != 0 && this.j9 != 0 && this.cl) {
                        if (this.lc > 0 && this.lc < v.g) {
                            let ae = ab * this.lc;
                            if (!this.ca) {
                                let af = aa;
                                while (af - ae > ad) {
                                    af -= ae;
                                    if (Math.abs(af - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gv(j, af, c, m, false);
                                }
                            }
                            else {
                                let ag = aa;
                                while (ag + ae < ad) {
                                    ag += ae;
                                    if (Math.abs(ag - ad) < 0.0001) {
                                        break;
                                    }
                                    this.gv(j, ag, c, m, false);
                                }
                            }
                            this.k9 = this.lc;
                        }
                        else {
                            for (let ah = 0; ah < truncate(v.g); ah++) {
                                for (let ai = 0; ai < this.j9; ai++) {
                                    let aj = this.getGroupCenter(ai, b, c, d);
                                    if (!this.ca) {
                                        aj = -aj;
                                    }
                                    let ak = this.dy(ah + ac * v.g, f) + aj;
                                    this.gv(j, ak, c, m, false);
                                }
                            }
                            this.k9 = 0.5;
                        }
                    }
                    let al = aa;
                    if (this.categoryMode != 0) {
                        let am = this.dy(ac * v.g + 1, f);
                        al = (aa + am) / 2;
                    }
                    if (al <= e.bottom && al >= e.top) {
                        let an = 0;
                        if (v.g >= 1) {
                            an = ac * truncate(Math.floor(v.g));
                        }
                        else {
                            if ((ac * v.g) * 2 % 2 == 0) {
                                an = truncate(Math.floor(ac * v.g));
                            }
                            else {
                                an = -1;
                            }
                        }
                        if (this.jn != null && an < this.jn.count && an >= 0) {
                            let ao = this.jn.item(an);
                            let ap = this.e8(ao);
                            if (!isNaN_(al) && !isInfinity(al) && ap != null) {
                                if ((typeof ap === 'string') && Base.equalsStatic(ap, "")) {
                                }
                                else {
                                    this.cx.add1(ap);
                                    this.cy.add(new LabelPosition(al));
                                }
                            }
                        }
                    }
                    aa = ad;
                }
            }
            this.k8 = v.g;
            if ((this.ay == null || this.ay.visibility == 0) && this.ai != null) {
                if (this.ay != null && (this.ay.location == 6 || this.ay.location == 7)) {
                    this.bh.it();
                }
            }
            this.a4.au(this.cx, this.cy);
            this.ku();
        }
    }
    get_a1() {
        return 1;
    }
    get a1() {
        return this.get_a1();
    }
    get isVertical() {
        return this.ch;
    }
    j$c(a, b) {
        return this.d1.apply(this, arguments);
    }
    j$b(a, b) {
        return this.dy.apply(this, arguments);
    }
    j$d(a, b, c, d, e) {
        this.gr.apply(this, arguments);
    }
    j$e(a, b, c, d) {
        this.gs.apply(this, arguments);
    }
    j$f(a, b, c, d) {
        this.gt.apply(this, arguments);
    }
    get j$a() {
        return this.ca;
    }
}
CategoryYAxis.$t = markType(CategoryYAxis, 'CategoryYAxis', CategoryAxisBase.$);
CategoryYAxis.ln = DependencyProperty.i("Interval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    a.g5("Interval", b.oldValue, b.newValue);
    a.hb(false);
}));
CategoryYAxis.lo = DependencyProperty.i("MinorInterval", Number_$type, CategoryYAxis.$, new PropertyMetadata(2, NaN, (a, b) => {
    (typeCast(CategoryYAxis.$, a)).g5("MinorInterval", b.oldValue, b.newValue);
    (typeCast(CategoryYAxis.$, a)).hb(false);
}));
/**
 * @hidden
 */
class CategoryYAxisView extends CategoryAxisBaseView {
    constructor(a) {
        super(a);
        this.bg = null;
        this.bg = a;
    }
}
CategoryYAxisView.$t = markType(CategoryYAxisView, 'CategoryYAxisView', CategoryAxisBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxCategoryYAxisComponent_1;
/**
 * Represents a IgxDataChartComponent category Y axis.
*/
const IgxCategoryYAxisComponent_PROVIDERS = [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryYAxisComponent) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryYAxisComponent) }];
let IgxCategoryYAxisComponent = IgxCategoryYAxisComponent_1 = class IgxCategoryYAxisComponent extends IgxCategoryAxisBaseComponent {
    constructor() {
        super();
        this._actualIntervalChange = null;
        this._actualMinorIntervalChange = null;
    }
    createImplementation() {
        return new CategoryYAxis();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets if the current axis is a vertical axis.
    */
    get isVertical() {
        return this.i.ch;
    }
    /**
     * Gets or sets the frequency of displayed labels.
     * The set value is a factor that determines which labels will be hidden. For example, an interval of 2 will display every other label.
    */
    get interval() {
        return this.i.lb;
    }
    set interval(v) {
        this.i.lb = +v;
    }
    /**
     * Gets the effective value for the current Interval.
    */
    get actualInterval() {
        return this.i.k8;
    }
    set actualInterval(v) {
        this.i.k8 = +v;
    }
    /**
     * Gets or sets the frequency of displayed minor lines.
     * The set value is a factor that determines how the minor lines will be displayed.
    */
    get minorInterval() {
        return this.i.lc;
    }
    set minorInterval(v) {
        this.i.lc = +v;
    }
    /**
     * Gets the effective value for the current MinorInterval.
    */
    get actualMinorInterval() {
        return this.i.k9;
    }
    set actualMinorInterval(v) {
        this.i.k9 = +v;
    }
    getCategoryBoundingBox(point, useInterpolation, singularWidth) {
        let iv = this.i.k2(toPoint(point), useInterpolation, singularWidth);
        return fromRect(iv);
    }
    scrollRangeIntoView(minimum, maximum) {
        this.i.lm(minimum, maximum);
    }
    /**
     * Scrolls the specified item into view.
    
    * @param item  * Data item to scroll into view
    */
    scrollIntoView(item) {
        this.i.ll(item);
    }
    get actualIntervalChange() {
        if (this._actualIntervalChange == null) {
            this._actualIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualInterval;
                if (this.beforeActualIntervalChange) {
                    this.beforeActualIntervalChange(this, ext);
                }
                this._actualIntervalChange.emit(ext);
            });
        }
        return this._actualIntervalChange;
    }
    get actualMinorIntervalChange() {
        if (this._actualMinorIntervalChange == null) {
            this._actualMinorIntervalChange = new EventEmitter();
            this.i.propertyChanged = delegateCombine(this.i.propertyChanged, (o, e) => {
                let iv = e;
                let ext = this.actualMinorInterval;
                if (this.beforeActualMinorIntervalChange) {
                    this.beforeActualMinorIntervalChange(this, ext);
                }
                this._actualMinorIntervalChange.emit(ext);
            });
        }
        return this._actualMinorIntervalChange;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryYAxisComponent.prototype, "interval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryYAxisComponent.prototype, "actualInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryYAxisComponent.prototype, "minorInterval", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxCategoryYAxisComponent.prototype, "actualMinorInterval", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryYAxisComponent.prototype, "actualIntervalChange", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCategoryYAxisComponent.prototype, "actualMinorIntervalChange", null);
IgxCategoryYAxisComponent = IgxCategoryYAxisComponent_1 = __decorate([
    Component({
        selector: 'igx-category-y-axis',
        template: ``,
        providers: [{ provide: IgxCategoryAxisBaseComponent, useExisting: forwardRef(() => IgxCategoryYAxisComponent_1) }, { provide: IgxAxisComponent, useExisting: forwardRef(() => IgxCategoryYAxisComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryYAxisComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryYAxisModule = class IgxCategoryYAxisModule {
};
IgxCategoryYAxisModule = __decorate([
    NgModule({
        declarations: [IgxCategoryYAxisComponent],
        imports: [CommonModule],
        exports: [IgxCategoryYAxisComponent],
        entryComponents: []
    })
], IgxCategoryYAxisModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCategoryYAxisDynamicModule = class IgxCategoryYAxisDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCategoryYAxisComponent", IgxCategoryYAxisComponent);
        TypeRegistrar.register("CategoryYAxis", CategoryYAxis.$type);
    }
};
IgxCategoryYAxisDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCategoryYAxisModule],
        exports: [IgxCategoryYAxisModule],
        entryComponents: [IgxCategoryYAxisComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCategoryYAxisDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVerticalCategoryCoreModule = class IgxDataChartVerticalCategoryCoreModule {
};
IgxDataChartVerticalCategoryCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisModule,
            IgxCategoryYAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisModule,
            IgxCategoryYAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartVerticalCategoryCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVerticalCategoryCoreDynamicModule = class IgxDataChartVerticalCategoryCoreDynamicModule {
};
IgxDataChartVerticalCategoryCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumericXAxisDynamicModule,
            IgxCategoryYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        imports: [CommonModule, IgxNumericXAxisDynamicModule,
            IgxCategoryYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartVerticalCategoryCoreDynamicModule);

/**
 * Represents a vertically laid out category based series.
*/
const IgxVerticalAnchoredCategorySeriesComponent_PROVIDERS = [{ provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxVerticalAnchoredCategorySeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxVerticalAnchoredCategorySeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxVerticalAnchoredCategorySeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxVerticalAnchoredCategorySeriesComponent) }];
class IgxVerticalAnchoredCategorySeriesComponent extends IgxAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the effective x-axis for the current CategorySeries object.
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current CategorySeries object.
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxCategoryYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    /**
     * Gets whether or not the current series is vertical series
    */
    get isVertical() {
        return this.i.isVertical;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    getNextOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fc(toPoint(world), skipUnknowns);
        return (iv);
    }
    getPreviousOrExactIndex(world, skipUnknowns) {
        let iv = this.i.fe(toPoint(world), skipUnknowns);
        return (iv);
    }
    /**
     * If possible, will return the best available value marker bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinates for which to get a value marker bounding box for
    */
    getSeriesValueMarkerBoundingBox(world) {
        let iv = this.i.l6(toPoint(world));
        return fromRect(iv);
    }
    getSeriesValue(world, useInterpolation, skipUnknowns) {
        let iv = this.i.en(toPoint(world), useInterpolation, skipUnknowns);
        return (iv);
    }
    getSeriesValuePosition(world, useInterpolation, skipUnknowns) {
        let iv = this.i.lv(toPoint(world), useInterpolation, skipUnknowns);
        return fromPoint(iv);
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.qg(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.qf(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxVerticalAnchoredCategorySeriesComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryYAxisComponent),
    __metadata("design:paramtypes", [IgxCategoryYAxisComponent])
], IgxVerticalAnchoredCategorySeriesComponent.prototype, "yAxis", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VerticalAnchoredCategorySeries extends AnchoredCategorySeries {
    constructor() {
        super(...arguments);
        this.qc = null;
    }
    h1() {
        super.h1();
        this.xAxis = null;
        this.yAxis = null;
    }
    get qd() {
        if (this.qc == null) {
            this.qc = DVContainer.instance.createInstance(IVerticalAnchoredCategorySeriesInteractionManager_$type, () => this.b2.n);
        }
        return this.qc;
    }
    get_isVertical() {
        return true;
    }
    nj() {
        return this.yAxis;
    }
    n3() {
        return this.xAxis;
    }
    getOffsetValue() {
        return this.no.r(this.nj(), this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    fc(a, b) {
        return this.fd(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    }
    fe(a, b) {
        return this.ff(a, b, this.nj(), runOn(this, this.oi), this.valueColumn);
    }
    d9(a, b, c, d, e) {
        if (this.valueColumn == null) {
            return Number.POSITIVE_INFINITY;
        }
        return this.ea(a, b, this.yAxis, d, e, this.valueColumn.count, runOn(this, this.oi));
    }
    bd() {
        if (this.be == 0) {
            return 1;
        }
        else {
            return super.bd();
        }
    }
    l6(a) {
        if (!this.hasMarkers || !this.md()) {
            return Rect.empty;
        }
        return this.qd.e$b(this, this.nk.m, a, runOn(this, this.ql));
    }
    ql(a) {
        return this.pb.c5(a);
    }
    dh(a, b) {
        if (this.dg(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    en(a, b, c) {
        if (this.bs == null) {
            return NaN;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = this.nj();
        let f = new ScalerParams(0, this.bs.n2, this.bi.br, e.ca, d);
        let g = this.no.r(e, this.bs.n2, this.bi.br, d);
        return this.ep(this.valueColumn, a, e, f, g, runOn(this, this.oi), b, c);
    }
    lv(a, b, c) {
        let d = this.nj();
        return this.lx(a, b, c, this.no.r(d, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi)), this.n3(), d, null, null, null);
    }
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    pt(a) {
        this.xAxis = typeCast(NumericXAxis.$, a);
    }
    pu(a) {
        this.yAxis = typeCast(CategoryYAxis.$, a);
    }
    oe() {
        return this.xAxis != null && this.xAxis.cn();
    }
    nd(a, b) {
        return this.o8(a, b, this.yAxis);
    }
    eb(a) {
        return this.qd.e$a(this, a);
    }
    oi(a) {
        return this.ed(a, this.nj());
    }
    e8(a) {
        return truncate(Math.round(this.eb(a)));
    }
    fp(a) {
        let b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                    this.it();
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.oe();
                    this.jl(false);
                    this.it();
                }
                break;
            case "TrendLineType":
                let e = EnumUtil.getEnumValue(TrendLineType_$type, d);
                if (e != 0) {
                    this.pb.cy = CategoryTrendLineManagerFactory.a(this.pb.cy, this.yAxis, this.j5, this, this.b2);
                }
                break;
        }
    }
    qg(a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    qf(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
VerticalAnchoredCategorySeries.$t = markType(VerticalAnchoredCategorySeries, 'VerticalAnchoredCategorySeries', AnchoredCategorySeries.$);
VerticalAnchoredCategorySeries.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalAnchoredCategorySeries, 'raisePropertyChanged', ['XAxis::qj', [NumericXAxis.$, null], 'YAxis::qk', [CategoryYAxis.$, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IBarSeries_$type = new Type(null, 'IBarSeries');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BarFramePreparer extends CategoryFramePreparer {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    let d = [c, typeCast(ISupportsMarkers_$type, c), typeCast(IProvidesViewport_$type, c), typeCast(ISupportsErrorBars_$type, c), typeCast(IBucketizer_$type, c)];
                    {
                        let f = d[0];
                        let g = d[1];
                        let h = d[2];
                        let i = d[3];
                        let j = d[4];
                        super(1, f, g, h, i, j);
                        this.aa = new DefaultCategoryTrendlineHost();
                        if (typeCast(IHasCategoryTrendline_$type, f) !== null) {
                            this.aa = typeCast(IHasCategoryTrendline_$type, f);
                        }
                        this.ab = new DefaultSingleValueProvider();
                        if (typeCast(IHasSingleValueCategory_$type, f) !== null) {
                            this.ab = typeCast(IHasSingleValueCategory_$type, f);
                        }
                    }
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                    this.aa = new DefaultCategoryTrendlineHost();
                    if (typeCast(IHasCategoryTrendline_$type, c) !== null) {
                        this.aa = typeCast(IHasCategoryTrendline_$type, c);
                    }
                    this.ab = new DefaultSingleValueProvider();
                    if (typeCast(IHasSingleValueCategory_$type, c) !== null) {
                        this.ab = typeCast(IHasSingleValueCategory_$type, c);
                    }
                }
                break;
        }
    }
    l(a, b, c, d, e, f) {
        let g = b[1];
        let h = b[0];
        let i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
    w(a, b, c) {
        if (this.aa.trendLineType == 0 || this.aa.trendlinePreparer == null || this.aa.trendLinePeriod < 1) {
            return;
        }
        let d = a.k;
        let e = new ScalerParams(0, a.m, a.l, a.b.j$a, d);
        let f = new ScalerParams(0, a.m, a.l, a.c.j$a, d);
        let g = b.f;
        if (a.d != null && a.d.i$b != null) {
            g = new SafeSortedReadOnlyDoubleCollection(0, g, a.d.i$b);
        }
        let h = ((() => {
            let $ret = new TrendResolutionParams();
            $ret.c = a.h;
            $ret.d = a.i;
            $ret.e = a.j;
            $ret.a = c;
            $ret.b = a.g;
            $ret.f = a.l;
            return $ret;
        })());
        if (this.aa.trendLineType != 0) {
            this.aa.trendlinePreparer.prepareLineCore(a.a.p, this.aa.trendLineType, g, this.aa.trendLinePeriod, (i) => a.c.j$b(i, f), (i) => a.b.j$b(i, e), h);
        }
    }
}
BarFramePreparer.$t = markType(BarFramePreparer, 'BarFramePreparer', CategoryFramePreparer.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BarTrendFitCalculator extends Base {
    static a(a, b, c, d, e, f, g, h, i, j, k) {
        if (d == null) {
            switch (b) {
                case 1:
                    d = LeastSquaresFit.k(e, g, f);
                    break;
                case 2:
                    d = LeastSquaresFit.o(e, g, f);
                    break;
                case 3:
                    d = LeastSquaresFit.i(e, g, f);
                    break;
                case 4:
                    d = LeastSquaresFit.p(e, g, f);
                    break;
                case 5:
                    d = LeastSquaresFit.q(e, g, f);
                    break;
                case 7:
                    d = LeastSquaresFit.j(e, g, f);
                    break;
                case 6:
                    d = LeastSquaresFit.l(e, g, f);
                    break;
                case 8:
                    d = LeastSquaresFit.n(e, g, f);
                    break;
                default: throw new NotImplementedException(0);
            }
        }
        if (d == null) {
            return null;
        }
        for (let l = 0; l < c.f.height; l += 2) {
            let m = l / (c.f.height - 1);
            let n = j + m * (k - j);
            let o = NaN;
            switch (b) {
                case 1:
                    o = LeastSquaresFit.ad(d, n);
                    break;
                case 2:
                    o = LeastSquaresFit.ah(d, n);
                    break;
                case 3:
                    o = LeastSquaresFit.ab(d, n);
                    break;
                case 4:
                    o = LeastSquaresFit.ai(d, n);
                    break;
                case 5:
                    o = LeastSquaresFit.aj(d, n);
                    break;
                case 7:
                    o = LeastSquaresFit.ac(d, n);
                    break;
                case 6:
                    o = LeastSquaresFit.ae(d, n);
                    break;
                case 8:
                    o = LeastSquaresFit.ag(d, n);
                    break;
                default: throw new NotImplementedException(0);
            }
            o = h(o);
            n = i(n);
            if (!isNaN_(o) && !isInfinity(o)) {
                a.add({ $type: Point_$type, x: o, y: n + c.a });
            }
        }
        return d;
    }
}
BarTrendFitCalculator.$t = markType(BarTrendFitCalculator, 'BarTrendFitCalculator');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BarTrendLineManager extends CategoryTrendLineManager {
    prepareLineCore(a, b, c, d, e, f, g) {
        let h = g.d * g.c;
        let i = g.e * g.c;
        let j = new List$1(Point_$type, 0);
        if (b == 0) {
            this.a = null;
            this.d.clear();
            return;
        }
        if (this.c(b)) {
            this.d.clear();
            this.a = BarTrendFitCalculator.a(j, b, g, this.a, c.count, (k) => c.item(k), (k) => k + 1, e, (k) => f(k - 1), h + 1, i + 1);
        }
        if (this.b(b)) {
            this.a = null;
            TrendAverageCalculator.b(b, this.d, c, d);
            for (let k = g.d; k <= g.e; k += 1) {
                let l = k * g.c;
                if (l >= 0 && l < this.d.count) {
                    let m = e(this.d._inner[l]);
                    let n = f(l);
                    j.add({ $type: Point_$type, x: m, y: n + g.a });
                }
            }
        }
        this.e(j, g, a);
    }
}
BarTrendLineManager.$t = markType(BarTrendLineManager, 'BarTrendLineManager', CategoryTrendLineManager.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BarSeries extends VerticalAnchoredCategorySeries {
    constructor() {
        super();
        this.ab = BarSeries.$;
        this.no = new BarFramePreparer(1, this, this.qm, this, this, this.qm.cn);
    }
    bf() {
        return new BarSeriesView(this);
    }
    nt() {
        return 1;
    }
    i2(a) {
        super.i2(a);
        this.qm = a;
    }
    get_n8() {
        return true;
    }
    l4(a) {
        if (this.xAxis == null || this.yAxis == null || this.nk.f.count == 0) {
            return Rect.empty;
        }
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, b, c, this.xAxis.ca, d);
        let f = this.lq(a);
        let g = this.fe(a, true);
        let h = this.fc(a, true);
        let i = truncate(Math.floor(g / this.ok(this.bi)));
        let j = truncate(Math.floor(h / this.ok(this.bi)));
        let k = i - this.ol(this.bi);
        let l = j - this.ol(this.bi);
        if (k < 0) {
            k = 0;
        }
        if (k > this.nk.f.count - 1) {
            k = this.nk.f.count - 1;
        }
        if (l < 0) {
            l = 0;
        }
        if (l > this.nk.f.count - 1) {
            l = this.nk.f.count - 1;
        }
        let m = this.nk.f._inner[k];
        let n = this.nk.f._inner[l];
        let o = Math.abs(f.y - m[0]);
        let p = Math.abs(f.y - n[0]);
        let q = this.pk(this.ns);
        let r = this.yAxis.jz(b, c, d);
        if (o < p) {
            let s = m[0] - 0.5 * r;
            let t = m[1];
            let u = q;
            return new Rect(0, Math.min(u, t), s, Math.max(u, t) - Math.min(u, t), r);
        }
        else {
            let v = n[0] - 0.5 * r;
            let w = n[1];
            let x = q;
            return new Rect(0, Math.min(x, w), v, Math.max(x, w) - Math.min(x, w), r);
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    np(a) {
        let b = typeCast(CategorySeriesView.$, a);
        if (b != null && b.n) {
            if (b.m) {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), b, this, b.cn);
            }
            else {
                return new BarFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.bs.b1.m, this, b.cn);
            }
        }
        else {
            return this.no;
        }
    }
    ac() {
        super.ac();
    }
    preferredCategoryMode(a) {
        return 2;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = typeCast(BarSeriesView.$, b);
        if (a && c != null && c.c7 != null) {
            c.c7.count = 0;
        }
    }
    om() {
        let a = 0;
        for (let b of fromEnum(this.bs.series)) {
            if (b == this) {
                return a;
            }
            let c = typeCast(IBarSeries_$type, b);
            if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                a++;
            }
        }
        return -1;
    }
    pk(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        if (!c.isEmpty && !d.isEmpty && this.xAxis != null) {
            let f = new ScalerParams(0, c, d, this.xAxis.ca, e);
            b = this.xAxis.dy(this.xAxis.km, f);
        }
        return b;
    }
    an(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.valueColumn.count - 1);
        }
        if (a == this.xAxis) {
            return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
        }
        return null;
    }
    c9(a) {
        let b = this.bi.bs;
        b = b.copy();
        let c = this.bi.br;
        let d = new Rect(0, 0, 0, 1, 1);
        let e = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        let f = this.l2(this.bi);
        let g = new ScalerParams(0, d, d, this.xAxis.ca, f);
        let h = new ScalerParams(0, d, d, this.yAxis.ca, f);
        let i = this.yAxis != null ? this.yAxis.dy(e, h) : NaN;
        let j = this.yAxis != null ? this.no.r(this.yAxis, d, d, f) : 0;
        i += j;
        let k = this.xAxis != null && this.valueColumn != null && e < this.valueColumn.count ? this.xAxis.dy(this.valueColumn.item(e), g) : NaN;
        if (!isNaN_(k)) {
            if (k < b.left + 0.1 * b.width) {
                k = k + 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
            if (k > b.right - 0.1 * b.width) {
                k = k - 0.4 * b.width;
                b.x = k - 0.5 * b.width;
            }
        }
        if (!isNaN_(i)) {
            if (i < b.top + 0.1 * b.height) {
                i = i + 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
            if (i > b.bottom - 0.1 * b.height) {
                i = i - 0.4 * b.height;
                b.y = i - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return e >= 0;
    }
    eg() {
        return this.yAxis.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    o1(a, b) {
        super.o1(a, b);
        let c = a.f;
        if (!b.l()) {
            return;
        }
        let d = b.bs;
        let e = b.br;
        let f = this.getEffectiveViewport1(b);
        let g = new ScalerParams(0, d, e, this.xAxis.ca, f);
        let h = this.yAxis;
        let i = new ScalerParams(0, d, e, this.yAxis.ca, f);
        let j = this.xAxis;
        let k = j.dy(j.km, g);
        let l = this.yAxis.jz(d, e, f);
        let m = typeCast(BarSeriesView.$, b);
        if (isNaN_(l) || isInfinity(l) || isNaN_(k)) {
            m.c7.count = 0;
            return;
        }
        this.nr.x(this, this.oc(), this.yAxis, runOn(this, this.nd), this.ok(b), this.ol(b));
        this.nr.p = this.qn;
        this.nr.q = this.qo;
        this.nr.j = this.qn;
        this.nr.k = this.qo;
        let n = false;
        let o = this.nr.c;
        if (o != null) {
            n = true;
        }
        let p = this.xAxis.cf;
        let q = this.valueColumn.count;
        for (let r = 0; r < c.count; ++r) {
            let s = c._inner[r][0] - 0.5 * l;
            let t = c._inner[r][1];
            let u = k;
            u = Math.max(u, -100);
            t = Math.min(t, e.right + 100);
            let v = m.c7.item(r);
            v.height = l;
            v.width = Math.abs(t - u);
            if (n) {
                this.ox(c, r, q, h, i, b.n);
            }
            this.nr.ae(v, false, false, false, false);
            v.am = this.nr.j;
            v.an = this.nr.k;
            m.dc(v, Math.min(t, u), s);
        }
        m.c7.count = c.count;
        b.cu(a);
    }
    h6(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.pb.cn.g(this.eu);
                break;
        }
        if (this.pb.cz) {
            this.pb.cy.g$e(a, b, c, d);
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (this.pq != null && this.pb.cn.d > 0) {
                    this.jl(true);
                }
                break;
            case 3:
                if (d == this.pq) {
                    if (this.xAxis != null && !this.xAxis.cn()) {
                        this.jl(true);
                    }
                }
                break;
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case VerticalAnchoredCategorySeries.$$p[0]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                this.pb.cn.g(this.eu);
                if (this.xAxis != null && this.xAxis.cn()) {
                    this.jl(false);
                }
                break;
            case VerticalAnchoredCategorySeries.$$p[1]:
                if (c != null) {
                    c.bx(this);
                }
                if (d != null) {
                    d.ck(this);
                }
                if (this.pb.cz) {
                    this.pb.cy = CategoryTrendLineManagerFactory.a(this.pb.cy, this.yAxis, this.j5, this, this.b2);
                }
                this.pb.cn.g(this.eu);
                this.jl(false);
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.pb.cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case "ValueColumn":
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.pb.cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.h7(this.xAxis);
                    this.h7(this.yAxis);
                }
                if (c == null && d != null) {
                    this.jc(this.xAxis);
                    this.jc(this.yAxis);
                }
                this.pb.cn.g(this.eu);
                this.jl(false);
                break;
        }
    }
    getPreferredCategoryMode() {
        return this.preferredCategoryMode(this.yAxis);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
BarSeries.$t = markType(BarSeries, 'BarSeries', VerticalAnchoredCategorySeries.$, [IBarSeries_$type]);
BarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, BarSeries, 'raisePropertyChanged', ['RadiusX:qn:qr', [1, 2], 'RadiusY:qo:qs', [1, 2]]);
/**
 * @hidden
 */
class BarBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
        this.i = null;
        this.h = null;
        this.j = 0;
        this.i = a;
    }
    g(a) {
        let b = this.c.bs;
        let c = this.c.br;
        let d = this.c.cp.bz;
        if (b.isEmpty || c.isEmpty || this.i.c6.yAxis == null || d == null || d.count == 0) {
            this.d = 0;
            return;
        }
        let e = typeCast(BarSeries.$, this.c.cp);
        let f = e.l0(this.c);
        let g = e.getEffectiveViewport1(this.c);
        let h = new ScalerParams(0, b, c, e.yAxis.ca, g);
        let i = Math.floor(e.yAxis.d2(f.top, h, 0));
        let j = Math.ceil(e.yAxis.d2(f.bottom, h, 0));
        if (!e.yAxis.ca) {
            j = Math.ceil(e.yAxis.d2(f.top, h, 0));
            i = Math.floor(e.yAxis.d2(f.bottom, h, 0));
        }
        let k = Math.floor((j - i + 1) * a / f.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    }
    getBucketWithoutUnknowns(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = 1.7976931348623157E+308;
        let h = -1.7976931348623157E+308;
        let i = true;
        for (let j = d; j <= e; ++j) {
            let k = b[j];
            g = g < k ? g : k;
            h = h > k ? h : k;
            Math.max(h, k);
            i = false;
        }
        if (!i) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    getBucket(a) {
        let b = this.h;
        let c = this.j;
        let d = a * this.d;
        let e = d + this.d - 1;
        let f = c - 1;
        d = d < f ? d : f;
        e = e < f ? e : f;
        let g = NaN;
        let h = NaN;
        for (let i = d; i <= e; ++i) {
            let j = b[i];
            if (!isNaN_(g)) {
                if (!isNaN_(j)) {
                    g = Math.min(g, j);
                    h = Math.max(h, j);
                }
            }
            else {
                g = j;
                h = j;
            }
        }
        if (!isNaN_(g)) {
            return [0.5 * (d + e), g, h];
        }
        return [0.5 * (d + e), NaN, NaN];
    }
    cacheValues() {
        this.j = this.i.c6.valueColumn.count;
        this.h = this.i.c6.valueColumn.asArray();
    }
    unCacheValues() {
        this.h = null;
    }
}
BarBucketCalculator.$t = markType(BarBucketCalculator, 'BarBucketCalculator', CategoryBucketCalculator.$);
/**
 * @hidden
 */
class BarSeriesView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c7 = null;
        this.c8 = null;
        this.dd = new Rectangle();
        this.c6 = a;
        this.c7 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.de);
            $ret.activate = runOn(this, this.c9);
            $ret.disactivate = runOn(this, this.db);
            $ret.destroy = runOn(this, this.da);
            return $ret;
        })());
        this.cy = new BarTrendLineManager();
    }
    ap() {
        super.ap();
        this.c8 = new List$1(Rectangle.$, 0);
        if (!this.n) {
            this.e.eu = 4;
            this.e.bj = 1;
        }
    }
    de() {
        let a = new Rectangle();
        this.c8.add(a);
        a._visibility = 1;
        return a;
    }
    c9(a) {
        a._visibility = 0;
    }
    db(a) {
        a._visibility = 1;
    }
    da(a) {
        this.c8.remove(a);
    }
    dc(a, b, c) {
        if (!this.isDirty) {
            this.an();
        }
        a.o = c;
        a.n = b;
    }
    co() {
        return new BarBucketCalculator(this);
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey;
    }
    z(a) {
        return this.c8._inner[a];
    }
    y(a) {
        let b = this.c8._inner[a];
        this.dd.n = b.n;
        this.dd.o = b.o;
        this.dd.width = b.width;
        this.dd.height = b.height;
        let c = this.bm(a);
        this.dd._fill = c;
        this.dd._stroke = c;
        this.dd.ac = this.e.ey + 3;
        return this.dd;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.c8.count; c++) {
                let d = this.x(c, b);
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c7.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.o > f.o) {
                return -1;
            }
            else if (e.o < f.o) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
    ac() {
        let a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.lk = a;
        this.e.ev = 5;
        this.e.ew = 5;
        this.e.ex = -5;
    }
}
BarSeriesView.$t = markType(BarSeriesView, 'BarSeriesView', AnchoredCategorySeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxBarSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent bar series.
*/
const IgxBarSeriesComponent_PROVIDERS = [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent) }];
let IgxBarSeriesComponent = IgxBarSeriesComponent_1 = class IgxBarSeriesComponent extends IgxVerticalAnchoredCategorySeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new BarSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
    */
    get radiusX() {
        return this.i.qn;
    }
    set radiusX(v) {
        this.i.qn = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
    */
    get radiusY() {
        return this.i.qo;
    }
    set radiusY(v) {
        this.i.qo = +v;
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBarSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxBarSeriesComponent.prototype, "radiusY", null);
IgxBarSeriesComponent = IgxBarSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-bar-series',
        template: ``,
        providers: [{ provide: IgxVerticalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBarSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBarSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBarSeriesModule = class IgxBarSeriesModule {
};
IgxBarSeriesModule = __decorate([
    NgModule({
        declarations: [IgxBarSeriesComponent],
        imports: [CommonModule],
        exports: [IgxBarSeriesComponent],
        entryComponents: []
    })
], IgxBarSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBarSeriesDynamicModule = class IgxBarSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBarSeriesComponent", IgxBarSeriesComponent);
        TypeRegistrar.register("BarSeries", BarSeries.$type);
    }
};
IgxBarSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBarSeriesModule],
        exports: [IgxBarSeriesModule],
        entryComponents: [IgxBarSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBarSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVerticalCategoryModule = class IgxDataChartVerticalCategoryModule {
};
IgxDataChartVerticalCategoryModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxBarSeriesModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        imports: [CommonModule, IgxBarSeriesModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartVerticalCategoryModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVerticalCategoryDynamicModule = class IgxDataChartVerticalCategoryDynamicModule {
};
IgxDataChartVerticalCategoryDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxBarSeriesDynamicModule,
            IgxDataChartVerticalCategoryCoreDynamicModule,
            IgxDataChartVerticalCategoryModule
        ],
        imports: [CommonModule, IgxBarSeriesDynamicModule,
            IgxDataChartVerticalCategoryCoreDynamicModule,
            IgxDataChartVerticalCategoryModule
        ],
        entryComponents: []
    })
], IgxDataChartVerticalCategoryDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let IStacked100Series_$type = new Type(null, 'IStacked100Series');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StackedSeriesCreatedEventArgs extends EventArgs {
    constructor(a) {
        super();
        this.c = null;
        this.c = a;
    }
    get brush() {
        return this.c.fu;
    }
    set brush(a) {
        this.c.fu = a;
    }
    get legendItemTemplate() {
        return this.c.dv;
    }
    set legendItemTemplate(a) {
        this.c.dv = a;
    }
    get legendItemBadgeTemplate() {
        return this.c.du;
    }
    set legendItemBadgeTemplate(a) {
        this.c.du = a;
    }
    get legendItemVisibility() {
        return this.c.ge;
    }
    set legendItemVisibility(a) {
        this.c.ge = a;
    }
    get outline() {
        return this.c.fy;
    }
    set outline(a) {
        this.c.fy = a;
    }
    get dashArray() {
        return this.c.f3;
    }
    set dashArray(a) {
        this.c.f3 = a;
    }
    get dashCap() {
        return this.c.f7;
    }
    set dashCap(a) {
        this.c.f7 = a;
    }
    get index() {
        return this.c.av;
    }
    get thickness() {
        return this.c.at;
    }
    set thickness(a) {
        this.c.at = a;
    }
    get title() {
        return this.c.ax;
    }
    set title(a) {
        this.c.ax = a;
    }
    get markerBrush() {
        return this.c.fv;
    }
    set markerBrush(a) {
        this.c.fv = a;
    }
    get markerOutline() {
        return this.c.fw;
    }
    set markerOutline(a) {
        this.c.fw = a;
    }
    get markerStyle() {
        return this.c.gb;
    }
    set markerStyle(a) {
        this.c.gb = a;
    }
    get markerTemplate() {
        return this.c.dw;
    }
    set markerTemplate(a) {
        this.c.dw = a;
    }
    get markerType() {
        return this.c.l;
    }
    set markerType(a) {
        this.c.l = a;
    }
    get startCap() {
        return this.c.f6;
    }
    set startCap(a) {
        this.c.f9 = a;
    }
    get endCap() {
        return this.c.f5;
    }
    set endCap(a) {
        this.c.f8 = a;
    }
}
StackedSeriesCreatedEventArgs.$t = markType(StackedSeriesCreatedEventArgs, 'StackedSeriesCreatedEventArgs', EventArgs.$);
/**
 * @hidden
 */
class FragmentBase extends HorizontalAnchoredCategorySeries {
    constructor() {
        super();
        this.qu = null;
        this._logicalSeriesLink = null;
        this.qw = null;
        this.qu = new CategoryLineRasterizer();
    }
    get logicalSeriesLink() {
        return this._logicalSeriesLink;
    }
    set logicalSeriesLink(a) {
        this._logicalSeriesLink = a;
    }
    get parentSeries() {
        return this.qw;
    }
    set parentSeries(a) {
        this.qw = a;
    }
    get_cv() {
        return false;
    }
    get_cq() {
        return false;
    }
    get_cs() {
        return true;
    }
    e7() {
        let a = this.parentSeries;
        if (a.fh == -1 || a.pg == null || a.pg.f.indexOf(this) == -1) {
            return -1;
        }
        return a.pg.f.indexOf(this);
    }
    fb() {
        let a = this.parentSeries;
        if (a.fh == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
            return -1;
        }
        return a.series.indexOf(this.logicalSeriesLink);
    }
    resolveLegendIndex() {
        let a = this.parentSeries;
        if (a.pj) {
            return -1 + a.fh + a.pc.count - a.pg.f.indexOf(this);
        }
        return super.resolveLegendIndex();
    }
    a6() {
        return this.parentSeries;
    }
    nj() {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchXAxis();
    }
    n3() {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    }
    qy(a, b, c, d, e, f, g, h) {
        let i = c[0];
        let j = c[1];
        let k = new Rect(0, i - 5, j - 5, 11, 11);
        if (!isNaN_(i) && !isNaN_(j) && !isInfinity(i) && !isInfinity(j) && d.tryAdd(k)) {
            b.m.add({ $type: Point_$type, x: i, y: j });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    }
    oy(a, b) {
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
            return;
        }
        if (this.logicalSeriesLink.ad.count == 0 || this.logicalSeriesLink.ac.count == 0) {
            return;
        }
        this.np(b).d(a, b);
    }
    q0(a, b, c) {
        let d = this.pk(c);
        let e = d;
        let f = this.logicalSeriesLink.y;
        let g = f ? this.parentSeries.pg.e : this.parentSeries.pg.d;
        let h = g.indexOf(this);
        if (a.count == 0) {
            return;
        }
        if (h == -1) {
            return;
        }
        let i = false;
        for (let j = h; j >= 0; j--) {
            if (i) {
                break;
            }
            if (j == 0) {
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
                break;
            }
            let k = typeCast(FragmentBase.$, g._inner[j - 1]);
            if (k != null && k.qu != null && k.qu.o.count > 0 && this.bi != null && k.dw(this.bi.br, this.bi.bs, this.bi)) {
                i = true;
                for (let l = k.qu.o.count - 1; l >= 0; l--) {
                    a.add(k.qu.o._inner[l]);
                }
            }
        }
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        let e = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        let f = this.parentSeries.fetchYAxis();
        if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.bz == null || e.bh == null || f.bh == null) {
            d = false;
        }
        if (this.valueColumn == null) {
            return false;
        }
        if (isInfinity(this.valueColumn.minimum) && isInfinity(this.valueColumn.maximum)) {
            d = false;
        }
        if (isNaN_(this.valueColumn.minimum) && isNaN_(this.valueColumn.maximum)) {
            d = false;
        }
        return d;
    }
    pk(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        let f = new ScalerParams(0, c, d, this.yAxis.ca, e);
        f.b = this.eh();
        if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
            b = this.yAxis.dy(0, f);
        }
        return b;
    }
    an(a) {
        return null;
    }
    qz() {
        if (this.parentSeries == null) {
            return -1;
        }
        let a = this.parentSeries.fh;
        let b = 0;
        let c = 1;
        if (this.parentSeries.pj) {
            b = this.parentSeries.pc.count - 1;
            c = -1;
        }
        for (let d = b; this.parentSeries.pj ? d >= 0 : d < this.parentSeries.pc.count; d += c) {
            let e = this.parentSeries.pc._inner[d];
            if (e.visualSeriesLink == this) {
                return a;
            }
            if (this.parentSeries.aw == null || e.gd != 0 || e.gc != 0) {
                continue;
            }
            a++;
        }
        return -1;
    }
    q1(a) {
        if (a == null) {
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.parentSeries == null) {
            return;
        }
        let e = typeCast(NumericAxisBase.$, this.parentSeries.fetchYAxis());
        if (e == null) {
            return;
        }
        switch (b) {
            case "ValueColumn":
                if (this.pb.cz) {
                    this.pb.cy.g$i();
                }
                if (e != null && !e.cn()) {
                    this.parentSeries.pb().cn.g(this.eu);
                    this.jl(false);
                }
                break;
            case "ActualBrush":
                if (this.logicalSeriesLink != null) {
                    this.logicalSeriesLink.fp = this.lb;
                }
                break;
        }
    }
    jn(a, b) {
        super.jn(a, b);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
FragmentBase.$t = markType(FragmentBase, 'FragmentBase', HorizontalAnchoredCategorySeries.$);
/**
 * @hidden
 */
class AreaFragment extends FragmentBase {
    constructor() {
        super();
        this.ab = AreaFragment.$;
    }
    bf() {
        return new AreaFragmentView(this);
    }
    i2(a) {
        super.i2(a);
        this.q2 = a;
    }
    get_ck() {
        return true;
    }
    q4(a, b) {
        let c = this.q2.c8.ak;
        if (this.dj(a, c)) {
            return true;
        }
        let d = this.q2.c9.ak;
        if (this.dj(a, d)) {
            return true;
        }
        return false;
    }
    dh(a, b) {
        if (this.q3(a, b)) {
            return true;
        }
        if (this.q4(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    q3(a, b) {
        let c = this.q2.da.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        let d = this.q2.db.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    o1(a, b) {
        super.o1(a, b);
        this.qu.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        let c = typeCast(AreaFragmentView.$, b);
        let d = c.cn.d;
        this.qu.i(c.c8, c.da, c.c9, c.db, a.f.count, a.f, true, d, this.eu, (e, f, g, h, i) => this.q0(e, a.f, b), 0);
        c.c8._opacity = this.d6;
        c.c9._opacity = 0.5 * this.d6;
    }
    jv() {
        let a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? this.parentSeries.d6 : this.d7;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
AreaFragment.$t = markType(AreaFragment, 'AreaFragment', FragmentBase.$);
/**
 * @hidden
 */
class ColumnFragment extends FragmentBase {
    constructor() {
        super();
        this.ab = ColumnFragment.$;
    }
    bf() {
        return new ColumnFragmentView(this);
    }
    i2(a) {
        super.i2(a);
        this.q3 = a;
    }
    get fragmentXAxis() {
        return this.parentSeries != null ? typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis()) : null;
    }
    get fragmentYAxis() {
        return this.parentSeries != null ? typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis()) : null;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    nj() {
        return this.fragmentXAxis;
    }
    n3() {
        return this.fragmentYAxis;
    }
    fetchXAxis() {
        return null;
    }
    fetchYAxis() {
        return null;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        if (a && c.c7 != null) {
            this.nk.m.clear();
            c.c7.count = 0;
        }
    }
    an(a) {
        if (this.valueColumn == null || this.valueColumn.count == 0) {
            return null;
        }
        return new AxisRange(this.valueColumn.minimum, this.valueColumn.maximum);
    }
    dw(a, b, c) {
        if (this.parentSeries == null) {
            return false;
        }
        return this.parentSeries.pk(this, a, b, this.q5(c));
    }
    dt() {
        return true;
    }
    ok(a) {
        if (this.parentSeries != null) {
            return this.parentSeries.ok(this.parentSeries.bi);
        }
        return super.ok(a);
    }
    ol(a) {
        if (this.parentSeries != null) {
            return this.parentSeries.ol(this.parentSeries.bi);
        }
        return super.ok(a);
    }
    l4(a) {
        if (this.nj() == null || this.fragmentYAxis == null) {
            return Rect.empty;
        }
        let b = this.lq(a);
        let c = this.bi.bs;
        let d = this.bi.br;
        let e = this.getEffectiveViewport1(this.bi);
        let f = new ScalerParams(0, c, d, this.fragmentYAxis.ca, e);
        let g = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), a, true);
        if (g == null) {
            return Rect.empty;
        }
        let h = g[0];
        let i = g[1];
        let j = Math.abs(b.x - h[0]);
        let k = Math.abs(b.x - i[0]);
        let l = this.nj().jz(c, d, e);
        if (j < k) {
            let m = h[0] - 0.5 * l;
            let n = h[1];
            let o = h[2];
            return new Rect(0, m, Math.min(n, o), l, Math.max(n, o) - Math.min(n, o));
        }
        else {
            let p = i[0] - 0.5 * l;
            let q = i[1];
            let r = i[2];
            return new Rect(0, p, Math.min(q, r), l, Math.max(q, r) - Math.min(q, r));
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    dk(a, b) {
        let c = this.l5(a);
        if (c.isEmpty) {
            return false;
        }
        let d = this.rc(c, this.ee(b));
        return d.containsPoint(a);
    }
    rc(a, b) {
        let c = a.left + a.width / 2;
        let d = a.top + a.height / 2;
        let e = c - ((a.width / 2) + b);
        let f = d - (a.height / 2);
        let g = a.height;
        let h = a.width + b * 2;
        return new Rect(0, e, f, h, g);
    }
    fv(a, b) {
        let c = typeCast(FrameworkElement.$, a);
        let d = c != null ? typeCast(DataContext.$, c.dataContext) : null;
        let e = d != null ? d.item : null;
        if (e == null) {
            let f = this.bi.br;
            let g = this.bs != null ? this.bs.n2 : Rect.empty;
            let h = { $type: Point_$type, x: g.left + g.width * (b.x - f.left) / f.width, y: g.top + g.height * (b.y - f.top) / f.height };
            e = this.fp(h);
        }
        return e;
    }
    fp(a) {
        let b = 0;
        if (typeCast(ISortingAxis_$type, this.nj()) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    fa(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        let e = this.nj();
        let f = new ScalerParams(0, b, c, e.ca, d);
        let g = typeCast(ISortingAxis_$type, this.fragmentXAxis);
        let h = this.l0(this.bi);
        let i = e.d1(h.left, f);
        let j = e.d1(h.right, f);
        let k = (a.x - b.left) / b.width;
        let l = i + ((j - i) * k);
        if (truncate(l) <= dateMinValue().getTime() || truncate(l) >= dateMaxValue().getTime()) {
            return -1;
        }
        let m = g.i$f(l);
        return m;
    }
    e8(a) {
        if (this.parentSeries == null) {
            return -1;
        }
        return this.parentSeries.pq(a);
    }
    qy(a, b, c, d, e, f, g, h) {
        let i = 0;
        let j = c[0];
        let k = e < i ? c[2] : c[1];
        let l = new Rect(0, j - 5, k - 5, 11, 11);
        if (!isNaN_(j) && !isNaN_(k) && !isInfinity(j) && !isInfinity(k) && d.tryAdd(l)) {
            b.m.add({ $type: Point_$type, x: j, y: k });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    }
    q5(a) {
        if (a.m) {
            return this.parentSeries.a0.a$h.item(a.aa);
        }
        else if (a == this.bh) {
            return this.parentSeries.bh;
        }
        else {
            return this.parentSeries.ns;
        }
    }
    jk(a, b, c, d, e) {
        this.a0.a$r(this, a, b, d, e);
        let f = this.a0.a$h.item(d);
        let g = f;
        f.ay(c);
        let h = this.q5(f);
        h.cn.g(this.eu);
        if (this.cc(g)) {
            return;
        }
        if (this.pc == null) {
            this.pc = new CategoryFrame(3);
        }
        this.pc.u();
        this.oy(this.pc, g);
        this.o1(this.pc, g);
    }
    oy(a, b) {
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null || this.logicalSeriesLink.ac.count == 0 || this.logicalSeriesLink.ad.count == 0) {
            return;
        }
        let c;
        if (b.m) {
            c = this.parentSeries.pa;
        }
        else if (b == this.bh) {
            c = this.parentSeries.nm;
        }
        else {
            c = this.parentSeries.nk;
        }
        let d = typeCast(CategorySeriesView.$, this.q5(b));
        a.f.clear();
        a.m.clear();
        let e = d.cn.e;
        let f = d.cn.f;
        let g = this.parentSeries.no.h.yScaler;
        let h = typeCast(ISortingAxis_$type, this.parentSeries.no.h.scaler);
        let i = typeCast(NumericAxisBase.$, g) !== null && g.j2;
        let j = typeCast(StackedBucketCalculator.$, d.cn);
        let k = d.cn.d;
        let l = 0;
        for (let m = e; m <= f; m++) {
            let n = m * k;
            if (this._visibility != 0) {
                break;
            }
            if (m >= this.valueColumn.count || m >= c.f.count + e) {
                continue;
            }
            let o = this.valueColumn.item(m);
            let p = !i || (i && o > 0);
            let q;
            if (h == null) {
                q = j.getBucket1(this, m, m, b.bs, b.br, c);
            }
            else {
                q = j.getBucket1(this, m, h.i$b._inner[m], b.bs, b.br, c);
            }
            a.f.add(q);
            if (p) {
                if (this.qy(b, a, q, this.no.h.provideCollisionDetector(), o, n, l, m)) {
                    l++;
                }
            }
        }
        b.cq.count = l;
    }
    o1(a, b) {
        super.o1(a, b);
        if (this.parentSeries == null) {
            return;
        }
        this.parentSeries.pz(this, a, b);
        CategoryMarkerManager.b(this, a.m, b.cq, this.mf);
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
ColumnFragment.$t = markType(ColumnFragment, 'ColumnFragment', FragmentBase.$);
ColumnFragment.$$p = markDep(DependencyProperty, PropertyMetadata, ColumnFragment, 'raisePropertyChanged', ['RadiusX:q6:ra', [1, 2], 'RadiusY:q7:rb', [1, 2]]);
/**
 * @hidden
 */
class BarFragment extends ColumnFragment {
    constructor() {
        super();
        this.ab = BarFragment.$;
    }
    get barFragmentXAxis() {
        return this.parentSeries != null ? this.parentSeries.xAxis : null;
    }
    get barFragmentYAxis() {
        return this.parentSeries != null ? this.parentSeries.yAxis : null;
    }
    nj() {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    }
    eb(a) {
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        let c = this.bi.br;
        let d = this.l0(this.bi);
        let e = this.getEffectiveViewport1(this.bi);
        let f = this.nj();
        let g = -1;
        if (f != null && !b.isEmpty && !c.isEmpty) {
            let h = new ScalerParams(0, b, c, f.ca, e);
            let i = f.d1(d.top, h);
            let j = f.d1(d.bottom, h);
            let k = (a.y - b.top) / b.height;
            let l = i + (k * (j - i));
            if (f.categoryMode != 0) {
                l -= 0.5;
            }
            g = l;
        }
        return g;
    }
    n3() {
        if (this.parentSeries == null) {
            return null;
        }
        return this.parentSeries.fetchYAxis();
    }
    rc(a, b) {
        let c = a.left + a.width / 2;
        let d = a.top + a.height / 2;
        let e = c - (a.width / 2);
        let f = d - ((a.height / 2) + b);
        let g = a.height + b * 2;
        let h = a.width;
        return new Rect(0, e, f, h, g);
    }
    l4(a) {
        if (this.nj() == null) {
            return Rect.empty;
        }
        let b = this.lq(a);
        let c = this.bi.bs;
        let d = this.bi.br;
        let e = this.getEffectiveViewport1(this.bi);
        let f = this.nj();
        let g = new ScalerParams(0, c, d, f.ca, e);
        let h = this.aj(this.nj(), this.nk.f, this.ok(this.bi), this.ol(this.bi), a, true);
        if (h == null) {
            return Rect.empty;
        }
        let i = h[0];
        let j = h[1];
        let k = Math.abs(b.y - i[0]);
        let l = Math.abs(b.y - j[0]);
        let m = f.jz(c, d, e);
        if (k < l) {
            let n = i[0] - 0.5 * m;
            let o = i[2];
            let p = i[1];
            return new Rect(0, o, n, Math.max(p, o) - Math.min(p, o), m);
        }
        else {
            let q = j[0] - 0.5 * m;
            let r = j[2];
            let s = j[1];
            return new Rect(0, r, q, Math.max(s, r) - Math.min(s, r), m);
        }
    }
    dh(a, b) {
        if (this.dk(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    qy(a, b, c, d, e, f, g, h) {
        let i = c[0];
        let j = e < 0 ? c[2] : c[1];
        let k = new Rect(0, j - 5, i - 5, 11, 11);
        if (!isNaN_(j) && !isNaN_(i) && !isInfinity(j) && !isInfinity(i) && d.tryAdd(k)) {
            b.m.add({ $type: Point_$type, x: j, y: i });
            a.updateMarkerTemplate(g, f, h);
            return true;
        }
        return false;
    }
    fp(a) {
        let b = 0;
        if (typeCast(ISortingAxis_$type, this.barFragmentYAxis) !== null) {
            b = this.fa(a);
            if (b == -1) {
                return null;
            }
        }
        else {
            b = this.e8(a);
        }
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    fa(a) {
        let b = this.bi.bs;
        let c = this.bi.br;
        if (b.isEmpty || c.isEmpty) {
            return -1;
        }
        let d = this.getEffectiveViewport1(this.bi);
        let e = new ScalerParams(0, b, c, this.barFragmentYAxis.ca, d);
        let f = typeCast(ISortingAxis_$type, this.barFragmentYAxis);
        let g = this.l0(this.bi);
        let h = this.barFragmentYAxis.d1(g.top, e);
        let i = this.barFragmentYAxis.d1(g.bottom, e);
        let j = (a.y - b.top) / b.height;
        let k = h + ((i - h) * j);
        if (truncate(k) <= dateMinValue().getTime() || truncate(k) >= dateMaxValue().getTime()) {
            return -1;
        }
        let l = f.i$f(k);
        return l;
    }
    pk(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        let f = new ScalerParams(0, c, d, this.barFragmentXAxis.ca, e);
        if (!c.isEmpty && !d.isEmpty && this.barFragmentXAxis != null) {
            b = this.barFragmentXAxis.dy(0, f);
        }
        return b;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        if (this.parentSeries == null || this.barFragmentXAxis == null) {
            return;
        }
        let e = this.barFragmentXAxis;
        switch (b) {
            case "ValueColumn":
                if (this.pb.cz) {
                    this.pb.cy.g$i();
                }
                if (e != null && !e.cn()) {
                    this.parentSeries.pb().cn.g(this.eu);
                    this.jl(false);
                }
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
BarFragment.$t = markType(BarFragment, 'BarFragment', ColumnFragment.$);
/**
 * @hidden
 */
class AreaFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getBucket(a) {
        let b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        let c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        let d = NaN;
        let e = NaN;
        let f = this.i.cw;
        let g = f.parentSeries;
        let h = typeCast(IStacked100Series_$type, g) !== null;
        let i = this.i.cw.valueColumn;
        let j = g.o8;
        let k = g.o9;
        let l = f.logicalSeriesLink.ad;
        let m = f.logicalSeriesLink.ac;
        for (let n = b; n <= c; ++n) {
            let o = i.item(n);
            if (isNaN_(o) || isInfinity(o)) {
                o = 0;
            }
            let p = Math.abs(k[n]) + j[n];
            if (h) {
                if (p == 0) {
                    o = 0;
                }
                else if (o < 0) {
                    o = (l._inner[n] + o) / p * 100;
                }
                else {
                    o = (m._inner[n] + o) / p * 100;
                }
            }
            else {
                o = o < 0 ? l._inner[n] + o : m._inner[n] + o;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(o)) {
                    d = Math.min(d, o);
                    e = Math.max(e, o);
                }
            }
            else {
                d = o;
                e = o;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    }
}
AreaFragmentBucketCalculator.$t = markType(AreaFragmentBucketCalculator, 'AreaFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
/**
 * @hidden
 */
class LineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucketWithoutUnknowns(a) {
        return this.getBucket(a);
    }
    getBucket(a) {
        let b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        let c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        let d = NaN;
        let e = NaN;
        let f = typeCast(FragmentBase.$, this.i.cw);
        let g = f.parentSeries;
        for (let h = b; h <= c; ++h) {
            let i = this.i.cw.valueColumn.item(h);
            let j = Math.abs(g.o9[h]) + g.o8[h];
            if (isNaN_(i) || isInfinity(i)) {
                i = 0;
            }
            if (typeCast(IStacked100Series_$type, g) !== null) {
                if (j == 0) {
                    i = 0;
                }
                else if (i < 0) {
                    i = (f.logicalSeriesLink.ad._inner[h] + i) / j * 100;
                }
                else {
                    i = (f.logicalSeriesLink.ac._inner[h] + i) / j * 100;
                }
            }
            else {
                i = i < 0 ? f.logicalSeriesLink.ad._inner[h] + i : f.logicalSeriesLink.ac._inner[h] + i;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(i)) {
                    d = Math.min(d, i);
                    e = Math.max(e, i);
                }
            }
            else {
                d = i;
                e = i;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    }
}
LineFragmentBucketCalculator.$t = markType(LineFragmentBucketCalculator, 'LineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
/**
 * @hidden
 */
class SplineFragmentBucketCalculator extends AnchoredCategoryBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        let b = Math.min(a * this.d, this.i.cw.valueColumn.count - 1);
        let c = Math.min(b + this.d - 1, this.i.cw.valueColumn.count - 1);
        let d = NaN;
        let e = NaN;
        let f = typeCast(SplineFragmentBase.$, this.i.cw);
        let g = f.parentSeries;
        for (let h = b; h <= c; ++h) {
            let i = this.i.cw.valueColumn.item(h);
            let j = Math.abs(g.o9[h]) + g.o8[h];
            if (isNaN_(i) || isInfinity(i)) {
                i = 0;
            }
            if (typeCast(IStacked100Series_$type, g) !== null) {
                if (j == 0) {
                    i = 0;
                }
                else if (i < 0) {
                    i = (f.logicalSeriesLink.ad._inner[h] + i) / j * 100;
                }
                else {
                    i = (f.logicalSeriesLink.ac._inner[h] + i) / j * 100;
                }
            }
            else {
                i = i < 0 ? f.logicalSeriesLink.ad._inner[h] + i : f.logicalSeriesLink.ac._inner[h] + i;
            }
            if (!isNaN_(d)) {
                if (!isNaN_(i)) {
                    d = Math.min(d, i);
                    e = Math.max(e, i);
                }
            }
            else {
                d = i;
                e = i;
            }
        }
        if (!isNaN_(d)) {
            return [0.5 * (b + c), d, e];
        }
        return [0.5 * (b + c), NaN, NaN];
    }
}
SplineFragmentBucketCalculator.$t = markType(SplineFragmentBucketCalculator, 'SplineFragmentBucketCalculator', AnchoredCategoryBucketCalculator.$);
/**
 * @hidden
 */
class StackedBucketCalculator extends CategoryBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        let b = typeCast(StackedSeriesBase.$, this.c.cp);
        let c = Math.min(b.o9 != null ? b.o9.length : 0, b.o8 != null ? b.o8.length : 0);
        let d = Math.min(a * this.d, c - 1);
        let e = Math.min(d + this.d - 1, c - 1);
        let f = NaN;
        let g = NaN;
        for (let h = d; h <= e; ++h) {
            let i = Math.min(b.o9[h], b.o8[h]);
            let j = Math.max(b.o9[h], b.o8[h]);
            if (!isNaN_(f)) {
                if (!isNaN_(i)) {
                    f = Math.min(f, i);
                    g = Math.max(g, i);
                }
                if (!isNaN_(j)) {
                    f = Math.min(f, j);
                    g = Math.max(g, j);
                }
            }
            else {
                f = i;
                g = j;
            }
        }
        if (!isNaN_(f) && !isNaN_(g)) {
            return [0.5 * (d + e), f, g];
        }
        return [NaN, NaN, NaN];
    }
    getBucket1(a, b, c, d, e, f) {
        return null;
    }
}
StackedBucketCalculator.$t = markType(StackedBucketCalculator, 'StackedBucketCalculator', CategoryBucketCalculator.$);
/**
 * @hidden
 */
class StackedBarBucketCalculator extends StackedBucketCalculator {
    constructor(a) {
        super(a);
    }
    g(a) {
        let b = this.c.bs;
        let c = this.c.br;
        let d = typeCast(StackedBarSeries.$, this.c.cp);
        let e = this.c.cp.bz;
        if (b.isEmpty || c.isEmpty || d.yAxis == null || e == null || e.count == 0) {
            this.d = 0;
            return;
        }
        let f = d.getEffectiveViewport1(this.c);
        let g = new ScalerParams(0, b, c, d.yAxis.ca, f);
        let h = d.l0(this.c);
        let i = Math.floor(d.yAxis.d2(h.top, g, 0));
        let j = Math.ceil(d.yAxis.d2(h.bottom, g, 0));
        if (!d.yAxis.ca) {
            j = Math.ceil(d.yAxis.d2(h.top, g, 0));
            i = Math.floor(d.yAxis.d2(h.bottom, g, 0));
        }
        let k = Math.floor((j - i + 1) * a / h.height);
        this.d = truncate(Math.max(1, k));
        this.e = truncate(Math.max(0, Math.floor(i / this.d) - 1));
        this.f = truncate(Math.ceil(j / this.d));
    }
    getBucket(a) {
        return super.getBucket(a);
    }
    getBucket1(a, b, c, d, e, f) {
        let g = [NaN, NaN, NaN];
        let h = typeCast(BarFragment.$, a);
        if (h == null || h.logicalSeriesLink == null) {
            return g;
        }
        let i = typeCast(StackedBarSeries.$, this.c.cp);
        let j = a.valueColumn.item(c);
        let k = 0;
        let l = NaN;
        let m = NaN;
        let n = Number.NEGATIVE_INFINITY;
        let o = Number.POSITIVE_INFINITY;
        let p = i.getEffectiveViewport1(this.c);
        let q = Math.min(i.o9 != null ? i.o9.length : 0, i.o8 != null ? i.o8.length : 0);
        let r = c * this.d;
        let s = Math.min(r + this.d - 1, q - 1);
        for (let t = r; t <= s; ++t) {
            j = a.valueColumn.item(t);
            if (j < k) {
                o = Math.min(o, h.logicalSeriesLink.ad._inner[t] + j);
                n = Math.max(n, h.logicalSeriesLink.ad._inner[t]);
            }
            else {
                o = Math.min(o, h.logicalSeriesLink.ac._inner[t]);
                n = Math.max(n, h.logicalSeriesLink.ac._inner[t] + j);
            }
            if (!isNaN_(l)) {
                if (!isNaN_(o)) {
                    l = Math.min(l, o);
                    m = Math.max(m, o);
                }
                if (!isNaN_(n)) {
                    l = Math.min(l, n);
                    m = Math.max(m, n);
                }
            }
            else {
                l = o;
                m = n;
            }
        }
        let u = new ScalerParams(0, d, e, i.xAxis.ca, p);
        g = [f.f._inner[b - this.e][0], i.xAxis.dy(m, u), i.xAxis.dy(l, u)];
        return g;
    }
}
StackedBarBucketCalculator.$t = markType(StackedBarBucketCalculator, 'StackedBarBucketCalculator', StackedBucketCalculator.$);
/**
 * @hidden
 */
class StackedColumnBucketCalculator extends StackedBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        return super.getBucket(a);
    }
    getBucket1(a, b, c, d, e, f) {
        let g = [NaN, NaN, NaN];
        let h = typeCast(ColumnFragment.$, a);
        if (h == null || h.logicalSeriesLink == null) {
            return g;
        }
        let i = typeCast(StackedColumnSeries.$, this.c.cp);
        let j = a.valueColumn.item(c);
        let k = 0;
        let l = NaN;
        let m = NaN;
        let n = Number.NEGATIVE_INFINITY;
        let o = Number.POSITIVE_INFINITY;
        let p = i.getEffectiveViewport1(this.c);
        let q = Math.min(i.o9 != null ? i.o9.length : 0, i.o8 != null ? i.o8.length : 0);
        let r = c * this.d;
        let s = Math.min(r + this.d - 1, q - 1);
        for (let t = r; t <= s; ++t) {
            j = a.valueColumn.item(t);
            if (j < k) {
                o = Math.min(o, h.logicalSeriesLink.ad._inner[t] + j);
                n = Math.max(n, h.logicalSeriesLink.ad._inner[t]);
            }
            else {
                o = Math.min(o, h.logicalSeriesLink.ac._inner[t]);
                n = Math.max(n, h.logicalSeriesLink.ac._inner[t] + j);
            }
            if (!isNaN_(l)) {
                if (!isNaN_(o)) {
                    l = Math.min(l, o);
                    m = Math.max(m, o);
                }
                if (!isNaN_(n)) {
                    l = Math.min(l, n);
                    m = Math.max(m, n);
                }
            }
            else {
                l = o;
                m = n;
            }
        }
        let u = new ScalerParams(0, d, e, i.yAxis.ca, p);
        g = [f.f._inner[b - this.e][0], i.yAxis.dy(m, u), i.yAxis.dy(l, u)];
        return g;
    }
}
StackedColumnBucketCalculator.$t = markType(StackedColumnBucketCalculator, 'StackedColumnBucketCalculator', StackedBucketCalculator.$);
/**
 * @hidden
 */
class LineFragment extends FragmentBase {
    constructor() {
        super();
        this.ab = LineFragment.$;
    }
    bf() {
        return new LineFragmentView(this);
    }
    i2(a) {
        super.i2(a);
        this.q2 = a;
    }
    q4(a, b) {
        let c = this.q2.c8.ak;
        if (this.dj(a, c)) {
            return true;
        }
        return false;
    }
    get_ck() {
        return true;
    }
    dh(a, b) {
        if (this.q3(a, b)) {
            return true;
        }
        if (this.q4(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    q3(a, b) {
        let c = this.q2.c9.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        let d = this.q2.da.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c7();
    }
    o1(a, b) {
        super.o1(a, b);
        let c = (d) => a.f._inner[d][0];
        let d = (e) => a.f._inner[e][1];
        let e = (f) => a.f._inner[f][0];
        let f = (g) => a.f._inner[g][2];
        this.qu.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        let g = b.cn.d;
        let h = typeCast(LineFragmentView.$, b);
        this.qu.m(h.c9, h.c8, h.da, a.f.count, a.f, true, 0, this.o9(a.f, a.f.count - 1, b.br, b.bs), g, this.eu);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
LineFragment.$t = markType(LineFragment, 'LineFragment', FragmentBase.$);
/**
 * @hidden
 */
class SplineFragmentBase extends SplineSeriesBase {
    constructor() {
        super();
        this._logicalSeriesLink = null;
        this.q4 = null;
        this.q6 = null;
        this.q4 = new CategoryLineRasterizer();
    }
    get logicalSeriesLink() {
        return this._logicalSeriesLink;
    }
    set logicalSeriesLink(a) {
        this._logicalSeriesLink = a;
    }
    get parentSeries() {
        return this.q6;
    }
    set parentSeries(a) {
        this.q6 = a;
    }
    get_cq() {
        return false;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get_cs() {
        return true;
    }
    e7() {
        let a = this.parentSeries;
        if (a.fh == -1 || a.pg == null || a.pg.f.indexOf(this) == -1) {
            return -1;
        }
        return a.pg.f.indexOf(this);
    }
    resolveLegendIndex() {
        let a = this.parentSeries;
        if (a.pj) {
            return -1 + a.fh + a.pc.count - a.pg.f.indexOf(this);
        }
        return super.resolveLegendIndex();
    }
    fb() {
        let a = this.parentSeries;
        if (a.fh == -1 || a.series.count == 0 || a.series.indexOf(this.logicalSeriesLink) == -1) {
            return -1;
        }
        return a.series.indexOf(this.logicalSeriesLink);
    }
    a6() {
        return this.parentSeries;
    }
    qx(a, b, c, d, e, f, g) {
        let h = b[0];
        let i = b[1];
        let j = new Rect(0, h - 5, i - 5, 11, 11);
        if (!isNaN_(h) && !isNaN_(i) && !isInfinity(h) && !isInfinity(i) && c.tryAdd(j)) {
            a.m.add({ $type: Point_$type, x: h, y: i });
            let k = f.cq.item(e);
            k.content.item = this.bz.item(d);
            k.al = g;
            return true;
        }
        return false;
    }
    dw(a, b, c) {
        let d = super.dw(a, b, c);
        let e = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        let f = this.parentSeries.fetchYAxis();
        if (this.parentSeries == null || e == null || e.itemsSource == null || f == null || this.parentSeries.bz == null || e.bh == null || f.bh == null) {
            d = false;
        }
        if (this.valueColumn == null) {
            return false;
        }
        if (isInfinity(this.valueColumn.minimum) && isInfinity(this.valueColumn.maximum)) {
            d = false;
        }
        if (isNaN_(this.valueColumn.minimum) && isNaN_(this.valueColumn.maximum)) {
            d = false;
        }
        return d;
    }
    an(a) {
        return null;
    }
    q8(a, b, c, d, e, f) {
        let g = typeCast(ISortingAxis_$type, d);
        if (g == null) {
            return;
        }
        let h = this.getEffectiveViewport1(f);
        let i = new ScalerParams(0, b, c, d.ca, h);
        let j = new ScalerParams(0, b, c, e.ca, h);
        let k = d.d1(2, i) - d.d1(1, i);
        let l = this.md();
        let m = 0;
        let n = this.qz(d, b, c, h);
        let o = (p) => Math.abs(this.parentSeries.o9[p]) + this.parentSeries.o8[p];
        let p = (q) => q;
        let q = (r) => {
            let s = g.i$b._inner[r];
            if (typeCast(IStacked100Series_$type, this.parentSeries) !== null) {
                return this.valueColumn.item(s) < 0 ? (this.logicalSeriesLink.ad._inner[s] + this.valueColumn.item(s)) / o(s) * 100 : (this.logicalSeriesLink.ac._inner[s] + this.valueColumn.item(s)) / o(s) * 100;
            }
            else {
                return this.valueColumn.item(s) < 0 ? this.logicalSeriesLink.ad._inner[s] + this.valueColumn.item(s) : this.logicalSeriesLink.ac._inner[s] + this.valueColumn.item(s);
            }
        };
        let r = this.ns.cn.f;
        let s = this.ns.cn.e;
        let t = truncate(Math.ceil(c.width / (r - s)));
        let u = new CollisionAvoider();
        let v = this.ns.cn.d;
        if (v <= 0 || (s <= 0 && r <= 0)) {
            this.ns.cq.count = m;
            return;
        }
        let w = 0;
        for (let x = s; x < r + 1; ++x) {
            let y = null;
            let z = x * v;
            if (g != null && g.i$b != null && z >= 0 && z < g.i$b.count) {
                z = g.i$b._inner[z];
            }
            if (x >= (this.valueColumn.count - 1)) {
                if (l && this.qx(a, a.f._inner[a.f.count - 1], u, Math.min(z, this.bz.count - 1), m, f, w - 1)) {
                    ++m;
                }
                break;
            }
            let aa = p(x);
            let ab = q(x);
            let ac = p(x + 1);
            let ad = q(x + 1);
            let ae = ac - aa;
            let af = this.qu[x];
            let ag = this.qu[x + 1];
            let ah = g.i$d(g.i$b._inner[x]);
            let ai = d.dy(ah, i) + n;
            let aj = e.dy(ab, j);
            a.f.add([ai, aj, aj]);
            w++;
            for (let ak = 1; ak < t; ++ak) {
                let al = ak / t;
                let am = aa + ae * al;
                let an = (ac - am) / ae;
                let ao = (am - aa) / ae;
                let ap = an * ab + ao * ad + ((an * an * an - an) * af + (ao * ao * ao - ao) * ag) * (ae * ae) / 6;
                let aq = g.i$d(g.i$b._inner[x]);
                let ar = g.i$d(g.i$b._inner[x + 1]);
                if (aq == ar && ab == ad) {
                    break;
                }
                let as = aq + (ar - aq) * al;
                am = d.dy(as, i) + n;
                ap = e.dy(ap, j);
                a.f.add([am, ap, ap]);
                w++;
            }
            if (l) {
                y = [ai, aj, aj];
            }
            if (l && this.qx(a, y, u, Math.min(z, this.bz.count - 1), m, f, w - 1)) {
                ++m;
            }
        }
        this.ns.cq.count = m;
    }
    oy(a, b) {
        a.u();
        if (this.valueColumn == null || this.parentSeries == null || this.logicalSeriesLink == null) {
            return;
        }
        if (this.logicalSeriesLink.ad.count == 0 || this.logicalSeriesLink.ac.count == 0) {
            return;
        }
        if (this.ns.cn.d == 0) {
            return;
        }
        super.oy(a, b);
        if (a.f.count <= 1) {
            return;
        }
        let c = b.bs;
        let d = b.br;
        let e = this.getEffectiveViewport1(b);
        let f = typeCast(CategoryAxisBase.$, this.parentSeries.fetchXAxis());
        let g = typeCast(NumericYAxis.$, this.parentSeries.fetchYAxis());
        let h = new ScalerParams(0, c, d, f.ca, e);
        let i = new ScalerParams(0, c, d, g.ca, e);
        a.f.clear();
        a.m.clear();
        let j = this.md();
        let k = 0;
        let l;
        let m;
        if (b.m) {
            l = this.parentSeries.pa;
            m = this.parentSeries.a0.a$h.item(b.aa);
        }
        else if (b == this.bh) {
            l = this.parentSeries.nm;
            m = typeCast(CategorySeriesView.$, this.parentSeries.bh);
        }
        else {
            l = this.parentSeries.nk;
            m = this.parentSeries.ns;
        }
        let n = m.cn.d;
        let o = typeCast(ISortingAxis_$type, f);
        if (o != null && o.i$b.count != this.bz.count) {
            return;
        }
        let p = this.preferredCategoryMode(f);
        if (p == 0 && f.categoryMode != 0) {
            p = 1;
        }
        let q = 0;
        switch (p) {
            case 0:
                q = 0;
                break;
            case 1:
                q = 0.5 * f.getCategorySize(c, d, e);
                break;
            case 2:
                let r = this.fh;
                q = f.getGroupCenter(this.fh, c, d, e);
                break;
        }
        if (f.ca) {
            q = -q;
        }
        let s = (t) => Math.abs(this.parentSeries.o9[t]) + this.parentSeries.o8[t];
        let t = (u) => u;
        let u = (v) => {
            let w = this.valueColumn.item(v);
            if (isNaN_(w) || isInfinity(w)) {
                w = 0;
            }
            if (typeCast(IStacked100Series_$type, this.parentSeries) !== null) {
                if (s(v) == 0) {
                    return 0;
                }
                return w < 0 ? (this.logicalSeriesLink.ad._inner[v] + w) / s(v) * 100 : (this.logicalSeriesLink.ac._inner[v] + w) / s(v) * 100;
            }
            return w < 0 ? this.logicalSeriesLink.ad._inner[v] + w : this.logicalSeriesLink.ac._inner[v] + w;
        };
        let v = b.cn.d;
        let w = this.qw == 0 ? NaN : 0;
        if (f != null && typeCast(ISortingAxis_$type, f) !== null && f.i$b != null) {
            let x = new SafeSortedReadOnlyDoubleCollection(0, this.valueColumn, f.i$b);
            u = (y) => x.item(y);
        }
        this.qu = Numeric.c(this.valueColumn.count, t, u, w, w);
        let y = m.cn.e;
        let z = m.cn.f;
        let aa = truncate(Math.ceil(d.width / (z - y)));
        let ab = new CollisionAvoider();
        if (o != null) {
            this.q8(a, c, d, f, g, b);
            return;
        }
        let ac = 0;
        let ad = 0;
        for (let ae = y; ae < z + 1; ++ae) {
            if (ae >= this.valueColumn.count) {
                break;
            }
            let af = null;
            if (v == 1) {
                if (ae >= (this.valueColumn.count - 1)) {
                    if (j && a.f.count > 0 && this.qx(a, a.f._inner[a.f.count - 1], ab, Math.min(ae * v, this.bz.count - 1), k, b, ac - 1)) {
                        ++k;
                    }
                    break;
                }
                let ag = t(ae);
                let ah = t(ae + 1);
                let ai = u(ae);
                let aj = u(ae + 1);
                let ak = ah - ag;
                let al = this.qu[ae];
                let am = this.qu[ae + 1];
                let an = f.dy(ag, h) + q;
                let ao = g.dy(ai, i);
                a.f.add([an, ao, ao]);
                ac++;
                ad = ac;
                for (let ap = 1; ap < aa; ++ap) {
                    let aq = ag + ak * ap / aa;
                    let ar = (ah - aq) / ak;
                    let as = (aq - ag) / ak;
                    let at = ar * ai + as * aj + ((ar * ar * ar - ar) * al + (as * as * as - as) * am) * (ak * ak) / 6;
                    aq = f.dy(aq, h) + q;
                    at = g.dy(at, i);
                    a.f.add([aq, at, at]);
                    ac++;
                }
                if (j) {
                    af = [an, ao, ao];
                }
            }
            else {
                af = b.cn.getBucket(ae);
                if (!isNaN_(af[0])) {
                    af[0] = f.dy(af[0], h) + q;
                    af[1] = g.dy(af[1], i);
                    af[2] = g.dy(af[2], i);
                    a.f.add(af);
                }
            }
            if (j && this.qx(a, af, ab, Math.min(ae * v, this.bz.count - 1), k, b, ad - 1)) {
                ++k;
            }
        }
        b.cq.count = k;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "ActualBrush":
                if (this.logicalSeriesLink != null) {
                    this.logicalSeriesLink.fp = this.lb;
                }
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineFragmentBase.$t = markType(SplineFragmentBase, 'SplineFragmentBase', SplineSeriesBase.$);
/**
 * @hidden
 */
class SplineAreaFragment extends SplineFragmentBase {
    constructor() {
        super();
        this.rd = null;
        this.ab = SplineAreaFragment.$;
    }
    bf() {
        return new SplineAreaFragmentView(this);
    }
    i2(a) {
        super.i2(a);
        this.q9 = typeCast(SplineAreaFragmentView.$, a);
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    get_ck() {
        return true;
    }
    rb(a, b) {
        let c = this.q9.c9.ak;
        if (this.dj(a, c)) {
            return true;
        }
        let d = this.q9.da.ak;
        if (this.dj(a, d)) {
            return true;
        }
        return false;
    }
    dh(a, b) {
        if (this.ra(a, b)) {
            return true;
        }
        if (this.rb(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    ra(a, b) {
        let c = this.q9.db.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        let d = this.q9.dc.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c8();
    }
    o1(a, b) {
        super.o1(a, b);
        this.q4.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        let c = typeCast(SplineAreaFragmentView.$, b);
        let d = b.cn.d;
        this.q4.i(c.c9, c.db, c.da, c.dc, a.f.count, a.f, true, d, this.eu, (e, f, g, h, i) => this.rc(e, a.f, b), 1);
        c.c9._opacity = this.d6;
        c.da._opacity = 0.5 * this.d6;
    }
    jn(a, b) {
        super.jn(a, b);
    }
    rc(a, b, c) {
        let d = this.pk(c);
        let e = d;
        let f = this.logicalSeriesLink.y;
        let g = f ? this.parentSeries.pg.e : this.parentSeries.pg.d;
        let h = g.indexOf(this);
        if (a.count == 0) {
            return;
        }
        if (h == -1) {
            return;
        }
        let i = false;
        for (let j = h; j >= 0; j--) {
            if (i) {
                break;
            }
            if (j == 0) {
                a.add({ $type: Point_$type, x: a._inner[a.count - 1].x, y: e });
                a.add({ $type: Point_$type, x: a._inner[0].x, y: e });
                break;
            }
            let k = typeCast(SplineFragmentBase.$, g._inner[j - 1]);
            if (k != null && k.q4 != null && k.q4.o.count > 0 && this.bi != null && k.dw(this.bi.br, this.bi.bs, this.bi)) {
                i = true;
                for (let l = k.q4.o.count - 1; l >= 0; l--) {
                    a.add(k.q4.o._inner[l]);
                }
            }
        }
    }
    pk(a) {
        let b = 0;
        let c = a.bs;
        let d = a.br;
        let e = this.getEffectiveViewport1(a);
        let f = new ScalerParams(0, c, d, this.yAxis.ca, e);
        if (!c.isEmpty && !d.isEmpty && this.yAxis != null) {
            b = this.yAxis.dy(0, f);
        }
        return b;
    }
    jv() {
        let a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? this.parentSeries.d6 : this.d7;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineAreaFragment.$t = markType(SplineAreaFragment, 'SplineAreaFragment', SplineFragmentBase.$);
/**
 * @hidden
 */
class SplineFragment extends SplineFragmentBase {
    constructor() {
        super();
        this.ab = SplineFragment.$;
    }
    bf() {
        return new SplineFragmentView(this);
    }
    i2(a) {
        super.i2(a);
        this.q9 = a;
    }
    rb(a, b) {
        let c = this.q9.c9.ak;
        if (this.dj(a, c)) {
            return true;
        }
        return false;
    }
    get_ck() {
        return true;
    }
    dh(a, b) {
        if (this.ra(a, b)) {
            return true;
        }
        if (this.rb(a, b)) {
            return true;
        }
        if (this.me(a, b)) {
            return true;
        }
        return false;
    }
    ra(a, b) {
        let c = this.q9.da.ak;
        if (this.di(a, b, c)) {
            return true;
        }
        let d = this.q9.db.ak;
        if (this.di(a, b, d)) {
            return true;
        }
        return false;
    }
    h3(a, b) {
        super.h3(a, b);
        let c = b;
        c.c8();
    }
    o1(a, b) {
        super.o1(a, b);
        this.q4.a = typeCast(ISortingAxis_$type, this.xAxis) !== null ? true : false;
        let c = typeCast(SplineFragmentView.$, b);
        let d = c.cn.d;
        this.q4.m(c.da, c.c9, c.db, a.f.count, a.f, true, 1, this.o9(a.f, a.f.count - 1, b.br, b.bs), d, this.eu);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
SplineFragment.$t = markType(SplineFragment, 'SplineFragment', SplineFragmentBase.$);
/**
 * @hidden
 */
class StackedSeriesBase extends CategorySeries {
    constructor() {
        super();
        this._series = null;
        this.seriesCreated = null;
        this.pp = 0;
        this.po = 0;
        this.o8 = null;
        this.o9 = null;
        this.pg = null;
        this.pd = null;
        this.pl = new Dictionary$2(String_$type, Boolean_$type, 0);
        this.pa = null;
        this.series = new StackedSeriesCollection();
        let a = this.series;
        a.collectionResetting = delegateCombine(a.collectionResetting, runOn(this, this.p1));
        let b = this.series;
        b.collectionChanged = delegateCombine(b.collectionChanged, runOn(this, this.p0));
        this.no = new StackedSeriesFramePreparer(1, this, this.ph, this, this, this.ph.cn);
        this.pg = new StackedSeriesManager(this);
        this.pd = new StackedSeriesCollection();
        let c = this.pd;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.p0));
        let d = this.pd;
        d.collectionResetting = delegateCombine(d.collectionResetting, runOn(this, this.pv));
    }
    get_cv() {
        return false;
    }
    getHostReferenceValue() {
        return this.eh();
    }
    bf() {
        return new StackedSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.ph = a;
    }
    i3(a, b) {
        super.i3(a, b);
        for (let c of fromEnum(this.series)) {
            c.visualSeriesLink.bi.br = b;
        }
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    fg() {
        if (this.series == null) {
            return -1;
        }
        return this.series.count;
    }
    ig(a) {
        for (let b = 0; b < this.pg.f.count; b++) {
            let c = this.pg.f._inner[b];
            if (!a(c)) {
                break;
            }
        }
    }
    get_isStacked() {
        return true;
    }
    get pc() {
        return this.pi ? this.pd : this.series;
    }
    pv(a, b) {
        for (let c of fromEnum(this.pd)) {
            if (this.pg != null && this.pg.c.contains(c)) {
                c.parentSeries = null;
                this.pg.c.remove(c);
            }
        }
    }
    p1(a, b) {
        for (let c of fromEnum(this.series)) {
            if (this.pg != null && this.pg.c.contains(c)) {
                c.parentSeries = null;
                this.pg.c.remove(c);
            }
        }
    }
    p0(a, b) {
        if (b.oldItems != null) {
            for (let c of fromEn(b.oldItems)) {
                if (this.pg != null && this.pg.c.contains(c)) {
                    c.parentSeries = null;
                    this.pg.c.remove(c);
                }
            }
        }
        if (b.newItems != null) {
            let d = b.newStartingIndex;
            for (let e of fromEn(b.newItems)) {
                if (this.pg != null && !this.pg.c.contains(e)) {
                    e.parentSeries = this;
                    e.c1();
                    e.dg();
                    e.dh();
                    e.dp();
                    e.di();
                    e.dj();
                    e.cx();
                    e.cy();
                    e.cz();
                    e.c0();
                    e.c2();
                    e.c3();
                    e.c4();
                    e.c5();
                    e.c9();
                    e.da();
                    e.c6();
                    e.c7();
                    e.c8();
                    e.c9();
                    e.db();
                    e.dc();
                    e.dd();
                    e.cw();
                    e.de();
                    e.df();
                    e.dk();
                    e.dl();
                    e.dm();
                    e.dn();
                    e.dq();
                    if (!this.pi) {
                        this.pg.c.insert(d, e);
                        d++;
                    }
                }
            }
        }
        if (!this.pi) {
            this.p2();
        }
    }
    js(a) {
        this.bq.b1.c2(a, true, false);
    }
    np(a) {
        if (a != null && a.n) {
            if (a.m) {
                return new StackedSeriesFramePreparer(1, typeCast(IIsCategoryBased_$type, this), typeCast(ISupportsMarkers_$type, a), a, this, a.cn);
            }
            else {
                let b = typeCast(CategorySeriesView.$, this.bh);
                return new StackedSeriesFramePreparer(1, this, typeCast(ISupportsMarkers_$type, b), this.bs.b1.m, this, b.cn);
            }
        }
        else {
            return this.no;
        }
    }
    oy(a, b) {
        a.u();
        this.py();
        this.np(b).d(a, b);
    }
    h3(a, b) {
        super.h3(a, b);
        for (let c of fromEnum(this.pc)) {
            if (c.visualSeriesLink != null) {
                c.visualSeriesLink.h3(a, c.visualSeriesLink.bi);
            }
        }
    }
    pw() {
        this.py();
    }
    p2() {
        let a = this.fetchXAxis();
        if (a != null) {
            a.co(true);
        }
        let b = this.fetchYAxis();
        if (b != null) {
            b.co(true);
        }
    }
    c9(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bs != null ? this.bs.n2 : Rect.empty;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.l2(this.bi);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            let g = this.fetchXAxis();
            if (g != null) {
                let h = new ScalerParams(0, e, e, g.ca, f);
                let i = g.dy(b, h);
                if (i < c.left + 0.1 * c.width) {
                    i = i + 0.4 * c.width;
                }
                if (i > c.right - 0.1 * c.width) {
                    i = i - 0.4 * c.width;
                }
                c.x = i - 0.5 * c.width;
            }
            let j = this.fetchYAxis();
            if (j != null && this.o8 != null && b < this.o8.length) {
                let k = new ScalerParams(0, e, e, j.ca, f);
                let l = j.dy(this.o8[b], k);
                let m = j.dy(this.o9[b], k);
                if (!isNaN_(l) && !isNaN_(m)) {
                    let n = Math.abs(m - l);
                    if (c.height < n) {
                        c.height = n;
                        c.y = Math.min(m, l);
                    }
                    else {
                        if (m < c.top + 0.1 * c.height) {
                            m = m + 0.4 * c.height;
                        }
                        if (m > c.bottom - 0.1 * c.height) {
                            m = m - 0.4 * c.height;
                        }
                        c.y = m - 0.5 * c.height;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    an(a) {
        if (this.o9 == null || this.o9.length == 0 || this.o8 == null || this.o8.length == 0) {
            return null;
        }
        if (a == this.fetchXAxis()) {
            let b = Math.min(this.o9.length, this.o8.length);
            return new AxisRange(0, b - 1);
        }
        if (a == this.fetchYAxis()) {
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    md() {
        return false;
    }
    h6(a, b, c, d) {
        this.py();
        this.oe();
        this.jl(false);
    }
    pb() {
        return this.ph;
    }
    pm() {
        let a = 0;
        let b = this.bi.bs;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        let e = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!b.isEmpty && !c.isEmpty && e != null) {
            let f = new ScalerParams(0, b, c, e.ca, d);
            a = e.dy(e.km, f);
        }
        return a;
    }
    pn() {
        let a = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (a != null) {
            return a.km;
        }
        return 0;
    }
    pr(a) {
        return this.fh < 0 || this.pc == null || this.pc.count == 0 ? -1 : this.fh + this.pc.indexOf(a);
    }
    pq(a) {
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        let e = typeCast(CategoryAxisBase.$, this.fetchXAxis());
        let f = -1;
        if (e != null && !b.isEmpty && !c.isEmpty) {
            let g = new ScalerParams(0, b, c, e.ca, d);
            let h = this.l0(this.bi);
            let i = e.d1(h.left, g);
            let j = e.d1(h.right, g);
            let k = (a.x - b.left) / b.width;
            let l = i + (k * (j - i));
            if (e.categoryMode != 0) {
                l -= 0.5;
            }
            let m = truncate(Math.round(l));
            f = m;
        }
        return f;
    }
    pk(a, b, c, d) {
        let e = true;
        let f = typeCast(CategoryAxisBase.$, this.fetchXAxis());
        let g = typeCast(NumericYAxis.$, this.fetchYAxis());
        if (!d.l() || c.isEmpty || b.isEmpty || f == null || f.itemsSource == null || g == null || this.bz == null || f.bh == null || g.bh == null || g.kc == g.kb) {
            e = false;
        }
        let h = d;
        let i = h.cn.d;
        if (a.valueColumn == null || a.valueColumn.count == 0 || i < 1 || a._visibility != 0) {
            e = false;
        }
        return e;
    }
    px() {
        if (this.bs == null || this.pg == null) {
            return;
        }
        if (!this.pi) {
            this.pd.clear();
            for (let a of fromEnum(this.series)) {
                if (!this.pg.c.contains(a)) {
                    this.pg.c.add(a);
                }
            }
            this.p2();
            return;
        }
    }
    o1(a, b) {
        super.o1(a, b);
        this.pg.h();
    }
    pz(a, b, c) {
    }
    py() {
        if (this.bz == null) {
            return;
        }
        let a = this.bz.count;
        this.o8 = new Array(a);
        this.o9 = new Array(a);
        for (let b = 0; b < a; b++) {
            this.o8[b] = 0;
            this.o9[b] = 0;
        }
        this.pp = Number.POSITIVE_INFINITY;
        this.po = Number.NEGATIVE_INFINITY;
        let c = 0;
        for (let d of fromEnum(this.pc)) {
            this.bz.deregisterColumn(d.p);
            d.p = this.bw(d.cq);
            if (d.visualSeriesLink != null) {
                d.visualSeriesLink.pj = true;
                d.visualSeriesLink.valueColumn = d.p;
                d.visualSeriesLink.pj = false;
            }
            d.y = true;
            if (d.p != null) {
                d.ac.clear();
                d.ad.clear();
                for (let e = 0; e < d.p.count; e++) {
                    let f = d.p.item(e);
                    if (f < c) {
                        d.ac.add(c);
                        d.ad.add(this.o9[e]);
                        this.o9[e] = this.o9[e] + f;
                        if (d.y) {
                            d.y = false;
                        }
                    }
                    else if (f >= c) {
                        d.ac.add(this.o8[e]);
                        d.ad.add(c);
                        this.o8[e] = this.o8[e] + f;
                    }
                    else if (isNaN_(f) || isInfinity(f)) {
                        d.ac.add(this.o8[e]);
                        d.ad.add(this.o9[e]);
                    }
                }
            }
        }
        for (let g = 0; g < a; g++) {
            this.pp = Math.min(this.pp, this.o9[g]);
            this.po = Math.max(this.po, this.o8[g]);
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.h7(this.fetchXAxis());
                    this.h7(this.fetchYAxis());
                }
                if (c == null && d != null) {
                    this.jc(this.fetchXAxis());
                    this.jc(this.fetchYAxis());
                }
                if (this.pc != null) {
                    for (let e of fromEnum(this.pc)) {
                        e.o = this.bs;
                    }
                    this.jl(false);
                }
                break;
            case "ItemsSource":
                if (this.pc != null) {
                    for (let f of fromEnum(this.pc)) {
                        if (f.visualSeriesLink != null) {
                            f.visualSeriesLink.itemsSource = d;
                        }
                    }
                }
                break;
            case "FastItemsSource":
                if (this.pi) {
                    this.px();
                }
                if (!this.oe()) {
                    this.ph.cn.g(this.eu);
                }
                this.jl(false);
                break;
            case StackedSeriesBase.$$p[0]:
                this.px();
                break;
            case StackedSeriesBase.$$p[1]:
                if (this.bs != null) {
                    this.bs.jn(this.pg.f);
                }
                break;
            case StackedSeriesBase.$$p[2]:
                for (let g of fromEnum(this.pc)) {
                    g.dq();
                }
                break;
            case "Brush":
                for (let h of fromEnum(this.pc)) {
                    h.cx();
                }
                break;
            case "DashArray":
                for (let i of fromEnum(this.pc)) {
                    i.cy();
                }
                break;
            case "DashCap":
                for (let j of fromEnum(this.pc)) {
                    j.cz();
                }
                break;
            case "IsDropShadowEnabled":
                for (let k of fromEnum(this.pc)) {
                    k.c1();
                }
                break;
            case "ShadowBlur":
                for (let l of fromEnum(this.pc)) {
                    l.dg();
                }
                break;
            case "ShadowColor":
                for (let m of fromEnum(this.pc)) {
                    m.dh();
                }
                break;
            case "UseSingleShadow":
                for (let n of fromEnum(this.pc)) {
                    n.dp();
                }
                break;
            case "ShadowOffsetX":
                for (let o of fromEnum(this.pc)) {
                    o.di();
                }
                break;
            case "ShadowOffsetY":
                for (let p of fromEnum(this.pc)) {
                    p.dj();
                }
                break;
            case "EndCap":
                for (let q of fromEnum(this.pc)) {
                    q.c0();
                }
                break;
            case "IsHitTestVisible":
                for (let r of fromEnum(this.pc)) {
                    r.c2();
                }
                break;
            case "LegendItemBadgeTemplate":
                for (let s of fromEnum(this.pc)) {
                    s.c3();
                }
                break;
            case "LegendItemTemplate":
                for (let t of fromEnum(this.pc)) {
                    t.c4();
                }
                break;
            case "LegendItemVisibility":
                for (let u of fromEnum(this.pc)) {
                    u.c5();
                }
                break;
            case "MarkerTemplate":
                for (let v of fromEnum(this.pc)) {
                    v.c9();
                }
                break;
            case "MarkerType":
                for (let w of fromEnum(this.pc)) {
                    w.da();
                }
                break;
            case "MarkerBrush":
                for (let x of fromEnum(this.pc)) {
                    x.c6();
                }
                break;
            case "MarkerOutline":
                for (let y of fromEnum(this.pc)) {
                    y.c7();
                }
                break;
            case "MarkerStyle":
                for (let z of fromEnum(this.pc)) {
                    z.c8();
                }
                break;
            case "Opacity":
                for (let aa of fromEnum(this.pc)) {
                    aa.db();
                }
                break;
            case "OpacityMask":
                for (let ab of fromEnum(this.pc)) {
                    ab.dc();
                }
                break;
            case "AreaFillOpacity":
                for (let ac of fromEnum(this.pc)) {
                    ac.cw();
                }
                break;
            case "Outline":
                for (let ad of fromEnum(this.pc)) {
                    ad.dd();
                }
                break;
            case "StartCap":
                for (let ae of fromEnum(this.pc)) {
                    ae.dk();
                }
                break;
            case "Thickness":
                for (let af of fromEnum(this.pc)) {
                    af.dl();
                }
                break;
            case "ToolTip":
                for (let ag of fromEnum(this.pc)) {
                    ag.dm();
                }
                break;
            case "UseLightweightMarkers":
                for (let ah of fromEnum(this.pc)) {
                    ah.dn();
                }
                break;
        }
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(typeCast(CategoryAxisBase.$, this.fetchXAxis()));
    }
    get scaler() {
        return typeCast(ICategoryScaler_$type, this.fetchXAxis());
    }
    get yScaler() {
        return typeCast(IScaler_$type, this.fetchYAxis());
    }
    get bucketizer() {
        return this.ns.cn;
    }
    get currentMode2Index() {
        return this.om();
    }
    provideCollisionDetector() {
        return new CollisionAvoider();
    }
    dc() {
        return false;
    }
    get_cq() {
        return false;
    }
    jn(a, b) {
        let c = this.dl;
        super.jn(a, b);
        if (!c) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        for (let d of fromEnum(this.series)) {
            d.visualSeriesLink.jn(a, b);
        }
        this.dl = false;
    }
    jk(a, b, c, d, e) {
        super.jk(a, b, c, d, e);
        let f = this.a0.a$h.item(d);
        f.cn.g(this.eu);
        f.ay(c);
        if (this.cc(f)) {
            return;
        }
        if (this.pa == null) {
            this.pa = new CategoryFrame(3);
        }
        this.pa.u();
        this.py();
        this.np(f).d(this.pa, f);
        this.o1(this.pa, f);
        for (let g of fromEnum(this.series)) {
            g.visualSeriesLink.jk(a, b, c, d, e);
        }
    }
    fo() {
        let a = this.a2.exportStackedVisualData(this, this.l8);
        for (let b of fromEnum(this.series)) {
            let c = this.a2.createFragmentVisualData(this, this.l8, getInstanceType(b).typeName, b.b8);
            b.visualSeriesLink.bi.ai(c);
            this.a2.addSubSeriesVisualData(a, c);
        }
        this.ic(a);
        this.bi.ai(a);
        return a;
    }
    get mayContainUnknowns() {
        return true;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedSeriesBase.$t = markType(StackedSeriesBase, 'StackedSeriesBase', CategorySeries.$, [IIsCategoryBased_$type]);
StackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, StackedSeriesBase, 'raisePropertyChanged', ['AutoGenerateSeries:pi:p3', [0, false], 'ReverseLegendOrder:pj:p4', [0, false], 'SeriesVisibility:p6:p5', [Visibility_$type, enumGetBox(Visibility_$type, 0)]]);
/**
 * @hidden
 */
class HorizontalStackedSeriesBase extends StackedSeriesBase {
    getOffsetValue() {
        return this.no.r(this.xAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.xAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    ag() {
        return [this.fetchXAxis(), this.fetchYAxis()];
    }
    oe() {
        return this.yAxis != null && this.yAxis.cn();
    }
    jv() {
        let a = (typeCast(XamDataChart.$, this.bs));
        if (a != null) {
            this.d6 = isNaN_(this.d7) ? a.oy.fh : this.d7;
            for (let b of fromEnum(this.pc)) {
                b.cw();
            }
        }
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case HorizontalStackedSeriesBase.$$p[0]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                    this.it();
                }
                break;
            case HorizontalStackedSeriesBase.$$p[1]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.oe();
                    this.jl(false);
                    this.it();
                }
                break;
        }
    }
    qa(a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    p9(a) {
        if (typeCast(CategoryXAxis.$, a) !== null || a.b7) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
HorizontalStackedSeriesBase.$t = markType(HorizontalStackedSeriesBase, 'HorizontalStackedSeriesBase', StackedSeriesBase.$);
HorizontalStackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, HorizontalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::qd', [CategoryAxisBase.$, null], 'YAxis::qe', [NumericYAxis.$, null]]);
/**
 * @hidden
 */
class StackedAreaSeries extends HorizontalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedAreaSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedAreaSeries.$t = markType(StackedAreaSeries, 'StackedAreaSeries', HorizontalStackedSeriesBase.$);
/**
 * @hidden
 */
class VerticalStackedSeriesBase extends StackedSeriesBase {
    nj() {
        return this.yAxis;
    }
    n3() {
        return this.xAxis;
    }
    getOffsetValue() {
        return this.no.r(this.yAxis, this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    getCategoryWidth() {
        return this.yAxis.getCategorySize(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    get_isVertical() {
        return true;
    }
    fetchXAxis() {
        return this.xAxis;
    }
    fetchYAxis() {
        return this.yAxis;
    }
    oe() {
        return this.xAxis != null && this.xAxis.cn();
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case VerticalStackedSeriesBase.$$p[0]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.jl(false);
                    this.it();
                }
                break;
            case VerticalStackedSeriesBase.$$p[1]:
                if (c != d) {
                    this.h7(typeCast(Axis.$, c));
                    this.jc(typeCast(Axis.$, d));
                    this.ns.cn.g(this.eu);
                    this.oe();
                    this.jl(false);
                    this.it();
                }
                break;
        }
    }
    qa(a) {
        if (typeCast(CategoryYAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    p9(a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
VerticalStackedSeriesBase.$t = markType(VerticalStackedSeriesBase, 'VerticalStackedSeriesBase', StackedSeriesBase.$);
VerticalStackedSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, VerticalStackedSeriesBase, 'raisePropertyChanged', ['XAxis::qd', [NumericXAxis.$, null], 'YAxis::qe', [CategoryYAxis.$, null]]);
/**
 * @hidden
 */
class StackedBarSeries extends VerticalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedBarSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    bf() {
        return new StackedBarSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qf = a;
    }
    getHostReferenceValue() {
        return this.eh();
    }
    pb() {
        return this.qf;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    om() {
        let a = 0;
        for (let b of fromEnum(this.bs.series)) {
            if (b == this) {
                return a;
            }
            let c = typeCast(IBarSeries_$type, b);
            if (c != null && c.yAxis == this.yAxis && c.getPreferredCategoryMode() == 2) {
                a++;
            }
        }
        return -1;
    }
    pm() {
        let a = 0;
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        let c = this.bi.br;
        if (!b.isEmpty && !c.isEmpty && this.xAxis != null) {
            let d = this.getEffectiveViewport1(this.bi);
            let e = new ScalerParams(0, b, c, this.xAxis.ca, d);
            a = this.xAxis.dy(this.xAxis.km, e);
        }
        return a;
    }
    pn() {
        if (this.xAxis != null) {
            return this.xAxis.km;
        }
        return 0;
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.yAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.xAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    c9(a) {
        let b = this.bz != null ? this.bz.indexOf(a) : -1;
        let c = this.bs != null ? this.bs.n2 : Rect.empty;
        c = c.copy();
        let d = this.bi.br;
        let e = new Rect(0, 0, 0, 1, 1);
        let f = this.l2(this.bi);
        let g = new ScalerParams(0, e, e, this.xAxis.ca, f);
        let h = new ScalerParams(0, e, e, this.yAxis.ca, f);
        if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
            if (this.yAxis != null) {
                let i = this.yAxis.dy(b, h);
                if (i < c.top + 0.1 * c.height) {
                    i = i + 0.4 * c.height;
                }
                if (i > c.bottom - 0.1 * c.height) {
                    i = i - 0.4 * c.height;
                }
                c.y = i - 0.5 * c.height;
            }
            if (this.xAxis != null && this.o8 != null && b < this.o8.length) {
                let j = this.xAxis.dy(this.o8[b], g);
                let k = this.xAxis.dy(this.o9[b], g);
                if (!isNaN_(j) && !isNaN_(k)) {
                    let l = Math.abs(k - j);
                    if (c.width < l) {
                        c.width = l;
                        c.x = Math.min(k, j);
                    }
                    else {
                        if (k < c.left + 0.1 * c.width) {
                            k = k + 0.4 * c.width;
                        }
                        if (k > c.right - 0.1 * c.width) {
                            k = k - 0.4 * c.width;
                        }
                        c.x = k - 0.5 * c.width;
                    }
                }
            }
            this.bn.ap(this.bs, c, true);
        }
        return b >= 0;
    }
    dw(a, b, c) {
        let d = true;
        let e = c;
        if (!c.l() || b.isEmpty || a.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.bz == null || this.xAxis.bh == null || this.yAxis.bh == null || this.xAxis.kc == this.xAxis.kb) {
            e.cn.d = 0;
            d = false;
        }
        return d;
    }
    h6(a, b, c, d) {
        switch (a) {
            case 4:
            case 1:
            case 0:
                this.ns.cn.g(this.eu);
                break;
        }
        switch (a) {
            case 4:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 1:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 0:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
            case 2:
                if (this.ns.cn.d > 0) {
                    this.jl(true);
                }
                break;
            case 3:
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.jl(true);
                }
                break;
        }
    }
    e8(a) {
        let b = this.bs != null ? this.bs.n2 : Rect.empty;
        let c = this.bi.br;
        let d = this.getEffectiveViewport1(this.bi);
        let e = -1;
        if (this.yAxis != null && !b.isEmpty && !c.isEmpty) {
            let f = new ScalerParams(0, b, c, this.yAxis.ca, d);
            let g = this.l0(this.bi);
            let h = this.yAxis.d1(g.top, f);
            let i = this.yAxis.d1(g.bottom, f);
            let j = (a.y - b.top) / b.height;
            let k = h + (j * (i - h));
            if (this.yAxis.categoryMode != 0) {
                k -= 0.5;
            }
            let l = truncate(Math.round(k));
            e = l;
        }
        return e;
    }
    fp(a) {
        let b = this.e8(a);
        return b >= 0 && this.bz != null && b < this.bz.count ? this.bz.item(b) : null;
    }
    p2() {
        if (this.xAxis != null) {
            this.xAxis.co(true);
        }
        if (this.yAxis != null) {
            this.yAxis.co(true);
        }
    }
    pq(a) {
        return this.e8(a);
    }
    pk(a, b, c, d) {
        let e = true;
        if (!d.l() || c.isEmpty || b.isEmpty || this.yAxis == null || this.yAxis.itemsSource == null || this.xAxis == null || this.bz == null || this.xAxis.bh == null || this.yAxis.bh == null) {
            e = false;
        }
        let f = d;
        if (a.valueColumn == null || a.valueColumn.count == 0 || f.cn.d < 1) {
            e = false;
        }
        return e;
    }
    eg() {
        return this.yAxis.jz(this.bi.bs, this.bi.br, this.getEffectiveViewport1(this.bi));
    }
    pz(a, b, c) {
        let d = typeCast(BarFragment.$, a);
        let e = typeCast(ColumnFragmentView.$, c);
        if (!this.dw(c.br, c.bs, c) || d == null || e == null) {
            return;
        }
        let f = this.yAxis.jz(c.bs, c.br, this.getEffectiveViewport1(c));
        if (isNaN_(f) || isInfinity(f)) {
            d.q3.c7.count = 0;
            return;
        }
        let g = 0;
        for (let h of fromEnum(b.f)) {
            if (isInfinity(h[0]) || isNaN_(h[0]) || isInfinity(h[1]) || isInfinity(h[2]) || isNaN_(h[1]) || isNaN_(h[2])) {
                continue;
            }
            let i = h[0] - 0.5 * f;
            let j = h[1];
            let k = h[2];
            k = Math.max(k, -100);
            j = Math.min(j, c.br.right + 100);
            let l = e.c7.item(g);
            l.height = f;
            l.width = Math.abs(j - k);
            e.de(l, Math.min(j, k), i);
            g++;
        }
        e.c7.count = g;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case StackedBarSeries.$$p[0]:
            case StackedBarSeries.$$p[1]:
                for (let e of fromEnum(this.pc)) {
                    e.de();
                    e.df();
                }
                this.jl(false);
                break;
            case "SyncLink":
                if (this.xAxis != null) {
                    this.xAxis.cn();
                }
                break;
            case "FastItemsSource":
                if (this.xAxis != null && !this.xAxis.cn()) {
                    this.qf.cn.g(this.eu);
                }
                this.jl(false);
                break;
            case "SeriesViewer":
                if (c != null && d == null) {
                    this.h7(this.xAxis);
                    this.h7(this.yAxis);
                }
                if (c == null && d != null) {
                    this.jc(this.xAxis);
                    this.jc(this.yAxis);
                }
                this.qf.cn.g(this.eu);
                this.jl(false);
                if (this.xAxis != null) {
                    this.xAxis.cn();
                }
                break;
        }
    }
    getPreferredCategoryMode() {
        return this.preferredCategoryMode(this.yAxis);
    }
    get currentCategoryMode() {
        return this.preferredCategoryMode(this.yAxis);
    }
    get scaler() {
        return this.yAxis;
    }
    get yScaler() {
        return this.xAxis;
    }
    get mayContainUnknowns() {
        return true;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedBarSeries.$t = markType(StackedBarSeries, 'StackedBarSeries', VerticalStackedSeriesBase.$, [IIsCategoryBased_$type, IBarSeries_$type]);
StackedBarSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedBarSeries, 'raisePropertyChanged', ['RadiusX:qg:qk', [1, 2], 'RadiusY:qh:ql', [1, 2]]);
/**
 * @hidden
 */
class StackedColumnSeries extends HorizontalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedColumnSeries.$;
    }
    bf() {
        return new StackedColumnSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qf = a;
    }
    pb() {
        return this.qf;
    }
    preferredCategoryMode(a) {
        return 2;
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    eg() {
        let a = this.getEffectiveViewport1(this.bi);
        return this.xAxis.jz(this.bi.bs, this.bi.br, a);
    }
    pz(a, b, c) {
        let d = typeCast(ColumnFragment.$, a);
        let e = typeCast(ColumnFragmentView.$, c);
        if (!this.dw(c.br, c.bs, c) || d == null || e == null) {
            return;
        }
        if (d == null) {
            return;
        }
        let f = this.getEffectiveViewport1(c);
        let g = this.xAxis.jz(c.bs, c.br, f);
        if (isNaN_(g) || isInfinity(g)) {
            d.q3.c7.count = 0;
            return;
        }
        let h = 0;
        for (let i of fromEnum(b.f)) {
            if (isInfinity(i[0]) || isNaN_(i[0]) || isInfinity(i[1]) || isInfinity(i[2]) || isNaN_(i[1]) || isNaN_(i[2])) {
                continue;
            }
            let j = i[0] - 0.5 * g;
            let k = i[1];
            let l = i[2];
            k = Math.max(k, -100);
            l = Math.min(l, c.br.bottom + 100);
            let m = e.c7.item(h);
            m.width = g;
            m.height = Math.abs(l - k);
            e.de(m, j, Math.min(l, k));
            h++;
        }
        e.c7.count = h;
    }
    i7(a, b, c, d) {
        super.i7(a, b, c, d);
        switch (b) {
            case StackedColumnSeries.$$p[0]:
            case StackedColumnSeries.$$p[1]:
                for (let e of fromEnum(this.pc)) {
                    e.de();
                    e.df();
                }
                this.jl(false);
                break;
            case "SyncLink":
                if (this.yAxis != null) {
                    this.yAxis.cn();
                }
                break;
            case "SeriesViewer":
                if (this.yAxis != null) {
                    this.yAxis.cn();
                }
                break;
        }
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedColumnSeries.$t = markType(StackedColumnSeries, 'StackedColumnSeries', HorizontalStackedSeriesBase.$);
StackedColumnSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedColumnSeries, 'raisePropertyChanged', ['RadiusX:qg:qk', [1, 2], 'RadiusY:qh:ql', [1, 2]]);
/**
 * @hidden
 */
class StackedLineSeries extends HorizontalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedLineSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedLineSeries.$t = markType(StackedLineSeries, 'StackedLineSeries', HorizontalStackedSeriesBase.$);
/**
 * @hidden
 */
class StackedSplineAreaSeries extends HorizontalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedSplineAreaSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedSplineAreaSeries.$t = markType(StackedSplineAreaSeries, 'StackedSplineAreaSeries', HorizontalStackedSeriesBase.$);
/**
 * @hidden
 */
class StackedSplineSeries extends HorizontalStackedSeriesBase {
    constructor() {
        super();
        this.ab = StackedSplineSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    an(a) {
        if (this.itemsSource == null) {
            return null;
        }
        if (a == this.xAxis) {
            return new AxisRange(0, this.bz.count - 1);
        }
        if (a == this.yAxis) {
            this.py();
            return new AxisRange(this.pp, this.po);
        }
        return null;
    }
    preferredCategoryMode(a) {
        return 0;
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
StackedSplineSeries.$t = markType(StackedSplineSeries, 'StackedSplineSeries', HorizontalStackedSeriesBase.$);
/**
 * @hidden
 */
class StackedFragmentSeries extends DependencyObject {
    constructor() {
        super();
        this.q = false;
        this.r = false;
        this._parentSeries = null;
        this.av = 0;
        this.o = null;
        this.p = null;
        this._visualSeriesLink = null;
        this.ac = null;
        this.ad = null;
        this.ab = null;
        this.y = false;
        this.au = null;
        this.propertyChanged = null;
        this.propertyUpdated = null;
        this.ac = new List$1(Number_$type, 0);
        this.ad = new List$1(Number_$type, 0);
        this.ab = new List$1(Array_$type, 0);
        this.propertyUpdated = delegateCombine(this.propertyUpdated, (a, b) => this.ct(a, b.propertyName, b.oldValue, b.newValue));
    }
    get parentSeries() {
        return this._parentSeries;
    }
    set parentSeries(a) {
        this._parentSeries = a;
    }
    get visualSeriesLink() {
        return this._visualSeriesLink;
    }
    set visualSeriesLink(a) {
        this._visualSeriesLink = a;
    }
    provideRenderer(a) {
        this.au = a;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.provideRenderer(a);
        }
    }
    dq() {
        if (this.parentSeries == null) {
            return;
        }
        this.gd = this.parentSeries._visibility != 0 ? 1 : this.gf;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink._visibility = this.gd;
        }
    }
    c9() {
        if (this.parentSeries == null) {
            return;
        }
        this.dt = this.dw != null ? this.dw : this.parentSeries.mw;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.mw = this.dt;
        }
    }
    da() {
        if (this.parentSeries == null) {
            return;
        }
        let a = this.l == 0 ? 1 : this.l;
        this.k = this.l == 0 ? this.parentSeries.mb : a;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.mb = this.k;
        }
    }
    cx() {
        if (this.parentSeries == null) {
            return;
        }
        this.fz = this.fu != null ? this.fu : this.parentSeries.ld;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ld = this.fz;
        }
    }
    cy() {
        if (this.parentSeries == null) {
            return;
        }
        this.f2 = this.f3 != null ? this.f3 : this.parentSeries.ll;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ll = this.f2;
        }
    }
    cz() {
        if (this.parentSeries == null) {
            return;
        }
        this.f4 = this.f7;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.lm = this.f4;
        }
    }
    c1() {
        if (this.parentSeries == null) {
            return;
        }
        if (!this.q) {
            this.s = this.parentSeries.cp;
        }
        else {
            this.s = this.w;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.cp = this.s;
        }
    }
    dg() {
        if (this.parentSeries == null) {
            return;
        }
        this.ai = !isNaN_(this.aq) ? this.aq : this.parentSeries.ev;
        if (this.visualSeriesLink != null && !isNaN_(this.ai)) {
            this.visualSeriesLink.ev = this.ai;
        }
    }
    dh() {
        if (this.parentSeries == null) {
            return;
        }
        this.f0 = Color.e(toNullable(Color.$, this.f1), toNullable(Color.$, null)) ? this.f1 : this.parentSeries.lk;
        if (this.visualSeriesLink != null && Color.e(toNullable(Color.$, this.f0), toNullable(Color.$, null))) {
            this.visualSeriesLink.lk = this.f0;
        }
    }
    dp() {
        if (this.parentSeries == null) {
            return;
        }
        if (!this.r) {
            this.v = this.parentSeries.du;
        }
        else {
            this.v = this.aa;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.du = this.v;
        }
    }
    di() {
        if (this.parentSeries == null) {
            return;
        }
        this.aj = !isNaN_(this.ar) ? this.ar : this.parentSeries.ew;
        if (this.visualSeriesLink != null && !isNaN_(this.aj)) {
            this.visualSeriesLink.ew = this.aj;
        }
    }
    dj() {
        if (this.parentSeries == null) {
            return;
        }
        this.ak = !isNaN_(this.as) ? this.as : this.parentSeries.ex;
        if (this.visualSeriesLink != null && !isNaN_(this.ak)) {
            this.visualSeriesLink.ex = this.ak;
        }
    }
    c0() {
        if (this.parentSeries == null) {
            return;
        }
        this.f5 = this.f8;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ln = this.f5;
        }
    }
    c2() {
        if (this.parentSeries == null) {
            return;
        }
        this.t = this.x;
    }
    c3() {
        if (this.parentSeries == null) {
            return;
        }
        this.dr = this.du != null ? this.du : this.parentSeries.legendItemBadgeTemplate;
        if (this.visualSeriesLink != null) {
            if (this.dr != null) {
                this.visualSeriesLink.legendItemBadgeTemplate = this.dr;
            }
            else {
                this.visualSeriesLink.legendItemBadgeTemplate = null;
            }
        }
    }
    c4() {
        if (this.parentSeries == null) {
            return;
        }
        this.ds = this.dv != null ? this.dv : this.parentSeries.legendItemTemplate;
        if (this.visualSeriesLink != null) {
            if (this.ds != null) {
                this.visualSeriesLink.legendItemTemplate = this.ds;
            }
            else {
                this.visualSeriesLink.legendItemTemplate = null;
            }
        }
    }
    c5() {
        if (this.parentSeries == null) {
            return;
        }
        this.gc = this.parentSeries.l9 != 0 ? 1 : this.ge;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.l9 = this.gc;
        }
    }
    c6() {
        if (this.parentSeries == null) {
            return;
        }
        this.fq = this.fv != null ? this.fv : this.parentSeries.na;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.na = this.fq;
        }
    }
    c7() {
        if (this.parentSeries == null) {
            return;
        }
        this.fr = this.fw != null ? this.fw : this.parentSeries.nb;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.nb = this.fr;
        }
    }
    c8() {
        if (this.parentSeries == null) {
            return;
        }
        this.ga = this.gb != null ? this.gb : this.parentSeries.nc;
        if (this.visualSeriesLink != null) {
            if (this.ga != null) {
                this.visualSeriesLink.nc = this.ga;
            }
            else {
                this.visualSeriesLink.nc = null;
            }
        }
    }
    db() {
        if (this.parentSeries == null) {
            return;
        }
        this.af = !isNaN_(this.an) ? this.an : this.parentSeries._opacity;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink._opacity = this.af;
        }
    }
    dc() {
    }
    dd() {
        if (this.parentSeries == null) {
            return;
        }
        this.ft = this.fy != null ? this.fy : this.parentSeries.li;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.li = this.ft;
        }
    }
    cw() {
        if (this.parentSeries == null) {
            return;
        }
        let a = NaN;
        if (typeCast(StackedAreaSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.d6;
        }
        if (typeCast(StackedSplineAreaSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.d6;
        }
        this.ae = !isNaN_(this.am) ? this.am : a;
        if (this.visualSeriesLink != null) {
            if (typeCast(AreaFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.d7 = this.ae;
            }
            if (typeCast(SplineAreaFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.d7 = this.ae;
            }
        }
    }
    de() {
        if (this.parentSeries == null) {
            return;
        }
        let a = NaN;
        if (typeCast(StackedColumnSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.qg;
        }
        if (typeCast(StackedBarSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.qg;
        }
        this.ag = !isNaN_(a) ? a : this.ao;
        if (this.visualSeriesLink != null) {
            if (typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.q6 = this.ag;
            }
            if (typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.q6 = this.ag;
            }
        }
    }
    df() {
        if (this.parentSeries == null) {
            return;
        }
        let a = NaN;
        if (typeCast(StackedColumnSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.qh;
        }
        if (typeCast(StackedBarSeries.$, this.parentSeries) !== null) {
            a = this.parentSeries.qh;
        }
        this.ah = !isNaN_(a) ? a : this.ap;
        if (this.visualSeriesLink != null) {
            if (typeCast(ColumnFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.q7 = this.ah;
            }
            if (typeCast(BarFragment.$, this.visualSeriesLink) !== null) {
                this.visualSeriesLink.q7 = this.ah;
            }
        }
    }
    dk() {
        if (this.parentSeries == null) {
            return;
        }
        this.f6 = this.f9;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.lo = this.f6;
        }
    }
    dl() {
        if (this.parentSeries == null) {
            return;
        }
        this.al = !isNaN_(this.at) ? this.at : this.parentSeries.ey;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.ey = this.al;
        }
    }
    dm() {
        if (this.parentSeries == null) {
            return;
        }
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.toolTip = this.ay;
        }
    }
    dn() {
        if (this.parentSeries == null) {
            return;
        }
        this.u = this.z;
        if (this.visualSeriesLink != null) {
            this.visualSeriesLink.mf = this.u;
        }
    }
    cv(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        if (this.propertyUpdated != null) {
            this.propertyUpdated(this, new PropertyUpdatedEventArgs(a, b, c));
        }
    }
    ct(a, b, c, d) {
        if (this.parentSeries == null) {
            return;
        }
        switch (b) {
            case StackedFragmentSeries.$$p[58]:
                if (this.parentSeries == null || this.visualSeriesLink == null) {
                    return;
                }
                this.visualSeriesLink.fx = d;
                break;
            case StackedFragmentSeries.$$p[63]:
                this.dq();
                break;
            case StackedFragmentSeries.$$p[31]:
                this.cx();
                break;
            case StackedFragmentSeries.$$p[32]:
                this.cy();
                break;
            case StackedFragmentSeries.$$p[33]:
                this.cz();
                break;
            case StackedFragmentSeries.$$p[35]:
                this.q = true;
                this.c1();
                break;
            case StackedFragmentSeries.$$p[52]:
                this.dg();
                break;
            case StackedFragmentSeries.$$p[53]:
                this.dh();
                break;
            case StackedFragmentSeries.$$p[61]:
                this.q = true;
                this.dp();
                break;
            case StackedFragmentSeries.$$p[54]:
                this.di();
                break;
            case StackedFragmentSeries.$$p[55]:
                this.dj();
                break;
            case StackedFragmentSeries.$$p[34]:
                this.c0();
                break;
            case StackedFragmentSeries.$$p[36]:
                this.c2();
                break;
            case StackedFragmentSeries.$$p[43]:
                this.c9();
                break;
            case StackedFragmentSeries.$$p[44]:
                this.da();
                break;
            case StackedFragmentSeries.$$p[37]:
                this.c3();
                break;
            case StackedFragmentSeries.$$p[38]:
                this.c4();
                break;
            case StackedFragmentSeries.$$p[39]:
                this.c5();
                break;
            case StackedFragmentSeries.$$p[40]:
                this.c6();
                break;
            case StackedFragmentSeries.$$p[41]:
                this.c7();
                break;
            case StackedFragmentSeries.$$p[42]:
                this.c8();
                break;
            case StackedFragmentSeries.$$p[47]:
                this.db();
                break;
            case StackedFragmentSeries.$$p[46]:
                this.dc();
                break;
            case StackedFragmentSeries.$$p[48]:
                this.dd();
                break;
            case StackedFragmentSeries.$$p[30]:
                this.cw();
                break;
            case StackedFragmentSeries.$$p[50]:
                this.de();
                break;
            case StackedFragmentSeries.$$p[51]:
                this.df();
                break;
            case StackedFragmentSeries.$$p[56]:
                this.dk();
                break;
            case StackedFragmentSeries.$$p[57]:
                this.dl();
                break;
            case StackedFragmentSeries.$$p[59]:
                this.dm();
                break;
            case StackedFragmentSeries.$$p[60]:
                this.dn();
                break;
        }
        this.parentSeries.jl(false);
    }
}
StackedFragmentSeries.$t = markType(StackedFragmentSeries, 'StackedFragmentSeries', DependencyObject.$, [INotifyPropertyChanged_$type]);
StackedFragmentSeries.$$p = markDep(DependencyProperty, PropertyMetadata, StackedFragmentSeries, 'cv', ['ActualAreaFillOpacity:ae:dx', [1, 1], 'ActualBrush:fp:dy', [Brush.$], 'ActualDashArray:f2:dz', [DoubleCollection.$], 'ActualDashCap:f4:d0', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'ActualEndCap:f5:d1', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'ActualIsDropShadowEnabled:s:d2', [0, false], 'ActualIsHitTestVisible:t:d3', [0, true], 'ActualLegendItemBadgeTemplate:dr:d4', [DataTemplate.$], 'ActualLegendItemTemplate:ds:d5', [DataTemplate.$], 'ActualLegendItemVisibility:gc:d6', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'ActualMarkerBrush:fq:d7', [Brush.$], 'ActualMarkerOutline:fr:d8', [Brush.$], 'ActualMarkerStyle:ga:d9', [Style.$], 'ActualMarkerTemplate:dt:ea', [DataTemplate.$], 'ActualMarkerType:k:eb', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ActualOpacityMask:fs:ec', [Brush.$], 'ActualOpacity:af:ed', [1, 1], 'ActualOutline:ft:ee', [Brush.$], 'ActualRadiusX:ag:ef', [1, 0], 'ActualRadiusY:ah:eg', [1, 0], 'ActualShadowBlur:ai:eh', [1, NaN], 'ActualShadowColor:f0:ei', [Color.$], 'ActualShadowOffsetX:aj:ej', [1, NaN], 'ActualShadowOffsetY:ak:ek', [1, NaN], 'ActualStartCap:f6:el', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'ActualThickness:al:em', [1, 1], 'ActualToolTip:aw:en', [4], 'ActualUseLightweightMarkers:u:eo', [0, false], 'ActualUseSingleShadow:v:ep', [0, true], 'ActualVisibility:gd:eq', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'AreaFillOpacity:am:er', [1, NaN], 'Brush:fu:es', [Brush.$], 'DashArray:f3:et', [DoubleCollection.$], 'DashCap:f7:eu', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 0)], 'EndCap:f8:ev', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'IsDropShadowEnabled:w:ew', [0], 'IsHitTestVisible:x:ex', [0, true], 'LegendItemBadgeTemplate:du:ey', [DataTemplate.$, null], 'LegendItemTemplate:dv:ez', [DataTemplate.$, null], 'LegendItemVisibility:ge:e0', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'MarkerBrush:fv:e1', [Brush.$], 'MarkerOutline:fw:e2', [Brush.$], 'MarkerStyle:gb:e3', [Style.$], 'MarkerTemplate:dw:e4', [DataTemplate.$, null], 'MarkerType:l:e5', [MarkerType_$type, enumGetBox(MarkerType_$type, 0)], 'Name:b8:e6', [2], 'OpacityMask:fx:e7', [Brush.$], 'Opacity:an:e8', [1, 1], 'Outline:fy:e9', [Brush.$, null], 'ParentOrLocalBrush:fz:fa', [Brush.$], 'RadiusX:ao:fb', [1, 2], 'RadiusY:ap:fc', [1, 2], 'ShadowBlur:aq:fd', [1, NaN], 'ShadowColor:f1:fe', [Color.$], 'ShadowOffsetX:ar:ff', [1, NaN], 'ShadowOffsetY:as:fg', [1, NaN], 'StartCap:f9:fh', [PenLineCap_$type, enumGetBox(PenLineCap_$type, 2)], 'Thickness:at:fi', [1, 1.5], 'Title:ax:fj', [4, "Series Title"], 'ToolTip:ay:fk', [4, null], 'UseLightweightMarkers:z:fl', [0, false], 'UseSingleShadow:aa:fm', [0], 'ValueMemberPath:cq:fn', [2, null], 'Visibility:gf:fo', [Visibility_$type, enumGetBox(Visibility_$type, 0)]]);
/**
 * @hidden
 */
class StackedSeriesCollection extends ObservableCollection$1 {
    constructor() {
        super(StackedFragmentSeries.$, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
StackedSeriesCollection.$t = markType(StackedSeriesCollection, 'StackedSeriesCollection', ObservableCollection$1.$.specialize(StackedFragmentSeries.$));
/**
 * @hidden
 */
class StackedSeriesFramePreparer extends CategoryFramePreparer {
    constructor(a, ..._rest) {
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    let c = _rest[0];
                    super(0, c);
                }
                break;
            case 1:
                {
                    let c = _rest[0];
                    let d = _rest[1];
                    let e = _rest[2];
                    let f = _rest[3];
                    let g = _rest[4];
                    super(1, c, d, e, f, g);
                }
                break;
        }
    }
    j(a) {
        let b = new SingleValuesHolder();
        if (typeCast(StackedColumnSeries.$, this.h) !== null || typeCast(StackedBarSeries.$, this.h) !== null) {
            let c = typeCast(StackedSeriesBase.$, this.h);
            if (c.pc.count > 0) {
                b.f = c.pc._inner[0].p;
            }
            return b;
        }
        let d = this.ab.valueColumn;
        b.f = d;
        return b;
    }
    t(a, b, c, d, e) {
        let f = 0;
        let g = false;
        let h;
        let i = a.d != null;
        let j = this.h.provideCollisionDetector();
        let k = a.f;
        let l = a.k;
        let m = this.h.mayContainUnknowns;
        let n = new ScalerParams(0, a.m, a.l, a.b.j$a, l);
        let o = new ScalerParams(0, a.m, a.l, a.c.j$a, l);
        o.b = this.h.getHostReferenceValue();
        let p = (a.b.j$c(2, n) - a.b.j$c(1, n));
        let q = a.m;
        let r = a.l;
        let s = typeCast(NumericAxisBase.$, a.c) !== null && a.c.j2;
        for (let t = a.i; t <= a.j; ++t) {
            let u;
            if (a.d == null) {
                if (!m) {
                    u = this.g.getBucketWithoutUnknowns(t);
                }
                else {
                    u = this.g.getBucket(t);
                }
            }
            else {
                u = ((() => { let v = this.f(a, t, b, p, g, h, c); t = v.p1; g = v.p4; h = v.p5; return v.ret; })());
            }
            let v = !s || (s && u[1] > 0);
            let w = u[0];
            if (!isNaN_(u[0])) {
                this.x(a, u, c, i, n, o);
                a.a.f.add(u);
                let x = t * a.h;
                let y = x;
                if (a.d != null && a.d.i$b != null && x >= 0 && x < a.d.i$b.count) {
                    x = a.d.i$b._inner[x];
                }
                let z = u;
                if (k && x < b.e) {
                    z = new Array(u.length);
                    z[0] = w;
                    this.z(b, x, true, a.e);
                    z[1] = b.c;
                    z[2] = b.d;
                    this.x(a, z, c, i, n, o);
                }
                if (d && v && this.l(a.a, z, j, Math.min(x, b.e - 1), f, a.a.f.count - 1)) {
                    ++f;
                }
            }
        }
        return f;
    }
    l(a, b, c, d, e, f) {
        let g = b[0];
        let h = b[1];
        if (typeCast(IBarSeries_$type, this.c) !== null) {
            h = b[0];
            g = b[1];
        }
        let i = new Rect(0, g - 5, h - 5, 11, 11);
        if (!isNaN_(g) && !isNaN_(h) && !isInfinity(g) && !isInfinity(h) && c.tryAdd(i)) {
            a.m.add({ $type: Point_$type, x: g, y: h });
            this.c.updateMarkerTemplate(e, d, f);
            return true;
        }
        return false;
    }
}
StackedSeriesFramePreparer.$t = markType(StackedSeriesFramePreparer, 'StackedSeriesFramePreparer', CategoryFramePreparer.$);
/**
 * @hidden
 */
class AreaFragmentView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c8 = new Path();
        this.da = new Path();
        this.c9 = new Path();
        this.db = new Path();
        this.c6 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    c7() {
        this.c8.ak = null;
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
    }
    co() {
        return new AreaFragmentBucketCalculator(this);
    }
    a8() {
        super.a8();
        this.c8._fill = this.e.lb;
        this.c9._fill = this.e.lb;
        this.c8._opacity = this.e.d6;
        this.c9._opacity = 0.5 * this.e.d6;
        this.da._stroke = this.e.lc;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.ll;
        this.da.ad = this.e.lm;
        this.db._stroke = this.e.lc;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.ll;
        this.db.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c8._fill = a;
        this.c9._fill = a;
        this.c8._opacity = 1;
        this.c9._opacity = 1;
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        a.s(this.c8);
        a.s(this.c9);
        a.s(this.da);
        a.s(this.db);
    }
    get_index() {
        let a = this.c6.parentSeries;
        let b = a.series.count;
        let c = a.series.indexOf(this.c6.logicalSeriesLink);
        let d = (b - 1) - c;
        let e = a.bi.index;
        return e + d;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.da, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.db, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.c9, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.c8, "fillShape", ["Fill"]);
    }
}
AreaFragmentView.$t = markType(AreaFragmentView, 'AreaFragmentView', AnchoredCategorySeriesView.$);
/**
 * @hidden
 */
class ColumnFragmentView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.da = null;
        this.c7 = null;
        this.c8 = null;
        this.c9 = null;
        this.c6 = a;
        this.c8 = new List$1(Number_$type, 0);
        this.c9 = new List$1(Number_$type, 0);
        this.c7 = ((() => {
            let $ret = new Pool$1(Rectangle.$);
            $ret.create = runOn(this, this.df);
            $ret.activate = runOn(this, this.db);
            $ret.disactivate = runOn(this, this.dd);
            $ret.destroy = runOn(this, this.dc);
            return $ret;
        })());
        this.da = new List$1(Rectangle.$, 0);
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    df() {
        let a = ((() => {
            let $ret = new Rectangle();
            $ret.dataContext = ((() => {
                let $ret = new DataContext();
                $ret.series = this.e;
                return $ret;
            })());
            return $ret;
        })());
        this.da.add(a);
        a._visibility = 1;
        return a;
    }
    db(a) {
        a._visibility = 0;
    }
    dd(a) {
        a._visibility = 1;
    }
    dc(a) {
        this.da.remove(a);
    }
    bb(a, b) {
        super.bb(a, b);
        let c = a;
        c._fill = this.e.lb;
        c._stroke = this.e.lc;
        c.ac = this.e.ey;
        c.ai = this.e.ll;
        c.ad = this.e.lm;
        c.am = this.c6.q6;
        c.an = this.c6.q7;
    }
    de(a, b, c) {
        let d = false;
        if (a.o != c) {
            d = true;
            a.o = c;
        }
        if (a.n != b) {
            d = true;
            a.n = b;
        }
        if (d) {
            this.an();
        }
    }
    bc(a, b) {
        super.bc(a, b);
        let c = a;
        let d = this.bm(b);
        c._fill = d;
        c._stroke = d;
        c.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            for (let c = 0; c < this.da.count; c++) {
                let d = this.da._inner[c];
                this.ba(d, c, b);
                a.v(d);
            }
        }
    }
    get_index() {
        let a = this.c6.parentSeries;
        let b = a.series.count;
        let c = a.series.indexOf(this.c6.logicalSeriesLink);
        let d = (b - 1) - c;
        let e = a.bi.index;
        return e + d;
    }
    ai(a) {
        super.ai(a);
        let b = 0;
        let c = new List$1(Rectangle.$, 0);
        for (let d of fromEnum(this.c7.a)) {
            c.add(d);
        }
        c.aa((e, f) => {
            if (e.n < f.n) {
                return -1;
            }
            else if (e.n > f.n) {
                return 1;
            }
            else {
                return 0;
            }
        });
        for (let e of fromEnum(c)) {
            this.e.a2.exportRectangleData(a, e, "column" + b, ["Main", "Fill"]);
        }
        b++;
    }
    getDefaultTooltipTemplate() {
        let a = "<div class='ui-chart-default-tooltip-content'>";
        let b = null;
        if (this.c6.nj().b4) {
            b = this.c6.fragmentXAxis;
        }
        else if (this.c6.fragmentYAxis.b4) {
            b = this.c6.fragmentYAxis;
        }
        if (b.b7) {
            let c = b;
            a += "<span>${item." + c.dateTimeMemberPath + "}</span><br/>";
        }
        if (b != null && b.e9 != null) {
            a += "<span>${item." + b.e9 + "}</span><br/>";
        }
        a += "<span";
        let d = this.e.a0.a$q(this.e);
        if (!stringIsNullOrEmpty(d)) {
            a += " style='color:" + d + "'";
        }
        a += ">" + this.c6.fx + ": </span><span class='ui-priority-primary'>" + "${item." + this.c6.pq + "}</span></div>";
        return a;
    }
}
ColumnFragmentView.$t = markType(ColumnFragmentView, 'ColumnFragmentView', AnchoredCategorySeriesView.$);
/**
 * @hidden
 */
class LineFragmentView extends AnchoredCategorySeriesView {
    constructor(a) {
        super(a);
        this.c6 = null;
        this.c9 = new Path();
        this.c8 = new Path();
        this.da = new Path();
        this.c6 = a;
    }
    c7() {
        this.c8.ak = null;
        this.c9.ak = null;
        this.da.ak = null;
    }
    co() {
        return new LineFragmentBucketCalculator(this);
    }
    a8() {
        super.a8();
        this.c9._stroke = this.e.lb;
        this.c9.ac = this.e.ey;
        this.c9.ai = this.e.ll;
        this.c9.ad = this.e.lm;
        this.da._stroke = this.e.lb;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.ll;
        this.da.ad = this.e.lm;
        this.c8._fill = this.e.lb;
        this.c8._opacity = 0.75;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c9._stroke = a;
        this.c9.ac = this.e.ey + 3;
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.c8._fill = a;
        this.c8._opacity = 1;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.c8);
            a.s(this.c9);
            a.s(this.da);
        }
    }
    get_index() {
        let a = this.c6.parentSeries;
        let b = a.series.count;
        let c = a.series.indexOf(this.c6.logicalSeriesLink);
        let d = (b - 1) - c;
        let e = a.bi.index;
        return e + d;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.c9, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.da, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.c8, "translucentShape", ["Translucent"]);
    }
}
LineFragmentView.$t = markType(LineFragmentView, 'LineFragmentView', AnchoredCategorySeriesView.$);
/**
 * @hidden
 */
class SplineAreaFragmentView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c7 = null;
        this.c9 = new Path();
        this.db = new Path();
        this.da = new Path();
        this.dc = new Path();
        this.c7 = a;
    }
    ap() {
        super.ap();
        if (!this.n) {
            this.e.bj = 1;
        }
    }
    c8() {
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
        this.dc.ak = null;
    }
    a8() {
        super.a8();
        this.c9._fill = this.e.lb;
        this.da._fill = this.e.lb;
        this.c9._opacity = this.e.d6;
        this.da._opacity = 0.5 * this.e.d6;
        this.db._stroke = this.e.lc;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.ll;
        this.db.ad = this.e.lm;
        this.dc._stroke = this.e.lc;
        this.dc.ac = this.e.ey;
        this.dc.ai = this.e.ll;
        this.dc.ad = this.e.lm;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.c9._fill = a;
        this.da._fill = a;
        this.da._opacity = 1;
        this.c9._opacity = 1;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.dc._stroke = a;
        this.dc.ac = this.e.ey + 3;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
            a.s(this.dc);
        }
    }
    get_index() {
        let a = this.c7.parentSeries;
        let b = a.series.count;
        let c = a.series.indexOf(this.c7.logicalSeriesLink);
        let d = (b - 1) - c;
        let e = a.bi.index;
        return e + d;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.db, "lowerShape", ["Lower"]);
        this.e.a2.exportPathData(a, this.dc, "upperShape", ["Upper", "Main"]);
        this.e.a2.exportPathData(a, this.da, "translucentShape", ["Translucent"]);
        this.e.a2.exportPathData(a, this.c9, "fillShape", ["Fill"]);
    }
}
SplineAreaFragmentView.$t = markType(SplineAreaFragmentView, 'SplineAreaFragmentView', SplineSeriesBaseView.$);
/**
 * @hidden
 */
class SplineFragmentView extends SplineSeriesBaseView {
    constructor(a) {
        super(a);
        this.c7 = null;
        this.da = new Path();
        this.c9 = new Path();
        this.db = new Path();
        this.c7 = a;
    }
    co() {
        return new SplineFragmentBucketCalculator(this);
    }
    c8() {
        this.c9.ak = null;
        this.da.ak = null;
        this.db.ak = null;
    }
    a8() {
        super.a8();
        this.da._stroke = this.e.lb;
        this.da.ac = this.e.ey;
        this.da.ai = this.e.ll;
        this.da.ad = this.e.lm;
        this.db._stroke = this.e.lb;
        this.db.ac = this.e.ey;
        this.db.ai = this.e.ll;
        this.db.ad = this.e.lm;
        this.c9._fill = this.e.lb;
        this.c9._opacity = 0.75;
    }
    a9() {
        super.a9();
        let a = this.bl();
        this.da._stroke = a;
        this.da.ac = this.e.ey + 3;
        this.db._stroke = a;
        this.db.ac = this.e.ey + 3;
        this.c9._fill = a;
        this.c9._opacity = 0.75;
    }
    a3(a, b) {
        super.a3(a, b);
        if (a.d) {
            a.s(this.c9);
            a.s(this.da);
            a.s(this.db);
        }
    }
    get_index() {
        let a = this.c7.parentSeries;
        let b = a.series.count;
        let c = a.series.indexOf(this.c7.logicalSeriesLink);
        let d = (b - 1) - c;
        let e = a.bi.index;
        return e + d;
    }
    ai(a) {
        super.ai(a);
        this.e.a2.exportPathData(a, this.da, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.db, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.c9, "translucentShape", ["Translucent"]);
    }
}
SplineFragmentView.$t = markType(SplineFragmentView, 'SplineFragmentView', SplineSeriesBaseView.$);
/**
 * @hidden
 */
class StackedSeriesView extends CategorySeriesView {
    constructor(a) {
        super(a);
        this.cw = null;
        this.cx = new Canvas();
        this.cz = new Panel();
        this.cw = a;
    }
    get cy() {
        return this.cx;
    }
    get c0() {
        return this.cz;
    }
    co() {
        return new StackedBucketCalculator(this);
    }
    am() {
        super.am();
        for (let a = 0; a < this.cw.pg.f.count; a++) {
            this.cw.pg.f._inner[a].bi.am();
        }
    }
    ao(a, b) {
        super.ao(a, b);
        for (let c of fromEnum(this.cw.series)) {
            c.visualSeriesLink.bi.ao(a, b);
        }
    }
    ac() {
        let a = "rgba(95,95,95,0.5)";
        let b = true;
        let c = 5, d = 5, e = 5;
        let f = this.e;
        if (typeCast(StackedAreaSeries.$, f) !== null || typeCast(StackedSplineAreaSeries.$, f) !== null) {
            d = 1;
            e = -3;
        }
        else if (typeCast(StackedLineSeries.$, f) !== null || typeCast(StackedSplineSeries.$, f) !== null) {
            c = 3;
            d = 1;
            e = 4;
            b = false;
        }
        else if (typeCast(StackedColumnSeries.$, f) !== null) {
            d = 5;
            e = 0;
        }
        let g = new Color();
        g.colorString = a;
        f.lk = g;
        f.ev = c;
        f.ew = d;
        f.ex = e;
        f.du = b;
    }
}
StackedSeriesView.$t = markType(StackedSeriesView, 'StackedSeriesView', CategorySeriesView.$);
/**
 * @hidden
 */
class StackedBarSeriesView extends StackedSeriesView {
    constructor(a) {
        super(a);
        this.c1 = null;
        this.c1 = a;
    }
    co() {
        return new StackedBarBucketCalculator(this);
    }
}
StackedBarSeriesView.$t = markType(StackedBarSeriesView, 'StackedBarSeriesView', StackedSeriesView.$);
/**
 * @hidden
 */
class StackedColumnSeriesView extends StackedSeriesView {
    constructor(a) {
        super(a);
    }
    co() {
        return new StackedColumnBucketCalculator(this);
    }
}
StackedColumnSeriesView.$t = markType(StackedColumnSeriesView, 'StackedColumnSeriesView', StackedSeriesView.$);
/**
 * @hidden
 */
class StackedSeriesManager extends Base {
    constructor(a) {
        super();
        this.b = null;
        this.f = null;
        this.c = null;
        this.e = null;
        this.d = null;
        this.j = null;
        this.k = null;
        if (a == null) {
            return;
        }
        this.b = a;
        this.f = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        this.c = new StackedSeriesCollection();
        this.e = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        this.d = new ObservableCollection$1(AnchoredCategorySeries.$, 0);
        this.j = this.b.ph.cy;
        this.k = this.b.ph.c0;
        let b = this.c;
        b.collectionChanged = delegateCombine(b.collectionChanged, (b, c) => {
            if (c.oldItems != null) {
                for (let d of fromEn(c.oldItems)) {
                    if (this.f.contains(d.visualSeriesLink)) {
                        this.f.remove(d.visualSeriesLink);
                    }
                }
            }
            if (c.newItems != null) {
                let e = c.newStartingIndex;
                for (let f of fromEn(c.newItems)) {
                    let g = this.a(f);
                    this.f.insert(e, g);
                    e++;
                }
            }
        });
        let c = this.f;
        c.collectionChanged = delegateCombine(c.collectionChanged, (c, d) => {
            if (d.oldItems != null) {
                for (let e of fromEn(d.oldItems)) {
                    e.h3(true, e.bi);
                    e.bs = null;
                    e.bn = null;
                    e.itemsSource = null;
                    e.legend = null;
                    if (this.k != null && this.k.ab.contains(e)) {
                        this.k.ab.remove(e);
                    }
                    if (this.b.bs != null) {
                        this.b.bs.k2(e);
                    }
                }
            }
            if (d.newItems != null) {
                for (let f of fromEn(d.newItems)) {
                    f.bs = this.b.bs;
                    f.bn = this.b.bn;
                    if (!this.k.ab.contains(f)) {
                        this.k.ab.add(f);
                    }
                    if (this.b.bs != null) {
                        this.b.bs.h7(f);
                    }
                }
            }
            this.b.jl(false);
        });
    }
    a(a) {
        if (typeCast(StackedLineSeries.$, this.b) !== null) {
            let b = new LineFragment();
            b.provideRenderer(a.au);
            b.parentSeries = this.b;
            a.visualSeriesLink = b;
            b.logicalSeriesLink = a;
            b.bi.br = this.b.bi.br;
            this.i(b, a);
            this.g(b);
            return b;
        }
        if (typeCast(StackedColumnSeries.$, this.b) !== null) {
            let c = new ColumnFragment();
            c.provideRenderer(a.au);
            c.parentSeries = this.b;
            a.visualSeriesLink = c;
            c.logicalSeriesLink = a;
            c.bi.br = this.b.bi.br;
            this.i(c, a);
            this.g(c);
            return c;
        }
        if (typeCast(StackedBarSeries.$, this.b) !== null) {
            let d = new BarFragment();
            d.provideRenderer(a.au);
            d.parentSeries = typeCast(StackedBarSeries.$, this.b);
            a.visualSeriesLink = d;
            d.logicalSeriesLink = a;
            d.bi.br = this.b.bi.br;
            this.i(d, a);
            this.g(d);
            return d;
        }
        if (typeCast(StackedAreaSeries.$, this.b) !== null) {
            let e = new AreaFragment();
            e.provideRenderer(a.au);
            e.parentSeries = this.b;
            a.visualSeriesLink = e;
            e.logicalSeriesLink = a;
            e.bi.br = this.b.bi.br;
            this.i(e, a);
            this.g(e);
            return e;
        }
        if (typeCast(StackedSplineSeries.$, this.b) !== null) {
            let f = new SplineFragment();
            f.provideRenderer(a.au);
            f.parentSeries = this.b;
            a.visualSeriesLink = f;
            f.logicalSeriesLink = a;
            f.bi.br = this.b.bi.br;
            this.i(f, a);
            this.g(f);
            return f;
        }
        if (typeCast(StackedSplineAreaSeries.$, this.b) !== null) {
            let g = new SplineAreaFragment();
            g.provideRenderer(a.au);
            g.parentSeries = this.b;
            a.visualSeriesLink = g;
            g.logicalSeriesLink = a;
            g.bi.br = this.b.bi.br;
            this.i(g, a);
            this.g(g);
            return g;
        }
        return null;
    }
    i(a, b) {
        a.ld = b.fz;
        a.ll = b.f2;
        a.lm = b.f4;
        a.ln = b.f5;
        a.itemsSource = this.b.itemsSource;
        a.legend = this.b.aw;
        a.legendItemTemplate = b.ds;
        a.l9 = b.gc;
        a.na = b.fq;
        a.nb = b.fr;
        a.nc = b.ga;
        a.mw = b.dt;
        a.mb = b.k;
        a.es = this.b.es;
        a._opacity = b.an;
        a.li = b.ft;
        a.eu = this.b.eu;
        a.lo = b.f6;
        a.ey = b.al;
        a.fx = b.ax;
        a.mf = b.u;
        a.pq = b.cq;
        a._visibility = b.gd;
        let c = typeCast(AreaFragment.$, a);
        if (c != null) {
            c.d6 = b.ae;
        }
        let d = typeCast(SplineAreaFragment.$, a);
        if (d != null) {
            d.d6 = b.ae;
        }
        let e = typeCast(ColumnFragment.$, a);
        if (e != null) {
            e.q6 = b.ag;
            e.q7 = b.ah;
        }
        let f = typeCast(BarFragment.$, a);
        if (f != null) {
            f.q6 = b.ag;
            f.q7 = b.ah;
        }
        a.toolTip = b.ay;
        a.cp = b.s;
        a.du = b.v;
        b.dg();
        b.dh();
        b.di();
        b.dj();
    }
    h() {
        this.e.clear();
        this.d.clear();
        let a = 0;
        for (let b of fromEnum(this.f)) {
            b.dl = true;
            b.fh = this.b.pr(this.c._inner[a]);
            b.bn = this.b.bn;
            b.bs = this.b.bs;
            if (this.c._inner[a].y) {
                this.e.add(b);
            }
            else {
                this.d.add(b);
            }
            if (typeCast(StackedLineSeries.$, this.b) !== null || typeCast(StackedAreaSeries.$, this.b) !== null || typeCast(StackedSplineSeries.$, this.b) !== null || typeCast(StackedSplineAreaSeries.$, this.b) !== null) {
                b.pt(this.b.fetchXAxis());
                b.pu(this.b.fetchYAxis());
            }
            b.jl(false);
            a++;
        }
    }
    g(a) {
        let fragment_ = a;
        fragment_.externalObject = TypeRegistrar.createFromInternal(fragment_, PlatformConstants.Prefix, PlatformConstants.Postfix);
        fragment_.externalObject._implementation = fragment_;
    }
}
StackedSeriesManager.$t = markType(StackedSeriesManager, 'StackedSeriesManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a non-visual child of StackedSeriesBase.
*/
const IgxStackedFragmentSeriesComponent_PROVIDERS = [];
let IgxStackedFragmentSeriesComponent = class IgxStackedFragmentSeriesComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._propertyUpdated = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new StackedFragmentSeries();
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets or sets the brush of the stacked fragment.
    */
    get brush() {
        return brushToString(this.i.fu);
    }
    set brush(v) {
        this.i.fu = stringToBrush(v);
    }
    /**
     * Gets the actual brush used by the series.
    */
    get actualBrush() {
        return brushToString(this.i.fp);
    }
    set actualBrush(v) {
        this.i.fp = stringToBrush(v);
    }
    /**
     * Gets or sets whether drop shadow should be enabled for this series.
    */
    get isDropShadowEnabled() {
        return this.i.w;
    }
    set isDropShadowEnabled(v) {
        this.i.w = ensureBool(v);
    }
    /**
     * Gets whether drop shadow is actually enabled for this series.
    */
    get actualIsDropShadowEnabled() {
        return this.i.s;
    }
    set actualIsDropShadowEnabled(v) {
        this.i.s = ensureBool(v);
    }
    /**
     * Gets or sets the shadow blur.
     * This property is ignored when StackedFragmentSeries.UseSingleShadow is set to true.
    */
    get shadowBlur() {
        return this.i.aq;
    }
    set shadowBlur(v) {
        this.i.aq = +v;
    }
    /**
     * Gets the actual shadow blur used by the series.
    */
    get actualShadowBlur() {
        return this.i.ai;
    }
    set actualShadowBlur(v) {
        this.i.ai = +v;
    }
    /**
     * Gets or sets the drop shadow color.
    */
    get shadowColor() {
        return colorToString(this.i.f1);
    }
    set shadowColor(v) {
        this.i.f1 = stringToColor(v);
    }
    /**
     * Gets actual the drop shadow color used by the series.
    */
    get actualShadowColor() {
        return colorToString(this.i.f0);
    }
    set actualShadowColor(v) {
        this.i.f0 = stringToColor(v);
    }
    /**
     * Gets or sets whether drop shadow is applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
     * When this property is set to true, no StackedFragmentSeries.ShadowBlur is applied.
    */
    get useSingleShadow() {
        return this.i.aa;
    }
    set useSingleShadow(v) {
        this.i.aa = ensureBool(v);
    }
    /**
     * Gets whether drop shadow is actually applied to the whole StackedFragmentSeries visual or to each of the individual shapes forming the StackedFragmentSeries.
    */
    get actualUseSingleShadow() {
        return this.i.v;
    }
    set actualUseSingleShadow(v) {
        this.i.v = ensureBool(v);
    }
    /**
     * Gets or sets the drop shadow x-offset.
    */
    get shadowOffsetX() {
        return this.i.ar;
    }
    set shadowOffsetX(v) {
        this.i.ar = +v;
    }
    /**
     * Gets the actual drop shadow x-offset applied to the series.
    */
    get actualShadowOffsetX() {
        return this.i.aj;
    }
    set actualShadowOffsetX(v) {
        this.i.aj = +v;
    }
    /**
     * Gets or sets the drop shadow y-offset.
    */
    get shadowOffsetY() {
        return this.i.as;
    }
    set shadowOffsetY(v) {
        this.i.as = +v;
    }
    /**
     * Gets the actual drop shadow y-offset applied to the series.
    */
    get actualShadowOffsetY() {
        return this.i.ak;
    }
    set actualShadowOffsetY(v) {
        this.i.ak = +v;
    }
    /**
     * Gets or sets the LegendItemBadgeTemplate property.
     * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
     * the series object itself.
    */
    get legendItemBadgeTemplate() {
        return this.i.du;
    }
    set legendItemBadgeTemplate(v) {
        this.i.du = v;
    }
    /**
     * Gets the actual legend item badge template used by the series.
    */
    get actualLegendItemBadgeTemplate() {
        return this.i.dr;
    }
    set actualLegendItemBadgeTemplate(v) {
        this.i.dr = v;
    }
    /**
     * Gets or sets the LegendItemTemplate property.
     * The legend item control content is created according to the LegendItemTemplate on-demand by
     * the series object itself.
    */
    get legendItemTemplate() {
        return this.i.dv;
    }
    set legendItemTemplate(v) {
        this.i.dv = v;
    }
    /**
     * Gets the actual legend item template used by the series.
    */
    get actualLegendItemTemplate() {
        return this.i.ds;
    }
    set actualLegendItemTemplate(v) {
        this.i.ds = v;
    }
    /**
     * Gets or sets the legend item visibility for the current series object.
    */
    get legendItemVisibility() {
        return this.i.ge;
    }
    set legendItemVisibility(v) {
        this.i.ge = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets the actual visibility of the legend items in the series.
    */
    get actualLegendItemVisibility() {
        return this.i.gc;
    }
    set actualLegendItemVisibility(v) {
        this.i.gc = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker interiors are painted.
    */
    get markerBrush() {
        return brushToString(this.i.fv);
    }
    set markerBrush(v) {
        this.i.fv = stringToBrush(v);
    }
    /**
     * Gets the actual marker brush of the series.
    */
    get actualMarkerBrush() {
        return brushToString(this.i.fq);
    }
    set actualMarkerBrush(v) {
        this.i.fq = stringToBrush(v);
    }
    /**
     * Gets or sets the brush that specifies how the current series object's marker outlines are painted.
    */
    get markerOutline() {
        return brushToString(this.i.fw);
    }
    set markerOutline(v) {
        this.i.fw = stringToBrush(v);
    }
    /**
     * Gets the actual marker outline of the series.
    */
    get actualMarkerOutline() {
        return brushToString(this.i.fr);
    }
    set actualMarkerOutline(v) {
        this.i.fr = stringToBrush(v);
    }
    /**
     * Gets or sets the MarkerTemplate for the current series object.
    */
    get markerTemplate() {
        return this.i.dw;
    }
    set markerTemplate(v) {
        this.i.dw = v;
    }
    /**
     * Gets the actual marker template used by the series.
    */
    get actualMarkerTemplate() {
        return this.i.dt;
    }
    set actualMarkerTemplate(v) {
        this.i.dt = v;
    }
    /**
     * Gets or sets the marker type for the current series object.
     * If the MarkerTemplate property is set, the setting of the MarkerType property will be ignored.
    */
    get markerType() {
        return this.i.l;
    }
    set markerType(v) {
        this.i.l = ensureEnum(MarkerType_$type, v);
    }
    /**
     * Gets the actual marker type set used in the series.
    */
    get actualMarkerType() {
        return this.i.k;
    }
    set actualMarkerType(v) {
        this.i.k = ensureEnum(MarkerType_$type, v);
    }
    /**
     * Gets or sets the Name of the stacked fragment.
    */
    get name() {
        return this.i.b8;
    }
    set name(v) {
        this.i.b8 = v;
    }
    /**
     * Gets or sets the Opacity of the stacked fragment.
    */
    get opacity() {
        return this.i.an;
    }
    set opacity(v) {
        this.i.an = +v;
    }
    /**
     * Gets the series opacity.
    */
    get actualOpacity() {
        return this.i.af;
    }
    set actualOpacity(v) {
        this.i.af = +v;
    }
    /**
     * Gets or sets the brush to use for the outline of the series.
     * Some series types, such as LineSeries, do not display outlines.  Therefore, this property does not affect some charts.
    */
    get outline() {
        return brushToString(this.i.fy);
    }
    set outline(v) {
        this.i.fy = stringToBrush(v);
    }
    /**
     * Gets the series outline.
    */
    get actualOutline() {
        return brushToString(this.i.ft);
    }
    set actualOutline(v) {
        this.i.ft = stringToBrush(v);
    }
    /**
     * Gets or sets the AreaFillOpacity of the stacked fragment. This property only applies for area-like series.
    */
    get areaFillOpacity() {
        return this.i.am;
    }
    set areaFillOpacity(v) {
        this.i.am = +v;
    }
    /**
     * Gets the series ActualAreaFillOpacity.  This property only applies for area-like series.
    */
    get actualAreaFillOpacity() {
        return this.i.ae;
    }
    set actualAreaFillOpacity(v) {
        this.i.ae = +v;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
    */
    get radiusX() {
        return this.i.ao;
    }
    set radiusX(v) {
        this.i.ao = +v;
    }
    /**
     * Gets the actual corner radius of the series
    */
    get actualRadiusX() {
        return this.i.ag;
    }
    set actualRadiusX(v) {
        this.i.ag = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column. This only applies to Bar and Column series.
    */
    get radiusY() {
        return this.i.ap;
    }
    set radiusY(v) {
        this.i.ap = +v;
    }
    /**
     * Gets the actual corner radius of the series
    */
    get actualRadiusY() {
        return this.i.ah;
    }
    set actualRadiusY(v) {
        this.i.ah = +v;
    }
    /**
     * Gets or sets the width of the current series object's line thickness.
    */
    get thickness() {
        return this.i.at;
    }
    set thickness(v) {
        this.i.at = +v;
    }
    /**
     * Gets or sets the thickness of this stacked fragment.
    */
    get actualThickness() {
        return this.i.al;
    }
    set actualThickness(v) {
        this.i.al = +v;
    }
    /**
     * Gets or sets the Title property.
     * The legend item control is created according to the Title on-demand by
     * the series object itself.
    */
    get title() {
        return this.i.ax;
    }
    set title(v) {
        this.i.ax = v;
    }
    /**
     * Gets or sets the value mapping property for the current series object.
    */
    get valueMemberPath() {
        return this.i.cq;
    }
    set valueMemberPath(v) {
        this.i.cq = v;
    }
    /**
     * Gets or sets the Visibility of the stacked fragment.
    */
    get visibility() {
        return this.i.gf;
    }
    set visibility(v) {
        this.i.gf = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets the actual visibility of the stacked fragment.
    */
    get actualVisibility() {
        return this.i.gd;
    }
    set actualVisibility(v) {
        this.i.gd = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets the resolved brush used between the local series and the parent series.
    */
    get parentOrLocalBrush() {
        return brushToString(this.i.fz);
    }
    set parentOrLocalBrush(v) {
        this.i.fz = stringToBrush(v);
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("StackedFragmentSeriesComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
     * Event raised when a property (including "effective" and non-dependency property) value changes.
    */
    get propertyUpdated() {
        if (this._propertyUpdated == null) {
            this._propertyUpdated = new EventEmitter();
            this.i.propertyUpdated = delegateCombine(this.i.propertyUpdated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxPropertyUpdatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforePropertyUpdated) {
                        this.beforePropertyUpdated(this, outerArgs);
                    }
                    this._propertyUpdated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._propertyUpdated;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "brush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "actualBrush", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedFragmentSeriesComponent.prototype, "isDropShadowEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedFragmentSeriesComponent.prototype, "actualIsDropShadowEnabled", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "shadowBlur", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualShadowBlur", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "shadowColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "actualShadowColor", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedFragmentSeriesComponent.prototype, "useSingleShadow", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedFragmentSeriesComponent.prototype, "actualUseSingleShadow", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "shadowOffsetX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualShadowOffsetX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "shadowOffsetY", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualShadowOffsetY", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "legendItemBadgeTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemBadgeTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "legendItemTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "legendItemVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualLegendItemVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "markerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "actualMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "markerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "actualMarkerOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "markerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "actualMarkerTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "markerType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualMarkerType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "name", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "opacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "outline", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "actualOutline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "areaFillOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualAreaFillOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualRadiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "radiusY", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualRadiusY", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "thickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxStackedFragmentSeriesComponent.prototype, "title", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "visibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedFragmentSeriesComponent.prototype, "actualVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxStackedFragmentSeriesComponent.prototype, "parentOrLocalBrush", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxStackedFragmentSeriesComponent.prototype, "propertyUpdated", null);
IgxStackedFragmentSeriesComponent = __decorate([
    Component({
        selector: 'igx-stacked-fragment-series',
        template: ``,
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedFragmentSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedFragmentSeriesModule = class IgxStackedFragmentSeriesModule {
};
IgxStackedFragmentSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedFragmentSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedFragmentSeriesComponent],
        entryComponents: []
    })
], IgxStackedFragmentSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedFragmentSeriesDynamicModule = class IgxStackedFragmentSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedFragmentSeriesComponent", IgxStackedFragmentSeriesComponent);
        TypeRegistrar.register("StackedFragmentSeries", StackedFragmentSeries.$type);
    }
};
IgxStackedFragmentSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedFragmentSeriesModule],
        exports: [IgxStackedFragmentSeriesModule],
        entryComponents: [IgxStackedFragmentSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedFragmentSeriesDynamicModule);

/**
 * Provides data for IgxDataChartComponent stacked series.
*/
class IgxStackedSeriesCreatedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets the series brush.
    */
    get brush() {
        return brushToString(this.i.brush);
    }
    set brush(v) {
        this.i.brush = stringToBrush(v);
    }
    /**
     * Gets or sets the series legend item template.
    */
    get legendItemTemplate() {
        return this.i.legendItemTemplate;
    }
    set legendItemTemplate(v) {
        this.i.legendItemTemplate = v;
    }
    /**
     * Gets or sets the series legend item badge templae.
    */
    get legendItemBadgeTemplate() {
        return this.i.legendItemBadgeTemplate;
    }
    set legendItemBadgeTemplate(v) {
        this.i.legendItemBadgeTemplate = v;
    }
    /**
     * Gets or sets the visibility of the series legend.
    */
    get legendItemVisibility() {
        return this.i.legendItemVisibility;
    }
    set legendItemVisibility(v) {
        this.i.legendItemVisibility = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the series outline brush.
    */
    get outline() {
        return brushToString(this.i.outline);
    }
    set outline(v) {
        this.i.outline = stringToBrush(v);
    }
    /**
     * Gets the index of the series.
    */
    get index() {
        return this.i.index;
    }
    /**
     * Gets or sets the series outline thickness.
    */
    get thickness() {
        return this.i.thickness;
    }
    set thickness(v) {
        this.i.thickness = +v;
    }
    /**
     * Gets or sets the series title.
    */
    get title() {
        return this.i.title;
    }
    set title(v) {
        this.i.title = v;
    }
    /**
     * Gets or sets the series marker brush.
    */
    get markerBrush() {
        return brushToString(this.i.markerBrush);
    }
    set markerBrush(v) {
        this.i.markerBrush = stringToBrush(v);
    }
    /**
     * Gets or sets the series marker outline.
    */
    get markerOutline() {
        return brushToString(this.i.markerOutline);
    }
    set markerOutline(v) {
        this.i.markerOutline = stringToBrush(v);
    }
    /**
     * Gets or sets the series marker style.
    */
    get markerStyle() {
        if (this.i.markerStyle == null) {
            return null;
        }
        if (!this.i.markerStyle.externalObject) {
            let e = new IgxStyle();
            e._implementation = this.i.markerStyle;
            this.i.markerStyle.externalObject = e;
        }
        return this.i.markerStyle.externalObject;
    }
    set markerStyle(v) {
        v == null ? this.i.markerStyle = null : this.i.markerStyle = v.i;
    }
    /**
     * Gets or sets the series marker template.
    */
    get markerTemplate() {
        return this.i.markerTemplate;
    }
    set markerTemplate(v) {
        this.i.markerTemplate = v;
    }
    /**
     * Gets or sets the series marker type.
    */
    get markerType() {
        return this.i.markerType;
    }
    set markerType(v) {
        this.i.markerType = ensureEnum(MarkerType_$type, v);
    }
}

class IgxStackedSeriesCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxStackedFragmentSeriesComponent.$type) {
            IgxStackedFragmentSeriesComponent.$type = markType(IgxStackedFragmentSeriesComponent, "IgxStackedFragmentSeriesComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxStackedFragmentSeriesComponent.$type, StackedFragmentSeries.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxStackedFragmentSeriesComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/**
 * Represents a IgxStackedSeriesBaseComponent base series.
*/
const IgxStackedSeriesBaseComponent_PROVIDERS = [];
class IgxStackedSeriesBaseComponent extends IgxCategorySeriesComponent {
    constructor() {
        super();
        this._seriesAdapter = null;
        /**
         * The series actually present in the chart. Do not directly modify this array.
         * This array's contents can be modified by causing Angular to reproject the child content.
         * Or adding and removing series from the manual series collection on the series property.
         */
        this.actualSeries = [];
        this._series = null;
        this._seriesCreated = null;
        //=============================
        this._seriesAdapter = new CollectionAdapter([], this.i.series, this.actualSeries, (c) => c.i, (i) => {
            i.owner = this;
            //(<any>i)._provideRenderer(this._dataSource);
            //i.provideData(this._dataSource);
            //this._ensureDefaultTooltip(i);
            //this._ensureTooltipCreated(i);
        }, (i) => {
            //(<any>i)._provideRenderer(null);
            //i.provideData(null); 
        });
        //=============================
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    get i() {
        return this._implementation;
    }
    //=============================
    ngAfterContentInit() {
        this._seriesAdapter.updateQuery(this.fragments);
    }
    /**
     * A collection or manually added series for the chart.
    */
    get series() {
        if (this._series === null) {
            let coll = new IgxStackedSeriesCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._seriesAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._seriesAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._seriesAdapter.clearManualItems();
                        break;
                }
            });
            this._series = coll;
        }
        return this._series;
    }
    //=============================
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * Gets or sets whether series should be automatically generated. Reqiures the use of GroupBy as the ItemsSource.
*/
    get autoGenerateSeries() {
        return this.i.pi;
    }
    set autoGenerateSeries(v) {
        this.i.pi = ensureBool(v);
    }
    /**
     * Gets or sets whether the order of the fragment series should be reversed in the legend.
    */
    get reverseLegendOrder() {
        return this.i.pj;
    }
    set reverseLegendOrder(v) {
        this.i.pj = ensureBool(v);
    }
    /**
     * Checks if this series is a stacked series
    */
    get isStacked() {
        return this.i.isStacked;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.series != null && this.series.findByName && this.series.findByName(name)) {
            return this.series.findByName(name);
        }
        return null;
    }
    /**
 * Simulates a pointer hover over the series surface.

* @param point  * The pointer position relative to the series viewport over which to hover.
*/
    simulateHover(point) {
        this.i.js(toPoint(point));
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Event raised when a new fragment series is automatically generated.
    */
    get seriesCreated() {
        if (this._seriesCreated == null) {
            this._seriesCreated = new EventEmitter();
            this.i.seriesCreated = delegateCombine(this.i.seriesCreated, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxStackedSeriesCreatedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSeriesCreated) {
                        this.beforeSeriesCreated(this, outerArgs);
                    }
                    this._seriesCreated.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._seriesCreated;
    }
}
__decorate([
    ContentChildren(IgxStackedFragmentSeriesComponent),
    __metadata("design:type", QueryList)
], IgxStackedSeriesBaseComponent.prototype, "fragments", void 0);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedSeriesBaseComponent.prototype, "autoGenerateSeries", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxStackedSeriesBaseComponent.prototype, "reverseLegendOrder", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxStackedSeriesBaseComponent.prototype, "seriesCreated", null);

/**
 * Base class for stacked series with a category x-axis and a numeric y-axis.
*/
const IgxHorizontalStackedSeriesBaseComponent_PROVIDERS = [{ provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxHorizontalStackedSeriesBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxHorizontalStackedSeriesBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxHorizontalStackedSeriesBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxHorizontalStackedSeriesBaseComponent) }];
class IgxHorizontalStackedSeriesBaseComponent extends IgxStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the effective x-axis for this series.
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for this series.
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxNumericYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.qa(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.p9(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryAxisBaseComponent),
    __metadata("design:paramtypes", [IgxCategoryAxisBaseComponent])
], IgxHorizontalStackedSeriesBaseComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxNumericYAxisComponent),
    __metadata("design:paramtypes", [IgxNumericYAxisComponent])
], IgxHorizontalStackedSeriesBaseComponent.prototype, "yAxis", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked area series.
*/
const IgxStackedAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent) }];
let IgxStackedAreaSeriesComponent = IgxStackedAreaSeriesComponent_1 = class IgxStackedAreaSeriesComponent extends IgxHorizontalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStackedAreaSeriesComponent = IgxStackedAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-area-series',
        template: ``,
        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100DataPreparer extends Base {
    static a(a) {
        if (a.bz == null) {
            return;
        }
        let b = Number.POSITIVE_INFINITY;
        let c = Number.NEGATIVE_INFINITY;
        for (let d = 0; d < a.bz.count; d++) {
            let e = Math.abs(a.o9[d]) + a.o8[d];
            if (e == 0) {
                b = Math.min(b, 0);
                c = Math.max(c, 0);
                continue;
            }
            b = Math.min(b, a.o9[d] / e * 100);
            c = Math.max(c, a.o8[d] / e * 100);
        }
        a.pp = b;
        a.po = c;
    }
}
Stacked100DataPreparer.$t = markType(Stacked100DataPreparer, 'Stacked100DataPreparer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100AreaSeries extends StackedAreaSeries {
    constructor() {
        super();
        this.ab = Stacked100AreaSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100AreaSeries.$t = markType(Stacked100AreaSeries, 'Stacked100AreaSeries', StackedAreaSeries.$, [IStacked100Series_$type]);

var IgxStacked100AreaSeriesComponent_1;
/**
 * Represents a stacked area series, where values are presented as percentages of the total.
*/
const IgxStacked100AreaSeriesComponent_PROVIDERS = [{ provide: IgxStackedAreaSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent) }];
let IgxStacked100AreaSeriesComponent = IgxStacked100AreaSeriesComponent_1 = class IgxStacked100AreaSeriesComponent extends IgxStackedAreaSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100AreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100AreaSeriesComponent = IgxStacked100AreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-area-series',
        template: ``,
        providers: [{ provide: IgxStackedAreaSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100AreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100AreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100AreaSeriesModule = class IgxStacked100AreaSeriesModule {
};
IgxStacked100AreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100AreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100AreaSeriesComponent],
        entryComponents: []
    })
], IgxStacked100AreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100AreaSeriesDynamicModule = class IgxStacked100AreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100AreaSeriesComponent", IgxStacked100AreaSeriesComponent);
        TypeRegistrar.register("Stacked100AreaSeries", Stacked100AreaSeries.$type);
    }
};
IgxStacked100AreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100AreaSeriesModule],
        exports: [IgxStacked100AreaSeriesModule],
        entryComponents: [IgxStacked100AreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100AreaSeriesDynamicModule);

/**
 * Base class for stacked series with a numeric x-axis and a category y-axis.
*/
const IgxVerticalStackedSeriesBaseComponent_PROVIDERS = [{ provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxVerticalStackedSeriesBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxVerticalStackedSeriesBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxVerticalStackedSeriesBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxVerticalStackedSeriesBaseComponent) }];
class IgxVerticalStackedSeriesBaseComponent extends IgxStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the effective x-axis for the current CategorySeries object.
    */
    get xAxis() {
        if (this.i.xAxis == null) {
            return null;
        }
        if (!this.i.xAxis.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.xAxis);
            if (e) {
                e._implementation = this.i.xAxis;
            }
            this.i.xAxis.externalObject = e;
        }
        return this.i.xAxis.externalObject;
    }
    set xAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.xAxis = null : this.i.xAxis = v.i;
    }
    /**
     * Gets or sets the effective y-axis for the current CategorySeries object.
    */
    get yAxis() {
        if (this.i.yAxis == null) {
            return null;
        }
        if (!this.i.yAxis.externalObject) {
            let e = IgxCategoryYAxisComponent._createFromInternal(this.i.yAxis);
            if (e) {
                e._implementation = this.i.yAxis;
            }
            this.i.yAxis.externalObject = e;
        }
        return this.i.yAxis.externalObject;
    }
    set yAxis(v) {
        if (v != null && this._stylingContainer && v._styling)
            v._styling(this._stylingContainer, this, this);
        v == null ? this.i.yAxis = null : this.i.yAxis = v.i;
    }
    /**
     * Gets whether or not the current series is vertical series
    */
    get isVertical() {
        return this.i.isVertical;
    }
    findByName(name) {
        var baseResult = super.findByName(name);
        if (baseResult) {
            return baseResult;
        }
        if (this.xAxis && this.xAxis.name && this.xAxis.name == name) {
            return this.xAxis;
        }
        if (this.yAxis && this.yAxis.name && this.yAxis.name == name) {
            return this.yAxis;
        }
        return null;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.xAxis && this.xAxis._styling) {
            this.xAxis._styling(container, component, this);
        }
        if (this.yAxis && this.yAxis._styling) {
            this.yAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Returns the offset value for this series if grouped on a category axis.
    
    */
    getOffsetValue() {
        let iv = this.i.getOffsetValue();
        return (iv);
    }
    /**
     * Returns the width of the category grouping this series is in.
    
    */
    getCategoryWidth() {
        let iv = this.i.getCategoryWidth();
        return (iv);
    }
    /**
     * Determine if object can be used as YAxis
    
    * @param axis  * The object to check
    */
    canUseAsYAxis(axis) {
        let iv = this.i.qa(axis);
        return (iv);
    }
    /**
     * Determine if object can be used as XAxis
    
    * @param axis  * The object to check
    */
    canUseAsXAxis(axis) {
        let iv = this.i.p9(axis);
        return (iv);
    }
}
__decorate([
    Input(),
    __metadata("design:type", IgxNumericXAxisComponent),
    __metadata("design:paramtypes", [IgxNumericXAxisComponent])
], IgxVerticalStackedSeriesBaseComponent.prototype, "xAxis", null);
__decorate([
    Input(),
    __metadata("design:type", IgxCategoryYAxisComponent),
    __metadata("design:paramtypes", [IgxCategoryYAxisComponent])
], IgxVerticalStackedSeriesBaseComponent.prototype, "yAxis", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedBarSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked bar series.
*/
const IgxStackedBarSeriesComponent_PROVIDERS = [{ provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent) }];
let IgxStackedBarSeriesComponent = IgxStackedBarSeriesComponent_1 = class IgxStackedBarSeriesComponent extends IgxVerticalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedBarSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the bar.
    */
    get radiusX() {
        return this.i.qg;
    }
    set radiusX(v) {
        this.i.qg = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the bar.
    */
    get radiusY() {
        return this.i.qh;
    }
    set radiusY(v) {
        this.i.qh = +v;
    }
    /**
     * Scrolls the series to display the item for the specified data item.
     * The series is scrolled by the minimum amount required to place the specified data item within
     * the central 80% of the visible axis.
    
    * @param item  * The data item (item) to scroll to.
    */
    scrollIntoView(item) {
        let iv = this.i.c9(item);
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedBarSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedBarSeriesComponent.prototype, "radiusY", null);
IgxStackedBarSeriesComponent = IgxStackedBarSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-bar-series',
        template: ``,
        providers: [{ provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedBarSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedBarSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100BarBucketCalculator extends StackedBarBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        return super.getBucket(a);
    }
    getBucket1(a, b, c, d, e, f) {
        let g = typeCast(StackedBarSeries.$, this.c.cp);
        let h = [NaN, NaN, NaN];
        let i = typeCast(BarFragment.$, a);
        if (i == null || i.logicalSeriesLink == null) {
            return h;
        }
        let j = a.valueColumn.item(c);
        let k = 0;
        let l = 0;
        let m = NaN;
        let n = NaN;
        let o = Number.NEGATIVE_INFINITY;
        let p = Number.POSITIVE_INFINITY;
        let q = g.getEffectiveViewport1(this.c);
        let r = Math.min(g.o9 != null ? g.o9.length : 0, g.o8 != null ? g.o8.length : 0);
        let s = c * this.d;
        let t = Math.min(s + this.d - 1, r - 1);
        for (let u = s; u <= t; ++u) {
            j = a.valueColumn.item(u);
            k = Math.abs(g.o9[u]) + g.o8[u];
            if (j < l) {
                p = Math.min(p, (i.logicalSeriesLink.ad._inner[u] + j) / k * 100);
                o = Math.max(o, i.logicalSeriesLink.ad._inner[u] / k * 100);
            }
            else {
                p = Math.min(p, i.logicalSeriesLink.ac._inner[u] / k * 100);
                o = Math.max(o, (i.logicalSeriesLink.ac._inner[u] + j) / k * 100);
            }
            if (!isNaN_(m)) {
                if (!isNaN_(p)) {
                    m = Math.min(m, p);
                    n = Math.max(n, p);
                }
                if (!isNaN_(o)) {
                    m = Math.min(m, o);
                    n = Math.max(n, o);
                }
            }
            else {
                m = p;
                n = o;
            }
        }
        let v = new ScalerParams(0, d, e, g.xAxis.ca, q);
        h = [f.f._inner[b - this.e][0], g.xAxis.dy(n, v), g.xAxis.dy(m, v)];
        return h;
    }
}
Stacked100BarBucketCalculator.$t = markType(Stacked100BarBucketCalculator, 'Stacked100BarBucketCalculator', StackedBarBucketCalculator.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100BarSeries extends StackedBarSeries {
    constructor() {
        super();
        this.ab = Stacked100BarSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    bf() {
        return new Stacked100BarSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qm = a;
    }
    pb() {
        return this.qm;
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100BarSeries.$t = markType(Stacked100BarSeries, 'Stacked100BarSeries', StackedBarSeries.$, [IStacked100Series_$type]);
/**
 * @hidden
 */
class Stacked100BarSeriesView extends StackedBarSeriesView {
    constructor(a) {
        super(a);
        this.c2 = null;
        this.c2 = a;
    }
    co() {
        return new Stacked100BarBucketCalculator(this);
    }
}
Stacked100BarSeriesView.$t = markType(Stacked100BarSeriesView, 'Stacked100BarSeriesView', StackedBarSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStacked100BarSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked100 bar series.
*/
const IgxStacked100BarSeriesComponent_PROVIDERS = [{ provide: IgxStackedBarSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent) }];
let IgxStacked100BarSeriesComponent = IgxStacked100BarSeriesComponent_1 = class IgxStacked100BarSeriesComponent extends IgxStackedBarSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100BarSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100BarSeriesComponent = IgxStacked100BarSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-bar-series',
        template: ``,
        providers: [{ provide: IgxStackedBarSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }, { provide: IgxVerticalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100BarSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100BarSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100BarSeriesModule = class IgxStacked100BarSeriesModule {
};
IgxStacked100BarSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100BarSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100BarSeriesComponent],
        entryComponents: []
    })
], IgxStacked100BarSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100BarSeriesDynamicModule = class IgxStacked100BarSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100BarSeriesComponent", IgxStacked100BarSeriesComponent);
        TypeRegistrar.register("Stacked100BarSeries", Stacked100BarSeries.$type);
    }
};
IgxStacked100BarSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100BarSeriesModule],
        exports: [IgxStacked100BarSeriesModule],
        entryComponents: [IgxStacked100BarSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100BarSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedColumnSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked column series.
*/
const IgxStackedColumnSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent) }];
let IgxStackedColumnSeriesComponent = IgxStackedColumnSeriesComponent_1 = class IgxStackedColumnSeriesComponent extends IgxHorizontalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedColumnSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX() {
        return this.i.qg;
    }
    set radiusX(v) {
        this.i.qg = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.qh;
    }
    set radiusY(v) {
        this.i.qh = +v;
    }
    /**
     * For a category plotted series, returns the current width of the items within the categories. This only returns a value if the items have some form of width (e.g. columns, bars, etc.) otherwise 0 is returned.
    
    */
    getItemSpan() {
        let iv = this.i.eg();
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedColumnSeriesComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxStackedColumnSeriesComponent.prototype, "radiusY", null);
IgxStackedColumnSeriesComponent = IgxStackedColumnSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-column-series',
        template: ``,
        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedColumnSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedColumnSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100ColumnBucketCalculator extends StackedColumnBucketCalculator {
    constructor(a) {
        super(a);
    }
    getBucket(a) {
        return super.getBucket(a);
    }
    getBucket1(a, b, c, d, e, f) {
        let g = typeCast(StackedSeriesBase.$, this.c.cp);
        let h = [NaN, NaN, NaN];
        let i = typeCast(ColumnFragment.$, a);
        if (i == null || i.logicalSeriesLink == null) {
            return h;
        }
        let j = g.getEffectiveViewport1(this.c);
        let k = a.valueColumn.item(c);
        let l = 0;
        let m = NaN;
        let n = NaN;
        let o = Number.NEGATIVE_INFINITY;
        let p = Number.POSITIVE_INFINITY;
        let q = 0;
        let r = Math.min(g.o9 != null ? g.o9.length : 0, g.o8 != null ? g.o8.length : 0);
        let s = c * this.d;
        let t = Math.min(s + this.d - 1, r - 1);
        for (let u = s; u <= t; ++u) {
            k = a.valueColumn.item(u);
            q = Math.abs(g.o9[u]) + g.o8[u];
            if (k < l) {
                p = Math.min(p, (i.logicalSeriesLink.ad._inner[u] + k) / q * 100);
                o = Math.max(o, i.logicalSeriesLink.ad._inner[u] / q * 100);
            }
            else {
                p = Math.min(p, i.logicalSeriesLink.ac._inner[u] / q * 100);
                o = Math.max(o, (i.logicalSeriesLink.ac._inner[u] + k) / q * 100);
            }
            if (!isNaN_(m)) {
                if (!isNaN_(p)) {
                    m = Math.min(m, p);
                    n = Math.max(n, p);
                }
                if (!isNaN_(o)) {
                    m = Math.min(m, o);
                    n = Math.max(n, o);
                }
            }
            else {
                m = p;
                n = o;
            }
        }
        let v = new ScalerParams(0, d, e, i.fragmentYAxis.ca, j);
        h = [f.f._inner[b - this.e][0], i.fragmentYAxis.dy(n, v), i.fragmentYAxis.dy(m, v)];
        return h;
    }
}
Stacked100ColumnBucketCalculator.$t = markType(Stacked100ColumnBucketCalculator, 'Stacked100ColumnBucketCalculator', StackedColumnBucketCalculator.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100ColumnSeries extends StackedColumnSeries {
    constructor() {
        super();
        this.ab = Stacked100ColumnSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    bf() {
        return new Stacked100ColumnSeriesView(this);
    }
    i2(a) {
        super.i2(a);
        this.qm = a;
    }
    pb() {
        return this.qm;
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100ColumnSeries.$t = markType(Stacked100ColumnSeries, 'Stacked100ColumnSeries', StackedColumnSeries.$, [IStacked100Series_$type]);
/**
 * @hidden
 */
class Stacked100ColumnSeriesView extends StackedColumnSeriesView {
    constructor(a) {
        super(a);
        this.c1 = null;
        this.c1 = a;
    }
    co() {
        return new Stacked100ColumnBucketCalculator(this);
    }
}
Stacked100ColumnSeriesView.$t = markType(Stacked100ColumnSeriesView, 'Stacked100ColumnSeriesView', StackedColumnSeriesView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStacked100ColumnSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked100 column series.
*/
const IgxStacked100ColumnSeriesComponent_PROVIDERS = [{ provide: IgxStackedColumnSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent) }];
let IgxStacked100ColumnSeriesComponent = IgxStacked100ColumnSeriesComponent_1 = class IgxStacked100ColumnSeriesComponent extends IgxStackedColumnSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100ColumnSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100ColumnSeriesComponent = IgxStacked100ColumnSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-column-series',
        template: ``,
        providers: [{ provide: IgxStackedColumnSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100ColumnSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100ColumnSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100ColumnSeriesModule = class IgxStacked100ColumnSeriesModule {
};
IgxStacked100ColumnSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100ColumnSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100ColumnSeriesComponent],
        entryComponents: []
    })
], IgxStacked100ColumnSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100ColumnSeriesDynamicModule = class IgxStacked100ColumnSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100ColumnSeriesComponent", IgxStacked100ColumnSeriesComponent);
        TypeRegistrar.register("Stacked100ColumnSeries", Stacked100ColumnSeries.$type);
    }
};
IgxStacked100ColumnSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100ColumnSeriesModule],
        exports: [IgxStacked100ColumnSeriesModule],
        entryComponents: [IgxStacked100ColumnSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100ColumnSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedLineSeriesComponent_1;
/**
 * Represents a stacked series, where the points in each series are connected with a line.
*/
const IgxStackedLineSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent) }];
let IgxStackedLineSeriesComponent = IgxStackedLineSeriesComponent_1 = class IgxStackedLineSeriesComponent extends IgxHorizontalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedLineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStackedLineSeriesComponent = IgxStackedLineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-line-series',
        template: ``,
        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedLineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedLineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100LineSeries extends StackedLineSeries {
    constructor() {
        super();
        this.ab = Stacked100LineSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100LineSeries.$t = markType(Stacked100LineSeries, 'Stacked100LineSeries', StackedLineSeries.$, [IStacked100Series_$type]);

var IgxStacked100LineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked100 line series.
*/
const IgxStacked100LineSeriesComponent_PROVIDERS = [{ provide: IgxStackedLineSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent) }];
let IgxStacked100LineSeriesComponent = IgxStacked100LineSeriesComponent_1 = class IgxStacked100LineSeriesComponent extends IgxStackedLineSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100LineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100LineSeriesComponent = IgxStacked100LineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-line-series',
        template: ``,
        providers: [{ provide: IgxStackedLineSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100LineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100LineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100LineSeriesModule = class IgxStacked100LineSeriesModule {
};
IgxStacked100LineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100LineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100LineSeriesComponent],
        entryComponents: []
    })
], IgxStacked100LineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100LineSeriesDynamicModule = class IgxStacked100LineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100LineSeriesComponent", IgxStacked100LineSeriesComponent);
        TypeRegistrar.register("Stacked100LineSeries", Stacked100LineSeries.$type);
    }
};
IgxStacked100LineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100LineSeriesModule],
        exports: [IgxStacked100LineSeriesModule],
        entryComponents: [IgxStacked100LineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100LineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedSplineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked spline series.
*/
const IgxStackedSplineSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent) }];
let IgxStackedSplineSeriesComponent = IgxStackedSplineSeriesComponent_1 = class IgxStackedSplineSeriesComponent extends IgxHorizontalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedSplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStackedSplineSeriesComponent = IgxStackedSplineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-spline-series',
        template: ``,
        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedSplineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100SplineSeries extends StackedSplineSeries {
    constructor() {
        super();
        this.ab = Stacked100SplineSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100SplineSeries.$t = markType(Stacked100SplineSeries, 'Stacked100SplineSeries', StackedSplineSeries.$, [IStacked100Series_$type]);

var IgxStacked100SplineSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked100 spline series.
*/
const IgxStacked100SplineSeriesComponent_PROVIDERS = [{ provide: IgxStackedSplineSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent) }];
let IgxStacked100SplineSeriesComponent = IgxStacked100SplineSeriesComponent_1 = class IgxStacked100SplineSeriesComponent extends IgxStackedSplineSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100SplineSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100SplineSeriesComponent = IgxStacked100SplineSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-spline-series',
        template: ``,
        providers: [{ provide: IgxStackedSplineSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100SplineSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100SplineSeriesModule = class IgxStacked100SplineSeriesModule {
};
IgxStacked100SplineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100SplineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100SplineSeriesComponent],
        entryComponents: []
    })
], IgxStacked100SplineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100SplineSeriesDynamicModule = class IgxStacked100SplineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100SplineSeriesComponent", IgxStacked100SplineSeriesComponent);
        TypeRegistrar.register("Stacked100SplineSeries", Stacked100SplineSeries.$type);
    }
};
IgxStacked100SplineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100SplineSeriesModule],
        exports: [IgxStacked100SplineSeriesModule],
        entryComponents: [IgxStacked100SplineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100SplineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxStackedSplineAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked spline area series.
*/
const IgxStackedSplineAreaSeriesComponent_PROVIDERS = [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent) }];
let IgxStackedSplineAreaSeriesComponent = IgxStackedSplineAreaSeriesComponent_1 = class IgxStackedSplineAreaSeriesComponent extends IgxHorizontalStackedSeriesBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new StackedSplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStackedSplineAreaSeriesComponent = IgxStackedSplineAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-spline-area-series',
        template: ``,
        providers: [{ provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStackedSplineAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStackedSplineAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Stacked100SplineAreaSeries extends StackedSplineAreaSeries {
    constructor() {
        super();
        this.ab = Stacked100SplineAreaSeries.$;
    }
    ac() {
        super.ac();
        this.jl(false);
    }
    py() {
        super.py();
        Stacked100DataPreparer.a(this);
    }
    get useHighMarkerFidelity() {
        return this.of;
    }
}
Stacked100SplineAreaSeries.$t = markType(Stacked100SplineAreaSeries, 'Stacked100SplineAreaSeries', StackedSplineAreaSeries.$, [IStacked100Series_$type]);

var IgxStacked100SplineAreaSeriesComponent_1;
/**
 * Represents a IgxDataChartComponent stacked100 spline area series.
*/
const IgxStacked100SplineAreaSeriesComponent_PROVIDERS = [{ provide: IgxStackedSplineAreaSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent) }];
let IgxStacked100SplineAreaSeriesComponent = IgxStacked100SplineAreaSeriesComponent_1 = class IgxStacked100SplineAreaSeriesComponent extends IgxStackedSplineAreaSeriesComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new Stacked100SplineAreaSeries();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxStacked100SplineAreaSeriesComponent = IgxStacked100SplineAreaSeriesComponent_1 = __decorate([
    Component({
        selector: 'igx-stacked-100-spline-area-series',
        template: ``,
        providers: [{ provide: IgxStackedSplineAreaSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }, { provide: IgxHorizontalStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }, { provide: IgxStackedSeriesBaseComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxStacked100SplineAreaSeriesComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100SplineAreaSeriesComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100SplineAreaSeriesModule = class IgxStacked100SplineAreaSeriesModule {
};
IgxStacked100SplineAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStacked100SplineAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStacked100SplineAreaSeriesComponent],
        entryComponents: []
    })
], IgxStacked100SplineAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStacked100SplineAreaSeriesDynamicModule = class IgxStacked100SplineAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStacked100SplineAreaSeriesComponent", IgxStacked100SplineAreaSeriesComponent);
        TypeRegistrar.register("Stacked100SplineAreaSeries", Stacked100SplineAreaSeries.$type);
    }
};
IgxStacked100SplineAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStacked100SplineAreaSeriesModule],
        exports: [IgxStacked100SplineAreaSeriesModule],
        entryComponents: [IgxStacked100SplineAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStacked100SplineAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedAreaSeriesModule = class IgxStackedAreaSeriesModule {
};
IgxStackedAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedAreaSeriesComponent],
        entryComponents: []
    })
], IgxStackedAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedAreaSeriesDynamicModule = class IgxStackedAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedAreaSeriesComponent", IgxStackedAreaSeriesComponent);
        TypeRegistrar.register("StackedAreaSeries", StackedAreaSeries.$type);
    }
};
IgxStackedAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedAreaSeriesModule],
        exports: [IgxStackedAreaSeriesModule],
        entryComponents: [IgxStackedAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedAreaSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedBarSeriesModule = class IgxStackedBarSeriesModule {
};
IgxStackedBarSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedBarSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedBarSeriesComponent],
        entryComponents: []
    })
], IgxStackedBarSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedBarSeriesDynamicModule = class IgxStackedBarSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedBarSeriesComponent", IgxStackedBarSeriesComponent);
        TypeRegistrar.register("StackedBarSeries", StackedBarSeries.$type);
    }
};
IgxStackedBarSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedBarSeriesModule],
        exports: [IgxStackedBarSeriesModule],
        entryComponents: [IgxStackedBarSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedBarSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedColumnSeriesModule = class IgxStackedColumnSeriesModule {
};
IgxStackedColumnSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedColumnSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedColumnSeriesComponent],
        entryComponents: []
    })
], IgxStackedColumnSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedColumnSeriesDynamicModule = class IgxStackedColumnSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedColumnSeriesComponent", IgxStackedColumnSeriesComponent);
        TypeRegistrar.register("StackedColumnSeries", StackedColumnSeries.$type);
    }
};
IgxStackedColumnSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedColumnSeriesModule],
        exports: [IgxStackedColumnSeriesModule],
        entryComponents: [IgxStackedColumnSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedColumnSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedLineSeriesModule = class IgxStackedLineSeriesModule {
};
IgxStackedLineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedLineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedLineSeriesComponent],
        entryComponents: []
    })
], IgxStackedLineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedLineSeriesDynamicModule = class IgxStackedLineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedLineSeriesComponent", IgxStackedLineSeriesComponent);
        TypeRegistrar.register("StackedLineSeries", StackedLineSeries.$type);
    }
};
IgxStackedLineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedLineSeriesModule],
        exports: [IgxStackedLineSeriesModule],
        entryComponents: [IgxStackedLineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedLineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedSplineSeriesModule = class IgxStackedSplineSeriesModule {
};
IgxStackedSplineSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedSplineSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedSplineSeriesComponent],
        entryComponents: []
    })
], IgxStackedSplineSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedSplineSeriesDynamicModule = class IgxStackedSplineSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedSplineSeriesComponent", IgxStackedSplineSeriesComponent);
        TypeRegistrar.register("StackedSplineSeries", StackedSplineSeries.$type);
    }
};
IgxStackedSplineSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedSplineSeriesModule],
        exports: [IgxStackedSplineSeriesModule],
        entryComponents: [IgxStackedSplineSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedSplineSeriesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedSplineAreaSeriesModule = class IgxStackedSplineAreaSeriesModule {
};
IgxStackedSplineAreaSeriesModule = __decorate([
    NgModule({
        declarations: [IgxStackedSplineAreaSeriesComponent],
        imports: [CommonModule],
        exports: [IgxStackedSplineAreaSeriesComponent],
        entryComponents: []
    })
], IgxStackedSplineAreaSeriesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxStackedSplineAreaSeriesDynamicModule = class IgxStackedSplineAreaSeriesDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxStackedSplineAreaSeriesComponent", IgxStackedSplineAreaSeriesComponent);
        TypeRegistrar.register("StackedSplineAreaSeries", StackedSplineAreaSeries.$type);
    }
};
IgxStackedSplineAreaSeriesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxStackedSplineAreaSeriesModule],
        exports: [IgxStackedSplineAreaSeriesModule],
        entryComponents: [IgxStackedSplineAreaSeriesComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxStackedSplineAreaSeriesDynamicModule);

/**
 * Represents one part of a stacked series.
*/
const IgxFragmentBaseComponent_PROVIDERS = [{ provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxFragmentBaseComponent) }];
class IgxFragmentBaseComponent extends IgxHorizontalAnchoredCategorySeriesComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets whether the current series is a stack fragment.
    */
    get isFragment() {
        return this.i.cs;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxAreaFragmentComponent_1;
/**
 * Represents one part of a StackedAreaSeries.
*/
const IgxAreaFragmentComponent_PROVIDERS = [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent) }];
let IgxAreaFragmentComponent = IgxAreaFragmentComponent_1 = class IgxAreaFragmentComponent extends IgxFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new AreaFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxAreaFragmentComponent = IgxAreaFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-area-fragment',
        template: ``,
        providers: [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxAreaFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxAreaFragmentComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAreaFragmentModule = class IgxAreaFragmentModule {
};
IgxAreaFragmentModule = __decorate([
    NgModule({
        declarations: [IgxAreaFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxAreaFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxAreaFragmentDynamicModule = class IgxAreaFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxAreaFragmentComponent", IgxAreaFragmentComponent);
        TypeRegistrar.register("AreaFragment", AreaFragment.$type);
    }
};
IgxAreaFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxAreaFragmentModule],
        exports: [IgxAreaFragmentModule],
        entryComponents: [IgxAreaFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxAreaFragmentDynamicModule);

var IgxColumnFragmentComponent_1;
/**
 * Represents one part of a StackedColumnSeries.
*/
const IgxColumnFragmentComponent_PROVIDERS = [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent) }];
let IgxColumnFragmentComponent = IgxColumnFragmentComponent_1 = class IgxColumnFragmentComponent extends IgxFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ColumnFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the x-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusX() {
        return this.i.q6;
    }
    set radiusX(v) {
        this.i.q6 = +v;
    }
    /**
     * Gets or sets the y-radius of the ellipse that is used to round the corners of the column.
    */
    get radiusY() {
        return this.i.q7;
    }
    set radiusY(v) {
        this.i.q7 = +v;
    }
    /**
     * Gets or sets the effective x-axis for this series.
    */
    get fragmentXAxis() {
        if (this.i.fragmentXAxis == null) {
            return null;
        }
        if (!this.i.fragmentXAxis.externalObject) {
            let e = IgxCategoryAxisBaseComponent._createFromInternal(this.i.fragmentXAxis);
            if (e) {
                e._implementation = this.i.fragmentXAxis;
            }
            this.i.fragmentXAxis.externalObject = e;
        }
        return this.i.fragmentXAxis.externalObject;
    }
    /**
     * Gets or sets the effective y-axis for this series.
    */
    get fragmentYAxis() {
        if (this.i.fragmentYAxis == null) {
            return null;
        }
        if (!this.i.fragmentYAxis.externalObject) {
            let e = IgxNumericAxisBaseComponent._createFromInternal(this.i.fragmentYAxis);
            if (e) {
                e._implementation = this.i.fragmentYAxis;
            }
            this.i.fragmentYAxis.externalObject = e;
        }
        return this.i.fragmentYAxis.externalObject;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.fragmentXAxis && this.fragmentXAxis._styling) {
            this.fragmentXAxis._styling(container, component, this);
        }
        if (this.fragmentYAxis && this.fragmentYAxis._styling) {
            this.fragmentYAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
    /**
     * Gets the index of the item that resides at the provided world coordinates.
    
    * @param world  * The world coordinates of the requested item.
    */
    getItemIndex(world) {
        let iv = this.i.e8(toPoint(world));
        return (iv);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxColumnFragmentComponent.prototype, "radiusX", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxColumnFragmentComponent.prototype, "radiusY", null);
IgxColumnFragmentComponent = IgxColumnFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-column-fragment',
        template: ``,
        providers: [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxColumnFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxColumnFragmentComponent);

var IgxBarFragmentComponent_1;
/**
 * Represents one part of a StackedBarSeries.
*/
const IgxBarFragmentComponent_PROVIDERS = [{ provide: IgxColumnFragmentComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent) }];
let IgxBarFragmentComponent = IgxBarFragmentComponent_1 = class IgxBarFragmentComponent extends IgxColumnFragmentComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new BarFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * The X-Axis for this BarFragment.
    */
    get barFragmentXAxis() {
        if (this.i.barFragmentXAxis == null) {
            return null;
        }
        if (!this.i.barFragmentXAxis.externalObject) {
            let e = IgxNumericXAxisComponent._createFromInternal(this.i.barFragmentXAxis);
            if (e) {
                e._implementation = this.i.barFragmentXAxis;
            }
            this.i.barFragmentXAxis.externalObject = e;
        }
        return this.i.barFragmentXAxis.externalObject;
    }
    /**
     * The Y-Axis for this BarFragment.
    */
    get barFragmentYAxis() {
        if (this.i.barFragmentYAxis == null) {
            return null;
        }
        if (!this.i.barFragmentYAxis.externalObject) {
            let e = IgxCategoryYAxisComponent._createFromInternal(this.i.barFragmentYAxis);
            if (e) {
                e._implementation = this.i.barFragmentYAxis;
            }
            this.i.barFragmentYAxis.externalObject = e;
        }
        return this.i.barFragmentYAxis.externalObject;
    }
    _styling(container, component, parent) {
        super._styling(container, component, parent);
        this._inStyling = true;
        if (this.barFragmentXAxis && this.barFragmentXAxis._styling) {
            this.barFragmentXAxis._styling(container, component, this);
        }
        if (this.barFragmentYAxis && this.barFragmentYAxis._styling) {
            this.barFragmentYAxis._styling(container, component, this);
        }
        this._inStyling = false;
    }
    /**
     * Gets the precise item index, if possible, based on the closeness to the previous or next whole integer. If the series cannot provide this information, GetExactItemIndex will return the same integer value as GetItemIndex.
    
    * @param world  * The world position for which to return the index.
    */
    getExactItemIndex(world) {
        let iv = this.i.eb(toPoint(world));
        return (iv);
    }
    /**
     * If possible, will return the best available value bounding box within the series that has the best value match for the world position provided.
    
    * @param world  * The world coordinate for which to get a value bounding box for
    */
    getSeriesValueBoundingBox(world) {
        let iv = this.i.l4(toPoint(world));
        return fromRect(iv);
    }
    /**
     * Gets the item that is the best match for the specified world coordinates.
    
    * @param world  * The world coordinates to use.
    */
    getItem(world) {
        let iv = this.i.fp(toPoint(world));
        return (iv);
    }
};
IgxBarFragmentComponent = IgxBarFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-bar-fragment',
        template: ``,
        providers: [{ provide: IgxColumnFragmentComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxBarFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxBarFragmentComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBarFragmentModule = class IgxBarFragmentModule {
};
IgxBarFragmentModule = __decorate([
    NgModule({
        declarations: [IgxBarFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxBarFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxBarFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBarFragmentDynamicModule = class IgxBarFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBarFragmentComponent", IgxBarFragmentComponent);
        TypeRegistrar.register("BarFragment", BarFragment.$type);
    }
};
IgxBarFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBarFragmentModule],
        exports: [IgxBarFragmentModule],
        entryComponents: [IgxBarFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBarFragmentDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxColumnFragmentModule = class IgxColumnFragmentModule {
};
IgxColumnFragmentModule = __decorate([
    NgModule({
        declarations: [IgxColumnFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxColumnFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxColumnFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxColumnFragmentDynamicModule = class IgxColumnFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxColumnFragmentComponent", IgxColumnFragmentComponent);
        TypeRegistrar.register("ColumnFragment", ColumnFragment.$type);
    }
};
IgxColumnFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxColumnFragmentModule],
        exports: [IgxColumnFragmentModule],
        entryComponents: [IgxColumnFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxColumnFragmentDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxLineFragmentComponent_1;
/**
 * Represents one part of a StackedLineSeries.
*/
const IgxLineFragmentComponent_PROVIDERS = [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent) }];
let IgxLineFragmentComponent = IgxLineFragmentComponent_1 = class IgxLineFragmentComponent extends IgxFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new LineFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxLineFragmentComponent = IgxLineFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-line-fragment',
        template: ``,
        providers: [{ provide: IgxFragmentBaseComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxLineFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxLineFragmentComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLineFragmentModule = class IgxLineFragmentModule {
};
IgxLineFragmentModule = __decorate([
    NgModule({
        declarations: [IgxLineFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxLineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxLineFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLineFragmentDynamicModule = class IgxLineFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxLineFragmentComponent", IgxLineFragmentComponent);
        TypeRegistrar.register("LineFragment", LineFragment.$type);
    }
};
IgxLineFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxLineFragmentModule],
        exports: [IgxLineFragmentModule],
        entryComponents: [IgxLineFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxLineFragmentDynamicModule);

/**
 * Represents one part in a StackedSplineSeries or StackedSplineAreaSeries.
*/
const IgxSplineFragmentBaseComponent_PROVIDERS = [{ provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentBaseComponent) }];
class IgxSplineFragmentBaseComponent extends IgxSplineSeriesBaseComponent {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Gets whether the current series is a stack fragment.
    */
    get isFragment() {
        return this.i.cs;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxSplineFragmentComponent_1;
/**
 * Represents one part of a StackedSplineSeries.
*/
const IgxSplineFragmentComponent_PROVIDERS = [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent) }];
let IgxSplineFragmentComponent = IgxSplineFragmentComponent_1 = class IgxSplineFragmentComponent extends IgxSplineFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxSplineFragmentComponent = IgxSplineFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-spline-fragment',
        template: ``,
        providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSplineFragmentComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineFragmentModule = class IgxSplineFragmentModule {
};
IgxSplineFragmentModule = __decorate([
    NgModule({
        declarations: [IgxSplineFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxSplineFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxSplineFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineFragmentDynamicModule = class IgxSplineFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSplineFragmentComponent", IgxSplineFragmentComponent);
        TypeRegistrar.register("SplineFragment", SplineFragment.$type);
    }
};
IgxSplineFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSplineFragmentModule],
        exports: [IgxSplineFragmentModule],
        entryComponents: [IgxSplineFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSplineFragmentDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxSplineAreaFragmentComponent_1;
/**
 * Represents one part of a StackedSplineAreaSeries.
*/
const IgxSplineAreaFragmentComponent_PROVIDERS = [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent) }];
let IgxSplineAreaFragmentComponent = IgxSplineAreaFragmentComponent_1 = class IgxSplineAreaFragmentComponent extends IgxSplineFragmentBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new SplineAreaFragment();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets whether the current series shows an area or line shape.
    */
    get isAreaOrLine() {
        return this.i.ck;
    }
};
IgxSplineAreaFragmentComponent = IgxSplineAreaFragmentComponent_1 = __decorate([
    Component({
        selector: 'igx-spline-area-fragment',
        template: ``,
        providers: [{ provide: IgxSplineFragmentBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxSplineSeriesBaseComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxHorizontalAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxAnchoredCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxCategorySeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxMarkerSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }, { provide: IgxSeriesComponent, useExisting: forwardRef(() => IgxSplineAreaFragmentComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxSplineAreaFragmentComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineAreaFragmentModule = class IgxSplineAreaFragmentModule {
};
IgxSplineAreaFragmentModule = __decorate([
    NgModule({
        declarations: [IgxSplineAreaFragmentComponent],
        imports: [CommonModule, IgxHorizontalAnchoredCategorySeriesProxyModule],
        exports: [IgxSplineAreaFragmentComponent, IgxHorizontalAnchoredCategorySeriesProxyModule],
        entryComponents: []
    })
], IgxSplineAreaFragmentModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSplineAreaFragmentDynamicModule = class IgxSplineAreaFragmentDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxSplineAreaFragmentComponent", IgxSplineAreaFragmentComponent);
        TypeRegistrar.register("SplineAreaFragment", SplineAreaFragment.$type);
    }
};
IgxSplineAreaFragmentDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxSplineAreaFragmentModule],
        exports: [IgxSplineAreaFragmentModule],
        entryComponents: [IgxSplineAreaFragmentComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSplineAreaFragmentDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartStackedModule = class IgxDataChartStackedModule {
};
IgxDataChartStackedModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxStackedFragmentSeriesModule,
            IgxStacked100AreaSeriesModule,
            IgxStacked100BarSeriesModule,
            IgxStacked100ColumnSeriesModule,
            IgxStacked100LineSeriesModule,
            IgxStacked100SplineSeriesModule,
            IgxStacked100SplineAreaSeriesModule,
            IgxStackedAreaSeriesModule,
            IgxStackedBarSeriesModule,
            IgxStackedColumnSeriesModule,
            IgxStackedLineSeriesModule,
            IgxStackedSplineSeriesModule,
            IgxStackedSplineAreaSeriesModule,
            IgxAreaFragmentDynamicModule,
            IgxBarFragmentDynamicModule,
            IgxColumnFragmentDynamicModule,
            IgxLineFragmentDynamicModule,
            IgxSplineFragmentDynamicModule,
            IgxSplineAreaFragmentDynamicModule,
            IgxDataChartCategoryCoreModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        imports: [CommonModule, IgxStackedFragmentSeriesModule,
            IgxStacked100AreaSeriesModule,
            IgxStacked100BarSeriesModule,
            IgxStacked100ColumnSeriesModule,
            IgxStacked100LineSeriesModule,
            IgxStacked100SplineSeriesModule,
            IgxStacked100SplineAreaSeriesModule,
            IgxStackedAreaSeriesModule,
            IgxStackedBarSeriesModule,
            IgxStackedColumnSeriesModule,
            IgxStackedLineSeriesModule,
            IgxStackedSplineSeriesModule,
            IgxStackedSplineAreaSeriesModule,
            IgxAreaFragmentDynamicModule,
            IgxBarFragmentDynamicModule,
            IgxColumnFragmentDynamicModule,
            IgxLineFragmentDynamicModule,
            IgxSplineFragmentDynamicModule,
            IgxSplineAreaFragmentDynamicModule,
            IgxDataChartCategoryCoreModule,
            IgxDataChartVerticalCategoryCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartStackedModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartStackedDynamicModule = class IgxDataChartStackedDynamicModule {
};
IgxDataChartStackedDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxStackedFragmentSeriesDynamicModule,
            IgxStacked100AreaSeriesDynamicModule,
            IgxStacked100BarSeriesDynamicModule,
            IgxStacked100ColumnSeriesDynamicModule,
            IgxStacked100LineSeriesDynamicModule,
            IgxStacked100SplineSeriesDynamicModule,
            IgxStacked100SplineAreaSeriesDynamicModule,
            IgxStackedAreaSeriesDynamicModule,
            IgxStackedBarSeriesDynamicModule,
            IgxStackedColumnSeriesDynamicModule,
            IgxStackedLineSeriesDynamicModule,
            IgxStackedSplineSeriesDynamicModule,
            IgxStackedSplineAreaSeriesDynamicModule,
            IgxAreaFragmentDynamicModule,
            IgxBarFragmentDynamicModule,
            IgxColumnFragmentDynamicModule,
            IgxLineFragmentDynamicModule,
            IgxSplineFragmentDynamicModule,
            IgxSplineAreaFragmentDynamicModule,
            IgxDataChartCategoryCoreDynamicModule,
            IgxDataChartVerticalCategoryCoreDynamicModule,
            IgxDataChartStackedModule
        ],
        imports: [CommonModule, IgxStackedFragmentSeriesDynamicModule,
            IgxStacked100AreaSeriesDynamicModule,
            IgxStacked100BarSeriesDynamicModule,
            IgxStacked100ColumnSeriesDynamicModule,
            IgxStacked100LineSeriesDynamicModule,
            IgxStacked100SplineSeriesDynamicModule,
            IgxStacked100SplineAreaSeriesDynamicModule,
            IgxStackedAreaSeriesDynamicModule,
            IgxStackedBarSeriesDynamicModule,
            IgxStackedColumnSeriesDynamicModule,
            IgxStackedLineSeriesDynamicModule,
            IgxStackedSplineSeriesDynamicModule,
            IgxStackedSplineAreaSeriesDynamicModule,
            IgxAreaFragmentDynamicModule,
            IgxBarFragmentDynamicModule,
            IgxColumnFragmentDynamicModule,
            IgxLineFragmentDynamicModule,
            IgxSplineFragmentDynamicModule,
            IgxSplineAreaFragmentDynamicModule,
            IgxDataChartCategoryCoreDynamicModule,
            IgxDataChartVerticalCategoryCoreDynamicModule,
            IgxDataChartStackedModule
        ],
        entryComponents: []
    })
], IgxDataChartStackedDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialCoreModule = class IgxDataChartFinancialCoreModule {
};
IgxDataChartFinancialCoreModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxCategoryXAxisModule,
            IgxNumericYAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialCoreDynamicModule = class IgxDataChartFinancialCoreDynamicModule {
};
IgxDataChartFinancialCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartFinancialCoreModule
        ],
        imports: [CommonModule, IgxCategoryXAxisDynamicModule,
            IgxNumericYAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartFinancialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialModule = class IgxDataChartFinancialModule {
};
IgxDataChartFinancialModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxFinancialPriceSeriesModule,
            IgxDataChartFinancialCoreModule
        ],
        imports: [CommonModule, IgxFinancialPriceSeriesModule,
            IgxDataChartFinancialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialDynamicModule = class IgxDataChartFinancialDynamicModule {
};
IgxDataChartFinancialDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialModule
        ],
        imports: [CommonModule, IgxFinancialPriceSeriesDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartExtendedAxesModule = class IgxDataChartExtendedAxesModule {
};
IgxDataChartExtendedAxesModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryDateTimeXAxisModule,
            IgxTimeAxisBreakModule,
            IgxTimeAxisIntervalModule,
            IgxTimeAxisLabelFormatModule,
            IgxTimeXAxisModule,
            IgxOrdinalTimeXAxisModule,
            IgxDataChartCoreModule
        ],
        imports: [CommonModule, IgxCategoryDateTimeXAxisModule,
            IgxTimeAxisBreakModule,
            IgxTimeAxisIntervalModule,
            IgxTimeAxisLabelFormatModule,
            IgxTimeXAxisModule,
            IgxOrdinalTimeXAxisModule,
            IgxDataChartCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartExtendedAxesModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartExtendedAxesDynamicModule = class IgxDataChartExtendedAxesDynamicModule {
};
IgxDataChartExtendedAxesDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxCategoryDateTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartExtendedAxesModule
        ],
        imports: [CommonModule, IgxCategoryDateTimeXAxisDynamicModule,
            IgxTimeAxisBreakDynamicModule,
            IgxTimeAxisIntervalDynamicModule,
            IgxTimeAxisLabelFormatDynamicModule,
            IgxTimeXAxisDynamicModule,
            IgxOrdinalTimeXAxisDynamicModule,
            IgxDataChartCoreDynamicModule,
            IgxDataChartExtendedAxesModule
        ],
        entryComponents: []
    })
], IgxDataChartExtendedAxesDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialIndicatorsModule = class IgxDataChartFinancialIndicatorsModule {
};
IgxDataChartFinancialIndicatorsModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxIndicatorsModule,
            IgxDataChartFinancialCoreModule
        ],
        imports: [CommonModule, IgxIndicatorsModule,
            IgxDataChartFinancialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialIndicatorsModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialIndicatorsDynamicModule = class IgxDataChartFinancialIndicatorsDynamicModule {
};
IgxDataChartFinancialIndicatorsDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxIndicatorsDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialIndicatorsModule
        ],
        imports: [CommonModule, IgxIndicatorsDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialIndicatorsModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialIndicatorsDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialOverlaysModule = class IgxDataChartFinancialOverlaysModule {
};
IgxDataChartFinancialOverlaysModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxOverlaysModule,
            IgxDataChartFinancialCoreModule
        ],
        imports: [CommonModule, IgxOverlaysModule,
            IgxDataChartFinancialCoreModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialOverlaysModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartFinancialOverlaysDynamicModule = class IgxDataChartFinancialOverlaysDynamicModule {
};
IgxDataChartFinancialOverlaysDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxOverlaysDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialOverlaysModule
        ],
        imports: [CommonModule, IgxOverlaysDynamicModule,
            IgxDataChartFinancialCoreDynamicModule,
            IgxDataChartFinancialOverlaysModule
        ],
        entryComponents: []
    })
], IgxDataChartFinancialOverlaysDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisLabelVisualData extends Base {
    constructor() {
        super();
        this._labelValue = null;
        this._labelPosition = 0;
        this._position = null;
        this._panelPosition = null;
        this._appearance = null;
        this._size = null;
        this.position = new PointData(NaN, NaN);
        this.size = new SizeData(NaN, NaN);
        this.panelPosition = new PointData(NaN, NaN);
    }
    get labelValue() {
        return this._labelValue;
    }
    set labelValue(a) {
        this._labelValue = a;
    }
    get labelPosition() {
        return this._labelPosition;
    }
    set labelPosition(a) {
        this._labelPosition = a;
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get panelPosition() {
        return this._panelPosition;
    }
    set panelPosition(a) {
        this._panelPosition = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    get size() {
        return this._size;
    }
    set size(a) {
        this._size = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("position: " + "{ x: " + this.position.x + ", y: " + this.position.y + "},");
        a.u("size: " + "{ width: " + this.size.width + ", height: " + this.size.height + "},");
        a.u("labelPosition: " + this.labelPosition + ",");
        a.u("appearance: " + (this.appearance != null ? this.appearance.serialize() : "null"));
        a.u("}");
        return a.toString();
    }
    h(a, b) {
        if (b) {
            this.labelPosition = (this.labelPosition - a.left) / a.width;
        }
        else {
            this.labelPosition = (this.labelPosition - a.top) / a.height;
        }
        let c = (this.position.x - a.left) / a.width;
        let d = (this.position.y - a.top) / a.height;
        this.position = new PointData(c, d);
        let e = (this.size.width) / a.width;
        let f = (this.size.height) / a.height;
        this.size = new SizeData(e, f);
    }
}
AxisLabelVisualData.$t = markType(AxisLabelVisualData, 'AxisLabelVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisLabelVisualDataList extends List$1 {
    constructor() {
        super(AxisLabelVisualData.$, 0);
    }
}
AxisLabelVisualDataList.$t = markType(AxisLabelVisualDataList, 'AxisLabelVisualDataList', List$1.$.specialize(AxisLabelVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChartTitleVisualData extends Base {
    constructor() {
        super();
        this._viewport = null;
        this._textPlotArea = null;
        this._appearance = null;
        this.appearance = new LabelAppearanceData();
    }
    get width() {
        return this.viewport.width;
    }
    get height() {
        return this.viewport.height;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get textPlotArea() {
        return this._textPlotArea;
    }
    set textPlotArea(a) {
        this._textPlotArea = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("viewport: " + this.viewport.serialize() + ", ");
        a.u("textPlotArea: " + this.textPlotArea.serialize() + ", ");
        a.u("appearance: " + this.appearance.serialize());
        a.u("}");
        return a.toString();
    }
    h(a) {
        let b = (this.textPlotArea.left - a.left) / a.width;
        let c = (this.textPlotArea.top - a.top) / a.height;
        let d = this.textPlotArea.width / a.width;
        let e = this.textPlotArea.height / a.height;
        this.textPlotArea = new RectData(b, c, d, e);
    }
    g() {
        let a = (this.textPlotArea.left - this.viewport.left) / this.viewport.width;
        let b = (this.textPlotArea.top - this.viewport.top) / this.viewport.height;
        let c = this.textPlotArea.width / this.viewport.width;
        let d = this.textPlotArea.height / this.viewport.height;
        this.textPlotArea = new RectData(a, b, c, d);
    }
    j(a) {
        let b = this.textPlotArea.left * a.width;
        let c = this.textPlotArea.top * a.height;
        let d = this.textPlotArea.width * a.width;
        let e = this.textPlotArea.height * a.height;
        this.textPlotArea = new RectData(b, c, d, e);
    }
    i() {
        let a = this.textPlotArea.left * this.viewport.width;
        let b = this.textPlotArea.top * this.viewport.height;
        let c = this.textPlotArea.width * this.viewport.width;
        let d = this.textPlotArea.height * this.viewport.height;
        this.textPlotArea = new RectData(a, b, c, d);
    }
}
ChartTitleVisualData.$t = markType(ChartTitleVisualData, 'ChartTitleVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisVisualData extends Base {
    constructor() {
        super();
        this._name = null;
        this._type = null;
        this._viewport = null;
        this._tickMarksLength = 0;
        this._tickMarks = null;
        this._labels = null;
        this._axisLine = null;
        this._majorLines = null;
        this._minorLines = null;
        this._strips = null;
        this._labelsPlotArea = null;
        this._labelsViewport = null;
        this._title = null;
        this._annotationBackings = null;
        this.tickMarksLength = 0;
        this.labels = new AxisLabelVisualDataList();
        this.title = new ChartTitleVisualData();
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get type() {
        return this._type;
    }
    set type(a) {
        this._type = a;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get tickMarksLength() {
        return this._tickMarksLength;
    }
    set tickMarksLength(a) {
        this._tickMarksLength = a;
    }
    get tickMarks() {
        return this._tickMarks;
    }
    set tickMarks(a) {
        this._tickMarks = a;
    }
    get labels() {
        return this._labels;
    }
    set labels(a) {
        this._labels = a;
    }
    get axisLine() {
        return this._axisLine;
    }
    set axisLine(a) {
        this._axisLine = a;
    }
    get majorLines() {
        return this._majorLines;
    }
    set majorLines(a) {
        this._majorLines = a;
    }
    get minorLines() {
        return this._minorLines;
    }
    set minorLines(a) {
        this._minorLines = a;
    }
    get strips() {
        return this._strips;
    }
    set strips(a) {
        this._strips = a;
    }
    get labelsPlotArea() {
        return this._labelsPlotArea;
    }
    set labelsPlotArea(a) {
        this._labelsPlotArea = a;
    }
    get labelsViewport() {
        return this._labelsViewport;
    }
    set labelsViewport(a) {
        this._labelsViewport = a;
    }
    get title() {
        return this._title;
    }
    set title(a) {
        this._title = a;
    }
    get annotationBackings() {
        return this._annotationBackings;
    }
    set annotationBackings(a) {
        this._annotationBackings = a;
    }
    p() {
        let a = true;
        if (Base.equalsStatic(this.type, "NumericYAxis") || Base.equalsStatic(this.type, "CategoryYAxis") || Base.equalsStatic(this.type, "PercentChangeYAxis")) {
            a = false;
        }
        for (let b of fromEnum(this.labels)) {
            b.h(this.labelsViewport, a);
        }
        this.tickMarks.scaleByViewport(this.labelsViewport);
        this.axisLine.scaleByViewport(this.labelsViewport);
        if (this.title != null) {
            this.title.h(this.labelsViewport);
        }
        this.majorLines.scaleByViewport(this.viewport);
        this.minorLines.scaleByViewport(this.viewport);
        this.strips.scaleByViewport(this.viewport);
        if (this.annotationBackings != null) {
            for (let c of fromEnum(this.annotationBackings)) {
                c.scaleByViewport(this.labelsViewport);
            }
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\",");
        a.u("type: \"" + this.type + "\", ");
        a.u("tickMarksLength: \"" + this.tickMarksLength.toString() + "\", ");
        a.u("viewport: " + this.viewport.serialize() + ", ");
        a.u("labelsViewport: " + this.labelsViewport.serialize() + ", ");
        if (this.labelsPlotArea != null) {
            a.u("labelsPlotArea: " + this.labelsPlotArea.serialize() + ", ");
        }
        a.u("labels: [");
        for (let b = 0; b < this.labels.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.labels._inner[b].serialize());
        }
        a.u("],");
        if (this.title != null) {
            a.u("title: " + ((this.title != null) ? this.title.serialize() : "null") + ", ");
        }
        a.u("axisLine: " + ((this.axisLine != null) ? this.axisLine.serialize() : "null") + ", ");
        a.u("tickMarks: " + ((this.tickMarks != null) ? this.tickMarks.serialize() : "null") + ", ");
        if (this.annotationBackings != null) {
            a.u("annotationBackings: [");
            for (let c = 0; c < this.annotationBackings.count; c++) {
                if (c != 0) {
                    a.l(", ");
                }
                a.l(this.annotationBackings._inner[c].serialize());
            }
            a.u("],");
        }
        if (this.axisLine != null) {
            a.u("majorLines: " + ((this.majorLines != null) ? this.majorLines.serialize() : "null") + ", ");
            a.u("minorLines: " + ((this.minorLines != null) ? this.minorLines.serialize() : "null") + ", ");
            a.u("strips: " + ((this.strips != null) ? this.strips.serialize() : "null"));
        }
        a.u("}");
        return a.toString();
    }
}
AxisVisualData.$t = markType(AxisVisualData, 'AxisVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisVisualDataList extends List$1 {
    constructor() {
        super(AxisVisualData.$, 0);
    }
}
AxisVisualDataList.$t = markType(AxisVisualDataList, 'AxisVisualDataList', List$1.$.specialize(AxisVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PointerTooltipVisualData extends Base {
    constructor() {
        super(...arguments);
        this._boxShape = null;
        this._pointerFillShape = null;
        this._pointerOutlineShape = null;
        this._offsetX = 0;
        this._offsetY = 0;
        this._categoryNames = null;
        this._viewport = null;
    }
    get boxShape() {
        return this._boxShape;
    }
    set boxShape(a) {
        this._boxShape = a;
    }
    get pointerFillShape() {
        return this._pointerFillShape;
    }
    set pointerFillShape(a) {
        this._pointerFillShape = a;
    }
    get pointerOutlineShape() {
        return this._pointerOutlineShape;
    }
    set pointerOutlineShape(a) {
        this._pointerOutlineShape = a;
    }
    get offsetX() {
        return this._offsetX;
    }
    set offsetX(a) {
        this._offsetX = a;
    }
    get offsetY() {
        return this._offsetY;
    }
    set offsetY(a) {
        this._offsetY = a;
    }
    get categoryNames() {
        return this._categoryNames;
    }
    set categoryNames(a) {
        this._categoryNames = a;
    }
    serialize() {
        let a = "";
        if (this.categoryNames != null) {
            for (let b of fromEnum(this.categoryNames)) {
                a += "\"" + b + "\",";
            }
            if (a != "") {
                a = a.substr(0, a.length - 1);
            }
        }
        let c = new StringBuilder(0);
        c.u("{");
        c.u("offsetX: " + this.offsetX + ", ");
        c.u("offsetY: " + this.offsetY + ", ");
        c.u("boxShape: " + this.boxShape.serialize() + ", ");
        c.u("pointerFillShape: " + this.pointerFillShape.serialize() + ", ");
        c.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
        c.u("pointerOutlineShape: " + this.pointerOutlineShape.serialize() + ", ");
        c.u("categoryNames: [" + a + "]");
        c.u("}");
        return c.toString();
    }
    scaleByViewport(a) {
        this.boxShape.scaleByViewport(this.viewport);
        this.pointerFillShape.scaleByViewport(this.viewport);
        this.pointerOutlineShape.scaleByViewport(this.viewport);
        this.offsetX = (this.offsetX - a.left) / a.width;
        this.offsetY = (this.offsetY - a.top) / a.height;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
}
PointerTooltipVisualData.$t = markType(PointerTooltipVisualData, 'PointerTooltipVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PointerTooltipVisualDataList extends List$1 {
    constructor() {
        super(PointerTooltipVisualData.$, 0);
    }
}
PointerTooltipVisualDataList.$t = markType(PointerTooltipVisualDataList, 'PointerTooltipVisualDataList', List$1.$.specialize(PointerTooltipVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerVisualDataList extends List$1 {
    constructor() {
        super(MarkerVisualData.$, 0);
    }
}
MarkerVisualDataList.$t = markType(MarkerVisualDataList, 'MarkerVisualDataList', List$1.$.specialize(MarkerVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutVisualData extends Base {
    constructor() {
        super(...arguments);
        this._background = null;
        this._text = null;
        this._line = null;
        this._left = 0;
        this._top = 0;
        this._marginLeft = 0;
        this._marginTop = 0;
    }
    get background() {
        return this._background;
    }
    set background(a) {
        this._background = a;
    }
    get text() {
        return this._text;
    }
    set text(a) {
        this._text = a;
    }
    get line() {
        return this._line;
    }
    set line(a) {
        this._line = a;
    }
    get left() {
        return this._left;
    }
    set left(a) {
        this._left = a;
    }
    get top() {
        return this._top;
    }
    set top(a) {
        this._top = a;
    }
    get marginLeft() {
        return this._marginLeft;
    }
    set marginLeft(a) {
        this._marginLeft = a;
    }
    get marginTop() {
        return this._marginTop;
    }
    set marginTop(a) {
        this._marginTop = a;
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("left: " + this.left.toString() + ",");
        a.u("top: " + this.top.toString() + ",");
        a.u("marginLeft: " + this.marginLeft.toString() + ",");
        a.u("marginTop: " + this.marginTop.toString() + ",");
        a.u("background: " + this.background.serialize() + ",");
        a.u("text: " + this.text.serialize() + ",");
        a.u("line: " + this.line.serialize());
        a.u("}");
        return a.toString();
    }
    scaleByViewport(a) {
        this.left = (this.left - a.left) / a.width;
        this.top = (this.top - a.top) / a.height;
        this.marginLeft = this.marginLeft / a.width;
        this.marginTop = this.marginTop / a.height;
        this.background.scaleByViewport(a);
        this.line.scaleByViewport(a);
    }
}
CalloutVisualData.$t = markType(CalloutVisualData, 'CalloutVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CalloutVisualDataList extends List$1 {
    constructor() {
        super(CalloutVisualData.$, 0);
    }
}
CalloutVisualDataList.$t = markType(CalloutVisualDataList, 'CalloutVisualDataList', List$1.$.specialize(CalloutVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesVisualData extends Base {
    constructor() {
        super();
        this._name = null;
        this._type = null;
        this._viewport = null;
        this._opacity = 0;
        this._shapes = null;
        this._pointerTooltips = null;
        this._markerShapes = null;
        this._calloutShapes = null;
        this._pixels = null;
        this._pixelWidth = 0;
        this._pixelHeight = 0;
        this.shapes = new PrimitiveVisualDataList();
        this.markerShapes = new MarkerVisualDataList();
        this.pointerTooltips = new PointerTooltipVisualDataList();
        this.calloutShapes = new CalloutVisualDataList();
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get type() {
        return this._type;
    }
    set type(a) {
        this._type = a;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get opacity() {
        return this._opacity;
    }
    set opacity(a) {
        this._opacity = a;
    }
    get shapes() {
        return this._shapes;
    }
    set shapes(a) {
        this._shapes = a;
    }
    get pointerTooltips() {
        return this._pointerTooltips;
    }
    set pointerTooltips(a) {
        this._pointerTooltips = a;
    }
    get markerShapes() {
        return this._markerShapes;
    }
    set markerShapes(a) {
        this._markerShapes = a;
    }
    get calloutShapes() {
        return this._calloutShapes;
    }
    set calloutShapes(a) {
        this._calloutShapes = a;
    }
    get pixels() {
        return this._pixels;
    }
    set pixels(a) {
        this._pixels = a;
    }
    get pixelWidth() {
        return this._pixelWidth;
    }
    set pixelWidth(a) {
        this._pixelWidth = a;
    }
    get pixelHeight() {
        return this._pixelHeight;
    }
    set pixelHeight(a) {
        this._pixelHeight = a;
    }
    m() {
        for (let a of fromEnum(this.shapes)) {
            a.scaleByViewport(this.viewport);
        }
        for (let b of fromEnum(this.markerShapes)) {
            b.i(this.viewport);
        }
        for (let c of fromEnum(this.pointerTooltips)) {
            c.scaleByViewport(this.viewport);
        }
        for (let d of fromEnum(this.calloutShapes)) {
            d.scaleByViewport(this.viewport);
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\",");
        a.u("type: \"" + this.type + "\", ");
        a.u("opacity: " + this.opacity + ", ");
        a.u("viewport: { left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height + "}, ");
        a.u("shapes: [");
        for (let b = 0; b < this.shapes.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.shapes._inner[b].serialize());
        }
        a.u("],");
        a.u("pointerTooltips: [");
        for (let c = 0; c < this.pointerTooltips.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.pointerTooltips._inner[c].serialize());
        }
        a.u("],");
        if (this.calloutShapes != null && this.calloutShapes.count > 0) {
            a.u("calloutshapes: [");
            for (let d = 0; d < this.calloutShapes.count; d++) {
                if (d != 0) {
                    a.l(", ");
                }
                a.l(this.calloutShapes._inner[d].serialize());
            }
            a.u("],");
        }
        a.u("markerShapes: [");
        for (let e = 0; e < this.markerShapes.count; e++) {
            if (e != 0) {
                a.l(", ");
            }
            a.l(this.markerShapes._inner[e].serialize());
        }
        a.u("]");
        if (this.pixels != null) {
            a.u(", pixels: [");
            for (let f = 0; f < this.pixels.length; f++) {
                if (f != 0) {
                    a.l(", ");
                }
                a.l(this.pixels[f].toString());
            }
            a.u("], ");
            a.u("pixelWidth: " + this.pixelWidth + ", ");
        }
        a.u("}");
        return a.toString();
    }
}
SeriesVisualData.$t = markType(SeriesVisualData, 'SeriesVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesVisualDataList extends List$1 {
    constructor() {
        super(SeriesVisualData.$, 0);
    }
}
SeriesVisualDataList.$t = markType(SeriesVisualDataList, 'SeriesVisualDataList', List$1.$.specialize(SeriesVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChartVisualData extends Base {
    constructor() {
        super();
        this._axes = null;
        this._series = null;
        this._title = null;
        this._subtitle = null;
        this._width = 0;
        this._height = 0;
        this._contentArea = null;
        this._centralArea = null;
        this._plotArea = null;
        this._name = null;
        this._isViewportScaled = false;
        this._dipScalingRatio = 0;
        this.dipScalingRatio = 1;
        this.axes = new AxisVisualDataList();
        this.series = new SeriesVisualDataList();
    }
    get axes() {
        return this._axes;
    }
    set axes(a) {
        this._axes = a;
    }
    get series() {
        return this._series;
    }
    set series(a) {
        this._series = a;
    }
    get title() {
        return this._title;
    }
    set title(a) {
        this._title = a;
    }
    get subtitle() {
        return this._subtitle;
    }
    set subtitle(a) {
        this._subtitle = a;
    }
    get width() {
        return this._width;
    }
    set width(a) {
        this._width = a;
    }
    get height() {
        return this._height;
    }
    set height(a) {
        this._height = a;
    }
    get contentArea() {
        return this._contentArea;
    }
    set contentArea(a) {
        this._contentArea = a;
    }
    get centralArea() {
        return this._centralArea;
    }
    set centralArea(a) {
        this._centralArea = a;
    }
    get plotArea() {
        return this._plotArea;
    }
    set plotArea(a) {
        this._plotArea = a;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get isViewportScaled() {
        return this._isViewportScaled;
    }
    set isViewportScaled(a) {
        this._isViewportScaled = a;
    }
    scaleByViewport() {
        for (let a of fromEnum(this.axes)) {
            a.p();
        }
        for (let b of fromEnum(this.series)) {
            b.m();
        }
        if (this.title != null) {
            this.title.g();
        }
        if (this.subtitle != null) {
            this.subtitle.g();
        }
    }
    getBounds() {
        return new RectData(0, 0, this.width, this.height);
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: '" + this.name + "',");
        a.u("width: " + this.width + ",");
        a.u("height: " + this.height + ",");
        a.u("plotArea: { left: " + this.plotArea.left + ", top: " + this.plotArea.top + ", width: " + this.plotArea.width + ", height: " + this.plotArea.height + "}, ");
        a.u("contentArea: { left: " + this.contentArea.left + ", top: " + this.contentArea.top + ", width: " + this.contentArea.width + ", height: " + this.contentArea.height + "}, ");
        a.u("centralArea: { left: " + this.centralArea.left + ", top: " + this.centralArea.top + ", width: " + this.centralArea.width + ", height: " + this.centralArea.height + "}, ");
        a.u("isViewportScaled: " + (this.isViewportScaled ? "true" : "false") + ", ");
        a.u("axes: [");
        for (let b = 0; b < this.axes.count; b++) {
            if (b != 0) {
                a.l(", ");
            }
            a.l(this.axes._inner[b].serialize());
        }
        a.u("],");
        a.u("series: [");
        for (let c = 0; c < this.series.count; c++) {
            if (c != 0) {
                a.l(", ");
            }
            a.l(this.series._inner[c].serialize());
        }
        a.u("]");
        if (this.title != null) {
            a.u(", title: " + this.title.serialize());
        }
        if (this.subtitle != null) {
            a.u(", subtitle: " + this.subtitle.serialize());
        }
        a.l(", dipScalingRatio: " + this.dipScalingRatio.toString());
        a.u("}");
        return a.toString();
    }
    getSerializedSeriesPoints(a, b, c) {
        let d = new List$1(List$1.$.specialize(PointData.$), 0);
        for (let e = 0; e < this.series.count; e++) {
            if (this.series._inner[e].name == a) {
                let f = this.series._inner[e].shapes.containingTag(b);
                for (let g = 0; g < f.count; g++) {
                    let h = f._inner[e];
                    h.getPointsOverride(d, c);
                }
            }
        }
        let i = new StringBuilder(0);
        i.u("[");
        for (let j = 0; j < d.count; j++) {
            let k = d._inner[j];
            i.u("[");
            for (let l = 0; l < k.count; l++) {
                if (l != 0) {
                    i.l(", ");
                }
                i.l("{ x: " + k._inner[l].x + ", y: " + k._inner[l].y + "}");
            }
            i.u("]");
        }
        i.u("]");
        return i.toString();
    }
    get dipScalingRatio() {
        return this._dipScalingRatio;
    }
    set dipScalingRatio(a) {
        this._dipScalingRatio = a;
    }
}
ChartVisualData.$t = markType(ChartVisualData, 'ChartVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VisualExportHelper extends Base {
    static a(a) {
        let b = { $type: Point_$type, x: a.n, y: a.o };
        let c = new Rect(0, b.x, b.y, a.m, a.l);
        let d = a.j;
        if (d == null) {
            return c;
        }
        let e = 0;
        let f = 0;
        let g = 0;
        let h = null;
        if (typeCast(RotateTransform.$, d) !== null) {
            h = typeCast(RotateTransform.$, d);
            e = h.j;
        }
        else if (typeCast(TransformGroup.$, d) !== null) {
            let i = typeCast(TransformGroup.$, d);
            for (let j of fromEnum(i.j)) {
                if (typeCast(RotateTransform.$, j) !== null) {
                    h = typeCast(RotateTransform.$, j);
                    e = h.j;
                }
                if (typeCast(TranslateTransform.$, j) !== null) {
                    let k = typeCast(TranslateTransform.$, j);
                    f = k.j;
                    g = k.k;
                }
            }
        }
        if (h != null) {
            c = RectUtil.x(c, h.k, h.l, e);
        }
        c.x = c.x + f;
        c.y = c.y + g;
        return c;
    }
}
VisualExportHelper.$t = markType(VisualExportHelper, 'VisualExportHelper');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DataChartVisualDataManager extends Base {
    exportVisualData(a) {
        let b = new ChartVisualData();
        for (let c = 0; c < a.axes.count; c++) {
            let d = a.axes._inner[c].e5();
            b.axes.add1(d);
        }
        for (let e = 0; e < a.series.count; e++) {
            let f = a.series._inner[e].fo();
            b.series.add1(f);
        }
        b.name = a.name;
        this.b(a, b);
        this.c(a, b);
        return b;
    }
    c(a, b) {
        let c = a.b1;
        b.width = c.a6;
        b.height = c.a5;
        b.contentArea = RectData.b(c.e6());
        b.centralArea = new RectData(c.a2, 0, c.a6 - (c.a2 + c.a3), c.a5 - (c.a4 + c.a1));
        b.plotArea = RectData.b(a.oh);
    }
    d(a, b) {
        let c = VisualExportHelper.a(a);
        return c;
    }
    b(a, b) {
        let c = a.b1;
        let d = null;
        b.title = null;
        b.subtitle = null;
        let e = c.fe();
        let f = 0;
        let g = 0;
        if (c.eq != null) {
            d = c.t();
            let h = this.a(c, c.eq, d);
            let i = { $type: Point_$type, x: 0, y: 0 };
            g = c.eq.l + e.b + e.e;
            let j = new ChartTitleVisualData();
            let k = c.e6();
            j.viewport = new RectData(k.left, k.top, k.width, g);
            j.textPlotArea = RectData.b(this.d(c.eq, a));
            j.textPlotArea = new RectData(c.eq.n, c.eq.o, c.eq.m, c.eq.l);
            f = j.height;
            j.appearance = AppearanceHelper.c(c.eq, h);
            let l = c.fe();
            j.appearance.marginTop = l.e;
            j.appearance.marginLeft = l.c;
            j.appearance.marginRight = l.d;
            j.appearance.marginBottom = l.b;
            let m = c.es();
            j.appearance.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, m);
            b.title = j;
        }
        if (c.ep != null) {
            d = c.s();
            let n = this.a(c, c.ep, d);
            let o = { $type: Point_$type, x: 0, y: f };
            let p = c.fd();
            let q = c.ep.l + p.b + p.e;
            let r = new ChartTitleVisualData();
            let s = c.e6();
            r.viewport = new RectData(s.left, s.top + g, s.width, q);
            r.textPlotArea = RectData.b(this.d(c.ep, a));
            r.appearance = AppearanceHelper.c(c.ep, n);
            let t = c.fd();
            r.appearance.marginTop = t.e;
            r.appearance.marginLeft = t.c;
            r.appearance.marginRight = t.d;
            r.appearance.marginBottom = t.b;
            let u = c.er();
            r.appearance.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, u);
            b.subtitle = r;
        }
    }
    a(a, b, c) {
        return FontUtil.getFontInfo(a.i.ae, b, c);
    }
}
DataChartVisualDataManager.$t = markType(DataChartVisualDataManager, 'DataChartVisualDataManager', Base.$, [IDataChartVisualDataManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisVisualDataManager extends Base {
    c(a) {
        return a;
    }
    d(a, b) {
        let c = VisualExportHelper.a(b);
        return c;
    }
    a(a, b, c, d) {
        let e = new ChartTitleVisualData();
        let f = a.a4;
        let g = f.a6();
        e.viewport = RectData.b(g);
        let h = this.d(a, d);
        e.textPlotArea = RectData.b(h);
        let i = d._visibility == 0 && d.x != null;
        let j = a.av.ae.d();
        let k = f.bd(d);
        let l = this.b(a, d, j);
        let m = AppearanceHelper.c(d, l);
        m.marginLeft = k.c;
        m.marginRight = k.d;
        m.marginTop = k.e;
        m.marginBottom = k.b;
        m.fontStretch = "Normal";
        m.textWrapping = "Wrap";
        m.visibility = i;
        if (a.be != null) {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, a.be.horizontalAlignment);
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, a.be.verticalAlignment);
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, a.be.position);
        }
        else {
            m.horizontalAlignment = EnumUtil.getName(HorizontalAlignment_$type, (0));
            m.verticalAlignment = EnumUtil.getName(VerticalAlignment_$type, (1));
            m.textPosition = EnumUtil.getName(AxisTitlePosition_$type, (0));
        }
        e.appearance = m;
        return e;
    }
    exportVisualData(a) {
        let b = new AxisVisualData();
        b.viewport = RectData.b(a.i9);
        b.labelsViewport = RectData.b(a.a4.a6());
        b.type = this.c(getInstanceType(a).typeName);
        b.name = a.name;
        let c = new PathVisualData(1, "axisLine", a.a4.a7);
        b.axisLine = c;
        b.tickMarks = new PathVisualData(1, "tickMarks", a.av.ae.av);
        if (!a.av.ab.contains(a.av.ae.av)) {
            b.tickMarks.data.clear();
        }
        b.minorLines = new PathVisualData(1, "minorLines", a.a4.a9);
        b.majorLines = new PathVisualData(1, "majorLines", a.a4.a8);
        b.strips = new PathVisualData(1, "strips", a.a4.ba);
        if (a.gc != null) {
            let d = this.a(a, a.bh, b.type, a.hq);
            b.title = d;
        }
        else {
            b.title = null;
        }
        let e = a.bh.getFontInfo();
        if (a.ay != null && a.ay.textStyle != null) {
            e = a.ay.g(a.bh.b1.i.ae);
        }
        let f, g, h, i;
        let j = a.av.ae.av.ak.d;
        for (let k = 1; k < j.count; k++) {
            let l = j._inner[k];
            let m = j._inner[k - 1];
            f = l.d.x - l.c.x;
            g = l.d.y - l.c.y;
            h = m.d.x - m.c.x;
            i = m.d.y - m.c.y;
            if (1 == k) {
                b.tickMarksLength = Math.sqrt(Math.pow(f, 2) + Math.pow(g, 2));
            }
        }
        let n = a.av.a3;
        let o = a.av.ae.g();
        for (let p = 0; p < n.count; p++) {
            let q = a.av.a3._inner[p];
            let r = a.av.a2._inner[p];
            let s = ((() => {
                let $ret = new AxisLabelVisualData();
                $ret.labelPosition = q.c;
                $ret.labelValue = r;
                $ret.panelPosition = PointData.b(a.a4.a3());
                return $ret;
            })());
            let t = new List$1(TextBlock.$, 0);
            for (let u of fromEnum(o)) {
                t.add(u);
            }
            if (p < t.count) {
                let v = this.b(a, t._inner[p], e);
                s.appearance = AppearanceHelper.c(t._inner[p], v);
                s.position = PointData.b(a.a4.a2(t._inner[p]));
                s.size = SizeData.b(new Size(1, t._inner[p].m, t._inner[p].l));
            }
            b.labels.add(s);
        }
        let w = null;
        for (let x = 0; x < a.bo.a.count; x++) {
            if (w == null) {
                w = new List$1(RectangleVisualData.$, 0);
            }
            let y = new RectangleVisualData(1, "annotationBacking_" + x, a.bo.item(x));
            y.appearance.canvasLeft = a.bo.item(x).n;
            y.appearance.canvasTop = a.bo.item(x).o;
            w.add(y);
        }
        b.annotationBackings = w;
        return b;
    }
    b(a, b, c) {
        return FontUtil.getFontInfo(a.bh.b1.i.ae, b, c);
    }
}
AxisVisualDataManager.$t = markType(AxisVisualDataManager, 'AxisVisualDataManager', Base.$, [IAxisVisualDataManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class StackedSeriesVisualData extends SeriesVisualData {
    constructor() {
        super();
        this._fragmentSeries = null;
        this.fragmentSeries = new SeriesVisualDataList();
    }
    get fragmentSeries() {
        return this._fragmentSeries;
    }
    set fragmentSeries(a) {
        this._fragmentSeries = a;
    }
}
StackedSeriesVisualData.$t = markType(StackedSeriesVisualData, 'StackedSeriesVisualData', SeriesVisualData.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesVisualDataManager extends Base {
    addSubSeriesVisualData(a, b) {
        let c = a;
        let d = b;
        c.fragmentSeries.add(d);
    }
    copyVisualData(a, b) {
        let c = a;
        let d = b;
        for (let e of fromEnum(d.shapes)) {
            c.shapes.add(e);
        }
        for (let f of fromEnum(d.markerShapes)) {
            c.markerShapes.add(f);
        }
        c.pixels = d.pixels;
        c.pixelWidth = d.pixelWidth;
    }
    createFragmentVisualData(a, b, c, d) {
        let e = new SeriesVisualData();
        e.viewport = RectData.b(b);
        e.type = c;
        e.name = d;
        return e;
    }
    exportMarkerVisualData(a, b) {
        let c = b;
        a.ma.cc((d) => {
            let e = this.getMarkerVisualData(a, d, a.mv);
            c.markerShapes.add(typeCast(MarkerVisualData.$, e));
        });
    }
    getMarkerVisualData(a, b, c) {
        let d = new MarkerVisualData();
        let e = new PrimitiveAppearanceData();
        d.x = b.n;
        d.y = b.o;
        d.bounds = new RectData(b.n - (b.m / 2), b.o - (b.l / 2), b.m, b.l);
        e.fill = ColorData.a_1(Color.u(0, 0, 0, 0));
        e.stroke = ColorData.a_1(Color.u(0, 0, 0, 0));
        d.index = -1;
        d.contentTemplate = b.ah;
        if (b.content != null && typeCast(DataContext.$, b.content) !== null && b._visibility == 0) {
            let f = b.content;
            e.fill = AppearanceHelper.b(f.actualItemBrush);
            e.fillExtended = AppearanceHelper.a(f.actualItemBrush);
            e.stroke = AppearanceHelper.b(f.outline);
            e.strokeExtended = AppearanceHelper.a(f.outline);
            e.strokeThickness = a.ey;
            if (f.item != null) {
                d.index = a.bz.indexOf(f.item);
            }
        }
        e.isVisible = b._visibility == 0;
        d.isVisible = b._visibility == 0;
        d.markerAppearance = e;
        d.markerType = this.a(a, c);
        return d;
    }
    a(a, b) {
        if (b == a.bs.ls) {
            return "Circle";
        }
        else if (b == a.bs.lt) {
            return "Diamond";
        }
        else if (b == a.bs.lu) {
            return "Hexagon";
        }
        else if (b == a.bs.lv) {
            return "Hexagram";
        }
        else if (b == a.bs.lw) {
            return "Pentagon";
        }
        else if (b == a.bs.lx) {
            return "Pentagram";
        }
        else if (b == a.bs.ly) {
            return "Pyramid";
        }
        else if (b == a.bs.lz) {
            return "Square";
        }
        else if (b == a.bs.l0) {
            return "Tetragram";
        }
        else if (b == a.bs.l1) {
            return "Triangle";
        }
        else {
            return "None";
        }
    }
    exportMarkerVisualDataFromMarker(a, b, c) {
        let d = b;
        let e = new MarkerVisualData();
        let f = new PrimitiveAppearanceData();
        e.x = c.n;
        e.y = c.o;
        e.bounds = new RectData(c.n - (c.m / 2), c.o - (c.l / 2), c.m, c.l);
        e.index = -1;
        e.contentTemplate = c.ah;
        if (typeCast(DataContext.$, c.content) !== null) {
            let g = c.content;
            f.fill = AppearanceHelper.b(g.actualItemBrush);
            f.stroke = AppearanceHelper.b(g.outline);
        }
        e.isVisible = c._visibility == 0;
        e.markerAppearance = f;
        if (c.ah == a.bs.ls) {
            e.markerType = "Circle";
        }
        else if (c.ah == a.bs.lt) {
            e.markerType = "Diamond";
        }
        else if (c.ah == a.bs.lu) {
            e.markerType = "Hexagon";
        }
        else if (c.ah == a.bs.lv) {
            e.markerType = "Hexagram";
        }
        else if (c.ah == a.bs.lw) {
            e.markerType = "Pentagon";
        }
        else if (c.ah == a.bs.lx) {
            e.markerType = "Pentagram";
        }
        else if (c.ah == a.bs.ly) {
            e.markerType = "Pyramid";
        }
        else if (c.ah == a.bs.lz) {
            e.markerType = "Square";
        }
        else if (c.ah == a.bs.l0) {
            e.markerType = "Tetragram";
        }
        else if (c.ah == a.bs.l1) {
            e.markerType = "Triangle";
        }
        else {
            e.markerType = "None";
        }
        d.markerShapes.add(e);
    }
    exportPathData(a, b, c, d) {
        let e = a;
        let f = new PathVisualData(1, c, b);
        if (d != null) {
            for (let g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    }
    exportPolygonData(a, b, c, d) {
        let e = a;
        let f = new PolygonVisualData(1, c, b);
        if (d != null) {
            for (let g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    }
    exportPolylineData(a, b, c, d) {
        let e = a;
        let f = new PolyLineVisualData(1, c, b);
        if (d != null) {
            for (let g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    }
    exportRectangleData(a, b, c, d) {
        let e = a;
        let f = new RectangleVisualData(1, c, b);
        if (d != null) {
            for (let g = 0; g < d.length; g++) {
                f.tags.add(d[g]);
            }
        }
        e.shapes.add(f);
    }
    exportStackedVisualData(a, b) {
        let c = new StackedSeriesVisualData();
        c.viewport = RectData.b(b);
        c.type = getInstanceType(a).typeName;
        c.name = a.name;
        return c;
    }
    exportTrendlineData(a, b, c) {
        let d = b;
        let e = new PolyLineVisualData(1, "trendLine", c);
        e.tags.add("Trend");
        d.shapes.add(e);
    }
    exportVisualData(a, b) {
        let c = new SeriesVisualData();
        c.viewport = RectData.b(b);
        c.type = this.b(getInstanceType(a).typeName);
        c.name = a.name;
        c.opacity = a._opacity;
        return c;
    }
    exportSeriesPixelsData(a, b, c, d) {
        let e = a;
        e.pixels = b;
        e.pixelWidth = c;
        e.pixelHeight = d;
    }
    b(a) {
        return a;
    }
    addPointerTooltipData(a, b, c, d, e) {
        if (b == null) {
            return;
        }
        let f = a;
        let g = b;
        g.offsetX = c;
        g.offsetY = d;
        g.categoryNames = e;
        f.pointerTooltips.add(g);
    }
    exportPointerTooltipData(a, b, c, d) {
        let e = new PointerTooltipVisualData();
        e.pointerFillShape = new PolygonVisualData(1, "fillShape", a);
        e.pointerOutlineShape = new PolyLineVisualData(1, "outlineShape", b);
        e.boxShape = new RectangleVisualData(1, "boxShape", c);
        e.viewport = RectData.b(d);
        return e;
    }
    exportCalloutData(a, b, c, d, e, f, g, h, i, j, k) {
        let l = new CalloutVisualData();
        l.left = a;
        l.top = b;
        l.marginLeft = c;
        l.marginTop = d;
        l.background = new RectangleVisualData(1, "calloutBackground", f);
        l.text = AppearanceHelper.c(g, h);
        l.line = new LineVisualData(1, "calloutLeaderLine", i);
        e.calloutShapes.add(l);
    }
}
SeriesVisualDataManager.$t = markType(SeriesVisualDataManager, 'SeriesVisualDataManager', Base.$, [ISeriesVisualDataManager_$type]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VisualDataFactoryManager extends Base {
    static register() {
        if (!VisualDataFactoryManager.a) {
            DVContainer.instance.registerFactory(IDataChartVisualDataManager_$type, () => new DataChartVisualDataManager());
            DVContainer.instance.registerFactory(IAxisVisualDataManager_$type, () => new AxisVisualDataManager());
            DVContainer.instance.registerFactory(ISeriesVisualDataManager_$type, () => new SeriesVisualDataManager());
            VisualDataFactoryManager.a = true;
        }
    }
}
VisualDataFactoryManager.$t = markType(VisualDataFactoryManager, 'VisualDataFactoryManager');
VisualDataFactoryManager.a = false;

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVisualDataModule = class IgxDataChartVisualDataModule {
    constructor() {
        TypeRegistrar.register('VisualDataFactoryManager', VisualDataFactoryManager.$type);
        VisualDataFactoryManager.register();
    }
};
IgxDataChartVisualDataModule = __decorate([
    NgModule({
        declarations: [],
        exports: [],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartVisualDataModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxDataChartVisualDataDynamicModule = class IgxDataChartVisualDataDynamicModule {
    constructor() {
        TypeRegistrar.register('VisualDataFactoryManager', VisualDataFactoryManager.$type);
        VisualDataFactoryManager.register();
    }
};
IgxDataChartVisualDataDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxDataChartVisualDataModule
        ],
        imports: [CommonModule, IgxDataChartVisualDataModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxDataChartVisualDataDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISeriesViewerWidgetOptions_$type = new Type(null, 'ISeriesViewerWidgetOptions');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ISeriesViewerWidget_$type = new Type(null, 'ISeriesViewerWidget');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumeration of options for the usage of the surface.
 */
var ViewerSurfaceUsage;
(function (ViewerSurfaceUsage) {
    /**
     * Normal surface usage.
     */
    ViewerSurfaceUsage[ViewerSurfaceUsage["Normal"] = 0] = "Normal";
    /**
     * Minimal surface usage.
     */
    ViewerSurfaceUsage[ViewerSurfaceUsage["Minimal"] = 1] = "Minimal";
})(ViewerSurfaceUsage || (ViewerSurfaceUsage = {}));
/**
 * @hidden
 */
let ViewerSurfaceUsage_$type = markEnum('ViewerSurfaceUsage', 'Normal,0|Minimal,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DataSourceManager extends Base {
    constructor() {
        super();
        this.d = null;
        this.c = null;
        this.b = null;
        this.a = null;
        this.d = new Dictionary$2(Base.$, Base.$, 0);
        this.c = new Dictionary$2(Base.$, Base.$, 0);
        this.b = new Dictionary$2(Base.$, Number_$type, 0);
        this.a = new Dictionary$2(String_$type, Base.$, 0);
    }
    e(target_, dataSource_) {
        if (this.d.containsKey(target_)) {
            this.f(target_);
        }
        this.d.addItem(target_, dataSource_);
        let arr_ = dataSource_.dataView();
        if (this.c.containsKey(arr_)) {
            this.c.removeItem(arr_);
        }
        this.c.addItem(arr_, dataSource_);
        let a = (dataSource_.id);
        if (this.a.containsKey(a)) {
            this.a.removeItem(a);
        }
        this.a.addItem(a, dataSource_);
        if (!this.b.containsKey(dataSource_)) {
            this.b.addItem(dataSource_, 1);
        }
        else {
            this.b.item(dataSource_, this.b.item(dataSource_) + 1);
        }
        target_.itemsSource(arr_);
    }
    f(target_) {
        let curr_ = target_.itemsSource();
        this.d.removeItem(target_);
        if (!this.c.containsKey(curr_)) {
            return;
        }
        let ds_ = this.c.item(curr_);
        this.b.item(ds_, this.b.item(ds_) - 1);
        if (this.b.item(ds_) == 0) {
            this.b.removeItem(ds_);
            this.c.removeItem(curr_);
            let a = (ds_.id);
            this.a.removeItem(a);
        }
    }
}
DataSourceManager.$t = markType(DataSourceManager, 'DataSourceManager');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SeriesViewerSurfaceViewer extends DependencyObject {
    constructor(a, b) {
        super();
        this.m = null;
        this.o = false;
        this.k = null;
        this.x = null;
        this.n = true;
        this.q = null;
        this.j = 0;
        this.propertyChanged = null;
        if (a == null || b == null) {
            throw new ArgumentNullException(0, "model");
        }
        this.l = a;
        let c = this.l;
        c.windowRectChanged = delegateCombine(c.windowRectChanged, runOn(this, this.u));
        this.m = b;
        this.x = new Canvas();
        this.w();
    }
    u(a, b) {
        let c = this.o;
        this.o = true;
        this.zoomLevel = 1 - Math.min(b.newRect.height, b.newRect.width);
        this.o = c;
    }
    get l() {
        return this.k;
    }
    set l(a) {
        if (this.k != null) {
            let b = typeCast(INotifyPropertyChanged_$type, this.k);
            if (b != null) {
                b.propertyChanged = delegateRemove(b.propertyChanged, runOn(this, this.t));
            }
        }
        this.k = a;
        if (this.k != null) {
            let c = typeCast(INotifyPropertyChanged_$type, this.k);
            if (c != null) {
                c.propertyChanged = delegateCombine(c.propertyChanged, runOn(this, this.t));
            }
        }
    }
    t(a, b) {
        if (b.propertyName == "DefaultInteraction") {
            this.j = this.l.bp;
            this.v(b.propertyName, enumGetBox(InteractionState_$type, this.defaultInteraction), enumGetBox(InteractionState_$type, this.defaultInteraction));
        }
    }
    zoomTo100() {
        this.l.oi = XamDataChart.oe;
    }
    scaleToFit() {
        this.l.oi = XamDataChart.oe;
    }
    renderPreview() {
        if (!this.isDirty) {
            return;
        }
        let a = new RenderSurface();
        a.a = this.m.l.viewThumbnailContext;
        if (a.a != null && a.a.d) {
            let b = this.m.l.viewThumbnailSize;
            this.m.b5(b.width, b.height, a);
        }
        this.isDirty = false;
    }
    get worldRect() {
        return XamDataChart.oe;
    }
    get viewportRect() {
        return this.l.oh;
    }
    get minimumZoomLevel() {
        return 0;
    }
    get maximumZoomLevel() {
        if (this.l.fm == 0.0001) {
            return 0.9;
        }
        else {
            return 1 - this.l.fm;
        }
    }
    get isDirty() {
        return this.n;
    }
    set isDirty(a) {
        this.n = a;
    }
    get isIsoScaled() {
        if (this.k == null) {
            return false;
        }
        return this.k.dg;
    }
    v(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        switch (a) {
            case SeriesViewerSurfaceViewer.$$p[0]:
                if (c - this.minimumZoomLevel < -1E-05) {
                    this.zoomLevel = this.minimumZoomLevel;
                    return;
                }
                if (c - this.maximumZoomLevel > 0.0001) {
                    this.zoomLevel = this.maximumZoomLevel;
                    return;
                }
                let d = this.l != null && this.l.bu != null && this.l.bu.updatingSliderRanges;
                if (!this.o && !d) {
                    let e = 1 - this.zoomLevel;
                    let f = RectUtil.l(this.l.n2);
                    let g = new Rect(0, f.x - e / 2, f.y - e / 2, e, e);
                    this.l.oi = SeriesViewerSurfaceViewer.z(this.l.oi, g, this.l.dp(), this.l.dq(), this.worldRect);
                }
                this.w();
                if (this.l.bu != null) {
                    this.l.bu.pushZoomLevel(this.zoomLevel);
                }
                break;
        }
    }
    w() {
        let a = Math.round(100 * (1 / (1 - this.zoomLevel)));
        if (a <= 1000) {
            this.zoomLevelDisplayText = a.toString();
        }
        else {
            this.zoomLevelDisplayText = "> 1000";
        }
    }
    get zoomLevelDisplayText() {
        return this.q;
    }
    set zoomLevelDisplayText(a) {
        let b = this.zoomLevelDisplayText != a;
        if (b) {
            let c = this.zoomLevelDisplayText;
            this.q = a;
            this.v("ZoomLevelDisplayText", c, a);
        }
    }
    get defaultInteraction() {
        return this.j;
    }
    set defaultInteraction(a) {
        this.j = a;
        this.l.bp = a;
    }
    static z(a, b, c, d, e) {
        let f, g, h, i;
        if (c) {
            f = b.left;
            h = b.width;
        }
        else {
            f = a.left;
            h = a.width;
        }
        if (d) {
            g = b.top;
            i = b.height;
        }
        else {
            g = a.top;
            i = a.height;
        }
        let j = f + h;
        let k = g + i;
        let l = Math.max(0, e.left - f);
        let m = Math.max(0, j - e.right);
        let n = Math.max(0, e.top - g);
        let o = Math.max(0, k - e.bottom);
        f += l - m;
        g += n - o;
        let p = new Rect(0, f, g, h, i);
        p.intersect(e);
        return p;
    }
}
SeriesViewerSurfaceViewer.$t = markType(SeriesViewerSurfaceViewer, 'SeriesViewerSurfaceViewer', DependencyObject.$, [IOverviewPlusDetailControl_$type, INotifyPropertyChanged_$type]);
SeriesViewerSurfaceViewer.$$p = markDep(DependencyProperty, PropertyMetadata, SeriesViewerSurfaceViewer, 'v', ['ZoomLevel::y', [1, 0]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Enumeration that determines whether the axis extent measures in pixels or percentage.
 */
var AxisExtentType;
(function (AxisExtentType) {
    /**
     * Axis extent measured in pixels
     */
    AxisExtentType[AxisExtentType["Pixel"] = 0] = "Pixel";
    /**
     * Axis extent measured as a percentage of the chart's size
     */
    AxisExtentType[AxisExtentType["Percent"] = 1] = "Percent";
})(AxisExtentType || (AxisExtentType = {}));
/**
 * @hidden
 */
let AxisExtentType_$type = markEnum('AxisExtentType', 'Pixel,0|Percent,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisLabelInfo extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.a = 0;
    }
}
AxisLabelInfo.$t = markType(AxisLabelInfo, 'AxisLabelInfo');

/**
 * Class containing several properties which are used as parameters passed to scaling operations in a SeriesViewer.
*
* Class containing several properties which are used as parameters passed to scaling operations in a `IgxSeriesViewerComponent`.
*/
class IgxScalerParams {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The series reference value.
     * Typically, the reference value is the initial value of the series.  The reference value is used by the PercentChangeYAxis, where all values in the series are scaled relative to the initial value.
    */
    get referenceValue() {
        return this.i.b;
    }
    set referenceValue(v) {
        this.i.b = +v;
    }
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available behaviors for series highlighting depending on distance of mouse on hover operation.
 */
var HighlightingMode;
(function (HighlightingMode) {
    /**
     * Specifies the highlight starts on closest element of series
     */
    HighlightingMode[HighlightingMode["Closest"] = 0] = "Closest";
    /**
     * Specifies the highlight starts when directly over element of series
     */
    HighlightingMode[HighlightingMode["DirectlyOver"] = 1] = "DirectlyOver";
})(HighlightingMode || (HighlightingMode = {}));
/**
 * @hidden
 */
let HighlightingMode_$type = markEnum('HighlightingMode', 'Closest,0|DirectlyOver,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SyncSettingsConverter extends Base {
}
SyncSettingsConverter.$t = markType(SyncSettingsConverter, 'SyncSettingsConverter');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TrendLineManagerType_$type = markEnum('TrendLineManagerType', 'Category,0|Sorting,1|Polar,2|Radial,3|Scatter,4');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendLineManagerNames extends Base {
}
TrendLineManagerNames.$t = markType(TrendLineManagerNames, 'TrendLineManagerNames');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Describes available orientations for an axis.
 */
var AxisOrientation;
(function (AxisOrientation) {
    /**
     * Specifies a horizontal axis.
     */
    AxisOrientation[AxisOrientation["Horizontal"] = 0] = "Horizontal";
    /**
     * Specifies a vertical axis.
     */
    AxisOrientation[AxisOrientation["Vertical"] = 1] = "Vertical";
    /**
     * Specifies an angular axis used by the polar series.
     */
    AxisOrientation[AxisOrientation["Angular"] = 2] = "Angular";
    /**
     * Specifies a radial axis used by radial series.
     */
    AxisOrientation[AxisOrientation["Radial"] = 3] = "Radial";
})(AxisOrientation || (AxisOrientation = {}));
/**
 * @hidden
 */
let AxisOrientation_$type = markEnum('AxisOrientation', 'Horizontal,0|Vertical,1|Angular,2|Radial,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CategoryErrorBarSettings extends ErrorBarSettingsBase {
    constructor() {
        super();
        this.p = null;
        this.propertyUpdated = delegateCombine(this.propertyUpdated, runOn(this, this.ab));
    }
    get q() {
        return this.p;
    }
    set q(a) {
        this.p = a;
    }
    ab(a, b) {
        switch (b.propertyName) {
            case CategoryErrorBarSettings.$$p[0]:
                let c = typeCast(IErrorBarCalculator_$type, b.oldValue);
                if (c != null) {
                    c.changed = delegateRemove(c.changed, runOn(this, this.aa));
                }
                if (this.q != null) {
                    this.q.jl(false);
                    if (this.q.bs != null) {
                        this.q.it();
                    }
                }
                let d = typeCast(IErrorBarCalculator_$type, b.newValue);
                if (d != null) {
                    d.changed = delegateCombine(d.changed, runOn(this, this.aa));
                }
                break;
            case CategoryErrorBarSettings.$$p[1]:
            case CategoryErrorBarSettings.$$p[2]:
            case CategoryErrorBarSettings.$$p[3]:
            case CategoryErrorBarSettings.$$p[4]:
            case CategoryErrorBarSettings.$$p[5]:
                if (this.q != null) {
                    this.q.jl(false);
                    if (this.q.bs != null) {
                        this.q.it();
                    }
                }
                break;
        }
    }
    aa(a, b) {
        let c = typeCast(IErrorBarCalculator_$type, a);
        if (c != null) {
            c.changed = delegateRemove(c.changed, runOn(this, this.aa));
            if (this.q != null) {
                this.q.jl(false);
            }
            c.changed = delegateCombine(c.changed, runOn(this, this.aa));
        }
    }
}
CategoryErrorBarSettings.$t = markType(CategoryErrorBarSettings, 'CategoryErrorBarSettings', ErrorBarSettingsBase.$);
CategoryErrorBarSettings.$$p = markDep(DependencyProperty, PropertyMetadata, CategoryErrorBarSettings, 'l', ['Calculator:r:ac', [IErrorBarCalculator_$type, null], 'EnableErrorBars:o:ad', [EnableErrorBars_$type, enumGetBox(EnableErrorBars_$type, 0)], 'ErrorBarCapLength:t:ae', [1, 6], 'ErrorBarStyle:aj:af', [Style.$, null], 'Stroke:ai:ag', [Brush.$, null], 'StrokeThickness:s:ah', [1, 1]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Used to indicate the orientation of the legend
 */
var LegendOrientation;
(function (LegendOrientation) {
    /**
     */
    LegendOrientation[LegendOrientation["Horizontal"] = 0] = "Horizontal";
    /**
     */
    LegendOrientation[LegendOrientation["Vertical"] = 1] = "Vertical";
})(LegendOrientation || (LegendOrientation = {}));
/**
 * @hidden
 */
let LegendOrientation_$type = markEnum('LegendOrientation', 'Horizontal,0|Vertical,1');

var IgxLegendComponent_1;
const IgxLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxLegendComponent) }];
/**
 * Represents a legend in a IgxDataChartComponent control.
*
* The `IgxLegendComponent` helps end-user identify visuals of chart series with contextual information related to the data plotted in the chart control.
*
* ```html
*  <igx-data-chart
*     [dataSource]="data"
* 	 [legend]="legend">
*     <igx-category-x-axis
*         label="label"
*         #xAxis>
*     </igx-category-x-axis>
*     <igx-numeric-y-axis
*         #yAxis>
*     </igx-numeric-y-axis>
*     <igx-line-series
*         [xAxis]="xAxis"
*         [yAxis]="yAxis"
*         valueMemberPath="value">
*     </igx-line-series>
* </igx-data-chart>
*  <igx-legend #legend></igx-legend>
* ```
*
* ```ts
* public legend : IgxLegendComponent;
* ```
*/
let IgxLegendComponent = IgxLegendComponent_1 = class IgxLegendComponent extends IgxLegendBaseComponent {
    constructor(renderer, elRef, ngZone) {
        super();
        this.renderer = renderer;
        this.elRef = elRef;
        this.ngZone = ngZone;
        this._zoneRunner = (act) => this.ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(elRef.nativeElement, this.container);
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        this.i.provideContainer(ren);
    }
    ngOnDestroy() {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    }
    createImplementation() {
        return new Legend();
    }
    get i() {
        return this._implementation;
    }
    /**
 * Gets or sets the current Legend object's orientation.
*/
    get orientation() {
        return this.i.bb;
    }
    set orientation(v) {
        this.i.bb = ensureEnum(LegendOrientation_$type, v);
    }
    /**
     * Gets or sets color of text
    */
    get textColor() {
        return this.i.bh;
    }
    set textColor(v) {
        this.i.bh = v;
    }
    /**
     * Gets or sets style of text.
    */
    get textStyle() {
        return this.i.bi;
    }
    set textStyle(v) {
        this.i.bi = v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxLegendComponent.prototype, "orientation", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxLegendComponent.prototype, "textColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxLegendComponent.prototype, "textStyle", null);
IgxLegendComponent = IgxLegendComponent_1 = __decorate([
    Component({
        selector: 'igx-legend',
        template: ``,
        providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxLegendComponent_1) }],
        host: { 'class': 'ig-legend igx-legend' },
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [`:host {
    display: block;
}
.ig-legend {
    border: none;
    border: var(--legend-border, none);
    overflow: auto;
    overflow: var(--legend-item-overflow, auto);
}
.ig-chart-legend-item-text {
    font: 12px Verdana, Arial, sans-serif;
    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);
    vertical-align: middle;
    vertical-align: var(--legend-item-vertical-align, middle);
}
.ig-chart-legend-items-list
{
    padding: 5px;
    padding: var(--legend-item-padding, 5px);
    margin: 0px;
    margin: var(--legend-item-margin, 0px);
    background-color: transparent;
    background-color: var(--legend-list-background-color, transparent);
}
.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas
{
    vertical-align: middle;
    vertical-align: var(--legend-item-badge-vertical-align, middle);
}
.ig-chart-legend-item
{
    background-color: transparent;
    background-color: var(--legend-item-background-color, transparent);
}`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ElementRef,
        NgZone])
], IgxLegendComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLegendModule = class IgxLegendModule {
    constructor() {
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxLegendModule = __decorate([
    NgModule({
        declarations: [IgxLegendComponent],
        exports: [IgxLegendComponent
        ],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxLegendModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLegendDynamicModule = class IgxLegendDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxLegendComponent', IgxLegendComponent);
        TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxLegendDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxLegendModule
        ],
        imports: [CommonModule, IgxLegendModule
        ],
        entryComponents: [IgxLegendComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxLegendDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ItemLegend extends LegendBase {
    constructor() {
        super();
        this.bb = null;
        this.bc = null;
        this.ab = ItemLegend.$;
        this.bb = this.ak;
        let a = this.at;
        a.collectionChanged = delegateCombine(a.collectionChanged, (a, b) => {
            if (b.oldItems != null) {
                for (let c of fromEn(b.oldItems)) {
                    this.bb.an(c);
                }
            }
            if (b.newItems != null) {
                for (let d of fromEn(b.newItems)) {
                    this.bb.x(d);
                }
            }
        });
    }
    aj() {
        return new ItemLegendView(this);
    }
    a8(a) {
        super.a8(a);
        this.bb = a;
    }
    addChildInOrder(a, b) {
        if (!this.ak.m()) {
            return;
        }
        this.bg(b);
    }
    get_isItemwise() {
        return true;
    }
    createItemwiseLegendItems(a, b) {
        this.a0(a, b);
    }
    a0(a, b) {
        this.ak.af();
        this.clearLegendItemsForSeries(b);
        if (b == null || a == null || a.count == 0) {
            return;
        }
        for (let c of fromEnum(a)) {
            let d = typeCast(ContentControl.$, c);
            if (d != null && d.content != null) {
                let e = typeCast(ILegendContext_$type, d.content);
                if (e != null && !this.bd(e)) {
                    this.at.add(c);
                    let f = new LegendItemInfo();
                    f.b = e;
                    f.c = c;
                    f.a = b;
                    if (e.legendLabel != null) {
                        f.d = e.legendLabel;
                    }
                    else {
                        f.d = e.itemLabel;
                    }
                }
            }
        }
        this.ak.ag();
    }
    createLegendItemsInsert(a, b) {
        this.bf(a, b);
    }
    bf(a, b) {
        this.ak.af();
        try {
            let c = this.be(b);
            if (b == null || a == null || a.count == 0) {
                return;
            }
            for (let d of fromEnum(a)) {
                let e = typeCast(ContentControl.$, d);
                if (e != null && e.content != null) {
                    let f = typeCast(ILegendContext_$type, e.content);
                    if (f != null && !this.bd(f)) {
                        this.at.insert(c, d);
                        c++;
                        let g = new LegendItemInfo();
                        g.b = f;
                        g.c = d;
                        g.a = b;
                        g.d = f.legendLabel != null ? f.legendLabel.toString() : f.itemLabel;
                    }
                }
            }
        }
        finally {
            this.ak.ag();
        }
    }
    renderItemwiseContent(a) {
        this.bg(a);
    }
    bg(a) {
        this.clearLegendItemsForSeries(a);
        if (a.hasSubItems) {
            a.forSubItems((b) => {
                let c = typeCast(ContentControl.$, b);
                if (c != null && c.content != null) {
                    let d = typeCast(ILegendContext_$type, c.content);
                    if (d != null && !this.bd(d)) {
                        this.at.add(b);
                        let e = new LegendItemInfo();
                        e.b = d;
                        e.c = b;
                        e.a = a;
                        e.d = d.itemLabel;
                    }
                }
            });
        }
    }
    be(a) {
        if (a == null || this.at == null || this.at.count == 0) {
            return 0;
        }
        let b = new ObservableCollection$1(UIElement.$, 0);
        let c = -1;
        let d = 0;
        for (let e of fromEnum(this.at)) {
            let f = typeCast(ContentControl.$, e);
            if (f != null && f.content != null) {
                let g = typeCast(ILegendContext_$type, f.content);
                if (g != null && g.series == a) {
                    if (c == -1) {
                        c = d;
                    }
                    b.add(e);
                }
            }
            d++;
        }
        for (let h of fromEnum(b)) {
            this.at.remove(h);
        }
        if (c == -1) {
            return this.at.count;
        }
        return c;
    }
    bd(a) {
        return this.bb.ap(a);
    }
}
ItemLegend.$t = markType(ItemLegend, 'ItemLegend', LegendBase.$, [IChartItemLegend_$type]);
/**
 * @hidden
 */
class ItemLegendView extends LegendBaseView {
    constructor(a) {
        super(a);
        this.ao = null;
        this.ao = a;
    }
    ak() {
        super.ak();
    }
    get_j() {
        return true;
    }
    ap(a) {
        return this.c.e(a);
    }
    f() {
        let a = new LegendVisualData();
        let b = this.c.g.rootWrapper;
        b = b.getChildAt(0);
        let c = b.getChildCount();
        for (let d = 0; d < c; d++) {
            let e = new LegendItemVisualData();
            let f = b.getChildAt(d);
            e.label = f.getText();
            e.label = e.label != null ? e.label.trim() : null;
            e.bounds = new RectData(f.getOffset().left, f.getOffset().top, f.width(), f.height());
            e.labelBounds = this.h(f);
            e.badgeBounds = this.g(f);
            a.items.add(e);
        }
        for (let g = 0; g < c; g++) {
            a.items._inner[g].appearance.fill = this.a(g);
        }
        return a;
    }
}
ItemLegendView.$t = markType(ItemLegendView, 'ItemLegendView', LegendBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxItemLegendComponent_1;
const IgxItemLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxItemLegendComponent) }];
/**
 * Represents a legend that displays an item for each point in the series.
*
* You can use the `IgxItemLegendComponent` to display a legend item for each data member bound to the `IgxBubbleSeriesComponent`
*/
let IgxItemLegendComponent = IgxItemLegendComponent_1 = class IgxItemLegendComponent extends IgxLegendBaseComponent {
    constructor(renderer, elRef, ngZone) {
        super();
        this.renderer = renderer;
        this.elRef = elRef;
        this.ngZone = ngZone;
        this._zoneRunner = (act) => this.ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(elRef.nativeElement, this.container);
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        this.i.provideContainer(ren);
    }
    ngOnDestroy() {
        this._wrapper.destroy();
        this.i.provideContainer(null);
    }
    createImplementation() {
        return new ItemLegend();
    }
    get i() {
        return this._implementation;
    }
    createItemwiseLegendItems(legendItems, series) {
        this.i.createItemwiseLegendItems(legendItems, series);
    }
    exportVisualData() {
        return this.i.exportVisualData();
    }
    exportSerializedVisualData() {
        return this.i.exportSerializedVisualData();
    }
    /**
 * Gets whether or not this legend supports itemwise visuals
*/
    get isItemwise() {
        return this.i.isItemwise;
    }
};
IgxItemLegendComponent = IgxItemLegendComponent_1 = __decorate([
    Component({
        selector: 'igx-item-legend',
        template: ``,
        host: { 'class': 'ig-item-legend igx-item-legend' },
        providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxItemLegendComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush,
        styles: [`:host {
    display: block;
}
.ig-legend {
    border: none;
    border: var(--legend-border, none);
    overflow: auto;
    overflow: var(--legend-item-overflow, auto);
}
.ig-chart-legend-item-text {
    font: 12px Verdana, Arial, sans-serif;
    font: var(--legend-item-font, 12px Verdana, Arial, sans-serif);
    vertical-align: middle;
    vertical-align: var(--legend-item-vertical-align, middle);
}
.ig-chart-legend-items-list
{
    padding: 5px;
    padding: var(--legend-item-padding, 5px);
    margin: 0px;
    margin: var(--legend-item-margin, 0px);
    background-color: transparent;
    background-color: var(--legend-list-background-color, transparent);
}
.ig-chart-legend-item-badge, .ui-chart-legend-item-badge canvas
{
    vertical-align: middle;
    vertical-align: var(--legend-item-badge-vertical-align, middle);
}
.ig-chart-legend-item
{
    background-color: transparent;
    background-color: var(--legend-item-background-color, transparent);
}`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ElementRef,
        NgZone])
], IgxItemLegendComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxItemLegendModule = class IgxItemLegendModule {
    constructor() {
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxItemLegendModule = __decorate([
    NgModule({
        declarations: [IgxItemLegendComponent],
        exports: [IgxItemLegendComponent
        ],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxItemLegendModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxItemLegendDynamicModule = class IgxItemLegendDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxItemLegendComponent', IgxItemLegendComponent);
        TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxItemLegendDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxItemLegendModule
        ],
        imports: [CommonModule, IgxItemLegendModule
        ],
        entryComponents: [IgxItemLegendComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxItemLegendDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class GradientStopData extends Base {
    constructor() {
        super(...arguments);
        this.a = 0;
        this.b = null;
    }
}
GradientStopData.$t = markType(GradientStopData, 'GradientStopData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class GradientData extends Base {
    constructor() {
        super();
        this.a = null;
        this.a = new List$1(GradientStopData.$, 0);
    }
    b() {
        this.a.aa((a, b) => Base.compareSimple(a.a, b.a));
    }
}
GradientData.$t = markType(GradientData, 'GradientData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ScaleLegend extends LegendBase {
    constructor() {
        super();
        this.bd = null;
        this.bf = 0;
        this.be = 0;
        this.bb = null;
        this.ab = ScaleLegend.$;
    }
    aj() {
        return new ScaleLegendView(this);
    }
    a8(a) {
        super.a8(a);
        this.bd = a;
    }
    get legendScaleElement() {
        return this.bd.ba;
    }
    get minText() {
        return this.bd.a6;
    }
    get maxText() {
        return this.bd.a5;
    }
    get bc() {
        return this.bb;
    }
    set bc(a) {
        this.bb = a;
    }
    bi() {
        this.bd.a2();
    }
    restoreOriginalState() {
        this.bi();
    }
    bl(a) {
        if (a == null) {
            return this.bd.a9();
        }
        return ColorUtil.m(a);
    }
    bg(a) {
        this.bc = a;
        this.bh();
    }
    initializeLegend(a) {
        this.bg(a);
    }
    get_isScale() {
        return true;
    }
    bh() {
        if (this.legendScaleElement == null || this.bc == null || !this.bc.legendReady) {
            return;
        }
        if (this.bc == null || !this.bc.isAttachedTo(this)) {
            return;
        }
        let a = false;
        let b = typeCast(Shape.$, this.legendScaleElement);
        if (b != null) {
            let c = this.bd.aw();
            if (!this.bc.forScaleColors((d, e) => this.bd.ay(c, this.bl(d), e))) {
                a = true;
            }
            this.bd.a3(b, a, c);
        }
        if (this.minText != null) {
            this.minText.ak = this.bc.minScaleText;
        }
        if (this.maxText != null) {
            this.maxText.ak = this.bc.maxScaleText;
        }
    }
}
ScaleLegend.$t = markType(ScaleLegend, 'ScaleLegend', LegendBase.$, [IChartScaleLegend_$type]);
/**
 * @hidden
 */
class ScaleLegendView extends LegendBaseView {
    constructor(a) {
        super(a);
        this.ap = null;
        this.ba = null;
        this.a6 = null;
        this.a5 = null;
        this.ao = null;
        this.aq = null;
        this.bb = new Size();
        this.ar = false;
        this.as = 0;
        this.a8 = null;
        this.a7 = null;
        this.ap = a;
        this.a6 = new TextBlock();
        this.a5 = new TextBlock();
        this.ba = new Polygon();
    }
    a2() {
    }
    z() {
    }
    a9() {
        return Color.u(0, 0, 0, 0);
    }
    aw() {
        return new GradientData();
    }
    ay(a, b, c) {
        let d = a;
        d.a.add(((() => {
            let $ret = new GradientStopData();
            $ret.b = ((() => {
                let $ret = new Brush();
                $ret.color = b;
                return $ret;
            })());
            $ret.a = c;
            return $ret;
        })()));
    }
    a3(a, b, c) {
        if (b) {
            this.a7 = this.ap.bc.actualMarkerBrush;
            this.ao = null;
        }
        else {
            this.a7 = null;
            this.ao = c;
            this.ao.b();
        }
        this.az();
    }
    ai(a) {
        super.ai(a);
        this.aq = this.c.b(a);
        this.bb = this.c.ab();
        this.az();
    }
    az() {
        if (!this.ar) {
            this.ar = true;
            if (this.c.g != null) {
                this.c.g.setTimeout(runOn(this, this.a4), 0);
            }
            else {
                window.setTimeout(runOn(this, this.a4), 0);
            }
        }
    }
    a4() {
        if (this.ar) {
            this.ar = false;
            this.a1();
        }
    }
    a1() {
        if (this.aq == null) {
            return;
        }
        this.a0();
    }
    au(a) {
        let b = typeCast(TextBlock.$, a);
        if (b != null && b.ak != null) {
            return this.aq.e(b) + 0;
        }
        return 0;
    }
    at(a) {
        return this.as + 0;
    }
    a0() {
        if (this.ap.bc == null || this.ap.bc.container == null || (this.ao == null && this.a7 == null)) {
            return;
        }
        if (this.aq.d) {
            let a = typeCast(IInternalLegendOwner_$type, this.ap.bc.container);
            this.aq.ac(a.getFontInfo());
            this.as = a.getFontHeight();
            this.a8 = a.getFontBrush();
            let b = this.au(this.a6);
            let c = this.au(this.a5);
            let d = Math.max(b, c) + 4;
            if (d >= this.bb.width) {
                d = 0;
            }
            let e = this.bb.width - d;
            let f = 2;
            let g = 2;
            e = e - 4;
            let h = this.bb.height - 4;
            let i = f + e + 4;
            let j = g;
            let k = h;
            let l = { $type: Point_$type, x: f + (3 / 5) * e, y: g };
            let m = { $type: Point_$type, x: f + (5 / 5) * e, y: g };
            let n = { $type: Point_$type, x: f + (5 / 5) * e, y: h };
            let o = { $type: Point_$type, x: f, y: h };
            let p = this.ba;
            p.ak.clear();
            p.ak.add(l);
            p.ak.add(m);
            p.ak.add(n);
            p.ak.add(o);
            this.a6.n = i;
            this.a6.o = j;
            this.a6.am = this.a8;
            this.a5.n = i;
            this.a5.o = j + k - (this.at(this.a6));
            this.a5.am = this.a8;
            this.aq.k(0, 0, this.bb.width, this.bb.height);
            if (this.ao == null && this.a7 != null) {
                p._fill = this.a7;
                this.aq.t(p);
            }
            else {
                this.c.y(this.aq, p, this.ao, new Rect(0, g, f, e, h));
            }
            if (d > 0) {
                this.aq.w(this.a6);
                this.aq.w(this.a5);
            }
        }
    }
    al() {
        super.al();
    }
}
ScaleLegendView.$t = markType(ScaleLegendView, 'ScaleLegendView', LegendBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxScaleLegendComponent_1;
/**
 * Represents a legend that indicates the size and the color scale for a collection of series.
*/
const IgxScaleLegendComponent_PROVIDERS = [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxScaleLegendComponent) }];
let IgxScaleLegendComponent = IgxScaleLegendComponent_1 = class IgxScaleLegendComponent extends IgxLegendBaseComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new ScaleLegend();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
};
IgxScaleLegendComponent = IgxScaleLegendComponent_1 = __decorate([
    Component({
        selector: 'igx-scale-legend',
        template: ``,
        providers: [{ provide: IgxLegendBaseComponent, useExisting: forwardRef(() => IgxScaleLegendComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxScaleLegendComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScaleLegendModule = class IgxScaleLegendModule {
    constructor() {
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxScaleLegendModule = __decorate([
    NgModule({
        declarations: [IgxScaleLegendComponent],
        exports: [IgxScaleLegendComponent
        ],
        imports: [CommonModule,
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxScaleLegendModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxScaleLegendDynamicModule = class IgxScaleLegendDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxScaleLegendComponent', IgxScaleLegendComponent);
        TypeRegistrar.registerCons('LegendTemplates', LegendTemplates);
        TypeRegistrar.register('LegendTemplates', LegendTemplates.$type);
    }
};
IgxScaleLegendDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxScaleLegendModule
        ],
        imports: [CommonModule, IgxScaleLegendModule
        ],
        entryComponents: [IgxScaleLegendComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxScaleLegendDynamicModule);

/**
 * Provides data for legend mouse button related events.
*/
class IgxLegendMouseEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the series associated with the current event.
    */
    get series() {
        return this.i.series;
    }
    set series(v) {
        this.i.series = v;
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get chart() {
        return this.i.chart;
    }
    set chart(v) {
        this.i.chart = v;
    }
    /**
     * The legend item in context.
    */
    get legendItem() {
        return this.i.legendItem;
    }
    set legendItem(v) {
        this.i.legendItem = v;
    }
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}

/**
 * Provides data for legend mouse button related events.
*/
class IgxLegendMouseButtonEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets or sets a value that indicates the present state of the event handling for a routed
     * event as it travels the route.
     * ChartMouseButton events are not routed events; setting this property effects the underlying
     * MouseButtonEvent.
    */
    get handled() {
        return this.i.handled;
    }
    set handled(v) {
        this.i.handled = ensureBool(v);
    }
    /**
     * Gets a reference to the object that raised the event.
    */
    get originalSource() {
        return this.i.originalSource;
    }
    /**
     * Gets the ItemsSource item associated with the current event.
    */
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    /**
     * Gets the series associated with the current event.
    */
    get series() {
        return this.i.series;
    }
    set series(v) {
        this.i.series = v;
    }
    /**
     * Gets the Chart associated with the current event.
    */
    get chart() {
        return this.i.chart;
    }
    set chart(v) {
        this.i.chart = v;
    }
    /**
     * The legend item that was the target of the mouse event.
    */
    get legendItem() {
        return this.i.legendItem;
    }
    set legendItem(v) {
        this.i.legendItem = v;
    }
    /**
     * Provides a human readable description of the mouse button event.
    
    */
    toString() {
        let iv = this.i.toString();
        return (iv);
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Contains PieChart label click event data.
*/
class IgxLabelClickEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * Gets the slice data context.
    */
    get item() {
        return this.i.item;
    }
    /**
     * Gets and sets whether or not the owning pie chart should fire its SliceClick event
    */
    get allowSliceClick() {
        return this.i.allowSliceClick;
    }
    set allowSliceClick(v) {
        this.i.allowSliceClick = ensureBool(v);
    }
}

/**
 * Provides data for the SelectedItemChanged event.
*/
class IgxSelectedItemChangedEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The previously selected item.
    */
    get oldItem() {
        return this.i.oldItem;
    }
    set oldItem(v) {
        this.i.oldItem = v;
    }
    /**
     * The newly selected item.
    */
    get newItem() {
        return this.i.newItem;
    }
    set newItem(v) {
        this.i.newItem = v;
    }
}

/**
 * Provides data for the SelectedItemChanging event.
*/
class IgxSelectedItemChangingEventArgs extends IgxSelectedItemChangedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Set this to true in order to stop the SelectedItem from changing.
    */
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}

/**
 * Provides data for the SelectedItemsChanged event.
*/
class IgxSelectedItemsChangedEventArgs {
    constructor() {
        this._oldItems = null;
        this._newItems = null;
        this._currentItems = null;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * A list of the previously selected items.
    */
    get oldItems() {
        if (this._oldItems === null) {
            let coll = new IgxObjectCollection();
            let innerColl = this.i.oldItems;
            if (!innerColl) {
                innerColl = new ObjectCollection(0);
            }
            this._oldItems = coll._fromInner(innerColl);
            this.i.oldItems = innerColl;
        }
        return this._oldItems;
    }
    set oldItems(v) {
        if (this._oldItems !== null) {
            this._oldItems._setSyncTarget(null);
            this._oldItems = null;
        }
        let coll = new IgxObjectCollection();
        this._oldItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.oldItems;
        if (!innerColl) {
            innerColl = new ObjectCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._oldItems._setSyncTarget(syncColl);
        this.i.oldItems = innerColl;
    }
    /**
     * A list of the items being selected.
    */
    get newItems() {
        if (this._newItems === null) {
            let coll = new IgxObjectCollection();
            let innerColl = this.i.newItems;
            if (!innerColl) {
                innerColl = new ObjectCollection(0);
            }
            this._newItems = coll._fromInner(innerColl);
            this.i.newItems = innerColl;
        }
        return this._newItems;
    }
    set newItems(v) {
        if (this._newItems !== null) {
            this._newItems._setSyncTarget(null);
            this._newItems = null;
        }
        let coll = new IgxObjectCollection();
        this._newItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.newItems;
        if (!innerColl) {
            innerColl = new ObjectCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._newItems._setSyncTarget(syncColl);
        this.i.newItems = innerColl;
    }
    /**
     * A list of the current items selected.
    */
    get currentItems() {
        if (this._currentItems === null) {
            let coll = new IgxObjectCollection();
            let innerColl = this.i.currentItems;
            if (!innerColl) {
                innerColl = new ObjectCollection(0);
            }
            this._currentItems = coll._fromInner(innerColl);
            this.i.currentItems = innerColl;
        }
        return this._currentItems;
    }
    set currentItems(v) {
        if (this._currentItems !== null) {
            this._currentItems._setSyncTarget(null);
            this._currentItems = null;
        }
        let coll = new IgxObjectCollection();
        this._currentItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.currentItems;
        if (!innerColl) {
            innerColl = new ObjectCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._currentItems._setSyncTarget(syncColl);
        this.i.currentItems = innerColl;
    }
}

/**
 * Provides data for the SelectedItemsChanging event.
*/
class IgxSelectedItemsChangingEventArgs extends IgxSelectedItemsChangedEventArgs {
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    constructor() {
        super();
    }
    /**
     * Set this to true in order to stop the SelectedItems collection from changing.
    */
    get cancel() {
        return this.i.cancel;
    }
    set cancel(v) {
        this.i.cancel = ensureBool(v);
    }
}

/**
 * Represents the base class for the pie chart.
*/
const IgxPieChartBaseComponent_PROVIDERS = [];
class IgxPieChartBaseComponent {
    constructor() {
        this._explodedSlices = null;
        this._selectedItems = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._labelClick = null;
        this._selectedItemChanging = null;
        this._selectedItemsChanging = null;
        this._selectedItemChanged = null;
        this._selectedItemsChanged = null;
        this._sliceClick = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return null;
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets or sets the amount of space between the center and the start of the arc. This property should be set between 0 and 1.
     * If InnerExtent is set to a value greater than 1, it will be interpreted as a percentage, effectively divided by 100.
    */
    get innerExtent() {
        return this.i.cv;
    }
    set innerExtent(v) {
        this.i.cv = +v;
    }
    /**
     * Gets or Sets the property name that contains the values.
    */
    get valueMemberPath() {
        return this.i.e4;
    }
    set valueMemberPath(v) {
        this.i.e4 = v;
    }
    /**
     * Gets or sets the property name that contains the labels.
    */
    get labelMemberPath() {
        return this.i.dx;
    }
    set labelMemberPath(v) {
        this.i.dx = v;
    }
    /**
     * Gets or sets the property name that contains the legend labels.
    */
    get legendLabelMemberPath() {
        return this.i.ec;
    }
    set legendLabelMemberPath(v) {
        this.i.ec = v;
    }
    /**
     * Gets or sets the position of chart labels.
    */
    get labelsPosition() {
        return this.i.aw;
    }
    set labelsPosition(v) {
        this.i.aw = ensureEnum(LabelsPosition_$type, v);
    }
    /**
     * Gets or sets the color for labels rendered outside of the pie chart.
    */
    get labelOuterColor() {
        return brushToString(this.i.hu);
    }
    set labelOuterColor(v) {
        this.i.hu = stringToBrush(v);
    }
    /**
     * Gets or sets the color for labels rendered inside of the pie chart.
    */
    get labelInnerColor() {
        return brushToString(this.i.ht);
    }
    set labelInnerColor(v) {
        this.i.ht = stringToBrush(v);
    }
    /**
     * Gets or sets whether the leader lines are visible.
    */
    get leaderLineVisibility() {
        return this.i.h6;
    }
    set leaderLineVisibility(v) {
        this.i.h6 = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets what type of leader lines will be used for the outside end labels.
    */
    get leaderLineType() {
        return this.i.ax;
    }
    set leaderLineType(v) {
        this.i.ax = ensureEnum(LeaderLineType_$type, v);
    }
    /**
     * Gets or sets the margin between a label and the end of its leader line. The default is 6 pixels.
    */
    get leaderLineMargin() {
        return this.i.cx;
    }
    set leaderLineMargin(v) {
        this.i.cx = +v;
    }
    /**
     * Gets or sets the ToolTip for the chart.
    */
    get toolTip() {
        return this.i.da;
    }
    set toolTip(v) {
        this.i.da = v;
    }
    /**
     * Gets or sets the threshold value that determines if slices are grouped into the Others slice.
    */
    get othersCategoryThreshold() {
        return this.i.cy;
    }
    set othersCategoryThreshold(v) {
        this.i.cy = +v;
    }
    /**
     * Gets or sets whether to use numeric or percent-based threshold value.
    */
    get othersCategoryType() {
        return this.i.ay;
    }
    set othersCategoryType(v) {
        this.i.ay = ensureEnum(OthersCategoryType_$type, v);
    }
    /**
     * Gets or sets the label of the Others slice.
    */
    get othersCategoryText() {
        return this.i.ej;
    }
    set othersCategoryText(v) {
        this.i.ej = v;
    }
    /**
     * Determines how much the exploded slice is offset from the center. Value between 0 and 1.
    */
    get explodedRadius() {
        return this.i.cq;
    }
    set explodedRadius(v) {
        this.i.cq = +v;
    }
    /**
     * Gets or sets the scaling factor of the chart's radius. Value between 0 and 1.
    */
    get radiusFactor() {
        return this.i.c1;
    }
    set radiusFactor(v) {
        this.i.c1 = +v;
    }
    /**
     * Gets or sets whether the slices can be selected.
    */
    get allowSliceSelection() {
        return this.i.b0;
    }
    set allowSliceSelection(v) {
        this.i.b0 = ensureBool(v);
    }
    /**
     * Gets or sets whether the slices can be exploded.
    */
    get allowSliceExplosion() {
        return this.i.bz;
    }
    set allowSliceExplosion(v) {
        this.i.bz = ensureBool(v);
    }
    /**
     * Gets or sets the collection of exploded slice indices.
    */
    get explodedSlices() {
        if (this._explodedSlices === null) {
            let coll = new IgxIndexCollection();
            let innerColl = this.i.explodedSlices;
            if (!innerColl) {
                innerColl = new IndexCollection();
            }
            this._explodedSlices = coll._fromInner(innerColl);
            this.i.explodedSlices = innerColl;
        }
        return this._explodedSlices;
    }
    set explodedSlices(v) {
        if (this._explodedSlices !== null) {
            this._explodedSlices._setSyncTarget(null);
            this._explodedSlices = null;
        }
        let coll = new IgxIndexCollection();
        this._explodedSlices = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Number_$type);
        let innerColl = this.i.explodedSlices;
        if (!innerColl) {
            innerColl = new IndexCollection();
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._explodedSlices._setSyncTarget(syncColl);
        this.i.explodedSlices = innerColl;
    }
    /**
     * Gets or sets the pixel amount by which the labels are offset from the edge of the slices.
    */
    get labelExtent() {
        return this.i.cw;
    }
    set labelExtent(v) {
        this.i.cw = +v;
    }
    /**
     * Gets or sets the starting angle of the chart.
     * The default zero value is equivalent to 3 o'clock.
    */
    get startAngle() {
        return this.i.c3;
    }
    set startAngle(v) {
        this.i.c3 = +v;
    }
    /**
     * Gets or sets the rotational direction of the chart.
    */
    get sweepDirection() {
        return this.i.hv;
    }
    set sweepDirection(v) {
        this.i.hv = ensureEnum(SweepDirection_$type, v);
    }
    /**
     * Gets or sets the fill brush.
    */
    get othersCategoryFill() {
        return this.i.h3 ? this.i.h3.fill : null;
    }
    set othersCategoryFill(v) {
        this.ensureOthersCategoryStyle();
        this.i.h3.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get othersCategoryStroke() {
        return this.i.h3 ? this.i.h3.stroke : null;
    }
    set othersCategoryStroke(v) {
        this.ensureOthersCategoryStyle();
        this.i.h3.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get othersCategoryStrokeThickness() {
        return this.i.h3 ? this.i.h3.strokeThickness : NaN;
    }
    set othersCategoryStrokeThickness(v) {
        this.ensureOthersCategoryStyle();
        this.i.h3.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get othersCategoryOpacity() {
        return this.i.h3 ? this.i.h3.opacity : NaN;
    }
    set othersCategoryOpacity(v) {
        this.ensureOthersCategoryStyle();
        this.i.h3.opacity = +v;
    }
    ensureOthersCategoryStyle() {
        if (this.i.h3) {
            return;
        }
        this.i.h3 = new Style();
    }
    /**
     * Gets or sets the fill brush.
    */
    get selectedSliceFill() {
        return this.i.h4 ? this.i.h4.fill : null;
    }
    set selectedSliceFill(v) {
        this.ensureSelectedStyle();
        this.i.h4.fill = v;
    }
    /**
     * Gets or sets the stroke brush.
    */
    get selectedSliceStroke() {
        return this.i.h4 ? this.i.h4.stroke : null;
    }
    set selectedSliceStroke(v) {
        this.ensureSelectedStyle();
        this.i.h4.stroke = v;
    }
    /**
     * Gets or sets the stroke thickness.
    */
    get selectedSliceStrokeThickness() {
        return this.i.h4 ? this.i.h4.strokeThickness : NaN;
    }
    set selectedSliceStrokeThickness(v) {
        this.ensureSelectedStyle();
        this.i.h4.strokeThickness = +v;
    }
    /**
     * Gets or sets the opacity.
    */
    get selectedSliceOpacity() {
        return this.i.h4 ? this.i.h4.opacity : NaN;
    }
    set selectedSliceOpacity(v) {
        this.ensureSelectedStyle();
        this.i.h4.opacity = +v;
    }
    ensureSelectedStyle() {
        if (this.i.h4) {
            return;
        }
        this.i.h4 = new Style();
    }
    /**
     * Gets or sets the palette of brushes to use for coloring the slices.
    */
    get brushes() {
        return fromBrushCollection(this.i.ak);
    }
    set brushes(v) {
        this.i.ak = toBrushCollection(v);
    }
    /**
     * Gets or sets the palette of brushes to use for outlines on the slices.
    */
    get outlines() {
        return fromBrushCollection(this.i.al);
    }
    set outlines(v) {
        this.i.al = toBrushCollection(v);
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get labelFormat() {
        return this.i.dt;
    }
    set labelFormat(v) {
        this.i.dt = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LabelFormat string.
    */
    get labelFormatSpecifiers() {
        return this.i.ag;
    }
    set labelFormatSpecifiers(v) {
        this.i.ag = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get othersLabelFormat() {
        return this.i.en;
    }
    set othersLabelFormat(v) {
        this.i.en = v;
    }
    /**
     * Gets or sets the format specifiers to use with the OthersLabelFormat string.
    */
    get othersLabelFormatSpecifiers() {
        return this.i.aj;
    }
    set othersLabelFormatSpecifiers(v) {
        this.i.aj = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get legendLabelFormat() {
        return this.i.d9;
    }
    set legendLabelFormat(v) {
        this.i.d9 = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LegendLabelFormat string.
    */
    get legendLabelFormatSpecifiers() {
        return this.i.ah;
    }
    set legendLabelFormatSpecifiers(v) {
        this.i.ah = v;
    }
    /**
     * Gets or sets the label format string to use for the label.
    */
    get legendOthersLabelFormat() {
        return this.i.ee;
    }
    set legendOthersLabelFormat(v) {
        this.i.ee = v;
    }
    /**
     * Gets or sets the format specifiers to use with the LegendOthersLabelFormat string.
    */
    get legendOthersLabelFormatSpecifiers() {
        return this.i.ai;
    }
    set legendOthersLabelFormatSpecifiers(v) {
        this.i.ai = v;
    }
    /**
     * Gets or sets the LegendItemTemplate property.
     * The legend item control content is created according to the LegendItemTemplate on-demand by
     * the chart object itself.
    */
    get legendItemTemplate() {
        return this.i.legendItemTemplate;
    }
    set legendItemTemplate(v) {
        this.i.legendItemTemplate = v;
    }
    /**
     * Gets or sets the LegendItemBadgeTemplate property.
     * The legend item badge is created according to the LegendItemBadgeTemplate on-demand by
     * the chart object itself.
    */
    get legendItemBadgeTemplate() {
        return this.i.legendItemBadgeTemplate;
    }
    set legendItemBadgeTemplate(v) {
        this.i.legendItemBadgeTemplate = v;
    }
    /**
     * Gets or sets whether all surface interactions with the plot area should be disabled.
    */
    get isSurfaceInteractionDisabled() {
        return this.i.b5;
    }
    set isSurfaceInteractionDisabled(v) {
        this.i.b5 = ensureBool(v);
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
    */
    get formatLabel() {
        return this.i.a1;
    }
    set formatLabel(v) {
        this.i.a1 = v;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart's legend.
    */
    get formatLegendLabel() {
        return this.i.a2;
    }
    set formatLegendLabel(v) {
        this.i.a2 = v;
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.c0;
    }
    set pixelScalingRatio(v) {
        this.i.c0 = +v;
    }
    /**
     * Resolved pixel scaling ratio. Unless explicitly overridden by the PieChartBase.PixelScalingRatio property,
     * this one returns the default ratio enforced by device. High resolution devices will initialize this property
     * to a higher value.
    */
    get actualPixelScalingRatio() {
        return this.i.cn;
    }
    set actualPixelScalingRatio(v) {
        this.i.cn = +v;
    }
    /**
     * Gets or sets which mode to use for selecting slices.
    */
    get selectionMode() {
        return this.i.bb;
    }
    set selectionMode(v) {
        this.i.bb = ensureEnum(SliceSelectionMode_$type, v);
    }
    /**
     * Gets or sets the currently selected data item.  If a different data item is provided the pie chart
     * will select the slice associated with the new item.
    */
    get selectedItem() {
        return this.i.selectedItem;
    }
    set selectedItem(v) {
        this.i.selectedItem = v;
    }
    /**
     * Gets the currently selected data items.  Adding or removing data items from this collection will
     * select or deselect the slices associated with those items.
    */
    get selectedItems() {
        if (this._selectedItems === null) {
            let coll = new IgxObjectCollection();
            let innerColl = this.i.selectedItems;
            if (!innerColl) {
                innerColl = new ObjectCollection(0);
            }
            this._selectedItems = coll._fromInner(innerColl);
            this.i.selectedItems = innerColl;
        }
        return this._selectedItems;
    }
    set selectedItems(v) {
        if (this._selectedItems !== null) {
            this._selectedItems._setSyncTarget(null);
            this._selectedItems = null;
        }
        let coll = new IgxObjectCollection();
        this._selectedItems = coll._fromOuter(v);
        let syncColl = new SyncableObservableCollection$1(Base.$type);
        let innerColl = this.i.selectedItems;
        if (!innerColl) {
            innerColl = new ObjectCollection(0);
        }
        syncColl._inner = innerColl;
        syncColl.clear();
        this._selectedItems._setSyncTarget(syncColl);
        this.i.selectedItems = innerColl;
    }
    /**
     * Manually overrides the style to use for the labels.
    */
    get textStyle() {
        return this.i.ez;
    }
    set textStyle(v) {
        this.i.ez = v;
    }
    findByName(name) {
        if (this.legend && this.legend.name && this.legend.name == name) {
            return this.legend;
        }
        if (this.labelFormatSpecifiers != null && arrayFindByName(this.labelFormatSpecifiers, name)) {
            return arrayFindByName(this.labelFormatSpecifiers, name);
        }
        if (this.othersLabelFormatSpecifiers != null && arrayFindByName(this.othersLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.othersLabelFormatSpecifiers, name);
        }
        if (this.legendLabelFormatSpecifiers != null && arrayFindByName(this.legendLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.legendLabelFormatSpecifiers, name);
        }
        if (this.legendOthersLabelFormatSpecifiers != null && arrayFindByName(this.legendOthersLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.legendOthersLabelFormatSpecifiers, name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("PieChartBaseComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
     * Returns the chart visuals expressed as a serialized string.
    
    */
    exportSerializedVisualData() {
        let iv = this.i.di();
        return (iv);
    }
    /**
     * Simulates a mouse click action at the specified point.
    
    * @param point  * The point to click at.
    */
    simulateLeftClick(point) {
        this.i.gb(toPoint(point));
    }
    /**
     * Invoked by the containing object to provide reference to the container.
    
    * @param container  * Reference to the container.
    */
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    /**
     * Notification from the containing object that the container has been resized.
    
    */
    notifyContainerResized() {
        this.i.notifyContainerResized();
    }
    /**
     * Invoked when the instance is being destroyed.
    
    */
    destroy() {
        this.i.destroy();
    }
    /**
     * Use to force the pie chart to finish any deferred work before printing or evaluating its visual.
     * This should only be called if the visual of the pie chart needs to be synchronously saved or evaluated.
     * Calling this method too often will hinder the performance of the pie chart.
    
    */
    flush() {
        this.i.e9();
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.fi(source_, index, oldItem, newItem);
    }
    /**
     * Manually notifies the pie chart's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the pie chart is bound to is already observable.
    
    * @param source_  * The data source.
    */
    notifyClearItems(source_) {
        this.i.fe(source_);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.fg(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.fh(source_, index, oldItem);
    }
    /**
     * Assigns data source for the items.
    
    * @param source_  * Array of the data source items.
    */
    setWidgetLevelDataSource(source_) {
        this.i.ga(source_);
    }
    /**
     * Resets items data source.
    
    */
    removeWidgetLevelDataSource() {
        this.i.f1();
    }
    /**
     * Invoked when style is updated.
    
    */
    styleUpdated() {
        this.i.gf();
    }
    /**
     * Raised when the slice's label is clicked.
    */
    get labelClick() {
        if (this._labelClick == null) {
            this._labelClick = new EventEmitter();
            this.i.labelClick = delegateCombine(this.i.labelClick, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxLabelClickEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeLabelClick) {
                        this.beforeLabelClick(this, outerArgs);
                    }
                    this._labelClick.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._labelClick;
    }
    /**
     * Raised when the SelectedItem property is changing.  This event is cancelable.
    */
    get selectedItemChanging() {
        if (this._selectedItemChanging == null) {
            this._selectedItemChanging = new EventEmitter();
            this.i.selectedItemChanging = delegateCombine(this.i.selectedItemChanging, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSelectedItemChangingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSelectedItemChanging) {
                        this.beforeSelectedItemChanging(this, outerArgs);
                    }
                    this._selectedItemChanging.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._selectedItemChanging;
    }
    /**
     * Raised when the SelectedItems collection is changing.  This event is cancelable.
    */
    get selectedItemsChanging() {
        if (this._selectedItemsChanging == null) {
            this._selectedItemsChanging = new EventEmitter();
            this.i.selectedItemsChanging = delegateCombine(this.i.selectedItemsChanging, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSelectedItemsChangingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSelectedItemsChanging) {
                        this.beforeSelectedItemsChanging(this, outerArgs);
                    }
                    this._selectedItemsChanging.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._selectedItemsChanging;
    }
    /**
     * Raised when the SelectedItem property has changed.
    */
    get selectedItemChanged() {
        if (this._selectedItemChanged == null) {
            this._selectedItemChanged = new EventEmitter();
            this.i.selectedItemChanged = delegateCombine(this.i.selectedItemChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSelectedItemChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSelectedItemChanged) {
                        this.beforeSelectedItemChanged(this, outerArgs);
                    }
                    this._selectedItemChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._selectedItemChanged;
    }
    /**
     * Raised when the SelectedItems collection has changed.
    */
    get selectedItemsChanged() {
        if (this._selectedItemsChanged == null) {
            this._selectedItemsChanged = new EventEmitter();
            this.i.selectedItemsChanged = delegateCombine(this.i.selectedItemsChanged, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSelectedItemsChangedEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSelectedItemsChanged) {
                        this.beforeSelectedItemsChanged(this, outerArgs);
                    }
                    this._selectedItemsChanged.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._selectedItemsChanged;
    }
    /**
     * Raised when the slice is clicked.
    */
    get sliceClick() {
        if (this._sliceClick == null) {
            this._sliceClick = new EventEmitter();
            this.i.sliceClick = delegateCombine(this.i.sliceClick, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxSliceClickEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeSliceClick) {
                        this.beforeSliceClick(this, outerArgs);
                    }
                    this._sliceClick.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._sliceClick;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
}
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "innerExtent", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "legendLabelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "labelsPosition", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "labelOuterColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "labelInnerColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "leaderLineVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "leaderLineType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "leaderLineMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxPieChartBaseComponent.prototype, "toolTip", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "othersCategoryThreshold", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "othersCategoryType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "othersCategoryText", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "explodedRadius", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "radiusFactor", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxPieChartBaseComponent.prototype, "allowSliceSelection", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxPieChartBaseComponent.prototype, "allowSliceExplosion", null);
__decorate([
    Input(),
    __metadata("design:type", IgxIndexCollection),
    __metadata("design:paramtypes", [IgxIndexCollection])
], IgxPieChartBaseComponent.prototype, "explodedSlices", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "labelExtent", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "startAngle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "sweepDirection", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "othersCategoryFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "othersCategoryStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "othersCategoryStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "othersCategoryOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "selectedSliceFill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "selectedSliceStroke", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "selectedSliceStrokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "selectedSliceOpacity", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "brushes", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "outlines", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "labelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "labelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "othersLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "othersLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "legendLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "legendLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "legendOthersLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartBaseComponent.prototype, "legendOthersLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxPieChartBaseComponent.prototype, "legendItemTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxPieChartBaseComponent.prototype, "legendItemBadgeTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxPieChartBaseComponent.prototype, "isSurfaceInteractionDisabled", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxPieChartBaseComponent.prototype, "formatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxPieChartBaseComponent.prototype, "formatLegendLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "actualPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxPieChartBaseComponent.prototype, "selectionMode", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxPieChartBaseComponent.prototype, "selectedItem", null);
__decorate([
    Input(),
    __metadata("design:type", IgxObjectCollection),
    __metadata("design:paramtypes", [IgxObjectCollection])
], IgxPieChartBaseComponent.prototype, "selectedItems", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartBaseComponent.prototype, "textStyle", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "labelClick", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "selectedItemChanging", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "selectedItemsChanging", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "selectedItemChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "selectedItemsChanged", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxPieChartBaseComponent.prototype, "sliceClick", null);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class XamPieChart extends PieChartBase {
    constructor() {
        super();
        this.h7 = null;
        this.ab = XamPieChart.$;
    }
    az() {
        return new XamPieChartView(this);
    }
    fu(a) {
        super.fu(a);
        this.h7 = a;
    }
}
XamPieChart.$t = markType(XamPieChart, 'XamPieChart', PieChartBase.$);
/**
 * @hidden
 */
class XamPieChartView extends PieChartBaseView {
    constructor(a) {
        super(a);
        this.b4 = null;
        this.b4 = a;
    }
}
XamPieChartView.$t = markType(XamPieChartView, 'XamPieChartView', PieChartBaseView.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

const IgxPieChartComponent_PROVIDERS = [];
/**
 * Represents Infragistics IgxPieChartComponent control.
*/
let IgxPieChartComponent = class IgxPieChartComponent extends IgxPieChartBaseComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        super();
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        this._root = null;
        this._dataSource = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._zoneRunner = (act) => ngZone.run(act);
        this.container = renderer.createElement("div");
        renderer.appendChild(_elRef.element.nativeElement, this.container);
        renderer.setStyle(this.container, "display", "block");
        renderer.setStyle(this.container, "width", "100%");
        renderer.setStyle(this.container, "height", "100%");
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        this._root = root;
        var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
        this._wrapper = ren;
        var chart = this.i;
        this._chart = chart;
        chart.provideContainer(ren);
        this.bindData();
        chart.notifyContainerResized();
        ren.addSizeWatcher(() => {
            this._chart.notifyContainerResized();
        });
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._chart.notifyContainerResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._chart.notifyContainerResized();
    }
    get width() {
        return this._width;
    }
    ngAfterContentInit() {
        this._styling(this._root, this);
        this.i.notifyContainerResized();
    }
    ngOnDestroy() {
        this._chart.destroy();
        this._wrapper.destroy();
    }
    createImplementation() {
        return new XamPieChart();
    }
    get i() {
        return this._implementation;
    }
    createSeriesComponent(type) {
        if (TypeRegistrar.isRegistered(type)) {
            let s = TypeRegistrar.create(type);
            s.owner = this;
            s._provideRenderer(this.renderer);
            return s;
        }
        else {
            //we shouldn't get here, hopefully.
            throw Error("series type not loaded: " + type);
        }
    }
    set dataSource(value) {
        this._dataSource = value;
        this.bindData();
    }
    get dataSource() {
        return this._dataSource;
    }
    bindData() {
        if (this._chart != null && this._chart !== undefined) {
            this._chart.itemsSource = this._dataSource;
        }
    }
    /**
     * Gets or sets the legend used for the current chart.
    */
    get legend() {
        if (this.i.legend != null)
            return this.i.legend.externalObject;
    }
    set legend(v) {
        if (v != undefined && v != null)
            this.i.legend = v.i;
    }
};
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxPieChartComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxPieChartComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxPieChartComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxPieChartComponent.prototype, "legend", null);
IgxPieChartComponent = __decorate([
    Component({
        selector: 'igx-pie-chart',
        template: `<ng-container #dynamicContent></ng-container>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxPieChartComponent_PROVIDERS,
        host: { 'class': 'ig-pie-chart igx-pie-chart' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxPieChartComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPieChartCoreModule = class IgxPieChartCoreModule {
    constructor() {
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxPieChartCoreModule = __decorate([
    NgModule({
        declarations: [IgxPieChartComponent],
        exports: [IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule,
            IgxPieChartComponent
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxPieChartCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPieChartCoreDynamicModule = class IgxPieChartCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxPieChartComponent', IgxPieChartComponent);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxPieChartCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxPieChartCoreModule
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxPieChartCoreModule
        ],
        entryComponents: [IgxPieChartComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxPieChartCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPieChartModule = class IgxPieChartModule {
};
IgxPieChartModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPieChartCoreModule,
            IgxDataChartInteractivityModule
        ],
        imports: [CommonModule, IgxPieChartCoreModule,
            IgxDataChartInteractivityModule
        ],
        entryComponents: []
    })
], IgxPieChartModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxPieChartDynamicModule = class IgxPieChartDynamicModule {
};
IgxPieChartDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxPieChartCoreDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxPieChartModule
        ],
        imports: [CommonModule, IgxPieChartCoreDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxPieChartModule
        ],
        entryComponents: []
    })
], IgxPieChartDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents the selected data contained inside the Others slice.
*/
class IgxPieSliceOthersContext {
    createImplementation() {
        return new PieSliceOthersContext();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    /**
     * The underlying data contained by the Others pie slice.
    */
    findByName(name) {
        return null;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxHorizontalRangeCategorySeriesProxyDynamicModule = class IgxHorizontalRangeCategorySeriesProxyDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy);
        TypeRegistrar.register('HorizontalRangeCategorySeriesProxy', HorizontalRangeCategorySeriesProxy.$type);
    }
};
IgxHorizontalRangeCategorySeriesProxyDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxHorizontalRangeCategorySeriesProxyModule
        ],
        imports: [CommonModule, IgxHorizontalRangeCategorySeriesProxyModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxHorizontalRangeCategorySeriesProxyDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MouseMoveThunk extends Base {
    constructor() {
        super(...arguments);
        this.d = null;
        this.c = null;
        this.b = 0;
        this.a = null;
    }
}
MouseMoveThunk.$t = markType(MouseMoveThunk, 'MouseMoveThunk');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class KNearestResults extends Base {
    constructor() {
        super(...arguments);
        this.e = 0;
        this.f = 0;
        this.b = null;
        this.a = false;
        this.d = 0;
        this.c = 0;
        this.g = 0;
    }
}
KNearestResults.$t = markType(KNearestResults, 'KNearestResults');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxBrushScaleDynamicModule = class IgxBrushScaleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxBrushScaleComponent", IgxBrushScaleComponent);
        TypeRegistrar.register("BrushScale", BrushScale.$type);
    }
};
IgxBrushScaleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxBrushScaleModule],
        exports: [IgxBrushScaleModule],
        entryComponents: [IgxBrushScaleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxBrushScaleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomPaletteBrushScaleDynamicModule = class IgxCustomPaletteBrushScaleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCustomPaletteBrushScaleComponent", IgxCustomPaletteBrushScaleComponent);
        TypeRegistrar.register("CustomPaletteBrushScale", CustomPaletteBrushScale.$type);
    }
};
IgxCustomPaletteBrushScaleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCustomPaletteBrushScaleModule],
        exports: [IgxCustomPaletteBrushScaleModule],
        entryComponents: [IgxCustomPaletteBrushScaleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCustomPaletteBrushScaleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomContourValueResolverEventArgs extends EventArgs {
    constructor(a) {
        super();
        this._valueColumn = null;
        this._contourValuesEnumerable = null;
        this.b = null;
        this.valueColumn = a;
    }
    get valueColumn() {
        return this._valueColumn;
    }
    set valueColumn(a) {
        this._valueColumn = a;
    }
    get contourValuesEnumerable() {
        return this._contourValuesEnumerable;
    }
    set contourValuesEnumerable(a) {
        this._contourValuesEnumerable = a;
    }
    get values() {
        if (this.valueColumn == null) {
            return [];
        }
        return this.valueColumn.asArray();
    }
    get contourValues() {
        return this.b;
    }
    set contourValues(a) {
        if (a == null) {
            this.contourValuesEnumerable = null;
        }
        else {
            this.contourValuesEnumerable = a;
        }
    }
}
CustomContourValueResolverEventArgs.$t = markType(CustomContourValueResolverEventArgs, 'CustomContourValueResolverEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class CustomContourValueResolver extends ContourValueResolver {
    constructor() {
        super();
        this.getCustomContourValues = null;
    }
    j(a) {
        let b = new CustomContourValueResolverEventArgs(a);
        this.n(b);
        if (b.contourValuesEnumerable != null) {
            return b.contourValuesEnumerable;
        }
        return [];
    }
    n(a) {
        if (this.getCustomContourValues != null) {
            this.getCustomContourValues(this, a);
        }
    }
}
CustomContourValueResolver.$t = markType(CustomContourValueResolver, 'CustomContourValueResolver', ContourValueResolver.$);

/**
 * Provides data for GetCustomContourValues event.
*/
class IgxCustomContourValueResolverEventArgs {
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get values() {
        return this.i.values;
    }
    get contourValues() {
        return this.i.contourValues;
    }
    set contourValues(v) {
        this.i.contourValues = v;
    }
}

var IgxCustomContourValueResolverComponent_1;
/**
 * ContourValueResolver class which fires an event to resolve the contour values.
*/
const IgxCustomContourValueResolverComponent_PROVIDERS = [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxCustomContourValueResolverComponent) }];
let IgxCustomContourValueResolverComponent = IgxCustomContourValueResolverComponent_1 = class IgxCustomContourValueResolverComponent extends IgxContourValueResolverComponent {
    constructor() {
        super();
        this._getCustomContourValues = null;
    }
    createImplementation() {
        return new CustomContourValueResolver();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Event raised when retrieving the contour values.
    */
    get getCustomContourValues() {
        if (this._getCustomContourValues == null) {
            this._getCustomContourValues = new EventEmitter();
            this.i.getCustomContourValues = delegateCombine(this.i.getCustomContourValues, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxCustomContourValueResolverEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeGetCustomContourValues) {
                        this.beforeGetCustomContourValues(this, outerArgs);
                    }
                    this._getCustomContourValues.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._getCustomContourValues;
    }
};
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxCustomContourValueResolverComponent.prototype, "getCustomContourValues", null);
IgxCustomContourValueResolverComponent = IgxCustomContourValueResolverComponent_1 = __decorate([
    Component({
        selector: 'igx-custom-contour-value-resolver',
        template: ``,
        providers: [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxCustomContourValueResolverComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxCustomContourValueResolverComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomContourValueResolverModule = class IgxCustomContourValueResolverModule {
};
IgxCustomContourValueResolverModule = __decorate([
    NgModule({
        declarations: [IgxCustomContourValueResolverComponent],
        imports: [CommonModule],
        exports: [IgxCustomContourValueResolverComponent],
        entryComponents: []
    })
], IgxCustomContourValueResolverModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxCustomContourValueResolverDynamicModule = class IgxCustomContourValueResolverDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxCustomContourValueResolverComponent", IgxCustomContourValueResolverComponent);
        TypeRegistrar.register("CustomContourValueResolver", CustomContourValueResolver.$type);
    }
};
IgxCustomContourValueResolverDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxCustomContourValueResolverModule],
        exports: [IgxCustomContourValueResolverModule],
        entryComponents: [IgxCustomContourValueResolverComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxCustomContourValueResolverDynamicModule);

var IgxLinearContourValueResolverComponent_1;
/**
 * ContourValueResolver class which resolves contour lines to be distributed at linear intervals from the data minimum to the data maximum.
*/
const IgxLinearContourValueResolverComponent_PROVIDERS = [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxLinearContourValueResolverComponent) }];
let IgxLinearContourValueResolverComponent = IgxLinearContourValueResolverComponent_1 = class IgxLinearContourValueResolverComponent extends IgxContourValueResolverComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new LinearContourValueResolver();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets how many contour values to return.
    */
    get valueCount() {
        return this.i.valueCount;
    }
    set valueCount(v) {
        this.i.valueCount = +v;
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxLinearContourValueResolverComponent.prototype, "valueCount", null);
IgxLinearContourValueResolverComponent = IgxLinearContourValueResolverComponent_1 = __decorate([
    Component({
        selector: 'igx-linear-contour-value-resolver',
        template: ``,
        providers: [{ provide: IgxContourValueResolverComponent, useExisting: forwardRef(() => IgxLinearContourValueResolverComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxLinearContourValueResolverComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLinearContourValueResolverModule = class IgxLinearContourValueResolverModule {
};
IgxLinearContourValueResolverModule = __decorate([
    NgModule({
        declarations: [IgxLinearContourValueResolverComponent],
        imports: [CommonModule],
        exports: [IgxLinearContourValueResolverComponent],
        entryComponents: []
    })
], IgxLinearContourValueResolverModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxLinearContourValueResolverDynamicModule = class IgxLinearContourValueResolverDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxLinearContourValueResolverComponent", IgxLinearContourValueResolverComponent);
        TypeRegistrar.register("LinearContourValueResolver", LinearContourValueResolver.$type);
    }
};
IgxLinearContourValueResolverDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxLinearContourValueResolverModule],
        exports: [IgxLinearContourValueResolverModule],
        entryComponents: [IgxLinearContourValueResolverComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxLinearContourValueResolverDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TriangleRasterizer_PointAndValue extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.a = 0;
    }
}
TriangleRasterizer_PointAndValue.$t = markType(TriangleRasterizer_PointAndValue, 'TriangleRasterizer_PointAndValue');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ChartTitleVisualDataList extends List$1 {
    constructor() {
        super(ChartTitleVisualData.$, 0);
    }
}
ChartTitleVisualDataList.$t = markType(ChartTitleVisualDataList, 'ChartTitleVisualDataList', List$1.$.specialize(ChartTitleVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VisualDataSerializer extends Base {
    static a(a) {
        let b = "{ left: " + a.left + ", top: " + a.top + ", width: " + a.width + ", height: " + a.height + " }";
        return b;
    }
}
VisualDataSerializer.$t = markType(VisualDataSerializer, 'VisualDataSerializer');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapVisualData extends Base {
    constructor() {
        super(...arguments);
        this._nodes = null;
        this._name = null;
        this._viewport = null;
    }
    get nodes() {
        return this._nodes;
    }
    set nodes(a) {
        this._nodes = a;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    scaleByViewport() {
        if (this.nodes != null) {
            for (let a of fromEnum(this.nodes)) {
                a.e(this.viewport);
            }
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.nodes != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            let c = true;
            a.l("Nodes: [");
            for (let d of fromEnum(this.nodes)) {
                if (c) {
                    c = false;
                }
                else {
                    a.l(", ");
                }
                a.u(d.d());
            }
            a.u("]");
        }
        if (this.name != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("name: '");
            a.l(this.name);
            a.u("'");
        }
        if (b) {
            b = false;
        }
        else {
            a.l(", ");
        }
        a.l("viewport: {");
        a.l("left: " + this.viewport.left + ", top: " + this.viewport.top + ", width: " + this.viewport.width + ", height: " + this.viewport.height);
        a.u("}");
        a.u("}");
        return a.toString();
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
}
TreemapVisualData.$t = markType(TreemapVisualData, 'TreemapVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapVisual extends Base {
    constructor() {
        super();
        this.a = null;
        this.i = null;
        this.l = null;
        this.j = null;
        this.n = null;
        this.o = null;
        this.g = null;
        this.k = null;
        this.m = null;
        this.t = 0;
        this.c = null;
        this.f = 0;
        this.b = false;
        this.e = 0;
        this.d = 0;
        this.q = 0;
        this.s = 0;
        this.r = 0;
        this.h = 0;
        this.p = 0;
        this.c = new List$1(Base.$, 0);
    }
}
TreemapVisual.$t = markType(TreemapVisual, 'TreemapVisual');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapNodeVisualData extends Base {
    constructor() {
        super(...arguments);
        this.c = null;
        this.b = null;
        this.a = null;
    }
    e(a) {
        if (this.c != null) {
            this.c.scaleByViewport(a);
        }
        if (this.b != null) {
            this.b.scaleByViewport(a);
        }
        if (this.a != null) {
            this.a.scaleByViewport(a);
        }
    }
    d() {
        let a = new StringBuilder(0);
        let b = true;
        a.u("{");
        if (this.c != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("nodeRect: ");
            a.l(this.c.serialize());
        }
        if (this.b != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("headerRect: ");
            a.l(this.b.serialize());
        }
        if (this.a != null) {
            if (b) {
                b = false;
            }
            else {
                a.l(", ");
            }
            a.l("label: ");
            a.l(this.a.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    }
}
TreemapNodeVisualData.$t = markType(TreemapNodeVisualData, 'TreemapNodeVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapLabelVisualData extends Base {
    constructor() {
        super(...arguments);
        this._labelValue = null;
        this._labelSize = null;
        this._labelPosition = null;
        this._appearance = null;
    }
    get labelValue() {
        return this._labelValue;
    }
    set labelValue(a) {
        this._labelValue = a;
    }
    get labelSize() {
        return this._labelSize;
    }
    set labelSize(a) {
        this._labelSize = a;
    }
    get labelPosition() {
        return this._labelPosition;
    }
    set labelPosition(a) {
        this._labelPosition = a;
    }
    get appearance() {
        return this._appearance;
    }
    set appearance(a) {
        this._appearance = a;
    }
    scaleByViewport(a) {
        this.labelPosition = new PointData((this.labelPosition.x - a.left) / a.width, (this.labelPosition.y - a.top) / a.height);
        this.labelSize = new SizeData((this.labelSize.width) / a.width, (this.labelSize.height) / a.height);
    }
    serialize() {
        return "{ labelValue: '" + this.labelValue + "', labelSize: { width: " + this.labelSize.width + ", height: " + this.labelSize.height + "}, labelPosition: { x: " + this.labelPosition.x + ", y: " + this.labelPosition.y + "}, appearance: " + this.appearance.serialize() + "}";
    }
}
TreemapLabelVisualData.$t = markType(TreemapLabelVisualData, 'TreemapLabelVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapOrientation;
(function (TreemapOrientation) {
    TreemapOrientation[TreemapOrientation["Horizontal"] = 0] = "Horizontal";
    TreemapOrientation[TreemapOrientation["Vertical"] = 1] = "Vertical";
})(TreemapOrientation || (TreemapOrientation = {}));
/**
 * @hidden
 */
let TreemapOrientation_$type = markEnum('TreemapOrientation', 'Horizontal,0|Vertical,1');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AreaInfo extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.a = 0;
    }
}
AreaInfo.$t = markType(AreaInfo, 'AreaInfo');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapFillScaleMode;
(function (TreemapFillScaleMode) {
    TreemapFillScaleMode[TreemapFillScaleMode["Sum"] = 0] = "Sum";
    TreemapFillScaleMode[TreemapFillScaleMode["GlobalSum"] = 1] = "GlobalSum";
    TreemapFillScaleMode[TreemapFillScaleMode["Value"] = 2] = "Value";
    TreemapFillScaleMode[TreemapFillScaleMode["GlobalValue"] = 3] = "GlobalValue";
})(TreemapFillScaleMode || (TreemapFillScaleMode = {}));
/**
 * @hidden
 */
let TreemapFillScaleMode_$type = markEnum('TreemapFillScaleMode', 'Sum,0|GlobalSum,1|Value,2|GlobalValue,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLabelVerticalFitMode;
(function (TreemapLabelVerticalFitMode) {
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Auto"] = 0] = "Auto";
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Show"] = 1] = "Show";
    TreemapLabelVerticalFitMode[TreemapLabelVerticalFitMode["Hide"] = 2] = "Hide";
})(TreemapLabelVerticalFitMode || (TreemapLabelVerticalFitMode = {}));
/**
 * @hidden
 */
let TreemapLabelVerticalFitMode_$type = markEnum('TreemapLabelVerticalFitMode', 'Auto,0|Show,1|Hide,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLabelHorizontalFitMode;
(function (TreemapLabelHorizontalFitMode) {
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Auto"] = 0] = "Auto";
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Ellipsis"] = 1] = "Ellipsis";
    TreemapLabelHorizontalFitMode[TreemapLabelHorizontalFitMode["Hide"] = 2] = "Hide";
})(TreemapLabelHorizontalFitMode || (TreemapLabelHorizontalFitMode = {}));
/**
 * @hidden
 */
let TreemapLabelHorizontalFitMode_$type = markEnum('TreemapLabelHorizontalFitMode', 'Auto,0|Ellipsis,1|Hide,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapHeaderDisplayMode;
(function (TreemapHeaderDisplayMode) {
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Auto"] = 0] = "Auto";
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Header"] = 1] = "Header";
    TreemapHeaderDisplayMode[TreemapHeaderDisplayMode["Overlay"] = 2] = "Overlay";
})(TreemapHeaderDisplayMode || (TreemapHeaderDisplayMode = {}));
/**
 * @hidden
 */
let TreemapHeaderDisplayMode_$type = markEnum('TreemapHeaderDisplayMode', 'Auto,0|Header,1|Overlay,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapLayoutType;
(function (TreemapLayoutType) {
    TreemapLayoutType[TreemapLayoutType["Squarified"] = 0] = "Squarified";
    TreemapLayoutType[TreemapLayoutType["SliceAndDice"] = 1] = "SliceAndDice";
    TreemapLayoutType[TreemapLayoutType["Stripped"] = 2] = "Stripped";
})(TreemapLayoutType || (TreemapLayoutType = {}));
/**
 * @hidden
 */
let TreemapLayoutType_$type = markEnum('TreemapLayoutType', 'Squarified,0|SliceAndDice,1|Stripped,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapNodeVisualDataList extends List$1 {
    constructor() {
        super(TreemapNodeVisualData.$, 0);
    }
}
TreemapNodeVisualDataList.$t = markType(TreemapNodeVisualDataList, 'TreemapNodeVisualDataList', List$1.$.specialize(TreemapNodeVisualData.$));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapValueMappingMode;
(function (TreemapValueMappingMode) {
    TreemapValueMappingMode[TreemapValueMappingMode["Sum"] = 0] = "Sum";
    TreemapValueMappingMode[TreemapValueMappingMode["Value"] = 1] = "Value";
    TreemapValueMappingMode[TreemapValueMappingMode["CustomValue"] = 2] = "CustomValue";
})(TreemapValueMappingMode || (TreemapValueMappingMode = {}));
/**
 * @hidden
 */
let TreemapValueMappingMode_$type = markEnum('TreemapValueMappingMode', 'Sum,0|Value,1|CustomValue,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapNodePointerEventArgs extends EventArgs {
    constructor() {
        super(...arguments);
        this._value = 0;
        this._sum = 0;
        this._customValue = null;
        this._item = null;
        this._parentItem = null;
        this._position = null;
        this._isRightButton = false;
        this._isHandled = false;
        this._isOverHeader = false;
        this._label = null;
        this._parentValue = 0;
        this._parentLabel = null;
        this._parentSum = 0;
    }
    get value() {
        return this._value;
    }
    set value(a) {
        this._value = a;
    }
    get sum() {
        return this._sum;
    }
    set sum(a) {
        this._sum = a;
    }
    get customValue() {
        return this._customValue;
    }
    set customValue(a) {
        this._customValue = a;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get parentItem() {
        return this._parentItem;
    }
    set parentItem(a) {
        this._parentItem = a;
    }
    get position() {
        return this._position;
    }
    set position(a) {
        this._position = a;
    }
    get isRightButton() {
        return this._isRightButton;
    }
    set isRightButton(a) {
        this._isRightButton = a;
    }
    get isHandled() {
        return this._isHandled;
    }
    set isHandled(a) {
        this._isHandled = a;
    }
    get isOverHeader() {
        return this._isOverHeader;
    }
    set isOverHeader(a) {
        this._isOverHeader = a;
    }
    get label() {
        return this._label;
    }
    set label(a) {
        this._label = a;
    }
    get parentValue() {
        return this._parentValue;
    }
    set parentValue(a) {
        this._parentValue = a;
    }
    get parentLabel() {
        return this._parentLabel;
    }
    set parentLabel(a) {
        this._parentLabel = a;
    }
    get parentSum() {
        return this._parentSum;
    }
    set parentSum(a) {
        this._parentSum = a;
    }
}
TreemapNodePointerEventArgs.$t = markType(TreemapNodePointerEventArgs, 'TreemapNodePointerEventArgs', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
var TreemapNodeStyleMappingTargetType;
(function (TreemapNodeStyleMappingTargetType) {
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["All"] = 0] = "All";
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Parent"] = 1] = "Parent";
    TreemapNodeStyleMappingTargetType[TreemapNodeStyleMappingTargetType["Child"] = 2] = "Child";
})(TreemapNodeStyleMappingTargetType || (TreemapNodeStyleMappingTargetType = {}));
/**
 * @hidden
 */
let TreemapNodeStyleMappingTargetType_$type = markEnum('TreemapNodeStyleMappingTargetType', 'All,0|Parent,1|Child,2');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TreemapView extends Base {
    constructor() {
        super();
        this.b = null;
        this.a = null;
        this.m = false;
        this.ac = null;
        this.j = null;
        this.aa = null;
        this.q = 0;
        this.p = 0;
        this.e = null;
        this.ab = null;
        this.t = 1;
        this.z = null;
        this.c = null;
        this.r = 0;
        this.s = 0;
        this.a1 = null;
        this.g = ((() => {
            let $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        this.f = ((() => {
            let $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        this.o = null;
        this.k = null;
        this.a2 = ((() => {
            let $ret = new Brush();
            $ret.fill = "rgba(0,0,0, 0.0)";
            return $ret;
        })());
        this.d = ((() => {
            let $ret = new FontInfo();
            $ret.n = "Verdana";
            $ret.d = DeviceUtils.f(13);
            return $ret;
        })());
        this.l = true;
        this.b = new TreemapViewRenderer();
        this.b.j = ((() => {
            let $ret = new Brush();
            $ret.fill = "white";
            return $ret;
        })());
    }
    au() {
    }
    ay() {
        this.ax();
    }
    az() {
        if (!this.m) {
            this.m = true;
            if (this.aa != null) {
                this.aa.setTimeout(runOn(this, this.ad), 0);
            }
            else {
                window.setTimeout(runOn(this, this.ad), 0);
            }
        }
    }
    ad() {
        if (this.m) {
            this.m = false;
            this.a.hf();
        }
    }
    n() {
        return true;
    }
    av() {
        this.t = this.a.cp;
        this.az();
    }
    ar(a) {
        if (a == null) {
            this.ac = null;
            this.aa = null;
            this.j = null;
            if (this.z != null) {
                window.removeEventListener("resize", this.z, false);
                this.z = null;
            }
            this.ae();
            return;
        }
        this.aa = a;
        this.ab = a;
        let b = this.ab.rootWrapper.width();
        let c = this.ab.rootWrapper.height();
        this.ao();
        this.t = (isNaN_(this.a.di) ? this.a.cp : this.a.di);
        let d = this.t;
        let e = Math.round(a.rootWrapper.width());
        let f = Math.round(a.rootWrapper.height());
        let g = e * d;
        let h = f * d;
        this.aa.rootWrapper.setStyleProperty("position", "relative");
        let i = a.createElement("canvas");
        i.setStyleProperty("position", "absolute");
        this.aa.rootWrapper.append(i);
        this.q = b;
        this.p = c;
        i.setAttribute("width", g.toString());
        i.setAttribute("height", h.toString());
        i.setStyleProperty("width", e.toString() + "px");
        i.setStyleProperty("height", f.toString() + "px");
        this.k = i.listen("contextmenu", (j) => j.preventDefault());
        this.a.io = new Rect(0, 0, 0, e, f);
        this.ac = i;
        let j = this.aa.get2DCanvasContext(this.ac);
        this.j = new RenderingContext(new CanvasViewRenderer(), j);
        this.an();
        this.a0();
        this.j.ac(this.e);
        this.ax();
        this.c = new CanvasGestureDOMEventProxy(this.ac, this.aa, true);
        this.c.al = (k) => true;
        this.c.bg = this.a.io;
        let k = this.c;
        k.onMouseOver = delegateCombine(k.onMouseOver, runOn(this, this.aj));
        let l = this.c;
        l.onMouseUp = delegateCombine(l.onMouseUp, runOn(this, this.ak));
        let m = this.c;
        m.onMouseDown = delegateCombine(m.onMouseDown, runOn(this, this.ag));
        let n = this.c;
        n.onMouseEnter = delegateCombine(n.onMouseEnter, runOn(this, this.ah));
        let o = this.c;
        o.onMouseLeave = delegateCombine(o.onMouseLeave, runOn(this, this.ai));
    }
    ai(a) {
        this.a.g4(a);
    }
    al(a) {
        this.b.e(a, this.o, this);
    }
    ah(a) {
        this.a.g3(a);
    }
    ao() {
        if (this.z == null) {
            this.z = (a) => {
                let b = this.a.di;
                let c = this.a.cp;
                if (!isNaN_(b) && b != 0) {
                    return;
                }
                if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
                    this.a.cp = window.devicePixelRatio;
                }
            };
            let e_ = this.z;
            window.addEventListener("resize", e_, false);
        }
        this.z(null);
    }
    ae() {
        if (this.k != null) {
            this.k();
            this.k = null;
        }
        if (this.c != null) {
            let a = this.c;
            a.onMouseOver = delegateRemove(a.onMouseOver, runOn(this, this.aj));
            let b = this.c;
            b.onMouseUp = delegateRemove(b.onMouseUp, runOn(this, this.ak));
            let c = this.c;
            c.onMouseDown = delegateRemove(c.onMouseDown, runOn(this, this.ag));
            let d = this.c;
            d.onMouseEnter = delegateRemove(d.onMouseEnter, runOn(this, this.ah));
            let e = this.c;
            e.onMouseLeave = delegateRemove(e.onMouseLeave, runOn(this, this.ai));
            this.c.al = null;
            this.c.ar();
        }
    }
    ag(a) {
        if (this.c.ai) {
            this.a.g8(a);
        }
        else {
            this.a.g2(a);
        }
    }
    ak(a) {
        if (this.c.ai) {
            this.a.g9(a);
        }
        else {
            this.a.g6(a);
        }
    }
    aj(a, b, c) {
        this.a.g5(a);
    }
    an() {
    }
    i() {
        return this.b.b;
    }
    a0() {
        this.e = FontUtil.getFont(this.aa);
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
        this.a1 = new Brush();
        this.a1._fill = this.aa.rootWrapper.getStyleProperty("color");
        if (this.j != null) {
            this.j.ac(this.e);
        }
    }
    ap() {
        let a = this.ab.rootWrapper.width();
        let b = this.ab.rootWrapper.height();
        this.a.io = new Rect(0, 0, 0, a, b);
        this.ao();
    }
    am() {
        if (this.m) {
            this.ad();
        }
    }
    ax() {
        if (this.j == null) {
            return;
        }
        let a = this.a.io.width;
        let b = this.a.io.height;
        let c = Math.round(a * this.t);
        let d = Math.round(b * this.t);
        if (this.q != c || this.p != d) {
            this.ac.setAttribute("width", c.toString());
            this.ac.setAttribute("height", d.toString());
            this.ac.setStyleProperty("width", a.toString() + "px");
            this.ac.setStyleProperty("height", b.toString() + "px");
            this.q = truncate(Math.round(c));
            this.p = truncate(Math.round(d));
        }
        if (this.j.d && this.t != 1) {
            this.j.z();
            this.j.aa(this.t, this.t);
        }
        this.b.f(this.j, this.a.io, this.o, this.r);
        if (this.j.d && this.t != 1) {
            this.j.y();
        }
    }
    at(a) {
        this.g = a;
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
    }
    aw(a) {
        this.f = a;
        if (this.f != null) {
            this.r = this.u(this.f);
        }
        else {
            this.r = this.u(this.e);
        }
        if (this.g != null) {
            this.s = this.u(this.g);
        }
        else {
            this.s = this.u(this.e);
        }
    }
    af(a) {
        this.o = a;
        this.ax();
    }
    y(a) {
        if (a != null) {
            if (this.f != null) {
                this.j.ac(this.f);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    }
    w(a) {
        if (a != null) {
            if (this.g != null) {
                this.j.ac(this.g);
            }
            else {
                this.j.ac(this.d);
            }
            return this.j.f(a);
        }
        return 0;
    }
    u(a) {
        return FontUtil.getCurrentFontHeight(this.aa, a);
    }
    x(a) {
        return this.r;
    }
    v(a) {
        return this.s;
    }
    a4() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(220,220,220)";
            return $ret;
        })());
    }
    a6() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(240, 240, 240)";
            return $ret;
        })());
    }
    a5() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(102, 102, 102)";
            return $ret;
        })());
    }
    bc() {
        return this.a2;
    }
    a8() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "black";
            return $ret;
        })());
    }
    a7() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(240,240,240)";
            return $ret;
        })());
    }
    bb() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(240, 240, 240)";
            return $ret;
        })());
    }
    a3() {
        return ((() => {
            let $ret = new Brush();
            $ret.fill = "rgb(102, 102, 102)";
            return $ret;
        })());
    }
    h() {
        return this.d;
    }
    a9() {
        return BrushUtil.g(153, 25, 25, 25);
    }
    ba() {
        return BrushUtil.g(153, 45, 45, 45);
    }
    aq() {
        this.l = true;
        this.ao();
        if (this.c != null) {
            this.c.aq(this.aa.rootWrapper, "");
        }
    }
    as() {
        this.l = false;
        if (this.c != null) {
            this.c.bc(this.aa.rootWrapper, "");
        }
    }
}
TreemapView.$t = markType(TreemapView, 'TreemapView');
/**
 * @hidden
 */
class TreemapViewRenderer extends Base {
    constructor() {
        super();
        this.b = null;
        this.c = null;
        this.j = null;
        this.c = new List$1(TreemapVisual.$, 0);
        this.b = ((() => {
            let $ret = new Pool$1(TreemapVisual.$);
            $ret.create = runOn(this, this.a);
            $ret.activate = runOn(this, this.g);
            $ret.disactivate = runOn(this, this.i);
            $ret.destroy = runOn(this, this.h);
            return $ret;
        })());
    }
    a() {
        let a = new TreemapVisual();
        this.c.add(a);
        return a;
    }
    g(a) {
        a.t = 0;
    }
    i(a) {
        a.t = 1;
    }
    h(a) {
        this.c.remove(a);
    }
    d(a) {
        if (a.c.count != 3) {
            a.c.add1(new Rectangle());
            a.c.add1(new Rectangle());
            a.c.add1(new TextBlock());
        }
    }
    f(a, b, c, d) {
        a.k(b.left, b.top, b.width, b.height);
        if (c != null) {
            for (let e = 0; e < c.count; e++) {
                let f = c._inner[e];
                this.d(f);
                let g = f.c._inner[0];
                let h = f.c._inner[1];
                let i = f.c._inner[2];
                g._fill = f.i;
                g._stroke = f.l;
                g.ac = f.f;
                g.width = f.m.width;
                g.height = f.m.height;
                g.n = f.m.left;
                g.o = f.m.top;
                a.ac(f.a);
                let j = a.f(f.g);
                if (f.b) {
                    i.ak = f.g;
                    switch (f.h) {
                        case 0:
                            i.n = f.m.left + f.o.c;
                            break;
                        case 1:
                        case 3:
                            i.n = f.m.left + f.m.width / 2 - f.e / 2;
                            break;
                        case 2:
                            i.n = Math.max(f.m.left + f.o.c, f.m.right - (j + f.o.d));
                            break;
                    }
                    switch (f.p) {
                        case 0:
                            i.o = f.m.top + f.o.e;
                            break;
                        case 1:
                        case 3:
                            i.o = f.m.top + f.m.height / 2 - f.d / 2;
                            break;
                        case 2:
                            i.o = Math.max(f.m.top + f.o.e, f.m.bottom - (d + f.o.b));
                            break;
                    }
                    i.am = f.k;
                }
                else {
                    h._fill = f.j;
                    h._stroke = f.l;
                    h.ac = f.f;
                    h.width = f.m.width;
                    h.height = f.d;
                    h.n = f.m.left;
                    h.o = f.m.top;
                    if (f.s == 0) {
                        h.width = j + f.n.c + f.n.d;
                    }
                    i.n = f.m.left + f.n.c;
                    i.o = f.m.top + f.n.e;
                    i.ak = f.g;
                    i.am = f.k;
                }
                a.v(g);
                if (f.s != 0) {
                    if (!f.b) {
                        a.v(h);
                    }
                }
                a.z();
                a.ae(f.m);
                if (f.s == 0) {
                    if (!f.b) {
                        a.v(h);
                    }
                }
                a.w(i);
                a.y();
            }
        }
    }
    e(a, b, c) {
        if (b != null) {
            for (let d = 0; d < b.count; d++) {
                let e = b._inner[d];
                this.d(e);
                let f = e.c._inner[0];
                let g = e.c._inner[1];
                let h = e.c._inner[2];
                let i = new TreemapNodeVisualData();
                i.c = new RectangleVisualData(1, "NodePath", f);
                i.b = new RectangleVisualData(1, "HeaderRect", g);
                let j = new TreemapLabelVisualData();
                j.labelPosition = new PointData(h.n, h.o);
                if (e.b) {
                    j.labelSize = new SizeData(c.y(h.ak), c.x(h.ak));
                }
                else {
                    j.labelSize = new SizeData(c.w(h.ak), c.v(h.ak));
                }
                j.labelValue = h.ak;
                j.appearance = AppearanceHelper.c(h, e.a);
                i.a = j;
                a.nodes.add(i);
            }
        }
    }
}
TreemapViewRenderer.$t = markType(TreemapViewRenderer, 'TreemapViewRenderer');
/**
 * @hidden
 */
class TreemapLayoutCalculator extends Base {
    static c(a, b, c, d) {
        let e = a.e();
        let f = d.f;
        let g = f * f / (b.width * b.height);
        if (e / c < g) {
            return true;
        }
        return false;
    }
    static a(a, b, c, d, e) {
        for (let f = 0; f < c.count; f++) {
            let g = c._inner[f];
            if (!a.contains(g)) {
                return false;
            }
        }
        return true;
    }
    static b(a, b) {
        if (a.width < b.f || a.height < b.f) {
            return true;
        }
        return false;
    }
    h(a, b, c) {
        return a.o(b);
    }
    i(a, b, c) {
        let d = a.o(b);
        if (d.isEmpty) {
            return d;
        }
        if (b.b != null && b.b.count > 0) {
            let e = c.i;
            let f = e.c + e.d;
            let g = e.e + e.b;
            let h = a.b(b);
            if (!h) {
                return d;
            }
            let i = new Rect(0, d.left - e.c, d.top - e.e, d.width + f, d.height + g);
            return i;
        }
        else {
            return d;
        }
    }
    g(a, b, c, d) {
        if (b.b != null && b.b.count > 0) {
            let e = d.i;
            let f = e.c + e.d;
            let g = e.e + e.b;
            if (c.width < f || c.height < g) {
                a.m(b, c);
                return;
            }
            let h = new Rect(0, c.left + e.c, c.top + e.e, c.width - f, c.height - g);
            a.m(b, h);
            a.n(b, true);
        }
        else {
            a.m(b, c);
        }
    }
    f(a, b, c, d, e, f) {
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                let g = 0;
                for (let h of fromEnum(c)) {
                    if (a.contains(h)) {
                        continue;
                    }
                    if (d > 0) {
                        let i = (d > 1) ? 1 : d;
                        let j = this.i(b, h, f);
                        if (j.isEmpty) {
                            continue;
                        }
                        this.g(b, h, new Rect(0, j.x + g, j.y, j.width + i, j.height), f);
                        d -= i;
                        g += i;
                    }
                    else {
                        let k = this.i(b, h, f);
                        if (k.isEmpty) {
                            continue;
                        }
                        this.g(b, h, new Rect(0, k.x + g, k.y, k.width, k.height), f);
                    }
                }
            }
        }
    }
    e(a, b, c, d, e, f) {
        if (!TreemapLayoutCalculator.a(a, b, c, e, f)) {
            while (d > 0) {
                let g = 0;
                for (let h of fromEnum(c)) {
                    if (a.contains(h)) {
                        continue;
                    }
                    if (d > 0) {
                        let i = (d > 1) ? 1 : d;
                        let j = this.i(b, h, f);
                        if (j.isEmpty) {
                            continue;
                        }
                        this.g(b, h, new Rect(0, j.x, j.y + g, j.width, j.height + i), f);
                        d -= i;
                        g += i;
                    }
                    else {
                        let k = this.i(b, h, f);
                        if (k.isEmpty) {
                            continue;
                        }
                        this.g(b, h, new Rect(0, k.x, k.y + g, k.width, k.height), f);
                    }
                }
            }
        }
    }
}
TreemapLayoutCalculator.$t = markType(TreemapLayoutCalculator, 'TreemapLayoutCalculator');
/**
 * @hidden
 */
class StrippedCalculator extends TreemapLayoutCalculator {
    d(a, b) {
        a.g();
        this.o(a, b.b.a, b.h, b, 0);
    }
    q(a, b, c) {
        return c.j;
    }
    o(a, b, c, d, e) {
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            let f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            for (let g of fromEnum(b.b)) {
                this.o(a, g, c, d, e + 1);
            }
            return;
        }
        let h = this.q(b, c, d);
        let i = h.c + h.d;
        let j = h.e + h.b;
        let k = new Rect(0, c.left, c.top, c.width, c.height);
        let l = d.a;
        if (i >= k.width || j >= k.height) {
            return;
        }
        k.x = k.x + h.c;
        k.width = k.width - i;
        k.y = k.y + h.e;
        k.height = k.height - j;
        let m = new HashSet$1(TreemapTreeNode.$, 0);
        StrippedCalculator.p(m, d, b.b, k);
        let n = 0;
        for (let o = 0; o < b.b.count; o++) {
            let p = b.b._inner[o];
            if (!m.contains(p)) {
                n += p.e();
            }
        }
        let q = n;
        let r = (k.width * k.height) / q;
        let s = l == 0 ? k.width : k.height;
        let t = new List$1(TreemapTreeNode.$, 0);
        let u = new List$1(TreemapTreeNode.$, 0);
        for (let v = 0; v < b.b.count; v++) {
            let w = b.b._inner[v];
            if (m.contains(w) || isNaN_(w.e())) {
                continue;
            }
            let x = StrippedCalculator.j(u, s, r);
            u.add(w);
            let y = StrippedCalculator.j(u, s, r);
            if (x < y) {
                if (t.count > 0) {
                    let z = this.m(m, a, d, t, r, k, l, false);
                    k = z.p5;
                }
                u.removeAt(u.count - 1);
                t.o(u);
                u.clear();
                u.add(w);
            }
        }
        let aa = StrippedCalculator.j(t, s, r);
        let ab = StrippedCalculator.j(u, s, r);
        let ac = new List$1(TreemapTreeNode.$, 0);
        ac.o(t);
        ac.o(u);
        let ad = StrippedCalculator.j(ac, s, r);
        if (ad < (aa + ab) / 2 || k.height < d.f * 2) {
            let ae = this.m(m, a, d, ac, r, k, l, true);
            k = ae.p5;
        }
        else {
            let af = this.m(m, a, d, t, r, k, l, false);
            k = af.p5;
            let ag = this.m(m, a, d, u, r, k, l, true);
            k = ag.p5;
        }
        for (let ah = 0; ah < b.b.count; ah++) {
            let ai = b.b._inner[ah];
            if (m.contains(ai)) {
                continue;
            }
            let aj = this.h(a, ai, d);
            if (aj.isEmpty) {
                continue;
            }
            let ak = new Rect(0, aj.left, aj.top + d.e, aj.width, Math.max(aj.height - d.e, 0));
            this.o(a, ai, ak, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    }
    m(a, b, c, d, e, f, g, h) {
        if (d.count == 0) {
            return {
                p5: f
            };
        }
        if (g == 0) {
            let i = this.l(a, b, c, d, e, f, h);
            f = i.p5;
        }
        else {
            let j = this.n(a, b, c, d, e, f, h);
            f = j.p5;
        }
        return {
            p5: f
        };
    }
    l(a, b, c, d, e, f, g) {
        let h = StrippedCalculator.k(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        let i = f.width;
        let j = (h * e) / i;
        let k = f.x;
        let l = 0;
        for (let m = 0; m < d.count; ++m) {
            let n = d._inner[m];
            let o = Math.floor((n.e() / h) * i);
            let p = new Rect(0, k, f.y, o, j);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.right;
                this.g(b, n, p, c);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        this.f(a, b, d, f.right - k, f, c);
        f.y = f.y + j;
        if (f.height < j) {
            f.height = 0;
        }
        else {
            f.height = f.height - j;
        }
        d.clear();
        return {
            p5: f
        };
    }
    n(a, b, c, d, e, f, g) {
        let h = StrippedCalculator.k(d);
        if (h <= 0) {
            return {
                p5: f
            };
        }
        let i = f.height;
        let j = (h * e) / i;
        let k = f.y;
        let l = 0;
        for (let m = 0; m < d.count; ++m) {
            let n = d._inner[m];
            let o = Math.floor((n.e() / h) * i);
            let p = new Rect(0, f.x, k, j, o);
            if (TreemapLayoutCalculator.b(p, c)) {
                a.add_1(n);
            }
            else {
                l = p.bottom;
                this.g(b, n, p, c);
            }
            if (a.contains(n)) {
                h -= n.e();
            }
            else {
                k += o;
            }
        }
        this.e(a, b, d, f.bottom - k, f, c);
        f.x = f.x + j;
        if (f.width < j) {
            f.width = 0;
        }
        else {
            f.width = f.width - j;
        }
        d.clear();
        return {
            p5: f
        };
    }
    static j(a, b, c) {
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        let d = StrippedCalculator.k(a);
        let e = (d * c) / b;
        let f = 0;
        for (let g = 0; g < a.count; g++) {
            let h = a._inner[g];
            let i = (h.e() / d) * b;
            f += Math.max(i / e, e / i);
        }
        f /= a.count;
        return f;
    }
    static k(a) {
        let b = 0;
        for (let c = 0; c < a.count; c++) {
            let d = a._inner[c];
            b += d.e();
        }
        return b;
    }
    static p(a, b, c, d) {
        let e = 0;
        for (let f = 0; f < c.count; f++) {
            let g = c._inner[f];
        }
        let h = e;
        let i = b.f * b.f / (d.width * d.height);
        for (let j = 0; j < c.count; j++) {
            let k = c._inner[j];
            if (k.e() / h < i) {
                a.add_1(k);
            }
        }
    }
}
StrippedCalculator.$t = markType(StrippedCalculator, 'StrippedCalculator', TreemapLayoutCalculator.$);
/**
 * @hidden
 */
class SliceAndDiceCalculator extends TreemapLayoutCalculator {
    d(a, b) {
        a.g();
        this.m(a, b.b.a, b.h, b, 0);
    }
    o(a, b, c) {
        return c.j;
    }
    m(a, b, c, d, e) {
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            let f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            for (let g of fromEnum(b.b)) {
                this.m(a, g, c, d, e + 1);
            }
            return;
        }
        let h = this.o(b, c, d);
        let i = SliceAndDiceCalculator.j(b, d, e);
        let j = h.c + h.d;
        let k = h.e + h.b;
        let l = new Rect(0, c.left, c.top, c.width, c.height);
        if (j >= l.width || k >= l.height) {
            return;
        }
        l.x = l.x + h.c;
        l.width = l.width - j;
        l.y = l.y + h.e;
        l.height = l.height - k;
        let m = new Size(1, l.width, l.height);
        let n = l.left;
        let o = l.top;
        let p = new HashSet$1(TreemapTreeNode.$, 0);
        let q = SliceAndDiceCalculator.k(b.b, b, d, m, p);
        if (q) {
            SliceAndDiceCalculator.n(b.b, b, d, m, p);
        }
        let r = 0;
        for (let s = 0; s < b.b.count; s++) {
            let t = b.b._inner[s];
            if (!p.contains(t)) {
                r += t.e();
            }
        }
        let u = (i == 0) ? m.height : m.width;
        let v = new Rect(4);
        for (let w = 0; w < b.b.count; w++) {
            let x = b.b._inner[w];
            if (p.contains(x) || isNaN_(x.e())) {
                continue;
            }
            if (r <= 0 || u <= 0) {
                break;
            }
            let y = x.e() / r;
            v.x = n;
            v.y = o;
            if (i == 0) {
                v.width = m.width;
                v.height = Math.round(u * y);
            }
            else {
                v.width = Math.round(u * y);
                v.height = m.height;
            }
            this.g(a, x, new Rect(0, v.left, v.top, v.width, v.height), d);
            if (i == 0) {
                o += v.height;
                u -= v.height;
            }
            else {
                n += v.width;
                u -= v.width;
            }
            r -= x.e();
            let z = this.h(a, x, d);
            if (z.isEmpty) {
                continue;
            }
            let aa = new Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
            this.m(a, x, aa, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    }
    static j(a, b, c) {
        let d = 0;
        if (b.a == 0) {
            d = (c % 2 == 0) ? 0 : 1;
        }
        else {
            d = (c % 2 == 0) ? 1 : 0;
        }
        return d;
    }
    static k(a, b, c, d, e) {
        let f = true;
        let g = b.e();
        let h = Math.min(d.width, d.height);
        for (let i = 0; i < a.count; i++) {
            let j = a._inner[i];
            if (Math.round(j.e() / g * h) < c.f) {
                if (!e.contains(j)) {
                    e.add_1(j);
                }
            }
            else {
                f = false;
            }
        }
        return f;
    }
    static n(a, b, c, d, e) {
        let f = new List$1(TreemapTreeNode.$, 0);
        f.o(a);
        f.aa((g, h) => {
            if (g.e() > h.e()) {
                return 1;
            }
            else if (g.e() < h.e()) {
                return -1;
            }
            return 0;
        });
        let g = 0;
        let h = Math.min(d.width, d.height);
        for (let i = 0; i < f.count; i++) {
            let j = f._inner[i];
            if (isNaN_(j.e())) {
                continue;
            }
            g += j.e();
            if (j.e() / g * h < c.f) {
                break;
            }
            else {
                if (e.contains(j)) {
                    e.remove(j);
                }
            }
        }
    }
}
SliceAndDiceCalculator.$t = markType(SliceAndDiceCalculator, 'SliceAndDiceCalculator', TreemapLayoutCalculator.$);
SliceAndDiceCalculator.l = null;
/**
 * @hidden
 */
class TreemapLayoutSettings extends Base {
    constructor() {
        super();
        this.a = 0;
        this.h = null;
        this.b = null;
        this.j = null;
        this.i = null;
        this.e = 0;
        this.f = 0;
        this.g = 0;
        this.c = null;
        this.d = false;
        this.g = -1;
        this.d = false;
    }
}
TreemapLayoutSettings.$t = markType(TreemapLayoutSettings, 'TreemapLayoutSettings');
/**
 * @hidden
 */
class SquarifiedCalculator extends TreemapLayoutCalculator {
    n(a, b, c, d, e) {
        if (d.g >= 0 && e > d.g) {
            return;
        }
        if (b == d.c) {
            d.d = true;
            this.g(a, b, c, d);
            let f = new Rect(0, c.left, c.top + d.e, c.width, c.height - d.e);
            c = f;
        }
        if (!d.d) {
            for (let g of fromEnum(b.b)) {
                this.n(a, g, c, d, e + 1);
            }
            return;
        }
        let h = this.o(b, c, d);
        let i = new Rect(0, c.left, c.top, c.width, c.height);
        let j = h.c + h.d;
        let k = h.e + h.b;
        if (j >= i.width || k >= i.height) {
            return;
        }
        i.x = i.x + h.c;
        i.width = i.width - j;
        i.y = i.y + h.e;
        i.height = i.height - k;
        let l = i.left;
        let m = i.top;
        let n = new List$1(TreemapTreeNode.$, 0);
        let o = b.e();
        let p = new Rect(0, i.left, i.top, i.width, i.height);
        let q = (i.width * i.height) / o;
        let r = new List$1(TreemapTreeNode.$, 1, b.b);
        r.aa((s, t) => {
            if (t.e() < s.e()) {
                return -1;
            }
            if (t.e() > s.e()) {
                return 1;
            }
            return 0;
        });
        let s = new AreaInfo();
        s.b = i;
        s.a = o;
        let t = new HashSet$1(TreemapTreeNode.$, 0);
        for (let u of fromEnum(r)) {
            if (TreemapLayoutCalculator.c(u, p, o, d) || isNaN_(u.e())) {
                t.add_1(u);
                continue;
            }
            let v = Math.min(i.width, i.height);
            let w = SquarifiedCalculator.j(n, v, q);
            n.add(u);
            let x = SquarifiedCalculator.j(n, v, q);
            if (w <= x) {
                n.removeAt(n.count - 1);
                this.l(t, a, n, s, d);
                i = s.b;
                n.add(u);
            }
        }
        this.l(t, a, n, s, d);
        i = s.b;
        for (let y of fromEnum(b.b)) {
            if (t.contains(y)) {
                continue;
            }
            let z = this.h(a, y, d);
            if (z.isEmpty) {
                continue;
            }
            let aa = new Rect(0, z.left, z.top + d.e, z.width, Math.max(z.height - d.e, 0));
            this.n(a, y, aa, d, e + 1);
        }
        if (b == d.c) {
            d.d = false;
        }
    }
    o(a, b, c) {
        return c.j;
    }
    static j(a, b, c) {
        if (a.count == 0) {
            return 1.7976931348623157E+308;
        }
        let d = 0;
        let e = 1.7976931348623157E+308;
        let f = -1.7976931348623157E+308;
        for (let g of fromEnum(a)) {
            let h = g.e() * c;
            if (e > h) {
                e = h;
            }
            if (f < h) {
                f = h;
            }
            d += h;
        }
        let i = (b * b * f) / (d * d);
        let j = (d * d) / (b * b * e);
        return Math.max(i, j);
    }
    l(a, b, c, d, e) {
        if (c.count < 1) {
            return;
        }
        let f = 0;
        for (let g = 0; g < c.count; ++g) {
            f += c._inner[g].e();
        }
        if (f <= 0) {
            return;
        }
        if (d.b.width > d.b.height) {
            this.k(a, b, c, f, d, e);
        }
        else {
            this.m(a, b, c, f, d, e);
        }
    }
    m(a, b, c, d, e, f) {
        let g = e.b;
        let h = e.a;
        let i = Math.round((d / h) * g.height);
        let j = g.x;
        for (let k = 0; k < c.count; ++k) {
            let l = c._inner[k];
            if (g.right < j) {
                a.add_1(l);
                continue;
            }
            let m = Math.floor((l.e() / d) * g.width);
            let n = new Rect(0, j, g.y, m, i);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            this.g(b, l, n, f);
            j += n.width;
        }
        this.f(a, b, c, g.right - j, g, f);
        g.y = g.y + i;
        if (g.height < i) {
            g.height = 0;
        }
        else {
            g.height = g.height - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    }
    k(a, b, c, d, e, f) {
        let g = e.b;
        let h = e.a;
        let i = Math.round((d / h) * g.width);
        let j = g.y;
        for (let k = 0; k < c.count; ++k) {
            let l = c._inner[k];
            if (g.bottom < j) {
                a.add_1(l);
                continue;
            }
            let m = Math.floor((l.e() / d) * g.height);
            let n = new Rect(0, g.x, j, i, m);
            if (TreemapLayoutCalculator.b(n, f)) {
                a.add_1(l);
                continue;
            }
            this.g(b, l, n, f);
            j += n.height;
        }
        this.e(a, b, c, g.bottom - j, g, f);
        g.x = g.x + i;
        if (g.width < i) {
            g.width = 0;
        }
        else {
            g.width = g.width - i;
        }
        h -= d;
        e.a = h;
        e.b = g;
        c.clear();
    }
    d(a, b) {
        a.g();
        this.n(a, b.b.a, b.h, b, 0);
    }
}
SquarifiedCalculator.$t = markType(SquarifiedCalculator, 'SquarifiedCalculator', TreemapLayoutCalculator.$);
/**
 * @hidden
 */
class TreemapTreeData extends Base {
    constructor() {
        super();
        this.a = null;
        this.b = null;
        this.d = null;
        this.c = null;
        this.b = new Dictionary$2(String_$type, TreemapTreeNode.$, 0);
        this.d = new List$1(String_$type, 0);
        this.c = new Dictionary$2(String_$type, List$1.$.specialize(TreemapTreeNode.$), 0);
        this.a = new TreemapTreeNode();
    }
    e(a) {
        this.b.addItem(a.i, a);
        this.d.add(a.i);
        if (a.k == null) {
            this.a.b.add(a);
        }
        else if (this.b.containsKey(a.k)) {
            this.b.item(a.k).b.add(a);
        }
        else {
            let b;
            if (!((() => { let c = this.c.tryGetValue(a.k, b); b = c.p1; return c.ret; })())) {
                b = new List$1(TreemapTreeNode.$, 0);
                this.c.item(a.k, b);
            }
            b.add(a);
        }
        if (this.c.containsKey(a.i)) {
            for (let c of fromEnum(this.c.item(a.i))) {
                a.b.add(c);
            }
            this.c.removeItem(a.i);
        }
    }
    g(a) {
        if (isNaN_(a.f)) {
            if (a.b.count > 0) {
                a.d = 0;
            }
            for (let b = 0; b < a.b.count; b++) {
                let c = a.b._inner[b];
                this.g(c);
                if (isNaN_(c.f)) {
                    a.d = a.d + c.d;
                }
                else {
                    a.d = a.d + c.f;
                }
            }
        }
    }
    f() {
        this.g(this.a);
    }
}
TreemapTreeData.$t = markType(TreemapTreeData, 'TreemapTreeData');
/**
 * @hidden
 */
class TreemapTreeNode extends Base {
    constructor() {
        super();
        this.i = null;
        this.k = null;
        this.b = null;
        this.c = null;
        this.f = 0;
        this.g = null;
        this.d = 0;
        this.j = null;
        this.h = null;
        this.a = false;
        this.b = new List$1(TreemapTreeNode.$, 0);
        this.f = NaN;
        this.g = null;
        this.c = new List$1(TreemapNodeStyleMapping.$, 0);
        this.d = 0;
    }
    e() {
        if (isNaN_(this.f)) {
            return this.d;
        }
        return this.f;
    }
}
TreemapTreeNode.$t = markType(TreemapTreeNode, 'TreemapTreeNode');
/**
 * @hidden
 */
class Treemap extends Base {
    constructor() {
        super();
        this.g = null;
        this.f = null;
        this.e = null;
        this.ba = false;
        this.an = null;
        this.il = null;
        this.ap = null;
        this.ea = null;
        this.d9 = "Root";
        this.d4 = " : ";
        this.d8 = null;
        this.d7 = null;
        this.d5 = null;
        this.d6 = null;
        this.bq = null;
        this.a = new BrushCollection();
        this.ae = new TreemapNodeStyleMappingCollection();
        this.c = 0;
        this.bb = false;
        this.dw = 10;
        this.bx = NaN;
        this.bw = NaN;
        this.n = 0;
        this.k = 0;
        this.hx = null;
        this.hr = null;
        this.hp = null;
        this.hw = null;
        this.hu = null;
        this.hq = null;
        this.hy = null;
        this.ho = null;
        this.ht = null;
        this.hs = null;
        this.at = null;
        this.as = null;
        this.h = 0;
        this.b0 = DeviceUtils.g(5);
        this.b2 = DeviceUtils.g(3);
        this.b1 = DeviceUtils.g(5);
        this.bz = DeviceUtils.g(3);
        this.ca = DeviceUtils.g(10);
        this.cc = DeviceUtils.g(10);
        this.cb = DeviceUtils.g(10);
        this.b9 = DeviceUtils.g(10);
        this.b5 = DeviceUtils.g(5);
        this.b7 = DeviceUtils.g(3);
        this.b6 = DeviceUtils.g(5);
        this.b4 = DeviceUtils.g(3);
        this.cf = DeviceUtils.g(0);
        this.cj = DeviceUtils.g(0);
        this.ch = DeviceUtils.g(0);
        this.cd = DeviceUtils.g(0);
        this.cg = DeviceUtils.g(3);
        this.ck = DeviceUtils.g(3);
        this.ci = DeviceUtils.g(3);
        this.ce = DeviceUtils.g(3);
        this.hl = 1;
        this.ip = 1;
        this.by = NaN;
        this.hv = null;
        this.cm = NaN;
        this.ah = 0;
        this.r = 0;
        this.b8 = DeviceUtils.g(3);
        this.dx = 500;
        this.cn = 0;
        this.dv = null;
        this.aq = null;
        this.a1 = null;
        this.ax = null;
        this.a0 = null;
        this.ay = null;
        this.az = null;
        this.cl = NaN;
        this.bt = 1;
        this.b3 = NaN;
        this.bs = 0.5;
        this.a9 = false;
        this.bf = false;
        this.bi = false;
        this.be = false;
        this.aj = null;
        this.q = null;
        this.bu = NaN;
        this.bv = DeviceUtils.g(1);
        this.propertyChanged = null;
        this.w = null;
        this.t = null;
        this.d2 = null;
        this.am = null;
        this.al = null;
        this.ik = null;
        this.nodeStyling = null;
        this.nodePointerOver = null;
        this.nodePointerEnter = null;
        this.nodePointerLeave = null;
        this.nodePointerPressed = null;
        this.nodePointerReleased = null;
        let a = new TreemapView();
        a.a = this;
        this.q = new SquarifiedCalculator();
        this.an = a;
        this.an.au();
        this.dv = (b, c) => this.go(c.action, c.position, c.count, c.propertyName);
        this.il = Rect.empty;
        this.g = new TreemapFrame();
        this.f = new TreemapFrame();
        this.e = new TreemapFrame();
        this.bf = true;
        this.ap = new DoubleAnimator(0, 1, this.d1);
        this.ap.b = EasingFunctions.cubicEase;
        let b = this.ap;
        b.propertyChanged = delegateCombine(b.propertyChanged, runOn(this, this.gn));
        let c = this.ae;
        c.collectionChanged = delegateCombine(c.collectionChanged, runOn(this, this.gl));
        let d = this.ae;
        d.collectionResetting = delegateCombine(d.collectionResetting, runOn(this, this.gm));
    }
    gm(a, b) {
        for (let c of fromEnum(this.styleMappings)) {
            c.propertyChanged = delegateRemove(c.propertyChanged, runOn(this, this.hh));
        }
        this.bf = true;
        this.bi = true;
        this.an.az();
    }
    gl(a, b) {
        if (b.oldItems != null) {
            for (let c of fromEn(b.oldItems)) {
                let d = c;
                if (d != null) {
                    d.propertyChanged = delegateRemove(d.propertyChanged, runOn(this, this.hh));
                }
            }
        }
        if (b.newItems != null) {
            for (let e of fromEn(b.newItems)) {
                let f = e;
                if (f != null) {
                    f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.hh));
                }
            }
        }
        this.bf = true;
        this.bi = true;
        this.an.az();
    }
    hh(a, b) {
        this.bf = true;
        this.bi = true;
        this.an.az();
    }
    go(a, b, c, d) {
        this.aj = null;
        this.bf = true;
        this.be = true;
        this.bi = true;
        this.an.az();
    }
    notifySizeChanged() {
        this.an.ap();
    }
    destroy() {
        this.provideContainer(null);
    }
    ao() {
        let a = new TreemapVisualData();
        a.viewport = new RectData(this.io.left, this.io.top, this.io.width, this.io.height);
        a.nodes = new TreemapNodeVisualDataList();
        this.an.al(a);
        return a;
    }
    ej() {
        let a = this.ao();
        a.scaleByViewport();
        return a.serialize();
    }
    g7(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.hc(a, b, c);
    }
    hc(a, b, c) {
        switch (a) {
            case "FocusItem":
                this.g1();
                break;
            case "LayoutType":
                {
                    switch (EnumUtil.getEnumValue(TreemapLayoutType_$type, c)) {
                        case 0:
                            this.q = new SquarifiedCalculator();
                            break;
                        case 1:
                            this.q = new SliceAndDiceCalculator();
                            break;
                        case 2:
                            this.q = new StrippedCalculator();
                            break;
                    }
                    this.bf = true;
                    this.an.az();
                }
                break;
            case "BreadcrumbSequence":
                this.bf = true;
                this.an.az();
                break;
            case "RootTitle":
                this.bf = true;
                this.an.az();
                break;
            case "ValueMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a8);
                    this.a8 = this.a6(this.gi);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "CustomValueMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a2);
                    this.a2 = this.a7(this.eg);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "IdMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a3);
                    this.a3 = this.a7(this.e5);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "LabelMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a4);
                    this.a4 = this.a7(this.ff);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "ParentIdMemberPath":
                if (this.ar != null) {
                    this.ar.deregisterColumn(this.a5);
                    this.a5 = this.a7(this.fw);
                    this.aj = null;
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "ItemsSource":
                this.ar = ((() => {
                    let $ret = new FastItemsSource();
                    $ret.e = this.dataSource;
                    return $ret;
                })());
                break;
            case "HeaderLabelLeftMargin":
            case "HeaderLabelTopMargin":
            case "HeaderLabelRightMargin":
            case "HeaderLabelBottomMargin":
            case "LabelLeftMargin":
            case "LabelTopMargin":
            case "LabelRightMargin":
            case "LabelBottomMargin":
            case "ParentNodeLeftMargin":
            case "ParentNodeTopMargin":
            case "ParentNodeRightMargin":
            case "ParentNodeBottomMargin":
            case "ParentNodeLeftPadding":
            case "ParentNodeTopPadding":
            case "ParentNodeRightPadding":
            case "ParentNodeBottomPadding":
            case "HeaderTextColor":
            case "HeaderHoverTextColor":
            case "OverlayHeaderHoverBackground":
            case "HeaderHoverBackground":
            case "StrokeThickness":
            case "Outline":
            case "FillBrushes":
            case "IsFillScaleLogarithmic":
            case "FillScaleMinimumValue":
            case "FillScaleMaximumValue":
            case "HeaderBackground":
            case "OverlayHeaderBackground":
            case "HeaderHeight":
            case "FillScaleLogarithmBase":
            case "FillScaleMode":
            case "MinimumDisplaySize":
            case "LayoutOrientation":
            case "LabelHorizontalAlignment":
            case "LabelVerticalAlignment":
            case "HeaderDisplayMode":
            case "LabelHorizontalFitMode":
            case "LabelVerticalFitMode":
                this.bf = true;
                this.an.az();
                break;
            case "TextStyle":
                this.an.aw(this.aw);
                this.bf = true;
                this.an.az();
                break;
            case "HeaderTextStyle":
                this.an.at(this.au);
                this.bf = true;
                this.an.az();
                break;
            case "PixelScalingRatio":
                if (!isNaN_(c)) {
                    this.cp = c;
                }
                break;
            case "ActualPixelScalingRatio":
                if (isNaN_(this.c0)) {
                    this.co = this.cp / 2;
                }
                if (this.an != null) {
                    this.an.av();
                }
                break;
            case "InteractionPixelScalingRatio":
                if (!isNaN_(c)) {
                    this.co = c;
                }
                break;
            case "ActualInteractionPixelScalingRatio":
                if (this.an != null) {
                    this.an.av();
                }
                break;
            case "TransitionProgress":
                if (this.du >= 1) {
                    this.ap.w();
                    this.an.av();
                    let d = this.f;
                    this.f = this.g;
                    this.g = d;
                    this.hb();
                    this.he(this.f);
                    this.an.ay();
                    this.an.az();
                    return;
                }
                this.e.h(this.du, this.g, this.f);
                this.he(this.e);
                this.an.ay();
                break;
            case "Viewport":
                this.bf = true;
                this.an.az();
                break;
            case "FastItemsSource":
                let e = b;
                let f = c;
                if (b != null) {
                    e.event = delegateRemove(e.event, this.dv);
                    this.a9 = false;
                    e.deregisterColumn(this.a8);
                    e.deregisterColumn(this.a3);
                    e.deregisterColumn(this.a5);
                    e.deregisterColumn(this.a4);
                    e.deregisterColumn(this.a2);
                    this.a8 = null;
                    this.a3 = null;
                    this.a5 = null;
                    this.a4 = null;
                    this.aj = null;
                }
                if (c != null) {
                    f.event = delegateCombine(f.event, this.dv);
                    this.a9 = true;
                    this.a8 = this.a6(this.gi);
                    this.a3 = this.a7(this.e5);
                    this.a5 = this.a7(this.fw);
                    this.a4 = this.a7(this.ff);
                    this.a2 = this.a7(this.eg);
                }
                this.bf = true;
                this.be = true;
                this.an.az();
                break;
            case "TransitionDuration":
                this.ap.r = this.d1;
                break;
        }
    }
    g1() {
        if (this.ba) {
            return;
        }
        if (this.aj == null) {
            return;
        }
        if (this.d3 == null) {
            this.al = null;
            this.bf = true;
            this.an.az();
            return;
        }
        for (let a = 0; a < this.aj.d.count; a++) {
            let b = this.aj.b.item(this.aj.d._inner[a]);
            if (b.h == this.d3) {
                this.al = b;
                this.bf = true;
                this.an.az();
                break;
            }
        }
    }
    get io() {
        return this.il;
    }
    set io(a) {
        let b = this.il;
        this.il = a;
        if (!b.equals1(this.il)) {
            this.g7("Viewport", b, this.il);
        }
    }
    gn(a, b) {
        this.du = this.ap.o;
    }
    get gi() {
        return this.ea;
    }
    set gi(a) {
        let b = this.ea;
        this.ea = a;
        if (b != this.ea) {
            this.hc("ValueMemberPath", b, a);
        }
    }
    get f8() {
        return this.d9;
    }
    set f8(a) {
        let b = this.d9;
        this.d9 = a;
        if (b != this.d9) {
            this.hc("RootTitle", b, a);
        }
    }
    get ed() {
        return this.d4;
    }
    set ed(a) {
        let b = this.d4;
        this.d4 = a;
        if (b != this.d9) {
            this.hc("BreadcrumbSequence", b, a);
        }
    }
    get fw() {
        return this.d8;
    }
    set fw(a) {
        let b = this.d8;
        this.d8 = a;
        if (b != this.d8) {
            this.g7("ParentIdMemberPath", b, a);
        }
    }
    get ff() {
        return this.d7;
    }
    set ff(a) {
        let b = this.d7;
        this.d7 = a;
        if (b != this.d7) {
            this.g7("LabelMemberPath", b, a);
        }
    }
    get eg() {
        return this.d5;
    }
    set eg(a) {
        let b = this.d5;
        this.d5 = a;
        if (b != this.d5) {
            this.g7("CustomValueMemberPath", b, a);
        }
    }
    get e5() {
        return this.d6;
    }
    set e5(a) {
        let b = this.d6;
        this.d6 = a;
        if (b != this.d6) {
            this.g7("IdMemberPath", b, a);
        }
    }
    get dataSource() {
        return this.bq;
    }
    set dataSource(a) {
        let b = this.bq;
        this.bq = a;
        if (b != this.bq) {
            this.g7("ItemsSource", b, a);
        }
    }
    get b() {
        return this.a;
    }
    set b(a) {
        let b = this.a;
        this.a = a;
        if (b != this.a) {
            this.g7("FillBrushes", b, a);
        }
    }
    get styleMappings() {
        return this.ae;
    }
    get d() {
        return this.c;
    }
    set d(a) {
        let b = this.c;
        this.c = a;
        if (b != this.c) {
            this.g7("FillScaleMode", enumGetBox(TreemapFillScaleMode_$type, b), enumGetBox(TreemapFillScaleMode_$type, a));
        }
    }
    get bg() {
        return this.bb;
    }
    set bg(a) {
        let b = this.bb;
        this.bb = a;
        if (b != this.bb) {
            this.g7("IsFillScaleLogarithmic", b, a);
        }
    }
    get dy() {
        return this.dw;
    }
    set dy(a) {
        let b = this.dw;
        this.dw = a;
        if (b != this.dw) {
            this.g7("FillScaleLogarithmBase", b, a);
        }
    }
    get ct() {
        return this.bx;
    }
    set ct(a) {
        let b = this.bx;
        this.bx = a;
        if (b != this.bx) {
            this.g7("FillScaleMinimumValue", b, a);
        }
    }
    get cs() {
        return this.bw;
    }
    set cs(a) {
        let b = this.bw;
        this.bw = a;
        if (b != this.bw) {
            this.g7("FillScaleMaximumValue", b, a);
        }
    }
    get p() {
        return this.n;
    }
    set p(a) {
        let b = this.n;
        this.n = a;
        if (b != this.n) {
            this.g7("LabelVerticalFitMode", enumGetBox(TreemapLabelVerticalFitMode_$type, b), enumGetBox(TreemapLabelVerticalFitMode_$type, a));
        }
    }
    get o() {
        return this.p == 0 ? 1 : this.p;
    }
    get m() {
        return this.k;
    }
    set m(a) {
        let b = this.k;
        this.k = a;
        if (b != this.k) {
            this.g7("LabelHorizontalFitMode", enumGetBox(TreemapLabelHorizontalFitMode_$type, b), enumGetBox(TreemapLabelHorizontalFitMode_$type, a));
        }
    }
    get l() {
        return this.m == 0 ? 1 : this.m;
    }
    get h8() {
        return this.hx;
    }
    set h8(a) {
        let b = this.hx;
        this.hx = a;
        if (b != this.hx) {
            this.g7("OverlayHeaderHoverBackground", b, a);
        }
    }
    get h2() {
        return this.hr;
    }
    set h2(a) {
        let b = this.hr;
        this.hr = a;
        if (b != this.hr) {
            this.g7("HeaderHoverBackground", b, a);
        }
    }
    get h0() {
        return this.hp;
    }
    set h0(a) {
        let b = this.hp;
        this.hp = a;
        if (b != this.hp) {
            this.g7("HeaderBackground", b, a);
        }
    }
    get h7() {
        return this.hw;
    }
    set h7(a) {
        let b = this.hw;
        this.hw = a;
        if (b != this.hw) {
            this.g7("OverlayHeaderBackground", b, a);
        }
    }
    get h5() {
        return this.hu;
    }
    set h5(a) {
        let b = this.hu;
        this.hu = a;
        if (b != this.hu) {
            this.g7("HeaderTextColor", b, a);
        }
    }
    get h1() {
        return this.hq;
    }
    set h1(a) {
        let b = this.hq;
        this.hq = a;
        if (b != this.hq) {
            this.g7("HeaderDarkTextColor", b, a);
        }
    }
    get ij() {
        return this.hy;
    }
    set ij(a) {
        let b = this.hy;
        this.hy = a;
        if (b != this.hy) {
            this.g7("TextColor", b, a);
        }
    }
    get hz() {
        return this.ho;
    }
    set hz(a) {
        let b = this.ho;
        this.ho = a;
        if (b != this.ho) {
            this.g7("DarkTextColor", b, a);
        }
    }
    get h4() {
        return this.ht;
    }
    set h4(a) {
        let b = this.ht;
        this.ht = a;
        if (b != this.ht) {
            this.g7("HeaderHoverTextColor", b, a);
        }
    }
    get h3() {
        return this.hs;
    }
    set h3(a) {
        let b = this.hs;
        this.hs = a;
        if (b != this.hs) {
            this.g7("HeaderHoverDarkTextColor", b, a);
        }
    }
    get aw() {
        return this.at;
    }
    set aw(a) {
        let b = this.at;
        this.at = a;
        if (b != this.at) {
            this.g7("TextStyle", b, this.at);
        }
    }
    get au() {
        return this.as;
    }
    set au(a) {
        let b = this.as;
        this.as = a;
        if (b != this.as) {
            this.g7("HeaderTextStyle", b, this.as);
        }
    }
    get j() {
        return this.h;
    }
    set j(a) {
        let b = this.h;
        this.h = a;
        if (b != this.h) {
            this.g7("HeaderDisplayMode", enumGetBox(TreemapHeaderDisplayMode_$type, b), enumGetBox(TreemapHeaderDisplayMode_$type, this.h));
        }
    }
    get i() {
        return this.j == 0 ? 1 : this.j;
    }
    get cx() {
        return this.b0;
    }
    set cx(a) {
        let b = this.b0;
        this.b0 = a;
        if (b != this.b0) {
            this.g7("HeaderLabelLeftMargin", b, a);
        }
    }
    get cz() {
        return this.b2;
    }
    set cz(a) {
        let b = this.b2;
        this.b2 = a;
        if (b != this.b2) {
            this.g7("HeaderLabelTopMargin", b, a);
        }
    }
    get cy() {
        return this.b1;
    }
    set cy(a) {
        let b = this.b1;
        this.b1 = a;
        if (b != this.b1) {
            this.g7("HeaderLabelRightMargin", b, a);
        }
    }
    get cw() {
        return this.bz;
    }
    set cw(a) {
        let b = this.bz;
        this.bz = a;
        if (b != this.bz) {
            this.g7("HeaderLabelBottomMargin", b, a);
        }
    }
    get c7() {
        return this.ca;
    }
    set c7(a) {
        let b = this.ca;
        this.ca = a;
        if (b != this.ca) {
            this.g7("OverlayHeaderLabelLeftMargin", b, a);
        }
    }
    get c9() {
        return this.cc;
    }
    set c9(a) {
        let b = this.cc;
        this.cc = a;
        if (b != this.cc) {
            this.g7("OverlayHeaderLabelTopMargin", b, a);
        }
    }
    get c8() {
        return this.cb;
    }
    set c8(a) {
        let b = this.cb;
        this.cb = a;
        if (b != this.cb) {
            this.g7("OverlayHeaderLabelRightMargin", b, a);
        }
    }
    get c6() {
        return this.b9;
    }
    set c6(a) {
        let b = this.b9;
        this.b9 = a;
        if (b != this.b9) {
            this.g7("OverlayHeaderLabelBottomMargin", b, a);
        }
    }
    get c2() {
        return this.b5;
    }
    set c2(a) {
        let b = this.b5;
        this.b5 = a;
        if (b != this.b5) {
            this.g7("LabelLeftMargin", b, a);
        }
    }
    get c4() {
        return this.b7;
    }
    set c4(a) {
        let b = this.b7;
        this.b7 = a;
        if (b != this.b7) {
            this.g7("LabelTopMargin", b, a);
        }
    }
    get c3() {
        return this.b6;
    }
    set c3(a) {
        let b = this.b6;
        this.b6 = a;
        if (b != this.b6) {
            this.g7("LabelRightMargin", b, a);
        }
    }
    get c1() {
        return this.b4;
    }
    set c1(a) {
        let b = this.b4;
        this.b4 = a;
        if (b != this.b4) {
            this.g7("LabelBottomMargin", b, a);
        }
    }
    get dc() {
        return this.cf;
    }
    set dc(a) {
        let b = this.cf;
        this.cf = a;
        if (b != this.cf) {
            this.g7("ParentNodeLeftMargin", b, a);
        }
    }
    get dg() {
        return this.cj;
    }
    set dg(a) {
        let b = this.cj;
        this.cj = a;
        if (b != this.cj) {
            this.g7("ParentNodeTopMargin", b, a);
        }
    }
    get de() {
        return this.ch;
    }
    set de(a) {
        let b = this.ch;
        this.ch = a;
        if (b != this.ch) {
            this.g7("ParentNodeRightMargin", b, a);
        }
    }
    get da() {
        return this.cd;
    }
    set da(a) {
        let b = this.cd;
        this.cd = a;
        if (b != this.cd) {
            this.g7("ParentNodeBottomMargin", b, a);
        }
    }
    get dd() {
        return this.cg;
    }
    set dd(a) {
        let b = this.cg;
        this.cg = a;
        if (b != this.cg) {
            this.g7("ParentNodeLeftPadding", b, a);
        }
    }
    get dh() {
        return this.ck;
    }
    set dh(a) {
        let b = this.ck;
        this.ck = a;
        if (b != this.ck) {
            this.g7("ParentNodeTopPadding", b, a);
        }
    }
    get df() {
        return this.ci;
    }
    set df(a) {
        let b = this.ci;
        this.ci = a;
        if (b != this.ci) {
            this.g7("ParentNodeRightPadding", b, a);
        }
    }
    get db() {
        return this.ce;
    }
    set db(a) {
        let b = this.ce;
        this.ce = a;
        if (b != this.ce) {
            this.g7("ParentNodeBottomPadding", b, a);
        }
    }
    get hm() {
        return this.hl;
    }
    set hm(a) {
        let b = this.hl;
        this.hl = a;
        if (b != this.hl) {
            this.g7("LabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
        }
    }
    get iq() {
        return this.ip;
    }
    set iq(a) {
        let b = this.ip;
        this.ip = a;
        if (b != this.ip) {
            this.g7("LabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
        }
    }
    get cv() {
        return this.by;
    }
    set cv(a) {
        let b = this.by;
        this.by = a;
        if (b != this.by) {
            this.g7("HeaderHeight", b, a);
        }
    }
    get h6() {
        return this.hv;
    }
    set h6(a) {
        let b = this.hv;
        this.hv = a;
        if (b != this.hv) {
            this.g7("Outline", b, a);
        }
    }
    get dt() {
        return this.cm;
    }
    set dt(a) {
        let b = this.cm;
        this.cm = a;
        if (b != this.cm) {
            this.g7("StrokeThickness", b, a);
        }
    }
    get ai() {
        return this.ah;
    }
    set ai(a) {
        let b = this.ah;
        this.ah = a;
        if (b != this.ah) {
            this.g7("LayoutOrientation", enumGetBox(TreemapOrientation_$type, b), enumGetBox(TreemapOrientation_$type, a));
        }
    }
    get s() {
        return this.r;
    }
    set s(a) {
        let b = this.r;
        this.r = a;
        if (b != this.r) {
            this.g7("LayoutType", enumGetBox(TreemapLayoutType_$type, b), enumGetBox(TreemapLayoutType_$type, a));
        }
    }
    get c5() {
        return this.b8;
    }
    set c5(a) {
        let b = this.b8;
        this.b8 = a;
        if (b != this.b8) {
            this.g7("MinimumDisplaySize", b, a);
        }
    }
    get d1() {
        return this.dx;
    }
    set d1(a) {
        let b = this.dx;
        this.dx = a;
        if (b != this.dx) {
            this.g7("TransitionDuration", b, a);
        }
    }
    get du() {
        return this.cn;
    }
    set du(a) {
        let b = this.cn;
        this.cn = a;
        if (b != this.cn) {
            this.g7("TransitionProgress", b, a);
        }
    }
    get ar() {
        return this.aq;
    }
    set ar(a) {
        let b = this.aq;
        this.aq = a;
        if (b != this.aq) {
            this.g7("FastItemsSource", b, this.aq);
        }
    }
    get a8() {
        return this.a1;
    }
    set a8(a) {
        this.a1 = a;
    }
    get a2() {
        return this.ax;
    }
    set a2(a) {
        this.ax = a;
    }
    get a5() {
        return this.a0;
    }
    set a5(a) {
        this.a0 = a;
    }
    get a3() {
        return this.ay;
    }
    set a3(a) {
        this.ay = a;
    }
    get a4() {
        return this.az;
    }
    set a4(a) {
        this.az = a;
    }
    get di() {
        return this.cl;
    }
    set di(a) {
        let b = this.cl;
        this.cl = a;
        if (b != this.cl) {
            this.g7("PixelScalingRatio", b, a);
        }
    }
    get cp() {
        return this.bt;
    }
    set cp(a) {
        let b = this.bt;
        this.bt = a;
        if (b != this.bt) {
            this.g7("ActualPixelScalingRatio", b, a);
        }
    }
    get c0() {
        return this.b3;
    }
    set c0(a) {
        let b = this.b3;
        this.b3 = a;
        if (b != this.b3) {
            this.g7("InteractionPixelScalingRatio", b, a);
        }
    }
    get co() {
        return this.bs;
    }
    set co(a) {
        let b = this.bs;
        this.bs = a;
        if (b != this.bs) {
            this.g7("ActualInteractionPixelScalingRatio", b, a);
        }
    }
    a6(a) {
        let b = null;
        return this.ar.registerColumn(a, b, false);
    }
    a7(a) {
        let b = null;
        return this.ar.registerColumnObject(a, b, false);
    }
    gt() {
        this.bf = true;
        this.an.az();
    }
    get bc() {
        return this.ap.f();
    }
    ak() {
        let a = new TreemapTreeData();
        if (this.a8 == null || (this.a4 == null && this.a3 == null)) {
            return null;
        }
        for (let b = 0; b < this.ar.count; b++) {
            let c = null;
            if (this.a2 != null && this.a2.count > b) {
                c = this.a2.item(b);
            }
            let d = this.a8.item(b);
            let e = null;
            let f = "";
            if (this.a4 != null) {
                f = this.a4.item(b) != null ? this.a4.item(b).toString() : "";
            }
            if (this.a3 != null) {
                if (this.a3.item(b) == null) {
                    continue;
                }
                e = stringReplace(this.a3.item(b).toString(), " ", "_");
            }
            if (e == null) {
                e = stringReplace(f, " ", "_");
                if (stringIsNullOrEmpty(e)) {
                    continue;
                }
            }
            let g = null;
            if (this.a5 != null) {
                g = this.a5.item(b) != null ? stringReplace(this.a5.item(b).toString(), " ", "_") : null;
            }
            let h = new TreemapTreeNode();
            h.i = e;
            h.k = g;
            h.h = this.ar.item(b);
            h.f = d;
            h.g = c;
            h.j = f;
            a.e(h);
        }
        a.f();
        return a;
    }
    hb() {
        if (this.aj == null) {
            this.aj = this.ak();
            if (this.aj == null) {
                return;
            }
            this.g1();
        }
        if (this.bi) {
            this.bi = false;
            for (let a = 0; a < this.aj.d.count; a++) {
                let b = this.aj.b.item(this.aj.d._inner[a]);
                b.c.clear();
                for (let c = 0; c < this.styleMappings.count; c++) {
                    if (this.bd(this.styleMappings._inner[c], b)) {
                        b.c.add(this.styleMappings._inner[c]);
                    }
                }
            }
        }
        if (!this.an.n()) {
            return;
        }
        let d = new TreemapLayoutSettings();
        d.b = this.aj;
        if (this.al != null && !this.aj.b.containsKey(this.al.i)) {
            this.al = null;
            this.hi(null);
        }
        else {
            if (this.al != null) {
                let e = this.aj.b.item(this.al.i);
                if (e != this.al) {
                    this.al = e;
                    this.hi(this.al);
                }
            }
        }
        d.h = this.io;
        d.c = this.al;
        d.f = this.c5;
        d.a = this.ai;
        let f = this.i;
        let g = this.dk();
        let h = this.dm();
        let i = this.dl();
        let j = this.dj();
        let k = this.dp();
        let l = this.dr();
        let m = this.dq();
        let n = this.dn();
        let o = this.hn();
        let p = this.ir();
        let q = this.an.v("M");
        let r = this.an.x("M");
        let s = q + h + j;
        let t = r + l + n;
        d.j = new Thickness(1, this.dd, this.dh, this.df, this.db);
        d.i = new Thickness(1, this.dc, this.dg, this.de, this.da);
        if (!isNaN_(this.cv)) {
            s = this.cv;
        }
        d.e = s;
        if (f == 2) {
            d.e = 0;
        }
        d.d = this.al == null;
        this.q.d(this.f, d);
        let u = 1.7976931348623157E+308;
        let v = -1.7976931348623157E+308;
        if (this.d == 1 || this.d == 3) {
            for (let w = 0; w < this.aj.d.count; w++) {
                let x = 0;
                if (this.d == 1) {
                    x = this.aj.b.item(this.aj.d._inner[w]).e();
                }
                else {
                    x = this.aj.b.item(this.aj.d._inner[w]).f;
                }
                if (!isNaN_(x)) {
                    u = Math.min(x, u);
                    v = Math.max(x, v);
                }
            }
        }
        else {
            for (let y = 0; y < this.f.e.count; y++) {
                let z = 0;
                if (this.d == 0) {
                    z = this.aj.b.item(this.f.e._inner[y]).e();
                }
                else {
                    z = this.aj.b.item(this.f.e._inner[y]).f;
                }
                if (!isNaN_(z)) {
                    u = Math.min(z, u);
                    v = Math.max(z, v);
                }
            }
        }
        for (let aa = 0; aa < this.f.e.count; aa++) {
            let ab = this.f.e._inner[aa];
            let ac = this.aj.b.item(ab);
            let ad = this.h9(ac, u, v);
            let ae = this.ie(ac);
            let af = this.ia(ac);
            let ag = this.ds(ac);
            let ah = this.f7(this.f, ac, g, i, k, m, s, t);
            let ai = this.id(ac, ad, af);
            let aj = this.av(ac);
            let ak = 0;
            if (this.bh(ac)) {
                ak = this.an.w(ah);
            }
            else {
                ak = this.an.y(ah);
            }
            let al = 0;
            if (this.bh(ac)) {
                al = s;
            }
            else {
                al = this.an.x(ah);
            }
            this.f.l(ac, ah, ad, ae, af, ai, ag, f, ak, al, g, h, i, j, k, l, m, n, o, p);
            if (ac.c.count > 0) {
                for (let am = 0; am < ac.c.count; am++) {
                    let an = ac.b != null && ac.b.count > 0;
                    if (ac.c._inner[am].bf == 2 && an) {
                        continue;
                    }
                    this.f.f(ac, ac.c._inner[am], runOn(this, this.id));
                }
            }
            if (this.nodeStyling != null) {
                let ao = new TreemapNodeStylingEventArgs();
                ao.item = ac.h;
                if (ac.k != null) {
                    if (this.aj.b.containsKey(ac.k)) {
                        let ap = this.aj.b.item(ac.k);
                        ao.parentItem = ap.h;
                        ao.parentLabel = ap.j;
                        ao.parentSum = ap.e();
                        ao.parentValue = ap.f;
                    }
                }
                ao.sum = ac.e();
                ao.value = ac.f;
                ao.label = ac.j;
                ao.customValue = ac.g;
                if (ac.b != null && ac.b.count > 0) {
                    ao.isParent = true;
                }
                ao.style = new TreemapNodeStyle();
                this.nodeStyling(this, ao);
                this.f.f(ac, ao.style, runOn(this, this.id));
            }
        }
    }
    bh(a) {
        return a.b != null && a.b.count > 0;
    }
    dn() {
        return this.c1;
    }
    dq() {
        return this.c3;
    }
    dr() {
        return this.c4;
    }
    dp() {
        return this.c2;
    }
    hn() {
        return this.hm;
    }
    ir() {
        return this.iq;
    }
    dj() {
        if (this.i == 2) {
            return this.c6;
        }
        return this.cw;
    }
    dl() {
        if (this.i == 2) {
            return this.c8;
        }
        return this.cy;
    }
    dm() {
        if (this.i == 2) {
            return this.c9;
        }
        return this.cz;
    }
    dk() {
        if (this.i == 2) {
            return this.c6;
        }
        return this.cx;
    }
    gg(a, b, c, d, e) {
        let f = b.length;
        let g = b;
        let h = ("\u2026");
        if (isNaN_(this.bu)) {
            if (this.bh(a)) {
                this.bu = this.an.w(h);
            }
            else {
                this.bu = this.an.y(h);
            }
        }
        if (c <= (this.bu + d + e)) {
            if (this.l == 2) {
                return "";
            }
            return h;
        }
        let i = 0;
        if (this.bh(a)) {
            i = this.an.w(b);
        }
        else {
            i = this.an.y(b);
        }
        if (i + d + e <= c) {
            return b;
        }
        let j = c / (i + d + e);
        let k = truncate(Math.ceil(f * j));
        let l = b.substr(0, k) + h;
        let m = 0;
        if (this.bh(a)) {
            m = this.an.w(l);
        }
        else {
            m = this.an.y(l);
        }
        if ((m + d + e) > c) {
            f = k;
        }
        else {
            k = k + 1;
            l = b.substr(0, k) + h;
            if (this.bh(a)) {
                m = this.an.w(l);
            }
            else {
                m = this.an.y(l);
            }
            if ((m + d + e) > c) {
                f = k;
            }
        }
        while ((i + d + e) > c && f > 0) {
            f--;
            b = b.substr(0, f) + h;
            if (this.l == 2) {
                return "";
            }
            if (this.bh(a)) {
                i = this.an.w(b);
            }
            else {
                i = this.an.y(b);
            }
        }
        return b;
    }
    f7(a, b, c, d, e, f, g, h) {
        if (b == null) {
            if (this.ed != null && this.f8 != null && !stringIsNullOrEmpty(this.f8)) {
                return this.f8 + this.ed;
            }
            return "";
        }
        let i = a.o(b);
        let j = i.width;
        let k = i.height;
        let l = b.j;
        if (this.al != null && this.al == b && this.ed != null) {
            let m = null;
            let n = b;
            while (n.k != null) {
                if (this.aj.b.containsKey(n.k)) {
                    m = this.aj.b.item(n.k);
                    if (m.j != null) {
                        l = m.j + this.ed + l;
                    }
                    n = m;
                }
            }
            if (this.f8 != null && !stringIsNullOrEmpty(this.f8)) {
                l = this.f8 + this.ed + l;
            }
        }
        let o = 0;
        let p = 0;
        if (a.c(b.i)) {
            let q = a.a(b.i);
            if (b.b.count > 0) {
                o = c;
                p = d;
                if (this.o == 2) {
                    if (k < g) {
                        return "";
                    }
                }
            }
            else {
                o = e;
                p = f;
                if (this.o == 2) {
                    if (k < h) {
                        return "";
                    }
                }
            }
        }
        return this.gg(b, l, j, o, p);
    }
    ds(a) {
        if (!isNaN_(this.dt)) {
            return this.dt;
        }
        return this.bv;
    }
    ia(a) {
        if (this.i == 2) {
            return this.ig(a);
        }
        if (a == this.am) {
            return this.ib(a);
        }
        if (this.h0 != null) {
            return this.h0;
        }
        return this.an.a4();
    }
    ig(a) {
        if (a == this.am) {
            return this.ih(a);
        }
        if (this.h7 != null) {
            return this.h7;
        }
        return this.an.a9();
    }
    id(a, b, c) {
        if (a.b.count > 0) {
            if (a == this.am) {
                return this.ic(a, c);
            }
            let d = this.an.a5();
            let e = this.an.a6();
            if (this.h5 != null) {
                e = this.h5;
            }
            if (this.h1 != null) {
                d = this.h1;
            }
            return BrushUtil.i(c, d, e);
        }
        else {
            let f = this.an.a3();
            let g = this.an.bb();
            if (this.ij != null) {
                g = this.ij;
            }
            if (this.hz != null) {
                f = this.hz;
            }
            return BrushUtil.i(b, f, g);
        }
    }
    av(a) {
        if (a.b.count > 0) {
            if (this.au != null) {
                return this.au;
            }
            return this.an.h();
        }
        else {
            if (this.aw != null) {
                return this.aw;
            }
            return this.an.h();
        }
    }
    onDetachedFromUI() {
        this.an.as();
    }
    onAttachedToUI() {
        this.an.aq();
    }
    ib(a) {
        if (this.h2 != null) {
            return this.h2;
        }
        return this.an.a7();
    }
    ih(a) {
        if (this.h8 != null) {
            return this.h8;
        }
        return this.an.ba();
    }
    ic(a, b) {
        let c = this.an.a5();
        let d = this.an.a6();
        if (this.h5 != null) {
            d = this.h5;
        }
        if (this.h1 != null) {
            c = this.h1;
        }
        if (this.h4 != null) {
            d = this.h4;
        }
        if (this.h3 != null) {
            c = this.h3;
        }
        return BrushUtil.i(b, c, d);
    }
    ie(a) {
        if (this.h6 != null) {
            return this.h6;
        }
        return this.an.a8();
    }
    h9(a, b, c) {
        if (this.b == null || this.b.count == 0) {
            return this.ii(a);
        }
        let d = this.cu(a);
        if (isNaN_(d)) {
            return this.ii(a);
        }
        let e = 0;
        if (this.bg && this.dy > 0) {
            if (d > 0) {
                e = (logBase(d, this.dy) - logBase(b, this.dy)) / (logBase(c, this.dy) - logBase(b, this.dy));
            }
            else {
                return this.ii(a);
            }
        }
        else {
            e = (d - b) / (c - b);
        }
        e = e * (this.b.count - 1);
        return BrushCollectionUtil.b(this.b, e);
    }
    cu(a) {
        switch (this.d) {
            case 0:
            case 1: return a.e();
            case 2:
            case 3: return a.f;
        }
        return a.e();
    }
    ii(a) {
        return this.an.a4();
    }
    he(a) {
        let b = new List$1(TreemapVisual.$, 0);
        let c = this.an.i();
        let d = 0;
        if (this.i == 2) {
            d = this.d0(a, false, d, c, (e) => true, b);
            d = this.d0(a, true, d, c, (e) => e.e.b != null && e.e.b.count > 0, b);
        }
        else {
            d = this.d0(a, false, d, c, (e) => true, b);
        }
        c.count = d;
        this.an.af(b);
    }
    d0(a, b, c, d, e, f) {
        for (let g = 0; g < a.e.count; g++) {
            let h = a.e._inner[g];
            let i = a.a(h);
            if (!e(i)) {
                continue;
            }
            let j = d.item(c);
            if (i.y.isEmpty || (i.y.width == 0 && i.y.height == 0)) {
                j.t = 1;
                continue;
            }
            c++;
            f.add(j);
            let k = i.e.b.count == 0;
            let l = !k && i.a == 2;
            j.a = this.av(i.e);
            j.i = i.u;
            j.l = i.x;
            j.j = i.v;
            j.n = new Thickness(1, i.i, i.k, i.j, i.h);
            j.o = new Thickness(1, i.n, i.p, i.o, i.m);
            j.k = i.w;
            j.g = i.s;
            j.f = i.q;
            j.t = 0;
            j.m = this.im(i.y, i.q);
            j.b = k;
            j.q = !k && !l ? 0 : 1;
            j.s = !k && l ? 0 : 1;
            j.r = k ? 0 : 1;
            j.e = i.l;
            j.d = i.g;
            j.h = i.t;
            j.p = i.z;
            if (!b && !k && l) {
                j.s = 1;
            }
            if (b && !k && l) {
                j.i = null;
                j.l = null;
            }
        }
        return c;
    }
    im(a, b) {
        let c = this.cq(Math.floor(a.left), b);
        let d = this.cq(Math.floor(a.right), b);
        let e = this.cq(Math.floor(a.top), b);
        let f = this.cq(Math.floor(a.bottom), b);
        return new Rect(0, c, e, d - c, f - e);
    }
    cq(a, b) {
        let c = a;
        if (b > 0) {
            let d = b % 2;
            if (d == 0 || d == 1) {
                let e = 1;
                c = Math.floor(a);
                if (c + 0.5 < a) {
                    e = -1;
                    c = Math.ceil(a);
                }
                if (d == 1) {
                    c += 0.5 * e;
                }
            }
        }
        return c;
    }
    bm() {
        return !this.io.isEmpty && this.an.n();
    }
    hf() {
        if (!this.bm()) {
            return;
        }
        if (this.bf) {
            let a = this.g;
            if (this.bc) {
                if (this.ap.g) {
                    this.ap.t();
                }
                this.g = this.e;
                this.e = a;
            }
            else {
                this.g = this.f;
                this.f = a;
            }
        }
        else if (this.bc) {
            this.e.h(this.du, this.g, this.f);
            this.he(this.e);
        }
        if (this.bf) {
            this.hb();
        }
        if (this.bf && this.bn) {
            this.hg();
            this.e.h(this.du, this.g, this.f);
            this.he(this.e);
        }
        else {
            if (this.bf) {
                this.he(this.f);
            }
        }
        this.bf = false;
        this.an.ay();
    }
    bd(a, b) {
        let c = null;
        switch (a.bh) {
            case 1:
                c = b.f;
                break;
            case 0:
                c = b.e();
                break;
            case 2:
                c = b.g;
                break;
        }
        if (this.bj(c)) {
            let d = this.cr(c);
            if (a.bn != null) {
                if (this.bj(a.bn)) {
                    let e = this.cr(a.bn);
                    if (isNaN_(e) && isNaN_(d)) {
                        return true;
                    }
                    if (d == e) {
                        return true;
                    }
                }
            }
            else if (!isNaN_(a.bl) || !isNaN_(a.bk)) {
                let f = a.bl;
                let g = a.bk;
                if (d >= f && d <= g) {
                    return true;
                }
            }
        }
        else if (this.bl(c)) {
            if (a.bn != null) {
                if (this.bl(a.bn)) {
                    let h = (a.bn);
                    if (Base.equalsStatic(h, c)) {
                        return true;
                    }
                }
            }
        }
        else {
            if (Base.equalsStatic(c, a.bn)) {
                return true;
            }
        }
        return false;
    }
    bl(a) {
        return typeof a === 'string';
    }
    cr(a) {
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        if (typeof a === 'number') {
            return typeGetValue(a);
        }
        if (typeof a === 'number') {
            return a;
        }
        return NaN;
    }
    bj(a) {
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        if (typeof a === 'number') {
            return true;
        }
        return false;
    }
    u(a) {
        let b = this.f;
        if (this.bc) {
            b = this.e;
        }
        let c = new List$1(TreemapNodeFrame.$, 0);
        for (let d = 0; d < b.e.count; d++) {
            let e = b.e._inner[d];
            let f = b.a(e);
            if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                c.add(f);
            }
        }
        c.aa((g, h) => {
            let i = this.dz(h);
            let j = this.dz(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        for (let g of fromEnum(c)) {
            if (g.e.b.count > 0) {
                return g;
            }
        }
        return null;
    }
    dz(a) {
        let b = a.e;
        let c = 0;
        while (b.k != null) {
            if (this.aj == null) {
                break;
            }
            if (this.aj.b.containsKey(b.k)) {
                c++;
                b = this.aj.b.item(b.k);
            }
            else {
                break;
            }
        }
        return c;
    }
    v(a) {
        let b = this.f;
        if (this.bc) {
            b = this.e;
        }
        let c = new List$1(TreemapNodeFrame.$, 0);
        for (let d = 0; d < b.e.count; d++) {
            let e = b.e._inner[d];
            let f = b.a(e);
            if (a.x >= f.y.left && a.x <= f.y.right && a.y >= f.y.top && a.y <= f.y.bottom) {
                c.add(f);
            }
        }
        c.aa((g, h) => {
            let i = this.dz(h);
            let j = this.dz(g);
            if (i > j) {
                return 1;
            }
            else if (j > i) {
                return -1;
            }
            return 0;
        });
        if (this.i == 2) {
            for (let g of fromEnum(c)) {
                if (g.e.b.count > 0) {
                    if (this.bk(a, g)) {
                        return g;
                    }
                }
            }
        }
        for (let h of fromEnum(c)) {
            return h;
        }
        return null;
    }
    hg() {
        this.cn = 0;
        this.ap.w();
        this.ap.v();
        this.an.av();
    }
    get bn() {
        return this.d1 > 0;
    }
    provideContainer(a) {
        this.an.ar(a);
        this.ap.u(a);
    }
    gr() {
        this.an.am();
    }
    get x() {
        return this.t;
    }
    set x(a) {
        let b = this.t;
        this.t = a;
        if (b != a) {
            this.gs(b);
            this.gq(a);
        }
    }
    gq(a) {
        if (a != null) {
            if (this.nodePointerEnter != null) {
                this.nodePointerEnter(this, this.y(a));
            }
        }
    }
    gs(a) {
        if (a != null) {
            if (this.nodePointerLeave != null) {
                this.nodePointerLeave(this, this.y(a));
            }
        }
    }
    y(a) {
        let b = new TreemapNodePointerEventArgs();
        if (a != null) {
            b.customValue = a.e.g;
            b.item = a.e.h;
            b.position = this.ik;
            b.sum = a.e.e();
            b.value = a.e.f;
            b.label = a.e.j;
            b.isOverHeader = this.bk(this.ik, a);
            if (a.e.k != null && this.aj != null && this.aj.b.containsKey(a.e.k)) {
                let c = this.aj.b.item(a.e.k);
                b.parentItem = c.h;
                b.parentSum = c.e();
                b.parentValue = c.f;
                b.parentLabel = c.j;
            }
        }
        b.isRightButton = false;
        return b;
    }
    get d3() {
        return this.d2;
    }
    set d3(a) {
        let b = this.d2;
        this.d2 = a;
        if (b != this.d2) {
            this.g7("FocusItem", b, a);
        }
    }
    g2(a) {
        this.hk(a);
        if (this.nodePointerPressed != null && this.x != null) {
            let b = this.y(this.x);
            this.nodePointerPressed(this, b);
        }
    }
    g6(a) {
        this.hk(a);
        let b = false;
        if (this.nodePointerReleased != null && this.x != null) {
            let c = this.y(this.x);
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            if (this.w != null) {
                if (this.w.e == this.al && this.bk(a, this.w)) {
                    this.al = null;
                    this.bf = true;
                    this.an.az();
                    this.hi(null);
                    return;
                }
                this.al = this.w.e;
                this.hi(this.w.e);
                this.bf = true;
                this.an.az();
            }
            else {
                this.al = null;
                this.bf = true;
                this.hi(null);
                this.an.az();
            }
        }
    }
    hi(a) {
        try {
            this.ba = true;
            if (a == null) {
                this.d3 = null;
            }
            else {
                this.d3 = a.h;
            }
            this.ba = false;
        }
        finally {
            this.ba = false;
        }
    }
    bk(a, b) {
        let c = this.f;
        if (this.bc) {
            c = this.e;
        }
        if (b == null) {
            return false;
        }
        let d = b;
        if (a.x >= d.y.left && a.x <= d.y.right && a.y >= d.y.top && a.y <= d.y.bottom) {
            if (a.y - d.y.top <= d.g) {
                return true;
            }
        }
        return false;
    }
    gx(source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        let d = this.ar;
        if (d == null) {
            return;
        }
        d.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, c, b, a));
    }
    gu(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        let a = this.ar;
        a.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
    }
    bo(a) {
        return Treemap.bp(a, this.dataSource);
    }
    static bp(a, b) {
        return a == b;
    }
    gv(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        let c = this.ar;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, b, a));
    }
    gw(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (!this.bo(source_)) {
            return;
        }
        let c = this.ar;
        if (c == null) {
            return;
        }
        c.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, b, a));
    }
    g3(a) {
        this.hk(a);
    }
    g4(a) {
        this.hk(a);
        this.w = null;
        this.x = null;
        if (!this.bc) {
            this.bf = true;
            this.an.az();
        }
    }
    hk(a) {
        this.ik = { $type: Point_$type, x: a.x, y: a.y };
        this.w = this.u(a);
        this.x = this.v(a);
        this.hj(a);
    }
    g5(a) {
        this.hk(a);
        if (this.x != null) {
            if (this.nodePointerOver != null) {
                this.nodePointerOver(this, this.y(this.x));
            }
        }
    }
    hj(a) {
        if (!this.bc) {
            if (this.bk(a, this.w)) {
                let b = this.am;
                this.am = this.w.e;
                if (this.am != b) {
                    this.bf = true;
                    this.an.az();
                }
            }
            else {
                let c = this.am;
                this.am = null;
                if (this.am != c) {
                    this.bf = true;
                    this.an.az();
                }
            }
        }
    }
    g8(a) {
        this.hk(a);
        if (this.nodePointerPressed != null && this.x != null) {
            let b = this.y(this.x);
            b.isRightButton = true;
            this.nodePointerPressed(this, b);
        }
    }
    g9(a) {
        this.hk(a);
        let b = false;
        if (this.nodePointerReleased != null && this.x != null) {
            let c = this.y(this.x);
            c.isRightButton = true;
            this.nodePointerReleased(this, c);
            b = c.isHandled;
        }
        if (!b) {
            this.w = null;
            this.al = null;
            this.hi(null);
            this.bf = true;
            this.an.az();
        }
    }
    ha(a) {
        this.bf = true;
        this.an.az();
    }
}
Treemap.$t = markType(Treemap, 'Treemap', Base.$, [INotifyPropertyChanged_$type]);
/**
 * @hidden
 */
class TreemapNodeStyle extends Base {
    constructor() {
        super(...arguments);
        this.a = null;
        this.c = new HashSet$1(String_$type, 0);
        this.a0 = null;
        this.az = null;
        this.a2 = null;
        this.x = null;
        this.a4 = null;
        this.a1 = null;
        this.f = DeviceUtils.g(5);
        this.h = DeviceUtils.g(3);
        this.g = DeviceUtils.g(5);
        this.e = DeviceUtils.g(3);
        this.j = DeviceUtils.g(5);
        this.l = DeviceUtils.g(3);
        this.k = DeviceUtils.g(5);
        this.i = DeviceUtils.g(3);
        this.d = NaN;
        this.aw = 1;
        this.bc = 1;
        this.ay = null;
        this.a3 = null;
        this.m = NaN;
        this.propertyChanged = null;
    }
    au(a, b, c) {
        if (this.propertyChanged != null) {
            this.propertyChanged(this, new PropertyChangedEventArgs(a));
        }
        this.av(a, b, c);
    }
    at() {
        this.c.clear();
    }
    b(a) {
        return this.c.contains(a);
    }
    av(a, b, c) {
        if (!this.c.contains(a)) {
            this.c.add_1(a);
        }
        if (this.a != null) {
            this.a.ha(this);
        }
    }
    get a7() {
        return this.a0;
    }
    set a7(a) {
        let b = this.a0;
        this.a0 = a;
        if (b != this.a0) {
            this.au("HeaderHoverBackground", b, a);
        }
    }
    get a6() {
        return this.az;
    }
    set a6(a) {
        let b = this.az;
        this.az = a;
        if (b != this.az) {
            this.au("HeaderBackground", b, a);
        }
    }
    get a9() {
        return this.a2;
    }
    set a9(a) {
        let b = this.a2;
        this.a2 = a;
        if (b != this.a2) {
            this.au("HeaderTextColor", b, a);
        }
    }
    get ai() {
        return this.x;
    }
    set ai(a) {
        let b = this.x;
        this.x = a;
        if (b != this.x) {
            this.au("Label", b, a);
        }
    }
    get bb() {
        return this.a4;
    }
    set bb(a) {
        let b = this.a4;
        this.a4 = a;
        if (b != this.a4) {
            this.au("TextColor", b, a);
        }
    }
    get a8() {
        return this.a1;
    }
    set a8(a) {
        let b = this.a1;
        this.a1 = a;
        if (b != this.a1) {
            this.au("HeaderHoverTextColor", b, a);
        }
    }
    get p() {
        return this.f;
    }
    set p(a) {
        let b = this.f;
        this.f = a;
        if (b != this.f) {
            this.au("HeaderLabelLeftMargin", b, a);
        }
    }
    get r() {
        return this.h;
    }
    set r(a) {
        let b = this.h;
        this.h = a;
        if (b != this.h) {
            this.au("HeaderLabelTopMargin", b, a);
        }
    }
    get q() {
        return this.g;
    }
    set q(a) {
        let b = this.g;
        this.g = a;
        if (b != this.g) {
            this.au("HeaderLabelRightMargin", b, a);
        }
    }
    get o() {
        return this.e;
    }
    set o(a) {
        let b = this.e;
        this.e = a;
        if (b != this.e) {
            this.au("HeaderLabelBottomMargin", b, a);
        }
    }
    get t() {
        return this.j;
    }
    set t(a) {
        let b = this.j;
        this.j = a;
        if (b != this.j) {
            this.au("LabelLeftMargin", b, a);
        }
    }
    get v() {
        return this.l;
    }
    set v(a) {
        let b = this.l;
        this.l = a;
        if (b != this.l) {
            this.au("LabelTopMargin", b, a);
        }
    }
    get u() {
        return this.k;
    }
    set u(a) {
        let b = this.k;
        this.k = a;
        if (b != this.k) {
            this.au("LabelRightMargin", b, a);
        }
    }
    get s() {
        return this.i;
    }
    set s(a) {
        let b = this.i;
        this.i = a;
        if (b != this.i) {
            this.au("LabelBottomMargin", b, a);
        }
    }
    get n() {
        return this.d;
    }
    set n(a) {
        let b = this.d;
        this.d = a;
        if (b != this.d) {
            this.au("HeaderHeight", b, a);
        }
    }
    get ax() {
        return this.aw;
    }
    set ax(a) {
        let b = this.aw;
        this.aw = a;
        if (b != this.aw) {
            this.au("LabelHorizontalAlignment", enumGetBox(HorizontalAlignment_$type, b), enumGetBox(HorizontalAlignment_$type, a));
        }
    }
    get bd() {
        return this.bc;
    }
    set bd(a) {
        let b = this.bc;
        this.bc = a;
        if (b != this.bc) {
            this.au("LabelVerticalAlignment", enumGetBox(VerticalAlignment_$type, b), enumGetBox(VerticalAlignment_$type, a));
        }
    }
    get a5() {
        return this.ay;
    }
    set a5(a) {
        let b = this.ay;
        this.ay = a;
        if (b != this.ay) {
            this.au("Fill", b, a);
        }
    }
    get ba() {
        return this.a3;
    }
    set ba(a) {
        let b = this.a3;
        this.a3 = a;
        if (b != this.a3) {
            this.au("Outline", b, a);
        }
    }
    get w() {
        return this.m;
    }
    set w(a) {
        let b = this.m;
        this.m = a;
        if (b != this.m) {
            this.au("StrokeThickness", b, a);
        }
    }
}
TreemapNodeStyle.$t = markType(TreemapNodeStyle, 'TreemapNodeStyle', Base.$, [INotifyPropertyChanged_$type]);
/**
 * @hidden
 */
class TreemapNodeStyleMapping extends TreemapNodeStyle {
    constructor() {
        super(...arguments);
        this.be = 0;
        this.bo = null;
        this.bj = NaN;
        this.bi = NaN;
        this.bm = null;
        this.bg = 1;
    }
    get bf() {
        return this.be;
    }
    set bf(a) {
        let b = this.be;
        this.be = a;
        if (b != this.be) {
            this.au("TargetType", enumGetBox(TreemapNodeStyleMappingTargetType_$type, b), enumGetBox(TreemapNodeStyleMappingTargetType_$type, a));
        }
    }
    get bs() {
        return this.bo;
    }
    set bs(a) {
        let b = this.bo;
        this.bo = a;
        if (b != this.bo) {
            this.au("Name", b, a);
        }
    }
    get bl() {
        return this.bj;
    }
    set bl(a) {
        let b = this.bj;
        this.bj = a;
        if (b != this.bj) {
            this.au("MinimumValue", b, a);
        }
    }
    get bk() {
        return this.bi;
    }
    set bk(a) {
        let b = this.bi;
        this.bi = a;
        if (b != this.bi) {
            this.au("MaximumValue", b, a);
        }
    }
    get bn() {
        return this.bm;
    }
    set bn(a) {
        let b = this.bm;
        this.bm = a;
        if (b != this.bm) {
            this.au("Value", b, a);
        }
    }
    get bh() {
        return this.bg;
    }
    set bh(a) {
        let b = this.bg;
        this.bg = a;
        if (b != this.bg) {
            this.au("MappingMode", enumGetBox(TreemapValueMappingMode_$type, b), enumGetBox(TreemapValueMappingMode_$type, a));
        }
    }
}
TreemapNodeStyleMapping.$t = markType(TreemapNodeStyleMapping, 'TreemapNodeStyleMapping', TreemapNodeStyle.$);
/**
 * @hidden
 */
class TreemapNodeStyleMappingCollection extends ObservableCollection$1 {
    constructor() {
        super(TreemapNodeStyleMapping.$, 0);
        this.collectionResetting = null;
    }
    p() {
        if (this.collectionResetting != null) {
            this.collectionResetting(this, null);
        }
        super.p();
    }
}
TreemapNodeStyleMappingCollection.$t = markType(TreemapNodeStyleMappingCollection, 'TreemapNodeStyleMappingCollection', ObservableCollection$1.$.specialize(TreemapNodeStyleMapping.$));
/**
 * @hidden
 */
class TreemapNodeStylingEventArgs extends EventArgs {
    constructor() {
        super(...arguments);
        this._value = 0;
        this._sum = 0;
        this._customValue = null;
        this._item = null;
        this._parentItem = null;
        this._label = null;
        this._parentValue = 0;
        this._parentLabel = null;
        this._parentSum = 0;
        this._isParent = false;
        this._style = null;
    }
    get value() {
        return this._value;
    }
    set value(a) {
        this._value = a;
    }
    get sum() {
        return this._sum;
    }
    set sum(a) {
        this._sum = a;
    }
    get customValue() {
        return this._customValue;
    }
    set customValue(a) {
        this._customValue = a;
    }
    get item() {
        return this._item;
    }
    set item(a) {
        this._item = a;
    }
    get parentItem() {
        return this._parentItem;
    }
    set parentItem(a) {
        this._parentItem = a;
    }
    get label() {
        return this._label;
    }
    set label(a) {
        this._label = a;
    }
    get parentValue() {
        return this._parentValue;
    }
    set parentValue(a) {
        this._parentValue = a;
    }
    get parentLabel() {
        return this._parentLabel;
    }
    set parentLabel(a) {
        this._parentLabel = a;
    }
    get parentSum() {
        return this._parentSum;
    }
    set parentSum(a) {
        this._parentSum = a;
    }
    get isParent() {
        return this._isParent;
    }
    set isParent(a) {
        this._isParent = a;
    }
    get style() {
        return this._style;
    }
    set style(a) {
        this._style = a;
    }
}
TreemapNodeStylingEventArgs.$t = markType(TreemapNodeStylingEventArgs, 'TreemapNodeStylingEventArgs', EventArgs.$);
/**
 * @hidden
 */
class TreemapFrame extends Base {
    constructor() {
        super();
        this.d = null;
        this.e = null;
        this.e = new List$1(String_$type, 0);
        this.d = new Dictionary$2(String_$type, TreemapNodeFrame.$, 0);
    }
    h(a, b, c) {
        this.g();
        this.k(a, b, c);
        this.j(a, b, c);
        this.i(a, b, c);
    }
    i(a, b, c) {
        for (let d = 0; d < b.e.count; d++) {
            let e = b.e._inner[d];
            if (c.d.containsKey(e)) {
                let f = TreemapNodeFrame.b(a, b.d.item(e), c.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    }
    j(a, b, c) {
        for (let d = 0; d < c.e.count; d++) {
            let e = c.e._inner[d];
            if (!b.d.containsKey(e)) {
                let f = TreemapNodeFrame.c(a, c.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    }
    k(a, b, c) {
        for (let d = 0; d < b.e.count; d++) {
            let e = b.e._inner[d];
            if (!c.d.containsKey(e)) {
                let f = TreemapNodeFrame.d(a, b.d.item(e));
                this.d.addItem(f.r, f);
                this.e.add(f.r);
            }
        }
    }
    m(a, b) {
        let c;
        if (!((() => { let d = this.d.tryGetValue(a.i, c); c = d.p1; return d.ret; })())) {
            c = new TreemapNodeFrame();
            c.r = a.i;
            c.e = a;
            this.d.item(c.r, c);
            this.e.add(c.r);
        }
        c.y = b;
    }
    n(a, b) {
        this.d.item(a.i).f = b;
    }
    b(a) {
        if (!this.d.containsKey(a.i)) {
            return false;
        }
        return this.d.item(a.i).f;
    }
    o(a) {
        let b;
        if (!((() => { let c = this.d.tryGetValue(a.i, b); b = c.p1; return c.ret; })())) {
            return Rect.empty;
        }
        return b.y;
    }
    l(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t) {
        let u;
        if (!((() => { let v = this.d.tryGetValue(a.i, u); u = v.p1; return v.ret; })())) {
            return;
        }
        u.s = b;
        u.u = c;
        u.x = d;
        u.q = g;
        u.v = e;
        u.a = h;
        u.l = i;
        u.g = j;
        u.w = f;
        u.i = k;
        u.k = l;
        u.j = m;
        u.h = n;
        u.n = o;
        u.p = p;
        u.o = q;
        u.m = r;
        u.t = s;
        u.z = t;
    }
    g() {
        this.e.clear();
        this.d.clear();
    }
    c(a) {
        return this.d.containsKey(a);
    }
    a(a) {
        return this.d.item(a);
    }
    f(a, b, c) {
        let d;
        if (!((() => { let e = this.d.tryGetValue(a.i, d); d = e.p1; return e.ret; })())) {
            return;
        }
        let e = a.b != null && a.b.count > 0;
        if (b.b("Label")) {
            d.s = b.ai;
        }
        if (b.b("Fill")) {
            d.u = b.a5;
        }
        if (b.b("LabelHorizontalAlignment")) {
            d.t = b.ax;
        }
        if (b.b("Outline")) {
            d.x = b.ba;
        }
        if (b.b("StrokeThickness")) {
            d.q = b.w;
        }
        if (b.b("HeaderBackground")) {
            d.v = b.a6;
        }
        if (e) {
            if (b.b("HeaderTextColor")) {
                d.w = b.a9;
            }
            else if (b.b("Fill") || b.b("HeaderBackground")) {
                d.w = c(a, d.u, d.v);
            }
        }
        else {
            if (b.b("TextColor")) {
                d.w = b.bb;
            }
            else if (b.b("Fill") || b.b("HeaderBackground")) {
                d.w = c(a, d.u, d.v);
            }
        }
        if (b.b("HeaderLabelLeftMargin")) {
            d.i = b.p;
        }
        if (b.b("HeaderLabelTopMargin")) {
            d.k = b.r;
        }
        if (b.b("HeaderLabelRightMargin")) {
            d.j = b.q;
        }
        if (b.b("HeaderLabelBottomMargin")) {
            d.h = b.o;
        }
        if (b.b("LabelLeftMargin")) {
            d.n = b.t;
        }
        if (b.b("LabelTopMargin")) {
            d.p = b.v;
        }
        if (b.b("LabelRightMargin")) {
            d.o = b.u;
        }
        if (b.b("LabelBottomMargin")) {
            d.m = b.s;
        }
    }
}
TreemapFrame.$t = markType(TreemapFrame, 'TreemapFrame');
/**
 * @hidden
 */
class TreemapNodeFrame extends Base {
    constructor() {
        super();
        this.y = null;
        this.e = null;
        this.r = null;
        this.s = null;
        this.u = null;
        this.x = null;
        this.q = 0;
        this.i = 0;
        this.k = 0;
        this.j = 0;
        this.h = 0;
        this.n = 0;
        this.p = 0;
        this.o = 0;
        this.m = 0;
        this.w = null;
        this.v = null;
        this.a = 0;
        this.l = 0;
        this.g = 0;
        this.t = 0;
        this.z = 0;
        this.f = false;
        this.y = Rect.empty;
    }
    static b(a, b, c) {
        let d = new TreemapNodeFrame();
        d.e = c.e;
        d.r = c.r;
        d.s = c.s;
        let e = c.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        let f = b.y;
        if (f.isEmpty) {
            f = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, f.left + (e.left - f.left) * a, f.top + (e.top - f.top) * a, f.width + (e.width - f.width) * a, f.height + (e.height - f.height) * a);
        d.u = BrushUtil.k(b.u, a, c.u, 0);
        d.x = BrushUtil.k(b.x, a, c.x, 0);
        d.v = BrushUtil.k(b.v, a, c.v, 0);
        d.w = BrushUtil.k(b.w, a, c.w, 0);
        d.q = b.q + (c.q - b.q) * a;
        d.i = b.i + (c.i - b.i) * a;
        d.k = b.k + (c.k - b.k) * a;
        d.j = b.j + (c.j - b.j) * a;
        d.h = b.h + (c.h - b.h) * a;
        d.n = b.n + (c.n - b.n) * a;
        d.p = b.p + (c.p - b.p) * a;
        d.o = b.o + (c.o - b.o) * a;
        d.m = b.m + (c.m - b.m) * a;
        d.l = b.l + (c.l - b.l) * a;
        d.g = b.g + (c.g - b.g) * a;
        d.t = a < 0.5 ? b.t : c.t;
        d.z = a < 0.5 ? b.z : c.z;
        d.a = a < 0.5 ? b.a : c.a;
        return d;
    }
    static d(a, b) {
        let c = new Rect(0, 0, 0, 0, 0);
        let d = new TreemapNodeFrame();
        d.e = b.e;
        d.s = b.s;
        d.r = b.r;
        let e = b.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, e.left + (c.left - e.left) * a, e.top + (c.top - e.top) * a, e.width + (c.width - e.width) * a, e.height + (c.height - e.height) * a);
        d.u = BrushUtil.k(b.u, a, null, 0);
        d.x = BrushUtil.k(b.x, a, null, 0);
        d.v = BrushUtil.k(b.v, a, null, 0);
        d.w = BrushUtil.k(b.w, a, null, 0);
        d.q = b.q + (0 - b.q) * a;
        d.i = b.i + (0 - b.i) * a;
        d.k = b.k + (0 - b.k) * a;
        d.j = b.j + (0 - b.j) * a;
        d.h = b.h + (0 - b.h) * a;
        d.n = b.n + (0 - b.n) * a;
        d.p = b.p + (0 - b.p) * a;
        d.o = b.o + (0 - b.o) * a;
        d.m = b.m + (0 - b.m) * a;
        d.l = b.l + (0 - b.l) * a;
        d.g = b.g + (0 - b.g) * a;
        d.t = b.t;
        d.z = b.z;
        d.a = b.a;
        return d;
    }
    static c(a, b) {
        let c = new Rect(0, 0, 0, 0, 0);
        let d = new TreemapNodeFrame();
        d.e = b.e;
        d.s = b.s;
        d.r = b.r;
        let e = b.y;
        if (e.isEmpty) {
            e = new Rect(0, 0, 0, 0, 0);
        }
        d.y = new Rect(0, c.left + (e.left - c.left) * a, c.top + (e.top - c.top) * a, c.width + (e.width - c.width) * a, c.height + (e.height - c.height) * a);
        d.u = BrushUtil.k(null, a, b.u, 0);
        d.x = BrushUtil.k(null, a, b.x, 0);
        d.v = BrushUtil.k(null, a, b.v, 0);
        d.w = BrushUtil.k(null, a, b.w, 0);
        d.q = 0 + (b.q - 0) * a;
        d.i = 0 + (b.i - 0) * a;
        d.k = 0 + (b.k - 0) * a;
        d.j = 0 + (b.j - 0) * a;
        d.h = 0 + (b.h - 0) * a;
        d.n = 0 + (b.n - 0) * a;
        d.p = 0 + (b.p - 0) * a;
        d.o = 0 + (b.o - 0) * a;
        d.m = 0 + (b.m - 0) * a;
        d.l = 0 + (b.l - 0) * a;
        d.g = 0 + (b.g - 0) * a;
        d.t = b.t;
        d.z = b.z;
        d.a = b.a;
        return d;
    }
}
TreemapNodeFrame.$t = markType(TreemapNodeFrame, 'TreemapNodeFrame');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/**
 * Represents a style to apply to a treemap node.
*/
const IgxTreemapNodeStyleComponent_PROVIDERS = [];
let IgxTreemapNodeStyleComponent = class IgxTreemapNodeStyleComponent {
    constructor() {
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    createImplementation() {
        return new TreemapNodeStyle();
    }
    ngOnInit() {
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    onImplementationCreated() {
    }
    /**
     * Gets or sets the background to use for the header when it is hovered.
    */
    get headerHoverBackground() {
        return brushToString(this.i.a7);
    }
    set headerHoverBackground(v) {
        this.i.a7 = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for the header.
    */
    get headerBackground() {
        return brushToString(this.i.a6);
    }
    set headerBackground(v) {
        this.i.a6 = stringToBrush(v);
    }
    /**
     * Gets or sets the text color to use for the header.
    */
    get headerTextColor() {
        return brushToString(this.i.a9);
    }
    set headerTextColor(v) {
        this.i.a9 = stringToBrush(v);
    }
    /**
     * Gets or sets the label to use for the node.
    */
    get label() {
        return this.i.ai;
    }
    set label(v) {
        this.i.ai = v;
    }
    /**
     * Gets or sets the text color to use for the nodes.
    */
    get textColor() {
        return brushToString(this.i.bb);
    }
    set textColor(v) {
        this.i.bb = stringToBrush(v);
    }
    /**
     * Gets or sets the text color to use for the header.
    */
    get headerHoverTextColor() {
        return brushToString(this.i.a8);
    }
    set headerHoverTextColor(v) {
        this.i.a8 = stringToBrush(v);
    }
    /**
     * Gets or sets the left margin to use for the header.
    */
    get headerLabelLeftMargin() {
        return this.i.p;
    }
    set headerLabelLeftMargin(v) {
        this.i.p = +v;
    }
    /**
     * Gets or sets the top margin to use for the header.
    */
    get headerLabelTopMargin() {
        return this.i.r;
    }
    set headerLabelTopMargin(v) {
        this.i.r = +v;
    }
    /**
     * Gets or sets the right margin to use for the header.
    */
    get headerLabelRightMargin() {
        return this.i.q;
    }
    set headerLabelRightMargin(v) {
        this.i.q = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the labels.
    */
    get headerLabelBottomMargin() {
        return this.i.o;
    }
    set headerLabelBottomMargin(v) {
        this.i.o = +v;
    }
    /**
     * Gets or sets the left margin to use for the labels.
    */
    get labelLeftMargin() {
        return this.i.t;
    }
    set labelLeftMargin(v) {
        this.i.t = +v;
    }
    /**
     * Gets or sets the top margin to use for the labels.
    */
    get labelTopMargin() {
        return this.i.v;
    }
    set labelTopMargin(v) {
        this.i.v = +v;
    }
    /**
     * Gets or sets the right margin to use for the labels.
    */
    get labelRightMargin() {
        return this.i.u;
    }
    set labelRightMargin(v) {
        this.i.u = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the labels.
    */
    get labelBottomMargin() {
        return this.i.s;
    }
    set labelBottomMargin(v) {
        this.i.s = +v;
    }
    /**
     * Gets or sets the height to use for the header.
    */
    get headerHeight() {
        return this.i.n;
    }
    set headerHeight(v) {
        this.i.n = +v;
    }
    /**
     * Gets or sets the horizontal alignment to use for the node labels.
    */
    get labelHorizontalAlignment() {
        return this.i.ax;
    }
    set labelHorizontalAlignment(v) {
        this.i.ax = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the vertical alignment to use for the node labels.
    */
    get labelVerticalAlignment() {
        return this.i.bd;
    }
    set labelVerticalAlignment(v) {
        this.i.bd = ensureEnum(VerticalAlignment_$type, v);
    }
    /**
     * Gets or sets the fill color to use for the nodes.
    */
    get fill() {
        return brushToString(this.i.a5);
    }
    set fill(v) {
        this.i.a5 = stringToBrush(v);
    }
    /**
     * Gets or sets the outline to use for the nodes.
    */
    get outline() {
        return brushToString(this.i.ba);
    }
    set outline(v) {
        this.i.ba = stringToBrush(v);
    }
    /**
     * Gets or sets the stroke thickness to use for the node outline.
    */
    get strokeThickness() {
        return this.i.w;
    }
    set strokeThickness(v) {
        this.i.w = +v;
    }
    findByName(name) {
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TreemapNodeStyleComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "headerHoverBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "headerBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "headerTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "label", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "textColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "headerHoverTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "headerLabelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "headerLabelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "headerLabelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "headerLabelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "headerHeight", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "labelVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "fill", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleComponent.prototype, "outline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleComponent.prototype, "strokeThickness", null);
IgxTreemapNodeStyleComponent = __decorate([
    Component({
        selector: 'igx-treemap-node-style',
        template: ``,
        providers: [],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapNodeStyleComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

var IgxTreemapNodeStyleMappingComponent_1;
/**
 * Represents a style to apply to a set of nodes in the treemap.
*/
const IgxTreemapNodeStyleMappingComponent_PROVIDERS = [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent) }];
let IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent_1 = class IgxTreemapNodeStyleMappingComponent extends IgxTreemapNodeStyleComponent {
    constructor() {
        super();
    }
    createImplementation() {
        return new TreemapNodeStyleMapping();
    }
    /**
                                 * @hidden
                                 */
    get i() {
        return this._implementation;
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get targetType() {
        return this.i.bf;
    }
    set targetType(v) {
        this.i.bf = ensureEnum(TreemapNodeStyleMappingTargetType_$type, v);
    }
    /**
     * Gets or sets the unique name of the mapping.
    */
    get name() {
        return this.i.bs;
    }
    set name(v) {
        this.i.bs = v;
    }
    /**
     * Gets or sets the minimum value to which the mapping applies.
    */
    get minimumValue() {
        return this.i.bl;
    }
    set minimumValue(v) {
        this.i.bl = +v;
    }
    /**
     * Gets or sets the maximum value to which the mapping applies.
    */
    get maximumValue() {
        return this.i.bk;
    }
    set maximumValue(v) {
        this.i.bk = +v;
    }
    /**
     * Gets or sets the value to which the mapping applies.
    */
    get value() {
        return this.i.bn;
    }
    set value(v) {
        this.i.bn = v;
    }
    /**
     * Gets or sets the mapping mode to use to evaluate whether the mapping applies.
    */
    get mappingMode() {
        return this.i.bh;
    }
    set mappingMode(v) {
        this.i.bh = ensureEnum(TreemapValueMappingMode_$type, v);
    }
};
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "targetType", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapNodeStyleMappingComponent.prototype, "name", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "minimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "maximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxTreemapNodeStyleMappingComponent.prototype, "value", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapNodeStyleMappingComponent.prototype, "mappingMode", null);
IgxTreemapNodeStyleMappingComponent = IgxTreemapNodeStyleMappingComponent_1 = __decorate([
    Component({
        selector: 'igx-treemap-node-style-mapping',
        template: ``,
        providers: [{ provide: IgxTreemapNodeStyleComponent, useExisting: forwardRef(() => IgxTreemapNodeStyleMappingComponent_1) }],
        changeDetection: ChangeDetectionStrategy.OnPush
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapNodeStyleMappingComponent);

class IgxTreemapNodeStyleMappingCollection extends IgCollection {
    constructor(list) {
        super();
        if (!IgxTreemapNodeStyleMappingComponent.$type) {
            IgxTreemapNodeStyleMappingComponent.$type = markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
        }
        if (list) {
            for (let i = 0; i < list.length; i++) {
                this.add(list[i]);
            }
        }
    }
    _createInnerColl() {
        if (!IgxTreemapNodeStyleMappingComponent.$type) {
            IgxTreemapNodeStyleMappingComponent.$type = markType(IgxTreemapNodeStyleMappingComponent, "IgxTreemapNodeStyleMappingComponent");
        }
        let coll = new SyncableObservableCollection$2(IgxTreemapNodeStyleMappingComponent.$type, TreemapNodeStyleMapping.$type, 0);
        coll.compare = (ext, int) => {
            let comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = (ext) => {
            return ext._implementation;
        };
        coll.createFrom = (int) => {
            let ext = int.externalObject;
            if (!ext) {
                ext = new IgxTreemapNodeStyleMappingComponent();
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    }
}

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

class IgxTreemapNodeStylingEventArgs {
    createImplementation() {
        return new TreemapNodeStylingEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = +v;
    }
    get sum() {
        return this.i.sum;
    }
    set sum(v) {
        this.i.sum = +v;
    }
    get customValue() {
        return this.i.customValue;
    }
    set customValue(v) {
        this.i.customValue = v;
    }
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    get parentItem() {
        return this.i.parentItem;
    }
    set parentItem(v) {
        this.i.parentItem = v;
    }
    get label() {
        return this.i.label;
    }
    set label(v) {
        this.i.label = v;
    }
    get parentValue() {
        return this.i.parentValue;
    }
    set parentValue(v) {
        this.i.parentValue = +v;
    }
    get parentLabel() {
        return this.i.parentLabel;
    }
    set parentLabel(v) {
        this.i.parentLabel = v;
    }
    get parentSum() {
        return this.i.parentSum;
    }
    set parentSum(v) {
        this.i.parentSum = +v;
    }
    get isParent() {
        return this.i.isParent;
    }
    set isParent(v) {
        this.i.isParent = ensureBool(v);
    }
    get style() {
        if (this.i.style == null) {
            return null;
        }
        if (!this.i.style.externalObject) {
            let e = IgxTreemapNodeStyleComponent._createFromInternal(this.i.style);
            if (e) {
                e._implementation = this.i.style;
            }
            this.i.style.externalObject = e;
        }
        return this.i.style.externalObject;
    }
    set style(v) {
        v == null ? this.i.style = null : this.i.style = v.i;
    }
}

class IgxTreemapNodePointerEventArgs {
    createImplementation() {
        return new TreemapNodePointerEventArgs();
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    }
    onImplementationCreated() {
    }
    constructor() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    _provideImplementation(i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
    }
    get value() {
        return this.i.value;
    }
    set value(v) {
        this.i.value = +v;
    }
    get sum() {
        return this.i.sum;
    }
    set sum(v) {
        this.i.sum = +v;
    }
    get customValue() {
        return this.i.customValue;
    }
    set customValue(v) {
        this.i.customValue = v;
    }
    get item() {
        return this.i.item;
    }
    set item(v) {
        this.i.item = v;
    }
    get parentItem() {
        return this.i.parentItem;
    }
    set parentItem(v) {
        this.i.parentItem = v;
    }
    get position() {
        return fromPoint(this.i.position);
    }
    set position(v) {
        this.i.position = toPoint(v);
    }
    get isRightButton() {
        return this.i.isRightButton;
    }
    set isRightButton(v) {
        this.i.isRightButton = ensureBool(v);
    }
    get isHandled() {
        return this.i.isHandled;
    }
    set isHandled(v) {
        this.i.isHandled = ensureBool(v);
    }
    get isOverHeader() {
        return this.i.isOverHeader;
    }
    set isOverHeader(v) {
        this.i.isOverHeader = ensureBool(v);
    }
    get label() {
        return this.i.label;
    }
    set label(v) {
        this.i.label = v;
    }
    get parentValue() {
        return this.i.parentValue;
    }
    set parentValue(v) {
        this.i.parentValue = +v;
    }
    get parentLabel() {
        return this.i.parentLabel;
    }
    set parentLabel(v) {
        this.i.parentLabel = v;
    }
    get parentSum() {
        return this.i.parentSum;
    }
    set parentSum(v) {
        this.i.parentSum = +v;
    }
}

const IgxTreemapComponent_PROVIDERS = [];
let IgxTreemapComponent = class IgxTreemapComponent {
    constructor(renderer, _elRef, ngZone, injector, componentFactoryResolver) {
        this.renderer = renderer;
        this._elRef = _elRef;
        this.ngZone = ngZone;
        this.injector = injector;
        this.componentFactoryResolver = componentFactoryResolver;
        /**
        * The style mappings actually present in the chart. Do not directly modify this array.
        * This array's contents can be modified by causing Angular to reproject the child content.
        * Or adding and removing stye mappings from the manual style mapping collection on the styleMappings property.
        */
        this.actualStyleMappings = [];
        this._styleMappings = null;
        this._styleMappingsAdapter = null;
        this._wrapper = null;
        this._root = null;
        this._implementation = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        this._nodeStyling = null;
        this._nodePointerOver = null;
        this._nodePointerEnter = null;
        this._nodePointerLeave = null;
        this._nodePointerPressed = null;
        this._nodePointerReleased = null;
        this._zoneRunner = null;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._implementation = this.createImplementation();
        if (renderer) {
            this.container = renderer.createElement("div");
            renderer.appendChild(_elRef.element.nativeElement, this.container);
            renderer.setStyle(this.container, "display", "block");
            renderer.setStyle(this.container, "width", "100%");
            renderer.setStyle(this.container, "height", "100%");
        }
        var root;
        root = this.container;
        if (this.container != null) {
            root = this.container;
        }
        if (root && root.nativeElement) {
            root = root.nativeElement;
        }
        this._root = root;
        var treemap = this.i;
        this._treeMap = treemap;
        this._styleMappingsAdapter = new CollectionAdapter([], this.i.styleMappings, this.actualStyleMappings, (c) => c.i, (i) => {
            if (this._root && this._root.parentElement) {
                i._styling(this._root, this, this);
            }
        }, (i) => { });
        if (renderer) {
            var ren = new AngularRenderer(root, this.renderer, window.document, this.ngZone, true, DataChartStylingDefaults);
            this._wrapper = ren;
            treemap.provideContainer(ren);
            treemap.notifySizeChanged();
            ren.addSizeWatcher(() => {
                this._treeMap.notifySizeChanged();
            });
        }
    }
    set height(value) {
        this._height = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._treeMap.notifySizeChanged();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this.renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._treeMap.notifySizeChanged();
    }
    get width() {
        return this._width;
    }
    /**
     * A collection or manually added axes for the chart.
    */
    get styleMappings() {
        if (this._styleMappings === null) {
            let coll = new IgxTreemapNodeStyleMappingCollection();
            let inner = coll._innerColl;
            inner.addListener((sender, e) => {
                switch (e.action) {
                    case NotifyCollectionChangedAction.Add:
                        this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Remove:
                        this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                        break;
                    case NotifyCollectionChangedAction.Replace:
                        this._styleMappingsAdapter.removeManualItemAt(e.oldStartingIndex);
                        this._styleMappingsAdapter.insertManualItem(e.newStartingIndex, e.newItems.item(0));
                        break;
                    case NotifyCollectionChangedAction.Reset:
                        this._styleMappingsAdapter.clearManualItems();
                        break;
                }
            });
            this._styleMappings = coll;
        }
        return this._styleMappings;
    }
    // supports angular themes or custom properties set in CSS
    updateStyle() {
        this._styling(this._root, this);
    }
    ngOnDestroy() {
        this._treeMap.destroy();
        this._wrapper.destroy();
    }
    ngAfterContentInit() {
        this._styleMappingsAdapter.updateQuery(this.contentStyleMappings);
        this._styling(this._root, this);
        if (this.actualStyleMappings && this.actualStyleMappings.length > 0) {
            var currStyleMapping = this.actualStyleMappings;
            for (var i = 0; i < currStyleMapping.length; i++) {
                currStyleMapping[i]._styling(this._root, this, this);
            }
        }
        this.i.notifySizeChanged();
        this.updateStyle();
    }
    createImplementation() {
        return new Treemap();
    }
    get i() {
        return this._implementation;
    }
    /**
 * Gets or sets path to use to get the values from the items.
*/
    get valueMemberPath() {
        return this.i.gi;
    }
    set valueMemberPath(v) {
        this.i.gi = v;
    }
    /**
     * Gets or sets the root title to use for breadcrumbs.
    */
    get rootTitle() {
        return this.i.f8;
    }
    set rootTitle(v) {
        this.i.f8 = v;
    }
    /**
     * Gets or sets the root title to use for breadcrumbs.
    */
    get breadcrumbSequence() {
        return this.i.ed;
    }
    set breadcrumbSequence(v) {
        this.i.ed = v;
    }
    /**
     * Gets or sets the path to use to get the Parent of the items.
    */
    get parentIdMemberPath() {
        return this.i.fw;
    }
    set parentIdMemberPath(v) {
        this.i.fw = v;
    }
    /**
     * Gets or sets the path to use to get the Label of the items.
    */
    get labelMemberPath() {
        return this.i.ff;
    }
    set labelMemberPath(v) {
        this.i.ff = v;
    }
    /**
     * Gets or sets the path to use to get the custom value of the items.
    */
    get customValueMemberPath() {
        return this.i.eg;
    }
    set customValueMemberPath(v) {
        this.i.eg = v;
    }
    /**
     * Gets or sets the path to use to get the id of the items.
    */
    get idMemberPath() {
        return this.i.e5;
    }
    set idMemberPath(v) {
        this.i.e5 = v;
    }
    /**
     * Gets or sets the (possibly hierarchical) data to assign to the TreeMap.
    */
    get dataSource() {
        return this.i.dataSource;
    }
    set dataSource(v) {
        this.i.dataSource = v;
    }
    /**
     * Gets or sets brushes to use for the fill scale.
    */
    get fillBrushes() {
        return fromBrushCollection(this.i.b);
    }
    set fillBrushes(v) {
        this.i.b = toBrushCollection(v);
    }
    /**
     * Gets or sets mode to use for the fill scale.
    */
    get fillScaleMode() {
        return this.i.d;
    }
    set fillScaleMode(v) {
        this.i.d = ensureEnum(TreemapFillScaleMode_$type, v);
    }
    /**
     * Gets or sets whether the fill scale is logarithmic.
    */
    get isFillScaleLogarithmic() {
        return this.i.bg;
    }
    set isFillScaleLogarithmic(v) {
        this.i.bg = ensureBool(v);
    }
    /**
     * Gets or sets the logarithm base to use if the fill scale is logarithmic.
    */
    get fillScaleLogarithmBase() {
        return this.i.dy;
    }
    set fillScaleLogarithmBase(v) {
        this.i.dy = +v;
    }
    /**
     * Gets or sets the minimum value to use for the fill scale.
    */
    get fillScaleMinimumValue() {
        return this.i.ct;
    }
    set fillScaleMinimumValue(v) {
        this.i.ct = +v;
    }
    /**
     * Gets or sets the maximum value to use for the fill scale.
    */
    get fillScaleMaximumValue() {
        return this.i.cs;
    }
    set fillScaleMaximumValue(v) {
        this.i.cs = +v;
    }
    /**
     * Gets or sets the vertical fit mode to use for the node labels.
    */
    get labelVerticalFitMode() {
        return this.i.p;
    }
    set labelVerticalFitMode(v) {
        this.i.p = ensureEnum(TreemapLabelVerticalFitMode_$type, v);
    }
    /**
     * Gets or sets the horizontal fit mode to use for the node labels.
    */
    get labelHorizontalFitMode() {
        return this.i.m;
    }
    set labelHorizontalFitMode(v) {
        this.i.m = ensureEnum(TreemapLabelHorizontalFitMode_$type, v);
    }
    /**
     * Gets or sets the background to use for the overlay header when it is hovered.
    */
    get overlayHeaderHoverBackground() {
        return brushToString(this.i.h8);
    }
    set overlayHeaderHoverBackground(v) {
        this.i.h8 = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for the header when it is hovered.
    */
    get headerHoverBackground() {
        return brushToString(this.i.h2);
    }
    set headerHoverBackground(v) {
        this.i.h2 = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for the header.
    */
    get headerBackground() {
        return brushToString(this.i.h0);
    }
    set headerBackground(v) {
        this.i.h0 = stringToBrush(v);
    }
    /**
     * Gets or sets the background to use for the overlay header.
    */
    get overlayHeaderBackground() {
        return brushToString(this.i.h7);
    }
    set overlayHeaderBackground(v) {
        this.i.h7 = stringToBrush(v);
    }
    /**
     * Gets or sets the text color to use for the header.
    */
    get headerTextColor() {
        return brushToString(this.i.h5);
    }
    set headerTextColor(v) {
        this.i.h5 = stringToBrush(v);
    }
    /**
     * Gets or sets the dark text color to use for the header.
    */
    get headerDarkTextColor() {
        return brushToString(this.i.h1);
    }
    set headerDarkTextColor(v) {
        this.i.h1 = stringToBrush(v);
    }
    /**
     * Gets or sets the text color to use for the nodes.
    */
    get textColor() {
        return brushToString(this.i.ij);
    }
    set textColor(v) {
        this.i.ij = stringToBrush(v);
    }
    /**
     * Gets or sets the dark text color to use for the nodes.
    */
    get darkTextColor() {
        return brushToString(this.i.hz);
    }
    set darkTextColor(v) {
        this.i.hz = stringToBrush(v);
    }
    /**
     * Gets or sets the text color to use for the header.
    */
    get headerHoverTextColor() {
        return brushToString(this.i.h4);
    }
    set headerHoverTextColor(v) {
        this.i.h4 = stringToBrush(v);
    }
    /**
     * Gets or sets the dark text color to use for the header when hovered.
    */
    get headerHoverDarkTextColor() {
        return brushToString(this.i.h3);
    }
    set headerHoverDarkTextColor(v) {
        this.i.h3 = stringToBrush(v);
    }
    /**
     * Gets or sets the font to use for content nodes
    */
    get textStyle() {
        if (this.i.aw == null) {
            return null;
        }
        return this.i.aw.fontString;
    }
    set textStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.aw = fi;
    }
    /**
     * Gets or sets the font to use for header nodes
    */
    get headerTextStyle() {
        if (this.i.au == null) {
            return null;
        }
        return this.i.au.fontString;
    }
    set headerTextStyle(v) {
        let fi = new FontInfo();
        fi.fontString = v;
        this.i.au = fi;
    }
    /**
     * Gets or sets the font to use for header nodes
    */
    get headerDisplayMode() {
        return this.i.j;
    }
    set headerDisplayMode(v) {
        this.i.j = ensureEnum(TreemapHeaderDisplayMode_$type, v);
    }
    /**
     * Gets or sets the left margin to use for the header.
    */
    get headerLabelLeftMargin() {
        return this.i.cx;
    }
    set headerLabelLeftMargin(v) {
        this.i.cx = +v;
    }
    /**
     * Gets or sets the top margin to use for the header.
    */
    get headerLabelTopMargin() {
        return this.i.cz;
    }
    set headerLabelTopMargin(v) {
        this.i.cz = +v;
    }
    /**
     * Gets or sets the right margin to use for the header.
    */
    get headerLabelRightMargin() {
        return this.i.cy;
    }
    set headerLabelRightMargin(v) {
        this.i.cy = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the header.
    */
    get headerLabelBottomMargin() {
        return this.i.cw;
    }
    set headerLabelBottomMargin(v) {
        this.i.cw = +v;
    }
    /**
     * Gets or sets the left margin to use for the overlay header.
    */
    get overlayHeaderLabelLeftMargin() {
        return this.i.c7;
    }
    set overlayHeaderLabelLeftMargin(v) {
        this.i.c7 = +v;
    }
    /**
     * Gets or sets the top margin to use for the overlay header.
    */
    get overlayHeaderLabelTopMargin() {
        return this.i.c9;
    }
    set overlayHeaderLabelTopMargin(v) {
        this.i.c9 = +v;
    }
    /**
     * Gets or sets the right margin to use for the overlay header.
    */
    get overlayHeaderLabelRightMargin() {
        return this.i.c8;
    }
    set overlayHeaderLabelRightMargin(v) {
        this.i.c8 = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the overlay header.
    */
    get overlayHeaderLabelBottomMargin() {
        return this.i.c6;
    }
    set overlayHeaderLabelBottomMargin(v) {
        this.i.c6 = +v;
    }
    /**
     * Gets or sets the left margin to use for the labels.
    */
    get labelLeftMargin() {
        return this.i.c2;
    }
    set labelLeftMargin(v) {
        this.i.c2 = +v;
    }
    /**
     * Gets or sets the top margin to use for the labels.
    */
    get labelTopMargin() {
        return this.i.c4;
    }
    set labelTopMargin(v) {
        this.i.c4 = +v;
    }
    /**
     * Gets or sets the right margin to use for the labels.
    */
    get labelRightMargin() {
        return this.i.c3;
    }
    set labelRightMargin(v) {
        this.i.c3 = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the labels.
    */
    get labelBottomMargin() {
        return this.i.c1;
    }
    set labelBottomMargin(v) {
        this.i.c1 = +v;
    }
    /**
     * Gets or sets the left margin to use for the parent nodes.
    */
    get parentNodeLeftMargin() {
        return this.i.dc;
    }
    set parentNodeLeftMargin(v) {
        this.i.dc = +v;
    }
    /**
     * Gets or sets the top margin to use for the parent nodes.
    */
    get parentNodeTopMargin() {
        return this.i.dg;
    }
    set parentNodeTopMargin(v) {
        this.i.dg = +v;
    }
    /**
     * Gets or sets the right margin to use for the parent nodes.
    */
    get parentNodeRightMargin() {
        return this.i.de;
    }
    set parentNodeRightMargin(v) {
        this.i.de = +v;
    }
    /**
     * Gets or sets the bottom margin to use for the parent nodes.
    */
    get parentNodeBottomMargin() {
        return this.i.da;
    }
    set parentNodeBottomMargin(v) {
        this.i.da = +v;
    }
    /**
     * Gets or sets the left padding to use for the parent nodes.
    */
    get parentNodeLeftPadding() {
        return this.i.dd;
    }
    set parentNodeLeftPadding(v) {
        this.i.dd = +v;
    }
    /**
     * Gets or sets the top padding to use for the parent nodes.
    */
    get parentNodeTopPadding() {
        return this.i.dh;
    }
    set parentNodeTopPadding(v) {
        this.i.dh = +v;
    }
    /**
     * Gets or sets the right padding to use for the parent nodes.
    */
    get parentNodeRightPadding() {
        return this.i.df;
    }
    set parentNodeRightPadding(v) {
        this.i.df = +v;
    }
    /**
     * Gets or sets the bottom padding to use for the parent nodes.
    */
    get parentNodeBottomPadding() {
        return this.i.db;
    }
    set parentNodeBottomPadding(v) {
        this.i.db = +v;
    }
    /**
     * Gets or sets the horizontal alignment to use for the node labels.
    */
    get labelHorizontalAlignment() {
        return this.i.hm;
    }
    set labelHorizontalAlignment(v) {
        this.i.hm = ensureEnum(HorizontalAlignment_$type, v);
    }
    /**
     * Gets or sets the vertical alignment to use for the node labels.
    */
    get labelVerticalAlignment() {
        return this.i.iq;
    }
    set labelVerticalAlignment(v) {
        this.i.iq = ensureEnum(VerticalAlignment_$type, v);
    }
    /**
     * Gets or sets the height to use for the header.
    */
    get headerHeight() {
        return this.i.cv;
    }
    set headerHeight(v) {
        this.i.cv = +v;
    }
    /**
     * Gets or sets the outline to use for the nodes.
    */
    get outline() {
        return brushToString(this.i.h6);
    }
    set outline(v) {
        this.i.h6 = stringToBrush(v);
    }
    /**
     * Gets or sets the stroke thickness to use for the node outline.
    */
    get strokeThickness() {
        return this.i.dt;
    }
    set strokeThickness(v) {
        this.i.dt = +v;
    }
    /**
     * Gets or sets the orientation to use for the stripped and slice and dice layout types.
    */
    get layoutOrientation() {
        return this.i.ai;
    }
    set layoutOrientation(v) {
        this.i.ai = ensureEnum(TreemapOrientation_$type, v);
    }
    /**
     * Gets or sets the type of layout to use for the nodes.
    */
    get layoutType() {
        return this.i.s;
    }
    set layoutType(v) {
        this.i.s = ensureEnum(TreemapLayoutType_$type, v);
    }
    /**
     * Gets or sets the minimum size (width or height) to display a node.
    */
    get minimumDisplaySize() {
        return this.i.c5;
    }
    set minimumDisplaySize(v) {
        this.i.c5 = +v;
    }
    /**
     * Gets or sets the number of milliseconds over which changes to the gauge should be animated.
    */
    get transitionDuration() {
        return this.i.d1;
    }
    set transitionDuration(v) {
        this.i.d1 = +v;
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.di;
    }
    set pixelScalingRatio(v) {
        this.i.di = +v;
    }
    get actualPixelScalingRatio() {
        return this.i.cp;
    }
    set actualPixelScalingRatio(v) {
        this.i.cp = +v;
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control while it is animating.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get interactionPixelScalingRatio() {
        return this.i.c0;
    }
    set interactionPixelScalingRatio(v) {
        this.i.c0 = +v;
    }
    /**
     * Gets or sets the resolved scaling value used to affect the pixel density of the control while it is animating.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualInteractionPixelScalingRatio() {
        return this.i.co;
    }
    set actualInteractionPixelScalingRatio(v) {
        this.i.co = +v;
    }
    get animating() {
        return this.i.bc;
    }
    /**
     * Gets or sets the item to drill to in the treemap.
    */
    get focusItem() {
        return this.i.d3;
    }
    set focusItem(v) {
        this.i.d3 = v;
    }
    findByName(name) {
        if (this.styleMappings != null && this.styleMappings.findByName && this.styleMappings.findByName(name)) {
            return this.styleMappings.findByName(name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("TreemapComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Returns visuals as a serialized string.

*/
    exportSerializedVisualData() {
        let iv = this.i.ej();
        return (iv);
    }
    markDirty() {
        this.i.gt();
    }
    onDetachedFromUI() {
        this.i.onDetachedFromUI();
    }
    onAttachedToUI() {
        this.i.onAttachedToUI();
    }
    flush() {
        this.i.gr();
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.gx(source_, index, oldItem, newItem);
    }
    /**
     * Manually notifies the treemap's data source that the data it has bound to has been cleared and needs to be re-examined.
     * This should not be called if the data that the pie chart is bound to is already observable.
    
    * @param source_  * The data source.
    */
    notifyClearItems(source_) {
        this.i.gu(source_);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.gv(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.gw(source_, index, oldItem);
    }
    /**
     * Fired when a node is being styled. Provides an opportunity to customize node styling.
    */
    get nodeStyling() {
        if (this._nodeStyling == null) {
            this._nodeStyling = new EventEmitter();
            this.i.nodeStyling = delegateCombine(this.i.nodeStyling, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxTreemapNodeStylingEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeNodeStyling) {
                        this.beforeNodeStyling(this, outerArgs);
                    }
                    this._nodeStyling.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._nodeStyling;
    }
    /**
     * Fired with the pointer is moving over a node.
    */
    get nodePointerOver() {
        if (this._nodePointerOver == null) {
            this._nodePointerOver = new EventEmitter();
            this.i.nodePointerOver = delegateCombine(this.i.nodePointerOver, (o, e) => {
                let outerArgs = new IgxTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeNodePointerOver) {
                    this.beforeNodePointerOver(this, outerArgs);
                }
                this._nodePointerOver.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._nodePointerOver;
    }
    /**
     * Fired when the pointer enters a node.
    */
    get nodePointerEnter() {
        if (this._nodePointerEnter == null) {
            this._nodePointerEnter = new EventEmitter();
            this.i.nodePointerEnter = delegateCombine(this.i.nodePointerEnter, (o, e) => {
                let outerArgs = new IgxTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeNodePointerEnter) {
                    this.beforeNodePointerEnter(this, outerArgs);
                }
                this._nodePointerEnter.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._nodePointerEnter;
    }
    /**
     * Fired when the pointer leaved a node.
    */
    get nodePointerLeave() {
        if (this._nodePointerLeave == null) {
            this._nodePointerLeave = new EventEmitter();
            this.i.nodePointerLeave = delegateCombine(this.i.nodePointerLeave, (o, e) => {
                let outerArgs = new IgxTreemapNodePointerEventArgs();
                outerArgs._provideImplementation(e);
                if (this.beforeNodePointerLeave) {
                    this.beforeNodePointerLeave(this, outerArgs);
                }
                this._nodePointerLeave.emit({
                    sender: this,
                    args: outerArgs
                });
            });
        }
        return this._nodePointerLeave;
    }
    /**
     * Fired when the pointer is pressed on a node.
    */
    get nodePointerPressed() {
        if (this._nodePointerPressed == null) {
            this._nodePointerPressed = new EventEmitter();
            this.i.nodePointerPressed = delegateCombine(this.i.nodePointerPressed, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxTreemapNodePointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeNodePointerPressed) {
                        this.beforeNodePointerPressed(this, outerArgs);
                    }
                    this._nodePointerPressed.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._nodePointerPressed;
    }
    /**
     * Fired when the pointer is released on a node.
    */
    get nodePointerReleased() {
        if (this._nodePointerReleased == null) {
            this._nodePointerReleased = new EventEmitter();
            this.i.nodePointerReleased = delegateCombine(this.i.nodePointerReleased, (o, e) => {
                this._runInZone(() => {
                    let outerArgs = new IgxTreemapNodePointerEventArgs();
                    outerArgs._provideImplementation(e);
                    if (this.beforeNodePointerReleased) {
                        this.beforeNodePointerReleased(this, outerArgs);
                    }
                    this._nodePointerReleased.emit({
                        sender: this,
                        args: outerArgs
                    });
                });
            });
        }
        return this._nodePointerReleased;
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
};
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "width", null);
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxTreemapComponent.prototype, "_dynamicContent", void 0);
__decorate([
    ContentChildren(IgxTreemapNodeStyleMappingComponent),
    __metadata("design:type", QueryList)
], IgxTreemapComponent.prototype, "contentStyleMappings", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "rootTitle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "breadcrumbSequence", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "parentIdMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "customValueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "idMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxTreemapComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxTreemapComponent.prototype, "fillBrushes", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "fillScaleMode", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxTreemapComponent.prototype, "isFillScaleLogarithmic", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "fillScaleLogarithmBase", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "fillScaleMinimumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "fillScaleMaximumValue", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelVerticalFitMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelHorizontalFitMode", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "overlayHeaderHoverBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerHoverBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "overlayHeaderBackground", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerDarkTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "textColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "darkTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerHoverTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerHoverDarkTextColor", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "textStyle", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "headerTextStyle", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerDisplayMode", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerLabelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerLabelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerLabelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerLabelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "overlayHeaderLabelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "overlayHeaderLabelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "overlayHeaderLabelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "overlayHeaderLabelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeLeftMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeTopMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeRightMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeBottomMargin", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeLeftPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeTopPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeRightPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "parentNodeBottomPadding", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelHorizontalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "labelVerticalAlignment", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "headerHeight", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxTreemapComponent.prototype, "outline", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "strokeThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "layoutOrientation", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "layoutType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "minimumDisplaySize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "transitionDuration", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "actualPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "interactionPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxTreemapComponent.prototype, "actualInteractionPixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxTreemapComponent.prototype, "focusItem", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodeStyling", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodePointerOver", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodePointerEnter", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodePointerLeave", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodePointerPressed", null);
__decorate([
    Output(),
    __metadata("design:type", EventEmitter),
    __metadata("design:paramtypes", [])
], IgxTreemapComponent.prototype, "nodePointerReleased", null);
IgxTreemapComponent = __decorate([
    Component({
        selector: 'igx-treemap',
        template: ``,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxTreemapComponent_PROVIDERS,
        host: { 'class': 'ig-treemap igx-treemap' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        Injector,
        ComponentFactoryResolver])
], IgxTreemapComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapNodeStyleModule = class IgxTreemapNodeStyleModule {
};
IgxTreemapNodeStyleModule = __decorate([
    NgModule({
        declarations: [IgxTreemapNodeStyleComponent],
        imports: [CommonModule],
        exports: [IgxTreemapNodeStyleComponent],
        entryComponents: []
    })
], IgxTreemapNodeStyleModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapNodeStyleDynamicModule = class IgxTreemapNodeStyleDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTreemapNodeStyleComponent", IgxTreemapNodeStyleComponent);
        TypeRegistrar.register("TreemapNodeStyle", TreemapNodeStyle.$type);
    }
};
IgxTreemapNodeStyleDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTreemapNodeStyleModule],
        exports: [IgxTreemapNodeStyleModule],
        entryComponents: [IgxTreemapNodeStyleComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapNodeStyleDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapNodeStyleMappingModule = class IgxTreemapNodeStyleMappingModule {
};
IgxTreemapNodeStyleMappingModule = __decorate([
    NgModule({
        declarations: [IgxTreemapNodeStyleMappingComponent],
        imports: [CommonModule],
        exports: [IgxTreemapNodeStyleMappingComponent],
        entryComponents: []
    })
], IgxTreemapNodeStyleMappingModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapNodeStyleMappingDynamicModule = class IgxTreemapNodeStyleMappingDynamicModule {
    constructor() {
        TypeRegistrar.registerCons("IgxTreemapNodeStyleMappingComponent", IgxTreemapNodeStyleMappingComponent);
        TypeRegistrar.register("TreemapNodeStyleMapping", TreemapNodeStyleMapping.$type);
    }
};
IgxTreemapNodeStyleMappingDynamicModule = __decorate([
    NgModule({
        declarations: [],
        imports: [CommonModule, IgxTreemapNodeStyleMappingModule],
        exports: [IgxTreemapNodeStyleMappingModule],
        entryComponents: [IgxTreemapNodeStyleMappingComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapNodeStyleMappingDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapModule = class IgxTreemapModule {
    constructor() {
        TypeRegistrar.registerCons('IgxTreemapComponent', IgxTreemapComponent);
        TypeRegistrar.register('Treemap', Treemap.$type);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxTreemapModule = __decorate([
    NgModule({
        declarations: [IgxTreemapComponent],
        exports: [IgxTreemapComponent,
            IgxTreemapNodeStyleDynamicModule,
            IgxTreemapNodeStyleMappingModule
        ],
        imports: [CommonModule, IgxTreemapNodeStyleDynamicModule,
            IgxTreemapNodeStyleMappingModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxTreemapDynamicModule = class IgxTreemapDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('Treemap', Treemap);
        TypeRegistrar.registerCons('IgxTreemapComponent', IgxTreemapComponent);
        TypeRegistrar.register('Treemap', Treemap.$type);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxTreemapDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxTreemapNodeStyleDynamicModule,
            IgxTreemapNodeStyleMappingDynamicModule,
            IgxTreemapModule
        ],
        imports: [CommonModule, IgxTreemapNodeStyleDynamicModule,
            IgxTreemapNodeStyleMappingDynamicModule,
            IgxTreemapModule
        ],
        entryComponents: [IgxTreemapComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxTreemapDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ServiceProvider_Spark extends Base {
    constructor() {
        super(...arguments);
        this.a = DictionaryUtil.dictionaryCreate();
    }
    addService(a, b) {
        this.a.set(a, b);
    }
    getService(a) {
        return this.a.get(a);
    }
}
ServiceProvider_Spark.$t = markType(ServiceProvider_Spark, 'ServiceProvider_Spark');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class Message_Spark extends Base {
    toString() {
        return getInstanceType(this).toString();
    }
}
Message_Spark.$t = markType(Message_Spark, 'Message_Spark');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MessageChannel_Spark extends Base {
    constructor() {
        super(...arguments);
        this.c = new Queue$1(Message_Spark.$);
        this.messageSent = null;
        this.a = null;
    }
    sendMessage(a) {
        if (this.messageSent != null) {
            this.messageSent(a);
        }
        else {
            this.c.g(a);
        }
    }
    attachTarget(a) {
        this.messageSent = delegateCombine(this.messageSent, a);
        while (this.c.count > 0) {
            let b = this.c.b();
            this.messageSent(b);
        }
    }
    detachTarget(a) {
        this.messageSent = delegateRemove(this.messageSent, a);
    }
    connectTo(a) {
        this.a = a;
        this.attachTarget(runOn(this, this.sendToNext));
    }
    detachFromNext() {
        if (this.a == null) {
            return;
        }
        this.detachTarget(runOn(this, this.sendToNext));
        this.a = null;
    }
    sendToNext(a) {
        if (this.a != null) {
            this.a.sendMessage(a);
        }
    }
    toString() {
        return "MessageQueue";
    }
}
MessageChannel_Spark.$t = markType(MessageChannel_Spark, 'MessageChannel_Spark');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class RenderingMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.b = 0;
    }
}
RenderingMessage_Spark.$t = markType(RenderingMessage_Spark, 'RenderingMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class AxisRenderMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = false;
    }
}
AxisRenderMessage_Spark.$t = markType(AxisRenderMessage_Spark, 'AxisRenderMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ContainerResizedMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.g = 0;
        this.d = 0;
        this.f = 0;
        this.e = 0;
        this.h = null;
        this.i = null;
        this.j = null;
        this.k = null;
        this.b = null;
        this.c = null;
    }
}
ContainerResizedMessage_Spark.$t = markType(ContainerResizedMessage_Spark, 'ContainerResizedMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class InteractionMessage_Spark extends Message_Spark {
}
InteractionMessage_Spark.$t = markType(InteractionMessage_Spark, 'InteractionMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ViewportChangedMessage_Spark extends InteractionMessage_Spark {
    constructor() {
        super(...arguments);
        this.d = 0;
        this.c = 0;
        this.e = 0;
        this.b = 0;
    }
    get newTop() {
        return this.d;
    }
    set newTop(a) {
        this.d = a;
    }
    get newLeft() {
        return this.c;
    }
    set newLeft(a) {
        this.c = a;
    }
    get newWidth() {
        return this.e;
    }
    set newWidth(a) {
        this.e = a;
    }
    get newHeight() {
        return this.b;
    }
    set newHeight(a) {
        this.b = a;
    }
    toString() {
        return "ViewportChangedMessage[" + this.newTop.toString() + ", " + this.newLeft.toString() + ", " + this.newWidth.toString() + ", " + this.newHeight.toString() + "]";
    }
}
ViewportChangedMessage_Spark.$t = markType(ViewportChangedMessage_Spark, 'ViewportChangedMessage_Spark', InteractionMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PixelRatioMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.b = 0;
    }
}
PixelRatioMessage_Spark.$t = markType(PixelRatioMessage_Spark, 'PixelRatioMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SparklineAxisVisualData extends Base {
    constructor() {
        super();
        this._name = null;
        this._minLabel = null;
        this._maxLabel = null;
        this._axisLine = null;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get minLabel() {
        return this._minLabel;
    }
    set minLabel(a) {
        this._minLabel = a;
    }
    get maxLabel() {
        return this._maxLabel;
    }
    set maxLabel(a) {
        this._maxLabel = a;
    }
    get axisLine() {
        return this._axisLine;
    }
    set axisLine(a) {
        this._axisLine = a;
    }
    scaleByViewport(a) {
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\"");
        if (this.minLabel != null) {
            a.u(",");
            a.l("minLabel: " + this.minLabel.serialize());
        }
        if (this.maxLabel != null) {
            a.u(",");
            a.l("maxLabel: " + this.maxLabel.serialize());
        }
        if (this.axisLine != null) {
            a.u(",");
            a.l("axisLine: " + this.axisLine.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    }
}
SparklineAxisVisualData.$t = markType(SparklineAxisVisualData, 'SparklineAxisVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ClearMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = false;
    }
}
ClearMessage_Spark.$t = markType(ClearMessage_Spark, 'ClearMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PolygonMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = null;
    }
    get points() {
        return this.c;
    }
    set points(a) {
        this.c = a;
    }
}
PolygonMessage_Spark.$t = markType(PolygonMessage_Spark, 'PolygonMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ColumnMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.d = null;
        this.g = null;
        this.k = null;
        this.l = null;
        this.f = null;
        this.e = null;
        this.i = 0;
        this.h = 0;
        this.j = 0;
        this.c = 0;
    }
}
ColumnMessage_Spark.$t = markType(ColumnMessage_Spark, 'ColumnMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class WinLossColumnMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.d = null;
        this.g = null;
        this.k = null;
        this.l = null;
        this.f = null;
        this.e = null;
        this.i = 0;
        this.h = 0;
        this.j = 0;
        this.c = 0;
    }
}
WinLossColumnMessage_Spark.$t = markType(WinLossColumnMessage_Spark, 'WinLossColumnMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MarkerMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.e = null;
        this.f = null;
        this.m = null;
        this.n = null;
        this.d = null;
        this.c = null;
        this.k = 0;
        this.g = 0;
        this.i = 0;
        this.h = 0;
        this.j = 0;
        this.l = 0;
    }
}
MarkerMessage_Spark.$t = markType(MarkerMessage_Spark, 'MarkerMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NormalRangeMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.g = 0;
        this.h = 0;
        this.f = 0;
        this.e = 0;
        this.c = false;
    }
    get k() {
        return this.g;
    }
    set k(a) {
        this.g = a;
    }
    get l() {
        return this.h;
    }
    set l(a) {
        this.h = a;
    }
    get j() {
        return this.f;
    }
    set j(a) {
        this.f = a;
    }
    get i() {
        return this.e;
    }
    set i(a) {
        this.e = a;
    }
    get d() {
        return this.c;
    }
    set d(a) {
        this.c = a;
    }
}
NormalRangeMessage_Spark.$t = markType(NormalRangeMessage_Spark, 'NormalRangeMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TrendLineMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = null;
    }
    get points() {
        return this.c;
    }
    set points(a) {
        this.c = a;
    }
}
TrendLineMessage_Spark.$t = markType(TrendLineMessage_Spark, 'TrendLineMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class TooltipMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = 0;
        this.d = 0;
        this.g = null;
    }
    get xOffset() {
        return this.c;
    }
    set xOffset(a) {
        this.c = a;
    }
    get yOffset() {
        return this.d;
    }
    set yOffset(a) {
        this.d = a;
    }
    get context() {
        return this.g;
    }
    set context(a) {
        this.g = a;
    }
}
TooltipMessage_Spark.$t = markType(TooltipMessage_Spark, 'TooltipMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ToooltipTemplateMessage_Spark extends RenderingMessage_Spark {
    constructor() {
        super(...arguments);
        this.c = null;
    }
    get template() {
        return this.c;
    }
    set template(a) {
        this.c = a;
    }
}
ToooltipTemplateMessage_Spark.$t = markType(ToooltipTemplateMessage_Spark, 'ToooltipTemplateMessage_Spark', RenderingMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ContainerMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.b = null;
    }
}
ContainerMessage_Spark.$t = markType(ContainerMessage_Spark, 'ContainerMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class BrushChangedMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.c = null;
        this.b = null;
    }
}
BrushChangedMessage_Spark.$t = markType(BrushChangedMessage_Spark, 'BrushChangedMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class VisibilityMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.c = 0;
        this.b = null;
    }
}
VisibilityMessage_Spark.$t = markType(VisibilityMessage_Spark, 'VisibilityMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class NumberChangedMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.b = 0;
        this.c = null;
    }
}
NumberChangedMessage_Spark.$t = markType(NumberChangedMessage_Spark, 'NumberChangedMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ContainerSizeChangedMessage_Spark extends InteractionMessage_Spark {
}
ContainerSizeChangedMessage_Spark.$t = markType(ContainerSizeChangedMessage_Spark, 'ContainerSizeChangedMessage_Spark', InteractionMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MouseMoveMessage_Spark extends InteractionMessage_Spark {
    constructor() {
        super(...arguments);
        this.b = null;
    }
    get position() {
        return this.b;
    }
    set position(a) {
        this.b = a;
    }
}
MouseMoveMessage_Spark.$t = markType(MouseMoveMessage_Spark, 'MouseMoveMessage_Spark', InteractionMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MouseLeaveMessage_Spark extends InteractionMessage_Spark {
}
MouseLeaveMessage_Spark.$t = markType(MouseLeaveMessage_Spark, 'MouseLeaveMessage_Spark', InteractionMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SparklineToolTipContext extends EventArgs {
    constructor() {
        super(...arguments);
        this._high = 0;
        this._low = 0;
        this._first = 0;
        this._last = 0;
    }
    get high() {
        return this._high;
    }
    set high(a) {
        this._high = a;
    }
    get low() {
        return this._low;
    }
    set low(a) {
        this._low = a;
    }
    get first() {
        return this._first;
    }
    set first(a) {
        this._first = a;
    }
    get last() {
        return this._last;
    }
    set last(a) {
        this._last = a;
    }
}
SparklineToolTipContext.$t = markType(SparklineToolTipContext, 'SparklineToolTipContext', EventArgs.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SparklineVisualData extends Base {
    constructor() {
        super();
        this._name = null;
        this._horizontalAxis = null;
        this._verticalAxis = null;
        this._sparkPath = null;
        this._negativeSparkPath = null;
        this._trendLinePath = null;
        this._rangePath = null;
        this._markersPath = null;
        this._negativeMarkersPath = null;
        this._lowMarkersPath = null;
        this._highMarkersPath = null;
        this._firstMarkerPath = null;
        this._lastMarkerPath = null;
        this._viewport = null;
        this._marginViewport = null;
    }
    get name() {
        return this._name;
    }
    set name(a) {
        this._name = a;
    }
    get horizontalAxis() {
        return this._horizontalAxis;
    }
    set horizontalAxis(a) {
        this._horizontalAxis = a;
    }
    get verticalAxis() {
        return this._verticalAxis;
    }
    set verticalAxis(a) {
        this._verticalAxis = a;
    }
    get sparkPath() {
        return this._sparkPath;
    }
    set sparkPath(a) {
        this._sparkPath = a;
    }
    get negativeSparkPath() {
        return this._negativeSparkPath;
    }
    set negativeSparkPath(a) {
        this._negativeSparkPath = a;
    }
    get trendLinePath() {
        return this._trendLinePath;
    }
    set trendLinePath(a) {
        this._trendLinePath = a;
    }
    get rangePath() {
        return this._rangePath;
    }
    set rangePath(a) {
        this._rangePath = a;
    }
    get markersPath() {
        return this._markersPath;
    }
    set markersPath(a) {
        this._markersPath = a;
    }
    get negativeMarkersPath() {
        return this._negativeMarkersPath;
    }
    set negativeMarkersPath(a) {
        this._negativeMarkersPath = a;
    }
    get lowMarkersPath() {
        return this._lowMarkersPath;
    }
    set lowMarkersPath(a) {
        this._lowMarkersPath = a;
    }
    get highMarkersPath() {
        return this._highMarkersPath;
    }
    set highMarkersPath(a) {
        this._highMarkersPath = a;
    }
    get firstMarkerPath() {
        return this._firstMarkerPath;
    }
    set firstMarkerPath(a) {
        this._firstMarkerPath = a;
    }
    get lastMarkerPath() {
        return this._lastMarkerPath;
    }
    set lastMarkerPath(a) {
        this._lastMarkerPath = a;
    }
    get viewport() {
        return this._viewport;
    }
    set viewport(a) {
        this._viewport = a;
    }
    get marginViewport() {
        return this._marginViewport;
    }
    set marginViewport(a) {
        this._marginViewport = a;
    }
    scaleByViewport() {
        this.horizontalAxis.scaleByViewport(this.viewport);
        this.verticalAxis.scaleByViewport(this.viewport);
        if (this.sparkPath != null) {
            this.sparkPath.scaleByViewport(this.marginViewport);
        }
        if (this.negativeSparkPath != null) {
            this.negativeSparkPath.scaleByViewport(this.marginViewport);
        }
        if (this.trendLinePath != null) {
            this.trendLinePath.scaleByViewport(this.marginViewport);
        }
        if (this.rangePath != null) {
            this.rangePath.scaleByViewport(this.marginViewport);
        }
        if (this.markersPath != null) {
            this.markersPath.scaleByViewport(this.marginViewport);
        }
        if (this.negativeMarkersPath != null) {
            this.negativeMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.lowMarkersPath != null) {
            this.lowMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.highMarkersPath != null) {
            this.highMarkersPath.scaleByViewport(this.marginViewport);
        }
        if (this.firstMarkerPath != null) {
            this.firstMarkerPath.scaleByViewport(this.marginViewport);
        }
        if (this.lastMarkerPath != null) {
            this.lastMarkerPath.scaleByViewport(this.marginViewport);
        }
    }
    serialize() {
        let a = new StringBuilder(0);
        a.u("{");
        a.u("name: \"" + this.name + "\"");
        if (this.horizontalAxis != null) {
            a.u(",");
            a.l("horizontalAxis: " + this.horizontalAxis.serialize());
        }
        if (this.horizontalAxis != null) {
            a.u(",");
            a.l("verticalAxis: " + this.verticalAxis.serialize());
        }
        if (this.sparkPath != null) {
            a.u(",");
            a.l("sparkPath: " + this.sparkPath.serialize());
        }
        if (this.negativeSparkPath != null) {
            a.u(",");
            a.l("negativeSparkPath: " + this.negativeSparkPath.serialize());
        }
        if (this.trendLinePath != null) {
            a.u(",");
            a.l("trendLinePath: " + this.trendLinePath.serialize());
        }
        if (this.rangePath != null) {
            a.u(",");
            a.l("rangePath: " + this.rangePath.serialize());
        }
        if (this.markersPath != null) {
            a.u(",");
            a.l("markersPath: " + this.markersPath.serialize());
        }
        if (this.negativeMarkersPath != null) {
            a.u(",");
            a.l("negativeMarkersPath: " + this.negativeMarkersPath.serialize());
        }
        if (this.lowMarkersPath != null) {
            a.u(",");
            a.l("lowMarkersPath: " + this.lowMarkersPath.serialize());
        }
        if (this.highMarkersPath != null) {
            a.u(",");
            a.l("highMarkersPath: " + this.highMarkersPath.serialize());
        }
        if (this.firstMarkerPath != null) {
            a.u(",");
            a.l("firstMarkerPath: " + this.firstMarkerPath.serialize());
        }
        if (this.lastMarkerPath != null) {
            a.u(",");
            a.l("lastMarkerPath: " + this.lastMarkerPath.serialize());
        }
        if (this.viewport != null) {
            a.l(",");
            a.l("viewPort:" + this.viewport.serialize());
        }
        if (this.marginViewport != null) {
            a.l(",");
            a.l("marginViewPort:" + this.marginViewport.serialize());
        }
        a.u("");
        a.u("}");
        return a.toString();
    }
}
SparklineVisualData.$t = markType(SparklineVisualData, 'SparklineVisualData');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Represents the type of sparkline
 */
var SparklineDisplayType;
(function (SparklineDisplayType) {
    /**
     * Display the sparkline as a line.
     */
    SparklineDisplayType[SparklineDisplayType["Line"] = 0] = "Line";
    /**
     * Display the sparkline as a filled polygon.
     */
    SparklineDisplayType[SparklineDisplayType["Area"] = 1] = "Area";
    /**
     * Display the sparkline as a set of columns.
     */
    SparklineDisplayType[SparklineDisplayType["Column"] = 2] = "Column";
    /**
     * Display the sparkline as a set of columns on a boolean scale.
     */
    SparklineDisplayType[SparklineDisplayType["WinLoss"] = 3] = "WinLoss";
})(SparklineDisplayType || (SparklineDisplayType = {}));
/**
 * @hidden
 */
let SparklineDisplayType_$type = markEnum('SparklineDisplayType', 'Line,0|Area,1|Column,2|WinLoss,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class SparkFrame extends Base {
    constructor() {
        super(...arguments);
        this.a = new List$1(Array_$type, 0);
        this.f = new List$1(Point_$type, 0);
        this.d = new List$1(Point_$type, 0);
        this.e = new List$1(Point_$type, 0);
        this.c = new List$1(Point_$type, 0);
        this.b = new List$1(Point_$type, 0);
        this.m = null;
        this.n = null;
    }
    get g() {
        return this.a;
    }
    set g(a) {
        this.a = a;
    }
    get l() {
        return this.f;
    }
    set l(a) {
        this.f = a;
    }
    get j() {
        return this.d;
    }
    set j(a) {
        this.d = a;
    }
    get k() {
        return this.e;
    }
    set k(a) {
        this.e = a;
    }
    get i() {
        return this.c;
    }
    set i(a) {
        this.c = a;
    }
    get h() {
        return this.b;
    }
    set h(a) {
        this.b = a;
    }
}
SparkFrame.$t = markType(SparkFrame, 'SparkFrame');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class ConfigurationMessage_Spark extends Message_Spark {
}
ConfigurationMessage_Spark.$t = markType(ConfigurationMessage_Spark, 'ConfigurationMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class PropertyChangedMessage_Spark extends ConfigurationMessage_Spark {
    constructor() {
        super(...arguments);
        this.f = null;
        this.c = null;
        this.b = null;
    }
    get propertyName() {
        return this.f;
    }
    set propertyName(a) {
        this.f = a;
    }
    get oldValue() {
        return this.c;
    }
    set oldValue(a) {
        this.c = a;
    }
    get newValue() {
        return this.b;
    }
    set newValue(a) {
        this.b = a;
    }
    toString() {
        let a = "null";
        let b = "null";
        if (this.oldValue != null) {
            a = this.oldValue.toString();
        }
        if (this.newValue != null) {
            b = this.newValue.toString();
        }
        return "PropertyChangedMessage[" + this.propertyName + ", " + a + ", " + b + "]";
    }
}
PropertyChangedMessage_Spark.$t = markType(PropertyChangedMessage_Spark, 'PropertyChangedMessage_Spark', ConfigurationMessage_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class DataChangedMessage_Spark extends Message_Spark {
    constructor() {
        super(...arguments);
        this.c = 0;
        this.e = null;
        this.d = null;
        this.b = 0;
    }
}
DataChangedMessage_Spark.$t = markType(DataChangedMessage_Spark, 'DataChangedMessage_Spark', Message_Spark.$);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class HorizontalAxisView extends Base {
    constructor(a) {
        super();
        this.j = null;
        this.w = null;
        this.m = null;
        this.l = null;
        this.s = 0;
        this.v = 0;
        this.u = 0;
        this.k = null;
        this.r = -1;
        this.ag = null;
        this.af = null;
        this.ah = null;
        this.a = ["border-top-width", "border-top-color", "color"];
        this.n = false;
        this.q = 1;
        this.g = null;
        this.o = new Dictionary$2(Type.$, Delegate_$type, 0);
        this.d = null;
        this.c = null;
        this.p.item(AxisRenderMessage_Spark.$, (b) => this.ac(typeCast(AxisRenderMessage_Spark.$, b)));
        this.p.item(ContainerResizedMessage_Spark.$, (b) => this.y(typeCast(ContainerResizedMessage_Spark.$, b)));
        this.p.item(ViewportChangedMessage_Spark.$, (b) => this.ae(typeCast(ViewportChangedMessage_Spark.$, b)));
        this.p.item(PixelRatioMessage_Spark.$, (b) => this.ab(typeCast(PixelRatioMessage_Spark.$, b)));
        this.j = a;
    }
    b() {
        if (!this.n) {
            this.n = true;
            this.k.a("ui-sparkline-axis-x", this.a);
        }
        return this.a;
    }
    t() {
        let a = this.r;
        if (a >= 0) {
            return a;
        }
        let b = this.b()[0];
        if (b != null) {
            a = parseInt(b);
        }
        this.r = a = (a < 1) ? 1 : a;
        return a;
    }
    get h() {
        return this.g;
    }
    set h(a) {
        let b = this.g;
        this.g = a;
        this.k = a.getService("View");
        this.aa(b, this.g);
    }
    get p() {
        return this.o;
    }
    set p(a) {
        this.o = a;
    }
    get f() {
        return this.d;
    }
    set f(a) {
        this.d = a;
    }
    get e() {
        return this.c;
    }
    set e(a) {
        this.c = a;
    }
    z(a) {
        let b;
        if (((() => { let c = this.p.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    }
    aa(a, b) {
        if (a != null) {
            this.f.detachTarget(runOn(this, this.z));
        }
        if (b != null) {
            this.f = b.getService("RenderingMessages");
            this.e = b.getService("InteractionMessages");
            this.f.attachTarget(runOn(this, this.z));
        }
    }
    y(a) {
        this.w = a.j;
        this.m = a.b;
        this.l = this.k.o("ui-sparkline-axis-x");
        if (this.l == null) {
            this.l = FontUtil.getFont(a.h);
        }
        if (this.m != null) {
            this.m.ac(this.l);
        }
        this.s = FontUtil.getCurrentFontHeight(a.h, this.l);
        if (this.j != null && this.j.fm != 1) {
            a.d = a.d - this.s;
            a.e = this.t();
        }
    }
    ae(a) {
        this.v = this.w.width();
        this.u = this.s + this.t();
    }
    ac(a) {
        this.ad(a.c);
    }
    ad(a) {
        this.ah = null;
        let b = (!a || this.j == null) ? null : this.m;
        if (b == null || !b.d) {
            return;
        }
        b.k(0, 0, this.v, this.u);
        if (this.l != null) {
            b.ac(this.l);
        }
        if (this.q != 1) {
            b.z();
            b.aa(this.q, this.q);
        }
        let c = this.t(), d = c / 2;
        let e = this.j.av == null || this.j.av.count == 0;
        if (e) {
            this.u = 0;
        }
        let f = e ? null : this.x(this.j.av.item(0));
        let g = f == null ? "" : f.toString();
        this.ag = new TextBlock();
        this.ag.ak = g;
        this.ag.n = 2;
        this.af = new TextBlock();
        let h = e ? null : this.x(this.j.av.item(this.j.av.count - 1));
        this.af.ak = g = h == null ? "" : h.toString();
        this.af.o = this.ag.o = c;
        this.af.n = this.v - b.f(g) - 4;
        let i = this.j.fb;
        let j = i == null ? null : i._fill;
        let k = new Color();
        let l = true;
        if (i != null) {
            l = false;
            k = i.color;
        }
        i = new Brush();
        if (l) {
            i._fill = (this.a[2] == null) ? "#000000" : this.a[2];
        }
        else {
            i.color = k;
        }
        this.ag.am = this.af.am = i;
        b.w(this.ag);
        b.w(this.af);
        if (c < 0.5) {
            return;
        }
        i = new Brush();
        if (j == null) {
            j = this.a[1];
        }
        i._fill = (j == null) ? "#000000" : j;
        this.ah = new Line();
        this.ah.ak = 0;
        this.ah.al = this.w.width();
        this.ah.am = d;
        this.ah.an = d;
        this.ah._stroke = i;
        this.ah.ac = c;
        b.r(this.ah);
        if (this.q != 1) {
            b.y();
        }
    }
    x(dataItem_) {
        let a = null;
        if (this.j.ai != null) {
            a = this.j.ai.i(dataItem_);
        }
        if (this.j.ax()) {
            a = this.j.c1(dataItem_);
        }
        if (a != null) {
            return a;
        }
        let label_ = this.j.br;
        return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
        ;
    }
    i() {
        let a = new SparklineAxisVisualData();
        if (this.ah != null) {
            a.axisLine = new LineVisualData(1, "HorizontalAxisLine", this.ah);
            a.axisLine.appearance.isVisible = this.w.height() > 0;
        }
        let b = this.l;
        if (this.ag != null) {
            a.minLabel = AppearanceHelper.c(this.ag, this.l);
        }
        if (this.af != null) {
            a.maxLabel = AppearanceHelper.c(this.af, this.l);
        }
        return a;
    }
    ab(a) {
        this.q = a.b;
    }
}
HorizontalAxisView.$t = markType(HorizontalAxisView, 'HorizontalAxisView');
/**
 * @hidden
 */
class VerticalAxisView extends Base {
    constructor(a) {
        super();
        this.ad = null;
        this.ac = null;
        this.al = null;
        this.ak = null;
        this.am = null;
        this.w = -1;
        this.u = -1;
        this.j = null;
        this.aa = null;
        this.m = null;
        this.l = null;
        this.t = 0;
        this.v = 0;
        this.z = 0;
        this.y = 0;
        this.k = null;
        this.s = -1;
        this.a = ["border-top-width", "border-top-color", "color", "text-align"];
        this.n = false;
        this.g = null;
        this.p = new Dictionary$2(Type.$, Delegate_$type, 0);
        this.d = null;
        this.c = null;
        this.r = 1;
        this.q.item(AxisRenderMessage_Spark.$, (b) => this.ai(typeCast(AxisRenderMessage_Spark.$, b)));
        this.q.item(ContainerResizedMessage_Spark.$, (b) => this.ae(typeCast(ContainerResizedMessage_Spark.$, b)));
        this.q.item(ViewportChangedMessage_Spark.$, (b) => this.aj(typeCast(ViewportChangedMessage_Spark.$, b)));
        this.q.item(PixelRatioMessage_Spark.$, (b) => this.ah(typeCast(PixelRatioMessage_Spark.$, b)));
        this.j = a;
    }
    b() {
        if (!this.n) {
            this.n = true;
            this.k.a("ui-sparkline-axis-y", this.a);
        }
        return this.a;
    }
    x() {
        let a = this.s;
        if (a >= 0) {
            return a;
        }
        let b = this.b()[0];
        if (b != null) {
            a = parseInt(b);
        }
        this.s = a = (a < 1) ? 1 : a;
        return a;
    }
    get h() {
        return this.g;
    }
    set h(a) {
        let b = this.g;
        this.g = a;
        this.k = a.getService("View");
        this.ag(b, this.g);
    }
    get q() {
        return this.p;
    }
    set q(a) {
        this.p = a;
    }
    get f() {
        return this.d;
    }
    set f(a) {
        this.d = a;
    }
    get e() {
        return this.c;
    }
    set e(a) {
        this.c = a;
    }
    af(a) {
        let b;
        if (((() => { let c = this.q.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    }
    ag(a, b) {
        if (a != null) {
            this.f.detachTarget(runOn(this, this.af));
        }
        if (b != null) {
            this.f = b.getService("RenderingMessages");
            this.e = b.getService("InteractionMessages");
            this.f.attachTarget(runOn(this, this.af));
        }
    }
    ae(a) {
        this.aa = a.k;
        this.m = a.c;
        this.l = this.k.o("ui-sparkline-axis-y");
        if (this.l == null) {
            this.l = FontUtil.getFont(a.h);
        }
        if (this.m != null) {
            this.m.ac(this.l);
        }
        this.t = FontUtil.getCurrentFontHeight(a.h, this.l);
        if (this.j != null && this.j.ft != 1) {
            this.o(false);
            a.g = a.g - this.v;
            a.f = this.x();
        }
    }
    aj(a) {
        this.z = this.v + this.x();
        this.y = this.aa.height();
    }
    ai(a) {
        if (this.o(a.c)) {
            let b = new ClearMessage_Spark();
            b.c = true;
            this.f.sendMessage(b);
        }
    }
    o(a) {
        this.am = null;
        if (this.j == null || this.m == null || !this.m.d || (a && this.ak == null)) {
            return false;
        }
        let b = this.m;
        if (a) {
            b.k(0, 0, this.z, this.y);
        }
        let c = false;
        if (b != null && this.l != null) {
            b.ac(this.l);
        }
        if (!a) {
            this.al = new TextBlock();
            this.ak = new TextBlock();
            let d = this.ab(this.j.a4);
            this.al.ak = this.ad = d == null ? "" : d.toString();
            let e = this.ab(this.j.a3);
            this.ak.ak = this.ac = e == null ? "" : e.toString();
            if (b != null) {
                this.w = b.f(this.ad) + 3;
                if (this.w > this.v) {
                    c = true;
                    this.v = this.w;
                }
                this.u = b.f(this.ac) + 3;
                if (this.u > this.v) {
                    c = true;
                    this.v = this.u;
                }
            }
            if (!c) {
                let f = Math.max(this.w, this.u);
                if (f < this.v) {
                    this.v = f;
                    c = true;
                }
            }
            if (c) {
                this.z = this.v;
            }
        }
        else if (b != null) {
            if (this.r != 1) {
                b.z();
                b.aa(this.r, this.r);
            }
            let g = this.j.fj;
            let h = 1;
            let i = g == null ? null : g._fill;
            let j = this.b()[3];
            if (j == "left") {
                h = 0;
            }
            else if (j == "center") {
                h = 0.5;
            }
            this.ak.o = 2;
            this.ak.n = (this.v - this.u) * h + 1;
            this.al.n = (this.v - this.w) * h + 1;
            this.al.o = this.y - this.t - 2;
            let k = new Color();
            let l = true;
            if (g != null) {
                k = g.color;
                l = false;
            }
            g = new Brush();
            if (l) {
                g._fill = (this.a[2] == null) ? "#000000" : this.a[2];
            }
            else {
                g.color = k;
            }
            this.al.am = this.ak.am = g;
            b.w(this.al);
            b.w(this.ak);
            let m = this.x(), n = m / 2;
            if (m >= 0.5) {
                g = new Brush();
                if (i == null) {
                    i = this.a[1];
                }
                g._fill = (i == null) ? "#000000" : i;
                this.am = new Line();
                this.am.ak = this.z - n;
                this.am.al = this.z - n;
                this.am.am = 0;
                this.am.an = this.y;
                this.am._stroke = g;
                this.am.ac = m;
                b.r(this.am);
            }
            if (this.r != 1) {
                b.y();
            }
        }
        return c;
    }
    ab(dataItem_) {
        let a = null;
        if (this.j.aj != null) {
            a = this.j.aj.i(dataItem_);
        }
        if (this.j.ax()) {
            a = this.j.c1(dataItem_);
        }
        if (a != null) {
            return a;
        }
        let label_ = this.j.bt;
        return (typeof dataItem_ != 'undefined') ? dataItem_ : '';
        ;
    }
    i() {
        let a = new SparklineAxisVisualData();
        if (this.am != null) {
            a.axisLine = new LineVisualData(1, "VerticalAxisLine", this.am);
            a.axisLine.appearance.isVisible = this.aa.width() > 0;
        }
        if (this.al != null) {
            a.minLabel = AppearanceHelper.c(this.al, this.l);
        }
        if (this.ak != null) {
            a.maxLabel = AppearanceHelper.c(this.ak, this.l);
        }
        return a;
    }
    ah(a) {
        this.r = a.b;
    }
}
VerticalAxisView.$t = markType(VerticalAxisView, 'VerticalAxisView');
/**
 * @hidden
 */
class XamSparklineView extends Base {
    constructor() {
        super();
        this.bn = null;
        this.bm = null;
        this.ae = null;
        this.af = null;
        this.ag = null;
        this.ah = null;
        this.p = null;
        this.q = null;
        this.r = null;
        this.n = null;
        this.u = false;
        this.b = new Array(6);
        this.y = -1;
        this.bw = new Path();
        this.bu = new Path();
        this.bx = new Path();
        this.bv = new Path();
        this.bs = new Path();
        this.bt = new Path();
        this.br = new Path();
        this.bp = new Path();
        this.bo = new Path();
        this.bq = new Path();
        this.j = null;
        this.f = null;
        this.g = null;
        this.v = new Dictionary$2(Type.$, Delegate_$type, 0);
        this.l = null;
        this.s = false;
        this.ai = null;
        this.e = null;
        this.d = null;
        this.c = null;
        this.t = false;
        this.x = 1;
        this.bs._visibility = 1;
        this.bt._visibility = 1;
        this.br._visibility = 1;
        this.bp._visibility = 1;
        this.bo._visibility = 1;
        this.bq._visibility = 1;
        this.bv._visibility = 1;
        let a = this.w;
        a.item(ClearMessage_Spark.$, (b) => this.aj(typeCast(ClearMessage_Spark.$, b)));
        a.item(PolygonMessage_Spark.$, (b) => this.bc(typeCast(PolygonMessage_Spark.$, b)));
        a.item(ColumnMessage_Spark.$, (b) => this.a5(typeCast(ColumnMessage_Spark.$, b)));
        a.item(WinLossColumnMessage_Spark.$, (b) => this.bj(typeCast(WinLossColumnMessage_Spark.$, b)));
        a.item(MarkerMessage_Spark.$, (b) => this.a8(typeCast(MarkerMessage_Spark.$, b)));
        a.item(NormalRangeMessage_Spark.$, (b) => this.bd(typeCast(NormalRangeMessage_Spark.$, b)));
        a.item(TrendLineMessage_Spark.$, (b) => this.bg(typeCast(TrendLineMessage_Spark.$, b)));
        a.item(TooltipMessage_Spark.$, (b) => this.be(typeCast(TooltipMessage_Spark.$, b)));
        a.item(ToooltipTemplateMessage_Spark.$, (b) => this.bf(typeCast(ToooltipTemplateMessage_Spark.$, b)));
        a.item(ContainerMessage_Spark.$, (b) => this.ak(typeCast(ContainerMessage_Spark.$, b)));
        a.item(PixelRatioMessage_Spark.$, (b) => this.aw(typeCast(PixelRatioMessage_Spark.$, b)));
        a.item(BrushChangedMessage_Spark.$, (b) => this.a3(typeCast(BrushChangedMessage_Spark.$, b)));
        a.item(ContainerResizedMessage_Spark.$, (b) => this.at());
        a.item(VisibilityMessage_Spark.$, (b) => this.bi(typeCast(VisibilityMessage_Spark.$, b)));
        a.item(NumberChangedMessage_Spark.$, (b) => this.bb(typeCast(NumberChangedMessage_Spark.$, b)));
        a.item(ContainerSizeChangedMessage_Spark.$, (b) => this.at());
        this.d = new CanvasRenderScheduler();
        this.c = new CanvasRenderScheduler();
        this.d.l(this);
        this.c.l(this);
    }
    aw(a) {
        this.x = a.b;
    }
    get k() {
        return this.j;
    }
    set k(a) {
        let b = this.j;
        this.j = a;
        this.av(b, this.j);
        this.l = null;
    }
    get h() {
        return this.f;
    }
    set h(a) {
        this.f = a;
    }
    get i() {
        return this.g;
    }
    set i(a) {
        this.g = a;
    }
    get w() {
        return this.v;
    }
    set w(a) {
        this.v = a;
    }
    av(a, b) {
        if (a != null) {
            this.i.detachTarget(runOn(this, this.ar));
            this.h = null;
        }
        if (b != null) {
            this.i = b.getService("RenderingMessages");
            this.h = b.getService("InteractionMessages");
            this.i.attachTarget(runOn(this, this.ar));
            this.a2(this.h);
        }
    }
    a2(a) {
        this.h = a;
    }
    ar(a) {
        let b;
        if (((() => { let c = this.w.tryGetValue(getInstanceType(a), b); b = c.p1; return c.ret; })())) {
            b(a);
        }
    }
    get m() {
        if (this.l == null) {
            this.l = this.k.getService("Controller");
        }
        return this.l;
    }
    a1(a, b, c) {
        let d = new MouseMoveMessage_Spark();
        d.position = a;
        this.h.sendMessage(d);
    }
    a0(a) {
        let b = new MouseLeaveMessage_Spark();
        this.h.sendMessage(b);
    }
    a3(a) {
        this.a4(a.b, a.c, null, -1, -1);
    }
    a4(a, b, c, d, e) {
        let f = null;
        let g = true, h = true;
        switch (a) {
            case "sparkpath":
            case XamSparkline.$$p[0]:
                f = this.bw;
                break;
            case "negativesparkpath":
            case XamSparkline.$$p[29]:
                f = this.bu;
                break;
            case "markers":
            case XamSparkline.$$p[24]:
                f = this.bs;
                break;
            case "firstmarker":
            case XamSparkline.$$p[3]:
                f = this.bo;
                break;
            case "lastmarker":
            case XamSparkline.$$p[17]:
                f = this.bq;
                break;
            case "highmarker":
            case XamSparkline.$$p[7]:
                f = this.bp;
                break;
            case "lowmarker":
            case XamSparkline.$$p[21]:
                f = this.br;
                break;
            case "negativemarkers":
            case XamSparkline.$$p[30]:
                f = this.bt;
                break;
            case "trendline":
            case XamSparkline.$$p[38]:
                f = this.bx;
                h = false;
                break;
            case "range":
            case XamSparkline.$$p[33]:
                f = this.bv;
                g = false;
                break;
        }
        if (f == null) {
            return;
        }
        if (b == null && c != null) {
            b = new Brush();
            b._fill = c;
        }
        if (b != null) {
            if (h && (c == null || f._fill == null)) {
                f._fill = b;
            }
            if (g && (c == null || f._stroke == null)) {
                f._stroke = b;
            }
        }
        if (d > 0 && d < 1) {
            f._opacity = d;
        }
        if (e > 0 && (c == null || f.ac <= 0)) {
            f.ac = e;
        }
        this.aq();
    }
    bi(a) {
        switch (a.b) {
            case XamSparkline.$$p[26]:
                this.bs._visibility = a.c;
                break;
            case XamSparkline.$$p[5]:
                this.bo._visibility = a.c;
                break;
            case XamSparkline.$$p[19]:
                this.bq._visibility = a.c;
                break;
            case XamSparkline.$$p[9]:
                this.bp._visibility = a.c;
                break;
            case XamSparkline.$$p[23]:
                this.br._visibility = a.c;
                break;
            case XamSparkline.$$p[32]:
                this.bt._visibility = a.c;
                break;
            case XamSparkline.$$p[36]:
                this.bv._visibility = a.c;
                break;
            case XamSparkline.$$p[37]:
                this.u = a.c == 0;
                break;
        }
        this.aq();
    }
    bb(a) {
        let b = a.b;
        if (b <= 0) {
            return;
        }
        switch (a.c) {
            case XamSparkline.$$p[20]:
                this.bw.ac = this.bu.ac = b;
                break;
            case XamSparkline.$$p[40]:
                this.bx.ac = b;
                break;
        }
        this.aq();
    }
    ak(a) {
        if (a.b == null) {
            if (this.n != null) {
                this.n.ar();
                let b = this.n;
                b.onMouseLeave = delegateRemove(b.onMouseLeave, runOn(this, this.a0));
                let c = this.n;
                c.onMouseOver = delegateRemove(c.onMouseOver, runOn(this, this.a1));
                this.n = null;
            }
            this.ae = null;
            this.af = null;
            this.ag = null;
            this.ah = null;
            this.p = this.q = this.r = null;
            this.d.j(null);
            return;
        }
        let d = a.b;
        this.d.j(d);
        this.ae = d;
        this.ae.rootWrapper.setStyleProperty("position", "relative");
        this.af = this.ae.createElement("canvas");
        this.af.setStyleProperty("position", "absolute");
        this.ag = this.ae.createElement("canvas");
        this.ag.setStyleProperty("position", "absolute");
        this.ah = this.ae.createElement("canvas");
        this.ah.setStyleProperty("position", "absolute");
        this.ae.append(this.af);
        this.ae.append(this.ag);
        this.ae.append(this.ah);
        this.p = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.af));
        this.q = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ag));
        this.r = new RenderingContext(new CanvasViewRenderer(), this.ae.get2DCanvasContext(this.ah));
        this.n = new CanvasGestureDOMEventProxy(this.af, this.ae, false);
        let e = this.n;
        e.onMouseLeave = delegateCombine(e.onMouseLeave, runOn(this, this.a0));
        let f = this.n;
        f.onMouseOver = delegateCombine(f.onMouseOver, runOn(this, this.a1));
        this.n.am = (g) => false;
        this.ao();
        this.at();
    }
    ao() {
        let a = ["sparkpath", "negativesparkpath", "trendline", "markers", "firstmarker", "lastmarker", "highmarker", "lowmarker", "negativemarkers", "range"];
        let b = ["#7446B9", "#C62828", "#565656", "#9FB328", "#2E9CA6", "#DC3F76", "#F96232", "#3F51B5", "#C62828", "#66666666"];
        for (let c = 0; c < 10; c++) {
            let d = a[c];
            let e = ["background-color", "opacity", "border-top-width"];
            this.a("ui-sparkline-" + d, e);
            let f = XamSparklineView.ad(e[2], (c < 3) ? (c < 2 ? 2 : 1.5) : -1);
            if (c > 2 && c < 9) {
                this.b[c - 3] = f;
            }
            this.a4(d, null, (e[0] == null) ? b[c] : e[0], XamSparklineView.ad(e[1], -1), c < 3 ? f : -1);
        }
    }
    static ad(v_, a) {
        let d_ = (v_ == null || v_.length < 1) ? null : parseFloat(v_);
        return (d_ == null || d_.toString() == "NaN") ? a : d_;
    }
    a(a, b) {
        this.ae.startCSSQuery();
        for (let c = 0; c < b.length; c++) {
            b[c] = this.ae.getCssDefaultPropertyValue(a, b[c]);
        }
        this.ae.endCSSQuery();
        return b;
    }
    at() {
        if (this.ae == null || this.s) {
            return;
        }
        this.s = true;
        this.ap(this.m.q);
        let a = this.ae.rootWrapper.width(), b = this.ae.rootWrapper.height();
        let c, d, e;
        c = this.af;
        d = this.ag;
        e = this.ah;
        let f = new ContainerResizedMessage_Spark();
        f.g = a;
        f.d = b;
        f.b = this.q;
        f.h = this.ae;
        f.c = this.r;
        f.f = 0;
        f.e = 0;
        f.j = d;
        f.i = c;
        f.k = e;
        this.i.sendMessage(f);
        let g = f.e, h = f.f, i = f.g - h, j = f.d - g;
        let k = i, l = a - i, m = j, n = b - j;
        c.setStyleProperty("width", k.toString() + "px");
        c.setStyleProperty("height", m.toString() + "px");
        c.setAttribute("width", (k * this.x).toString());
        c.setAttribute("height", (m * this.x).toString());
        c.setStyleProperty("marginLeft", l + "px");
        k = (i + h);
        this.az(d, k, n, k * this.x, n * this.x);
        d.setStyleProperty("marginTop", m + "px");
        d.setStyleProperty("marginLeft", (a - i - h).toString() + "px");
        this.az(e, l, m, l * this.x, m * this.x);
        this.bn = new Rect(0, 0, 0, i, j);
        if (this.n != null) {
            this.n.bg = this.bn;
        }
        this.bh();
        let o = new ViewportChangedMessage_Spark();
        o.newLeft = this.bn.left;
        o.newTop = this.bn.top;
        o.newHeight = this.bn.height;
        o.newWidth = this.bn.width;
        this.i.sendMessage(o);
        this.s = false;
    }
    al(a) {
        if (a) {
            this.y = -1;
        }
        else if (this.y < 0) {
            this.bh();
        }
    }
    bh() {
        let a = this.bn.left;
        let b = this.bn.width;
        let c = this.bn.height;
        let d = this.ab(true);
        let e = new Rect(0, a + d, d, b - d * 2, c - d * 2);
        let f = new ViewportChangedMessage_Spark();
        f.newLeft = e.left;
        f.newTop = e.top;
        f.newHeight = e.height;
        f.newWidth = e.width;
        this.bm = e;
        this.h.sendMessage(f);
    }
    aj(a) {
        if (Rect.l_op_Equality(this.bn, null)) {
            return;
        }
        switch (a.b) {
            case 2:
                this.bs.ak = null;
                this.bo.ak = null;
                this.bq.ak = null;
                this.bp.ak = null;
                this.br.ak = null;
                this.bt.ak = null;
                break;
            case 8:
                this.bv.ak = null;
                break;
            case 1:
                this.bw.ak = null;
                this.bu.ak = null;
                break;
            case 4:
                this.am(null);
                break;
            case 16:
                this.bx.ak = null;
                break;
        }
        if (a.c) {
            this.at();
        }
    }
    ab(a) {
        if (a) {
            this.y = -1;
        }
        let b = this.y;
        if (b >= 0) {
            return b;
        }
        b = 0;
        let c = this.m.q;
        if (c.fp == 0) {
            b = this.ac(b, c.bd, 0);
        }
        if (c.fk == 0) {
            b = this.ac(b, c.a6, 1);
        }
        if (c.fn == 0) {
            b = this.ac(b, c.a8, 2);
        }
        if (c.fl == 0) {
            b = this.ac(b, c.a7, 3);
        }
        if (c.fo == 0) {
            b = this.ac(b, c.bc, 4);
        }
        if (c.fq == 0) {
            b = this.ac(b, c.bi, 5);
        }
        this.y = b;
        return b;
    }
    ac(a, b, c) {
        if (b >= 0) {
            return b > a ? b : a;
        }
        return this.b[c] > a ? this.b[c] : a;
    }
    a8(a) {
        this.a9(this.bs, a.e, a.k, 0);
        this.a9(this.bt, a.f, a.l, 5);
        this.a9(this.br, a.d, a.j, 4);
        this.a9(this.bp, a.c, a.h, 3);
        this.ba(this.bo, a.m, a.g, 1);
        this.ba(this.bq, a.n, a.i, 2);
        this.aq();
    }
    ba(a, b, c, d) {
        let e = ((() => {
            let $ret = new List$1(Point_$type, 0);
            $ret.add(b);
            return $ret;
        })());
        this.a9(a, e, c, d);
    }
    a9(a, b, c, d) {
        if (c < 0) {
            c = this.b[d];
        }
        a.ak = this.bl(b, c < 0.1 ? DeviceUtils.g(3) : c);
        if (this.m.q.aq != 3) {
            let e = new TranslateTransform();
            e.j = this.m.o.d;
            a.j = e;
        }
        else {
            a.j = null;
        }
    }
    bl(a, b) {
        let c = new GeometryGroup();
        c.c = 1;
        let d = this.bn.right;
        let e = this.bn.bottom;
        for (let f of fromEnum(a)) {
            if ((!f)) {
                continue;
            }
            if (f.x < 0 || f.y < 0 || f.x > d || f.y > e) {
                continue;
            }
            let g = new EllipseGeometry();
            g.c = b;
            g.d = b;
            g.e = f;
            c.d.add(g);
        }
        return c;
    }
    bc(a) {
        let b = new PathGeometry();
        let c = this.m.q.aq == 1;
        for (let d of fromEnum(a.points)) {
            let e = d.length;
            if (e == 0) {
                continue;
            }
            let f = new PathFigure();
            f._isClosed = f._isFilled = c;
            f._startPoint = d[0];
            for (let g = 1; g < e; g++) {
                let h = new LineSegment(1);
                h.c = d[g];
                f._segments.add(h);
            }
            b.c.add(f);
        }
        this.bw.ak = b;
        this.aq();
    }
    bk(a, b) {
        let c = typeCast(WinLossColumnMessage_Spark.$, b);
        let d = typeCast(ColumnMessage_Spark.$, b);
        let e = new GeometryGroup();
        let f = c != null ? c.i : d.i;
        let g = c != null ? c.h : d.h;
        let h = f * 0.1;
        for (let i of fromEnum(a)) {
            let j = f * 2 - h * 2;
            let k = Math.abs(g - i.y);
            let l = i.x + h;
            let m = (i.y > g ? g : i.y);
            let n = new RectangleGeometry();
            n.e = new Rect(0, l, m, j, k);
            e.d.add(n);
        }
        return e;
    }
    a5(a) {
        this.a6(this.bw, a.d, a);
        this.a6(this.bu, a.g, a);
        this.aq();
    }
    a7(a, b, c) {
        let d = ((() => {
            let $ret = new List$1(Point_$type, 0);
            $ret.add(b);
            return $ret;
        })());
        this.a6(a, d, c);
    }
    a6(a, b, c) {
        a.ak = this.bk(b, c);
    }
    bj(a) {
        this.a6(this.bw, a.d, a);
        this.a6(this.bu, a.g, a);
        this.aq();
    }
    bd(a) {
        let b = new RectangleGeometry();
        b.e = new Rect(0, a.k, a.l, a.j, a.i);
        this.bv.ak = b;
        this.aq();
    }
    bg(a) {
        if (a.points.length == 0) {
            return;
        }
        let b = new PathGeometry();
        let c = new PathFigure();
        c._isClosed = c._isFilled = false;
        c._startPoint = a.points[0];
        let d = a.points.length;
        for (let e = 1; e < d; e++) {
            let f = new LineSegment(1);
            f.c = a.points[e];
            c._segments.add(f);
        }
        b.c.add(c);
        this.bx.ak = b;
        this.aq();
    }
    bf(a) {
        this.ai = a.template;
    }
    be(a) {
        if (!this.u) {
            this.am(null);
            return;
        }
        let b = truncate(Math.round(a.xOffset - 10));
        let c = truncate(Math.round(a.yOffset - 10));
        b = truncate(Math.round(b * this.x));
        c = truncate(Math.round(c * this.x));
        let d = this.p.a(b, c);
        if (d[3] > 0) {
            this.am(a);
        }
        else {
            this.am(null);
        }
    }
    am(a) {
        let x_ = 0, y_ = 0;
        let v_ = null, t_ = null, i_ = this.ae;
        {
            if (a != null) {
                t_ = this.ai;
                x_ = a.xOffset + 6;
                y_ = a.yOffset + 6;
                let b = a.context;
                let f_ = b.first, l_ = b.last, o_ = b.low, h_ = b.high;
                v_ = { First: f_, Last: l_, Low: o_, High: h_ };
            }
            let ren_ = this.ae;
            if (this.e == null) {
                this.e = new DataContext();
            }
            let dc_ = this.e;
            dc_.item = v_;
            dc_.series = this;
            let tt_ = this.ai;
            if (tt_ != null) {
                if (v_ != null) {
                    tt_.updateToolTip(dc_);
                    tt_.setRawPosition(x_, y_);
                }
                else {
                    tt_.hideToolTip();
                }
            }
        }
    }
    get isDirty() {
        return this.t;
    }
    set isDirty(a) {
        this.t = a;
    }
    aq() {
        if (!this.isDirty) {
            this.isDirty = true;
            this.d.o(this.p, null);
            this.c.o(this.q, this.r);
        }
    }
    undirty(a) {
        this.t = false;
        this.ax();
    }
    get index() {
        return 10;
    }
    ay(a, b) {
        b.s(a);
    }
    ax() {
        let a = this.p;
        if (a != null && a.d) {
            if (this.x != 1) {
                a.z();
                a.aa(this.x, this.x);
            }
            a.k(this.bn.left, this.bn.top, this.bn.width, this.bn.height);
            a.s(this.bw);
            a.s(this.bu);
            this.ay(this.bs, a);
            this.ay(this.bt, a);
            this.ay(this.bp, a);
            this.ay(this.br, a);
            this.ay(this.bo, a);
            this.ay(this.bq, a);
            a.s(this.bv);
            a.s(this.bx);
            if (this.x != 1) {
                a.y();
            }
        }
        let b = new AxisRenderMessage_Spark();
        b.c = true;
        this.i.sendMessage(b);
        this.postRender();
    }
    postRender() {
    }
    an(a) {
        a.viewport = new RectData(this.bn.left, this.bn.top, this.bn.width, this.bn.height);
        a.marginViewport = new RectData(this.bm.left, this.bm.top, this.bm.width, this.bm.height);
        a.sparkPath = new PathVisualData(1, "SparkPath", this.bw);
        a.negativeSparkPath = new PathVisualData(1, "NegativeSparkPath", this.bu);
        a.trendLinePath = new PathVisualData(1, "TrendLinePath", this.bx);
        a.rangePath = new PathVisualData(1, "RangePath", this.bv);
        a.markersPath = new PathVisualData(1, "MarkersPath", this.bs);
        a.negativeMarkersPath = new PathVisualData(1, "NegativeMarkersPath", this.bt);
        a.lowMarkersPath = new PathVisualData(1, "LowMarkersPath", this.br);
        a.highMarkersPath = new PathVisualData(1, "HighMarkersPath", this.bp);
        a.firstMarkerPath = new PathVisualData(1, "FirstMarkerPath", this.bo);
        a.lastMarkerPath = new PathVisualData(1, "LastMarkerPath", this.bq);
    }
    preRender() {
    }
    isValid() {
        return true;
    }
    o(a) {
        return FontUtil.getFontForClass(this.ae, a);
    }
    az(a, b, c, d, e) {
        a.setStyleProperty("width", b + "px");
        a.setStyleProperty("height", c + "px");
        a.setAttribute("width", d.toString());
        a.setAttribute("height", e.toString());
    }
    ap(a) {
        let b = a.bl;
        let c = a.a5;
        if (!isNaN_(b) && b != 0) {
            return;
        }
        if (window.devicePixelRatio != undefined && window.devicePixelRatio != c) {
            a.a5 = window.devicePixelRatio;
        }
    }
    au() {
        if (this.n != null) {
            this.n.bc(this.af, "");
        }
    }
    as() {
        this.ap(this.l.q);
        if (this.n != null) {
            this.n.aq(this.af, "");
        }
    }
}
XamSparklineView.$t = markType(XamSparklineView, 'XamSparklineView', Base.$, [ISchedulableRender_$type]);
/**
 * @hidden
 */
class SparkFramePreparer extends Base {
    constructor() {
        super(...arguments);
        this.b = null;
        this.d = 0;
        this.c = 0;
    }
    e(a) {
        this.b.r.al(false);
        a.g.clear();
        a.l.clear();
        a.j.clear();
        a.k.clear();
        a.i.clear();
        a.h.clear();
        let b = this.b.t;
        if (b == null) {
            return;
        }
        let c = b.count;
        let d = this.b.a3.top;
        let e = this.b.a3.left;
        let f = this.b.a3.width;
        let g = this.b.a3.height;
        let h = this.b.a3.bottom;
        let i = Math.floor((c + 1) / f);
        let j = truncate(Math.max(1, i));
        let k = 0;
        let l = truncate(Math.ceil(1 * c / j));
        let m = 0;
        let n = new List$1(Number_$type, 0);
        let o = this.b.q.ar;
        let p = this.b.q.aq;
        let q = this.b.q.bq;
        let r = o != 0 && q >= 1;
        let s = null;
        let t = null;
        if (p == 1 || p == 0) {
            this.d = 0;
        }
        else {
            if (l == 0) {
                this.d = 0;
            }
            else {
                this.d = f / l / 2;
            }
        }
        if (r) {
            let u = (v) => v + 1;
            let v = (w) => b.item(w);
            let w = (x) => this.b.y(x);
            let x = (y) => this.b.z(y);
            switch (this.b.q.ar) {
                case 9:
                    s = TrendCalculators.e(b, q);
                    break;
                case 10:
                    s = TrendCalculators.b(b, q);
                    break;
                case 11:
                    s = TrendCalculators.c(b, q);
                    break;
                case 12:
                    s = TrendCalculators.a(b);
                    break;
                case 13:
                    s = TrendCalculators.g(b, q);
                    break;
                case 1:
                    t = LeastSquaresFit.k(c, u, v);
                    break;
                case 2:
                    t = LeastSquaresFit.o(c, u, v);
                    break;
                case 3:
                    t = LeastSquaresFit.i(c, u, v);
                    break;
                case 4:
                    t = LeastSquaresFit.p(c, u, v);
                    break;
                case 5:
                    t = LeastSquaresFit.q(c, u, v);
                    break;
                case 7:
                    t = LeastSquaresFit.j(c, u, v);
                    break;
                case 6:
                    t = LeastSquaresFit.l(c, u, v);
                    break;
                case 8:
                    t = LeastSquaresFit.n(c, u, v);
                    break;
            }
            if (s != null) {
                for (let y of fromEnum(s)) {
                    n.add(y);
                }
            }
            if (t != null) {
                let z = k * j;
                let aa = l * j;
                if (p == 1 || p == 0) {
                    aa = aa - 1;
                }
                let ab = 0 + this.d;
                let ac = f - this.d;
                let ad = 0;
                if (this.d != 0) {
                    ad = 0.5;
                }
                for (let ae = ab; ae <= ac; ae += 2) {
                    let af = ae / (f - 1);
                    let ag = z + af * (aa - z);
                    let ah = NaN;
                    switch (o) {
                        case 1:
                            ah = LeastSquaresFit.ad(t, ag - ad);
                            break;
                        case 2:
                            ah = LeastSquaresFit.ah(t, ag - ad);
                            break;
                        case 3:
                            ah = LeastSquaresFit.ab(t, ag - ad);
                            break;
                        case 4:
                            ah = LeastSquaresFit.ai(t, ag - ad);
                            break;
                        case 5:
                            ah = LeastSquaresFit.aj(t, ag - ad);
                            break;
                        case 7:
                            ah = LeastSquaresFit.ac(t, ag - ad);
                            break;
                        case 6:
                            ah = LeastSquaresFit.ae(t, ag - ad);
                            break;
                        case 8:
                            ah = LeastSquaresFit.ag(t, ag - ad);
                            break;
                    }
                    ag = w(ag);
                    ah = x(ah);
                    if (!isNaN_(ah) && !isInfinity(ah)) {
                        a.l.add({ $type: Point_$type, x: ag, y: ah });
                    }
                }
            }
        }
        let ai = this.b.t.minimum;
        let aj = this.b.t.maximum;
        let ak = this.b.q.a4;
        let al = this.b.q.a3;
        this.c = h - (m - ak) / (al - ak) * g;
        if (this.c < 0) {
            this.c = 0;
        }
        else if (this.c > h) {
            this.c = h;
        }
        let am = this.c;
        let an;
        for (let ao = k; ao < l; ao++) {
            let ap = this.a(ao, j, c);
            let aq = ap[1];
            let ar = ap[2];
            this.f(ap, c, this.b.a3, ak, al);
            an = ap[1];
            if (ap[2] < am) {
                an = ap[2];
            }
            a.g.add(ap);
            if (!isNaN_(ap[0]) && !isNaN_(ap[1])) {
                a.j.add({ $type: Point_$type, x: ap[0], y: an });
            }
            if (r && s != null) {
                let as = ao * j;
                let at = h - (((n._inner[as] - ai) / (aj - ai)) * g);
                a.l.add({ $type: Point_$type, x: ap[0] + this.d, y: at });
            }
            if (aq < m) {
                a.k.add({ $type: Point_$type, x: ap[0], y: ap[1] });
            }
            if (ai == aq) {
                a.i.add({ $type: Point_$type, x: ap[0], y: ap[1] });
            }
            if (aj == ar) {
                a.h.add({ $type: Point_$type, x: ap[0], y: ap[2] });
            }
        }
        if (a.j.count == 0) {
            a.m = a.n = { $type: Point_$type, x: NaN, y: NaN };
        }
        else {
            a.m = a.j._inner[0];
            a.n = a.j._inner[a.j.count - 1];
        }
    }
    a(a, b, c) {
        let d = Math.min(a * b, c - 1);
        let e = Math.min(d + b - 1, c - 1);
        let f = true;
        let g = 0;
        let h = 0;
        for (let i = d; i <= e; ++i) {
            let j = this.b.t.item(i);
            if (f) {
                f = false;
                g = j;
                h = j;
            }
            else {
                g = Math.min(g, j);
                h = Math.max(h, j);
            }
        }
        let k = [0, 0, 0];
        k[0] = (0.5 * (d + e));
        k[1] = g;
        k[2] = h;
        return k;
    }
    f(a, b, c, d, e) {
        let f = c.left;
        let g = c.top;
        let h = c.width;
        let i = c.height;
        if (this.b.q.aq == 1 || this.b.q.aq == 0) {
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        let j = b > 0 ? a[0] / b : b == 0 ? 0.5 : NaN;
        a[0] = f + j * h;
        if (this.b.q.aq == 3) {
            if (a[1] > 0) {
                a[1] = g;
                a[2] = g;
            }
            else if (a[1] < 0) {
                a[1] = g + i;
                a[2] = g + i;
            }
            else {
                a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
                a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
            }
        }
        else {
            a[1] = g + (1 - ((a[1] - d) / (e - d))) * i;
            a[2] = g + (1 - ((a[2] - d) / (e - d))) * i;
        }
    }
}
SparkFramePreparer.$t = markType(SparkFramePreparer, 'SparkFramePreparer');
/**
 * @hidden
 */
class SparklineConnector extends Base {
    constructor(a, b) {
        super();
        this.d = null;
        this.b = null;
        this.e = null;
        this.a = null;
        this.c = null;
        this.e = b;
        if (a == null) {
            return;
        }
        this.d = typeCast(XamSparkline.$, a);
        this.a = this.d.ak;
        this.c = this.d.at;
        b.ap(this.d);
        let c = new ServiceProvider_Spark();
        c.addService("ConfigurationMessages", new MessageChannel_Spark());
        c.addService("RenderingMessages", new MessageChannel_Spark());
        c.addService("InteractionMessages", new MessageChannel_Spark());
        c.addService("Model", this.d);
        c.addService("View", this.e);
        c.addService("HorizontalAxis", this.a);
        c.addService("VerticalAxis", this.c);
        this.d.ao = c;
        this.e.k = c;
        this.a.h = c;
        this.c.h = c;
        this.b = new SparklineController(c);
        c.addService("Controller", this.b);
    }
}
SparklineConnector.$t = markType(SparklineConnector, 'SparklineConnector');
/**
 * @hidden
 */
class SparklineController extends DependencyObject {
    constructor(a) {
        super();
        this.k = null;
        this.m = null;
        this.l = null;
        this.p = null;
        this.r = null;
        this.t = null;
        this.s = null;
        this.o = new SparkFramePreparer();
        this.n = new SparkFrame();
        this.a3 = Rect.empty;
        this.aa = null;
        this.k = a.getService("ConfigurationMessages");
        this.m = a.getService("RenderingMessages");
        this.l = a.getService("InteractionMessages");
        this.aa = (b, c) => this.ah(c.action, c.position, c.count, c.propertyName);
        this.q = a.getService("Model");
        this.r = a.getService("View");
        this.k.attachTarget(runOn(this, this.ag));
        this.l.attachTarget(runOn(this, this.aj));
    }
    get q() {
        return this.p;
    }
    set q(a) {
        let b = this.p != a;
        if (b) {
            this.p = a;
            this.an(runOn(this, this.aw));
        }
    }
    get x() {
        return this.q != null ? this.q.itemsSource : null;
    }
    get u() {
        return this.c(SparklineController.a2);
    }
    set u(a) {
        this.h(SparklineController.a2, a);
    }
    get ad() {
        return this.q != null ? this.q.c9 : null;
    }
    get ac() {
        return this.q != null ? this.q.ce : null;
    }
    get ab() {
        return this.q != null ? this.q.toolTip : null;
    }
    y(a) {
        let b = this.t.count;
        if (this.q.aq == 1 || this.q.aq == 0) {
            b--;
        }
        if (b < 0) {
            b = 0;
        }
        let c = b > 0 ? a / b : b == 0 ? 0.5 : NaN;
        c = this.a3.left + (c) * this.a3.width;
        return c;
    }
    z(a) {
        let b = ((a - this.q.a4) / (this.q.a3 - this.q.a4));
        b = (1 - b);
        b = this.a3.top + (b) * this.a3.height;
        return b;
    }
    w() {
        return !this.a3.isEmpty && this.a3.width > 0 && this.a3.height > 0 && this.q != null && this.q.a4 != this.q.a3;
    }
    v(a) {
        if (a.oldValue != a.newValue) {
            return true;
        }
        return false;
    }
    av(a, b) {
        if (this.aa == null) {
            this.aa = (c, d) => this.ah(d.action, d.position, d.count, d.propertyName);
        }
        let c = typeCast(FastItemsSource.$, a);
        if (c != null) {
            c.event = delegateRemove(c.event, this.aa);
        }
        let d = typeCast(FastItemsSource.$, b);
        if (d != null) {
            d.event = delegateCombine(d.event, this.aa);
        }
    }
    ay() {
        if (this.q != null) {
            if (this.t == null) {
                this.q.a4 = this.q.a3 = NaN;
            }
            else {
                if (isNaN_(this.q.bh)) {
                    this.q.a4 = this.t.minimum;
                }
                else {
                    this.q.a4 = this.q.bh;
                }
                if (isNaN_(this.q.bg)) {
                    this.q.a3 = this.t.maximum;
                }
                else {
                    this.q.a3 = this.q.bg;
                }
                if (this.q.a4 == this.q.a3) {
                    if (!isNaN_(this.q.bg) && isNaN_(this.q.bh)) {
                        this.q.a4 = this.q.a3 - 1;
                    }
                    else if (isNaN_(this.q.bg) && !isNaN_(this.q.bh)) {
                        this.q.a3 = this.q.a4 + 1;
                    }
                    else {
                        if (Math.floor(this.q.a4) < this.q.a4) {
                            this.q.a4 = Math.floor(this.q.a4);
                        }
                        else {
                            this.q.a4 = Math.floor(this.q.a4) - 1;
                        }
                        if (Math.ceil(this.q.a3) > this.q.a3) {
                            this.q.a3 = Math.ceil(this.q.a3);
                        }
                        else {
                            this.q.a3 = Math.ceil(this.q.a3) + 1;
                        }
                    }
                }
            }
        }
    }
    a0() {
        if (this.u != null) {
            this.u.deregisterColumn(this.t);
            this.t = this.u.registerColumn(this.ad, null, false);
        }
        else {
            this.t = null;
        }
    }
    ax() {
        if (this.u != null) {
            this.u.deregisterColumn(this.s);
            this.s = this.u.registerColumnObject(this.ac, null, false);
            this.q.av = this.s;
        }
        else {
            this.q.av = this.s = null;
        }
    }
    au() {
        let a = new AxisRenderMessage_Spark();
        this.m.sendMessage(a);
    }
    an(a) {
        a();
    }
    aw() {
        this.u = this.getFastItemsSource(this.x);
        this.a0();
        this.ax();
        this.ay();
        this.au();
    }
    ah(a, b, c, d) {
        this.a0();
        this.ax();
        this.ay();
        this.au();
        this.an(runOn(this, this.ao));
    }
    az() {
        let a = new ToooltipTemplateMessage_Spark();
        a.template = this.ab;
        this.m.sendMessage(a);
    }
    ag(a) {
        if (typeCast(PropertyChangedMessage_Spark.$, a) !== null) {
            this.am(a);
        }
        else if (typeCast(ContainerSizeChangedMessage_Spark.$, a) !== null) {
            this.m.sendMessage(a);
        }
        else if (typeCast(DataChangedMessage_Spark.$, a) !== null) {
            this.ai(a);
        }
    }
    ai(a) {
        let b = this.u;
        if (b == null) {
            return;
        }
        switch (a.b) {
            case 2:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(2, 2, a.d, a.e, a.c));
                break;
            case 0:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 0, a.d, a.c));
                break;
            case 1:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(1, 1, a.e, a.c));
                break;
            case 4:
                b.handleCollectionChanged(new NotifyCollectionChangedEventArgs(0, 4));
                break;
        }
        this.an(runOn(this, this.aw));
    }
    aj(a) {
        let b = a;
        if (typeCast(ViewportChangedMessage_Spark.$, b) !== null) {
            this.a1(b);
        }
        else if (typeCast(MouseLeaveMessage_Spark.$, b) !== null) {
            this.ak(b);
        }
        else if (typeCast(MouseMoveMessage_Spark.$, b) !== null) {
            this.al(b);
        }
        else if (typeCast(ContainerSizeChangedMessage_Spark.$, b) !== null) {
            this.m.sendMessage(a);
        }
    }
    am(a) {
        switch (a.propertyName) {
            case XamSparkline.$$p[15]:
                this.an(runOn(this, this.aw));
                break;
            case XamSparkline.$$p[43]:
                this.an(runOn(this, this.aw));
                break;
            case XamSparkline.$$p[16]:
                this.an(runOn(this, this.aw));
                break;
            case "ToolTip":
                this.az();
                break;
            case XamSparkline.$$p[28]:
            case XamSparkline.$$p[27]:
                this.ay();
                this.au();
                break;
            case XamSparkline.$$p[11]:
            case XamSparkline.$$p[45]:
                this.au();
                break;
            case XamSparkline.$$p[0]:
            case XamSparkline.$$p[29]:
            case XamSparkline.$$p[24]:
            case XamSparkline.$$p[3]:
            case XamSparkline.$$p[17]:
            case XamSparkline.$$p[7]:
            case XamSparkline.$$p[21]:
            case XamSparkline.$$p[30]:
            case XamSparkline.$$p[38]:
            case XamSparkline.$$p[33]:
                let b = new BrushChangedMessage_Spark();
                b.c = typeCast(Brush.$, a.newValue);
                b.b = a.propertyName;
                this.m.sendMessage(b);
                break;
            case XamSparkline.$$p[26]:
            case XamSparkline.$$p[5]:
            case XamSparkline.$$p[19]:
            case XamSparkline.$$p[9]:
            case XamSparkline.$$p[23]:
            case XamSparkline.$$p[32]:
            case XamSparkline.$$p[36]:
            case XamSparkline.$$p[37]:
                let c = new VisibilityMessage_Spark();
                c.c = EnumUtil.getEnumValue(Visibility_$type, a.newValue);
                c.b = a.propertyName;
                this.m.sendMessage(c);
                this.r.al(true);
                break;
            case XamSparkline.$$p[25]:
            case XamSparkline.$$p[4]:
            case XamSparkline.$$p[18]:
            case XamSparkline.$$p[8]:
            case XamSparkline.$$p[22]:
            case XamSparkline.$$p[31]:
                this.r.al(true);
                break;
            case XamSparkline.$$p[20]:
            case XamSparkline.$$p[40]:
                let d = new NumberChangedMessage_Spark();
                d.b = a.newValue;
                d.c = a.propertyName;
                this.m.sendMessage(d);
                break;
            case XamSparkline.$$p[10]:
            case XamSparkline.$$p[44]:
            case XamSparkline.$$p[12]:
            case XamSparkline.$$p[46]:
                this.at();
                break;
            case "Container":
                let e = new ContainerMessage_Spark();
                e.b = a.newValue;
                this.m.sendMessage(e);
                break;
            case "ActualPixelScalingRatio":
                {
                    let f = new PixelRatioMessage_Spark();
                    f.b = a.newValue;
                    this.m.sendMessage(f);
                }
                break;
            case XamSparkline.$$p[13]:
            case XamSparkline.$$p[14]:
                if (this.q.ca != null) {
                    this.q.ai = new BindingFormatter();
                    this.q.ai.j = this.q.ca;
                    this.q.ai.d = this.q.ag;
                }
                else {
                    this.q.ai = null;
                }
                this.au();
                break;
            case XamSparkline.$$p[47]:
            case XamSparkline.$$p[48]:
                if (this.q.df != null) {
                    this.q.aj = new BindingFormatter();
                    this.q.aj.j = this.q.df;
                    this.q.aj.d = this.q.ah;
                }
                else {
                    this.q.aj = null;
                }
                this.au();
                break;
        }
        if (this.v(a)) {
            this.an(runOn(this, this.ao));
        }
    }
    at() {
        let a = new ClearMessage_Spark();
        a.c = true;
        this.m.sendMessage(a);
    }
    a1(a) {
        this.a3 = new Rect(0, a.newLeft, a.newTop, a.newWidth, a.newHeight);
        this.an(runOn(this, this.ao));
    }
    al(a) {
        let b = new ClearMessage_Spark();
        b.b = 4;
        this.m.sendMessage(b);
        let c = new TooltipMessage_Spark();
        c.b = 4;
        c.xOffset = a.position.x + 10;
        c.yOffset = a.position.y + 10;
        if (this.t != null && this.t.count > 0) {
            let d = new SparklineToolTipContext();
            d.high = this.t.maximum;
            d.low = this.t.minimum;
            d.first = this.t.item(0);
            d.last = this.t.item(this.t.count - 1);
            c.context = d;
        }
        this.m.sendMessage(c);
    }
    ak(a) {
        let b = new ClearMessage_Spark();
        b.b = 4;
        this.m.sendMessage(b);
    }
    af(a) {
        let b = new ClearMessage_Spark();
        b.b = a;
        this.m.sendMessage(b);
    }
    ae() {
        this.af(1);
        this.af(2);
        this.af(16);
        this.af(8);
    }
    ao() {
        this.ae();
        if (!this.w()) {
            return;
        }
        this.o.b = this;
        this.o.e(this.n);
        switch (this.q.aq) {
            case 2:
                this.ap();
                break;
            case 3:
                this.as();
                break;
            case 0:
            case 1:
                this.ar();
                break;
        }
        let a = new NormalRangeMessage_Spark();
        a.k = this.a3.left;
        a.l = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bj)));
        a.j = this.a3.width;
        let b = Math.max(this.a3.top, Math.min(this.a3.bottom, this.z(this.q.bk)));
        a.i = Math.abs(b - a.l);
        a.l = Math.min(a.l, b);
        a.d = this.q.aw;
        this.m.sendMessage(a);
        let c = new TrendLineMessage_Spark();
        c.points = this.n.l.toArray();
        this.m.sendMessage(c);
    }
    ap() {
        let a = new ColumnMessage_Spark();
        a.d = this.n.j;
        a.g = this.n.k;
        a.f = this.n.i;
        a.e = this.n.h;
        a.k = this.n.m;
        a.l = this.n.n;
        a.j = this.n.g.count;
        a.h = this.o.c;
        a.i = this.o.d;
        a.c = this.q.aq;
        this.m.sendMessage(a);
        this.aq();
    }
    as() {
        let a = new WinLossColumnMessage_Spark();
        a.d = this.n.j;
        a.g = this.n.k;
        a.f = this.n.i;
        a.e = this.n.h;
        a.k = this.n.m;
        a.l = this.n.n;
        a.j = this.n.g.count;
        a.h = this.o.c;
        a.i = this.o.d;
        a.c = this.q.aq;
        this.m.sendMessage(a);
    }
    ar() {
        if (this.n.g.count == 0) {
            return;
        }
        let a = new List$1(List$1.$.specialize(Array_$type), 0);
        let b = new List$1(Array_$type, 0);
        let c = true;
        for (let d of fromEnum(this.n.g)) {
            if (isNaN_(d[1]) || isInfinity(d[1])) {
                if (!c) {
                    a.add(b);
                }
                c = true;
                continue;
            }
            if (c) {
                b = new List$1(Array_$type, 0);
                c = false;
            }
            b.add(d);
        }
        if (!c) {
            a.add(b);
        }
        let e = new PolygonMessage_Spark();
        e.points = new List$1(Array_$type, 0);
        if (this.q.as == 0) {
            let f = new List$1(Array_$type, 0);
            for (let g of fromEnum(a)) {
                f.o(g);
            }
            let h = this.j(f);
            e.points.add(h);
        }
        else {
            for (let i of fromEnum(a)) {
                let j = this.j(i);
                e.points.add(j);
            }
        }
        this.m.sendMessage(e);
        this.aq();
    }
    j(a) {
        let b = this.o.c;
        let c = new List$1(Point_$type, 0);
        let d;
        let e = this.q.aq == 1;
        for (let f of fromEnum(a)) {
            d = f[1];
            if (e) {
                if (f[2] <= b) {
                    d = f[2];
                }
            }
            c.add({ $type: Point_$type, x: f[0], y: d });
        }
        if (this.q.aq == 0) {
            let g = new List$1(Point_$type, 0);
            for (let h of fromEnum(a)) {
                g.add({ $type: Point_$type, x: h[0], y: h[2] });
            }
            g.w();
            c.o(g);
        }
        if (this.q.aq == 1 && c.count > 0) {
            let i = c._inner[0];
            let j = c._inner[c.count - 1];
            c.add({ $type: Point_$type, x: j.x, y: this.o.c });
            c.add({ $type: Point_$type, x: i.x, y: this.o.c });
        }
        return c.toArray();
    }
    aq() {
        let a = new MarkerMessage_Spark();
        a.e = this.n.j;
        a.f = this.n.k;
        a.d = this.n.i;
        a.c = this.n.h;
        a.m = this.n.m;
        a.n = this.n.n;
        a.k = this.q.bd;
        a.g = this.q.a6;
        a.i = this.q.a8;
        a.h = this.q.a7;
        a.j = this.q.bc;
        a.l = this.q.bi;
        this.m.sendMessage(a);
    }
    getFastItemsSource(a) {
        let b = null;
        if (this.x != null) {
            let c = null;
            b = new FastItemsSource();
            b.e = this.x;
            c = new FastItemsSourceReference(b);
            c.b++;
            b = c.a;
        }
        return b;
    }
    releaseFastItemsSource(a) {
        if (a != null) {
            let b = null;
            --b.b;
        }
        return null;
    }
}
SparklineController.$t = markType(SparklineController, 'SparklineController', DependencyObject.$, [IFastItemsSourceProvider_$type]);
SparklineController.a2 = DependencyProperty.i("FastItemsSource", IFastItemsSource_$type, SparklineController.$, new PropertyMetadata(1, (a, b) => (typeCast(SparklineController.$, a)).av(b.oldValue, b.newValue)));
/**
 * @hidden
 */
class XamSparkline extends Control {
    constructor() {
        super();
        this.ap = null;
        this.ai = null;
        this.aj = null;
        this.an = null;
        this.al = new MessageChannel_Spark();
        this.a0 = NaN;
        this.az = NaN;
        this.av = null;
        this.ak = null;
        this.at = null;
        this.a2 = NaN;
        this.a1 = 1;
        this.ab = XamSparkline.$;
        this.at = new VerticalAxisView(this);
        this.ak = new HorizontalAxisView(this);
        this.ap = new SparklineConnector(this, new XamSparklineView());
    }
    get toolTip() {
        return this.c(XamSparkline.ev);
    }
    set toolTip(a) {
        this.h(XamSparkline.ev, a);
        this.fs = a == null || a.toString().length == 0 ? 1 : 0;
    }
    ax() {
        return this.bp != null;
    }
    c1(a) {
        return this.bp(a);
    }
    get ao() {
        return this.an;
    }
    set ao(a) {
        let b = this.an;
        this.an = a;
        this.ds(b, this.an);
    }
    get am() {
        return this.al;
    }
    set am(a) {
        this.al = a;
    }
    get a4() {
        return this.a0;
    }
    set a4(a) {
        this.a0 = a;
    }
    get a3() {
        return this.az;
    }
    set a3(a) {
        this.az = a;
    }
    ds(a, b) {
        if (a != null) {
            this.am.detachFromNext();
        }
        if (b != null) {
            this.am.connectTo(b.getService("ConfigurationMessages"));
        }
    }
    onDetachedFromUI() {
        this.ap.e.au();
    }
    onAttachedToUI() {
        this.ap.e.as();
    }
    dr(a, b, c) {
        if (a == "PixelScalingRatio") {
            if (!isNaN_(DeviceUtils.a(this.bl))) {
                this.a5 = DeviceUtils.a(this.bl);
            }
        }
        this.am.sendMessage(((() => {
            let $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = a;
            $ret.oldValue = b;
            $ret.newValue = c;
            return $ret;
        })()));
    }
    destroy() {
        this.am.sendMessage(((() => {
            let $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = "Container";
            $ret.newValue = null;
            return $ret;
        })()));
    }
    provideContainer(a) {
        this.am.sendMessage(((() => {
            let $ret = new PropertyChangedMessage_Spark();
            $ret.propertyName = "Container";
            $ret.newValue = a;
            return $ret;
        })()));
    }
    notifyResized() {
        this.am.sendMessage(new ContainerSizeChangedMessage_Spark());
    }
    dn(source_, a, b, c) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.am.sendMessage(((() => {
            let $ret = new DataChangedMessage_Spark();
            $ret.b = 2;
            $ret.e = b;
            $ret.d = c;
            $ret.c = a;
            return $ret;
        })()));
    }
    dj(source_) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.am.sendMessage(((() => {
            let $ret = new DataChangedMessage_Spark();
            $ret.b = 4;
            return $ret;
        })()));
    }
    dk(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.am.sendMessage(((() => {
            let $ret = new DataChangedMessage_Spark();
            $ret.b = 0;
            $ret.d = b;
            $ret.c = a;
            return $ret;
        })()));
    }
    dl(source_, a, b) {
        if (source_.dataView && source_.dataSource) {
            source_ = source_.dataView();
        }
        ;
        if (source_ != this.itemsSource) {
            return;
        }
        this.am.sendMessage(((() => {
            let $ret = new DataChangedMessage_Spark();
            $ret.b = 1;
            $ret.e = b;
            $ret.c = a;
            return $ret;
        })()));
    }
    au() {
        let a = new SparklineVisualData();
        a.name = "SparklineVisualData";
        a.horizontalAxis = this.ak.i();
        a.verticalAxis = this.at.i();
        this.ap.e.an(a);
        return a;
    }
    by() {
        let a = this.au();
        a.scaleByViewport();
        return a.serialize();
    }
    get bl() {
        return this.a2;
    }
    set bl(a) {
        let b = this.a2;
        this.a2 = a;
        this.dr("PixelScalingRatio", b, this.a2);
        if (this.a2 != b) {
            this.dr("PixelScalingRatio", b, this.a2);
        }
    }
    get a5() {
        return this.a1;
    }
    set a5(a) {
        let b = this.a1;
        this.a1 = a;
        if (this.a1 != b) {
            this.dr("ActualPixelScalingRatio", b, this.a1);
        }
    }
}
XamSparkline.$t = markType(XamSparkline, 'XamSparkline', Control.$);
XamSparkline.bf = -1;
XamSparkline.bb = -1;
XamSparkline.ev = DependencyProperty.i("ToolTip", Base.$, XamSparkline.$, new PropertyMetadata(2, null, (a, b) => (typeCast(XamSparkline.$, a)).dr("ToolTip", b.oldValue, b.newValue)));
XamSparkline.bo = -1;
XamSparkline.$$p = markDep(DependencyProperty, PropertyMetadata, XamSparkline, 'dr', ['Brush:e8:du', [Brush.$, null], 'DisplayNormalRangeInFront:aw:dv', [0, true], 'DisplayType:aq:dw', [SparklineDisplayType_$type, enumGetBox(SparklineDisplayType_$type, 0)], 'FirstMarkerBrush:e9:dx', [Brush.$, null], 'FirstMarkerSize:a6:dy', [1, XamSparkline.bf], 'FirstMarkerVisibility:fk:dz', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'FormatLabel:bp:d0', [Delegate_$type], 'HighMarkerBrush:fa:d1', [Brush.$, null], 'HighMarkerSize:a7:d2', [1, XamSparkline.bf], 'HighMarkerVisibility:fl:d3', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'HorizontalAxisBrush:fb:d4', [Brush.$, null], 'HorizontalAxisLabel:br:d5', [4, "{0}"], 'HorizontalAxisVisibility:fm:d6', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'HorizontalLabelFormat:ca:d7', [2, null], 'HorizontalLabelFormatSpecifiers:ag:d8', [Array_$type, null], 'ItemsSource::d9', [IEnumerable_$type, null], 'LabelMemberPath:ce:ea', [2, null], 'LastMarkerBrush:fc:eb', [Brush.$, null], 'LastMarkerSize:a8:ec', [1, XamSparkline.bf], 'LastMarkerVisibility:fn:ed', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'LineThickness:a9:ee', [1, XamSparkline.bb], 'LowMarkerBrush:fd:ef', [Brush.$, null], 'LowMarkerSize:bc:eg', [1, XamSparkline.bf], 'LowMarkerVisibility:fo:eh', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'MarkerBrush:fe:ei', [Brush.$, null], 'MarkerSize:bd:ej', [1, XamSparkline.bf], 'MarkerVisibility:fp:ek', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'Maximum:bg:el', [1, NaN], 'Minimum:bh:em', [1, NaN], 'NegativeBrush:ff:en', [Brush.$, null], 'NegativeMarkerBrush:fg:eo', [Brush.$, null], 'NegativeMarkerSize:bi:ep', [1, XamSparkline.bf], 'NegativeMarkerVisibility:fq:eq', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'NormalRangeFill:fh:er', [Brush.$, null], 'NormalRangeMaximum:bj:es', [1, 0], 'NormalRangeMinimum:bk:et', [1, 0], 'NormalRangeVisibility:fr:eu', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'ToolTipVisibility:fs:ew', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'TrendLineBrush:fi:ex', [Brush.$, null], 'TrendLinePeriod:bq:ey', [1, 7], 'TrendLineThickness:bm:ez', [1, XamSparkline.bo], 'TrendLineType:ar:e0', [TrendLineType_$type, enumGetBox(TrendLineType_$type, 0)], 'UnknownValuePlotting:as:e1', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)], 'ValueMemberPath:c9:e2', [2, null], 'VerticalAxisBrush:fj:e3', [Brush.$, null], 'VerticalAxisLabel:bt:e4', [4, "{0:n}"], 'VerticalAxisVisibility:ft:e5', [Visibility_$type, enumGetBox(Visibility_$type, 1)], 'VerticalLabelFormat:df:e6', [2, null], 'VerticalLabelFormatSpecifiers:ah:e7', [Array_$type, null]]);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

let defaultFont$1 = "Verdana, \"Segoe UI\", Arial, \"Myriad Pro\", sans-serif";
let SparklineStylingDefaults = {
    //"ui-lineargauge-backing": {
    //    "background-color": "#ffffff",
    //    "border-color": "#ffffff"
    //},
    "ui-sparkline-axis": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    "ui-sparkline-axis-x": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    "ui-sparkline-axis-y": {
        "border-color": "#989ea3",
        "background-color": "#989ea3",
        "font-family": defaultFont$1,
        "font-style": "normal",
        "font-weight": "normal",
        "font-size": "13px",
        "color": "#666666",
        "font-variant": "",
        "line-height": ""
    },
    //.ui-chart-tooltip
    //{
    //    -moz-box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    -webkit-box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    box-shadow: 0 0 2px rgba(0,0,0,0.6);
    //    padding: 5px 8px;
    //    font-size: 12px;
    //    font-family:"Segoe UI", Arial, sans-serif;
    //}
    "font-family": defaultFont$1,
    "font-style": "normal",
    "font-weight": "normal",
    "font-size": "13px",
    "color": "#666666",
    "font-variant": "",
    "line-height": ""
};

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
const IgxSparklineComponent_PROVIDERS = [];
/**
 * Represents a sparkline chart.
*/
let IgxSparklineComponent = class IgxSparklineComponent {
    constructor(_renderer, _elRef, _ngZone, _componentFactoryResolver, _injector) {
        //super();
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._ngZone = _ngZone;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._injector = _injector;
        this._dataSource = null;
        this._root = null;
        this._zoneRunner = null;
        this._tooltipTemplate = null;
        this._tooltipContent = null;
        this._defaultTooltips = null;
        this.__p = null;
        this._hasUserValues = new Set();
        this._stylingContainer = null;
        this._stylingParent = null;
        this._inStyling = false;
        if (this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
        }
        this._zoneRunner = (act) => this._ngZone.run(act);
        this._implementation = this.createImplementation();
        this._container = _renderer.createElement("div");
        _renderer.appendChild(_elRef.element.nativeElement, this._container);
        _renderer.setStyle(this._container, "display", "block");
        _renderer.setStyle(this._container, "width", "100%");
        _renderer.setStyle(this._container, "height", "100%");
        var root;
        root = this._container;
        if (this._container.nativeElement != null) {
            root = this._container.nativeElement;
        }
        this._root = root;
        var ren = new AngularRenderer(root, this._renderer, window.document, this._ngZone, true, SparklineStylingDefaults);
        this._wrapper = ren;
        var sparkline = this.i;
        this._sparkline = sparkline;
        sparkline.provideContainer(ren);
        ren.addSizeWatcher(() => {
            this._sparkline.notifyResized();
        });
    }
    set height(value) {
        this._height = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "height", value);
        this._sparkline.notifyResized();
    }
    get height() {
        return this._height;
    }
    set width(value) {
        this._width = value;
        this._renderer.setStyle(this._elRef.element.nativeElement, "width", value);
        this._sparkline.notifyResized();
    }
    get width() {
        return this._width;
    }
    set dataSource(value) {
        this._dataSource = value;
        this.i.itemsSource = this._dataSource;
        //console.log("setting axis data source: " + value)
    }
    get dataSource() {
        if (this._dataSource != null) {
            return this._dataSource;
        }
        return this.i.itemsSource;
    }
    ngOnDestroy() {
        this._sparkline.destroy();
        this._wrapper.destroy();
    }
    createImplementation() {
        return new XamSparkline();
    }
    ngAfterContentInit() {
        this._styling(this._root, this);
        this.i.notifyResized();
    }
    _runInZone(act) {
        if (this._zoneRunner != null) {
            this._zoneRunner(act);
        }
        else {
            act();
        }
    }
    set tooltipTemplate(value) {
        this._tooltipTemplate = value;
        if (value == null) {
            if (this._tooltipContent !== null) {
                this._tooltipContent.destroy();
                this._tooltipContent = null;
            }
        }
        if (this._tooltipContent != null) {
            this._tooltipContent.instance.template = this._tooltipTemplate;
        }
        else {
            this._ensureTooltipCreated();
        }
    }
    get tooltipTemplate() {
        return this._tooltipTemplate;
    }
    _ensureTooltipCreated() {
        if (this.i.toolTip == null) {
            let tooltip = this.createTooltip();
            if (tooltip == null) {
                return;
            }
            this._tooltipContent = tooltip;
            tooltip.instance.template = this._tooltipTemplate;
            this.i.toolTip = this.createWrapper(tooltip.location.nativeElement);
        }
    }
    createWrapper(ele) {
        let wrapper = new AngularWrapper(ele, this._renderer, this._ngZone);
        wrapper.updateToolTip = ele.updateToolTip;
        wrapper.hideToolTip = ele.hideToolTip;
        return wrapper;
    }
    _ensureDefaultTooltip() {
        if (this._defaultTooltips == null) {
            return;
        }
        this._defaultTooltips.instance["ensureDefaultTooltip"](this);
    }
    _onDefaultTooltipsReady(cr) {
        this._ensureDefaultTooltip();
    }
    createTooltip() {
        if (!TypeRegistrar.isRegistered("IgxTooltipContainerComponent")) {
            return null;
        }
        let t = TypeRegistrar.get("IgxTooltipContainerComponent");
        let cf = this._componentFactoryResolver.resolveComponentFactory(t);
        let cr = this._dynamicContent.createComponent(cf);
        let ele = cr.location.nativeElement;
        let self = this;
        ele.updateToolTip = function (c) {
            if (c.externalObject) {
                c = c.externalObject;
            }
            else {
                let ext = new IgxDataContext();
                ext._implementation = c;
                c = ext;
            }
            if (ele.parentElement != self._container) {
                if (ele.parentElement != null) {
                    ele.parentElement.removeChild(ele);
                }
                self._container.appendChild(ele);
            }
            cr.instance.context = c;
            ele.style.display = "block";
            return true;
        };
        ele.hideToolTip = function () {
            ele.style.display = "none";
        };
        ele.style.display = "none";
        return cr;
    }
    /**
     * @hidden
     */
    get i() {
        return this._implementation;
    } /**
                                 * @hidden
                                 */
    static _createFromInternal(internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        let name = internal.$type.name;
        let externalName = "Igx" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    }
    /**
 * Gets or sets the sparkline brush.
*/
    get brush() {
        return brushToString(this.i.e8);
    }
    set brush(v) {
        this.i.e8 = stringToBrush(v);
    }
    /**
     * Gets or sets the negative brush of the sparkline.
    */
    get negativeBrush() {
        return brushToString(this.i.ff);
    }
    set negativeBrush(v) {
        this.i.ff = stringToBrush(v);
    }
    /**
     * Gets or sets the marker brush of the sparkline.
    */
    get markerBrush() {
        return brushToString(this.i.fe);
    }
    set markerBrush(v) {
        this.i.fe = stringToBrush(v);
    }
    /**
     * Gets or sets the negative marker brush of the sparkline.
    */
    get negativeMarkerBrush() {
        return brushToString(this.i.fg);
    }
    set negativeMarkerBrush(v) {
        this.i.fg = stringToBrush(v);
    }
    /**
     * Gets or sets the first marker brush of the sparkline.
    */
    get firstMarkerBrush() {
        return brushToString(this.i.e9);
    }
    set firstMarkerBrush(v) {
        this.i.e9 = stringToBrush(v);
    }
    /**
     * Gets or sets the last marker brush of the sparkline.
    */
    get lastMarkerBrush() {
        return brushToString(this.i.fc);
    }
    set lastMarkerBrush(v) {
        this.i.fc = stringToBrush(v);
    }
    /**
     * Gets or sets the high marker brush of the sparkline.
    */
    get highMarkerBrush() {
        return brushToString(this.i.fa);
    }
    set highMarkerBrush(v) {
        this.i.fa = stringToBrush(v);
    }
    /**
     * Gets or sets the low marker brush of the sparkline.
    */
    get lowMarkerBrush() {
        return brushToString(this.i.fd);
    }
    set lowMarkerBrush(v) {
        this.i.fd = stringToBrush(v);
    }
    /**
     * Gets or sets the trendline brush of the sparkline.
    */
    get trendLineBrush() {
        return brushToString(this.i.fi);
    }
    set trendLineBrush(v) {
        this.i.fi = stringToBrush(v);
    }
    /**
     * Gets or sets the horizontal axis line brush of the sparkline.
    */
    get horizontalAxisBrush() {
        return brushToString(this.i.fb);
    }
    set horizontalAxisBrush(v) {
        this.i.fb = stringToBrush(v);
    }
    /**
     * Gets or sets the vertical axis line brush of the sparkline.
    */
    get verticalAxisBrush() {
        return brushToString(this.i.fj);
    }
    set verticalAxisBrush(v) {
        this.i.fj = stringToBrush(v);
    }
    /**
     * Gets or sets the normal range brush of the sparkline.
    */
    get normalRangeFill() {
        return brushToString(this.i.fh);
    }
    set normalRangeFill(v) {
        this.i.fh = stringToBrush(v);
    }
    /**
     * Gets or sets the display state of the horizontal axis.
    */
    get horizontalAxisVisibility() {
        return this.i.fm;
    }
    set horizontalAxisVisibility(v) {
        this.i.fm = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the display state of the vertical axis.
    */
    get verticalAxisVisibility() {
        return this.i.ft;
    }
    set verticalAxisVisibility(v) {
        this.i.ft = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the marker visibility of the sparkline.
    */
    get markerVisibility() {
        return this.i.fp;
    }
    set markerVisibility(v) {
        this.i.fp = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the negative marker visibility of the sparkline.
    */
    get negativeMarkerVisibility() {
        return this.i.fq;
    }
    set negativeMarkerVisibility(v) {
        this.i.fq = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the first marker visibility of the sparkline.
    */
    get firstMarkerVisibility() {
        return this.i.fk;
    }
    set firstMarkerVisibility(v) {
        this.i.fk = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the last marker visibility of the sparkline.
    */
    get lastMarkerVisibility() {
        return this.i.fn;
    }
    set lastMarkerVisibility(v) {
        this.i.fn = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the low marker visibility of the sparkline.
    */
    get lowMarkerVisibility() {
        return this.i.fo;
    }
    set lowMarkerVisibility(v) {
        this.i.fo = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the high marker visibility of the sparkline.
    */
    get highMarkerVisibility() {
        return this.i.fl;
    }
    set highMarkerVisibility(v) {
        this.i.fl = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the normal range visibility of the sparkline.
    */
    get normalRangeVisibility() {
        return this.i.fr;
    }
    set normalRangeVisibility(v) {
        this.i.fr = ensureEnum(Visibility_$type, v);
    }
    /**
     * Gets or sets the position of the normal range on the sparkline.
    */
    get displayNormalRangeInFront() {
        return this.i.aw;
    }
    set displayNormalRangeInFront(v) {
        this.i.aw = ensureBool(v);
    }
    /**
     * Gets or sets the marker size of the sparkline.
    */
    get markerSize() {
        return this.i.bd;
    }
    set markerSize(v) {
        this.i.bd = +v;
    }
    /**
     * Gets or sets the first marker size of the sparkline.
    */
    get firstMarkerSize() {
        return this.i.a6;
    }
    set firstMarkerSize(v) {
        this.i.a6 = +v;
    }
    /**
     * Gets or sets the last marker size of the sparkline.
    */
    get lastMarkerSize() {
        return this.i.a8;
    }
    set lastMarkerSize(v) {
        this.i.a8 = +v;
    }
    /**
     * Gets or sets the high marker size of the sparkline.
    */
    get highMarkerSize() {
        return this.i.a7;
    }
    set highMarkerSize(v) {
        this.i.a7 = +v;
    }
    /**
     * Gets or sets the low marker size of the sparkline.
    */
    get lowMarkerSize() {
        return this.i.bc;
    }
    set lowMarkerSize(v) {
        this.i.bc = +v;
    }
    /**
     * Gets or sets the negative marker size of the sparkline.
    */
    get negativeMarkerSize() {
        return this.i.bi;
    }
    set negativeMarkerSize(v) {
        this.i.bi = +v;
    }
    /**
     * Gets or sets the line thickness of the sparkline.
    */
    get lineThickness() {
        return this.i.a9;
    }
    set lineThickness(v) {
        this.i.a9 = +v;
    }
    /**
     * Gets or sets the minimum value of the y axis.
    */
    get minimum() {
        return this.i.bh;
    }
    set minimum(v) {
        this.i.bh = +v;
    }
    /**
     * Gets or sets the maximum value of the y axis.
    */
    get maximum() {
        return this.i.bg;
    }
    set maximum(v) {
        this.i.bg = +v;
    }
    /**
     * Gets or sets the string path to the value column.
    */
    get valueMemberPath() {
        return this.i.c9;
    }
    set valueMemberPath(v) {
        this.i.c9 = v;
    }
    /**
     * String identifier of a column or property name to get labels from on each item in the data source.  These labels will be retrieved from the first and last item, and displayed by the horizontal axis.
    */
    get labelMemberPath() {
        return this.i.ce;
    }
    set labelMemberPath(v) {
        this.i.ce = v;
    }
    /**
     * Gets or sets the type of trendline used by the sparkline.
    */
    get trendLineType() {
        return this.i.ar;
    }
    set trendLineType(v) {
        this.i.ar = ensureEnum(TrendLineType_$type, v);
    }
    /**
     * Gets or sets the trendline period used by the sparkline.
    */
    get trendLinePeriod() {
        return this.i.bq;
    }
    set trendLinePeriod(v) {
        this.i.bq = +v;
    }
    /**
     * Gets or sets the thickness of the sparkline's trendline.
    */
    get trendLineThickness() {
        return this.i.bm;
    }
    set trendLineThickness(v) {
        this.i.bm = +v;
    }
    /**
     * Gets or sets the minimum value of the normal range.
    */
    get normalRangeMinimum() {
        return this.i.bk;
    }
    set normalRangeMinimum(v) {
        this.i.bk = +v;
    }
    /**
     * Gets or sets the maximum value of the normal range.
    */
    get normalRangeMaximum() {
        return this.i.bj;
    }
    set normalRangeMaximum(v) {
        this.i.bj = +v;
    }
    /**
     * Gets or sets the display type of the sparkline.
    */
    get displayType() {
        return this.i.aq;
    }
    set displayType(v) {
        this.i.aq = ensureEnum(SparklineDisplayType_$type, v);
    }
    /**
     * Gets or sets the way null values are interpreted.
    */
    get unknownValuePlotting() {
        return this.i.as;
    }
    set unknownValuePlotting(v) {
        this.i.as = ensureEnum(UnknownValuePlotting_$type, v);
    }
    /**
     * The value or content to display on the vertical axis.
     * This can be set to a formatted string, such as "{0:n}", or it can be set to a DataTemplate.
    */
    get verticalAxisLabel() {
        return this.i.bt;
    }
    set verticalAxisLabel(v) {
        this.i.bt = v;
    }
    /**
     * The value or content to display on the horizontal axis.
     * This can be set to a formatted string, such as "{0}", or it can be set to a DataTemplate.
    */
    get horizontalAxisLabel() {
        return this.i.br;
    }
    set horizontalAxisLabel(v) {
        this.i.br = v;
    }
    /**
     * Sets or gets a function which takes an object that produces a formatted label for displaying in the chart.
    */
    get formatLabel() {
        return this.i.bp;
    }
    set formatLabel(v) {
        this.i.bp = v;
    }
    /**
     * Gets or sets the label composite format used when creating label values.
    */
    get horizontalLabelFormat() {
        return this.i.ca;
    }
    set horizontalLabelFormat(v) {
        this.i.ca = v;
    }
    /**
     * Gets or sets the format specifiers to use with the HorizontalLabelFormat string.
    */
    get horizontalLabelFormatSpecifiers() {
        return this.i.ag;
    }
    set horizontalLabelFormatSpecifiers(v) {
        this.i.ag = v;
    }
    /**
     * Gets or sets the label composite format used when creating label values.
    */
    get verticalLabelFormat() {
        return this.i.df;
    }
    set verticalLabelFormat(v) {
        this.i.df = v;
    }
    /**
     * Gets or sets the format specifiers to use with the VerticalLabelFormat string.
    */
    get verticalLabelFormatSpecifiers() {
        return this.i.ah;
    }
    set verticalLabelFormatSpecifiers(v) {
        this.i.ah = v;
    }
    /**
     * Gets or sets the scaling value used to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get pixelScalingRatio() {
        return this.i.bl;
    }
    set pixelScalingRatio(v) {
        this.i.bl = +v;
    }
    /**
     * Gets the actual scaling value used by the component to affect the pixel density of the control.
     * A higher scaling ratio will produce crisper visuals at the expense of memory.  Lower values will cause the control
     * to appear blurry.
    */
    get actualPixelScalingRatio() {
        return this.i.a5;
    }
    set actualPixelScalingRatio(v) {
        this.i.a5 = +v;
    }
    findByName(name) {
        if (this.horizontalLabelFormatSpecifiers != null && arrayFindByName(this.horizontalLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.horizontalLabelFormatSpecifiers, name);
        }
        if (this.verticalLabelFormatSpecifiers != null && arrayFindByName(this.verticalLabelFormatSpecifiers, name)) {
            return arrayFindByName(this.verticalLabelFormatSpecifiers, name);
        }
        return null;
    }
    get hasUserValues() {
        return this._hasUserValues;
    }
    __m(propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    }
    _styling(container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        let genericPrefix = "";
        let typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("SparklineComponent");
        let additionalPrefixes = [];
        let prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        let b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            let basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            let parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            let parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    }
    /**
 * Provides a container to the sparkline control.

* @param container  * The container.
*/
    provideContainer(container) {
        this.i.provideContainer(container);
    }
    /**
     * Notify that the control has resized.
    
    */
    notifyResized() {
        this.i.notifyResized();
    }
    notifySetItem(source_, index, oldItem, newItem) {
        this.i.dn(source_, index, oldItem, newItem);
    }
    /**
     * Used to manually notify the IgxSparklineComponent that the data source has reset or cleared its items.  Invoking this method is only necessary if that datasource is not observable.
    
    * @param source_  * The data source which was cleared or reset.
    */
    notifyClearItems(source_) {
        this.i.dj(source_);
    }
    notifyInsertItem(source_, index, newItem) {
        this.i.dk(source_, index, newItem);
    }
    notifyRemoveItem(source_, index, oldItem) {
        this.i.dl(source_, index, oldItem);
    }
    /**
     * Returns the sparkline visuals expressed as a SparklineVisualData object.
    
    */
    exportVisualData() {
        let iv = this.i.au();
        return (iv);
    }
    /**
     * Returns visuals as a serialized string.
    
    */
    exportSerializedVisualData() {
        let iv = this.i.by();
        return (iv);
    }
};
__decorate([
    ViewChild("dynamicContent", { read: ViewContainerRef, static: true }),
    __metadata("design:type", ViewContainerRef)
], IgxSparklineComponent.prototype, "_dynamicContent", void 0);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "height", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "width", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSparklineComponent.prototype, "dataSource", null);
__decorate([
    Input(),
    __metadata("design:type", TemplateRef),
    __metadata("design:paramtypes", [TemplateRef])
], IgxSparklineComponent.prototype, "tooltipTemplate", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "brush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "negativeBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "markerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "negativeMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "firstMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "lastMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "highMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "lowMarkerBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "trendLineBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "horizontalAxisBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "verticalAxisBrush", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "normalRangeFill", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "horizontalAxisVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "verticalAxisVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "markerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "negativeMarkerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "firstMarkerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "lastMarkerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "lowMarkerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "highMarkerVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "normalRangeVisibility", null);
__decorate([
    Input(),
    __metadata("design:type", Boolean),
    __metadata("design:paramtypes", [Boolean])
], IgxSparklineComponent.prototype, "displayNormalRangeInFront", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "markerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "firstMarkerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "lastMarkerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "highMarkerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "lowMarkerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "negativeMarkerSize", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "lineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "minimum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "maximum", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "valueMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "labelMemberPath", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "trendLineType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "trendLinePeriod", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "trendLineThickness", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "normalRangeMinimum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "normalRangeMaximum", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "displayType", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "unknownValuePlotting", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSparklineComponent.prototype, "verticalAxisLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Object),
    __metadata("design:paramtypes", [Object])
], IgxSparklineComponent.prototype, "horizontalAxisLabel", null);
__decorate([
    Input(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function])
], IgxSparklineComponent.prototype, "formatLabel", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "horizontalLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxSparklineComponent.prototype, "horizontalLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", String),
    __metadata("design:paramtypes", [String])
], IgxSparklineComponent.prototype, "verticalLabelFormat", null);
__decorate([
    Input(),
    __metadata("design:type", Array),
    __metadata("design:paramtypes", [Array])
], IgxSparklineComponent.prototype, "verticalLabelFormatSpecifiers", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "pixelScalingRatio", null);
__decorate([
    Input(),
    __metadata("design:type", Number),
    __metadata("design:paramtypes", [Number])
], IgxSparklineComponent.prototype, "actualPixelScalingRatio", null);
IgxSparklineComponent = __decorate([
    Component({
        selector: 'igx-sparkline',
        template: `<ng-container #dynamicContent></ng-container>`,
        changeDetection: ChangeDetectionStrategy.OnPush,
        providers: IgxSparklineComponent_PROVIDERS,
        host: { 'class': 'ig-sparkline igx-sparkline' },
        styles: [`
		:host {
			display: block;
		}
	`]
    }),
    __metadata("design:paramtypes", [Renderer2,
        ViewContainerRef,
        NgZone,
        ComponentFactoryResolver,
        Injector])
], IgxSparklineComponent);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSparklineCoreModule = class IgxSparklineCoreModule {
    constructor() {
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxSparklineCoreModule = __decorate([
    NgModule({
        declarations: [IgxSparklineComponent],
        exports: [IgxSparklineComponent,
            IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierModule,
            IgxDateTimeFormatSpecifierModule
        ],
        entryComponents: []
    }),
    __metadata("design:paramtypes", [])
], IgxSparklineCoreModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSparklineCoreDynamicModule = class IgxSparklineCoreDynamicModule {
    constructor() {
        TypeRegistrar.registerCons('IgxSparklineComponent', IgxSparklineComponent);
        TypeRegistrar.register('FastItemObjectColumn', FastItemObjectColumn.$type);
    }
};
IgxSparklineCoreDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxSparklineCoreModule
        ],
        imports: [CommonModule, IgxNumberFormatSpecifierDynamicModule,
            IgxDateTimeFormatSpecifierDynamicModule,
            IgxSparklineCoreModule
        ],
        entryComponents: [IgxSparklineComponent]
    }),
    __metadata("design:paramtypes", [])
], IgxSparklineCoreDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSparklineModule = class IgxSparklineModule {
};
IgxSparklineModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxSparklineCoreModule,
            IgxDataChartInteractivityModule
        ],
        imports: [CommonModule, IgxSparklineCoreModule,
            IgxDataChartInteractivityModule
        ],
        entryComponents: []
    })
], IgxSparklineModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
let IgxSparklineDynamicModule = class IgxSparklineDynamicModule {
};
IgxSparklineDynamicModule = __decorate([
    NgModule({
        declarations: [],
        exports: [IgxSparklineCoreDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxSparklineModule
        ],
        imports: [CommonModule, IgxSparklineCoreDynamicModule,
            IgxDataChartInteractivityDynamicModule,
            IgxSparklineModule
        ],
        entryComponents: []
    })
], IgxSparklineDynamicModule);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let SparkLayerType_$type = markEnum('SparkLayerType', 'SparkLayer,1|MarkerLayer,2|ToolTipLayer,4|RangeLayer,8|TrendLayer,16');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
class MessageHandler_Spark extends Base {
    constructor() {
        super(...arguments);
        this.a = DictionaryUtil.dictionaryCreate();
    }
    addHandler(a, b) {
        this.a.set(a.typeName, b);
    }
    messageReceived(a) {
        let b;
        let c = getInstanceType(a).typeName;
        if (this.a.has(c)) {
            b = this.a.get(c);
            b(a);
        }
    }
}
MessageHandler_Spark.$t = markType(MessageHandler_Spark, 'MessageHandler_Spark');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderCursor_$type = markEnum('ZoomSliderCursor', 'Default,0|LeftRight,1|UpDown,2|Move,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let TrackShadeOrientation_$type = markEnum('TrackShadeOrientation', 'HorizontalLower,0|HorizontalHigher,1|VerticalLower,2|VerticalHigher,3');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
let ZoomSliderVisualArea_$type = markEnum('ZoomSliderVisualArea', 'LowerThumb,0|HigherThumb,1|LowerShade,2|HigherShade,3|RangeThumb,4|Bar,5|None,6');

/**
 * Generated bundle index. Do not edit.
 */

export { AbsoluteVolumeOscillatorIndicator, AbsoluteVolumeOscillatorIndicatorStrategy, AccumulationDistributionIndicator, AccumulationDistributionIndicatorStrategy, ActualRange, AnchoredCategoryBucketCalculator, AnchoredCategorySeries, AnchoredCategorySeriesInteractionManager, AnchoredCategorySeriesView, AnchoredRadialBucketCalculator, AnchoredRadialSeries, AnchoredRadialSeriesView, AngleAxisLabelPanel, AngleAxisLabelPanelView, AngleRadiusPair, AnnotationFactoryManager, AnnotationInfoProvider, AnnotationLayer, AnnotationLayerProxy, AnnotationLayerView, Arc, ArcItem, ArcView, ArcVisualData, ArcVisualDataList, AreaFragment, AreaFragmentBucketCalculator, AreaFragmentView, AreaInfo, AreaSeries, AreaSeriesView, AssigningCategoryMarkerStyleEventArgs, AssigningCategoryStyleEventArgs, AssigningCategoryStyleEventArgsBase, AutoRangeCalculator, AverageDirectionalIndexIndicator, AverageDirectionalIndexIndicatorStrategy, AverageTrueRangeIndicator, AverageTrueRangeIndicatorStrategy, Axis, AxisAnnotation, AxisAnnotationFrame, AxisAnnotationFrameManager, AxisAnnotationManager, AxisCollection, AxisComponentsForView, AxisComponentsFromView, AxisExtentType, AxisExtentType_$type, AxisLabelInfo, AxisLabelManager, AxisLabelPanelBase, AxisLabelPanelBaseView, AxisLabelSettings, AxisLabelVisualData, AxisLabelVisualDataList, AxisLabelsLocation, AxisLabelsLocation_$type, AxisOrientation, AxisOrientation_$type, AxisRange, AxisRangeChangedEventArgs, AxisRenderMessage_Spark, AxisRendererBase, AxisRenderingParametersBase, AxisTitlePosition, AxisTitlePosition_$type, AxisView, AxisVisualData, AxisVisualDataList, AxisVisualDataManager, BarBucketCalculator, BarFragment, BarFramePreparer, BarSeries, BarSeriesView, BarTrendFitCalculator, BarTrendLineManager, BollingerBandWidthIndicator, BollingerBandWidthIndicatorStrategy, BollingerBandsBucketCalculator, BollingerBandsOverlay, BollingerBandsOverlayView, BrushChangedMessage_Spark, BrushScale, BrushSelectionMode, BrushSelectionMode_$type, BubbleMarkerManager, BubbleSeries, BubbleSeriesView, CalculatedColumn, CalloutAnnotation, CalloutAnnotationCollection, CalloutAnnotationWrapper, CalloutCollisionMode, CalloutCollisionMode_$type, CalloutContentUpdatingEventArgs, CalloutKey, CalloutLabelUpdatingEventArgs, CalloutLayer, CalloutLayerFrame, CalloutLayerView, CalloutSeriesSelectingEventArgs, CalloutStyleUpdatingEventArgs, CalloutView, CalloutViewHelper, CalloutVisualData, CalloutVisualDataList, CategoryAngleAxis, CategoryAngleAxisView, CategoryAxisBase, CategoryAxisBaseView, CategoryAxisRenderer, CategoryAxisRenderingParameters, CategoryBucketCalculator, CategoryChart, CategoryChartType, CategoryChartType_$type, CategoryDateTimeXAxis, CategoryDateTimeXAxisView, CategoryErrorBarSettings, CategoryFrame, CategoryFramePreparer, CategoryFramePreparerBase, CategoryHighlightFrameRect, CategoryHighlightLayer, CategoryHighlightLayerFrame, CategoryHighlightLayerView, CategoryItemHighlightLayer, CategoryItemHighlightLayerFrame, CategoryItemHighlightLayerView, CategoryItemHighlightType, CategoryItemHighlightType_$type, CategoryLineRasterizer, CategoryMarkerManager, CategoryMode_$type, CategorySeries, CategorySeriesInteractionManager, CategorySeriesMarkerCollisionAvoidance, CategorySeriesMarkerCollisionAvoidance_$type, CategorySeriesRenderManager, CategorySeriesView, CategoryTickmarkValues, CategoryToolTipCollisionInfo, CategoryToolTipLayer, CategoryToolTipLayerFrame, CategoryToolTipLayerView, CategoryTooltipLayerPosition, CategoryTooltipLayerPosition_$type, CategoryTooltipSeriesInfo, CategoryTransitionInMode, CategoryTransitionInMode_$type, CategoryTransitionSourceFramePreparer, CategoryTrendLineManager, CategoryTrendLineManagerBase, CategoryTrendLineManagerFactory, CategoryXAxis, CategoryXAxisView, CategoryYAxis, CategoryYAxisView, ChaikinOscillatorIndicator, ChaikinOscillatorIndicatorStrategy, ChaikinVolatilityIndicator, ChaikinVolatilityIndicatorStrategy, ChartAxisRangeChangedEventArgs, ChartCollection, ChartContentManager, ChartContentType_$type, ChartCursorEventArgs, ChartHitTestMode, ChartHitTestMode_$type, ChartMouseEventArgs, ChartSeriesEventArgs, ChartTitleVisualData, ChartTitleVisualDataList, ChartVisualData, ClearMessage_Spark, CoercionInfo, CollisionAvoidanceType, CollisionAvoidanceType_$type, CollisionAvoider, ColorScale, ColorScaleInterpolationMode, ColorScaleInterpolationMode_$type, ColumnFragment, ColumnFragmentView, ColumnMessage_Spark, ColumnSeries, ColumnSeriesView, ColumnSupportingCalculation, CommodityChannelIndexIndicator, CommodityChannelIndexIndicatorStrategy, ConfigurationMessage_Spark, ConsolidatedItemHitTestBehavior, ConsolidatedItemHitTestBehavior_$type, ConsolidatedItemsPosition, ConsolidatedItemsPosition_$type, ContainerMessage_Spark, ContainerResizedMessage_Spark, ContainerSizeChangedMessage_Spark, ContentInfo, ContourBuilder, ContourValueResolver, CrosshairLayer, CrosshairLayerFrame, CrosshairLayerView, CrosshairsDisplayMode, CrosshairsDisplayMode_$type, CustomContourValueResolver, CustomContourValueResolverEventArgs, CustomIndicator, CustomIndicatorNameCollection, CustomIndicatorStrategy, CustomPaletteBrushScale, CustomPaletteColorScale, DataChangedMessage_Spark, DataChartMouseButtonEventArgs, DataChartStylingDefaults, DataChartVisualDataManager, DataSourceManager, DataSourceSupportingCalculation, DefaultCategoryTrendlineHost, DefaultCategoryTrendlinePreparer, DefaultFlattener, DefaultHighLowValueProvider, DefaultPaletteInfo, DefaultProvidesViewport, DefaultSingleValueProvider, DefaultSupportsErrorBars, DefaultSupportsMarkers, DefaultTrackBarVisual, DefaultTrackRangeVisual, DefaultTrackShadeVisual, DefaultTrackThumbCalloutVisual, DefaultTrackThumbVisual, DelegateClipper, DetrendedPriceOscillatorIndicator, DetrendedPriceOscillatorIndicatorStrategy, DictInterpolator$3, DomainChart, DomainChartSeriesPointerEventArgs, DoughnutChartLabelVisualData, DoughnutChartVisualData, EaseOfMovementIndicator, EaseOfMovementIndicatorStrategy, EnableErrorBars, EnableErrorBars_$type, ErrorBarSettingsBase, ErrorBarsHelper, FastHorizontalLinearScaler, FastStochasticOscillatorIndicator, FastStochasticOscillatorIndicatorStrategy, FastVerticalLinearScaler, FinalValueLayer, FinalValueLayerFrame, FinalValueLayerView, FinalValueSelectionMode, FinalValueSelectionMode_$type, FinancialBucketCalculator, FinancialCalculationDataSource, FinancialCalculationSupportingCalculations, FinancialChart, FinancialChartContext, FinancialChartCustomIndicatorArgs, FinancialChartDropDownControl, FinancialChartDropDownControlView, FinancialChartDropDownControlViewModel, FinancialChartEnumCollectionPickerVisualData, FinancialChartEnumPickerVisualData, FinancialChartIndicatorMenu, FinancialChartIndicatorMenuContext, FinancialChartIndicatorMenuItem, FinancialChartIndicatorMenuItems, FinancialChartIndicatorMenuView, FinancialChartIndicatorMenuViewModel, FinancialChartRangeSelector, FinancialChartRangeSelectorContext, FinancialChartRangeSelectorOption, FinancialChartRangeSelectorOptionCollection, FinancialChartRangeSelectorOption_$type, FinancialChartRangeSelectorView, FinancialChartRangeSelectorViewModel, FinancialChartRangeSelectorVisualData, FinancialChartToolbar, FinancialChartToolbarContext, FinancialChartToolbarViewModel, FinancialChartToolbarVisualData, FinancialChartType, FinancialChartTypePicker, FinancialChartTypePickerContext, FinancialChartTypePickerView, FinancialChartTypePickerViewModel, FinancialChartType_$type, FinancialChartViewModel, FinancialChartVisualData, FinancialChartVolumeType, FinancialChartVolumeType_$type, FinancialChartXAxisMode, FinancialChartXAxisMode_$type, FinancialChartYAxisMode, FinancialChartYAxisMode_$type, FinancialChartZoomSliderType, FinancialChartZoomSliderType_$type, FinancialEventArgs, FinancialIndicator, FinancialIndicatorBucketCalculator, FinancialIndicatorType, FinancialIndicatorTypeCollection, FinancialIndicatorType_$type, FinancialIndicatorView, FinancialLegend, FinancialLegendView, FinancialLegendViewManager, FinancialOverlay, FinancialOverlayType, FinancialOverlayTypeCollection, FinancialOverlayType_$type, FinancialPriceBucketCalculator, FinancialPriceSeries, FinancialPriceSeriesProxy, FinancialPriceSeriesView, FinancialSeries, FinancialSeriesView, FinancialValueList, FlattenedShape, ForceIndexIndicator, ForceIndexIndicatorStrategy, FragmentBase, Frame, FrameExtended, FramePreparer, FullStochasticOscillatorIndicator, FullStochasticOscillatorIndicatorStrategy, GradientData, GradientStopData, GridMode, GridMode_$type, HierarchicalRingSeries, HighDensityScatterSeries, HighDensityScatterSeriesView, HighLowValuesHolder, HighlightingInfo, HighlightingManager, HighlightingMode, HighlightingMode_$type, HighlightingState, HighlightingState_$type, HoleDimensionsChangedEventArgs, HorizontalAnchoredCategorySeries, HorizontalAnchoredCategorySeriesInteractionManager, HorizontalAnchoredCategorySeriesProxy, HorizontalAxisLabelPanel, HorizontalAxisLabelPanelBase, HorizontalAxisLabelPanelBaseView, HorizontalAxisView, HorizontalLinearScaler, HorizontalLogarithmicScaler, HorizontalRangeCategorySeries, HorizontalRangeCategorySeriesProxy, HorizontalStackedSeriesBase, IAnchoredCategorySeriesInteractionManager_$type, IAngleScaler_$type, IAnnotationInfoProvider_$type, IAnnotationLayerProxy_$type, IAxisAnnotationManager_$type, IAxisAnnotation_$type, IAxisVisualDataManager_$type, IBarSeries_$type, IBucketizer_$type, ICategoryScaler_$type, ICategorySeriesInteractionManager_$type, IDataChartVisualDataManager_$type, IDateTimeAxis_$type, IDetectsCollisions_$type, IDomainChartWidget_$type, IFinancialPriceSeriesProxy_$type, IFlattener_$type, IHasCategoryAxis_$type, IHasCategoryModePreference_$type, IHasCategoryTrendline_$type, IHasHighLowValueCategory_$type, IHasSingleValueCategory_$type, IHasTrendline_$type, IHighlightingManager_$type, IHorizontalAnchoredCategorySeriesInteractionManager_$type, IHorizontalAnchoredCategorySeriesProxy_$type, IHorizontalRangeCategorySeriesProxy_$type, IIndicatorProxy_$type, IIsCategoryBased_$type, INumberAbbreviator_$type, IOverlayProxy_$type, IPolarRadialRenderingParameters_$type, IPreparesCategoryTrendline_$type, IProvidesViewport_$type, IScaler_$type, ISeriesInteractionManager_$type, ISeriesViewerInteractionManager_$type, ISeriesViewerWidgetOptions_$type, ISeriesViewerWidget_$type, ISeriesVisualDataManager_$type, IShortPeriodLongPeriod_$type, ISortingAxis_$type, IStacked100Series_$type, ISupportsErrorBars_$type, ISupportsFillScale_$type, ISupportsMarkers_$type, ISupportsSizeScale_$type, ITileZoomTileInfo_$type, ITileZoomTile_$type, ITimeRangeSelectorAxis_$type, ITimeXAxis_$type, ITrackBarVisual_$type, ITrackOwner_$type, ITrackRangeVisual_$type, ITrackShadeVisual_$type, ITrackThumbCalloutVisual_$type, ITrackThumbVisual_$type, ITrendLineManager_$type, ITrendLineSeries_$type, IVerticalAnchoredCategorySeriesInteractionManager_$type, IgQueue$1, IgxAbsoluteVolumeOscillatorIndicatorComponent, IgxAbsoluteVolumeOscillatorIndicatorComponent_PROVIDERS, IgxAbsoluteVolumeOscillatorIndicatorDynamicModule, IgxAbsoluteVolumeOscillatorIndicatorModule, IgxAccumulationDistributionIndicatorComponent, IgxAccumulationDistributionIndicatorComponent_PROVIDERS, IgxAccumulationDistributionIndicatorDynamicModule, IgxAccumulationDistributionIndicatorModule, IgxAnchoredCategorySeriesComponent, IgxAnchoredCategorySeriesComponent_PROVIDERS, IgxAnchoredRadialSeriesComponent, IgxAnchoredRadialSeriesComponent_PROVIDERS, IgxAnnotationLayerComponent, IgxAnnotationLayerComponent_PROVIDERS, IgxAnnotationLayerProxyDynamicModule, IgxAnnotationLayerProxyModule, IgxAreaFragmentComponent, IgxAreaFragmentComponent_PROVIDERS, IgxAreaFragmentDynamicModule, IgxAreaFragmentModule, IgxAreaSeriesComponent, IgxAreaSeriesComponent_PROVIDERS, IgxAreaSeriesDynamicModule, IgxAreaSeriesModule, IgxAssigningCategoryMarkerStyleEventArgs, IgxAssigningCategoryStyleEventArgs, IgxAssigningCategoryStyleEventArgsBase, IgxAverageDirectionalIndexIndicatorComponent, IgxAverageDirectionalIndexIndicatorComponent_PROVIDERS, IgxAverageDirectionalIndexIndicatorDynamicModule, IgxAverageDirectionalIndexIndicatorModule, IgxAverageTrueRangeIndicatorComponent, IgxAverageTrueRangeIndicatorComponent_PROVIDERS, IgxAverageTrueRangeIndicatorDynamicModule, IgxAverageTrueRangeIndicatorModule, IgxAxisAnnotation, IgxAxisAnnotationCollection, IgxAxisCollection, IgxAxisComponent, IgxAxisComponent_PROVIDERS, IgxAxisRangeChangedEventArgs, IgxBarFragmentComponent, IgxBarFragmentComponent_PROVIDERS, IgxBarFragmentDynamicModule, IgxBarFragmentModule, IgxBarSeriesComponent, IgxBarSeriesComponent_PROVIDERS, IgxBarSeriesDynamicModule, IgxBarSeriesModule, IgxBollingerBandWidthIndicatorComponent, IgxBollingerBandWidthIndicatorComponent_PROVIDERS, IgxBollingerBandWidthIndicatorDynamicModule, IgxBollingerBandWidthIndicatorModule, IgxBollingerBandsOverlayComponent, IgxBollingerBandsOverlayComponent_PROVIDERS, IgxBollingerBandsOverlayDynamicModule, IgxBollingerBandsOverlayModule, IgxBrushScaleComponent, IgxBrushScaleComponent_PROVIDERS, IgxBrushScaleDynamicModule, IgxBrushScaleModule, IgxBubbleSeriesComponent, IgxBubbleSeriesComponent_PROVIDERS, IgxBubbleSeriesDynamicModule, IgxBubbleSeriesModule, IgxCalculatedColumn, IgxCalloutAnnotation, IgxCalloutAnnotationCollection, IgxCalloutContentUpdatingEventArgs, IgxCalloutLabelUpdatingEventArgs, IgxCalloutLayerComponent, IgxCalloutLayerComponent_PROVIDERS, IgxCalloutLayerDynamicModule, IgxCalloutLayerModule, IgxCalloutSeriesSelectingEventArgs, IgxCalloutStyleUpdatingEventArgs, IgxCategoryAngleAxisComponent, IgxCategoryAngleAxisComponent_PROVIDERS, IgxCategoryAngleAxisDynamicModule, IgxCategoryAngleAxisModule, IgxCategoryAxisBaseComponent, IgxCategoryAxisBaseComponent_PROVIDERS, IgxCategoryChartComponent, IgxCategoryChartComponent_PROVIDERS, IgxCategoryChartCoreDynamicModule, IgxCategoryChartCoreModule, IgxCategoryChartDynamicModule, IgxCategoryChartModule, IgxCategoryDateTimeXAxisComponent, IgxCategoryDateTimeXAxisComponent_PROVIDERS, IgxCategoryDateTimeXAxisDynamicModule, IgxCategoryDateTimeXAxisModule, IgxCategoryHighlightLayerComponent, IgxCategoryHighlightLayerComponent_PROVIDERS, IgxCategoryHighlightLayerDynamicModule, IgxCategoryHighlightLayerModule, IgxCategoryItemHighlightLayerComponent, IgxCategoryItemHighlightLayerComponent_PROVIDERS, IgxCategoryItemHighlightLayerDynamicModule, IgxCategoryItemHighlightLayerModule, IgxCategorySeriesComponent, IgxCategorySeriesComponent_PROVIDERS, IgxCategoryToolTipLayerComponent, IgxCategoryToolTipLayerComponent_PROVIDERS, IgxCategoryToolTipLayerDynamicModule, IgxCategoryToolTipLayerModule, IgxCategoryXAxisComponent, IgxCategoryXAxisComponent_PROVIDERS, IgxCategoryXAxisDynamicModule, IgxCategoryXAxisModule, IgxCategoryYAxisComponent, IgxCategoryYAxisComponent_PROVIDERS, IgxCategoryYAxisDynamicModule, IgxCategoryYAxisModule, IgxChaikinOscillatorIndicatorComponent, IgxChaikinOscillatorIndicatorComponent_PROVIDERS, IgxChaikinOscillatorIndicatorDynamicModule, IgxChaikinOscillatorIndicatorModule, IgxChaikinVolatilityIndicatorComponent, IgxChaikinVolatilityIndicatorComponent_PROVIDERS, IgxChaikinVolatilityIndicatorDynamicModule, IgxChaikinVolatilityIndicatorModule, IgxChartCursorEventArgs, IgxChartMouseEventArgs, IgxChartSeriesEventArgs, IgxColorScaleComponent, IgxColorScaleComponent_PROVIDERS, IgxColumnFragmentComponent, IgxColumnFragmentComponent_PROVIDERS, IgxColumnFragmentDynamicModule, IgxColumnFragmentModule, IgxColumnSeriesComponent, IgxColumnSeriesComponent_PROVIDERS, IgxColumnSeriesDynamicModule, IgxColumnSeriesModule, IgxColumnSupportingCalculation, IgxCommodityChannelIndexIndicatorComponent, IgxCommodityChannelIndexIndicatorComponent_PROVIDERS, IgxCommodityChannelIndexIndicatorDynamicModule, IgxCommodityChannelIndexIndicatorModule, IgxContourValueResolverComponent, IgxContourValueResolverComponent_PROVIDERS, IgxCrosshairLayerComponent, IgxCrosshairLayerComponent_PROVIDERS, IgxCrosshairLayerDynamicModule, IgxCrosshairLayerModule, IgxCustomContourValueResolverComponent, IgxCustomContourValueResolverComponent_PROVIDERS, IgxCustomContourValueResolverDynamicModule, IgxCustomContourValueResolverEventArgs, IgxCustomContourValueResolverModule, IgxCustomIndicatorComponent, IgxCustomIndicatorComponent_PROVIDERS, IgxCustomIndicatorDynamicModule, IgxCustomIndicatorModule, IgxCustomIndicatorNameCollection, IgxCustomPaletteBrushScaleComponent, IgxCustomPaletteBrushScaleComponent_PROVIDERS, IgxCustomPaletteBrushScaleDynamicModule, IgxCustomPaletteBrushScaleModule, IgxCustomPaletteColorScaleComponent, IgxCustomPaletteColorScaleComponent_PROVIDERS, IgxCustomPaletteColorScaleDynamicModule, IgxCustomPaletteColorScaleModule, IgxDataChartAnnotationDynamicModule, IgxDataChartAnnotationModule, IgxDataChartCategoryCoreDynamicModule, IgxDataChartCategoryCoreModule, IgxDataChartCategoryDynamicModule, IgxDataChartCategoryModule, IgxDataChartCategoryTrendLineDynamicModule, IgxDataChartCategoryTrendLineModule, IgxDataChartComponent, IgxDataChartComponent_PROVIDERS, IgxDataChartCoreDynamicModule, IgxDataChartCoreModule, IgxDataChartDefaultTooltipsComponent, IgxDataChartExtendedAxesDynamicModule, IgxDataChartExtendedAxesModule, IgxDataChartFinancialCoreDynamicModule, IgxDataChartFinancialCoreModule, IgxDataChartFinancialDynamicModule, IgxDataChartFinancialIndicatorsDynamicModule, IgxDataChartFinancialIndicatorsModule, IgxDataChartFinancialModule, IgxDataChartFinancialOverlaysDynamicModule, IgxDataChartFinancialOverlaysModule, IgxDataChartInteractivityDynamicModule, IgxDataChartInteractivityModule, IgxDataChartMouseButtonEventArgs, IgxDataChartPolarCoreDynamicModule, IgxDataChartPolarCoreModule, IgxDataChartPolarDynamicModule, IgxDataChartPolarModule, IgxDataChartRadialCoreDynamicModule, IgxDataChartRadialCoreModule, IgxDataChartRadialDynamicModule, IgxDataChartRadialModule, IgxDataChartScatterCoreDynamicModule, IgxDataChartScatterCoreModule, IgxDataChartScatterDynamicModule, IgxDataChartScatterModule, IgxDataChartShapeCoreDynamicModule, IgxDataChartShapeCoreModule, IgxDataChartShapeDynamicModule, IgxDataChartShapeModule, IgxDataChartStackedDynamicModule, IgxDataChartStackedModule, IgxDataChartVerticalCategoryCoreDynamicModule, IgxDataChartVerticalCategoryCoreModule, IgxDataChartVerticalCategoryDynamicModule, IgxDataChartVerticalCategoryModule, IgxDataChartVisualDataDynamicModule, IgxDataChartVisualDataModule, IgxDataSourceSupportingCalculation, IgxDetrendedPriceOscillatorIndicatorComponent, IgxDetrendedPriceOscillatorIndicatorComponent_PROVIDERS, IgxDetrendedPriceOscillatorIndicatorDynamicModule, IgxDetrendedPriceOscillatorIndicatorModule, IgxDomainChartComponent, IgxDomainChartComponent_PROVIDERS, IgxDomainChartSeriesPointerEventArgs, IgxDoughnutChartComponent, IgxDoughnutChartComponent_PROVIDERS, IgxDoughnutChartCoreDynamicModule, IgxDoughnutChartCoreModule, IgxDoughnutChartDefaultTooltipsComponent, IgxDoughnutChartDynamicModule, IgxDoughnutChartInteractivityDynamicModule, IgxDoughnutChartInteractivityModule, IgxDoughnutChartModule, IgxEaseOfMovementIndicatorComponent, IgxEaseOfMovementIndicatorComponent_PROVIDERS, IgxEaseOfMovementIndicatorDynamicModule, IgxEaseOfMovementIndicatorModule, IgxFastStochasticOscillatorIndicatorComponent, IgxFastStochasticOscillatorIndicatorComponent_PROVIDERS, IgxFastStochasticOscillatorIndicatorDynamicModule, IgxFastStochasticOscillatorIndicatorModule, IgxFinalValueLayerComponent, IgxFinalValueLayerComponent_PROVIDERS, IgxFinalValueLayerDynamicModule, IgxFinalValueLayerModule, IgxFinancialCalculationDataSource, IgxFinancialCalculationSupportingCalculations, IgxFinancialChartComponent, IgxFinancialChartComponent_PROVIDERS, IgxFinancialChartCoreDynamicModule, IgxFinancialChartCoreModule, IgxFinancialChartCustomIndicatorArgs, IgxFinancialChartDefaultTemplatesComponent, IgxFinancialChartDynamicModule, IgxFinancialChartModule, IgxFinancialChartRangeSelectorOptionCollection, IgxFinancialEventArgs, IgxFinancialIndicatorComponent, IgxFinancialIndicatorComponent_PROVIDERS, IgxFinancialIndicatorTypeCollection, IgxFinancialLegendComponent, IgxFinancialLegendComponent_PROVIDERS, IgxFinancialLegendDynamicModule, IgxFinancialLegendModule, IgxFinancialOverlayComponent, IgxFinancialOverlayComponent_PROVIDERS, IgxFinancialOverlayTypeCollection, IgxFinancialPriceSeriesComponent, IgxFinancialPriceSeriesComponent_PROVIDERS, IgxFinancialPriceSeriesDynamicModule, IgxFinancialPriceSeriesModule, IgxFinancialPriceSeriesProxyDynamicModule, IgxFinancialPriceSeriesProxyModule, IgxFinancialSeriesComponent, IgxFinancialSeriesComponent_PROVIDERS, IgxForceIndexIndicatorComponent, IgxForceIndexIndicatorComponent_PROVIDERS, IgxForceIndexIndicatorDynamicModule, IgxForceIndexIndicatorModule, IgxFragmentBaseComponent, IgxFragmentBaseComponent_PROVIDERS, IgxFullStochasticOscillatorIndicatorComponent, IgxFullStochasticOscillatorIndicatorComponent_PROVIDERS, IgxFullStochasticOscillatorIndicatorDynamicModule, IgxFullStochasticOscillatorIndicatorModule, IgxHierarchicalRingSeriesComponent, IgxHierarchicalRingSeriesComponent_PROVIDERS, IgxHierarchicalRingSeriesDynamicModule, IgxHierarchicalRingSeriesModule, IgxHighDensityScatterSeriesComponent, IgxHighDensityScatterSeriesComponent_PROVIDERS, IgxHighDensityScatterSeriesDynamicModule, IgxHighDensityScatterSeriesModule, IgxHighlightingInfo, IgxHoleDimensionsChangedEventArgs, IgxHorizontalAnchoredCategorySeriesComponent, IgxHorizontalAnchoredCategorySeriesComponent_PROVIDERS, IgxHorizontalAnchoredCategorySeriesProxyDynamicModule, IgxHorizontalAnchoredCategorySeriesProxyModule, IgxHorizontalRangeCategorySeriesComponent, IgxHorizontalRangeCategorySeriesComponent_PROVIDERS, IgxHorizontalRangeCategorySeriesProxyDynamicModule, IgxHorizontalRangeCategorySeriesProxyModule, IgxHorizontalStackedSeriesBaseComponent, IgxHorizontalStackedSeriesBaseComponent_PROVIDERS, IgxIndexCollection, IgxIndicatorDisplayTypeCollection, IgxIndicatorProxyDynamicModule, IgxIndicatorProxyModule, IgxIndicatorsDynamicModule, IgxIndicatorsModule, IgxItemLegendComponent, IgxItemLegendComponent_PROVIDERS, IgxItemLegendDynamicModule, IgxItemLegendModule, IgxItemToolTipLayerComponent, IgxItemToolTipLayerComponent_PROVIDERS, IgxItemToolTipLayerDynamicModule, IgxItemToolTipLayerModule, IgxItemwiseStrategyBasedIndicatorComponent, IgxItemwiseStrategyBasedIndicatorComponent_PROVIDERS, IgxLabelClickEventArgs, IgxLegendBaseComponent, IgxLegendComponent, IgxLegendComponent_PROVIDERS, IgxLegendDynamicModule, IgxLegendModule, IgxLegendMouseButtonEventArgs, IgxLegendMouseEventArgs, IgxLineFragmentComponent, IgxLineFragmentComponent_PROVIDERS, IgxLineFragmentDynamicModule, IgxLineFragmentModule, IgxLineSeriesComponent, IgxLineSeriesComponent_PROVIDERS, IgxLineSeriesDynamicModule, IgxLineSeriesModule, IgxLinearContourValueResolverComponent, IgxLinearContourValueResolverComponent_PROVIDERS, IgxLinearContourValueResolverDynamicModule, IgxLinearContourValueResolverModule, IgxMarkerSeriesComponent, IgxMarkerSeriesComponent_PROVIDERS, IgxMarkerTypeCollection, IgxMarketFacilitationIndexIndicatorComponent, IgxMarketFacilitationIndexIndicatorComponent_PROVIDERS, IgxMarketFacilitationIndexIndicatorDynamicModule, IgxMarketFacilitationIndexIndicatorModule, IgxMassIndexIndicatorComponent, IgxMassIndexIndicatorComponent_PROVIDERS, IgxMassIndexIndicatorDynamicModule, IgxMassIndexIndicatorModule, IgxMedianPriceIndicatorComponent, IgxMedianPriceIndicatorComponent_PROVIDERS, IgxMedianPriceIndicatorDynamicModule, IgxMedianPriceIndicatorModule, IgxMoneyFlowIndexIndicatorComponent, IgxMoneyFlowIndexIndicatorComponent_PROVIDERS, IgxMoneyFlowIndexIndicatorDynamicModule, IgxMoneyFlowIndexIndicatorModule, IgxMovingAverageConvergenceDivergenceIndicatorComponent, IgxMovingAverageConvergenceDivergenceIndicatorComponent_PROVIDERS, IgxMovingAverageConvergenceDivergenceIndicatorDynamicModule, IgxMovingAverageConvergenceDivergenceIndicatorModule, IgxNegativeVolumeIndexIndicatorComponent, IgxNegativeVolumeIndexIndicatorComponent_PROVIDERS, IgxNegativeVolumeIndexIndicatorDynamicModule, IgxNegativeVolumeIndexIndicatorModule, IgxNumberAbbreviatorDynamicModule, IgxNumberAbbreviatorModule, IgxNumericAngleAxisComponent, IgxNumericAngleAxisComponent_PROVIDERS, IgxNumericAngleAxisDynamicModule, IgxNumericAngleAxisModule, IgxNumericAxisBaseComponent, IgxNumericAxisBaseComponent_PROVIDERS, IgxNumericRadiusAxisComponent, IgxNumericRadiusAxisComponent_PROVIDERS, IgxNumericRadiusAxisDynamicModule, IgxNumericRadiusAxisModule, IgxNumericXAxisComponent, IgxNumericXAxisComponent_PROVIDERS, IgxNumericXAxisDynamicModule, IgxNumericXAxisModule, IgxNumericYAxisComponent, IgxNumericYAxisComponent_PROVIDERS, IgxNumericYAxisDynamicModule, IgxNumericYAxisModule, IgxOnBalanceVolumeIndicatorComponent, IgxOnBalanceVolumeIndicatorComponent_PROVIDERS, IgxOnBalanceVolumeIndicatorDynamicModule, IgxOnBalanceVolumeIndicatorModule, IgxOrdinalTimeXAxisComponent, IgxOrdinalTimeXAxisComponent_PROVIDERS, IgxOrdinalTimeXAxisDynamicModule, IgxOrdinalTimeXAxisModule, IgxOverlayProxyDynamicModule, IgxOverlayProxyModule, IgxOverlaysDynamicModule, IgxOverlaysModule, IgxPercentChangeYAxisComponent, IgxPercentChangeYAxisComponent_PROVIDERS, IgxPercentChangeYAxisDynamicModule, IgxPercentChangeYAxisModule, IgxPercentagePriceOscillatorIndicatorComponent, IgxPercentagePriceOscillatorIndicatorComponent_PROVIDERS, IgxPercentagePriceOscillatorIndicatorDynamicModule, IgxPercentagePriceOscillatorIndicatorModule, IgxPercentageVolumeOscillatorIndicatorComponent, IgxPercentageVolumeOscillatorIndicatorComponent_PROVIDERS, IgxPercentageVolumeOscillatorIndicatorDynamicModule, IgxPercentageVolumeOscillatorIndicatorModule, IgxPieChartBaseComponent, IgxPieChartBaseComponent_PROVIDERS, IgxPieChartComponent, IgxPieChartComponent_PROVIDERS, IgxPieChartCoreDynamicModule, IgxPieChartCoreModule, IgxPieChartDynamicModule, IgxPieChartModule, IgxPieSliceDataContext, IgxPieSliceOthersContext, IgxPlotAreaMouseButtonEventArgs, IgxPlotAreaMouseEventArgs, IgxPointSeriesComponent, IgxPointSeriesComponent_PROVIDERS, IgxPointSeriesDynamicModule, IgxPointSeriesModule, IgxPolarAreaSeriesComponent, IgxPolarAreaSeriesComponent_PROVIDERS, IgxPolarAreaSeriesDynamicModule, IgxPolarAreaSeriesModule, IgxPolarBaseComponent, IgxPolarBaseComponent_PROVIDERS, IgxPolarLineSeriesBaseComponent, IgxPolarLineSeriesBaseComponent_PROVIDERS, IgxPolarLineSeriesComponent, IgxPolarLineSeriesComponent_PROVIDERS, IgxPolarLineSeriesDynamicModule, IgxPolarLineSeriesModule, IgxPolarScatterSeriesComponent, IgxPolarScatterSeriesComponent_PROVIDERS, IgxPolarScatterSeriesDynamicModule, IgxPolarScatterSeriesModule, IgxPolarSplineAreaSeriesComponent, IgxPolarSplineAreaSeriesComponent_PROVIDERS, IgxPolarSplineAreaSeriesDynamicModule, IgxPolarSplineAreaSeriesModule, IgxPolarSplineSeriesComponent, IgxPolarSplineSeriesComponent_PROVIDERS, IgxPolarSplineSeriesDynamicModule, IgxPolarSplineSeriesModule, IgxPositiveVolumeIndexIndicatorComponent, IgxPositiveVolumeIndexIndicatorComponent_PROVIDERS, IgxPositiveVolumeIndexIndicatorDynamicModule, IgxPositiveVolumeIndexIndicatorModule, IgxPriceChannelOverlayComponent, IgxPriceChannelOverlayComponent_PROVIDERS, IgxPriceChannelOverlayDynamicModule, IgxPriceChannelOverlayModule, IgxPriceVolumeTrendIndicatorComponent, IgxPriceVolumeTrendIndicatorComponent_PROVIDERS, IgxPriceVolumeTrendIndicatorDynamicModule, IgxPriceVolumeTrendIndicatorModule, IgxProgressiveLoadStatusEventArgs, IgxRadialAreaSeriesComponent, IgxRadialAreaSeriesComponent_PROVIDERS, IgxRadialAreaSeriesDynamicModule, IgxRadialAreaSeriesModule, IgxRadialBaseComponent, IgxRadialBaseComponent_PROVIDERS, IgxRadialColumnSeriesComponent, IgxRadialColumnSeriesComponent_PROVIDERS, IgxRadialColumnSeriesDynamicModule, IgxRadialColumnSeriesModule, IgxRadialLineSeriesComponent, IgxRadialLineSeriesComponent_PROVIDERS, IgxRadialLineSeriesDynamicModule, IgxRadialLineSeriesModule, IgxRadialPieSeriesComponent, IgxRadialPieSeriesComponent_PROVIDERS, IgxRadialPieSeriesDynamicModule, IgxRadialPieSeriesModule, IgxRangeAreaSeriesComponent, IgxRangeAreaSeriesComponent_PROVIDERS, IgxRangeAreaSeriesDynamicModule, IgxRangeAreaSeriesModule, IgxRangeCategorySeriesComponent, IgxRangeCategorySeriesComponent_PROVIDERS, IgxRangeColumnSeriesComponent, IgxRangeColumnSeriesComponent_PROVIDERS, IgxRangeColumnSeriesDynamicModule, IgxRangeColumnSeriesModule, IgxRateOfChangeAndMomentumIndicatorComponent, IgxRateOfChangeAndMomentumIndicatorComponent_PROVIDERS, IgxRateOfChangeAndMomentumIndicatorDynamicModule, IgxRateOfChangeAndMomentumIndicatorModule, IgxRefreshCompletedEventArgs, IgxRelativeStrengthIndexIndicatorComponent, IgxRelativeStrengthIndexIndicatorComponent_PROVIDERS, IgxRelativeStrengthIndexIndicatorDynamicModule, IgxRelativeStrengthIndexIndicatorModule, IgxRenderRequestedEventArgs, IgxRing, IgxRingSeriesBaseComponent, IgxRingSeriesBaseComponent_PROVIDERS, IgxRingSeriesCollection, IgxRingSeriesComponent, IgxRingSeriesComponent_PROVIDERS, IgxRingSeriesDynamicModule, IgxRingSeriesModule, IgxScaleLegendComponent, IgxScaleLegendComponent_PROVIDERS, IgxScaleLegendDynamicModule, IgxScaleLegendModule, IgxScalerParams, IgxScatterAreaSeriesComponent, IgxScatterAreaSeriesComponent_PROVIDERS, IgxScatterAreaSeriesDynamicModule, IgxScatterAreaSeriesModule, IgxScatterBaseComponent, IgxScatterBaseComponent_PROVIDERS, IgxScatterContourSeriesComponent, IgxScatterContourSeriesComponent_PROVIDERS, IgxScatterContourSeriesDynamicModule, IgxScatterContourSeriesModule, IgxScatterLineSeriesComponent, IgxScatterLineSeriesComponent_PROVIDERS, IgxScatterLineSeriesDynamicModule, IgxScatterLineSeriesModule, IgxScatterPolygonSeriesComponent, IgxScatterPolygonSeriesComponent_PROVIDERS, IgxScatterPolygonSeriesDynamicModule, IgxScatterPolygonSeriesModule, IgxScatterPolylineSeriesComponent, IgxScatterPolylineSeriesComponent_PROVIDERS, IgxScatterPolylineSeriesDynamicModule, IgxScatterPolylineSeriesModule, IgxScatterSeriesComponent, IgxScatterSeriesComponent_PROVIDERS, IgxScatterSeriesDynamicModule, IgxScatterSeriesModule, IgxScatterSplineSeriesComponent, IgxScatterSplineSeriesComponent_PROVIDERS, IgxScatterSplineSeriesDynamicModule, IgxScatterSplineSeriesModule, IgxScatterTriangulationSeriesComponent, IgxScatterTriangulationSeriesComponent_PROVIDERS, IgxSelectedItemChangedEventArgs, IgxSelectedItemChangingEventArgs, IgxSelectedItemsChangedEventArgs, IgxSelectedItemsChangingEventArgs, IgxSeriesCollection, IgxSeriesComponent, IgxSeriesComponent_PROVIDERS, IgxSeriesViewerComponent, IgxSeriesViewerComponent_PROVIDERS, IgxSeriesViewerManipulationEventArgs, IgxShapeSeriesBaseComponent, IgxShapeSeriesBaseComponent_PROVIDERS, IgxSizeScaleComponent, IgxSizeScaleComponent_PROVIDERS, IgxSizeScaleDynamicModule, IgxSizeScaleModule, IgxSliceClickEventArgs, IgxSlowStochasticOscillatorIndicatorComponent, IgxSlowStochasticOscillatorIndicatorComponent_PROVIDERS, IgxSlowStochasticOscillatorIndicatorDynamicModule, IgxSlowStochasticOscillatorIndicatorModule, IgxSparklineComponent, IgxSparklineComponent_PROVIDERS, IgxSparklineCoreDynamicModule, IgxSparklineCoreModule, IgxSparklineDynamicModule, IgxSparklineModule, IgxSplineAreaFragmentComponent, IgxSplineAreaFragmentComponent_PROVIDERS, IgxSplineAreaFragmentDynamicModule, IgxSplineAreaFragmentModule, IgxSplineAreaSeriesComponent, IgxSplineAreaSeriesComponent_PROVIDERS, IgxSplineAreaSeriesDynamicModule, IgxSplineAreaSeriesModule, IgxSplineFragmentBaseComponent, IgxSplineFragmentBaseComponent_PROVIDERS, IgxSplineFragmentComponent, IgxSplineFragmentComponent_PROVIDERS, IgxSplineFragmentDynamicModule, IgxSplineFragmentModule, IgxSplineSeriesBaseComponent, IgxSplineSeriesBaseComponent_PROVIDERS, IgxSplineSeriesComponent, IgxSplineSeriesComponent_PROVIDERS, IgxSplineSeriesDynamicModule, IgxSplineSeriesModule, IgxStacked100AreaSeriesComponent, IgxStacked100AreaSeriesComponent_PROVIDERS, IgxStacked100AreaSeriesDynamicModule, IgxStacked100AreaSeriesModule, IgxStacked100BarSeriesComponent, IgxStacked100BarSeriesComponent_PROVIDERS, IgxStacked100BarSeriesDynamicModule, IgxStacked100BarSeriesModule, IgxStacked100ColumnSeriesComponent, IgxStacked100ColumnSeriesComponent_PROVIDERS, IgxStacked100ColumnSeriesDynamicModule, IgxStacked100ColumnSeriesModule, IgxStacked100LineSeriesComponent, IgxStacked100LineSeriesComponent_PROVIDERS, IgxStacked100LineSeriesDynamicModule, IgxStacked100LineSeriesModule, IgxStacked100SplineAreaSeriesComponent, IgxStacked100SplineAreaSeriesComponent_PROVIDERS, IgxStacked100SplineAreaSeriesDynamicModule, IgxStacked100SplineAreaSeriesModule, IgxStacked100SplineSeriesComponent, IgxStacked100SplineSeriesComponent_PROVIDERS, IgxStacked100SplineSeriesDynamicModule, IgxStacked100SplineSeriesModule, IgxStackedAreaSeriesComponent, IgxStackedAreaSeriesComponent_PROVIDERS, IgxStackedAreaSeriesDynamicModule, IgxStackedAreaSeriesModule, IgxStackedBarSeriesComponent, IgxStackedBarSeriesComponent_PROVIDERS, IgxStackedBarSeriesDynamicModule, IgxStackedBarSeriesModule, IgxStackedColumnSeriesComponent, IgxStackedColumnSeriesComponent_PROVIDERS, IgxStackedColumnSeriesDynamicModule, IgxStackedColumnSeriesModule, IgxStackedFragmentSeriesComponent, IgxStackedFragmentSeriesComponent_PROVIDERS, IgxStackedFragmentSeriesDynamicModule, IgxStackedFragmentSeriesModule, IgxStackedLineSeriesComponent, IgxStackedLineSeriesComponent_PROVIDERS, IgxStackedLineSeriesDynamicModule, IgxStackedLineSeriesModule, IgxStackedSeriesBaseComponent, IgxStackedSeriesBaseComponent_PROVIDERS, IgxStackedSeriesCollection, IgxStackedSeriesCreatedEventArgs, IgxStackedSplineAreaSeriesComponent, IgxStackedSplineAreaSeriesComponent_PROVIDERS, IgxStackedSplineAreaSeriesDynamicModule, IgxStackedSplineAreaSeriesModule, IgxStackedSplineSeriesComponent, IgxStackedSplineSeriesComponent_PROVIDERS, IgxStackedSplineSeriesDynamicModule, IgxStackedSplineSeriesModule, IgxStandardDeviationIndicatorComponent, IgxStandardDeviationIndicatorComponent_PROVIDERS, IgxStandardDeviationIndicatorDynamicModule, IgxStandardDeviationIndicatorModule, IgxStepAreaSeriesComponent, IgxStepAreaSeriesComponent_PROVIDERS, IgxStepAreaSeriesDynamicModule, IgxStepAreaSeriesModule, IgxStepLineSeriesComponent, IgxStepLineSeriesComponent_PROVIDERS, IgxStepLineSeriesDynamicModule, IgxStepLineSeriesModule, IgxStochRSIIndicatorComponent, IgxStochRSIIndicatorComponent_PROVIDERS, IgxStochRSIIndicatorDynamicModule, IgxStochRSIIndicatorModule, IgxStraightNumericAxisBaseComponent, IgxStraightNumericAxisBaseComponent_PROVIDERS, IgxStrategyBasedIndicatorComponent, IgxStrategyBasedIndicatorComponent_PROVIDERS, IgxStyleShapeEventArgs, IgxTRIXIndicatorComponent, IgxTRIXIndicatorComponent_PROVIDERS, IgxTRIXIndicatorDynamicModule, IgxTRIXIndicatorModule, IgxTimeAxisBaseComponent, IgxTimeAxisBaseComponent_PROVIDERS, IgxTimeAxisBreakCollection, IgxTimeAxisBreakComponent, IgxTimeAxisBreakComponent_PROVIDERS, IgxTimeAxisBreakDynamicModule, IgxTimeAxisBreakModule, IgxTimeAxisIntervalCollection, IgxTimeAxisIntervalComponent, IgxTimeAxisIntervalComponent_PROVIDERS, IgxTimeAxisIntervalDynamicModule, IgxTimeAxisIntervalModule, IgxTimeAxisLabelFormatCollection, IgxTimeAxisLabelFormatComponent, IgxTimeAxisLabelFormatComponent_PROVIDERS, IgxTimeAxisLabelFormatDynamicModule, IgxTimeAxisLabelFormatModule, IgxTimeXAxisComponent, IgxTimeXAxisComponent_PROVIDERS, IgxTimeXAxisDynamicModule, IgxTimeXAxisModule, IgxTreemapComponent, IgxTreemapComponent_PROVIDERS, IgxTreemapDynamicModule, IgxTreemapModule, IgxTreemapNodePointerEventArgs, IgxTreemapNodeStyleComponent, IgxTreemapNodeStyleComponent_PROVIDERS, IgxTreemapNodeStyleDynamicModule, IgxTreemapNodeStyleMappingCollection, IgxTreemapNodeStyleMappingComponent, IgxTreemapNodeStyleMappingComponent_PROVIDERS, IgxTreemapNodeStyleMappingDynamicModule, IgxTreemapNodeStyleMappingModule, IgxTreemapNodeStyleModule, IgxTreemapNodeStylingEventArgs, IgxTypicalPriceIndicatorComponent, IgxTypicalPriceIndicatorComponent_PROVIDERS, IgxTypicalPriceIndicatorDynamicModule, IgxTypicalPriceIndicatorModule, IgxUltimateOscillatorIndicatorComponent, IgxUltimateOscillatorIndicatorComponent_PROVIDERS, IgxUltimateOscillatorIndicatorDynamicModule, IgxUltimateOscillatorIndicatorModule, IgxValueBrushScaleComponent, IgxValueBrushScaleComponent_PROVIDERS, IgxValueBrushScaleDynamicModule, IgxValueBrushScaleModule, IgxValueOverlayComponent, IgxValueOverlayComponent_PROVIDERS, IgxValueOverlayDynamicModule, IgxValueOverlayModule, IgxVerticalAnchoredCategorySeriesComponent, IgxVerticalAnchoredCategorySeriesComponent_PROVIDERS, IgxVerticalStackedSeriesBaseComponent, IgxVerticalStackedSeriesBaseComponent_PROVIDERS, IgxWaterfallSeriesComponent, IgxWaterfallSeriesComponent_PROVIDERS, IgxWaterfallSeriesDynamicModule, IgxWaterfallSeriesModule, IgxWeightedCloseIndicatorComponent, IgxWeightedCloseIndicatorComponent_PROVIDERS, IgxWeightedCloseIndicatorDynamicModule, IgxWeightedCloseIndicatorModule, IgxWilliamsPercentRIndicatorComponent, IgxWilliamsPercentRIndicatorComponent_PROVIDERS, IgxWilliamsPercentRIndicatorDynamicModule, IgxWilliamsPercentRIndicatorModule, IgxXYChartComponent, IgxXYChartComponent_PROVIDERS, IgxZoomSliderComponent, IgxZoomSliderComponent_PROVIDERS, IgxZoomSliderDynamicModule, IgxZoomSliderModule, IgxZoomSliderResolvingAxisValueEventArgs, IndexCollection, IndicatorCalculationStrategy, IndicatorDisplayType, IndicatorDisplayTypeCollection, IndicatorDisplayType_$type, IndicatorPane, IndicatorProxy, IndicatorRenderer, InteractionMessage_Spark, InteractivityFactoryManager, ItemHighlightFrameRect, ItemLegend, ItemLegendView, ItemToolTipLayer, ItemToolTipLayerView, ItemTooltipCollisionInfo, ItemTooltipLayerFrame, ItemwiseIndicatorCalculationStrategy, ItemwiseStrategyBasedIndicator, ItemwiseStrategyCalculationStrategy, KDPointData, KDTree2D, KDTreeNode2D, KDTreeThunk, KNearestResult, KNearestResults, LabelClickEventArgs, LabelFontHeuristics, LabelPanelArranger, LabelPanelsArrangeState, LabelPosition, LabelsPosition, LabelsPosition_$type, LeaderLineType, LeaderLineType_$type, Legend, LegendBase, LegendBaseView, LegendBaseViewManager, LegendItemInfo, LegendItemVisualData, LegendMouseButtonEventArgs, LegendMouseEventArgs, LegendOrientation, LegendOrientation_$type, LegendTemplates, LegendView, LegendVisualData, LegendVisualDataList, LineFragment, LineFragmentBucketCalculator, LineFragmentView, LineSeries, LineSeriesView, LinearCategorySnapper, LinearContourValueResolver, LinearNumericSnapper, LinearScaler, LinearTickmarkValues, LogarithmicNumericSnapper, LogarithmicScaler, LogarithmicTickmarkValues, Marker, MarkerManagerBase, MarkerManagerBucket, MarkerMessage_Spark, MarkerSeries, MarkerSeriesView, MarkerTemplates, MarkerType, MarkerTypeCollection, MarkerType_$type, MarkerVisualData, MarkerVisualDataList, MarketFacilitationIndexIndicator, MarketFacilitationIndexIndicatorStrategy, MassIndexIndicator, MassIndexIndicatorStrategy, MedianPriceIndicator, MedianPriceIndicatorStrategy, MessageChannel_Spark, MessageHandler_Spark, Message_Spark, MoneyFlowIndexIndicator, MoneyFlowIndexIndicatorStrategy, MouseLeaveMessage_Spark, MouseMoveMessage_Spark, MouseMoveThunk, MovingAverageConvergenceDivergenceIndicator, MovingAverageConvergenceDivergenceIndicatorStrategy, NaNSegmenter, NegativeVolumeIndexIndicator, NegativeVolumeIndexIndicatorStrategy, Node$1 as Node, NonCollisionAvoider, NormalRangeMessage_Spark, NumberAbbreviator, NumberAbbreviatorFactory, NumberChangedMessage_Spark, NumericAngleAxis, NumericAngleAxisView, NumericAxisBase, NumericAxisBaseView, NumericAxisRenderer, NumericAxisRenderingParameters, NumericMarkerManager, NumericRadiusAxis, NumericRadiusAxisView, NumericScaleMode, NumericScaleMode_$type, NumericScaler, NumericXAxis, NumericXAxisView, NumericYAxis, NumericYAxisView, OnBalanceVolumeIndicator, OnBalanceVolumeIndicatorStrategy, OrderedDictionary, OrderedDictionary$2, OrderedDictionaryEnumerator$2, OrdinalTimeXAxis, OthersCategoryType, OthersCategoryType_$type, OverlayProxy, OverviewPlusDetailViewportHost, OwnedPoint, PathRenderer, PathRenderingInfo, PercentChangeAxisRenderer, PercentChangeYAxis, PercentKCalculationStrategy, PercentagePriceOscillatorIndicator, PercentagePriceOscillatorIndicatorStrategy, PercentageVolumeOscillatorIndicator, PercentageVolumeOscillatorIndicatorStrategy, PieChartBase, PieChartBaseView, PieChartSliceSelector, PieChartStyleInfo, PieChartViewManager, PieChartVisualData, PieLabel, PieLegendTemplates, PieSliceDataContext, PieSliceOthersContext, PieSliceVisualData, PieSliceVisualDataList, PixelRatioMessage_Spark, PlotAreaMouseButtonEventArgs, PlotAreaMouseEventArgs, PointSeries, PointSeriesView, PointerTooltip, PointerTooltipPointerLocation, PointerTooltipPointerLocation_$type, PointerTooltipStyle, PointerTooltipView, PointerTooltipVisualData, PointerTooltipVisualDataList, PolarAreaSeries, PolarAreaSeriesView, PolarAxes, PolarAxisInfoCache, PolarAxisRenderingManager, PolarAxisRenderingParameters, PolarBase, PolarBaseView, PolarFrame, PolarLinePlanner, PolarLineSeries, PolarLineSeriesBase, PolarLineSeriesBaseView, PolarLineSeriesView, PolarScatterSeries, PolarScatterSeriesView, PolarSplineAreaSeries, PolarSplineAreaSeriesView, PolarSplineSeries, PolarSplineSeriesView, PolarTrendLineManager, PolygonMessage_Spark, PolylineBuilder, PositiveVolumeIndexIndicator, PositiveVolumeIndexIndicatorStrategy, PreparationParams, PriceChannelBucketCalculator, PriceChannelOverlay, PriceChannelOverlayView, PriceDisplayType, PriceDisplayType_$type, PriceVolumeTrendIndicator, PriceVolumeTrendIndicatorStrategy, ProgressiveLoadStatusEventArgs, PropertyChangedMessage_Spark, RadialAreaSeries, RadialAreaSeriesView, RadialAxes, RadialAxisLabelPanel, RadialAxisLabelPanelView, RadialAxisRenderingParameters, RadialBase, RadialBaseView, RadialBucketCalculator, RadialColumnSeries, RadialColumnSeriesView, RadialFrame, RadialLineSeries, RadialLineSeriesView, RadialPieSeries, RadialPieSeriesView, RadialTrendLineManager, RangeAreaSeries, RangeAreaSeriesView, RangeCategoryBucketCalculator, RangeCategoryFramePreparer, RangeCategorySeries, RangeCategorySeriesView, RangeColumnSeries, RangeColumnSeriesView, RangeInfo, RangeValueList, RateOfChangeAndMomentumIndicator, RateOfChangeAndMomentumIndicatorStrategy, RefreshCompletedEventArgs, RelativeStrengthIndexIndicator, RelativeStrengthIndexIndicatorStrategy, RenderRequestedEventArgs, RenderSurface, RenderingMessage_Spark, Ring, RingCollection, RingControl, RingControlView, RingSeries, RingSeriesBase, RingSeriesBaseView, RingSeriesCollection, RingSeriesVisualData, RingSeriesVisualDataList, RingVisualData, RingVisualDataList, SafeEnumerable, SafeReadOnlyDoubleCollection, SafeSortedReadOnlyDoubleCollection, ScaleLegend, ScaleLegendView, ScalerParams, ScatterAreaSeries, ScatterAreaSeriesView, ScatterAxisInfoCache, ScatterBase, ScatterBaseView, ScatterContourSeries, ScatterContourSeriesView, ScatterErrorBarSettings, ScatterFrame, ScatterFrameBase$1, ScatterLineSeries, ScatterLineSeriesView, ScatterPolygonSeries, ScatterPolygonSeriesView, ScatterPolylineSeries, ScatterPolylineSeriesView, ScatterSeries, ScatterSeriesView, ScatterSplineSeries, ScatterSplineSeriesView, ScatterTrendLineManager, ScatterTriangulationSeries, SearchArgs, SearchData, SelectedItemChangedEventArgs, SelectedItemChangingEventArgs, SelectedItemsChangedEventArgs, SelectedItemsChangingEventArgs, Series, SeriesCollection, SeriesComponentsForView, SeriesComponentsFromView, SeriesHitTestMode, SeriesHitTestMode_$type, SeriesInteractionManager, SeriesPointOfInterest, SeriesRenderer$2, SeriesRenderingArguments, SeriesView, SeriesViewer, SeriesViewerComponentsForView, SeriesViewerComponentsFromView, SeriesViewerInteractionManager, SeriesViewerManipulationEventArgs, SeriesViewerSurfaceViewer, SeriesViewerView, SeriesViewerViewManager, SeriesVisualData, SeriesVisualDataList, SeriesVisualDataManager, ServiceProvider_Spark, ShapeAxisInfoCache, ShapeHitRegion, ShapeSeriesBase, ShapeSeriesViewBase, SingleValuesHolder, SizeScale, Slice, SliceAndDiceCalculator, SliceClickEventArgs, SliceCollection, SliceCoords, SliceItem, SliceSelectionMode, SliceSelectionMode_$type, SliceView, SliceVisualData, SliceVisualDataList, SlowStochasticOscillatorIndicator, SlowStochasticOscillatorIndicatorStrategy, Snapper, SortedListView$1, SortingTrendLineManager, SparkFrame, SparkFramePreparer, SparkLayerType_$type, SparklineAxisVisualData, SparklineConnector, SparklineController, SparklineDisplayType, SparklineDisplayType_$type, SparklineStylingDefaults, SparklineToolTipContext, SparklineVisualData, SplineAreaFragment, SplineAreaFragmentView, SplineAreaSeries, SplineAreaSeriesView, SplineFragment, SplineFragmentBase, SplineFragmentBucketCalculator, SplineFragmentView, SplineSeries, SplineSeriesBase, SplineSeriesBaseView, SplineSeriesView, SplineType, SplineType_$type, SquarifiedCalculator, Stacked100AreaSeries, Stacked100BarBucketCalculator, Stacked100BarSeries, Stacked100BarSeriesView, Stacked100ColumnBucketCalculator, Stacked100ColumnSeries, Stacked100ColumnSeriesView, Stacked100DataPreparer, Stacked100LineSeries, Stacked100SplineAreaSeries, Stacked100SplineSeries, StackedAreaSeries, StackedBarBucketCalculator, StackedBarSeries, StackedBarSeriesView, StackedBucketCalculator, StackedColumnBucketCalculator, StackedColumnSeries, StackedColumnSeriesView, StackedFragmentSeries, StackedLineSeries, StackedSeriesBase, StackedSeriesCollection, StackedSeriesCreatedEventArgs, StackedSeriesFramePreparer, StackedSeriesManager, StackedSeriesView, StackedSeriesVisualData, StackedSplineAreaSeries, StackedSplineSeries, StandardDeviationIndicator, StandardDeviationIndicatorStrategy, StepAreaSeries, StepAreaSeriesView, StepLineSeries, StepLineSeriesView, StochRSIIndicator, StochRSIIndicatorStrategy, StraightNumericAxisBase, StraightNumericAxisBaseView, StrategyBasedIndicator, StreamingIndicatorCalculationStrategy, StrippedCalculator, StyleSelector, StyleShapeEventArgs, SupportingCalculation$1, SyncLink, SyncLinkManager, SyncManager, SyncSettings, SyncSettingsConverter, TRIXIndicator, TRIXIndicatorStrategy, TemplatePicker, TemplatedHtmlControl, ThumbRangePosition, ThumbRangePosition_$type, TickmarkValues, TickmarkValuesInitializationParameters, TileZoomInfo, TileZoomManager, TileZoomTile, TileZoomTileCache, TileZoomTileInfo, TimeAxisBase, TimeAxisBreak, TimeAxisBreakCollection, TimeAxisDisplayType, TimeAxisDisplayType_$type, TimeAxisInterval, TimeAxisIntervalCollection, TimeAxisIntervalType, TimeAxisIntervalType_$type, TimeAxisLabelFormat, TimeAxisLabelFormatCollection, TimeAxisLabellingMode, TimeAxisLabellingMode_$type, TimeRepetitionLevel_$type, TimeXAxis, TitleSettings, ToolTipType, ToolTipType_$type, Tooltip, TooltipMessage_Spark, ToooltipTemplateMessage_Spark, TrackShadeOrientation_$type, TrackThumb, TrackThumbRange, TransitionInSpeedType, TransitionInSpeedType_$type, Treemap, TreemapFillScaleMode, TreemapFillScaleMode_$type, TreemapFrame, TreemapHeaderDisplayMode, TreemapHeaderDisplayMode_$type, TreemapLabelHorizontalFitMode, TreemapLabelHorizontalFitMode_$type, TreemapLabelVerticalFitMode, TreemapLabelVerticalFitMode_$type, TreemapLabelVisualData, TreemapLayoutCalculator, TreemapLayoutSettings, TreemapLayoutType, TreemapLayoutType_$type, TreemapNodeFrame, TreemapNodePointerEventArgs, TreemapNodeStyle, TreemapNodeStyleMapping, TreemapNodeStyleMappingCollection, TreemapNodeStyleMappingTargetType, TreemapNodeStyleMappingTargetType_$type, TreemapNodeStylingEventArgs, TreemapNodeVisualData, TreemapNodeVisualDataList, TreemapOrientation, TreemapOrientation_$type, TreemapTreeData, TreemapTreeNode, TreemapValueMappingMode, TreemapValueMappingMode_$type, TreemapView, TreemapViewRenderer, TreemapVisual, TreemapVisualData, TrendAverageCalculator, TrendFitCalculator, TrendLineManagerBase$1, TrendLineManagerNames, TrendLineManagerType_$type, TrendLineMessage_Spark, TrendResolutionParams, TriangleRasterizer, TriangleRasterizer_PointAndValue, TypicalPriceIndicator, TypicalPriceIndicatorStrategy, UltimateOscillatorIndicator, UltimateOscillatorIndicatorCalculationStrategy, ValueBrushScale, ValueOverlay, ValueOverlayView, ValuesHolder, VerticalAnchoredCategorySeries, VerticalAnchoredCategorySeriesInteractionManager, VerticalAxisLabelPanel, VerticalAxisLabelPanelView, VerticalAxisView, VerticalLinearScaler, VerticalLogarithmicScaler, VerticalPercentChangeScaler, VerticalStackedSeriesBase, ViewerSurfaceUsage, ViewerSurfaceUsage_$type, ViewportChangedMessage_Spark, ViewportUtils, VisibilityMessage_Spark, VisualDataFactoryManager, VisualDataSerializer, VisualExportHelper, WaterfallSeries, WaterfallSeriesView, WeightedCloseIndicator, WeightedCloseIndicatorStrategy, WilliamsPercentRIndicator, WilliamsPercentRIndicatorStrategy, WinLossColumnMessage_Spark, WindowResponse, WindowResponse_$type, XYChart, XamDataChart, XamDataChartView, XamDoughnutChart, XamDoughnutChartView, XamPieChart, XamPieChartView, XamSparkline, XamSparklineView, ZoomCoercionMode, ZoomCoercionMode_$type, ZoomSlider, ZoomSliderCursor_$type, ZoomSliderOrientation, ZoomSliderOrientation_$type, ZoomSliderResolvingAxisValueEventArgs, ZoomSliderView, ZoomSliderVisualArea_$type, ɵ0 };
//# sourceMappingURL=igniteui-angular-charts.js.map
